//
// 23 Jul 2016
//
// Signsrch signature file
// by Luigi Auriemma
// e-mail: aluigi@autistici.org
// web:    aluigi.org
//
// this file is a chaotic collection of tables and various signatures for
// catching protocols and algorithms from any data file
// the format is very simple:
// TITLE: the description of the signature
// TYPE:
//   8  for 8 bit elements (1 byte)
//   16 for 16 bit elements (2 bytes)
//   32 for 32 bit elements (4 bytes)
//   64 for 64 bit elements (8 bytes)
//   FLOAT for float and double elements (32 and 64 bits / 4 and 8 bytes)
//     CRC automatic calculation of checksum table through a given poly
//     AND used for searching more than one element within about 3000 bytes
//     HEX for hex recognization (never needed)
//     NOBIG avoids the creation of the big endian signature
// DATA
//   "string" just a text string in printf style, example: "my string\ttest\n\0"
//   'a' a character, printf style supported
//   numbers, supports decimal, hex (0x) and octal 0
//   comments are supported: /* */ on the same line and #, // and ;
//
// I usually add new stuff so the previous info could change or be improved
//
// a HUGE thanx to all the people which have indirectly contribuited to this
// list with their research or their source code from which I have got the
// signatures!
//
// Other contributors who had the patience to parse all the signatures:
// http://code.google.com/p/clamsrch/wiki/changes

################################################################################

TITLE
    CRC32

TYPE
    CRC 32

DATA
    0x1800063
    0x1db71064
    0x3b6e20c8
    0x26d930ac
    0x76dc4190
    0x6b6b51f4
    0x4db26158
    0x5005713c
    0xf00f9344
    0xd6d6a3e8
    0xcb61b38c
    0x9b64c2b0
    0x86d3d2d4
    0xa00ae278
    0xbdbdf21c

################################################################################

TITLE
    XFER

TYPE
    CRC 32

DATA
    0x000000af

################################################################################

TITLE
    Adler CRC32 (0x191b3141)

TYPE
    32

DATA
    0x00000000UL, 0x191b3141UL, 0x32366282UL, 0x2b2d53c3UL, 0x646cc504UL,
    0x7d77f445UL, 0x565aa786UL, 0x4f4196c7UL, 0xc8d98a08UL, 0xd1c2bb49UL,
    0xfaefe88aUL, 0xe3f4d9cbUL, 0xacb54f0cUL, 0xb5ae7e4dUL, 0x9e832d8eUL,
    0x87981ccfUL, 0x4ac21251UL, 0x53d92310UL, 0x78f470d3UL, 0x61ef4192UL,
    0x2eaed755UL, 0x37b5e614UL, 0x1c98b5d7UL, 0x05838496UL, 0x821b9859UL,
    0x9b00a918UL, 0xb02dfadbUL, 0xa936cb9aUL, 0xe6775d5dUL, 0xff6c6c1cUL,
    0xd4413fdfUL, 0xcd5a0e9eUL, 0x958424a2UL, 0x8c9f15e3UL, 0xa7b24620UL,
    0xbea97761UL, 0xf1e8e1a6UL, 0xe8f3d0e7UL, 0xc3de8324UL, 0xdac5b265UL,
    0x5d5daeaaUL, 0x44469febUL, 0x6f6bcc28UL, 0x7670fd69UL, 0x39316baeUL,
    0x202a5aefUL, 0x0b07092cUL, 0x121c386dUL, 0xdf4636f3UL, 0xc65d07b2UL,
    0xed705471UL, 0xf46b6530UL, 0xbb2af3f7UL, 0xa231c2b6UL, 0x891c9175UL,
    0x9007a034UL, 0x179fbcfbUL, 0x0e848dbaUL, 0x25a9de79UL, 0x3cb2ef38UL,
    0x73f379ffUL, 0x6ae848beUL, 0x41c51b7dUL, 0x58de2a3cUL, 0xf0794f05UL,
    0xe9627e44UL, 0xc24f2d87UL, 0xdb541cc6UL, 0x94158a01UL, 0x8d0ebb40UL,
    0xa623e883UL, 0xbf38d9c2UL, 0x38a0c50dUL, 0x21bbf44cUL, 0x0a96a78fUL,
    0x138d96ceUL, 0x5ccc0009UL, 0x45d73148UL, 0x6efa628bUL, 0x77e153caUL,
    0xbabb5d54UL, 0xa3a06c15UL, 0x888d3fd6UL, 0x91960e97UL, 0xded79850UL,
    0xc7cca911UL, 0xece1fad2UL, 0xf5facb93UL, 0x7262d75cUL, 0x6b79e61dUL,
    0x4054b5deUL, 0x594f849fUL, 0x160e1258UL, 0x0f152319UL, 0x243870daUL,
    0x3d23419bUL, 0x65fd6ba7UL, 0x7ce65ae6UL, 0x57cb0925UL, 0x4ed03864UL,
    0x0191aea3UL, 0x188a9fe2UL, 0x33a7cc21UL, 0x2abcfd60UL, 0xad24e1afUL,
    0xb43fd0eeUL, 0x9f12832dUL, 0x8609b26cUL, 0xc94824abUL, 0xd05315eaUL,
    0xfb7e4629UL, 0xe2657768UL, 0x2f3f79f6UL, 0x362448b7UL, 0x1d091b74UL,
    0x04122a35UL, 0x4b53bcf2UL, 0x52488db3UL, 0x7965de70UL, 0x607eef31UL,
    0xe7e6f3feUL, 0xfefdc2bfUL, 0xd5d0917cUL, 0xcccba03dUL, 0x838a36faUL,
    0x9a9107bbUL, 0xb1bc5478UL, 0xa8a76539UL, 0x3b83984bUL, 0x2298a90aUL,
    0x09b5fac9UL, 0x10aecb88UL, 0x5fef5d4fUL, 0x46f46c0eUL, 0x6dd93fcdUL,
    0x74c20e8cUL, 0xf35a1243UL, 0xea412302UL, 0xc16c70c1UL, 0xd8774180UL,
    0x9736d747UL, 0x8e2de606UL, 0xa500b5c5UL, 0xbc1b8484UL, 0x71418a1aUL,
    0x685abb5bUL, 0x4377e898UL, 0x5a6cd9d9UL, 0x152d4f1eUL, 0x0c367e5fUL,
    0x271b2d9cUL, 0x3e001cddUL, 0xb9980012UL, 0xa0833153UL, 0x8bae6290UL,
    0x92b553d1UL, 0xddf4c516UL, 0xc4eff457UL, 0xefc2a794UL, 0xf6d996d5UL,
    0xae07bce9UL, 0xb71c8da8UL, 0x9c31de6bUL, 0x852aef2aUL, 0xca6b79edUL,
    0xd37048acUL, 0xf85d1b6fUL, 0xe1462a2eUL, 0x66de36e1UL, 0x7fc507a0UL,
    0x54e85463UL, 0x4df36522UL, 0x02b2f3e5UL, 0x1ba9c2a4UL, 0x30849167UL,
    0x299fa026UL, 0xe4c5aeb8UL, 0xfdde9ff9UL, 0xd6f3cc3aUL, 0xcfe8fd7bUL,
    0x80a96bbcUL, 0x99b25afdUL, 0xb29f093eUL, 0xab84387fUL, 0x2c1c24b0UL,
    0x350715f1UL, 0x1e2a4632UL, 0x07317773UL, 0x4870e1b4UL, 0x516bd0f5UL,
    0x7a468336UL, 0x635db277UL, 0xcbfad74eUL, 0xd2e1e60fUL, 0xf9ccb5ccUL,
    0xe0d7848dUL, 0xaf96124aUL, 0xb68d230bUL, 0x9da070c8UL, 0x84bb4189UL,
    0x03235d46UL, 0x1a386c07UL, 0x31153fc4UL, 0x280e0e85UL, 0x674f9842UL,
    0x7e54a903UL, 0x5579fac0UL, 0x4c62cb81UL, 0x8138c51fUL, 0x9823f45eUL,
    0xb30ea79dUL, 0xaa1596dcUL, 0xe554001bUL, 0xfc4f315aUL, 0xd7626299UL,
    0xce7953d8UL, 0x49e14f17UL, 0x50fa7e56UL, 0x7bd72d95UL, 0x62cc1cd4UL,
    0x2d8d8a13UL, 0x3496bb52UL, 0x1fbbe891UL, 0x06a0d9d0UL, 0x5e7ef3ecUL,
    0x4765c2adUL, 0x6c48916eUL, 0x7553a02fUL, 0x3a1236e8UL, 0x230907a9UL,
    0x0824546aUL, 0x113f652bUL, 0x96a779e4UL, 0x8fbc48a5UL, 0xa4911b66UL,
    0xbd8a2a27UL, 0xf2cbbce0UL, 0xebd08da1UL, 0xc0fdde62UL, 0xd9e6ef23UL,
    0x14bce1bdUL, 0x0da7d0fcUL, 0x268a833fUL, 0x3f91b27eUL, 0x70d024b9UL,
    0x69cb15f8UL, 0x42e6463bUL, 0x5bfd777aUL, 0xdc656bb5UL, 0xc57e5af4UL,
    0xee530937UL, 0xf7483876UL, 0xb809aeb1UL, 0xa1129ff0UL, 0x8a3fcc33UL,
    0x9324fd72UL

################################################################################

TITLE
    Adler CRC32 (0x01c26a37)

TYPE
    32

DATA
    0x00000000UL, 0x01c26a37UL, 0x0384d46eUL, 0x0246be59UL, 0x0709a8dcUL,
    0x06cbc2ebUL, 0x048d7cb2UL, 0x054f1685UL, 0x0e1351b8UL, 0x0fd13b8fUL,
    0x0d9785d6UL, 0x0c55efe1UL, 0x091af964UL, 0x08d89353UL, 0x0a9e2d0aUL,
    0x0b5c473dUL, 0x1c26a370UL, 0x1de4c947UL, 0x1fa2771eUL, 0x1e601d29UL,
    0x1b2f0bacUL, 0x1aed619bUL, 0x18abdfc2UL, 0x1969b5f5UL, 0x1235f2c8UL,
    0x13f798ffUL, 0x11b126a6UL, 0x10734c91UL, 0x153c5a14UL, 0x14fe3023UL,
    0x16b88e7aUL, 0x177ae44dUL, 0x384d46e0UL, 0x398f2cd7UL, 0x3bc9928eUL,
    0x3a0bf8b9UL, 0x3f44ee3cUL, 0x3e86840bUL, 0x3cc03a52UL, 0x3d025065UL,
    0x365e1758UL, 0x379c7d6fUL, 0x35dac336UL, 0x3418a901UL, 0x3157bf84UL,
    0x3095d5b3UL, 0x32d36beaUL, 0x331101ddUL, 0x246be590UL, 0x25a98fa7UL,
    0x27ef31feUL, 0x262d5bc9UL, 0x23624d4cUL, 0x22a0277bUL, 0x20e69922UL,
    0x2124f315UL, 0x2a78b428UL, 0x2bbade1fUL, 0x29fc6046UL, 0x283e0a71UL,
    0x2d711cf4UL, 0x2cb376c3UL, 0x2ef5c89aUL, 0x2f37a2adUL, 0x709a8dc0UL,
    0x7158e7f7UL, 0x731e59aeUL, 0x72dc3399UL, 0x7793251cUL, 0x76514f2bUL,
    0x7417f172UL, 0x75d59b45UL, 0x7e89dc78UL, 0x7f4bb64fUL, 0x7d0d0816UL,
    0x7ccf6221UL, 0x798074a4UL, 0x78421e93UL, 0x7a04a0caUL, 0x7bc6cafdUL,
    0x6cbc2eb0UL, 0x6d7e4487UL, 0x6f38fadeUL, 0x6efa90e9UL, 0x6bb5866cUL,
    0x6a77ec5bUL, 0x68315202UL, 0x69f33835UL, 0x62af7f08UL, 0x636d153fUL,
    0x612bab66UL, 0x60e9c151UL, 0x65a6d7d4UL, 0x6464bde3UL, 0x662203baUL,
    0x67e0698dUL, 0x48d7cb20UL, 0x4915a117UL, 0x4b531f4eUL, 0x4a917579UL,
    0x4fde63fcUL, 0x4e1c09cbUL, 0x4c5ab792UL, 0x4d98dda5UL, 0x46c49a98UL,
    0x4706f0afUL, 0x45404ef6UL, 0x448224c1UL, 0x41cd3244UL, 0x400f5873UL,
    0x4249e62aUL, 0x438b8c1dUL, 0x54f16850UL, 0x55330267UL, 0x5775bc3eUL,
    0x56b7d609UL, 0x53f8c08cUL, 0x523aaabbUL, 0x507c14e2UL, 0x51be7ed5UL,
    0x5ae239e8UL, 0x5b2053dfUL, 0x5966ed86UL, 0x58a487b1UL, 0x5deb9134UL,
    0x5c29fb03UL, 0x5e6f455aUL, 0x5fad2f6dUL, 0xe1351b80UL, 0xe0f771b7UL,
    0xe2b1cfeeUL, 0xe373a5d9UL, 0xe63cb35cUL, 0xe7fed96bUL, 0xe5b86732UL,
    0xe47a0d05UL, 0xef264a38UL, 0xeee4200fUL, 0xeca29e56UL, 0xed60f461UL,
    0xe82fe2e4UL, 0xe9ed88d3UL, 0xebab368aUL, 0xea695cbdUL, 0xfd13b8f0UL,
    0xfcd1d2c7UL, 0xfe976c9eUL, 0xff5506a9UL, 0xfa1a102cUL, 0xfbd87a1bUL,
    0xf99ec442UL, 0xf85cae75UL, 0xf300e948UL, 0xf2c2837fUL, 0xf0843d26UL,
    0xf1465711UL, 0xf4094194UL, 0xf5cb2ba3UL, 0xf78d95faUL, 0xf64fffcdUL,
    0xd9785d60UL, 0xd8ba3757UL, 0xdafc890eUL, 0xdb3ee339UL, 0xde71f5bcUL,
    0xdfb39f8bUL, 0xddf521d2UL, 0xdc374be5UL, 0xd76b0cd8UL, 0xd6a966efUL,
    0xd4efd8b6UL, 0xd52db281UL, 0xd062a404UL, 0xd1a0ce33UL, 0xd3e6706aUL,
    0xd2241a5dUL, 0xc55efe10UL, 0xc49c9427UL, 0xc6da2a7eUL, 0xc7184049UL,
    0xc25756ccUL, 0xc3953cfbUL, 0xc1d382a2UL, 0xc011e895UL, 0xcb4dafa8UL,
    0xca8fc59fUL, 0xc8c97bc6UL, 0xc90b11f1UL, 0xcc440774UL, 0xcd866d43UL,
    0xcfc0d31aUL, 0xce02b92dUL, 0x91af9640UL, 0x906dfc77UL, 0x922b422eUL,
    0x93e92819UL, 0x96a63e9cUL, 0x976454abUL, 0x9522eaf2UL, 0x94e080c5UL,
    0x9fbcc7f8UL, 0x9e7eadcfUL, 0x9c381396UL, 0x9dfa79a1UL, 0x98b56f24UL,
    0x99770513UL, 0x9b31bb4aUL, 0x9af3d17dUL, 0x8d893530UL, 0x8c4b5f07UL,
    0x8e0de15eUL, 0x8fcf8b69UL, 0x8a809decUL, 0x8b42f7dbUL, 0x89044982UL,
    0x88c623b5UL, 0x839a6488UL, 0x82580ebfUL, 0x801eb0e6UL, 0x81dcdad1UL,
    0x8493cc54UL, 0x8551a663UL, 0x8717183aUL, 0x86d5720dUL, 0xa9e2d0a0UL,
    0xa820ba97UL, 0xaa6604ceUL, 0xaba46ef9UL, 0xaeeb787cUL, 0xaf29124bUL,
    0xad6fac12UL, 0xacadc625UL, 0xa7f18118UL, 0xa633eb2fUL, 0xa4755576UL,
    0xa5b73f41UL, 0xa0f829c4UL, 0xa13a43f3UL, 0xa37cfdaaUL, 0xa2be979dUL,
    0xb5c473d0UL, 0xb40619e7UL, 0xb640a7beUL, 0xb782cd89UL, 0xb2cddb0cUL,
    0xb30fb13bUL, 0xb1490f62UL, 0xb08b6555UL, 0xbbd72268UL, 0xba15485fUL,
    0xb853f606UL, 0xb9919c31UL, 0xbcde8ab4UL, 0xbd1ce083UL, 0xbf5a5edaUL,
    0xbe9834edUL

################################################################################

TITLE
    Adler CRC32 (0xb8bc6765)

TYPE
    32

DATA
    0x00000000UL, 0xb8bc6765UL, 0xaa09c88bUL, 0x12b5afeeUL, 0x8f629757UL,
    0x37def032UL, 0x256b5fdcUL, 0x9dd738b9UL, 0xc5b428efUL, 0x7d084f8aUL,
    0x6fbde064UL, 0xd7018701UL, 0x4ad6bfb8UL, 0xf26ad8ddUL, 0xe0df7733UL,
    0x58631056UL, 0x5019579fUL, 0xe8a530faUL, 0xfa109f14UL, 0x42acf871UL,
    0xdf7bc0c8UL, 0x67c7a7adUL, 0x75720843UL, 0xcdce6f26UL, 0x95ad7f70UL,
    0x2d111815UL, 0x3fa4b7fbUL, 0x8718d09eUL, 0x1acfe827UL, 0xa2738f42UL,
    0xb0c620acUL, 0x087a47c9UL, 0xa032af3eUL, 0x188ec85bUL, 0x0a3b67b5UL,
    0xb28700d0UL, 0x2f503869UL, 0x97ec5f0cUL, 0x8559f0e2UL, 0x3de59787UL,
    0x658687d1UL, 0xdd3ae0b4UL, 0xcf8f4f5aUL, 0x7733283fUL, 0xeae41086UL,
    0x525877e3UL, 0x40edd80dUL, 0xf851bf68UL, 0xf02bf8a1UL, 0x48979fc4UL,
    0x5a22302aUL, 0xe29e574fUL, 0x7f496ff6UL, 0xc7f50893UL, 0xd540a77dUL,
    0x6dfcc018UL, 0x359fd04eUL, 0x8d23b72bUL, 0x9f9618c5UL, 0x272a7fa0UL,
    0xbafd4719UL, 0x0241207cUL, 0x10f48f92UL, 0xa848e8f7UL, 0x9b14583dUL,
    0x23a83f58UL, 0x311d90b6UL, 0x89a1f7d3UL, 0x1476cf6aUL, 0xaccaa80fUL,
    0xbe7f07e1UL, 0x06c36084UL, 0x5ea070d2UL, 0xe61c17b7UL, 0xf4a9b859UL,
    0x4c15df3cUL, 0xd1c2e785UL, 0x697e80e0UL, 0x7bcb2f0eUL, 0xc377486bUL,
    0xcb0d0fa2UL, 0x73b168c7UL, 0x6104c729UL, 0xd9b8a04cUL, 0x446f98f5UL,
    0xfcd3ff90UL, 0xee66507eUL, 0x56da371bUL, 0x0eb9274dUL, 0xb6054028UL,
    0xa4b0efc6UL, 0x1c0c88a3UL, 0x81dbb01aUL, 0x3967d77fUL, 0x2bd27891UL,
    0x936e1ff4UL, 0x3b26f703UL, 0x839a9066UL, 0x912f3f88UL, 0x299358edUL,
    0xb4446054UL, 0x0cf80731UL, 0x1e4da8dfUL, 0xa6f1cfbaUL, 0xfe92dfecUL,
    0x462eb889UL, 0x549b1767UL, 0xec277002UL, 0x71f048bbUL, 0xc94c2fdeUL,
    0xdbf98030UL, 0x6345e755UL, 0x6b3fa09cUL, 0xd383c7f9UL, 0xc1366817UL,
    0x798a0f72UL, 0xe45d37cbUL, 0x5ce150aeUL, 0x4e54ff40UL, 0xf6e89825UL,
    0xae8b8873UL, 0x1637ef16UL, 0x048240f8UL, 0xbc3e279dUL, 0x21e91f24UL,
    0x99557841UL, 0x8be0d7afUL, 0x335cb0caUL, 0xed59b63bUL, 0x55e5d15eUL,
    0x47507eb0UL, 0xffec19d5UL, 0x623b216cUL, 0xda874609UL, 0xc832e9e7UL,
    0x708e8e82UL, 0x28ed9ed4UL, 0x9051f9b1UL, 0x82e4565fUL, 0x3a58313aUL,
    0xa78f0983UL, 0x1f336ee6UL, 0x0d86c108UL, 0xb53aa66dUL, 0xbd40e1a4UL,
    0x05fc86c1UL, 0x1749292fUL, 0xaff54e4aUL, 0x322276f3UL, 0x8a9e1196UL,
    0x982bbe78UL, 0x2097d91dUL, 0x78f4c94bUL, 0xc048ae2eUL, 0xd2fd01c0UL,
    0x6a4166a5UL, 0xf7965e1cUL, 0x4f2a3979UL, 0x5d9f9697UL, 0xe523f1f2UL,
    0x4d6b1905UL, 0xf5d77e60UL, 0xe762d18eUL, 0x5fdeb6ebUL, 0xc2098e52UL,
    0x7ab5e937UL, 0x680046d9UL, 0xd0bc21bcUL, 0x88df31eaUL, 0x3063568fUL,
    0x22d6f961UL, 0x9a6a9e04UL, 0x07bda6bdUL, 0xbf01c1d8UL, 0xadb46e36UL,
    0x15080953UL, 0x1d724e9aUL, 0xa5ce29ffUL, 0xb77b8611UL, 0x0fc7e174UL,
    0x9210d9cdUL, 0x2aacbea8UL, 0x38191146UL, 0x80a57623UL, 0xd8c66675UL,
    0x607a0110UL, 0x72cfaefeUL, 0xca73c99bUL, 0x57a4f122UL, 0xef189647UL,
    0xfdad39a9UL, 0x45115eccUL, 0x764dee06UL, 0xcef18963UL, 0xdc44268dUL,
    0x64f841e8UL, 0xf92f7951UL, 0x41931e34UL, 0x5326b1daUL, 0xeb9ad6bfUL,
    0xb3f9c6e9UL, 0x0b45a18cUL, 0x19f00e62UL, 0xa14c6907UL, 0x3c9b51beUL,
    0x842736dbUL, 0x96929935UL, 0x2e2efe50UL, 0x2654b999UL, 0x9ee8defcUL,
    0x8c5d7112UL, 0x34e11677UL, 0xa9362eceUL, 0x118a49abUL, 0x033fe645UL,
    0xbb838120UL, 0xe3e09176UL, 0x5b5cf613UL, 0x49e959fdUL, 0xf1553e98UL,
    0x6c820621UL, 0xd43e6144UL, 0xc68bceaaUL, 0x7e37a9cfUL, 0xd67f4138UL,
    0x6ec3265dUL, 0x7c7689b3UL, 0xc4caeed6UL, 0x591dd66fUL, 0xe1a1b10aUL,
    0xf3141ee4UL, 0x4ba87981UL, 0x13cb69d7UL, 0xab770eb2UL, 0xb9c2a15cUL,
    0x017ec639UL, 0x9ca9fe80UL, 0x241599e5UL, 0x36a0360bUL, 0x8e1c516eUL,
    0x866616a7UL, 0x3eda71c2UL, 0x2c6fde2cUL, 0x94d3b949UL, 0x090481f0UL,
    0xb1b8e695UL, 0xa30d497bUL, 0x1bb12e1eUL, 0x43d23e48UL, 0xfb6e592dUL,
    0xe9dbf6c3UL, 0x516791a6UL, 0xccb0a91fUL, 0x740cce7aUL, 0x66b96194UL,
    0xde0506f1UL

################################################################################

TITLE
    CRC-8

TYPE
    CRC 8

DATA
    0xd5
    0xab
    0xea

################################################################################

TITLE
    CRC-8-SAE J1850

TYPE
    CRC 8

DATA
    0x1d
    0xb8
    0x8e

################################################################################

TITLE
    CRC-8-WCDMA

TYPE
    CRC 8

DATA
    0x9b
    0xd9
    0xcd

################################################################################

TITLE
    CRC-1

TYPE
    CRC 8

DATA
    0x1

################################################################################

TITLE
    CRC-4 ITU

TYPE
    CRC 8

DATA
    0x3
    0xc
    0x9

################################################################################

TITLE
    CRC-6 ITU

TYPE
    CRC 8

DATA
    //0x3
    0x30
    0x21

################################################################################

TITLE
    CRC-5-CCITT

TYPE
    CRC 8

DATA
    0x0b

################################################################################

TITLE
    CRC-5-CCITT

TYPE
    CRC 8

DATA
    0x15
    0x1a

################################################################################

TITLE
    CRC-5-USB

TYPE
    CRC 8

DATA
    0x05
    0x14
    0x12

################################################################################

TITLE
    CRC-7

TYPE
    CRC 8

DATA
    //0x9
    0x48
    0x44

################################################################################

TITLE
    CRC-7

TYPE
    CRC 8

DATA
    0x11

################################################################################

TITLE
    CRC-8-ATM

TYPE
    CRC 8

DATA
    0x07
    0xe0
    0x83

################################################################################

TITLE
    CRC-8-ATM

TYPE
    CRC 8

DATA
    0xc1

################################################################################

TITLE
    CRC-8-CCITT

TYPE
    CRC 8

DATA
    0x87

################################################################################

TITLE
    CRC-8-CCITT

TYPE
    CRC 8

DATA
    0xe1

################################################################################

TITLE
    CRC-8-Dallas/Maxim

TYPE
    CRC 8

DATA
    0x31
    0x8c
    0x98

################################################################################

TITLE
    CRC-8

TYPE
    CRC 8

DATA
    0xd3

################################################################################

TITLE
    CRC-10

TYPE
    CRC 16

DATA
    0x233
    0x331
    0x319

################################################################################

TITLE
    CRC-11

TYPE
    CRC 16

DATA
    0x385
    0x50e
    0x5c2

################################################################################

TITLE
    CRC-12

TYPE
    CRC 16

DATA
    0x80f
    0xf01
    0xc07

################################################################################

TITLE
    CRC-12

TYPE
    CRC 16

DATA
    0xe03

################################################################################

TITLE
    CRC-15-CAN

TYPE
    CRC 16

DATA
    0x4599
    0x4cd1
    0x62cc

################################################################################

TITLE
    CRC-15-MPT1327

TYPE
    CRC 16

DATA
    0x6815
    0x540b
    0x740a

################################################################################

TITLE
    CRC-16-CCITT modem/x25/kermit

TYPE
    CRC 16

DATA
    0x1021
    0x8408
    0x8810

################################################################################

TITLE
    CRC-16-T10-DIF

TYPE
    CRC 16

DATA
    0x8b27
    0xedd1
    0xc5db

################################################################################

TITLE
    CRC-16-DNP

TYPE
    CRC 16

DATA
    0x3d65
    0xa6bc
    0x9eb2

################################################################################

TITLE
    CRC-16-DECT

TYPE
    CRC 16

DATA
    0x0589
    0x91A0
    0x82C4

################################################################################

TITLE
    CRC-16-ARINC

TYPE
    CRC 16

DATA
    0xA02B
    0xD405
    0xD015

################################################################################

TITLE
    CRC-16-CCITT

TYPE
    CRC 16

DATA
    0x0811

################################################################################

TITLE
    CRC-16-IBM maxim/usb

TYPE
    CRC 16

DATA
    0x8005
    0xa001
    0xc002

################################################################################

TITLE
    CRC-16-IBM

TYPE
    CRC 16

DATA
    0x4003

################################################################################

TITLE
    CRC16

TYPE
    CRC 16

DATA
    0xb005

################################################################################

TITLE
    CRC-24

TYPE
    CRC 32

DATA
    0x5D6DCB
    0xD3B6BA
    0xAEB6E5

################################################################################

TITLE
    CRC-24-Radix-64

TYPE
    CRC 32

DATA
    0x864CFB
    0xDF3261
    0xC3267D

################################################################################

TITLE
    CRC-30

TYPE
    CRC 32

DATA
    0x2030B9C7
    0x38E74301
    0x30185CE3

################################################################################

TITLE
    CRC-32-IEEE 802.3

TYPE
    CRC 32

DATA
    0x04C11DB7
    0xEDB88320
    0x82608EDB

################################################################################

TITLE
    CRC-32-IEEE 802.3

TYPE
    CRC 32

DATA
    0xDB710641

################################################################################

TITLE
    CRC-32D

TYPE
    CRC 32

DATA
    0xa833982b

################################################################################

TITLE
    CRC-32C (Castagnoli)

TYPE
    CRC 32

DATA
    0x1EDC6F41
    0x82F63B78
    0x8F6E37A0

################################################################################

TITLE
    CRC-32K (Koopman)

TYPE
    CRC 32

DATA
    0x741B8CD7
    0xEB31D82E
    0xBA0DC66B

################################################################################

TITLE
    CRC-32Q

TYPE
    CRC 32

DATA
    0x814141AB
    0xD5828281
    0xC0A0A0D5

################################################################################

TITLE
    CRC-32C (Castagnoli)

TYPE
    CRC 32

DATA
    0x05EC76F1

################################################################################

TITLE
    CRC-64-ISO

TYPE
    CRC 64

DATA
    0x000000000000001B
    0xD800000000000000
    0xB000000000000001

################################################################################

TITLE
    CRC-40-GSM

TYPE
    CRC 64

DATA
    0x0004820009

################################################################################

TITLE
    CRC64BitJones

TYPE
    CRC 64

DATA
    0xAD93D23594C935A9

################################################################################

TITLE
    CRC-64-ECMA-182

TYPE
    CRC 64

DATA
    0x42F0E1EBA9EA3693
    0xC96C5795D7870F42
    0x92D8AF2BAF0E1E85

################################################################################

TITLE
    G726 16kbit/s 2bits per sample table

TYPE
    32

DATA
           { 0, 7, 7, 0 };
           { -22, 439, 439, -22 };
           { 116, 365, 365, 116 };
           { 260, INT_MAX };

################################################################################

TITLE
    G726 24kbit/s 3bits per sample table

TYPE
    32

DATA
           { 0, 1, 2, 7, 7, 2, 1, 0 };
           { -4,  30, 137, 582, 582, 137,  30, -4 };
           { INT_MIN, 135, 273, 373, 373, 273, 135, INT_MIN };
           {  7, 217, 330, INT_MAX };

################################################################################

TITLE
    G726 32kbit/s 4bits per sample table

TYPE
    32

DATA
           { 0, 0, 0, 1, 1, 1, 3, 7, 7, 3, 1, 1, 1, 0, 0, 0 };
           { -12,  18,  41,  64, 112, 198, 355, 1122,
            1122, 355, 198, 112,  64,  41,  18, -12};
           { INT_MIN,   4, 135, 213, 273, 323, 373, 425,
                 425, 373, 323, 273, 213, 135,   4, INT_MIN };
           { -125,  79, 177, 245, 299, 348, 399, INT_MAX };

################################################################################

TITLE
    G726 40kbit/s 5bits per sample table (iquant_tbl)

TYPE
    32

DATA
           { 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 3, 4, 5, 6, 6,
             6, 6, 5, 4, 3, 2, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0 };
           {   14,  14,  24,  39,  40,  41,   58,  100,
              141, 179, 219, 280, 358, 440,  529,  696,
              696, 529, 440, 358, 280, 219,  179,  141,
              100,  58,  41,  40,  39,  24,   14,   14 };
           { INT_MIN, -66,  28, 104, 169, 224, 274, 318,
                 358, 395, 429, 459, 488, 514, 539, 566,
                 566, 539, 514, 488, 459, 429, 395, 358,
                 318, 274, 224, 169, 104,  28, -66, INT_MIN };
           { -122, -16,  67, 138, 197, 249, 297, 338,
              377, 412, 444, 474, 501, 527, 552, INT_MAX };

################################################################################

TITLE
    G726 40kbit/s 5bits per sample table (iquant_tbl) (b)

TYPE
    16,32
DATA
-2147483648,        -66,         28,        104,        169,        224,        274,        318,
        358,        395,        429,        459,        488,        514,        539,        566,
        566,        539,        514,        488,        459,        429,        395,        358,
        318,        274,        224,        169,        104,         28,        -66,-2147483648,

################################################################################

TITLE
    G726 40kbit/s 5bits per sample table (W_tbl40)

TYPE
    16 32

DATA
0x000e,0x000e,0x0018,0x0027,0x0028,0x0029,0x003a,0x0064,0x008d,0x00b3,0x00db,0x0118,0x0166,0x01b8,0x0211,0x02b8,
0x02b8,0x0211,0x01b8,0x0166,0x0118,0x00db,0x00b3,0x008d,0x0064,0x003a,0x0029,0x0028,0x0027,0x0018,0x000e,0x000e,

################################################################################

TITLE
    ADPCM index table (step variation)

TYPE
    32

DATA
    -1, -1, -1, -1, 2, 4, 6, 8,
    -1, -1, -1, -1, 2, 4, 6, 8,

################################################################################

TITLE
    ima_adpcm step table

TYPE
    16, 32

DATA
    7, 8, 9, 10, 11, 12, 13, 14, 16, 17,
    19, 21, 23, 25, 28, 31, 34, 37, 41, 45,
    50, 55, 60, 66, 73, 80, 88, 97, 107, 118,
    130, 143, 157, 173, 190, 209, 230, 253, 279, 307,
    337, 371, 408, 449, 494, 544, 598, 658, 724, 796,
    876, 963, 1060, 1166, 1282, 1411, 1552, 1707, 1878, 2066,
    2272, 2499, 2749, 3024, 3327, 3660, 4026, 4428, 4871, 5358,
    5894, 6484, 7132, 7845, 8630, 9493, 10442, 11487, 12635, 13899,
    15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794, 32767

################################################################################

TITLE
    MS ADPCM AdaptationTable

TYPE
    16 32

DATA
    230, 230, 230, 230, 307, 409, 512, 614,
    768, 614, 512, 409, 307, 230, 230, 230

################################################################################

TITLE
    PSX VAG CD-ROM XA ADPCM table

TYPE
    32

DATA
   {   0,   0 },
   {  60,   0 },
   { 115, -52 },
   {  98, -55 },
   { 122, -60 }

################################################################################

TITLE
    Electronic Arts ADPCM table

TYPE
    32

DATA
    0, 240, 460, 392, 0, 0, -208, -220, 0, 1,
    3, 4, 7, 8, 10, 11, 0, -1, -3, -4

################################################################################

TITLE
    Creative ADPCM table

TYPE
    32

DATA
    0x00E6, 0x00E6, 0x00E6, 0x00E6,
    0x0133, 0x0199, 0x0200, 0x0266

################################################################################

TITLE
    Macromedia Flash SWF ADPCM table

TYPE
    32

DATA
            -1,  2   0   0   0   0   0   0  0  0  0  0  0   0   0   0
            -1, -1,  2,  4   0   0   0   0  0  0  0  0  0   0   0   0
            -1, -1, -1, -1,  2,  4,  6,  8  0  0  0  0  0   0   0   0
            -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 4, 6, 8, 10, 13, 16

################################################################################

TITLE
    Yamaha ADPCM index table

TYPE
    16 32

DATA
    230, 230, 230, 230, 307, 409, 512, 614,
    230, 230, 230, 230, 307, 409, 512, 614

################################################################################

TITLE
    Yamaha ADPCM diff lookup table

TYPE
    8 32

DATA
    1, 3, 5, 7, 9, 11, 13, 15,
    -1, -3, -5, -7, -9, -11, -13, -15

################################################################################

TITLE
    libavutil ff_log2_tab

TYPE
    8

DATA
        0,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
        5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
        6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
        7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7

################################################################################

TITLE
    ACSS decryption sbox

TYPE
    8, 32

DATA
	0x33, 0x73, 0x3b, 0x26, 0x63, 0x23, 0x6b, 0x76,
	0x3e, 0x7e, 0x36, 0x2b, 0x6e, 0x2e, 0x66, 0x7b,
	0xd3, 0x93, 0xdb, 0x06, 0x43, 0x03, 0x4b, 0x96,
	0xde, 0x9e, 0xd6, 0x0b, 0x4e, 0x0e, 0x46, 0x9b,
	0x57, 0x17, 0x5f, 0x82, 0xc7, 0x87, 0xcf, 0x12,
	0x5a, 0x1a, 0x52, 0x8f, 0xca, 0x8a, 0xc2, 0x1f,
	0xd9, 0x99, 0xd1, 0x00, 0x49, 0x09, 0x41, 0x90,
	0xd8, 0x98, 0xd0, 0x01, 0x48, 0x08, 0x40, 0x91,
	0x3d, 0x7d, 0x35, 0x24, 0x6d, 0x2d, 0x65, 0x74,
	0x3c, 0x7c, 0x34, 0x25, 0x6c, 0x2c, 0x64, 0x75,
	0xdd, 0x9d, 0xd5, 0x04, 0x4d, 0x0d, 0x45, 0x94,
	0xdc, 0x9c, 0xd4, 0x05, 0x4c, 0x0c, 0x44, 0x95,
	0x59, 0x19, 0x51, 0x80, 0xc9, 0x89, 0xc1, 0x10,
	0x58, 0x18, 0x50, 0x81, 0xc8, 0x88, 0xc0, 0x11,
	0xd7, 0x97, 0xdf, 0x02, 0x47, 0x07, 0x4f, 0x92,
	0xda, 0x9a, 0xd2, 0x0f, 0x4a, 0x0a, 0x42, 0x9f,
	0x53, 0x13, 0x5b, 0x86, 0xc3, 0x83, 0xcb, 0x16,
	0x5e, 0x1e, 0x56, 0x8b, 0xce, 0x8e, 0xc6, 0x1b,
	0xb3, 0xf3, 0xbb, 0xa6, 0xe3, 0xa3, 0xeb, 0xf6,
	0xbe, 0xfe, 0xb6, 0xab, 0xee, 0xae, 0xe6, 0xfb,
	0x37, 0x77, 0x3f, 0x22, 0x67, 0x27, 0x6f, 0x72,
	0x3a, 0x7a, 0x32, 0x2f, 0x6a, 0x2a, 0x62, 0x7f,
	0xb9, 0xf9, 0xb1, 0xa0, 0xe9, 0xa9, 0xe1, 0xf0,
	0xb8, 0xf8, 0xb0, 0xa1, 0xe8, 0xa8, 0xe0, 0xf1,
	0x5d, 0x1d, 0x55, 0x84, 0xcd, 0x8d, 0xc5, 0x14,
	0x5c, 0x1c, 0x54, 0x85, 0xcc, 0x8c, 0xc4, 0x15,
	0xbd, 0xfd, 0xb5, 0xa4, 0xed, 0xad, 0xe5, 0xf4,
	0xbc, 0xfc, 0xb4, 0xa5, 0xec, 0xac, 0xe4, 0xf5,
	0x39, 0x79, 0x31, 0x20, 0x69, 0x29, 0x61, 0x70,
	0x38, 0x78, 0x30, 0x21, 0x68, 0x28, 0x60, 0x71,
	0xb7, 0xf7, 0xbf, 0xa2, 0xe7, 0xa7, 0xef, 0xf2,
	0xba, 0xfa, 0xb2, 0xaf, 0xea, 0xaa, 0xe2, 0xff

################################################################################

TITLE
    ACSS encryption sbox

TYPE
    8, 32

DATA
	0x33, 0x3b, 0x73, 0x15, 0x53, 0x5b, 0x13, 0x75,
	0x3d, 0x35, 0x7d, 0x1b, 0x5d, 0x55, 0x1d, 0x7b,
	0x67, 0x6f, 0x27, 0x81, 0xc7, 0xcf, 0x87, 0x21,
	0x69, 0x61, 0x29, 0x8f, 0xc9, 0xc1, 0x89, 0x2f,
	0xe3, 0xeb, 0xa3, 0x05, 0x43, 0x4b, 0x03, 0xa5,
	0xed, 0xe5, 0xad, 0x0b, 0x4d, 0x45, 0x0d, 0xab,
	0xea, 0xe2, 0xaa, 0x00, 0x4a, 0x42, 0x0a, 0xa0,
	0xe8, 0xe0, 0xa8, 0x02, 0x48, 0x40, 0x08, 0xa2,
	0x3e, 0x36, 0x7e, 0x14, 0x5e, 0x56, 0x1e, 0x74,
	0x3c, 0x34, 0x7c, 0x16, 0x5c, 0x54, 0x1c, 0x76,
	0x6a, 0x62, 0x2a, 0x80, 0xca, 0xc2, 0x8a, 0x20,
	0x68, 0x60, 0x28, 0x82, 0xc8, 0xc0, 0x88, 0x22,
	0xee, 0xe6, 0xae, 0x04, 0x4e, 0x46, 0x0e, 0xa4,
	0xec, 0xe4, 0xac, 0x06, 0x4c, 0x44, 0x0c, 0xa6,
	0xe7, 0xef, 0xa7, 0x01, 0x47, 0x4f, 0x07, 0xa1,
	0xe9, 0xe1, 0xa9, 0x0f, 0x49, 0x41, 0x09, 0xaf,
	0x63, 0x6b, 0x23, 0x85, 0xc3, 0xcb, 0x83, 0x25,
	0x6d, 0x65, 0x2d, 0x8b, 0xcd, 0xc5, 0x8d, 0x2b,
	0x37, 0x3f, 0x77, 0x11, 0x57, 0x5f, 0x17, 0x71,
	0x39, 0x31, 0x79, 0x1f, 0x59, 0x51, 0x19, 0x7f,
	0xb3, 0xbb, 0xf3, 0x95, 0xd3, 0xdb, 0x93, 0xf5,
	0xbd, 0xb5, 0xfd, 0x9b, 0xdd, 0xd5, 0x9d, 0xfb,
	0xba, 0xb2, 0xfa, 0x90, 0xda, 0xd2, 0x9a, 0xf0,
	0xb8, 0xb0, 0xf8, 0x92, 0xd8, 0xd0, 0x98, 0xf2,
	0x6e, 0x66, 0x2e, 0x84, 0xce, 0xc6, 0x8e, 0x24,
	0x6c, 0x64, 0x2c, 0x86, 0xcc, 0xc4, 0x8c, 0x26,
	0x3a, 0x32, 0x7a, 0x10, 0x5a, 0x52, 0x1a, 0x70,
	0x38, 0x30, 0x78, 0x12, 0x58, 0x50, 0x18, 0x72,
	0xbe, 0xb6, 0xfe, 0x94, 0xde, 0xd6, 0x9e, 0xf4,
	0xbc, 0xb4, 0xfc, 0x96, 0xdc, 0xd4, 0x9c, 0xf6,
	0xb7, 0xbf, 0xf7, 0x91, 0xd7, 0xdf, 0x97, 0xf1,
	0xb9, 0xb1, 0xf9, 0x9f, 0xd9, 0xd1, 0x99, 0xff

################################################################################

TITLE
    ACSS reverse sbox

TYPE
    8, 32

DATA
	0x00, 0x80, 0x40, 0xc0, 0x20, 0xa0, 0x60, 0xe0,
	0x10, 0x90, 0x50, 0xd0, 0x30, 0xb0, 0x70, 0xf0,
	0x08, 0x88, 0x48, 0xc8, 0x28, 0xa8, 0x68, 0xe8,
	0x18, 0x98, 0x58, 0xd8, 0x38, 0xb8, 0x78, 0xf8,
	0x04, 0x84, 0x44, 0xc4, 0x24, 0xa4, 0x64, 0xe4,
	0x14, 0x94, 0x54, 0xd4, 0x34, 0xb4, 0x74, 0xf4,
	0x0c, 0x8c, 0x4c, 0xcc, 0x2c, 0xac, 0x6c, 0xec,
	0x1c, 0x9c, 0x5c, 0xdc, 0x3c, 0xbc, 0x7c, 0xfc,
	0x02, 0x82, 0x42, 0xc2, 0x22, 0xa2, 0x62, 0xe2,
	0x12, 0x92, 0x52, 0xd2, 0x32, 0xb2, 0x72, 0xf2,
	0x0a, 0x8a, 0x4a, 0xca, 0x2a, 0xaa, 0x6a, 0xea,
	0x1a, 0x9a, 0x5a, 0xda, 0x3a, 0xba, 0x7a, 0xfa,
	0x06, 0x86, 0x46, 0xc6, 0x26, 0xa6, 0x66, 0xe6,
	0x16, 0x96, 0x56, 0xd6, 0x36, 0xb6, 0x76, 0xf6,
	0x0e, 0x8e, 0x4e, 0xce, 0x2e, 0xae, 0x6e, 0xee,
	0x1e, 0x9e, 0x5e, 0xde, 0x3e, 0xbe, 0x7e, 0xfe,
	0x01, 0x81, 0x41, 0xc1, 0x21, 0xa1, 0x61, 0xe1,
	0x11, 0x91, 0x51, 0xd1, 0x31, 0xb1, 0x71, 0xf1,
	0x09, 0x89, 0x49, 0xc9, 0x29, 0xa9, 0x69, 0xe9,
	0x19, 0x99, 0x59, 0xd9, 0x39, 0xb9, 0x79, 0xf9,
	0x05, 0x85, 0x45, 0xc5, 0x25, 0xa5, 0x65, 0xe5,
	0x15, 0x95, 0x55, 0xd5, 0x35, 0xb5, 0x75, 0xf5,
	0x0d, 0x8d, 0x4d, 0xcd, 0x2d, 0xad, 0x6d, 0xed,
	0x1d, 0x9d, 0x5d, 0xdd, 0x3d, 0xbd, 0x7d, 0xfd,
	0x03, 0x83, 0x43, 0xc3, 0x23, 0xa3, 0x63, 0xe3,
	0x13, 0x93, 0x53, 0xd3, 0x33, 0xb3, 0x73, 0xf3,
	0x0b, 0x8b, 0x4b, 0xcb, 0x2b, 0xab, 0x6b, 0xeb,
	0x1b, 0x9b, 0x5b, 0xdb, 0x3b, 0xbb, 0x7b, 0xfb,
	0x07, 0x87, 0x47, 0xc7, 0x27, 0xa7, 0x67, 0xe7,
	0x17, 0x97, 0x57, 0xd7, 0x37, 0xb7, 0x77, 0xf7,
	0x0f, 0x8f, 0x4f, 0xcf, 0x2f, 0xaf, 0x6f, 0xef,
	0x1f, 0x9f, 0x5f, 0xdf, 0x3f, 0xbf, 0x7f, 0xff

################################################################################

TITLE
    SHA256 Hash constant words K (0x428a2f98)

TYPE
    32

DATA
	0x428a2f98UL, 0x71374491UL, 0xb5c0fbcfUL, 0xe9b5dba5UL,
	0x3956c25bUL, 0x59f111f1UL, 0x923f82a4UL, 0xab1c5ed5UL,
	0xd807aa98UL, 0x12835b01UL, 0x243185beUL, 0x550c7dc3UL,
	0x72be5d74UL, 0x80deb1feUL, 0x9bdc06a7UL, 0xc19bf174UL,
	0xe49b69c1UL, 0xefbe4786UL, 0x0fc19dc6UL, 0x240ca1ccUL,
	0x2de92c6fUL, 0x4a7484aaUL, 0x5cb0a9dcUL, 0x76f988daUL,
	0x983e5152UL, 0xa831c66dUL, 0xb00327c8UL, 0xbf597fc7UL,
	0xc6e00bf3UL, 0xd5a79147UL, 0x06ca6351UL, 0x14292967UL,
	0x27b70a85UL, 0x2e1b2138UL, 0x4d2c6dfcUL, 0x53380d13UL,
	0x650a7354UL, 0x766a0abbUL, 0x81c2c92eUL, 0x92722c85UL,
	0xa2bfe8a1UL, 0xa81a664bUL, 0xc24b8b70UL, 0xc76c51a3UL,
	0xd192e819UL, 0xd6990624UL, 0xf40e3585UL, 0x106aa070UL,
	0x19a4c116UL, 0x1e376c08UL, 0x2748774cUL, 0x34b0bcb5UL,
	0x391c0cb3UL, 0x4ed8aa4aUL, 0x5b9cca4fUL, 0x682e6ff3UL,
	0x748f82eeUL, 0x78a5636fUL, 0x84c87814UL, 0x8cc70208UL,
	0x90befffaUL, 0xa4506cebUL, 0xbef9a3f7UL, 0xc67178f2UL

################################################################################

TITLE
    SHA256 Initial hash value H (0x6a09e667UL)

TYPE
    32 AND

DATA
	0x6a09e667UL,
	0xbb67ae85UL,
	0x3c6ef372UL,
	0xa54ff53aUL,
	0x510e527fUL,
	0x9b05688cUL,
	0x1f83d9abUL,
	0x5be0cd19UL

################################################################################

TITLE
    Hash constant words K for SHA-384 and SHA-512

TYPE
    64

DATA
	0x428a2f98d728ae22ULL, 0x7137449123ef65cdULL,
	0xb5c0fbcfec4d3b2fULL, 0xe9b5dba58189dbbcULL,
	0x3956c25bf348b538ULL, 0x59f111f1b605d019ULL,
	0x923f82a4af194f9bULL, 0xab1c5ed5da6d8118ULL,
	0xd807aa98a3030242ULL, 0x12835b0145706fbeULL,
	0x243185be4ee4b28cULL, 0x550c7dc3d5ffb4e2ULL,
	0x72be5d74f27b896fULL, 0x80deb1fe3b1696b1ULL,
	0x9bdc06a725c71235ULL, 0xc19bf174cf692694ULL,
	0xe49b69c19ef14ad2ULL, 0xefbe4786384f25e3ULL,
	0x0fc19dc68b8cd5b5ULL, 0x240ca1cc77ac9c65ULL,
	0x2de92c6f592b0275ULL, 0x4a7484aa6ea6e483ULL,
	0x5cb0a9dcbd41fbd4ULL, 0x76f988da831153b5ULL,
	0x983e5152ee66dfabULL, 0xa831c66d2db43210ULL,
	0xb00327c898fb213fULL, 0xbf597fc7beef0ee4ULL,
	0xc6e00bf33da88fc2ULL, 0xd5a79147930aa725ULL,
	0x06ca6351e003826fULL, 0x142929670a0e6e70ULL,
	0x27b70a8546d22ffcULL, 0x2e1b21385c26c926ULL,
	0x4d2c6dfc5ac42aedULL, 0x53380d139d95b3dfULL,
	0x650a73548baf63deULL, 0x766a0abb3c77b2a8ULL,
	0x81c2c92e47edaee6ULL, 0x92722c851482353bULL,
	0xa2bfe8a14cf10364ULL, 0xa81a664bbc423001ULL,
	0xc24b8b70d0f89791ULL, 0xc76c51a30654be30ULL,
	0xd192e819d6ef5218ULL, 0xd69906245565a910ULL,
	0xf40e35855771202aULL, 0x106aa07032bbd1b8ULL,
	0x19a4c116b8d2d0c8ULL, 0x1e376c085141ab53ULL,
	0x2748774cdf8eeb99ULL, 0x34b0bcb5e19b48a8ULL,
	0x391c0cb3c5c95a63ULL, 0x4ed8aa4ae3418acbULL,
	0x5b9cca4f7763e373ULL, 0x682e6ff3d6b2b8a3ULL,
	0x748f82ee5defb2fcULL, 0x78a5636f43172f60ULL,
	0x84c87814a1f0ab72ULL, 0x8cc702081a6439ecULL,
	0x90befffa23631e28ULL, 0xa4506cebde82bde9ULL,
	0xbef9a3f7b2c67915ULL, 0xc67178f2e372532bULL,
	0xca273eceea26619cULL, 0xd186b8c721c0c207ULL,
	0xeada7dd6cde0eb1eULL, 0xf57d4f7fee6ed178ULL,
	0x06f067aa72176fbaULL, 0x0a637dc5a2c898a6ULL,
	0x113f9804bef90daeULL, 0x1b710b35131c471bULL,
	0x28db77f523047d84ULL, 0x32caab7b40c72493ULL,
	0x3c9ebe0a15c9bebcULL, 0x431d67c49c100d4cULL,
	0x4cc5d4becb3e42b6ULL, 0x597f299cfc657e2aULL,
	0x5fcb6fab3ad6faecULL, 0x6c44198c4a475817ULL

################################################################################

TITLE
    Initial hash value H for SHA-384 and SHA-512

TYPE
    64 AND

DATA
	0xcbbb9d5dc1059ed8ULL,
	0x629a292a367cd507ULL,
	0x9159015a3070dd17ULL,
	0x152fecd8f70e5939ULL,
	0x67332667ffc00b31ULL,
	0x8eb44a8768581511ULL,
	0xdb0c2e0d64f98fa7ULL,
	0x47b5481dbefa4fa4ULL

################################################################################

TITLE
    Initial hash value H for SHA-512

TYPE
    64 AND

DATA
	0x6a09e667f3bcc908ULL,
	0xbb67ae8584caa73bULL,
	0x3c6ef372fe94f82bULL,
	0xa54ff53a5f1d36f1ULL,
	0x510e527fade682d1ULL,
	0x9b05688c2b3e6c1fULL,
	0x1f83d9abfb41bd6bULL,
	0x5be0cd19137e2179ULL

################################################################################

TITLE
    Standard huffman HuffFreq table (0.14473691)

TYPE
    FLOAT

DATA
	0.14473691,	0.01147017,	0.00167522,	0.03831121,
	0.00356579,	0.03811315,	0.00178254,	0.00199644,
	0.00183511,	0.00225716,	0.00211240,	0.00308829,
	0.00172852,	0.00186608,	0.00215921,	0.00168891,
	0.00168603,	0.00218586,	0.00284414,	0.00161833,
	0.00196043,	0.00151029,	0.00173932,	0.00218370,
	0.00934121,	0.00220530,	0.00381211,	0.00185456,
	0.00194675,	0.00161977,	0.00186680,	0.00182071,
	0.06421956,	0.00537786,	0.00514019,	0.00487155,
	0.00493925,	0.00503143,	0.00514019,	0.00453520,
	0.00454241,	0.00485642,	0.00422407,	0.00593387,
	0.00458130,	0.00343687,	0.00342823,	0.00531592,
	0.00324890,	0.00333388,	0.00308613,	0.00293776,
	0.00258918,	0.00259278,	0.00377105,	0.00267488,
	0.00227516,	0.00415997,	0.00248763,	0.00301555,
	0.00220962,	0.00206990,	0.00270369,	0.00231694,
	0.00273826,	0.00450928,	0.00384380,	0.00504728,
	0.00221251,	0.00376961,	0.00232990,	0.00312574,
	0.00291688,	0.00280236,	0.00252436,	0.00229461,
	0.00294353,	0.00241201,	0.00366590,	0.00199860,
	0.00257838,	0.00225860,	0.00260646,	0.00187256,
	0.00266552,	0.00242641,	0.00219450,	0.00192082,
	0.00182071,	0.02185930,	0.00157439,	0.00164353,
	0.00161401,	0.00187544,	0.00186248,	0.03338637,
	0.00186968,	0.00172132,	0.00148509,	0.00177749,
	0.00144620,	0.00192442,	0.00169683,	0.00209439,
	0.00209439,	0.00259062,	0.00194531,	0.00182359,
	0.00159096,	0.00145196,	0.00128199,	0.00158376,
	0.00171412,	0.00243433,	0.00345704,	0.00156359,
	0.00145700,	0.00157007,	0.00232342,	0.00154198,
	0.00140730,	0.00288807,	0.00152830,	0.00151246,
	0.00250203,	0.00224420,	0.00161761,	0.00714383,
	0.08188576,	0.00802537,	0.00119484,	0.00123805,
	0.05632671,	0.00305156,	0.00105584,	0.00105368,
	0.00099246,	0.00090459,	0.00109473,	0.00115379,
	0.00261223,	0.00105656,	0.00124381,	0.00100326,
	0.00127550,	0.00089739,	0.00162481,	0.00100830,
	0.00097229,	0.00078864,	0.00107240,	0.00084409,
	0.00265760,	0.00116891,	0.00073102,	0.00075695,
	0.00093916,	0.00106880,	0.00086786,	0.00185600,
	0.00608367,	0.00133600,	0.00075695,	0.00122077,
	0.00566955,	0.00108249,	0.00259638,	0.00077063,
	0.00166586,	0.00090387,	0.00087074,	0.00084914,
	0.00130935,	0.00162409,	0.00085922,	0.00093340,
	0.00093844,	0.00087722,	0.00108249,	0.00098598,
	0.00095933,	0.00427593,	0.00496661,	0.00102775,
	0.00159312,	0.00118404,	0.00114947,	0.00104936,
	0.00154342,	0.00140082,	0.00115883,	0.00110769,
	0.00161112,	0.00169107,	0.00107816,	0.00142747,
	0.00279804,	0.00085922,	0.00116315,	0.00119484,
	0.00128559,	0.00146204,	0.00130215,	0.00101551,
	0.00091756,	0.00161184,	0.00236375,	0.00131872,
	0.00214120,	0.00088875,	0.00138570,	0.00211960,
	0.00094060,	0.00088083,	0.00094564,	0.00090243,
	0.00106160,	0.00088659,	0.00114514,	0.00095861,
	0.00108753,	0.00124165,	0.00427016,	0.00159384,
	0.00170547,	0.00104431,	0.00091395,	0.00095789,
	0.00134681,	0.00095213,	0.00105944,	0.00094132,
	0.00141883,	0.00102127,	0.00101911,	0.00082105,
	0.00158448,	0.00102631,	0.00087938,	0.00139290,
	0.00114658,	0.00095501,	0.00161329,	0.00126542,
	0.00113218,	0.00123661,	0.00101695,	0.00112930,
	0.00317976,	0.00085346,	0.00101190,	0.00189849,
	0.00105728,	0.00186824,	0.00092908,	0.00160896

################################################################################

TITLE
    Zdaemon huffman HuffFreq table (0.46947443)

TYPE
    FLOAT

DATA
    0.46947443, 0.03744229, 0.02009356, 0.00707818,
    0.00728153, 0.02111485, 0.00445556, 0.00229655,
    0.01265820, 0.00241106, 0.00299206, 0.00265591,
    0.00284209, 0.00339483, 0.00203944, 0.00192218,
    0.01423221, 0.00194756, 0.00250942, 0.00224109,
    0.00264493, 0.00185304, 0.00164660, 0.00135765,
    0.00238693, 0.00155698, 0.00132108, 0.00136161,
    0.00168719, 0.00133527, 0.00138385, 0.00133988,
    0.00255865, 0.00167663, 0.00142282, 0.00185067,
    0.00179926, 0.00132452, 0.00107309, 0.00524015,
    0.00246438, 0.00096060, 0.00734912, 0.00102914,
    0.00170869, 0.00128854, 0.00097614, 0.00113916,
    0.00186316, 0.01077324, 0.00102875, 0.00354735,
    0.00125545, 0.00114088, 0.00103111, 0.00132834,
    0.00206495, 0.00107727, 0.00099150, 0.00454583,
    0.00144284, 0.00102763, 0.00105168, 0.00117436,
    0.00197808, 0.00103239, 0.00325006, 0.00115212,
    0.00125261, 0.00100999, 0.00100125, 0.00112827,
    0.00129156, 0.00098112, 0.00095781, 0.00098035,
    0.00117501, 0.00103275, 0.00111885, 0.00110044,
    0.00820434, 0.00091584, 0.00098619, 0.00089814,
    0.00135214, 0.00088258, 0.00095421, 0.00088725,
    0.00213761, 0.00099426, 0.00102234, 0.00098324,
    0.00116107, 0.00090388, 0.00085447, 0.00094951,
    0.00157389, 0.00110302, 0.00089621, 0.00094432,
    0.00813035, 0.00961901, 0.00476472, 0.00097480,
    0.00135165, 0.00093732, 0.00086517, 0.00092980,
    0.00543320, 0.00116154, 0.00099676, 0.00192325,
    0.00154463, 0.00087127, 0.00106448, 0.00113199,
    0.00343841, 0.00469290, 0.00088090, 0.00102023,
    0.00131824, 0.00091547, 0.00088527, 0.00090882,
    0.00113292, 0.00088162, 0.00088137, 0.00112587,
    0.00328156, 0.00088004, 0.00102551, 0.00086177,
    0.00107408, 0.00116912, 0.00084356, 0.00081423,
    0.00125029, 0.00079219, 0.00079757, 0.00089434,
    0.00107415, 0.00083609, 0.00078779, 0.00084491,
    0.00148952, 0.00085361, 0.00079014, 0.00082267,
    0.00103773, 0.00083512, 0.00081632, 0.00081653,
    0.00123191, 0.00079775, 0.00080431, 0.00081823,
    0.00122765, 0.00080738, 0.00080918, 0.00084970,
    0.00235248, 0.00079080, 0.00078659, 0.00081687,
    0.00107209, 0.00078719, 0.00078745, 0.00097451,
    0.00122689, 0.00078703, 0.00079399, 0.00076628,
    0.00119746, 0.00076251, 0.00079380, 0.00086241,
    0.00132236, 0.00077717, 0.00087071, 0.00080988,
    0.00099657, 0.00075881, 0.00077917, 0.00080354,
    0.00112704, 0.00078615, 0.00078358, 0.00077879,
    0.00109891, 0.00095691, 0.00080671, 0.00079289,
    0.00244628, 0.00080076, 0.00075714, 0.00079463,
    0.00122710, 0.00075707, 0.00073999, 0.00079447,
    0.00113160, 0.00095707, 0.00075825, 0.00074562,
    0.00105562, 0.00075720, 0.00079450, 0.00360570,
    0.00135354, 0.00077605, 0.00076658, 0.00081708,
    0.00138878, 0.00079424, 0.00083277, 0.00076214,
    0.00117659, 0.00598942, 0.00082706, 0.00081629,
    0.00132374, 0.00075337, 0.00077039, 0.00113487,
    0.00163245, 0.00090353, 0.00086913, 0.00091947,
    0.00125829, 0.00079054, 0.00079913, 0.00082155,
    0.00124808, 0.00079468, 0.00126046, 0.00086568,
    0.00130345, 0.00104526, 0.00107681, 0.00118829,
    0.00178076, 0.00132801, 0.00150205, 0.00155763,
    0.00225596, 0.00221831, 0.00161586, 0.00166614,
    0.00217488, 0.00195445, 0.00243183, 0.00258366,
    0.00355952, 0.00450725, 0.00615087, 0.02669448

################################################################################

TITLE
    AES Rijndael Logtable

TYPE
    8

DATA
  0,   0,  25,   1,  50,   2,  26, 198,  75, 199,  27, 104,  51, 238, 223,   3, 
100,   4, 224,  14,  52, 141, 129, 239,  76, 113,   8, 200, 248, 105,  28, 193, 
125, 194,  29, 181, 249, 185,  39, 106,  77, 228, 166, 114, 154, 201,   9, 120, 
101,  47, 138,   5,  33,  15, 225,  36,  18, 240, 130,  69,  53, 147, 218, 142, 
150, 143, 219, 189,  54, 208, 206, 148,  19,  92, 210, 241,  64,  70, 131,  56, 
102, 221, 253,  48, 191,   6, 139,  98, 179,  37, 226, 152,  34, 136, 145,  16, 
126, 110,  72, 195, 163, 182,  30,  66,  58, 107,  40,  84, 250, 133,  61, 186, 
 43, 121,  10,  21, 155, 159,  94, 202,  78, 212, 172, 229, 243, 115, 167,  87, 
175,  88, 168,  80, 244, 234, 214, 116,  79, 174, 233, 213, 231, 230, 173, 232, 
 44, 215, 117, 122, 235,  22,  11, 245,  89, 203,  95, 176, 156, 169,  81, 160, 
127,  12, 246, 111,  23, 196,  73, 236, 216,  67,  31,  45, 164, 118, 123, 183, 
204, 187,  62,  90, 251,  96, 177, 134,  59,  82, 161, 108, 170,  85,  41, 157, 
151, 178, 135, 144,  97, 190, 220, 252, 188, 149, 207, 205,  55,  63,  91, 209, 
 83,  57, 132,  60,  65, 162, 109,  71,  20,  42, 158,  93,  86, 242, 211, 171, 
 68,  17, 146, 217,  35,  32,  46, 137, 180, 124, 184,  38, 119, 153, 227, 165, 
103,  74, 237, 222, 197,  49, 254,  24,  13,  99, 140, 128, 192, 247, 112,   7

################################################################################

TITLE
    AES Rijndael Alogtable

TYPE
    8

DATA
  1,   3,   5,  15,  17,  51,  85, 255,  26,  46, 114, 150, 161, 248,  19,  53, 
 95, 225,  56,  72, 216, 115, 149, 164, 247,   2,   6,  10,  30,  34, 102, 170, 
229,  52,  92, 228,  55,  89, 235,  38, 106, 190, 217, 112, 144, 171, 230,  49, 
 83, 245,   4,  12,  20,  60,  68, 204,  79, 209, 104, 184, 211, 110, 178, 205, 
 76, 212, 103, 169, 224,  59,  77, 215,  98, 166, 241,   8,  24,  40, 120, 136, 
131, 158, 185, 208, 107, 189, 220, 127, 129, 152, 179, 206,  73, 219, 118, 154, 
181, 196,  87, 249,  16,  48,  80, 240,  11,  29,  39, 105, 187, 214,  97, 163, 
254,  25,  43, 125, 135, 146, 173, 236,  47, 113, 147, 174, 233,  32,  96, 160, 
251,  22,  58,  78, 210, 109, 183, 194,  93, 231,  50,  86, 250,  21,  63,  65, 
195,  94, 226,  61,  71, 201,  64, 192,  91, 237,  44, 116, 156, 191, 218, 117, 
159, 186, 213, 100, 172, 239,  42, 126, 130, 157, 188, 223, 122, 142, 137, 128, 
155, 182, 193,  88, 232,  35, 101, 175, 234,  37, 111, 177, 200,  67, 197,  84, 
252,  31,  33,  99, 165, 244,   7,   9,  27,  45, 119, 153, 176, 203,  70, 202, 
 69, 207,  74, 222, 121, 139, 134, 145, 168, 227,  62,  66, 198,  81, 243,  14, 
 18,  54,  90, 238,  41, 123, 141, 140, 143, 138, 133, 148, 167, 242,  13,  23, 
 57,  75, 221, 124, 132, 151, 162, 253,  28,  36, 108, 180, 199,  82, 246,   1

################################################################################

TITLE
    AES Rijndael S / ARIA S1

TYPE
    8

DATA
 99, 124, 119, 123, 242, 107, 111, 197,  48,   1, 103,  43, 254, 215, 171, 118, 
202, 130, 201, 125, 250,  89,  71, 240, 173, 212, 162, 175, 156, 164, 114, 192, 
183, 253, 147,  38,  54,  63, 247, 204,  52, 165, 229, 241, 113, 216,  49,  21, 
  4, 199,  35, 195,  24, 150,   5, 154,   7,  18, 128, 226, 235,  39, 178, 117, 
  9, 131,  44,  26,  27, 110,  90, 160,  82,  59, 214, 179,  41, 227,  47, 132, 
 83, 209,   0, 237,  32, 252, 177,  91, 106, 203, 190,  57,  74,  76,  88, 207, 
208, 239, 170, 251,  67,  77,  51, 133,  69, 249,   2, 127,  80,  60, 159, 168, 
 81, 163,  64, 143, 146, 157,  56, 245, 188, 182, 218,  33,  16, 255, 243, 210, 
205,  12,  19, 236,  95, 151,  68,  23, 196, 167, 126,  61, 100,  93,  25, 115, 
 96, 129,  79, 220,  34,  42, 144, 136,  70, 238, 184,  20, 222,  94,  11, 219, 
224,  50,  58,  10,  73,   6,  36,  92, 194, 211, 172,  98, 145, 149, 228, 121, 
231, 200,  55, 109, 141, 213,  78, 169, 108,  86, 244, 234, 101, 122, 174,   8, 
186, 120,  37,  46,  28, 166, 180, 198, 232, 221, 116,  31,  75, 189, 139, 138, 
112,  62, 181, 102,  72,   3, 246,  14,  97,  53,  87, 185, 134, 193,  29, 158, 
225, 248, 152,  17, 105, 217, 142, 148, 155,  30, 135, 233, 206,  85,  40, 223, 
140, 161, 137,  13, 191, 230,  66, 104,  65, 153,  45,  15, 176,  84, 187,  22

################################################################################

TITLE
    AES Rijndael Si / ARIA X1

TYPE
    8

DATA
 82,   9, 106, 213,  48,  54, 165,  56, 191,  64, 163, 158, 129, 243, 215, 251, 
124, 227,  57, 130, 155,  47, 255, 135,  52, 142,  67,  68, 196, 222, 233, 203, 
 84, 123, 148,  50, 166, 194,  35,  61, 238,  76, 149,  11,  66, 250, 195,  78, 
  8,  46, 161, 102,  40, 217,  36, 178, 118,  91, 162,  73, 109, 139, 209,  37, 
114, 248, 246, 100, 134, 104, 152,  22, 212, 164,  92, 204,  93, 101, 182, 146, 
108, 112,  72,  80, 253, 237, 185, 218,  94,  21,  70,  87, 167, 141, 157, 132, 
144, 216, 171,   0, 140, 188, 211,  10, 247, 228,  88,   5, 184, 179,  69,   6, 
208,  44,  30, 143, 202,  63,  15,   2, 193, 175, 189,   3,   1,  19, 138, 107, 
 58, 145,  17,  65,  79, 103, 220, 234, 151, 242, 207, 206, 240, 180, 230, 115, 
150, 172, 116,  34, 231, 173,  53, 133, 226, 249,  55, 232,  28, 117, 223, 110, 
 71, 241,  26, 113,  29,  41, 197, 137, 111, 183,  98,  14, 170,  24, 190,  27, 
252,  86,  62,  75, 198, 210, 121,  32, 154, 219, 192, 254, 120, 205,  90, 244, 
 31, 221, 168,  51, 136,   7, 199,  49, 177,  18,  16,  89,  39, 128, 236,  95, 
 96,  81, 127, 169,  25, 181,  74,  13,  45, 229, 122, 159, 147, 201, 156, 239, 
160, 224,  59,  77, 174,  42, 245, 176, 200, 235, 187,  60, 131,  83, 153,  97, 
 23,  43,   4, 126, 186, 119, 214,  38, 225, 105,  20,  99,  85,  33,  12, 125

################################################################################

TITLE
    Rijndael Te0 (0xc66363a5U)

TYPE
    32

DATA
    0xc66363a5U, 0xf87c7c84U, 0xee777799U, 0xf67b7b8dU,
    0xfff2f20dU, 0xd66b6bbdU, 0xde6f6fb1U, 0x91c5c554U,
    0x60303050U, 0x02010103U, 0xce6767a9U, 0x562b2b7dU,
    0xe7fefe19U, 0xb5d7d762U, 0x4dababe6U, 0xec76769aU,
    0x8fcaca45U, 0x1f82829dU, 0x89c9c940U, 0xfa7d7d87U,
    0xeffafa15U, 0xb25959ebU, 0x8e4747c9U, 0xfbf0f00bU,
    0x41adadecU, 0xb3d4d467U, 0x5fa2a2fdU, 0x45afafeaU,
    0x239c9cbfU, 0x53a4a4f7U, 0xe4727296U, 0x9bc0c05bU,
    0x75b7b7c2U, 0xe1fdfd1cU, 0x3d9393aeU, 0x4c26266aU,
    0x6c36365aU, 0x7e3f3f41U, 0xf5f7f702U, 0x83cccc4fU,
    0x6834345cU, 0x51a5a5f4U, 0xd1e5e534U, 0xf9f1f108U,
    0xe2717193U, 0xabd8d873U, 0x62313153U, 0x2a15153fU,
    0x0804040cU, 0x95c7c752U, 0x46232365U, 0x9dc3c35eU,
    0x30181828U, 0x379696a1U, 0x0a05050fU, 0x2f9a9ab5U,
    0x0e070709U, 0x24121236U, 0x1b80809bU, 0xdfe2e23dU,
    0xcdebeb26U, 0x4e272769U, 0x7fb2b2cdU, 0xea75759fU,
    0x1209091bU, 0x1d83839eU, 0x582c2c74U, 0x341a1a2eU,
    0x361b1b2dU, 0xdc6e6eb2U, 0xb45a5aeeU, 0x5ba0a0fbU,
    0xa45252f6U, 0x763b3b4dU, 0xb7d6d661U, 0x7db3b3ceU,
    0x5229297bU, 0xdde3e33eU, 0x5e2f2f71U, 0x13848497U,
    0xa65353f5U, 0xb9d1d168U, 0x00000000U, 0xc1eded2cU,
    0x40202060U, 0xe3fcfc1fU, 0x79b1b1c8U, 0xb65b5bedU,
    0xd46a6abeU, 0x8dcbcb46U, 0x67bebed9U, 0x7239394bU,
    0x944a4adeU, 0x984c4cd4U, 0xb05858e8U, 0x85cfcf4aU,
    0xbbd0d06bU, 0xc5efef2aU, 0x4faaaae5U, 0xedfbfb16U,
    0x864343c5U, 0x9a4d4dd7U, 0x66333355U, 0x11858594U,
    0x8a4545cfU, 0xe9f9f910U, 0x04020206U, 0xfe7f7f81U,
    0xa05050f0U, 0x783c3c44U, 0x259f9fbaU, 0x4ba8a8e3U,
    0xa25151f3U, 0x5da3a3feU, 0x804040c0U, 0x058f8f8aU,
    0x3f9292adU, 0x219d9dbcU, 0x70383848U, 0xf1f5f504U,
    0x63bcbcdfU, 0x77b6b6c1U, 0xafdada75U, 0x42212163U,
    0x20101030U, 0xe5ffff1aU, 0xfdf3f30eU, 0xbfd2d26dU,
    0x81cdcd4cU, 0x180c0c14U, 0x26131335U, 0xc3ecec2fU,
    0xbe5f5fe1U, 0x359797a2U, 0x884444ccU, 0x2e171739U,
    0x93c4c457U, 0x55a7a7f2U, 0xfc7e7e82U, 0x7a3d3d47U,
    0xc86464acU, 0xba5d5de7U, 0x3219192bU, 0xe6737395U,
    0xc06060a0U, 0x19818198U, 0x9e4f4fd1U, 0xa3dcdc7fU,
    0x44222266U, 0x542a2a7eU, 0x3b9090abU, 0x0b888883U,
    0x8c4646caU, 0xc7eeee29U, 0x6bb8b8d3U, 0x2814143cU,
    0xa7dede79U, 0xbc5e5ee2U, 0x160b0b1dU, 0xaddbdb76U,
    0xdbe0e03bU, 0x64323256U, 0x743a3a4eU, 0x140a0a1eU,
    0x924949dbU, 0x0c06060aU, 0x4824246cU, 0xb85c5ce4U,
    0x9fc2c25dU, 0xbdd3d36eU, 0x43acacefU, 0xc46262a6U,
    0x399191a8U, 0x319595a4U, 0xd3e4e437U, 0xf279798bU,
    0xd5e7e732U, 0x8bc8c843U, 0x6e373759U, 0xda6d6db7U,
    0x018d8d8cU, 0xb1d5d564U, 0x9c4e4ed2U, 0x49a9a9e0U,
    0xd86c6cb4U, 0xac5656faU, 0xf3f4f407U, 0xcfeaea25U,
    0xca6565afU, 0xf47a7a8eU, 0x47aeaee9U, 0x10080818U,
    0x6fbabad5U, 0xf0787888U, 0x4a25256fU, 0x5c2e2e72U,
    0x381c1c24U, 0x57a6a6f1U, 0x73b4b4c7U, 0x97c6c651U,
    0xcbe8e823U, 0xa1dddd7cU, 0xe874749cU, 0x3e1f1f21U,
    0x964b4bddU, 0x61bdbddcU, 0x0d8b8b86U, 0x0f8a8a85U,
    0xe0707090U, 0x7c3e3e42U, 0x71b5b5c4U, 0xcc6666aaU,
    0x904848d8U, 0x06030305U, 0xf7f6f601U, 0x1c0e0e12U,
    0xc26161a3U, 0x6a35355fU, 0xae5757f9U, 0x69b9b9d0U,
    0x17868691U, 0x99c1c158U, 0x3a1d1d27U, 0x279e9eb9U,
    0xd9e1e138U, 0xebf8f813U, 0x2b9898b3U, 0x22111133U,
    0xd26969bbU, 0xa9d9d970U, 0x078e8e89U, 0x339494a7U,
    0x2d9b9bb6U, 0x3c1e1e22U, 0x15878792U, 0xc9e9e920U,
    0x87cece49U, 0xaa5555ffU, 0x50282878U, 0xa5dfdf7aU,
    0x038c8c8fU, 0x59a1a1f8U, 0x09898980U, 0x1a0d0d17U,
    0x65bfbfdaU, 0xd7e6e631U, 0x844242c6U, 0xd06868b8U,
    0x824141c3U, 0x299999b0U, 0x5a2d2d77U, 0x1e0f0f11U,
    0x7bb0b0cbU, 0xa85454fcU, 0x6dbbbbd6U, 0x2c16163aU,

################################################################################

TITLE
    Rijndael Te1 (0xa5c66363U)

TYPE
    32

DATA
    0xa5c66363U, 0x84f87c7cU, 0x99ee7777U, 0x8df67b7bU,
    0x0dfff2f2U, 0xbdd66b6bU, 0xb1de6f6fU, 0x5491c5c5U,
    0x50603030U, 0x03020101U, 0xa9ce6767U, 0x7d562b2bU,
    0x19e7fefeU, 0x62b5d7d7U, 0xe64dababU, 0x9aec7676U,
    0x458fcacaU, 0x9d1f8282U, 0x4089c9c9U, 0x87fa7d7dU,
    0x15effafaU, 0xebb25959U, 0xc98e4747U, 0x0bfbf0f0U,
    0xec41adadU, 0x67b3d4d4U, 0xfd5fa2a2U, 0xea45afafU,
    0xbf239c9cU, 0xf753a4a4U, 0x96e47272U, 0x5b9bc0c0U,
    0xc275b7b7U, 0x1ce1fdfdU, 0xae3d9393U, 0x6a4c2626U,
    0x5a6c3636U, 0x417e3f3fU, 0x02f5f7f7U, 0x4f83ccccU,
    0x5c683434U, 0xf451a5a5U, 0x34d1e5e5U, 0x08f9f1f1U,
    0x93e27171U, 0x73abd8d8U, 0x53623131U, 0x3f2a1515U,
    0x0c080404U, 0x5295c7c7U, 0x65462323U, 0x5e9dc3c3U,
    0x28301818U, 0xa1379696U, 0x0f0a0505U, 0xb52f9a9aU,
    0x090e0707U, 0x36241212U, 0x9b1b8080U, 0x3ddfe2e2U,
    0x26cdebebU, 0x694e2727U, 0xcd7fb2b2U, 0x9fea7575U,
    0x1b120909U, 0x9e1d8383U, 0x74582c2cU, 0x2e341a1aU,
    0x2d361b1bU, 0xb2dc6e6eU, 0xeeb45a5aU, 0xfb5ba0a0U,
    0xf6a45252U, 0x4d763b3bU, 0x61b7d6d6U, 0xce7db3b3U,
    0x7b522929U, 0x3edde3e3U, 0x715e2f2fU, 0x97138484U,
    0xf5a65353U, 0x68b9d1d1U, 0x00000000U, 0x2cc1ededU,
    0x60402020U, 0x1fe3fcfcU, 0xc879b1b1U, 0xedb65b5bU,
    0xbed46a6aU, 0x468dcbcbU, 0xd967bebeU, 0x4b723939U,
    0xde944a4aU, 0xd4984c4cU, 0xe8b05858U, 0x4a85cfcfU,
    0x6bbbd0d0U, 0x2ac5efefU, 0xe54faaaaU, 0x16edfbfbU,
    0xc5864343U, 0xd79a4d4dU, 0x55663333U, 0x94118585U,
    0xcf8a4545U, 0x10e9f9f9U, 0x06040202U, 0x81fe7f7fU,
    0xf0a05050U, 0x44783c3cU, 0xba259f9fU, 0xe34ba8a8U,
    0xf3a25151U, 0xfe5da3a3U, 0xc0804040U, 0x8a058f8fU,
    0xad3f9292U, 0xbc219d9dU, 0x48703838U, 0x04f1f5f5U,
    0xdf63bcbcU, 0xc177b6b6U, 0x75afdadaU, 0x63422121U,
    0x30201010U, 0x1ae5ffffU, 0x0efdf3f3U, 0x6dbfd2d2U,
    0x4c81cdcdU, 0x14180c0cU, 0x35261313U, 0x2fc3ececU,
    0xe1be5f5fU, 0xa2359797U, 0xcc884444U, 0x392e1717U,
    0x5793c4c4U, 0xf255a7a7U, 0x82fc7e7eU, 0x477a3d3dU,
    0xacc86464U, 0xe7ba5d5dU, 0x2b321919U, 0x95e67373U,
    0xa0c06060U, 0x98198181U, 0xd19e4f4fU, 0x7fa3dcdcU,
    0x66442222U, 0x7e542a2aU, 0xab3b9090U, 0x830b8888U,
    0xca8c4646U, 0x29c7eeeeU, 0xd36bb8b8U, 0x3c281414U,
    0x79a7dedeU, 0xe2bc5e5eU, 0x1d160b0bU, 0x76addbdbU,
    0x3bdbe0e0U, 0x56643232U, 0x4e743a3aU, 0x1e140a0aU,
    0xdb924949U, 0x0a0c0606U, 0x6c482424U, 0xe4b85c5cU,
    0x5d9fc2c2U, 0x6ebdd3d3U, 0xef43acacU, 0xa6c46262U,
    0xa8399191U, 0xa4319595U, 0x37d3e4e4U, 0x8bf27979U,
    0x32d5e7e7U, 0x438bc8c8U, 0x596e3737U, 0xb7da6d6dU,
    0x8c018d8dU, 0x64b1d5d5U, 0xd29c4e4eU, 0xe049a9a9U,
    0xb4d86c6cU, 0xfaac5656U, 0x07f3f4f4U, 0x25cfeaeaU,
    0xafca6565U, 0x8ef47a7aU, 0xe947aeaeU, 0x18100808U,
    0xd56fbabaU, 0x88f07878U, 0x6f4a2525U, 0x725c2e2eU,
    0x24381c1cU, 0xf157a6a6U, 0xc773b4b4U, 0x5197c6c6U,
    0x23cbe8e8U, 0x7ca1ddddU, 0x9ce87474U, 0x213e1f1fU,
    0xdd964b4bU, 0xdc61bdbdU, 0x860d8b8bU, 0x850f8a8aU,
    0x90e07070U, 0x427c3e3eU, 0xc471b5b5U, 0xaacc6666U,
    0xd8904848U, 0x05060303U, 0x01f7f6f6U, 0x121c0e0eU,
    0xa3c26161U, 0x5f6a3535U, 0xf9ae5757U, 0xd069b9b9U,
    0x91178686U, 0x5899c1c1U, 0x273a1d1dU, 0xb9279e9eU,
    0x38d9e1e1U, 0x13ebf8f8U, 0xb32b9898U, 0x33221111U,
    0xbbd26969U, 0x70a9d9d9U, 0x89078e8eU, 0xa7339494U,
    0xb62d9b9bU, 0x223c1e1eU, 0x92158787U, 0x20c9e9e9U,
    0x4987ceceU, 0xffaa5555U, 0x78502828U, 0x7aa5dfdfU,
    0x8f038c8cU, 0xf859a1a1U, 0x80098989U, 0x171a0d0dU,
    0xda65bfbfU, 0x31d7e6e6U, 0xc6844242U, 0xb8d06868U,
    0xc3824141U, 0xb0299999U, 0x775a2d2dU, 0x111e0f0fU,
    0xcb7bb0b0U, 0xfca85454U, 0xd66dbbbbU, 0x3a2c1616U,

################################################################################

TITLE
    Rijndael Te2 (0x63a5c663U)

TYPE
    32

DATA
    0x63a5c663U, 0x7c84f87cU, 0x7799ee77U, 0x7b8df67bU,
    0xf20dfff2U, 0x6bbdd66bU, 0x6fb1de6fU, 0xc55491c5U,
    0x30506030U, 0x01030201U, 0x67a9ce67U, 0x2b7d562bU,
    0xfe19e7feU, 0xd762b5d7U, 0xabe64dabU, 0x769aec76U,
    0xca458fcaU, 0x829d1f82U, 0xc94089c9U, 0x7d87fa7dU,
    0xfa15effaU, 0x59ebb259U, 0x47c98e47U, 0xf00bfbf0U,
    0xadec41adU, 0xd467b3d4U, 0xa2fd5fa2U, 0xafea45afU,
    0x9cbf239cU, 0xa4f753a4U, 0x7296e472U, 0xc05b9bc0U,
    0xb7c275b7U, 0xfd1ce1fdU, 0x93ae3d93U, 0x266a4c26U,
    0x365a6c36U, 0x3f417e3fU, 0xf702f5f7U, 0xcc4f83ccU,
    0x345c6834U, 0xa5f451a5U, 0xe534d1e5U, 0xf108f9f1U,
    0x7193e271U, 0xd873abd8U, 0x31536231U, 0x153f2a15U,
    0x040c0804U, 0xc75295c7U, 0x23654623U, 0xc35e9dc3U,
    0x18283018U, 0x96a13796U, 0x050f0a05U, 0x9ab52f9aU,
    0x07090e07U, 0x12362412U, 0x809b1b80U, 0xe23ddfe2U,
    0xeb26cdebU, 0x27694e27U, 0xb2cd7fb2U, 0x759fea75U,
    0x091b1209U, 0x839e1d83U, 0x2c74582cU, 0x1a2e341aU,
    0x1b2d361bU, 0x6eb2dc6eU, 0x5aeeb45aU, 0xa0fb5ba0U,
    0x52f6a452U, 0x3b4d763bU, 0xd661b7d6U, 0xb3ce7db3U,
    0x297b5229U, 0xe33edde3U, 0x2f715e2fU, 0x84971384U,
    0x53f5a653U, 0xd168b9d1U, 0x00000000U, 0xed2cc1edU,
    0x20604020U, 0xfc1fe3fcU, 0xb1c879b1U, 0x5bedb65bU,
    0x6abed46aU, 0xcb468dcbU, 0xbed967beU, 0x394b7239U,
    0x4ade944aU, 0x4cd4984cU, 0x58e8b058U, 0xcf4a85cfU,
    0xd06bbbd0U, 0xef2ac5efU, 0xaae54faaU, 0xfb16edfbU,
    0x43c58643U, 0x4dd79a4dU, 0x33556633U, 0x85941185U,
    0x45cf8a45U, 0xf910e9f9U, 0x02060402U, 0x7f81fe7fU,
    0x50f0a050U, 0x3c44783cU, 0x9fba259fU, 0xa8e34ba8U,
    0x51f3a251U, 0xa3fe5da3U, 0x40c08040U, 0x8f8a058fU,
    0x92ad3f92U, 0x9dbc219dU, 0x38487038U, 0xf504f1f5U,
    0xbcdf63bcU, 0xb6c177b6U, 0xda75afdaU, 0x21634221U,
    0x10302010U, 0xff1ae5ffU, 0xf30efdf3U, 0xd26dbfd2U,
    0xcd4c81cdU, 0x0c14180cU, 0x13352613U, 0xec2fc3ecU,
    0x5fe1be5fU, 0x97a23597U, 0x44cc8844U, 0x17392e17U,
    0xc45793c4U, 0xa7f255a7U, 0x7e82fc7eU, 0x3d477a3dU,
    0x64acc864U, 0x5de7ba5dU, 0x192b3219U, 0x7395e673U,
    0x60a0c060U, 0x81981981U, 0x4fd19e4fU, 0xdc7fa3dcU,
    0x22664422U, 0x2a7e542aU, 0x90ab3b90U, 0x88830b88U,
    0x46ca8c46U, 0xee29c7eeU, 0xb8d36bb8U, 0x143c2814U,
    0xde79a7deU, 0x5ee2bc5eU, 0x0b1d160bU, 0xdb76addbU,
    0xe03bdbe0U, 0x32566432U, 0x3a4e743aU, 0x0a1e140aU,
    0x49db9249U, 0x060a0c06U, 0x246c4824U, 0x5ce4b85cU,
    0xc25d9fc2U, 0xd36ebdd3U, 0xacef43acU, 0x62a6c462U,
    0x91a83991U, 0x95a43195U, 0xe437d3e4U, 0x798bf279U,
    0xe732d5e7U, 0xc8438bc8U, 0x37596e37U, 0x6db7da6dU,
    0x8d8c018dU, 0xd564b1d5U, 0x4ed29c4eU, 0xa9e049a9U,
    0x6cb4d86cU, 0x56faac56U, 0xf407f3f4U, 0xea25cfeaU,
    0x65afca65U, 0x7a8ef47aU, 0xaee947aeU, 0x08181008U,
    0xbad56fbaU, 0x7888f078U, 0x256f4a25U, 0x2e725c2eU,
    0x1c24381cU, 0xa6f157a6U, 0xb4c773b4U, 0xc65197c6U,
    0xe823cbe8U, 0xdd7ca1ddU, 0x749ce874U, 0x1f213e1fU,
    0x4bdd964bU, 0xbddc61bdU, 0x8b860d8bU, 0x8a850f8aU,
    0x7090e070U, 0x3e427c3eU, 0xb5c471b5U, 0x66aacc66U,
    0x48d89048U, 0x03050603U, 0xf601f7f6U, 0x0e121c0eU,
    0x61a3c261U, 0x355f6a35U, 0x57f9ae57U, 0xb9d069b9U,
    0x86911786U, 0xc15899c1U, 0x1d273a1dU, 0x9eb9279eU,
    0xe138d9e1U, 0xf813ebf8U, 0x98b32b98U, 0x11332211U,
    0x69bbd269U, 0xd970a9d9U, 0x8e89078eU, 0x94a73394U,
    0x9bb62d9bU, 0x1e223c1eU, 0x87921587U, 0xe920c9e9U,
    0xce4987ceU, 0x55ffaa55U, 0x28785028U, 0xdf7aa5dfU,
    0x8c8f038cU, 0xa1f859a1U, 0x89800989U, 0x0d171a0dU,
    0xbfda65bfU, 0xe631d7e6U, 0x42c68442U, 0x68b8d068U,
    0x41c38241U, 0x99b02999U, 0x2d775a2dU, 0x0f111e0fU,
    0xb0cb7bb0U, 0x54fca854U, 0xbbd66dbbU, 0x163a2c16U,

################################################################################

TITLE
    Rijndael Te3 (0x6363a5c6U)

TYPE
    32

DATA
    0x6363a5c6U, 0x7c7c84f8U, 0x777799eeU, 0x7b7b8df6U,
    0xf2f20dffU, 0x6b6bbdd6U, 0x6f6fb1deU, 0xc5c55491U,
    0x30305060U, 0x01010302U, 0x6767a9ceU, 0x2b2b7d56U,
    0xfefe19e7U, 0xd7d762b5U, 0xababe64dU, 0x76769aecU,
    0xcaca458fU, 0x82829d1fU, 0xc9c94089U, 0x7d7d87faU,
    0xfafa15efU, 0x5959ebb2U, 0x4747c98eU, 0xf0f00bfbU,
    0xadadec41U, 0xd4d467b3U, 0xa2a2fd5fU, 0xafafea45U,
    0x9c9cbf23U, 0xa4a4f753U, 0x727296e4U, 0xc0c05b9bU,
    0xb7b7c275U, 0xfdfd1ce1U, 0x9393ae3dU, 0x26266a4cU,
    0x36365a6cU, 0x3f3f417eU, 0xf7f702f5U, 0xcccc4f83U,
    0x34345c68U, 0xa5a5f451U, 0xe5e534d1U, 0xf1f108f9U,
    0x717193e2U, 0xd8d873abU, 0x31315362U, 0x15153f2aU,
    0x04040c08U, 0xc7c75295U, 0x23236546U, 0xc3c35e9dU,
    0x18182830U, 0x9696a137U, 0x05050f0aU, 0x9a9ab52fU,
    0x0707090eU, 0x12123624U, 0x80809b1bU, 0xe2e23ddfU,
    0xebeb26cdU, 0x2727694eU, 0xb2b2cd7fU, 0x75759feaU,
    0x09091b12U, 0x83839e1dU, 0x2c2c7458U, 0x1a1a2e34U,
    0x1b1b2d36U, 0x6e6eb2dcU, 0x5a5aeeb4U, 0xa0a0fb5bU,
    0x5252f6a4U, 0x3b3b4d76U, 0xd6d661b7U, 0xb3b3ce7dU,
    0x29297b52U, 0xe3e33eddU, 0x2f2f715eU, 0x84849713U,
    0x5353f5a6U, 0xd1d168b9U, 0x00000000U, 0xeded2cc1U,
    0x20206040U, 0xfcfc1fe3U, 0xb1b1c879U, 0x5b5bedb6U,
    0x6a6abed4U, 0xcbcb468dU, 0xbebed967U, 0x39394b72U,
    0x4a4ade94U, 0x4c4cd498U, 0x5858e8b0U, 0xcfcf4a85U,
    0xd0d06bbbU, 0xefef2ac5U, 0xaaaae54fU, 0xfbfb16edU,
    0x4343c586U, 0x4d4dd79aU, 0x33335566U, 0x85859411U,
    0x4545cf8aU, 0xf9f910e9U, 0x02020604U, 0x7f7f81feU,
    0x5050f0a0U, 0x3c3c4478U, 0x9f9fba25U, 0xa8a8e34bU,
    0x5151f3a2U, 0xa3a3fe5dU, 0x4040c080U, 0x8f8f8a05U,
    0x9292ad3fU, 0x9d9dbc21U, 0x38384870U, 0xf5f504f1U,
    0xbcbcdf63U, 0xb6b6c177U, 0xdada75afU, 0x21216342U,
    0x10103020U, 0xffff1ae5U, 0xf3f30efdU, 0xd2d26dbfU,
    0xcdcd4c81U, 0x0c0c1418U, 0x13133526U, 0xecec2fc3U,
    0x5f5fe1beU, 0x9797a235U, 0x4444cc88U, 0x1717392eU,
    0xc4c45793U, 0xa7a7f255U, 0x7e7e82fcU, 0x3d3d477aU,
    0x6464acc8U, 0x5d5de7baU, 0x19192b32U, 0x737395e6U,
    0x6060a0c0U, 0x81819819U, 0x4f4fd19eU, 0xdcdc7fa3U,
    0x22226644U, 0x2a2a7e54U, 0x9090ab3bU, 0x8888830bU,
    0x4646ca8cU, 0xeeee29c7U, 0xb8b8d36bU, 0x14143c28U,
    0xdede79a7U, 0x5e5ee2bcU, 0x0b0b1d16U, 0xdbdb76adU,
    0xe0e03bdbU, 0x32325664U, 0x3a3a4e74U, 0x0a0a1e14U,
    0x4949db92U, 0x06060a0cU, 0x24246c48U, 0x5c5ce4b8U,
    0xc2c25d9fU, 0xd3d36ebdU, 0xacacef43U, 0x6262a6c4U,
    0x9191a839U, 0x9595a431U, 0xe4e437d3U, 0x79798bf2U,
    0xe7e732d5U, 0xc8c8438bU, 0x3737596eU, 0x6d6db7daU,
    0x8d8d8c01U, 0xd5d564b1U, 0x4e4ed29cU, 0xa9a9e049U,
    0x6c6cb4d8U, 0x5656faacU, 0xf4f407f3U, 0xeaea25cfU,
    0x6565afcaU, 0x7a7a8ef4U, 0xaeaee947U, 0x08081810U,
    0xbabad56fU, 0x787888f0U, 0x25256f4aU, 0x2e2e725cU,
    0x1c1c2438U, 0xa6a6f157U, 0xb4b4c773U, 0xc6c65197U,
    0xe8e823cbU, 0xdddd7ca1U, 0x74749ce8U, 0x1f1f213eU,
    0x4b4bdd96U, 0xbdbddc61U, 0x8b8b860dU, 0x8a8a850fU,
    0x707090e0U, 0x3e3e427cU, 0xb5b5c471U, 0x6666aaccU,
    0x4848d890U, 0x03030506U, 0xf6f601f7U, 0x0e0e121cU,
    0x6161a3c2U, 0x35355f6aU, 0x5757f9aeU, 0xb9b9d069U,
    0x86869117U, 0xc1c15899U, 0x1d1d273aU, 0x9e9eb927U,
    0xe1e138d9U, 0xf8f813ebU, 0x9898b32bU, 0x11113322U,
    0x6969bbd2U, 0xd9d970a9U, 0x8e8e8907U, 0x9494a733U,
    0x9b9bb62dU, 0x1e1e223cU, 0x87879215U, 0xe9e920c9U,
    0xcece4987U, 0x5555ffaaU, 0x28287850U, 0xdfdf7aa5U,
    0x8c8c8f03U, 0xa1a1f859U, 0x89898009U, 0x0d0d171aU,
    0xbfbfda65U, 0xe6e631d7U, 0x4242c684U, 0x6868b8d0U,
    0x4141c382U, 0x9999b029U, 0x2d2d775aU, 0x0f0f111eU,
    0xb0b0cb7bU, 0x5454fca8U, 0xbbbbd66dU, 0x16163a2cU,

################################################################################

TITLE
    Rijndael Te4 (0x63636363U)

TYPE
    32

DATA
    0x63636363U, 0x7c7c7c7cU, 0x77777777U, 0x7b7b7b7bU,
    0xf2f2f2f2U, 0x6b6b6b6bU, 0x6f6f6f6fU, 0xc5c5c5c5U,
    0x30303030U, 0x01010101U, 0x67676767U, 0x2b2b2b2bU,
    0xfefefefeU, 0xd7d7d7d7U, 0xababababU, 0x76767676U,
    0xcacacacaU, 0x82828282U, 0xc9c9c9c9U, 0x7d7d7d7dU,
    0xfafafafaU, 0x59595959U, 0x47474747U, 0xf0f0f0f0U,
    0xadadadadU, 0xd4d4d4d4U, 0xa2a2a2a2U, 0xafafafafU,
    0x9c9c9c9cU, 0xa4a4a4a4U, 0x72727272U, 0xc0c0c0c0U,
    0xb7b7b7b7U, 0xfdfdfdfdU, 0x93939393U, 0x26262626U,
    0x36363636U, 0x3f3f3f3fU, 0xf7f7f7f7U, 0xccccccccU,
    0x34343434U, 0xa5a5a5a5U, 0xe5e5e5e5U, 0xf1f1f1f1U,
    0x71717171U, 0xd8d8d8d8U, 0x31313131U, 0x15151515U,
    0x04040404U, 0xc7c7c7c7U, 0x23232323U, 0xc3c3c3c3U,
    0x18181818U, 0x96969696U, 0x05050505U, 0x9a9a9a9aU,
    0x07070707U, 0x12121212U, 0x80808080U, 0xe2e2e2e2U,
    0xebebebebU, 0x27272727U, 0xb2b2b2b2U, 0x75757575U,
    0x09090909U, 0x83838383U, 0x2c2c2c2cU, 0x1a1a1a1aU,
    0x1b1b1b1bU, 0x6e6e6e6eU, 0x5a5a5a5aU, 0xa0a0a0a0U,
    0x52525252U, 0x3b3b3b3bU, 0xd6d6d6d6U, 0xb3b3b3b3U,
    0x29292929U, 0xe3e3e3e3U, 0x2f2f2f2fU, 0x84848484U,
    0x53535353U, 0xd1d1d1d1U, 0x00000000U, 0xededededU,
    0x20202020U, 0xfcfcfcfcU, 0xb1b1b1b1U, 0x5b5b5b5bU,
    0x6a6a6a6aU, 0xcbcbcbcbU, 0xbebebebeU, 0x39393939U,
    0x4a4a4a4aU, 0x4c4c4c4cU, 0x58585858U, 0xcfcfcfcfU,
    0xd0d0d0d0U, 0xefefefefU, 0xaaaaaaaaU, 0xfbfbfbfbU,
    0x43434343U, 0x4d4d4d4dU, 0x33333333U, 0x85858585U,
    0x45454545U, 0xf9f9f9f9U, 0x02020202U, 0x7f7f7f7fU,
    0x50505050U, 0x3c3c3c3cU, 0x9f9f9f9fU, 0xa8a8a8a8U,
    0x51515151U, 0xa3a3a3a3U, 0x40404040U, 0x8f8f8f8fU,
    0x92929292U, 0x9d9d9d9dU, 0x38383838U, 0xf5f5f5f5U,
    0xbcbcbcbcU, 0xb6b6b6b6U, 0xdadadadaU, 0x21212121U,
    0x10101010U, 0xffffffffU, 0xf3f3f3f3U, 0xd2d2d2d2U,
    0xcdcdcdcdU, 0x0c0c0c0cU, 0x13131313U, 0xececececU,
    0x5f5f5f5fU, 0x97979797U, 0x44444444U, 0x17171717U,
    0xc4c4c4c4U, 0xa7a7a7a7U, 0x7e7e7e7eU, 0x3d3d3d3dU,
    0x64646464U, 0x5d5d5d5dU, 0x19191919U, 0x73737373U,
    0x60606060U, 0x81818181U, 0x4f4f4f4fU, 0xdcdcdcdcU,
    0x22222222U, 0x2a2a2a2aU, 0x90909090U, 0x88888888U,
    0x46464646U, 0xeeeeeeeeU, 0xb8b8b8b8U, 0x14141414U,
    0xdedededeU, 0x5e5e5e5eU, 0x0b0b0b0bU, 0xdbdbdbdbU,
    0xe0e0e0e0U, 0x32323232U, 0x3a3a3a3aU, 0x0a0a0a0aU,
    0x49494949U, 0x06060606U, 0x24242424U, 0x5c5c5c5cU,
    0xc2c2c2c2U, 0xd3d3d3d3U, 0xacacacacU, 0x62626262U,
    0x91919191U, 0x95959595U, 0xe4e4e4e4U, 0x79797979U,
    0xe7e7e7e7U, 0xc8c8c8c8U, 0x37373737U, 0x6d6d6d6dU,
    0x8d8d8d8dU, 0xd5d5d5d5U, 0x4e4e4e4eU, 0xa9a9a9a9U,
    0x6c6c6c6cU, 0x56565656U, 0xf4f4f4f4U, 0xeaeaeaeaU,
    0x65656565U, 0x7a7a7a7aU, 0xaeaeaeaeU, 0x08080808U,
    0xbabababaU, 0x78787878U, 0x25252525U, 0x2e2e2e2eU,
    0x1c1c1c1cU, 0xa6a6a6a6U, 0xb4b4b4b4U, 0xc6c6c6c6U,
    0xe8e8e8e8U, 0xddddddddU, 0x74747474U, 0x1f1f1f1fU,
    0x4b4b4b4bU, 0xbdbdbdbdU, 0x8b8b8b8bU, 0x8a8a8a8aU,
    0x70707070U, 0x3e3e3e3eU, 0xb5b5b5b5U, 0x66666666U,
    0x48484848U, 0x03030303U, 0xf6f6f6f6U, 0x0e0e0e0eU,
    0x61616161U, 0x35353535U, 0x57575757U, 0xb9b9b9b9U,
    0x86868686U, 0xc1c1c1c1U, 0x1d1d1d1dU, 0x9e9e9e9eU,
    0xe1e1e1e1U, 0xf8f8f8f8U, 0x98989898U, 0x11111111U,
    0x69696969U, 0xd9d9d9d9U, 0x8e8e8e8eU, 0x94949494U,
    0x9b9b9b9bU, 0x1e1e1e1eU, 0x87878787U, 0xe9e9e9e9U,
    0xcecececeU, 0x55555555U, 0x28282828U, 0xdfdfdfdfU,
    0x8c8c8c8cU, 0xa1a1a1a1U, 0x89898989U, 0x0d0d0d0dU,
    0xbfbfbfbfU, 0xe6e6e6e6U, 0x42424242U, 0x68686868U,
    0x41414141U, 0x99999999U, 0x2d2d2d2dU, 0x0f0f0f0fU,
    0xb0b0b0b0U, 0x54545454U, 0xbbbbbbbbU, 0x16161616U,

################################################################################

TITLE
    Rijndael Td0 (0x51f4a750U)

TYPE
    32

DATA
    0x51f4a750U, 0x7e416553U, 0x1a17a4c3U, 0x3a275e96U,
    0x3bab6bcbU, 0x1f9d45f1U, 0xacfa58abU, 0x4be30393U,
    0x2030fa55U, 0xad766df6U, 0x88cc7691U, 0xf5024c25U,
    0x4fe5d7fcU, 0xc52acbd7U, 0x26354480U, 0xb562a38fU,
    0xdeb15a49U, 0x25ba1b67U, 0x45ea0e98U, 0x5dfec0e1U,
    0xc32f7502U, 0x814cf012U, 0x8d4697a3U, 0x6bd3f9c6U,
    0x038f5fe7U, 0x15929c95U, 0xbf6d7aebU, 0x955259daU,
    0xd4be832dU, 0x587421d3U, 0x49e06929U, 0x8ec9c844U,
    0x75c2896aU, 0xf48e7978U, 0x99583e6bU, 0x27b971ddU,
    0xbee14fb6U, 0xf088ad17U, 0xc920ac66U, 0x7dce3ab4U,
    0x63df4a18U, 0xe51a3182U, 0x97513360U, 0x62537f45U,
    0xb16477e0U, 0xbb6bae84U, 0xfe81a01cU, 0xf9082b94U,
    0x70486858U, 0x8f45fd19U, 0x94de6c87U, 0x527bf8b7U,
    0xab73d323U, 0x724b02e2U, 0xe31f8f57U, 0x6655ab2aU,
    0xb2eb2807U, 0x2fb5c203U, 0x86c57b9aU, 0xd33708a5U,
    0x302887f2U, 0x23bfa5b2U, 0x02036abaU, 0xed16825cU,
    0x8acf1c2bU, 0xa779b492U, 0xf307f2f0U, 0x4e69e2a1U,
    0x65daf4cdU, 0x0605bed5U, 0xd134621fU, 0xc4a6fe8aU,
    0x342e539dU, 0xa2f355a0U, 0x058ae132U, 0xa4f6eb75U,
    0x0b83ec39U, 0x4060efaaU, 0x5e719f06U, 0xbd6e1051U,
    0x3e218af9U, 0x96dd063dU, 0xdd3e05aeU, 0x4de6bd46U,
    0x91548db5U, 0x71c45d05U, 0x0406d46fU, 0x605015ffU,
    0x1998fb24U, 0xd6bde997U, 0x894043ccU, 0x67d99e77U,
    0xb0e842bdU, 0x07898b88U, 0xe7195b38U, 0x79c8eedbU,
    0xa17c0a47U, 0x7c420fe9U, 0xf8841ec9U, 0x00000000U,
    0x09808683U, 0x322bed48U, 0x1e1170acU, 0x6c5a724eU,
    0xfd0efffbU, 0x0f853856U, 0x3daed51eU, 0x362d3927U,
    0x0a0fd964U, 0x685ca621U, 0x9b5b54d1U, 0x24362e3aU,
    0x0c0a67b1U, 0x9357e70fU, 0xb4ee96d2U, 0x1b9b919eU,
    0x80c0c54fU, 0x61dc20a2U, 0x5a774b69U, 0x1c121a16U,
    0xe293ba0aU, 0xc0a02ae5U, 0x3c22e043U, 0x121b171dU,
    0x0e090d0bU, 0xf28bc7adU, 0x2db6a8b9U, 0x141ea9c8U,
    0x57f11985U, 0xaf75074cU, 0xee99ddbbU, 0xa37f60fdU,
    0xf701269fU, 0x5c72f5bcU, 0x44663bc5U, 0x5bfb7e34U,
    0x8b432976U, 0xcb23c6dcU, 0xb6edfc68U, 0xb8e4f163U,
    0xd731dccaU, 0x42638510U, 0x13972240U, 0x84c61120U,
    0x854a247dU, 0xd2bb3df8U, 0xaef93211U, 0xc729a16dU,
    0x1d9e2f4bU, 0xdcb230f3U, 0x0d8652ecU, 0x77c1e3d0U,
    0x2bb3166cU, 0xa970b999U, 0x119448faU, 0x47e96422U,
    0xa8fc8cc4U, 0xa0f03f1aU, 0x567d2cd8U, 0x223390efU,
    0x87494ec7U, 0xd938d1c1U, 0x8ccaa2feU, 0x98d40b36U,
    0xa6f581cfU, 0xa57ade28U, 0xdab78e26U, 0x3fadbfa4U,
    0x2c3a9de4U, 0x5078920dU, 0x6a5fcc9bU, 0x547e4662U,
    0xf68d13c2U, 0x90d8b8e8U, 0x2e39f75eU, 0x82c3aff5U,
    0x9f5d80beU, 0x69d0937cU, 0x6fd52da9U, 0xcf2512b3U,
    0xc8ac993bU, 0x10187da7U, 0xe89c636eU, 0xdb3bbb7bU,
    0xcd267809U, 0x6e5918f4U, 0xec9ab701U, 0x834f9aa8U,
    0xe6956e65U, 0xaaffe67eU, 0x21bccf08U, 0xef15e8e6U,
    0xbae79bd9U, 0x4a6f36ceU, 0xea9f09d4U, 0x29b07cd6U,
    0x31a4b2afU, 0x2a3f2331U, 0xc6a59430U, 0x35a266c0U,
    0x744ebc37U, 0xfc82caa6U, 0xe090d0b0U, 0x33a7d815U,
    0xf104984aU, 0x41ecdaf7U, 0x7fcd500eU, 0x1791f62fU,
    0x764dd68dU, 0x43efb04dU, 0xccaa4d54U, 0xe49604dfU,
    0x9ed1b5e3U, 0x4c6a881bU, 0xc12c1fb8U, 0x4665517fU,
    0x9d5eea04U, 0x018c355dU, 0xfa877473U, 0xfb0b412eU,
    0xb3671d5aU, 0x92dbd252U, 0xe9105633U, 0x6dd64713U,
    0x9ad7618cU, 0x37a10c7aU, 0x59f8148eU, 0xeb133c89U,
    0xcea927eeU, 0xb761c935U, 0xe11ce5edU, 0x7a47b13cU,
    0x9cd2df59U, 0x55f2733fU, 0x1814ce79U, 0x73c737bfU,
    0x53f7cdeaU, 0x5ffdaa5bU, 0xdf3d6f14U, 0x7844db86U,
    0xcaaff381U, 0xb968c43eU, 0x3824342cU, 0xc2a3405fU,
    0x161dc372U, 0xbce2250cU, 0x283c498bU, 0xff0d9541U,
    0x39a80171U, 0x080cb3deU, 0xd8b4e49cU, 0x6456c190U,
    0x7bcb8461U, 0xd532b670U, 0x486c5c74U, 0xd0b85742U,

################################################################################

TITLE
    Rijndael Td1 (0x5051f4a7U)

TYPE
    32

DATA
    0x5051f4a7U, 0x537e4165U, 0xc31a17a4U, 0x963a275eU,
    0xcb3bab6bU, 0xf11f9d45U, 0xabacfa58U, 0x934be303U,
    0x552030faU, 0xf6ad766dU, 0x9188cc76U, 0x25f5024cU,
    0xfc4fe5d7U, 0xd7c52acbU, 0x80263544U, 0x8fb562a3U,
    0x49deb15aU, 0x6725ba1bU, 0x9845ea0eU, 0xe15dfec0U,
    0x02c32f75U, 0x12814cf0U, 0xa38d4697U, 0xc66bd3f9U,
    0xe7038f5fU, 0x9515929cU, 0xebbf6d7aU, 0xda955259U,
    0x2dd4be83U, 0xd3587421U, 0x2949e069U, 0x448ec9c8U,
    0x6a75c289U, 0x78f48e79U, 0x6b99583eU, 0xdd27b971U,
    0xb6bee14fU, 0x17f088adU, 0x66c920acU, 0xb47dce3aU,
    0x1863df4aU, 0x82e51a31U, 0x60975133U, 0x4562537fU,
    0xe0b16477U, 0x84bb6baeU, 0x1cfe81a0U, 0x94f9082bU,
    0x58704868U, 0x198f45fdU, 0x8794de6cU, 0xb7527bf8U,
    0x23ab73d3U, 0xe2724b02U, 0x57e31f8fU, 0x2a6655abU,
    0x07b2eb28U, 0x032fb5c2U, 0x9a86c57bU, 0xa5d33708U,
    0xf2302887U, 0xb223bfa5U, 0xba02036aU, 0x5ced1682U,
    0x2b8acf1cU, 0x92a779b4U, 0xf0f307f2U, 0xa14e69e2U,
    0xcd65daf4U, 0xd50605beU, 0x1fd13462U, 0x8ac4a6feU,
    0x9d342e53U, 0xa0a2f355U, 0x32058ae1U, 0x75a4f6ebU,
    0x390b83ecU, 0xaa4060efU, 0x065e719fU, 0x51bd6e10U,
    0xf93e218aU, 0x3d96dd06U, 0xaedd3e05U, 0x464de6bdU,
    0xb591548dU, 0x0571c45dU, 0x6f0406d4U, 0xff605015U,
    0x241998fbU, 0x97d6bde9U, 0xcc894043U, 0x7767d99eU,
    0xbdb0e842U, 0x8807898bU, 0x38e7195bU, 0xdb79c8eeU,
    0x47a17c0aU, 0xe97c420fU, 0xc9f8841eU, 0x00000000U,
    0x83098086U, 0x48322bedU, 0xac1e1170U, 0x4e6c5a72U,
    0xfbfd0effU, 0x560f8538U, 0x1e3daed5U, 0x27362d39U,
    0x640a0fd9U, 0x21685ca6U, 0xd19b5b54U, 0x3a24362eU,
    0xb10c0a67U, 0x0f9357e7U, 0xd2b4ee96U, 0x9e1b9b91U,
    0x4f80c0c5U, 0xa261dc20U, 0x695a774bU, 0x161c121aU,
    0x0ae293baU, 0xe5c0a02aU, 0x433c22e0U, 0x1d121b17U,
    0x0b0e090dU, 0xadf28bc7U, 0xb92db6a8U, 0xc8141ea9U,
    0x8557f119U, 0x4caf7507U, 0xbbee99ddU, 0xfda37f60U,
    0x9ff70126U, 0xbc5c72f5U, 0xc544663bU, 0x345bfb7eU,
    0x768b4329U, 0xdccb23c6U, 0x68b6edfcU, 0x63b8e4f1U,
    0xcad731dcU, 0x10426385U, 0x40139722U, 0x2084c611U,
    0x7d854a24U, 0xf8d2bb3dU, 0x11aef932U, 0x6dc729a1U,
    0x4b1d9e2fU, 0xf3dcb230U, 0xec0d8652U, 0xd077c1e3U,
    0x6c2bb316U, 0x99a970b9U, 0xfa119448U, 0x2247e964U,
    0xc4a8fc8cU, 0x1aa0f03fU, 0xd8567d2cU, 0xef223390U,
    0xc787494eU, 0xc1d938d1U, 0xfe8ccaa2U, 0x3698d40bU,
    0xcfa6f581U, 0x28a57adeU, 0x26dab78eU, 0xa43fadbfU,
    0xe42c3a9dU, 0x0d507892U, 0x9b6a5fccU, 0x62547e46U,
    0xc2f68d13U, 0xe890d8b8U, 0x5e2e39f7U, 0xf582c3afU,
    0xbe9f5d80U, 0x7c69d093U, 0xa96fd52dU, 0xb3cf2512U,
    0x3bc8ac99U, 0xa710187dU, 0x6ee89c63U, 0x7bdb3bbbU,
    0x09cd2678U, 0xf46e5918U, 0x01ec9ab7U, 0xa8834f9aU,
    0x65e6956eU, 0x7eaaffe6U, 0x0821bccfU, 0xe6ef15e8U,
    0xd9bae79bU, 0xce4a6f36U, 0xd4ea9f09U, 0xd629b07cU,
    0xaf31a4b2U, 0x312a3f23U, 0x30c6a594U, 0xc035a266U,
    0x37744ebcU, 0xa6fc82caU, 0xb0e090d0U, 0x1533a7d8U,
    0x4af10498U, 0xf741ecdaU, 0x0e7fcd50U, 0x2f1791f6U,
    0x8d764dd6U, 0x4d43efb0U, 0x54ccaa4dU, 0xdfe49604U,
    0xe39ed1b5U, 0x1b4c6a88U, 0xb8c12c1fU, 0x7f466551U,
    0x049d5eeaU, 0x5d018c35U, 0x73fa8774U, 0x2efb0b41U,
    0x5ab3671dU, 0x5292dbd2U, 0x33e91056U, 0x136dd647U,
    0x8c9ad761U, 0x7a37a10cU, 0x8e59f814U, 0x89eb133cU,
    0xeecea927U, 0x35b761c9U, 0xede11ce5U, 0x3c7a47b1U,
    0x599cd2dfU, 0x3f55f273U, 0x791814ceU, 0xbf73c737U,
    0xea53f7cdU, 0x5b5ffdaaU, 0x14df3d6fU, 0x867844dbU,
    0x81caaff3U, 0x3eb968c4U, 0x2c382434U, 0x5fc2a340U,
    0x72161dc3U, 0x0cbce225U, 0x8b283c49U, 0x41ff0d95U,
    0x7139a801U, 0xde080cb3U, 0x9cd8b4e4U, 0x906456c1U,
    0x617bcb84U, 0x70d532b6U, 0x74486c5cU, 0x42d0b857U,

################################################################################

TITLE
    Rijndael Td2 (0xa75051f4U)

TYPE
    32

DATA
    0xa75051f4U, 0x65537e41U, 0xa4c31a17U, 0x5e963a27U,
    0x6bcb3babU, 0x45f11f9dU, 0x58abacfaU, 0x03934be3U,
    0xfa552030U, 0x6df6ad76U, 0x769188ccU, 0x4c25f502U,
    0xd7fc4fe5U, 0xcbd7c52aU, 0x44802635U, 0xa38fb562U,
    0x5a49deb1U, 0x1b6725baU, 0x0e9845eaU, 0xc0e15dfeU,
    0x7502c32fU, 0xf012814cU, 0x97a38d46U, 0xf9c66bd3U,
    0x5fe7038fU, 0x9c951592U, 0x7aebbf6dU, 0x59da9552U,
    0x832dd4beU, 0x21d35874U, 0x692949e0U, 0xc8448ec9U,
    0x896a75c2U, 0x7978f48eU, 0x3e6b9958U, 0x71dd27b9U,
    0x4fb6bee1U, 0xad17f088U, 0xac66c920U, 0x3ab47dceU,
    0x4a1863dfU, 0x3182e51aU, 0x33609751U, 0x7f456253U,
    0x77e0b164U, 0xae84bb6bU, 0xa01cfe81U, 0x2b94f908U,
    0x68587048U, 0xfd198f45U, 0x6c8794deU, 0xf8b7527bU,
    0xd323ab73U, 0x02e2724bU, 0x8f57e31fU, 0xab2a6655U,
    0x2807b2ebU, 0xc2032fb5U, 0x7b9a86c5U, 0x08a5d337U,
    0x87f23028U, 0xa5b223bfU, 0x6aba0203U, 0x825ced16U,
    0x1c2b8acfU, 0xb492a779U, 0xf2f0f307U, 0xe2a14e69U,
    0xf4cd65daU, 0xbed50605U, 0x621fd134U, 0xfe8ac4a6U,
    0x539d342eU, 0x55a0a2f3U, 0xe132058aU, 0xeb75a4f6U,
    0xec390b83U, 0xefaa4060U, 0x9f065e71U, 0x1051bd6eU,
    0x8af93e21U, 0x063d96ddU, 0x05aedd3eU, 0xbd464de6U,
    0x8db59154U, 0x5d0571c4U, 0xd46f0406U, 0x15ff6050U,
    0xfb241998U, 0xe997d6bdU, 0x43cc8940U, 0x9e7767d9U,
    0x42bdb0e8U, 0x8b880789U, 0x5b38e719U, 0xeedb79c8U,
    0x0a47a17cU, 0x0fe97c42U, 0x1ec9f884U, 0x00000000U,
    0x86830980U, 0xed48322bU, 0x70ac1e11U, 0x724e6c5aU,
    0xfffbfd0eU, 0x38560f85U, 0xd51e3daeU, 0x3927362dU,
    0xd9640a0fU, 0xa621685cU, 0x54d19b5bU, 0x2e3a2436U,
    0x67b10c0aU, 0xe70f9357U, 0x96d2b4eeU, 0x919e1b9bU,
    0xc54f80c0U, 0x20a261dcU, 0x4b695a77U, 0x1a161c12U,
    0xba0ae293U, 0x2ae5c0a0U, 0xe0433c22U, 0x171d121bU,
    0x0d0b0e09U, 0xc7adf28bU, 0xa8b92db6U, 0xa9c8141eU,
    0x198557f1U, 0x074caf75U, 0xddbbee99U, 0x60fda37fU,
    0x269ff701U, 0xf5bc5c72U, 0x3bc54466U, 0x7e345bfbU,
    0x29768b43U, 0xc6dccb23U, 0xfc68b6edU, 0xf163b8e4U,
    0xdccad731U, 0x85104263U, 0x22401397U, 0x112084c6U,
    0x247d854aU, 0x3df8d2bbU, 0x3211aef9U, 0xa16dc729U,
    0x2f4b1d9eU, 0x30f3dcb2U, 0x52ec0d86U, 0xe3d077c1U,
    0x166c2bb3U, 0xb999a970U, 0x48fa1194U, 0x642247e9U,
    0x8cc4a8fcU, 0x3f1aa0f0U, 0x2cd8567dU, 0x90ef2233U,
    0x4ec78749U, 0xd1c1d938U, 0xa2fe8ccaU, 0x0b3698d4U,
    0x81cfa6f5U, 0xde28a57aU, 0x8e26dab7U, 0xbfa43fadU,
    0x9de42c3aU, 0x920d5078U, 0xcc9b6a5fU, 0x4662547eU,
    0x13c2f68dU, 0xb8e890d8U, 0xf75e2e39U, 0xaff582c3U,
    0x80be9f5dU, 0x937c69d0U, 0x2da96fd5U, 0x12b3cf25U,
    0x993bc8acU, 0x7da71018U, 0x636ee89cU, 0xbb7bdb3bU,
    0x7809cd26U, 0x18f46e59U, 0xb701ec9aU, 0x9aa8834fU,
    0x6e65e695U, 0xe67eaaffU, 0xcf0821bcU, 0xe8e6ef15U,
    0x9bd9bae7U, 0x36ce4a6fU, 0x09d4ea9fU, 0x7cd629b0U,
    0xb2af31a4U, 0x23312a3fU, 0x9430c6a5U, 0x66c035a2U,
    0xbc37744eU, 0xcaa6fc82U, 0xd0b0e090U, 0xd81533a7U,
    0x984af104U, 0xdaf741ecU, 0x500e7fcdU, 0xf62f1791U,
    0xd68d764dU, 0xb04d43efU, 0x4d54ccaaU, 0x04dfe496U,
    0xb5e39ed1U, 0x881b4c6aU, 0x1fb8c12cU, 0x517f4665U,
    0xea049d5eU, 0x355d018cU, 0x7473fa87U, 0x412efb0bU,
    0x1d5ab367U, 0xd25292dbU, 0x5633e910U, 0x47136dd6U,
    0x618c9ad7U, 0x0c7a37a1U, 0x148e59f8U, 0x3c89eb13U,
    0x27eecea9U, 0xc935b761U, 0xe5ede11cU, 0xb13c7a47U,
    0xdf599cd2U, 0x733f55f2U, 0xce791814U, 0x37bf73c7U,
    0xcdea53f7U, 0xaa5b5ffdU, 0x6f14df3dU, 0xdb867844U,
    0xf381caafU, 0xc43eb968U, 0x342c3824U, 0x405fc2a3U,
    0xc372161dU, 0x250cbce2U, 0x498b283cU, 0x9541ff0dU,
    0x017139a8U, 0xb3de080cU, 0xe49cd8b4U, 0xc1906456U,
    0x84617bcbU, 0xb670d532U, 0x5c74486cU, 0x5742d0b8U,

################################################################################

TITLE
    Rijndael Td3 (0xf4a75051U)

TYPE
    32

DATA
    0xf4a75051U, 0x4165537eU, 0x17a4c31aU, 0x275e963aU,
    0xab6bcb3bU, 0x9d45f11fU, 0xfa58abacU, 0xe303934bU,
    0x30fa5520U, 0x766df6adU, 0xcc769188U, 0x024c25f5U,
    0xe5d7fc4fU, 0x2acbd7c5U, 0x35448026U, 0x62a38fb5U,
    0xb15a49deU, 0xba1b6725U, 0xea0e9845U, 0xfec0e15dU,
    0x2f7502c3U, 0x4cf01281U, 0x4697a38dU, 0xd3f9c66bU,
    0x8f5fe703U, 0x929c9515U, 0x6d7aebbfU, 0x5259da95U,
    0xbe832dd4U, 0x7421d358U, 0xe0692949U, 0xc9c8448eU,
    0xc2896a75U, 0x8e7978f4U, 0x583e6b99U, 0xb971dd27U,
    0xe14fb6beU, 0x88ad17f0U, 0x20ac66c9U, 0xce3ab47dU,
    0xdf4a1863U, 0x1a3182e5U, 0x51336097U, 0x537f4562U,
    0x6477e0b1U, 0x6bae84bbU, 0x81a01cfeU, 0x082b94f9U,
    0x48685870U, 0x45fd198fU, 0xde6c8794U, 0x7bf8b752U,
    0x73d323abU, 0x4b02e272U, 0x1f8f57e3U, 0x55ab2a66U,
    0xeb2807b2U, 0xb5c2032fU, 0xc57b9a86U, 0x3708a5d3U,
    0x2887f230U, 0xbfa5b223U, 0x036aba02U, 0x16825cedU,
    0xcf1c2b8aU, 0x79b492a7U, 0x07f2f0f3U, 0x69e2a14eU,
    0xdaf4cd65U, 0x05bed506U, 0x34621fd1U, 0xa6fe8ac4U,
    0x2e539d34U, 0xf355a0a2U, 0x8ae13205U, 0xf6eb75a4U,
    0x83ec390bU, 0x60efaa40U, 0x719f065eU, 0x6e1051bdU,
    0x218af93eU, 0xdd063d96U, 0x3e05aeddU, 0xe6bd464dU,
    0x548db591U, 0xc45d0571U, 0x06d46f04U, 0x5015ff60U,
    0x98fb2419U, 0xbde997d6U, 0x4043cc89U, 0xd99e7767U,
    0xe842bdb0U, 0x898b8807U, 0x195b38e7U, 0xc8eedb79U,
    0x7c0a47a1U, 0x420fe97cU, 0x841ec9f8U, 0x00000000U,
    0x80868309U, 0x2bed4832U, 0x1170ac1eU, 0x5a724e6cU,
    0x0efffbfdU, 0x8538560fU, 0xaed51e3dU, 0x2d392736U,
    0x0fd9640aU, 0x5ca62168U, 0x5b54d19bU, 0x362e3a24U,
    0x0a67b10cU, 0x57e70f93U, 0xee96d2b4U, 0x9b919e1bU,
    0xc0c54f80U, 0xdc20a261U, 0x774b695aU, 0x121a161cU,
    0x93ba0ae2U, 0xa02ae5c0U, 0x22e0433cU, 0x1b171d12U,
    0x090d0b0eU, 0x8bc7adf2U, 0xb6a8b92dU, 0x1ea9c814U,
    0xf1198557U, 0x75074cafU, 0x99ddbbeeU, 0x7f60fda3U,
    0x01269ff7U, 0x72f5bc5cU, 0x663bc544U, 0xfb7e345bU,
    0x4329768bU, 0x23c6dccbU, 0xedfc68b6U, 0xe4f163b8U,
    0x31dccad7U, 0x63851042U, 0x97224013U, 0xc6112084U,
    0x4a247d85U, 0xbb3df8d2U, 0xf93211aeU, 0x29a16dc7U,
    0x9e2f4b1dU, 0xb230f3dcU, 0x8652ec0dU, 0xc1e3d077U,
    0xb3166c2bU, 0x70b999a9U, 0x9448fa11U, 0xe9642247U,
    0xfc8cc4a8U, 0xf03f1aa0U, 0x7d2cd856U, 0x3390ef22U,
    0x494ec787U, 0x38d1c1d9U, 0xcaa2fe8cU, 0xd40b3698U,
    0xf581cfa6U, 0x7ade28a5U, 0xb78e26daU, 0xadbfa43fU,
    0x3a9de42cU, 0x78920d50U, 0x5fcc9b6aU, 0x7e466254U,
    0x8d13c2f6U, 0xd8b8e890U, 0x39f75e2eU, 0xc3aff582U,
    0x5d80be9fU, 0xd0937c69U, 0xd52da96fU, 0x2512b3cfU,
    0xac993bc8U, 0x187da710U, 0x9c636ee8U, 0x3bbb7bdbU,
    0x267809cdU, 0x5918f46eU, 0x9ab701ecU, 0x4f9aa883U,
    0x956e65e6U, 0xffe67eaaU, 0xbccf0821U, 0x15e8e6efU,
    0xe79bd9baU, 0x6f36ce4aU, 0x9f09d4eaU, 0xb07cd629U,
    0xa4b2af31U, 0x3f23312aU, 0xa59430c6U, 0xa266c035U,
    0x4ebc3774U, 0x82caa6fcU, 0x90d0b0e0U, 0xa7d81533U,
    0x04984af1U, 0xecdaf741U, 0xcd500e7fU, 0x91f62f17U,
    0x4dd68d76U, 0xefb04d43U, 0xaa4d54ccU, 0x9604dfe4U,
    0xd1b5e39eU, 0x6a881b4cU, 0x2c1fb8c1U, 0x65517f46U,
    0x5eea049dU, 0x8c355d01U, 0x877473faU, 0x0b412efbU,
    0x671d5ab3U, 0xdbd25292U, 0x105633e9U, 0xd647136dU,
    0xd7618c9aU, 0xa10c7a37U, 0xf8148e59U, 0x133c89ebU,
    0xa927eeceU, 0x61c935b7U, 0x1ce5ede1U, 0x47b13c7aU,
    0xd2df599cU, 0xf2733f55U, 0x14ce7918U, 0xc737bf73U,
    0xf7cdea53U, 0xfdaa5b5fU, 0x3d6f14dfU, 0x44db8678U,
    0xaff381caU, 0x68c43eb9U, 0x24342c38U, 0xa3405fc2U,
    0x1dc37216U, 0xe2250cbcU, 0x3c498b28U, 0x0d9541ffU,
    0xa8017139U, 0x0cb3de08U, 0xb4e49cd8U, 0x56c19064U,
    0xcb84617bU, 0x32b670d5U, 0x6c5c7448U, 0xb85742d0U,

################################################################################

TITLE
    Rijndael Td4 (0x52525252U)

TYPE
    32

DATA
    0x52525252U, 0x09090909U, 0x6a6a6a6aU, 0xd5d5d5d5U,
    0x30303030U, 0x36363636U, 0xa5a5a5a5U, 0x38383838U,
    0xbfbfbfbfU, 0x40404040U, 0xa3a3a3a3U, 0x9e9e9e9eU,
    0x81818181U, 0xf3f3f3f3U, 0xd7d7d7d7U, 0xfbfbfbfbU,
    0x7c7c7c7cU, 0xe3e3e3e3U, 0x39393939U, 0x82828282U,
    0x9b9b9b9bU, 0x2f2f2f2fU, 0xffffffffU, 0x87878787U,
    0x34343434U, 0x8e8e8e8eU, 0x43434343U, 0x44444444U,
    0xc4c4c4c4U, 0xdedededeU, 0xe9e9e9e9U, 0xcbcbcbcbU,
    0x54545454U, 0x7b7b7b7bU, 0x94949494U, 0x32323232U,
    0xa6a6a6a6U, 0xc2c2c2c2U, 0x23232323U, 0x3d3d3d3dU,
    0xeeeeeeeeU, 0x4c4c4c4cU, 0x95959595U, 0x0b0b0b0bU,
    0x42424242U, 0xfafafafaU, 0xc3c3c3c3U, 0x4e4e4e4eU,
    0x08080808U, 0x2e2e2e2eU, 0xa1a1a1a1U, 0x66666666U,
    0x28282828U, 0xd9d9d9d9U, 0x24242424U, 0xb2b2b2b2U,
    0x76767676U, 0x5b5b5b5bU, 0xa2a2a2a2U, 0x49494949U,
    0x6d6d6d6dU, 0x8b8b8b8bU, 0xd1d1d1d1U, 0x25252525U,
    0x72727272U, 0xf8f8f8f8U, 0xf6f6f6f6U, 0x64646464U,
    0x86868686U, 0x68686868U, 0x98989898U, 0x16161616U,
    0xd4d4d4d4U, 0xa4a4a4a4U, 0x5c5c5c5cU, 0xccccccccU,
    0x5d5d5d5dU, 0x65656565U, 0xb6b6b6b6U, 0x92929292U,
    0x6c6c6c6cU, 0x70707070U, 0x48484848U, 0x50505050U,
    0xfdfdfdfdU, 0xededededU, 0xb9b9b9b9U, 0xdadadadaU,
    0x5e5e5e5eU, 0x15151515U, 0x46464646U, 0x57575757U,
    0xa7a7a7a7U, 0x8d8d8d8dU, 0x9d9d9d9dU, 0x84848484U,
    0x90909090U, 0xd8d8d8d8U, 0xababababU, 0x00000000U,
    0x8c8c8c8cU, 0xbcbcbcbcU, 0xd3d3d3d3U, 0x0a0a0a0aU,
    0xf7f7f7f7U, 0xe4e4e4e4U, 0x58585858U, 0x05050505U,
    0xb8b8b8b8U, 0xb3b3b3b3U, 0x45454545U, 0x06060606U,
    0xd0d0d0d0U, 0x2c2c2c2cU, 0x1e1e1e1eU, 0x8f8f8f8fU,
    0xcacacacaU, 0x3f3f3f3fU, 0x0f0f0f0fU, 0x02020202U,
    0xc1c1c1c1U, 0xafafafafU, 0xbdbdbdbdU, 0x03030303U,
    0x01010101U, 0x13131313U, 0x8a8a8a8aU, 0x6b6b6b6bU,
    0x3a3a3a3aU, 0x91919191U, 0x11111111U, 0x41414141U,
    0x4f4f4f4fU, 0x67676767U, 0xdcdcdcdcU, 0xeaeaeaeaU,
    0x97979797U, 0xf2f2f2f2U, 0xcfcfcfcfU, 0xcecececeU,
    0xf0f0f0f0U, 0xb4b4b4b4U, 0xe6e6e6e6U, 0x73737373U,
    0x96969696U, 0xacacacacU, 0x74747474U, 0x22222222U,
    0xe7e7e7e7U, 0xadadadadU, 0x35353535U, 0x85858585U,
    0xe2e2e2e2U, 0xf9f9f9f9U, 0x37373737U, 0xe8e8e8e8U,
    0x1c1c1c1cU, 0x75757575U, 0xdfdfdfdfU, 0x6e6e6e6eU,
    0x47474747U, 0xf1f1f1f1U, 0x1a1a1a1aU, 0x71717171U,
    0x1d1d1d1dU, 0x29292929U, 0xc5c5c5c5U, 0x89898989U,
    0x6f6f6f6fU, 0xb7b7b7b7U, 0x62626262U, 0x0e0e0e0eU,
    0xaaaaaaaaU, 0x18181818U, 0xbebebebeU, 0x1b1b1b1bU,
    0xfcfcfcfcU, 0x56565656U, 0x3e3e3e3eU, 0x4b4b4b4bU,
    0xc6c6c6c6U, 0xd2d2d2d2U, 0x79797979U, 0x20202020U,
    0x9a9a9a9aU, 0xdbdbdbdbU, 0xc0c0c0c0U, 0xfefefefeU,
    0x78787878U, 0xcdcdcdcdU, 0x5a5a5a5aU, 0xf4f4f4f4U,
    0x1f1f1f1fU, 0xddddddddU, 0xa8a8a8a8U, 0x33333333U,
    0x88888888U, 0x07070707U, 0xc7c7c7c7U, 0x31313131U,
    0xb1b1b1b1U, 0x12121212U, 0x10101010U, 0x59595959U,
    0x27272727U, 0x80808080U, 0xececececU, 0x5f5f5f5fU,
    0x60606060U, 0x51515151U, 0x7f7f7f7fU, 0xa9a9a9a9U,
    0x19191919U, 0xb5b5b5b5U, 0x4a4a4a4aU, 0x0d0d0d0dU,
    0x2d2d2d2dU, 0xe5e5e5e5U, 0x7a7a7a7aU, 0x9f9f9f9fU,
    0x93939393U, 0xc9c9c9c9U, 0x9c9c9c9cU, 0xefefefefU,
    0xa0a0a0a0U, 0xe0e0e0e0U, 0x3b3b3b3bU, 0x4d4d4d4dU,
    0xaeaeaeaeU, 0x2a2a2a2aU, 0xf5f5f5f5U, 0xb0b0b0b0U,
    0xc8c8c8c8U, 0xebebebebU, 0xbbbbbbbbU, 0x3c3c3c3cU,
    0x83838383U, 0x53535353U, 0x99999999U, 0x61616161U,
    0x17171717U, 0x2b2b2b2bU, 0x04040404U, 0x7e7e7e7eU,
    0xbabababaU, 0x77777777U, 0xd6d6d6d6U, 0x26262626U,
    0xe1e1e1e1U, 0x69696969U, 0x14141414U, 0x63636363U,
    0x55555555U, 0x21212121U, 0x0c0c0c0cU, 0x7d7d7d7dU,

################################################################################

TITLE
    Rijndael rcon

TYPE
    32

DATA
	0x01000000, 0x02000000, 0x04000000, 0x08000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000,
	0x1B000000, 0x36000000, /* for 128-bit blocks, Rijndael never uses more than 10 rcon values */

################################################################################

TITLE
    Scard DEFAUT0

TYPE
    8

DATA
    0xad, 0x9f, 0x61, 0xfe, 0xfa, 0x20, 0xce, 0x63

################################################################################

TITLE
    SSH RSA id-sha1 OBJ.ID. oiw(14) secsig(3) algorithms(2) 26

TYPE
    8

DATA
	0x30, 0x21, /* type Sequence, length 0x21 (33) */
	0x30, 0x09, /* type Sequence, length 0x09 */
	0x06, 0x05, /* type OID, length 0x05 */
	0x2b, 0x0e, 0x03, 0x02, 0x1a, /* id-sha1 OID */
	0x05, 0x00, /* NULL */
	0x04, 0x14  /* Octet string, length 0x14 (20), followed by sha1 hash */

################################################################################

TITLE
    OpenSSL dh512_p

TYPE
    8

DATA
	0xDA,0x58,0x3C,0x16,0xD9,0x85,0x22,0x89,0xD0,0xE4,0xAF,0x75,
	0x6F,0x4C,0xCA,0x92,0xDD,0x4B,0xE5,0x33,0xB8,0x04,0xFB,0x0F,
	0xED,0x94,0xEF,0x9C,0x8A,0x44,0x03,0xED,0x57,0x46,0x50,0xD3,
	0x69,0x99,0xDB,0x29,0xD7,0x76,0x27,0x6B,0xA2,0xD3,0xD4,0x12,
	0xE2,0x18,0xF4,0xDD,0x1E,0x08,0x4C,0xF6,0xD8,0x00,0x3E,0x7C,
	0x47,0x74,0xE8,0x33,

################################################################################

TITLE
    Blowfish bfp table

TYPE
    32

DATA
	0x243f6a88L, 0x85a308d3L, 0x13198a2eL, 0x03707344L,
	0xa4093822L, 0x299f31d0L, 0x082efa98L, 0xec4e6c89L,
	0x452821e6L, 0x38d01377L, 0xbe5466cfL, 0x34e90c6cL,
	0xc0ac29b7L, 0xc97c50ddL, 0x3f84d5b5L, 0xb5470917L,
	0x9216d5d9L, 0x8979fb1b

################################################################################

TITLE
    Blowfish ks0 table

TYPE
    32

DATA
  0xd1310ba6, 0x98dfb5ac, 0x2ffd72db, 0xd01adfb7,
  0xb8e1afed, 0x6a267e96, 0xba7c9045, 0xf12c7f99,
  0x24a19947, 0xb3916cf7, 0x0801f2e2, 0x858efc16,
  0x636920d8, 0x71574e69, 0xa458fea3, 0xf4933d7e,
  0x0d95748f, 0x728eb658, 0x718bcd58, 0x82154aee,
  0x7b54a41d, 0xc25a59b5, 0x9c30d539, 0x2af26013,
  0xc5d1b023, 0x286085f0, 0xca417918, 0xb8db38ef,
  0x8e79dcb0, 0x603a180e, 0x6c9e0e8b, 0xb01e8a3e,
  0xd71577c1, 0xbd314b27, 0x78af2fda, 0x55605c60,
  0xe65525f3, 0xaa55ab94, 0x57489862, 0x63e81440,
  0x55ca396a, 0x2aab10b6, 0xb4cc5c34, 0x1141e8ce,
  0xa15486af, 0x7c72e993, 0xb3ee1411, 0x636fbc2a,
  0x2ba9c55d, 0x741831f6, 0xce5c3e16, 0x9b87931e,
  0xafd6ba33, 0x6c24cf5c, 0x7a325381, 0x28958677,
  0x3b8f4898, 0x6b4bb9af, 0xc4bfe81b, 0x66282193,
  0x61d809cc, 0xfb21a991, 0x487cac60, 0x5dec8032,
  0xef845d5d, 0xe98575b1, 0xdc262302, 0xeb651b88,
  0x23893e81, 0xd396acc5, 0x0f6d6ff3, 0x83f44239,
  0x2e0b4482, 0xa4842004, 0x69c8f04a, 0x9e1f9b5e,
  0x21c66842, 0xf6e96c9a, 0x670c9c61, 0xabd388f0,
  0x6a51a0d2, 0xd8542f68, 0x960fa728, 0xab5133a3,
  0x6eef0b6c, 0x137a3be4, 0xba3bf050, 0x7efb2a98,
  0xa1f1651d, 0x39af0176, 0x66ca593e, 0x82430e88,
  0x8cee8619, 0x456f9fb4, 0x7d84a5c3, 0x3b8b5ebe,
  0xe06f75d8, 0x85c12073, 0x401a449f, 0x56c16aa6,
  0x4ed3aa62, 0x363f7706, 0x1bfedf72, 0x429b023d,
  0x37d0d724, 0xd00a1248, 0xdb0fead3, 0x49f1c09b,
  0x075372c9, 0x80991b7b, 0x25d479d8, 0xf6e8def7,
  0xe3fe501a, 0xb6794c3b, 0x976ce0bd, 0x04c006ba,
  0xc1a94fb6, 0x409f60c4, 0x5e5c9ec2, 0x196a2463,
  0x68fb6faf, 0x3e6c53b5, 0x1339b2eb, 0x3b52ec6f,
  0x6dfc511f, 0x9b30952c, 0xcc814544, 0xaf5ebd09,
  0xbee3d004, 0xde334afd, 0x660f2807, 0x192e4bb3,
  0xc0cba857, 0x45c8740f, 0xd20b5f39, 0xb9d3fbdb,
  0x5579c0bd, 0x1a60320a, 0xd6a100c6, 0x402c7279,
  0x679f25fe, 0xfb1fa3cc, 0x8ea5e9f8, 0xdb3222f8,
  0x3c7516df, 0xfd616b15, 0x2f501ec8, 0xad0552ab,
  0x323db5fa, 0xfd238760, 0x53317b48, 0x3e00df82,
  0x9e5c57bb, 0xca6f8ca0, 0x1a87562e, 0xdf1769db,
  0xd542a8f6, 0x287effc3, 0xac6732c6, 0x8c4f5573,
  0x695b27b0, 0xbbca58c8, 0xe1ffa35d, 0xb8f011a0,
  0x10fa3d98, 0xfd2183b8, 0x4afcb56c, 0x2dd1d35b,
  0x9a53e479, 0xb6f84565, 0xd28e49bc, 0x4bfb9790,
  0xe1ddf2da, 0xa4cb7e33, 0x62fb1341, 0xcee4c6e8,
  0xef20cada, 0x36774c01, 0xd07e9efe, 0x2bf11fb4,
  0x95dbda4d, 0xae909198, 0xeaad8e71, 0x6b93d5a0,
  0xd08ed1d0, 0xafc725e0, 0x8e3c5b2f, 0x8e7594b7,
  0x8ff6e2fb, 0xf2122b64, 0x8888b812, 0x900df01c,
  0x4fad5ea0, 0x688fc31c, 0xd1cff191, 0xb3a8c1ad,
  0x2f2f2218, 0xbe0e1777, 0xea752dfe, 0x8b021fa1,
  0xe5a0cc0f, 0xb56f74e8, 0x18acf3d6, 0xce89e299,
  0xb4a84fe0, 0xfd13e0b7, 0x7cc43b81, 0xd2ada8d9,
  0x165fa266, 0x80957705, 0x93cc7314, 0x211a1477,
  0xe6ad2065, 0x77b5fa86, 0xc75442f5, 0xfb9d35cf,
  0xebcdaf0c, 0x7b3e89a0, 0xd6411bd3, 0xae1e7e49,
  0x00250e2d, 0x2071b35e, 0x226800bb, 0x57b8e0af,
  0x2464369b, 0xf009b91e, 0x5563911d, 0x59dfa6aa,
  0x78c14389, 0xd95a537f, 0x207d5ba2, 0x02e5b9c5,
  0x83260376, 0x6295cfa9, 0x11c81968, 0x4e734a41,
  0xb3472dca, 0x7b14a94a, 0x1b510052, 0x9a532915,
  0xd60f573f, 0xbc9bc6e4, 0x2b60a476, 0x81e67400,
  0x08ba6fb5, 0x571be91f, 0xf296ec6b, 0x2a0dd915,
  0xb6636521, 0xe7b9f9b6, 0xff34052e, 0xc5855664,
  0x53b02d5d, 0xa99f8fa1, 0x08ba4799, 0x6e85076a

################################################################################

TITLE
    Blowfish ks1 table

TYPE
    32

DATA
  0x4b7a70e9, 0xb5b32944, 0xdb75092e, 0xc4192623,
  0xad6ea6b0, 0x49a7df7d, 0x9cee60b8, 0x8fedb266,
  0xecaa8c71, 0x699a17ff, 0x5664526c, 0xc2b19ee1,
  0x193602a5, 0x75094c29, 0xa0591340, 0xe4183a3e,
  0x3f54989a, 0x5b429d65, 0x6b8fe4d6, 0x99f73fd6,
  0xa1d29c07, 0xefe830f5, 0x4d2d38e6, 0xf0255dc1,
  0x4cdd2086, 0x8470eb26, 0x6382e9c6, 0x021ecc5e,
  0x09686b3f, 0x3ebaefc9, 0x3c971814, 0x6b6a70a1,
  0x687f3584, 0x52a0e286, 0xb79c5305, 0xaa500737,
  0x3e07841c, 0x7fdeae5c, 0x8e7d44ec, 0x5716f2b8,
  0xb03ada37, 0xf0500c0d, 0xf01c1f04, 0x0200b3ff,
  0xae0cf51a, 0x3cb574b2, 0x25837a58, 0xdc0921bd,
  0xd19113f9, 0x7ca92ff6, 0x94324773, 0x22f54701,
  0x3ae5e581, 0x37c2dadc, 0xc8b57634, 0x9af3dda7,
  0xa9446146, 0x0fd0030e, 0xecc8c73e, 0xa4751e41,
  0xe238cd99, 0x3bea0e2f, 0x3280bba1, 0x183eb331,
  0x4e548b38, 0x4f6db908, 0x6f420d03, 0xf60a04bf,
  0x2cb81290, 0x24977c79, 0x5679b072, 0xbcaf89af,
  0xde9a771f, 0xd9930810, 0xb38bae12, 0xdccf3f2e,
  0x5512721f, 0x2e6b7124, 0x501adde6, 0x9f84cd87,
  0x7a584718, 0x7408da17, 0xbc9f9abc, 0xe94b7d8c,
  0xec7aec3a, 0xdb851dfa, 0x63094366, 0xc464c3d2,
  0xef1c1847, 0x3215d908, 0xdd433b37, 0x24c2ba16,
  0x12a14d43, 0x2a65c451, 0x50940002, 0x133ae4dd,
  0x71dff89e, 0x10314e55, 0x81ac77d6, 0x5f11199b,
  0x043556f1, 0xd7a3c76b, 0x3c11183b, 0x5924a509,
  0xf28fe6ed, 0x97f1fbfa, 0x9ebabf2c, 0x1e153c6e,
  0x86e34570, 0xeae96fb1, 0x860e5e0a, 0x5a3e2ab3,
  0x771fe71c, 0x4e3d06fa, 0x2965dcb9, 0x99e71d0f,
  0x803e89d6, 0x5266c825, 0x2e4cc978, 0x9c10b36a,
  0xc6150eba, 0x94e2ea78, 0xa5fc3c53, 0x1e0a2df4,
  0xf2f74ea7, 0x361d2b3d, 0x1939260f, 0x19c27960,
  0x5223a708, 0xf71312b6, 0xebadfe6e, 0xeac31f66,
  0xe3bc4595, 0xa67bc883, 0xb17f37d1, 0x018cff28,
  0xc332ddef, 0xbe6c5aa5, 0x65582185, 0x68ab9802,
  0xeecea50f, 0xdb2f953b, 0x2aef7dad, 0x5b6e2f84,
  0x1521b628, 0x29076170, 0xecdd4775, 0x619f1510,
  0x13cca830, 0xeb61bd96, 0x0334fe1e, 0xaa0363cf,
  0xb5735c90, 0x4c70a239, 0xd59e9e0b, 0xcbaade14,
  0xeecc86bc, 0x60622ca7, 0x9cab5cab, 0xb2f3846e,
  0x648b1eaf, 0x19bdf0ca, 0xa02369b9, 0x655abb50,
  0x40685a32, 0x3c2ab4b3, 0x319ee9d5, 0xc021b8f7,
  0x9b540b19, 0x875fa099, 0x95f7997e, 0x623d7da8,
  0xf837889a, 0x97e32d77, 0x11ed935f, 0x16681281,
  0x0e358829, 0xc7e61fd6, 0x96dedfa1, 0x7858ba99,
  0x57f584a5, 0x1b227263, 0x9b83c3ff, 0x1ac24696,
  0xcdb30aeb, 0x532e3054, 0x8fd948e4, 0x6dbc3128,
  0x58ebf2ef, 0x34c6ffea, 0xfe28ed61, 0xee7c3c73,
  0x5d4a14d9, 0xe864b7e3, 0x42105d14, 0x203e13e0,
  0x45eee2b6, 0xa3aaabea, 0xdb6c4f15, 0xfacb4fd0,
  0xc742f442, 0xef6abbb5, 0x654f3b1d, 0x41cd2105,
  0xd81e799e, 0x86854dc7, 0xe44b476a, 0x3d816250,
  0xcf62a1f2, 0x5b8d2646, 0xfc8883a0, 0xc1c7b6a3,
  0x7f1524c3, 0x69cb7492, 0x47848a0b, 0x5692b285,
  0x095bbf00, 0xad19489d, 0x1462b174, 0x23820e00,
  0x58428d2a, 0x0c55f5ea, 0x1dadf43e, 0x233f7061,
  0x3372f092, 0x8d937e41, 0xd65fecf1, 0x6c223bdb,
  0x7cde3759, 0xcbee7460, 0x4085f2a7, 0xce77326e,
  0xa6078084, 0x19f8509e, 0xe8efd855, 0x61d99735,
  0xa969a7aa, 0xc50c06c2, 0x5a04abfc, 0x800bcadc,
  0x9e447a2e, 0xc3453484, 0xfdd56705, 0x0e1e9ec9,
  0xdb73dbd3, 0x105588cd, 0x675fda79, 0xe3674340,
  0xc5c43465, 0x713e38d8, 0x3d28f89e, 0xf16dff20,
  0x153e21e7, 0x8fb03d4a, 0xe6e39f2b, 0xdb83adf7

################################################################################

TITLE
    Blowfish ks2 table

TYPE
    32

DATA
  0xe93d5a68, 0x948140f7, 0xf64c261c, 0x94692934,
  0x411520f7, 0x7602d4f7, 0xbcf46b2e, 0xd4a20068,
  0xd4082471, 0x3320f46a, 0x43b7d4b7, 0x500061af,
  0x1e39f62e, 0x97244546, 0x14214f74, 0xbf8b8840,
  0x4d95fc1d, 0x96b591af, 0x70f4ddd3, 0x66a02f45,
  0xbfbc09ec, 0x03bd9785, 0x7fac6dd0, 0x31cb8504,
  0x96eb27b3, 0x55fd3941, 0xda2547e6, 0xabca0a9a,
  0x28507825, 0x530429f4, 0x0a2c86da, 0xe9b66dfb,
  0x68dc1462, 0xd7486900, 0x680ec0a4, 0x27a18dee,
  0x4f3ffea2, 0xe887ad8c, 0xb58ce006, 0x7af4d6b6,
  0xaace1e7c, 0xd3375fec, 0xce78a399, 0x406b2a42,
  0x20fe9e35, 0xd9f385b9, 0xee39d7ab, 0x3b124e8b,
  0x1dc9faf7, 0x4b6d1856, 0x26a36631, 0xeae397b2,
  0x3a6efa74, 0xdd5b4332, 0x6841e7f7, 0xca7820fb,
  0xfb0af54e, 0xd8feb397, 0x454056ac, 0xba489527,
  0x55533a3a, 0x20838d87, 0xfe6ba9b7, 0xd096954b,
  0x55a867bc, 0xa1159a58, 0xcca92963, 0x99e1db33,
  0xa62a4a56, 0x3f3125f9, 0x5ef47e1c, 0x9029317c,
  0xfdf8e802, 0x04272f70, 0x80bb155c, 0x05282ce3,
  0x95c11548, 0xe4c66d22, 0x48c1133f, 0xc70f86dc,
  0x07f9c9ee, 0x41041f0f, 0x404779a4, 0x5d886e17,
  0x325f51eb, 0xd59bc0d1, 0xf2bcc18f, 0x41113564,
  0x257b7834, 0x602a9c60, 0xdff8e8a3, 0x1f636c1b,
  0x0e12b4c2, 0x02e1329e, 0xaf664fd1, 0xcad18115,
  0x6b2395e0, 0x333e92e1, 0x3b240b62, 0xeebeb922,
  0x85b2a20e, 0xe6ba0d99, 0xde720c8c, 0x2da2f728,
  0xd0127845, 0x95b794fd, 0x647d0862, 0xe7ccf5f0,
  0x5449a36f, 0x877d48fa, 0xc39dfd27, 0xf33e8d1e,
  0x0a476341, 0x992eff74, 0x3a6f6eab, 0xf4f8fd37,
  0xa812dc60, 0xa1ebddf8, 0x991be14c, 0xdb6e6b0d,
  0xc67b5510, 0x6d672c37, 0x2765d43b, 0xdcd0e804,
  0xf1290dc7, 0xcc00ffa3, 0xb5390f92, 0x690fed0b,
  0x667b9ffb, 0xcedb7d9c, 0xa091cf0b, 0xd9155ea3,
  0xbb132f88, 0x515bad24, 0x7b9479bf, 0x763bd6eb,
  0x37392eb3, 0xcc115979, 0x8026e297, 0xf42e312d,
  0x6842ada7, 0xc66a2b3b, 0x12754ccc, 0x782ef11c,
  0x6a124237, 0xb79251e7, 0x06a1bbe6, 0x4bfb6350,
  0x1a6b1018, 0x11caedfa, 0x3d25bdd8, 0xe2e1c3c9,
  0x44421659, 0x0a121386, 0xd90cec6e, 0xd5abea2a,
  0x64af674e, 0xda86a85f, 0xbebfe988, 0x64e4c3fe,
  0x9dbc8057, 0xf0f7c086, 0x60787bf8, 0x6003604d,
  0xd1fd8346, 0xf6381fb0, 0x7745ae04, 0xd736fccc,
  0x83426b33, 0xf01eab71, 0xb0804187, 0x3c005e5f,
  0x77a057be, 0xbde8ae24, 0x55464299, 0xbf582e61,
  0x4e58f48f, 0xf2ddfda2, 0xf474ef38, 0x8789bdc2,
  0x5366f9c3, 0xc8b38e74, 0xb475f255, 0x46fcd9b9,
  0x7aeb2661, 0x8b1ddf84, 0x846a0e79, 0x915f95e2,
  0x466e598e, 0x20b45770, 0x8cd55591, 0xc902de4c,
  0xb90bace1, 0xbb8205d0, 0x11a86248, 0x7574a99e,
  0xb77f19b6, 0xe0a9dc09, 0x662d09a1, 0xc4324633,
  0xe85a1f02, 0x09f0be8c, 0x4a99a025, 0x1d6efe10,
  0x1ab93d1d, 0x0ba5a4df, 0xa186f20f, 0x2868f169,
  0xdcb7da83, 0x573906fe, 0xa1e2ce9b, 0x4fcd7f52,
  0x50115e01, 0xa70683fa, 0xa002b5c4, 0x0de6d027,
  0x9af88c27, 0x773f8641, 0xc3604c06, 0x61a806b5,
  0xf0177a28, 0xc0f586e0, 0x006058aa, 0x30dc7d62,
  0x11e69ed7, 0x2338ea63, 0x53c2dd94, 0xc2c21634,
  0xbbcbee56, 0x90bcb6de, 0xebfc7da1, 0xce591d76,
  0x6f05e409, 0x4b7c0188, 0x39720a3d, 0x7c927c24,
  0x86e3725f, 0x724d9db9, 0x1ac15bb4, 0xd39eb8fc,
  0xed545578, 0x08fca5b5, 0xd83d7cd3, 0x4dad0fc4,
  0x1e50ef5e, 0xb161e6f8, 0xa28514d9, 0x6c51133c,
  0x6fd5c7e7, 0x56e14ec4, 0x362abfce, 0xddc6c837,
  0xd79a3234, 0x92638212, 0x670efa8e, 0x406000e0

################################################################################

TITLE
    Blowfish ks3 table

TYPE
    32

DATA
  0x3a39ce37, 0xd3faf5cf, 0xabc27737, 0x5ac52d1b,
  0x5cb0679e, 0x4fa33742, 0xd3822740, 0x99bc9bbe,
  0xd5118e9d, 0xbf0f7315, 0xd62d1c7e, 0xc700c47b,
  0xb78c1b6b, 0x21a19045, 0xb26eb1be, 0x6a366eb4,
  0x5748ab2f, 0xbc946e79, 0xc6a376d2, 0x6549c2c8,
  0x530ff8ee, 0x468dde7d, 0xd5730a1d, 0x4cd04dc6,
  0x2939bbdb, 0xa9ba4650, 0xac9526e8, 0xbe5ee304,
  0xa1fad5f0, 0x6a2d519a, 0x63ef8ce2, 0x9a86ee22,
  0xc089c2b8, 0x43242ef6, 0xa51e03aa, 0x9cf2d0a4,
  0x83c061ba, 0x9be96a4d, 0x8fe51550, 0xba645bd6,
  0x2826a2f9, 0xa73a3ae1, 0x4ba99586, 0xef5562e9,
  0xc72fefd3, 0xf752f7da, 0x3f046f69, 0x77fa0a59,
  0x80e4a915, 0x87b08601, 0x9b09e6ad, 0x3b3ee593,
  0xe990fd5a, 0x9e34d797, 0x2cf0b7d9, 0x022b8b51,
  0x96d5ac3a, 0x017da67d, 0xd1cf3ed6, 0x7c7d2d28,
  0x1f9f25cf, 0xadf2b89b, 0x5ad6b472, 0x5a88f54c,
  0xe029ac71, 0xe019a5e6, 0x47b0acfd, 0xed93fa9b,
  0xe8d3c48d, 0x283b57cc, 0xf8d56629, 0x79132e28,
  0x785f0191, 0xed756055, 0xf7960e44, 0xe3d35e8c,
  0x15056dd4, 0x88f46dba, 0x03a16125, 0x0564f0bd,
  0xc3eb9e15, 0x3c9057a2, 0x97271aec, 0xa93a072a,
  0x1b3f6d9b, 0x1e6321f5, 0xf59c66fb, 0x26dcf319,
  0x7533d928, 0xb155fdf5, 0x03563482, 0x8aba3cbb,
  0x28517711, 0xc20ad9f8, 0xabcc5167, 0xccad925f,
  0x4de81751, 0x3830dc8e, 0x379d5862, 0x9320f991,
  0xea7a90c2, 0xfb3e7bce, 0x5121ce64, 0x774fbe32,
  0xa8b6e37e, 0xc3293d46, 0x48de5369, 0x6413e680,
  0xa2ae0810, 0xdd6db224, 0x69852dfd, 0x09072166,
  0xb39a460a, 0x6445c0dd, 0x586cdecf, 0x1c20c8ae,
  0x5bbef7dd, 0x1b588d40, 0xccd2017f, 0x6bb4e3bb,
  0xdda26a7e, 0x3a59ff45, 0x3e350a44, 0xbcb4cdd5,
  0x72eacea8, 0xfa6484bb, 0x8d6612ae, 0xbf3c6f47,
  0xd29be463, 0x542f5d9e, 0xaec2771b, 0xf64e6370,
  0x740e0d8d, 0xe75b1357, 0xf8721671, 0xaf537d5d,
  0x4040cb08, 0x4eb4e2cc, 0x34d2466a, 0x0115af84,
  0xe1b00428, 0x95983a1d, 0x06b89fb4, 0xce6ea048,
  0x6f3f3b82, 0x3520ab82, 0x011a1d4b, 0x277227f8,
  0x611560b1, 0xe7933fdc, 0xbb3a792b, 0x344525bd,
  0xa08839e1, 0x51ce794b, 0x2f32c9b7, 0xa01fbac9,
  0xe01cc87e, 0xbcc7d1f6, 0xcf0111c3, 0xa1e8aac7,
  0x1a908749, 0xd44fbd9a, 0xd0dadecb, 0xd50ada38,
  0x0339c32a, 0xc6913667, 0x8df9317c, 0xe0b12b4f,
  0xf79e59b7, 0x43f5bb3a, 0xf2d519ff, 0x27d9459c,
  0xbf97222c, 0x15e6fc2a, 0x0f91fc71, 0x9b941525,
  0xfae59361, 0xceb69ceb, 0xc2a86459, 0x12baa8d1,
  0xb6c1075e, 0xe3056a0c, 0x10d25065, 0xcb03a442,
  0xe0ec6e0e, 0x1698db3b, 0x4c98a0be, 0x3278e964,
  0x9f1f9532, 0xe0d392df, 0xd3a0342b, 0x8971f21e,
  0x1b0a7441, 0x4ba3348c, 0xc5be7120, 0xc37632d8,
  0xdf359f8d, 0x9b992f2e, 0xe60b6f47, 0x0fe3f11d,
  0xe54cda54, 0x1edad891, 0xce6279cf, 0xcd3e7e6f,
  0x1618b166, 0xfd2c1d05, 0x848fd2c5, 0xf6fb2299,
  0xf523f357, 0xa6327623, 0x93a83531, 0x56cccd02,
  0xacf08162, 0x5a75ebb5, 0x6e163697, 0x88d273cc,
  0xde966292, 0x81b949d0, 0x4c50901b, 0x71c65614,
  0xe6c6c7bd, 0x327a140a, 0x45e1d006, 0xc3f27b9a,
  0xc9aa53fd, 0x62a80f00, 0xbb25bfe2, 0x35bdd2f6,
  0x71126905, 0xb2040222, 0xb6cbcf7c, 0xcd769c2b,
  0x53113ec0, 0x1640e3d3, 0x38abbd60, 0x2547adf0,
  0xba38209c, 0xf746ce76, 0x77afa1c5, 0x20756060,
  0x85cbfe4e, 0x8ae88dd8, 0x7aaaf9b0, 0x4cf9aa7e,
  0x1948c25c, 0x02fb8a8c, 0x01c36ae4, 0xd6ebe1f9,
  0x90d4f869, 0xa65cdea0, 0x3f09252d, 0xc208e69f,
  0xb74e6132, 0xce77e25b, 0x578fdfe3, 0x3ac372e6

################################################################################

TITLE
    "First Oakley Default Group" (768-bit) from RFC2409

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x3A,0x36,0x20,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "Second Oakley Default Group" (1024-bit) from RFC2409

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE6,0x53,0x81,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "1536-bit MODP Group" from RFC3526, Section 2.

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x23,0x73,0x27,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "2048-bit MODP Group" from RFC3526, Section 3.

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x18,0x21,0x7C,0x32,0x90,0x5E,0x46,0x2E,0x36,0xCE,0x3B,
		0xE3,0x9E,0x77,0x2C,0x18,0x0E,0x86,0x03,0x9B,0x27,0x83,0xA2,
		0xEC,0x07,0xA2,0x8F,0xB5,0xC5,0x5D,0xF0,0x6F,0x4C,0x52,0xC9,
		0xDE,0x2B,0xCB,0xF6,0x95,0x58,0x17,0x18,0x39,0x95,0x49,0x7C,
		0xEA,0x95,0x6A,0xE5,0x15,0xD2,0x26,0x18,0x98,0xFA,0x05,0x10,
		0x15,0x72,0x8E,0x5A,0x8A,0xAC,0xAA,0x68,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "3072-bit MODP Group" from RFC3526, Section 4.

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x18,0x21,0x7C,0x32,0x90,0x5E,0x46,0x2E,0x36,0xCE,0x3B,
		0xE3,0x9E,0x77,0x2C,0x18,0x0E,0x86,0x03,0x9B,0x27,0x83,0xA2,
		0xEC,0x07,0xA2,0x8F,0xB5,0xC5,0x5D,0xF0,0x6F,0x4C,0x52,0xC9,
		0xDE,0x2B,0xCB,0xF6,0x95,0x58,0x17,0x18,0x39,0x95,0x49,0x7C,
		0xEA,0x95,0x6A,0xE5,0x15,0xD2,0x26,0x18,0x98,0xFA,0x05,0x10,
		0x15,0x72,0x8E,0x5A,0x8A,0xAA,0xC4,0x2D,0xAD,0x33,0x17,0x0D,
		0x04,0x50,0x7A,0x33,0xA8,0x55,0x21,0xAB,0xDF,0x1C,0xBA,0x64,
		0xEC,0xFB,0x85,0x04,0x58,0xDB,0xEF,0x0A,0x8A,0xEA,0x71,0x57,
		0x5D,0x06,0x0C,0x7D,0xB3,0x97,0x0F,0x85,0xA6,0xE1,0xE4,0xC7,
		0xAB,0xF5,0xAE,0x8C,0xDB,0x09,0x33,0xD7,0x1E,0x8C,0x94,0xE0,
		0x4A,0x25,0x61,0x9D,0xCE,0xE3,0xD2,0x26,0x1A,0xD2,0xEE,0x6B,
		0xF1,0x2F,0xFA,0x06,0xD9,0x8A,0x08,0x64,0xD8,0x76,0x02,0x73,
		0x3E,0xC8,0x6A,0x64,0x52,0x1F,0x2B,0x18,0x17,0x7B,0x20,0x0C,
		0xBB,0xE1,0x17,0x57,0x7A,0x61,0x5D,0x6C,0x77,0x09,0x88,0xC0,
		0xBA,0xD9,0x46,0xE2,0x08,0xE2,0x4F,0xA0,0x74,0xE5,0xAB,0x31,
		0x43,0xDB,0x5B,0xFC,0xE0,0xFD,0x10,0x8E,0x4B,0x82,0xD1,0x20,
		0xA9,0x3A,0xD2,0xCA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "4096-bit MODP Group" from RFC3526, Section 5.

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x18,0x21,0x7C,0x32,0x90,0x5E,0x46,0x2E,0x36,0xCE,0x3B,
		0xE3,0x9E,0x77,0x2C,0x18,0x0E,0x86,0x03,0x9B,0x27,0x83,0xA2,
		0xEC,0x07,0xA2,0x8F,0xB5,0xC5,0x5D,0xF0,0x6F,0x4C,0x52,0xC9,
		0xDE,0x2B,0xCB,0xF6,0x95,0x58,0x17,0x18,0x39,0x95,0x49,0x7C,
		0xEA,0x95,0x6A,0xE5,0x15,0xD2,0x26,0x18,0x98,0xFA,0x05,0x10,
		0x15,0x72,0x8E,0x5A,0x8A,0xAA,0xC4,0x2D,0xAD,0x33,0x17,0x0D,
		0x04,0x50,0x7A,0x33,0xA8,0x55,0x21,0xAB,0xDF,0x1C,0xBA,0x64,
		0xEC,0xFB,0x85,0x04,0x58,0xDB,0xEF,0x0A,0x8A,0xEA,0x71,0x57,
		0x5D,0x06,0x0C,0x7D,0xB3,0x97,0x0F,0x85,0xA6,0xE1,0xE4,0xC7,
		0xAB,0xF5,0xAE,0x8C,0xDB,0x09,0x33,0xD7,0x1E,0x8C,0x94,0xE0,
		0x4A,0x25,0x61,0x9D,0xCE,0xE3,0xD2,0x26,0x1A,0xD2,0xEE,0x6B,
		0xF1,0x2F,0xFA,0x06,0xD9,0x8A,0x08,0x64,0xD8,0x76,0x02,0x73,
		0x3E,0xC8,0x6A,0x64,0x52,0x1F,0x2B,0x18,0x17,0x7B,0x20,0x0C,
		0xBB,0xE1,0x17,0x57,0x7A,0x61,0x5D,0x6C,0x77,0x09,0x88,0xC0,
		0xBA,0xD9,0x46,0xE2,0x08,0xE2,0x4F,0xA0,0x74,0xE5,0xAB,0x31,
		0x43,0xDB,0x5B,0xFC,0xE0,0xFD,0x10,0x8E,0x4B,0x82,0xD1,0x20,
		0xA9,0x21,0x08,0x01,0x1A,0x72,0x3C,0x12,0xA7,0x87,0xE6,0xD7,
		0x88,0x71,0x9A,0x10,0xBD,0xBA,0x5B,0x26,0x99,0xC3,0x27,0x18,
		0x6A,0xF4,0xE2,0x3C,0x1A,0x94,0x68,0x34,0xB6,0x15,0x0B,0xDA,
		0x25,0x83,0xE9,0xCA,0x2A,0xD4,0x4C,0xE8,0xDB,0xBB,0xC2,0xDB,
		0x04,0xDE,0x8E,0xF9,0x2E,0x8E,0xFC,0x14,0x1F,0xBE,0xCA,0xA6,
		0x28,0x7C,0x59,0x47,0x4E,0x6B,0xC0,0x5D,0x99,0xB2,0x96,0x4F,
		0xA0,0x90,0xC3,0xA2,0x23,0x3B,0xA1,0x86,0x51,0x5B,0xE7,0xED,
		0x1F,0x61,0x29,0x70,0xCE,0xE2,0xD7,0xAF,0xB8,0x1B,0xDD,0x76,
		0x21,0x70,0x48,0x1C,0xD0,0x06,0x91,0x27,0xD5,0xB0,0x5A,0xA9,
		0x93,0xB4,0xEA,0x98,0x8D,0x8F,0xDD,0xC1,0x86,0xFF,0xB7,0xDC,
		0x90,0xA6,0xC0,0x8F,0x4D,0xF4,0x35,0xC9,0x34,0x06,0x31,0x99,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "6144-bit MODP Group" from RFC3526, Section 6

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x18,0x21,0x7C,0x32,0x90,0x5E,0x46,0x2E,0x36,0xCE,0x3B,
		0xE3,0x9E,0x77,0x2C,0x18,0x0E,0x86,0x03,0x9B,0x27,0x83,0xA2,
		0xEC,0x07,0xA2,0x8F,0xB5,0xC5,0x5D,0xF0,0x6F,0x4C,0x52,0xC9,
		0xDE,0x2B,0xCB,0xF6,0x95,0x58,0x17,0x18,0x39,0x95,0x49,0x7C,
		0xEA,0x95,0x6A,0xE5,0x15,0xD2,0x26,0x18,0x98,0xFA,0x05,0x10,
		0x15,0x72,0x8E,0x5A,0x8A,0xAA,0xC4,0x2D,0xAD,0x33,0x17,0x0D,
		0x04,0x50,0x7A,0x33,0xA8,0x55,0x21,0xAB,0xDF,0x1C,0xBA,0x64,
		0xEC,0xFB,0x85,0x04,0x58,0xDB,0xEF,0x0A,0x8A,0xEA,0x71,0x57,
		0x5D,0x06,0x0C,0x7D,0xB3,0x97,0x0F,0x85,0xA6,0xE1,0xE4,0xC7,
		0xAB,0xF5,0xAE,0x8C,0xDB,0x09,0x33,0xD7,0x1E,0x8C,0x94,0xE0,
		0x4A,0x25,0x61,0x9D,0xCE,0xE3,0xD2,0x26,0x1A,0xD2,0xEE,0x6B,
		0xF1,0x2F,0xFA,0x06,0xD9,0x8A,0x08,0x64,0xD8,0x76,0x02,0x73,
		0x3E,0xC8,0x6A,0x64,0x52,0x1F,0x2B,0x18,0x17,0x7B,0x20,0x0C,
		0xBB,0xE1,0x17,0x57,0x7A,0x61,0x5D,0x6C,0x77,0x09,0x88,0xC0,
		0xBA,0xD9,0x46,0xE2,0x08,0xE2,0x4F,0xA0,0x74,0xE5,0xAB,0x31,
		0x43,0xDB,0x5B,0xFC,0xE0,0xFD,0x10,0x8E,0x4B,0x82,0xD1,0x20,
		0xA9,0x21,0x08,0x01,0x1A,0x72,0x3C,0x12,0xA7,0x87,0xE6,0xD7,
		0x88,0x71,0x9A,0x10,0xBD,0xBA,0x5B,0x26,0x99,0xC3,0x27,0x18,
		0x6A,0xF4,0xE2,0x3C,0x1A,0x94,0x68,0x34,0xB6,0x15,0x0B,0xDA,
		0x25,0x83,0xE9,0xCA,0x2A,0xD4,0x4C,0xE8,0xDB,0xBB,0xC2,0xDB,
		0x04,0xDE,0x8E,0xF9,0x2E,0x8E,0xFC,0x14,0x1F,0xBE,0xCA,0xA6,
		0x28,0x7C,0x59,0x47,0x4E,0x6B,0xC0,0x5D,0x99,0xB2,0x96,0x4F,
		0xA0,0x90,0xC3,0xA2,0x23,0x3B,0xA1,0x86,0x51,0x5B,0xE7,0xED,
		0x1F,0x61,0x29,0x70,0xCE,0xE2,0xD7,0xAF,0xB8,0x1B,0xDD,0x76,
		0x21,0x70,0x48,0x1C,0xD0,0x06,0x91,0x27,0xD5,0xB0,0x5A,0xA9,
		0x93,0xB4,0xEA,0x98,0x8D,0x8F,0xDD,0xC1,0x86,0xFF,0xB7,0xDC,
		0x90,0xA6,0xC0,0x8F,0x4D,0xF4,0x35,0xC9,0x34,0x02,0x84,0x92,
		0x36,0xC3,0xFA,0xB4,0xD2,0x7C,0x70,0x26,0xC1,0xD4,0xDC,0xB2,
		0x60,0x26,0x46,0xDE,0xC9,0x75,0x1E,0x76,0x3D,0xBA,0x37,0xBD,
		0xF8,0xFF,0x94,0x06,0xAD,0x9E,0x53,0x0E,0xE5,0xDB,0x38,0x2F,
		0x41,0x30,0x01,0xAE,0xB0,0x6A,0x53,0xED,0x90,0x27,0xD8,0x31,
		0x17,0x97,0x27,0xB0,0x86,0x5A,0x89,0x18,0xDA,0x3E,0xDB,0xEB,
		0xCF,0x9B,0x14,0xED,0x44,0xCE,0x6C,0xBA,0xCE,0xD4,0xBB,0x1B,
		0xDB,0x7F,0x14,0x47,0xE6,0xCC,0x25,0x4B,0x33,0x20,0x51,0x51,
		0x2B,0xD7,0xAF,0x42,0x6F,0xB8,0xF4,0x01,0x37,0x8C,0xD2,0xBF,
		0x59,0x83,0xCA,0x01,0xC6,0x4B,0x92,0xEC,0xF0,0x32,0xEA,0x15,
		0xD1,0x72,0x1D,0x03,0xF4,0x82,0xD7,0xCE,0x6E,0x74,0xFE,0xF6,
		0xD5,0x5E,0x70,0x2F,0x46,0x98,0x0C,0x82,0xB5,0xA8,0x40,0x31,
		0x90,0x0B,0x1C,0x9E,0x59,0xE7,0xC9,0x7F,0xBE,0xC7,0xE8,0xF3,
		0x23,0xA9,0x7A,0x7E,0x36,0xCC,0x88,0xBE,0x0F,0x1D,0x45,0xB7,
		0xFF,0x58,0x5A,0xC5,0x4B,0xD4,0x07,0xB2,0x2B,0x41,0x54,0xAA,
		0xCC,0x8F,0x6D,0x7E,0xBF,0x48,0xE1,0xD8,0x14,0xCC,0x5E,0xD2,
		0x0F,0x80,0x37,0xE0,0xA7,0x97,0x15,0xEE,0xF2,0x9B,0xE3,0x28,
		0x06,0xA1,0xD5,0x8B,0xB7,0xC5,0xDA,0x76,0xF5,0x50,0xAA,0x3D,
		0x8A,0x1F,0xBF,0xF0,0xEB,0x19,0xCC,0xB1,0xA3,0x13,0xD5,0x5C,
		0xDA,0x56,0xC9,0xEC,0x2E,0xF2,0x96,0x32,0x38,0x7F,0xE8,0xD7,
		0x6E,0x3C,0x04,0x68,0x04,0x3E,0x8F,0x66,0x3F,0x48,0x60,0xEE,
		0x12,0xBF,0x2D,0x5B,0x0B,0x74,0x74,0xD6,0xE6,0x94,0xF9,0x1E,
		0x6D,0xCC,0x40,0x24,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    "8192-bit MODP Group" from RFC3526, Section 7.

TYPE
    8

DATA
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC9,0x0F,0xDA,0xA2,
		0x21,0x68,0xC2,0x34,0xC4,0xC6,0x62,0x8B,0x80,0xDC,0x1C,0xD1,
		0x29,0x02,0x4E,0x08,0x8A,0x67,0xCC,0x74,0x02,0x0B,0xBE,0xA6,
		0x3B,0x13,0x9B,0x22,0x51,0x4A,0x08,0x79,0x8E,0x34,0x04,0xDD,
		0xEF,0x95,0x19,0xB3,0xCD,0x3A,0x43,0x1B,0x30,0x2B,0x0A,0x6D,
		0xF2,0x5F,0x14,0x37,0x4F,0xE1,0x35,0x6D,0x6D,0x51,0xC2,0x45,
		0xE4,0x85,0xB5,0x76,0x62,0x5E,0x7E,0xC6,0xF4,0x4C,0x42,0xE9,
		0xA6,0x37,0xED,0x6B,0x0B,0xFF,0x5C,0xB6,0xF4,0x06,0xB7,0xED,
		0xEE,0x38,0x6B,0xFB,0x5A,0x89,0x9F,0xA5,0xAE,0x9F,0x24,0x11,
		0x7C,0x4B,0x1F,0xE6,0x49,0x28,0x66,0x51,0xEC,0xE4,0x5B,0x3D,
		0xC2,0x00,0x7C,0xB8,0xA1,0x63,0xBF,0x05,0x98,0xDA,0x48,0x36,
		0x1C,0x55,0xD3,0x9A,0x69,0x16,0x3F,0xA8,0xFD,0x24,0xCF,0x5F,
		0x83,0x65,0x5D,0x23,0xDC,0xA3,0xAD,0x96,0x1C,0x62,0xF3,0x56,
		0x20,0x85,0x52,0xBB,0x9E,0xD5,0x29,0x07,0x70,0x96,0x96,0x6D,
		0x67,0x0C,0x35,0x4E,0x4A,0xBC,0x98,0x04,0xF1,0x74,0x6C,0x08,
		0xCA,0x18,0x21,0x7C,0x32,0x90,0x5E,0x46,0x2E,0x36,0xCE,0x3B,
		0xE3,0x9E,0x77,0x2C,0x18,0x0E,0x86,0x03,0x9B,0x27,0x83,0xA2,
		0xEC,0x07,0xA2,0x8F,0xB5,0xC5,0x5D,0xF0,0x6F,0x4C,0x52,0xC9,
		0xDE,0x2B,0xCB,0xF6,0x95,0x58,0x17,0x18,0x39,0x95,0x49,0x7C,
		0xEA,0x95,0x6A,0xE5,0x15,0xD2,0x26,0x18,0x98,0xFA,0x05,0x10,
		0x15,0x72,0x8E,0x5A,0x8A,0xAA,0xC4,0x2D,0xAD,0x33,0x17,0x0D,
		0x04,0x50,0x7A,0x33,0xA8,0x55,0x21,0xAB,0xDF,0x1C,0xBA,0x64,
		0xEC,0xFB,0x85,0x04,0x58,0xDB,0xEF,0x0A,0x8A,0xEA,0x71,0x57,
		0x5D,0x06,0x0C,0x7D,0xB3,0x97,0x0F,0x85,0xA6,0xE1,0xE4,0xC7,
		0xAB,0xF5,0xAE,0x8C,0xDB,0x09,0x33,0xD7,0x1E,0x8C,0x94,0xE0,
		0x4A,0x25,0x61,0x9D,0xCE,0xE3,0xD2,0x26,0x1A,0xD2,0xEE,0x6B,
		0xF1,0x2F,0xFA,0x06,0xD9,0x8A,0x08,0x64,0xD8,0x76,0x02,0x73,
		0x3E,0xC8,0x6A,0x64,0x52,0x1F,0x2B,0x18,0x17,0x7B,0x20,0x0C,
		0xBB,0xE1,0x17,0x57,0x7A,0x61,0x5D,0x6C,0x77,0x09,0x88,0xC0,
		0xBA,0xD9,0x46,0xE2,0x08,0xE2,0x4F,0xA0,0x74,0xE5,0xAB,0x31,
		0x43,0xDB,0x5B,0xFC,0xE0,0xFD,0x10,0x8E,0x4B,0x82,0xD1,0x20,
		0xA9,0x21,0x08,0x01,0x1A,0x72,0x3C,0x12,0xA7,0x87,0xE6,0xD7,
		0x88,0x71,0x9A,0x10,0xBD,0xBA,0x5B,0x26,0x99,0xC3,0x27,0x18,
		0x6A,0xF4,0xE2,0x3C,0x1A,0x94,0x68,0x34,0xB6,0x15,0x0B,0xDA,
		0x25,0x83,0xE9,0xCA,0x2A,0xD4,0x4C,0xE8,0xDB,0xBB,0xC2,0xDB,
		0x04,0xDE,0x8E,0xF9,0x2E,0x8E,0xFC,0x14,0x1F,0xBE,0xCA,0xA6,
		0x28,0x7C,0x59,0x47,0x4E,0x6B,0xC0,0x5D,0x99,0xB2,0x96,0x4F,
		0xA0,0x90,0xC3,0xA2,0x23,0x3B,0xA1,0x86,0x51,0x5B,0xE7,0xED,
		0x1F,0x61,0x29,0x70,0xCE,0xE2,0xD7,0xAF,0xB8,0x1B,0xDD,0x76,
		0x21,0x70,0x48,0x1C,0xD0,0x06,0x91,0x27,0xD5,0xB0,0x5A,0xA9,
		0x93,0xB4,0xEA,0x98,0x8D,0x8F,0xDD,0xC1,0x86,0xFF,0xB7,0xDC,
		0x90,0xA6,0xC0,0x8F,0x4D,0xF4,0x35,0xC9,0x34,0x02,0x84,0x92,
		0x36,0xC3,0xFA,0xB4,0xD2,0x7C,0x70,0x26,0xC1,0xD4,0xDC,0xB2,
		0x60,0x26,0x46,0xDE,0xC9,0x75,0x1E,0x76,0x3D,0xBA,0x37,0xBD,
		0xF8,0xFF,0x94,0x06,0xAD,0x9E,0x53,0x0E,0xE5,0xDB,0x38,0x2F,
		0x41,0x30,0x01,0xAE,0xB0,0x6A,0x53,0xED,0x90,0x27,0xD8,0x31,
		0x17,0x97,0x27,0xB0,0x86,0x5A,0x89,0x18,0xDA,0x3E,0xDB,0xEB,
		0xCF,0x9B,0x14,0xED,0x44,0xCE,0x6C,0xBA,0xCE,0xD4,0xBB,0x1B,
		0xDB,0x7F,0x14,0x47,0xE6,0xCC,0x25,0x4B,0x33,0x20,0x51,0x51,
		0x2B,0xD7,0xAF,0x42,0x6F,0xB8,0xF4,0x01,0x37,0x8C,0xD2,0xBF,
		0x59,0x83,0xCA,0x01,0xC6,0x4B,0x92,0xEC,0xF0,0x32,0xEA,0x15,
		0xD1,0x72,0x1D,0x03,0xF4,0x82,0xD7,0xCE,0x6E,0x74,0xFE,0xF6,
		0xD5,0x5E,0x70,0x2F,0x46,0x98,0x0C,0x82,0xB5,0xA8,0x40,0x31,
		0x90,0x0B,0x1C,0x9E,0x59,0xE7,0xC9,0x7F,0xBE,0xC7,0xE8,0xF3,
		0x23,0xA9,0x7A,0x7E,0x36,0xCC,0x88,0xBE,0x0F,0x1D,0x45,0xB7,
		0xFF,0x58,0x5A,0xC5,0x4B,0xD4,0x07,0xB2,0x2B,0x41,0x54,0xAA,
		0xCC,0x8F,0x6D,0x7E,0xBF,0x48,0xE1,0xD8,0x14,0xCC,0x5E,0xD2,
		0x0F,0x80,0x37,0xE0,0xA7,0x97,0x15,0xEE,0xF2,0x9B,0xE3,0x28,
		0x06,0xA1,0xD5,0x8B,0xB7,0xC5,0xDA,0x76,0xF5,0x50,0xAA,0x3D,
		0x8A,0x1F,0xBF,0xF0,0xEB,0x19,0xCC,0xB1,0xA3,0x13,0xD5,0x5C,
		0xDA,0x56,0xC9,0xEC,0x2E,0xF2,0x96,0x32,0x38,0x7F,0xE8,0xD7,
		0x6E,0x3C,0x04,0x68,0x04,0x3E,0x8F,0x66,0x3F,0x48,0x60,0xEE,
		0x12,0xBF,0x2D,0x5B,0x0B,0x74,0x74,0xD6,0xE6,0x94,0xF9,0x1E,
		0x6D,0xBE,0x11,0x59,0x74,0xA3,0x92,0x6F,0x12,0xFE,0xE5,0xE4,
		0x38,0x77,0x7C,0xB6,0xA9,0x32,0xDF,0x8C,0xD8,0xBE,0xC4,0xD0,
		0x73,0xB9,0x31,0xBA,0x3B,0xC8,0x32,0xB6,0x8D,0x9D,0xD3,0x00,
		0x74,0x1F,0xA7,0xBF,0x8A,0xFC,0x47,0xED,0x25,0x76,0xF6,0x93,
		0x6B,0xA4,0x24,0x66,0x3A,0xAB,0x63,0x9C,0x5A,0xE4,0xF5,0x68,
		0x34,0x23,0xB4,0x74,0x2B,0xF1,0xC9,0x78,0x23,0x8F,0x16,0xCB,
		0xE3,0x9D,0x65,0x2D,0xE3,0xFD,0xB8,0xBE,0xFC,0x84,0x8A,0xD9,
		0x22,0x22,0x2E,0x04,0xA4,0x03,0x7C,0x07,0x13,0xEB,0x57,0xA8,
		0x1A,0x23,0xF0,0xC7,0x34,0x73,0xFC,0x64,0x6C,0xEA,0x30,0x6B,
		0x4B,0xCB,0xC8,0x86,0x2F,0x83,0x85,0xDD,0xFA,0x9D,0x4B,0x7F,
		0xA2,0xC0,0x87,0xE8,0x79,0x68,0x33,0x03,0xED,0x5B,0xDD,0x3A,
		0x06,0x2B,0x3C,0xF5,0xB3,0xA2,0x78,0xA6,0x6D,0x2A,0x13,0xF8,
		0x3F,0x44,0xF8,0x2D,0xDF,0x31,0x0E,0xE0,0x74,0xAB,0x6A,0x36,
		0x45,0x97,0xE8,0x99,0xA0,0x25,0x5D,0xC1,0x64,0xF3,0x1C,0xC5,
		0x08,0x46,0x85,0x1D,0xF9,0xAB,0x48,0x19,0x5D,0xED,0x7E,0xA1,
		0xB1,0xD5,0x10,0xBD,0x7E,0xE7,0x4D,0x73,0xFA,0xF3,0x6B,0xC3,
		0x1E,0xCF,0xA2,0x68,0x35,0x90,0x46,0xF4,0xEB,0x87,0x9F,0x92,
		0x40,0x09,0x43,0x8B,0x48,0x1C,0x6C,0xD7,0x88,0x9A,0x00,0x2E,
		0xD5,0xEE,0x38,0x2B,0xC9,0x19,0x0D,0xA6,0xFC,0x02,0x6E,0x47,
		0x95,0x58,0xE4,0x47,0x56,0x77,0xE9,0xAA,0x9E,0x30,0x50,0xE2,
		0x76,0x56,0x94,0xDF,0xC8,0x1F,0x56,0xE8,0x80,0xB9,0x6E,0x71,
		0x60,0xC9,0x80,0xDD,0x98,0xED,0xD3,0xDF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    camellia

TYPE
    32 AND

DATA
    0xA09E667FL 0x3BCC908BL 0xB67AE858L 0x4CAA73B2L
    0xC6EF372FL 0xE94F82BEL 0x54FF53A5L 0xF1D36F1CL
    0x10E527FAL 0xDE682D1DL 0xB05688C2L 0xB3E6C1FDL

################################################################################

TITLE
    camellia_sp1110

TYPE
    32

DATA
	0x70707000,0x82828200,0x2c2c2c00,0xececec00,
	0xb3b3b300,0x27272700,0xc0c0c000,0xe5e5e500,
	0xe4e4e400,0x85858500,0x57575700,0x35353500,
	0xeaeaea00,0x0c0c0c00,0xaeaeae00,0x41414100,
	0x23232300,0xefefef00,0x6b6b6b00,0x93939300,
	0x45454500,0x19191900,0xa5a5a500,0x21212100,
	0xededed00,0x0e0e0e00,0x4f4f4f00,0x4e4e4e00,
	0x1d1d1d00,0x65656500,0x92929200,0xbdbdbd00,
	0x86868600,0xb8b8b800,0xafafaf00,0x8f8f8f00,
	0x7c7c7c00,0xebebeb00,0x1f1f1f00,0xcecece00,
	0x3e3e3e00,0x30303000,0xdcdcdc00,0x5f5f5f00,
	0x5e5e5e00,0xc5c5c500,0x0b0b0b00,0x1a1a1a00,
	0xa6a6a600,0xe1e1e100,0x39393900,0xcacaca00,
	0xd5d5d500,0x47474700,0x5d5d5d00,0x3d3d3d00,
	0xd9d9d900,0x01010100,0x5a5a5a00,0xd6d6d600,
	0x51515100,0x56565600,0x6c6c6c00,0x4d4d4d00,
	0x8b8b8b00,0x0d0d0d00,0x9a9a9a00,0x66666600,
	0xfbfbfb00,0xcccccc00,0xb0b0b000,0x2d2d2d00,
	0x74747400,0x12121200,0x2b2b2b00,0x20202000,
	0xf0f0f000,0xb1b1b100,0x84848400,0x99999900,
	0xdfdfdf00,0x4c4c4c00,0xcbcbcb00,0xc2c2c200,
	0x34343400,0x7e7e7e00,0x76767600,0x05050500,
	0x6d6d6d00,0xb7b7b700,0xa9a9a900,0x31313100,
	0xd1d1d100,0x17171700,0x04040400,0xd7d7d700,
	0x14141400,0x58585800,0x3a3a3a00,0x61616100,
	0xdedede00,0x1b1b1b00,0x11111100,0x1c1c1c00,
	0x32323200,0x0f0f0f00,0x9c9c9c00,0x16161600,
	0x53535300,0x18181800,0xf2f2f200,0x22222200,
	0xfefefe00,0x44444400,0xcfcfcf00,0xb2b2b200,
	0xc3c3c300,0xb5b5b500,0x7a7a7a00,0x91919100,
	0x24242400,0x08080800,0xe8e8e800,0xa8a8a800,
	0x60606000,0xfcfcfc00,0x69696900,0x50505000,
	0xaaaaaa00,0xd0d0d000,0xa0a0a000,0x7d7d7d00,
	0xa1a1a100,0x89898900,0x62626200,0x97979700,
	0x54545400,0x5b5b5b00,0x1e1e1e00,0x95959500,
	0xe0e0e000,0xffffff00,0x64646400,0xd2d2d200,
	0x10101000,0xc4c4c400,0x00000000,0x48484800,
	0xa3a3a300,0xf7f7f700,0x75757500,0xdbdbdb00,
	0x8a8a8a00,0x03030300,0xe6e6e600,0xdadada00,
	0x09090900,0x3f3f3f00,0xdddddd00,0x94949400,
	0x87878700,0x5c5c5c00,0x83838300,0x02020200,
	0xcdcdcd00,0x4a4a4a00,0x90909000,0x33333300,
	0x73737300,0x67676700,0xf6f6f600,0xf3f3f300,
	0x9d9d9d00,0x7f7f7f00,0xbfbfbf00,0xe2e2e200,
	0x52525200,0x9b9b9b00,0xd8d8d800,0x26262600,
	0xc8c8c800,0x37373700,0xc6c6c600,0x3b3b3b00,
	0x81818100,0x96969600,0x6f6f6f00,0x4b4b4b00,
	0x13131300,0xbebebe00,0x63636300,0x2e2e2e00,
	0xe9e9e900,0x79797900,0xa7a7a700,0x8c8c8c00,
	0x9f9f9f00,0x6e6e6e00,0xbcbcbc00,0x8e8e8e00,
	0x29292900,0xf5f5f500,0xf9f9f900,0xb6b6b600,
	0x2f2f2f00,0xfdfdfd00,0xb4b4b400,0x59595900,
	0x78787800,0x98989800,0x06060600,0x6a6a6a00,
	0xe7e7e700,0x46464600,0x71717100,0xbababa00,
	0xd4d4d400,0x25252500,0xababab00,0x42424200,
	0x88888800,0xa2a2a200,0x8d8d8d00,0xfafafa00,
	0x72727200,0x07070700,0xb9b9b900,0x55555500,
	0xf8f8f800,0xeeeeee00,0xacacac00,0x0a0a0a00,
	0x36363600,0x49494900,0x2a2a2a00,0x68686800,
	0x3c3c3c00,0x38383800,0xf1f1f100,0xa4a4a400,
	0x40404000,0x28282800,0xd3d3d300,0x7b7b7b00,
	0xbbbbbb00,0xc9c9c900,0x43434300,0xc1c1c100,
	0x15151500,0xe3e3e300,0xadadad00,0xf4f4f400,
	0x77777700,0xc7c7c700,0x80808000,0x9e9e9e00,

################################################################################

TITLE
    camellia_sp0222

TYPE
    32

DATA
	0x00e0e0e0,0x00050505,0x00585858,0x00d9d9d9,
	0x00676767,0x004e4e4e,0x00818181,0x00cbcbcb,
	0x00c9c9c9,0x000b0b0b,0x00aeaeae,0x006a6a6a,
	0x00d5d5d5,0x00181818,0x005d5d5d,0x00828282,
	0x00464646,0x00dfdfdf,0x00d6d6d6,0x00272727,
	0x008a8a8a,0x00323232,0x004b4b4b,0x00424242,
	0x00dbdbdb,0x001c1c1c,0x009e9e9e,0x009c9c9c,
	0x003a3a3a,0x00cacaca,0x00252525,0x007b7b7b,
	0x000d0d0d,0x00717171,0x005f5f5f,0x001f1f1f,
	0x00f8f8f8,0x00d7d7d7,0x003e3e3e,0x009d9d9d,
	0x007c7c7c,0x00606060,0x00b9b9b9,0x00bebebe,
	0x00bcbcbc,0x008b8b8b,0x00161616,0x00343434,
	0x004d4d4d,0x00c3c3c3,0x00727272,0x00959595,
	0x00ababab,0x008e8e8e,0x00bababa,0x007a7a7a,
	0x00b3b3b3,0x00020202,0x00b4b4b4,0x00adadad,
	0x00a2a2a2,0x00acacac,0x00d8d8d8,0x009a9a9a,
	0x00171717,0x001a1a1a,0x00353535,0x00cccccc,
	0x00f7f7f7,0x00999999,0x00616161,0x005a5a5a,
	0x00e8e8e8,0x00242424,0x00565656,0x00404040,
	0x00e1e1e1,0x00636363,0x00090909,0x00333333,
	0x00bfbfbf,0x00989898,0x00979797,0x00858585,
	0x00686868,0x00fcfcfc,0x00ececec,0x000a0a0a,
	0x00dadada,0x006f6f6f,0x00535353,0x00626262,
	0x00a3a3a3,0x002e2e2e,0x00080808,0x00afafaf,
	0x00282828,0x00b0b0b0,0x00747474,0x00c2c2c2,
	0x00bdbdbd,0x00363636,0x00222222,0x00383838,
	0x00646464,0x001e1e1e,0x00393939,0x002c2c2c,
	0x00a6a6a6,0x00303030,0x00e5e5e5,0x00444444,
	0x00fdfdfd,0x00888888,0x009f9f9f,0x00656565,
	0x00878787,0x006b6b6b,0x00f4f4f4,0x00232323,
	0x00484848,0x00101010,0x00d1d1d1,0x00515151,
	0x00c0c0c0,0x00f9f9f9,0x00d2d2d2,0x00a0a0a0,
	0x00555555,0x00a1a1a1,0x00414141,0x00fafafa,
	0x00434343,0x00131313,0x00c4c4c4,0x002f2f2f,
	0x00a8a8a8,0x00b6b6b6,0x003c3c3c,0x002b2b2b,
	0x00c1c1c1,0x00ffffff,0x00c8c8c8,0x00a5a5a5,
	0x00202020,0x00898989,0x00000000,0x00909090,
	0x00474747,0x00efefef,0x00eaeaea,0x00b7b7b7,
	0x00151515,0x00060606,0x00cdcdcd,0x00b5b5b5,
	0x00121212,0x007e7e7e,0x00bbbbbb,0x00292929,
	0x000f0f0f,0x00b8b8b8,0x00070707,0x00040404,
	0x009b9b9b,0x00949494,0x00212121,0x00666666,
	0x00e6e6e6,0x00cecece,0x00ededed,0x00e7e7e7,
	0x003b3b3b,0x00fefefe,0x007f7f7f,0x00c5c5c5,
	0x00a4a4a4,0x00373737,0x00b1b1b1,0x004c4c4c,
	0x00919191,0x006e6e6e,0x008d8d8d,0x00767676,
	0x00030303,0x002d2d2d,0x00dedede,0x00969696,
	0x00262626,0x007d7d7d,0x00c6c6c6,0x005c5c5c,
	0x00d3d3d3,0x00f2f2f2,0x004f4f4f,0x00191919,
	0x003f3f3f,0x00dcdcdc,0x00797979,0x001d1d1d,
	0x00525252,0x00ebebeb,0x00f3f3f3,0x006d6d6d,
	0x005e5e5e,0x00fbfbfb,0x00696969,0x00b2b2b2,
	0x00f0f0f0,0x00313131,0x000c0c0c,0x00d4d4d4,
	0x00cfcfcf,0x008c8c8c,0x00e2e2e2,0x00757575,
	0x00a9a9a9,0x004a4a4a,0x00575757,0x00848484,
	0x00111111,0x00454545,0x001b1b1b,0x00f5f5f5,
	0x00e4e4e4,0x000e0e0e,0x00737373,0x00aaaaaa,
	0x00f1f1f1,0x00dddddd,0x00595959,0x00141414,
	0x006c6c6c,0x00929292,0x00545454,0x00d0d0d0,
	0x00787878,0x00707070,0x00e3e3e3,0x00494949,
	0x00808080,0x00505050,0x00a7a7a7,0x00f6f6f6,
	0x00777777,0x00939393,0x00868686,0x00838383,
	0x002a2a2a,0x00c7c7c7,0x005b5b5b,0x00e9e9e9,
	0x00eeeeee,0x008f8f8f,0x00010101,0x003d3d3d,

################################################################################

TITLE
    camellia_sp3033

TYPE
    32

DATA
	0x38003838,0x41004141,0x16001616,0x76007676,
	0xd900d9d9,0x93009393,0x60006060,0xf200f2f2,
	0x72007272,0xc200c2c2,0xab00abab,0x9a009a9a,
	0x75007575,0x06000606,0x57005757,0xa000a0a0,
	0x91009191,0xf700f7f7,0xb500b5b5,0xc900c9c9,
	0xa200a2a2,0x8c008c8c,0xd200d2d2,0x90009090,
	0xf600f6f6,0x07000707,0xa700a7a7,0x27002727,
	0x8e008e8e,0xb200b2b2,0x49004949,0xde00dede,
	0x43004343,0x5c005c5c,0xd700d7d7,0xc700c7c7,
	0x3e003e3e,0xf500f5f5,0x8f008f8f,0x67006767,
	0x1f001f1f,0x18001818,0x6e006e6e,0xaf00afaf,
	0x2f002f2f,0xe200e2e2,0x85008585,0x0d000d0d,
	0x53005353,0xf000f0f0,0x9c009c9c,0x65006565,
	0xea00eaea,0xa300a3a3,0xae00aeae,0x9e009e9e,
	0xec00ecec,0x80008080,0x2d002d2d,0x6b006b6b,
	0xa800a8a8,0x2b002b2b,0x36003636,0xa600a6a6,
	0xc500c5c5,0x86008686,0x4d004d4d,0x33003333,
	0xfd00fdfd,0x66006666,0x58005858,0x96009696,
	0x3a003a3a,0x09000909,0x95009595,0x10001010,
	0x78007878,0xd800d8d8,0x42004242,0xcc00cccc,
	0xef00efef,0x26002626,0xe500e5e5,0x61006161,
	0x1a001a1a,0x3f003f3f,0x3b003b3b,0x82008282,
	0xb600b6b6,0xdb00dbdb,0xd400d4d4,0x98009898,
	0xe800e8e8,0x8b008b8b,0x02000202,0xeb00ebeb,
	0x0a000a0a,0x2c002c2c,0x1d001d1d,0xb000b0b0,
	0x6f006f6f,0x8d008d8d,0x88008888,0x0e000e0e,
	0x19001919,0x87008787,0x4e004e4e,0x0b000b0b,
	0xa900a9a9,0x0c000c0c,0x79007979,0x11001111,
	0x7f007f7f,0x22002222,0xe700e7e7,0x59005959,
	0xe100e1e1,0xda00dada,0x3d003d3d,0xc800c8c8,
	0x12001212,0x04000404,0x74007474,0x54005454,
	0x30003030,0x7e007e7e,0xb400b4b4,0x28002828,
	0x55005555,0x68006868,0x50005050,0xbe00bebe,
	0xd000d0d0,0xc400c4c4,0x31003131,0xcb00cbcb,
	0x2a002a2a,0xad00adad,0x0f000f0f,0xca00caca,
	0x70007070,0xff00ffff,0x32003232,0x69006969,
	0x08000808,0x62006262,0x00000000,0x24002424,
	0xd100d1d1,0xfb00fbfb,0xba00baba,0xed00eded,
	0x45004545,0x81008181,0x73007373,0x6d006d6d,
	0x84008484,0x9f009f9f,0xee00eeee,0x4a004a4a,
	0xc300c3c3,0x2e002e2e,0xc100c1c1,0x01000101,
	0xe600e6e6,0x25002525,0x48004848,0x99009999,
	0xb900b9b9,0xb300b3b3,0x7b007b7b,0xf900f9f9,
	0xce00cece,0xbf00bfbf,0xdf00dfdf,0x71007171,
	0x29002929,0xcd00cdcd,0x6c006c6c,0x13001313,
	0x64006464,0x9b009b9b,0x63006363,0x9d009d9d,
	0xc000c0c0,0x4b004b4b,0xb700b7b7,0xa500a5a5,
	0x89008989,0x5f005f5f,0xb100b1b1,0x17001717,
	0xf400f4f4,0xbc00bcbc,0xd300d3d3,0x46004646,
	0xcf00cfcf,0x37003737,0x5e005e5e,0x47004747,
	0x94009494,0xfa00fafa,0xfc00fcfc,0x5b005b5b,
	0x97009797,0xfe00fefe,0x5a005a5a,0xac00acac,
	0x3c003c3c,0x4c004c4c,0x03000303,0x35003535,
	0xf300f3f3,0x23002323,0xb800b8b8,0x5d005d5d,
	0x6a006a6a,0x92009292,0xd500d5d5,0x21002121,
	0x44004444,0x51005151,0xc600c6c6,0x7d007d7d,
	0x39003939,0x83008383,0xdc00dcdc,0xaa00aaaa,
	0x7c007c7c,0x77007777,0x56005656,0x05000505,
	0x1b001b1b,0xa400a4a4,0x15001515,0x34003434,
	0x1e001e1e,0x1c001c1c,0xf800f8f8,0x52005252,
	0x20002020,0x14001414,0xe900e9e9,0xbd00bdbd,
	0xdd00dddd,0xe400e4e4,0xa100a1a1,0xe000e0e0,
	0x8a008a8a,0xf100f1f1,0xd600d6d6,0x7a007a7a,
	0xbb00bbbb,0xe300e3e3,0x40004040,0x4f004f4f,

################################################################################

TITLE
    camellia_sp4404

TYPE
    32

DATA
	0x70700070,0x2c2c002c,0xb3b300b3,0xc0c000c0,
	0xe4e400e4,0x57570057,0xeaea00ea,0xaeae00ae,
	0x23230023,0x6b6b006b,0x45450045,0xa5a500a5,
	0xeded00ed,0x4f4f004f,0x1d1d001d,0x92920092,
	0x86860086,0xafaf00af,0x7c7c007c,0x1f1f001f,
	0x3e3e003e,0xdcdc00dc,0x5e5e005e,0x0b0b000b,
	0xa6a600a6,0x39390039,0xd5d500d5,0x5d5d005d,
	0xd9d900d9,0x5a5a005a,0x51510051,0x6c6c006c,
	0x8b8b008b,0x9a9a009a,0xfbfb00fb,0xb0b000b0,
	0x74740074,0x2b2b002b,0xf0f000f0,0x84840084,
	0xdfdf00df,0xcbcb00cb,0x34340034,0x76760076,
	0x6d6d006d,0xa9a900a9,0xd1d100d1,0x04040004,
	0x14140014,0x3a3a003a,0xdede00de,0x11110011,
	0x32320032,0x9c9c009c,0x53530053,0xf2f200f2,
	0xfefe00fe,0xcfcf00cf,0xc3c300c3,0x7a7a007a,
	0x24240024,0xe8e800e8,0x60600060,0x69690069,
	0xaaaa00aa,0xa0a000a0,0xa1a100a1,0x62620062,
	0x54540054,0x1e1e001e,0xe0e000e0,0x64640064,
	0x10100010,0x00000000,0xa3a300a3,0x75750075,
	0x8a8a008a,0xe6e600e6,0x09090009,0xdddd00dd,
	0x87870087,0x83830083,0xcdcd00cd,0x90900090,
	0x73730073,0xf6f600f6,0x9d9d009d,0xbfbf00bf,
	0x52520052,0xd8d800d8,0xc8c800c8,0xc6c600c6,
	0x81810081,0x6f6f006f,0x13130013,0x63630063,
	0xe9e900e9,0xa7a700a7,0x9f9f009f,0xbcbc00bc,
	0x29290029,0xf9f900f9,0x2f2f002f,0xb4b400b4,
	0x78780078,0x06060006,0xe7e700e7,0x71710071,
	0xd4d400d4,0xabab00ab,0x88880088,0x8d8d008d,
	0x72720072,0xb9b900b9,0xf8f800f8,0xacac00ac,
	0x36360036,0x2a2a002a,0x3c3c003c,0xf1f100f1,
	0x40400040,0xd3d300d3,0xbbbb00bb,0x43430043,
	0x15150015,0xadad00ad,0x77770077,0x80800080,
	0x82820082,0xecec00ec,0x27270027,0xe5e500e5,
	0x85850085,0x35350035,0x0c0c000c,0x41410041,
	0xefef00ef,0x93930093,0x19190019,0x21210021,
	0x0e0e000e,0x4e4e004e,0x65650065,0xbdbd00bd,
	0xb8b800b8,0x8f8f008f,0xebeb00eb,0xcece00ce,
	0x30300030,0x5f5f005f,0xc5c500c5,0x1a1a001a,
	0xe1e100e1,0xcaca00ca,0x47470047,0x3d3d003d,
	0x01010001,0xd6d600d6,0x56560056,0x4d4d004d,
	0x0d0d000d,0x66660066,0xcccc00cc,0x2d2d002d,
	0x12120012,0x20200020,0xb1b100b1,0x99990099,
	0x4c4c004c,0xc2c200c2,0x7e7e007e,0x05050005,
	0xb7b700b7,0x31310031,0x17170017,0xd7d700d7,
	0x58580058,0x61610061,0x1b1b001b,0x1c1c001c,
	0x0f0f000f,0x16160016,0x18180018,0x22220022,
	0x44440044,0xb2b200b2,0xb5b500b5,0x91910091,
	0x08080008,0xa8a800a8,0xfcfc00fc,0x50500050,
	0xd0d000d0,0x7d7d007d,0x89890089,0x97970097,
	0x5b5b005b,0x95950095,0xffff00ff,0xd2d200d2,
	0xc4c400c4,0x48480048,0xf7f700f7,0xdbdb00db,
	0x03030003,0xdada00da,0x3f3f003f,0x94940094,
	0x5c5c005c,0x02020002,0x4a4a004a,0x33330033,
	0x67670067,0xf3f300f3,0x7f7f007f,0xe2e200e2,
	0x9b9b009b,0x26260026,0x37370037,0x3b3b003b,
	0x96960096,0x4b4b004b,0xbebe00be,0x2e2e002e,
	0x79790079,0x8c8c008c,0x6e6e006e,0x8e8e008e,
	0xf5f500f5,0xb6b600b6,0xfdfd00fd,0x59590059,
	0x98980098,0x6a6a006a,0x46460046,0xbaba00ba,
	0x25250025,0x42420042,0xa2a200a2,0xfafa00fa,
	0x07070007,0x55550055,0xeeee00ee,0x0a0a000a,
	0x49490049,0x68680068,0x38380038,0xa4a400a4,
	0x28280028,0x7b7b007b,0xc9c900c9,0xc1c100c1,
	0xe3e300e3,0xf4f400f4,0xc7c700c7,0x9e9e009e,

################################################################################

TITLE
    Fcrypt DES con_salt

TYPE
    8

DATA
    0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,
    0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xE0,0xE1,
    0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,
    0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0xF0,0xF1,
    0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,
    0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0x00,0x01,
    0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,
    0x0A,0x0B,0x05,0x06,0x07,0x08,0x09,0x0A,
    0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,0x12,
    0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,
    0x1B,0x1C,0x1D,0x1E,0x1F,0x20,0x21,0x22,
    0x23,0x24,0x25,0x20,0x21,0x22,0x23,0x24,
    0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,
    0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33,0x34,
    0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
    0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,

################################################################################

TITLE
    DES

TYPE
    32 AND

DATA
    0x0f0f0f0fL 0x0000ffffL 0x33333333L 0x00ff00ffL 0x55555555L

################################################################################

TITLE
    DES odd_parity

TYPE
    8

DATA
  1,  1,  2,  2,  4,  4,  7,  7,  8,  8, 11, 11, 13, 13, 14, 14,
 16, 16, 19, 19, 21, 21, 22, 22, 25, 25, 26, 26, 28, 28, 31, 31,
 32, 32, 35, 35, 37, 37, 38, 38, 41, 41, 42, 42, 44, 44, 47, 47,
 49, 49, 50, 50, 52, 52, 55, 55, 56, 56, 59, 59, 61, 61, 62, 62,
 64, 64, 67, 67, 69, 69, 70, 70, 73, 73, 74, 74, 76, 76, 79, 79,
 81, 81, 82, 82, 84, 84, 87, 87, 88, 88, 91, 91, 93, 93, 94, 94,
 97, 97, 98, 98,100,100,103,103,104,104,107,107,109,109,110,110,
112,112,115,115,117,117,118,118,121,121,122,122,124,124,127,127,
128,128,131,131,133,133,134,134,137,137,138,138,140,140,143,143,
145,145,146,146,148,148,151,151,152,152,155,155,157,157,158,158,
161,161,162,162,164,164,167,167,168,168,171,171,173,173,174,174,
176,176,179,179,181,181,182,182,185,185,186,186,188,188,191,191,
193,193,194,194,196,196,199,199,200,200,203,203,205,205,206,206,
208,208,211,211,213,213,214,214,217,217,218,218,220,220,223,223,
224,224,227,227,229,229,230,230,233,233,234,234,236,236,239,239,
241,241,242,242,244,244,247,247,248,248,251,251,253,253,254,254

################################################################################

TITLE
    DES semi weak keys

TYPE
    8

DATA
	{0x01,0xFE,0x01,0xFE,0x01,0xFE,0x01,0xFE},
	{0xFE,0x01,0xFE,0x01,0xFE,0x01,0xFE,0x01},
	{0x1F,0xE0,0x1F,0xE0,0x0E,0xF1,0x0E,0xF1},
	{0xE0,0x1F,0xE0,0x1F,0xF1,0x0E,0xF1,0x0E},
	{0x01,0xE0,0x01,0xE0,0x01,0xF1,0x01,0xF1},
	{0xE0,0x01,0xE0,0x01,0xF1,0x01,0xF1,0x01},
	{0x1F,0xFE,0x1F,0xFE,0x0E,0xFE,0x0E,0xFE},
	{0xFE,0x1F,0xFE,0x1F,0xFE,0x0E,0xFE,0x0E},
	{0x01,0x1F,0x01,0x1F,0x01,0x0E,0x01,0x0E},
	{0x1F,0x01,0x1F,0x01,0x0E,0x01,0x0E,0x01},
	{0xE0,0xFE,0xE0,0xFE,0xF1,0xFE,0xF1,0xFE},
	{0xFE,0xE0,0xFE,0xE0,0xFE,0xF1,0xFE,0xF1}};

################################################################################

TITLE
    DES skb

TYPE
    32

DATA
	/* for C bits (numbered as per FIPS 46) 1 2 3 4 5 6 */
	0x00000000L,0x00000010L,0x20000000L,0x20000010L,
	0x00010000L,0x00010010L,0x20010000L,0x20010010L,
	0x00000800L,0x00000810L,0x20000800L,0x20000810L,
	0x00010800L,0x00010810L,0x20010800L,0x20010810L,
	0x00000020L,0x00000030L,0x20000020L,0x20000030L,
	0x00010020L,0x00010030L,0x20010020L,0x20010030L,
	0x00000820L,0x00000830L,0x20000820L,0x20000830L,
	0x00010820L,0x00010830L,0x20010820L,0x20010830L,
	0x00080000L,0x00080010L,0x20080000L,0x20080010L,
	0x00090000L,0x00090010L,0x20090000L,0x20090010L,
	0x00080800L,0x00080810L,0x20080800L,0x20080810L,
	0x00090800L,0x00090810L,0x20090800L,0x20090810L,
	0x00080020L,0x00080030L,0x20080020L,0x20080030L,
	0x00090020L,0x00090030L,0x20090020L,0x20090030L,
	0x00080820L,0x00080830L,0x20080820L,0x20080830L,
	0x00090820L,0x00090830L,0x20090820L,0x20090830L,
	},{
	/* for C bits (numbered as per FIPS 46) 7 8 10 11 12 13 */
	0x00000000L,0x02000000L,0x00002000L,0x02002000L,
	0x00200000L,0x02200000L,0x00202000L,0x02202000L,
	0x00000004L,0x02000004L,0x00002004L,0x02002004L,
	0x00200004L,0x02200004L,0x00202004L,0x02202004L,
	0x00000400L,0x02000400L,0x00002400L,0x02002400L,
	0x00200400L,0x02200400L,0x00202400L,0x02202400L,
	0x00000404L,0x02000404L,0x00002404L,0x02002404L,
	0x00200404L,0x02200404L,0x00202404L,0x02202404L,
	0x10000000L,0x12000000L,0x10002000L,0x12002000L,
	0x10200000L,0x12200000L,0x10202000L,0x12202000L,
	0x10000004L,0x12000004L,0x10002004L,0x12002004L,
	0x10200004L,0x12200004L,0x10202004L,0x12202004L,
	0x10000400L,0x12000400L,0x10002400L,0x12002400L,
	0x10200400L,0x12200400L,0x10202400L,0x12202400L,
	0x10000404L,0x12000404L,0x10002404L,0x12002404L,
	0x10200404L,0x12200404L,0x10202404L,0x12202404L,
	},{
	/* for C bits (numbered as per FIPS 46) 14 15 16 17 19 20 */
	0x00000000L,0x00000001L,0x00040000L,0x00040001L,
	0x01000000L,0x01000001L,0x01040000L,0x01040001L,
	0x00000002L,0x00000003L,0x00040002L,0x00040003L,
	0x01000002L,0x01000003L,0x01040002L,0x01040003L,
	0x00000200L,0x00000201L,0x00040200L,0x00040201L,
	0x01000200L,0x01000201L,0x01040200L,0x01040201L,
	0x00000202L,0x00000203L,0x00040202L,0x00040203L,
	0x01000202L,0x01000203L,0x01040202L,0x01040203L,
	0x08000000L,0x08000001L,0x08040000L,0x08040001L,
	0x09000000L,0x09000001L,0x09040000L,0x09040001L,
	0x08000002L,0x08000003L,0x08040002L,0x08040003L,
	0x09000002L,0x09000003L,0x09040002L,0x09040003L,
	0x08000200L,0x08000201L,0x08040200L,0x08040201L,
	0x09000200L,0x09000201L,0x09040200L,0x09040201L,
	0x08000202L,0x08000203L,0x08040202L,0x08040203L,
	0x09000202L,0x09000203L,0x09040202L,0x09040203L,
	},{
	/* for C bits (numbered as per FIPS 46) 21 23 24 26 27 28 */
	0x00000000L,0x00100000L,0x00000100L,0x00100100L,
	0x00000008L,0x00100008L,0x00000108L,0x00100108L,
	0x00001000L,0x00101000L,0x00001100L,0x00101100L,
	0x00001008L,0x00101008L,0x00001108L,0x00101108L,
	0x04000000L,0x04100000L,0x04000100L,0x04100100L,
	0x04000008L,0x04100008L,0x04000108L,0x04100108L,
	0x04001000L,0x04101000L,0x04001100L,0x04101100L,
	0x04001008L,0x04101008L,0x04001108L,0x04101108L,
	0x00020000L,0x00120000L,0x00020100L,0x00120100L,
	0x00020008L,0x00120008L,0x00020108L,0x00120108L,
	0x00021000L,0x00121000L,0x00021100L,0x00121100L,
	0x00021008L,0x00121008L,0x00021108L,0x00121108L,
	0x04020000L,0x04120000L,0x04020100L,0x04120100L,
	0x04020008L,0x04120008L,0x04020108L,0x04120108L,
	0x04021000L,0x04121000L,0x04021100L,0x04121100L,
	0x04021008L,0x04121008L,0x04021108L,0x04121108L,
	},{
	/* for D bits (numbered as per FIPS 46) 1 2 3 4 5 6 */
	0x00000000L,0x10000000L,0x00010000L,0x10010000L,
	0x00000004L,0x10000004L,0x00010004L,0x10010004L,
	0x20000000L,0x30000000L,0x20010000L,0x30010000L,
	0x20000004L,0x30000004L,0x20010004L,0x30010004L,
	0x00100000L,0x10100000L,0x00110000L,0x10110000L,
	0x00100004L,0x10100004L,0x00110004L,0x10110004L,
	0x20100000L,0x30100000L,0x20110000L,0x30110000L,
	0x20100004L,0x30100004L,0x20110004L,0x30110004L,
	0x00001000L,0x10001000L,0x00011000L,0x10011000L,
	0x00001004L,0x10001004L,0x00011004L,0x10011004L,
	0x20001000L,0x30001000L,0x20011000L,0x30011000L,
	0x20001004L,0x30001004L,0x20011004L,0x30011004L,
	0x00101000L,0x10101000L,0x00111000L,0x10111000L,
	0x00101004L,0x10101004L,0x00111004L,0x10111004L,
	0x20101000L,0x30101000L,0x20111000L,0x30111000L,
	0x20101004L,0x30101004L,0x20111004L,0x30111004L,
	},{
	/* for D bits (numbered as per FIPS 46) 8 9 11 12 13 14 */
	0x00000000L,0x08000000L,0x00000008L,0x08000008L,
	0x00000400L,0x08000400L,0x00000408L,0x08000408L,
	0x00020000L,0x08020000L,0x00020008L,0x08020008L,
	0x00020400L,0x08020400L,0x00020408L,0x08020408L,
	0x00000001L,0x08000001L,0x00000009L,0x08000009L,
	0x00000401L,0x08000401L,0x00000409L,0x08000409L,
	0x00020001L,0x08020001L,0x00020009L,0x08020009L,
	0x00020401L,0x08020401L,0x00020409L,0x08020409L,
	0x02000000L,0x0A000000L,0x02000008L,0x0A000008L,
	0x02000400L,0x0A000400L,0x02000408L,0x0A000408L,
	0x02020000L,0x0A020000L,0x02020008L,0x0A020008L,
	0x02020400L,0x0A020400L,0x02020408L,0x0A020408L,
	0x02000001L,0x0A000001L,0x02000009L,0x0A000009L,
	0x02000401L,0x0A000401L,0x02000409L,0x0A000409L,
	0x02020001L,0x0A020001L,0x02020009L,0x0A020009L,
	0x02020401L,0x0A020401L,0x02020409L,0x0A020409L,
	},{
	/* for D bits (numbered as per FIPS 46) 16 17 18 19 20 21 */
	0x00000000L,0x00000100L,0x00080000L,0x00080100L,
	0x01000000L,0x01000100L,0x01080000L,0x01080100L,
	0x00000010L,0x00000110L,0x00080010L,0x00080110L,
	0x01000010L,0x01000110L,0x01080010L,0x01080110L,
	0x00200000L,0x00200100L,0x00280000L,0x00280100L,
	0x01200000L,0x01200100L,0x01280000L,0x01280100L,
	0x00200010L,0x00200110L,0x00280010L,0x00280110L,
	0x01200010L,0x01200110L,0x01280010L,0x01280110L,
	0x00000200L,0x00000300L,0x00080200L,0x00080300L,
	0x01000200L,0x01000300L,0x01080200L,0x01080300L,
	0x00000210L,0x00000310L,0x00080210L,0x00080310L,
	0x01000210L,0x01000310L,0x01080210L,0x01080310L,
	0x00200200L,0x00200300L,0x00280200L,0x00280300L,
	0x01200200L,0x01200300L,0x01280200L,0x01280300L,
	0x00200210L,0x00200310L,0x00280210L,0x00280310L,
	0x01200210L,0x01200310L,0x01280210L,0x01280310L,
	},{
	/* for D bits (numbered as per FIPS 46) 22 23 24 25 27 28 */
	0x00000000L,0x04000000L,0x00040000L,0x04040000L,
	0x00000002L,0x04000002L,0x00040002L,0x04040002L,
	0x00002000L,0x04002000L,0x00042000L,0x04042000L,
	0x00002002L,0x04002002L,0x00042002L,0x04042002L,
	0x00000020L,0x04000020L,0x00040020L,0x04040020L,
	0x00000022L,0x04000022L,0x00040022L,0x04040022L,
	0x00002020L,0x04002020L,0x00042020L,0x04042020L,
	0x00002022L,0x04002022L,0x00042022L,0x04042022L,
	0x00000800L,0x04000800L,0x00040800L,0x04040800L,
	0x00000802L,0x04000802L,0x00040802L,0x04040802L,
	0x00002800L,0x04002800L,0x00042800L,0x04042800L,
	0x00002802L,0x04002802L,0x00042802L,0x04042802L,
	0x00000820L,0x04000820L,0x00040820L,0x04040820L,
	0x00000822L,0x04000822L,0x00040822L,0x04040822L,
	0x00002820L,0x04002820L,0x00042820L,0x04042820L,
	0x00002822L,0x04002822L,0x00042822L,0x04042822L,

################################################################################

TITLE
    DES SPR SPtrans

TYPE
    32

DATA
/* nibble 0 */
0x02080800L, 0x00080000L, 0x02000002L, 0x02080802L,
0x02000000L, 0x00080802L, 0x00080002L, 0x02000002L,
0x00080802L, 0x02080800L, 0x02080000L, 0x00000802L,
0x02000802L, 0x02000000L, 0x00000000L, 0x00080002L,
0x00080000L, 0x00000002L, 0x02000800L, 0x00080800L,
0x02080802L, 0x02080000L, 0x00000802L, 0x02000800L,
0x00000002L, 0x00000800L, 0x00080800L, 0x02080002L,
0x00000800L, 0x02000802L, 0x02080002L, 0x00000000L,
0x00000000L, 0x02080802L, 0x02000800L, 0x00080002L,
0x02080800L, 0x00080000L, 0x00000802L, 0x02000800L,
0x02080002L, 0x00000800L, 0x00080800L, 0x02000002L,
0x00080802L, 0x00000002L, 0x02000002L, 0x02080000L,
0x02080802L, 0x00080800L, 0x02080000L, 0x02000802L,
0x02000000L, 0x00000802L, 0x00080002L, 0x00000000L,
0x00080000L, 0x02000000L, 0x02000802L, 0x02080800L,
0x00000002L, 0x02080002L, 0x00000800L, 0x00080802L,
},{
/* nibble 1 */
0x40108010L, 0x00000000L, 0x00108000L, 0x40100000L,
0x40000010L, 0x00008010L, 0x40008000L, 0x00108000L,
0x00008000L, 0x40100010L, 0x00000010L, 0x40008000L,
0x00100010L, 0x40108000L, 0x40100000L, 0x00000010L,
0x00100000L, 0x40008010L, 0x40100010L, 0x00008000L,
0x00108010L, 0x40000000L, 0x00000000L, 0x00100010L,
0x40008010L, 0x00108010L, 0x40108000L, 0x40000010L,
0x40000000L, 0x00100000L, 0x00008010L, 0x40108010L,
0x00100010L, 0x40108000L, 0x40008000L, 0x00108010L,
0x40108010L, 0x00100010L, 0x40000010L, 0x00000000L,
0x40000000L, 0x00008010L, 0x00100000L, 0x40100010L,
0x00008000L, 0x40000000L, 0x00108010L, 0x40008010L,
0x40108000L, 0x00008000L, 0x00000000L, 0x40000010L,
0x00000010L, 0x40108010L, 0x00108000L, 0x40100000L,
0x40100010L, 0x00100000L, 0x00008010L, 0x40008000L,
0x40008010L, 0x00000010L, 0x40100000L, 0x00108000L,
},{
/* nibble 2 */
0x04000001L, 0x04040100L, 0x00000100L, 0x04000101L,
0x00040001L, 0x04000000L, 0x04000101L, 0x00040100L,
0x04000100L, 0x00040000L, 0x04040000L, 0x00000001L,
0x04040101L, 0x00000101L, 0x00000001L, 0x04040001L,
0x00000000L, 0x00040001L, 0x04040100L, 0x00000100L,
0x00000101L, 0x04040101L, 0x00040000L, 0x04000001L,
0x04040001L, 0x04000100L, 0x00040101L, 0x04040000L,
0x00040100L, 0x00000000L, 0x04000000L, 0x00040101L,
0x04040100L, 0x00000100L, 0x00000001L, 0x00040000L,
0x00000101L, 0x00040001L, 0x04040000L, 0x04000101L,
0x00000000L, 0x04040100L, 0x00040100L, 0x04040001L,
0x00040001L, 0x04000000L, 0x04040101L, 0x00000001L,
0x00040101L, 0x04000001L, 0x04000000L, 0x04040101L,
0x00040000L, 0x04000100L, 0x04000101L, 0x00040100L,
0x04000100L, 0x00000000L, 0x04040001L, 0x00000101L,
0x04000001L, 0x00040101L, 0x00000100L, 0x04040000L,
},{
/* nibble 3 */
0x00401008L, 0x10001000L, 0x00000008L, 0x10401008L,
0x00000000L, 0x10400000L, 0x10001008L, 0x00400008L,
0x10401000L, 0x10000008L, 0x10000000L, 0x00001008L,
0x10000008L, 0x00401008L, 0x00400000L, 0x10000000L,
0x10400008L, 0x00401000L, 0x00001000L, 0x00000008L,
0x00401000L, 0x10001008L, 0x10400000L, 0x00001000L,
0x00001008L, 0x00000000L, 0x00400008L, 0x10401000L,
0x10001000L, 0x10400008L, 0x10401008L, 0x00400000L,
0x10400008L, 0x00001008L, 0x00400000L, 0x10000008L,
0x00401000L, 0x10001000L, 0x00000008L, 0x10400000L,
0x10001008L, 0x00000000L, 0x00001000L, 0x00400008L,
0x00000000L, 0x10400008L, 0x10401000L, 0x00001000L,
0x10000000L, 0x10401008L, 0x00401008L, 0x00400000L,
0x10401008L, 0x00000008L, 0x10001000L, 0x00401008L,
0x00400008L, 0x00401000L, 0x10400000L, 0x10001008L,
0x00001008L, 0x10000000L, 0x10000008L, 0x10401000L,
},{
/* nibble 4 */
0x08000000L, 0x00010000L, 0x00000400L, 0x08010420L,
0x08010020L, 0x08000400L, 0x00010420L, 0x08010000L,
0x00010000L, 0x00000020L, 0x08000020L, 0x00010400L,
0x08000420L, 0x08010020L, 0x08010400L, 0x00000000L,
0x00010400L, 0x08000000L, 0x00010020L, 0x00000420L,
0x08000400L, 0x00010420L, 0x00000000L, 0x08000020L,
0x00000020L, 0x08000420L, 0x08010420L, 0x00010020L,
0x08010000L, 0x00000400L, 0x00000420L, 0x08010400L,
0x08010400L, 0x08000420L, 0x00010020L, 0x08010000L,
0x00010000L, 0x00000020L, 0x08000020L, 0x08000400L,
0x08000000L, 0x00010400L, 0x08010420L, 0x00000000L,
0x00010420L, 0x08000000L, 0x00000400L, 0x00010020L,
0x08000420L, 0x00000400L, 0x00000000L, 0x08010420L,
0x08010020L, 0x08010400L, 0x00000420L, 0x00010000L,
0x00010400L, 0x08010020L, 0x08000400L, 0x00000420L,
0x00000020L, 0x00010420L, 0x08010000L, 0x08000020L,
},{
/* nibble 5 */
0x80000040L, 0x00200040L, 0x00000000L, 0x80202000L,
0x00200040L, 0x00002000L, 0x80002040L, 0x00200000L,
0x00002040L, 0x80202040L, 0x00202000L, 0x80000000L,
0x80002000L, 0x80000040L, 0x80200000L, 0x00202040L,
0x00200000L, 0x80002040L, 0x80200040L, 0x00000000L,
0x00002000L, 0x00000040L, 0x80202000L, 0x80200040L,
0x80202040L, 0x80200000L, 0x80000000L, 0x00002040L,
0x00000040L, 0x00202000L, 0x00202040L, 0x80002000L,
0x00002040L, 0x80000000L, 0x80002000L, 0x00202040L,
0x80202000L, 0x00200040L, 0x00000000L, 0x80002000L,
0x80000000L, 0x00002000L, 0x80200040L, 0x00200000L,
0x00200040L, 0x80202040L, 0x00202000L, 0x00000040L,
0x80202040L, 0x00202000L, 0x00200000L, 0x80002040L,
0x80000040L, 0x80200000L, 0x00202040L, 0x00000000L,
0x00002000L, 0x80000040L, 0x80002040L, 0x80202000L,
0x80200000L, 0x00002040L, 0x00000040L, 0x80200040L,
},{
/* nibble 6 */
0x00004000L, 0x00000200L, 0x01000200L, 0x01000004L,
0x01004204L, 0x00004004L, 0x00004200L, 0x00000000L,
0x01000000L, 0x01000204L, 0x00000204L, 0x01004000L,
0x00000004L, 0x01004200L, 0x01004000L, 0x00000204L,
0x01000204L, 0x00004000L, 0x00004004L, 0x01004204L,
0x00000000L, 0x01000200L, 0x01000004L, 0x00004200L,
0x01004004L, 0x00004204L, 0x01004200L, 0x00000004L,
0x00004204L, 0x01004004L, 0x00000200L, 0x01000000L,
0x00004204L, 0x01004000L, 0x01004004L, 0x00000204L,
0x00004000L, 0x00000200L, 0x01000000L, 0x01004004L,
0x01000204L, 0x00004204L, 0x00004200L, 0x00000000L,
0x00000200L, 0x01000004L, 0x00000004L, 0x01000200L,
0x00000000L, 0x01000204L, 0x01000200L, 0x00004200L,
0x00000204L, 0x00004000L, 0x01004204L, 0x01000000L,
0x01004200L, 0x00000004L, 0x00004004L, 0x01004204L,
0x01000004L, 0x01004200L, 0x01004000L, 0x00004004L,
},{
/* nibble 7 */
0x20800080L, 0x20820000L, 0x00020080L, 0x00000000L,
0x20020000L, 0x00800080L, 0x20800000L, 0x20820080L,
0x00000080L, 0x20000000L, 0x00820000L, 0x00020080L,
0x00820080L, 0x20020080L, 0x20000080L, 0x20800000L,
0x00020000L, 0x00820080L, 0x00800080L, 0x20020000L,
0x20820080L, 0x20000080L, 0x00000000L, 0x00820000L,
0x20000000L, 0x00800000L, 0x20020080L, 0x20800080L,
0x00800000L, 0x00020000L, 0x20820000L, 0x00000080L,
0x00800000L, 0x00020000L, 0x20000080L, 0x20820080L,
0x00020080L, 0x20000000L, 0x00000000L, 0x00820000L,
0x20800080L, 0x20020080L, 0x20020000L, 0x00800080L,
0x20820000L, 0x00000080L, 0x00800080L, 0x20020000L,
0x20820080L, 0x00800000L, 0x20800000L, 0x20000080L,
0x00820000L, 0x00020080L, 0x20020080L, 0x20800000L,
0x00000080L, 0x20820000L, 0x00820080L, 0x00000000L,
0x20000000L, 0x20800080L, 0x00020000L, 0x00820080L,

################################################################################

TITLE
    OpenSSL dh/p1024.c

TYPE
    8

DATA
    0x97,0xF6,0x42,0x61,0xCA,0xB5,0x05,0xDD,
	0x28,0x28,0xE1,0x3F,0x1D,0x68,0xB6,0xD3,
	0xDB,0xD0,0xF3,0x13,0x04,0x7F,0x40,0xE8,
	0x56,0xDA,0x58,0xCB,0x13,0xB8,0xA1,0xBF,
	0x2B,0x78,0x3A,0x4C,0x6D,0x59,0xD5,0xF9,
	0x2A,0xFC,0x6C,0xFF,0x3D,0x69,0x3F,0x78,
	0xB2,0x3D,0x4F,0x31,0x60,0xA9,0x50,0x2E,
	0x3E,0xFA,0xF7,0xAB,0x5E,0x1A,0xD5,0xA6,
	0x5E,0x55,0x43,0x13,0x82,0x8D,0xA8,0x3B,
	0x9F,0xF2,0xD9,0x41,0xDE,0xE9,0x56,0x89,
	0xFA,0xDA,0xEA,0x09,0x36,0xAD,0xDF,0x19,
	0x71,0xFE,0x63,0x5B,0x20,0xAF,0x47,0x03,
	0x64,0x60,0x3C,0x2D,0xE0,0x59,0xF5,0x4B,
	0x65,0x0A,0xD8,0xFA,0x0C,0xF7,0x01,0x21,
	0xC7,0x47,0x99,0xD7,0x58,0x71,0x32,0xBE,
	0x9B,0x99,0x9B,0xB9,0xB7,0x87,0xE8,0xAB,

################################################################################

TITLE
    OpenSSL dh/p192.c

TYPE
    8

DATA
    0xD4,0xA0,0xBA,0x02,0x50,0xB6,0xFD,0x2E,
    0xC6,0x26,0xE7,0xEF,0xD6,0x37,0xDF,0x76,
    0xC7,0x16,0xE2,0x2D,0x09,0x44,0xB8,0x8B,

################################################################################

TITLE
    OpenSSL DSAgen

TYPE
    8

DATA
	0xd5,0x01,0x4e,0x4b,
	0x60,0xef,0x2b,0xa8,
	0xb6,0x21,0x1b,0x40,
	0x62,0xba,0x32,0x24,
	0xe0,0x42,0x7d

################################################################################

TITLE
    bijective ebcdic-to-ascii table

TYPE
    8, 32

DATA
       0x00, 0x01, 0x02, 0x03, 0x85, 0x09, 0x86, 0x7f,
       0x87, 0x8d, 0x8e, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, /*................*/
       0x10, 0x11, 0x12, 0x13, 0x8f, 0x0a, 0x08, 0x97,
       0x18, 0x19, 0x9c, 0x9d, 0x1c, 0x1d, 0x1e, 0x1f, /*................*/
       0x80, 0x81, 0x82, 0x83, 0x84, 0x92, 0x17, 0x1b,
       0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x05, 0x06, 0x07, /*................*/
       0x90, 0x91, 0x16, 0x93, 0x94, 0x95, 0x96, 0x04,
       0x98, 0x99, 0x9a, 0x9b, 0x14, 0x15, 0x9e, 0x1a, /*................*/
       0x20, 0xa0, 0xe2, 0xe4, 0xe0, 0xe1, 0xe3, 0xe5,
       0xe7, 0xf1, 0x60, 0x2e, 0x3c, 0x28, 0x2b, 0x7c, /* .........`.<(+|*/
       0x26, 0xe9, 0xea, 0xeb, 0xe8, 0xed, 0xee, 0xef,
       0xec, 0xdf, 0x21, 0x24, 0x2a, 0x29, 0x3b, 0x9f, /*&.........!$*);.*/
       0x2d, 0x2f, 0xc2, 0xc4, 0xc0, 0xc1, 0xc3, 0xc5,
       0xc7, 0xd1, 0x5e, 0x2c, 0x25, 0x5f, 0x3e, 0x3f, /*-/........^,%_>?*/
       0xf8, 0xc9, 0xca, 0xcb, 0xc8, 0xcd, 0xce, 0xcf,
       0xcc, 0xa8, 0x3a, 0x23, 0x40, 0x27, 0x3d, 0x22, /*..........:#@'="*/
       0xd8, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
       0x68, 0x69, 0xab, 0xbb, 0xf0, 0xfd, 0xfe, 0xb1, /*.abcdefghi......*/
       0xb0, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70,
       0x71, 0x72, 0xaa, 0xba, 0xe6, 0xb8, 0xc6, 0xa4, /*.jklmnopqr......*/
       0xb5, 0xaf, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
       0x79, 0x7a, 0xa1, 0xbf, 0xd0, 0xdd, 0xde, 0xae, /*..stuvwxyz......*/
       0xa2, 0xa3, 0xa5, 0xb7, 0xa9, 0xa7, 0xb6, 0xbc,
       0xbd, 0xbe, 0xac, 0x5b, 0x5c, 0x5d, 0xb4, 0xd7, /*...........[\]..*/
       0xf9, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
       0x48, 0x49, 0xad, 0xf4, 0xf6, 0xf2, 0xf3, 0xf5, /*.ABCDEFGHI......*/
       0xa6, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 0x50,
       0x51, 0x52, 0xb9, 0xfb, 0xfc, 0xdb, 0xfa, 0xff, /*.JKLMNOPQR......*/
       0xd9, 0xf7, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
       0x59, 0x5a, 0xb2, 0xd4, 0xd6, 0xd2, 0xd3, 0xd5, /*..STUVWXYZ......*/
       0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
       0x38, 0x39, 0xb3, 0x7b, 0xdc, 0x7d, 0xda, 0x7e  /*0123456789.{.}.~*/

################################################################################

TITLE
    ascii-to-ebcdic table

TYPE
    8, 32

DATA
    0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f,
	0x16, 0x05, 0x15, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,  /*................*/
    0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26,
	0x18, 0x19, 0x3f, 0x27, 0x1c, 0x1d, 0x1e, 0x1f,  /*................*/
    0x40, 0x5a, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d,
	0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61,  /* !"#$%&'()*+,-./ */
    0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
	0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f,  /*0123456789:;<=>?*/
    0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
	0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6,  /*@ABCDEFGHIJKLMNO*/
    0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
	0xe7, 0xe8, 0xe9, 0xbb, 0xbc, 0xbd, 0x6a, 0x6d,  /*PQRSTUVWXYZ[\]^_*/
    0x4a, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
	0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,  /*`abcdefghijklmno*/
    0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
	0xa7, 0xa8, 0xa9, 0xfb, 0x4f, 0xfd, 0xff, 0x07,  /*pqrstuvwxyz{|}~.*/
    0x20, 0x21, 0x22, 0x23, 0x24, 0x04, 0x06, 0x08,
	0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x09, 0x0a, 0x14,  /*................*/
    0x30, 0x31, 0x25, 0x33, 0x34, 0x35, 0x36, 0x17,
	0x38, 0x39, 0x3a, 0x3b, 0x1a, 0x1b, 0x3e, 0x5f,  /*................*/
    0x41, 0xaa, 0xb0, 0xb1, 0x9f, 0xb2, 0xd0, 0xb5,
	0x79, 0xb4, 0x9a, 0x8a, 0xba, 0xca, 0xaf, 0xa1,  /*................*/
    0x90, 0x8f, 0xea, 0xfa, 0xbe, 0xa0, 0xb6, 0xb3,
	0x9d, 0xda, 0x9b, 0x8b, 0xb7, 0xb8, 0xb9, 0xab,  /*................*/
    0x64, 0x65, 0x62, 0x66, 0x63, 0x67, 0x9e, 0x68,
	0x74, 0x71, 0x72, 0x73, 0x78, 0x75, 0x76, 0x77,  /*................*/
    0xac, 0x69, 0xed, 0xee, 0xeb, 0xef, 0xec, 0xbf,
	0x80, 0xe0, 0xfe, 0xdd, 0xfc, 0xad, 0xae, 0x59,  /*................*/
    0x44, 0x45, 0x42, 0x46, 0x43, 0x47, 0x9c, 0x48,
	0x54, 0x51, 0x52, 0x53, 0x58, 0x55, 0x56, 0x57,  /*................*/
    0x8c, 0x49, 0xcd, 0xce, 0xcb, 0xcf, 0xcc, 0xe1,
	0x70, 0xc0, 0xde, 0xdb, 0xdc, 0x8d, 0x8e, 0xdf   /*................*/

################################################################################

TITLE
    Bijective EBCDIC (character set IBM-1047) to US-ASCII table

TYPE
    8, 32

DATA
    0x00, 0x01, 0x02, 0x03, 0x85, 0x09, 0x86, 0x7f, /* 00-0f:           */
    0x87, 0x8d, 0x8e, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, /* ................ */
    0x10, 0x11, 0x12, 0x13, 0x8f, 0x0a, 0x08, 0x97, /* 10-1f:           */
    0x18, 0x19, 0x9c, 0x9d, 0x1c, 0x1d, 0x1e, 0x1f, /* ................ */
    0x80, 0x81, 0x82, 0x83, 0x84, 0x92, 0x17, 0x1b, /* 20-2f:           */
    0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x05, 0x06, 0x07, /* ................ */
    0x90, 0x91, 0x16, 0x93, 0x94, 0x95, 0x96, 0x04, /* 30-3f:           */
    0x98, 0x99, 0x9a, 0x9b, 0x14, 0x15, 0x9e, 0x1a, /* ................ */
    0x20, 0xa0, 0xe2, 0xe4, 0xe0, 0xe1, 0xe3, 0xe5, /* 40-4f:           */
    0xe7, 0xf1, 0xa2, 0x2e, 0x3c, 0x28, 0x2b, 0x7c, /*  ...........<(+| */
    0x26, 0xe9, 0xea, 0xeb, 0xe8, 0xed, 0xee, 0xef, /* 50-5f:           */
    0xec, 0xdf, 0x21, 0x24, 0x2a, 0x29, 0x3b, 0x5e, /* &.........!$*);^ */
    0x2d, 0x2f, 0xc2, 0xc4, 0xc0, 0xc1, 0xc3, 0xc5, /* 60-6f:           */
    0xc7, 0xd1, 0xa6, 0x2c, 0x25, 0x5f, 0x3e, 0x3f, /* -/.........,%_>? */
    0xf8, 0xc9, 0xca, 0xcb, 0xc8, 0xcd, 0xce, 0xcf, /* 70-7f:           */
    0xcc, 0x60, 0x3a, 0x23, 0x40, 0x27, 0x3d, 0x22, /* .........`:#@'=" */
    0xd8, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, /* 80-8f:           */
    0x68, 0x69, 0xab, 0xbb, 0xf0, 0xfd, 0xfe, 0xb1, /* .abcdefghi...... */
    0xb0, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70, /* 90-9f:           */
    0x71, 0x72, 0xaa, 0xba, 0xe6, 0xb8, 0xc6, 0xa4, /* .jklmnopqr...... */
    0xb5, 0x7e, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, /* a0-af:           */
    0x79, 0x7a, 0xa1, 0xbf, 0xd0, 0x5b, 0xde, 0xae, /* .~stuvwxyz...[.. */
    0xac, 0xa3, 0xa5, 0xb7, 0xa9, 0xa7, 0xb6, 0xbc, /* b0-bf:           */
    0xbd, 0xbe, 0xdd, 0xa8, 0xaf, 0x5d, 0xb4, 0xd7, /* .............].. */
    0x7b, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, /* c0-cf:           */
    0x48, 0x49, 0xad, 0xf4, 0xf6, 0xf2, 0xf3, 0xf5, /* {ABCDEFGHI...... */
    0x7d, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 0x50, /* d0-df:           */
    0x51, 0x52, 0xb9, 0xfb, 0xfc, 0xf9, 0xfa, 0xff, /* }JKLMNOPQR...... */
    0x5c, 0xf7, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, /* e0-ef:           */
    0x59, 0x5a, 0xb2, 0xd4, 0xd6, 0xd2, 0xd3, 0xd5, /* \.STUVWXYZ...... */
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, /* f0-ff:           */
    0x38, 0x39, 0xb3, 0xdb, 0xdc, 0xd9, 0xda, 0x9f  /* 0123456789...... */

################################################################################

TITLE
    US-ASCII to EBCDIC (character set IBM-1047) table

TYPE
    8, 32

DATA
    0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f, /* 00-0f:           */
    0x16, 0x05, 0x15, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, /* ................ */
    0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26, /* 10-1f:           */
    0x18, 0x19, 0x3f, 0x27, 0x1c, 0x1d, 0x1e, 0x1f, /* ................ */
    0x40, 0x5a, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d, /* 20-2f:           */
    0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61, /*  !"#$%&'()*+,-./ */
    0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, /* 30-3f:           */
    0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f, /* 0123456789:;<=>? */
    0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, /* 40-4f:           */
    0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, /* @ABCDEFGHIJKLMNO */
    0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, /* 50-5f:           */
    0xe7, 0xe8, 0xe9, 0xad, 0xe0, 0xbd, 0x5f, 0x6d, /* PQRSTUVWXYZ[\]^_ */
    0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, /* 60-6f:           */
    0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, /* `abcdefghijklmno */
    0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, /* 70-7f:           */
    0xa7, 0xa8, 0xa9, 0xc0, 0x4f, 0xd0, 0xa1, 0x07, /* pqrstuvwxyz{|}~. */
    0x20, 0x21, 0x22, 0x23, 0x24, 0x04, 0x06, 0x08, /* 80-8f:           */
    0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x09, 0x0a, 0x14, /* ................ */
    0x30, 0x31, 0x25, 0x33, 0x34, 0x35, 0x36, 0x17, /* 90-9f:           */
    0x38, 0x39, 0x3a, 0x3b, 0x1a, 0x1b, 0x3e, 0xff, /* ................ */
    0x41, 0xaa, 0x4a, 0xb1, 0x9f, 0xb2, 0x6a, 0xb5, /* a0-af:           */
    0xbb, 0xb4, 0x9a, 0x8a, 0xb0, 0xca, 0xaf, 0xbc, /* ................ */
    0x90, 0x8f, 0xea, 0xfa, 0xbe, 0xa0, 0xb6, 0xb3, /* b0-bf:           */
    0x9d, 0xda, 0x9b, 0x8b, 0xb7, 0xb8, 0xb9, 0xab, /* ................ */
    0x64, 0x65, 0x62, 0x66, 0x63, 0x67, 0x9e, 0x68, /* c0-cf:           */
    0x74, 0x71, 0x72, 0x73, 0x78, 0x75, 0x76, 0x77, /* ................ */
    0xac, 0x69, 0xed, 0xee, 0xeb, 0xef, 0xec, 0xbf, /* d0-df:           */
    0x80, 0xfd, 0xfe, 0xfb, 0xfc, 0xba, 0xae, 0x59, /* ................ */
    0x44, 0x45, 0x42, 0x46, 0x43, 0x47, 0x9c, 0x48, /* e0-ef:           */
    0x54, 0x51, 0x52, 0x53, 0x58, 0x55, 0x56, 0x57, /* ................ */
    0x8c, 0x49, 0xcd, 0xce, 0xcb, 0xcf, 0xcc, 0xe1, /* f0-ff:           */
    0x70, 0xdd, 0xde, 0xdb, 0xdc, 0x8d, 0x8e, 0xdf  /* ................ */

################################################################################

TITLE
    EC curve _EC_NIST_PRIME_192_SEED

TYPE
    8

DATA
	0x30,0x45,0xAE,0x6F,0xC8,0x42,0x2F,0x64,0xED,0x57,
	0x95,0x28,0xD3,0x81,0x20,0xEA,0xE1,0x21,0x96,0xD5};

################################################################################

TITLE
    EC curve _EC_NIST_PRIME_224_SEED

TYPE
    8

DATA
	0xBD,0x71,0x34,0x47,0x99,0xD5,0xC7,0xFC,0xDC,0x45,
	0xB5,0x9F,0xA3,0xB9,0xAB,0x8F,0x6A,0x94,0x8B,0xC5};

################################################################################

TITLE
    EC curve _EC_NIST_PRIME_384_SEED

TYPE
    8

DATA
	0xA3,0x35,0x92,0x6A,0xA3,0x19,0xA2,0x7A,0x1D,0x00,
	0x89,0x6A,0x67,0x73,0xA4,0x82,0x7A,0xCD,0xAC,0x73};

################################################################################

TITLE
    EC curve _EC_NIST_PRIME_521_SEED

TYPE
    8

DATA
	0xD0,0x9E,0x88,0x00,0x29,0x1C,0xB8,0x53,0x96,0xCC,
	0x67,0x17,0x39,0x32,0x84,0xAA,0xA0,0xDA,0x64,0xBA};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_192V2_SEED

TYPE
    8

DATA
	0x31,0xA9,0x2E,0xE2,0x02,0x9F,0xD1,0x0D,0x90,0x1B,
	0x11,0x3E,0x99,0x07,0x10,0xF0,0xD2,0x1A,0xC6,0xB6};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_192V3_SEED

TYPE
    8

DATA
	0xC4,0x69,0x68,0x44,0x35,0xDE,0xB3,0x78,0xC4,0xB6,
	0x5C,0xA9,0x59,0x1E,0x2A,0x57,0x63,0x05,0x9A,0x2E};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_239V1_SEED

TYPE
    8

DATA
	0xE4,0x3B,0xB4,0x60,0xF0,0xB8,0x0C,0xC0,0xC0,0xB0,
	0x75,0x79,0x8E,0x94,0x80,0x60,0xF8,0x32,0x1B,0x7D};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_239V2_SEED

TYPE
    8

DATA
	0xE8,0xB4,0x01,0x16,0x04,0x09,0x53,0x03,0xCA,0x3B,
	0x80,0x99,0x98,0x2B,0xE0,0x9F,0xCB,0x9A,0xE6,0x16};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_239V3_SEED

TYPE
    8

DATA
	0x7D,0x73,0x74,0x16,0x8F,0xFE,0x34,0x71,0xB6,0x0A,
	0x85,0x76,0x86,0xA1,0x94,0x75,0xD3,0xBF,0xA2,0xFF};

################################################################################

TITLE
    EC curve _EC_X9_62_PRIME_256V1_SEED

TYPE
    8

DATA
	0xC4,0x9D,0x36,0x08,0x86,0xE7,0x04,0x93,0x6A,0x66,
	0x78,0xE1,0x13,0x9D,0x26,0xB7,0x81,0x9F,0x7E,0x90};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_112R1_SEED

TYPE
    8

DATA
	0x00,0xF5,0x0B,0x02,0x8E,0x4D,0x69,0x6E,0x67,0x68,
	0x75,0x61,0x51,0x75,0x29,0x04,0x72,0x78,0x3F,0xB1};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_112R2_SEED

TYPE
    8

DATA
	0x00,0x27,0x57,0xA1,0x11,0x4D,0x69,0x6E,0x67,0x68,
	0x75,0x61,0x51,0x75,0x53,0x16,0xC0,0x5E,0x0B,0xD4};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_128R1_SEED

TYPE
    8

DATA
	0x00,0x0E,0x0D,0x4D,0x69,0x6E,0x67,0x68,0x75,0x61,
	0x51,0x75,0x0C,0xC0,0x3A,0x44,0x73,0xD0,0x36,0x79};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_128R2_SEED

TYPE
    8

DATA
	0x00,0x4D,0x69,0x6E,0x67,0x68,0x75,0x61,0x51,0x75,
	0x12,0xD8,0xF0,0x34,0x31,0xFC,0xE6,0x3B,0x88,0xF4};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_160R1_SEED

TYPE
    8

DATA
	0x10,0x53,0xCD,0xE4,0x2C,0x14,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x53,0x3B,0xF3,0xF8,0x33,0x45};

################################################################################

TITLE
    EC curve _EC_SECG_PRIME_160R2_SEED

TYPE
    8

DATA
	0xB9,0x9B,0x99,0xB0,0x99,0xB3,0x23,0xE0,0x27,0x09,
	0xA4,0xD6,0x96,0xE6,0x76,0x87,0x56,0x15,0x17,0x51};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_113R1_SEED

TYPE
    8

DATA
	0x10,0xE7,0x23,0xAB,0x14,0xD6,0x96,0xE6,0x76,0x87,
	0x56,0x15,0x17,0x56,0xFE,0xBF,0x8F,0xCB,0x49,0xA9};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_113R2_SEED

TYPE
    8

DATA
	0x10,0xC0,0xFB,0x15,0x76,0x08,0x60,0xDE,0xF1,0xEE,
	0xF4,0xD6,0x96,0xE6,0x76,0x87,0x56,0x15,0x17,0x5D};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_131R1_SEED

TYPE
    8

DATA
	0x4D,0x69,0x6E,0x67,0x68,0x75,0x61,0x51,0x75,0x98,
	0x5B,0xD3,0xAD,0xBA,0xDA,0x21,0xB4,0x3A,0x97,0xE2};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_131R2_SEED

TYPE
    8

DATA
	0x98,0x5B,0xD3,0xAD,0xBA,0xD4,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x5A,0x21,0xB4,0x3A,0x97,0xE3};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_163R1_SEED

TYPE
    8

DATA
	0x24,0xB7,0xB1,0x37,0xC8,0xA1,0x4D,0x69,0x6E,0x67,
	0x68,0x75,0x61,0x51,0x75,0x6F,0xD0,0xDA,0x2E,0x5C};

################################################################################

TITLE
    EC curve _EC_NIST_CHAR2_163B_SEED

TYPE
    8

DATA
	0x85,0xE2,0x5B,0xFE,0x5C,0x86,0x22,0x6C,0xDB,0x12,
	0x01,0x6F,0x75,0x53,0xF9,0xD0,0xE6,0x93,0xA2,0x68};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_193R1_SEED

TYPE
    8

DATA
	0x10,0x3F,0xAE,0xC7,0x4D,0x69,0x6E,0x67,0x68,0x75,
	0x61,0x51,0x75,0x77,0x7F,0xC5,0xB1,0x91,0xEF,0x30};

################################################################################

TITLE
    EC curve _EC_SECG_CHAR2_193R2_SEED

TYPE
    8

DATA
	0x10,0xB7,0xB4,0xD6,0x96,0xE6,0x76,0x87,0x56,0x15,
	0x17,0x51,0x37,0xC8,0xA1,0x6F,0xD0,0xDA,0x22,0x11};

################################################################################

TITLE
    EC curve _EC_NIST_CHAR2_233B_SEED

TYPE
    8

DATA
	0x74,0xD5,0x9F,0xF0,0x7F,0x6B,0x41,0x3D,0x0E,0xA1,
	0x4B,0x34,0x4B,0x20,0xA2,0xDB,0x04,0x9B,0x50,0xC3};

################################################################################

TITLE
    EC curve _EC_NIST_CHAR2_283B_SEED

TYPE
    8

DATA
	0x77,0xE2,0xB0,0x73,0x70,0xEB,0x0F,0x83,0x2A,0x6D,
	0xD5,0xB6,0x2D,0xFC,0x88,0xCD,0x06,0xBB,0x84,0xBE};

################################################################################

TITLE
    EC curve _EC_NIST_CHAR2_409B_SEED

TYPE
    8

DATA
	0x40,0x99,0xB5,0xA4,0x57,0xF9,0xD6,0x9F,0x79,0x21,
	0x3D,0x09,0x4C,0x4B,0xCD,0x4D,0x42,0x62,0x21,0x0B};

################################################################################

TITLE
    EC curve _EC_NIST_CHAR2_571B_SEED

TYPE
    8

DATA
	0x2A,0xA0,0x58,0xF7,0x3A,0x0E,0x33,0xAB,0x48,0x6B,
	0x0F,0x61,0x04,0x10,0xC5,0x3A,0x7F,0x13,0x23,0x10};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_163V1_SEED

TYPE
    8

DATA
	0xD2,0xC0,0xFB,0x15,0x76,0x08,0x60,0xDE,0xF1,0xEE,
	0xF4,0xD6,0x96,0xE6,0x76,0x87,0x56,0x15,0x17,0x54};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_163V2_SEED

TYPE
    8

DATA
	0x53,0x81,0x4C,0x05,0x0D,0x44,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x58,0x0C,0xA4,0xE2,0x9F,0xFD};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_163V3_SEED

TYPE
    8

DATA
	0x50,0xCB,0xF1,0xD9,0x5C,0xA9,0x4D,0x69,0x6E,0x67,
	0x68,0x75,0x61,0x51,0x75,0xF1,0x6A,0x36,0xA3,0xB8};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_191V1_SEED

TYPE
    8

DATA
	0x4E,0x13,0xCA,0x54,0x27,0x44,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x55,0x2F,0x27,0x9A,0x8C,0x84};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_191V2_SEED

TYPE
    8

DATA
	0x08,0x71,0xEF,0x2F,0xEF,0x24,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x58,0xBE,0xE0,0xD9,0x5C,0x15};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_191V3_SEED

TYPE
    8

DATA
	0xE0,0x53,0x51,0x2D,0xC6,0x84,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x50,0x67,0xAE,0x78,0x6D,0x1F};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_239V1_SEED

TYPE
    8

DATA
	0xD3,0x4B,0x9A,0x4D,0x69,0x6E,0x67,0x68,0x75,0x61,
	0x51,0x75,0xCA,0x71,0xB9,0x20,0xBF,0xEF,0xB0,0x5D};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_239V2_SEED

TYPE
    8

DATA
	0x2A,0xA6,0x98,0x2F,0xDF,0xA4,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x5D,0x26,0x67,0x27,0x27,0x7D};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_239V3_SEED

TYPE
    8

DATA
	0x9E,0x07,0x6F,0x4D,0x69,0x6E,0x67,0x68,0x75,0x61,
	0x51,0x75,0xE1,0x1E,0x9F,0xDD,0x77,0xF9,0x20,0x41};

################################################################################

TITLE
    EC curve _EC_X9_62_CHAR2_359V1_SEED

TYPE
    8

DATA
	0x2B,0x35,0x49,0x20,0xB7,0x24,0xD6,0x96,0xE6,0x76,
	0x87,0x56,0x15,0x17,0x58,0x5B,0xA1,0x33,0x2D,0xC6};

################################################################################

TITLE
    ASCII to BIN table

TYPE
    8, 32

DATA
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xE0,0xF0,0xFF,0xFF,0xF1,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xE0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0x3E,0xFF,0xF2,0xFF,0x3F,
	0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,
	0x3C,0x3D,0xFF,0xFF,0xFF,0x00,0xFF,0xFF,
	0xFF,0x00,0x01,0x02,0x03,0x04,0x05,0x06,
	0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,
	0x0F,0x10,0x11,0x12,0x13,0x14,0x15,0x16,
	0x17,0x18,0x19,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,
	0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,
	0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,
	0x31,0x32,0x33,0xFF,0xFF,0xFF,0xFF,0xFF,

################################################################################

TITLE
    MD2 MD2_INT S

TYPE
    8, 32

DATA
	0x29, 0x2E, 0x43, 0xC9, 0xA2, 0xD8, 0x7C, 0x01,
	0x3D, 0x36, 0x54, 0xA1, 0xEC, 0xF0, 0x06, 0x13,
	0x62, 0xA7, 0x05, 0xF3, 0xC0, 0xC7, 0x73, 0x8C,
	0x98, 0x93, 0x2B, 0xD9, 0xBC, 0x4C, 0x82, 0xCA,
	0x1E, 0x9B, 0x57, 0x3C, 0xFD, 0xD4, 0xE0, 0x16,
	0x67, 0x42, 0x6F, 0x18, 0x8A, 0x17, 0xE5, 0x12,
	0xBE, 0x4E, 0xC4, 0xD6, 0xDA, 0x9E, 0xDE, 0x49,
	0xA0, 0xFB, 0xF5, 0x8E, 0xBB, 0x2F, 0xEE, 0x7A,
	0xA9, 0x68, 0x79, 0x91, 0x15, 0xB2, 0x07, 0x3F,
	0x94, 0xC2, 0x10, 0x89, 0x0B, 0x22, 0x5F, 0x21,
	0x80, 0x7F, 0x5D, 0x9A, 0x5A, 0x90, 0x32, 0x27,
	0x35, 0x3E, 0xCC, 0xE7, 0xBF, 0xF7, 0x97, 0x03,
	0xFF, 0x19, 0x30, 0xB3, 0x48, 0xA5, 0xB5, 0xD1,
	0xD7, 0x5E, 0x92, 0x2A, 0xAC, 0x56, 0xAA, 0xC6,
	0x4F, 0xB8, 0x38, 0xD2, 0x96, 0xA4, 0x7D, 0xB6,
	0x76, 0xFC, 0x6B, 0xE2, 0x9C, 0x74, 0x04, 0xF1,
	0x45, 0x9D, 0x70, 0x59, 0x64, 0x71, 0x87, 0x20,
	0x86, 0x5B, 0xCF, 0x65, 0xE6, 0x2D, 0xA8, 0x02,
	0x1B, 0x60, 0x25, 0xAD, 0xAE, 0xB0, 0xB9, 0xF6,
	0x1C, 0x46, 0x61, 0x69, 0x34, 0x40, 0x7E, 0x0F,
	0x55, 0x47, 0xA3, 0x23, 0xDD, 0x51, 0xAF, 0x3A,
	0xC3, 0x5C, 0xF9, 0xCE, 0xBA, 0xC5, 0xEA, 0x26,
	0x2C, 0x53, 0x0D, 0x6E, 0x85, 0x28, 0x84, 0x09,
	0xD3, 0xDF, 0xCD, 0xF4, 0x41, 0x81, 0x4D, 0x52,
	0x6A, 0xDC, 0x37, 0xC8, 0x6C, 0xC1, 0xAB, 0xFA,
	0x24, 0xE1, 0x7B, 0x08, 0x0C, 0xBD, 0xB1, 0x4A,
	0x78, 0x88, 0x95, 0x8B, 0xE3, 0x63, 0xE8, 0x6D,
	0xE9, 0xCB, 0xD5, 0xFE, 0x3B, 0x00, 0x1D, 0x39,
	0xF2, 0xEF, 0xB7, 0x0E, 0x66, 0x58, 0xD0, 0xE4,
	0xA6, 0x77, 0x72, 0xF8, 0xEB, 0x75, 0x4B, 0x0A,
	0x31, 0x44, 0x50, 0xB4, 0x8F, 0xED, 0x1F, 0x1A,
	0xDB, 0x99, 0x8D, 0x33, 0x9F, 0x11, 0x83, 0x14,

################################################################################

TITLE
    openbsd_hw.c do_digest md5zero

TYPE
    8

DATA
	0xd4,0x1d,0x8c,0xd9,0x8f,0x00,0xb2,0x04,
	0xe9,0x80,0x09,0x98,0xec,0xf8,0x42,0x7e

################################################################################

TITLE
    MD4 digest

TYPE
    32 AND

DATA
    0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476
    0x5A827999, 0x6ED9EBA1

################################################################################

TITLE
    MD5 digest

TYPE
    32 AND

DATA
    0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476
	/* Round 0 */
    0xd76aa478L);
    0xe8c7b756L);
    0x242070dbL);
    0xc1bdceeeL);
    0xf57c0fafL);
    0x4787c62aL);
    0xa8304613L);
    0xfd469501L);
    0x698098d8L);
    0x8b44f7afL);
    0xffff5bb1L);
    0x895cd7beL);
    0x6b901122L);
    0xfd987193L);
    0xa679438eL);
    0x49b40821L);
	/* Round 1 */
    0xf61e2562L);
    0xc040b340L);
    0x265e5a51L);
    0xe9b6c7aaL);
    0xd62f105dL);
    0x02441453L);
    0xd8a1e681L);
    0xe7d3fbc8L);
    0x21e1cde6L);
    0xc33707d6L);
    0xf4d50d87L);
    0x455a14edL);
    0xa9e3e905L);
    0xfcefa3f8L);
    0x676f02d9L);
    0x8d2a4c8aL);
	/* Round 2 */
    0xfffa3942L);
    0x8771f681L);
    0x6d9d6122L);
    0xfde5380cL);
    0xa4beea44L);
    0x4bdecfa9L);
    0xf6bb4b60L);
    0xbebfbc70L);
    0x289b7ec6L);
    0xeaa127faL);
    0xd4ef3085L);
    0x04881d05L);
    0xd9d4d039L);
    0xe6db99e5L);
    0x1fa27cf8L);
    0xc4ac5665L);
	/* Round 3 */
    0xf4292244L);
    0x432aff97L);
    0xab9423a7L);
    0xfc93a039L);
    0x655b59c3L);
    0x8f0ccc92L);
    0xffeff47dL);
    0x85845dd1L);
    0x6fa87e4fL);
    0xfe2ce6e0L);
    0xa3014314L);
    0x4e0811a1L);
    0xf7537e82L);
    0xbd3af235L);
    0x2ad7d2bbL);
    0xeb86d391L);

################################################################################

TITLE
    OpenSSL obj_dat.h lvalues

TYPE
    8

DATA
0x00,                                        /* [  0] OBJ_undef */
0x2A,0x86,0x48,0x86,0xF7,0x0D,               /* [  1] OBJ_rsadsi */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,          /* [  7] OBJ_pkcs */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x02,0x02,     /* [ 14] OBJ_md2 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x02,0x05,     /* [ 22] OBJ_md5 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x03,0x04,     /* [ 30] OBJ_rc4 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x01,/* [ 38] OBJ_rsaEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x02,/* [ 47] OBJ_md2WithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x04,/* [ 56] OBJ_md5WithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x01,/* [ 65] OBJ_pbeWithMD2AndDES_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x03,/* [ 74] OBJ_pbeWithMD5AndDES_CBC */
0x55,                                        /* [ 83] OBJ_X500 */
0x55,0x04,                                   /* [ 84] OBJ_X509 */
0x55,0x04,0x03,                              /* [ 86] OBJ_commonName */
0x55,0x04,0x06,                              /* [ 89] OBJ_countryName */
0x55,0x04,0x07,                              /* [ 92] OBJ_localityName */
0x55,0x04,0x08,                              /* [ 95] OBJ_stateOrProvinceName */
0x55,0x04,0x0A,                              /* [ 98] OBJ_organizationName */
0x55,0x04,0x0B,                              /* [101] OBJ_organizationalUnitName */
0x55,0x08,0x01,0x01,                         /* [104] OBJ_rsa */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,     /* [108] OBJ_pkcs7 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x01,/* [116] OBJ_pkcs7_data */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x02,/* [125] OBJ_pkcs7_signed */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x03,/* [134] OBJ_pkcs7_enveloped */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x04,/* [143] OBJ_pkcs7_signedAndEnveloped */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x05,/* [152] OBJ_pkcs7_digest */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x07,0x06,/* [161] OBJ_pkcs7_encrypted */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x03,     /* [170] OBJ_pkcs3 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x03,0x01,/* [178] OBJ_dhKeyAgreement */
0x2B,0x0E,0x03,0x02,0x06,                    /* [187] OBJ_des_ecb */
0x2B,0x0E,0x03,0x02,0x09,                    /* [192] OBJ_des_cfb64 */
0x2B,0x0E,0x03,0x02,0x07,                    /* [197] OBJ_des_cbc */
0x2B,0x0E,0x03,0x02,0x11,                    /* [202] OBJ_des_ede_ecb */
0x2B,0x06,0x01,0x04,0x01,0x81,0x3C,0x07,0x01,0x01,0x02,/* [207] OBJ_idea_cbc */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x03,0x02,     /* [218] OBJ_rc2_cbc */
0x2B,0x0E,0x03,0x02,0x12,                    /* [226] OBJ_sha */
0x2B,0x0E,0x03,0x02,0x0F,                    /* [231] OBJ_shaWithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x03,0x07,     /* [236] OBJ_des_ede3_cbc */
0x2B,0x0E,0x03,0x02,0x08,                    /* [244] OBJ_des_ofb64 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,     /* [249] OBJ_pkcs9 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x01,/* [257] OBJ_pkcs9_emailAddress */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x02,/* [266] OBJ_pkcs9_unstructuredName */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x03,/* [275] OBJ_pkcs9_contentType */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x04,/* [284] OBJ_pkcs9_messageDigest */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x05,/* [293] OBJ_pkcs9_signingTime */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x06,/* [302] OBJ_pkcs9_countersignature */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x07,/* [311] OBJ_pkcs9_challengePassword */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x08,/* [320] OBJ_pkcs9_unstructuredAddress */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x09,/* [329] OBJ_pkcs9_extCertAttributes */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,          /* [338] OBJ_netscape */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,     /* [345] OBJ_netscape_cert_extension */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x02,     /* [353] OBJ_netscape_data_type */
0x2B,0x0E,0x03,0x02,0x1A,                    /* [361] OBJ_sha1 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x05,/* [366] OBJ_sha1WithRSAEncryption */
0x2B,0x0E,0x03,0x02,0x0D,                    /* [375] OBJ_dsaWithSHA */
0x2B,0x0E,0x03,0x02,0x0C,                    /* [380] OBJ_dsa_2 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x0B,/* [385] OBJ_pbeWithSHA1AndRC2_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x0C,/* [394] OBJ_id_pbkdf2 */
0x2B,0x0E,0x03,0x02,0x1B,                    /* [403] OBJ_dsaWithSHA1_2 */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x01,/* [408] OBJ_netscape_cert_type */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x02,/* [417] OBJ_netscape_base_url */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x03,/* [426] OBJ_netscape_revocation_url */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x04,/* [435] OBJ_netscape_ca_revocation_url */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x07,/* [444] OBJ_netscape_renewal_url */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x08,/* [453] OBJ_netscape_ca_policy_url */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x0C,/* [462] OBJ_netscape_ssl_server_name */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x01,0x0D,/* [471] OBJ_netscape_comment */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x02,0x05,/* [480] OBJ_netscape_cert_sequence */
0x55,0x1D,                                   /* [489] OBJ_id_ce */
0x55,0x1D,0x0E,                              /* [491] OBJ_subject_key_identifier */
0x55,0x1D,0x0F,                              /* [494] OBJ_key_usage */
0x55,0x1D,0x10,                              /* [497] OBJ_private_key_usage_period */
0x55,0x1D,0x11,                              /* [500] OBJ_subject_alt_name */
0x55,0x1D,0x12,                              /* [503] OBJ_issuer_alt_name */
0x55,0x1D,0x13,                              /* [506] OBJ_basic_constraints */
0x55,0x1D,0x14,                              /* [509] OBJ_crl_number */
0x55,0x1D,0x20,                              /* [512] OBJ_certificate_policies */
0x55,0x1D,0x23,                              /* [515] OBJ_authority_key_identifier */
0x2B,0x06,0x01,0x04,0x01,0x97,0x55,0x01,0x02,/* [518] OBJ_bf_cbc */
0x55,0x08,0x03,0x65,                         /* [527] OBJ_mdc2 */
0x55,0x08,0x03,0x64,                         /* [531] OBJ_mdc2WithRSA */
0x55,0x04,0x2A,                              /* [535] OBJ_givenName */
0x55,0x04,0x04,                              /* [538] OBJ_surname */
0x55,0x04,0x2B,                              /* [541] OBJ_initials */
0x55,0x1D,0x1F,                              /* [544] OBJ_crl_distribution_points */
0x2B,0x0E,0x03,0x02,0x03,                    /* [547] OBJ_md5WithRSA */
0x55,0x04,0x05,                              /* [552] OBJ_serialNumber */
0x55,0x04,0x0C,                              /* [555] OBJ_title */
0x55,0x04,0x0D,                              /* [558] OBJ_description */
0x2A,0x86,0x48,0x86,0xF6,0x7D,0x07,0x42,0x0A,/* [561] OBJ_cast5_cbc */
0x2A,0x86,0x48,0x86,0xF6,0x7D,0x07,0x42,0x0C,/* [570] OBJ_pbeWithMD5AndCast5_CBC */
0x2A,0x86,0x48,0xCE,0x38,0x04,0x03,          /* [579] OBJ_dsaWithSHA1 */
0x2B,0x0E,0x03,0x02,0x1D,                    /* [586] OBJ_sha1WithRSA */
0x2A,0x86,0x48,0xCE,0x38,0x04,0x01,          /* [591] OBJ_dsa */
0x2B,0x24,0x03,0x02,0x01,                    /* [598] OBJ_ripemd160 */
0x2B,0x24,0x03,0x03,0x01,0x02,               /* [603] OBJ_ripemd160WithRSA */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x03,0x08,     /* [609] OBJ_rc5_cbc */
0x29,0x01,0x01,0x85,0x1A,0x01,               /* [617] OBJ_rle_compression */
0x29,0x01,0x01,0x85,0x1A,0x02,               /* [623] OBJ_zlib_compression */
0x55,0x1D,0x25,                              /* [629] OBJ_ext_key_usage */
0x2B,0x06,0x01,0x05,0x05,0x07,               /* [632] OBJ_id_pkix */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,          /* [638] OBJ_id_kp */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x01,     /* [645] OBJ_server_auth */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x02,     /* [653] OBJ_client_auth */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x03,     /* [661] OBJ_code_sign */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x04,     /* [669] OBJ_email_protect */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x08,     /* [677] OBJ_time_stamp */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x02,0x01,0x15,/* [685] OBJ_ms_code_ind */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x02,0x01,0x16,/* [695] OBJ_ms_code_com */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x0A,0x03,0x01,/* [705] OBJ_ms_ctl_sign */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x0A,0x03,0x03,/* [715] OBJ_ms_sgc */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x0A,0x03,0x04,/* [725] OBJ_ms_efs */
0x60,0x86,0x48,0x01,0x86,0xF8,0x42,0x04,0x01,/* [735] OBJ_ns_sgc */
0x55,0x1D,0x1B,                              /* [744] OBJ_delta_crl */
0x55,0x1D,0x15,                              /* [747] OBJ_crl_reason */
0x55,0x1D,0x18,                              /* [750] OBJ_invalidity_date */
0x2B,0x65,0x01,0x04,0x01,                    /* [753] OBJ_sxnet */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x01,/* [758] OBJ_pbe_WithSHA1And128BitRC4 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x02,/* [768] OBJ_pbe_WithSHA1And40BitRC4 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x03,/* [778] OBJ_pbe_WithSHA1And3_Key_TripleDES_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x04,/* [788] OBJ_pbe_WithSHA1And2_Key_TripleDES_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x05,/* [798] OBJ_pbe_WithSHA1And128BitRC2_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x01,0x06,/* [808] OBJ_pbe_WithSHA1And40BitRC2_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x01,/* [818] OBJ_keyBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x02,/* [829] OBJ_pkcs8ShroudedKeyBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x03,/* [840] OBJ_certBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x04,/* [851] OBJ_crlBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x05,/* [862] OBJ_secretBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x0C,0x0A,0x01,0x06,/* [873] OBJ_safeContentsBag */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x14,/* [884] OBJ_friendlyName */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x15,/* [893] OBJ_localKeyID */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x16,0x01,/* [902] OBJ_x509Certificate */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x16,0x02,/* [912] OBJ_sdsiCertificate */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x17,0x01,/* [922] OBJ_x509Crl */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x0D,/* [932] OBJ_pbes2 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x0E,/* [941] OBJ_pbmac1 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x02,0x07,     /* [950] OBJ_hmacWithSHA1 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x02,0x01,     /* [958] OBJ_id_qt_cps */
0x2B,0x06,0x01,0x05,0x05,0x07,0x02,0x02,     /* [966] OBJ_id_qt_unotice */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x0F,/* [974] OBJ_SMIMECapabilities */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x04,/* [983] OBJ_pbeWithMD2AndRC2_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x06,/* [992] OBJ_pbeWithMD5AndRC2_CBC */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,0x0A,/* [1001] OBJ_pbeWithSHA1AndDES_CBC */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x02,0x01,0x0E,/* [1010] OBJ_ms_ext_req */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x0E,/* [1020] OBJ_ext_req */
0x55,0x04,0x29,                              /* [1029] OBJ_name */
0x55,0x04,0x2E,                              /* [1032] OBJ_dnQualifier */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,          /* [1035] OBJ_id_pe */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,          /* [1042] OBJ_id_ad */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x01,     /* [1049] OBJ_info_access */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,     /* [1057] OBJ_ad_OCSP */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x02,     /* [1065] OBJ_ad_ca_issuers */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x09,     /* [1073] OBJ_OCSP_sign */
0x28,                                        /* [1081] OBJ_iso */
0x2A,                                        /* [1082] OBJ_member_body */
0x2A,0x86,0x48,                              /* [1083] OBJ_ISO_US */
0x2A,0x86,0x48,0xCE,0x38,                    /* [1086] OBJ_X9_57 */
0x2A,0x86,0x48,0xCE,0x38,0x04,               /* [1091] OBJ_X9cm */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,     /* [1097] OBJ_pkcs1 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x05,     /* [1105] OBJ_pkcs5 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,/* [1113] OBJ_SMIME */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,/* [1122] OBJ_id_smime_mod */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,/* [1132] OBJ_id_smime_ct */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,/* [1142] OBJ_id_smime_aa */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,/* [1152] OBJ_id_smime_alg */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x04,/* [1162] OBJ_id_smime_cd */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x05,/* [1172] OBJ_id_smime_spq */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,/* [1182] OBJ_id_smime_cti */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x01,/* [1192] OBJ_id_smime_mod_cms */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x02,/* [1203] OBJ_id_smime_mod_ess */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x03,/* [1214] OBJ_id_smime_mod_oid */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x04,/* [1225] OBJ_id_smime_mod_msg_v3 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x05,/* [1236] OBJ_id_smime_mod_ets_eSignature_88 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x06,/* [1247] OBJ_id_smime_mod_ets_eSignature_97 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x07,/* [1258] OBJ_id_smime_mod_ets_eSigPolicy_88 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x00,0x08,/* [1269] OBJ_id_smime_mod_ets_eSigPolicy_97 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x01,/* [1280] OBJ_id_smime_ct_receipt */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x02,/* [1291] OBJ_id_smime_ct_authData */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x03,/* [1302] OBJ_id_smime_ct_publishCert */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x04,/* [1313] OBJ_id_smime_ct_TSTInfo */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x05,/* [1324] OBJ_id_smime_ct_TDTInfo */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x06,/* [1335] OBJ_id_smime_ct_contentInfo */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x07,/* [1346] OBJ_id_smime_ct_DVCSRequestData */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x01,0x08,/* [1357] OBJ_id_smime_ct_DVCSResponseData */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x01,/* [1368] OBJ_id_smime_aa_receiptRequest */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x02,/* [1379] OBJ_id_smime_aa_securityLabel */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x03,/* [1390] OBJ_id_smime_aa_mlExpandHistory */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x04,/* [1401] OBJ_id_smime_aa_contentHint */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x05,/* [1412] OBJ_id_smime_aa_msgSigDigest */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x06,/* [1423] OBJ_id_smime_aa_encapContentType */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x07,/* [1434] OBJ_id_smime_aa_contentIdentifier */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x08,/* [1445] OBJ_id_smime_aa_macValue */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x09,/* [1456] OBJ_id_smime_aa_equivalentLabels */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0A,/* [1467] OBJ_id_smime_aa_contentReference */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0B,/* [1478] OBJ_id_smime_aa_encrypKeyPref */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0C,/* [1489] OBJ_id_smime_aa_signingCertificate */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0D,/* [1500] OBJ_id_smime_aa_smimeEncryptCerts */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0E,/* [1511] OBJ_id_smime_aa_timeStampToken */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x0F,/* [1522] OBJ_id_smime_aa_ets_sigPolicyId */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x10,/* [1533] OBJ_id_smime_aa_ets_commitmentType */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x11,/* [1544] OBJ_id_smime_aa_ets_signerLocation */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x12,/* [1555] OBJ_id_smime_aa_ets_signerAttr */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x13,/* [1566] OBJ_id_smime_aa_ets_otherSigCert */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x14,/* [1577] OBJ_id_smime_aa_ets_contentTimestamp */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x15,/* [1588] OBJ_id_smime_aa_ets_CertificateRefs */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x16,/* [1599] OBJ_id_smime_aa_ets_RevocationRefs */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x17,/* [1610] OBJ_id_smime_aa_ets_certValues */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x18,/* [1621] OBJ_id_smime_aa_ets_revocationValues */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x19,/* [1632] OBJ_id_smime_aa_ets_escTimeStamp */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x1A,/* [1643] OBJ_id_smime_aa_ets_certCRLTimestamp */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x1B,/* [1654] OBJ_id_smime_aa_ets_archiveTimeStamp */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x1C,/* [1665] OBJ_id_smime_aa_signatureType */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x02,0x1D,/* [1676] OBJ_id_smime_aa_dvcs_dvc */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x01,/* [1687] OBJ_id_smime_alg_ESDHwith3DES */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x02,/* [1698] OBJ_id_smime_alg_ESDHwithRC2 */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x03,/* [1709] OBJ_id_smime_alg_3DESwrap */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x04,/* [1720] OBJ_id_smime_alg_RC2wrap */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x05,/* [1731] OBJ_id_smime_alg_ESDH */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x06,/* [1742] OBJ_id_smime_alg_CMS3DESwrap */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x03,0x07,/* [1753] OBJ_id_smime_alg_CMSRC2wrap */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x04,0x01,/* [1764] OBJ_id_smime_cd_ldap */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x05,0x01,/* [1775] OBJ_id_smime_spq_ets_sqt_uri */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x05,0x02,/* [1786] OBJ_id_smime_spq_ets_sqt_unotice */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x01,/* [1797] OBJ_id_smime_cti_ets_proofOfOrigin */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x02,/* [1808] OBJ_id_smime_cti_ets_proofOfReceipt */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x03,/* [1819] OBJ_id_smime_cti_ets_proofOfDelivery */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x04,/* [1830] OBJ_id_smime_cti_ets_proofOfSender */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x05,/* [1841] OBJ_id_smime_cti_ets_proofOfApproval */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x09,0x10,0x06,0x06,/* [1852] OBJ_id_smime_cti_ets_proofOfCreation */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x02,0x04,     /* [1863] OBJ_md4 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,          /* [1871] OBJ_id_pkix_mod */
0x2B,0x06,0x01,0x05,0x05,0x07,0x02,          /* [1878] OBJ_id_qt */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,          /* [1885] OBJ_id_it */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,          /* [1892] OBJ_id_pkip */
0x2B,0x06,0x01,0x05,0x05,0x07,0x06,          /* [1899] OBJ_id_alg */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,          /* [1906] OBJ_id_cmc */
0x2B,0x06,0x01,0x05,0x05,0x07,0x08,          /* [1913] OBJ_id_on */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,          /* [1920] OBJ_id_pda */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,          /* [1927] OBJ_id_aca */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0B,          /* [1934] OBJ_id_qcs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0C,          /* [1941] OBJ_id_cct */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x01,     /* [1948] OBJ_id_pkix1_explicit_88 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x02,     /* [1956] OBJ_id_pkix1_implicit_88 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x03,     /* [1964] OBJ_id_pkix1_explicit_93 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x04,     /* [1972] OBJ_id_pkix1_implicit_93 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x05,     /* [1980] OBJ_id_mod_crmf */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x06,     /* [1988] OBJ_id_mod_cmc */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x07,     /* [1996] OBJ_id_mod_kea_profile_88 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x08,     /* [2004] OBJ_id_mod_kea_profile_93 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x09,     /* [2012] OBJ_id_mod_cmp */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0A,     /* [2020] OBJ_id_mod_qualified_cert_88 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0B,     /* [2028] OBJ_id_mod_qualified_cert_93 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0C,     /* [2036] OBJ_id_mod_attribute_cert */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0D,     /* [2044] OBJ_id_mod_timestamp_protocol */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0E,     /* [2052] OBJ_id_mod_ocsp */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x0F,     /* [2060] OBJ_id_mod_dvcs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x00,0x10,     /* [2068] OBJ_id_mod_cmp2000 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x02,     /* [2076] OBJ_biometricInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x03,     /* [2084] OBJ_qcStatements */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x04,     /* [2092] OBJ_ac_auditEntity */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x05,     /* [2100] OBJ_ac_targeting */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x06,     /* [2108] OBJ_aaControls */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x07,     /* [2116] OBJ_sbgp_ipAddrBlock */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x08,     /* [2124] OBJ_sbgp_autonomousSysNum */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x09,     /* [2132] OBJ_sbgp_routerIdentifier */
0x2B,0x06,0x01,0x05,0x05,0x07,0x02,0x03,     /* [2140] OBJ_textNotice */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x05,     /* [2148] OBJ_ipsecEndSystem */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x06,     /* [2156] OBJ_ipsecTunnel */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x07,     /* [2164] OBJ_ipsecUser */
0x2B,0x06,0x01,0x05,0x05,0x07,0x03,0x0A,     /* [2172] OBJ_dvcs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x01,     /* [2180] OBJ_id_it_caProtEncCert */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x02,     /* [2188] OBJ_id_it_signKeyPairTypes */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x03,     /* [2196] OBJ_id_it_encKeyPairTypes */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x04,     /* [2204] OBJ_id_it_preferredSymmAlg */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x05,     /* [2212] OBJ_id_it_caKeyUpdateInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x06,     /* [2220] OBJ_id_it_currentCRL */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x07,     /* [2228] OBJ_id_it_unsupportedOIDs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x08,     /* [2236] OBJ_id_it_subscriptionRequest */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x09,     /* [2244] OBJ_id_it_subscriptionResponse */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0A,     /* [2252] OBJ_id_it_keyPairParamReq */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0B,     /* [2260] OBJ_id_it_keyPairParamRep */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0C,     /* [2268] OBJ_id_it_revPassphrase */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0D,     /* [2276] OBJ_id_it_implicitConfirm */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0E,     /* [2284] OBJ_id_it_confirmWaitTime */
0x2B,0x06,0x01,0x05,0x05,0x07,0x04,0x0F,     /* [2292] OBJ_id_it_origPKIMessage */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,     /* [2300] OBJ_id_regCtrl */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x02,     /* [2308] OBJ_id_regInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x01,/* [2316] OBJ_id_regCtrl_regToken */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x02,/* [2325] OBJ_id_regCtrl_authenticator */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x03,/* [2334] OBJ_id_regCtrl_pkiPublicationInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x04,/* [2343] OBJ_id_regCtrl_pkiArchiveOptions */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x05,/* [2352] OBJ_id_regCtrl_oldCertID */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x01,0x06,/* [2361] OBJ_id_regCtrl_protocolEncrKey */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x02,0x01,/* [2370] OBJ_id_regInfo_utf8Pairs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x05,0x02,0x02,/* [2379] OBJ_id_regInfo_certReq */
0x2B,0x06,0x01,0x05,0x05,0x07,0x06,0x01,     /* [2388] OBJ_id_alg_des40 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x06,0x02,     /* [2396] OBJ_id_alg_noSignature */
0x2B,0x06,0x01,0x05,0x05,0x07,0x06,0x03,     /* [2404] OBJ_id_alg_dh_sig_hmac_sha1 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x06,0x04,     /* [2412] OBJ_id_alg_dh_pop */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x01,     /* [2420] OBJ_id_cmc_statusInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x02,     /* [2428] OBJ_id_cmc_identification */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x03,     /* [2436] OBJ_id_cmc_identityProof */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x04,     /* [2444] OBJ_id_cmc_dataReturn */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x05,     /* [2452] OBJ_id_cmc_transactionId */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x06,     /* [2460] OBJ_id_cmc_senderNonce */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x07,     /* [2468] OBJ_id_cmc_recipientNonce */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x08,     /* [2476] OBJ_id_cmc_addExtensions */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x09,     /* [2484] OBJ_id_cmc_encryptedPOP */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x0A,     /* [2492] OBJ_id_cmc_decryptedPOP */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x0B,     /* [2500] OBJ_id_cmc_lraPOPWitness */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x0F,     /* [2508] OBJ_id_cmc_getCert */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x10,     /* [2516] OBJ_id_cmc_getCRL */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x11,     /* [2524] OBJ_id_cmc_revokeRequest */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x12,     /* [2532] OBJ_id_cmc_regInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x13,     /* [2540] OBJ_id_cmc_responseInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x15,     /* [2548] OBJ_id_cmc_queryPending */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x16,     /* [2556] OBJ_id_cmc_popLinkRandom */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x17,     /* [2564] OBJ_id_cmc_popLinkWitness */
0x2B,0x06,0x01,0x05,0x05,0x07,0x07,0x18,     /* [2572] OBJ_id_cmc_confirmCertAcceptance */
0x2B,0x06,0x01,0x05,0x05,0x07,0x08,0x01,     /* [2580] OBJ_id_on_personalData */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,0x01,     /* [2588] OBJ_id_pda_dateOfBirth */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,0x02,     /* [2596] OBJ_id_pda_placeOfBirth */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,0x03,     /* [2604] OBJ_id_pda_gender */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,0x04,     /* [2612] OBJ_id_pda_countryOfCitizenship */
0x2B,0x06,0x01,0x05,0x05,0x07,0x09,0x05,     /* [2620] OBJ_id_pda_countryOfResidence */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x01,     /* [2628] OBJ_id_aca_authenticationInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x02,     /* [2636] OBJ_id_aca_accessIdentity */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x03,     /* [2644] OBJ_id_aca_chargingIdentity */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x04,     /* [2652] OBJ_id_aca_group */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x05,     /* [2660] OBJ_id_aca_role */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0B,0x01,     /* [2668] OBJ_id_qcs_pkixQCSyntax_v1 */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0C,0x01,     /* [2676] OBJ_id_cct_crs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0C,0x02,     /* [2684] OBJ_id_cct_PKIData */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0C,0x03,     /* [2692] OBJ_id_cct_PKIResponse */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x03,     /* [2700] OBJ_ad_timeStamping */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x04,     /* [2708] OBJ_ad_dvcs */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x01,/* [2716] OBJ_id_pkix_OCSP_basic */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x02,/* [2725] OBJ_id_pkix_OCSP_Nonce */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x03,/* [2734] OBJ_id_pkix_OCSP_CrlID */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x04,/* [2743] OBJ_id_pkix_OCSP_acceptableResponses */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x05,/* [2752] OBJ_id_pkix_OCSP_noCheck */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x06,/* [2761] OBJ_id_pkix_OCSP_archiveCutoff */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x07,/* [2770] OBJ_id_pkix_OCSP_serviceLocator */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x08,/* [2779] OBJ_id_pkix_OCSP_extendedStatus */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x09,/* [2788] OBJ_id_pkix_OCSP_valid */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x0A,/* [2797] OBJ_id_pkix_OCSP_path */
0x2B,0x06,0x01,0x05,0x05,0x07,0x30,0x01,0x0B,/* [2806] OBJ_id_pkix_OCSP_trustRoot */
0x2B,0x0E,0x03,0x02,                         /* [2815] OBJ_algorithm */
0x2B,0x0E,0x03,0x02,0x0B,                    /* [2819] OBJ_rsaSignature */
0x55,0x08,                                   /* [2824] OBJ_X500algorithms */
0x2B,                                        /* [2826] OBJ_org */
0x2B,0x06,                                   /* [2827] OBJ_dod */
0x2B,0x06,0x01,                              /* [2829] OBJ_iana */
0x2B,0x06,0x01,0x01,                         /* [2832] OBJ_Directory */
0x2B,0x06,0x01,0x02,                         /* [2836] OBJ_Management */
0x2B,0x06,0x01,0x03,                         /* [2840] OBJ_Experimental */
0x2B,0x06,0x01,0x04,                         /* [2844] OBJ_Private */
0x2B,0x06,0x01,0x05,                         /* [2848] OBJ_Security */
0x2B,0x06,0x01,0x06,                         /* [2852] OBJ_SNMPv2 */
0x2B,0x06,0x01,0x07,                         /* [2856] OBJ_Mail */
0x2B,0x06,0x01,0x04,0x01,                    /* [2860] OBJ_Enterprises */
0x2B,0x06,0x01,0x04,0x01,0x8B,0x3A,0x82,0x58,/* [2865] OBJ_dcObject */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x19,/* [2874] OBJ_domainComponent */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x0D,/* [2884] OBJ_Domain */
0x00,                                        /* [2894] OBJ_joint_iso_ccitt */
0x55,0x01,0x05,                              /* [2895] OBJ_selected_attribute_types */
0x55,0x01,0x05,0x37,                         /* [2898] OBJ_clearance */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x03,/* [2902] OBJ_md4WithRSAEncryption */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x0A,     /* [2911] OBJ_ac_proxying */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x0B,     /* [2919] OBJ_sinfo_access */
0x2B,0x06,0x01,0x05,0x05,0x07,0x0A,0x06,     /* [2927] OBJ_id_aca_encAttrs */
0x55,0x04,0x48,                              /* [2935] OBJ_role */
0x55,0x1D,0x24,                              /* [2938] OBJ_policy_constraints */
0x55,0x1D,0x37,                              /* [2941] OBJ_target_information */
0x55,0x1D,0x38,                              /* [2944] OBJ_no_rev_avail */
0x00,                                        /* [2947] OBJ_ccitt */
0x2A,0x86,0x48,0xCE,0x3D,                    /* [2948] OBJ_ansi_X9_62 */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x01,          /* [2953] OBJ_X9_62_prime_field */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x02,          /* [2960] OBJ_X9_62_characteristic_two_field */
0x2A,0x86,0x48,0xCE,0x3D,0x02,0x01,          /* [2967] OBJ_X9_62_id_ecPublicKey */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x01,     /* [2974] OBJ_X9_62_prime192v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x02,     /* [2982] OBJ_X9_62_prime192v2 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x03,     /* [2990] OBJ_X9_62_prime192v3 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x04,     /* [2998] OBJ_X9_62_prime239v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x05,     /* [3006] OBJ_X9_62_prime239v2 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x06,     /* [3014] OBJ_X9_62_prime239v3 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x01,0x07,     /* [3022] OBJ_X9_62_prime256v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x04,0x01,          /* [3030] OBJ_ecdsa_with_SHA1 */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x11,0x01,/* [3037] OBJ_ms_csp_name */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x01,/* [3046] OBJ_aes_128_ecb */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x02,/* [3055] OBJ_aes_128_cbc */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x03,/* [3064] OBJ_aes_128_ofb128 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x04,/* [3073] OBJ_aes_128_cfb128 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x15,/* [3082] OBJ_aes_192_ecb */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x16,/* [3091] OBJ_aes_192_cbc */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x17,/* [3100] OBJ_aes_192_ofb128 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x18,/* [3109] OBJ_aes_192_cfb128 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x29,/* [3118] OBJ_aes_256_ecb */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x2A,/* [3127] OBJ_aes_256_cbc */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x2B,/* [3136] OBJ_aes_256_ofb128 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x01,0x2C,/* [3145] OBJ_aes_256_cfb128 */
0x55,0x1D,0x17,                              /* [3154] OBJ_hold_instruction_code */
0x2A,0x86,0x48,0xCE,0x38,0x02,0x01,          /* [3157] OBJ_hold_instruction_none */
0x2A,0x86,0x48,0xCE,0x38,0x02,0x02,          /* [3164] OBJ_hold_instruction_call_issuer */
0x2A,0x86,0x48,0xCE,0x38,0x02,0x03,          /* [3171] OBJ_hold_instruction_reject */
0x09,                                        /* [3178] OBJ_data */
0x09,0x92,0x26,                              /* [3179] OBJ_pss */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,          /* [3182] OBJ_ucl */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,     /* [3189] OBJ_pilot */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,/* [3197] OBJ_pilotAttributeType */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x03,/* [3206] OBJ_pilotAttributeSyntax */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,/* [3215] OBJ_pilotObjectClass */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x0A,/* [3224] OBJ_pilotGroups */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x03,0x04,/* [3233] OBJ_iA5StringSyntax */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x03,0x05,/* [3243] OBJ_caseIgnoreIA5StringSyntax */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x03,/* [3253] OBJ_pilotObject */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x04,/* [3263] OBJ_pilotPerson */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x05,/* [3273] OBJ_account */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x06,/* [3283] OBJ_document */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x07,/* [3293] OBJ_room */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x09,/* [3303] OBJ_documentSeries */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x0E,/* [3313] OBJ_rFC822localPart */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x0F,/* [3323] OBJ_dNSDomain */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x11,/* [3333] OBJ_domainRelatedObject */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x12,/* [3343] OBJ_friendlyCountry */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x13,/* [3353] OBJ_simpleSecurityObject */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x14,/* [3363] OBJ_pilotOrganization */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x15,/* [3373] OBJ_pilotDSA */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x04,0x16,/* [3383] OBJ_qualityLabelledData */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x01,/* [3393] OBJ_userId */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x02,/* [3403] OBJ_textEncodedORAddress */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x03,/* [3413] OBJ_rfc822Mailbox */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x04,/* [3423] OBJ_info */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x05,/* [3433] OBJ_favouriteDrink */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x06,/* [3443] OBJ_roomNumber */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x07,/* [3453] OBJ_photo */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x08,/* [3463] OBJ_userClass */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x09,/* [3473] OBJ_host */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0A,/* [3483] OBJ_manager */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0B,/* [3493] OBJ_documentIdentifier */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0C,/* [3503] OBJ_documentTitle */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0D,/* [3513] OBJ_documentVersion */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0E,/* [3523] OBJ_documentAuthor */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x0F,/* [3533] OBJ_documentLocation */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x14,/* [3543] OBJ_homeTelephoneNumber */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x15,/* [3553] OBJ_secretary */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x16,/* [3563] OBJ_otherMailbox */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x17,/* [3573] OBJ_lastModifiedTime */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x18,/* [3583] OBJ_lastModifiedBy */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1A,/* [3593] OBJ_aRecord */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1B,/* [3603] OBJ_pilotAttributeType27 */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1C,/* [3613] OBJ_mXRecord */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1D,/* [3623] OBJ_nSRecord */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1E,/* [3633] OBJ_sOARecord */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x1F,/* [3643] OBJ_cNAMERecord */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x25,/* [3653] OBJ_associatedDomain */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x26,/* [3663] OBJ_associatedName */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x27,/* [3673] OBJ_homePostalAddress */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x28,/* [3683] OBJ_personalTitle */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x29,/* [3693] OBJ_mobileTelephoneNumber */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x2A,/* [3703] OBJ_pagerTelephoneNumber */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x2B,/* [3713] OBJ_friendlyCountryName */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x2D,/* [3723] OBJ_organizationalStatus */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x2E,/* [3733] OBJ_janetMailbox */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x2F,/* [3743] OBJ_mailPreferenceOption */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x30,/* [3753] OBJ_buildingName */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x31,/* [3763] OBJ_dSAQuality */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x32,/* [3773] OBJ_singleLevelQuality */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x33,/* [3783] OBJ_subtreeMinimumQuality */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x34,/* [3793] OBJ_subtreeMaximumQuality */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x35,/* [3803] OBJ_personalSignature */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x36,/* [3813] OBJ_dITRedirect */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x37,/* [3823] OBJ_audio */
0x09,0x92,0x26,0x89,0x93,0xF2,0x2C,0x64,0x01,0x38,/* [3833] OBJ_documentPublisher */
0x55,0x04,0x2D,                              /* [3843] OBJ_x500UniqueIdentifier */
0x2B,0x06,0x01,0x07,0x01,                    /* [3846] OBJ_mime_mhs */
0x2B,0x06,0x01,0x07,0x01,0x01,               /* [3851] OBJ_mime_mhs_headings */
0x2B,0x06,0x01,0x07,0x01,0x02,               /* [3857] OBJ_mime_mhs_bodies */
0x2B,0x06,0x01,0x07,0x01,0x01,0x01,          /* [3863] OBJ_id_hex_partial_message */
0x2B,0x06,0x01,0x07,0x01,0x01,0x02,          /* [3870] OBJ_id_hex_multipart_message */
0x55,0x04,0x2C,                              /* [3877] OBJ_generationQualifier */
0x55,0x04,0x41,                              /* [3880] OBJ_pseudonym */
0x67,0x2A,                                   /* [3883] OBJ_id_set */
0x67,0x2A,0x00,                              /* [3885] OBJ_set_ctype */
0x67,0x2A,0x01,                              /* [3888] OBJ_set_msgExt */
0x67,0x2A,0x03,                              /* [3891] OBJ_set_attr */
0x67,0x2A,0x05,                              /* [3894] OBJ_set_policy */
0x67,0x2A,0x07,                              /* [3897] OBJ_set_certExt */
0x67,0x2A,0x08,                              /* [3900] OBJ_set_brand */
0x67,0x2A,0x00,0x00,                         /* [3903] OBJ_setct_PANData */
0x67,0x2A,0x00,0x01,                         /* [3907] OBJ_setct_PANToken */
0x67,0x2A,0x00,0x02,                         /* [3911] OBJ_setct_PANOnly */
0x67,0x2A,0x00,0x03,                         /* [3915] OBJ_setct_OIData */
0x67,0x2A,0x00,0x04,                         /* [3919] OBJ_setct_PI */
0x67,0x2A,0x00,0x05,                         /* [3923] OBJ_setct_PIData */
0x67,0x2A,0x00,0x06,                         /* [3927] OBJ_setct_PIDataUnsigned */
0x67,0x2A,0x00,0x07,                         /* [3931] OBJ_setct_HODInput */
0x67,0x2A,0x00,0x08,                         /* [3935] OBJ_setct_AuthResBaggage */
0x67,0x2A,0x00,0x09,                         /* [3939] OBJ_setct_AuthRevReqBaggage */
0x67,0x2A,0x00,0x0A,                         /* [3943] OBJ_setct_AuthRevResBaggage */
0x67,0x2A,0x00,0x0B,                         /* [3947] OBJ_setct_CapTokenSeq */
0x67,0x2A,0x00,0x0C,                         /* [3951] OBJ_setct_PInitResData */
0x67,0x2A,0x00,0x0D,                         /* [3955] OBJ_setct_PI_TBS */
0x67,0x2A,0x00,0x0E,                         /* [3959] OBJ_setct_PResData */
0x67,0x2A,0x00,0x10,                         /* [3963] OBJ_setct_AuthReqTBS */
0x67,0x2A,0x00,0x11,                         /* [3967] OBJ_setct_AuthResTBS */
0x67,0x2A,0x00,0x12,                         /* [3971] OBJ_setct_AuthResTBSX */
0x67,0x2A,0x00,0x13,                         /* [3975] OBJ_setct_AuthTokenTBS */
0x67,0x2A,0x00,0x14,                         /* [3979] OBJ_setct_CapTokenData */
0x67,0x2A,0x00,0x15,                         /* [3983] OBJ_setct_CapTokenTBS */
0x67,0x2A,0x00,0x16,                         /* [3987] OBJ_setct_AcqCardCodeMsg */
0x67,0x2A,0x00,0x17,                         /* [3991] OBJ_setct_AuthRevReqTBS */
0x67,0x2A,0x00,0x18,                         /* [3995] OBJ_setct_AuthRevResData */
0x67,0x2A,0x00,0x19,                         /* [3999] OBJ_setct_AuthRevResTBS */
0x67,0x2A,0x00,0x1A,                         /* [4003] OBJ_setct_CapReqTBS */
0x67,0x2A,0x00,0x1B,                         /* [4007] OBJ_setct_CapReqTBSX */
0x67,0x2A,0x00,0x1C,                         /* [4011] OBJ_setct_CapResData */
0x67,0x2A,0x00,0x1D,                         /* [4015] OBJ_setct_CapRevReqTBS */
0x67,0x2A,0x00,0x1E,                         /* [4019] OBJ_setct_CapRevReqTBSX */
0x67,0x2A,0x00,0x1F,                         /* [4023] OBJ_setct_CapRevResData */
0x67,0x2A,0x00,0x20,                         /* [4027] OBJ_setct_CredReqTBS */
0x67,0x2A,0x00,0x21,                         /* [4031] OBJ_setct_CredReqTBSX */
0x67,0x2A,0x00,0x22,                         /* [4035] OBJ_setct_CredResData */
0x67,0x2A,0x00,0x23,                         /* [4039] OBJ_setct_CredRevReqTBS */
0x67,0x2A,0x00,0x24,                         /* [4043] OBJ_setct_CredRevReqTBSX */
0x67,0x2A,0x00,0x25,                         /* [4047] OBJ_setct_CredRevResData */
0x67,0x2A,0x00,0x26,                         /* [4051] OBJ_setct_PCertReqData */
0x67,0x2A,0x00,0x27,                         /* [4055] OBJ_setct_PCertResTBS */
0x67,0x2A,0x00,0x28,                         /* [4059] OBJ_setct_BatchAdminReqData */
0x67,0x2A,0x00,0x29,                         /* [4063] OBJ_setct_BatchAdminResData */
0x67,0x2A,0x00,0x2A,                         /* [4067] OBJ_setct_CardCInitResTBS */
0x67,0x2A,0x00,0x2B,                         /* [4071] OBJ_setct_MeAqCInitResTBS */
0x67,0x2A,0x00,0x2C,                         /* [4075] OBJ_setct_RegFormResTBS */
0x67,0x2A,0x00,0x2D,                         /* [4079] OBJ_setct_CertReqData */
0x67,0x2A,0x00,0x2E,                         /* [4083] OBJ_setct_CertReqTBS */
0x67,0x2A,0x00,0x2F,                         /* [4087] OBJ_setct_CertResData */
0x67,0x2A,0x00,0x30,                         /* [4091] OBJ_setct_CertInqReqTBS */
0x67,0x2A,0x00,0x31,                         /* [4095] OBJ_setct_ErrorTBS */
0x67,0x2A,0x00,0x32,                         /* [4099] OBJ_setct_PIDualSignedTBE */
0x67,0x2A,0x00,0x33,                         /* [4103] OBJ_setct_PIUnsignedTBE */
0x67,0x2A,0x00,0x34,                         /* [4107] OBJ_setct_AuthReqTBE */
0x67,0x2A,0x00,0x35,                         /* [4111] OBJ_setct_AuthResTBE */
0x67,0x2A,0x00,0x36,                         /* [4115] OBJ_setct_AuthResTBEX */
0x67,0x2A,0x00,0x37,                         /* [4119] OBJ_setct_AuthTokenTBE */
0x67,0x2A,0x00,0x38,                         /* [4123] OBJ_setct_CapTokenTBE */
0x67,0x2A,0x00,0x39,                         /* [4127] OBJ_setct_CapTokenTBEX */
0x67,0x2A,0x00,0x3A,                         /* [4131] OBJ_setct_AcqCardCodeMsgTBE */
0x67,0x2A,0x00,0x3B,                         /* [4135] OBJ_setct_AuthRevReqTBE */
0x67,0x2A,0x00,0x3C,                         /* [4139] OBJ_setct_AuthRevResTBE */
0x67,0x2A,0x00,0x3D,                         /* [4143] OBJ_setct_AuthRevResTBEB */
0x67,0x2A,0x00,0x3E,                         /* [4147] OBJ_setct_CapReqTBE */
0x67,0x2A,0x00,0x3F,                         /* [4151] OBJ_setct_CapReqTBEX */
0x67,0x2A,0x00,0x40,                         /* [4155] OBJ_setct_CapResTBE */
0x67,0x2A,0x00,0x41,                         /* [4159] OBJ_setct_CapRevReqTBE */
0x67,0x2A,0x00,0x42,                         /* [4163] OBJ_setct_CapRevReqTBEX */
0x67,0x2A,0x00,0x43,                         /* [4167] OBJ_setct_CapRevResTBE */
0x67,0x2A,0x00,0x44,                         /* [4171] OBJ_setct_CredReqTBE */
0x67,0x2A,0x00,0x45,                         /* [4175] OBJ_setct_CredReqTBEX */
0x67,0x2A,0x00,0x46,                         /* [4179] OBJ_setct_CredResTBE */
0x67,0x2A,0x00,0x47,                         /* [4183] OBJ_setct_CredRevReqTBE */
0x67,0x2A,0x00,0x48,                         /* [4187] OBJ_setct_CredRevReqTBEX */
0x67,0x2A,0x00,0x49,                         /* [4191] OBJ_setct_CredRevResTBE */
0x67,0x2A,0x00,0x4A,                         /* [4195] OBJ_setct_BatchAdminReqTBE */
0x67,0x2A,0x00,0x4B,                         /* [4199] OBJ_setct_BatchAdminResTBE */
0x67,0x2A,0x00,0x4C,                         /* [4203] OBJ_setct_RegFormReqTBE */
0x67,0x2A,0x00,0x4D,                         /* [4207] OBJ_setct_CertReqTBE */
0x67,0x2A,0x00,0x4E,                         /* [4211] OBJ_setct_CertReqTBEX */
0x67,0x2A,0x00,0x4F,                         /* [4215] OBJ_setct_CertResTBE */
0x67,0x2A,0x00,0x50,                         /* [4219] OBJ_setct_CRLNotificationTBS */
0x67,0x2A,0x00,0x51,                         /* [4223] OBJ_setct_CRLNotificationResTBS */
0x67,0x2A,0x00,0x52,                         /* [4227] OBJ_setct_BCIDistributionTBS */
0x67,0x2A,0x01,0x01,                         /* [4231] OBJ_setext_genCrypt */
0x67,0x2A,0x01,0x03,                         /* [4235] OBJ_setext_miAuth */
0x67,0x2A,0x01,0x04,                         /* [4239] OBJ_setext_pinSecure */
0x67,0x2A,0x01,0x05,                         /* [4243] OBJ_setext_pinAny */
0x67,0x2A,0x01,0x07,                         /* [4247] OBJ_setext_track2 */
0x67,0x2A,0x01,0x08,                         /* [4251] OBJ_setext_cv */
0x67,0x2A,0x05,0x00,                         /* [4255] OBJ_set_policy_root */
0x67,0x2A,0x07,0x00,                         /* [4259] OBJ_setCext_hashedRoot */
0x67,0x2A,0x07,0x01,                         /* [4263] OBJ_setCext_certType */
0x67,0x2A,0x07,0x02,                         /* [4267] OBJ_setCext_merchData */
0x67,0x2A,0x07,0x03,                         /* [4271] OBJ_setCext_cCertRequired */
0x67,0x2A,0x07,0x04,                         /* [4275] OBJ_setCext_tunneling */
0x67,0x2A,0x07,0x05,                         /* [4279] OBJ_setCext_setExt */
0x67,0x2A,0x07,0x06,                         /* [4283] OBJ_setCext_setQualf */
0x67,0x2A,0x07,0x07,                         /* [4287] OBJ_setCext_PGWYcapabilities */
0x67,0x2A,0x07,0x08,                         /* [4291] OBJ_setCext_TokenIdentifier */
0x67,0x2A,0x07,0x09,                         /* [4295] OBJ_setCext_Track2Data */
0x67,0x2A,0x07,0x0A,                         /* [4299] OBJ_setCext_TokenType */
0x67,0x2A,0x07,0x0B,                         /* [4303] OBJ_setCext_IssuerCapabilities */
0x67,0x2A,0x03,0x00,                         /* [4307] OBJ_setAttr_Cert */
0x67,0x2A,0x03,0x01,                         /* [4311] OBJ_setAttr_PGWYcap */
0x67,0x2A,0x03,0x02,                         /* [4315] OBJ_setAttr_TokenType */
0x67,0x2A,0x03,0x03,                         /* [4319] OBJ_setAttr_IssCap */
0x67,0x2A,0x03,0x00,0x00,                    /* [4323] OBJ_set_rootKeyThumb */
0x67,0x2A,0x03,0x00,0x01,                    /* [4328] OBJ_set_addPolicy */
0x67,0x2A,0x03,0x02,0x01,                    /* [4333] OBJ_setAttr_Token_EMV */
0x67,0x2A,0x03,0x02,0x02,                    /* [4338] OBJ_setAttr_Token_B0Prime */
0x67,0x2A,0x03,0x03,0x03,                    /* [4343] OBJ_setAttr_IssCap_CVM */
0x67,0x2A,0x03,0x03,0x04,                    /* [4348] OBJ_setAttr_IssCap_T2 */
0x67,0x2A,0x03,0x03,0x05,                    /* [4353] OBJ_setAttr_IssCap_Sig */
0x67,0x2A,0x03,0x03,0x03,0x01,               /* [4358] OBJ_setAttr_GenCryptgrm */
0x67,0x2A,0x03,0x03,0x04,0x01,               /* [4364] OBJ_setAttr_T2Enc */
0x67,0x2A,0x03,0x03,0x04,0x02,               /* [4370] OBJ_setAttr_T2cleartxt */
0x67,0x2A,0x03,0x03,0x05,0x01,               /* [4376] OBJ_setAttr_TokICCsig */
0x67,0x2A,0x03,0x03,0x05,0x02,               /* [4382] OBJ_setAttr_SecDevSig */
0x67,0x2A,0x08,0x01,                         /* [4388] OBJ_set_brand_IATA_ATA */
0x67,0x2A,0x08,0x1E,                         /* [4392] OBJ_set_brand_Diners */
0x67,0x2A,0x08,0x22,                         /* [4396] OBJ_set_brand_AmericanExpress */
0x67,0x2A,0x08,0x23,                         /* [4400] OBJ_set_brand_JCB */
0x67,0x2A,0x08,0x04,                         /* [4404] OBJ_set_brand_Visa */
0x67,0x2A,0x08,0x05,                         /* [4408] OBJ_set_brand_MasterCard */
0x67,0x2A,0x08,0xAE,0x7B,                    /* [4412] OBJ_set_brand_Novus */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x03,0x0A,     /* [4417] OBJ_des_cdmf */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x06,/* [4425] OBJ_rsaOAEPEncryptionSET */
0x00,                                        /* [4434] OBJ_itu_t */
0x50,                                        /* [4435] OBJ_joint_iso_itu_t */
0x67,                                        /* [4436] OBJ_international_organizations */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x14,0x02,0x02,/* [4437] OBJ_ms_smartcard_login */
0x2B,0x06,0x01,0x04,0x01,0x82,0x37,0x14,0x02,0x03,/* [4447] OBJ_ms_upn */
0x55,0x04,0x09,                              /* [4457] OBJ_streetAddress */
0x55,0x04,0x11,                              /* [4460] OBJ_postalCode */
0x2B,0x06,0x01,0x05,0x05,0x07,0x15,          /* [4463] OBJ_id_ppl */
0x2B,0x06,0x01,0x05,0x05,0x07,0x01,0x0E,     /* [4470] OBJ_proxyCertInfo */
0x2B,0x06,0x01,0x05,0x05,0x07,0x15,0x00,     /* [4478] OBJ_id_ppl_anyLanguage */
0x2B,0x06,0x01,0x05,0x05,0x07,0x15,0x01,     /* [4486] OBJ_id_ppl_inheritAll */
0x55,0x1D,0x1E,                              /* [4494] OBJ_name_constraints */
0x2B,0x06,0x01,0x05,0x05,0x07,0x15,0x02,     /* [4497] OBJ_Independent */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x0B,/* [4505] OBJ_sha256WithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x0C,/* [4514] OBJ_sha384WithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x0D,/* [4523] OBJ_sha512WithRSAEncryption */
0x2A,0x86,0x48,0x86,0xF7,0x0D,0x01,0x01,0x0E,/* [4532] OBJ_sha224WithRSAEncryption */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x01,/* [4541] OBJ_sha256 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x02,/* [4550] OBJ_sha384 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x03,/* [4559] OBJ_sha512 */
0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x04,/* [4568] OBJ_sha224 */
0x2B,                                        /* [4577] OBJ_identified_organization */
0x2B,0x81,0x04,                              /* [4578] OBJ_certicom_arc */
0x67,0x2B,                                   /* [4581] OBJ_wap */
0x67,0x2B,0x0D,                              /* [4583] OBJ_wap_wsg */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x02,0x03,     /* [4586] OBJ_X9_62_id_characteristic_two_basis */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x02,0x03,0x01,/* [4594] OBJ_X9_62_onBasis */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x02,0x03,0x02,/* [4603] OBJ_X9_62_tpBasis */
0x2A,0x86,0x48,0xCE,0x3D,0x01,0x02,0x03,0x03,/* [4612] OBJ_X9_62_ppBasis */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x01,     /* [4621] OBJ_X9_62_c2pnb163v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x02,     /* [4629] OBJ_X9_62_c2pnb163v2 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x03,     /* [4637] OBJ_X9_62_c2pnb163v3 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x04,     /* [4645] OBJ_X9_62_c2pnb176v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x05,     /* [4653] OBJ_X9_62_c2tnb191v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x06,     /* [4661] OBJ_X9_62_c2tnb191v2 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x07,     /* [4669] OBJ_X9_62_c2tnb191v3 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x08,     /* [4677] OBJ_X9_62_c2onb191v4 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x09,     /* [4685] OBJ_X9_62_c2onb191v5 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0A,     /* [4693] OBJ_X9_62_c2pnb208w1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0B,     /* [4701] OBJ_X9_62_c2tnb239v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0C,     /* [4709] OBJ_X9_62_c2tnb239v2 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0D,     /* [4717] OBJ_X9_62_c2tnb239v3 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0E,     /* [4725] OBJ_X9_62_c2onb239v4 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x0F,     /* [4733] OBJ_X9_62_c2onb239v5 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x10,     /* [4741] OBJ_X9_62_c2pnb272w1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x11,     /* [4749] OBJ_X9_62_c2pnb304w1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x12,     /* [4757] OBJ_X9_62_c2tnb359v1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x13,     /* [4765] OBJ_X9_62_c2pnb368w1 */
0x2A,0x86,0x48,0xCE,0x3D,0x03,0x00,0x14,     /* [4773] OBJ_X9_62_c2tnb431r1 */
0x2B,0x81,0x04,0x00,0x06,                    /* [4781] OBJ_secp112r1 */
0x2B,0x81,0x04,0x00,0x07,                    /* [4786] OBJ_secp112r2 */
0x2B,0x81,0x04,0x00,0x1C,                    /* [4791] OBJ_secp128r1 */
0x2B,0x81,0x04,0x00,0x1D,                    /* [4796] OBJ_secp128r2 */
0x2B,0x81,0x04,0x00,0x09,                    /* [4801] OBJ_secp160k1 */
0x2B,0x81,0x04,0x00,0x08,                    /* [4806] OBJ_secp160r1 */
0x2B,0x81,0x04,0x00,0x1E,                    /* [4811] OBJ_secp160r2 */
0x2B,0x81,0x04,0x00,0x1F,                    /* [4816] OBJ_secp192k1 */
0x2B,0x81,0x04,0x00,0x20,                    /* [4821] OBJ_secp224k1 */
0x2B,0x81,0x04,0x00,0x21,                    /* [4826] OBJ_secp224r1 */
0x2B,0x81,0x04,0x00,0x0A,                    /* [4831] OBJ_secp256k1 */
0x2B,0x81,0x04,0x00,0x22,                    /* [4836] OBJ_secp384r1 */
0x2B,0x81,0x04,0x00,0x23,                    /* [4841] OBJ_secp521r1 */
0x2B,0x81,0x04,0x00,0x04,                    /* [4846] OBJ_sect113r1 */
0x2B,0x81,0x04,0x00,0x05,                    /* [4851] OBJ_sect113r2 */
0x2B,0x81,0x04,0x00,0x16,                    /* [4856] OBJ_sect131r1 */
0x2B,0x81,0x04,0x00,0x17,                    /* [4861] OBJ_sect131r2 */
0x2B,0x81,0x04,0x00,0x01,                    /* [4866] OBJ_sect163k1 */
0x2B,0x81,0x04,0x00,0x02,                    /* [4871] OBJ_sect163r1 */
0x2B,0x81,0x04,0x00,0x0F,                    /* [4876] OBJ_sect163r2 */
0x2B,0x81,0x04,0x00,0x18,                    /* [4881] OBJ_sect193r1 */
0x2B,0x81,0x04,0x00,0x19,                    /* [4886] OBJ_sect193r2 */
0x2B,0x81,0x04,0x00,0x1A,                    /* [4891] OBJ_sect233k1 */
0x2B,0x81,0x04,0x00,0x1B,                    /* [4896] OBJ_sect233r1 */
0x2B,0x81,0x04,0x00,0x03,                    /* [4901] OBJ_sect239k1 */
0x2B,0x81,0x04,0x00,0x10,                    /* [4906] OBJ_sect283k1 */
0x2B,0x81,0x04,0x00,0x11,                    /* [4911] OBJ_sect283r1 */
0x2B,0x81,0x04,0x00,0x24,                    /* [4916] OBJ_sect409k1 */
0x2B,0x81,0x04,0x00,0x25,                    /* [4921] OBJ_sect409r1 */
0x2B,0x81,0x04,0x00,0x26,                    /* [4926] OBJ_sect571k1 */
0x2B,0x81,0x04,0x00,0x27,                    /* [4931] OBJ_sect571r1 */
0x67,0x2B,0x0D,0x04,0x01,                    /* [4936] OBJ_wap_wsg_idm_ecid_wtls1 */
0x67,0x2B,0x0D,0x04,0x03,                    /* [4941] OBJ_wap_wsg_idm_ecid_wtls3 */
0x67,0x2B,0x0D,0x04,0x04,                    /* [4946] OBJ_wap_wsg_idm_ecid_wtls4 */
0x67,0x2B,0x0D,0x04,0x05,                    /* [4951] OBJ_wap_wsg_idm_ecid_wtls5 */
0x67,0x2B,0x0D,0x04,0x06,                    /* [4956] OBJ_wap_wsg_idm_ecid_wtls6 */
0x67,0x2B,0x0D,0x04,0x07,                    /* [4961] OBJ_wap_wsg_idm_ecid_wtls7 */
0x67,0x2B,0x0D,0x04,0x08,                    /* [4966] OBJ_wap_wsg_idm_ecid_wtls8 */
0x67,0x2B,0x0D,0x04,0x09,                    /* [4971] OBJ_wap_wsg_idm_ecid_wtls9 */
0x67,0x2B,0x0D,0x04,0x0A,                    /* [4976] OBJ_wap_wsg_idm_ecid_wtls10 */
0x67,0x2B,0x0D,0x04,0x0B,                    /* [4981] OBJ_wap_wsg_idm_ecid_wtls11 */
0x67,0x2B,0x0D,0x04,0x0C,                    /* [4986] OBJ_wap_wsg_idm_ecid_wtls12 */
0x55,0x1D,0x20,0x00,                         /* [4991] OBJ_any_policy */
0x55,0x1D,0x21,                              /* [4995] OBJ_policy_mappings */
0x55,0x1D,0x36,                              /* [4998] OBJ_inhibit_any_policy */
0x2A,0x83,0x08,0x8C,0x9A,0x4B,0x3D,0x01,0x01,0x01,0x02,/* [5001] OBJ_camellia_128_cbc */
0x2A,0x83,0x08,0x8C,0x9A,0x4B,0x3D,0x01,0x01,0x01,0x03,/* [5012] OBJ_camellia_192_cbc */
0x2A,0x83,0x08,0x8C,0x9A,0x4B,0x3D,0x01,0x01,0x01,0x04,/* [5023] OBJ_camellia_256_cbc */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x01,     /* [5034] OBJ_camellia_128_ecb */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x15,     /* [5042] OBJ_camellia_192_ecb */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x29,     /* [5050] OBJ_camellia_256_ecb */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x04,     /* [5058] OBJ_camellia_128_cfb128 */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x18,     /* [5066] OBJ_camellia_192_cfb128 */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x2C,     /* [5074] OBJ_camellia_256_cfb128 */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x03,     /* [5082] OBJ_camellia_128_ofb128 */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x17,     /* [5090] OBJ_camellia_192_ofb128 */
0x03,0xA2,0x31,0x05,0x03,0x01,0x09,0x2B,     /* [5098] OBJ_camellia_256_ofb128 */

################################################################################

TITLE
    RC2 skey key_table

TYPE
    8

DATA
	0xd9,0x78,0xf9,0xc4,0x19,0xdd,0xb5,0xed,0x28,0xe9,0xfd,0x79,
	0x4a,0xa0,0xd8,0x9d,0xc6,0x7e,0x37,0x83,0x2b,0x76,0x53,0x8e,
	0x62,0x4c,0x64,0x88,0x44,0x8b,0xfb,0xa2,0x17,0x9a,0x59,0xf5,
	0x87,0xb3,0x4f,0x13,0x61,0x45,0x6d,0x8d,0x09,0x81,0x7d,0x32,
	0xbd,0x8f,0x40,0xeb,0x86,0xb7,0x7b,0x0b,0xf0,0x95,0x21,0x22,
	0x5c,0x6b,0x4e,0x82,0x54,0xd6,0x65,0x93,0xce,0x60,0xb2,0x1c,
	0x73,0x56,0xc0,0x14,0xa7,0x8c,0xf1,0xdc,0x12,0x75,0xca,0x1f,
	0x3b,0xbe,0xe4,0xd1,0x42,0x3d,0xd4,0x30,0xa3,0x3c,0xb6,0x26,
	0x6f,0xbf,0x0e,0xda,0x46,0x69,0x07,0x57,0x27,0xf2,0x1d,0x9b,
	0xbc,0x94,0x43,0x03,0xf8,0x11,0xc7,0xf6,0x90,0xef,0x3e,0xe7,
	0x06,0xc3,0xd5,0x2f,0xc8,0x66,0x1e,0xd7,0x08,0xe8,0xea,0xde,
	0x80,0x52,0xee,0xf7,0x84,0xaa,0x72,0xac,0x35,0x4d,0x6a,0x2a,
	0x96,0x1a,0xd2,0x71,0x5a,0x15,0x49,0x74,0x4b,0x9f,0xd0,0x5e,
	0x04,0x18,0xa4,0xec,0xc2,0xe0,0x41,0x6e,0x0f,0x51,0xcb,0xcc,
	0x24,0x91,0xaf,0x50,0xa1,0xf4,0x70,0x39,0x99,0x7c,0x3a,0x85,
	0x23,0xb8,0xb4,0x7a,0xfc,0x02,0x36,0x5b,0x25,0x55,0x97,0x31,
	0x2d,0x5d,0xfa,0x98,0xe3,0x8a,0x92,0xae,0x05,0xdf,0x29,0x10,
	0x67,0x6c,0xba,0xc9,0xd3,0x00,0xe6,0xcf,0xe1,0x9e,0xa8,0x2c,
	0x63,0x16,0x01,0x3f,0x58,0xe2,0x89,0xa9,0x0d,0x38,0x34,0x1b,
	0xab,0x33,0xff,0xb0,0xbb,0x48,0x0c,0x5f,0xb9,0xb1,0xcd,0x2e,
	0xc5,0xf3,0xdb,0x47,0xe5,0xa5,0x9c,0x77,0x0a,0xa6,0x20,0x68,
	0xfe,0x7f,0xc1,0xad,

################################################################################

TITLE
    RC2 tab ebits to num

TYPE
    8

DATA
	0xbd,0x56,0xea,0xf2,0xa2,0xf1,0xac,0x2a,
	0xb0,0x93,0xd1,0x9c,0x1b,0x33,0xfd,0xd0,
	0x30,0x04,0xb6,0xdc,0x7d,0xdf,0x32,0x4b,
	0xf7,0xcb,0x45,0x9b,0x31,0xbb,0x21,0x5a,
	0x41,0x9f,0xe1,0xd9,0x4a,0x4d,0x9e,0xda,
	0xa0,0x68,0x2c,0xc3,0x27,0x5f,0x80,0x36,
	0x3e,0xee,0xfb,0x95,0x1a,0xfe,0xce,0xa8,
	0x34,0xa9,0x13,0xf0,0xa6,0x3f,0xd8,0x0c,
	0x78,0x24,0xaf,0x23,0x52,0xc1,0x67,0x17,
	0xf5,0x66,0x90,0xe7,0xe8,0x07,0xb8,0x60,
	0x48,0xe6,0x1e,0x53,0xf3,0x92,0xa4,0x72,
	0x8c,0x08,0x15,0x6e,0x86,0x00,0x84,0xfa,
	0xf4,0x7f,0x8a,0x42,0x19,0xf6,0xdb,0xcd,
	0x14,0x8d,0x50,0x12,0xba,0x3c,0x06,0x4e,
	0xec,0xb3,0x35,0x11,0xa1,0x88,0x8e,0x2b,
	0x94,0x99,0xb7,0x71,0x74,0xd3,0xe4,0xbf,
	0x3a,0xde,0x96,0x0e,0xbc,0x0a,0xed,0x77,
	0xfc,0x37,0x6b,0x03,0x79,0x89,0x62,0xc6,
	0xd7,0xc0,0xd2,0x7c,0x6a,0x8b,0x22,0xa3,
	0x5b,0x05,0x5d,0x02,0x75,0xd5,0x61,0xe3,
	0x18,0x8f,0x55,0x51,0xad,0x1f,0x0b,0x5e,
	0x85,0xe5,0xc2,0x57,0x63,0xca,0x3d,0x6c,
	0xb4,0xc5,0xcc,0x70,0xb2,0x91,0x59,0x0d,
	0x47,0x20,0xc8,0x4f,0x58,0xe0,0x01,0xe2,
	0x16,0x38,0xc4,0x6f,0x3b,0x0f,0x65,0x46,
	0xbe,0x7e,0x2d,0x7b,0x82,0xf9,0x40,0xb5,
	0x1d,0x73,0xf8,0xeb,0x26,0xc7,0x87,0x97,
	0x25,0x54,0xb1,0x28,0xaa,0x98,0x9d,0xa5,
	0x64,0x6d,0x7a,0xd4,0x10,0x81,0x44,0xef,
	0x49,0xd6,0xae,0x2e,0xdd,0x76,0x5c,0x2f,
	0xa7,0x1c,0xc9,0x09,0x69,0x9a,0x83,0xcf,
	0x29,0x39,0xb9,0xe9,0x4c,0xff,0x43,0xab,

################################################################################

TITLE
    RC2 tab num to ebits

TYPE
    8

DATA
	0x5d,0xbe,0x9b,0x8b,0x11,0x99,0x6e,0x4d,
	0x59,0xf3,0x85,0xa6,0x3f,0xb7,0x83,0xc5,
	0xe4,0x73,0x6b,0x3a,0x68,0x5a,0xc0,0x47,
	0xa0,0x64,0x34,0x0c,0xf1,0xd0,0x52,0xa5,
	0xb9,0x1e,0x96,0x43,0x41,0xd8,0xd4,0x2c,
	0xdb,0xf8,0x07,0x77,0x2a,0xca,0xeb,0xef,
	0x10,0x1c,0x16,0x0d,0x38,0x72,0x2f,0x89,
	0xc1,0xf9,0x80,0xc4,0x6d,0xae,0x30,0x3d,
	0xce,0x20,0x63,0xfe,0xe6,0x1a,0xc7,0xb8,
	0x50,0xe8,0x24,0x17,0xfc,0x25,0x6f,0xbb,
	0x6a,0xa3,0x44,0x53,0xd9,0xa2,0x01,0xab,
	0xbc,0xb6,0x1f,0x98,0xee,0x9a,0xa7,0x2d,
	0x4f,0x9e,0x8e,0xac,0xe0,0xc6,0x49,0x46,
	0x29,0xf4,0x94,0x8a,0xaf,0xe1,0x5b,0xc3,
	0xb3,0x7b,0x57,0xd1,0x7c,0x9c,0xed,0x87,
	0x40,0x8c,0xe2,0xcb,0x93,0x14,0xc9,0x61,
	0x2e,0xe5,0xcc,0xf6,0x5e,0xa8,0x5c,0xd6,
	0x75,0x8d,0x62,0x95,0x58,0x69,0x76,0xa1,
	0x4a,0xb5,0x55,0x09,0x78,0x33,0x82,0xd7,
	0xdd,0x79,0xf5,0x1b,0x0b,0xde,0x26,0x21,
	0x28,0x74,0x04,0x97,0x56,0xdf,0x3c,0xf0,
	0x37,0x39,0xdc,0xff,0x06,0xa4,0xea,0x42,
	0x08,0xda,0xb4,0x71,0xb0,0xcf,0x12,0x7a,
	0x4e,0xfa,0x6c,0x1d,0x84,0x00,0xc8,0x7f,
	0x91,0x45,0xaa,0x2b,0xc2,0xb1,0x8f,0xd5,
	0xba,0xf2,0xad,0x19,0xb2,0x67,0x36,0xf7,
	0x0f,0x0a,0x92,0x7d,0xe3,0x9d,0xe9,0x90,
	0x3e,0x23,0x27,0x66,0x13,0xec,0x81,0x15,
	0xbd,0x22,0xbf,0x9f,0x7e,0xa9,0x51,0x4b,
	0x4c,0xfb,0x02,0xd3,0x70,0x86,0x31,0xe7,
	0x3b,0x05,0x03,0x54,0x60,0x48,0x65,0x18,
	0xd2,0xcd,0x5f,0x32,0x88,0x0e,0x35,0xfd,

################################################################################

TITLE
    RC5 RC5_64_P and RC5_64_Q

TYPE
    64 AND

DATA
    0xB7E151628AED2A6BLL
    0x9E3779B97F4A7C15LL

################################################################################

TITLE
    RIPEMD

TYPE
    32 AND

DATA
    0x00000000L 0x5A827999L 0x6ED9EBA1L 0x8F1BBCDCL 0xA953FD4EL
    0x50A28BE6L 0x5C4DD124L 0x6D703EF3L 0x7A6D76E9L 0x00000000L
    0x67452301L 0xEFCDAB89L 0x98BADCFEL 0x10325476L 0xC3D2E1F0L

################################################################################

TITLE
    SHA224

TYPE
    32 AND

DATA
    0xc1059ed8UL   0x367cd507UL
    0x3070dd17UL   0xf70e5939UL
    0xffc00b31UL   0x68581511UL
    0x64f98fa7UL   0xbefa4fa4UL
    0x428a2f98UL,0x71374491UL,0xb5c0fbcfUL,0xe9b5dba5UL,
    0x3956c25bUL,0x59f111f1UL,0x923f82a4UL,0xab1c5ed5UL,
    0xd807aa98UL,0x12835b01UL,0x243185beUL,0x550c7dc3UL,
    0x72be5d74UL,0x80deb1feUL,0x9bdc06a7UL,0xc19bf174UL,
    0xe49b69c1UL,0xefbe4786UL,0x0fc19dc6UL,0x240ca1ccUL,
    0x2de92c6fUL,0x4a7484aaUL,0x5cb0a9dcUL,0x76f988daUL,
    0x983e5152UL,0xa831c66dUL,0xb00327c8UL,0xbf597fc7UL,
    0xc6e00bf3UL,0xd5a79147UL,0x06ca6351UL,0x14292967UL,
    0x27b70a85UL,0x2e1b2138UL,0x4d2c6dfcUL,0x53380d13UL,
    0x650a7354UL,0x766a0abbUL,0x81c2c92eUL,0x92722c85UL,
    0xa2bfe8a1UL,0xa81a664bUL,0xc24b8b70UL,0xc76c51a3UL,
    0xd192e819UL,0xd6990624UL,0xf40e3585UL,0x106aa070UL,
    0x19a4c116UL,0x1e376c08UL,0x2748774cUL,0x34b0bcb5UL,
    0x391c0cb3UL,0x4ed8aa4aUL,0x5b9cca4fUL,0x682e6ff3UL,
    0x748f82eeUL,0x78a5636fUL,0x84c87814UL,0x8cc70208UL,
    0x90befffaUL,0xa4506cebUL,0xbef9a3f7UL,0xc67178f2UL };

################################################################################

TITLE
    SHA256

TYPE
    32 AND

DATA
    0x6a09e667UL   0xbb67ae85UL
    0x3c6ef372UL   0xa54ff53aUL
    0x510e527fUL   0x9b05688cUL
    0x1f83d9abUL   0x5be0cd19UL
    0x428a2f98UL,0x71374491UL,0xb5c0fbcfUL,0xe9b5dba5UL,
    0x3956c25bUL,0x59f111f1UL,0x923f82a4UL,0xab1c5ed5UL,
    0xd807aa98UL,0x12835b01UL,0x243185beUL,0x550c7dc3UL,
    0x72be5d74UL,0x80deb1feUL,0x9bdc06a7UL,0xc19bf174UL,
    0xe49b69c1UL,0xefbe4786UL,0x0fc19dc6UL,0x240ca1ccUL,
    0x2de92c6fUL,0x4a7484aaUL,0x5cb0a9dcUL,0x76f988daUL,
    0x983e5152UL,0xa831c66dUL,0xb00327c8UL,0xbf597fc7UL,
    0xc6e00bf3UL,0xd5a79147UL,0x06ca6351UL,0x14292967UL,
    0x27b70a85UL,0x2e1b2138UL,0x4d2c6dfcUL,0x53380d13UL,
    0x650a7354UL,0x766a0abbUL,0x81c2c92eUL,0x92722c85UL,
    0xa2bfe8a1UL,0xa81a664bUL,0xc24b8b70UL,0xc76c51a3UL,
    0xd192e819UL,0xd6990624UL,0xf40e3585UL,0x106aa070UL,
    0x19a4c116UL,0x1e376c08UL,0x2748774cUL,0x34b0bcb5UL,
    0x391c0cb3UL,0x4ed8aa4aUL,0x5b9cca4fUL,0x682e6ff3UL,
    0x748f82eeUL,0x78a5636fUL,0x84c87814UL,0x8cc70208UL,
    0x90befffaUL,0xa4506cebUL,0xbef9a3f7UL,0xc67178f2UL };

################################################################################

TITLE
    SHA384

TYPE
    64 AND

DATA
    0xcbbb9d5dc1059ed8);
    0x629a292a367cd507);
    0x9159015a3070dd17);
    0x152fecd8f70e5939);
    0x67332667ffc00b31);
    0x8eb44a8768581511);
    0xdb0c2e0d64f98fa7);
    0x47b5481dbefa4fa4);

        0x428a2f98d728ae22 0x7137449123ef65cd 
        0xb5c0fbcfec4d3b2f 0xe9b5dba58189dbbc 
        0x3956c25bf348b538 0x59f111f1b605d019 
        0x923f82a4af194f9b 0xab1c5ed5da6d8118 
        0xd807aa98a3030242 0x12835b0145706fbe 
        0x243185be4ee4b28c 0x550c7dc3d5ffb4e2 
        0x72be5d74f27b896f 0x80deb1fe3b1696b1 
        0x9bdc06a725c71235 0xc19bf174cf692694 
        0xe49b69c19ef14ad2 0xefbe4786384f25e3 
        0x0fc19dc68b8cd5b5 0x240ca1cc77ac9c65 
        0x2de92c6f592b0275 0x4a7484aa6ea6e483 
        0x5cb0a9dcbd41fbd4 0x76f988da831153b5 
        0x983e5152ee66dfab 0xa831c66d2db43210 
        0xb00327c898fb213f 0xbf597fc7beef0ee4 
        0xc6e00bf33da88fc2 0xd5a79147930aa725 
        0x06ca6351e003826f 0x142929670a0e6e70 
        0x27b70a8546d22ffc 0x2e1b21385c26c926 
        0x4d2c6dfc5ac42aed 0x53380d139d95b3df 
        0x650a73548baf63de 0x766a0abb3c77b2a8 
        0x81c2c92e47edaee6 0x92722c851482353b 
        0xa2bfe8a14cf10364 0xa81a664bbc423001 
        0xc24b8b70d0f89791 0xc76c51a30654be30 
        0xd192e819d6ef5218 0xd69906245565a910 
        0xf40e35855771202a 0x106aa07032bbd1b8 
        0x19a4c116b8d2d0c8 0x1e376c085141ab53 
        0x2748774cdf8eeb99 0x34b0bcb5e19b48a8 
        0x391c0cb3c5c95a63 0x4ed8aa4ae3418acb 
        0x5b9cca4f7763e373 0x682e6ff3d6b2b8a3 
        0x748f82ee5defb2fc 0x78a5636f43172f60 
        0x84c87814a1f0ab72 0x8cc702081a6439ec 
        0x90befffa23631e28 0xa4506cebde82bde9 
        0xbef9a3f7b2c67915 0xc67178f2e372532b 
        0xca273eceea26619c 0xd186b8c721c0c207 
        0xeada7dd6cde0eb1e 0xf57d4f7fee6ed178 
        0x06f067aa72176fba 0x0a637dc5a2c898a6 
        0x113f9804bef90dae 0x1b710b35131c471b 
        0x28db77f523047d84 0x32caab7b40c72493 
        0x3c9ebe0a15c9bebc 0x431d67c49c100d4c 
        0x4cc5d4becb3e42b6 0x597f299cfc657e2a 
        0x5fcb6fab3ad6faec 0x6c44198c4a475817

################################################################################

TITLE
    SHA512

TYPE
    64 AND

DATA
    0x6a09e667f3bcc908);
    0xbb67ae8584caa73b);
    0x3c6ef372fe94f82b);
    0xa54ff53a5f1d36f1);
    0x510e527fade682d1);
    0x9b05688c2b3e6c1f);
    0x1f83d9abfb41bd6b);
    0x5be0cd19137e2179);

        0x428a2f98d728ae22 0x7137449123ef65cd 
        0xb5c0fbcfec4d3b2f 0xe9b5dba58189dbbc 
        0x3956c25bf348b538 0x59f111f1b605d019 
        0x923f82a4af194f9b 0xab1c5ed5da6d8118 
        0xd807aa98a3030242 0x12835b0145706fbe 
        0x243185be4ee4b28c 0x550c7dc3d5ffb4e2 
        0x72be5d74f27b896f 0x80deb1fe3b1696b1 
        0x9bdc06a725c71235 0xc19bf174cf692694 
        0xe49b69c19ef14ad2 0xefbe4786384f25e3 
        0x0fc19dc68b8cd5b5 0x240ca1cc77ac9c65 
        0x2de92c6f592b0275 0x4a7484aa6ea6e483 
        0x5cb0a9dcbd41fbd4 0x76f988da831153b5 
        0x983e5152ee66dfab 0xa831c66d2db43210 
        0xb00327c898fb213f 0xbf597fc7beef0ee4 
        0xc6e00bf33da88fc2 0xd5a79147930aa725 
        0x06ca6351e003826f 0x142929670a0e6e70 
        0x27b70a8546d22ffc 0x2e1b21385c26c926 
        0x4d2c6dfc5ac42aed 0x53380d139d95b3df 
        0x650a73548baf63de 0x766a0abb3c77b2a8 
        0x81c2c92e47edaee6 0x92722c851482353b 
        0xa2bfe8a14cf10364 0xa81a664bbc423001 
        0xc24b8b70d0f89791 0xc76c51a30654be30 
        0xd192e819d6ef5218 0xd69906245565a910 
        0xf40e35855771202a 0x106aa07032bbd1b8 
        0x19a4c116b8d2d0c8 0x1e376c085141ab53 
        0x2748774cdf8eeb99 0x34b0bcb5e19b48a8 
        0x391c0cb3c5c95a63 0x4ed8aa4ae3418acb 
        0x5b9cca4f7763e373 0x682e6ff3d6b2b8a3 
        0x748f82ee5defb2fc 0x78a5636f43172f60 
        0x84c87814a1f0ab72 0x8cc702081a6439ec 
        0x90befffa23631e28 0xa4506cebde82bde9 
        0xbef9a3f7b2c67915 0xc67178f2e372532b 
        0xca273eceea26619c 0xd186b8c721c0c207 
        0xeada7dd6cde0eb1e 0xf57d4f7fee6ed178 
        0x06f067aa72176fba 0x0a637dc5a2c898a6 
        0x113f9804bef90dae 0x1b710b35131c471b 
        0x28db77f523047d84 0x32caab7b40c72493 
        0x3c9ebe0a15c9bebc 0x431d67c49c100d4c 
        0x4cc5d4becb3e42b6 0x597f299cfc657e2a 
        0x5fcb6fab3ad6faec 0x6c44198c4a475817

################################################################################

TITLE
    SHA1 / SHA0 / RIPEMD-160 initialization

TYPE
    32 AND

DATA
    0x67452301UL    0xefcdab89UL    0x98badcfeUL    0x10325476UL    0xc3d2e1f0UL
//    0x5a827999UL    0x6ed9eba1UL    0x8f1bbcdcUL    0xca62c1d6UL

################################################################################

TITLE
    padding used in hashing algorithms (0x80 0 ... 0)

TYPE
    8

DATA
 0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

################################################################################

TITLE
    SSL3 pad 1 and 2

TYPE
    8

DATA
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
	0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36 };

	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,
	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,
	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,
	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,
	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,
	0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c }

################################################################################

TITLE
    SSL3 #define

TYPE
    32 AND

DATA
    0x03000001
    0x03000002
    0x03000003
    0x03000004
    0x03000005
    0x03000006
    0x03000007
    0x03000008
    0x03000009
    0x0300000A
    0x0300000B
    0x0300000C
    0x0300000D
    0x0300000E
    0x0300000F
    0x03000010
    0x03000011
    0x03000012
    0x03000013
    0x03000014
    0x03000015
    0x03000016
    0x03000017
    0x03000018
    0x03000019
    0x0300001A
    0x0300001B
    0x0300001C
    0x0300001D
    0x0300001E
    0x0300001E
    0x0300001F
    0x03000020
    0x03000021
    0x03000022
    0x03000023
    0x03000024
    0x03000025
    0x03000026
    0x03000027
    0x03000028
    0x03000029
    0x0300002A
    0x0300002B

################################################################################

TITLE
    SSL2 #define

TYPE
    32 AND

DATA
    0x02000000 /* v3 */
    0x02010080
    0x02020080
    0x02030080
    0x02040080
    0x02050080
    0x02060040
    0x02060140 /* v3 */
    0x020700c0
    0x020701c0 /* v3 */
    0x02080080 /* MS hack */
    0x02ff0800 /* SSLeay */
    0x02ff0810 /* SSLeay */

################################################################################

TITLE
    Tiger

TYPE
    64

DATA
    0x02AAB17CF7E90C5ELL   /*    0 */,    0xAC424B03E243A8ECLL   /*    1 */,
    0x72CD5BE30DD5FCD3LL   /*    2 */,    0x6D019B93F6F97F3ALL   /*    3 */,
    0xCD9978FFD21F9193LL   /*    4 */,    0x7573A1C9708029E2LL   /*    5 */,
    0xB164326B922A83C3LL   /*    6 */,    0x46883EEE04915870LL   /*    7 */,
    0xEAACE3057103ECE6LL   /*    8 */,    0xC54169B808A3535CLL   /*    9 */,
    0x4CE754918DDEC47CLL   /*   10 */,    0x0AA2F4DFDC0DF40CLL   /*   11 */,
    0x10B76F18A74DBEFALL   /*   12 */,    0xC6CCB6235AD1AB6ALL   /*   13 */,
    0x13726121572FE2FFLL   /*   14 */,    0x1A488C6F199D921ELL   /*   15 */,
    0x4BC9F9F4DA0007CALL   /*   16 */,    0x26F5E6F6E85241C7LL   /*   17 */,
    0x859079DBEA5947B6LL   /*   18 */,    0x4F1885C5C99E8C92LL   /*   19 */,
    0xD78E761EA96F864BLL   /*   20 */,    0x8E36428C52B5C17DLL   /*   21 */,
    0x69CF6827373063C1LL   /*   22 */,    0xB607C93D9BB4C56ELL   /*   23 */,
    0x7D820E760E76B5EALL   /*   24 */,    0x645C9CC6F07FDC42LL   /*   25 */,
    0xBF38A078243342E0LL   /*   26 */,    0x5F6B343C9D2E7D04LL   /*   27 */,
    0xF2C28AEB600B0EC6LL   /*   28 */,    0x6C0ED85F7254BCACLL   /*   29 */,
    0x71592281A4DB4FE5LL   /*   30 */,    0x1967FA69CE0FED9FLL   /*   31 */,
    0xFD5293F8B96545DBLL   /*   32 */,    0xC879E9D7F2A7600BLL   /*   33 */,
    0x860248920193194ELL   /*   34 */,    0xA4F9533B2D9CC0B3LL   /*   35 */,
    0x9053836C15957613LL   /*   36 */,    0xDB6DCF8AFC357BF1LL   /*   37 */,
    0x18BEEA7A7A370F57LL   /*   38 */,    0x037117CA50B99066LL   /*   39 */,
    0x6AB30A9774424A35LL   /*   40 */,    0xF4E92F02E325249BLL   /*   41 */,
    0x7739DB07061CCAE1LL   /*   42 */,    0xD8F3B49CECA42A05LL   /*   43 */,
    0xBD56BE3F51382F73LL   /*   44 */,    0x45FAED5843B0BB28LL   /*   45 */,
    0x1C813D5C11BF1F83LL   /*   46 */,    0x8AF0E4B6D75FA169LL   /*   47 */,
    0x33EE18A487AD9999LL   /*   48 */,    0x3C26E8EAB1C94410LL   /*   49 */,
    0xB510102BC0A822F9LL   /*   50 */,    0x141EEF310CE6123BLL   /*   51 */,
    0xFC65B90059DDB154LL   /*   52 */,    0xE0158640C5E0E607LL   /*   53 */,
    0x884E079826C3A3CFLL   /*   54 */,    0x930D0D9523C535FDLL   /*   55 */,
    0x35638D754E9A2B00LL   /*   56 */,    0x4085FCCF40469DD5LL   /*   57 */,
    0xC4B17AD28BE23A4CLL   /*   58 */,    0xCAB2F0FC6A3E6A2ELL   /*   59 */,
    0x2860971A6B943FCDLL   /*   60 */,    0x3DDE6EE212E30446LL   /*   61 */,
    0x6222F32AE01765AELL   /*   62 */,    0x5D550BB5478308FELL   /*   63 */,
    0xA9EFA98DA0EDA22ALL   /*   64 */,    0xC351A71686C40DA7LL   /*   65 */,
    0x1105586D9C867C84LL   /*   66 */,    0xDCFFEE85FDA22853LL   /*   67 */,
    0xCCFBD0262C5EEF76LL   /*   68 */,    0xBAF294CB8990D201LL   /*   69 */,
    0xE69464F52AFAD975LL   /*   70 */,    0x94B013AFDF133E14LL   /*   71 */,
    0x06A7D1A32823C958LL   /*   72 */,    0x6F95FE5130F61119LL   /*   73 */,
    0xD92AB34E462C06C0LL   /*   74 */,    0xED7BDE33887C71D2LL   /*   75 */,
    0x79746D6E6518393ELL   /*   76 */,    0x5BA419385D713329LL   /*   77 */,
    0x7C1BA6B948A97564LL   /*   78 */,    0x31987C197BFDAC67LL   /*   79 */,
    0xDE6C23C44B053D02LL   /*   80 */,    0x581C49FED002D64DLL   /*   81 */,
    0xDD474D6338261571LL   /*   82 */,    0xAA4546C3E473D062LL   /*   83 */,
    0x928FCE349455F860LL   /*   84 */,    0x48161BBACAAB94D9LL   /*   85 */,
    0x63912430770E6F68LL   /*   86 */,    0x6EC8A5E602C6641CLL   /*   87 */,
    0x87282515337DDD2BLL   /*   88 */,    0x2CDA6B42034B701BLL   /*   89 */,
    0xB03D37C181CB096DLL   /*   90 */,    0xE108438266C71C6FLL   /*   91 */,
    0x2B3180C7EB51B255LL   /*   92 */,    0xDF92B82F96C08BBCLL   /*   93 */,
    0x5C68C8C0A632F3BALL   /*   94 */,    0x5504CC861C3D0556LL   /*   95 */,
    0xABBFA4E55FB26B8FLL   /*   96 */,    0x41848B0AB3BACEB4LL   /*   97 */,
    0xB334A273AA445D32LL   /*   98 */,    0xBCA696F0A85AD881LL   /*   99 */,
    0x24F6EC65B528D56CLL   /*  100 */,    0x0CE1512E90F4524ALL   /*  101 */,
    0x4E9DD79D5506D35ALL   /*  102 */,    0x258905FAC6CE9779LL   /*  103 */,
    0x2019295B3E109B33LL   /*  104 */,    0xF8A9478B73A054CCLL   /*  105 */,
    0x2924F2F934417EB0LL   /*  106 */,    0x3993357D536D1BC4LL   /*  107 */,
    0x38A81AC21DB6FF8BLL   /*  108 */,    0x47C4FBF17D6016BFLL   /*  109 */,
    0x1E0FAADD7667E3F5LL   /*  110 */,    0x7ABCFF62938BEB96LL   /*  111 */,
    0xA78DAD948FC179C9LL   /*  112 */,    0x8F1F98B72911E50DLL   /*  113 */,
    0x61E48EAE27121A91LL   /*  114 */,    0x4D62F7AD31859808LL   /*  115 */,
    0xECEBA345EF5CEAEBLL   /*  116 */,    0xF5CEB25EBC9684CELL   /*  117 */,
    0xF633E20CB7F76221LL   /*  118 */,    0xA32CDF06AB8293E4LL   /*  119 */,
    0x985A202CA5EE2CA4LL   /*  120 */,    0xCF0B8447CC8A8FB1LL   /*  121 */,
    0x9F765244979859A3LL   /*  122 */,    0xA8D516B1A1240017LL   /*  123 */,
    0x0BD7BA3EBB5DC726LL   /*  124 */,    0xE54BCA55B86ADB39LL   /*  125 */,
    0x1D7A3AFD6C478063LL   /*  126 */,    0x519EC608E7669EDDLL   /*  127 */,
    0x0E5715A2D149AA23LL   /*  128 */,    0x177D4571848FF194LL   /*  129 */,
    0xEEB55F3241014C22LL   /*  130 */,    0x0F5E5CA13A6E2EC2LL   /*  131 */,
    0x8029927B75F5C361LL   /*  132 */,    0xAD139FABC3D6E436LL   /*  133 */,
    0x0D5DF1A94CCF402FLL   /*  134 */,    0x3E8BD948BEA5DFC8LL   /*  135 */,
    0xA5A0D357BD3FF77ELL   /*  136 */,    0xA2D12E251F74F645LL   /*  137 */,
    0x66FD9E525E81A082LL   /*  138 */,    0x2E0C90CE7F687A49LL   /*  139 */,
    0xC2E8BCBEBA973BC5LL   /*  140 */,    0x000001BCE509745FLL   /*  141 */,
    0x423777BBE6DAB3D6LL   /*  142 */,    0xD1661C7EAEF06EB5LL   /*  143 */,
    0xA1781F354DAACFD8LL   /*  144 */,    0x2D11284A2B16AFFCLL   /*  145 */,
    0xF1FC4F67FA891D1FLL   /*  146 */,    0x73ECC25DCB920ADALL   /*  147 */,
    0xAE610C22C2A12651LL   /*  148 */,    0x96E0A810D356B78ALL   /*  149 */,
    0x5A9A381F2FE7870FLL   /*  150 */,    0xD5AD62EDE94E5530LL   /*  151 */,
    0xD225E5E8368D1427LL   /*  152 */,    0x65977B70C7AF4631LL   /*  153 */,
    0x99F889B2DE39D74FLL   /*  154 */,    0x233F30BF54E1D143LL   /*  155 */,
    0x9A9675D3D9A63C97LL   /*  156 */,    0x5470554FF334F9A8LL   /*  157 */,
    0x166ACB744A4F5688LL   /*  158 */,    0x70C74CAAB2E4AEADLL   /*  159 */,
    0xF0D091646F294D12LL   /*  160 */,    0x57B82A89684031D1LL   /*  161 */,
    0xEFD95A5A61BE0B6BLL   /*  162 */,    0x2FBD12E969F2F29ALL   /*  163 */,
    0x9BD37013FEFF9FE8LL   /*  164 */,    0x3F9B0404D6085A06LL   /*  165 */,
    0x4940C1F3166CFE15LL   /*  166 */,    0x09542C4DCDF3DEFBLL   /*  167 */,
    0xB4C5218385CD5CE3LL   /*  168 */,    0xC935B7DC4462A641LL   /*  169 */,
    0x3417F8A68ED3B63FLL   /*  170 */,    0xB80959295B215B40LL   /*  171 */,
    0xF99CDAEF3B8C8572LL   /*  172 */,    0x018C0614F8FCB95DLL   /*  173 */,
    0x1B14ACCD1A3ACDF3LL   /*  174 */,    0x84D471F200BB732DLL   /*  175 */,
    0xC1A3110E95E8DA16LL   /*  176 */,    0x430A7220BF1A82B8LL   /*  177 */,
    0xB77E090D39DF210ELL   /*  178 */,    0x5EF4BD9F3CD05E9DLL   /*  179 */,
    0x9D4FF6DA7E57A444LL   /*  180 */,    0xDA1D60E183D4A5F8LL   /*  181 */,
    0xB287C38417998E47LL   /*  182 */,    0xFE3EDC121BB31886LL   /*  183 */,
    0xC7FE3CCC980CCBEFLL   /*  184 */,    0xE46FB590189BFD03LL   /*  185 */,
    0x3732FD469A4C57DCLL   /*  186 */,    0x7EF700A07CF1AD65LL   /*  187 */,
    0x59C64468A31D8859LL   /*  188 */,    0x762FB0B4D45B61F6LL   /*  189 */,
    0x155BAED099047718LL   /*  190 */,    0x68755E4C3D50BAA6LL   /*  191 */,
    0xE9214E7F22D8B4DFLL   /*  192 */,    0x2ADDBF532EAC95F4LL   /*  193 */,
    0x32AE3909B4BD0109LL   /*  194 */,    0x834DF537B08E3450LL   /*  195 */,
    0xFA209DA84220728DLL   /*  196 */,    0x9E691D9B9EFE23F7LL   /*  197 */,
    0x0446D288C4AE8D7FLL   /*  198 */,    0x7B4CC524E169785BLL   /*  199 */,
    0x21D87F0135CA1385LL   /*  200 */,    0xCEBB400F137B8AA5LL   /*  201 */,
    0x272E2B66580796BELL   /*  202 */,    0x3612264125C2B0DELL   /*  203 */,
    0x057702BDAD1EFBB2LL   /*  204 */,    0xD4BABB8EACF84BE9LL   /*  205 */,
    0x91583139641BC67BLL   /*  206 */,    0x8BDC2DE08036E024LL   /*  207 */,
    0x603C8156F49F68EDLL   /*  208 */,    0xF7D236F7DBEF5111LL   /*  209 */,
    0x9727C4598AD21E80LL   /*  210 */,    0xA08A0896670A5FD7LL   /*  211 */,
    0xCB4A8F4309EBA9CBLL   /*  212 */,    0x81AF564B0F7036A1LL   /*  213 */,
    0xC0B99AA778199ABDLL   /*  214 */,    0x959F1EC83FC8E952LL   /*  215 */,
    0x8C505077794A81B9LL   /*  216 */,    0x3ACAAF8F056338F0LL   /*  217 */,
    0x07B43F50627A6778LL   /*  218 */,    0x4A44AB49F5ECCC77LL   /*  219 */,
    0x3BC3D6E4B679EE98LL   /*  220 */,    0x9CC0D4D1CF14108CLL   /*  221 */,
    0x4406C00B206BC8A0LL   /*  222 */,    0x82A18854C8D72D89LL   /*  223 */,
    0x67E366B35C3C432CLL   /*  224 */,    0xB923DD61102B37F2LL   /*  225 */,
    0x56AB2779D884271DLL   /*  226 */,    0xBE83E1B0FF1525AFLL   /*  227 */,
    0xFB7C65D4217E49A9LL   /*  228 */,    0x6BDBE0E76D48E7D4LL   /*  229 */,
    0x08DF828745D9179ELL   /*  230 */,    0x22EA6A9ADD53BD34LL   /*  231 */,
    0xE36E141C5622200ALL   /*  232 */,    0x7F805D1B8CB750EELL   /*  233 */,
    0xAFE5C7A59F58E837LL   /*  234 */,    0xE27F996A4FB1C23CLL   /*  235 */,
    0xD3867DFB0775F0D0LL   /*  236 */,    0xD0E673DE6E88891ALL   /*  237 */,
    0x123AEB9EAFB86C25LL   /*  238 */,    0x30F1D5D5C145B895LL   /*  239 */,
    0xBB434A2DEE7269E7LL   /*  240 */,    0x78CB67ECF931FA38LL   /*  241 */,
    0xF33B0372323BBF9CLL   /*  242 */,    0x52D66336FB279C74LL   /*  243 */,
    0x505F33AC0AFB4EAALL   /*  244 */,    0xE8A5CD99A2CCE187LL   /*  245 */,
    0x534974801E2D30BBLL   /*  246 */,    0x8D2D5711D5876D90LL   /*  247 */,
    0x1F1A412891BC038ELL   /*  248 */,    0xD6E2E71D82E56648LL   /*  249 */,
    0x74036C3A497732B7LL   /*  250 */,    0x89B67ED96361F5ABLL   /*  251 */,
    0xFFED95D8F1EA02A2LL   /*  252 */,    0xE72B3BD61464D43DLL   /*  253 */,
    0xA6300F170BDC4820LL   /*  254 */,    0xEBC18760ED78A77ALL   /*  255 */,
    0xE6A6BE5A05A12138LL   /*  256 */,    0xB5A122A5B4F87C98LL   /*  257 */,
    0x563C6089140B6990LL   /*  258 */,    0x4C46CB2E391F5DD5LL   /*  259 */,
    0xD932ADDBC9B79434LL   /*  260 */,    0x08EA70E42015AFF5LL   /*  261 */,
    0xD765A6673E478CF1LL   /*  262 */,    0xC4FB757EAB278D99LL   /*  263 */,
    0xDF11C6862D6E0692LL   /*  264 */,    0xDDEB84F10D7F3B16LL   /*  265 */,
    0x6F2EF604A665EA04LL   /*  266 */,    0x4A8E0F0FF0E0DFB3LL   /*  267 */,
    0xA5EDEEF83DBCBA51LL   /*  268 */,    0xFC4F0A2A0EA4371ELL   /*  269 */,
    0xE83E1DA85CB38429LL   /*  270 */,    0xDC8FF882BA1B1CE2LL   /*  271 */,
    0xCD45505E8353E80DLL   /*  272 */,    0x18D19A00D4DB0717LL   /*  273 */,
    0x34A0CFEDA5F38101LL   /*  274 */,    0x0BE77E518887CAF2LL   /*  275 */,
    0x1E341438B3C45136LL   /*  276 */,    0xE05797F49089CCF9LL   /*  277 */,
    0xFFD23F9DF2591D14LL   /*  278 */,    0x543DDA228595C5CDLL   /*  279 */,
    0x661F81FD99052A33LL   /*  280 */,    0x8736E641DB0F7B76LL   /*  281 */,
    0x15227725418E5307LL   /*  282 */,    0xE25F7F46162EB2FALL   /*  283 */,
    0x48A8B2126C13D9FELL   /*  284 */,    0xAFDC541792E76EEALL   /*  285 */,
    0x03D912BFC6D1898FLL   /*  286 */,    0x31B1AAFA1B83F51BLL   /*  287 */,
    0xF1AC2796E42AB7D9LL   /*  288 */,    0x40A3A7D7FCD2EBACLL   /*  289 */,
    0x1056136D0AFBBCC5LL   /*  290 */,    0x7889E1DD9A6D0C85LL   /*  291 */,
    0xD33525782A7974AALL   /*  292 */,    0xA7E25D09078AC09BLL   /*  293 */,
    0xBD4138B3EAC6EDD0LL   /*  294 */,    0x920ABFBE71EB9E70LL   /*  295 */,
    0xA2A5D0F54FC2625CLL   /*  296 */,    0xC054E36B0B1290A3LL   /*  297 */,
    0xF6DD59FF62FE932BLL   /*  298 */,    0x3537354511A8AC7DLL   /*  299 */,
    0xCA845E9172FADCD4LL   /*  300 */,    0x84F82B60329D20DCLL   /*  301 */,
    0x79C62CE1CD672F18LL   /*  302 */,    0x8B09A2ADD124642CLL   /*  303 */,
    0xD0C1E96A19D9E726LL   /*  304 */,    0x5A786A9B4BA9500CLL   /*  305 */,
    0x0E020336634C43F3LL   /*  306 */,    0xC17B474AEB66D822LL   /*  307 */,
    0x6A731AE3EC9BAAC2LL   /*  308 */,    0x8226667AE0840258LL   /*  309 */,
    0x67D4567691CAECA5LL   /*  310 */,    0x1D94155C4875ADB5LL   /*  311 */,
    0x6D00FD985B813FDFLL   /*  312 */,    0x51286EFCB774CD06LL   /*  313 */,
    0x5E8834471FA744AFLL   /*  314 */,    0xF72CA0AEE761AE2ELL   /*  315 */,
    0xBE40E4CDAEE8E09ALL   /*  316 */,    0xE9970BBB5118F665LL   /*  317 */,
    0x726E4BEB33DF1964LL   /*  318 */,    0x703B000729199762LL   /*  319 */,
    0x4631D816F5EF30A7LL   /*  320 */,    0xB880B5B51504A6BELL   /*  321 */,
    0x641793C37ED84B6CLL   /*  322 */,    0x7B21ED77F6E97D96LL   /*  323 */,
    0x776306312EF96B73LL   /*  324 */,    0xAE528948E86FF3F4LL   /*  325 */,
    0x53DBD7F286A3F8F8LL   /*  326 */,    0x16CADCE74CFC1063LL   /*  327 */,
    0x005C19BDFA52C6DDLL   /*  328 */,    0x68868F5D64D46AD3LL   /*  329 */,
    0x3A9D512CCF1E186ALL   /*  330 */,    0x367E62C2385660AELL   /*  331 */,
    0xE359E7EA77DCB1D7LL   /*  332 */,    0x526C0773749ABE6ELL   /*  333 */,
    0x735AE5F9D09F734BLL   /*  334 */,    0x493FC7CC8A558BA8LL   /*  335 */,
    0xB0B9C1533041AB45LL   /*  336 */,    0x321958BA470A59BDLL   /*  337 */,
    0x852DB00B5F46C393LL   /*  338 */,    0x91209B2BD336B0E5LL   /*  339 */,
    0x6E604F7D659EF19FLL   /*  340 */,    0xB99A8AE2782CCB24LL   /*  341 */,
    0xCCF52AB6C814C4C7LL   /*  342 */,    0x4727D9AFBE11727BLL   /*  343 */,
    0x7E950D0C0121B34DLL   /*  344 */,    0x756F435670AD471FLL   /*  345 */,
    0xF5ADD442615A6849LL   /*  346 */,    0x4E87E09980B9957ALL   /*  347 */,
    0x2ACFA1DF50AEE355LL   /*  348 */,    0xD898263AFD2FD556LL   /*  349 */,
    0xC8F4924DD80C8FD6LL   /*  350 */,    0xCF99CA3D754A173ALL   /*  351 */,
    0xFE477BACAF91BF3CLL   /*  352 */,    0xED5371F6D690C12DLL   /*  353 */,
    0x831A5C285E687094LL   /*  354 */,    0xC5D3C90A3708A0A4LL   /*  355 */,
    0x0F7F903717D06580LL   /*  356 */,    0x19F9BB13B8FDF27FLL   /*  357 */,
    0xB1BD6F1B4D502843LL   /*  358 */,    0x1C761BA38FFF4012LL   /*  359 */,
    0x0D1530C4E2E21F3BLL   /*  360 */,    0x8943CE69A7372C8ALL   /*  361 */,
    0xE5184E11FEB5CE66LL   /*  362 */,    0x618BDB80BD736621LL   /*  363 */,
    0x7D29BAD68B574D0BLL   /*  364 */,    0x81BB613E25E6FE5BLL   /*  365 */,
    0x071C9C10BC07913FLL   /*  366 */,    0xC7BEEB7909AC2D97LL   /*  367 */,
    0xC3E58D353BC5D757LL   /*  368 */,    0xEB017892F38F61E8LL   /*  369 */,
    0xD4EFFB9C9B1CC21ALL   /*  370 */,    0x99727D26F494F7ABLL   /*  371 */,
    0xA3E063A2956B3E03LL   /*  372 */,    0x9D4A8B9A4AA09C30LL   /*  373 */,
    0x3F6AB7D500090FB4LL   /*  374 */,    0x9CC0F2A057268AC0LL   /*  375 */,
    0x3DEE9D2DEDBF42D1LL   /*  376 */,    0x330F49C87960A972LL   /*  377 */,
    0xC6B2720287421B41LL   /*  378 */,    0x0AC59EC07C00369CLL   /*  379 */,
    0xEF4EAC49CB353425LL   /*  380 */,    0xF450244EEF0129D8LL   /*  381 */,
    0x8ACC46E5CAF4DEB6LL   /*  382 */,    0x2FFEAB63989263F7LL   /*  383 */,
    0x8F7CB9FE5D7A4578LL   /*  384 */,    0x5BD8F7644E634635LL   /*  385 */,
    0x427A7315BF2DC900LL   /*  386 */,    0x17D0C4AA2125261CLL   /*  387 */,
    0x3992486C93518E50LL   /*  388 */,    0xB4CBFEE0A2D7D4C3LL   /*  389 */,
    0x7C75D6202C5DDD8DLL   /*  390 */,    0xDBC295D8E35B6C61LL   /*  391 */,
    0x60B369D302032B19LL   /*  392 */,    0xCE42685FDCE44132LL   /*  393 */,
    0x06F3DDB9DDF65610LL   /*  394 */,    0x8EA4D21DB5E148F0LL   /*  395 */,
    0x20B0FCE62FCD496FLL   /*  396 */,    0x2C1B912358B0EE31LL   /*  397 */,
    0xB28317B818F5A308LL   /*  398 */,    0xA89C1E189CA6D2CFLL   /*  399 */,
    0x0C6B18576AAADBC8LL   /*  400 */,    0xB65DEAA91299FAE3LL   /*  401 */,
    0xFB2B794B7F1027E7LL   /*  402 */,    0x04E4317F443B5BEBLL   /*  403 */,
    0x4B852D325939D0A6LL   /*  404 */,    0xD5AE6BEEFB207FFCLL   /*  405 */,
    0x309682B281C7D374LL   /*  406 */,    0xBAE309A194C3B475LL   /*  407 */,
    0x8CC3F97B13B49F05LL   /*  408 */,    0x98A9422FF8293967LL   /*  409 */,
    0x244B16B01076FF7CLL   /*  410 */,    0xF8BF571C663D67EELL   /*  411 */,
    0x1F0D6758EEE30DA1LL   /*  412 */,    0xC9B611D97ADEB9B7LL   /*  413 */,
    0xB7AFD5887B6C57A2LL   /*  414 */,    0x6290AE846B984FE1LL   /*  415 */,
    0x94DF4CDEACC1A5FDLL   /*  416 */,    0x058A5BD1C5483AFFLL   /*  417 */,
    0x63166CC142BA3C37LL   /*  418 */,    0x8DB8526EB2F76F40LL   /*  419 */,
    0xE10880036F0D6D4ELL   /*  420 */,    0x9E0523C9971D311DLL   /*  421 */,
    0x45EC2824CC7CD691LL   /*  422 */,    0x575B8359E62382C9LL   /*  423 */,
    0xFA9E400DC4889995LL   /*  424 */,    0xD1823ECB45721568LL   /*  425 */,
    0xDAFD983B8206082FLL   /*  426 */,    0xAA7D29082386A8CBLL   /*  427 */,
    0x269FCD4403B87588LL   /*  428 */,    0x1B91F5F728BDD1E0LL   /*  429 */,
    0xE4669F39040201F6LL   /*  430 */,    0x7A1D7C218CF04ADELL   /*  431 */,
    0x65623C29D79CE5CELL   /*  432 */,    0x2368449096C00BB1LL   /*  433 */,
    0xAB9BF1879DA503BALL   /*  434 */,    0xBC23ECB1A458058ELL   /*  435 */,
    0x9A58DF01BB401ECCLL   /*  436 */,    0xA070E868A85F143DLL   /*  437 */,
    0x4FF188307DF2239ELL   /*  438 */,    0x14D565B41A641183LL   /*  439 */,
    0xEE13337452701602LL   /*  440 */,    0x950E3DCF3F285E09LL   /*  441 */,
    0x59930254B9C80953LL   /*  442 */,    0x3BF299408930DA6DLL   /*  443 */,
    0xA955943F53691387LL   /*  444 */,    0xA15EDECAA9CB8784LL   /*  445 */,
    0x29142127352BE9A0LL   /*  446 */,    0x76F0371FFF4E7AFBLL   /*  447 */,
    0x0239F450274F2228LL   /*  448 */,    0xBB073AF01D5E868BLL   /*  449 */,
    0xBFC80571C10E96C1LL   /*  450 */,    0xD267088568222E23LL   /*  451 */,
    0x9671A3D48E80B5B0LL   /*  452 */,    0x55B5D38AE193BB81LL   /*  453 */,
    0x693AE2D0A18B04B8LL   /*  454 */,    0x5C48B4ECADD5335FLL   /*  455 */,
    0xFD743B194916A1CALL   /*  456 */,    0x2577018134BE98C4LL   /*  457 */,
    0xE77987E83C54A4ADLL   /*  458 */,    0x28E11014DA33E1B9LL   /*  459 */,
    0x270CC59E226AA213LL   /*  460 */,    0x71495F756D1A5F60LL   /*  461 */,
    0x9BE853FB60AFEF77LL   /*  462 */,    0xADC786A7F7443DBFLL   /*  463 */,
    0x0904456173B29A82LL   /*  464 */,    0x58BC7A66C232BD5ELL   /*  465 */,
    0xF306558C673AC8B2LL   /*  466 */,    0x41F639C6B6C9772ALL   /*  467 */,
    0x216DEFE99FDA35DALL   /*  468 */,    0x11640CC71C7BE615LL   /*  469 */,
    0x93C43694565C5527LL   /*  470 */,    0xEA038E6246777839LL   /*  471 */,
    0xF9ABF3CE5A3E2469LL   /*  472 */,    0x741E768D0FD312D2LL   /*  473 */,
    0x0144B883CED652C6LL   /*  474 */,    0xC20B5A5BA33F8552LL   /*  475 */,
    0x1AE69633C3435A9DLL   /*  476 */,    0x97A28CA4088CFDECLL   /*  477 */,
    0x8824A43C1E96F420LL   /*  478 */,    0x37612FA66EEEA746LL   /*  479 */,
    0x6B4CB165F9CF0E5ALL   /*  480 */,    0x43AA1C06A0ABFB4ALL   /*  481 */,
    0x7F4DC26FF162796BLL   /*  482 */,    0x6CBACC8E54ED9B0FLL   /*  483 */,
    0xA6B7FFEFD2BB253ELL   /*  484 */,    0x2E25BC95B0A29D4FLL   /*  485 */,
    0x86D6A58BDEF1388CLL   /*  486 */,    0xDED74AC576B6F054LL   /*  487 */,
    0x8030BDBC2B45805DLL   /*  488 */,    0x3C81AF70E94D9289LL   /*  489 */,
    0x3EFF6DDA9E3100DBLL   /*  490 */,    0xB38DC39FDFCC8847LL   /*  491 */,
    0x123885528D17B87ELL   /*  492 */,    0xF2DA0ED240B1B642LL   /*  493 */,
    0x44CEFADCD54BF9A9LL   /*  494 */,    0x1312200E433C7EE6LL   /*  495 */,
    0x9FFCC84F3A78C748LL   /*  496 */,    0xF0CD1F72248576BBLL   /*  497 */,
    0xEC6974053638CFE4LL   /*  498 */,    0x2BA7B67C0CEC4E4CLL   /*  499 */,
    0xAC2F4DF3E5CE32EDLL   /*  500 */,    0xCB33D14326EA4C11LL   /*  501 */,
    0xA4E9044CC77E58BCLL   /*  502 */,    0x5F513293D934FCEFLL   /*  503 */,
    0x5DC9645506E55444LL   /*  504 */,    0x50DE418F317DE40ALL   /*  505 */,
    0x388CB31A69DDE259LL   /*  506 */,    0x2DB4A83455820A86LL   /*  507 */,
    0x9010A91E84711AE9LL   /*  508 */,    0x4DF7F0B7B1498371LL   /*  509 */,
    0xD62A2EABC0977179LL   /*  510 */,    0x22FAC097AA8D5C0ELL   /*  511 */,
    0xF49FCC2FF1DAF39BLL   /*  512 */,    0x487FD5C66FF29281LL   /*  513 */,
    0xE8A30667FCDCA83FLL   /*  514 */,    0x2C9B4BE3D2FCCE63LL   /*  515 */,
    0xDA3FF74B93FBBBC2LL   /*  516 */,    0x2FA165D2FE70BA66LL   /*  517 */,
    0xA103E279970E93D4LL   /*  518 */,    0xBECDEC77B0E45E71LL   /*  519 */,
    0xCFB41E723985E497LL   /*  520 */,    0xB70AAA025EF75017LL   /*  521 */,
    0xD42309F03840B8E0LL   /*  522 */,    0x8EFC1AD035898579LL   /*  523 */,
    0x96C6920BE2B2ABC5LL   /*  524 */,    0x66AF4163375A9172LL   /*  525 */,
    0x2174ABDCCA7127FBLL   /*  526 */,    0xB33CCEA64A72FF41LL   /*  527 */,
    0xF04A4933083066A5LL   /*  528 */,    0x8D970ACDD7289AF5LL   /*  529 */,
    0x8F96E8E031C8C25ELL   /*  530 */,    0xF3FEC02276875D47LL   /*  531 */,
    0xEC7BF310056190DDLL   /*  532 */,    0xF5ADB0AEBB0F1491LL   /*  533 */,
    0x9B50F8850FD58892LL   /*  534 */,    0x4975488358B74DE8LL   /*  535 */,
    0xA3354FF691531C61LL   /*  536 */,    0x0702BBE481D2C6EELL   /*  537 */,
    0x89FB24057DEDED98LL   /*  538 */,    0xAC3075138596E902LL   /*  539 */,
    0x1D2D3580172772EDLL   /*  540 */,    0xEB738FC28E6BC30DLL   /*  541 */,
    0x5854EF8F63044326LL   /*  542 */,    0x9E5C52325ADD3BBELL   /*  543 */,
    0x90AA53CF325C4623LL   /*  544 */,    0xC1D24D51349DD067LL   /*  545 */,
    0x2051CFEEA69EA624LL   /*  546 */,    0x13220F0A862E7E4FLL   /*  547 */,
    0xCE39399404E04864LL   /*  548 */,    0xD9C42CA47086FCB7LL   /*  549 */,
    0x685AD2238A03E7CCLL   /*  550 */,    0x066484B2AB2FF1DBLL   /*  551 */,
    0xFE9D5D70EFBF79ECLL   /*  552 */,    0x5B13B9DD9C481854LL   /*  553 */,
    0x15F0D475ED1509ADLL   /*  554 */,    0x0BEBCD060EC79851LL   /*  555 */,
    0xD58C6791183AB7F8LL   /*  556 */,    0xD1187C5052F3EEE4LL   /*  557 */,
    0xC95D1192E54E82FFLL   /*  558 */,    0x86EEA14CB9AC6CA2LL   /*  559 */,
    0x3485BEB153677D5DLL   /*  560 */,    0xDD191D781F8C492ALL   /*  561 */,
    0xF60866BAA784EBF9LL   /*  562 */,    0x518F643BA2D08C74LL   /*  563 */,
    0x8852E956E1087C22LL   /*  564 */,    0xA768CB8DC410AE8DLL   /*  565 */,
    0x38047726BFEC8E1ALL   /*  566 */,    0xA67738B4CD3B45AALL   /*  567 */,
    0xAD16691CEC0DDE19LL   /*  568 */,    0xC6D4319380462E07LL   /*  569 */,
    0xC5A5876D0BA61938LL   /*  570 */,    0x16B9FA1FA58FD840LL   /*  571 */,
    0x188AB1173CA74F18LL   /*  572 */,    0xABDA2F98C99C021FLL   /*  573 */,
    0x3E0580AB134AE816LL   /*  574 */,    0x5F3B05B773645ABBLL   /*  575 */,
    0x2501A2BE5575F2F6LL   /*  576 */,    0x1B2F74004E7E8BA9LL   /*  577 */,
    0x1CD7580371E8D953LL   /*  578 */,    0x7F6ED89562764E30LL   /*  579 */,
    0xB15926FF596F003DLL   /*  580 */,    0x9F65293DA8C5D6B9LL   /*  581 */,
    0x6ECEF04DD690F84CLL   /*  582 */,    0x4782275FFF33AF88LL   /*  583 */,
    0xE41433083F820801LL   /*  584 */,    0xFD0DFE409A1AF9B5LL   /*  585 */,
    0x4325A3342CDB396BLL   /*  586 */,    0x8AE77E62B301B252LL   /*  587 */,
    0xC36F9E9F6655615ALL   /*  588 */,    0x85455A2D92D32C09LL   /*  589 */,
    0xF2C7DEA949477485LL   /*  590 */,    0x63CFB4C133A39EBALL   /*  591 */,
    0x83B040CC6EBC5462LL   /*  592 */,    0x3B9454C8FDB326B0LL   /*  593 */,
    0x56F56A9E87FFD78CLL   /*  594 */,    0x2DC2940D99F42BC6LL   /*  595 */,
    0x98F7DF096B096E2DLL   /*  596 */,    0x19A6E01E3AD852BFLL   /*  597 */,
    0x42A99CCBDBD4B40BLL   /*  598 */,    0xA59998AF45E9C559LL   /*  599 */,
    0x366295E807D93186LL   /*  600 */,    0x6B48181BFAA1F773LL   /*  601 */,
    0x1FEC57E2157A0A1DLL   /*  602 */,    0x4667446AF6201AD5LL   /*  603 */,
    0xE615EBCACFB0F075LL   /*  604 */,    0xB8F31F4F68290778LL   /*  605 */,
    0x22713ED6CE22D11ELL   /*  606 */,    0x3057C1A72EC3C93BLL   /*  607 */,
    0xCB46ACC37C3F1F2FLL   /*  608 */,    0xDBB893FD02AAF50ELL   /*  609 */,
    0x331FD92E600B9FCFLL   /*  610 */,    0xA498F96148EA3AD6LL   /*  611 */,
    0xA8D8426E8B6A83EALL   /*  612 */,    0xA089B274B7735CDCLL   /*  613 */,
    0x87F6B3731E524A11LL   /*  614 */,    0x118808E5CBC96749LL   /*  615 */,
    0x9906E4C7B19BD394LL   /*  616 */,    0xAFED7F7E9B24A20CLL   /*  617 */,
    0x6509EADEEB3644A7LL   /*  618 */,    0x6C1EF1D3E8EF0EDELL   /*  619 */,
    0xB9C97D43E9798FB4LL   /*  620 */,    0xA2F2D784740C28A3LL   /*  621 */,
    0x7B8496476197566FLL   /*  622 */,    0x7A5BE3E6B65F069DLL   /*  623 */,
    0xF96330ED78BE6F10LL   /*  624 */,    0xEEE60DE77A076A15LL   /*  625 */,
    0x2B4BEE4AA08B9BD0LL   /*  626 */,    0x6A56A63EC7B8894ELL   /*  627 */,
    0x02121359BA34FEF4LL   /*  628 */,    0x4CBF99F8283703FCLL   /*  629 */,
    0x398071350CAF30C8LL   /*  630 */,    0xD0A77A89F017687ALL   /*  631 */,
    0xF1C1A9EB9E423569LL   /*  632 */,    0x8C7976282DEE8199LL   /*  633 */,
    0x5D1737A5DD1F7ABDLL   /*  634 */,    0x4F53433C09A9FA80LL   /*  635 */,
    0xFA8B0C53DF7CA1D9LL   /*  636 */,    0x3FD9DCBC886CCB77LL   /*  637 */,
    0xC040917CA91B4720LL   /*  638 */,    0x7DD00142F9D1DCDFLL   /*  639 */,
    0x8476FC1D4F387B58LL   /*  640 */,    0x23F8E7C5F3316503LL   /*  641 */,
    0x032A2244E7E37339LL   /*  642 */,    0x5C87A5D750F5A74BLL   /*  643 */,
    0x082B4CC43698992ELL   /*  644 */,    0xDF917BECB858F63CLL   /*  645 */,
    0x3270B8FC5BF86DDALL   /*  646 */,    0x10AE72BB29B5DD76LL   /*  647 */,
    0x576AC94E7700362BLL   /*  648 */,    0x1AD112DAC61EFB8FLL   /*  649 */,
    0x691BC30EC5FAA427LL   /*  650 */,    0xFF246311CC327143LL   /*  651 */,
    0x3142368E30E53206LL   /*  652 */,    0x71380E31E02CA396LL   /*  653 */,
    0x958D5C960AAD76F1LL   /*  654 */,    0xF8D6F430C16DA536LL   /*  655 */,
    0xC8FFD13F1BE7E1D2LL   /*  656 */,    0x7578AE66004DDBE1LL   /*  657 */,
    0x05833F01067BE646LL   /*  658 */,    0xBB34B5AD3BFE586DLL   /*  659 */,
    0x095F34C9A12B97F0LL   /*  660 */,    0x247AB64525D60CA8LL   /*  661 */,
    0xDCDBC6F3017477D1LL   /*  662 */,    0x4A2E14D4DECAD24DLL   /*  663 */,
    0xBDB5E6D9BE0A1EEBLL   /*  664 */,    0x2A7E70F7794301ABLL   /*  665 */,
    0xDEF42D8A270540FDLL   /*  666 */,    0x01078EC0A34C22C1LL   /*  667 */,
    0xE5DE511AF4C16387LL   /*  668 */,    0x7EBB3A52BD9A330ALL   /*  669 */,
    0x77697857AA7D6435LL   /*  670 */,    0x004E831603AE4C32LL   /*  671 */,
    0xE7A21020AD78E312LL   /*  672 */,    0x9D41A70C6AB420F2LL   /*  673 */,
    0x28E06C18EA1141E6LL   /*  674 */,    0xD2B28CBD984F6B28LL   /*  675 */,
    0x26B75F6C446E9D83LL   /*  676 */,    0xBA47568C4D418D7FLL   /*  677 */,
    0xD80BADBFE6183D8ELL   /*  678 */,    0x0E206D7F5F166044LL   /*  679 */,
    0xE258A43911CBCA3ELL   /*  680 */,    0x723A1746B21DC0BCLL   /*  681 */,
    0xC7CAA854F5D7CDD3LL   /*  682 */,    0x7CAC32883D261D9CLL   /*  683 */,
    0x7690C26423BA942CLL   /*  684 */,    0x17E55524478042B8LL   /*  685 */,
    0xE0BE477656A2389FLL   /*  686 */,    0x4D289B5E67AB2DA0LL   /*  687 */,
    0x44862B9C8FBBFD31LL   /*  688 */,    0xB47CC8049D141365LL   /*  689 */,
    0x822C1B362B91C793LL   /*  690 */,    0x4EB14655FB13DFD8LL   /*  691 */,
    0x1ECBBA0714E2A97BLL   /*  692 */,    0x6143459D5CDE5F14LL   /*  693 */,
    0x53A8FBF1D5F0AC89LL   /*  694 */,    0x97EA04D81C5E5B00LL   /*  695 */,
    0x622181A8D4FDB3F3LL   /*  696 */,    0xE9BCD341572A1208LL   /*  697 */,
    0x1411258643CCE58ALL   /*  698 */,    0x9144C5FEA4C6E0A4LL   /*  699 */,
    0x0D33D06565CF620FLL   /*  700 */,    0x54A48D489F219CA1LL   /*  701 */,
    0xC43E5EAC6D63C821LL   /*  702 */,    0xA9728B3A72770DAFLL   /*  703 */,
    0xD7934E7B20DF87EFLL   /*  704 */,    0xE35503B61A3E86E5LL   /*  705 */,
    0xCAE321FBC819D504LL   /*  706 */,    0x129A50B3AC60BFA6LL   /*  707 */,
    0xCD5E68EA7E9FB6C3LL   /*  708 */,    0xB01C90199483B1C7LL   /*  709 */,
    0x3DE93CD5C295376CLL   /*  710 */,    0xAED52EDF2AB9AD13LL   /*  711 */,
    0x2E60F512C0A07884LL   /*  712 */,    0xBC3D86A3E36210C9LL   /*  713 */,
    0x35269D9B163951CELL   /*  714 */,    0x0C7D6E2AD0CDB5FALL   /*  715 */,
    0x59E86297D87F5733LL   /*  716 */,    0x298EF221898DB0E7LL   /*  717 */,
    0x55000029D1A5AA7ELL   /*  718 */,    0x8BC08AE1B5061B45LL   /*  719 */,
    0xC2C31C2B6C92703ALL   /*  720 */,    0x94CC596BAF25EF42LL   /*  721 */,
    0x0A1D73DB22540456LL   /*  722 */,    0x04B6A0F9D9C4179ALL   /*  723 */,
    0xEFFDAFA2AE3D3C60LL   /*  724 */,    0xF7C8075BB49496C4LL   /*  725 */,
    0x9CC5C7141D1CD4E3LL   /*  726 */,    0x78BD1638218E5534LL   /*  727 */,
    0xB2F11568F850246ALL   /*  728 */,    0xEDFABCFA9502BC29LL   /*  729 */,
    0x796CE5F2DA23051BLL   /*  730 */,    0xAAE128B0DC93537CLL   /*  731 */,
    0x3A493DA0EE4B29AELL   /*  732 */,    0xB5DF6B2C416895D7LL   /*  733 */,
    0xFCABBD25122D7F37LL   /*  734 */,    0x70810B58105DC4B1LL   /*  735 */,
    0xE10FDD37F7882A90LL   /*  736 */,    0x524DCAB5518A3F5CLL   /*  737 */,
    0x3C9E85878451255BLL   /*  738 */,    0x4029828119BD34E2LL   /*  739 */,
    0x74A05B6F5D3CECCBLL   /*  740 */,    0xB610021542E13ECALL   /*  741 */,
    0x0FF979D12F59E2ACLL   /*  742 */,    0x6037DA27E4F9CC50LL   /*  743 */,
    0x5E92975A0DF1847DLL   /*  744 */,    0xD66DE190D3E623FELL   /*  745 */,
    0x5032D6B87B568048LL   /*  746 */,    0x9A36B7CE8235216ELL   /*  747 */,
    0x80272A7A24F64B4ALL   /*  748 */,    0x93EFED8B8C6916F7LL   /*  749 */,
    0x37DDBFF44CCE1555LL   /*  750 */,    0x4B95DB5D4B99BD25LL   /*  751 */,
    0x92D3FDA169812FC0LL   /*  752 */,    0xFB1A4A9A90660BB6LL   /*  753 */,
    0x730C196946A4B9B2LL   /*  754 */,    0x81E289AA7F49DA68LL   /*  755 */,
    0x64669A0F83B1A05FLL   /*  756 */,    0x27B3FF7D9644F48BLL   /*  757 */,
    0xCC6B615C8DB675B3LL   /*  758 */,    0x674F20B9BCEBBE95LL   /*  759 */,
    0x6F31238275655982LL   /*  760 */,    0x5AE488713E45CF05LL   /*  761 */,
    0xBF619F9954C21157LL   /*  762 */,    0xEABAC46040A8EAE9LL   /*  763 */,
    0x454C6FE9F2C0C1CDLL   /*  764 */,    0x419CF6496412691CLL   /*  765 */,
    0xD3DC3BEF265B0F70LL   /*  766 */,    0x6D0E60F5C3578A9ELL   /*  767 */,
    0x5B0E608526323C55LL   /*  768 */,    0x1A46C1A9FA1B59F5LL   /*  769 */,
    0xA9E245A17C4C8FFALL   /*  770 */,    0x65CA5159DB2955D7LL   /*  771 */,
    0x05DB0A76CE35AFC2LL   /*  772 */,    0x81EAC77EA9113D45LL   /*  773 */,
    0x528EF88AB6AC0A0DLL   /*  774 */,    0xA09EA253597BE3FFLL   /*  775 */,
    0x430DDFB3AC48CD56LL   /*  776 */,    0xC4B3A67AF45CE46FLL   /*  777 */,
    0x4ECECFD8FBE2D05ELL   /*  778 */,    0x3EF56F10B39935F0LL   /*  779 */,
    0x0B22D6829CD619C6LL   /*  780 */,    0x17FD460A74DF2069LL   /*  781 */,
    0x6CF8CC8E8510ED40LL   /*  782 */,    0xD6C824BF3A6ECAA7LL   /*  783 */,
    0x61243D581A817049LL   /*  784 */,    0x048BACB6BBC163A2LL   /*  785 */,
    0xD9A38AC27D44CC32LL   /*  786 */,    0x7FDDFF5BAAF410ABLL   /*  787 */,
    0xAD6D495AA804824BLL   /*  788 */,    0xE1A6A74F2D8C9F94LL   /*  789 */,
    0xD4F7851235DEE8E3LL   /*  790 */,    0xFD4B7F886540D893LL   /*  791 */,
    0x247C20042AA4BFDALL   /*  792 */,    0x096EA1C517D1327CLL   /*  793 */,
    0xD56966B4361A6685LL   /*  794 */,    0x277DA5C31221057DLL   /*  795 */,
    0x94D59893A43ACFF7LL   /*  796 */,    0x64F0C51CCDC02281LL   /*  797 */,
    0x3D33BCC4FF6189DBLL   /*  798 */,    0xE005CB184CE66AF1LL   /*  799 */,
    0xFF5CCD1D1DB99BEALL   /*  800 */,    0xB0B854A7FE42980FLL   /*  801 */,
    0x7BD46A6A718D4B9FLL   /*  802 */,    0xD10FA8CC22A5FD8CLL   /*  803 */,
    0xD31484952BE4BD31LL   /*  804 */,    0xC7FA975FCB243847LL   /*  805 */,
    0x4886ED1E5846C407LL   /*  806 */,    0x28CDDB791EB70B04LL   /*  807 */,
    0xC2B00BE2F573417FLL   /*  808 */,    0x5C9590452180F877LL   /*  809 */,
    0x7A6BDDFFF370EB00LL   /*  810 */,    0xCE509E38D6D9D6A4LL   /*  811 */,
    0xEBEB0F00647FA702LL   /*  812 */,    0x1DCC06CF76606F06LL   /*  813 */,
    0xE4D9F28BA286FF0ALL   /*  814 */,    0xD85A305DC918C262LL   /*  815 */,
    0x475B1D8732225F54LL   /*  816 */,    0x2D4FB51668CCB5FELL   /*  817 */,
    0xA679B9D9D72BBA20LL   /*  818 */,    0x53841C0D912D43A5LL   /*  819 */,
    0x3B7EAA48BF12A4E8LL   /*  820 */,    0x781E0E47F22F1DDFLL   /*  821 */,
    0xEFF20CE60AB50973LL   /*  822 */,    0x20D261D19DFFB742LL   /*  823 */,
    0x16A12B03062A2E39LL   /*  824 */,    0x1960EB2239650495LL   /*  825 */,
    0x251C16FED50EB8B8LL   /*  826 */,    0x9AC0C330F826016ELL   /*  827 */,
    0xED152665953E7671LL   /*  828 */,    0x02D63194A6369570LL   /*  829 */,
    0x5074F08394B1C987LL   /*  830 */,    0x70BA598C90B25CE1LL   /*  831 */,
    0x794A15810B9742F6LL   /*  832 */,    0x0D5925E9FCAF8C6CLL   /*  833 */,
    0x3067716CD868744ELL   /*  834 */,    0x910AB077E8D7731BLL   /*  835 */,
    0x6A61BBDB5AC42F61LL   /*  836 */,    0x93513EFBF0851567LL   /*  837 */,
    0xF494724B9E83E9D5LL   /*  838 */,    0xE887E1985C09648DLL   /*  839 */,
    0x34B1D3C675370CFDLL   /*  840 */,    0xDC35E433BC0D255DLL   /*  841 */,
    0xD0AAB84234131BE0LL   /*  842 */,    0x08042A50B48B7EAFLL   /*  843 */,
    0x9997C4EE44A3AB35LL   /*  844 */,    0x829A7B49201799D0LL   /*  845 */,
    0x263B8307B7C54441LL   /*  846 */,    0x752F95F4FD6A6CA6LL   /*  847 */,
    0x927217402C08C6E5LL   /*  848 */,    0x2A8AB754A795D9EELL   /*  849 */,
    0xA442F7552F72943DLL   /*  850 */,    0x2C31334E19781208LL   /*  851 */,
    0x4FA98D7CEAEE6291LL   /*  852 */,    0x55C3862F665DB309LL   /*  853 */,
    0xBD0610175D53B1F3LL   /*  854 */,    0x46FE6CB840413F27LL   /*  855 */,
    0x3FE03792DF0CFA59LL   /*  856 */,    0xCFE700372EB85E8FLL   /*  857 */,
    0xA7BE29E7ADBCE118LL   /*  858 */,    0xE544EE5CDE8431DDLL   /*  859 */,
    0x8A781B1B41F1873ELL   /*  860 */,    0xA5C94C78A0D2F0E7LL   /*  861 */,
    0x39412E2877B60728LL   /*  862 */,    0xA1265EF3AFC9A62CLL   /*  863 */,
    0xBCC2770C6A2506C5LL   /*  864 */,    0x3AB66DD5DCE1CE12LL   /*  865 */,
    0xE65499D04A675B37LL   /*  866 */,    0x7D8F523481BFD216LL   /*  867 */,
    0x0F6F64FCEC15F389LL   /*  868 */,    0x74EFBE618B5B13C8LL   /*  869 */,
    0xACDC82B714273E1DLL   /*  870 */,    0xDD40BFE003199D17LL   /*  871 */,
    0x37E99257E7E061F8LL   /*  872 */,    0xFA52626904775AAALL   /*  873 */,
    0x8BBBF63A463D56F9LL   /*  874 */,    0xF0013F1543A26E64LL   /*  875 */,
    0xA8307E9F879EC898LL   /*  876 */,    0xCC4C27A4150177CCLL   /*  877 */,
    0x1B432F2CCA1D3348LL   /*  878 */,    0xDE1D1F8F9F6FA013LL   /*  879 */,
    0x606602A047A7DDD6LL   /*  880 */,    0xD237AB64CC1CB2C7LL   /*  881 */,
    0x9B938E7225FCD1D3LL   /*  882 */,    0xEC4E03708E0FF476LL   /*  883 */,
    0xFEB2FBDA3D03C12DLL   /*  884 */,    0xAE0BCED2EE43889ALL   /*  885 */,
    0x22CB8923EBFB4F43LL   /*  886 */,    0x69360D013CF7396DLL   /*  887 */,
    0x855E3602D2D4E022LL   /*  888 */,    0x073805BAD01F784CLL   /*  889 */,
    0x33E17A133852F546LL   /*  890 */,    0xDF4874058AC7B638LL   /*  891 */,
    0xBA92B29C678AA14ALL   /*  892 */,    0x0CE89FC76CFAADCDLL   /*  893 */,
    0x5F9D4E0908339E34LL   /*  894 */,    0xF1AFE9291F5923B9LL   /*  895 */,
    0x6E3480F60F4A265FLL   /*  896 */,    0xEEBF3A2AB29B841CLL   /*  897 */,
    0xE21938A88F91B4ADLL   /*  898 */,    0x57DFEFF845C6D3C3LL   /*  899 */,
    0x2F006B0BF62CAAF2LL   /*  900 */,    0x62F479EF6F75EE78LL   /*  901 */,
    0x11A55AD41C8916A9LL   /*  902 */,    0xF229D29084FED453LL   /*  903 */,
    0x42F1C27B16B000E6LL   /*  904 */,    0x2B1F76749823C074LL   /*  905 */,
    0x4B76ECA3C2745360LL   /*  906 */,    0x8C98F463B91691BDLL   /*  907 */,
    0x14BCC93CF1ADE66ALL   /*  908 */,    0x8885213E6D458397LL   /*  909 */,
    0x8E177DF0274D4711LL   /*  910 */,    0xB49B73B5503F2951LL   /*  911 */,
    0x10168168C3F96B6BLL   /*  912 */,    0x0E3D963B63CAB0AELL   /*  913 */,
    0x8DFC4B5655A1DB14LL   /*  914 */,    0xF789F1356E14DE5CLL   /*  915 */,
    0x683E68AF4E51DAC1LL   /*  916 */,    0xC9A84F9D8D4B0FD9LL   /*  917 */,
    0x3691E03F52A0F9D1LL   /*  918 */,    0x5ED86E46E1878E80LL   /*  919 */,
    0x3C711A0E99D07150LL   /*  920 */,    0x5A0865B20C4E9310LL   /*  921 */,
    0x56FBFC1FE4F0682ELL   /*  922 */,    0xEA8D5DE3105EDF9BLL   /*  923 */,
    0x71ABFDB12379187ALL   /*  924 */,    0x2EB99DE1BEE77B9CLL   /*  925 */,
    0x21ECC0EA33CF4523LL   /*  926 */,    0x59A4D7521805C7A1LL   /*  927 */,
    0x3896F5EB56AE7C72LL   /*  928 */,    0xAA638F3DB18F75DCLL   /*  929 */,
    0x9F39358DABE9808ELL   /*  930 */,    0xB7DEFA91C00B72ACLL   /*  931 */,
    0x6B5541FD62492D92LL   /*  932 */,    0x6DC6DEE8F92E4D5BLL   /*  933 */,
    0x353F57ABC4BEEA7ELL   /*  934 */,    0x735769D6DA5690CELL   /*  935 */,
    0x0A234AA642391484LL   /*  936 */,    0xF6F9508028F80D9DLL   /*  937 */,
    0xB8E319A27AB3F215LL   /*  938 */,    0x31AD9C1151341A4DLL   /*  939 */,
    0x773C22A57BEF5805LL   /*  940 */,    0x45C7561A07968633LL   /*  941 */,
    0xF913DA9E249DBE36LL   /*  942 */,    0xDA652D9B78A64C68LL   /*  943 */,
    0x4C27A97F3BC334EFLL   /*  944 */,    0x76621220E66B17F4LL   /*  945 */,
    0x967743899ACD7D0BLL   /*  946 */,    0xF3EE5BCAE0ED6782LL   /*  947 */,
    0x409F753600C879FCLL   /*  948 */,    0x06D09A39B5926DB6LL   /*  949 */,
    0x6F83AEB0317AC588LL   /*  950 */,    0x01E6CA4A86381F21LL   /*  951 */,
    0x66FF3462D19F3025LL   /*  952 */,    0x72207C24DDFD3BFBLL   /*  953 */,
    0x4AF6B6D3E2ECE2EBLL   /*  954 */,    0x9C994DBEC7EA08DELL   /*  955 */,
    0x49ACE597B09A8BC4LL   /*  956 */,    0xB38C4766CF0797BALL   /*  957 */,
    0x131B9373C57C2A75LL   /*  958 */,    0xB1822CCE61931E58LL   /*  959 */,
    0x9D7555B909BA1C0CLL   /*  960 */,    0x127FAFDD937D11D2LL   /*  961 */,
    0x29DA3BADC66D92E4LL   /*  962 */,    0xA2C1D57154C2ECBCLL   /*  963 */,
    0x58C5134D82F6FE24LL   /*  964 */,    0x1C3AE3515B62274FLL   /*  965 */,
    0xE907C82E01CB8126LL   /*  966 */,    0xF8ED091913E37FCBLL   /*  967 */,
    0x3249D8F9C80046C9LL   /*  968 */,    0x80CF9BEDE388FB63LL   /*  969 */,
    0x1881539A116CF19ELL   /*  970 */,    0x5103F3F76BD52457LL   /*  971 */,
    0x15B7E6F5AE47F7A8LL   /*  972 */,    0xDBD7C6DED47E9CCFLL   /*  973 */,
    0x44E55C410228BB1ALL   /*  974 */,    0xB647D4255EDB4E99LL   /*  975 */,
    0x5D11882BB8AAFC30LL   /*  976 */,    0xF5098BBB29D3212ALL   /*  977 */,
    0x8FB5EA14E90296B3LL   /*  978 */,    0x677B942157DD025ALL   /*  979 */,
    0xFB58E7C0A390ACB5LL   /*  980 */,    0x89D3674C83BD4A01LL   /*  981 */,
    0x9E2DA4DF4BF3B93BLL   /*  982 */,    0xFCC41E328CAB4829LL   /*  983 */,
    0x03F38C96BA582C52LL   /*  984 */,    0xCAD1BDBD7FD85DB2LL   /*  985 */,
    0xBBB442C16082AE83LL   /*  986 */,    0xB95FE86BA5DA9AB0LL   /*  987 */,
    0xB22E04673771A93FLL   /*  988 */,    0x845358C9493152D8LL   /*  989 */,
    0xBE2A488697B4541ELL   /*  990 */,    0x95A2DC2DD38E6966LL   /*  991 */,
    0xC02C11AC923C852BLL   /*  992 */,    0x2388B1990DF2A87BLL   /*  993 */,
    0x7C8008FA1B4F37BELL   /*  994 */,    0x1F70D0C84D54E503LL   /*  995 */,
    0x5490ADEC7ECE57D4LL   /*  996 */,    0x002B3C27D9063A3ALL   /*  997 */,
    0x7EAEA3848030A2BFLL   /*  998 */,    0xC602326DED2003C0LL   /*  999 */,
    0x83A7287D69A94086LL   /* 1000 */,    0xC57A5FCB30F57A8ALL   /* 1001 */,
    0xB56844E479EBE779LL   /* 1002 */,    0xA373B40F05DCBCE9LL   /* 1003 */,
    0xD71A786E88570EE2LL   /* 1004 */,    0x879CBACDBDE8F6A0LL   /* 1005 */,
    0x976AD1BCC164A32FLL   /* 1006 */,    0xAB21E25E9666D78BLL   /* 1007 */,
    0x901063AAE5E5C33CLL   /* 1008 */,    0x9818B34448698D90LL   /* 1009 */,
    0xE36487AE3E1E8ABBLL   /* 1010 */,    0xAFBDF931893BDCB4LL   /* 1011 */,
    0x6345A0DC5FBBD519LL   /* 1012 */,    0x8628FE269B9465CALL   /* 1013 */,
    0x1E5D01603F9C51ECLL   /* 1014 */,    0x4DE44006A15049B7LL   /* 1015 */,
    0xBF6C70E5F776CBB1LL   /* 1016 */,    0x411218F2EF552BEDLL   /* 1017 */,
    0xCB0C0708705A36A3LL   /* 1018 */,    0xE74D14754F986044LL   /* 1019 */,
    0xCD56D9430EA8280ELL   /* 1020 */,    0xC12591D7535F5065LL   /* 1021 */,
    0xC83223F1720AEF96LL   /* 1022 */,    0xC3A0396F7363A51FLL   /* 1023 */};

################################################################################

TITLE
    Whirlpool obsolete C0 table

TYPE
    64

DATA
    0xd818186018c07830, 0x2623238c2305af46, 0xb8c6c63fc67ef991, 0xfbe8e887e8136fcd,
    0xcb878726874ca113, 0x11b8b8dab8a9626d, 0x0901010401080502, 0x0d4f4f214f426e9e,
    0x9b3636d836adee6c, 0xffa6a6a2a6590451, 0x0cd2d26fd2debdb9, 0x0ef5f5f3f5fb06f7,
    0x967979f979ef80f2, 0x306f6fa16f5fcede, 0x6d91917e91fcef3f, 0xf852525552aa07a4,
    0x4760609d6027fdc0, 0x35bcbccabc897665, 0x379b9b569baccd2b, 0x8a8e8e028e048c01,
    0xd2a3a3b6a371155b, 0x6c0c0c300c603c18, 0x847b7bf17bff8af6, 0x803535d435b5e16a,
    0xf51d1d741de8693a, 0xb3e0e0a7e05347dd, 0x21d7d77bd7f6acb3, 0x9cc2c22fc25eed99,
    0x432e2eb82e6d965c, 0x294b4b314b627a96, 0x5dfefedffea321e1, 0xd5575741578216ae,
    0xbd15155415a8412a, 0xe87777c1779fb6ee, 0x923737dc37a5eb6e, 0x9ee5e5b3e57b56d7,
    0x139f9f469f8cd923, 0x23f0f0e7f0d317fd, 0x204a4a354a6a7f94, 0x44dada4fda9e95a9,
    0xa258587d58fa25b0, 0xcfc9c903c906ca8f, 0x7c2929a429558d52, 0x5a0a0a280a502214,
    0x50b1b1feb1e14f7f, 0xc9a0a0baa0691a5d, 0x146b6bb16b7fdad6, 0xd985852e855cab17,
    0x3cbdbdcebd817367, 0x8f5d5d695dd234ba, 0x9010104010805020, 0x07f4f4f7f4f303f5,
    0xddcbcb0bcb16c08b, 0xd33e3ef83eedc67c, 0x2d0505140528110a, 0x78676781671fe6ce,
    0x97e4e4b7e47353d5, 0x0227279c2725bb4e, 0x7341411941325882, 0xa78b8b168b2c9d0b,
    0xf6a7a7a6a7510153, 0xb27d7de97dcf94fa, 0x4995956e95dcfb37, 0x56d8d847d88e9fad,
    0x70fbfbcbfb8b30eb, 0xcdeeee9fee2371c1, 0xbb7c7ced7cc791f8, 0x716666856617e3cc,
    0x7bdddd53dda68ea7, 0xaf17175c17b84b2e, 0x454747014702468e, 0x1a9e9e429e84dc21,
    0xd4caca0fca1ec589, 0x582d2db42d75995a, 0x2ebfbfc6bf917963, 0x3f07071c07381b0e,
    0xacadad8ead012347, 0xb05a5a755aea2fb4, 0xef838336836cb51b, 0xb63333cc3385ff66,
    0x5c636391633ff2c6, 0x1202020802100a04, 0x93aaaa92aa393849, 0xde7171d971afa8e2,
    0xc6c8c807c80ecf8d, 0xd119196419c87d32, 0x3b49493949727092, 0x5fd9d943d9869aaf,
    0x31f2f2eff2c31df9, 0xa8e3e3abe34b48db, 0xb95b5b715be22ab6, 0xbc88881a8834920d,
    0x3e9a9a529aa4c829, 0x0b262698262dbe4c, 0xbf3232c8328dfa64, 0x59b0b0fab0e94a7d,
    0xf2e9e983e91b6acf, 0x770f0f3c0f78331e, 0x33d5d573d5e6a6b7, 0xf480803a8074ba1d,
    0x27bebec2be997c61, 0xebcdcd13cd26de87, 0x893434d034bde468, 0x3248483d487a7590,
    0x54ffffdbffab24e3, 0x8d7a7af57af78ff4, 0x6490907a90f4ea3d, 0x9d5f5f615fc23ebe,
    0x3d202080201da040, 0x0f6868bd6867d5d0, 0xca1a1a681ad07234, 0xb7aeae82ae192c41,
    0x7db4b4eab4c95e75, 0xce54544d549a19a8, 0x7f93937693ece53b, 0x2f222288220daa44,
    0x6364648d6407e9c8, 0x2af1f1e3f1db12ff, 0xcc7373d173bfa2e6, 0x8212124812905a24,
    0x7a40401d403a5d80, 0x4808082008402810, 0x95c3c32bc356e89b, 0xdfecec97ec337bc5,
    0x4ddbdb4bdb9690ab, 0xc0a1a1bea1611f5f, 0x918d8d0e8d1c8307, 0xc83d3df43df5c97a,
    0x5b97976697ccf133, 0x0000000000000000, 0xf9cfcf1bcf36d483, 0x6e2b2bac2b458756,
    0xe17676c57697b3ec, 0xe68282328264b019, 0x28d6d67fd6fea9b1, 0xc31b1b6c1bd87736,
    0x74b5b5eeb5c15b77, 0xbeafaf86af112943, 0x1d6a6ab56a77dfd4, 0xea50505d50ba0da0,
    0x5745450945124c8a, 0x38f3f3ebf3cb18fb, 0xad3030c0309df060, 0xc4efef9bef2b74c3,
    0xda3f3ffc3fe5c37e, 0xc755554955921caa, 0xdba2a2b2a2791059, 0xe9eaea8fea0365c9,
    0x6a656589650fecca, 0x03babad2bab96869, 0x4a2f2fbc2f65935e, 0x8ec0c027c04ee79d,
    0x60dede5fdebe81a1, 0xfc1c1c701ce06c38, 0x46fdfdd3fdbb2ee7, 0x1f4d4d294d52649a,
    0x7692927292e4e039, 0xfa7575c9758fbcea, 0x3606061806301e0c, 0xae8a8a128a249809,
    0x4bb2b2f2b2f94079, 0x85e6e6bfe66359d1, 0x7e0e0e380e70361c, 0xe71f1f7c1ff8633e,
    0x556262956237f7c4, 0x3ad4d477d4eea3b5, 0x81a8a89aa829324d, 0x5296966296c4f431,
    0x62f9f9c3f99b3aef, 0xa3c5c533c566f697, 0x102525942535b14a, 0xab59597959f220b2,
    0xd084842a8454ae15, 0xc57272d572b7a7e4, 0xec3939e439d5dd72, 0x164c4c2d4c5a6198,
    0x945e5e655eca3bbc, 0x9f7878fd78e785f0, 0xe53838e038ddd870, 0x988c8c0a8c148605,
    0x17d1d163d1c6b2bf, 0xe4a5a5aea5410b57, 0xa1e2e2afe2434dd9, 0x4e616199612ff8c2,
    0x42b3b3f6b3f1457b, 0x342121842115a542, 0x089c9c4a9c94d625, 0xee1e1e781ef0663c,
    0x6143431143225286, 0xb1c7c73bc776fc93, 0x4ffcfcd7fcb32be5, 0x2404041004201408,
    0xe351515951b208a2, 0x2599995e99bcc72f, 0x226d6da96d4fc4da, 0x650d0d340d68391a,
    0x79fafacffa8335e9, 0x69dfdf5bdfb684a3, 0xa97e7ee57ed79bfc, 0x19242490243db448,
    0xfe3b3bec3bc5d776, 0x9aabab96ab313d4b, 0xf0cece1fce3ed181, 0x9911114411885522,
    0x838f8f068f0c8903, 0x044e4e254e4a6b9c, 0x66b7b7e6b7d15173, 0xe0ebeb8beb0b60cb,
    0xc13c3cf03cfdcc78, 0xfd81813e817cbf1f, 0x4094946a94d4fe35, 0x1cf7f7fbf7eb0cf3,
    0x18b9b9deb9a1676f, 0x8b13134c13985f26, 0x512c2cb02c7d9c58, 0x05d3d36bd3d6b8bb,
    0x8ce7e7bbe76b5cd3, 0x396e6ea56e57cbdc, 0xaac4c437c46ef395, 0x1b03030c03180f06,
    0xdc565645568a13ac, 0x5e44440d441a4988, 0xa07f7fe17fdf9efe, 0x88a9a99ea921374f,
    0x672a2aa82a4d8254, 0x0abbbbd6bbb16d6b, 0x87c1c123c146e29f, 0xf153535153a202a6,
    0x72dcdc57dcae8ba5, 0x530b0b2c0b582716, 0x019d9d4e9d9cd327, 0x2b6c6cad6c47c1d8,
    0xa43131c43195f562, 0xf37474cd7487b9e8, 0x15f6f6fff6e309f1, 0x4c464605460a438c,
    0xa5acac8aac092645, 0xb589891e893c970f, 0xb414145014a04428, 0xbae1e1a3e15b42df,
    0xa616165816b04e2c, 0xf73a3ae83acdd274, 0x066969b9696fd0d2, 0x4109092409482d12,
    0xd77070dd70a7ade0, 0x6fb6b6e2b6d95471, 0x1ed0d067d0ceb7bd, 0xd6eded93ed3b7ec7,
    0xe2cccc17cc2edb85, 0x68424215422a5784, 0x2c98985a98b4c22d, 0xeda4a4aaa4490e55,
    0x752828a0285d8850, 0x865c5c6d5cda31b8, 0x6bf8f8c7f8933fed, 0xc28686228644a411,

################################################################################

TITLE
    Whirlpool C0 table

TYPE
    64

DATA
    0x18186018c07830d8, 0x23238c2305af4626, 0xc6c63fc67ef991b8, 0xe8e887e8136fcdfb,
    0x878726874ca113cb, 0xb8b8dab8a9626d11, 0x0101040108050209, 0x4f4f214f426e9e0d,
    0x3636d836adee6c9b, 0xa6a6a2a6590451ff, 0xd2d26fd2debdb90c, 0xf5f5f3f5fb06f70e,
    0x7979f979ef80f296, 0x6f6fa16f5fcede30, 0x91917e91fcef3f6d, 0x52525552aa07a4f8,
    0x60609d6027fdc047, 0xbcbccabc89766535, 0x9b9b569baccd2b37, 0x8e8e028e048c018a,
    0xa3a3b6a371155bd2, 0x0c0c300c603c186c, 0x7b7bf17bff8af684, 0x3535d435b5e16a80,
    0x1d1d741de8693af5, 0xe0e0a7e05347ddb3, 0xd7d77bd7f6acb321, 0xc2c22fc25eed999c,
    0x2e2eb82e6d965c43, 0x4b4b314b627a9629, 0xfefedffea321e15d, 0x575741578216aed5,
    0x15155415a8412abd, 0x7777c1779fb6eee8, 0x3737dc37a5eb6e92, 0xe5e5b3e57b56d79e,
    0x9f9f469f8cd92313, 0xf0f0e7f0d317fd23, 0x4a4a354a6a7f9420, 0xdada4fda9e95a944,
    0x58587d58fa25b0a2, 0xc9c903c906ca8fcf, 0x2929a429558d527c, 0x0a0a280a5022145a,
    0xb1b1feb1e14f7f50, 0xa0a0baa0691a5dc9, 0x6b6bb16b7fdad614, 0x85852e855cab17d9,
    0xbdbdcebd8173673c, 0x5d5d695dd234ba8f, 0x1010401080502090, 0xf4f4f7f4f303f507,
    0xcbcb0bcb16c08bdd, 0x3e3ef83eedc67cd3, 0x0505140528110a2d, 0x676781671fe6ce78,
    0xe4e4b7e47353d597, 0x27279c2725bb4e02, 0x4141194132588273, 0x8b8b168b2c9d0ba7,
    0xa7a7a6a7510153f6, 0x7d7de97dcf94fab2, 0x95956e95dcfb3749, 0xd8d847d88e9fad56,
    0xfbfbcbfb8b30eb70, 0xeeee9fee2371c1cd, 0x7c7ced7cc791f8bb, 0x6666856617e3cc71,
    0xdddd53dda68ea77b, 0x17175c17b84b2eaf, 0x4747014702468e45, 0x9e9e429e84dc211a,
    0xcaca0fca1ec589d4, 0x2d2db42d75995a58, 0xbfbfc6bf9179632e, 0x07071c07381b0e3f,
    0xadad8ead012347ac, 0x5a5a755aea2fb4b0, 0x838336836cb51bef, 0x3333cc3385ff66b6,
    0x636391633ff2c65c, 0x02020802100a0412, 0xaaaa92aa39384993, 0x7171d971afa8e2de,
    0xc8c807c80ecf8dc6, 0x19196419c87d32d1, 0x494939497270923b, 0xd9d943d9869aaf5f,
    0xf2f2eff2c31df931, 0xe3e3abe34b48dba8, 0x5b5b715be22ab6b9, 0x88881a8834920dbc,
    0x9a9a529aa4c8293e, 0x262698262dbe4c0b, 0x3232c8328dfa64bf, 0xb0b0fab0e94a7d59,
    0xe9e983e91b6acff2, 0x0f0f3c0f78331e77, 0xd5d573d5e6a6b733, 0x80803a8074ba1df4,
    0xbebec2be997c6127, 0xcdcd13cd26de87eb, 0x3434d034bde46889, 0x48483d487a759032,
    0xffffdbffab24e354, 0x7a7af57af78ff48d, 0x90907a90f4ea3d64, 0x5f5f615fc23ebe9d,
    0x202080201da0403d, 0x6868bd6867d5d00f, 0x1a1a681ad07234ca, 0xaeae82ae192c41b7,
    0xb4b4eab4c95e757d, 0x54544d549a19a8ce, 0x93937693ece53b7f, 0x222288220daa442f,
    0x64648d6407e9c863, 0xf1f1e3f1db12ff2a, 0x7373d173bfa2e6cc, 0x12124812905a2482,
    0x40401d403a5d807a, 0x0808200840281048, 0xc3c32bc356e89b95, 0xecec97ec337bc5df,
    0xdbdb4bdb9690ab4d, 0xa1a1bea1611f5fc0, 0x8d8d0e8d1c830791, 0x3d3df43df5c97ac8,
    0x97976697ccf1335b, 0x0000000000000000, 0xcfcf1bcf36d483f9, 0x2b2bac2b4587566e,
    0x7676c57697b3ece1, 0x8282328264b019e6, 0xd6d67fd6fea9b128, 0x1b1b6c1bd87736c3,
    0xb5b5eeb5c15b7774, 0xafaf86af112943be, 0x6a6ab56a77dfd41d, 0x50505d50ba0da0ea,
    0x45450945124c8a57, 0xf3f3ebf3cb18fb38, 0x3030c0309df060ad, 0xefef9bef2b74c3c4,
    0x3f3ffc3fe5c37eda, 0x55554955921caac7, 0xa2a2b2a2791059db, 0xeaea8fea0365c9e9,
    0x656589650fecca6a, 0xbabad2bab9686903, 0x2f2fbc2f65935e4a, 0xc0c027c04ee79d8e,
    0xdede5fdebe81a160, 0x1c1c701ce06c38fc, 0xfdfdd3fdbb2ee746, 0x4d4d294d52649a1f,
    0x92927292e4e03976, 0x7575c9758fbceafa, 0x06061806301e0c36, 0x8a8a128a249809ae,
    0xb2b2f2b2f940794b, 0xe6e6bfe66359d185, 0x0e0e380e70361c7e, 0x1f1f7c1ff8633ee7,
    0x6262956237f7c455, 0xd4d477d4eea3b53a, 0xa8a89aa829324d81, 0x96966296c4f43152,
    0xf9f9c3f99b3aef62, 0xc5c533c566f697a3, 0x2525942535b14a10, 0x59597959f220b2ab,
    0x84842a8454ae15d0, 0x7272d572b7a7e4c5, 0x3939e439d5dd72ec, 0x4c4c2d4c5a619816,
    0x5e5e655eca3bbc94, 0x7878fd78e785f09f, 0x3838e038ddd870e5, 0x8c8c0a8c14860598,
    0xd1d163d1c6b2bf17, 0xa5a5aea5410b57e4, 0xe2e2afe2434dd9a1, 0x616199612ff8c24e,
    0xb3b3f6b3f1457b42, 0x2121842115a54234, 0x9c9c4a9c94d62508, 0x1e1e781ef0663cee,
    0x4343114322528661, 0xc7c73bc776fc93b1, 0xfcfcd7fcb32be54f, 0x0404100420140824,
    0x51515951b208a2e3, 0x99995e99bcc72f25, 0x6d6da96d4fc4da22, 0x0d0d340d68391a65,
    0xfafacffa8335e979, 0xdfdf5bdfb684a369, 0x7e7ee57ed79bfca9, 0x242490243db44819,
    0x3b3bec3bc5d776fe, 0xabab96ab313d4b9a, 0xcece1fce3ed181f0, 0x1111441188552299,
    0x8f8f068f0c890383, 0x4e4e254e4a6b9c04, 0xb7b7e6b7d1517366, 0xebeb8beb0b60cbe0,
    0x3c3cf03cfdcc78c1, 0x81813e817cbf1ffd, 0x94946a94d4fe3540, 0xf7f7fbf7eb0cf31c,
    0xb9b9deb9a1676f18, 0x13134c13985f268b, 0x2c2cb02c7d9c5851, 0xd3d36bd3d6b8bb05,
    0xe7e7bbe76b5cd38c, 0x6e6ea56e57cbdc39, 0xc4c437c46ef395aa, 0x03030c03180f061b,
    0x565645568a13acdc, 0x44440d441a49885e, 0x7f7fe17fdf9efea0, 0xa9a99ea921374f88,
    0x2a2aa82a4d825467, 0xbbbbd6bbb16d6b0a, 0xc1c123c146e29f87, 0x53535153a202a6f1,
    0xdcdc57dcae8ba572, 0x0b0b2c0b58271653, 0x9d9d4e9d9cd32701, 0x6c6cad6c47c1d82b,
    0x3131c43195f562a4, 0x7474cd7487b9e8f3, 0xf6f6fff6e309f115, 0x464605460a438c4c,
    0xacac8aac092645a5, 0x89891e893c970fb5, 0x14145014a04428b4, 0xe1e1a3e15b42dfba,
    0x16165816b04e2ca6, 0x3a3ae83acdd274f7, 0x6969b9696fd0d206, 0x09092409482d1241,
    0x7070dd70a7ade0d7, 0xb6b6e2b6d954716f, 0xd0d067d0ceb7bd1e, 0xeded93ed3b7ec7d6,
    0xcccc17cc2edb85e2, 0x424215422a578468, 0x98985a98b4c22d2c, 0xa4a4aaa4490e55ed,
    0x2828a0285d885075, 0x5c5c6d5cda31b886, 0xf8f8c7f8933fed6b, 0x8686228644a411c2,

################################################################################

TITLE
    Whirlpool rc

TYPE
    64

DATA
    //0x0000000000000000,
    0x1823c6e887b8014f,
    0x36a6d2f5796f9152,
    0x60bc9b8ea30c7b35,
    0x1de0d7c22e4bfe57,
    0x157737e59ff04ada,
    0x58c9290ab1a06b85,
    0xbd5d10f4cb3e0567,
    0xe427418ba77d95d8,
    0xfbee7c66dd17479e,
    0xca2dbf07ad5a8333,

################################################################################

TITLE
    Gost hash sbox 1

TYPE
    32

DATA
    0x72000UL, 0x75000UL, 0x74800UL, 0x71000UL, 0x76800UL,
	0x74000UL, 0x70000UL, 0x77000UL, 0x73000UL, 0x75800UL,
	0x70800UL, 0x76000UL, 0x73800UL, 0x77800UL, 0x72800UL,
	0x71800UL, 0x5A000UL, 0x5D000UL, 0x5C800UL, 0x59000UL,
	0x5E800UL, 0x5C000UL, 0x58000UL, 0x5F000UL, 0x5B000UL,
	0x5D800UL, 0x58800UL, 0x5E000UL, 0x5B800UL, 0x5F800UL,
	0x5A800UL, 0x59800UL, 0x22000UL, 0x25000UL, 0x24800UL,
	0x21000UL, 0x26800UL, 0x24000UL, 0x20000UL, 0x27000UL,
	0x23000UL, 0x25800UL, 0x20800UL, 0x26000UL, 0x23800UL,
	0x27800UL, 0x22800UL, 0x21800UL, 0x62000UL, 0x65000UL,
	0x64800UL, 0x61000UL, 0x66800UL, 0x64000UL, 0x60000UL,
	0x67000UL, 0x63000UL, 0x65800UL, 0x60800UL, 0x66000UL,
	0x63800UL, 0x67800UL, 0x62800UL, 0x61800UL, 0x32000UL,
	0x35000UL, 0x34800UL, 0x31000UL, 0x36800UL, 0x34000UL,
	0x30000UL, 0x37000UL, 0x33000UL, 0x35800UL, 0x30800UL,
	0x36000UL, 0x33800UL, 0x37800UL, 0x32800UL, 0x31800UL,
	0x6A000UL, 0x6D000UL, 0x6C800UL, 0x69000UL, 0x6E800UL,
	0x6C000UL, 0x68000UL, 0x6F000UL, 0x6B000UL, 0x6D800UL,
	0x68800UL, 0x6E000UL, 0x6B800UL, 0x6F800UL, 0x6A800UL,
	0x69800UL, 0x7A000UL, 0x7D000UL, 0x7C800UL, 0x79000UL,
	0x7E800UL, 0x7C000UL, 0x78000UL, 0x7F000UL, 0x7B000UL,
	0x7D800UL, 0x78800UL, 0x7E000UL, 0x7B800UL, 0x7F800UL,
	0x7A800UL, 0x79800UL, 0x52000UL, 0x55000UL, 0x54800UL,
	0x51000UL, 0x56800UL, 0x54000UL, 0x50000UL, 0x57000UL,
	0x53000UL, 0x55800UL, 0x50800UL, 0x56000UL, 0x53800UL,
	0x57800UL, 0x52800UL, 0x51800UL, 0x12000UL, 0x15000UL,
	0x14800UL, 0x11000UL, 0x16800UL, 0x14000UL, 0x10000UL,
	0x17000UL, 0x13000UL, 0x15800UL, 0x10800UL, 0x16000UL,
	0x13800UL, 0x17800UL, 0x12800UL, 0x11800UL, 0x1A000UL,
	0x1D000UL, 0x1C800UL, 0x19000UL, 0x1E800UL, 0x1C000UL,
	0x18000UL, 0x1F000UL, 0x1B000UL, 0x1D800UL, 0x18800UL,
	0x1E000UL, 0x1B800UL, 0x1F800UL, 0x1A800UL, 0x19800UL,
	0x42000UL, 0x45000UL, 0x44800UL, 0x41000UL, 0x46800UL,
	0x44000UL, 0x40000UL, 0x47000UL, 0x43000UL, 0x45800UL,
	0x40800UL, 0x46000UL, 0x43800UL, 0x47800UL, 0x42800UL,
	0x41800UL, 0xA000UL,  0xD000UL,  0xC800UL,  0x9000UL,
	0xE800UL,  0xC000UL,  0x8000UL,  0xF000UL,  0xB000UL,
	0xD800UL,  0x8800UL,  0xE000UL,  0xB800UL,  0xF800UL,
	0xA800UL,  0x9800UL,  0x2000UL,  0x5000UL,  0x4800UL,
	0x1000UL,  0x6800UL,  0x4000UL,  0x0UL,     0x7000UL,
	0x3000UL,  0x5800UL,  0x800UL,   0x6000UL,  0x3800UL,
	0x7800UL,  0x2800UL,  0x1800UL,  0x3A000UL, 0x3D000UL,
	0x3C800UL, 0x39000UL, 0x3E800UL, 0x3C000UL, 0x38000UL,
	0x3F000UL, 0x3B000UL, 0x3D800UL, 0x38800UL, 0x3E000UL,
	0x3B800UL, 0x3F800UL, 0x3A800UL, 0x39800UL, 0x2A000UL,
	0x2D000UL, 0x2C800UL, 0x29000UL, 0x2E800UL, 0x2C000UL,
	0x28000UL, 0x2F000UL, 0x2B000UL, 0x2D800UL, 0x28800UL,
	0x2E000UL, 0x2B800UL, 0x2F800UL, 0x2A800UL, 0x29800UL,
	0x4A000UL, 0x4D000UL, 0x4C800UL, 0x49000UL, 0x4E800UL,
	0x4C000UL, 0x48000UL, 0x4F000UL, 0x4B000UL, 0x4D800UL,
	0x48800UL, 0x4E000UL, 0x4B800UL, 0x4F800UL, 0x4A800UL,
	0x49800UL,

################################################################################

TITLE
    Haval hash pass2

TYPE
    32 AND

DATA
    0x452821E6UL    0x38D01377UL    0xBE5466CFUL    0x34E90C6CUL
    0xC0AC29B7UL    0xC97C50DDUL    0x3F84D5B5UL    0xB5470917UL
    0x9216D5D9UL    0x8979FB1BUL    0xD1310BA6UL    0x98DFB5ACUL
    0x2FFD72DBUL    0xD01ADFB7UL    0xB8E1AFEDUL    0x6A267E96UL
    0xBA7C9045UL    0xF12C7F99UL    0x24A19947UL    0xB3916CF7UL
    0x0801F2E2UL    0x858EFC16UL    0x636920D8UL    0x71574E69UL
    0xA458FEA3UL    0xF4933D7EUL    0x0D95748FUL    0x728EB658UL
    0x718BCD58UL    0x82154AEEUL    0x7B54A41DUL    0xC25A59B5UL

################################################################################

TITLE
    War Times CRC algorithm

TYPE
    32

DATA
    0x0000162e, 0x000004d0, 0x00001994, 0x00002694

################################################################################

TITLE
    Playgate decoding/encoding algorithm

TYPE
    8

DATA
    "\x28\xE5\xBA\x0A\x99\x20\x6F\x0F\x38\x90\xD8\x34\xC0\x54\x96\xD9"
    "\xAA\x5D\xA4\x45\xFB\xB4\xAC\x27\x42\xE9\x8B\x30\x29\xA1\x5B\x97"
    "\x73\xCC\x7A\x8D\xCE\x92\x95\xE7\x98\xE8\xDE\x5F\x9A\x6E\x6D\x8E"
    "\x62\xB0\xFA\xD5\xD2\x74\x40\x2D\x64\x02\xBE\x88\x71\x4F\x61\x4D"
    "\xFC\x91\x81\xA6\x4A\xEA\x50\xE3\xA3\x66\x67\xF2\xDA\xF5\x4C\xDC"
    "\x23\xFE\x36\x86\x04\x3E\xC2\x60\xEF\xF0\xEE\xE1\x06\xAE\x8A\x63"
    "\x8C\xA7\x72\xBC\x82\x69\x46\xAF\xE6\xEB\x09\x1F\xDB\x0B\xB8\x5C"
    "\x11\xB6\x07\x6B\x18\x4B\x89\x48\x13\x9C\x3F\x55\x17\x35\xED\xDD"
    "\x79\x5E\x2E\x3A\xAD\x3B\xB1\x15\xB3\x6C\xE0\xF8\xF7\x9F\x03\x2C"
    "\x56\x7F\x1A\x87\x0D\xE2\x78\x4E\x2F\x1B\xD6\x51\xCF\x1D\xD7\xFF"
    "\xD4\xAB\x00\x08\x33\xF3\xA8\xC5\xC1\xEC\x52\xF4\x68\x7C\x84\xD3"
    "\x80\x57\x01\xA2\xB7\xD0\x70\xCB\xFD\x3C\x9B\x14\x65\x58\x12\x26"
    "\xBB\xA5\x05\xBD\xCA\xB2\xB5\x76\x37\x2A\xCD\x39\x1E\x47\x5A\x85"
    "\x8F\x22\xB9\x53\x6A\x59\x10\xC7\x7E\x1C\x44\xF1\x25\xC8\x83\x9E"
    "\xC3\x7D\xBF\x49\x32\x19\xC4\xD1\x77\xF6\xC6\x9D\xA9\x7B\xA0\xE4"
    "\x41\x0C\x93\xC9\x0E\xDF\x2B\x24\xF9\x75\x3D\x94\x21\x43\x16\x31"

################################################################################

TITLE
    Teamsound join password algorithm

TYPE
    8

DATA
        "\xD4\x70\x5F\x69\xC3\x10\xEC\xF5\x62\x1C\xF3\x39\xC9\xF9\xBC\x7C"
        "\xD6\x7D\x2E\xE4\x57\xD2\x4B\x6B\xCE\x0E\xEB\x77\x84\xE9\xCC\x25"
        "\xBB\xA8\x40\x3D\x67\xAD\xAF\x1F\x1D\x41\x83\x28\x8C\x6E\x2D\x06"
        "\x9A\xDC\xA6\x03\x66\x7E\x29\x8F\xDD\x6F\xFE\x3A\x01\x16\x43\x7B"
        "\xCF\x64\x9E\x9B\x23\xC0\x81\x0F\x18\x3F\x56\x1B\xEA\xD0\x8D\x07"
        "\x5D\x0C\x31\x47\x50\x11\x24\xA3\xAC\xD1\xE2\xFF\xC5\xE6\x5A\xFC"
        "\x87\x60\x02\x7A\xAE\xB0\x3C\x71\xB7\xFD\x33\x44\x92\x54\xD7\x65"
        "\xE1\xC4\xB9\xD9\x21\x4E\x26\x93\x38\x76\x3B\x9F\xF7\x78\x5E\x3E"
        "\xFB\x17\xDA\x22\xE3\x48\x4C\x53\x12\xF2\x0B\x61\x72\xCD\xBD\xB8"
        "\xEF\xA0\xE5\x7F\x68\xF6\x51\x73\x1A\xB2\xDF\x27\x2B\x0A\x19\x5B"
        "\xC7\x90\x8E\xAA\x36\x8A\x6D\x2F\x00\xE0\x1E\x85\xC2\xC8\x91\xCA"
        "\xD5\x9D\x04\x0D\x20\x95\x98\x35\xDE\xA1\x75\xBA\x9C\x89\x58\x86"
        "\xB4\x49\xD8\xA7\xA2\xC1\xB3\xC6\x4F\xF4\x82\x55\x32\x46\x15\xD3"
        "\x52\xFA\xAB\xBE\xA5\x6C\x59\xF8\xBF\x2A\xA4\x14\xE7\x5C\x2C\x88"
        "\xB1\x6A\x97\x30\x37\x13\x94\x99\xDB\x42\x4D\xA9\xF0\x74\xF1\x05"
        "\xB5\x8B\x45\x09\xED\x96\x79\x63\x08\x4A\x34\xCB\x80\xE8\xB6\xEE"

################################################################################

TITLE
    Ultima Online login encryption algorithm

TYPE
    16, 32

DATA
    0x0068, 0x0005, 0x0007, 0x8000, 0x0002, 0x0005, 0x0005, 0x0007,
    0x000e, 0x0005, 0x000b, 0x0007, 0x8000, 0x0003, 0x8000, 0x003d,
    0x00d7, 0x8000, 0x8000, 0x000a, 0x0006, 0x0009, 0x8000, 0x8000,
    0x8000, 0x8000, 0x8000, 0x0025, 0x8000, 0x0005, 0x0004, 0x0008,
    0x0013, 0x0008, 0x0003, 0x001a, 0x0007, 0x0014, 0x0005, 0x0002,
    0x0005, 0x0001, 0x0005, 0x0002, 0x0002, 0x0011, 0x000f, 0x000a,
    0x0005, 0x8000, 0x0002, 0x0002, 0x000a, 0x028d, 0x8000, 0x0008,
    0x0007, 0x0009, 0x8000, 0x8000, 0x8000, 0x0002, 0x0025, 0x8000,
    0x00c9, 0x8000, 0x8000, 0x0229, 0x02c9, 0x0005, 0x8000, 0x000b,
    0x0049, 0x005d, 0x0005, 0x0009, 0x8000, 0x8000, 0x0006, 0x0002,
    0x8000, 0x8000, 0x8000, 0x0002, 0x000c, 0x0001, 0x000b, 0x006e,
    0x006a, 0x8000, 0x8000, 0x0004, 0x0002, 0x0049, 0x8000, 0x0031,
    0x0005, 0x0009, 0x000f, 0x000d, 0x0001, 0x0004, 0x8000, 0x0015,
    0x8000, 0x8000, 0x0003, 0x0009, 0x0013, 0x0003, 0x000e, 0x8000,
    0x001c, 0x8000, 0x0005, 0x0002, 0x8000, 0x0023, 0x0010, 0x0011,
    0x8000, 0x0009, 0x8000, 0x0002, 0x8000, 0x000d, 0x0002, 0x8000,
    0x003e, 0x8000, 0x0002, 0x0027, 0x0045, 0x0002, 0x8000, 0x8000,
    0x0042, 0x8000, 0x8000, 0x8000, 0x000b, 0x8000, 0x8000, 0x8000,
    0x0013, 0x0041, 0x8000, 0x0063, 0x8000, 0x0009, 0x8000, 0x0002,
    0x8000, 0x001a, 0x8000, 0x0102, 0x0135, 0x0033, 0x8000, 0x8000,
    0x0003, 0x0009, 0x0009, 0x0009, 0x0095, 0x8000, 0x8000, 0x0004,
    0x8000, 0x8000, 0x0005, 0x8000, 0x8000, 0x8000, 0x8000, 0x000d,
    0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x0040, 0x0009, 0x8000,
    0x8000, 0x0003, 0x0006, 0x0009, 0x0003, 0x8000, 0x8000, 0x8000,
    0x0024, 0x8000, 0x8000, 0x8000, 0x0006, 0x00cb, 0x0001, 0x0031,
    0x0002, 0x0006, 0x0006, 0x0007, 0x8000, 0x0001, 0x8000, 0x004e,
    0x8000, 0x0002, 0x0019, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
    0x8000, 0x010c, 0x8000, 0x8000, 0x0009, 0x8000

################################################################################

TITLE
    Empires Dawn of the modern World: packets algorithm

TYPE
    8

DATA
            "\x00\xE7\x1A\x56\xF3\x3D\x28\x13\xCF\x1F\x2E\xDA\x5B\x80\xF2\xF3"
            "\x73\x3D\x09\xBA\x4A\x7F\x33\x93\x1D\xB3\x3A\x90\xFC\x5C\xFA\x5F"
            "\x99\xC7\xF8\xAF\xA7\xF6\x3D\xBF\xEC\xB0\xC3\x2A\x63\x1D\x48\xA9"
            "\x99\xD4\xAE\xF2\xBF\xD2\xDF\x51\x7C\x23\x4D\x26\xF8\xC4\xF6\x02"
            "\x4F\x97\x35\x6C\xC0\xD1\x05\x14\xCC\xCF\x2F\x80\xB4\xB8\x04\xFC"
            "\x6A\xCD\xFB\xD2\x70\xE4\x04\x89\xC1\xD3\xBB\x50\x39\x5C\x6A\x31"
            "\x8B\x5D\xFA\x46\x53\xCB\xC3\x89\x42\x44\x58\x69\xF0\xB4\x42\xDB"
            "\x64\xF3\xD0\xF6\xC5\xB8\xD6\xDB\x56\xCF\xA2\xFC\x33\x07\xE4\x7B"
            "\xDC\xA7\xDF\xBD\x1E\xEC\xA1\xE0\x48\x5D\x8E\x37\x5E\x7A\x08\x78"
            "\x2C\x98\x75\xC3\xCF\x5A\x75\x2C\xC6\xAC\x85\xE2\x00\xB4\xDF\xB9"
            "\xFC\x8D\xE0\x1C\x86\x43\xB1\x25\x01\xF3\x87\x05\xEC\x7B\x40\x4F"
            "\x8D\x96\x9B\x66\x49\xDB\xE5\xA8\xCA\x85\x4D\x80\x66\x58\xBA\x0B"
            "\xCC\xAB\x63\x70\x99\xE7\xED\xA7\xB7\x69\x63\xB5\x34\x32\xBE\x24"
            "\x7D\x4F\x5C\xD3\x93\x5A\x16\xC7\x40\x00\x4E\x1E\xCE\xF0\xBC\xD6"
            "\x54\x2A\x33\x95\x0D\xF8\x38\x03\xDD\xA4\xA9\xF2\x74\x1E\x41\x03"
            "\x18\xAD\x39\xC8\xB7\xF8\xDC\x47\x2E\x48\x44\xC8\x4E\x82\x17\xCD"

################################################################################

TITLE
    Gamespy GSMSALG

TYPE
    8

DATA
        "\x01\xba\xfa\xb2\x51\x00\x54\x80\x75\x16\x8e\x8e\x02\x08\x36\xa5"
        "\x2d\x05\x0d\x16\x52\x07\xb4\x22\x8c\xe9\x09\xd6\xb9\x26\x00\x04"
        "\x06\x05\x00\x13\x18\xc4\x1e\x5b\x1d\x76\x74\xfc\x50\x51\x06\x16"
        "\x00\x51\x28\x00\x04\x0a\x29\x78\x51\x00\x01\x11\x52\x16\x06\x4a"
        "\x20\x84\x01\xa2\x1e\x16\x47\x16\x32\x51\x9a\xc4\x03\x2a\x73\xe1"
        "\x2d\x4f\x18\x4b\x93\x4c\x0f\x39\x0a\x00\x04\xc0\x12\x0c\x9a\x5e"
        "\x02\xb3\x18\xb8\x07\x0c\xcd\x21\x05\xc0\xa9\x41\x43\x04\x3c\x52"
        "\x75\xec\x98\x80\x1d\x08\x02\x1d\x58\x84\x01\x4e\x3b\x6a\x53\x7a"
        "\x55\x56\x57\x1e\x7f\xec\xb8\xad\x00\x70\x1f\x82\xd8\xfc\x97\x8b"
        "\xf0\x83\xfe\x0e\x76\x03\xbe\x39\x29\x77\x30\xe0\x2b\xff\xb7\x9e"
        "\x01\x04\xf8\x01\x0e\xe8\x53\xff\x94\x0c\xb2\x45\x9e\x0a\xc7\x06"
        "\x18\x01\x64\xb0\x03\x98\x01\xeb\x02\xb0\x01\xb4\x12\x49\x07\x1f"
        "\x5f\x5e\x5d\xa0\x4f\x5b\xa0\x5a\x59\x58\xcf\x52\x54\xd0\xb8\x34"
        "\x02\xfc\x0e\x42\x29\xb8\xda\x00\xba\xb1\xf0\x12\xfd\x23\xae\xb6"
        "\x45\xa9\xbb\x06\xb8\x88\x14\x24\xa9\x00\x14\xcb\x24\x12\xae\xcc"
        "\x57\x56\xee\xfd\x08\x30\xd9\xfd\x8b\x3e\x0a\x84\x46\xfa\x77\xb8"

################################################################################

TITLE
    GS SDK challenge-response algorithm default key

TYPE
    8

DATA
    "3b8dd8995f7c40a9a5c5b7dd5b481341"

################################################################################

TITLE
    GS SDK challenge-response algorithm (Soldier of Anarchy) key

TYPE
    8

DATA
    "0AB3F935936211D19A2B080000300512"

################################################################################

TITLE
    All Seeing Eye UDP packets decoding/encoding algorithm

TYPE
    32

DATA
        0x0ff97174, 0x1f9bd468, 0x37849969, 0x4e89ae73,
        0x612bf420, 0x67d79c63, 0x6d77656f, 0x745adb64,
        0x7bea3365, 0x834ce620, 0x89795069, 0x8f45bf73,
        0x96a87220, 0x9ec22f73, 0xa63fab74, 0xac514d6f,
        0xb267656c, 0xb8413965, 0xbfe26c6e, 0xc797b620,
        0xcc6a2266, 0xcf2ffb72, 0xd1fa4c6f, 0xd5eb436d,
        0xd9e9a020, 0xdc48ca54, 0xdcb1b468, 0xdd11b165,
        0xdd7cd620, 0xde4c6f41, 0xded49a6c, 0xdf15566c,
        0xdf5a892d, 0xdfc13753, 0xe0184665, 0xe0525065,
        0xe07cb969, 0xe09e356e, 0xe0d3c867, 0xe116bf20,
        0xe1412945, 0xe1606979, 0xe17b3365, 0xe1a59c20,
        0xe1d8f428, 0xe20c4b63, 0xe236b429, 0xe253b920,
        0xe26e8355, 0xe2aac844, 0xe2c7cd50, 0xe2f6ad20,
        0xe3117753, 0xe32e7c6f, 0xe3523366, 0xe37c9c74,
        0xe39e1820, 0xe3d5e64c, 0xe3f76254, 0xe4146744,
        0xe42cf52e, 0xe44e7120, 0xe46db168, 0xe49a5674,
        0xe4c28474, 0xe4df8970, 0xe501053a, 0xe519932f,
        0xe5345c2f, 0xe5633c77, 0xe5969477, 0xe5b15d77,
        0xe5d09e2e, 0xe5eb6775, 0xe6063064, 0xe627ac70,
        0xe64d9f73, 0xe66f1b6f, 0xe6856d66, 0xe69dfb74,
        0xe6b8c42e, 0xe6d5c963, 0xe6ec1c6f, 0xe706e56d,
        0xe71d3831, 0xe73c7880, 0xe7597d5b, 0xe76fcfdd,
        0xe79c74df, 0xe7b502d4, 0xe7d44323, 0xe7ea95a4,
        0xe80c1166, 0xe8249f5b, 0xe841a436, 0xe869d252,
        0xe88024d4, 0xe898b2c8, 0xe8b140bd, 0xe8dbaa4c,
        0xe8f43841, 0xe90a8ac2, 0xe920dd44, 0xe9449479,
        0xe95ae6fa, 0xe977ebd6, 0xe9972c24, 0xe9ad7ea6,
        0xe9c8480e, 0xe9e54ce9, 0xe9fb9f6a, 0xea142d5f,
        0xea2cbb54, 0xea4784bc, 0xea5dd73d, 0xea7429be,
        0xea936a0d, 0xeaa9bc8f, 0xeac24a83, 0xead89d05,
        0xeaeeef86, 0xeb054207, 0xeb1b9489, 0xeb31e70a,
        0xeb559e3f, 0xeb6bf0c1, 0xeb824342, 0xeb9895c3,
        0xebb59a9f, 0xebcbed20, 0xebe23fa1, 0xec05f6d7,
        0xec1e84cb, 0xec34d74d, 0xec4b29ce, 0xec63b7c3,
        0xec7a0a44, 0xec905cc5, 0xeca6af47, 0xecbd01c8,
        0xecd3544a, 0xece9a6cb, 0xecfff94c, 0xed164bce,
        0xed3350a9, 0xed49a32a, 0xed62311f, 0xed7883a0,
        0xed8ed622, 0xeda528a3, 0xedbb7b24, 0xedd1cda6,
        0xede82027, 0xedfe72a8, 0xee14c52a, 0xee2b17ab,
        0xee416a2c, 0xee57bcae, 0xee6e0f2f, 0xee8461b0,
        0xee9ab432, 0xeeb106b3, 0xeec75934, 0xeeddabb6,
        0xeef3fe37, 0xef0a50b9, 0xef20a33a, 0xef36f5bb,
        0xef4d483d, 0xef639abe, 0xef79ed3f, 0xef903fc1,
        0xefa69242, 0xefbce4c3, 0xefd33745, 0xefe989c6,
        0xefffdc47, 0xf0162ec9, 0xf02c814a, 0xf042d3cb,
        0xf059264d, 0xf06f78ce, 0xf08806c3, 0xf09e5944,
        0xf0b4abc5, 0xf0cafe47, 0xf0e150c8, 0xf0f7a34a,
        0xf10df5cb, 0xf124484c, 0xf13a9ace, 0xf150ed4f,
        0xf1673fd0, 0xf17d9252, 0xf1985bba, 0xf1aeae3b,
        0xf1c500bc, 0xf1db533e, 0xf1f1a5bf, 0xf207f840,
        0xf21e4ac2, 0xf2349d43, 0xf24aefc4, 0xf2614246,
        0xf27794c7, 0xf28de748, 0xf2a439ca, 0xf2ba8c4b,
        0xf2d0decc, 0xf2e7314e, 0xf2fd83cf, 0xf313d650,
        0xf32a28d2, 0xf3407b53, 0xf3590948, 0xf371973d,
        0xf387e9be, 0xf39e3c3f, 0xf3b48ec1, 0xf3cd1cb5,
        0xf3e36f37, 0xf3f9c1b8, 0xf4101439, 0xf42666bb,
        0xf43cb93c, 0xf4530bbd, 0xf4695e3f, 0xf47fb0c0,
        0xf4960341, 0xf4ac55c3, 0xf4c2a844, 0xf4d8fac5,
        0xf4ef4d47, 0xf5059fc8, 0xf51bf249, 0xf53244cb,
        0xf548974c, 0xf55ee9ce, 0xf5753c4f, 0xf58b8ed0,
        0xf5a1e152, 0xf5b833d3, 0xf5ce8654, 0xf5e4d8d6,
        0xf5fb2b57, 0xf6117dd8, 0xf627d05a, 0xf63e22db,
        0xf654755c, 0xf66ac7de, 0xf6811a5f, 0xf6976ce0,
        0xf6adbf62, 0xf6c411e3, 0xf6da6464, 0xffffffff };

################################################################################

TITLE
    All Seeing Eye 'v' ping (aka scanner) algorithm

TYPE
    32

DATA
 0x0109a70d, 0x30d621ac, 0x44d52cc7, 0x16a343ab,
 0x30c7cb66, 0x64e65400, 0x6f0c2b78, 0xe6bea4d8,
 0x80167528, 0x002ce936, 0xe465518b, 0xf28d4c4b,
 0x5866ff57, 0xd4b79029, 0x3a711818, 0x52001968,
 0xeda001ac, 0x42cba660, 0x0d5a63a5, 0xa82fb91b,
 0xc4512deb, 0xb636b73d, 0x3f30f44e, 0xa0d0279f,
 0x16bee383, 0x9aa0557b, 0x375d38e5, 0x25033006,
 0x41760f0f, 0x56e43c26, 0x7cb59306, 0x9d30d5f4,
 0xdc21629a, 0x4c2df2f7, 0x85463b50, 0xedcc1cf2,
 0x76d228f7, 0x3d7ca241, 0xd3a4f5f8, 0x273bebe3,
 0xb3bffb5d, 0x48650da8, 0xd688c129, 0xf6942ade,
 0x9536d9b6, 0xcf4e9e95, 0x73fb348e, 0xa29fd21e,
 0x9f17c38f, 0x2fbca3aa, 0x188a3293, 0xda6bc5fe,
 0xd7d8506c, 0x238afe34, 0x695244b4, 0x6a22fa7d,
 0x1b9d85cd, 0x7b97397c, 0xaec8cfdc, 0x22d77196,
 0x348ef65b, 0x6b5e3dee, 0x75ddafba, 0x29321bb7,
 0x47032744, 0xc979bb4f, 0x6005b770, 0x8ec945ff,
 0x1099655c, 0x3c0c778f, 0xd2793667, 0x83edacb1,
 0xdb95fdd6, 0x364b5827, 0xbad1d7bc, 0x04b16c21,
 0x35d03527, 0x5404f4ae, 0xbe1ee679, 0x63b8e5a7,
 0x8b32bc01, 0x6c431003, 0xa2a94b89, 0x4d69d098,
 0xa9c0b4e0, 0x2b7aa1c0, 0x616e30c5, 0x81672bd1,
 0x514e0b00, 0xcd476111, 0x8d379eb7, 0xdc356302,
 0xac4acccc, 0xbbb46b73, 0xdf128b47, 0x99507f69,
 0x53e0747b, 0x675a160f, 0x19d31aaf, 0xca3cf7be,
 0x5a60c62f, 0x9ce8858d, 0x46f1ebc0, 0x583e8146,
 0x933879fc, 0x06951ef0, 0x2201d2fb, 0x1b01e8ca,
 0xffb898a9, 0x11c21492, 0x9bf7807a, 0xd242970d,
 0xe8874609, 0x2e8f2c84, 0x64c277f2, 0x3718f36e,
 0x9abb9599, 0xbe9e6856, 0xbdf5041b, 0xd6a2c6a2,
 0x5edc64ee, 0xb4482f09, 0x849bdd0c, 0xac45b3cc,
 0xe12ae245, 0x0bb0384a, 0xb65b2ffd, 0x3e49ddad,
 0x9134caae, 0xe7f1baa6, 0x43f6c5c3, 0x2dec4eed,
 0x12293d42, 0xcb5d822e, 0xe76a334f, 0xf33469d9,
 0x08d43a43, 0x7c140a91, 0x566b4815, 0xb9c59483,
 0x4ba508d8, 0xb8724f01, 0x9e145705, 0x4edb8d40,
 0x8e4899df, 0x131b720a, 0x4d6cdf73, 0xec400f50,
 0x72e98d2c, 0x9b80fbfc, 0xdab27ec9, 0x8274d8a4,
 0x50fe699b, 0xf0625e90, 0x66e56107, 0x620edca9,
 0xb153e433, 0x33e3d3eb, 0xc7944d16, 0x152adbc8,
 0x7ff3aa9f, 0xf739cfb5, 0x782fe1a8, 0xd03dc32d,
 0x52906c1e, 0x84ef8cd2, 0x77b7da12, 0xe075c44d,
 0x8724c7a3, 0xe4ad86d7, 0x11e1a008, 0x89465954,
 0x5c35ec7f, 0xdf169985, 0x078cc964, 0x709a42d0,
 0x654c4aa7, 0xebb61862, 0xd1185e76, 0xd8c1cb3c,
 0x2f64590e, 0xe24fda24, 0x8a44bfea, 0x5e68f876,
 0x1ea20039, 0x90e1323a, 0x82e842cf, 0xc58b7e38,
 0xf3fdd36e, 0x8509bc5d, 0x329897bd, 0x5c412db2,
 0x20a3f2ed, 0x09fcfdf1, 0xf6ba9ada, 0xbff80ee4,
 0xd8dfe99c, 0x97aa7625, 0xcd636db9, 0x1dc61fa0,
 0xf7e71e80, 0x79bf40b6, 0xb5fa07d2, 0x246a0c6c,
 0xee9f206a, 0xba59791c, 0xaf4da18c, 0x9e12ae35,
 0xbc9a4f4c, 0x0f27ad65, 0x7a19cd94, 0xadaf7c93,
 0xe36931a2, 0x6e089de7, 0xfaffa559, 0xb0e265e6,
 0x5f438e10, 0x0d21281f, 0x746824e3, 0x1eee0bd4,
 0x31c54c2b, 0x453fd632, 0x2dc65b03, 0x6893a99e,
 0xcf220313, 0xfad2537a, 0xf43b1d62, 0xf99dfca5,
 0x86aa8a95, 0x65d836e8, 0x1759566d, 0x4aa6bd1d,
 0xaba79dca, 0x6db91d07, 0x881adb87, 0x12f79533,
 0xa87d5fb8, 0x7fda87e2, 0x68e49ca0, 0x5b921ad3,
 0x00e2b8f4, 0xa74af130, 0x237e3e26, 0x2c53ea71,
 0x9c3a10ef, 0x75774b17, 0x3d754eec, 0x0aa541ba,
 0x2e9c3f17, 0x351a2967, 0x9804dc0b, 0x5ade0982,
 0x04eb8f90, 0x7ae5b2d6, 0xc5bd260a, 0x01e02520,
 0xb03ffe77, 0x69dce41a, 0x7def158a, 0xb1026a86,
 0xf1477ae8, 0x945c3357, 0x6e7860d7, 0xa1c73a6a,
 0x3e82b2b1, 0xa3d99a37, 0x6dcfde3a, 0x2887354c,
 0x6b8622d5, 0x3f85b679, 0xd4b672f1, 0x92f6affd,
 0xa7b04941, 0x47284972, 0x898bbd4a, 0x8d17442c,
 0x26737cb5, 0xc0d3ab78, 0x6c5823e1, 0x61ff7358,
 0x2bc3f0f0, 0xa531cef6, 0x920d76c1, 0xfb2b262f,
 0x2120b137, 0xeabd5b53, 0xad6121a4, 0x8ad1518a,
 0xe213d181, 0x1a263fb4, 0xfc859bde, 0x4b8e05ec,
 0x5bf4c4f5, 0x77837515, 0x1d06c238, 0xfda74749,
 0x62cc39c6, 0x07888b5f, 0xdd2bc87c, 0xe8acee05,
 0x55896eb0, 0x8c576075, 0xf983ac3c, 0xc7299281,
 0x25eabe69, 0x101d8f5b, 0x4f1c0e82, 0xde7e66c1,
 0x57eea27d, 0x502e0194, 0xe6679fbf, 0x71cfccc4,
 0xa5d68365, 0xc2a85dc2, 0xbf92b586, 0x8f448a48,
 0xc370bad9, 0x80bbff4e, 0xde26d658, 0xf5734a64,
 0xa6d9ce11, 0x4f336261, 0xeffc9132, 0x18119fb0,
 0x0e576f34, 0x594d3ebc, 0x7ede375f, 0x51fdb8dc,
 0x9d7c1914, 0xbd370752, 0x49acf7ff, 0xa9fbd4c6,
 0x0f40bb2d, 0x7e86de8e, 0x48f83cc2, 0x43547d08,
 0x09b92920, 0x8707e17f, 0x2cb3a6e2, 0x2060e3cf,
 0xf0daf130, 0xe5e95659, 0xf8416b51, 0xff8113b8,
 0x4e029661, 0xcc15f618, 0xc945ead1, 0xafc80219,
 0x0a74d422, 0x5dc004b9, 0xc1841121, 0x46c3f0e9,
 0x815c5af6, 0xa684ca5a, 0xc262e59e, 0x0eeb9caf,
 0x966fa392, 0x1c5fc06f, 0xaaaea93f, 0x956cbe99,
 0x71555cf9, 0x8b38e69c, 0x79332e52, 0x600bc943,
 0x67caee3e, 0xdb9017e5, 0xd5cb0d02, 0xc67d7431,
 0x244b056f, 0x41968422, 0xa11d1fab, 0x0c76a82a,
 0xa4256768, 0xdda95abf, 0x4a2d7196, 0xab6e9366,
 0xeacd09cb, 0x38d5e010, 0xb8ade09d, 0x741f1197,
 0xcb772a53, 0x2166919a, 0xb7930236, 0xc4faa777,
 0x28f281a1, 0xc39806cb, 0x1a1b0c1c, 0x96f4d714,
 0x0b8f0691, 0xd720c77e, 0x838d9498, 0xaa0d4623,
 0x9754a4a6, 0xee8cc847, 0x70f9ae2e, 0xf8064db3,
 0x2a81735e, 0x191031fa, 0xe0b489be, 0x7d785c6d,
 0x9400a85a, 0xb264670b, 0xb4c44374, 0xb555f5dd,
 0xc0d78454, 0x765812d5, 0x8f4f53c8, 0xef4ca587,
 0xb27f55d4, 0x3aae3bdb, 0x3ca17b84, 0x267bd1ef,
 0x3b31b624, 0xfe7f98fb, 0x3696c03b, 0x98f570c9,
 0x15e68255, 0xc1ea5f89, 0xf2b168aa, 0x880a6442,
 0x5942f8e7, 0x66cd7bdf, 0xca2cb9f3, 0x6f7022e0,
 0x14abfc1d, 0xc851c1f9, 0x061f7088, 0xe399503f,
 0x0ca67fd3, 0x32abb00c, 0x4049144b, 0xae529680,
 0x296dd825, 0xfc91cd5e, 0x02db921a, 0xe90f48ea,
 0xccece7d0, 0x02f37a63, 0x633e25dd, 0x72e7bfe1,
 0x05230a71, 0xd19c2413, 0x1f1558e4, 0xa4a47851,
 0x42a878fe, 0x7389e2f3, 0xecc98685, 0x5305803e,
 0xfdcef923, 0x9f24a06b, 0x130f1b31, 0xcec41528,
 0xeb07efdb, 0x40b3c20e, 0x270a40fa, 0x3b1c6fbb,
 0xfb5e1763, 0x31ca8ec3, 0xe93952ce, 0xf11e6dce,
 0xf50b16ad, 0x3963ed74, 0xd9f04172, 0xe1192eda,
 0x4c3d1340, 0x86dfe712, 0xbb56ed19, 0x08f0ef55,
 0xe57b54c4, 0x575b8345, 0xfe27fa7e, 0x05f26e9b,
 0x7bbc4504, 0x5fd400f5, 0xc897ad49, 0x93130804,
 0x6a0ef3b2, 0xbc822039, 0x1c726660, 0xb371eca3,
 0xd03cd51f, 0x14a1d93b, 0xb911872a, 0xd9feaacd,
 0x8c8088b3, 0x44ce0388, 0x455f4797, 0x5556572b,
 0x5d506ae6, 0x036ff944, 0x99911246, 0x2a6d888c,
 0x907ad08d, 0xb7b29bc7, 0x03edab75, 0x49f93416,
 0x332eb035, 0xd523df70, 0xa0af1cbb, 0x179bb1f8,
 0x38288ce9, 0xf4b5b58b, 0xa3e3b33d, 0xd33a89a1,
 0x54105d4d, 0x91ddb45c, 0xc69e7d56, 0x78ba23bd,
 0x39c1906b, 0x1f61529d, 0xce08e848, 0x342537c5,

################################################################################

TITLE
    Half-Life packets decoding/encoding function key

TYPE
    8, 32

DATA
    "\x05\x61\x7A\xED\x1B\xCA\x0D\x9B\x4A\xF1\x64\xC7\xB5\x8E\xDF\xA0"

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d4638

TYPE
    8

DATA
        "\xF7\xA9\x66\x11\xE1\x10\xEC\xC6\x7B\x67\x6A\xD4\x4B\x67\x38\xDA"
        "\x98\x38\xEC\x3A\x95\x82\xDD\x5A\xEA\x86\x28\x53\xD8\x02\x1E\x67"
        "\x24\x4F\xB9\xF7\x6E",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d4660

TYPE
    8

DATA
        "\x9B\x48\xE9\xD2\xE4\xF9\x86\x60\xB0\x95\x13\x67\x9D\x3E\x70\x8E"
        "\xD2\x77\xC3\xF8\x2E\x2A\x8D\x61\x57\x69\xF3\xB9\xC8\x4F\x30\xA0"
        "\x52\xC9\x84\x16\x2D\xCE\xC3\x2F\x99",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d468c

TYPE
    8

DATA
        "\xF1\xB2\xCD\x0E\x16\xA8\x5F\x2C\xC7\xF2\x15\x69\x17\x09\xC2\x20"
        "\xA1\x82\xC3\x8F\x3B\x56\x46\x54\x2F\xFB\x3D\xD0\x58\x94\xE2\xEA"
        "\x5C\xCD\x80\xC7\xEF\x9E\x3B\x91\xC4\xBB\xBC\x3B\xAE\xC6\x01",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d46bc

TYPE
    8

DATA
        "\xEB\xA5\x39\xBB\x84\x30\x97\xA4\xDB\x19\xD6\xBB\xAA\x2B\xDD\x64"
        "\xB5\x47\xF1\x90\xA8\xF9\xA5\xC2\x79\x51\xDE\x59\xDB\xF8\x2E\xAA"
        "\x16\x6C\x76\x14\xDA\xBA\xFB\x9E\x20\xC9\x64\x67\x95\xD5\xEF\xE9"
        "\x15\xE4\x3D\x9D\xAF",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d46f4

TYPE
    8

DATA
        "\x74\xD0\xD7\x3B\xC5\x2D\xFA\xB2\x19\xFC\x4A\x77\xFB\xE8\x53\x20"
        "\x35\x1D\xAB\x73\x99\x9F\x61\x2E\x58\x25\x15\x1C\x10\x00\x62\x72"
        "\x9A\x46\xCA\x45\x64\xE3\xC5\xA0\x59\xCE\xA4",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d4720

TYPE
    8

DATA
        "\x52\x7A\x88\x4B\x39\x64\xB2\x54\x61\x19\x24\x5F\x9B\xBE\x6B\x6E"
        "\xC6\xB8\x10\xA7\xD7\xAA\x22\xBC\xD3\xEA\xF9\x3E\x52\x5D\xC9\x17"
        "\x11\xCF\x20\x56\x4C\xE6\x53\xD4\x0B\xD7\xB2\x76\x63\x1E\xF3\x86"
        "\x91",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d4754

TYPE
    8

DATA
        "\x4D\x7F\xDB\x4C\xC8\x62\x82\x7B\xA1\x1F\xBB\x82\x91\x78\x42\x0D"
        "\x3C\xF6\x45\x65\xFA\x32\x10\xE7\x93\xD0\x4C\xED\x38\x0C\x3B\xA1"
        "\x42\x9D\x19\xBA\x60\x1C\xD9\x64\x7A\x83\x10\x41\x3F\xD5\x1E\x6A"
        "\xB4\xF8\x31",

################################################################################

TITLE
    Speed Challenge network encryption/decryption algorithm X4d4788

TYPE
    8

DATA
        "\x53\x7C\xC9\x16\x6C\xB3\x8A\xE1\x1E\xA7\x02\x6F\xDE\xE0\x0D\xC6"
        "\x50\x2D\x13\xB5\x37\x0A\x42\x0A\x48\x90\xF6\xB2\x2A\xD2\x07\x23"
        "\x3B\xA3\x05\xEF\x09\xD5\x6D\x53\x33\x92\xDA\x31\xFC\xA0\xB0\x53"
        "\x29\x46\x8C\x5B\xF3\x21\x23",

################################################################################

TITLE
    Speed Challenge files decoder

TYPE
    8

DATA
//            enc1[] =
//            "\x27\xF4\x94\x50\x33\x73\x67\x21\x27\xAA\xCD\x0D\x47\xD9\xD5\x78"
//            "\xBE\x90\x9E\x94\x3F\xC3\x1A\x1E\xED\x20\x12\x48\x78",
//            enc2[] =
//            "\xF5\x11\xD7\x25\x8D\xCB\x5B\xBE\x8D\xAA\x67\xE4\x84\xCC\x2F\x44"
//            "\x7B\xE5\x25\xDB\x88\x86\x28\x5D\xA0\xA0\xF8\xD8\xAD\x44\xEE\x94"
//            "\xE0\xAC\xEA\x3F\x49\x7F\x8C",
//            enc3[] =
            "\xCF\x20\x3A\xF7\x12\x7E\xF1\x9F\xF1\x9A\xB1\x6B\xAC\x48\x4A\xF8"
            "\x41\x1F\x47\xB4\x2F\x2D\xD1\x37\x7F\xEA\xD1\xD7\x05\x6B\x55\x76"
            "\xE4\xD8\x35\x9F\x50\x20\xF6\xD2\x98";

################################################################################

TITLE
    UBI.COM gschat encoding/decoding algorithm

TYPE
    32

DATA
 0x7d534b3b, 0x62efc73a, 0x969984ab, 0xde17df73,
 0x6c819824, 0x4fb6e4e6, 0xb86d4e76, 0xbad9457f,
 0x89071a49, 0x23bd3e2c, 0x219e1f09, 0x32b330aa,
 0x683d97e1, 0xac3ddab6, 0x397a7933, 0x3ba6beca,
 0x6e07ba4e, 0x212ed4a7, 0x95e620a6, 0x698b9b73,
 0x082b364c, 0x5e1d5e06, 0x5f8f034c, 0x631c7567,
 0x9621ba3a, 0x66704d9e, 0xb9e6bf43, 0x97cd7047,
 0x85bbeae7, 0xc0a12d0e, 0x960712ed, 0x279e3e35,
 0x49f2fe84, 0x69554f89, 0xb7f8cdd6, 0x4e4f7822,
 0x6aeeb9b3, 0xe10462d6, 0xbf97b9ea, 0x92db49ac,
 0x8e138e40, 0xe7c36b7c, 0x69d7a80a, 0x0f8b63a4,
 0xd39513b5, 0x8b4d63cb, 0x9ff77163, 0xf0184190,
 0x037518aa, 0x0c59df14, 0x62c198d7, 0xe2647625,
 0xadd69c81, 0x573f76f9, 0xc1a8579b, 0x0e47dedc,
 0xa9874318, 0x343cc91f, 0xa10703db, 0x8977e1fd,
 0xbb3c3149, 0x4854d4cd, 0x6517cb5b, 0xe426006d,
 0xa39a2876, 0xb63e0510, 0x3a750e39, 0x1ce65029,
 0x5c3a8196, 0x35f361e9, 0xa02a7631, 0x09e6d5b9,
 0x23c30eb8, 0x2b721189, 0x9bd76ee6, 0x7f8b9af9,
 0x6c806214, 0x930f30a4, 0xff649d43, 0x3828ec51,
 0xc8d6e992, 0x8041721d, 0xaa1144e7, 0x3229c71d,
 0xd8ce29d1, 0x8b52ee50, 0xef7675d2, 0x16df79ce,
 0xe76e0e61, 0xbaf1e259, 0x4eb79d99, 0x39233316,
 0xf3bbe3ea, 0x4466f62d, 0x9b707896, 0x5d0d3281,
 0x32db3bd2, 0x85e1ae39, 0x8c79abef, 0xde5717cf,
 0x0e02ddb8, 0x743291f4, 0xa020b26e, 0x18a8e91c,
 0x5b38d24c, 0x1bc11195, 0x8d3af775, 0x7e192ebb,
 0x8507a8f3, 0x3b21f00a, 0x3ad8437a, 0xe7097480,
 0xc1291f3a, 0x6e15f95e, 0xe270f22c, 0x400db04a,
 0x410d74ef, 0x80fc6c24, 0xc96939a7, 0x8b6b3140,
 0x71bd65a6, 0x85e9266c, 0xd6690e05, 0x90a4501d,
 0xcf3e92b4, 0x789ab025, 0x93d93c10, 0xe0c7b082,
 0x2e7d5006, 0x9e0946b7, 0xcc804e83, 0x282e391a,
 0x6e416136, 0x112fb982, 0x104a90d2, 0xb606d2fd,
 0x7b00ea01, 0x6a588226, 0xf507283d, 0x792652c9,
 0x86e63d17, 0xcd3e8286, 0x0b8b9c1c, 0xd2d9a61e,
 0x6609737e, 0x0d4913dd, 0xcc44ebe6, 0xfbcf72c1,
 0x108ba524, 0x62f5d09f, 0x54ad6460, 0x62f609c6,
 0x64a71062, 0xad235231, 0x00daf4ad, 0x8288b12d,
 0x81b33bd7, 0x37eaa2c4, 0x924e8e37, 0xd10f6aa0,
 0x387bd549, 0x7e5989f6, 0xf54d04fc, 0x17258f1c,
 0xebfb8082, 0x873212b5, 0x605bf190, 0x9dc788d9,
 0x85c4d707, 0x564c91e1, 0xf520c09a, 0x10c49bba,
 0x7d8a9740, 0x5d808ade, 0x045e602a, 0xdfefd01d,
 0x7a21f3d4, 0x5f533bee, 0x6a3d1e4d, 0x3c5b2e3b,
 0x5424e5ff, 0x3e4b8472, 0x1977af0a, 0x5f737dd0,
 0x6a2bebcf, 0x5e9a452a, 0x9a5631dd, 0x56b001ee,
 0x2b53ee6b, 0xf701516a, 0x9f9dd8f3, 0xeb0947c2,
 0x1da2b231, 0xd33680c7, 0x88d515c0, 0x04ed11b7,
 0xd9e770aa, 0xcd389784, 0x3ea8bc0c, 0x59049448,
 0xe71738d8, 0xa5aeded6, 0x3a47bf6c, 0x2bf8d666,
 0x4ff49c85, 0x29f6b70e, 0xaeb15e21, 0x4ed7e3fd,
 0x9929fce9, 0xa4305cce, 0x09279e37, 0x28a5ecbc,
 0xc66ddb13, 0x7a385fe2, 0x42fde727, 0xb50290e0,
 0x04e855c8, 0xce94d39b, 0x2d59f2e9, 0xbeb23d30,
 0x2a92531e, 0xae3f2ecf, 0x46ee9d11, 0x1a7a145d,
 0x884e4b21, 0x01cffae4, 0x294d2aef, 0xb9ff2515,
 0x92e67b09, 0xb445e5a5, 0x1b95a397, 0x668f56a0,
 0xf9006eab, 0x772bb81c, 0xfbe78ce4, 0x5d57bdba,
 0xce257ff0, 0x57c98048, 0xa7e43d5a, 0x06fefe99,
 0x90aad687, 0x3bb673c3, 0xb731198b, 0x32ee79aa,
 0x63f08e87, 0xc0db278b, 0xf1f7ba12, 0xd1cabe5a,
 0xc9284e2a, 0x2d4c2a9d, 0xfe9d086e, 0x75faf6fe,
 0xd5c5a840, 0xecb94fda, 0x0a053678, 0x93190cfa,
 0x3b709fc1, 0xedcff3bd, 0x57c7b747, 0xf91a7c65,
 0x4ce549b0, 0x0c3ac609, 0x33b6139d, 0x60cebe6c,
 0x585353e5, 0x8c49f73d, 0xfce66857, 0x6a41b6ad,
 0x74fd0228, 0x48b5d687, 0xfb5324a0, 0x3cef55ee,
 0x4e289d29, 0x42c39cae, 0x2ebbf514, 0x4793cbcd,
 0x6f7ba208, 0xe56b6d97, 0xecfb5bb4, 0x4c877b4c,
 0x4d5da287, 0x7daf39bb, 0xcb1f9fa4, 0x88a5b36e,
 0x51c74945, 0x45179299, 0x92fa2c4a, 0x43c56415,
 0x0320f4f9, 0x68d5ed19, 0x09abe789, 0x909aea30,
 0x6d7fb3c5, 0x30938076, 0x5392f959, 0x07e5f4d2,
 0xf33e4028, 0xd44f2ef0, 0xdd230d1b, 0x49e646e9,
 0x6f21bd50, 0xded74cfb, 0x35de78d1, 0xef578807,
 0xd067fa1e, 0xed5975f5, 0xb4cb3b94, 0x6a5149a7,
 0x9272e07c, 0x73542452, 0x0e6ff2ee, 0x8b50b8fc,
 0x7dd6fd18, 0x7eccca6e, 0x95afef66, 0x02f15fdb,
 0x6a356fa0, 0x505306d5, 0x02e5afa2, 0x399ecca1,
 0x3ebf0563, 0xb96a9093, 0x905d7504, 0xccc7fd85,
 0xc6fcc1e5, 0xbabbfb0a, 0x9925a245, 0x32332e23,
 0xb1daa8fb, 0x660670e9, 0xc1b9d6b0, 0x8ba31904,
 0xb576e598, 0xecdea011, 0x1534a5ad, 0xc33d1a8a,
 0x0f3800c4, 0x943ddfd6, 0x8eb52a05, 0xa66b6bbb,
 0xdd160424, 0x93799b19, 0x3abc042a, 0x90814fea,
 0x33d2f573, 0x54899538, 0xf6d632ce, 0x7978aa11,
 0x6166ac76, 0x33a293dd, 0x1a35ad4a, 0x398e0f31,
 0x8a0e2a75, 0xa653506c, 0xb9368613, 0x432b7030,
 0xbf759f91, 0xcaeb5b37, 0x7a48ef54, 0x7531595f,
 0xff6c9b52, 0xfb291c39, 0xeae9183a, 0x2379ed28,
 0x7d224404, 0x917e9722, 0xce8704dc, 0x6eab0487,
 0xe49802a6, 0x3544454b, 0x137173a8, 0x9d2b33bd,
 0x84013e0f, 0x856cc03f, 0x597bbad0, 0xfba1dddc,
 0x81ef6196, 0xdf59585e, 0x40222892, 0xc9a2ffc1,
 0x6b9e8806, 0x75973658, 0x50ac148c, 0x6a5c53d1,
 0xc315c528, 0x270d1b3c, 0x4196b2ab, 0xfd7c20a6,
 0x922abb78, 0x60caa117, 0xb28a7951, 0x251ee435,
 0xa39b18c5, 0x2825807f, 0x5a675f4b, 0xffc93b8d,
 0x5b2c37a4, 0x19318471, 0x893fd270, 0xe063b1c4,
 0xb82a1e5e, 0xae84c8bb, 0x7cf0e263, 0x8b246c99,
 0xf6cb3c6e, 0x01a652eb, 0xce941e8e, 0x4171f48d,
 0xa7403e24, 0xbd9c5e06, 0x129e8ee6, 0xc15c1432,
 0x43315e3e, 0xc2050d00, 0x5b7ceb56, 0xac9beb6b,
 0xb85b9ab6, 0x6ec070fb, 0x7b4c4152, 0x62657dfd,
 0x90303886, 0xb9fd6c97, 0xf5b8b765, 0xbed19a11,
 0x22f137ac, 0x30e8d742, 0x79216c81, 0x664a3aa8,
 0xe695b5d2, 0xd021f39a, 0x83ca650e, 0xbf249ce5,
 0xd7494070, 0xe333d0a5, 0x8daad530, 0xedb0eceb,
 0x047f7a41, 0x9d6d42e1, 0x492533c7, 0x1a806865,
 0xa98e9d94, 0xa3a88d79, 0xceac7c47, 0x3d0aacfc,
 0xe1dc5e40, 0x5ecb6ca1, 0x17f25d42, 0xec242cf9,
 0xd49e925b, 0xeb201656, 0xc63fe1db, 0xa63306ce,
 0xd3798dd5, 0xc57db0b5, 0x3c081268, 0xb65f3495,
 0x73b61273, 0x40b7418a, 0x23fc2ba5, 0xf2e9a205,
 0xe8691be0, 0x6e5a763c, 0xb7cf1647, 0xcc548751,
 0xfbbef5ca, 0x0eb7fb19, 0xc7b75804, 0x8ee642e2,
 0xe0aec829, 0xbc917ef2, 0xac0fc0e1, 0x1a6232f1,
 0xc6ca9465, 0xb1a117aa, 0x067d974c, 0xa716e3dd,
 0x214c5592, 0xb99710d0, 0x9dff256e, 0x4b6603ef,
 0xf4d3a626, 0xa034e14e, 0xbcd98e65, 0xe4f4f734,
 0x6ff13834, 0xba938012, 0xcef8349d, 0x376ba34f,
 0x4176ee6b, 0x8bcbfde0, 0x13145616, 0x7b1e2e90,
 0x577cad5a, 0xf6b172e8, 0x9f6f02da, 0x2f4cd4d6,
 0x3ff118f3, 0x0304ee50, 0xc704df0b, 0x9fdb8365,
 0xccef4ea5, 0xd837f82a, 0xeec934a1, 0x1c674e26,
 0xa1b17d66, 0xa2e44633, 0x823e1e7f, 0xc23e6526,
 0x25ba3da0, 0x14a21c28, 0xc1a1a46b, 0xa4a10aa4,
 0x160260ad, 0x2dd8befe, 0x5c2d9e5b, 0x9ed9c7a6,
 0x80b4f786, 0xe168a01f, 0x7f813abe, 0x29e5bed6,
 0x2f21747e, 0x4ce7dafc, 0x016cfc49, 0x2e5304f8,
 0xea90e7f9, 0x2cf8d63a, 0x8f9abf82, 0x33366db5,
 0x95987021, 0x83117669, 0xadfcecd7, 0x812d45e2,
 0x26e594b1, 0x6e5e0f32, 0xeae8633f, 0x14f8af56,
 0x439b1995, 0xc5ba8cf7, 0x68b5a040, 0xec590d8d,
 0x5070603b, 0x76d1bd7c, 0xca008839, 0x22f22f2f,
 0x504fcc97, 0x596cafb2, 0x24936b02, 0xef7d11f0,
 0x810222a3, 0x611646a8, 0x725ef6e9, 0x5ce1c8ac,
 0xccb647e8, 0xed96eda8, 0xa8126fc7, 0xed365893,
 0xed71c68d, 0x38f78e02, 0xd68ee65f, 0x963af8cb,
 0x2d6b2454, 0x124e7801, 0x7308c458, 0xd79bd61a,
 0xa5e6e41e, 0xc4307827, 0x76afffde, 0x2215581a,
 0x8f31cc31, 0x5dd8bd56, 0x22d5c628, 0x557c4cb2,
 0x9c68ec66, 0x6a15a69c, 0xb10c9ac1, 0x98a4ab57,
 0xc79434c1, 0xd42e04a7, 0x5aff5cfe, 0xd406f8a0,
 0x9d8f51a5, 0x5e9ff4bf, 0x05fd767d, 0xfd163a6f,
 0x9ca511d9, 0xcd3e283b, 0xddde27d3, 0xedd6f460,
 0xc6f1daed, 0x880b533c, 0xf6e18bbb, 0x38c34e28,
 0x7b193f81, 0x36f0d738, 0x820278be, 0xc2d762c9,
 0x1dd83cb2, 0xc2081002, 0x3ff73dbd, 0x93106051,
 0x8a206cc8, 0x0062dc43, 0xa726277e, 0xed30d615,
 0x55d999c1, 0x4f2a5f47, 0x5639520f, 0x8c5bc43a,
 0x419b526c, 0xef0ebff9, 0xd1fdd244, 0x147d6404,
 0xced92314, 0xf3212ec2, 0x3d01b888, 0x6729f516,
 0x4c01ec65, 0x00a1d637, 0x3614871c, 0xfa115533,
 0x7c2b9fdf, 0x7e38988b, 0x3e1589f0, 0x6000740e,
 0x11e2b916, 0x031257c2, 0x6173c707, 0xa895bf8c,
 0x831dae90, 0x53fe73d3, 0x358538c9, 0x80905969,
 0x43a73af5, 0x07c7a19c, 0xe169b4a8, 0x17fec826,
 0xe87aa4c1, 0x0e443116, 0x4db50d6e, 0x7d4d329f,
 0x48684434, 0x0b20b82c, 0x325319b5, 0xfe3d4296,
 0x1268f74f, 0x30851eff, 0xe054a1ef, 0xd407d3ad,
 0x11eec964, 0x37d1eec3, 0x9c0c0f91, 0x4e9a830a,
 0xbb66f603, 0xccd40365, 0x3aa26543, 0x32228a92,
 0xd654f674, 0x2d9d8319, 0x5086f54d, 0x877a06b1,
 0x8adbca38, 0xd992ef45, 0xd86814af, 0x50abe373,
 0xadaed318, 0x9b9b28c8, 0xa5c18fbe, 0x3eb86912,
 0xa1107d2a, 0x8fff58a3, 0x9ba4f6e9, 0x81f6a9a1,
 0x4d8d508c, 0xbee476de, 0xeb32c9fd, 0xc2320719,
 0x42ee6148, 0xf40dd799, 0x5305a1ce, 0xfdf1a7b7,
 0x684fdeb7, 0xb93a089c, 0xd4a570ba, 0x79bc08b6,
 0x5e4af883, 0x95f496dc, 0x7c57816e, 0x91bb7695,
 0x5f1c55af, 0xdc53952d, 0x492b2434, 0xffac8c03,
 0xd72d9166, 0xe8f351c2, 0xeb59f14a, 0x3d5328e7,
 0x221d5f23, 0xe5499756, 0xe65383fa, 0x0ce5c488,
 0x8d6aa151, 0xd229c1fd, 0xceb93bc8, 0x84c0f770,
 0xa5a1c6dd, 0x64f4af22, 0x3e062d09, 0xb9d15672,
 0x4aa8a75f, 0x10d3f511, 0x332c538f, 0xfdb169f1,
 0xb7e68f0b, 0xb1ea3115, 0xb72f7bee, 0x0fefb7cd,
 0x8c150017, 0xa80ec01b, 0xc5e5e171, 0x42521d00,
 0x70e55786, 0x9f2d8ff4, 0xd855f397, 0xbab1e725,
 0x7ace8e49, 0x7cee1ef2, 0x92f1346f, 0xd9a192bf,
 0xb4a3585d, 0x2271a727, 0xc07c433c, 0x588c4fce,
 0x55556c1c, 0xd1e10751, 0x3443f454, 0x5f0429d8,
 0x9e1fa563, 0xadf3d095, 0x4e1f93a1, 0x626221dc,
 0xca0d60c6, 0xd46a199f, 0x8b4238fa, 0x00473c18,
 0xc8bb9fc5, 0x7d411664, 0xbbfa18b2, 0x9bd40244,
 0x123e3013, 0xacfcce07, 0x84c86031, 0x89a00515,
 0x6367c669, 0xcc3aa138, 0x2b05a83d, 0xf6fd8026,
 0x62798ae4, 0x883a038a, 0x8a6a7cad, 0x15b3560b,
 0x7e4eb436, 0xbdb7b4fa, 0x34cd1128, 0x721250ad,
 0xcf7f167c, 0x4964424d, 0x8533ebda, 0x46ec788d,
 0x656f8dee, 0xf0348673, 0xa18c99c1, 0xada8ca5b,
 0x74d2b2f4, 0xad12f74c, 0x0df64845, 0x71f223c2,
 0x2e0c1b72, 0x8529c249, 0x9d5b4813, 0x484187cd,
 0x9434648f, 0x3e84f799, 0x9c966fa9, 0x60755385,
 0x37b75e8b, 0xef0a5a88, 0x17f407ac, 0x6bd9c129,
 0x5db626df, 0x24dd5a56, 0x845934d9, 0x445cb5b5,
 0xe135907a, 0x8ed16394, 0x6774c5b0, 0x1b944422,
 0x467dfb60, 0xce6c32c0, 0xdeef91f1, 0xc04fb508,
 0x918fbc48, 0x24da7074, 0x333afaf0, 0x961c7a76,
 0x830c812c, 0xfd618771, 0x52ae60f1, 0x01f469e7,
 0xbcde87b3, 0xc5232a45, 0xe7c0e1ba, 0xdc0ee464,
 0xa7d0315a, 0xb64a1a8a, 0x1a288044, 0xcb03b4d2,
 0x6e500e87, 0xa6c6df5d, 0xd3c5c122, 0x4041e921,
 0x33f9173a, 0xda293425, 0x0db8730a, 0x378ef24a,
 0xd2ea07c4, 0x7444d94e, 0x8570e176, 0x384d95ca,
 0x5bcf579e, 0xaf34f244, 0x7cb37d9e, 0xf880fa20,
 0x414e10f3, 0xa23fc900, 0x3a63fa6c, 0x40d0ac97,
 0xa1831cf3, 0x27deafc6, 0x9ee4bebc, 0x23524bf2,
 0x89915f98, 0x3ee262fa, 0xef3a7dde, 0x5c6a1676,
 0x88bc0780, 0x466bca94, 0x7e4c7bff, 0x9041377e,
 0xaaefa091, 0x3e16ab71, 0x6d5dc006, 0xc49de4cb,
 0x69c51f07, 0x0f3f2a7d, 0xa170da78, 0x1edf1356,
 0x83af66f6, 0x71e3bfec, 0x8de2815d, 0xe1fea1f4,
 0x5336832a, 0xec12edca, 0x8b1ab2d5, 0x600839f7,
 0x35328895, 0x37f18f40, 0x4de359b5, 0x44584d11,
 0xc4b5dbd0, 0x033a78d2, 0xebbaba35, 0xac30d252,
 0x8eb43a04, 0x179b277c, 0x85ca2729, 0x91cf59b4,
 0x85c525ed, 0x6f007951, 0x1af111d5, 0x86885ca3,
 0x8489e581, 0xdde185b6, 0xeb51f92e, 0xe7589272,
 0x8fcdd791, 0x21c9221c, 0x268c7674, 0x3f93cde2,
 0x41d907da, 0xea008728, 0xa655fc06, 0x958bdf38,
 0xe6872627, 0x7b7be98f, 0x2f35251a, 0x945eb054,
 0xc81e3ebd, 0x403a2e1f, 0x2e1ff3bb, 0xb6a48052,
 0xb90e2be4, 0x0bb2a345, 0x68b0ad40, 0xdf314550,
 0x325bd931, 0x78ee2222, 0xabb00331, 0xdfa9a7e9,
 0xedaf8095, 0xb3c1dc89, 0x408c9dad, 0x02dcb049,
 0xc16ef7de, 0x9e202225, 0xf560636b, 0x88ba6f2d,
 0x91cdffa9, 0xe50246f4, 0xce24349b, 0x869b1df2,
 0xc4490740, 0x7542caef, 0x5df82051, 0x8e3bf5f3,
 0x475ec74e, 0x55c55d75, 0x6b699775, 0xadaf3436,
 0x1d7f8c44, 0xcff55e6d, 0x4bc2917f, 0xb9ad8eb0,
 0x90a8cbbe, 0x58628a1b, 0x489beba6, 0xaffd43f1,
 0xb42d2590, 0x8edfd19b, 0x693f8c59, 0xcb206975,
 0xd205e635, 0x3d018c71, 0x460878e9, 0x5a0c9e24,
 0x5455b789, 0xe7b83ec5, 0x771b8706, 0x1e586af5,
 0x4f4aadff, 0x1c309a27, 0x11134ab0, 0x905673af,
 0xeb71a8cd, 0x57998faf, 0xa9f8e484, 0x35e9b455,
 0x3712c766, 0x24c05e03, 0xd778ba7e, 0xc78b1808,
 0xebbf3956, 0xaf9aba38, 0x4cda0a35, 0x1a461525,
 0x331604be, 0x5d129774, 0x0541568a, 0x7c635930,
 0xe51c886f, 0x7e23d82d, 0xde3d4a66, 0x7c716bf9,
 0xe4a21b31, 0x7f5e5bc3, 0xac1028d7, 0x7af1bfb3,
 0x504e629d, 0x5ad66270, 0x7b172f3d, 0xe42476da,
 0x57ee8acf, 0x27ac80ba, 0x9ec80198, 0x13429379,
 0x5e448845, 0xf44f5115, 0x9ab322e0, 0xc8a02feb,
 0xcad2a214, 0x63f04be7, 0xb8bcfac2, 0x49a3aa36,
 0x284e3765, 0x9a0819b2, 0xfbc11568, 0xf0786378,
 0xb0269983, 0xeeb2cbad, 0xc58b2f6a, 0xfef747e8,
 0x962a8bc6, 0xb0deaf42, 0x92db2c37, 0xf0481c4b,
 0xd6e61b7e, 0x9cd6cafa, 0x2ca8d240, 0x44b0118d,
 0x703b2752, 0x1779f076, 0x83b887c1, 0xf3f905ce,
 0x9f70cc46, 0x600f357e, 0xd3ef9eac, 0xf06f2c11,
 0x2819508d, 0x24343228, 0x3a8f5477, 0x32b9ada7,
 0xd5a0e207, 0x598cda0e, 0xf4ac5df1, 0x12c35fa1,
 0x602850f0, 0xebb6b84e, 0x7ac5ea46, 0x8eda8925,
 0xb1ef5c39, 0xde1172cc, 0xf51c19ca, 0xd2d26a4e,
 0xc32bb512, 0x13e580b7, 0x8e6b2c55, 0xbf765304,
 0xe86db62e, 0x7bf455cd, 0x1c82593d, 0xcdf5ae77,
 0x9215265a, 0x47f39cf6, 0x243f6a88, 0x85a308d3,
 0x13198a2e, 0x03707344, 0xa4093822, 0x299f31d0,
 0x082efa98, 0xec4e6c89, 0x452821e6, 0x38d01377,
 0xbe5466cf, 0x34e90c6c, 0xc0ac29b7, 0xc97c50dd,
 0x3f84d5b5, 0xb5470917, 0x9216d5d9, 0x8979fb1b,
 0xd1310ba6, 0x98dfb5ac, 0x2ffd72db, 0xd01adfb7,
 0xb8e1afed, 0x6a267e96, 0xba7c9045, 0xf12c7f99,
 0x24a19947, 0xb3916cf7, 0x0801f2e2, 0x858efc16,
 0x636920d8, 0x71574e69, 0xa458fea3, 0xf4933d7e,
 0x0d95748f, 0x728eb658, 0x718bcd58, 0x82154aee,
 0x7b54a41d, 0xc25a59b5, 0x9c30d539, 0x2af26013,
 0xc5d1b023, 0x286085f0, 0xca417918, 0xb8db38ef,
 0x8e79dcb0, 0x603a180e, 0x6c9e0e8b, 0xb01e8a3e,
 0xd71577c1, 0xbd314b27, 0x78af2fda, 0x55605c60,
 0xe65525f3, 0xaa55ab94, 0x57489862, 0x63e81440,
 0x55ca396a, 0x2aab10b6, 0xb4cc5c34, 0x1141e8ce,
 0xa15486af, 0x7c72e993, 0xb3ee1411, 0x636fbc2a,
 0x2ba9c55d, 0x741831f6, 0xce5c3e16, 0x9b87931e,
 0xafd6ba33, 0x6c24cf5c, 0x7a325381, 0x28958677,
 0x3b8f4898, 0x6b4bb9af, 0xc4bfe81b, 0x66282193,
 0x61d809cc, 0xfb21a991, 0x487cac60, 0x5dec8032,
 0xef845d5d, 0xe98575b1, 0xdc262302, 0xeb651b88,
 0x23893e81, 0xd396acc5, 0x0f6d6ff3, 0x83f44239,
 0x2e0b4482, 0xa4842004, 0x69c8f04a, 0x9e1f9b5e,
 0x21c66842, 0xf6e96c9a, 0x670c9c61, 0xabd388f0,
 0x6a51a0d2, 0xd8542f68, 0x960fa728, 0xab5133a3,
 0x6eef0b6c, 0x137a3be4, 0xba3bf050, 0x7efb2a98,
 0xa1f1651d, 0x39af0176, 0x66ca593e, 0x82430e88,
 0x8cee8619, 0x456f9fb4, 0x7d84a5c3, 0x3b8b5ebe,
 0xe06f75d8, 0x85c12073, 0x401a449f, 0x56c16aa6,
 0x4ed3aa62, 0x363f7706, 0x1bfedf72, 0x429b023d,
 0x37d0d724, 0xd00a1248, 0xdb0fead3, 0x49f1c09b,
 0x075372c9, 0x80991b7b, 0x25d479d8, 0xf6e8def7,
 0xe3fe501a, 0xb6794c3b, 0x976ce0bd, 0x04c006ba,
 0xc1a94fb6, 0x409f60c4, 0x5e5c9ec2, 0x196a2463,
 0x68fb6faf, 0x3e6c53b5, 0x1339b2eb, 0x3b52ec6f,
 0x6dfc511f, 0x9b30952c, 0xcc814544, 0xaf5ebd09,
 0xbee3d004, 0xde334afd, 0x660f2807, 0x192e4bb3,
 0xc0cba857, 0x45c8740f, 0xd20b5f39, 0xb9d3fbdb,
 0x5579c0bd, 0x1a60320a, 0xd6a100c6, 0x402c7279,
 0x679f25fe, 0xfb1fa3cc, 0x8ea5e9f8, 0xdb3222f8,
 0x3c7516df, 0xfd616b15, 0x2f501ec8, 0xad0552ab,
 0x323db5fa, 0xfd238760, 0x53317b48, 0x3e00df82,
 0x9e5c57bb, 0xca6f8ca0, 0x1a87562e, 0xdf1769db,
 0xd542a8f6, 0x287effc3, 0xac6732c6, 0x8c4f5573,
 0x695b27b0, 0xbbca58c8, 0xe1ffa35d, 0xb8f011a0,
 0x10fa3d98, 0xfd2183b8, 0x4afcb56c, 0x2dd1d35b,
 0x9a53e479, 0xb6f84565, 0xd28e49bc, 0x4bfb9790,
 0xe1ddf2da, 0xa4cb7e33, 0x62fb1341, 0xcee4c6e8,
 0xef20cada, 0x36774c01, 0xd07e9efe, 0x2bf11fb4,
 0x95dbda4d, 0xae909198, 0xeaad8e71, 0x6b93d5a0,
 0xd08ed1d0, 0xafc725e0, 0x8e3c5b2f, 0x8e7594b7,
 0x8ff6e2fb, 0xf2122b64, 0x8888b812, 0x900df01c,
 0x4fad5ea0, 0x688fc31c, 0xd1cff191, 0xb3a8c1ad,
 0x2f2f2218, 0xbe0e1777, 0xea752dfe, 0x8b021fa1,
 0xe5a0cc0f, 0xb56f74e8, 0x18acf3d6, 0xce89e299,
 0xb4a84fe0, 0xfd13e0b7, 0x7cc43b81, 0xd2ada8d9,
 0x165fa266, 0x80957705, 0x93cc7314, 0x211a1477,
 0xe6ad2065, 0x77b5fa86, 0xc75442f5, 0xfb9d35cf,
 0xebcdaf0c, 0x7b3e89a0, 0xd6411bd3, 0xae1e7e49,
 0x00250e2d, 0x2071b35e, 0x226800bb, 0x57b8e0af,
 0x2464369b, 0xf009b91e, 0x5563911d, 0x59dfa6aa,
 0x78c14389, 0xd95a537f, 0x207d5ba2, 0x02e5b9c5,
 0x83260376, 0x6295cfa9, 0x11c81968, 0x4e734a41,
 0xb3472dca, 0x7b14a94a, 0x1b510052, 0x9a532915,
 0xd60f573f, 0xbc9bc6e4, 0x2b60a476, 0x81e67400,
 0x08ba6fb5, 0x571be91f, 0xf296ec6b, 0x2a0dd915,
 0xb6636521, 0xe7b9f9b6, 0xff34052e, 0xc5855664,
 0x53b02d5d, 0xa99f8fa1, 0x08ba4799, 0x6e85076a,
 0x4b7a70e9, 0xb5b32944, 0xdb75092e, 0xc4192623,
 0xad6ea6b0, 0x49a7df7d, 0x9cee60b8, 0x8fedb266,
 0xecaa8c71, 0x699a17ff, 0x5664526c, 0xc2b19ee1,
 0x193602a5, 0x75094c29, 0xa0591340, 0xe4183a3e,
 0x3f54989a, 0x5b429d65, 0x6b8fe4d6, 0x99f73fd6,
 0xa1d29c07, 0xefe830f5, 0x4d2d38e6, 0xf0255dc1,
 0x4cdd2086, 0x8470eb26, 0x6382e9c6, 0x021ecc5e,
 0x09686b3f, 0x3ebaefc9, 0x3c971814, 0x6b6a70a1,
 0x687f3584, 0x52a0e286, 0xb79c5305, 0xaa500737,
 0x3e07841c, 0x7fdeae5c, 0x8e7d44ec, 0x5716f2b8,
 0xb03ada37, 0xf0500c0d, 0xf01c1f04, 0x0200b3ff,
 0xae0cf51a, 0x3cb574b2, 0x25837a58, 0xdc0921bd,
 0xd19113f9, 0x7ca92ff6, 0x94324773, 0x22f54701,
 0x3ae5e581, 0x37c2dadc, 0xc8b57634, 0x9af3dda7,
 0xa9446146, 0x0fd0030e, 0xecc8c73e, 0xa4751e41,
 0xe238cd99, 0x3bea0e2f, 0x3280bba1, 0x183eb331,
 0x4e548b38, 0x4f6db908, 0x6f420d03, 0xf60a04bf,
 0x2cb81290, 0x24977c79, 0x5679b072, 0xbcaf89af,
 0xde9a771f, 0xd9930810, 0xb38bae12, 0xdccf3f2e,
 0x5512721f, 0x2e6b7124, 0x501adde6, 0x9f84cd87,
 0x7a584718, 0x7408da17, 0xbc9f9abc, 0xe94b7d8c,
 0xec7aec3a, 0xdb851dfa, 0x63094366, 0xc464c3d2,
 0xef1c1847, 0x3215d908, 0xdd433b37, 0x24c2ba16,
 0x12a14d43, 0x2a65c451, 0x50940002, 0x133ae4dd,
 0x71dff89e, 0x10314e55, 0x81ac77d6, 0x5f11199b,
 0x043556f1, 0xd7a3c76b, 0x3c11183b, 0x5924a509,
 0xf28fe6ed, 0x97f1fbfa, 0x9ebabf2c, 0x1e153c6e,
 0x86e34570, 0xeae96fb1, 0x860e5e0a, 0x5a3e2ab3,
 0x771fe71c, 0x4e3d06fa, 0x2965dcb9, 0x99e71d0f,
 0x803e89d6, 0x5266c825, 0x2e4cc978, 0x9c10b36a,
 0xc6150eba, 0x94e2ea78, 0xa5fc3c53, 0x1e0a2df4,
 0xf2f74ea7, 0x361d2b3d, 0x1939260f, 0x19c27960,
 0x5223a708, 0xf71312b6, 0xebadfe6e, 0xeac31f66,
 0xe3bc4595, 0xa67bc883, 0xb17f37d1, 0x018cff28,
 0xc332ddef, 0xbe6c5aa5, 0x65582185, 0x68ab9802,
 0xeecea50f, 0xdb2f953b, 0x2aef7dad, 0x5b6e2f84,
 0x1521b628, 0x29076170, 0xecdd4775, 0x619f1510,
 0x13cca830, 0xeb61bd96, 0x0334fe1e, 0xaa0363cf,
 0xb5735c90, 0x4c70a239, 0xd59e9e0b, 0xcbaade14,
 0xeecc86bc, 0x60622ca7, 0x9cab5cab, 0xb2f3846e,
 0x648b1eaf, 0x19bdf0ca, 0xa02369b9, 0x655abb50,
 0x40685a32, 0x3c2ab4b3, 0x319ee9d5, 0xc021b8f7,
 0x9b540b19, 0x875fa099, 0x95f7997e, 0x623d7da8,
 0xf837889a, 0x97e32d77, 0x11ed935f, 0x16681281,
 0x0e358829, 0xc7e61fd6, 0x96dedfa1, 0x7858ba99,
 0x57f584a5, 0x1b227263, 0x9b83c3ff, 0x1ac24696,
 0xcdb30aeb, 0x532e3054, 0x8fd948e4, 0x6dbc3128,
 0x58ebf2ef, 0x34c6ffea, 0xfe28ed61, 0xee7c3c73,
 0x5d4a14d9, 0xe864b7e3, 0x42105d14, 0x203e13e0,
 0x45eee2b6, 0xa3aaabea, 0xdb6c4f15, 0xfacb4fd0,
 0xc742f442, 0xef6abbb5, 0x654f3b1d, 0x41cd2105,
 0xd81e799e, 0x86854dc7, 0xe44b476a, 0x3d816250,
 0xcf62a1f2, 0x5b8d2646, 0xfc8883a0, 0xc1c7b6a3,
 0x7f1524c3, 0x69cb7492, 0x47848a0b, 0x5692b285,
 0x095bbf00, 0xad19489d, 0x1462b174, 0x23820e00,
 0x58428d2a, 0x0c55f5ea, 0x1dadf43e, 0x233f7061,
 0x3372f092, 0x8d937e41, 0xd65fecf1, 0x6c223bdb,
 0x7cde3759, 0xcbee7460, 0x4085f2a7, 0xce77326e,
 0xa6078084, 0x19f8509e, 0xe8efd855, 0x61d99735,
 0xa969a7aa, 0xc50c06c2, 0x5a04abfc, 0x800bcadc,
 0x9e447a2e, 0xc3453484, 0xfdd56705, 0x0e1e9ec9,
 0xdb73dbd3, 0x105588cd, 0x675fda79, 0xe3674340,
 0xc5c43465, 0x713e38d8, 0x3d28f89e, 0xf16dff20,
 0x153e21e7, 0x8fb03d4a, 0xe6e39f2b, 0xdb83adf7,
 0xe93d5a68, 0x948140f7, 0xf64c261c, 0x94692934,
 0x411520f7, 0x7602d4f7, 0xbcf46b2e, 0xd4a20068,
 0xd4082471, 0x3320f46a, 0x43b7d4b7, 0x500061af,
 0x1e39f62e, 0x97244546, 0x14214f74, 0xbf8b8840,
 0x4d95fc1d, 0x96b591af, 0x70f4ddd3, 0x66a02f45,
 0xbfbc09ec, 0x03bd9785, 0x7fac6dd0, 0x31cb8504,
 0x96eb27b3, 0x55fd3941, 0xda2547e6, 0xabca0a9a,
 0x28507825, 0x530429f4, 0x0a2c86da, 0xe9b66dfb,
 0x68dc1462, 0xd7486900, 0x680ec0a4, 0x27a18dee,
 0x4f3ffea2, 0xe887ad8c, 0xb58ce006, 0x7af4d6b6,
 0xaace1e7c, 0xd3375fec, 0xce78a399, 0x406b2a42,
 0x20fe9e35, 0xd9f385b9, 0xee39d7ab, 0x3b124e8b,
 0x1dc9faf7, 0x4b6d1856, 0x26a36631, 0xeae397b2,
 0x3a6efa74, 0xdd5b4332, 0x6841e7f7, 0xca7820fb,
 0xfb0af54e, 0xd8feb397, 0x454056ac, 0xba489527,
 0x55533a3a, 0x20838d87, 0xfe6ba9b7, 0xd096954b,
 0x55a867bc, 0xa1159a58, 0xcca92963, 0x99e1db33,
 0xa62a4a56, 0x3f3125f9, 0x5ef47e1c, 0x9029317c,
 0xfdf8e802, 0x04272f70, 0x80bb155c, 0x05282ce3,
 0x95c11548, 0xe4c66d22, 0x48c1133f, 0xc70f86dc,
 0x07f9c9ee, 0x41041f0f, 0x404779a4, 0x5d886e17,
 0x325f51eb, 0xd59bc0d1, 0xf2bcc18f, 0x41113564,
 0x257b7834, 0x602a9c60, 0xdff8e8a3, 0x1f636c1b,
 0x0e12b4c2, 0x02e1329e, 0xaf664fd1, 0xcad18115,
 0x6b2395e0, 0x333e92e1, 0x3b240b62, 0xeebeb922,
 0x85b2a20e, 0xe6ba0d99, 0xde720c8c, 0x2da2f728,
 0xd0127845, 0x95b794fd, 0x647d0862, 0xe7ccf5f0,
 0x5449a36f, 0x877d48fa, 0xc39dfd27, 0xf33e8d1e,
 0x0a476341, 0x992eff74, 0x3a6f6eab, 0xf4f8fd37,
 0xa812dc60, 0xa1ebddf8, 0x991be14c, 0xdb6e6b0d,
 0xc67b5510, 0x6d672c37, 0x2765d43b, 0xdcd0e804,
 0xf1290dc7, 0xcc00ffa3, 0xb5390f92, 0x690fed0b,
 0x667b9ffb, 0xcedb7d9c, 0xa091cf0b, 0xd9155ea3,
 0xbb132f88, 0x515bad24, 0x7b9479bf, 0x763bd6eb,
 0x37392eb3, 0xcc115979, 0x8026e297, 0xf42e312d,
 0x6842ada7, 0xc66a2b3b, 0x12754ccc, 0x782ef11c,
 0x6a124237, 0xb79251e7, 0x06a1bbe6, 0x4bfb6350,
 0x1a6b1018, 0x11caedfa, 0x3d25bdd8, 0xe2e1c3c9,
 0x44421659, 0x0a121386, 0xd90cec6e, 0xd5abea2a,
 0x64af674e, 0xda86a85f, 0xbebfe988, 0x64e4c3fe,
 0x9dbc8057, 0xf0f7c086, 0x60787bf8, 0x6003604d,
 0xd1fd8346, 0xf6381fb0, 0x7745ae04, 0xd736fccc,
 0x83426b33, 0xf01eab71, 0xb0804187, 0x3c005e5f,
 0x77a057be, 0xbde8ae24, 0x55464299, 0xbf582e61,
 0x4e58f48f, 0xf2ddfda2, 0xf474ef38, 0x8789bdc2,
 0x5366f9c3, 0xc8b38e74, 0xb475f255, 0x46fcd9b9,
 0x7aeb2661, 0x8b1ddf84, 0x846a0e79, 0x915f95e2,
 0x466e598e, 0x20b45770, 0x8cd55591, 0xc902de4c,
 0xb90bace1, 0xbb8205d0, 0x11a86248, 0x7574a99e,
 0xb77f19b6, 0xe0a9dc09, 0x662d09a1, 0xc4324633,
 0xe85a1f02, 0x09f0be8c, 0x4a99a025, 0x1d6efe10,
 0x1ab93d1d, 0x0ba5a4df, 0xa186f20f, 0x2868f169,
 0xdcb7da83, 0x573906fe, 0xa1e2ce9b, 0x4fcd7f52,
 0x50115e01, 0xa70683fa, 0xa002b5c4, 0x0de6d027,
 0x9af88c27, 0x773f8641, 0xc3604c06, 0x61a806b5,
 0xf0177a28, 0xc0f586e0, 0x006058aa, 0x30dc7d62,
 0x11e69ed7, 0x2338ea63, 0x53c2dd94, 0xc2c21634,
 0xbbcbee56, 0x90bcb6de, 0xebfc7da1, 0xce591d76,
 0x6f05e409, 0x4b7c0188, 0x39720a3d, 0x7c927c24,
 0x86e3725f, 0x724d9db9, 0x1ac15bb4, 0xd39eb8fc,
 0xed545578, 0x08fca5b5, 0xd83d7cd3, 0x4dad0fc4,
 0x1e50ef5e, 0xb161e6f8, 0xa28514d9, 0x6c51133c,
 0x6fd5c7e7, 0x56e14ec4, 0x362abfce, 0xddc6c837,
 0xd79a3234, 0x92638212, 0x670efa8e, 0x406000e0,
 0x3a39ce37, 0xd3faf5cf, 0xabc27737, 0x5ac52d1b,
 0x5cb0679e, 0x4fa33742, 0xd3822740, 0x99bc9bbe,
 0xd5118e9d, 0xbf0f7315, 0xd62d1c7e, 0xc700c47b,
 0xb78c1b6b, 0x21a19045, 0xb26eb1be, 0x6a366eb4,
 0x5748ab2f, 0xbc946e79, 0xc6a376d2, 0x6549c2c8,
 0x530ff8ee, 0x468dde7d, 0xd5730a1d, 0x4cd04dc6,
 0x2939bbdb, 0xa9ba4650, 0xac9526e8, 0xbe5ee304,
 0xa1fad5f0, 0x6a2d519a, 0x63ef8ce2, 0x9a86ee22,
 0xc089c2b8, 0x43242ef6, 0xa51e03aa, 0x9cf2d0a4,
 0x83c061ba, 0x9be96a4d, 0x8fe51550, 0xba645bd6,
 0x2826a2f9, 0xa73a3ae1, 0x4ba99586, 0xef5562e9,
 0xc72fefd3, 0xf752f7da, 0x3f046f69, 0x77fa0a59,
 0x80e4a915, 0x87b08601, 0x9b09e6ad, 0x3b3ee593,
 0xe990fd5a, 0x9e34d797, 0x2cf0b7d9, 0x022b8b51,
 0x96d5ac3a, 0x017da67d, 0xd1cf3ed6, 0x7c7d2d28,
 0x1f9f25cf, 0xadf2b89b, 0x5ad6b472, 0x5a88f54c,
 0xe029ac71, 0xe019a5e6, 0x47b0acfd, 0xed93fa9b,
 0xe8d3c48d, 0x283b57cc, 0xf8d56629, 0x79132e28,
 0x785f0191, 0xed756055, 0xf7960e44, 0xe3d35e8c,
 0x15056dd4, 0x88f46dba, 0x03a16125, 0x0564f0bd,
 0xc3eb9e15, 0x3c9057a2, 0x97271aec, 0xa93a072a,
 0x1b3f6d9b, 0x1e6321f5, 0xf59c66fb, 0x26dcf319,
 0x7533d928, 0xb155fdf5, 0x03563482, 0x8aba3cbb,
 0x28517711, 0xc20ad9f8, 0xabcc5167, 0xccad925f,
 0x4de81751, 0x3830dc8e, 0x379d5862, 0x9320f991,
 0xea7a90c2, 0xfb3e7bce, 0x5121ce64, 0x774fbe32,
 0xa8b6e37e, 0xc3293d46, 0x48de5369, 0x6413e680,
 0xa2ae0810, 0xdd6db224, 0x69852dfd, 0x09072166,
 0xb39a460a, 0x6445c0dd, 0x586cdecf, 0x1c20c8ae,
 0x5bbef7dd, 0x1b588d40, 0xccd2017f, 0x6bb4e3bb,
 0xdda26a7e, 0x3a59ff45, 0x3e350a44, 0xbcb4cdd5,
 0x72eacea8, 0xfa6484bb, 0x8d6612ae, 0xbf3c6f47,
 0xd29be463, 0x542f5d9e, 0xaec2771b, 0xf64e6370,
 0x740e0d8d, 0xe75b1357, 0xf8721671, 0xaf537d5d,
 0x4040cb08, 0x4eb4e2cc, 0x34d2466a, 0x0115af84,
 0xe1b00428, 0x95983a1d, 0x06b89fb4, 0xce6ea048,
 0x6f3f3b82, 0x3520ab82, 0x011a1d4b, 0x277227f8,
 0x611560b1, 0xe7933fdc, 0xbb3a792b, 0x344525bd,
 0xa08839e1, 0x51ce794b, 0x2f32c9b7, 0xa01fbac9,
 0xe01cc87e, 0xbcc7d1f6, 0xcf0111c3, 0xa1e8aac7,
 0x1a908749, 0xd44fbd9a, 0xd0dadecb, 0xd50ada38,
 0x0339c32a, 0xc6913667, 0x8df9317c, 0xe0b12b4f,
 0xf79e59b7, 0x43f5bb3a, 0xf2d519ff, 0x27d9459c,
 0xbf97222c, 0x15e6fc2a, 0x0f91fc71, 0x9b941525,
 0xfae59361, 0xceb69ceb, 0xc2a86459, 0x12baa8d1,
 0xb6c1075e, 0xe3056a0c, 0x10d25065, 0xcb03a442,
 0xe0ec6e0e, 0x1698db3b, 0x4c98a0be, 0x3278e964,
 0x9f1f9532, 0xe0d392df, 0xd3a0342b, 0x8971f21e,
 0x1b0a7441, 0x4ba3348c, 0xc5be7120, 0xc37632d8,
 0xdf359f8d, 0x9b992f2e, 0xe60b6f47, 0x0fe3f11d,
 0xe54cda54, 0x1edad891, 0xce6279cf, 0xcd3e7e6f,
 0x1618b166, 0xfd2c1d05, 0x848fd2c5, 0xf6fb2299,
 0xf523f357, 0xa6327623, 0x93a83531, 0x56cccd02,
 0xacf08162, 0x5a75ebb5, 0x6e163697, 0x88d273cc,
 0xde966292, 0x81b949d0, 0x4c50901b, 0x71c65614,
 0xe6c6c7bd, 0x327a140a, 0x45e1d006, 0xc3f27b9a,
 0xc9aa53fd, 0x62a80f00, 0xbb25bfe2, 0x35bdd2f6,
 0x71126905, 0xb2040222, 0xb6cbcf7c, 0xcd769c2b,
 0x53113ec0, 0x1640e3d3, 0x38abbd60, 0x2547adf0,
 0xba38209c, 0xf746ce76, 0x77afa1c5, 0x20756060,
 0x85cbfe4e, 0x8ae88dd8, 0x7aaaf9b0, 0x4cf9aa7e,
 0x1948c25c, 0x02fb8a8c, 0x01c36ae4, 0xd6ebe1f9,
 0x90d4f869, 0xa65cdea0, 0x3f09252d, 0xc208e69f,
 0xb74e6132, 0xce77e25b, 0x578fdfe3, 0x3ac372e6

################################################################################

TITLE
    Ventrilo encryption/decryption algorithm

TYPE
    8, 32

DATA
    "\xAA\x55\x22\xCC\x69\x7C\x38\x91\x88\xF5\xE1"

################################################################################

TITLE
    Virtools .crypted files decrypter key

TYPE
    8, 32

DATA
    "\x9d\x0b\x08\x5b\xd4\x13\x77\x60\xe7\x10\x3f\x0a\x2c\x55\xb8\x0a"

################################################################################

TITLE
    Zlib dist_code

TYPE
    8

DATA
 0,  1,  2,  3,  4,  4,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8,
 8,  8,  8,  8,  9,  9,  9,  9,  9,  9,  9,  9, 10, 10, 10, 10, 10, 10, 10, 10,
10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,
11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13,
13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
13, 13, 13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15,
15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,  0,  0, 16, 17,
18, 18, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22, 22, 22,
23, 23, 23, 23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
24, 24, 24, 24, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,
26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26,
26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 27, 27, 27, 27, 27, 27, 27, 27,
27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
27, 27, 27, 27, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
28, 28, 28, 28, 28, 28, 28, 28, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29,
29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29,
29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29,
29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29

################################################################################

TITLE
    Zlib length_code

TYPE
    8

DATA
 0,  1,  2,  3,  4,  5,  6,  7,  8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 12, 12,
13, 13, 13, 13, 14, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 16, 16, 16, 16,
17, 17, 17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 19, 19, 19, 19,
19, 19, 19, 19, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22,
22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 23, 23, 23, 23, 23, 23, 23, 23,
23, 23, 23, 23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,
25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26,
26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26,
26, 26, 26, 26, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,
27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 28

################################################################################

TITLE
    Zlib base_length

TYPE
    8 32

DATA
    0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 12, 14, 16, 20, 24, 28, 32, 40, 48, 56,
    64, 80, 96, 112, 128, 160, 192, 224, 0

################################################################################

TITLE
    Zlib base_dist

TYPE
    32

DATA
    0,     1,     2,     3,     4,     6,     8,    12,    16,    24,
   32,    48,    64,    96,   128,   192,   256,   384,   512,   768,
 1024,  1536,  2048,  3072,  4096,  6144,  8192, 12288, 16384, 24576

################################################################################

TITLE
    BICOM bialib sufftree.cpp dini

TYPE
    32

DATA
  25,29,30,33,37,42,44,42,45,47,45,48,49,50,53,59,60,61,61,61,
  23,31,26,31,38,45,46,42,46,50,47,49,52,49,53,59,60,61,61,61,
  23,31,31,39,44,48,52,50,54,52,54,55,57,55,57,62,61,62,61,61,
  23,28,33,46,51,54,54,52,54,56,57,56,56,58,58,62,61,63,63,59,
  16,27,32,47,52,53,53,56,56,58,58,53,57,60,61,62,63,63,63,57,
  25,33,38,56,52,53,56,55,58,54,57,56,55,61,62,63,63,62,63,61,
  25,33,38,56,52,53,56,55,58,54,57,56,55,61,62,63,63,62,63,61,
  25,33,38,56,52,53,56,55,58,54,57,56,55,61,62,63,63,62,63,61

################################################################################

TITLE
    Tabulated escapes for exponential symbol distribution

TYPE
    8

DATA
    51,43,18,12,11,9,8,7,6,5,4,3,3,2,2,2

################################################################################

TITLE
    PPMZ2 counts

TYPE
    32

DATA
   23,    0,    0,    0,    0,    0,    0,    0,
    3,   59,  397,    0,    0,   13,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   26,    0,    0,    0,    0,
 2249,   23,   39,    5,   17,   37,    1,   65,
   65,   57,   15,   16,  146,  108,  211,   11,
   58,   65,   39,   25,   21,   21,   21,   20,
   24,   23,   41,   58,   10,   17,   16,    8,
   10,   39,   22,   34,   24,   26,   18,   12,
   27,   57,   12,   14,   20,   27,   22,   18,
   29,    2,   24,   33,   52,   15,    6,   12,
    6,    5,    1,   37,   45,    8,    1,    7,
    3,  790,  162,  337,  389, 1273,  238,  202,
  497,  728,   13,   73,  426,  278,  739,  758,
  242,   16,  625,  682,  895,  312,  102,  179,
   47,  178,   16,    5,    3,    5,   17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
//    0, };

################################################################################

TITLE
    LZRW1 test

TYPE
    32 AND

DATA
    40543, 0xfff 4095 0xf00 //0x8000

################################################################################

TITLE
    LZ Huffman (lzhuf/lha) decoding table

TYPE
    8

DATA
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
	0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
	0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,
	0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
	0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B,
	0x0C, 0x0C, 0x0C, 0x0C, 0x0D, 0x0D, 0x0D, 0x0D,
	0x0E, 0x0E, 0x0E, 0x0E, 0x0F, 0x0F, 0x0F, 0x0F,
	0x10, 0x10, 0x10, 0x10, 0x11, 0x11, 0x11, 0x11,
	0x12, 0x12, 0x12, 0x12, 0x13, 0x13, 0x13, 0x13,
	0x14, 0x14, 0x14, 0x14, 0x15, 0x15, 0x15, 0x15,
	0x16, 0x16, 0x16, 0x16, 0x17, 0x17, 0x17, 0x17,
	0x18, 0x18, 0x19, 0x19, 0x1A, 0x1A, 0x1B, 0x1B,
	0x1C, 0x1C, 0x1D, 0x1D, 0x1E, 0x1E, 0x1F, 0x1F,
	0x20, 0x20, 0x21, 0x21, 0x22, 0x22, 0x23, 0x23,
	0x24, 0x24, 0x25, 0x25, 0x26, 0x26, 0x27, 0x27,
	0x28, 0x28, 0x29, 0x29, 0x2A, 0x2A, 0x2B, 0x2B,
	0x2C, 0x2C, 0x2D, 0x2D, 0x2E, 0x2E, 0x2F, 0x2F,
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F,

################################################################################

TITLE
    LZ Huffman (lzhuf/lha) encoding table

TYPE
    8

DATA
	0x00, 0x20, 0x30, 0x40, 0x50, 0x58, 0x60, 0x68,
	0x70, 0x78, 0x80, 0x88, 0x90, 0x94, 0x98, 0x9C,
	0xA0, 0xA4, 0xA8, 0xAC, 0xB0, 0xB4, 0xB8, 0xBC,
	0xC0, 0xC2, 0xC4, 0xC6, 0xC8, 0xCA, 0xCC, 0xCE,
	0xD0, 0xD2, 0xD4, 0xD6, 0xD8, 0xDA, 0xDC, 0xDE,
	0xE0, 0xE2, 0xE4, 0xE6, 0xE8, 0xEA, 0xEC, 0xEE,
	0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7,
	0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF

################################################################################

TITLE
    possible mask reset used in arithmetic compression

TYPE
    8

DATA
    0x00,  0x80,  0xC0,  0xE0,  0xF0,  0xF8,  0xFC,  0xFE,  0xFF,

################################################################################

TITLE
    State table used in PAQ7 compression

TYPE
    8

DATA
  0, 1,2, 1,2,1,2, 1,1,1,2,1,2,2,2, 1,1,1,1,2,1,1,1,2,2,2,1,2,2,2,2,
  1,1,2,1,2,1,2,1,2,2, 1,1,2,1,2,1,2,1,2,1,2,2, 1,1,2,1,2,1,2,1,2,1,2,1,2,2}; 

################################################################################

TITLE
    Squash table used in PAQ7 compression

TYPE
    32

DATA
    1,2,3,6,10,16,27,45,73,120,194,310,488,747,1101,
    1546,2047,2549,2994,3348,3607,3785,3901,3975,4022,
    4050,4068,4079,4085,4089,4092,4093,4094};

################################################################################

TITLE
    State table used in PAQ8 compression

TYPE
    8

DATA
  {  1,  2, 0, 0},{  3,  5, 1, 0},{  4,  6, 0, 1},{  7, 10, 2, 0}, // 0-3
  {  8, 12, 1, 1},{  9, 13, 1, 1},{ 11, 14, 0, 2},{ 15, 19, 3, 0}, // 4-7
  { 16, 23, 2, 1},{ 17, 24, 2, 1},{ 18, 25, 2, 1},{ 20, 27, 1, 2}, // 8-11
  { 21, 28, 1, 2},{ 22, 29, 1, 2},{ 26, 30, 0, 3},{ 31, 33, 4, 0}, // 12-15
  { 32, 35, 3, 1},{ 32, 35, 3, 1},{ 32, 35, 3, 1},{ 32, 35, 3, 1}, // 16-19
  { 34, 37, 2, 2},{ 34, 37, 2, 2},{ 34, 37, 2, 2},{ 34, 37, 2, 2}, // 20-23
  { 34, 37, 2, 2},{ 34, 37, 2, 2},{ 36, 39, 1, 3},{ 36, 39, 1, 3}, // 24-27
  { 36, 39, 1, 3},{ 36, 39, 1, 3},{ 38, 40, 0, 4},{ 41, 43, 5, 0}, // 28-31
  { 42, 45, 4, 1},{ 42, 45, 4, 1},{ 44, 47, 3, 2},{ 44, 47, 3, 2}, // 32-35
  { 46, 49, 2, 3},{ 46, 49, 2, 3},{ 48, 51, 1, 4},{ 48, 51, 1, 4}, // 36-39
  { 50, 52, 0, 5},{ 53, 43, 6, 0},{ 54, 57, 5, 1},{ 54, 57, 5, 1}, // 40-43
  { 56, 59, 4, 2},{ 56, 59, 4, 2},{ 58, 61, 3, 3},{ 58, 61, 3, 3}, // 44-47
  { 60, 63, 2, 4},{ 60, 63, 2, 4},{ 62, 65, 1, 5},{ 62, 65, 1, 5}, // 48-51
  { 50, 66, 0, 6},{ 67, 55, 7, 0},{ 68, 57, 6, 1},{ 68, 57, 6, 1}, // 52-55
  { 70, 73, 5, 2},{ 70, 73, 5, 2},{ 72, 75, 4, 3},{ 72, 75, 4, 3}, // 56-59
  { 74, 77, 3, 4},{ 74, 77, 3, 4},{ 76, 79, 2, 5},{ 76, 79, 2, 5}, // 60-63
  { 62, 81, 1, 6},{ 62, 81, 1, 6},{ 64, 82, 0, 7},{ 83, 69, 8, 0}, // 64-67
  { 84, 71, 7, 1},{ 84, 71, 7, 1},{ 86, 73, 6, 2},{ 86, 73, 6, 2}, // 68-71
  { 44, 59, 5, 3},{ 44, 59, 5, 3},{ 58, 61, 4, 4},{ 58, 61, 4, 4}, // 72-75
  { 60, 49, 3, 5},{ 60, 49, 3, 5},{ 76, 89, 2, 6},{ 76, 89, 2, 6}, // 76-79
  { 78, 91, 1, 7},{ 78, 91, 1, 7},{ 80, 92, 0, 8},{ 93, 69, 9, 0}, // 80-83
  { 94, 87, 8, 1},{ 94, 87, 8, 1},{ 96, 45, 7, 2},{ 96, 45, 7, 2}, // 84-87
  { 48, 99, 2, 7},{ 48, 99, 2, 7},{ 88,101, 1, 8},{ 88,101, 1, 8}, // 88-91
  { 80,102, 0, 9},{103, 69,10, 0},{104, 87, 9, 1},{104, 87, 9, 1}, // 92-95
  {106, 57, 8, 2},{106, 57, 8, 2},{ 62,109, 2, 8},{ 62,109, 2, 8}, // 96-99
  { 88,111, 1, 9},{ 88,111, 1, 9},{ 80,112, 0,10},{113, 85,11, 0}, // 100-103
  {114, 87,10, 1},{114, 87,10, 1},{116, 57, 9, 2},{116, 57, 9, 2}, // 104-107
  { 62,119, 2, 9},{ 62,119, 2, 9},{ 88,121, 1,10},{ 88,121, 1,10}, // 108-111
  { 90,122, 0,11},{123, 85,12, 0},{124, 97,11, 1},{124, 97,11, 1}, // 112-115
  {126, 57,10, 2},{126, 57,10, 2},{ 62,129, 2,10},{ 62,129, 2,10}, // 116-119
  { 98,131, 1,11},{ 98,131, 1,11},{ 90,132, 0,12},{133, 85,13, 0}, // 120-123
  {134, 97,12, 1},{134, 97,12, 1},{136, 57,11, 2},{136, 57,11, 2}, // 124-127
  { 62,139, 2,11},{ 62,139, 2,11},{ 98,141, 1,12},{ 98,141, 1,12}, // 128-131
  { 90,142, 0,13},{143, 95,14, 0},{144, 97,13, 1},{144, 97,13, 1}, // 132-135
  { 68, 57,12, 2},{ 68, 57,12, 2},{ 62, 81, 2,12},{ 62, 81, 2,12}, // 136-139
  { 98,147, 1,13},{ 98,147, 1,13},{100,148, 0,14},{149, 95,15, 0}, // 140-143
  {150,107,14, 1},{150,107,14, 1},{108,151, 1,14},{108,151, 1,14}, // 144-147
  {100,152, 0,15},{153, 95,16, 0},{154,107,15, 1},{108,155, 1,15}, // 148-151
  {100,156, 0,16},{157, 95,17, 0},{158,107,16, 1},{108,159, 1,16}, // 152-155
  {100,160, 0,17},{161,105,18, 0},{162,107,17, 1},{108,163, 1,17}, // 156-159
  {110,164, 0,18},{165,105,19, 0},{166,117,18, 1},{118,167, 1,18}, // 160-163
  {110,168, 0,19},{169,105,20, 0},{170,117,19, 1},{118,171, 1,19}, // 164-167
  {110,172, 0,20},{173,105,21, 0},{174,117,20, 1},{118,175, 1,20}, // 168-171
  {110,176, 0,21},{177,105,22, 0},{178,117,21, 1},{118,179, 1,21}, // 172-175
  {110,180, 0,22},{181,115,23, 0},{182,117,22, 1},{118,183, 1,22}, // 176-179
  {120,184, 0,23},{185,115,24, 0},{186,127,23, 1},{128,187, 1,23}, // 180-183
  {120,188, 0,24},{189,115,25, 0},{190,127,24, 1},{128,191, 1,24}, // 184-187
  {120,192, 0,25},{193,115,26, 0},{194,127,25, 1},{128,195, 1,25}, // 188-191
  {120,196, 0,26},{197,115,27, 0},{198,127,26, 1},{128,199, 1,26}, // 192-195
  {120,200, 0,27},{201,115,28, 0},{202,127,27, 1},{128,203, 1,27}, // 196-199
  {120,204, 0,28},{205,115,29, 0},{206,127,28, 1},{128,207, 1,28}, // 200-203
  {120,208, 0,29},{209,125,30, 0},{210,127,29, 1},{128,211, 1,29}, // 204-207
  {130,212, 0,30},{213,125,31, 0},{214,137,30, 1},{138,215, 1,30}, // 208-211
  {130,216, 0,31},{217,125,32, 0},{218,137,31, 1},{138,219, 1,31}, // 212-215
  {130,220, 0,32},{221,125,33, 0},{222,137,32, 1},{138,223, 1,32}, // 216-219
  {130,224, 0,33},{225,125,34, 0},{226,137,33, 1},{138,227, 1,33}, // 220-223
  {130,228, 0,34},{229,125,35, 0},{230,137,34, 1},{138,231, 1,34}, // 224-227
  {130,232, 0,35},{233,125,36, 0},{234,137,35, 1},{138,235, 1,35}, // 228-231
  {130,236, 0,36},{237,125,37, 0},{238,137,36, 1},{138,239, 1,36}, // 232-235
  {130,240, 0,37},{241,125,38, 0},{242,137,37, 1},{138,243, 1,37}, // 236-239
  {130,244, 0,38},{245,135,39, 0},{246,137,38, 1},{138,247, 1,38}, // 240-243
  {140,248, 0,39},{249,135,40, 0},{250, 69,39, 1},{ 80,251, 1,39}, // 244-247
  {140,252, 0,40},{249,135,41, 0},{250, 69,40, 1},{ 80,251, 1,40}, // 248-251
  {140,252, 0,41}};  // 252, 253-255 are reserved

################################################################################

TITLE
    zz (zigzag coef u,v) used in PAQ8 compression

TYPE
    8

DATA
//  const static U8 zzu[64]={  // zigzag coef -> u,v
    0,1,0,0,1,2,3,2,1,0,0,1,2,3,4,5,4,3,2,1,0,0,1,2,3,4,5,6,7,6,5,4,
    3,2,1,0,1,2,3,4,5,6,7,7,6,5,4,3,2,3,4,5,6,7,7,6,5,4,5,6,7,7,6,7};
//  const static U8 zzv[64]={
    0,0,1,2,1,0,0,1,2,3,4,3,2,1,0,0,1,2,3,4,5,6,5,4,3,2,1,0,0,1,2,3,
    4,5,6,7,7,6,5,4,3,2,1,2,3,4,5,6,7,7,6,5,4,3,4,5,6,7,7,6,5,6,7,7};

################################################################################

TITLE
    State table used in PAQ4, PAQ6 and PAQC compression

TYPE
    8

DATA
    0x00, 0x00, 0x00, 0x02, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x04, 0x00, 0x01, 0x04, 0x01, 0x03, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x00, 0x00, 0x02, 0x05, 0x02, 0x04, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x08, 0x00, 0x01, 0x04, 0x03, 0x06, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x04, 0x08, 0x04, 0x07, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x00, 0x00, 0x05, 0x09, 0x02, 0x04, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x0c, 0x00, 0x01, 0x04, 0x06, 0x0a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x04, 0x08, 0x07, 0x0b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x08, 0x0d, 0x04, 0x07, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x00, 0x00, 0x09, 0x0e, 0x02, 0x04, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x10, 0x00, 0x03, 0x07, 0x0a, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x04, 0x08, 0x0b, 0x10, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x08, 0x0d, 0x07, 0x0b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x0d, 0x13, 0x04, 0x07, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 
    0x00, 0x00, 0x0e, 0x14, 0x05, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x14, 0x00, 0x03, 0x07, 0x0f, 0x15, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x04, 0x00, 0x07, 0x0c, 0x10, 0x16, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x08, 0x0d, 0x0b, 0x10, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x0d, 0x13, 0x07, 0x0b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x01, 0x00, 0x13, 0x1a, 0x08, 0x0c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x00, 0x00, 0x14, 0x1b, 0x05, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x18, 0x00, 0x06, 0x0b, 0x15, 0x1c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x05, 0x00, 0x07, 0x0c, 0x16, 0x1d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x0c, 0x12, 0x10, 0x16, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x0d, 0x13, 0x0b, 0x10, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x13, 0x1a, 0x0c, 0x11, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x01, 0x00, 0x1a, 0x22, 0x08, 0x0c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x18, 0x00, 
    0x00, 0x00, 0x1b, 0x23, 0x09, 0x0d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x1c, 0x00, 0x06, 0x0b, 0x1c, 0x24, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x06, 0x00, 0x0b, 0x11, 0x1d, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x0c, 0x12, 0x16, 0x1d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x12, 0x19, 0x10, 0x16, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x13, 0x1a, 0x11, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x1a, 0x22, 0x0c, 0x11, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x01, 0x00, 0x22, 0x2b, 0x0d, 0x12, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1c, 0x00, 
    0x00, 0x00, 0x23, 0x2c, 0x09, 0x0d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x20, 0x00, 0x0a, 0x10, 0x24, 0x2d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x07, 0x00, 0x0b, 0x11, 0x25, 0x2e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x11, 0x18, 0x1d, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x12, 0x19, 0x16, 0x1d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x19, 0x21, 0x17, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x1a, 0x22, 0x11, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x22, 0x2b, 0x12, 0x18, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x01, 0x00, 0x2b, 0x35, 0x0d, 0x12, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20, 0x00, 
    0x00, 0x00, 0x2c, 0x36, 0x0e, 0x13, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x24, 0x00, 0x0a, 0x10, 0x2d, 0x37, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x08, 0x00, 0x10, 0x17, 0x2e, 0x38, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x11, 0x18, 0x25, 0x2e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x18, 0x20, 0x1d, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x19, 0x21, 0x1e, 0x26, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x21, 0x2a, 0x17, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x22, 0x2b, 0x18, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x2b, 0x35, 0x12, 0x18, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x01, 0x00, 0x35, 0x3d, 0x13, 0x19, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x24, 0x00, 
    0x00, 0x00, 0x36, 0x3e, 0x0e, 0x13, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x28, 0x00, 0x0f, 0x16, 0x37, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x09, 0x00, 0x10, 0x17, 0x38, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x04, 0x00, 0x17, 0x1f, 0x2e, 0x38, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x18, 0x20, 0x25, 0x2e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x2b, 0x35, 0x18, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x01, 0x00, 0x35, 0x3d, 0x19, 0x20, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x01, 0x00, 0x3d, 0x45, 0x13, 0x19, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x28, 0x00, 
    0x00, 0x00, 0x3e, 0x46, 0x14, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x2c, 0x00, 0x0f, 0x16, 0x3f, 0x47, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0a, 0x00, 0x16, 0x1e, 0x40, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x04, 0x00, 0x17, 0x1f, 0x38, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x1f, 0x28, 0x2e, 0x38, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x35, 0x3d, 0x20, 0x28, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x01, 0x00, 0x3d, 0x45, 0x19, 0x20, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0a, 0x00, 
    0x01, 0x00, 0x45, 0x4d, 0x1a, 0x21, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x2c, 0x00, 
    0x00, 0x00, 0x46, 0x4e, 0x14, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x30, 0x00, 0x15, 0x1d, 0x47, 0x4f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0b, 0x00, 0x16, 0x1e, 0x48, 0x50, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x05, 0x00, 0x1e, 0x27, 0x40, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x1f, 0x28, 0x38, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x3d, 0x45, 0x20, 0x28, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x01, 0x00, 0x45, 0x4d, 0x21, 0x29, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0b, 0x00, 
    0x01, 0x00, 0x4d, 0x55, 0x1a, 0x21, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x30, 0x00, 
    0x00, 0x00, 0x4e, 0x56, 0x1b, 0x22, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x34, 0x00, 0x15, 0x1d, 0x4f, 0x57, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0c, 0x00, 0x1d, 0x26, 0x50, 0x58, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x05, 0x00, 0x1e, 0x27, 0x48, 0x50, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x27, 0x31, 0x40, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x45, 0x4d, 0x29, 0x32, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x01, 0x00, 0x4d, 0x55, 0x21, 0x29, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x01, 0x00, 0x55, 0x5b, 0x22, 0x2a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x34, 0x00, 
    0x00, 0x00, 0x56, 0x5c, 0x1b, 0x22, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x38, 0x00, 0x1c, 0x25, 0x57, 0x5d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0d, 0x00, 0x1d, 0x26, 0x58, 0x5e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x06, 0x00, 0x26, 0x30, 0x50, 0x58, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x01, 0x00, 0x55, 0x5b, 0x2a, 0x33, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0d, 0x00, 
    0x01, 0x00, 0x5b, 0x61, 0x22, 0x2a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x38, 0x00, 
    0x00, 0x00, 0x5c, 0x62, 0x23, 0x2b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x3c, 0x00, 0x1c, 0x25, 0x5d, 0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0e, 0x00, 0x25, 0x2f, 0x5e, 0x64, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x06, 0x00, 0x26, 0x30, 0x58, 0x5e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x01, 0x00, 0x5b, 0x61, 0x2a, 0x33, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x01, 0x00, 0x61, 0x67, 0x2b, 0x34, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3c, 0x00, 
    0x00, 0x00, 0x62, 0x68, 0x23, 0x2b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x40, 0x00, 0x24, 0x2e, 0x63, 0x69, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0f, 0x00, 0x25, 0x2f, 0x64, 0x6a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x07, 0x00, 0x2f, 0x3a, 0x5e, 0x64, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x01, 0x00, 0x61, 0x67, 0x34, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x00, 
    0x01, 0x00, 0x67, 0x6d, 0x2b, 0x34, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x40, 0x00, 
    0x00, 0x00, 0x68, 0x6e, 0x2c, 0x35, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x44, 0x00, 0x24, 0x2e, 0x69, 0x6f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x10, 0x00, 0x2e, 0x39, 0x6a, 0x70, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x07, 0x00, 0x2f, 0x3a, 0x64, 0x6a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x01, 0x00, 0x67, 0x6d, 0x34, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 
    0x01, 0x00, 0x6d, 0x71, 0x35, 0x3c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x44, 0x00, 
    0x00, 0x00, 0x6e, 0x72, 0x2c, 0x35, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x48, 0x00, 0x2d, 0x38, 0x6f, 0x73, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x11, 0x00, 0x2e, 0x39, 0x70, 0x74, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x11, 0x00, 
    0x01, 0x00, 0x71, 0x77, 0x35, 0x3c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x48, 0x00, 
    0x00, 0x00, 0x72, 0x78, 0x36, 0x3d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x4c, 0x00, 0x2d, 0x38, 0x73, 0x79, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x12, 0x00, 0x38, 0x41, 0x74, 0x7a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x08, 0x00, 0x39, 0x42, 0x70, 0x74, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x01, 0x00, 0x71, 0x77, 0x3c, 0x43, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x12, 0x00, 
    0x01, 0x00, 0x77, 0x7d, 0x3d, 0x44, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x4c, 0x00, 
    0x00, 0x00, 0x78, 0x7e, 0x36, 0x3d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x50, 0x00, 0x37, 0x40, 0x79, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x13, 0x00, 0x38, 0x41, 0x7a, 0x80, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x09, 0x00, 0x41, 0x4a, 0x74, 0x7a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x01, 0x00, 0x77, 0x7d, 0x44, 0x4b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x13, 0x00, 
    0x01, 0x00, 0x7d, 0x83, 0x3d, 0x44, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x50, 0x00, 
    0x00, 0x00, 0x7e, 0x84, 0x3e, 0x45, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x54, 0x00, 0x37, 0x40, 0x7f, 0x85, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x14, 0x00, 0x40, 0x49, 0x80, 0x86, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x09, 0x00, 0x41, 0x4a, 0x7a, 0x80, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x01, 0x00, 0x7d, 0x83, 0x44, 0x4b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x01, 0x00, 0x83, 0x89, 0x45, 0x4c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x54, 0x00, 
    0x00, 0x00, 0x84, 0x8a, 0x3e, 0x45, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x58, 0x00, 0x3f, 0x48, 0x85, 0x8b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x15, 0x00, 0x40, 0x49, 0x86, 0x8c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0a, 0x00, 0x49, 0x52, 0x80, 0x86, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0a, 0x00, 
    0x01, 0x00, 0x83, 0x89, 0x4c, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x15, 0x00, 
    0x01, 0x00, 0x89, 0x8f, 0x45, 0x4c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x58, 0x00, 
    0x00, 0x00, 0x8a, 0x90, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x5c, 0x00, 0x3f, 0x48, 0x8b, 0x91, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x16, 0x00, 0x48, 0x51, 0x8c, 0x92, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0a, 0x00, 0x49, 0x52, 0x86, 0x8c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0a, 0x00, 
    0x01, 0x00, 0x89, 0x8f, 0x4c, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x16, 0x00, 
    0x01, 0x00, 0x8f, 0x93, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x5c, 0x00, 
    0x00, 0x00, 0x90, 0x94, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x60, 0x00, 0x47, 0x50, 0x91, 0x95, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x17, 0x00, 0x48, 0x51, 0x92, 0x96, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x17, 0x00, 
    0x01, 0x00, 0x93, 0x97, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x60, 0x00, 
    0x00, 0x00, 0x94, 0x98, 0x4e, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x64, 0x00, 0x3f, 0x48, 0x95, 0x99, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x18, 0x00, 0x50, 0x59, 0x96, 0x9a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x18, 0x00, 
    0x01, 0x00, 0x97, 0x9b, 0x55, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x64, 0x00, 
    0x00, 0x00, 0x98, 0x9c, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x68, 0x00, 0x3f, 0x48, 0x99, 0x9d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x19, 0x00, 0x48, 0x51, 0x9a, 0x9e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x19, 0x00, 
    0x01, 0x00, 0x9b, 0x9f, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x68, 0x00, 
    0x00, 0x00, 0x9c, 0xa0, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x6c, 0x00, 0x3f, 0x48, 0x9d, 0xa1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1a, 0x00, 0x48, 0x51, 0x9e, 0xa2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1a, 0x00, 
    0x01, 0x00, 0x9f, 0xa3, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x6c, 0x00, 
    0x00, 0x00, 0xa0, 0xa4, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x70, 0x00, 0x3f, 0x48, 0xa1, 0xa5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1b, 0x00, 0x48, 0x51, 0xa2, 0xa6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1b, 0x00, 
    0x01, 0x00, 0xa3, 0xa7, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x70, 0x00, 
    0x00, 0x00, 0xa4, 0xa8, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x74, 0x00, 0x3f, 0x48, 0xa5, 0xa9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1c, 0x00, 0x48, 0x51, 0xa6, 0xaa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1c, 0x00, 
    0x01, 0x00, 0xa7, 0xab, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x74, 0x00, 
    0x00, 0x00, 0xa8, 0xac, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x78, 0x00, 0x3f, 0x48, 0xa9, 0xad, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1d, 0x00, 0x48, 0x51, 0xaa, 0xae, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1d, 0x00, 
    0x01, 0x00, 0xab, 0xaf, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x78, 0x00, 
    0x00, 0x00, 0xac, 0xb0, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x7c, 0x00, 0x3f, 0x48, 0xad, 0xb1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1e, 0x00, 0x48, 0x51, 0xae, 0xb2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1e, 0x00, 
    0x01, 0x00, 0xaf, 0xb3, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7c, 0x00, 
    0x00, 0x00, 0xb0, 0xb4, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x80, 0x00, 0x3f, 0x48, 0xb1, 0xb5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1f, 0x00, 0x48, 0x51, 0xb2, 0xb6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0x00, 
    0x01, 0x00, 0xb3, 0xb7, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 
    0x00, 0x00, 0xb4, 0xb8, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x84, 0x00, 0x3f, 0x48, 0xb5, 0xb9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x20, 0x00, 0x48, 0x51, 0xb6, 0xba, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x20, 0x00, 
    0x01, 0x00, 0xb7, 0xbb, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x84, 0x00, 
    0x00, 0x00, 0xb8, 0xbc, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x88, 0x00, 0x3f, 0x48, 0xb9, 0xbd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x21, 0x00, 0x48, 0x51, 0xba, 0xbe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x21, 0x00, 
    0x01, 0x00, 0xbb, 0xbf, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x88, 0x00, 
    0x00, 0x00, 0xbc, 0xc0, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x8c, 0x00, 0x3f, 0x48, 0xbd, 0xc1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x22, 0x00, 0x48, 0x51, 0xbe, 0xc2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x22, 0x00, 
    0x01, 0x00, 0xbf, 0xc3, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x8c, 0x00, 
    0x00, 0x00, 0xc0, 0xc4, 0x46, 0x4d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x90, 0x00, 0x47, 0x50, 0xc1, 0xc5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x23, 0x00, 0x48, 0x51, 0xc2, 0xc6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x23, 0x00, 
    0x01, 0x00, 0xc3, 0xc7, 0x4d, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x90, 0x00, 
    0x00, 0x00, 0xc4, 0xc8, 0x4e, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x94, 0x00, 0x47, 0x50, 0xc5, 0xc9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x24, 0x00, 0x50, 0x59, 0xc6, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x24, 0x00, 
    0x01, 0x00, 0xc7, 0xcb, 0x55, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x94, 0x00, 
    0x00, 0x00, 0xc8, 0xcc, 0x4e, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x98, 0x00, 0x47, 0x50, 0xc9, 0xcd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x25, 0x00, 0x50, 0x59, 0xca, 0xce, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x25, 0x00, 
    0x01, 0x00, 0xcb, 0xcf, 0x55, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x98, 0x00, 
    0x00, 0x00, 0xcc, 0xd0, 0x4e, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x9c, 0x00, 0x47, 0x50, 0xcd, 0xd1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x26, 0x00, 0x50, 0x59, 0xce, 0xd2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x26, 0x00, 
    0x01, 0x00, 0xcf, 0xd3, 0x55, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x9c, 0x00, 
    0x00, 0x00, 0xd0, 0xd4, 0x4e, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0xa0, 0x00, 0x47, 0x50, 0xd1, 0xd7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x01, 0x00, 
    0x27, 0x00, 0x50, 0x59, 0xd2, 0xd5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x27, 0x00, 
    0x01, 0x00, 0xd3, 0xd6, 0x55, 0x5a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xa0, 0x00, 
    0x00, 0x00, 0xd4, 0xd8, 0x4e, 0x55, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x28, 0x00, 0x50, 0x59, 0xd5, 0xd9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x28, 0x00, 
    0x01, 0x00, 0xd6, 0xda, 0x55, 0x5a, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0xb0, 0x00, 0x47, 0x50, 0xd7, 0xdb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0xb0, 0x00, 
    0x00, 0x00, 0xd8, 0xdc, 0x4e, 0x55, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x2c, 0x00, 0x50, 0x59, 0xd9, 0xdd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x2c, 0x00, 
    0x01, 0x00, 0xda, 0xde, 0x55, 0x5a, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0xc0, 0x00, 0x47, 0x50, 0xdb, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0xc0, 0x00, 
    0x00, 0x00, 0xdc, 0xe0, 0x4e, 0x55, 0xff, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x30, 0x00, 0x50, 0x59, 0xdd, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0x30, 0x00, 
    0x01, 0x00, 0xde, 0xe2, 0x55, 0x5a, 0xff, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0xe0, 0x00, 0x4f, 0x58, 0xdf, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0xe0, 0x00, 
    0x00, 0x00, 0xe0, 0xe4, 0x56, 0x5b, 0xff, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x38, 0x00, 0x58, 0x5f, 0xe1, 0xe5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1f, 0x38, 0x00, 
    0x01, 0x00, 0xe2, 0xe6, 0x5b, 0x60, 0xff, 0xff, 0xff, 0x1f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x00, 0x01, 0x57, 0x5e, 0xe3, 0xe7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 0x01, 
    0x00, 0x00, 0xe4, 0xe8, 0x5c, 0x61, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x40, 0x00, 0x5e, 0x65, 0xe5, 0xe9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x01, 0x00, 0xe6, 0xea, 0x61, 0x66, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x80, 0x01, 0x5d, 0x64, 0xe7, 0xeb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x80, 0x01, 
    0x00, 0x00, 0xe8, 0xec, 0x62, 0x67, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x60, 0x00, 0x64, 0x6b, 0xe9, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x60, 0x00, 
    0x01, 0x00, 0xea, 0xee, 0x67, 0x6c, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x00, 0x02, 0x69, 0x70, 0xeb, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 0x02, 
    0x00, 0x00, 0xec, 0xf0, 0x6e, 0x71, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x80, 0x00, 0x70, 0x75, 0xed, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x80, 0x00, 
    0x01, 0x00, 0xee, 0xf2, 0x71, 0x76, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x80, 0x02, 0x6f, 0x74, 0xef, 0xf3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x80, 0x02, 
    0x00, 0x00, 0xf0, 0xf4, 0x72, 0x77, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0xa0, 0x00, 0x74, 0x7b, 0xf1, 0xf5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0xa0, 0x00, 
    0x01, 0x00, 0xf2, 0xf6, 0x77, 0x7c, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x00, 0x03, 0x73, 0x7a, 0xf3, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 0x03, 
    0x00, 0x00, 0xf4, 0xf8, 0x78, 0x7d, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0xc0, 0x00, 0x7a, 0x81, 0xf5, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0xc0, 0x00, 
    0x01, 0x00, 0xf6, 0xfa, 0x7d, 0x82, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x80, 0x03, 0x79, 0x80, 0xf7, 0xfb, 0xff, 0xff, 0xff, 0xff, 0x84, 0x10, 0x42, 0x08, 0x80, 0x03, 
    0x00, 0x00, 0xf8, 0xfc, 0x7e, 0x83, 0x84, 0x10, 0x42, 0x08, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0xe0, 0x00, 0x80, 0x87, 0xf9, 0xfd, 0xff, 0xff, 0xff, 0xff, 0x84, 0x10, 0x42, 0x08, 0xe0, 0x00, 
    0x01, 0x00, 0xfa, 0xfe, 0x83, 0x88, 0x84, 0x10, 0x42, 0x08, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0xfc, 0x03, 0x7f, 0x86, 0xfb, 0xfb, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x03, 
    0x00, 0x00, 0xfc, 0xfc, 0x84, 0x89, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0xff, 0x00, 0x86, 0x8d, 0xfd, 0xfd, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 
    0x01, 0x00, 0xfe, 0xfe, 0x89, 0x8e, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff

################################################################################

TITLE
    State table used in PAQ1, PAQ2, PAQ3 and PAQ5 compression

TYPE
    8

DATA
    0x00, 0x00, 0x00, 0x02, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x01, 0x00, 0x01, 0x04, 0x01, 0x03, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x00, 0x00, 0x02, 0x05, 0x02, 0x04, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x02, 0x00, 0x03, 0x07, 0x03, 0x06, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x01, 0x00, 0x04, 0x08, 0x04, 0x07, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x00, 0x00, 0x05, 0x09, 0x05, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x03, 0x00, 0x03, 0x07, 0x06, 0x0a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x02, 0x00, 0x07, 0x0c, 0x07, 0x0b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x01, 0x00, 0x08, 0x0d, 0x08, 0x0c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x00, 0x00, 0x09, 0x0e, 0x05, 0x08, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x04, 0x00, 0x06, 0x0b, 0x0a, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x03, 0x00, 0x07, 0x0c, 0x0b, 0x10, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x02, 0x00, 0x0c, 0x12, 0x0c, 0x11, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x01, 0x00, 0x0d, 0x13, 0x08, 0x0c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x00, 0x00, 0x0e, 0x14, 0x09, 0x0d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x05, 0x00, 0x06, 0x0b, 0x0f, 0x15, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x04, 0x00, 0x0b, 0x11, 0x10, 0x16, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x03, 0x00, 0x0c, 0x12, 0x11, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x02, 0x00, 0x12, 0x19, 0x0c, 0x11, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x01, 0x00, 0x13, 0x1a, 0x0d, 0x12, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x00, 0x00, 0x14, 0x1b, 0x09, 0x0d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x06, 0x00, 0x0a, 0x10, 0x15, 0x1c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x05, 0x00, 0x0b, 0x11, 0x16, 0x1d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x04, 0x00, 0x11, 0x18, 0x17, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x03, 0x00, 0x12, 0x19, 0x11, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x02, 0x00, 0x19, 0x21, 0x12, 0x18, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x01, 0x00, 0x1a, 0x22, 0x0d, 0x12, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x00, 0x00, 0x1b, 0x23, 0x0e, 0x13, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x07, 0x00, 0x0a, 0x10, 0x1c, 0x24, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x06, 0x00, 0x10, 0x17, 0x1d, 0x25, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x05, 0x00, 0x11, 0x18, 0x1e, 0x26, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x04, 0x00, 0x18, 0x20, 0x17, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x03, 0x00, 0x19, 0x21, 0x18, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x02, 0x00, 0x21, 0x2a, 0x12, 0x18, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x01, 0x00, 0x22, 0x2b, 0x13, 0x19, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x00, 0x00, 0x23, 0x2c, 0x0e, 0x13, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x08, 0x00, 0x0f, 0x16, 0x24, 0x2d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x07, 0x00, 0x10, 0x17, 0x25, 0x2e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x06, 0x00, 0x17, 0x1f, 0x26, 0x2f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x05, 0x00, 0x18, 0x20, 0x1e, 0x26, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x04, 0x00, 0x20, 0x29, 0x1f, 0x27, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x03, 0x00, 0x21, 0x2a, 0x18, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x02, 0x00, 0x2a, 0x34, 0x19, 0x20, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x01, 0x00, 0x2b, 0x35, 0x13, 0x19, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x00, 0x00, 0x2c, 0x36, 0x14, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x09, 0x00, 0x0f, 0x16, 0x2d, 0x5e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x08, 0x00, 0x16, 0x1e, 0x2e, 0x37, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x07, 0x00, 0x17, 0x1f, 0x2f, 0x38, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x06, 0x00, 0x1f, 0x28, 0x26, 0x2f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x05, 0x00, 0x20, 0x29, 0x27, 0x30, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x04, 0x00, 0x29, 0x33, 0x1f, 0x27, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x03, 0x00, 0x2a, 0x34, 0x20, 0x28, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x02, 0x00, 0x34, 0x3e, 0x19, 0x20, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x01, 0x00, 0x35, 0x3f, 0x1a, 0x21, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x00, 0x00, 0x36, 0x5f, 0x14, 0x1a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x09, 0x00, 0x16, 0x1e, 0x37, 0x60, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x08, 0x00, 0x1e, 0x27, 0x38, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x07, 0x00, 0x1f, 0x28, 0x2f, 0x38, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x06, 0x00, 0x28, 0x32, 0x30, 0x39, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x05, 0x00, 0x29, 0x33, 0x27, 0x30, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x04, 0x00, 0x33, 0x3d, 0x28, 0x31, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x03, 0x00, 0x34, 0x3e, 0x20, 0x28, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x02, 0x00, 0x3e, 0x47, 0x21, 0x29, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x01, 0x00, 0x3f, 0x61, 0x1a, 0x21, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x09, 0x00, 0x1e, 0x27, 0x40, 0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x08, 0x00, 0x27, 0x31, 0x38, 0x40, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x07, 0x00, 0x28, 0x32, 0x39, 0x41, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x06, 0x00, 0x32, 0x3c, 0x30, 0x39, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x05, 0x00, 0x33, 0x3d, 0x31, 0x3a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x04, 0x00, 0x3d, 0x46, 0x28, 0x31, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x03, 0x00, 0x3e, 0x47, 0x29, 0x32, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x02, 0x00, 0x47, 0x64, 0x21, 0x29, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x09, 0x00, 0x27, 0x31, 0x40, 0x63, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x08, 0x00, 0x31, 0x3b, 0x41, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x07, 0x00, 0x32, 0x3c, 0x39, 0x41, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x06, 0x00, 0x3c, 0x45, 0x3a, 0x42, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x05, 0x00, 0x3d, 0x46, 0x31, 0x3a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x04, 0x00, 0x46, 0x4e, 0x32, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x03, 0x00, 0x47, 0x64, 0x29, 0x32, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x09, 0x00, 0x31, 0x3b, 0x48, 0x67, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x08, 0x00, 0x3b, 0x44, 0x41, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x07, 0x00, 0x3c, 0x45, 0x42, 0x49, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x06, 0x00, 0x45, 0x4d, 0x3a, 0x42, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x05, 0x00, 0x46, 0x4e, 0x3b, 0x43, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x04, 0x00, 0x4e, 0x68, 0x32, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x09, 0x00, 0x3b, 0x44, 0x48, 0x67, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x07, 0x00, 0x45, 0x4d, 0x42, 0x49, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x05, 0x00, 0x4e, 0x68, 0x3b, 0x43, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x09, 0x00, 0x44, 0x4c, 0x4f, 0x6c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x06, 0x00, 0x54, 0x6d, 0x43, 0x4a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 
    0x09, 0x00, 0x4c, 0x53, 0x4f, 0x6c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x07, 0x00, 0x54, 0x6d, 0x4a, 0x50, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x08, 0x00, 
    0x09, 0x00, 0x53, 0x57, 0x55, 0x72, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x09, 0x00, 
    0x08, 0x00, 0x57, 0x73, 0x50, 0x55, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x0a, 0x00, 0x15, 0x1d, 0x5e, 0x62, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x00, 0x00, 0x5f, 0x65, 0x1b, 0x22, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0a, 0x00, 0x1d, 0x26, 0x60, 0x66, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x01, 0x00, 0x61, 0x69, 0x22, 0x2a, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x0c, 0x00, 0x1c, 0x25, 0x62, 0x6a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x02, 0x00, 
    0x0a, 0x00, 0x26, 0x30, 0x63, 0x6b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x02, 0x00, 0x64, 0x6e, 0x2a, 0x33, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x00, 0x00, 0x65, 0x6f, 0x23, 0x2b, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0c, 0x00, 0x25, 0x2f, 0x66, 0x70, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x03, 0x00, 
    0x0a, 0x00, 0x30, 0x3a, 0x63, 0x6b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x03, 0x00, 0x64, 0x6e, 0x33, 0x3c, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x01, 0x00, 0x69, 0x75, 0x2b, 0x34, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x0e, 0x00, 0x24, 0x2e, 0x6a, 0x76, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x02, 0x00, 
    0x0c, 0x00, 0x2f, 0x39, 0x6b, 0x77, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x04, 0x00, 
    0x0a, 0x00, 0x3a, 0x43, 0x67, 0x71, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x04, 0x00, 0x68, 0x74, 0x3c, 0x44, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x02, 0x00, 0x6e, 0x7a, 0x34, 0x3d, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x00, 0x00, 0x6f, 0x7b, 0x2c, 0x35, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x0e, 0x00, 0x2e, 0x38, 0x70, 0x7c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x03, 0x00, 
    0x0c, 0x00, 0x39, 0x42, 0x6b, 0x77, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x05, 0x00, 
    0x0a, 0x00, 0x43, 0x4b, 0x67, 0x71, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0a, 0x00, 
    0x05, 0x00, 0x68, 0x74, 0x44, 0x4b, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 
    0x03, 0x00, 0x6e, 0x7a, 0x3d, 0x45, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x01, 0x00, 0x75, 0x81, 0x35, 0x3e, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x10, 0x00, 0x2d, 0x37, 0x76, 0x8a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x02, 0x00, 
    0x0e, 0x00, 0x38, 0x41, 0x77, 0x82, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x04, 0x00, 
    0x0c, 0x00, 0x42, 0x4a, 0x71, 0x7d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0c, 0x00, 
    0x04, 0x00, 0x74, 0x80, 0x45, 0x4c, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x02, 0x00, 0x7a, 0x87, 0x3e, 0x46, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 
    0x00, 0x00, 0x7b, 0x8d, 0x36, 0x3f, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x10, 0x00, 0x37, 0x40, 0x7c, 0x8e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x03, 0x00, 
    0x0e, 0x00, 0x41, 0x49, 0x77, 0x82, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x05, 0x00, 
    0x0c, 0x00, 0x4a, 0x51, 0x71, 0x7d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0c, 0x00, 
    0x05, 0x00, 0x74, 0x80, 0x4c, 0x52, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x03, 0x00, 0x7a, 0x87, 0x46, 0x4d, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 
    0x01, 0x00, 0x81, 0x91, 0x3f, 0x47, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x10, 0x00, 0x40, 0x48, 0x82, 0x92, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x04, 0x00, 
    0x0e, 0x00, 0x49, 0x50, 0x7d, 0x88, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x06, 0x00, 
    0x0c, 0x00, 0x51, 0x56, 0x78, 0x83, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x0c, 0x00, 
    0x06, 0x00, 0x79, 0x86, 0x52, 0x56, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x0e, 0x00, 
    0x04, 0x00, 0x80, 0x89, 0x4d, 0x53, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 
    0x02, 0x00, 0x87, 0x95, 0x47, 0x4e, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x10, 0x00, 0x48, 0x4f, 0x82, 0x92, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x00, 
    0x03, 0x00, 0x87, 0x95, 0x4e, 0x54, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x14, 0x00, 0x5e, 0x60, 0x8a, 0x9a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x04, 0x00, 
    0x10, 0x00, 0x4f, 0x55, 0x88, 0x96, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x00, 
    0x04, 0x00, 0x89, 0x99, 0x54, 0x57, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x00, 0x00, 0x8d, 0x9d, 0x5f, 0x61, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x14, 0x00, 0x60, 0x63, 0x8e, 0x9e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x05, 0x00, 
    0x10, 0x00, 0x55, 0x58, 0x88, 0x96, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x00, 
    0x05, 0x00, 0x89, 0x99, 0x57, 0x59, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x01, 0x00, 0x91, 0x9f, 0x61, 0x64, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x14, 0x00, 0x63, 0x67, 0x92, 0xa0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x06, 0x00, 
    0x10, 0x00, 0x58, 0x5a, 0x8b, 0x9b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x00, 
    0x06, 0x00, 0x8c, 0x9c, 0x59, 0x5b, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x02, 0x00, 0x95, 0xa1, 0x64, 0x68, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x14, 0x00, 0x67, 0x6c, 0x92, 0xa0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x07, 0x00, 
    0x10, 0x00, 0x5a, 0x5c, 0x8b, 0x9b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x00, 
    0x07, 0x00, 0x8c, 0x9c, 0x5b, 0x5d, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x14, 0x00, 
    0x03, 0x00, 0x95, 0xa1, 0x68, 0x6d, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x18, 0x00, 0x62, 0x66, 0x9a, 0xa4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x04, 0x00, 
    0x14, 0x00, 0x6c, 0x72, 0x96, 0xa2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x14, 0x00, 
    0x04, 0x00, 0x99, 0xa3, 0x6d, 0x73, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x18, 0x00, 
    0x00, 0x00, 0x9d, 0xa7, 0x65, 0x69, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x18, 0x00, 0x66, 0x6b, 0x9e, 0xa8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x18, 0x00, 
    0x01, 0x00, 0x9f, 0xab, 0x69, 0x6e, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x18, 0x00, 0x6b, 0x71, 0xa0, 0xac, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x18, 0x00, 
    0x02, 0x00, 0xa1, 0xad, 0x6e, 0x74, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x18, 0x00, 0x71, 0x78, 0xa0, 0xac, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x18, 0x00, 
    0x03, 0x00, 0xa1, 0xad, 0x74, 0x79, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x1c, 0x00, 0x6a, 0x70, 0xa4, 0xb0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x04, 0x00, 
    0x18, 0x00, 0x78, 0x7e, 0xa2, 0xae, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x18, 0x00, 
    0x04, 0x00, 0xa3, 0xaf, 0x79, 0x7f, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x1c, 0x00, 
    0x00, 0x00, 0xa7, 0xb1, 0x6f, 0x75, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x1c, 0x00, 0x70, 0x77, 0xa8, 0xb2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x05, 0x00, 
    0x18, 0x00, 0x7e, 0x84, 0xa2, 0xae, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x18, 0x00, 
    0x05, 0x00, 0xa3, 0xaf, 0x7f, 0x85, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x1c, 0x00, 
    0x01, 0x00, 0xab, 0xb3, 0x75, 0x7a, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x1c, 0x00, 0x77, 0x7d, 0xac, 0xb4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x1c, 0x00, 
    0x02, 0x00, 0xad, 0xb5, 0x7a, 0x80, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x1c, 0x00, 0x7d, 0x83, 0xac, 0xb4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0x1c, 0x00, 
    0x03, 0x00, 0xad, 0xb5, 0x80, 0x86, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x20, 0x00, 0x76, 0x7c, 0xb0, 0xbe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x00, 0x00, 0xb1, 0xbf, 0x7b, 0x81, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x20, 0x00, 0x7c, 0x82, 0xb2, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x01, 0x00, 0xb3, 0xc1, 0x81, 0x87, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x20, 0x00, 0x82, 0x88, 0xb4, 0xc2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x02, 0x00, 0xb5, 0xc3, 0x87, 0x89, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x20, 0x00, 0x88, 0x8b, 0xb4, 0xc2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x03, 0x00, 0xb5, 0xc3, 0x89, 0x8c, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x20, 0x00, 0x8b, 0x8f, 0xb6, 0xc4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x04, 0x00, 0xb7, 0xc5, 0x8c, 0x90, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x20, 0x00, 0x8f, 0x93, 0xb6, 0xc4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x05, 0x00, 0xb7, 0xc5, 0x90, 0x94, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x06, 0x00, 
    0x20, 0x00, 0x93, 0x97, 0xb8, 0xc6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x20, 0x00, 
    0x06, 0x00, 0xb9, 0xc7, 0x94, 0x98, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x30, 0x00, 0x9a, 0x9e, 0xbe, 0xc8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x30, 0x00, 
    0x00, 0x00, 0xbf, 0xc9, 0x9d, 0x9f, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x30, 0x00, 0x9e, 0xa0, 0xc0, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x30, 0x00, 
    0x01, 0x00, 0xc1, 0xcb, 0x9f, 0xa1, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x30, 0x00, 0xa0, 0xa2, 0xc2, 0xcc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x30, 0x00, 
    0x02, 0x00, 0xc3, 0xcd, 0xa1, 0xa3, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x30, 0x00, 0xa2, 0xa5, 0xc2, 0xcc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x30, 0x00, 
    0x03, 0x00, 0xc3, 0xcd, 0xa3, 0xa6, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x30, 0x00, 0xa5, 0xa9, 0xc4, 0xce, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x30, 0x00, 
    0x04, 0x00, 0xc5, 0xcf, 0xa6, 0xaa, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x40, 0x00, 0xb0, 0xb2, 0xc8, 0xd4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x00, 0x00, 0xc9, 0xd5, 0xb1, 0xb3, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x40, 0x00, 0xb2, 0xb4, 0xca, 0xd6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x01, 0x00, 0xcb, 0xd7, 0xb3, 0xb5, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x40, 0x00, 0xb4, 0xb6, 0xcc, 0xd8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x02, 0x00, 0xcd, 0xd9, 0xb5, 0xb7, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x40, 0x00, 0xb6, 0xb8, 0xcc, 0xd8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x03, 0x00, 0xcd, 0xd9, 0xb7, 0xb9, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x40, 0x00, 0xb8, 0xba, 0xce, 0xda, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x04, 0x00, 0xcf, 0xdb, 0xb9, 0xbb, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x05, 0x00, 
    0x40, 0x00, 0xba, 0xbc, 0xce, 0xda, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x40, 0x00, 
    0x05, 0x00, 0xcf, 0xdb, 0xbb, 0xbd, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x60, 0x00, 0xbe, 0xc0, 0xd4, 0xdc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x60, 0x00, 
    0x00, 0x00, 0xd5, 0xdd, 0xbf, 0xc1, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x60, 0x00, 0xc0, 0xc2, 0xd6, 0xde, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x60, 0x00, 
    0x01, 0x00, 0xd7, 0xdf, 0xc1, 0xc3, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x60, 0x00, 0xc2, 0xc4, 0xd8, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x60, 0x00, 
    0x02, 0x00, 0xd9, 0xe1, 0xc3, 0xc5, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x60, 0x00, 0xc4, 0xc6, 0xd8, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x07, 0x60, 0x00, 
    0x03, 0x00, 0xd9, 0xe1, 0xc5, 0xc7, 0xff, 0xff, 0xff, 0x07, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x80, 0x00, 0xc8, 0xca, 0xdc, 0xe6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x80, 0x00, 
    0x00, 0x00, 0xdd, 0xe7, 0xc9, 0xcb, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x80, 0x00, 0xca, 0xcc, 0xde, 0xe8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x80, 0x00, 
    0x01, 0x00, 0xdf, 0xe9, 0xcb, 0xcd, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x80, 0x00, 0xcc, 0xce, 0xe0, 0xea, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x80, 0x00, 
    0x02, 0x00, 0xe1, 0xeb, 0xcd, 0xcf, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x80, 0x00, 0xce, 0xd0, 0xe0, 0xea, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x80, 0x00, 
    0x03, 0x00, 0xe1, 0xeb, 0xcf, 0xd1, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0xff, 0x04, 0x00, 
    0x80, 0x00, 0xd0, 0xd2, 0xe2, 0xec, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01, 0x80, 0x00, 
    0x04, 0x00, 0xe3, 0xed, 0xd1, 0xd3, 0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x00, 0x01, 0xdc, 0xde, 0xe6, 0xee, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x01, 
    0x00, 0x00, 0xe7, 0xef, 0xdd, 0xdf, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x00, 0x01, 0xde, 0xe0, 0xe8, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x01, 
    0x01, 0x00, 0xe9, 0xf1, 0xdf, 0xe1, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x00, 0x01, 0xe0, 0xe2, 0xea, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x01, 
    0x02, 0x00, 0xeb, 0xf3, 0xe1, 0xe3, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0x03, 0x00, 
    0x00, 0x01, 0xe2, 0xe4, 0xea, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x01, 
    0x03, 0x00, 0xeb, 0xf3, 0xe3, 0xe5, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 
    0x00, 0x02, 0xe6, 0xe8, 0xee, 0xee, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 
    0x00, 0x00, 0xef, 0xef, 0xe7, 0xe9, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x01, 0x00, 
    0x00, 0x02, 0xe8, 0xea, 0xf0, 0xf0, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 
    0x01, 0x00, 0xf1, 0xf1, 0xe9, 0xeb, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x02, 0x00, 
    0x00, 0x02, 0xea, 0xec, 0xf2, 0xf2, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 
    0x02, 0x00, 0xf3, 0xf3, 0xeb, 0xed, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 

################################################################################

TITLE
    Bzip2 signature

TYPE
    8

DATA
    "BZh91A"

################################################################################

TITLE
    Bzip2 BZ2_rNums

TYPE
    16 32

DATA
   619, 720, 127, 481, 931, 816, 813, 233, 566, 247, 
   985, 724, 205, 454, 863, 491, 741, 242, 949, 214, 
   733, 859, 335, 708, 621, 574, 73, 654, 730, 472, 
   419, 436, 278, 496, 867, 210, 399, 680, 480, 51, 
   878, 465, 811, 169, 869, 675, 611, 697, 867, 561, 
   862, 687, 507, 283, 482, 129, 807, 591, 733, 623, 
   150, 238, 59, 379, 684, 877, 625, 169, 643, 105, 
   170, 607, 520, 932, 727, 476, 693, 425, 174, 647, 
   73, 122, 335, 530, 442, 853, 695, 249, 445, 515, 
   909, 545, 703, 919, 874, 474, 882, 500, 594, 612, 
   641, 801, 220, 162, 819, 984, 589, 513, 495, 799, 
   161, 604, 958, 533, 221, 400, 386, 867, 600, 782, 
   382, 596, 414, 171, 516, 375, 682, 485, 911, 276, 
   98, 553, 163, 354, 666, 933, 424, 341, 533, 870, 
   227, 730, 475, 186, 263, 647, 537, 686, 600, 224, 
   469, 68, 770, 919, 190, 373, 294, 822, 808, 206, 
   184, 943, 795, 384, 383, 461, 404, 758, 839, 887, 
   715, 67, 618, 276, 204, 918, 873, 777, 604, 560, 
   951, 160, 578, 722, 79, 804, 96, 409, 713, 940, 
   652, 934, 970, 447, 318, 353, 859, 672, 112, 785, 
   645, 863, 803, 350, 139, 93, 354, 99, 820, 908, 
   609, 772, 154, 274, 580, 184, 79, 626, 630, 742, 
   653, 282, 762, 623, 680, 81, 927, 626, 789, 125, 
   411, 521, 938, 300, 821, 78, 343, 175, 128, 250, 
   170, 774, 972, 275, 999, 639, 495, 78, 352, 126, 
   857, 956, 358, 619, 580, 124, 737, 594, 701, 612, 
   669, 112, 134, 694, 363, 992, 809, 743, 168, 974, 
   944, 375, 748, 52, 600, 747, 642, 182, 862, 81, 
   344, 805, 988, 739, 511, 655, 814, 334, 249, 515, 
   897, 955, 664, 981, 649, 113, 974, 459, 893, 228, 
   433, 837, 553, 268, 926, 240, 102, 654, 459, 51, 
   686, 754, 806, 760, 493, 403, 415, 394, 687, 700, 
   946, 670, 656, 610, 738, 392, 760, 799, 887, 653, 
   978, 321, 576, 617, 626, 502, 894, 679, 243, 440, 
   680, 879, 194, 572, 640, 724, 926, 56, 204, 700, 
   707, 151, 457, 449, 797, 195, 791, 558, 945, 679, 
   297, 59, 87, 824, 713, 663, 412, 693, 342, 606, 
   134, 108, 571, 364, 631, 212, 174, 643, 304, 329, 
   343, 97, 430, 751, 497, 314, 983, 374, 822, 928, 
   140, 206, 73, 263, 980, 736, 876, 478, 430, 305, 
   170, 514, 364, 692, 829, 82, 855, 953, 676, 246, 
   369, 970, 294, 750, 807, 827, 150, 790, 288, 923, 
   804, 378, 215, 828, 592, 281, 565, 555, 710, 82, 
   896, 831, 547, 261, 524, 462, 293, 465, 502, 56, 
   661, 821, 976, 991, 658, 869, 905, 758, 745, 193, 
   768, 550, 608, 933, 378, 286, 215, 979, 792, 961, 
   61, 688, 793, 644, 986, 403, 106, 366, 905, 644, 
   372, 567, 466, 434, 645, 210, 389, 550, 919, 135, 
   780, 773, 635, 389, 707, 100, 626, 958, 165, 504, 
   920, 176, 193, 713, 857, 265, 203, 50, 668, 108, 
   645, 990, 626, 197, 510, 357, 358, 850, 858, 364, 
   936, 638

################################################################################

TITLE
    Jpeg dct 14 bit aanscales

TYPE
    16

DATA
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  22725, 31521, 29692, 26722, 22725, 17855, 12299,  6270,
	  21407, 29692, 27969, 25172, 21407, 16819, 11585,  5906,
	  19266, 26722, 25172, 22654, 19266, 15137, 10426,  5315,
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  12873, 17855, 16819, 15137, 12873, 10114,  6967,  3552,
	   8867, 12299, 11585, 10426,  8867,  6967,  4799,  2446,
	   4520,  6270,  5906,  5315,  4520,  3552,  2446,  1247

################################################################################

TITLE
    Jpeg dct AA&N scale factor

TYPE
    FLOAT

DATA
	  1.0, 1.387039845, 1.306562965, 1.175875602,
	  1.0, 0.785694958, 0.541196100, 0.275899379

################################################################################

TITLE
    libmng interlace const

TYPE
    32

DATA
/* MNG_LOCAL mng_uint32 const interlace_row      [7] = */ { 0, 0, 4, 0, 2, 0, 1 };
/* MNG_LOCAL mng_uint32 const interlace_rowskip  [7] = */ { 8, 8, 8, 4, 4, 2, 2 };
/* MNG_LOCAL mng_uint32 const interlace_col      [7] = */ { 0, 4, 0, 2, 0, 1, 0 };
/* MNG_LOCAL mng_uint32 const interlace_colskip  [7] = */ { 8, 8, 4, 4, 2, 2, 1 };
/* MNG_LOCAL mng_uint32 const interlace_roundoff [7] = */ { 7, 7, 3, 3, 1, 1, 0 };
/* MNG_LOCAL mng_uint32 const interlace_divider  [7] = */ { 3, 3, 2, 2, 1, 1, 0 };

################################################################################

TITLE
    Little CMS inter PCS conversions

TYPE
    FLOAT AND

DATA
    45.2548339756803022511987494    192.2798368355061050458134625
    119.1654824285581628956914143   13.43250139086239872172837314
    0.1636161226585754240958355063  14.80884093219134573786480845
    151.9714051044435648658557668   168.5254414101568283957668343
    33.9905941350215598754191872
    65280.0     0.964294    1.000000    0.825104    127.9961

################################################################################

TITLE
    Little CMS isotempdata

TYPE
    FLOAT

DATA
    {0,     0.18006,  0.26352,  -0.24341},
    {10,    0.18066,  0.26589,  -0.25479},
    {20,    0.18133,  0.26846,  -0.26876},
    {30,    0.18208,  0.27119,  -0.28539},
    {40,    0.18293,  0.27407,  -0.30470},
    {50,    0.18388,  0.27709,  -0.32675},
    {60,    0.18494,  0.28021,  -0.35156},
    {70,    0.18611,  0.28342,  -0.37915},
    {80,    0.18740,  0.28668,  -0.40955},
    {90,    0.18880,  0.28997,  -0.44278},
    {100,   0.19032,  0.29326,  -0.47888},
    {125,   0.19462,  0.30141,  -0.58204},
    {150,   0.19962,  0.30921,  -0.70471},
    {175,   0.20525,  0.31647,  -0.84901},
    {200,   0.21142,  0.32312,  -1.0182 },
    {225,   0.21807,  0.32909,  -1.2168 },
    {250,   0.22511,  0.33439,  -1.4512 },
    {275,   0.23247,  0.33904,  -1.7298 },
    {300,   0.24010,  0.34308,  -2.0637 },
    {325,   0.24702,  0.34655,  -2.4681 },
    {350,   0.25591,  0.34951,  -2.9641 },
    {375,   0.26400,  0.35200,  -3.5814 },
    {400,   0.27218,  0.35407,  -4.3633 },
    {425,   0.28039,  0.35577,  -5.3762 },
    {450,   0.28863,  0.35714,  -6.7262 },
    {475,   0.29685,  0.35823,  -8.5955 },
    {500,   0.30505,  0.35907,  -11.324 },
    {525,   0.31320,  0.35968,  -15.628 },
    {550,   0.32129,  0.36011,  -23.325 },
    {575,   0.32931,  0.36038,  -40.770 },
    {600,   0.33724,  0.36051, -116.45  }

################################################################################

TITLE
    LD-CELP G.728 cb_shape

TYPE
    FLOAT

DATA
{  0.326171875, -1.440429688, -0.612304688, -0.874023438, -1.246582031},
{ -2.457031250, -2.234863281, -0.510253906,  1.419921875,  1.620117188},
{ -1.376464844, -1.307128906, -0.462890625, -1.379394531, -2.172851563},
{ -3.261230469, -0.166015625,  0.723632813, -0.623046875,  0.616210938},
{ -0.274414063, -3.299316406,  0.625488281,  0.087402344, -0.622070313},
{ -1.226562500, -3.481445313, -2.404785156,  3.375488281,  1.177246094},
{ -1.209960938, -0.076171875,  2.286621094, -1.891113281,  0.000000000},
{ -4.007812500,  1.044921875, -0.233398438, -1.359863281,  0.260253906},
{  0.922363281,  1.347167969,  0.674316406, -3.395996094, -2.887207031},
{  2.481445313, -1.201171875, -2.821289063,  0.877441406,  0.277343750},
{ -1.078125000, -1.615722656, -2.208496094, -3.044921875, -3.664550781},
{ -1.327636719,  2.127929688, -1.458984375, -0.561035156,  1.300781250},
{  0.614746094,  0.485839844,  1.323730469, -1.203125000, -5.073242188},
{  0.840820313, -3.695800781, -1.338867188,  1.060058594, -1.137207031},
{  0.503906250,  0.364746094, -0.418945313, -3.879882813, -6.270996094},
{  1.516601563,  2.371093750, -2.047363281, -1.240722656,  0.505371094},
{  0.909179688, -0.468750000, -3.236328125,  0.200195313,  2.872070313},
{ -1.217285156, -1.283203125, -1.953125000, -0.029296875,  3.516601563},
{ -1.304687500,  0.706054688,  0.750000000, -1.870605469,  0.602050781},
{ -2.588867188,  3.375000000,  0.775878906, -2.044433594,  1.789550781},
{ -1.687500000, -3.989257813, -3.764160156,  0.675781250,  2.293945313},
{ -2.294433594, -3.031738281, -5.457031250,  3.957031250,  8.217773438},
{  0.454101563,  3.419921875,  0.619628906, -4.383300781,  1.253417969},
{  2.270019531,  5.763671875,  1.680175781, -2.762207031,  0.585449219},
{  1.241210938, -0.089355469, -4.325683594, -3.894531250,  1.577148438},
{ -1.402343750, -0.981933594, -4.742675781, -4.094238281,  6.339355469},
{  1.506835938,  1.044921875, -1.796875000, -4.708496094, -1.414062500},
{ -3.715332031,  3.181152344, -1.114746094, -1.231445313,  3.091796875},
{ -1.627441406, -2.744140625, -4.458007813, -5.435058594,  2.706542969},
{ -0.198730469, -3.281738281, -8.528320313, -1.410644531,  5.648437500},
{  1.802734375,  3.318359375, -0.127929688, -5.295898438, -0.906250000},
{  3.552246094,  6.544921875, -1.459472656, -5.173339844,  2.410156250},
{  0.119140625, -1.083496094,  1.296875000,  1.843750000, -2.642578125},
{ -1.974121094, -2.897460938,  1.040527344,  0.421386719, -1.399414063},
{ -1.612304688,  0.851074219, -0.979492188, -0.062500000, -1.001953125},
{ -3.105957031,  1.631835938, -0.772949219, -0.010253906,  0.557617188},
{ -1.873535156, -0.894042969,  3.123535156,  1.242675781, -1.390625000},
{ -4.556640625, -3.187500000,  2.592285156,  0.969726563, -1.096191406},
{ -2.192382813,  0.365234375,  0.944824219, -1.478027344, -0.240722656},
{ -4.519042969,  2.620117188,  1.559082031, -2.193847656,  0.871093750},
{  2.335937500, -0.180664063,  0.911132813,  0.516113281, -0.922363281},
{  3.584960938, -1.313476563, -1.258300781,  0.330078125, -0.298339844},
{ -0.245117188,  1.091308594, -0.903320313, -0.867675781, -1.000488281},
{  0.493652344,  1.894531250, -1.203613281,  1.078613281, -0.074218750},
{  1.265625000,  1.381347656,  2.728515625,  1.386230469, -3.567382813},
{ -1.488769531, -2.401367188,  2.907714844,  4.492675781, -2.171386719},
{  0.340332031,  1.908203125,  2.831054688, -2.173339844, -2.267578125},
{ -1.035644531,  2.658203125, -1.254882813,  0.156738281, -0.586914063},
{  1.389648438, -1.018554688,  1.724609375,  0.276367188, -0.345703125},
{ -2.089355469,  0.463867188,  2.431640625,  1.830566406,  0.220703125},
{ -1.212890625,  1.709960938,  0.839355469, -0.083007813,  0.116210938},
{ -1.677246094,  0.128417969,  1.032226563, -0.979003906,  1.152832031},
{ -3.583007813, -0.589843750,  4.563964844, -0.593750000, -1.959472656},
{ -6.590820313, -0.214355469,  3.919921875, -2.066406250,  0.176269531},
{ -1.820800781,  2.652832031,  0.978515625, -2.308105469, -0.614746094},
{ -1.946289063,  3.780761719,  4.115722656, -1.802246094, -0.481933594},
{  2.538085938, -0.206542969,  0.561523438, -0.625488281,  0.398437500},
{  3.617675781,  2.006347656, -1.928222656,  1.313476563,  0.014648438},
{  0.608398438,  1.491699219, -0.017089844, -0.668945313, -0.120117188},
{ -0.727050781,  2.751464844, -0.331054688, -1.282714844,  1.547851563},
{  2.358398438, -2.238769531,  0.980468750, -0.518554688,  0.390136719},
{ -0.062988281,  0.350097656,  2.243164063,  7.293457031,  5.227539063},
{  0.203613281,  1.347167969,  0.903320313, -2.469238281, -0.562988281},
{ -1.897949219,  3.594238281, -2.816406250,  2.092285156,  0.325195313},
{  0.704589844, -0.458007813,  0.009765625, -1.034667969, -0.828613281},
{ -1.812500000, -1.661132813, -1.080078125,  0.053710938,  1.042968750},
{ -1.441406250,  0.005859375, -0.765625000, -1.708984375, -0.905761719},
{ -0.642089844, -0.845214844,  0.566406250, -0.272460938,  0.834472656},
{  0.042968750, -2.230957031,  0.094726563, -0.221679688, -1.443847656},
{ -1.386230469, -0.813476563, -0.133300781,  1.017578125, -0.075683594},
{ -0.092285156, -1.160156250,  0.812011719, -0.507812500, -1.195800781},
{ -1.387695313, -0.668457031,  0.310546875, -0.121093750, -1.307128906},
{  0.740722656,  0.038574219, -1.471191406, -1.791503906, -0.475097656},
{  0.934082031, -1.217285156, -2.593750000, -0.365722656,  0.620605469},
{ -1.417480469, -1.623046875, -1.833984375, -1.801757813, -0.893066406},
{ -1.422363281, -0.755371094, -1.347656250, -0.686523438,  0.548828125},
{  0.900390625, -0.895507813,  0.222656250,  0.344726563, -2.085937500},
{  0.228027344, -2.078125000, -0.932128906,  0.742675781,  0.553710938},
{ -0.062011719, -0.485351563, -0.311035156, -0.728027344, -3.170898438},
{  0.426269531, -0.998535156, -1.869140625, -1.363281250, -0.282226563},
{  1.128417969, -0.887207031,  1.285156250, -1.490234375,  0.960937500},
{  0.312988281,  0.583007813,  0.924316406,  2.005371094,  3.096679688},
{ -0.021972656,  0.584960938,  1.054687500, -0.707519531,  1.075683594},
{ -0.978515625,  0.836425781,  1.717773438,  1.294921875,  2.075683594},
{  1.433593750, -1.937500000,  0.625000000,  0.063964844, -0.720703125},
{  1.380371094,  0.003906250, -0.941406250,  1.297851563,  1.715332031},
{  1.562011719, -0.398437500,  1.312011719, -0.850097656, -0.687011719},
{  1.439453125,  1.967285156,  0.192382813, -0.123535156,  0.633789063},
{  2.092773438,  0.024902344, -2.200683594, -0.015625000, -0.321777344},
{  1.905761719,  2.756835938, -2.728515625, -1.265625000,  2.786621094},
{ -0.295898438,  0.602539063, -0.784667969, -2.532714844,  0.324218750},
{ -0.256347656,  1.767578125, -1.070312500, -1.233886719,  0.833496094},
{  2.098144531, -1.587402344, -1.114746094,  0.396484375, -1.105468750},
{  2.814941406,  0.257812500, -1.604980469,  0.660156250,  0.816406250},
{  1.335449219,  0.605957031, -0.538574219, -1.598144531, -1.663574219},
{  1.969238281,  0.804687500, -1.447753906, -0.573242188,  0.705078125},
{  0.036132813,  0.448242188,  0.976074219,  0.446777344, -0.500976563},
{ -1.218750000, -0.783691406,  0.993164063,  1.440429688,  0.111816406},
{ -1.058593750,  0.994628906,  0.007324219, -0.617187500, -0.101562500},
{ -1.734375000,  0.747070313,  0.283691406,  0.728027344,  0.469726563},
{ -1.275878906, -1.141601563,  1.768066406, -0.726562500, -1.066894531},
{ -0.853027344,  0.039550781,  2.704101563,  0.699218750, -1.102050781},
{ -0.497558594,  0.423339844,  0.104492188, -1.115234375, -0.737304688},
{ -0.822265625,  1.375000000, -0.111816406,  1.245605469, -0.678222656},
{  1.321777344,  0.246093750,  0.233886719,  1.358886719, -0.492675781},
{  1.229003906, -0.726074219, -0.779296875,  0.303222656,  0.941894531},
{ -0.072265625,  1.077148438, -2.093750000,  0.630859375, -0.684082031},
{ -0.257324219,  0.606933594, -1.333496094,  0.932128906,  0.625000000},
{  1.049316406, -0.732910156,  1.800781250,  0.297851563, -2.241699219},
{  1.614257813, -1.645019531,  0.915527344,  1.775390625, -0.594238281},
{  1.256835938,  1.227050781,  0.707519531, -1.500976563, -2.431152344},
{  0.397460938,  0.891601563, -1.219238281,  2.067382813, -1.990722656},
{  0.812500000, -0.107421875,  1.668945313,  0.489257813,  0.544433594},
{  0.381347656,  0.809570313,  1.913574219,  2.993164063,  1.533203125},
{  0.560546875,  1.984863281,  0.740234375,  0.397949219,  0.097167969},
{  0.581542969,  1.215332031,  1.250488281,  1.182128906,  1.192871094},
{  0.375976563, -2.888183594,  2.692871094, -0.179687500, -1.562011719},
{  0.581054688,  0.511230469,  1.827148438,  3.382324219, -1.020019531},
{  0.142578125,  1.513183594,  2.103515625, -0.370117188, -1.198730469},
{  0.255371094,  1.914550781,  1.974609375,  0.676757813,  0.041503906},
{  2.132324219,  0.491210938, -0.611328125, -0.715820313, -0.675292969},
{  1.880859375,  0.770996094, -0.037597656,  1.007812500,  0.423828125},
{  2.494628906,  1.425292969, -0.098632813,  0.175292969, -0.248535156},
{  1.782226563,  1.565429688,  1.124511719,  0.826660156,  0.632812500},
{  1.418457031, -1.907714844,  0.111816406, -0.583984375, -1.138671875},
{  2.918457031, -1.750488281,  0.393066406,  1.867675781, -1.532226563},
{  1.829101563, -0.295898438,  0.025878906, -0.131347656, -1.611816406},
{  0.295898438,  0.985351563, -0.642578125,  1.984375000,  0.194335938}

################################################################################

TITLE
    LD-CELP G.728 cb_gain

TYPE
    FLOAT

DATA
     0.515625,  .90234375,  1.579101563,  2.763427734,
    -0.515625, -.90234375, -1.579101563, -2.763427734

################################################################################

TITLE
    LD-CELP G.728 cb_gain2

TYPE
    FLOAT

DATA
     1.031250,  1.8046875, 3.158203126,  5.526855468,
    -1.031250, -1.8046875, -3.158203126, -5.526855468};

################################################################################

TITLE
    LD-CELP G.728 cb_gain_mid

TYPE
    FLOAT

DATA
     0.708984375,  1.240722656,  2.171264649, 0, 
    -0.708984375, -1.240722656, -2.171264649, 0};

################################################################################

TITLE
    LD-CELP G.728 cb_gain_sq

TYPE
    FLOAT

DATA
    0.26586914, 0.814224243, 2.493561746, 7.636532841,
    0.26586914, 0.814224243, 2.493561746, 7.636532841};

################################################################################

TITLE
    LD-CELP G.728 hw_gain

TYPE
    FLOAT

DATA
 0.583953857, 0.605346680, 0.627502441, 0.650482178, 0.674316406,
 0.699005127, 0.724578857, 0.751129150, 0.778625488, 0.807128906,
 0.836669922, 0.867309570, 0.899078369, 0.932006836, 0.961486816,
 0.982757568, 0.995635986, 1.000000000, 0.995819092, 0.983154297,
 0.962066650, 0.932769775, 0.895507812, 0.850585938, 0.798400879,
 0.739379883, 0.674072266, 0.602996826, 0.526763916, 0.446014404,
 0.361480713, 0.273834229, 0.183868408, 0.092346191

################################################################################

TITLE
    LD-CELP G.728 hw_percw

TYPE
    FLOAT

DATA
 0.581085205, 0.591217041, 0.601562500, 0.612091064, 0.622772217,
 0.633666992, 0.644744873, 0.656005859, 0.667480469, 0.679138184,
 0.691009521, 0.703094482, 0.715393066, 0.727874756, 0.740600586,
 0.753570557, 0.766723633, 0.780120850, 0.793762207, 0.807647705,
 0.821746826, 0.836120605, 0.850738525, 0.865600586, 0.880737305,
 0.896148682, 0.911804199, 0.927734375, 0.943939209, 0.960449219,
 0.975372314, 0.986816406, 0.994720459, 0.999084473, 0.999847412,
 0.997070312, 0.990722656, 0.980865479, 0.967468262, 0.950622559,
 0.930389404, 0.906829834, 0.880035400, 0.850097656, 0.817108154,
 0.781219482, 0.742523193, 0.701171875, 0.657348633, 0.611145020,
 0.562774658, 0.512390137, 0.460174561, 0.406311035, 0.351013184,
 0.294433594, 0.236816406, 0.178375244, 0.119262695, 0.059722900

################################################################################

TITLE
    LD-CELP G.728 hw_synth

TYPE
    FLOAT

DATA
 0.602020264, 0.606384277, 0.610748291, 0.615142822, 0.619598389,
 0.624084473, 0.628570557, 0.633117676, 0.637695312, 0.642272949,
 0.646911621, 0.651580811, 0.656280518, 0.661041260, 0.665802002,
 0.670593262, 0.675445557, 0.680328369, 0.685241699, 0.690185547,
 0.695159912, 0.700164795, 0.705230713, 0.710327148, 0.715454102,
 0.720611572, 0.725830078, 0.731048584, 0.736328125, 0.741638184,
 0.747009277, 0.752380371, 0.757812500, 0.763305664, 0.768798828,
 0.774353027, 0.779937744, 0.785583496, 0.791229248, 0.796936035,
 0.802703857, 0.808502197, 0.814331055, 0.820220947, 0.826141357,
 0.832092285, 0.838104248, 0.844146729, 0.850250244, 0.856384277,
 0.862548828, 0.868774414, 0.875061035, 0.881378174, 0.887725830,
 0.894134521, 0.900604248, 0.907104492, 0.913635254, 0.920227051,
 0.926879883, 0.933563232, 0.940307617, 0.947082520, 0.953918457,
 0.960815430, 0.967742920, 0.974731445, 0.981781006, 0.988861084,
 0.994842529, 0.998565674, 0.999969482, 0.999114990, 0.996002197,
 0.990600586, 0.982910156, 0.973022461, 0.960876465, 0.946533203,
 0.930053711, 0.911437988, 0.890747070, 0.868041992, 0.843322754,
 0.816680908, 0.788208008, 0.757904053, 0.725891113, 0.692199707,
 0.656921387, 0.620178223, 0.582000732, 0.542480469, 0.501739502,
 0.459838867, 0.416900635, 0.373016357, 0.328277588, 0.282775879,
 0.236663818, 0.189971924, 0.142852783, 0.095428467, 0.047760010

################################################################################

TITLE
    LD-CELP G.728 shzscale and shpscale

TYPE
    FLOAT

DATA
//static real shzscale[SPORDER+1]= /* Precomputed Scales for IIR coefficients */
{ 1.0, 0.6500244140625, 0.4224853515625, 0.27459716796875, 
  0.17852783203125, 0.11602783203125, 0.075439453125, 
  0.04901123046875, 0.0318603515625, 0.02069091796875, 0.01348876953125};

//static real shpscale[SPORDER+1]= /* Precomputed Scales for FIR Coefficients */
{ 1.0, 0.75, 0.5625, 0.421875, 0.31640625, 0.2373046875, 0.177978515625, 
  0.13348388671875, 0.10009765625, 0.0750732421875, 0.05633544921875};

################################################################################

TITLE
    G.711 u- to A-law conversions (81 82)

TYPE
    8

DATA
	1,	1,	2,	2,	3,	3,	4,	4,
	5,	5,	6,	6,	7,	7,	8,	8,
	9,	10,	11,	12,	13,	14,	15,	16,
	17,	18,	19,	20,	21,	22,	23,	24,
	25,	27,	29,	31,	33,	34,	35,	36,
	37,	38,	39,	40,	41,	42,	43,	44,
	46,	48,	49,	50,	51,	52,	53,	54,
	55,	56,	57,	58,	59,	60,	61,	62,
	64,	65,	66,	67,	68,	69,	70,	71,
	72,	73,	74,	75,	76,	77,	78,	79,
	81,	82,	83,	84,	85,	86,	87,	88,
	89,	90,	91,	92,	93,	94,	95,	96,
	97,	98,	99,	100,	101,	102,	103,	104,
	105,	106,	107,	108,	109,	110,	111,	112,
	113,	114,	115,	116,	117,	118,	119,	120,
	121,	122,	123,	124,	125,	126,	127,	128};

################################################################################

TITLE
    G.711 u- to A-law conversions (80 82)

TYPE
    8

DATA
	1,	1,	2,	2,	3,	3,	4,	4,
	5,	5,	6,	6,	7,	7,	8,	8,
	9,	10,	11,	12,	13,	14,	15,	16,
	17,	18,	19,	20,	21,	22,	23,	24,
	25,	27,	29,	31,	33,	34,	35,	36,
	37,	38,	39,	40,	41,	42,	43,	44,
	46,	48,	49,	50,	51,	52,	53,	54,
	55,	56,	57,	58,	59,	60,	61,	62,
	64,	65,	66,	67,	68,	69,	70,	71,
	72,	73,	74,	75,	76,	77,	78,	79,
	80,	82,	83,	84,	85,	86,	87,	88,
	89,	90,	91,	92,	93,	94,	95,	96,
	97,	98,	99,	100,	101,	102,	103,	104,
	105,	106,	107,	108,	109,	110,	111,	112,
	113,	114,	115,	116,	117,	118,	119,	120,
	121,	122,	123,	124,	125,	126,	127,	128};

################################################################################

TITLE
    G.711 A- to u-law conversions (79 79)

TYPE
    8

DATA
	1,	3,	5,	7,	9,	11,	13,	15,
	16,	17,	18,	19,	20,	21,	22,	23,
	24,	25,	26,	27,	28,	29,	30,	31,
	32,	32,	33,	33,	34,	34,	35,	35,
	36,	37,	38,	39,	40,	41,	42,	43,
	44,	45,	46,	47,	48,	48,	49,	49,
	50,	51,	52,	53,	54,	55,	56,	57,
	58,	59,	60,	61,	62,	63,	64,	64,
	65,	66,	67,	68,	69,	70,	71,	72,
	73,	74,	75,	76,	77,	78,	79,	79,
	80,	81,	82,	83,	84,	85,	86,	87,
	88,	89,	90,	91,	92,	93,	94,	95,
	96,	97,	98,	99,	100,	101,	102,	103,
	104,	105,	106,	107,	108,	109,	110,	111,
	112,	113,	114,	115,	116,	117,	118,	119,
	120,	121,	122,	123,	124,	125,	126,	127};

################################################################################

TITLE
    G.711 A- to u-law conversions (80 80)

TYPE
    8

DATA
	1,	3,	5,	7,	9,	11,	13,	15,
	16,	17,	18,	19,	20,	21,	22,	23,
	24,	25,	26,	27,	28,	29,	30,	31,
	32,	32,	33,	33,	34,	34,	35,	35,
	36,	37,	38,	39,	40,	41,	42,	43,
	44,	45,	46,	47,	48,	48,	49,	49,
	50,	51,	52,	53,	54,	55,	56,	57,
	58,	59,	60,	61,	62,	63,	64,	64,
	65,	66,	67,	68,	69,	70,	71,	72,
	73,	74,	75,	76,	77,	78,	79,	80,
	80,	81,	82,	83,	84,	85,	86,	87,
	88,	89,	90,	91,	92,	93,	94,	95,
	96,	97,	98,	99,	100,	101,	102,	103,
	104,	105,	106,	107,	108,	109,	110,	111,
	112,	113,	114,	115,	116,	117,	118,	119,
	120,	121,	122,	123,	124,	125,	126,	127};

################################################################################

TITLE
    G.721 qtab

TYPE
    16

DATA
    -124, 80, 178, 246, 300, 349, 400

################################################################################

TITLE
    G.721 _dqlntab

TYPE
    16

DATA
    -2048, 4, 135, 213, 273, 323, 373, 425,
	425, 373, 323, 273, 213, 135, 4, -2048};

################################################################################

TITLE
    G.721 _witab

TYPE
    16

DATA
    -12, 18, 41, 64, 112, 198, 355, 1122,
	1122, 355, 198, 112, 64, 41, 18, -12};

################################################################################

TITLE
    G.721 _fitab

TYPE
    16

DATA
    0, 0, 0, 0x200, 0x200, 0x200, 0x600, 0xE00,
	0xE00, 0x600, 0x200, 0x200, 0x200, 0, 0, 0};

################################################################################

TITLE
    G.723_24 _dqlntab

TYPE
    16

DATA
    {-2048, 135, 273, 373, 373, 273, 135, -2048};

################################################################################

TITLE
    G.723_24 _witab

TYPE
    16

DATA
    {-128, 960, 4384, 18624, 18624, 4384, 960, -128};

################################################################################

TITLE
    G.723_24 _fitab

TYPE
    16

DATA
    {0, 0x200, 0x400, 0xE00, 0xE00, 0x400, 0x200, 0};

################################################################################

TITLE
    G.723_40 _dqlntab

TYPE
    16

DATA
    {-2048, -66, 28, 104, 169, 224, 274, 318,
	358, 395, 429, 459, 488, 514, 539, 566,
	566, 539, 514, 488, 459, 429, 395, 358,
	318, 274, 224, 169, 104, 28, -66, -2048};

################################################################################

TITLE
    G.723_40 _witab

TYPE
    16

DATA
    {448, 448, 768, 1248, 1280, 1312, 1856, 3200,
	4512, 5728, 7008, 8960, 11456, 14080, 16928, 22272,
	22272, 16928, 14080, 11456, 8960, 7008, 5728, 4512,
	3200, 1856, 1312, 1280, 1248, 768, 448, 448};

################################################################################

TITLE
    G.723_40 _fitab

TYPE
    16

DATA
    {0, 0, 0, 0, 0, 0x200, 0x200, 0x200,
	0x200, 0x200, 0x400, 0x600, 0x800, 0xA00, 0xC00, 0xC00,
	0xC00, 0xC00, 0xA00, 0x800, 0x600, 0x400, 0x200, 0x200,
	0x200, 0x200, 0x200, 0, 0, 0, 0, 0};

################################################################################

TITLE
    G.723_40 qtab_723_40

TYPE
    16

DATA
    {-122, -16, 68, 139, 198, 250, 298, 339,
	378, 413, 445, 475, 502, 528, 553};

################################################################################

TITLE
    ulaw table

TYPE
    16, 32

DATA
    -32124, -31100, -30076, -29052, -28028, -27004, -25980, -24956,
    -23932, -22908, -21884, -20860, -19836, -18812, -17788, -16764,
    -15996, -15484, -14972, -14460, -13948, -13436, -12924, -12412,
    -11900, -11388, -10876, -10364,  -9852,  -9340,  -8828,  -8316,
     -7932,  -7676,  -7420,  -7164,  -6908,  -6652,  -6396,  -6140,
     -5884,  -5628,  -5372,  -5116,  -4860,  -4604,  -4348,  -4092,
     -3900,  -3772,  -3644,  -3516,  -3388,  -3260,  -3132,  -3004,
     -2876,  -2748,  -2620,  -2492,  -2364,  -2236,  -2108,  -1980,
     -1884,  -1820,  -1756,  -1692,  -1628,  -1564,  -1500,  -1436,
     -1372,  -1308,  -1244,  -1180,  -1116,  -1052,   -988,   -924,
      -876,   -844,   -812,   -780,   -748,   -716,   -684,   -652,
      -620,   -588,   -556,   -524,   -492,   -460,   -428,   -396,
      -372,   -356,   -340,   -324,   -308,   -292,   -276,   -260,
      -244,   -228,   -212,   -196,   -180,   -164,   -148,   -132,
      -120,   -112,   -104,    -96,    -88,    -80,    -72,    -64,
       -56,    -48,    -40,    -32,    -24,    -16,     -8,      0,
     32124,  31100,  30076,  29052,  28028,  27004,  25980,  24956,
     23932,  22908,  21884,  20860,  19836,  18812,  17788,  16764,
     15996,  15484,  14972,  14460,  13948,  13436,  12924,  12412,
     11900,  11388,  10876,  10364,   9852,   9340,   8828,   8316,
      7932,   7676,   7420,   7164,   6908,   6652,   6396,   6140,
      5884,   5628,   5372,   5116,   4860,   4604,   4348,   4092,
      3900,   3772,   3644,   3516,   3388,   3260,   3132,   3004,
      2876,   2748,   2620,   2492,   2364,   2236,   2108,   1980,
      1884,   1820,   1756,   1692,   1628,   1564,   1500,   1436,
      1372,   1308,   1244,   1180,   1116,   1052,    988,    924,
       876,    844,    812,    780,    748,    716,    684,    652,
       620,    588,    556,    524,    492,    460,    428,    396,
       372,    356,    340,    324,    308,    292,    276,    260,
       244,    228,    212,    196,    180,    164,    148,    132,
       120,    112,    104,     96,     88,     80,     72,     64,
        56,     48,     40,     32,     24,     16,      8,      0 };

################################################################################

TITLE
    GSM toast ulaw u2s

TYPE
    16

DATA
	33280, 34308, 35336, 36364, 37393, 38421, 39449, 40477,
	41505, 42534, 43562, 44590, 45618, 46647, 47675, 48703,
	49474, 49988, 50503, 51017, 51531, 52045, 52559, 53073,
	53587, 54101, 54616, 55130, 55644, 56158, 56672, 57186,
	57572, 57829, 58086, 58343, 58600, 58857, 59114, 59371,
	59628, 59885, 60142, 60399, 60656, 60913, 61171, 61428,
	61620, 61749, 61877, 62006, 62134, 62263, 62392, 62520,
	62649, 62777, 62906, 63034, 63163, 63291, 63420, 63548,
	63645, 63709, 63773, 63838, 63902, 63966, 64030, 64095,
	64159, 64223, 64287, 64352, 64416, 64480, 64544, 64609,
	64657, 64689, 64721, 64753, 64785, 64818, 64850, 64882,
	64914, 64946, 64978, 65010, 65042, 65075, 65107, 65139,
	65163, 65179, 65195, 65211, 65227, 65243, 65259, 65275,
	65291, 65308, 65324, 65340, 65356, 65372, 65388, 65404,
	65416, 65424, 65432, 65440, 65448, 65456, 65464, 65472,
	65480, 65488, 65496, 65504, 65512, 65520, 65528,     0,
	32256, 31228, 30200, 29172, 28143, 27115, 26087, 25059,
	24031, 23002, 21974, 20946, 19918, 18889, 17861, 16833,
	16062, 15548, 15033, 14519, 14005, 13491, 12977, 12463,
	11949, 11435, 10920, 10406,  9892,  9378,  8864,  8350,
	 7964,  7707,  7450,  7193,  6936,  6679,  6422,  6165, 
	 5908,  5651,  5394,  5137,  4880,  4623,  4365,  4108, 
	 3916,  3787,  3659,  3530,  3402,  3273,  3144,  3016, 
	 2887,  2759,  2630,  2502,  2373,  2245,  2116,  1988, 
	 1891,  1827,  1763,  1698,  1634,  1570,  1506,  1441, 
	 1377,  1313,  1249,  1184,  1120,  1056,   992,   927, 
	  879,   847,   815,   783,   751,   718,   686,   654,
	  622,   590,   558,   526,   494,   461,   429,   397,
	  373,   357,   341,   325,   309,   293,   277,   261,
	  245,   228,   212,   196,   180,   164,   148,   132,
	  120,   112,   104,    96,    88,    80,    72,    64,
 	   56,    48,    40,    32,    24,    16,    8,      0

################################################################################

TITLE
    GSM toast ulaw s2u

TYPE
    8

DATA
0377,0376,0375,0374,0373,0372,0371,0370,0367,0366,0365,0364,0363,0362,0361,
0360,0357,0357,0356,0356,0355,0355,0354,0354,0353,0353,0352,0352,0351,0351,
0350,0350,0347,0347,0346,0346,0345,0345,0344,0344,0343,0343,0342,0342,0341,
0341,0340,0340,0337,0337,0337,0337,0336,0336,0336,0336,0335,0335,0335,0335,
0334,0334,0334,0334,0333,0333,0333,0333,0332,0332,0332,0332,0331,0331,0331,
0331,0330,0330,0330,0330,0327,0327,0327,0327,0326,0326,0326,0326,0325,0325,
0325,0325,0324,0324,0324,0324,0323,0323,0323,0323,0322,0322,0322,0322,0321,
0321,0321,0321,0320,0320,0320,0320,0317,0317,0317,0317,0317,0317,0317,0317,
0316,0316,0316,0316,0316,0316,0316,0316,0315,0315,0315,0315,0315,0315,0315,
0315,0314,0314,0314,0314,0314,0314,0314,0314,0313,0313,0313,0313,0313,0313,
0313,0313,0312,0312,0312,0312,0312,0312,0312,0312,0311,0311,0311,0311,0311,
0311,0311,0311,0310,0310,0310,0310,0310,0310,0310,0310,0307,0307,0307,0307,
0307,0307,0307,0307,0306,0306,0306,0306,0306,0306,0306,0306,0305,0305,0305,
0305,0305,0305,0305,0305,0304,0304,0304,0304,0304,0304,0304,0304,0303,0303,
0303,0303,0303,0303,0303,0303,0303,0302,0302,0302,0302,0302,0302,0302,0302,
0301,0301,0301,0301,0301,0301,0301,0301,0300,0300,0300,0300,0300,0300,0300,
0300,0277,0277,0277,0277,0277,0277,0277,0277,0277,0277,0277,0277,0277,0277,
0277,0277,0276,0276,0276,0276,0276,0276,0276,0276,0276,0276,0276,0276,0276,
0276,0276,0276,0275,0275,0275,0275,0275,0275,0275,0275,0275,0275,0275,0275,
0275,0275,0275,0275,0274,0274,0274,0274,0274,0274,0274,0274,0274,0274,0274,
0274,0274,0274,0274,0274,0273,0273,0273,0273,0273,0273,0273,0273,0273,0273,
0273,0273,0273,0273,0273,0273,0272,0272,0272,0272,0272,0272,0272,0272,0272,
0272,0272,0272,0272,0272,0272,0272,0271,0271,0271,0271,0271,0271,0271,0271,
0271,0271,0271,0271,0271,0271,0271,0271,0270,0270,0270,0270,0270,0270,0270,
0270,0270,0270,0270,0270,0270,0270,0270,0270,0267,0267,0267,0267,0267,0267,
0267,0267,0267,0267,0267,0267,0267,0267,0267,0267,0266,0266,0266,0266,0266,
0266,0266,0266,0266,0266,0266,0266,0266,0266,0266,0266,0265,0265,0265,0265,
0265,0265,0265,0265,0265,0265,0265,0265,0265,0265,0265,0265,0264,0264,0264,
0264,0264,0264,0264,0264,0264,0264,0264,0264,0264,0264,0264,0264,0263,0263,
0263,0263,0263,0263,0263,0263,0263,0263,0263,0263,0263,0263,0263,0263,0262,
0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,0262,
0262,0261,0261,0261,0261,0261,0261,0261,0261,0261,0261,0261,0261,0261,0261,
0261,0261,0260,0260,0260,0260,0260,0260,0260,0260,0260,0260,0260,0260,0260,
0260,0260,0260,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,
0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,0257,
0257,0257,0257,0257,0257,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,
0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,0256,
0256,0256,0256,0256,0256,0256,0256,0255,0255,0255,0255,0255,0255,0255,0255,
0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,0255,
0255,0255,0255,0255,0255,0255,0255,0255,0255,0254,0254,0254,0254,0254,0254,
0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,
0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0254,0253,0253,0253,0253,
0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,
0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0253,0252,0252,
0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,
0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,0252,
0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,
0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,0251,
0251,0251,0251,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,
0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,0250,
0250,0250,0250,0250,0250,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,
0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,0247,
0247,0247,0247,0247,0247,0247,0247,0246,0246,0246,0246,0246,0246,0246,0246,
0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,0246,
0246,0246,0246,0246,0246,0246,0246,0246,0246,0245,0245,0245,0245,0245,0245,
0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,
0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0245,0244,0244,0244,0244,
0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,
0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0244,0243,0243,
0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,
0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,0243,
0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,
0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,0242,
0242,0242,0242,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,
0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,0241,
0241,0241,0241,0241,0241,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,
0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,0240,
0240,0240,0240,0240,0240,0240,0240,0237,0237,0237,0237,0237,0237,0237,0237,
0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,
0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,
0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,
0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0237,0236,0236,0236,0236,
0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,
0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,
0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,
0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,0236,
0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,
0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,
0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,
0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,0235,
0235,0235,0235,0235,0235,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,
0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,
0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,
0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,0234,
0234,0234,0234,0234,0234,0234,0234,0234,0234,0233,0233,0233,0233,0233,0233,
0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,
0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,
0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,
0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0233,0232,0232,
0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,
0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,
0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,
0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,0232,
0232,0232,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,
0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,
0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,
0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,0231,
0231,0231,0231,0231,0231,0231,0231,0230,0230,0230,0230,0230,0230,0230,0230,
0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,
0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,
0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,
0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0230,0227,0227,0227,0227,
0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,
0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,
0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,
0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,0227,
0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,
0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,
0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,
0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,0226,
0226,0226,0226,0226,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,
0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,
0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,
0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,0225,
0225,0225,0225,0225,0225,0225,0225,0225,0225,0224,0224,0224,0224,0224,0224,
0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,
0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,
0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,
0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0224,0223,0223,
0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,
0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,
0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,
0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,0223,
0223,0223,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,
0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,
0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,
0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,0222,
0222,0222,0222,0222,0222,0222,0221,0221,0221,0221,0221,0221,0221,0221,0221,
0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,
0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,
0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,
0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0221,0220,0220,0220,0220,
0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,
0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,
0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,
0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,0220,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,0217,
0217,0217,0217,0217,0217,0217,0217,0217,0217,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,0216,
0216,0216,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,
0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0215,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,0214,
0214,0214,0214,0214,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,
0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0213,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,0212,
0212,0212,0212,0212,0212,0212,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,0211,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,0210,
0210,0210,0210,0210,0210,0210,0210,0210,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,0207,
0207,0207,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,
0206,0206,0206,0206,0206,0206,0206,0206,0206,0206,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,0205,
0205,0205,0205,0205,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,
0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0204,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,0203,
0203,0203,0203,0203,0203,0203,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,
0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0202,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,0201,
0201,0201,0201,0201,0201,0201,0201,0201,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,0200,
0200,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,
0000,0000,0000,0000,0000,0000,0000,0000,0000,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,0001,
0001,0001,0001,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,
0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0002,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,0003,
0003,0003,0003,0003,0003,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,
0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0004,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,0005,
0005,0005,0005,0005,0005,0005,0005,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,0006,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,0007,
0007,0007,0007,0007,0007,0007,0007,0007,0007,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,0010,
0010,0010,0010,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,
0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0011,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,0012,
0012,0012,0012,0012,0012,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,
0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0013,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,0014,
0014,0014,0014,0014,0014,0014,0014,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,0015,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,0016,
0016,0016,0016,0016,0016,0016,0016,0016,0016,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,0017,
0017,0017,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,
0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,
0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,
0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,0020,
0020,0020,0020,0020,0020,0020,0021,0021,0021,0021,0021,0021,0021,0021,0021,
0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,
0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,
0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,
0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0021,0022,0022,0022,0022,
0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,
0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,
0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,
0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,0022,
0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,
0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,
0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,
0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,0023,
0023,0023,0023,0023,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,
0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,
0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,
0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,0024,
0024,0024,0024,0024,0024,0024,0024,0024,0024,0025,0025,0025,0025,0025,0025,
0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,
0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,
0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,
0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0025,0026,0026,
0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,
0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,
0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,
0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,0026,
0026,0026,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,
0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,
0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,
0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,0027,
0027,0027,0027,0027,0027,0027,0030,0030,0030,0030,0030,0030,0030,0030,0030,
0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,
0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,
0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,
0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0030,0031,0031,0031,0031,
0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,
0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,
0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,
0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,0031,
0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,
0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,
0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,
0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,0032,
0032,0032,0032,0032,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,
0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,
0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,
0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,0033,
0033,0033,0033,0033,0033,0033,0033,0033,0034,0034,0034,0034,0034,0034,0034,
0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,
0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,
0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,
0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0034,0035,0035,
0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,
0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,
0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,
0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,0035,
0035,0035,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,
0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,
0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,
0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,0036,
0036,0036,0036,0036,0036,0036,0037,0037,0037,0037,0037,0037,0037,0037,0037,
0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,
0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,
0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,
0037,0037,0037,0037,0037,0037,0037,0037,0037,0037,0040,0040,0040,0040,0040,
0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,
0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0040,0041,0041,
0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,
0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,0041,
0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,
0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,0042,
0042,0042,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,
0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,0043,
0043,0043,0043,0043,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,
0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,0044,
0044,0044,0044,0044,0044,0044,0045,0045,0045,0045,0045,0045,0045,0045,0045,
0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,0045,
0045,0045,0045,0045,0045,0045,0045,0045,0046,0046,0046,0046,0046,0046,0046,
0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,
0046,0046,0046,0046,0046,0046,0046,0046,0046,0046,0047,0047,0047,0047,0047,
0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,
0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0047,0050,0050,
0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,
0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,0050,
0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,
0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,0051,
0051,0051,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,
0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,0052,
0052,0052,0052,0052,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,
0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,0053,
0053,0053,0053,0053,0053,0053,0054,0054,0054,0054,0054,0054,0054,0054,0054,
0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,0054,
0054,0054,0054,0054,0054,0054,0054,0054,0055,0055,0055,0055,0055,0055,0055,
0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,
0055,0055,0055,0055,0055,0055,0055,0055,0055,0055,0056,0056,0056,0056,0056,
0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,
0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0056,0057,0057,0057,
0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,
0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,0057,
0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,0060,
0060,0061,0061,0061,0061,0061,0061,0061,0061,0061,0061,0061,0061,0061,0061,
0061,0061,0062,0062,0062,0062,0062,0062,0062,0062,0062,0062,0062,0062,0062,
0062,0062,0062,0063,0063,0063,0063,0063,0063,0063,0063,0063,0063,0063,0063,
0063,0063,0063,0063,0064,0064,0064,0064,0064,0064,0064,0064,0064,0064,0064,
0064,0064,0064,0064,0064,0065,0065,0065,0065,0065,0065,0065,0065,0065,0065,
0065,0065,0065,0065,0065,0065,0066,0066,0066,0066,0066,0066,0066,0066,0066,
0066,0066,0066,0066,0066,0066,0066,0067,0067,0067,0067,0067,0067,0067,0067,
0067,0067,0067,0067,0067,0067,0067,0067,0070,0070,0070,0070,0070,0070,0070,
0070,0070,0070,0070,0070,0070,0070,0070,0070,0071,0071,0071,0071,0071,0071,
0071,0071,0071,0071,0071,0071,0071,0071,0071,0071,0072,0072,0072,0072,0072,
0072,0072,0072,0072,0072,0072,0072,0072,0072,0072,0072,0073,0073,0073,0073,
0073,0073,0073,0073,0073,0073,0073,0073,0073,0073,0073,0073,0074,0074,0074,
0074,0074,0074,0074,0074,0074,0074,0074,0074,0074,0074,0074,0074,0075,0075,
0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,0075,
0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,0076,
0076,0077,0077,0077,0077,0077,0077,0077,0077,0077,0077,0077,0077,0077,0077,
0077,0077,0100,0100,0100,0100,0100,0100,0100,0100,0101,0101,0101,0101,0101,
0101,0101,0101,0102,0102,0102,0102,0102,0102,0102,0102,0103,0103,0103,0103,
0103,0103,0103,0103,0104,0104,0104,0104,0104,0104,0104,0104,0105,0105,0105,
0105,0105,0105,0105,0105,0106,0106,0106,0106,0106,0106,0106,0106,0107,0107,
0107,0107,0107,0107,0107,0107,0110,0110,0110,0110,0110,0110,0110,0110,0111,
0111,0111,0111,0111,0111,0111,0111,0112,0112,0112,0112,0112,0112,0112,0112,
0113,0113,0113,0113,0113,0113,0113,0113,0114,0114,0114,0114,0114,0114,0114,
0114,0115,0115,0115,0115,0115,0115,0115,0115,0116,0116,0116,0116,0116,0116,
0116,0116,0117,0117,0117,0117,0117,0117,0117,0117,0120,0120,0120,0120,0121,
0121,0121,0121,0122,0122,0122,0122,0123,0123,0123,0123,0124,0124,0124,0124,
0125,0125,0125,0125,0126,0126,0126,0126,0127,0127,0127,0127,0130,0130,0130,
0130,0131,0131,0131,0131,0132,0132,0132,0132,0133,0133,0133,0133,0134,0134,
0134,0134,0135,0135,0135,0135,0136,0136,0136,0136,0137,0137,0137,0137,0140,
0140,0141,0141,0142,0142,0143,0143,0144,0144,0145,0145,0146,0146,0147,0147,
0150,0150,0150,0151,0151,0152,0152,0153,0153,0154,0154,0155,0155,0156,0156,
0157,0157,0160,0161,0162,0163,0164,0165,0166,0167,0170,0171,0172,0173,0174,
0175,0176

################################################################################

TITLE
    GSM toast alaw a2s

TYPE
    16

DATA
 	 5120,60160,  320,65200,20480,44032, 1280,64192,
	 2560,62848,   64,65456,10240,54784,  640,64864,
	 7168,58112,  448,65072,28672,35840, 1792,63680,
	 3584,61824,  192,65328,14336,50688,  896,64608,
	 4096,61184,  256,65264,16384,48128, 1024,64448,
	 2048,63360,    0,65520, 8192,56832,  512,64992,
	 6144,59136,  384,65136,24576,39936, 1536,63936,
	 3072,62336,  128,65392,12288,52736,  768,64736,
	 5632,59648,  352,65168,22528,41984, 1408,64064,
	 2816,62592,   96,65424,11264,53760,  704,64800,
	 7680,57600,  480,65040,30720,33792, 1920,63552,
	 3840,61568,  224,65296,15360,49664,  960,64544,
	 4608,60672,  288,65232,18432,46080, 1152,64320,
	 2304,63104,   32,65488, 9216,55808,  576,64928,
	 6656,58624,  416,65104,26624,37888, 1664,63808,
	 3328,62080,  160,65360,13312,51712,  832,64672,
	 5376,59904,  336,65184,21504,43008, 1344,64128,
	 2688,62720,   80,65440,10752,54272,  672,64832,
	 7424,57856,  464,65056,29696,34816, 1856,63616,
	 3712,61696,  208,65312,14848,50176,  928,64576,
	 4352,60928,  272,65248,17408,47104, 1088,64384,
	 2176,63232,   16,65504, 8704,56320,  544,64960,
	 6400,58880,  400,65120,25600,38912, 1600,63872,
	 3200,62208,  144,65376,12800,52224,  800,64704,
	 5888,59392,  368,65152,23552,40960, 1472,64000,
	 2944,62464,  112,65408,11776,53248,  736,64768,
	 7936,57344,  496,65024,31744,32768, 1984,63488,
	 3968,61440,  240,65280,15872,49152,  992,64512,
	 4864,60416,  304,65216,19456,45056, 1216,64256,
	 2432,62976,   48,65472, 9728,55296,  608,64896,
	 6912,58368,  432,65088,27648,36864, 1728,63744,
	 3456,61952,  176,65344,13824,51200,  864,64640

################################################################################

TITLE
    GSM toast alaw s2a

TYPE
    8

DATA
	170, 42,234,106,138, 10,202, 74,186, 58,250,122,154, 26,218, 90,
	162, 34,226, 98,130,  2,194, 66,178, 50,242,114,146, 18,210, 82,
	174, 46, 46,238,238,110,110,142,142, 14, 14,206,206, 78, 78,190,
	190, 62, 62,254,254,126,126,158,158, 30, 30,222,222, 94, 94,166,
	166, 38, 38, 38, 38,230,230,230,230,102,102,102,102,134,134,134,
	134,  6,  6,  6,  6,198,198,198,198, 70, 70, 70, 70,182,182,182,
	182, 54, 54, 54, 54,246,246,246,246,118,118,118,118,150,150,150,
	150, 22, 22, 22, 22,214,214,214,214, 86, 86, 86, 86,168,168,168,
	168, 40, 40, 40, 40, 40, 40, 40, 40,232,232,232,232,232,232,232,
	232,104,104,104,104,104,104,104,104,136,136,136,136,136,136,136,
	136,  8,  8,  8,  8,  8,  8,  8,  8,200,200,200,200,200,200,200,
	200, 72, 72, 72, 72, 72, 72, 72, 72,184,184,184,184,184,184,184,
	184, 56, 56, 56, 56, 56, 56, 56, 56,248,248,248,248,248,248,248,
	248,120,120,120,120,120,120,120,120,152,152,152,152,152,152,152,
	152, 24, 24, 24, 24, 24, 24, 24, 24,216,216,216,216,216,216,216,
	216, 88, 88, 88, 88, 88, 88, 88, 88,160,160,160,160,160,160,160,
	160, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
	 32,224,224,224,224,224,224,224,224,224,224,224,224,224,224,224,
	224, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
	 96,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,
	128,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	  0,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,
	192, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
	 64,176,176,176,176,176,176,176,176,176,176,176,176,176,176,176,
	176, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
	 48,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,
	240,112,112,112,112,112,112,112,112,112,112,112,112,112,112,112,
	112,144,144,144,144,144,144,144,144,144,144,144,144,144,144,144,
	144, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
	 16,208,208,208,208,208,208,208,208,208,208,208,208,208,208,208,
	208, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80,
	 80,172,172,172,172,172,172,172,172,172,172,172,172,172,172,172,
	172, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44,
	 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44,
	 44,236,236,236,236,236,236,236,236,236,236,236,236,236,236,236,
	236,236,236,236,236,236,236,236,236,236,236,236,236,236,236,236,
	236,108,108,108,108,108,108,108,108,108,108,108,108,108,108,108,
	108,108,108,108,108,108,108,108,108,108,108,108,108,108,108,108,
	108,140,140,140,140,140,140,140,140,140,140,140,140,140,140,140,
	140,140,140,140,140,140,140,140,140,140,140,140,140,140,140,140,
	140, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
	 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
	 12,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
	204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
	204, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
	 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
	 76,188,188,188,188,188,188,188,188,188,188,188,188,188,188,188,
	188,188,188,188,188,188,188,188,188,188,188,188,188,188,188,188,
	188, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
	 60,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,
	252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,
	252,124,124,124,124,124,124,124,124,124,124,124,124,124,124,124,
	124,124,124,124,124,124,124,124,124,124,124,124,124,124,124,124,
	124,156,156,156,156,156,156,156,156,156,156,156,156,156,156,156,
	156,156,156,156,156,156,156,156,156,156,156,156,156,156,156,156,
	156, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
	 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,
	 28,220,220,220,220,220,220,220,220,220,220,220,220,220,220,220,
	220,220,220,220,220,220,220,220,220,220,220,220,220,220,220,220,
	220, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
	 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
	 92,164,164,164,164,164,164,164,164,164,164,164,164,164,164,164,
	164,164,164,164,164,164,164,164,164,164,164,164,164,164,164,164,
	164, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
	 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
	 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
	 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
	 36,228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,
	228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,
	228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,
	228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,228,
	228,100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,
	100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,
	100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,
	100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,100,
	100,132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,
	132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,
	132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,
	132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,132,
	132,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	  4,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,
	196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,
	196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,
	196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,
	196, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
	 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
	 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
	 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
	 68,180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,
	180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,
	180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,
	180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,180,
	180, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
	 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
	 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
	 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
	 52,244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,
	244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,
	244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,
	244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,244,
	244,116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,
	116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,
	116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,
	116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,116,
	116,148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,
	148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,
	148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,
	148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,148,
	148, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
	 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
	 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
	 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
	 20,212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,
	212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,
	212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,
	212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,212,
	212, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84,
	 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84,
	 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84,
	 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84,
	 84, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85,
	 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85,
	 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85,
	 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85,
	 85,213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,
	213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,
	213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,
	213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,213,
	213, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
	 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
	 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
	 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
	 21,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
	149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
	149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
	149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
	149,117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,
	117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,
	117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,
	117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,117,
	117,245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,
	245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,
	245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,
	245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,245,
	245, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53,
	 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53,
	 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53,
	 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53,
	 53,181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,
	181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,
	181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,
	181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,181,
	181, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
	 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
	 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
	 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69,
	 69,197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,
	197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,
	197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,
	197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,197,
	197,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
	  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
	  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
	  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
	  5,133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,
	133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,
	133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,
	133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,133,
	133,101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,
	101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,
	101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,
	101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,101,
	101,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,
	229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,
	229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,
	229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,
	229, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,
	 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,
	 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,
	 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,
	 37,165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,
	165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,
	165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,
	165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,165,
	165, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
	 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
	 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
	 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
	 93,221,221,221,221,221,221,221,221,221,221,221,221,221,221,221,
	221,221,221,221,221,221,221,221,221,221,221,221,221,221,221,221,
	221, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29,
	 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29,
	 29,157,157,157,157,157,157,157,157,157,157,157,157,157,157,157,
	157,157,157,157,157,157,157,157,157,157,157,157,157,157,157,157,
	157,125,125,125,125,125,125,125,125,125,125,125,125,125,125,125,
	125,125,125,125,125,125,125,125,125,125,125,125,125,125,125,125,
	125,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,
	253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,
	253, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
	 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
	 61,189,189,189,189,189,189,189,189,189,189,189,189,189,189,189,
	189,189,189,189,189,189,189,189,189,189,189,189,189,189,189,189,
	189, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77,
	 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77,
	 77,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,
	205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,205,
	205, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	 13,141,141,141,141,141,141,141,141,141,141,141,141,141,141,141,
	141,141,141,141,141,141,141,141,141,141,141,141,141,141,141,141,
	141,109,109,109,109,109,109,109,109,109,109,109,109,109,109,109,
	109,109,109,109,109,109,109,109,109,109,109,109,109,109,109,109,
	109,237,237,237,237,237,237,237,237,237,237,237,237,237,237,237,
	237,237,237,237,237,237,237,237,237,237,237,237,237,237,237,237,
	237, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45,
	 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45,
	 45,173,173,173,173,173,173,173,173,173,173,173,173,173,173,173,
	173,173,173,173,173,173,173,173,173,173,173,173,173,173,173,173,
	173, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
	 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
	 81,209,209,209,209,209,209,209,209,209,209,209,209,209,209,209,
	209, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,
	 17,145,145,145,145,145,145,145,145,145,145,145,145,145,145,145,
	145,113,113,113,113,113,113,113,113,113,113,113,113,113,113,113,
	113,241,241,241,241,241,241,241,241,241,241,241,241,241,241,241,
	241, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,
	 49,177,177,177,177,177,177,177,177,177,177,177,177,177,177,177,
	177, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65,
	 65,193,193,193,193,193,193,193,193,193,193,193,193,193,193,193,
	193,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	  1,129,129,129,129,129,129,129,129,129,129,129,129,129,129,129,
	129, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
	 97,225,225,225,225,225,225,225,225,225,225,225,225,225,225,225,
	225, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
	 33,161,161,161,161,161,161,161,161,161,161,161,161,161,161,161,
	161, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89,
	 89,217,217,217,217,217,217,217,217, 25, 25, 25, 25, 25, 25, 25,
	 25,153,153,153,153,153,153,153,153,121,121,121,121,121,121,121,
	121,249,249,249,249,249,249,249,249, 57, 57, 57, 57, 57, 57, 57,
	 57,185,185,185,185,185,185,185,185, 73, 73, 73, 73, 73, 73, 73,
	 73,201,201,201,201,201,201,201,201,  9,  9,  9,  9,  9,  9,  9,
	  9,137,137,137,137,137,137,137,137,105,105,105,105,105,105,105,
	105,233,233,233,233,233,233,233,233, 41, 41, 41, 41, 41, 41, 41,
	 41,169,169,169,169,169,169,169,169, 87, 87, 87, 87, 87, 87, 87,
	 87,215,215,215,215, 23, 23, 23, 23,151,151,151,151,119,119,119,
	119,247,247,247,247, 55, 55, 55, 55,183,183,183,183, 71, 71, 71,
	 71,199,199,199,199,  7,  7,  7,  7,135,135,135,135,103,103,103,
	103,231,231,231,231, 39, 39, 39, 39,167,167,167,167, 95, 95, 95,
	 95,223,223, 31, 31,159,159,127,127,255,255, 63, 63,191,191, 79,
	 79,207,207, 15, 15,143,143,111,111,239,239, 47, 47,175,175, 83,
	 83,211, 19,147,115,243, 51,179, 67,195,  3,131, 99,227, 35,163,
	 91,219, 27,155,123,251, 59,187, 75,203, 11,139,107,235, 43,171

################################################################################

TITLE
    GSM table gsm_A

TYPE
    16

DATA
  {20480, 20480, 20480,  20480,  13964,  15360,   8534,  9036};

################################################################################

TITLE
    GSM table gsm_B

TYPE
    16

DATA
    {    0,     0,  2048,  -2560,     94,  -1792,   -341, -1144};

################################################################################

TITLE
    GSM table gsm_MIC

TYPE
    16

DATA
    { -32,   -32,   -16,    -16,     -8,     -8,     -4,    -4 };

################################################################################

TITLE
    GSM table gsm_MAC

TYPE
    16

DATA
    {  31,    31,    15,     15,      7,      7,      3,     3 };

################################################################################

TITLE
    GSM table gsm_INVA

TYPE
    16

DATA
//  Table 4.2  Tabulation  of 1/A[1..8]
    { 13107, 13107,  13107, 13107,  19223, 17476,  31454, 29708 };

################################################################################

TITLE
    GSM table gsm_H

TYPE
    16

DATA
//   Table 4.4	 Coefficients of the weighting filter
   {-134, -374, 0, 2054, 5741, 8192, 5741, 2054, 0, -374, -134 };

################################################################################

TITLE
    GSM table gsm_NRFAC

TYPE
    16

DATA
//   Table 4.5 	 Normalized inverse mantissa used to compute xM/xmax 
    { 29128, 26215, 23832, 21846, 20165, 18725, 17476, 16384 };

################################################################################

TITLE
    GSM table gsm_FAC

TYPE
    16

DATA
    //  Table 4.6	 Normalized direct mantissa used to compute xM/xmax
  { 18431, 20479, 22527, 24575, 26623, 28671, 30719, 32767 };

################################################################################

TITLE
    HAM84 DAC tab

TYPE
    32

DATA
	16,0,0,3,0,5,14,7,0,9,14,11,
	14,13,30,14,0,9,2,7,4,7,7,23,9,
	25,10,9,12,9,14,7,0,5,2,11,5,21,
	6,5,8,11,11,27,12,5,14,11,2,1,18,
	2,12,5,2,7,12,9,2,11,28,12,12,15,
	0,3,3,19,4,13,6,3,8,13,10,3,13,29,
	14,13,4,1,10,3,20,4,4,7,10,9,26,
	10,4,13,10,15,8,1,6,3,6,5,22,6,24,
	8,8,11,8,13,6,15,1,17,2,1,4,1,6,
	15,8,1,10,15,12,15,15,31

################################################################################

TITLE
    lpc decode detau table

TYPE
    32

DATA
 0,0,0,3,0,3,3,31, 0,3,3,21,3,3,29,30,
           0,3,3,20,3,25,27,26, 3,23,58,22,3,24,28,3,
    	0,3,3,3,3,39,33,32, 3,37,35,36,3,38,34,3,
           3,42,46,44,50,40,48,3, 54,3,56,3,52,3,3,1,
    	0,3,3,108,3,78,100,104, 3,84,92,88,156,80,96,3,
    	3,74,70,72,66,76,68,3, 62,3,60,3,64,3,3,1,
    	3,116,132,112,148,152,3,3, 140,3,136,3,144,3,3,1,
           124,120,128,3,3,3,3,1, 3,3,3,1,3,1,1,1

################################################################################

TITLE
    lpc encode rmst table

TYPE
    32

DATA
    1024,936,856,784,718,656,600,550,
    502,460,420,384,352,328,294,270,
    246,226,206,188,172,158,144,132,
    120,110,102,92,84,78,70,64,
    60,54,50,46,42,38,34,32,
    30,26,24,22,20,18,17,16,
    15,14,13,12,11,10,9,8,
    7,6,5,4,3,2,1,0};

################################################################################

TITLE
    bsynz kexc table

TYPE
    32

DATA
    8,-16,26,-48,86,-162,294,-502,718,-728,
    184,672,-610,-672,184,728,718,502,294,162,
    86,48,26,16,8

################################################################################

TITLE
    bsynz kexc table (float)

TYPE
    float

DATA
    8,-16,26,-48,86,-162,294,-502,718,-728,
    184,672,-610,-672,184,728,718,502,294,162,
    86,48,26,16,8

################################################################################

TITLE
    SA LPC-10 Voice Coder TAU

TYPE
    32

DATA
    20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,
	35,36,37,38,39,40,42,44,46,48,50,52,54,56,58,60,62,64,66,
	68,70,72,74,76,78,80,84,88,92,96,100,104,108,112,116,120,
	124,128,132,136,140,144,148,152,156

################################################################################

TITLE
    31 Point Equiripple FIR Low-Pass Filter

TYPE
    FLOAT

DATA
    -0.0097201988;
    -0.0105179986;
    -0.0083479648;
    0.0005860774;
    0.0130892089;
    0.0217052232;
    0.0184161253;
    0.0003397230;
    -0.0260797087;
    -0.0455563702;
    -0.0403068550;
    0.0005029835;
    0.0729262903;
    0.1572008878;
    0.2247288674;
    0.2505359650;

################################################################################

TITLE
    len_table (from h264)

TYPE
    32

DATA
    1,
    1,
    2,2,
    3,3,3,3,
    4,4,4,4,4,4,4,4,
    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
    6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
    6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
    7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
    8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

################################################################################

TITLE
    BGMC Cumulative frequency table 0

TYPE
    16

DATA
    16384, 16066, 15748, 15431, 15114, 14799, 14485, 14173, 13861, 13552, 13243, 12939, 12635, 12336, 12038, 11745, 11452, 11161, 10870, 10586, 10303, 10027, 9751, 9483, 9215, 8953, 8692, 8440, 8189, 7946, 7704, 7472, 7240, 7008, 6776, 6554, 6333, 6122, 5912, 5711, 5512, 5320, 5128, 4947, 4766, 4595, 4425, 4264, 4104, 3946, 3788, 3640, 3493, 3355, 3218, 3090, 2963, 2842, 2721,
    2609, 2498, 2395, 2292, 2196, 2100, 2004, 1908, 1820, 1732, 1651, 1570, 1497, 1424, 1355, 1287, 1223, 1161, 1100, 1044, 988, 938, 888, 839, 790, 746, 702, 662, 623, 588, 553, 520, 488, 459, 431, 405, 380, 357, 334, 311, 288, 268, 248, 230, 213, 197, 182, 168, 154, 142, 130, 119, 108,  99, 90, 81, 72, 64, 56, 49, 42, 36, 30, 25, 20, 15, 11, 7, 3, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 1

TYPE
    16

DATA
    16384, 16080, 15776, 15473, 15170, 14868, 14567, 14268, 13970, 13674, 13378, 13086, 12794, 12505, 12218, 11936, 11654, 11373, 11092, 10818, 10544, 10276, 10008, 9749, 9490, 9236, 8982, 8737, 8492, 8256, 8020, 7792, 7564, 7336, 7108, 6888, 6669, 6459, 6249, 6050, 5852, 5660, 5468, 5286, 5104, 4931, 4760, 4598, 4436, 4275, 4115, 3965, 3816, 3674, 3534, 3403, 3272, 3147, 3023,
    2907, 2792, 2684, 2577, 2476, 2375, 2274, 2173, 2079, 1986, 1897, 1810, 1724, 1645, 1567, 1493, 1419, 1351, 1284, 1222, 1161, 1105, 1050, 995, 941, 891, 842, 797, 753, 713, 673, 636, 599, 566, 533, 503, 473, 446, 419, 392, 365, 340, 316, 294, 272, 253, 234, 216, 199, 184, 169, 155, 142, 130, 118, 106, 95, 85, 75, 66, 57, 49, 41, 34, 27, 21, 15, 10, 5, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 2

TYPE
    16

DATA
    16384, 16092, 15801, 15510, 15219, 14930, 14641, 14355, 14069, 13785, 13501, 13219, 12938, 12661, 12384, 12112, 11841, 11571, 11301, 11037, 10773, 10514, 10256, 10005, 9754, 9508, 9263, 9025, 8787, 8557, 8327, 8103, 7879, 7655, 7431, 7215, 7000, 6792, 6585, 6387, 6190, 5998, 5807, 5625, 5445, 5272, 5100, 4937, 4774, 4613, 4452, 4301, 4150, 4007, 3865, 3731, 3597, 3469, 3341,
    3218, 3099, 2981, 2869, 2758, 2652, 2546, 2440, 2334, 2234, 2134, 2041, 1949, 1864, 1779, 1699, 1620, 1547, 1474, 1407, 1340, 1278, 1217, 1157, 1097, 1043, 989, 940, 891, 846, 801, 759, 718, 680, 643, 609, 575, 543, 511, 479, 447, 418, 389, 363, 337, 314, 291, 270, 249, 230, 212, 195, 179, 164, 149, 135, 121, 108, 96, 85, 74, 64, 54, 45, 36, 28, 20, 13, 6, 0 }

################################################################################

TITLE
    BGMC Cumulative frequency table 3

TYPE
    16

DATA
    16384, 16104, 15825, 15546, 15268, 14991, 14714, 14439, 14164, 13891, 13620, 13350, 13081, 12815, 12549, 12287, 12025, 11765, 11505, 11250, 10996, 10746, 10497, 10254, 10011, 9772, 9534, 9303, 9072, 8848, 8624, 8406, 8188, 7970, 7752, 7539, 7327, 7123, 6919, 6724, 6529, 6339, 6150, 5970, 5790, 5618, 5446, 5282, 5119, 4957, 4795, 4642, 4490, 4345, 4201, 4065, 3929, 3798, 3669,
    3547, 3425, 3310, 3196, 3086, 2976, 2866, 2756, 2650, 2545, 2447, 2350, 2260, 2170, 2085, 2000, 1921, 1843, 1770, 1698, 1632, 1566, 1501, 1436, 1376, 1316, 1261, 1207, 1157, 1108, 1061, 1015, 973, 931, 893, 855, 819, 783, 747, 711, 677, 644, 614, 584, 557, 530, 505, 480, 458, 436, 416, 396, 378, 360, 343, 326, 310, 295, 281, 267, 255, 243, 232, 221, 211, 201, 192, 183, 174,
    166, 158, 150, 142, 134, 126, 119, 112, 106, 100, 95, 90, 85, 80, 76, 72, 69, 66, 63, 60, 57, 54, 51, 48, 46, 44, 42, 40, 38, 36, 34, 33, 32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 4

TYPE
    16

DATA
    16384, 16116, 15849, 15582, 15316, 15050, 14785, 14521, 14257, 13995, 13734, 13476, 13218, 12963, 12708, 12457, 12206, 11956, 11706, 11460, 11215, 10975, 10735, 10500, 10265, 10034, 9803, 9579, 9355, 9136, 8917, 8703, 8489, 8275, 8061, 7853, 7645, 7444, 7244, 7051, 6858, 6671, 6484, 6305, 6127, 5956, 5785, 5622, 5459, 5298, 5137, 4983, 4830, 4684, 4539, 4401, 4263, 4131, 3999,
    3874, 3750, 3632, 3515, 3401, 3287, 3173, 3059, 2949, 2840, 2737, 2635, 2539, 2444, 2354, 2264, 2181, 2098, 2020, 1943, 1872, 1801, 1731, 1661, 1596, 1532, 1472, 1412, 1357, 1303, 1251, 1200, 1153, 1106, 1063, 1020, 979, 938, 897, 856, 818, 780, 746, 712, 681, 650, 621, 592, 566, 540, 517, 494, 473, 452, 431, 410, 391, 373, 356, 340, 325, 310, 296, 282, 270, 258, 247, 236,
    225, 214, 203, 192, 182, 172, 162, 153, 144, 136, 128, 121, 114, 108, 102, 97, 92, 87, 82, 77, 73, 69, 65, 62, 59, 56, 53, 50, 47, 45, 43, 41, 39, 37, 35, 33, 31, 29, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 5

TYPE
    16

DATA
    16384, 16128, 15872, 15617, 15362, 15107, 14853, 14600, 14347, 14096, 13846, 13597, 13350, 13105, 12860, 12618, 12376, 12135, 11894, 11657, 11421, 11189, 10957, 10730, 10503, 10279, 10056, 9838, 9620, 9407, 9195, 8987, 8779, 8571, 8363, 8159, 7955, 7758, 7561, 7371, 7182, 6997, 6812, 6635, 6459, 6289, 6120, 5957, 5795, 5634, 5473, 5319, 5165, 5018, 4871, 4732, 4593, 4458,
    4324, 4197, 4071, 3951, 3831, 3714, 3597, 3480, 3363, 3250, 3138, 3032, 2927, 2828, 2729, 2635, 2541, 2453, 2366, 2284, 2202, 2126, 2050, 1975, 1900, 1830, 1761, 1697, 1633, 1574, 1515, 1459, 1403, 1351, 1300, 1252, 1205, 1160, 1115, 1070, 1025, 982, 939, 899, 860, 824, 789, 756, 723, 693, 663, 636, 609, 584, 559, 535, 511, 489, 467, 447, 427, 409, 391, 374, 358, 343, 328,
    313, 300, 287, 274, 261, 248, 235, 223, 211, 200, 189, 179, 169, 160, 151, 143, 135, 128, 121, 115, 109, 103, 97, 92, 87, 82, 77, 73, 69, 65, 61, 58, 55, 52, 49, 46, 43, 40, 37, 35, 33, 31, 29, 27, 25, 23, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 6

TYPE
    16

DATA
    16384, 16139, 15894, 15649, 15405, 15162, 14919, 14677, 14435, 14195, 13955, 13717, 13479, 13243, 13008, 12775, 12542, 12310, 12079, 11851, 11623, 11399, 11176, 10956, 10737, 10521, 10305, 10094, 9883, 9677, 9471, 9268, 9065, 8862, 8659, 8459, 8260, 8067, 7874, 7688, 7502, 7321, 7140, 6965, 6790, 6621, 6452, 6290, 6128, 5968, 5808, 5655, 5503, 5356, 5209, 5069, 4929, 4794,
    4660, 4532, 4404, 4282, 4160, 4041, 3922, 3803, 3684, 3568, 3452, 3343, 3234, 3131, 3029, 2931, 2833, 2741, 2649, 2563, 2477, 2396, 2316, 2236, 2157, 2083, 2009, 1940, 1871, 1807, 1743, 1683, 1623, 1567, 1511, 1459, 1407, 1357, 1307, 1257, 1207, 1159, 1111, 1067, 1023, 983, 943, 905, 868, 834, 800, 769, 738, 709, 681, 653, 625, 600, 575, 552, 529, 508, 487, 466, 447, 428, 410,
    392, 376, 360, 344, 328, 313, 298, 283, 268, 255, 242, 230, 218, 207, 196, 186, 176, 167, 158, 150, 142, 135, 128, 121, 114, 108, 102, 97, 92, 87, 82, 78, 74, 70, 66, 62, 58, 54, 50, 47, 44, 41, 38, 35, 32, 30, 28, 26, 24, 22, 20, 18, 16, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 7

TYPE
    16

DATA
    16384, 16149, 15915, 15681, 15447, 15214, 14981, 14749, 14517, 14286, 14055, 13827, 13599, 13373, 13147, 12923, 12699, 12476, 12253, 12034, 11815, 11599, 11383, 11171, 10959, 10750, 10541, 10337, 10133, 9933, 9733, 9536, 9339, 9142, 8945, 8751, 8557, 8369, 8181, 7998, 7816, 7638, 7460, 7288, 7116, 6950, 6785, 6625, 6465, 6306, 6147, 5995, 5843, 5697, 5551, 5411, 5271, 5135,
    5000, 4871, 4742, 4618, 4495, 4374, 4253, 4132, 4011, 3893, 3775, 3663, 3552, 3446, 3340, 3239, 3138, 3043, 2948, 2858, 2768, 2684, 2600, 2516, 2433, 2355, 2278, 2205, 2133, 2065, 1997, 1932, 1867, 1807, 1747, 1690, 1634, 1580, 1526, 1472, 1418, 1366, 1314, 1266, 1218, 1174, 1130, 1088, 1047, 1009, 971, 936, 901, 868, 836, 804, 772, 743, 714, 685, 658, 631, 606, 582, 559, 536,
    515, 494, 475, 456, 437, 418, 399, 380, 362, 344, 328, 312, 297, 283, 270, 257, 245, 233, 222, 211, 201, 191, 181, 172, 163, 155, 147, 139, 132, 125, 119, 113, 107, 101, 96, 91, 86, 81, 76, 71, 66, 62, 58, 54, 50, 46, 43, 40, 37, 34, 31, 28, 26, 24, 22, 20, 18, 16, 14, 12, 10, 8, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 8

TYPE
    16

DATA
    16384, 16159, 15934, 15709, 15485, 15261, 15038, 14816, 14594, 14373, 14152, 13933, 13714, 13497, 13280, 13065, 12850, 12636, 12422, 12211, 12000, 11791, 11583, 11378, 11173, 10971, 10769, 10571, 10373, 10179, 9985, 9793, 9601, 9409, 9217, 9029, 8842, 8658, 8475, 8297, 8120, 7946, 7773, 7604, 7435, 7271, 7108, 6950, 6792, 6634, 6477, 6326, 6175, 6029, 5883, 5742, 5602, 5466,
    5330, 5199, 5068, 4943, 4818, 4696, 4574, 4452, 4330, 4211, 4093, 3979, 3866, 3759, 3652, 3549, 3446, 3348, 3250, 3157, 3065, 2977, 2889, 2802, 2716, 2634, 2553, 2476, 2399, 2326, 2254, 2185, 2117, 2052, 1987, 1926, 1866, 1808, 1750, 1692, 1634, 1578, 1522, 1470, 1418, 1369, 1321, 1275, 1229, 1187, 1145, 1105, 1066, 1027, 991, 955, 919, 883, 850, 817, 786, 756, 728, 700, 674,
    648, 624, 600, 578, 556, 534, 512, 490, 468, 447, 426, 407, 388, 371, 354, 338, 322, 307, 293, 280, 267, 255, 243, 231, 219, 209, 199, 189, 179, 170, 161, 153, 145, 138, 131, 124, 117, 111, 105, 99, 93, 87, 81, 76, 71, 66, 61, 57, 53, 49, 45, 42, 39, 36, 33, 30, 27, 24, 21, 19, 17, 15, 13, 11, 9, 7, 5, 3, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 9

TYPE
    16

DATA
    16384, 16169, 15954, 15739, 15524, 15310, 15096, 14883, 14670, 14458, 14246, 14035, 13824, 13614, 13405, 13198, 12991, 12785, 12579, 12376, 12173, 11972, 11772, 11574, 11377, 11182, 10987, 10795, 10603, 10414, 10226, 10040, 9854, 9668, 9482, 9299, 9116, 8937, 8759, 8585, 8411, 8241, 8071, 7906, 7741, 7580, 7419, 7263, 7107, 6952, 6797, 6647, 6497, 6353, 6209, 6070, 5931, 5796,
    5661, 5531, 5401, 5275, 5150, 5027, 4904, 4781, 4658, 4538, 4419, 4304, 4190, 4081, 3972, 3867, 3762, 3662, 3562, 3467, 3372, 3281, 3191, 3101, 3012, 2928, 2844, 2764, 2684, 2608, 2533, 2460, 2387, 2318, 2250, 2185, 2121, 2059, 1997, 1935, 1873, 1813, 1754, 1698, 1642, 1588, 1535, 1483, 1433, 1384, 1338, 1292, 1249, 1206, 1165, 1125, 1085, 1045, 1008, 971, 937, 903, 871, 840,
    810, 780, 752, 724, 698, 672, 647, 622, 597, 572, 548, 524, 502, 480, 460, 440, 421, 403, 386, 369, 353, 337, 323, 309, 295, 281, 268, 255, 243, 231, 220, 209, 199, 189, 180, 171, 163, 155, 147, 139, 131, 123, 116, 109, 102, 95, 89, 83, 77, 72, 67, 62, 57, 52, 48, 44, 40, 36, 32, 28, 25, 22, 19, 16, 13, 10, 8, 6, 4, 2, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 10

TYPE
    16

DATA
    16384, 16177, 15970, 15764, 15558, 15353, 15148, 14944, 14740, 14537, 14334, 14132, 13930, 13729, 13529, 13330, 13131, 12933, 12735, 12539, 12343, 12150, 11957, 11766, 11576, 11388, 11200, 11015, 10830, 10647, 10465, 10285, 10105, 9925, 9745, 9568, 9391, 9218, 9045, 8876, 8707, 8541, 8375, 8213, 8051, 7894, 7737, 7583, 7429, 7277, 7125, 6977, 6830, 6687, 6544, 6406, 6268,
    6133, 5998, 5868, 5738, 5612, 5487, 5364, 5241, 5118, 4995, 4875, 4755, 4640, 4525, 4414, 4304, 4198, 4092, 3990, 3888, 3790, 3693, 3600, 3507, 3415, 3323, 3235, 3147, 3064, 2981, 2902, 2823, 2746, 2670, 2594, 2522, 2450, 2382, 2314, 2248, 2182, 2116, 2050, 1987, 1924, 1864, 1804, 1748, 1692, 1638, 1585, 1534, 1484, 1437, 1390, 1346, 1302, 1258, 1215, 1174, 1133, 1095, 1057,
    1021, 986, 952, 918, 887, 856, 827, 798, 770, 742, 714, 686, 659, 632, 607, 582, 559, 536, 514, 492, 472, 452, 433, 415, 398, 381, 364, 348, 333, 318, 304, 290, 277, 264, 252, 240, 229, 218, 208, 198, 188, 178, 168, 158, 149, 140, 132, 124, 116, 108, 101, 94, 87, 81, 75, 69, 64, 59, 54, 49, 44, 39, 35, 31, 27, 23, 19, 15, 12, 9, 6, 3, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 11

TYPE
    16

DATA
    16384, 16187, 15990, 15793, 15597, 15401, 15205, 15009, 14813, 14618, 14423, 14230, 14037, 13845, 13653, 13463, 13273, 13083, 12894, 12706, 12518, 12332, 12146, 11962, 11778, 11597, 11416, 11237, 11059, 10882, 10706, 10532, 10358, 10184, 10010, 9838, 9666, 9497, 9328, 9163, 8999, 8837, 8675, 8517, 8359, 8205, 8051, 7901, 7751, 7602, 7453, 7308, 7163, 7022, 6882, 6745, 6609,
    6476, 6343, 6214, 6085, 5960, 5835, 5712, 5589, 5466, 5343, 5223, 5103, 4987, 4872, 4761, 4650, 4542, 4435, 4332, 4229, 4130, 4031, 3936, 3841, 3747, 3653, 3563, 3473, 3387, 3302, 3220, 3138, 3059, 2980, 2905, 2830, 2759, 2688, 2619, 2550, 2481, 2412, 2345, 2278, 2215, 2152, 2092, 2032, 1974, 1917, 1863, 1809, 1758, 1707, 1659, 1611, 1564, 1517, 1473, 1429, 1387, 1346, 1307,
    1268, 1230, 1193, 1158, 1123, 1090, 1058, 1026, 994, 962, 930, 899, 869, 841, 813, 786, 760, 735, 710, 687, 664, 643, 622, 602, 582, 562, 543, 525, 507, 490, 473, 457, 442, 427, 412, 398, 385, 373, 361, 349, 337, 325, 313, 301, 290, 279, 269, 259, 249, 240, 231, 222, 214, 206, 199, 192, 185, 178, 171, 165, 159, 153, 148, 143, 138, 133, 128, 123, 119, 115, 111, 107, 103, 99,
    95, 91, 87, 83, 80, 77, 74, 71, 68, 65, 63, 61, 59, 57, 55, 53, 51, 49, 47, 45, 43, 41, 40, 39, 38, 37, 36, 35, 34, 33, 32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 12

TYPE
    16

DATA
    16384, 16195, 16006, 15817, 15629, 15441, 15253, 15065, 14878, 14692, 14506, 14321, 14136, 13952, 13768, 13585, 13402, 13219, 13037, 12857, 12677, 12499, 12321, 12144, 11967, 11792, 11617, 11444, 11271, 11100, 10930, 10762, 10594, 10426, 10258, 10091, 9925, 9761, 9598, 9438, 9278, 9120, 8963, 8809, 8655, 8504, 8354, 8207, 8060, 7914, 7769, 7627, 7485, 7347, 7209, 7074, 6939,
    6807, 6676, 6548, 6420, 6296, 6172, 6050, 5928, 5806, 5684, 5564, 5444, 5328, 5212, 5100, 4988, 4879, 4771, 4667, 4563, 4462, 4362, 4265, 4169, 4073, 3978, 3886, 3795, 3707, 3619, 3535, 3451, 3369, 3288, 3210, 3133, 3059, 2985, 2913, 2841, 2769, 2697, 2627, 2557, 2490, 2424, 2360, 2297, 2237, 2177, 2119, 2062, 2007, 1953, 1901, 1849, 1798, 1748, 1700, 1652, 1607, 1562, 1519,
    1476, 1435, 1394, 1355, 1317, 1281, 1245, 1210, 1175, 1140, 1105, 1071, 1037, 1005, 973, 943, 913, 885, 857, 830, 804, 779, 754, 731, 708, 685, 663, 642, 621, 601, 581, 563, 545, 528, 511, 495, 479, 463, 448, 433, 419, 405, 391, 377, 364, 351, 338, 326, 314, 302, 291, 280, 270, 260, 251, 242, 234, 226, 218, 210, 202, 195, 188, 181, 174, 168, 162, 156, 150, 144, 139, 134, 129,
    124, 119, 114, 109, 104, 100, 96, 92, 88, 84, 80, 77, 74, 71, 68, 65, 62, 59, 56, 54, 52, 50, 48, 46, 44, 42, 40, 38, 36, 34, 33, 32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 13

TYPE
    16

DATA
    16384, 16203, 16022, 15842, 15662, 15482, 15302, 15122, 14942, 14763, 14584, 14406, 14228, 14051, 13874, 13698, 13522, 13347, 13172, 12998, 12824, 12652, 12480, 12310, 12140, 11971, 11803, 11637, 11471, 11307, 11143, 10980, 10817, 10654, 10491, 10330, 10169, 10011, 9853, 9697, 9542, 9389, 9236, 9086, 8936, 8789, 8642, 8498, 8355, 8212, 8070, 7931, 7792, 7656, 7520, 7388, 7256,
    7126, 6996, 6870, 6744, 6621, 6498, 6377, 6256, 6135, 6014, 5895, 5776, 5660, 5545, 5433, 5321, 5212, 5104, 4999, 4895, 4793, 4692, 4594, 4496, 4400, 4304, 4211, 4118, 4028, 3939, 3853, 3767, 3684, 3601, 3521, 3441, 3364, 3287, 3212, 3137, 3062, 2987, 2915, 2843, 2773, 2704, 2638, 2572, 2508, 2445, 2384, 2324, 2266, 2208, 2153, 2098, 2044, 1990, 1939, 1888, 1839, 1791, 1745,
    1699, 1655, 1611, 1569, 1527, 1487, 1448, 1409, 1370, 1331, 1292, 1255, 1218, 1183, 1148, 1115, 1082, 1051, 1020, 990, 960, 932, 904, 878, 852, 826, 801, 777, 753, 731, 709, 687, 666, 645, 625, 605, 586, 567, 550, 533, 516, 499, 482, 465, 449, 433, 418, 403, 389, 375, 362, 349, 337, 325, 314, 303, 293, 283, 273, 263, 254, 245, 236, 227, 219, 211, 204, 197, 190, 183, 177, 171,
    165, 159, 153, 147, 141, 135, 130, 125, 120, 115, 110, 105, 101, 97, 93, 89, 85, 81, 77, 74, 71, 68, 65, 62, 59, 56, 53, 51, 49, 47, 45, 43, 41, 39, 37, 35, 33, 31, 29, 27, 25, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 14 

TYPE
    16

DATA
    16384, 16210, 16036, 15863, 15690, 15517, 15344, 15172, 15000, 14828, 14656, 14485, 14314, 14145, 13976, 13808, 13640, 13472, 13304, 13137, 12970, 12804, 12639, 12475, 12312, 12149, 11987, 11827, 11667, 11508, 11349, 11192, 11035, 10878, 10721, 10565, 10410, 10257, 10104, 9953, 9802, 9654, 9506, 9359, 9213, 9070, 8927, 8787, 8647, 8508, 8369, 8233, 8097, 7964, 7831, 7700,
    7570, 7442, 7315, 7190, 7065, 6943, 6821, 6701, 6581, 6461, 6341, 6223, 6105, 5990, 5876, 5764, 5653, 5545, 5437, 5331, 5226, 5124, 5022, 4924, 4826, 4729, 4632, 4538, 4444, 4353, 4262, 4174, 4087, 4002, 3917, 3835, 3753, 3674, 3595, 3518, 3441, 3364, 3287, 3212, 3138, 3066, 2995, 2926, 2858, 2792, 2726, 2662, 2599, 2538, 2478, 2420, 2362, 2305, 2249, 2195, 2141, 2089, 2037,
    1988, 1939, 1891, 1844, 1799, 1754, 1711, 1668, 1626, 1584, 1542, 1500, 1459, 1418, 1380, 1342, 1305, 1269, 1234, 1199, 1166, 1133, 1102, 1071, 1041, 1012, 983, 954, 926, 899, 872, 847, 822, 798, 774, 751, 728, 707, 686, 666, 646, 627, 608, 589, 570, 552, 534, 517, 500, 484, 468, 453, 438, 424, 410, 397, 384, 372, 360, 348, 336, 325, 314, 303, 293, 283, 273, 264, 255, 246,
    237, 229, 221, 213, 205, 197, 189, 181, 174, 167, 160, 154, 148, 142, 136, 131, 126, 121, 116, 111, 106, 101, 97, 93, 89, 85, 81, 77, 73, 70, 67, 64, 61, 58, 55, 52, 49, 46, 43, 40, 37, 35, 33, 31, 29, 27, 25, 23, 21, 19, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    BGMC Cumulative frequency table 15

TYPE
    16

DATA
    16384, 16218, 16052, 15886, 15720, 15554, 15389, 15224, 15059, 14895, 14731, 14567, 14403, 14240, 14077, 13915, 13753, 13591, 13429, 13269, 13109, 12950, 12791, 12633, 12476, 12320, 12164, 12009, 11854, 11701, 11548, 11396, 11244, 11092, 10940, 10790, 10640, 10492, 10344, 10198, 10052, 9908, 9764, 9622, 9481, 9342, 9203, 9066, 8929, 8793, 8657, 8524, 8391, 8261, 8131, 8003,
    7875, 7749, 7624, 7502, 7380, 7260, 7140, 7022, 6904, 6786, 6668, 6551, 6435, 6322, 6209, 6099, 5989, 5881, 5773, 5668, 5563, 5461, 5359, 5260, 5161, 5063, 4965, 4871, 4777, 4686, 4595, 4506, 4417, 4331, 4245, 4162, 4079, 3999, 3919, 3841, 3763, 3685, 3607, 3530, 3454, 3380, 3307, 3236, 3166, 3097, 3029, 2963, 2897, 2834, 2771, 2710, 2650, 2591, 2532, 2475, 2418, 2363, 2309,
    2257, 2205, 2155, 2105, 2057, 2009, 1963, 1918, 1873, 1828, 1783, 1738, 1694, 1650, 1607, 1565, 1524, 1484, 1445, 1407, 1369, 1333, 1297, 1263, 1229, 1197, 1165, 1134, 1103, 1073, 1043, 1015, 987, 960, 933, 907, 882, 858, 834, 811, 788, 766, 744, 722, 700, 679, 658, 638, 618, 599, 581, 563, 545, 528, 511, 495, 480, 465, 451, 437, 423, 410, 397, 384, 372, 360, 348, 337, 326,
    315, 305, 295, 285, 275, 265, 255, 245, 236, 227, 219, 211, 203, 195, 188, 181, 174, 167, 161, 155, 149, 143, 137, 131, 126, 121, 116, 111, 106, 101, 97, 93, 89, 85, 81, 77, 73, 69, 65, 61, 58, 55, 52, 49, 46, 43, 40, 37, 34, 32, 30, 28, 26, 24, 22, 20, 18, 16, 14, 12, 10, 8, 6, 5, 4, 3, 2, 1, 0 };

################################################################################

TITLE
    lms_order_table

TYPE
    16

DATA
    {2,3,4,5,6,7,8,9,10,12,14,16,18,20,24,28,32,36,
     48,64,80,96,128,256,384,448,512,640,768,896,1024,0};

################################################################################

TITLE
    pc12_tbl reconstruction levels for 1st and 2nd coefficients

TYPE
    32

DATA
        -1048544, -1048288, -1047776, -1047008, -1045984, -1044704, -1043168, -1041376, -1039328,
        -1037024, -1034464, -1031648, -1028576, -1025248, -1021664, -1017824, -1013728, -1009376,
        -1004768, -999904, -994784, -989408, -983776, -977888, -971744, -965344, -958688, -951776,
        -944608, -937184, -929504, -921568, -913376, -904928, -896224, -887264, -878048, -868576,
        -858848, -848864, -838624, -828128, -817376, -806368, -795104, -783584, -771808, -759776,
        -747488, -734944, -722144, -709088, -695776, -682208, -668384, -654304, -639968, -625376,
        -610528, -595424, -580064, -564448, -548576, -532448, -516064, -499424, -482528, -465376,
        -447968, -430304, -412384, -394208, -375776, -357088, -338144, -318944, -299488, -279776,
        -259808, -239584, -219104, -198368, -177376, -156128, -134624, -112864, -90848, -68576,
        -46048, -23264, -224, 23072, 46624, 70432, 94496, 118816, 143392, 168224, 193312, 218656,
        244256, 270112, 296224, 322592, 349216, 376096, 403232, 430624, 458272, 486176, 514336,
        542752, 571424, 600352, 629536, 658976, 688672, 718624, 748832, 779296, 810016, 840992,
        872224, 903712, 935456, 967456, 999712, 1032224 };

################################################################################

TITLE
    MPEG-4 mcc gmmtable

TYPE
    16

DATA
                       { 204, 192, 179, 166, 153, 140, 128, 115,
						 102,  89,  76,  64,  51,  38,  25,  12,
						   0, -12, -25, -38, -51, -64, -76, -89,
						-102,-115,-128,-140,-153,-166,-179,-192};

################################################################################

TITLE
    FFT and FHT routines costab

TYPE
    FLOAT

DATA
    9.238795325112867e-01, 3.826834323650898e-01,
    9.951847266721969e-01, 9.801714032956060e-02,
    9.996988186962042e-01, 2.454122852291229e-02,
    9.999811752826011e-01, 6.135884649154475e-03

################################################################################

TITLE
    ReplayGainAnalysis ABYule

TYPE
    FLOAT

DATA
    {0.03857599435200, -3.84664617118067, -0.02160367184185, 7.81501653005538, -0.00123395316851,
     -11.34170355132042, -0.00009291677959, 13.05504219327545, -0.01655260341619,
     -12.28759895145294, 0.02161526843274, 9.48293806319790, -0.02074045215285, -5.87257861775999,
     0.00594298065125, 2.75465861874613, 0.00306428023191, -0.86984376593551, 0.00012025322027,
     0.13919314567432, 0.00288463683916},
    {0.05418656406430, -3.47845948550071, -0.02911007808948, 6.36317777566148, -0.00848709379851,
     -8.54751527471874, -0.00851165645469, 9.47693607801280, -0.00834990904936, -8.81498681370155,
     0.02245293253339, 6.85401540936998, -0.02596338512915, -4.39470996079559, 0.01624864962975,
     2.19611684890774, -0.00240879051584, -0.75104302451432, 0.00674613682247, 0.13149317958808,
     -0.00187763777362},
    {0.15457299681924, -2.37898834973084, -0.09331049056315, 2.84868151156327, -0.06247880153653,
     -2.64577170229825, 0.02163541888798, 2.23697657451713, -0.05588393329856, -1.67148153367602,
     0.04781476674921, 1.00595954808547, 0.00222312597743, -0.45953458054983, 0.03174092540049,
     0.16378164858596, -0.01390589421898, -0.05032077717131, 0.00651420667831, 0.02347897407020,
     -0.00881362733839},
    {0.30296907319327, -1.61273165137247, -0.22613988682123, 1.07977492259970, -0.08587323730772,
     -0.25656257754070, 0.03282930172664, -0.16276719120440, -0.00915702933434, -0.22638893773906,
     -0.02364141202522, 0.39120800788284, -0.00584456039913, -0.22138138954925, 0.06276101321749,
     0.04500235387352, -0.00000828086748, 0.02005851806501, 0.00205861885564, 0.00302439095741,
     -0.02950134983287},
    {0.33642304856132, -1.49858979367799, -0.25572241425570, 0.87350271418188, -0.11828570177555,
     0.12205022308084, 0.11921148675203, -0.80774944671438, -0.07834489609479, 0.47854794562326,
     -0.00469977914380, -0.12453458140019, -0.00589500224440, -0.04067510197014, 0.05724228140351,
     0.08333755284107, 0.00832043980773, -0.04237348025746, -0.01635381384540, 0.02977207319925,
     -0.01760176568150},
    {0.44915256608450, -0.62820619233671, -0.14351757464547, 0.29661783706366, -0.22784394429749,
     -0.37256372942400, -0.01419140100551, 0.00213767857124, 0.04078262797139, -0.42029820170918,
     -0.12398163381748, 0.22199650564824, 0.04097565135648, 0.00613424350682, 0.10478503600251,
     0.06747620744683, -0.01863887810927, 0.05784820375801, -0.03193428438915, 0.03222754072173,
     0.00541907748707},
    {0.56619470757641, -1.04800335126349, -0.75464456939302, 0.29156311971249, 0.16242137742230,
     -0.26806001042947, 0.16744243493672, 0.00819999645858, -0.18901604199609, 0.45054734505008,
     0.30931782841830, -0.33032403314006, -0.27562961986224, 0.06739368333110, 0.00647310677246,
     -0.04784254229033, 0.08647503780351, 0.01639907836189, -0.03788984554840, 0.01807364323573,
     -0.00588215443421},
    {0.58100494960553, -0.51035327095184, -0.53174909058578, -0.31863563325245, -0.14289799034253,
     -0.20256413484477, 0.17520704835522, 0.14728154134330, 0.02377945217615, 0.38952639978999,
     0.15558449135573, -0.23313271880868, -0.25344790059353, -0.05246019024463, 0.01628462406333,
     -0.02505961724053, 0.06920467763959, 0.02442357316099, -0.03721611395801, 0.01818801111503,
     -0.00749618797172},
    {0.53648789255105, -0.25049871956020, -0.42163034350696, -0.43193942311114, -0.00275953611929,
     -0.03424681017675, 0.04267842219415, -0.04678328784242, -0.10214864179676, 0.26408300200955,
     0.14590772289388, 0.15113130533216, -0.02459864859345, -0.17556493366449, -0.11202315195388,
     -0.18823009262115, -0.04060034127000, 0.05477720428674, 0.04788665548180, 0.04704409688120,
     -0.02217936801134}

################################################################################

TITLE
    Windows CryptAcquireContext

TYPE
    8

DATA
    "CryptAcquireContextA\0"

################################################################################

TITLE
    Windows CryptCreateHash

TYPE
    8

DATA
    "CryptCreateHash\0"

################################################################################

TITLE
    Windows CryptImportKey

TYPE
    8

DATA
    "CryptImportKey\0"

################################################################################

TITLE
    Windows CryptHashData

TYPE
    8

DATA
    "CryptHashData\0"

################################################################################

TITLE
    Windows CryptVerifySignature

TYPE
    8

DATA
    "CryptVerifySignature\0"

################################################################################

TITLE
    Windows CryptDeriveKey

TYPE
    8

DATA
    "CryptDeriveKey\0"

################################################################################

TITLE
    Windows CryptDecrypt

TYPE
    8

DATA
    "CryptDecrypt\0"

################################################################################

TITLE
    __popcount_tab (compression?)

TYPE
    8

DATA
    0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
    1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
    1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
    2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
    1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
    2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
    2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
    3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,

################################################################################

TITLE
    select_tab (compression?)

TYPE
    8

DATA
    0,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    6,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    7,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    6,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    8,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    6,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    7,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,
    6,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,5,1,2,1,3,1,2,1,4,1,2,1,3,1,2,1,

################################################################################

TITLE
    t264 deblock_threshold_tc0

TYPE
    8

DATA
    { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 },
    { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 },
    { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 1 },
    { 0, 0, 1 }, { 0, 0, 1 }, { 0, 0, 1 }, { 0, 1, 1 }, { 0, 1, 1 }, { 1, 1, 1 },
    { 1, 1, 1 }, { 1, 1, 1 }, { 1, 1, 1 }, { 1, 1, 2 }, { 1, 1, 2 }, { 1, 1, 2 },
    { 1, 1, 2 }, { 1, 2, 3 }, { 1, 2, 3 }, { 2, 2, 3 }, { 2, 2, 4 }, { 2, 3, 4 },
    { 2, 3, 4 }, { 3, 3, 5 }, { 3, 4, 6 }, { 3, 4, 6 }, { 4, 5, 7 }, { 4, 5, 8 },
    { 4, 6, 9 }, { 5, 7,10 }, { 6, 8,11 }, { 6, 8,13 }, { 7,10,14 }, { 8,11,16 },
    { 9,12,18 }, {10,13,20 }, {11,15,23 }, {13,17,25 

################################################################################
#
#TITLE
#    T264_cabac_range_lps
#
#TYPE
#    8 32
#
#DATA
#       { 128, 176, 208, 240 }, { 128, 167, 197, 227 }, { 128, 158, 187, 216 },
#       { 123, 150, 178, 205 }, { 116, 142, 169, 195 }, { 111, 135, 160, 185 },
#       { 105, 128, 152, 175 }, { 100, 122, 144, 166 }, {  95, 116, 137, 158 },
#       {  90, 110, 130, 150 }, {  85, 104, 123, 142 }, {  81,  99, 117, 135 },
#       {  77,  94, 111, 128 }, {  73,  89, 105, 122 }, {  69,  85, 100, 116 },
#       {  66,  80,  95, 110 }, {  62,  76,  90, 104 }, {  59,  72,  86,  99 },
#       {  56,  69,  81,  94 }, {  53,  65,  77,  89 }, {  51,  62,  73,  85 },
#       {  48,  59,  69,  80 }, {  46,  56,  66,  76 }, {  43,  53,  63,  72 },
#       {  41,  50,  59,  69 }, {  39,  48,  56,  65 }, {  37,  45,  54,  62 },
#       {  35,  43,  51,  59 }, {  33,  41,  48,  56 }, {  32,  39,  46,  53 },
#       {  30,  37,  43,  50 }, {  29,  35,  41,  48 }, {  27,  33,  39,  45 },
#       {  26,  31,  37,  43 }, {  24,  30,  35,  41 }, {  23,  28,  33,  39 },
#       {  22,  27,  32,  37 }, {  21,  26,  30,  35 }, {  20,  24,  29,  33 },
#       {  19,  23,  27,  31 }, {  18,  22,  26,  30 }, {  17,  21,  25,  28 },
#       {  16,  20,  23,  27 }, {  15,  19,  22,  25 }, {  14,  18,  21,  24 },
#       {  14,  17,  20,  23 }, {  13,  16,  19,  22 }, {  12,  15,  18,  21 },
#      {  12,  14,  17,  20 }, {  11,  14,  16,  19 }, {  11,  13,  15,  18 },
#       {  10,  12,  15,  17 }, {  10,  12,  14,  16 }, {   9,  11,  13,  15 },
#       {   9,  11,  12,  14 }, {   8,  10,  12,  14 }, {   8,   9,  11,  13 },
#       {   7,   9,  11,  12 }, {   7,   9,  10,  12 }, {   7,   8,  10,  11 },
#       {   6,   8,   9,  11 }, {   6,   7,   9,  10 }, {   6,   7,   8,   9 },
#       {   2,   2,   2,   2 },
#
################################################################################

TITLE
    T264_cabac_probability

TYPE
    8

DATA
 0xfb 0x00 0x00 0x00 0xfa 0x00 0x00 0x00 0xfa 0x00 0x00 0x00 0xfa 0x00 0x00 0x00
 0xfa 0x00 0x00 0x00 0xf9 0x00 0x00 0x00 0xf9 0x00 0x00 0x00 0xf9 0x00 0x00 0x00
 0xf8 0x00 0x00 0x00 0xf8 0x00 0x00 0x00 0xf7 0x00 0x00 0x00 0xf7 0x00 0x00 0x00
 0xf7 0x00 0x00 0x00 0xf6 0x00 0x00 0x00 0xf6 0x00 0x00 0x00 0xf5 0x00 0x00 0x00
 0xf4 0x00 0x00 0x00 0xf4 0x00 0x00 0x00 0xf3 0x00 0x00 0x00 0xf3 0x00 0x00 0x00
 0xf2 0x00 0x00 0x00 0xf1 0x00 0x00 0x00 0xf0 0x00 0x00 0x00 0xf0 0x00 0x00 0x00
 0xef 0x00 0x00 0x00 0xee 0x00 0x00 0x00 0xed 0x00 0x00 0x00 0xec 0x00 0x00 0x00
 0xeb 0x00 0x00 0x00 0xea 0x00 0x00 0x00 0xe9 0x00 0x00 0x00 0xe7 0x00 0x00 0x00
 0xe6 0x00 0x00 0x00 0xe5 0x00 0x00 0x00 0xe3 0x00 0x00 0x00 0xe2 0x00 0x00 0x00
 0xe0 0x00 0x00 0x00 0xde 0x00 0x00 0x00 0xdd 0x00 0x00 0x00 0xdb 0x00 0x00 0x00
 0xd9 0x00 0x00 0x00 0xd7 0x00 0x00 0x00 0xd5 0x00 0x00 0x00 0xd2 0x00 0x00 0x00
 0xd0 0x00 0x00 0x00 0xcd 0x00 0x00 0x00 0xcb 0x00 0x00 0x00 0xc8 0x00 0x00 0x00
 0xc5 0x00 0x00 0x00 0xc2 0x00 0x00 0x00 0xbf 0x00 0x00 0x00 0xbb 0x00 0x00 0x00
 0xb7 0x00 0x00 0x00 0xb3 0x00 0x00 0x00 0xaf 0x00 0x00 0x00 0xab 0x00 0x00 0x00
 0xa7 0x00 0x00 0x00 0xa2 0x00 0x00 0x00 0x9d 0x00 0x00 0x00 0x98 0x00 0x00 0x00
 0x92 0x00 0x00 0x00 0x8c 0x00 0x00 0x00 0x86 0x00 0x00 0x00 0x80 0x00 0x00 0x00
 0x80 0x00 0x00 0x00 0x79 0x00 0x00 0x00 0x73 0x00 0x00 0x00 0x6d 0x00 0x00 0x00
 0x67 0x00 0x00 0x00 0x62 0x00 0x00 0x00 0x5d 0x00 0x00 0x00 0x58 0x00 0x00 0x00
 0x54 0x00 0x00 0x00 0x50 0x00 0x00 0x00 0x4c 0x00 0x00 0x00 0x48 0x00 0x00 0x00
 0x44 0x00 0x00 0x00 0x40 0x00 0x00 0x00 0x3d 0x00 0x00 0x00 0x3a 0x00 0x00 0x00
 0x37 0x00 0x00 0x00 0x34 0x00 0x00 0x00 0x32 0x00 0x00 0x00 0x2f 0x00 0x00 0x00
 0x2d 0x00 0x00 0x00 0x2a 0x00 0x00 0x00 0x28 0x00 0x00 0x00 0x26 0x00 0x00 0x00
 0x24 0x00 0x00 0x00 0x22 0x00 0x00 0x00 0x21 0x00 0x00 0x00 0x1f 0x00 0x00 0x00
 0x1d 0x00 0x00 0x00 0x1c 0x00 0x00 0x00 0x1a 0x00 0x00 0x00 0x19 0x00 0x00 0x00
 0x18 0x00 0x00 0x00 0x16 0x00 0x00 0x00 0x15 0x00 0x00 0x00 0x14 0x00 0x00 0x00
 0x13 0x00 0x00 0x00 0x12 0x00 0x00 0x00 0x11 0x00 0x00 0x00 0x10 0x00 0x00 0x00
 0x0f 0x00 0x00 0x00 0x0f 0x00 0x00 0x00 0x0e 0x00 0x00 0x00 0x0d 0x00 0x00 0x00
 0x0c 0x00 0x00 0x00 0x0c 0x00 0x00 0x00 0x0b 0x00 0x00 0x00 0x0b 0x00 0x00 0x00
 0x0a 0x00 0x00 0x00 0x09 0x00 0x00 0x00 0x09 0x00 0x00 0x00 0x08 0x00 0x00 0x00
 0x08 0x00 0x00 0x00 0x08 0x00 0x00 0x00 0x07 0x00 0x00 0x00 0x07 0x00 0x00 0x00
 0x06 0x00 0x00 0x00 0x06 0x00 0x00 0x00 0x06 0x00 0x00 0x00 0x05 0x00 0x00 0x00
 0x05 0x00 0x00 0x00 0x05 0x00 0x00 0x00 0x05 0x00 0x00 0x00 0x04 0x00 0x00 0x00

################################################################################

TITLE
    T264_cabac_probability 2

TYPE
    8

DATA
 0x06 0x00 0x00 0x00 0x07 0x00 0x00 0x00 0x07 0x00 0x00 0x00 0x08 0x00 0x00 0x00
 0x08 0x00 0x00 0x00 0x09 0x00 0x00 0x00 0x09 0x00 0x00 0x00 0x0a 0x00 0x00 0x00
 0x0a 0x00 0x00 0x00 0x0b 0x00 0x00 0x00 0x0b 0x00 0x00 0x00 0x0c 0x00 0x00 0x00
 0x0d 0x00 0x00 0x00 0x0d 0x00 0x00 0x00 0x0e 0x00 0x00 0x00 0x0f 0x00 0x00 0x00
 0x10 0x00 0x00 0x00 0x11 0x00 0x00 0x00 0x12 0x00 0x00 0x00 0x13 0x00 0x00 0x00
 0x14 0x00 0x00 0x00 0x15 0x00 0x00 0x00 0x16 0x00 0x00 0x00 0x17 0x00 0x00 0x00
 0x19 0x00 0x00 0x00 0x1a 0x00 0x00 0x00 0x1b 0x00 0x00 0x00 0x1d 0x00 0x00 0x00
 0x1f 0x00 0x00 0x00 0x20 0x00 0x00 0x00 0x22 0x00 0x00 0x00 0x24 0x00 0x00 0x00
 0x26 0x00 0x00 0x00 0x28 0x00 0x00 0x00 0x2b 0x00 0x00 0x00 0x2d 0x00 0x00 0x00
 0x30 0x00 0x00 0x00 0x32 0x00 0x00 0x00 0x35 0x00 0x00 0x00 0x39 0x00 0x00 0x00
 0x3c 0x00 0x00 0x00 0x3f 0x00 0x00 0x00 0x43 0x00 0x00 0x00 0x47 0x00 0x00 0x00
 0x4b 0x00 0x00 0x00 0x50 0x00 0x00 0x00 0x55 0x00 0x00 0x00 0x5a 0x00 0x00 0x00
 0x5f 0x00 0x00 0x00 0x65 0x00 0x00 0x00 0x6c 0x00 0x00 0x00 0x72 0x00 0x00 0x00
 0x7a 0x00 0x00 0x00 0x82 0x00 0x00 0x00 0x8a 0x00 0x00 0x00 0x93 0x00 0x00 0x00
 0x9d 0x00 0x00 0x00 0xa8 0x00 0x00 0x00 0xb3 0x00 0x00 0x00 0xc0 0x00 0x00 0x00
 0xce 0x00 0x00 0x00 0xdd 0x00 0x00 0x00 0xed 0x00 0x00 0x00 0x00 0x01 0x00 0x00
 0x00 0x01 0x00 0x00 0x13 0x01 0x00 0x00 0x26 0x01 0x00 0x00 0x39 0x01 0x00 0x00
 0x4d 0x01 0x00 0x00 0x60 0x01 0x00 0x00 0x73 0x01 0x00 0x00 0x86 0x01 0x00 0x00
 0x99 0x01 0x00 0x00 0xad 0x01 0x00 0x00 0xc0 0x01 0x00 0x00 0xd3 0x01 0x00 0x00
 0xe6 0x01 0x00 0x00 0xfa 0x01 0x00 0x00 0x0d 0x02 0x00 0x00 0x20 0x02 0x00 0x00
 0x33 0x02 0x00 0x00 0x47 0x02 0x00 0x00 0x5a 0x02 0x00 0x00 0x6d 0x02 0x00 0x00
 0x80 0x02 0x00 0x00 0x94 0x02 0x00 0x00 0xa7 0x02 0x00 0x00 0xba 0x02 0x00 0x00
 0xcd 0x02 0x00 0x00 0xe1 0x02 0x00 0x00 0xf4 0x02 0x00 0x00 0x07 0x03 0x00 0x00
 0x1a 0x03 0x00 0x00 0x2e 0x03 0x00 0x00 0x41 0x03 0x00 0x00 0x54 0x03 0x00 0x00
 0x67 0x03 0x00 0x00 0x7b 0x03 0x00 0x00 0x8e 0x03 0x00 0x00 0xa1 0x03 0x00 0x00
 0xb4 0x03 0x00 0x00 0xc8 0x03 0x00 0x00 0xdb 0x03 0x00 0x00 0xee 0x03 0x00 0x00
 0x01 0x04 0x00 0x00 0x15 0x04 0x00 0x00 0x28 0x04 0x00 0x00 0x3b 0x04 0x00 0x00
 0x4e 0x04 0x00 0x00 0x62 0x04 0x00 0x00 0x75 0x04 0x00 0x00 0x88 0x04 0x00 0x00
 0x9b 0x04 0x00 0x00 0xaf 0x04 0x00 0x00 0xc2 0x04 0x00 0x00 0xd5 0x04 0x00 0x00
 0xe8 0x04 0x00 0x00 0xfc 0x04 0x00 0x00 0x0f 0x05 0x00 0x00 0x22 0x05 0x00 0x00
 0x35 0x05 0x00 0x00 0x49 0x05 0x00 0x00 0x5c 0x05 0x00 0x00 0x6f 0x05 0x00 0x00
 0x82 0x05 0x00 0x00 0x96 0x05 0x00 0x00 0xa9 0x05 0x00 0x00 0xbc 0x05 0x00 0x00

################################################################################

TITLE
    TEA encryption/decryption (0xc6ef3720  0x9e3779b9)

TYPE
    32 AND

DATA
    0xc6ef3720  0x9e3779b9

################################################################################

TITLE
    TEA encryption/decryption (0xc6ef3720  0x61c88647)

TYPE
    32 AND

DATA
    0xc6ef3720  0x61c88647

################################################################################

TITLE
    classical random incrementer 0x343FD 0x269EC3

TYPE
    32 AND

DATA
    0x343FD 0x269EC3

################################################################################

TITLE
    Huffman book1

TYPE
    32

DATA
	{     0,     11,     2040},
	{     1,      9,      497},
	{     2,     11,     2045},
	{     3,     10,     1013},
	{     4,      7,      104},
	{     5,     10,     1008},
	{     6,     11,     2039},
	{     7,      9,      492},
	{     8,     11,     2037},
	{     9,     10,     1009},
	{    10,      7,      114},
	{    11,     10,     1012},
	{    12,      7,      116},
	{    13,      5,       17},
	{    14,      7,      118},
	{    15,      9,      491},
	{    16,      7,      108},
	{    17,     10,     1014},
	{    18,     11,     2044},
	{    19,      9,      481},
	{    20,     11,     2033},
	{    21,      9,      496},
	{    22,      7,       97},
	{    23,      9,      502},
	{    24,     11,     2034},
	{    25,      9,      490},
	{    26,     11,     2043},
	{    27,      9,      498},
	{    28,      7,      105},
	{    29,      9,      493},
	{    30,      7,      119},
	{    31,      5,       23},
	{    32,      7,      111},
	{    33,      9,      486},
	{    34,      7,      100},
	{    35,      9,      485},
	{    36,      7,      103},
	{    37,      5,       21},
	{    38,      7,       98},
	{    39,      5,       18},
	{    40,      1,        0},
	{    41,      5,       20},
	{    42,      7,      101},
	{    43,      5,       22},
	{    44,      7,      109},
	{    45,      9,      489},
	{    46,      7,       99},
	{    47,      9,      484},
	{    48,      7,      107},
	{    49,      5,       19},
	{    50,      7,      113},
	{    51,      9,      483},
	{    52,      7,      112},
	{    53,      9,      499},
	{    54,     11,     2046},
	{    55,      9,      487},
	{    56,     11,     2035},
	{    57,      9,      495},
	{    58,      7,       96},
	{    59,      9,      494},
	{    60,     11,     2032},
	{    61,      9,      482},
	{    62,     11,     2042},
	{    63,     10,     1011},
	{    64,      7,      106},
	{    65,      9,      488},
	{    66,      7,      117},
	{    67,      5,       16},
	{    68,      7,      115},
	{    69,      9,      500},
	{    70,      7,      110},
	{    71,     10,     1015},
	{    72,     11,     2038},
	{    73,      9,      480},
	{    74,     11,     2041},
	{    75,     10,     1010},
	{    76,      7,      102},
	{    77,      9,      501},
	{    78,     11,     2047},
	{    79,      9,      503},
	{    80,     11,     2036}

################################################################################

TITLE
    Huffman book2

TYPE
    32

DATA
	{     0,      9,      499},
	{     1,      7,      111},
	{     2,      9,      509},
	{     3,      8,      235},
	{     4,      6,       35},
	{     5,      8,      234},
	{     6,      9,      503},
	{     7,      8,      232},
	{     8,      9,      506},
	{     9,      8,      242},
	{    10,      6,       45},
	{    11,      7,      112},
	{    12,      6,       32},
	{    13,      5,        6},
	{    14,      6,       43},
	{    15,      7,      110},
	{    16,      6,       40},
	{    17,      8,      233},
	{    18,      9,      505},
	{    19,      7,      102},
	{    20,      8,      248},
	{    21,      8,      231},
	{    22,      6,       27},
	{    23,      8,      241},
	{    24,      9,      500},
	{    25,      7,      107},
	{    26,      9,      501},
	{    27,      8,      236},
	{    28,      6,       42},
	{    29,      7,      108},
	{    30,      6,       44},
	{    31,      5,       10},
	{    32,      6,       39},
	{    33,      7,      103},
	{    34,      6,       26},
	{    35,      8,      245},
	{    36,      6,       36},
	{    37,      5,        8},
	{    38,      6,       31},
	{    39,      5,        9},
	{    40,      3,        0},
	{    41,      5,        7},
	{    42,      6,       29},
	{    43,      5,       11},
	{    44,      6,       48},
	{    45,      8,      239},
	{    46,      6,       28},
	{    47,      7,      100},
	{    48,      6,       30},
	{    49,      5,       12},
	{    50,      6,       41},
	{    51,      8,      243},
	{    52,      6,       47},
	{    53,      8,      240},
	{    54,      9,      508},
	{    55,      7,      113},
	{    56,      9,      498},
	{    57,      8,      244},
	{    58,      6,       33},
	{    59,      8,      230},
	{    60,      8,      247},
	{    61,      7,      104},
	{    62,      9,      504},
	{    63,      8,      238},
	{    64,      6,       34},
	{    65,      7,      101},
	{    66,      6,       49},
	{    67,      4,        2},
	{    68,      6,       38},
	{    69,      8,      237},
	{    70,      6,       37},
	{    71,      7,      106},
	{    72,      9,      507},
	{    73,      7,      114},
	{    74,      9,      510},
	{    75,      7,      105},
	{    76,      6,       46},
	{    77,      8,      246},
	{    78,      9,      511},
	{    79,      7,      109},
	{    80,      9,      502}

################################################################################

TITLE
    Huffman book3

TYPE
    32

DATA
	{     0,      1,        0},
	{     1,      4,        9},
	{     2,      8,      239},
	{     3,      4,       11},
	{     4,      5,       25},
	{     5,      8,      240},
	{     6,      9,      491},
	{     7,      9,      486},
	{     8,     10,     1010},
	{     9,      4,       10},
	{    10,      6,       53},
	{    11,      9,      495},
	{    12,      6,       52},
	{    13,      6,       55},
	{    14,      9,      489},
	{    15,      9,      493},
	{    16,      9,      487},
	{    17,     10,     1011},
	{    18,      9,      494},
	{    19,     10,     1005},
	{    20,     13,     8186},
	{    21,      9,      492},
	{    22,      9,      498},
	{    23,     11,     2041},
	{    24,     11,     2040},
	{    25,     10,     1016},
	{    26,     12,     4088},
	{    27,      4,        8},
	{    28,      6,       56},
	{    29,     10,     1014},
	{    30,      6,       54},
	{    31,      7,      117},
	{    32,     10,     1009},
	{    33,     10,     1003},
	{    34,     10,     1004},
	{    35,     12,     4084},
	{    36,      5,       24},
	{    37,      7,      118},
	{    38,     11,     2036},
	{    39,      6,       57},
	{    40,      7,      116},
	{    41,     10,     1007},
	{    42,      9,      499},
	{    43,      9,      500},
	{    44,     11,     2038},
	{    45,      9,      488},
	{    46,     10,     1002},
	{    47,     13,     8188},
	{    48,      8,      242},
	{    49,      9,      497},
	{    50,     12,     4091},
	{    51,     10,     1013},
	{    52,     11,     2035},
	{    53,     12,     4092},
	{    54,      8,      238},
	{    55,     10,     1015},
	{    56,     15,    32766},
	{    57,      9,      496},
	{    58,     11,     2037},
	{    59,     15,    32765},
	{    60,     13,     8187},
	{    61,     14,    16378},
	{    62,     16,    65535},
	{    63,      8,      241},
	{    64,     10,     1008},
	{    65,     14,    16380},
	{    66,      9,      490},
	{    67,     10,     1006},
	{    68,     14,    16379},
	{    69,     12,     4086},
	{    70,     12,     4090},
	{    71,     15,    32764},
	{    72,     11,     2034},
	{    73,     12,     4085},
	{    74,     16,    65534},
	{    75,     10,     1012},
	{    76,     11,     2039},
	{    77,     15,    32763},
	{    78,     12,     4087},
	{    79,     12,     4089},
	{    80,     15,    32762}

################################################################################

TITLE
    Huffman book4

TYPE
    32

DATA
	{     0,      4,        7},
	{     1,      5,       22},
	{     2,      8,      246},
	{     3,      5,       24},
	{     4,      4,        8},
	{     5,      8,      239},
	{     6,      9,      495},
	{     7,      8,      243},
	{     8,     11,     2040},
	{     9,      5,       25},
	{    10,      5,       23},
	{    11,      8,      237},
	{    12,      5,       21},
	{    13,      4,        1},
	{    14,      8,      226},
	{    15,      8,      240},
	{    16,      7,      112},
	{    17,     10,     1008},
	{    18,      9,      494},
	{    19,      8,      241},
	{    20,     11,     2042},
	{    21,      8,      238},
	{    22,      8,      228},
	{    23,     10,     1010},
	{    24,     11,     2038},
	{    25,     10,     1007},
	{    26,     11,     2045},
	{    27,      4,        5},
	{    28,      5,       20},
	{    29,      8,      242},
	{    30,      4,        9},
	{    31,      4,        4},
	{    32,      8,      229},
	{    33,      8,      244},
	{    34,      8,      232},
	{    35,     10,     1012},
	{    36,      4,        6},
	{    37,      4,        2},
	{    38,      8,      231},
	{    39,      4,        3},
	{    40,      4,        0},
	{    41,      7,      107},
	{    42,      8,      227},
	{    43,      7,      105},
	{    44,      9,      499},
	{    45,      8,      235},
	{    46,      8,      230},
	{    47,     10,     1014},
	{    48,      7,      110},
	{    49,      7,      106},
	{    50,      9,      500},
	{    51,     10,     1004},
	{    52,      9,      496},
	{    53,     10,     1017},
	{    54,      8,      245},
	{    55,      8,      236},
	{    56,     11,     2043},
	{    57,      8,      234},
	{    58,      7,      111},
	{    59,     10,     1015},
	{    60,     11,     2041},
	{    61,     10,     1011},
	{    62,     12,     4095},
	{    63,      8,      233},
	{    64,      7,      109},
	{    65,     10,     1016},
	{    66,      7,      108},
	{    67,      7,      104},
	{    68,      9,      501},
	{    69,     10,     1006},
	{    70,      9,      498},
	{    71,     11,     2036},
	{    72,     11,     2039},
	{    73,     10,     1009},
	{    74,     12,     4094},
	{    75,     10,     1005},
	{    76,      9,      497},
	{    77,     11,     2037},
	{    78,     11,     2046},
	{    79,     10,     1013},
	{    80,     11,     2044}

################################################################################

TITLE
    Huffman book5

TYPE
    32

DATA
	{     0,     13,     8191},
	{     1,     12,     4087},
	{     2,     11,     2036},
	{     3,     11,     2024},
	{     4,     10,     1009},
	{     5,     11,     2030},
	{     6,     11,     2041},
	{     7,     12,     4088},
	{     8,     13,     8189},
	{     9,     12,     4093},
	{    10,     11,     2033},
	{    11,     10,     1000},
	{    12,      9,      488},
	{    13,      8,      240},
	{    14,      9,      492},
	{    15,     10,     1006},
	{    16,     11,     2034},
	{    17,     12,     4090},
	{    18,     12,     4084},
	{    19,     10,     1007},
	{    20,      9,      498},
	{    21,      8,      232},
	{    22,      7,      112},
	{    23,      8,      236},
	{    24,      9,      496},
	{    25,     10,     1002},
	{    26,     11,     2035},
	{    27,     11,     2027},
	{    28,      9,      491},
	{    29,      8,      234},
	{    30,      5,       26},
	{    31,      4,        8},
	{    32,      5,       25},
	{    33,      8,      238},
	{    34,      9,      495},
	{    35,     11,     2029},
	{    36,     10,     1008},
	{    37,      8,      242},
	{    38,      7,      115},
	{    39,      4,       11},
	{    40,      1,        0},
	{    41,      4,       10},
	{    42,      7,      113},
	{    43,      8,      243},
	{    44,     11,     2025},
	{    45,     11,     2031},
	{    46,      9,      494},
	{    47,      8,      239},
	{    48,      5,       24},
	{    49,      4,        9},
	{    50,      5,       27},
	{    51,      8,      235},
	{    52,      9,      489},
	{    53,     11,     2028},
	{    54,     11,     2038},
	{    55,     10,     1003},
	{    56,      9,      499},
	{    57,      8,      237},
	{    58,      7,      114},
	{    59,      8,      233},
	{    60,      9,      497},
	{    61,     10,     1005},
	{    62,     11,     2039},
	{    63,     12,     4086},
	{    64,     11,     2032},
	{    65,     10,     1001},
	{    66,      9,      493},
	{    67,      8,      241},
	{    68,      9,      490},
	{    69,     10,     1004},
	{    70,     11,     2040},
	{    71,     12,     4089},
	{    72,     13,     8188},
	{    73,     12,     4092},
	{    74,     12,     4085},
	{    75,     11,     2026},
	{    76,     10,     1011},
	{    77,     10,     1010},
	{    78,     11,     2037},
	{    79,     12,     4091},
	{    80,     13,     8190}

################################################################################

TITLE
    Huffman book6

TYPE
    32

DATA
	{     0,     11,     2046},
	{     1,     10,     1021},
	{     2,      9,      497},
	{     3,      9,      491},
	{     4,      9,      500},
	{     5,      9,      490},
	{     6,      9,      496},
	{     7,     10,     1020},
	{     8,     11,     2045},
	{     9,     10,     1014},
	{    10,      9,      485},
	{    11,      8,      234},
	{    12,      7,      108},
	{    13,      7,      113},
	{    14,      7,      104},
	{    15,      8,      240},
	{    16,      9,      486},
	{    17,     10,     1015},
	{    18,      9,      499},
	{    19,      8,      239},
	{    20,      6,       50},
	{    21,      6,       39},
	{    22,      6,       40},
	{    23,      6,       38},
	{    24,      6,       49},
	{    25,      8,      235},
	{    26,      9,      503},
	{    27,      9,      488},
	{    28,      7,      111},
	{    29,      6,       46},
	{    30,      4,        8},
	{    31,      4,        4},
	{    32,      4,        6},
	{    33,      6,       41},
	{    34,      7,      107},
	{    35,      9,      494},
	{    36,      9,      495},
	{    37,      7,      114},
	{    38,      6,       45},
	{    39,      4,        2},
	{    40,      4,        0},
	{    41,      4,        3},
	{    42,      6,       47},
	{    43,      7,      115},
	{    44,      9,      506},
	{    45,      9,      487},
	{    46,      7,      110},
	{    47,      6,       43},
	{    48,      4,        7},
	{    49,      4,        1},
	{    50,      4,        5},
	{    51,      6,       44},
	{    52,      7,      109},
	{    53,      9,      492},
	{    54,      9,      505},
	{    55,      8,      238},
	{    56,      6,       48},
	{    57,      6,       36},
	{    58,      6,       42},
	{    59,      6,       37},
	{    60,      6,       51},
	{    61,      8,      236},
	{    62,      9,      498},
	{    63,     10,     1016},
	{    64,      9,      484},
	{    65,      8,      237},
	{    66,      7,      106},
	{    67,      7,      112},
	{    68,      7,      105},
	{    69,      7,      116},
	{    70,      8,      241},
	{    71,     10,     1018},
	{    72,     11,     2047},
	{    73,     10,     1017},
	{    74,      9,      502},
	{    75,      9,      493},
	{    76,      9,      504},
	{    77,      9,      489},
	{    78,      9,      501},
	{    79,     10,     1019},
	{    80,     11,     2044}

################################################################################

TITLE
    Huffman book7

TYPE
    32

DATA
	{     0,      1,        0},
	{     1,      3,        5},
	{     2,      6,       55},
	{     3,      7,      116},
	{     4,      8,      242},
	{     5,      9,      491},
	{     6,     10,     1005},
	{     7,     11,     2039},
	{     8,      3,        4},
	{     9,      4,       12},
	{    10,      6,       53},
	{    11,      7,      113},
	{    12,      8,      236},
	{    13,      8,      238},
	{    14,      9,      494},
	{    15,      9,      501},
	{    16,      6,       54},
	{    17,      6,       52},
	{    18,      7,      114},
	{    19,      8,      234},
	{    20,      8,      241},
	{    21,      9,      489},
	{    22,      9,      499},
	{    23,     10,     1013},
	{    24,      7,      115},
	{    25,      7,      112},
	{    26,      8,      235},
	{    27,      8,      240},
	{    28,      9,      497},
	{    29,      9,      496},
	{    30,     10,     1004},
	{    31,     10,     1018},
	{    32,      8,      243},
	{    33,      8,      237},
	{    34,      9,      488},
	{    35,      9,      495},
	{    36,     10,     1007},
	{    37,     10,     1009},
	{    38,     10,     1017},
	{    39,     11,     2043},
	{    40,      9,      493},
	{    41,      8,      239},
	{    42,      9,      490},
	{    43,      9,      498},
	{    44,     10,     1011},
	{    45,     10,     1016},
	{    46,     11,     2041},
	{    47,     11,     2044},
	{    48,     10,     1006},
	{    49,      9,      492},
	{    50,      9,      500},
	{    51,     10,     1012},
	{    52,     10,     1015},
	{    53,     11,     2040},
	{    54,     12,     4093},
	{    55,     12,     4094},
	{    56,     11,     2038},
	{    57,     10,     1008},
	{    58,     10,     1010},
	{    59,     10,     1014},
	{    60,     11,     2042},
	{    61,     11,     2045},
	{    62,     12,     4092},
	{    63,     12,     4095}

################################################################################

TITLE
    Huffman book8

TYPE
    32

DATA
	{     0,      5,       14},
	{     1,      4,        5},
	{     2,      5,       16},
	{     3,      6,       48},
	{     4,      7,      111},
	{     5,      8,      241},
	{     6,      9,      506},
	{     7,     10,     1022},
	{     8,      4,        3},
	{     9,      3,        0},
	{    10,      4,        4},
	{    11,      5,       18},
	{    12,      6,       44},
	{    13,      7,      106},
	{    14,      7,      117},
	{    15,      8,      248},
	{    16,      5,       15},
	{    17,      4,        2},
	{    18,      4,        6},
	{    19,      5,       20},
	{    20,      6,       46},
	{    21,      7,      105},
	{    22,      7,      114},
	{    23,      8,      245},
	{    24,      6,       47},
	{    25,      5,       17},
	{    26,      5,       19},
	{    27,      6,       42},
	{    28,      6,       50},
	{    29,      7,      108},
	{    30,      8,      236},
	{    31,      8,      250},
	{    32,      7,      113},
	{    33,      6,       43},
	{    34,      6,       45},
	{    35,      6,       49},
	{    36,      7,      109},
	{    37,      7,      112},
	{    38,      8,      242},
	{    39,      9,      505},
	{    40,      8,      239},
	{    41,      7,      104},
	{    42,      6,       51},
	{    43,      7,      107},
	{    44,      7,      110},
	{    45,      8,      238},
	{    46,      8,      249},
	{    47,     10,     1020},
	{    48,      9,      504},
	{    49,      7,      116},
	{    50,      7,      115},
	{    51,      8,      237},
	{    52,      8,      240},
	{    53,      8,      246},
	{    54,      9,      502},
	{    55,      9,      509},
	{    56,     10,     1021},
	{    57,      8,      243},
	{    58,      8,      244},
	{    59,      8,      247},
	{    60,      9,      503},
	{    61,      9,      507},
	{    62,      9,      508},
	{    63,     10,     1023}

################################################################################

TITLE
    Huffman book9

TYPE
    32

DATA
	{     0,      1,        0},
	{     1,      3,        5},
	{     2,      6,       55},
	{     3,      8,      231},
	{     4,      9,      478},
	{     5,     10,      974},
	{     6,     10,      985},
	{     7,     11,     1992},
	{     8,     11,     1997},
	{     9,     12,     4040},
	{    10,     12,     4061},
	{    11,     13,     8164},
	{    12,     13,     8172},
	{    13,      3,        4},
	{    14,      4,       12},
	{    15,      6,       53},
	{    16,      7,      114},
	{    17,      8,      234},
	{    18,      8,      237},
	{    19,      9,      482},
	{    20,     10,      977},
	{    21,     10,      979},
	{    22,     10,      992},
	{    23,     11,     2008},
	{    24,     12,     4047},
	{    25,     12,     4053},
	{    26,      6,       54},
	{    27,      6,       52},
	{    28,      7,      113},
	{    29,      8,      232},
	{    30,      8,      236},
	{    31,      9,      481},
	{    32,     10,      975},
	{    33,     10,      989},
	{    34,     10,      987},
	{    35,     11,     2000},
	{    36,     12,     4039},
	{    37,     12,     4052},
	{    38,     12,     4068},
	{    39,      8,      230},
	{    40,      7,      112},
	{    41,      8,      233},
	{    42,      9,      477},
	{    43,      9,      483},
	{    44,     10,      978},
	{    45,     10,      988},
	{    46,     11,     1996},
	{    47,     11,     1994},
	{    48,     11,     2014},
	{    49,     12,     4056},
	{    50,     12,     4074},
	{    51,     13,     8155},
	{    52,      9,      479},
	{    53,      8,      235},
	{    54,      9,      476},
	{    55,      9,      486},
	{    56,     10,      981},
	{    57,     10,      990},
	{    58,     11,     1995},
	{    59,     11,     2013},
	{    60,     11,     2012},
	{    61,     12,     4045},
	{    62,     12,     4066},
	{    63,     12,     4071},
	{    64,     13,     8161},
	{    65,     10,      976},
	{    66,      9,      480},
	{    67,      9,      484},
	{    68,     10,      982},
	{    69,     11,     1989},
	{    70,     11,     2001},
	{    71,     11,     2011},
	{    72,     12,     4050},
	{    73,     11,     2016},
	{    74,     12,     4057},
	{    75,     12,     4075},
	{    76,     13,     8163},
	{    77,     13,     8169},
	{    78,     11,     1988},
	{    79,      9,      485},
	{    80,     10,      983},
	{    81,     11,     1990},
	{    82,     11,     1999},
	{    83,     11,     2010},
	{    84,     12,     4043},
	{    85,     12,     4058},
	{    86,     12,     4067},
	{    87,     12,     4073},
	{    88,     13,     8166},
	{    89,     13,     8179},
	{    90,     13,     8183},
	{    91,     11,     2003},
	{    92,     10,      984},
	{    93,     10,      993},
	{    94,     11,     2004},
	{    95,     11,     2009},
	{    96,     12,     4051},
	{    97,     12,     4062},
	{    98,     13,     8157},
	{    99,     13,     8153},
	{   100,     13,     8162},
	{   101,     13,     8170},
	{   102,     13,     8177},
	{   103,     13,     8182},
	{   104,     11,     2002},
	{   105,     10,      980},
	{   106,     10,      986},
	{   107,     11,     1991},
	{   108,     11,     2007},
	{   109,     11,     2018},
	{   110,     12,     4046},
	{   111,     12,     4059},
	{   112,     13,     8152},
	{   113,     13,     8174},
	{   114,     14,    16368},
	{   115,     13,     8180},
	{   116,     14,    16370},
	{   117,     11,     2017},
	{   118,     10,      991},
	{   119,     11,     1993},
	{   120,     11,     2006},
	{   121,     12,     4042},
	{   122,     12,     4048},
	{   123,     12,     4069},
	{   124,     12,     4070},
	{   125,     13,     8171},
	{   126,     13,     8175},
	{   127,     14,    16371},
	{   128,     14,    16372},
	{   129,     14,    16373},
	{   130,     12,     4064},
	{   131,     11,     1998},
	{   132,     11,     2005},
	{   133,     12,     4038},
	{   134,     12,     4049},
	{   135,     12,     4065},
	{   136,     13,     8160},
	{   137,     13,     8168},
	{   138,     13,     8176},
	{   139,     14,    16369},
	{   140,     14,    16376},
	{   141,     14,    16374},
	{   142,     15,    32764},
	{   143,     12,     4072},
	{   144,     11,     2015},
	{   145,     12,     4041},
	{   146,     12,     4055},
	{   147,     12,     4060},
	{   148,     13,     8156},
	{   149,     13,     8159},
	{   150,     13,     8173},
	{   151,     13,     8181},
	{   152,     14,    16377},
	{   153,     14,    16379},
	{   154,     15,    32765},
	{   155,     15,    32766},
	{   156,     13,     8167},
	{   157,     12,     4044},
	{   158,     12,     4054},
	{   159,     12,     4063},
	{   160,     13,     8158},
	{   161,     13,     8154},
	{   162,     13,     8165},
	{   163,     13,     8178},
	{   164,     14,    16378},
	{   165,     14,    16375},
	{   166,     14,    16380},
	{   167,     14,    16381},
	{   168,     15,    32767}

################################################################################

TITLE
    Huffman book10

TYPE
    32

DATA
	{     0,      6,       34},
	{     1,      5,        8},
	{     2,      6,       29},
	{     3,      6,       38},
	{     4,      7,       95},
	{     5,      8,      211},
	{     6,      9,      463},
	{     7,     10,      976},
	{     8,     10,      983},
	{     9,     10,     1005},
	{    10,     11,     2032},
	{    11,     11,     2038},
	{    12,     12,     4093},
	{    13,      5,        7},
	{    14,      4,        0},
	{    15,      4,        1},
	{    16,      5,        9},
	{    17,      6,       32},
	{    18,      7,       84},
	{    19,      7,       96},
	{    20,      8,      213},
	{    21,      8,      220},
	{    22,      9,      468},
	{    23,     10,      973},
	{    24,     10,      990},
	{    25,     11,     2023},
	{    26,      6,       28},
	{    27,      4,        2},
	{    28,      5,        6},
	{    29,      5,       12},
	{    30,      6,       30},
	{    31,      6,       40},
	{    32,      7,       91},
	{    33,      8,      205},
	{    34,      8,      217},
	{    35,      9,      462},
	{    36,      9,      476},
	{    37,     10,      985},
	{    38,     10,     1009},
	{    39,      6,       37},
	{    40,      5,       11},
	{    41,      5,       10},
	{    42,      5,       13},
	{    43,      6,       36},
	{    44,      7,       87},
	{    45,      7,       97},
	{    46,      8,      204},
	{    47,      8,      221},
	{    48,      9,      460},
	{    49,      9,      478},
	{    50,     10,      979},
	{    51,     10,      999},
	{    52,      7,       93},
	{    53,      6,       33},
	{    54,      6,       31},
	{    55,      6,       35},
	{    56,      6,       39},
	{    57,      7,       89},
	{    58,      7,      100},
	{    59,      8,      216},
	{    60,      8,      223},
	{    61,      9,      466},
	{    62,      9,      482},
	{    63,     10,      989},
	{    64,     10,     1006},
	{    65,      8,      209},
	{    66,      7,       85},
	{    67,      6,       41},
	{    68,      7,       86},
	{    69,      7,       88},
	{    70,      7,       98},
	{    71,      8,      206},
	{    72,      8,      224},
	{    73,      8,      226},
	{    74,      9,      474},
	{    75,     10,      980},
	{    76,     10,      995},
	{    77,     11,     2027},
	{    78,      9,      457},
	{    79,      7,       94},
	{    80,      7,       90},
	{    81,      7,       92},
	{    82,      7,       99},
	{    83,      8,      202},
	{    84,      8,      218},
	{    85,      9,      455},
	{    86,      9,      458},
	{    87,      9,      480},
	{    88,     10,      987},
	{    89,     10,     1000},
	{    90,     11,     2028},
	{    91,      9,      483},
	{    92,      8,      210},
	{    93,      8,      203},
	{    94,      8,      208},
	{    95,      8,      215},
	{    96,      8,      219},
	{    97,      9,      454},
	{    98,      9,      469},
	{    99,      9,      472},
	{   100,     10,      970},
	{   101,     10,      986},
	{   102,     11,     2026},
	{   103,     11,     2033},
	{   104,      9,      481},
	{   105,      8,      212},
	{   106,      8,      207},
	{   107,      8,      214},
	{   108,      8,      222},
	{   109,      8,      225},
	{   110,      9,      464},
	{   111,      9,      470},
	{   112,     10,      977},
	{   113,     10,      981},
	{   114,     10,     1010},
	{   115,     11,     2030},
	{   116,     11,     2043},
	{   117,     10,     1001},
	{   118,      9,      461},
	{   119,      9,      456},
	{   120,      9,      459},
	{   121,      9,      465},
	{   122,      9,      471},
	{   123,      9,      479},
	{   124,     10,      975},
	{   125,     10,      992},
	{   126,     10,     1007},
	{   127,     11,     2022},
	{   128,     11,     2040},
	{   129,     12,     4090},
	{   130,     10,     1003},
	{   131,      9,      477},
	{   132,      9,      467},
	{   133,      9,      473},
	{   134,      9,      475},
	{   135,     10,      978},
	{   136,     10,      972},
	{   137,     10,      988},
	{   138,     10,     1002},
	{   139,     11,     2029},
	{   140,     11,     2035},
	{   141,     11,     2041},
	{   142,     12,     4089},
	{   143,     11,     2034},
	{   144,     10,      974},
	{   145,      9,      484},
	{   146,     10,      971},
	{   147,     10,      984},
	{   148,     10,      982},
	{   149,     10,      994},
	{   150,     10,      997},
	{   151,     11,     2024},
	{   152,     11,     2036},
	{   153,     11,     2037},
	{   154,     11,     2039},
	{   155,     12,     4091},
	{   156,     11,     2042},
	{   157,     10,     1004},
	{   158,     10,      991},
	{   159,     10,      993},
	{   160,     10,      996},
	{   161,     10,      998},
	{   162,     10,     1008},
	{   163,     11,     2025},
	{   164,     11,     2031},
	{   165,     12,     4088},
	{   166,     12,     4094},
	{   167,     12,     4092},
	{   168,     12,     4095}

################################################################################

TITLE
    Huffman book11

TYPE
    32

DATA
	{     0,      4,        0},
	{     1,      5,        6},
	{     2,      6,       25},
	{     3,      7,       61},
	{     4,      8,      156},
	{     5,      8,      198},
	{     6,      9,      423},
	{     7,     10,      912},
	{     8,     10,      962},
	{     9,     10,      991},
	{    10,     11,     2022},
	{    11,     11,     2035},
	{    12,     12,     4091},
	{    13,     11,     2028},
	{    14,     12,     4090},
	{    15,     12,     4094},
	{    16,     10,      910},
	{    17,      5,        5},
	{    18,      4,        1},
	{    19,      5,        8},
	{    20,      6,       20},
	{    21,      7,       55},
	{    22,      7,       66},
	{    23,      8,      146},
	{    24,      8,      175},
	{    25,      9,      401},
	{    26,      9,      421},
	{    27,      9,      437},
	{    28,     10,      926},
	{    29,     10,      960},
	{    30,     10,      930},
	{    31,     10,      973},
	{    32,     11,     2006},
	{    33,      8,      174},
	{    34,      6,       23},
	{    35,      5,        7},
	{    36,      5,        9},
	{    37,      6,       24},
	{    38,      7,       57},
	{    39,      7,       64},
	{    40,      8,      142},
	{    41,      8,      163},
	{    42,      8,      184},
	{    43,      9,      409},
	{    44,      9,      428},
	{    45,      9,      449},
	{    46,     10,      945},
	{    47,     10,      918},
	{    48,     10,      958},
	{    49,     10,      970},
	{    50,      8,      157},
	{    51,      7,       60},
	{    52,      6,       21},
	{    53,      6,       22},
	{    54,      6,       26},
	{    55,      7,       59},
	{    56,      7,       68},
	{    57,      8,      145},
	{    58,      8,      165},
	{    59,      8,      190},
	{    60,      9,      406},
	{    61,      9,      430},
	{    62,      9,      441},
	{    63,     10,      929},
	{    64,     10,      913},
	{    65,     10,      933},
	{    66,     10,      981},
	{    67,      8,      148},
	{    68,      8,      154},
	{    69,      7,       54},
	{    70,      7,       56},
	{    71,      7,       58},
	{    72,      7,       65},
	{    73,      8,      140},
	{    74,      8,      155},
	{    75,      8,      176},
	{    76,      8,      195},
	{    77,      9,      414},
	{    78,      9,      427},
	{    79,      9,      444},
	{    80,     10,      927},
	{    81,     10,      911},
	{    82,     10,      937},
	{    83,     10,      975},
	{    84,      8,      147},
	{    85,      8,      191},
	{    86,      7,       62},
	{    87,      7,       63},
	{    88,      7,       67},
	{    89,      7,       69},
	{    90,      8,      158},
	{    91,      8,      167},
	{    92,      8,      185},
	{    93,      9,      404},
	{    94,      9,      418},
	{    95,      9,      442},
	{    96,      9,      451},
	{    97,     10,      934},
	{    98,     10,      935},
	{    99,     10,      955},
	{   100,     10,      980},
	{   101,      8,      159},
	{   102,      9,      416},
	{   103,      8,      143},
	{   104,      8,      141},
	{   105,      8,      144},
	{   106,      8,      152},
	{   107,      8,      166},
	{   108,      8,      182},
	{   109,      8,      196},
	{   110,      9,      415},
	{   111,      9,      431},
	{   112,      9,      447},
	{   113,     10,      921},
	{   114,     10,      959},
	{   115,     10,      948},
	{   116,     10,      969},
	{   117,     10,      999},
	{   118,      8,      168},
	{   119,      9,      438},
	{   120,      8,      171},
	{   121,      8,      164},
	{   122,      8,      170},
	{   123,      8,      178},
	{   124,      8,      194},
	{   125,      8,      197},
	{   126,      9,      408},
	{   127,      9,      420},
	{   128,      9,      440},
	{   129,     10,      908},
	{   130,     10,      932},
	{   131,     10,      964},
	{   132,     10,      966},
	{   133,     10,      989},
	{   134,     10,     1000},
	{   135,      8,      173},
	{   136,     10,      943},
	{   137,      9,      402},
	{   138,      8,      189},
	{   139,      8,      188},
	{   140,      9,      398},
	{   141,      9,      407},
	{   142,      9,      410},
	{   143,      9,      419},
	{   144,      9,      433},
	{   145,     10,      909},
	{   146,     10,      920},
	{   147,     10,      951},
	{   148,     10,      979},
	{   149,     10,      977},
	{   150,     10,      987},
	{   151,     11,     2013},
	{   152,      8,      180},
	{   153,     10,      990},
	{   154,      9,      425},
	{   155,      9,      411},
	{   156,      9,      412},
	{   157,      9,      417},
	{   158,      9,      426},
	{   159,      9,      429},
	{   160,      9,      435},
	{   161,     10,      907},
	{   162,     10,      946},
	{   163,     10,      952},
	{   164,     10,      974},
	{   165,     10,      993},
	{   166,     10,      992},
	{   167,     11,     2002},
	{   168,     11,     2021},
	{   169,      8,      183},
	{   170,     11,     2019},
	{   171,      9,      443},
	{   172,      9,      424},
	{   173,      9,      422},
	{   174,      9,      432},
	{   175,      9,      434},
	{   176,      9,      439},
	{   177,     10,      923},
	{   178,     10,      922},
	{   179,     10,      954},
	{   180,     10,      949},
	{   181,     10,      982},
	{   182,     11,     2007},
	{   183,     10,      996},
	{   184,     11,     2008},
	{   185,     11,     2026},
	{   186,      8,      186},
	{   187,     11,     2024},
	{   188,     10,      928},
	{   189,      9,      445},
	{   190,      9,      436},
	{   191,     10,      906},
	{   192,      9,      452},
	{   193,     10,      914},
	{   194,     10,      938},
	{   195,     10,      944},
	{   196,     10,      956},
	{   197,     10,      983},
	{   198,     11,     2004},
	{   199,     11,     2012},
	{   200,     11,     2011},
	{   201,     11,     2005},
	{   202,     11,     2032},
	{   203,      8,      193},
	{   204,     11,     2043},
	{   205,     10,      968},
	{   206,     10,      931},
	{   207,     10,      917},
	{   208,     10,      925},
	{   209,     10,      940},
	{   210,     10,      942},
	{   211,     10,      965},
	{   212,     10,      984},
	{   213,     10,      994},
	{   214,     10,      998},
	{   215,     11,     2020},
	{   216,     11,     2023},
	{   217,     11,     2016},
	{   218,     11,     2025},
	{   219,     11,     2039},
	{   220,      9,      400},
	{   221,     11,     2034},
	{   222,     10,      915},
	{   223,      9,      446},
	{   224,      9,      448},
	{   225,     10,      916},
	{   226,     10,      919},
	{   227,     10,      941},
	{   228,     10,      963},
	{   229,     10,      961},
	{   230,     10,      978},
	{   231,     11,     2010},
	{   232,     11,     2009},
	{   233,     11,     2015},
	{   234,     11,     2027},
	{   235,     11,     2036},
	{   236,     11,     2042},
	{   237,      9,      405},
	{   238,     11,     2040},
	{   239,     10,      957},
	{   240,     10,      924},
	{   241,     10,      939},
	{   242,     10,      936},
	{   243,     10,      947},
	{   244,     10,      953},
	{   245,     10,      976},
	{   246,     10,      995},
	{   247,     10,      997},
	{   248,     11,     2018},
	{   249,     11,     2014},
	{   250,     11,     2029},
	{   251,     11,     2033},
	{   252,     11,     2041},
	{   253,     11,     2044},
	{   254,      9,      403},
	{   255,     12,     4093},
	{   256,     10,      988},
	{   257,     10,      950},
	{   258,     10,      967},
	{   259,     10,      972},
	{   260,     10,      971},
	{   261,     10,      985},
	{   262,     10,      986},
	{   263,     11,     2003},
	{   264,     11,     2017},
	{   265,     11,     2030},
	{   266,     11,     2031},
	{   267,     11,     2037},
	{   268,     11,     2038},
	{   269,     12,     4092},
	{   270,     12,     4095},
	{   271,      9,      413},
	{   272,      9,      450},
	{   273,      8,      181},
	{   274,      8,      161},
	{   275,      8,      150},
	{   276,      8,      151},
	{   277,      8,      149},
	{   278,      8,      153},
	{   279,      8,      160},
	{   280,      8,      162},
	{   281,      8,      172},
	{   282,      8,      169},
	{   283,      8,      177},
	{   284,      8,      179},
	{   285,      8,      187},
	{   286,      8,      192},
	{   287,      9,      399},
	{   288,      5,        4}

################################################################################

TITLE
    Huffman booksc1

TYPE
    32

DATA
	{     0,     18,   262120},
	{     1,     18,   262118},
	{     2,     18,   262119},
	{     3,     18,   262117},
	{     4,     19,   524277},
	{     5,     19,   524273},
	{     6,     19,   524269},
	{     7,     19,   524278},
	{     8,     19,   524270},
	{     9,     19,   524271},
	{    10,     19,   524272},
	{    11,     19,   524284},
	{    12,     19,   524285},
	{    13,     19,   524287},
	{    14,     19,   524286},
	{    15,     19,   524279},
	{    16,     19,   524280},
	{    17,     19,   524283},
	{    18,     19,   524281},
	{    19,     18,   262116},
	{    20,     19,   524282},
	{    21,     18,   262115},
	{    22,     17,   131055},
	{    23,     17,   131056},
	{    24,     16,    65525},
	{    25,     17,   131054},
	{    26,     16,    65522},
	{    27,     16,    65523},
	{    28,     16,    65524},
	{    29,     16,    65521},
	{    30,     15,    32758},
	{    31,     15,    32759},
	{    32,     14,    16377},
	{    33,     14,    16373},
	{    34,     14,    16375},
	{    35,     14,    16371},
	{    36,     14,    16374},
	{    37,     14,    16370},
	{    38,     13,     8183},
	{    39,     13,     8181},
	{    40,     12,     4089},
	{    41,     12,     4087},
	{    42,     12,     4086},
	{    43,     11,     2041},
	{    44,     12,     4084},
	{    45,     11,     2040},
	{    46,     10,     1017},
	{    47,     10,     1015},
	{    48,     10,     1013},
	{    49,      9,      504},
	{    50,      9,      503},
	{    51,      8,      250},
	{    52,      8,      248},
	{    53,      8,      246},
	{    54,      7,      121},
	{    55,      6,       58},
	{    56,      6,       56},
	{    57,      5,       26},
	{    58,      4,       11},
	{    59,      3,        4},
	{    60,      1,        0},
	{    61,      4,       10},
	{    62,      4,       12},
	{    63,      5,       27},
	{    64,      6,       57},
	{    65,      6,       59},
	{    66,      7,      120},
	{    67,      7,      122},
	{    68,      8,      247},
	{    69,      8,      249},
	{    70,      9,      502},
	{    71,      9,      505},
	{    72,     10,     1012},
	{    73,     10,     1014},
	{    74,     10,     1016},
	{    75,     11,     2037},
	{    76,     11,     2036},
	{    77,     11,     2038},
	{    78,     11,     2039},
	{    79,     12,     4085},
	{    80,     12,     4088},
	{    81,     13,     8180},
	{    82,     13,     8182},
	{    83,     13,     8184},
	{    84,     14,    16376},
	{    85,     14,    16372},
	{    86,     16,    65520},
	{    87,     15,    32756},
	{    88,     16,    65526},
	{    89,     15,    32757},
	{    90,     18,   262114},
	{    91,     19,   524249},
	{    92,     19,   524250},
	{    93,     19,   524251},
	{    94,     19,   524252},
	{    95,     19,   524253},
	{    96,     19,   524254},
	{    97,     19,   524248},
	{    98,     19,   524242},
	{    99,     19,   524243},
	{   100,     19,   524244},
	{   101,     19,   524245},
	{   102,     19,   524246},
	{   103,     19,   524274},
	{   104,     19,   524255},
	{   105,     19,   524263},
	{   106,     19,   524264},
	{   107,     19,   524265},
	{   108,     19,   524266},
	{   109,     19,   524267},
	{   110,     19,   524262},
	{   111,     19,   524256},
	{   112,     19,   524257},
	{   113,     19,   524258},
	{   114,     19,   524259},
	{   115,     19,   524260},
	{   116,     19,   524261},
	{   117,     19,   524247},
	{   118,     19,   524268},
	{   119,     19,   524276},
	{   120,     19,   524275}

################################################################################

TITLE
    Huffman bookRvlc

TYPE
    32

DATA
        {    -7,      7,       65},
        {    -6,      9,      257},
        {    -5,      8,      129},
        {    -4,      6,       33},
        {    -3,      5,       17},
        {    -2,      4,        9},
        {    -1,      3,        5},
        {     0,      1,        0},
        {     1,      3,        7},
        {     2,      5,       27},
        {     3,      6,       51},
        {     4,      7,      107},
        {     5,      8,      195},
        {     6,      9,      427},
        {     7,      7,       99}

################################################################################

TITLE
    Huffman bookEscape

TYPE
    32

DATA
  {     0,      2,        2},
  {     1,      2,        0},
  {     2,      3,        6},
  {     3,      3,        2},
  {     4,      4,       14},
  {     5,      5,       31},
  {     6,      5,       15},
  {     7,      5,       13},
  {     8,      6,       61},
  {     9,      6,       29},
  {    10,      6,       25},
  {    11,      6,       24},
  {    12,      7,      120},
  {    13,      7,       56},
  {    14,      8,      242},
  {    15,      8,      114},
  {    16,      9,      486},
  {    17,      9,      230},
  {    18,     10,      974},
  {    19,     10,      463},
  {    20,     11,     1950},
  {    21,     11,     1951},
  {    22,     11,      925},
  {    23,     12,     1848},
  {    24,     14,     7399},
  {    25,     13,     3698},
  {    26,     15,    14797},
  {    27,     20,   473482},
  {    28,     20,   473483},
  {    29,     20,   473484},
  {    30,     20,   473485},
  {    31,     20,   473486},
  {    32,     20,   473487},
  {    33,     20,   473488},
  {    34,     20,   473489},
  {    35,     20,   473490},
  {    36,     20,   473491},
  {    37,     20,   473492},
  {    38,     20,   473493},
  {    39,     20,   473494},
  {    40,     20,   473495},
  {    41,     20,   473496},
  {    42,     20,   473497},
  {    43,     20,   473498},
  {    44,     20,   473499},
  {    45,     20,   473500},
  {    46,     20,   473501},
  {    47,     20,   473502},
  {    48,     20,   473503},
  {    49,     19,   236736},
  {    50,     19,   236737},
  {    51,     19,   236738},
  {    52,     19,   236739},
  {    53,     19,   236740}

################################################################################

TITLE
    AAC escAssignment[MAX_ELEMENTS][NR_OF_ASSIGNMENT_SCHEMES]

TYPE
    16

DATA
    {3, 3, 3},  /* COEF_COMPRESS */
    {3, 3, 3},  /* COEF_RES */
    {9, 0, 0},  /* COMMON_WINDOW */
    {3, 3, 3},  /* DIRECTION */
    {1, 1, 1},  /* DPCM_NOISE_LAST_POSITION */
    {1, 1, 1},  /* DPCM_NOISE_NRG */
    {1, 0, 0},  /* ELEMENT_INSTANCE_TAG */
    {1, 1, 1},  /* GAIN_CONTROL_DATA_PRESENT */
    {1, 1, 1},  /* GLOBAL_GAIN */
    {4, 4, 4},  /* HCOD */
    {4, 4, 4},  /* HCOD_ESC */
    {1, 1, 1},  /* HCOD_SF */
    {1, 1, 0},  /* ICS_RESERVED */
    {3, 3, 3},  /* LENGTH */
    {1, 1, 1},  /* LENGTH_OF_LONGEST_CODEWORD */
    {1, 1, 1},  /* LENGTH_OF_REORDERED_SPECTRAL_DATA */
    {1, 1, 1},  /* LENGTH_OF_RVLC_ESCAPES */
    {1, 1, 1},  /* LENGTH_OF_RVLC_SF */
    {1, 1, 1},  /* LTP_COEF */
    {1, 1, 0},  /* LTP_DATA_PRESENT */
    {1, 1, 1},  /* LTP_LAG */
    {1, 1, 1},  /* LTP_LAG_UPDATE */
    {1, 1, 1},  /* LTP_LONG_USED */
    {1, 1, 1},  /* LTP_SHORT_LAG */
    {1, 1, 1},  /* LTP_SHORT_LAG_PRESENT */
    {1, 1, 1},  /* LTP_SHORT_USED */
    {1, 1, 0},  /* MAX_SFB */
    {9, 0, 0},  /* MS_MASK_PRESENT */
    {9, 0, 0},  /* MS_USED */
    {3, 3, 3},  /* N_FILT */
    {1, 1, 1},  /* NUMBER_PULSE */
    {3, 3, 3},  /* ORDER */
    {1, 1, 0},  /* PREDICTOR_DATA_PRESENT */
    {1, 1, 1},  /* PULSE_AMP */
    {1, 1, 1},  /* PULSE_DATA_PRESENT */
    {1, 1, 1},  /* PULSE_OFFSET */
    {1, 1, 1},  /* PULSE_START_SFB */
    {4, 4, 4},  /* REORDERED_SPECTRAL_DATA */
    {1, 1, 1},  /* REV_GLOBAL_GAIN */
    {2, 2, 2},  /* RVLC_CODE_SF */
    {2, 2, 2},  /* RVLC_ESC_SF */
    {1, 1, 0},  /* SCALE_FACTOR_GROUPING */
    {1, 1, 1},  /* SECT_CB */
    {1, 1, 1},  /* SECT_LEN_INCR */
    {1, 1, 1},  /* SF_CONCEALMENT */
    {1, 1, 1},  /* SF_ESCAPES_PRESENT */
    {4, 4, 4},  /* SIGN_BITS */
    {1, 1, 1},  /* TNS_DATA_PRESENT */
    {1, 1, 0},  /* WINDOW_SEQ */
    {1, 1, 0},  /* WINDOW_SHAPE_CODE */
    {4, 4, 4}}; /* ALIGN_BITS */

################################################################################

TITLE
    Dolby window dol_long

TYPE
    FLOAT

DATA
    0.00029256153896361,
    0.00042998567353047,
    0.00054674074589540,
    0.00065482304299792,
    0.00075870195068747,
    0.00086059331713336,
    0.00096177541439010,
    0.0010630609410878,
    0.0011650036308132,
    0.0012680012194148,
    0.0013723517232956,
    0.0014782864109136,
    0.0015859901976719,
    0.0016956148252373,
    0.0018072876903517,
    0.0019211179405514,
    0.0020372007924215,
    0.0021556206591754,
    0.0022764534599614,
    0.0023997683540995,
    0.0025256290631156,
    0.0026540948920831,
    0.0027852215281403,
    0.0029190616715331,
    0.0030556655443223,
    0.0031950812943391,
    0.0033373553240392,
    0.0034825325586930,
    0.0036306566699199,
    0.0037817702604646,
    0.0039359150179719,
    0.0040931318437260,
    0.0042534609610026,
    0.0044169420066964,
    0.0045836141091341,
    0.0047535159544086,
    0.0049266858431214,
    0.0051031617390698,
    0.0052829813111335,
    0.0054661819693975,
    0.0056528008963682,
    0.0058428750739943,
    0.0060364413070882,
    0.0062335362436492,
    0.0064341963925079,
    0.0066384581386503,
    0.0068463577565218,
    0.0070579314215715,
    0.0072732152202559,
    0.0074922451586909,
    0.0077150571701162,
    0.0079416871213115,
    0.0081721708180857,
    0.0084065440099458,
    0.0086448423940363,
    0.0088871016184291,
    0.0091333572848345,
    0.0093836449507939,
    0.0096380001314086,
    0.0098964583006517,
    0.010159054892306,
    0.010425825300561,
    0.010696804880310,
    0.010972028947167,
    0.011251532777236,
    0.011535351606646,
    0.011823520630897,
    0.012116075003993,
    0.012413049837429,
    0.012714480198999,
    0.013020401111478,
    0.013330847551161,
    0.013645854446288,
    0.013965456675352,
    0.014289689065314,
    0.014618586389712,
    0.014952183366697,
    0.015290514656976,
    0.015633614861688,
    0.015981518520214,
    0.016334260107915,
    0.016691874033817,
    0.017054394638241,
    0.017421856190380,
    0.017794292885832,
    0.018171738844085,
    0.018554228105962,
    0.018941794631032,
    0.019334472294980,
    0.019732294886947,
    0.020135296106839,
    0.020543509562604,
    0.020956968767488,
    0.021375707137257,
    0.021799757987407,
    0.022229154530343,
    0.022663929872540,
    0.023104117011689,
    0.023549748833816,
    0.024000858110398,
    0.024457477495451,
    0.024919639522613,
    0.025387376602207,
    0.025860721018295,
    0.026339704925726,
    0.026824360347160,
    0.027314719170100,
    0.027810813143900,
    0.028312673876775,
    0.028820332832801,
    0.029333821328905,
    0.029853170531859,
    0.030378411455255,
    0.030909574956490,
    0.031446691733739,
    0.031989792322926,
    0.032538907094693,
    0.033094066251369,
    0.033655299823935,
    0.034222637668991,
    0.034796109465717,
    0.035375744712844,
    0.035961572725616,
    0.036553622632758,
    0.037151923373446,
    0.037756503694277,
    0.038367392146243,
    0.038984617081711,
    0.039608206651398,
    0.040238188801359,
    0.040874591269976,
    0.041517441584950,
    0.042166767060301,
    0.042822594793376,
    0.043484951661852,
    0.044153864320760,
    0.044829359199509,
    0.045511462498913,
    0.046200200188234,
    0.046895598002228,
    0.047597681438201,
    0.048306475753074,
    0.049022005960455,
    0.049744296827725,
    0.050473372873129,
    0.051209258362879,
    0.051951977308273,
    0.052701553462813,
    0.053458010319350,
    0.054221371107223,
    0.054991658789428,
    0.055768896059787,
    0.056553105340134,
    0.057344308777513,
    0.058142528241393,
    0.058947785320893,
    0.059760101322019,
    0.060579497264926,
    0.061405993881180,
    0.062239611611049,
    0.063080370600799,
    0.063928290700012,
    0.064783391458919,
    0.065645692125747,
    0.066515211644086,
    0.067391968650269,
    0.068275981470777,
    0.069167268119652,
    0.070065846295935,
    0.070971733381121,
    0.071884946436630,
    0.072805502201299,
    0.073733417088896,
    0.074668707185649,
    0.075611388247794,
    0.076561475699152,
    0.077518984628715,
    0.078483929788261,
    0.079456325589986,
    0.080436186104162,
    0.081423525056808,
    0.082418355827392,
    0.083420691446553,
    0.084430544593841,
    0.085447927595483,
    0.086472852422178,
    0.087505330686900,
    0.088545373642744,
    0.089592992180780,
    0.090648196827937,
    0.091710997744919,
    0.092781404724131,
    0.093859427187640,
    0.094945074185163,
    0.096038354392069,
    0.097139276107423,
    0.098247847252041,
    0.099364075366580,
    0.10048796760965,
    0.10161953075597,
    0.10275877119451,
    0.10390569492671,
    0.10506030756469,
    0.10622261432949,
    0.10739262004941,
    0.10857032915821,
    0.10975574569357,
    0.11094887329534,
    0.11214971520402,
    0.11335827425914,
    0.11457455289772,
    0.11579855315274,
    0.11703027665170,
    0.11826972461510,
    0.11951689785504,
    0.12077179677383,
    0.12203442136263,
    0.12330477120008,
    0.12458284545102,
    0.12586864286523,
    0.12716216177615,
    0.12846340009971,
    0.12977235533312,
    0.13108902455375,
    0.13241340441801,
    0.13374549116025,
    0.13508528059173,
    0.13643276809961,
    0.13778794864595,
    0.13915081676677,
    0.14052136657114,
    0.14189959174027,
    0.14328548552671,
    0.14467904075349,
    0.14608024981336,
    0.14748910466804,
    0.14890559684750,
    0.15032971744929,
    0.15176145713790,
    0.15320080614414,
    0.15464775426459,
    0.15610229086100,
    0.15756440485987,
    0.15903408475193,
    0.16051131859170,
    0.16199609399712,
    0.16348839814917,
    0.16498821779156,
    0.16649553923042,
    0.16801034833404,
    0.16953263053270,
    0.17106237081842,
    0.17259955374484,
    0.17414416342714,
    0.17569618354193,
    0.17725559732720,
    0.17882238758238,
    0.18039653666830,
    0.18197802650733,
    0.18356683858343,
    0.18516295394233,
    0.18676635319174,
    0.18837701650148,
    0.18999492360384,
    0.19162005379380,
    0.19325238592940,
    0.19489189843209,
    0.19653856928714,
    0.19819237604409,
    0.19985329581721,
    0.20152130528605,
    0.20319638069594,
    0.20487849785865,
    0.20656763215298,
    0.20826375852540,
    0.20996685149083,
    0.21167688513330,
    0.21339383310678,
    0.21511766863598,
    0.21684836451719,
    0.21858589311922,
    0.22033022638425,
    0.22208133582887,
    0.22383919254503,
    0.22560376720111,
    0.22737503004300,
    0.22915295089517,
    0.23093749916189,
    0.23272864382838,
    0.23452635346201,
    0.23633059621364,
    0.23814133981883,
    0.23995855159925,
    0.24178219846403,
    0.24361224691114,
    0.24544866302890,
    0.24729141249740,
    0.24914046059007,
    0.25099577217522,
    0.25285731171763,
    0.25472504328019,
    0.25659893052556,
    0.25847893671788,
    0.26036502472451,
    0.26225715701781,
    0.26415529567692,
    0.26605940238966,
    0.26796943845439,
    0.26988536478190,
    0.27180714189742,
    0.27373472994256,
    0.27566808867736,
    0.27760717748238,
    0.27955195536071,
    0.28150238094021,
    0.28345841247557,
    0.28542000785059,
    0.28738712458038,
    0.28935971981364,
    0.29133775033492,
    0.29332117256704,
    0.29530994257338,
    0.29730401606034,
    0.29930334837974,
    0.30130789453132,
    0.30331760916521,
    0.30533244658452,
    0.30735236074785,
    0.30937730527195,
    0.31140723343430,
    0.31344209817583,
    0.31548185210356,
    0.31752644749341,
    0.31957583629288,
    0.32162997012390,
    0.32368880028565,
    0.32575227775738,
    0.32782035320134,
    0.32989297696566,
    0.33197009908736,
    0.33405166929523,
    0.33613763701295,
    0.33822795136203,
    0.34032256116495,
    0.34242141494820,
    0.34452446094547,
    0.34663164710072,
    0.34874292107143,
    0.35085823023181,
    0.35297752167598,
    0.35510074222129,
    0.35722783841160,
    0.35935875652060,
    0.36149344255514,
    0.36363184225864,
    0.36577390111444,
    0.36791956434930,
    0.37006877693676,
    0.37222148360070,
    0.37437762881878,
    0.37653715682603,
    0.37870001161834,
    0.38086613695607,
    0.38303547636766,
    0.38520797315322,
    0.38738357038821,
    0.38956221092708,
    0.39174383740701,
    0.39392839225157,
    0.39611581767449,
    0.39830605568342,
    0.40049904808370,
    0.40269473648218,
    0.40489306229101,
    0.40709396673153,
    0.40929739083810,
    0.41150327546197,
    0.41371156127524,
    0.41592218877472,
    0.41813509828594,
    0.42035022996702,
    0.42256752381274,
    0.42478691965848,
    0.42700835718423,
    0.42923177591866,
    0.43145711524314,
    0.43368431439580,
    0.43591331247564,
    0.43814404844658,
    0.44037646114161,
    0.44261048926688,
    0.44484607140589,
    0.44708314602359,
    0.44932165147057,
    0.45156152598727,
    0.45380270770813,
    0.45604513466581,
    0.45828874479543,
    0.46053347593880,
    0.46277926584861,
    0.46502605219277,
    0.46727377255861,
    0.46952236445718,
    0.47177176532752,
    0.47402191254100,
    0.47627274340557,
    0.47852419517009,
    0.48077620502869,
    0.48302871012505,
    0.48528164755674,
    0.48753495437962,
    0.48978856761212,
    0.49204242423966,
    0.49429646121898,
    0.49655061548250,
    0.49880482394273,
    0.50105902349665,
    0.50331315103004,
    0.50556714342194,
    0.50782093754901,
    0.51007447028990,
    0.51232767852971,
    0.51458049916433,
    0.51683286910489,
    0.51908472528213,
    0.52133600465083,
    0.52358664419420,
    0.52583658092832,
    0.52808575190648,
    0.53033409422367,
    0.53258154502092,
    0.53482804148974,
    0.53707352087652,
    0.53931792048690,
    0.54156117769021,
    0.54380322992385,
    0.54604401469766,
    0.54828346959835,
    0.55052153229384,
    0.55275814053768,
    0.55499323217338,
    0.55722674513883,
    0.55945861747062,
    0.56168878730842,
    0.56391719289930,
    0.56614377260214,
    0.56836846489188,
    0.57059120836390,
    0.57281194173835,
    0.57503060386439,
    0.57724713372458,
    0.57946147043912,
    0.58167355327012,
    0.58388332162591,
    0.58609071506528,
    0.58829567330173,
    0.59049813620770,
    0.59269804381879,
    0.59489533633802,
    0.59708995413996,
    0.59928183777495,
    0.60147092797329,
    0.60365716564937,
    0.60584049190582,
    0.60802084803764,
    0.61019817553632,
    0.61237241609393,
    0.61454351160718,
    0.61671140418155,
    0.61887603613527,
    0.62103735000336,
    0.62319528854167,
    0.62534979473088,
    0.62750081178042,
    0.62964828313250,
    0.63179215246597,
    0.63393236370030,
    0.63606886099946,
    0.63820158877577,
    0.64033049169379,
    0.64245551467413,
    0.64457660289729,
    0.64669370180740,
    0.64880675711607,
    0.65091571480603,
    0.65302052113494,
    0.65512112263906,
    0.65721746613689,
    0.65930949873289,
    0.66139716782102,
    0.66348042108842,
    0.66555920651892,
    0.66763347239664,
    0.66970316730947,
    0.67176824015260,
    0.67382864013196,
    0.67588431676768,
    0.67793521989751,
    0.67998129968017,
    0.68202250659876,
    0.68405879146403,
    0.68609010541774,
    0.68811639993588,
    0.69013762683195,
    0.69215373826012,
    0.69416468671849,
    0.69617042505214,
    0.69817090645634,
    0.70016608447958,
    0.70215591302664,
    0.70414034636163,
    0.70611933911096,
    0.70809284626630,
    0.71006082318751,
    0.71202322560554,
    0.71398000962530,
    0.71593113172842,
    0.71787654877613,
    0.71981621801195,
    0.72175009706445,
    0.72367814394990,
    0.72560031707496,
    0.72751657523927,
    0.72942687763803,
    0.73133118386457,
    0.73322945391280,
    0.73512164817975,
    0.73700772746796,
    0.73888765298787,
    0.74076138636020,
    0.74262888961827,
    0.74449012521027,
    0.74634505600152,
    0.74819364527663,
    0.75003585674175,
    0.75187165452661,
    0.75370100318668,
    0.75552386770515,
    0.75734021349500,
    0.75915000640095,
    0.76095321270137,
    0.76274979911019,
    0.76453973277875,
    0.76632298129757,
    0.76809951269819,
    0.76986929545481,
    0.77163229848604,
    0.77338849115651,
    0.77513784327849,
    0.77688032511340,
    0.77861590737340,
    0.78034456122283,
    0.78206625827961,
    0.78378097061667,
    0.78548867076330,
    0.78718933170643,
    0.78888292689189,
    0.79056943022564,
    0.79224881607494,
    0.79392105926949,
    0.79558613510249,
    0.79724401933170,
    0.79889468818046,
    0.80053811833858,
    0.80217428696334,
    0.80380317168028,
    0.80542475058405,
    0.80703900223920,
    0.80864590568089,
    0.81024544041560,
    0.81183758642175,
    0.81342232415032,
    0.81499963452540,
    0.81656949894467,
    0.81813189927991,
    0.81968681787738,
    0.82123423755821,
    0.82277414161874,
    0.82430651383076,
    0.82583133844180,
    0.82734860017528,
    0.82885828423070,
    0.83036037628369,
    0.83185486248609,
    0.83334172946597,
    0.83482096432759,
    0.83629255465130,
    0.83775648849344,
    0.83921275438615,
    0.84066134133716,
    0.84210223882952,
    0.84353543682130,
    0.84496092574524,
    0.84637869650833,
    0.84778874049138,
    0.84919104954855,
    0.85058561600677,
    0.85197243266520,
    0.85335149279457,
    0.85472279013653,
    0.85608631890295,
    0.85744207377513,
    0.85879004990298,
    0.86013024290422,
    0.86146264886346,
    0.86278726433124,
    0.86410408632306,
    0.86541311231838,
    0.86671434025950,
    0.86800776855046,
    0.86929339605590,
    0.87057122209981,
    0.87184124646433,
    0.87310346938840,
    0.87435789156650,
    0.87560451414719,
    0.87684333873173,
    0.87807436737261,
    0.87929760257204,
    0.88051304728038,
    0.88172070489456,
    0.88292057925645,
    0.88411267465117,
    0.88529699580537,
    0.88647354788545,
    0.88764233649580,
    0.88880336767692,
    0.88995664790351,
    0.89110218408260,
    0.89223998355154,
    0.89337005407600,
    0.89449240384793,
    0.89560704148345,
    0.89671397602074,
    0.89781321691786,
    0.89890477405053,
    0.89998865770993,
    0.90106487860034,
    0.90213344783689,
    0.90319437694315,
    0.90424767784873,
    0.90529336288690,
    0.90633144479201,
    0.90736193669708,
    0.90838485213119,
    0.90940020501694,
    0.91040800966776,
    0.91140828078533,
    0.91240103345685,
    0.91338628315231,
    0.91436404572173,
    0.91533433739238,
    0.91629717476594,
    0.91725257481564,
    0.91820055488334,
    0.91914113267664,
    0.92007432626589,
    0.92100015408120,
    0.92191863490944,
    0.92282978789113,
    0.92373363251740,
    0.92463018862687,
    0.92551947640245,
    0.92640151636824,
    0.92727632938624,
    0.92814393665320,
    0.92900435969727,
    0.92985762037477,
    0.93070374086684,
    0.93154274367610,
    0.93237465162328,
    0.93319948784382,
    0.93401727578443,
    0.93482803919967,
    0.93563180214841,
    0.93642858899043,
    0.93721842438279,
    0.93800133327637,
    0.93877734091223,
    0.93954647281807,
    0.94030875480458,
    0.94106421296182,
    0.94181287365556,
    0.94255476352362,
    0.94328990947213,
    0.94401833867184,
    0.94474007855439,
    0.94545515680855,
    0.94616360137644,
    0.94686544044975,
    0.94756070246592,
    0.94824941610434,
    0.94893161028248,
    0.94960731415209,
    0.95027655709525,
    0.95093936872056,
    0.95159577885924,
    0.95224581756115,
    0.95288951509097,
    0.95352690192417,
    0.95415800874314,
    0.95478286643320,
    0.95540150607863,
    0.95601395895871,
    0.95662025654373,
    0.95722043049100,
    0.95781451264084,
    0.95840253501260,
    0.95898452980058,
    0.95956052937008,
    0.96013056625336,
    0.96069467314557,
    0.96125288290073,
    0.96180522852773,
    0.96235174318622,
    0.96289246018262,
    0.96342741296604,
    0.96395663512424,
    0.96448016037959,
    0.96499802258499,
    0.96551025571985,
    0.96601689388602,
    0.96651797130376,
    0.96701352230768,
    0.96750358134269,
    0.96798818295998,
    0.96846736181297,
    0.96894115265327,
    0.96940959032667,
    0.96987270976912,
    0.97033054600270,
    0.97078313413161,
    0.97123050933818,
    0.97167270687887,
    0.97210976208030,
    0.97254171033525,
    0.97296858709871,
    0.97339042788392,
    0.97380726825843,
    0.97421914384017,
    0.97462609029350,
    0.97502814332534,
    0.97542533868127,
    0.97581771214160,
    0.97620529951759,
    0.97658813664749,
    0.97696625939282,
    0.97733970363445,
    0.97770850526884,
    0.97807270020427,
    0.97843232435704,
    0.97878741364771,
    0.97913800399743,
    0.97948413132414,
    0.97982583153895,
    0.98016314054243,
    0.98049609422096,
    0.98082472844313,
    0.98114907905608,
    0.98146918188197,
    0.98178507271438,
    0.98209678731477,
    0.98240436140902,
    0.98270783068385,
    0.98300723078342,
    0.98330259730589,
    0.98359396579995,
    0.98388137176152,
    0.98416485063031,
    0.98444443778651,
    0.98472016854752,
    0.98499207816463,
    0.98526020181980,
    0.98552457462240,
    0.98578523160609,
    0.98604220772560,
    0.98629553785362,
    0.98654525677772,
    0.98679139919726,
    0.98703399972035,
    0.98727309286089,
    0.98750871303556,
    0.98774089456089,
    0.98796967165036,
    0.98819507841154,
    0.98841714884323,
    0.98863591683269,
    0.98885141615285,
    0.98906368045957,
    0.98927274328896,
    0.98947863805473,
    0.98968139804554,
    0.98988105642241,
    0.99007764621618,
    0.99027120032501,
    0.99046175151186,
    0.99064933240208,
    0.99083397548099,
    0.99101571309153,
    0.99119457743191,
    0.99137060055337,
    0.99154381435784,
    0.99171425059582,
    0.99188194086414,
    0.99204691660388,
    0.99220920909823,
    0.99236884947045,
    0.99252586868186,
    0.99268029752989,
    0.99283216664606,
    0.99298150649419,
    0.99312834736847,
    0.99327271939167,
    0.99341465251338,
    0.99355417650825,
    0.99369132097430,
    0.99382611533130,
    0.99395858881910,
    0.99408877049612,
    0.99421668923778,
    0.99434237373503,
    0.99446585249289,
    0.99458715382906,
    0.99470630587254,
    0.99482333656229,
    0.99493827364600,
    0.99505114467878,
    0.99516197702200,
    0.99527079784214,
    0.99537763410962,
    0.99548251259777,
    0.99558545988178,
    0.99568650233767,
    0.99578566614138,
    0.99588297726783,
    0.99597846149005,
    0.99607214437834,
    0.99616405129947,
    0.99625420741595,
    0.99634263768527,
    0.99642936685928,
    0.99651441948352,
    0.99659781989663,
    0.99667959222978,
    0.99675976040620,
    0.99683834814063,
    0.99691537893895,
    0.99699087609774,
    0.99706486270391,
    0.99713736163442,
    0.99720839555593,
    0.99727798692461,
    0.99734615798589,
    0.99741293077431,
    0.99747832711337,
    0.99754236861541,
    0.99760507668158,
    0.99766647250181,
    0.99772657705478,
    0.99778541110799,
    0.99784299521785,
    0.99789934972976,
    0.99795449477828,
    0.99800845028730,
    0.99806123597027,
    0.99811287133042,
    0.99816337566108,
    0.99821276804596,
    0.99826106735952,
    0.99830829226732,
    0.99835446122649,
    0.99839959248609,
    0.99844370408765,
    0.99848681386566,
    0.99852893944805,
    0.99857009825685,
    0.99861030750869,
    0.99864958421549,
    0.99868794518504,
    0.99872540702178,
    0.99876198612738,
    0.99879769870160,
    0.99883256074295,
    0.99886658804953,
    0.99889979621983,
    0.99893220065356,
    0.99896381655254,
    0.99899465892154,
    0.99902474256924,
    0.99905408210916,
    0.99908269196056,
    0.99911058634952,
    0.99913777930986,
    0.99916428468421,
    0.99919011612505,
    0.99921528709576,
    0.99923981087174,
    0.99926370054150,
    0.99928696900779,
    0.99930962898876,
    0.99933169301910,
    0.99935317345126,
    0.99937408245662,
    0.99939443202674,
    0.99941423397457,
    0.99943349993572,
    0.99945224136972,
    0.99947046956130,
    0.99948819562171,
    0.99950543049000,
    0.99952218493439,
    0.99953846955355,
    0.99955429477803,
    0.99956967087154,
    0.99958460793242,
    0.99959911589494,
    0.99961320453077,
    0.99962688345035,
    0.99964016210433,
    0.99965304978499,
    0.99966555562769,
    0.99967768861231,
    0.99968945756473,
    0.99970087115825,
    0.99971193791510,
    0.99972266620792,
    0.99973306426121,
    0.99974314015288,
    0.99975290181568,
    0.99976235703876,
    0.99977151346914,
    0.99978037861326,
    0.99978895983845,
    0.99979726437448,
    0.99980529931507,
    0.99981307161943,
    0.99982058811377,
    0.99982785549283,
    0.99983488032144,
    0.99984166903600,
    0.99984822794606,
    0.99985456323584,
    0.99986068096572,
    0.99986658707386,
    0.99987228737764,
    0.99987778757524,
    0.99988309324717,
    0.99988820985777,
    0.99989314275675,
    0.99989789718072,
    0.99990247825468,
    0.99990689099357,
    0.99991114030376,
    0.99991523098456,
    0.99991916772971,
    0.99992295512891,
    0.99992659766930,
    0.99993009973692,
    0.99993346561824,
    0.99993669950161,
    0.99993980547870,
    0.99994278754604,
    0.99994564960642,
    0.99994839547033,
    0.99995102885747,
    0.99995355339809,
    0.99995597263451,
    0.99995829002249,
    0.99996050893264,
    0.99996263265183,
    0.99996466438460,
    0.99996660725452,
    0.99996846430558,
    0.99997023850356,
    0.99997193273736,
    0.99997354982037,
    0.99997509249183,
    0.99997656341810,
    0.99997796519400,
    0.99997930034415,
    0.99998057132421,
    0.99998178052220,
    0.99998293025975,
    0.99998402279338,
    0.99998506031574,
    0.99998604495686,
    0.99998697878536,
    0.99998786380966,
    0.99998870197921,
    0.99998949518567,
    0.99999024526408,
    0.99999095399401,
    0.99999162310077,
    0.99999225425649,
    0.99999284908128,
    0.99999340914435,
    0.99999393596510,
    0.99999443101421,
    0.99999489571473,
    0.99999533144314,
    0.99999573953040,
    0.99999612126300,
    0.99999647788395,
    0.99999681059383,
    0.99999712055178,
    0.99999740887647,
    0.99999767664709,
    0.99999792490431,
    0.99999815465123,
    0.99999836685427,
    0.99999856244415,
    0.99999874231676,
    0.99999890733405,
    0.99999905832493,
    0.99999919608613,
    0.99999932138304,
    0.99999943495056,
    0.99999953749392,
    0.99999962968950,
    0.99999971218563,
    0.99999978560337,
    0.99999985053727,
    0.99999990755616,
    0.99999995720387

################################################################################

TITLE
    Dolby window dol_short

TYPE
    FLOAT

DATA
    4.3795702929468881e-005,
    0.00011867384265436617,
    0.0002307165763996192,
    0.00038947282760568383,
    0.00060581272288302553,
    0.00089199695169487453,
    0.0012617254423430522,
    0.0017301724373162003,
    0.0023140071937421476,
    0.0030313989666022221,
    0.0039020049735530842,
    0.0049469401815512024,
    0.0061887279335368318,
    0.0076512306364647726,
    0.0093595599562652423,
    0.011339966208377799,
    0.013619706891715299,
    0.016226894586323766,
    0.019190324717288168,
    0.022539283975960878,
    0.026303340480472455,
    0.030512117046644357,
    0.03519504922365594,
    0.040381130021856941,
    0.046098643518702249,
    0.052374889768730587,
    0.059235903660769147,
    0.066706170556282418,
    0.074808341703430481,
    0.083562952548726227,
    0.092988147159339674,
    0.1030994120216919,
    0.11390932249409955,
    0.12542730516149531,
    0.13765941926783826,
    0.15060816028651081,
    0.16427228853114245,
    0.17864668550988483,
    0.19372224048676889,
    0.20948576943658073,
    0.22591996826744942,
    0.24300340184133981,
    0.26071052995068139,
    0.27901177101369551,
    0.29787360383626599,
    0.3172587073594233,
    0.33712613787396362,
    0.35743154274286698,
    0.37812740923363009,
    0.39916334663203618,
    0.42048639939189658,
    0.4420413886774246,
    0.4637712792815169,
    0.4856175685594023,
    0.50752069370766872,
    0.52942045344797806,
    0.55125643994680196,
    0.57296847662071559,
    0.59449705734411495,
    0.61578378249506627,
    0.63677178724712891,
    0.65740615754163356,
    0.67763432925662526,
    0.69740646622548552,
    0.71667581294953808,
    0.73539901809352737,
    0.75353642514900732,
    0.77105232699609816,
    0.78791518148597028,
    0.80409778560147072,
    0.81957740622770781,
    0.83433586607383625,
    0.84835958382689225,
    0.86163956818294229,
    0.87417136598406997,
    0.88595496528524853,
    0.89699465477567619,
    0.90729884157670959,
    0.91687983002436779,
    0.92575356460899649,
    0.93393934077779084,
    0.94145948779657318,
    0.94833902830402828,
    0.95460531956280026,
    0.96028768170574896,
    0.96541701848104766,
    0.97002543610646474,
    0.97414586584250062,
    0.97781169577969584,
    0.98105641710392333,
    0.98391328975491177,
    0.98641503193166202,
    0.98859353733226141,
    0.99047962335771556,
    0.9921028127769449,
    0.99349115056397752,
    0.99467105680259038,
    0.9956672157341897,
    0.99650250022834352,
    0.99719793020823266,
    0.99777266288955657,
    0.99824401211201486,
    0.99862749357391212,
    0.99893689243401962,
    0.99918434952623147,
    0.99938046234161726,
    0.99953439696357238,
    0.99965400728430465,
    0.99974595807027455,
    0.99981584876278362,
    0.99986833527824281,
    0.99990724749057802,
    0.99993570051598468,
    0.99995619835942084,
    0.99997072890647543,
    0.9999808496399144,
    0.99998776381655818,
    0.99999238714961569,
    0.99999540529959718,
    0.99999732268176988,
    0.99999850325054862,
    0.99999920402413744,
    0.9999996021706401,
    0.99999981649545566,
    0.99999992415545547,
    0.99999997338493041,
    0.99999999295825959,
    0.99999999904096815

################################################################################

TITLE
    sfb_96_1024

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 
  32, 36, 40, 44, 48, 52, 56, 
  64, 72, 80, 88, 96, 108, 120, 
  132, 144, 156, 172, 188, 212, 240, 
  276, 320, 384, 448, 512, 576, 640, 
  704, 768, 832, 896, 960, 1024
};   /* 41 scfbands */

################################################################################

TITLE
    sfb_96_128 and sfb_64_128

TYPE
    16 32

DATA
  4, 8, 12, 16, 20, 24, 32, 
  40, 48, 64, 92, 128
};   /* 12 scfbands */

################################################################################

TITLE
    sfb_64_1024

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 
  32, 36, 40, 44, 48, 52, 56, 
  64, 72, 80, 88, 100, 112, 124, 
  140, 156, 172, 192, 216, 240, 268, 
  304, 344, 384, 424, 464, 504, 544, 
  584, 624, 664, 704, 744, 784, 824, 
  864, 904, 944, 984, 1024
};   /* 41 scfbands 47 */ 

################################################################################

TITLE
    sfb_48_1024

TYPE
    16

DATA
        4,	8,	12,	16,	20,	24,	28,	
        32,	36,	40,	48,	56,	64,	72,	
        80,	88,	96,	108,	120,	132,	144,	
        160,	176,	196,	216,	240,	264,	292,	
        320,	352,	384,	416,	448,	480,	512,	
        544,	576,	608,	640,	672,	704,	736,	
        768,	800,	832,	864,	896,	928,	1024
};

################################################################################

TITLE
    sfb_48_960 and sfb_32_960

TYPE
    16

DATA
        4,      8,      12,     16,     20,     24,     28,
        32,     36,     40,     48,     56,     64,     72,
        80,     88,     96,     108,    120,    132,    144,
        160,    176,    196,    216,    240,    264,    292,
        320,    352,    384,    416,    448,    480,    512,
        544,    576,    608,    640,    672,    704,    736,
        768,    800,    832,    864,    896,    928,    960, 0 };

################################################################################

TITLE
    sfb_48_512

TYPE
    16

DATA
        4,      8,      12,     16,     20,     24,     28, 
        32,     36,     40,     44,     48,     52,     56, 
        60,     68,     76,     84,     92,     100,    112,
        124,    136,    148,    164,    184,    208,    236,
        268,    300,    332,    364,    396,    428,    460,
        512
};   /* 36 scfbands */

################################################################################

TITLE
    sfb_48_480

TYPE
    16

DATA
        4,      8,      12,     16,     20,     24,     28, 
        32,     36,     40,     44,     48,     52,     56, 
        64,     72,     80,     88,     96,     108,    120,
        132,    144,    156,    172,    188,    212,    240,
        272,    304,    336,    368,    400,    432,    480
};   /* 35 scfbands */

################################################################################

TITLE
    sfb_48_128

TYPE
    16 32

DATA
          4,	8,	12,	16,	20,	28,	36,	
          44,	56,	68,	80,	96,	112,	128
};

################################################################################

TITLE
    sfb_48_120

TYPE
    16

DATA
{         4,    8,      12,     16,     20,     28,     36,
          44,   56,     68,     80,     96,     112,    120};

################################################################################

TITLE
    sfb_32_1024

TYPE
    16

DATA
        4,	8,	12,	16,	20,	24,	28,	
        32,	36,	40,	48,	56,	64,	72,	
        80,	88,	96,	108,	120,	132,	144,	
        160,	176,	196,	216,	240,	264,	292,	
        320,	352,	384,	416,	448,	480,	512,	
        544,	576,	608,	640,	672,	704,	736,	
        768,	800,	832,	864,	896,	928,	960,
        992,	1024
};

################################################################################

TITLE
    sfb_32_512

TYPE
    16

DATA
        4,     8,       12,     16,     20,     24,     28, 
        32,    36,      40,     44,     48,     52,     56, 
        64,    72,      80,     88,     96,     108,    120, 
        132,   144,     160,    176,    192,    212,    236, 
        260,   288,     320,    352,    384,    416,    448, 
        480,   512
};   /* 37 scfbands */

################################################################################

TITLE
    sfb_32_480

TYPE
    16

DATA
        4,     8,       12,     16,     20,      24,     28, 
        32,    36,      40,     44,     48,      52,     56, 
        60,    64,      72,     80,     88,      96,     104, 
        112,   124,     136,    148,    164,     180,    200, 
        224,   256,     288,    320,    352,     384,    416, 
        448,   480
};   /* 37 scfbands */

################################################################################

TITLE
    sfb_32_120

TYPE
    16

DATA
{ 4, 8, 12, 16, 20, 28, 36, 
  44, 56, 68, 80, 96, 112, 120, 0 };

################################################################################

TITLE
    sfb_24_1024

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 
  32, 36, 40, 44, 52, 60, 68, 
  76, 84, 92, 100, 108, 116, 124, 
  136, 148, 160, 172, 188, 204, 220, 
  240, 260, 284, 308, 336, 364, 396, 
  432, 468, 508, 552, 600, 652, 704, 
  768, 832, 896, 960, 1024
};   /* 47 scfbands */

################################################################################

TITLE
    sfb_24_960

TYPE
    16

DATA
        4,   8,   12,  16,  20,  24,  28,
        32,  36,  40,  44,  52,  60,  68,
        76,  84,  92,  100, 108, 116, 124,
        136, 148, 160, 172, 188, 204, 220,
        240, 260, 284, 308, 336, 364, 396,
        432, 468, 508, 552, 600, 652, 704,
        768, 832, 896, 960,0
};   /* 47 scfbands */

################################################################################

TITLE
    sfb_24_512

TYPE
    16

DATA
        4,   8,   12,  16,  20,  24,  28,  
        32,  36,  40,  44,  52,  60,  68, 
        80,  92,  104, 120, 140, 164, 192, 
        224, 256, 288, 320, 352, 384, 416, 
        448, 480, 512
};   /* 31 scfbands */

################################################################################

TITLE
    sfb_24_480

TYPE
    16

DATA
        4,   8,   12,  16,  20,  24,  28,  
        32,  36,  40,  44,  52,  60,  68, 
        80,  92,  104, 120, 140, 164, 192, 
        224, 256, 288, 320, 352, 384, 416, 
        448, 480
};   /* 30 scfbands */

################################################################################

TITLE
    sfb_24_128

TYPE
    16 32

DATA
  4, 8, 12, 16, 20, 24, 28, 
  36, 44, 52, 64, 76, 92, 108, 
  128
};   /* 15 scfbands */

################################################################################

TITLE
    sfb_24_120

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 36, 44, 52, 64, 76, 92, 108, 120, 0
};   /* 15 scfbands */

################################################################################

TITLE
    sfb_16_1024

TYPE
    16

DATA
  8, 16, 24, 32, 40, 48, 56, 
  64, 72, 80, 88, 100, 112, 124, 
  136, 148, 160, 172, 184, 196, 212, 
  228, 244, 260, 280, 300, 320, 344, 
  368, 396, 424, 456, 492, 532, 572, 
  616, 664, 716, 772, 832, 896, 960, 
  1024
};   /* 43 scfbands */

################################################################################

TITLE
    sfb_16_960

TYPE
    16

DATA
  8,   16,  24,  32,  40,  48,  56, 
  64,  72,  80,  88,  100, 112, 124, 
  136, 148, 160, 172, 184, 196, 212, 
  228, 244, 260, 280, 300, 320, 344, 
  368, 396, 424, 456, 492, 532, 572, 
  616, 664, 716, 772, 832, 896, 960
};   /* 42 scfbands */

################################################################################

TITLE
    sfb_16_128

TYPE
    16 32

DATA
  4, 8, 12, 16, 20, 24, 28, 
  32, 40, 48, 60, 72, 88, 108, 
  128
};   /* 15 scfbands */

################################################################################

TITLE
    sfb_16_120

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 32, 40, 48, 60, 72, 88, 108, 120
};   /* 15 scfbands */

################################################################################

TITLE
    sfb_8_1024

TYPE
    16

DATA
  12, 24, 36, 48, 60, 72, 84, 
  96, 108, 120, 132, 144, 156, 172, 
  188, 204, 220, 236, 252, 268, 288, 
  308, 328, 348, 372, 396, 420, 448, 
  476, 508, 544, 580, 620, 664, 712, 
  764, 820, 880, 944, 1024
};   /* 40 scfbands */

################################################################################

TITLE
    sfb_8_960

TYPE
    16

DATA
  12, 24, 36, 48, 60, 72, 84, 
  96, 108, 120, 132, 144, 156, 172, 
  188, 204, 220, 236, 252, 268, 288, 
  308, 328, 348, 372, 396, 420, 448, 
  476, 508, 544, 580, 620, 664, 712, 
  764, 820, 880, 944, 960
};   /* 40 scfbands */

################################################################################

TITLE
    sfb_8_128

TYPE
    16 32

DATA
  4, 8, 12, 16, 20, 24, 28, 
  36, 44, 52, 60, 72, 88, 108, 
  128
};   /* 15 scfbands */

################################################################################

TITLE
    sfb_8_120

TYPE
    16

DATA
  4, 8, 12, 16, 20, 24, 28, 
  36, 44, 52, 60, 72, 88, 108, 
  120
};   /* 15 scfbands */

################################################################################

TITLE
    tns_max_bands_tbl

TYPE
    8 32

DATA
    {31,  9, 28,  7},	    /* 96000 */
    {31,  9, 28,  7},	    /* 88200 */
    {34, 10, 27,  7},	    /* 64000 */
    {40, 14, 26,  6},	    /* 48000 */
    {42, 14, 26,  6},	    /* 44100 */
    {51, 14, 26,  6},	    /* 32000 */
    {46, 14, 29,  7},	    /* 24000 */
    {46, 14, 29,  7},	    /* 22050 */
    {42, 14, 23,  8},	    /* 16000 */
    {42, 14, 23,  8},	    /* 12000 */
    {42, 14, 23,  8},	    /* 11025 */
    {39, 14, 19,  7},	    /* 8000  */
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}

################################################################################

TITLE
    tns_max_bands_tbl_low_delay

TYPE
    32

DATA
    {0, 0},	    /* 96000 */
    {0, 0},	    /* 88200 */
    {0, 0},	    /* 64000 */
    {31, 31},	    /* 48000 */
    {32, 32},	    /* 44100 */
    {37, 37},	    /* 32000 */
    {30, 31},	    /* 24000 */
    {30, 31},	    /* 22050 */
    {0, 0},	    /* 16000 */
    {0, 0},	    /* 12000 */
    {0, 0},	    /* 11025 */
    {0, 0},	    /* 8000  */
    {0,0},
    {0,0},
    {0,0},
    {0,0}

################################################################################

TITLE
    pred_max_bands_tbl

TYPE
    8 32

DATA
  33,     /* 96000 */
  33,	  /* 88200 */
  38,	  /* 64000 */
  40,	  /* 48000 */
  40,	  /* 44100 */
  40,	  /* 32000 */
  41,	  /* 24000 */
  41,     /* 22050 */
  37,	  /* 16000 */
  37,	  /* 12000 */
  37,	  /* 11025 */
  34,	  /* 8000  */
  0,
  0,
  0,
  0

################################################################################

TITLE
    Dolby window dol_short_ssr

TYPE
    FLOAT

DATA
0.0000875914060105,
0.0009321760265333,
0.0032114611466596,
0.0081009893216786,
0.0171240286619181,
0.0320720743527833,
0.0548307856028528,
0.0871361822564870,
0.1302923415174603,
0.1848955425508276,
0.2506163195331889,
0.3260874142923209,
0.4089316830907141,
0.4959414909423747,
0.5833939894958904,
0.6674601983218376,
0.7446454751465113,
0.8121892962974020,
0.8683559394406505,
0.9125649996381605,
0.9453396205809574,
0.9680864942677585,
0.9827581789763112,
0.9914756203467121,
0.9961964092194694,
0.9984956609571091,
0.9994855586984285,
0.9998533730714648,
0.9999671864476404,
0.9999948432453556,
0.9999995655238333,
0.9999999961638728

################################################################################

TITLE
    Dolby window dol_short_ssr (b)

TYPE
    FLOAT

DATA
  0.0005851230124487,
  0.0009642149851497,
  0.0013558207534965,
  0.0017771849644394,
  0.0022352533849672,
  0.0027342299070304,
  0.0032773001022195,
  0.0038671998069216,
  0.0045064443384152,
  0.0051974336885144,
  0.0059425050016407,
  0.0067439602523141,
  0.0076040812644888,
  0.0085251378135895,
  0.0095093917383048,
  0.0105590986429280,
  0.0116765080854300,
  0.0128638627792770,
  0.0141233971318631,
  0.0154573353235409,
  0.0168678890600951,
  0.0183572550877256,
  0.0199276125319803,
  0.0215811201042484,
  0.0233199132076965,
  0.0251461009666641,
  0.0270617631981826,
  0.0290689473405856,
  0.0311696653515848,
  0.0333658905863535,
  0.0356595546648444,
  0.0380525443366107,
  0.0405466983507029,
  0.0431438043376910,
  0.0458455957104702,
  0.0486537485902075,
  0.0515698787635492,
  0.0545955386770205,
  0.0577322144743916,
  0.0609813230826460,
  0.0643442093520723,
  0.0678221432558827,
  0.0714163171546603,
  0.0751278431308314,
  0.0789577503982528,
  0.0829069827918993,
  0.0869763963425241,
  0.0911667569410503,
  0.0954787380973307,
  0.0999129187977865,
  0.1044697814663005,
  0.1091497100326053,
  0.1139529881122542,
  0.1188797973021148,
  0.1239302155951605,
  0.1291042159181728,
  0.1344016647957880,
  0.1398223211441467,
  0.1453658351972151,
  0.1510317475686540,
  0.1568194884519144,
  0.1627283769610327,
  0.1687576206143887,
  0.1749063149634756,
  0.1811734433685097,
  0.1875578769224857,
  0.1940583745250518,
  0.2006735831073503,
  0.2074020380087318,
  0.2142421635060113,
  0.2211922734956977,
  0.2282505723293797,
  0.2354151558022098,
  0.2426840122941792,
  0.2500550240636293,
  0.2575259686921987,
  0.2650945206801527,
  0.2727582531907993,
  0.2805146399424422,
  0.2883610572460804,
  0.2962947861868143,
  0.3043130149466800,
  0.3124128412663888,
  0.3205912750432127,
  0.3288452410620226,
  0.3371715818562547,
  0.3455670606953511,
  0.3540283646950029,
  0.3625521080463003,
  0.3711348353596863,
  0.3797730251194006,
  0.3884630932439016,
  0.3972013967475546,
  0.4059842374986933,
  0.4148078660689724,
  0.4236684856687616,
  0.4325622561631607,
  0.4414852981630577,
  0.4504336971855032,
  0.4594035078775303,
  0.4683907582974173,
  0.4773914542472655,
  0.4864015836506502,
  0.4954171209689973,
  0.5044340316502417,
  0.5134482766032377,
  0.5224558166913167,
  0.5314526172383208,
  0.5404346525403849,
  0.5493979103766972,
  0.5583383965124314,
  0.5672521391870222,
  0.5761351935809411,
  0.5849836462541291,
  0.5937936195492526,
  0.6025612759529649,
  0.6112828224083939,
  0.6199545145721097,
  0.6285726610088878,
  0.6371336273176413,
  0.6456338401819751,
  0.6540697913388968,
  0.6624380414593221,
  0.6707352239341151,
  0.6789580485595255,
  0.6871033051160131,
  0.6951678668345944,
  0.7031486937449871,
  0.7110428359000029,
  0.7188474364707993,
  0.7265597347077880,
  0.7341770687621900,
  0.7416968783634273,
  0.7491167073477523,
  0.7564342060337386,
  0.7636471334404891,
  0.7707533593446514,
  0.7777508661725849,
  0.7846377507242818,
  0.7914122257259034,
  0.7980726212080798,
  0.8046173857073919,
  0.8110450872887550,
  0.8173544143867162,
  0.8235441764639875,
  0.8296133044858474,
  0.8355608512093652,
  0.8413859912867303,
  0.8470880211822968,
  0.8526663589032990,
  0.8581205435445334,
  0.8634502346476508,
  0.8686552113760616,
  0.8737353715068081,
  0.8786907302411250,
  0.8835214188357692,
  0.8882276830575707,
  0.8928098814640207,
  0.8972684835130879,
  0.9016040675058185,
  0.9058173183656508,
  0.9099090252587376,
  0.9138800790599416,
  0.9177314696695282,
  0.9214642831859411,
  0.9250796989403991,
  0.9285789863994010,
  0.9319635019415643,
  0.9352346855155568,
  0.9383940571861993,
  0.9414432135761304,
  0.9443838242107182,
  0.9472176277741918,
  0.9499464282852282,
  0.9525720912004834,
  0.9550965394547873,
  0.9575217494469370,
  0.9598497469802043,
  0.9620826031668507,
  0.9642224303060783,
  0.9662713777449607,
  0.9682316277319895,
  0.9701053912729269,
  0.9718949039986892,
  0.9736024220549734,
  0.9752302180233160,
  0.9767805768831932,
  0.9782557920246753,
  0.9796581613210076,
  0.9809899832703159,
  0.9822535532154261,
  0.9834511596505429,
  0.9845850806232530,
  0.9856575802399989,
  0.9866709052828243,
  0.9876272819448033,
  0.9885289126911557,
  0.9893779732525968,
  0.9901766097569984,
  0.9909269360049311,
  0.9916310308941294,
  0.9922909359973702,
  0.9929086532976777,
  0.9934861430841844,
  0.9940253220113651,
  0.9945280613237534,
  0.9949961852476154,
  0.9954314695504363,
  0.9958356402684387,
  0.9962103726017252,
  0.9965572899760172,
  0.9968779632693499,
  0.9971739102014799,
  0.9974465948831872,
  0.9976974275220812,
  0.9979277642809907,
  0.9981389072844972,
  0.9983321047686901,
  0.9985085513687731,
  0.9986693885387259,
  0.9988157050968516,
  0.9989485378906924,
  0.9990688725744943,
  0.9991776444921379,
  0.9992757396582338,
  0.9993639958299003,
  0.9994432036616085,
  0.9995141079353859,
  0.9995774088586188,
  0.9996337634216871,
  0.9996837868076957,
  0.9997280538466377,
  0.9997671005064359,
  0.9998014254134544,
  0.9998314913952471,
  0.9998577270385304,
  0.9998805282555989,
  0.9999002598526793,
  0.9999172570940037,
  0.9999318272557038,
  0.9999442511639580,
  0.9999547847121726,
  0.9999636603523446,
  0.9999710885561258,
  0.9999772592414866,
  0.9999823431612708,
  0.9999864932503106,
  0.9999898459281599,
  0.9999925223548691,
  0.9999946296375997,
  0.9999962619864214,
  0.9999975018180320,
  0.9999984208055542,
  0.9999990808746198,
  0.9999995351446231,
  0.9999998288155155

################################################################################

TITLE
    gc_pqf_common.c a_half

TYPE
    FLOAT

DATA
   1.2206911375946939E-05,  1.7261986723798209E-05,  1.2300093657077942E-05,
  -1.0833943097791965E-05, -5.7772498639901686E-05, -1.2764767618947719E-04,
  -2.0965186675013334E-04, -2.8166673689263850E-04, -3.1234860429017460E-04,
  -2.6738519958452353E-04, -1.1949424681824722E-04,  1.3965139412648678E-04,
   4.8864136409185725E-04,  8.7044629275148344E-04,  1.1949430269934793E-03,
   1.3519708175026700E-03,  1.2346314373964412E-03,  7.6953209114159191E-04,
  -5.2242432579537141E-05, -1.1516092887213454E-03, -2.3538469841711277E-03,
  -3.4033123072127277E-03, -4.0028551071986133E-03, -3.8745415659693259E-03,
  -2.8321073426874310E-03, -8.5038892323704195E-04,  1.8856751185350931E-03,
   4.9688741735340923E-03,  7.8056704536795926E-03,  9.7027909685901654E-03,
   9.9960423120166159E-03,  8.2019366335594487E-03,  4.1642072876103365E-03,
  -1.8364453822737758E-03, -9.0384863094167686E-03, -1.6241528177129844E-02,
  -2.1939551286300665E-02, -2.4533179947088161E-02, -2.2591663337768787E-02,
  -1.5122066420044672E-02, -1.7971713448186293E-03,  1.6903413428575379E-02,
   3.9672315874127042E-02,  6.4487527248102796E-02,  8.8850025474701726E-02,
   0.1101132906105560    ,  0.1258540205143761    ,  0.1342239368467012    

################################################################################

TITLE
    epTool punctbl

TYPE
    32

DATA
  {0x00,0x00,0x00},
  {0x80,0x00,0x00}, {0x88,0x00,0x00}, {0xa8,0x00,0x00},{0xaa,0x00,0x00},
  {0xea,0x00,0x00}, {0xee,0x00,0x00}, {0xfe,0x00,0x00},{0xff,0x00,0x00},
  {0xff,0x80,0x00}, {0xff,0x88,0x00}, {0xff,0xa8,0x00},{0xff,0xaa,0x00},
  {0xff,0xea,0x00}, {0xff,0xee,0x00}, {0xff,0xfe,0x00},{0xff,0xff,0x00},
  {0xff,0xff,0x80}, {0xff,0xff,0x88}, {0xff,0xff,0xa8},{0xff,0xff,0xaa},
  {0xff,0xff,0xea}, {0xff,0xff,0xee}, {0xff,0xff,0xfe},{0xff,0xff,0xff}};

################################################################################

TITLE
    epTool bgptbl

TYPE
    32

DATA
  0107657,			/* BCH_3116 */
  05423325,			/* BCH_3111 */
  023,				/* BCH_1511 */
  02467,			/* BCH_155  */
  05343,			/* GOLAY_2312 */
  013,				/* BCH_74 */
  0351				/* BCH_157 */

################################################################################

TITLE
    generic sampling rate table (96000 -> 8000)

TYPE
    32

DATA
	96000, 
	88200, 
	64000, 
	48000, 
	44100, 
	32000, 
	24000, 
	22050, 
	16000, 
	12000, 
	11025, 
	8000,

################################################################################

TITLE
    MPEG4 fir48_4_120

TYPE
    FLOAT

DATA
  { -0.0000000000F, -0.0004061767F, -0.0006554074F, -0.0005603479F,
    +0.0000000000F, +0.0010332072F, +0.0024067306F, +0.0038511274F,
    +0.0049972718F, +0.0054446460F, +0.0048504364F, +0.0030230276F,
    -0.0000000000F, -0.0039090311F, -0.0081300062F, -0.0118895363F,
    -0.0143338396F, -0.0146862233F, -0.0124177060F, -0.0073988790F,
    +0.0000000000F, +0.0088885044F, +0.0179316783F, +0.0255223974F,
    +0.0300328067F, +0.0301098647F, +0.0249669378F, +0.0146174761F,
    -0.0000000000F, -0.0170435762F, -0.0339530545F, -0.0477884869F,
    -0.0556838859F, -0.0553529653F, -0.0455668957F, -0.0265189851F,
    +0.0000000000F, +0.0306695549F, +0.0609699140F, +0.0857542392F,
    +0.1000000000F, +0.0996415654F, +0.0823628662F, +0.0482228773F,
    -0.0000000000F, -0.0568263967F, -0.1144916118F, -0.1637363938F,
    -0.1948936008F, -0.1991420526F, -0.1697652726F, -0.1032409730F,
    +0.0000000000F, +0.1352696593F, +0.2938416526F, +0.4636919170F,
    +0.6306889405F, +0.7800976241F, +0.8982140690F, +0.9739261298F,
    +1.0000000000F, +0.9739261298F, +0.8982140690F, +0.7800976241F,
    +0.6306889405F, +0.4636919170F, +0.2938416526F, +0.1352696593F,
    +0.0000000000F, -0.1032409730F, -0.1697652726F, -0.1991420526F,
    -0.1948936008F, -0.1637363938F, -0.1144916118F, -0.0568263967F,
    -0.0000000000F, +0.0482228773F, +0.0823628662F, +0.0996415654F,
    +0.1000000000F, +0.0857542392F, +0.0609699140F, +0.0306695549F,
    +0.0000000000F, -0.0265189851F, -0.0455668957F, -0.0553529653F,
    -0.0556838859F, -0.0477884869F, -0.0339530545F, -0.0170435762F,
    -0.0000000000F, +0.0146174761F, +0.0249669378F, +0.0301098647F,
    +0.0300328067F, +0.0255223974F, +0.0179316783F, +0.0088885044F,
    +0.0000000000F, -0.0073988790F, -0.0124177060F, -0.0146862233F,
    -0.0143338396F, -0.0118895363F, -0.0081300062F, -0.0039090311F,
    -0.0000000000F, +0.0030230276F, +0.0048504364F, +0.0054446460F,
    +0.0049972718F, +0.0038511274F, +0.0024067306F, +0.0010332072F,
    +0.0000000000F, -0.0005603479F, -0.0006554074F, -0.0004061767F,
    -0.0000000000F,

################################################################################

TITLE
    celptb1

TYPE
    32

DATA
    {{154,156,23,8,2,134}, {170,172,23,8,2,150},
     {186,188,23,8,2,166}, {147,149,23,8,2,127},
     {156,158,23,8,2,136}, {165,167,23,8,2,145},
     {114,116,23,8,2, 94}, {120,122,23,8,2,100},
     {126,128,23,8,2,106}, {132,134,23,8,2,112},
     {138,140,23,8,2,118}, {142,144,23,8,2,122},
     {146,148,23,8,2,126}, {154,156,23,8,2,134},
     {166,168,23,8,2,146}, {174,176,23,8,2,154},
     {182,184,23,8,2,162}, {190,192,23,8,2,170},
     {198,200,23,8,2,178}, {206,208,23,8,2,186},
     {210,212,23,8,2,190}, {214,216,23,8,2,194},
     {110,112,23,8,2, 90}, {114,116,23,8,2, 94},
     {118,120,23,8,2, 98}, {120,122,23,8,2,100},
     {122,124,23,8,2,102}, {186,188,23,8,2,166},
     {218,220,40,8,2,174}, {230,232,40,8,2,186},
     {242,244,40,8,2,198}, {254,256,40,8,2,210},
     {266,268,40,8,2,222}, {278,280,40,8,2,234},
     {286,288,40,8,2,242}, {294,296,40,8,2,250},
     {318,320,40,8,2,276}, {342,344,40,8,2,298},
     {358,360,40,8,2,314}, {374,376,40,8,2,330},
     {390,392,40,8,2,346}, {406,408,40,8,2,362},
     {422,424,40,8,2,378}, {136,138,40,8,2, 92},
     {142,144,40,8,2, 98}, {148,150,40,8,2,104},
     {154,156,40,8,2,110}, {160,162,40,8,2,116},
     {166,168,40,8,2,122}, {170,172,40,8,2,126},
     {174,176,40,8,2,130}, {186,188,40,8,2,142},
     {198,200,40,8,2,154}, {206,208,40,8,2,162},
     {214,216,40,8,2,170}, {222,224,40,8,2,178},
     {230,232,40,8,2,186}, {238,240,40,8,2,194},
     {216,218,40,8,2,172}, {160,162,40,8,2,116},
     {280,282,40,8,2,238}, {338,340,40,8,2,296},
     {  0,  0, 0,0,0,  0}, {  0,  0, 0,0,0,  0} };

################################################################################

TITLE
    celptb2

TYPE
    32

DATA
    {{ 80, 0, 0, 0}, { 60, 0, 0, 0}, { 40, 0, 0, 0},
     { 20, 0, 0, 0}, {368,21, 0, 0}, {416,21, 0, 0},
     {464,21, 0, 0}, {496,21, 0, 0}, {284,21, 0, 0},
     {320,21, 0, 0}, {356,21, 0, 0}, {380,21, 0, 0},
     {200,21, 0, 0}, {224,21, 0, 0}, {248,21, 0, 0},
     {264,21, 0, 0}, {116,21, 0, 0}, {128,21, 0, 0},
     {140,21, 0, 0}, {148,21, 0, 0} };

################################################################################

TITLE
    phi init_freq

TYPE
    32

DATA
	82,
	72,
	46,
	46,
	57,
	59,
	75,
	76,
	865,
	82,
	89,
	78,
	91,
	64,
	92,
	126,
	109,
	151,
	219,
	225,
	303,
	365,
	390,
	385,
	405,
	418,
	422,
	423,
	452,
	392,
	378,
	294,
	234,
	208,
	94,
	168,
	43,
	33,
	52,
	71,
	86,
	137,
	138,
	187,
	220,
	264,
	350,
	401,
	553,
	542,
	557,
	598,
	480,
	380,
	351,
	321,
	296,
	1219,
	391,
	173,
	73,
	50,
	32,
	29,
	58,
	192,
	229,
	361,
	488,
	1502,
	1066,
	1073,
	890,
	734,
	598,
	421,
	223,
	106,
	73,
	48,
	66,
	144,
	309,
	527,
	646,
	831,
	1118,
	1285,
	1830,
	598,
	330,
	175,
	106,
	34,
	77,
	199,
	552,
	850,
	2155,
	1692,
	1161,
	672,
	332,
	177,
	69,
	42,
	9,
	15,
	54,
	131,
	297,
	674,
	1128,
	1786,
	2349,
	955,
	416,
	150,
	48,
	54,
	160,
	301,
	579,
	953,
	2263,
	1792,
	1103,
	503,
	206,
	74,
	23,
	28,
	64,
	191,
	464,
	885,
	1420,
	1993,
	2210,
	551,
	152,
	52,
	65,
	180,
	646,
	2471,
	2235,
	1393,
	691,
	231,
	96,
	85,
	223,
	693,
	1577,
	2306,
	2462,
	521,
	140,
	42,
	281,
	841,
	2898,
	2320,
	1165,
	374,
	86,
	126,
	465,
	1261,
	2456,
	2775,
	695,
	228,
	78,
	575,
	2946,
	2542,
	1250,
	466,
	149,
	40,
	268,
	1089,
	2491,
	3051,
	832,
	198,
	38,
	110,
	659,
	3004,
	2496,
	1186,
	451,
	100,
	307,
	1149,
	2549,
	3038,
	794,
	168,
	101,
	763,
	3682,
	2512,
	782,
	165,
	4,
	108,
	980,
	2841,
	3407,
	631,
	35,
	38,
	706,
	3821,
	2821,
	589,
	30,
	57,
	849,
	3114,
	3480,
	500,
	5,

################################################################################

TITLE
    base64 decoding table

TYPE
    8, 32

DATA
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x3f,
        0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b,
        0x3c, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06,
        0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e,
        0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16,
        0x17, 0x18, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20,
        0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28,
        0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e, 0x2f, 0x30,
        0x31, 0x32, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00

################################################################################

TITLE
    UnRARlib CRCCrypt Code InitSubstTable

TYPE
    8

DATA
  215, 19,149, 35, 73,197,192,205,249, 28, 16,119, 48,221,  2, 42,
  232,  1,177,233, 14, 88,219, 25,223,195,244, 90, 87,239,153,137,
  255,199,147, 70, 92, 66,246, 13,216, 40, 62, 29,217,230, 86,  6,
   71, 24,171,196,101,113,218,123, 93, 91,163,178,202, 67, 44,235,
  107,250, 75,234, 49,167,125,211, 83,114,157,144, 32,193,143, 36,
  158,124,247,187, 89,214,141, 47,121,228, 61,130,213,194,174,251,
   97,110, 54,229,115, 57,152, 94,105,243,212, 55,209,245, 63, 11,
  164,200, 31,156, 81,176,227, 21, 76, 99,139,188,127, 17,248, 51,
  207,120,189,210,  8,226, 41, 72,183,203,135,165,166, 60, 98,  7,
  122, 38,155,170, 69,172,252,238, 39,134, 59,128,236, 27,240, 80,
  131,  3, 85,206,145, 79,154,142,159,220,201,133, 74, 64, 20,129,
  224,185,138,103,173,182, 43, 34,254, 82,198,151,231,180, 58, 10,
  118, 26,102, 12, 50,132, 22,191,136,111,162,179, 45,  4,148,108,
  161, 56, 78,126,242,222, 15,175,146, 23, 33,241,181,190, 77,225,
    0, 46,169,186, 68, 95,237, 65, 53,208,253,168,  9, 18,100, 52,
  116,184,160, 96,109, 37, 30,106,140,104,150,  5,204,117,112, 84

################################################################################

TITLE
    liba52 hthtab

TYPE
    32

DATA
    {0x730, 0x730, 0x7c0, 0x800, 0x820, 0x840, 0x850, 0x850, 0x860, 0x860,
     0x860, 0x860, 0x860, 0x870, 0x870, 0x870, 0x880, 0x880, 0x890, 0x890,
     0x8a0, 0x8a0, 0x8b0, 0x8b0, 0x8c0, 0x8c0, 0x8d0, 0x8e0, 0x8f0, 0x900,
     0x910, 0x910, 0x910, 0x910, 0x900, 0x8f0, 0x8c0, 0x870, 0x820, 0x7e0,
     0x7a0, 0x770, 0x760, 0x7a0, 0x7c0, 0x7c0, 0x6e0, 0x400, 0x3c0, 0x3c0},
    {0x710, 0x710, 0x7a0, 0x7f0, 0x820, 0x830, 0x840, 0x850, 0x850, 0x860,
     0x860, 0x860, 0x860, 0x860, 0x870, 0x870, 0x870, 0x880, 0x880, 0x880,
     0x890, 0x890, 0x8a0, 0x8a0, 0x8b0, 0x8b0, 0x8c0, 0x8c0, 0x8e0, 0x8f0,
     0x900, 0x910, 0x910, 0x910, 0x910, 0x900, 0x8e0, 0x8b0, 0x870, 0x820,
     0x7e0, 0x7b0, 0x760, 0x770, 0x7a0, 0x7c0, 0x780, 0x5d0, 0x3c0, 0x3c0},
    {0x680, 0x680, 0x750, 0x7b0, 0x7e0, 0x810, 0x820, 0x830, 0x840, 0x850,
     0x850, 0x850, 0x860, 0x860, 0x860, 0x860, 0x860, 0x860, 0x860, 0x860,
     0x870, 0x870, 0x870, 0x870, 0x880, 0x880, 0x880, 0x890, 0x8a0, 0x8b0,
     0x8c0, 0x8d0, 0x8e0, 0x8f0, 0x900, 0x910, 0x910, 0x910, 0x900, 0x8f0,
     0x8d0, 0x8b0, 0x840, 0x7f0, 0x790, 0x760, 0x7a0, 0x7c0, 0x7b0, 0x720}

################################################################################

TITLE
    liba52 baptab

TYPE
    8

DATA
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,	/* 93 padding elems */

    16, 16, 16, 16, 16, 16, 16, 16, 16, 14, 14, 14, 14, 14, 14, 14,
    14, 12, 12, 12, 12, 11, 11, 11, 11, 10, 10, 10, 10,  9,  9,  9,
     9,  8,  8,  8,  8,  7,  7,  7,  7,  6,  6,  6,  6,  5,  5,  5,
     5,  4,  4, -3, -3,  3,  3,  3, -2, -2, -1, -1, -1, -1, -1,  0,

     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0					/* 148 padding elems */

################################################################################

TITLE
    liba52 bndtab

TYPE
    8 32

DATA
     {21, 22,  23,  24,  25,  26,  27,  28,  31,  34,
			 37, 40,  43,  46,  49,  55,  61,  67,  73,  79,
			 85, 97, 109, 121, 133, 157, 181, 205, 229, 253};

################################################################################

TITLE
    liba52 latab

TYPE
    8

DATA
    -64, -63, -62, -61, -60, -59, -58, -57, -56, -55, -54, -53,
    -52, -52, -51, -50, -49, -48, -47, -47, -46, -45, -44, -44,
    -43, -42, -41, -41, -40, -39, -38, -38, -37, -36, -36, -35,
    -35, -34, -33, -33, -32, -32, -31, -30, -30, -29, -29, -28,
    -28, -27, -27, -26, -26, -25, -25, -24, -24, -23, -23, -22,
    -22, -21, -21, -21, -20, -20, -19, -19, -19, -18, -18, -18,
    -17, -17, -17, -16, -16, -16, -15, -15, -15, -14, -14, -14,
    -13, -13, -13, -13, -12, -12, -12, -12, -11, -11, -11, -11,
    -10, -10, -10, -10, -10,  -9,  -9,  -9,  -9,  -9,  -8,  -8,
     -8,  -8,  -8,  -8,  -7,  -7,  -7,  -7,  -7,  -7,  -6,  -6,
     -6,  -6,  -6,  -6,  -6,  -6,  -5,  -5,  -5,  -5,  -5,  -5,
     -5,  -5,  -4,  -4,  -4,  -4,  -4,  -4,  -4,  -4,  -4,  -4,
     -4,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,
     -3,  -3,  -3,  -2,  -2,  -2,  -2,  -2,  -2,  -2,  -2,  -2,
     -2,  -2,  -2,  -2,  -2,  -2,  -2,  -2,  -2,  -2,  -1,  -1,
     -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     -1,  -1,  -1,  -1,  -1,  -1,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0

################################################################################

TITLE
    liba52 pm128

TYPE
    32

DATA
	0, 16, 32, 48, 64, 80,  96, 112,  8, 40, 72, 104, 24, 56,  88, 120,
	4, 20, 36, 52, 68, 84, 100, 116, 12, 28, 44,  60, 76, 92, 108, 124,
	2, 18, 34, 50, 66, 82,  98, 114, 10, 42, 74, 106, 26, 58,  90, 122,
	6, 22, 38, 54, 70, 86, 102, 118, 14, 46, 78, 110, 30, 62,  94, 126,
	1, 17, 33, 49, 65, 81,  97, 113,  9, 41, 73, 105, 25, 57,  89, 121,
	5, 21, 37, 53, 69, 85, 101, 117, 13, 29, 45,  61, 77, 93, 109, 125,
	3, 19, 35, 51, 67, 83,  99, 115, 11, 43, 75, 107, 27, 59,  91, 123,
	7, 23, 39, 55, 71, 87, 103, 119, 15, 31, 47,  63, 79, 95, 111, 127

################################################################################

TITLE
    liba52 bit_reverse_512

TYPE
    8

DATA
	0x00, 0x40, 0x20, 0x60, 0x10, 0x50, 0x30, 0x70, 
	0x08, 0x48, 0x28, 0x68, 0x18, 0x58, 0x38, 0x78, 
	0x04, 0x44, 0x24, 0x64, 0x14, 0x54, 0x34, 0x74, 
	0x0c, 0x4c, 0x2c, 0x6c, 0x1c, 0x5c, 0x3c, 0x7c, 
	0x02, 0x42, 0x22, 0x62, 0x12, 0x52, 0x32, 0x72, 
	0x0a, 0x4a, 0x2a, 0x6a, 0x1a, 0x5a, 0x3a, 0x7a, 
	0x06, 0x46, 0x26, 0x66, 0x16, 0x56, 0x36, 0x76, 
	0x0e, 0x4e, 0x2e, 0x6e, 0x1e, 0x5e, 0x3e, 0x7e, 
	0x01, 0x41, 0x21, 0x61, 0x11, 0x51, 0x31, 0x71, 
	0x09, 0x49, 0x29, 0x69, 0x19, 0x59, 0x39, 0x79, 
	0x05, 0x45, 0x25, 0x65, 0x15, 0x55, 0x35, 0x75, 
	0x0d, 0x4d, 0x2d, 0x6d, 0x1d, 0x5d, 0x3d, 0x7d, 
	0x03, 0x43, 0x23, 0x63, 0x13, 0x53, 0x33, 0x73, 
	0x0b, 0x4b, 0x2b, 0x6b, 0x1b, 0x5b, 0x3b, 0x7b, 
	0x07, 0x47, 0x27, 0x67, 0x17, 0x57, 0x37, 0x77, 
	0x0f, 0x4f, 0x2f, 0x6f, 0x1f, 0x5f, 0x3f, 0x7f};

################################################################################

TITLE
    liba52 fftorder

TYPE
    8

DATA
      0,128, 64,192, 32,160,224, 96, 16,144, 80,208,240,112, 48,176,
      8,136, 72,200, 40,168,232,104,248,120, 56,184, 24,152,216, 88,
      4,132, 68,196, 36,164,228,100, 20,148, 84,212,244,116, 52,180,
    252,124, 60,188, 28,156,220, 92, 12,140, 76,204,236,108, 44,172,
      2,130, 66,194, 34,162,226, 98, 18,146, 82,210,242,114, 50,178,
     10,138, 74,202, 42,170,234,106,250,122, 58,186, 26,154,218, 90,
    254,126, 62,190, 30,158,222, 94, 14,142, 78,206,238,110, 46,174,
      6,134, 70,198, 38,166,230,102,246,118, 54,182, 22,150,214, 86

################################################################################

TITLE
    liba52 dither_lut

TYPE
    16

DATA
    0x0000, 0xa011, 0xe033, 0x4022, 0x6077, 0xc066, 0x8044, 0x2055,
    0xc0ee, 0x60ff, 0x20dd, 0x80cc, 0xa099, 0x0088, 0x40aa, 0xe0bb,
    0x21cd, 0x81dc, 0xc1fe, 0x61ef, 0x41ba, 0xe1ab, 0xa189, 0x0198,
    0xe123, 0x4132, 0x0110, 0xa101, 0x8154, 0x2145, 0x6167, 0xc176,
    0x439a, 0xe38b, 0xa3a9, 0x03b8, 0x23ed, 0x83fc, 0xc3de, 0x63cf,
    0x8374, 0x2365, 0x6347, 0xc356, 0xe303, 0x4312, 0x0330, 0xa321,
    0x6257, 0xc246, 0x8264, 0x2275, 0x0220, 0xa231, 0xe213, 0x4202,
    0xa2b9, 0x02a8, 0x428a, 0xe29b, 0xc2ce, 0x62df, 0x22fd, 0x82ec,
    0x8734, 0x2725, 0x6707, 0xc716, 0xe743, 0x4752, 0x0770, 0xa761,
    0x47da, 0xe7cb, 0xa7e9, 0x07f8, 0x27ad, 0x87bc, 0xc79e, 0x678f,
    0xa6f9, 0x06e8, 0x46ca, 0xe6db, 0xc68e, 0x669f, 0x26bd, 0x86ac,
    0x6617, 0xc606, 0x8624, 0x2635, 0x0660, 0xa671, 0xe653, 0x4642,
    0xc4ae, 0x64bf, 0x249d, 0x848c, 0xa4d9, 0x04c8, 0x44ea, 0xe4fb,
    0x0440, 0xa451, 0xe473, 0x4462, 0x6437, 0xc426, 0x8404, 0x2415,
    0xe563, 0x4572, 0x0550, 0xa541, 0x8514, 0x2505, 0x6527, 0xc536,
    0x258d, 0x859c, 0xc5be, 0x65af, 0x45fa, 0xe5eb, 0xa5c9, 0x05d8,
    0xae79, 0x0e68, 0x4e4a, 0xee5b, 0xce0e, 0x6e1f, 0x2e3d, 0x8e2c,
    0x6e97, 0xce86, 0x8ea4, 0x2eb5, 0x0ee0, 0xaef1, 0xeed3, 0x4ec2,
    0x8fb4, 0x2fa5, 0x6f87, 0xcf96, 0xefc3, 0x4fd2, 0x0ff0, 0xafe1,
    0x4f5a, 0xef4b, 0xaf69, 0x0f78, 0x2f2d, 0x8f3c, 0xcf1e, 0x6f0f,
    0xede3, 0x4df2, 0x0dd0, 0xadc1, 0x8d94, 0x2d85, 0x6da7, 0xcdb6,
    0x2d0d, 0x8d1c, 0xcd3e, 0x6d2f, 0x4d7a, 0xed6b, 0xad49, 0x0d58,
    0xcc2e, 0x6c3f, 0x2c1d, 0x8c0c, 0xac59, 0x0c48, 0x4c6a, 0xec7b,
    0x0cc0, 0xacd1, 0xecf3, 0x4ce2, 0x6cb7, 0xcca6, 0x8c84, 0x2c95,
    0x294d, 0x895c, 0xc97e, 0x696f, 0x493a, 0xe92b, 0xa909, 0x0918,
    0xe9a3, 0x49b2, 0x0990, 0xa981, 0x89d4, 0x29c5, 0x69e7, 0xc9f6,
    0x0880, 0xa891, 0xe8b3, 0x48a2, 0x68f7, 0xc8e6, 0x88c4, 0x28d5,
    0xc86e, 0x687f, 0x285d, 0x884c, 0xa819, 0x0808, 0x482a, 0xe83b,
    0x6ad7, 0xcac6, 0x8ae4, 0x2af5, 0x0aa0, 0xaab1, 0xea93, 0x4a82,
    0xaa39, 0x0a28, 0x4a0a, 0xea1b, 0xca4e, 0x6a5f, 0x2a7d, 0x8a6c,
    0x4b1a, 0xeb0b, 0xab29, 0x0b38, 0x2b6d, 0x8b7c, 0xcb5e, 0x6b4f,
    0x8bf4, 0x2be5, 0x6bc7, 0xcbd6, 0xeb83, 0x4b92, 0x0bb0, 0xaba1

################################################################################

TITLE
    liba52 scale_factor float

TYPE
    FLOAT

DATA
    0.000030517578125,
    0.0000152587890625,
    0.00000762939453125,
    0.000003814697265625,
    0.0000019073486328125,
    0.00000095367431640625,
    0.000000476837158203125,
    0.0000002384185791015625,
    0.00000011920928955078125,
    0.000000059604644775390625,
    0.0000000298023223876953125,
    0.00000001490116119384765625,
    0.000000007450580596923828125,
    0.0000000037252902984619140625,
    0.00000000186264514923095703125,
    0.000000000931322574615478515625,
    0.0000000004656612873077392578125,
    0.00000000023283064365386962890625,
    0.000000000116415321826934814453125,
    0.0000000000582076609134674072265625,
    0.00000000002910383045673370361328125,
    0.000000000014551915228366851806640625,
    0.0000000000072759576141834259033203125,
    0.00000000000363797880709171295166015625,
    0.000000000001818989403545856475830078125

################################################################################

TITLE
    libaf alaw_decode

TYPE
    16

DATA
{	 -5504,  -5248,  -6016,  -5760,  -4480,  -4224,  -4992,  -4736, 
	 -7552,  -7296,  -8064,  -7808,  -6528,  -6272,  -7040,  -6784, 
	 -2752,  -2624,  -3008,  -2880,  -2240,  -2112,  -2496,  -2368, 
	 -3776,  -3648,  -4032,  -3904,  -3264,  -3136,  -3520,  -3392, 
	-22016, -20992, -24064, -23040, -17920, -16896, -19968, -18944, 
	-30208, -29184, -32256, -31232, -26112, -25088, -28160, -27136, 
	-11008, -10496, -12032, -11520,  -8960,  -8448,  -9984,  -9472, 
	-15104, -14592, -16128, -15616, -13056, -12544, -14080, -13568, 
	  -344,   -328,   -376,   -360,   -280,   -264,   -312,   -296, 
	  -472,   -456,   -504,   -488,   -408,   -392,   -440,   -424, 
	   -88,    -72,   -120,   -104,    -24,     -8,    -56,    -40, 
	  -216,   -200,   -248,   -232,   -152,   -136,   -184,   -168, 
	 -1376,  -1312,  -1504,  -1440,  -1120,  -1056,  -1248,  -1184, 
	 -1888,  -1824,  -2016,  -1952,  -1632,  -1568,  -1760,  -1696, 
	  -688,   -656,   -752,   -720,   -560,   -528,   -624,   -592, 
	  -944,   -912,  -1008,   -976,   -816,   -784,   -880,   -848

################################################################################

TITLE
    libaf alaw_encode

TYPE
    8

DATA
{	0xD5, 0xD4, 0xD7, 0xD6, 0xD1, 0xD0, 0xD3, 0xD2, 0xDD, 0xDC, 0xDF, 0xDE, 
	0xD9, 0xD8, 0xDB, 0xDA, 0xC5, 0xC4, 0xC7, 0xC6, 0xC1, 0xC0, 0xC3, 0xC2, 
	0xCD, 0xCC, 0xCF, 0xCE, 0xC9, 0xC8, 0xCB, 0xCA, 0xF5, 0xF5, 0xF4, 0xF4, 
	0xF7, 0xF7, 0xF6, 0xF6, 0xF1, 0xF1, 0xF0, 0xF0, 0xF3, 0xF3, 0xF2, 0xF2, 
	0xFD, 0xFD, 0xFC, 0xFC, 0xFF, 0xFF, 0xFE, 0xFE, 0xF9, 0xF9, 0xF8, 0xF8, 
	0xFB, 0xFB, 0xFA, 0xFA, 0xE5, 0xE5, 0xE5, 0xE5, 0xE4, 0xE4, 0xE4, 0xE4, 
	0xE7, 0xE7, 0xE7, 0xE7, 0xE6, 0xE6, 0xE6, 0xE6, 0xE1, 0xE1, 0xE1, 0xE1, 
	0xE0, 0xE0, 0xE0, 0xE0, 0xE3, 0xE3, 0xE3, 0xE3, 0xE2, 0xE2, 0xE2, 0xE2, 
	0xED, 0xED, 0xED, 0xED, 0xEC, 0xEC, 0xEC, 0xEC, 0xEF, 0xEF, 0xEF, 0xEF, 
	0xEE, 0xEE, 0xEE, 0xEE, 0xE9, 0xE9, 0xE9, 0xE9, 0xE8, 0xE8, 0xE8, 0xE8, 
	0xEB, 0xEB, 0xEB, 0xEB, 0xEA, 0xEA, 0xEA, 0xEA, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB5, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 
	0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 
	0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 
	0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 
	0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 
	0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB6, 0xB6, 0xB6, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 
	0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 
	0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB3, 0xB3, 0xB3, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 
	0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 
	0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBC, 0xBC, 0xBC, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 
	0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 
	0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 
	0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 
	0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 
	0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xB9, 0xB9, 0xB9, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 
	0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 
	0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBA, 0xBA, 0xBA, 0xBA, 
	0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 
	0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 
	0xBA, 0xBA, 0xBA, 0xBA, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0x2A

################################################################################

TITLE
    libaf ulaw_decode

TYPE
    16

DATA
{	-32124, -31100, -30076, -29052, -28028, -27004, -25980, -24956, 
	-23932, -22908, -21884, -20860, -19836, -18812, -17788, -16764, 
	-15996, -15484, -14972, -14460, -13948, -13436, -12924, -12412, 
	-11900, -11388, -10876, -10364,  -9852,  -9340,  -8828,  -8316, 
	 -7932,  -7676,  -7420,  -7164,  -6908,  -6652,  -6396,  -6140, 
	 -5884,  -5628,  -5372,  -5116,  -4860,  -4604,  -4348,  -4092, 
	 -3900,  -3772,  -3644,  -3516,  -3388,  -3260,  -3132,  -3004, 
	 -2876,  -2748,  -2620,  -2492,  -2364,  -2236,  -2108,  -1980, 
	 -1884,  -1820,  -1756,  -1692,  -1628,  -1564,  -1500,  -1436, 
	 -1372,  -1308,  -1244,  -1180,  -1116,  -1052,   -988,   -924, 
	  -876,   -844,   -812,   -780,   -748,   -716,   -684,   -652, 
	  -620,   -588,   -556,   -524,   -492,   -460,   -428,   -396, 
	  -372,   -356,   -340,   -324,   -308,   -292,   -276,   -260, 
	  -244,   -228,   -212,   -196,   -180,   -164,   -148,   -132, 
	  -120,   -112,   -104,    -96,    -88,    -80,    -72,    -64, 
	   -56,    -48,    -40,    -32,    -24,    -16,     -8,      0, 

################################################################################

TITLE
    libaf ulaw_encode

TYPE
    8

DATA
{	0xFF, 0xFE, 0xFE, 0xFD, 0xFD, 0xFC, 0xFC, 0xFB, 0xFB, 0xFA, 0xFA, 0xF9, 
	0xF9, 0xF8, 0xF8, 0xF7, 0xF7, 0xF6, 0xF6, 0xF5, 0xF5, 0xF4, 0xF4, 0xF3, 
	0xF3, 0xF2, 0xF2, 0xF1, 0xF1, 0xF0, 0xF0, 0xEF, 0xEF, 0xEF, 0xEF, 0xEE, 
	0xEE, 0xEE, 0xEE, 0xED, 0xED, 0xED, 0xED, 0xEC, 0xEC, 0xEC, 0xEC, 0xEB, 
	0xEB, 0xEB, 0xEB, 0xEA, 0xEA, 0xEA, 0xEA, 0xE9, 0xE9, 0xE9, 0xE9, 0xE8, 
	0xE8, 0xE8, 0xE8, 0xE7, 0xE7, 0xE7, 0xE7, 0xE6, 0xE6, 0xE6, 0xE6, 0xE5, 
	0xE5, 0xE5, 0xE5, 0xE4, 0xE4, 0xE4, 0xE4, 0xE3, 0xE3, 0xE3, 0xE3, 0xE2, 
	0xE2, 0xE2, 0xE2, 0xE1, 0xE1, 0xE1, 0xE1, 0xE0, 0xE0, 0xE0, 0xE0, 0xDF, 
	0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0xDE, 0xDE, 0xDE, 0xDE, 0xDE, 
	0xDE, 0xDE, 0xDE, 0xDD, 0xDD, 0xDD, 0xDD, 0xDD, 0xDD, 0xDD, 0xDD, 0xDC, 
	0xDC, 0xDC, 0xDC, 0xDC, 0xDC, 0xDC, 0xDC, 0xDB, 0xDB, 0xDB, 0xDB, 0xDB, 
	0xDB, 0xDB, 0xDB, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xD9, 
	0xD9, 0xD9, 0xD9, 0xD9, 0xD9, 0xD9, 0xD9, 0xD8, 0xD8, 0xD8, 0xD8, 0xD8, 
	0xD8, 0xD8, 0xD8, 0xD7, 0xD7, 0xD7, 0xD7, 0xD7, 0xD7, 0xD7, 0xD7, 0xD6, 
	0xD6, 0xD6, 0xD6, 0xD6, 0xD6, 0xD6, 0xD6, 0xD5, 0xD5, 0xD5, 0xD5, 0xD5, 
	0xD5, 0xD5, 0xD5, 0xD4, 0xD4, 0xD4, 0xD4, 0xD4, 0xD4, 0xD4, 0xD4, 0xD3, 
	0xD3, 0xD3, 0xD3, 0xD3, 0xD3, 0xD3, 0xD3, 0xD2, 0xD2, 0xD2, 0xD2, 0xD2, 
	0xD2, 0xD2, 0xD2, 0xD1, 0xD1, 0xD1, 0xD1, 0xD1, 0xD1, 0xD1, 0xD1, 0xD0, 
	0xD0, 0xD0, 0xD0, 0xD0, 0xD0, 0xD0, 0xD0, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 
	0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCF, 0xCE, 
	0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 0xCE, 
	0xCE, 0xCE, 0xCE, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 
	0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCD, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 
	0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCB, 
	0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 0xCB, 
	0xCB, 0xCB, 0xCB, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 
	0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xCA, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 
	0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC9, 0xC8, 
	0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 0xC8, 
	0xC8, 0xC8, 0xC8, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 
	0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC7, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
	0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC5, 
	0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 0xC5, 
	0xC5, 0xC5, 0xC5, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 
	0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC4, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 
	0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC3, 0xC2, 
	0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 0xC2, 
	0xC2, 0xC2, 0xC2, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 
	0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC1, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 
	0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xBF, 
	0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 
	0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 
	0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBF, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 
	0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 
	0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 
	0xBE, 0xBE, 0xBE, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 
	0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 
	0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBD, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 
	0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBC, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 
	0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 
	0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 0xBB, 
	0xBB, 0xBB, 0xBB, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 
	0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 
	0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xBA, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 
	0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB9, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 0xB8, 
	0xB8, 0xB8, 0xB8, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 
	0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 
	0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB7, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 
	0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB6, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 0xB5, 
	0xB5, 0xB5, 0xB5, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 
	0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 
	0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB4, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 
	0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 0xB2, 
	0xB2, 0xB2, 0xB2, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 
	0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 
	0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB1, 0xB0, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 
	0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xB0, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 
	0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAF, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 0xAE, 
	0xAE, 0xAE, 0xAE, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 
	0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAD, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 
	0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 
	0xAB, 0xAB, 0xAB, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 
	0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 
	0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA9, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 0xA8, 
	0xA8, 0xA8, 0xA8, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 
	0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA7, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 
	0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA6, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 
	0xA5, 0xA5, 0xA5, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 
	0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA4, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 
	0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 0xA2, 
	0xA2, 0xA2, 0xA2, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 
	0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA1, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 
	0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 
	0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9F, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 0x9E, 
	0x9E, 0x9E, 0x9E, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 
	0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 
	0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9C, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 
	0x9B, 0x9B, 0x9B, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 
	0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x9A, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 
	0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 
	0x98, 0x98, 0x98, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 
	0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x97, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 
	0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x96, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 0x95, 
	0x95, 0x95, 0x95, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 
	0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x94, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 
	0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x93, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 
	0x92, 0x92, 0x92, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 
	0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x91, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 
	0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 
	0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8F, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 0x8E, 
	0x8E, 0x8E, 0x8E, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 
	0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8D, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 
	0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8C, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 0x8B, 
	0x8B, 0x8B, 0x8B, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 
	0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x8A, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 
	0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x89, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 
	0x88, 0x88, 0x88, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 
	0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x87, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 
	0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x86, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 0x85, 
	0x85, 0x85, 0x85, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 
	0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 
	0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 
	0x82, 0x82, 0x82, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 
	0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00

################################################################################

TITLE
    libaf center front (-5 degrees)

TYPE
    FLOAT

DATA
   -0.00008638082319075036, 0.0003198059946385229,
   -0.0005010631339162132, 0.0011424741331126876,
   -0.001584220794688753, 0.001742715363246275,
   -0.0011080796626780694, 0.0001651829990860167,
   0.005235028337314985, 0.0035223828473357776,
   0.010057681388431303, -0.033469432129545514,
   0.013391253316233523, 0.004858462839827063,
   0.08172161220103627, 0.26158596134500023,
   -0.12420314583323326, -0.14298458356097565,
   0.14421897280453896, -0.1635792507629016,
   -0.02187136722480014, 0.2426863044711817,
   0.07229814207917194, 0.0942742651913879,
   0.29856830878076834, 0.2944146162057754,
   -0.12122157003421209, -0.19640092165631157,
   0.11623836502034968, -0.05794027397995521,
   -0.34313138341973776, -0.19487516249168105,
   0.010118993953802401, -0.09460218797710966,
   -0.16761521117359582, 0.004154461610153861,
   0.052768641758969316, -0.00041823982226147407,
   0.021634960445143514, 0.07562793486871108,
   0.08895407129506479, 0.039857755093416214,
   0.044257936180422945, 0.061557584906101664,
   0.015547268541895703, -0.023908191934932484,
   0.009498030443468223, 0.03816269003221337,
   -0.009820500607303615, -0.042003975527908084,
   -0.03335447117311547, -0.029294510859746596,
   -0.05212623136198511, -0.073427547153205,
   -0.061190797824958836, -0.04620925059966413,
   -0.04204619420702159, -0.02331915902615157,
   0.00211481411477094, 0.00852563995740107,
   0.008766809731743399, 0.008666632180812078,
   0.018279202191625352, 0.02924332751289675,
   0.022293148257836494, 0.012362146008584188,
   0.008572582458807008, 0.006491370763597344,
   -0.0019366944997535774, -0.006318669309634434,
   -0.006457921690218669, -0.015050265524669974,
   -0.02110660282616213, -0.017027809096377904,
   -0.01651052305334348, -0.022770064150046673,
   -0.01999875754219472, -0.012294792027337775,
   -0.011506057031057188, -0.011448970577312903,
   -0.004823572302580925, 0.0022451134042777883,
   0.004145473526859826, 0.005629030064546135,
   0.008588029213398785, 0.010092048834844231,
   0.007182013245552008, 0.0014600979508720656,
   -0.0038314646272511756, -0.003443901997881347,
   -0.0029483418254804047, -0.007609357112679647,
   -0.006518368948030822, -0.004495803701497202,
   -0.007109113004849672, -0.008346237278084265,
   -0.005560847336252453, -0.002993453167553188,
   -0.005122897816824269, -0.004389782626604215,
   -0.0010912633695218108, -0.0019712029474458835,
   -0.005870162265802235, -0.005626159534954128,
   -0.00027254977910844407, 0.0013794425431633785,
   -0.0005919083190430062, -0.0007861203545416682,
   -0.0007049560240893946, -0.0032720188494468868,
   -0.004460645567968504, -0.0032018528193571696,
   -0.0030579229375062105, -0.003593998902656612,
   -0.0038032977997776445, -0.004613776010454773,
   -0.0059796549143736845, -0.00420126194319768,
   -0.0012374419948287222, 0.0008572699213050608,
   0.0021490971020081094, 0.00047295283198381995,
   -0.0009670277915884887, -0.001354440866080231,
   -0.002962902746547851, -0.00533935813338141,
   -0.005469203016468759, -0.004355784273189485

################################################################################

TITLE
    libaf front same side (30 degree)

TYPE
    FLOAT

DATA
   -0.004140580614755493, 0.005790934614385445,
   0.003318916682081112, 0.014257145544366063,
   0.007328442487127339, -0.06550381777876194,
   0.03502225818161845, -0.013090579770708259,
   0.2517776798694195, 0.420770489950659,
   -0.3418854608834852, -0.24371032493696737,
   0.04901356150030018, -0.1778083521632833,
   0.26448004245714163, 0.23245199964546834,
   0.033053145803936305, 0.46811222821062415,
   0.5359265986255611, -0.011912195468533787,
   -0.39763432601411647, -0.034482864386898314,
   0.029445398240649626, -0.3850940407863262,
   -0.3272328478175581, -0.14701421403616477,
   -0.08522137400169517, -0.14936851633336035,
   -0.09432605283433723, 0.0991200405937827,
   0.011075012089917331, -0.0051036489980274685,
   0.0933903289749412, 0.1344189369609565,
   0.10507466913017807, 0.04240159324684365,
   0.06559270110638656, 0.026984119875617524,
   -0.03359846103238096, -0.018000197099174275,
   0.042031818548178244, 0.03849039666888434,
   -0.02450829674011345, -0.03407882403088576,
   -0.029230189282961977, -0.046964865291761734,
   -0.09458258700116245, -0.1527349330901158,
   -0.15411577687826097, -0.08761679790956928,
   -0.033623549089171874, -0.007204768531481949,
   0.008273425020444852, 0.021368717994908505,
   0.04366608267875025, 0.05660907333076205,
   0.06775726495503939, 0.05621881735271431,
   0.03576231950669927, 0.02500825834889175,
   0.015423811076054601, 0.007903258334503761,
   -0.0053873014137761945, -0.006987955469434698,
   -0.012027972007598602, -0.025228281243816594,
   -0.026225091797257318, -0.023809293997344882,
   -0.03250172017712295, -0.03195696301067249,
   -0.01784813952189948, -0.01663267233760342,
   -0.016184530450468065, -0.011659883749357463,
   -0.0035378511240219163, -0.0005485800790443406,
   0.0018432660108168625, 0.011634844139907534,
   0.018333603402051105, 0.020447379185133056,
   0.00850783664147828, 0.0004694148911037838,
   -0.0017047130409786676, -0.0022409152834483997,
   -0.000860472174892845, -0.004111075059198666,
   -0.003527843382056666, -0.009640160874903018,
   -0.01750044574231376, -0.015613389403672443,
   -0.010790028120953001, -0.0095313499955768,
   -0.007469721416726809, -0.0019186578145117315,
   -0.00014977322572890802, -0.0029803838028179728,
   -0.006520567233727221, 0.000035015132033882596,
   0.009245098100543752, 0.009896930052308656,
   0.008316744929565786, 0.004575207140193997,
   -0.0000647420103997081, -0.004502916832871627,
   -0.004225962213251224, -0.002886014126381486,
   -0.006416834142585976, -0.007156609995423569,
   -0.008840274447579472, -0.01441763751386817,
   -0.015435817484659574, -0.00924487254924743,
   -0.0021571721940235205, 0.0028540722992305453,
   0.00273577475088536, -0.000788412365513805,
   -0.0032650029728365907, -0.003880217646231338,
   -0.0035302087299613778, -0.0038531436176586246,
   -0.0011921632190514074, -0.0020722967099011938,
   -0.004985351145629344, -0.0042375588844648735,
   -0.003030360463006021, -0.0014161075428041471,
   -0.0005083025643192044, 0.00035096963769606926

################################################################################

TITLE
    libaf front opposite side (-30 degree)

TYPE
    FLOAT

DATA
   -0.000013472538374193126, -0.00008048061877079751,
   0.000043927265781258155, -0.000017931700794858892,
   -0.000034774602476112886, -0.00009576223008735474,
   0.0001557797638630691, -0.00018742885883751094,
   0.00026512448626705716, -0.0001451040203319678,
   -0.00008263233117758043, 0.0006486245853639179,
   -0.0010631408451846698, 0.0026571994100746143,
   0.0014179177997092787, 0.0062326502956616256,
   -0.008194149324545333, -0.006568029415878379,
   0.009538759710818582, 0.012309193558632693,
   0.12336638055838955, 0.046164307101829005,
   -0.10228706407884815, 0.04047687260345798,
   -0.00296595313977046, -0.07057949208414134,
   0.08172114840714612, 0.08736490764127891,
   0.05105250431333021, 0.11627179512747428,
   0.20717888490340705, 0.09375052213570291,
   -0.09784374168330194, -0.010493571845901443,
   0.053131894303891716, -0.10157443971694806,
   -0.16264032634244974, -0.05402369511361273,
   -0.0274403608654217, -0.09860277022495063,
   -0.06841875821090282, -0.004434574400066223,
   -0.0005222661652743502, -0.006231881259827263,
   0.014410397820340159, 0.04885649512730243,
   0.04361962569042684, 0.03399214029009391,
   0.04961073933475931, 0.04067325604132289,
   0.007850647519227257, 0.004564440466905299,
   0.02257107958021618, 0.008183791928884486,
   -0.014913479343180557, -0.018685938460856224,
   -0.01745737397226911, -0.02327177054233603,
   -0.03723048632685227, -0.044739390162299685,
   -0.042651220125613766, -0.03730017561004743,
   -0.029039465434276192, -0.01885087458914294,
   -0.01207127752277769, -0.006779800724164512,
   -0.001930416967444157, 0.000029454577995528385,
   0.0013822760965755472, 0.0014799128583230202,
   0.0002068200609199832, 0.0022254295286201083,
   0.005143858159434566, 0.0018580542060917013,
   -0.0019426046325146259, -0.0014464042108543495,
   -0.0034430083560735582, -0.009692758426099499,
   -0.011840035292593485, -0.010716508855893968,
   -0.012939889036853034, -0.0121846427935653,
   -0.006198503315630782, -0.0023186723099380305,
   -0.002679872498314837, -0.003086020446226295,
   -0.0015709623347698936, -0.0008147490468332398,
   -0.0012384575726770983, -0.0005212877089109362,
   0.0017707578744906142, 0.001324932723905786,
   -0.0017023653780617696, -0.0045108927752919425,
   -0.005422155613096912, -0.0039489323837623835,
   -0.005295995750506547, -0.00629706566356189,
   -0.004685732198036754, -0.0048076735568143,
   -0.005978864279217503, -0.005928999306332966,
   -0.004187703549017582, -0.003213999896976475,
   -0.0028068699816073414, -0.0010889703907593833,
   0.0003276714243495386, -0.0013015007040186994,
   -0.003208050402434782, -0.0025115319088208545,
   -0.0013787553006401076, -0.0018279087370218635,
   -0.0025904836507747754, -0.002071221947222004,
   -0.0026424212922485594, -0.0039837031817577,
   -0.0041635566057380965, -0.004355223489150822,
   -0.004350395332709937, -0.0036693292471930263,
   -0.003386384394185026, -0.003972568655001128,
   -0.004332336840023821, -0.002648767912111827,
   -0.001384410080218114, -0.0011353792711849466,
   -0.0013726264946164232, -0.0020075119315034313

################################################################################

TITLE
    libaf rear same side (135 degree)

TYPE
    FLOAT

DATA
   0.004573315040810066, 0.0013592578059426913,
   0.01553271930902704, -0.0002356117224941317,
   -0.05746098219774702, 0.03430688963370445,
   0.00808371687447385, 0.21893535841158596,
   0.2984357591724814, -0.3302799746504719,
   -0.3194029149806245, 0.21633225051331056,
   0.24371260938097083, -0.08843705549751085,
   0.03939684701343366, 0.45386926431114494,
   0.07599118140753386, -0.18114706160474578,
   0.285640624686038, 0.4049515236666218,
   -0.05347890222071792, -0.31464359045319074,
   -0.1033502246468194, -0.04553593949283157,
   -0.1880747731157464, -0.13629090230626037,
   -0.10435789106123239, -0.19818232801888755,
   -0.16701805476330397, -0.022793111199284,
   0.058049696762683685, 0.007048321372693906,
   -0.002966419183225961, 0.10140569697797763,
   0.11648999956673124, 0.05218347182779882,
   0.028427001212735392, 0.04151900310166159,
   -0.0006960604221423734, -0.05898623212226975,
   -0.03801934531173312, -0.029306970535287986,
   -0.04549125782835908, -0.0599222718506552,
   -0.058299618975430116, -0.03765579129720727,
   -0.03559302657499581, -0.020647901025903054,
   -0.005720957338744348, -0.0041915732688915545,
   -0.0011470880098346143, 0.008737404798553,
   0.023444168098121512, 0.024204226042172663,
   0.01894897166475026, 0.020807655257479588,
   0.021570431128040954, 0.006800556178576289,
   -0.009000089216921362, -0.010969824547067934,
   -0.0033653428332822374, -0.012676936164668659,
   -0.026739938673413587, -0.023427869194287573,
   -0.023302007105117244, -0.023647155590533712,
   -0.021289317515613106, -0.009120487305069884,
   0.0009251551667728967, 0.00004285344125653763,
   -0.00009042365479456271, 0.00022573242339446494,
   0.00720168491586098, 0.007111875505402431,
   0.003186514817683482, 0.00810087718334745,
   0.012619557025922575, 0.007854726400013397,
   -0.0024013592881066267, -0.001452457473161119,
   -0.0025535188366093945, -0.012428911627809337,
   -0.013729251536694145, -0.0070099675146427344,
   -0.007165284278706593, -0.01639289295622301,
   -0.015831795079778305, -0.007305768485523729,
   -0.003608863157004021, -0.0032640528878698084,
   0.0030901263998481944, 0.00749497566124848,
   0.002515185532327241, 0.00004840875738621367,
   0.0017596043486043966, 0.0046229941553338144,
   0.0034259167322926096, 0.003707347634186093,
   0.0035584806528586328, -0.0019078936035275198,
   -0.006057343815214898, -0.0069262470468817,
   -0.004345020728618624, -0.004177623355574794,
   -0.005373506556122508, -0.006624933928893836,
   -0.008679541408588839, -0.010718719681595322,
   -0.011392246979594496, -0.007893917064389902,
   -0.0027572935365832536, -0.00006064707149834412,
   -0.0012512537319656323, -0.0024501501002409786,
   -0.0022106788572895998, -0.00234124933370301,
   -0.0008953445167066823, 0.0005393670625637734,
   -0.00033175600142209297, -0.004023994309351289,
   -0.008655472335784443, -0.009899957354849682,
   -0.008664952919996412, -0.00553483124503576,
   -0.003735336089277662, -0.002754824348643885,
   -0.0026884314856593368, -0.004084181815125924

################################################################################

TITLE
    libaf rear opposite side (-135 degree)

TYPE
    FLOAT

DATA
   0.0001220944028243897, -0.000021785381808441314,
   5.823057988603169e-6, -0.00001217768176447613,
   -0.00006123604397345513, 5.574117262531134e-6,
   -0.00004935331914366778, 1.1771577934768211e-6,
   -0.000059236211621095756, 9.503536190497286e-6,
   -0.0001494445696103564, 0.00012248858284145305,
   -0.0000963975321456313, 6.017905197665205e-6,
   0.00003353395360402643, -0.0001931511015359506,
   0.0005113536523931485, -0.0005676652619386114,
   0.0012057159755477467, 0.0009370492250339692,
   0.004596472288877981, -0.0018831773384237068,
   -0.008208535225621212, 0.0038178646400751056,
   0.008726517739105965, 0.06664363898418262,
   0.06788684221502142, -0.04492315162807267,
   -0.04019906311255255, 0.026203059677375153,
   0.013678129114847544, -0.014334962223993527,
   0.010141709596167392, 0.11559131576945537,
   0.1586402064538425, 0.059975334707967023,
   0.004671725963777715, 0.031498678282775874,
   0.014338626006524587, -0.014749719448472231,
   -0.02055508237941379, -0.05407690143992048,
   -0.07767559836886143, -0.05029091786216801,
   -0.030808335706574427, -0.03401958135442541,
   -0.030520368430288967, -0.014168302104259355,
   0.011907621259989802, 0.014286081013069,
   0.006377467879613449, 0.018546823568277478,
   0.028297012771618273, 0.025222339408338186,
   0.021931611353415138, 0.019708894333646355,
   0.01729258494072014, 0.017468204169564034,
   0.009729094845051928, -0.002976992018531901,
   -0.00956986166277019, -0.016125733548332074,
   -0.02934094241442545, -0.04133767871051455,
   -0.043536981145416466, -0.0385966307108608,
   -0.02784453599342459, -0.018995135307247116,
   -0.012849534096536747, -0.004437491064613308,
   0.00028385411598204655, 0.003776874988516643,
   0.008069432041547833, 0.008764754183751848,
   0.008020908861878062, 0.006830351461360802,
   0.002218330884267235, -0.0020478725582339444,
   -0.003997428121462543, -0.007066287373515421,
   -0.00940847412544698, -0.010938998446237963,
   -0.011775483016151306, -0.011391103919484287,
   -0.010586061195163017, -0.009842793078929053,
   -0.007753202010139829, -0.00569213732353025,
   -0.006506783349722073, -0.005346134281903736,
   -0.003913089814898934, -0.0036091443854759727,
   -0.0020328564301266287, 0.00017932870773467683,
   0.0032779786679056357, 0.003969695813293966,
   0.0020339334412434987, -0.00011345940675415259,
   -0.0018344103399567666, -0.003556764701666365,
   -0.004263523639408391, -0.002940568582022133,
   -0.0034341188272627556, -0.006023399920020824,
   -0.0077456903203677865, -0.007912219312377842,
   -0.00625202770436523, -0.00530785086116117,
   -0.005569722659634311, -0.004664448462594344,
   -0.0037747773914077747, -0.004175649656985592,
   -0.004659601521384289, -0.005008602967819641,
   -0.004730625079902729, -0.0034039554356604146,
   -0.0017110333873406587, -0.0006091938771510242,
   -0.0016051679050678297, -0.003312864664007262,
   -0.004505512715977288, -0.004152222189861692,
   -0.003218596419678823, -0.0027277806209877343,
   -0.001715005444317267, -0.0012589960071233749,
   -0.001852908777923165, -0.002540339553144362

################################################################################

TITLE
    libaf center rear (180 degree)

TYPE
    FLOAT

DATA
   -0.00005989110716536726, -0.00022790291829128702,
   0.0002659166098971966, -0.0003774772716776257,
   0.0004540309551867803, -0.000420238187386368,
   0.00025518536450885686, 0.00028285526288953955,
   -0.001016391007574093, 0.0028634984299063795,
   0.0021574799687976045, 0.01035121276682072,
   -0.010481720917298163, -0.013197198495899292,
   0.0031928225328717195, 0.02903137843618603,
   0.1632429772511569, 0.1047487989875262,
   -0.10464685060623742, -0.09260196288035998,
   -0.007514241993554443, 0.013596249226741712,
   -0.019876166508450258, 0.1255626123599804,
   0.3648170359521724, 0.19458249753223478,
   -0.04434070930031298, 0.046582528121935265,
   0.09484427347230277, -0.03137795311969644,
   -0.10297437925363695, -0.09351091015917065,
   -0.1129521092162064, -0.14925322995658827,
   -0.1231466295584665, -0.06356719756705227,
   -0.05442277895126282, -0.07568433015661316,
   -0.023314932828602003, 0.04260950721318558,
   0.02249026315598923, 0.02048195669571197,
   0.05651342117268278, 0.05885038917623213,
   0.03797102097397795, 0.011767394419953451,
   0.00560502503429481, 0.005051125343961189,
   -0.012925933188033823, -0.023918884651306566,
   -0.013251659441678816, -0.010694772488866284,
   -0.03080486448617846, -0.03661278237783158,
   -0.0379227303416262, -0.042189005718490775,
   -0.026595666344596286, -0.009759025956801257,
   -0.002064986663513004, -0.002420117028098389,
   -0.006629991977552491, 0.004619970897631026,
   0.019450642967537877, 0.0173521119057514,
   0.017641425439988062, 0.02270029598048491,
   0.018976431925275348, 0.009299852902290885,
   -0.001695039371619912, -0.00675162574265618,
   -0.009380968871003034, -0.011208396125485165,
   -0.01308640049201482, -0.0165636375633249,
   -0.022004099870933345, -0.025173458684139286,
   -0.016918759559175375, -0.00865150653575917,
   -0.006999929082792643, -0.005454830010518988,
   -0.0021129521131095317, 0.00018717090054046307,
   -0.0002864344788569993, 0.0017615225381095569,
   0.006985907557802283, 0.010577308310476465,
   0.006466104789306027, -0.0014988738575948326,
   -0.0039669755229277195, -0.0065156971200080235,
   -0.009343206924192169, -0.0076430644693577495,
   -0.004395214976600924, -0.003052735340422483,
   -0.007019103043066595, -0.00974109267696527,
   -0.007968015032797376, -0.007801513845528344,
   -0.007535748903681969, -0.003543341967287925,
   0.0015083125553729722, 0.0023345972556147025,
   -0.0010043623069557037, -0.0025295765105203746,
   -0.0023701840891643634, -0.0005908186035024362,
   0.0029826252289082847, 0.004829048542117764,
   0.004488360022902081, 0.00002643748103005408,
   -0.0042100779212597295, -0.006170600558114495,
   -0.007267149164680168, -0.006825522903494639,
   -0.006899834372739123, -0.0073493916110062675,
   -0.009554351265163382, -0.011790297433830197,
   -0.010645796603734424, -0.0064661575394022106,
   -0.002026743466524137, -0.0004337034584909932,
   -0.0011172647031654614, -0.0017947816283674731,
   -0.00255615052036616, -0.0017721562881944813,
   -0.0002379619297227554, 0.0007130120121089036

################################################################################

TITLE
    libavcodec 4XM mv

TYPE
    8

DATA
{  0,  0},{  0, -1},{ -1,  0},{  1,  0},{  0,  1},{ -1, -1},{  1, -1},{ -1,  1},
{  1,  1},{  0, -2},{ -2,  0},{  2,  0},{  0,  2},{ -1, -2},{  1, -2},{ -2, -1},
{  2, -1},{ -2,  1},{  2,  1},{ -1,  2},{  1,  2},{ -2, -2},{  2, -2},{ -2,  2},
{  2,  2},{  0, -3},{ -3,  0},{  3,  0},{  0,  3},{ -1, -3},{  1, -3},{ -3, -1},
{  3, -1},{ -3,  1},{  3,  1},{ -1,  3},{  1,  3},{ -2, -3},{  2, -3},{ -3, -2},
{  3, -2},{ -3,  2},{  3,  2},{ -2,  3},{  2,  3},{  0, -4},{ -4,  0},{  4,  0},
{  0,  4},{ -1, -4},{  1, -4},{ -4, -1},{  4, -1},{  4,  1},{ -1,  4},{  1,  4},
{ -3, -3},{ -3,  3},{  3,  3},{ -2, -4},{ -4, -2},{  4, -2},{ -4,  2},{ -2,  4},
{  2,  4},{ -3, -4},{  3, -4},{  4, -3},{ -5,  0},{ -4,  3},{ -3,  4},{  3,  4},
{ -1, -5},{ -5, -1},{ -5,  1},{ -1,  5},{ -2, -5},{  2, -5},{  5, -2},{  5,  2},
{ -4, -4},{ -4,  4},{ -3, -5},{ -5, -3},{ -5,  3},{  3,  5},{ -6,  0},{  0,  6},
{ -6, -1},{ -6,  1},{  1,  6},{  2, -6},{ -6,  2},{  2,  6},{ -5, -4},{  5,  4},
{  4,  5},{ -6, -3},{  6,  3},{ -7,  0},{ -1, -7},{  5, -5},{ -7,  1},{ -1,  7},
{  4, -6},{  6,  4},{ -2, -7},{ -7,  2},{ -3, -7},{  7, -3},{  3,  7},{  6, -5},
{  0, -8},{ -1, -8},{ -7, -4},{ -8,  1},{  4,  7},{  2, -8},{ -2,  8},{  6,  6},
{ -8,  3},{  5, -7},{ -5,  7},{  8, -4},{  0, -9},{ -9, -1},{  1,  9},{  7, -6},
{ -7,  6},{ -5, -8},{ -5,  8},{ -9,  3},{  9, -4},{  7, -7},{  8, -6},{  6,  8},
{ 10,  1},{-10,  2},{  9, -5},{ 10, -3},{ -8, -7},{-10, -4},{  6, -9},{-11,  0},
{ 11,  1},{-11, -2},{ -2, 11},{  7, -9},{ -7,  9},{ 10,  6},{ -4, 11},{  8, -9},
{  8,  9},{  5, 11},{  7,-10},{ 12, -3},{ 11,  6},{ -9, -9},{  8, 10},{  5, 12},
{-11,  7},{ 13,  2},{  6,-12},{ 10,  9},{-11,  8},{ -7, 12},{  0, 14},{ 14, -2},
{ -9, 11},{ -6, 13},{-14, -4},{ -5,-14},{  5, 14},{-15, -1},{-14, -6},{  3,-15},
{ 11,-11},{ -7, 14},{ -5, 15},{  8,-14},{ 15,  6},{  3, 16},{  7,-15},{-16,  5},
{  0, 17},{-16, -6},{-10, 14},{-16,  7},{ 12, 13},{-16,  8},{-17,  6},{-18,  3},
{ -7, 17},{ 15, 11},{ 16, 10},{  2,-19},{  3,-19},{-11,-16},{-18,  8},{-19, -6},
{  2,-20},{-17,-11},{-10,-18},{  8, 19},{-21, -1},{-20,  7},{ -4, 21},{ 21,  5},
{ 15, 16},{  2,-22},{-10,-20},{-22,  5},{ 20,-11},{ -7,-22},{-12, 20},{ 23, -5},
{ 13,-20},{ 24, -2},{-15, 19},{-11, 22},{ 16, 19},{ 23,-10},{-18,-18},{ -9,-24},
{ 24,-10},{ -3, 26},{-23, 13},{-18,-20},{ 17, 21},{ -4, 27},{ 27,  6},{  1,-28},
{-11, 26},{-17,-23},{  7, 28},{ 11,-27},{ 29,  5},{-23,-19},{-28,-11},{-21, 22},
{-30,  7},{-17, 26},{-27, 16},{ 13, 29},{ 19,-26},{ 10,-31},{-14,-30},{ 20,-27},
{-29, 18},{-16,-31},{-28,-22},{ 21,-30},{-25, 28},{ 26,-29},{ 25,-32},{-32,-32}

################################################################################

TITLE
    scaled down product of jpeg quantizer and AAN premul table

TYPE
    8

DATA
 16, 15, 13, 19, 24, 31, 28, 17,
 17, 23, 25, 31, 36, 63, 45, 21,
 18, 24, 27, 37, 52, 59, 49, 20,
 16, 28, 34, 40, 60, 80, 51, 20,
 18, 31, 48, 66, 68, 86, 56, 21,
 19, 38, 56, 59, 64, 64, 48, 20,
 27, 48, 55, 55, 56, 51, 35, 15,
 20, 35, 34, 32, 31, 22, 15,  8,


################################################################################

TITLE
    libavcodec ASUS V1/V2 codec asv2_level_tab

TYPE
    8 HEX

DATA
 3f 0a 2f 0a 37 0a 27 0a 3b 0a 2b 0a 33 0a 23 0a
 3d 0a 2d 0a 35 0a 25 0a 39 0a 29 0a 31 0a 21 0a
 1f 08 17 08 1b 08 13 08 1d 08 15 08 19 08 11 08
 0f 06 0b 06 0d 06 09 06 07 04 05 04 03 02 00 05
 02 02 04 04 06 04 08 06 0c 06 0a 06 0e 06 10 08
 18 08 14 08 1c 08 12 08 1a 08 16 08 1e 08 20 0a
 30 0a 28 0a 38 0a 24 0a 34 0a 2c 0a 3c 0a 22 0a
 32 0a 2a 0a 3a 0a 26 0a 36 0a 2e 0a 3e 0a

################################################################################

TITLE
    libavcodec H.26L/H.264/AVC/JVT/14496-10 lps_range

TYPE
    8

DATA
{128,176,208,240}, {128,167,197,227}, {128,158,187,216}, {123,150,178,205},
{116,142,169,195}, {111,135,160,185}, {105,128,152,175}, {100,122,144,166},
{ 95,116,137,158}, { 90,110,130,150}, { 85,104,123,142}, { 81, 99,117,135},
{ 77, 94,111,128}, { 73, 89,105,122}, { 69, 85,100,116}, { 66, 80, 95,110},
{ 62, 76, 90,104}, { 59, 72, 86, 99}, { 56, 69, 81, 94}, { 53, 65, 77, 89},
{ 51, 62, 73, 85}, { 48, 59, 69, 80}, { 46, 56, 66, 76}, { 43, 53, 63, 72},
{ 41, 50, 59, 69}, { 39, 48, 56, 65}, { 37, 45, 54, 62}, { 35, 43, 51, 59},
{ 33, 41, 48, 56}, { 32, 39, 46, 53}, { 30, 37, 43, 50}, { 29, 35, 41, 48},
{ 27, 33, 39, 45}, { 26, 31, 37, 43}, { 24, 30, 35, 41}, { 23, 28, 33, 39},
{ 22, 27, 32, 37}, { 21, 26, 30, 35}, { 20, 24, 29, 33}, { 19, 23, 27, 31},
{ 18, 22, 26, 30}, { 17, 21, 25, 28}, { 16, 20, 23, 27}, { 15, 19, 22, 25},
{ 14, 18, 21, 24}, { 14, 17, 20, 23}, { 13, 16, 19, 22}, { 12, 15, 18, 21},
{ 12, 14, 17, 20}, { 11, 14, 16, 19}, { 11, 13, 15, 18}, { 10, 12, 15, 17},
{ 10, 12, 14, 16}, {  9, 11, 13, 15}, {  9, 11, 12, 14}, {  8, 10, 12, 14},
{  8,  9, 11, 13}, {  7,  9, 11, 12}, {  7,  9, 10, 12}, {  7,  8, 10, 11},
{  6,  8,  9, 11}, {  6,  7,  9, 10}, {  6,  7,  8,  9}, {  2,  2,  2,  2},

################################################################################

TITLE
    libavcodec H.26L/H.264/AVC/JVT/14496-10 ff_h264_norm_shift

TYPE
    8

DATA
 9,8,7,7,6,6,6,6,5,5,5,5,5,5,5,5,
 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

################################################################################

TITLE
    libavcodec H.26L/H.264/AVC/JVT/14496-10 ff_h264_norm_shift_old

TYPE
    8

DATA
 7,6,5,5,4,4,4,4,3,3,3,3,3,3,3,3,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

################################################################################

TITLE
    libavcodec Chinese AVS video (AVS1-P2, JiZhun) cbp_tab

TYPE
    8

DATA
  {63, 0},{15,15},{31,63},{47,31},{ 0,16},{14,32},{13,47},{11,13},
  { 7,14},{ 5,11},{10,12},{ 8, 5},{12,10},{61, 7},{ 4,48},{55, 3},
  { 1, 2},{ 2, 8},{59, 4},{ 3, 1},{62,61},{ 9,55},{ 6,59},{29,62},
  {45,29},{51,27},{23,23},{39,19},{27,30},{46,28},{53, 9},{30, 6},
  {43,60},{37,21},{60,44},{16,26},{21,51},{28,35},{19,18},{35,20},
  {42,24},{26,53},{44,17},{32,37},{58,39},{24,45},{20,58},{17,43},
  {18,42},{48,46},{22,36},{33,33},{25,34},{49,40},{40,52},{36,49},
  {34,50},{50,56},{52,25},{54,22},{41,54},{56,57},{38,41},{57,38}

################################################################################

TITLE
    libavcodec Chinese AVS video (AVS1-P2, JiZhun) dequant_mul

TYPE
    16

DATA
  32768,36061,38968,42495,46341,50535,55437,60424,
  32932,35734,38968,42495,46177,50535,55109,59933,
  65535,35734,38968,42577,46341,50617,55027,60097,
  32809,35734,38968,42454,46382,50576,55109,60056,
  65535,35734,38968,42495,46320,50515,55109,60076,
  65535,35744,38968,42495,46341,50535,55099,60087,
  65535,35734,38973,42500,46341,50535,55109,60097,
  32771,35734,38965,42497,46341,50535,55109,60099

################################################################################

TITLE
    libavcodec Chinese AVS video (AVS1-P2, JiZhun) intra_2dvlc

TYPE
    8 HEX

DATA
 01 01 01 ff 01 01 01 02 01 ff 02 01 01 03 01 ff
 03 01 01 04 01 ff 04 01 01 05 01 ff 05 01 01 06
 01 ff 06 01 01 07 01 ff 07 01 01 08 01 ff 08 01
 01 09 01 ff 09 01 01 0a 01 ff 0a 01 01 0b 01 ff
 0b 01 02 01 02 fe 01 02 01 0c 01 ff 0c 01 01 0d
 01 ff 0d 01 01 0e 01 ff 0e 01 01 0f 01 ff 0f 01
 02 02 02 fe 02 02 01 10 01 ff 10 01 01 11 01 ff
 11 01 03 01 03 fd 01 03 01 12 01 ff 12 01 01 13
 01 ff 13 01 02 03 02 fe 03 02 01 14 01 ff 14 01
 01 15 01 ff 15 01 02 04 02 fe 04 02 01 16 01 ff
 16 01 02 05 02 fe 05 02 01 17 01 ff 17 01 00 00
 00 00 04 03 03 03 03 02 02 02 02 02 02 02 02 02
 02 02 02 02 02 02 02 02 02 ff ff ff 02 00 00 00
 00 00 00 00 17 00 00 00 01 01 00 ff 01 00 01 02
 00 ff 02 00 02 01 01 fe 01 01 01 03 00 ff 03 00
 00 00 00 01 04 00 ff 04 00 01 05 00 ff 05 00 01
 06 00 ff 06 00 03 01 02 fd 01 02 02 02 01 fe 02
 01 01 07 00 ff 07 00 01 08 00 ff 08 00 01 09 00
 ff 09 00 02 03 01 fe 03 01 04 01 02 fc 01 02 01
 0a 00 ff 0a 00 01 0b 00 ff 0b 00 02 04 01 fe 04
 01 03 02 02 fd 02 02 01 0c 00 ff 0c 00 02 05 01
 fe 05 01 05 01 03 fb 01 03 01 0d 00 ff 0d 00 02
 06 01 fe 06 01 01 0e 00 ff 0e 00 02 07 01 fe 07
 01 02 08 01 fe 08 01 03 03 02 fd 03 02 06 01 03
 fa 01 03 01 0f 00 ff 0f 00 00 07 04 04 03 03 03
 03 03 02 02 02 02 02 02 02 ff ff ff ff ff ff ff
 ff ff ff ff 02 00 00 00 01 00 00 00 0f 00 00 00
 01 01 00 ff 01 00 02 01 00 fe 01 00 01 02 00 ff
 02 00 03 01 01 fd 01 01 00 00 00 01 03 00 ff 03
 00 02 02 00 fe 02 00 04 01 01 fc 01 01 01 04 00
 ff 04 00 05 01 02 fb 01 02 01 05 00 ff 05 00 03
 02 01 fd 02 01 02 03 00 fe 03 00 01 06 00 ff 06
 00 06 01 02 fa 01 02 02 04 00 fe 04 00 01 07 00
 ff 07 00 04 02 01 fc 02 01 07 01 02 f9 01 02 03
 03 01 fd 03 01 02 05 00 fe 05 00 01 08 00 ff 08
 00 02 06 00 fe 06 00 08 01 03 f8 01 03 01 09 00
 ff 09 00 05 02 02 fb 02 02 03 04 01 fd 04 01 02
 07 00 fe 07 00 09 01 03 f7 01 03 01 0a 00 ff 0a
 00 00 0a 06 04 04 03 03 03 02 02 02 ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 02 00 00 00 0a 00 00 00 01 01 00 ff 01 00 02 01
 00 fe 01 00 03 01 00 fd 01 00 01 02 00 ff 02 00
 00 00 00 04 01 00 fc 01 00 05 01 01 fb 01 01 02
 02 00 fe 02 00 01 03 00 ff 03 00 06 01 01 fa 01
 01 03 02 00 fd 02 00 07 01 01 f9 01 01 01 04 00
 ff 04 00 08 01 02 f8 01 02 02 03 00 fe 03 00 04
 02 00 fc 02 00 01 05 00 ff 05 00 09 01 02 f7 01
 02 05 02 01 fb 02 01 02 04 00 fe 04 00 0a 01 02
 f6 01 02 03 03 00 fd 03 00 01 06 00 ff 06 00 0b
 01 03 f5 01 03 06 02 01 fa 02 01 01 07 00 ff 07
 00 02 05 00 fe 05 00 03 04 00 fd 04 00 0c 01 03
 f4 01 03 04 03 00 fc 03 00 00 0d 07 05 04 03 02
 02 ff ff fe ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff 00 02 00 00 00 04 00 00 00 07 00 00 00
 01 01 00 ff 01 00 02 01 00 fe 01 00 03 01 00 fd
 01 00 00 00 00 04 01 00 fc 01 00 05 01 00 fb 01
 00 06 01 00 fa 01 00 01 02 00 ff 02 00 07 01 00
 f9 01 00 08 01 01 f8 01 01 02 02 00 fe 02 00 09
 01 01 f7 01 01 0a 01 01 f6 01 01 01 03 00 ff 03
 00 03 02 00 fd 02 00 0b 01 02 f5 01 02 04 02 00
 fc 02 00 0c 01 02 f4 01 02 0d 01 02 f3 01 02 05
 02 00 fb 02 00 01 04 00 ff 04 00 02 03 00 fe 03
 00 0e 01 02 f2 01 02 06 02 00 fa 02 00 0f 01 02
 f1 01 02 10 01 02 f0 01 02 03 03 00 fd 03 00 01
 05 00 ff 05 00 07 02 00 f9 02 00 11 01 02 ef 01
 02 00 12 08 04 02 02 ff ff ff ff ff ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 07 00 00 00 05 00 00 00 00 00 00 01 01 00 ff 01
 00 02 01 00 fe 01 00 03 01 00 fd 01 00 04 01 00
 fc 01 00 05 01 00 fb 01 00 06 01 00 fa 01 00 07
 01 00 f9 01 00 08 01 00 f8 01 00 09 01 00 f7 01
 00 0a 01 00 f6 01 00 01 02 00 ff 02 00 0b 01 01
 f5 01 01 0c 01 01 f4 01 01 0d 01 01 f3 01 01 02
 02 00 fe 02 00 0e 01 01 f2 01 01 0f 01 01 f1 01
 01 03 02 00 fd 02 00 10 01 01 f0 01 01 01 03 00
 ff 03 00 11 01 01 ef 01 01 04 02 00 fc 02 00 12
 01 01 ee 01 01 05 02 00 fb 02 00 13 01 01 ed 01
 01 14 01 01 ec 01 01 06 02 00 fa 02 00 15 01 01
 eb 01 01 02 03 00 fe 03 00 00 16 07 03 ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff 02 00 00 00 0a 00 00 00 03 00 00 00
 00 00 00 01 01 00 ff 01 00 02 01 00 fe 01 00 03
 01 00 fd 01 00 04 01 00 fc 01 00 05 01 00 fb 01
 00 06 01 00 fa 01 00 07 01 00 f9 01 00 08 01 00
 f8 01 00 09 01 00 f7 01 00 0a 01 00 f6 01 00 0b
 01 00 f5 01 00 0c 01 00 f4 01 00 0d 01 00 f3 01
 00 0e 01 00 f2 01 00 0f 01 00 f1 01 00 10 01 00
 f0 01 00 01 02 00 ff 02 00 11 01 00 ef 01 00 12
 01 00 ee 01 00 13 01 00 ed 01 00 14 01 00 ec 01
 00 15 01 00 eb 01 00 02 02 00 fe 02 00 16 01 00
 ea 01 00 17 01 00 e9 01 00 18 01 00 e8 01 00 19
 01 00 e7 01 00 03 02 00 fd 02 00 1a 01 00 e6 01
 00 00 1b 04 ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 ff ff ff 7f 02 00 00 00

################################################################################

TITLE
    libavcodec Chinese AVS video (AVS1-P2, JiZhun) inter_2dvlc

TYPE
    8 HEX

DATA
 01 01 01 ff 01 01 01 02 01 ff 02 01 01 03 01 ff
 03 01 01 04 01 ff 04 01 01 05 01 ff 05 01 01 06
 01 ff 06 01 01 07 01 ff 07 01 01 08 01 ff 08 01
 01 09 01 ff 09 01 01 0a 01 ff 0a 01 01 0b 01 ff
 0b 01 01 0c 01 ff 0c 01 01 0d 01 ff 0d 01 02 01
 02 fe 01 02 01 0e 01 ff 0e 01 01 0f 01 ff 0f 01
 01 10 01 ff 10 01 01 11 01 ff 11 01 01 12 01 ff
 12 01 01 13 01 ff 13 01 03 01 03 fd 01 03 01 14
 01 ff 14 01 01 15 01 ff 15 01 02 02 02 fe 02 02
 01 16 01 ff 16 01 01 17 01 ff 17 01 01 18 01 ff
 18 01 01 19 01 ff 19 01 01 1a 01 ff 1a 01 00 00
 00 00 04 03 02 02 02 02 02 02 02 02 02 02 02 02
 02 02 02 02 02 02 02 02 02 02 02 02 03 00 00 00
 00 00 00 00 1a 00 00 00 01 01 00 ff 01 00 00 00
 00 01 02 00 ff 02 00 01 03 00 ff 03 00 01 04 00
 ff 04 00 01 05 00 ff 05 00 01 06 00 ff 06 00 02
 01 01 fe 01 01 01 07 00 ff 07 00 01 08 00 ff 08
 00 01 09 00 ff 09 00 01 0a 00 ff 0a 00 02 02 01
 fe 02 01 01 0b 00 ff 0b 00 01 0c 00 ff 0c 00 03
 01 02 fd 01 02 01 0d 00 ff 0d 00 01 0e 00 ff 0e
 00 02 03 01 fe 03 01 01 0f 00 ff 0f 00 02 04 01
 fe 04 01 01 10 00 ff 10 00 02 05 01 fe 05 01 01
 11 00 ff 11 00 04 01 03 fc 01 03 02 06 01 fe 06
 01 01 12 00 ff 12 00 01 13 00 ff 13 00 02 07 01
 fe 07 01 03 02 02 fd 02 02 00 05 04 03 03 03 03
 03 02 02 02 02 02 02 02 02 02 02 02 02 ff ff ff
 ff ff ff ff 02 00 00 00 01 00 00 00 13 00 00 00
 01 01 00 ff 01 00 00 00 00 01 02 00 ff 02 00 02
 01 00 fe 01 00 01 03 00 ff 03 00 01 04 00 ff 04
 00 03 01 01 fd 01 01 02 02 00 fe 02 00 01 05 00
 ff 05 00 01 06 00 ff 06 00 01 07 00 ff 07 00 02
 03 00 fe 03 00 04 01 02 fc 01 02 01 08 00 ff 08
 00 03 02 01 fd 02 01 02 04 00 fe 04 00 01 09 00
 ff 09 00 01 0a 00 ff 0a 00 05 01 02 fb 01 02 02
 05 00 fe 05 00 01 0b 00 ff 0b 00 02 06 00 fe 06
 00 01 0c 00 ff 0c 00 03 03 01 fd 03 01 06 01 02
 fa 01 02 04 02 02 fc 02 02 01 0d 00 ff 0d 00 02
 07 00 fe 07 00 03 04 01 fd 04 01 01 0e 00 ff 0e
 00 00 07 05 04 04 03 03 03 02 02 02 02 02 02 02
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 02 00 00 00 0e 00 00 00 01 01 00 ff 01 00 00 00
 00 02 01 00 fe 01 00 01 02 00 ff 02 00 03 01 00
 fd 01 00 01 03 00 ff 03 00 02 02 00 fe 02 00 04
 01 01 fc 01 01 01 04 00 ff 04 00 05 01 01 fb 01
 01 01 05 00 ff 05 00 03 02 00 fd 02 00 02 03 00
 fe 03 00 01 06 00 ff 06 00 06 01 01 fa 01 01 02
 04 00 fe 04 00 01 07 00 ff 07 00 04 02 01 fc 02
 01 07 01 02 f9 01 02 03 03 00 fd 03 00 01 08 00
 ff 08 00 02 05 00 fe 05 00 08 01 02 f8 01 02 01
 09 00 ff 09 00 03 04 00 fd 04 00 02 06 00 fe 06
 00 05 02 01 fb 02 01 01 0a 00 ff 0a 00 09 01 02
 f7 01 02 04 03 01 fc 03 01 00 0a 06 05 04 03 03
 02 02 02 02 ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff 02 00 00 00 03 00 00 00 0a 00 00 00
 01 01 00 ff 01 00 00 00 00 02 01 00 fe 01 00 03
 01 00 fd 01 00 01 02 00 ff 02 00 04 01 00 fc 01
 00 05 01 00 fb 01 00 02 02 00 fe 02 00 01 03 00
 ff 03 00 06 01 00 fa 01 00 03 02 00 fd 02 00 07
 01 01 f9 01 01 01 04 00 ff 04 00 08 01 01 f8 01
 01 02 03 00 fe 03 00 04 02 00 fc 02 00 01 05 00
 ff 05 00 09 01 01 f7 01 01 05 02 00 fb 02 00 02
 04 00 fe 04 00 01 06 00 ff 06 00 0a 01 02 f6 01
 02 03 03 00 fd 03 00 0b 01 02 f5 01 02 01 07 00
 ff 07 00 06 02 00 fa 02 00 03 04 00 fd 04 00 02
 05 00 fe 05 00 0c 01 02 f4 01 02 04 03 00 fc 03
 00 00 0d 07 05 04 03 02 02 ff ff ff ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 06 00 00 00 07 00 00 00 00 00 00 01 01 00 ff 01
 00 02 01 00 fe 01 00 03 01 00 fd 01 00 04 01 00
 fc 01 00 05 01 00 fb 01 00 01 02 00 ff 02 00 06
 01 00 fa 01 00 07 01 00 f9 01 00 08 01 00 f8 01
 00 02 02 00 fe 02 00 09 01 00 f7 01 00 01 03 00
 ff 03 00 0a 01 01 f6 01 01 03 02 00 fd 02 00 0b
 01 01 f5 01 01 04 02 00 fc 02 00 0c 01 01 f4 01
 01 01 04 00 ff 04 00 02 03 00 fe 03 00 0d 01 01
 f3 01 01 05 02 00 fb 02 00 0e 01 01 f2 01 01 06
 02 00 fa 02 00 01 05 00 ff 05 00 0f 01 01 f1 01
 01 03 03 00 fd 03 00 10 01 01 f0 01 01 02 04 00
 fe 04 00 07 02 00 f9 02 00 00 11 08 04 03 02 ff
 ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff 02 00 00 00 09 00 00 00 05 00 00 00
 00 00 00 01 01 00 ff 01 00 02 01 00 fe 01 00 03
 01 00 fd 01 00 04 01 00 fc 01 00 05 01 00 fb 01
 00 06 01 00 fa 01 00 07 01 00 f9 01 00 01 02 00
 ff 02 00 08 01 00 f8 01 00 09 01 00 f7 01 00 0a
 01 00 f6 01 00 0b 01 00 f5 01 00 0c 01 00 f4 01
 00 02 02 00 fe 02 00 0d 01 00 f3 01 00 01 03 00
 ff 03 00 0e 01 00 f2 01 00 0f 01 00 f1 01 00 03
 02 00 fd 02 00 10 01 00 f0 01 00 11 01 00 ef 01
 00 12 01 00 ee 01 00 04 02 00 fc 02 00 13 01 00
 ed 01 00 14 01 00 ec 01 00 02 03 00 fe 03 00 01
 04 00 ff 04 00 05 02 00 fb 02 00 15 01 00 eb 01
 00 00 16 06 03 02 ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 02 00 00 00
 ff ff ff 7f 04 00 00 00

################################################################################

TITLE
    libavcodec Chinese AVS video (AVS1-P2, JiZhun) chroma_2dvlc

TYPE
    8 HEX

DATA
 01 01 01 ff 01 01 01 02 01 ff 02 01 01 03 01 ff
 03 01 01 04 01 ff 04 01 01 05 01 ff 05 01 01 06
 01 ff 06 01 01 07 01 ff 07 01 02 01 02 fe 01 02
 01 08 01 ff 08 01 01 09 01 ff 09 01 01 0a 01 ff
 0a 01 01 0b 01 ff 0b 01 01 0c 01 ff 0c 01 01 0d
 01 ff 0d 01 01 0e 01 ff 0e 01 01 0f 01 ff 0f 01
 03 01 03 fd 01 03 01 10 01 ff 10 01 01 11 01 ff
 11 01 01 12 01 ff 12 01 01 13 01 ff 13 01 01 14
 01 ff 14 01 01 15 01 ff 15 01 01 16 01 ff 16 01
 02 02 02 fe 02 02 01 17 01 ff 17 01 01 18 01 ff
 18 01 01 19 01 ff 19 01 04 01 03 fc 01 03 00 00
 00 00 05 03 02 02 02 02 02 02 02 02 02 02 02 02
 02 02 02 02 02 02 02 02 02 02 02 ff 02 00 00 00
 00 00 00 00 19 00 00 00 00 00 00 01 01 00 ff 01
 00 01 02 00 ff 02 00 02 01 01 fe 01 01 01 03 00
 ff 03 00 01 04 00 ff 04 00 01 05 00 ff 05 00 01
 06 00 ff 06 00 03 01 02 fd 01 02 01 07 00 ff 07
 00 01 08 00 ff 08 00 02 02 01 fe 02 01 01 09 00
 ff 09 00 01 0a 00 ff 0a 00 01 0b 00 ff 0b 00 04
 01 02 fc 01 02 01 0c 00 ff 0c 00 01 0d 00 ff 0d
 00 01 0e 00 ff 0e 00 02 03 01 fe 03 01 01 0f 00
 ff 0f 00 02 04 01 fe 04 01 05 01 03 fb 01 03 03
 02 02 fd 02 02 01 10 00 ff 10 00 01 11 00 ff 11
 00 01 12 00 ff 12 00 02 05 01 fe 05 01 01 13 00
 ff 13 00 01 14 00 ff 14 00 00 06 04 03 03 03 02
 02 02 02 02 02 02 02 02 02 02 02 02 02 02 ff ff
 ff ff ff ff 00 00 00 00 01 00 00 00 14 00 00 00
 01 01 00 ff 01 00 00 00 00 02 01 00 fe 01 00 01
 02 00 ff 02 00 03 01 01 fd 01 01 01 03 00 ff 03
 00 04 01 01 fc 01 01 02 02 00 fe 02 00 01 04 00
 ff 04 00 05 01 02 fb 01 02 01 05 00 ff 05 00 03
 02 01 fd 02 01 02 03 00 fe 03 00 01 06 00 ff 06
 00 06 01 02 fa 01 02 01 07 00 ff 07 00 02 04 00
 fe 04 00 07 01 02 f9 01 02 01 08 00 ff 08 00 04
 02 01 fc 02 01 01 09 00 ff 09 00 03 03 01 fd 03
 01 02 05 00 fe 05 00 02 06 00 fe 06 00 08 01 02
 f8 01 02 01 0a 00 ff 0a 00 01 0b 00 ff 0b 00 09
 01 02 f7 01 02 05 02 02 fb 02 02 03 04 01 fd 04
 01 00 0a 06 04 04 03 03 02 02 02 02 02 ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 01 00 00 00
 02 00 00 00 0b 00 00 00 00 00 00 01 01 00 ff 01
 00 02 01 00 fe 01 00 03 01 00 fd 01 00 04 01 00
 fc 01 00 01 02 00 ff 02 00 05 01 01 fb 01 01 02
 02 00 fe 02 00 06 01 01 fa 01 01 01 03 00 ff 03
 00 07 01 01 f9 01 01 03 02 00 fd 02 00 08 01 01
 f8 01 01 01 04 00 ff 04 00 02 03 00 fe 03 00 09
 01 01 f7 01 01 04 02 00 fc 02 00 01 05 00 ff 05
 00 0a 01 01 f6 01 01 03 03 00 fd 03 00 05 02 01
 fb 02 01 02 04 00 fe 04 00 0b 01 01 f5 01 01 01
 06 00 ff 06 00 0c 01 01 f4 01 01 01 07 00 ff 07
 00 06 02 01 fa 02 01 0d 01 01 f3 01 01 02 05 00
 fe 05 00 01 08 00 ff 08 00 00 0e 07 04 03 03 02
 02 02 ff ff ff ff ff ff ff ff ff ff ff ff ff ff
 ff ff ff ff 01 00 00 00 04 00 00 00 08 00 00 00
 00 00 00 01 01 00 ff 01 00 02 01 00 fe 01 00 03
 01 00 fd 01 00 04 01 00 fc 01 00 05 01 00 fb 01
 00 06 01 00 fa 01 00 07 01 00 f9 01 00 08 01 00
 f8 01 00 01 02 00 ff 02 00 09 01 00 f7 01 00 0a
 01 00 f6 01 00 0b 01 00 f5 01 00 02 02 00 fe 02
 00 0c 01 00 f4 01 00 0d 01 00 f3 01 00 03 02 00
 fd 02 00 0e 01 00 f2 01 00 01 03 00 ff 03 00 0f
 01 00 f1 01 00 04 02 00 fc 02 00 10 01 00 f0 01
 00 11 01 00 ef 01 00 05 02 00 fb 02 00 01 04 00
 ff 04 00 02 03 00 fe 03 00 12 01 00 ee 01 00 06
 02 00 fa 02 00 13 01 00 ed 01 00 01 05 00 ff 05
 00 00 14 07 03 02 02 ff ff ff ff ff ff ff ff ff
 ff ff ff ff ff ff ff ff ff ff ff ff 00 00 00 00
 ff ff ff 7f 05 00 00 00

################################################################################

TITLE
    libavcodec COOK quant_centroid_tab

TYPE
    FLOAT

DATA
  { 0.000, 0.392, 0.761, 1.120, 1.477, 1.832, 2.183, 2.541, 2.893, 3.245, 3.598, 3.942, 4.288, 4.724 },
  { 0.000, 0.544, 1.060, 1.563, 2.068, 2.571, 3.072, 3.562, 4.070, 4.620, 0.000, 0.000, 0.000, 0.000 },
  { 0.000, 0.746, 1.464, 2.180, 2.882, 3.584, 4.316, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000 },
  { 0.000, 1.006, 2.000, 2.993, 3.985, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000 },
  { 0.000, 1.321, 2.703, 3.983, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000 },
  { 0.000, 1.657, 3.491, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000 },
  { 0.000, 1.964, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000 }

################################################################################

TITLE
    libavcodec COOK envelope_quant_index_huffbits

TYPE
    8

DATA
    {  4,  6,  5,  5,  4, 4, 4, 4, 4, 4, 3, 3, 3, 4, 5, 7,  8,  9, 11, 11, 12, 12, 12, 12 },
    { 10,  8,  6,  5,  5, 4, 3, 3, 3, 3, 3, 3, 4, 5, 7, 9, 11, 12, 13, 15, 15, 15, 16, 16 },
    { 12, 10,  8,  6,  5, 4, 4, 4, 4, 4, 4, 3, 3, 3, 4, 4,  5,  5,  7,  9, 11, 13, 14, 14 },
    { 13, 10,  9,  9,  7, 7, 5, 5, 4, 3, 3, 3, 3, 3, 4, 4,  4,  5,  7,  9, 11, 13, 13, 13 },
    { 12, 13, 10,  8,  6, 6, 5, 5, 4, 4, 3, 3, 3, 3, 3, 4,  5,  5,  6,  7,  9, 11, 14, 14 },
    { 12, 11,  9,  8,  8, 7, 5, 4, 4, 3, 3, 3, 3, 3, 4, 4,  5,  5,  7,  8, 10, 13, 14, 14 },
    { 15, 16, 15, 12, 10, 8, 6, 5, 4, 3, 3, 3, 2, 3, 4, 5,  5,  7,  9, 11, 13, 16, 16, 16 },
    { 14, 14, 11, 10,  9, 7, 7, 5, 5, 4, 3, 3, 2, 3, 3, 4,  5,  7,  9,  9, 12, 14, 15, 15 },
    {  9,  9,  9,  8,  7, 6, 5, 4, 3, 3, 3, 3, 3, 3, 4, 5,  6,  7,  8, 10, 11, 12, 13, 13 },
    { 14, 12, 10,  8,  6, 6, 5, 4, 3, 3, 3, 3, 3, 3, 4, 5,  6,  8,  8,  9, 11, 14, 14, 14 },
    { 13, 10,  9,  8,  6, 6, 5, 4, 4, 4, 3, 3, 2, 3, 4, 5,  6,  8,  9,  9, 11, 12, 14, 14 },
    { 16, 13, 12, 11,  9, 6, 5, 5, 4, 4, 4, 3, 2, 3, 3, 4,  5,  7,  8, 10, 14, 16, 16, 16 },
    { 13, 14, 14, 14, 10, 8, 7, 7, 5, 4, 3, 3, 2, 3, 3, 4,  5,  5,  7,  9, 11, 14, 14, 14 },

################################################################################

TITLE
    libavcodec COOK envelope_quant_index_huffcodes

TYPE
    16

DATA
    {0x0006, 0x003e, 0x001c, 0x001d, 0x0007, 0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x0000, 0x0001,
     0x0002, 0x000d, 0x001e, 0x007e, 0x00fe, 0x01fe, 0x07fc, 0x07fd, 0x0ffc, 0x0ffd, 0x0ffe, 0x0fff},
    {0x03fe, 0x00fe, 0x003e, 0x001c, 0x001d, 0x000c, 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005,
     0x000d, 0x001e, 0x007e, 0x01fe, 0x07fe, 0x0ffe, 0x1ffe, 0x7ffc, 0x7ffd, 0x7ffe, 0xfffe, 0xffff},
    {0x0ffe, 0x03fe, 0x00fe, 0x003e, 0x001c, 0x0006, 0x0007, 0x0008, 0x0009, 0x000a, 0x000b, 0x0000,
     0x0001, 0x0002, 0x000c, 0x000d, 0x001d, 0x001e, 0x007e, 0x01fe, 0x07fe, 0x1ffe, 0x3ffe, 0x3fff},
    {0x1ffc, 0x03fe, 0x01fc, 0x01fd, 0x007c, 0x007d, 0x001c, 0x001d, 0x000a, 0x0000, 0x0001, 0x0002,
     0x0003, 0x0004, 0x000b, 0x000c, 0x000d, 0x001e, 0x007e, 0x01fe, 0x07fe, 0x1ffd, 0x1ffe, 0x1fff},
    {0x0ffe, 0x1ffe, 0x03fe, 0x00fe, 0x003c, 0x003d, 0x001a, 0x001b, 0x000a, 0x000b, 0x0000, 0x0001,
     0x0002, 0x0003, 0x0004, 0x000c, 0x001c, 0x001d, 0x003e, 0x007e, 0x01fe, 0x07fe, 0x3ffe, 0x3fff},
    {0x0ffe, 0x07fe, 0x01fe, 0x00fc, 0x00fd, 0x007c, 0x001c, 0x000a, 0x000b, 0x0000, 0x0001, 0x0002,
     0x0003, 0x0004, 0x000c, 0x000d, 0x001d, 0x001e, 0x007d, 0x00fe, 0x03fe, 0x1ffe, 0x3ffe, 0x3fff},
    {0x7ffc, 0xfffc, 0x7ffd, 0x0ffe, 0x03fe, 0x00fe, 0x003e, 0x001c, 0x000c, 0x0002, 0x0003, 0x0004,
     0x0000, 0x0005, 0x000d, 0x001d, 0x001e, 0x007e, 0x01fe, 0x07fe, 0x1ffe, 0xfffd, 0xfffe, 0xffff},
    {0x3ffc, 0x3ffd, 0x07fe, 0x03fe, 0x01fc, 0x007c, 0x007d, 0x001c, 0x001d, 0x000c, 0x0002, 0x0003,
     0x0000, 0x0004, 0x0005, 0x000d, 0x001e, 0x007e, 0x01fd, 0x01fe, 0x0ffe, 0x3ffe, 0x7ffe, 0x7fff},
    {0x01fc, 0x01fd, 0x01fe, 0x00fc, 0x007c, 0x003c, 0x001c, 0x000c, 0x0000, 0x0001, 0x0002, 0x0003,
     0x0004, 0x0005, 0x000d, 0x001d, 0x003d, 0x007d, 0x00fd, 0x03fe, 0x07fe, 0x0ffe, 0x1ffe, 0x1fff},
    {0x3ffc, 0x0ffe, 0x03fe, 0x00fc, 0x003c, 0x003d, 0x001c, 0x000c, 0x0000, 0x0001, 0x0002, 0x0003,
     0x0004, 0x0005, 0x000d, 0x001d, 0x003e, 0x00fd, 0x00fe, 0x01fe, 0x07fe, 0x3ffd, 0x3ffe, 0x3fff},
    {0x1ffe, 0x03fe, 0x01fc, 0x00fc, 0x003c, 0x003d, 0x001c, 0x000a, 0x000b, 0x000c, 0x0002, 0x0003,
     0x0000, 0x0004, 0x000d, 0x001d, 0x003e, 0x00fd, 0x01fd, 0x01fe, 0x07fe, 0x0ffe, 0x3ffe, 0x3fff},
    {0xfffc, 0x1ffe, 0x0ffe, 0x07fe, 0x01fe, 0x003e, 0x001c, 0x001d, 0x000a, 0x000b, 0x000c, 0x0002,
     0x0000, 0x0003, 0x0004, 0x000d, 0x001e, 0x007e, 0x00fe, 0x03fe, 0x3ffe, 0xfffd, 0xfffe, 0xffff},
    {0x1ffc, 0x3ffa, 0x3ffb, 0x3ffc, 0x03fe, 0x00fe, 0x007c, 0x007d, 0x001c, 0x000c, 0x0002, 0x0003,
     0x0000, 0x0004, 0x0005, 0x000d, 0x001d, 0x001e, 0x007e, 0x01fe, 0x07fe, 0x3ffd, 0x3ffe, 0x3fff},

################################################################################

TITLE
    libavcodec COOK cvh_huffbits0

TYPE
    8

DATA
    1, 4, 6, 6, 7, 7, 8, 8, 8, 9, 9, 10,
    11, 11, 4, 5, 6, 7, 7, 8, 8, 9, 9, 9,
    9, 10, 11, 11, 5, 6, 7, 8, 8, 9, 9, 9,
    9, 10, 10, 10, 11, 12, 6, 7, 8, 9, 9, 9,
    9, 10, 10, 10, 10, 11, 12, 13, 7, 7, 8, 9,
    9, 9, 10, 10, 10, 10, 11, 11, 12, 13, 8, 8,
    9, 9, 9, 10, 10, 10, 10, 11, 11, 12, 13, 14,
    8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13,
    13, 15, 8, 8, 9, 9, 10, 10, 11, 11, 11, 12,
    12, 13, 14, 15, 9, 9, 9, 10, 10, 10, 11, 11,
    12, 13, 12, 14, 15, 16, 9, 9, 10, 10, 10, 10,
    11, 12, 12, 14, 14, 16, 16, 0, 9, 9, 10, 10,
    11, 11, 12, 13, 13, 14, 14, 15, 0, 0, 10, 10,
    10, 11, 11, 12, 12, 13, 15, 15, 16, 0, 0, 0,
    11, 11, 11, 12, 13, 13, 13, 15, 16, 16, 0, 0,
    0, 0, 11, 11, 12, 13, 13, 14, 15, 16, 16,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes0

TYPE
    16

DATA
    0x0000,0x0008,0x002c,0x002d,0x0062,0x0063,0x00d4,0x00d5,0x00d6,0x01c6,0x01c7,0x03ca,
    0x07d6,0x07d7,0x0009,0x0014,0x002e,0x0064,0x0065,0x00d7,0x00d8,0x01c8,0x01c9,0x01ca,
    0x01cb,0x03cb,0x07d8,0x07d9,0x0015,0x002f,0x0066,0x00d9,0x00da,0x01cc,0x01cd,0x01ce,
    0x01cf,0x03cc,0x03cd,0x03ce,0x07da,0x0fe4,0x0030,0x0067,0x00db,0x01d0,0x01d1,0x01d2,
    0x01d3,0x03cf,0x03d0,0x03d1,0x03d2,0x07db,0x0fe5,0x1fea,0x0068,0x0069,0x00dc,0x01d4,
    0x01d5,0x01d6,0x03d3,0x03d4,0x03d5,0x03d6,0x07dc,0x07dd,0x0fe6,0x1feb,0x00dd,0x00de,
    0x01d7,0x01d8,0x01d9,0x03d7,0x03d8,0x03d9,0x03da,0x07de,0x07df,0x0fe7,0x1fec,0x3ff2,
    0x00df,0x00e0,0x01da,0x01db,0x03db,0x03dc,0x07e0,0x07e1,0x07e2,0x0fe8,0x0fe9,0x1fed,
    0x1fee,0x7ff4,0x00e1,0x00e2,0x01dc,0x01dd,0x03dd,0x03de,0x07e3,0x07e4,0x07e5,0x0fea,
    0x0feb,0x1fef,0x3ff3,0x7ff5,0x01de,0x01df,0x01e0,0x03df,0x03e0,0x03e1,0x07e6,0x07e7,
    0x0fec,0x1ff0,0x0fed,0x3ff4,0x7ff6,0xfff8,0x01e1,0x01e2,0x03e2,0x03e3,0x03e4,0x03e5,
    0x07e8,0x0fee,0x0fef,0x3ff5,0x3ff6,0xfff9,0xfffa,0xfffa,0x01e3,0x01e4,0x03e6,0x03e7,
    0x07e9,0x07ea,0x0ff0,0x1ff1,0x1ff2,0x3ff7,0x3ff8,0x7ff7,0x7ff7,0xfffa,0x03e8,0x03e9,
    0x03ea,0x07eb,0x07ec,0x0ff1,0x0ff2,0x1ff3,0x7ff8,0x7ff9,0xfffb,0x3ff8,0x7ff7,0x7ff7,
    0x07ed,0x07ee,0x07ef,0x0ff3,0x1ff4,0x1ff5,0x1ff6,0x7ffa,0xfffc,0xfffd,0xfffb,0xfffb,
    0x3ff8,0x7ff7,0x07f0,0x07f1,0x0ff4,0x1ff7,0x1ff8,0x3ff9,0x7ffb,0xfffe,0xffff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits1

TYPE
    8

DATA
    1, 4, 5, 6, 7, 8, 8, 9, 10, 10, 4, 5,
    6, 7, 7, 8, 8, 9, 9, 11, 5, 5, 6, 7,
    8, 8, 9, 9, 10, 11, 6, 6, 7, 8, 8, 9,
    9, 10, 11, 12, 7, 7, 8, 8, 9, 9, 10, 11,
    11, 13, 8, 8, 8, 9, 9, 10, 10, 11, 12, 14,
    8, 8, 8, 9, 10, 11, 11, 12, 13, 15, 9, 9,
    9, 10, 11, 12, 12, 14, 14, 0, 9, 9, 9, 10,
    11, 12, 14, 16, 0, 0, 10, 10, 11, 12, 13, 14,
    16,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes1

TYPE
    16

DATA
    0x0000,0x0008,0x0014,0x0030,0x006a,0x00e2,0x00e3,0x01e4,0x03ec,0x03ed,0x0009,0x0015,
    0x0031,0x006b,0x006c,0x00e4,0x00e5,0x01e5,0x01e6,0x07f0,0x0016,0x0017,0x0032,0x006d,
    0x00e6,0x00e7,0x01e7,0x01e8,0x03ee,0x07f1,0x0033,0x0034,0x006e,0x00e8,0x00e9,0x01e9,
    0x01ea,0x03ef,0x07f2,0x0ff6,0x006f,0x0070,0x00ea,0x00eb,0x01eb,0x01ec,0x03f0,0x07f3,
    0x07f4,0x1ffa,0x00ec,0x00ed,0x00ee,0x01ed,0x01ee,0x03f1,0x03f2,0x07f5,0x0ff7,0x3ffa,
    0x00ef,0x00f0,0x00f1,0x01ef,0x03f3,0x07f6,0x07f7,0x0ff8,0x1ffb,0x7ffe,0x01f0,0x01f1,
    0x01f2,0x03f4,0x07f8,0x0ff9,0x0ffa,0x3ffb,0x3ffc,0x0000,0x01f3,0x01f4,0x01f5,0x03f5,
    0x07f9,0x0ffb,0x3ffd,0xfffe,0x0000,0x0000,0x03f6,0x03f7,0x07fa,0x0ffc,0x1ffc,0x3ffe,
    0xffff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits2

TYPE
    8

DATA
    1, 4, 5, 7, 8, 9, 10, 3, 4, 5, 7, 8,
    9, 10, 5, 5, 6, 7, 8, 10, 10, 7, 6, 7,
    8, 9, 10, 12, 8, 8, 8, 9, 10, 12, 14, 8,
    9, 9, 10, 11, 15, 16, 9, 10, 11, 12, 13, 16,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes2

TYPE
    16

DATA
    0x0000,0x000a,0x0018,0x0074,0x00f2,0x01f4,0x03f6,0x0004,0x000b,0x0019,0x0075,0x00f3,
    0x01f5,0x03f7,0x001a,0x001b,0x0038,0x0076,0x00f4,0x03f8,0x03f9,0x0077,0x0039,0x0078,
    0x00f5,0x01f6,0x03fa,0x0ffc,0x00f6,0x00f7,0x00f8,0x01f7,0x03fb,0x0ffd,0x3ffe,0x00f9,
    0x01f8,0x01f9,0x03fc,0x07fc,0x7ffe,0xfffe,0x01fa,0x03fd,0x07fd,0x0ffe,0x1ffe,0xffff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits3

TYPE
    8

DATA
    2, 4, 6, 8, 10, 5, 5, 6, 8, 10, 7, 8,
    8, 10, 12, 9, 9, 10, 12, 15, 10, 11, 13, 16,
    16, 5, 6, 8, 10, 11, 5, 6, 8, 10, 12, 7,
    7, 8, 10, 13, 9, 9, 10, 12, 15, 12, 11, 13,
    16, 16, 7, 9, 10, 12, 15, 7, 8, 10, 12, 13,
    9, 9, 11, 13, 16, 11, 11, 12, 14, 16, 12, 12,
    14, 16, 0, 9, 11, 12, 16, 16, 9, 10, 13, 15,
    16, 10, 11, 12, 16, 16, 13, 13, 16, 16, 16, 16,
    16, 15, 16, 0, 11, 13, 16, 16, 15, 11, 13, 15,
    16, 16, 13, 13, 16, 16, 0, 14, 16, 16, 16, 0,
    16, 16, 0, 0, 0, 4, 6, 8, 10, 13, 6, 6,
    8, 10, 13, 9, 8, 10, 12, 16, 10, 10, 11, 15,
    16, 13, 12, 14, 16, 16, 5, 6, 8, 11, 13, 6,
    6, 8, 10, 13, 8, 8, 9, 11, 14, 10, 10, 12,
    12, 16, 13, 12, 13, 15, 16, 7, 8, 9, 12, 16,
    7, 8, 10, 12, 14, 9, 9, 10, 13, 16, 11, 10,
    12, 15, 16, 13, 13, 16, 16, 0, 9, 11, 13, 16,
    16, 9, 10, 12, 15, 16, 10, 11, 13, 16, 16, 13,
    12, 16, 16, 16, 16, 16, 16, 16, 0, 11, 13, 16,
    16, 16, 11, 13, 16, 16, 16, 12, 13, 15, 16, 0,
    16, 16, 16, 16, 0, 16, 16, 0, 0, 0, 6, 8,
    11, 13, 16, 8, 8, 10, 12, 16, 11, 10, 11, 13,
    16, 12, 13, 13, 15, 16, 16, 16, 14, 16, 0, 6,
    8, 10, 13, 16, 8, 8, 10, 12, 16, 10, 10, 11,
    13, 16, 13, 12, 13, 16, 16, 14, 14, 14, 16, 0,
    8, 9, 11, 13, 16, 8, 9, 11, 16, 14, 10, 10,
    12, 15, 16, 12, 12, 13, 16, 16, 15, 16, 16, 16,
    0, 10, 12, 15, 16, 16, 10, 12, 12, 14, 16, 12,
    12, 13, 16, 16, 14, 15, 16, 16, 0, 16, 16, 16,
    0, 0, 12, 15, 15, 16, 0, 13, 13, 16, 16, 0,
    14, 16, 16, 16, 0, 16, 16, 16, 0, 0, 0, 0,
    0, 0, 0, 8, 10, 13, 15, 16, 10, 11, 13, 16,
    16, 13, 13, 14, 16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 0, 8, 10, 11, 15, 16, 9, 10, 12,
    16, 16, 12, 12, 15, 16, 16, 16, 14, 16, 16, 16,
    16, 16, 16, 16, 0, 9, 11, 14, 16, 16, 10, 11,
    13, 16, 16, 14, 13, 14, 16, 16, 16, 15, 15, 16,
    0, 16, 16, 16, 0, 0, 11, 13, 16, 16, 16, 11,
    13, 15, 16, 16, 13, 16, 16, 16, 0, 16, 16, 16,
    16, 0, 16, 16, 0, 0, 0, 15, 16, 16, 16, 0,
    14, 16, 16, 16, 0, 16, 16, 16, 0, 0, 16, 16,
    0, 0, 0, 0, 0, 0, 0, 0, 9, 13, 16, 16,
    16, 11, 13, 16, 16, 16, 14, 15, 16, 16, 0, 15,
    16, 16, 16, 0, 16, 16, 0, 0, 0, 9, 13, 15,
    15, 16, 12, 13, 14, 16, 16, 16, 15, 16, 16, 0,
    16, 16, 16, 16, 0, 16, 16, 0, 0, 0, 11, 13,
    15, 16, 0, 12, 14, 16, 16, 0, 16, 16, 16, 16,
    0, 16, 16, 16, 0, 0, 0, 0, 0, 0, 0, 16,
    16, 16, 16, 0, 16, 16, 16, 16, 0, 16, 16, 16,
    0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0,
    16, 16, 0, 0, 0, 16, 16,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes3

TYPE
    16

DATA
    0x0000,0x0004,0x0022,0x00c6,0x03b0,0x000c,0x000d,0x0023,0x00c7,0x03b1,0x005c,0x00c8,
    0x00c9,0x03b2,0x0fa4,0x01c2,0x01c3,0x03b3,0x0fa5,0x7f72,0x03b4,0x07b2,0x1f9a,0xff24,
    0xff25,0x000e,0x0024,0x00ca,0x03b5,0x07b3,0x000f,0x0025,0x00cb,0x03b6,0x0fa6,0x005d,
    0x005e,0x00cc,0x03b7,0x1f9b,0x01c4,0x01c5,0x03b8,0x0fa7,0x7f73,0x0fa8,0x07b4,0x1f9c,
    0xff26,0xff27,0x005f,0x01c6,0x03b9,0x0fa9,0x7f74,0x0060,0x00cd,0x03ba,0x0faa,0x1f9d,
    0x01c7,0x01c8,0x07b5,0x1f9e,0xff28,0x07b6,0x07b7,0x0fab,0x3fa2,0xff29,0x0fac,0x0fad,
    0x3fa3,0xff2a,0x3fa2,0x01c9,0x07b8,0x0fae,0xff2b,0xff2c,0x01ca,0x03bb,0x1f9f,0x7f75,
    0xff2d,0x03bc,0x07b9,0x0faf,0xff2e,0xff2f,0x1fa0,0x1fa1,0xff30,0xff31,0xff32,0xff33,
    0xff34,0x7f76,0xff35,0xff31,0x07ba,0x1fa2,0xff36,0xff37,0x7f77,0x07bb,0x1fa3,0x7f78,
    0xff38,0xff39,0x1fa4,0x1fa5,0xff3a,0xff3b,0xff2e,0x3fa4,0xff3c,0xff3d,0xff3e,0xff31,
    0xff3f,0xff40,0xff30,0xff31,0xff31,0x0005,0x0026,0x00ce,0x03bd,0x1fa6,0x0027,0x0028,
    0x00cf,0x03be,0x1fa7,0x01cb,0x00d0,0x03bf,0x0fb0,0xff41,0x03c0,0x03c1,0x07bc,0x7f79,
    0xff42,0x1fa8,0x0fb1,0x3fa5,0xff43,0xff44,0x0010,0x0029,0x00d1,0x07bd,0x1fa9,0x002a,
    0x002b,0x00d2,0x03c2,0x1faa,0x00d3,0x00d4,0x01cc,0x07be,0x3fa6,0x03c3,0x03c4,0x0fb2,
    0x0fb3,0xff45,0x1fab,0x0fb4,0x1fac,0x7f7a,0xff46,0x0061,0x00d5,0x01cd,0x0fb5,0xff47,
    0x0062,0x00d6,0x03c5,0x0fb6,0x3fa7,0x01ce,0x01cf,0x03c6,0x1fad,0xff48,0x07bf,0x03c7,
    0x0fb7,0x7f7b,0xff49,0x1fae,0x1faf,0xff4a,0xff4b,0x7f7b,0x01d0,0x07c0,0x1fb0,0xff4c,
    0xff4d,0x01d1,0x03c8,0x0fb8,0x7f7c,0xff4e,0x03c9,0x07c1,0x1fb1,0xff4f,0xff50,0x1fb2,
    0x0fb9,0xff51,0xff52,0xff53,0xff54,0xff55,0xff56,0xff57,0xff52,0x07c2,0x1fb3,0xff58,
    0xff59,0xff5a,0x07c3,0x1fb4,0xff5b,0xff5c,0xff5d,0x0fba,0x1fb5,0x7f7d,0xff5e,0xff4f,
    0xff5f,0xff60,0xff61,0xff62,0xff52,0xff63,0xff64,0xff51,0xff52,0xff52,0x002c,0x00d7,
    0x07c4,0x1fb6,0xff65,0x00d8,0x00d9,0x03ca,0x0fbb,0xff66,0x07c5,0x03cb,0x07c6,0x1fb7,
    0xff67,0x0fbc,0x1fb8,0x1fb9,0x7f7e,0xff68,0xff69,0xff6a,0x3fa8,0xff6b,0x7f7e,0x002d,
    0x00da,0x03cc,0x1fba,0xff6c,0x00db,0x00dc,0x03cd,0x0fbd,0xff6d,0x03ce,0x03cf,0x07c7,
    0x1fbb,0xff6e,0x1fbc,0x0fbe,0x1fbd,0xff6f,0xff70,0x3fa9,0x3faa,0x3fab,0xff71,0xff6f,
    0x00dd,0x01d2,0x07c8,0x1fbe,0xff72,0x00de,0x01d3,0x07c9,0xff73,0x3fac,0x03d0,0x03d1,
    0x0fbf,0x7f7f,0xff74,0x0fc0,0x0fc1,0x1fbf,0xff75,0xff76,0x7f80,0xff77,0xff78,0xff79,
    0xff75,0x03d2,0x0fc2,0x7f81,0xff7a,0xff7b,0x03d3,0x0fc3,0x0fc4,0x3fad,0xff7c,0x0fc5,
    0x0fc6,0x1fc0,0xff7d,0xff7e,0x3fae,0x7f82,0xff7f,0xff80,0xff80,0xff81,0xff82,0xff83,
    0xff80,0xff80,0x0fc7,0x7f83,0x7f84,0xff84,0xff7a,0x1fc1,0x1fc2,0xff85,0xff86,0x3fad,
    0x3faf,0xff87,0xff88,0xff89,0xff7d,0xff8a,0xff8b,0xff8c,0xff80,0xff80,0x3fae,0x7f82,
    0xff7f,0xff80,0xff80,0x00df,0x03d4,0x1fc3,0x7f85,0xff8d,0x03d5,0x07ca,0x1fc4,0xff8e,
    0xff8f,0x1fc5,0x1fc6,0x3fb0,0xff90,0xff91,0xff92,0xff93,0xff94,0xff95,0xff96,0xff97,
    0xff98,0xff99,0xff9a,0xff95,0x00e0,0x03d6,0x07cb,0x7f86,0xff9b,0x01d4,0x03d7,0x0fc8,
    0xff9c,0xff9d,0x0fc9,0x0fca,0x7f87,0xff9e,0xff9f,0xffa0,0x3fb1,0xffa1,0xffa2,0xffa3,
    0xffa4,0xffa5,0xffa6,0xffa7,0xffa2,0x01d5,0x07cc,0x3fb2,0xffa8,0xffa9,0x03d8,0x07cd,
    0x1fc7,0xffaa,0xffab,0x3fb3,0x1fc8,0x3fb4,0xffac,0xffad,0xffae,0x7f88,0x7f89,0xffaf,
    0xffaf,0xffb0,0xffb1,0xffb2,0xffaf,0xffaf,0x07ce,0x1fc9,0xffb3,0xffb4,0xffb5,0x07cf,
    0x1fca,0x7f8a,0xffb6,0xffb7,0x1fcb,0xffb8,0xffb9,0xffba,0xffba,0xffbb,0xffbc,0xffbd,
    0xffbe,0xffbe,0xffbf,0xffc0,0xffbd,0xffbe,0xffbe,0x7f8b,0xffc1,0xffc2,0xffc3,0xffb4,
    0x3fb5,0xffc4,0xffc5,0xffc6,0xffb6,0xffc7,0xffc8,0xffc9,0xffba,0xffba,0xffca,0xffcb,
    0xffbd,0xffbe,0xffbe,0xffbb,0xffbc,0xffbd,0xffbe,0xffbe,0x01d6,0x1fcc,0xffcc,0xffcd,
    0xffce,0x07d0,0x1fcd,0xffcf,0xffd0,0xffd1,0x3fb6,0x7f8c,0xffd2,0xffd3,0xff90,0x7f8d,
    0xffd4,0xffd5,0xffd6,0xff95,0xffd7,0xffd8,0xff94,0xff95,0xff95,0x01d7,0x1fce,0x7f8e,
    0x7f8f,0xffd9,0x0fcb,0x1fcf,0x3fb7,0xffda,0xffdb,0xffdc,0x7f90,0xffdd,0xffde,0xff9e,
    0xffdf,0xffe0,0xffe1,0xffe2,0xffa2,0xffe3,0xffe4,0xffa1,0xffa2,0xffa2,0x07d1,0x1fd0,
    0x7f91,0xffe5,0xffa8,0x0fcc,0x3fb8,0xffe6,0xffe7,0xffaa,0xffe8,0xffe9,0xffea,0xffeb,
    0xffac,0xffec,0xffed,0xffee,0xffaf,0xffaf,0xffae,0x7f88,0x7f89,0xffaf,0xffaf,0xffef,
    0xfff0,0xfff1,0xfff2,0xffb4,0xfff3,0xfff4,0xfff5,0xfff6,0xffb6,0xfff7,0xfff8,0xfff9,
    0xffba,0xffba,0xfffa,0xfffb,0xffbd,0xffbe,0xffbe,0xffbb,0xffbc,0xffbd,0xffbe,0xffbe,
    0xfffc,0xfffd,0xffb3,0xffb4,0xffb4,0xfffe,0xffff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits4

TYPE
    8

DATA
    2, 4, 7, 10, 4, 5, 7, 10, 7, 8, 10, 14,
    11, 11, 15, 15, 4, 5, 9, 12, 5, 5, 8, 12,
    8, 7, 10, 15, 11, 11, 15, 15, 7, 9, 12, 15,
    8, 8, 12, 15, 10, 10, 13, 15, 14, 14, 15, 0,
    11, 13, 15, 15, 11, 13, 15, 15, 14, 15, 15, 0,
    15, 15, 0, 0, 4, 5, 9, 13, 5, 6, 9, 13,
    9, 9, 11, 15, 14, 13, 15, 15, 4, 6, 9, 12,
    5, 6, 9, 13, 9, 8, 11, 15, 13, 12, 15, 15,
    7, 9, 12, 15, 7, 8, 11, 15, 10, 10, 14, 15,
    14, 15, 15, 0, 10, 12, 15, 15, 11, 13, 15, 15,
    15, 15, 15, 0, 15, 15, 0, 0, 6, 9, 13, 14,
    8, 9, 12, 15, 12, 12, 15, 15, 15, 15, 15, 0,
    7, 9, 13, 15, 8, 9, 12, 15, 11, 12, 15, 15,
    15, 15, 15, 0, 9, 11, 15, 15, 9, 11, 15, 15,
    14, 14, 15, 0, 15, 15, 0, 0, 14, 15, 15, 0,
    14, 15, 15, 0, 15, 15, 0, 0, 0, 0, 0, 0,
    9, 12, 15, 15, 12, 13, 15, 15, 15, 15, 15, 0,
    15, 15, 0, 0, 10, 12, 15, 15, 12, 14, 15, 15,
    15, 15, 15, 0, 15, 15, 0, 0, 14, 15, 15, 0,
    15, 15, 15, 0, 15, 15, 0, 0, 0, 0, 0, 0,
    15, 15, 0, 0, 15, 15,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes4

TYPE
    16

DATA
    0x0000,0x0004,0x006c,0x03e6,0x0005,0x0012,0x006d,0x03e7,0x006e,0x00e8,0x03e8,0x3fc4,
    0x07e0,0x07e1,0x7fa4,0x7fa5,0x0006,0x0013,0x01e2,0x0fda,0x0014,0x0015,0x00e9,0x0fdb,
    0x00ea,0x006f,0x03e9,0x7fa6,0x07e2,0x07e3,0x7fa7,0x7fa8,0x0070,0x01e3,0x0fdc,0x7fa9,
    0x00eb,0x00ec,0x0fdd,0x7faa,0x03ea,0x03eb,0x1fd6,0x7fab,0x3fc5,0x3fc6,0x7fac,0x1fd6,
    0x07e4,0x1fd7,0x7fad,0x7fae,0x07e5,0x1fd8,0x7faf,0x7fb0,0x3fc7,0x7fb1,0x7fb2,0x1fd6,
    0x7fb3,0x7fb4,0x1fd6,0x1fd6,0x0007,0x0016,0x01e4,0x1fd9,0x0017,0x0032,0x01e5,0x1fda,
    0x01e6,0x01e7,0x07e6,0x7fb5,0x3fc8,0x1fdb,0x7fb6,0x7fb7,0x0008,0x0033,0x01e8,0x0fde,
    0x0018,0x0034,0x01e9,0x1fdc,0x01ea,0x00ed,0x07e7,0x7fb8,0x1fdd,0x0fdf,0x7fb9,0x7fba,
    0x0071,0x01eb,0x0fe0,0x7fbb,0x0072,0x00ee,0x07e8,0x7fbc,0x03ec,0x03ed,0x3fc9,0x7fbd,
    0x3fca,0x7fbe,0x7fbf,0x3fc9,0x03ee,0x0fe1,0x7fc0,0x7fc1,0x07e9,0x1fde,0x7fc2,0x7fc3,
    0x7fc4,0x7fc5,0x7fc6,0x3fc9,0x7fc7,0x7fc8,0x3fc9,0x3fc9,0x0035,0x01ec,0x1fdf,0x3fcb,
    0x00ef,0x01ed,0x0fe2,0x7fc9,0x0fe3,0x0fe4,0x7fca,0x7fcb,0x7fcc,0x7fcd,0x7fce,0x7fca,
    0x0073,0x01ee,0x1fe0,0x7fcf,0x00f0,0x01ef,0x0fe5,0x7fd0,0x07ea,0x0fe6,0x7fd1,0x7fd2,
    0x7fd3,0x7fd4,0x7fd5,0x7fd1,0x01f0,0x07eb,0x7fd6,0x7fd7,0x01f1,0x07ec,0x7fd8,0x7fd9,
    0x3fcc,0x3fcd,0x7fda,0x7fda,0x7fdb,0x7fdc,0x7fda,0x7fda,0x3fce,0x7fdd,0x7fde,0x7fd6,
    0x3fcf,0x7fdf,0x7fe0,0x7fd8,0x7fe1,0x7fe2,0x7fda,0x7fda,0x3fcc,0x3fcd,0x7fda,0x7fda,
    0x01f2,0x0fe7,0x7fe3,0x7fe4,0x0fe8,0x1fe1,0x7fe5,0x7fe6,0x7fe7,0x7fe8,0x7fe9,0x7fca,
    0x7fea,0x7feb,0x7fca,0x7fca,0x03ef,0x0fe9,0x7fec,0x7fed,0x0fea,0x3fd0,0x7fee,0x7fef,
    0x7ff0,0x7ff1,0x7ff2,0x7fd1,0x7ff3,0x7ff4,0x7fd1,0x7fd1,0x3fd1,0x7ff5,0x7ff6,0x7fd6,
    0x7ff7,0x7ff8,0x7ff9,0x7fd8,0x7ffa,0x7ffb,0x7fda,0x7fda,0x3fcc,0x3fcd,0x7fda,0x7fda,
    0x7ffc,0x7ffd,0x7fd6,0x7fd6,0x7ffe,0x7fff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits5

TYPE
    8

DATA
    2, 4, 8, 4, 5, 9, 9, 10, 14, 4, 6, 11,
    5, 6, 12, 10, 11, 15, 9, 11, 15, 10, 13, 15,
    14, 15, 0, 4, 6, 12, 6, 7, 12, 12, 12, 15,
    5, 7, 13, 6, 7, 13, 12, 13, 15, 10, 12, 15,
    11, 13, 15, 15, 15, 0, 8, 13, 15, 11, 12, 15,
    15, 15, 0, 10, 13, 15, 12, 15, 15, 15, 15, 0,
    15, 15, 0, 15, 15, 0, 0, 0, 0, 4, 5, 11,
    5, 7, 12, 11, 12, 15, 6, 7, 13, 7, 8, 14,
    12, 14, 15, 11, 13, 15, 12, 13, 15, 15, 15, 0,
    5, 6, 13, 7, 8, 15, 12, 14, 15, 6, 8, 14,
    7, 8, 15, 14, 15, 15, 12, 12, 15, 12, 13, 15,
    15, 15, 0, 9, 13, 15, 12, 13, 15, 15, 15, 0,
    11, 13, 15, 13, 13, 15, 15, 15, 0, 14, 15, 0,
    15, 15, 0, 0, 0, 0, 8, 10, 15, 11, 12, 15,
    15, 15, 0, 10, 12, 15, 12, 13, 15, 15, 15, 0,
    14, 15, 0, 15, 15, 0, 0, 0, 0, 8, 12, 15,
    12, 13, 15, 15, 15, 0, 11, 13, 15, 13, 15, 15,
    15, 15, 0, 15, 15, 0, 15, 15, 0, 0, 0, 0,
    14, 15, 0, 15, 15, 0, 0, 0, 0, 15, 15, 0,
    15, 15,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes5

TYPE
    16

DATA
    0x0000,0x0004,0x00f0,0x0005,0x0012,0x01f0,0x01f1,0x03e8,0x3fce,0x0006,0x0030,0x07de,
    0x0013,0x0031,0x0fd2,0x03e9,0x07df,0x7fb0,0x01f2,0x07e0,0x7fb1,0x03ea,0x1fd2,0x7fb2,
    0x3fcf,0x7fb3,0x0031,0x0007,0x0032,0x0fd3,0x0033,0x0070,0x0fd4,0x0fd5,0x0fd6,0x7fb4,
    0x0014,0x0071,0x1fd3,0x0034,0x0072,0x1fd4,0x0fd7,0x1fd5,0x7fb5,0x03eb,0x0fd8,0x7fb6,
    0x07e1,0x1fd6,0x7fb7,0x7fb8,0x7fb9,0x0072,0x00f1,0x1fd7,0x7fba,0x07e2,0x0fd9,0x7fbb,
    0x7fbc,0x7fbd,0x0070,0x03ec,0x1fd8,0x7fbe,0x0fda,0x7fbf,0x7fc0,0x7fc1,0x7fc2,0x0072,
    0x7fc3,0x7fc4,0x0071,0x7fc5,0x7fc6,0x0072,0x0034,0x0072,0x0072,0x0008,0x0015,0x07e3,
    0x0016,0x0073,0x0fdb,0x07e4,0x0fdc,0x7fc7,0x0035,0x0074,0x1fd9,0x0075,0x00f2,0x3fd0,
    0x0fdd,0x3fd1,0x7fc8,0x07e5,0x1fda,0x7fc9,0x0fde,0x1fdb,0x7fca,0x7fcb,0x7fcc,0x00f2,
    0x0017,0x0036,0x1fdc,0x0076,0x00f3,0x7fcd,0x0fdf,0x3fd2,0x7fce,0x0037,0x00f4,0x3fd3,
    0x0077,0x00f5,0x7fcf,0x3fd4,0x7fd0,0x7fd1,0x0fe0,0x0fe1,0x7fd2,0x0fe2,0x1fdd,0x7fd3,
    0x7fd4,0x7fd5,0x00f5,0x01f3,0x1fde,0x7fd6,0x0fe3,0x1fdf,0x7fd7,0x7fd8,0x7fd9,0x00f3,
    0x07e6,0x1fe0,0x7fda,0x1fe1,0x1fe2,0x7fdb,0x7fdc,0x7fdd,0x00f5,0x3fd5,0x7fde,0x00f4,
    0x7fdf,0x7fe0,0x00f5,0x0077,0x00f5,0x00f5,0x00f6,0x03ed,0x7fe1,0x07e7,0x0fe4,0x7fe2,
    0x7fe3,0x7fe4,0x0073,0x03ee,0x0fe5,0x7fe5,0x0fe6,0x1fe3,0x7fe6,0x7fe7,0x7fe8,0x00f2,
    0x3fd6,0x7fe9,0x0074,0x7fea,0x7feb,0x00f2,0x0075,0x00f2,0x00f2,0x00f7,0x0fe7,0x7fec,
    0x0fe8,0x1fe4,0x7fed,0x7fee,0x7fef,0x00f3,0x07e8,0x1fe5,0x7ff0,0x1fe6,0x7ff1,0x7ff2,
    0x7ff3,0x7ff4,0x00f5,0x7ff5,0x7ff6,0x00f4,0x7ff7,0x7ff8,0x00f5,0x0077,0x00f5,0x00f5,
    0x3fd7,0x7ff9,0x0036,0x7ffa,0x7ffb,0x00f3,0x0076,0x00f3,0x00f3,0x7ffc,0x7ffd,0x0000,
    0x7ffe,0x7fff,

################################################################################

TITLE
    libavcodec COOK cvh_huffbits6

TYPE
    8

DATA
     1,  4,  4,  6,  4,  6,  6,  8,  4,  6,  6,  8,
     6,  9,  8, 10,  4,  6,  7,  8,  6,  9,  8, 11,
     6,  9,  8, 10,  8, 10,  9,  11,

################################################################################

TITLE
    libavcodec COOK cvh_huffcodes6

TYPE
    16

DATA
    0x0000,0x0008,0x0009,0x0034,0x000a,0x0035,0x0036,0x00f6,0x000b,0x0037,0x0038,0x00f7,
    0x0039,0x01fa,0x00f8,0x03fc,0x000c,0x003a,0x007a,0x00f9,0x003b,0x01fb,0x00fa,0x07fe,
    0x003c,0x01fc,0x00fb,0x03fd,0x00fc,0x03fe,0x01fd,0x07ff,

################################################################################

TITLE
    libavcodec COOK ccpl_huffcodes5

TYPE
    16

DATA
    0x03f8,0x03f9,0x03fa,0x03fb,0x01f8,0x01f9,0x00f8,0x00f9,0x0078,0x0079,0x0038,0x0039,
    0x0018,0x0019,0x0004,0x0000,0x0005,0x001a,0x001b,0x003a,0x003b,0x007a,0x007b,0x00fa,
    0x00fb,0x01fa,0x01fb,0x03fc,0x03fd,0x03fe,0x03ff,

################################################################################

TITLE
    libavcodec COOK ccpl_huffcodes6

TYPE
    16

DATA
    0x0004,0x0005,0x0005,0x0006,0x0006,0x0007,0x0007,0x0007,0x0007,0x0008,0x0008,0x0008,
    0x0008,0x0009,0x0009,0x0009,0x0009,0x000a,0x000a,0x000a,0x000a,0x000a,0x000b,0x000b,
    0x000b,0x000b,0x000c,0x000d,0x000e,0x000e,0x0010,0x0000,0x000a,0x0018,0x0019,0x0036,
    0x0037,0x0074,0x0075,0x0076,0x0077,0x00f4,0x00f5,0x00f6,0x00f7,0x01f5,0x01f6,0x01f7,
    0x01f8,0x03f6,0x03f7,0x03f8,0x03f9,0x03fa,0x07fa,0x07fb,0x07fc,0x07fd,0x0ffd,0x1ffd,
    0x3ffd,0x3ffe,0xffff,

################################################################################

TITLE
    libavcodec COOK ccpl_huffbits6

TYPE
    8

DATA
    16,15,14,13,12,11,11,11,11,10,10,10,
    10,9,9,9,9,9,8,8,8,8,7,7,
    7,7,6,6,5,5,3,1,4,5,5,6,
    6,7,7,7,7,8,8,8,8,9,9,9,
    9,10,10,10,10,10,11,11,11,11,12,13,
    14,14,16,

################################################################################

TITLE
    libavcodec COOK cplscale3

TYPE
    FLOAT

DATA
0.981279790401459,0.936997592449188,0.875934481620789,0.70710676908493,
0.482430040836334,0.349335819482803,0.192587479948997,

################################################################################

TITLE
    libavcodec COOK cplscale4

TYPE
    FLOAT

DATA
0.991486728191376,0.973249018192291,0.953020632266998,0.930133521556854,
0.903453230857849,0.870746195316315,0.826180458068848,0.70710676908493,
0.563405573368073,0.491732746362686,0.428686618804932,0.367221474647522,
0.302905440330505,0.229752898216248,0.130207896232605,

################################################################################

TITLE
    libavcodec COOK cplscale5

TYPE
    FLOAT

DATA
0.995926380157471,0.987517595291138,0.978726446628571,0.969505727291107,
0.95979779958725,0.949531257152557,0.938616216182709,0.926936149597168,
0.914336204528809,0.900602877140045,0.885426938533783,0.868331849575043,
0.84851086139679,0.824381768703461,0.791833400726318,0.70710676908493,
0.610737144947052,0.566034197807312,0.529177963733673,0.495983630418777,
0.464778542518616,0.434642940759659,0.404955863952637,0.375219136476517,
0.344963222742081,0.313672333955765,0.280692428350449,0.245068684220314,
0.205169528722763,0.157508864998817,0.0901700109243393,

################################################################################

TITLE
    libavcodec COOK cplscale6

TYPE
    FLOAT

DATA
0.998005926609039,0.993956744670868,0.989822506904602,0.985598564147949,
0.981279790401459,0.976860702037811,0.972335040569305,0.967696130275726,
0.962936460971832,0.958047747612000,0.953020632266998,0.947844684123993,
0.942508161067963,0.936997592449188,0.931297719478607,0.925390899181366,
0.919256627559662,0.912870943546295,0.906205296516418,0.899225592613220,
0.891890347003937,0.884148240089417,0.875934481620789,0.867165684700012,
0.857730865478516,0.847477376461029,0.836184680461884,0.823513329029083,
0.808890223503113,0.791194140911102,0.767520070075989,0.707106769084930,
0.641024887561798,0.611565053462982,0.587959706783295,0.567296981811523,
0.548448026180267,0.530831515789032,0.514098942279816,0.498019754886627,
0.482430040836334,0.467206478118896,0.452251672744751,0.437485188245773,
0.422837972640991,0.408248275518417,0.393658757209778,0.379014074802399,
0.364258885383606,0.349335819482803,0.334183186292648,0.318732559680939,
0.302905440330505,0.286608695983887,0.269728302955627,0.252119421958923,
0.233590632677078,0.213876649737358,0.192587479948997,0.169101938605309,
0.142307326197624,0.109772264957428,0.0631198287010193,

################################################################################

TITLE
    libavcodec dpcm sol_table_old

TYPE
    8 32

DATA
    { 0x0,  0x1,  0x2 , 0x3,  0x6,  0xA,  0xF, 0x15,
    -0x15, -0xF, -0xA, -0x6, -0x3, -0x2, -0x1, 0x0};

################################################################################

TITLE
    libavcodec dpcm sol_table_new

TYPE
    8 32

DATA
    { 0x0,  0x1,  0x2,  0x3,  0x6,  0xA,  0xF,  0x15,
      0x0, -0x1, -0x2, -0x3, -0x6, -0xA, -0xF, -0x15};

################################################################################

TITLE
    libavcodec dpcm sol_table_16

TYPE
    16 32

DATA
    0x000, 0x008, 0x010, 0x020, 0x030, 0x040, 0x050, 0x060, 0x070, 0x080,
    0x090, 0x0A0, 0x0B0, 0x0C0, 0x0D0, 0x0E0, 0x0F0, 0x100, 0x110, 0x120,
    0x130, 0x140, 0x150, 0x160, 0x170, 0x180, 0x190, 0x1A0, 0x1B0, 0x1C0,
    0x1D0, 0x1E0, 0x1F0, 0x200, 0x208, 0x210, 0x218, 0x220, 0x228, 0x230,
    0x238, 0x240, 0x248, 0x250, 0x258, 0x260, 0x268, 0x270, 0x278, 0x280,
    0x288, 0x290, 0x298, 0x2A0, 0x2A8, 0x2B0, 0x2B8, 0x2C0, 0x2C8, 0x2D0,
    0x2D8, 0x2E0, 0x2E8, 0x2F0, 0x2F8, 0x300, 0x308, 0x310, 0x318, 0x320,
    0x328, 0x330, 0x338, 0x340, 0x348, 0x350, 0x358, 0x360, 0x368, 0x370,
    0x378, 0x380, 0x388, 0x390, 0x398, 0x3A0, 0x3A8, 0x3B0, 0x3B8, 0x3C0,
    0x3C8, 0x3D0, 0x3D8, 0x3E0, 0x3E8, 0x3F0, 0x3F8, 0x400, 0x440, 0x480,
    0x4C0, 0x500, 0x540, 0x580, 0x5C0, 0x600, 0x640, 0x680, 0x6C0, 0x700,
    0x740, 0x780, 0x7C0, 0x800, 0x900, 0xA00, 0xB00, 0xC00, 0xD00, 0xE00,
    0xF00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x3000, 0x4000

################################################################################

TITLE
    libavcodec CIN Audio/Video cinaudio_delta16_table

TYPE
    16

DATA
         0,      0,      0,      0,      0,      0,      0,      0,
         0,      0,      0,      0,      0,      0,      0,      0,
         0,      0,      0, -30210, -27853, -25680, -23677, -21829,
    -20126, -18556, -17108, -15774, -14543, -13408, -12362, -11398,
    -10508,  -9689,  -8933,  -8236,  -7593,  -7001,  -6455,  -5951,
     -5487,  -5059,  -4664,  -4300,  -3964,  -3655,  -3370,  -3107,
     -2865,  -2641,  -2435,  -2245,  -2070,  -1908,  -1759,  -1622,
     -1495,  -1379,  -1271,  -1172,  -1080,   -996,   -918,   -847,
      -781,   -720,   -663,   -612,   -564,   -520,   -479,   -442,
      -407,   -376,   -346,   -319,   -294,   -271,   -250,   -230,
      -212,   -196,   -181,   -166,   -153,   -141,   -130,   -120,
      -111,   -102,    -94,    -87,    -80,    -74,    -68,    -62,
       -58,    -53,    -49,    -45,    -41,    -38,    -35,    -32,
       -30,    -27,    -25,    -23,    -21,    -20,    -18,    -17,
       -15,    -14,    -13,    -12,    -11,    -10,     -9,     -8,
        -7,     -6,     -5,     -4,     -3,     -2,     -1,      0,
         0,      1,      2,      3,      4,      5,      6,      7,
         8,      9,     10,     11,     12,     13,     14,     15,
        17,     18,     20,     21,     23,     25,     27,     30,
        32,     35,     38,     41,     45,     49,     53,     58,
        62,     68,     74,     80,     87,     94,    102,    111,
       120,    130,    141,    153,    166,    181,    196,    212,
       230,    250,    271,    294,    319,    346,    376,    407,
       442,    479,    520,    564,    612,    663,    720,    781,
       847,    918,    996,   1080,   1172,   1271,   1379,   1495,
      1622,   1759,   1908,   2070,   2245,   2435,   2641,   2865,
      3107,   3370,   3655,   3964,   4300,   4664,   5059,   5487,
      5951,   6455,   7001,   7593,   8236,   8933,   9689,  10508,
     11398,  12362,  13408,  14543,  15774,  17108,  18556,  20126,
     21829,  23677,  25680,  27853,  30210,      0,      0,      0,
         0,      0,      0,      0,      0,      0,      0,      0,
         0,      0,      0,      0,      0,      0,      0,      0

################################################################################

TITLE
    libavcodec ff_zigzag_direct

TYPE
    8

DATA
    0,   1,  8, 16,  9,  2,  3, 10,
    17, 24, 32, 25, 18, 11,  4,  5,
    12, 19, 26, 33, 40, 48, 41, 34,
    27, 20, 13,  6,  7, 14, 21, 28,
    35, 42, 49, 56, 57, 50, 43, 36,
    29, 22, 15, 23, 30, 37, 44, 51,
    58, 59, 52, 45, 38, 31, 39, 46,
    53, 60, 61, 54, 47, 55, 62, 63

################################################################################

TITLE
    libavcodec ff_zigzag248_direct

TYPE
    8

DATA
     0,  8,  1,  9, 16, 24,  2, 10,
    17, 25, 32, 40, 48, 56, 33, 41,
    18, 26,  3, 11,  4, 12, 19, 27,
    34, 42, 49, 57, 50, 58, 35, 43,
    20, 28,  5, 13,  6, 14, 21, 29,
    36, 44, 51, 59, 52, 60, 37, 45,
    22, 30,  7, 15, 23, 31, 38, 46,
    53, 61, 54, 62, 39, 47, 55, 63,

################################################################################

TITLE
    libavcodec ff_alternate_horizontal_scan

TYPE
    8

DATA
    0,  1,   2,  3,  8,  9, 16, 17,
    10, 11,  4,  5,  6,  7, 15, 14,
    13, 12, 19, 18, 24, 25, 32, 33,
    26, 27, 20, 21, 22, 23, 28, 29,
    30, 31, 34, 35, 40, 41, 48, 49,
    42, 43, 36, 37, 38, 39, 44, 45,
    46, 47, 50, 51, 56, 57, 58, 59,
    52, 53, 54, 55, 60, 61, 62, 63,

################################################################################

TITLE
    libavcodec ff_alternate_vertical_scan

TYPE
    8

DATA
    0,  8,  16, 24,  1,  9,  2, 10,
    17, 25, 32, 40, 48, 56, 57, 49,
    41, 33, 26, 18,  3, 11,  4, 12,
    19, 27, 34, 42, 50, 58, 35, 43,
    51, 59, 20, 28,  5, 13,  6, 14,
    21, 29, 36, 44, 52, 60, 37, 45,
    53, 61, 22, 30,  7, 15, 23, 31,
    38, 46, 54, 62, 39, 47, 55, 63,

################################################################################

TITLE
    libavcodec inverse table

TYPE
    32

DATA
         0, 4294967295U,2147483648U,1431655766, 1073741824,  858993460,  715827883,  613566757,
 536870912,  477218589,  429496730,  390451573,  357913942,  330382100,  306783379,  286331154,
 268435456,  252645136,  238609295,  226050911,  214748365,  204522253,  195225787,  186737709,
 178956971,  171798692,  165191050,  159072863,  153391690,  148102321,  143165577,  138547333,
 134217728,  130150525,  126322568,  122713352,  119304648,  116080198,  113025456,  110127367,
 107374183,  104755300,  102261127,   99882961,   97612894,   95443718,   93368855,   91382283,
  89478486,   87652394,   85899346,   84215046,   82595525,   81037119,   79536432,   78090315,
  76695845,   75350304,   74051161,   72796056,   71582789,   70409300,   69273667,   68174085,
  67108864,   66076420,   65075263,   64103990,   63161284,   62245903,   61356676,   60492498,
  59652324,   58835169,   58040099,   57266231,   56512728,   55778797,   55063684,   54366675,
  53687092,   53024288,   52377650,   51746594,   51130564,   50529028,   49941481,   49367441,
  48806447,   48258060,   47721859,   47197443,   46684428,   46182445,   45691142,   45210183,
  44739243,   44278014,   43826197,   43383509,   42949673,   42524429,   42107523,   41698712,
  41297763,   40904451,   40518560,   40139882,   39768216,   39403370,   39045158,   38693400,
  38347923,   38008561,   37675152,   37347542,   37025581,   36709123,   36398028,   36092163,
  35791395,   35495598,   35204650,   34918434,   34636834,   34359739,   34087043,   33818641,
  33554432,   33294321,   33038210,   32786010,   32537632,   32292988,   32051995,   31814573,
  31580642,   31350127,   31122952,   30899046,   30678338,   30460761,   30246249,   30034737,
  29826162,   29620465,   29417585,   29217465,   29020050,   28825284,   28633116,   28443493,
  28256364,   28071682,   27889399,   27709467,   27531842,   27356480,   27183338,   27012373,
  26843546,   26676816,   26512144,   26349493,   26188825,   26030105,   25873297,   25718368,
  25565282,   25414008,   25264514,   25116768,   24970741,   24826401,   24683721,   24542671,
  24403224,   24265352,   24129030,   23994231,   23860930,   23729102,   23598722,   23469767,
  23342214,   23216040,   23091223,   22967740,   22845571,   22724695,   22605092,   22486740,
  22369622,   22253717,   22139007,   22025474,   21913099,   21801865,   21691755,   21582751,
  21474837,   21367997,   21262215,   21157475,   21053762,   20951060,   20849356,   20748635,
  20648882,   20550083,   20452226,   20355296,   20259280,   20164166,   20069941,   19976593,
  19884108,   19792477,   19701685,   19611723,   19522579,   19434242,   19346700,   19259944,
  19173962,   19088744,   19004281,   18920561,   18837576,   18755316,   18673771,   18592933,
  18512791,   18433337,   18354562,   18276457,   18199014,   18122225,   18046082,   17970575,
  17895698,   17821442,   17747799,   17674763,   17602325,   17530479,   17459217,   17388532,
  17318417,   17248865,   17179870,   17111424,   17043522,   16976156,   16909321,   16843010,

################################################################################

TITLE
    libavcodec DV dv_vlc_bits

TYPE
    16

DATA
 0x0000, 0x0002, 0x0007, 0x0008, 0x0009, 0x0014, 0x0015, 0x0016,
 0x0017, 0x0030, 0x0031, 0x0032, 0x0033, 0x0068, 0x0069, 0x006a,
 0x006b, 0x006c, 0x006d, 0x006e, 0x006f, 0x00e0, 0x00e1, 0x00e2,
 0x00e3, 0x00e4, 0x00e5, 0x00e6, 0x00e7, 0x00e8, 0x00e9, 0x00ea,
 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef, 0x01e0, 0x01e1, 0x01e2,
 0x01e3, 0x01e4, 0x01e5, 0x01e6, 0x01e7, 0x01e8, 0x01e9, 0x01ea,
 0x01eb, 0x01ec, 0x01ed, 0x01ee, 0x01ef, 0x03e0, 0x03e1, 0x03e2,
 0x03e3, 0x03e4, 0x03e5, 0x03e6, 0x07ce, 0x07cf, 0x07d0, 0x07d1,
 0x07d2, 0x07d3, 0x07d4, 0x07d5, 0x0fac, 0x0fad, 0x0fae, 0x0faf,
 0x0fb0, 0x0fb1, 0x0fb2, 0x0fb3, 0x0fb4, 0x0fb5, 0x0fb6, 0x0fb7,
 0x0fb8, 0x0fb9, 0x0fba, 0x0fbb, 0x0fbc, 0x0fbd, 0x0fbe, 0x0fbf,
 0x1f80, 0x1f81, 0x1f82, 0x1f83, 0x1f84, 0x1f85, 0x1f86, 0x1f87,
 0x1f88, 0x1f89, 0x1f8a, 0x1f8b, 0x1f8c, 0x1f8d, 0x1f8e, 0x1f8f,
 0x1f90, 0x1f91, 0x1f92, 0x1f93, 0x1f94, 0x1f95, 0x1f96, 0x1f97,
 0x1f98, 0x1f99, 0x1f9a, 0x1f9b, 0x1f9c, 0x1f9d, 0x1f9e, 0x1f9f,
 0x1fa0, 0x1fa1, 0x1fa2, 0x1fa3, 0x1fa4, 0x1fa5, 0x1fa6, 0x1fa7,
 0x1fa8, 0x1fa9, 0x1faa, 0x1fab, 0x1fac, 0x1fad, 0x1fae, 0x1faf,
 0x1fb0, 0x1fb1, 0x1fb2, 0x1fb3, 0x1fb4, 0x1fb5, 0x1fb6, 0x1fb7,
 0x1fb8, 0x1fb9, 0x1fba, 0x1fbb, 0x1fbc, 0x1fbd, 0x1fbe, 0x1fbf,
 0x7f00, 0x7f01, 0x7f02, 0x7f03, 0x7f04, 0x7f05, 0x7f06, 0x7f07,
 0x7f08, 0x7f09, 0x7f0a, 0x7f0b, 0x7f0c, 0x7f0d, 0x7f0e, 0x7f0f,
 0x7f10, 0x7f11, 0x7f12, 0x7f13, 0x7f14, 0x7f15, 0x7f16, 0x7f17,
 0x7f18, 0x7f19, 0x7f1a, 0x7f1b, 0x7f1c, 0x7f1d, 0x7f1e, 0x7f1f,
 0x7f20, 0x7f21, 0x7f22, 0x7f23, 0x7f24, 0x7f25, 0x7f26, 0x7f27,
 0x7f28, 0x7f29, 0x7f2a, 0x7f2b, 0x7f2c, 0x7f2d, 0x7f2e, 0x7f2f,
 0x7f30, 0x7f31, 0x7f32, 0x7f33, 0x7f34, 0x7f35, 0x7f36, 0x7f37,
 0x7f38, 0x7f39, 0x7f3a, 0x7f3b, 0x7f3c, 0x7f3d, 0x7f3e, 0x7f3f,
 0x7f40, 0x7f41, 0x7f42, 0x7f43, 0x7f44, 0x7f45, 0x7f46, 0x7f47,
 0x7f48, 0x7f49, 0x7f4a, 0x7f4b, 0x7f4c, 0x7f4d, 0x7f4e, 0x7f4f,
 0x7f50, 0x7f51, 0x7f52, 0x7f53, 0x7f54, 0x7f55, 0x7f56, 0x7f57,
 0x7f58, 0x7f59, 0x7f5a, 0x7f5b, 0x7f5c, 0x7f5d, 0x7f5e, 0x7f5f,
 0x7f60, 0x7f61, 0x7f62, 0x7f63, 0x7f64, 0x7f65, 0x7f66, 0x7f67,
 0x7f68, 0x7f69, 0x7f6a, 0x7f6b, 0x7f6c, 0x7f6d, 0x7f6e, 0x7f6f,
 0x7f70, 0x7f71, 0x7f72, 0x7f73, 0x7f74, 0x7f75, 0x7f76, 0x7f77,
 0x7f78, 0x7f79, 0x7f7a, 0x7f7b, 0x7f7c, 0x7f7d, 0x7f7e, 0x7f7f,
 0x7f80, 0x7f81, 0x7f82, 0x7f83, 0x7f84, 0x7f85, 0x7f86, 0x7f87,
 0x7f88, 0x7f89, 0x7f8a, 0x7f8b, 0x7f8c, 0x7f8d, 0x7f8e, 0x7f8f,
 0x7f90, 0x7f91, 0x7f92, 0x7f93, 0x7f94, 0x7f95, 0x7f96, 0x7f97,
 0x7f98, 0x7f99, 0x7f9a, 0x7f9b, 0x7f9c, 0x7f9d, 0x7f9e, 0x7f9f,
 0x7fa0, 0x7fa1, 0x7fa2, 0x7fa3, 0x7fa4, 0x7fa5, 0x7fa6, 0x7fa7,
 0x7fa8, 0x7fa9, 0x7faa, 0x7fab, 0x7fac, 0x7fad, 0x7fae, 0x7faf,
 0x7fb0, 0x7fb1, 0x7fb2, 0x7fb3, 0x7fb4, 0x7fb5, 0x7fb6, 0x7fb7,
 0x7fb8, 0x7fb9, 0x7fba, 0x7fbb, 0x7fbc, 0x7fbd, 0x7fbe, 0x7fbf,
 0x7fc0, 0x7fc1, 0x7fc2, 0x7fc3, 0x7fc4, 0x7fc5, 0x7fc6, 0x7fc7,
 0x7fc8, 0x7fc9, 0x7fca, 0x7fcb, 0x7fcc, 0x7fcd, 0x7fce, 0x7fcf,
 0x7fd0, 0x7fd1, 0x7fd2, 0x7fd3, 0x7fd4, 0x7fd5, 0x7fd6, 0x7fd7,
 0x7fd8, 0x7fd9, 0x7fda, 0x7fdb, 0x7fdc, 0x7fdd, 0x7fde, 0x7fdf,
 0x7fe0, 0x7fe1, 0x7fe2, 0x7fe3, 0x7fe4, 0x7fe5, 0x7fe6, 0x7fe7,
 0x7fe8, 0x7fe9, 0x7fea, 0x7feb, 0x7fec, 0x7fed, 0x7fee, 0x7fef,
 0x7ff0, 0x7ff1, 0x7ff2, 0x7ff3, 0x7ff4, 0x7ff5, 0x7ff6, 0x7ff7,
 0x7ff8, 0x7ff9, 0x7ffa, 0x7ffb, 0x7ffc, 0x7ffd, 0x7ffe, 0x7fff,
 0x0006,

################################################################################

TITLE
    libavcodec DV dv_vlc_len

TYPE
    8

DATA
  2,  3,  4,  4,  4,  5,  5,  5,
  5,  6,  6,  6,  6,  7,  7,  7,
  7,  7,  7,  7,  7,  8,  8,  8,
  8,  8,  8,  8,  8,  8,  8,  8,
  8,  8,  8,  8,  8,  9,  9,  9,
  9,  9,  9,  9,  9,  9,  9,  9,
  9,  9,  9,  9,  9, 10, 10, 10,
 10, 10, 10, 10, 11, 11, 11, 11,
 11, 11, 11, 11, 12, 12, 12, 12,
 12, 12, 12, 12, 12, 12, 12, 12,
 12, 12, 12, 12, 12, 12, 12, 12,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15,
  4,

################################################################################

TITLE
    libavcodec DV dv_vlc_run

TYPE
    8

DATA
  0,  0,  1,  0,  0,  2,  1,  0,
  0,  3,  4,  0,  0,  5,  6,  2,
  1,  1,  0,  0,  0,  7,  8,  9,
 10,  3,  4,  2,  1,  1,  1,  0,
  0,  0,  0,  0,  0, 11, 12, 13,
 14,  5,  6,  3,  4,  2,  2,  1,
  0,  0,  0,  0,  0,  5,  3,  3,
  2,  1,  1,  1,  0,  1,  6,  4,
  3,  1,  1,  1,  2,  3,  4,  5,
  7,  8,  9, 10,  7,  8,  4,  3,
  2,  2,  2,  2,  2,  1,  1,  1,
  0,  1,  2,  3,  4,  5,  6,  7,
  8,  9, 10, 11, 12, 13, 14, 15,
 16, 17, 18, 19, 20, 21, 22, 23,
 24, 25, 26, 27, 28, 29, 30, 31,
 32, 33, 34, 35, 36, 37, 38, 39,
 40, 41, 42, 43, 44, 45, 46, 47,
 48, 49, 50, 51, 52, 53, 54, 55,
 56, 57, 58, 59, 60, 61, 62, 63,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
127,

################################################################################

TITLE
    libavcodec DV dv_vlc_level

TYPE
    8

DATA
  1,  2,  1,  3,  4,  1,  2,  5,
  6,  1,  1,  7,  8,  1,  1,  2,
  3,  4,  9, 10, 11,  1,  1,  1,
  1,  2,  2,  3,  5,  6,  7, 12,
 13, 14, 15, 16, 17,  1,  1,  1,
  1,  2,  2,  3,  3,  4,  5,  8,
 18, 19, 20, 21, 22,  3,  4,  5,
  6,  9, 10, 11,  0,  0,  3,  4,
  6, 12, 13, 14,  0,  0,  0,  0,
  2,  2,  2,  2,  3,  3,  5,  7,
  7,  8,  9, 10, 11, 15, 16, 17,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,
  0,  1,  2,  3,  4,  5,  6,  7,
  8,  9, 10, 11, 12, 13, 14, 15,
 16, 17, 18, 19, 20, 21, 22, 23,
 24, 25, 26, 27, 28, 29, 30, 31,
 32, 33, 34, 35, 36, 37, 38, 39,
 40, 41, 42, 43, 44, 45, 46, 47,
 48, 49, 50, 51, 52, 53, 54, 55,
 56, 57, 58, 59, 60, 61, 62, 63,
 64, 65, 66, 67, 68, 69, 70, 71,
 72, 73, 74, 75, 76, 77, 78, 79,
 80, 81, 82, 83, 84, 85, 86, 87,
 88, 89, 90, 91, 92, 93, 94, 95,
 96, 97, 98, 99, 100, 101, 102, 103,
 104, 105, 106, 107, 108, 109, 110, 111,
 112, 113, 114, 115, 116, 117, 118, 119,
 120, 121, 122, 123, 124, 125, 126, 127,
 128, 129, 130, 131, 132, 133, 134, 135,
 136, 137, 138, 139, 140, 141, 142, 143,
 144, 145, 146, 147, 148, 149, 150, 151,
 152, 153, 154, 155, 156, 157, 158, 159,
 160, 161, 162, 163, 164, 165, 166, 167,
 168, 169, 170, 171, 172, 173, 174, 175,
 176, 177, 178, 179, 180, 181, 182, 183,
 184, 185, 186, 187, 188, 189, 190, 191,
 192, 193, 194, 195, 196, 197, 198, 199,
 200, 201, 202, 203, 204, 205, 206, 207,
 208, 209, 210, 211, 212, 213, 214, 215,
 216, 217, 218, 219, 220, 221, 222, 223,
 224, 225, 226, 227, 228, 229, 230, 231,
 232, 233, 234, 235, 236, 237, 238, 239,
 240, 241, 242, 243, 244, 245, 246, 247,
 248, 249, 250, 251, 252, 253, 254, 255,
  0,

################################################################################

TITLE
    libavcodec DV dv_88_areas

TYPE
    8

DATA
    0,0,0,1,1,1,2,2,
    0,0,1,1,1,2,2,2,
    0,1,1,1,2,2,2,3,
    1,1,1,2,2,2,3,3,
    1,1,2,2,2,3,3,3,
    1,2,2,2,3,3,3,3,
    2,2,2,3,3,3,3,3,
    2,2,3,3,3,3,3,3,

################################################################################

TITLE
    libavcodec DV dv_248_areas

TYPE
    8

DATA
    0,0,1,1,1,2,2,3,
    0,0,1,1,2,2,2,3,
    0,1,1,2,2,2,3,3,
    0,1,1,2,2,2,3,3,
    1,1,2,2,2,3,3,3,
    1,1,2,2,2,3,3,3,
    1,2,2,2,3,3,3,3,
    1,2,2,3,3,3,3,3,

################################################################################

TITLE
    libavcodec DV dv_quant_shifts

TYPE
    8

DATA
  { 3,3,4,4 },
  { 3,3,4,4 },
  { 2,3,3,4 },
  { 2,3,3,4 },
  { 2,2,3,3 },
  { 2,2,3,3 },
  { 1,2,2,3 },
  { 1,2,2,3 },
  { 1,1,2,2 },
  { 1,1,2,2 },
  { 0,1,1,2 },
  { 0,1,1,2 },
  { 0,0,1,1 },
  { 0,0,1,1 },
  { 0,0,0,1 },
  { 0,0,0,0 },
  { 0,0,0,0 },
  { 0,0,0,0 },
  { 0,0,0,0 },
  { 0,0,0,0 },
  { 0,0,0,0 },
  { 0,0,0,0 },

################################################################################

TITLE
    libavcodec DV dv_place_420

TYPE
    16

DATA
 0x0c24, 0x2412, 0x3036, 0x0000, 0x1848,
 0x0e24, 0x2612, 0x3236, 0x0200, 0x1a48,
 0x1024, 0x2812, 0x3436, 0x0400, 0x1c48,
 0x1026, 0x2814, 0x3438, 0x0402, 0x1c4a,
 0x0e26, 0x2614, 0x3238, 0x0202, 0x1a4a,
 0x0c26, 0x2414, 0x3038, 0x0002, 0x184a,
 0x0c28, 0x2416, 0x303a, 0x0004, 0x184c,
 0x0e28, 0x2616, 0x323a, 0x0204, 0x1a4c,
 0x1028, 0x2816, 0x343a, 0x0404, 0x1c4c,
 0x102a, 0x2818, 0x343c, 0x0406, 0x1c4e,
 0x0e2a, 0x2618, 0x323c, 0x0206, 0x1a4e,
 0x0c2a, 0x2418, 0x303c, 0x0006, 0x184e,
 0x0c2c, 0x241a, 0x303e, 0x0008, 0x1850,
 0x0e2c, 0x261a, 0x323e, 0x0208, 0x1a50,
 0x102c, 0x281a, 0x343e, 0x0408, 0x1c50,
 0x102e, 0x281c, 0x3440, 0x040a, 0x1c52,
 0x0e2e, 0x261c, 0x3240, 0x020a, 0x1a52,
 0x0c2e, 0x241c, 0x3040, 0x000a, 0x1852,
 0x0c30, 0x241e, 0x3042, 0x000c, 0x1854,
 0x0e30, 0x261e, 0x3242, 0x020c, 0x1a54,
 0x1030, 0x281e, 0x3442, 0x040c, 0x1c54,
 0x1032, 0x2820, 0x3444, 0x040e, 0x1c56,
 0x0e32, 0x2620, 0x3244, 0x020e, 0x1a56,
 0x0c32, 0x2420, 0x3044, 0x000e, 0x1856,
 0x0c34, 0x2422, 0x3046, 0x0010, 0x1858,
 0x0e34, 0x2622, 0x3246, 0x0210, 0x1a58,
 0x1034, 0x2822, 0x3446, 0x0410, 0x1c58,
 0x1224, 0x2a12, 0x3636, 0x0600, 0x1e48,
 0x1424, 0x2c12, 0x3836, 0x0800, 0x2048,
 0x1624, 0x2e12, 0x3a36, 0x0a00, 0x2248,
 0x1626, 0x2e14, 0x3a38, 0x0a02, 0x224a,
 0x1426, 0x2c14, 0x3838, 0x0802, 0x204a,
 0x1226, 0x2a14, 0x3638, 0x0602, 0x1e4a,
 0x1228, 0x2a16, 0x363a, 0x0604, 0x1e4c,
 0x1428, 0x2c16, 0x383a, 0x0804, 0x204c,
 0x1628, 0x2e16, 0x3a3a, 0x0a04, 0x224c,
 0x162a, 0x2e18, 0x3a3c, 0x0a06, 0x224e,
 0x142a, 0x2c18, 0x383c, 0x0806, 0x204e,
 0x122a, 0x2a18, 0x363c, 0x0606, 0x1e4e,
 0x122c, 0x2a1a, 0x363e, 0x0608, 0x1e50,
 0x142c, 0x2c1a, 0x383e, 0x0808, 0x2050,
 0x162c, 0x2e1a, 0x3a3e, 0x0a08, 0x2250,
 0x162e, 0x2e1c, 0x3a40, 0x0a0a, 0x2252,
 0x142e, 0x2c1c, 0x3840, 0x080a, 0x2052,
 0x122e, 0x2a1c, 0x3640, 0x060a, 0x1e52,
 0x1230, 0x2a1e, 0x3642, 0x060c, 0x1e54,
 0x1430, 0x2c1e, 0x3842, 0x080c, 0x2054,
 0x1630, 0x2e1e, 0x3a42, 0x0a0c, 0x2254,
 0x1632, 0x2e20, 0x3a44, 0x0a0e, 0x2256,
 0x1432, 0x2c20, 0x3844, 0x080e, 0x2056,
 0x1232, 0x2a20, 0x3644, 0x060e, 0x1e56,
 0x1234, 0x2a22, 0x3646, 0x0610, 0x1e58,
 0x1434, 0x2c22, 0x3846, 0x0810, 0x2058,
 0x1634, 0x2e22, 0x3a46, 0x0a10, 0x2258,
 0x1824, 0x3012, 0x3c36, 0x0c00, 0x2448,
 0x1a24, 0x3212, 0x3e36, 0x0e00, 0x2648,
 0x1c24, 0x3412, 0x4036, 0x1000, 0x2848,
 0x1c26, 0x3414, 0x4038, 0x1002, 0x284a,
 0x1a26, 0x3214, 0x3e38, 0x0e02, 0x264a,
 0x1826, 0x3014, 0x3c38, 0x0c02, 0x244a,
 0x1828, 0x3016, 0x3c3a, 0x0c04, 0x244c,
 0x1a28, 0x3216, 0x3e3a, 0x0e04, 0x264c,
 0x1c28, 0x3416, 0x403a, 0x1004, 0x284c,
 0x1c2a, 0x3418, 0x403c, 0x1006, 0x284e,
 0x1a2a, 0x3218, 0x3e3c, 0x0e06, 0x264e,
 0x182a, 0x3018, 0x3c3c, 0x0c06, 0x244e,
 0x182c, 0x301a, 0x3c3e, 0x0c08, 0x2450,
 0x1a2c, 0x321a, 0x3e3e, 0x0e08, 0x2650,
 0x1c2c, 0x341a, 0x403e, 0x1008, 0x2850,
 0x1c2e, 0x341c, 0x4040, 0x100a, 0x2852,
 0x1a2e, 0x321c, 0x3e40, 0x0e0a, 0x2652,
 0x182e, 0x301c, 0x3c40, 0x0c0a, 0x2452,
 0x1830, 0x301e, 0x3c42, 0x0c0c, 0x2454,
 0x1a30, 0x321e, 0x3e42, 0x0e0c, 0x2654,
 0x1c30, 0x341e, 0x4042, 0x100c, 0x2854,
 0x1c32, 0x3420, 0x4044, 0x100e, 0x2856,
 0x1a32, 0x3220, 0x3e44, 0x0e0e, 0x2656,
 0x1832, 0x3020, 0x3c44, 0x0c0e, 0x2456,
 0x1834, 0x3022, 0x3c46, 0x0c10, 0x2458,
 0x1a34, 0x3222, 0x3e46, 0x0e10, 0x2658,
 0x1c34, 0x3422, 0x4046, 0x1010, 0x2858,
 0x1e24, 0x3612, 0x4236, 0x1200, 0x2a48,
 0x2024, 0x3812, 0x4436, 0x1400, 0x2c48,
 0x2224, 0x3a12, 0x4636, 0x1600, 0x2e48,
 0x2226, 0x3a14, 0x4638, 0x1602, 0x2e4a,
 0x2026, 0x3814, 0x4438, 0x1402, 0x2c4a,
 0x1e26, 0x3614, 0x4238, 0x1202, 0x2a4a,
 0x1e28, 0x3616, 0x423a, 0x1204, 0x2a4c,
 0x2028, 0x3816, 0x443a, 0x1404, 0x2c4c,
 0x2228, 0x3a16, 0x463a, 0x1604, 0x2e4c,
 0x222a, 0x3a18, 0x463c, 0x1606, 0x2e4e,
 0x202a, 0x3818, 0x443c, 0x1406, 0x2c4e,
 0x1e2a, 0x3618, 0x423c, 0x1206, 0x2a4e,
 0x1e2c, 0x361a, 0x423e, 0x1208, 0x2a50,
 0x202c, 0x381a, 0x443e, 0x1408, 0x2c50,
 0x222c, 0x3a1a, 0x463e, 0x1608, 0x2e50,
 0x222e, 0x3a1c, 0x4640, 0x160a, 0x2e52,
 0x202e, 0x381c, 0x4440, 0x140a, 0x2c52,
 0x1e2e, 0x361c, 0x4240, 0x120a, 0x2a52,
 0x1e30, 0x361e, 0x4242, 0x120c, 0x2a54,
 0x2030, 0x381e, 0x4442, 0x140c, 0x2c54,
 0x2230, 0x3a1e, 0x4642, 0x160c, 0x2e54,
 0x2232, 0x3a20, 0x4644, 0x160e, 0x2e56,
 0x2032, 0x3820, 0x4444, 0x140e, 0x2c56,
 0x1e32, 0x3620, 0x4244, 0x120e, 0x2a56,
 0x1e34, 0x3622, 0x4246, 0x1210, 0x2a58,
 0x2034, 0x3822, 0x4446, 0x1410, 0x2c58,
 0x2234, 0x3a22, 0x4646, 0x1610, 0x2e58,
 0x2424, 0x3c12, 0x0036, 0x1800, 0x3048,
 0x2624, 0x3e12, 0x0236, 0x1a00, 0x3248,
 0x2824, 0x4012, 0x0436, 0x1c00, 0x3448,
 0x2826, 0x4014, 0x0438, 0x1c02, 0x344a,
 0x2626, 0x3e14, 0x0238, 0x1a02, 0x324a,
 0x2426, 0x3c14, 0x0038, 0x1802, 0x304a,
 0x2428, 0x3c16, 0x003a, 0x1804, 0x304c,
 0x2628, 0x3e16, 0x023a, 0x1a04, 0x324c,
 0x2828, 0x4016, 0x043a, 0x1c04, 0x344c,
 0x282a, 0x4018, 0x043c, 0x1c06, 0x344e,
 0x262a, 0x3e18, 0x023c, 0x1a06, 0x324e,
 0x242a, 0x3c18, 0x003c, 0x1806, 0x304e,
 0x242c, 0x3c1a, 0x003e, 0x1808, 0x3050,
 0x262c, 0x3e1a, 0x023e, 0x1a08, 0x3250,
 0x282c, 0x401a, 0x043e, 0x1c08, 0x3450,
 0x282e, 0x401c, 0x0440, 0x1c0a, 0x3452,
 0x262e, 0x3e1c, 0x0240, 0x1a0a, 0x3252,
 0x242e, 0x3c1c, 0x0040, 0x180a, 0x3052,
 0x2430, 0x3c1e, 0x0042, 0x180c, 0x3054,
 0x2630, 0x3e1e, 0x0242, 0x1a0c, 0x3254,
 0x2830, 0x401e, 0x0442, 0x1c0c, 0x3454,
 0x2832, 0x4020, 0x0444, 0x1c0e, 0x3456,
 0x2632, 0x3e20, 0x0244, 0x1a0e, 0x3256,
 0x2432, 0x3c20, 0x0044, 0x180e, 0x3056,
 0x2434, 0x3c22, 0x0046, 0x1810, 0x3058,
 0x2634, 0x3e22, 0x0246, 0x1a10, 0x3258,
 0x2834, 0x4022, 0x0446, 0x1c10, 0x3458,
 0x2a24, 0x4212, 0x0636, 0x1e00, 0x3648,
 0x2c24, 0x4412, 0x0836, 0x2000, 0x3848,
 0x2e24, 0x4612, 0x0a36, 0x2200, 0x3a48,
 0x2e26, 0x4614, 0x0a38, 0x2202, 0x3a4a,
 0x2c26, 0x4414, 0x0838, 0x2002, 0x384a,
 0x2a26, 0x4214, 0x0638, 0x1e02, 0x364a,
 0x2a28, 0x4216, 0x063a, 0x1e04, 0x364c,
 0x2c28, 0x4416, 0x083a, 0x2004, 0x384c,
 0x2e28, 0x4616, 0x0a3a, 0x2204, 0x3a4c,
 0x2e2a, 0x4618, 0x0a3c, 0x2206, 0x3a4e,
 0x2c2a, 0x4418, 0x083c, 0x2006, 0x384e,
 0x2a2a, 0x4218, 0x063c, 0x1e06, 0x364e,
 0x2a2c, 0x421a, 0x063e, 0x1e08, 0x3650,
 0x2c2c, 0x441a, 0x083e, 0x2008, 0x3850,
 0x2e2c, 0x461a, 0x0a3e, 0x2208, 0x3a50,
 0x2e2e, 0x461c, 0x0a40, 0x220a, 0x3a52,
 0x2c2e, 0x441c, 0x0840, 0x200a, 0x3852,
 0x2a2e, 0x421c, 0x0640, 0x1e0a, 0x3652,
 0x2a30, 0x421e, 0x0642, 0x1e0c, 0x3654,
 0x2c30, 0x441e, 0x0842, 0x200c, 0x3854,
 0x2e30, 0x461e, 0x0a42, 0x220c, 0x3a54,
 0x2e32, 0x4620, 0x0a44, 0x220e, 0x3a56,
 0x2c32, 0x4420, 0x0844, 0x200e, 0x3856,
 0x2a32, 0x4220, 0x0644, 0x1e0e, 0x3656,
 0x2a34, 0x4222, 0x0646, 0x1e10, 0x3658,
 0x2c34, 0x4422, 0x0846, 0x2010, 0x3858,
 0x2e34, 0x4622, 0x0a46, 0x2210, 0x3a58,
 0x3024, 0x0012, 0x0c36, 0x2400, 0x3c48,
 0x3224, 0x0212, 0x0e36, 0x2600, 0x3e48,
 0x3424, 0x0412, 0x1036, 0x2800, 0x4048,
 0x3426, 0x0414, 0x1038, 0x2802, 0x404a,
 0x3226, 0x0214, 0x0e38, 0x2602, 0x3e4a,
 0x3026, 0x0014, 0x0c38, 0x2402, 0x3c4a,
 0x3028, 0x0016, 0x0c3a, 0x2404, 0x3c4c,
 0x3228, 0x0216, 0x0e3a, 0x2604, 0x3e4c,
 0x3428, 0x0416, 0x103a, 0x2804, 0x404c,
 0x342a, 0x0418, 0x103c, 0x2806, 0x404e,
 0x322a, 0x0218, 0x0e3c, 0x2606, 0x3e4e,
 0x302a, 0x0018, 0x0c3c, 0x2406, 0x3c4e,
 0x302c, 0x001a, 0x0c3e, 0x2408, 0x3c50,
 0x322c, 0x021a, 0x0e3e, 0x2608, 0x3e50,
 0x342c, 0x041a, 0x103e, 0x2808, 0x4050,
 0x342e, 0x041c, 0x1040, 0x280a, 0x4052,
 0x322e, 0x021c, 0x0e40, 0x260a, 0x3e52,
 0x302e, 0x001c, 0x0c40, 0x240a, 0x3c52,
 0x3030, 0x001e, 0x0c42, 0x240c, 0x3c54,
 0x3230, 0x021e, 0x0e42, 0x260c, 0x3e54,
 0x3430, 0x041e, 0x1042, 0x280c, 0x4054,
 0x3432, 0x0420, 0x1044, 0x280e, 0x4056,
 0x3232, 0x0220, 0x0e44, 0x260e, 0x3e56,
 0x3032, 0x0020, 0x0c44, 0x240e, 0x3c56,
 0x3034, 0x0022, 0x0c46, 0x2410, 0x3c58,
 0x3234, 0x0222, 0x0e46, 0x2610, 0x3e58,
 0x3434, 0x0422, 0x1046, 0x2810, 0x4058,
 0x3624, 0x0612, 0x1236, 0x2a00, 0x4248,
 0x3824, 0x0812, 0x1436, 0x2c00, 0x4448,
 0x3a24, 0x0a12, 0x1636, 0x2e00, 0x4648,
 0x3a26, 0x0a14, 0x1638, 0x2e02, 0x464a,
 0x3826, 0x0814, 0x1438, 0x2c02, 0x444a,
 0x3626, 0x0614, 0x1238, 0x2a02, 0x424a,
 0x3628, 0x0616, 0x123a, 0x2a04, 0x424c,
 0x3828, 0x0816, 0x143a, 0x2c04, 0x444c,
 0x3a28, 0x0a16, 0x163a, 0x2e04, 0x464c,
 0x3a2a, 0x0a18, 0x163c, 0x2e06, 0x464e,
 0x382a, 0x0818, 0x143c, 0x2c06, 0x444e,
 0x362a, 0x0618, 0x123c, 0x2a06, 0x424e,
 0x362c, 0x061a, 0x123e, 0x2a08, 0x4250,
 0x382c, 0x081a, 0x143e, 0x2c08, 0x4450,
 0x3a2c, 0x0a1a, 0x163e, 0x2e08, 0x4650,
 0x3a2e, 0x0a1c, 0x1640, 0x2e0a, 0x4652,
 0x382e, 0x081c, 0x1440, 0x2c0a, 0x4452,
 0x362e, 0x061c, 0x1240, 0x2a0a, 0x4252,
 0x3630, 0x061e, 0x1242, 0x2a0c, 0x4254,
 0x3830, 0x081e, 0x1442, 0x2c0c, 0x4454,
 0x3a30, 0x0a1e, 0x1642, 0x2e0c, 0x4654,
 0x3a32, 0x0a20, 0x1644, 0x2e0e, 0x4656,
 0x3832, 0x0820, 0x1444, 0x2c0e, 0x4456,
 0x3632, 0x0620, 0x1244, 0x2a0e, 0x4256,
 0x3634, 0x0622, 0x1246, 0x2a10, 0x4258,
 0x3834, 0x0822, 0x1446, 0x2c10, 0x4458,
 0x3a34, 0x0a22, 0x1646, 0x2e10, 0x4658,
 0x3c24, 0x0c12, 0x1836, 0x3000, 0x0048,
 0x3e24, 0x0e12, 0x1a36, 0x3200, 0x0248,
 0x4024, 0x1012, 0x1c36, 0x3400, 0x0448,
 0x4026, 0x1014, 0x1c38, 0x3402, 0x044a,
 0x3e26, 0x0e14, 0x1a38, 0x3202, 0x024a,
 0x3c26, 0x0c14, 0x1838, 0x3002, 0x004a,
 0x3c28, 0x0c16, 0x183a, 0x3004, 0x004c,
 0x3e28, 0x0e16, 0x1a3a, 0x3204, 0x024c,
 0x4028, 0x1016, 0x1c3a, 0x3404, 0x044c,
 0x402a, 0x1018, 0x1c3c, 0x3406, 0x044e,
 0x3e2a, 0x0e18, 0x1a3c, 0x3206, 0x024e,
 0x3c2a, 0x0c18, 0x183c, 0x3006, 0x004e,
 0x3c2c, 0x0c1a, 0x183e, 0x3008, 0x0050,
 0x3e2c, 0x0e1a, 0x1a3e, 0x3208, 0x0250,
 0x402c, 0x101a, 0x1c3e, 0x3408, 0x0450,
 0x402e, 0x101c, 0x1c40, 0x340a, 0x0452,
 0x3e2e, 0x0e1c, 0x1a40, 0x320a, 0x0252,
 0x3c2e, 0x0c1c, 0x1840, 0x300a, 0x0052,
 0x3c30, 0x0c1e, 0x1842, 0x300c, 0x0054,
 0x3e30, 0x0e1e, 0x1a42, 0x320c, 0x0254,
 0x4030, 0x101e, 0x1c42, 0x340c, 0x0454,
 0x4032, 0x1020, 0x1c44, 0x340e, 0x0456,
 0x3e32, 0x0e20, 0x1a44, 0x320e, 0x0256,
 0x3c32, 0x0c20, 0x1844, 0x300e, 0x0056,
 0x3c34, 0x0c22, 0x1846, 0x3010, 0x0058,
 0x3e34, 0x0e22, 0x1a46, 0x3210, 0x0258,
 0x4034, 0x1022, 0x1c46, 0x3410, 0x0458,
 0x4224, 0x1212, 0x1e36, 0x3600, 0x0648,
 0x4424, 0x1412, 0x2036, 0x3800, 0x0848,
 0x4624, 0x1612, 0x2236, 0x3a00, 0x0a48,
 0x4626, 0x1614, 0x2238, 0x3a02, 0x0a4a,
 0x4426, 0x1414, 0x2038, 0x3802, 0x084a,
 0x4226, 0x1214, 0x1e38, 0x3602, 0x064a,
 0x4228, 0x1216, 0x1e3a, 0x3604, 0x064c,
 0x4428, 0x1416, 0x203a, 0x3804, 0x084c,
 0x4628, 0x1616, 0x223a, 0x3a04, 0x0a4c,
 0x462a, 0x1618, 0x223c, 0x3a06, 0x0a4e,
 0x442a, 0x1418, 0x203c, 0x3806, 0x084e,
 0x422a, 0x1218, 0x1e3c, 0x3606, 0x064e,
 0x422c, 0x121a, 0x1e3e, 0x3608, 0x0650,
 0x442c, 0x141a, 0x203e, 0x3808, 0x0850,
 0x462c, 0x161a, 0x223e, 0x3a08, 0x0a50,
 0x462e, 0x161c, 0x2240, 0x3a0a, 0x0a52,
 0x442e, 0x141c, 0x2040, 0x380a, 0x0852,
 0x422e, 0x121c, 0x1e40, 0x360a, 0x0652,
 0x4230, 0x121e, 0x1e42, 0x360c, 0x0654,
 0x4430, 0x141e, 0x2042, 0x380c, 0x0854,
 0x4630, 0x161e, 0x2242, 0x3a0c, 0x0a54,
 0x4632, 0x1620, 0x2244, 0x3a0e, 0x0a56,
 0x4432, 0x1420, 0x2044, 0x380e, 0x0856,
 0x4232, 0x1220, 0x1e44, 0x360e, 0x0656,
 0x4234, 0x1222, 0x1e46, 0x3610, 0x0658,
 0x4434, 0x1422, 0x2046, 0x3810, 0x0858,
 0x4634, 0x1622, 0x2246, 0x3a10, 0x0a58,
 0x0024, 0x1812, 0x2436, 0x3c00, 0x0c48,
 0x0224, 0x1a12, 0x2636, 0x3e00, 0x0e48,
 0x0424, 0x1c12, 0x2836, 0x4000, 0x1048,
 0x0426, 0x1c14, 0x2838, 0x4002, 0x104a,
 0x0226, 0x1a14, 0x2638, 0x3e02, 0x0e4a,
 0x0026, 0x1814, 0x2438, 0x3c02, 0x0c4a,
 0x0028, 0x1816, 0x243a, 0x3c04, 0x0c4c,
 0x0228, 0x1a16, 0x263a, 0x3e04, 0x0e4c,
 0x0428, 0x1c16, 0x283a, 0x4004, 0x104c,
 0x042a, 0x1c18, 0x283c, 0x4006, 0x104e,
 0x022a, 0x1a18, 0x263c, 0x3e06, 0x0e4e,
 0x002a, 0x1818, 0x243c, 0x3c06, 0x0c4e,
 0x002c, 0x181a, 0x243e, 0x3c08, 0x0c50,
 0x022c, 0x1a1a, 0x263e, 0x3e08, 0x0e50,
 0x042c, 0x1c1a, 0x283e, 0x4008, 0x1050,
 0x042e, 0x1c1c, 0x2840, 0x400a, 0x1052,
 0x022e, 0x1a1c, 0x2640, 0x3e0a, 0x0e52,
 0x002e, 0x181c, 0x2440, 0x3c0a, 0x0c52,
 0x0030, 0x181e, 0x2442, 0x3c0c, 0x0c54,
 0x0230, 0x1a1e, 0x2642, 0x3e0c, 0x0e54,
 0x0430, 0x1c1e, 0x2842, 0x400c, 0x1054,
 0x0432, 0x1c20, 0x2844, 0x400e, 0x1056,
 0x0232, 0x1a20, 0x2644, 0x3e0e, 0x0e56,
 0x0032, 0x1820, 0x2444, 0x3c0e, 0x0c56,
 0x0034, 0x1822, 0x2446, 0x3c10, 0x0c58,
 0x0234, 0x1a22, 0x2646, 0x3e10, 0x0e58,
 0x0434, 0x1c22, 0x2846, 0x4010, 0x1058,
 0x0624, 0x1e12, 0x2a36, 0x4200, 0x1248,
 0x0824, 0x2012, 0x2c36, 0x4400, 0x1448,
 0x0a24, 0x2212, 0x2e36, 0x4600, 0x1648,
 0x0a26, 0x2214, 0x2e38, 0x4602, 0x164a,
 0x0826, 0x2014, 0x2c38, 0x4402, 0x144a,
 0x0626, 0x1e14, 0x2a38, 0x4202, 0x124a,
 0x0628, 0x1e16, 0x2a3a, 0x4204, 0x124c,
 0x0828, 0x2016, 0x2c3a, 0x4404, 0x144c,
 0x0a28, 0x2216, 0x2e3a, 0x4604, 0x164c,
 0x0a2a, 0x2218, 0x2e3c, 0x4606, 0x164e,
 0x082a, 0x2018, 0x2c3c, 0x4406, 0x144e,
 0x062a, 0x1e18, 0x2a3c, 0x4206, 0x124e,
 0x062c, 0x1e1a, 0x2a3e, 0x4208, 0x1250,
 0x082c, 0x201a, 0x2c3e, 0x4408, 0x1450,
 0x0a2c, 0x221a, 0x2e3e, 0x4608, 0x1650,
 0x0a2e, 0x221c, 0x2e40, 0x460a, 0x1652,
 0x082e, 0x201c, 0x2c40, 0x440a, 0x1452,
 0x062e, 0x1e1c, 0x2a40, 0x420a, 0x1252,
 0x0630, 0x1e1e, 0x2a42, 0x420c, 0x1254,
 0x0830, 0x201e, 0x2c42, 0x440c, 0x1454,
 0x0a30, 0x221e, 0x2e42, 0x460c, 0x1654,
 0x0a32, 0x2220, 0x2e44, 0x460e, 0x1656,
 0x0832, 0x2020, 0x2c44, 0x440e, 0x1456,
 0x0632, 0x1e20, 0x2a44, 0x420e, 0x1256,
 0x0634, 0x1e22, 0x2a46, 0x4210, 0x1258,
 0x0834, 0x2022, 0x2c46, 0x4410, 0x1458,
 0x0a34, 0x2222, 0x2e46, 0x4610, 0x1658,

################################################################################

TITLE
    libavcodec DV dv_place_411P

TYPE
    16

DATA
 0x0c24, 0x2710, 0x3334, 0x0000, 0x1848,
 0x0d24, 0x2810, 0x3434, 0x0100, 0x1948,
 0x0e24, 0x2910, 0x3534, 0x0200, 0x1a48,
 0x0f24, 0x2914, 0x3538, 0x0300, 0x1b48,
 0x1024, 0x2814, 0x3438, 0x0400, 0x1c48,
 0x1124, 0x2714, 0x3338, 0x0500, 0x1d48,
 0x1128, 0x2614, 0x3238, 0x0504, 0x1d4c,
 0x1028, 0x2514, 0x3138, 0x0404, 0x1c4c,
 0x0f28, 0x2414, 0x3038, 0x0304, 0x1b4c,
 0x0e28, 0x2418, 0x303c, 0x0204, 0x1a4c,
 0x0d28, 0x2518, 0x313c, 0x0104, 0x194c,
 0x0c28, 0x2618, 0x323c, 0x0004, 0x184c,
 0x0c2c, 0x2718, 0x333c, 0x0008, 0x1850,
 0x0d2c, 0x2818, 0x343c, 0x0108, 0x1950,
 0x0e2c, 0x2918, 0x353c, 0x0208, 0x1a50,
 0x0f2c, 0x291c, 0x3540, 0x0308, 0x1b50,
 0x102c, 0x281c, 0x3440, 0x0408, 0x1c50,
 0x112c, 0x271c, 0x3340, 0x0508, 0x1d50,
 0x1130, 0x261c, 0x3240, 0x050c, 0x1d54,
 0x1030, 0x251c, 0x3140, 0x040c, 0x1c54,
 0x0f30, 0x241c, 0x3040, 0x030c, 0x1b54,
 0x0e30, 0x2420, 0x3044, 0x020c, 0x1a54,
 0x0d30, 0x2520, 0x3144, 0x010c, 0x1954,
 0x0c30, 0x2620, 0x3244, 0x000c, 0x1854,
 0x0c34, 0x2720, 0x3344, 0x0010, 0x1858,
 0x0d34, 0x2820, 0x3444, 0x0110, 0x1a58,
 0x0e34, 0x2920, 0x3544, 0x0210, 0x1c58,
 0x1224, 0x2d10, 0x3934, 0x0600, 0x1e48,
 0x1324, 0x2e10, 0x3a34, 0x0700, 0x1f48,
 0x1424, 0x2f10, 0x3b34, 0x0800, 0x2048,
 0x1524, 0x2f14, 0x3b38, 0x0900, 0x2148,
 0x1624, 0x2e14, 0x3a38, 0x0a00, 0x2248,
 0x1724, 0x2d14, 0x3938, 0x0b00, 0x2348,
 0x1728, 0x2c14, 0x3838, 0x0b04, 0x234c,
 0x1628, 0x2b14, 0x3738, 0x0a04, 0x224c,
 0x1528, 0x2a14, 0x3638, 0x0904, 0x214c,
 0x1428, 0x2a18, 0x363c, 0x0804, 0x204c,
 0x1328, 0x2b18, 0x373c, 0x0704, 0x1f4c,
 0x1228, 0x2c18, 0x383c, 0x0604, 0x1e4c,
 0x122c, 0x2d18, 0x393c, 0x0608, 0x1e50,
 0x132c, 0x2e18, 0x3a3c, 0x0708, 0x1f50,
 0x142c, 0x2f18, 0x3b3c, 0x0808, 0x2050,
 0x152c, 0x2f1c, 0x3b40, 0x0908, 0x2150,
 0x162c, 0x2e1c, 0x3a40, 0x0a08, 0x2250,
 0x172c, 0x2d1c, 0x3940, 0x0b08, 0x2350,
 0x1730, 0x2c1c, 0x3840, 0x0b0c, 0x2354,
 0x1630, 0x2b1c, 0x3740, 0x0a0c, 0x2254,
 0x1530, 0x2a1c, 0x3640, 0x090c, 0x2154,
 0x1430, 0x2a20, 0x3644, 0x080c, 0x2054,
 0x1330, 0x2b20, 0x3744, 0x070c, 0x1f54,
 0x1230, 0x2c20, 0x3844, 0x060c, 0x1e54,
 0x1234, 0x2d20, 0x3944, 0x0610, 0x1e58,
 0x1334, 0x2e20, 0x3a44, 0x0710, 0x2058,
 0x1434, 0x2f20, 0x3b44, 0x0810, 0x2258,
 0x1824, 0x3310, 0x3f34, 0x0c00, 0x2448,
 0x1924, 0x3410, 0x4034, 0x0d00, 0x2548,
 0x1a24, 0x3510, 0x4134, 0x0e00, 0x2648,
 0x1b24, 0x3514, 0x4138, 0x0f00, 0x2748,
 0x1c24, 0x3414, 0x4038, 0x1000, 0x2848,
 0x1d24, 0x3314, 0x3f38, 0x1100, 0x2948,
 0x1d28, 0x3214, 0x3e38, 0x1104, 0x294c,
 0x1c28, 0x3114, 0x3d38, 0x1004, 0x284c,
 0x1b28, 0x3014, 0x3c38, 0x0f04, 0x274c,
 0x1a28, 0x3018, 0x3c3c, 0x0e04, 0x264c,
 0x1928, 0x3118, 0x3d3c, 0x0d04, 0x254c,
 0x1828, 0x3218, 0x3e3c, 0x0c04, 0x244c,
 0x182c, 0x3318, 0x3f3c, 0x0c08, 0x2450,
 0x192c, 0x3418, 0x403c, 0x0d08, 0x2550,
 0x1a2c, 0x3518, 0x413c, 0x0e08, 0x2650,
 0x1b2c, 0x351c, 0x4140, 0x0f08, 0x2750,
 0x1c2c, 0x341c, 0x4040, 0x1008, 0x2850,
 0x1d2c, 0x331c, 0x3f40, 0x1108, 0x2950,
 0x1d30, 0x321c, 0x3e40, 0x110c, 0x2954,
 0x1c30, 0x311c, 0x3d40, 0x100c, 0x2854,
 0x1b30, 0x301c, 0x3c40, 0x0f0c, 0x2754,
 0x1a30, 0x3020, 0x3c44, 0x0e0c, 0x2654,
 0x1930, 0x3120, 0x3d44, 0x0d0c, 0x2554,
 0x1830, 0x3220, 0x3e44, 0x0c0c, 0x2454,
 0x1834, 0x3320, 0x3f44, 0x0c10, 0x2458,
 0x1934, 0x3420, 0x4044, 0x0d10, 0x2658,
 0x1a34, 0x3520, 0x4144, 0x0e10, 0x2858,
 0x1e24, 0x3910, 0x4534, 0x1200, 0x2a48,
 0x1f24, 0x3a10, 0x4634, 0x1300, 0x2b48,
 0x2024, 0x3b10, 0x4734, 0x1400, 0x2c48,
 0x2124, 0x3b14, 0x4738, 0x1500, 0x2d48,
 0x2224, 0x3a14, 0x4638, 0x1600, 0x2e48,
 0x2324, 0x3914, 0x4538, 0x1700, 0x2f48,
 0x2328, 0x3814, 0x4438, 0x1704, 0x2f4c,
 0x2228, 0x3714, 0x4338, 0x1604, 0x2e4c,
 0x2128, 0x3614, 0x4238, 0x1504, 0x2d4c,
 0x2028, 0x3618, 0x423c, 0x1404, 0x2c4c,
 0x1f28, 0x3718, 0x433c, 0x1304, 0x2b4c,
 0x1e28, 0x3818, 0x443c, 0x1204, 0x2a4c,
 0x1e2c, 0x3918, 0x453c, 0x1208, 0x2a50,
 0x1f2c, 0x3a18, 0x463c, 0x1308, 0x2b50,
 0x202c, 0x3b18, 0x473c, 0x1408, 0x2c50,
 0x212c, 0x3b1c, 0x4740, 0x1508, 0x2d50,
 0x222c, 0x3a1c, 0x4640, 0x1608, 0x2e50,
 0x232c, 0x391c, 0x4540, 0x1708, 0x2f50,
 0x2330, 0x381c, 0x4440, 0x170c, 0x2f54,
 0x2230, 0x371c, 0x4340, 0x160c, 0x2e54,
 0x2130, 0x361c, 0x4240, 0x150c, 0x2d54,
 0x2030, 0x3620, 0x4244, 0x140c, 0x2c54,
 0x1f30, 0x3720, 0x4344, 0x130c, 0x2b54,
 0x1e30, 0x3820, 0x4444, 0x120c, 0x2a54,
 0x1e34, 0x3920, 0x4544, 0x1210, 0x2a58,
 0x1f34, 0x3a20, 0x4644, 0x1310, 0x2c58,
 0x2034, 0x3b20, 0x4744, 0x1410, 0x2e58,
 0x2424, 0x3f10, 0x0334, 0x1800, 0x3048,
 0x2524, 0x4010, 0x0434, 0x1900, 0x3148,
 0x2624, 0x4110, 0x0534, 0x1a00, 0x3248,
 0x2724, 0x4114, 0x0538, 0x1b00, 0x3348,
 0x2824, 0x4014, 0x0438, 0x1c00, 0x3448,
 0x2924, 0x3f14, 0x0338, 0x1d00, 0x3548,
 0x2928, 0x3e14, 0x0238, 0x1d04, 0x354c,
 0x2828, 0x3d14, 0x0138, 0x1c04, 0x344c,
 0x2728, 0x3c14, 0x0038, 0x1b04, 0x334c,
 0x2628, 0x3c18, 0x003c, 0x1a04, 0x324c,
 0x2528, 0x3d18, 0x013c, 0x1904, 0x314c,
 0x2428, 0x3e18, 0x023c, 0x1804, 0x304c,
 0x242c, 0x3f18, 0x033c, 0x1808, 0x3050,
 0x252c, 0x4018, 0x043c, 0x1908, 0x3150,
 0x262c, 0x4118, 0x053c, 0x1a08, 0x3250,
 0x272c, 0x411c, 0x0540, 0x1b08, 0x3350,
 0x282c, 0x401c, 0x0440, 0x1c08, 0x3450,
 0x292c, 0x3f1c, 0x0340, 0x1d08, 0x3550,
 0x2930, 0x3e1c, 0x0240, 0x1d0c, 0x3554,
 0x2830, 0x3d1c, 0x0140, 0x1c0c, 0x3454,
 0x2730, 0x3c1c, 0x0040, 0x1b0c, 0x3354,
 0x2630, 0x3c20, 0x0044, 0x1a0c, 0x3254,
 0x2530, 0x3d20, 0x0144, 0x190c, 0x3154,
 0x2430, 0x3e20, 0x0244, 0x180c, 0x3054,
 0x2434, 0x3f20, 0x0344, 0x1810, 0x3058,
 0x2534, 0x4020, 0x0444, 0x1910, 0x3258,
 0x2634, 0x4120, 0x0544, 0x1a10, 0x3458,
 0x2a24, 0x4510, 0x0934, 0x1e00, 0x3648,
 0x2b24, 0x4610, 0x0a34, 0x1f00, 0x3748,
 0x2c24, 0x4710, 0x0b34, 0x2000, 0x3848,
 0x2d24, 0x4714, 0x0b38, 0x2100, 0x3948,
 0x2e24, 0x4614, 0x0a38, 0x2200, 0x3a48,
 0x2f24, 0x4514, 0x0938, 0x2300, 0x3b48,
 0x2f28, 0x4414, 0x0838, 0x2304, 0x3b4c,
 0x2e28, 0x4314, 0x0738, 0x2204, 0x3a4c,
 0x2d28, 0x4214, 0x0638, 0x2104, 0x394c,
 0x2c28, 0x4218, 0x063c, 0x2004, 0x384c,
 0x2b28, 0x4318, 0x073c, 0x1f04, 0x374c,
 0x2a28, 0x4418, 0x083c, 0x1e04, 0x364c,
 0x2a2c, 0x4518, 0x093c, 0x1e08, 0x3650,
 0x2b2c, 0x4618, 0x0a3c, 0x1f08, 0x3750,
 0x2c2c, 0x4718, 0x0b3c, 0x2008, 0x3850,
 0x2d2c, 0x471c, 0x0b40, 0x2108, 0x3950,
 0x2e2c, 0x461c, 0x0a40, 0x2208, 0x3a50,
 0x2f2c, 0x451c, 0x0940, 0x2308, 0x3b50,
 0x2f30, 0x441c, 0x0840, 0x230c, 0x3b54,
 0x2e30, 0x431c, 0x0740, 0x220c, 0x3a54,
 0x2d30, 0x421c, 0x0640, 0x210c, 0x3954,
 0x2c30, 0x4220, 0x0644, 0x200c, 0x3854,
 0x2b30, 0x4320, 0x0744, 0x1f0c, 0x3754,
 0x2a30, 0x4420, 0x0844, 0x1e0c, 0x3654,
 0x2a34, 0x4520, 0x0944, 0x1e10, 0x3658,
 0x2b34, 0x4620, 0x0a44, 0x1f10, 0x3858,
 0x2c34, 0x4720, 0x0b44, 0x2010, 0x3a58,
 0x3024, 0x0310, 0x0f34, 0x2400, 0x3c48,
 0x3124, 0x0410, 0x1034, 0x2500, 0x3d48,
 0x3224, 0x0510, 0x1134, 0x2600, 0x3e48,
 0x3324, 0x0514, 0x1138, 0x2700, 0x3f48,
 0x3424, 0x0414, 0x1038, 0x2800, 0x4048,
 0x3524, 0x0314, 0x0f38, 0x2900, 0x4148,
 0x3528, 0x0214, 0x0e38, 0x2904, 0x414c,
 0x3428, 0x0114, 0x0d38, 0x2804, 0x404c,
 0x3328, 0x0014, 0x0c38, 0x2704, 0x3f4c,
 0x3228, 0x0018, 0x0c3c, 0x2604, 0x3e4c,
 0x3128, 0x0118, 0x0d3c, 0x2504, 0x3d4c,
 0x3028, 0x0218, 0x0e3c, 0x2404, 0x3c4c,
 0x302c, 0x0318, 0x0f3c, 0x2408, 0x3c50,
 0x312c, 0x0418, 0x103c, 0x2508, 0x3d50,
 0x322c, 0x0518, 0x113c, 0x2608, 0x3e50,
 0x332c, 0x051c, 0x1140, 0x2708, 0x3f50,
 0x342c, 0x041c, 0x1040, 0x2808, 0x4050,
 0x352c, 0x031c, 0x0f40, 0x2908, 0x4150,
 0x3530, 0x021c, 0x0e40, 0x290c, 0x4154,
 0x3430, 0x011c, 0x0d40, 0x280c, 0x4054,
 0x3330, 0x001c, 0x0c40, 0x270c, 0x3f54,
 0x3230, 0x0020, 0x0c44, 0x260c, 0x3e54,
 0x3130, 0x0120, 0x0d44, 0x250c, 0x3d54,
 0x3030, 0x0220, 0x0e44, 0x240c, 0x3c54,
 0x3034, 0x0320, 0x0f44, 0x2410, 0x3c58,
 0x3134, 0x0420, 0x1044, 0x2510, 0x3e58,
 0x3234, 0x0520, 0x1144, 0x2610, 0x4058,
 0x3624, 0x0910, 0x1534, 0x2a00, 0x4248,
 0x3724, 0x0a10, 0x1634, 0x2b00, 0x4348,
 0x3824, 0x0b10, 0x1734, 0x2c00, 0x4448,
 0x3924, 0x0b14, 0x1738, 0x2d00, 0x4548,
 0x3a24, 0x0a14, 0x1638, 0x2e00, 0x4648,
 0x3b24, 0x0914, 0x1538, 0x2f00, 0x4748,
 0x3b28, 0x0814, 0x1438, 0x2f04, 0x474c,
 0x3a28, 0x0714, 0x1338, 0x2e04, 0x464c,
 0x3928, 0x0614, 0x1238, 0x2d04, 0x454c,
 0x3828, 0x0618, 0x123c, 0x2c04, 0x444c,
 0x3728, 0x0718, 0x133c, 0x2b04, 0x434c,
 0x3628, 0x0818, 0x143c, 0x2a04, 0x424c,
 0x362c, 0x0918, 0x153c, 0x2a08, 0x4250,
 0x372c, 0x0a18, 0x163c, 0x2b08, 0x4350,
 0x382c, 0x0b18, 0x173c, 0x2c08, 0x4450,
 0x392c, 0x0b1c, 0x1740, 0x2d08, 0x4550,
 0x3a2c, 0x0a1c, 0x1640, 0x2e08, 0x4650,
 0x3b2c, 0x091c, 0x1540, 0x2f08, 0x4750,
 0x3b30, 0x081c, 0x1440, 0x2f0c, 0x4754,
 0x3a30, 0x071c, 0x1340, 0x2e0c, 0x4654,
 0x3930, 0x061c, 0x1240, 0x2d0c, 0x4554,
 0x3830, 0x0620, 0x1244, 0x2c0c, 0x4454,
 0x3730, 0x0720, 0x1344, 0x2b0c, 0x4354,
 0x3630, 0x0820, 0x1444, 0x2a0c, 0x4254,
 0x3634, 0x0920, 0x1544, 0x2a10, 0x4258,
 0x3734, 0x0a20, 0x1644, 0x2b10, 0x4458,
 0x3834, 0x0b20, 0x1744, 0x2c10, 0x4658,
 0x3c24, 0x0f10, 0x1b34, 0x3000, 0x0048,
 0x3d24, 0x1010, 0x1c34, 0x3100, 0x0148,
 0x3e24, 0x1110, 0x1d34, 0x3200, 0x0248,
 0x3f24, 0x1114, 0x1d38, 0x3300, 0x0348,
 0x4024, 0x1014, 0x1c38, 0x3400, 0x0448,
 0x4124, 0x0f14, 0x1b38, 0x3500, 0x0548,
 0x4128, 0x0e14, 0x1a38, 0x3504, 0x054c,
 0x4028, 0x0d14, 0x1938, 0x3404, 0x044c,
 0x3f28, 0x0c14, 0x1838, 0x3304, 0x034c,
 0x3e28, 0x0c18, 0x183c, 0x3204, 0x024c,
 0x3d28, 0x0d18, 0x193c, 0x3104, 0x014c,
 0x3c28, 0x0e18, 0x1a3c, 0x3004, 0x004c,
 0x3c2c, 0x0f18, 0x1b3c, 0x3008, 0x0050,
 0x3d2c, 0x1018, 0x1c3c, 0x3108, 0x0150,
 0x3e2c, 0x1118, 0x1d3c, 0x3208, 0x0250,
 0x3f2c, 0x111c, 0x1d40, 0x3308, 0x0350,
 0x402c, 0x101c, 0x1c40, 0x3408, 0x0450,
 0x412c, 0x0f1c, 0x1b40, 0x3508, 0x0550,
 0x4130, 0x0e1c, 0x1a40, 0x350c, 0x0554,
 0x4030, 0x0d1c, 0x1940, 0x340c, 0x0454,
 0x3f30, 0x0c1c, 0x1840, 0x330c, 0x0354,
 0x3e30, 0x0c20, 0x1844, 0x320c, 0x0254,
 0x3d30, 0x0d20, 0x1944, 0x310c, 0x0154,
 0x3c30, 0x0e20, 0x1a44, 0x300c, 0x0054,
 0x3c34, 0x0f20, 0x1b44, 0x3010, 0x0058,
 0x3d34, 0x1020, 0x1c44, 0x3110, 0x0258,
 0x3e34, 0x1120, 0x1d44, 0x3210, 0x0458,
 0x4224, 0x1510, 0x2134, 0x3600, 0x0648,
 0x4324, 0x1610, 0x2234, 0x3700, 0x0748,
 0x4424, 0x1710, 0x2334, 0x3800, 0x0848,
 0x4524, 0x1714, 0x2338, 0x3900, 0x0948,
 0x4624, 0x1614, 0x2238, 0x3a00, 0x0a48,
 0x4724, 0x1514, 0x2138, 0x3b00, 0x0b48,
 0x4728, 0x1414, 0x2038, 0x3b04, 0x0b4c,
 0x4628, 0x1314, 0x1f38, 0x3a04, 0x0a4c,
 0x4528, 0x1214, 0x1e38, 0x3904, 0x094c,
 0x4428, 0x1218, 0x1e3c, 0x3804, 0x084c,
 0x4328, 0x1318, 0x1f3c, 0x3704, 0x074c,
 0x4228, 0x1418, 0x203c, 0x3604, 0x064c,
 0x422c, 0x1518, 0x213c, 0x3608, 0x0650,
 0x432c, 0x1618, 0x223c, 0x3708, 0x0750,
 0x442c, 0x1718, 0x233c, 0x3808, 0x0850,
 0x452c, 0x171c, 0x2340, 0x3908, 0x0950,
 0x462c, 0x161c, 0x2240, 0x3a08, 0x0a50,
 0x472c, 0x151c, 0x2140, 0x3b08, 0x0b50,
 0x4730, 0x141c, 0x2040, 0x3b0c, 0x0b54,
 0x4630, 0x131c, 0x1f40, 0x3a0c, 0x0a54,
 0x4530, 0x121c, 0x1e40, 0x390c, 0x0954,
 0x4430, 0x1220, 0x1e44, 0x380c, 0x0854,
 0x4330, 0x1320, 0x1f44, 0x370c, 0x0754,
 0x4230, 0x1420, 0x2044, 0x360c, 0x0654,
 0x4234, 0x1520, 0x2144, 0x3610, 0x0658,
 0x4334, 0x1620, 0x2244, 0x3710, 0x0858,
 0x4434, 0x1720, 0x2344, 0x3810, 0x0a58,
 0x0024, 0x1b10, 0x2734, 0x3c00, 0x0c48,
 0x0124, 0x1c10, 0x2834, 0x3d00, 0x0d48,
 0x0224, 0x1d10, 0x2934, 0x3e00, 0x0e48,
 0x0324, 0x1d14, 0x2938, 0x3f00, 0x0f48,
 0x0424, 0x1c14, 0x2838, 0x4000, 0x1048,
 0x0524, 0x1b14, 0x2738, 0x4100, 0x1148,
 0x0528, 0x1a14, 0x2638, 0x4104, 0x114c,
 0x0428, 0x1914, 0x2538, 0x4004, 0x104c,
 0x0328, 0x1814, 0x2438, 0x3f04, 0x0f4c,
 0x0228, 0x1818, 0x243c, 0x3e04, 0x0e4c,
 0x0128, 0x1918, 0x253c, 0x3d04, 0x0d4c,
 0x0028, 0x1a18, 0x263c, 0x3c04, 0x0c4c,
 0x002c, 0x1b18, 0x273c, 0x3c08, 0x0c50,
 0x012c, 0x1c18, 0x283c, 0x3d08, 0x0d50,
 0x022c, 0x1d18, 0x293c, 0x3e08, 0x0e50,
 0x032c, 0x1d1c, 0x2940, 0x3f08, 0x0f50,
 0x042c, 0x1c1c, 0x2840, 0x4008, 0x1050,
 0x052c, 0x1b1c, 0x2740, 0x4108, 0x1150,
 0x0530, 0x1a1c, 0x2640, 0x410c, 0x1154,
 0x0430, 0x191c, 0x2540, 0x400c, 0x1054,
 0x0330, 0x181c, 0x2440, 0x3f0c, 0x0f54,
 0x0230, 0x1820, 0x2444, 0x3e0c, 0x0e54,
 0x0130, 0x1920, 0x2544, 0x3d0c, 0x0d54,
 0x0030, 0x1a20, 0x2644, 0x3c0c, 0x0c54,
 0x0034, 0x1b20, 0x2744, 0x3c10, 0x0c58,
 0x0134, 0x1c20, 0x2844, 0x3d10, 0x0e58,
 0x0234, 0x1d20, 0x2944, 0x3e10, 0x1058,
 0x0624, 0x2110, 0x2d34, 0x4200, 0x1248,
 0x0724, 0x2210, 0x2e34, 0x4300, 0x1348,
 0x0824, 0x2310, 0x2f34, 0x4400, 0x1448,
 0x0924, 0x2314, 0x2f38, 0x4500, 0x1548,
 0x0a24, 0x2214, 0x2e38, 0x4600, 0x1648,
 0x0b24, 0x2114, 0x2d38, 0x4700, 0x1748,
 0x0b28, 0x2014, 0x2c38, 0x4704, 0x174c,
 0x0a28, 0x1f14, 0x2b38, 0x4604, 0x164c,
 0x0928, 0x1e14, 0x2a38, 0x4504, 0x154c,
 0x0828, 0x1e18, 0x2a3c, 0x4404, 0x144c,
 0x0728, 0x1f18, 0x2b3c, 0x4304, 0x134c,
 0x0628, 0x2018, 0x2c3c, 0x4204, 0x124c,
 0x062c, 0x2118, 0x2d3c, 0x4208, 0x1250,
 0x072c, 0x2218, 0x2e3c, 0x4308, 0x1350,
 0x082c, 0x2318, 0x2f3c, 0x4408, 0x1450,
 0x092c, 0x231c, 0x2f40, 0x4508, 0x1550,
 0x0a2c, 0x221c, 0x2e40, 0x4608, 0x1650,
 0x0b2c, 0x211c, 0x2d40, 0x4708, 0x1750,
 0x0b30, 0x201c, 0x2c40, 0x470c, 0x1754,
 0x0a30, 0x1f1c, 0x2b40, 0x460c, 0x1654,
 0x0930, 0x1e1c, 0x2a40, 0x450c, 0x1554,
 0x0830, 0x1e20, 0x2a44, 0x440c, 0x1454,
 0x0730, 0x1f20, 0x2b44, 0x430c, 0x1354,
 0x0630, 0x2020, 0x2c44, 0x420c, 0x1254,
 0x0634, 0x2120, 0x2d44, 0x4210, 0x1258,
 0x0734, 0x2220, 0x2e44, 0x4310, 0x1458,
 0x0834, 0x2320, 0x2f44, 0x4410, 0x1658,

################################################################################

TITLE
    libavcodec DV dv_place_411

TYPE
    16

DATA
 0x0c24, 0x2710, 0x3334, 0x0000, 0x1848,
 0x0d24, 0x2810, 0x3434, 0x0100, 0x1948,
 0x0e24, 0x2910, 0x3534, 0x0200, 0x1a48,
 0x0f24, 0x2914, 0x3538, 0x0300, 0x1b48,
 0x1024, 0x2814, 0x3438, 0x0400, 0x1c48,
 0x1124, 0x2714, 0x3338, 0x0500, 0x1d48,
 0x1128, 0x2614, 0x3238, 0x0504, 0x1d4c,
 0x1028, 0x2514, 0x3138, 0x0404, 0x1c4c,
 0x0f28, 0x2414, 0x3038, 0x0304, 0x1b4c,
 0x0e28, 0x2418, 0x303c, 0x0204, 0x1a4c,
 0x0d28, 0x2518, 0x313c, 0x0104, 0x194c,
 0x0c28, 0x2618, 0x323c, 0x0004, 0x184c,
 0x0c2c, 0x2718, 0x333c, 0x0008, 0x1850,
 0x0d2c, 0x2818, 0x343c, 0x0108, 0x1950,
 0x0e2c, 0x2918, 0x353c, 0x0208, 0x1a50,
 0x0f2c, 0x291c, 0x3540, 0x0308, 0x1b50,
 0x102c, 0x281c, 0x3440, 0x0408, 0x1c50,
 0x112c, 0x271c, 0x3340, 0x0508, 0x1d50,
 0x1130, 0x261c, 0x3240, 0x050c, 0x1d54,
 0x1030, 0x251c, 0x3140, 0x040c, 0x1c54,
 0x0f30, 0x241c, 0x3040, 0x030c, 0x1b54,
 0x0e30, 0x2420, 0x3044, 0x020c, 0x1a54,
 0x0d30, 0x2520, 0x3144, 0x010c, 0x1954,
 0x0c30, 0x2620, 0x3244, 0x000c, 0x1854,
 0x0c34, 0x2720, 0x3344, 0x0010, 0x1858,
 0x0d34, 0x2820, 0x3444, 0x0110, 0x1a58,
 0x0e34, 0x2920, 0x3544, 0x0210, 0x1c58,
 0x1224, 0x2d10, 0x3934, 0x0600, 0x1e48,
 0x1324, 0x2e10, 0x3a34, 0x0700, 0x1f48,
 0x1424, 0x2f10, 0x3b34, 0x0800, 0x2048,
 0x1524, 0x2f14, 0x3b38, 0x0900, 0x2148,
 0x1624, 0x2e14, 0x3a38, 0x0a00, 0x2248,
 0x1724, 0x2d14, 0x3938, 0x0b00, 0x2348,
 0x1728, 0x2c14, 0x3838, 0x0b04, 0x234c,
 0x1628, 0x2b14, 0x3738, 0x0a04, 0x224c,
 0x1528, 0x2a14, 0x3638, 0x0904, 0x214c,
 0x1428, 0x2a18, 0x363c, 0x0804, 0x204c,
 0x1328, 0x2b18, 0x373c, 0x0704, 0x1f4c,
 0x1228, 0x2c18, 0x383c, 0x0604, 0x1e4c,
 0x122c, 0x2d18, 0x393c, 0x0608, 0x1e50,
 0x132c, 0x2e18, 0x3a3c, 0x0708, 0x1f50,
 0x142c, 0x2f18, 0x3b3c, 0x0808, 0x2050,
 0x152c, 0x2f1c, 0x3b40, 0x0908, 0x2150,
 0x162c, 0x2e1c, 0x3a40, 0x0a08, 0x2250,
 0x172c, 0x2d1c, 0x3940, 0x0b08, 0x2350,
 0x1730, 0x2c1c, 0x3840, 0x0b0c, 0x2354,
 0x1630, 0x2b1c, 0x3740, 0x0a0c, 0x2254,
 0x1530, 0x2a1c, 0x3640, 0x090c, 0x2154,
 0x1430, 0x2a20, 0x3644, 0x080c, 0x2054,
 0x1330, 0x2b20, 0x3744, 0x070c, 0x1f54,
 0x1230, 0x2c20, 0x3844, 0x060c, 0x1e54,
 0x1234, 0x2d20, 0x3944, 0x0610, 0x1e58,
 0x1334, 0x2e20, 0x3a44, 0x0710, 0x2058,
 0x1434, 0x2f20, 0x3b44, 0x0810, 0x2258,
 0x1824, 0x3310, 0x0334, 0x0c00, 0x2448,
 0x1924, 0x3410, 0x0434, 0x0d00, 0x2548,
 0x1a24, 0x3510, 0x0534, 0x0e00, 0x2648,
 0x1b24, 0x3514, 0x0538, 0x0f00, 0x2748,
 0x1c24, 0x3414, 0x0438, 0x1000, 0x2848,
 0x1d24, 0x3314, 0x0338, 0x1100, 0x2948,
 0x1d28, 0x3214, 0x0238, 0x1104, 0x294c,
 0x1c28, 0x3114, 0x0138, 0x1004, 0x284c,
 0x1b28, 0x3014, 0x0038, 0x0f04, 0x274c,
 0x1a28, 0x3018, 0x003c, 0x0e04, 0x264c,
 0x1928, 0x3118, 0x013c, 0x0d04, 0x254c,
 0x1828, 0x3218, 0x023c, 0x0c04, 0x244c,
 0x182c, 0x3318, 0x033c, 0x0c08, 0x2450,
 0x192c, 0x3418, 0x043c, 0x0d08, 0x2550,
 0x1a2c, 0x3518, 0x053c, 0x0e08, 0x2650,
 0x1b2c, 0x351c, 0x0540, 0x0f08, 0x2750,
 0x1c2c, 0x341c, 0x0440, 0x1008, 0x2850,
 0x1d2c, 0x331c, 0x0340, 0x1108, 0x2950,
 0x1d30, 0x321c, 0x0240, 0x110c, 0x2954,
 0x1c30, 0x311c, 0x0140, 0x100c, 0x2854,
 0x1b30, 0x301c, 0x0040, 0x0f0c, 0x2754,
 0x1a30, 0x3020, 0x0044, 0x0e0c, 0x2654,
 0x1930, 0x3120, 0x0144, 0x0d0c, 0x2554,
 0x1830, 0x3220, 0x0244, 0x0c0c, 0x2454,
 0x1834, 0x3320, 0x0344, 0x0c10, 0x2458,
 0x1934, 0x3420, 0x0444, 0x0d10, 0x2658,
 0x1a34, 0x3520, 0x0544, 0x0e10, 0x2858,
 0x1e24, 0x3910, 0x0934, 0x1200, 0x2a48,
 0x1f24, 0x3a10, 0x0a34, 0x1300, 0x2b48,
 0x2024, 0x3b10, 0x0b34, 0x1400, 0x2c48,
 0x2124, 0x3b14, 0x0b38, 0x1500, 0x2d48,
 0x2224, 0x3a14, 0x0a38, 0x1600, 0x2e48,
 0x2324, 0x3914, 0x0938, 0x1700, 0x2f48,
 0x2328, 0x3814, 0x0838, 0x1704, 0x2f4c,
 0x2228, 0x3714, 0x0738, 0x1604, 0x2e4c,
 0x2128, 0x3614, 0x0638, 0x1504, 0x2d4c,
 0x2028, 0x3618, 0x063c, 0x1404, 0x2c4c,
 0x1f28, 0x3718, 0x073c, 0x1304, 0x2b4c,
 0x1e28, 0x3818, 0x083c, 0x1204, 0x2a4c,
 0x1e2c, 0x3918, 0x093c, 0x1208, 0x2a50,
 0x1f2c, 0x3a18, 0x0a3c, 0x1308, 0x2b50,
 0x202c, 0x3b18, 0x0b3c, 0x1408, 0x2c50,
 0x212c, 0x3b1c, 0x0b40, 0x1508, 0x2d50,
 0x222c, 0x3a1c, 0x0a40, 0x1608, 0x2e50,
 0x232c, 0x391c, 0x0940, 0x1708, 0x2f50,
 0x2330, 0x381c, 0x0840, 0x170c, 0x2f54,
 0x2230, 0x371c, 0x0740, 0x160c, 0x2e54,
 0x2130, 0x361c, 0x0640, 0x150c, 0x2d54,
 0x2030, 0x3620, 0x0644, 0x140c, 0x2c54,
 0x1f30, 0x3720, 0x0744, 0x130c, 0x2b54,
 0x1e30, 0x3820, 0x0844, 0x120c, 0x2a54,
 0x1e34, 0x3920, 0x0944, 0x1210, 0x2a58,
 0x1f34, 0x3a20, 0x0a44, 0x1310, 0x2c58,
 0x2034, 0x3b20, 0x0b44, 0x1410, 0x2e58,
 0x2424, 0x0310, 0x0f34, 0x1800, 0x3048,
 0x2524, 0x0410, 0x1034, 0x1900, 0x3148,
 0x2624, 0x0510, 0x1134, 0x1a00, 0x3248,
 0x2724, 0x0514, 0x1138, 0x1b00, 0x3348,
 0x2824, 0x0414, 0x1038, 0x1c00, 0x3448,
 0x2924, 0x0314, 0x0f38, 0x1d00, 0x3548,
 0x2928, 0x0214, 0x0e38, 0x1d04, 0x354c,
 0x2828, 0x0114, 0x0d38, 0x1c04, 0x344c,
 0x2728, 0x0014, 0x0c38, 0x1b04, 0x334c,
 0x2628, 0x0018, 0x0c3c, 0x1a04, 0x324c,
 0x2528, 0x0118, 0x0d3c, 0x1904, 0x314c,
 0x2428, 0x0218, 0x0e3c, 0x1804, 0x304c,
 0x242c, 0x0318, 0x0f3c, 0x1808, 0x3050,
 0x252c, 0x0418, 0x103c, 0x1908, 0x3150,
 0x262c, 0x0518, 0x113c, 0x1a08, 0x3250,
 0x272c, 0x051c, 0x1140, 0x1b08, 0x3350,
 0x282c, 0x041c, 0x1040, 0x1c08, 0x3450,
 0x292c, 0x031c, 0x0f40, 0x1d08, 0x3550,
 0x2930, 0x021c, 0x0e40, 0x1d0c, 0x3554,
 0x2830, 0x011c, 0x0d40, 0x1c0c, 0x3454,
 0x2730, 0x001c, 0x0c40, 0x1b0c, 0x3354,
 0x2630, 0x0020, 0x0c44, 0x1a0c, 0x3254,
 0x2530, 0x0120, 0x0d44, 0x190c, 0x3154,
 0x2430, 0x0220, 0x0e44, 0x180c, 0x3054,
 0x2434, 0x0320, 0x0f44, 0x1810, 0x3058,
 0x2534, 0x0420, 0x1044, 0x1910, 0x3258,
 0x2634, 0x0520, 0x1144, 0x1a10, 0x3458,
 0x2a24, 0x0910, 0x1534, 0x1e00, 0x3648,
 0x2b24, 0x0a10, 0x1634, 0x1f00, 0x3748,
 0x2c24, 0x0b10, 0x1734, 0x2000, 0x3848,
 0x2d24, 0x0b14, 0x1738, 0x2100, 0x3948,
 0x2e24, 0x0a14, 0x1638, 0x2200, 0x3a48,
 0x2f24, 0x0914, 0x1538, 0x2300, 0x3b48,
 0x2f28, 0x0814, 0x1438, 0x2304, 0x3b4c,
 0x2e28, 0x0714, 0x1338, 0x2204, 0x3a4c,
 0x2d28, 0x0614, 0x1238, 0x2104, 0x394c,
 0x2c28, 0x0618, 0x123c, 0x2004, 0x384c,
 0x2b28, 0x0718, 0x133c, 0x1f04, 0x374c,
 0x2a28, 0x0818, 0x143c, 0x1e04, 0x364c,
 0x2a2c, 0x0918, 0x153c, 0x1e08, 0x3650,
 0x2b2c, 0x0a18, 0x163c, 0x1f08, 0x3750,
 0x2c2c, 0x0b18, 0x173c, 0x2008, 0x3850,
 0x2d2c, 0x0b1c, 0x1740, 0x2108, 0x3950,
 0x2e2c, 0x0a1c, 0x1640, 0x2208, 0x3a50,
 0x2f2c, 0x091c, 0x1540, 0x2308, 0x3b50,
 0x2f30, 0x081c, 0x1440, 0x230c, 0x3b54,
 0x2e30, 0x071c, 0x1340, 0x220c, 0x3a54,
 0x2d30, 0x061c, 0x1240, 0x210c, 0x3954,
 0x2c30, 0x0620, 0x1244, 0x200c, 0x3854,
 0x2b30, 0x0720, 0x1344, 0x1f0c, 0x3754,
 0x2a30, 0x0820, 0x1444, 0x1e0c, 0x3654,
 0x2a34, 0x0920, 0x1544, 0x1e10, 0x3658,
 0x2b34, 0x0a20, 0x1644, 0x1f10, 0x3858,
 0x2c34, 0x0b20, 0x1744, 0x2010, 0x3a58,
 0x3024, 0x0f10, 0x1b34, 0x2400, 0x0048,
 0x3124, 0x1010, 0x1c34, 0x2500, 0x0148,
 0x3224, 0x1110, 0x1d34, 0x2600, 0x0248,
 0x3324, 0x1114, 0x1d38, 0x2700, 0x0348,
 0x3424, 0x1014, 0x1c38, 0x2800, 0x0448,
 0x3524, 0x0f14, 0x1b38, 0x2900, 0x0548,
 0x3528, 0x0e14, 0x1a38, 0x2904, 0x054c,
 0x3428, 0x0d14, 0x1938, 0x2804, 0x044c,
 0x3328, 0x0c14, 0x1838, 0x2704, 0x034c,
 0x3228, 0x0c18, 0x183c, 0x2604, 0x024c,
 0x3128, 0x0d18, 0x193c, 0x2504, 0x014c,
 0x3028, 0x0e18, 0x1a3c, 0x2404, 0x004c,
 0x302c, 0x0f18, 0x1b3c, 0x2408, 0x0050,
 0x312c, 0x1018, 0x1c3c, 0x2508, 0x0150,
 0x322c, 0x1118, 0x1d3c, 0x2608, 0x0250,
 0x332c, 0x111c, 0x1d40, 0x2708, 0x0350,
 0x342c, 0x101c, 0x1c40, 0x2808, 0x0450,
 0x352c, 0x0f1c, 0x1b40, 0x2908, 0x0550,
 0x3530, 0x0e1c, 0x1a40, 0x290c, 0x0554,
 0x3430, 0x0d1c, 0x1940, 0x280c, 0x0454,
 0x3330, 0x0c1c, 0x1840, 0x270c, 0x0354,
 0x3230, 0x0c20, 0x1844, 0x260c, 0x0254,
 0x3130, 0x0d20, 0x1944, 0x250c, 0x0154,
 0x3030, 0x0e20, 0x1a44, 0x240c, 0x0054,
 0x3034, 0x0f20, 0x1b44, 0x2410, 0x0058,
 0x3134, 0x1020, 0x1c44, 0x2510, 0x0258,
 0x3234, 0x1120, 0x1d44, 0x2610, 0x0458,
 0x3624, 0x1510, 0x2134, 0x2a00, 0x0648,
 0x3724, 0x1610, 0x2234, 0x2b00, 0x0748,
 0x3824, 0x1710, 0x2334, 0x2c00, 0x0848,
 0x3924, 0x1714, 0x2338, 0x2d00, 0x0948,
 0x3a24, 0x1614, 0x2238, 0x2e00, 0x0a48,
 0x3b24, 0x1514, 0x2138, 0x2f00, 0x0b48,
 0x3b28, 0x1414, 0x2038, 0x2f04, 0x0b4c,
 0x3a28, 0x1314, 0x1f38, 0x2e04, 0x0a4c,
 0x3928, 0x1214, 0x1e38, 0x2d04, 0x094c,
 0x3828, 0x1218, 0x1e3c, 0x2c04, 0x084c,
 0x3728, 0x1318, 0x1f3c, 0x2b04, 0x074c,
 0x3628, 0x1418, 0x203c, 0x2a04, 0x064c,
 0x362c, 0x1518, 0x213c, 0x2a08, 0x0650,
 0x372c, 0x1618, 0x223c, 0x2b08, 0x0750,
 0x382c, 0x1718, 0x233c, 0x2c08, 0x0850,
 0x392c, 0x171c, 0x2340, 0x2d08, 0x0950,
 0x3a2c, 0x161c, 0x2240, 0x2e08, 0x0a50,
 0x3b2c, 0x151c, 0x2140, 0x2f08, 0x0b50,
 0x3b30, 0x141c, 0x2040, 0x2f0c, 0x0b54,
 0x3a30, 0x131c, 0x1f40, 0x2e0c, 0x0a54,
 0x3930, 0x121c, 0x1e40, 0x2d0c, 0x0954,
 0x3830, 0x1220, 0x1e44, 0x2c0c, 0x0854,
 0x3730, 0x1320, 0x1f44, 0x2b0c, 0x0754,
 0x3630, 0x1420, 0x2044, 0x2a0c, 0x0654,
 0x3634, 0x1520, 0x2144, 0x2a10, 0x0658,
 0x3734, 0x1620, 0x2244, 0x2b10, 0x0858,
 0x3834, 0x1720, 0x2344, 0x2c10, 0x0a58,
 0x0024, 0x1b10, 0x2734, 0x3000, 0x0c48,
 0x0124, 0x1c10, 0x2834, 0x3100, 0x0d48,
 0x0224, 0x1d10, 0x2934, 0x3200, 0x0e48,
 0x0324, 0x1d14, 0x2938, 0x3300, 0x0f48,
 0x0424, 0x1c14, 0x2838, 0x3400, 0x1048,
 0x0524, 0x1b14, 0x2738, 0x3500, 0x1148,
 0x0528, 0x1a14, 0x2638, 0x3504, 0x114c,
 0x0428, 0x1914, 0x2538, 0x3404, 0x104c,
 0x0328, 0x1814, 0x2438, 0x3304, 0x0f4c,
 0x0228, 0x1818, 0x243c, 0x3204, 0x0e4c,
 0x0128, 0x1918, 0x253c, 0x3104, 0x0d4c,
 0x0028, 0x1a18, 0x263c, 0x3004, 0x0c4c,
 0x002c, 0x1b18, 0x273c, 0x3008, 0x0c50,
 0x012c, 0x1c18, 0x283c, 0x3108, 0x0d50,
 0x022c, 0x1d18, 0x293c, 0x3208, 0x0e50,
 0x032c, 0x1d1c, 0x2940, 0x3308, 0x0f50,
 0x042c, 0x1c1c, 0x2840, 0x3408, 0x1050,
 0x052c, 0x1b1c, 0x2740, 0x3508, 0x1150,
 0x0530, 0x1a1c, 0x2640, 0x350c, 0x1154,
 0x0430, 0x191c, 0x2540, 0x340c, 0x1054,
 0x0330, 0x181c, 0x2440, 0x330c, 0x0f54,
 0x0230, 0x1820, 0x2444, 0x320c, 0x0e54,
 0x0130, 0x1920, 0x2544, 0x310c, 0x0d54,
 0x0030, 0x1a20, 0x2644, 0x300c, 0x0c54,
 0x0034, 0x1b20, 0x2744, 0x3010, 0x0c58,
 0x0134, 0x1c20, 0x2844, 0x3110, 0x0e58,
 0x0234, 0x1d20, 0x2944, 0x3210, 0x1058,
 0x0624, 0x2110, 0x2d34, 0x3600, 0x1248,
 0x0724, 0x2210, 0x2e34, 0x3700, 0x1348,
 0x0824, 0x2310, 0x2f34, 0x3800, 0x1448,
 0x0924, 0x2314, 0x2f38, 0x3900, 0x1548,
 0x0a24, 0x2214, 0x2e38, 0x3a00, 0x1648,
 0x0b24, 0x2114, 0x2d38, 0x3b00, 0x1748,
 0x0b28, 0x2014, 0x2c38, 0x3b04, 0x174c,
 0x0a28, 0x1f14, 0x2b38, 0x3a04, 0x164c,
 0x0928, 0x1e14, 0x2a38, 0x3904, 0x154c,
 0x0828, 0x1e18, 0x2a3c, 0x3804, 0x144c,
 0x0728, 0x1f18, 0x2b3c, 0x3704, 0x134c,
 0x0628, 0x2018, 0x2c3c, 0x3604, 0x124c,
 0x062c, 0x2118, 0x2d3c, 0x3608, 0x1250,
 0x072c, 0x2218, 0x2e3c, 0x3708, 0x1350,
 0x082c, 0x2318, 0x2f3c, 0x3808, 0x1450,
 0x092c, 0x231c, 0x2f40, 0x3908, 0x1550,
 0x0a2c, 0x221c, 0x2e40, 0x3a08, 0x1650,
 0x0b2c, 0x211c, 0x2d40, 0x3b08, 0x1750,
 0x0b30, 0x201c, 0x2c40, 0x3b0c, 0x1754,
 0x0a30, 0x1f1c, 0x2b40, 0x3a0c, 0x1654,
 0x0930, 0x1e1c, 0x2a40, 0x390c, 0x1554,
 0x0830, 0x1e20, 0x2a44, 0x380c, 0x1454,
 0x0730, 0x1f20, 0x2b44, 0x370c, 0x1354,
 0x0630, 0x2020, 0x2c44, 0x360c, 0x1254,
 0x0634, 0x2120, 0x2d44, 0x3610, 0x1258,
 0x0734, 0x2220, 0x2e44, 0x3710, 0x1458,
 0x0834, 0x2320, 0x2f44, 0x3810, 0x1658,

################################################################################

TITLE
    libavcodec DV dv_place_422_525

TYPE
    16

DATA
 0x0c48, 0x2424, 0x306c, 0x0000, 0x1890,
 0x0d48, 0x2524, 0x316c, 0x0100, 0x1990,
 0x0e48, 0x2624, 0x326c, 0x0200, 0x1a90,
 0x0e4c, 0x2628, 0x3270, 0x0204, 0x1a94,
 0x0d4c, 0x2528, 0x3170, 0x0104, 0x1994,
 0x0c4c, 0x2428, 0x3070, 0x0004, 0x1894,
 0x0c50, 0x242c, 0x3074, 0x0008, 0x1898,
 0x0d50, 0x252c, 0x3174, 0x0108, 0x1998,
 0x0e50, 0x262c, 0x3274, 0x0208, 0x1a98,
 0x0e54, 0x2630, 0x3278, 0x020c, 0x1a9c,
 0x0d54, 0x2530, 0x3178, 0x010c, 0x199c,
 0x0c54, 0x2430, 0x3078, 0x000c, 0x189c,
 0x0c58, 0x2434, 0x307c, 0x0010, 0x18a0,
 0x0d58, 0x2534, 0x317c, 0x0110, 0x19a0,
 0x0e58, 0x2634, 0x327c, 0x0210, 0x1aa0,
 0x0e5c, 0x2638, 0x3280, 0x0214, 0x1aa4,
 0x0d5c, 0x2538, 0x3180, 0x0114, 0x19a4,
 0x0c5c, 0x2438, 0x3080, 0x0014, 0x18a4,
 0x0c60, 0x243c, 0x3084, 0x0018, 0x18a8,
 0x0d60, 0x253c, 0x3184, 0x0118, 0x19a8,
 0x0e60, 0x263c, 0x3284, 0x0218, 0x1aa8,
 0x0e64, 0x2640, 0x3288, 0x021c, 0x1aac,
 0x0d64, 0x2540, 0x3188, 0x011c, 0x19ac,
 0x0c64, 0x2440, 0x3088, 0x001c, 0x18ac,
 0x0c68, 0x2444, 0x308c, 0x0020, 0x18b0,
 0x0d68, 0x2544, 0x318c, 0x0120, 0x19b0,
 0x0e68, 0x2644, 0x328c, 0x0220, 0x1ab0,
 0x1248, 0x2a24, 0x366c, 0x0600, 0x1e90,
 0x1348, 0x2b24, 0x376c, 0x0700, 0x1f90,
 0x1448, 0x2c24, 0x386c, 0x0800, 0x2090,
 0x144c, 0x2c28, 0x3870, 0x0804, 0x2094,
 0x134c, 0x2b28, 0x3770, 0x0704, 0x1f94,
 0x124c, 0x2a28, 0x3670, 0x0604, 0x1e94,
 0x1250, 0x2a2c, 0x3674, 0x0608, 0x1e98,
 0x1350, 0x2b2c, 0x3774, 0x0708, 0x1f98,
 0x1450, 0x2c2c, 0x3874, 0x0808, 0x2098,
 0x1454, 0x2c30, 0x3878, 0x080c, 0x209c,
 0x1354, 0x2b30, 0x3778, 0x070c, 0x1f9c,
 0x1254, 0x2a30, 0x3678, 0x060c, 0x1e9c,
 0x1258, 0x2a34, 0x367c, 0x0610, 0x1ea0,
 0x1358, 0x2b34, 0x377c, 0x0710, 0x1fa0,
 0x1458, 0x2c34, 0x387c, 0x0810, 0x20a0,
 0x145c, 0x2c38, 0x3880, 0x0814, 0x20a4,
 0x135c, 0x2b38, 0x3780, 0x0714, 0x1fa4,
 0x125c, 0x2a38, 0x3680, 0x0614, 0x1ea4,
 0x1260, 0x2a3c, 0x3684, 0x0618, 0x1ea8,
 0x1360, 0x2b3c, 0x3784, 0x0718, 0x1fa8,
 0x1460, 0x2c3c, 0x3884, 0x0818, 0x20a8,
 0x1464, 0x2c40, 0x3888, 0x081c, 0x20ac,
 0x1364, 0x2b40, 0x3788, 0x071c, 0x1fac,
 0x1264, 0x2a40, 0x3688, 0x061c, 0x1eac,
 0x1268, 0x2a44, 0x368c, 0x0620, 0x1eb0,
 0x1368, 0x2b44, 0x378c, 0x0720, 0x1fb0,
 0x1468, 0x2c44, 0x388c, 0x0820, 0x20b0,
 0x1848, 0x3024, 0x006c, 0x0c00, 0x2490,
 0x1948, 0x3124, 0x016c, 0x0d00, 0x2590,
 0x1a48, 0x3224, 0x026c, 0x0e00, 0x2690,
 0x1a4c, 0x3228, 0x0270, 0x0e04, 0x2694,
 0x194c, 0x3128, 0x0170, 0x0d04, 0x2594,
 0x184c, 0x3028, 0x0070, 0x0c04, 0x2494,
 0x1850, 0x302c, 0x0074, 0x0c08, 0x2498,
 0x1950, 0x312c, 0x0174, 0x0d08, 0x2598,
 0x1a50, 0x322c, 0x0274, 0x0e08, 0x2698,
 0x1a54, 0x3230, 0x0278, 0x0e0c, 0x269c,
 0x1954, 0x3130, 0x0178, 0x0d0c, 0x259c,
 0x1854, 0x3030, 0x0078, 0x0c0c, 0x249c,
 0x1858, 0x3034, 0x007c, 0x0c10, 0x24a0,
 0x1958, 0x3134, 0x017c, 0x0d10, 0x25a0,
 0x1a58, 0x3234, 0x027c, 0x0e10, 0x26a0,
 0x1a5c, 0x3238, 0x0280, 0x0e14, 0x26a4,
 0x195c, 0x3138, 0x0180, 0x0d14, 0x25a4,
 0x185c, 0x3038, 0x0080, 0x0c14, 0x24a4,
 0x1860, 0x303c, 0x0084, 0x0c18, 0x24a8,
 0x1960, 0x313c, 0x0184, 0x0d18, 0x25a8,
 0x1a60, 0x323c, 0x0284, 0x0e18, 0x26a8,
 0x1a64, 0x3240, 0x0288, 0x0e1c, 0x26ac,
 0x1964, 0x3140, 0x0188, 0x0d1c, 0x25ac,
 0x1864, 0x3040, 0x0088, 0x0c1c, 0x24ac,
 0x1868, 0x3044, 0x008c, 0x0c20, 0x24b0,
 0x1968, 0x3144, 0x018c, 0x0d20, 0x25b0,
 0x1a68, 0x3244, 0x028c, 0x0e20, 0x26b0,
 0x1e48, 0x3624, 0x066c, 0x1200, 0x2a90,
 0x1f48, 0x3724, 0x076c, 0x1300, 0x2b90,
 0x2048, 0x3824, 0x086c, 0x1400, 0x2c90,
 0x204c, 0x3828, 0x0870, 0x1404, 0x2c94,
 0x1f4c, 0x3728, 0x0770, 0x1304, 0x2b94,
 0x1e4c, 0x3628, 0x0670, 0x1204, 0x2a94,
 0x1e50, 0x362c, 0x0674, 0x1208, 0x2a98,
 0x1f50, 0x372c, 0x0774, 0x1308, 0x2b98,
 0x2050, 0x382c, 0x0874, 0x1408, 0x2c98,
 0x2054, 0x3830, 0x0878, 0x140c, 0x2c9c,
 0x1f54, 0x3730, 0x0778, 0x130c, 0x2b9c,
 0x1e54, 0x3630, 0x0678, 0x120c, 0x2a9c,
 0x1e58, 0x3634, 0x067c, 0x1210, 0x2aa0,
 0x1f58, 0x3734, 0x077c, 0x1310, 0x2ba0,
 0x2058, 0x3834, 0x087c, 0x1410, 0x2ca0,
 0x205c, 0x3838, 0x0880, 0x1414, 0x2ca4,
 0x1f5c, 0x3738, 0x0780, 0x1314, 0x2ba4,
 0x1e5c, 0x3638, 0x0680, 0x1214, 0x2aa4,
 0x1e60, 0x363c, 0x0684, 0x1218, 0x2aa8,
 0x1f60, 0x373c, 0x0784, 0x1318, 0x2ba8,
 0x2060, 0x383c, 0x0884, 0x1418, 0x2ca8,
 0x2064, 0x3840, 0x0888, 0x141c, 0x2cac,
 0x1f64, 0x3740, 0x0788, 0x131c, 0x2bac,
 0x1e64, 0x3640, 0x0688, 0x121c, 0x2aac,
 0x1e68, 0x3644, 0x068c, 0x1220, 0x2ab0,
 0x1f68, 0x3744, 0x078c, 0x1320, 0x2bb0,
 0x2068, 0x3844, 0x088c, 0x1420, 0x2cb0,
 0x2448, 0x0024, 0x0c6c, 0x1800, 0x3090,
 0x2548, 0x0124, 0x0d6c, 0x1900, 0x3190,
 0x2648, 0x0224, 0x0e6c, 0x1a00, 0x3290,
 0x264c, 0x0228, 0x0e70, 0x1a04, 0x3294,
 0x254c, 0x0128, 0x0d70, 0x1904, 0x3194,
 0x244c, 0x0028, 0x0c70, 0x1804, 0x3094,
 0x2450, 0x002c, 0x0c74, 0x1808, 0x3098,
 0x2550, 0x012c, 0x0d74, 0x1908, 0x3198,
 0x2650, 0x022c, 0x0e74, 0x1a08, 0x3298,
 0x2654, 0x0230, 0x0e78, 0x1a0c, 0x329c,
 0x2554, 0x0130, 0x0d78, 0x190c, 0x319c,
 0x2454, 0x0030, 0x0c78, 0x180c, 0x309c,
 0x2458, 0x0034, 0x0c7c, 0x1810, 0x30a0,
 0x2558, 0x0134, 0x0d7c, 0x1910, 0x31a0,
 0x2658, 0x0234, 0x0e7c, 0x1a10, 0x32a0,
 0x265c, 0x0238, 0x0e80, 0x1a14, 0x32a4,
 0x255c, 0x0138, 0x0d80, 0x1914, 0x31a4,
 0x245c, 0x0038, 0x0c80, 0x1814, 0x30a4,
 0x2460, 0x003c, 0x0c84, 0x1818, 0x30a8,
 0x2560, 0x013c, 0x0d84, 0x1918, 0x31a8,
 0x2660, 0x023c, 0x0e84, 0x1a18, 0x32a8,
 0x2664, 0x0240, 0x0e88, 0x1a1c, 0x32ac,
 0x2564, 0x0140, 0x0d88, 0x191c, 0x31ac,
 0x2464, 0x0040, 0x0c88, 0x181c, 0x30ac,
 0x2468, 0x0044, 0x0c8c, 0x1820, 0x30b0,
 0x2568, 0x0144, 0x0d8c, 0x1920, 0x31b0,
 0x2668, 0x0244, 0x0e8c, 0x1a20, 0x32b0,
 0x2a48, 0x0624, 0x126c, 0x1e00, 0x3690,
 0x2b48, 0x0724, 0x136c, 0x1f00, 0x3790,
 0x2c48, 0x0824, 0x146c, 0x2000, 0x3890,
 0x2c4c, 0x0828, 0x1470, 0x2004, 0x3894,
 0x2b4c, 0x0728, 0x1370, 0x1f04, 0x3794,
 0x2a4c, 0x0628, 0x1270, 0x1e04, 0x3694,
 0x2a50, 0x062c, 0x1274, 0x1e08, 0x3698,
 0x2b50, 0x072c, 0x1374, 0x1f08, 0x3798,
 0x2c50, 0x082c, 0x1474, 0x2008, 0x3898,
 0x2c54, 0x0830, 0x1478, 0x200c, 0x389c,
 0x2b54, 0x0730, 0x1378, 0x1f0c, 0x379c,
 0x2a54, 0x0630, 0x1278, 0x1e0c, 0x369c,
 0x2a58, 0x0634, 0x127c, 0x1e10, 0x36a0,
 0x2b58, 0x0734, 0x137c, 0x1f10, 0x37a0,
 0x2c58, 0x0834, 0x147c, 0x2010, 0x38a0,
 0x2c5c, 0x0838, 0x1480, 0x2014, 0x38a4,
 0x2b5c, 0x0738, 0x1380, 0x1f14, 0x37a4,
 0x2a5c, 0x0638, 0x1280, 0x1e14, 0x36a4,
 0x2a60, 0x063c, 0x1284, 0x1e18, 0x36a8,
 0x2b60, 0x073c, 0x1384, 0x1f18, 0x37a8,
 0x2c60, 0x083c, 0x1484, 0x2018, 0x38a8,
 0x2c64, 0x0840, 0x1488, 0x201c, 0x38ac,
 0x2b64, 0x0740, 0x1388, 0x1f1c, 0x37ac,
 0x2a64, 0x0640, 0x1288, 0x1e1c, 0x36ac,
 0x2a68, 0x0644, 0x128c, 0x1e20, 0x36b0,
 0x2b68, 0x0744, 0x138c, 0x1f20, 0x37b0,
 0x2c68, 0x0844, 0x148c, 0x2020, 0x38b0,
 0x3048, 0x0c24, 0x186c, 0x2400, 0x0090,
 0x3148, 0x0d24, 0x196c, 0x2500, 0x0190,
 0x3248, 0x0e24, 0x1a6c, 0x2600, 0x0290,
 0x324c, 0x0e28, 0x1a70, 0x2604, 0x0294,
 0x314c, 0x0d28, 0x1970, 0x2504, 0x0194,
 0x304c, 0x0c28, 0x1870, 0x2404, 0x0094,
 0x3050, 0x0c2c, 0x1874, 0x2408, 0x0098,
 0x3150, 0x0d2c, 0x1974, 0x2508, 0x0198,
 0x3250, 0x0e2c, 0x1a74, 0x2608, 0x0298,
 0x3254, 0x0e30, 0x1a78, 0x260c, 0x029c,
 0x3154, 0x0d30, 0x1978, 0x250c, 0x019c,
 0x3054, 0x0c30, 0x1878, 0x240c, 0x009c,
 0x3058, 0x0c34, 0x187c, 0x2410, 0x00a0,
 0x3158, 0x0d34, 0x197c, 0x2510, 0x01a0,
 0x3258, 0x0e34, 0x1a7c, 0x2610, 0x02a0,
 0x325c, 0x0e38, 0x1a80, 0x2614, 0x02a4,
 0x315c, 0x0d38, 0x1980, 0x2514, 0x01a4,
 0x305c, 0x0c38, 0x1880, 0x2414, 0x00a4,
 0x3060, 0x0c3c, 0x1884, 0x2418, 0x00a8,
 0x3160, 0x0d3c, 0x1984, 0x2518, 0x01a8,
 0x3260, 0x0e3c, 0x1a84, 0x2618, 0x02a8,
 0x3264, 0x0e40, 0x1a88, 0x261c, 0x02ac,
 0x3164, 0x0d40, 0x1988, 0x251c, 0x01ac,
 0x3064, 0x0c40, 0x1888, 0x241c, 0x00ac,
 0x3068, 0x0c44, 0x188c, 0x2420, 0x00b0,
 0x3168, 0x0d44, 0x198c, 0x2520, 0x01b0,
 0x3268, 0x0e44, 0x1a8c, 0x2620, 0x02b0,
 0x3648, 0x1224, 0x1e6c, 0x2a00, 0x0690,
 0x3748, 0x1324, 0x1f6c, 0x2b00, 0x0790,
 0x3848, 0x1424, 0x206c, 0x2c00, 0x0890,
 0x384c, 0x1428, 0x2070, 0x2c04, 0x0894,
 0x374c, 0x1328, 0x1f70, 0x2b04, 0x0794,
 0x364c, 0x1228, 0x1e70, 0x2a04, 0x0694,
 0x3650, 0x122c, 0x1e74, 0x2a08, 0x0698,
 0x3750, 0x132c, 0x1f74, 0x2b08, 0x0798,
 0x3850, 0x142c, 0x2074, 0x2c08, 0x0898,
 0x3854, 0x1430, 0x2078, 0x2c0c, 0x089c,
 0x3754, 0x1330, 0x1f78, 0x2b0c, 0x079c,
 0x3654, 0x1230, 0x1e78, 0x2a0c, 0x069c,
 0x3658, 0x1234, 0x1e7c, 0x2a10, 0x06a0,
 0x3758, 0x1334, 0x1f7c, 0x2b10, 0x07a0,
 0x3858, 0x1434, 0x207c, 0x2c10, 0x08a0,
 0x385c, 0x1438, 0x2080, 0x2c14, 0x08a4,
 0x375c, 0x1338, 0x1f80, 0x2b14, 0x07a4,
 0x365c, 0x1238, 0x1e80, 0x2a14, 0x06a4,
 0x3660, 0x123c, 0x1e84, 0x2a18, 0x06a8,
 0x3760, 0x133c, 0x1f84, 0x2b18, 0x07a8,
 0x3860, 0x143c, 0x2084, 0x2c18, 0x08a8,
 0x3864, 0x1440, 0x2088, 0x2c1c, 0x08ac,
 0x3764, 0x1340, 0x1f88, 0x2b1c, 0x07ac,
 0x3664, 0x1240, 0x1e88, 0x2a1c, 0x06ac,
 0x3668, 0x1244, 0x1e8c, 0x2a20, 0x06b0,
 0x3768, 0x1344, 0x1f8c, 0x2b20, 0x07b0,
 0x3868, 0x1444, 0x208c, 0x2c20, 0x08b0,
 0x0048, 0x1824, 0x246c, 0x3000, 0x0c90,
 0x0148, 0x1924, 0x256c, 0x3100, 0x0d90,
 0x0248, 0x1a24, 0x266c, 0x3200, 0x0e90,
 0x024c, 0x1a28, 0x2670, 0x3204, 0x0e94,
 0x014c, 0x1928, 0x2570, 0x3104, 0x0d94,
 0x004c, 0x1828, 0x2470, 0x3004, 0x0c94,
 0x0050, 0x182c, 0x2474, 0x3008, 0x0c98,
 0x0150, 0x192c, 0x2574, 0x3108, 0x0d98,
 0x0250, 0x1a2c, 0x2674, 0x3208, 0x0e98,
 0x0254, 0x1a30, 0x2678, 0x320c, 0x0e9c,
 0x0154, 0x1930, 0x2578, 0x310c, 0x0d9c,
 0x0054, 0x1830, 0x2478, 0x300c, 0x0c9c,
 0x0058, 0x1834, 0x247c, 0x3010, 0x0ca0,
 0x0158, 0x1934, 0x257c, 0x3110, 0x0da0,
 0x0258, 0x1a34, 0x267c, 0x3210, 0x0ea0,
 0x025c, 0x1a38, 0x2680, 0x3214, 0x0ea4,
 0x015c, 0x1938, 0x2580, 0x3114, 0x0da4,
 0x005c, 0x1838, 0x2480, 0x3014, 0x0ca4,
 0x0060, 0x183c, 0x2484, 0x3018, 0x0ca8,
 0x0160, 0x193c, 0x2584, 0x3118, 0x0da8,
 0x0260, 0x1a3c, 0x2684, 0x3218, 0x0ea8,
 0x0264, 0x1a40, 0x2688, 0x321c, 0x0eac,
 0x0164, 0x1940, 0x2588, 0x311c, 0x0dac,
 0x0064, 0x1840, 0x2488, 0x301c, 0x0cac,
 0x0068, 0x1844, 0x248c, 0x3020, 0x0cb0,
 0x0168, 0x1944, 0x258c, 0x3120, 0x0db0,
 0x0268, 0x1a44, 0x268c, 0x3220, 0x0eb0,
 0x0648, 0x1e24, 0x2a6c, 0x3600, 0x1290,
 0x0748, 0x1f24, 0x2b6c, 0x3700, 0x1390,
 0x0848, 0x2024, 0x2c6c, 0x3800, 0x1490,
 0x084c, 0x2028, 0x2c70, 0x3804, 0x1494,
 0x074c, 0x1f28, 0x2b70, 0x3704, 0x1394,
 0x064c, 0x1e28, 0x2a70, 0x3604, 0x1294,
 0x0650, 0x1e2c, 0x2a74, 0x3608, 0x1298,
 0x0750, 0x1f2c, 0x2b74, 0x3708, 0x1398,
 0x0850, 0x202c, 0x2c74, 0x3808, 0x1498,
 0x0854, 0x2030, 0x2c78, 0x380c, 0x149c,
 0x0754, 0x1f30, 0x2b78, 0x370c, 0x139c,
 0x0654, 0x1e30, 0x2a78, 0x360c, 0x129c,
 0x0658, 0x1e34, 0x2a7c, 0x3610, 0x12a0,
 0x0758, 0x1f34, 0x2b7c, 0x3710, 0x13a0,
 0x0858, 0x2034, 0x2c7c, 0x3810, 0x14a0,
 0x085c, 0x2038, 0x2c80, 0x3814, 0x14a4,
 0x075c, 0x1f38, 0x2b80, 0x3714, 0x13a4,
 0x065c, 0x1e38, 0x2a80, 0x3614, 0x12a4,
 0x0660, 0x1e3c, 0x2a84, 0x3618, 0x12a8,
 0x0760, 0x1f3c, 0x2b84, 0x3718, 0x13a8,
 0x0860, 0x203c, 0x2c84, 0x3818, 0x14a8,
 0x0864, 0x2040, 0x2c88, 0x381c, 0x14ac,
 0x0764, 0x1f40, 0x2b88, 0x371c, 0x13ac,
 0x0664, 0x1e40, 0x2a88, 0x361c, 0x12ac,
 0x0668, 0x1e44, 0x2a8c, 0x3620, 0x12b0,
 0x0768, 0x1f44, 0x2b8c, 0x3720, 0x13b0,
 0x0868, 0x2044, 0x2c8c, 0x3820, 0x14b0,
 0x0f48, 0x2724, 0x336c, 0x0300, 0x1b90,
 0x1048, 0x2824, 0x346c, 0x0400, 0x1c90,
 0x1148, 0x2924, 0x356c, 0x0500, 0x1d90,
 0x114c, 0x2928, 0x3570, 0x0504, 0x1d94,
 0x104c, 0x2828, 0x3470, 0x0404, 0x1c94,
 0x0f4c, 0x2728, 0x3370, 0x0304, 0x1b94,
 0x0f50, 0x272c, 0x3374, 0x0308, 0x1b98,
 0x1050, 0x282c, 0x3474, 0x0408, 0x1c98,
 0x1150, 0x292c, 0x3574, 0x0508, 0x1d98,
 0x1154, 0x2930, 0x3578, 0x050c, 0x1d9c,
 0x1054, 0x2830, 0x3478, 0x040c, 0x1c9c,
 0x0f54, 0x2730, 0x3378, 0x030c, 0x1b9c,
 0x0f58, 0x2734, 0x337c, 0x0310, 0x1ba0,
 0x1058, 0x2834, 0x347c, 0x0410, 0x1ca0,
 0x1158, 0x2934, 0x357c, 0x0510, 0x1da0,
 0x115c, 0x2938, 0x3580, 0x0514, 0x1da4,
 0x105c, 0x2838, 0x3480, 0x0414, 0x1ca4,
 0x0f5c, 0x2738, 0x3380, 0x0314, 0x1ba4,
 0x0f60, 0x273c, 0x3384, 0x0318, 0x1ba8,
 0x1060, 0x283c, 0x3484, 0x0418, 0x1ca8,
 0x1160, 0x293c, 0x3584, 0x0518, 0x1da8,
 0x1164, 0x2940, 0x3588, 0x051c, 0x1dac,
 0x1064, 0x2840, 0x3488, 0x041c, 0x1cac,
 0x0f64, 0x2740, 0x3388, 0x031c, 0x1bac,
 0x0f68, 0x2744, 0x338c, 0x0320, 0x1bb0,
 0x1068, 0x2844, 0x348c, 0x0420, 0x1cb0,
 0x1168, 0x2944, 0x358c, 0x0520, 0x1db0,
 0x1548, 0x2d24, 0x396c, 0x0900, 0x2190,
 0x1648, 0x2e24, 0x3a6c, 0x0a00, 0x2290,
 0x1748, 0x2f24, 0x3b6c, 0x0b00, 0x2390,
 0x174c, 0x2f28, 0x3b70, 0x0b04, 0x2394,
 0x164c, 0x2e28, 0x3a70, 0x0a04, 0x2294,
 0x154c, 0x2d28, 0x3970, 0x0904, 0x2194,
 0x1550, 0x2d2c, 0x3974, 0x0908, 0x2198,
 0x1650, 0x2e2c, 0x3a74, 0x0a08, 0x2298,
 0x1750, 0x2f2c, 0x3b74, 0x0b08, 0x2398,
 0x1754, 0x2f30, 0x3b78, 0x0b0c, 0x239c,
 0x1654, 0x2e30, 0x3a78, 0x0a0c, 0x229c,
 0x1554, 0x2d30, 0x3978, 0x090c, 0x219c,
 0x1558, 0x2d34, 0x397c, 0x0910, 0x21a0,
 0x1658, 0x2e34, 0x3a7c, 0x0a10, 0x22a0,
 0x1758, 0x2f34, 0x3b7c, 0x0b10, 0x23a0,
 0x175c, 0x2f38, 0x3b80, 0x0b14, 0x23a4,
 0x165c, 0x2e38, 0x3a80, 0x0a14, 0x22a4,
 0x155c, 0x2d38, 0x3980, 0x0914, 0x21a4,
 0x1560, 0x2d3c, 0x3984, 0x0918, 0x21a8,
 0x1660, 0x2e3c, 0x3a84, 0x0a18, 0x22a8,
 0x1760, 0x2f3c, 0x3b84, 0x0b18, 0x23a8,
 0x1764, 0x2f40, 0x3b88, 0x0b1c, 0x23ac,
 0x1664, 0x2e40, 0x3a88, 0x0a1c, 0x22ac,
 0x1564, 0x2d40, 0x3988, 0x091c, 0x21ac,
 0x1568, 0x2d44, 0x398c, 0x0920, 0x21b0,
 0x1668, 0x2e44, 0x3a8c, 0x0a20, 0x22b0,
 0x1768, 0x2f44, 0x3b8c, 0x0b20, 0x23b0,
 0x1b48, 0x3324, 0x036c, 0x0f00, 0x2790,
 0x1c48, 0x3424, 0x046c, 0x1000, 0x2890,
 0x1d48, 0x3524, 0x056c, 0x1100, 0x2990,
 0x1d4c, 0x3528, 0x0570, 0x1104, 0x2994,
 0x1c4c, 0x3428, 0x0470, 0x1004, 0x2894,
 0x1b4c, 0x3328, 0x0370, 0x0f04, 0x2794,
 0x1b50, 0x332c, 0x0374, 0x0f08, 0x2798,
 0x1c50, 0x342c, 0x0474, 0x1008, 0x2898,
 0x1d50, 0x352c, 0x0574, 0x1108, 0x2998,
 0x1d54, 0x3530, 0x0578, 0x110c, 0x299c,
 0x1c54, 0x3430, 0x0478, 0x100c, 0x289c,
 0x1b54, 0x3330, 0x0378, 0x0f0c, 0x279c,
 0x1b58, 0x3334, 0x037c, 0x0f10, 0x27a0,
 0x1c58, 0x3434, 0x047c, 0x1010, 0x28a0,
 0x1d58, 0x3534, 0x057c, 0x1110, 0x29a0,
 0x1d5c, 0x3538, 0x0580, 0x1114, 0x29a4,
 0x1c5c, 0x3438, 0x0480, 0x1014, 0x28a4,
 0x1b5c, 0x3338, 0x0380, 0x0f14, 0x27a4,
 0x1b60, 0x333c, 0x0384, 0x0f18, 0x27a8,
 0x1c60, 0x343c, 0x0484, 0x1018, 0x28a8,
 0x1d60, 0x353c, 0x0584, 0x1118, 0x29a8,
 0x1d64, 0x3540, 0x0588, 0x111c, 0x29ac,
 0x1c64, 0x3440, 0x0488, 0x101c, 0x28ac,
 0x1b64, 0x3340, 0x0388, 0x0f1c, 0x27ac,
 0x1b68, 0x3344, 0x038c, 0x0f20, 0x27b0,
 0x1c68, 0x3444, 0x048c, 0x1020, 0x28b0,
 0x1d68, 0x3544, 0x058c, 0x1120, 0x29b0,
 0x2148, 0x3924, 0x096c, 0x1500, 0x2d90,
 0x2248, 0x3a24, 0x0a6c, 0x1600, 0x2e90,
 0x2348, 0x3b24, 0x0b6c, 0x1700, 0x2f90,
 0x234c, 0x3b28, 0x0b70, 0x1704, 0x2f94,
 0x224c, 0x3a28, 0x0a70, 0x1604, 0x2e94,
 0x214c, 0x3928, 0x0970, 0x1504, 0x2d94,
 0x2150, 0x392c, 0x0974, 0x1508, 0x2d98,
 0x2250, 0x3a2c, 0x0a74, 0x1608, 0x2e98,
 0x2350, 0x3b2c, 0x0b74, 0x1708, 0x2f98,
 0x2354, 0x3b30, 0x0b78, 0x170c, 0x2f9c,
 0x2254, 0x3a30, 0x0a78, 0x160c, 0x2e9c,
 0x2154, 0x3930, 0x0978, 0x150c, 0x2d9c,
 0x2158, 0x3934, 0x097c, 0x1510, 0x2da0,
 0x2258, 0x3a34, 0x0a7c, 0x1610, 0x2ea0,
 0x2358, 0x3b34, 0x0b7c, 0x1710, 0x2fa0,
 0x235c, 0x3b38, 0x0b80, 0x1714, 0x2fa4,
 0x225c, 0x3a38, 0x0a80, 0x1614, 0x2ea4,
 0x215c, 0x3938, 0x0980, 0x1514, 0x2da4,
 0x2160, 0x393c, 0x0984, 0x1518, 0x2da8,
 0x2260, 0x3a3c, 0x0a84, 0x1618, 0x2ea8,
 0x2360, 0x3b3c, 0x0b84, 0x1718, 0x2fa8,
 0x2364, 0x3b40, 0x0b88, 0x171c, 0x2fac,
 0x2264, 0x3a40, 0x0a88, 0x161c, 0x2eac,
 0x2164, 0x3940, 0x0988, 0x151c, 0x2dac,
 0x2168, 0x3944, 0x098c, 0x1520, 0x2db0,
 0x2268, 0x3a44, 0x0a8c, 0x1620, 0x2eb0,
 0x2368, 0x3b44, 0x0b8c, 0x1720, 0x2fb0,
 0x2748, 0x0324, 0x0f6c, 0x1b00, 0x3390,
 0x2848, 0x0424, 0x106c, 0x1c00, 0x3490,
 0x2948, 0x0524, 0x116c, 0x1d00, 0x3590,
 0x294c, 0x0528, 0x1170, 0x1d04, 0x3594,
 0x284c, 0x0428, 0x1070, 0x1c04, 0x3494,
 0x274c, 0x0328, 0x0f70, 0x1b04, 0x3394,
 0x2750, 0x032c, 0x0f74, 0x1b08, 0x3398,
 0x2850, 0x042c, 0x1074, 0x1c08, 0x3498,
 0x2950, 0x052c, 0x1174, 0x1d08, 0x3598,
 0x2954, 0x0530, 0x1178, 0x1d0c, 0x359c,
 0x2854, 0x0430, 0x1078, 0x1c0c, 0x349c,
 0x2754, 0x0330, 0x0f78, 0x1b0c, 0x339c,
 0x2758, 0x0334, 0x0f7c, 0x1b10, 0x33a0,
 0x2858, 0x0434, 0x107c, 0x1c10, 0x34a0,
 0x2958, 0x0534, 0x117c, 0x1d10, 0x35a0,
 0x295c, 0x0538, 0x1180, 0x1d14, 0x35a4,
 0x285c, 0x0438, 0x1080, 0x1c14, 0x34a4,
 0x275c, 0x0338, 0x0f80, 0x1b14, 0x33a4,
 0x2760, 0x033c, 0x0f84, 0x1b18, 0x33a8,
 0x2860, 0x043c, 0x1084, 0x1c18, 0x34a8,
 0x2960, 0x053c, 0x1184, 0x1d18, 0x35a8,
 0x2964, 0x0540, 0x1188, 0x1d1c, 0x35ac,
 0x2864, 0x0440, 0x1088, 0x1c1c, 0x34ac,
 0x2764, 0x0340, 0x0f88, 0x1b1c, 0x33ac,
 0x2768, 0x0344, 0x0f8c, 0x1b20, 0x33b0,
 0x2868, 0x0444, 0x108c, 0x1c20, 0x34b0,
 0x2968, 0x0544, 0x118c, 0x1d20, 0x35b0,
 0x2d48, 0x0924, 0x156c, 0x2100, 0x3990,
 0x2e48, 0x0a24, 0x166c, 0x2200, 0x3a90,
 0x2f48, 0x0b24, 0x176c, 0x2300, 0x3b90,
 0x2f4c, 0x0b28, 0x1770, 0x2304, 0x3b94,
 0x2e4c, 0x0a28, 0x1670, 0x2204, 0x3a94,
 0x2d4c, 0x0928, 0x1570, 0x2104, 0x3994,
 0x2d50, 0x092c, 0x1574, 0x2108, 0x3998,
 0x2e50, 0x0a2c, 0x1674, 0x2208, 0x3a98,
 0x2f50, 0x0b2c, 0x1774, 0x2308, 0x3b98,
 0x2f54, 0x0b30, 0x1778, 0x230c, 0x3b9c,
 0x2e54, 0x0a30, 0x1678, 0x220c, 0x3a9c,
 0x2d54, 0x0930, 0x1578, 0x210c, 0x399c,
 0x2d58, 0x0934, 0x157c, 0x2110, 0x39a0,
 0x2e58, 0x0a34, 0x167c, 0x2210, 0x3aa0,
 0x2f58, 0x0b34, 0x177c, 0x2310, 0x3ba0,
 0x2f5c, 0x0b38, 0x1780, 0x2314, 0x3ba4,
 0x2e5c, 0x0a38, 0x1680, 0x2214, 0x3aa4,
 0x2d5c, 0x0938, 0x1580, 0x2114, 0x39a4,
 0x2d60, 0x093c, 0x1584, 0x2118, 0x39a8,
 0x2e60, 0x0a3c, 0x1684, 0x2218, 0x3aa8,
 0x2f60, 0x0b3c, 0x1784, 0x2318, 0x3ba8,
 0x2f64, 0x0b40, 0x1788, 0x231c, 0x3bac,
 0x2e64, 0x0a40, 0x1688, 0x221c, 0x3aac,
 0x2d64, 0x0940, 0x1588, 0x211c, 0x39ac,
 0x2d68, 0x0944, 0x158c, 0x2120, 0x39b0,
 0x2e68, 0x0a44, 0x168c, 0x2220, 0x3ab0,
 0x2f68, 0x0b44, 0x178c, 0x2320, 0x3bb0,
 0x3348, 0x0f24, 0x1b6c, 0x2700, 0x0390,
 0x3448, 0x1024, 0x1c6c, 0x2800, 0x0490,
 0x3548, 0x1124, 0x1d6c, 0x2900, 0x0590,
 0x354c, 0x1128, 0x1d70, 0x2904, 0x0594,
 0x344c, 0x1028, 0x1c70, 0x2804, 0x0494,
 0x334c, 0x0f28, 0x1b70, 0x2704, 0x0394,
 0x3350, 0x0f2c, 0x1b74, 0x2708, 0x0398,
 0x3450, 0x102c, 0x1c74, 0x2808, 0x0498,
 0x3550, 0x112c, 0x1d74, 0x2908, 0x0598,
 0x3554, 0x1130, 0x1d78, 0x290c, 0x059c,
 0x3454, 0x1030, 0x1c78, 0x280c, 0x049c,
 0x3354, 0x0f30, 0x1b78, 0x270c, 0x039c,
 0x3358, 0x0f34, 0x1b7c, 0x2710, 0x03a0,
 0x3458, 0x1034, 0x1c7c, 0x2810, 0x04a0,
 0x3558, 0x1134, 0x1d7c, 0x2910, 0x05a0,
 0x355c, 0x1138, 0x1d80, 0x2914, 0x05a4,
 0x345c, 0x1038, 0x1c80, 0x2814, 0x04a4,
 0x335c, 0x0f38, 0x1b80, 0x2714, 0x03a4,
 0x3360, 0x0f3c, 0x1b84, 0x2718, 0x03a8,
 0x3460, 0x103c, 0x1c84, 0x2818, 0x04a8,
 0x3560, 0x113c, 0x1d84, 0x2918, 0x05a8,
 0x3564, 0x1140, 0x1d88, 0x291c, 0x05ac,
 0x3464, 0x1040, 0x1c88, 0x281c, 0x04ac,
 0x3364, 0x0f40, 0x1b88, 0x271c, 0x03ac,
 0x3368, 0x0f44, 0x1b8c, 0x2720, 0x03b0,
 0x3468, 0x1044, 0x1c8c, 0x2820, 0x04b0,
 0x3568, 0x1144, 0x1d8c, 0x2920, 0x05b0,
 0x3948, 0x1524, 0x216c, 0x2d00, 0x0990,
 0x3a48, 0x1624, 0x226c, 0x2e00, 0x0a90,
 0x3b48, 0x1724, 0x236c, 0x2f00, 0x0b90,
 0x3b4c, 0x1728, 0x2370, 0x2f04, 0x0b94,
 0x3a4c, 0x1628, 0x2270, 0x2e04, 0x0a94,
 0x394c, 0x1528, 0x2170, 0x2d04, 0x0994,
 0x3950, 0x152c, 0x2174, 0x2d08, 0x0998,
 0x3a50, 0x162c, 0x2274, 0x2e08, 0x0a98,
 0x3b50, 0x172c, 0x2374, 0x2f08, 0x0b98,
 0x3b54, 0x1730, 0x2378, 0x2f0c, 0x0b9c,
 0x3a54, 0x1630, 0x2278, 0x2e0c, 0x0a9c,
 0x3954, 0x1530, 0x2178, 0x2d0c, 0x099c,
 0x3958, 0x1534, 0x217c, 0x2d10, 0x09a0,
 0x3a58, 0x1634, 0x227c, 0x2e10, 0x0aa0,
 0x3b58, 0x1734, 0x237c, 0x2f10, 0x0ba0,
 0x3b5c, 0x1738, 0x2380, 0x2f14, 0x0ba4,
 0x3a5c, 0x1638, 0x2280, 0x2e14, 0x0aa4,
 0x395c, 0x1538, 0x2180, 0x2d14, 0x09a4,
 0x3960, 0x153c, 0x2184, 0x2d18, 0x09a8,
 0x3a60, 0x163c, 0x2284, 0x2e18, 0x0aa8,
 0x3b60, 0x173c, 0x2384, 0x2f18, 0x0ba8,
 0x3b64, 0x1740, 0x2388, 0x2f1c, 0x0bac,
 0x3a64, 0x1640, 0x2288, 0x2e1c, 0x0aac,
 0x3964, 0x1540, 0x2188, 0x2d1c, 0x09ac,
 0x3968, 0x1544, 0x218c, 0x2d20, 0x09b0,
 0x3a68, 0x1644, 0x228c, 0x2e20, 0x0ab0,
 0x3b68, 0x1744, 0x238c, 0x2f20, 0x0bb0,
 0x0348, 0x1b24, 0x276c, 0x3300, 0x0f90,
 0x0448, 0x1c24, 0x286c, 0x3400, 0x1090,
 0x0548, 0x1d24, 0x296c, 0x3500, 0x1190,
 0x054c, 0x1d28, 0x2970, 0x3504, 0x1194,
 0x044c, 0x1c28, 0x2870, 0x3404, 0x1094,
 0x034c, 0x1b28, 0x2770, 0x3304, 0x0f94,
 0x0350, 0x1b2c, 0x2774, 0x3308, 0x0f98,
 0x0450, 0x1c2c, 0x2874, 0x3408, 0x1098,
 0x0550, 0x1d2c, 0x2974, 0x3508, 0x1198,
 0x0554, 0x1d30, 0x2978, 0x350c, 0x119c,
 0x0454, 0x1c30, 0x2878, 0x340c, 0x109c,
 0x0354, 0x1b30, 0x2778, 0x330c, 0x0f9c,
 0x0358, 0x1b34, 0x277c, 0x3310, 0x0fa0,
 0x0458, 0x1c34, 0x287c, 0x3410, 0x10a0,
 0x0558, 0x1d34, 0x297c, 0x3510, 0x11a0,
 0x055c, 0x1d38, 0x2980, 0x3514, 0x11a4,
 0x045c, 0x1c38, 0x2880, 0x3414, 0x10a4,
 0x035c, 0x1b38, 0x2780, 0x3314, 0x0fa4,
 0x0360, 0x1b3c, 0x2784, 0x3318, 0x0fa8,
 0x0460, 0x1c3c, 0x2884, 0x3418, 0x10a8,
 0x0560, 0x1d3c, 0x2984, 0x3518, 0x11a8,
 0x0564, 0x1d40, 0x2988, 0x351c, 0x11ac,
 0x0464, 0x1c40, 0x2888, 0x341c, 0x10ac,
 0x0364, 0x1b40, 0x2788, 0x331c, 0x0fac,
 0x0368, 0x1b44, 0x278c, 0x3320, 0x0fb0,
 0x0468, 0x1c44, 0x288c, 0x3420, 0x10b0,
 0x0568, 0x1d44, 0x298c, 0x3520, 0x11b0,
 0x0948, 0x2124, 0x2d6c, 0x3900, 0x1590,
 0x0a48, 0x2224, 0x2e6c, 0x3a00, 0x1690,
 0x0b48, 0x2324, 0x2f6c, 0x3b00, 0x1790,
 0x0b4c, 0x2328, 0x2f70, 0x3b04, 0x1794,
 0x0a4c, 0x2228, 0x2e70, 0x3a04, 0x1694,
 0x094c, 0x2128, 0x2d70, 0x3904, 0x1594,
 0x0950, 0x212c, 0x2d74, 0x3908, 0x1598,
 0x0a50, 0x222c, 0x2e74, 0x3a08, 0x1698,
 0x0b50, 0x232c, 0x2f74, 0x3b08, 0x1798,
 0x0b54, 0x2330, 0x2f78, 0x3b0c, 0x179c,
 0x0a54, 0x2230, 0x2e78, 0x3a0c, 0x169c,
 0x0954, 0x2130, 0x2d78, 0x390c, 0x159c,
 0x0958, 0x2134, 0x2d7c, 0x3910, 0x15a0,
 0x0a58, 0x2234, 0x2e7c, 0x3a10, 0x16a0,
 0x0b58, 0x2334, 0x2f7c, 0x3b10, 0x17a0,
 0x0b5c, 0x2338, 0x2f80, 0x3b14, 0x17a4,
 0x0a5c, 0x2238, 0x2e80, 0x3a14, 0x16a4,
 0x095c, 0x2138, 0x2d80, 0x3914, 0x15a4,
 0x0960, 0x213c, 0x2d84, 0x3918, 0x15a8,
 0x0a60, 0x223c, 0x2e84, 0x3a18, 0x16a8,
 0x0b60, 0x233c, 0x2f84, 0x3b18, 0x17a8,
 0x0b64, 0x2340, 0x2f88, 0x3b1c, 0x17ac,
 0x0a64, 0x2240, 0x2e88, 0x3a1c, 0x16ac,
 0x0964, 0x2140, 0x2d88, 0x391c, 0x15ac,
 0x0968, 0x2144, 0x2d8c, 0x3920, 0x15b0,
 0x0a68, 0x2244, 0x2e8c, 0x3a20, 0x16b0,
 0x0b68, 0x2344, 0x2f8c, 0x3b20, 0x17b0,

################################################################################

TITLE
    libavcodec DV dv_place_422_625

TYPE
    16

DATA
 0x0c48, 0x2424, 0x306c, 0x0000, 0x1890,
 0x0d48, 0x2524, 0x316c, 0x0100, 0x1990,
 0x0e48, 0x2624, 0x326c, 0x0200, 0x1a90,
 0x0e4c, 0x2628, 0x3270, 0x0204, 0x1a94,
 0x0d4c, 0x2528, 0x3170, 0x0104, 0x1994,
 0x0c4c, 0x2428, 0x3070, 0x0004, 0x1894,
 0x0c50, 0x242c, 0x3074, 0x0008, 0x1898,
 0x0d50, 0x252c, 0x3174, 0x0108, 0x1998,
 0x0e50, 0x262c, 0x3274, 0x0208, 0x1a98,
 0x0e54, 0x2630, 0x3278, 0x020c, 0x1a9c,
 0x0d54, 0x2530, 0x3178, 0x010c, 0x199c,
 0x0c54, 0x2430, 0x3078, 0x000c, 0x189c,
 0x0c58, 0x2434, 0x307c, 0x0010, 0x18a0,
 0x0d58, 0x2534, 0x317c, 0x0110, 0x19a0,
 0x0e58, 0x2634, 0x327c, 0x0210, 0x1aa0,
 0x0e5c, 0x2638, 0x3280, 0x0214, 0x1aa4,
 0x0d5c, 0x2538, 0x3180, 0x0114, 0x19a4,
 0x0c5c, 0x2438, 0x3080, 0x0014, 0x18a4,
 0x0c60, 0x243c, 0x3084, 0x0018, 0x18a8,
 0x0d60, 0x253c, 0x3184, 0x0118, 0x19a8,
 0x0e60, 0x263c, 0x3284, 0x0218, 0x1aa8,
 0x0e64, 0x2640, 0x3288, 0x021c, 0x1aac,
 0x0d64, 0x2540, 0x3188, 0x011c, 0x19ac,
 0x0c64, 0x2440, 0x3088, 0x001c, 0x18ac,
 0x0c68, 0x2444, 0x308c, 0x0020, 0x18b0,
 0x0d68, 0x2544, 0x318c, 0x0120, 0x19b0,
 0x0e68, 0x2644, 0x328c, 0x0220, 0x1ab0,
 0x1248, 0x2a24, 0x366c, 0x0600, 0x1e90,
 0x1348, 0x2b24, 0x376c, 0x0700, 0x1f90,
 0x1448, 0x2c24, 0x386c, 0x0800, 0x2090,
 0x144c, 0x2c28, 0x3870, 0x0804, 0x2094,
 0x134c, 0x2b28, 0x3770, 0x0704, 0x1f94,
 0x124c, 0x2a28, 0x3670, 0x0604, 0x1e94,
 0x1250, 0x2a2c, 0x3674, 0x0608, 0x1e98,
 0x1350, 0x2b2c, 0x3774, 0x0708, 0x1f98,
 0x1450, 0x2c2c, 0x3874, 0x0808, 0x2098,
 0x1454, 0x2c30, 0x3878, 0x080c, 0x209c,
 0x1354, 0x2b30, 0x3778, 0x070c, 0x1f9c,
 0x1254, 0x2a30, 0x3678, 0x060c, 0x1e9c,
 0x1258, 0x2a34, 0x367c, 0x0610, 0x1ea0,
 0x1358, 0x2b34, 0x377c, 0x0710, 0x1fa0,
 0x1458, 0x2c34, 0x387c, 0x0810, 0x20a0,
 0x145c, 0x2c38, 0x3880, 0x0814, 0x20a4,
 0x135c, 0x2b38, 0x3780, 0x0714, 0x1fa4,
 0x125c, 0x2a38, 0x3680, 0x0614, 0x1ea4,
 0x1260, 0x2a3c, 0x3684, 0x0618, 0x1ea8,
 0x1360, 0x2b3c, 0x3784, 0x0718, 0x1fa8,
 0x1460, 0x2c3c, 0x3884, 0x0818, 0x20a8,
 0x1464, 0x2c40, 0x3888, 0x081c, 0x20ac,
 0x1364, 0x2b40, 0x3788, 0x071c, 0x1fac,
 0x1264, 0x2a40, 0x3688, 0x061c, 0x1eac,
 0x1268, 0x2a44, 0x368c, 0x0620, 0x1eb0,
 0x1368, 0x2b44, 0x378c, 0x0720, 0x1fb0,
 0x1468, 0x2c44, 0x388c, 0x0820, 0x20b0,
 0x1848, 0x3024, 0x3c6c, 0x0c00, 0x2490,
 0x1948, 0x3124, 0x3d6c, 0x0d00, 0x2590,
 0x1a48, 0x3224, 0x3e6c, 0x0e00, 0x2690,
 0x1a4c, 0x3228, 0x3e70, 0x0e04, 0x2694,
 0x194c, 0x3128, 0x3d70, 0x0d04, 0x2594,
 0x184c, 0x3028, 0x3c70, 0x0c04, 0x2494,
 0x1850, 0x302c, 0x3c74, 0x0c08, 0x2498,
 0x1950, 0x312c, 0x3d74, 0x0d08, 0x2598,
 0x1a50, 0x322c, 0x3e74, 0x0e08, 0x2698,
 0x1a54, 0x3230, 0x3e78, 0x0e0c, 0x269c,
 0x1954, 0x3130, 0x3d78, 0x0d0c, 0x259c,
 0x1854, 0x3030, 0x3c78, 0x0c0c, 0x249c,
 0x1858, 0x3034, 0x3c7c, 0x0c10, 0x24a0,
 0x1958, 0x3134, 0x3d7c, 0x0d10, 0x25a0,
 0x1a58, 0x3234, 0x3e7c, 0x0e10, 0x26a0,
 0x1a5c, 0x3238, 0x3e80, 0x0e14, 0x26a4,
 0x195c, 0x3138, 0x3d80, 0x0d14, 0x25a4,
 0x185c, 0x3038, 0x3c80, 0x0c14, 0x24a4,
 0x1860, 0x303c, 0x3c84, 0x0c18, 0x24a8,
 0x1960, 0x313c, 0x3d84, 0x0d18, 0x25a8,
 0x1a60, 0x323c, 0x3e84, 0x0e18, 0x26a8,
 0x1a64, 0x3240, 0x3e88, 0x0e1c, 0x26ac,
 0x1964, 0x3140, 0x3d88, 0x0d1c, 0x25ac,
 0x1864, 0x3040, 0x3c88, 0x0c1c, 0x24ac,
 0x1868, 0x3044, 0x3c8c, 0x0c20, 0x24b0,
 0x1968, 0x3144, 0x3d8c, 0x0d20, 0x25b0,
 0x1a68, 0x3244, 0x3e8c, 0x0e20, 0x26b0,
 0x1e48, 0x3624, 0x426c, 0x1200, 0x2a90,
 0x1f48, 0x3724, 0x436c, 0x1300, 0x2b90,
 0x2048, 0x3824, 0x446c, 0x1400, 0x2c90,
 0x204c, 0x3828, 0x4470, 0x1404, 0x2c94,
 0x1f4c, 0x3728, 0x4370, 0x1304, 0x2b94,
 0x1e4c, 0x3628, 0x4270, 0x1204, 0x2a94,
 0x1e50, 0x362c, 0x4274, 0x1208, 0x2a98,
 0x1f50, 0x372c, 0x4374, 0x1308, 0x2b98,
 0x2050, 0x382c, 0x4474, 0x1408, 0x2c98,
 0x2054, 0x3830, 0x4478, 0x140c, 0x2c9c,
 0x1f54, 0x3730, 0x4378, 0x130c, 0x2b9c,
 0x1e54, 0x3630, 0x4278, 0x120c, 0x2a9c,
 0x1e58, 0x3634, 0x427c, 0x1210, 0x2aa0,
 0x1f58, 0x3734, 0x437c, 0x1310, 0x2ba0,
 0x2058, 0x3834, 0x447c, 0x1410, 0x2ca0,
 0x205c, 0x3838, 0x4480, 0x1414, 0x2ca4,
 0x1f5c, 0x3738, 0x4380, 0x1314, 0x2ba4,
 0x1e5c, 0x3638, 0x4280, 0x1214, 0x2aa4,
 0x1e60, 0x363c, 0x4284, 0x1218, 0x2aa8,
 0x1f60, 0x373c, 0x4384, 0x1318, 0x2ba8,
 0x2060, 0x383c, 0x4484, 0x1418, 0x2ca8,
 0x2064, 0x3840, 0x4488, 0x141c, 0x2cac,
 0x1f64, 0x3740, 0x4388, 0x131c, 0x2bac,
 0x1e64, 0x3640, 0x4288, 0x121c, 0x2aac,
 0x1e68, 0x3644, 0x428c, 0x1220, 0x2ab0,
 0x1f68, 0x3744, 0x438c, 0x1320, 0x2bb0,
 0x2068, 0x3844, 0x448c, 0x1420, 0x2cb0,
 0x2448, 0x3c24, 0x006c, 0x1800, 0x3090,
 0x2548, 0x3d24, 0x016c, 0x1900, 0x3190,
 0x2648, 0x3e24, 0x026c, 0x1a00, 0x3290,
 0x264c, 0x3e28, 0x0270, 0x1a04, 0x3294,
 0x254c, 0x3d28, 0x0170, 0x1904, 0x3194,
 0x244c, 0x3c28, 0x0070, 0x1804, 0x3094,
 0x2450, 0x3c2c, 0x0074, 0x1808, 0x3098,
 0x2550, 0x3d2c, 0x0174, 0x1908, 0x3198,
 0x2650, 0x3e2c, 0x0274, 0x1a08, 0x3298,
 0x2654, 0x3e30, 0x0278, 0x1a0c, 0x329c,
 0x2554, 0x3d30, 0x0178, 0x190c, 0x319c,
 0x2454, 0x3c30, 0x0078, 0x180c, 0x309c,
 0x2458, 0x3c34, 0x007c, 0x1810, 0x30a0,
 0x2558, 0x3d34, 0x017c, 0x1910, 0x31a0,
 0x2658, 0x3e34, 0x027c, 0x1a10, 0x32a0,
 0x265c, 0x3e38, 0x0280, 0x1a14, 0x32a4,
 0x255c, 0x3d38, 0x0180, 0x1914, 0x31a4,
 0x245c, 0x3c38, 0x0080, 0x1814, 0x30a4,
 0x2460, 0x3c3c, 0x0084, 0x1818, 0x30a8,
 0x2560, 0x3d3c, 0x0184, 0x1918, 0x31a8,
 0x2660, 0x3e3c, 0x0284, 0x1a18, 0x32a8,
 0x2664, 0x3e40, 0x0288, 0x1a1c, 0x32ac,
 0x2564, 0x3d40, 0x0188, 0x191c, 0x31ac,
 0x2464, 0x3c40, 0x0088, 0x181c, 0x30ac,
 0x2468, 0x3c44, 0x008c, 0x1820, 0x30b0,
 0x2568, 0x3d44, 0x018c, 0x1920, 0x31b0,
 0x2668, 0x3e44, 0x028c, 0x1a20, 0x32b0,
 0x2a48, 0x4224, 0x066c, 0x1e00, 0x3690,
 0x2b48, 0x4324, 0x076c, 0x1f00, 0x3790,
 0x2c48, 0x4424, 0x086c, 0x2000, 0x3890,
 0x2c4c, 0x4428, 0x0870, 0x2004, 0x3894,
 0x2b4c, 0x4328, 0x0770, 0x1f04, 0x3794,
 0x2a4c, 0x4228, 0x0670, 0x1e04, 0x3694,
 0x2a50, 0x422c, 0x0674, 0x1e08, 0x3698,
 0x2b50, 0x432c, 0x0774, 0x1f08, 0x3798,
 0x2c50, 0x442c, 0x0874, 0x2008, 0x3898,
 0x2c54, 0x4430, 0x0878, 0x200c, 0x389c,
 0x2b54, 0x4330, 0x0778, 0x1f0c, 0x379c,
 0x2a54, 0x4230, 0x0678, 0x1e0c, 0x369c,
 0x2a58, 0x4234, 0x067c, 0x1e10, 0x36a0,
 0x2b58, 0x4334, 0x077c, 0x1f10, 0x37a0,
 0x2c58, 0x4434, 0x087c, 0x2010, 0x38a0,
 0x2c5c, 0x4438, 0x0880, 0x2014, 0x38a4,
 0x2b5c, 0x4338, 0x0780, 0x1f14, 0x37a4,
 0x2a5c, 0x4238, 0x0680, 0x1e14, 0x36a4,
 0x2a60, 0x423c, 0x0684, 0x1e18, 0x36a8,
 0x2b60, 0x433c, 0x0784, 0x1f18, 0x37a8,
 0x2c60, 0x443c, 0x0884, 0x2018, 0x38a8,
 0x2c64, 0x4440, 0x0888, 0x201c, 0x38ac,
 0x2b64, 0x4340, 0x0788, 0x1f1c, 0x37ac,
 0x2a64, 0x4240, 0x0688, 0x1e1c, 0x36ac,
 0x2a68, 0x4244, 0x068c, 0x1e20, 0x36b0,
 0x2b68, 0x4344, 0x078c, 0x1f20, 0x37b0,
 0x2c68, 0x4444, 0x088c, 0x2020, 0x38b0,
 0x3048, 0x0024, 0x0c6c, 0x2400, 0x3c90,
 0x3148, 0x0124, 0x0d6c, 0x2500, 0x3d90,
 0x3248, 0x0224, 0x0e6c, 0x2600, 0x3e90,
 0x324c, 0x0228, 0x0e70, 0x2604, 0x3e94,
 0x314c, 0x0128, 0x0d70, 0x2504, 0x3d94,
 0x304c, 0x0028, 0x0c70, 0x2404, 0x3c94,
 0x3050, 0x002c, 0x0c74, 0x2408, 0x3c98,
 0x3150, 0x012c, 0x0d74, 0x2508, 0x3d98,
 0x3250, 0x022c, 0x0e74, 0x2608, 0x3e98,
 0x3254, 0x0230, 0x0e78, 0x260c, 0x3e9c,
 0x3154, 0x0130, 0x0d78, 0x250c, 0x3d9c,
 0x3054, 0x0030, 0x0c78, 0x240c, 0x3c9c,
 0x3058, 0x0034, 0x0c7c, 0x2410, 0x3ca0,
 0x3158, 0x0134, 0x0d7c, 0x2510, 0x3da0,
 0x3258, 0x0234, 0x0e7c, 0x2610, 0x3ea0,
 0x325c, 0x0238, 0x0e80, 0x2614, 0x3ea4,
 0x315c, 0x0138, 0x0d80, 0x2514, 0x3da4,
 0x305c, 0x0038, 0x0c80, 0x2414, 0x3ca4,
 0x3060, 0x003c, 0x0c84, 0x2418, 0x3ca8,
 0x3160, 0x013c, 0x0d84, 0x2518, 0x3da8,
 0x3260, 0x023c, 0x0e84, 0x2618, 0x3ea8,
 0x3264, 0x0240, 0x0e88, 0x261c, 0x3eac,
 0x3164, 0x0140, 0x0d88, 0x251c, 0x3dac,
 0x3064, 0x0040, 0x0c88, 0x241c, 0x3cac,
 0x3068, 0x0044, 0x0c8c, 0x2420, 0x3cb0,
 0x3168, 0x0144, 0x0d8c, 0x2520, 0x3db0,
 0x3268, 0x0244, 0x0e8c, 0x2620, 0x3eb0,
 0x3648, 0x0624, 0x126c, 0x2a00, 0x4290,
 0x3748, 0x0724, 0x136c, 0x2b00, 0x4390,
 0x3848, 0x0824, 0x146c, 0x2c00, 0x4490,
 0x384c, 0x0828, 0x1470, 0x2c04, 0x4494,
 0x374c, 0x0728, 0x1370, 0x2b04, 0x4394,
 0x364c, 0x0628, 0x1270, 0x2a04, 0x4294,
 0x3650, 0x062c, 0x1274, 0x2a08, 0x4298,
 0x3750, 0x072c, 0x1374, 0x2b08, 0x4398,
 0x3850, 0x082c, 0x1474, 0x2c08, 0x4498,
 0x3854, 0x0830, 0x1478, 0x2c0c, 0x449c,
 0x3754, 0x0730, 0x1378, 0x2b0c, 0x439c,
 0x3654, 0x0630, 0x1278, 0x2a0c, 0x429c,
 0x3658, 0x0634, 0x127c, 0x2a10, 0x42a0,
 0x3758, 0x0734, 0x137c, 0x2b10, 0x43a0,
 0x3858, 0x0834, 0x147c, 0x2c10, 0x44a0,
 0x385c, 0x0838, 0x1480, 0x2c14, 0x44a4,
 0x375c, 0x0738, 0x1380, 0x2b14, 0x43a4,
 0x365c, 0x0638, 0x1280, 0x2a14, 0x42a4,
 0x3660, 0x063c, 0x1284, 0x2a18, 0x42a8,
 0x3760, 0x073c, 0x1384, 0x2b18, 0x43a8,
 0x3860, 0x083c, 0x1484, 0x2c18, 0x44a8,
 0x3864, 0x0840, 0x1488, 0x2c1c, 0x44ac,
 0x3764, 0x0740, 0x1388, 0x2b1c, 0x43ac,
 0x3664, 0x0640, 0x1288, 0x2a1c, 0x42ac,
 0x3668, 0x0644, 0x128c, 0x2a20, 0x42b0,
 0x3768, 0x0744, 0x138c, 0x2b20, 0x43b0,
 0x3868, 0x0844, 0x148c, 0x2c20, 0x44b0,
 0x3c48, 0x0c24, 0x186c, 0x3000, 0x0090,
 0x3d48, 0x0d24, 0x196c, 0x3100, 0x0190,
 0x3e48, 0x0e24, 0x1a6c, 0x3200, 0x0290,
 0x3e4c, 0x0e28, 0x1a70, 0x3204, 0x0294,
 0x3d4c, 0x0d28, 0x1970, 0x3104, 0x0194,
 0x3c4c, 0x0c28, 0x1870, 0x3004, 0x0094,
 0x3c50, 0x0c2c, 0x1874, 0x3008, 0x0098,
 0x3d50, 0x0d2c, 0x1974, 0x3108, 0x0198,
 0x3e50, 0x0e2c, 0x1a74, 0x3208, 0x0298,
 0x3e54, 0x0e30, 0x1a78, 0x320c, 0x029c,
 0x3d54, 0x0d30, 0x1978, 0x310c, 0x019c,
 0x3c54, 0x0c30, 0x1878, 0x300c, 0x009c,
 0x3c58, 0x0c34, 0x187c, 0x3010, 0x00a0,
 0x3d58, 0x0d34, 0x197c, 0x3110, 0x01a0,
 0x3e58, 0x0e34, 0x1a7c, 0x3210, 0x02a0,
 0x3e5c, 0x0e38, 0x1a80, 0x3214, 0x02a4,
 0x3d5c, 0x0d38, 0x1980, 0x3114, 0x01a4,
 0x3c5c, 0x0c38, 0x1880, 0x3014, 0x00a4,
 0x3c60, 0x0c3c, 0x1884, 0x3018, 0x00a8,
 0x3d60, 0x0d3c, 0x1984, 0x3118, 0x01a8,
 0x3e60, 0x0e3c, 0x1a84, 0x3218, 0x02a8,
 0x3e64, 0x0e40, 0x1a88, 0x321c, 0x02ac,
 0x3d64, 0x0d40, 0x1988, 0x311c, 0x01ac,
 0x3c64, 0x0c40, 0x1888, 0x301c, 0x00ac,
 0x3c68, 0x0c44, 0x188c, 0x3020, 0x00b0,
 0x3d68, 0x0d44, 0x198c, 0x3120, 0x01b0,
 0x3e68, 0x0e44, 0x1a8c, 0x3220, 0x02b0,
 0x4248, 0x1224, 0x1e6c, 0x3600, 0x0690,
 0x4348, 0x1324, 0x1f6c, 0x3700, 0x0790,
 0x4448, 0x1424, 0x206c, 0x3800, 0x0890,
 0x444c, 0x1428, 0x2070, 0x3804, 0x0894,
 0x434c, 0x1328, 0x1f70, 0x3704, 0x0794,
 0x424c, 0x1228, 0x1e70, 0x3604, 0x0694,
 0x4250, 0x122c, 0x1e74, 0x3608, 0x0698,
 0x4350, 0x132c, 0x1f74, 0x3708, 0x0798,
 0x4450, 0x142c, 0x2074, 0x3808, 0x0898,
 0x4454, 0x1430, 0x2078, 0x380c, 0x089c,
 0x4354, 0x1330, 0x1f78, 0x370c, 0x079c,
 0x4254, 0x1230, 0x1e78, 0x360c, 0x069c,
 0x4258, 0x1234, 0x1e7c, 0x3610, 0x06a0,
 0x4358, 0x1334, 0x1f7c, 0x3710, 0x07a0,
 0x4458, 0x1434, 0x207c, 0x3810, 0x08a0,
 0x445c, 0x1438, 0x2080, 0x3814, 0x08a4,
 0x435c, 0x1338, 0x1f80, 0x3714, 0x07a4,
 0x425c, 0x1238, 0x1e80, 0x3614, 0x06a4,
 0x4260, 0x123c, 0x1e84, 0x3618, 0x06a8,
 0x4360, 0x133c, 0x1f84, 0x3718, 0x07a8,
 0x4460, 0x143c, 0x2084, 0x3818, 0x08a8,
 0x4464, 0x1440, 0x2088, 0x381c, 0x08ac,
 0x4364, 0x1340, 0x1f88, 0x371c, 0x07ac,
 0x4264, 0x1240, 0x1e88, 0x361c, 0x06ac,
 0x4268, 0x1244, 0x1e8c, 0x3620, 0x06b0,
 0x4368, 0x1344, 0x1f8c, 0x3720, 0x07b0,
 0x4468, 0x1444, 0x208c, 0x3820, 0x08b0,
 0x0048, 0x1824, 0x246c, 0x3c00, 0x0c90,
 0x0148, 0x1924, 0x256c, 0x3d00, 0x0d90,
 0x0248, 0x1a24, 0x266c, 0x3e00, 0x0e90,
 0x024c, 0x1a28, 0x2670, 0x3e04, 0x0e94,
 0x014c, 0x1928, 0x2570, 0x3d04, 0x0d94,
 0x004c, 0x1828, 0x2470, 0x3c04, 0x0c94,
 0x0050, 0x182c, 0x2474, 0x3c08, 0x0c98,
 0x0150, 0x192c, 0x2574, 0x3d08, 0x0d98,
 0x0250, 0x1a2c, 0x2674, 0x3e08, 0x0e98,
 0x0254, 0x1a30, 0x2678, 0x3e0c, 0x0e9c,
 0x0154, 0x1930, 0x2578, 0x3d0c, 0x0d9c,
 0x0054, 0x1830, 0x2478, 0x3c0c, 0x0c9c,
 0x0058, 0x1834, 0x247c, 0x3c10, 0x0ca0,
 0x0158, 0x1934, 0x257c, 0x3d10, 0x0da0,
 0x0258, 0x1a34, 0x267c, 0x3e10, 0x0ea0,
 0x025c, 0x1a38, 0x2680, 0x3e14, 0x0ea4,
 0x015c, 0x1938, 0x2580, 0x3d14, 0x0da4,
 0x005c, 0x1838, 0x2480, 0x3c14, 0x0ca4,
 0x0060, 0x183c, 0x2484, 0x3c18, 0x0ca8,
 0x0160, 0x193c, 0x2584, 0x3d18, 0x0da8,
 0x0260, 0x1a3c, 0x2684, 0x3e18, 0x0ea8,
 0x0264, 0x1a40, 0x2688, 0x3e1c, 0x0eac,
 0x0164, 0x1940, 0x2588, 0x3d1c, 0x0dac,
 0x0064, 0x1840, 0x2488, 0x3c1c, 0x0cac,
 0x0068, 0x1844, 0x248c, 0x3c20, 0x0cb0,
 0x0168, 0x1944, 0x258c, 0x3d20, 0x0db0,
 0x0268, 0x1a44, 0x268c, 0x3e20, 0x0eb0,
 0x0648, 0x1e24, 0x2a6c, 0x4200, 0x1290,
 0x0748, 0x1f24, 0x2b6c, 0x4300, 0x1390,
 0x0848, 0x2024, 0x2c6c, 0x4400, 0x1490,
 0x084c, 0x2028, 0x2c70, 0x4404, 0x1494,
 0x074c, 0x1f28, 0x2b70, 0x4304, 0x1394,
 0x064c, 0x1e28, 0x2a70, 0x4204, 0x1294,
 0x0650, 0x1e2c, 0x2a74, 0x4208, 0x1298,
 0x0750, 0x1f2c, 0x2b74, 0x4308, 0x1398,
 0x0850, 0x202c, 0x2c74, 0x4408, 0x1498,
 0x0854, 0x2030, 0x2c78, 0x440c, 0x149c,
 0x0754, 0x1f30, 0x2b78, 0x430c, 0x139c,
 0x0654, 0x1e30, 0x2a78, 0x420c, 0x129c,
 0x0658, 0x1e34, 0x2a7c, 0x4210, 0x12a0,
 0x0758, 0x1f34, 0x2b7c, 0x4310, 0x13a0,
 0x0858, 0x2034, 0x2c7c, 0x4410, 0x14a0,
 0x085c, 0x2038, 0x2c80, 0x4414, 0x14a4,
 0x075c, 0x1f38, 0x2b80, 0x4314, 0x13a4,
 0x065c, 0x1e38, 0x2a80, 0x4214, 0x12a4,
 0x0660, 0x1e3c, 0x2a84, 0x4218, 0x12a8,
 0x0760, 0x1f3c, 0x2b84, 0x4318, 0x13a8,
 0x0860, 0x203c, 0x2c84, 0x4418, 0x14a8,
 0x0864, 0x2040, 0x2c88, 0x441c, 0x14ac,
 0x0764, 0x1f40, 0x2b88, 0x431c, 0x13ac,
 0x0664, 0x1e40, 0x2a88, 0x421c, 0x12ac,
 0x0668, 0x1e44, 0x2a8c, 0x4220, 0x12b0,
 0x0768, 0x1f44, 0x2b8c, 0x4320, 0x13b0,
 0x0868, 0x2044, 0x2c8c, 0x4420, 0x14b0,
 0x0f48, 0x2724, 0x336c, 0x0300, 0x1b90,
 0x1048, 0x2824, 0x346c, 0x0400, 0x1c90,
 0x1148, 0x2924, 0x356c, 0x0500, 0x1d90,
 0x114c, 0x2928, 0x3570, 0x0504, 0x1d94,
 0x104c, 0x2828, 0x3470, 0x0404, 0x1c94,
 0x0f4c, 0x2728, 0x3370, 0x0304, 0x1b94,
 0x0f50, 0x272c, 0x3374, 0x0308, 0x1b98,
 0x1050, 0x282c, 0x3474, 0x0408, 0x1c98,
 0x1150, 0x292c, 0x3574, 0x0508, 0x1d98,
 0x1154, 0x2930, 0x3578, 0x050c, 0x1d9c,
 0x1054, 0x2830, 0x3478, 0x040c, 0x1c9c,
 0x0f54, 0x2730, 0x3378, 0x030c, 0x1b9c,
 0x0f58, 0x2734, 0x337c, 0x0310, 0x1ba0,
 0x1058, 0x2834, 0x347c, 0x0410, 0x1ca0,
 0x1158, 0x2934, 0x357c, 0x0510, 0x1da0,
 0x115c, 0x2938, 0x3580, 0x0514, 0x1da4,
 0x105c, 0x2838, 0x3480, 0x0414, 0x1ca4,
 0x0f5c, 0x2738, 0x3380, 0x0314, 0x1ba4,
 0x0f60, 0x273c, 0x3384, 0x0318, 0x1ba8,
 0x1060, 0x283c, 0x3484, 0x0418, 0x1ca8,
 0x1160, 0x293c, 0x3584, 0x0518, 0x1da8,
 0x1164, 0x2940, 0x3588, 0x051c, 0x1dac,
 0x1064, 0x2840, 0x3488, 0x041c, 0x1cac,
 0x0f64, 0x2740, 0x3388, 0x031c, 0x1bac,
 0x0f68, 0x2744, 0x338c, 0x0320, 0x1bb0,
 0x1068, 0x2844, 0x348c, 0x0420, 0x1cb0,
 0x1168, 0x2944, 0x358c, 0x0520, 0x1db0,
 0x1548, 0x2d24, 0x396c, 0x0900, 0x2190,
 0x1648, 0x2e24, 0x3a6c, 0x0a00, 0x2290,
 0x1748, 0x2f24, 0x3b6c, 0x0b00, 0x2390,
 0x174c, 0x2f28, 0x3b70, 0x0b04, 0x2394,
 0x164c, 0x2e28, 0x3a70, 0x0a04, 0x2294,
 0x154c, 0x2d28, 0x3970, 0x0904, 0x2194,
 0x1550, 0x2d2c, 0x3974, 0x0908, 0x2198,
 0x1650, 0x2e2c, 0x3a74, 0x0a08, 0x2298,
 0x1750, 0x2f2c, 0x3b74, 0x0b08, 0x2398,
 0x1754, 0x2f30, 0x3b78, 0x0b0c, 0x239c,
 0x1654, 0x2e30, 0x3a78, 0x0a0c, 0x229c,
 0x1554, 0x2d30, 0x3978, 0x090c, 0x219c,
 0x1558, 0x2d34, 0x397c, 0x0910, 0x21a0,
 0x1658, 0x2e34, 0x3a7c, 0x0a10, 0x22a0,
 0x1758, 0x2f34, 0x3b7c, 0x0b10, 0x23a0,
 0x175c, 0x2f38, 0x3b80, 0x0b14, 0x23a4,
 0x165c, 0x2e38, 0x3a80, 0x0a14, 0x22a4,
 0x155c, 0x2d38, 0x3980, 0x0914, 0x21a4,
 0x1560, 0x2d3c, 0x3984, 0x0918, 0x21a8,
 0x1660, 0x2e3c, 0x3a84, 0x0a18, 0x22a8,
 0x1760, 0x2f3c, 0x3b84, 0x0b18, 0x23a8,
 0x1764, 0x2f40, 0x3b88, 0x0b1c, 0x23ac,
 0x1664, 0x2e40, 0x3a88, 0x0a1c, 0x22ac,
 0x1564, 0x2d40, 0x3988, 0x091c, 0x21ac,
 0x1568, 0x2d44, 0x398c, 0x0920, 0x21b0,
 0x1668, 0x2e44, 0x3a8c, 0x0a20, 0x22b0,
 0x1768, 0x2f44, 0x3b8c, 0x0b20, 0x23b0,
 0x1b48, 0x3324, 0x3f6c, 0x0f00, 0x2790,
 0x1c48, 0x3424, 0x406c, 0x1000, 0x2890,
 0x1d48, 0x3524, 0x416c, 0x1100, 0x2990,
 0x1d4c, 0x3528, 0x4170, 0x1104, 0x2994,
 0x1c4c, 0x3428, 0x4070, 0x1004, 0x2894,
 0x1b4c, 0x3328, 0x3f70, 0x0f04, 0x2794,
 0x1b50, 0x332c, 0x3f74, 0x0f08, 0x2798,
 0x1c50, 0x342c, 0x4074, 0x1008, 0x2898,
 0x1d50, 0x352c, 0x4174, 0x1108, 0x2998,
 0x1d54, 0x3530, 0x4178, 0x110c, 0x299c,
 0x1c54, 0x3430, 0x4078, 0x100c, 0x289c,
 0x1b54, 0x3330, 0x3f78, 0x0f0c, 0x279c,
 0x1b58, 0x3334, 0x3f7c, 0x0f10, 0x27a0,
 0x1c58, 0x3434, 0x407c, 0x1010, 0x28a0,
 0x1d58, 0x3534, 0x417c, 0x1110, 0x29a0,
 0x1d5c, 0x3538, 0x4180, 0x1114, 0x29a4,
 0x1c5c, 0x3438, 0x4080, 0x1014, 0x28a4,
 0x1b5c, 0x3338, 0x3f80, 0x0f14, 0x27a4,
 0x1b60, 0x333c, 0x3f84, 0x0f18, 0x27a8,
 0x1c60, 0x343c, 0x4084, 0x1018, 0x28a8,
 0x1d60, 0x353c, 0x4184, 0x1118, 0x29a8,
 0x1d64, 0x3540, 0x4188, 0x111c, 0x29ac,
 0x1c64, 0x3440, 0x4088, 0x101c, 0x28ac,
 0x1b64, 0x3340, 0x3f88, 0x0f1c, 0x27ac,
 0x1b68, 0x3344, 0x3f8c, 0x0f20, 0x27b0,
 0x1c68, 0x3444, 0x408c, 0x1020, 0x28b0,
 0x1d68, 0x3544, 0x418c, 0x1120, 0x29b0,
 0x2148, 0x3924, 0x456c, 0x1500, 0x2d90,
 0x2248, 0x3a24, 0x466c, 0x1600, 0x2e90,
 0x2348, 0x3b24, 0x476c, 0x1700, 0x2f90,
 0x234c, 0x3b28, 0x4770, 0x1704, 0x2f94,
 0x224c, 0x3a28, 0x4670, 0x1604, 0x2e94,
 0x214c, 0x3928, 0x4570, 0x1504, 0x2d94,
 0x2150, 0x392c, 0x4574, 0x1508, 0x2d98,
 0x2250, 0x3a2c, 0x4674, 0x1608, 0x2e98,
 0x2350, 0x3b2c, 0x4774, 0x1708, 0x2f98,
 0x2354, 0x3b30, 0x4778, 0x170c, 0x2f9c,
 0x2254, 0x3a30, 0x4678, 0x160c, 0x2e9c,
 0x2154, 0x3930, 0x4578, 0x150c, 0x2d9c,
 0x2158, 0x3934, 0x457c, 0x1510, 0x2da0,
 0x2258, 0x3a34, 0x467c, 0x1610, 0x2ea0,
 0x2358, 0x3b34, 0x477c, 0x1710, 0x2fa0,
 0x235c, 0x3b38, 0x4780, 0x1714, 0x2fa4,
 0x225c, 0x3a38, 0x4680, 0x1614, 0x2ea4,
 0x215c, 0x3938, 0x4580, 0x1514, 0x2da4,
 0x2160, 0x393c, 0x4584, 0x1518, 0x2da8,
 0x2260, 0x3a3c, 0x4684, 0x1618, 0x2ea8,
 0x2360, 0x3b3c, 0x4784, 0x1718, 0x2fa8,
 0x2364, 0x3b40, 0x4788, 0x171c, 0x2fac,
 0x2264, 0x3a40, 0x4688, 0x161c, 0x2eac,
 0x2164, 0x3940, 0x4588, 0x151c, 0x2dac,
 0x2168, 0x3944, 0x458c, 0x1520, 0x2db0,
 0x2268, 0x3a44, 0x468c, 0x1620, 0x2eb0,
 0x2368, 0x3b44, 0x478c, 0x1720, 0x2fb0,
 0x2748, 0x3f24, 0x036c, 0x1b00, 0x3390,
 0x2848, 0x4024, 0x046c, 0x1c00, 0x3490,
 0x2948, 0x4124, 0x056c, 0x1d00, 0x3590,
 0x294c, 0x4128, 0x0570, 0x1d04, 0x3594,
 0x284c, 0x4028, 0x0470, 0x1c04, 0x3494,
 0x274c, 0x3f28, 0x0370, 0x1b04, 0x3394,
 0x2750, 0x3f2c, 0x0374, 0x1b08, 0x3398,
 0x2850, 0x402c, 0x0474, 0x1c08, 0x3498,
 0x2950, 0x412c, 0x0574, 0x1d08, 0x3598,
 0x2954, 0x4130, 0x0578, 0x1d0c, 0x359c,
 0x2854, 0x4030, 0x0478, 0x1c0c, 0x349c,
 0x2754, 0x3f30, 0x0378, 0x1b0c, 0x339c,
 0x2758, 0x3f34, 0x037c, 0x1b10, 0x33a0,
 0x2858, 0x4034, 0x047c, 0x1c10, 0x34a0,
 0x2958, 0x4134, 0x057c, 0x1d10, 0x35a0,
 0x295c, 0x4138, 0x0580, 0x1d14, 0x35a4,
 0x285c, 0x4038, 0x0480, 0x1c14, 0x34a4,
 0x275c, 0x3f38, 0x0380, 0x1b14, 0x33a4,
 0x2760, 0x3f3c, 0x0384, 0x1b18, 0x33a8,
 0x2860, 0x403c, 0x0484, 0x1c18, 0x34a8,
 0x2960, 0x413c, 0x0584, 0x1d18, 0x35a8,
 0x2964, 0x4140, 0x0588, 0x1d1c, 0x35ac,
 0x2864, 0x4040, 0x0488, 0x1c1c, 0x34ac,
 0x2764, 0x3f40, 0x0388, 0x1b1c, 0x33ac,
 0x2768, 0x3f44, 0x038c, 0x1b20, 0x33b0,
 0x2868, 0x4044, 0x048c, 0x1c20, 0x34b0,
 0x2968, 0x4144, 0x058c, 0x1d20, 0x35b0,
 0x2d48, 0x4524, 0x096c, 0x2100, 0x3990,
 0x2e48, 0x4624, 0x0a6c, 0x2200, 0x3a90,
 0x2f48, 0x4724, 0x0b6c, 0x2300, 0x3b90,
 0x2f4c, 0x4728, 0x0b70, 0x2304, 0x3b94,
 0x2e4c, 0x4628, 0x0a70, 0x2204, 0x3a94,
 0x2d4c, 0x4528, 0x0970, 0x2104, 0x3994,
 0x2d50, 0x452c, 0x0974, 0x2108, 0x3998,
 0x2e50, 0x462c, 0x0a74, 0x2208, 0x3a98,
 0x2f50, 0x472c, 0x0b74, 0x2308, 0x3b98,
 0x2f54, 0x4730, 0x0b78, 0x230c, 0x3b9c,
 0x2e54, 0x4630, 0x0a78, 0x220c, 0x3a9c,
 0x2d54, 0x4530, 0x0978, 0x210c, 0x399c,
 0x2d58, 0x4534, 0x097c, 0x2110, 0x39a0,
 0x2e58, 0x4634, 0x0a7c, 0x2210, 0x3aa0,
 0x2f58, 0x4734, 0x0b7c, 0x2310, 0x3ba0,
 0x2f5c, 0x4738, 0x0b80, 0x2314, 0x3ba4,
 0x2e5c, 0x4638, 0x0a80, 0x2214, 0x3aa4,
 0x2d5c, 0x4538, 0x0980, 0x2114, 0x39a4,
 0x2d60, 0x453c, 0x0984, 0x2118, 0x39a8,
 0x2e60, 0x463c, 0x0a84, 0x2218, 0x3aa8,
 0x2f60, 0x473c, 0x0b84, 0x2318, 0x3ba8,
 0x2f64, 0x4740, 0x0b88, 0x231c, 0x3bac,
 0x2e64, 0x4640, 0x0a88, 0x221c, 0x3aac,
 0x2d64, 0x4540, 0x0988, 0x211c, 0x39ac,
 0x2d68, 0x4544, 0x098c, 0x2120, 0x39b0,
 0x2e68, 0x4644, 0x0a8c, 0x2220, 0x3ab0,
 0x2f68, 0x4744, 0x0b8c, 0x2320, 0x3bb0,
 0x3348, 0x0324, 0x0f6c, 0x2700, 0x3f90,
 0x3448, 0x0424, 0x106c, 0x2800, 0x4090,
 0x3548, 0x0524, 0x116c, 0x2900, 0x4190,
 0x354c, 0x0528, 0x1170, 0x2904, 0x4194,
 0x344c, 0x0428, 0x1070, 0x2804, 0x4094,
 0x334c, 0x0328, 0x0f70, 0x2704, 0x3f94,
 0x3350, 0x032c, 0x0f74, 0x2708, 0x3f98,
 0x3450, 0x042c, 0x1074, 0x2808, 0x4098,
 0x3550, 0x052c, 0x1174, 0x2908, 0x4198,
 0x3554, 0x0530, 0x1178, 0x290c, 0x419c,
 0x3454, 0x0430, 0x1078, 0x280c, 0x409c,
 0x3354, 0x0330, 0x0f78, 0x270c, 0x3f9c,
 0x3358, 0x0334, 0x0f7c, 0x2710, 0x3fa0,
 0x3458, 0x0434, 0x107c, 0x2810, 0x40a0,
 0x3558, 0x0534, 0x117c, 0x2910, 0x41a0,
 0x355c, 0x0538, 0x1180, 0x2914, 0x41a4,
 0x345c, 0x0438, 0x1080, 0x2814, 0x40a4,
 0x335c, 0x0338, 0x0f80, 0x2714, 0x3fa4,
 0x3360, 0x033c, 0x0f84, 0x2718, 0x3fa8,
 0x3460, 0x043c, 0x1084, 0x2818, 0x40a8,
 0x3560, 0x053c, 0x1184, 0x2918, 0x41a8,
 0x3564, 0x0540, 0x1188, 0x291c, 0x41ac,
 0x3464, 0x0440, 0x1088, 0x281c, 0x40ac,
 0x3364, 0x0340, 0x0f88, 0x271c, 0x3fac,
 0x3368, 0x0344, 0x0f8c, 0x2720, 0x3fb0,
 0x3468, 0x0444, 0x108c, 0x2820, 0x40b0,
 0x3568, 0x0544, 0x118c, 0x2920, 0x41b0,
 0x3948, 0x0924, 0x156c, 0x2d00, 0x4590,
 0x3a48, 0x0a24, 0x166c, 0x2e00, 0x4690,
 0x3b48, 0x0b24, 0x176c, 0x2f00, 0x4790,
 0x3b4c, 0x0b28, 0x1770, 0x2f04, 0x4794,
 0x3a4c, 0x0a28, 0x1670, 0x2e04, 0x4694,
 0x394c, 0x0928, 0x1570, 0x2d04, 0x4594,
 0x3950, 0x092c, 0x1574, 0x2d08, 0x4598,
 0x3a50, 0x0a2c, 0x1674, 0x2e08, 0x4698,
 0x3b50, 0x0b2c, 0x1774, 0x2f08, 0x4798,
 0x3b54, 0x0b30, 0x1778, 0x2f0c, 0x479c,
 0x3a54, 0x0a30, 0x1678, 0x2e0c, 0x469c,
 0x3954, 0x0930, 0x1578, 0x2d0c, 0x459c,
 0x3958, 0x0934, 0x157c, 0x2d10, 0x45a0,
 0x3a58, 0x0a34, 0x167c, 0x2e10, 0x46a0,
 0x3b58, 0x0b34, 0x177c, 0x2f10, 0x47a0,
 0x3b5c, 0x0b38, 0x1780, 0x2f14, 0x47a4,
 0x3a5c, 0x0a38, 0x1680, 0x2e14, 0x46a4,
 0x395c, 0x0938, 0x1580, 0x2d14, 0x45a4,
 0x3960, 0x093c, 0x1584, 0x2d18, 0x45a8,
 0x3a60, 0x0a3c, 0x1684, 0x2e18, 0x46a8,
 0x3b60, 0x0b3c, 0x1784, 0x2f18, 0x47a8,
 0x3b64, 0x0b40, 0x1788, 0x2f1c, 0x47ac,
 0x3a64, 0x0a40, 0x1688, 0x2e1c, 0x46ac,
 0x3964, 0x0940, 0x1588, 0x2d1c, 0x45ac,
 0x3968, 0x0944, 0x158c, 0x2d20, 0x45b0,
 0x3a68, 0x0a44, 0x168c, 0x2e20, 0x46b0,
 0x3b68, 0x0b44, 0x178c, 0x2f20, 0x47b0,
 0x3f48, 0x0f24, 0x1b6c, 0x3300, 0x0390,
 0x4048, 0x1024, 0x1c6c, 0x3400, 0x0490,
 0x4148, 0x1124, 0x1d6c, 0x3500, 0x0590,
 0x414c, 0x1128, 0x1d70, 0x3504, 0x0594,
 0x404c, 0x1028, 0x1c70, 0x3404, 0x0494,
 0x3f4c, 0x0f28, 0x1b70, 0x3304, 0x0394,
 0x3f50, 0x0f2c, 0x1b74, 0x3308, 0x0398,
 0x4050, 0x102c, 0x1c74, 0x3408, 0x0498,
 0x4150, 0x112c, 0x1d74, 0x3508, 0x0598,
 0x4154, 0x1130, 0x1d78, 0x350c, 0x059c,
 0x4054, 0x1030, 0x1c78, 0x340c, 0x049c,
 0x3f54, 0x0f30, 0x1b78, 0x330c, 0x039c,
 0x3f58, 0x0f34, 0x1b7c, 0x3310, 0x03a0,
 0x4058, 0x1034, 0x1c7c, 0x3410, 0x04a0,
 0x4158, 0x1134, 0x1d7c, 0x3510, 0x05a0,
 0x415c, 0x1138, 0x1d80, 0x3514, 0x05a4,
 0x405c, 0x1038, 0x1c80, 0x3414, 0x04a4,
 0x3f5c, 0x0f38, 0x1b80, 0x3314, 0x03a4,
 0x3f60, 0x0f3c, 0x1b84, 0x3318, 0x03a8,
 0x4060, 0x103c, 0x1c84, 0x3418, 0x04a8,
 0x4160, 0x113c, 0x1d84, 0x3518, 0x05a8,
 0x4164, 0x1140, 0x1d88, 0x351c, 0x05ac,
 0x4064, 0x1040, 0x1c88, 0x341c, 0x04ac,
 0x3f64, 0x0f40, 0x1b88, 0x331c, 0x03ac,
 0x3f68, 0x0f44, 0x1b8c, 0x3320, 0x03b0,
 0x4068, 0x1044, 0x1c8c, 0x3420, 0x04b0,
 0x4168, 0x1144, 0x1d8c, 0x3520, 0x05b0,
 0x4548, 0x1524, 0x216c, 0x3900, 0x0990,
 0x4648, 0x1624, 0x226c, 0x3a00, 0x0a90,
 0x4748, 0x1724, 0x236c, 0x3b00, 0x0b90,
 0x474c, 0x1728, 0x2370, 0x3b04, 0x0b94,
 0x464c, 0x1628, 0x2270, 0x3a04, 0x0a94,
 0x454c, 0x1528, 0x2170, 0x3904, 0x0994,
 0x4550, 0x152c, 0x2174, 0x3908, 0x0998,
 0x4650, 0x162c, 0x2274, 0x3a08, 0x0a98,
 0x4750, 0x172c, 0x2374, 0x3b08, 0x0b98,
 0x4754, 0x1730, 0x2378, 0x3b0c, 0x0b9c,
 0x4654, 0x1630, 0x2278, 0x3a0c, 0x0a9c,
 0x4554, 0x1530, 0x2178, 0x390c, 0x099c,
 0x4558, 0x1534, 0x217c, 0x3910, 0x09a0,
 0x4658, 0x1634, 0x227c, 0x3a10, 0x0aa0,
 0x4758, 0x1734, 0x237c, 0x3b10, 0x0ba0,
 0x475c, 0x1738, 0x2380, 0x3b14, 0x0ba4,
 0x465c, 0x1638, 0x2280, 0x3a14, 0x0aa4,
 0x455c, 0x1538, 0x2180, 0x3914, 0x09a4,
 0x4560, 0x153c, 0x2184, 0x3918, 0x09a8,
 0x4660, 0x163c, 0x2284, 0x3a18, 0x0aa8,
 0x4760, 0x173c, 0x2384, 0x3b18, 0x0ba8,
 0x4764, 0x1740, 0x2388, 0x3b1c, 0x0bac,
 0x4664, 0x1640, 0x2288, 0x3a1c, 0x0aac,
 0x4564, 0x1540, 0x2188, 0x391c, 0x09ac,
 0x4568, 0x1544, 0x218c, 0x3920, 0x09b0,
 0x4668, 0x1644, 0x228c, 0x3a20, 0x0ab0,
 0x4768, 0x1744, 0x238c, 0x3b20, 0x0bb0,
 0x0348, 0x1b24, 0x276c, 0x3f00, 0x0f90,
 0x0448, 0x1c24, 0x286c, 0x4000, 0x1090,
 0x0548, 0x1d24, 0x296c, 0x4100, 0x1190,
 0x054c, 0x1d28, 0x2970, 0x4104, 0x1194,
 0x044c, 0x1c28, 0x2870, 0x4004, 0x1094,
 0x034c, 0x1b28, 0x2770, 0x3f04, 0x0f94,
 0x0350, 0x1b2c, 0x2774, 0x3f08, 0x0f98,
 0x0450, 0x1c2c, 0x2874, 0x4008, 0x1098,
 0x0550, 0x1d2c, 0x2974, 0x4108, 0x1198,
 0x0554, 0x1d30, 0x2978, 0x410c, 0x119c,
 0x0454, 0x1c30, 0x2878, 0x400c, 0x109c,
 0x0354, 0x1b30, 0x2778, 0x3f0c, 0x0f9c,
 0x0358, 0x1b34, 0x277c, 0x3f10, 0x0fa0,
 0x0458, 0x1c34, 0x287c, 0x4010, 0x10a0,
 0x0558, 0x1d34, 0x297c, 0x4110, 0x11a0,
 0x055c, 0x1d38, 0x2980, 0x4114, 0x11a4,
 0x045c, 0x1c38, 0x2880, 0x4014, 0x10a4,
 0x035c, 0x1b38, 0x2780, 0x3f14, 0x0fa4,
 0x0360, 0x1b3c, 0x2784, 0x3f18, 0x0fa8,
 0x0460, 0x1c3c, 0x2884, 0x4018, 0x10a8,
 0x0560, 0x1d3c, 0x2984, 0x4118, 0x11a8,
 0x0564, 0x1d40, 0x2988, 0x411c, 0x11ac,
 0x0464, 0x1c40, 0x2888, 0x401c, 0x10ac,
 0x0364, 0x1b40, 0x2788, 0x3f1c, 0x0fac,
 0x0368, 0x1b44, 0x278c, 0x3f20, 0x0fb0,
 0x0468, 0x1c44, 0x288c, 0x4020, 0x10b0,
 0x0568, 0x1d44, 0x298c, 0x4120, 0x11b0,
 0x0948, 0x2124, 0x2d6c, 0x4500, 0x1590,
 0x0a48, 0x2224, 0x2e6c, 0x4600, 0x1690,
 0x0b48, 0x2324, 0x2f6c, 0x4700, 0x1790,
 0x0b4c, 0x2328, 0x2f70, 0x4704, 0x1794,
 0x0a4c, 0x2228, 0x2e70, 0x4604, 0x1694,
 0x094c, 0x2128, 0x2d70, 0x4504, 0x1594,
 0x0950, 0x212c, 0x2d74, 0x4508, 0x1598,
 0x0a50, 0x222c, 0x2e74, 0x4608, 0x1698,
 0x0b50, 0x232c, 0x2f74, 0x4708, 0x1798,
 0x0b54, 0x2330, 0x2f78, 0x470c, 0x179c,
 0x0a54, 0x2230, 0x2e78, 0x460c, 0x169c,
 0x0954, 0x2130, 0x2d78, 0x450c, 0x159c,
 0x0958, 0x2134, 0x2d7c, 0x4510, 0x15a0,
 0x0a58, 0x2234, 0x2e7c, 0x4610, 0x16a0,
 0x0b58, 0x2334, 0x2f7c, 0x4710, 0x17a0,
 0x0b5c, 0x2338, 0x2f80, 0x4714, 0x17a4,
 0x0a5c, 0x2238, 0x2e80, 0x4614, 0x16a4,
 0x095c, 0x2138, 0x2d80, 0x4514, 0x15a4,
 0x0960, 0x213c, 0x2d84, 0x4518, 0x15a8,
 0x0a60, 0x223c, 0x2e84, 0x4618, 0x16a8,
 0x0b60, 0x233c, 0x2f84, 0x4718, 0x17a8,
 0x0b64, 0x2340, 0x2f88, 0x471c, 0x17ac,
 0x0a64, 0x2240, 0x2e88, 0x461c, 0x16ac,
 0x0964, 0x2140, 0x2d88, 0x451c, 0x15ac,
 0x0968, 0x2144, 0x2d8c, 0x4520, 0x15b0,
 0x0a68, 0x2244, 0x2e8c, 0x4620, 0x16b0,
 0x0b68, 0x2344, 0x2f8c, 0x4720, 0x17b0,

################################################################################

TITLE
    libavcodec DV dv_weight_88

TYPE
    32

DATA
 131072, 257107, 257107, 242189, 252167, 242189, 235923, 237536,
 237536, 235923, 229376, 231390, 223754, 231390, 229376, 222935,
 224969, 217965, 217965, 224969, 222935, 200636, 218652, 211916,
 212325, 211916, 218652, 200636, 188995, 196781, 205965, 206433,
 206433, 205965, 196781, 188995, 185364, 185364, 200636, 200704,
 200636, 185364, 185364, 174609, 180568, 195068, 195068, 180568,
 174609, 170091, 175557, 189591, 175557, 170091, 165371, 170627,
 170627, 165371, 160727, 153560, 160727, 144651, 144651, 136258,

################################################################################

TITLE
    libavcodec DV dv_weight_248

TYPE
    32

DATA
 131072, 242189, 257107, 237536, 229376, 200636, 242189, 223754,
 224969, 196781, 262144, 242189, 229376, 200636, 257107, 237536,
 211916, 185364, 235923, 217965, 229376, 211916, 206433, 180568,
 242189, 223754, 224969, 196781, 211916, 185364, 235923, 217965,
 200704, 175557, 222935, 205965, 200636, 185364, 195068, 170627,
 229376, 211916, 206433, 180568, 200704, 175557, 222935, 205965,
 175557, 153560, 188995, 174609, 165371, 144651, 200636, 185364,
 195068, 170627, 175557, 153560, 188995, 174609, 165371, 144651,

################################################################################

TITLE
    libavcodec DV dv_iweight_88

TYPE
    32

DATA
 32768, 16710, 16710, 17735, 17015, 17735, 18197, 18079,
 18079, 18197, 18725, 18559, 19196, 18559, 18725, 19284,
 19108, 19692, 19692, 19108, 19284, 21400, 19645, 20262,
 20214, 20262, 19645, 21400, 22733, 21845, 20867, 20815,
 20815, 20867, 21845, 22733, 23173, 23173, 21400, 21400,
 21400, 23173, 23173, 24600, 23764, 22017, 22017, 23764,
 24600, 25267, 24457, 22672, 24457, 25267, 25971, 25191,
 25191, 25971, 26715, 27962, 26715, 29642, 29642, 31536,

################################################################################

TITLE
    libavcodec DV dv_iweight_248

TYPE
    32

DATA
 32768, 17735, 16710, 18079, 18725, 21400, 17735, 19196,
 19108, 21845, 16384, 17735, 18725, 21400, 16710, 18079,
 20262, 23173, 18197, 19692, 18725, 20262, 20815, 23764,
 17735, 19196, 19108, 21845, 20262, 23173, 18197, 19692,
 21400, 24457, 19284, 20867, 21400, 23173, 22017, 25191,
 18725, 20262, 20815, 23764, 21400, 24457, 19284, 20867,
 24457, 27962, 22733, 24600, 25971, 29642, 21400, 23173,
 22017, 25191, 24457, 27962, 22733, 24600, 25971, 29642,

################################################################################

TITLE
    libavcodec DV dv_audio_shuffle525

TYPE
    8 16

DATA
  {  0, 30, 60, 20, 50, 80, 10, 40, 70 }, /* 1st channel */
  {  6, 36, 66, 26, 56, 86, 16, 46, 76 },
  { 12, 42, 72,  2, 32, 62, 22, 52, 82 },
  { 18, 48, 78,  8, 38, 68, 28, 58, 88 },
  { 24, 54, 84, 14, 44, 74,  4, 34, 64 },

  {  1, 31, 61, 21, 51, 81, 11, 41, 71 }, /* 2nd channel */
  {  7, 37, 67, 27, 57, 87, 17, 47, 77 },
  { 13, 43, 73,  3, 33, 63, 23, 53, 83 },
  { 19, 49, 79,  9, 39, 69, 29, 59, 89 },
  { 25, 55, 85, 15, 45, 75,  5, 35, 65 },

################################################################################

TITLE
    libavcodec DV dv_audio_shuffle625

TYPE
    8 16

DATA
  {   0,  36,  72,  26,  62,  98,  16,  52,  88}, /* 1st channel */
  {   6,  42,  78,  32,  68, 104,  22,  58,  94},
  {  12,  48,  84,   2,  38,  74,  28,  64, 100},
  {  18,  54,  90,   8,  44,  80,  34,  70, 106},
  {  24,  60,  96,  14,  50,  86,   4,  40,  76},
  {  30,  66, 102,  20,  56,  92,  10,  46,  82},

  {   1,  37,  73,  27,  63,  99,  17,  53,  89}, /* 2nd channel */
  {   7,  43,  79,  33,  69, 105,  23,  59,  95},
  {  13,  49,  85,   3,  39,  75,  29,  65, 101},
  {  19,  55,  91,   9,  45,  81,  35,  71, 107},
  {  25,  61,  97,  15,  51,  87,   5,  41,  77},
  {  31,  67, 103,  21,  57,  93,  11,  47,  83},

################################################################################

TITLE
    libavcodec ASF asf_header

TYPE
    8 HEX

DATA
    30 26 b2 75 8e 66 cf 11 a6 d9 00 aa 00 62 ce 6c

################################################################################

TITLE
    libavcodec DV muxer/demuxer dv_aaux_packs_dist

TYPE
    32

DATA
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },

################################################################################

TITLE
    libavutil ff_sqrt_tab

TYPE
    8

DATA
        0, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5,
        5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
        9, 9, 9, 9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11

################################################################################

TITLE
    Generic bitmask table

TYPE
    32

DATA
    0x0, 0x1, 0x3, 0x7, 0xF, 0x1F, 0x3F, 0x7F, 0xFF, 0x1FF,
    0x3FF, 0x7FF, 0xFFF, 0x1FFF, 0x3FFF, 0x7FFF, 0xFFFF,
    0x1FFFF, 0x3FFFF, 0x7FFFF, 0xFFFFF, 0x1FFFFF, 0x3FFFFF,
    0x7FFFFF, 0xFFFFFF, 0x1FFFFFF, 0x3FFFFFF, 0x7FFFFFF,
    0xFFFFFFF, 0x1FFFFFFF, 0x3FFFFFFF, 0x7FFFFFFF

################################################################################

TITLE
    libfaad2 cfft_tab_512

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.999924719333649, 0.012271538376808 },
    { 0.999698817729950, 0.024541229009628 },
    { 0.999322354793549, 0.036807224154472 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.998118102550507, 0.061320740729570 },
    { 0.997290432453156, 0.073564566671848 },
    { 0.996312618255615, 0.085797317326069 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.993906974792480, 0.110222205519676 },
    { 0.992479562759399, 0.122410677373409 },
    { 0.990902662277222, 0.134580716490746 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.987301409244537, 0.158858150243759 },
    { 0.985277652740479, 0.170961901545525 },
    { 0.983105480670929, 0.183039888739586 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.978317379951477, 0.207111388444901 },
    { 0.975702106952667, 0.219101235270500 },
    { 0.972939968109131, 0.231058120727539 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.966976463794708, 0.254865676164627 },
    { 0.963776051998138, 0.266712784767151 },
    { 0.960430502891541, 0.278519690036774 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.953306019306183, 0.302005946636200 },
    { 0.949528157711029, 0.313681751489639 },
    { 0.945607304573059, 0.325310319662094 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.937339007854462, 0.348418682813644 },
    { 0.932992815971375, 0.359895050525665 },
    { 0.928506076335907, 0.371317207813263 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.919113874435425, 0.393992066383362 },
    { 0.914209723472595, 0.405241340398788 },
    { 0.909167945384979, 0.416429579257965 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.898674488067627, 0.438616245985031 },
    { 0.893224298954010, 0.449611335992813 },
    { 0.887639641761780, 0.460538715124130 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.876070082187653, 0.482183754444122 },
    { 0.870086967945099, 0.492898225784302 },
    { 0.863972842693329, 0.503538370132446 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.851355195045471, 0.524589717388153 },
    { 0.844853579998016, 0.534997642040253 },
    { 0.838224709033966, 0.545324981212616 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.824589252471924, 0.565731823444366 },
    { 0.817584812641144, 0.575808227062225 },
    { 0.810457170009613, 0.585797905921936 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.795836925506592, 0.605511009693146 },
    { 0.788346409797668, 0.615231633186340 },
    { 0.780737221240997, 0.624859511852264 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.765167236328125, 0.643831551074982 },
    { 0.757208824157715, 0.653172850608826 },
    { 0.749136388301849, 0.662415802478790 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.732654273509979, 0.680601000785828 },
    { 0.724247097969055, 0.689540565013886 },
    { 0.715730786323547, 0.698376297950745 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.698376238346100, 0.715730845928192 },
    { 0.689540505409241, 0.724247097969055 },
    { 0.680601000785828, 0.732654273509979 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.662415742874146, 0.749136388301849 },
    { 0.653172791004181, 0.757208883762360 },
    { 0.643831551074982, 0.765167295932770 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.624859452247620, 0.780737280845642 },
    { 0.615231573581696, 0.788346409797668 },
    { 0.605511009693146, 0.795836925506592 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.585797846317291, 0.810457170009613 },
    { 0.575808167457581, 0.817584812641144 },
    { 0.565731823444366, 0.824589312076569 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.545324981212616, 0.838224709033966 },
    { 0.534997642040253, 0.844853579998016 },
    { 0.524589657783508, 0.851355195045471 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.503538429737091, 0.863972842693329 },
    { 0.492898195981979, 0.870086967945099 },
    { 0.482183724641800, 0.876070141792297 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.460538715124130, 0.887639641761780 },
    { 0.449611306190491, 0.893224298954010 },
    { 0.438616186380386, 0.898674488067627 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.416429549455643, 0.909168004989624 },
    { 0.405241280794144, 0.914209783077240 },
    { 0.393991947174072, 0.919113874435425 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.371317148208618, 0.928506076335907 },
    { 0.359894961118698, 0.932992815971375 },
    { 0.348418682813644, 0.937339007854462 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.325310230255127, 0.945607364177704 },
    { 0.313681662082672, 0.949528217315674 },
    { 0.302005946636200, 0.953306019306183 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.278519600629807, 0.960430562496185 },
    { 0.266712754964828, 0.963776051998138 },
    { 0.254865646362305, 0.966976463794708 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.231058135628700, 0.972939968109131 },
    { 0.219101220369339, 0.975702106952667 },
    { 0.207111328840256, 0.978317379951477 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.183039888739586, 0.983105480670929 },
    { 0.170961856842041, 0.985277652740479 },
    { 0.158858075737953, 0.987301409244537 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.134580686688423, 0.990902662277222 },
    { 0.122410625219345, 0.992479562759399 },
    { 0.110222116112709, 0.993906974792480 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.085797272622585, 0.996312618255615 },
    { 0.073564492166042, 0.997290432453156 },
    { 0.061320748180151, 0.998118102550507 },
    { 0.049067649990320, 0.998795449733734 },
    { 0.036807164549828, 0.999322414398193 },
    { 0.024541135877371, 0.999698817729950 },
    { 0.012271529063582, 0.999924719333649 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.012271616607904, 0.999924719333649 },
    { -0.024541223421693, 0.999698817729950 },
    { -0.036807250231504, 0.999322354793549 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.061320833861828, 0.998118102550507 },
    { -0.073564574122429, 0.997290432453156 },
    { -0.085797362029552, 0.996312618255615 },
    { -0.098017223179340, 0.995184719562531 },
    { -0.110222205519676, 0.993906974792480 },
    { -0.122410707175732, 0.992479503154755 },
    { -0.134580776095390, 0.990902602672577 },
    { -0.146730571985245, 0.989176511764526 },
    { -0.158858165144920, 0.987301409244537 },
    { -0.170961946249008, 0.985277652740479 },
    { -0.183039978146553, 0.983105480670929 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.207111418247223, 0.978317379951477 },
    { -0.219101309776306, 0.975702106952667 },
    { -0.231058210134506, 0.972939908504486 },
    { -0.242980197072029, 0.970031261444092 },
    { -0.254865705966949, 0.966976463794708 },
    { -0.266712844371796, 0.963776051998138 },
    { -0.278519690036774, 0.960430502891541 },
    { -0.290284723043442, 0.956940293312073 },
    { -0.302006036043167, 0.953306019306183 },
    { -0.313681721687317, 0.949528157711029 },
    { -0.325310319662094, 0.945607304573059 },
    { -0.336889922618866, 0.941544055938721 },
    { -0.348418772220612, 0.937338948249817 },
    { -0.359895050525665, 0.932992815971375 },
    { -0.371317237615585, 0.928506076335907 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.393992036581039, 0.919113874435425 },
    { -0.405241340398788, 0.914209723472595 },
    { -0.416429519653320, 0.909168004989624 },
    { -0.427555084228516, 0.903989315032959 },
    { -0.438616245985031, 0.898674428462982 },
    { -0.449611365795136, 0.893224298954010 },
    { -0.460538804531097, 0.887639582157135 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.482183903455734, 0.876070022583008 },
    { -0.492898166179657, 0.870087027549744 },
    { -0.503538370132446, 0.863972842693329 },
    { -0.514102756977081, 0.857728600502014 },
    { -0.524589717388153, 0.851355135440826 },
    { -0.534997701644897, 0.844853520393372 },
    { -0.545325100421906, 0.838224649429321 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.565731763839722, 0.824589312076569 },
    { -0.575808167457581, 0.817584812641144 },
    { -0.585797905921936, 0.810457170009613 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.605511128902435, 0.795836865901947 },
    { -0.615231692790985, 0.788346350193024 },
    { -0.624859631061554, 0.780737102031708 },
    { -0.634393274784088, 0.773010492324829 },
    { -0.643831551074982, 0.765167236328125 },
    { -0.653172850608826, 0.757208824157715 },
    { -0.662415802478790, 0.749136328697205 },
    { -0.671559035778046, 0.740951061248779 },
    { -0.680601119995117, 0.732654154300690 },
    { -0.689540684223175, 0.724246978759766 },
    { -0.698376238346100, 0.715730845928192 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.715730845928192, 0.698376238346100 },
    { -0.724247157573700, 0.689540505409241 },
    { -0.732654333114624, 0.680600941181183 },
    { -0.740951240062714, 0.671558856964111 },
    { -0.749136507511139, 0.662415623664856 },
    { -0.757208824157715, 0.653172850608826 },
    { -0.765167295932770, 0.643831551074982 },
    { -0.773010492324829, 0.634393274784088 },
    { -0.780737280845642, 0.624859452247620 },
    { -0.788346469402313, 0.615231513977051 },
    { -0.795836985111237, 0.605510950088501 },
    { -0.803207635879517, 0.595699131488800 },
    { -0.810457170009613, 0.585797846317291 },
    { -0.817584812641144, 0.575808167457581 },
    { -0.824589312076569, 0.565731763839722 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.838224768638611, 0.545324862003326 },
    { -0.844853639602661, 0.534997463226318 },
    { -0.851355314254761, 0.524589538574219 },
    { -0.857728600502014, 0.514102756977081 },
    { -0.863972842693329, 0.503538370132446 },
    { -0.870087027549744, 0.492898136377335 },
    { -0.876070141792297, 0.482183694839478 },
    { -0.881921350955963, 0.471396625041962 },
    { -0.887639701366425, 0.460538566112518 },
    { -0.893224298954010, 0.449611365795136 },
    { -0.898674488067627, 0.438616245985031 },
    { -0.903989315032959, 0.427555054426193 },
    { -0.909168004989624, 0.416429489850998 },
    { -0.914209783077240, 0.405241221189499 },
    { -0.919113874435425, 0.393991917371750 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.928506076335907, 0.371317237615585 },
    { -0.932992815971375, 0.359895050525665 },
    { -0.937339007854462, 0.348418653011322 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.945607364177704, 0.325310200452805 },
    { -0.949528217315674, 0.313681602478027 },
    { -0.953306078910828, 0.302005797624588 },
    { -0.956940352916718, 0.290284723043442 },
    { -0.960430502891541, 0.278519690036774 },
    { -0.963776051998138, 0.266712725162506 },
    { -0.966976463794708, 0.254865586757660 },
    { -0.970031261444092, 0.242980077862740 },
    { -0.972939968109131, 0.231057971715927 },
    { -0.975702166557312, 0.219101071357727 },
    { -0.978317379951477, 0.207111403346062 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.983105480670929, 0.183039844036102 },
    { -0.985277652740479, 0.170961812138557 },
    { -0.987301409244537, 0.158858031034470 },
    { -0.989176511764526, 0.146730333566666 },
    { -0.990902662277222, 0.134580522775650 },
    { -0.992479503154755, 0.122410699725151 },
    { -0.993906974792480, 0.110222198069096 },
    { -0.995184719562531, 0.098017096519470 },
    { -0.996312618255615, 0.085797227919102 },
    { -0.997290492057800, 0.073564447462559 },
    { -0.998118102550507, 0.061320584267378 },
    { -0.998795449733734, 0.049067486077547 },
    { -0.999322354793549, 0.036807239055634 },
    { -0.999698817729950, 0.024541210383177 },
    { -0.999924719333649, 0.012271485291421 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.999698817729950, 0.024541229009628 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.997290432453156, 0.073564566671848 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.992479562759399, 0.122410677373409 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.985277652740479, 0.170961901545525 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.975702106952667, 0.219101235270500 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.963776051998138, 0.266712784767151 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.949528157711029, 0.313681751489639 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.932992815971375, 0.359895050525665 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.914209723472595, 0.405241340398788 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.893224298954010, 0.449611335992813 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.870086967945099, 0.492898225784302 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.844853579998016, 0.534997642040253 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.817584812641144, 0.575808227062225 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.788346409797668, 0.615231633186340 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.757208824157715, 0.653172850608826 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.724247097969055, 0.689540565013886 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.689540505409241, 0.724247097969055 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.653172791004181, 0.757208883762360 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.615231573581696, 0.788346409797668 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.575808167457581, 0.817584812641144 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.534997642040253, 0.844853579998016 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.492898195981979, 0.870086967945099 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.449611306190491, 0.893224298954010 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.405241280794144, 0.914209783077240 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.359894961118698, 0.932992815971375 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.313681662082672, 0.949528217315674 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.266712754964828, 0.963776051998138 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.219101220369339, 0.975702106952667 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.170961856842041, 0.985277652740479 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.122410625219345, 0.992479562759399 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.073564492166042, 0.997290432453156 },
    { 0.049067649990320, 0.998795449733734 },
    { 0.024541135877371, 0.999698817729950 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.049067649990320, 0.998795449733734 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.098017223179340, 0.995184719562531 },
    { -0.146730571985245, 0.989176511764526 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.242980197072029, 0.970031261444092 },
    { -0.290284723043442, 0.956940293312073 },
    { -0.336889922618866, 0.941544055938721 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.427555084228516, 0.903989315032959 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.514102756977081, 0.857728600502014 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.634393274784088, 0.773010492324829 },
    { -0.671559035778046, 0.740951061248779 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.740951240062714, 0.671558856964111 },
    { -0.773010492324829, 0.634393274784088 },
    { -0.803207635879517, 0.595699131488800 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.857728600502014, 0.514102756977081 },
    { -0.881921350955963, 0.471396625041962 },
    { -0.903989315032959, 0.427555054426193 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.956940352916718, 0.290284723043442 },
    { -0.970031261444092, 0.242980077862740 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.989176511764526, 0.146730333566666 },
    { -0.995184719562531, 0.098017096519470 },
    { -0.998795449733734, 0.049067486077547 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.997290432453156, 0.073564566671848 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.975702106952667, 0.219101235270500 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.932992815971375, 0.359895050525665 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.870086967945099, 0.492898225784302 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.788346469402313, 0.615231573581696 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.689540505409241, 0.724247097969055 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.575808227062225, 0.817584812641144 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.449611306190491, 0.893224298954010 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.313681751489639, 0.949528157711029 },
    { 0.242980241775513, 0.970031261444092 },
    { 0.170961856842041, 0.985277652740479 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.024541255086660, 0.999698817729950 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.122410707175732, 0.992479503154755 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.266712725162506, 0.963776051998138 },
    { -0.336889803409576, 0.941544055938721 },
    { -0.405241340398788, 0.914209723472595 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.534997701644897, 0.844853520393372 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.653172850608826, 0.757208824157715 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.757208824157715, 0.653172850608826 },
    { -0.803207516670227, 0.595699369907379 },
    { -0.844853520393372, 0.534997701644897 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.914209783077240, 0.405241221189499 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.963776051998138, 0.266712725162506 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.992479503154755, 0.122410699725151 },
    { -0.998795449733734, 0.049067724496126 },
    { -0.999698817729950, -0.024541147053242 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.985277652740479, -0.170961990952492 },
    { -0.970031261444092, -0.242980241775513 },
    { -0.949528157711029, -0.313681781291962 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.893224298954010, -0.449611306190491 },
    { -0.857728660106659, -0.514102697372437 },
    { -0.817584872245789, -0.575808107852936 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.724247038364410, -0.689540624618530 },
    { -0.671558916568756, -0.740951180458069 },
    { -0.615231573581696, -0.788346469402313 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.492898195981979, -0.870086967945099 },
    { -0.427554935216904, -0.903989374637604 },
    { -0.359895110130310, -0.932992756366730 },
    { -0.290284544229507, -0.956940352916718 },
    { -0.219101369380951, -0.975702106952667 },
    { -0.146730408072472, -0.989176511764526 },
    { -0.073564760386944, -0.997290432453156 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.098017133772373, 0.995184719562531 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.195090234279633, 0.980785310268402 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.980785310268402, 0.195090308785439 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.098017133772373, 0.995184719562531 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.290284544229507, -0.956940352916718 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.382683426141739, 0.923879504203796 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.707106769084930, 0.707106769084930 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.707106769084930, 0.707106769084930 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.382683426141739, 0.923879504203796 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.923879504203796, -0.382683426141739 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.000000011924881, -1.000000000000000 }

################################################################################

TITLE
    libfaad2 cfft_tab_480

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.999914348125458, 0.013089596293867 },
    { 0.999657332897186, 0.026176949962974 },
    { 0.999229013919830, 0.039259817451239 },
    { 0.998629510402679, 0.052335958927870 },
    { 0.997858941555023, 0.065403133630753 },
    { 0.996917307376862, 0.078459098935127 },
    { 0.995804905891418, 0.091501623392105 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.993068456649780, 0.117537401616573 },
    { 0.991444885730743, 0.130526199936867 },
    { 0.989651381969452, 0.143492624163628 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.985556066036224, 0.169349506497383 },
    { 0.983254909515381, 0.182235524058342 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.975342333316803, 0.220697447657585 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.969230890274048, 0.246153295040131 },
    { 0.965925812721252, 0.258819043636322 },
    { 0.962455213069916, 0.271440446376801 },
    { 0.958819746971130, 0.284015357494354 },
    { 0.955019950866699, 0.296541601419449 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.946930110454559, 0.321439445018768 },
    { 0.942641496658325, 0.333806872367859 },
    { 0.938191354274750, 0.346117079257965 },
    { 0.933580398559570, 0.358367949724197 },
    { 0.928809583187103, 0.370557427406311 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.918791174888611, 0.394743889570236 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.908143162727356, 0.418659746646881 },
    { 0.902585268020630, 0.430511116981506 },
    { 0.896872758865356, 0.442288726568222 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.884987652301788, 0.465614527463913 },
    { 0.878817081451416, 0.477158784866333 },
    { 0.872496008872986, 0.488621264696121 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.859406411647797, 0.511293113231659 },
    { 0.852640151977539, 0.522498548030853 },
    { 0.845727801322937, 0.533614516258240 },
    { 0.838670551776886, 0.544639050960541 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.824126183986664, 0.566406250000000 },
    { 0.816641509532928, 0.577145218849182 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.801253795623779, 0.598324596881866 },
    { 0.793353319168091, 0.608761429786682 },
    { 0.785316884517670, 0.619093954563141 },
    { 0.777145922183990, 0.629320383071899 },
    { 0.768841803073883, 0.639438986778259 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.751839756965637, 0.659345865249634 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.734322488307953, 0.678800761699677 },
    { 0.725374400615692, 0.688354551792145 },
    { 0.716301918029785, 0.697790503501892 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.697790443897247, 0.716301977634430 },
    { 0.688354551792145, 0.725374400615692 },
    { 0.678800702095032, 0.734322547912598 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.659345805644989, 0.751839816570282 },
    { 0.649448037147522, 0.760405957698822 },
    { 0.639438986778259, 0.768841862678528 },
    { 0.629320383071899, 0.777145981788635 },
    { 0.619093954563141, 0.785316944122314 },
    { 0.608761370182037, 0.793353378772736 },
    { 0.598324596881866, 0.801253855228424 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.577145159244537, 0.816641569137573 },
    { 0.566406250000000, 0.824126183986664 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.544638991355896, 0.838670611381531 },
    { 0.533614516258240, 0.845727801322937 },
    { 0.522498488426209, 0.852640211582184 },
    { 0.511293113231659, 0.859406411647797 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.488621175289154, 0.872496068477631 },
    { 0.477158755064011, 0.878817141056061 },
    { 0.465614467859268, 0.884987652301788 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.442288666963577, 0.896872758865356 },
    { 0.430511027574539, 0.902585327625275 },
    { 0.418659746646881, 0.908143162727356 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.394743800163269, 0.918791234493256 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.370557397603989, 0.928809583187103 },
    { 0.358367860317230, 0.933580458164215 },
    { 0.346117049455643, 0.938191354274750 },
    { 0.333806812763214, 0.942641496658325 },
    { 0.321439474821091, 0.946930110454559 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.296541512012482, 0.955019950866699 },
    { 0.284015327692032, 0.958819746971130 },
    { 0.271440386772156, 0.962455272674561 },
    { 0.258819073438644, 0.965925812721252 },
    { 0.246153265237808, 0.969230890274048 },
    { 0.233445301651955, 0.972369909286499 },
    { 0.220697447657585, 0.975342333316803 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.182235524058342, 0.983254909515381 },
    { 0.169349446892738, 0.985556066036224 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.143492594361305, 0.989651381969452 },
    { 0.130526125431061, 0.991444885730743 },
    { 0.117537401616573, 0.993068456649780 },
    { 0.104528419673443, 0.994521915912628 },
    { 0.091501533985138, 0.995804905891418 },
    { 0.078459084033966, 0.996917307376862 },
    { 0.065403074026108, 0.997858941555023 },
    { 0.052335973829031, 0.998629510402679 },
    { 0.039259787648916, 0.999229013919830 },
    { 0.026176875457168, 0.999657332897186 },
    { 0.013089597225189, 0.999914348125458 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.013089684769511, 0.999914348125458 },
    { -0.026176963001490, 0.999657332897186 },
    { -0.039259877055883, 0.999229013919830 },
    { -0.052336059510708, 0.998629510402679 },
    { -0.065403163433075, 0.997858941555023 },
    { -0.078459173440933, 0.996917307376862 },
    { -0.091501623392105, 0.995804905891418 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.117537491023541, 0.993068456649780 },
    { -0.130526214838028, 0.991444885730743 },
    { -0.143492683768272, 0.989651381969452 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.169349536299706, 0.985556066036224 },
    { -0.182235598564148, 0.983254909515381 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.220697522163391, 0.975342273712158 },
    { -0.233445391058922, 0.972369909286499 },
    { -0.246153354644775, 0.969230890274048 },
    { -0.258819162845612, 0.965925812721252 },
    { -0.271440476179123, 0.962455213069916 },
    { -0.284015417098999, 0.958819687366486 },
    { -0.296541571617126, 0.955019950866699 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.321439564228058, 0.946930110454559 },
    { -0.333806872367859, 0.942641496658325 },
    { -0.346117109060287, 0.938191294670105 },
    { -0.358367949724197, 0.933580458164215 },
    { -0.370557487010956, 0.928809523582459 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.394743859767914, 0.918791234493256 },
    { -0.406736701726913, 0.913545429706573 },
    { -0.418659836053848, 0.908143103122711 },
    { -0.430511116981506, 0.902585268020630 },
    { -0.442288637161255, 0.896872758865356 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.465614557266235, 0.884987592697144 },
    { -0.477158725261688, 0.878817141056061 },
    { -0.488621354103088, 0.872495949268341 },
    { -0.500000059604645, 0.866025388240814 },
    { -0.511293053627014, 0.859406411647797 },
    { -0.522498667240143, 0.852640092372894 },
    { -0.533614575862885, 0.845727801322937 },
    { -0.544639050960541, 0.838670551776886 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.566406309604645, 0.824126124382019 },
    { -0.577145218849182, 0.816641569137573 },
    { -0.587785184383392, 0.809017002582550 },
    { -0.598324656486511, 0.801253736019135 },
    { -0.608761429786682, 0.793353319168091 },
    { -0.619093894958496, 0.785316944122314 },
    { -0.629320502281189, 0.777145862579346 },
    { -0.639439046382904, 0.768841803073883 },
    { -0.649448037147522, 0.760405957698822 },
    { -0.659345924854279, 0.751839697360992 },
    { -0.669130682945251, 0.743144810199738 },
    { -0.678800761699677, 0.734322488307953 },
    { -0.688354671001434, 0.725374281406403 },
    { -0.697790503501892, 0.716301858425140 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.716302037239075, 0.697790324687958 },
    { -0.725374460220337, 0.688354492187500 },
    { -0.734322547912598, 0.678800702095032 },
    { -0.743144929409027, 0.669130444526672 },
    { -0.751839876174927, 0.659345746040344 },
    { -0.760406017303467, 0.649448037147522 },
    { -0.768841803073883, 0.639439046382904 },
    { -0.777146041393280, 0.629320263862610 },
    { -0.785316944122314, 0.619093894958496 },
    { -0.793353319168091, 0.608761429786682 },
    { -0.801253914833069, 0.598324477672577 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.816641569137573, 0.577145218849182 },
    { -0.824126303195953, 0.566406130790710 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.838670551776886, 0.544639050960541 },
    { -0.845727920532227, 0.533614337444305 },
    { -0.852640211582184, 0.522498488426209 },
    { -0.859406411647797, 0.511293053627014 },
    { -0.866025388240814, 0.500000059604645 },
    { -0.872496068477631, 0.488621145486832 },
    { -0.878817141056061, 0.477158725261688 },
    { -0.884987652301788, 0.465614557266235 },
    { -0.891006588935852, 0.453990370035172 },
    { -0.896872758865356, 0.442288637161255 },
    { -0.902585268020630, 0.430511116981506 },
    { -0.908143222332001, 0.418659597635269 },
    { -0.913545489311218, 0.406736582517624 },
    { -0.918791234493256, 0.394743859767914 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.928809583187103, 0.370557337999344 },
    { -0.933580458164215, 0.358367919921875 },
    { -0.938191413879395, 0.346116900444031 },
    { -0.942641556262970, 0.333806753158569 },
    { -0.946930170059204, 0.321439445018768 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.955020010471344, 0.296541452407837 },
    { -0.958819746971130, 0.284015297889709 },
    { -0.962455213069916, 0.271440476179123 },
    { -0.965925872325897, 0.258818924427032 },
    { -0.969230949878693, 0.246153235435486 },
    { -0.972369909286499, 0.233445376157761 },
    { -0.975342333316803, 0.220697283744812 },
    { -0.978147625923157, 0.207911610603333 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.983254909515381, 0.182235360145569 },
    { -0.985556066036224, 0.169349402189255 },
    { -0.987688362598419, 0.156434446573257 },
    { -0.989651441574097, 0.143492430448532 },
    { -0.991444885730743, 0.130526080727577 },
    { -0.993068456649780, 0.117537356913090 },
    { -0.994521915912628, 0.104528494179249 },
    { -0.995804965496063, 0.091501489281654 },
    { -0.996917366981506, 0.078459039330482 },
    { -0.997858941555023, 0.065403148531914 },
    { -0.998629570007324, 0.052335809916258 },
    { -0.999229013919830, 0.039259742945433 },
    { -0.999657332897186, 0.026176951825619 },
    { -0.999914348125458, 0.013089434243739 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.999657332897186, 0.026176949962974 },
    { 0.998629510402679, 0.052335958927870 },
    { 0.996917307376862, 0.078459098935127 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.991444885730743, 0.130526199936867 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.983254909515381, 0.182235524058342 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.965925812721252, 0.258819043636322 },
    { 0.958819746971130, 0.284015357494354 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.942641496658325, 0.333806872367859 },
    { 0.933580398559570, 0.358367949724197 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.902585268020630, 0.430511116981506 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.878817081451416, 0.477158784866333 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.852640151977539, 0.522498548030853 },
    { 0.838670551776886, 0.544639050960541 },
    { 0.824126183986664, 0.566406250000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.793353319168091, 0.608761429786682 },
    { 0.777145922183990, 0.629320383071899 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.725374400615692, 0.688354551792145 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.688354551792145, 0.725374400615692 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.649448037147522, 0.760405957698822 },
    { 0.629320383071899, 0.777145981788635 },
    { 0.608761370182037, 0.793353378772736 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.566406250000000, 0.824126183986664 },
    { 0.544638991355896, 0.838670611381531 },
    { 0.522498488426209, 0.852640211582184 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.477158755064011, 0.878817141056061 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.430511027574539, 0.902585327625275 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.358367860317230, 0.933580458164215 },
    { 0.333806812763214, 0.942641496658325 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.284015327692032, 0.958819746971130 },
    { 0.258819073438644, 0.965925812721252 },
    { 0.233445301651955, 0.972369909286499 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.182235524058342, 0.983254909515381 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.130526125431061, 0.991444885730743 },
    { 0.104528419673443, 0.994521915912628 },
    { 0.078459084033966, 0.996917307376862 },
    { 0.052335973829031, 0.998629510402679 },
    { 0.026176875457168, 0.999657332897186 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.026176963001490, 0.999657332897186 },
    { -0.052336059510708, 0.998629510402679 },
    { -0.078459173440933, 0.996917307376862 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.130526214838028, 0.991444885730743 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.182235598564148, 0.983254909515381 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.233445391058922, 0.972369909286499 },
    { -0.258819162845612, 0.965925812721252 },
    { -0.284015417098999, 0.958819687366486 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.333806872367859, 0.942641496658325 },
    { -0.358367949724197, 0.933580458164215 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.406736701726913, 0.913545429706573 },
    { -0.430511116981506, 0.902585268020630 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.477158725261688, 0.878817141056061 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.998629510402679, 0.052335958927870 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.965925812721252, 0.258819043636322 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.933580398559570, 0.358367949724197 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.838670551776886, 0.544639050960541 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.777145922183990, 0.629320383071899 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.629320383071899, 0.777145981788635 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.544638991355896, 0.838670611381531 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.358367860317230, 0.933580458164215 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.258819073438644, 0.965925812721252 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.104528419673443, 0.994521915912628 },
    { 0.052335973829031, 0.998629510402679 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.052336059510708, 0.998629510402679 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.258819162845612, 0.965925812721252 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.358367949724197, 0.933580458164215 },
    { -0.406736701726913, 0.913545429706573 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.500000059604645, 0.866025388240814 },
    { -0.544639050960541, 0.838670551776886 },
    { -0.587785184383392, 0.809017002582550 },
    { -0.629320502281189, 0.777145862579346 },
    { -0.669130682945251, 0.743144810199738 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.743144929409027, 0.669130444526672 },
    { -0.777146041393280, 0.629320263862610 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.838670551776886, 0.544639050960541 },
    { -0.866025388240814, 0.500000059604645 },
    { -0.891006588935852, 0.453990370035172 },
    { -0.913545489311218, 0.406736582517624 },
    { -0.933580458164215, 0.358367919921875 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.965925872325897, 0.258818924427032 },
    { -0.978147625923157, 0.207911610603333 },
    { -0.987688362598419, 0.156434446573257 },
    { -0.994521915912628, 0.104528494179249 },
    { -0.998629570007324, 0.052335809916258 },
    { -1.000000000000000, -0.000000087422777 },
    { -0.998629510402679, -0.052335985004902 },
    { -0.994521856307983, -0.104528672993183 },
    { -0.987688302993774, -0.156434610486031 },
    { -0.978147566318512, -0.207911789417267 },
    { -0.965925812721252, -0.258819073438644 },
    { -0.951056540012360, -0.309016972780228 },
    { -0.933580398559570, -0.358368098735809 },
    { -0.913545429706573, -0.406736731529236 },
    { -0.891006529331207, -0.453990548849106 },
    { -0.866025269031525, -0.500000178813934 },
    { -0.838670492172241, -0.544639170169830 },
    { -0.809016942977905, -0.587785363197327 },
    { -0.777145922183990, -0.629320442676544 },
    { -0.743144810199738, -0.669130623340607 },
    { -0.707106649875641, -0.707106888294220 },
    { -0.669130504131317, -0.743144869804382 },
    { -0.629320323467255, -0.777145981788635 },
    { -0.587785065174103, -0.809017121791840 },
    { -0.544639110565186, -0.838670551776886 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.996917307376862, 0.078459098935127 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.852640151977539, 0.522498548030853 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.649448037147522, 0.760405957698822 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.522498488426209, 0.852640211582184 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.233445301651955, 0.972369909286499 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.078459084033966, 0.996917307376862 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.156434372067451, 0.987688362598419 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.587785184383392, 0.809017002582550 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.891006588935852, 0.453990370035172 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.987688362598419, 0.156434446573257 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.156434372067451, 0.987688362598419 },
    { -0.078459173440933, 0.996917307376862 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.522498667240143, 0.852640092372894 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.852640211582184, 0.522498488426209 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.996917366981506, 0.078459039330482 },
    { -0.987688302993774, -0.156434610486031 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.809016942977905, -0.587785363197327 },
    { -0.649447917938232, -0.760406076908112 },
    { -0.453990221023560, -0.891006648540497 },
    { -0.233445450663567, -0.972369909286499 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.309016972780228, 0.951056540012360 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.309016972780228, 0.951056540012360 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.809017062187195, 0.587785184383392 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.587785243988037, 0.809017002582550 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.809016942977905, -0.587785363197327 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.309017121791840, -0.951056480407715 }

################################################################################

TITLE
    libfaad2 cfft_tab_64

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.098017133772373, 0.995184719562531 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.195090234279633, 0.980785310268402 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.980785310268402, 0.195090308785439 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.098017133772373, 0.995184719562531 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.290284544229507, -0.956940352916718 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.382683426141739, 0.923879504203796 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.707106769084930, 0.707106769084930 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.707106769084930, 0.707106769084930 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.382683426141739, 0.923879504203796 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.923879504203796, -0.382683426141739 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.000000011924881, -1.000000000000000 }

################################################################################

TITLE
    libfaad2 cfft_tab_60

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.104528419673443, 0.994521915912628 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.406736701726913, 0.913545429706573 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.104528419673443, 0.994521915912628 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.500000059604645, 0.866025388240814 },
    { -0.669130682945251, 0.743144810199738 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.913545489311218, 0.406736582517624 },
    { -0.978147625923157, 0.207911610603333 },
    { -1.000000000000000, -0.000000087422777 },
    { -0.978147566318512, -0.207911789417267 },
    { -0.913545429706573, -0.406736731529236 },
    { -0.809016942977905, -0.587785363197327 },
    { -0.669130504131317, -0.743144869804382 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.309016972780228, 0.951056540012360 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.309016972780228, 0.951056540012360 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.809017062187195, 0.587785184383392 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.587785243988037, 0.809017002582550 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.809016942977905, -0.587785363197327 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.309017121791840, -0.951056480407715 }

################################################################################

TITLE
    libfaad2 cfft_tab_256

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.999698817729950, 0.024541229009628 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.997290432453156, 0.073564566671848 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.992479562759399, 0.122410677373409 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.985277652740479, 0.170961901545525 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.975702106952667, 0.219101235270500 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.963776051998138, 0.266712784767151 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.949528157711029, 0.313681751489639 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.932992815971375, 0.359895050525665 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.914209723472595, 0.405241340398788 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.893224298954010, 0.449611335992813 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.870086967945099, 0.492898225784302 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.844853579998016, 0.534997642040253 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.817584812641144, 0.575808227062225 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.788346409797668, 0.615231633186340 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.757208824157715, 0.653172850608826 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.724247097969055, 0.689540565013886 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.689540505409241, 0.724247097969055 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.653172791004181, 0.757208883762360 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.615231573581696, 0.788346409797668 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.575808167457581, 0.817584812641144 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.534997642040253, 0.844853579998016 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.492898195981979, 0.870086967945099 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.449611306190491, 0.893224298954010 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.405241280794144, 0.914209783077240 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.359894961118698, 0.932992815971375 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.313681662082672, 0.949528217315674 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.266712754964828, 0.963776051998138 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.219101220369339, 0.975702106952667 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.170961856842041, 0.985277652740479 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.122410625219345, 0.992479562759399 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.073564492166042, 0.997290432453156 },
    { 0.049067649990320, 0.998795449733734 },
    { 0.024541135877371, 0.999698817729950 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.049067649990320, 0.998795449733734 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.098017223179340, 0.995184719562531 },
    { -0.146730571985245, 0.989176511764526 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.242980197072029, 0.970031261444092 },
    { -0.290284723043442, 0.956940293312073 },
    { -0.336889922618866, 0.941544055938721 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.427555084228516, 0.903989315032959 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.514102756977081, 0.857728600502014 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.634393274784088, 0.773010492324829 },
    { -0.671559035778046, 0.740951061248779 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.740951240062714, 0.671558856964111 },
    { -0.773010492324829, 0.634393274784088 },
    { -0.803207635879517, 0.595699131488800 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.857728600502014, 0.514102756977081 },
    { -0.881921350955963, 0.471396625041962 },
    { -0.903989315032959, 0.427555054426193 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.956940352916718, 0.290284723043442 },
    { -0.970031261444092, 0.242980077862740 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.989176511764526, 0.146730333566666 },
    { -0.995184719562531, 0.098017096519470 },
    { -0.998795449733734, 0.049067486077547 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.997290432453156, 0.073564566671848 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.975702106952667, 0.219101235270500 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.932992815971375, 0.359895050525665 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.870086967945099, 0.492898225784302 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.788346469402313, 0.615231573581696 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.689540505409241, 0.724247097969055 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.575808227062225, 0.817584812641144 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.449611306190491, 0.893224298954010 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.313681751489639, 0.949528157711029 },
    { 0.242980241775513, 0.970031261444092 },
    { 0.170961856842041, 0.985277652740479 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.024541255086660, 0.999698817729950 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.122410707175732, 0.992479503154755 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.266712725162506, 0.963776051998138 },
    { -0.336889803409576, 0.941544055938721 },
    { -0.405241340398788, 0.914209723472595 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.534997701644897, 0.844853520393372 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.653172850608826, 0.757208824157715 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.757208824157715, 0.653172850608826 },
    { -0.803207516670227, 0.595699369907379 },
    { -0.844853520393372, 0.534997701644897 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.914209783077240, 0.405241221189499 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.963776051998138, 0.266712725162506 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.992479503154755, 0.122410699725151 },
    { -0.998795449733734, 0.049067724496126 },
    { -0.999698817729950, -0.024541147053242 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.985277652740479, -0.170961990952492 },
    { -0.970031261444092, -0.242980241775513 },
    { -0.949528157711029, -0.313681781291962 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.893224298954010, -0.449611306190491 },
    { -0.857728660106659, -0.514102697372437 },
    { -0.817584872245789, -0.575808107852936 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.724247038364410, -0.689540624618530 },
    { -0.671558916568756, -0.740951180458069 },
    { -0.615231573581696, -0.788346469402313 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.492898195981979, -0.870086967945099 },
    { -0.427554935216904, -0.903989374637604 },
    { -0.359895110130310, -0.932992756366730 },
    { -0.290284544229507, -0.956940352916718 },
    { -0.219101369380951, -0.975702106952667 },
    { -0.146730408072472, -0.989176511764526 },
    { -0.073564760386944, -0.997290432453156 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.098017133772373, 0.995184719562531 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.195090234279633, 0.980785310268402 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.980785310268402, 0.195090308785439 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.098017133772373, 0.995184719562531 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.290284544229507, -0.956940352916718 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.382683426141739, 0.923879504203796 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.707106769084930, 0.707106769084930 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.707106769084930, 0.707106769084930 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.382683426141739, 0.923879504203796 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.923879504203796, -0.382683426141739 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.000000011924881, -1.000000000000000 }

################################################################################

TITLE
    libfaad2 cfft_tab_240

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.999657332897186, 0.026176949962974 },
    { 0.998629510402679, 0.052335958927870 },
    { 0.996917307376862, 0.078459098935127 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.991444885730743, 0.130526199936867 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.983254909515381, 0.182235524058342 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.965925812721252, 0.258819043636322 },
    { 0.958819746971130, 0.284015357494354 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.942641496658325, 0.333806872367859 },
    { 0.933580398559570, 0.358367949724197 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.902585268020630, 0.430511116981506 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.878817081451416, 0.477158784866333 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.852640151977539, 0.522498548030853 },
    { 0.838670551776886, 0.544639050960541 },
    { 0.824126183986664, 0.566406250000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.793353319168091, 0.608761429786682 },
    { 0.777145922183990, 0.629320383071899 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.725374400615692, 0.688354551792145 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.688354551792145, 0.725374400615692 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.649448037147522, 0.760405957698822 },
    { 0.629320383071899, 0.777145981788635 },
    { 0.608761370182037, 0.793353378772736 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.566406250000000, 0.824126183986664 },
    { 0.544638991355896, 0.838670611381531 },
    { 0.522498488426209, 0.852640211582184 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.477158755064011, 0.878817141056061 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.430511027574539, 0.902585327625275 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.358367860317230, 0.933580458164215 },
    { 0.333806812763214, 0.942641496658325 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.284015327692032, 0.958819746971130 },
    { 0.258819073438644, 0.965925812721252 },
    { 0.233445301651955, 0.972369909286499 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.182235524058342, 0.983254909515381 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.130526125431061, 0.991444885730743 },
    { 0.104528419673443, 0.994521915912628 },
    { 0.078459084033966, 0.996917307376862 },
    { 0.052335973829031, 0.998629510402679 },
    { 0.026176875457168, 0.999657332897186 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.026176963001490, 0.999657332897186 },
    { -0.052336059510708, 0.998629510402679 },
    { -0.078459173440933, 0.996917307376862 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.130526214838028, 0.991444885730743 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.182235598564148, 0.983254909515381 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.233445391058922, 0.972369909286499 },
    { -0.258819162845612, 0.965925812721252 },
    { -0.284015417098999, 0.958819687366486 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.333806872367859, 0.942641496658325 },
    { -0.358367949724197, 0.933580458164215 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.406736701726913, 0.913545429706573 },
    { -0.430511116981506, 0.902585268020630 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.477158725261688, 0.878817141056061 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.998629510402679, 0.052335958927870 },
    { 0.994521915912628, 0.104528464376926 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.978147625923157, 0.207911700010300 },
    { 0.965925812721252, 0.258819043636322 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.933580398559570, 0.358367949724197 },
    { 0.913545429706573, 0.406736642122269 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.866025388240814, 0.500000000000000 },
    { 0.838670551776886, 0.544639050960541 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.777145922183990, 0.629320383071899 },
    { 0.743144810199738, 0.669130623340607 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.669130563735962, 0.743144869804382 },
    { 0.629320383071899, 0.777145981788635 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.544638991355896, 0.838670611381531 },
    { 0.499999970197678, 0.866025447845459 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.406736612319946, 0.913545489311218 },
    { 0.358367860317230, 0.933580458164215 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.258819073438644, 0.965925812721252 },
    { 0.207911655306816, 0.978147625923157 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.104528419673443, 0.994521915912628 },
    { 0.052335973829031, 0.998629510402679 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.052336059510708, 0.998629510402679 },
    { -0.104528509080410, 0.994521915912628 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.207911744713783, 0.978147566318512 },
    { -0.258819162845612, 0.965925812721252 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.358367949724197, 0.933580458164215 },
    { -0.406736701726913, 0.913545429706573 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.500000059604645, 0.866025388240814 },
    { -0.544639050960541, 0.838670551776886 },
    { -0.587785184383392, 0.809017002582550 },
    { -0.629320502281189, 0.777145862579346 },
    { -0.669130682945251, 0.743144810199738 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.743144929409027, 0.669130444526672 },
    { -0.777146041393280, 0.629320263862610 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.838670551776886, 0.544639050960541 },
    { -0.866025388240814, 0.500000059604645 },
    { -0.891006588935852, 0.453990370035172 },
    { -0.913545489311218, 0.406736582517624 },
    { -0.933580458164215, 0.358367919921875 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.965925872325897, 0.258818924427032 },
    { -0.978147625923157, 0.207911610603333 },
    { -0.987688362598419, 0.156434446573257 },
    { -0.994521915912628, 0.104528494179249 },
    { -0.998629570007324, 0.052335809916258 },
    { -1.000000000000000, -0.000000087422777 },
    { -0.998629510402679, -0.052335985004902 },
    { -0.994521856307983, -0.104528672993183 },
    { -0.987688302993774, -0.156434610486031 },
    { -0.978147566318512, -0.207911789417267 },
    { -0.965925812721252, -0.258819073438644 },
    { -0.951056540012360, -0.309016972780228 },
    { -0.933580398559570, -0.358368098735809 },
    { -0.913545429706573, -0.406736731529236 },
    { -0.891006529331207, -0.453990548849106 },
    { -0.866025269031525, -0.500000178813934 },
    { -0.838670492172241, -0.544639170169830 },
    { -0.809016942977905, -0.587785363197327 },
    { -0.777145922183990, -0.629320442676544 },
    { -0.743144810199738, -0.669130623340607 },
    { -0.707106649875641, -0.707106888294220 },
    { -0.669130504131317, -0.743144869804382 },
    { -0.629320323467255, -0.777145981788635 },
    { -0.587785065174103, -0.809017121791840 },
    { -0.544639110565186, -0.838670551776886 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.996917307376862, 0.078459098935127 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.852640151977539, 0.522498548030853 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.649448037147522, 0.760405957698822 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.522498488426209, 0.852640211582184 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.233445301651955, 0.972369909286499 },
    { 0.156434372067451, 0.987688362598419 },
    { 0.078459084033966, 0.996917307376862 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.987688362598419, 0.156434476375580 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.453990519046783, 0.891006529331207 },
    { 0.309016972780228, 0.951056540012360 },
    { 0.156434372067451, 0.987688362598419 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.156434446573257, 0.987688362598419 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.453990608453751, 0.891006469726563 },
    { -0.587785184383392, 0.809017002582550 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.809017062187195, 0.587785184383392 },
    { -0.891006588935852, 0.453990370035172 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.987688362598419, 0.156434446573257 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.972369909286499, 0.233445376157761 },
    { 0.891006529331207, 0.453990519046783 },
    { 0.760405957698822, 0.649448096752167 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.156434372067451, 0.987688362598419 },
    { -0.078459173440933, 0.996917307376862 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.522498667240143, 0.852640092372894 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.852640211582184, 0.522498488426209 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.996917366981506, 0.078459039330482 },
    { -0.987688302993774, -0.156434610486031 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.809016942977905, -0.587785363197327 },
    { -0.649447917938232, -0.760406076908112 },
    { -0.453990221023560, -0.891006648540497 },
    { -0.233445450663567, -0.972369909286499 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.951056540012360, 0.309017002582550 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.587785243988037, 0.809017002582550 },
    { 0.309016972780228, 0.951056540012360 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.809017002582550, 0.587785243988037 },
    { 0.309016972780228, 0.951056540012360 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.809017062187195, 0.587785184383392 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.587785243988037, 0.809017002582550 },
    { -0.309017032384872, 0.951056480407715 },
    { -0.951056599617004, 0.309016793966293 },
    { -0.809016942977905, -0.587785363197327 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.309017121791840, -0.951056480407715 }

################################################################################

TITLE
    libfaad2 cfft_tab_128

TYPE
    FLOAT

DATA
    { 1.000000000000000, 0.000000000000000 },
    { 0.998795449733734, 0.049067676067352 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.989176511764526, 0.146730467677116 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.970031261444092, 0.242980197072029 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.941544055938721, 0.336889863014221 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.903989315032959, 0.427555084228516 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.857728600502014, 0.514102756977081 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.803207516670227, 0.595699310302734 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.740951120853424, 0.671558976173401 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.671558916568756, 0.740951180458069 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.595699310302734, 0.803207516670227 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.514102697372437, 0.857728660106659 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.427555114030838, 0.903989315032959 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.336889833211899, 0.941544055938721 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.242980122566223, 0.970031261444092 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.146730497479439, 0.989176511764526 },
    { 0.098017133772373, 0.995184719562531 },
    { 0.049067649990320, 0.998795449733734 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.049067739397287, 0.998795449733734 },
    { -0.098017223179340, 0.995184719562531 },
    { -0.146730571985245, 0.989176511764526 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.242980197072029, 0.970031261444092 },
    { -0.290284723043442, 0.956940293312073 },
    { -0.336889922618866, 0.941544055938721 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.427555084228516, 0.903989315032959 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.514102756977081, 0.857728600502014 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.595699369907379, 0.803207516670227 },
    { -0.634393274784088, 0.773010492324829 },
    { -0.671559035778046, 0.740951061248779 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.740951240062714, 0.671558856964111 },
    { -0.773010492324829, 0.634393274784088 },
    { -0.803207635879517, 0.595699131488800 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.857728600502014, 0.514102756977081 },
    { -0.881921350955963, 0.471396625041962 },
    { -0.903989315032959, 0.427555054426193 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.941544115543365, 0.336889803409576 },
    { -0.956940352916718, 0.290284723043442 },
    { -0.970031261444092, 0.242980077862740 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.989176511764526, 0.146730333566666 },
    { -0.995184719562531, 0.098017096519470 },
    { -0.998795449733734, 0.049067486077547 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.995184719562531, 0.098017141222954 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.881921231746674, 0.471396744251251 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.773010432720184, 0.634393334388733 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.471396654844284, 0.881921291351318 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.290284633636475, 0.956940352916718 },
    { 0.195090234279633, 0.980785310268402 },
    { 0.098017133772373, 0.995184719562531 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.980785250663757, 0.195090323686600 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.555570185184479, 0.831469655036926 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.195090234279633, 0.980785310268402 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.382683515548706, 0.923879504203796 },
    { -0.555570363998413, 0.831469535827637 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.831469655036926, 0.555570185184479 },
    { -0.923879623413086, 0.382683277130127 },
    { -0.980785310268402, 0.195090308785439 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.956940352916718, 0.290284663438797 },
    { 0.831469595432281, 0.555570244789124 },
    { 0.634393274784088, 0.773010432720184 },
    { 0.382683426141739, 0.923879504203796 },
    { 0.098017133772373, 0.995184719562531 },
    { -0.195090323686600, 0.980785250663757 },
    { -0.471396833658218, 0.881921231746674 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.881921231746674, 0.471396833658218 },
    { -0.980785310268402, 0.195090308785439 },
    { -0.995184719562531, -0.098017267882824 },
    { -0.923879504203796, -0.382683426141739 },
    { -0.773010551929474, -0.634393215179443 },
    { -0.555570006370544, -0.831469774246216 },
    { -0.290284544229507, -0.956940352916718 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.923879504203796, 0.382683455944061 },
    { 0.707106769084930, 0.707106769084930 },
    { 0.382683426141739, 0.923879504203796 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.707106769084930, 0.707106769084930 },
    { -0.000000043711388, 1.000000000000000 },
    { -0.707106769084930, 0.707106769084930 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.382683426141739, 0.923879504203796 },
    { -0.707106769084930, 0.707106769084930 },
    { -0.923879504203796, -0.382683426141739 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 1.000000000000000, 0.000000000000000 },
    { 0.000000011924881, -1.000000000000000 }

################################################################################

TITLE
    libfaad2 pow2_tab

TYPE
    FLOAT

DATA
    1.000000000000000, 1.010889286051701, 1.021897148654117,
    1.033024879021228, 1.044273782427414, 1.055645178360557,
    1.067140400676824, 1.078760797757120, 1.090507732665258,
    1.102382583307841, 1.114386742595892, 1.126521618608242,
    1.138788634756692, 1.151189229952983, 1.163724858777578,
    1.176396991650281, 1.189207115002721, 1.202156731452703,
    1.215247359980469, 1.228480536106870, 1.241857812073484,
    1.255380757024691, 1.269050957191733, 1.282870016078778,
    1.296839554651010, 1.310961211524764, 1.325236643159741,
    1.339667524053303, 1.354255546936893, 1.369002422974591,
    1.383909881963832, 1.398979672538311, 1.414213562373095,
    1.429613338391970, 1.445180806977047, 1.460917794180647,
    1.476826145939499, 1.492907728291265, 1.509164427593423,
    1.525598150744538, 1.542210825407941, 1.559004400237837,
    1.575980845107887, 1.593142151342267, 1.610490331949254,
    1.628027421857348, 1.645755478153965, 1.663676580326736,
    1.681792830507429, 1.700106353718524, 1.718619298122478,
    1.737333835273706, 1.756252160373300, 1.775376492526521,
    1.794709075003107, 1.814252175500399, 1.834008086409342,
    1.853979125083386, 1.874167634110300, 1.894575981586966,
    1.915206561397147, 1.936061793492294, 1.957144124175400,
    1.978456026387951, 2.000000000000000

################################################################################

TITLE
    libfaad2 log2_tab

TYPE
    FLOAT

DATA
    0.000000000000000, 0.022367813028455, 0.044394119358453,
    0.066089190457772, 0.087462841250339, 0.108524456778169,
    0.129283016944966, 0.149747119504682, 0.169925001442312,
    0.189824558880017, 0.209453365628950, 0.228818690495881,
    0.247927513443585, 0.266786540694901, 0.285402218862248,
    0.303780748177103, 0.321928094887362, 0.339850002884625,
    0.357552004618084, 0.375039431346925, 0.392317422778760,
    0.409390936137702, 0.426264754702098, 0.442943495848728,
    0.459431618637297, 0.475733430966398, 0.491853096329675,
    0.507794640198696, 0.523561956057013, 0.539158811108031,
    0.554588851677637, 0.569855608330948, 0.584962500721156,
    0.599912842187128, 0.614709844115208, 0.629356620079610,
    0.643856189774725, 0.658211482751795, 0.672425341971496,
    0.686500527183218, 0.700439718141092, 0.714245517666123,
    0.727920454563199, 0.741466986401147, 0.754887502163469,
    0.768184324776926, 0.781359713524660, 0.794415866350106,
    0.807354922057604, 0.820178962415188, 0.832890014164742,
    0.845490050944375, 0.857980995127572, 0.870364719583405,
    0.882643049361841, 0.894817763307943, 0.906890595608519,
    0.918863237274595, 0.930737337562886, 0.942514505339240,
    0.954196310386875, 0.965784284662087, 0.977279923499917,
    0.988684686772166, 1.000000000000000

################################################################################

TITLE
    libfaad2 drc_pow2_table

TYPE
    FLOAT

DATA
    0.5146511183,
    0.5297315472,
    0.5452538663,
    0.5612310242,
    0.5776763484,
    0.5946035575,
    0.6120267717,
    0.6299605249,
    0.6484197773,
    0.6674199271,
    0.6869768237,
    0.7071067812,
    0.7278265914,
    0.7491535384,
    0.7711054127,
    0.7937005260,
    0.8169577266,
    0.8408964153,
    0.8655365610,
    0.8908987181,
    0.9170040432,
    0.9438743127,
    0.9715319412,
    1.0000000000,
    1.0293022366,
    1.0594630944,
    1.0905077327,
    1.1224620483,
    1.1553526969,
    1.1892071150,
    1.2240535433,
    1.2599210499,
    1.2968395547,
    1.3348398542,
    1.3739536475,
    1.4142135624,
    1.4556531828,
    1.4983070769,
    1.5422108254,
    1.5874010520,
    1.6339154532,
    1.6817928305,
    1.7310731220,
    1.7817974363,
    1.8340080864,
    1.8877486254,
    1.9430638823

################################################################################

TITLE
    libfaad2 f_huffman_sa

TYPE
    8

DATA
    { /*0*/ -15, 1 },             /* index 0: 1 bits:  x */
    { 2, 3 },                     /* index 1: 2 bits:  1x */
    { /*7*/ -8, 4 },              /* index 2: 3 bits:  10x */
    { 5, 6 },                     /* index 3: 3 bits:  11x */
    { /*1*/ -14, /*-1*/ -16 },    /* index 4: 4 bits:  101x */
    { /*-2*/ -17, 7 },            /* index 5: 4 bits:  110x */
    { 8, 9 },                     /* index 6: 4 bits:  111x */
    { /*2*/ -13, /*-3*/ -18 },    /* index 7: 5 bits:  1101x */
    { /*3*/ -12, 10 },            /* index 8: 5 bits:  1110x */
    { 11, 12 },                   /* index 9: 5 bits:  1111x */
    { /*4*/ -11, /*5*/ -10 },     /* index 10: 6 bits: 11101x */
    { /*-4*/ -19, /*-5*/ -20 },   /* index 11: 6 bits: 11110x */
    { /*6*/ -9, 13 },             /* index 12: 6 bits: 11111x */
    { /*-7*/ -22, /*-6*/ -21 }    /* index 13: 7 bits: 111111x */

################################################################################

TITLE
    libfaad2 t_huffman_sa

TYPE
    8

DATA
    { /*0*/ -15, 1 },             /* index 0: 1 bits: x */
    { 2, 3 },                     /* index 1: 2 bits: 1x */
    { /*-1*/ -16, /*1*/ -14 },    /* index 2: 3 bits: 10x */
    { 4, 5 },                     /* index 3: 3 bits: 11x */
    { /*-2*/ -17, /*2*/ -13 },    /* index 4: 4 bits: 110x */
    { 6, 7 },                     /* index 5: 4 bits: 111x */
    { /*-3*/ -18, /*3*/ -12 },    /* index 6: 5 bits: 1110x */
    { 8, 9 },                     /* index 7: 5 bits: 1111x */
    { /*-4*/ -19, /*4*/ -11 },    /* index 8: 6 bits: 11110x */
    { 10, 11 },                   /* index 9: 6 bits: 11111x */
    { /*-5*/ -20, /*5*/ -10 },    /* index 10: 7 bits: 111110x */
    { /*-6*/ -21, 12 },           /* index 11: 7 bits: 111111x */
    { /*-7*/ -22, 13 },           /* index 12: 8 bits: 1111111x */
    { /*6*/ -9, /*7*/ -8 }        /* index 13: 9 bits: 11111111x */

################################################################################

TITLE
    libfaad2 f_huffman_pan

TYPE
    8

DATA
    { /*0*/ -15, 1 },             /* index 0: 1 bits: x */
    { /*-1*/ -16, 2 },            /* index 1: 2 bits: 1x */
    { /*1*/ -14, 3 },             /* index 2: 3 bits: 11x */
    { 4, 5 },                     /* index 3: 4 bits: 111x */
    { /*-2*/ -17, /*2*/ -13 },    /* index 4: 5 bits: 1110x */
    { 6, 7 },                     /* index 5: 5 bits: 1111x */
    { /*-3*/ -18, /*3*/ -12 },    /* index 6: 6 bits: 11110x */
    { 8, 9 },                     /* index 7: 6 bits: 11111x */
    { /*-4*/ -19, /*4*/ -11 },    /* index 8: 7 bits: 111110x */
    { 10, 11 },                   /* index 9: 7 bits: 111111x */
    { /*-5*/ -20, /*5*/ -10 },    /* index 10: 8 bits: 1111110x */
    { 12, 13 },                   /* index 11: 8 bits: 1111111x */
    { /*-6*/ -21, /*6*/ -9 },     /* index 12: 9 bits: 11111110x */
    { /*-7*/ -22, 14 },           /* index 13: 9 bits: 11111111x */
    { /*7*/ -8, 15 },             /* index 14: 10 bits: 111111111x */
    { 16, 17 },                   /* index 15: 11 bits: 1111111111x */
    { /*-8*/ -23, /*8*/ -7 },     /* index 16: 12 bits: 11111111110x */
    { 18, 19 },                   /* index 17: 12 bits: 11111111111x */
    { /*-10*/ -25, 20 },          /* index 18: 13 bits: 111111111110x */
    { 21, 22 },                   /* index 19: 13 bits: 111111111111x */
    { /*-9*/ -24, /*9*/ -6 },     /* index 20: 14 bits: 1111111111101x */
    { /*10*/ -5, 23 },            /* index 21: 14 bits: 1111111111110x */
    { 24, 25 },                   /* index 22: 14 bits: 1111111111111x */
    { /*-13*/ -28, /*-11*/ -26 }, /* index 23: 15 bits: 11111111111101x */
    { /*11*/ -4, /*13*/ -2 },     /* index 24: 15 bits: 11111111111110x */
    { 26, 27 },                   /* index 25: 15 bits: 11111111111111x */
    { /*-14*/ -29, /*-12*/ -27 }, /* index 26: 16 bits: 111111111111110x */
    { /*12*/ -3, /*14*/ -1 }      /* index 27: 16 bits: 111111111111111x */

################################################################################

TITLE
    libfaad2 t_huffman_pan

TYPE
    8

DATA
    { /*0*/ -15, 1 },             /* index 0: 1 bits: x */
    { /*-1*/ -16, 2 },            /* index 1: 2 bits: 1x */
    { /*1*/ -14, 3 },             /* index 2: 3 bits: 11x */
    { /*-2*/ -17, 4 },            /* index 3: 4 bits: 111x */
    { /*2*/ -13, 5 },             /* index 4: 5 bits: 1111x */
    { /*-3*/ -18, 6 },            /* index 5: 6 bits: 11111x */
    { /*3*/ -12, 7 },             /* index 6: 7 bits: 111111x */
    { /*-4*/ -19, 8 },            /* index 7: 8 bits: 1111111x */
    { /*4*/ -11, 9 },             /* index 8: 9 bits: 11111111x */
    { 10, 11 },                   /* index 9: 10 bits: 111111111x */
    { /*-5*/ -20, /*5*/ -10 },    /* index 10: 11 bits: 1111111110x */
    { 12, 13 },                   /* index 11: 11 bits: 1111111111x */
    { /*-6*/ -21, /*6*/ -9 },     /* index 12: 12 bits: 11111111110x */
    { 14, 15 },                   /* index 13: 12 bits: 11111111111x */
    { /*-7*/ -22, /*7*/ -8 },     /* index 14: 13 bits: 111111111110x */
    { 16, 17 },                   /* index 15: 13 bits: 111111111111x */
    { /*-8*/ -23, /*8*/ -7 },     /* index 16: 14 bits: 1111111111110x */
    { 18, 19 },                   /* index 17: 14 bits: 1111111111111x */
    { /*-10*/ -25, /*10*/ -5 },   /* index 18: 15 bits: 11111111111110x */
    { 20, 21 },                   /* index 19: 15 bits: 11111111111111x */
    { /*-9*/ -24, /*9*/ -6 },     /* index 20: 16 bits: 111111111111110x */
    { 22, 23 },                   /* index 21: 16 bits: 111111111111111x */
    { 24, 25 },                   /* index 22: 17 bits: 1111111111111110x */
    { 26, 27 },                   /* index 23: 17 bits: 1111111111111111x */
    { /*-14*/ -29, /*-13*/ -28 }, /* index 24: 18 bits: 11111111111111100x */
    { /*-12*/ -27, /*-11*/ -26 }, /* index 25: 18 bits: 11111111111111101x */
    { /*11*/ -4, /*12*/ -3 },     /* index 26: 18 bits: 11111111111111110x */
    { /*13*/ -2, /*14*/ -1 }      /* index 27: 18 bits: 11111111111111111x */

################################################################################

TITLE
    libfaad2 sa_quant

TYPE
    FLOAT

DATA
    { 0.0000, 0.0000 },
    { 0.0501, 0.1778 },
    { 0.0706, 0.2818 },
    { 0.0995, 0.4467 },
    { 0.1399, 0.5623 },
    { 0.1957, 0.7079 },
    { 0.2713, 0.8913 },
    { 0.3699, 1.0000 },

################################################################################

TITLE
    libfaad2 pan_quant

TYPE
    FLOAT

DATA
    { 0.0000, 0.0000, 0.0000, 0.0000, 0.0000 },
    { 0.1661, 0.1661, 0.3322, 0.3322, 0.3322 },
    { 0.3322, 0.3322, 0.6644, 0.8305, 0.8305 },
    { 0.4983, 0.6644, 0.9966, 1.4949, 1.6610 },
    { 0.6644, 0.9966, 1.4949, 2.1593, 2.4914 },
    { 0.8305, 1.3288, 2.1593, 2.9897, 3.4880 },
    { 0.9966, 1.8271, 2.8236, 3.8202, 4.6507 },
    { 1.3288, 2.3253, 3.4880, 4.6507, 5.8134 },

################################################################################

TITLE
    libfaad2 pan_pow_2_pos

TYPE
    FLOAT

DATA
    { 1.0000000, 1.0000000, 1.0000000, 1.0000000, 1.0000000  },
    { 1.1220021, 1.1220021, 1.2589312, 1.2589312, 1.2589312  },
    { 1.2589312, 1.2589312, 1.5849090, 1.7783016, 1.7783016  },
    { 1.4125481, 1.5849090, 1.9952921, 2.8184461, 3.1623565  },
    { 1.5849090, 1.9952922, 2.8184461, 4.4669806, 5.6232337  },
    { 1.7783016, 2.5119365, 4.4669806, 7.9430881, 11.219994  },
    { 1.9952921, 3.5482312, 7.0792671, 14.125206, 25.118876  },
    { 2.5119365, 5.0116998, 11.219994, 25.118876, 56.235140  }

################################################################################

TITLE
    libfaad2 pan_pow_2_neg

TYPE
    FLOAT

DATA
    { 1,         1,         1,         1,         1          },
    { 0.8912487, 0.8912487, 0.7943242, 0.7943242, 0.7943242  },
    { 0.7943242, 0.7943242, 0.6309511, 0.5623344, 0.5623344  },
    { 0.7079405, 0.6309511, 0.5011797, 0.3548054, 0.3162199  },
    { 0.6309511, 0.5011797, 0.3548054, 0.2238649, 0.1778336  },
    { 0.5623343, 0.3980992, 0.2238649, 0.1258956, 0.0891266  },
    { 0.5011797, 0.2818306, 0.1412576, 0.0707954, 0.0398107  },
    { 0.3980992, 0.1995331, 0.0891267, 0.0398107, 0.0177825  }

################################################################################

TITLE
    libfaad2 pan_pow_2_30_pos

TYPE
    FLOAT

DATA
    { 1,           1,           1,           1,           1           }, 
    { 1.003845098, 1.003845098, 1.007704982, 1.007704982, 1.007704982 }, 
    { 1.007704982, 1.007704982, 1.01546933,  1.019373909, 1.019373909 }, 
    { 1.011579706, 1.01546933,  1.023293502, 1.035142941, 1.039123167 }, 
    { 1.01546933,  1.023293502, 1.035142941, 1.051155908, 1.059252598 },
    { 1.019373909, 1.03117796,  1.051155908, 1.071518432, 1.0839263   }, 
    { 1.023293502, 1.043118698, 1.067414119, 1.092277933, 1.113439626 }, 
    { 1.03117796,  1.055195268, 1.0839263,   1.113439626, 1.143756546 }

################################################################################

TITLE
    libfaad2 pan_pow_2_30_neg

TYPE
    FLOAT

DATA
    { 1,           1,           1,           1,           1           },
    { 0.99616963,  0.99616963,  0.992353931, 0.992353931, 0.99235393  }, 
    { 0.992353931, 0.992353931, 0.984766325, 0.980994305, 0.980994305 }, 
    { 0.988552848, 0.984766325, 0.977236734, 0.966050157, 0.962349827 }, 
    { 0.984766325, 0.977236734, 0.966050157, 0.951333663, 0.944061881 }, 
    { 0.980994305, 0.969764715, 0.951333663, 0.933255062, 0.922571949 }, 
    { 0.977236734, 0.958663671, 0.936843519, 0.915517901, 0.898117847 }, 
    { 0.969764715, 0.947691892, 0.922571949, 0.898117847, 0.874311936 }

################################################################################

TITLE
    libfaad2 g_decayslope

TYPE
    FLOAT

DATA
    1,   1,   1,   0.95,0.9, 0.85, 0.8, 
    0.75,0.7, 0.65,0.6, 0.55,0.5,  0.45, 
    0.4, 0.35,0.3, 0.25,0.2, 0.15, 0.1,
    0.05,0,   0,   0,   0,   0,    0, 
    0,   0,   0,   0,   0,   0,    0,  
    0,   0,   0,   0,   0,   0,    0,   
    0,   0,   0

################################################################################

TITLE
    libfaad2 sa_sqrt_1_minus

TYPE
    FLOAT

DATA
    { 1,            1           },
    { 0.998744206,  0.984066644 },
    { 0.997504707,  0.959473168 },
    { 0.995037562,  0.894683804 },
    { 0.990165638,  0.826933317 },
    { 0.980663811,  0.706312672 },
    { 0.962494836,  0.45341406  },
    { 0.929071574,  0           }

################################################################################

TITLE
    libfaad2 sa_freq_scale

TYPE
    8

DATA
    { 0, 0},  
    { 1, 1},  
    { 2, 2},  
    { 3, 3},  
    { 5, 5},  
    { 7, 7},  
    {10,10},  
    {13,13},  
    {46,23}

################################################################################

TITLE
    libfaad2 pan_inv_freq

TYPE
    8

DATA
     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 
    15, 15, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 
    19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,
    19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19

################################################################################

TITLE
    libfaad2 sa_inv_freq

TYPE
    8

DATA
    0, 1, 2, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6,
    7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
    7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
    7, 7, 7, 7, 7, 7, 7

################################################################################

TITLE
    libfaad2 Q_Fract_allpass_Qmf

TYPE
    FLOAT

DATA
    { { 0.7804303765, 0.6252426505 }, { 0.3826834261, 0.9238795042 }, { 0.8550928831, 0.5184748173 } },
    { { -0.4399392009, 0.8980275393 }, { -0.9238795042, -0.3826834261 }, { -0.0643581524, 0.9979268909 } },
    { { -0.9723699093, -0.2334454209 }, { 0.9238795042, -0.3826834261 }, { -0.9146071672, 0.4043435752 } },
    { { 0.0157073960, -0.9998766184 }, { -0.3826834261, 0.9238795042 }, { -0.7814115286, -0.6240159869 } },
    { { 0.9792228341, -0.2027871907 }, { -0.3826834261, -0.9238795042 }, { 0.1920081824, -0.9813933372 } },
    { { 0.4115142524, 0.9114032984 }, { 0.9238795042, 0.3826834261 }, { 0.9589683414, -0.2835132182 } },
    { { -0.7996847630, 0.6004201174 }, { -0.9238795042, 0.3826834261 }, { 0.6947838664, 0.7192186117 } },
    { { -0.7604058385, -0.6494481564 }, { 0.3826834261, -0.9238795042 }, { -0.3164770305, 0.9486001730 } },
    { { 0.4679299891, -0.8837655187 }, { 0.3826834261, 0.9238795042 }, { -0.9874414206, 0.1579856575 } },
    { { 0.9645573497, 0.2638732493 }, { -0.9238795042, -0.3826834261 }, { -0.5966450572, -0.8025052547 } },
    { { -0.0471066870, 0.9988898635 }, { 0.9238795042, -0.3826834261 }, { 0.4357025325, -0.9000906944 } },
    { { -0.9851093888, 0.1719288528 }, { -0.3826834261, 0.9238795042 }, { 0.9995546937, -0.0298405960 } },
    { { -0.3826831877, -0.9238796234 }, { -0.3826834261, -0.9238795042 }, { 0.4886211455, 0.8724960685 } },
    { { 0.8181498647, -0.5750049949 }, { 0.9238795042, 0.3826834261 }, { -0.5477093458, 0.8366686702 } },
    { { 0.7396308780, 0.6730127335 }, { -0.9238795042, 0.3826834261 }, { -0.9951074123, -0.0987988561 } },
    { { -0.4954589605, 0.8686313629 }, { 0.3826834261, -0.9238795042 }, { -0.3725017905, -0.9280315042 } },
    { { -0.9557929039, -0.2940406799 }, { 0.3826834261, 0.9238795042 }, { 0.6506417990, -0.7593847513 } },
    { { 0.0784594864, -0.9969173074 }, { -0.9238795042, -0.3826834261 }, { 0.9741733670, 0.2258014232 } },
    { { 0.9900237322, -0.1409008205 }, { 0.9238795042, -0.3826834261 }, { 0.2502108514, 0.9681913853 } },
    { { 0.3534744382, 0.9354441762 }, { -0.3826834261, 0.9238795042 }, { -0.7427945137, 0.6695194840 } },
    { { -0.8358076215, 0.5490224361 }, { -0.3826834261, -0.9238795042 }, { -0.9370992780, -0.3490629196 } },
    { { -0.7181259394, -0.6959131360 }, { 0.9238795042, 0.3826834261 }, { -0.1237744763, -0.9923103452 } },
    { { 0.5224990249, -0.8526399136 }, { -0.9238795042, 0.3826834261 }, { 0.8226406574, -0.5685616732 } },
    { { 0.9460852146, 0.3239179254 }, { 0.3826834261, -0.9238795042 }, { 0.8844994903, 0.4665412009 } },
    { { -0.1097348556, 0.9939609170 }, { 0.3826834261, 0.9238795042 }, { -0.0047125919, 0.9999889135 } },
    { { -0.9939610362, 0.1097337380 }, { -0.9238795042, -0.3826834261 }, { -0.8888573647, 0.4581840038 } },
    { { -0.3239168525, -0.9460855722 }, { 0.9238795042, -0.3826834261 }, { -0.8172453642, -0.5762898922 } },
    { { 0.8526405096, -0.5224980116 }, { -0.3826834261, 0.9238795042 }, { 0.1331215799, -0.9910997152 } },
    { { 0.6959123611, 0.7181267142 }, { -0.3826834261, -0.9238795042 }, { 0.9403476119, -0.3402152061 } },
    { { -0.5490233898, 0.8358070254 }, { 0.9238795042, 0.3826834261 }, { 0.7364512086, 0.6764906645 } },
    { { -0.9354437590, -0.3534754813 }, { -0.9238795042, 0.3826834261 }, { -0.2593250275, 0.9657900929 } },
    { { 0.1409019381, -0.9900235534 }, { 0.3826834261, -0.9238795042 }, { -0.9762582779, 0.2166097313 } },
    { { 0.9969173670, -0.0784583688 }, { 0.3826834261, 0.9238795042 }, { -0.6434556246, -0.7654833794 } },
    { { 0.2940396070, 0.9557932615 }, { -0.9238795042, -0.3826834261 }, { 0.3812320232, -0.9244794250 } },
    { { -0.8686318994, 0.4954580069 }, { 0.9238795042, -0.3826834261 }, { 0.9959943891, -0.0894154981 } },
    { { -0.6730118990, -0.7396316528 }, { -0.3826834261, 0.9238795042 }, { 0.5397993922, 0.8417937160 } },
    { { 0.5750059485, -0.8181492686 }, { -0.3826834261, -0.9238795042 }, { -0.4968227744, 0.8678520322 } },
    { { 0.9238792062, 0.3826842010 }, { 0.9238795042, 0.3826834261 }, { -0.9992290139, -0.0392601527 } },
    { { -0.1719299555, 0.9851091504 }, { -0.9238795042, 0.3826834261 }, { -0.4271997511, -0.9041572809 } },
    { { -0.9988899231, 0.0471055657 }, { 0.3826834261, -0.9238795042 }, { 0.6041822433, -0.7968461514 } },
    { { -0.2638721764, -0.9645576477 }, { 0.3826834261, 0.9238795042 }, { 0.9859085083, 0.1672853529 } },
    { { 0.8837660551, -0.4679289758 }, { -0.9238795042, -0.3826834261 }, { 0.3075223565, 0.9515408874 } },
    { { 0.6494473219, 0.7604066133 }, { 0.9238795042, -0.3826834261 }, { -0.7015317082, 0.7126382589 } },
    { { -0.6004210114, 0.7996840477 }, { -0.3826834261, 0.9238795042 }, { -0.9562535882, -0.2925389707 } },
    { { -0.9114028811, -0.4115152657 }, { -0.3826834261, -0.9238795042 }, { -0.1827499419, -0.9831594229 } },
    { { 0.2027882934, -0.9792225957 }, { 0.9238795042, 0.3826834261 }, { 0.7872582674, -0.6166234016 } },
    { { 0.9998766780, -0.0157062728 }, { -0.9238795042, 0.3826834261 }, { 0.9107555747, 0.4129458666 } },
    { { 0.2334443331, 0.9723701477 }, { 0.3826834261, -0.9238795042 }, { 0.0549497530, 0.9984891415 } },
    { { -0.8980280757, 0.4399381876 }, { 0.3826834261, 0.9238795042 }, { -0.8599416018, 0.5103924870 } },
    { { -0.6252418160, -0.7804310918 }, { -0.9238795042, -0.3826834261 }, { -0.8501682281, -0.5265110731 } },
    { { 0.6252435446, -0.7804297209 }, { 0.9238795042, -0.3826834261 }, { 0.0737608299, -0.9972759485 } },
    { { 0.8980270624, 0.4399402142 }, { -0.3826834261, 0.9238795042 }, { 0.9183775187, -0.3957053721 } },
    { { -0.2334465086, 0.9723696709 }, { -0.3826834261, -0.9238795042 }, { 0.7754954696, 0.6313531399 } },
    { { -0.9998766184, -0.0157085191 }, { 0.9238795042, 0.3826834261 }, { -0.2012493610, 0.9795400500 } },
    { { -0.2027861029, -0.9792230725 }, { -0.9238795042, 0.3826834261 }, { -0.9615978599, 0.2744622827 } },
    { { 0.9114037752, -0.4115132093 }, { 0.3826834261, -0.9238795042 }, { -0.6879743338, -0.7257350087 } },
    { { 0.6004192233, 0.7996854186 }, { 0.3826834261, 0.9238795042 }, { 0.3254036009, -0.9455752373 } },
    { { -0.6494490504, 0.7604051232 }, { -0.9238795042, -0.3826834261 }, { 0.9888865948, -0.1486719251 } },
    { { -0.8837650418, -0.4679309726 }, { 0.9238795042, -0.3826834261 }, { 0.5890548825, 0.8080930114 } },
    { { 0.2638743520, -0.9645570517 }, { -0.3826834261, 0.9238795042 }, { -0.4441666007, 0.8959442377 } },
    { { 0.9988898039, 0.0471078083 }, { -0.3826834261, -0.9238795042 }, { -0.9997915030, 0.0204183888 } },
    { { 0.1719277352, 0.9851095676 }, { 0.9238795042, 0.3826834261 }, { -0.4803760946, -0.8770626187 } },
    { { -0.9238800406, 0.3826821446 }, { -0.9238795042, 0.3826834261 }, { 0.5555707216, -0.8314692974 } },
    { { -0.5750041008, -0.8181505203 }, { 0.3826834261, -0.9238795042 }, { 0.9941320419, 0.1081734300 } }

################################################################################

TITLE
    libfaad2 Phi_Fract_Qmf

TYPE
    FLOAT

DATA
    { 0.8181497455, 0.5750052333 },
    { -0.2638730407, 0.9645574093 },
    { -0.9969173074, 0.0784590989 },
    { -0.4115143716, -0.9114032984 },
    { 0.7181262970, -0.6959127784 },
    { 0.8980275989, 0.4399391711 },
    { -0.1097343117, 0.9939609766 },
    { -0.9723699093, 0.2334453613 },
    { -0.5490227938, -0.8358073831 },
    { 0.6004202366, -0.7996846437 },
    { 0.9557930231, 0.2940403223 },
    { 0.0471064523, 0.9988898635 },
    { -0.9238795042, 0.3826834261 },
    { -0.6730124950, -0.7396311164 },
    { 0.4679298103, -0.8837656379 },
    { 0.9900236726, 0.1409012377 },
    { 0.2027872950, 0.9792228341 },
    { -0.8526401520, 0.5224985480 },
    { -0.7804304361, -0.6252426505 },
    { 0.3239174187, -0.9460853338 },
    { 0.9998766184, -0.0157073177 },
    { 0.3534748554, 0.9354440570 },
    { -0.7604059577, 0.6494480371 },
    { -0.8686315417, -0.4954586625 },
    { 0.1719291061, -0.9851093292 },
    { 0.9851093292, -0.1719291061 },
    { 0.4954586625, 0.8686315417 },
    { -0.6494480371, 0.7604059577 },
    { -0.9354440570, -0.3534748554 },
    { 0.0157073177, -0.9998766184 },
    { 0.9460853338, -0.3239174187 },
    { 0.6252426505, 0.7804304361 },
    { -0.5224985480, 0.8526401520 },
    { -0.9792228341, -0.2027872950 },
    { -0.1409012377, -0.9900236726 },
    { 0.8837656379, -0.4679298103 },
    { 0.7396311164, 0.6730124950 },
    { -0.3826834261, 0.9238795042 },
    { -0.9988898635, -0.0471064523 },
    { -0.2940403223, -0.9557930231 },
    { 0.7996846437, -0.6004202366 },
    { 0.8358073831, 0.5490227938 },
    { -0.2334453613, 0.9723699093 },
    { -0.9939609766, 0.1097343117 },
    { -0.4399391711, -0.8980275989 },
    { 0.6959127784, -0.7181262970 },
    { 0.9114032984, 0.4115143716 },
    { -0.0784590989, 0.9969173074 },
    { -0.9645574093, 0.2638730407 },
    { -0.5750052333, -0.8181497455 },
    { 0.5750052333, -0.8181497455 },
    { 0.9645574093, 0.2638730407 },
    { 0.0784590989, 0.9969173074 },
    { -0.9114032984, 0.4115143716 },
    { -0.6959127784, -0.7181262970 },
    { 0.4399391711, -0.8980275989 },
    { 0.9939609766, 0.1097343117 },
    { 0.2334453613, 0.9723699093 },
    { -0.8358073831, 0.5490227938 },
    { -0.7996846437, -0.6004202366 },
    { 0.2940403223, -0.9557930231 },
    { 0.9988898635, -0.0471064523 },
    { 0.3826834261, 0.9238795042 },
    { -0.7396311164, 0.6730124950 }

################################################################################

TITLE
    libfaad2 mnt_table

TYPE
    FLOAT

DATA
    0.9531250000, 0.9453125000,
    0.9375000000, 0.9296875000,
    0.9257812500, 0.9179687500,
    0.9101562500, 0.9023437500,
    0.8984375000, 0.8906250000,
    0.8828125000, 0.8789062500,
    0.8710937500, 0.8671875000,
    0.8593750000, 0.8515625000,
    0.8476562500, 0.8398437500,
    0.8359375000, 0.8281250000,
    0.8242187500, 0.8203125000,
    0.8125000000, 0.8085937500,
    0.8007812500, 0.7968750000,
    0.7929687500, 0.7851562500,
    0.7812500000, 0.7773437500,
    0.7734375000, 0.7656250000,
    0.7617187500, 0.7578125000,
    0.7539062500, 0.7500000000,
    0.7421875000, 0.7382812500,
    0.7343750000, 0.7304687500,
    0.7265625000, 0.7226562500,
    0.7187500000, 0.7148437500,
    0.7109375000, 0.7070312500,
    0.6992187500, 0.6953125000,
    0.6914062500, 0.6875000000,
    0.6835937500, 0.6796875000,
    0.6796875000, 0.6757812500,
    0.6718750000, 0.6679687500,
    0.6640625000, 0.6601562500,
    0.6562500000, 0.6523437500,
    0.6484375000, 0.6445312500,
    0.6406250000, 0.6406250000,
    0.6367187500, 0.6328125000,
    0.6289062500, 0.6250000000,
    0.6210937500, 0.6210937500,
    0.6171875000, 0.6132812500,
    0.6093750000, 0.6054687500,
    0.6054687500, 0.6015625000,
    0.5976562500, 0.5937500000,
    0.5937500000, 0.5898437500,
    0.5859375000, 0.5820312500,
    0.5820312500, 0.5781250000,
    0.5742187500, 0.5742187500,
    0.5703125000, 0.5664062500,
    0.5664062500, 0.5625000000,
    0.5585937500, 0.5585937500,
    0.5546875000, 0.5507812500,
    0.5507812500, 0.5468750000,
    0.5429687500, 0.5429687500,
    0.5390625000, 0.5390625000,
    0.5351562500, 0.5312500000,
    0.5312500000, 0.5273437500,
    0.5273437500, 0.5234375000,
    0.5195312500, 0.5195312500,
    0.5156250000, 0.5156250000,
    0.5117187500, 0.5117187500,
    0.5078125000, 0.5078125000,
    0.5039062500, 0.5039062500,
    0.5000000000, 0.4980468750,
    0.4960937500, 0.4941406250,
    0.4921875000, 0.4902343750,
    0.4882812500, 0.4863281250,
    0.4843750000, 0.4824218750,
    0.4804687500, 0.4785156250

################################################################################

TITLE
    libfaad2 exp_table

TYPE
    FLOAT

DATA
    0.50000000000000000000000000000000000000000000000000,
    0.25000000000000000000000000000000000000000000000000,
    0.12500000000000000000000000000000000000000000000000,
    0.06250000000000000000000000000000000000000000000000,
    0.03125000000000000000000000000000000000000000000000,
    0.01562500000000000000000000000000000000000000000000,
    0.00781250000000000000000000000000000000000000000000,
    0.00390625000000000000000000000000000000000000000000,
    0.00195312500000000000000000000000000000000000000000,
    0.00097656250000000000000000000000000000000000000000,
    0.00048828125000000000000000000000000000000000000000,
    0.00024414062500000000000000000000000000000000000000,
    0.00012207031250000000000000000000000000000000000000,
    0.00006103515625000000000000000000000000000000000000,
    0.00003051757812500000000000000000000000000000000000,
    0.00001525878906250000000000000000000000000000000000,
    0.00000762939453125000000000000000000000000000000000,
    0.00000381469726562500000000000000000000000000000000,
    0.00000190734863281250000000000000000000000000000000,
    0.00000095367431640625000000000000000000000000000000,
    0.00000047683715820312500000000000000000000000000000,
    0.00000023841857910156250000000000000000000000000000,
    0.00000011920928955078125000000000000000000000000000,
    0.00000005960464477539062500000000000000000000000000,
    0.00000002980232238769531300000000000000000000000000,
    0.00000001490116119384765600000000000000000000000000,
    0.00000000745058059692382810000000000000000000000000,
    0.00000000372529029846191410000000000000000000000000,
    0.00000000186264514923095700000000000000000000000000,
    0.00000000093132257461547852000000000000000000000000,
    0.00000000046566128730773926000000000000000000000000,
    0.00000000023283064365386963000000000000000000000000,
    0.00000000011641532182693481000000000000000000000000,
    0.00000000005820766091346740700000000000000000000000,
    0.00000000002910383045673370400000000000000000000000,
    0.00000000001455191522836685200000000000000000000000,
    0.00000000000727595761418342590000000000000000000000,
    0.00000000000363797880709171300000000000000000000000,
    0.00000000000181898940354585650000000000000000000000,
    0.00000000000090949470177292824000000000000000000000,
    0.00000000000045474735088646412000000000000000000000,
    0.00000000000022737367544323206000000000000000000000,
    0.00000000000011368683772161603000000000000000000000,
    0.00000000000005684341886080801500000000000000000000,
    0.00000000000002842170943040400700000000000000000000,
    0.00000000000001421085471520200400000000000000000000,
    0.00000000000000710542735760100190000000000000000000,
    0.00000000000000355271367880050090000000000000000000,
    0.00000000000000177635683940025050000000000000000000,
    0.00000000000000088817841970012523000000000000000000,
    0.00000000000000044408920985006262000000000000000000,
    0.00000000000000022204460492503131000000000000000000,
    0.00000000000000011102230246251565000000000000000000,
    0.00000000000000005551115123125782700000000000000000,
    0.00000000000000002775557561562891400000000000000000,
    0.00000000000000001387778780781445700000000000000000,
    0.00000000000000000693889390390722840000000000000000,
    0.00000000000000000346944695195361420000000000000000,
    0.00000000000000000173472347597680710000000000000000,
    0.00000000000000000086736173798840355000000000000000,
    0.00000000000000000043368086899420177000000000000000,
    0.00000000000000000021684043449710089000000000000000,
    0.00000000000000000010842021724855044000000000000000,
    0.00000000000000000005421010862427522200000000000000,
    0.00000000000000000002710505431213761100000000000000,
    0.00000000000000000001355252715606880500000000000000,
    0.00000000000000000000677626357803440270000000000000,
    0.00000000000000000000338813178901720140000000000000,
    0.00000000000000000000169406589450860070000000000000,
    0.00000000000000000000084703294725430034000000000000,
    0.00000000000000000000042351647362715017000000000000,
    0.00000000000000000000021175823681357508000000000000,
    0.00000000000000000000010587911840678754000000000000,
    0.00000000000000000000005293955920339377100000000000,
    0.00000000000000000000002646977960169688600000000000,
    0.00000000000000000000001323488980084844300000000000,
    0.00000000000000000000000661744490042422140000000000,
    0.00000000000000000000000330872245021211070000000000,
    0.00000000000000000000000165436122510605530000000000,
    0.00000000000000000000000082718061255302767000000000,
    0.00000000000000000000000041359030627651384000000000,
    0.00000000000000000000000020679515313825692000000000,
    0.00000000000000000000000010339757656912846000000000,
    0.00000000000000000000000005169878828456423000000000,
    0.00000000000000000000000002584939414228211500000000,
    0.00000000000000000000000001292469707114105700000000,
    0.00000000000000000000000000646234853557052870000000,
    0.00000000000000000000000000323117426778526440000000,
    0.00000000000000000000000000161558713389263220000000,
    0.00000000000000000000000000080779356694631609000000,
    0.00000000000000000000000000040389678347315804000000,
    0.00000000000000000000000000020194839173657902000000,
    0.00000000000000000000000000010097419586828951000000,
    0.00000000000000000000000000005048709793414475600000,
    0.00000000000000000000000000002524354896707237800000,
    0.00000000000000000000000000001262177448353618900000,
    0.00000000000000000000000000000631088724176809440000,
    0.00000000000000000000000000000315544362088404720000,
    0.00000000000000000000000000000157772181044202360000,
    0.00000000000000000000000000000078886090522101181000,
    0.00000000000000000000000000000039443045261050590000,
    0.00000000000000000000000000000019721522630525295000,
    0.00000000000000000000000000000009860761315262647600,
    0.00000000000000000000000000000004930380657631323800,
    0.00000000000000000000000000000002465190328815661900,
    0.00000000000000000000000000000001232595164407830900,
    0.00000000000000000000000000000000616297582203915470,
    0.00000000000000000000000000000000308148791101957740,
    0.00000000000000000000000000000000154074395550978870,
    0.00000000000000000000000000000000077037197775489434,
    0.00000000000000000000000000000000038518598887744717,
    0.00000000000000000000000000000000019259299443872359,
    0.00000000000000000000000000000000009629649721936179,
    0.00000000000000000000000000000000004814824860968090,
    0.00000000000000000000000000000000002407412430484045,
    0.00000000000000000000000000000000001203706215242022,
    0.00000000000000000000000000000000000601853107621011,
    0.00000000000000000000000000000000000300926553810506,
    0.00000000000000000000000000000000000150463276905253,
    0.00000000000000000000000000000000000075231638452626,
    0.00000000000000000000000000000000000037615819226313,
    0.00000000000000000000000000000000000018807909613157,
    0.00000000000000000000000000000000000009403954806578,
    0.00000000000000000000000000000000000004701977403289,
    0.00000000000000000000000000000000000002350988701645,
    0.00000000000000000000000000000000000001175494350822,

################################################################################

TITLE
    libfaad2 pow05_table

TYPE
    FLOAT

DATA
    1.68179283050743 /* 0.5^(-3/4) */
    1.41421356237310 /* 0.5^(-2/4) */
    1.18920711500272 /* 0.5^(-1/4) */
    1.0              /* 0.5^( 0/4) */
    0.84089641525371 /* 0.5^(+1/4) */
    0.70710678118655 /* 0.5^(+2/4) */
    0.59460355750136 /* 0.5^(+3/4) */

################################################################################

TITLE
    libfaad2 codebook

TYPE
    FLOAT

DATA
    0.570829,
    0.696616,
    0.813004,
    0.911304,
    0.984900,
    1.067894,
    1.194601,
    1.369533

################################################################################

TITLE
    libfaad2 f_huff_iid_def

TYPE
    8

DATA
    { /*0*/ -31, 1 },             /* index 0: 1 bits: x */
    { 2, 3 },                     /* index 1: 2 bits: 1x */
    { /*1*/ -30, /*-1*/ -32 },    /* index 2: 3 bits: 10x */
    { 4, 5 },                     /* index 3: 3 bits: 11x */
    { /*2*/ -29, /*-2*/ -33 },    /* index 4: 4 bits: 110x */
    { 6, 7 },                     /* index 5: 4 bits: 111x */
    { /*3*/ -28, /*-3*/ -34 },    /* index 6: 5 bits: 1110x */
    { 8, 9 },                     /* index 7: 5 bits: 1111x */
    { /*-4*/ -35, /*4*/ -27 },    /* index 8: 6 bits: 11110x */
    { /*5*/ -26, 10 },            /* index 9: 6 bits: 11111x */
    { /*-5*/ -36, 11 },           /* index 10: 7 bits: 111111x */
    { /*6*/ -25, 12 },            /* index 11: 8 bits: 1111111x */
    { /*-6*/ -37, 13 },           /* index 12: 9 bits: 11111111x */
    { /*-7*/ -38, 14 },           /* index 13: 10 bits: 111111111x */
    { /*7*/ -24, 15 },            /* index 14: 11 bits: 1111111111x */
    { 16, 17 },                   /* index 15: 12 bits: 11111111111x */
    { /*8*/ -23, /*-8*/ -39 },    /* index 16: 13 bits: 111111111110x */
    { 18, 19 },                   /* index 17: 13 bits: 111111111111x */
    { /*9*/ -22, /*10*/ -21 },    /* index 18: 14 bits: 1111111111110x */
    { 20, 21 },                   /* index 19: 14 bits: 1111111111111x */
    { /*-9*/ -40, /*11*/ -20 },   /* index 20: 15 bits: 11111111111110x */
    { 22, 23 },                   /* index 21: 15 bits: 11111111111111x */
    { /*-10*/ -41, 24 },          /* index 22: 16 bits: 111111111111110x */
    { 25, 26 },                   /* index 23: 16 bits: 111111111111111x */
    { /*-11*/ -42, /*-14*/ -45 }, /* index 24: 17 bits: 1111111111111101x */
    { /*-13*/ -44, /*-12*/ -43 }, /* index 25: 17 bits: 1111111111111110x */
    { /*12*/ -19, 27 },           /* index 26: 17 bits: 1111111111111111x */
    { /*13*/ -18, /*14*/ -17 }    /* index 27: 18 bits: 11111111111111111x */

################################################################################

TITLE
    libfaad2 t_huff_iid_def

TYPE
    8

DATA
    { /*0*/ -31, 1 },             /* index 0: 1 bits: x */
    { /*-1*/ -32, 2 },            /* index 1: 2 bits: 1x */
    { /*1*/ -30, 3 },             /* index 2: 3 bits: 11x */
    { /*-2*/ -33, 4 },            /* index 3: 4 bits: 111x */
    { /*2*/ -29, 5 },             /* index 4: 5 bits: 1111x */
    { /*-3*/ -34, 6 },            /* index 5: 6 bits: 11111x */
    { /*3*/ -28, 7 },             /* index 6: 7 bits: 111111x */
    { /*-4*/ -35, 8 },            /* index 7: 8 bits: 1111111x */
    { /*4*/ -27, 9 },             /* index 8: 9 bits: 11111111x */
    { /*-5*/ -36, 10 },           /* index 9: 10 bits: 111111111x */
    { /*5*/ -26, 11 },            /* index 10: 11 bits: 1111111111x */
    { /*-6*/ -37, 12 },           /* index 11: 12 bits: 11111111111x */
    { /*6*/ -25, 13 },            /* index 12: 13 bits: 111111111111x */
    { /*7*/ -24, 14 },            /* index 13: 14 bits: 1111111111111x */
    { /*-7*/ -38, 15 },           /* index 14: 15 bits: 11111111111111x */
    { 16, 17 },                   /* index 15: 16 bits: 111111111111111x */
    { /*8*/ -23, /*-8*/ -39 },    /* index 16: 17 bits: 1111111111111110x */
    { 18, 19 },                   /* index 17: 17 bits: 1111111111111111x */
    { 20, 21 },                   /* index 18: 18 bits: 11111111111111110x */
    { 22, 23 },                   /* index 19: 18 bits: 11111111111111111x */
    { /*9*/ -22, /*-14*/ -45 },   /* index 20: 19 bits: 111111111111111100x */
    { /*-13*/ -44, /*-12*/ -43 }, /* index 21: 19 bits: 111111111111111101x */
    { 24, 25 },                   /* index 22: 19 bits: 111111111111111110x */
    { 26, 27 },                   /* index 23: 19 bits: 111111111111111111x */
    { /*-11*/ -42, /*-10*/ -41 }, /* index 24: 20 bits: 1111111111111111100x */
    { /*-9*/ -40, /*10*/ -21 },   /* index 25: 20 bits: 1111111111111111101x */
    { /*11*/ -20, /*12*/ -19 },   /* index 26: 20 bits: 1111111111111111110x */
    { /*13*/ -18, /*14*/ -17 }    /* index 27: 20 bits: 1111111111111111111x */

################################################################################

TITLE
    libfaad2 f_huff_iid_fine

TYPE
    8

DATA
    { 1, /*0*/ -31 },             /* index 0: 1 bits: x */
    { 2, 3 },                     /* index 1: 2 bits: 0x */
    { 4, /*-1*/ -32 },            /* index 2: 3 bits: 00x */
    { /*1*/ -30, 5 },             /* index 3: 3 bits: 01x */
    { /*-2*/ -33, /*2*/ -29 },    /* index 4: 4 bits: 000x */
    { 6, 7 },                     /* index 5: 4 bits: 011x */
    { /*-3*/ -34, /*3*/ -28 },    /* index 6: 5 bits: 0110x */
    { 8, 9 },                     /* index 7: 5 bits: 0111x */
    { /*-4*/ -35, /*4*/ -27 },    /* index 8: 6 bits: 01110x */
    { 10, 11 },                   /* index 9: 6 bits: 01111x */
    { /*-5*/ -36, /*5*/ -26 },    /* index 10: 7 bits: 011110x */
    { 12, 13 },                   /* index 11: 7 bits: 011111x */
    { /*-6*/ -37, /*6*/ -25 },    /* index 12: 8 bits: 0111110x */
    { 14, 15 },                   /* index 13: 8 bits: 0111111x */
    { /*7*/ -24, 16 },            /* index 14: 9 bits: 01111110x */
    { 17, 18 },                   /* index 15: 9 bits: 01111111x */
    { 19, /*-8*/ -39 },           /* index 16: 10 bits: 011111101x */
    { /*8*/ -23, 20 },            /* index 17: 10 bits: 011111110x */
    { 21, /*-7*/ -38 },           /* index 18: 10 bits: 011111111x */
    { /*10*/ -21, 22 },           /* index 19: 11 bits: 0111111010x */
    { 23, /*-9*/ -40 },           /* index 20: 11 bits: 0111111101x */
    { /*9*/ -22, 24 },            /* index 21: 11 bits: 0111111110x */
    { /*-11*/ -42, /*11*/ -20 },  /* index 22: 12 bits: 01111110101x */
    { 25, 26 },                   /* index 23: 12 bits: 01111111010x */
    { 27, /*-10*/ -41 },          /* index 24: 12 bits: 01111111101x */
    { 28, /*-12*/ -43 },          /* index 25: 13 bits: 011111110100x */
    { /*12*/ -19, 29 },           /* index 26: 13 bits: 011111110101x */
    { 30, 31 },                   /* index 27: 13 bits: 011111111010x */
    { 32, /*-14*/ -45 },          /* index 28: 14 bits: 0111111101000x */
    { /*14*/ -17, 33 },           /* index 29: 14 bits: 0111111101011x */
    { 34, /*-13*/ -44 },          /* index 30: 14 bits: 0111111110100x */
    { /*13*/ -18, 35 },           /* index 31: 14 bits: 0111111110101x */
    { 36, 37 },                   /* index 32: 15 bits: 01111111010000x */
    { 38, /*-15*/ -46 },          /* index 33: 15 bits: 01111111010111x */
    { /*15*/ -16, 39 },           /* index 34: 15 bits: 01111111101000x */
    { 40, 41 },                   /* index 35: 15 bits: 01111111101011x */
    { 42, 43 },                   /* index 36: 16 bits: 011111110100000x */
    { /*-17*/ -48, /*17*/ -14 },  /* index 37: 16 bits: 011111110100001x */
    { 44, 45 },                   /* index 38: 16 bits: 011111110101110x */
    { 46, 47 },                   /* index 39: 16 bits: 011111111010001x */
    { 48, 49 },                   /* index 40: 16 bits: 011111111010110x */
    { /*-16*/ -47, /*16*/ -15 },  /* index 41: 16 bits: 011111111010111x */
    { /*-21*/ -52, /*21*/ -10 },  /* index 42: 17 bits: 0111111101000000x */
    { /*-19*/ -50, /*19*/ -12 },  /* index 43: 17 bits: 0111111101000001x */
    { /*-18*/ -49, /*18*/ -13 },  /* index 44: 17 bits: 0111111101011100x */
    { 50, 51 },                   /* index 45: 17 bits: 0111111101011101x */
    { 52, 53 },                   /* index 46: 17 bits: 0111111110100010x */
    { 54, 55 },                   /* index 47: 17 bits: 0111111110100011x */
    { 56, 57 },                   /* index 48: 17 bits: 0111111110101100x */
    { 58, 59 },                   /* index 49: 17 bits: 0111111110101101x */
    { /*-26*/ -57, /*-25*/ -56 }, /* index 50: 18 bits: 01111111010111010x */
    { /*-28*/ -59, /*-27*/ -58 }, /* index 51: 18 bits: 01111111010111011x */
    { /*-22*/ -53, /*22*/ -9 },   /* index 52: 18 bits: 01111111101000100x */
    { /*-24*/ -55, /*-23*/ -54 }, /* index 53: 18 bits: 01111111101000101x */
    { /*25*/ -6, /*26*/ -5 },     /* index 54: 18 bits: 01111111101000110x */
    { /*23*/ -8, /*24*/ -7 },     /* index 55: 18 bits: 01111111101000111x */
    { /*29*/ -2, /*30*/ -1 },     /* index 56: 18 bits: 01111111101011000x */
    { /*27*/ -4, /*28*/ -3 },     /* index 57: 18 bits: 01111111101011001x */
    { /*-30*/ -61, /*-29*/ -60 }, /* index 58: 18 bits: 01111111101011010x */
    { /*-20*/ -51, /*20*/ -11 }   /* index 59: 18 bits: 01111111101011011x */

################################################################################

TITLE
    libfaad2 t_huff_iid_fine

TYPE
    8

DATA
    { 1, /*0*/ -31 },             /* index 0: 1 bits: x */
    { /*1*/ -30, 2 },             /* index 1: 2 bits: 0x */
    { 3, /*-1*/ -32 },            /* index 2: 3 bits: 01x */
    { 4, 5 },                     /* index 3: 4 bits: 010x */
    { 6, 7 },                     /* index 4: 5 bits: 0100x */
    { /*-2*/ -33, /*2*/ -29 },    /* index 5: 5 bits: 0101x */
    { 8, /*-3*/ -34 },            /* index 6: 6 bits: 01000x */
    { /*3*/ -28, 9 },             /* index 7: 6 bits: 01001x */
    { /*-4*/ -35, /*4*/ -27 },    /* index 8: 7 bits: 010000x */
    { 10, 11 },                   /* index 9: 7 bits: 010011x */
    { /*5*/ -26, 12 },            /* index 10: 8 bits: 0100110x */
    { 13, 14 },                   /* index 11: 8 bits: 0100111x */
    { /*-6*/ -37, /*6*/ -25 },    /* index 12: 9 bits: 01001101x */
    { 15, 16 },                   /* index 13: 9 bits: 01001110x */
    { 17, /*-5*/ -36 },           /* index 14: 9 bits: 01001111x */
    { 18, /*-7*/ -38 },           /* index 15: 10 bits: 010011100x */
    { /*7*/ -24, 19 },            /* index 16: 10 bits: 010011101x */
    { 20, 21 },                   /* index 17: 10 bits: 010011110x */
    { /*9*/ -22, 22 },            /* index 18: 11 bits: 0100111000x */
    { 23, 24 },                   /* index 19: 11 bits: 0100111011x */
    { /*-8*/ -39, /*8*/ -23 },    /* index 20: 11 bits: 0100111100x */
    { 25, 26 },                   /* index 21: 11 bits: 0100111101x */
    { /*11*/ -20, 27 },           /* index 22: 12 bits: 01001110001x */
    { 28, 29 },                   /* index 23: 12 bits: 01001110110x */
    { /*-10*/ -41, /*10*/ -21 },  /* index 24: 12 bits: 01001110111x */
    { 30, 31 },                   /* index 25: 12 bits: 01001111010x */
    { 32, /*-9*/ -40 },           /* index 26: 12 bits: 01001111011x */
    { 33, /*-13*/ -44 },          /* index 27: 13 bits: 010011100011x */
    { /*13*/ -18, 34 },           /* index 28: 13 bits: 010011101100x */
    { 35, 36 },                   /* index 29: 13 bits: 010011101101x */
    { 37, /*-12*/ -43 },          /* index 30: 13 bits: 010011110100x */
    { /*12*/ -19, 38 },           /* index 31: 13 bits: 010011110101x */
    { 39, /*-11*/ -42 },          /* index 32: 13 bits: 010011110110x */
    { 40, 41 },                   /* index 33: 14 bits: 0100111000110x */
    { 42, 43 },                   /* index 34: 14 bits: 0100111011001x */
    { 44, 45 },                   /* index 35: 14 bits: 0100111011010x */
    { 46, /*-15*/ -46 },          /* index 36: 14 bits: 0100111011011x */
    { /*15*/ -16, 47 },           /* index 37: 14 bits: 0100111101000x */
    { /*-14*/ -45, /*14*/ -17 },  /* index 38: 14 bits: 0100111101011x */
    { 48, 49 },                   /* index 39: 14 bits: 0100111101100x */
    { /*-21*/ -52, /*-20*/ -51 }, /* index 40: 15 bits: 01001110001100x */
    { /*18*/ -13, /*19*/ -12 },   /* index 41: 15 bits: 01001110001101x */
    { /*-19*/ -50, /*-18*/ -49 }, /* index 42: 15 bits: 01001110110010x */
    { 50, 51 },                   /* index 43: 15 bits: 01001110110011x */
    { 52, 53 },                   /* index 44: 15 bits: 01001110110100x */
    { 54, 55 },                   /* index 45: 15 bits: 01001110110101x */
    { 56, /*-17*/ -48 },          /* index 46: 15 bits: 01001110110110x */
    { /*17*/ -14, 57 },           /* index 47: 15 bits: 01001111010001x */
    { 58, /*-16*/ -47 },          /* index 48: 15 bits: 01001111011000x */
    { /*16*/ -15, 59 },           /* index 49: 15 bits: 01001111011001x */
    { /*-26*/ -57, /*26*/ -5 },   /* index 50: 16 bits: 010011101100110x */
    { /*-28*/ -59, /*-27*/ -58 }, /* index 51: 16 bits: 010011101100111x */
    { /*29*/ -2, /*30*/ -1 },     /* index 52: 16 bits: 010011101101000x */
    { /*27*/ -4, /*28*/ -3 },     /* index 53: 16 bits: 010011101101001x */
    { /*-30*/ -61, /*-29*/ -60 }, /* index 54: 16 bits: 010011101101010x */
    { /*-25*/ -56, /*25*/ -6 },   /* index 55: 16 bits: 010011101101011x */
    { /*-24*/ -55, /*24*/ -7 },   /* index 56: 16 bits: 010011101101100x */
    { /*-23*/ -54, /*23*/ -8 },   /* index 57: 16 bits: 010011110100011x */
    { /*-22*/ -53, /*22*/ -9 },   /* index 58: 16 bits: 010011110110000x */
    { /*20*/ -11, /*21*/ -10 }    /* index 59: 16 bits: 010011110110011x */

################################################################################

TITLE
    libfaad2 f_huff_icc

TYPE
    8

DATA
    { /*0*/ -31, 1 },            /* index 0: 1 bits: x */
    { /*1*/ -30, 2 },            /* index 1: 2 bits: 1x */
    { /*-1*/ -32, 3 },           /* index 2: 3 bits: 11x */
    { /*2*/ -29, 4 },            /* index 3: 4 bits: 111x */
    { /*-2*/ -33, 5 },           /* index 4: 5 bits: 1111x */
    { /*3*/ -28, 6 },            /* index 5: 6 bits: 11111x */
    { /*-3*/ -34, 7 },           /* index 6: 7 bits: 111111x */
    { /*4*/ -27, 8 },            /* index 7: 8 bits: 1111111x */
    { /*5*/ -26, 9 },            /* index 8: 9 bits: 11111111x */
    { /*-4*/ -35, 10 },          /* index 9: 10 bits: 111111111x */
    { /*6*/ -25, 11 },           /* index 10: 11 bits: 1111111111x */
    { /*-5*/ -36, 12 },          /* index 11: 12 bits: 11111111111x */
    { /*7*/ -24, 13 },           /* index 12: 13 bits: 111111111111x */
    { /*-6*/ -37, /*-7*/ -38 }   /* index 13: 14 bits: 1111111111111x */

################################################################################

TITLE
    libfaad2 t_huff_icc

TYPE
    8

DATA
    { /*0*/ -31, 1 },            /* index 0: 1 bits: x */
    { /*1*/ -30, 2 },            /* index 1: 2 bits: 1x */
    { /*-1*/ -32, 3 },           /* index 2: 3 bits: 11x */
    { /*2*/ -29, 4 },            /* index 3: 4 bits: 111x */
    { /*-2*/ -33, 5 },           /* index 4: 5 bits: 1111x */
    { /*3*/ -28, 6 },            /* index 5: 6 bits: 11111x */
    { /*-3*/ -34, 7 },           /* index 6: 7 bits: 111111x */
    { /*4*/ -27, 8 },            /* index 7: 8 bits: 1111111x */
    { /*-4*/ -35, 9 },           /* index 8: 9 bits: 11111111x */
    { /*5*/ -26, 10 },           /* index 9: 10 bits: 111111111x */
    { /*-5*/ -36, 11 },          /* index 10: 11 bits: 1111111111x */
    { /*6*/ -25, 12 },           /* index 11: 12 bits: 11111111111x */
    { /*-6*/ -37, 13 },          /* index 12: 13 bits: 111111111111x */
    { /*-7*/ -38, /*7*/ -24 }    /* index 13: 14 bits: 1111111111111x */

################################################################################

TITLE
    libfaad2 f_huff_ipd

TYPE
    8

DATA
    { 1, /*0*/ -31 },         /* index 0: 1 bits: x */
    { 2, 3 },                 /* index 1: 2 bits: 0x */
    { /*1*/ -30, 4 },         /* index 2: 3 bits: 00x */
    { 5, 6 },                 /* index 3: 3 bits: 01x */
    { /*4*/ -27, /*5*/ -26 }, /* index 4: 4 bits: 001x */
    { /*3*/ -28, /*6*/ -25 }, /* index 5: 4 bits: 010x */
    { /*2*/ -29, /*7*/ -24 }  /* index 6: 4 bits: 011x */

################################################################################

TITLE
    libfaad2 t_huff_ipd

TYPE
    8

DATA
    { 1, /*0*/ -31 },         /* index 0: 1 bits: x */
    { 2, 3 },                 /* index 1: 2 bits: 0x */
    { 4, 5 },                 /* index 2: 3 bits: 00x */
    { /*1*/ -30, /*7*/ -24 }, /* index 3: 3 bits: 01x */
    { /*5*/ -26, 6 },         /* index 4: 4 bits: 000x */
    { /*2*/ -29, /*6*/ -25 }, /* index 5: 4 bits: 001x */
    { /*4*/ -27, /*3*/ -28 }  /* index 6: 5 bits: 0001x */

################################################################################

TITLE
    libfaad2 f_huff_opd

TYPE
    8

DATA
    { 1, /*0*/ -31 },         /* index 0: 1 bits: x */
    { 2, 3 },                 /* index 1: 2 bits: 0x */
    { /*7*/ -24, /*1*/ -30 }, /* index 2: 3 bits: 00x */
    { 4, 5 },                 /* index 3: 3 bits: 01x */
    { /*3*/ -28, /*6*/ -25 }, /* index 4: 4 bits: 010x */
    { /*2*/ -29, 6 },         /* index 5: 4 bits: 011x */
    { /*5*/ -26, /*4*/ -27 }  /* index 6: 5 bits: 0111x */

################################################################################

TITLE
    libmpcodecs DTS_BITRATES

TYPE
    32

DATA
  32000,
  56000,
  64000,
  96000,
  112000,
  128000,
  192000,
  224000,
  256000,
  320000,
  384000,
  448000,
  512000,
  576000,
  640000,
  768000,
  896000,
  1024000,
  1152000,
  1280000,
  1344000,
  1408000,
  1411200,
  1472000,
  1536000,
  1920000,
  2048000,
  3072000,
  3840000,
  4096000

################################################################################

TITLE
    asf_stream_header_guid

TYPE
    8

DATA
    0x91, 0x07, 0xdc, 0xb7, 0xb7, 0xa9, 0xcf, 0x11, 0x8e, 0xe6, 0x00, 0xc0, 0x0c, 0x20, 0x53, 0x65

################################################################################

TITLE
    asf_file_header_guid

TYPE
    8

DATA
    0xa1, 0xdc, 0xab, 0x8c, 0x47, 0xa9, 0xcf, 0x11, 0x8e, 0xe4, 0x00, 0xc0, 0x0c, 0x20, 0x53, 0x65};

################################################################################

TITLE
    asf_content_desc_guid

TYPE
    8

DATA
    0x33, 0x26, 0xb2, 0x75, 0x8e, 0x66, 0xcf, 0x11, 0xa6, 0xd9, 0x00, 0xaa, 0x00, 0x62, 0xce, 0x6c};

################################################################################

TITLE
    asf_stream_group_guid

TYPE
    8

DATA
    0xce, 0x75, 0xf8, 0x7b, 0x8d, 0x46, 0xd1, 0x11, 0x8d, 0x82, 0x00, 0x60, 0x97, 0xc9, 0xa2, 0xb2};

################################################################################

TITLE
    asf_data_chunk_guid

TYPE
    8

DATA
    0x36, 0x26, 0xb2, 0x75, 0x8e, 0x66, 0xcf, 0x11, 0xa6, 0xd9, 0x00, 0xaa, 0x00, 0x62, 0xce, 0x6c};

################################################################################

TITLE
    asf_ext_stream_embed_stream_header

TYPE
    8

DATA
    0xe2, 0x65, 0xfb, 0x3a, 0xef, 0x47, 0xf2, 0x40, 0xac, 0x2c, 0x70, 0xa9, 0x0d, 0x71, 0xd3, 0x43};

################################################################################

TITLE
    asf_ext_stream_audio

TYPE
    8

DATA
    0x9d, 0x8c, 0x17, 0x31, 0xe1, 0x03, 0x28, 0x45, 0xb5, 0x82, 0x3d, 0xf9, 0xdb, 0x22, 0xf5, 0x03};

################################################################################

TITLE
    asf_ext_stream_header

TYPE
    8

DATA
    0xCB, 0xA5, 0xE6, 0x14, 0x72, 0xC6, 0x32, 0x43, 0x83, 0x99, 0xA9, 0x69, 0x52, 0x06, 0x5B, 0x5A};

################################################################################

TITLE
    libmpdemux sipr_swaps

TYPE
    8

DATA
    {0,63},{1,22},{2,44},{3,90},{5,81},{7,31},{8,86},{9,58},{10,36},{12,68},
    {13,39},{14,73},{15,53},{16,69},{17,57},{19,88},{20,34},{21,71},{24,46},
    {25,94},{26,54},{28,75},{29,50},{32,70},{33,92},{35,74},{38,85},{40,56},
    {42,87},{43,65},{45,59},{48,79},{49,93},{51,89},{55,95},{61,76},{67,83},
    {77,80} };

################################################################################

TITLE
    libmpdemux Matroska cook_fl2bps

TYPE
    32

DATA
    {1000, 1378, 2024, 2584, 4005, 5513, 8010, 4005, 750, 2498,
     4048, 5513, 8010, 11973, 8010, 2584, 4005, 2067, 2584, 2584,
     4005, 4005, 5513, 5513, 8010, 12059, 1550, 8010, 12059, 5513,
     12016, 16408, 22911, 33506};

################################################################################

TITLE
    libmpdemux tivo Series1AudioWithPTS

TYPE
    32

DATA
   347   395   491   587   779   875

################################################################################

TITLE
    libmpdemux tivo Series2AudioWithPTS

TYPE
    32
DATA
0x0160,0x0190,0x01f0,0x0250,0x0310,0x0370,

################################################################################

TITLE
    libmpdemux vivo h263_format

TYPE
    16

DATA
    { 0, 0 },
    { 128, 96 },
    { 176, 144 },
    { 352, 288 },
    { 704, 576 },
    { 1408, 1152 },
    { 320, 240 }   // ??????? or 240x180 (found in vivo2) ?

################################################################################

TITLE
    libmpdvdkit2 css pp_perm_challenge

TYPE
    8

DATA
            { { 1, 3, 0, 7, 5, 2, 9, 6, 4, 8 },
              { 6, 1, 9, 3, 8, 5, 7, 4, 0, 2 },
              { 4, 0, 3, 5, 7, 2, 8, 6, 1, 9 } };

################################################################################

TITLE
    libmpdvdkit2 css pp_perm_variant

TYPE
    8

DATA
            { { 0x0a, 0x08, 0x0e, 0x0c, 0x0b, 0x09, 0x0f, 0x0d,
                0x1a, 0x18, 0x1e, 0x1c, 0x1b, 0x19, 0x1f, 0x1d,
                0x02, 0x00, 0x06, 0x04, 0x03, 0x01, 0x07, 0x05,
                0x12, 0x10, 0x16, 0x14, 0x13, 0x11, 0x17, 0x15 },
              { 0x12, 0x1a, 0x16, 0x1e, 0x02, 0x0a, 0x06, 0x0e,
                0x10, 0x18, 0x14, 0x1c, 0x00, 0x08, 0x04, 0x0c,
                0x13, 0x1b, 0x17, 0x1f, 0x03, 0x0b, 0x07, 0x0f,
                0x11, 0x19, 0x15, 0x1d, 0x01, 0x09, 0x05, 0x0d } };

################################################################################

TITLE
    libmpdvdkit2 css p_variants

TYPE
    8

DATA
            {   0xB7, 0x74, 0x85, 0xD0, 0xCC, 0xDB, 0xCA, 0x73,
                0x03, 0xFE, 0x31, 0x03, 0x52, 0xE0, 0xB7, 0x42,
                0x63, 0x16, 0xF2, 0x2A, 0x79, 0x52, 0xFF, 0x1B,
                0x7A, 0x11, 0xCA, 0x1A, 0x9B, 0x40, 0xAD, 0x01 };

################################################################################

TITLE
    libmpdvdkit2 css p_secret

TYPE
    8

DATA
    0x55, 0xD6, 0xC4, 0xC5, 0x28

################################################################################

TITLE
    libmpdvdkit2 css alternate DVD player keys

TYPE
    8

DATA
    { 0x01, 0xaf, 0xe3, 0x12, 0x80 },
    { 0x12, 0x11, 0xca, 0x04, 0x3b },
    { 0x14, 0x0c, 0x9e, 0xd0, 0x09 },
    { 0x14, 0x71, 0x35, 0xba, 0xe2 },
    { 0x1a, 0xa4, 0x33, 0x21, 0xa6 },
    { 0x26, 0xec, 0xc4, 0xa7, 0x4e },
    { 0x2c, 0xb2, 0xc1, 0x09, 0xee },
    { 0x2f, 0x25, 0x9e, 0x96, 0xdd },
    { 0x33, 0x2f, 0x49, 0x6c, 0xe0 },
    { 0x35, 0x5b, 0xc1, 0x31, 0x0f },
    { 0x36, 0x67, 0xb2, 0xe3, 0x85 },
    { 0x39, 0x3d, 0xf1, 0xf1, 0xbd },
    { 0x3b, 0x31, 0x34, 0x0d, 0x91 },
    { 0x45, 0xed, 0x28, 0xeb, 0xd3 },
    { 0x48, 0xb7, 0x6c, 0xce, 0x69 },
    { 0x4b, 0x65, 0x0d, 0xc1, 0xee },
    { 0x4c, 0xbb, 0xf5, 0x5b, 0x23 },
    { 0x51, 0x67, 0x67, 0xc5, 0xe0 },
    { 0x53, 0x94, 0xe1, 0x75, 0xbf },
    { 0x57, 0x2c, 0x8b, 0x31, 0xae },
    { 0x63, 0xdb, 0x4c, 0x5b, 0x4a },
    { 0x7b, 0x1e, 0x5e, 0x2b, 0x57 },
    { 0x85, 0xf3, 0x85, 0xa0, 0xe0 },
    { 0xab, 0x1e, 0xe7, 0x7b, 0x72 },
    { 0xab, 0x36, 0xe3, 0xeb, 0x76 },
    { 0xb1, 0xb8, 0xf9, 0x38, 0x03 },
    { 0xb8, 0x5d, 0xd8, 0x53, 0xbd },
    { 0xbf, 0x92, 0xc3, 0xb0, 0xe2 },
    { 0xcf, 0x1a, 0xb2, 0xf8, 0x0a },
    { 0xec, 0xa0, 0xcf, 0xb3, 0xff },
    { 0xfc, 0x95, 0xa9, 0x87, 0x35 }

################################################################################

TITLE
    libmpdvdkit2 p_css_tab2

TYPE
    8

DATA
    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
    0x09, 0x08, 0x0b, 0x0a, 0x0d, 0x0c, 0x0f, 0x0e,
    0x12, 0x13, 0x10, 0x11, 0x16, 0x17, 0x14, 0x15,
    0x1b, 0x1a, 0x19, 0x18, 0x1f, 0x1e, 0x1d, 0x1c,
    0x24, 0x25, 0x26, 0x27, 0x20, 0x21, 0x22, 0x23,
    0x2d, 0x2c, 0x2f, 0x2e, 0x29, 0x28, 0x2b, 0x2a,
    0x36, 0x37, 0x34, 0x35, 0x32, 0x33, 0x30, 0x31,
    0x3f, 0x3e, 0x3d, 0x3c, 0x3b, 0x3a, 0x39, 0x38,
    0x49, 0x48, 0x4b, 0x4a, 0x4d, 0x4c, 0x4f, 0x4e,
    0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
    0x5b, 0x5a, 0x59, 0x58, 0x5f, 0x5e, 0x5d, 0x5c,
    0x52, 0x53, 0x50, 0x51, 0x56, 0x57, 0x54, 0x55,
    0x6d, 0x6c, 0x6f, 0x6e, 0x69, 0x68, 0x6b, 0x6a,
    0x64, 0x65, 0x66, 0x67, 0x60, 0x61, 0x62, 0x63,
    0x7f, 0x7e, 0x7d, 0x7c, 0x7b, 0x7a, 0x79, 0x78,
    0x76, 0x77, 0x74, 0x75, 0x72, 0x73, 0x70, 0x71,
    0x92, 0x93, 0x90, 0x91, 0x96, 0x97, 0x94, 0x95,
    0x9b, 0x9a, 0x99, 0x98, 0x9f, 0x9e, 0x9d, 0x9c,
    0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
    0x89, 0x88, 0x8b, 0x8a, 0x8d, 0x8c, 0x8f, 0x8e,
    0xb6, 0xb7, 0xb4, 0xb5, 0xb2, 0xb3, 0xb0, 0xb1,
    0xbf, 0xbe, 0xbd, 0xbc, 0xbb, 0xba, 0xb9, 0xb8,
    0xa4, 0xa5, 0xa6, 0xa7, 0xa0, 0xa1, 0xa2, 0xa3,
    0xad, 0xac, 0xaf, 0xae, 0xa9, 0xa8, 0xab, 0xaa,
    0xdb, 0xda, 0xd9, 0xd8, 0xdf, 0xde, 0xdd, 0xdc,
    0xd2, 0xd3, 0xd0, 0xd1, 0xd6, 0xd7, 0xd4, 0xd5,
    0xc9, 0xc8, 0xcb, 0xca, 0xcd, 0xcc, 0xcf, 0xce,
    0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
    0xff, 0xfe, 0xfd, 0xfc, 0xfb, 0xfa, 0xf9, 0xf8,
    0xf6, 0xf7, 0xf4, 0xf5, 0xf2, 0xf3, 0xf0, 0xf1,
    0xed, 0xec, 0xef, 0xee, 0xe9, 0xe8, 0xeb, 0xea,
    0xe4, 0xe5, 0xe6, 0xe7, 0xe0, 0xe1, 0xe2, 0xe3

################################################################################

TITLE
    libmpdvdkit2 p_css_tab3

TYPE
    8

DATA
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff,
    0x00, 0x24, 0x49, 0x6d, 0x92, 0xb6, 0xdb, 0xff

################################################################################

TITLE
    libmpdvdkit2 p_css_tab5

TYPE
    8

DATA
    0xff, 0x7f, 0xbf, 0x3f, 0xdf, 0x5f, 0x9f, 0x1f,
    0xef, 0x6f, 0xaf, 0x2f, 0xcf, 0x4f, 0x8f, 0x0f,
    0xf7, 0x77, 0xb7, 0x37, 0xd7, 0x57, 0x97, 0x17,
    0xe7, 0x67, 0xa7, 0x27, 0xc7, 0x47, 0x87, 0x07,
    0xfb, 0x7b, 0xbb, 0x3b, 0xdb, 0x5b, 0x9b, 0x1b,
    0xeb, 0x6b, 0xab, 0x2b, 0xcb, 0x4b, 0x8b, 0x0b,
    0xf3, 0x73, 0xb3, 0x33, 0xd3, 0x53, 0x93, 0x13,
    0xe3, 0x63, 0xa3, 0x23, 0xc3, 0x43, 0x83, 0x03,
    0xfd, 0x7d, 0xbd, 0x3d, 0xdd, 0x5d, 0x9d, 0x1d,
    0xed, 0x6d, 0xad, 0x2d, 0xcd, 0x4d, 0x8d, 0x0d,
    0xf5, 0x75, 0xb5, 0x35, 0xd5, 0x55, 0x95, 0x15,
    0xe5, 0x65, 0xa5, 0x25, 0xc5, 0x45, 0x85, 0x05,
    0xf9, 0x79, 0xb9, 0x39, 0xd9, 0x59, 0x99, 0x19,
    0xe9, 0x69, 0xa9, 0x29, 0xc9, 0x49, 0x89, 0x09,
    0xf1, 0x71, 0xb1, 0x31, 0xd1, 0x51, 0x91, 0x11,
    0xe1, 0x61, 0xa1, 0x21, 0xc1, 0x41, 0x81, 0x01,
    0xfe, 0x7e, 0xbe, 0x3e, 0xde, 0x5e, 0x9e, 0x1e,
    0xee, 0x6e, 0xae, 0x2e, 0xce, 0x4e, 0x8e, 0x0e,
    0xf6, 0x76, 0xb6, 0x36, 0xd6, 0x56, 0x96, 0x16,
    0xe6, 0x66, 0xa6, 0x26, 0xc6, 0x46, 0x86, 0x06,
    0xfa, 0x7a, 0xba, 0x3a, 0xda, 0x5a, 0x9a, 0x1a,
    0xea, 0x6a, 0xaa, 0x2a, 0xca, 0x4a, 0x8a, 0x0a,
    0xf2, 0x72, 0xb2, 0x32, 0xd2, 0x52, 0x92, 0x12,
    0xe2, 0x62, 0xa2, 0x22, 0xc2, 0x42, 0x82, 0x02,
    0xfc, 0x7c, 0xbc, 0x3c, 0xdc, 0x5c, 0x9c, 0x1c,
    0xec, 0x6c, 0xac, 0x2c, 0xcc, 0x4c, 0x8c, 0x0c,
    0xf4, 0x74, 0xb4, 0x34, 0xd4, 0x54, 0x94, 0x14,
    0xe4, 0x64, 0xa4, 0x24, 0xc4, 0x44, 0x84, 0x04,
    0xf8, 0x78, 0xb8, 0x38, 0xd8, 0x58, 0x98, 0x18,
    0xe8, 0x68, 0xa8, 0x28, 0xc8, 0x48, 0x88, 0x08,
    0xf0, 0x70, 0xb0, 0x30, 0xd0, 0x50, 0x90, 0x10,
    0xe0, 0x60, 0xa0, 0x20, 0xc0, 0x40, 0x80, 0x00

################################################################################

TITLE
    libmpdvdkit2 p_crypt_tab0

TYPE
    8

DATA
    0xB7, 0xF4, 0x82, 0x57, 0xDA, 0x4D, 0xDB, 0xE2,
    0x2F, 0x52, 0x1A, 0xA8, 0x68, 0x5A, 0x8A, 0xFF,
    0xFB, 0x0E, 0x6D, 0x35, 0xF7, 0x5C, 0x76, 0x12,
    0xCE, 0x25, 0x79, 0x29, 0x39, 0x62, 0x08, 0x24,
    0xA5, 0x85, 0x7B, 0x56, 0x01, 0x23, 0x68, 0xCF,
    0x0A, 0xE2, 0x5A, 0xED, 0x3D, 0x59, 0xB0, 0xA9,
    0xB0, 0x2C, 0xF2, 0xB8, 0xEF, 0x32, 0xA9, 0x40,
    0x80, 0x71, 0xAF, 0x1E, 0xDE, 0x8F, 0x58, 0x88,
    0xB8, 0x3A, 0xD0, 0xFC, 0xC4, 0x1E, 0xB5, 0xA0,
    0xBB, 0x3B, 0x0F, 0x01, 0x7E, 0x1F, 0x9F, 0xD9,
    0xAA, 0xB8, 0x3D, 0x9D, 0x74, 0x1E, 0x25, 0xDB,
    0x37, 0x56, 0x8F, 0x16, 0xBA, 0x49, 0x2B, 0xAC,
    0xD0, 0xBD, 0x95, 0x20, 0xBE, 0x7A, 0x28, 0xD0,
    0x51, 0x64, 0x63, 0x1C, 0x7F, 0x66, 0x10, 0xBB,
    0xC4, 0x56, 0x1A, 0x04, 0x6E, 0x0A, 0xEC, 0x9C,
    0xD6, 0xE8, 0x9A, 0x7A, 0xCF, 0x8C, 0xDB, 0xB1,
    0xEF, 0x71, 0xDE, 0x31, 0xFF, 0x54, 0x3E, 0x5E,
    0x07, 0x69, 0x96, 0xB0, 0xCF, 0xDD, 0x9E, 0x47,
    0xC7, 0x96, 0x8F, 0xE4, 0x2B, 0x59, 0xC6, 0xEE,
    0xB9, 0x86, 0x9A, 0x64, 0x84, 0x72, 0xE2, 0x5B,
    0xA2, 0x96, 0x58, 0x99, 0x50, 0x03, 0xF5, 0x38,
    0x4D, 0x02, 0x7D, 0xE7, 0x7D, 0x75, 0xA7, 0xB8,
    0x67, 0x87, 0x84, 0x3F, 0x1D, 0x11, 0xE5, 0xFC,
    0x1E, 0xD3, 0x83, 0x16, 0xA5, 0x29, 0xF6, 0xC7,
    0x15, 0x61, 0x29, 0x1A, 0x43, 0x4F, 0x9B, 0xAF,
    0xC5, 0x87, 0x34, 0x6C, 0x0F, 0x3B, 0xA8, 0x1D,
    0x45, 0x58, 0x25, 0xDC, 0xA8, 0xA3, 0x3B, 0xD1,
    0x79, 0x1B, 0x48, 0xF2, 0xE9, 0x93, 0x1F, 0xFC,
    0xDB, 0x2A, 0x90, 0xA9, 0x8A, 0x3D, 0x39, 0x18,
    0xA3, 0x8E, 0x58, 0x6C, 0xE0, 0x12, 0xBB, 0x25,
    0xCD, 0x71, 0x22, 0xA2, 0x64, 0xC6, 0xE7, 0xFB,
    0xAD, 0x94, 0x77, 0x04, 0x9A, 0x39, 0xCF, 0x7C

################################################################################

TITLE
    libmpdvdkit2 p_crypt_tab1

TYPE
    8

DATA
    0x8C, 0x47, 0xB0, 0xE1, 0xEB, 0xFC, 0xEB, 0x56,
    0x10, 0xE5, 0x2C, 0x1A, 0x5D, 0xEF, 0xBE, 0x4F,
    0x08, 0x75, 0x97, 0x4B, 0x0E, 0x25, 0x8E, 0x6E,
    0x39, 0x5A, 0x87, 0x53, 0xC4, 0x1F, 0xF4, 0x5C,
    0x4E, 0xE6, 0x99, 0x30, 0xE0, 0x42, 0x88, 0xAB,
    0xE5, 0x85, 0xBC, 0x8F, 0xD8, 0x3C, 0x54, 0xC9,
    0x53, 0x47, 0x18, 0xD6, 0x06, 0x5B, 0x41, 0x2C,
    0x67, 0x1E, 0x41, 0x74, 0x33, 0xE2, 0xB4, 0xE0,
    0x23, 0x29, 0x42, 0xEA, 0x55, 0x0F, 0x25, 0xB4,
    0x24, 0x2C, 0x99, 0x13, 0xEB, 0x0A, 0x0B, 0xC9,
    0xF9, 0x63, 0x67, 0x43, 0x2D, 0xC7, 0x7D, 0x07,
    0x60, 0x89, 0xD1, 0xCC, 0xE7, 0x94, 0x77, 0x74,
    0x9B, 0x7E, 0xD7, 0xE6, 0xFF, 0xBB, 0x68, 0x14,
    0x1E, 0xA3, 0x25, 0xDE, 0x3A, 0xA3, 0x54, 0x7B,
    0x87, 0x9D, 0x50, 0xCA, 0x27, 0xC3, 0xA4, 0x50,
    0x91, 0x27, 0xD4, 0xB0, 0x82, 0x41, 0x97, 0x79,
    0x94, 0x82, 0xAC, 0xC7, 0x8E, 0xA5, 0x4E, 0xAA,
    0x78, 0x9E, 0xE0, 0x42, 0xBA, 0x28, 0xEA, 0xB7,
    0x74, 0xAD, 0x35, 0xDA, 0x92, 0x60, 0x7E, 0xD2,
    0x0E, 0xB9, 0x24, 0x5E, 0x39, 0x4F, 0x5E, 0x63,
    0x09, 0xB5, 0xFA, 0xBF, 0xF1, 0x22, 0x55, 0x1C,
    0xE2, 0x25, 0xDB, 0xC5, 0xD8, 0x50, 0x03, 0x98,
    0xC4, 0xAC, 0x2E, 0x11, 0xB4, 0x38, 0x4D, 0xD0,
    0xB9, 0xFC, 0x2D, 0x3C, 0x08, 0x04, 0x5A, 0xEF,
    0xCE, 0x32, 0xFB, 0x4C, 0x92, 0x1E, 0x4B, 0xFB,
    0x1A, 0xD0, 0xE2, 0x3E, 0xDA, 0x6E, 0x7C, 0x4D,
    0x56, 0xC3, 0x3F, 0x42, 0xB1, 0x3A, 0x23, 0x4D,
    0x6E, 0x84, 0x56, 0x68, 0xF4, 0x0E, 0x03, 0x64,
    0xD0, 0xA9, 0x92, 0x2F, 0x8B, 0xBC, 0x39, 0x9C,
    0xAC, 0x09, 0x5E, 0xEE, 0xE5, 0x97, 0xBF, 0xA5,
    0xCE, 0xFA, 0x28, 0x2C, 0x6D, 0x4F, 0xEF, 0x77,
    0xAA, 0x1B, 0x79, 0x8E, 0x97, 0xB4, 0xC3, 0xF4

################################################################################

TITLE
    libmpdvdkit2 p_crypt_tab2

TYPE
    8

DATA
    0xB7, 0x75, 0x81, 0xD5, 0xDC, 0xCA, 0xDE, 0x66,
    0x23, 0xDF, 0x15, 0x26, 0x62, 0xD1, 0x83, 0x77,
    0xE3, 0x97, 0x76, 0xAF, 0xE9, 0xC3, 0x6B, 0x8E,
    0xDA, 0xB0, 0x6E, 0xBF, 0x2B, 0xF1, 0x19, 0xB4,
    0x95, 0x34, 0x48, 0xE4, 0x37, 0x94, 0x5D, 0x7B,
    0x36, 0x5F, 0x65, 0x53, 0x07, 0xE2, 0x89, 0x11,
    0x98, 0x85, 0xD9, 0x12, 0xC1, 0x9D, 0x84, 0xEC,
    0xA4, 0xD4, 0x88, 0xB8, 0xFC, 0x2C, 0x79, 0x28,
    0xD8, 0xDB, 0xB3, 0x1E, 0xA2, 0xF9, 0xD0, 0x44,
    0xD7, 0xD6, 0x60, 0xEF, 0x14, 0xF4, 0xF6, 0x31,
    0xD2, 0x41, 0x46, 0x67, 0x0A, 0xE1, 0x58, 0x27,
    0x43, 0xA3, 0xF8, 0xE0, 0xC8, 0xBA, 0x5A, 0x5C,
    0x80, 0x6C, 0xC6, 0xF2, 0xE8, 0xAD, 0x7D, 0x04,
    0x0D, 0xB9, 0x3C, 0xC2, 0x25, 0xBD, 0x49, 0x63,
    0x8C, 0x9F, 0x51, 0xCE, 0x20, 0xC5, 0xA1, 0x50,
    0x92, 0x2D, 0xDD, 0xBC, 0x8D, 0x4F, 0x9A, 0x71,
    0x2F, 0x30, 0x1D, 0x73, 0x39, 0x13, 0xFB, 0x1A,
    0xCB, 0x24, 0x59, 0xFE, 0x05, 0x96, 0x57, 0x0F,
    0x1F, 0xCF, 0x54, 0xBE, 0xF5, 0x06, 0x1B, 0xB2,
    0x6D, 0xD3, 0x4D, 0x32, 0x56, 0x21, 0x33, 0x0B,
    0x52, 0xE7, 0xAB, 0xEB, 0xA6, 0x74, 0x00, 0x4C,
    0xB1, 0x7F, 0x82, 0x99, 0x87, 0x0E, 0x5E, 0xC0,
    0x8F, 0xEE, 0x6F, 0x55, 0xF3, 0x7E, 0x08, 0x90,
    0xFA, 0xB6, 0x64, 0x70, 0x47, 0x4A, 0x17, 0xA7,
    0xB5, 0x40, 0x8A, 0x38, 0xE5, 0x68, 0x3E, 0x8B,
    0x69, 0xAA, 0x9B, 0x42, 0xA5, 0x10, 0x01, 0x35,
    0xFD, 0x61, 0x9E, 0xE6, 0x16, 0x9C, 0x86, 0xED,
    0xCD, 0x2E, 0xFF, 0xC4, 0x5B, 0xA0, 0xAE, 0xCC,
    0x4B, 0x3B, 0x03, 0xBB, 0x1C, 0x2A, 0xAC, 0x0C,
    0x3F, 0x93, 0xC7, 0x72, 0x7A, 0x09, 0x22, 0x3D,
    0x45, 0x78, 0xA9, 0xA8, 0xEA, 0xC9, 0x6A, 0xF7,
    0x29, 0x91, 0xF0, 0x02, 0x18, 0x3A, 0x4E, 0x7C

################################################################################

TITLE
    libmpdvdkit2 p_crypt_tab3

TYPE
    8

DATA
    0x73, 0x51, 0x95, 0xE1, 0x12, 0xE4, 0xC0, 0x58,
    0xEE, 0xF2, 0x08, 0x1B, 0xA9, 0xFA, 0x98, 0x4C,
    0xA7, 0x33, 0xE2, 0x1B, 0xA7, 0x6D, 0xF5, 0x30,
    0x97, 0x1D, 0xF3, 0x02, 0x60, 0x5A, 0x82, 0x0F,
    0x91, 0xD0, 0x9C, 0x10, 0x39, 0x7A, 0x83, 0x85,
    0x3B, 0xB2, 0xB8, 0xAE, 0x0C, 0x09, 0x52, 0xEA,
    0x1C, 0xE1, 0x8D, 0x66, 0x4F, 0xF3, 0xDA, 0x92,
    0x29, 0xB9, 0xD5, 0xC5, 0x77, 0x47, 0x22, 0x53,
    0x14, 0xF7, 0xAF, 0x22, 0x64, 0xDF, 0xC6, 0x72,
    0x12, 0xF3, 0x75, 0xDA, 0xD7, 0xD7, 0xE5, 0x02,
    0x9E, 0xED, 0xDA, 0xDB, 0x4C, 0x47, 0xCE, 0x91,
    0x06, 0x06, 0x6D, 0x55, 0x8B, 0x19, 0xC9, 0xEF,
    0x8C, 0x80, 0x1A, 0x0E, 0xEE, 0x4B, 0xAB, 0xF2,
    0x08, 0x5C, 0xE9, 0x37, 0x26, 0x5E, 0x9A, 0x90,
    0x00, 0xF3, 0x0D, 0xB2, 0xA6, 0xA3, 0xF7, 0x26,
    0x17, 0x48, 0x88, 0xC9, 0x0E, 0x2C, 0xC9, 0x02,
    0xE7, 0x18, 0x05, 0x4B, 0xF3, 0x39, 0xE1, 0x20,
    0x02, 0x0D, 0x40, 0xC7, 0xCA, 0xB9, 0x48, 0x30,
    0x57, 0x67, 0xCC, 0x06, 0xBF, 0xAC, 0x81, 0x08,
    0x24, 0x7A, 0xD4, 0x8B, 0x19, 0x8E, 0xAC, 0xB4,
    0x5A, 0x0F, 0x73, 0x13, 0xAC, 0x9E, 0xDA, 0xB6,
    0xB8, 0x96, 0x5B, 0x60, 0x88, 0xE1, 0x81, 0x3F,
    0x07, 0x86, 0x37, 0x2D, 0x79, 0x14, 0x52, 0xEA,
    0x73, 0xDF, 0x3D, 0x09, 0xC8, 0x25, 0x48, 0xD8,
    0x75, 0x60, 0x9A, 0x08, 0x27, 0x4A, 0x2C, 0xB9,
    0xA8, 0x8B, 0x8A, 0x73, 0x62, 0x37, 0x16, 0x02,
    0xBD, 0xC1, 0x0E, 0x56, 0x54, 0x3E, 0x14, 0x5F,
    0x8C, 0x8F, 0x6E, 0x75, 0x1C, 0x07, 0x39, 0x7B,
    0x4B, 0xDB, 0xD3, 0x4B, 0x1E, 0xC8, 0x7E, 0xFE,
    0x3E, 0x72, 0x16, 0x83, 0x7D, 0xEE, 0xF5, 0xCA,
    0xC5, 0x18, 0xF9, 0xD8, 0x68, 0xAB, 0x38, 0x85,
    0xA8, 0xF0, 0xA1, 0x73, 0x9F, 0x5D, 0x19, 0x0B,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x33, 0x72, 0x39, 0x25, 0x67, 0x26, 0x6D, 0x71,
    0x36, 0x77, 0x3C, 0x20, 0x62, 0x23, 0x68, 0x74,
    0xC3, 0x82, 0xC9, 0x15, 0x57, 0x16, 0x5D, 0x81

################################################################################

TITLE
    libmpeg2 default_intra_quantizer_matrix

TYPE
    8

DATA
    8,
    16, 16,
    19, 16, 19,
    22, 22, 22, 22,
    22, 22, 26, 24, 26,
    27, 27, 27, 26, 26, 26,
    26, 27, 27, 27, 29, 29, 29,
    34, 34, 34, 29, 29, 29, 27, 27,
    29, 29, 32, 32, 34, 34, 37,
    38, 37, 35, 35, 34, 35,
    38, 38, 40, 40, 40,
    48, 48, 46, 46,
    56, 56, 58,
    69, 69,
    83

################################################################################

TITLE
    YUV to RGB dither_2x2_4

TYPE
    8

DATA
{  1,   3,   1,   3,   1,   3,   1,   3, },
{  2,   0,   2,   0,   2,   0,   2,   0, },

################################################################################

TITLE
    YUV to RGB dither_2x2_8

TYPE
    8

DATA
{  6,   2,   6,   2,   6,   2,   6,   2, },
{  0,   4,   0,   4,   0,   4,   0,   4, },

################################################################################

TITLE
    YUV to RGB dither_8x8_32

TYPE
    8

DATA
{ 17,   9,  23,  15,  16,   8,  22,  14, },
{  5,  29,   3,  27,   4,  28,   2,  26, },
{ 21,  13,  19,  11,  20,  12,  18,  10, },
{  0,  24,   6,  30,   1,  25,   7,  31, },
{ 16,   8,  22,  14,  17,   9,  23,  15, },
{  4,  28,   2,  26,   5,  29,   3,  27, },
{ 20,  12,  18,  10,  21,  13,  19,  11, },
{  1,  25,   7,  31,   0,  24,   6,  30, },

################################################################################

TITLE
    YUV to RGB dither_8x8_64

TYPE
    8

DATA
{  0,  48,  12,  60,   3,  51,  15,  63, },
{ 32,  16,  44,  28,  35,  19,  47,  31, },
{  8,  56,   4,  52,  11,  59,   7,  55, },
{ 40,  24,  36,  20,  43,  27,  39,  23, },
{  2,  50,  14,  62,   1,  49,  13,  61, },
{ 34,  18,  46,  30,  33,  17,  45,  29, },
{ 10,  58,   6,  54,   9,  57,   5,  53, },
{ 42,  26,  38,  22,  41,  25,  37,  21, },

################################################################################

TITLE
    YUV to RGB dither_8x8_73

TYPE
    8

DATA
{  0,  55,  14,  68,   3,  58,  17,  72, },
{ 37,  18,  50,  32,  40,  22,  54,  35, },
{  9,  64,   5,  59,  13,  67,   8,  63, },
{ 46,  27,  41,  23,  49,  31,  44,  26, },
{  2,  57,  16,  71,   1,  56,  15,  70, },
{ 39,  21,  52,  34,  38,  19,  51,  33, },
{ 11,  66,   7,  62,  10,  65,   6,  60, },
{ 48,  30,  43,  25,  47,  29,  42,  24, },

################################################################################

TITLE
    YUV to RGB dither_8x8_128

TYPE
    8

DATA
{ 68,  36,  92,  60,  66,  34,  90,  58, },
{ 20, 116,  12, 108,  18, 114,  10, 106, },
{ 84,  52,  76,  44,  82,  50,  74,  42, },
{  0,  96,  24, 120,   6, 102,  30, 126, },
{ 64,  32,  88,  56,  70,  38,  94,  62, },
{ 16, 112,   8, 104,  22, 118,  14, 110, },
{ 80,  48,  72,  40,  86,  54,  78,  46, },
{  4, 100,  28, 124,   2,  98,  26, 122, },

################################################################################

TITLE
    YUV to RGB dither_8x8_220

TYPE
    8

DATA
{117,  62, 158, 103, 113,  58, 155, 100, },
{ 34, 199,  21, 186,  31, 196,  17, 182, },
{144,  89, 131,  76, 141,  86, 127,  72, },
{  0, 165,  41, 206,  10, 175,  52, 217, },
{110,  55, 151,  96, 120,  65, 162, 107, },
{ 28, 193,  14, 179,  38, 203,  24, 189, },
{138,  83, 124,  69, 148,  93, 134,  79, },
{  7, 172,  48, 213,   3, 168,  45, 210, },

################################################################################

TITLE
    YUV to RGB dither_8x8_220 2

TYPE
    8

DATA
{  0, 143,  18, 200,   2, 156,  25, 215, },
{ 78,  28, 125,  64,  89,  36, 138,  74, },
{ 10, 180,   3, 161,  16, 195,   8, 175, },
{109,  51,  93,  38, 121,  60, 105,  47, },
{  1, 152,  23, 210,   0, 147,  20, 205, },
{ 85,  33, 134,  71,  81,  30, 130,  67, },
{ 14, 190,   6, 171,  12, 185,   5, 166, },
{117,  57, 101,  44, 113,  54,  97,  41, },

################################################################################

TITLE
    YUV to RGB dither_8x8_220 3

TYPE
    8

DATA
{  0, 124,   8, 193,   0, 140,  12, 213, },
{ 55,  14, 104,  42,  66,  19, 119,  52, },
{  3, 168,   1, 145,   6, 187,   3, 162, },
{ 86,  31,  70,  21,  99,  39,  82,  28, },
{  0, 134,  11, 206,   0, 129,   9, 200, },
{ 62,  17, 114,  48,  58,  16, 109,  45, },
{  5, 181,   2, 157,   4, 175,   1, 151, },
{ 95,  36,  78,  26,  90,  34,  74,  24, },

################################################################################

TITLE
    YUV to RGB dither_8x8_220 4

TYPE
    8

DATA
{  0, 107,   3, 187,   0, 125,   6, 212, },
{ 39,   7,  86,  28,  49,  11, 102,  36, },
{  1, 158,   0, 131,   3, 180,   1, 151, },
{ 68,  19,  52,  12,  81,  25,  64,  17, },
{  0, 119,   5, 203,   0, 113,   4, 195, },
{ 45,   9,  96,  33,  42,   8,  91,  30, },
{  2, 172,   1, 144,   2, 165,   0, 137, },
{ 77,  23,  60,  15,  72,  21,  56,  14, },

################################################################################

TITLE
    YUV to RGB Inverse_Table_6_9

TYPE
    32

DATA
    {117504, 138453, 13954, 34903}, /* no sequence_display_extension */
    {117504, 138453, 13954, 34903}, /* ITU-R Rec. 709 (1990) */
    {104597, 132201, 25675, 53279}, /* unspecified */
    {104597, 132201, 25675, 53279}, /* reserved */
    {104448, 132798, 24759, 53109}, /* FCC */
    {104597, 132201, 25675, 53279}, /* ITU-R Rec. 624-4 System B, G */
    {104597, 132201, 25675, 53279}, /* SMPTE 170M */
    {117579, 136230, 16907, 35559}  /* SMPTE 240M (1987) */

################################################################################

TITLE
    OSD fonts

TYPE
    8

DATA
0x80,0x01,0x02,0x17,0x00,0x00,0x25,0x21,0x50,0x53,0x2d,0x41,0x64,0x6f,0x62,0x65,
0x46,0x6f,0x6e,0x74,0x2d,0x31,0x2e,0x30,0x3a,0x20,0x4f,0x53,0x44,0x20,0x31,0x2e,
0x30,0x30,0x0a,0x25,0x25,0x43,0x72,0x65,0x61,0x74,0x69,0x6f,0x6e,0x44,0x61,0x74,
0x65,0x3a,0x20,0x53,0x75,0x6e,0x20,0x4a,0x75,0x6c,0x20,0x32,0x32,0x20,0x31,0x32,
0x3a,0x33,0x38,0x3a,0x32,0x38,0x20,0x32,0x30,0x30,0x31,0x0a,0x25,0x0a,0x25,0x25,
0x45,0x6e,0x64,0x43,0x6f,0x6d,0x6d,0x65,0x6e,0x74,0x73,0x0a,0x31,0x32,0x20,0x64,
0x69,0x63,0x74,0x20,0x62,0x65,0x67,0x69,0x6e,0x0a,0x2f,0x46,0x6f,0x6e,0x74,0x49,
0x6e,0x66,0x6f,0x20,0x39,0x20,0x64,0x69,0x63,0x74,0x20,0x64,0x75,0x70,0x20,0x62,
0x65,0x67,0x69,0x6e,0x0a,0x2f,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e,0x20,0x28,0x56,
0x65,0x72,0x73,0x69,0x6f,0x6e,0x20,0x31,0x2e,0x30,0x30,0x29,0x20,0x72,0x65,0x61,
0x64,0x6f,0x6e,0x6c,0x79,0x20,0x64,0x65,0x66,0x0a,0x2f,0x4e,0x6f,0x74,0x69,0x63,
0x65,0x20,0x28,0x54,0x68,0x69,0x73,0x20,0x69,0x73,0x20,0x67,0x65,0x6e,0x65,0x72,
0x61,0x74,0x65,0x64,0x20,0x66,0x69,0x6c,0x65,0x2e,0x29,0x20,0x72,0x65,0x61,0x64,
0x6f,0x6e,0x6c,0x79,0x20,0x64,0x65,0x66,0x0a,0x2f,0x46,0x75,0x6c,0x6c,0x4e,0x61,
0x6d,0x65,0x20,0x28,0x4f,0x53,0x44,0x29,0x20,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,
0x79,0x20,0x64,0x65,0x66,0x0a,0x2f,0x46,0x61,0x6d,0x69,0x6c,0x79,0x4e,0x61,0x6d,
0x65,0x20,0x28,0x4f,0x53,0x44,0x29,0x20,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,0x79,
0x20,0x64,0x65,0x66,0x0a,0x2f,0x57,0x65,0x69,0x67,0x68,0x74,0x20,0x28,0x52,0x65,
0x67,0x75,0x6c,0x61,0x72,0x29,0x20,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,0x79,0x20,
0x64,0x65,0x66,0x0a,0x2f,0x49,0x74,0x61,0x6c,0x69,0x63,0x41,0x6e,0x67,0x6c,0x65,
0x20,0x30,0x2e,0x30,0x30,0x30,0x30,0x30,0x30,0x20,0x64,0x65,0x66,0x0a,0x2f,0x69,
0x73,0x46,0x69,0x78,0x65,0x64,0x50,0x69,0x74,0x63,0x68,0x20,0x66,0x61,0x6c,0x73,
0x65,0x20,0x64,0x65,0x66,0x0a,0x2f,0x55,0x6e,0x64,0x65,0x72,0x6c,0x69,0x6e,0x65,
0x50,0x6f,0x73,0x69,0x74,0x69,0x6f,0x6e,0x20,0x2d,0x31,0x33,0x33,0x20,0x64,0x65,
0x66,0x0a,0x2f,0x55,0x6e,0x64,0x65,0x72,0x6c,0x69,0x6e,0x65,0x54,0x68,0x69,0x63,
0x6b,0x6e,0x65,0x73,0x73,0x20,0x34,0x39,0x20,0x64,0x65,0x66,0x0a,0x65,0x6e,0x64,
0x20,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,0x79,0x20,0x64,0x65,0x66,0x0a,0x2f,0x46,
0x6f,0x6e,0x74,0x4e,0x61,0x6d,0x65,0x20,0x2f,0x4f,0x53,0x44,0x20,0x64,0x65,0x66,
0x0a,0x2f,0x50,0x61,0x69,0x6e,0x74,0x54,0x79,0x70,0x65,0x20,0x30,0x20,0x64,0x65,
0x66,0x0a,0x2f,0x53,0x74,0x72,0x6f,0x6b,0x65,0x57,0x69,0x64,0x74,0x68,0x20,0x30,
0x20,0x64,0x65,0x66,0x0a,0x2f,0x46,0x6f,0x6e,0x74,0x4d,0x61,0x74,0x72,0x69,0x78,
0x20,0x5b,0x30,0x2e,0x30,0x30,0x31,0x20,0x30,0x20,0x30,0x20,0x30,0x2e,0x30,0x30,
0x31,0x20,0x30,0x20,0x30,0x5d,0x20,0x64,0x65,0x66,0x0a,0x2f,0x46,0x6f,0x6e,0x74,
0x42,0x42,0x6f,0x78,0x20,0x7b,0x30,0x20,0x2d,0x31,0x30,0x20,0x31,0x30,0x30,0x30,
0x20,0x38,0x31,0x30,0x7d,0x20,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,0x79,0x20,0x64,
0x65,0x66,0x0a,0x2f,0x45,0x6e,0x63,0x6f,0x64,0x69,0x6e,0x67,0x20,0x32,0x35,0x36,
0x20,0x61,0x72,0x72,0x61,0x79,0x0a,0x64,0x75,0x70,0x20,0x30,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x20,
0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x31,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x32,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x33,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x33,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x34,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,
0x34,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x20,0x2f,0x75,0x6e,0x69,
0x45,0x30,0x30,0x35,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x36,0x20,0x2f,
0x75,0x6e,0x69,0x45,0x30,0x30,0x36,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x37,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x37,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x38,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x38,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x39,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x20,0x2f,0x75,0x6e,0x69,
0x45,0x30,0x30,0x41,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x20,
0x2f,0x75,0x6e,0x69,0x45,0x30,0x30,0x42,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x36,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x31,0x30,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x20,0x2f,0x75,0x6e,0x69,0x45,0x30,0x31,0x31,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x20,0x2f,0x75,0x6e,0x69,
0x45,0x30,0x31,0x32,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x20,
0x2f,0x75,0x6e,0x69,0x45,0x30,0x31,0x33,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x36,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x30,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x33,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x33,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x34,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x33,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x33,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x38,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x33,0x39,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x34,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x34,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x34,0x32,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x34,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x34,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x34,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x34,0x36,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x34,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x34,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x34,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x30,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x35,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x35,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x34,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x35,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x35,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x38,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x35,0x39,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x36,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x36,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x36,0x32,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x36,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x36,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x36,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x36,0x36,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x36,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x36,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x36,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x30,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x37,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x37,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x34,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x37,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x37,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x38,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x37,0x39,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x38,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x38,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x38,0x32,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x38,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x38,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x38,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x38,0x36,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x38,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x38,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x38,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x30,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x39,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x39,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x34,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x39,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x39,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x38,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x39,0x39,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x30,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x32,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x30,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x35,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x30,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x30,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,0x38,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x30,
0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x31,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x31,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x32,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x31,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x31,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x31,0x38,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x31,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x32,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x32,0x31,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x32,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x32,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x32,0x34,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x32,
0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x32,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x32,0x37,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x32,0x38,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x32,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x33,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x34,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x33,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x33,0x37,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x33,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x33,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x30,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,
0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x34,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x33,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x34,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x34,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x34,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x34,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x30,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x35,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x33,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x35,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x35,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x36,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,
0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x35,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x35,0x39,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x30,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x36,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x36,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x36,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x36,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x36,0x39,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x37,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x37,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x32,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,
0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x37,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x35,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x36,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x37,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x37,0x39,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x38,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x32,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x38,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x35,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,
0x38,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x31,0x38,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,0x38,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x38,
0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x31,0x39,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x31,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x32,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x31,0x39,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x35,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x31,0x39,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x31,0x39,0x38,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x31,0x39,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x30,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x30,0x31,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,
0x30,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x32,0x30,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x30,0x34,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x30,
0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x32,0x30,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x30,0x37,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x30,0x38,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x32,0x30,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x31,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x31,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x34,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x32,0x31,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x31,0x37,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,
0x31,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x32,0x31,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x30,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,
0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x32,0x32,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x33,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x34,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x32,0x32,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x36,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x37,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x32,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x32,0x39,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x30,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x32,0x33,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x33,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,
0x33,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x32,0x33,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x36,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,
0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x32,0x33,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x33,0x39,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x30,
0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,
0x70,0x20,0x32,0x34,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,
0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x32,0x20,0x2f,0x2e,0x6e,0x6f,0x74,
0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x33,0x20,
0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,
0x20,0x32,0x34,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,
0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x35,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,
0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x36,0x20,0x2f,
0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,
0x32,0x34,0x37,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,
0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x38,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,
0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x34,0x39,0x20,0x2f,0x2e,
0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,
0x35,0x30,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,
0x64,0x75,0x70,0x20,0x32,0x35,0x31,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,
0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x35,0x32,0x20,0x2f,0x2e,0x6e,
0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x35,
0x33,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x64,
0x75,0x70,0x20,0x32,0x35,0x34,0x20,0x2f,0x2e,0x6e,0x6f,0x74,0x64,0x65,0x66,0x20,
0x70,0x75,0x74,0x0a,0x64,0x75,0x70,0x20,0x32,0x35,0x35,0x20,0x2f,0x2e,0x6e,0x6f,
0x74,0x64,0x65,0x66,0x20,0x70,0x75,0x74,0x0a,0x72,0x65,0x61,0x64,0x6f,0x6e,0x6c,
0x79,0x20,0x64,0x65,0x66,0x0a,0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x64,0x69,0x63,
0x74,0x20,0x65,0x6e,0x64,0x0a,0x63,0x75,0x72,0x72,0x65,0x6e,0x74,0x66,0x69,0x6c,
0x65,0x20,0x65,0x65,0x78,0x65,0x63,0x0a,0x80,0x02,0x64,0x07,0x00,0x00,0xd9,0xd6,
0x6f,0x63,0x3b,0x84,0x6a,0x98,0x9b,0x99,0x74,0xb0,0x17,0x9f,0xc6,0xcc,0x44,0x5b,
0xc2,0xc0,0x31,0x03,0xc6,0x85,0x70,0xa7,0xb3,0x54,0xa4,0xa2,0x80,0xae,0x6f,0xbf,
0x7f,0x98,0x88,0xe0,0x62,0xac,0xe9,0x21,0x16,0xed,0xa3,0x16,0x4a,0xb4,0x31,0xb6,
0xaa,0x5d,0x94,0xf1,0xc3,0x04,0x34,0xfb,0xeb,0xfd,0x8d,0xb1,0xf9,0xaf,0xd6,0x14,
0x0e,0x48,0xa2,0xd1,0xdf,0x43,0xa3,0x52,0xac,0xb2,0xa0,0x05,0xe8,0xd4,0x3c,0xdf,
0x44,0xb0,0xfb,0x04,0xb4,0x6b,0xf5,0x7c,0xb2,0x5a,0xcf,0x59,0x2b,0xa6,0x84,0xf3,
0xb8,0x18,0x21,0xbe,0xfe,0xf4,0xfd,0x83,0x30,0x31,0x19,0x63,0x70,0x76,0xcc,0x17,
0x8d,0xf5,0xbb,0x1b,0x08,0xb2,0x39,0x99,0x74,0x40,0xfc,0xe8,0xa5,0x75,0xb0,0xe8,
0x06,0x4f,0x42,0xa4,0xed,0x7b,0xd4,0xde,0x19,0xf8,0x85,0x97,0x5a,0x82,0xe9,0x7a,
0xda,0xf9,0xe9,0x9e,0x70,0x7f,0xd5,0xd6,0x50,0x4e,0x24,0xfe,0xad,0xb3,0xd1,0x83,
0xb0,0x63,0x04,0xb0,0x43,0x5d,0xcf,0xe8,0xe0,0xf7,0x01,0xb5,0xae,0x80,0xa2,0xab,
0xf3,0xf9,0x02,0x5e,0xe4,0x71,0x0d,0x72,0x9d,0x9a,0xfd,0x81,0x96,0xc5,0xde,0x19,
0xf8,0xbc,0x12,0xc0,0x52,0xc0,0xa8,0x55,0x8c,0x7f,0xa0,0x5f,0x84,0x46,0x75,0x46,
0xfc,0x13,0x5e,0x05,0x11,0xce,0xfc,0xd4,0x96,0xfd,0xf0,0xa9,0xc4,0xbb,0xcf,0x07,
0x97,0x37,0x93,0xc2,0xab,0x48,0x78,0xa5,0x80,0xc2,0xf6,0xfa,0x62,0x90,0x77,0x74,
0x29,0x53,0x8e,0xcc,0x7c,0xb2,0x30,0xd2,0x4c,0x74,0xe5,0xd9,0x8c,0x5a,0x06,0x83,
0x90,0x47,0xd8,0xbb,0x48,0x86,0x93,0xbf,0xdb,0x87,0x79,0xca,0xaf,0xd0,0xb0,0x8b,
0x3d,0x0e,0x27,0xc0,0xda,0xda,0x4e,0xf9,0xc7,0x77,0x11,0xff,0x10,0xc9,0x6a,0x74,
0xfb,0xe5,0x0d,0xd2,0x43,0x70,0x44,0xbb,0x41,0xf3,0x15,0x92,0x57,0x90,0xd9,0x47,
0x6f,0x46,0x8e,0x4a,0x56,0x72,0x4f,0x39,0xee,0xfc,0x19,0x45,0xb2,0x89,0x9a,0xf0,
0xa7,0x0f,0x14,0x78,0xaf,0xf3,0x87,0x09,0x86,0xd9,0xfa,0x4b,0x3e,0x72,0x96,0xc1,
0x3b,0x39,0xfa,0x7e,0x7c,0x2e,0xa2,0xd0,0x78,0xa9,0xce,0x4f,0x3d,0x0c,0x71,0x3e,
0xca,0x52,0xa0,0x3a,0xe9,0x33,0xe8,0x9b,0x41,0xc6,0xec,0x13,0x2d,0x22,0x8a,0x66,
0x21,0xc1,0x8f,0x98,0xce,0xa5,0xf9,0xe5,0x44,0x76,0xb4,0xc8,0x46,0x8d,0xcd,0x65,
0xc9,0x61,0xdf,0xa7,0xa9,0xd7,0x58,0x0a,0xc1,0x5b,0xc8,0xd9,0x87,0xda,0xc6,0x1e,
0x8b,0x64,0xca,0x08,0x75,0x5a,0x86,0xba,0xb2,0x57,0x96,0x23,0xfb,0xf9,0xb2,0x42,
0xd5,0x13,0x8f,0xaa,0x7e,0x97,0xa2,0xd6,0x0e,0x17,0xcb,0xdf,0x6f,0xdb,0xb0,0xb2,
0x68,0x8a,0xf6,0x9b,0x6c,0x9f,0x77,0xd7,0x33,0xa9,0x36,0x1f,0x50,0xe1,0xa0,0x1f,
0xd9,0xb8,0x3b,0xa9,0x1c,0x2b,0x1e,0xa4,0x31,0x24,0x5b,0x48,0x95,0xc1,0x26,0x3f,
0x62,0x24,0x71,0x2e,0xe6,0xae,0xdd,0xd0,0xa1,0x51,0x83,0x2c,0x3b,0x2d,0x14,0xea,
0x94,0xda,0x77,0x87,0xe2,0xd2,0x97,0x4d,0x5a,0x28,0x6b,0x64,0x19,0x37,0xc9,0x3f,
0x90,0x66,0xb8,0x91,0x2f,0x17,0xd6,0xb6,0xa9,0x55,0xc1,0x7b,0x04,0xb0,0x96,0xa0,
0x34,0x9a,0x14,0xea,0x12,0xf0,0x33,0xc3,0xc2,0x79,0x2a,0x42,0x33,0x8d,0x75,0x17,
0xf4,0x05,0x79,0x36,0x89,0x22,0x8d,0xdb,0xd6,0x28,0xae,0xaa,0x22,0x0c,0x86,0x60,
0xe0,0x66,0x5c,0x7a,0x43,0x0b,0x7f,0xd4,0x74,0x59,0x48,0x2b,0xd8,0xb7,0xd1,0x05,
0xee,0xbe,0x91,0xe4,0x67,0x8d,0x4d,0xd2,0x25,0xe0,0x13,0xd7,0x85,0x53,0x8b,0x9c,
0xd0,0x5f,0x09,0x09,0xfd,0xff,0xe1,0x59,0x37,0xe4,0x6d,0x9e,0x65,0x34,0x2e,0xfd,
0x34,0x67,0x2a,0x1d,0x6e,0xc6,0x51,0x4d,0x69,0x55,0x9c,0xf7,0xfc,0xe7,0x4e,0x75,
0xd5,0x2c,0x01,0xd5,0x70,0x29,0x8b,0xd0,0x6a,0xa5,0x69,0x1c,0x98,0x98,0x81,0xda,
0xbf,0xc0,0x8a,0xf6,0x30,0x6c,0xf9,0xb0,0x0d,0xf4,0xf9,0x6a,0x35,0x55,0x02,0x2d,
0x97,0xe6,0xd0,0x15,0xa8,0xbe,0xf5,0x80,0xe0,0x73,0xd5,0xb8,0xae,0xdc,0x5b,0x6a,
0xa2,0x4d,0x67,0x7d,0x61,0xcd,0xa9,0xf0,0xe0,0x0a,0x63,0x3e,0x03,0x01,0x7d,0xcf,
0x56,0x91,0x48,0x74,0x65,0x4c,0xdc,0xcd,0xe3,0xfe,0xdf,0xc0,0x82,0x5e,0x25,0xb4,
0xea,0x04,0xe0,0x6f,0x16,0x5b,0x94,0x5d,0xf7,0x62,0xce,0xc3,0xa8,0xb9,0x9b,0x0f,
0xd9,0x5c,0x92,0x56,0x59,0x58,0x41,0x50,0x85,0xbb,0x20,0x13,0xcc,0xff,0xa9,0xd0,
0xa1,0x88,0x91,0x02,0x4e,0x44,0xe6,0x2e,0x36,0xc1,0x8b,0x53,0xb5,0xc7,0x47,0xad,
0xb1,0x10,0xe7,0xb7,0x1c,0x27,0xbf,0xf0,0x16,0x79,0x39,0xaa,0x4f,0xa4,0x05,0x79,
0x00,0x7f,0x3f,0xc6,0xfc,0x0f,0xf9,0x6b,0x21,0xbf,0x57,0x9f,0x64,0x10,0xfe,0xcd,
0xd9,0x80,0x1c,0xab,0xb0,0x21,0x6a,0x84,0x4e,0x8a,0x07,0x93,0xc6,0x76,0x54,0x41,
0x8e,0x2d,0x2d,0x72,0xc9,0x52,0xa2,0x16,0xdf,0x0d,0x84,0x09,0x43,0x88,0x3e,0x25,
0x21,0x5a,0xf3,0x28,0xec,0x4d,0x08,0x41,0xce,0x55,0x7e,0xf9,0x34,0x54,0xcc,0xa2,
0x2d,0xe0,0x95,0x4a,0x78,0xd5,0x8c,0xd4,0xd4,0x1b,0x3c,0x17,0xe0,0xb7,0x2f,0xf5,
0x8a,0xc7,0x2b,0x71,0x2a,0x42,0x44,0x04,0x58,0xcf,0x03,0x1a,0x43,0x2e,0xf5,0xf0,
0x68,0xbf,0x90,0x54,0x83,0xc8,0x57,0xed,0xbb,0xbc,0xc0,0x07,0x13,0x7d,0x71,0x17,
0x37,0x2c,0x3e,0x3c,0xce,0x31,0xdb,0x68,0xac,0xd4,0x8c,0xca,0xd7,0x6e,0x52,0x51,
0x0a,0x2d,0xa0,0x09,0xbf,0xfa,0x80,0xce,0xd9,0xe8,0x2c,0xfa,0x34,0xce,0x8c,0x85,
0x95,0xd5,0x7a,0xd3,0x63,0x02,0x49,0x44,0x4e,0xee,0x34,0xa9,0x23,0x56,0x88,0x69,
0xf1,0xf8,0x6d,0x28,0xc9,0x2d,0xd2,0x63,0x72,0x64,0xe2,0xd7,0xb6,0x6a,0x74,0xb8,
0xf3,0xda,0xca,0x56,0xa9,0xbd,0xff,0x04,0x03,0xca,0xc2,0x08,0x27,0x54,0x17,0x5c,
0xa1,0x71,0xb4,0x32,0x70,0x85,0x52,0x0a,0xc0,0x65,0x37,0x97,0x9f,0xb5,0xef,0xe6,
0x26,0xc5,0xad,0x7b,0x2a,0x2a,0xd9,0x39,0xb2,0x27,0x56,0x43,0xf6,0x4a,0xce,0x84,
0x3e,0x90,0x97,0xe3,0x62,0xcc,0xe5,0xa6,0x2c,0x4a,0xf3,0x10,0x91,0xf3,0x37,0x98,
0x61,0x69,0xdf,0x5b,0x11,0x49,0xe0,0x43,0x56,0xed,0xe9,0x03,0x98,0x17,0x6e,0x41,
0xc9,0x55,0xa8,0x77,0x5e,0x02,0xd5,0x08,0x9f,0x04,0x5e,0x18,0x79,0x8d,0xf9,0xed,
0xc7,0x46,0x93,0x4f,0xd7,0xb9,0x46,0x19,0xd4,0x48,0xc7,0xf9,0x73,0x61,0xac,0x5b,
0x3d,0x18,0x52,0x8f,0x73,0xc6,0x77,0xad,0x57,0x3a,0x8a,0xd7,0x3a,0xee,0xae,0xf9,
0x80,0x47,0xbc,0xdb,0x44,0x49,0x01,0x5d,0x9d,0x3e,0xeb,0x1a,0xb3,0x53,0x37,0xca,
0x4b,0x42,0xda,0x09,0xd9,0x4c,0xcd,0x85,0xc0,0x94,0x37,0x22,0x5e,0x74,0x73,0xda,
0x60,0x56,0x4e,0x07,0x0c,0x4d,0x46,0x29,0x66,0x08,0x74,0x80,0xc2,0x38,0xfb,0x76,
0xd5,0x94,0x03,0xa0,0x41,0x3b,0x66,0xc3,0xfa,0x2c,0x1a,0xdd,0x9e,0x5f,0x17,0x77,
0xa1,0x0c,0x8c,0x47,0xc4,0x0d,0x51,0x29,0x47,0xb9,0xb9,0xed,0xbb,0xee,0xde,0xb3,
0xf9,0x33,0xec,0x59,0xda,0x02,0xf9,0xa3,0x6c,0x8c,0x52,0x59,0x8d,0xbc,0x86,0x89,
0xa0,0x0d,0xd0,0x68,0x6d,0xa0,0xb1,0x54,0x0c,0xbc,0x2e,0xe9,0xa0,0x8d,0x2e,0xad,
0x37,0xdb,0x95,0x9b,0xb0,0x77,0xb6,0x4f,0x02,0xba,0x0b,0xe2,0xbd,0x7c,0x4b,0xa7,
0x4d,0xab,0x45,0x96,0x64,0xef,0x2d,0x6b,0x66,0x3e,0x10,0x67,0x79,0x63,0x0a,0x96,
0x7e,0x76,0x98,0xcf,0x4e,0x13,0xa0,0x3c,0x8e,0xbf,0xf3,0xd7,0x60,0x9e,0xb9,0xd0,
0xe0,0xbd,0x14,0xfb,0x89,0xaf,0x2d,0xcf,0xd7,0x90,0x22,0xc1,0x77,0x54,0x4a,0x6c,
0x42,0x5c,0xab,0x68,0x75,0xbd,0xeb,0x05,0x3e,0x5e,0x3b,0xfb,0x1a,0x87,0xc6,0x20,
0x15,0x3f,0x62,0x03,0xf7,0x7d,0xf6,0x9c,0x1d,0x5f,0x80,0x93,0x13,0xb6,0x76,0xbe,
0x90,0xbc,0x1d,0x87,0x66,0xa4,0xfe,0xfd,0x11,0x91,0x1f,0x8f,0x1e,0x35,0x9b,0x88,
0x59,0xf6,0x85,0x8f,0x07,0xe9,0x15,0x45,0x59,0x07,0xf4,0xb5,0x66,0x1a,0xcd,0x19,
0x12,0xe0,0xe4,0x88,0x5d,0xc9,0x8c,0xa6,0x9b,0x23,0x29,0x19,0x07,0x89,0xe5,0x4a,
0x83,0xc7,0xcf,0xf5,0x10,0xc5,0x80,0x56,0xde,0x3e,0xa7,0x68,0x8b,0x71,0x15,0x63,
0x12,0x24,0x12,0xbb,0xc4,0xb0,0xfe,0x65,0x4f,0xe9,0xe9,0x13,0x80,0xbf,0x3a,0x33,
0xbd,0xba,0x9f,0x70,0x42,0x33,0xc4,0x5d,0x3b,0xeb,0x66,0x99,0x0e,0xff,0x66,0x39,
0x1e,0xea,0x00,0x13,0x13,0x49,0xa7,0xef,0x7c,0x55,0xb0,0x36,0x9f,0xe3,0x2d,0x7d,
0x1a,0xb9,0x0e,0x2f,0xff,0x9b,0x03,0xa1,0xaa,0xb6,0x6d,0x7b,0x8d,0xe3,0x0e,0x4b,
0x2b,0x7c,0x96,0xdb,0xb8,0xf0,0xd3,0xa5,0xbf,0xbb,0x3e,0xda,0x95,0xa2,0xc7,0xd2,
0x8e,0x8e,0xdc,0xfe,0x77,0x93,0x4b,0x6e,0x1f,0x13,0x21,0x6a,0x60,0x9f,0x8c,0xe1,
0x05,0x50,0x53,0x58,0x3f,0xdc,0xab,0x20,0x96,0xdb,0xb0,0xb5,0x08,0xdb,0xb9,0xc4,
0x62,0xce,0x47,0x1b,0x0c,0xcd,0xb6,0x78,0xfb,0x68,0x14,0x42,0xf3,0x75,0x3f,0x4f,
0x44,0xec,0x75,0x12,0x7b,0x10,0x0e,0x2b,0x39,0x64,0x2c,0xea,0xaf,0xf2,0x11,0x08,
0xfc,0xca,0x61,0xc1,0xcc,0x8b,0xc7,0xb4,0xc3,0x73,0x7f,0x30,0xc9,0xb8,0x9c,0xa5,
0xce,0xb6,0xa7,0xc4,0x1c,0xf0,0xe6,0x17,0x5a,0x18,0x7e,0x7f,0xbb,0xc0,0x8f,0x08,
0x3d,0xf7,0xa4,0x9a,0x99,0xb4,0x7b,0x4d,0x81,0xfc,0xe1,0x36,0x1b,0xb5,0x9a,0xa7,
0xdc,0xdc,0x6e,0x1c,0xe3,0x4a,0x4e,0x57,0x80,0x86,0xb4,0xfa,0x01,0x94,0x3d,0x92,
0x49,0xa4,0x0f,0x95,0x00,0x57,0xcf,0xe6,0x74,0xd7,0xaf,0x8a,0x93,0x23,0x83,0x67,
0x1f,0xcd,0xb9,0xe1,0x3b,0x9f,0x86,0x04,0x3c,0x6b,0x88,0x5f,0x7f,0x87,0x54,0x98,
0xf7,0x2f,0x0c,0x5c,0x23,0x95,0x11,0xe1,0x01,0x28,0x56,0x5c,0x5e,0x82,0xe2,0x22,
0x12,0x6b,0x1e,0x90,0x27,0x16,0x80,0x50,0x65,0x28,0xc1,0x67,0xf5,0x36,0xf2,0xfb,
0xff,0x30,0xf1,0x06,0x28,0x72,0x2e,0xb8,0x64,0xca,0xa6,0xd0,0x14,0xc7,0x50,0xca,
0xb2,0xa3,0x82,0xda,0xe8,0xb2,0x77,0x60,0xac,0xc9,0x94,0x93,0x8a,0xcf,0xb5,0xfe,
0x28,0x90,0x96,0x1d,0x5c,0x80,0x1e,0xcb,0xf3,0xdb,0x3c,0x3a,0x03,0xeb,0xc7,0x29,
0x2c,0xa2,0x55,0x5e,0x66,0x6b,0xd4,0xa7,0x60,0xa7,0xe9,0x56,0xdc,0x1e,0xf2,0x02,
0x5f,0x49,0xb7,0x29,0x31,0x4f,0x94,0x2b,0xd3,0xd7,0x1a,0x51,0x16,0xe1,0x0b,0x5b,
0xcf,0xa1,0x98,0x70,0x24,0x50,0x11,0x3b,0x97,0x84,0x9f,0x5c,0xdc,0x81,0xfe,0x64,
0x64,0xee,0x2a,0xa5,0x91,0xd3,0x14,0xc6,0x6e,0xe6,0x3b,0xf8,0x77,0x2b,0x35,0xa3,
0x2d,0x6c,0x3b,0xc2,0xd5,0x8e,0x28,0x1a,0x67,0xf0,0x56,0x55,0x11,0xf0,0x78,0x91,
0x81,0xa9,0xf4,0xd2,0xbb,0x06,0xe4,0x21,0x7f,0x9d,0x33,0x49,0x30,0x22,0x06,0x96,
0x85,0x31,0xe6,0xd7,0x9b,0xd0,0x27,0x53,0x6c,0xe2,0x0c,0xcf,0x73,0x0d,0x18,0x26,
0x56,0x21,0xcd,0xf8,0xad,0x1d,0xfb,0x82,0x6b,0x01,0x21,0x45,0x17,0x96,0x11,0x88,
0x27,0xc1,0x2e,0x11,0xa9,0x23,0x95,0xf2,0xbe,0xaa,0xba,0xc7,0xa0,0xf5,0x42,0x21,
0xed,0xa0,0x7d,0x02,0xf8,0xbe,0x58,0x23,0x8f,0xdb,0x0d,0x7b,0xdc,0xd8,0x8f,0xe2,
0xe4,0xd9,0x99,0x26,0x08,0x7b,0x97,0x6b,0x4f,0xfe,0x3f,0x6a,0x49,0xb0,0x8e,0x7b,
0xe5,0xf9,0x0d,0x8c,0x4e,0x39,0x8c,0x95,0x81,0x80,0xd9,0x3a,0xc2,0x9f,0x65,0x3f,
0xd9,0x2f,0xa3,0xd7,0x4c,0xa3,0xf6,0x93,0xd7,0x84,0xb0,0xaf,0x2d,0xe2,0xcd,0x04,
0x56,0x9e,0x63,0x08,0x1b,0x23,0x61,0xad,0xdd,0x17,0xa3,0x94,0x51,0xaa,0x7a,0xd3,
0xac,0x90,0xc2,0x58,0x61,0x86,0xec,0x0e,0x97,0xfc,0x45,0xb4,0x3b,0xa2,0xdc,0xb2,
0xdd,0xe2,0x80,0x01,0x08,0x02,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x0a,
0x80,0x03,};

################################################################################

TITLE
    MMX codes

TYPE
    32

DATA
	1056974725,
	1057056395,
	1057223771,
	1057485416,
	1057855544,
	1058356026,
	1059019886,
	1059897405,
	1061067246,
	1062657950,
	1064892987,
	1066774581,
	1069414683,
	1073984175,
	1079645762,
	1092815430,
	1057005197,
	1057342072,
	1058087743,
	1059427869,
	1061799040,
	1065862217,
	1071413542,
	1084439708,
	1057128951,
	1058664893,
	1063675095,
	1076102863,
	1057655764,
	1067924853,
	1060439283,

################################################################################

TITLE
    mp3lib huffman tab1

TYPE
    16

DATA
  -5,  -3,  -1,  17,   1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab2

TYPE
    16

DATA
 -15, -11,  -9,  -5,  -3,  -1,  34,   2,  18,  -1,  33,  32,  17,  -1,   1,
  16,   0

################################################################################

TITLE
    mp3lib huffman tab3

TYPE
    16

DATA
 -13, -11,  -9,  -5,  -3,  -1,  34,   2,  18,  -1,  33,  32,  16,  17,  -1,
   1,   0

################################################################################

TITLE
    mp3lib huffman tab5

TYPE
    16

DATA
 -29, -25, -23, -15,  -7,  -5,  -3,  -1,  51,  35,  50,  49,  -3,  -1,  19,
   3,  -1,  48,  34,  -3,  -1,  18,  33,  -1,   2,  32,  17,  -1,   1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab6

TYPE
    16

DATA
 -25, -19, -13,  -9,  -5,  -3,  -1,  51,   3,  35,  -1,  50,  48,  -1,  19,
  49,  -3,  -1,  34,   2,  18,  -3,  -1,  33,  32,   1,  -1,  17,  -1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab7

TYPE
    16

DATA
 -69, -65, -57, -39, -29, -17, -11,  -7,  -3,  -1,  85,  69,  -1,  84,  83,
  -1,  53,  68,  -3,  -1,  37,  82,  21,  -5,  -1,  81,  -1,   5,  52,  -1,
  80,  -1,  67,  51,  -5,  -3,  -1,  36,  66,  20,  -1,  65,  64, -11,  -7,
  -3,  -1,   4,  35,  -1,  50,   3,  -1,  19,  49,  -3,  -1,  48,  34,  18,
  -5,  -1,  33,  -1,   2,  32,  17,  -1,   1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab8

TYPE
    16

DATA
 -65, -63, -59, -45, -31, -19, -13,  -7,  -5,  -3,  -1,  85,  84,  69,  83,
  -3,  -1,  53,  68,  37,  -3,  -1,  82,   5,  21,  -5,  -1,  81,  -1,  52,
  67,  -3,  -1,  80,  51,  36,  -5,  -3,  -1,  66,  20,  65,  -3,  -1,   4,
  64,  -1,  35,  50,  -9,  -7,  -3,  -1,  19,  49,  -1,   3,  48,  34,  -1,
   2,  32,  -1,  18,  33,  17,  -3,  -1,   1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab9

TYPE
    16

DATA
 -63, -53, -41, -29, -19, -11,  -5,  -3,  -1,  85,  69,  53,  -1,  83,  -1,
  84,   5,  -3,  -1,  68,  37,  -1,  82,  21,  -3,  -1,  81,  52,  -1,  67,
  -1,  80,   4,  -7,  -3,  -1,  36,  66,  -1,  51,  64,  -1,  20,  65,  -5,
  -3,  -1,  35,  50,  19,  -1,  49,  -1,   3,  48,  -5,  -3,  -1,  34,   2,
  18,  -1,  33,  32,  -3,  -1,  17,   1,  -1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab10

TYPE
    16

DATA
-125,-121,-111, -83, -55, -35, -21, -13,  -7,  -3,  -1, 119, 103,  -1, 118,
  87,  -3,  -1, 117, 102,  71,  -3,  -1, 116,  86,  -1, 101,  55,  -9,  -3,
  -1, 115,  70,  -3,  -1,  85,  84,  99,  -1,  39, 114, -11,  -5,  -3,  -1,
 100,   7, 112,  -1,  98,  -1,  69,  53,  -5,  -1,   6,  -1,  83,  68,  23,
 -17,  -5,  -1, 113,  -1,  54,  38,  -5,  -3,  -1,  37,  82,  21,  -1,  81,
  -1,  52,  67,  -3,  -1,  22,  97,  -1,  96,  -1,   5,  80, -19, -11,  -7,
  -3,  -1,  36,  66,  -1,  51,   4,  -1,  20,  65,  -3,  -1,  64,  35,  -1,
  50,   3,  -3,  -1,  19,  49,  -1,  48,  34,  -7,  -3,  -1,  18,  33,  -1,
   2,  32,  17,  -1,   1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab11

TYPE
    16

DATA
-121,-113, -89, -59, -43, -27, -17,  -7,  -3,  -1, 119, 103,  -1, 118, 117,
  -3,  -1, 102,  71,  -1, 116,  -1,  87,  85,  -5,  -3,  -1,  86, 101,  55,
  -1, 115,  70,  -9,  -7,  -3,  -1,  69,  84,  -1,  53,  83,  39,  -1, 114,
  -1, 100,   7,  -5,  -1, 113,  -1,  23, 112,  -3,  -1,  54,  99,  -1,  96,
  -1,  68,  37, -13,  -7,  -5,  -3,  -1,  82,   5,  21,  98,  -3,  -1,  38,
   6,  22,  -5,  -1,  97,  -1,  81,  52,  -5,  -1,  80,  -1,  67,  51,  -1,
  36,  66, -15, -11,  -7,  -3,  -1,  20,  65,  -1,   4,  64,  -1,  35,  50,
  -1,  19,  49,  -5,  -3,  -1,   3,  48,  34,  33,  -5,  -1,  18,  -1,   2,
  32,  17,  -3,  -1,   1,  16,   0

################################################################################

TITLE
    mp3lib huffman tab12

TYPE
    16

DATA
-115, -99, -73, -45, -27, -17,  -9,  -5,  -3,  -1, 119, 103, 118,  -1,  87,
 117,  -3,  -1, 102,  71,  -1, 116, 101,  -3,  -1,  86,  55,  -3,  -1, 115,
  85,  39,  -7,  -3,  -1, 114,  70,  -1, 100,  23,  -5,  -1, 113,  -1,   7,
 112,  -1,  54,  99, -13,  -9,  -3,  -1,  69,  84,  -1,  68,  -1,   6,   5,
  -1,  38,  98,  -5,  -1,  97,  -1,  22,  96,  -3,  -1,  53,  83,  -1,  37,
  82, -17,  -7,  -3,  -1,  21,  81,  -1,  52,  67,  -5,  -3,  -1,  80,   4,
  36,  -1,  66,  20,  -3,  -1,  51,  65,  -1,  35,  50, -11,  -7,  -5,  -3,
  -1,  64,   3,  48,  19,  -1,  49,  34,  -1,  18,  33,  -7,  -5,  -3,  -1,
   2,  32,   0,  17,  -1,   1,  16

################################################################################

TITLE
    mp3lib huffman tab13

TYPE
    16

DATA
-509,-503,-475,-405,-333,-265,-205,-153,-115, -83, -53, -35, -21, -13,  -9,
  -7,  -5,  -3,  -1, 254, 252, 253, 237, 255,  -1, 239, 223,  -3,  -1, 238,
 207,  -1, 222, 191,  -9,  -3,  -1, 251, 206,  -1, 220,  -1, 175, 233,  -1,
 236, 221,  -9,  -5,  -3,  -1, 250, 205, 190,  -1, 235, 159,  -3,  -1, 249,
 234,  -1, 189, 219, -17,  -9,  -3,  -1, 143, 248,  -1, 204,  -1, 174, 158,
  -5,  -1, 142,  -1, 127, 126, 247,  -5,  -1, 218,  -1, 173, 188,  -3,  -1,
 203, 246, 111, -15,  -7,  -3,  -1, 232,  95,  -1, 157, 217,  -3,  -1, 245,
 231,  -1, 172, 187,  -9,  -3,  -1,  79, 244,  -3,  -1, 202, 230, 243,  -1,
  63,  -1, 141, 216, -21,  -9,  -3,  -1,  47, 242,  -3,  -1, 110, 156,  15,
  -5,  -3,  -1, 201,  94, 171,  -3,  -1, 125, 215,  78, -11,  -5,  -3,  -1,
 200, 214,  62,  -1, 185,  -1, 155, 170,  -1,  31, 241, -23, -13,  -5,  -1,
 240,  -1, 186, 229,  -3,  -1, 228, 140,  -1, 109, 227,  -5,  -1, 226,  -1,
  46,  14,  -1,  30, 225, -15,  -7,  -3,  -1, 224,  93,  -1, 213, 124,  -3,
  -1, 199,  77,  -1, 139, 184,  -7,  -3,  -1, 212, 154,  -1, 169, 108,  -1,
 198,  61, -37, -21,  -9,  -5,  -3,  -1, 211, 123,  45,  -1, 210,  29,  -5,
  -1, 183,  -1,  92, 197,  -3,  -1, 153, 122, 195,  -7,  -5,  -3,  -1, 167,
 151,  75, 209,  -3,  -1,  13, 208,  -1, 138, 168, -11,  -7,  -3,  -1,  76,
 196,  -1, 107, 182,  -1,  60,  44,  -3,  -1, 194,  91,  -3,  -1, 181, 137,
  28, -43, -23, -11,  -5,  -1, 193,  -1, 152,  12,  -1, 192,  -1, 180, 106,
  -5,  -3,  -1, 166, 121,  59,  -1, 179,  -1, 136,  90, -11,  -5,  -1,  43,
  -1, 165, 105,  -1, 164,  -1, 120, 135,  -5,  -1, 148,  -1, 119, 118, 178,
 -11,  -3,  -1,  27, 177,  -3,  -1,  11, 176,  -1, 150,  74,  -7,  -3,  -1,
  58, 163,  -1,  89, 149,  -1,  42, 162, -47, -23,  -9,  -3,  -1,  26, 161,
  -3,  -1,  10, 104, 160,  -5,  -3,  -1, 134,  73, 147,  -3,  -1,  57,  88,
  -1, 133, 103,  -9,  -3,  -1,  41, 146,  -3,  -1,  87, 117,  56,  -5,  -1,
 131,  -1, 102,  71,  -3,  -1, 116,  86,  -1, 101, 115, -11,  -3,  -1,  25,
 145,  -3,  -1,   9, 144,  -1,  72, 132,  -7,  -5,  -1, 114,  -1,  70, 100,
  40,  -1, 130,  24, -41, -27, -11,  -5,  -3,  -1,  55,  39,  23,  -1, 113,
  -1,  85,   7,  -7,  -3,  -1, 112,  54,  -1,  99,  69,  -3,  -1,  84,  38,
  -1,  98,  53,  -5,  -1, 129,  -1,   8, 128,  -3,  -1,  22,  97,  -1,   6,
  96, -13,  -9,  -5,  -3,  -1,  83,  68,  37,  -1,  82,   5,  -1,  21,  81,
  -7,  -3,  -1,  52,  67,  -1,  80,  36,  -3,  -1,  66,  51,  20, -19, -11,
  -5,  -1,  65,  -1,   4,  64,  -3,  -1,  35,  50,  19,  -3,  -1,  49,   3,
  -1,  48,  34,  -3,  -1,  18,  33,  -1,   2,  32,  -3,  -1,  17,   1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab15

TYPE
    16

DATA
-495,-445,-355,-263,-183,-115, -77, -43, -27, -13,  -7,  -3,  -1, 255, 239,
  -1, 254, 223,  -1, 238,  -1, 253, 207,  -7,  -3,  -1, 252, 222,  -1, 237,
 191,  -1, 251,  -1, 206, 236,  -7,  -3,  -1, 221, 175,  -1, 250, 190,  -3,
  -1, 235, 205,  -1, 220, 159, -15,  -7,  -3,  -1, 249, 234,  -1, 189, 219,
  -3,  -1, 143, 248,  -1, 204, 158,  -7,  -3,  -1, 233, 127,  -1, 247, 173,
  -3,  -1, 218, 188,  -1, 111,  -1, 174,  15, -19, -11,  -3,  -1, 203, 246,
  -3,  -1, 142, 232,  -1,  95, 157,  -3,  -1, 245, 126,  -1, 231, 172,  -9,
  -3,  -1, 202, 187,  -3,  -1, 217, 141,  79,  -3,  -1, 244,  63,  -1, 243,
 216, -33, -17,  -9,  -3,  -1, 230,  47,  -1, 242,  -1, 110, 240,  -3,  -1,
  31, 241,  -1, 156, 201,  -7,  -3,  -1,  94, 171,  -1, 186, 229,  -3,  -1,
 125, 215,  -1,  78, 228, -15,  -7,  -3,  -1, 140, 200,  -1,  62, 109,  -3,
  -1, 214, 227,  -1, 155, 185,  -7,  -3,  -1,  46, 170,  -1, 226,  30,  -5,
  -1, 225,  -1,  14, 224,  -1,  93, 213, -45, -25, -13,  -7,  -3,  -1, 124,
 199,  -1,  77, 139,  -1, 212,  -1, 184, 154,  -7,  -3,  -1, 169, 108,  -1,
 198,  61,  -1, 211, 210,  -9,  -5,  -3,  -1,  45,  13,  29,  -1, 123, 183,
  -5,  -1, 209,  -1,  92, 208,  -1, 197, 138, -17,  -7,  -3,  -1, 168,  76,
  -1, 196, 107,  -5,  -1, 182,  -1, 153,  12,  -1,  60, 195,  -9,  -3,  -1,
 122, 167,  -1, 166,  -1, 192,  11,  -1, 194,  -1,  44,  91, -55, -29, -15,
  -7,  -3,  -1, 181,  28,  -1, 137, 152,  -3,  -1, 193,  75,  -1, 180, 106,
  -5,  -3,  -1,  59, 121, 179,  -3,  -1, 151, 136,  -1,  43,  90, -11,  -5,
  -1, 178,  -1, 165,  27,  -1, 177,  -1, 176, 105,  -7,  -3,  -1, 150,  74,
  -1, 164, 120,  -3,  -1, 135,  58, 163, -17,  -7,  -3,  -1,  89, 149,  -1,
  42, 162,  -3,  -1,  26, 161,  -3,  -1,  10, 160, 104,  -7,  -3,  -1, 134,
  73,  -1, 148,  57,  -5,  -1, 147,  -1, 119,   9,  -1,  88, 133, -53, -29,
 -13,  -7,  -3,  -1,  41, 103,  -1, 118, 146,  -1, 145,  -1,  25, 144,  -7,
  -3,  -1,  72, 132,  -1,  87, 117,  -3,  -1,  56, 131,  -1, 102,  71,  -7,
  -3,  -1,  40, 130,  -1,  24, 129,  -7,  -3,  -1, 116,   8,  -1, 128,  86,
  -3,  -1, 101,  55,  -1, 115,  70, -17,  -7,  -3,  -1,  39, 114,  -1, 100,
  23,  -3,  -1,  85, 113,  -3,  -1,   7, 112,  54,  -7,  -3,  -1,  99,  69,
  -1,  84,  38,  -3,  -1,  98,  22,  -3,  -1,   6,  96,  53, -33, -19,  -9,
  -5,  -1,  97,  -1,  83,  68,  -1,  37,  82,  -3,  -1,  21,  81,  -3,  -1,
   5,  80,  52,  -7,  -3,  -1,  67,  36,  -1,  66,  51,  -1,  65,  -1,  20,
   4,  -9,  -3,  -1,  35,  50,  -3,  -1,  64,   3,  19,  -3,  -1,  49,  48,
  34,  -9,  -7,  -3,  -1,  18,  33,  -1,   2,  32,  17,  -3,  -1,   1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab16

TYPE
    16

DATA
-509,-503,-461,-323,-103, -37, -27, -15,  -7,  -3,  -1, 239, 254,  -1, 223,
 253,  -3,  -1, 207, 252,  -1, 191, 251,  -5,  -1, 175,  -1, 250, 159,  -3,
  -1, 249, 248, 143,  -7,  -3,  -1, 127, 247,  -1, 111, 246, 255,  -9,  -5,
  -3,  -1,  95, 245,  79,  -1, 244, 243, -53,  -1, 240,  -1,  63, -29, -19,
 -13,  -7,  -5,  -1, 206,  -1, 236, 221, 222,  -1, 233,  -1, 234, 217,  -1,
 238,  -1, 237, 235,  -3,  -1, 190, 205,  -3,  -1, 220, 219, 174, -11,  -5,
  -1, 204,  -1, 173, 218,  -3,  -1, 126, 172, 202,  -5,  -3,  -1, 201, 125,
  94, 189, 242, -93,  -5,  -3,  -1,  47,  15,  31,  -1, 241, -49, -25, -13,
  -5,  -1, 158,  -1, 188, 203,  -3,  -1, 142, 232,  -1, 157, 231,  -7,  -3,
  -1, 187, 141,  -1, 216, 110,  -1, 230, 156, -13,  -7,  -3,  -1, 171, 186,
  -1, 229, 215,  -1,  78,  -1, 228, 140,  -3,  -1, 200,  62,  -1, 109,  -1,
 214, 155, -19, -11,  -5,  -3,  -1, 185, 170, 225,  -1, 212,  -1, 184, 169,
  -5,  -1, 123,  -1, 183, 208, 227,  -7,  -3,  -1,  14, 224,  -1,  93, 213,
  -3,  -1, 124, 199,  -1,  77, 139, -75, -45, -27, -13,  -7,  -3,  -1, 154,
 108,  -1, 198,  61,  -3,  -1,  92, 197,  13,  -7,  -3,  -1, 138, 168,  -1,
 153,  76,  -3,  -1, 182, 122,  60, -11,  -5,  -3,  -1,  91, 137,  28,  -1,
 192,  -1, 152, 121,  -1, 226,  -1,  46,  30, -15,  -7,  -3,  -1, 211,  45,
  -1, 210, 209,  -5,  -1,  59,  -1, 151, 136,  29,  -7,  -3,  -1, 196, 107,
  -1, 195, 167,  -1,  44,  -1, 194, 181, -23, -13,  -7,  -3,  -1, 193,  12,
  -1,  75, 180,  -3,  -1, 106, 166, 179,  -5,  -3,  -1,  90, 165,  43,  -1,
 178,  27, -13,  -5,  -1, 177,  -1,  11, 176,  -3,  -1, 105, 150,  -1,  74,
 164,  -5,  -3,  -1, 120, 135, 163,  -3,  -1,  58,  89,  42, -97, -57, -33,
 -19, -11,  -5,  -3,  -1, 149, 104, 161,  -3,  -1, 134, 119, 148,  -5,  -3,
  -1,  73,  87, 103, 162,  -5,  -1,  26,  -1,  10, 160,  -3,  -1,  57, 147,
  -1,  88, 133,  -9,  -3,  -1,  41, 146,  -3,  -1, 118,   9,  25,  -5,  -1,
 145,  -1, 144,  72,  -3,  -1, 132, 117,  -1,  56, 131, -21, -11,  -5,  -3,
  -1, 102,  40, 130,  -3,  -1,  71, 116,  24,  -3,  -1, 129, 128,  -3,  -1,
   8,  86,  55,  -9,  -5,  -1, 115,  -1, 101,  70,  -1,  39, 114,  -5,  -3,
  -1, 100,  85,   7,  23, -23, -13,  -5,  -1, 113,  -1, 112,  54,  -3,  -1,
  99,  69,  -1,  84,  38,  -3,  -1,  98,  22,  -1,  97,  -1,   6,  96,  -9,
  -5,  -1,  83,  -1,  53,  68,  -1,  37,  82,  -1,  81,  -1,  21,   5, -33,
 -23, -13,  -7,  -3,  -1,  52,  67,  -1,  80,  36,  -3,  -1,  66,  51,  20,
  -5,  -1,  65,  -1,   4,  64,  -1,  35,  50,  -3,  -1,  19,  49,  -3,  -1,
   3,  48,  34,  -3,  -1,  18,  33,  -1,   2,  32,  -3,  -1,  17,   1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab24

TYPE
    16

DATA
-451,-117, -43, -25, -15,  -7,  -3,  -1, 239, 254,  -1, 223, 253,  -3,  -1,
 207, 252,  -1, 191, 251,  -5,  -1, 250,  -1, 175, 159,  -1, 249, 248,  -9,
  -5,  -3,  -1, 143, 127, 247,  -1, 111, 246,  -3,  -1,  95, 245,  -1,  79,
 244, -71,  -7,  -3,  -1,  63, 243,  -1,  47, 242,  -5,  -1, 241,  -1,  31,
 240, -25,  -9,  -1,  15,  -3,  -1, 238, 222,  -1, 237, 206,  -7,  -3,  -1,
 236, 221,  -1, 190, 235,  -3,  -1, 205, 220,  -1, 174, 234, -15,  -7,  -3,
  -1, 189, 219,  -1, 204, 158,  -3,  -1, 233, 173,  -1, 218, 188,  -7,  -3,
  -1, 203, 142,  -1, 232, 157,  -3,  -1, 217, 126,  -1, 231, 172, 255,-235,
-143, -77, -45, -25, -15,  -7,  -3,  -1, 202, 187,  -1, 141, 216,  -5,  -3,
  -1,  14, 224,  13, 230,  -5,  -3,  -1, 110, 156, 201,  -1,  94, 186,  -9,
  -5,  -1, 229,  -1, 171, 125,  -1, 215, 228,  -3,  -1, 140, 200,  -3,  -1,
  78,  46,  62, -15,  -7,  -3,  -1, 109, 214,  -1, 227, 155,  -3,  -1, 185,
 170,  -1, 226,  30,  -7,  -3,  -1, 225,  93,  -1, 213, 124,  -3,  -1, 199,
  77,  -1, 139, 184, -31, -15,  -7,  -3,  -1, 212, 154,  -1, 169, 108,  -3,
  -1, 198,  61,  -1, 211,  45,  -7,  -3,  -1, 210,  29,  -1, 123, 183,  -3,
  -1, 209,  92,  -1, 197, 138, -17,  -7,  -3,  -1, 168, 153,  -1,  76, 196,
  -3,  -1, 107, 182,  -3,  -1, 208,  12,  60,  -7,  -3,  -1, 195, 122,  -1,
 167,  44,  -3,  -1, 194,  91,  -1, 181,  28, -57, -35, -19,  -7,  -3,  -1,
 137, 152,  -1, 193,  75,  -5,  -3,  -1, 192,  11,  59,  -3,  -1, 176,  10,
  26,  -5,  -1, 180,  -1, 106, 166,  -3,  -1, 121, 151,  -3,  -1, 160,   9,
 144,  -9,  -3,  -1, 179, 136,  -3,  -1,  43,  90, 178,  -7,  -3,  -1, 165,
  27,  -1, 177, 105,  -1, 150, 164, -17,  -9,  -5,  -3,  -1,  74, 120, 135,
  -1,  58, 163,  -3,  -1,  89, 149,  -1,  42, 162,  -7,  -3,  -1, 161, 104,
  -1, 134, 119,  -3,  -1,  73, 148,  -1,  57, 147, -63, -31, -15,  -7,  -3,
  -1,  88, 133,  -1,  41, 103,  -3,  -1, 118, 146,  -1,  25, 145,  -7,  -3,
  -1,  72, 132,  -1,  87, 117,  -3,  -1,  56, 131,  -1, 102,  40, -17,  -7,
  -3,  -1, 130,  24,  -1,  71, 116,  -5,  -1, 129,  -1,   8, 128,  -1,  86,
 101,  -7,  -5,  -1,  23,  -1,   7, 112, 115,  -3,  -1,  55,  39, 114, -15,
  -7,  -3,  -1,  70, 100,  -1,  85, 113,  -3,  -1,  54,  99,  -1,  69,  84,
  -7,  -3,  -1,  38,  98,  -1,  22,  97,  -5,  -3,  -1,   6,  96,  53,  -1,
  83,  68, -51, -37, -23, -15,  -9,  -3,  -1,  37,  82,  -1,  21,  -1,   5,
  80,  -1,  81,  -1,  52,  67,  -3,  -1,  36,  66,  -1,  51,  20,  -9,  -5,
  -1,  65,  -1,   4,  64,  -1,  35,  50,  -1,  19,  49,  -7,  -5,  -3,  -1,
   3,  48,  34,  18,  -1,  33,  -1,   2,  32,  -3,  -1,  17,   1,  -1,  16,
   0

################################################################################

TITLE
    mp3lib huffman tab_c0

TYPE
    16

DATA
 -29, -21, -13,  -7,  -3,  -1,  11,  15,  -1,  13,  14,  -3,  -1,   7,   5,
   9,  -3,  -1,   6,   3,  -1,  10,  12,  -3,  -1,   2,   1,  -1,   4,   8,
   0

################################################################################

TITLE
    mp3lib huffman tab_c1

TYPE
    16

DATA
 -15,  -7,  -3,  -1,  15,  14,  -1,  13,  12,  -3,  -1,  11,  10,  -1,   9,
   8,  -7,  -3,  -1,   7,   6,  -1,   5,   4,  -3,  -1,   3,   2,  -1,   1,
   0

################################################################################

TITLE
    mp3lib bandInfo

TYPE
    8 HEX

DATA
 00 00 00 00 04 00 00 00 08 00 00 00 0c 00 00 00
 10 00 00 00 14 00 00 00 18 00 00 00 1e 00 00 00
 24 00 00 00 2c 00 00 00 34 00 00 00 3e 00 00 00
 4a 00 00 00 5a 00 00 00 6e 00 00 00 86 00 00 00
 a2 00 00 00 c4 00 00 00 ee 00 00 00 20 01 00 00
 56 01 00 00 a2 01 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 04 00 00 00
 04 00 00 00 06 00 00 00 06 00 00 00 08 00 00 00
 08 00 00 00 0a 00 00 00 0c 00 00 00 10 00 00 00
 14 00 00 00 18 00 00 00 1c 00 00 00 22 00 00 00
 2a 00 00 00 32 00 00 00 36 00 00 00 4c 00 00 00
 9e 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 30 00 00 00 42 00 00 00 5a 00 00 00
 78 00 00 00 9c 00 00 00 c6 00 00 00 fc 00 00 00
 3e 01 00 00 98 01 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 06 00 00 00
 08 00 00 00 0a 00 00 00 0c 00 00 00 0e 00 00 00
 12 00 00 00 16 00 00 00 1e 00 00 00 38 00 00 00
 00 00 00 00 04 00 00 00 08 00 00 00 0c 00 00 00
 10 00 00 00 14 00 00 00 18 00 00 00 1e 00 00 00
 24 00 00 00 2a 00 00 00 32 00 00 00 3c 00 00 00
 48 00 00 00 58 00 00 00 6a 00 00 00 80 00 00 00
 9c 00 00 00 be 00 00 00 e6 00 00 00 14 01 00 00
 4a 01 00 00 80 01 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 04 00 00 00
 04 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 08 00 00 00 0a 00 00 00 0c 00 00 00 10 00 00 00
 12 00 00 00 16 00 00 00 1c 00 00 00 22 00 00 00
 28 00 00 00 2e 00 00 00 36 00 00 00 36 00 00 00
 c0 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 30 00 00 00 42 00 00 00 54 00 00 00
 72 00 00 00 96 00 00 00 c0 00 00 00 f0 00 00 00
 2c 01 00 00 7a 01 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 06 00 00 00
 06 00 00 00 0a 00 00 00 0c 00 00 00 0e 00 00 00
 10 00 00 00 14 00 00 00 1a 00 00 00 42 00 00 00
 00 00 00 00 04 00 00 00 08 00 00 00 0c 00 00 00
 10 00 00 00 14 00 00 00 18 00 00 00 1e 00 00 00
 24 00 00 00 2c 00 00 00 36 00 00 00 42 00 00 00
 52 00 00 00 66 00 00 00 7e 00 00 00 9c 00 00 00
 c2 00 00 00 f0 00 00 00 28 01 00 00 6c 01 00 00
 c0 01 00 00 26 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 04 00 00 00
 04 00 00 00 06 00 00 00 06 00 00 00 08 00 00 00
 0a 00 00 00 0c 00 00 00 10 00 00 00 14 00 00 00
 18 00 00 00 1e 00 00 00 26 00 00 00 2e 00 00 00
 38 00 00 00 44 00 00 00 54 00 00 00 66 00 00 00
 1a 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 30 00 00 00 42 00 00 00 5a 00 00 00
 7e 00 00 00 ae 00 00 00 ea 00 00 00 38 01 00 00
 9e 01 00 00 1c 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 04 00 00 00 06 00 00 00
 08 00 00 00 0c 00 00 00 10 00 00 00 14 00 00 00
 1a 00 00 00 22 00 00 00 2a 00 00 00 0c 00 00 00
 00 00 00 00 06 00 00 00 0c 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 24 00 00 00 2c 00 00 00
 36 00 00 00 42 00 00 00 50 00 00 00 60 00 00 00
 74 00 00 00 8c 00 00 00 a8 00 00 00 c8 00 00 00
 ee 00 00 00 1c 01 00 00 50 01 00 00 8c 01 00 00
 d0 01 00 00 0a 02 00 00 40 02 00 00 06 00 00 00
 06 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 06 00 00 00 08 00 00 00 0a 00 00 00 0c 00 00 00
 0e 00 00 00 10 00 00 00 14 00 00 00 18 00 00 00
 1c 00 00 00 20 00 00 00 26 00 00 00 2e 00 00 00
 34 00 00 00 3c 00 00 00 44 00 00 00 3a 00 00 00
 36 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 36 00 00 00 48 00 00 00 60 00 00 00
 7e 00 00 00 a8 00 00 00 de 00 00 00 2c 01 00 00
 8c 01 00 00 0a 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 06 00 00 00 06 00 00 00
 08 00 00 00 0a 00 00 00 0e 00 00 00 12 00 00 00
 1a 00 00 00 20 00 00 00 2a 00 00 00 12 00 00 00
 00 00 00 00 06 00 00 00 0c 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 24 00 00 00 2c 00 00 00
 36 00 00 00 42 00 00 00 50 00 00 00 60 00 00 00
 72 00 00 00 88 00 00 00 a2 00 00 00 c2 00 00 00
 e8 00 00 00 16 01 00 00 4c 01 00 00 8a 01 00 00
 d0 01 00 00 1c 02 00 00 40 02 00 00 06 00 00 00
 06 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 06 00 00 00 08 00 00 00 0a 00 00 00 0c 00 00 00
 0e 00 00 00 10 00 00 00 12 00 00 00 16 00 00 00
 1a 00 00 00 20 00 00 00 26 00 00 00 2e 00 00 00
 36 00 00 00 3e 00 00 00 46 00 00 00 4c 00 00 00
 24 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 36 00 00 00 4e 00 00 00 6c 00 00 00
 90 00 00 00 ba 00 00 00 f0 00 00 00 38 01 00 00
 98 01 00 00 1c 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 06 00 00 00 08 00 00 00
 0a 00 00 00 0c 00 00 00 0e 00 00 00 12 00 00 00
 18 00 00 00 20 00 00 00 2c 00 00 00 0c 00 00 00
 00 00 00 00 06 00 00 00 0c 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 24 00 00 00 2c 00 00 00
 36 00 00 00 42 00 00 00 50 00 00 00 60 00 00 00
 74 00 00 00 8c 00 00 00 a8 00 00 00 c8 00 00 00
 ee 00 00 00 1c 01 00 00 50 01 00 00 8c 01 00 00
 d0 01 00 00 0a 02 00 00 40 02 00 00 06 00 00 00
 06 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 06 00 00 00 08 00 00 00 0a 00 00 00 0c 00 00 00
 0e 00 00 00 10 00 00 00 14 00 00 00 18 00 00 00
 1c 00 00 00 20 00 00 00 26 00 00 00 2e 00 00 00
 34 00 00 00 3c 00 00 00 44 00 00 00 3a 00 00 00
 36 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 36 00 00 00 4e 00 00 00 6c 00 00 00
 90 00 00 00 ba 00 00 00 f0 00 00 00 38 01 00 00
 92 01 00 00 0a 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 06 00 00 00 08 00 00 00
 0a 00 00 00 0c 00 00 00 0e 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 28 00 00 00 12 00 00 00
 00 00 00 00 06 00 00 00 0c 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 24 00 00 00 2c 00 00 00
 36 00 00 00 42 00 00 00 50 00 00 00 60 00 00 00
 74 00 00 00 8c 00 00 00 a8 00 00 00 c8 00 00 00
 ee 00 00 00 1c 01 00 00 50 01 00 00 8c 01 00 00
 d0 01 00 00 0a 02 00 00 40 02 00 00 06 00 00 00
 06 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 06 00 00 00 08 00 00 00 0a 00 00 00 0c 00 00 00
 0e 00 00 00 10 00 00 00 14 00 00 00 18 00 00 00
 1c 00 00 00 20 00 00 00 26 00 00 00 2e 00 00 00
 34 00 00 00 3c 00 00 00 44 00 00 00 3a 00 00 00
 36 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 36 00 00 00 4e 00 00 00 6c 00 00 00
 90 00 00 00 ba 00 00 00 f0 00 00 00 38 01 00 00
 92 01 00 00 0a 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 06 00 00 00 08 00 00 00
 0a 00 00 00 0c 00 00 00 0e 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 28 00 00 00 12 00 00 00
 00 00 00 00 06 00 00 00 0c 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 24 00 00 00 2c 00 00 00
 36 00 00 00 42 00 00 00 50 00 00 00 60 00 00 00
 74 00 00 00 8c 00 00 00 a8 00 00 00 c8 00 00 00
 ee 00 00 00 1c 01 00 00 50 01 00 00 8c 01 00 00
 d0 01 00 00 0a 02 00 00 40 02 00 00 06 00 00 00
 06 00 00 00 06 00 00 00 06 00 00 00 06 00 00 00
 06 00 00 00 08 00 00 00 0a 00 00 00 0c 00 00 00
 0e 00 00 00 10 00 00 00 14 00 00 00 18 00 00 00
 1c 00 00 00 20 00 00 00 26 00 00 00 2e 00 00 00
 34 00 00 00 3c 00 00 00 44 00 00 00 3a 00 00 00
 36 00 00 00 00 00 00 00 0c 00 00 00 18 00 00 00
 24 00 00 00 36 00 00 00 4e 00 00 00 6c 00 00 00
 90 00 00 00 ba 00 00 00 f0 00 00 00 38 01 00 00
 92 01 00 00 0a 02 00 00 40 02 00 00 04 00 00 00
 04 00 00 00 04 00 00 00 06 00 00 00 08 00 00 00
 0a 00 00 00 0c 00 00 00 0e 00 00 00 12 00 00 00
 18 00 00 00 1e 00 00 00 28 00 00 00 12 00 00 00
 00 00 00 00 0c 00 00 00 18 00 00 00 24 00 00 00
 30 00 00 00 3c 00 00 00 48 00 00 00 58 00 00 00
 6c 00 00 00 84 00 00 00 a0 00 00 00 c0 00 00 00
 e8 00 00 00 18 01 00 00 50 01 00 00 90 01 00 00
 dc 01 00 00 36 02 00 00 38 02 00 00 3a 02 00 00
 3c 02 00 00 3e 02 00 00 40 02 00 00 0c 00 00 00
 0c 00 00 00 0c 00 00 00 0c 00 00 00 0c 00 00 00
 0c 00 00 00 10 00 00 00 14 00 00 00 18 00 00 00
 1c 00 00 00 20 00 00 00 28 00 00 00 30 00 00 00
 38 00 00 00 40 00 00 00 4c 00 00 00 5a 00 00 00
 02 00 00 00 02 00 00 00 02 00 00 00 02 00 00 00
 02 00 00 00 00 00 00 00 18 00 00 00 30 00 00 00
 48 00 00 00 6c 00 00 00 9c 00 00 00 d8 00 00 00
 20 01 00 00 74 01 00 00 e0 01 00 00 e6 01 00 00
 ec 01 00 00 f2 01 00 00 40 02 00 00 08 00 00 00
 08 00 00 00 08 00 00 00 0c 00 00 00 10 00 00 00
 14 00 00 00 18 00 00 00 1c 00 00 00 24 00 00 00
 02 00 00 00 02 00 00 00 02 00 00 00 1a 00 00 00

################################################################################

TITLE
    mp3lib intwinbase

TYPE
    32

DATA
     0,    -1,    -1,    -1,    -1,    -1,    -1,    -2,    -2,    -2,
    -2,    -3,    -3,    -4,    -4,    -5,    -5,    -6,    -7,    -7,
    -8,    -9,   -10,   -11,   -13,   -14,   -16,   -17,   -19,   -21,
   -24,   -26,   -29,   -31,   -35,   -38,   -41,   -45,   -49,   -53,
   -58,   -63,   -68,   -73,   -79,   -85,   -91,   -97,  -104,  -111,
  -117,  -125,  -132,  -139,  -147,  -154,  -161,  -169,  -176,  -183,
  -190,  -196,  -202,  -208,  -213,  -218,  -222,  -225,  -227,  -228,
  -228,  -227,  -224,  -221,  -215,  -208,  -200,  -189,  -177,  -163,
  -146,  -127,  -106,   -83,   -57,   -29,     2,    36,    72,   111,
   153,   197,   244,   294,   347,   401,   459,   519,   581,   645,
   711,   779,   848,   919,   991,  1064,  1137,  1210,  1283,  1356,
  1428,  1498,  1567,  1634,  1698,  1759,  1817,  1870,  1919,  1962,
  2001,  2032,  2057,  2075,  2085,  2087,  2080,  2063,  2037,  2000,
  1952,  1893,  1822,  1739,  1644,  1535,  1414,  1280,  1131,   970,
   794,   605,   402,   185,   -45,  -288,  -545,  -814, -1095, -1388,
 -1692, -2006, -2330, -2663, -3004, -3351, -3705, -4063, -4425, -4788,
 -5153, -5517, -5879, -6237, -6589, -6935, -7271, -7597, -7910, -8209,
 -8491, -8755, -8998, -9219, -9416, -9585, -9727, -9838, -9916, -9959,
 -9966, -9935, -9863, -9750, -9592, -9389, -9139, -8840, -8492, -8092,
 -7640, -7134, -6574, -5959, -5288, -4561, -3776, -2935, -2037, -1082,
   -70,   998,  2122,  3300,  4533,  5818,  7154,  8540,  9975, 11455,
 12980, 14548, 16155, 17799, 19478, 21189, 22929, 24694, 26482, 28289,
 30112, 31947, 33791, 35640, 37489, 39336, 41176, 43006, 44821, 46617,
 48390, 50137, 51853, 53534, 55178, 56778, 58333, 59838, 61289, 62684,
 64019, 65290, 66494, 67629, 68692, 69679, 70590, 71420, 72169, 72835,
 73415, 73908, 74313, 74630, 74856, 74992, 75038 };

################################################################################

TITLE
    mp3lib intwinbase_MMX

TYPE
    32

DATA
	      0,    -1,    -1,    -1,    -1,    -1,    -1,    -2,
	     -2,    -2,    -2,    -3,    -3,    -4,    -4,    -5,
	     -5,    -6,    -7,    -7,    -8,    -9,   -10,   -11,
	    -13,   -14,   -16,   -17,   -19,   -21,   -24,   -26,
	    -29,   -31,   -35,   -38,   -41,   -45,   -49,   -53,
	    -58,   -63,   -68,   -73,   -79,   -85,   -91,   -97,
	   -104,  -111,  -117,  -125,  -132,  -139,  -147,  -154,
	   -161,  -169,  -176,  -183,  -190,  -196,  -202,  -208,
	   -213,  -218,  -222,  -225,  -227,  -228,  -228,  -227,
	   -224,  -221,  -215,  -208,  -200,  -189,  -177,  -163,
	   -146,  -127,  -106,   -83,   -57,   -29,     2,    36,
	     72,   111,   153,   197,   244,   294,   347,   401,
	    459,   519,   581,   645,   711,   779,   848,   919,
	    991,  1064,  1137,  1210,  1283,  1356,  1428,  1498,
	   1567,  1634,  1698,  1759,  1817,  1870,  1919,  1962,
	   2001,  2032,  2057,  2075,  2085,  2087,  2080,  2063,
	   2037,  2000,  1952,  1893,  1822,  1739,  1644,  1535,
	   1414,  1280,  1131,   970,   794,   605,   402,   185,
	    -45,  -288,  -545,  -814, -1095, -1388, -1692, -2006,
	  -2330, -2663, -3004, -3351, -3705, -4063, -4425, -4788,
	  -5153, -5517, -5879, -6237, -6589, -6935, -7271, -7597,
	  -7910, -8209, -8491, -8755, -8998, -9219, -9416, -9585,
	  -9727, -9838, -9916, -9959, -9966, -9935, -9863, -9750,
	  -9592, -9389, -9139, -8840, -8492, -8092, -7640, -7134,
	  -6574, -5959, -5288, -4561, -3776, -2935, -2037, -1082,
	    -70,   998,  2122,  3300,  4533,  5818,  7154,  8540,
	   9975, 11455, 12980, 14548, 16155, 17799, 19478, 21189,
	  22929, 24694, 26482, 28289, 30112, 31947,-26209,-24360,
	 -22511,-20664,-18824,-16994,-15179,-13383,-11610, -9863,
	  -8147, -6466, -4822, -3222, -1667,  -162,  1289,  2684,
	   4019,  5290,  6494,  7629,  8692,  9679, 10590, 11420,
	  12169, 12835, 13415, 13908, 14313, 14630, 14856, 14992,
	  15038

################################################################################

TITLE
    libdjvu IW44 norm of all wavelets

TYPE
    FLOAT

DATA
  2.627989e+03F,
  1.832893e+02F, 1.832959e+02F, 5.114690e+01F,
  4.583344e+01F, 4.583462e+01F, 1.279225e+01F,
  1.149671e+01F, 1.149712e+01F, 3.218888e+00F,
  2.999281e+00F, 2.999476e+00F, 8.733161e-01F,
  1.074451e+00F, 1.074511e+00F, 4.289318e-01F

################################################################################

TITLE
    libdjvu GPixmap dither table

TYPE
    8 16

DATA
    {   0,192, 48,240, 12,204, 60,252,  3,195, 51,243, 15,207, 63,255 },
    { 128, 64,176,112,140, 76,188,124,131, 67,179,115,143, 79,191,127 },
    {  32,224, 16,208, 44,236, 28,220, 35,227, 19,211, 47,239, 31,223 },
    { 160, 96,144, 80,172,108,156, 92,163, 99,147, 83,175,111,159, 95 },
    {   8,200, 56,248,  4,196, 52,244, 11,203, 59,251,  7,199, 55,247 },
    { 136, 72,184,120,132, 68,180,116,139, 75,187,123,135, 71,183,119 },
    {  40,232, 24,216, 36,228, 20,212, 43,235, 27,219, 39,231, 23,215 },
    { 168,104,152, 88,164,100,148, 84,171,107,155, 91,167,103,151, 87 },
    {   2,194, 50,242, 14,206, 62,254,  1,193, 49,241, 13,205, 61,253 },
    { 130, 66,178,114,142, 78,190,126,129, 65,177,113,141, 77,189,125 },
    {  34,226, 18,210, 46,238, 30,222, 33,225, 17,209, 45,237, 29,221 },
    { 162, 98,146, 82,174,110,158, 94,161, 97,145, 81,173,109,157, 93 },
    {  10,202, 58,250,  6,198, 54,246,  9,201, 57,249,  5,197, 53,245 },
    { 138, 74,186,122,134, 70,182,118,137, 73,185,121,133, 69,181,117 },
    {  42,234, 26,218, 38,230, 22,214, 41,233, 25,217, 37,229, 21,213 },
    { 170,106,154, 90,166,102,150, 86,169,105,153, 89,165,101,149, 85 }

################################################################################

TITLE
    libdjvu MMR wcodes

TYPE
    16

DATA
  // 13 bit codes
  { 0x06a0,  8,    0 }, // 00110101
  { 0x0380,  6,    1 }, // 000111
  { 0x0e00,  4,    2 }, // 0111
  { 0x1000,  4,    3 }, // 1000
  { 0x1600,  4,    4 }, // 1011
  { 0x1800,  4,    5 }, // 1100
  { 0x1c00,  4,    6 }, // 1110
  { 0x1e00,  4,    7 }, // 1111
  { 0x1300,  5,    8 }, // 10011
  { 0x1400,  5,    9 }, // 10100
  { 0x0700,  5,   10 }, // 00111
  { 0x0800,  5,   11 }, // 01000
  { 0x0400,  6,   12 }, // 001000
  { 0x0180,  6,   13 }, // 000011
  { 0x1a00,  6,   14 }, // 110100
  { 0x1a80,  6,   15 }, // 110101
  { 0x1500,  6,   16 }, // 101010
  { 0x1580,  6,   17 }, // 101011
  { 0x09c0,  7,   18 }, // 0100111
  { 0x0300,  7,   19 }, // 0001100
  { 0x0200,  7,   20 }, // 0001000
  { 0x05c0,  7,   21 }, // 0010111
  { 0x00c0,  7,   22 }, // 0000011
  { 0x0100,  7,   23 }, // 0000100
  { 0x0a00,  7,   24 }, // 0101000
  { 0x0ac0,  7,   25 }, // 0101011
  { 0x04c0,  7,   26 }, // 0010011
  { 0x0900,  7,   27 }, // 0100100
  { 0x0600,  7,   28 }, // 0011000
  { 0x0040,  8,   29 }, // 00000010
  { 0x0060,  8,   30 }, // 00000011
  { 0x0340,  8,   31 }, // 00011010
  { 0x0360,  8,   32 }, // 00011011
  { 0x0240,  8,   33 }, // 00010010
  { 0x0260,  8,   34 }, // 00010011
  { 0x0280,  8,   35 }, // 00010100
  { 0x02a0,  8,   36 }, // 00010101
  { 0x02c0,  8,   37 }, // 00010110
  { 0x02e0,  8,   38 }, // 00010111
  { 0x0500,  8,   39 }, // 00101000
  { 0x0520,  8,   40 }, // 00101001
  { 0x0540,  8,   41 }, // 00101010
  { 0x0560,  8,   42 }, // 00101011
  { 0x0580,  8,   43 }, // 00101100
  { 0x05a0,  8,   44 }, // 00101101
  { 0x0080,  8,   45 }, // 00000100
  { 0x00a0,  8,   46 }, // 00000101
  { 0x0140,  8,   47 }, // 00001010
  { 0x0160,  8,   48 }, // 00001011
  { 0x0a40,  8,   49 }, // 01010010
  { 0x0a60,  8,   50 }, // 01010011
  { 0x0a80,  8,   51 }, // 01010100
  { 0x0aa0,  8,   52 }, // 01010101
  { 0x0480,  8,   53 }, // 00100100
  { 0x04a0,  8,   54 }, // 00100101
  { 0x0b00,  8,   55 }, // 01011000
  { 0x0b20,  8,   56 }, // 01011001
  { 0x0b40,  8,   57 }, // 01011010
  { 0x0b60,  8,   58 }, // 01011011
  { 0x0940,  8,   59 }, // 01001010
  { 0x0960,  8,   60 }, // 01001011
  { 0x0640,  8,   61 }, // 00110010
  { 0x0660,  8,   62 }, // 00110011
  { 0x0680,  8,   63 }, // 00110100
  { 0x1b00,  5,   64 }, // 11011
  { 0x1200,  5,  128 }, // 10010
  { 0x0b80,  6,  192 }, // 010111
  { 0x0dc0,  7,  256 }, // 0110111
  { 0x06c0,  8,  320 }, // 00110110
  { 0x06e0,  8,  384 }, // 00110111
  { 0x0c80,  8,  448 }, // 01100100
  { 0x0ca0,  8,  512 }, // 01100101
  { 0x0d00,  8,  576 }, // 01101000
  { 0x0ce0,  8,  640 }, // 01100111
  { 0x0cc0,  9,  704 }, // 011001100
  { 0x0cd0,  9,  768 }, // 011001101
  { 0x0d20,  9,  832 }, // 011010010
  { 0x0d30,  9,  896 }, // 011010011
  { 0x0d40,  9,  960 }, // 011010100
  { 0x0d50,  9, 1024 }, // 011010101
  { 0x0d60,  9, 1088 }, // 011010110
  { 0x0d70,  9, 1152 }, // 011010111
  { 0x0d80,  9, 1216 }, // 011011000
  { 0x0d90,  9, 1280 }, // 011011001
  { 0x0da0,  9, 1344 }, // 011011010
  { 0x0db0,  9, 1408 }, // 011011011
  { 0x0980,  9, 1472 }, // 010011000
  { 0x0990,  9, 1536 }, // 010011001
  { 0x09a0,  9, 1600 }, // 010011010
  { 0x0c00,  6, 1664 }, // 011000  (what did they think?)
  { 0x09b0,  9, 1728 }, // 010011011
  { 0x0020, 11, 1792 }, // 00000001000
  { 0x0030, 11, 1856 }, // 00000001100
  { 0x0034, 11, 1920 }, // 00000001101
  { 0x0024, 12, 1984 }, // 000000010010
  { 0x0026, 12, 2048 }, // 000000010011
  { 0x0028, 12, 2112 }, // 000000010100
  { 0x002a, 12, 2176 }, // 000000010101
  { 0x002c, 12, 2240 }, // 000000010110
  { 0x002e, 12, 2304 }, // 000000010111
  { 0x0038, 12, 2368 }, // 000000011100
  { 0x003a, 12, 2432 }, // 000000011101
  { 0x003c, 12, 2496 }, // 000000011110
  { 0x003e, 12, 2560 }, // 000000011111
  { 0x0000,  0,   -1 }  // Illegal entry

################################################################################

TITLE
    libdjvu MMR bcodes

TYPE
    16

DATA
  // 13 bit codes
  { 0x01b8, 10,    0 }, // 0000110111
  { 0x0800,  3,    1 }, // 010
  { 0x1800,  2,    2 }, // 11
  { 0x1000,  2,    3 }, // 10
  { 0x0c00,  3,    4 }, // 011
  { 0x0600,  4,    5 }, // 0011
  { 0x0400,  4,    6 }, // 0010
  { 0x0300,  5,    7 }, // 00011
  { 0x0280,  6,    8 }, // 000101
  { 0x0200,  6,    9 }, // 000100
  { 0x0100,  7,   10 }, // 0000100
  { 0x0140,  7,   11 }, // 0000101
  { 0x01c0,  7,   12 }, // 0000111
  { 0x0080,  8,   13 }, // 00000100
  { 0x00e0,  8,   14 }, // 00000111
  { 0x0180,  9,   15 }, // 000011000
  { 0x00b8, 10,   16 }, // 0000010111
  { 0x00c0, 10,   17 }, // 0000011000
  { 0x0040, 10,   18 }, // 0000001000
  { 0x019c, 11,   19 }, // 00001100111
  { 0x01a0, 11,   20 }, // 00001101000
  { 0x01b0, 11,   21 }, // 00001101100
  { 0x00dc, 11,   22 }, // 00000110111
  { 0x00a0, 11,   23 }, // 00000101000
  { 0x005c, 11,   24 }, // 00000010111
  { 0x0060, 11,   25 }, // 00000011000
  { 0x0194, 12,   26 }, // 000011001010
  { 0x0196, 12,   27 }, // 000011001011
  { 0x0198, 12,   28 }, // 000011001100
  { 0x019a, 12,   29 }, // 000011001101
  { 0x00d0, 12,   30 }, // 000001101000
  { 0x00d2, 12,   31 }, // 000001101001
  { 0x00d4, 12,   32 }, // 000001101010
  { 0x00d6, 12,   33 }, // 000001101011
  { 0x01a4, 12,   34 }, // 000011010010
  { 0x01a6, 12,   35 }, // 000011010011
  { 0x01a8, 12,   36 }, // 000011010100
  { 0x01aa, 12,   37 }, // 000011010101
  { 0x01ac, 12,   38 }, // 000011010110
  { 0x01ae, 12,   39 }, // 000011010111
  { 0x00d8, 12,   40 }, // 000001101100
  { 0x00da, 12,   41 }, // 000001101101
  { 0x01b4, 12,   42 }, // 000011011010
  { 0x01b6, 12,   43 }, // 000011011011
  { 0x00a8, 12,   44 }, // 000001010100
  { 0x00aa, 12,   45 }, // 000001010101
  { 0x00ac, 12,   46 }, // 000001010110
  { 0x00ae, 12,   47 }, // 000001010111
  { 0x00c8, 12,   48 }, // 000001100100
  { 0x00ca, 12,   49 }, // 000001100101
  { 0x00a4, 12,   50 }, // 000001010010
  { 0x00a6, 12,   51 }, // 000001010011
  { 0x0048, 12,   52 }, // 000000100100
  { 0x006e, 12,   53 }, // 000000110111
  { 0x0070, 12,   54 }, // 000000111000
  { 0x004e, 12,   55 }, // 000000100111
  { 0x0050, 12,   56 }, // 000000101000
  { 0x00b0, 12,   57 }, // 000001011000
  { 0x00b2, 12,   58 }, // 000001011001
  { 0x0056, 12,   59 }, // 000000101011
  { 0x0058, 12,   60 }, // 000000101100
  { 0x00b4, 12,   61 }, // 000001011010
  { 0x00cc, 12,   62 }, // 000001100110
  { 0x00ce, 12,   63 }, // 000001100111
  { 0x0078, 10,   64 }, // 0000001111
  { 0x0190, 12,  128 }, // 000011001000
  { 0x0192, 12,  192 }, // 000011001001
  { 0x00b6, 12,  256 }, // 000001011011
  { 0x0066, 12,  320 }, // 000000110011
  { 0x0068, 12,  384 }, // 000000110100
  { 0x006a, 12,  448 }, // 000000110101
  { 0x006c, 13,  512 }, // 0000001101100
  { 0x006d, 13,  576 }, // 0000001101101
  { 0x004a, 13,  640 }, // 0000001001010
  { 0x004b, 13,  704 }, // 0000001001011
  { 0x004c, 13,  768 }, // 0000001001100
  { 0x004d, 13,  832 }, // 0000001001101
  { 0x0072, 13,  896 }, // 0000001110010
  { 0x0073, 13,  960 }, // 0000001110011
  { 0x0074, 13, 1024 }, // 0000001110100
  { 0x0075, 13, 1088 }, // 0000001110101
  { 0x0076, 13, 1152 }, // 0000001110110
  { 0x0077, 13, 1216 }, // 0000001110111
  { 0x0052, 13, 1280 }, // 0000001010010
  { 0x0053, 13, 1344 }, // 0000001010011
  { 0x0054, 13, 1408 }, // 0000001010100
  { 0x0055, 13, 1472 }, // 0000001010101
  { 0x005a, 13, 1536 }, // 0000001011010
  { 0x005b, 13, 1600 }, // 0000001011011
  { 0x0064, 13, 1664 }, // 0000001100100
  { 0x0065, 13, 1728 }, // 0000001100101
  { 0x0020, 11, 1792 }, // 00000001000
  { 0x0030, 11, 1856 }, // 00000001100
  { 0x0034, 11, 1920 }, // 00000001101
  { 0x0024, 12, 1984 }, // 000000010010
  { 0x0026, 12, 2048 }, // 000000010011
  { 0x0028, 12, 2112 }, // 000000010100
  { 0x002a, 12, 2176 }, // 000000010101
  { 0x002c, 12, 2240 }, // 000000010110
  { 0x002e, 12, 2304 }, // 000000010111
  { 0x0038, 12, 2368 }, // 000000011100
  { 0x003a, 12, 2432 }, // 000000011101
  { 0x003c, 12, 2496 }, // 000000011110
  { 0x003e, 12, 2560 }, // 000000011111
  { 0x0000,  0,   -1 }  // Illegal entry

################################################################################

TITLE
    Borland alternate ebcdic_to_ascii

TYPE
    8

DATA
 0x00,0x01,0x02,0x03,0x00,0x09,0x00,0x7f,0x00,0x00,0x00,0x0b,0x0c,0x0d,0x0e,0x0f
,0x10,0x11,0x12,0x13,0x00,0x00,0x08,0x00,0x18,0x19,0x00,0x00,0x1c,0x1d,0x1e,0x1f
,0x00,0x00,0x00,0x00,0x00,0x0a,0x17,0x1b,0x00,0x00,0x00,0x00,0x00,0x05,0x06,0x07
,0x00,0x00,0x16,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x14,0x15,0x00,0x1a
,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5b,0x2e,0x3c,0x28,0x2b,0x21
,0x26,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x21,0x24,0x2a,0x29,0x3b,0x5e
,0x2d,0x2f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7c,0x2c,0x25,0x5f,0x3e,0x3f
,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x3a,0x23,0x40,0x27,0x3d,0x22
,0x00,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x00,0x00,0x00,0x00,0x00,0x00
,0x00,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,0x00,0x00,0x00,0x00,0x00,0x00
,0x00,0x7e,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x00,0x00,0x00,0x00,0x00,0x00
,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
,0x7b,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x00,0x00,0x00,0x00,0x00,0x00
,0x7d,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0x00,0x00,0x00,0x00,0x00,0x00
,0x00,0x00,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x00,0x00,0x00,0x00,0x00,0x00
,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x00,0x00,0x00,0x00,0x00,0xff

################################################################################

TITLE
    Borland ascii_to_ebcdic

TYPE
    8

DATA
 0x00,0x01,0x02,0x03,0x37,0x2d,0x2e,0x2f,0x16,0x05,0x25,0x0b,0x0c,0x0d,0x0e,0x0f
,0x10,0x11,0x12,0x13,0x3c,0x3d,0x32,0x26,0x18,0x19,0x3f,0x27,0x1c,0x1d,0x1e,0x1f
,0x40,0x4f,0x7f,0x7b,0x5b,0x6c,0x50,0x7d,0x4d,0x5d,0x5c,0x4e,0x6b,0x60,0x4b,0x61
,0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0x7a,0x5e,0x4c,0x7e,0x6e,0x6f
,0x7c,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6
,0xd7,0xd8,0xd9,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0x4a,0xe0,0x5a,0x5f,0x6d
,0x79,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x91,0x92,0x93,0x94,0x95,0x96
,0x97,0x98,0x99,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xc0,0x6a,0xd0,0xa1,0x07
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f
,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0xff

################################################################################

TITLE
    Borland ebcdic_to_ascii

TYPE
    8

DATA
 0x00,0x01,0x02,0x03,0x5c,0x09,0x5c,0x7f,0x5c,0x5c,0x5c,0x0b,0x0c,0x0d,0x0e,0x0f
,0x10,0x11,0x12,0x13,0x5c,0x5c,0x08,0x5c,0x18,0x19,0x5c,0x5c,0x1c,0x1d,0x1e,0x1f
,0x5c,0x5c,0x5c,0x5c,0x5c,0x0a,0x17,0x1b,0x5c,0x5c,0x5c,0x5c,0x5c,0x05,0x06,0x07
,0x5c,0x5c,0x16,0x5c,0x5c,0x5c,0x5c,0x04,0x5c,0x5c,0x5c,0x5c,0x14,0x15,0x5c,0x1a
,0x20,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5b,0x2e,0x3c,0x28,0x2b,0x21
,0x26,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5d,0x24,0x2a,0x29,0x3b,0x5e
,0x2d,0x2f,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x7c,0x2c,0x25,0x5f,0x3e,0x3f
,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x60,0x3a,0x23,0x40,0x27,0x3d,0x22
,0x5c,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x5c,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x5c,0x7e,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x7b,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x7d,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x5c,0x5c,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5c,0x5c,0x5c,0x5c,0x5c,0x5c
,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x5c,0x5c,0x5c,0x5c,0x5c,0xff

################################################################################

TITLE
    Borland Jfif CrRTable

TYPE
    32

DATA
-179, -178, -177, -175, -174, -172, -171, -170,
-168, -167, -165, -164, -163, -161, -160, -158,
-157, -156, -154, -153, -151, -150, -149, -147,
-146, -144, -143, -142, -140, -139, -137, -136,
-135, -133, -132, -130, -129, -128, -126, -125,
-123, -122, -121, -119, -118, -116, -115, -114,
-112, -111, -109, -108, -107, -105, -104, -102,
-101, -100,  -98,  -97,  -95,  -94,  -93,  -91,
 -90,  -88,  -87,  -86,  -84,  -83,  -81,  -80,
 -79,  -77,  -76,  -74,  -73,  -72,  -70,  -69,
 -67,  -66,  -64,  -63,  -62,  -60,  -59,  -57,
 -56,  -55,  -53,  -52,  -50,  -49,  -48,  -46,
 -45,  -43,  -42,  -41,  -39,  -38,  -36,  -35,
 -34,  -32,  -31,  -29,  -28,  -27,  -25,  -24,
 -22,  -21,  -20,  -18,  -17,  -15,  -14,  -13,
 -11,  -10,   -8,   -7,   -6,   -4,   -3,   -1,
   0,    1,    3,    4,    6,    7,    8,   10,
  11,   13,   14,   15,   17,   18,   20,   21,
  22,   24,   25,   27,   28,   29,   31,   32,
  34,   35,   36,   38,   39,   41,   42,   43,
  45,   46,   48,   49,   50,   52,   53,   55,
  56,   57,   59,   60,   62,   63,   64,   66,
  67,   69,   70,   72,   73,   74,   76,   77,
  79,   80,   81,   83,   84,   86,   87,   88,
  90,   91,   93,   94,   95,   97,   98,  100,
 101,  102,  104,  105,  107,  108,  109,  111,
 112,  114,  115,  116,  118,  119,  121,  122,
 123,  125,  126,  128,  129,  130,  132,  133,
 135,  136,  137,  139,  140,  142,  143,  144,
 146,  147,  149,  150,  151,  153,  154,  156,
 157,  158,  160,  161,  163,  164,  165,  167,
 168,  170,  171,  172,  174,  175,  177,  178,

################################################################################

TITLE
    Borland Jfif CbGTable

TYPE
    32

DATA
-2802969, -2781071, -2759173, -2737275, -2715377, -2693478, -2671580, -2649682,
-2627784, -2605886, -2583987, -2562089, -2540191, -2518293, -2496395, -2474496,
-2452598, -2430700, -2408802, -2386904, -2365005, -2343107, -2321209, -2299311,
-2277413, -2255515, -2233616, -2211718, -2189820, -2167922, -2146024, -2124125,
-2102227, -2080329, -2058431, -2036533, -2014634, -1992736, -1970838, -1948940,
-1927042, -1905143, -1883245, -1861347, -1839449, -1817551, -1795652, -1773754,
-1751856, -1729958, -1708060, -1686161, -1664263, -1642365, -1620467, -1598569,
-1576670, -1554772, -1532874, -1510976, -1489078, -1467179, -1445281, -1423383,
-1401485, -1379587, -1357688, -1335790, -1313892, -1291994, -1270096, -1248197,
-1226299, -1204401, -1182503, -1160605, -1138706, -1116808, -1094910, -1073012,
-1051114, -1029215, -1007317,  -985419,  -963521,  -941623,  -919724,  -897826,
 -875928,  -854030,  -832132,  -810233,  -788335,  -766437,  -744539,  -722641,
 -700742,  -678844,  -656946,  -635048,  -613150,  -591251,  -569353,  -547455,
 -525557,  -503659,  -481760,  -459862,  -437964,  -416066,  -394168,  -372269,
 -350371,  -328473,  -306575,  -284677,  -262778,  -240880,  -218982,  -197084, 
 -175186,  -153287,  -131389,  -109491,   -87593,   -65695,   -43796,   -21898,
       0,    21898,    43796,    65695,    87593,   109491,   131389,   153287, 
  175186,   197084,   218982,   240880,   262778,   284677,   306575,   328473,
  350371,   372269,   394168,   416066,   437964,   459862,   481760,   503659,
  525557,   547455,   569353,   591251,   613150,   635048,   656946,   678844, 
  700742,   722641,   744539,   766437,   788335,   810233,   832132,   854030,
  875928,   897826,   919724,   941623,   963521,   985419,  1007317,  1029215,
 1051114,  1073012,  1094910,  1116808,  1138706,  1160605,  1182503,  1204401,
 1226299,  1248197,  1270096,  1291994,  1313892,  1335790,  1357688,  1379587,
 1401485,  1423383,  1445281,  1467179,  1489078,  1510976,  1532874,  1554772,
 1576670,  1598569,  1620467,  1642365,  1664263,  1686161,  1708060,  1729958,
 1751856,  1773754,  1795652,  1817551,  1839449,  1861347,  1883245,  1905143,
 1927042,  1948940,  1970838,  1992736,  2014634,  2036533,  2058431,  2080329,
 2102227,  2124125,  2146024,  2167922,  2189820,  2211718,  2233616,  2255515,
 2277413,  2299311,  2321209,  2343107,  2365005,  2386904,  2408802,  2430700,
 2452598,  2474496,  2496395,  2518293,  2540191,  2562089,  2583987,  2605886,
 2627784,  2649682,  2671580,  2693478,  2715377,  2737275,  2759173,  2781071,

################################################################################

TITLE
    Borland Jfif CrGTable

TYPE
    32

DATA
-5990641, -5943839, -5897037, -5850235, -5803433, -5756631, -5709829, -5663027,
-5616225, -5569424, -5522622, -5475820, -5429018, -5382216, -5335414, -5288612,
-5241810, -5195009, -5148207, -5101405, -5054603, -5007801, -4960999, -4914197,
-4867395, -4820594, -4773792, -4726990, -4680188, -4633386, -4586584, -4539782,
-4492980, -4446179, -4399377, -4352575, -4305773, -4258971, -4212169, -4165367,
-4118565, -4071763, -4024962, -3978160, -3931358, -3884556, -3837754, -3790952,
-3744150, -3697348, -3650547, -3603745, -3556943, -3510141, -3463339, -3416537,
-3369735, -3322933, -3276132, -3229330, -3182528, -3135726, -3088924, -3042122,
-2995320, -2948518, -2901717, -2854915, -2808113, -2761311, -2714509, -2667707,
-2620905, -2574103, -2527301, -2480500, -2433698, -2386896, -2340094, -2293292,
-2246490, -2199688, -2152886, -2106085, -2059283, -2012481, -1965679, -1918877,
-1872075, -1825273, -1778471, -1731670, -1684868, -1638066, -1591264, -1544462,
-1497660, -1450858, -1404056, -1357254, -1310453, -1263651, -1216849, -1170047,
-1123245, -1076443, -1029641,  -982839,  -936038,  -889236,  -842434,  -795632, 
 -748830,  -702028,  -655226,  -608424,  -561623,  -514821,  -468019,  -421217,
 -374415,  -327613,  -280811,  -234009,  -187208,  -140406,   -93604,   -46802,
       0,    46802,    93604,   140406,   187208,   234009,   280811,   327613,
  374415,   421217,   468019,   514821,   561623,   608424,   655226,   702028,
  748830,   795632,   842434,   889236,   936038,   982839,  1029641,  1076443, 
 1123245,  1170047,  1216849,  1263651,  1310453,  1357254,  1404056,  1450858,
 1497660,  1544462,  1591264,  1638066,  1684868,  1731670,  1778471,  1825273, 
 1872075,  1918877,  1965679,  2012481,  2059283,  2106085,  2152886,  2199688, 
 2246490,  2293292,  2340094,  2386896,  2433698,  2480500,  2527301,  2574103, 
 2620905,  2667707,  2714509,  2761311,  2808113,  2854915,  2901717,  2948518,
 2995320,  3042122,  3088924,  3135726,  3182528,  3229330,  3276132,  3322933, 
 3369735,  3416537,  3463339,  3510141,  3556943,  3603745,  3650547,  3697348, 
 3744150,  3790952,  3837754,  3884556,  3931358,  3978160,  4024962,  4071763, 
 4118565,  4165367,  4212169,  4258971,  4305773,  4352575,  4399377,  4446179,
 4492980,  4539782,  4586584,  4633386,  4680188,  4726990,  4773792,  4820594,
 4867395,  4914197,  4960999,  5007801,  5054603,  5101405,  5148207,  5195009, 
 5241810,  5288612,  5335414,  5382216,  5429018,  5475820,  5522622,  5569424,
 5616225,  5663027,  5709829,  5756631,  5803433,  5850235,  5897037,  5943839,

################################################################################

TITLE
    Borland Jfif CbBTable

TYPE
    32

DATA
-227, -225, -223, -222, -220, -218, -216, -214,
-213, -211, -209, -207, -206, -204, -202, -200,
-198, -197, -195, -193, -191, -190, -188, -186,
-184, -183, -181, -179, -177, -175, -174, -172,
-170, -168, -167, -165, -163, -161, -159, -158, 
-156, -154, -152, -151, -149, -147, -145, -144,
-142, -140, -138, -136, -135, -133, -131, -129, 
-128, -126, -124, -122, -120, -119, -117, -115, 
-113, -112, -110, -108, -106, -105, -103, -101, 
 -99,  -97,  -96,  -94,  -92,  -90,  -89,  -87, 
 -85,  -83,  -82,  -80,  -78,  -76,  -74,  -73,
 -71,  -69,  -67,  -66,  -64,  -62,  -60,  -58,
 -57,  -55,  -53,  -51,  -50,  -48,  -46,  -44,
 -43,  -41,  -39,  -37,  -35,  -34,  -32,  -30, 
 -28,  -27,  -25,  -23,  -21,  -19,  -18,  -16,
 -14,  -12,  -11,   -9,   -7,   -5,   -4,   -2,
   0,    2,    4,    5,    7,    9,   11,   12, 
  14,   16,   18,   19,   21,   23,   25,   27,
  28,   30,   32,   34,   35,   37,   39,   41,
  43,   44,   46,   48,   50,   51,   53,   55, 
  57,   58,   60,   62,   64,   66,   67,   69,
  71,   73,   74,   76,   78,   80,   82,   83,
  85,   87,   89,   90,   92,   94,   96,   97,
  99,  101,  103,  105,  106,  108,  110,  112, 
 113,  115,  117,  119,  120,  122,  124,  126,
 128,  129,  131,  133,  135,  136,  138,  140,
 142,  144,  145,  147,  149,  151,  152,  154, 
 156,  158,  159,  161,  163,  165,  167,  168,
 170,  172,  174,  175,  177,  179,  181,  183, 
 184,  186,  188,  190,  191,  193,  195,  197,
 198,  200,  202,  204,  206,  207,  209,  211, 
 213,  214,  216,  218,  220,  222,  223,  225,

################################################################################

TITLE
    ARGB default palette

TYPE
    32

DATA
0xff01003f, 0xff03003f, 0xff06013e, 0xff09023d, 0xff0b023d, 0xff0e033c, 0xff10043b, 0xff13043b,
0xff15053a, 0xff18063a, 0xff1b0639, 0xff1d0738, 0xff200838, 0xff220837, 0xff250936, 0xff270a36,
0xff2a0a35, 0xff2d0b35, 0xff2f0c34, 0xff320c33, 0xff340d33, 0xff370e32, 0xff390e31, 0xff3c0f31,
0xff3f1030, 0xff411030, 0xff43102f, 0xff46112e, 0xff48122e, 0xff4b122d, 0xff4d132c, 0xff50142c,
0xff52142b, 0xff55152b, 0xff57162a, 0xff5a1629, 0xff5c1729, 0xff5f1728, 0xff611827, 0xff641927,
0xff661926, 0xff691a26, 0xff6b1b25, 0xff6e1b24, 0xff701c24, 0xff731d23, 0xff751d22, 0xff781e22,
0xff7a1e21, 0xff7d1f21, 0xff7f2020, 0xff81201f, 0xff83211f, 0xff85221e, 0xff87221d, 0xff89231d,
0xff8b241c, 0xff8d251c, 0xff8f251b, 0xff91261a, 0xff93271a, 0xff952819, 0xff972818, 0xff992918,
0xff9b2a17, 0xff9d2b17, 0xff9f2c16, 0xffa12c15, 0xffa32d15, 0xffa52e14, 0xffa72f13, 0xffa92f13,
0xffab3012, 0xffad3111, 0xffaf3211, 0xffb13210, 0xffb33310, 0xffb5340f, 0xffb7340e, 0xffb9350e,
0xffbb360d, 0xffbd370c, 0xffbf370c, 0xffc1380b, 0xffc3390b, 0xffc53a0a, 0xffc73a09, 0xffc93b09,
0xffcb3c08, 0xffce3d08, 0xffd03d07, 0xffd23e06, 0xffd43f06, 0xffd64005, 0xffd84004, 0xffda4104,
0xffdc4203, 0xffde4303, 0xffe04302, 0xffe24401, 0xffe44501, 0xffe64600, 0xffe64700, 0xffe64800,
0xffe64a00, 0xffe74b01, 0xffe74d01, 0xffe74f02, 0xffe75002, 0xffe85202, 0xffe85303, 0xffe85503,
0xffe85704, 0xffe95804, 0xffe95a04, 0xffe95b05, 0xffea5d05, 0xffea5f06, 0xffea6006, 0xffea6206,
0xffeb6307, 0xffeb6507, 0xffeb6708, 0xffec6808, 0xffec6a08, 0xffec6b09, 0xffec6d09, 0xffed6f0a,
0xffed700a, 0xffed720a, 0xffee740b, 0xffee750b, 0xffee770c, 0xffee780c, 0xffef7a0c, 0xffef7c0d,
0xffef7d0d, 0xffef7f0e, 0xfff0800e, 0xfff0820e, 0xfff0840f, 0xfff1850f, 0xfff18710, 0xfff18810,
0xfff18a10, 0xfff28b11, 0xfff28c11, 0xfff28e11, 0xfff28f12, 0xfff39112, 0xfff39212, 0xfff39413,
0xfff49513, 0xfff49714, 0xfff49814, 0xfff49a14, 0xfff59b15, 0xfff59d15, 0xfff59e15, 0xfff6a016,
0xfff6a116, 0xfff6a317, 0xfff6a417, 0xfff7a617, 0xfff7a718, 0xfff7a918, 0xfff8aa18, 0xfff8ac19,
0xfff8ae19, 0xfff8af19, 0xfff9b11a, 0xfff9b21a, 0xfff9b41b, 0xfffab51b, 0xfffab71b, 0xfffab81c,
0xfffaba1c, 0xfffbbb1c, 0xfffbbd1d, 0xfffbbe1d, 0xfffcc01e, 0xfffcc11e, 0xfffcc31e, 0xfffcc41f,
0xfffdc61f, 0xfffdc71f, 0xfffdc920, 0xfffeca20, 0xfffecc21, 0xfffecd21, 0xfffecf21, 0xffffd022,
0xffffd021, 0xffffd120, 0xffffd220, 0xffffd31f, 0xffffd31f, 0xffffd41e, 0xffffd51e, 0xffffd61d,
0xffffd61d, 0xffffd71c, 0xffffd81c, 0xffffd91b, 0xffffd91a, 0xffffda1a, 0xffffdb19, 0xffffdc19,
0xffffdc18, 0xffffdd18, 0xffffde17, 0xffffdf17, 0xffffe016, 0xffffe016, 0xffffe115, 0xffffe214,
0xffffe314, 0xffffe313, 0xffffe413, 0xffffe512, 0xffffe612, 0xffffe611, 0xffffe711, 0xffffe710,
0xffffe810, 0xffffe90f, 0xffffea0f, 0xffffea0e, 0xffffeb0e, 0xffffec0d, 0xffffed0d, 0xffffed0c,
0xffffee0b, 0xffffef0b, 0xfffff00a, 0xfffff00a, 0xfffff109, 0xfffff209, 0xfffff208, 0xfffff308,
0xfffff407, 0xfffff507, 0xfffff506, 0xfffff606, 0xfffff705, 0xfffff805, 0xfffff804, 0xfffff904,
0xfffffa03, 0xfffffa03, 0xfffffb02, 0xfffffc02, 0xfffffd01, 0xfffffd01, 0xfffffe00, 0xffffff00

################################################################################

TITLE
    Nsis archive signature

TYPE
    8 32

DATA
0xef,0xbe,0xad,0xde,0x4e,0x75,0x6c,0x6c,0x73,0x6f,0x66,0x74,0x49,0x6e,0x73,0x74,

################################################################################

TITLE
    Nsis archive signature (b)

TYPE
    8 32

DATA
    0xF0, 0xBE, 0xAD, 0xDE, 0x4E, 0x75, 0x6C, 0x6C, 0x73, 0x6F, 0x66, 0x74, 0x49, 0x6E, 0x73, 0x74

################################################################################

TITLE
    Rar29 InitBinEsc

TYPE
    16

DATA
    0x3CDD,0x1F3F,0x59BF,0x48F3,0x64A1,0x5ABC,0x6632,0x6051

################################################################################

TITLE
    EPWIC p_from_kurt_func

TYPE
    FLOAT

DATA
 {0.363627, 0.452834, 0.539309, 0.624062, 0.707648, 0.790398,
  0.872531, 0.954191, 1.03548, 1.11648, 1.19724, 1.2778, 1.3582, 1.43846,
  1.5186, 1.59864, 1.6786, 1.75848, 1.8383, 1.91806, 1.99777, 2.07743,
  2.15705, 2.23664, 2.31619, 2.39572, 2.47521, 2.55468, 2.63413, 2.71356,
  2.79298, 2.87237, 2.95175, 3.03111, 3.11046, 3.1898, 3.26913, 3.34845,
  3.42775, 3.50705, 3.58634};

################################################################################

TITLE
    EPWIC s_from_var_func

TYPE
    FLOAT

DATA
 {-0.30103, -0.254176, -0.203822, -0.150212, -0.0935598, -0.0340527,
   0.0281421, 0.0928755, 0.160013, 0.229435, 0.30103, 0.374699, 0.450351,
   0.527901, 0.607273, 0.688395, 0.771201, 0.855629, 0.941624, 1.02913,
   1.1181, 1.20848, 1.30024, 1.39333, 1.48771, 1.58334, 1.68019, 1.77824,
   1.87743, 1.97776, 2.07918, 2.18168, 2.28522, 2.38978, 2.49534, 2.60188,
   2.70937, 2.8178, 2.92714, 3.03738, 3.1485, 3.26048, 3.3733, 3.48695,
   3.60142, 3.71668, 3.83273, 3.94955, 4.06712, 4.18544, 4.30449, 4.42426,
   4.54474, 4.66591, 4.78777, 4.91031, 5.03351, 5.15736, 5.28186, 5.407,
   5.53276};

################################################################################

TITLE
    Rar20Crypto SetOldKeys

TYPE
    32 AND

DATA
    0xD3A3B879L 0x3F6D12F7L 0x7515A235L 0xA4E7F123L;

################################################################################

TITLE
    Zip Crypto

TYPE
    32 AND

DATA
    134775813L  305419896L  591751049L  878082192L

################################################################################

TITLE
    EPWIC Sum to sqrt 2 lo_filter

TYPE
    FLOAT

DATA
  {0.028071524524270521, -0.06093975981002458, -0.07338062349083309,
    0.4146915396805326, 0.7973282005652047, 0.4146915396805326,
    -0.07338062349083309, -0.06093975981002458, 0.028071524524270521};

################################################################################

TITLE
    EPWIC Sum to sqrt 2 hi_filter

TYPE
    FLOAT

DATA
 {0.028071524524270521, 0.06093975981002458, -0.07338062349083309,
    -0.4146915396805326, 0.7973282005652047, -0.4146915396805326,
    -0.07338062349083309, 0.06093975981002458, 0.028071524524270521};

################################################################################

TITLE
    EPWIC Sum to 1 lo_filter

TYPE
    FLOAT

DATA
  {0.019849565349356158, -0.04309091740554781, -0.05188793647806494,
   0.2932311998087948,    0.5637961774509238,   0.2932311998087948,
  -0.05188793647806494, -0.04309091740554781, 0.019849565349356158 };

################################################################################

TITLE
    EPWIC Sum to 1 hi_filter

TYPE
    FLOAT

DATA
  {0.019849565349356158, 0.04309091740554781, -0.05188793647806494,
   -0.2932311998087948,    0.5637961774509238,   -0.2932311998087948,
  -0.05188793647806494, 0.04309091740554781, 0.019849565349356158 };

################################################################################

TITLE
    EPWIC 15 tap lo_filter

TYPE
    FLOAT

DATA
  {-0.0012475221, -0.0024950907, 0.0087309530, 0.0199579580,
   -0.0505290000, -0.1205509700, 0.2930455800,
    0.7061761600,
    0.2930455800, -0.1205509700, -0.0505290000,
    0.0199579580, 0.0087309530, -0.0024950907, -0.0012475221};

################################################################################

TITLE
    EPWIC 15 tap hi_filter

TYPE
    FLOAT

DATA
  { 0.0012475221, -0.0024950907, -0.0087309530, 0.0199579580,
    0.0505290000, -0.1205509700, -0.2930455800,
    0.7061761600,
   -0.2930455800, -0.1205509700, 0.0505290000,
    0.0199579580, -0.0087309530, -0.0024950907, 0.0012475221};

################################################################################

TITLE
    EPWIC old 15 tap filter

TYPE
    FLOAT

DATA
{-0.0012262390415035739,   -0.003678700794579351,    0.008583567145971109,
    0.02084685570723222,   -0.050280283267807716,   -0.12137238637509237,
    0.29292296128706447,    0.7084084506774304,    0.29292296128706447,
   -0.12137238637509237,   -0.050280283267807716,    0.02084685570723222,
    0.008583567145971109,   -0.003678700794579351,   -0.0012262390415035739};

################################################################################

TITLE
    EPWIC old 11 tap filter

TYPE
    FLOAT

DATA
  { 0.007987761489921101,  0.02011649866148413,  -0.05015758257647976,
   -0.12422330961337678,   0.29216982108655865,   0.7082136219037853,
    0.29216982108655865,  -0.12422330961337678,  -0.05015758257647976,
    0.02011649866148413,   0.007987761489921101 };

################################################################################

TITLE
    cellb_yytable

TYPE
    16

DATA
	0x1014, 0x1018, 0x1020, 0x1030, 0x1040, 0x1050, 0x1070, 0x1090,
	0x10b0, 0x10d0, 0x10f0, 0x1418, 0x181c, 0x1820, 0x1828, 0x1c20,
	0x2024, 0x2028, 0x2030, 0x2040, 0x2050, 0x2060, 0x2428, 0x282c,
	0x2830, 0x2838, 0x2c30, 0x3034, 0x3038, 0x3040, 0x3050, 0x3060,
	0x3070, 0x3090, 0x30b0, 0x30d0, 0x30f0, 0x3438, 0x383c, 0x3840,
	0x3848, 0x3c40, 0x4044, 0x4048, 0x4050, 0x4060, 0x4070, 0x4080,
	0x4448, 0x484c, 0x4850, 0x4858, 0x4c50, 0x5054, 0x5058, 0x5060,
	0x5070, 0x5080, 0x5090, 0x50b0, 0x50d0, 0x50f0, 0x5458, 0x585c,
	0x5860, 0x5868, 0x5c60, 0x6064, 0x6068, 0x6070, 0x6080, 0x6090,
	0x60a0, 0x6468, 0x686c, 0x6870, 0x6878, 0x6c70, 0x7074, 0x7078,
	0x7080, 0x7090, 0x70a0, 0x70b0, 0x70d0, 0x70f0, 0x7880, 0x7888,
	0x8088, 0x8090, 0x80a0, 0x80b0, 0x80c0, 0x8890, 0x8898, 0x9098,
	0x90a0, 0x90b0, 0x90c0, 0x90d0, 0x90f0, 0x98a0, 0x98a8, 0xa0a8,
	0xa0b0, 0xa0c0, 0xa0d0, 0xa0e0, 0xa8b0, 0xa8b8, 0xb0b8, 0xb0c0,
	0xb0d0, 0xb0e0, 0xb0f0, 0xb8c0, 0xb8c8, 0xc0c8, 0xc0d0, 0xc0e0,
	0xc0f0, 0xc8d0, 0xc8d8, 0xd0d8, 0xd0e0, 0xd0f0, 0xd8e8, 0xe0f0,
	0x1410, 0x1810, 0x2010, 0x3010, 0x4010, 0x5010, 0x7010, 0x9010,
	0xb010, 0xd010, 0xf010, 0x1814, 0x1c18, 0x2018, 0x2818, 0x201c,
	0x2420, 0x2820, 0x3020, 0x4020, 0x5020, 0x6020, 0x2824, 0x2c28,
	0x3028, 0x3828, 0x302c, 0x3430, 0x3830, 0x4030, 0x5030, 0x6030,
	0x7030, 0x9030, 0xb030, 0xd030, 0xf030, 0x3834, 0x3c38, 0x4038,
	0x4838, 0x403c, 0x4440, 0x4840, 0x5040, 0x6040, 0x7040, 0x8040,
	0x4844, 0x4c48, 0x5048, 0x5848, 0x504c, 0x5450, 0x5850, 0x6050,
	0x7050, 0x8050, 0x9050, 0xb050, 0xd050, 0xf050, 0x5854, 0x5c58,
	0x6058, 0x6858, 0x605c, 0x6460, 0x6860, 0x7060, 0x8060, 0x9060,
	0xa060, 0x6864, 0x6c68, 0x7068, 0x7868, 0x706c, 0x7470, 0x7870,
	0x8070, 0x9070, 0xa070, 0xb070, 0xd070, 0xf070, 0x8078, 0x8878,
	0x8880, 0x9080, 0xa080, 0xb080, 0xc080, 0x9088, 0x9888, 0x9890,
	0xa090, 0xb090, 0xc090, 0xd090, 0xf090, 0xa098, 0xa898, 0xa8a0,
	0xb0a0, 0xc0a0, 0xd0a0, 0xe0a0, 0xb0a8, 0xb8a8, 0xb8b0, 0xc0b0,
	0xd0b0, 0xe0b0, 0xf0b0, 0xc0b8, 0xc8b8, 0xc8c0, 0xd0c0, 0xe0c0,
	0xf0c0, 0xd0c8, 0xd8c8, 0xd8d0, 0xe0d0, 0xf0d0, 0xe8d8, 0xf0e0

################################################################################

TITLE
    huffyuv left_yuv

TYPE
    8

DATA
  66,36,37,38,71,136,233,10,12,11,18,12,21,13,21,14,17,15,13,208,
  17,8,16,8,15,13,46,47,14,12,13,17,12,22,11,17,10,12,233,200,
  71,38,37,36,35,

  66,36,37,38,39,40,41,42,75,44,77,78,79,80,81,114,83,52,149,86,
  87,185,58,89,26,158,57,122,57,90,57,87,54,55,150,53,54,149,116,115,
  114,81,112,175,78,45,44,43,74,40,39,38,37,36,34,

  66,36,37,71,40,73,74,75,76,77,78,79,80,113,178,49,176,81,82,52,
  53,55,26,174,121,90,56,57,56,119,86,53,52,51,52,51,49,48,47,46,
  77,76,75,74,73,40,39,38,37,36,34, 0

################################################################################

TITLE
    huffyuv grad_yuv

TYPE
    8

DATA
  34,35,36,37,38,103,168,9,8,10,11,11,10,12,8,237,14,9,15,11,
  16,8,241,242,19,8,212,85,54,23,10,54,119,54,55,54,119,182,55,54,
  53,54,117,244,51,52,147,178,177,16,8,15,9,14,10,13,9,12,9,11,
  9,10,11,9,8,168,103,38,37,36,34,

  66,36,38,40,42,44,45,46,80,81,82,115,148,21,10,54,151,58,56,90,
  57,26,162,57,90,56,57,58,56,58,57,58,57,152,55,54,55,86,117,52,
  53,116,53,52,53,148,147,82,49,48,79,45,44,41,39,37,35,34,

  66,36,38,40,41,42,76,45,78,47,112,113,82,115,52,53,55,86,55,54,
  55,54,23,193,54,53,54,53,52,53,51,84,51,50,51,82,49,112,47,78,
  45,44,43,42,41,40,37,35,34, 0

################################################################################

TITLE
    huffyuv med_yuv

TYPE
    8

DATA
  66,37,38,71,104,201,10,9,11,11,12,9,13,9,14,9,15,8,16,9,
  209,50,49,210,83,52,83,116,53,55,54,55,56,89,122,56,55,56,121,58,
  57,58,89,88,57,56,55,88,57,120,89,90,152,121,58,57,56,55,86,53,
  54,53,54,53,52,53,116,115,18,8,17,8,16,8,15,9,238,13,9,12,
  10,11,11,234,201,136,103,38,36,34,

  66,36,38,40,42,43,44,45,46,47,48,81,50,115,116,53,52,149,84,85,
  54,55,25,25,26,140,25,16,88,57,56,55,56,118,117,20,10,147,114,49,
  80,47,78,44,43,42,39,37,35,34,

  33,35,37,39,40,41,75,44,77,46,79,112,113,82,148,53,57,56,89,56,
  25,184,56,25,12,56,57,88,54,55,53,84,51,82,49,48,79,46,45,76,
  43,42,41,40,39,36,34, 0

################################################################################

TITLE
    huffyuv left_rgb

TYPE
    8

DATA
  99,36,37,38,71,136,201,10,13,11,19,12,22,13,28,14,33,15,9,46,
  47,14,15,13,24,44,45,12,21,11,19,10,11,9,8,168,71,38,37,36,
  67,

  34,67,37,70,71,168,9,9,10,14,11,22,12,24,13,26,14,46,13,17,
  12,27,11,20,10,14,9,10,200,103,70,37,36,35,

  34,35,68,37,38,71,136,233,10,11,11,18,12,24,13,28,46,45,14,61,
  13,22,12,21,11,19,10,11,9,8,168,71,38,37,68,35, 0

################################################################################

TITLE
    huffyuv left_decorrelate_rgb

TYPE
    8

DATA
  34,67,36,37,38,39,73,42,43,76,173,14,9,207,208,241,210,51,82,243,
  180,53,52,181,54,53,118,87,54,56,58,88,153,26,15,57,26,38,57,122,
  89,186,89,90,89,186,56,57,58,89,90,56,55,56,57,55,182,181,20,9,
  243,18,8,17,8,16,11,207,174,109,44,75,41,40,39,38,37,36,67,

  34,67,37,70,71,168,9,9,10,14,11,22,12,24,13,26,14,46,13,17,
  12,27,11,20,10,14,9,10,200,103,70,37,36,35,

  34,67,36,70,39,40,137,74,107,76,109,238,207,240,17,9,50,49,82,49,
  18,8,49,50,113,114,83,52,53,54,55,88,90,57,26,102,57,56,87,86,
  85,52,53,116,243,50,83,210,209,176,175,206,77,108,75,138,73,40,39,38,
  37,36,67, 0

################################################################################

TITLE
    huffyuv grad_decorrelate_rgb

TYPE
    8

DATA
  34,67,36,37,38,39,40,42,75,108,141,174,207,208,17,8,210,179,180,181,
  54,117,54,53,54,55,54,55,54,53,55,85,55,86,55,86,57,56,57,87,
  57,56,89,56,121,56,25,66,55,89,55,89,88,119,56,151,214,53,55,54,
  181,52,85,51,52,179,18,10,17,8,176,175,174,173,108,75,42,40,39,38,
  37,36,67,

  34,67,37,38,103,136,9,8,10,11,11,13,12,11,13,10,14,11,15,10,
  16,13,209,146,51,50,147,244,53,52,53,20,10,51,52,19,8,18,9,241,
  16,12,15,11,14,9,13,10,12,9,11,13,10,12,233,168,103,38,37,67,

  34,67,36,38,39,40,42,75,108,141,174,207,176,209,178,211,148,53,52,53,
  118,55,118,87,88,55,57,88,55,56,57,55,88,57,56,57,88,153,56,89,
  56,121,56,25,77,88,87,86,53,54,85,52,85,148,53,20,9,211,50,115,
  18,9,241,240,111,142,141,140,75,42,40,39,38,99, 0

################################################################################

TITLE
    huffyuv classic_add_chroma

TYPE
    8

DATA
    3,  1,  2,  2,  2,  2,  3,  3,  7,  5,  7,  5,  8,  6, 11,  9,
    7, 13, 11, 10,  9,  8,  7,  5,  9,  7,  6,  4,  7,  5,  8,  7,
   11,  8, 13, 11, 19, 15, 22, 23, 20, 33, 32, 28, 27, 29, 51, 77,
   43, 45, 76, 81, 46, 82, 75, 55, 56,144, 58, 80, 60, 74,147, 63,
  143, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 27, 30, 21, 22,
   17, 14,  5,  6,100, 54, 47, 50, 51, 53,106,107,108,109,110,111,
  112,113,114,115,  4,117,118, 92, 94,121,122,  3,124,103,  2,  1,
    0,129,130,131,120,119,126,125,136,137,138,139,140,141,142,134,
  135,132,133,104, 64,101, 62, 57,102, 95, 93, 59, 61, 28, 97, 96,
   52, 49, 48, 29, 32, 25, 24, 46, 23, 98, 45, 44, 43, 20, 42, 41,
   19, 18, 99, 40, 15, 39, 38, 16, 13, 12, 11, 37, 10,  9,  8, 36,
    7,128,127,105,123,116, 35, 34, 33,145, 31, 79, 42,146, 78, 26,
   83, 48, 49, 50, 44, 47, 26, 31, 30, 18, 17, 19, 21, 24, 25, 13,
   14, 16, 17, 18, 20, 21, 12, 14, 15,  9, 10,  6,  9,  6,  5,  8,
    6, 12,  8, 10,  7,  9,  6,  4,  6,  2,  2,  3,  3,  3,  3,  2,

################################################################################

TITLE
    OpenJPEG dwt_norms

TYPE
    FLOAT

DATA
	{1.000, 1.500, 2.750, 5.375, 10.68, 21.34, 42.67, 85.33, 170.7, 341.3},
	{1.038, 1.592, 2.919, 5.703, 11.33, 22.64, 45.25, 90.48, 180.9},
	{1.038, 1.592, 2.919, 5.703, 11.33, 22.64, 45.25, 90.48, 180.9},
	{.7186, .9218, 1.586, 3.043, 6.019, 12.01, 24.00, 47.97, 95.93}

################################################################################

TITLE
    OpenJPEG dwt_norms_real

TYPE
    FLOAT

DATA
	{1.000, 1.965, 4.177, 8.403, 16.90, 33.84, 67.69, 135.3, 270.6, 540.9},
	{2.022, 3.989, 8.355, 17.04, 34.27, 68.63, 137.3, 274.6, 549.0},
	{2.022, 3.989, 8.355, 17.04, 34.27, 68.63, 137.3, 274.6, 549.0},
	{2.080, 3.865, 8.307, 17.18, 34.71, 69.59, 139.3, 278.6, 557.2}

################################################################################

TITLE
    FLAC log2_lookup

TYPE
    32

DATA
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00000001,
		/* lg(4/3) = */ 0x00000000,
		/* lg(8/7) = */ 0x00000000,
		/* lg(16/15) = */ 0x00000000,
		/* lg(32/31) = */ 0x00000000,
		/* lg(64/63) = */ 0x00000000,
		/* lg(128/127) = */ 0x00000000,
		/* lg(256/255) = */ 0x00000000,
		/* lg(512/511) = */ 0x00000000,
		/* lg(1024/1023) = */ 0x00000000,
		/* lg(2048/2047) = */ 0x00000000,
		/* lg(4096/4095) = */ 0x00000000,
		/* lg(8192/8191) = */ 0x00000000,
		/* lg(16384/16383) = */ 0x00000000,
		/* lg(32768/32767) = */ 0x00000000
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00000010,
		/* lg(4/3) = */ 0x00000007,
		/* lg(8/7) = */ 0x00000003,
		/* lg(16/15) = */ 0x00000001,
		/* lg(32/31) = */ 0x00000001,
		/* lg(64/63) = */ 0x00000000,
		/* lg(128/127) = */ 0x00000000,
		/* lg(256/255) = */ 0x00000000,
		/* lg(512/511) = */ 0x00000000,
		/* lg(1024/1023) = */ 0x00000000,
		/* lg(2048/2047) = */ 0x00000000,
		/* lg(4096/4095) = */ 0x00000000,
		/* lg(8192/8191) = */ 0x00000000,
		/* lg(16384/16383) = */ 0x00000000,
		/* lg(32768/32767) = */ 0x00000000
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00000100,
		/* lg(4/3) = */ 0x0000006a,
		/* lg(8/7) = */ 0x00000031,
		/* lg(16/15) = */ 0x00000018,
		/* lg(32/31) = */ 0x0000000c,
		/* lg(64/63) = */ 0x00000006,
		/* lg(128/127) = */ 0x00000003,
		/* lg(256/255) = */ 0x00000001,
		/* lg(512/511) = */ 0x00000001,
		/* lg(1024/1023) = */ 0x00000000,
		/* lg(2048/2047) = */ 0x00000000,
		/* lg(4096/4095) = */ 0x00000000,
		/* lg(8192/8191) = */ 0x00000000,
		/* lg(16384/16383) = */ 0x00000000,
		/* lg(32768/32767) = */ 0x00000000
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00001000,
		/* lg(4/3) = */ 0x000006a4,
		/* lg(8/7) = */ 0x00000315,
		/* lg(16/15) = */ 0x0000017d,
		/* lg(32/31) = */ 0x000000bc,
		/* lg(64/63) = */ 0x0000005d,
		/* lg(128/127) = */ 0x0000002e,
		/* lg(256/255) = */ 0x00000017,
		/* lg(512/511) = */ 0x0000000c,
		/* lg(1024/1023) = */ 0x00000006,
		/* lg(2048/2047) = */ 0x00000003,
		/* lg(4096/4095) = */ 0x00000001,
		/* lg(8192/8191) = */ 0x00000001,
		/* lg(16384/16383) = */ 0x00000000,
		/* lg(32768/32767) = */ 0x00000000
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00010000,
		/* lg(4/3) = */ 0x00006a40,
		/* lg(8/7) = */ 0x00003151,
		/* lg(16/15) = */ 0x000017d6,
		/* lg(32/31) = */ 0x00000bba,
		/* lg(64/63) = */ 0x000005d1,
		/* lg(128/127) = */ 0x000002e6,
		/* lg(256/255) = */ 0x00000172,
		/* lg(512/511) = */ 0x000000b9,
		/* lg(1024/1023) = */ 0x0000005c,
		/* lg(2048/2047) = */ 0x0000002e,
		/* lg(4096/4095) = */ 0x00000017,
		/* lg(8192/8191) = */ 0x0000000c,
		/* lg(16384/16383) = */ 0x00000006,
		/* lg(32768/32767) = */ 0x00000003
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x00100000,
		/* lg(4/3) = */ 0x0006a3fe,
		/* lg(8/7) = */ 0x00031513,
		/* lg(16/15) = */ 0x00017d60,
		/* lg(32/31) = */ 0x0000bb9d,
		/* lg(64/63) = */ 0x00005d10,
		/* lg(128/127) = */ 0x00002e59,
		/* lg(256/255) = */ 0x00001721,
		/* lg(512/511) = */ 0x00000b8e,
		/* lg(1024/1023) = */ 0x000005c6,
		/* lg(2048/2047) = */ 0x000002e3,
		/* lg(4096/4095) = */ 0x00000171,
		/* lg(8192/8191) = */ 0x000000b9,
		/* lg(16384/16383) = */ 0x0000005c,
		/* lg(32768/32767) = */ 0x0000002e
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x01000000,
		/* lg(4/3) = */ 0x006a3fe6,
		/* lg(8/7) = */ 0x00315130,
		/* lg(16/15) = */ 0x0017d605,
		/* lg(32/31) = */ 0x000bb9ca,
		/* lg(64/63) = */ 0x0005d0fc,
		/* lg(128/127) = */ 0x0002e58f,
		/* lg(256/255) = */ 0x0001720e,
		/* lg(512/511) = */ 0x0000b8d8,
		/* lg(1024/1023) = */ 0x00005c61,
		/* lg(2048/2047) = */ 0x00002e2d,
		/* lg(4096/4095) = */ 0x00001716,
		/* lg(8192/8191) = */ 0x00000b8b,
		/* lg(16384/16383) = */ 0x000005c5,
		/* lg(32768/32767) = */ 0x000002e3
		/* undefined */ 0x00000000,
		/* lg(2/1) = */ 0x10000000,
		/* lg(4/3) = */ 0x06a3fe5c,
		/* lg(8/7) = */ 0x03151301,
		/* lg(16/15) = */ 0x017d6049,
		/* lg(32/31) = */ 0x00bb9ca6,
		/* lg(64/63) = */ 0x005d0fba,
		/* lg(128/127) = */ 0x002e58f7,
		/* lg(256/255) = */ 0x001720da,
		/* lg(512/511) = */ 0x000b8d87,
		/* lg(1024/1023) = */ 0x0005c60b,
		/* lg(2048/2047) = */ 0x0002e2d7,
		/* lg(4096/4095) = */ 0x00017160,
		/* lg(8192/8191) = */ 0x0000b8ad,
		/* lg(16384/16383) = */ 0x00005c56,
		/* lg(32768/32767) = */ 0x00002e2b

################################################################################

TITLE
    Open H323 pwlib bv dct_basis

TYPE
    32

DATA
{875836468,875836468,
875836468,875836468,
875836468,875836468,
875836468,875836468,
875836468,875836468,
875836468,875836468,
875836468,875836468,
875836468,875836468,
},
{0,0,
16843009,16843009,
33686018,33686018,
50529027,50529027,
67372036,67372036,
84215045,84215045,
101058054,101058054,
117901063,117901063,
},
{66051,67438087,
66051,67438087,
66051,67438087,
66051,67438087,
66051,67438087,
66051,67438087,
66051,67438087,
66051,67438087,
},
{134810123,185207048,
134810123,185207048,
134810123,185207048,
134810123,185207048,
134810123,185207048,
134810123,185207048,
134810123,185207048,
134810123,185207048,
},
{202182159,269554195,
219419926,387455250,
236263963,471668753,
253106974,521934608,
269949983,505091599,
286792988,454694158,
303634455,370480141,
319951120,252579084,
},
{134744072,134744072,
151587081,151587081,
168430090,168430090,
185273099,185273099,
185273099,185273099,
168430090,168430090,
151587081,151587081,
134744072,134744072,
},
{16843009,16843009,
538976288,538976288,
117901063,117901063,
555819297,555819297,
572662306,572662306,
0,0,
589505315,589505315,
101058054,101058054,
},
{606612528,858729255,
623455537,841886246,
640298546,825043237,
657141555,808200228,
657141555,808200228,
640298546,825043237,
623455537,841886246,
606612528,858729255,
},
{606414375,656811300,
673786411,724183336,
741158447,791555372,
808530483,858927408,
858927408,808530483,
791555372,741158447,
724183336,673786411,
656811300,606414375,
},
{18876193,570434310,
18876193,570434310,
18876193,570434310,
18876193,570434310,
18876193,570434310,
18876193,570434310,
18876193,570434310,
18876193,570434310,
},
{875902260,875902260,
875902260,875902260,
875902260,875902260,
875902260,875902260,
875902260,875902260,
875902260,875902260,
875902260,875902260,
875902260,875902260,
},
{219157265,235671314,
337056280,353179161,
354160950,923671320,
371134492,453975575,
387845915,470818582,
404426295,907090965,
420875541,403838740,
302976014,286461965,
},
{943274555,993671480,
960249146,977091641,
977091641,960249146,
993671480,943274555,
993671480,943274555,
977091641,960249146,
960249146,977091641,
943274555,993671480,
},
{219419926,387455250,
269949983,505091599,
319951120,252579084,
286799388,456594702,
236271387,473307153,
202182159,269554195,
253106974,521934608,
303634455,370480141,
},
{875836468,875836468,
892679477,892679477,
892679477,892679477,
875836468,875836468,
875836468,875836468,
892679477,892679477,
892679477,892679477,
875836468,875836468,
},
{572662306,572662306,
117901063,117901063,
589505315,589505315,
16843009,16843009,
101058054,101058054,
538976288,538976288,
0,0,
555819297,555819297,
},
{66051,67438087,
117835012,50462976,
117835012,50462976,
66051,67438087,
66051,67438087,
117835012,50462976,
117835012,50462976,
66051,67438087,
},
{673786411,724183336,
858927408,808530483,
656811300,606414375,
792740140,742473775,
742473775,792740140,
606414375,656811300,
808530483,858927408,
724183336,673786411,
},
{674446895,742338603,
691152448,1092956458,
707863873,1076245033,
724582188,792605480,
724582188,792605480,
707863873,1076245033,
691152448,1092956458,
674446895,742338603,
},
{460544,460544,
17171969,17171969,
33883394,33883394,
50594819,50594819,
67306244,67306244,
84017669,84017669,
100729094,100729094,
117440519,117440519,
},
{570893057,102760481,
570893057,102760481,
570893057,102760481,
570893057,102760481,
570893057,102760481,
570893057,102760481,
570893057,102760481,
570893057,102760481,
},
{151717898,168299273,
151717898,168299273,
151717898,168299273,
151717898,168299273,
151717898,168299273,
151717898,168299273,
151717898,168299273,
151717898,168299273,
},
{236130061,303041553,
353506836,420941080,
923867925,404491830,
454041110,387911452,
470753047,371068955,
906894360,354095415,
403511065,336990741,
286003218,219091726,
},
{134941448,134941448,
151652873,151652873,
168364298,168364298,
185075723,185075723,
185075723,185075723,
168364298,168364298,
151652873,151652873,
134941448,134941448,
},
{337056280,353179161,
387845915,470818582,
302976014,286461965,
404426295,907090965,
354160950,923671320,
219157265,235671314,
371134492,453975575,
420875541,403838740,
},
{134810123,185207048,
185207048,134810123,
185207048,134810123,
134810123,185207048,
134810123,185207048,
185207048,134810123,
185207048,134810123,
134810123,185207048,
},
{236271387,473307153,
319951120,252579084,
253106974,521934608,
219419926,387455250,
303634455,370480141,
269949983,505091599,
202182159,269554195,
286799388,456594702,
},
{151587081,151587081,
185273099,185273099,
134744072,134744072,
168430090,168430090,
168430090,168430090,
134744072,134744072,
185273099,185273099,
151587081,151587081,
},
{50529027,50529027,
84215045,84215045,
16843009,16843009,
117901063,117901063,
0,0,
101058054,101058054,
33686018,33686018,
67372036,67372036,
},
{623455537,841886246,
657141555,808200228,
606612528,858729255,
640298546,825043237,
640298546,825043237,
606612528,858729255,
657141555,808200228,
623455537,841886246,
},
{742473775,792740140,
656811300,606414375,
808530483,858927408,
673786411,724183336,
724183336,673786411,
858927408,808530483,
606414375,656811300,
792740140,742473775,
},
{18876193,570434310,
102957090,554115073,
102957090,554115073,
18876193,570434310,
18876193,570434310,
102957090,554115073,
102957090,554115073,
18876193,570434310,
},
{17171969,17171969,
539173664,539173664,
117440519,117440519,
555885089,555885089,
572596514,572596514,
460544,460544,
589307939,589307939,
100729094,100729094,
},
{742273064,724778799,
1093021993,707929408,
1076179498,691086913,
792671019,674250284,
792671019,674250284,
1076179498,691086913,
1093021993,707929408,
742273064,724778799,
},
{623322150,639903525,
690694186,707275561,
758066222,774647597,
825438258,842019633,
842019633,825438258,
774647597,758066222,
707275561,690694186,
639903525,623322150,
},
{50659591,393732,
50659591,393732,
50659591,393732,
50659591,393732,
50659591,393732,
50659591,393732,
50659591,393732,
50659591,393732,
},
{252775699,202509840,
370676754,219747607,
454890769,236460572,
505157136,253172511,
521869071,269884446,
471472142,286596379,
387258637,303306774,
269357580,319623439,
},
{960182330,976763705,
1010448701,1027160636,
1027160636,1010448701,
976763705,960182330,
976763705,960182330,
1027160636,1010448701,
1010448701,1027160636,
960182330,976763705,
},
{353506836,420941080,
470753047,371068955,
286003218,219091726,
906894360,354095415,
923867925,404491830,
236130061,303041553,
454041110,387911452,
403511065,336990741,
},
{875902260,875902260,
892613685,892613685,
892613685,892613685,
875902260,875902260,
875902260,875902260,
892613685,892613685,
892613685,892613685,
875902260,875902260,
},
{354160950,923671320,
302976014,286461965,
371134492,453975575,
337056280,353179161,
420875541,403838740,
387845915,470818582,
219157265,235671314,
404426295,907090965,
},
{960249146,977091641,
993671480,943274555,
943274555,993671480,
977091641,960249146,
977091641,960249146,
943274555,993671480,
993671480,943274555,
960249146,977091641,
},
{253106974,521934608,
286792988,454694158,
219419926,387455250,
319951120,252579084,
202182159,269554195,
303634455,370480141,
236263963,471668753,
269949983,505091599,
},
{808530483,858927408,
791555372,741158447,
673786411,724183336,
656811300,606414375,
606414375,656811300,
724183336,673786411,
741158447,791555372,
858927408,808530483,
},
{691152448,1092956458,
724582188,792605480,
674446895,742338603,
707863873,1076245033,
707863873,1076245033,
674446895,742338603,
724582188,792605480,
691152448,1092956458,
},
{572596514,572596514,
117440519,117440519,
589307939,589307939,
17171969,17171969,
100729094,100729094,
539173664,539173664,
460544,460544,
555885089,555885089,
},
{570893057,102760481,
553656326,19072802,
553656326,19072802,
570893057,102760481,
570893057,102760481,
553656326,19072802,
553656326,19072802,
570893057,102760481,
},
{690694186,707275561,
842019633,825438258,
639903525,623322150,
1076637505,1093610560,
1093610560,1076637505,
623322150,639903525,
825438258,842019633,
707275561,690694186,
},
{808396839,606809139,
825108774,623521074,
841820709,640233009,
858532644,656944944,
858532644,656944944,
841820709,640233009,
825108774,623521074,
808396839,606809139,
},
{370676754,219747607,
521869071,269884446,
269357580,319623439,
473372686,286602779,
456529169,236467996,
252775699,202509840,
505157136,253172511,
387258637,303306774,
},
{151717898,168299273,
168299273,151717898,
168299273,151717898,
151717898,168299273,
151717898,168299273,
168299273,151717898,
168299273,151717898,
151717898,168299273,
},
{923867925,404491830,
286003218,219091726,
454041110,387911452,
353506836,420941080,
403511065,336990741,
470753047,371068955,
236130061,303041553,
906894360,354095415,
},
{151652873,151652873,
185075723,185075723,
134941448,134941448,
168364298,168364298,
168364298,168364298,
134941448,134941448,
185075723,185075723,
151652873,151652873,
},
{371134492,453975575,
404426295,907090965,
337056280,353179161,
302976014,286461965,
219157265,235671314,
420875541,403838740,
354160950,923671320,
387845915,470818582,
},
{50594819,50594819,
84017669,84017669,
17171969,17171969,
117440519,117440519,
460544,460544,
100729094,100729094,
33883394,33883394,
67306244,67306244,
},
{1093021993,707929408,
792671019,674250284,
742273064,724778799,
1076179498,691086913,
1076179498,691086913,
742273064,724778799,
792671019,674250284,
1093021993,707929408,
},
{1093610560,1076637505,
639903525,623322150,
825438258,842019633,
690694186,707275561,
707275561,690694186,
842019633,825438258,
623322150,639903525,
1076637505,1093610560,
},
{50659591,393732,
67241472,117507331,
67241472,117507331,
50659591,393732,
50659591,393732,
67241472,117507331,
67241472,117507331,
50659591,393732,
},
{456529169,236467996,
269357580,319623439,
505157136,253172511,
370676754,219747607,
387258637,303306774,
521869071,269884446,
252775699,202509840,
473372686,286602779,
},
{1010448701,1027160636,
976763705,960182330,
960182330,976763705,
1027160636,1010448701,
1027160636,1010448701,
960182330,976763705,
976763705,960182330,
1010448701,1027160636,
},
{454041110,387911452,
906894360,354095415,
353506836,420941080,
286003218,219091726,
236130061,303041553,
403511065,336990741,
923867925,404491830,
470753047,371068955,
},
{825438258,842019633,
774647597,758066222,
690694186,707275561,
639903525,623322150,
623322150,639903525,
707275561,690694186,
758066222,774647597,
842019633,825438258,
},
{825108774,623521074,
858532644,656944944,
808396839,606809139,
841820709,640233009,
841820709,640233009,
808396839,606809139,
858532644,656944944,
825108774,623521074,
},
{505157136,253172511,
471472142,286596379,
370676754,219747607,
269357580,319623439,
252775699,202509840,
387258637,303306774,
454890769,236460572,
521869071,269884446,
},
};

################################################################################

TITLE
    Speex lsp tables nb cdbk_nb

TYPE
    8

DATA
30,19,38,34,40,32,46,43,58,43,
5,-18,-25,-40,-33,-55,-52,20,34,28,
-20,-63,-97,-92,61,53,47,49,53,75,
-14,-53,-77,-79,0,-3,-5,19,22,26,
-9,-53,-55,66,90,72,85,68,74,52,
-4,-41,-58,-31,-18,-31,27,32,30,18,
24,3,8,5,-12,-3,26,28,74,63,
-2,-39,-67,-77,-106,-74,59,59,73,65,
44,40,71,72,82,83,98,88,89,60,
-6,-31,-47,-48,-13,-39,-9,7,2,79,
-1,-39,-60,-17,87,81,65,50,45,19,
-21,-67,-91,-87,-41,-50,7,18,39,74,
10,-31,-28,39,24,13,23,5,56,45,
29,10,-5,-13,-11,-35,-18,-8,-10,-8,
-25,-71,-77,-21,2,16,50,63,87,87,
5,-32,-40,-51,-68,0,12,6,54,34,
5,-12,32,52,68,64,69,59,65,45,
14,-16,-31,-40,-65,-67,41,49,47,37,
-11,-52,-75,-84,-4,57,48,42,42,33,
-11,-51,-68,-6,13,0,8,-8,26,32,
-23,-53,0,36,56,76,97,105,111,97,
-1,-28,-39,-40,-43,-54,-44,-40,-18,35,
16,-20,-19,-28,-42,29,47,38,74,45,
3,-29,-48,-62,-80,-104,-33,56,59,59,
10,17,46,72,84,101,117,123,123,106,
-7,-33,-49,-51,-70,-67,-27,-31,70,67,
-16,-62,-85,-20,82,71,86,80,85,74,
-19,-58,-75,-45,-29,-33,-18,-25,45,57,
-12,-42,-5,12,28,36,52,64,81,82,
13,-9,-27,-28,22,3,2,22,26,6,
-6,-44,-51,2,15,10,48,43,49,34,
-19,-62,-84,-89,-102,-24,8,17,61,68,
39,24,23,19,16,-5,12,15,27,15,
-8,-44,-49,-60,-18,-32,-28,52,54,62,
-8,-48,-77,-70,66,101,83,63,61,37,
-12,-50,-75,-64,33,17,13,25,15,77,
1,-42,-29,72,64,46,49,31,61,44,
-8,-47,-54,-46,-30,19,20,-1,-16,0,
16,-12,-18,-9,-26,-27,-10,-22,53,45,
-10,-47,-75,-82,-105,-109,8,25,49,77,
50,65,114,117,124,118,115,96,90,61,
-9,-45,-63,-60,-75,-57,8,11,20,29,
0,-35,-49,-43,40,47,35,40,55,38,
-24,-76,-103,-112,-27,3,23,34,52,75,
8,-29,-43,12,63,38,35,29,24,8,
25,11,1,-15,-18,-43,-7,37,40,21,
-20,-56,-19,-19,-4,-2,11,29,51,63,
-2,-44,-62,-75,-89,30,57,51,74,51,
50,46,68,64,65,52,63,55,65,43,
18,-9,-26,-35,-55,-69,3,6,8,17,
-15,-61,-86,-97,1,86,93,74,78,67,
-1,-38,-66,-48,48,39,29,25,17,-1,
13,13,29,39,50,51,69,82,97,98,
-2,-36,-46,-27,-16,-30,-13,-4,-7,-4,
25,-5,-11,-6,-25,-21,33,12,31,29,
-8,-38,-52,-63,-68,-89,-33,-1,10,74,
-2,-15,59,91,105,105,101,87,84,62,
-7,-33,-50,-35,-54,-47,25,17,82,81,
-13,-56,-83,21,58,31,42,25,72,65,
-24,-66,-91,-56,9,-2,21,10,69,75,
2,-24,11,22,25,28,38,34,48,33,
7,-29,-26,17,15,-1,14,0,-2,0,
-6,-41,-67,6,-2,-9,19,2,85,74,
-22,-67,-84,-71,-50,3,11,-9,2,62};

################################################################################

TITLE
    Speex exc_5_256_table

TYPE
    8

DATA
-8,-37,5,-43,5,
73,61,39,12,-3,
-61,-32,2,42,30,
-3,17,-27,9,34,
20,-1,-5,2,23,
-7,-46,26,53,-47,
20,-2,-33,-89,-51,
-64,27,11,15,-34,
-5,-56,25,-9,-1,
-29,1,40,67,-23,
-16,16,33,19,7,
14,85,22,-10,-10,
-12,-7,-1,52,89,
29,11,-20,-37,-46,
-15,17,-24,-28,24,
2,1,0,23,-101,
23,14,-1,-23,-18,
9,5,-13,38,1,
-28,-28,4,27,51,
-26,34,-40,35,47,
54,38,-54,-26,-6,
42,-25,13,-30,-36,
18,41,-4,-33,23,
-32,-7,-4,51,-3,
17,-52,56,-47,36,
-2,-21,36,10,8,
-33,31,19,9,-5,
-40,10,-9,-21,19,
18,-78,-18,-5,0,
-26,-36,-47,-51,-44,
18,40,27,-2,29,
49,-26,2,32,-54,
30,-73,54,3,-5,
36,22,53,10,-1,
-84,-53,-29,-5,3,
-44,53,-51,4,22,
71,-35,-1,33,-5,
-27,-7,36,17,-23,
-39,16,-9,-55,-15,
-20,39,-35,6,-39,
-14,18,48,-64,-17,
-15,9,39,81,37,
-68,37,47,-21,-6,
-104,13,6,9,-2,
35,8,-23,18,42,
45,21,33,-5,-49,
9,-6,-43,-56,39,
2,-16,-25,87,1,
-3,-9,17,-25,-11,
-9,-1,10,2,-14,
-14,4,-1,-10,28,
-23,40,-32,26,-9,
26,4,-27,-23,3,
42,-60,1,49,-3,
27,10,-52,-40,-2,
18,45,-23,17,-44,
3,-3,17,-46,52,
-40,-47,25,75,31,
-49,53,30,-30,-32,
-36,38,-6,-15,-16,
54,-27,-48,3,38,
-29,-32,-22,-14,-4,
-23,-13,32,-39,9,
8,-45,-13,34,-16,
49,40,32,31,28,
23,23,32,47,59,
-68,8,62,44,25,
-14,-24,-65,-16,36,
67,-25,-38,-21,4,
-33,-2,42,5,-63,
40,11,26,-42,-23,
-61,79,-31,23,-20,
10,-32,53,-25,-36,
10,-26,-5,3,0,
-71,5,-10,-37,1,
-24,21,-54,-17,1,
-29,-25,-15,-27,32,
68,45,-16,-37,-18,
-5,1,0,-77,71,
-6,3,-20,71,-67,
29,-35,10,-30,19,
4,16,17,5,0,
-14,19,2,28,26,
59,3,2,24,39,
55,-50,-45,-18,-17,
33,-35,14,-1,1,
8,87,-35,-29,0,
-27,13,-7,23,-13,
37,-40,50,-35,14,
19,-7,-14,49,54,
-5,22,-2,-29,-8,
-27,38,13,27,48,
12,-41,-21,-15,28,
7,-16,-24,-19,-20,
11,-20,9,2,13,
23,-20,11,27,-27,
71,-69,8,2,-6,
22,12,16,16,9,
-16,-8,-17,1,25,
1,40,-37,-33,66,
94,53,4,-22,-25,
-41,-42,25,35,-16,
-15,57,31,-29,-32,
21,16,-60,45,15,
-1,7,57,-26,-47,
-29,11,8,15,19,
-105,-8,54,27,10,
-17,6,-12,-1,-10,
4,0,23,-10,31,
13,11,10,12,-64,
23,-3,-8,-19,16,
52,24,-40,16,10,
40,5,9,0,-13,
-7,-21,-8,-6,-7,
-21,59,16,-53,18,
-60,11,-47,14,-18,
25,-13,-24,4,-39,
16,-28,54,26,-67,
30,27,-20,-52,20,
-12,55,12,18,-16,
39,-14,-6,-26,56,
-88,-55,12,25,26,
-37,6,75,0,-34,
-81,54,-30,1,-7,
49,-23,-14,21,10,
-62,-58,-57,-47,-34,
15,-4,34,-78,31,
25,-11,7,50,-10,
42,-63,14,-36,-4,
57,55,57,53,42,
-42,-1,15,40,37,
15,25,-11,6,1,
31,-2,-6,-1,-7,
-64,34,28,30,-1,
3,21,0,-88,-12,
-56,25,-28,40,8,
-28,-14,9,12,2,
-6,-17,22,49,-6,
-26,14,28,-20,4,
-12,50,35,40,13,
-38,-58,-29,17,30,
22,60,26,-54,-39,
-12,58,-28,-63,10,
-21,-8,-12,26,-62,
6,-10,-11,-22,-6,
-7,4,1,18,2,
-70,11,14,4,13,
19,-24,-34,24,67,
17,51,-21,13,23,
54,-30,48,1,-13,
80,26,-16,-2,13,
-4,6,-30,29,-24,
73,-58,30,-27,20,
-2,-21,41,45,30,
-27,-3,-5,-18,-20,
-49,-3,-35,10,42,
-19,-67,-53,-11,9,
13,-15,-33,-51,-30,
15,7,25,-30,4,
28,-22,-34,54,-29,
39,-46,20,16,34,
-4,47,75,1,-44,
-55,-24,7,-1,9,
-42,50,-8,-36,41,
68,0,-4,-10,-23,
-15,-50,64,36,-9,
-27,12,25,-38,-47,
-37,32,-49,51,-36,
2,-4,69,-26,19,
7,45,67,46,13,
-63,46,15,-47,4,
-41,13,-6,5,-21,
37,26,-55,-7,33,
-1,-28,10,-17,-64,
-14,0,-36,-17,93,
-3,-9,-66,44,-21,
3,-12,38,-6,-13,
-12,19,13,43,-43,
-10,-12,6,-5,9,
-49,32,-5,2,4,
5,15,-16,10,-21,
8,-62,-8,64,8,
79,-1,-66,-49,-18,
5,40,-5,-30,-45,
1,-6,21,-32,93,
-18,-30,-21,32,21,
-18,22,8,5,-41,
-54,80,22,-10,-7,
-8,-23,-64,66,56,
-14,-30,-41,-46,-14,
-29,-37,27,-14,42,
-2,-9,-29,34,14,
33,-14,22,4,10,
26,26,28,32,23,
-72,-32,3,0,-14,
35,-42,-78,-32,6,
29,-18,-45,-5,7,
-33,-45,-3,-22,-34,
8,-8,4,-51,-25,
-9,59,-78,21,-5,
-25,-48,66,-15,-17,
-24,-49,-13,25,-23,
-64,-6,40,-24,-19,
-11,57,-33,-8,1,
10,-52,-54,28,39,
49,34,-11,-61,-41,
-43,10,15,-15,51,
30,15,-51,32,-34,
-2,-34,14,18,16,
1,1,-3,-3,1,
1,-18,6,16,48,
12,-5,-42,7,36,
48,7,-20,-10,7,
12,2,54,39,-38,
37,54,4,-11,-8,
-46,-10,5,-10,-34,
46,-12,29,-37,39,
36,-11,24,56,17,
14,20,25,0,-25,
-28,55,-7,-5,27,
3,9,-26,-8,6,
-24,-10,-30,-31,-34,
18,4,22,21,40,
-1,-29,-37,-8,-21,
92,-29,11,-3,11,
73,23,22,7,4,
-44,-9,-11,21,-13,
11,9,-78,-1,47,
114,-12,-37,-19,-5,
-11,-22,19,12,-30,
7,38,45,-21,-8,
-9,55,-45,56,-21,
7,17,46,-57,-87,
-6,27,31,31,7,
-56,-12,46,21,-5,
-12,36,3,3,-21,
43,19,12,-7,9,
-14,0,-9,-33,-91,
7,26,3,-11,64,
83,-31,-46,25,2,
9,5,2,2,-1,
20,-17,10,-5,-27,
-8,20,8,-19,16,
-21,-13,-31,5,5,
42,24,9,34,-20,
28,-61,22,11,-39,
64,-20,-1,-30,-9,
-20,24,-25,-24,-29,
22,-60,6,-5,41,
-9,-87,14,34,15,
-57,52,69,15,-3,
-102,58,16,3,6,
60,-75,-32,26,7,
-57,-27,-32,-24,-21,
-29,-16,62,-46,31,
30,-27,-15,7,15};

################################################################################

TITLE
    Speex high_lsp_cdbk

TYPE
    8

DATA
39,12,-14,-20,-29,-61,-67,-76,
-32,-71,-67,68,77,46,34,5,
-13,-48,-46,-72,-81,-84,-60,-58,
-40,-28,82,93,68,45,29,3,
-19,-47,-28,-43,-35,-30,-8,-13,
-39,-91,-91,-123,-96,10,10,-6,
-18,-55,-60,-91,-56,-36,-27,-16,
-48,-75,40,28,-10,-28,35,9,
37,19,1,-20,-31,-41,-18,-25,
-35,-68,-80,45,27,-1,47,13,
0,-29,-35,-57,-50,-79,-73,-38,
-19,5,35,14,-10,-23,16,-8,
5,-24,-40,-62,-23,-27,-22,-16,
-18,-46,-72,-77,43,21,33,1,
-80,-70,-70,-64,-56,-52,-39,-33,
-31,-38,-19,-19,-15,32,33,-2,
7,-15,-15,-24,-23,-33,-41,-56,
-24,-57,5,89,64,41,27,5,
-9,-47,-60,-97,-97,-124,-20,-9,
-44,-73,31,29,-4,64,48,7,
-35,-57,0,-3,-26,-47,-3,-6,
-40,-76,-79,-48,12,81,55,10,
9,-24,-43,-73,-57,-69,16,5,
-28,-53,18,29,20,0,-4,-11,
6,-13,23,7,-17,-35,-37,-37,
-30,-68,-63,6,24,-9,-14,3,
21,-13,-27,-57,-49,-80,-24,-41,
-5,-16,-5,1,45,25,12,-7,
3,-15,-6,-16,-15,-8,6,-13,
-42,-81,-80,-87,14,1,-10,-3,
-43,-69,-46,-24,-28,-29,36,6,
-43,-56,-12,12,54,79,43,9,
54,22,2,8,-12,-43,-46,-52,
-38,-69,-89,-5,75,38,33,5,
-13,-53,-62,-87,-89,-113,-99,-55,
-34,-37,62,55,33,16,21,-2,
-17,-46,-29,-38,-38,-48,-39,-42,
-36,-75,-72,-88,-48,-30,21,2,
-15,-57,-64,-98,-84,-76,25,1,
-46,-80,-12,18,-7,3,34,6,
38,31,23,4,-1,20,14,-15,
-43,-78,-91,-24,14,-3,54,16,
0,-27,-28,-44,-56,-83,-92,-89,
-3,34,56,41,36,22,20,-8,
-7,-35,-42,-62,-49,3,12,-10,
-50,-87,-96,-66,92,70,38,9,
-70,-71,-62,-42,-39,-43,-11,-7,
-50,-79,-58,-50,-31,32,31,-6,
-4,-25,7,-17,-38,-70,-58,-27,
-43,-83,-28,59,36,20,31,2,
-27,-71,-80,-109,-98,-75,-33,-32,
-31,-2,33,15,-6,43,33,-5,
0,-22,-10,-27,-34,-49,-11,-20,
-41,-91,-100,-121,-39,57,41,10,
-19,-50,-38,-59,-60,-70,-18,-20,
-8,-31,-8,-15,1,-14,-26,-25,
33,21,32,17,1,-19,-19,-26,
-58,-81,-35,-22,45,30,11,-11,
3,-26,-48,-87,-67,-83,-58,3,
-1,-26,-20,44,10,25,39,5,
-9,-35,-27,-38,7,10,4,-9,
-42,-85,-102,-127,52,44,28,10,
-47,-61,-40,-39,-17,-1,-10,-33,
-42,-74,-48,21,-4,70,52,10};

################################################################################

TITLE
    Speex high_lsp_cdbk2

TYPE
    8

DATA
-36,-62,6,-9,-10,-14,-56,23,
1,-26,23,-48,-17,12,8,-7,
23,29,-36,-28,-6,-29,-17,-5,
40,23,10,10,-46,-13,36,6,
4,-30,-29,62,32,-32,-1,22,
-14,1,-4,-22,-45,2,54,4,
-30,-57,-59,-12,27,-3,-31,8,
-9,5,10,-14,32,66,19,9,
2,-25,-37,23,-15,18,-38,-31,
5,-9,-21,15,0,22,62,30,
15,-12,-14,-46,77,21,33,3,
34,29,-19,50,2,11,9,-38,
-12,-37,62,1,-15,54,32,6,
2,-24,20,35,-21,2,19,24,
-13,55,4,9,39,-19,30,-1,
-21,73,54,33,8,18,3,15,
6,-19,-47,6,-3,-48,-50,1,
26,20,8,-23,-50,65,-14,-55,
-17,-31,-37,-28,53,-1,-17,-53,
1,57,11,-8,-25,-30,-37,64,
5,-52,-45,15,23,31,15,14,
-25,24,33,-2,-44,-56,-18,6,
-21,-43,4,-12,17,-37,20,-10,
34,15,2,15,55,21,-11,-31,
-6,46,25,16,-9,-25,-8,-62,
28,17,20,-32,-29,26,30,25,
-19,2,-16,-17,26,-51,2,50,
42,19,-66,23,29,-2,3,19,
-19,-37,32,15,6,30,-34,13,
11,-5,40,31,10,-42,4,-9,
26,-9,-70,17,-2,-23,20,-22,
-55,51,-24,-31,22,-22,15,-13,
3,-10,-28,-16,56,4,-63,11,
-18,-15,-18,-38,-35,16,-7,34,
-1,-21,-49,-47,9,-37,7,8,
69,55,20,6,-33,-45,-10,-9,
6,-9,12,71,15,-3,-42,-7,
-24,32,-35,-2,-42,-17,-5,0,
-2,-33,-54,13,-12,-34,47,23,
19,55,7,-8,74,31,14,16,
-23,-26,19,12,-18,-49,-28,-31,
-20,2,-14,-20,-47,78,40,13,
-23,-11,21,-6,18,1,47,5,
38,35,32,46,22,8,13,16,
-14,18,51,19,40,39,11,-26,
-1,-17,47,2,-53,-15,31,-22,
38,21,-15,-16,5,-33,53,15,
-38,86,11,-3,-24,49,13,-4,
-11,-18,28,20,-12,-27,-26,35,
-25,-35,-3,-20,-61,30,10,-55,
-12,-22,-52,-54,-14,19,-32,-12,
45,15,-8,-48,-9,11,-32,8,
-16,-34,-13,51,18,38,-2,-32,
-17,22,-2,-18,-28,-70,59,27,
-28,-19,-10,-20,-9,-9,-8,-21,
21,-8,35,-2,45,-3,-9,12,
0,30,7,-39,43,27,-38,-91,
30,26,19,-55,-4,63,14,-17,
13,9,13,2,7,4,6,61,
72,-1,-17,29,-1,-22,-17,8,
-28,-37,63,44,41,3,2,14,
9,-6,75,-8,-7,-12,-15,-12,
13,9,-4,30,-22,-65,15,0,
-45,4,-4,1,5,22,11,23};

################################################################################

TITLE
    iLBC State quantization table frgqTbl

TYPE
    FLOAT

DATA
       1.000085, 1.071695, 1.140395,  
       1.206868, 1.277188, 1.351503,  
       1.429380, 1.500727, 1.569049,  
       1.639599, 1.707071, 1.781531,  
       1.840799, 1.901550, 1.956695,  
       2.006750, 2.055474, 2.102787,  
       2.142819, 2.183592, 2.217962,  
       2.257177, 2.295739, 2.332967,  
       2.369248, 2.402792, 2.435080,  
       2.468598, 2.503394, 2.539284,  
       2.572944, 2.605036, 2.636331,  
       2.668939, 2.698780, 2.729101,  
       2.759786, 2.789834, 2.818679,  
       2.848074, 2.877470, 2.906899,  
       2.936655, 2.967804, 3.000115,  
       3.033367, 3.066355, 3.104231,  
       3.141499, 3.183012, 3.222952,  
       3.265433, 3.308441, 3.350823,  
       3.395275, 3.442793, 3.490801,  
       3.542514, 3.604064, 3.666050,  
       3.740994, 3.830749, 3.938770,  
       4.101764 

################################################################################

TITLE
    LZO 1x_999 compress level

TYPE
    32

DATA
        {   0,   0,   0,   8,    4,   0 },      /* faster compression */
        {   0,   0,   0,  16,    8,   0 },
        {   0,   0,   0,  32,   16,   0 },

        {   1,   4,   4,  16,   16,   0 },
        {   1,   8,  16,  32,   32,   0 },
        {   1,   8,  16, 128,  128,   0 },

        {   2,   8,  32, 128,  256,   0 },
        {   2,  32, 128,1024, 2048,   1 },
        {   2,1024,1024,1024, 4096,   1 }       /* max. compression */

################################################################################

TITLE
    UPX miniacc

TYPE
    64 AND

DATA
    0x5851f42d4c957f2d 6364136223846793005 6364136223846793005 25214903917
    9223372036854775807 18446744073709551615

################################################################################

TITLE
    Melp fsvq_cb 

TYPE
    FLOAT

DATA
0.822998, 1.496297, 0.584847, 1.313507, 0.846008, 0.614041, 0.615298, 0.881819, 1.227331, 0.902116, 
1.248150, 1.020382, 0.517184, 1.489079, 0.650498, 0.716904, 0.650349, 1.260358, 0.871024, 0.907932, 
1.167392, 1.468091, 0.743322, 0.712255, 1.564293, 0.721041, 0.528277, 0.657527, 0.763228, 0.846655, 
1.043080, 1.570270, 0.444422, 0.933200, 1.211773, 0.669870, 0.932675, 0.806473, 0.913787, 0.868244, 
0.759126, 1.037894, 1.126967, 1.133186, 0.789090, 0.807399, 1.054906, 0.949898, 1.007863, 1.119437, 
0.977225, 1.130888, 1.044601, 1.432985, 0.819888, 0.517787, 0.932401, 0.964477, 0.886867, 0.895436, 
0.666187, 1.364039, 1.088940, 0.902131, 1.110838, 0.980791, 0.926721, 0.867719, 0.925053, 0.913544, 
0.983185, 1.460579, 0.732273, 0.923475, 1.088579, 0.952291, 0.789664, 1.025082, 0.904670, 0.854338, 
0.697275, 1.651033, 0.506420, 0.809603, 1.113992, 1.083678, 0.629739, 0.986236, 0.871250, 0.997090, 
0.749416, 1.354976, 0.731452, 1.281438, 1.080946, 1.037235, 0.748186, 0.821493, 0.879839, 0.965350, 
0.976897, 2.009469, 0.741592, 0.606862, 0.644927, 0.687413, 0.760360, 0.833318, 0.869851, 0.810534, 
0.576891, 1.527863, 0.657703, 1.006739, 1.226803, 0.786733, 0.991212, 0.821165, 1.014984, 0.878058, 
0.517211, 1.220859, 0.886556, 0.980153, 0.884365, 1.041315, 0.949276, 0.881296, 1.373464, 0.890748, 
0.651809, 1.106789, 0.885180, 1.329281, 1.124388, 0.626778, 1.261132, 0.822453, 0.966925, 0.806183, 
0.614335, 1.430380, 0.899696, 0.847168, 0.624567, 1.307056, 1.360741, 0.735438, 0.854307, 0.674763, 
0.830604, 1.373081, 0.785967, 0.735951, 0.968745, 1.100706, 0.927619, 0.728449, 1.292031, 0.884959, 
1.084085, 1.385767, 0.448480, 1.297458, 0.770611, 0.719263, 1.080766, 0.909836, 0.838299, 0.909742, 
1.244608, 1.158451, 0.615757, 1.169599, 1.032735, 0.921809, 0.916509, 1.060343, 0.836990, 0.767101, 
1.313869, 1.341417, 0.481710, 0.685601, 1.086817, 1.003461, 0.762127, 0.832518, 1.081618, 0.917168, 
1.427137, 0.932544, 0.595881, 0.652610, 1.073852, 0.847480, 1.264058, 0.899502, 0.899264, 0.958964, 
1.027745, 1.214124, 0.896291, 0.972030, 0.841943, 0.738307, 1.048254, 1.077882, 0.952564, 1.056319, 
0.952252, 1.098463, 0.690316, 1.175721, 0.911712, 0.962678, 0.859269, 1.138901, 1.074558, 0.924091, 
0.902314, 1.163750, 1.143587, 0.814860, 0.923235, 0.973077, 1.098871, 0.966014, 0.968856, 0.893133, 
1.133879, 1.110463, 0.687589, 0.793794, 1.026535, 1.076900, 1.185281, 0.821843, 0.845464, 1.079782, 
0.623910, 1.269921, 0.722072, 0.990256, 1.183314, 1.161476, 0.677381, 1.199311, 0.902081, 0.883634, 
0.585861, 1.189163, 0.882952, 1.134136, 0.900218, 1.263223, 0.995922, 1.011126, 0.906268, 0.863339, 
0.687616, 1.562003, 0.815795, 0.701934, 0.789752, 1.204232, 0.821560, 1.168157, 0.888904, 0.860778, 
0.950686, 1.329037, 0.692678, 0.754646, 1.095995, 1.446339, 0.941535, 0.710369, 0.789949, 0.826271, 
0.520026, 1.293024, 0.938993, 0.990412, 0.897114, 0.914170, 1.358696, 0.952011, 0.936183, 0.837973, 
0.669622, 1.291638, 0.749196, 1.167486, 1.042641, 0.721329, 1.005261, 1.252692, 0.883186, 0.854416, 
0.497926, 1.222508, 1.403952, 0.799058, 0.798533, 0.793545, 1.264461, 0.958949, 0.843825, 0.909886, 
0.891705, 1.342163, 0.761635, 0.758182, 0.987397, 1.008477, 1.377249, 0.845635, 0.845744, 0.822265, 
1.174305, 0.454482, 0.432532, 0.691549, 1.066271, 0.890505, 0.845957, 1.125649, 1.338280, 1.204068, 
1.607432, 0.688224, 0.500617, 1.288348, 0.678978, 0.674969, 1.047764, 1.012974, 0.954688, 0.803209, 
1.739179, 0.919542, 0.639494, 0.775935, 1.021945, 0.991820, 0.887633, 0.876449, 0.796800, 0.771028, 
1.620174, 1.211703, 0.610139, 1.372774, 1.057336, 0.618126, 0.642995, 0.667444, 0.666172, 0.676810, 
1.219952, 0.844191, 1.016601, 0.867402, 1.006595, 0.940309, 0.893858, 0.963053, 0.730414, 1.286290, 
1.251753, 1.004762, 0.777132, 1.203828, 0.656382, 0.657205, 1.233246, 0.874799, 1.106710, 0.855250, 
1.348819, 0.791939, 1.030755, 0.765314, 1.014939, 1.044297, 0.747682, 1.309667, 0.853913, 0.723126, 
1.262759, 1.109681, 0.672002, 1.109957, 0.827608, 1.272683, 0.670943, 1.068174, 0.752511, 0.878203, 
1.108504, 1.250712, 0.620039, 0.752463, 1.439216, 0.890828, 1.018300, 0.736766, 0.910504, 0.849118, 
1.222589, 1.083869, 0.627894, 1.150342, 1.377353, 0.785771, 0.679900, 0.897937, 0.854521, 0.920765, 
1.326349, 1.690290, 1.188837, 0.595281, 0.602145, 0.626852, 0.676343, 0.829212, 0.785923, 0.799661, 
1.499772, 1.400400, 0.655881, 0.892565, 1.089036, 0.702486, 0.835749, 0.800092, 0.731263, 0.835818, 
1.126664, 1.353291, 0.898265, 0.897870, 0.934461, 1.003119, 0.982470, 0.815886, 0.952342, 0.831774, 
1.316478, 1.060041, 0.667653, 1.065408, 0.910377, 1.002121, 1.339044, 0.710796, 0.720291, 0.813624, 
0.976194, 1.377380, 1.071262, 0.789567, 1.085928, 1.253806, 1.017727, 0.719049, 0.561583, 0.692329, 
1.202869, 1.059008, 0.962883, 0.999919, 0.524897, 1.074531, 1.091141, 0.910749, 1.044517, 0.859795, 
1.413976, 0.836644, 0.666408, 1.039645, 1.088087, 0.820217, 0.816371, 1.049252, 1.083270, 0.881172, 
1.388093, 0.807110, 0.781561, 0.964242, 0.973557, 1.138037, 1.026733, 0.970914, 0.866461, 0.841057, 
1.456077, 0.982162, 0.557993, 0.738683, 1.375522, 0.772422, 0.644426, 0.952329, 0.954631, 1.004692, 
1.606208, 1.220452, 0.738208, 0.744965, 0.659231, 0.813191, 0.932141, 0.922849, 0.956161, 0.892080, 
1.126839, 1.038057, 0.935449, 1.012686, 1.080640, 0.884338, 1.126468, 1.076987, 0.817224, 0.736383, 
1.215351, 0.845602, 0.829299, 1.204972, 0.891515, 0.934431, 0.887728, 0.938925, 0.955741, 1.114145, 
1.206387, 0.977863, 1.051199, 0.847855, 0.939759, 1.254109, 0.970361, 0.901040, 0.844070, 0.819544, 
1.207602, 0.976323, 0.841307, 0.870300, 0.877422, 0.988163, 0.931714, 1.031677, 1.205409, 0.903902, 
1.095130, 1.105129, 0.722843, 0.943180, 1.211443, 1.178861, 0.634252, 0.870933, 1.011727, 0.936443, 
1.032014, 0.998735, 0.686262, 1.100404, 1.022352, 1.222401, 1.146689, 0.812882, 0.927129, 0.801404, 
1.131931, 1.489739, 0.677826, 0.610733, 0.759219, 0.808122, 1.042500, 1.077132, 1.035717, 0.906736, 
1.342504, 1.076171, 0.583400, 0.764890, 0.818097, 1.293405, 1.058200, 0.852259, 0.958646, 0.872888, 
1.308520, 1.219689, 0.935572, 0.714861, 1.129251, 0.856944, 0.920880, 0.974834, 0.821443, 0.847930, 
1.372592, 0.887155, 0.710732, 1.029836, 1.278897, 0.650119, 1.136552, 0.881858, 0.850047, 0.819899, 
1.019956, 1.381944, 1.089064, 0.576825, 0.594933, 0.752016, 1.265619, 1.129530, 0.867864, 0.768122, 
1.154864, 1.069591, 0.913967, 0.796105, 0.790255, 0.854206, 1.523905, 0.856969, 0.887946, 0.756665, 
0.874806, 1.645517, 0.834275, 1.578196, 0.903996, 0.547038, 0.565520, 0.704114, 0.697290, 0.713786, 
1.153418, 1.095160, 0.870564, 1.655735, 1.071838, 0.806210, 0.607539, 0.566859, 0.683404, 0.826413, 
0.830864, 1.448871, 1.014508, 0.939034, 1.574030, 0.796490, 0.654852, 0.558685, 0.641596, 0.797132, 
1.125819, 1.396448, 0.746324, 1.295697, 1.137447, 1.301677, 0.574765, 0.486441, 0.489204, 0.608138, 
0.832614, 0.802739, 1.148272, 1.316531, 1.305743, 0.696667, 0.940671, 0.848198, 0.872696, 0.851311, 
1.260278, 0.958467, 0.667246, 1.406435, 0.859092, 0.534003, 0.485425, 0.723814, 1.418320, 0.944772, 
0.887527, 1.330678, 1.062704, 0.552689, 1.098956, 0.917567, 0.874732, 1.075172, 0.845710, 1.019528, 
0.906302, 1.326878, 0.632127, 0.781817, 1.111568, 0.753606, 0.896250, 0.945621, 0.969063, 1.304544, 
0.163798, 1.616260, 0.520967, 1.244674, 0.597986, 1.174228, 0.802735, 1.079115, 0.892800, 0.877604, 
0.717419, 1.075445, 0.997204, 1.206762, 1.312107, 1.316050, 0.696587, 0.745413, 0.739740, 0.731447, 
0.339447, 1.827655, 0.684798, 0.716559, 0.676084, 1.081139, 0.894730, 0.954454, 0.948165, 0.910477, 
0.864667, 1.451421, 0.725543, 1.176080, 1.209637, 1.083631, 1.163663, 0.662386, 0.501862, 0.463726, 
0.563978, 1.135516, 0.835026, 1.736364, 1.000137, 0.805360, 0.828496, 0.833563, 0.776277, 0.805186, 
1.009051, 1.360317, 0.668259, 1.417717, 1.518623, 0.638014, 0.446922, 0.496800, 0.693633, 0.726920, 
0.186440, 1.625134, 0.835253, 1.175778, 0.860628, 0.885086, 1.011866, 0.789303, 1.010232, 0.802450, 
0.652311, 1.599127, 0.599516, 1.058215, 0.801753, 0.992815, 1.146092, 0.829615, 0.939228, 0.837653, 
0.759780, 1.399480, 0.987329, 1.024824, 0.974458, 0.551246, 1.150852, 0.844956, 1.016771, 0.925568, 
1.069814, 1.160678, 0.803250, 1.193140, 1.112463, 0.744748, 1.070724, 0.739996, 0.924675, 0.942765, 
1.168517, 1.633441, 0.774778, 0.736824, 1.089258, 1.057042, 0.783527, 0.691403, 0.779568, 0.728487, 
1.301817, 1.572909, 0.526128, 0.558027, 0.660410, 1.078262, 1.089774, 0.718543, 0.753433, 0.965337, 
0.891795, 1.262297, 0.911545, 1.214103, 0.776010, 0.944986, 1.138773, 0.772798, 0.957464, 0.885334, 
1.219015, 1.048683, 0.943178, 1.150567, 0.837824, 0.566225, 0.660764, 1.219023, 1.019092, 0.988723, 
0.925533, 1.350162, 1.164350, 0.542695, 1.227640, 0.600203, 1.205779, 0.701896, 0.932956, 0.815466, 
1.019130, 1.292473, 0.796847, 0.819714, 1.254208, 0.522062, 1.293349, 0.823616, 0.832862, 0.890015, 
0.686388, 1.534513, 1.023273, 1.065238, 0.769952, 0.914897, 0.958226, 0.965983, 0.847693, 0.876086, 
0.560425, 1.321635, 0.837563, 1.105726, 0.800833, 0.952432, 0.673960, 1.327502, 0.806885, 1.135634, 
0.722275, 1.482196, 1.269134, 0.695424, 0.734410, 1.240968, 0.873750, 0.825209, 0.794290, 0.840055, 
1.022015, 1.408327, 0.702067, 0.966478, 0.742264, 1.204704, 0.633885, 0.888498, 0.713166, 1.231153, 
0.512817, 1.187577, 0.939995, 1.273059, 1.261853, 0.875396, 0.884657, 0.928591, 0.900721, 0.880112, 
0.781537, 1.223652, 0.854824, 0.972599, 1.347144, 0.807227, 0.911694, 0.956919, 0.990262, 0.893345, 
0.358832, 1.601542, 1.125781, 0.730841, 0.795475, 0.856229, 1.070817, 0.869601, 1.043598, 0.896567, 
0.821456, 1.676333, 0.931807, 0.740210, 0.946762, 0.917425, 0.936539, 0.884692, 0.872158, 0.827619, 
1.133434, 1.069057, 0.628708, 1.348112, 1.024242, 0.726333, 0.485013, 0.517711, 0.812878, 1.483409, 
1.439495, 0.401963, 0.704352, 1.185582, 1.196889, 0.894400, 0.762308, 0.871978, 1.004571, 0.965074, 
1.355857, 1.217795, 0.623188, 0.626000, 1.080819, 1.443039, 0.690217, 0.676470, 0.752167, 0.890824, 
1.384203, 0.893545, 0.571820, 1.422045, 1.054457, 0.896980, 0.929532, 0.779836, 0.816629, 0.774798, 
1.272930, 0.807536, 0.943865, 1.161822, 1.109685, 0.883353, 0.756987, 1.183318, 0.792499, 0.818768, 
1.368426, 0.939970, 0.927314, 1.372501, 0.966845, 0.661820, 0.817570, 0.813094, 0.874638, 0.905751, 
1.234512, 0.812394, 1.092298, 0.956999, 0.926831, 1.159350, 0.560790, 0.914404, 1.104409, 0.951357, 
1.462063, 1.107453, 0.736919, 1.182041, 0.753060, 0.817381, 0.845724, 0.960321, 0.930034, 0.870101, 
1.154263, 1.149050, 0.969239, 1.003195, 0.709246, 1.334899, 0.539388, 0.648414, 1.170228, 0.841587, 
1.363427, 0.856319, 0.848329, 1.330223, 1.580245, 0.593904, 0.534564, 0.577523, 0.647285, 0.799871, 
1.430748, 1.277622, 0.535910, 1.316419, 0.704018, 1.139968, 0.844730, 0.708186, 0.689915, 0.673166, 
1.456831, 0.852769, 0.836842, 1.661979, 0.555156, 0.659789, 0.754965, 0.765223, 0.801905, 0.871901, 
1.219340, 0.941999, 1.021315, 1.258016, 0.869648, 1.086416, 1.006363, 0.806097, 0.807889, 0.739562, 
1.269435, 1.217910, 1.091920, 1.130622, 1.241678, 0.548636, 0.659441, 0.769661, 0.738142, 0.844145, 
1.109102, 1.109600, 0.921873, 1.080103, 0.644065, 1.551581, 0.917328, 0.782032, 0.649409, 0.682361, 
1.148823, 1.115256, 0.784950, 1.519787, 0.632186, 0.880947, 0.965093, 0.738516, 0.923041, 0.843738, 
1.099162, 1.072237, 1.059239, 1.012868, 1.091543, 0.820111, 0.632757, 0.796845, 1.140959, 1.032531, 
1.382078, 1.014650, 0.855020, 1.088445, 1.147617, 1.054602, 0.759230, 0.758359, 0.828497, 0.830315, 
1.331108, 0.911897, 0.551680, 0.739304, 1.080511, 1.173246, 0.671436, 0.925538, 1.082333, 1.110124, 
1.380841, 1.130295, 0.743747, 0.910074, 0.957719, 0.986217, 0.885270, 0.809240, 0.914088, 1.051811, 
1.310270, 0.998818, 0.989857, 1.025202, 0.906801, 0.876459, 0.895856, 0.981348, 0.982188, 0.901957, 
1.442392, 0.947518, 1.052543, 0.888925, 1.092888, 0.674498, 0.920650, 0.987177, 0.890263, 0.816537, 
1.173251, 0.879037, 1.128982, 0.905439, 1.302826, 1.072854, 0.709855, 0.689286, 1.000834, 0.819403, 
1.162547, 0.939193, 1.038151, 0.930689, 0.914292, 0.877584, 1.144403, 0.667857, 1.257437, 0.810249, 
0.957634, 1.145630, 1.008914, 1.045813, 1.030746, 1.071616, 0.801657, 0.909400, 0.880216, 1.014015, 
1.250553, 1.148173, 0.606277, 0.991795, 0.997859, 0.688890, 0.942568, 0.922857, 1.233180, 0.891771, 
1.223899, 1.343365, 0.813470, 0.600631, 0.514261, 1.292102, 0.994158, 1.012705, 0.774822, 0.889761, 
1.434258, 1.190874, 0.478282, 0.454840, 0.731792, 1.170314, 0.776934, 1.201793, 0.865726, 0.993823, 
1.075483, 0.950940, 1.056806, 0.939311, 0.767863, 1.050672, 0.923138, 1.208091, 0.957328, 0.914622, 
1.152850, 0.985329, 0.758860, 0.902903, 1.268339, 0.822622, 0.951593, 0.972154, 0.988798, 1.010038, 
0.934316, 1.213602, 1.137776, 0.530840, 0.583216, 1.327735, 0.648220, 1.122533, 0.983140, 0.947688, 
1.096461, 1.329950, 1.056696, 1.096312, 0.518753, 0.667957, 1.377914, 0.802439, 0.713627, 0.728387, 
0.438479, 0.986558, 0.795180, 1.048475, 1.212747, 1.336801, 0.859633, 1.040980, 0.943136, 0.921149, 
1.106514, 0.482598, 0.612108, 1.642264, 0.798236, 0.780622, 0.825869, 0.883680, 1.122055, 0.975218, 
0.977340, 0.929082, 0.748423, 0.688517, 1.866792, 0.978102, 0.704420, 0.691328, 0.814419, 0.732273, 
2.061007, 1.317233, 0.531080, 0.663650, 0.466228, 0.673965, 0.663756, 0.680624, 0.722060, 0.735546, 
0.324483, 0.566419, 1.626532, 0.909957, 0.767043, 1.218518, 0.923857, 0.781191, 1.034489, 0.929690, 
1.132776, 0.664024, 0.658276, 1.115888, 1.058611, 0.773592, 1.143017, 1.345343, 0.885859, 0.793138, 
0.693193, 0.957946, 1.074530, 0.991271, 1.178869, 1.050262, 1.231718, 0.919607, 0.838514, 0.820971, 
0.981206, 1.282808, 0.628439, 0.831905, 0.871888, 1.000360, 1.072068, 1.359583, 0.865264, 0.714229, 
0.444708, 1.320901, 0.863009, 0.823633, 1.282252, 1.175766, 1.016159, 0.800445, 0.885734, 0.918392, 
0.524278, 0.903183, 0.842282, 0.999358, 1.663203, 0.862494, 0.990065, 0.863742, 0.861246, 0.885159, 
0.647517, 1.630489, 0.674425, 0.552789, 1.367019, 0.802523, 1.078554, 0.810538, 0.843750, 0.824923, 
1.157635, 1.168651, 0.661005, 0.556302, 1.240422, 0.970912, 0.829631, 1.237884, 0.917322, 0.831318, 
0.271398, 0.978008, 0.699287, 1.501347, 0.903792, 1.105029, 0.960131, 1.036695, 1.001109, 0.890359, 
0.275143, 0.628587, 1.143603, 1.112293, 1.315251, 1.071179, 0.889841, 0.954181, 1.018312, 0.964080, 
0.659209, 1.447333, 0.894087, 1.001992, 0.839399, 1.449942, 0.796803, 0.843993, 0.756016, 0.817636, 
0.853138, 1.064738, 0.855133, 0.742170, 0.868512, 1.370756, 0.989681, 1.038327, 0.937196, 0.993200, 
0.973539, 1.188932, 1.023116, 0.931037, 1.059522, 0.699512, 0.709015, 1.360161, 0.889684, 0.811761, 
1.226588, 1.022695, 0.719215, 1.364611, 0.676914, 0.710196, 1.255418, 1.207082, 0.643748, 0.569250, 
0.911359, 1.344114, 1.042414, 0.518823, 1.545711, 0.394875, 0.583463, 1.042424, 0.973970, 0.781663, 
1.728382, 0.630457, 0.384633, 0.410263, 0.623340, 0.756137, 0.963416, 1.240436, 1.179740, 0.957703, 
0.738959, 0.590931, 1.110580, 1.101743, 0.983178, 0.969963, 1.084357, 1.136055, 1.021410, 0.944931, 
1.244427, 0.569958, 1.057313, 1.369461, 0.723367, 0.805159, 1.027868, 1.091877, 0.873967, 0.776658, 
0.787743, 0.905228, 1.203273, 0.843008, 1.182612, 1.029414, 0.763719, 1.097128, 0.900016, 1.016990, 
1.314427, 1.012982, 0.695385, 0.878737, 0.749022, 0.792771, 1.048592, 1.421864, 0.816344, 0.837093, 
0.284264, 1.037450, 0.783668, 1.045137, 1.085681, 0.925955, 1.010468, 0.963587, 1.285465, 1.083612, 
0.182413, 0.501944, 0.613194, 0.864945, 1.046530, 1.201125, 1.222115, 1.201816, 1.144754, 1.100226, 
0.399720, 1.302627, 1.339572, 0.544091, 1.113712, 0.704227, 0.959569, 1.086265, 0.919326, 0.996120, 
1.312087, 1.234779, 1.155127, 0.573204, 0.603170, 1.675500, 0.578462, 0.549438, 0.586763, 0.627105, 
0.347498, 1.019206, 0.902255, 0.918363, 1.078096, 0.895444, 1.295650, 1.236476, 0.896594, 0.955950, 
0.228297, 0.547356, 1.316811, 1.334579, 0.850478, 0.739122, 1.162684, 1.153175, 0.961239, 0.847730, 
0.450951, 1.164991, 1.356497, 0.748838, 1.098313, 1.180630, 0.960353, 0.882357, 0.871493, 0.801907, 
1.101005, 1.177952, 1.577841, 0.463778, 0.535020, 0.573959, 0.857461, 1.214102, 0.824723, 0.827632, 
1.008192, 0.512187, 0.511630, 0.803656, 1.363784, 1.397129, 1.041883, 0.945399, 0.880500, 0.836761, 
1.333032, 0.522169, 0.512363, 0.626419, 0.780427, 0.951713, 1.495366, 1.235918, 0.888195, 0.836141, 
1.680621, 0.528954, 0.445504, 0.623836, 1.316133, 1.053039, 0.890863, 0.877480, 0.775161, 0.883213, 
2.235511, 0.589895, 0.429925, 0.577054, 0.680209, 0.667395, 0.784315, 0.803936, 0.861809, 0.801209, 
1.092796, 0.555938, 1.481165, 0.731586, 1.165349, 0.972450, 0.847847, 0.832928, 0.893096, 0.925555, 
1.276456, 0.719658, 0.981702, 1.037082, 1.176864, 0.684247, 0.782879, 0.891723, 1.117659, 1.034450, 
1.228245, 0.771626, 1.121788, 0.749934, 0.884593, 0.958108, 1.233677, 1.045060, 0.933820, 0.833295, 
1.469187, 0.712424, 0.977325, 0.707326, 1.237597, 0.953937, 0.835168, 0.794138, 0.991406, 0.934207, 
1.079164, 1.065143, 1.263724, 0.575489, 1.628970, 0.516204, 0.546497, 0.527023, 0.774807, 1.079119, 
1.337945, 0.994695, 0.675169, 0.865744, 1.373516, 1.324911, 0.866779, 0.633895, 0.599425, 0.727921, 
1.511212, 0.641169, 1.710560, 0.731522, 0.590315, 0.546117, 0.624898, 0.778970, 0.908906, 0.903649, 
1.760845, 1.236091, 1.067203, 0.487204, 0.655720, 0.713362, 0.697764, 0.749475, 0.847174, 0.921298, 
1.242002, 1.065400, 0.986706, 0.626575, 1.306310, 0.681929, 0.717473, 0.615010, 1.350818, 0.832838, 
1.114715, 0.651334, 1.082160, 1.095767, 1.064034, 1.122643, 1.004475, 0.903535, 0.874168, 0.865362, 
1.244497, 1.005714, 1.193496, 0.734583, 0.598761, 1.274922, 1.289539, 0.614727, 0.688696, 0.778442, 
1.408250, 0.839767, 1.067828, 0.572007, 0.672582, 1.239141, 0.865001, 0.858314, 1.080318, 0.941161, 
1.250488, 0.918235, 1.101326, 0.668242, 1.365644, 0.555295, 0.552784, 1.259466, 0.907460, 0.811412, 
1.631045, 0.643427, 0.448596, 0.462433, 0.721966, 1.376064, 1.149863, 0.918544, 0.813496, 0.874574, 
1.535075, 1.109493, 1.002904, 0.867410, 1.515072, 0.754291, 0.569348, 0.512821, 0.594932, 0.664862, 
1.968050, 0.717136, 1.151858, 0.741070, 0.764881, 0.686026, 0.715694, 0.699206, 0.765000, 0.778737, 
1.413788, 0.795490, 1.377022, 0.733397, 1.230761, 0.728025, 0.815985, 0.866154, 0.713555, 0.821627, 
1.339077, 0.710095, 1.014431, 1.092420, 0.988468, 0.688934, 1.213969, 0.865531, 0.928889, 0.852068, 
1.172569, 0.971105, 1.147345, 0.503528, 1.077878, 1.006880, 0.936191, 1.024685, 0.978125, 0.897520, 
1.346133, 0.825702, 1.278602, 0.712776, 0.990801, 0.824307, 0.741063, 0.777009, 1.172757, 0.958583, 
0.838360, 1.061588, 1.184451, 0.806865, 1.445930, 0.716610, 1.122729, 0.763437, 0.824729, 0.830950, 
1.276108, 0.881797, 1.013445, 0.821855, 1.264900, 1.025945, 1.227647, 0.703569, 0.659312, 0.734361, 
1.043635, 1.011762, 1.513310, 0.739962, 0.660585, 0.587323, 0.680578, 0.841721, 1.167268, 1.132996, 
1.473979, 0.627258, 1.381177, 0.659284, 0.759202, 1.049849, 1.020305, 0.870139, 0.779335, 0.834162, 
1.308547, 0.926336, 1.119570, 0.550398, 1.232051, 0.605843, 1.181402, 0.819554, 0.865953, 0.920083, 
1.337645, 0.769449, 1.229177, 0.813618, 0.735630, 0.883470, 1.569295, 0.634285, 0.606052, 0.688148, 
1.290794, 1.093894, 1.145434, 0.552063, 0.804350, 0.769436, 0.840595, 1.089482, 1.009731, 1.051359, 
1.364932, 0.913519, 1.316632, 0.718362, 0.529225, 0.723872, 1.181281, 0.876150, 0.962565, 0.918262, 
0.803741, 1.388152, 0.980932, 1.386743, 0.402886, 1.229764, 0.855613, 0.743859, 0.738745, 0.812385, 
1.187083, 1.328233, 0.750736, 1.808456, 0.498683, 0.428506, 0.498878, 0.815022, 0.756569, 0.712230, 
1.008780, 1.634667, 0.998899, 1.114864, 1.106568, 0.814867, 0.677242, 0.626767, 0.727848, 0.701162, 
1.442123, 1.578969, 1.235055, 1.279799, 0.604508, 0.459123, 0.486663, 0.548079, 0.537477, 0.639041, 
0.824699, 0.832512, 1.286809, 0.946005, 0.788899, 1.581450, 0.819352, 0.804348, 0.757910, 0.797158, 
1.173084, 0.852089, 0.837159, 1.215371, 0.614107, 0.664921, 0.798941, 1.185092, 1.404650, 0.752108, 
0.837980, 1.195548, 1.251800, 1.166862, 1.139151, 0.630036, 0.966812, 0.823920, 0.819578, 0.833867, 
1.284059, 1.360185, 0.903226, 1.260066, 0.869280, 0.794052, 0.767674, 0.784999, 0.770146, 0.814413, 
0.434909, 1.062061, 0.820721, 0.980006, 0.915903, 1.352711, 1.363232, 0.818512, 0.933755, 0.804752, 
0.140705, 0.369673, 0.761460, 1.721146, 1.281940, 0.814390, 0.770430, 0.912685, 1.029093, 0.894100, 
0.381833, 1.386068, 0.895360, 0.756433, 0.795777, 0.665474, 1.098763, 1.438104, 1.037485, 0.828884, 
0.848084, 1.088554, 0.824684, 0.776900, 0.721938, 0.676660, 0.800316, 1.135752, 1.511374, 1.057070, 
0.675218, 1.083363, 1.015844, 1.396638, 0.903676, 0.983177, 0.888414, 1.062584, 0.890620, 0.821218, 
0.754970, 0.952752, 1.127383, 1.539338, 0.700672, 0.751028, 0.640102, 0.797817, 1.188132, 0.971816, 
0.701999, 1.321737, 1.118923, 1.317673, 0.798997, 1.146361, 0.653062, 0.923909, 0.716226, 0.881342, 
0.916108, 1.387334, 0.769658, 1.200061, 0.617306, 1.096865, 0.828575, 1.077143, 0.950269, 0.767253, 
0.662335, 1.292372, 1.294051, 1.134329, 0.611097, 0.878492, 0.979876, 0.932184, 0.972586, 0.870668, 
1.081800, 1.056505, 1.431825, 1.568379, 0.608668, 0.601313, 0.533137, 0.646402, 0.768233, 0.839110, 
1.062379, 1.439992, 1.195124, 1.101291, 0.690349, 0.686199, 0.744970, 0.782839, 0.947571, 0.913290, 
1.302173, 1.079498, 1.059178, 0.961715, 0.721412, 0.548559, 0.490001, 0.649919, 1.527619, 0.917298, 
0.680923, 1.193324, 1.324460, 1.076160, 0.940757, 1.158478, 1.016504, 0.799201, 0.766968, 0.708056, 
1.013158, 0.953016, 1.286560, 1.218908, 0.634730, 1.131540, 0.788277, 0.928104, 0.871793, 0.842399, 
0.801060, 0.948640, 1.501946, 0.737009, 0.751623, 1.024697, 1.091762, 0.879438, 0.970670, 0.874395, 
1.322228, 1.272781, 1.083638, 0.879445, 0.649796, 0.924154, 0.851784, 0.949572, 0.890756, 0.876190, 
0.308295, 1.165975, 1.273902, 1.153456, 0.938787, 0.761951, 0.988352, 0.937937, 0.984994, 0.988803, 
0.307028, 0.833986, 1.891761, 1.166166, 0.526468, 0.545358, 0.772629, 0.838092, 0.849941, 1.006412, 
0.724400, 1.661022, 1.407543, 0.659395, 0.621709, 0.664584, 0.781703, 0.915312, 0.912252, 0.868291, 
0.899730, 0.520003, 2.050203, 0.570193, 0.525624, 0.618870, 0.773975, 0.953262, 0.860057, 0.852288, 
0.564036, 1.194072, 1.054038, 1.309234, 0.682175, 1.184083, 1.261020, 0.720925, 0.837966, 0.682236, 
0.705321, 0.906931, 1.440192, 1.246568, 0.945792, 0.911725, 0.914322, 0.903469, 0.819844, 0.853160, 
0.639259, 1.118893, 1.183435, 0.912825, 0.722814, 1.107206, 0.903505, 1.289695, 0.937470, 0.852877, 
0.833210, 1.220093, 1.668781, 0.922503, 0.998916, 0.696036, 0.765626, 0.779931, 0.724635, 0.754248, 
1.214346, 0.962383, 1.132890, 0.827035, 0.876470, 1.255731, 0.611676, 0.550693, 0.663031, 1.355367, 
1.790710, 0.452581, 0.576174, 0.955171, 0.930091, 0.858695, 1.025674, 0.874218, 0.875633, 0.842868, 
1.436801, 0.888196, 1.189311, 0.679367, 1.104152, 1.351368, 0.585875, 0.677641, 0.703740, 0.775152, 
1.614636, 0.783579, 0.883180, 1.156453, 0.973477, 0.848164, 0.830311, 0.892666, 0.763745, 0.831350, 
1.372060, 0.499597, 1.000811, 0.900767, 0.931695, 0.898965, 1.028259, 1.067040, 0.960141, 0.995706, 
1.464549, 0.744441, 0.906385, 0.936059, 0.731646, 0.716360, 0.829522, 1.117880, 1.156979, 1.018394, 
1.367898, 0.866499, 1.263666, 1.112268, 1.167850, 0.937974, 0.788936, 0.718079, 0.635187, 0.707080, 
1.439445, 0.795863, 0.796972, 1.211896, 0.538767, 1.255454, 0.958684, 0.857981, 0.848545, 0.824913, 
1.376381, 0.568678, 0.926291, 0.641770, 0.834535, 1.808678, 0.804428, 0.607970, 0.669675, 0.720965, 
1.355563, 0.460449, 0.596175, 1.214770, 0.946022, 1.352957, 0.860313, 0.864696, 0.785836, 0.918103, 
1.435024, 0.909544, 1.041289, 1.123733, 0.794294, 1.439099, 0.648301, 0.574374, 0.602775, 0.780902, 
1.516270, 0.918985, 0.927275, 1.189389, 0.590144, 0.748748, 1.248918, 0.683386, 0.755543, 0.882486, 
1.476744, 0.514611, 1.218581, 1.065365, 0.862836, 0.922786, 0.764142, 0.839729, 0.935193, 0.933221, 
1.315547, 0.722841, 1.311024, 1.315785, 0.913893, 0.706439, 0.682783, 0.788285, 0.877441, 0.888931, 
1.348712, 0.858988, 1.055635, 1.052220, 0.611431, 1.171928, 0.730139, 1.115700, 0.744873, 0.946277, 
1.180305, 1.053248, 0.878721, 1.288189, 0.507336, 1.103290, 0.705925, 1.007651, 0.841461, 1.044969, 
1.196638, 1.080029, 1.301461, 0.997280, 0.885975, 0.846955, 0.887870, 0.844710, 0.873575, 0.870310, 
1.373492, 1.068929, 1.077698, 1.096515, 0.998252, 0.717247, 1.234505, 0.694028, 0.663647, 0.627234, 
1.437332, 1.207382, 1.145016, 0.902884, 0.999814, 1.049959, 0.751617, 0.679969, 0.707880, 0.681629, 
1.540923, 0.966825, 1.074880, 0.967647, 0.780575, 0.824665, 0.721806, 0.771586, 0.917974, 1.059911, 
1.075058, 0.874560, 1.223286, 0.875247, 1.114946, 0.785841, 1.030228, 1.006401, 0.939058, 0.894774, 
1.230599, 0.763269, 1.223421, 1.021346, 0.751078, 0.863709, 0.928759, 0.989248, 1.037576, 0.975537, 
1.200394, 0.826452, 1.374917, 0.728714, 0.749645, 1.169742, 0.809933, 1.098679, 0.840553, 0.806698, 
1.458186, 0.835033, 1.120633, 0.933190, 0.831612, 1.053974, 1.060913, 0.785122, 0.845646, 0.769115, 
1.087334, 1.237373, 1.295267, 0.657919, 1.094758, 1.035074, 0.693941, 0.869327, 0.868297, 0.787626, 
1.183917, 0.792976, 1.143049, 0.749982, 0.626687, 0.658678, 0.983599, 1.416025, 1.044253, 0.931234, 
1.694116, 1.108393, 1.504700, 0.828677, 0.586589, 0.658925, 0.648047, 0.676080, 0.628926, 0.681370, 
1.363659, 0.859205, 1.134321, 1.227826, 0.519545, 0.570781, 0.847817, 1.035284, 0.967904, 0.993060, 
1.202407, 0.995001, 1.034142, 0.944991, 0.778536, 0.657893, 1.164819, 0.964661, 0.913810, 1.114029, 
1.325400, 0.953743, 1.087893, 1.003095, 0.754906, 0.862034, 1.119859, 1.201467, 0.736865, 0.616466, 
1.321790, 0.767809, 1.313064, 0.954328, 0.816200, 0.607967, 0.663671, 1.355803, 0.816644, 0.850276, 
1.493994, 1.117090, 1.211209, 1.311853, 0.619853, 0.708056, 0.764515, 0.708914, 0.718302, 0.743372};

################################################################################

TITLE
    TIFF mkg3states TermB

TYPE
    16

DATA
{ 0x03b0, 10 },
{ 0x0002, 19 },
{ 0x0003, 34 },
{ 0x0001, 50 },
{ 0x0006, 67 },
{ 0x000c, 84 },
{ 0x0004, 100 },
{ 0x0018, 117 },
{ 0x0028, 134 },
{ 0x0008, 150 },
{ 0x0010, 167 },
{ 0x0050, 183 },
{ 0x0070, 199 },
{ 0x0020, 216 },
{ 0x00e0, 232 },
{ 0x0030, 249 },
{ 0x03a0, 266 },
{ 0x0060, 282 },
{ 0x0040, 298 },
{ 0x0730, 315 },
{ 0x00b0, 331 },
{ 0x01b0, 347 },
{ 0x0760, 363 },
{ 0x00a0, 379 },
{ 0x0740, 395 },
{ 0x00c0, 411 },
{ 0x0530, 428 },
{ 0x0d30, 444 },
{ 0x0330, 460 },
{ 0x0b30, 476 },
{ 0x0160, 492 },
{ 0x0960, 508 },
{ 0x0560, 524 },
{ 0x0d60, 540 },
{ 0x04b0, 556 },
{ 0x0cb0, 572 },
{ 0x02b0, 588 },
{ 0x0ab0, 604 },
{ 0x06b0, 620 },
{ 0x0eb0, 636 },
{ 0x0360, 652 },
{ 0x0b60, 668 },
{ 0x05b0, 684 },
{ 0x0db0, 700 },
{ 0x02a0, 716 },
{ 0x0aa0, 732 },
{ 0x06a0, 748 },
{ 0x0ea0, 764 },
{ 0x0260, 780 },
{ 0x0a60, 796 },
{ 0x04a0, 812 },
{ 0x0ca0, 828 },
{ 0x0240, 844 },
{ 0x0ec0, 860 },
{ 0x01c0, 876 },
{ 0x0e40, 892 },
{ 0x0140, 908 },
{ 0x01a0, 924 },
{ 0x09a0, 940 },
{ 0x0d40, 956 },
{ 0x0340, 972 },
{ 0x05a0, 988 },
{ 0x0660, 1004 },
{ 0x0e60, 1020 },
{ 0, 0 }
};

################################################################################

TITLE
    DES initial permutation IP

TYPE
    8

DATA
	58, 50, 42, 34, 26, 18, 10,  2,
	60, 52, 44, 36, 28, 20, 12,  4,
	62, 54, 46, 38, 30, 22, 14,  6,
	64, 56, 48, 40, 32, 24, 16,  8,
	57, 49, 41, 33, 25, 17,  9,  1,
	59, 51, 43, 35, 27, 19, 11,  3,
	61, 53, 45, 37, 29, 21, 13,  5,
	63, 55, 47, 39, 31, 23, 15,  7

################################################################################

TITLE
    DES final permutation IP

TYPE
    8

DATA
	40,  8, 48, 16, 56, 24, 64, 32,
	39,  7, 47, 15, 55, 23, 63, 31,
	38,  6, 46, 14, 54, 22, 62, 30,
	37,  5, 45, 13, 53, 21, 61, 29,
	36,  4, 44, 12, 52, 20, 60, 28,
	35,  3, 43, 11, 51, 19, 59, 27,
	34,  2, 42, 10, 50, 18, 58, 26,
	33,  1, 41,  9, 49, 17, 57, 2

################################################################################

TITLE
    DES permuted choice table (key)

TYPE
    8

DATA
	57, 49, 41, 33, 25, 17,  9,
	 1, 58, 50, 42, 34, 26, 18,
	10,  2, 59, 51, 43, 35, 27,
	19, 11,  3, 60, 52, 44, 36,

	63, 55, 47, 39, 31, 23, 15,
	 7, 62, 54, 46, 38, 30, 22,
	14,  6, 61, 53, 45, 37, 29,
	21, 13,  5, 28, 20, 12,  4

################################################################################

TITLE
    DES permuted choice key (table)

TYPE
    8

DATA
	14, 17, 11, 24,  1,  5,
	 3, 28, 15,  6, 21, 10,
	23, 19, 12,  4, 26,  8,
	16,  7, 27, 20, 13,  2,
	41, 52, 31, 37, 47, 55,
	30, 40, 51, 45, 33, 48,
	44, 49, 39, 56, 34, 53,
	46, 42, 50, 36, 29, 32

################################################################################

TITLE
    DES S-boxes

TYPE
    8

DATA
	/* S1 */
	14,  4, 13,  1,  2, 15, 11,  8,  3, 10,  6, 12,  5,  9,  0,  7,
	 0, 15,  7,  4, 14,  2, 13,  1, 10,  6, 12, 11,  9,  5,  3,  8,
	 4,  1, 14,  8, 13,  6,  2, 11, 15, 12,  9,  7,  3, 10,  5,  0,
	15, 12,  8,  2,  4,  9,  1,  7,  5, 11,  3, 14, 10,  0,  6, 13,

	/* S2 */
	15,  1,  8, 14,  6, 11,  3,  4,  9,  7,  2, 13, 12,  0,  5, 10,
	 3, 13,  4,  7, 15,  2,  8, 14, 12,  0,  1, 10,  6,  9, 11,  5,
	 0, 14,  7, 11, 10,  4, 13,  1,  5,  8, 12,  6,  9,  3,  2, 15,
	13,  8, 10,  1,  3, 15,  4,  2, 11,  6,  7, 12,  0,  5, 14,  9,

	/* S3 */
	10,  0,  9, 14,  6,  3, 15,  5,  1, 13, 12,  7, 11,  4,  2,  8,
	13,  7,  0,  9,  3,  4,  6, 10,  2,  8,  5, 14, 12, 11, 15,  1,
	13,  6,  4,  9,  8, 15,  3,  0, 11,  1,  2, 12,  5, 10, 14,  7,
	 1, 10, 13,  0,  6,  9,  8,  7,  4, 15, 14,  3, 11,  5,  2, 12,

	/* S4 */
	 7, 13, 14,  3,  0,  6,  9, 10,  1,  2,  8,  5, 11, 12,  4, 15,
	13,  8, 11,  5,  6, 15,  0,  3,  4,  7,  2, 12,  1, 10, 14,  9,
	10,  6,  9,  0, 12, 11,  7, 13, 15,  1,  3, 14,  5,  2,  8,  4,
	 3, 15,  0,  6, 10,  1, 13,  8,  9,  4,  5, 11, 12,  7,  2, 14,

	/* S5 */
	 2, 12,  4,  1,  7, 10, 11,  6,  8,  5,  3, 15, 13,  0, 14,  9,
	14, 11,  2, 12,  4,  7, 13,  1,  5,  0, 15, 10,  3,  9,  8,  6,
	 4,  2,  1, 11, 10, 13,  7,  8, 15,  9, 12,  5,  6,  3,  0, 14,
	11,  8, 12,  7,  1, 14,  2, 13,  6, 15,  0,  9, 10,  4,  5,  3,

	/* S6 */
	12,  1, 10, 15,  9,  2,  6,  8,  0, 13,  3,  4, 14,  7,  5, 11,
	10, 15,  4,  2,  7, 12,  9,  5,  6,  1, 13, 14,  0, 11,  3,  8,
	 9, 14, 15,  5,  2,  8, 12,  3,  7,  0,  4, 10,  1, 13, 11,  6,
	 4,  3,  2, 12,  9,  5, 15, 10, 11, 14,  1,  7,  6,  0,  8, 13,

	/* S7 */
	 4, 11,  2, 14, 15,  0,  8, 13,  3, 12,  9,  7,  5, 10,  6,  1,
	13,  0, 11,  7,  4,  9,  1, 10, 14,  3,  5, 12,  2, 15,  8,  6,
	 1,  4, 11, 13, 12,  3,  7, 14, 10, 15,  6,  8,  0,  5,  9,  2,
	 6, 11, 13,  8,  1,  4, 10,  7,  9,  5,  0, 15, 14,  2,  3, 12,

	/* S8 */
	13,  2,  8,  4,  6, 15, 11,  1, 10,  9,  3, 14,  5,  0, 12,  7,
	 1, 15, 13,  8, 10,  3,  7,  4, 12,  5,  6, 11,  0, 14,  9,  2,
	 7, 11,  4,  1,  9, 12, 14,  2,  0,  6, 10, 13, 15,  3,  5,  8,
	 2,  1, 14,  7,  4, 10,  8, 13, 15, 12,  9,  0,  3,  5,  6, 11

################################################################################

TITLE
    MPEG dct_coeff_tbl_0

TYPE
    16

DATA
0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 
0x052f, 0x051f, 0x050f, 0x04ff, 
0x183f, 0x402f, 0x3c2f, 0x382f, 
0x342f, 0x302f, 0x2c2f, 0x7c1f, 
0x781f, 0x741f, 0x701f, 0x6c1f, 
0x028e, 0x028e, 0x027e, 0x027e, 
0x026e, 0x026e, 0x025e, 0x025e, 
0x024e, 0x024e, 0x023e, 0x023e, 
0x022e, 0x022e, 0x021e, 0x021e, 
0x020e, 0x020e, 0x04ee, 0x04ee, 
0x04de, 0x04de, 0x04ce, 0x04ce, 
0x04be, 0x04be, 0x04ae, 0x04ae, 
0x049e, 0x049e, 0x048e, 0x048e, 
0x01fd, 0x01fd, 0x01fd, 0x01fd, 
0x01ed, 0x01ed, 0x01ed, 0x01ed, 
0x01dd, 0x01dd, 0x01dd, 0x01dd, 
0x01cd, 0x01cd, 0x01cd, 0x01cd, 
0x01bd, 0x01bd, 0x01bd, 0x01bd, 
0x01ad, 0x01ad, 0x01ad, 0x01ad, 
0x019d, 0x019d, 0x019d, 0x019d, 
0x018d, 0x018d, 0x018d, 0x018d, 
0x017d, 0x017d, 0x017d, 0x017d, 
0x016d, 0x016d, 0x016d, 0x016d, 
0x015d, 0x015d, 0x015d, 0x015d, 
0x014d, 0x014d, 0x014d, 0x014d, 
0x013d, 0x013d, 0x013d, 0x013d, 
0x012d, 0x012d, 0x012d, 0x012d, 
0x011d, 0x011d, 0x011d, 0x011d, 
0x010d, 0x010d, 0x010d, 0x010d, 
0x282c, 0x282c, 0x282c, 0x282c, 
0x282c, 0x282c, 0x282c, 0x282c, 
0x242c, 0x242c, 0x242c, 0x242c, 
0x242c, 0x242c, 0x242c, 0x242c, 
0x143c, 0x143c, 0x143c, 0x143c, 
0x143c, 0x143c, 0x143c, 0x143c, 
0x0c4c, 0x0c4c, 0x0c4c, 0x0c4c, 
0x0c4c, 0x0c4c, 0x0c4c, 0x0c4c, 
0x085c, 0x085c, 0x085c, 0x085c, 
0x085c, 0x085c, 0x085c, 0x085c, 
0x047c, 0x047c, 0x047c, 0x047c, 
0x047c, 0x047c, 0x047c, 0x047c, 
0x046c, 0x046c, 0x046c, 0x046c, 
0x046c, 0x046c, 0x046c, 0x046c, 
0x00fc, 0x00fc, 0x00fc, 0x00fc, 
0x00fc, 0x00fc, 0x00fc, 0x00fc, 
0x00ec, 0x00ec, 0x00ec, 0x00ec, 
0x00ec, 0x00ec, 0x00ec, 0x00ec, 
0x00dc, 0x00dc, 0x00dc, 0x00dc, 
0x00dc, 0x00dc, 0x00dc, 0x00dc, 
0x00cc, 0x00cc, 0x00cc, 0x00cc, 
0x00cc, 0x00cc, 0x00cc, 0x00cc, 
0x681c, 0x681c, 0x681c, 0x681c, 
0x681c, 0x681c, 0x681c, 0x681c, 
0x641c, 0x641c, 0x641c, 0x641c, 
0x641c, 0x641c, 0x641c, 0x641c, 
0x601c, 0x601c, 0x601c, 0x601c, 
0x601c, 0x601c, 0x601c, 0x601c, 
0x5c1c, 0x5c1c, 0x5c1c, 0x5c1c, 
0x5c1c, 0x5c1c, 0x5c1c, 0x5c1c, 
0x581c, 0x581c, 0x581c, 0x581c, 
0x581c, 0x581c, 0x581c, 0x581c, 

################################################################################

TITLE
    libntlm DES key_swap

TYPE
    32

DATA
  0x00000000, 0x00000001, 0x00000100, 0x00000101,
  0x00010000, 0x00010001, 0x00010100, 0x00010101,
  0x01000000, 0x01000001, 0x01000100, 0x01000101,
  0x01010000, 0x01010001, 0x01010100, 0x01010101

################################################################################

TITLE
    libntlm DES weak_keys

TYPE
    8

DATA
  {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},	/*w */
  {0x00, 0x00, 0x1e, 0x1e, 0x00, 0x00, 0x0e, 0x0e},
  {0x00, 0x00, 0xe0, 0xe0, 0x00, 0x00, 0xf0, 0xf0},
  {0x00, 0x00, 0xfe, 0xfe, 0x00, 0x00, 0xfe, 0xfe},
  {0x00, 0x1e, 0x00, 0x1e, 0x00, 0x0e, 0x00, 0x0e},	/*sw */
  {0x00, 0x1e, 0x1e, 0x00, 0x00, 0x0e, 0x0e, 0x00},
  {0x00, 0x1e, 0xe0, 0xfe, 0x00, 0x0e, 0xf0, 0xfe},
  {0x00, 0x1e, 0xfe, 0xe0, 0x00, 0x0e, 0xfe, 0xf0},
  {0x00, 0xe0, 0x00, 0xe0, 0x00, 0xf0, 0x00, 0xf0},	/*sw */
  {0x00, 0xe0, 0x1e, 0xfe, 0x00, 0xf0, 0x0e, 0xfe},
  {0x00, 0xe0, 0xe0, 0x00, 0x00, 0xf0, 0xf0, 0x00},
  {0x00, 0xe0, 0xfe, 0x1e, 0x00, 0xf0, 0xfe, 0x0e},
  {0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe},	/*sw */
  {0x00, 0xfe, 0x1e, 0xe0, 0x00, 0xfe, 0x0e, 0xf0},
  {0x00, 0xfe, 0xe0, 0x1e, 0x00, 0xfe, 0xf0, 0x0e},
  {0x00, 0xfe, 0xfe, 0x00, 0x00, 0xfe, 0xfe, 0x00},
  {0x1e, 0x00, 0x00, 0x1e, 0x0e, 0x00, 0x00, 0x0e},
  {0x1e, 0x00, 0x1e, 0x00, 0x0e, 0x00, 0x0e, 0x00},	/*sw */
  {0x1e, 0x00, 0xe0, 0xfe, 0x0e, 0x00, 0xf0, 0xfe},
  {0x1e, 0x00, 0xfe, 0xe0, 0x0e, 0x00, 0xfe, 0xf0},
  {0x1e, 0x1e, 0x00, 0x00, 0x0e, 0x0e, 0x00, 0x00},
  {0x1e, 0x1e, 0x1e, 0x1e, 0x0e, 0x0e, 0x0e, 0x0e},	/*w */
  {0x1e, 0x1e, 0xe0, 0xe0, 0x0e, 0x0e, 0xf0, 0xf0},
  {0x1e, 0x1e, 0xfe, 0xfe, 0x0e, 0x0e, 0xfe, 0xfe},
  {0x1e, 0xe0, 0x00, 0xfe, 0x0e, 0xf0, 0x00, 0xfe},
  {0x1e, 0xe0, 0x1e, 0xe0, 0x0e, 0xf0, 0x0e, 0xf0},	/*sw */
  {0x1e, 0xe0, 0xe0, 0x1e, 0x0e, 0xf0, 0xf0, 0x0e},
  {0x1e, 0xe0, 0xfe, 0x00, 0x0e, 0xf0, 0xfe, 0x00},
  {0x1e, 0xfe, 0x00, 0xe0, 0x0e, 0xfe, 0x00, 0xf0},
  {0x1e, 0xfe, 0x1e, 0xfe, 0x0e, 0xfe, 0x0e, 0xfe},	/*sw */
  {0x1e, 0xfe, 0xe0, 0x00, 0x0e, 0xfe, 0xf0, 0x00},
  {0x1e, 0xfe, 0xfe, 0x1e, 0x0e, 0xfe, 0xfe, 0x0e},
  {0xe0, 0x00, 0x00, 0xe0, 0xf0, 0x00, 0x00, 0xf0},
  {0xe0, 0x00, 0x1e, 0xfe, 0xf0, 0x00, 0x0e, 0xfe},
  {0xe0, 0x00, 0xe0, 0x00, 0xf0, 0x00, 0xf0, 0x00},	/*sw */
  {0xe0, 0x00, 0xfe, 0x1e, 0xf0, 0x00, 0xfe, 0x0e},
  {0xe0, 0x1e, 0x00, 0xfe, 0xf0, 0x0e, 0x00, 0xfe},
  {0xe0, 0x1e, 0x1e, 0xe0, 0xf0, 0x0e, 0x0e, 0xf0},
  {0xe0, 0x1e, 0xe0, 0x1e, 0xf0, 0x0e, 0xf0, 0x0e},	/*sw */
  {0xe0, 0x1e, 0xfe, 0x00, 0xf0, 0x0e, 0xfe, 0x00},
  {0xe0, 0xe0, 0x00, 0x00, 0xf0, 0xf0, 0x00, 0x00},
  {0xe0, 0xe0, 0x1e, 0x1e, 0xf0, 0xf0, 0x0e, 0x0e},
  {0xe0, 0xe0, 0xe0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0},	/*w */
  {0xe0, 0xe0, 0xfe, 0xfe, 0xf0, 0xf0, 0xfe, 0xfe},
  {0xe0, 0xfe, 0x00, 0x1e, 0xf0, 0xfe, 0x00, 0x0e},
  {0xe0, 0xfe, 0x1e, 0x00, 0xf0, 0xfe, 0x0e, 0x00},
  {0xe0, 0xfe, 0xe0, 0xfe, 0xf0, 0xfe, 0xf0, 0xfe},	/*sw */
  {0xe0, 0xfe, 0xfe, 0xe0, 0xf0, 0xfe, 0xfe, 0xf0},
  {0xfe, 0x00, 0x00, 0xfe, 0xfe, 0x00, 0x00, 0xfe},
  {0xfe, 0x00, 0x1e, 0xe0, 0xfe, 0x00, 0x0e, 0xf0},
  {0xfe, 0x00, 0xe0, 0x1e, 0xfe, 0x00, 0xf0, 0x0e},
  {0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00},	/*sw */
  {0xfe, 0x1e, 0x00, 0xe0, 0xfe, 0x0e, 0x00, 0xf0},
  {0xfe, 0x1e, 0x1e, 0xfe, 0xfe, 0x0e, 0x0e, 0xfe},
  {0xfe, 0x1e, 0xe0, 0x00, 0xfe, 0x0e, 0xf0, 0x00},
  {0xfe, 0x1e, 0xfe, 0x1e, 0xfe, 0x0e, 0xfe, 0x0e},	/*sw */
  {0xfe, 0xe0, 0x00, 0x1e, 0xfe, 0xf0, 0x00, 0x0e},
  {0xfe, 0xe0, 0x1e, 0x00, 0xfe, 0xf0, 0x0e, 0x00},
  {0xfe, 0xe0, 0xe0, 0xfe, 0xfe, 0xf0, 0xf0, 0xfe},
  {0xfe, 0xe0, 0xfe, 0xe0, 0xfe, 0xf0, 0xfe, 0xf0},	/*sw */
  {0xfe, 0xfe, 0x00, 0x00, 0xfe, 0xfe, 0x00, 0x00},
  {0xfe, 0xfe, 0x1e, 0x1e, 0xfe, 0xfe, 0x0e, 0x0e},
  {0xfe, 0xfe, 0xe0, 0xe0, 0xfe, 0xfe, 0xf0, 0xf0},
  {0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe}	/*w */

################################################################################

TITLE
    libntlm DES weak_keys_chksum

TYPE
    8

DATA
  0xD0, 0xCF, 0x07, 0x38, 0x93, 0x70, 0x8A, 0x83, 0x7D, 0xD7,
  0x8A, 0x36, 0x65, 0x29, 0x6C, 0x1F, 0x7C, 0x3F, 0xD3, 0x41

################################################################################

TITLE
    libtheora FrequencyCounts_VP3

TYPE
    32

DATA
  {  272,    84,    31,    36,    10,    2,    1,    92,    1,
     701,   872,   410,   478,
     630,   502,   417,   356,   582,   824,   985,   965,   697,   606,
     125,   119,    40,    3,    9,    15,    10,
     73,    37,
  },
  {  311,   107,    41,    51,    18,    4,    2,   120,    1,
     824,  1037,   468,   541,
     714,   555,   451,   374,   595,   819,   929,   817,   474,   220,
     172,   142,    27,    4,    9,    10,    2,
     98,    48,
  },
  {  353,   125,    49,    66,    24,    6,    2,   124,    1,
     926,  1172,   512,   594,
     766,   581,   458,   379,   590,   789,   849,   665,   306,    80,
     204,   147,    25,    5,    12,    9,    2,
     108,    54,
  },
  {  392,   141,    57,    75,    31,    7,    4,   138,    1,
     1050,  1321,   559,   649,
     806,   594,   460,   372,   568,   727,   710,   475,   155,    19,
     251,   174,    27,    7,    16,    8,    2,
     126,    62,
  },
  {  455,   168,    66,    87,    39,    10,    6,   124,    2,
     1143,  1455,   592,   692,
     824,   596,   453,   361,   542,   657,   592,   329,    78,    5,
     269,   184,    27,    9,    19,    7,    2,
     127,    66,
  },
  {  544,   201,    80,   102,    45,    11,    6,    99,    1,
     1236,  1587,   610,   720,
     833,   590,   444,   348,   506,   588,   487,   226,    39,    2,
     253,   178,    27,    10,    20,    7,    2,
     118,    65,
  },
  {  649,   241,    98,   121,    54,    14,    8,    84,    1,
     1349,  1719,   634,   763,
     847,   583,   428,   323,   456,   492,   349,   120,    13,    1,
     231,   170,    24,    8,    19,    7,    1,
     109,    67,
  },
  {  824,   304,   129,   158,    66,    19,    10,    44,    2,
     1476,  1925,   644,   794,
     838,   559,   396,   289,   392,   384,   223,    53,    3,    1,
     159,   121,    17,    6,    16,    6,    2,
     69,    53,
  },

  /* DC Inter Bias */
  {  534,   174,    71,    68,    10,    1,    1,    68,   119,
     1674,  1526,   560,   536,
     539,   331,   229,   168,   233,   262,   231,   149,    71,    51,
     629,   530,   284,   126,   182,   208,   184,
     148,    87,
  },
  {  594,   195,    77,    71,    9,    1,    1,    47,    89,
     1723,  1592,   595,   570,
     574,   351,   241,   176,   243,   271,   234,   144,    65,    37,
     534,   449,   240,   117,   167,   277,   153,
     96,    54,
  },
  {  642,   213,    88,    83,    12,    1,    1,    40,    80,
     1751,  1630,   621,   600,
     598,   367,   250,   183,   251,   276,   235,   143,    62,    28,
     485,   397,   212,   110,   161,   193,   141,
     84,    48,
  },
  {  693,   258,   114,   131,    27,    3,    1,    44,    79,
     1794,  1644,   550,   533,
     518,   314,   213,   154,   209,   223,   174,    97,    40,    14,
     584,   463,   236,   138,   196,   249,   143,
     94,    54,
  },
  {  758,   303,   144,   189,    53,    8,    1,    37,    69,
     1842,  1732,   513,   504,
     478,   287,   191,   137,   182,   186,   137,    72,    31,    6,
     589,   469,   199,   128,   177,   264,   161,
     89,    49,
  },
  {  817,   344,   170,   243,    84,    18,    2,    30,    65,
     1836,  1733,   518,   511,
     477,   281,   185,   130,   169,   166,   117,    59,    25,    3,
     572,   450,   185,   121,   173,   232,   146,
     80,    43,
  },
  {  865,   389,   204,   322,   139,    42,    9,    26,    51,
     1848,  1766,   531,   522,
     477,   275,   177,   122,   153,   144,    97,    50,    16,    1,
     485,   378,   167,   115,   164,   203,   128,
     74,    42,
  },
  {  961,   447,   243,   407,   196,    74,    26,    12,    34,
     2003,  1942,   571,   565,
     494,   278,   173,   116,   141,   129,    85,    44,    8,    1,
     285,   223,   101,    66,   104,   120,    74,
     35,    22,
  },

  /* AC INTRA Tables  */
  /* AC Intra bias group 1 tables */
  {  245,    68,    25,    28,    5,    1,    1,   359,    4,
     910,   904,   570,   571,
     766,   620,   478,   375,   554,   684,   652,   441,   182,    30,
     535,   206,   118,    77,    69,    90,    16,
     299,   100,
  },
  {  302,    86,    32,    36,    8,    1,    1,   362,    3,
     974,   968,   599,   599,
     774,   635,   469,   365,   528,   628,   557,   337,   118,    14,
     577,   219,   136,    82,    69,    65,    13,
     317,   112,
  },
  {  348,   102,    39,    44,    9,    2,    1,   363,    3,
     1062,  1055,   607,   609,
     787,   626,   457,   348,   494,   550,   452,   233,    60,    2,
     636,   244,   159,    92,    74,    68,    12,
     327,   119,
  },
  {  400,   121,    47,    51,    11,    2,    1,   366,    3,
     1109,  1102,   620,   622,
     786,   624,   450,   331,   459,   490,   366,   163,    29,    1,
     673,   257,   175,    98,    77,    63,    14,
     344,   131,
  },
  {  470,   151,    59,    67,    15,    3,    1,   354,    4,
     1198,  1189,   640,   643,
     769,   603,   410,   294,   386,   381,   240,    78,    5,    1,
     746,   282,   205,   113,    87,    64,    15,
     368,   145,
  },
  {  553,   189,    77,    94,    24,    6,    1,   347,    4,
     1244,  1232,   650,   653,
     739,   551,   360,   249,   303,   261,   129,    24,    1,    1,
     828,   313,   245,   135,   108,    77,    17,
     403,   169,
  },
  {  701,   253,   109,   140,    42,    12,    2,   350,    6,
     1210,  1197,   652,   647,
     673,   495,   299,   189,   211,   151,    50,    2,    1,    1,
     892,   336,   284,   162,   134,   101,    25,
     455,   205,
  },
  {  924,   390,   180,   248,    85,    31,    13,   286,    14,
     1242,  1206,   601,   577,
     519,   342,   175,   100,    85,    36,    1,    1,    1,    1,
     1031,   348,   346,   204,   166,   131,    34,
     473,   197,
  },
  /* AC Inter bias group 1 tables */
  {  459,   128,    50,    48,    8,    1,    1,   224,    69,
     1285,  1227,   587,   565,
     573,   406,   261,   180,   228,   213,   130,    47,    11,    3,
     1069,   540,   309,   231,   147,   279,   157,
     383,   165,
  },
  {  524,   155,    62,    64,    14,    2,    1,   209,    63,
     1345,  1288,   523,   507,
     515,   358,   225,   153,   183,   160,    87,    29,    7,    2,
     1151,   591,   365,   282,   179,   308,   133,
     344,   157,
  },
  {  588,   181,    75,    81,    19,    3,    1,   204,    68,
     1344,  1288,   517,   503,
     505,   346,   216,   141,   169,   139,    71,    21,    5,    1,
     1146,   584,   366,   286,   170,   298,   153,
     342,   157,
  },
  {  634,   196,    82,    89,    22,    4,    1,   194,    60,
     1356,  1312,   515,   502,
     489,   331,   199,   127,   145,   111,    51,    14,    3,    1,
     1156,   589,   393,   300,   182,   285,   144,
     340,   159,
  },
  {  715,   231,    98,   113,    31,    7,    1,   181,    57,
     1345,  1303,   498,   490,
     448,   291,   166,   101,   106,    75,    30,    9,    1,    1,
     1175,   584,   416,   321,   209,   333,   164,
     330,   159,
  },
  {  825,   283,   125,   149,    44,    11,    2,   160,    59,
     1343,  1308,   476,   469,
     405,   247,   131,    75,    76,    47,    18,    5,    1,    1,
     1192,   579,   432,   332,   217,   327,   176,
     320,   154,
  },
  {  961,   361,   170,   215,    70,    20,    5,   161,    55,
     1250,  1218,   463,   460,
     354,   204,   101,    52,    48,    28,    11,    1,    1,    1,
     1172,   570,   449,   350,   222,   332,   169,
     338,   174,
  },
  {  1139,   506,   266,   387,   156,    57,    26,   114,    48,
     1192,  1170,   366,   366,
     226,   113,    47,    22,    22,    12,    1,    1,    1,    1,
     1222,   551,   462,   391,   220,   322,   156,
     290,   136,
  },

  /* AC Intra bias group 2 tables */
  {  245,    49,    15,    11,    1,    1,    1,   332,    38,
     1163,  1162,   685,   683,
     813,   623,   437,   318,   421,   424,   288,   109,    14,    1,
     729,   303,   179,   112,    87,   199,    46,
     364,   135,
  },
  {  305,    67,    22,    17,    2,    1,    1,   329,    39,
     1250,  1245,   706,   705,
     801,   584,   385,   267,   330,   296,   165,    40,    3,    1,
     798,   340,   206,   131,   108,   258,    52,
     382,   154,
  },
  {  356,    82,    28,    23,    3,    1,    1,   312,    42,
     1340,  1334,   701,   703,
     770,   545,   346,   227,   269,   223,   100,    17,    1,    1,
     846,   359,   222,   142,   120,   284,    55,
     379,   157,
  },
  {  402,    95,    33,    30,    4,    1,    1,   300,    43,
     1379,  1371,   710,   714,
     724,   486,   289,   182,   202,   144,    47,    5,    1,    1,
     908,   394,   250,   161,   141,   350,    60,
     391,   171,
  },
  {  499,   122,    44,    42,    7,    1,    1,   267,    45,
     1439,  1436,   690,   694,
     628,   385,   213,   122,   117,    62,    14,    1,    1,    1,
     992,   441,   288,   187,   167,   446,    82,
     378,   176,
  },
  {  641,   168,    62,    60,    12,    1,    1,   247,    49,
     1435,  1436,   662,   669,
     527,   298,   142,    71,    55,    22,    3,    1,    1,    1,
     1036,   470,   319,   208,   193,   548,   106,
     362,   184,
  },
  {  860,   274,   111,   113,    23,    4,    1,   229,    59,
     1331,  1323,   629,   645,
     419,   192,    72,    30,    19,    6,    1,    1,    1,    1,
     1022,   478,   339,   225,   213,   690,   142,
     342,   198,
  },
  {  1059,   437,   218,   285,    84,    17,    2,   152,    44,
     1284,  1313,   530,   561,
     212,    66,    17,    6,    3,    1,    1,    1,    1,    1,
     1034,   485,   346,   226,   207,   819,   185,
     248,   145,
  },
  /* AC Inter bias group 2 tables */
  {  407,    93,    31,    24,    2,    1,    1,   232,   108,
     1365,  1349,   581,   578,
     498,   305,   170,   100,   103,    67,    24,    5,    1,    1,
     1175,   604,   393,   268,   209,   506,   217,
     379,   193,
  },
  {  521,   129,    46,    39,    4,    1,    1,   199,   116,
     1419,  1403,   543,   540,
     446,   263,   138,    78,    75,    44,    13,    2,    1,    1,
     1201,   605,   392,   267,   214,   533,   252,
     334,   167,
  },
  {  575,   144,    52,    46,    6,    1,    1,   193,   124,
     1394,  1384,   528,   528,
     406,   227,   112,    59,    54,    28,    7,    1,    1,    1,
     1210,   621,   412,   284,   235,   604,   265,
     320,   167,
  },
  {  673,   174,    64,    59,    9,    1,    1,   177,   128,
     1392,  1385,   499,   499,
     352,   183,    85,    42,    35,    16,    3,    1,    1,    1,
     1210,   626,   418,   289,   246,   675,   297,
     292,   158,
  },
  {  804,   225,    85,    77,    12,    1,    1,   150,   129,
     1387,  1384,   455,   455,
     277,   129,    53,    23,    17,    7,    1,    1,    1,    1,
     1212,   635,   433,   306,   268,   760,   313,
     249,   137,
  },
  {  975,   305,   123,   117,    20,    2,    1,   135,   140,
     1312,  1310,   401,   399,
     201,    80,    28,    11,    8,    2,    1,    1,    1,    1,
     1162,   623,   439,   314,   283,   906,   368,
     203,   121,
  },
  {  1205,   452,   208,   231,    50,    6,    1,   123,   149,
     1161,  1164,   370,   370,
     137,    45,    14,    4,    2,    1,    1,    1,    1,    1,
     1047,   562,   413,   300,   277,  1020,   404,
     168,   105,
  },
  {  1297,   662,   389,   574,   200,    39,    4,    55,   120,
     1069,  1076,   273,   265,
     66,    14,    2,    1,    1,    1,    1,    1,    1,    1,
     930,   475,   345,   249,   236,  1124,   376,
     91,    56,
  },

  /* AC Intra bias group 3 tables */
  {  278,    55,    17,    12,    1,    1,    1,   288,    71,
     1315,  1304,   725,   724,
     733,   506,   307,   195,   225,   175,    77,    12,    1,    1,
     904,   414,   246,   170,   126,   290,   205,
     423,   185,
  },
  {  382,    80,    26,    21,    2,    1,    1,   239,    64,
     1442,  1429,   706,   701,
     664,   420,   239,   146,   152,   105,    34,    2,    1,    1,
     975,   440,   263,   185,   140,   332,   229,
     397,   169,
  },
  {  451,    97,    32,    27,    4,    1,    1,   223,    75,
     1462,  1454,   682,   680,
     574,   343,   179,   101,    98,    54,    9,    1,    1,    1,
     1031,   482,   293,   210,   163,   400,   297,
     384,   181,
  },
  {  551,   128,    43,    37,    5,    1,    1,   201,    78,
     1497,  1487,   642,   651,
     493,   269,   133,    70,    60,    24,    2,    1,    1,    1,
     1065,   504,   312,   228,   178,   451,   352,
     351,   174,
  },
  {  693,   179,    63,    54,    8,    1,    1,   169,    78,
     1502,  1497,   580,   591,
     375,   186,    77,    35,    21,    4,    1,    1,    1,    1,
     1099,   533,   341,   253,   206,   542,   432,
     306,   164,
  },
  {  867,   263,   105,    96,    16,    2,    1,   152,    81,
     1435,  1439,   521,   525,
     270,   107,    32,    8,    3,    1,    1,    1,    1,    1,
     1085,   537,   361,   277,   223,   616,   549,
     258,   156,
  },
  {  1022,   385,   182,   207,    46,    7,    1,   158,    88,
     1290,  1318,   501,   502,
     184,    38,    6,    1,    1,    1,    1,    1,    1,    1,
     1023,   480,   345,   301,   232,   665,   661,
     210,   133,
  },
  {  1184,   555,   307,   457,   185,    44,    6,   115,    41,
     1236,  1253,   329,   340,
     32,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     1017,   385,   316,   370,   246,   672,   788,
     85,    23,
  },
  /* AC Inter bias group 3 tables */
  {  502,   106,    33,    22,    1,    1,    1,   151,   132,
     1446,  1451,   502,   499,
     343,   181,    84,    42,    36,    16,    3,    1,    1,    1,
     1211,   661,   429,   312,   242,   637,   498,
     288,   156,
  },
  {  651,   147,    48,    35,    3,    1,    1,   145,   140,
     1419,  1420,   469,   466,
     281,   132,    56,    25,    18,    6,    1,    1,    1,    1,
     1175,   656,   435,   328,   260,   715,   556,
     252,   147,
  },
  {  749,   179,    59,    43,    4,    1,    1,   123,   135,
     1423,  1431,   413,   409,
     221,    95,    36,    15,    9,    2,    1,    1,    1,    1,
     1159,   658,   444,   340,   272,   782,   656,
     205,   124,
  },
  {  902,   243,    86,    67,    7,    1,    1,   114,   141,
     1385,  1385,   387,   383,
     178,    67,    22,    7,    4,    1,    1,    1,    1,    1,
     1096,   632,   434,   339,   277,   813,   735,
     171,   109,
  },
  {  1081,   337,   133,   112,    15,    1,    1,    92,   137,
     1350,  1349,   311,   309,
     115,    34,    8,    2,    1,    1,    1,    1,    1,    1,
     1016,   595,   418,   342,   283,   870,   883,
     114,    78,
  },
  {  1253,   467,   210,   205,    34,    3,    1,    80,   130,
     1318,  1313,   258,   260,
     68,    12,    2,    1,    1,    1,    1,    1,    1,    1,
     874,   516,   378,   330,   273,   877,  1000,
     72,    53,
  },
  {  1362,   626,   333,   423,   100,    10,    1,    73,   106,
     1311,  1313,   241,   231,
     31,    3,    1,    1,    1,    1,    1,    1,    1,    1,
     620,   368,   286,   302,   245,   814,  1127,
     34,    28,
  },
  {  1203,   743,   460,   774,   284,    36,    1,    13,    25,
     1956,  1961,   103,   106,
     3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     248,   131,   149,   272,   165,   535,   813,
     3,    3,
  },

  /* AC Intra bias group 4 tables */
  {  599,   150,    55,    50,    9,    1,    1,   181,    19,
     1487,  1487,   625,   625,
     473,   271,   138,    74,    71,    42,    11,    1,    1,    1,
     1187,   591,   356,   239,   170,   351,   137,
     395,   194,
  },
  {  758,   209,    79,    74,    15,    2,    1,   147,    25,
     1514,  1514,   521,   520,
     334,   165,    74,    36,    30,    11,    1,    1,    1,    1,
     1252,   644,   409,   279,   211,   472,   203,
     318,   171,
  },
  {  852,   252,   100,    98,    20,    3,    1,   130,    26,
     1493,  1498,   481,   473,
     268,   123,    51,    23,    15,    3,    1,    1,    1,    1,
     1256,   652,   426,   294,   231,   543,   242,
     278,   156,
  },
  {  971,   309,   130,   136,    30,    5,    1,   113,    28,
     1458,  1467,   443,   435,
     215,    90,    31,    12,    5,    1,    1,    1,    1,    1,
     1232,   643,   426,   303,   243,   590,   300,
     235,   136,
  },
  {  1100,   399,   180,   206,    53,    9,    1,   101,    29,
     1419,  1425,   375,   374,
     158,    47,    10,    1,    1,    1,    1,    1,    1,    1,
     1193,   609,   426,   319,   256,   643,   383,
     166,   103,
  },
  {  1195,   505,   249,   326,    98,    20,    3,   102,    25,
     1370,  1356,   355,   347,
     104,    11,    1,    1,    1,    1,    1,    1,    1,    1,
     1100,   568,   381,   330,   261,   642,   466,
     105,    69,
  },
  {  1176,   608,   345,   559,   244,    57,    6,   110,    9,
     1370,  1332,   372,   367,
     29,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     859,   427,   269,   359,   375,   608,   451,
     35,    20,
  },
  {  1140,   613,   391,   797,   458,   180,    37,    2,    1,
     2037,  1697,    95,    31,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     360,    49,    23,   198,  1001,   719,   160,
     1,    1,
  },
  /* AC Inter bias group 4 tables */
  {  931,   272,   105,    96,    16,    1,    1,    91,    52,
     1481,  1489,   347,   349,
     174,    74,    28,    12,    8,    3,    1,    1,    1,    1,
     1247,   719,   490,   356,   279,   706,   363,
     187,   110,
  },
  {  1095,   358,   148,   143,    25,    3,    1,    74,    61,
     1439,  1457,   304,   302,
     127,    46,    15,    5,    3,    1,    1,    1,    1,    1,
     1138,   664,   469,   347,   282,   768,   487,
     139,    87,
  },
  {  1192,   423,   188,   189,    36,    4,    1,    64,    61,
     1457,  1475,   284,   282,
     106,    35,    10,    3,    1,    1,    1,    1,    1,    1,
     1078,   624,   440,   329,   264,   744,   507,
     117,    73,
  },
  {  1275,   496,   231,   258,    52,    6,    1,    53,    55,
     1458,  1470,   248,   245,
     77,    20,    5,    1,    1,    1,    1,    1,    1,    1,
     984,   576,   414,   323,   260,   771,   569,
     84,    54,
  },
  {  1377,   603,   302,   367,    87,    11,    1,    37,    52,
     1522,  1532,   207,   204,
     47,    8,    1,    1,    1,    1,    1,    1,    1,    1,
     840,   493,   366,   291,   231,   690,   636,
     52,    32,
  },
  {  1409,   708,   385,   529,   148,    24,    1,    23,    37,
     1672,  1670,   163,   162,
     22,    2,    1,    1,    1,    1,    1,    1,    1,    1,
     647,   364,   291,   262,   210,   574,   643,
     26,    14,
  },
  {  1348,   778,   481,   755,   245,    53,    4,    13,    19,
     2114,  2089,   141,   139,
     7,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     302,   183,   162,   181,   182,   344,   437,
     8,    3,
  },
  {  1560,   769,   410,   664,   243,    58,    1,    1,    1,
     3017,  2788,    17,    24,
     3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     34,    16,    8,    55,   134,   105,    86,
     1,    1,
  },
};

################################################################################

TITLE
    libtheora old FrequencyCounts_VP3

TYPE
    32

DATA
  /* DC Intra bias */
  {  198,    62,    22,    31,    14,     6,     6,   205,     3,
     843,   843,   415,   516,
     660,   509,   412,   347,   560,   779,   941,   930,   661,   377,
     170,   155,    39,     2,     9,    15,    11,
     128,    86,
  },
  {  299,    92,    34,    39,    15,     6,     6,   132,     1,
     851,   851,   484,   485,
     666,   514,   416,   351,   567,   788,   953,   943,   670,   383,
     117,   119,    26,     4,    17,     7,     1,
      93,    56,
  },
  {  367,   115,   42,   47,   16,    6,    6,   105,    1,
     896,   896,   492,   493,
     667,   510,   408,   342,   547,   760,   932,   927,   656,   379,
     114,   103,   10,    3,    6,    2,    1,
     88,   49,
  },
  {  462,   158,   63,   76,   28,    9,    8,   145,    1,
     1140,  1140,   573,   574,
     754,   562,   435,   357,   555,   742,   793,   588,   274,   81,
     154,   117,   13,    6,   12,    2,    1,
     104,   62,
  },
  {  558,   196,   81,   99,   36,   11,    9,   135,    1,
     1300,  1301,   606,   607,
     779,   560,   429,   349,   536,   680,   644,   405,   153,   30,
     171,   120,   12,    5,   14,    3,    1,
     104,   53,
  },
  {  635,   233,   100,   122,   46,   14,   12,   113,    1,
     1414,  1415,   631,   631,
     785,   555,   432,   335,   513,   611,   521,   284,   89,   13,
     170,   113,   10,    5,   14,    3,    1,
     102,   62,
  },
  {  720,   276,   119,   154,   62,   20,   16,   101,    1,
     1583,  1583,   661,   661,
     794,   556,   407,   318,   447,   472,   343,   153,   35,    1,
     172,   115,   11,    7,   14,    3,    1,
     112,   70,
  },
  {  853,   326,   144,   184,   80,   27,   19,   52,    1,
     1739,  1740,   684,   685,
     800,   540,   381,   277,   364,   352,   218,   78,   13,    1,
     139,   109,    9,    6,   20,    2,    1,
     94,   50,
  },

  /* DC Inter Bias */
  {  490,   154,   57,   53,   10,    2,    1,   238,   160,
     1391,  1390,   579,   578,
     491,   273,   172,   118,   152,   156,   127,   79,   41,   39,
     712,   547,   316,   125,   183,   306,   237,
     451,   358,
  },
  {  566,   184,   70,   65,   11,    2,    1,   235,   51,
     1414,  1414,   599,   598,
     510,   285,   180,   124,   157,   161,   131,   82,   42,   40,
     738,   551,   322,   138,   195,   188,   93,
     473,   365,
  },
  {  711,   261,   111,   126,   27,    4,    1,   137,   52,
     1506,  1505,   645,   645,
     567,   316,   199,   136,   172,   175,   142,   88,   45,   48,
     548,   449,   255,   145,   184,   174,   121,
     260,   227,
  },
  {  823,   319,   144,   175,   43,    7,    1,   53,   42,
     1648,  1648,   653,   652,
     583,   329,   205,   139,   175,   176,   139,   84,   44,   34,
     467,   389,   211,   137,   181,   186,   107,
     106,   85,
  },
  {  948,   411,   201,   276,   85,   16,    2,   39,   33,
     1778,  1777,   584,   583,
     489,   265,   162,   111,   140,   140,   108,   64,   38,   23,
     428,   356,   201,   139,   186,   165,   94,
     78,   63,
  },
  {  1002,   470,   248,   386,   153,   39,    6,   23,   23,
     1866,  1866,   573,   573,
     467,   249,   155,   103,   130,   128,   94,   60,   38,   14,
     323,   263,   159,   111,   156,   153,   74,
     46,   34,
  },
  {  1020,   518,   291,   504,   242,   78,   18,   14,   14,
     1980,  1979,   527,   526,
     408,   219,   132,   87,   110,   104,   79,   55,   31,    7,
     265,   213,   129,   91,   131,   111,   50,
     31,   20,
  },
  {  1018,   544,   320,   591,   338,   139,   47,    5,    2,
     2123,  2123,   548,   547,
     414,   212,   126,   83,   101,   96,   79,   60,   23,    1,
     120,   97,   55,   39,   60,   38,   15,
     11,    8,
  },

  /* AC INTRA Tables  */
  /* AC Intra bias group 1 tables */
  {  242,   62,   22,   20,    4,    1,    1,   438,    1,
     593,   593,   489,   490,
     657,   580,   471,   374,   599,   783,   869,   770,   491,   279,
     358,   144,   82,   54,   49,   70,    5,
     289,   107,
  },
  {  317,   95,   38,   41,    8,    1,    1,   479,    1,
     653,   654,   500,   501,
     682,   611,   473,   376,   582,   762,   806,   656,   358,   155,
     419,   162,   86,   58,   36,   34,    1,
     315,   126,
  },
  {  382,   121,   49,   59,   15,    3,    1,   496,    1,
     674,   674,   553,   554,
     755,   636,   487,   391,   576,   718,   701,   488,   221,   72,
     448,   161,   107,   56,   37,   29,    1,
     362,   156,
  },
  {  415,   138,   57,   73,   21,    5,    1,   528,    1,
     742,   741,   562,   563,
     753,   669,   492,   388,   563,   664,   589,   340,   129,   26,
     496,   184,   139,   71,   48,   33,    2,
     387,   166,
  },
  {  496,   170,   73,   94,   31,    8,    2,   513,    1,
     855,   855,   604,   604,
     769,   662,   477,   356,   486,   526,   381,   183,   51,    5,
     590,   214,   160,   85,   60,   39,    3,
     427,   203,
  },
  {  589,   207,   89,   116,   40,   13,    3,   491,    1,
     919,   919,   631,   631,
     769,   633,   432,   308,   408,   378,   247,   94,   17,    1,
     659,   247,   201,   105,   73,   51,    3,
     466,   242,
  },
  {  727,   266,   115,   151,   49,   17,    6,   439,    1,
     977,   977,   642,   642,
     718,   572,   379,   243,   285,   251,   133,   40,    1,    1,
     756,   287,   253,   126,   94,   66,    4,
     492,   280,
  },
  {  940,   392,   180,   247,   82,   30,   14,   343,    1,
     1064,  1064,   615,   616,
     596,   414,   235,   146,   149,   108,   41,    1,    1,    1,
     882,   314,   346,   172,   125,   83,    6,
     489,   291,
  },
  /* AC Inter bias group 1 tables */
  {  440,   102,   33,   23,    2,    1,    1,   465,   85,
     852,   852,   744,   743,
     701,   496,   297,   193,   225,   200,   129,   58,   18,    2,
     798,   450,   269,   202,   145,   308,   154,
     646,   389,
  },
  {  592,   151,   53,   43,    6,    1,    1,   409,   34,
     875,   875,   748,   747,
     723,   510,   305,   196,   229,   201,   130,   59,   18,    2,
     800,   436,   253,   185,   115,   194,   88,
     642,   368,
  },
  {  759,   222,   86,   85,   17,    2,    1,   376,   46,
     888,   888,   689,   688,
     578,   408,   228,   143,   165,   141,   84,   35,    7,    1,
     878,   488,   321,   244,   147,   266,   124,
     612,   367,
  },
  {  912,   298,   122,   133,   34,    7,    1,   261,   44,
     1092,  1091,   496,   496,
     409,   269,   150,   95,   106,   87,   49,   16,    1,    1,
     1102,   602,   428,   335,   193,   323,   157,
     423,   253,
  },
  {  1072,   400,   180,   210,   60,   16,    3,   210,   40,
     1063,  1063,   451,   451,
     345,   221,   121,   73,   79,   64,   31,    6,    1,    1,
     1105,   608,   462,   358,   202,   330,   155,
     377,   228,
  },
  {  1164,   503,   254,   330,   109,   34,    9,   167,   35,
     1038,  1037,   390,   390,
     278,   170,   89,   54,   56,   40,   13,    1,    1,    1,
     1110,   607,   492,   401,   218,   343,   141,
     323,   192,
  },
  {  1173,   583,   321,   486,   196,   68,   23,   124,   23,
     1037,  1037,   347,   346,
     232,   139,   69,   40,   37,   20,    2,    1,    1,    1,
     1128,   584,   506,   410,   199,   301,   113,
     283,   159,
  },
  {  1023,   591,   366,   699,   441,   228,   113,   79,    5,
     1056,  1056,   291,   291,
     173,   96,   38,   19,    8,    1,    1,    1,    1,    1,
     1187,   527,   498,   409,   147,   210,   56,
     263,   117,
  },

  /* AC Intra bias group 2 tables */
  {  311,   74,   27,   27,    5,    1,    1,   470,   24,
     665,   667,   637,   638,
     806,   687,   524,   402,   585,   679,   609,   364,   127,   20,
     448,   210,   131,   76,   52,   111,   19,
     393,   195,
  },
  {  416,   104,   39,   38,    8,    1,    1,   545,   33,
     730,   731,   692,   692,
     866,   705,   501,   365,   495,   512,   387,   168,   39,    2,
     517,   240,   154,   86,   64,   127,   19,
     461,   247,
  },
  {  474,   117,   43,   42,    9,    1,    1,   560,   40,
     783,   783,   759,   760,
     883,   698,   466,   318,   404,   377,   215,   66,    7,    1,
     559,   259,   176,   110,   87,   170,   22,
     520,   278,
  },
  {  582,   149,   53,   53,   12,    2,    1,   473,   39,
     992,   993,   712,   713,
     792,   593,   373,   257,   299,   237,   114,   25,    1,    1,
     710,   329,   221,   143,   116,   226,   26,
     490,   259,
  },
  {  744,   210,   78,   77,   16,    2,    1,   417,   37,
     1034,  1035,   728,   728,
     718,   509,   296,   175,   184,   122,   42,    3,    1,    1,
     791,   363,   255,   168,   145,   311,   35,
     492,   272,
  },
  {  913,   291,   121,   128,   28,    4,    1,   334,   40,
     1083,  1084,   711,   712,
     624,   378,   191,   107,   95,   50,    7,    1,    1,    1,
     876,   414,   288,   180,   164,   382,   39,
     469,   275,
  },
  {  1065,   405,   184,   216,   53,    8,    1,   236,   36,
     1134,  1134,   685,   686,
     465,   253,   113,   48,   41,    9,    1,    1,    1,    1,
     965,   451,   309,   179,   166,   429,   53,
     414,   249,
  },
  {  1148,   548,   301,   438,   160,   42,    6,   84,   17,
     1222,  1223,   574,   575,
     272,   111,   23,    6,    2,    1,    1,    1,    1,    1,
     1060,   502,   328,   159,   144,   501,   54,
     302,   183,
  },
  /* AC Inter bias group 2 tables */
  {  403,   80,   24,   17,    1,    1,    1,   480,   90,
     899,   899,   820,   819,
     667,   413,   228,   133,   139,   98,   42,   10,    1,    1,
     865,   470,   316,   222,   171,   419,   213,
     645,   400,
  },
  {  698,   169,   59,   49,    6,    1,    1,   414,   101,
     894,   893,   761,   761,
     561,   338,   171,   96,   97,   64,   26,    6,    1,    1,
     896,   494,   343,   239,   192,   493,   215,
     583,   366,
  },
  {  914,   255,   94,   80,   10,    1,    1,   345,   128,
     935,   935,   670,   671,
     415,   222,   105,   55,   51,   30,   10,    1,    1,    1,
     954,   530,   377,   274,   232,   641,   295,
     456,   298,
  },
  {  1103,   359,   146,   135,   20,    1,    1,   235,   119,
     1042,  1042,   508,   507,
     293,   146,   65,   33,   30,   16,    4,    1,    1,    1,
     1031,   561,   407,   296,   265,   813,   317,
     301,   192,
  },
  {  1255,   504,   238,   265,   51,    5,    1,   185,   113,
     1013,  1013,   437,   438,
     212,   92,   41,   18,   15,    6,    1,    1,    1,    1,
     976,   530,   386,   276,   260,   927,   357,
     224,   148,
  },
  {  1292,   610,   332,   460,   127,   16,    1,   136,   99,
     1014,  1015,   384,   384,
     153,   65,   25,   11,    6,    1,    1,    1,    1,    1,
     942,   487,   343,   241,   238,   970,   358,
     174,   103,
  },
  {  1219,   655,   407,   700,   280,   55,    2,   100,   60,
     1029,  1029,   337,   336,
     119,   43,   11,    3,    2,    1,    1,    1,    1,    1,
     894,   448,   305,   199,   213,  1005,   320,
     136,   77,
  },
  {  1099,   675,   435,   971,   581,   168,   12,   37,   16,
     1181,  1081,   319,   318,
     66,   11,    6,    1,    1,    1,    1,    1,    1,    1,
     914,   370,   235,   138,   145,   949,   128,
     94,   41,
  },

  /* AC Intra bias group 3 tables */
  {  486,   112,   39,   34,    6,    1,    1,   541,   67,
     819,   818,   762,   763,
     813,   643,   403,   280,   332,   295,   164,   53,    6,    1,
     632,   294,   180,   131,   105,   208,   109,
     594,   295,
  },
  {  723,   191,   69,   65,   12,    1,    1,   445,   79,
     865,   865,   816,   816,
     750,   515,   290,   172,   184,   122,   46,    5,    1,    1,
     740,   340,   213,   165,   129,   270,   168,
     603,   326,
  },
  {  884,   264,   102,   103,   21,    3,    1,   382,   68,
     897,   897,   836,   836,
     684,   427,   227,   119,   119,   70,   16,    1,    1,    1,
     771,   367,   234,   184,   143,   272,   178,
     555,   326,
  },
  {  1028,   347,   153,   161,   36,    8,    1,   251,   44,
     1083,  1084,   735,   735,
     541,   289,   144,   77,   57,   23,    3,    1,    1,    1,
     926,   422,   270,   215,   176,   301,   183,
     443,   248,
  },
  {  1155,   465,   224,   264,   71,   14,    3,   174,   27,
     1110,  1111,   730,   731,
     429,   206,   79,   30,   19,    4,    1,    1,    1,    1,
     929,   443,   279,   225,   194,   298,   196,
     354,   223,
  },
  {  1191,   576,   296,   415,   144,   36,    8,   114,   16,
     1162,  1162,   749,   749,
     338,   108,   29,    8,    5,    1,    1,    1,    1,    1,
     947,   458,   273,   207,   194,   248,   145,
     258,   152,
  },
  {  1169,   619,   366,   603,   247,   92,   23,   46,    1,
     1236,  1236,   774,   775,
     191,   35,   14,    1,    1,    1,    1,    1,    1,    1,
     913,   449,   260,   214,   194,   180,   82,
     174,   98,
  },
  {  1006,   537,   381,   897,   504,   266,   101,   39,    1,
     1307,  1307,   668,   667,
     116,    3,    1,    1,    1,    1,    1,    1,    1,    1,
     1175,   261,   295,   70,   164,   107,   31,
     10,   76,
  },
  /* AC Inter bias group 3 tables */
  {  652,   156,   53,   43,    5,    1,    1,   368,   128,
     983,   984,   825,   825,
     583,   331,   163,   88,   84,   48,   15,    1,    1,    1,
     870,   480,   316,   228,   179,   421,   244,
     562,   349,
  },
  {  988,   280,   104,   87,   12,    1,    1,   282,   194,
     980,   981,   738,   739,
     395,   189,   80,   37,   31,   12,    2,    1,    1,    1,
     862,   489,   333,   262,   214,   600,   446,
     390,   260,
  },
  {  1176,   399,   165,   154,   24,    2,    1,   218,   224,
     1017,  1018,   651,   651,
     280,   111,   42,   16,    9,    3,    1,    1,    1,    1,
     787,   469,   324,   269,   229,   686,   603,
     267,   194,
  },
  {  1319,   530,   255,   268,   47,    4,    1,   113,   183,
     1149,  1150,   461,   461,
     173,   58,   17,    5,    3,    1,    1,    1,    1,    1,
     768,   450,   305,   261,   221,   716,   835,
     136,   97,
  },
  {  1362,   669,   355,   465,   104,    9,    1,   76,   153,
     1253,  1253,   398,   397,
     102,   21,    5,    1,    1,    1,    1,    1,    1,    1,
     596,   371,   238,   228,   196,   660,   954,
     68,   53,
  },
  {  1354,   741,   446,   702,   174,   15,    1,   38,   87,
     1498,  1498,   294,   294,
     43,    7,    1,    1,    1,    1,    1,    1,    1,    1,
     381,   283,   165,   181,   155,   544,  1039,
     25,   21,
  },
  {  1262,   885,   546,   947,   263,   18,    1,   18,   27,
     1908,  1908,   163,   162,
     14,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     195,   152,   83,   125,   109,   361,   827,
     7,    5,
  },
  {  2539,   951,   369,   554,   212,   18,    1,    1,    1,
     2290,  2289,   64,   64,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     18,   18,    9,   55,   36,   184,   323,
     1,    1,
  },


  /* AC Intra bias group 4 tables */
  {  921,   264,   101,   100,   19,    2,    1,   331,   98,
     1015,  1016,   799,   799,
     512,   269,   119,   60,   50,   17,    1,    1,    1,    1,
     841,   442,   307,   222,   182,   493,   256,
     438,   310,
  },
  {  1147,   412,   184,   206,   50,    6,    1,   242,   141,
     977,   976,   808,   807,
     377,   135,   40,   10,    7,    1,    1,    1,    1,    1,
     788,   402,   308,   223,   205,   584,   406,
     316,   227,
  },
  {  1243,   504,   238,   310,   79,   11,    1,   184,   150,
     983,   984,   814,   813,
     285,   56,   10,    1,    1,    1,    1,    1,    1,    1,
     713,   377,   287,   217,   180,   615,   558,
     208,   164,
  },
  {  1266,   606,   329,   484,   161,   27,    1,   79,   92,
     1187,  1188,   589,   588,
     103,   10,    1,    1,    1,    1,    1,    1,    1,    1,
     680,   371,   278,   221,   244,   614,   728,
     80,   62,
  },
  {  1126,   828,   435,   705,   443,   90,    8,   10,   55,
     1220,  1219,   350,   350,
     28,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     602,   330,   222,   168,   158,   612,   919,
     104,    5,
  },
  {  1210,   506,  1014,   926,   474,   240,    4,    1,    44,
     1801,  1801,   171,   171,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     900,   132,    36,    11,    47,   191,   316,
     2,    1,
  },
  {  1210,   506,  1014,   926,   474,   240,    4,    1,    44,
     1801,  1801,   171,   171,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     900,   132,    36,    11,    47,   191,   316,
     2,    1,
  },
  {  1210,   506,  1014,   926,   474,   240,    4,    1,    44,
     1801,  1801,   171,   171,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     900,   132,    36,    11,    47,   191,   316,
     2,    1,
  },
  /* AC Inter bias group 4 tables */
  {  1064,   325,   129,   117,    20,    2,    1,   266,   121,
     1000,  1000,   706,   706,
     348,   162,    67,    32,    25,    11,    1,    1,    1,    1,
     876,   513,   363,   274,   225,   627,   384,
     370,   251,
  },
  {  1311,   517,   238,   254,    45,    3,    1,   188,   160,
     1070,  1070,   635,   635,
     239,    85,    30,    11,    6,    1,    1,    1,    1,    1,
     744,   420,   313,   239,   206,   649,   541,
     221,   155,
  },
  {  1394,   632,   322,   385,    78,    7,    1,   134,   152,
     1163,  1164,   607,   607,
     185,    51,    12,    3,    1,    1,    1,    1,    1,    1,
     631,   331,   275,   203,   182,   604,   620,
     146,    98,
  },
  {  1410,   727,   407,   546,   146,    19,    1,    67,    88,
     1485,  1486,   419,   418,
     103,    18,    3,    1,    1,    1,    1,    1,    1,    1,
     555,   261,   234,   164,   148,   522,   654,
      67,    39,
  },
  {  1423,   822,   492,   719,   216,    22,    1,    28,    59,
     1793,  1793,   323,   324,
     37,    2,    1,    1,    1,    1,    1,    1,    1,    1,
     376,   138,   158,   102,   119,   400,   604,
     28,    9,
  },
  {  1585,   923,   563,   918,   207,    25,    1,    5,    20,
     2229,  2230,   172,   172,
     7,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     191,    40,    56,    22,    65,   243,   312,
     2,    1,
  },
  {  2225,  1100,   408,   608,   133,    8,    1,    1,    1,
     2658,  2658,    25,    24,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     8,    1,    1,    1,    1,   125,    16,
     1,    1,
  },
  {  2539,   951,   369,   554,   212,    18,    1,    1,    1,
     2290,  2289,    64,    64,
     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     18,    18,    9,    55,    36,   184,   323,
     1,    1,
  },
};

################################################################################

TITLE
    Vorbis FLOOR1_fromdB_LOOKUP

TYPE
    FLOAT

DATA
  1.0649863e-07F, 1.1341951e-07F, 1.2079015e-07F, 1.2863978e-07F, 
  1.3699951e-07F, 1.4590251e-07F, 1.5538408e-07F, 1.6548181e-07F, 
  1.7623575e-07F, 1.8768855e-07F, 1.9988561e-07F, 2.128753e-07F, 
  2.2670913e-07F, 2.4144197e-07F, 2.5713223e-07F, 2.7384213e-07F, 
  2.9163793e-07F, 3.1059021e-07F, 3.3077411e-07F, 3.5226968e-07F, 
  3.7516214e-07F, 3.9954229e-07F, 4.2550680e-07F, 4.5315863e-07F, 
  4.8260743e-07F, 5.1396998e-07F, 5.4737065e-07F, 5.8294187e-07F, 
  6.2082472e-07F, 6.6116941e-07F, 7.0413592e-07F, 7.4989464e-07F, 
  7.9862701e-07F, 8.5052630e-07F, 9.0579828e-07F, 9.6466216e-07F, 
  1.0273513e-06F, 1.0941144e-06F, 1.1652161e-06F, 1.2409384e-06F, 
  1.3215816e-06F, 1.4074654e-06F, 1.4989305e-06F, 1.5963394e-06F, 
  1.7000785e-06F, 1.8105592e-06F, 1.9282195e-06F, 2.0535261e-06F, 
  2.1869758e-06F, 2.3290978e-06F, 2.4804557e-06F, 2.6416497e-06F, 
  2.8133190e-06F, 2.9961443e-06F, 3.1908506e-06F, 3.3982101e-06F, 
  3.6190449e-06F, 3.8542308e-06F, 4.1047004e-06F, 4.3714470e-06F, 
  4.6555282e-06F, 4.9580707e-06F, 5.2802740e-06F, 5.6234160e-06F, 
  5.9888572e-06F, 6.3780469e-06F, 6.7925283e-06F, 7.2339451e-06F, 
  7.7040476e-06F, 8.2047000e-06F, 8.7378876e-06F, 9.3057248e-06F, 
  9.9104632e-06F, 1.0554501e-05F, 1.1240392e-05F, 1.1970856e-05F, 
  1.2748789e-05F, 1.3577278e-05F, 1.4459606e-05F, 1.5399272e-05F, 
  1.6400004e-05F, 1.7465768e-05F, 1.8600792e-05F, 1.9809576e-05F, 
  2.1096914e-05F, 2.2467911e-05F, 2.3928002e-05F, 2.5482978e-05F, 
  2.7139006e-05F, 2.8902651e-05F, 3.0780908e-05F, 3.2781225e-05F, 
  3.4911534e-05F, 3.7180282e-05F, 3.9596466e-05F, 4.2169667e-05F, 
  4.4910090e-05F, 4.7828601e-05F, 5.0936773e-05F, 5.4246931e-05F, 
  5.7772202e-05F, 6.1526565e-05F, 6.5524908e-05F, 6.9783085e-05F, 
  7.4317983e-05F, 7.9147585e-05F, 8.4291040e-05F, 8.9768747e-05F, 
  9.5602426e-05F, 0.00010181521F, 0.00010843174F, 0.00011547824F, 
  0.00012298267F, 0.00013097477F, 0.00013948625F, 0.00014855085F, 
  0.00015820453F, 0.00016848555F, 0.00017943469F, 0.00019109536F, 
  0.00020351382F, 0.00021673929F, 0.00023082423F, 0.00024582449F, 
  0.00026179955F, 0.00027881276F, 0.00029693158F, 0.00031622787F, 
  0.00033677814F, 0.00035866388F, 0.00038197188F, 0.00040679456F, 
  0.00043323036F, 0.00046138411F, 0.00049136745F, 0.00052329927F, 
  0.00055730621F, 0.00059352311F, 0.00063209358F, 0.00067317058F, 
  0.00071691700F, 0.00076350630F, 0.00081312324F, 0.00086596457F, 
  0.00092223983F, 0.00098217216F, 0.0010459992F, 0.0011139742F, 
  0.0011863665F, 0.0012634633F, 0.0013455702F, 0.0014330129F, 
  0.0015261382F, 0.0016253153F, 0.0017309374F, 0.0018434235F, 
  0.0019632195F, 0.0020908006F, 0.0022266726F, 0.0023713743F, 
  0.0025254795F, 0.0026895994F, 0.0028643847F, 0.0030505286F, 
  0.0032487691F, 0.0034598925F, 0.0036847358F, 0.0039241906F, 
  0.0041792066F, 0.0044507950F, 0.0047400328F, 0.0050480668F, 
  0.0053761186F, 0.0057254891F, 0.0060975636F, 0.0064938176F, 
  0.0069158225F, 0.0073652516F, 0.0078438871F, 0.0083536271F, 
  0.0088964928F, 0.009474637F, 0.010090352F, 0.010746080F, 
  0.011444421F, 0.012188144F, 0.012980198F, 0.013823725F, 
  0.014722068F, 0.015678791F, 0.016697687F, 0.017782797F, 
  0.018938423F, 0.020169149F, 0.021479854F, 0.022875735F, 
  0.024362330F, 0.025945531F, 0.027631618F, 0.029427276F, 
  0.031339626F, 0.033376252F, 0.035545228F, 0.037855157F, 
  0.040315199F, 0.042935108F, 0.045725273F, 0.048696758F, 
  0.051861348F, 0.055231591F, 0.058820850F, 0.062643361F, 
  0.066714279F, 0.071049749F, 0.075666962F, 0.080584227F, 
  0.085821044F, 0.091398179F, 0.097337747F, 0.10366330F, 
  0.11039993F, 0.11757434F, 0.12521498F, 0.13335215F, 
  0.14201813F, 0.15124727F, 0.16107617F, 0.17154380F, 
  0.18269168F, 0.19456402F, 0.20720788F, 0.22067342F, 
  0.23501402F, 0.25028656F, 0.26655159F, 0.28387361F, 
  0.30232132F, 0.32196786F, 0.34289114F, 0.36517414F, 
  0.38890521F, 0.41417847F, 0.44109412F, 0.46975890F, 
  0.50028648F, 0.53279791F, 0.56742212F, 0.60429640F, 
  0.64356699F, 0.68538959F, 0.72993007F, 0.77736504F, 
  0.82788260F, 0.88168307F, 0.9389798F, 1.F, 

################################################################################

TITLE
    libskba asn1 yytranslate

TYPE
    8

DATA
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      49,    50,     2,    47,    51,    48,    56,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    52,     2,    53,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    54,     2,    55,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46

################################################################################

TITLE
    libskba asn1 yycheck

TYPE
    32 16

DATA
      12,    41,    65,    45,   123,     4,     5,     4,   127,     5,
      52,     4,     5,   156,    56,    57,    58,    59,    60,    61,
      62,     4,     5,     8,     8,    50,     5,     8,     5,    29,
      30,    56,     6,    18,    97,     4,    54,    18,     0,     4,
       5,   104,    16,     5,    13,    14,    15,   190,    51,    31,
      47,    48,    55,    49,    96,    34,    55,    22,    23,    51,
      37,    49,    55,    55,    49,    49,   101,     4,    49,    54,
     105,    32,    55,    54,     3,   138,    51,   196,    90,   198,
      55,   144,    47,    48,   124,     5,     3,     7,     5,     9,
       7,    11,    12,    33,    51,    38,    51,    17,    55,    19,
      55,    21,    19,    51,    24,    25,    50,    55,    28,     4,
       5,    29,    30,   153,     5,    35,    36,     4,     5,    39,
      40,    41,    42,    43,    44,    45,    46,     5,     5,     7,
       5,     9,    52,    11,    12,     3,     3,    20,    54,    17,
     152,    19,    54,    21,    10,    10,    24,    25,    20,    54,
      28,    49,    26,    54,     4,     3,    49,    35,    36,     8,
       5,    39,    40,    41,    42,    43,    44,    45,    46,   181,
      54,    18,    27,     5,    18,     4,    56,    53,     5,    50,
      49,    54,     4,    53,     4,    49,     4,    50,    92,   176,
      50,    50,    50,    50,    56,    56,   163,   139,    32,   135,
      -1,   167

################################################################################

TITLE
    twofish q0

TYPE
    8

DATA
   0xA9, 0x67, 0xB3, 0xE8, 0x04, 0xFD, 0xA3, 0x76, 0x9A, 0x92, 0x80, 0x78,
   0xE4, 0xDD, 0xD1, 0x38, 0x0D, 0xC6, 0x35, 0x98, 0x18, 0xF7, 0xEC, 0x6C,
   0x43, 0x75, 0x37, 0x26, 0xFA, 0x13, 0x94, 0x48, 0xF2, 0xD0, 0x8B, 0x30,
   0x84, 0x54, 0xDF, 0x23, 0x19, 0x5B, 0x3D, 0x59, 0xF3, 0xAE, 0xA2, 0x82,
   0x63, 0x01, 0x83, 0x2E, 0xD9, 0x51, 0x9B, 0x7C, 0xA6, 0xEB, 0xA5, 0xBE,
   0x16, 0x0C, 0xE3, 0x61, 0xC0, 0x8C, 0x3A, 0xF5, 0x73, 0x2C, 0x25, 0x0B,
   0xBB, 0x4E, 0x89, 0x6B, 0x53, 0x6A, 0xB4, 0xF1, 0xE1, 0xE6, 0xBD, 0x45,
   0xE2, 0xF4, 0xB6, 0x66, 0xCC, 0x95, 0x03, 0x56, 0xD4, 0x1C, 0x1E, 0xD7,
   0xFB, 0xC3, 0x8E, 0xB5, 0xE9, 0xCF, 0xBF, 0xBA, 0xEA, 0x77, 0x39, 0xAF,
   0x33, 0xC9, 0x62, 0x71, 0x81, 0x79, 0x09, 0xAD, 0x24, 0xCD, 0xF9, 0xD8,
   0xE5, 0xC5, 0xB9, 0x4D, 0x44, 0x08, 0x86, 0xE7, 0xA1, 0x1D, 0xAA, 0xED,
   0x06, 0x70, 0xB2, 0xD2, 0x41, 0x7B, 0xA0, 0x11, 0x31, 0xC2, 0x27, 0x90,
   0x20, 0xF6, 0x60, 0xFF, 0x96, 0x5C, 0xB1, 0xAB, 0x9E, 0x9C, 0x52, 0x1B,
   0x5F, 0x93, 0x0A, 0xEF, 0x91, 0x85, 0x49, 0xEE, 0x2D, 0x4F, 0x8F, 0x3B,
   0x47, 0x87, 0x6D, 0x46, 0xD6, 0x3E, 0x69, 0x64, 0x2A, 0xCE, 0xCB, 0x2F,
   0xFC, 0x97, 0x05, 0x7A, 0xAC, 0x7F, 0xD5, 0x1A, 0x4B, 0x0E, 0xA7, 0x5A,
   0x28, 0x14, 0x3F, 0x29, 0x88, 0x3C, 0x4C, 0x02, 0xB8, 0xDA, 0xB0, 0x17,
   0x55, 0x1F, 0x8A, 0x7D, 0x57, 0xC7, 0x8D, 0x74, 0xB7, 0xC4, 0x9F, 0x72,
   0x7E, 0x15, 0x22, 0x12, 0x58, 0x07, 0x99, 0x34, 0x6E, 0x50, 0xDE, 0x68,
   0x65, 0xBC, 0xDB, 0xF8, 0xC8, 0xA8, 0x2B, 0x40, 0xDC, 0xFE, 0x32, 0xA4,
   0xCA, 0x10, 0x21, 0xF0, 0xD3, 0x5D, 0x0F, 0x00, 0x6F, 0x9D, 0x36, 0x42,
   0x4A, 0x5E, 0xC1, 0xE0

################################################################################

TITLE
    twofish q1

TYPE
    8

DATA
   0x75, 0xF3, 0xC6, 0xF4, 0xDB, 0x7B, 0xFB, 0xC8, 0x4A, 0xD3, 0xE6, 0x6B,
   0x45, 0x7D, 0xE8, 0x4B, 0xD6, 0x32, 0xD8, 0xFD, 0x37, 0x71, 0xF1, 0xE1,
   0x30, 0x0F, 0xF8, 0x1B, 0x87, 0xFA, 0x06, 0x3F, 0x5E, 0xBA, 0xAE, 0x5B,
   0x8A, 0x00, 0xBC, 0x9D, 0x6D, 0xC1, 0xB1, 0x0E, 0x80, 0x5D, 0xD2, 0xD5,
   0xA0, 0x84, 0x07, 0x14, 0xB5, 0x90, 0x2C, 0xA3, 0xB2, 0x73, 0x4C, 0x54,
   0x92, 0x74, 0x36, 0x51, 0x38, 0xB0, 0xBD, 0x5A, 0xFC, 0x60, 0x62, 0x96,
   0x6C, 0x42, 0xF7, 0x10, 0x7C, 0x28, 0x27, 0x8C, 0x13, 0x95, 0x9C, 0xC7,
   0x24, 0x46, 0x3B, 0x70, 0xCA, 0xE3, 0x85, 0xCB, 0x11, 0xD0, 0x93, 0xB8,
   0xA6, 0x83, 0x20, 0xFF, 0x9F, 0x77, 0xC3, 0xCC, 0x03, 0x6F, 0x08, 0xBF,
   0x40, 0xE7, 0x2B, 0xE2, 0x79, 0x0C, 0xAA, 0x82, 0x41, 0x3A, 0xEA, 0xB9,
   0xE4, 0x9A, 0xA4, 0x97, 0x7E, 0xDA, 0x7A, 0x17, 0x66, 0x94, 0xA1, 0x1D,
   0x3D, 0xF0, 0xDE, 0xB3, 0x0B, 0x72, 0xA7, 0x1C, 0xEF, 0xD1, 0x53, 0x3E,
   0x8F, 0x33, 0x26, 0x5F, 0xEC, 0x76, 0x2A, 0x49, 0x81, 0x88, 0xEE, 0x21,
   0xC4, 0x1A, 0xEB, 0xD9, 0xC5, 0x39, 0x99, 0xCD, 0xAD, 0x31, 0x8B, 0x01,
   0x18, 0x23, 0xDD, 0x1F, 0x4E, 0x2D, 0xF9, 0x48, 0x4F, 0xF2, 0x65, 0x8E,
   0x78, 0x5C, 0x58, 0x19, 0x8D, 0xE5, 0x98, 0x57, 0x67, 0x7F, 0x05, 0x64,
   0xAF, 0x63, 0xB6, 0xFE, 0xF5, 0xB7, 0x3C, 0xA5, 0xCE, 0xE9, 0x68, 0x44,
   0xE0, 0x4D, 0x43, 0x69, 0x29, 0x2E, 0xAC, 0x15, 0x59, 0xA8, 0x0A, 0x9E,
   0x6E, 0x47, 0xDF, 0x34, 0x35, 0x6A, 0xCF, 0xDC, 0x22, 0xC9, 0xC0, 0x9B,
   0x89, 0xD4, 0xED, 0xAB, 0x12, 0xA2, 0x0D, 0x52, 0xBB, 0x02, 0x2F, 0xA9,
   0xD7, 0x61, 0x1E, 0xB4, 0x50, 0x04, 0xF6, 0xC2, 0x16, 0x25, 0x86, 0x56,
   0x55, 0x09, 0xBE, 0x91

################################################################################

TITLE
    twofish poly_to_exp

TYPE
    8

DATA
   0x00, 0x01, 0x17, 0x02, 0x2E, 0x18, 0x53, 0x03, 0x6A, 0x2F, 0x93, 0x19,
   0x34, 0x54, 0x45, 0x04, 0x5C, 0x6B, 0xB6, 0x30, 0xA6, 0x94, 0x4B, 0x1A,
   0x8C, 0x35, 0x81, 0x55, 0xAA, 0x46, 0x0D, 0x05, 0x24, 0x5D, 0x87, 0x6C,
   0x9B, 0xB7, 0xC1, 0x31, 0x2B, 0xA7, 0xA3, 0x95, 0x98, 0x4C, 0xCA, 0x1B,
   0xE6, 0x8D, 0x73, 0x36, 0xCD, 0x82, 0x12, 0x56, 0x62, 0xAB, 0xF0, 0x47,
   0x4F, 0x0E, 0xBD, 0x06, 0xD4, 0x25, 0xD2, 0x5E, 0x27, 0x88, 0x66, 0x6D,
   0xD6, 0x9C, 0x79, 0xB8, 0x08, 0xC2, 0xDF, 0x32, 0x68, 0x2C, 0xFD, 0xA8,
   0x8A, 0xA4, 0x5A, 0x96, 0x29, 0x99, 0x22, 0x4D, 0x60, 0xCB, 0xE4, 0x1C,
   0x7B, 0xE7, 0x3B, 0x8E, 0x9E, 0x74, 0xF4, 0x37, 0xD8, 0xCE, 0xF9, 0x83,
   0x6F, 0x13, 0xB2, 0x57, 0xE1, 0x63, 0xDC, 0xAC, 0xC4, 0xF1, 0xAF, 0x48,
   0x0A, 0x50, 0x42, 0x0F, 0xBA, 0xBE, 0xC7, 0x07, 0xDE, 0xD5, 0x78, 0x26,
   0x65, 0xD3, 0xD1, 0x5F, 0xE3, 0x28, 0x21, 0x89, 0x59, 0x67, 0xFC, 0x6E,
   0xB1, 0xD7, 0xF8, 0x9D, 0xF3, 0x7A, 0x3A, 0xB9, 0xC6, 0x09, 0x41, 0xC3,
   0xAE, 0xE0, 0xDB, 0x33, 0x44, 0x69, 0x92, 0x2D, 0x52, 0xFE, 0x16, 0xA9,
   0x0C, 0x8B, 0x80, 0xA5, 0x4A, 0x5B, 0xB5, 0x97, 0xC9, 0x2A, 0xA2, 0x9A,
   0xC0, 0x23, 0x86, 0x4E, 0xBC, 0x61, 0xEF, 0xCC, 0x11, 0xE5, 0x72, 0x1D,
   0x3D, 0x7C, 0xEB, 0xE8, 0xE9, 0x3C, 0xEA, 0x8F, 0x7D, 0x9F, 0xEC, 0x75,
   0x1E, 0xF5, 0x3E, 0x38, 0xF6, 0xD9, 0x3F, 0xCF, 0x76, 0xFA, 0x1F, 0x84,
   0xA0, 0x70, 0xED, 0x14, 0x90, 0xB3, 0x7E, 0x58, 0xFB, 0xE2, 0x20, 0x64,
   0xD0, 0xDD, 0x77, 0xAD, 0xDA, 0xC5, 0x40, 0xF2, 0x39, 0xB0, 0xF7, 0x49,
   0xB4, 0x0B, 0x7F, 0x51, 0x15, 0x43, 0x91, 0x10, 0x71, 0xBB, 0xEE, 0xBF,
   0x85, 0xC8, 0xA1

################################################################################

TITLE
    twofish exp_to_poly

TYPE
    8

DATA
   0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x4D, 0x9A, 0x79, 0xF2,
   0xA9, 0x1F, 0x3E, 0x7C, 0xF8, 0xBD, 0x37, 0x6E, 0xDC, 0xF5, 0xA7, 0x03,
   0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0xCD, 0xD7, 0xE3, 0x8B, 0x5B, 0xB6,
   0x21, 0x42, 0x84, 0x45, 0x8A, 0x59, 0xB2, 0x29, 0x52, 0xA4, 0x05, 0x0A,
   0x14, 0x28, 0x50, 0xA0, 0x0D, 0x1A, 0x34, 0x68, 0xD0, 0xED, 0x97, 0x63,
   0xC6, 0xC1, 0xCF, 0xD3, 0xEB, 0x9B, 0x7B, 0xF6, 0xA1, 0x0F, 0x1E, 0x3C,
   0x78, 0xF0, 0xAD, 0x17, 0x2E, 0x5C, 0xB8, 0x3D, 0x7A, 0xF4, 0xA5, 0x07,
   0x0E, 0x1C, 0x38, 0x70, 0xE0, 0x8D, 0x57, 0xAE, 0x11, 0x22, 0x44, 0x88,
   0x5D, 0xBA, 0x39, 0x72, 0xE4, 0x85, 0x47, 0x8E, 0x51, 0xA2, 0x09, 0x12,
   0x24, 0x48, 0x90, 0x6D, 0xDA, 0xF9, 0xBF, 0x33, 0x66, 0xCC, 0xD5, 0xE7,
   0x83, 0x4B, 0x96, 0x61, 0xC2, 0xC9, 0xDF, 0xF3, 0xAB, 0x1B, 0x36, 0x6C,
   0xD8, 0xFD, 0xB7, 0x23, 0x46, 0x8C, 0x55, 0xAA, 0x19, 0x32, 0x64, 0xC8,
   0xDD, 0xF7, 0xA3, 0x0B, 0x16, 0x2C, 0x58, 0xB0, 0x2D, 0x5A, 0xB4, 0x25,
   0x4A, 0x94, 0x65, 0xCA, 0xD9, 0xFF, 0xB3, 0x2B, 0x56, 0xAC, 0x15, 0x2A,
   0x54, 0xA8, 0x1D, 0x3A, 0x74, 0xE8, 0x9D, 0x77, 0xEE, 0x91, 0x6F, 0xDE,
   0xF1, 0xAF, 0x13, 0x26, 0x4C, 0x98, 0x7D, 0xFA, 0xB9, 0x3F, 0x7E, 0xFC,
   0xB5, 0x27, 0x4E, 0x9C, 0x75, 0xEA, 0x99, 0x7F, 0xFE, 0xB1, 0x2F, 0x5E,
   0xBC, 0x35, 0x6A, 0xD4, 0xE5, 0x87, 0x43, 0x86, 0x41, 0x82, 0x49, 0x92,
   0x69, 0xD2, 0xE9, 0x9F, 0x73, 0xE6, 0x81, 0x4F, 0x9E, 0x71, 0xE2, 0x89,
   0x5F, 0xBE, 0x31, 0x62, 0xC4, 0xC5, 0xC7, 0xC3, 0xCB, 0xDB, 0xFB, 0xBB,
   0x3B, 0x76, 0xEC, 0x95, 0x67, 0xCE, 0xD1, 0xEF, 0x93, 0x6B, 0xD6, 0xE1,
   0x8F, 0x53, 0xA6, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x4D,
   0x9A, 0x79, 0xF2, 0xA9, 0x1F, 0x3E, 0x7C, 0xF8, 0xBD, 0x37, 0x6E, 0xDC,
   0xF5, 0xA7, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0xCD, 0xD7, 0xE3,
   0x8B, 0x5B, 0xB6, 0x21, 0x42, 0x84, 0x45, 0x8A, 0x59, 0xB2, 0x29, 0x52,
   0xA4, 0x05, 0x0A, 0x14, 0x28, 0x50, 0xA0, 0x0D, 0x1A, 0x34, 0x68, 0xD0,
   0xED, 0x97, 0x63, 0xC6, 0xC1, 0xCF, 0xD3, 0xEB, 0x9B, 0x7B, 0xF6, 0xA1,
   0x0F, 0x1E, 0x3C, 0x78, 0xF0, 0xAD, 0x17, 0x2E, 0x5C, 0xB8, 0x3D, 0x7A,
   0xF4, 0xA5, 0x07, 0x0E, 0x1C, 0x38, 0x70, 0xE0, 0x8D, 0x57, 0xAE, 0x11,
   0x22, 0x44, 0x88, 0x5D, 0xBA, 0x39, 0x72, 0xE4, 0x85, 0x47, 0x8E, 0x51,
   0xA2, 0x09, 0x12, 0x24, 0x48, 0x90, 0x6D, 0xDA, 0xF9, 0xBF, 0x33, 0x66,
   0xCC, 0xD5, 0xE7, 0x83, 0x4B, 0x96, 0x61, 0xC2, 0xC9, 0xDF, 0xF3, 0xAB,
   0x1B, 0x36, 0x6C, 0xD8, 0xFD, 0xB7, 0x23, 0x46, 0x8C, 0x55, 0xAA, 0x19,
   0x32, 0x64, 0xC8, 0xDD, 0xF7, 0xA3, 0x0B, 0x16, 0x2C, 0x58, 0xB0, 0x2D,
   0x5A, 0xB4, 0x25, 0x4A, 0x94, 0x65, 0xCA, 0xD9, 0xFF, 0xB3, 0x2B, 0x56,
   0xAC, 0x15, 0x2A, 0x54, 0xA8, 0x1D, 0x3A, 0x74, 0xE8, 0x9D, 0x77, 0xEE,
   0x91, 0x6F, 0xDE, 0xF1, 0xAF, 0x13, 0x26, 0x4C, 0x98, 0x7D, 0xFA, 0xB9,
   0x3F, 0x7E, 0xFC, 0xB5, 0x27, 0x4E, 0x9C, 0x75, 0xEA, 0x99, 0x7F, 0xFE,
   0xB1, 0x2F, 0x5E, 0xBC, 0x35, 0x6A, 0xD4, 0xE5, 0x87, 0x43, 0x86, 0x41,
   0x82, 0x49, 0x92, 0x69, 0xD2, 0xE9, 0x9F, 0x73, 0xE6, 0x81, 0x4F, 0x9E,
   0x71, 0xE2, 0x89, 0x5F, 0xBE, 0x31, 0x62, 0xC4, 0xC5, 0xC7, 0xC3, 0xCB

################################################################################

TITLE
    twofish calc_sb_tbl

TYPE
    8

DATA
    0xA9, 0x75, 0x67, 0xF3, 0xB3, 0xC6, 0xE8, 0xF4,
    0x04, 0xDB, 0xFD, 0x7B, 0xA3, 0xFB, 0x76, 0xC8,
    0x9A, 0x4A, 0x92, 0xD3, 0x80, 0xE6, 0x78, 0x6B,
    0xE4, 0x45, 0xDD, 0x7D, 0xD1, 0xE8, 0x38, 0x4B,
    0x0D, 0xD6, 0xC6, 0x32, 0x35, 0xD8, 0x98, 0xFD,
    0x18, 0x37, 0xF7, 0x71, 0xEC, 0xF1, 0x6C, 0xE1,
    0x43, 0x30, 0x75, 0x0F, 0x37, 0xF8, 0x26, 0x1B,
    0xFA, 0x87, 0x13, 0xFA, 0x94, 0x06, 0x48, 0x3F,
    0xF2, 0x5E, 0xD0, 0xBA, 0x8B, 0xAE, 0x30, 0x5B,
    0x84, 0x8A, 0x54, 0x00, 0xDF, 0xBC, 0x23, 0x9D,
    0x19, 0x6D, 0x5B, 0xC1, 0x3D, 0xB1, 0x59, 0x0E,
    0xF3, 0x80, 0xAE, 0x5D, 0xA2, 0xD2, 0x82, 0xD5,
    0x63, 0xA0, 0x01, 0x84, 0x83, 0x07, 0x2E, 0x14,
    0xD9, 0xB5, 0x51, 0x90, 0x9B, 0x2C, 0x7C, 0xA3,
    0xA6, 0xB2, 0xEB, 0x73, 0xA5, 0x4C, 0xBE, 0x54,
    0x16, 0x92, 0x0C, 0x74, 0xE3, 0x36, 0x61, 0x51,
    0xC0, 0x38, 0x8C, 0xB0, 0x3A, 0xBD, 0xF5, 0x5A,
    0x73, 0xFC, 0x2C, 0x60, 0x25, 0x62, 0x0B, 0x96,
    0xBB, 0x6C, 0x4E, 0x42, 0x89, 0xF7, 0x6B, 0x10,
    0x53, 0x7C, 0x6A, 0x28, 0xB4, 0x27, 0xF1, 0x8C,
    0xE1, 0x13, 0xE6, 0x95, 0xBD, 0x9C, 0x45, 0xC7,
    0xE2, 0x24, 0xF4, 0x46, 0xB6, 0x3B, 0x66, 0x70,
    0xCC, 0xCA, 0x95, 0xE3, 0x03, 0x85, 0x56, 0xCB,
    0xD4, 0x11, 0x1C, 0xD0, 0x1E, 0x93, 0xD7, 0xB8,
    0xFB, 0xA6, 0xC3, 0x83, 0x8E, 0x20, 0xB5, 0xFF,
    0xE9, 0x9F, 0xCF, 0x77, 0xBF, 0xC3, 0xBA, 0xCC,
    0xEA, 0x03, 0x77, 0x6F, 0x39, 0x08, 0xAF, 0xBF,
    0x33, 0x40, 0xC9, 0xE7, 0x62, 0x2B, 0x71, 0xE2,
    0x81, 0x79, 0x79, 0x0C, 0x09, 0xAA, 0xAD, 0x82,
    0x24, 0x41, 0xCD, 0x3A, 0xF9, 0xEA, 0xD8, 0xB9,
    0xE5, 0xE4, 0xC5, 0x9A, 0xB9, 0xA4, 0x4D, 0x97,
    0x44, 0x7E, 0x08, 0xDA, 0x86, 0x7A, 0xE7, 0x17,
    0xA1, 0x66, 0x1D, 0x94, 0xAA, 0xA1, 0xED, 0x1D,
    0x06, 0x3D, 0x70, 0xF0, 0xB2, 0xDE, 0xD2, 0xB3,
    0x41, 0x0B, 0x7B, 0x72, 0xA0, 0xA7, 0x11, 0x1C,
    0x31, 0xEF, 0xC2, 0xD1, 0x27, 0x53, 0x90, 0x3E,
    0x20, 0x8F, 0xF6, 0x33, 0x60, 0x26, 0xFF, 0x5F,
    0x96, 0xEC, 0x5C, 0x76, 0xB1, 0x2A, 0xAB, 0x49,
    0x9E, 0x81, 0x9C, 0x88, 0x52, 0xEE, 0x1B, 0x21,
    0x5F, 0xC4, 0x93, 0x1A, 0x0A, 0xEB, 0xEF, 0xD9,
    0x91, 0xC5, 0x85, 0x39, 0x49, 0x99, 0xEE, 0xCD,
    0x2D, 0xAD, 0x4F, 0x31, 0x8F, 0x8B, 0x3B, 0x01,
    0x47, 0x18, 0x87, 0x23, 0x6D, 0xDD, 0x46, 0x1F,
    0xD6, 0x4E, 0x3E, 0x2D, 0x69, 0xF9, 0x64, 0x48,
    0x2A, 0x4F, 0xCE, 0xF2, 0xCB, 0x65, 0x2F, 0x8E,
    0xFC, 0x78, 0x97, 0x5C, 0x05, 0x58, 0x7A, 0x19,
    0xAC, 0x8D, 0x7F, 0xE5, 0xD5, 0x98, 0x1A, 0x57,
    0x4B, 0x67, 0x0E, 0x7F, 0xA7, 0x05, 0x5A, 0x64,
    0x28, 0xAF, 0x14, 0x63, 0x3F, 0xB6, 0x29, 0xFE,
    0x88, 0xF5, 0x3C, 0xB7, 0x4C, 0x3C, 0x02, 0xA5,
    0xB8, 0xCE, 0xDA, 0xE9, 0xB0, 0x68, 0x17, 0x44,
    0x55, 0xE0, 0x1F, 0x4D, 0x8A, 0x43, 0x7D, 0x69,
    0x57, 0x29, 0xC7, 0x2E, 0x8D, 0xAC, 0x74, 0x15,
    0xB7, 0x59, 0xC4, 0xA8, 0x9F, 0x0A, 0x72, 0x9E,
    0x7E, 0x6E, 0x15, 0x47, 0x22, 0xDF, 0x12, 0x34,
    0x58, 0x35, 0x07, 0x6A, 0x99, 0xCF, 0x34, 0xDC,
    0x6E, 0x22, 0x50, 0xC9, 0xDE, 0xC0, 0x68, 0x9B,
    0x65, 0x89, 0xBC, 0xD4, 0xDB, 0xED, 0xF8, 0xAB,
    0xC8, 0x12, 0xA8, 0xA2, 0x2B, 0x0D, 0x40, 0x52,
    0xDC, 0xBB, 0xFE, 0x02, 0x32, 0x2F, 0xA4, 0xA9,
    0xCA, 0xD7, 0x10, 0x61, 0x21, 0x1E, 0xF0, 0xB4,
    0xD3, 0x50, 0x5D, 0x04, 0x0F, 0xF6, 0x00, 0xC2,
    0x6F, 0x16, 0x9D, 0x25, 0x36, 0x86, 0x42, 0x56,
    0x4A, 0x55, 0x5E, 0x09, 0xC1, 0xBE, 0xE0, 0x91

################################################################################

TITLE
    small prime numbers used in libgcrypt

TYPE
    16

DATA
    3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43,
    47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101,
    103, 107, 109, 113, 127, 131, 137, 139, 149, 151,
    157, 163, 167, 173, 179, 181, 191, 193, 197, 199,
    211, 223, 227, 229, 233, 239, 241, 251, 257, 263,
    269, 271, 277, 281, 283, 293, 307, 311, 313, 317,
    331, 337, 347, 349, 353, 359, 367, 373, 379, 383,
    389, 397, 401, 409, 419, 421, 431, 433, 439, 443,
    449, 457, 461, 463, 467, 479, 487, 491, 499, 503,
    509, 521, 523, 541, 547, 557, 563, 569, 571, 577,
    587, 593, 599, 601, 607, 613, 617, 619, 631, 641,
    643, 647, 653, 659, 661, 673, 677, 683, 691, 701,
    709, 719, 727, 733, 739, 743, 751, 757, 761, 769,
    773, 787, 797, 809, 811, 821, 823, 827, 829, 839,
    853, 857, 859, 863, 877, 881, 883, 887, 907, 911,
    919, 929, 937, 941, 947, 953, 967, 971, 977, 983,
    991, 997, 1009, 1013, 1019, 1021, 1031, 1033,
    1039, 1049, 1051, 1061, 1063, 1069, 1087, 1091,
    1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151,
    1153, 1163, 1171, 1181, 1187, 1193, 1201, 1213,
    1217, 1223, 1229, 1231, 1237, 1249, 1259, 1277,
    1279, 1283, 1289, 1291, 1297, 1301, 1303, 1307,
    1319, 1321, 1327, 1361, 1367, 1373, 1381, 1399,
    1409, 1423, 1427, 1429, 1433, 1439, 1447, 1451,
    1453, 1459, 1471, 1481, 1483, 1487, 1489, 1493,
    1499, 1511, 1523, 1531, 1543, 1549, 1553, 1559,
    1567, 1571, 1579, 1583, 1597, 1601, 1607, 1609,
    1613, 1619, 1621, 1627, 1637, 1657, 1663, 1667,
    1669, 1693, 1697, 1699, 1709, 1721, 1723, 1733,
    1741, 1747, 1753, 1759, 1777, 1783, 1787, 1789,
    1801, 1811, 1823, 1831, 1847, 1861, 1867, 1871,
    1873, 1877, 1879, 1889, 1901, 1907, 1913, 1931,
    1933, 1949, 1951, 1973, 1979, 1987, 1993, 1997,
    1999, 2003, 2011, 2017, 2027, 2029, 2039, 2053,
    2063, 2069, 2081, 2083, 2087, 2089, 2099, 2111,
    2113, 2129, 2131, 2137, 2141, 2143, 2153, 2161,
    2179, 2203, 2207, 2213, 2221, 2237, 2239, 2243,
    2251, 2267, 2269, 2273, 2281, 2287, 2293, 2297,
    2309, 2311, 2333, 2339, 2341, 2347, 2351, 2357,
    2371, 2377, 2381, 2383, 2389, 2393, 2399, 2411,
    2417, 2423, 2437, 2441, 2447, 2459, 2467, 2473,
    2477, 2503, 2521, 2531, 2539, 2543, 2549, 2551,
    2557, 2579, 2591, 2593, 2609, 2617, 2621, 2633,
    2647, 2657, 2659, 2663, 2671, 2677, 2683, 2687,
    2689, 2693, 2699, 2707, 2711, 2713, 2719, 2729,
    2731, 2741, 2749, 2753, 2767, 2777, 2789, 2791,
    2797, 2801, 2803, 2819, 2833, 2837, 2843, 2851,
    2857, 2861, 2879, 2887, 2897, 2903, 2909, 2917,
    2927, 2939, 2953, 2957, 2963, 2969, 2971, 2999,
    3001, 3011, 3019, 3023, 3037, 3041, 3049, 3061,
    3067, 3079, 3083, 3089, 3109, 3119, 3121, 3137,
    3163, 3167, 3169, 3181, 3187, 3191, 3203, 3209,
    3217, 3221, 3229, 3251, 3253, 3257, 3259, 3271,
    3299, 3301, 3307, 3313, 3319, 3323, 3329, 3331,
    3343, 3347, 3359, 3361, 3371, 3373, 3389, 3391,
    3407, 3413, 3433, 3449, 3457, 3461, 3463, 3467,
    3469, 3491, 3499, 3511, 3517, 3527, 3529, 3533,
    3539, 3541, 3547, 3557, 3559, 3571, 3581, 3583,
    3593, 3607, 3613, 3617, 3623, 3631, 3637, 3643,
    3659, 3671, 3673, 3677, 3691, 3697, 3701, 3709,
    3719, 3727, 3733, 3739, 3761, 3767, 3769, 3779,
    3793, 3797, 3803, 3821, 3823, 3833, 3847, 3851,
    3853, 3863, 3877, 3881, 3889, 3907, 3911, 3917,
    3919, 3923, 3929, 3931, 3943, 3947, 3967, 3989,
    4001, 4003, 4007, 4013, 4019, 4021, 4027, 4049,
    4051, 4057, 4073, 4079, 4091, 4093, 4099, 4111,
    4127, 4129, 4133, 4139, 4153, 4157, 4159, 4177,
    4201, 4211, 4217, 4219, 4229, 4231, 4241, 4243,
    4253, 4259, 4261, 4271, 4273, 4283, 4289, 4297,
    4327, 4337, 4339, 4349, 4357, 4363, 4373, 4391,
    4397, 4409, 4421, 4423, 4441, 4447, 4451, 4457,
    4463, 4481, 4483, 4493, 4507, 4513, 4517, 4519,
    4523, 4547, 4549, 4561, 4567, 4583, 4591, 4597,
    4603, 4621, 4637, 4639, 4643, 4649, 4651, 4657,
    4663, 4673, 4679, 4691, 4703, 4721, 4723, 4729,
    4733, 4751, 4759, 4783, 4787, 4789, 4793, 4799,
    4801, 4813, 4817, 4831, 4861, 4871, 4877, 4889,
    4903, 4909, 4919, 4931, 4933, 4937, 4943, 4951,
    4957, 4967, 4969, 4973, 4987, 4993, 4999,

################################################################################

TITLE
    Serpent crypto SBox

TYPE
    8

DATA
	{ 3, 8,15, 1,10, 6, 5,11,14,13, 4, 2, 7, 0, 9,12 },/* S0: */
	{15,12, 2, 7, 9, 0, 5,10, 1,11,14, 8, 6,13, 3, 4 },/* S1: */
	{ 8, 6, 7, 9, 3,12,10,15,13, 1,14, 4, 0,11, 5, 2 },/* S2: */
	{ 0,15,11, 8,12, 9, 6, 3,13, 1, 2, 4,10, 7, 5,14 },/* S3: */
	{ 1,15, 8, 3,12, 0,11, 6, 2, 5, 4,10, 9,14, 7,13 },/* S4: */
	{15, 5, 2,11, 4,10, 9,12, 0, 3,14, 8,13, 6, 7, 1 },/* S5: */
	{ 7, 2,12, 5, 8, 4, 6,11,14, 9, 1,15,13, 3,10, 0 },/* S6: */
	{ 1,13,15, 0,14, 8, 2,11, 7, 4,12,10, 9, 3, 5, 6 },/* S7: */
	{ 3, 8,15, 1,10, 6, 5,11,14,13, 4, 2, 7, 0, 9,12 },/* S0: */
	{15,12, 2, 7, 9, 0, 5,10, 1,11,14, 8, 6,13, 3, 4 },/* S1: */
	{ 8, 6, 7, 9, 3,12,10,15,13, 1,14, 4, 0,11, 5, 2 },/* S2: */
	{ 0,15,11, 8,12, 9, 6, 3,13, 1, 2, 4,10, 7, 5,14 },/* S3: */
	{ 1,15, 8, 3,12, 0,11, 6, 2, 5, 4,10, 9,14, 7,13 },/* S4: */
	{15, 5, 2,11, 4,10, 9,12, 0, 3,14, 8,13, 6, 7, 1 },/* S5: */
	{ 7, 2,12, 5, 8, 4, 6,11,14, 9, 1,15,13, 3,10, 0 },/* S6: */
	{ 1,13,15, 0,14, 8, 2,11, 7, 4,12,10, 9, 3, 5, 6 },/* S7: */
	{ 3, 8,15, 1,10, 6, 5,11,14,13, 4, 2, 7, 0, 9,12 },/* S0: */
	{15,12, 2, 7, 9, 0, 5,10, 1,11,14, 8, 6,13, 3, 4 },/* S1: */
	{ 8, 6, 7, 9, 3,12,10,15,13, 1,14, 4, 0,11, 5, 2 },/* S2: */
	{ 0,15,11, 8,12, 9, 6, 3,13, 1, 2, 4,10, 7, 5,14 },/* S3: */
	{ 1,15, 8, 3,12, 0,11, 6, 2, 5, 4,10, 9,14, 7,13 },/* S4: */
	{15, 5, 2,11, 4,10, 9,12, 0, 3,14, 8,13, 6, 7, 1 },/* S5: */
	{ 7, 2,12, 5, 8, 4, 6,11,14, 9, 1,15,13, 3,10, 0 },/* S6: */
	{ 1,13,15, 0,14, 8, 2,11, 7, 4,12,10, 9, 3, 5, 6 },/* S7: */
	{ 3, 8,15, 1,10, 6, 5,11,14,13, 4, 2, 7, 0, 9,12 },/* S0: */
	{15,12, 2, 7, 9, 0, 5,10, 1,11,14, 8, 6,13, 3, 4 },/* S1: */
	{ 8, 6, 7, 9, 3,12,10,15,13, 1,14, 4, 0,11, 5, 2 },/* S2: */
	{ 0,15,11, 8,12, 9, 6, 3,13, 1, 2, 4,10, 7, 5,14 },/* S3: */
	{ 1,15, 8, 3,12, 0,11, 6, 2, 5, 4,10, 9,14, 7,13 },/* S4: */
	{15, 5, 2,11, 4,10, 9,12, 0, 3,14, 8,13, 6, 7, 1 },/* S5: */
	{ 7, 2,12, 5, 8, 4, 6,11,14, 9, 1,15,13, 3,10, 0 },/* S6: */
	{ 1,13,15, 0,14, 8, 2,11, 7, 4,12,10, 9, 3, 5, 6 } /* S7: */

################################################################################

TITLE
    Serpent crypto SBoxInverse

TYPE
    8

DATA
	{13, 3,11, 0,10, 6, 5,12, 1,14, 4, 7,15, 9, 8, 2 },/* InvS0: */
	{ 5, 8, 2,14,15, 6,12, 3,11, 4, 7, 9, 1,13,10, 0 },/* InvS1: */
	{12, 9,15, 4,11,14, 1, 2, 0, 3, 6,13, 5, 8,10, 7 },/* InvS2: */
	{ 0, 9,10, 7,11,14, 6,13, 3, 5,12, 2, 4, 8,15, 1 },/* InvS3: */
	{ 5, 0, 8, 3,10, 9, 7,14, 2,12,11, 6, 4,15,13, 1 },/* InvS4: */
	{ 8,15, 2, 9, 4, 1,13,14,11, 6, 5, 3, 7,12,10, 0 },/* InvS5: */
	{15,10, 1,13, 5, 3, 6, 0, 4, 9,14, 7, 2,12, 8,11 },/* InvS6: */
	{ 3, 0, 6,13, 9,14,15, 8, 5,12,11, 7,10, 1, 4, 2 },/* InvS7: */
	{13, 3,11, 0,10, 6, 5,12, 1,14, 4, 7,15, 9, 8, 2 },/* InvS0: */
	{ 5, 8, 2,14,15, 6,12, 3,11, 4, 7, 9, 1,13,10, 0 },/* InvS1: */
	{12, 9,15, 4,11,14, 1, 2, 0, 3, 6,13, 5, 8,10, 7 },/* InvS2: */
	{ 0, 9,10, 7,11,14, 6,13, 3, 5,12, 2, 4, 8,15, 1 },/* InvS3: */
	{ 5, 0, 8, 3,10, 9, 7,14, 2,12,11, 6, 4,15,13, 1 },/* InvS4: */
	{ 8,15, 2, 9, 4, 1,13,14,11, 6, 5, 3, 7,12,10, 0 },/* InvS5: */
	{15,10, 1,13, 5, 3, 6, 0, 4, 9,14, 7, 2,12, 8,11 },/* InvS6: */
	{ 3, 0, 6,13, 9,14,15, 8, 5,12,11, 7,10, 1, 4, 2 },/* InvS7: */
	{13, 3,11, 0,10, 6, 5,12, 1,14, 4, 7,15, 9, 8, 2 },/* InvS0: */
	{ 5, 8, 2,14,15, 6,12, 3,11, 4, 7, 9, 1,13,10, 0 },/* InvS1: */
	{12, 9,15, 4,11,14, 1, 2, 0, 3, 6,13, 5, 8,10, 7 },/* InvS2: */
	{ 0, 9,10, 7,11,14, 6,13, 3, 5,12, 2, 4, 8,15, 1 },/* InvS3: */
	{ 5, 0, 8, 3,10, 9, 7,14, 2,12,11, 6, 4,15,13, 1 },/* InvS4: */
	{ 8,15, 2, 9, 4, 1,13,14,11, 6, 5, 3, 7,12,10, 0 },/* InvS5: */
	{15,10, 1,13, 5, 3, 6, 0, 4, 9,14, 7, 2,12, 8,11 },/* InvS6: */
	{ 3, 0, 6,13, 9,14,15, 8, 5,12,11, 7,10, 1, 4, 2 },/* InvS7: */
	{13, 3,11, 0,10, 6, 5,12, 1,14, 4, 7,15, 9, 8, 2 },/* InvS0: */
	{ 5, 8, 2,14,15, 6,12, 3,11, 4, 7, 9, 1,13,10, 0 },/* InvS1: */
	{12, 9,15, 4,11,14, 1, 2, 0, 3, 6,13, 5, 8,10, 7 },/* InvS2: */
	{ 0, 9,10, 7,11,14, 6,13, 3, 5,12, 2, 4, 8,15, 1 },/* InvS3: */
	{ 5, 0, 8, 3,10, 9, 7,14, 2,12,11, 6, 4,15,13, 1 },/* InvS4: */
	{ 8,15, 2, 9, 4, 1,13,14,11, 6, 5, 3, 7,12,10, 0 },/* InvS5: */
	{15,10, 1,13, 5, 3, 6, 0, 4, 9,14, 7, 2,12, 8,11 },/* InvS6: */
	{ 3, 0, 6,13, 9,14,15, 8, 5,12,11, 7,10, 1, 4, 2 } /* InvS7: */

################################################################################

TITLE
    Serpent crypto IPTable

TYPE
    8 32

DATA
    0, 32, 64, 96, 1, 33, 65, 97, 2, 34, 66, 98, 3, 35, 67, 99,
    4, 36, 68, 100, 5, 37, 69, 101, 6, 38, 70, 102, 7, 39, 71, 103,
    8, 40, 72, 104, 9, 41, 73, 105, 10, 42, 74, 106, 11, 43, 75, 107,
    12, 44, 76, 108, 13, 45, 77, 109, 14, 46, 78, 110, 15, 47, 79, 111,
    16, 48, 80, 112, 17, 49, 81, 113, 18, 50, 82, 114, 19, 51, 83, 115,
    20, 52, 84, 116, 21, 53, 85, 117, 22, 54, 86, 118, 23, 55, 87, 119,
    24, 56, 88, 120, 25, 57, 89, 121, 26, 58, 90, 122, 27, 59, 91, 123,
    28, 60, 92, 124, 29, 61, 93, 125, 30, 62, 94, 126, 31, 63, 95, 127

################################################################################

TITLE
    Serpent crypto FPTable

TYPE
    8 32

DATA
    0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60,
    64, 68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120, 124,
    1, 5, 9, 13, 17, 21, 25, 29, 33, 37, 41, 45, 49, 53, 57, 61,
    65, 69, 73, 77, 81, 85, 89, 93, 97, 101, 105, 109, 113, 117, 121, 125,
    2, 6, 10, 14, 18, 22, 26, 30, 34, 38, 42, 46, 50, 54, 58, 62,
    66, 70, 74, 78, 82, 86, 90, 94, 98, 102, 106, 110, 114, 118, 122, 126,
    3, 7, 11, 15, 19, 23, 27, 31, 35, 39, 43, 47, 51, 55, 59, 63,
    67, 71, 75, 79, 83, 87, 91, 95, 99, 103, 107, 111, 115, 119, 123, 127

################################################################################

TITLE
    ElGamal public key encryption (qbits)

TYPE
    16,32
DATA
    0x0077,0x0091,0x00a5,0x00b7,0x00c6,0x00d4,0x00e1,0x00ed,0x00f9,0x0103,0x010d,0x0117,0x0120,0x0128,0x0131,0x0139,
    0x0140,0x0148,0x014f,

################################################################################

TITLE
    ElGamal public key encryption

TYPE
    32

DATA
      {  512, 119 },	/* 9 x 10^17 */
      {  768, 145 },	/* 6 x 10^21 */
      { 1024, 165 },	/* 7 x 10^24 */
      { 1280, 183 },	/* 3 x 10^27 */
      { 1536, 198 },	/* 7 x 10^29 */
      { 1792, 212 },	/* 9 x 10^31 */
      { 2048, 225 },	/* 8 x 10^33 */
      { 2304, 237 },	/* 5 x 10^35 */
      { 2560, 249 },	/* 3 x 10^37 */
      { 2816, 259 },	/* 1 x 10^39 */
      { 3072, 269 },	/* 3 x 10^40 */
      { 3328, 279 },	/* 8 x 10^41 */
      { 3584, 288 },	/* 2 x 10^43 */
      { 3840, 296 },	/* 4 x 10^44 */
      { 4096, 305 },	/* 7 x 10^45 */
      { 4352, 313 },	/* 1 x 10^47 */
      { 4608, 320 },	/* 2 x 10^48 */
      { 4864, 328 },	/* 2 x 10^49 */
      { 5120, 335 },	/* 3 x 10^50 */

################################################################################

TITLE
    FFT and FHT routines rv_tbl

TYPE
    8 16

DATA
    0x00, 0x80, 0x40, 0xc0, 0x20, 0xa0, 0x60, 0xe0,
    0x10, 0x90, 0x50, 0xd0, 0x30, 0xb0, 0x70, 0xf0,
    0x08, 0x88, 0x48, 0xc8, 0x28, 0xa8, 0x68, 0xe8,
    0x18, 0x98, 0x58, 0xd8, 0x38, 0xb8, 0x78, 0xf8,
    0x04, 0x84, 0x44, 0xc4, 0x24, 0xa4, 0x64, 0xe4,
    0x14, 0x94, 0x54, 0xd4, 0x34, 0xb4, 0x74, 0xf4,
    0x0c, 0x8c, 0x4c, 0xcc, 0x2c, 0xac, 0x6c, 0xec,
    0x1c, 0x9c, 0x5c, 0xdc, 0x3c, 0xbc, 0x7c, 0xfc,
    0x02, 0x82, 0x42, 0xc2, 0x22, 0xa2, 0x62, 0xe2,
    0x12, 0x92, 0x52, 0xd2, 0x32, 0xb2, 0x72, 0xf2,
    0x0a, 0x8a, 0x4a, 0xca, 0x2a, 0xaa, 0x6a, 0xea,
    0x1a, 0x9a, 0x5a, 0xda, 0x3a, 0xba, 0x7a, 0xfa,
    0x06, 0x86, 0x46, 0xc6, 0x26, 0xa6, 0x66, 0xe6,
    0x16, 0x96, 0x56, 0xd6, 0x36, 0xb6, 0x76, 0xf6,
    0x0e, 0x8e, 0x4e, 0xce, 0x2e, 0xae, 0x6e, 0xee,
    0x1e, 0x9e, 0x5e, 0xde, 0x3e, 0xbe, 0x7e, 0xfe

################################################################################

TITLE
    ReplayGainAnalysis ABButter

TYPE
    FLOAT

DATA
    {0.98621192462708, -1.97223372919527, -1.97242384925416, 0.97261396931306, 0.98621192462708},
    {0.98500175787242, -1.96977855582618, -1.97000351574484, 0.97022847566350, 0.98500175787242},
    {0.97938932735214, -1.95835380975398, -1.95877865470428, 0.95920349965459, 0.97938932735214},
    {0.97531843204928, -1.95002759149878, -1.95063686409857, 0.95124613669835, 0.97531843204928},
    {0.97316523498161, -1.94561023566527, -1.94633046996323, 0.94705070426118, 0.97316523498161},
    {0.96454515552826, -1.92783286977036, -1.92909031105652, 0.93034775234268, 0.96454515552826},
    {0.96009142950541, -1.91858953033784, -1.92018285901082, 0.92177618768381, 0.96009142950541},
    {0.95856916599601, -1.91542108074780, -1.91713833199203, 0.91885558323625, 0.95856916599601},
    {0.94597685600279, -1.88903307939452, -1.89195371200558, 0.89487434461664, 0.94597685600279}

################################################################################

TITLE
    id3tag genre_alpha_map

TYPE
    8 32

DATA
    123, 34, 74, 73, 99, 20, 40, 26, 145, 90, 116, 41, 135, 85, 96, 138, 89, 0,
    107, 132, 65, 88, 104, 102, 97, 136, 61, 141, 32, 1, 112, 128, 57, 140, 2,
    139, 58, 3, 125, 50, 22, 4, 55, 127, 122, 120, 98, 52, 48, 54, 124, 25, 84,
    80, 115, 81, 119, 5, 30, 36, 59, 126, 38, 49, 91, 6, 129, 79, 137, 7, 35,
    100, 131, 19, 33, 46, 47, 8, 29, 146, 63, 86, 71, 45, 142, 9, 77, 82, 64,
    133, 10, 66, 39, 11, 103, 12, 75, 134, 13, 53, 62, 109, 117, 23, 108, 92,
    67, 93, 43, 121, 15, 68, 14, 16, 76, 87, 118, 17, 78, 143, 114, 110, 69, 21,
    111, 95, 105, 42, 37, 24, 56, 44, 101, 83, 94, 106, 147, 113, 18, 51, 130,
    144, 60, 70, 31, 72, 27, 28

################################################################################

TITLE
    Lame freq_map

TYPE
    32

DATA
        {8, 2000},
        {16, 3700},
        {24, 3900},
        {32, 5500},
        {40, 7000},
        {48, 7500},
        {56, 10000},
        {64, 11000},
        {80, 13500},
        {96, 15100},
        {112, 15600},
        {128, 17000},
        {160, 17500},
        {192, 18600},
        {224, 19400},
        {256, 19700},
        {320, 20500}

################################################################################

TITLE
    Lame MP3 window subband -> mdct routine win

TYPE
    FLOAT

DATA
     2.382191739347913e-13,
     6.423305872147834e-13,
     9.400849094049688e-13,
     1.122435026096556e-12,
     1.183840321267481e-12,
     1.122435026096556e-12,
     9.400849094049690e-13,
     6.423305872147839e-13,
     2.382191739347918e-13,

     5.456116108943412e-12,
     4.878985199565852e-12,
     4.240448995017367e-12,
     3.559909094758252e-12,
     2.858043359288075e-12,
     2.156177623817898e-12,
     1.475637723558783e-12,
     8.371015190102974e-13,
     2.599706096327376e-13,

     -5.456116108943412e-12,
     -4.878985199565852e-12,
     -4.240448995017367e-12,
     -3.559909094758252e-12,
     -2.858043359288076e-12,
     -2.156177623817898e-12,
     -1.475637723558783e-12,
     -8.371015190102975e-13,
     -2.599706096327376e-13,

     -2.382191739347923e-13,
     -6.423305872147843e-13,
     -9.400849094049696e-13,
     -1.122435026096556e-12,
     -1.183840321267481e-12,
     -1.122435026096556e-12,
     -9.400849094049694e-13,
     -6.423305872147840e-13,
     -2.382191739347918e-13,
     },
    {
     2.382191739347913e-13,
     6.423305872147834e-13,
     9.400849094049688e-13,
     1.122435026096556e-12,
     1.183840321267481e-12,
     1.122435026096556e-12,
     9.400849094049688e-13,
     6.423305872147841e-13,
     2.382191739347918e-13,

     5.456116108943413e-12,
     4.878985199565852e-12,
     4.240448995017367e-12,
     3.559909094758253e-12,
     2.858043359288075e-12,
     2.156177623817898e-12,
     1.475637723558782e-12,
     8.371015190102975e-13,
     2.599706096327376e-13,

     -5.461314069809755e-12,
     -4.921085770524055e-12,
     -4.343405037091838e-12,
     -3.732668368707687e-12,
     -3.093523840190885e-12,
     -2.430835727329465e-12,
     -1.734679010007751e-12,
     -9.748253656609281e-13,
     -2.797435120168326e-13,

     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     -2.283748241799531e-13,
     -4.037858874020686e-13,
     -2.146547464825323e-13,
     },
    {
     1.316524975873958e-01, /* win[SHORT_TYPE] */
     4.142135623730950e-01,
     7.673269879789602e-01,

     1.091308501069271e+00, /* tantab_l */
     1.303225372841206e+00,
     1.569685577117490e+00,
     1.920982126971166e+00,
     2.414213562373094e+00,
     3.171594802363212e+00,
     4.510708503662055e+00,
     7.595754112725146e+00,
     2.290376554843115e+01,

     0.98480775301220802032, /* cx */
     0.64278760968653936292,
     0.34202014332566882393,
     0.93969262078590842791,
     -0.17364817766693030343,
     -0.76604444311897790243,
     0.86602540378443870761,
     0.500000000000000e+00,

     -5.144957554275265e-01, /* ca */
     -4.717319685649723e-01,
     -3.133774542039019e-01,
     -1.819131996109812e-01,
     -9.457419252642064e-02,
     -4.096558288530405e-02,
     -1.419856857247115e-02,
     -3.699974673760037e-03,

     8.574929257125442e-01, /* cs */
     8.817419973177052e-01,
     9.496286491027329e-01,
     9.833145924917901e-01,
     9.955178160675857e-01,
     9.991605581781475e-01,
     9.998991952444470e-01,
     9.999931550702802e-01,
     },
    {
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     0.000000000000000e+00,
     2.283748241799531e-13,
     4.037858874020686e-13,
     2.146547464825323e-13,

     5.461314069809755e-12,
     4.921085770524055e-12,
     4.343405037091838e-12,
     3.732668368707687e-12,
     3.093523840190885e-12,
     2.430835727329466e-12,
     1.734679010007751e-12,
     9.748253656609281e-13,
     2.797435120168326e-13,

     -5.456116108943413e-12,
     -4.878985199565852e-12,
     -4.240448995017367e-12,
     -3.559909094758253e-12,
     -2.858043359288075e-12,
     -2.156177623817898e-12,
     -1.475637723558782e-12,
     -8.371015190102975e-13,
     -2.599706096327376e-13,

     -2.382191739347913e-13,
     -6.423305872147834e-13,
     -9.400849094049688e-13,
     -1.122435026096556e-12,
     -1.183840321267481e-12,
     -1.122435026096556e-12,
     -9.400849094049688e-13,
     -6.423305872147841e-13,
     -2.382191739347918e-13,
     }

################################################################################

TITLE
    Lame abr_switch_map

TYPE
    8 HEX

DATA
 08 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 00 00 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 f0 c1 00 00 30 41
 52 49 9d 3a 01 00 00 00 10 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 00 00 00 00 33 33 d3 40
 00 00 11 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 c8 c1 00 00 30 41 6f 12 83 3a 01 00 00 00
 18 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 00 00 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 a0 c1 00 00 30 41
 6f 12 83 3a 01 00 00 00 20 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 00 00 00 00 33 33 d3 40
 00 00 11 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 70 c1 00 00 30 41 6f 12 83 3a 01 00 00 00
 28 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 00 00 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 20 c1 00 00 30 41
 fa ed 6b 3a 01 00 00 00 30 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 00 00 00 00 33 33 d3 40
 00 00 11 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 20 c1 00 00 30 41 fa ed 6b 3a 01 00 00 00
 38 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 00 00 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 c0 c0 00 00 30 41
 17 b7 51 3a 01 00 00 00 40 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 00 00 00 00 33 33 d3 40
 00 00 11 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 00 c0 00 00 30 41 17 b7 51 3a 01 00 00 00
 50 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 00 00 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 00 00 00 00 00 41
 34 80 37 3a 01 00 00 00 60 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 00 00 20 40 33 33 d3 40
 00 00 11 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 80 3f 00 00 b0 40 52 49 1d 3a 01 00 00 00
 70 00 00 00 09 00 00 00 09 00 00 00 00 00 00 00
 00 00 10 40 33 33 d3 40 00 00 11 43 00 00 00 00
 33 33 73 3f 00 00 00 00 00 00 00 40 00 00 90 40
 6f 12 03 3a 01 00 00 00 80 00 00 00 09 00 00 00
 09 00 00 00 00 00 00 00 9a 99 f9 3f cd cc cc 40
 00 00 0c 43 00 00 00 00 33 33 73 3f 00 00 00 00
 00 00 40 40 00 00 80 40 17 b7 51 39 01 00 00 00
 a0 00 00 00 09 00 00 00 09 00 00 00 01 00 00 00
 b8 1e e5 3f 00 00 c0 40 00 00 07 43 00 00 00 00
 33 33 73 3f 00 00 00 c0 00 00 a0 40 00 00 60 40
 00 00 00 00 01 00 00 00 c0 00 00 00 09 00 00 00
 09 00 00 00 01 00 00 00 52 b8 be 3f 33 33 b3 40
 00 00 fa 42 00 00 00 00 ec 51 78 3f 00 00 80 c0
 00 00 e0 40 00 00 40 40 00 00 00 00 00 00 00 00
 e0 00 00 00 09 00 00 00 09 00 00 00 01 00 00 00
 00 00 a0 3f 66 66 a6 40 00 00 fa 42 00 00 00 00
 48 e1 7a 3f 00 00 c0 c0 00 00 10 41 00 00 00 40
 00 00 00 00 00 00 00 00 00 01 00 00 09 00 00 00
 09 00 00 00 01 00 00 00 ec 51 78 3f 66 66 a6 40
 00 00 fa 42 00 00 00 00 00 00 80 3f 00 00 00 c1
 00 00 20 41 00 00 80 3f 00 00 00 00 00 00 00 00
 40 01 00 00 09 00 00 00 09 00 00 00 01 00 00 00
 66 66 66 3f 66 66 a6 40 00 00 fa 42 00 00 00 00
 00 00 80 3f 00 00 20 c1 00 00 40 41 00 00 00 00
 00 00 00 00 00 00 00 00

################################################################################

TITLE
    psymodel table1

TYPE
    FLOAT

DATA
 11.0529651641845703 10.4870405197143555 9.9500503540039062 9.0247373580932617
 8.1854925155639648 7.0440874099731445 6.0618872642517090 5.2166562080383301
 4.4892711639404297 3.8632688522338867 3.3246052265167236 2.8610370159149170
 2.4621062278747559 2.1508569717407227 1.8789281845092773 1.7170432806015015
 1.5691069364547729 1.4555939435958862 1.3503136634826660 1.2715945243835449
 1.1974487304687500 1.1361428499221802 1.0779838562011719 1.0382591485977173
 1.0000000000000000

################################################################################

TITLE
    psymodel table2

TYPE
    FLOAT

DATA
 1.7782756090164185 1.8463102579116821 1.9169510602951050 1.9459413290023804
 1.9753739833831787 1.8325036764144897 1.6999466419219971 1.4962427616119385
 1.3169398307800293 1.0000000000000000

################################################################################

TITLE
    psymodel table3

TYPE
    FLOAT

DATA
 5.5396213531494141 5.2559690475463867 4.9868698120117188 4.5230655670166016
 4.1024475097656250 3.5304155349731445 3.0381536483764648 2.6145272254943848
 2.2499699592590332 1.9362165927886963 1.6662421226501465 1.4339104890823364
 1.2339655160903931 1.0779838562011719

################################################################################

TITLE
    in_cube AFC decoder (ngc_afc_decoder)

TYPE
    16

DATA
{{0,0},
{0x0800,0},
{0,0x0800},
{0x0400,0x0400},
{0x1000,0xf800},
{0x0e00,0xfa00},
{0x0c00,0xfc00},
{0x1200,0xf600},
{0x1068,0xf738},
{0x12c0,0xf704},
{0x1400,0xf400},
{0x0800,0xf800},
{0x0400,0xfc00},
{0xfc00,0x0400},
{0xfc00,0},
{0xf800,0}};

################################################################################

TITLE
    power2 table

TYPE
    16

DATA
    {1, 2, 4, 8, 0x10, 0x20, 0x40, 0x80,
    0x100, 0x200, 0x400, 0x800, 0x1000, 0x2000, 0x4000}

################################################################################

TITLE
    rfc3548 Base 64 Encoding with URL and Filename Safe Alphabet

TYPE
    8 32

DATA
 'A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P'
 'Q' 'R' 'S' 'T' 'U' 'V' 'W' 'X' 'Y' 'Z' 'a' 'b' 'c' 'd' 'e' 'f'
 'g' 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' 'p' 'q' 'r' 's' 't' 'u' 'v'
 'w' 'x' 'y' 'z' '0' '1' '2' '3' '4' '5' '6' '7' '8' '9'
// '-' '_'

################################################################################

TITLE
    rfc3548 Base 32 Encoding

TYPE
    8 32

DATA
 'A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P'
 'Q' 'R' 'S' 'T' 'U' 'V' 'W' 'X' 'Y' 'Z' '2' '3' '4' '5' '6' '7'

################################################################################

TITLE
    UUEncodeTable

TYPE
    8 32

DATA
  '`', '!', '"', '#', '$', '%', '&', '\'',
  '(', ')', '*', '+', ',', '-', '.', '/',
  '0', '1', '2', '3', '4', '5', '6', '7',
  '8', '9', ':', ';', '<', '=', '>', '?',
  '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
  'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
  'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
  'X', 'Y', 'Z', '[', '\\',']', '^', '_'

################################################################################

TITLE
    B64EncodeTable

TYPE
    8 32

DATA
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
  'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
  'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
  'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
  'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
  'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
  'w', 'x', 'y', 'z', '0', '1', '2', '3',
  '4', '5', '6', '7', '8', '9', '+', '/'

################################################################################

TITLE
    XXEncodeTable

TYPE
    8 32

DATA
  '+', '-', '0', '1', '2', '3', '4', '5',
  '6', '7', '8', '9', 'A', 'B', 'C', 'D',
  'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
  'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
  'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b',
  'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
  'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
  's', 't', 'u', 'v', 'w', 'x', 'y', 'z'

################################################################################

TITLE
    BHEncodeTable

TYPE
    8 32

DATA
  '!', '"', '#', '$', '%', '&', '\'', '(',
  ')', '*', '+', ',', '-', '0', '1', '2',
  '3', '4', '5', '6', '8', '9', '@', 'A', 
  'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 
  'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 
  'S', 'T', 'U', 'V', 'X', 'Y', 'Z', '[', 
  '`', 'a', 'b', 'c', 'd', 'e', 'f', 'h', 
  'i', 'j', 'k', 'l', 'm', 'p', 'q', 'r'

################################################################################

TITLE
    Anubis T0

TYPE
    32 HEX

DATA
    0a753a6f5h, 0d3bb6bd0h, 0e6d1bf6eh, 071e2d93bh
    0d0bd67dah, 0ac458acfh, 04d9a29b3h, 079f2f90bh
    03a74e89ch, 0c98f038ch, 0913f7e41h, 0fce5d732h
    01e3c7844h, 0478e018fh, 054a84de5h, 0bd67cea9h
    08c050a0fh, 0a557aef9h, 07af4f501h, 0fbebcb20h
    063c69157h, 0b86ddab7h, 0dda753f4h, 0d4b577c2h
    0e5d7b364h, 0b37bf68dh, 0c59733a4h, 0be61c2a3h
    0a94f9ed1h, 0880d1a17h, 00c183028h, 0a259b2ebh
    03972e496h, 0dfa35bf8h, 02952a4f6h, 0daa94fe6h
    02b56acfah, 0a84d9ad7h, 0cb8b0b80h, 04c982db5h
    04b9631a7h, 0224488cch, 0aa4992dbh, 0244890d8h
    04182199bh, 070e0dd3dh, 0a651a2f3h, 0f9efc32ch
    05ab475c1h, 0e2d9af76h, 0b07dfa87h, 0366cd8b4h
    07dfae913h, 0e4d5b762h, 03366ccaah, 0ffe3db38h
    060c09d5dh, 0204080c0h, 008102030h, 08b0b161dh
    05ebc65d9h, 0ab4b96ddh, 07ffee11fh, 078f0fd0dh
    07cf8ed15h, 02c58b0e8h, 057ae41efh, 0d2b96fd6h
    0dca557f2h, 06ddaa973h, 07efce519h, 00d1a342eh
    053a651f7h, 094356a5fh, 0c39b2bb0h, 02850a0f0h
    0274e9cd2h, 0060c1814h, 05fbe61dfh, 0ad478ec9h
    067ce814fh, 05cb86dd5h, 055aa49e3h, 048903dadh
    00e1c3824h, 052a455f1h, 0eac98f46h, 042841591h
    05bb671c7h, 05dba69d3h, 03060c0a0h, 058b07dcdh
    051a259fbh, 059b279cbh, 03c78f088h, 04e9c25b9h
    03870e090h, 08a09121bh, 072e4d531h, 014285078h
    0e7d3bb68h, 0c6913faeh, 0dea15ffeh, 050a05dfdh
    08e010203h, 09239724bh, 0d1bf63dch, 077eec12fh
    0933b764dh, 0458a0983h, 09a29527bh, 0ce811f9eh
    02d5ab4eeh, 003060c0ah, 062c49551h, 0b671e293h
    0b96fdeb1h, 0bf63c6a5h, 096316253h, 06bd6b167h
    03f7efc82h, 0070e1c12h, 01224486ch, 0ae4182c3h
    040801d9dh, 03468d0b8h, 0468c0589h, 03e7cf884h
    0dbab4be0h, 0cf831b98h, 0ecc59752h, 0cc851792h
    0c19f23bch, 0a15fbee1h, 0c09d27bah, 0d6b17fceh
    01d3a744eh, 0f4f5f702h, 061c2995bh, 03b76ec9ah
    010204060h, 0d8ad47eah, 068d0bd6dh, 0a05dbae7h
    0b17ffe81h, 00a14283ch, 069d2b96bh, 06cd8ad75h
    0499239abh, 0fae9cf26h, 076ecc529h, 0c49537a2h
    09e214263h, 09b2b567dh, 06edca579h, 0992f5e71h
    0c2992fb6h, 0b773e695h, 0982d5a77h, 0bc65caafh
    08f030605h, 085172e39h, 01f3e7c42h, 0b475ea9fh
    0f8edc72ah, 011224466h, 02e5cb8e4h, 000000000h
    0254a94deh, 01c387048h, 02a54a8fch, 03d7af48eh
    0050a141eh, 04f9e21bfh, 07bf6f107h, 0b279f28bh
    03264c8ach, 0903d7a47h, 0af4386c5h, 019326456h
    0a35bb6edh, 0f7f3fb08h, 073e6d137h, 09d274e69h
    0152a547eh, 074e8cd25h, 0eec19f5eh, 0ca890f86h
    09f234665h, 00f1e3c22h, 01b366c5ah, 075eac923h
    086112233h, 084152a3fh, 09c254a6fh, 04a9435a1h
    097336655h, 01a34685ch, 065ca8943h, 0f6f1ff0eh
    0edc79354h, 009122436h, 0bb6bd6bdh, 0264c98d4h
    0831b362dh, 0ebcb8b40h, 06fdea17fh, 0811f3e21h
    004081018h, 06ad4b561h, 043861197h, 001020406h
    0172e5c72h, 0e1dfa37ch, 087132635h, 0f5f7f304h
    08d070e09h, 0e3dbab70h, 023468ccah, 0801d3a27h
    044880d85h, 0162c5874h, 066cc8549h, 0214284c6h
    0fee1df3eh, 0d5b773c4h, 03162c4a6h, 0d9af43ech
    0356ad4beh, 018306050h, 00204080ch, 064c88d45h
    0f2f9ef16h, 0f1ffe31ch, 056ac45e9h, 0cd871394h
    08219322bh, 0c88d078ah, 0ba69d2bbh, 0f0fde71ah
    0efc39b58h, 0e9cf834ch, 0e8cd874ah, 0fde7d334h
    0890f1e11h, 0d7b37bc8h, 0c7933ba8h, 0b577ee99h
    0a455aaffh, 02f5ebce2h, 095376e59h, 013264c6ah
    00b162c3ah, 0f3fbeb10h, 0e0dda77ah, 0376edcb2h

###############################################################################

TITLE
    Anubis T1

TYPE
    32 HEX

DATA
    053a7f5a6h, 0bbd3d06bh, 0d1e66ebfh, 0e2713bd9h
    0bdd0da67h, 045accf8ah, 09a4db329h, 0f2790bf9h
    0743a9ce8h, 08fc98c03h, 03f91417eh, 0e5fc32d7h
    03c1e4478h, 08e478f01h, 0a854e54dh, 067bda9ceh
    0058c0f0ah, 057a5f9aeh, 0f47a01f5h, 0ebfb20cbh
    0c6635791h, 06db8b7dah, 0a7ddf453h, 0b5d4c277h
    0d7e564b3h, 07bb38df6h, 097c5a433h, 061bea3c2h
    04fa9d19eh, 00d88171ah, 0180c2830h, 059a2ebb2h
    0723996e4h, 0a3dff85bh, 05229f6a4h, 0a9dae64fh
    0562bfaach, 04da8d79ah, 08bcb800bh, 0984cb52dh
    0964ba731h, 04422cc88h, 049aadb92h, 04824d890h
    082419b19h, 0e0703dddh, 051a6f3a2h, 0eff92cc3h
    0b45ac175h, 0d9e276afh, 07db087fah, 06c36b4d8h
    0fa7d13e9h, 0d5e462b7h, 06633aacch, 0e3ff38dbh
    0c0605d9dh, 04020c080h, 010083020h, 00b8b1d16h
    0bc5ed965h, 04babdd96h, 0fe7f1fe1h, 0f0780dfdh
    0f87c15edh, 0582ce8b0h, 0ae57ef41h, 0b9d2d66fh
    0a5dcf257h, 0da6d73a9h, 0fc7e19e5h, 01a0d2e34h
    0a653f751h, 035945f6ah, 09bc3b02bh, 05028f0a0h
    04e27d29ch, 00c061418h, 0be5fdf61h, 047adc98eh
    0ce674f81h, 0b85cd56dh, 0aa55e349h, 09048ad3dh
    01c0e2438h, 0a452f155h, 0c9ea468fh, 084429115h
    0b65bc771h, 0ba5dd369h, 06030a0c0h, 0b058cd7dh
    0a251fb59h, 0b259cb79h, 0783c88f0h, 09c4eb925h
    0703890e0h, 0098a1b12h, 0e47231d5h, 028147850h
    0d3e768bbh, 091c6ae3fh, 0a1defe5fh, 0a050fd5dh
    0018e0302h, 039924b72h, 0bfd1dc63h, 0ee772fc1h
    03b934d76h, 08a458309h, 0299a7b52h, 081ce9e1fh
    05a2deeb4h, 006030a0ch, 0c4625195h, 071b693e2h
    06fb9b1deh, 063bfa5c6h, 031965362h, 0d66b67b1h
    07e3f82fch, 00e07121ch, 024126c48h, 041aec382h
    080409d1dh, 06834b8d0h, 08c468905h, 07c3e84f8h
    0abdbe04bh, 083cf981bh, 0c5ec5297h, 085cc9217h
    09fc1bc23h, 05fa1e1beh, 09dc0ba27h, 0b1d6ce7fh
    03a1d4e74h, 0f5f402f7h, 0c2615b99h, 0763b9aech
    020106040h, 0add8ea47h, 0d0686dbdh, 05da0e7bah
    07fb181feh, 0140a3c28h, 0d2696bb9h, 0d86c75adh
    09249ab39h, 0e9fa26cfh, 0ec7629c5h, 095c4a237h
    0219e6342h, 02b9b7d56h, 0dc6e79a5h, 02f99715eh
    099c2b62fh, 073b795e6h, 02d98775ah, 065bcafcah
    0038f0506h, 01785392eh, 03e1f427ch, 075b49feah
    0edf82ac7h, 022116644h, 05c2ee4b8h, 000000000h
    04a25de94h, 0381c4870h, 0542afca8h, 07a3d8ef4h
    00a051e14h, 09e4fbf21h, 0f67b07f1h, 079b28bf2h
    06432acc8h, 03d90477ah, 043afc586h, 032195664h
    05ba3edb6h, 0f3f708fbh, 0e67337d1h, 0279d694eh
    02a157e54h, 0e87425cdh, 0c1ee5e9fh, 089ca860fh
    0239f6546h, 01e0f223ch, 0361b5a6ch, 0ea7523c9h
    011863322h, 015843f2ah, 0259c6f4ah, 0944aa135h
    033975566h, 0341a5c68h, 0ca654389h, 0f1f60effh
    0c7ed5493h, 012093624h, 06bbbbdd6h, 04c26d498h
    01b832d36h, 0cbeb408bh, 0de6f7fa1h, 01f81213eh
    008041810h, 0d46a61b5h, 086439711h, 002010604h
    02e17725ch, 0dfe17ca3h, 013873526h, 0f7f504f3h
    0078d090eh, 0dbe370abh, 04623ca8ch, 01d80273ah
    08844850dh, 02c167458h, 0cc664985h, 04221c684h
    0e1fe3edfh, 0b7d5c473h, 06231a6c4h, 0afd9ec43h
    06a35bed4h, 030185060h, 004020c08h, 0c864458dh
    0f9f216efh, 0fff11ce3h, 0ac56e945h, 087cd9413h
    019822b32h, 08dc88a07h, 069babbd2h, 0fdf01ae7h
    0c3ef589bh, 0cfe94c83h, 0cde84a87h, 0e7fd34d3h
    00f89111eh, 0b3d7c87bh, 093c7a83bh, 077b599eeh
    055a4ffaah, 05e2fe2bch, 03795596eh, 026136a4ch
    0160b3a2ch, 0fbf310ebh, 0dde07aa7h, 06e37b2dch

###############################################################################

TITLE
    Anubis T4

TYPE
    32 HEX

DATA
    0a7a7a7a7h, 0d3d3d3d3h, 0e6e6e6e6h, 071717171h
    0d0d0d0d0h, 0acacacach, 04d4d4d4dh, 079797979h
    03a3a3a3ah, 0c9c9c9c9h, 091919191h, 0fcfcfcfch
    01e1e1e1eh, 047474747h, 054545454h, 0bdbdbdbdh
    08c8c8c8ch, 0a5a5a5a5h, 07a7a7a7ah, 0fbfbfbfbh
    063636363h, 0b8b8b8b8h, 0ddddddddh, 0d4d4d4d4h
    0e5e5e5e5h, 0b3b3b3b3h, 0c5c5c5c5h, 0bebebebeh
    0a9a9a9a9h, 088888888h, 00c0c0c0ch, 0a2a2a2a2h
    039393939h, 0dfdfdfdfh, 029292929h, 0dadadadah
    02b2b2b2bh, 0a8a8a8a8h, 0cbcbcbcbh, 04c4c4c4ch
    04b4b4b4bh, 022222222h, 0aaaaaaaah, 024242424h
    041414141h, 070707070h, 0a6a6a6a6h, 0f9f9f9f9h
    05a5a5a5ah, 0e2e2e2e2h, 0b0b0b0b0h, 036363636h
    07d7d7d7dh, 0e4e4e4e4h, 033333333h, 0ffffffffh
    060606060h, 020202020h, 008080808h, 08b8b8b8bh
    05e5e5e5eh, 0ababababh, 07f7f7f7fh, 078787878h
    07c7c7c7ch, 02c2c2c2ch, 057575757h, 0d2d2d2d2h
    0dcdcdcdch, 06d6d6d6dh, 07e7e7e7eh, 00d0d0d0dh
    053535353h, 094949494h, 0c3c3c3c3h, 028282828h
    027272727h, 006060606h, 05f5f5f5fh, 0adadadadh
    067676767h, 05c5c5c5ch, 055555555h, 048484848h
    00e0e0e0eh, 052525252h, 0eaeaeaeah, 042424242h
    05b5b5b5bh, 05d5d5d5dh, 030303030h, 058585858h
    051515151h, 059595959h, 03c3c3c3ch, 04e4e4e4eh
    038383838h, 08a8a8a8ah, 072727272h, 014141414h
    0e7e7e7e7h, 0c6c6c6c6h, 0dedededeh, 050505050h
    08e8e8e8eh, 092929292h, 0d1d1d1d1h, 077777777h
    093939393h, 045454545h, 09a9a9a9ah, 0cecececeh
    02d2d2d2dh, 003030303h, 062626262h, 0b6b6b6b6h
    0b9b9b9b9h, 0bfbfbfbfh, 096969696h, 06b6b6b6bh
    03f3f3f3fh, 007070707h, 012121212h, 0aeaeaeaeh
    040404040h, 034343434h, 046464646h, 03e3e3e3eh
    0dbdbdbdbh, 0cfcfcfcfh, 0ecececech, 0cccccccch
    0c1c1c1c1h, 0a1a1a1a1h, 0c0c0c0c0h, 0d6d6d6d6h
    01d1d1d1dh, 0f4f4f4f4h, 061616161h, 03b3b3b3bh
    010101010h, 0d8d8d8d8h, 068686868h, 0a0a0a0a0h
    0b1b1b1b1h, 00a0a0a0ah, 069696969h, 06c6c6c6ch
    049494949h, 0fafafafah, 076767676h, 0c4c4c4c4h
    09e9e9e9eh, 09b9b9b9bh, 06e6e6e6eh, 099999999h
    0c2c2c2c2h, 0b7b7b7b7h, 098989898h, 0bcbcbcbch
    08f8f8f8fh, 085858585h, 01f1f1f1fh, 0b4b4b4b4h
    0f8f8f8f8h, 011111111h, 02e2e2e2eh, 000000000h
    025252525h, 01c1c1c1ch, 02a2a2a2ah, 03d3d3d3dh
    005050505h, 04f4f4f4fh, 07b7b7b7bh, 0b2b2b2b2h
    032323232h, 090909090h, 0afafafafh, 019191919h
    0a3a3a3a3h, 0f7f7f7f7h, 073737373h, 09d9d9d9dh
    015151515h, 074747474h, 0eeeeeeeeh, 0cacacacah
    09f9f9f9fh, 00f0f0f0fh, 01b1b1b1bh, 075757575h
    086868686h, 084848484h, 09c9c9c9ch, 04a4a4a4ah
    097979797h, 01a1a1a1ah, 065656565h, 0f6f6f6f6h
    0ededededh, 009090909h, 0bbbbbbbbh, 026262626h
    083838383h, 0ebebebebh, 06f6f6f6fh, 081818181h
    004040404h, 06a6a6a6ah, 043434343h, 001010101h
    017171717h, 0e1e1e1e1h, 087878787h, 0f5f5f5f5h
    08d8d8d8dh, 0e3e3e3e3h, 023232323h, 080808080h
    044444444h, 016161616h, 066666666h, 021212121h
    0fefefefeh, 0d5d5d5d5h, 031313131h, 0d9d9d9d9h
    035353535h, 018181818h, 002020202h, 064646464h
    0f2f2f2f2h, 0f1f1f1f1h, 056565656h, 0cdcdcdcdh
    082828282h, 0c8c8c8c8h, 0babababah, 0f0f0f0f0h
    0efefefefh, 0e9e9e9e9h, 0e8e8e8e8h, 0fdfdfdfdh
    089898989h, 0d7d7d7d7h, 0c7c7c7c7h, 0b5b5b5b5h
    0a4a4a4a4h, 02f2f2f2fh, 095959595h, 013131313h
    00b0b0b0bh, 0f3f3f3f3h, 0e0e0e0e0h, 037373737h

###############################################################################

TITLE
    Anubis T5

TYPE
    32 HEX

DATA
    000000000h, 001020608h, 002040c10h, 003060a18h
    004081820h, 0050a1e28h, 0060c1430h, 0070e1238h
    008103040h, 009123648h, 00a143c50h, 00b163a58h
    00c182860h, 00d1a2e68h, 00e1c2470h, 00f1e2278h
    010206080h, 011226688h, 012246c90h, 013266a98h
    0142878a0h, 0152a7ea8h, 0162c74b0h, 0172e72b8h
    0183050c0h, 0193256c8h, 01a345cd0h, 01b365ad8h
    01c3848e0h, 01d3a4ee8h, 01e3c44f0h, 01f3e42f8h
    02040c01dh, 02142c615h, 02244cc0dh, 02346ca05h
    02448d83dh, 0254ade35h, 0264cd42dh, 0274ed225h
    02850f05dh, 02952f655h, 02a54fc4dh, 02b56fa45h
    02c58e87dh, 02d5aee75h, 02e5ce46dh, 02f5ee265h
    03060a09dh, 03162a695h, 03264ac8dh, 03366aa85h
    03468b8bdh, 0356abeb5h, 0366cb4adh, 0376eb2a5h
    0387090ddh, 0397296d5h, 03a749ccdh, 03b769ac5h
    03c7888fdh, 03d7a8ef5h, 03e7c84edh, 03f7e82e5h
    040809d3ah, 041829b32h, 04284912ah, 043869722h
    04488851ah, 0458a8312h, 0468c890ah, 0478e8f02h
    04890ad7ah, 04992ab72h, 04a94a16ah, 04b96a762h
    04c98b55ah, 04d9ab352h, 04e9cb94ah, 04f9ebf42h
    050a0fdbah, 051a2fbb2h, 052a4f1aah, 053a6f7a2h
    054a8e59ah, 055aae392h, 056ace98ah, 057aeef82h
    058b0cdfah, 059b2cbf2h, 05ab4c1eah, 05bb6c7e2h
    05cb8d5dah, 05dbad3d2h, 05ebcd9cah, 05fbedfc2h
    060c05d27h, 061c25b2fh, 062c45137h, 063c6573fh
    064c84507h, 065ca430fh, 066cc4917h, 067ce4f1fh
    068d06d67h, 069d26b6fh, 06ad46177h, 06bd6677fh
    06cd87547h, 06dda734fh, 06edc7957h, 06fde7f5fh
    070e03da7h, 071e23bafh, 072e431b7h, 073e637bfh
    074e82587h, 075ea238fh, 076ec2997h, 077ee2f9fh
    078f00de7h, 079f20befh, 07af401f7h, 07bf607ffh
    07cf815c7h, 07dfa13cfh, 07efc19d7h, 07ffe1fdfh
    0801d2774h, 0811f217ch, 082192b64h, 0831b2d6ch
    084153f54h, 08517395ch, 086113344h, 08713354ch
    0880d1734h, 0890f113ch, 08a091b24h, 08b0b1d2ch
    08c050f14h, 08d07091ch, 08e010304h, 08f03050ch
    0903d47f4h, 0913f41fch, 092394be4h, 0933b4dech
    094355fd4h, 0953759dch, 0963153c4h, 0973355cch
    0982d77b4h, 0992f71bch, 09a297ba4h, 09b2b7dach
    09c256f94h, 09d27699ch, 09e216384h, 09f23658ch
    0a05de769h, 0a15fe161h, 0a259eb79h, 0a35bed71h
    0a455ff49h, 0a557f941h, 0a651f359h, 0a753f551h
    0a84dd729h, 0a94fd121h, 0aa49db39h, 0ab4bdd31h
    0ac45cf09h, 0ad47c901h, 0ae41c319h, 0af43c511h
    0b07d87e9h, 0b17f81e1h, 0b2798bf9h, 0b37b8df1h
    0b4759fc9h, 0b57799c1h, 0b67193d9h, 0b77395d1h
    0b86db7a9h, 0b96fb1a1h, 0ba69bbb9h, 0bb6bbdb1h
    0bc65af89h, 0bd67a981h, 0be61a399h, 0bf63a591h
    0c09dba4eh, 0c19fbc46h, 0c299b65eh, 0c39bb056h
    0c495a26eh, 0c597a466h, 0c691ae7eh, 0c793a876h
    0c88d8a0eh, 0c98f8c06h, 0ca89861eh, 0cb8b8016h
    0cc85922eh, 0cd879426h, 0ce819e3eh, 0cf839836h
    0d0bddaceh, 0d1bfdcc6h, 0d2b9d6deh, 0d3bbd0d6h
    0d4b5c2eeh, 0d5b7c4e6h, 0d6b1cefeh, 0d7b3c8f6h
    0d8adea8eh, 0d9afec86h, 0daa9e69eh, 0dbabe096h
    0dca5f2aeh, 0dda7f4a6h, 0dea1febeh, 0dfa3f8b6h
    0e0dd7a53h, 0e1df7c5bh, 0e2d97643h, 0e3db704bh
    0e4d56273h, 0e5d7647bh, 0e6d16e63h, 0e7d3686bh
    0e8cd4a13h, 0e9cf4c1bh, 0eac94603h, 0ebcb400bh
    0ecc55233h, 0edc7543bh, 0eec15e23h, 0efc3582bh
    0f0fd1ad3h, 0f1ff1cdbh, 0f2f916c3h, 0f3fb10cbh
    0f4f502f3h, 0f5f704fbh, 0f6f10ee3h, 0f7f308ebh
    0f8ed2a93h, 0f9ef2c9bh, 0fae92683h, 0fbeb208bh
    0fce532b3h, 0fde734bbh, 0fee13ea3h, 0ffe338abh

###############################################################################

TITLE
    Anubis RC

TYPE
    32 HEX

DATA
    0a7d3e671h, 0d0ac4d79h, 03ac991fch, 01e4754bdh
    08ca57afbh, 063b8ddd4h, 0e5b3c5beh, 0a9880ca2h
    039df29dah, 02ba8cb4ch, 04b22aa24h, 04170a6f9h
    05ae2b036h, 07de433ffh, 06020088bh, 05eab7f78h
    07c2c57d2h, 0dc6d7e0dh, 05394c328h

###############################################################################

TITLE
    Whirlpool sbox

TYPE
    8

DATA
  0x68, 0xd0, 0xeb, 0x2b, 0x48, 0x9d, 0x6a, 0xe4,
  0xe3, 0xa3, 0x56, 0x81, 0x7d, 0xf1, 0x85, 0x9e,
  0x2c, 0x8e, 0x78, 0xca, 0x17, 0xa9, 0x61, 0xd5,
  0x5d, 0x0b, 0x8c, 0x3c, 0x77, 0x51, 0x22, 0x42,
  0x3f, 0x54, 0x41, 0x80, 0xcc, 0x86, 0xb3, 0x18,
  0x2e, 0x57, 0x06, 0x62, 0xf4, 0x36, 0xd1, 0x6b,
  0x1b, 0x65, 0x75, 0x10, 0xda, 0x49, 0x26, 0xf9,
  0xcb, 0x66, 0xe7, 0xba, 0xae, 0x50, 0x52, 0xab,
  0x05, 0xf0, 0x0d, 0x73, 0x3b, 0x04, 0x20, 0xfe,
  0xdd, 0xf5, 0xb4, 0x5f, 0x0a, 0xb5, 0xc0, 0xa0,
  0x71, 0xa5, 0x2d, 0x60, 0x72, 0x93, 0x39, 0x08,
  0x83, 0x21, 0x5c, 0x87, 0xb1, 0xe0, 0x00, 0xc3,
  0x12, 0x91, 0x8a, 0x02, 0x1c, 0xe6, 0x45, 0xc2,
  0xc4, 0xfd, 0xbf, 0x44, 0xa1, 0x4c, 0x33, 0xc5,
  0x84, 0x23, 0x7c, 0xb0, 0x25, 0x15, 0x35, 0x69,
  0xff, 0x94, 0x4d, 0x70, 0xa2, 0xaf, 0xcd, 0xd6,
  0x6c, 0xb7, 0xf8, 0x09, 0xf3, 0x67, 0xa4, 0xea,
  0xec, 0xb6, 0xd4, 0xd2, 0x14, 0x1e, 0xe1, 0x24,
  0x38, 0xc6, 0xdb, 0x4b, 0x7a, 0x3a, 0xde, 0x5e,
  0xdf, 0x95, 0xfc, 0xaa, 0xd7, 0xce, 0x07, 0x0f,
  0x3d, 0x58, 0x9a, 0x98, 0x9c, 0xf2, 0xa7, 0x11,
  0x7e, 0x8b, 0x43, 0x03, 0xe2, 0xdc, 0xe5, 0xb2,
  0x4e, 0xc7, 0x6d, 0xe9, 0x27, 0x40, 0xd8, 0x37,
  0x92, 0x8f, 0x01, 0x1d, 0x53, 0x3e, 0x59, 0xc1,
  0x4f, 0x32, 0x16, 0xfa, 0x74, 0xfb, 0x63, 0x9f,
  0x34, 0x1a, 0x2a, 0x5a, 0x8d, 0xc9, 0xcf, 0xf6,
  0x90, 0x28, 0x88, 0x9b, 0x31, 0x0e, 0xbd, 0x4a,
  0xe8, 0x96, 0xa6, 0x0c, 0xc8, 0x79, 0xbc, 0xbe,
  0xef, 0x6e, 0x46, 0x97, 0x5b, 0xed, 0x19, 0xd9,
  0xac, 0x99, 0xa8, 0x29, 0x64, 0x1f, 0xad, 0x55,
  0x13, 0xbb, 0xf7, 0x6f, 0xb9, 0x47, 0x2f, 0xee,
  0xb8, 0x7b, 0x89, 0x30, 0xd3, 0x7f, 0x76, 0x82

###############################################################################

TITLE
    Anubis / Khazad sbox

TYPE
    8

DATA
    0xa7, 0xd3, 0xe6, 0x71, 0xd0, 0xac, 0x4d, 0x79,
    0x3a, 0xc9, 0x91, 0xfc, 0x1e, 0x47, 0x54, 0xbd,
    0x8c, 0xa5, 0x7a, 0xfb, 0x63, 0xb8, 0xdd, 0xd4,
    0xe5, 0xb3, 0xc5, 0xbe, 0xa9, 0x88, 0x0c, 0xa2,
    0x39, 0xdf, 0x29, 0xda, 0x2b, 0xa8, 0xcb, 0x4c,
    0x4b, 0x22, 0xaa, 0x24, 0x41, 0x70, 0xa6, 0xf9,
    0x5a, 0xe2, 0xb0, 0x36, 0x7d, 0xe4, 0x33, 0xff,
    0x60, 0x20, 0x08, 0x8b, 0x5e, 0xab, 0x7f, 0x78,
    0x7c, 0x2c, 0x57, 0xd2, 0xdc, 0x6d, 0x7e, 0x0d,
    0x53, 0x94, 0xc3, 0x28, 0x27, 0x06, 0x5f, 0xad,
    0x67, 0x5c, 0x55, 0x48, 0x0e, 0x52, 0xea, 0x42,
    0x5b, 0x5d, 0x30, 0x58, 0x51, 0x59, 0x3c, 0x4e,
    0x38, 0x8a, 0x72, 0x14, 0xe7, 0xc6, 0xde, 0x50,
    0x8e, 0x92, 0xd1, 0x77, 0x93, 0x45, 0x9a, 0xce,
    0x2d, 0x03, 0x62, 0xb6, 0xb9, 0xbf, 0x96, 0x6b,
    0x3f, 0x07, 0x12, 0xae, 0x40, 0x34, 0x46, 0x3e,
    0xdb, 0xcf, 0xec, 0xcc, 0xc1, 0xa1, 0xc0, 0xd6,
    0x1d, 0xf4, 0x61, 0x3b, 0x10, 0xd8, 0x68, 0xa0,
    0xb1, 0x0a, 0x69, 0x6c, 0x49, 0xfa, 0x76, 0xc4,
    0x9e, 0x9b, 0x6e, 0x99, 0xc2, 0xb7, 0x98, 0xbc,
    0x8f, 0x85, 0x1f, 0xb4, 0xf8, 0x11, 0x2e, 0x00,
    0x25, 0x1c, 0x2a, 0x3d, 0x05, 0x4f, 0x7b, 0xb2,
    0x32, 0x90, 0xaf, 0x19, 0xa3, 0xf7, 0x73, 0x9d,
    0x15, 0x74, 0xee, 0xca, 0x9f, 0x0f, 0x1b, 0x75,
    0x86, 0x84, 0x9c, 0x4a, 0x97, 0x1a, 0x65, 0xf6,
    0xed, 0x09, 0xbb, 0x26, 0x83, 0xeb, 0x6f, 0x81,
    0x04, 0x6a, 0x43, 0x01, 0x17, 0xe1, 0x87, 0xf5,
    0x8d, 0xe3, 0x23, 0x80, 0x44, 0x16, 0x66, 0x21,
    0xfe, 0xd5, 0x31, 0xd9, 0x35, 0x18, 0x02, 0x64,
    0xf2, 0xf1, 0x56, 0xcd, 0x82, 0xc8, 0xba, 0xf0,
    0xef, 0xe9, 0xe8, 0xfd, 0x89, 0xd7, 0xc7, 0xb5,
    0xa4, 0x2f, 0x95, 0x13, 0x0b, 0xf3, 0xe0, 0x37

###############################################################################

TITLE
    Whirlpool C2

TYPE
    64

DATA
    0x30d818186018c078, 0x462623238c2305af, 0x91b8c6c63fc67ef9, 0xcdfbe8e887e8136f,
    0x13cb878726874ca1, 0x6d11b8b8dab8a962, 0x0209010104010805, 0x9e0d4f4f214f426e,
    0x6c9b3636d836adee, 0x51ffa6a6a2a65904, 0xb90cd2d26fd2debd, 0xf70ef5f5f3f5fb06,
    0xf2967979f979ef80, 0xde306f6fa16f5fce, 0x3f6d91917e91fcef, 0xa4f852525552aa07,
    0xc04760609d6027fd, 0x6535bcbccabc8976, 0x2b379b9b569baccd, 0x018a8e8e028e048c,
    0x5bd2a3a3b6a37115, 0x186c0c0c300c603c, 0xf6847b7bf17bff8a, 0x6a803535d435b5e1,
    0x3af51d1d741de869, 0xddb3e0e0a7e05347, 0xb321d7d77bd7f6ac, 0x999cc2c22fc25eed,
    0x5c432e2eb82e6d96, 0x96294b4b314b627a, 0xe15dfefedffea321, 0xaed5575741578216,
    0x2abd15155415a841, 0xeee87777c1779fb6, 0x6e923737dc37a5eb, 0xd79ee5e5b3e57b56,
    0x23139f9f469f8cd9, 0xfd23f0f0e7f0d317, 0x94204a4a354a6a7f, 0xa944dada4fda9e95,
    0xb0a258587d58fa25, 0x8fcfc9c903c906ca, 0x527c2929a429558d, 0x145a0a0a280a5022,
    0x7f50b1b1feb1e14f, 0x5dc9a0a0baa0691a, 0xd6146b6bb16b7fda, 0x17d985852e855cab,
    0x673cbdbdcebd8173, 0xba8f5d5d695dd234, 0x2090101040108050, 0xf507f4f4f7f4f303,
    0x8bddcbcb0bcb16c0, 0x7cd33e3ef83eedc6, 0x0a2d050514052811, 0xce78676781671fe6,
    0xd597e4e4b7e47353, 0x4e0227279c2725bb, 0x8273414119413258, 0x0ba78b8b168b2c9d,
    0x53f6a7a7a6a75101, 0xfab27d7de97dcf94, 0x374995956e95dcfb, 0xad56d8d847d88e9f,
    0xeb70fbfbcbfb8b30, 0xc1cdeeee9fee2371, 0xf8bb7c7ced7cc791, 0xcc716666856617e3,
    0xa77bdddd53dda68e, 0x2eaf17175c17b84b, 0x8e45474701470246, 0x211a9e9e429e84dc,
    0x89d4caca0fca1ec5, 0x5a582d2db42d7599, 0x632ebfbfc6bf9179, 0x0e3f07071c07381b,
    0x47acadad8ead0123, 0xb4b05a5a755aea2f, 0x1bef838336836cb5, 0x66b63333cc3385ff,
    0xc65c636391633ff2, 0x041202020802100a, 0x4993aaaa92aa3938, 0xe2de7171d971afa8,
    0x8dc6c8c807c80ecf, 0x32d119196419c87d, 0x923b494939497270, 0xaf5fd9d943d9869a,
    0xf931f2f2eff2c31d, 0xdba8e3e3abe34b48, 0xb6b95b5b715be22a, 0x0dbc88881a883492,
    0x293e9a9a529aa4c8, 0x4c0b262698262dbe, 0x64bf3232c8328dfa, 0x7d59b0b0fab0e94a,
    0xcff2e9e983e91b6a, 0x1e770f0f3c0f7833, 0xb733d5d573d5e6a6, 0x1df480803a8074ba,
    0x6127bebec2be997c, 0x87ebcdcd13cd26de, 0x68893434d034bde4, 0x903248483d487a75,
    0xe354ffffdbffab24, 0xf48d7a7af57af78f, 0x3d6490907a90f4ea, 0xbe9d5f5f615fc23e,
    0x403d202080201da0, 0xd00f6868bd6867d5, 0x34ca1a1a681ad072, 0x41b7aeae82ae192c,
    0x757db4b4eab4c95e, 0xa8ce54544d549a19, 0x3b7f93937693ece5, 0x442f222288220daa,
    0xc86364648d6407e9, 0xff2af1f1e3f1db12, 0xe6cc7373d173bfa2, 0x248212124812905a,
    0x807a40401d403a5d, 0x1048080820084028, 0x9b95c3c32bc356e8, 0xc5dfecec97ec337b,
    0xab4ddbdb4bdb9690, 0x5fc0a1a1bea1611f, 0x07918d8d0e8d1c83, 0x7ac83d3df43df5c9,
    0x335b97976697ccf1, 0x0000000000000000, 0x83f9cfcf1bcf36d4, 0x566e2b2bac2b4587,
    0xece17676c57697b3, 0x19e68282328264b0, 0xb128d6d67fd6fea9, 0x36c31b1b6c1bd877,
    0x7774b5b5eeb5c15b, 0x43beafaf86af1129, 0xd41d6a6ab56a77df, 0xa0ea50505d50ba0d,
    0x8a5745450945124c, 0xfb38f3f3ebf3cb18, 0x60ad3030c0309df0, 0xc3c4efef9bef2b74,
    0x7eda3f3ffc3fe5c3, 0xaac755554955921c, 0x59dba2a2b2a27910, 0xc9e9eaea8fea0365,
    0xca6a656589650fec, 0x6903babad2bab968, 0x5e4a2f2fbc2f6593, 0x9d8ec0c027c04ee7,
    0xa160dede5fdebe81, 0x38fc1c1c701ce06c, 0xe746fdfdd3fdbb2e, 0x9a1f4d4d294d5264,
    0x397692927292e4e0, 0xeafa7575c9758fbc, 0x0c3606061806301e, 0x09ae8a8a128a2498,
    0x794bb2b2f2b2f940, 0xd185e6e6bfe66359, 0x1c7e0e0e380e7036, 0x3ee71f1f7c1ff863,
    0xc4556262956237f7, 0xb53ad4d477d4eea3, 0x4d81a8a89aa82932, 0x315296966296c4f4,
    0xef62f9f9c3f99b3a, 0x97a3c5c533c566f6, 0x4a102525942535b1, 0xb2ab59597959f220,
    0x15d084842a8454ae, 0xe4c57272d572b7a7, 0x72ec3939e439d5dd, 0x98164c4c2d4c5a61,
    0xbc945e5e655eca3b, 0xf09f7878fd78e785, 0x70e53838e038ddd8, 0x05988c8c0a8c1486,
    0xbf17d1d163d1c6b2, 0x57e4a5a5aea5410b, 0xd9a1e2e2afe2434d, 0xc24e616199612ff8,
    0x7b42b3b3f6b3f145, 0x42342121842115a5, 0x25089c9c4a9c94d6, 0x3cee1e1e781ef066,
    0x8661434311432252, 0x93b1c7c73bc776fc, 0xe54ffcfcd7fcb32b, 0x0824040410042014,
    0xa2e351515951b208, 0x2f2599995e99bcc7, 0xda226d6da96d4fc4, 0x1a650d0d340d6839,
    0xe979fafacffa8335, 0xa369dfdf5bdfb684, 0xfca97e7ee57ed79b, 0x4819242490243db4,
    0x76fe3b3bec3bc5d7, 0x4b9aabab96ab313d, 0x81f0cece1fce3ed1, 0x2299111144118855,
    0x03838f8f068f0c89, 0x9c044e4e254e4a6b, 0x7366b7b7e6b7d151, 0xcbe0ebeb8beb0b60,
    0x78c13c3cf03cfdcc, 0x1ffd81813e817cbf, 0x354094946a94d4fe, 0xf31cf7f7fbf7eb0c,
    0x6f18b9b9deb9a167, 0x268b13134c13985f, 0x58512c2cb02c7d9c, 0xbb05d3d36bd3d6b8,
    0xd38ce7e7bbe76b5c, 0xdc396e6ea56e57cb, 0x95aac4c437c46ef3, 0x061b03030c03180f,
    0xacdc565645568a13, 0x885e44440d441a49, 0xfea07f7fe17fdf9e, 0x4f88a9a99ea92137,
    0x54672a2aa82a4d82, 0x6b0abbbbd6bbb16d, 0x9f87c1c123c146e2, 0xa6f153535153a202,
    0xa572dcdc57dcae8b, 0x16530b0b2c0b5827, 0x27019d9d4e9d9cd3, 0xd82b6c6cad6c47c1,
    0x62a43131c43195f5, 0xe8f37474cd7487b9, 0xf115f6f6fff6e309, 0x8c4c464605460a43,
    0x45a5acac8aac0926, 0x0fb589891e893c97, 0x28b414145014a044, 0xdfbae1e1a3e15b42,
    0x2ca616165816b04e, 0x74f73a3ae83acdd2, 0xd2066969b9696fd0, 0x124109092409482d,
    0xe0d77070dd70a7ad, 0x716fb6b6e2b6d954, 0xbd1ed0d067d0ceb7, 0xc7d6eded93ed3b7e,
    0x85e2cccc17cc2edb, 0x8468424215422a57, 0x2d2c98985a98b4c2, 0x55eda4a4aaa4490e,
    0x50752828a0285d88, 0xb8865c5c6d5cda31, 0xed6bf8f8c7f8933f, 0x11c28686228644a4,

###############################################################################

TITLE
    Whirlpool C3

TYPE
    64

DATA
    0x7830d818186018c0, 0xaf462623238c2305, 0xf991b8c6c63fc67e, 0x6fcdfbe8e887e813,
    0xa113cb878726874c, 0x626d11b8b8dab8a9, 0x0502090101040108, 0x6e9e0d4f4f214f42,
    0xee6c9b3636d836ad, 0x0451ffa6a6a2a659, 0xbdb90cd2d26fd2de, 0x06f70ef5f5f3f5fb,
    0x80f2967979f979ef, 0xcede306f6fa16f5f, 0xef3f6d91917e91fc, 0x07a4f852525552aa,
    0xfdc04760609d6027, 0x766535bcbccabc89, 0xcd2b379b9b569bac, 0x8c018a8e8e028e04,
    0x155bd2a3a3b6a371, 0x3c186c0c0c300c60, 0x8af6847b7bf17bff, 0xe16a803535d435b5,
    0x693af51d1d741de8, 0x47ddb3e0e0a7e053, 0xacb321d7d77bd7f6, 0xed999cc2c22fc25e,
    0x965c432e2eb82e6d, 0x7a96294b4b314b62, 0x21e15dfefedffea3, 0x16aed55757415782,
    0x412abd15155415a8, 0xb6eee87777c1779f, 0xeb6e923737dc37a5, 0x56d79ee5e5b3e57b,
    0xd923139f9f469f8c, 0x17fd23f0f0e7f0d3, 0x7f94204a4a354a6a, 0x95a944dada4fda9e,
    0x25b0a258587d58fa, 0xca8fcfc9c903c906, 0x8d527c2929a42955, 0x22145a0a0a280a50,
    0x4f7f50b1b1feb1e1, 0x1a5dc9a0a0baa069, 0xdad6146b6bb16b7f, 0xab17d985852e855c,
    0x73673cbdbdcebd81, 0x34ba8f5d5d695dd2, 0x5020901010401080, 0x03f507f4f4f7f4f3,
    0xc08bddcbcb0bcb16, 0xc67cd33e3ef83eed, 0x110a2d0505140528, 0xe6ce78676781671f,
    0x53d597e4e4b7e473, 0xbb4e0227279c2725, 0x5882734141194132, 0x9d0ba78b8b168b2c,
    0x0153f6a7a7a6a751, 0x94fab27d7de97dcf, 0xfb374995956e95dc, 0x9fad56d8d847d88e,
    0x30eb70fbfbcbfb8b, 0x71c1cdeeee9fee23, 0x91f8bb7c7ced7cc7, 0xe3cc716666856617,
    0x8ea77bdddd53dda6, 0x4b2eaf17175c17b8, 0x468e454747014702, 0xdc211a9e9e429e84,
    0xc589d4caca0fca1e, 0x995a582d2db42d75, 0x79632ebfbfc6bf91, 0x1b0e3f07071c0738,
    0x2347acadad8ead01, 0x2fb4b05a5a755aea, 0xb51bef838336836c, 0xff66b63333cc3385,
    0xf2c65c636391633f, 0x0a04120202080210, 0x384993aaaa92aa39, 0xa8e2de7171d971af,
    0xcf8dc6c8c807c80e, 0x7d32d119196419c8, 0x70923b4949394972, 0x9aaf5fd9d943d986,
    0x1df931f2f2eff2c3, 0x48dba8e3e3abe34b, 0x2ab6b95b5b715be2, 0x920dbc88881a8834,
    0xc8293e9a9a529aa4, 0xbe4c0b262698262d, 0xfa64bf3232c8328d, 0x4a7d59b0b0fab0e9,
    0x6acff2e9e983e91b, 0x331e770f0f3c0f78, 0xa6b733d5d573d5e6, 0xba1df480803a8074,
    0x7c6127bebec2be99, 0xde87ebcdcd13cd26, 0xe468893434d034bd, 0x75903248483d487a,
    0x24e354ffffdbffab, 0x8ff48d7a7af57af7, 0xea3d6490907a90f4, 0x3ebe9d5f5f615fc2,
    0xa0403d202080201d, 0xd5d00f6868bd6867, 0x7234ca1a1a681ad0, 0x2c41b7aeae82ae19,
    0x5e757db4b4eab4c9, 0x19a8ce54544d549a, 0xe53b7f93937693ec, 0xaa442f222288220d,
    0xe9c86364648d6407, 0x12ff2af1f1e3f1db, 0xa2e6cc7373d173bf, 0x5a24821212481290,
    0x5d807a40401d403a, 0x2810480808200840, 0xe89b95c3c32bc356, 0x7bc5dfecec97ec33,
    0x90ab4ddbdb4bdb96, 0x1f5fc0a1a1bea161, 0x8307918d8d0e8d1c, 0xc97ac83d3df43df5,
    0xf1335b97976697cc, 0x0000000000000000, 0xd483f9cfcf1bcf36, 0x87566e2b2bac2b45,
    0xb3ece17676c57697, 0xb019e68282328264, 0xa9b128d6d67fd6fe, 0x7736c31b1b6c1bd8,
    0x5b7774b5b5eeb5c1, 0x2943beafaf86af11, 0xdfd41d6a6ab56a77, 0x0da0ea50505d50ba,
    0x4c8a574545094512, 0x18fb38f3f3ebf3cb, 0xf060ad3030c0309d, 0x74c3c4efef9bef2b,
    0xc37eda3f3ffc3fe5, 0x1caac75555495592, 0x1059dba2a2b2a279, 0x65c9e9eaea8fea03,
    0xecca6a656589650f, 0x686903babad2bab9, 0x935e4a2f2fbc2f65, 0xe79d8ec0c027c04e,
    0x81a160dede5fdebe, 0x6c38fc1c1c701ce0, 0x2ee746fdfdd3fdbb, 0x649a1f4d4d294d52,
    0xe0397692927292e4, 0xbceafa7575c9758f, 0x1e0c360606180630, 0x9809ae8a8a128a24,
    0x40794bb2b2f2b2f9, 0x59d185e6e6bfe663, 0x361c7e0e0e380e70, 0x633ee71f1f7c1ff8,
    0xf7c4556262956237, 0xa3b53ad4d477d4ee, 0x324d81a8a89aa829, 0xf4315296966296c4,
    0x3aef62f9f9c3f99b, 0xf697a3c5c533c566, 0xb14a102525942535, 0x20b2ab59597959f2,
    0xae15d084842a8454, 0xa7e4c57272d572b7, 0xdd72ec3939e439d5, 0x6198164c4c2d4c5a,
    0x3bbc945e5e655eca, 0x85f09f7878fd78e7, 0xd870e53838e038dd, 0x8605988c8c0a8c14,
    0xb2bf17d1d163d1c6, 0x0b57e4a5a5aea541, 0x4dd9a1e2e2afe243, 0xf8c24e616199612f,
    0x457b42b3b3f6b3f1, 0xa542342121842115, 0xd625089c9c4a9c94, 0x663cee1e1e781ef0,
    0x5286614343114322, 0xfc93b1c7c73bc776, 0x2be54ffcfcd7fcb3, 0x1408240404100420,
    0x08a2e351515951b2, 0xc72f2599995e99bc, 0xc4da226d6da96d4f, 0x391a650d0d340d68,
    0x35e979fafacffa83, 0x84a369dfdf5bdfb6, 0x9bfca97e7ee57ed7, 0xb44819242490243d,
    0xd776fe3b3bec3bc5, 0x3d4b9aabab96ab31, 0xd181f0cece1fce3e, 0x5522991111441188,
    0x8903838f8f068f0c, 0x6b9c044e4e254e4a, 0x517366b7b7e6b7d1, 0x60cbe0ebeb8beb0b,
    0xcc78c13c3cf03cfd, 0xbf1ffd81813e817c, 0xfe354094946a94d4, 0x0cf31cf7f7fbf7eb,
    0x676f18b9b9deb9a1, 0x5f268b13134c1398, 0x9c58512c2cb02c7d, 0xb8bb05d3d36bd3d6,
    0x5cd38ce7e7bbe76b, 0xcbdc396e6ea56e57, 0xf395aac4c437c46e, 0x0f061b03030c0318,
    0x13acdc565645568a, 0x49885e44440d441a, 0x9efea07f7fe17fdf, 0x374f88a9a99ea921,
    0x8254672a2aa82a4d, 0x6d6b0abbbbd6bbb1, 0xe29f87c1c123c146, 0x02a6f153535153a2,
    0x8ba572dcdc57dcae, 0x2716530b0b2c0b58, 0xd327019d9d4e9d9c, 0xc1d82b6c6cad6c47,
    0xf562a43131c43195, 0xb9e8f37474cd7487, 0x09f115f6f6fff6e3, 0x438c4c464605460a,
    0x2645a5acac8aac09, 0x970fb589891e893c, 0x4428b414145014a0, 0x42dfbae1e1a3e15b,
    0x4e2ca616165816b0, 0xd274f73a3ae83acd, 0xd0d2066969b9696f, 0x2d12410909240948,
    0xade0d77070dd70a7, 0x54716fb6b6e2b6d9, 0xb7bd1ed0d067d0ce, 0x7ec7d6eded93ed3b,
    0xdb85e2cccc17cc2e, 0x578468424215422a, 0xc22d2c98985a98b4, 0x0e55eda4a4aaa449,
    0x8850752828a0285d, 0x31b8865c5c6d5cda, 0x3fed6bf8f8c7f893, 0xa411c28686228644,

###############################################################################

TITLE
    Wake crypto algorithm

TYPE
    32

DATA
		0x726a8f3bL,								 // table
		0xe69a3b5cL,
		0xd3c71fe5L,
		0xab3c73d2L,
		0x4d3a8eb3L,
		0x0396d6e8L,
		0x3d4c2f7aL,
		0x9ee27cf3L, } ;

###############################################################################

TITLE
    Tiger crypto algorithm init

TYPE
    64 AND

DATA
    0x0123456789ABCDEF, 0xFEDCBA9876543210, 0xF096A5B4C3B2E187

###############################################################################

TITLE
    Twofish q

TYPE
    8

DATA
   0xA9, 0x67, 0xB3, 0xE8, 0x04, 0xFD, 0xA3, 0x76, 0x9A, 0x92, 0x80, 0x78,
   0xE4, 0xDD, 0xD1, 0x38, 0x0D, 0xC6, 0x35, 0x98, 0x18, 0xF7, 0xEC, 0x6C,
   0x43, 0x75, 0x37, 0x26, 0xFA, 0x13, 0x94, 0x48, 0xF2, 0xD0, 0x8B, 0x30,
   0x84, 0x54, 0xDF, 0x23, 0x19, 0x5B, 0x3D, 0x59, 0xF3, 0xAE, 0xA2, 0x82,
   0x63, 0x01, 0x83, 0x2E, 0xD9, 0x51, 0x9B, 0x7C, 0xA6, 0xEB, 0xA5, 0xBE,
   0x16, 0x0C, 0xE3, 0x61, 0xC0, 0x8C, 0x3A, 0xF5, 0x73, 0x2C, 0x25, 0x0B,
   0xBB, 0x4E, 0x89, 0x6B, 0x53, 0x6A, 0xB4, 0xF1, 0xE1, 0xE6, 0xBD, 0x45,
   0xE2, 0xF4, 0xB6, 0x66, 0xCC, 0x95, 0x03, 0x56, 0xD4, 0x1C, 0x1E, 0xD7,
   0xFB, 0xC3, 0x8E, 0xB5, 0xE9, 0xCF, 0xBF, 0xBA, 0xEA, 0x77, 0x39, 0xAF,
   0x33, 0xC9, 0x62, 0x71, 0x81, 0x79, 0x09, 0xAD, 0x24, 0xCD, 0xF9, 0xD8,
   0xE5, 0xC5, 0xB9, 0x4D, 0x44, 0x08, 0x86, 0xE7, 0xA1, 0x1D, 0xAA, 0xED,
   0x06, 0x70, 0xB2, 0xD2, 0x41, 0x7B, 0xA0, 0x11, 0x31, 0xC2, 0x27, 0x90,
   0x20, 0xF6, 0x60, 0xFF, 0x96, 0x5C, 0xB1, 0xAB, 0x9E, 0x9C, 0x52, 0x1B,
   0x5F, 0x93, 0x0A, 0xEF, 0x91, 0x85, 0x49, 0xEE, 0x2D, 0x4F, 0x8F, 0x3B,
   0x47, 0x87, 0x6D, 0x46, 0xD6, 0x3E, 0x69, 0x64, 0x2A, 0xCE, 0xCB, 0x2F,
   0xFC, 0x97, 0x05, 0x7A, 0xAC, 0x7F, 0xD5, 0x1A, 0x4B, 0x0E, 0xA7, 0x5A,
   0x28, 0x14, 0x3F, 0x29, 0x88, 0x3C, 0x4C, 0x02, 0xB8, 0xDA, 0xB0, 0x17,
   0x55, 0x1F, 0x8A, 0x7D, 0x57, 0xC7, 0x8D, 0x74, 0xB7, 0xC4, 0x9F, 0x72,
   0x7E, 0x15, 0x22, 0x12, 0x58, 0x07, 0x99, 0x34, 0x6E, 0x50, 0xDE, 0x68,
   0x65, 0xBC, 0xDB, 0xF8, 0xC8, 0xA8, 0x2B, 0x40, 0xDC, 0xFE, 0x32, 0xA4,
   0xCA, 0x10, 0x21, 0xF0, 0xD3, 0x5D, 0x0F, 0x00, 0x6F, 0x9D, 0x36, 0x42,
   0x4A, 0x5E, 0xC1, 0xE0,

   0x75, 0xF3, 0xC6, 0xF4, 0xDB, 0x7B, 0xFB, 0xC8, 0x4A, 0xD3, 0xE6, 0x6B,
   0x45, 0x7D, 0xE8, 0x4B, 0xD6, 0x32, 0xD8, 0xFD, 0x37, 0x71, 0xF1, 0xE1,
   0x30, 0x0F, 0xF8, 0x1B, 0x87, 0xFA, 0x06, 0x3F, 0x5E, 0xBA, 0xAE, 0x5B,
   0x8A, 0x00, 0xBC, 0x9D, 0x6D, 0xC1, 0xB1, 0x0E, 0x80, 0x5D, 0xD2, 0xD5,
   0xA0, 0x84, 0x07, 0x14, 0xB5, 0x90, 0x2C, 0xA3, 0xB2, 0x73, 0x4C, 0x54,
   0x92, 0x74, 0x36, 0x51, 0x38, 0xB0, 0xBD, 0x5A, 0xFC, 0x60, 0x62, 0x96,
   0x6C, 0x42, 0xF7, 0x10, 0x7C, 0x28, 0x27, 0x8C, 0x13, 0x95, 0x9C, 0xC7,
   0x24, 0x46, 0x3B, 0x70, 0xCA, 0xE3, 0x85, 0xCB, 0x11, 0xD0, 0x93, 0xB8,
   0xA6, 0x83, 0x20, 0xFF, 0x9F, 0x77, 0xC3, 0xCC, 0x03, 0x6F, 0x08, 0xBF,
   0x40, 0xE7, 0x2B, 0xE2, 0x79, 0x0C, 0xAA, 0x82, 0x41, 0x3A, 0xEA, 0xB9,
   0xE4, 0x9A, 0xA4, 0x97, 0x7E, 0xDA, 0x7A, 0x17, 0x66, 0x94, 0xA1, 0x1D,
   0x3D, 0xF0, 0xDE, 0xB3, 0x0B, 0x72, 0xA7, 0x1C, 0xEF, 0xD1, 0x53, 0x3E,
   0x8F, 0x33, 0x26, 0x5F, 0xEC, 0x76, 0x2A, 0x49, 0x81, 0x88, 0xEE, 0x21,
   0xC4, 0x1A, 0xEB, 0xD9, 0xC5, 0x39, 0x99, 0xCD, 0xAD, 0x31, 0x8B, 0x01,
   0x18, 0x23, 0xDD, 0x1F, 0x4E, 0x2D, 0xF9, 0x48, 0x4F, 0xF2, 0x65, 0x8E,
   0x78, 0x5C, 0x58, 0x19, 0x8D, 0xE5, 0x98, 0x57, 0x67, 0x7F, 0x05, 0x64,
   0xAF, 0x63, 0xB6, 0xFE, 0xF5, 0xB7, 0x3C, 0xA5, 0xCE, 0xE9, 0x68, 0x44,
   0xE0, 0x4D, 0x43, 0x69, 0x29, 0x2E, 0xAC, 0x15, 0x59, 0xA8, 0x0A, 0x9E,
   0x6E, 0x47, 0xDF, 0x34, 0x35, 0x6A, 0xCF, 0xDC, 0x22, 0xC9, 0xC0, 0x9B,
   0x89, 0xD4, 0xED, 0xAB, 0x12, 0xA2, 0x0D, 0x52, 0xBB, 0x02, 0x2F, 0xA9,
   0xD7, 0x61, 0x1E, 0xB4, 0x50, 0x04, 0xF6, 0xC2, 0x16, 0x25, 0x86, 0x56,
   0x55, 0x09, 0xBE, 0x91

###############################################################################

TITLE
    Twofish mds

TYPE
    32

DATA
	0xbcbc3275, 0xecec21f3, 0x202043c6, 0xb3b3c9f4, 
	0xdada03db, 0x02028b7b, 0xe2e22bfb, 0x9e9efac8, 
	0xc9c9ec4a, 0xd4d409d3, 0x18186be6, 0x1e1e9f6b, 
	0x98980e45, 0xb2b2387d, 0xa6a6d2e8, 0x2626b74b, 
	0x3c3c57d6, 0x93938a32, 0x8282eed8, 0x525298fd, 
	0x7b7bd437, 0xbbbb3771, 0x5b5b97f1, 0x474783e1, 
	0x24243c30, 0x5151e20f, 0xbabac6f8, 0x4a4af31b, 
	0xbfbf4887, 0x0d0d70fa, 0xb0b0b306, 0x7575de3f, 
	0xd2d2fd5e, 0x7d7d20ba, 0x666631ae, 0x3a3aa35b, 
	0x59591c8a, 0x00000000, 0xcdcd93bc, 0x1a1ae09d, 
	0xaeae2c6d, 0x7f7fabc1, 0x2b2bc7b1, 0xbebeb90e, 
	0xe0e0a080, 0x8a8a105d, 0x3b3b52d2, 0x6464bad5, 
	0xd8d888a0, 0xe7e7a584, 0x5f5fe807, 0x1b1b1114, 
	0x2c2cc2b5, 0xfcfcb490, 0x3131272c, 0x808065a3, 
	0x73732ab2, 0x0c0c8173, 0x79795f4c, 0x6b6b4154, 
	0x4b4b0292, 0x53536974, 0x94948f36, 0x83831f51, 
	0x2a2a3638, 0xc4c49cb0, 0x2222c8bd, 0xd5d5f85a, 
	0xbdbdc3fc, 0x48487860, 0xffffce62, 0x4c4c0796, 
	0x4141776c, 0xc7c7e642, 0xebeb24f7, 0x1c1c1410, 
	0x5d5d637c, 0x36362228, 0x6767c027, 0xe9e9af8c, 
	0x4444f913, 0x1414ea95, 0xf5f5bb9c, 0xcfcf18c7, 
	0x3f3f2d24, 0xc0c0e346, 0x7272db3b, 0x54546c70, 
	0x29294cca, 0xf0f035e3, 0x0808fe85, 0xc6c617cb, 
	0xf3f34f11, 0x8c8ce4d0, 0xa4a45993, 0xcaca96b8, 
	0x68683ba6, 0xb8b84d83, 0x38382820, 0xe5e52eff, 
	0xadad569f, 0x0b0b8477, 0xc8c81dc3, 0x9999ffcc, 
	0x5858ed03, 0x19199a6f, 0x0e0e0a08, 0x95957ebf, 
	0x70705040, 0xf7f730e7, 0x6e6ecf2b, 0x1f1f6ee2, 
	0xb5b53d79, 0x09090f0c, 0x616134aa, 0x57571682, 
	0x9f9f0b41, 0x9d9d803a, 0x111164ea, 0x2525cdb9, 
	0xafafdde4, 0x4545089a, 0xdfdf8da4, 0xa3a35c97, 
	0xeaead57e, 0x353558da, 0xededd07a, 0x4343fc17, 
	0xf8f8cb66, 0xfbfbb194, 0x3737d3a1, 0xfafa401d, 
	0xc2c2683d, 0xb4b4ccf0, 0x32325dde, 0x9c9c71b3, 
	0x5656e70b, 0xe3e3da72, 0x878760a7, 0x15151b1c, 
	0xf9f93aef, 0x6363bfd1, 0x3434a953, 0x9a9a853e, 
	0xb1b1428f, 0x7c7cd133, 0x88889b26, 0x3d3da65f, 
	0xa1a1d7ec, 0xe4e4df76, 0x8181942a, 0x91910149, 
	0x0f0ffb81, 0xeeeeaa88, 0x161661ee, 0xd7d77321, 
	0x9797f5c4, 0xa5a5a81a, 0xfefe3feb, 0x6d6db5d9, 
	0x7878aec5, 0xc5c56d39, 0x1d1de599, 0x7676a4cd, 
	0x3e3edcad, 0xcbcb6731, 0xb6b6478b, 0xefef5b01, 
	0x12121e18, 0x6060c523, 0x6a6ab0dd, 0x4d4df61f, 
	0xcecee94e, 0xdede7c2d, 0x55559df9, 0x7e7e5a48, 
	0x2121b24f, 0x03037af2, 0xa0a02665, 0x5e5e198e, 
	0x5a5a6678, 0x65654b5c, 0x62624e58, 0xfdfd4519, 
	0x0606f48d, 0x404086e5, 0xf2f2be98, 0x3333ac57, 
	0x17179067, 0x05058e7f, 0xe8e85e05, 0x4f4f7d64, 
	0x89896aaf, 0x10109563, 0x74742fb6, 0x0a0a75fe, 
	0x5c5c92f5, 0x9b9b74b7, 0x2d2d333c, 0x3030d6a5, 
	0x2e2e49ce, 0x494989e9, 0x46467268, 0x77775544, 
	0xa8a8d8e0, 0x9696044d, 0x2828bd43, 0xa9a92969, 
	0xd9d97929, 0x8686912e, 0xd1d187ac, 0xf4f44a15, 
	0x8d8d1559, 0xd6d682a8, 0xb9b9bc0a, 0x42420d9e, 
	0xf6f6c16e, 0x2f2fb847, 0xdddd06df, 0x23233934, 
	0xcccc6235, 0xf1f1c46a, 0xc1c112cf, 0x8585ebdc, 
	0x8f8f9e22, 0x7171a1c9, 0x9090f0c0, 0xaaaa539b, 
	0x0101f189, 0x8b8be1d4, 0x4e4e8ced, 0x8e8e6fab, 
	0xababa212, 0x6f6f3ea2, 0xe6e6540d, 0xdbdbf252, 
	0x92927bbb, 0xb7b7b602, 0x6969ca2f, 0x3939d9a9, 
	0xd3d30cd7, 0xa7a72361, 0xa2a2ad1e, 0xc3c399b4, 
	0x6c6c4450, 0x07070504, 0x04047ff6, 0x272746c2, 
	0xacaca716, 0xd0d07625, 0x50501386, 0xdcdcf756, 
	0x84841a55, 0xe1e15109, 0x7a7a25be, 0x1313ef91, 

	0xa9d93939, 0x67901717, 0xb3719c9c, 0xe8d2a6a6, 
	0x04050707, 0xfd985252, 0xa3658080, 0x76dfe4e4, 
	0x9a084545, 0x92024b4b, 0x80a0e0e0, 0x78665a5a, 
	0xe4ddafaf, 0xddb06a6a, 0xd1bf6363, 0x38362a2a, 
	0x0d54e6e6, 0xc6432020, 0x3562cccc, 0x98bef2f2, 
	0x181e1212, 0xf724ebeb, 0xecd7a1a1, 0x6c774141, 
	0x43bd2828, 0x7532bcbc, 0x37d47b7b, 0x269b8888, 
	0xfa700d0d, 0x13f94444, 0x94b1fbfb, 0x485a7e7e, 
	0xf27a0303, 0xd0e48c8c, 0x8b47b6b6, 0x303c2424, 
	0x84a5e7e7, 0x54416b6b, 0xdf06dddd, 0x23c56060, 
	0x1945fdfd, 0x5ba33a3a, 0x3d68c2c2, 0x59158d8d, 
	0xf321ecec, 0xae316666, 0xa23e6f6f, 0x82165757, 
	0x63951010, 0x015befef, 0x834db8b8, 0x2e918686, 
	0xd9b56d6d, 0x511f8383, 0x9b53aaaa, 0x7c635d5d, 
	0xa63b6868, 0xeb3ffefe, 0xa5d63030, 0xbe257a7a, 
	0x16a7acac, 0x0c0f0909, 0xe335f0f0, 0x6123a7a7, 
	0xc0f09090, 0x8cafe9e9, 0x3a809d9d, 0xf5925c5c, 
	0x73810c0c, 0x2c273131, 0x2576d0d0, 0x0be75656, 
	0xbb7b9292, 0x4ee9cece, 0x89f10101, 0x6b9f1e1e, 
	0x53a93434, 0x6ac4f1f1, 0xb499c3c3, 0xf1975b5b, 
	0xe1834747, 0xe66b1818, 0xbdc82222, 0x450e9898, 
	0xe26e1f1f, 0xf4c9b3b3, 0xb62f7474, 0x66cbf8f8, 
	0xccff9999, 0x95ea1414, 0x03ed5858, 0x56f7dcdc, 
	0xd4e18b8b, 0x1c1b1515, 0x1eada2a2, 0xd70cd3d3, 
	0xfb2be2e2, 0xc31dc8c8, 0x8e195e5e, 0xb5c22c2c, 
	0xe9894949, 0xcf12c1c1, 0xbf7e9595, 0xba207d7d, 
	0xea641111, 0x77840b0b, 0x396dc5c5, 0xaf6a8989, 
	0x33d17c7c, 0xc9a17171, 0x62ceffff, 0x7137bbbb, 
	0x81fb0f0f, 0x793db5b5, 0x0951e1e1, 0xaddc3e3e, 
	0x242d3f3f, 0xcda47676, 0xf99d5555, 0xd8ee8282, 
	0xe5864040, 0xc5ae7878, 0xb9cd2525, 0x4d049696, 
	0x44557777, 0x080a0e0e, 0x86135050, 0xe730f7f7, 
	0xa1d33737, 0x1d40fafa, 0xaa346161, 0xed8c4e4e, 
	0x06b3b0b0, 0x706c5454, 0xb22a7373, 0xd2523b3b, 
	0x410b9f9f, 0x7b8b0202, 0xa088d8d8, 0x114ff3f3, 
	0x3167cbcb, 0xc2462727, 0x27c06767, 0x90b4fcfc, 
	0x20283838, 0xf67f0404, 0x60784848, 0xff2ee5e5, 
	0x96074c4c, 0x5c4b6565, 0xb1c72b2b, 0xab6f8e8e, 
	0x9e0d4242, 0x9cbbf5f5, 0x52f2dbdb, 0x1bf34a4a, 
	0x5fa63d3d, 0x9359a4a4, 0x0abcb9b9, 0xef3af9f9, 
	0x91ef1313, 0x85fe0808, 0x49019191, 0xee611616, 
	0x2d7cdede, 0x4fb22121, 0x8f42b1b1, 0x3bdb7272, 
	0x47b82f2f, 0x8748bfbf, 0x6d2caeae, 0x46e3c0c0, 
	0xd6573c3c, 0x3e859a9a, 0x6929a9a9, 0x647d4f4f, 
	0x2a948181, 0xce492e2e, 0xcb17c6c6, 0x2fca6969, 
	0xfcc3bdbd, 0x975ca3a3, 0x055ee8e8, 0x7ad0eded, 
	0xac87d1d1, 0x7f8e0505, 0xd5ba6464, 0x1aa8a5a5, 
	0x4bb72626, 0x0eb9bebe, 0xa7608787, 0x5af8d5d5, 
	0x28223636, 0x14111b1b, 0x3fde7575, 0x2979d9d9, 
	0x88aaeeee, 0x3c332d2d, 0x4c5f7979, 0x02b6b7b7, 
	0xb896caca, 0xda583535, 0xb09cc4c4, 0x17fc4343, 
	0x551a8484, 0x1ff64d4d, 0x8a1c5959, 0x7d38b2b2, 
	0x57ac3333, 0xc718cfcf, 0x8df40606, 0x74695353, 
	0xb7749b9b, 0xc4f59797, 0x9f56adad, 0x72dae3e3, 
	0x7ed5eaea, 0x154af4f4, 0x229e8f8f, 0x12a2abab, 
	0x584e6262, 0x07e85f5f, 0x99e51d1d, 0x34392323, 
	0x6ec1f6f6, 0x50446c6c, 0xde5d3232, 0x68724646, 
	0x6526a0a0, 0xbc93cdcd, 0xdb03dada, 0xf8c6baba, 
	0xc8fa9e9e, 0xa882d6d6, 0x2bcf6e6e, 0x40507070, 
	0xdceb8585, 0xfe750a0a, 0x328a9393, 0xa48ddfdf, 
	0xca4c2929, 0x10141c1c, 0x2173d7d7, 0xf0ccb4b4, 
	0xd309d4d4, 0x5d108a8a, 0x0fe25151, 0x00000000, 
	0x6f9a1919, 0x9de01a1a, 0x368f9494, 0x42e6c7c7, 
	0x4aecc9c9, 0x5efdd2d2, 0xc1ab7f7f, 0xe0d8a8a8, 

	0xbc75bc32, 0xecf3ec21, 0x20c62043, 0xb3f4b3c9, 
	0xdadbda03, 0x027b028b, 0xe2fbe22b, 0x9ec89efa, 
	0xc94ac9ec, 0xd4d3d409, 0x18e6186b, 0x1e6b1e9f, 
	0x9845980e, 0xb27db238, 0xa6e8a6d2, 0x264b26b7, 
	0x3cd63c57, 0x9332938a, 0x82d882ee, 0x52fd5298, 
	0x7b377bd4, 0xbb71bb37, 0x5bf15b97, 0x47e14783, 
	0x2430243c, 0x510f51e2, 0xbaf8bac6, 0x4a1b4af3, 
	0xbf87bf48, 0x0dfa0d70, 0xb006b0b3, 0x753f75de, 
	0xd25ed2fd, 0x7dba7d20, 0x66ae6631, 0x3a5b3aa3, 
	0x598a591c, 0x00000000, 0xcdbccd93, 0x1a9d1ae0, 
	0xae6dae2c, 0x7fc17fab, 0x2bb12bc7, 0xbe0ebeb9, 
	0xe080e0a0, 0x8a5d8a10, 0x3bd23b52, 0x64d564ba, 
	0xd8a0d888, 0xe784e7a5, 0x5f075fe8, 0x1b141b11, 
	0x2cb52cc2, 0xfc90fcb4, 0x312c3127, 0x80a38065, 
	0x73b2732a, 0x0c730c81, 0x794c795f, 0x6b546b41, 
	0x4b924b02, 0x53745369, 0x9436948f, 0x8351831f, 
	0x2a382a36, 0xc4b0c49c, 0x22bd22c8, 0xd55ad5f8, 
	0xbdfcbdc3, 0x48604878, 0xff62ffce, 0x4c964c07, 
	0x416c4177, 0xc742c7e6, 0xebf7eb24, 0x1c101c14, 
	0x5d7c5d63, 0x36283622, 0x672767c0, 0xe98ce9af, 
	0x441344f9, 0x149514ea, 0xf59cf5bb, 0xcfc7cf18, 
	0x3f243f2d, 0xc046c0e3, 0x723b72db, 0x5470546c, 
	0x29ca294c, 0xf0e3f035, 0x088508fe, 0xc6cbc617, 
	0xf311f34f, 0x8cd08ce4, 0xa493a459, 0xcab8ca96, 
	0x68a6683b, 0xb883b84d, 0x38203828, 0xe5ffe52e, 
	0xad9fad56, 0x0b770b84, 0xc8c3c81d, 0x99cc99ff, 
	0x580358ed, 0x196f199a, 0x0e080e0a, 0x95bf957e, 
	0x70407050, 0xf7e7f730, 0x6e2b6ecf, 0x1fe21f6e, 
	0xb579b53d, 0x090c090f, 0x61aa6134, 0x57825716, 
	0x9f419f0b, 0x9d3a9d80, 0x11ea1164, 0x25b925cd, 
	0xafe4afdd, 0x459a4508, 0xdfa4df8d, 0xa397a35c, 
	0xea7eead5, 0x35da3558, 0xed7aedd0, 0x431743fc, 
	0xf866f8cb, 0xfb94fbb1, 0x37a137d3, 0xfa1dfa40, 
	0xc23dc268, 0xb4f0b4cc, 0x32de325d, 0x9cb39c71, 
	0x560b56e7, 0xe372e3da, 0x87a78760, 0x151c151b, 
	0xf9eff93a, 0x63d163bf, 0x345334a9, 0x9a3e9a85, 
	0xb18fb142, 0x7c337cd1, 0x8826889b, 0x3d5f3da6, 
	0xa1eca1d7, 0xe476e4df, 0x812a8194, 0x91499101, 
	0x0f810ffb, 0xee88eeaa, 0x16ee1661, 0xd721d773, 
	0x97c497f5, 0xa51aa5a8, 0xfeebfe3f, 0x6dd96db5, 
	0x78c578ae, 0xc539c56d, 0x1d991de5, 0x76cd76a4, 
	0x3ead3edc, 0xcb31cb67, 0xb68bb647, 0xef01ef5b, 
	0x1218121e, 0x602360c5, 0x6add6ab0, 0x4d1f4df6, 
	0xce4ecee9, 0xde2dde7c, 0x55f9559d, 0x7e487e5a, 
	0x214f21b2, 0x03f2037a, 0xa065a026, 0x5e8e5e19, 
	0x5a785a66, 0x655c654b, 0x6258624e, 0xfd19fd45, 
	0x068d06f4, 0x40e54086, 0xf298f2be, 0x335733ac, 
	0x17671790, 0x057f058e, 0xe805e85e, 0x4f644f7d, 
	0x89af896a, 0x10631095, 0x74b6742f, 0x0afe0a75, 
	0x5cf55c92, 0x9bb79b74, 0x2d3c2d33, 0x30a530d6, 
	0x2ece2e49, 0x49e94989, 0x46684672, 0x77447755, 
	0xa8e0a8d8, 0x964d9604, 0x284328bd, 0xa969a929, 
	0xd929d979, 0x862e8691, 0xd1acd187, 0xf415f44a, 
	0x8d598d15, 0xd6a8d682, 0xb90ab9bc, 0x429e420d, 
	0xf66ef6c1, 0x2f472fb8, 0xdddfdd06, 0x23342339, 
	0xcc35cc62, 0xf16af1c4, 0xc1cfc112, 0x85dc85eb, 
	0x8f228f9e, 0x71c971a1, 0x90c090f0, 0xaa9baa53, 
	0x018901f1, 0x8bd48be1, 0x4eed4e8c, 0x8eab8e6f, 
	0xab12aba2, 0x6fa26f3e, 0xe60de654, 0xdb52dbf2, 
	0x92bb927b, 0xb702b7b6, 0x692f69ca, 0x39a939d9, 
	0xd3d7d30c, 0xa761a723, 0xa21ea2ad, 0xc3b4c399, 
	0x6c506c44, 0x07040705, 0x04f6047f, 0x27c22746, 
	0xac16aca7, 0xd025d076, 0x50865013, 0xdc56dcf7, 
	0x8455841a, 0xe109e151, 0x7abe7a25, 0x139113ef, 

	0xd939a9d9, 0x90176790, 0x719cb371, 0xd2a6e8d2, 
	0x05070405, 0x9852fd98, 0x6580a365, 0xdfe476df, 
	0x08459a08, 0x024b9202, 0xa0e080a0, 0x665a7866, 
	0xddafe4dd, 0xb06addb0, 0xbf63d1bf, 0x362a3836, 
	0x54e60d54, 0x4320c643, 0x62cc3562, 0xbef298be, 
	0x1e12181e, 0x24ebf724, 0xd7a1ecd7, 0x77416c77, 
	0xbd2843bd, 0x32bc7532, 0xd47b37d4, 0x9b88269b, 
	0x700dfa70, 0xf94413f9, 0xb1fb94b1, 0x5a7e485a, 
	0x7a03f27a, 0xe48cd0e4, 0x47b68b47, 0x3c24303c, 
	0xa5e784a5, 0x416b5441, 0x06dddf06, 0xc56023c5, 
	0x45fd1945, 0xa33a5ba3, 0x68c23d68, 0x158d5915, 
	0x21ecf321, 0x3166ae31, 0x3e6fa23e, 0x16578216, 
	0x95106395, 0x5bef015b, 0x4db8834d, 0x91862e91, 
	0xb56dd9b5, 0x1f83511f, 0x53aa9b53, 0x635d7c63, 
	0x3b68a63b, 0x3ffeeb3f, 0xd630a5d6, 0x257abe25, 
	0xa7ac16a7, 0x0f090c0f, 0x35f0e335, 0x23a76123, 
	0xf090c0f0, 0xafe98caf, 0x809d3a80, 0x925cf592, 
	0x810c7381, 0x27312c27, 0x76d02576, 0xe7560be7, 
	0x7b92bb7b, 0xe9ce4ee9, 0xf10189f1, 0x9f1e6b9f, 
	0xa93453a9, 0xc4f16ac4, 0x99c3b499, 0x975bf197, 
	0x8347e183, 0x6b18e66b, 0xc822bdc8, 0x0e98450e, 
	0x6e1fe26e, 0xc9b3f4c9, 0x2f74b62f, 0xcbf866cb, 
	0xff99ccff, 0xea1495ea, 0xed5803ed, 0xf7dc56f7, 
	0xe18bd4e1, 0x1b151c1b, 0xada21ead, 0x0cd3d70c, 
	0x2be2fb2b, 0x1dc8c31d, 0x195e8e19, 0xc22cb5c2, 
	0x8949e989, 0x12c1cf12, 0x7e95bf7e, 0x207dba20, 
	0x6411ea64, 0x840b7784, 0x6dc5396d, 0x6a89af6a, 
	0xd17c33d1, 0xa171c9a1, 0xceff62ce, 0x37bb7137, 
	0xfb0f81fb, 0x3db5793d, 0x51e10951, 0xdc3eaddc, 
	0x2d3f242d, 0xa476cda4, 0x9d55f99d, 0xee82d8ee, 
	0x8640e586, 0xae78c5ae, 0xcd25b9cd, 0x04964d04, 
	0x55774455, 0x0a0e080a, 0x13508613, 0x30f7e730, 
	0xd337a1d3, 0x40fa1d40, 0x3461aa34, 0x8c4eed8c, 
	0xb3b006b3, 0x6c54706c, 0x2a73b22a, 0x523bd252, 
	0x0b9f410b, 0x8b027b8b, 0x88d8a088, 0x4ff3114f, 
	0x67cb3167, 0x4627c246, 0xc06727c0, 0xb4fc90b4, 
	0x28382028, 0x7f04f67f, 0x78486078, 0x2ee5ff2e, 
	0x074c9607, 0x4b655c4b, 0xc72bb1c7, 0x6f8eab6f, 
	0x0d429e0d, 0xbbf59cbb, 0xf2db52f2, 0xf34a1bf3, 
	0xa63d5fa6, 0x59a49359, 0xbcb90abc, 0x3af9ef3a, 
	0xef1391ef, 0xfe0885fe, 0x01914901, 0x6116ee61, 
	0x7cde2d7c, 0xb2214fb2, 0x42b18f42, 0xdb723bdb, 
	0xb82f47b8, 0x48bf8748, 0x2cae6d2c, 0xe3c046e3, 
	0x573cd657, 0x859a3e85, 0x29a96929, 0x7d4f647d, 
	0x94812a94, 0x492ece49, 0x17c6cb17, 0xca692fca, 
	0xc3bdfcc3, 0x5ca3975c, 0x5ee8055e, 0xd0ed7ad0, 
	0x87d1ac87, 0x8e057f8e, 0xba64d5ba, 0xa8a51aa8, 
	0xb7264bb7, 0xb9be0eb9, 0x6087a760, 0xf8d55af8, 
	0x22362822, 0x111b1411, 0xde753fde, 0x79d92979, 
	0xaaee88aa, 0x332d3c33, 0x5f794c5f, 0xb6b702b6, 
	0x96cab896, 0x5835da58, 0x9cc4b09c, 0xfc4317fc, 
	0x1a84551a, 0xf64d1ff6, 0x1c598a1c, 0x38b27d38, 
	0xac3357ac, 0x18cfc718, 0xf4068df4, 0x69537469, 
	0x749bb774, 0xf597c4f5, 0x56ad9f56, 0xdae372da, 
	0xd5ea7ed5, 0x4af4154a, 0x9e8f229e, 0xa2ab12a2, 
	0x4e62584e, 0xe85f07e8, 0xe51d99e5, 0x39233439, 
	0xc1f66ec1, 0x446c5044, 0x5d32de5d, 0x72466872, 
	0x26a06526, 0x93cdbc93, 0x03dadb03, 0xc6baf8c6, 
	0xfa9ec8fa, 0x82d6a882, 0xcf6e2bcf, 0x50704050, 
	0xeb85dceb, 0x750afe75, 0x8a93328a, 0x8ddfa48d, 
	0x4c29ca4c, 0x141c1014, 0x73d72173, 0xccb4f0cc, 
	0x09d4d309, 0x108a5d10, 0xe2510fe2, 0x00000000, 
	0x9a196f9a, 0xe01a9de0, 0x8f94368f, 0xe6c742e6, 
	0xecc94aec, 0xfdd25efd, 0xab7fc1ab, 0xd8a8e0d8};

###############################################################################

TITLE
    Square / Sharkbox crypto algorithm S encoding

TYPE
    8

DATA
177, 206, 195, 149,  90, 173, 231,   2,  77,  68, 251, 145,  12, 135, 161,  80, 
203, 103,  84, 221,  70, 143, 225,  78, 240, 253, 252, 235, 249, 196,  26, 110, 
 94, 245, 204, 141,  28,  86,  67, 254,   7,  97, 248, 117,  89, 255,   3,  34, 
138, 209,  19, 238, 136,   0,  14,  52,  21, 128, 148, 227, 237, 181,  83,  35, 
 75,  71,  23, 167, 144,  53, 171, 216, 184, 223,  79,  87, 154, 146, 219,  27, 
 60, 200, 153,   4, 142, 224, 215, 125, 133, 187,  64,  44,  58,  69, 241,  66, 
101,  32,  65,  24, 114,  37, 147, 112,  54,   5, 242,  11, 163, 121, 236,   8, 
 39,  49,  50, 182, 124, 176,  10, 115,  91, 123, 183, 129, 210,  13, 106,  38, 
158,  88, 156, 131, 116, 179, 172,  48, 122, 105, 119,  15, 174,  33, 222, 208, 
 46, 151,  16, 164, 152, 168, 212, 104,  45,  98,  41, 109,  22,  73, 118, 199, 
232, 193, 150,  55, 229, 202, 244, 233,  99,  18, 194, 166,  20, 188, 211,  40, 
175,  47, 230,  36,  82, 198, 160,   9, 189, 140, 207,  93,  17,  95,   1, 197, 
159,  61, 162, 155, 201,  59, 190,  81,  25,  31,  63,  92, 178, 239,  74, 205, 
191, 186, 111, 100, 217, 243,  62, 180, 170, 220, 213,   6, 192, 126, 246, 102, 
108, 132, 113,  56, 185,  29, 127, 157,  72, 139,  42, 218, 165,  51, 130,  57, 
214, 120, 134, 250, 228,  43, 169,  30, 137,  96, 107, 234,  85,  76, 247, 226, 

###############################################################################

TITLE
    Square / Sharkbox crypto algorithm S decoding

TYPE
    8

DATA
 53, 190,   7,  46,  83, 105, 219,  40, 111, 183, 118, 107,  12, 125,  54, 139, 
146, 188, 169,  50, 172,  56, 156,  66,  99, 200,  30,  79,  36, 229, 247, 201, 
 97, 141,  47,  63, 179, 101, 127, 112, 175, 154, 234, 245,  91, 152, 144, 177, 
135, 113, 114, 237,  55,  69, 104, 163, 227, 239,  92, 197,  80, 193, 214, 202, 
 90,  98,  95,  38,   9,  93,  20,  65, 232, 157, 206,  64, 253,   8,  23,  74, 
 15, 199, 180,  62,  18, 252,  37,  75, 129,  44,   4, 120, 203, 187,  32, 189, 
249,  41, 153, 168, 211,  96, 223,  17, 151, 137, 126, 250, 224, 155,  31, 210, 
103, 226, 100, 119, 132,  43, 158, 138, 241, 109, 136, 121, 116,  87, 221, 230, 
 57, 123, 238, 131, 225,  88, 242,  13,  52, 248,  48, 233, 185,  35,  84,  21, 
 68,  11,  77, 102,  58,   3, 162, 145, 148,  82,  76, 195, 130, 231, 128, 192, 
182,  14, 194, 108, 147, 236, 171,  67, 149, 246, 216,  70, 134,   5, 140, 176, 
117,   0, 204, 133, 215,  61, 115, 122,  72, 228, 209,  89, 173, 184, 198, 208, 
220, 161, 170,   2,  29, 191, 181, 159,  81, 196, 165,  16,  34, 207,   1, 186, 
143,  49, 124, 174, 150, 218, 240,  86,  71, 212, 235,  78, 217,  19, 142,  73, 
 85,  22, 255,  59, 244, 164, 178,   6, 160, 167, 251,  27, 110,  60,  51, 205, 
 24,  94, 106, 213, 166,  33, 222, 254,  42,  28, 243,  10,  26,  25,  39,  45, 

###############################################################################

TITLE
    Square crypto algorithm T encoding

TYPE
    32

DATA
0x97b1b126UL, 0x69cecea7UL, 0x73c3c3b0UL, 0xdf95954aUL, 
0xb45a5aeeUL, 0xafadad02UL, 0x3be7e7dcUL, 0x04020206UL, 
0x9a4d4dd7UL, 0x884444ccUL, 0x03fbfbf8UL, 0xd7919146UL, 
0x180c0c14UL, 0xfb87877cUL, 0xb7a1a116UL, 0xa05050f0UL, 
0x63cbcba8UL, 0xce6767a9UL, 0xa85454fcUL, 0x4fdddd92UL, 
0x8c4646caUL, 0xeb8f8f64UL, 0x37e1e1d6UL, 0x9c4e4ed2UL, 
0x15f0f0e5UL, 0x0ffdfdf2UL, 0x0dfcfcf1UL, 0x23ebebc8UL, 
0x07f9f9feUL, 0x7dc4c4b9UL, 0x341a1a2eUL, 0xdc6e6eb2UL, 
0xbc5e5ee2UL, 0x1ff5f5eaUL, 0x6dcccca1UL, 0xef8d8d62UL, 
0x381c1c24UL, 0xac5656faUL, 0x864343c5UL, 0x09fefef7UL, 
0x0e070709UL, 0xc26161a3UL, 0x05f8f8fdUL, 0xea75759fUL, 
0xb25959ebUL, 0x0bfffff4UL, 0x06030305UL, 0x44222266UL, 
0xe18a8a6bUL, 0x57d1d186UL, 0x26131335UL, 0x29eeeec7UL, 
0xe588886dUL, 0x00000000UL, 0x1c0e0e12UL, 0x6834345cUL, 
0x2a15153fUL, 0xf5808075UL, 0xdd949449UL, 0x33e3e3d0UL, 
0x2fededc2UL, 0x9fb5b52aUL, 0xa65353f5UL, 0x46232365UL, 
0x964b4bddUL, 0x8e4747c9UL, 0x2e171739UL, 0xbba7a71cUL, 
0xd5909045UL, 0x6a35355fUL, 0xa3abab08UL, 0x45d8d89dUL, 
0x85b8b83dUL, 0x4bdfdf94UL, 0x9e4f4fd1UL, 0xae5757f9UL, 
0xc19a9a5bUL, 0xd1929243UL, 0x43dbdb98UL, 0x361b1b2dUL, 
0x783c3c44UL, 0x65c8c8adUL, 0xc799995eUL, 0x0804040cUL, 
0xe98e8e67UL, 0x35e0e0d5UL, 0x5bd7d78cUL, 0xfa7d7d87UL, 
0xff85857aUL, 0x83bbbb38UL, 0x804040c0UL, 0x582c2c74UL, 
0x743a3a4eUL, 0x8a4545cfUL, 0x17f1f1e6UL, 0x844242c6UL, 
0xca6565afUL, 0x40202060UL, 0x824141c3UL, 0x30181828UL, 
0xe4727296UL, 0x4a25256fUL, 0xd3939340UL, 0xe0707090UL, 
0x6c36365aUL, 0x0a05050fUL, 0x11f2f2e3UL, 0x160b0b1dUL, 
0xb3a3a310UL, 0xf279798bUL, 0x2dececc1UL, 0x10080818UL, 
0x4e272769UL, 0x62313153UL, 0x64323256UL, 0x99b6b62fUL, 
0xf87c7c84UL, 0x95b0b025UL, 0x140a0a1eUL, 0xe6737395UL, 
0xb65b5bedUL, 0xf67b7b8dUL, 0x9bb7b72cUL, 0xf7818176UL, 
0x51d2d283UL, 0x1a0d0d17UL, 0xd46a6abeUL, 0x4c26266aUL, 
0xc99e9e57UL, 0xb05858e8UL, 0xcd9c9c51UL, 0xf3838370UL, 
0xe874749cUL, 0x93b3b320UL, 0xadacac01UL, 0x60303050UL, 
0xf47a7a8eUL, 0xd26969bbUL, 0xee777799UL, 0x1e0f0f11UL, 
0xa9aeae07UL, 0x42212163UL, 0x49dede97UL, 0x55d0d085UL, 
0x5c2e2e72UL, 0xdb97974cUL, 0x20101030UL, 0xbda4a419UL, 
0xc598985dUL, 0xa5a8a80dUL, 0x5dd4d489UL, 0xd06868b8UL, 
0x5a2d2d77UL, 0xc46262a6UL, 0x5229297bUL, 0xda6d6db7UL, 
0x2c16163aUL, 0x924949dbUL, 0xec76769aUL, 0x7bc7c7bcUL, 
0x25e8e8cdUL, 0x77c1c1b6UL, 0xd996964fUL, 0x6e373759UL, 
0x3fe5e5daUL, 0x61cacaabUL, 0x1df4f4e9UL, 0x27e9e9ceUL, 
0xc66363a5UL, 0x24121236UL, 0x71c2c2b3UL, 0xb9a6a61fUL, 
0x2814143cUL, 0x8dbcbc31UL, 0x53d3d380UL, 0x50282878UL, 
0xabafaf04UL, 0x5e2f2f71UL, 0x39e6e6dfUL, 0x4824246cUL, 
0xa45252f6UL, 0x79c6c6bfUL, 0xb5a0a015UL, 0x1209091bUL, 
0x8fbdbd32UL, 0xed8c8c61UL, 0x6bcfcfa4UL, 0xba5d5de7UL, 
0x22111133UL, 0xbe5f5fe1UL, 0x02010103UL, 0x7fc5c5baUL, 
0xcb9f9f54UL, 0x7a3d3d47UL, 0xb1a2a213UL, 0xc39b9b58UL, 
0x67c9c9aeUL, 0x763b3b4dUL, 0x89bebe37UL, 0xa25151f3UL, 
0x3219192bUL, 0x3e1f1f21UL, 0x7e3f3f41UL, 0xb85c5ce4UL, 
0x91b2b223UL, 0x2befefc4UL, 0x944a4adeUL, 0x6fcdcda2UL, 
0x8bbfbf34UL, 0x81baba3bUL, 0xde6f6fb1UL, 0xc86464acUL, 
0x47d9d99eUL, 0x13f3f3e0UL, 0x7c3e3e42UL, 0x9db4b429UL, 
0xa1aaaa0bUL, 0x4ddcdc91UL, 0x5fd5d58aUL, 0x0c06060aUL, 
0x75c0c0b5UL, 0xfc7e7e82UL, 0x19f6f6efUL, 0xcc6666aaUL, 
0xd86c6cb4UL, 0xfd848479UL, 0xe2717193UL, 0x70383848UL, 
0x87b9b93eUL, 0x3a1d1d27UL, 0xfe7f7f81UL, 0xcf9d9d52UL, 
0x904848d8UL, 0xe38b8b68UL, 0x542a2a7eUL, 0x41dada9bUL, 
0xbfa5a51aUL, 0x66333355UL, 0xf1828273UL, 0x7239394bUL, 
0x59d6d68fUL, 0xf0787888UL, 0xf986867fUL, 0x01fafafbUL, 
0x3de4e4d9UL, 0x562b2b7dUL, 0xa7a9a90eUL, 0x3c1e1e22UL, 
0xe789896eUL, 0xc06060a0UL, 0xd66b6bbdUL, 0x21eaeacbUL, 
0xaa5555ffUL, 0x984c4cd4UL, 0x1bf7f7ecUL, 0x31e2e2d3UL, 
},

{
0x2697b1b1UL, 0xa769ceceUL, 0xb073c3c3UL, 0x4adf9595UL, 
0xeeb45a5aUL, 0x02afadadUL, 0xdc3be7e7UL, 0x06040202UL, 
0xd79a4d4dUL, 0xcc884444UL, 0xf803fbfbUL, 0x46d79191UL, 
0x14180c0cUL, 0x7cfb8787UL, 0x16b7a1a1UL, 0xf0a05050UL, 
0xa863cbcbUL, 0xa9ce6767UL, 0xfca85454UL, 0x924fddddUL, 
0xca8c4646UL, 0x64eb8f8fUL, 0xd637e1e1UL, 0xd29c4e4eUL, 
0xe515f0f0UL, 0xf20ffdfdUL, 0xf10dfcfcUL, 0xc823ebebUL, 
0xfe07f9f9UL, 0xb97dc4c4UL, 0x2e341a1aUL, 0xb2dc6e6eUL, 
0xe2bc5e5eUL, 0xea1ff5f5UL, 0xa16dccccUL, 0x62ef8d8dUL, 
0x24381c1cUL, 0xfaac5656UL, 0xc5864343UL, 0xf709fefeUL, 
0x090e0707UL, 0xa3c26161UL, 0xfd05f8f8UL, 0x9fea7575UL, 
0xebb25959UL, 0xf40bffffUL, 0x05060303UL, 0x66442222UL, 
0x6be18a8aUL, 0x8657d1d1UL, 0x35261313UL, 0xc729eeeeUL, 
0x6de58888UL, 0x00000000UL, 0x121c0e0eUL, 0x5c683434UL, 
0x3f2a1515UL, 0x75f58080UL, 0x49dd9494UL, 0xd033e3e3UL, 
0xc22fededUL, 0x2a9fb5b5UL, 0xf5a65353UL, 0x65462323UL, 
0xdd964b4bUL, 0xc98e4747UL, 0x392e1717UL, 0x1cbba7a7UL, 
0x45d59090UL, 0x5f6a3535UL, 0x08a3ababUL, 0x9d45d8d8UL, 
0x3d85b8b8UL, 0x944bdfdfUL, 0xd19e4f4fUL, 0xf9ae5757UL, 
0x5bc19a9aUL, 0x43d19292UL, 0x9843dbdbUL, 0x2d361b1bUL, 
0x44783c3cUL, 0xad65c8c8UL, 0x5ec79999UL, 0x0c080404UL, 
0x67e98e8eUL, 0xd535e0e0UL, 0x8c5bd7d7UL, 0x87fa7d7dUL, 
0x7aff8585UL, 0x3883bbbbUL, 0xc0804040UL, 0x74582c2cUL, 
0x4e743a3aUL, 0xcf8a4545UL, 0xe617f1f1UL, 0xc6844242UL, 
0xafca6565UL, 0x60402020UL, 0xc3824141UL, 0x28301818UL, 
0x96e47272UL, 0x6f4a2525UL, 0x40d39393UL, 0x90e07070UL, 
0x5a6c3636UL, 0x0f0a0505UL, 0xe311f2f2UL, 0x1d160b0bUL, 
0x10b3a3a3UL, 0x8bf27979UL, 0xc12dececUL, 0x18100808UL, 
0x694e2727UL, 0x53623131UL, 0x56643232UL, 0x2f99b6b6UL, 
0x84f87c7cUL, 0x2595b0b0UL, 0x1e140a0aUL, 0x95e67373UL, 
0xedb65b5bUL, 0x8df67b7bUL, 0x2c9bb7b7UL, 0x76f78181UL, 
0x8351d2d2UL, 0x171a0d0dUL, 0xbed46a6aUL, 0x6a4c2626UL, 
0x57c99e9eUL, 0xe8b05858UL, 0x51cd9c9cUL, 0x70f38383UL, 
0x9ce87474UL, 0x2093b3b3UL, 0x01adacacUL, 0x50603030UL, 
0x8ef47a7aUL, 0xbbd26969UL, 0x99ee7777UL, 0x111e0f0fUL, 
0x07a9aeaeUL, 0x63422121UL, 0x9749dedeUL, 0x8555d0d0UL, 
0x725c2e2eUL, 0x4cdb9797UL, 0x30201010UL, 0x19bda4a4UL, 
0x5dc59898UL, 0x0da5a8a8UL, 0x895dd4d4UL, 0xb8d06868UL, 
0x775a2d2dUL, 0xa6c46262UL, 0x7b522929UL, 0xb7da6d6dUL, 
0x3a2c1616UL, 0xdb924949UL, 0x9aec7676UL, 0xbc7bc7c7UL, 
0xcd25e8e8UL, 0xb677c1c1UL, 0x4fd99696UL, 0x596e3737UL, 
0xda3fe5e5UL, 0xab61cacaUL, 0xe91df4f4UL, 0xce27e9e9UL, 
0xa5c66363UL, 0x36241212UL, 0xb371c2c2UL, 0x1fb9a6a6UL, 
0x3c281414UL, 0x318dbcbcUL, 0x8053d3d3UL, 0x78502828UL, 
0x04abafafUL, 0x715e2f2fUL, 0xdf39e6e6UL, 0x6c482424UL, 
0xf6a45252UL, 0xbf79c6c6UL, 0x15b5a0a0UL, 0x1b120909UL, 
0x328fbdbdUL, 0x61ed8c8cUL, 0xa46bcfcfUL, 0xe7ba5d5dUL, 
0x33221111UL, 0xe1be5f5fUL, 0x03020101UL, 0xba7fc5c5UL, 
0x54cb9f9fUL, 0x477a3d3dUL, 0x13b1a2a2UL, 0x58c39b9bUL, 
0xae67c9c9UL, 0x4d763b3bUL, 0x3789bebeUL, 0xf3a25151UL, 
0x2b321919UL, 0x213e1f1fUL, 0x417e3f3fUL, 0xe4b85c5cUL, 
0x2391b2b2UL, 0xc42befefUL, 0xde944a4aUL, 0xa26fcdcdUL, 
0x348bbfbfUL, 0x3b81babaUL, 0xb1de6f6fUL, 0xacc86464UL, 
0x9e47d9d9UL, 0xe013f3f3UL, 0x427c3e3eUL, 0x299db4b4UL, 
0x0ba1aaaaUL, 0x914ddcdcUL, 0x8a5fd5d5UL, 0x0a0c0606UL, 
0xb575c0c0UL, 0x82fc7e7eUL, 0xef19f6f6UL, 0xaacc6666UL, 
0xb4d86c6cUL, 0x79fd8484UL, 0x93e27171UL, 0x48703838UL, 
0x3e87b9b9UL, 0x273a1d1dUL, 0x81fe7f7fUL, 0x52cf9d9dUL, 
0xd8904848UL, 0x68e38b8bUL, 0x7e542a2aUL, 0x9b41dadaUL, 
0x1abfa5a5UL, 0x55663333UL, 0x73f18282UL, 0x4b723939UL, 
0x8f59d6d6UL, 0x88f07878UL, 0x7ff98686UL, 0xfb01fafaUL, 
0xd93de4e4UL, 0x7d562b2bUL, 0x0ea7a9a9UL, 0x223c1e1eUL, 
0x6ee78989UL, 0xa0c06060UL, 0xbdd66b6bUL, 0xcb21eaeaUL, 
0xffaa5555UL, 0xd4984c4cUL, 0xec1bf7f7UL, 0xd331e2e2UL, 
},

{
0xb12697b1UL, 0xcea769ceUL, 0xc3b073c3UL, 0x954adf95UL, 
0x5aeeb45aUL, 0xad02afadUL, 0xe7dc3be7UL, 0x02060402UL, 
0x4dd79a4dUL, 0x44cc8844UL, 0xfbf803fbUL, 0x9146d791UL, 
0x0c14180cUL, 0x877cfb87UL, 0xa116b7a1UL, 0x50f0a050UL, 
0xcba863cbUL, 0x67a9ce67UL, 0x54fca854UL, 0xdd924fddUL, 
0x46ca8c46UL, 0x8f64eb8fUL, 0xe1d637e1UL, 0x4ed29c4eUL, 
0xf0e515f0UL, 0xfdf20ffdUL, 0xfcf10dfcUL, 0xebc823ebUL, 
0xf9fe07f9UL, 0xc4b97dc4UL, 0x1a2e341aUL, 0x6eb2dc6eUL, 
0x5ee2bc5eUL, 0xf5ea1ff5UL, 0xcca16dccUL, 0x8d62ef8dUL, 
0x1c24381cUL, 0x56faac56UL, 0x43c58643UL, 0xfef709feUL, 
0x07090e07UL, 0x61a3c261UL, 0xf8fd05f8UL, 0x759fea75UL, 
0x59ebb259UL, 0xfff40bffUL, 0x03050603UL, 0x22664422UL, 
0x8a6be18aUL, 0xd18657d1UL, 0x13352613UL, 0xeec729eeUL, 
0x886de588UL, 0x00000000UL, 0x0e121c0eUL, 0x345c6834UL, 
0x153f2a15UL, 0x8075f580UL, 0x9449dd94UL, 0xe3d033e3UL, 
0xedc22fedUL, 0xb52a9fb5UL, 0x53f5a653UL, 0x23654623UL, 
0x4bdd964bUL, 0x47c98e47UL, 0x17392e17UL, 0xa71cbba7UL, 
0x9045d590UL, 0x355f6a35UL, 0xab08a3abUL, 0xd89d45d8UL, 
0xb83d85b8UL, 0xdf944bdfUL, 0x4fd19e4fUL, 0x57f9ae57UL, 
0x9a5bc19aUL, 0x9243d192UL, 0xdb9843dbUL, 0x1b2d361bUL, 
0x3c44783cUL, 0xc8ad65c8UL, 0x995ec799UL, 0x040c0804UL, 
0x8e67e98eUL, 0xe0d535e0UL, 0xd78c5bd7UL, 0x7d87fa7dUL, 
0x857aff85UL, 0xbb3883bbUL, 0x40c08040UL, 0x2c74582cUL, 
0x3a4e743aUL, 0x45cf8a45UL, 0xf1e617f1UL, 0x42c68442UL, 
0x65afca65UL, 0x20604020UL, 0x41c38241UL, 0x18283018UL, 
0x7296e472UL, 0x256f4a25UL, 0x9340d393UL, 0x7090e070UL, 
0x365a6c36UL, 0x050f0a05UL, 0xf2e311f2UL, 0x0b1d160bUL, 
0xa310b3a3UL, 0x798bf279UL, 0xecc12decUL, 0x08181008UL, 
0x27694e27UL, 0x31536231UL, 0x32566432UL, 0xb62f99b6UL, 
0x7c84f87cUL, 0xb02595b0UL, 0x0a1e140aUL, 0x7395e673UL, 
0x5bedb65bUL, 0x7b8df67bUL, 0xb72c9bb7UL, 0x8176f781UL, 
0xd28351d2UL, 0x0d171a0dUL, 0x6abed46aUL, 0x266a4c26UL, 
0x9e57c99eUL, 0x58e8b058UL, 0x9c51cd9cUL, 0x8370f383UL, 
0x749ce874UL, 0xb32093b3UL, 0xac01adacUL, 0x30506030UL, 
0x7a8ef47aUL, 0x69bbd269UL, 0x7799ee77UL, 0x0f111e0fUL, 
0xae07a9aeUL, 0x21634221UL, 0xde9749deUL, 0xd08555d0UL, 
0x2e725c2eUL, 0x974cdb97UL, 0x10302010UL, 0xa419bda4UL, 
0x985dc598UL, 0xa80da5a8UL, 0xd4895dd4UL, 0x68b8d068UL, 
0x2d775a2dUL, 0x62a6c462UL, 0x297b5229UL, 0x6db7da6dUL, 
0x163a2c16UL, 0x49db9249UL, 0x769aec76UL, 0xc7bc7bc7UL, 
0xe8cd25e8UL, 0xc1b677c1UL, 0x964fd996UL, 0x37596e37UL, 
0xe5da3fe5UL, 0xcaab61caUL, 0xf4e91df4UL, 0xe9ce27e9UL, 
0x63a5c663UL, 0x12362412UL, 0xc2b371c2UL, 0xa61fb9a6UL, 
0x143c2814UL, 0xbc318dbcUL, 0xd38053d3UL, 0x28785028UL, 
0xaf04abafUL, 0x2f715e2fUL, 0xe6df39e6UL, 0x246c4824UL, 
0x52f6a452UL, 0xc6bf79c6UL, 0xa015b5a0UL, 0x091b1209UL, 
0xbd328fbdUL, 0x8c61ed8cUL, 0xcfa46bcfUL, 0x5de7ba5dUL, 
0x11332211UL, 0x5fe1be5fUL, 0x01030201UL, 0xc5ba7fc5UL, 
0x9f54cb9fUL, 0x3d477a3dUL, 0xa213b1a2UL, 0x9b58c39bUL, 
0xc9ae67c9UL, 0x3b4d763bUL, 0xbe3789beUL, 0x51f3a251UL, 
0x192b3219UL, 0x1f213e1fUL, 0x3f417e3fUL, 0x5ce4b85cUL, 
0xb22391b2UL, 0xefc42befUL, 0x4ade944aUL, 0xcda26fcdUL, 
0xbf348bbfUL, 0xba3b81baUL, 0x6fb1de6fUL, 0x64acc864UL, 
0xd99e47d9UL, 0xf3e013f3UL, 0x3e427c3eUL, 0xb4299db4UL, 
0xaa0ba1aaUL, 0xdc914ddcUL, 0xd58a5fd5UL, 0x060a0c06UL, 
0xc0b575c0UL, 0x7e82fc7eUL, 0xf6ef19f6UL, 0x66aacc66UL, 
0x6cb4d86cUL, 0x8479fd84UL, 0x7193e271UL, 0x38487038UL, 
0xb93e87b9UL, 0x1d273a1dUL, 0x7f81fe7fUL, 0x9d52cf9dUL, 
0x48d89048UL, 0x8b68e38bUL, 0x2a7e542aUL, 0xda9b41daUL, 
0xa51abfa5UL, 0x33556633UL, 0x8273f182UL, 0x394b7239UL, 
0xd68f59d6UL, 0x7888f078UL, 0x867ff986UL, 0xfafb01faUL, 
0xe4d93de4UL, 0x2b7d562bUL, 0xa90ea7a9UL, 0x1e223c1eUL, 
0x896ee789UL, 0x60a0c060UL, 0x6bbdd66bUL, 0xeacb21eaUL, 
0x55ffaa55UL, 0x4cd4984cUL, 0xf7ec1bf7UL, 0xe2d331e2UL, 
},

{
0xb1b12697UL, 0xcecea769UL, 0xc3c3b073UL, 0x95954adfUL, 
0x5a5aeeb4UL, 0xadad02afUL, 0xe7e7dc3bUL, 0x02020604UL, 
0x4d4dd79aUL, 0x4444cc88UL, 0xfbfbf803UL, 0x919146d7UL, 
0x0c0c1418UL, 0x87877cfbUL, 0xa1a116b7UL, 0x5050f0a0UL, 
0xcbcba863UL, 0x6767a9ceUL, 0x5454fca8UL, 0xdddd924fUL, 
0x4646ca8cUL, 0x8f8f64ebUL, 0xe1e1d637UL, 0x4e4ed29cUL, 
0xf0f0e515UL, 0xfdfdf20fUL, 0xfcfcf10dUL, 0xebebc823UL, 
0xf9f9fe07UL, 0xc4c4b97dUL, 0x1a1a2e34UL, 0x6e6eb2dcUL, 
0x5e5ee2bcUL, 0xf5f5ea1fUL, 0xcccca16dUL, 0x8d8d62efUL, 
0x1c1c2438UL, 0x5656faacUL, 0x4343c586UL, 0xfefef709UL, 
0x0707090eUL, 0x6161a3c2UL, 0xf8f8fd05UL, 0x75759feaUL, 
0x5959ebb2UL, 0xfffff40bUL, 0x03030506UL, 0x22226644UL, 
0x8a8a6be1UL, 0xd1d18657UL, 0x13133526UL, 0xeeeec729UL, 
0x88886de5UL, 0x00000000UL, 0x0e0e121cUL, 0x34345c68UL, 
0x15153f2aUL, 0x808075f5UL, 0x949449ddUL, 0xe3e3d033UL, 
0xededc22fUL, 0xb5b52a9fUL, 0x5353f5a6UL, 0x23236546UL, 
0x4b4bdd96UL, 0x4747c98eUL, 0x1717392eUL, 0xa7a71cbbUL, 
0x909045d5UL, 0x35355f6aUL, 0xabab08a3UL, 0xd8d89d45UL, 
0xb8b83d85UL, 0xdfdf944bUL, 0x4f4fd19eUL, 0x5757f9aeUL, 
0x9a9a5bc1UL, 0x929243d1UL, 0xdbdb9843UL, 0x1b1b2d36UL, 
0x3c3c4478UL, 0xc8c8ad65UL, 0x99995ec7UL, 0x04040c08UL, 
0x8e8e67e9UL, 0xe0e0d535UL, 0xd7d78c5bUL, 0x7d7d87faUL, 
0x85857affUL, 0xbbbb3883UL, 0x4040c080UL, 0x2c2c7458UL, 
0x3a3a4e74UL, 0x4545cf8aUL, 0xf1f1e617UL, 0x4242c684UL, 
0x6565afcaUL, 0x20206040UL, 0x4141c382UL, 0x18182830UL, 
0x727296e4UL, 0x25256f4aUL, 0x939340d3UL, 0x707090e0UL, 
0x36365a6cUL, 0x05050f0aUL, 0xf2f2e311UL, 0x0b0b1d16UL, 
0xa3a310b3UL, 0x79798bf2UL, 0xececc12dUL, 0x08081810UL, 
0x2727694eUL, 0x31315362UL, 0x32325664UL, 0xb6b62f99UL, 
0x7c7c84f8UL, 0xb0b02595UL, 0x0a0a1e14UL, 0x737395e6UL, 
0x5b5bedb6UL, 0x7b7b8df6UL, 0xb7b72c9bUL, 0x818176f7UL, 
0xd2d28351UL, 0x0d0d171aUL, 0x6a6abed4UL, 0x26266a4cUL, 
0x9e9e57c9UL, 0x5858e8b0UL, 0x9c9c51cdUL, 0x838370f3UL, 
0x74749ce8UL, 0xb3b32093UL, 0xacac01adUL, 0x30305060UL, 
0x7a7a8ef4UL, 0x6969bbd2UL, 0x777799eeUL, 0x0f0f111eUL, 
0xaeae07a9UL, 0x21216342UL, 0xdede9749UL, 0xd0d08555UL, 
0x2e2e725cUL, 0x97974cdbUL, 0x10103020UL, 0xa4a419bdUL, 
0x98985dc5UL, 0xa8a80da5UL, 0xd4d4895dUL, 0x6868b8d0UL, 
0x2d2d775aUL, 0x6262a6c4UL, 0x29297b52UL, 0x6d6db7daUL, 
0x16163a2cUL, 0x4949db92UL, 0x76769aecUL, 0xc7c7bc7bUL, 
0xe8e8cd25UL, 0xc1c1b677UL, 0x96964fd9UL, 0x3737596eUL, 
0xe5e5da3fUL, 0xcacaab61UL, 0xf4f4e91dUL, 0xe9e9ce27UL, 
0x6363a5c6UL, 0x12123624UL, 0xc2c2b371UL, 0xa6a61fb9UL, 
0x14143c28UL, 0xbcbc318dUL, 0xd3d38053UL, 0x28287850UL, 
0xafaf04abUL, 0x2f2f715eUL, 0xe6e6df39UL, 0x24246c48UL, 
0x5252f6a4UL, 0xc6c6bf79UL, 0xa0a015b5UL, 0x09091b12UL, 
0xbdbd328fUL, 0x8c8c61edUL, 0xcfcfa46bUL, 0x5d5de7baUL, 
0x11113322UL, 0x5f5fe1beUL, 0x01010302UL, 0xc5c5ba7fUL, 
0x9f9f54cbUL, 0x3d3d477aUL, 0xa2a213b1UL, 0x9b9b58c3UL, 
0xc9c9ae67UL, 0x3b3b4d76UL, 0xbebe3789UL, 0x5151f3a2UL, 
0x19192b32UL, 0x1f1f213eUL, 0x3f3f417eUL, 0x5c5ce4b8UL, 
0xb2b22391UL, 0xefefc42bUL, 0x4a4ade94UL, 0xcdcda26fUL, 
0xbfbf348bUL, 0xbaba3b81UL, 0x6f6fb1deUL, 0x6464acc8UL, 
0xd9d99e47UL, 0xf3f3e013UL, 0x3e3e427cUL, 0xb4b4299dUL, 
0xaaaa0ba1UL, 0xdcdc914dUL, 0xd5d58a5fUL, 0x06060a0cUL, 
0xc0c0b575UL, 0x7e7e82fcUL, 0xf6f6ef19UL, 0x6666aaccUL, 
0x6c6cb4d8UL, 0x848479fdUL, 0x717193e2UL, 0x38384870UL, 
0xb9b93e87UL, 0x1d1d273aUL, 0x7f7f81feUL, 0x9d9d52cfUL, 
0x4848d890UL, 0x8b8b68e3UL, 0x2a2a7e54UL, 0xdada9b41UL, 
0xa5a51abfUL, 0x33335566UL, 0x828273f1UL, 0x39394b72UL, 
0xd6d68f59UL, 0x787888f0UL, 0x86867ff9UL, 0xfafafb01UL, 
0xe4e4d93dUL, 0x2b2b7d56UL, 0xa9a90ea7UL, 0x1e1e223cUL, 
0x89896ee7UL, 0x6060a0c0UL, 0x6b6bbdd6UL, 0xeaeacb21UL, 
0x5555ffaaUL, 0x4c4cd498UL, 0xf7f7ec1bUL, 0xe2e2d331UL, 

###############################################################################

TITLE
    Square crypto algorithm T decoding

TYPE
    32

DATA
0xe368bc02UL, 0x5585620cUL, 0x2a3f2331UL, 0x61ab13f7UL, 
0x98d46d72UL, 0x21cb9a19UL, 0x3c22a461UL, 0x459d3dcdUL, 
0x05fdb423UL, 0x2bc4075fUL, 0x9b2c01c0UL, 0x3dd9800fUL, 
0x486c5c74UL, 0xf97f7e85UL, 0xf173ab1fUL, 0xb6edde0eUL, 
0x283c6bedUL, 0x4997781aUL, 0x9f2a918dUL, 0xc9579f33UL, 
0xa907a8aaUL, 0xa50ded7dUL, 0x7c422d8fUL, 0x764db0c9UL, 
0x4d91e857UL, 0xcea963ccUL, 0xb4ee96d2UL, 0x3028e1b6UL, 
0x0df161b9UL, 0xbd196726UL, 0x419bad80UL, 0xc0a06ec7UL, 
0x5183f241UL, 0x92dbf034UL, 0x6fa21efcUL, 0x8f32ce4cUL, 
0x13e03373UL, 0x69a7c66dUL, 0xe56d6493UL, 0xbf1a2ffaUL, 
0xbb1cbfb7UL, 0x587403b5UL, 0xe76e2c4fUL, 0x5d89b796UL, 
0xe89c052aUL, 0x446619a3UL, 0x342e71fbUL, 0x0ff22965UL, 
0xfe81827aUL, 0xb11322f1UL, 0xa30835ecUL, 0xcd510f7eUL, 
0xff7aa614UL, 0x5c7293f8UL, 0x2fc29712UL, 0xf370e3c3UL, 
0x992f491cUL, 0xd1431568UL, 0xc2a3261bUL, 0x88cc32b3UL, 
0x8acf7a6fUL, 0xb0e8069fUL, 0x7a47f51eUL, 0xd2bb79daUL, 
0xe6950821UL, 0x4398e55cUL, 0xd0b83106UL, 0x11e37bafUL, 
0x7e416553UL, 0xccaa2b10UL, 0xd8b4e49cUL, 0x6456a7d4UL, 
0xfb7c3659UL, 0x724b2084UL, 0xea9f4df6UL, 0x6a5faadfUL, 
0x2dc1dfceUL, 0x70486858UL, 0xcaaff381UL, 0x0605d891UL, 
0x5a774b69UL, 0x94de28a5UL, 0x39df1042UL, 0x813bc347UL, 
0xfc82caa6UL, 0x23c8d2c5UL, 0x03f86cb2UL, 0x080cd59aUL, 
0xdab7ac40UL, 0x7db909e1UL, 0x3824342cUL, 0xcf5247a2UL, 
0xdcb274d1UL, 0x63a85b2bUL, 0x35d55595UL, 0x479e7511UL, 
0x15e5ebe2UL, 0x4b9430c6UL, 0x4a6f14a8UL, 0x91239c86UL, 
0x4c6acc39UL, 0x5f8aff4aUL, 0x0406904dUL, 0xee99ddbbUL, 
0x1e1152caUL, 0xaaffc418UL, 0xeb646998UL, 0x07fefcffUL, 
0x8b345e01UL, 0x567d0ebeUL, 0xbae79bd9UL, 0x4263c132UL, 
0x75b5dc7bUL, 0x97264417UL, 0x67aecb66UL, 0x95250ccbUL, 
0xec9a9567UL, 0x57862ad0UL, 0x60503799UL, 0xb8e4d305UL, 
0x65ad83baUL, 0x19efae35UL, 0xa4f6c913UL, 0xc15b4aa9UL, 
0x873e1bd6UL, 0xa0f0595eUL, 0x18148a5bUL, 0xaf02703bUL, 
0xab04e076UL, 0xdd4950bfUL, 0xdf4a1863UL, 0xc6a5b656UL, 
0x853d530aUL, 0xfa871237UL, 0x77b694a7UL, 0x4665517fUL, 
0xed61b109UL, 0x1bece6e9UL, 0xd5458525UL, 0xf5753b52UL, 
0x7fba413dUL, 0x27ce4288UL, 0xb2eb4e43UL, 0xd6bde997UL, 
0x527b9ef3UL, 0x62537f45UL, 0x2c3afba0UL, 0x7bbcd170UL, 
0xb91ff76bUL, 0x121b171dUL, 0xfd79eec8UL, 0x3a277cf0UL, 
0x0c0a45d7UL, 0x96dd6079UL, 0x2233f6abUL, 0xacfa1c89UL, 
0xc8acbb5dUL, 0xa10b7d30UL, 0xd4bea14bUL, 0xbee10b94UL, 
0x25cd0a54UL, 0x547e4662UL, 0xa2f31182UL, 0x17e6a33eUL, 
0x263566e6UL, 0xc3580275UL, 0x83388b9bUL, 0x7844bdc2UL, 
0x020348dcUL, 0x4f92a08bUL, 0x2e39b37cUL, 0x4e6984e5UL, 
0xf0888f71UL, 0x362d3927UL, 0x9cd2fd3fUL, 0x01fb246eUL, 
0x893716ddUL, 0x00000000UL, 0xf68d57e0UL, 0xe293986cUL, 
0x744ef815UL, 0x9320d45aUL, 0xad0138e7UL, 0xd3405db4UL, 
0x1a17c287UL, 0xb3106a2dUL, 0x5078d62fUL, 0xf48e1f3cUL, 
0xa70ea5a1UL, 0x71b34c36UL, 0x9ad725aeUL, 0x5e71db24UL, 
0x161d8750UL, 0xef62f9d5UL, 0x8d318690UL, 0x1c121a16UL, 
0xa6f581cfUL, 0x5b8c6f07UL, 0x37d61d49UL, 0x6e593a92UL, 
0x84c67764UL, 0x86c53fb8UL, 0xd746cdf9UL, 0xe090d0b0UL, 
0x29c74f83UL, 0xe49640fdUL, 0x0e090d0bUL, 0x6da15620UL, 
0x8ec9ea22UL, 0xdb4c882eUL, 0xf776738eUL, 0xb515b2bcUL, 
0x10185fc1UL, 0x322ba96aUL, 0x6ba48eb1UL, 0xaef95455UL, 
0x406089eeUL, 0x6655ef08UL, 0xe9672144UL, 0x3e21ecbdUL, 
0x2030be77UL, 0xf28bc7adUL, 0x80c0e729UL, 0x141ecf8cUL, 
0xbce24348UL, 0xc4a6fe8aUL, 0x31d3c5d8UL, 0xb716fa60UL, 
0x5380ba9dUL, 0xd94fc0f2UL, 0x1de93e78UL, 0x24362e3aUL, 
0xe16bf4deUL, 0xcb54d7efUL, 0x09f7f1f4UL, 0x82c3aff5UL, 
0x0bf4b928UL, 0x9d29d951UL, 0xc75e9238UL, 0xf8845aebUL, 
0x90d8b8e8UL, 0xdeb13c0dUL, 0x33d08d04UL, 0x685ce203UL, 
0xc55ddae4UL, 0x3bdc589eUL, 0x0a0f9d46UL, 0x3fdac8d3UL, 
0x598f27dbUL, 0xa8fc8cc4UL, 0x79bf99acUL, 0x6c5a724eUL, 
0x8ccaa2feUL, 0x9ed1b5e3UL, 0x1fea76a4UL, 0x73b004eaUL, 
},

{
0x02e368bcUL, 0x0c558562UL, 0x312a3f23UL, 0xf761ab13UL, 
0x7298d46dUL, 0x1921cb9aUL, 0x613c22a4UL, 0xcd459d3dUL, 
0x2305fdb4UL, 0x5f2bc407UL, 0xc09b2c01UL, 0x0f3dd980UL, 
0x74486c5cUL, 0x85f97f7eUL, 0x1ff173abUL, 0x0eb6eddeUL, 
0xed283c6bUL, 0x1a499778UL, 0x8d9f2a91UL, 0x33c9579fUL, 
0xaaa907a8UL, 0x7da50dedUL, 0x8f7c422dUL, 0xc9764db0UL, 
0x574d91e8UL, 0xcccea963UL, 0xd2b4ee96UL, 0xb63028e1UL, 
0xb90df161UL, 0x26bd1967UL, 0x80419badUL, 0xc7c0a06eUL, 
0x415183f2UL, 0x3492dbf0UL, 0xfc6fa21eUL, 0x4c8f32ceUL, 
0x7313e033UL, 0x6d69a7c6UL, 0x93e56d64UL, 0xfabf1a2fUL, 
0xb7bb1cbfUL, 0xb5587403UL, 0x4fe76e2cUL, 0x965d89b7UL, 
0x2ae89c05UL, 0xa3446619UL, 0xfb342e71UL, 0x650ff229UL, 
0x7afe8182UL, 0xf1b11322UL, 0xeca30835UL, 0x7ecd510fUL, 
0x14ff7aa6UL, 0xf85c7293UL, 0x122fc297UL, 0xc3f370e3UL, 
0x1c992f49UL, 0x68d14315UL, 0x1bc2a326UL, 0xb388cc32UL, 
0x6f8acf7aUL, 0x9fb0e806UL, 0x1e7a47f5UL, 0xdad2bb79UL, 
0x21e69508UL, 0x5c4398e5UL, 0x06d0b831UL, 0xaf11e37bUL, 
0x537e4165UL, 0x10ccaa2bUL, 0x9cd8b4e4UL, 0xd46456a7UL, 
0x59fb7c36UL, 0x84724b20UL, 0xf6ea9f4dUL, 0xdf6a5faaUL, 
0xce2dc1dfUL, 0x58704868UL, 0x81caaff3UL, 0x910605d8UL, 
0x695a774bUL, 0xa594de28UL, 0x4239df10UL, 0x47813bc3UL, 
0xa6fc82caUL, 0xc523c8d2UL, 0xb203f86cUL, 0x9a080cd5UL, 
0x40dab7acUL, 0xe17db909UL, 0x2c382434UL, 0xa2cf5247UL, 
0xd1dcb274UL, 0x2b63a85bUL, 0x9535d555UL, 0x11479e75UL, 
0xe215e5ebUL, 0xc64b9430UL, 0xa84a6f14UL, 0x8691239cUL, 
0x394c6accUL, 0x4a5f8affUL, 0x4d040690UL, 0xbbee99ddUL, 
0xca1e1152UL, 0x18aaffc4UL, 0x98eb6469UL, 0xff07fefcUL, 
0x018b345eUL, 0xbe567d0eUL, 0xd9bae79bUL, 0x324263c1UL, 
0x7b75b5dcUL, 0x17972644UL, 0x6667aecbUL, 0xcb95250cUL, 
0x67ec9a95UL, 0xd057862aUL, 0x99605037UL, 0x05b8e4d3UL, 
0xba65ad83UL, 0x3519efaeUL, 0x13a4f6c9UL, 0xa9c15b4aUL, 
0xd6873e1bUL, 0x5ea0f059UL, 0x5b18148aUL, 0x3baf0270UL, 
0x76ab04e0UL, 0xbfdd4950UL, 0x63df4a18UL, 0x56c6a5b6UL, 
0x0a853d53UL, 0x37fa8712UL, 0xa777b694UL, 0x7f466551UL, 
0x09ed61b1UL, 0xe91bece6UL, 0x25d54585UL, 0x52f5753bUL, 
0x3d7fba41UL, 0x8827ce42UL, 0x43b2eb4eUL, 0x97d6bde9UL, 
0xf3527b9eUL, 0x4562537fUL, 0xa02c3afbUL, 0x707bbcd1UL, 
0x6bb91ff7UL, 0x1d121b17UL, 0xc8fd79eeUL, 0xf03a277cUL, 
0xd70c0a45UL, 0x7996dd60UL, 0xab2233f6UL, 0x89acfa1cUL, 
0x5dc8acbbUL, 0x30a10b7dUL, 0x4bd4bea1UL, 0x94bee10bUL, 
0x5425cd0aUL, 0x62547e46UL, 0x82a2f311UL, 0x3e17e6a3UL, 
0xe6263566UL, 0x75c35802UL, 0x9b83388bUL, 0xc27844bdUL, 
0xdc020348UL, 0x8b4f92a0UL, 0x7c2e39b3UL, 0xe54e6984UL, 
0x71f0888fUL, 0x27362d39UL, 0x3f9cd2fdUL, 0x6e01fb24UL, 
0xdd893716UL, 0x00000000UL, 0xe0f68d57UL, 0x6ce29398UL, 
0x15744ef8UL, 0x5a9320d4UL, 0xe7ad0138UL, 0xb4d3405dUL, 
0x871a17c2UL, 0x2db3106aUL, 0x2f5078d6UL, 0x3cf48e1fUL, 
0xa1a70ea5UL, 0x3671b34cUL, 0xae9ad725UL, 0x245e71dbUL, 
0x50161d87UL, 0xd5ef62f9UL, 0x908d3186UL, 0x161c121aUL, 
0xcfa6f581UL, 0x075b8c6fUL, 0x4937d61dUL, 0x926e593aUL, 
0x6484c677UL, 0xb886c53fUL, 0xf9d746cdUL, 0xb0e090d0UL, 
0x8329c74fUL, 0xfde49640UL, 0x0b0e090dUL, 0x206da156UL, 
0x228ec9eaUL, 0x2edb4c88UL, 0x8ef77673UL, 0xbcb515b2UL, 
0xc110185fUL, 0x6a322ba9UL, 0xb16ba48eUL, 0x55aef954UL, 
0xee406089UL, 0x086655efUL, 0x44e96721UL, 0xbd3e21ecUL, 
0x772030beUL, 0xadf28bc7UL, 0x2980c0e7UL, 0x8c141ecfUL, 
0x48bce243UL, 0x8ac4a6feUL, 0xd831d3c5UL, 0x60b716faUL, 
0x9d5380baUL, 0xf2d94fc0UL, 0x781de93eUL, 0x3a24362eUL, 
0xdee16bf4UL, 0xefcb54d7UL, 0xf409f7f1UL, 0xf582c3afUL, 
0x280bf4b9UL, 0x519d29d9UL, 0x38c75e92UL, 0xebf8845aUL, 
0xe890d8b8UL, 0x0ddeb13cUL, 0x0433d08dUL, 0x03685ce2UL, 
0xe4c55ddaUL, 0x9e3bdc58UL, 0x460a0f9dUL, 0xd33fdac8UL, 
0xdb598f27UL, 0xc4a8fc8cUL, 0xac79bf99UL, 0x4e6c5a72UL, 
0xfe8ccaa2UL, 0xe39ed1b5UL, 0xa41fea76UL, 0xea73b004UL, 
},

{
0xbc02e368UL, 0x620c5585UL, 0x23312a3fUL, 0x13f761abUL, 
0x6d7298d4UL, 0x9a1921cbUL, 0xa4613c22UL, 0x3dcd459dUL, 
0xb42305fdUL, 0x075f2bc4UL, 0x01c09b2cUL, 0x800f3dd9UL, 
0x5c74486cUL, 0x7e85f97fUL, 0xab1ff173UL, 0xde0eb6edUL, 
0x6bed283cUL, 0x781a4997UL, 0x918d9f2aUL, 0x9f33c957UL, 
0xa8aaa907UL, 0xed7da50dUL, 0x2d8f7c42UL, 0xb0c9764dUL, 
0xe8574d91UL, 0x63cccea9UL, 0x96d2b4eeUL, 0xe1b63028UL, 
0x61b90df1UL, 0x6726bd19UL, 0xad80419bUL, 0x6ec7c0a0UL, 
0xf2415183UL, 0xf03492dbUL, 0x1efc6fa2UL, 0xce4c8f32UL, 
0x337313e0UL, 0xc66d69a7UL, 0x6493e56dUL, 0x2ffabf1aUL, 
0xbfb7bb1cUL, 0x03b55874UL, 0x2c4fe76eUL, 0xb7965d89UL, 
0x052ae89cUL, 0x19a34466UL, 0x71fb342eUL, 0x29650ff2UL, 
0x827afe81UL, 0x22f1b113UL, 0x35eca308UL, 0x0f7ecd51UL, 
0xa614ff7aUL, 0x93f85c72UL, 0x97122fc2UL, 0xe3c3f370UL, 
0x491c992fUL, 0x1568d143UL, 0x261bc2a3UL, 0x32b388ccUL, 
0x7a6f8acfUL, 0x069fb0e8UL, 0xf51e7a47UL, 0x79dad2bbUL, 
0x0821e695UL, 0xe55c4398UL, 0x3106d0b8UL, 0x7baf11e3UL, 
0x65537e41UL, 0x2b10ccaaUL, 0xe49cd8b4UL, 0xa7d46456UL, 
0x3659fb7cUL, 0x2084724bUL, 0x4df6ea9fUL, 0xaadf6a5fUL, 
0xdfce2dc1UL, 0x68587048UL, 0xf381caafUL, 0xd8910605UL, 
0x4b695a77UL, 0x28a594deUL, 0x104239dfUL, 0xc347813bUL, 
0xcaa6fc82UL, 0xd2c523c8UL, 0x6cb203f8UL, 0xd59a080cUL, 
0xac40dab7UL, 0x09e17db9UL, 0x342c3824UL, 0x47a2cf52UL, 
0x74d1dcb2UL, 0x5b2b63a8UL, 0x559535d5UL, 0x7511479eUL, 
0xebe215e5UL, 0x30c64b94UL, 0x14a84a6fUL, 0x9c869123UL, 
0xcc394c6aUL, 0xff4a5f8aUL, 0x904d0406UL, 0xddbbee99UL, 
0x52ca1e11UL, 0xc418aaffUL, 0x6998eb64UL, 0xfcff07feUL, 
0x5e018b34UL, 0x0ebe567dUL, 0x9bd9bae7UL, 0xc1324263UL, 
0xdc7b75b5UL, 0x44179726UL, 0xcb6667aeUL, 0x0ccb9525UL, 
0x9567ec9aUL, 0x2ad05786UL, 0x37996050UL, 0xd305b8e4UL, 
0x83ba65adUL, 0xae3519efUL, 0xc913a4f6UL, 0x4aa9c15bUL, 
0x1bd6873eUL, 0x595ea0f0UL, 0x8a5b1814UL, 0x703baf02UL, 
0xe076ab04UL, 0x50bfdd49UL, 0x1863df4aUL, 0xb656c6a5UL, 
0x530a853dUL, 0x1237fa87UL, 0x94a777b6UL, 0x517f4665UL, 
0xb109ed61UL, 0xe6e91becUL, 0x8525d545UL, 0x3b52f575UL, 
0x413d7fbaUL, 0x428827ceUL, 0x4e43b2ebUL, 0xe997d6bdUL, 
0x9ef3527bUL, 0x7f456253UL, 0xfba02c3aUL, 0xd1707bbcUL, 
0xf76bb91fUL, 0x171d121bUL, 0xeec8fd79UL, 0x7cf03a27UL, 
0x45d70c0aUL, 0x607996ddUL, 0xf6ab2233UL, 0x1c89acfaUL, 
0xbb5dc8acUL, 0x7d30a10bUL, 0xa14bd4beUL, 0x0b94bee1UL, 
0x0a5425cdUL, 0x4662547eUL, 0x1182a2f3UL, 0xa33e17e6UL, 
0x66e62635UL, 0x0275c358UL, 0x8b9b8338UL, 0xbdc27844UL, 
0x48dc0203UL, 0xa08b4f92UL, 0xb37c2e39UL, 0x84e54e69UL, 
0x8f71f088UL, 0x3927362dUL, 0xfd3f9cd2UL, 0x246e01fbUL, 
0x16dd8937UL, 0x00000000UL, 0x57e0f68dUL, 0x986ce293UL, 
0xf815744eUL, 0xd45a9320UL, 0x38e7ad01UL, 0x5db4d340UL, 
0xc2871a17UL, 0x6a2db310UL, 0xd62f5078UL, 0x1f3cf48eUL, 
0xa5a1a70eUL, 0x4c3671b3UL, 0x25ae9ad7UL, 0xdb245e71UL, 
0x8750161dUL, 0xf9d5ef62UL, 0x86908d31UL, 0x1a161c12UL, 
0x81cfa6f5UL, 0x6f075b8cUL, 0x1d4937d6UL, 0x3a926e59UL, 
0x776484c6UL, 0x3fb886c5UL, 0xcdf9d746UL, 0xd0b0e090UL, 
0x4f8329c7UL, 0x40fde496UL, 0x0d0b0e09UL, 0x56206da1UL, 
0xea228ec9UL, 0x882edb4cUL, 0x738ef776UL, 0xb2bcb515UL, 
0x5fc11018UL, 0xa96a322bUL, 0x8eb16ba4UL, 0x5455aef9UL, 
0x89ee4060UL, 0xef086655UL, 0x2144e967UL, 0xecbd3e21UL, 
0xbe772030UL, 0xc7adf28bUL, 0xe72980c0UL, 0xcf8c141eUL, 
0x4348bce2UL, 0xfe8ac4a6UL, 0xc5d831d3UL, 0xfa60b716UL, 
0xba9d5380UL, 0xc0f2d94fUL, 0x3e781de9UL, 0x2e3a2436UL, 
0xf4dee16bUL, 0xd7efcb54UL, 0xf1f409f7UL, 0xaff582c3UL, 
0xb9280bf4UL, 0xd9519d29UL, 0x9238c75eUL, 0x5aebf884UL, 
0xb8e890d8UL, 0x3c0ddeb1UL, 0x8d0433d0UL, 0xe203685cUL, 
0xdae4c55dUL, 0x589e3bdcUL, 0x9d460a0fUL, 0xc8d33fdaUL, 
0x27db598fUL, 0x8cc4a8fcUL, 0x99ac79bfUL, 0x724e6c5aUL, 
0xa2fe8ccaUL, 0xb5e39ed1UL, 0x76a41feaUL, 0x04ea73b0UL, 
},

{
0x68bc02e3UL, 0x85620c55UL, 0x3f23312aUL, 0xab13f761UL, 
0xd46d7298UL, 0xcb9a1921UL, 0x22a4613cUL, 0x9d3dcd45UL, 
0xfdb42305UL, 0xc4075f2bUL, 0x2c01c09bUL, 0xd9800f3dUL, 
0x6c5c7448UL, 0x7f7e85f9UL, 0x73ab1ff1UL, 0xedde0eb6UL, 
0x3c6bed28UL, 0x97781a49UL, 0x2a918d9fUL, 0x579f33c9UL, 
0x07a8aaa9UL, 0x0ded7da5UL, 0x422d8f7cUL, 0x4db0c976UL, 
0x91e8574dUL, 0xa963ccceUL, 0xee96d2b4UL, 0x28e1b630UL, 
0xf161b90dUL, 0x196726bdUL, 0x9bad8041UL, 0xa06ec7c0UL, 
0x83f24151UL, 0xdbf03492UL, 0xa21efc6fUL, 0x32ce4c8fUL, 
0xe0337313UL, 0xa7c66d69UL, 0x6d6493e5UL, 0x1a2ffabfUL, 
0x1cbfb7bbUL, 0x7403b558UL, 0x6e2c4fe7UL, 0x89b7965dUL, 
0x9c052ae8UL, 0x6619a344UL, 0x2e71fb34UL, 0xf229650fUL, 
0x81827afeUL, 0x1322f1b1UL, 0x0835eca3UL, 0x510f7ecdUL, 
0x7aa614ffUL, 0x7293f85cUL, 0xc297122fUL, 0x70e3c3f3UL, 
0x2f491c99UL, 0x431568d1UL, 0xa3261bc2UL, 0xcc32b388UL, 
0xcf7a6f8aUL, 0xe8069fb0UL, 0x47f51e7aUL, 0xbb79dad2UL, 
0x950821e6UL, 0x98e55c43UL, 0xb83106d0UL, 0xe37baf11UL, 
0x4165537eUL, 0xaa2b10ccUL, 0xb4e49cd8UL, 0x56a7d464UL, 
0x7c3659fbUL, 0x4b208472UL, 0x9f4df6eaUL, 0x5faadf6aUL, 
0xc1dfce2dUL, 0x48685870UL, 0xaff381caUL, 0x05d89106UL, 
0x774b695aUL, 0xde28a594UL, 0xdf104239UL, 0x3bc34781UL, 
0x82caa6fcUL, 0xc8d2c523UL, 0xf86cb203UL, 0x0cd59a08UL, 
0xb7ac40daUL, 0xb909e17dUL, 0x24342c38UL, 0x5247a2cfUL, 
0xb274d1dcUL, 0xa85b2b63UL, 0xd5559535UL, 0x9e751147UL, 
0xe5ebe215UL, 0x9430c64bUL, 0x6f14a84aUL, 0x239c8691UL, 
0x6acc394cUL, 0x8aff4a5fUL, 0x06904d04UL, 0x99ddbbeeUL, 
0x1152ca1eUL, 0xffc418aaUL, 0x646998ebUL, 0xfefcff07UL, 
0x345e018bUL, 0x7d0ebe56UL, 0xe79bd9baUL, 0x63c13242UL, 
0xb5dc7b75UL, 0x26441797UL, 0xaecb6667UL, 0x250ccb95UL, 
0x9a9567ecUL, 0x862ad057UL, 0x50379960UL, 0xe4d305b8UL, 
0xad83ba65UL, 0xefae3519UL, 0xf6c913a4UL, 0x5b4aa9c1UL, 
0x3e1bd687UL, 0xf0595ea0UL, 0x148a5b18UL, 0x02703bafUL, 
0x04e076abUL, 0x4950bfddUL, 0x4a1863dfUL, 0xa5b656c6UL, 
0x3d530a85UL, 0x871237faUL, 0xb694a777UL, 0x65517f46UL, 
0x61b109edUL, 0xece6e91bUL, 0x458525d5UL, 0x753b52f5UL, 
0xba413d7fUL, 0xce428827UL, 0xeb4e43b2UL, 0xbde997d6UL, 
0x7b9ef352UL, 0x537f4562UL, 0x3afba02cUL, 0xbcd1707bUL, 
0x1ff76bb9UL, 0x1b171d12UL, 0x79eec8fdUL, 0x277cf03aUL, 
0x0a45d70cUL, 0xdd607996UL, 0x33f6ab22UL, 0xfa1c89acUL, 
0xacbb5dc8UL, 0x0b7d30a1UL, 0xbea14bd4UL, 0xe10b94beUL, 
0xcd0a5425UL, 0x7e466254UL, 0xf31182a2UL, 0xe6a33e17UL, 
0x3566e626UL, 0x580275c3UL, 0x388b9b83UL, 0x44bdc278UL, 
0x0348dc02UL, 0x92a08b4fUL, 0x39b37c2eUL, 0x6984e54eUL, 
0x888f71f0UL, 0x2d392736UL, 0xd2fd3f9cUL, 0xfb246e01UL, 
0x3716dd89UL, 0x00000000UL, 0x8d57e0f6UL, 0x93986ce2UL, 
0x4ef81574UL, 0x20d45a93UL, 0x0138e7adUL, 0x405db4d3UL, 
0x17c2871aUL, 0x106a2db3UL, 0x78d62f50UL, 0x8e1f3cf4UL, 
0x0ea5a1a7UL, 0xb34c3671UL, 0xd725ae9aUL, 0x71db245eUL, 
0x1d875016UL, 0x62f9d5efUL, 0x3186908dUL, 0x121a161cUL, 
0xf581cfa6UL, 0x8c6f075bUL, 0xd61d4937UL, 0x593a926eUL, 
0xc6776484UL, 0xc53fb886UL, 0x46cdf9d7UL, 0x90d0b0e0UL, 
0xc74f8329UL, 0x9640fde4UL, 0x090d0b0eUL, 0xa156206dUL, 
0xc9ea228eUL, 0x4c882edbUL, 0x76738ef7UL, 0x15b2bcb5UL, 
0x185fc110UL, 0x2ba96a32UL, 0xa48eb16bUL, 0xf95455aeUL, 
0x6089ee40UL, 0x55ef0866UL, 0x672144e9UL, 0x21ecbd3eUL, 
0x30be7720UL, 0x8bc7adf2UL, 0xc0e72980UL, 0x1ecf8c14UL, 
0xe24348bcUL, 0xa6fe8ac4UL, 0xd3c5d831UL, 0x16fa60b7UL, 
0x80ba9d53UL, 0x4fc0f2d9UL, 0xe93e781dUL, 0x362e3a24UL, 
0x6bf4dee1UL, 0x54d7efcbUL, 0xf7f1f409UL, 0xc3aff582UL, 
0xf4b9280bUL, 0x29d9519dUL, 0x5e9238c7UL, 0x845aebf8UL, 
0xd8b8e890UL, 0xb13c0ddeUL, 0xd08d0433UL, 0x5ce20368UL, 
0x5ddae4c5UL, 0xdc589e3bUL, 0x0f9d460aUL, 0xdac8d33fUL, 
0x8f27db59UL, 0xfc8cc4a8UL, 0xbf99ac79UL, 0x5a724e6cUL, 
0xcaa2fe8cUL, 0xd1b5e39eUL, 0xea76a41fUL, 0xb004ea73UL, 

###############################################################################

TITLE
    Skipjack crypto algorithm ftable

TYPE
    8

DATA
	0xa3,0xd7,0x09,0x83,0xf8,0x48,0xf6,0xf4,0xb3,0x21,0x15,0x78,0x99,0xb1,0xaf,0xf9,
	0xe7,0x2d,0x4d,0x8a,0xce,0x4c,0xca,0x2e,0x52,0x95,0xd9,0x1e,0x4e,0x38,0x44,0x28,
	0x0a,0xdf,0x02,0xa0,0x17,0xf1,0x60,0x68,0x12,0xb7,0x7a,0xc3,0xe9,0xfa,0x3d,0x53,
	0x96,0x84,0x6b,0xba,0xf2,0x63,0x9a,0x19,0x7c,0xae,0xe5,0xf5,0xf7,0x16,0x6a,0xa2,
	0x39,0xb6,0x7b,0x0f,0xc1,0x93,0x81,0x1b,0xee,0xb4,0x1a,0xea,0xd0,0x91,0x2f,0xb8,
	0x55,0xb9,0xda,0x85,0x3f,0x41,0xbf,0xe0,0x5a,0x58,0x80,0x5f,0x66,0x0b,0xd8,0x90,
	0x35,0xd5,0xc0,0xa7,0x33,0x06,0x65,0x69,0x45,0x00,0x94,0x56,0x6d,0x98,0x9b,0x76,
	0x97,0xfc,0xb2,0xc2,0xb0,0xfe,0xdb,0x20,0xe1,0xeb,0xd6,0xe4,0xdd,0x47,0x4a,0x1d,
	0x42,0xed,0x9e,0x6e,0x49,0x3c,0xcd,0x43,0x27,0xd2,0x07,0xd4,0xde,0xc7,0x67,0x18,
	0x89,0xcb,0x30,0x1f,0x8d,0xc6,0x8f,0xaa,0xc8,0x74,0xdc,0xc9,0x5d,0x5c,0x31,0xa4,
	0x70,0x88,0x61,0x2c,0x9f,0x0d,0x2b,0x87,0x50,0x82,0x54,0x64,0x26,0x7d,0x03,0x40,
	0x34,0x4b,0x1c,0x73,0xd1,0xc4,0xfd,0x3b,0xcc,0xfb,0x7f,0xab,0xe6,0x3e,0x5b,0xa5,
	0xad,0x04,0x23,0x9c,0x14,0x51,0x22,0xf0,0x29,0x79,0x71,0x7e,0xff,0x8c,0x0e,0xe2,
	0x0c,0xef,0xbc,0x72,0x75,0x6f,0x37,0xa1,0xec,0xd3,0x8e,0x62,0x8b,0x86,0x10,0xe8,
	0x08,0x77,0x11,0xbe,0x92,0x4f,0x24,0xc5,0x32,0x36,0x9d,0xcf,0xf3,0xa6,0xbb,0xac,
	0x5e,0x6c,0xa9,0x13,0x57,0x25,0xb5,0xe3,0xbd,0xa8,0x3a,0x01,0x05,0x59,0x2a,0x46

###############################################################################

TITLE
    Sharkbox crypto algorithm Enc cbox

TYPE
    64

DATA
    0x060d838f16f3a365,
    0xa68857ee5cae56f6,
    0xebf516353c2c4d89,
    0x652174be88e85bdc,
    0x0d4e9a8086c17921,
    0x27ba7d33cffa58a1,
    0x88d9e104a237b530,
    0x693b8755a4fbe816,
    0xdac9591826b254a0,
    0x45c2e369fb336af3,
    0xa96e1fb87b3e4ef4,
    0xb7578f1435eb7ef0,
    0x839af80b32056f74,
    0xae37f55cc71f277a,
    0xa4208538fdff37d5,
    0x35991e74ad3cdb6f,
    0xba191594b32a07d1,
    0x5344d1772e572b7b,
    0xe7efe5de103ffe43,
    0xa3796fdc41de5e5b,
    0x2cf9643c5fc882e5,
    0xffdbf6fd48196d22,
    0x33949dfbbbcf780a,
    0x7d15679dd0cec8bd,
    0x5f5e229c024498b1,
    0x1223634762c683ce,
    0xdcc4da973041f7c5,
    0x0b43190f9032da44,
    0xc05598eddfc5a6e2,
    0x9e5fd31a7753f4b8,
    0x9afa8243c0f136fe,
    0xcc4f6b06f3d61528,
    0xdf38612a3bc25c0d,
    0x43cf60e6edc0c996,
    0xcfb3d0bbf855bee0,
    0x96e071a8ece28534,
    0x21b7febcd909fbc4,
    0x8ed4628bb4c41655,
    0x30682646b04cd3c2,
    0xb5ff5dc294ba1fd3,
    0x75aac52f4b7fb931,
    0xe809ad8837afe641,
    0x0eb2213d8d42d2e9,
    0x9852509561a057dd,
    0xaa92a40570bde53c,
    0x7b18e412c63d6bd8,
    0xa7dc3e85f67c9c1d,
    0xd8618bce87e33583,
    0xe34ab487a79d3c05,
    0x20e397d773db312f,
    0x05f138321d7008ad,
    0x17d25b757fb68b63,
    0x8a7133d20366d413,
    0x0000000000000000,
    0xeaa17f5e96fe8762,
    0xc101f18675176c09,
    0xbebc44cd0488c597,
    0xdb9d30738c609e4b,
    0xabc6cd6eda6f2fd7,
    0x5aaf1aae1f34901c,
    0xb00e65f089ca177e,
    0xd47b7825abf08649,
    0x924520f15b404772,
    0x1686321ed5644188,
    0x618425e73f4a999a,
    0xe21eddec0d4ff6ee,
    0xd787c398a0732d81,
    0x1f6df9c7e407faef,
    0x79b036c4676c0afb,
    0x0fe6485627901802,
    0x9cf701ccd602959b,
    0xbfe82da6ae5a0f7c,
    0x990639fecb729d36,
    0xca42e889e525b64d,
    0xb3f2de4d8249bcb6,
    0x4033db5be643625e,
    0x4167b2304c91a8b5,
    0x108bb191c397e2ed,
    0x1834132358269361,
    0x541d3b93927642f5,
    0x90edf227fa112651,
    0x1dc52b1145569bcc,
    0xe6bb8cb5baed34a8,
    0xd276fbaabd03252c,
    0x313c4f2d1a9e1929,
    0xfd73242be9480c01,
    0x9baeeb286a23fc15,
    0xc9be5334eea61d85,
    0xc70c720963e4cf6c,
    0x3eda077b3d0e012b,
    0x97b418c346304fdf,
    0x32c0f490111db2e1,
    0x2ba08ed8e3e9eb6b,
    0x8b255ab9a9b41ef8,
    0x91b99b4c50c3ecba,
    0xfe8f9f96e2cba7c9,
    0x3a7f56228aacc36d,
    0xb15a0c9b2318dd95,
    0x5953a11314b73bd4,
    0xf3c10516640adee8,
    0xedf895ba2adfeeec,
    0xadcb4ee1cc9c8cb2,
    0xde6c0841911096e6,
    0x84c312ef8e2406fa,
    0xa83a76d3d1ec841f,
    0x1c91427aef845127,
    0x3665a5c9a6bf70a7,
    0xf6303d24797ad645,
    0xcd1b026d5904dfc3,
    0x1bc8a89e53a538a9,
    0x7ee9dc20db4d6375,
    0x51ec03a18f064a58,
    0xc4f0c9b4686764a4,
    0xdd90b3fc9a933d2e,
    0x7a4c8d796cefa133,
    0x73a746a05d8c1a54,
    0x0759eae4bc21698e,
    0xc8ea3a5f4474d76e,
    0x38d784f42bfda24e,
    0x231f2c6a78589ae7,
    0xc3a92350d4460d2a,
    0x72f32fcbf75ed0bf,
    0xbd40ff700f0b6e5f,
    0x157a89a3dee7ea40,
    0x873fa95285a7ad32,
    0x4d7d41db60821b7f,
    0x1e3990ac4ed53004,
    0x0a1770643ae010af,
    0x9311499af1928d99,
    0x64751dd5223a9137,
    0xfa2acecf5569658f,
    0x7c410ef67a1c0256,
    0x56b5e945332723d6,
    0x6f3604dab2084b73,
    0xe95dc4e39d7d2caa,
    0x13770a2cc8144925,
    0xbc14961ba5d9a4b4,
    0xb9e5ae29b8a9ac19,
    0xf169d7c0c55bbfcb,
    0x2446c68ec479f369,
    0x806643b63986c4bc,
    0x7fbdb54b719fa99e,
    0x04a55159b7a2c246,
    0xee042e07215c4524,
    0x5bfb73c5b5e65af7,
    0x0c1af3eb2c13b3ca,
    0xa22d06b7eb0c94b0,
    0xb8b1c742127b66f2,
    0x285c3565e86a40a3,
    0x3b2b3f49207e0986,
    0x3c72d5ad9c5f6008,
    0x770217f9ea2ed812,
    0xfc274d40439ac6ea,
    0x4fd5930dc1d37a5c,
    0x2e51b6eafe99e3c6,
    0x6b93558305aa8935,
    0x19607a48f2f4598a,
    0x08bfa2b29bb1718c,
    0x3f8e6e1097dccbc0,
    0x3983ed9f812f68a5,
    0xac9f278a664e4659,
    0x82ce916098d7a59f,
    0xc2fd4a3b7e94c7c1,
    0x66ddcf03836bf014,
    0xe1e2665106cc5d26,
    0x74feac44e1ad73da,
    0x8d28d936bf47bd9d,
    0x62789e5a34c93252,
    0x81322add93540e57,
    0xcb1681e24ff77ca6,
    0x2512afe56eab3982,
    0xd18a4017b6808ee4,
    0x705bfd1d560fb19c,
    0x4b70c2547671b81a,
    0x49d81082d720d939,
    0xe0b60f3aac1e97cd,
    0x4e81fa666b01b0b7,
    0x951cca15e7612efc,
    0x463e58d4f0b0c13b,
    0x632cf7319e1bf8b9,
    0x5ca2992109c73379,
    0xf764544fd3a81cae,
    0x6ac73ce8af7843de,
    0x9f0bba71dd813e53,
    0x85977b8424f6cc11,
    0x5807c878be65f13f,
    0x686fee3e0e2922fd,
    0x78e45fafcdbec010,
    0x6ccabf67b98be0bb,
    0x11dfd8fa69452806,
    0xcee7b9d05287740b,
    0x50b86aca25d480b3,
    0x5df6f04aa315f992,
    0x5e0a4bf7a896525a,
    0x03fcbbbd0b83abc8,
    0x8f800be01e16dcbe,
    0xd32292c117d1efc7,
    0xe5473708b16e9f60,
    0x224b4501d28a500c,
    0xfb7ea7a4ffbbaf64,
    0x3d26bcc6368daae3,
    0x866bc0392f7567d9,
    0x3731cca20c6dba4c,
    0xb603e67f9f39b41b,
    0xa1d1bd0ae08f3f78,
    0xd935e2a52d31ff68,
    0xaf639c376dcded91,
    0x0154696baad2caeb,
    0xecacfcd1800d2407,
    0xf03dbeab6f897520,
    0x02a8d2d6a1516123,
    0xf498eff2d82bb766,
    0x710f9476fcdd7b77,
    0xf8821c19f43804ac,
    0xf9d675725eeace47,
    0x1a9cc1f5f977f242,
    0x5210b81c8485e190,
    0x6d9ed60c13592a50,
    0xf2956c7dced81403,
    0xbb4d7cff19f8cd3a,
    0x4c2928b0ca50d194,
    0x6e626db118da8198,
    0xe4135e631bbc558b,
    0x9da368a77cd05f70,
    0xa574ec53572dfd3e,
    0x09ebcbd93163bb67,
    0x4a24ab3fdca372f1,
    0x429b098d4712037d,
    0x57e1802e99f5e93d,
    0xef50476c8b8e8fcf,
    0xa085d4614a5df593,
    0x34cd771f07ee1184,
    0xc6581b62c9360587,
    0x2dad0d57f51a480e,
    0x898d886f08e57fdb,
    0xd6d3aaf30aa1e76a,
    0x76567e9240fc12f9,
    0xb4ab34a93e68d538,
    0xb2a6b726289b765d,
    0x8c7cb05d15957776,
    0x554952f838a4881e,
    0xd52f114e01224ca2,
    0x60d04c8c95985371,
    0x6789a66829b93aff,
    0x2f05df81544b292d,
    0x476a31bf5a620bd0,
    0xf5cc869972f97d8d,
    0x488c79e97df213d2,
    0x44968a0251e1a018,
    0x26ee14586528924a,
    0xd0de297c1c52440f,
    0xc5a4a0dfc2b5ae4f,
    0x29085c0e42b88a48,
    0x142ee0c8743520ab,
    0x2af4e7b3493b2180,
    0x9448a37e4db3e417,
/* box 1 */
    0xe2795ba105ba30ce,
    0x65b5d634f5e0fbdd,
    0x2d7d7f1464dd8c55,
    0xeefbf778add1c20b,
    0x1eb0fbd1f11968e7,
    0xe6073f45ce30cd8d,
    0x21ffd3cdccb67e90,
    0xdf0941cfa750a262,
    0xc61df5b1b75ef18a,
    0xc5c7defa9dc337c6,
    0x2581b729073c83d3,
    0xa5e97513167173cf,
    0xdd3673bd381526b9,
    0xe8baa1eef91ebb93,
    0x3b314cf8f625eb34,
    0x579d4bc8d5fc5df8,
    0xbb598ec2e7681b28,
    0xc8a06b1a80708794,
    0x1c8fc9a36e5cec3c,
    0xf60a5a3f0807d374,
    0x1ace9f353a9395a4,
    0x7e9e50387aab2cee,
    0xb5e41069d0466d36,
    0x8cea6ee3b92602d9,
    0xf952ddad8af1e7fd,
    0xb19a748d1bcc9075,
    0x2464ae10b2e4c144,
    0xfcc9a070f4a35829,
    0xfa88f6e6a06c21b1,
    0x2c98662dd105cec2,
    0x9065a740d77aeee5,
    0xcb7a4051aaed41d8,
    0x55a279ba4ab9d923,
    0x27be855b98790708,
    0xbabc97fb52b059bf,
    0xa19711f7ddfb8e8c,
    0x047e64e4cb8afd43,
    0xc386886cc90c4e5e,
    0xc422c7c3281b7551,
    0xfb6defdf15b46326,
    0x01e51939b5d84297,
    0x5cbba8be9c809432,
    0x6f762c7b09447080,
    0xcee13d8cd4bffe0c,
    0x54476083ff619bb4,
    0x6e933542bc9c3217,
    0x4af79b520e78f353,
    0x98996f7db49be163,
    0xa07208ce6823cc1b,
    0x2b3c29823012f5cd,
    0x93bf8c0bfde728a9,
    0x2225f886e62bb8dc,
    0x7f7b4901cf736e79,
    0x0000000000000000,
    0x023f32729f4584db,
    0xd5cabb805bf4293f,
    0x07a44fafe1173b0f,
    0xe95fb8d74cc6f904,
    0x7b052de504f9933a,
    0x6aed51a67716cf54,
    0x68d263d4e8534b8f,
    0xa96bd9cabe1a810a,
    0x1d6ad09adb84aeab,
    0x0d67b5e01db3b052,
    0x52063615abaee22c,
    0x8f3045a893bbc495,
    0xd8ad0e604647996d,
    0xaf2a8f5cead5f892,
    0x3017af8ebf5922fe,
    0x4034611df2dc780e,
    0x721cfce1d2c0de2b,
    0x28e602c91a8f3381,
    0xe1a370ea2f27f682,
    0x29031bf0af577116,
    0x1914b47e100e53e8,
    0x567852f160241f6f,
    0x793a1f979bbc17e1,
    0xef1eee411809809c,
    0x6211999b14f7c0d2,
    0x059b7ddd7e52bfd4,
    0x43ee4a56d841be42,
    0xf1ae1590e910e87b,
    0x33cd84c595c4e4b2,
    0x4b12826bbba0b1c4,
    0xeb608aa5d3837ddf,
    0x201acaf4796e3c07,
    0xbf27ea262ce2e66b,
    0x58c5cc5a570a6971,
    0x37b3e0215e4e19f1,
    0xab54ebb8215f05d1,
    0x8ed55c9126638602,
    0x9aa65d0f2bde65b8,
    0xd7f589f2c4b1ade4,
    0x5039046734eb66f7,
    0x6cac073023d9b6cc,
    0x51dc1d5e81332460,
    0x17a92ad5272025f6,
    0x47902eb213cb4301,
    0x1b2b860c8f4bd733,
    0x4f6ce68f702a4c87,
    0xcf0424b56167bc9b,
    0x997c76440143a3f4,
    0x7ae034dcb121d1ad,
    0x100d657ac6371ef9,
    0x0ac3fa4ffca48b5d,
    0xdeec58f61288e0f5,
    0x265b9c622da1459f,
    0xdcd36a848dcd642e,
    0xe4380d3751754956,
    0x13d74e31ecaad8b5,
    0xfd2cb949417b1abe,
    0x9624f1d683b5977d,
    0x4675378ba6130196,
    0x0b26e376497cc9ca,
    0x41d1782447043a99,
    0xe39c4298b0627259,
    0xcd3b16c7fe223840,
    0x7787813cac9261ff,
    0x492db01924e5351f,
    0x5afafe28c84fedaa,
    0x8b4e214c583139d6,
    0xccde0ffe4bfa7ad7,
    0x76629805194a2368,
    0x7ca1624ae5eea835,
    0x61cbb2d03e6a069e,
    0x48c8a920913d7788,
    0x8068c23a114df01c,
    0xd38bed160f3b50a7,
    0x32289dfc201ca625,
    0xc1b9ba1e5649ca85,
    0xed21dc33874c0447,
    0xa3a8238542be0a57,
    0x5b1fe7117d97af3d,
    0x3d701a6ea2ea92ac,
    0x73f9e5d867189cbc,
    0x9ed839ebe05498fb,
    0x5920d563e2d22be6,
    0xca9f59681f35034f,
    0x11e87c4373ef5c6e,
    0x97c1e8ef366dd5ea,
    0xacf0a417c0483ede,
    0xd26ef42fbae31230,
    0xbcfdc16d067f2027,
    0xbec2f31f993aa4fc,
    0x45af1cc08c8ec7da,
    0x31f2b6b70a816069,
    0xd9481759f39fdbfa,
    0xe5dd140ee4ad0bc1,
    0xa6335e583cecb583,
    0x38eb67b3dcb82d78,
    0xf5d07174229a1538,
    0x5f6183f5b61d527e,
    0x0f58879282f63489,
    0x164c33ec92f86761,
    0x444a05f93956854d,
    0x818ddb03a495b28b,
    0x4d53d4fdef6fc85c,
    0x8d0f77da0cfe404e,
    0x8416a6dedac70d5f,
    0x666ffd7fdf7d3d91,
    0xb63e3b22fadbab7a,
    0xf2743edbc38d2e37,
    0xa40c6c2aa3a93158,
    0x9f3d20d2558cda6c,
    0xfef692026be6dcf2,
    0x2ea7545f4e404a19,
    0xb2405fc631515639,
    0x23c0e1bf53f3fa4b,
    0x83b2e9713bd03650,
    0x0641569654cf7998,
    0xb883a589cdf5dd64,
    0x3ad455c143fda9a3,
    0x925a9532483f6a3e,
    0xaab1f28194874746,
    0xf435684d974257af,
    0xd1b4df64907ed47c,
    0x390e7e8a69606fef,
    0xd051c65d25a696eb,
    0xb4010950659e2fa1,
    0x0c82acd9a86bf2c5,
    0x88940a0772acff9a,
    0xf39127e276556ca0,
    0xaecf96655f0dba05,
    0x03da2b4b2a9dc64c,
    0x3f4f281c3daf1677,
    0x3469cb6a74d3dfbd,
    0xf04b0ca95cc8aaec,
    0x1f55e2e844c12a70,
    0x4cb6cdc45ab78acb,
    0xc05ca327e3918812,
    0x95feda9da9285131,
    0xb966bcb0782d9ff3,
    0xa7d647618934f714,
    0xd61090cb7169ef73,
    0x71c6d7aaf85d1867,
    0xecc4c50a329446d0,
    0x6450cf0d4038b94a,
    0x420b536f6d99fcd5,
    0x75b8b34e33d7e524,
    0xc26391557cd40cc9,
    0xda923c12d9021db6,
    0x4e89ffb6c5f20e10,
    0x0919d104d6394d11,
    0x8aab3875ede97b41,
    0xa88ec0f30bc2c39d,
    0xb7db221b4f03e9ed,
    0xc7f8ec880286b31d,
    0x2f424d66fb98088e,
    0xe04669d39affb415,
    0x3eaa3125887754e0,
    0x5e849acc03c510e9,
    0x8257f0488e0874c7,
    0xbd18d854b3a762b0,
    0xb3a546ff848914ae,
    0x9ce70b997f111c20,
    0x3c9503571732d03b,
    0xe7e2267c7be88f1a,
    0x63f480a2a12f8245,
    0x602eabe98bb24409,
    0x941bc3a41cf013a6,
    0x678ae4466aa57f06,
    0x1232570859729a22,
    0x6d491e099601f45b,
    0x5d5eb1872958d6a5,
    0x1473019e0dbde3ba,
    0xa24d3abcf76648c0,
    0x85f3bfe76f1f4fc8,
    0x08fcc83d63e10f86,
    0x745daa77860fa7b3,
    0x9180be7962a2ac72,
    0x87cc8d95f05acb13,
    0x78df06ae2e645576,
    0x18f1ad47a5d6117f,
    0x358cd253c10b9d2a,
    0x0ebd9eab372e761e,
    0xf7ef4306bddf91e3,
    0x7023ce934d855af0,
    0xd42fa2b9ee2c6ba8,
    0x3656f918eb965b66,
    0x9d0212a0cac95eb7,
    0x2ad930bb85cab75a,
    0x862994ac45828984,
    0x7d447b735036eaa2,
    0xb07f6db4ae14d2e2,
    0x6b08489fc2ce8dc3,
    0x9b4344369e06272f,
    0xad15bd2e75907c49,
    0xdb77252b6cda5f21,
    0xea85939c665b3f48,
    0xc945722335a8c503,
    0x159618a7b865a12d,
    0x69377aed5d8b0918,
    0x8971133ec774bd0d,
    0x53e32f2c1e76a0bb,
    0xf8b7c4943f29a56a,
    0xff138b3bde3e9e65,
/* box 2 */
    0x7c6a2eb5fdabecc6,
    0x401cda0a752bbea0,
    0x1925217156dc57c4,
    0x56dec6d301d70787,
    0x41c751ff73c6ac58,
    0xc9067697a92cb5f9,
    0x3391c917aaa0bc85,
    0xae0a9a4c0e742afe,
    0xaa8ca972162a62f4,
    0x5aa193912935df99,
    0x86fd9135fe27e5ba,
    0xffca074b1d3f538e,
    0x0e3cb65d24cdfc1b,
    0x4384b2e07fe9885d,
    0xc73ac0ca8de149e2,
    0x48e5bc7645972eb4,
    0xbe0d56b46ef9ffd6,
    0x200e6d05c0ef5f50,
    0xe1f17dee597f7abd,
    0x0243e31f0c2f2405,
    0xf4ab09dd2741f567,
    0xe4acc52547cc204f,
    0x348f92c3b83cc272,
    0x53837e181f645d75,
    0xd8da319acf4c7229,
    0x81e3cae1ecbb9b4d,
    0xd6e687c7eb818e32,
    0x3dad7f4a8e6d409e,
    0x28f70b79f053cf44,
    0x493e3783437a3c4c,
    0xb27203f6461b27c8,
    0xd02357e6fff0e23d,
    0xe8d390676f2ef851,
    0x26cbbd24d49e335f,
    0xee1640467b5f945e,
    0x4aa65f6949b80ab1,
    0xb56c58225487593f,
    0x4ffbe7a2570b5043,
    0x0aba85633c93b411,
    0x78ec1d8be5f5a4cc,
    0x501b16f215a66b88,
    0x271036d1d27321a7,
    0x7ff2465ff769da3b,
    0x35541936bed1d08a,
    0xb8c886957a8893d9,
    0x2fe950ade2cfb1b3,
    0xf90fd76a094e3f81,
    0x2daab3b2eee095b6,
    0x1abd499b5c1e6139,
    0x0c7f554228e2d81e,
    0x425f391579049aa5,
    0xc3bcf3f495bf01e8,
    0xb4b7d3d7526a4bc7,
    0x0000000000000000,
    0xa0362c112ab9d6e5,
    0x91e406198c364e65,
    0x454162c16b98e452,
    0x139fa4126a4fe3d5,
    0x01db8bf506ed12f8,
    0x9a85088fb648e88c,
    0x3ab3249e9cf13e69,
    0xd57eef2de143b8cf,
    0xb1ea6b1c4cd91135,
    0x7aaffe94e9da80c9,
    0xad92f2a604b61c03,
    0xa3ae44fb207be018,
    0xeb4bf88d65ecceac,
    0xc0249b1e9f7d3715,
    0xa8cf4a6d1a0546f1,
    0xc6e14b3f8b0c5b1a,
    0xce182d43bbb0cb0e,
    0xfc526fa117fd6573,
    0x8c471456c2b451ab,
    0xac497953025b0efb,
    0x0486333e185e480a,
    0x18feaa845031453c,
    0xa1eda7e42c54c41d,
    0x06c5d02114716c0f,
    0x055db8cb1eb35af2,
    0xe5774ed0412132b7,
    0x36cc71dcb413e677,
    0x470281de67b7c057,
    0x58e2708e251afb9c,
    0xa914c1981ce85409,
    0xb3a9880340f63530,
    0x638adfe5bf06d70d,
    0x0b610e963a7ea6e9,
    0x927c6ef386f47898,
    0xed8e28ac719da2a3,
    0x7548c33ccbfa6e2a,
    0xf3b5520935dd8b90,
    0x8d9c9fa3c4594353,
    0x31d22a08a68f9880,
    0x0da4deb72e0fcae6,
    0x8fdf7cbcc8766756,
    0x5dbfc8453ba9a16e,
    0x8e04f749ce9b75ae,
    0x83a029fee094bf48,
    0xa4b01f2f32e79eef,
    0x1c7899ba486f0d36,
    0x654f0fc4ab77bb02,
    0x7db1a540fb46fe3e,
    0x51c09d07134b7970,
    0xcb459588a50391fc,
    0x3fee9c558242649b,
    0xfe118cbe1bd24176,
    0x76d0abd6c13858d7,
    0x5e27a0af316b9793,
    0x69305a868395631c,
    0x3b68af6b9a1c2c91,
    0x6db669b89bcb2b16,
    0xa72877c53825a812,
    0xd3bb3f0cf532d4c0,
    0x6ff58aa797e40f13,
    0x96fa5dcd9eaa3092,
    0x2c713847e80d874e,
    0xc57923d581ce6de7,
    0x2b6f6393fa91f9b9,
    0x0922ed89365182ec,
    0x324a42e2ac4dae7d,
    0x16c21cd974fcb927,
    0x956235279468066f,
    0x7b747561ef379231,
    0x449ae9346d75f6aa,
    0xf570822821ace79f,
    0x5939fb7b23f7e964,
    0x7937967ee318b634,
    0x84be722af208c1bf,
    0x08f9667c30bc9014,
    0xefcdcbb37db286a6,
    0xa6f3fc303ec8baea,
    0xea9073786301dc54,
    0x62515410b9ebc5f5,
    0xd260b4f9f3dfc638,
    0x9e033bb1ae16a086,
    0x38f0c78190de1a6c,
    0xc267780193521310,
    0x80384114ea5689b5,
    0x9b5e837ab0a5fa74,
    0xf73361372d83c39a,
    0x3009a1fda0628a78,
    0xd4a564d8e7aeaa37,
    0xfb4c347505611b84,
    0x5b7a18642fd8cd61,
    0x239605efca2d69ad,
    0xf8d45c9f0fa32d79,
    0xbb50ee7f704aa524,
    0x392b4c7496330894,
    0x0fe73da82220eee3,
    0x3717fa29b2fef48f,
    0xf26ed9fc33309968,
    0xd73d0c32ed6c9cca,
    0xda99d285c363562c,
    0xde1fe1bbdb3d1e26,
    0x738d131ddf8b0225,
    0x292c808cf6beddbc,
    0xbc4eb5ab62d6dbd3,
    0x039868ea0ac236fd,
    0xcc5bce5cb79fef0b,
    0xb031e0e94a3403cd,
    0xc4a2a82087237f1f,
    0xb72fbb3d58a87d3a,
    0xafd111b908993806,
    0x68ebd173857871e4,
    0x9d9b535ba4d4967b,
    0xe9081b9269c3eaa9,
    0x71cef002d3a42620,
    0x93a7e50680196a60,
    0x891aac9ddc070b59,
    0x155a74337e3e8fda,
    0x4e206c5751e642bb,
    0x9721d6389847226a,
    0x12442fe76ca2f12d,
    0x2553d5cede5c05a2,
    0xa275cf0e2696f2e0,
    0x24885e3bd8b1175a,
    0x670cecdba7589f07,
    0x749348c9cd177cd2,
    0x64948431ad9aa9fa,
    0x2ab4e866fc7ceb41,
    0xe6ef263a4be3044a,
    0xe734adcf4d0e16b2,
    0x903f8dec8adb5c9d,
    0xf02d3ae33f1fbd6d,
    0x725698e8d96610dd,
    0x1da3124f4e821fce,
    0x1719972c7211abdf,
    0x11dc470d6660c7d0,
    0xec55a3597770b05b,
    0xbfd6dd416814ed2e,
    0x57054d26073a157f,
    0x1e3b7aa544402933,
    0x5ffc2b5a3786856b,
    0x61c93cfab329f308,
    0x3e3517a084af7663,
    0xf6e8eac22b6ed162,
    0x1007ccf8608dd528,
    0x66d7672ea1b58dff,
    0x8b594f82d0282f5c,
    0x1fe0f15042ad3bcb,
    0x4b7dd49c4f551849,
    0x4c638f485dc966be,
    0xcfc3a6b6bd5dd9f6,
    0x46d90a2b615ad2af,
    0x8565f9dff4e5d347,
    0x94b9bed292851497,
    0xfa97bf80038c097c,
    0xb9130d607c658121,
    0xdc5c02a4d7123a23,
    0x224d8e1accc07b55,
    0x87261ac0f8caf742,
    0xd901ba6fc9a160d1,
    0xab57228710c7700c,
    0x21d5e6f0c6024da8,
    0x98c6eb90ba67cc89,
    0x827ba20be679adb0,
    0x991d6065bc8ade71,
    0x5546ae390b15317a,
    0xa56b94da340a8c17,
    0x071e5bd4129c7ef7,
    0xe02af61b5f926845,
    0x6b73b9998fba4719,
    0xdfc46a4eddd00cde,
    0x770b2023c7d54a2f,
    0x7e29cdaaf184c8c3,
    0xba8b658a76a7b7dc,
    0x9c40d8aea2398483,
    0x9fd8b044a8fbb27e,
    0xdb425970c58e44d4,
    0xe269150453bd4c40,
    0x3c76f4bf88805266,
    0xf1f6b11639f2af95,
    0x549d25cc0df82382,
    0x4db804bd5b247446,
    0x8a82c477d6c53da4,
    0x5258f5ed19894f8d,
    0x6e2e015291091deb,
    0xc1ff10eb999025ed,
    0xbd953e5e643bc92b,
    0xc8ddfd62afc1a701,
    0x5c6443b03d44b396,
    0x6c6de24d9d2639ee,
    0x1481ffc678d39d22,
    0xd1f8dc13f91df0c5,
    0xca9e1e7da3ee8304,
    0xdd878951d1ff28db,
    0x6012b70fb5c4e1f0,
    0x1b66c26e5af373c1,
    0xe3b29ef155505eb8,
    0x70157bf7d54934d8,
    0x2e32db58e422a34b,
    0x6aa8326c895755e1,
    0xb6f430c85e456fc2,
    0xfd89e4541110778b,
    0x88c12768daea19a1,
    0xcd8045a9b172fdf3,
/* box 3 */
    0x99183e616655b742,
    0xb2872032a50d6860,
    0x0946f63b060528ef,
    0x36612b9a141ef07d,
    0x0634da84dd49579b,
    0xfc9c9e9b486c8a57,
    0xa63fe3c0744e6fd0,
    0xf1515758d8b46bf9,
    0x3e82559fcd5197ff,
    0x92e12d262bc40177,
    0xc3bb433a5a7752c5,
    0x21c3852a5183267a,
    0x39130725cf528f09,
    0x9ba7db1d2dc12998,
    0xc58f99be873e055e,
    0xd9d424498f32656c,
    0x27f75fae8cca71e1,
    0x59b91019a8fc3430,
    0xce768af9caafb36b,
    0x9d930199f0887e03,
    0x63b07a7ef3706a8e,
    0xb5167288a70e7096,
    0x40cc1a28e967d22e,
    0x4d01d3eb79bf3380,
    0x9e896cdb6456afb4,
    0x2548bad2c75eef3b,
    0xa79a6bfeab0420bd,
    0x9f2ce4e5bb1ce0d9,
    0x32ea146282c3393c,
    0x6d67defff7765a97,
    0x83775912b31080eb,
    0xf5da68a04e69a2b8,
    0x1196743498d4819c,
    0x0bf913474d91b635,
    0x43d6776a7db90399,
    0x444725d07fba1b6f,
    0x6584a0fa2e393d15,
    0x3f27dda1121bd892,
    0xf6c005e2dab7730f,
    0x56cb3ca673b04b44,
    0x642128c4f1737278,
    0xbf4ae9f135d589ce,
    0xb038c54eee99f6ba,
    0xf47fe09e9123edd5,
    0x75b75cf069a7f3e4,
    0xd419ed8a1fea84c2,
    0x73838674b4eea47f,
    0x498aec13ef62fac1,
    0x20660d148ec96917,
    0xa48006bc3fdaf10a,
    0x2f1421ab55851663,
    0x0a5c9b7992dbf958,
    0xd1375a4c567d02ee,
    0x0000000000000000,
    0xc842507d17e6e4f0,
    0xf3eeb2249320f523,
    0xc9e7d843c8acab9d,
    0xff86f3d9dcb25be0,
    0xb4b3fab678443ffb,
    0xb19d4d7031d3b9d7,
    0x79df1d0d26355d27,
    0x8eba90d123c86145,
    0xaa57a23d3bdcc113,
    0xcb583d3f83383547,
    0xd871ac7750782a01,
    0xe162ab529f2aa508,
    0x38b68f1b1018c064,
    0x237c60561a17b8a0,
    0xa31154063dd9e9fc,
    0x713c6308ff7a3aa5,
    0x1a6f6773d54537a9,
    0x08e37e05d94f6782,
    0x357b46d880c021ca,
    0x6cc256c1283c15fa,
    0xcfd302c715e5fc06,
    0xbdf50c8d7e411714,
    0x7cf1aacb6fa2db0b,
    0x5240035ee56d8205,
    0x7b60f8716da1c3fd,
    0x01a5883edf4a4f6d,
    0xdd5f1bb119efac2d,
    0x5474d9da3824d59e,
    0x0f722cbfdb4c7f74,
    0x17a2aeb0459dd607,
    0x37c4a3a4cb54bf10,
    0xc21ecb04853d1da8,
    0x4273ff54a2f34cf4,
    0xdace490b1becb4db,
    0x6af68c45f5754261,
    0x46f8c0ac342e85b5,
    0x854383966e59d770,
    0x81c8bc6ef8841e31,
    0x3bace25984c611d3,
    0x1033fc0a479ecef1,
    0x1c5bbdf7080c6032,
    0x7412d4ceb6edbc89,
    0xa8e8474170485fc9,
    0xb8dbbb4b37d69138,
    0x079152ba020318f6,
    0x72260e4a6ba4eb12,
    0x905ec85a60509fad,
    0x2dabc4d71e1188b9,
    0xd092d27289374d83,
    0x610f9f02b8e4f454,
    0x02bfe57c4b949eda,
    0x95707f9c29c71981,
    0x6fd83b83bce2c44d,
    0x5d322fe13e21fd71,
    0x34decee65f8a6ea7,
    0xcd6ce7bb5e7162dc,
    0xfb0dcc214a6f92a1,
    0x2eb1a9958acf590e,
    0xdcfa938fc6a5e340,
    0x669ecdb8bae7eca2,
    0x151d4bcc0e0948dd,
    0xfd3916a59726c53a,
    0x581c982777b67b5d,
    0x1bcaef4d0a0f78c4,
    0xdfe0fecd527b32f7,
    0x128c19760c0a502b,
    0x84e60ba8b113981d,
    0x3c3db0e386c50925,
    0x7febc789fb7c0abc,
    0x7d5422f5b0e89466,
    0xd70380c88b345575,
    0xbbc1d609a308408f,
    0xe278c6100bf474bf,
    0x5e2842a3aaff2cc6,
    0x6b53047b2a3f0d0c,
    0xf7658ddc05fd3c62,
    0x9a025323f28b66f5,
    0x8c0575ad685cff9f,
    0x76ad31b2fd792253,
    0x68496939bee1dcbb,
    0x7e4e4fb7243645d1,
    0xe44c1c94d6bd2324,
    0xbeef61cfea9fc6a3,
    0x91fb4064bf1ad0c0,
    0x052eb7c64997862c,
    0x4a9081517bbc2b76,
    0x8f1f18effc822e28,
    0x3a096a675b8c5ebe,
    0xee1087ed4466da7c,
    0x2652d79053803e8c,
    0x7099eb36203075c8,
    0xc7307cc2ccaa9b84,
    0x5c97a7dfe16bb21c,
    0x50ffe622aef91cdf,
    0x8da0fd93b716b0f2,
    0x69ece10761ab93d6,
    0x31f07920161de88b,
    0x13299148d3401f46,
    0x031a6d4294ded1b7,
    0xccc96f85813b2db1,
    0x14b8c3f2d14307b0,
    0x8659eed4fa8706c7,
    0xba645e377c420fe2,
    0x2920fb2f88cc41f8,
    0x87fc66ea25cd49aa,
    0x1ee4588b4398fee8,
    0xecaf62910ff244a6,
    0xf817a163deb14316,
    0x45e2adeea0f05402,
    0x806d345027ce515c,
    0x576eb498acfa0429,
    0xa5258e82e090be67,
    0x892bc26b21cb79b3,
    0x6e7db3bd63a88b20,
    0x4e1bbea9ed61e237,
    0xadc6f08739dfd9e5,
    0x8b9427176a5fe769,
    0xa1aeb17a764d7726,
    0x4b35096fa4f6641b,
    0x22d9e868c55df7cd,
    0x55d151e4e76e9af3,
    0x966a12debd19c836,
    0x0dcdc9c390d8e1ae,
    0xf24b3a1a4c6aba4e,
    0x24ed32ec1814a056,
    0xaf7915fb724b473f,
    0x2885731157860e95,
    0x9c3689a72fc2316e,
    0x475d4892eb64cad8,
    0xac6378b9e6959688,
    0xa00b3944a907384b,
    0xc695f4fc13e0d4e9,
    0x3055f11ec957a7e6,
    0x6215f2402c3a25e3,
    0xde4576f38d317d9a,
    0x9344a518f48e4e1a,
    0x82d2d12c6c5acf86,
    0xefb50fd39b2c9511,
    0xe981d5574665c28a,
    0x5f8dca9d75b563ab,
    0xb60c1fca33d0a121,
    0xfe237be703f8148d,
    0xd6a608f6547e1a18,
    0xb97e3375e89cde55,
    0xd388bf301de99c34,
    0x5b06f565e368aaea,
    0xf0f4df6607fe2494,
    0x1607268e9ad7996a,
    0xaedc9dc5ad010852,
    0xe0c7236c4060ea65,
    0xea9bb815d2bb133d,
    0x888e4a55fe8136de,
    0x5aa37d5b3c22e587,
    0xc104a64611e3cc1f,
    0x515a6e1c71b353b2,
    0xc42a118058744a33,
    0x7708b98c22336d3e,
    0x2a3a966d1c12904f,
    0x8a31af29b515a804,
    0xed0aeaafd0b80bcb,
    0x2c0e4ce9c15bc7d4,
    0x0c6841fd4f92aec3,
    0x98bdb65fb91ff82f,
    0x1f41d0b59cd2b185,
    0xb322a80c7a47270d,
    0xe6f3f9e89d29bdfe,
    0x7ac5704fb2eb8c90,
    0xa94dcf7faf0210a4,
    0x787a9533f97f124a,
    0xdb6bc135c4a6fbb6,
    0x048b3ff896ddc941,
    0xe8245d69992f8de7,
    0xe3dd4e2ed4be3bd2,
    0xcafdb5015c727a2a,
    0xb7a997f4ec9aee4c,
    0xe75671d64263f293,
    0x2b9f1e53c358df22,
    0x18d0820f9ed1a973,
    0xabf22a03e4968e7e,
    0xa2b4dc38e293a691,
    0x673b458665ada3cf,
    0xf9b2295d01fb0c7b,
    0xd22d370ec2a3d359,
    0x97cf9ae06253875b,
    0x0ed7a48104063019,
    0x482f642d3028b5ac,
    0xc0a12e78cea98372,
    0x4fbe3697322bad5a,
    0x19750a31419be61e,
    0x41699216362d9d43,
    0xd5bc65b4c0a0cbaf,
    0xe5e994aa09f76c49,
    0xeb3e302b0df15c50,
    0x94d5f7a2f68d56ec,
    0x53e58b603a27cd68,
    0x3d9838dd598f4648,
    0x60aa173c67aebb39,
    0x1dfe35c9d7462f5f,
    0x4ca45bd5a6f57ced,
    0xbc5084b3a10b5879,
    0xfaa8441f9525ddcc,
    0x334f9c5c5d897651,
/* box 4 */
    0xda1687a883adf27e,
    0xe35c9378578d9f22,
    0x303ca4531637fa40,
    0xa088321f74b20375,
    0xc9863f3a9acb95e9,
    0x5fcf47c57d0b0ed4,
    0x4aa211e4e1280b4b,
    0xe1a4c9ba871d1289,
    0x4926664759f03a4f,
    0xadfb36ede3707bca,
    0xcf7bd1891f8ef7e1,
    0x9735559e8f882792,
    0x5932a976f84e6cdc,
    0x9dc792bef547818a,
    0x06fdeeb385456208,
    0x46ad38771ea2cf5b,
    0x5eb36aa41543b27b,
    0x8b2eb33cd1bcb511,
    0x71105ff6e598ebbc,
    0x5441ad846f8c1463,
    0x4c5fff57646d6943,
    0xf3485c49f633c9b1,
    0x9cbbbfdf9d0f3d25,
    0x22d031a067192178,
    0xca0248992213a4ed,
    0x19627fb263a9c18f,
    0x9330e1efda5dc831,
    0x1390b89219666797,
    0x2edf18339893e568,
    0x6c779435d3e4c590,
    0x53c06e568281cac4,
    0x6ff3e3966b3cf494,
    0xfe3b58bb61f1b10e,
    0x77edb14560dd89b4,
    0x02f85ac2d0908dab,
    0x12ec95f3712edb38,
    0x85d9c06dfea6fcaa,
    0x90b4964c6285f935,
    0xf1b0068b26a3441a,
    0x729428555d40dab8,
    0x5c4b3066c5d33fd0,
    0x5d371d07ad9b837f,
    0xa48d866e2167ecd6,
    0xb661139d504937ee,
    0xa27068dda4228ede,
    0xf8c6b608e4b4d306,
    0x6bf657e73ee91b37,
    0xac871b8c8b38c765,
    0x4ea7a595b4fde4e8,
    0x0d7304f297c278bf,
    0xb71d3efc38018b41,
    0xae7f414e5ba84ace,
    0xaf036c2f33e0f661,
    0x0000000000000000,
    0xb89660cc7f537e55,
    0xa675dcacf1f7617d,
    0x610490c74426bd2f,
    0xc18ca2d83094be5a,
    0x2adaac42cd460acb,
    0x7d1f76651a122fac,
    0xc58916a9654151f9,
    0xedabe0297897d699,
    0x2d5b6f90204bd46c,
    0x26d585d132cccedb,
    0x9f3fc87c25d70c21,
    0xc60d610add9960fd,
    0x80a0597dc33bafa6,
    0xd0e44088f9625466,
    0x1d67cbc3367c2e2c,
    0x2c2742f1480368c3,
    0x89d6e9fe012c38ba,
    0xe9ae54582d42393a,
    0x3ecbd702392db3fb,
    0xb5e5643ee89106ea,
    0xa882affddeed28c6,
    0x1ae60811db71f08b,
    0x924ccc8eb215749e,
    0xfcc30279b1613ca5,
    0x825803bf13ab220d,
    0xd992f00b3b75c37a,
    0xc8fa125bf2832946,
    0x35453d432baaa94c,
    0xf9ba9b698cfc6fa9,
    0x37bd6781fb3a24e7,
    0x791ac2144fc7c00f,
    0x16e9218224fb349b,
    0xdb6aaac9ebe54ed1,
    0xd8eedd6a533d7fd5,
    0x7c635b04725a9303,
    0x553d80e507c4a8cc,
    0x9a46516c184a5f2d,
    0x14117b40f46bb930,
    0x1ee3bc608ea41f28,
    0x27a9a8b05a847274,
    0x4050d6c49be7ad53,
    0x7be298d69f574da4,
    0x6a8a7a8656a1a798,
    0x4d23d2360c25d5ec,
    0x1014cf31a1be5693,
    0xb264a7ec059cd84d,
    0xea2a23fb959a083e,
    0xf0cc2bea4eebf8b5,
    0x76919c240895351b,
    0x0b8eea4112871ab7,
    0x47d1151676ea73f4,
    0xbdeff9dc42ce2d59,
    0x2ba68123a50eb664,
    0x057999103d9d530c,
    0xe759270902587081,
    0xef53baeba8075b32,
    0x4fdb88f4dcb55847,
    0x6e8fcef70374483b,
    0x1168e250c9f6ea3c,
    0x1b9a2570b3394c24,
    0x706c72978dd05713,
    0x865db7ce467ecdae,
    0x52bc4337eac9766b,
    0x504419f53a59fbc0,
    0x8f2b074d84695ab2,
    0x6078bda62c6e0180,
    0x43d4a167233f9c57,
    0x0ef773512f1a49bb,
    0x0c0f2993ff8ac410,
    0x4bde3c858960b7e4,
    0x66855315a92b6388,
    0xd360372b41ba6562,
    0x584e84179006d073,
    0x9b3a7c0d7002e382,
    0xa5f1ab0f492f5079,
    0x2822f6801dd68760,
    0x445562b5ce3242f0,
    0xaa7af53f0e7da56d,
    0x3c338dc0e9bd3e50,
    0x3bb24e1204b0e0f7,
    0xd59dd998c4ff076a,
    0x91c8bb2d0acd459a,
    0x84a5ed0c96ee4005,
    0x33b8d3f0aeefcb44,
    0x57c5da27d7542567,
    0x32c4fe91c6a777eb,
    0x3439102243e215e3,
    0xc7714c6bb5d1dc52,
    0x3fb7fa6351650f54,
    0x87219aaf2e367101,
    0xf5b5b2fa7376abb9,
    0x412cfba5f3af11fc,
    0xdceb691b06e89076,
    0xbb12176fc78b4f51,
    0x73e8053435086617,
    0xe220be193fc5238d,
    0xb09cfd2ed50c55e6,
    0xb9ea4dad171bc2fa,
    0x9e43e51d4d9fb08e,
    0x36c14ae093729848,
    0xa9fe829cb6a59469,
    0x0405b47155d5efa3,
    0x0af2c7207acfa618,
    0x7e9b01c6a2ca1ea8,
    0xdd97447a6ea02cd9,
    0x0781c3d2ed0ddea7,
    0x7866ef75278f7ca0,
    0xd1986de9912ae8c9,
    0xcb7e65f84a5b1842,
    0xcd838b4bcf1e7a4a,
    0xab06d85e663519c2,
    0xd4e1f4f9acb7bbc5,
    0xfdbf2f18d929800a,
    0xf23471289e7b751e,
    0xbc93d4bd2a8691f6,
    0x3d4fa0a181f582ff,
    0xba6e3a0eafc3f3fe,
    0x5ab6ded540965dd8,
    0xeb560e9afdd2b491,
    0x0976b083c217971c,
    0xecd7cd4810df6a36,
    0x23ac1cc10f519dd7,
    0xbe6b8e7ffa161c5d,
    0x7fe72ca7ca82a207,
    0xc0f08fb958dc02f5,
    0x7a9eb5b7f71ff10b,
    0xa709f1cd99bfddd2,
    0x8dd35d8f54f9d719,
    0x8caf70ee3cb16bb6,
    0xe4dd50aaba804185,
    0x83242ede7be39ea2,
    0x98be0baec8dad286,
    0x690e0d25ee79969c,
    0x95cd0f5c5f18aa39,
    0x56b9f746bf1c99c8,
    0x7469c6e6d805b8b0,
    0x8a529e5db9f409be,
    0xe6250a686a10cc2e,
    0x2fa33552f0db59c7,
    0x42a88c064b7720f8,
    0x6d0bb954bbac793f,
    0x181e52d30be17d20,
    0xbf17a31e925ea0f2,
    0x94b1223d37501696,
    0xe8d27939450a8595,
    0xccffa62aa756c6e5,
    0x383639b1bc68d1f3,
    0xee2f978ac04fe79d,
    0xa30c45bccc6a3271,
    0x1f9f9101e6eca387,
    0xb1e0d04fbd44e949,
    0x242ddf13e25c4370,
    0x156d56219c23059f,
    0x88aac49f69648415,
    0x6280e764fcfe8c2b,
    0xdf6f1eb8be30a172,
    0xe5a17dcbd2c8fd2a,
    0xe0d8e4dbef55ae26,
    0x63fcca0594b63084,
    0xa1f41f7e1cfabfda,
    0x295edbe1759e3bcf,
    0x67f97e74c163df27,
    0x038477a3b8d83104,
    0xde1333d9d6781ddd,
    0x3ace63736cf85c58,
    0xd619ae3b7c27366e,
    0x5bcaf3b428dee177,
    0xb3188a8d6dd464e2,
    0x1c1be6a25e349283,
    0x017c2d616848bcaf,
    0x8e572a2cec21e61d,
    0xf631c559cbae9abd,
    0x81dc741cab731309,
    0xff4775da09b90da1,
    0xb499495f80d9ba45,
    0x0f8b5e304752f514,
    0x394a14d0d4206d5c,
    0xce07fce877c64b4e,
    0xf4c99f9b1b3e1716,
    0xc4f53bc80d09ed56,
    0xc208d57b884c8f5e,
    0x080a9de2aa5f2bb3,
    0x314089327e7f46ef,
    0xfa3eecca34245ead,
    0x20286b62b789acd3,
    0x7515eb87b04d041f,
    0x513834945211476f,
    0x650124b611f3528c,
    0x17950ce34cb38834,
    0x45294fd4a67afe5f,
    0x21544603dfc1107c,
    0x485a4b2631b886e0,
    0x6872204486312a33,
    0x647d09d779bbee23,
    0x2551f2728a14ffdf,
    0xd765835a146f8ac1,
    0xd21c1a4a29f2d9cd,
    0x99c226cfa0926e29,
    0xfb42c1ab5c6ce202,
    0xc374f81ae00433f1,
    0x964978ffe7c09b3d,
    0xf74de838a3e62612,
/* box 5 */
    0x74b87b36b0592c6a,
    0x3d82d75dffb4b81c,
    0x8884246715267825,
    0xdaf2d8a77ed4e5de,
    0xfeb118650e53f9c7,
    0xbd2d1aea59226b06,
    0x26ce87f6dbabb191,
    0x32772ecbeb66bd0a,
    0xd4bbf82bc5104c8c,
    0x055357720c4e03a1,
    0xef5be62a32d0f6fd,
    0xbe1c84c45d186aca,
    0xacc7e4a565a1643c,
    0x8dd7731519687b84,
    0x11eafe4f3c830f3a,
    0x04ef8e68a358afe5,
    0x40ad9ca1534b930d,
    0xe44191d4855a5c0e,
    0x6001d20b809420f1,
    0x73666b70173b8243,
    0x372479b9e728beab,
    0x45fecbd35f0590ac,
    0x7057f55e1301838f,
    0xff0dc17fa1455583,
    0x0cc467b810e804da,
    0xb9c29482fa7ac4e3,
    0xa003831d754960e6,
    0x8a096353be0ad5ad,
    0xdd2cc8e1d9b64bf7,
    0xc7dc415052bfee3e,
    0x9f0c137421d17572,
    0x35a93e8d4c041323,
    0x9a5f44062d9f76d3,
    0x71eb2c44bc172fcb,
    0x0ff5f99614d20516,
    0x7789e518b4632da6,
    0xc99561dce97b476c,
    0x5276fcc06bf29dfb,
    0x4a0b32454bd795ba,
    0x9274add69e2fddec,
    0x4f5865374799961b,
    0xb2d8e37c4df06e10,
    0xc4eddf7e5685eff2,
    0xb3643a66e2e6c254,
    0xd50721316a06e0c8,
    0x8bb5ba49111c79e9,
    0x2bb639546455190f,
    0xf8d3d1390627fbaa,
    0x38d1802ff3fabbbd,
    0xdfa18fd5729ae67f,
    0x4ee4bc2de88f3a5f,
    0xf72628af12f5febc,
    0x0aa6aee4189c06b7,
    0x0000000000000000,
    0x9eb0ca6e8ec7d936,
    0xcb1826e84257eae4,
    0x187dce8520250841,
    0xc28f16225ef1ed9f,
    0xc333cf38f1e741db,
    0x4220db95f8673e85,
    0xdc9011fb76a0e7b3,
    0x105627559395a37e,
    0x2f59b73cc70db6ea,
    0xe112c6a689145faf,
    0x82228a830dba7e92,
    0x2ee56e26681b1aae,
    0x2a0ae04ecb43b54b,
    0x47738ce7f4293d24,
    0xa7dd935bd22bcecf,
    0xd2d93177cd644ee1,
    0xebb4684291885918,
    0x0e49208cbbc4a952,
    0xa550d46f79076347,
    0x411145bbfc5d3f49,
    0xe6ccd6e02e76f186,
    0x4bb7eb5fe4c139fe,
    0x5d8305567f2098ed,
    0x95aabd90394d73c5,
    0x25ff19d8df91b05d,
    0x86cd04ebaee2d177,
    0x03319e2e043a01cc,
    0x6b1ba5f5371e8a02,
    0x76353c021b7581e2,
    0x64ee5c6323cc8f14,
    0x5c3fdc4cd03634a9,
    0x6996e2c19c32278a,
    0x8938fd7dba30d461,
    0x7b4d82a0a48b297c,
    0xbfa05ddef20ec68e,
    0x8ee6ed3b1d527a48,
    0x61bd0b112f828cb5,
    0x66631b5788e0229c,
    0x55a8ec86cc9033d2,
    0x1c9240ed837da7a4,
    0x150570279fdba0df,
    0x53ca25dac4e431bf,
    0xd636bf1f6e3ce104,
    0xcaa4fff2ed4146a0,
    0x787c1c8ea0b128b0,
    0xad7b3dbfcab7c878,
    0xfc3c5f51a57f544f,
    0xb78bb40e41be6db1,
    0x8c6baa0fb67ed7c0,
    0xce4b719a4e19e945,
    0xf96f0823a93157ee,
    0x7d2f4bfcacff2b11,
    0x3eb34973fb8eb9d0,
    0xe39f81922238f227,
    0x239dd084d7e5b230,
    0x1fa3dec38747a668,
    0xc5510664f99343b6,
    0xc829b8c6466deb28,
    0x85fc9ac5aad8d0bb,
    0xb6376d14eea8c1f5,
    0x9d8154408afdd8fa,
    0x3be01e01f7c0ba71,
    0x628c953f2bb88d79,
    0x6d796ca93f6a886f,
    0xfa5e960dad0b5622,
    0xe5fd48ce2a4cf04a,
    0xe7700ffa81605dc2,
    0x2dd4f0086c211b62,
    0x2221099e78f31e74,
    0xdb4e01bdd1c2499a,
    0xf417b68116cfff70,
    0xb506f33aea92c039,
    0x514762ee6fc89c37,
    0x9c3d8d5a25eb74be,
    0x396d59355cec17f9,
    0xccc636aee53544cd,
    0x0b1a77feb78aaaf3,
    0xe9392f763aa4f490,
    0xaaa52df96dd56651,
    0x46cf55fd5b3f9160,
    0xa4ec0d75d611cf03,
    0xaff67a8b619b65f0,
    0x3415e797e312bf67,
    0x7af15bba0b9d8538,
    0x811314ad09807f5e,
    0x8771ddf101f47d33,
    0x969b23be3d777209,
    0xd365e86d6272e2a5,
    0x58d05224736e9b4c,
    0xc660984afda9427a,
    0x5414359c63869f96,
    0xe885f66c95b258d4,
    0x655285798cda2350,
    0x6cc5b5b3907c242b,
    0x6ff42b9d944625e7,
    0xc0025116f5dd4017,
    0xa28ec429de65cd6e,
    0x63304c2584ae213d,
    0x7fa20cc807d38699,
    0x996eda2829a5771f,
    0x1b4c50ab241f098d,
    0x1e1f07d928510a2c,
    0x33cbf7d14470114e,
    0xb055a448e6dcc398,
    0x98d2033286b3db5b,
    0xec6a780436eaf731,
    0xa1bf5a07da5fcca2,
    0xbaf30aacfe40c52f,
    0xf144e1f31a81fcd1,
    0xe0ae1fbc2602f3eb,
    0x14b9a93d30cd0c9b,
    0x596c8b3edc783708,
    0x682a3bdb33248bce,
    0xb87e4d98556c68a7,
    0x80afcdb7a696d31a,
    0x5725abb267bc9e5a,
    0x914533f89a15dc20,
    0x5eb29b787b1a9921,
    0x01bcd91aaf16ac44,
    0xc1be880c5acbec53,
    0xedd6a11e99fc5b75,
    0x028d4734ab2cad88,
    0x8f5a3421b244d60c,
    0x4dd52203ecb53b93,
    0x3f0f906954981594,
    0xae4aa391ce8dc9b4,
    0x3698a0a3483e12ef,
    0xf5ab6f9bb9d95334,
    0x082be9d0b3b0ab3f,
    0xd1e8af59c95e4f2d,
    0xd87f9f93d5f84856,
    0x6e48f2873b5089a3,
    0x2443c0c270871c19,
    0xb1e97d5249ca6fdc,
    0x7c9392e603e98755,
    0x839e5399a2acd2d6,
    0x19c1179f8f33a405,
    0xde1d56cfdd8c4a3b,
    0x20ac4eaad3dfb3fc,
    0x1af089b18b09a5c9,
    0x3a5cc71b58d61635,
    0x444212c9f0133ce8,
    0x72dab26ab82d2e07,
    0x4c69fb1943a397d7,
    0xf3c9a6c7b1ad5159,
    0x1d2e99f72c6b0be0,
    0xb4ba2a2045846c7d,
    0xe22358888d2e5e63,
    0x2887a77a606f18c3,
    0xa8286acdc6f9cbd9,
    0x5f0e4262d40c3565,
    0xeee73f309dc65ab9,
    0x9be39d1c8289da97,
    0x1634ee099be1a113,
    0xea08b1583e9ef55c,
    0x9727faa49261de4d,
    0x2c682912c337b726,
    0xcff7a880e10f4501,
    0x1788371334f70d57,
    0x27725eec74bd1dd5,
    0x3146b0e5ef5cbcc6,
    0x099730ca1ca6077b,
    0xf2757fdd1ebbfd1d,
    0x6aa77cef98082646,
    0xbb4fd3b65156696b,
    0x569972a8c8aa321e,
    0xa3321d337173612a,
    0x50fbbbf4c0de3073,
    0x5a5d1510d84236c4,
    0xfd80864b0a69f80b,
    0x07de1046a762ae29,
    0xa6614a417d3d628b,
    0xd78a6605c12a4d40,
    0x67dfc24d27f68ed8,
    0xbc91c3f0f634c742,
    0xd05476436648e369,
    0x493aac6b4fed9476,
    0x12db606138b90ef6,
    0xa994b3d769ef679d,
    0x211097b07cc91fb8,
    0x30fa69ff404a1082,
    0x3c3e0e4750a21458,
    0x7504a22c1f4f802e,
    0x844043df05ce7cff,
    0xf0f838e9b5975095,
    0x7e1ed5d2a8c52add,
    0x90f9eae235037064,
    0x0662c95c0874026d,
    0x9416648a965bdf81,
    0xf69af1b5bde352f8,
    0x0d78bea2bffea89e,
    0x293b7e60cf79b487,
    0xd9c346897aeee412,
    0xfbe24f17021dfa66,
    0x1367b97b97afa2b2,
    0xab19f4e3c2c3ca15,
    0x48867571e0fb3832,
    0x93c874cc313971a8,
    0x79c0c5940fa784f4,
    0xcd7aefb44a23e889,
    0x439c028f577192c1,
    0x5be1cc0a77549a80,
/* box 6 */
    0x714d28d778656928,
    0xc88a7c6b84f64f7c,
    0xec43cac5ab89aaca,
    0x777fa38110dc16a3,
    0x0f7d5c87e4213b5c,
    0x73f051e5f3a1ef51,
    0xea714193c330d541,
    0x95e5f3dae016c4f3,
    0x63d3738095a0e173,
    0x9825d66f8ff379d6,
    0xe8cc38a148f45338,
    0xa840b0c025f06bb0,
    0x944135c35f748735,
    0x74661caa247ad31c,
    0xe7b16426acd56864,
    0xd1e689df6e6f0589,
    0xa73dec47c1d150ec,
    0x64453ecf427bdd3e,
    0x0ed99a9e5b43789a,
    0x7b1b402dc05be840,
    0x0dc025b56fe5bd25,
    0x3f183a284e22293a,
    0xa0aba108160a6ca1,
    0x46be033705bd4703,
    0x86df6e94b2b10f6e,
    0xa216d83a9dceead8,
    0x129e5b57edc5885b,
    0x7e3074509c445274,
    0x7d29cb7ba8e297cb,
    0x1611a9330eb871a9,
    0x486799a95efe3f99,
    0x9fb39b205828459b,
    0xd0424fc6d10d464f,
    0xe968feb8f79610fe,
    0x5d6f8fb164e08b8f,
    0xaafdc9f2ae34edc9,
    0x02bd79328bc48679,
    0x9b3c6944bb55bc69,
    0x6277b5992ac2a2b5,
    0x877ba88d0dd34ca8,
    0xfa5263f6a531db63,
    0x2e9fde54974164de,
    0xcda14816d8e9f548,
    0x675c81e476dd1881,
    0x2a102c30743c9d2c,
    0x37f32be07dd82e2b,
    0x256d70b7901da670,
    0x4ce86bcdbd83c66b,
    0x50afaa040b0536aa,
    0xef5a75ee9f2f6f75,
    0xb3913c4644ada73c,
    0x1187e47cd9634de4,
    0xc54a59deeb13f259,
    0x0000000000000000,
    0x01a4c619bf6243c6,
    0x90cec7a7bc097ec7,
    0xf94bdcdd91971edc,
    0x8e347f5c814b087f,
    0xc7f720ec60d77420,
    0x354e52d2f61ca852,
    0x34ea94cb497eeb94,
    0xae723b964d49143b,
    0xf48bf968fe72a3f9,
    0xfc60e8a0cd88a4e8,
    0x2909931b409a5893,
    0xbd48a6d81feedfa6,
    0x6cae2f077181da2f,
    0xad6b84bd79efd184,
    0x18c833ad55fb0933,
    0x204644cacc021c44,
    0x392ab17e269b56b1,
    0x14acd001857cf7d0,
    0x8abb8d386236f18d,
    0xeefeb3f7204d2cb3,
    0xf636805a75b62580,
    0x2bb4ea29cb5edeea,
    0xc653e6f5dfb537e6,
    0x8d2dc077b5edcdc0,
    0x31c1a0b6156151a0,
    0xf8ef1ac42ef55d1a,
    0xdbb0e125d65184e1,
    0x82509cf051ccf69c,
    0xe33e96424fa89196,
    0xdf3f1341352c7d13,
    0x8f90b9453e294bb9,
    0x1023226566010e22,
    0xa58095754a15d695,
    0x2c22a7661c85e2a7,
    0xe183ef70c46c17ef,
    0xafd6fd8ff22b57fd,
    0x471ac52ebadf04c5,
    0x4d4cadd402e185ad,
    0x916a01be036b3d01,
    0x28ad5502fff81b55,
    0x3657edf9c2ba6ded,
    0xd2ff36f45ac9c036,
    0xf1a0cd15a26d19cd,
    0xd90d98175d950298,
    0xf7924643cad46646,
    0xdd826a73bee8fb6a,
    0x9d0ee212d3ecc3e2,
    0xb6ba083b18b21d08,
    0x3da5431ac5e6af43,
    0x08eb11c833fa0711,
    0x052b347d5c1fba34,
    0x6fb7902c45271f90,
    0x133a9d4e52a7cb9d,
    0x6e135635fa455c56,
    0x725497fc4cc3ac97,
    0xf31db42729a99fb4,
    0x846217a639758917,
    0x4b7e26826a58fa26,
    0x235ffbe1f8a4d9fb,
    0xff79578bf92e6157,
    0xda14273c6933c727,
    0x8b1f4b21dd54b24b,
    0x9caa240b6c8e8024,
    0xc1c5abba086e0bab,
    0xde9bd5588a4e3ed5,
    0x2d86617fa3e7a161,
    0xbff5dfea942a59df,
    0x66f847fdc9bf5b47,
    0x3b97c84cad5fd0c8,
    0x3ebcfc31f1406afc,
    0xca3705590f32c905,
    0x24c9b6ae2f7fe5b6,
    0x408c88616d043888,
    0x93d7788c88afbb78,
    0x196cf5b4ea994af5,
    0x9a98af5d0437ffaf,
    0x8c89066e0a8f8e06,
    0xab590feb1156ae0f,
    0xd7d4028906d67a02,
    0xe4a8db0d9873addb,
    0xc378d28883aa8dd2,
    0x4ff1d4e6892503d4,
    0xd670c490b9b439c4,
    0x65e1f8d6fd199ef8,
    0xf2b9723e96cbdc72,
    0xb12c4574cf692145,
    0x569d215263bc4921,
    0x69851b7a2d9e601b,
    0x5e76309a50464e30,
    0x5fd2f683ef240df6,
    0xd8a95e0ee2f7415e,
    0xe29a505bf0cad250,
    0x96fc4cf1d4b0014c,
    0x8806f40ae9f277f4,
    0x53b6152f3fa3f315,
    0x1c47c1c9b686f0c1,
    0x80ede5c2da0870e5,
    0xd5697bbb8d12fc7b,
    0xfdc42eb972eae72e,
    0x0bf2aee3075cc2ae,
    0x22fb3df847c69a3d,
    0xbadeeb97c835e3eb,
    0xdc26ac6a018ab8ac,
    0xbcec60c1a08c9c60,
    0x4231f153e6c0bef1,
    0x337cd9849ea5d7d9,
    0x5b5d04e70c59f404,
    0x79a6391f4b9f6e39,
    0x5212d33680c1b0d3,
    0xb5a3b7102c14d8b7,
    0x7f94b249232611b2,
    0x17b56f2ab1da326f,
    0x59e07dd5879d727d,
    0xebd5878a7c529687,
    0xbb7a2d8e7757a02d,
    0x0319bf2b34a6c5bf,
    0x5ccb49a8db82c849,
    0x1de307d009e4b307,
    0x49c35fb0e19c7c5f,
    0x55849e79571a8c9e,
    0x7abf86347f39ab86,
    0x9273be9537cdf8be,
    0xe615a23f13b72ba2,
    0x6821dd6392fc23dd,
    0x5af9c2feb33bb7c2,
    0x06328b5668b97f8b,
    0x44037a058e79c17a,
    0x83f45ae9eeaeb55a,
    0x5739e74bdcde0ae7,
    0xfbf6a5ef1a5398a5,
    0xe50c1d142711ee1d,
    0x1a754a9fde3f8f4a,
    0x7802ff06f4fd2dff,
    0xf52f3f714110e03f,
    0x2674cf9ca4bb63cf,
    0x60caccaba10624cc,
    0xb088836d700b6283,
    0xa6992a5e7eb3132a,
    0xa9e476d99a922876,
    0x6b386248a65ae662,
    0xc2dc14913cc8ce14,
    0x76db6598afbe5565,
    0x32d81f9d21c7941f,
    0x21e282d373605f82,
    0xc0616da3b70c486d,
    0x616e0ab21e64670a,
    0x6d0ae91ecee399e9,
    0x27d009851bd92009,
    0xfedd9192464c2291,
    0x45a7bc1c311b82bc,
    0x54205860e878cf58,
    0xa10f6711a9682f67,
    0x9981107630913a10,
    0xede70cdc14ebe90c,
    0x70e9eecec7072aee,
    0x1f5e7ee28220357e,
    0x2f3b184d28232718,
    0x41284e78d2667b4e,
    0xa424536cf5779553,
    0xa3b21e2322aca91e,
    0x4e5512ff36474012,
    0x1efab8fb3d4276b8,
    0x89a2321356903432,
    0xcb93c340b0508ac3,
    0x306566afaa031266,
    0x4adae09bd53ab9e0,
    0xc92eba723b940cba,
    0x094fd7d18c9844d7,
    0xcc058e0f678bb68e,
    0xd4cdbda23270bfbd,
    0x0a5668fab83e8168,
    0x510b6c1db467756c,
    0xb86392a543f16592,
    0x048ff264e37df9f2,
    0x3a330e55123d930e,
    0xb235fa5ffbcfe4fa,
    0xb9c754bcfc932654,
    0x3c0185037a84ec85,
    0x0c64e3acd087fee3,
    0xe02729697b0e5429,
    0x07964d4fd7db3c4d,
    0x814923db656a3323,
    0x388e776799f91577,
    0x6a9ca4511938a5a4,
    0x1bd18c86615dcc8c,
    0xb407710993769b71,
    0x150816183a1eb416,
    0x4395374a59a2fd37,
    0xc4ee9fc75471b19f,
    0x5844bbcc38ff31bb,
    0xcf1c3124532d7331,
    0xb71ece22a7d05ece,
    0xaccf42a4c68d9242,
    0x97588ae86bd2428a,
    0x75c2dab39b1890da,
    0x9e175d39e74a065d,
    0xf0040b0c1d0f5a0b,
    0xceb8f73dec4f30f7,
    0xbe5119f32b481a19,
    0xd35bf0ede5ab83f0,
    0x7c8d0d621780d40d,
    0x85c6d1bf8617cad1,
/* box 7 */
    0xb1c742127b66f2a4,
    0xce916098d7a59fc1,
    0xc312ef8e2406fa70,
    0x956c7dced81403d5,
    0x5a0c9b2318dd9520,
    0xad0d57f51a480e8b,
    0xe7b9d05287740b01,
    0x0217f9ea2ed81268,
    0x4d7cff19f8cd3a06,
    0x44d1772e572b7b67,
    0xfb73c5b5e65af72e,
    0x91427aef84512705,
    0x0c720963e4cf6c85,
    0x87c398a0732d8117,
    0xa17f5e96fe87620e,
    0x50476c8b8e8fcf1d,
    0xcb4ee1cc9c8cb225,
    0x67b2304c91a8b59a,
    0x54696baad2caebcd,
    0xddcf03836bf01437,
    0x46c68ec479f3690f,
    0x8f9f96e2cba7c942,
    0xe1802e99f5e93db9,
    0x4e9a8086c179215a,
    0xf0c9b4686764a427,
    0xfd4a3b7e94c7c196,
    0xfcbbbd0b83abc8a2,
    0xebcbd93163bb6784,
    0xf9643c5fc882e546,
    0xc4da973041f7c5fc,
    0x1af3eb2c13b3ca97,
    0x6e1fb87b3e4ef4fb,
    0x5e229c024498b1f0,
    0xf516353c2c4d89c3,
    0xcc869972f97d8da9,
    0x8d886f08e57fdb2a,
    0x1cca15e7612efc2f,
    0x567e9240fc12f9a5,
    0x43190f9032da44eb,
    0xfeac44e1ad73daca,
    0x07c878be65f13f8c,
    0x618bce87e3358322,
    0xf895ba2adfeeec72,
    0x751dd5223a913758,
    0x59eae4bc21698e7c,
    0xff5dc294ba1fd3fe,
    0x03e67f9f39b41b5c,
    0x2292c117d1efc7c9,
    0x8a4017b6808ee4a6,
    0xd1bd0ae08f3f78b2,
    0x135e631bbc558bf6,
    0xee14586528924a60,
    0x8857ee5cae56f6ce,
    0x0000000000000000,
    0x0e65f089ca177eed,
    0x34132358269361db,
    0x15679dd0cec8bd4e,
    0x800be01e16dcbe9b,
    0x949dfbbbcf780ae1,
    0xe397d773db312fd1,
    0xedf227fa1126513c,
    0xb5e945332723d674,
    0x53a11314b73bd441,
    0x23634762c683cefd,
    0x4b4501d28a500cbe,
    0x473708b16e9f603b,
    0x1770643ae010af26,
    0xa746a05d8c1a54b6,
    0x90b3fc9a933d2e31,
    0x35e2a52d31ff68ef,
    0xab34a93e68d53833,
    0xd81082d720d939d3,
    0xb86aca25d480b3c5,
    0xdfd8fa694528065f,
    0x4f6b06f3d615286e,
    0x578f1435eb7ef091,
    0x9af80b32056f740c,
    0x92a40570bde53c59,
    0xdbf6fd48196d228f,
    0x1b026d5904dfc3a3,
    0x3c4f2d1a9e19298e,
    0xc8a89e53a538a979,
    0x991e74ad3cdb6f50,
    0x042e07215c4524d0,
    0x8e6e1097dccbc076,
    0xe071a8ece285348d,
    0xd784f42bfda24e0a,
    0x7d41db60821b7f0d,
    0x85d4614a5df5937f,
    0xbb8cb5baed34a899,
    0x40ff700f0b6e5fb7,
    0x2cf7319e1bf8b924,
    0x3a76d3d1ec841f36,
    0x4520f15b40477253,
    0xf138321d7008ad13,
    0x42e889e525b64ddf,
    0x65a5c9a6bf70a7f2,
    0x208538fdff37d5a1,
    0x410ef67a1c025683,
    0x18e412c63d6bd8ff,
    0x72d5ad9c5f6008d4,
    0x255ab9a9b41ef845,
    0x93558305aa89356d,
    0x70c2547671b81abc,
    0x3604dab2084b73b3,
    0x05df81544b292de4,
    0xf2de4d8249bcb64f,
    0x0bba71dd813e5309,
    0xa368a77cd05f7066,
    0x796fdc41de5e5bdd,
    0xec03a18f064a5808,
    0x085c0e42b88a4855,
    0x274d40439ac6ea2d,
    0x31cca20c6dba4c3f,
    0x322add93540e5763,
    0xb60f3aac1e97cd28,
    0x7cb05d1595777639,
    0xb036c4676c0afb90,
    0x0a4bf7a896525a3d,
    0x73242be9480c01e0,
    0x5bfd1d560fb19c14,
    0x7b7825abf08649b5,
    0xb7febcd909fbc41c,
    0x81fa666b01b0b7af,
    0xd25b757fb68b63ee,
    0x0d838f16f3a365b1,
    0x6a31bf5a620bd02b,
    0x26bcc6368daae319,
    0x9ed60c13592a50dc,
    0x581b62c936058748,
    0x9cc1f5f977f242b4,
    0x83ed9f812f68a5c7,
    0x74ec53572dfd3e6c,
    0xb3d0bbf855bee0cc,
    0xacfcd1800d2407bf,
    0x303d24797ad6450b,
    0x7a89a3dee7ea4081,
    0x69d7c0c55bbfcb77,
    0x770a2cc814492530,
    0x0f9476fcdd7b77d9,
    0xaeeb286a23fc15d7,
    0x2174be88e85bdc95,
    0xde297c1c52440f6b,
    0xd04c8c9598537186,
    0x2ee0c8743520ab4c,
    0x977b8424f6cc11bd,
    0x10b81c8485e190aa,
    0xa4a0dfc2b5ae4fea,
    0x98eff2d82bb76664,
    0xa8d2d6a15161236f,
    0xd4628bb4c4165556,
    0x682646b04cd3c243,
    0x2d06b7eb0c94b010,
    0x626db118da81987e,
    0x2928b0ca50d194c0,
    0x6df9c7e407faefa7,
    0x1681e24ff77ca612,
    0x4952f838a4881ed6,
    0x76fbaabd03252c04,
    0xc73ce8af7843dea0,
    0xe82da6ae5a0f7cd8,
    0xc10516640adee818,
    0x968a0251e1a01889,
    0x37f55cc71f277a87,
    0xe5ae29b8a9ac1969,
    0xcabf67b98be0bb11,
    0xf4e7b3493b2180f7,
    0xe9dc20db4d6375ec,
    0x639c376dcded914a,
    0x12afe56eab3982c2,
    0xc2e369fb336af344,
    0xa6b726289b765d82,
    0x14961ba5d9a4b47a,
    0xbc44cd0488c59715,
    0xd3aaf30aa1e76ada,
    0x28d936bf47bd9df4,
    0xaf1aae1f34901ce3,
    0x2f114e01224ca278,
    0xe648562790180235,
    0x24ab3fdca372f171,
    0x52509561a057dd75,
    0xc6cd6eda6f2fd794,
    0xa08ed8e3e9eb6b3a,
    0x09ad8837afe64161,
    0xbdb54b719fa99e21,
    0x8c79e97df213d21e,
    0xcf60e6edc0c996f5,
    0x5dc4e39d7d2caaac,
    0x11499af1928d999e,
    0x5fd31a7753f4b8c4,
    0x01f18675176c0934,
    0xc52b1145569bccc8,
    0x9f278a664e4659e8,
    0x3dbeab6f897520ba,
    0xa2992109c7337952,
    0x9b098d4712037d38,
    0xc9591826b254a04d,
    0x3b8755a4fbe81602,
    0xbe5334eea61d857d,
    0x51b6eafe99e3c629,
    0x191594b32a07d1cb,
    0x1f2c6a78589ae773,
    0x3fa95285a7ad32d2,
    0x5c3565e86a40a398,
    0xb2213d8d42d2e9f8,
    0xefe5de103ffe4354,
    0x4ab487a79d3c058a,
    0xcd771f07ee11849d,
    0xbfa2b29bb1718c49,
    0xba7d33cffa58a1ad,
    0x6fee3e0e2922fdcf,
    0x64544fd3a81caec6,
    0xd9e104a237b530e7,
    0xf32fcbf75ed0bf7b,
    0x3e58d4f0b0c13be6,
    0xb418c346304fdf40,
    0xaac52f4b7fb93107,
    0xdc3e85f67c9c1d03,
    0xd5930dc1d37a5c62,
    0x0639fecb729d36b8,
    0xc0f490111db2e12c,
    0x7ea7a4ffbbaf6451,
    0xf6f04aa315f9929f,
    0x6643b63986c4bcae,
    0x6c0841911096e693,
    0x8425e73f4a999a4b,
    0x7133d20366d41388,
    0x38612a3bc25c0d5e,
    0xb99b4c50c3ecbaf1,
    0x1d3b93927642f51b,
    0x7f56228aacc36d65,
    0x9d30738c609e4b80,
    0x48a37e4db3e417e2,
    0x8bb191c397e2ed92,
    0x2acecf5569658f9c,
    0xda077b3d0e012bbb,
    0xa55159b7a2c246de,
    0x33db5be643625e57,
    0x821c19f43804acf3,
    0x3990ac4ed530046a,
    0xd675725eeace473e,
    0x789e5a34c93252e9,
    0x86321ed564418823,
    0xfa8243c0f136fe1a,
    0xe45fafcdbec0105d,
    0x2b3f49207e0986a8,
    0xa92350d4460d2a5b,
    0x1eddec0d4ff6ee47,
    0x89a66829b93afffa,
    0x607a48f2f4598a16,
    0x6bc0392f7567d91f,
    0xea3a5f4474d76eb0,
    0x5598eddfc5a6e2f9,
    0x4c8d796cefa13332,
    0xf701ccd602959bab,
    0xe2665106cc5d26e5,

###############################################################################

TITLE
    Sharkbox crypto algorithm Dec cbox

TYPE
    64

DATA
    0xe6126af05e55aff3,
    0x4b6c893f310b0835,
    0xaa4c0e84ebfc8d57,
    0xfb9b5c7bf3b3090d,
    0x4508a6a9ccba5ce2,
    0xe5d1d2064dc6bde9,
    0x348343755288edde,
    0xb684505de46b250c,
    0xa8cede205a1e91e8,
    0x40b89b46f9fa6acc,
    0x8ee1ec1afab080ba,
    0xde77d6b7408e0a45,
    0x9a3e184c2e455802,
    0xbe93fad23f0955ef,
    0x3ae76ce3af39b909,
    0xad7ee3cf6f5ea7c6,
    0x8b51d1f5cff0b694,
    0x70ca8d8e3c43bf99,
    0xccdba7f8b2a8f6c9,
    0x4c5e6474b5a922a4,
    0x5d31adcd541ccc32,
    0x9b7f701e8c3456a7,
    0x2ac9cd08ecfd593a,
    0x8fa0844858c18e1f,
    0x32f0c66c745bc9ea,
    0xc58d6525cbbb888f,
    0x8c633cbe4b529c05,
    0xf2cd9ea68aa0774b,
    0x2cba4811ca2e7d0e,
    0xe2e33f4dc9649778,
    0xf4be1bbfac73537f,
    0x22de6787379f29d9,
    0x0956c2dd79137e46,
    0xe061efe978868bc7,
    0x1cc85ed90f97a85b,
    0x31337e9a67c8dbf0,
    0x360193d1e36af161,
    0x7fefca4a6383e5eb,
    0x8535fe633241e243,
    0xc3fee03ced68acbb,
    0x81c4abdea570dac8,
    0x67d6c12efb25753b,
    0xa4282112164dd980,
    0xcf181f0ea13be4d3,
    0xa98fb672f86f9f4d,
    0x5c70c59ff66dc297,
    0xb0f7d544c2b80138,
    0x0da79760ee2246cd,
    0x3740fb83411bffc4,
    0x24ade29e114c0ded,
    0xf858e48de0201b17,
    0x0e642f96fdb154d7,
    0xddb46e41531d185f,
    0x25ec8accb33d0348,
    0x0282d0a4b1e21cbf,
    0x1bfab3928b3582ca,
    0xaffc336bdebcbb79,
    0x35c22b27f0f9e37b,
    0x03c3b8f61393121a,
    0xb8e07fcb19da71db,
    0x99fda0ba3dd64a18,
    0xce59775c034aea76,
    0x49ee599b80e9148a,
    0xfe2b6194c6f33f23,
    0x4edcb4d0044b3e1b,
    0xd5a3c4ce887f68bc,
    0xdf36bee5e2ff04e0,
    0x171c4ca0c766caa2,
    0x0bd41279c8f162f9,
    0xe490ba54efb7b34c,
    0x5b4228d472cfe806,
    0x5355825ba9ad98e5,
    0x9f8e25a31b056e2c,
    0xcd9acfaa10d9f86c,
    0x88926903dc63a48e,
    0xb40680f9558939b3,
    0x239f0fd595ee277c,
    0xec8710db34d5c3af,
    0x87b72ec783a3fefc,
    0x632794936c144db0,
    0x46cb1e5fdf294ef8,
    0x83467b7a1492c677,
    0x9c4d9d5508967c36,
    0xd6607c389bec7aa6,
    0x165d24f26517c407,
    0xc4cc0d7769ca862a,
    0xcbe94ab3360adc58,
    0x847496319030ece6,
    0x7a5ff7a556c3d3c5,
    0xc03d58cafefbbea1,
    0x76b908971a909bad,
    0x2f79f0e7d9bd6f14,
    0x197863363ad79e75,
    0xda86830ad7bf32ce,
    0x5a034086d0bee6a3,
    0x97998f2cc0671ecf,
    0x552607428f7ebcd1,
    0x51d752ff184f845a,
    0xbb23c73d0a4963c1,
    0x2b88a55a4e8c579f,
    0xd80453ae665d2e71,
    0xee05c07f8537df10,
    0x423a4be248187673,
    0xcaa822e1947bd2fd,
    0x1abbdbc029448c6f,
    0x96d8e77e6216106a,
    0x6266fcc1ce654315,
    0x89d301517e12aa2b,
    0x730935782fd0ad83,
    0x8085c38c0701d46d,
    0x6b303e1cb7763d53,
    0x3f57510c9a798f27,
    0x4449cefb6ecb5247,
    0x48af31c922981a2f,
    0x98bcc8e89fa744bd,
    0x69b2eeb8069421ec,
    0xebb5fd90b077e93e,
    0x6a71564e150733f6,
    0x116fc9b9e1b5ee96,
    0x4a2de16d937a0690,
    0xb9a11799bbab7f7e,
    0x9368da9157562644,
    0x718be5dc9e32b13c,
    0xc82af2452599ce42,
    0xb547e8abf7f83716,
    0x33b1ae3ed62ac74f,
    0x799c4f534550c1df,
    0x3e16395e38088182,
    0x7c2c72bc7010f7f1,
    0xf38cf6f428d179ee,
    0xd29129850cdd422d,
    0x41f9f3145b8b6469,
    0x945a37dad3f40cd5,
    0x757ab061090389b7,
    0x6554118a4ac76984,
    0x7d6d1aeed261f954,
    0x01416852a2710ea5,
    0xb27505e0735a1d87,
    0x77f860c5b8e19508,
    0x78dd2701e721cf7a,
    0xe12087bbdaf78562,
    0x86f6469521d2f059,
    0xef44a82d2746d1b5,
    0xbc112a768eeb4950,
    0xc2bf886e4f19a21e,
    0x307216c8c5b9d555,
    0xc96b9a1787e8c0e7,
    0xa31acc5992eff311,
    0xa0d974af817ce10b,
    0xdcf50613f16c16fa,
    0xfca9b1307711239c,
    0x57a4d7e63e9ca06e,
    0xc64eddd3d8289a95,
    0xa25ba40b309efdb4,
    0x2e3898b57bcc61b1,
    0xf5ff73ed0e025dda,
    0xa6aaf1b6a7afc53f,
    0xd9453bfcc42c20d4,
    0x9d0cf507aae77293,
    0x290a75feff6e4b20,
    0xa7eb99e405decb9a,
    0xa1981cfd230defae,
    0x12ac714ff226fc8c,
    0x743bd833ab728712,
    0x6c02d35733d417c2,
    0xe9372d340195f581,
    0xf77da349bfe04165,
    0x68f386eaa4e52f49,
    0x211ddf71240c3bc3,
    0x13ed191d5057f229,
    0xe8764566a3e4fb24,
    0xf9198cdf425115b2,
    0xd013f921bd3f5e92,
    0x91ea0a35e6b43afb,
    0x0732ed4b84a22a91,
    0xeaf495c21206e79b,
    0x5214ea090bdc9640,
    0x0000000000000000,
    0xb3346db2d12b1322,
    0x0ce6ff324c534868,
    0xaebd5b397ccdb5dc,
    0x0a957a2b6a806c5c,
    0x1f0be62f1c04ba41,
    0x14dff456d4f5d8b8,
    0x58819022615cfa1c,
    0x05b03def3540362e,
    0xe3a2571f6b1599dd,
    0x9229b2c3f52728e1,
    0xba62af6fa8386d64,
    0x0673851926d32434,
    0x641579d8e8b66721,
    0x04f155bd9731388b,
    0x9ecf4df1b9746089,
    0x205cb723867d3566,
    0x102ea1eb43c4e033,
    0x3ba604b10d48b7ac,
    0x50963aadba3e8aff,
    0xac3f8b9dcd2fa963,
    0x7b1e9ff7f4b2dd60,
    0xf63ccb1b1d914fc0,
    0x7eaea218c1f2eb4e,
    0x5fb37d69e5fed08d,
    0x56e5bfb49cedaecb,
    0x2dfb2043685f73ab,
    0x61a54437ddf6510f,
    0x6fc16ba1204705d8,
    0xe75302a2fc24a156,
    0x3dd581a82b9b9398,
    0xdbc7eb5875ce3c6b,
    0x90ab626744c5345e,
    0x59c0f870c32df4b9,
    0x6697a97c59547b9e,
    0xfde8d962d5602d39,
    0xd3d041d7aeac4c88,
    0x5ef2153b478fde28,
    0xd4e2ac9c2a0e6619,
    0x1e4a8e7dbe75b4e4,
    0x72485d2a8da1a326,
    0x437b23b0ea6978d6,
    0x159e9c047684d61d,
    0x0f2547c45fc05a72,
    0xf10e265099336551,
    0x3c94e9fa89ea9d3d,
    0xbfd292809d785b4a,
    0x0817aa8fdb6270e3,
    0x60e42c657f875faa,
    0x18390b6498a690d0,
    0x478a760d7d58405d,
    0x284b1dac5d1f4585,
    0xb1b6bd1660c90f9d,
    0xd15291731f4e5037,
    0x4d1f0c2617d82c01,
    0xc70fb5817a599430,
    0x6d43bb0591a51967,
    0x6e8003f382360b7d,
    0x1d89368bade6a6fe,
    0x4f9ddc82a63a30be,
    0xedc6788996a4cd0a,
    0xab0d66d6498d83f2,
    0x54676f102d0fb274,
    0xc17c30985c8ab004,
    0x3865bc471edba5b6,
    0x3924d415bcaaab13,
    0x951b5f8871850270,
    0x8a10b9a76d81b831,
    0xbd5042242c9a47f5,
    0xa5694940b43cd725,
    0xff6a09c664823186,
    0x8d2254ece92392a0,
    0xb7c5380f461a2ba9,
    0x82071328b6e3c8d2,
    0xd721146a399d7403,
    0xfada342951c207a8,
    0x262f323aa0ae1152,
    0xf04f4e023b426bf4,
    0x276e5a6802df1ff7,
/* box 1 */
    0x3b4016dbfd16e203,
    0x9a7574c51174530a,
    0x90012e69c02ec8d3,
    0xf44580e3d780e076,
    0xf81dec2b49eca14b,
    0x26cae3e8a6e3d7ef,
    0x0962419e0c41f6ab,
    0x54d1eb4070ebd951,
    0x865e884b0188eec8,
    0xdf76067ea406fe8a,
    0x29849412e594fba0,
    0x461569896869c0f2,
    0xb5ddd6b3bbd6724e,
    0x0c586cc89e6c413d,
    0x6b0ad97054d904ea,
    0xa135621eec62b109,
    0x0eef7e47087ea461,
    0xfaaafea4dffe4417,
    0xe0ad344e80342331,
    0xab4138b23d382ad0,
    0x107390468e90fcff,
    0xbe0885a2218561b9,
    0xdbed22957d22c132,
    0x2251c7037fc7e857,
    0x33835ef8ba5e9c86,
    0xb3f1e0d7f4e0a8aa,
    0x3fdb32302432ddbb,
    0xa719547aa3546bed,
    0xe10c3df3cb3dab1f,
    0x17feaf9f8aafae35,
    0x9df84b1c154b01c0,
    0x8364a51d93a5595e,
    0x535cd49974d48b9b,
    0x01a109bd4b09882e,
    0xc4d0c529b0c51182,
    0x2e09abcbe1aba96a,
    0x1f3de7bccde7d0b0,
    0x9317355b1d35a5a1,
    0x6c87e6a950e65620,
    0x8910ffb142ffc287,
    0x40395fed275f1a16,
    0x7b794936da49f815,
    0xf269b68798b63a92,
    0xfd27c17ddbc116dd,
    0x8d8bdb5a9bdbfd3f,
    0x1ba6c35714c3ef08,
    0x6e30f426c6f4b37c,
    0x7fe26ddd036dc7ad,
    0x14e8b4ad57b4c347,
    0xb985ba7b25ba3373,
    0xe9cf75d08c75d59a,
    0x626898ee5898f241,
    0x5b9f9cba339cf51e,
    0xb250e96abfe92084,
    0x165fa622c1a6261b,
    0xf5e4895e9c896858,
    0xb76ac43c2dc49712,
    0x02b7128f9612e55c,
    0x1d8af5335bf535ec,
    0x36b973ae28732b10,
    0xa8572380e02347a2,
    0xf6f2926c4192052a,
    0x8c2ad2e7d0d27511,
    0xd32e6ab63a6abfb7,
    0xbd1e9e90fc9e0ccb,
    0x03161b32dd1b6d72,
    0x4dc03a98f23ad305,
    0x81d3b79205b7bc02,
    0x450372bbb572ad80,
    0x2d1fb0f93cb0c418,
    0x2a928f20388f96d2,
    0x721b08a8d6080ebe,
    0x92b63ce6563c2d8f,
    0xeb78675f1a6730c6,
    0x13658b74538b918d,
    0x428e4d62b14dff4a,
    0x88b1f60c09f64aa9,
    0x75963771d2375c74,
    0x7ad8408b9140703b,
    0x57c7f072adf0b423,
    0xe5971918121994a7,
    0x5666f9cfe6f93c0d,
    0x8f3cc9d50dc91863,
    0x1e9cee0186ee589e,
    0x8a06e4839fe4aff5,
    0xb824b3c66eb3bb5d,
    0xd1997839ac785aeb,
    0x6752b5b8cab545d7,
    0xb47cdf0ef0dffa60,
    0x949a0a82190af76b,
    0xc04be1c269e12e3a,
    0xfc86c8c090c89ef3,
    0xe3bb2f7c5d2f4e43,
    0x6aabd0cd1fd08cc4,
    0x2147dc31a2dc8525,
    0xca3fbb6eb8bbb5e3,
    0x48fa17ce60176493,
    0x6444ae8a17ae28a5,
    0x2b33869d73861efc,
    0xd0387184e771d2c5,
    0x7cf476efde76aadf,
    0x63c9915313917a6f,
    0xc929a05c65a0d891,
    0xda4c2b28362b491c,
    0xfe31da4f06da7baf,
    0xc1eae87f22e8a614,
    0x5c12a36337a3a7d4,
    0x18b0d865c9d8827a,
    0xe7200b97840b71fb,
    0x4bec0cfcbd0c09e1,
    0x0f4e77fa43772c4f,
    0x4c613325b9335b2b,
    0xf3c8bf3ad3bfb2bc,
    0x87ff81f64a8166e6,
    0xa38270917a705455,
    0x1911d1d882d10a54,
    0x44a27b06fe7b25ae,
    0x049b24ebd9243fb8,
    0xbb32a8f4b3a8d62f,
    0x91a027d48b2740fd,
    0x3d6c20bfb22038e7,
    0xe681022acf02f9d5,
    0xf17fadb545ad57e0,
    0xcc138d0af78d6f07,
    0x495b1e732b1eecbd,
    0x38560de9200d8f71,
    0xa9f62a3dab2acf8c,
    0x47b46034236048dc,
    0x8e9dc06846c0904d,
    0xaccc076b3907781a,
    0x32225745f15714a8,
    0xd4a3556f3e55ed7d,
    0xd7b54e5de34e800f,
    0xddc114f132141bd6,
    0x6d26ef141befde0e,
    0x85489379dc9383ba,
    0x0bd553119a5313f7,
    0x786f520407529567,
    0xcb9eb2d3f3b23dcd,
    0xa223792c3179dc7b,
    0x0a745aacd15a9bd9,
    0x710d139a0b1363cc,
    0x681cc24289c26998,
    0x1a07caea5fca6726,
    0x82c5aca0d8acd170,
    0x25dcf8da7bf8ba9d,
    0xc7c6de1b6dde7cf0,
    0xc35dfaf0b4fa4348,
    0xded70fc3ef0f76a4,
    0x504acfaba9cfe6e9,
    0xc571cc94fbcc99ac,
    0x5ea5b1eca1b14288,
    0xae7b15e4af159d46,
    0xc888a9e12ea950bf,
    0xf7539bd10a9b8d04,
    0x962d180d8f181237,
    0xe43610a559101c89,
    0x772125fe4425b928,
    0x84e99ac4979a0b94,
    0xc667d7a626d7f4de,
    0xefe343b4c3430f7e,
    0xd5025cd2755c6553,
    0xa6b85dc7e85de3c3,
    0xd61447e0a8470821,
    0x3e7a3b8d6f3b5595,
    0x52fddd243fdd03b5,
    0x8072be2f4ebe342c,
    0x12c482c9188219a3,
    0x9eee502ec8506cb2,
    0xad6d0ed6720ef034,
    0x59288e35a58e1042,
    0xe21a26c11626c66d,
    0x247df16730f132b3,
    0xf0dea4080ea4dfce,
    0x31344c772c4c79da,
    0x4f77281764283659,
    0x79ce5bb94c5b1d49,
    0x0000000000000000,
    0x73ba01159d018690,
    0x74373ecc993ed45a,
    0xbcbf972db79784e5,
    0x4ed621aa2f21be77,
    0xd95a301aeb30246e,
    0x9c5942a15e4289ee,
    0x37187a13637aa33e,
    0x276bea55edea5fc1,
    0x1c2bfc8e10fcbdc2,
    0xed54513b5551ea22,
    0x20e6d58ce9d50d0b,
    0x3ae11f66b61f6a2d,
    0x66f3bc0581bccdf9,
    0x2cbeb94477b94c36,
    0x99636ff7cc6f3e78,
    0x953b033f52037f45,
    0xb0e7fbe529fbc5d8,
    0x60df8a61ce8a171d,
    0x6f91fd9b8dfd3b52,
    0xaae0310f7631a2fe,
    0xbfa98c1f6a8ce997,
    0x8ba7ed3ed4ed27db,
    0x98c2664a8766b656,
    0x062c36644f36dae4,
    0x5570e2fd3be2517f,
    0xead96ee2516eb8e8,
    0x419856506c569238,
    0x23f0cebe34ce6079,
    0x309545ca6745f1f4,
    0x5a3e950778957d30,
    0x617e83dc85839f33,
    0xfb0bf71994f7cc39,
    0x3ccd2902f929b0c9,
    0x70ac1a27401aebe2,
    0xcea49f85619f8a5b,
    0x39f704546b04075f,
    0x0df96575d565c913,
    0x08c3482347487e85,
    0xd28f630b71633799,
    0xecf558861e58620c,
    0xc2fcf34dfff3cb66,
    0x978c11b0c4119a19,
    0x69bdcbffc2cbe1b6,
    0xba93a149f8a15e01,
    0x51ebc616e2c66ec7,
    0x078d3fd9043f52ca,
    0x58898788ee87986c,
    0x4a4d0541f60581cf,
    0xe86e7c6dc77c5db4,
    0xee424a09884a8750,
    0xcdb284b7bc84e729,
    0x65e5a7375ca7a08b,
    0x2fa8a276aaa22144,
    0xa0946ba3a76b3927,
    0xa5ae46f535468eb1,
    0x35af689cf5684662,
    0x28259dafae9d738e,
    0xcf0596382a960275,
    0xb6cbcd8166cd1f3c,
    0x7e43646048644f83,
    0x9bd47d785a7ddb24,
    0x432f44dffa447764,
    0x9f4f59938359e49c,
    0x7d557f52957f22f1,
    0x76802c430f2c3106,
    0xdc601d4c791d93f8,
    0x053a2d56922db796,
    0x11d299fbc59974d1,
    0xf9bce59602e52965,
    0xd8fb39a7a039ac40,
    0x340e6121be61ce4c,
    0x5f04b851eab8caa6,
    0x5db3aade7caa2ffa,
    0x1549bd101cbd4b69,
    0xff90d3f24dd3f381,
    0xafda1c59e41c1568,
    0xb146f25862f24df6,
    0xa40f4f487e4f069f,
/* box 2 */
    0xa1a35cebf8f0f94c,
    0x2c203d650f3f095d,
    0x1a2bdaee4084a2a7,
    0xd32404574d7bcc68,
    0xf785bea594a9adc4,
    0xf2eb54456206949c,
    0x3f5e334d0475ced1,
    0x5994299b835d1f60,
    0x785b7989ac204794,
    0x025da6a2cf461a41,
    0xdf1f3a71f01a901b,
    0x27284f018bb77637,
    0xe1955a6d694c5310,
    0x24a1baf2d9d261ac,
    0xe4fbb08d9fe36a48,
    0x8d83618ef7cff011,
    0x2ac72276abf5279e,
    0xf9e32621e68eebf6,
    0xbf323fb4d3f86f69,
    0xbb888605b8745beb,
    0x70dafe1e7acd2f65,
    0xd0adf1a41f1edbf3,
    0x1e91635f2b089625,
    0xee2791b8864818f8,
    0x99ce23e4c56c1484,
    0xf33f0714ff259946,
    0xbd6f99161cbe7528,
    0x9f293cf761a63a47,
    0xb80173f6ea114c70,
    0x6543ef25d54dc62a,
    0x39b92c5ea0bfe012,
    0x63a4f0367187e8e9,
    0x4c0d38a02cddf62f,
    0x07334c4239e92319,
    0x43bff375c3d9bdc7,
    0xca862b4a5f9a7954,
    0x5d2e902ae8d12be2,
    0x137e0e280b4ac78c,
    0xf162a1b630638307,
    0x55af17bd3e3c4313,
    0x358212781ddebc61,
    0x94214e93e52e452d,
    0xc18e592edb12063e,
    0xec7a371a490e02b9,
    0x4963d240da72cf77,
    0x41e255d70c9fa786,
    0xff0439324244c535,
    0x88ed8b6e0160c949,
    0x6c163be39e83a301,
    0xc534e09fb09e32bc,
    0x806c0cf9d78da1b8,
    0xdba583c09b96a499,
    0x746047af11411be7,
    0xf40c4b56c6ccba5f,
    0x6270a367eca4e533,
    0xd41748157492ef71,
    0xeff3c2e91b6b1522,
    0x0e66988472274632,
    0x534808ae9af66dd0,
    0x8231aa5b18cbbbf9,
    0xb2dd52c3f3ba3ec0,
    0xdd429cd33f5c8a5a,
    0x4e509e02e39bec6e,
    0x26fc1c5016947bed,
    0xd9f8256254d0bed8,
    0x0955d4c64bce652b,
    0x1610e4c8fde5fed4,
    0x6dc268b203a0aedb,
    0x2e7d9bc7c079131c,
    0xc3d3ff8c14541c7f,
    0xd64aeeb7bbd4f530,
    0xab7f7ddee15b8bfc,
    0x144d426a32a3e495,
    0x8e0a947da5aae78a,
    0x798f2ad831034a4e,
    0x3be48afc6ff9fa53,
    0x529c5bff07d5600a,
    0xbee66ce54edb62b3,
    0x931202d1dcc76634,
    0x50c1fd5dc8937a4b,
    0xa4cdb60b0e5fc014,
    0x57f2b11ff17a5952,
    0x47054ac4a8558945,
    0x5a1ddc68d13808fb,
    0x5cfac37b75f22638,
    0xc207acdd897711a5,
    0x289a84d464b33ddf,
    0xc05a0a7f46310be4,
    0xe6a6162f50a57009,
    0x06e71f13a4ca2ec3,
    0x5f733688279731a3,
    0xeb497b5870e721a0,
    0xb667eb7298360a42,
    0xe3c8fccfa60a4951,
    0xe772457ecd867dd3,
    0x6978d103682c9a59,
    0x0def6d77204251a9,
    0xc90fdeb90dff6ecf,
    0xd179a2f5823dd629,
    0x2fa9c8965d5a1ec6,
    0x81b85fa84aaeac62,
    0xdc96cf82a27f8780,
    0x602d05c523e2ff72,
    0x19a22f1d12e1b53c,
    0xe52fe3dc02c06792,
    0x58407aca1e7e12ba,
    0x61f95694bec1f2a8,
    0x48b781114751c2ad,
    0xaaab2e8f7c788626,
    0x04bab9b16b8c3482,
    0x2df46e34921c0487,
    0x1123a88ac40cddcd,
    0xc6bd156ce2fb2527,
    0x7f6835cb95c9648d,
    0x83e5f90a85e8b623,
    0x4f84cd537eb8e1b4,
    0x294ed785f9903005,
    0x1cccc5fde44e8c64,
    0xcb52781bc2b9748e,
    0x1d1896ac796d81be,
    0xb30901926e99331a,
    0xad9862cd4591a53f,
    0xc8db8de890dc6315,
    0x7bd28c7afe45500f,
    0x0adc213519ab72b0,
    0xa8f6882db33e9c67,
    0xb5ee1e81ca531dd9,
    0x201b0343b25e552e,
    0x4036068691bcaa5c,
    0xae11973e17f4b2a4,
    0x9efd6fa6fc85379d,
    0x33650d6bb91492a2,
    0x3a30d9adf2daf789,
    0x0c3b3e26bd615c73,
    0xf651edf4098aa01e,
    0x710ead4fe7ee22bf,
    0x3138abc9765288e3,
    0x9d749a55aee02006,
    0x6e4b9d4151c5b940,
    0x84d6b548bc01953a,
    0x360be78b4fbbabfa,
    0xa22aa918aa95eed7,
    0xedae644bd42d0f63,
    0x46d119953576849f,
    0x6497bc74486ecbf0,
    0xfbbe808329c8f1b7,
    0x4aea27b38817d8ec,
    0x5626e24e6c595488,
    0x056eeae0f6af3958,
    0x4558ec6667139304,
    0x448cbf37fa309ede,
    0x6f9fce10cce6b49a,
    0xa0770fba65d3f496,
    0x671e49871a0bdc6b,
    0xda71d09106b5a943,
    0x08818797d6ed68f1,
    0xa3fefa4937b6e30d,
    0xb080f4613cfc2481,
    0x763de10dde0701a6,
    0x4dd96bf1b1fefbf5,
    0x92c6518041e46bee,
    0x3456412980fdb1bb,
    0x981a70b5584f195e,
    0x3d0395efcb33d490,
    0xba5cd55425575631,
    0x4b3e74e21534d536,
    0x6af124f03a498dc2,
    0x7ebc669a08ea6957,
    0x30ecf898eb718539,
    0xa922db7c2e1d91bd,
    0x7a06df2b63665dd5,
    0xb154a730a1df295b,
    0xfc8dccc11021d2ae,
    0xcfe8c1aaa935400c,
    0x97a8bb60b74b52b6,
    0x18767c4c8fc2b8e6,
    0x9a47d6179709031f,
    0x0000000000000000,
    0xac4c319cd8b2a8e5,
    0xb9d520a7773241aa,
    0xdecb69206d399dc1,
    0x1f45300eb62b9bff,
    0x10f7fbdb592fd017,
    0x3e8a601c9956c30b,
    0x8502e619212298e0,
    0xf5d818075befb785,
    0x547b44eca31f4ec9,
    0x9ca0c90433c32ddc,
    0xe041093cf46f5eca,
    0xa69010a9c119da55,
    0xc769463d7fd828fd,
    0xc4e0b3ce2dbd3f66,
    0x2575e9a344f16c76,
    0x01d453519d230dda,
    0xfa6ad3d2b4ebfc6d,
    0xd5c31b44e9b1e2ab,
    0xf83775707bade62c,
    0xbcbbca47819d78f2,
    0xd79ebde626f7f8ea,
    0x5bc98f394c1b0521,
    0x2246a5e17d184f6f,
    0x12aa5d799669ca56,
    0x5ea765d9bab43c79,
    0x8939d83f9c43c493,
    0x32b15e3a24379f78,
    0xe914ddfabfa13be1,
    0x909bf7228ea271af,
    0x73530bed28a838fe,
    0xd2f05706d058c1b2,
    0xfed06a63df67c8ef,
    0xb43a4dd057701003,
    0xa519e55a937ccdce,
    0x75b414fe8c62163d,
    0xafc5c46f8ad7bf7e,
    0x2392f6b0e03b42b5,
    0x386d7f0f3d9cedc8,
    0x21cf50122f7d58f4,
    0x9b9385460a2a0ec5,
    0x5115ae0c55b07791,
    0x0fb2cbd5ef044be8,
    0xea9d2809edc42c7a,
    0xcc613459fb505797,
    0x426ba0245efab01d,
    0x1599113baf80e94f,
    0x7d3593695a8f7ecc,
    0x0389f5f35265179b,
    0x875f40bbee6482a1,
    0x95f51dc2780d48f7,
    0x7ce1c038c7ac7316,
    0xce3c92fb34164dd6,
    0xcdb5670866735a4d,
    0x8ab02dccce26d308,
    0x914fa47313817c75,
    0x8b647e9d5305ded2,
    0xd82c7633c9f3b302,
    0x728758bcb58b3524,
    0xe8c08eab2282363b,
    0x8fdec72c3889ea50,
    0x2b13712736d62a44,
    0x3cd7c6be5610d94a,
    0x37dfb4dad298a620,
    0x868b13ea73478f7b,
    0xb7b3b82305150798,
    0x0b08726484887f6a,
    0x1bff89bfdda7af7d,
    0x77e9b25c43240c7c,
    0xf0b6f2e7ad408edd,
    0x17c4b79960c6f30e,
    0x8c5732df6aecfdcb,
    0x68ac8252f50f9783,
    0x66ca1ad68728d1b1,
    0x6b2577a1a76a8018,
    0xe21caf9e3b29448b,
    0xa74443f85c3ad78f,
    0xfd599f908d02df74,
    0x967ce8312a685f6c,
/* box 3 */
    0xfa7b9775ba3af751,
    0x03ef98cb769c2d13,
    0x7191ce067072359e,
    0xbab18b6bff7516a8,
    0xe6e5ef4efbc1065e,
    0x7bec74a3b1d0dbf4,
    0x656b4fb907c31c4a,
    0x4e8520f99fc86304,
    0x8fd8df31d16dae58,
    0x90a93fc1e60a7244,
    0x30ad09f2b449cfc5,
    0x8453be7e91bb5b90,
    0x1d68a3d1c08feaad,
    0x5c54642504b410f6,
    0x8061383c8a9e3707,
    0xf9940fbecca6da42,
    0x46e1d97da982bbdf,
    0xfc50521656f7ad77,
    0x5e4d2704f35c2647,
    0x8bea5973ca48c2cf,
    0xd06323dfa34593bd,
    0x62b651306a7a5dce,
    0xa436b0714966d116,
    0x4f73fb131ebc78a6,
    0x92b07ce011e244f5,
    0x33429139c2d5e2d6,
    0xcee418c515565403,
    0xd7be3d56cefcd239,
    0x53ed83285f4789a9,
    0xf3e9b51b0d043428,
    0x20650e0fd8dd8a86,
    0xb6e7f4add21aa2e4,
    0x6d0fb63d3189c491,
    0x0da0a42cac1bafee,
    0x3f14eeffefba569a,
    0x13279f361a086850,
    0x9b225e8ea6dc878c,
    0x6684d772715f3159,
    0xa3ebaef824df9092,
    0xc499a260d4f4ba69,
    0xaa798c9693e153eb,
    0x50021be329dba4ba,
    0x949bb983fd2f1ed3,
    0xdfdac4d2f8b60ae2,
    0xf0062dd07b98193b,
    0xafbdd13e09b024de,
    0xb95e13a089e93bbb,
    0x649d945386b707e8,
    0xe4fcac6f0c2930ef,
    0x413cc7f4c43bfa5b,
    0x3b2668bdf49f3a0d,
    0xe50a77858d5d2b4d,
    0x05c45da89a517735,
    0x3ee235156ece4d38,
    0xfe491137a11f9bc6,
    0xb7112f47536eb946,
    0x07dd1e896db94184,
    0x1ab5bd58ad36ab29,
    0x8197e3d60bea2ca5,
    0xab8f577c12954849,
    0x9cff4007cb65c608,
    0xa00436335243bd81,
    0xfda689fcd783b6d5,
    0xccfd5be4e2be62b2,
    0x75a348446b575909,
    0x17151974012d04c7,
    0xfb8d4c9f3b4eecf3,
    0xac5249f57f2c09cd,
    0x9346a70a90965f57,
    0x043286421b256c97,
    0x27b81086b564cb02,
    0x3569545a2e18b8f0,
    0x6b24735edd449eb7,
    0x2193d5e559a99124,
    0xc7763aaba268977a,
    0xb0cc31ce3ed7f8c2,
    0xc939064c78ef1587,
    0x16e3c29e80591f65,
    0x5da2bfcf85c00b54,
    0x5990398d9ee567c3,
    0x67720c98f02b2afb,
    0x54309da132fec82d,
    0xeab39088d6aeb212,
    0x9682faa20ac72862,
    0xd38cbb14d5d9beae,
    0x4c9c63d8682055b5,
    0xd648e6bc4f88c99b,
    0xdc355c198e2a27f1,
    0x10c807fd6c944543,
    0x450e41b6df1e96cc,
    0x0b8b614f40d6f5c8,
    0xd27a60fe54ada50c,
    0x49583e70f2712280,
    0x8dc19c10268598e9,
    0x5866e2671f917c61,
    0x79f537824638ed45,
    0xc2b267033839e04f,
    0xcb20456d8f072336,
    0x2a18b4aa197f64ec,
    0xdbe84290e3936675,
    0x73888d27879a032f,
    0xe8aad3a9214684a3,
    0x6ee02ef64715e982,
    0xa996145de57d7ef8,
    0xc8cfdda6f99b0e25,
    0x062bc563eccd5a26,
    0x264ecb6c3410d0a0,
    0xb8a8c84a089d2019,
    0x7dc7b1c05d1d81d2,
    0xd5a77e773914e488,
    0x4b417d5105991431,
    0xf62de8b39755431d,
    0x993b1daf5134b13d,
    0x82787b1d7d7601b6,
    0xe321b2e66190716b,
    0xb5086c66a4868ff7,
    0x9ee603263c8df0b9,
    0x349f8fb0af6ca352,
    0x5b897aac690d5172,
    0x7c316a2adc699a70,
    0xd451a59db860ff2a,
    0x706715ecf1062e3c,
    0x838ea0f7fc021a14,
    0x57df056a4462e53e,
    0xcf12c32f94224fa1,
    0xed6e8e01bb17f396,
    0x915fe42b677e69e6,
    0x89f31a523da0f47e,
    0xe71334a47ab51dfc,
    0xa860cfb76409655a,
    0x9f10d8ccbdf9eb1b,
    0xef77cd204cffc527,
    0xf862d4544dd2c1e0,
    0x8a1c82994b3cd96d,
    0xae4b0ad488c43f7c,
    0x98cdc645d040aa9f,
    0x7fdef2e1aaf5b763,
    0x4717029728f6a07d,
    0x745593aeea2342ab,
    0xee8116cacd8bde85,
    0x727e56cd06ee188d,
    0x227c4d2e2f35bc37,
    0x977421488bb333c0,
    0xa21d7512a5ab8b30,
    0xbb4750817e010d0a,
    0x6cf96dd7b0fddf33,
    0x2801f78bee97525d,
    0x1c9e783b41fbf10f,
    0x9d099bed4a11ddaa,
    0x7a1aaf4930a4c056,
    0x32b44ad343a1f974,
    0x3cfb763499267b89,
    0xb2d572efc93fce73,
    0x63408adaeb0e466c,
    0xada4921ffe58126f,
    0x5fbbfcee72283de5,
    0x6ad2a8b45c308515,
    0x0c567fc62d6fb44c,
    0x956d62697c5b0571,
    0x25a153a7428cfdb3,
    0x150c5a55f6c53276,
    0xe2d7690ce0e46ac9,
    0xda1e997a62e77dd7,
    0xf5c27078e1c96e0e,
    0xc344bce9b94dfbed,
    0x60af12119d926b7f,
    0xa1f2edd9d337a623,
    0xcad69e870e733894,
    0x3770177bd9f08e41,
    0xa5c06b9bc812cab4,
    0x1f71e0f03767dc1c,
    0x44f89a5c5e6a8d6e,
    0x6159c9fb1ce670dd,
    0x8e2e04db5019b5fa,
    0x8805c1b8bcd4efdc,
    0xe138f1c7967847da,
    0x4ab7a6bb84ed0f93,
    0x0000000000000000,
    0x38c9f0768203171e,
    0x1b4366b22c42b08b,
    0x7803ec68c74cf6e7,
    0xec9855eb3a63e834,
    0xbe830d29e4507a3f,
    0x2dc5aa2374c62568,
    0xa62ff350be8ee7a7,
    0x764cd08f1dcb741a,
    0x8c3747faa7f1834b,
    0x0fb9e70d5bf3995f,
    0x55c6464bb38ad38f,
    0xf7db3359162158bf,
    0xd195f8352231881f,
    0x0992226eb73ec379,
    0x14fa81bf77b129d4,
    0x48aee59a73053922,
    0x2457884dc3f8e611,
    0xffbfcadd206b8064,
    0xb4feb78c25f29455,
    0x864afd5f66536d21,
    0x6f16f51cc661f220,
    0xde2c1f3879c21140,
    0x195a2593dbaa863a,
    0x2e2a32e8025a087b,
    0x432584d533d3ccea,
    0x2c3371c9f5b23eca,
    0xa7d928ba3ffafc05,
    0x42d35f3fb2a7d748,
    0x85a5659410cf4032,
    0x0864f984364ad8db,
    0xf21f6ef18c702f8a,
    0xf1f0f63afaec0299,
    0xd9f101b1147b50c4,
    0x2fdce902832e13d9,
    0x4d6ab832e9544e17,
    0xe0ce2a2d170c5c78,
    0x51f4c009a8afbf18,
    0x68cbeb95abd8b3a4,
    0xc15dffc84ea5cd5c,
    0x02194321f7e836b1,
    0x113edc17ede05ee1,
    0x521b58c2de33920b,
    0x9ad4856427a89c2e,
    0x5629de80c516fe9c,
    0x77ba0b659cbf6fb8,
    0x238a96c4ae41a795,
    0x12d144dc9b7c73f2,
    0xd807da5b950f4b66,
    0x3686cc91588495e3,
    0x18acfe795ade9d98,
    0x5a7fa146e8794ad0,
    0xc680e141231c8cd8,
    0x1e873b1ab613c7be,
    0xf434ab9260bd75ac,
    0xcd0b800e63ca7910,
    0xbc9a4e0813b84c8e,
    0x3d0dadde1852602b,
    0x40ca1c1e454fe1f9,
    0x0a7dbaa5c1a2ee6a,
    0x693d307f2aaca806,
    0x0e4f3ce7da8782fd,
    0xbd6c95e292cc572c,
    0x3ad0b35775eb21af,
    0x7e28290b2b81acc1,
    0x01f6dbea81741ba2,
    0x87bc26b5e7277683,
    0x393f2b9c03770cbc,
    0xddc387f30f5e3c53,
    0xeb454b6257daa9b0,
    0xb323a905484bd5d1,
    0xb13aea24bfa3e360,
    0x315bd218353dd467,
    0x2bee6f40980b7f4e,
    0xe95c0843a0329f01,
    0xc56f798a5580a1cb,
    0xbf75d6c36524619d,
    0x29f72c616fe349ff,
    0xc0ab2422cfd1d6fe,
/* box 4 */
    0x561fc423e957943c,
    0x014287ca69079288,
    0x2f086129dfcd1d21,
    0xc537d4aea044fd99,
    0xf1e8c3bfd7c8a457,
    0x2971998a5cdf9bfb,
    0x23fa649a2ce9e460,
    0x3aa9e9c356a6716a,
    0xd6efa4e7aa3d1708,
    0x705a24b1fda5b5eb,
    0x101e0ce2b170a9fc,
    0x7ca821020e814caa,
    0x0bc97ada1931ed13,
    0x34df1711778c59ce,
    0xd35020ef9226d2bf,
    0x575d43e9805006b4,
    0x91acebec9b1db840,
    0x549b3f423b5945d9,
    0x99a3ed9d3925163e,
    0x7917a50a369a891d,
    0xe372343cb4b6dc4e,
    0x8d40e2bdd949e8fd,
    0xcfbc29bed0728202,
    0x969794857108ac12,
    0xdd26de3db30cfa1b,
    0x115c8b28d8773b74,
    0xe9f9c92cc480a3d5,
    0x4dc8b21b4116d0d3,
    0x316093194f979c79,
    0x5124bb4a0342806e,
    0xb31408bcdef3cea8,
    0xc1cad76cf158aaa6,
    0x88ff66b5e1522d4a,
    0xa8c37e8476b28a47,
    0x15a188ea896b6c4b,
    0xa24883940684f5dc,
    0xda1da1545919ee49,
    0x22b8e35045ee76e8,
    0x6106af9925d28e9f,
    0xef80318f4792250f,
    0x663dd0f0cfc79acd,
    0x302214d326900ef1,
    0xdfa2255c61022bfe,
    0xe6cdb0348cad19f9,
    0x50663c806a4512e6,
    0x65fbac5b74ced9a0,
    0xc4755364c9436f11,
    0x8fc419dc0b473918,
    0x5c9439339961eba7,
    0x3f166dcb6ebdb4dd,
    0xba59890715ccf25e,
    0xf0aa4475becf36df,
    0x03c67cabbb09436d,
    0xb99ff5acaec5b133,
    0xf9e7c5ce75f00a29,
    0x6df4aa2ad6f677de,
    0xaeba8627f5a00c9d,
    0xa573fcfdec91e18e,
    0x7f6e5da9b5880fc7,
    0xca03adb6e86947b5,
    0x74a72773acb9e2d4,
    0x604428534cd51c17,
    0xf8a542041cf798a1,
    0x448533a08a29ec25,
    0x80f060c4436a8334,
    0x0db082799a236bc9,
    0xfa21b965cef94944,
    0x64b92b911dc94b28,
    0x7118a37b94a22763,
    0xaff801ed9ca79e15,
    0x1dae8e9b2b53c235,
    0x13d870490a79ea91,
    0x8a7b9dd4335cfcaf,
    0x1f2a75faf95d13d0,
    0xeec2b6452e95b787,
    0xc34e2c0d23567b43,
    0x47434f0b3120af48,
    0xa18eff3fbd8db6b1,
    0x98e16a57502284b6,
    0x37196bbacc851aa3,
    0x8e869e166240ab90,
    0x9fda153eba3790e4,
    0xf515c07d86d4f368,
    0x72dedfd02fab640e,
    0xe230b3f6ddb14ec6,
    0x97d5134f180f3e9a,
    0xe1f6cf5d66b80dab,
    0xe78f37fee5aa8b71,
    0xa30a045e6f836754,
    0x90ee6c26f21a2ac8,
    0xaa4785e5a4bc5ba2,
    0x4e0eceb0fa1f93be,
    0x94136fe4a3067df7,
    0x7b935e6be49458f8,
    0x9b2716fceb2bc7db,
    0x840d63061276d40b,
    0xed04caee959cf4ea,
    0xea3fb5877f89e0b8,
    0xb56df01f5de14872,
    0x4935b1d9100a87ec,
    0x82749ba5916452d1,
    0x58693af1c87dbc98,
    0x89bde17f8855bfc2,
    0x677f573aa6c00845,
    0xeb7d324d168e7230,
    0x0284fb61d20ed1e5,
    0xb190f3dd0cfd1f4d,
    0x684b2e22eeedb269,
    0x2bf562eb8ed14a1e,
    0xe0b448970fbf9f23,
    0x396f9568edaf3207,
    0x52e2c7e1b84bc303,
    0x77615bd817b0a1b9,
    0x7e2cda63dc8f9d4f,
    0xf22ebf146cc1e73a,
    0xc08850a6985f382e,
    0xd9dbddffe210ad24,
    0xbfe60d0f2dd737e9,
    0x9a659136822c5553,
    0x87cb1fada97f9766,
    0x4c8a35d12811425b,
    0x83361c6ff863c059,
    0xd212a725fb214037,
    0x9e9892f4d330026c,
    0x45c7b46ae32e7ead,
    0x5baf465a7374fff5,
    0xdc6459f7da0b6893,
    0xd46b5f867833c6ed,
    0x5dd6bef9f066792f,
    0xcb412a7c816ed53d,
    0x75e5a0b9c5be705c,
    0xf6d3bcd63dddb005,
    0xfb633eafa7fedbcc,
    0xd529d84c11345465,
    0xc9c5d11d536004d8,
    0xdb5f269e301e7cc1,
    0x86899867c07805ee,
    0x3d9296aabcb36538,
    0x2cce1d8264c45e4c,
    0x5aedc1901a736d7d,
    0x2e4ae6e3b6ca8fa9,
    0x1e68f230905a8158,
    0xdee0a2960805b976,
    0xcd38d2df027c53e7,
    0x6909a9e887ea20e1,
    0x24c11bf3c6fcf032,
    0x18110a9313480782,
    0xa7f7079c3e9f306b,
    0xd8995a358b173fac,
    0x854fe4cc7b714683,
    0xbd62f66effd9e60c,
    0x14e30f20e06cfec3,
    0x6e32d6816dff34b3,
    0x217e9ffbfee73585,
    0xc88756d73a679650,
    0x359d90db1e8bcb46,
    0x2645e09214f221d7,
    0x04fd03c2511c573f,
    0x739c581a46acf686,
    0xb0d2741765fa8dc5,
    0xa0cc78f5d48a2439,
    0x5e10c2524b6f3a42,
    0xe50bcc9f37a45a94,
    0x53a0402bd14c518b,
    0x413ab7a8b2322992,
    0x203c183197e0a70d,
    0xcc7a55156b7bc16f,
    0x4601c8c158273dc0,
    0xbea48ac544d0a561,
    0x638254f8f7dc5f7a,
    0xa6b580565798a2e3,
    0x3cd01160d5b4f7b0,
    0x8c026577b04e7a75,
    0x7ad1d9a18d93ca70,
    0x785522c05f9d1b95,
    0x5f5245982268a8ca,
    0x9551e82eca01ef7f,
    0x0000000000000000,
    0xbb1b0ecd7ccb60d6,
    0x094d81bbcb3f3cf6,
    0x28331e4035d80973,
    0xf7913b1c54da228d,
    0x6acfd5433ce3638c,
    0x1bd77638a84144ef,
    0x62c0d3329edbcdf2,
    0x81b2e70e2a6d11bc,
    0xd7ad232dc33a8580,
    0x05bf8408381bc5b7,
    0x33e468789d994d9c,
    0xfedcbaa79fe51e7b,
    0x4f4c497a93180136,
    0x073b7f69ea151452,
    0x0cf205b3f324f941,
    0x382d12a284a8a08f,
    0x1cec0951425450bd,
    0x55d9b888525ed751,
    0x6cb62de0bff1e556,
    0xd1d4db8e4028035a,
    0x25839c39affb62ba,
    0x4af3cd72ab03c481,
    0xa4317b3785967306,
    0x1a95f1f2c146d667,
    0x926a97472014fb2d,
    0xb7e90b7e8fef9997,
    0xcefeae74b975108a,
    0x3e54ea0107ba2655,
    0xd0965c44292f91d2,
    0xab05022fcdbbc92a,
    0xfd1ac60c24ec5d16,
    0xfc5841c64debcf9e,
    0xe4494b555ea3c81c,
    0xb6ab8cb4e6e80b1f,
    0x3beb6e093fa1e3e2,
    0xf36c38de05c675b2,
    0x9c1c6995013ed389,
    0x8b391a1e5a5b6e27,
    0xec464d24fc9b6662,
    0xad7cfa8c4ea94ff0,
    0x0f347918482dba2c,
    0x9d5eee5f68394101,
    0x7623dc127eb73331,
    0x32a6efb2f49edf14,
    0x2d8c9a480dc3ccc4,
    0xb2568f76b7f45c20,
    0x0e76fed2212a28a4,
    0x48773613790d1564,
    0x129af783637e7819,
    0x080f0671a238ae7e,
    0x365bec70a582882b,
    0x42fccb03093b6aff,
    0x0a8bfd1070367f9b,
    0xff9e3d6df6e28cf3,
    0xe8bb4ee6ad87315d,
    0xc7b32fcf724a2c7c,
    0xb8dd7266c7c223bb,
    0x9328108d491369a5,
    0x0679f8a3831286da,
    0x270767587df5b35f,
    0xa981f94e1fb518cf,
    0x6b8d528955e4f104,
    0x1667f44132622f26,
    0x2ab7e521e7d6d896,
    0xac3e7d4627aedd78,
    0x7deaa6c86786de22,
    0x1725738b5b65bdae,
    0x4bb14ab8c2045609,
    0x592bbd3ba17a2e10,
    0xc20cabc74a51e9cb,
    0x6f70514b04f8a63b,
    0xbc2071a496de7484,
    0x19538d597a4f950a,
    0xf45747b7efd361e0,
    0x43be4cc9603cf877,
    0xc6f1a8051b4dbef4,
    0xb42f77d534e6dafa,
    0x40783062db35bb1a,
/* box 5 */
    0xf5a96c292deb0a4e,
    0x211c9df6ee653c51,
    0x04de5ddcbeeef596,
    0xe1e5b06f7457c19f,
    0x74ca30f014a54fb6,
    0xc296f9f7c5457d85,
    0x7d4ee08a484d10b0,
    0xae87f2d0bf9b13ad,
    0x8df4bb480e89afb7,
    0x2d8b7a67d9a2d61e,
    0x0f3559c8bd712adb,
    0x541bc7312f013338,
    0x9ec4848b636d5164,
    0x952f809f60f28e29,
    0x28984d8cb28d6357,
    0xd4b5f1dfc38e361f,
    0x5674135f7076b373,
    0xb791a330042172ec,
    0xab94c53bd4b4a6e4,
    0xf17731f59305ffd8,
    0x39c7a621801e1dcf,
    0x20d1f7c13ba47c8e,
    0x5e3da912f95facaa,
    0xb1202a82e5b80731,
    0x13303fc36de4fed3,
    0x2e29c43e5314168a,
    0x861fbf5c0d1670fa,
    0x6458b16af3f771f1,
    0x3043765bdcf642c9,
    0x12fd55f4b825be0c,
    0x0a266e23d65e9f92,
    0x6595db5d2636312e,
    0x85bd010587a0b06e,
    0x9bd7b3600842e42d,
    0xaa59af0c0175e63b,
    0x240faa1d854a8918,
    0xf464061ef82a4a91,
    0x5c527d7ca6282ce1,
    0x03a2be598ab6c094,
    0x40571b7776bdf8e9,
    0xe4f687841f7874d6,
    0x115febad32937e98,
    0x5108f0da442e8671,
    0x9cab50e53c1ad12f,
    0x33e1c8025640825d,
    0x87d2d56bd8d73025,
    0xc0f92d999a32fdce,
    0x62e938d8126e042c,
    0x4a717554a0e3677b,
    0x0beb0414039fdf4d,
    0xd6da25b19cf9b654,
    0x55d6ad06fac073e7,
    0x632452efc7af44f3,
    0xb5fe775e5b56f2a7,
    0x892ae694b0675a21,
    0x7a32030f7c1525b2,
    0x5d9f174b73e96c3e,
    0xc35b93c010843d5a,
    0x373f95dee8ae77cb,
    0xfb515fd6455b604a,
    0xa9fb11558bc326af,
    0x22be23af64d3fcc5,
    0xa8367b625e026670,
    0xb8a4faf8b9505837,
    0x785dd7612362a5f9,
    0x588c20a018c6d977,
    0xea0eb47b77c81ed2,
    0xa6ce489d36b20c74,
    0x0c97e79137c7ea4f,
    0x7c838abd9d8c506f,
    0x57b97968a5b7f3ac,
    0x6c110b277ade6e28,
    0xc785ce1cae6ac8cc,
    0x1581b6718c7d8b0e,
    0x614b868198d8c4b8,
    0x27ad14440ffc498c,
    0xdb80a8177eff1cc4,
    0x472bf8f242e5cdeb,
    0x8a8858cd3ad19ab5,
    0xf60bd270a75dcada,
    0x43f5a52efc0b387d,
    0x6ddc6110af1f2ef7,
    0xf0ba5bc246c4bf07,
    0x6fb3b57ef068aebc,
    0x18db3bd76e7b219e,
    0x903cb7740bdd3b60,
    0x7bff6938a9d4656d,
    0xbdb7cd13d27fed7e,
    0x051337eb6b2fb549,
    0x77688ea99e138f22,
    0xd9ef7c7921889c8f,
    0x077ce38534583502,
    0xf318e59bcc727f93,
    0xb34ffeecbacf877a,
    0xe9ac0a22fd7ede46,
    0xfc2dbc5371035548,
    0x026fd46e5f77804b,
    0xe53bedb3cab93409,
    0xcc6eca08adf51781,
    0xe028da58a1968140,
    0x3a6518780aa8dd5b,
    0xce011e66f28297ca,
    0xa4a19cf369c58c3f,
    0xc5ea1a72f11d4887,
    0xc427704524dc0858,
    0x4238cf1929ca78a2,
    0x481ea13aff94e730,
    0xdf5ef5cbc011e952,
    0x80ae36eeec8f0527,
    0x5ae3f4ce47b1593c,
    0xcda3a03f7834575e,
    0x71d9071b7f8afaff,
    0xcadf43ba4c6c625c,
    0x1623082806cb4b9a,
    0x17ee621fd30a0b45,
    0x448946abc8530d7f,
    0x974054f13f850e62,
    0x73b6d37520fd7ab4,
    0xc8b097d4131be217,
    0x9f09eebcb6ac11bb,
    0x45442c9c1d924da0,
    0x1b79858ee4cde10a,
    0x0984d07a5ce85f06,
    0x4cc0fce6417a12a6,
    0x99b8670e57356466,
    0xad254c89352dd339,
    0x322ca2358381c282,
    0xcfcc74512743d715,
    0x6b6de8a24e865b2a,
    0xda4dc220ab3e5c1b,
    0x88e78ca365a61afe,
    0x939e092d816bfbf4,
    0xcb12298d99ad2283,
    0xeed0e9a7c926eb44,
    0x98750d3982f424b9,
    0xd5789be8164f76c0,
    0xbe15734a58c92dea,
    0x49d3cb0d2a55a7ef,
    0x67fa0f337941b165,
    0x8c39d17fdb48ef68,
    0x25c2c02a508bc9c7,
    0x349d2b876218b75f,
    0x70146d2caa4bba20,
    0x1c05660bd095d408,
    0xfe42683d2e74d503,
    0x9a1ad957dd83a4f2,
    0xf2d58fac19b33f4c,
    0x81635cd9394e45f8,
    0xb65cc907d1e03233,
    0xdd3121a59f666919,
    0x318e1c6c09370216,
    0x8b4532faef10da6a,
    0x191651e0bbba6141,
    0x3f762f9361876812,
    0xb96990cf6c9118e8,
    0xb4331d698e97b278,
    0xd822164ef449dc50,
    0x84706b325261f0b1,
    0x4eaf28881e0d92ed,
    0x69023ccc11f1db61,
    0x66376504ac80f1ba,
    0x0849ba4d89291fd9,
    0xff8f020afbb595dc,
    0x50c59aed91efc6ae,
    0x1dc80c3c055494d7,
    0x1e6ab2658fe25443,
    0x3d19fbfd3ef0e859,
    0xfa9c35e1909a2095,
    0x52aa4e83ce9846e5,
    0x419a7140a37cb836,
    0xa07fc12fd72b79a9,
    0x68cf56fbc4309bbe,
    0x01cd6a37d5c140df,
    0x9253631a54aabb2b,
    0xd06bac037d60c389,
    0x295527bb674c2388,
    0xd204786d221743c2,
    0x0000000000000000,
    0xf7c6b847729c8a05,
    0xdcfc4b924aa729c6,
    0xe38a64012b2041d4,
    0xb28294db6f0ec7a5,
    0x9d663ad2e9db91f0,
    0x91f1dd43de1c7bbf,
    0x6086ecb64d198467,
    0x59414a97cd0799a8,
    0xace826bee0ec93e6,
    0xa56cf6c4bc04cce0,
    0x727bb942f53c3a6b,
    0x6e7edf4925a9ee63,
    0x26607e73da3d0953,
    0xe75439dd95ceb442,
    0x7990bd56f6a3e526,
    0xecbf3dc996516b0f,
    0x76a5e49e4bd2cffd,
    0x968d3ec6ea444ebd,
    0x5b2e9ef9927019e3,
    0x6aa082959b471bf5,
    0xbb0644a133e698a3,
    0x830c88b76639c5b3,
    0xe2470e36fee1010b,
    0xb0ed40b5307947ee,
    0x355041b0b7d9f780,
    0x8e560511843f6f23,
    0x7f2134e4173a90fb,
    0x2af799e2edfae31c,
    0x4bbc1f63752227a4,
    0xf8f3e18fcfeda0de,
    0x0d5a8da6e206aa90,
    0x2c4610500c6396c1,
    0xde939ffc15d0a98d,
    0xaf4a98e76a5a5372,
    0x8f9b6f2651fe2ffc,
    0x36f2ffe93d6f3714,
    0x0ef833ff68b06a04,
    0xe69953ea400ff49d,
    0x23734998b112bc1a,
    0x3ebb45a4b44628cd,
    0x1ab4efb9310ca1d5,
    0x2fe4ae0986d55655,
    0xebc3de4ca2095e0d,
    0x536724b41b59063a,
    0x46e692c597248d34,
    0x2b3af3d5383ba3c3,
    0x3ba8724fdf699d84,
    0xc13447ae4ff3bd11,
    0x4d0d96d194bb5279,
    0xfde0d664a4c21597,
    0xd7174f864938f68b,
    0x7eec5ed3c2fbd024,
    0xbfd8197d8d086d35,
    0x4f6242bfcbccd232,
    0xa70322aae3734cab,
    0xa3dd7f765d9db93d,
    0x94e2eaa8b533cef6,
    0x144cdc4659bccbd1,
    0xc648a42b7bab8813,
    0xf93e8bb81a2ce001,
    0xbacb2e96e627d87c,
    0xbc7aa72407beada1,
    0xc97dfde3c6daa2c8,
    0xa1b2ab1802ea3976,
    0x1fa7d8525a23149c,
    0x75075ac7c1640f69,
    0xe861601528bf9e99,
    0xa2101541885cf9e2,
    0xef1d83901ce7ab9b,
    0x06b189b2e19975dd,
    0x380acc1655df5d10,
    0x1092819ae7523e47,
    0xd3c9125af7d6031d,
    0xd1a6c634a8a18356,
    0x5ff0c3252c9eec75,
    0x82c1e280b3f8856c,
    0xed7257fe43902bd0,
    0x3cd491caeb31a886,
/* box 6 */
    0x94af9eb6fad9e7df,
    0x9208ae5e03c94ddd,
    0x1d8de8d67158480b,
    0xfd093cd2ba147af8,
    0xa45ceb22e6597ccf,
    0x9bbde6e77bf113da,
    0xe4edf4b465fffe5c,
    0x7125622e4e8d2a2f,
    0x1791b81b8f68430d,
    0xb56a63d1902195c0,
    0xa980832b30d2ee67,
    0x4c0a7fb384862397,
    0xed58bc0d1dc7a05b,
    0x5955d7f05c4d0637,
    0xd2b9b1c8806fcf4e,
    0x06a730e8f910aa02,
    0xb8b60bd846aa0768,
    0x45bf370afcbe7d90,
    0x16f6b0375ec370a1,
    0x892276608b81afd4,
    0xdcccc1b5d0ec08e7,
    0xe856949162df5f58,
    0x82592e81a41a977e,
    0xac8eabb74fca1164,
    0xfac9041692afe356,
    0x3b882d75331ba3ba,
    0xa39cd3e6cee2e561,
    0xd077a190d7cca9e3,
    0x9c7dde23534a8a74,
    0x80973ed9f3b9f1d3,
    0xce535132209cb4e9,
    0xaa299b5fb6dabb66,
    0x2d7e9d426dd8d31b,
    0x8a8b6e140d89fad5,
    0x6ca88af83fd56224,
    0xf5db7c4713871753,
    0xeef1a4799bcff55a,
    0x76e55aea6636b381,
    0x8ee24ea4a33a367a,
    0x25acddd7c44bbeb0,
    0x9adaeecbaa5a2076,
    0x0e75707d5083c7a9,
    0x2bd9adaa94c87919,
    0x19e4c866dfeb84a4,
    0x129f9087f070bc0e,
    0xd9c2e929aff4f7e4,
    0x6f01928cb9dd3725,
    0x39463d2d64b8c517,
    0xebff8ce5e4d70a59,
    0xb40d6bfd418aa66c,
    0xf21b44833b3c8efd,
    0x3654457ce5903112,
    0x431807e205aed792,
    0xb10343613e92596f,
    0x0a1c50cdfe300b06,
    0x778252c6b79d802d,
    0x0cbb60250720a104,
    0xe1e3dc281ae7015f,
    0x0f1278518128f405,
    0x47712752ab1d1b3d,
    0xe24ac45c9cef545e,
    0x1ceae0faa0f37ba7,
    0x9814fe93fdf946db,
    0xec3fb421cc6c93f7,
    0x833e26ad75b1a4d2,
    0x6b68b23c176efb8a,
    0x4904572ffb9edc94,
    0x4bca4777ac3dba39,
    0x2762cd8f93e8d81d,
    0x9eb3ce7b04e9ecd9,
    0xc2e8311727bc15ed,
    0xea9884c9357c39f5,
    0xfc6e34fe6bbf4954,
    0x13f898ab21db8fa2,
    0xb7a47389c782f36d,
    0x7b3932e3b0bd2129,
    0xaf27b3c3c9c24465,
    0xb6c37ba51629c0c1,
    0x84fe1e695d0a3d7c,
    0x1a4dd01259e3d1a5,
    0xab4e9373677188ca,
    0x90c6be06546a2b70,
    0xf37c4cafea97bd51,
    0x647aca6d96460f8f,
    0x4ec46febd325453a,
    0x3e8605e94c035cb9,
    0x0ddc6809d68b92a8,
    0x8bec6638dc22c979,
    0x67d3d219104e5a8e,
    0x2abea58645634ab5,
    0x5b9bc7a80bee609a,
    0x936fa672d2627e71,
    0x7d9e020b49ad8b2b,
    0x5832dfdc8de6359b,
    0xc7e6198b58a4eaee,
    0xd41e8120797f654c,
    0xf4bc746bc22c24ff,
    0xe084d404cb4c32f3,
    0x48635f032a35ef38,
    0x8757061ddb02687d,
    0x522e8f1173d63e9d,
    0xbcdf2b68e819cbc7,
    0xbf76331c6e119ec6,
    0x08d24095a9936dab,
    0x728c7a5ac8857f2e,
    0xd110a9bc06679a4f,
    0x1f43f88e26fb2ea6,
    0xb2aa5b15b89a0c6e,
    0x4aad4f5b7d968995,
    0x9fd4c657d542df75,
    0x323d65cc4b23fdbd,
    0xc38f393bf6172641,
    0xa152c3be994183cc,
    0x9d1ad60f82e1b9d8,
    0xe744ecc0e3f7ab5d,
    0x38213501b513f6bb,
    0xade9a39b9e6122c8,
    0x37334d50343b02be,
    0x55eeb7d55b6da733,
    0x970686c27cd1b2de,
    0x427f0fced405e43e,
    0xc026214f701f7340,
    0x40b11f9683a68293,
    0x02ce105857a366ad,
    0x7e371a7fcfa5de2a,
    0xffc72c8aedb71c55,
    0x68c1aa489166ae8b,
    0xc68111a7890fd942,
    0x79f722bbe71e4784,
    0xd579890ca8d456e0,
    0x70426a029f261983,
    0xb0644b4def396ac3,
    0xdb0cf971f8579149,
    0x5489bff98ac6949f,
    0x046920b0aeb3ccaf,
    0x7cf90a279806b887,
    0x050e289c7f18ff03,
    0x651dc24147ed3c23,
    0x5e95ef3474f69f99,
    0x6dcf82d4ee7e5188,
    0x8f854688729105d6,
    0x81f036f52212c27f,
    0xb9d103f4970134c4,
    0x5349873da27d0d31,
    0x20a2f54bbb5341b3,
    0xf0d554db6c9fe850,
    0x07c038c428bb99ae,
    0x30f375941c809b10,
    0x3fe10dc59da86f15,
    0x46162f7e7ab62891,
    0xe623e4ec325c98f1,
    0xfea024a63c1c2ff9,
    0x349a5524b23357bf,
    0x35fd5d0863986413,
    0x96618eeead7a8172,
    0xcb5d79ae5f844bea,
    0x21c5fd676af8721f,
    0x5720a78d0ccec19e,
    0xf6726433958f4252,
    0x8d4b56d02532637b,
    0x24cbd5fb15e08d1c,
    0x3aef2559e2b09016,
    0x5afccf84da455336,
    0x51879765f5de6b9c,
    0x2917bdf2c36b1fb4,
    0xa7f5f356605129ce,
    0xc1412963a1b440ec,
    0x3d2f1d9dca0b09b8,
    0xa53be30e37f24f63,
    0x5ff2e718a55dac35,
    0xa2fbdbca1f49d6cd,
    0xf7156c1f442471fe,
    0x7a5e3acf61161285,
    0xca3a71828e2f7846,
    0x1b2ad83e8848e209,
    0xa8e78b07e179ddcb,
    0xef96ac554a64c6f6,
    0x0000000000000000,
    0x6013eadd38f5c320,
    0x3c4815b11ba03a14,
    0x09b548b978385e07,
    0x226ce513ecf0271e,
    0x63baf2a9befd9621,
    0x44d83f262d154e3c,
    0xcdfa4946a694e1e8,
    0x113688f37678e90f,
    0x859916458ca10ed0,
    0xc52809d30f078c43,
    0x4d6d779f552d103b,
    0x1e24f0a2f7501d0a,
    0x0167082cd1ab33ac,
    0x1438a06f0960160c,
    0xf9601c6214a7b657,
    0xa035cb9248eab060,
    0x50e09f4924755830,
    0xd7b79954ff77304d,
    0xe58afc98b454cdf0,
    0x03a9187486085501,
    0x62ddfa856f56a58d,
    0xc44f01ffdeacbfef,
    0x73eb7276192e4c82,
    0xd6d091782edc03e1,
    0xfbae0c3a4304d0fa,
    0x9973f6bf2c527577,
    0x105180dfa7d3daa3,
    0x2605c5a34243ebb1,
    0x91a1b62a85c118dc,
    0xc99369f608272d47,
    0x5d3cf740f2feca98,
    0xcf34591ef1378745,
    0xc8f461dad98c1eeb,
    0x0b7b58e12f9b38aa,
    0xe32dcc704d4467f2,
    0x754c429ee03ee680,
    0xd3deb9e451c4fce2,
    0x6e669aa068760489,
    0x66b4da35c1e56922,
    0x4fa367c7028e7696,
    0xba781b80110961c5,
    0x41d617ba520db13f,
    0x335a6de09a88ce11,
    0xdf65d9c156e45de6,
    0xcc9d416a773fd244,
    0x5c5bff6c2355f934,
    0x2870b5de12c02c18,
    0x155fa843d8cb25a0,
    0x78902a9736b57428,
    0xae40bbef186977c9,
    0x88457e4c5a2a9c78,
    0x6a0fba10c6c5c826,
    0x7f5012531e0eed86,
    0x8c2c5efcf49950d7,
    0x31947db8cd2ba8bc,
    0x2c19956ebc73e0b7,
    0x230bed3f3d5b14b2,
    0x69a6a26440cd9d27,
    0x86300e310aa95bd1,
    0xb3cd533969313fc2,
    0x1883c04a0e40b708,
    0xf1b25cf7bd34dbfc,
    0x2fb08d1a3a7bb5b6,
    0xd8a5e1057e5fc448,
    0xddabc99901473b4b,
    0xde02d1ed874f6e4a,
    0xbdb8234439b2f86b,
    0x5647afa1dd65f232,
    0x2ed78536ebd0861a,
    0xe9319cbdb3746cf4,
    0xa692fb7ab1fa1a62,
    0x742b4ab23195d52c,
    0x95c8969a2b72d473,
    0x6174e2f1e95ef08c,
    0xf807144ec50c85fb,
    0xbe113b30bfbaad6a,
    0xda6bf15d29fca2e5,
    0xbb1f13acc0a25269,
/* box 7 */
    0xc22b27f0f9e37bf9,
    0x93fad23f0955ef09,
    0x32ed4b84a22a91a2,
    0x3898b57bcc61b1cc,
    0x55825ba9ad98e5ad,
    0xb2eeb8069421ec94,
    0xc7eb5875ce3c6bce,
    0x4b1dac5d1f45851f,
    0xc16ba1204705d847,
    0xc5380f461a2ba91a,
    0xb908971a909bad90,
    0x303e1cb7763d5376,
    0xe6ff324c53486853,
    0x6d1aeed261f95461,
    0x0193d1e36af1616a,
    0x51d1f5cff0b694f0,
    0x29b2c3f52728e127,
    0x112a768eeb4950eb,
    0x8fb672f86f9f4d6f,
    0xf0c66c745bc9ea5b,
    0x3f8b9dcd2fa9632f,
    0x65bc471edba5b6db,
    0x4d9d5508967c3696,
    0x3a4be24818767318,
    0x2794936c144db014,
    0x2af2452599ce4299,
    0x4a8e7dbe75b4e475,
    0x9ddc82a63a30be3a,
    0xade29e114c0ded4c,
    0xd1d2064dc6bde9c6,
    0x7da349bfe04165e0,
    0x6b9a1787e8c0e7e8,
    0xa54437ddf6510ff6,
    0x2254ece92392a023,
    0x79f0e7d9bd6f14bd,
    0x57510c9a798f2779,
    0x346db2d12b13222b,
    0x54118a4ac76984c7,
    0xefca4a6383e5eb83,
    0xca8d8e3c43bf9943,
    0xfc336bdebcbb79bc,
    0x3e184c2e45580245,
    0xf495c21206e79b06,
    0xff73ed0e025dda02,
    0x4228d472cfe806cf,
    0xbcc8e89fa744bda7,
    0xab626744c5345ec5,
    0xb6bd1660c90f9dc9,
    0xb72ec783a3fefca3,
    0x8be5dc9e32b13c32,
    0x485d2a8da1a326a1,
    0xc6788996a4cd0aa4,
    0x40fb83411bffc41b,
    0x08a6a9ccba5ce2ba,
    0xf386eaa4e52f49e5,
    0x1acc5992eff311ef,
    0xa2571f6b1599dd15,
    0x44a82d2746d1b546,
    0x70c59ff66dc2976d,
    0x8d6525cbbb888fbb,
    0x963aadba3e8aff3e,
    0x7c30985c8ab0048a,
    0x607c389bec7aa6ec,
    0xa822e1947bd2fd7b,
    0x034086d0bee6a3be,
    0x66fcc1ce65431565,
    0xb37d69e5fed08dfe,
    0x2f323aa0ae1152ae,
    0x56c2dd79137e4613,
    0x31adcd541ccc321c,
    0xdff456d4f5d8b8f5,
    0xf9f3145b8b64698b,
    0x764566a3e4fb24e4,
    0x0cf507aae77293e7,
    0x59775c034aea764a,
    0xb89b46f9fa6accfa,
    0xe8d962d5602d3960,
    0x17aa8fdb6270e362,
    0x1c4ca0c766caa266,
    0x2de16d937a06907a,
    0x2547c45fc05a72c0,
    0x0fb5817a59943059,
    0x0680f9558939b389,
    0x16395e3808818208,
    0xac714ff226fc8c26,
    0xa9b1307711239c11,
    0xec8accb33d03483d,
    0x6c893f310b08350b,
    0xc4abdea570dac870,
    0xba4811ca2e7d0e2e,
    0xf155bd9731388b31,
    0xdd2701e721cf7a21,
    0xe94ab3360adc580a,
    0x23c73d0a4963c149,
    0x5cb723867d35667d,
    0x5042242c9a47f59a,
    0x198cdf425115b251,
    0x0a75feff6e4b206e,
    0xfda0ba3dd64a18d6,
    0xcede205a1e91e81e,
    0xd041d7aeac4c88ac,
    0xe42c657f875faa87,
    0x36bee5e2ff04e0ff,
    0x6fc9b9e1b5ee96b5,
    0x998f2cc0671ecf67,
    0xd301517e12aa2b12,
    0xaea218c1f2eb4ef2,
    0xda342951c207a8c2,
    0x61efe978868bc786,
    0x7f701e8c3456a734,
    0x0be62f1c04ba4104,
    0x9129850cdd422ddd,
    0xd6c12efb25753b25,
    0xe33f4dc964977864,
    0x1579d8e8b66721b6,
    0xf860c5b8e19508e1,
    0x7496319030ece630,
    0x88a55a4e8c579f8c,
    0xcf4df1b974608974,
    0x10b9a76d81b83181,
    0x0e26509933655133,
    0x43bb0591a51967a5,
    0x926903dc63a48e63,
    0x9c4f534550c1df50,
    0x3bd833ab72871272,
    0xa4d7e63e9ca06e9c,
    0xb46e41531d185f1d,
    0x126af05e55aff355,
    0x24d415bcaaab13aa,
    0x1e9ff7f4b2dd60b2,
    0x05c07f8537df1037,
    0x467b7a1492c67792,
    0x2087bbdaf78562f7,
    0x819022615cfa1c5c,
    0xcd9ea68aa0774ba0,
    0xa79760ee2246cd22,
    0x8343755288edde88,
    0x58e48de0201b1720,
    0x7216c8c5b9d555b9,
    0x372d340195f58195,
    0xa11799bbab7f7eab,
    0x9f0fd595ee277cee,
    0x676f102d0fb2740f,
    0x9e9c047684d61d84,
    0x49cefb6ecb5247cb,
    0xd41279c8f162f9f1,
    0x1f0c2617d82c01d8,
    0x97a97c59547b9e54,
    0xe76ce3af39b90939,
    0xc3b8f61393121a93,
    0x5ba40b309efdb49e,
    0xea0a35e6b43afbb4,
    0x5a37dad3f40cd5f4,
    0x14ea090bdc9640dc,
    0x5e6474b5a922a4a9,
    0xfee03ced68acbb68,
    0x071328b6e3c8d2e3,
    0x5302a2fc24a15624,
    0x85c38c0701d46d01,
    0x3d58cafefbbea1fb,
    0x84505de46b250c6b,
    0x642f96fdb154d7b1,
    0xbf886e4f19a21e19,
    0x02d35733d417c2d4,
    0x68da915756264456,
    0x8710db34d5c3afd5,
    0x0d66d6498d83f28d,
    0x7b23b0ea6978d669,
    0x1b5f887185027085,
    0x3ccb1b1d914fc091,
    0x0453ae665d2e715d,
    0xcb1e5fdf294ef829,
    0xf6469521d2f059d2,
    0xb03def3540362e40,
    0x633cbe4b529c0552,
    0xf7d544c2b80138b8,
    0x7ab061090389b703,
    0x0000000000000000,
    0xdba7f8b2a8f6c9a8,
    0x35fe633241e24341,
    0x21146a399d74039d,
    0xd581a82b9b93989b,
    0x0935782fd0ad83d0,
    0x5ff7a556c3d3c5c3,
    0xaf31c922981a2f98,
    0x90ba54efb7b34cb7,
    0x5291731f4e50374e,
    0xc0f870c32df4b92d,
    0x7ee3cf6f5ea7c65e,
    0xe07fcb19da71dbda,
    0x4eddd3d8289a9528,
    0x13f921bd3f5e923f,
    0xf50613f16c16fa6c,
    0x981cfd230defae0d,
    0x4c0e84ebfc8d57fc,
    0x82d0a4b1e21cbfe2,
    0x89368bade6a6fee6,
    0xd292809d785b4a78,
    0x47e8abf7f83716f8,
    0x8e25a31b056e2c05,
    0xd752ff184f845a4f,
    0xcc0d7769ca862aca,
    0x694940b43cd7253c,
    0x2ea1eb43c4e033c4,
    0xde6787379f29d99f,
    0x181f0ea13be4d33b,
    0x416852a2710ea571,
    0x62af6fa8386d6438,
    0xa0844858c18e1fc1,
    0x337e9a67c8dbf0c8,
    0x2c72bc7010f7f110,
    0xbd5b397ccdb5dccd,
    0xd8e77e6216106a16,
    0x86830ad7bf32cebf,
    0x4f4e023b426bf442,
    0xe5bfb49cedaecbed,
    0x8a760d7d58405d58,
    0xe2ac9c2a0e66190e,
    0xb5fd90b077e93e77,
    0xdcb4d0044b3e1b4b,
    0x453bfcc42c20d42c,
    0xed191d5057f22957,
    0xe1ec1afab080bab0,
    0xee599b80e9148ae9,
    0x2607428f7ebcd17e,
    0x5d24f26517c40717,
    0x6a09c66482318682,
    0xa604b10d48b7ac48,
    0xbe1bbfac73537f73,
    0x282112164dd9804d,
    0x7505e0735a1d875a,
    0x73851926d32434d3,
    0xd974af817ce10b7c,
    0xeb99e405decb9ade,
    0x9b5c7bf3b3090db3,
    0xfab3928b3582ca35,
    0x8003f382360b7d36,
    0x94e9fa89ea9d3dea,
    0xb1ae3ed62ac74f2a,
    0x9acfaa10d9f86cd9,
    0x390b6498a690d0a6,
    0xf2153b478fde288f,
    0x71564e150733f607,
    0xa3c4ce887f68bc7f,
    0xaaf1b6a7afc53faf,
    0x1ddf71240c3bc30c,
    0x77d6b7408e0a458e,
    0x2b6194c6f33f23f3,
    0xc9cd08ecfd593afd,
    0xc85ed90f97a85b97,
    0x8cf6f428d179eed1,
    0x957a2b6a806c5c80,
    0xbbdbc029448c6f44,
    0x7863363ad79e75d7,
    0x6e5a6802df1ff7df,
    0xfb2043685f73ab5f,

###############################################################################

TITLE
    Sharkbox crypto algorithm iG

TYPE
    8

DATA
		0xe7, 0x30, 0x90, 0x85, 0xd0, 0x4b, 0x91, 0x41, 
		0x53, 0x95, 0x9b, 0xa5, 0x96, 0xbc, 0xa1, 0x68, 
		0x02, 0x45, 0xf7, 0x65, 0x5c, 0x1f, 0xb6, 0x52, 
		0xa2, 0xca, 0x22, 0x94, 0x44, 0x63, 0x2a, 0xa2, 
		0xfc, 0x67, 0x8e, 0x10, 0x29, 0x75, 0x85, 0x71, 
		0x24, 0x45, 0xa2, 0xcf, 0x2f, 0x22, 0xc1, 0x0e, 
		0xa1, 0xf1, 0x71, 0x40, 0x91, 0x27, 0x18, 0xa5, 
		0x56, 0xf4, 0xaf, 0x32, 0xd2, 0xa4, 0xdc, 0x71, 

###############################################################################

TITLE
    Safer log_tab

TYPE
    8

DATA
	{128, 0, 176, 9, 96, 239, 185, 253, 16, 18, 159, 228, 105, 186, 173, 248,
	192, 56, 194, 101, 79, 6, 148, 252, 25, 222, 106, 27, 93, 78, 168, 130,
	112, 237, 232, 236, 114, 179, 21, 195, 255, 171, 182, 71, 68, 1, 172, 37,
	201, 250, 142, 65, 26, 33, 203, 211, 13, 110, 254, 38, 88, 218, 50, 15,
	32, 169, 157, 132, 152, 5, 156, 187, 34, 140, 99, 231, 197, 225, 115, 198,
	175, 36, 91, 135, 102, 39, 247, 87, 244, 150, 177, 183, 92, 139, 213, 84,
	121, 223, 170, 246, 62, 163, 241, 17, 202, 245, 209, 23, 123, 147, 131, 188,
	189, 82, 30, 235, 174, 204, 214, 53, 8, 200, 138, 180, 226, 205, 191, 217,
	208, 80, 89, 63, 77, 98, 52, 10, 72, 136, 181, 86, 76, 46, 107, 158,
	210, 61, 60, 3, 19, 251, 151, 81, 117, 74, 145, 113, 35, 190, 118, 42,
	95, 249, 212, 85, 11, 220, 55, 49, 22, 116, 215, 119, 167, 230, 7, 219,
	164, 47, 70, 243, 97, 69, 103, 227, 12, 162, 59, 28, 133, 24, 4, 29,
	41, 160, 143, 178, 90, 216, 166, 126, 238, 141, 83, 75, 161, 154, 193, 14,
	122, 73, 165, 44, 129, 196, 199, 54, 43, 127, 67, 149, 51, 242, 108, 104,
	109, 240, 2, 40, 206, 221, 155, 234, 94, 153, 124, 20, 134, 207, 229, 66,
	184, 64, 120, 45, 58, 233, 100, 31, 146, 144, 125, 57, 111, 224, 137, 48};

###############################################################################

TITLE
    RIPEMD k values

TYPE
    32 AND

DATA
    0x5a827999UL 0x6ed9eba1UL 0x8f1bbcdcUL 0xa953fd4eUL
    0x50a28be6UL 0x5c4dd124UL 0x6d703ef3UL 0x7a6d76e9UL

###############################################################################

TITLE
    RIPEMD-320 values

TYPE
    32 AND

DATA
    0x67452301L 0xefcdab89L 0x98badcfeL 0x10325476L
    0xc3d2e1f0L 0x76543210L 0xfedcba98L 0x89abcdefL
    0x01234567L 0x3c2d1e0fL

###############################################################################

TITLE
    RIPEMD-128 InitState

TYPE
    32 AND

DATA
    0x10325476L 0x67452301L 0xefcdab89L 0x98badcfeL

###############################################################################

TITLE
    RIPEMD-256 InitState

TYPE
    32 AND

DATA
    0x67452301L 0xefcdab89L 0x98badcfeL 0x10325476L
    0x76543210L 0xfedcba98L 0x89abcdefL 0x01234567L

###############################################################################

TITLE
    RC5 and RC6 magic values (0xb7e15163L 0x9e3779b9L)

TYPE
    32 AND

DATA
    0xb7e15163L 0x9e3779b9L

###############################################################################

TITLE
    RC5 and RC6 magic values (0xb7e15163L 0x61C88647)

TYPE
    32 AND

DATA
    0xb7e15163L 0x61C88647

###############################################################################

TITLE
    MD5MAC

TYPE
    32

DATA
	{ 0xac45ef97,0xcd430f29,0x551b7e45,0x3411801c,
	  0x96ce77b1,0x7c8e722e,0x0aab5a5f,0x18be4336,
	  0x21b4219d,0x4db987bc,0xbd279da2,0xc3d75bc7 };

###############################################################################

TITLE
    MARS Sbox

TYPE
    32

DATA
  0x09d0c479, 0x28c8ffe0, 0x84aa6c39, 0x9dad7287, 
  0x7dff9be3, 0xd4268361, 0xc96da1d4, 0x7974cc93, 
  0x85d0582e, 0x2a4b5705, 0x1ca16a62, 0xc3bd279d, 
  0x0f1f25e5, 0x5160372f, 0xc695c1fb, 0x4d7ff1e4, 
  0xae5f6bf4, 0x0d72ee46, 0xff23de8a, 0xb1cf8e83, 
  0xf14902e2, 0x3e981e42, 0x8bf53eb6, 0x7f4bf8ac, 
  0x83631f83, 0x25970205, 0x76afe784, 0x3a7931d4, 
  0x4f846450, 0x5c64c3f6, 0x210a5f18, 0xc6986a26, 
  0x28f4e826, 0x3a60a81c, 0xd340a664, 0x7ea820c4, 
  0x526687c5, 0x7eddd12b, 0x32a11d1d, 0x9c9ef086, 
  0x80f6e831, 0xab6f04ad, 0x56fb9b53, 0x8b2e095c, 
  0xb68556ae, 0xd2250b0d, 0x294a7721, 0xe21fb253, 
  0xae136749, 0xe82aae86, 0x93365104, 0x99404a66, 
  0x78a784dc, 0xb69ba84b, 0x04046793, 0x23db5c1e, 
  0x46cae1d6, 0x2fe28134, 0x5a223942, 0x1863cd5b, 
  0xc190c6e3, 0x07dfb846, 0x6eb88816, 0x2d0dcc4a, 
  0xa4ccae59, 0x3798670d, 0xcbfa9493, 0x4f481d45, 
  0xeafc8ca8, 0xdb1129d6, 0xb0449e20, 0x0f5407fb, 
  0x6167d9a8, 0xd1f45763, 0x4daa96c3, 0x3bec5958, 
  0xababa014, 0xb6ccd201, 0x38d6279f, 0x02682215, 
  0x8f376cd5, 0x092c237e, 0xbfc56593, 0x32889d2c, 
  0x854b3e95, 0x05bb9b43, 0x7dcd5dcd, 0xa02e926c, 
  0xfae527e5, 0x36a1c330, 0x3412e1ae, 0xf257f462, 
  0x3c4f1d71, 0x30a2e809, 0x68e5f551, 0x9c61ba44, 
  0x5ded0ab8, 0x75ce09c8, 0x9654f93e, 0x698c0cca, 
  0x243cb3e4, 0x2b062b97, 0x0f3b8d9e, 0x00e050df, 
  0xfc5d6166, 0xe35f9288, 0xc079550d, 0x0591aee8, 
  0x8e531e74, 0x75fe3578, 0x2f6d829a, 0xf60b21ae, 
  0x95e8eb8d, 0x6699486b, 0x901d7d9b, 0xfd6d6e31, 
  0x1090acef, 0xe0670dd8, 0xdab2e692, 0xcd6d4365, 
  0xe5393514, 0x3af345f0, 0x6241fc4d, 0x460da3a3, 
  0x7bcf3729, 0x8bf1d1e0, 0x14aac070, 0x1587ed55, 
  0x3afd7d3e, 0xd2f29e01, 0x29a9d1f6, 0xefb10c53, 
  0xcf3b870f, 0xb414935c, 0x664465ed, 0x024acac7, 
  0x59a744c1, 0x1d2936a7, 0xdc580aa6, 0xcf574ca8, 
  0x040a7a10, 0x6cd81807, 0x8a98be4c, 0xaccea063, 
  0xc33e92b5, 0xd1e0e03d, 0xb322517e, 0x2092bd13, 
  0x386b2c4a, 0x52e8dd58, 0x58656dfb, 0x50820371, 
  0x41811896, 0xe337ef7e, 0xd39fb119, 0xc97f0df6, 
  0x68fea01b, 0xa150a6e5, 0x55258962, 0xeb6ff41b, 
  0xd7c9cd7a, 0xa619cd9e, 0xbcf09576, 0x2672c073, 
  0xf003fb3c, 0x4ab7a50b, 0x1484126a, 0x487ba9b1, 
  0xa64fc9c6, 0xf6957d49, 0x38b06a75, 0xdd805fcd, 
  0x63d094cf, 0xf51c999e, 0x1aa4d343, 0xb8495294, 
  0xce9f8e99, 0xbffcd770, 0xc7c275cc, 0x378453a7, 
  0x7b21be33, 0x397f41bd, 0x4e94d131, 0x92cc1f98, 
  0x5915ea51, 0x99f861b7, 0xc9980a88, 0x1d74fd5f, 
  0xb0a495f8, 0x614deed0, 0xb5778eea, 0x5941792d, 
  0xfa90c1f8, 0x33f824b4, 0xc4965372, 0x3ff6d550, 
  0x4ca5fec0, 0x8630e964, 0x5b3fbbd6, 0x7da26a48, 
  0xb203231a, 0x04297514, 0x2d639306, 0x2eb13149, 
  0x16a45272, 0x532459a0, 0x8e5f4872, 0xf966c7d9, 
  0x07128dc0, 0x0d44db62, 0xafc8d52d, 0x06316131, 
  0xd838e7ce, 0x1bc41d00, 0x3a2e8c0f, 0xea83837e, 
  0xb984737d, 0x13ba4891, 0xc4f8b949, 0xa6d6acb3, 
  0xa215cdce, 0x8359838b, 0x6bd1aa31, 0xf579dd52, 
  0x21b93f93, 0xf5176781, 0x187dfdde, 0xe94aeb76, 
  0x2b38fd54, 0x431de1da, 0xab394825, 0x9ad3048f, 
  0xdfea32aa, 0x659473e3, 0x623f7863, 0xf3346c59, 
  0xab3ab685, 0x3346a90b, 0x6b56443e, 0xc6de01f8, 
  0x8d421fc0, 0x9b0ed10c, 0x88f1a1e9, 0x54c1f029, 
  0x7dead57b, 0x8d7ba426, 0x4cf5178a, 0x551a7cca, 
  0x1a9a5f08, 0xfcd651b9, 0x25605182, 0xe11fc6c3, 
  0xb6fd9676, 0x337b3027, 0xb7c8eb14, 0x9e5fd030, 
  0x6b57e354, 0xad913cf7, 0x7e16688d, 0x58872a69, 
  0x2c2fc7df, 0xe389ccc6, 0x30738df1, 0x0824a734, 
  0xe1797a8b, 0xa4a8d57b, 0x5b5d193b, 0xc8a8309b, 
  0x73f9a978, 0x73398d32, 0x0f59573e, 0xe9df2b03, 
  0xe8a5b6c8, 0x848d0704, 0x98df93c2, 0x720a1dc3, 
  0x684f259a, 0x943ba848, 0xa6370152, 0x863b5ea3, 
  0xd17b978b, 0x6d9b58ef, 0x0a700dd4, 0xa73d36bf, 
  0x8e6a0829, 0x8695bc14, 0xe35b3447, 0x933ac568, 
  0x8894b022, 0x2f511c27, 0xddfbcc3c, 0x006662b6, 
  0x117c83fe, 0x4e12b414, 0xc2bca766, 0x3a2fec10, 
  0xf4562420, 0x55792e2a, 0x46f5d857, 0xceda25ce, 
  0xc3601d3b, 0x6c00ab46, 0xefac9c28, 0xb3c35047, 
  0x611dfee3, 0x257c3207, 0xfdd58482, 0x3b14d84f, 
  0x23becb64, 0xa075f3a3, 0x088f8ead, 0x07adf158, 
  0x7796943c, 0xfacabf3d, 0xc09730cd, 0xf7679969, 
  0xda44e9ed, 0x2c854c12, 0x35935fa3, 0x2f057d9f, 
  0x690624f8, 0x1cb0bafd, 0x7b0dbdc6, 0x810f23bb, 
  0xfa929a1a, 0x6d969a17, 0x6742979b, 0x74ac7d05, 
  0x010e65c4, 0x86a3d963, 0xf907b5a0, 0xd0042bd3, 
  0x158d7d03, 0x287a8255, 0xbba8366f, 0x096edc33, 
  0x21916a7b, 0x77b56b86, 0x951622f9, 0xa6c5e650, 
  0x8cea17d1, 0xcd8c62bc, 0xa3d63433, 0x358a68fd, 
  0x0f9b9d3c, 0xd6aa295b, 0xfe33384a, 0xc000738e, 
  0xcd67eb2f, 0xe2eb6dc2, 0x97338b02, 0x06c9f246, 
  0x419cf1ad, 0x2b83c045, 0x3723f18a, 0xcb5b3089, 
  0x160bead7, 0x5d494656, 0x35f8a74b, 0x1e4e6c9e, 
  0x000399bd, 0x67466880, 0xb4174831, 0xacf423b2, 
  0xca815ab3, 0x5a6395e7, 0x302a67c5, 0x8bdb446b, 
  0x108f8fa4, 0x10223eda, 0x92b8b48b, 0x7f38d0ee, 
  0xab2701d4, 0x0262d415, 0xaf224a30, 0xb3d88aba, 
  0xf8b2c3af, 0xdaf7ef70, 0xcc97d3b7, 0xe9614b6c, 
  0x2baebff4, 0x70f687cf, 0x386c9156, 0xce092ee5, 
  0x01e87da6, 0x6ce91e6a, 0xbb7bcc84, 0xc7922c20, 
  0x9d3b71fd, 0x060e41c6, 0xd7590f15, 0x4e03bb47, 
  0x183c198e, 0x63eeb240, 0x2ddbf49a, 0x6d5cba54, 
  0x923750af, 0xf9e14236, 0x7838162b, 0x59726c72, 
  0x81b66760, 0xbb2926c1, 0x48a0ce0d, 0xa6c0496d, 
  0xad43507b, 0x718d496a, 0x9df057af, 0x44b1bde6, 
  0x054356dc, 0xde7ced35, 0xd51a138b, 0x62088cc9, 
  0x35830311, 0xc96efca2, 0x686f86ec, 0x8e77cb68, 
  0x63e1d6b8, 0xc80f9778, 0x79c491fd, 0x1b4c67f2, 
  0x72698d7d, 0x5e368c31, 0xf7d95e2e, 0xa1d3493f, 
  0xdcd9433e, 0x896f1552, 0x4bc4ca7a, 0xa6d1baf4, 
  0xa5a96dcc, 0x0bef8b46, 0xa169fda7, 0x74df40b7, 
  0x4e208804, 0x9a756607, 0x038e87c8, 0x20211e44, 
  0x8b7ad4bf, 0xc6403f35, 0x1848e36d, 0x80bdb038, 
  0x1e62891c, 0x643d2107, 0xbf04d6f8, 0x21092c8c, 
  0xf644f389, 0x0778404e, 0x7b78adb8, 0xa2c52d53, 
  0x42157abe, 0xa2253e2e, 0x7bf3f4ae, 0x80f594f9, 
  0x953194e7, 0x77eb92ed, 0xb3816930, 0xda8d9336, 
  0xbf447469, 0xf26d9483, 0xee6faed5, 0x71371235, 
  0xde425f73, 0xb4e59f43, 0x7dbe2d4e, 0x2d37b185, 
  0x49dc9a63, 0x98c39d98, 0x1301c9a2, 0x389b1bbf, 
  0x0c18588d, 0xa421c1ba, 0x7aa3865c, 0x71e08558, 
  0x3c5cfcaa, 0x7d239ca4, 0x0297d9dd, 0xd7dc2830, 
  0x4b37802b, 0x7428ab54, 0xaeee0347, 0x4b3fbb85, 
  0x692f2f08, 0x134e578e, 0x36d9e0bf, 0xae8b5fcf, 
  0xedb93ecf, 0x2b27248e, 0x170eb1ef, 0x7dc57fd6, 
  0x1e760f16, 0xb1136601, 0x864e1b9b, 0xd7ea7319, 
  0x3ab871bd, 0xcfa4d76f, 0xe31bd782, 0x0dbeb469, 
  0xabb96061, 0x5370f85d, 0xffb07e37, 0xda30d0fb, 
  0xebc977b6, 0x0b98b40f, 0x3a4d0fe6, 0xdf4fc26b, 
  0x159cf22a, 0xc298d6e2, 0x2b78ef6a, 0x61a94ac0, 
  0xab561187, 0x14eea0f0, 0xdf0d4164, 0x19af70ee 

###############################################################################

TITLE
    Haval init

TYPE
    32 AND

DATA
    0x243F6A88 0x85A308D3 0x13198A2E 0x03707344
	0xA4093822 0x299F31D0 0x082EFA98 0xEC4E6C89

###############################################################################

TITLE
    Haval mc3

TYPE
    32

DATA
0x9C30D539,0x2AF26013,0xC5D1B023,0x286085F0,0xCA417918,0xB8DB38EF,0x8E79DCB0,0x603A180E,
0x6C9E0E8B,0xB01E8A3E,0xD71577C1,0xBD314B27,0x78AF2FDA,0x55605C60,0xE65525F3,0xAA55AB94,
0x57489862,0x63E81440,0x55CA396A,0x2AAB10B6,0xB4CC5C34,0x1141E8CE,0xA15486AF,0x7C72E993,
0xB3EE1411,0x636FBC2A,0x2BA9C55D,0x741831F6,0xCE5C3E16,0x9B87931E,0xAFD6BA33,0x6C24CF5C};

###############################################################################

TITLE
    Haval mc4

TYPE
    32

DATA
0x7A325381,0x28958677,0x3B8F4898,0x6B4BB9AF,0xC4BFE81B,0x66282193,0x61D809CC,0xFB21A991,
0x487CAC60,0x5DEC8032,0xEF845D5D,0xE98575B1,0xDC262302,0xEB651B88,0x23893E81,0xD396ACC5,
0x0F6D6FF3,0x83F44239,0x2E0B4482,0xA4842004,0x69C8F04A,0x9E1F9B5E,0x21C66842,0xF6E96C9A,
0x670C9C61,0xABD388F0,0x6A51A0D2,0xD8542F68,0x960FA728,0xAB5133A3,0x6EEF0B6C,0x137A3BE4};

###############################################################################

TITLE
    Haval mc5

TYPE
    32

DATA
0xBA3BF050,0x7EFB2A98,0xA1F1651D,0x39AF0176,0x66CA593E,0x82430E88,0x8CEE8619,0x456F9FB4,
0x7D84A5C3,0x3B8B5EBE,0xE06F75D8,0x85C12073,0x401A449F,0x56C16AA6,0x4ED3AA62,0x363F7706,
0x1BFEDF72,0x429B023D,0x37D0D724,0xD00A1248,0xDB0FEAD3,0x49F1C09B,0x075372C9,0x80991B7B,
0x25D479D8,0xF6E8DEF7,0xE3FE501A,0xB6794C3B,0x976CE0BD,0x04C006BA,0xC1A94FB6,0x409F60C4};

###############################################################################

TITLE
    Gost sBox

TYPE
    8

DATA
	{4, 10, 9, 2, 13, 8, 0, 14, 6, 11, 1, 12, 7, 15, 5, 3},
	{14, 11, 4, 12, 6, 13, 15, 10, 2, 3, 8, 1, 0, 7, 5, 9},
	{5, 8, 1, 13, 10, 3, 4, 2, 14, 15, 12, 7, 6, 0, 9, 11},
	{7, 13, 10, 1, 0, 8, 9, 15, 14, 4, 6, 12, 11, 2, 5, 3},
	{6, 12, 7, 1, 5, 15, 13, 8, 4, 10, 9, 14, 0, 3, 11, 2},
	{4, 11, 10, 0, 7, 2, 1, 13, 3, 6, 8, 5, 9, 12, 15, 14},
	{13, 11, 4, 1, 3, 15, 5, 9, 0, 10, 14, 7, 6, 8, 2, 12},
	{1, 15, 13, 0, 5, 7, 10, 4, 9, 2, 3, 14, 6, 11, 8, 12}};

###############################################################################

TITLE
    Gost original sBox

TYPE
    8

DATA
	{13,  2,  8,  4,  6, 15, 11,  1, 10,  9,  3, 14,  5,  0, 12,  7 },
	{ 4, 11,  2, 14, 15,  0,  8, 13,  3, 12,  9,  7,  5, 10,  6,  1 },
	{12,  1, 10, 15,  9,  2,  6,  8,  0, 13,  3,  4, 14,  7,  5, 11 },
	{ 2, 12,  4,  1,  7, 10, 11,  6,  8,  5,  3, 15, 13,  0, 14,  9 },
	{ 7, 13, 14,  3,  0,  6,  9, 10,  1,  2,  8,  5, 11, 12,  4, 15 },
	{10,  0,  9, 14,  6,  3, 15,  5,  1, 13, 12,  7, 11,  4,  2,  8 },
	{15,  1,  8, 14,  6, 11,  3,  4,  9,  7,  2, 13, 12,  0,  5, 10 },
	{14,  4, 13,  1,  2, 15, 11,  8,  3, 10,  6, 12,  5,  9,  0,  7 }}; 


###############################################################################

TITLE
    Generic squared map

TYPE
    8, 16, 32

DATA
    {0, 1, 4, 5, 16, 17, 20, 21, 64, 65, 68, 69, 80, 81, 84, 85};

###############################################################################

TITLE
    RawDES sbox1

TYPE
    32

DATA
0x01010400,0x00000000,0x00010000,0x01010404, 0x01010004,0x00010404,0x00000004,0x00010000,
0x00000400,0x01010400,0x01010404,0x00000400, 0x01000404,0x01010004,0x01000000,0x00000004,
0x00000404,0x01000400,0x01000400,0x00010400, 0x00010400,0x01010000,0x01010000,0x01000404,
0x00010004,0x01000004,0x01000004,0x00010004, 0x00000000,0x00000404,0x00010404,0x01000000,
0x00010000,0x01010404,0x00000004,0x01010000, 0x01010400,0x01000000,0x01000000,0x00000400,
0x01010004,0x00010000,0x00010400,0x01000004, 0x00000400,0x00000004,0x01000404,0x00010404,
0x01010404,0x00010004,0x01010000,0x01000404, 0x01000004,0x00000404,0x00010404,0x01010400,
0x00000404,0x01000400,0x01000400,0x00000000, 0x00010004,0x00010400,0x00000000,0x01010004},

###############################################################################

TITLE
    RawDES sbox2

TYPE
    32

DATA
0x80108020,0x80008000,0x00008000,0x00108020, 0x00100000,0x00000020,0x80100020,0x80008020,
0x80000020,0x80108020,0x80108000,0x80000000, 0x80008000,0x00100000,0x00000020,0x80100020,
0x00108000,0x00100020,0x80008020,0x00000000, 0x80000000,0x00008000,0x00108020,0x80100000,
0x00100020,0x80000020,0x00000000,0x00108000, 0x00008020,0x80108000,0x80100000,0x00008020,
0x00000000,0x00108020,0x80100020,0x00100000, 0x80008020,0x80100000,0x80108000,0x00008000,
0x80100000,0x80008000,0x00000020,0x80108020, 0x00108020,0x00000020,0x00008000,0x80000000,
0x00008020,0x80108000,0x00100000,0x80000020, 0x00100020,0x80008020,0x80000020,0x00100020,
0x00108000,0x00000000,0x80008000,0x00008020, 0x80000000,0x80100020,0x80108020,0x00108000},

###############################################################################

TITLE
    RawDES sbox3

TYPE
    32

DATA
0x00000208,0x08020200,0x00000000,0x08020008, 0x08000200,0x00000000,0x00020208,0x08000200,
0x00020008,0x08000008,0x08000008,0x00020000, 0x08020208,0x00020008,0x08020000,0x00000208,
0x08000000,0x00000008,0x08020200,0x00000200, 0x00020200,0x08020000,0x08020008,0x00020208,
0x08000208,0x00020200,0x00020000,0x08000208, 0x00000008,0x08020208,0x00000200,0x08000000,
0x08020200,0x08000000,0x00020008,0x00000208, 0x00020000,0x08020200,0x08000200,0x00000000,
0x00000200,0x00020008,0x08020208,0x08000200, 0x08000008,0x00000200,0x00000000,0x08020008,
0x08000208,0x00020000,0x08000000,0x08020208, 0x00000008,0x00020208,0x00020200,0x08000008,
0x08020000,0x08000208,0x00000208,0x08020000, 0x00020208,0x00000008,0x08020008,0x00020200},

###############################################################################

TITLE
    RawDES sbox4

TYPE
    32

DATA
0x00802001,0x00002081,0x00002081,0x00000080, 0x00802080,0x00800081,0x00800001,0x00002001,
0x00000000,0x00802000,0x00802000,0x00802081, 0x00000081,0x00000000,0x00800080,0x00800001,
0x00000001,0x00002000,0x00800000,0x00802001, 0x00000080,0x00800000,0x00002001,0x00002080,
0x00800081,0x00000001,0x00002080,0x00800080, 0x00002000,0x00802080,0x00802081,0x00000081,
0x00800080,0x00800001,0x00802000,0x00802081, 0x00000081,0x00000000,0x00000000,0x00802000,
0x00002080,0x00800080,0x00800081,0x00000001, 0x00802001,0x00002081,0x00002081,0x00000080,
0x00802081,0x00000081,0x00000001,0x00002000, 0x00800001,0x00002001,0x00802080,0x00800081,
0x00002001,0x00002080,0x00800000,0x00802001, 0x00000080,0x00800000,0x00002000,0x00802080},

###############################################################################

TITLE
    RawDES sbox5

TYPE
    32

DATA
0x00000100,0x02080100,0x02080000,0x42000100, 0x00080000,0x00000100,0x40000000,0x02080000,
0x40080100,0x00080000,0x02000100,0x40080100, 0x42000100,0x42080000,0x00080100,0x40000000,
0x02000000,0x40080000,0x40080000,0x00000000, 0x40000100,0x42080100,0x42080100,0x02000100,
0x42080000,0x40000100,0x00000000,0x42000000, 0x02080100,0x02000000,0x42000000,0x00080100,
0x00080000,0x42000100,0x00000100,0x02000000, 0x40000000,0x02080000,0x42000100,0x40080100,
0x02000100,0x40000000,0x42080000,0x02080100, 0x40080100,0x00000100,0x02000000,0x42080000,
0x42080100,0x00080100,0x42000000,0x42080100, 0x02080000,0x00000000,0x40080000,0x42000000,
0x00080100,0x02000100,0x40000100,0x00080000, 0x00000000,0x40080000,0x02080100,0x40000100},

###############################################################################

TITLE
    RawDES sbox6

TYPE
    32

DATA
0x20000010,0x20400000,0x00004000,0x20404010, 0x20400000,0x00000010,0x20404010,0x00400000,
0x20004000,0x00404010,0x00400000,0x20000010, 0x00400010,0x20004000,0x20000000,0x00004010,
0x00000000,0x00400010,0x20004010,0x00004000, 0x00404000,0x20004010,0x00000010,0x20400010,
0x20400010,0x00000000,0x00404010,0x20404000, 0x00004010,0x00404000,0x20404000,0x20000000,
0x20004000,0x00000010,0x20400010,0x00404000, 0x20404010,0x00400000,0x00004010,0x20000010,
0x00400000,0x20004000,0x20000000,0x00004010, 0x20000010,0x20404010,0x00404000,0x20400000,
0x00404010,0x20404000,0x00000000,0x20400010, 0x00000010,0x00004000,0x20400000,0x00404010,
0x00004000,0x00400010,0x20004010,0x00000000, 0x20404000,0x20000000,0x00400010,0x20004010},

###############################################################################

TITLE
    RawDES sbox7

TYPE
    32

DATA
0x00200000,0x04200002,0x04000802,0x00000000, 0x00000800,0x04000802,0x00200802,0x04200800,
0x04200802,0x00200000,0x00000000,0x04000002, 0x00000002,0x04000000,0x04200002,0x00000802,
0x04000800,0x00200802,0x00200002,0x04000800, 0x04000002,0x04200000,0x04200800,0x00200002,
0x04200000,0x00000800,0x00000802,0x04200802, 0x00200800,0x00000002,0x04000000,0x00200800,
0x04000000,0x00200800,0x00200000,0x04000802, 0x04000802,0x04200002,0x04200002,0x00000002,
0x00200002,0x04000000,0x04000800,0x00200000, 0x04200800,0x00000802,0x00200802,0x04200800,
0x00000802,0x04000002,0x04200802,0x04200000, 0x00200800,0x00000000,0x00000002,0x04200802,
0x00000000,0x00200802,0x04200000,0x00000800, 0x04000002,0x04000800,0x00000800,0x00200002},

###############################################################################

TITLE
    RawDES sbox8

TYPE
    32

DATA
0x10001040,0x00001000,0x00040000,0x10041040, 0x10000000,0x10001040,0x00000040,0x10000000,
0x00040040,0x10040000,0x10041040,0x00041000, 0x10041000,0x00041040,0x00001000,0x00000040,
0x10040000,0x10000040,0x10001000,0x00001040, 0x00041000,0x00040040,0x10040040,0x10041000,
0x00001040,0x00000000,0x00000000,0x10040040, 0x10000040,0x10001000,0x00041040,0x00040000,
0x00041040,0x00040000,0x10041000,0x00001000, 0x00000040,0x10040040,0x00001000,0x00041040,
0x10001000,0x00000040,0x10000040,0x10040000, 0x10040040,0x10000000,0x00040000,0x10001040,
0x00000000,0x10041040,0x00040040,0x10000040, 0x10040000,0x10001000,0x10001040,0x00000000,
0x10041040,0x00041000,0x00041000,0x00001040, 0x00001040,0x00040040,0x10000000,0x10041000}

###############################################################################

TITLE
    CAST-256 t_m

TYPE
    32

DATA
{	0x5a827999, 0xd151d6a1, 0x482133a9, 0xbef090b1, 0x35bfedb9, 0xac8f4ac1, 
	0x235ea7c9, 0x9a2e04d1, 0x10fd61d9, 0x87ccbee1, 0xfe9c1be9, 0x756b78f1, 
	0xec3ad5f9, 0x630a3301, 0xd9d99009, 0x50a8ed11, 0xc7784a19, 0x3e47a721, 
	0xb5170429, 0x2be66131, 0xa2b5be39, 0x19851b41, 0x90547849, 0x0723d551}, 
{	0xc95c653a, 0x402bc242, 0xb6fb1f4a, 0x2dca7c52, 0xa499d95a, 0x1b693662, 
	0x9238936a, 0x0907f072, 0x7fd74d7a, 0xf6a6aa82, 0x6d76078a, 0xe4456492, 
	0x5b14c19a, 0xd1e41ea2, 0x48b37baa, 0xbf82d8b2, 0x365235ba, 0xad2192c2, 
	0x23f0efca, 0x9ac04cd2, 0x118fa9da, 0x885f06e2, 0xff2e63ea, 0x75fdc0f2}, 
{	0x383650db, 0xaf05ade3, 0x25d50aeb, 0x9ca467f3, 0x1373c4fb, 0x8a432203, 
	0x01127f0b, 0x77e1dc13, 0xeeb1391b, 0x65809623, 0xdc4ff32b, 0x531f5033, 
	0xc9eead3b, 0x40be0a43, 0xb78d674b, 0x2e5cc453, 0xa52c215b, 0x1bfb7e63, 
	0x92cadb6b, 0x099a3873, 0x8069957b, 0xf738f283, 0x6e084f8b, 0xe4d7ac93}, 
{	0xa7103c7c, 0x1ddf9984, 0x94aef68c, 0x0b7e5394, 0x824db09c, 0xf91d0da4, 
	0x6fec6aac, 0xe6bbc7b4, 0x5d8b24bc, 0xd45a81c4, 0x4b29decc, 0xc1f93bd4, 
	0x38c898dc, 0xaf97f5e4, 0x266752ec, 0x9d36aff4, 0x14060cfc, 0x8ad56a04, 
	0x01a4c70c, 0x78742414, 0xef43811c, 0x6612de24, 0xdce23b2c, 0x53b19834}, 
{	0x15ea281d, 0x8cb98525, 0x0388e22d, 0x7a583f35, 0xf1279c3d, 0x67f6f945, 
	0xdec6564d, 0x5595b355, 0xcc65105d, 0x43346d65, 0xba03ca6d, 0x30d32775, 
	0xa7a2847d, 0x1e71e185, 0x95413e8d, 0x0c109b95, 0x82dff89d, 0xf9af55a5, 
	0x707eb2ad, 0xe74e0fb5, 0x5e1d6cbd, 0xd4ecc9c5, 0x4bbc26cd, 0xc28b83d5}, 
{	0x84c413be, 0xfb9370c6, 0x7262cdce, 0xe9322ad6, 0x600187de, 0xd6d0e4e6, 
	0x4da041ee, 0xc46f9ef6, 0x3b3efbfe, 0xb20e5906, 0x28ddb60e, 0x9fad1316, 
	0x167c701e, 0x8d4bcd26, 0x041b2a2e, 0x7aea8736, 0xf1b9e43e, 0x68894146, 
	0xdf589e4e, 0x5627fb56, 0xccf7585e, 0x43c6b566, 0xba96126e, 0x31656f76}, 
{	0xf39dff5f, 0x6a6d5c67, 0xe13cb96f, 0x580c1677, 0xcedb737f, 0x45aad087, 
	0xbc7a2d8f, 0x33498a97, 0xaa18e79f, 0x20e844a7, 0x97b7a1af, 0x0e86feb7, 
	0x85565bbf, 0xfc25b8c7, 0x72f515cf, 0xe9c472d7, 0x6093cfdf, 0xd7632ce7, 
	0x4e3289ef, 0xc501e6f7, 0x3bd143ff, 0xb2a0a107, 0x296ffe0f, 0xa03f5b17}, 
{	0x6277eb00, 0xd9474808, 0x5016a510, 0xc6e60218, 0x3db55f20, 0xb484bc28, 
	0x2b541930, 0xa2237638, 0x18f2d340, 0x8fc23048, 0x06918d50, 0x7d60ea58, 
	0xf4304760, 0x6affa468, 0xe1cf0170, 0x589e5e78, 0xcf6dbb80, 0x463d1888, 
	0xbd0c7590, 0x33dbd298, 0xaaab2fa0, 0x217a8ca8, 0x9849e9b0, 0x0f1946b8} 

###############################################################################

TITLE
    CAST-256 t_r

TYPE
    8, 32

DATA
	{19, 27, 3, 11, 19, 27, 3, 11, 19, 27, 3, 11, 19, 27, 3, 11, 19, 27, 3, 11, 19, 27, 3, 11}, 
	{4, 12, 20, 28, 4, 12, 20, 28, 4, 12, 20, 28, 4, 12, 20, 28, 4, 12, 20, 28, 4, 12, 20, 28}, 
	{21, 29, 5, 13, 21, 29, 5, 13, 21, 29, 5, 13, 21, 29, 5, 13, 21, 29, 5, 13, 21, 29, 5, 13}, 
	{6, 14, 22, 30, 6, 14, 22, 30, 6, 14, 22, 30, 6, 14, 22, 30, 6, 14, 22, 30, 6, 14, 22, 30}, 
	{23, 31, 7, 15, 23, 31, 7, 15, 23, 31, 7, 15, 23, 31, 7, 15, 23, 31, 7, 15, 23, 31, 7, 15}, 
	{8, 16, 24, 0, 8, 16, 24, 0, 8, 16, 24, 0, 8, 16, 24, 0, 8, 16, 24, 0, 8, 16, 24, 0}, 
	{25, 1, 9, 17, 25, 1, 9, 17, 25, 1, 9, 17, 25, 1, 9, 17, 25, 1, 9, 17, 25, 1, 9, 17}, 
	{10, 18, 26, 2, 10, 18, 26, 2, 10, 18, 26, 2, 10, 18, 26, 2, 10, 18, 26, 2, 10, 18, 26, 2}

###############################################################################

TITLE
    Camellia s1

TYPE
    8

DATA
	112,130,44,236,179,39,192,229,228,133,87,53,234,12,174,65,
	35,239,107,147,69,25,165,33,237,14,79,78,29,101,146,189,
	134,184,175,143,124,235,31,206,62,48,220,95,94,197,11,26,
	166,225,57,202,213,71,93,61,217,1,90,214,81,86,108,77,
	139,13,154,102,251,204,176,45,116,18,43,32,240,177,132,153,
	223,76,203,194,52,126,118,5,109,183,169,49,209,23,4,215,
	20,88,58,97,222,27,17,28,50,15,156,22,83,24,242,34,
	254,68,207,178,195,181,122,145,36,8,232,168,96,252,105,80,
	170,208,160,125,161,137,98,151,84,91,30,149,224,255,100,210,
	16,196,0,72,163,247,117,219,138,3,230,218,9,63,221,148,
	135,92,131,2,205,74,144,51,115,103,246,243,157,127,191,226,
	82,155,216,38,200,55,198,59,129,150,111,75,19,190,99,46,
	233,121,167,140,159,110,188,142,41,245,249,182,47,253,180,89,
	120,152,6,106,231,70,113,186,212,37,171,66,136,162,141,250,
	114,7,185,85,248,238,172,10,54,73,42,104,60,56,241,164,
	64,40,211,123,187,201,67,193,21,227,173,244,119,199,128,158

###############################################################################

TITLE
    Camellia s2

TYPE
    8

DATA
	224,5,88,217,103,78,129,203,201,11,174,106,213,24,93,130,
	70,223,214,39,138,50,75,66,219,28,158,156,58,202,37,123,
	13,113,95,31,248,215,62,157,124,96,185,190,188,139,22,52,
	77,195,114,149,171,142,186,122,179,2,180,173,162,172,216,154,
	23,26,53,204,247,153,97,90,232,36,86,64,225,99,9,51,
	191,152,151,133,104,252,236,10,218,111,83,98,163,46,8,175,
	40,176,116,194,189,54,34,56,100,30,57,44,166,48,229,68,
	253,136,159,101,135,107,244,35,72,16,209,81,192,249,210,160,
	85,161,65,250,67,19,196,47,168,182,60,43,193,255,200,165,
	32,137,0,144,71,239,234,183,21,6,205,181,18,126,187,41,
	15,184,7,4,155,148,33,102,230,206,237,231,59,254,127,197,
	164,55,177,76,145,110,141,118,3,45,222,150,38,125,198,92,
	211,242,79,25,63,220,121,29,82,235,243,109,94,251,105,178,
	240,49,12,212,207,140,226,117,169,74,87,132,17,69,27,245,
	228,14,115,170,241,221,89,20,108,146,84,208,120,112,227,73,
	128,80,167,246,119,147,134,131,42,199,91,233,238,143,1,61

###############################################################################

TITLE
    Camellia s3

TYPE
    8

DATA
	56,65,22,118,217,147,96,242,114,194,171,154,117,6,87,160,
	145,247,181,201,162,140,210,144,246,7,167,39,142,178,73,222,
	67,92,215,199,62,245,143,103,31,24,110,175,47,226,133,13,
	83,240,156,101,234,163,174,158,236,128,45,107,168,43,54,166,
	197,134,77,51,253,102,88,150,58,9,149,16,120,216,66,204,
	239,38,229,97,26,63,59,130,182,219,212,152,232,139,2,235,
	10,44,29,176,111,141,136,14,25,135,78,11,169,12,121,17,
	127,34,231,89,225,218,61,200,18,4,116,84,48,126,180,40,
	85,104,80,190,208,196,49,203,42,173,15,202,112,255,50,105,
	8,98,0,36,209,251,186,237,69,129,115,109,132,159,238,74,
	195,46,193,1,230,37,72,153,185,179,123,249,206,191,223,113,
	41,205,108,19,100,155,99,157,192,75,183,165,137,95,177,23,
	244,188,211,70,207,55,94,71,148,250,252,91,151,254,90,172,
	60,76,3,53,243,35,184,93,106,146,213,33,68,81,198,125,
	57,131,220,170,124,119,86,5,27,164,21,52,30,28,248,82,
	32,20,233,189,221,228,161,224,138,241,214,122,187,227,64,79

###############################################################################

TITLE
    Camellia s4

TYPE
    8

DATA
	112,44,179,192,228,87,234,174,35,107,69,165,237,79,29,146,
	134,175,124,31,62,220,94,11,166,57,213,93,217,90,81,108,
	139,154,251,176,116,43,240,132,223,203,52,118,109,169,209,4,
	20,58,222,17,50,156,83,242,254,207,195,122,36,232,96,105,
	170,160,161,98,84,30,224,100,16,0,163,117,138,230,9,221,
	135,131,205,144,115,246,157,191,82,216,200,198,129,111,19,99,
	233,167,159,188,41,249,47,180,120,6,231,113,212,171,136,141,
	114,185,248,172,54,42,60,241,64,211,187,67,21,173,119,128,
	130,236,39,229,133,53,12,65,239,147,25,33,14,78,101,189,
	184,143,235,206,48,95,197,26,225,202,71,61,1,214,86,77,
	13,102,204,45,18,32,177,153,76,194,126,5,183,49,23,215,
	88,97,27,28,15,22,24,34,68,178,181,145,8,168,252,80,
	208,125,137,151,91,149,255,210,196,72,247,219,3,218,63,148,
	92,2,74,51,103,243,127,226,155,38,55,59,150,75,190,46,
	121,140,110,142,245,182,253,89,152,106,70,186,37,66,162,250,
	7,85,238,10,73,104,56,164,40,123,201,193,227,244,199,158

###############################################################################

TITLE
    3way

TYPE
    32 AND

DATA
    0x0b0b  0xb1b1
    0xAAAAAAAA  0x55555555  0xCCCCCCCC  0x33333333
    0xF0F0F0F0  0x0F0F0F0F
    0x11011

###############################################################################

TITLE
    Baseking RCE

TYPE
    8 32, HEX

DATA
    00Bh,016h,02Ch,058h,0B0h,071h,0E2h,0D5h,0BBh,067h,0CEh,08Dh

###############################################################################

TITLE
    Baseking RCD

TYPE
    8 32, HEX

DATA
    08Dh,0CEh,067h,0BBh,0D5h,0E2h,071h,0B0h,058h,02Ch,016h,00Bh

###############################################################################

TITLE
    CAST128 sbox5

TYPE
    32 HEX

DATA
    07EC90C04h, 02C6E74B9h, 09B0E66DFh, 0A6337911h 
    0B86A7FFFh, 01DD358F5h, 044DD9D44h, 01731167Fh 
    008FBF1FAh, 0E7F511CCh, 0D2051B00h, 0735ABA00h 
    02AB722D8h, 0386381CBh, 0ACF6243Ah, 069BEFD7Ah 
    0E6A2E77Fh, 0F0C720CDh, 0C4494816h, 0CCF5C180h 
    038851640h, 015B0A848h, 0E68B18CBh, 04CAADEFFh 
    05F480A01h, 00412B2AAh, 0259814FCh, 041D0EFE2h 
    04E40B48Dh, 0248EB6FBh, 08DBA1CFEh, 041A99B02h 
    01A550A04h, 0BA8F65CBh, 07251F4E7h, 095A51725h 
    0C106ECD7h, 097A5980Ah, 0C539B9AAh, 04D79FE6Ah 
    0F2F3F763h, 068AF8040h, 0ED0C9E56h, 011B4958Bh 
    0E1EB5A88h, 08709E6B0h, 0D7E07156h, 04E29FEA7h 
    06366E52Dh, 002D1C000h, 0C4AC8E05h, 09377F571h 
    00C05372Ah, 0578535F2h, 02261BE02h, 0D642A0C9h 
    0DF13A280h, 074B55BD2h, 0682199C0h, 0D421E5ECh 
    053FB3CE8h, 0C8ADEDB3h, 028A87FC9h, 03D959981h 
    05C1FF900h, 0FE38D399h, 00C4EFF0Bh, 0062407EAh 
    0AA2F4FB1h, 04FB96976h, 090C79505h, 0B0A8A774h 
    0EF55A1FFh, 0E59CA2C2h, 0A6B62D27h, 0E66A4263h 
    0DF65001Fh, 00EC50966h, 0DFDD55BCh, 029DE0655h 
    0911E739Ah, 017AF8975h, 032C7911Ch, 089F89468h 
    00D01E980h, 0524755F4h, 003B63CC9h, 00CC844B2h 
    0BCF3F0AAh, 087AC36E9h, 0E53A7426h, 001B3D82Bh 
    01A9E7449h, 064EE2D7Eh, 0CDDBB1DAh, 001C94910h 
    0B868BF80h, 00D26F3FDh, 09342EDE7h, 004A5C284h 
    0636737B6h, 050F5B616h, 0F24766E3h, 08ECA36C1h 
    0136E05DBh, 0FEF18391h, 0FB887A37h, 0D6E7F7D4h 
    0C7FB7DC9h, 03063FCDFh, 0B6F589DEh, 0EC2941DAh 
    026E46695h, 0B7566419h, 0F654EFC5h, 0D08D58B7h 
    048925401h, 0C1BACB7Fh, 0E5FF550Fh, 0B6083049h 
    05BB5D0E8h, 087D72E5Ah, 0AB6A6EE1h, 0223A66CEh 
    0C62BF3CDh, 09E0885F9h, 068CB3E47h, 0086C010Fh 
    0A21DE820h, 0D18B69DEh, 0F3F65777h, 0FA02C3F6h 
    0407EDAC3h, 0CBB3D550h, 01793084Dh, 0B0D70EBAh 
    00AB378D5h, 0D951FB0Ch, 0DED7DA56h, 04124BBE4h 
    094CA0B56h, 00F5755D1h, 0E0E1E56Eh, 06184B5BEh 
    0580A249Fh, 094F74BC0h, 0E327888Eh, 09F7B5561h 
    0C3DC0280h, 005687715h, 0646C6BD7h, 044904DB3h 
    066B4F0A3h, 0C0F1648Ah, 0697ED5AFh, 049E92FF6h 
    0309E374Fh, 02CB6356Ah, 085808573h, 04991F840h 
    076F0AE02h, 0083BE84Dh, 028421C9Ah, 044489406h 
    0736E4CB8h, 0C1092910h, 08BC95FC6h, 07D869CF4h 
    0134F616Fh, 02E77118Dh, 0B31B2BE1h, 0AA90B472h 
    03CA5D717h, 07D161BBAh, 09CAD9010h, 0AF462BA2h 
    09FE459D2h, 045D34559h, 0D9F2DA13h, 0DBC65487h 
    0F3E4F94Eh, 0176D486Fh, 0097C13EAh, 0631DA5C7h 
    0445F7382h, 0175683F4h, 0CDC66A97h, 070BE0288h 
    0B3CDCF72h, 06E5DD2F3h, 020936079h, 0459B80A5h 
    0BE60E2DBh, 0A9C23101h, 0EBA5315Ch, 0224E42F2h 
    01C5C1572h, 0F6721B2Ch, 01AD2FFF3h, 08C25404Eh 
    0324ED72Fh, 04067B7FDh, 00523138Eh, 05CA3BC78h 
    0DC0FD66Eh, 075922283h, 0784D6B17h, 058EBB16Eh 
    044094F85h, 03F481D87h, 0FCFEAE7Bh, 077B5FF76h 
    08C2302BFh, 0AAF47556h, 05F46B02Ah, 02B092801h 
    03D38F5F7h, 00CA81F36h, 052AF4A8Ah, 066D5E7C0h 
    0DF3B0874h, 095055110h, 01B5AD7A8h, 0F61ED5ADh 
    06CF6E479h, 020758184h, 0D0CEFA65h, 088F7BE58h 
    04A046826h, 00FF6F8F3h, 0A09C7F70h, 05346ABA0h 
    05CE96C28h, 0E176EDA3h, 06BAC307Fh, 0376829D2h 
    085360FA9h, 017E3FE2Ah, 024B79767h, 0F5A96B20h 
    0D6CD2595h, 068FF1EBFh, 07555442Ch, 0F19F06BEh 
    0F9E0659Ah, 0EEB9491Dh, 034010718h, 0BB30CAB8h 
    0E822FE15h, 088570983h, 0750E6249h, 0DA627E55h 
    05E76FFA8h, 0B1534546h, 06D47DE08h, 0EFE9E7D4h

###############################################################################

TITLE
    CAST128 sbox6

TYPE
    32 HEX

DATA
    0F6FA8F9Dh, 02CAC6CE1h, 04CA34867h, 0E2337F7Ch 
    095DB08E7h, 0016843B4h, 0ECED5CBCh, 0325553ACh 
    0BF9F0960h, 0DFA1E2EDh, 083F0579Dh, 063ED86B9h 
    01AB6A6B8h, 0DE5EBE39h, 0F38FF732h, 08989B138h 
    033F14961h, 0C01937BDh, 0F506C6DAh, 0E4625E7Eh 
    0A308EA99h, 04E23E33Ch, 079CBD7CCh, 048A14367h 
    0A3149619h, 0FEC94BD5h, 0A114174Ah, 0EAA01866h 
    0A084DB2Dh, 009A8486Fh, 0A888614Ah, 02900AF98h 
    001665991h, 0E1992863h, 0C8F30C60h, 02E78EF3Ch 
    0D0D51932h, 0CF0FEC14h, 0F7CA07D2h, 0D0A82072h 
    0FD41197Eh, 09305A6B0h, 0E86BE3DAh, 074BED3CDh 
    0372DA53Ch, 04C7F4448h, 0DAB5D440h, 06DBA0EC3h 
    0083919A7h, 09FBAEED9h, 049DBCFB0h, 04E670C53h 
    05C3D9C01h, 064BDB941h, 02C0E636Ah, 0BA7DD9CDh 
    0EA6F7388h, 0E70BC762h, 035F29ADBh, 05C4CDD8Dh 
    0F0D48D8Ch, 0B88153E2h, 008A19866h, 01AE2EAC8h 
    0284CAF89h, 0AA928223h, 09334BE53h, 03B3A21BFh 
    016434BE3h, 09AEA3906h, 0EFE8C36Eh, 0F890CDD9h 
    080226DAEh, 0C340A4A3h, 0DF7E9C09h, 0A694A807h 
    05B7C5ECCh, 0221DB3A6h, 09A69A02Fh, 068818A54h 
    0CEB2296Fh, 053C0843Ah, 0FE893655h, 025BFE68Ah 
    0B4628ABCh, 0CF222EBFh, 025AC6F48h, 0A9A99387h 
    053BDDB65h, 0E76FFBE7h, 0E967FD78h, 00BA93563h 
    08E342BC1h, 0E8A11BE9h, 04980740Dh, 0C8087DFCh 
    08DE4BF99h, 0A11101A0h, 07FD37975h, 0DA5A26C0h 
    0E81F994Fh, 09528CD89h, 0FD339FEDh, 0B87834BFh 
    05F04456Dh, 022258698h, 0C9C4C83Bh, 02DC156BEh 
    04F628DAAh, 057F55EC5h, 0E2220ABEh, 0D2916EBFh 
    04EC75B95h, 024F2C3C0h, 042D15D99h, 0CD0D7FA0h 
    07B6E27FFh, 0A8DC8AF0h, 07345C106h, 0F41E232Fh 
    035162386h, 0E6EA8926h, 03333B094h, 0157EC6F2h 
    0372B74AFh, 0692573E4h, 0E9A9D848h, 0F3160289h 
    03A62EF1Dh, 0A787E238h, 0F3A5F676h, 074364853h 
    020951063h, 04576698Dh, 0B6FAD407h, 0592AF950h 
    036F73523h, 04CFB6E87h, 07DA4CEC0h, 06C152DAAh 
    0CB0396A8h, 0C50DFE5Dh, 0FCD707ABh, 00921C42Fh 
    089DFF0BBh, 05FE2BE78h, 0448F4F33h, 0754613C9h 
    02B05D08Dh, 048B9D585h, 0DC049441h, 0C8098F9Bh 
    07DEDE786h, 0C39A3373h, 042410005h, 06A091751h 
    00EF3C8A6h, 0890072D6h, 028207682h, 0A9A9F7BEh 
    0BF32679Dh, 0D45B5B75h, 0B353FD00h, 0CBB0E358h 
    0830F220Ah, 01F8FB214h, 0D372CF08h, 0CC3C4A13h 
    08CF63166h, 0061C87BEh, 088C98F88h, 06062E397h 
    047CF8E7Ah, 0B6C85283h, 03CC2ACFBh, 03FC06976h 
    04E8F0252h, 064D8314Dh, 0DA3870E3h, 01E665459h 
    0C10908F0h, 0513021A5h, 06C5B68B7h, 0822F8AA0h 
    03007CD3Eh, 074719EEFh, 0DC872681h, 0073340D4h 
    07E432FD9h, 00C5EC241h, 08809286Ch, 0F592D891h 
    008A930F6h, 0957EF305h, 0B7FBFFBDh, 0C266E96Fh 
    06FE4AC98h, 0B173ECC0h, 0BC60B42Ah, 0953498DAh 
    0FBA1AE12h, 02D4BD736h, 00F25FAABh, 0A4F3FCEBh 
    0E2969123h, 0257F0C3Dh, 09348AF49h, 0361400BCh 
    0E8816F4Ah, 03814F200h, 0A3F94043h, 09C7A54C2h 
    0BC704F57h, 0DA41E7F9h, 0C25AD33Ah, 054F4A084h 
    0B17F5505h, 059357CBEh, 0EDBD15C8h, 07F97C5ABh 
    0BA5AC7B5h, 0B6F6DEAFh, 03A479C3Ah, 05302DA25h 
    0653D7E6Ah, 054268D49h, 051A477EAh, 05017D55Bh 
    0D7D25D88h, 044136C76h, 00404A8C8h, 0B8E5A121h 
    0B81A928Ah, 060ED5869h, 097C55B96h, 0EAEC991Bh 
    029935913h, 001FDB7F1h, 0088E8DFAh, 09AB6F6F5h 
    03B4CBF9Fh, 04A5DE3ABh, 0E6051D35h, 0A0E1D855h 
    0D36B4CF1h, 0F544EDEBh, 0B0E93524h, 0BEBB8FBDh 
    0A2D762CFh, 049C92F54h, 038B5F331h, 07128A454h 
    048392905h, 0A65B1DB8h, 0851C97BDh, 0D675CF2Fh

###############################################################################

TITLE
    CAST128 sbox7

TYPE
    32 HEX

DATA
    085E04019h, 0332BF567h, 0662DBFFFh, 0CFC65693h 
    02A8D7F6Fh, 0AB9BC912h, 0DE6008A1h, 02028DA1Fh 
    00227BCE7h, 04D642916h, 018FAC300h, 050F18B82h 
    02CB2CB11h, 0B232E75Ch, 04B3695F2h, 0B28707DEh 
    0A05FBCF6h, 0CD4181E9h, 0E150210Ch, 0E24EF1BDh 
    0B168C381h, 0FDE4E789h, 05C79B0D8h, 01E8BFD43h 
    04D495001h, 038BE4341h, 0913CEE1Dh, 092A79C3Fh 
    0089766BEh, 0BAEEADF4h, 01286BECFh, 0B6EACB19h 
    02660C200h, 07565BDE4h, 064241F7Ah, 08248DCA9h 
    0C3B3AD66h, 028136086h, 00BD8DFA8h, 0356D1CF2h 
    0107789BEh, 0B3B2E9CEh, 00502AA8Fh, 00BC0351Eh 
    0166BF52Ah, 0EB12FF82h, 0E3486911h, 0D34D7516h 
    04E7B3AFFh, 05F43671Bh, 09CF6E037h, 04981AC83h 
    0334266CEh, 08C9341B7h, 0D0D854C0h, 0CB3A6C88h 
    047BC2829h, 04725BA37h, 0A66AD22Bh, 07AD61F1Eh 
    00C5CBAFAh, 04437F107h, 0B6E79962h, 042D2D816h 
    00A961288h, 0E1A5C06Eh, 013749E67h, 072FC081Ah 
    0B1D139F7h, 0F9583745h, 0CF19DF58h, 0BEC3F756h 
    0C06EBA30h, 007211B24h, 045C28829h, 0C95E317Fh 
    0BC8EC511h, 038BC46E9h, 0C6E6FA14h, 0BAE8584Ah 
    0AD4EBC46h, 0468F508Bh, 07829435Fh, 0F124183Bh 
    0821DBA9Fh, 0AFF60FF4h, 0EA2C4E6Dh, 016E39264h 
    092544A8Bh, 0009B4FC3h, 0ABA68CEDh, 09AC96F78h 
    006A5B79Ah, 0B2856E6Eh, 01AEC3CA9h, 0BE838688h 
    00E0804E9h, 055F1BE56h, 0E7E5363Bh, 0B3A1F25Dh 
    0F7DEBB85h, 061FE033Ch, 016746233h, 03C034C28h 
    0DA6D0C74h, 079AAC56Ch, 03CE4E1ADh, 051F0C802h 
    098F8F35Ah, 01626A49Fh, 0EED82B29h, 01D382FE3h 
    00C4FB99Ah, 0BB325778h, 03EC6D97Bh, 06E77A6A9h 
    0CB658B5Ch, 0D45230C7h, 02BD1408Bh, 060C03EB7h 
    0B9068D78h, 0A33754F4h, 0F430C87Dh, 0C8A71302h 
    0B96D8C32h, 0EBD4E7BEh, 0BE8B9D2Dh, 07979FB06h 
    0E7225308h, 08B75CF77h, 011EF8DA4h, 0E083C858h 
    08D6B786Fh, 05A6317A6h, 0FA5CF7A0h, 05DDA0033h 
    0F28EBFB0h, 0F5B9C310h, 0A0EAC280h, 008B9767Ah 
    0A3D9D2B0h, 079D34217h, 0021A718Dh, 09AC6336Ah 
    02711FD60h, 0438050E3h, 0069908A8h, 03D7FEDC4h 
    0826D2BEFh, 04EEB8476h, 0488DCF25h, 036C9D566h 
    028E74E41h, 0C2610ACAh, 03D49A9CFh, 0BAE3B9DFh 
    0B65F8DE6h, 092AEAF64h, 03AC7D5E6h, 09EA80509h 
    0F22B017Dh, 0A4173F70h, 0DD1E16C3h, 015E0D7F9h 
    050B1B887h, 02B9F4FD5h, 0625ABA82h, 06A017962h 
    02EC01B9Ch, 015488AA9h, 0D716E740h, 040055A2Ch 
    093D29A22h, 0E32DBF9Ah, 0058745B9h, 03453DC1Eh 
    0D699296Eh, 0496CFF6Fh, 01C9F4986h, 0DFE2ED07h 
    0B87242D1h, 019DE7EAEh, 0053E561Ah, 015AD6F8Ch 
    066626C1Ch, 07154C24Ch, 0EA082B2Ah, 093EB2939h 
    017DCB0F0h, 058D4F2AEh, 09EA294FBh, 052CF564Ch 
    09883FE66h, 02EC40581h, 0763953C3h, 001D6692Eh 
    0D3A0C108h, 0A1E7160Eh, 0E4F2DFA6h, 0693ED285h 
    074904698h, 04C2B0EDDh, 04F757656h, 05D393378h 
    0A132234Fh, 03D321C5Dh, 0C3F5E194h, 04B269301h 
    0C79F022Fh, 03C997E7Eh, 05E4F9504h, 03FFAFBBDh 
    076F7AD0Eh, 0296693F4h, 03D1FCE6Fh, 0C61E45BEh 
    0D3B5AB34h, 0F72BF9B7h, 01B0434C0h, 04E72B567h 
    05592A33Dh, 0B5229301h, 0CFD2A87Fh, 060AEB767h 
    01814386Bh, 030BCC33Dh, 038A0C07Dh, 0FD1606F2h 
    0C363519Bh, 0589DD390h, 05479F8E6h, 01CB8D647h 
    097FD61A9h, 0EA7759F4h, 02D57539Dh, 0569A58CFh 
    0E84E63ADh, 0462E1B78h, 06580F87Eh, 0F3817914h 
    091DA55F4h, 040A230F3h, 0D1988F35h, 0B6E318D2h 
    03FFA50BCh, 03D40F021h, 0C3C0BDAEh, 04958C24Ch 
    0518F36B2h, 084B1D370h, 00FEDCE83h, 0878DDADAh 
    0F2A279C7h, 094E01BE8h, 090716F4Bh, 0954B8AA3h

###############################################################################

TITLE
    CAST128 sbox8

TYPE
    32 HEX

DATA
    0E216300Dh, 0BBDDFFFCh, 0A7EBDABDh, 035648095h 
    07789F8B7h, 0E6C1121Bh, 00E241600h, 0052CE8B5h 
    011A9CFB0h, 0E5952F11h, 0ECE7990Ah, 09386D174h 
    02A42931Ch, 076E38111h, 0B12DEF3Ah, 037DDDDFCh 
    0DE9ADEB1h, 00A0CC32Ch, 0BE197029h, 084A00940h 
    0BB243A0Fh, 0B4D137CFh, 0B44E79F0h, 0049EEDFDh 
    00B15A15Dh, 0480D3168h, 08BBBDE5Ah, 0669DED42h 
    0C7ECE831h, 03F8F95E7h, 072DF191Bh, 07580330Dh 
    094074251h, 05C7DCDFAh, 0ABBE6D63h, 0AA402164h 
    0B301D40Ah, 002E7D1CAh, 053571DAEh, 07A3182A2h 
    012A8DDECh, 0FDAA335Dh, 0176F43E8h, 071FB46D4h 
    038129022h, 0CE949AD4h, 0B84769ADh, 0965BD862h 
    082F3D055h, 066FB9767h, 015B80B4Eh, 01D5B47A0h 
    04CFDE06Fh, 0C28EC4B8h, 057E8726Eh, 0647A78FCh 
    099865D44h, 0608BD593h, 06C200E03h, 039DC5FF6h 
    05D0B00A3h, 0AE63AFF2h, 07E8BD632h, 070108C0Ch 
    0BBD35049h, 02998DF04h, 0980CF42Ah, 09B6DF491h 
    09E7EDD53h, 006918548h, 058CB7E07h, 03B74EF2Eh 
    0522FFFB1h, 0D24708CCh, 01C7E27CDh, 0A4EB215Bh 
    03CF1D2E2h, 019B47A38h, 0424F7618h, 035856039h 
    09D17DEE7h, 027EB35E6h, 0C9AFF67Bh, 036BAF5B8h 
    009C467CDh, 0C18910B1h, 0E11DBF7Bh, 006CD1AF8h 
    07170C608h, 02D5E3354h, 0D4DE495Ah, 064C6D006h 
    0BCC0C62Ch, 03DD00DB3h, 0708F8F34h, 077D51B42h 
    0264F620Fh, 024B8D2BFh, 015C1B79Eh, 046A52564h 
    0F8D7E54Eh, 03E378160h, 07895CDA5h, 0859C15A5h 
    0E6459788h, 0C37BC75Fh, 0DB07BA0Ch, 00676A3ABh 
    07F229B1Eh, 031842E7Bh, 024259FD7h, 0F8BEF472h 
    0835FFCB8h, 06DF4C1F2h, 096F5B195h, 0FD0AF0FCh 
    0B0FE134Ch, 0E2506D3Dh, 04F9B12EAh, 0F215F225h 
    0A223736Fh, 09FB4C428h, 025D04979h, 034C713F8h 
    0C4618187h, 0EA7A6E98h, 07CD16EFCh, 01436876Ch 
    0F1544107h, 0BEDEEE14h, 056E9AF27h, 0A04AA441h 
    03CF7C899h, 092ECBAE6h, 0DD67016Dh, 0151682EBh 
    0A842EEDFh, 0FDBA60B4h, 0F1907B75h, 020E3030Fh 
    024D8C29Eh, 0E139673Bh, 0EFA63FB8h, 071873054h 
    0B6F2CF3Bh, 09F326442h, 0CB15A4CCh, 0B01A4504h 
    0F1E47D8Dh, 0844A1BE5h, 0BAE7DFDCh, 042CBDA70h 
    0CD7DAE0Ah, 057E85B7Ah, 0D53F5AF6h, 020CF4D8Ch 
    0CEA4D428h, 079D130A4h, 03486EBFBh, 033D3CDDCh 
    077853B53h, 037EFFCB5h, 0C5068778h, 0E580B3E6h 
    04E68B8F4h, 0C5C8B37Eh, 00D809EA2h, 0398FEB7Ch 
    0132A4F94h, 043B7950Eh, 02FEE7D1Ch, 0223613BDh 
    0DD06CAA2h, 037DF932Bh, 0C4248289h, 0ACF3EBC3h 
    05715F6B7h, 0EF3478DDh, 0F267616Fh, 0C148CBE4h 
    09052815Eh, 05E410FABh, 0B48A2465h, 02EDA7FA4h 
    0E87B40E4h, 0E98EA084h, 05889E9E1h, 0EFD390FCh 
    0DD07D35Bh, 0DB485694h, 038D7E5B2h, 057720101h 
    0730EDEBCh, 05B643113h, 094917E4Fh, 0503C2FBAh 
    0646F1282h, 07523D24Ah, 0E0779695h, 0F9C17A8Fh 
    07A5B2121h, 0D187B896h, 029263A4Dh, 0BA510CDFh 
    081F47C9Fh, 0AD1163EDh, 0EA7B5965h, 01A00726Eh 
    011403092h, 000DA6D77h, 04A0CDD61h, 0AD1F4603h 
    0605BDFB0h, 09EEDC364h, 022EBE6A8h, 0CEE7D28Ah 
    0A0E736A0h, 05564A6B9h, 010853209h, 0C7EB8F37h 
    02DE705CAh, 08951570Fh, 0DF09822Bh, 0BD691A6Ch 
    0AA12E4F2h, 087451C0Fh, 0E0F6A27Ah, 03ADA4819h 
    04CF1764Fh, 00D771C2Bh, 067CDB156h, 0350D8384h 
    05938FA0Fh, 042399EF3h, 036997B07h, 00E84093Dh 
    04AA93E61h, 08360D87Bh, 01FA98B0Ch, 01149382Ch 
    0E97625A5h, 00614D1B7h, 00E25244Bh, 00C768347h 
    0589E8D82h, 00D2059D1h, 0A466BB1Eh, 0F8DA0A82h 
    004F19130h, 0BA6E4EC0h, 099265164h, 01EE7230Dh 
    050B2AD80h, 0EAEE6801h, 08DB2A283h, 0EA8BF59Eh

###############################################################################

TITLE
    CAST128 / CAST256 sbox1

TYPE
    32 HEX

DATA
    030fb40d4h, 09fa0ff0bh, 06beccd2fh, 03f258c7ah, 01e213f2fh, 09C004dd3h
    06003e540h, 0cf9fc949h, 0bfd4af27h, 088bbbdb5h, 0e2034090h, 098d09675h
    06e63a0e0h, 015c361d2h, 0c2e7661dh, 022d4ff8eh, 028683b6fh, 0c07fd059h
    0ff2379c8h, 0775f50e2h, 043c340d3h, 0df2f8656h, 0887ca41ah, 0a2d2bd2dh
    0a1c9e0d6h, 0346c4819h, 061b76d87h, 022540f2fh, 02abe32e1h, 0aa54166bh
    022568e3ah, 0a2d341d0h, 066db40c8h, 0a784392fh, 0004dff2fh, 02db9d2deh
    097943fach, 04a97c1d8h, 0527644b7h, 0b5f437a7h, 0b82cbaefh, 0d751d159h
    06ff7f0edh, 05a097a1fh, 0827b68d0h, 090ecf52eh, 022b0c054h, 0bc8e5935h
    04b6d2f7fh, 050bb64a2h, 0d2664910h, 0bee5812dh, 0b7332290h, 0e93b159fh
    0b48ee411h, 04bff345dh, 0fd45c240h, 0ad31973fh, 0c4f6d02eh, 055fc8165h
    0d5b1caadh, 0a1ac2daeh, 0a2d4b76dh, 0c19b0C50h, 0882240f2h, 00c6e4f38h
    0a4e4bfd7h, 04f5ba272h, 0564c1d2fh, 0c59c5319h, 0b949e354h, 0b04669feh
    0b1b6ab8ah, 0c71358ddh, 06385c545h, 0110f935dh, 057538ad5h, 06a390493h 
    0e63d37e0h, 02a54f6b3h, 03a787d5fh, 06276a0b5h, 019a6fcdfh, 07a42206ah 
    029f9d4d5h, 0f61b1891h, 0bb72275eh, 0aa508167h, 038901091h, 0c6b505ebh 
    084c7cb8ch, 02ad75a0fh, 0874a1427h, 0a2d1936bh, 02ad286afh, 0aa56d291h
    0d7894360h, 0425c750dh, 093b39e26h, 0187184c9h, 06c00b32dh, 073e2bb14h 
    0a0bebc3ch, 054623779h, 064459eabh, 03f328b82h, 07718cf82h, 059a2cea6h
    004ee002eh, 089fe78e6h, 03fab0950h, 0325ff6C2h, 081383f05h, 06963c5c8h
    076cb5ad6h, 0d49974c9h, 0ca180dcfh, 0380782d5h, 0c7fa5cf6h, 08ac31511h
    035e79e13h, 047da91d0h, 0f40f9086h, 0a7e2419eh, 031366241h, 0051ef495h 
    0aa573b04h, 04a805d8dh, 0548300d0h, 000322a3ch, 0bf64cddfh, 0ba57a68eh
    075c6372bh, 050afd341h, 0a7c13275h, 0915a0bf5h, 06b54bfabh, 02b0b1426h 
    0ab4cc9d7h, 0449ccd82h, 0f7fbf265h, 0ab85c5f3h, 01b55db94h, 0aad4e324h 
    0cfa4bd3fh, 02deaa3e2h, 09e204d02h, 0c8bd25ach, 0eadf55b3h, 0d5bd9e98h 
    0e31231b2h, 02ad5ad6ch, 0954329deh, 0adbe4528h, 0d8710f69h, 0aa51c90fh
    0aa786bf6h, 022513f1eh, 0aa51a79bh, 02ad344cch, 07b5a41f0h, 0d37cfbadh 
    01b069505h, 041ece491h, 0b4c332e6h, 0032268d4h, 0c9600acch, 0ce387e6dh 
    0bf6bb16ch, 06a70fb78h, 00d03d9c9h, 0d4df39deh, 0e01063dah, 04736f464h 
    05ad328d8h, 0b347cc96h, 075bb0fc3h, 098511bfbh, 04ffbcc35h, 0b58bcf6ah
    0e11f0abch, 0bfc5fe4ah, 0a70aec10h, 0ac39570ah, 03f04442fh, 06188b153h 
    0e0397a2eh, 05727cb79h, 09ceb418fh, 01cacd68dh, 02ad37c96h, 00175cb9dh 
    0c69dff09h, 0c75b65f0h, 0d9db40d8h, 0ec0e7779h, 04744ead4h, 0b11c3274h 
    0dd24cb9eh, 07e1c54bdh, 0f01144f9h, 0d2240eb1h, 09675b3fdh, 0a3ac3755h
    0d47c27afh, 051c85f4dh, 056907596h, 0a5bb15e6h, 0580304f0h, 0ca042cf1h 
    0011a37eah, 08dbfaadbh, 035ba3e4ah, 03526ffa0h, 0c37b4d09h, 0bc306ed9h
    098a52666h, 05648f725h, 0ff5e569dh, 00ced63d0h, 07c63b2cfh, 0700b45e1h 
    0d5ea50f1h, 085a92872h, 0af1fbda7h, 0d4234870h, 0a7870bf3h, 02d3b4d79h
    042e04198h, 00cd0ede7h, 026470db8h, 0f881814Ch, 0474d6ad7h, 07c0c5e5ch 
    0d1231959h, 0381b7298h, 0f5d2f4dbh, 0ab838653h, 06e2f1e23h, 083719c9eh
    0bd91e046h, 09a56456eh, 0dc39200ch, 020c8c571h, 0962bda1ch, 0e1e696ffh 
    0b141ab08h, 07cca89b9h, 01a69e783h, 002cc4843h, 0a2f7c579h, 0429ef47dh 
    0427b169ch, 05ac9f049h, 0dd8f0f00h, 05c8165bfh

###############################################################################

TITLE
    CAST128 / CAST256 sbox2

TYPE
    32 HEX

DATA
    01f201094h, 0ef0ba75bh, 069e3cf7eh, 0393f4380h, 0fe61cf7ah, 0eec5207ah
    055889c94h, 072fc0651h, 0ada7ef79h, 04e1d7235h, 0d55a63ceh, 0de0436bah
    099c430efh, 05f0c0794h, 018dcdb7dh, 0a1d6eff3h, 0a0b52f7bh, 059e83605h
    0ee15b094h, 0e9ffd909h, 0dc440086h, 0ef944459h, 0ba83ccb3h, 0e0c3cdfbh
    0d1da4181h, 03b092ab1h, 0f997f1c1h, 0a5e6cf7bh, 001420ddbh, 0e4e7ef5bh 
    025a1ff41h, 0e180f806h, 01fc41080h, 0179bee7ah, 0d37ac6a9h, 0fe5830a4h 
    098de8b7fh, 077e83f4eh, 079929269h, 024fa9f7bh, 0e113c85bh, 0acc40083h 
    0d7503525h, 0f7ea615fh, 062143154h, 00d554b63h, 05d681121h, 0c866c359h
    03d63cf73h, 0cee234c0h, 0d4d87e87h, 05c672b21h, 0071f6181h, 039f7627fh 
    0361e3084h, 0e4eb573bh, 0602f64a4h, 0d63acd9ch, 01bbc4635h, 09e81032dh 
    02701f50ch, 099847ab4h, 0a0e3df79h, 0ba6cf38ch, 010843094h, 02537a95eh 
    0f46f6ffeh, 0a1ff3b1fh, 0208cfb6ah, 08f458c74h, 0d9e0a227h, 04ec73a34h
    0fc884f69h, 03e4de8dfh, 0ef0e0088h, 03559648dh, 08a45388ch, 01d804366h 
    0721d9bfdh, 0a58684bbh, 0e8256333h, 0844e8212h, 0128d8098h, 0fed33fb4h 
    0ce280ae1h, 027e19ba5h, 0d5a6c252h, 0e49754bdh, 0c5d655ddh, 0eb667064h 
    077840b4dh, 0a1b6a801h, 084db26a9h, 0e0b56714h, 021f043b7h, 0e5d05860h
    054f03084h, 0066ff472h, 0a31aa153h, 0dadc4755h, 0b5625dbfh, 068561be6h 
    083ca6b94h, 02d6ed23bh, 0eccf01dbh, 0a6d3d0bah, 0b6803d5ch, 0af77a709h 
    033b4a34ch, 0397bc8d6h, 05ee22b95h, 05f0e5304h, 081ed6f61h, 020e74364h 
    0b45e1378h, 0de18639bh, 0881ca122h, 0b96726d1h, 08049a7e8h, 022b7da7bh
    05e552d25h, 05272d237h, 079d2951ch, 0c60d894ch, 0488cb402h, 01ba4fe5bh 
    0a4b09f6bh, 01ca815cfh, 0a20c3005h, 08871df63h, 0b9de2fcbh, 00cc6c9e9h 
    00beeff53h, 0e3214517h, 0b4542835h, 09f63293ch, 0ee41e729h, 06e1d2d7ch 
    050045286h, 01e6685f3h, 0f33401c6h, 030a22c95h, 031a70850h, 060930f13h
    073f98417h, 0a1269859h, 0ec645c44h, 052c877a9h, 0cdff33a6h, 0a02b1741h
    07cbad9a2h, 02180036fh, 050d99c08h, 0cb3f4861h, 0c26bd765h, 064a3f6abh 
    080342676h, 025a75e7bh, 0e4e6d1fch, 020c710e6h, 0cdf0b680h, 017844d3bh 
    031eef84dh, 07e0824e4h, 02ccb49ebh, 0846a3baeh, 08ff77888h, 0ee5d60f6h
    07af75673h, 02fdd5cdbh, 0a11631c1h, 030f66f43h, 0b3faec54h, 0157fd7fah 
    0ef8579cch, 0d152de58h, 0db2ffd5eh, 08f32ce19h, 0306af97ah, 002f03ef8h 
    099319ad5h, 0c242fa0fh, 0a7e3ebb0h, 0c68e4906h, 0b8da230ch, 080823028h 
    0dcdef3c8h, 0d35fb171h, 0088a1bc8h, 0bec0c560h, 061a3c9e8h, 0bca8f54dh
    0c72feffah, 022822e99h, 082c570b4h, 0d8d94e89h, 08b1c34bch, 0301e16e6h
    0273be979h, 0b0ffeaa6h, 061d9b8c6h, 000b24869h, 0b7ffce3fh, 008dc283bh 
    043daf65ah, 0f7e19798h, 07619b72fh, 08f1c9ba4h, 0dc8637a0h, 016a7d3b1h 
    09fc393b7h, 0a7136eebh, 0c6bcc63eh, 01a513742h, 0ef6828bch, 0520365d6h
    02d6a77abh, 03527ed4bh, 0821fd216h, 0095c6e2eh, 0db92f2fbh, 05eea29cbh 
    0145892f5h, 091584f7fh, 05483697bh, 02667a8cch, 085196048h, 08c4baceah 
    0833860d4h, 00d23e0f9h, 06c387e8ah, 00ae6d249h, 0b284600ch, 0d835731dh 
    0dcb1c647h, 0ac4c56eah, 03ebd81b3h, 0230eabb0h, 06438bc87h, 0f0b5b1fah
    08f5ea2b3h, 0fc184642h, 00a036b7ah, 04fb089bdh, 0649da589h, 0a345415eh 
    05c038323h, 03e5d3bb9h, 043d79572h, 07e6dd07ch, 006dfdf1eh, 06c6cc4efh 
    07160a539h, 073bfbe70h, 083877605h, 04523ecf1h

###############################################################################

TITLE
    CAST128 / CAST256 sbox3

TYPE
    32 HEX

DATA
    08defc240h, 025fa5d9fh, 0eb903dbfh, 0e810c907h, 047607fffh, 0369fe44bh
    08c1fc644h, 0aececa90h, 0beb1f9bfh, 0eefbcaeah, 0e8cf1950h, 051df07aeh 
    0920e8806h, 0f0ad0548h, 0e13c8d83h, 0927010d5h, 011107d9fh, 007647db9h
    0b2e3e4d4h, 03d4f285eh, 0b9afa820h, 0fade82e0h, 0a067268bh, 08272792eh
    0553fb2c0h, 0489ae22bh, 0d4ef9794h, 0125e3fbch, 021fffceeh, 0825b1bfdh
    09255c5edh, 01257a240h, 04e1a8302h, 0bae07fffh, 0528246e7h, 08e57140eh
    03373f7bfh, 08c9f8188h, 0a6fc4ee8h, 0c982b5a5h, 0a8c01db7h, 0579fc264h
    067094f31h, 0f2bd3f5fh, 040fff7c1h, 01fb78dfch, 08e6bd2c1h, 0437be59bh
    099b03dbfh, 0b5dbc64bh, 0638dc0e6h, 055819d99h, 0a197c81ch, 04a012d6eh
    0c5884a28h, 0ccc36f71h, 0b843c213h, 06c0743f1h, 08309893ch, 00feddd5fh
    02f7fe850h, 0d7c07f7eh, 002507fbfh, 05afb9a04h, 0a747d2d0h, 01651192eh 
    0af70bf3eh, 058c31380h, 05f98302eh, 0727cc3c4h, 00a0fb402h, 00f7fef82h
    08c96fdadh, 05d2c2aaeh, 08ee99a49h, 050da88b8h, 08427f4a0h, 01eac5790h
    0796fb449h, 08252dc15h, 0efbd7d9bh, 0a672597dh, 0ada840d8h, 045f54504h 
    0fa5d7403h, 0e83ec305h, 04f91751ah, 0925669c2h, 023efe941h, 0a903f12eh 
    060270df2h, 00276e4b6h, 094fd6574h, 0927985b2h, 08276dbcbh, 002778176h
    0f8af918dh, 04e48f79eh, 08f616ddfh, 0e29d840eh, 0842f7d83h, 0340ce5c8h 
    096bbb682h, 093b4b148h, 0ef303cabh, 0984faf28h, 0779faf9bh, 092dc560dh 
    0224d1e20h, 08437aa88h, 07d29dc96h, 02756d3dch, 08b907ceeh, 0b51fd240h 
    0e7c07ce3h, 0e566b4a1h, 0c3e9615eh, 03cf8209dh, 06094d1e3h, 0cd9ca341h
    05c76460eh, 000ea983bh, 0d4d67881h, 0fd47572ch, 0f76cedd9h, 0bda8229ch 
    0127dadaah, 0438a074eh, 01f97c090h, 0081bdb8ah, 093a07ebeh, 0b938ca15h
    097b03cffh, 03dc2c0f8h, 08d1ab2ech, 064380e51h, 068cc7bfbh, 0d90f2788h 
    012490181h, 05de5ffd4h, 0dd7ef86ah, 076a2e214h, 0b9a40368h, 0925d958fh
    04b39fffah, 0ba39aee9h, 0a4ffd30bh, 0faf7933bh, 06d498623h, 0193cbcfah 
    027627545h, 0825cf47ah, 061bd8ba0h, 0d11e42d1h, 0cead04f4h, 0127ea392h 
    010428db7h, 08272a972h, 09270c4a8h, 0127de50bh, 0285ba1c8h, 03c62f44fh 
    035c0eaa5h, 0e805d231h, 0428929fbh, 0b4fcdf82h, 04fb66a53h, 00e7dc15bh
    01f081fabh, 0108618aeh, 0fcfd086dh, 0f9ff2889h, 0694bcc11h, 0236a5caeh 
    012deca4dh, 02c3f8cc5h, 0d2d02dfeh, 0f8ef5896h, 0e4cf52dah, 095155b67h 
    0494a488ch, 0b9b6a80ch, 05c8f82bch, 089d36b45h, 03a609437h, 0ec00c9a9h 
    044715253h, 00a874b49h, 0d773bc40h, 07c34671ch, 002717ef6h, 04feb5536h
    0a2d02fffh, 0d2bf60c4h, 0d43f03c0h, 050b4ef6dh, 007478cd1h, 0006e1888h 
    0a2e53f55h, 0b9e6d4bch, 0a2048016h, 097573833h, 0d7207d67h, 0de0f8f3dh 
    072f87b33h, 0abcc4f33h, 07688c55dh, 07b00a6b0h, 0947b0001h, 0570075d2h 
    0f9bb88f8h, 08942019eh, 04264a5ffh, 0856302e0h, 072dbd92bh, 0ee971b69h
    06ea22fdeh, 05f08ae2bh, 0af7a616dh, 0e5c98767h, 0cf1febd2h, 061efc8c2h 
    0f1ac2571h, 0cc8239c2h, 067214cb8h, 0b1e583d1h, 0b7dc3e62h, 07f10bdceh 
    0f90a5c38h, 00ff0443dh, 0606e6dc6h, 060543a49h, 05727c148h, 02be98a1dh 
    08ab41738h, 020e1be24h, 0af96da0fh, 068458425h, 099833be5h, 0600d457dh
    0282f9350h, 08334b362h, 0d91d1120h, 02b6d8da0h, 0642b1e31h, 09c305a00h 
    052bce688h, 01b03588ah, 0f7baefd5h, 04142ed9ch, 0a4315c11h, 083323ec5h 
    0dfef4636h, 0a133c501h, 0e9d3531ch, 0ee353783h

###############################################################################

TITLE
    CAST128 / CAST256 sbox4

TYPE
    32 HEX

DATA
    09db30420h, 01fb6e9deh, 0a7be7befh, 0d273a298h, 04a4f7bdbh, 064ad8c57h
    085510443h, 0fa020ed1h, 07e287affh, 0e60fb663h, 0095f35a1h, 079ebf120h
    0fd059d43h, 06497b7b1h, 0f3641f63h, 0241e4adfh, 028147f5fh, 04fa2b8cdh 
    0c9430040h, 00cc32220h, 0fdd30b30h, 0c0a5374fh, 01d2d00d9h, 024147b15h
    0ee4d111ah, 00fca5167h, 071ff904ch, 02d195ffeh, 01a05645fh, 00c13fefeh 
    0081b08cah, 005170121h, 080530100h, 0e83e5efeh, 0ac9af4f8h, 07fe72701h 
    0d2b8ee5fh, 006df4261h, 0bb9e9b8ah, 07293ea25h, 0ce84ffdfh, 0f5718801h 
    03dd64b04h, 0a26f263bh, 07ed48400h, 0547eebe6h, 0446d4ca0h, 06cf3d6f5h
    02649abdfh, 0aea0c7f5h, 036338cc1h, 0503f7e93h, 0d3772061h, 011b638e1h 
    072500e03h, 0f80eb2bbh, 0abe0502eh, 0ec8d77deh, 057971e81h, 0e14f6746h
    0c9335400h, 06920318fh, 0081dbb99h, 0ffc304a5h, 04d351805h, 07f3d5ce3h 
    0a6c866c6h, 05d5bcca9h, 0daec6feah, 09f926f91h, 09f46222fh, 03991467dh
    0a5bf6d8eh, 01143c44fh, 043958302h, 0d0214eebh, 0022083b8h, 03fb6180ch
    018f8931eh, 0281658e6h, 026486e3eh, 08bd78a70h, 07477e4c1h, 0b506e07ch
    0f32d0a25h, 079098b02h, 0e4eabb81h, 028123b23h, 069dead38h, 01574ca16h 
    0df871b62h, 0211c40b7h, 0a51a9ef9h, 00014377bh, 0041e8ac8h, 009114003h
    0bd59e4d2h, 0e3d156d5h, 04fe876d5h, 02f91a340h, 0557be8deh, 000eae4a7h
    00ce5c2ech, 04db4bba6h, 0e756bdffh, 0dd3369ach, 0ec17b035h, 006572327h 
    099afc8b0h, 056c8c391h, 06b65811ch, 05e146119h, 06e85cb75h, 0be07c002h 
    0c2325577h, 0893ff4ech, 05bbfc92dh, 0d0ec3b25h, 0b7801ab7h, 08d6d3b24h
    020c763efh, 0c366a5fch, 09c382880h, 00ace3205h, 0aac9548ah, 0eca1d7c7h 
    0041afa32h, 01d16625ah, 06701902ch, 09b757a54h, 031d477f7h, 09126b031h 
    036cc6fdbh, 0c70b8b46h, 0d9e66a48h, 056e55a79h, 0026a4cebh, 052437effh 
    02f8f76b4h, 00df980a5h, 08674cde3h, 0edda04ebh, 017a9be04h, 02c18f4dfh
    0b7747f9dh, 0ab2af7b4h, 0efc34d20h, 02e096b7ch, 01741a254h, 0e5b6a035h 
    0213d42f6h, 02c1c7c26h, 061c2f50fh, 06552daf9h, 0d2c231f8h, 025130f69h 
    0d8167fa2h, 00418f2c8h, 0001a96a6h, 00d1526abh, 063315c21h, 05e0a72ech 
    049bafefdh, 0187908d9h, 08d0dbd86h, 0311170a7h, 03e9b640ch, 0cc3e10d7h
    0d5cad3b6h, 00caec388h, 0f73001e1h, 06c728affh, 071eae2a1h, 01f9af36eh 
    0cfcbd12fh, 0c1de8417h, 0ac07be6bh, 0cb44a1d8h, 08b9b0f56h, 0013988c3h 
    0b1c52fcah, 0b4be31cdh, 0d8782806h, 012a3a4e2h, 06f7de532h, 058fd7eb6h
    0d01ee900h, 024adffc2h, 0f4990fc5h, 09711aac5h, 0001d7b95h, 082e5e7d2h
    0109873f6h, 000613096h, 0c32d9521h, 0ada121ffh, 029908415h, 07fbb977fh 
    0af9eb3dbh, 029c9ed2ah, 05ce2a465h, 0a730f32ch, 0d0aa3fe8h, 08a5cc091h 
    0d49e2ce7h, 00ce454a9h, 0d60acd86h, 0015f1919h, 077079103h, 0dea03af6h 
    078a8565eh, 0dee356dfh, 021f05cbeh, 08b75e387h, 0b3c50651h, 0b8a5c3efh
    0d8eeb6d2h, 0e523be77h, 0c2154529h, 02f69efdfh, 0afe67afbh, 0f470c4b2h
    0f3e0eb5bh, 0d6cc9876h, 039e4460ch, 01fda8538h, 01987832fh, 0ca007367h 
    0a99144f8h, 0296b299eh, 0492fc295h, 09266beabh, 0b5676e69h, 09bd3dddah
    0df7e052fh, 0db25701ch, 01b5e51eeh, 0f65324e6h, 06afce36ch, 00316cc04h
    08644213eh, 0b7dc59d0h, 07965291fh, 0ccd6fd43h, 041823979h, 0932bcdf6h
    0b657c34dh, 04edfd282h, 07ae5290ch, 03cb9536bh, 0851e20feh, 09833557eh
    013ecf0b0h, 0d3ffb372h, 03f85c5c1h, 00aef7ed2h

###############################################################################

TITLE
    DESX pc1

TYPE
    8

DATA
	    56, 48, 40, 32, 24, 16,  8,0, 57, 49, 41, 33, 25, 17
	     9,  1, 58, 50, 42, 34, 26,18, 10,  2, 59, 51, 43, 35
	    62, 54, 46, 38, 30, 22, 14, 6, 61, 53, 45, 37, 29, 21
	    13,  5, 60, 52, 44, 36, 28,20, 12,  4, 27, 19, 11,  3

###############################################################################

TITLE
    DESX pc2

TYPE
    8

DATA
	    13, 16, 10, 23,  0,  4, 2, 27, 14,  5, 20,  9
	    22, 18, 11,  3, 25,  7,15,  6, 26, 19, 12,  1
	    40, 51, 30, 36, 46, 54,29, 39, 50, 44, 32, 47
	    43, 48, 38, 55, 33, 52,45, 41, 49, 35, 28, 31 

###############################################################################

TITLE
    khazad_U0

TYPE
    32 HEX NOBIG

DATA
    0bad3d268h, 054fc4d19h, 02f71bc93h, 0749ccdb9h
    053f55102h, 0d3686bb8h, 0d26b6fbdh, 04dd72964h
    050f05d0dh, 0ace98a26h, 08d8a0e83h, 0bfdcc679h
    07090ddadh, 052f65507h, 09ab352c8h, 04cd42d61h
    0ea238f65h, 0d56273a6h, 097a466f1h, 0d16e63b2h
    03355ccffh, 051f35908h, 05bed712ah, 0a6f7a204h
    0de7f5f81h, 048d83d75h, 0a8e59a32h, 099b65ec7h
    0db704b90h, 03256c8fah, 0b7c4e651h, 0fc19d72bh
    0e338ab48h, 09ebf42dch, 091ae7eefh, 09bb056cdh
    0e23baf4dh, 0bbd0d66dh, 041c31958h, 06eb2a5cbh
    0a5f2ae0bh, 0cb400bc0h, 06bbdb1dah, 095a26efbh
    0a1febe1fh, 0f308eb18h, 0b1cefe4fh, 00206080ah
    0cc4917dbh, 0c45137f3h, 01d277469h, 0143c5044h
    0c3582be8h, 063a591f2h, 0da734f95h, 05de76934h
    05fe1613eh, 0dc79578bh, 07d87e994h, 0cd4a13deh
    07f81e19eh, 05aee752fh, 06cb4adc1h, 05ce46d31h
    0f704fb0ch, 0266a98beh, 0ff1cdb24h, 0ed2a937eh
    0e825876fh, 09dba4ed3h, 06fb1a1ceh, 08e8f028ch
    0192b647dh, 0a0fdba1ah, 0f00de717h, 089861e97h
    00f113c33h, 007091c1bh, 0afec8629h, 0fb10cb30h
    008182028h, 0153f5441h, 00d173439h, 0040c1014h
    001030405h, 064ac8de9h, 0df7c5b84h, 0769ac5b3h
    0798bf980h, 0dd7a538eh, 03d47f4c9h, 0163a584eh
    03f41fcc3h, 03759dcebh, 06db7a9c4h, 03848e0d8h
    0b9d6de67h, 07395d1a2h, 0e926836ah, 0355fd4e1h
    055ff491ch, 07193d9a8h, 07b8df18ah, 08c890a86h
    07296d5a7h, 088851a92h, 0f607ff09h, 02a7ea882h
    03e42f8c6h, 05ee2653bh, 027699cbbh, 046ca0543h
    00c14303ch, 065af89ech, 068b8bdd5h, 061a399f8h
    003050c0fh, 0c15e23e2h, 057f94116h, 0d6677fa9h
    0d976439ah, 058e87d25h, 0d875479fh, 066aa85e3h
    0d7647bach, 03a4ee8d2h, 0c84507cfh, 03c44f0cch
    0fa13cf35h, 096a762f4h, 0a7f4a601h, 098b55ac2h
    0ec29977bh, 0b8d5da62h, 0c7543bfch, 0aeef822ch
    069bbb9d0h, 04bdd317ah, 0abe0963dh, 0a9e69e37h
    067a981e6h, 00a1e2822h, 047c90146h, 0f20bef1dh
    0b5c2ee5bh, 0226688aah, 0e532b356h, 0ee2f9f71h
    0bedfc27ch, 02b7dac87h, 0819e3ebfh, 01236485ah
    0839836b5h, 01b2d6c77h, 00e123836h, 023658cafh
    0f502f306h, 045cf094ch, 0216384a5h, 0ce4f1fd1h
    049db3970h, 02c74b09ch, 0f916c33ah, 0e637bf59h
    0b6c7e254h, 02878a088h, 017395c4bh, 0829b32b0h
    01a2e6872h, 08b80169dh, 0fe1fdf21h, 08a831298h
    0091b242dh, 0c94603cah, 0879426a1h, 04ed2256bh
    0e13ea342h, 02e72b896h, 0e431b753h, 0e03da747h
    0eb208b60h, 090ad7aeah, 0a4f1aa0eh, 01e227866h
    085922eabh, 060a09dfdh, 000000000h, 0256f94b1h
    0f401f703h, 0f10ee312h, 094a16afeh, 00b1d2c27h
    0e734bb5ch, 0759fc9bch, 0ef2c9b74h, 0345cd0e4h
    03153c4f5h, 0d46177a3h, 0d06d67b7h, 0869722a4h
    07e82e59bh, 0adea8e23h, 0fd1ad32eh, 0297ba48dh
    03050c0f0h, 03b4decd7h, 09fbc46d9h, 0f815c73fh
    0c6573ff9h, 013354c5fh, 0060a181eh, 0050f1411h
    0c55233f6h, 011334455h, 07799c1b6h, 07c84ed91h
    07a8ef58fh, 07888fd85h, 0365ad8eeh, 01c24706ch
    0394be4ddh, 059eb7920h, 018286078h, 056fa4513h
    0b3c8f645h, 0b0cdfa4ah, 0246c90b4h, 0206080a0h
    0b2cbf240h, 092ab72e0h, 0a3f8b615h, 0c05d27e7h
    044cc0d49h, 062a695f7h, 010304050h, 0b4c1ea5eh
    084912aaeh, 043c51152h, 093a876e5h, 0c25b2fedh
    04ade357fh, 0bddace73h, 08f8c0689h, 02d77b499h
    0bcd9ca76h, 09cb94ad6h, 06abeb5dfh, 040c01d5dh
    0cf4c1bd4h, 0a2fbb210h, 0809d3abah, 04fd1216eh
    01f217c63h, 0ca430fc5h, 0aae39238h, 042c61557h

###############################################################################

TITLE
    khazad_V0

TYPE
    32 HEX NOBIG

DATA
    0bbb96a01h, 0e59a66b1h, 0e26514cdh, 025871b51h
    0f7a257a4h, 0d0d6be03h, 0d6deb504h, 0b35285feh
    0fdba4aadh, 0cf09e063h, 0091c9684h, 0a5914d1ah
    03da7374dh, 0f1aa5ca3h, 07ba417e1h, 0b55a8ef9h
    0460320ach, 0c4e68411h, 055cc68c2h, 0dcc6a80dh
    0aa85d099h, 0fbb241aah, 0c7e20f9ch, 0f359ae55h
    0febec120h, 0ad7aa2e5h, 0d729cc7fh, 071bc0ae8h
    0e096e63bh, 0ac8ddb9eh, 095d11522h, 032b3aaceh
    0704b7393h, 063843bfdh, 041fc52d0h, 07dac1ce6h
    076437894h, 0bdb16106h, 09b32f1dah, 07957e517h
    0f941b35ch, 08016564bh, 0677fc20ch, 059dc7ecch
    0e1619f40h, 010cbc3e3h, 081e12f30h, 00c10160eh
    0922e675eh, 0a26e3f66h, 04ee8cf53h, 078a09c6ch
    0b0560e73h, 0573f9a34h, 0e69eed3ch, 0d3d2358eh
    0dfc22380h, 0f2aed72eh, 013cf486eh, 094266c59h
    01fdf5e60h, 0c1ea049bh, 07547f319h, 0d5da3e89h
    008ebefffh, 0d42d47f2h, 038abb7c7h, 0543b11b9h
    04a1336a2h, 0699c26f4h, 07f5fee10h, 003048b8dh
    056c8e34fh, 0e7699447h, 01ad3deeah, 0113cba98h
    02278692dh, 012383115h, 0c511fd6ah, 0208b9bdbh
    030405838h, 07ea8976bh, 02e687f23h, 018202c1ch
    006080b07h, 04507ab21h, 0f8b6ca27h, 029970d5fh
    00bef6472h, 0f4a6dc29h, 08ef5b2b3h, 074b08a62h
    082e5a4bdh, 0b2a5fc85h, 0734ff81eh, 090dd95a8h
    0b1a17708h, 037bf2a44h, 04c1b3da5h, 0beb5ea8bh
    0e3926db6h, 03baf3c4ah, 007ff727ch, 00f149d83h
    031b72143h, 01734b19fh, 00ee3e4f8h, 0fc4d33d6h
    084edafbah, 0d9ca2887h, 0d2254cf5h, 0890ac0cfh
    028607424h, 0430fa026h, 06d67df05h, 05b2f8c3ah
    00a181d09h, 0bc46187dh, 0ef827bb8h, 0cefe9918h
    0ec86f035h, 0cdfa1295h, 0ea8efb32h, 04917bd2fh
    0c8f6921fh, 09ccd83a6h, 08a0e4b42h, 088fdb9b4h
    0268390dch, 053c463c5h, 0f551a552h, 077b401efh
    052331abeh, 0b7a97c0fh, 0a876226fh, 0c319f66dh
    06b6fd402h, 0a762bfech, 0dd31d176h, 0d121c778h
    04f1fb628h, 03c504e36h, 08f02cbc8h, 016c3c8e4h
    099c1032ch, 0cc0d6beeh, 0647b4981h, 05e230cb0h
    0a399461dh, 0fa4538d1h, 0217ce2a0h, 06c90a67eh
    02d6cf4aeh, 05ad8f541h, 02470622ah, 0ca0560e9h
    004fbf9f1h, 08312ddc6h, 0c61576e7h, 09e3e7150h
    0ab72a9e2h, 0e87d09c4h, 02c9b8dd5h, 06e635488h
    093d91e25h, 0f05d25d8h, 072b88165h, 02b64ffa9h
    05cd0fe46h, 01d2cac96h, 03ea3bcc0h, 01b24a791h
    03648533fh, 08c064045h, 0354cd8b2h, 0b94a98f7h
    07c5b659dh, 0e46d1fcah, 062734286h, 07a536e9ah
    0400b2babh, 047f459d7h, 0ff49b85bh, 044f0d25ah
    0395ccebch, 05d27873dh, 000000000h, 0de355afbh
    002f3f2f6h, 01cdbd5edh, 05fd475cbh, 03a584531h
    0686b5f8fh, 0238f1056h, 0582b07b7h, 0b8bde18ch
    0a695c697h, 0c2ee8f16h, 0dacea30ah, 03344d3b5h
    019d75567h, 0c901eb64h, 034bba1c9h, 0f6552edfh
    0a09dcd90h, 09ac588a1h, 0658c30fah, 02a9386d2h
    0ae7e2968h, 06a98ad79h, 014303a12h, 01e28271bh
    0a4663461h, 06688bb77h, 02f9f0658h, 015c74369h
    001f7797bh, 00de76f75h, 0b4adf782h, 048e0c454h
    096d59eafh, 0cbf21992h, 050c0e848h, 0e98a70bfh
    08df1393eh, 087e92437h, 0d83d51fch, 0c01d7de0h
    08bf93239h, 04be44fd9h, 0ed71894eh, 0ba4e137ah
    0851ad6c1h, 051379133h, 06080b070h, 09fc9082bh
    03f54c5bbh, 09722e7d4h, 04dec44deh, 0b65e0574h
    0a16ab4ebh, 0a9815b14h, 0050c808ah, 0ee7502c3h
    0af895013h, 06f942df3h, 06177c90bh, 09d3afaddh
    098367a57h, 0eb798249h, 02774e9a7h, 0bf4293f0h
    042f8d95dh, 0861e5d4ch, 0db39da71h, 0912aecd3h

###############################################################################

TITLE
    khazad_U1

TYPE
    32 HEX NOBIG

DATA
    0d3ba68d2h, 0fc54194dh, 0712f93bch, 09c74b9cdh
    0f5530251h, 068d3b86bh, 06bd2bd6fh, 0d74d6429h
    0f0500d5dh, 0e9ac268ah, 08a8d830eh, 0dcbf79c6h
    09070adddh, 0f6520755h, 0b39ac852h, 0d44c612dh
    023ea658fh, 062d5a673h, 0a497f166h, 06ed1b263h
    05533ffcch, 0f3510859h, 0ed5b2a71h, 0f7a604a2h
    07fde815fh, 0d848753dh, 0e5a8329ah, 0b699c75eh
    070db904bh, 05632fac8h, 0c4b751e6h, 019fc2bd7h
    038e348abh, 0bf9edc42h, 0ae91ef7eh, 0b09bcd56h
    03be24dafh, 0d0bb6dd6h, 0c3415819h, 0b26ecba5h
    0f2a50baeh, 040cbc00bh, 0bd6bdab1h, 0a295fb6eh
    0fea11fbeh, 008f318ebh, 0ceb14ffeh, 006020a08h
    049ccdb17h, 051c4f337h, 0271d6974h, 03c144450h
    058c3e82bh, 0a563f291h, 073da954fh, 0e75d3469h
    0e15f3e61h, 079dc8b57h, 0877d94e9h, 04acdde13h
    0817f9ee1h, 0ee5a2f75h, 0b46cc1adh, 0e45c316dh
    004f70cfbh, 06a26be98h, 01cff24dbh, 02aed7e93h
    025e86f87h, 0ba9dd34eh, 0b16fcea1h, 08f8e8c02h
    02b197d64h, 0fda01abah, 00df017e7h, 08689971eh
    0110f333ch, 009071b1ch, 0ecaf2986h, 010fb30cbh
    018082820h, 03f154154h, 0170d3934h, 00c041410h
    003010504h, 0ac64e98dh, 07cdf845bh, 09a76b3c5h
    08b7980f9h, 07add8e53h, 0473dc9f4h, 03a164e58h
    0413fc3fch, 05937ebdch, 0b76dc4a9h, 04838d8e0h
    0d6b967deh, 09573a2d1h, 026e96a83h, 05f35e1d4h
    0ff551c49h, 09371a8d9h, 08d7b8af1h, 0898c860ah
    09672a7d5h, 08588921ah, 007f609ffh, 07e2a82a8h
    0423ec6f8h, 0e25e3b65h, 06927bb9ch, 0ca464305h
    0140c3c30h, 0af65ec89h, 0b868d5bdh, 0a361f899h
    005030f0ch, 05ec1e223h, 0f9571641h, 067d6a97fh
    076d99a43h, 0e858257dh, 075d89f47h, 0aa66e385h
    064d7ac7bh, 04e3ad2e8h, 045c8cf07h, 0443cccf0h
    013fa35cfh, 0a796f462h, 0f4a701a6h, 0b598c25ah
    029ec7b97h, 0d5b862dah, 054c7fc3bh, 0efae2c82h
    0bb69d0b9h, 0dd4b7a31h, 0e0ab3d96h, 0e6a9379eh
    0a967e681h, 01e0a2228h, 0c9474601h, 00bf21defh
    0c2b55beeh, 06622aa88h, 032e556b3h, 02fee719fh
    0dfbe7cc2h, 07d2b87ach, 09e81bf3eh, 036125a48h
    09883b536h, 02d1b776ch, 0120e3638h, 06523af8ch
    002f506f3h, 0cf454c09h, 06321a584h, 04fced11fh
    0db497039h, 0742c9cb0h, 016f93ac3h, 037e659bfh
    0c7b654e2h, 0782888a0h, 039174b5ch, 09b82b032h
    02e1a7268h, 0808b9d16h, 01ffe21dfh, 0838a9812h
    01b092d24h, 046c9ca03h, 09487a126h, 0d24e6b25h
    03ee142a3h, 0722e96b8h, 031e453b7h, 03de047a7h
    020eb608bh, 0ad90ea7ah, 0f1a40eaah, 0221e6678h
    09285ab2eh, 0a060fd9dh, 000000000h, 06f25b194h
    001f403f7h, 00ef112e3h, 0a194fe6ah, 01d0b272ch
    034e75cbbh, 09f75bcc9h, 02cef749bh, 05c34e4d0h
    05331f5c4h, 061d4a377h, 06dd0b767h, 09786a422h
    0827e9be5h, 0eaad238eh, 01afd2ed3h, 07b298da4h
    05030f0c0h, 04d3bd7ech, 0bc9fd946h, 015f83fc7h
    057c6f93fh, 035135f4ch, 00a061e18h, 00f051114h
    052c5f633h, 033115544h, 09977b6c1h, 0847c91edh
    08e7a8ff5h, 0887885fdh, 05a36eed8h, 0241c6c70h
    04b39dde4h, 0eb592079h, 028187860h, 0fa561345h
    0c8b345f6h, 0cdb04afah, 06c24b490h, 06020a080h
    0cbb240f2h, 0ab92e072h, 0f8a315b6h, 05dc0e727h
    0cc44490dh, 0a662f795h, 030105040h, 0c1b45eeah
    09184ae2ah, 0c5435211h, 0a893e576h, 05bc2ed2fh
    0de4a7f35h, 0dabd73ceh, 08c8f8906h, 0772d99b4h
    0d9bc76cah, 0b99cd64ah, 0be6adfb5h, 0c0405d1dh
    04ccfd41bh, 0fba210b2h, 09d80ba3ah, 0d14f6e21h
    0211f637ch, 043cac50fh, 0e3aa3892h, 0c6425715h

###############################################################################

TITLE
    khazad_V1

TYPE
    32 HEX NOBIG

DATA
    0b9bb016ah, 09ae5b166h, 065e2cd14h, 08725511bh
    0a2f7a457h, 0d6d003beh, 0ded604b5h, 052b3fe85h
    0bafdad4ah, 009cf63e0h, 01c098496h, 091a51a4dh
    0a73d4d37h, 0aaf1a35ch, 0a47be117h, 05ab5f98eh
    00346ac20h, 0e6c41184h, 0cc55c268h, 0c6dc0da8h
    085aa99d0h, 0b2fbaa41h, 0e2c79c0fh, 059f355aeh
    0befe20c1h, 07aade5a2h, 029d77fcch, 0bc71e80ah
    096e03be6h, 08dac9edbh, 0d1952215h, 0b332ceaah
    04b709373h, 08463fd3bh, 0fc41d052h, 0ac7de61ch
    043769478h, 0b1bd0661h, 0329bdaf1h, 0577917e5h
    041f95cb3h, 016804b56h, 07f670cc2h, 0dc59cc7eh
    061e1409fh, 0cb10e3c3h, 0e181302fh, 0100c0e16h
    02e925e67h, 06ea2663fh, 0e84e53cfh, 0a0786c9ch
    056b0730eh, 03f57349ah, 09ee63cedh, 0d2d38e35h
    0c2df8023h, 0aef22ed7h, 0cf136e48h, 02694596ch
    0df1f605eh, 0eac19b04h, 0477519f3h, 0dad5893eh
    0eb08ffefh, 02dd4f247h, 0ab38c7b7h, 03b54b911h
    0134aa236h, 09c69f426h, 05f7f10eeh, 004038d8bh
    0c8564fe3h, 069e74794h, 0d31aeadeh, 03c1198bah
    078222d69h, 038121531h, 011c56afdh, 08b20db9bh
    040303858h, 0a87e6b97h, 0682e237fh, 020181c2ch
    00806070bh, 0074521abh, 0b6f827cah, 097295f0dh
    0ef0b7264h, 0a6f429dch, 0f58eb3b2h, 0b074628ah
    0e582bda4h, 0a5b285fch, 04f731ef8h, 0dd90a895h
    0a1b10877h, 0bf37442ah, 01b4ca53dh, 0b5be8beah
    092e3b66dh, 0af3b4a3ch, 0ff077c72h, 0140f839dh
    0b7314321h, 034179fb1h, 0e30ef8e4h, 04dfcd633h
    0ed84baafh, 0cad98728h, 025d2f54ch, 00a89cfc0h
    060282474h, 00f4326a0h, 0676d05dfh, 02f5b3a8ch
    0180a091dh, 046bc7d18h, 082efb87bh, 0fece1899h
    086ec35f0h, 0facd9512h, 08eea32fbh, 017492fbdh
    0f6c81f92h, 0cd9ca683h, 00e8a424bh, 0fd88b4b9h
    08326dc90h, 0c453c563h, 051f552a5h, 0b477ef01h
    03352be1ah, 0a9b70f7ch, 076a86f22h, 019c36df6h
    06f6b02d4h, 062a7ecbfh, 031dd76d1h, 021d178c7h
    01f4f28b6h, 0503c364eh, 0028fc8cbh, 0c316e4c8h
    0c1992c03h, 00dccee6bh, 07b648149h, 0235eb00ch
    099a31d46h, 045fad138h, 07c21a0e2h, 0906c7ea6h
    06c2daef4h, 0d85a41f5h, 070242a62h, 005cae960h
    0fb04f1f9h, 01283c6ddh, 015c6e776h, 03e9e5071h
    072abe2a9h, 07de8c409h, 09b2cd58dh, 0636e8854h
    0d993251eh, 05df0d825h, 0b8726581h, 0642ba9ffh
    0d05c46feh, 02c1d96ach, 0a33ec0bch, 0241b91a7h
    048363f53h, 0068c4540h, 04c35b2d8h, 04ab9f798h
    05b7c9d65h, 06de4ca1fh, 073628642h, 0537a9a6eh
    00b40ab2bh, 0f447d759h, 049ff5bb8h, 0f0445ad2h
    05c39bcceh, 0275d3d87h, 000000000h, 035defb5ah
    0f302f6f2h, 0db1cedd5h, 0d45fcb75h, 0583a3145h
    06b688f5fh, 08f235610h, 02b58b707h, 0bdb88ce1h
    095a697c6h, 0eec2168fh, 0ceda0aa3h, 04433b5d3h
    0d7196755h, 001c964ebh, 0bb34c9a1h, 055f6df2eh
    09da090cdh, 0c59aa188h, 08c65fa30h, 0932ad286h
    07eae6829h, 0986a79adh, 03014123ah, 0281e1b27h
    066a46134h, 0886677bbh, 09f2f5806h, 0c7156943h
    0f7017b79h, 0e70d756fh, 0adb482f7h, 0e04854c4h
    0d596af9eh, 0f2cb9219h, 0c05048e8h, 08ae9bf70h
    0f18d3e39h, 0e9873724h, 03dd8fc51h, 01dc0e07dh
    0f98b3932h, 0e44bd94fh, 071ed4e89h, 04eba7a13h
    01a85c1d6h, 037513391h, 0806070b0h, 0c99f2b08h
    0543fbbc5h, 02297d4e7h, 0ec4dde44h, 05eb67405h
    06aa1ebb4h, 081a9145bh, 00c058a80h, 075eec302h
    089af1350h, 0946ff32dh, 077610bc9h, 03a9dddfah
    03698577ah, 079eb4982h, 07427a7e9h, 042bff093h
    0f8425dd9h, 01e864c5dh, 039db71dah, 02a91d3ech

###############################################################################

TITLE
    khazad_U2

TYPE
    32 HEX NOBIG

DATA
    0d268bad3h, 04d1954fch, 0bc932f71h, 0cdb9749ch 
    0510253f5h, 06bb8d368h, 06fbdd26bh, 029644dd7h 
    05d0d50f0h, 08a26ace9h, 00e838d8ah, 0c679bfdch 
    0ddad7090h, 0550752f6h, 052c89ab3h, 02d614cd4h 
    08f65ea23h, 073a6d562h, 066f197a4h, 063b2d16eh 
    0ccff3355h, 0590851f3h, 0712a5bedh, 0a204a6f7h 
    05f81de7fh, 03d7548d8h, 09a32a8e5h, 05ec799b6h 
    04b90db70h, 0c8fa3256h, 0e651b7c4h, 0d72bfc19h 
    0ab48e338h, 042dc9ebfh, 07eef91aeh, 056cd9bb0h 
    0af4de23bh, 0d66dbbd0h, 0195841c3h, 0a5cb6eb2h 
    0ae0ba5f2h, 00bc0cb40h, 0b1da6bbdh, 06efb95a2h 
    0be1fa1feh, 0eb18f308h, 0fe4fb1ceh, 0080a0206h 
    017dbcc49h, 037f3c451h, 074691d27h, 05044143ch 
    02be8c358h, 091f263a5h, 04f95da73h, 069345de7h 
    0613e5fe1h, 0578bdc79h, 0e9947d87h, 013decd4ah 
    0e19e7f81h, 0752f5aeeh, 0adc16cb4h, 06d315ce4h 
    0fb0cf704h, 098be266ah, 0db24ff1ch, 0937eed2ah 
    0876fe825h, 04ed39dbah, 0a1ce6fb1h, 0028c8e8fh 
    0647d192bh, 0ba1aa0fdh, 0e717f00dh, 01e978986h 
    03c330f11h, 01c1b0709h, 08629afech, 0cb30fb10h 
    020280818h, 05441153fh, 034390d17h, 01014040ch 
    004050103h, 08de964ach, 05b84df7ch, 0c5b3769ah 
    0f980798bh, 0538edd7ah, 0f4c93d47h, 0584e163ah 
    0fcc33f41h, 0dceb3759h, 0a9c46db7h, 0e0d83848h 
    0de67b9d6h, 0d1a27395h, 0836ae926h, 0d4e1355fh 
    0491c55ffh, 0d9a87193h, 0f18a7b8dh, 00a868c89h 
    0d5a77296h, 01a928885h, 0ff09f607h, 0a8822a7eh 
    0f8c63e42h, 0653b5ee2h, 09cbb2769h, 0054346cah 
    0303c0c14h, 089ec65afh, 0bdd568b8h, 099f861a3h 
    00c0f0305h, 023e2c15eh, 0411657f9h, 07fa9d667h 
    0439ad976h, 07d2558e8h, 0479fd875h, 085e366aah 
    07bacd764h, 0e8d23a4eh, 007cfc845h, 0f0cc3c44h 
    0cf35fa13h, 062f496a7h, 0a601a7f4h, 05ac298b5h 
    0977bec29h, 0da62b8d5h, 03bfcc754h, 0822caeefh 
    0b9d069bbh, 0317a4bddh, 0963dabe0h, 09e37a9e6h 
    081e667a9h, 028220a1eh, 0014647c9h, 0ef1df20bh 
    0ee5bb5c2h, 088aa2266h, 0b356e532h, 09f71ee2fh 
    0c27cbedfh, 0ac872b7dh, 03ebf819eh, 0485a1236h 
    036b58398h, 06c771b2dh, 038360e12h, 08caf2365h 
    0f306f502h, 0094c45cfh, 084a52163h, 01fd1ce4fh 
    0397049dbh, 0b09c2c74h, 0c33af916h, 0bf59e637h 
    0e254b6c7h, 0a0882878h, 05c4b1739h, 032b0829bh 
    068721a2eh, 0169d8b80h, 0df21fe1fh, 012988a83h 
    0242d091bh, 003cac946h, 026a18794h, 0256b4ed2h 
    0a342e13eh, 0b8962e72h, 0b753e431h, 0a747e03dh 
    08b60eb20h, 07aea90adh, 0aa0ea4f1h, 078661e22h 
    02eab8592h, 09dfd60a0h, 000000000h, 094b1256fh 
    0f703f401h, 0e312f10eh, 06afe94a1h, 02c270b1dh 
    0bb5ce734h, 0c9bc759fh, 09b74ef2ch, 0d0e4345ch 
    0c4f53153h, 077a3d461h, 067b7d06dh, 022a48697h 
    0e59b7e82h, 08e23adeah, 0d32efd1ah, 0a48d297bh 
    0c0f03050h, 0ecd73b4dh, 046d99fbch, 0c73ff815h 
    03ff9c657h, 04c5f1335h, 0181e060ah, 01411050fh 
    033f6c552h, 044551133h, 0c1b67799h, 0ed917c84h 
    0f58f7a8eh, 0fd857888h, 0d8ee365ah, 0706c1c24h 
    0e4dd394bh, 0792059ebh, 060781828h, 0451356fah 
    0f645b3c8h, 0fa4ab0cdh, 090b4246ch, 080a02060h 
    0f240b2cbh, 072e092abh, 0b615a3f8h, 027e7c05dh 
    00d4944cch, 095f762a6h, 040501030h, 0ea5eb4c1h 
    02aae8491h, 0115243c5h, 076e593a8h, 02fedc25bh 
    0357f4adeh, 0ce73bddah, 006898f8ch, 0b4992d77h 
    0ca76bcd9h, 04ad69cb9h, 0b5df6abeh, 01d5d40c0h 
    01bd4cf4ch, 0b210a2fbh, 03aba809dh, 0216e4fd1h 
    07c631f21h, 00fc5ca43h, 09238aae3h, 0155742c6h 

###############################################################################

TITLE
    khazad_V2

TYPE
    32 HEX NOBIG

DATA
    06a01bbb9h, 066b1e59ah, 014cde265h, 01b512587h 
    057a4f7a2h, 0be03d0d6h, 0b504d6deh, 085feb352h 
    04aadfdbah, 0e063cf09h, 09684091ch, 04d1aa591h 
    0374d3da7h, 05ca3f1aah, 017e17ba4h, 08ef9b55ah 
    020ac4603h, 08411c4e6h, 068c255cch, 0a80ddcc6h 
    0d099aa85h, 041aafbb2h, 00f9cc7e2h, 0ae55f359h 
    0c120febeh, 0a2e5ad7ah, 0cc7fd729h, 00ae871bch 
    0e63be096h, 0db9eac8dh, 0152295d1h, 0aace32b3h 
    07393704bh, 03bfd6384h, 052d041fch, 01ce67dach 
    078947643h, 06106bdb1h, 0f1da9b32h, 0e5177957h 
    0b35cf941h, 0564b8016h, 0c20c677fh, 07ecc59dch 
    09f40e161h, 0c3e310cbh, 02f3081e1h, 0160e0c10h 
    0675e922eh, 03f66a26eh, 0cf534ee8h, 09c6c78a0h 
    00e73b056h, 09a34573fh, 0ed3ce69eh, 0358ed3d2h 
    02380dfc2h, 0d72ef2aeh, 0486e13cfh, 06c599426h 
    05e601fdfh, 0049bc1eah, 0f3197547h, 03e89d5dah 
    0efff08ebh, 047f2d42dh, 0b7c738abh, 011b9543bh 
    036a24a13h, 026f4699ch, 0ee107f5fh, 08b8d0304h 
    0e34f56c8h, 09447e769h, 0deea1ad3h, 0ba98113ch 
    0692d2278h, 031151238h, 0fd6ac511h, 09bdb208bh 
    058383040h, 0976b7ea8h, 07f232e68h, 02c1c1820h 
    00b070608h, 0ab214507h, 0ca27f8b6h, 00d5f2997h 
    064720befh, 0dc29f4a6h, 0b2b38ef5h, 08a6274b0h 
    0a4bd82e5h, 0fc85b2a5h, 0f81e734fh, 095a890ddh 
    07708b1a1h, 02a4437bfh, 03da54c1bh, 0ea8bbeb5h 
    06db6e392h, 03c4a3bafh, 0727c07ffh, 09d830f14h 
    0214331b7h, 0b19f1734h, 0e4f80ee3h, 033d6fc4dh 
    0afba84edh, 02887d9cah, 04cf5d225h, 0c0cf890ah 
    074242860h, 0a026430fh, 0df056d67h, 08c3a5b2fh 
    01d090a18h, 0187dbc46h, 07bb8ef82h, 09918cefeh 
    0f035ec86h, 01295cdfah, 0fb32ea8eh, 0bd2f4917h 
    0921fc8f6h, 083a69ccdh, 04b428a0eh, 0b9b488fdh 
    090dc2683h, 063c553c4h, 0a552f551h, 001ef77b4h 
    01abe5233h, 07c0fb7a9h, 0226fa876h, 0f66dc319h 
    0d4026b6fh, 0bfeca762h, 0d176dd31h, 0c778d121h 
    0b6284f1fh, 04e363c50h, 0cbc88f02h, 0c8e416c3h 
    0032c99c1h, 06beecc0dh, 04981647bh, 00cb05e23h 
    0461da399h, 038d1fa45h, 0e2a0217ch, 0a67e6c90h 
    0f4ae2d6ch, 0f5415ad8h, 0622a2470h, 060e9ca05h 
    0f9f104fbh, 0ddc68312h, 076e7c615h, 071509e3eh 
    0a9e2ab72h, 009c4e87dh, 08dd52c9bh, 054886e63h 
    01e2593d9h, 025d8f05dh, 0816572b8h, 0ffa92b64h 
    0fe465cd0h, 0ac961d2ch, 0bcc03ea3h, 0a7911b24h 
    0533f3648h, 040458c06h, 0d8b2354ch, 098f7b94ah 
    0659d7c5bh, 01fcae46dh, 042866273h, 06e9a7a53h 
    02bab400bh, 059d747f4h, 0b85bff49h, 0d25a44f0h 
    0cebc395ch, 0873d5d27h, 000000000h, 05afbde35h 
    0f2f602f3h, 0d5ed1cdbh, 075cb5fd4h, 045313a58h 
    05f8f686bh, 01056238fh, 007b7582bh, 0e18cb8bdh 
    0c697a695h, 08f16c2eeh, 0a30adaceh, 0d3b53344h 
    0556719d7h, 0eb64c901h, 0a1c934bbh, 02edff655h 
    0cd90a09dh, 088a19ac5h, 030fa658ch, 086d22a93h 
    02968ae7eh, 0ad796a98h, 03a121430h, 0271b1e28h 
    03461a466h, 0bb776688h, 006582f9fh, 0436915c7h 
    0797b01f7h, 06f750de7h, 0f782b4adh, 0c45448e0h 
    09eaf96d5h, 01992cbf2h, 0e84850c0h, 070bfe98ah 
    0393e8df1h, 0243787e9h, 051fcd83dh, 07de0c01dh 
    032398bf9h, 04fd94be4h, 0894eed71h, 0137aba4eh 
    0d6c1851ah, 091335137h, 0b0706080h, 0082b9fc9h 
    0c5bb3f54h, 0e7d49722h, 044de4dech, 00574b65eh 
    0b4eba16ah, 05b14a981h, 0808a050ch, 002c3ee75h 
    05013af89h, 02df36f94h, 0c90b6177h, 0fadd9d3ah 
    07a579836h, 08249eb79h, 0e9a72774h, 093f0bf42h 
    0d95d42f8h, 05d4c861eh, 0da71db39h, 0ecd3912ah 

###############################################################################

TITLE
    khazad_U3

TYPE
    32 HEX NOBIG

DATA
    068d2d3bah, 0194dfc54h, 093bc712fh, 0b9cd9c74h 
    00251f553h, 0b86b68d3h, 0bd6f6bd2h, 06429d74dh 
    00d5df050h, 0268ae9ach, 0830e8a8dh, 079c6dcbfh 
    0addd9070h, 00755f652h, 0c852b39ah, 0612dd44ch 
    0658f23eah, 0a67362d5h, 0f166a497h, 0b2636ed1h 
    0ffcc5533h, 00859f351h, 02a71ed5bh, 004a2f7a6h 
    0815f7fdeh, 0753dd848h, 0329ae5a8h, 0c75eb699h 
    0904b70dbh, 0fac85632h, 051e6c4b7h, 02bd719fch 
    048ab38e3h, 0dc42bf9eh, 0ef7eae91h, 0cd56b09bh 
    04daf3be2h, 06dd6d0bbh, 05819c341h, 0cba5b26eh 
    00baef2a5h, 0c00b40cbh, 0dab1bd6bh, 0fb6ea295h 
    01fbefea1h, 018eb08f3h, 04ffeceb1h, 00a080602h 
    0db1749cch, 0f33751c4h, 06974271dh, 044503c14h 
    0e82b58c3h, 0f291a563h, 0954f73dah, 03469e75dh 
    03e61e15fh, 08b5779dch, 094e9877dh, 0de134acdh 
    09ee1817fh, 02f75ee5ah, 0c1adb46ch, 0316de45ch 
    00cfb04f7h, 0be986a26h, 024db1cffh, 07e932aedh 
    06f8725e8h, 0d34eba9dh, 0cea1b16fh, 08c028f8eh 
    07d642b19h, 01abafda0h, 017e70df0h, 0971e8689h 
    0333c110fh, 01b1c0907h, 02986ecafh, 030cb10fbh 
    028201808h, 041543f15h, 03934170dh, 014100c04h 
    005040301h, 0e98dac64h, 0845b7cdfh, 0b3c59a76h 
    080f98b79h, 08e537addh, 0c9f4473dh, 04e583a16h 
    0c3fc413fh, 0ebdc5937h, 0c4a9b76dh, 0d8e04838h 
    067ded6b9h, 0a2d19573h, 06a8326e9h, 0e1d45f35h 
    01c49ff55h, 0a8d99371h, 08af18d7bh, 0860a898ch 
    0a7d59672h, 0921a8588h, 009ff07f6h, 082a87e2ah 
    0c6f8423eh, 03b65e25eh, 0bb9c6927h, 04305ca46h 
    03c30140ch, 0ec89af65h, 0d5bdb868h, 0f899a361h 
    00f0c0503h, 0e2235ec1h, 01641f957h, 0a97f67d6h 
    09a4376d9h, 0257de858h, 09f4775d8h, 0e385aa66h 
    0ac7b64d7h, 0d2e84e3ah, 0cf0745c8h, 0ccf0443ch 
    035cf13fah, 0f462a796h, 001a6f4a7h, 0c25ab598h 
    07b9729ech, 062dad5b8h, 0fc3b54c7h, 02c82efaeh 
    0d0b9bb69h, 07a31dd4bh, 03d96e0abh, 0379ee6a9h 
    0e681a967h, 022281e0ah, 04601c947h, 01def0bf2h 
    05beec2b5h, 0aa886622h, 056b332e5h, 0719f2feeh 
    07cc2dfbeh, 087ac7d2bh, 0bf3e9e81h, 05a483612h 
    0b5369883h, 0776c2d1bh, 03638120eh, 0af8c6523h 
    006f302f5h, 04c09cf45h, 0a5846321h, 0d11f4fceh 
    07039db49h, 09cb0742ch, 03ac316f9h, 059bf37e6h 
    054e2c7b6h, 088a07828h, 04b5c3917h, 0b0329b82h 
    072682e1ah, 09d16808bh, 021df1ffeh, 09812838ah 
    02d241b09h, 0ca0346c9h, 0a1269487h, 06b25d24eh 
    042a33ee1h, 096b8722eh, 053b731e4h, 047a73de0h 
    0608b20ebh, 0ea7aad90h, 00eaaf1a4h, 06678221eh 
    0ab2e9285h, 0fd9da060h, 000000000h, 0b1946f25h 
    003f701f4h, 012e30ef1h, 0fe6aa194h, 0272c1d0bh 
    05cbb34e7h, 0bcc99f75h, 0749b2cefh, 0e4d05c34h 
    0f5c45331h, 0a37761d4h, 0b7676dd0h, 0a4229786h 
    09be5827eh, 0238eeaadh, 02ed31afdh, 08da47b29h 
    0f0c05030h, 0d7ec4d3bh, 0d946bc9fh, 03fc715f8h 
    0f93f57c6h, 05f4c3513h, 01e180a06h, 011140f05h 
    0f63352c5h, 055443311h, 0b6c19977h, 091ed847ch 
    08ff58e7ah, 085fd8878h, 0eed85a36h, 06c70241ch 
    0dde44b39h, 02079eb59h, 078602818h, 01345fa56h 
    045f6c8b3h, 04afacdb0h, 0b4906c24h, 0a0806020h 
    040f2cbb2h, 0e072ab92h, 015b6f8a3h, 0e7275dc0h 
    0490dcc44h, 0f795a662h, 050403010h, 05eeac1b4h 
    0ae2a9184h, 05211c543h, 0e576a893h, 0ed2f5bc2h 
    07f35de4ah, 073cedabdh, 089068c8fh, 099b4772dh 
    076cad9bch, 0d64ab99ch, 0dfb5be6ah, 05d1dc040h 
    0d41b4ccfh, 010b2fba2h, 0ba3a9d80h, 06e21d14fh 
    0637c211fh, 0c50f43cah, 03892e3aah, 05715c642h 

###############################################################################

TITLE
    khazad_V3

TYPE
    32 HEX NOBIG

DATA
    0016ab9bbh, 0b1669ae5h, 0cd1465e2h, 0511b8725h 
    0a457a2f7h, 003bed6d0h, 004b5ded6h, 0fe8552b3h 
    0ad4abafdh, 063e009cfh, 084961c09h, 01a4d91a5h 
    04d37a73dh, 0a35caaf1h, 0e117a47bh, 0f98e5ab5h 
    0ac200346h, 01184e6c4h, 0c268cc55h, 00da8c6dch 
    099d085aah, 0aa41b2fbh, 09c0fe2c7h, 055ae59f3h 
    020c1befeh, 0e5a27aadh, 07fcc29d7h, 0e80abc71h 
    03be696e0h, 09edb8dach, 02215d195h, 0ceaab332h 
    093734b70h, 0fd3b8463h, 0d052fc41h, 0e61cac7dh 
    094784376h, 00661b1bdh, 0daf1329bh, 017e55779h 
    05cb341f9h, 04b561680h, 00cc27f67h, 0cc7edc59h 
    0409f61e1h, 0e3c3cb10h, 0302fe181h, 00e16100ch 
    05e672e92h, 0663f6ea2h, 053cfe84eh, 06c9ca078h 
    0730e56b0h, 0349a3f57h, 03ced9ee6h, 08e35d2d3h 
    08023c2dfh, 02ed7aef2h, 06e48cf13h, 0596c2694h 
    0605edf1fh, 09b04eac1h, 019f34775h, 0893edad5h 
    0ffefeb08h, 0f2472dd4h, 0c7b7ab38h, 0b9113b54h 
    0a236134ah, 0f4269c69h, 010ee5f7fh, 08d8b0403h 
    04fe3c856h, 0479469e7h, 0eaded31ah, 098ba3c11h 
    02d697822h, 015313812h, 06afd11c5h, 0db9b8b20h 
    038584030h, 06b97a87eh, 0237f682eh, 01c2c2018h 
    0070b0806h, 021ab0745h, 027cab6f8h, 05f0d9729h 
    07264ef0bh, 029dca6f4h, 0b3b2f58eh, 0628ab074h 
    0bda4e582h, 085fca5b2h, 01ef84f73h, 0a895dd90h 
    00877a1b1h, 0442abf37h, 0a53d1b4ch, 08beab5beh 
    0b66d92e3h, 04a3caf3bh, 07c72ff07h, 0839d140fh 
    04321b731h, 09fb13417h, 0f8e4e30eh, 0d6334dfch 
    0baafed84h, 08728cad9h, 0f54c25d2h, 0cfc00a89h 
    024746028h, 026a00f43h, 005df676dh, 03a8c2f5bh 
    0091d180ah, 07d1846bch, 0b87b82efh, 01899feceh 
    035f086ech, 09512facdh, 032fb8eeah, 02fbd1749h 
    01f92f6c8h, 0a683cd9ch, 0424b0e8ah, 0b4b9fd88h 
    0dc908326h, 0c563c453h, 052a551f5h, 0ef01b477h 
    0be1a3352h, 00f7ca9b7h, 06f2276a8h, 06df619c3h 
    002d46f6bh, 0ecbf62a7h, 076d131ddh, 078c721d1h 
    028b61f4fh, 0364e503ch, 0c8cb028fh, 0e4c8c316h 
    02c03c199h, 0ee6b0dcch, 081497b64h, 0b00c235eh 
    01d4699a3h, 0d13845fah, 0a0e27c21h, 07ea6906ch 
    0aef46c2dh, 041f5d85ah, 02a627024h, 0e96005cah 
    0f1f9fb04h, 0c6dd1283h, 0e77615c6h, 050713e9eh 
    0e2a972abh, 0c4097de8h, 0d58d9b2ch, 08854636eh 
    0251ed993h, 0d8255df0h, 06581b872h, 0a9ff642bh 
    046fed05ch, 096ac2c1dh, 0c0bca33eh, 091a7241bh 
    03f534836h, 04540068ch, 0b2d84c35h, 0f7984ab9h 
    09d655b7ch, 0ca1f6de4h, 086427362h, 09a6e537ah 
    0ab2b0b40h, 0d759f447h, 05bb849ffh, 05ad2f044h 
    0bcce5c39h, 03d87275dh, 000000000h, 0fb5a35deh 
    0f6f2f302h, 0edd5db1ch, 0cb75d45fh, 03145583ah 
    08f5f6b68h, 056108f23h, 0b7072b58h, 08ce1bdb8h 
    097c695a6h, 0168feec2h, 00aa3cedah, 0b5d34433h 
    06755d719h, 064eb01c9h, 0c9a1bb34h, 0df2e55f6h 
    090cd9da0h, 0a188c59ah, 0fa308c65h, 0d286932ah 
    068297eaeh, 079ad986ah, 0123a3014h, 01b27281eh 
    0613466a4h, 077bb8866h, 058069f2fh, 06943c715h 
    07b79f701h, 0756fe70dh, 082f7adb4h, 054c4e048h 
    0af9ed596h, 09219f2cbh, 048e8c050h, 0bf708ae9h 
    03e39f18dh, 03724e987h, 0fc513dd8h, 0e07d1dc0h 
    03932f98bh, 0d94fe44bh, 04e8971edh, 07a134ebah 
    0c1d61a85h, 033913751h, 070b08060h, 02b08c99fh 
    0bbc5543fh, 0d4e72297h, 0de44ec4dh, 074055eb6h 
    0ebb46aa1h, 0145b81a9h, 08a800c05h, 0c30275eeh 
    0135089afh, 0f32d946fh, 00bc97761h, 0ddfa3a9dh 
    0577a3698h, 0498279ebh, 0a7e97427h, 0f09342bfh 
    05dd9f842h, 04c5d1e86h, 071da39dbh, 0d3ec2a91h 

###############################################################################

TITLE
    khazad_c

TYPE
    32 HEX

DATA
    0ba542f74h, 053d3d24dh
    050ac8dbfh, 070529a4ch
    0ead597d1h, 033515ba6h
    0de48a899h, 0db32b7fch
    0e39e919bh, 0e2bb416eh
    0a5cb6b95h, 0a1f3b102h
    0ccc41d14h, 0c363da5dh
    05fdc7dcdh, 07f5a6c5ch
    0f726ffedh, 0e89d6f8eh

###############################################################################

TITLE
    MMB crypt algorithm

TYPE
    32 HEX AND

DATA
    025F1CDBh   04BE39B6h   12F8E6D8h   2F8E6D81h
    0DAD4694h   06D6A34Ah   81B5A8D2h   281B5A8Dh
    2AAAAAAAh

###############################################################################

TITLE
    newdes_rotor

TYPE
    8

DATA
    32,137,239,188,102,125,221, 72,212, 68, 81, 37, 86,237,147,149
    70,229, 17,124,115,207, 33, 20,122,143, 25,215, 51,183,138,142
    146,211,110,173,  1,228,189, 14,103, 78,162, 36,253,167,116,255
    158, 45,185, 50, 98,168,250,235, 54,141,195,247,240, 63,148,  2
    224,169,214,180, 62, 22,117,108, 19,172,161,159,160, 47, 43,171
    194,175,178, 56,196,112, 23,220, 89, 21,164,130,157,  8, 85,251
    216, 44, 94,179,226, 38, 90,119, 40,202, 34,206, 35, 69,231,246
    29,109, 74, 71,176,  6, 60,145, 65, 13, 77,151, 12,127, 95,199
    57,101,  5,232,150,210,129, 24,181, 10,121,187, 48,193,139,252
    219, 64, 88,233, 96,128, 80, 53,191,144,218, 11,106,132,155,104
    91,136, 31, 42,243, 66,126,135, 30, 26, 87,186,182,154,242,123
    82,166,208, 39,152,190,113,205,114,105,225, 84, 73,163, 99,111
    204, 61,200,217,170, 15,198, 28,192,254,134,234,222,  7,236,248
    201, 41,177,156, 92,131, 67,249,245,184,203,  9,241,  0, 27, 46
    133,174, 75, 18, 93,209,100,120, 76,213, 16, 83,  4,107,140, 52
    58, 55,  3,244, 97,197,238,227,118, 49, 79,230,223,165,153, 59

###############################################################################

TITLE
    Nush 64	/ Nessie C_64

TYPE
    16 HEX

DATA
    0AC25h,08A93h,0243Dh,0262Eh,0F887h,0C4F2h,08E36h,09FA1h,07DC0h
    06A29h,06D84h,034BDh,0A267h,0CC15h,004FEh,0B94Ah,0DF24h,040EFh
    096DAh,0905Fh,0D631h,0AA62h,04D15h,070CBh,07533h,045FCh,05337h
    0D25Eh,0A926h,01C7Bh,05F12h,04ECCh,03C86h,028DBh,0FC01h,07CB1h

###############################################################################

TITLE
    Nush 64	/ Nessie S_64

TYPE
    16

DATA
    4, 7, 11, 8, 7, 14, 5, 4, 8
    2, 9, 4, 13, 1, 14, 6, 7, 12
    5, 1, 2, 4, 12, 3, 9, 2, 11
    13, 12, 3, 6, 11, 7, 15, 4, 14

###############################################################################

TITLE
    Q128 ftab

TYPE
    32 HEX

DATA
    0d6d92632h,05e84404dh,04f341282h,071654b06h,0d48d6a0bh,0245becc4h
    0c8f84d80h,022c620c9h,066aa8b02h,00ac697ffh,08b755a36h,02577931ch
    0438d17b6h,0bb7b1bd1h,0e0a8f51eh,0f4fd583dh,0beceeb95h,07945c1aeh
    029ce9628h,03d7965cdh,080cfbdb9h,02f535a25h,07666a9bdh,06df2324bh
    098731a06h,0e4d32444h,0265faf55h,041895427h,0f2d2c55eh,08151930fh
    077a888a3h,09cba9a32h,0a7ec629ch,055dcf904h,0b35b9179h,01ab8e42eh
    0a0ef8027h,0db4c5cdeh,09fc2a9d3h,0a9512439h,09c08cb5ch,04bfd92b6h
    0c23eda7fh,0037833e1h,040177a91h,0bae53567h,0774ad665h,03cb744d3h
    06e8a01aah,065d2b8e3h,00507a12ah,0ef69c3cbh,0230801d7h,00bbae78fh
    062630b36h,0ed6d805ah,05aaf9ebfh,0721d78e7h,0d33cd9deh,06618da6ch
    09dc6ea42h,00d272b82h,03559ef65h,0dcfdef0bh,0865271b4h,03621dc84h
    0885d667fh,092e58251h,02e9d7b3bh,0e9165100h,099bd3b18h,0b1ed8386h
    084563225h,0446cabcbh,07e462315h,0a2bbcc1eh,03be4a9c0h,0320a0276h
    0416b0ae1h,0c6a755e3h,05c8003dch,036c38242h,097e2237bh,02ae6aa61h
    08a5925eeh,03b56f8aeh,026bdf193h,096ce5ca3h,0e51d055ah,0ad2af563h
    02b9ada11h,09f70f8bdh,03f9f789ah,089934761h,0a8cf0a8fh,0c78b2a3bh
    08f5e84c4h,0b8b1795eh,0afcce834h,0d9aa4189h,0c28c8b11h,07636a615h
    0f2609430h,0eca3a144h,07869be76h,012c8612eh,0d18acb21h,0cc61c21ch
    0eddfd134h,0ad7afacbh,07f6a5ccdh,00c0b545ah,0584983e8h,004998f9ch
    0969e530bh,0e21ee7e1h,0fff5eedch,0fe3bcfc2h,097007dbdh,066fa84aah
    0a375ed00h,03509e0cdh,01b76c530h,070193b76h,086e020dah,0c9366c9eh
    049f9d127h,0ae52c682h,0260fa0fdh,0e380c957h,0ce358e25h,002044391h
    0aeb09844h,0f31ce440h,0f0d686cfh,08cc4e9e3h,0be2cb553h,01e933adch
    0c312a5a7h,01d0957fbh,0a1c3ffffh,0bd5486b2h,0e8d8701eh,06e685f6ch
    01bc4945eh,0062f9d63h,084063d8dh,0c1f4b8f0h,0a7bc6d34h,0c4f319dah
    0f81452a1h,04cae7fa5h,01dbb0695h,0aa9b46b6h,06bddaf28h,061f96611h
    09a27563fh,0c2dc84b9h,06530e625h,0e7494963h,06ff671dah,0b8532798h
    0c06a9646h,0cc839cdah,09eeed60bh,0a70e3c5ah,0f0868967h,002544c39h
    087cc5f02h,0b3b9cfbfh,0f6f91bach,0dcade0a3h,08b9704f0h,06cde4d93h
    064aec893h,03e515984h,07bf3d351h,03eb30742h,0be9ee43dh,0b15fd2e8h
    02c7b666ch,001ce211eh,03b06f706h,005e5ffech,024e9bdaah,0fda1a2e5h
    0e04aabd8h,0e9a4006eh,0019e2eb6h,08d0ac8fdh,073d359f9h,06a43819eh
    000500fa8h,0da302caeh,0c0d8c728h,062d15a58h,061a969b9h,01e216bb2h
    00892dbc6h,03a7a8776h,034259f15h,079a79f68h,0f96822d1h,07f88020bh
    0af9ce79ch,0017c7070h,0f8445d09h,0ee15b3bbh,0e3629791h,020203d9eh
    053413509h,025279cb4h,0df378d84h,08921160fh,0a89f0527h,0413b0549h
    0ad98a40dh,0fb8e3f86h,000000000h,0d717072ch,0e6353913h,0acb4dbd5h
    01f0d146ah,0c411471ch,0b9cd092eh,041d95b8fh,074d0bb42h,086027e1ch
    0da827dc0h,057d8ba95h,012986e86h,09bb97889h,0c9843df0h,0122a3fe8h
    0556ea86ah,0d8346f3fh,0693bb27fh,053113aa1h,02850b89eh,00ce90a9ch
    0fb3c6ee8h,07a6dfde7h,0917fef76h,02a54fb0fh,0e2acb68fh,0e4832bech
    02e7f25fdh,0110203a1h,0aacb491eh,018eca817h,09e5c8765h,014b7f3e5h
    0c146e99eh,02e2f2a55h,047a6c944h,023ba50b9h,0d2f2f8c0h,0fbde302eh
    0a494517dh,0b5740c1ah,072af2989h,0ee45bc13h,003283c49h,06fa67e72h
    0f767351ah,01a5abae8h,0197286a1h,0e71946cbh,00f7367bbh,0dd33ce15h
    031c060f9h,067d6fb72h,0aee097ech,028e2e9f0h,0e7ab17a5h,0ba076ba1h
    02595cddah,0d43f3b65h,025c5c272h,0c81a1346h,0177d916ah,09b5b264fh
    0e166d400h,09ebed9a3h,07ef4727bh,0611b38d7h,05dfc73ach,00c5b5bf2h
    08de8963bh,0c7db2593h,031223e3fh,0d7470884h,0606748a7h,0ffa5e174h
    0f3feba86h,040f52457h,0a3c7bc6eh,0dc4fbe65h,06233049eh,0c26ed5d7h
    04f8643ech,0468ab69ch,053a36bcfh,0558cf6ach,095043e2ch,01b26ca98h
    04867ff91h,085c81c93h,0b60c3ffbh,0897119a7h,04ad1ed6eh,07480b4eah
    00beae827h,0d0f6bb51h,058198c40h,06989e311h,05f1a6efbh,0696bbdd7h
    06847c20fh,06c6c1cfdh,01ec33574h,0f64b4ac2h,0f41f06fbh,000b2516eh
    0644c9655h,08c94e64bh,06648d5c4h,0a2ebc3b6h,04c1c2ecbh,0f7856bdch
    07adfac89h,04837f039h,0ae02c92ah,035bbb1a3h,0e461752ah,0f7d56474h
    0d210a606h,0718715c0h,0a4c45ed5h,0bab53acfh,01c252823h,0cb807e61h
    0cdafe302h,0aa791870h,00b58b949h,0a00ddee1h,060d519c9h,0e1848ac6h
    0d9481f4fh,0f148a879h,064fec73bh,03c551a15h,0e5af5434h,04d605ebbh
    0a55a7063h,03c0515bdh,01deb093dh,00d957aech,03ee308eah,0ccd39372h
    0d38e88b0h,0fa401e98h,08f0e8b6ch,0b023a298h,09207dc97h,07c126f2ch
    0d8863e51h,0cd4dbdc4h,0382ecb4fh,06a138e36h,0631f7b46h,019228909h
    01c75278bh,050db582eh,090039f06h,0a9b37affh,006cdc3a5h,0210c4246h
    08fecd5aah,0b227e109h,03d9b3b0bh,0b92f57e8h,023ea5f11h,07839b1deh
    0caac01b9h,0127a3040h,0f282caf6h,09a950751h,08e22f4b4h,0fc6f83fbh
    056f4c54dh,0bccaa804h,00f91397dh,060851661h,0807decd7h,0eadc338fh
    051457698h,09f20f715h,0e4317a82h,0d7a55642h,0f2309b98h,03f2d29f4h
    0eb121291h,0dbae0218h,099ed34b0h,0fd13f38bh,091cdbe18h,0c9666336h
    07b118d97h,0042bdef2h,0ed3d8ff2h,0179fcfach,063ad2a28h,032b85318h
    0cdffecaah,0724d774fh,021ee1c80h,042a1686eh,02a04f4a7h,095b66f42h
    0de4bfdf4h,0d240a9aeh,04a81e2c6h,0a82d5449h,07d3e10f4h,0614b377fh
    0faa2405eh,03fcf7732h,090b1ce68h,0fc8ddd3dh,08db89993h,016e3bfdch
    0b30b9ed1h,08229a0eeh,04eaa3c34h,0b10fdd40h,056a4cae5h,084e4634bh
    0d16895e7h,06e3850c4h,095543184h,058abdd2eh,0be7cbafbh,0c8a84228h
    0dad27268h,0db1c5376h,071d71a68h,0bdb6d874h,0ebf04c57h,0dfd5d342h
    0852a4255h,0d66b775ch,0b4087c6ah,0cbd071c9h,0eb421d39h,0dd819f7bh
    04fd64c44h,0305e4e4fh,07d8c419ah,0d014e597h,0dea9a332h,01c97794dh
    045a28ad5h,0628155f0h,0912fe0deh,043dd181eh,0faf24ff6h,04efa339ch
    09399f221h,00eed490dh,0b4ba2d04h,0a193f057h,0942841f4h,0e136dba8h
    0e7fb180dh,0f5337923h,030bc1089h,0bc9aa7ach,0cffbaf3bh,06560e98dh
    033942cc0h,00a969857h,05788b53dh,020703236h,031906f51h,0a75e33f2h
    05987a2f6h,06b3ff1eeh,0c5df6602h,0a25992d8h,06af1d0f0h,01651eeb2h
    05fa83f95h,0d8d631f9h,0788be0b0h,0b6be6e95h,0a121a139h,019c0d7cfh
    0095cfad8h,009bea41eh,0872e01c4h,0c7397b55h,0990f6a76h,01601e11ah
    017cfc004h,03bb4a668h,08abb7b28h,0809fb211h,094ca1f32h,0b277eea1h
    0cfaba093h,05965fc30h,09ac508f9h,07f3a5365h,0ef8b9d0dh,037effd9ah
    0949a109ah,09f92a67bh,090e1c1c0h,0f8f60c67h,08a092a46h,0f8a603cfh
    0f9382d79h,06f142f1ch,05aff9117h,0ace4d47dh,0fe899each,013564f98h
    0d2a2f768h,076d4f8d3h,0a2099d70h,008c2d46eh,042133900h,007e1bc7dh
    0f4ad5795h,0eef7ed7dh,0932ba34fh,033267daeh,0cafc0e11h,02fb104e3h
    0503906e8h,0172d9ec2h,0f61b456ah,06eda0e02h,04e4862f2h,0c56d376ch
    0526d4ad1h,0e9465ea8h,0448ef50dh,0ea3e6d49h,03952bb3fh,02ecd7493h
    0ac068abbh,059d7ad5eh,0877e0e6ch,0a397b3c6h,0069dcc0dh,0d63b78f4h
    07cf031eah,0180ef6d1h,0ca1e50d7h,0df85dceah,08c76b88dh,0ea6e62e1h
    0090cf570h,0e54d0af2h,0b2c5bfcfh,014e7fc4dh,0b7204023h,07ea47dd3h
    052df1bbfh,06582b74bh,0ecf3aeech,0c03a99eeh,07e162cbdh,03a98d9b0h
    00dc57544h,0a325e2a8h,0d5434b15h,0e687687dh,06817cda7h,06d406325h
    04714982ah,0102e7c79h,0bc28f6c2h,078dbef18h,02ab6a5c9h,0c3a0f4c9h
    07d6e1f5ch,09c58c4f4h,082cbfe28h,021be1328h,0576aebfbh,08e72fb1ch
    0a6724c2ah,04638e7f2h,02b7884d7h,040477539h,05442d7b2h,0ea8c3c27h
    01455ad23h,02773d08dh,0387ec4e7h,03ac8d618h,04b4fc3d8h,018bca7bfh
    083b78e58h,053f36467h,02723df25h,04c4c2163h,08598133bh,01fbf4504h
    02fe10b4bh,0297cc746h,046dab934h,056469423h,0641c99fdh,04cfe700dh
    08b25559eh,05d1e2d6ah,0bc78f96ah,024b9b202h,0ef39cc63h,0c116e636h
    0989144c0h,0efdb92a5h,05d4e22c2h,068a59cc9h,077f8870bh,07a3df24fh
    07ca03e42h,0fd43fc23h,070fb65b0h,0905390aeh,0443ca463h,06d106c8dh
    01529dd53h,038cc9589h,05935f398h,02f03558dh,0b8e176f6h,0b073ad30h
    05e661e8bh,011520c09h,0573ae453h,08c26b725h,0ddd190d3h,097507215h
    027c181e3h,00557ae82h,0f3aeb52eh,0d51344bdh,09d96e5eah,042f167c6h
    0a6c01d44h,0982315aeh,02b288b7fh,0a171ae91h,097b22cd3h,0919db1b0h
    013b4115eh,07684f77bh,0c342aa0fh,008208aa8h,008708500h,0e5ff5b9ch
    04e186d5ah,02800b736h,0d5a115d3h,0c4a31672h,0159b8c3dh,0fe6bc06ah
    0967c0dcdh,007b1b3d5h,0433f46d8h,0e8887fb6h,04668e85ah,045f2857dh
    02bcad5b9h,0d4dd65a3h,072ff2621h,0b99d0686h,08ec0aa72h,02de548dah
    0e01aa470h,08355d09eh,05e361123h,0e66536bbh,05f4a6153h,05dac7c04h
    023580e7fh,0b52403b2h,093c9fd89h,0b6ee613dh,0c6f75a4bh,03a2a88deh
    070ab6a18h,04d305113h,0c3f0fb61h,022247e0fh,049a9de8fh,08d5ac755h
    095e660eah,0c088c880h,0c6450b25h,0f7373ab2h,0f1aaf6bfh,03ce74b7bh
    0fdf1ad4dh,0634f74eeh,0abe736c6h,0436f4970h,04a63bc00h,094784e5ch
    027918e4bh,0300e41e7h,09be97721h,0dbfe0db0h,0ed8fde9ch,081e3c261h
    0fed99104h,033c42368h,05ed44fe5h,00753ed13h,047f6c6ech,0704934deh
    02cc93702h,002b612ffh,03f7d265ch,0a4760fbbh,01a0ab540h,009eeabb6h
    0adc8aba5h,013e41ef6h,088bf38b9h,0d91810e7h,0523d4579h,06734a5b4h
    0370da35ch,0dc1fb1cdh,004c98034h,02db54772h,04dd20fd5h,086b02f72h
    0bb994517h,0d044ea3fh,0d1dac489h,04885a157h,03902b497h,0c1a4b758h
    00fc136d5h,0ff17b01ah,05b83e167h,07a8fa321h,01579d2fbh,0eba043ffh
    050690940h,0802de37fh,0a6224382h,06b8da080h,00a74c691h,07432e584h
    0528f1417h,0a5e8210dh,088ef3711h,09a775997h,00cb90534h,0292cc8eeh
    047449782h,020c26358h,0c615048dh,0aa2917d8h,0494b8049h,084b46ce3h
    073610897h,07ba3dcf9h,04510dbbbh,068f59361h,08279af46h,0bd04891ah
    0ce87df4bh,0553ea7c2h,0cb322f0fh,05c625d1ah,04f641d2ah,0325a0ddeh
    0a50a7fcbh,011b052cfh,01d595853h,0f563768bh,098c14b68h,03d296a65h
    0de1bf25ch,03671d32ch,0e3329839h,0f581284dh,037bff232h,0def9ac9ah
    08e90a5dah,0754e95f4h,05b31b009h,0b4ea22ach,0713544aeh,0ce65818dh
    0067f92cbh,039e0ea51h,0b0c1fc5eh,0c84a1ceeh,06aa1df58h,0e9f40fc6h
    0f1faf917h,013064030h,005b5f044h,0424336a8h,00a24c939h,0c44148b4h
    06f4420b4h,0047bd15ah,039b0e5f9h,08bc70b58h,00e5f1863h,0d1389a4fh
    0af2eb6f2h,0c9d43258h,0107e73d1h,089c348c9h,09cea959ah,011e05d67h
    0bb2b1479h,073835651h,0f34cebe8h,0d36cd676h,04540d413h,05cd00c74h
    031723197h,0eea7e2d5h,00f236813h,081b3cdc9h,07fd80da3h,0d7f559eah
    003ca628fh,03dcb34a3h,033767206h,02c2b69c4h,051f727f6h,0829bf180h
    0039a6d27h,056169b8bh,04d82007dh,09d24b484h,0bde6d7dch,0389c9a21h
    069d9ecb9h,0b792114dh,044defaa5h,08fbcda02h,092b58df9h,0962c0265h
    0cf19f1fdh,07462ea2ch,0227471a7h,0c53d38c4h,09257d33fh,032e85cb0h
    0abb7396eh,030ec1f21h,058fbd286h,05b61bfa1h,0240be36ch,0b7704f8bh
    0a69012ech,01f5d1bc2h,08305df36h,0299e9980h,05ff8303dh,0c58f69aah
    07ddc4e32h,0e6d767d5h,0880d69d7h,0d46f34cdh,0ff47bfb2h,022962f61h
    0a9e37557h,0fa101130h,083e781f0h,0cf49fe55h,0fcddd295h,02d07161ch
    0e83a2ed8h,0ca4e5f7fh,075fcc49ah,07915ce06h,054f086dch,0a9012b91h
    00ebd46a5h,0df67822ch,0d9fa4e21h,0af7eb95ah,081019ca7h,0f118a7d1h
    000e25ec6h,09b0b29e7h,0e2fcb927h,0ec11f02ah,0857a4dfdh,03497ce7bh
    01b949bf6h,09d74bb2ch,0cc31cdb4h,0e3d0c6ffh,0bf00ca8bh,036938deah
    016b3b074h,0ced7d0e3h,06037470fh,0cd1db26ch,06da23de3h,0bbc94abfh
    05a1dcfd1h,0c76974fdh,0a05dd149h,0f034d809h,0a4260013h,0b091f3f6h
    0a5b82ea5h,06786f4dah,04bad9d1eh,01e71641ah,0b59652dch,0ba576409h
    0b1bd8c2eh,02d5719b4h,07331073fh,0ac568513h,0b97f5840h,0bf50c523h
    00703e2bbh,06764aa1ch,020926cf0h,0012c7fd8h,01cc776e5h,09e0c88cdh
    0995f65deh,0f44f0953h,0e86a2170h,01fef4aach,07c426084h,0771ad9cdh
    02c9938aah,0b8032830h,04a33b3a8h,0751e9a5ch,0dd63c1bdh,079f790c0h
    051157930h,0d5f11a7bh,0d8646097h,0cb6220a7h,0d689299ah,0879c50aah
    0b7c21ee5h,04b1fcc70h,00b08b6e1h,028b2e658h,0b295b067h,0ab056800h
    075accb32h,0bfb29be5h,0f5d127e5h,06c8e423bh,06b6ffe46h,0215c4deeh
    0f9da73bfh,07b41823fh,048d5aeffh,01405a28bh,0bfe2944dh,0347590bdh
    0b45873c2h,0b65c3053h,0a0bf8f8fh,0937bace7h,01ae8eb86h,040a52bffh
    0e24ee849h,0d3de8718h,06c3c1355h,01990d867h,054a08974h,0375dacf4h
    0508b5786h,063fd2580h,0f98a7c17h,034c7c1d3h,0d0a6b4f9h,03e01562ch
    0185ef979h,05412d81ah,0b5c65d74h,026edfe3bh,035ebbe0bh,002e61d57h
    015cb8395h,00e0f17cbh,0fc3f8c53h,05a4dc079h,0e0f8fab6h,05bd3eecfh
    0e1d4856eh,08aeb7480h,05c3252b2h,0ab5567a8h,0fb6c6140h,0b3e9c017h
    0ec41ff82h,0f064d7a1h,0491b8fe1h,0a87d5be1h,010cc22bfh,0f6a91404h
    00d77242ah,0da602306h,051a7285eh,0109c2d17h

###############################################################################

TITLE
    SAFER+ expf

TYPE
    8

DATA
    1,  45, 226, 147, 190,  69,  21, 174, 120,   3, 135, 164, 184,  56, 207,  63
    8, 103,   9, 148, 235,  38, 168, 107, 189,  24,  52,  27, 187, 191, 114, 247 
    64,  53,  72, 156,  81,  47,  59,  85, 227, 192, 159, 216, 211, 243, 141, 177 
    255, 167,  62, 220, 134, 119, 215, 166,  17, 251, 244, 186, 146, 145, 100, 131 
    241,  51, 239, 218,  44, 181, 178,  43, 136, 209, 153, 203, 140, 132,  29,  20
    129, 151, 113, 202,  95, 163, 139,  87,  60, 130, 196,  82,  92,  28, 232, 160
    4, 180, 133,  74, 246,  19,  84, 182, 223,  12,  26, 142, 222, 224,  57, 252 
    32, 155,  36,  78, 169, 152, 158, 171, 242,  96, 208, 108, 234, 250, 199, 217 
    0, 212,  31, 110,  67, 188, 236,  83, 137, 254, 122,  93,  73, 201,  50, 194 
    249, 154, 248, 109,  22, 219,  89, 150,  68, 233, 205, 230,  70,  66, 143,  10 
    193, 204, 185, 101, 176, 210, 198, 172,  30,  65,  98,  41,  46,  14, 116,  80 
    2,  90, 195,  37, 123, 138,  42,  91, 240,   6,  13,  71, 111, 112, 157, 126
    16, 206,  18,  39, 213,  76,  79, 214, 121,  48, 104,  54, 117, 125, 228, 237 
    128, 106, 144,  55, 162,  94, 118, 170, 197, 127,  61, 175, 165, 229,  25,  97 
    253,  77, 124, 183,  11, 238, 173,  75,  34, 245, 231, 115,  35,  33, 200,   5 
    225, 102, 221, 179,  88, 105,  99,  86,  15, 161,  49, 149,  23,   7,  58,  40 

###############################################################################

TITLE
    SAFER+ logf

TYPE
    8

DATA
    128,   0, 176,   9,  96, 239, 185, 253,  16,  18, 159, 228, 105, 186, 173, 248 
    192,  56, 194, 101,  79,   6, 148, 252,  25, 222, 106,  27,  93,  78, 168, 130 
    112, 237, 232, 236, 114, 179,  21, 195, 255, 171, 182,  71,  68,   1, 172,  37 
    201, 250, 142,  65,  26,  33, 203, 211,  13, 110, 254,  38,  88, 218,  50,  15
    32, 169, 157, 132, 152,   5, 156, 187,  34, 140,  99, 231, 197, 225, 115, 198 
    175,  36,  91, 135, 102,  39, 247,  87, 244, 150, 177, 183,  92, 139, 213,  84 
    121, 223, 170, 246,  62, 163, 241,  17, 202, 245, 209,  23, 123, 147, 131, 188 
    189,  82,  30, 235, 174, 204, 214,  53,   8, 200, 138, 180, 226, 205, 191, 217
    208,  80,  89,  63,  77,  98,  52,  10,  72, 136, 181,  86,  76,  46, 107, 158
    210,  61,  60,   3,  19, 251, 151,  81, 117,  74, 145, 113,  35, 190, 118,  42 
    95, 249, 212,  85,  11, 220,  55,  49,  22, 116, 215, 119, 167, 230,   7, 219 
    164,  47,  70, 243,  97,  69, 103, 227,  12, 162,  59,  28, 133,  24,   4,  29
    41, 160, 143, 178,  90, 216, 166, 126, 238, 141,  83,  75, 161, 154, 193,  14 
    122,  73, 165,  44, 129, 196, 199,  54,  43, 127,  67, 149,  51, 242, 108, 104 
    109, 240,   2,  40, 206, 221, 155, 234,  94, 153, 124,  20, 134, 207, 229,  66 
    184,  64, 120,  45,  58, 233, 100,  31, 146, 144, 125,  57, 111, 224, 137,  48	
    128,   0, 176,   9,  96, 239, 185, 253,  16,  18, 159, 228, 105, 186, 173, 248 
    192,  56, 194, 101,  79,   6, 148, 252,  25, 222, 106,  27,  93,  78, 168, 130 
    112, 237, 232, 236, 114, 179,  21, 195, 255, 171, 182,  71,  68,   1, 172,  37 
    201, 250, 142,  65,  26,  33, 203, 211,  13, 110, 254,  38,  88, 218,  50,  15
    32, 169, 157, 132, 152,   5, 156, 187,  34, 140,  99, 231, 197, 225, 115, 198 
    175,  36,  91, 135, 102,  39, 247,  87, 244, 150, 177, 183,  92, 139, 213,  84 
    121, 223, 170, 246,  62, 163, 241,  17, 202, 245, 209,  23, 123, 147, 131, 188 
    189,  82,  30, 235, 174, 204, 214,  53,   8, 200, 138, 180, 226, 205, 191, 217
    208,  80,  89,  63,  77,  98,  52,  10,  72, 136, 181,  86,  76,  46, 107, 158
    210,  61,  60,   3,  19, 251, 151,  81, 117,  74, 145, 113,  35, 190, 118,  42 
    95, 249, 212,  85,  11, 220,  55,  49,  22, 116, 215, 119, 167, 230,   7, 219 
    164,  47,  70, 243,  97,  69, 103, 227,  12, 162,  59,  28, 133,  24,   4,  29
    41, 160, 143, 178,  90, 216, 166, 126, 238, 141,  83,  75, 161, 154, 193,  14 
    122,  73, 165,  44, 129, 196, 199,  54,  43, 127,  67, 149,  51, 242, 108, 104 
    109, 240,   2,  40, 206, 221, 155, 234,  94, 153, 124,  20, 134, 207, 229,  66 
    184,  64, 120,  45,  58, 233, 100,  31, 146, 144, 125,  57, 111, 224, 137,  48

###############################################################################

TITLE
    seed_SS0

TYPE
    32 HEX

DATA
    02989a1a8h,005858184h,016c6d2d4h,013c3d3d0h,014445054h,01d0d111ch,02c8ca0ach,025052124h
    01d4d515ch,003434340h,018081018h,01e0e121ch,011415150h,03cccf0fch,00acac2c8h,023436360h
    028082028h,004444044h,020002020h,01d8d919ch,020c0e0e0h,022c2e2e0h,008c8c0c8h,017071314h 
    02585a1a4h,00f8f838ch,003030300h,03b4b7378h,03b8bb3b8h,013031310h,012c2d2d0h,02ecee2ech 
    030407070h,00c8c808ch,03f0f333ch,02888a0a8h,032023230h,01dcdd1dch,036c6f2f4h,034447074h 
    02ccce0ech,015859194h,00b0b0308h,017475354h,01c4c505ch,01b4b5358h,03d8db1bch,001010100h 
    024042024h,01c0c101ch,033437370h,018889098h,010001010h,00cccc0cch,032c2f2f0h,019c9d1d8h 
    02c0c202ch,027c7e3e4h,032427270h,003838380h,01b8b9398h,011c1d1d0h,006868284h,009c9c1c8h 
    020406060h,010405050h,02383a3a0h,02bcbe3e8h,00d0d010ch,03686b2b4h,01e8e929ch,00f4f434ch 
    03787b3b4h,01a4a5258h,006c6c2c4h,038487078h,02686a2a4h,012021210h,02f8fa3ach,015c5d1d4h 
    021416160h,003c3c3c0h,03484b0b4h,001414140h,012425250h,03d4d717ch,00d8d818ch,008080008h 
    01f0f131ch,019899198h,000000000h,019091118h,004040004h,013435350h,037c7f3f4h,021c1e1e0h 
    03dcdf1fch,036467274h,02f0f232ch,027072324h,03080b0b0h,00b8b8388h,00e0e020ch,02b8ba3a8h 
    02282a2a0h,02e4e626ch,013839390h,00d4d414ch,029496168h,03c4c707ch,009090108h,00a0a0208h 
    03f8fb3bch,02fcfe3ech,033c3f3f0h,005c5c1c4h,007878384h,014041014h,03ecef2fch,024446064h 
    01eced2dch,02e0e222ch,00b4b4348h,01a0a1218h,006060204h,021012120h,02b4b6368h,026466264h 
    002020200h,035c5f1f4h,012829290h,00a8a8288h,00c0c000ch,03383b3b0h,03e4e727ch,010c0d0d0h 
    03a4a7278h,007474344h,016869294h,025c5e1e4h,026062224h,000808080h,02d8da1ach,01fcfd3dch 
    02181a1a0h,030003030h,037073334h,02e8ea2ach,036063234h,015051114h,022022220h,038083038h 
    034c4f0f4h,02787a3a4h,005454144h,00c4c404ch,001818180h,029c9e1e8h,004848084h,017879394h 
    035053134h,00bcbc3c8h,00ecec2cch,03c0c303ch,031417170h,011011110h,007c7c3c4h,009898188h 
    035457174h,03bcbf3f8h,01acad2d8h,038c8f0f8h,014849094h,019495158h,002828280h,004c4c0c4h 
    03fcff3fch,009494148h,039093138h,027476364h,000c0c0c0h,00fcfc3cch,017c7d3d4h,03888b0b8h
    00f0f030ch,00e8e828ch,002424240h,023032320h,011819190h,02c4c606ch,01bcbd3d8h,02484a0a4h
    034043034h,031c1f1f0h,008484048h,002c2c2c0h,02f4f636ch,03d0d313ch,02d0d212ch,000404040h
    03e8eb2bch,03e0e323ch,03c8cb0bch,001c1c1c0h,02a8aa2a8h,03a8ab2b8h,00e4e424ch,015455154h
    03b0b3338h,01cccd0dch,028486068h,03f4f737ch,01c8c909ch,018c8d0d8h,00a4a4248h,016465254h
    037477374h,02080a0a0h,02dcde1ech,006464244h,03585b1b4h,02b0b2328h,025456164h,03acaf2f8h
    023c3e3e0h,03989b1b8h,03181b1b0h,01f8f939ch,01e4e525ch,039c9f1f8h,026c6e2e4h,03282b2b0h
    031013130h,02acae2e8h,02d4d616ch,01f4f535ch,024c4e0e4h,030c0f0f0h,00dcdc1cch,008888088h
    016061214h,03a0a3238h,018485058h,014c4d0d4h,022426260h,029092128h,007070304h,033033330h
    028c8e0e8h,01b0b1318h,005050104h,039497178h,010809090h,02a4a6268h,02a0a2228h,01a8a9298h

###############################################################################

TITLE
    seed_SS1

TYPE
    32 HEX

DATA
    038380830h,0e828c8e0h,02c2d0d21h,0a42686a2h,0cc0fcfc3h,0dc1eced2h,0b03383b3h,0b83888b0h
    0ac2f8fa3h,060204060h,054154551h,0c407c7c3h,044044440h,06c2f4f63h,0682b4b63h,0581b4b53h
    0c003c3c3h,060224262h,030330333h,0b43585b1h,028290921h,0a02080a0h,0e022c2e2h,0a42787a3h
    0d013c3d3h,090118191h,010110111h,004060602h,01c1c0c10h,0bc3c8cb0h,034360632h,0480b4b43h
    0ec2fcfe3h,088088880h,06c2c4c60h,0a82888a0h,014170713h,0c404c4c0h,014160612h,0f434c4f0h
    0c002c2c2h,044054541h,0e021c1e1h,0d416c6d2h,03c3f0f33h,03c3d0d31h,08c0e8e82h,098188890h
    028280820h,04c0e4e42h,0f436c6f2h,03c3e0e32h,0a42585a1h,0f839c9f1h,00c0d0d01h,0dc1fcfd3h
    0d818c8d0h,0282b0b23h,064264662h,0783a4a72h,024270723h,02c2f0f23h,0f031c1f1h,070324272h
    040024242h,0d414c4d0h,040014141h,0c000c0c0h,070334373h,064274763h,0ac2c8ca0h,0880b8b83h
    0f437c7f3h,0ac2d8da1h,080008080h,01c1f0f13h,0c80acac2h,02c2c0c20h,0a82a8aa2h,034340430h
    0d012c2d2h,0080b0b03h,0ec2ecee2h,0e829c9e1h,05c1d4d51h,094148490h,018180810h,0f838c8f0h
    054174753h,0ac2e8ea2h,008080800h,0c405c5c1h,010130313h,0cc0dcdc1h,084068682h,0b83989b1h
    0fc3fcff3h,07c3d4d71h,0c001c1c1h,030310131h,0f435c5f1h,0880a8a82h,0682a4a62h,0b03181b1h
    0d011c1d1h,020200020h,0d417c7d3h,000020202h,020220222h,004040400h,068284860h,070314171h
    004070703h,0d81bcbd3h,09c1d8d91h,098198991h,060214161h,0bc3e8eb2h,0e426c6e2h,058194951h
    0dc1dcdd1h,050114151h,090108090h,0dc1cccd0h,0981a8a92h,0a02383a3h,0a82b8ba3h,0d010c0d0h
    080018181h,00c0f0f03h,044074743h,0181a0a12h,0e023c3e3h,0ec2ccce0h,08c0d8d81h,0bc3f8fb3h
    094168692h,0783b4b73h,05c1c4c50h,0a02282a2h,0a02181a1h,060234363h,020230323h,04c0d4d41h
    0c808c8c0h,09c1e8e92h,09c1c8c90h,0383a0a32h,00c0c0c00h,02c2e0e22h,0b83a8ab2h,06c2e4e62h
    09c1f8f93h,0581a4a52h,0f032c2f2h,090128292h,0f033c3f3h,048094941h,078384870h,0cc0cccc0h
    014150511h,0f83bcbf3h,070304070h,074354571h,07c3f4f73h,034350531h,010100010h,000030303h
    064244460h,06c2d4d61h,0c406c6c2h,074344470h,0d415c5d1h,0b43484b0h,0e82acae2h,008090901h
    074364672h,018190911h,0fc3ecef2h,040004040h,010120212h,0e020c0e0h,0bc3d8db1h,004050501h
    0f83acaf2h,000010101h,0f030c0f0h,0282a0a22h,05c1e4e52h,0a82989a1h,054164652h,040034343h
    084058581h,014140410h,088098981h,0981b8b93h,0b03080b0h,0e425c5e1h,048084840h,078394971h
    094178793h,0fc3cccf0h,01c1e0e12h,080028282h,020210121h,08c0c8c80h,0181b0b13h,05c1f4f53h
    074374773h,054144450h,0b03282b2h,01c1d0d11h,024250521h,04c0f4f43h,000000000h,044064642h
    0ec2dcde1h,058184850h,050124252h,0e82bcbe3h,07c3e4e72h,0d81acad2h,0c809c9c1h,0fc3dcdf1h
    030300030h,094158591h,064254561h,03c3c0c30h,0b43686b2h,0e424c4e0h,0b83b8bb3h,07c3c4c70h
    00c0e0e02h,050104050h,038390931h,024260622h,030320232h,084048480h,068294961h,090138393h
    034370733h,0e427c7e3h,024240420h,0a42484a0h,0c80bcbc3h,050134353h,0080a0a02h,084078783h
    0d819c9d1h,04c0c4c40h,080038383h,08c0f8f83h,0cc0ecec2h,0383b0b33h,0480a4a42h,0b43787b3h

###############################################################################

TITLE
    seed_SS2

TYPE
    32 HEX

DATA
    0a1a82989h,081840585h,0d2d416c6h,0d3d013c3h,050541444h,0111c1d0dh,0a0ac2c8ch,021242505h
    0515c1d4dh,043400343h,010181808h,0121c1e0eh,051501141h,0f0fc3ccch,0c2c80acah,063602343h
    020282808h,040440444h,020202000h,0919c1d8dh,0e0e020c0h,0e2e022c2h,0c0c808c8h,013141707h
    0a1a42585h,0838c0f8fh,003000303h,073783b4bh,0b3b83b8bh,013101303h,0d2d012c2h,0e2ec2eceh
    070703040h,0808c0c8ch,0333c3f0fh,0a0a82888h,032303202h,0d1dc1dcdh,0f2f436c6h,070743444h
    0e0ec2ccch,091941585h,003080b0bh,053541747h,0505c1c4ch,053581b4bh,0b1bc3d8dh,001000101h
    020242404h,0101c1c0ch,073703343h,090981888h,010101000h,0c0cc0ccch,0f2f032c2h,0d1d819c9h
    0202c2c0ch,0e3e427c7h,072703242h,083800383h,093981b8bh,0d1d011c1h,082840686h,0c1c809c9h
    060602040h,050501040h,0a3a02383h,0e3e82bcbh,0010c0d0dh,0b2b43686h,0929c1e8eh,0434c0f4fh
    0b3b43787h,052581a4ah,0c2c406c6h,070783848h,0a2a42686h,012101202h,0a3ac2f8fh,0d1d415c5h
    061602141h,0c3c003c3h,0b0b43484h,041400141h,052501242h,0717c3d4dh,0818c0d8dh,000080808h
    0131c1f0fh,091981989h,000000000h,011181909h,000040404h,053501343h,0f3f437c7h,0e1e021c1h
    0f1fc3dcdh,072743646h,0232c2f0fh,023242707h,0b0b03080h,083880b8bh,0020c0e0eh,0a3a82b8bh
    0a2a02282h,0626c2e4eh,093901383h,0414c0d4dh,061682949h,0707c3c4ch,001080909h,002080a0ah
    0b3bc3f8fh,0e3ec2fcfh,0f3f033c3h,0c1c405c5h,083840787h,010141404h,0f2fc3eceh,060642444h
    0d2dc1eceh,0222c2e0eh,043480b4bh,012181a0ah,002040606h,021202101h,063682b4bh,062642646h
    002000202h,0f1f435c5h,092901282h,082880a8ah,0000c0c0ch,0b3b03383h,0727c3e4eh,0d0d010c0h
    072783a4ah,043440747h,092941686h,0e1e425c5h,022242606h,080800080h,0a1ac2d8dh,0d3dc1fcfh
    0a1a02181h,030303000h,033343707h,0a2ac2e8eh,032343606h,011141505h,022202202h,030383808h
    0f0f434c4h,0a3a42787h,041440545h,0404c0c4ch,081800181h,0e1e829c9h,080840484h,093941787h
    031343505h,0c3c80bcbh,0c2cc0eceh,0303c3c0ch,071703141h,011101101h,0c3c407c7h,081880989h
    071743545h,0f3f83bcbh,0d2d81acah,0f0f838c8h,090941484h,051581949h,082800282h,0c0c404c4h
    0f3fc3fcfh,041480949h,031383909h,063642747h,0c0c000c0h,0c3cc0fcfh,0d3d417c7h,0b0b83888h
    0030c0f0fh,0828c0e8eh,042400242h,023202303h,091901181h,0606c2c4ch,0d3d81bcbh,0a0a42484h
    030343404h,0f1f031c1h,040480848h,0c2c002c2h,0636c2f4fh,0313c3d0dh,0212c2d0dh,040400040h
    0b2bc3e8eh,0323c3e0eh,0b0bc3c8ch,0c1c001c1h,0a2a82a8ah,0b2b83a8ah,0424c0e4eh,051541545h
    033383b0bh,0d0dc1ccch,060682848h,0737c3f4fh,0909c1c8ch,0d0d818c8h,042480a4ah,052541646h
    073743747h,0a0a02080h,0e1ec2dcdh,042440646h,0b1b43585h,023282b0bh,061642545h,0f2f83acah
    0e3e023c3h,0b1b83989h,0b1b03181h,0939c1f8fh,0525c1e4eh,0f1f839c9h,0e2e426c6h,0b2b03282h
    031303101h,0e2e82acah,0616c2d4dh,0535c1f4fh,0e0e424c4h,0f0f030c0h,0c1cc0dcdh,080880888h
    012141606h,032383a0ah,050581848h,0d0d414c4h,062602242h,021282909h,003040707h,033303303h
    0e0e828c8h,013181b0bh,001040505h,071783949h,090901080h,062682a4ah,022282a0ah,092981a8ah

###############################################################################

TITLE
    seed_SS3

TYPE
    32 HEX

DATA
    008303838h,0c8e0e828h,00d212c2dh,086a2a426h,0cfc3cc0fh,0ced2dc1eh,083b3b033h,088b0b838h
    08fa3ac2fh,040606020h,045515415h,0c7c3c407h,044404404h,04f636c2fh,04b63682bh,04b53581bh
    0c3c3c003h,042626022h,003333033h,085b1b435h,009212829h,080a0a020h,0c2e2e022h,087a3a427h
    0c3d3d013h,081919011h,001111011h,006020406h,00c101c1ch,08cb0bc3ch,006323436h,04b43480bh
    0cfe3ec2fh,088808808h,04c606c2ch,088a0a828h,007131417h,0c4c0c404h,006121416h,0c4f0f434h
    0c2c2c002h,045414405h,0c1e1e021h,0c6d2d416h,00f333c3fh,00d313c3dh,08e828c0eh,088909818h
    008202828h,04e424c0eh,0c6f2f436h,00e323c3eh,085a1a425h,0c9f1f839h,00d010c0dh,0cfd3dc1fh
    0c8d0d818h,00b23282bh,046626426h,04a72783ah,007232427h,00f232c2fh,0c1f1f031h,042727032h
    042424002h,0c4d0d414h,041414001h,0c0c0c000h,043737033h,047636427h,08ca0ac2ch,08b83880bh
    0c7f3f437h,08da1ac2dh,080808000h,00f131c1fh,0cac2c80ah,00c202c2ch,08aa2a82ah,004303434h
    0c2d2d012h,00b03080bh,0cee2ec2eh,0c9e1e829h,04d515c1dh,084909414h,008101818h,0c8f0f838h
    047535417h,08ea2ac2eh,008000808h,0c5c1c405h,003131013h,0cdc1cc0dh,086828406h,089b1b839h
    0cff3fc3fh,04d717c3dh,0c1c1c001h,001313031h,0c5f1f435h,08a82880ah,04a62682ah,081b1b031h
    0c1d1d011h,000202020h,0c7d3d417h,002020002h,002222022h,004000404h,048606828h,041717031h
    007030407h,0cbd3d81bh,08d919c1dh,089919819h,041616021h,08eb2bc3eh,0c6e2e426h,049515819h
    0cdd1dc1dh,041515011h,080909010h,0ccd0dc1ch,08a92981ah,083a3a023h,08ba3a82bh,0c0d0d010h
    081818001h,00f030c0fh,047434407h,00a12181ah,0c3e3e023h,0cce0ec2ch,08d818c0dh,08fb3bc3fh
    086929416h,04b73783bh,04c505c1ch,082a2a022h,081a1a021h,043636023h,003232023h,04d414c0dh
    0c8c0c808h,08e929c1eh,08c909c1ch,00a32383ah,00c000c0ch,00e222c2eh,08ab2b83ah,04e626c2eh
    08f939c1fh,04a52581ah,0c2f2f032h,082929012h,0c3f3f033h,049414809h,048707838h,0ccc0cc0ch
    005111415h,0cbf3f83bh,040707030h,045717435h,04f737c3fh,005313435h,000101010h,003030003h
    044606424h,04d616c2dh,0c6c2c406h,044707434h,0c5d1d415h,084b0b434h,0cae2e82ah,009010809h
    046727436h,009111819h,0cef2fc3eh,040404000h,002121012h,0c0e0e020h,08db1bc3dh,005010405h
    0caf2f83ah,001010001h,0c0f0f030h,00a22282ah,04e525c1eh,089a1a829h,046525416h,043434003h
    085818405h,004101414h,089818809h,08b93981bh,080b0b030h,0c5e1e425h,048404808h,049717839h
    087939417h,0ccf0fc3ch,00e121c1eh,082828002h,001212021h,08c808c0ch,00b13181bh,04f535c1fh
    047737437h,044505414h,082b2b032h,00d111c1dh,005212425h,04f434c0fh,000000000h,046424406h
    0cde1ec2dh,048505818h,042525012h,0cbe3e82bh,04e727c3eh,0cad2d81ah,0c9c1c809h,0cdf1fc3dh
    000303030h,085919415h,045616425h,00c303c3ch,086b2b436h,0c4e0e424h,08bb3b83bh,04c707c3ch
    00e020c0eh,040505010h,009313839h,006222426h,002323032h,084808404h,049616829h,083939013h
    007333437h,0c7e3e427h,004202424h,084a0a424h,0cbc3c80bh,043535013h,00a02080ah,087838407h
    0c9d1d819h,04c404c0ch,083838003h,08f838c0fh,0cec2cc0eh,00b33383bh,04a42480ah,087b3b437h

###############################################################################

TITLE
    Ruby MARK 5

TYPE
    32 HEX AND

DATA
    456C6091h   0AA7110C3h
    1fh 1bh

###############################################################################

TITLE
    MD5_DS

TYPE
    32 HEX

DATA
    0d76aa478h,0e8c7b756h,242070dbh,0c1bdceeeh,0f57c0fafh,4787c62ah,0a8304613h,0fd469501h,0

###############################################################################

TITLE
    RIPEMD128_DS

TYPE
    32 HEX

DATA
    5a827999h,6ed9eba1h,8f1bbcdch,50a28be6h,5c4dd124h,6d703ef3h

###############################################################################

TITLE
    RIPEMD160_DS

TYPE
    32 HEX

DATA
    7a6d76e9h,0c3d2e1f0h,5a827999h,6ed9eba1h,8f1bbcdch,50a28be6h,5c4dd124h,6d703ef3h

###############################################################################

TITLE
    RIPEMD256_DS

TYPE
    32 HEX

DATA
    7A6D76E9h ,0A953FD4Eh

###############################################################################

TITLE
    WHIRILPOOL_DS

TYPE
    64 HEX

DATA
    018186018c07830d8h, 023238c2305af4626h, 0c6c63fc67ef991b8h, 0e8e887e8136fcdfbh,0878726874ca113cbh, 0b8b8dab8a9626d11h, 00101040108050209h, 04f4f214f426e9e0dh

###############################################################################

TITLE
    SHA1_DS

TYPE
    32 HEX

DATA
    67452301h,0efcdab89h,98badcfeh,10325476h,0c3d2e1f0h,0

###############################################################################

TITLE
    SHA1_DS2

TYPE
    32 HEX

DATA
    5a827999h , 6ed9eba1h , 8f1bbcdch ,0ca62c1d6h,0

###############################################################################

TITLE
    SHA224_DS

TYPE
    32 HEX

DATA
    0c1059ed8h,0367cd507h,03070dd17h,0f70e5939h, 0ffc00b31h,068581511h,064f98fa7h,0befa4fa4h

###############################################################################

TITLE
    SHA256_DS2

TYPE
    32 HEX

DATA
    027b70a85h,02e1b2138h,04d2c6dfch,053380d13h,0650a7354h,0766a0abbh,081c2c92eh,092722c85h
    0a2bfe8a1h,0a81a664bh,0c24b8b70h,0c76c51a3h,0d192e819h,0d6990624h,0f40e3585h,0106aa070h,0

###############################################################################

TITLE
    SHA512_DS

TYPE
    32 HEX

DATA
    0f3bcc908h,84caa73bh,0fe94f82bh,5f1d36f1h,0ade682d1h,2b3e6c1fh,0fb41bd6bh,137e2179h,0

###############################################################################

TITLE
    SHA512_DS2

TYPE
    32 HEX

DATA
    46d22ffch,5c26c926h,5ac42aedh,9d95b3dfh,8baf63deh,3c77b2a8h,47edaee6h,1482353bh
    4cf10364h,0bc423001h,0d0f89791h,0654be30h,0d6ef5218h,5565a910h,5771202ah,32bbd1b8h,0

###############################################################################

TITLE
    SHA384_DS

TYPE
    32 HEX

DATA
    0cbbb9d5dh,0c1059ed8h,629a292ah, 367cd507h,9159015ah ,3070dd17h,152fecd8h,0f70e5939h
    67332667h,0ffc00b31h,8eb44a87h,68581511h,0db0c2e0dh,64f98fa7h,47b5481dh,0befa4fa4h,0

###############################################################################

TITLE
    MD4_DS

TYPE
    32 HEX

DATA
    5A827999h,6ED9EBA1h,67452301h,0efcdab89h,98badcfeh,10325476h,0

###############################################################################

TITLE
    MD5_UNIDS

TYPE
    32 HEX

DATA
    00370036h, 00350034h, 00330032h, 00310030h, 00660065h, 00640063h, 00620061h, 00390038h
    00380039h, 00610062h, 00630064h, 00650066h, 00300031h, 00320033h, 00340035h, 00360037h
    00370064h, 00610036h, 00340061h, 00380037h,0

###############################################################################

TITLE
    CRC32_DS

TYPE
    32 HEX

DATA
    00000000h, 77073096h, 0EE0E612Ch, 990951BAh
    076DC419h, 706AF48Fh, 0E963A535h, 9E6495A3h
    0EDB8832h, 79DCB8A4h, 0E0D5E91Eh, 97D2D988h
    09B64C2Bh, 7EB17CBDh, 0E7B82D07h, 90BF1D91h,0

###############################################################################

TITLE
    CRC16_DS, classical crc16 table

TYPE
    16 HEX

DATA
    00000h, 0C0C1h, 0C181h, 00140h, 0C301h, 003C0h, 00280h, 0C241h
    0C601h, 006C0h, 00780h, 0C741h, 00500h, 0C5C1h, 0C481h, 00440h
    0CC01h, 00CC0h, 00D80h, 0CD41h, 00F00h, 0CFC1h, 0CE81h, 00E40h
    00A00h, 0CAC1h, 0CB81h, 00B40h, 0C901h, 009C0h, 00880h, 0C841h,0

###############################################################################

TITLE
    CRC32b_DS, classical crc32 table

TYPE
    32 HEX

DATA
    000000000h, 004c11db7h, 009823b6eh, 00d4326d9h, 0130476dch, 017c56b6bh
    01a864db2h, 01e475005h, 02608edb8h, 022c9f00fh, 02f8ad6d6h, 02b4bcb61h
    0350c9b64h, 031cd86d3h, 03c8ea00ah, 0384fbdbdh, 04c11db70h, 048d0c6c7h,0

###############################################################################

TITLE
    TIGER_DS

TYPE
    32 HEX

DATA
    02AAB17Ch, 0F7E90C5Eh, 0AC424B03h, 0E243A8ECh, 72CD5BE3h, 0DD5FCD3h, 06D019B93h, 0F6F97F3Ah,0 

###############################################################################

TITLE
    ECC_DS

TYPE
    8 HEX

DATA
    00,0cch,38h,2fh,05h,10h,25h,0aah
    45h,89h,1bh,68h,44h,82h,48h,67h,0dh,0ebh,4fh,0ceh,055h,0

###############################################################################

TITLE
    CAST_DS

TYPE
    32 HEX

DATA
    30fb40d4h, 9fa0ff0bh, 6beccd2fh, 3f258c7ah, 1e213f2fh, 9c004dd3h, 6003e540h,0

###############################################################################

TITLE
    CAST2_DS

TYPE
    32 HEX

DATA
    0e216300dh, 0bbddfffch, 0a7ebdabdh, 35648095h, 7789f8b7h, 0e6c1121bh, 0e241600h,0

###############################################################################

TITLE
    SHA1_UNIDS

TYPE
    32 HEX

DATA
    00370036h, 00350034h, 00330032h, 00310030h, 00660065h, 00640063h, 00620061h, 00390038h
    00380039h, 00610062h, 00630064h, 00650066h, 00300031h, 00320033h, 00340035h, 00360037h
    00610035h, 00320038h, 00390037h, 00390039h,0

###############################################################################

TITLE
    RC56_DS

TYPE
    32 HEX

DATA
    0b7e15163h, 9e3779b9h,0

###############################################################################

TITLE
    RC56_DS1

TYPE
    32 HEX

DATA
    0b7e15163h,61C88647h,0

###############################################################################

TITLE
    RC5_DS

TYPE
    32 HEX

DATA
    0D7C7E065h,075FF5A1Eh,1436D3D7h,0B26E4D90h,050A5C749h,0EEDD4102h
    08D14BABBh,02B4C3474h,0C983AE2Dh,67BB27E6h,005F2A19Fh,0A42A1B58h
    42619511h,0E0990ECAh,7ED08883h,1D08023Ch,0

###############################################################################

TITLE
    RC6_DS

TYPE
    32 HEX

DATA
    0BB3F7BF5h,5976F5AEh
    0F7AE6F67h,95E5E920h,341D62D9h,0D254DC92h,708C564Bh,0EC3D004h
    0ACFB49BDh,4B32C376h,0E96A3D2Fh,87A1B6E8h,25D930A1h,0C410AA5Ah
    62482413h,007F9DCCh,9EB71785h,3CEE913Eh,0

###############################################################################

TITLE
    BF2_DS

TYPE
    32 HEX

DATA
    4B7A70E9h, 0B5B32944h, 0DB75092Eh, 0C4192623h, 0AD6EA6B0h, 49A7DF7Dh, 9CEE60B8h, 8FEDB266h,0

###############################################################################

TITLE
    HAVAL_DS

TYPE
    32 HEX

DATA
    25D479D8h, 0F6E8DEF7h, 0E3FE501Ah, 0B6794C3Bh, 976CE0BDh, 04C006BAh, 0C1A94FB6h, 409F60C4h,0

###############################################################################

TITLE
    HAVAL1_DS

TYPE
    32 HEX

DATA
    0670C9C61h, 0ABD388F0h, 06A51A0D2h, 0D8542F68h, 0960FA728h, 0AB5133A3h, 06EEF0B6Ch, 0137A3BE4h

###############################################################################

TITLE
    HAVAL2_DS

TYPE
    32 HEX

DATA
    0B3EE1411h, 0636FBC2Ah, 02BA9C55Dh, 0741831F6h, 0CE5C3E16h, 09B87931Eh, 0AFD6BA33h, 06C24CF5Ch

###############################################################################

TITLE
    BF_DS

TYPE
    32 HEX

DATA
    243f6a88h, 85a308d3h, 13198a2eh, 03707344h, 0a4093822h, 299f31d0h, 082efa98h,0

###############################################################################

TITLE
    DESL_DS

TYPE
    32 HEX

DATA
    02080800h, 00080000h, 02000002h, 02080802h, 00000802h
    40108010h, 40000010h, 00008000h, 00108010h, 40008010h
    20800080h, 20820080h, 00820000h,01004004h, 01004204h,0

###############################################################################

TITLE
    DESC_DS

TYPE
    8 HEX

DATA
    2Eh,2Fh,30h,31h,32h,33h,34h,35h
    36h,37h,38h,39h,41h,42h,43h,44h
    45h,46h,47h,48h,49h,4Ah,4Bh,4Ch
    4Dh,4Eh,4Fh,50h,51h,52h,53h,54h
    55h,56h,57h,58h,59h,5Ah,61h,62h
    63h,64h,65h,66h,67h,68h,69h,6Ah
    6Bh,6Ch,6Dh,6Eh,6Fh,70h,71h,72h
    73h,74h,75h,76h,77h,78h,79h,7Ah,0

###############################################################################

TITLE
    DESC1_DS

TYPE
    8 HEX

DATA
    0D2h,0D3h,0D4h,0D5h,0D6h,0D7h,0D8h,0D9h
    0DAh,0DBh,0DCh,0DDh,0DEh,0DFh,0E0h,0E1h
    0E2h,0E3h,0E4h,0E5h,0E6h,0E7h,0E8h,0E9h
    0EAh,0EBh,0ECh,0EDh,0EEh,0EFh,0F0h,0F1h
    0F2h,0F3h,0F4h,0F5h,0F6h,0F7h,0F8h,0F9h
    0FAh,0FBh,0FCh,0FDh,0FEh,0FFh,000h,001h
    002h,003h,004h,005h,006h,007h,008h,009h
    00Ah,00Bh,005h,006h,007h,008h,009h,00Ah
    00Bh,00Ch,00Dh,00Eh,00Fh,010h,011h,012h
    013h,014h,015h,016h,017h,018h,019h,01Ah
    01Bh,01Ch,01Dh,01Eh,01Fh,020h,021h,022h
    023h,024h,025h,020h,021h,022h,023h,024h
    025h,026h,027h,028h,029h,02Ah,02Bh,02Ch
    02Dh,02Eh,02Fh,030h,031h,032h,033h,034h
    035h,036h,037h,038h,039h,03Ah,03Bh,03Ch
    03Dh,03Eh,03Fh,040h,041h,042h,043h,044h,0

###############################################################################

TITLE
    DESL1_DS

TYPE
    32 HEX

DATA
    000000D2h,000000D3h,000000D4h,000000D5h,000000D6h,000000D7h,000000D8h,000000D9h
    000000DAh,000000DBh,000000DCh,000000DDh,000000DEh,000000DFh,000000E0h,000000E1h
    000000E2h,000000E3h,000000E4h,000000E5h,000000E6h,000000E7h,000000E8h,000000E9h
    000000EAh,000000EBh,000000ECh,000000EDh,000000EEh,000000EFh,000000F0h,000000F1h
    000000F2h,000000F3h,000000F4h,000000F5h,000000F6h,000000F7h,000000F8h,000000F9h
    000000FAh,000000FBh,000000FCh,000000FDh,000000FEh,000000FFh,00000000h,00000001h
    00000002h,00000003h,00000004h,00000005h,00000006h,00000007h,00000008h,00000009h
    0000000Ah,0000000Bh,00000005h,00000006h,00000007h,00000008h,00000009h,0000000Ah
    0000000Bh,0000000Ch,0000000Dh,0000000Eh,0000000Fh,00000010h,00000011h,00000012h
    00000013h,00000014h,00000015h,00000016h,00000017h,00000018h,00000019h,0000001Ah
    0000001Bh,0000001Ch,0000001Dh,0000001Eh,0000001Fh,00000020h,00000021h,00000022h
    00000023h,00000024h,00000025h,00000020h,00000021h,00000022h,00000023h,00000024h
    00000025h,00000026h,00000027h,00000028h,00000029h,0000002Ah,0000002Bh,0000002Ch
    0000002Dh,0000002Eh,0000002Fh,00000030h,00000031h,00000032h,00000033h,00000034h
    00000035h,00000036h,00000037h,00000038h,00000039h,0000003Ah,0000003Bh,0000003Ch
    0000003Dh,0000003Eh,0000003Fh,00000040h,00000041h,00000042h,00000043h,00000044h

###############################################################################

TITLE
    DES2_DS

TYPE
    32 HEX

DATA
    000080000h,000080010h,020080000h,020080010h
    000090000h,000090010h,020090000h,020090010h
    000080800h,000080810h,020080800h,020080810h
    000090800h,000090810h,020090800h,020090810h
    000080020h,000080030h,020080020h,020080030h
    000090020h,000090030h,020090020h,020090030h
    000080820h,000080830h,020080820h,020080830h
    000090820h,000090830h,020090820h,020090830

###############################################################################

TITLE
    DES3_DS

TYPE
    8 HEX

DATA
    14, 4,13, 1, 2,15,11, 8, 3,10, 6,12, 5, 9, 0, 7h
    0,15, 7, 4,14, 2,13, 1,10, 6,12,11, 9, 5, 3, 8h
    4, 1,14, 8,13, 6, 2,11,15,12, 9, 7, 3,10, 5, 0h
    15,12, 8, 2, 4, 9, 1, 7, 5,11, 3,14,10, 0, 6,13

###############################################################################

TITLE
    RIJNDAEL_DS

TYPE
    8 HEX

DATA
    0a5h,063h,63h,0c6h,84h,7ch,7ch,0f8h,0

###############################################################################

TITLE
    RIJNDAEL1_DS

TYPE
    8

DATA
    225, 248, 152,  17, 105, 217, 142, 148, 155,  30, 135, 233, 206,  85,  40, 223
    140, 161, 137,  13, 191, 230,  66, 104,  65, 153,  45,  15, 176,  84, 187,  22,0

###############################################################################

TITLE
    RIJNDAEL2_DS

TYPE
    8 HEX

DATA
    0d3h,23h,0abh,73h, 02h,0e2h,72h,4bh, 8fh,57h,0e3h,1fh, 0abh,2ah,66h,55h
    28h,07h,0b2h,0ebh, 0c2h,03h,2fh,0b5h, 7bh,9ah,86h,0c5h, 08h,0a5h,0d3h,37h,0

###############################################################################

TITLE
    RC2L_DS

TYPE
    32 HEX

DATA
    0000000d9h,000000078h,0000000f9h,0000000c4h,000000019h,0000000ddh,0000000b5h,0000000edh,000000028h,0000000e9h,0000000fdh,000000079h
    00000004ah,0000000a0h,0000000d8h,00000009dh,0000000c6h,00000007eh,000000037h,000000083h,00000002bh,000000076h,000000053h,00000008eh
    000000062h,00000004ch,000000064h,000000088h,000000044h,00000008bh,0000000fbh,0000000a2h,000000017h,00000009ah,000000059h,0000000f5h
    000000087h,0000000b3h,00000004fh,000000013h,000000061h,000000045h,00000006dh,00000008dh,000000009h,000000081h,00000007dh,000000032h
    0000000bdh,00000008fh,000000040h,0000000ebh,000000086h,0000000b7h,00000007bh,00000000bh,0000000f0h,000000095h,000000021h,000000022h
    00000005ch,00000006bh,00000004eh,000000082h,000000054h,0000000d6h,000000065h,000000093h,0000000ceh,000000060h,0000000b2h,00000001ch
    000000073h,000000056h,0000000c0h,000000014h,0000000a7h,00000008ch,0000000f1h,0000000dch,000000012h,000000075h,0000000cah,00000001fh
    00000003bh,0000000beh,0000000e4h,0000000d1h,000000042h,00000003dh,0000000d4h,000000030h,0000000a3h,00000003ch,0000000b6h,000000026h
    00000006fh,0000000bfh,00000000eh,0000000dah,000000046h,000000069h,000000007h,000000057h,000000027h,0000000f2h,00000001dh,00000009bh
    0000000bch,000000094h,000000043h,000000003h,0000000f8h,000000011h,0000000c7h,0000000f6h,000000090h,0000000efh,00000003eh,0000000e7h
    000000006h,0000000c3h,0000000d5h,00000002fh,0000000c8h,000000066h,00000001eh,0000000d7h,000000008h,0000000e8h,0000000eah,0000000deh
    000000080h,000000052h,0000000eeh,0000000f7h,000000084h,0000000aah,000000072h,0000000ach,000000035h,00000004dh,00000006ah,00000002ah
    000000096h,00000001ah,0000000d2h,000000071h,00000005ah,000000015h,000000049h,000000074h,00000004bh,00000009fh,0000000d0h,00000005eh
    000000004h,000000018h,0000000a4h,0000000ech,0000000c2h,0000000e0h,000000041h,00000006eh,00000000fh,000000051h,0000000cbh,0000000cch
    000000024h,000000091h,0000000afh,000000050h,0000000a1h,0000000f4h,000000070h,000000039h,000000099h,00000007ch,00000003ah,000000085h
    000000023h,0000000b8h,0000000b4h,00000007ah,0000000fch,000000002h,000000036h,00000005bh,000000025h,000000055h,000000097h,000000031h
    00000002dh,00000005dh,0000000fah,000000098h,0000000e3h,00000008ah,000000092h,0000000aeh,000000005h,0000000dfh,000000029h,000000010h
    000000067h,00000006ch,0000000bah,0000000c9h,0000000d3h,000000000h,0000000e6h,0000000cfh,0000000e1h,00000009eh,0000000a8h,00000002ch
    000000063h,000000016h,000000001h,00000003fh,000000058h,0000000e2h,000000089h,0000000a9h,00000000dh,000000038h,000000034h,00000001bh
    0000000abh,000000033h,0000000ffh,0000000b0h,0000000bbh,000000048h,00000000ch,00000005fh,0000000b9h,0000000b1h,0000000cdh,00000002eh
    0000000c5h,0000000f3h,0000000dbh,000000047h,0000000e5h,0000000a5h,00000009ch,000000077h,00000000ah,0000000a6h,000000020h,000000068h
    0000000feh,00000007fh,0000000c1h,0000000adh

###############################################################################

TITLE
    GOST_DS

TYPE
    8 HEX

DATA
    04h,0ah,09h,02h,0ch,08h,000h,0dh,06h,0bh,001h,00ch,07h,0fh,05h,03h,0

###############################################################################

TITLE
    GOST4_DS

TYPE
    8

DATA
    14,  4, 13,  1,  2, 15, 11,  8,  3, 10,  6, 12,  5,  9,  0,  7
    15,  1,  8, 14,  6, 11,  3,  4,  9,  7,  2, 13, 12,  0,  5, 10 
    10,  0,  9, 14,  6,  3, 15,  5,  1, 13, 12,  7, 11,  4,  2,  8 
    7, 13, 14,  3,  0,  6,  9, 10,  1,  2,  8,  5, 11, 12,  4, 15
    2, 12,  4,  1,  7, 10, 11,  6,  8,  5,  3, 15, 13,  0, 14,  9
    12,  1, 10, 15,  9,  2,  6,  8,  0, 13,  3,  4, 14,  7,  5, 11
    4, 11,  2, 14, 15,  0,  8, 13,  3, 12,  9,  7,  5, 10,  6,  1
    13,  2,  8,  4,  6, 15, 11,  1, 10,  9,  3, 14,  5,  0, 12,  7

###############################################################################

TITLE
    TWOFISH_DS

TYPE
    8 HEX

DATA
    0A9h,067h,0B3h,0E8h,004h,0FDh,0A3h,076h,0

###############################################################################

TITLE
    TWOFISH1_DS

TYPE
    8 HEX

DATA
    04fh,0f2h,065h,08eh,078h,05ch,058h,019h
    08dh,0e5h,098h,057h,067h,07fh,005h,064h
    0afh,063h,0b6h,0feh,0f5h,0b7h,03ch,0a5h
    0ceh,0e9h,068h,044h,0e0h,04dh,043h,069h
    029h,02eh,0ach,015h,059h,0a8h,00ah,09eh

###############################################################################

TITLE
    MARS_DS

TYPE
    32 HEX

DATA
    07796943ch, 0facabf3dh, 0c09730cdh, 0f7679969h
    0da44e9edh, 02c854c12h, 035935fa3h, 02f057d9fh
    0690624f8h, 01cb0bafdh, 07b0dbdc6h, 0810f23bbh
    0fa929a1ah, 06d969a17h, 06742979bh, 074ac7d05h

###############################################################################

TITLE
    MARS1_DS

TYPE
    32 HEX

DATA
    009d0c479h,028c8ffe0h,084aa6c39h,09dad7287h,07dff9be3h,0d4268361h
    0c96da1d4h

###############################################################################

TITLE
    ICE1_DS

TYPE
    8 HEX

DATA
    083h, 085h, 09bh, 0cdh
    0cch, 0a7h, 0adh, 041h
    04bh, 02eh, 0d4h, 033h
    0eah, 0cbh, 02eh, 004

###############################################################################

TITLE
    MISTY_DS

TYPE
    8 HEX

DATA
    019h, 012h, 065h, 02fh, 030h, 039h, 008h, 068h, 05fh, 078h, 02ah, 04ch, 064h, 045h, 075h, 03dh
    059h, 048h, 003h, 057h, 07ch, 04fh, 062h, 03ch, 01dh, 021h, 05eh, 027h, 06ah, 070h, 04dh, 03ah

###############################################################################

TITLE
    TEA_DS

TYPE
    32 HEX

DATA
    9E3779B9h,0C6EF3720h

###############################################################################

TITLE
    TEA1_DS

TYPE
    32 HEX

DATA
    9E3779B9h	

###############################################################################

TITLE
    SAFER_DS

TYPE
    8 HEX

DATA
    044h,0E9h,0CDh,0E6h,046h,042h,08Fh,00Ah
    0C1h,0CCh,0B9h,065h,0B0h,0D2h,0C6h,0ACh
    01Eh,041h,062h,029h,02Eh,00Eh,074h,050h
    002h,05Ah,0C3h,025h,07Bh,08Ah,02Ah,05Bh
    0F0h,006h,00Dh,047h,06Fh,070h,09Dh,07Eh
    010h,0CEh,012h,027h,0D5h,04Ch,04Fh,0D6h
    079h,030h,068h,036h,075h,07Dh,0E4h,0EDh
    080h,06Ah,090h,037h,0A2h,05Eh,076h,0AAh

###############################################################################

TITLE
    SAFER1_DS

TYPE
    8 HEX

DATA
    080h, 000h, 0B0h, 009h, 060h, 0EFh, 0B9h, 0FDh
    010h, 012h, 09Fh, 0E4h, 069h, 0BAh, 0ADh, 0F8h
    0C0h, 038h, 0C2h, 065h, 04Fh, 006h, 094h, 0FCh
    019h, 0DEh, 06Ah, 01Bh, 05Dh, 04Eh, 0A8h, 082h
    070h, 0EDh, 0E8h, 0ECh, 072h, 0B3h, 015h, 0C3h
    0FFh, 0ABh, 0B6h, 047h, 044h, 001h, 0ACh, 025h
    0C9h, 0FAh, 08Eh, 041h, 01Ah, 021h, 0CBh, 0D3h
    00Dh, 06Eh, 0FEh, 026h, 058h, 0DAh, 032h, 00Fh

###############################################################################

TITLE
    GOST1_DS

TYPE
    32 HEX

DATA
    000000200h,000000250h,000000270h,000000238h,000000230h,000000240h,000000210h,000000260h	;
    0000004E8h,0000004D8h,0000004A0h,000000488h,000000498h,0000004F8h,0000004A8h,0000004C8h
    000000480h,0000004D0h,0000004F0h,0000004B8h,0000004B0h,0000004C0h,000000490h,0000004E0h
    000000168h,000000158h,000000120h,000000108h,000000118h,000000178h,000000128h,000000148h
    000000100h,000000150h,000000170h,000000138h,000000130h,000000140h,000000110h,000000160h
    0000001E8h,0000001D8h,0000001A0h,000000188h,000000198h,0000001F8h,0000001A8h,0000001C8h
    000000180h,0000001D0h,0000001F0h,0000001B8h,0000001B0h,0000001C0h,000000190h,0000001E0h
    000000768h,000000758h,000000720h,000000708h,000000718h,000000778h,000000728h,000000748h

###############################################################################

TITLE
    GOST2_DS

TYPE
    8 HEX

DATA
    024h, 02Ah, 029h, 022h, 02Dh, 028h, 020h, 02Eh, 026h, 02Bh, 021h, 02Ch, 027h, 02Fh, 025h, 023h
    034h, 03Ah, 039h, 032h, 03Dh, 038h, 030h, 03Eh, 036h, 03Bh, 031h, 03Ch, 037h, 03Fh, 035h, 033h
    084h, 08Ah, 089h, 082h, 08Dh, 088h, 080h, 08Eh, 086h, 08Bh, 081h, 08Ch, 087h, 08Fh, 085h, 083h
    014h, 01Ah, 019h, 012h, 01Dh, 018h, 010h, 01Eh, 016h, 01Bh, 011h, 01Ch, 017h, 01Fh, 015h, 013h
    004h, 00Ah, 009h, 002h, 00Dh, 008h, 000h, 00Eh, 006h, 00Bh, 001h, 00Ch, 007h, 00Fh, 005h, 003h
    074h, 07Ah, 079h, 072h, 07Dh, 078h, 070h, 07Eh, 076h, 07Bh, 071h, 07Ch, 077h, 07Fh, 075h, 073h
    054h, 05Ah, 059h, 052h, 05Dh, 058h, 050h, 05Eh, 056h, 05Bh, 051h, 05Ch, 057h, 05Fh, 055h, 053h
    094h, 09Ah, 099h, 092h, 09Dh, 098h, 090h, 09Eh, 096h, 09Bh, 091h, 09Ch, 097h, 09Fh, 095h, 093h

###############################################################################

TITLE
    GOST3_DS

TYPE
    8 HEX

DATA
    01Dh, 01Bh, 014h, 011h, 013h, 01Fh, 015h, 019h, 010h, 01Ah, 01Eh, 017h, 016h, 018h, 012h, 01Ch
    0FDh, 0FBh, 0F4h, 0F1h, 0F3h, 0FFh, 0F5h, 0F9h, 0F0h, 0FAh, 0FEh, 0F7h, 0F6h, 0F8h, 0F2h, 0FCh
    0DDh, 0DBh, 0D4h, 0D1h, 0D3h, 0DFh, 0D5h, 0D9h, 0D0h, 0DAh, 0DEh, 0D7h, 0D6h, 0D8h, 0D2h, 0DCh
    00Dh, 00Bh, 004h, 001h, 003h, 00Fh, 005h, 009h, 000h, 00Ah, 00Eh, 007h, 006h, 008h, 002h, 00Ch
    05Dh, 05Bh, 054h, 051h, 053h, 05Fh, 055h, 059h, 050h, 05Ah, 05Eh, 057h, 056h, 058h, 052h, 05Ch
    07Dh, 07Bh, 074h, 071h, 073h, 07Fh, 075h, 079h, 070h, 07Ah, 07Eh, 077h, 076h, 078h, 072h, 07Ch
    0ADh, 0ABh, 0A4h, 0A1h, 0A3h, 0AFh, 0A5h, 0A9h, 0A0h, 0AAh, 0AEh, 0A7h, 0A6h, 0A8h, 0A2h, 0ACh
    04Dh, 04Bh, 044h, 041h, 043h, 04Fh, 045h, 049h, 040h, 04Ah, 04Eh, 047h, 046h, 048h, 042h, 04Ch

###############################################################################

TITLE
    ENIGMA_DS

TYPE
    32 HEX

DATA
    08088405h,7FFFFFFFh	;

###############################################################################

TITLE
    SKIPJACK_DS

TYPE
    8 HEX

DATA
    096h,084h,06bh,0bah,0f2h,063h,09ah,019h,07ch,0aeh,0e5h,0f5h,0f7h,016h,06ah,0a2h
    039h,0b6h,07bh,00fh,0c1h,093h,081h,01bh,0eeh,0b4h,01ah,0eah,0d0h,091h,02fh,0b8h
    055h,0b9h,0dah,085h,03fh,041h,0bfh,0e0h,05ah,058h,080h,05fh,066h,00bh,0d8h,090h
    035h,0d5h,0c0h,0a7h,033h,006h,065h,069h,045h,000h,094h,056h,06dh,098h,09bh,076h
    097h,0fch,0b2h,0c2h,0b0h,0feh,0dbh,020h,0e1h,0ebh,0d6h,0e4h,0ddh,047h,04ah,01dh
    042h,0edh,09eh,06eh,049h,03ch,0cdh,043h,027h,0d2h,007h,0d4h,0deh,0c7h,067h,018h
    089h,0cbh,030h,01fh,08dh,0c6h,08fh,0aah,0c8h,074h,0dch,0c9h,05dh,05ch,031h,0a4h
    070h,088h,061h,02ch,09fh,00dh,02bh,087h,050h,082h,054h,064h,026h,07dh,003h,040h

###############################################################################

TITLE
    RUBY_DS

TYPE
    32 HEX

DATA
    0456C6091h,0AA7110C3h

###############################################################################

TITLE
    NEWDES_DS

TYPE
    8

DATA
    194,175,178, 56,196,112, 23,220, 89, 21,164,130,157,  8, 85,251
    216, 44, 94,179,226, 38, 90,119, 40,202, 34,206, 35, 69,231,246
    29,109, 74, 71,176,  6, 60,145, 65, 13, 77,151, 12,127, 95,199
    57,101,  5,232,150,210,129, 24,181, 10,121,187, 48,193,139,252
    219, 64, 88,233, 96,128, 80, 53,191,144,218, 11,106,132,155,104
    91,136, 31, 42,243, 66,126,135, 30, 26, 87,186,182,154,242,123
    82,166,208, 39,152,190,113,205,114,105,225, 84, 73,163, 99,111
    204, 61,200,217,170, 15,198, 28,192,254,134,234,222,  7,236,248

###############################################################################

TITLE
    E2_DS

TYPE
    8 HEX

DATA
    091h, 022h, 004h, 0edh, 0a6h, 048h, 049h, 067h, 0ech, 0f7h, 0c0h, 039h, 0ceh, 0f2h, 02dh, 0beh
    05dh, 01ch, 0e3h, 087h, 007h, 00dh, 07ah, 0f4h, 0fbh, 032h, 0f5h, 08ch, 0dbh, 08fh, 025h, 096h
    0a8h, 0eah, 0cdh, 033h, 065h, 054h, 006h, 08dh, 089h, 00ah, 05eh, 0d9h, 016h, 00eh, 071h, 06ch
    00bh, 0ffh, 060h, 0d2h, 02eh, 0d3h, 0c8h, 055h, 0c2h, 023h, 0b7h, 074h, 0e2h, 09bh, 0dfh, 077h
    02bh, 0b9h, 03ch, 062h, 013h, 0e5h, 094h, 034h, 0b1h, 027h, 084h, 09fh, 0d7h, 051h, 000h, 061h
    0adh, 085h, 073h, 003h, 008h, 040h, 0efh, 068h, 0feh, 097h, 01fh, 0deh, 0afh, 066h, 0e8h, 0b8h
    0aeh, 0bdh, 0b3h, 0ebh, 0c6h, 06bh, 047h, 0a9h, 0d8h, 0a7h, 072h, 0eeh, 01dh, 07eh, 0aah, 0b6h
    075h, 0cbh, 0d4h, 030h, 069h, 020h, 07fh, 037h, 05bh, 09dh, 078h, 0a3h, 0f1h, 076h, 0fah, 005h

###############################################################################

TITLE
    BIGCREATE_DS

TYPE
    8 HEX

DATA
    51h,57h,56h,6ah,04h,68h,00,10h,00,00,6ah,54h,6ah,00,0e8h,30h,11h,00,00,8bh,4dh,08h,85h,0c9h,74h,09h

###############################################################################

TITLE
    BIGDESTROY_DS

TYPE
    8 HEX

DATA
    51h,57h,56h,68h,00,80h,00,00,6ah,00,0ffh,75h,08h,0e8h,0ah,11h,00,00

###############################################################################

TITLE
    CRYPTON

TYPE
    32 HEX AND

DATA
    3fcff3fch,0fc3fcff3h,0f3fc3fcfh,0cff3fc3fh

###############################################################################

TITLE
    HPC

TYPE
    32 HEX AND

DATA
    0a23249d6h,2b992ddfh,0c0b36173h,25b946ebh,0e9e17158h,0c442f56bh

###############################################################################

TITLE
    LOKI

TYPE
    32 HEX AND

DATA
    7f4a7c15h,9e3779b9h

###############################################################################

TITLE
    REDOC3

TYPE
    8

DATA
    1,   3,   5,   7,  11,  13,  17
    19,  23,  29,  31,  37,  41,  43
    47,  53,  59,  61,  67,  71,  73
    79,  83,  89,  97, 101, 103, 107
    109, 113, 127, 131, 137, 139, 149

###############################################################################

TITLE
    S1

TYPE
    8

DATA
    07,02,11,14,10,16,1,15,2,0,3,17,7,3,17,10,17,12,5,13,0,17

###############################################################################

TITLE
    SEAL

TYPE
    32 HEX AND

DATA
    5a827999h,6ed9eba1h,8f1bbcdh,0ca62c1d6h

###############################################################################

TITLE
    SQUARE

TYPE
    32 HEX

DATA
    002BC68E3h,00C628555h,031233F2Ah,0F713AB61h,0726DD498h,0199ACB21h,061A4223Ch,0CD3D9D45h
    023B4FD05h,05F07C42Bh,0C0012C9Bh,00F80D93Dh,0745C6C48h,0857E7FF9h,01FAB73F1h,00EDEEDB6h,0

###############################################################################

TITLE
    SHARK

TYPE
    32 HEX

DATA
    064F9001Bh,0FEDDCDF6h,07C8FF1E2h,011D71514h,08B8C18D3h,0DDDF881Eh,06EAB5056h,088CED8E1h
    049148959h,069C56FD5h,0B7994F03h,00FBCEE3Eh,03C264940h,021557E58h,0E14B3FC2h,02E5CF591h

###############################################################################

TITLE
    Q128

TYPE
    32 HEX

DATA
    0D6D92632h,05E84404Dh,04F341282h,071654B06h,0D48D6A0Bh,0245BECC4h,0C8F84D80h,022C620C9h
    066AA8B02h,00AC697FFh,08B755A36h,02577931Ch,0438D17B6h,0BB7B1BD1h,0E0A8F51Eh,0F4FD583Dh

###############################################################################

TITLE
    FROG

TYPE
    8 HEX

DATA
    071h,015h,0E8h,012h,071h,05Ch,03Fh,09Dh,07Ch,0C1h,0A6h,0C5h,07Eh,038h,0E5h,0E5h
    09Ch,0A2h,036h,011h,0E6h,059h,0BDh,057h,0A9h,000h,051h,0CCh,008h,046h,0CBh,0E1h
    0A0h,03Bh,0A7h,0BDh,064h,09Dh,054h,00Bh,007h,082h,01Dh,033h,020h,02Dh,087h,0EDh
    08Bh,021h,011h,0DDh,018h,032h,059h,04Ah,015h,0CDh,0BFh,0F2h,054h,035h,003h,0E6h
    0E7h,076h,00Fh,00Fh,06Bh,004h,015h,022h,003h,09Ch,039h,042h,05Dh,0FFh,0BFh,003h
    055h,087h,0CDh,0C8h,0B9h,0CCh,034h,025h,023h,018h,044h,0B9h,0C9h,00Ah,0E0h,0EAh
    007h,078h,0C9h,073h,0D8h,067h,039h,0FFh,05Dh,06Eh,02Ah,0F9h,044h,00Eh,01Dh,037h
    080h,054h,025h,098h,0DDh,089h,027h,00Bh,0FCh,032h,090h,023h,0B2h,0BEh,02Bh,0A2h
    067h,0F9h,06Dh,008h,0EBh,021h,09Eh,06Fh,0FCh,0CDh,0A9h,036h,00Ah,014h,0DDh,0C9h
    0B2h,0E0h,059h,0B8h,0B6h,041h,0C9h,00Ah,03Ch,006h,0BFh,0AEh,04Fh,062h,01Ah,0A0h
    0FCh,033h,03Fh,04Fh,006h,066h,07Bh,0ADh,031h,003h,06Eh,0E9h,05Ah,09Eh,0E4h,0D2h
    0D1h,0EDh,01Eh,05Fh,01Ch,0B3h,0CCh,0DCh,048h,0A3h,04Dh,0A6h,0C0h,062h,0A5h,019h
    091h,0A2h,05Bh,0D4h,029h,0E6h,06Eh,006h,06Bh,0BBh,07Fh,026h,052h,062h,01Eh,043h
    0E1h,050h,0D0h,086h,03Ch,0FAh,099h,057h,094h,03Ch,042h,0A5h,048h,01Dh,0A5h,052h
    0D3h,0CFh,000h,0B1h,0CEh,00Dh,006h,00Eh,05Ch,0F8h,03Ch,0C9h,084h,05Fh,023h,0D7h
    076h,0B1h,079h,0B4h,01Bh,053h,083h,01Ah,027h,02Eh,00Ch

###############################################################################

TITLE
    BIGLIB

TYPE
    8 HEX

DATA
    00Fh, 0A3h, 04Eh, 004h, 00Fh, 092h, 0C0h, 008h
    047h, 004h, 08Bh, 055h, 00Ch, 08Bh, 01Ah, 039h, 01Fh

###############################################################################

TITLE
    BIGLIB1

TYPE
    8 HEX

DATA
    08Bh,086h,0D4h,001h,000h,000h,08Bh,04Eh
    018h,0C7h,086h,080h,000h,000h,000h,001h
    000h,000h,000h,08Bh,000h,083h,0C4h,00Ch
    025h,0FFh,0FFh,0FFh,07Fh,08Bh,0D0h,081h
    0E2h,0FFh,0FFh,000h,000h,03Bh,0D1h

###############################################################################

TITLE
    DFC_DS

TYPE
    32 HEX

DATA
    04422a52eh, 0cb238feeh, 0e5ab6addh, 0835fd1a0h
    0753d0a8fh, 078e537d2h, 0b95bb79dh, 08dcaec64h
    02c1e9f23h, 0b829b5c2h, 0780bf387h, 037df8bb3h
    000d01334h, 0a0d0bd86h, 045cbfa73h, 0a6160ffeh

###############################################################################

TITLE
    MMB_DS

TYPE
    32 HEX

DATA
    025F1CDBh,04BE39B6h,12F8E6D8h,2F8E6D81h,0DAD4694h,06D6A34Ah,81B5A8D2h,281B5A8Dh

###############################################################################

TITLE
     zinflate_lengthStarts

TYPE
    16 32

DATA
	3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
	35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258};

###############################################################################

TITLE
     zinflate_lengthExtraBits

TYPE
    8 32

DATA
	0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
	3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0};

###############################################################################

TITLE
     zinflate_distanceStarts

TYPE
    16 32

DATA
	1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
	257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
	8193, 12289, 16385, 24577};

###############################################################################

TITLE
     zinflate_distanceExtraBits

TYPE
    8 16 32

DATA
	0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6,
	7, 7, 8, 8, 9, 9, 10, 10, 11, 11,
	12, 12, 13, 13};

###############################################################################

TITLE
     zdeflate_lengthCodes

TYPE
    32

DATA
	257, 258, 259, 260, 261, 262, 263, 264, 265, 265, 266, 266, 267, 267, 268, 268,
	269, 269, 269, 269, 270, 270, 270, 270, 271, 271, 271, 271, 272, 272, 272, 272,
	273, 273, 273, 273, 273, 273, 273, 273, 274, 274, 274, 274, 274, 274, 274, 274,
	275, 275, 275, 275, 275, 275, 275, 275, 276, 276, 276, 276, 276, 276, 276, 276,
	277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277, 277,
	278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278,
	279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279, 279,
	280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
	281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281,
	281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281, 281,
	282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282,
	282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282, 282,
	283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283,
	283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283, 283,
	284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284,
	284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 284, 285};

###############################################################################

TITLE
     Whirlpool_C0

TYPE
    64

DATA
	0x1818281878c0d878, 0x23236523af0526af,
	0xc6c657c6f97eb8f9, 0xe8e825e86f13fb6f,
	0x87879487a14ccba1, 0xb8b8d5b862a91162,
	0x0101030105080905, 0x4f4fd14f6e420d6e,
	0x36365a36eead9bee, 0xa6a6f7a60459ff04,
	0xd2d26bd2bdde0cbd, 0xf5f502f506fb0e06,
	0x79798b7980ef9680, 0x6f6fb16fce5f30ce,
	0x9191ae91effc6def, 0x5252f65207aaf807,
	0x6060a060fd2747fd, 0xbcbcd9bc76893576,
	0x9b9bb09bcdac37cd, 0x8e8e8f8e8c048a8c,
	0xa3a3f8a31571d215, 0x0c0c140c3c606c3c,
	0x7b7b8d7b8aff848a, 0x35355f35e1b580e1,
	0x1d1d271d69e8f569, 0xe0e03de04753b347,
	0xd7d764d7acf621ac, 0xc2c25bc2ed5e9ced,
	0x2e2e722e966d4396, 0x4b4bdd4b7a62297a,
	0xfefe1ffe21a35d21, 0x5757f9571682d516,
	0x15153f1541a8bd41, 0x77779977b69fe8b6,
	0x37375937eba592eb, 0xe5e532e5567b9e56,
	0x9f9fbc9fd98c13d9, 0xf0f00df017d32317,
	0x4a4ade4a7f6a207f, 0xdada73da959e4495,
	0x5858e85825faa225, 0xc9c946c9ca06cfca,
	0x29297b298d557c8d, 0x0a0a1e0a22505a22,
	0xb1b1ceb14fe1504f, 0xa0a0fda01a69c91a,
	0x6b6bbd6bda7f14da, 0x85859285ab5cd9ab,
	0xbdbddabd73813c73, 0x5d5de75d34d28f34,
	0x1010301050809050, 0xf4f401f403f30703,
	0xcbcb40cbc016ddc0, 0x3e3e423ec6edd3c6,
	0x05050f0511282d11, 0x6767a967e61f78e6,
	0xe4e431e453739753, 0x27276927bb2502bb,
	0x4141c34158327358, 0x8b8b808b9d2ca79d,
	0xa7a7f4a70151f601, 0x7d7d877d94cfb294,
	0x9595a295fbdc49fb, 0xd8d875d89f8e569f,
	0xfbfb10fb308b7030, 0xeeee2fee7123cd71,
	0x7c7c847c91c7bb91, 0x6666aa66e31771e3,
	0xdddd7add8ea67b8e, 0x171739174bb8af4b,
	0x4747c94746024546, 0x9e9ebf9edc841adc,
	0xcaca43cac51ed4c5, 0x2d2d772d99755899,
	0xbfbfdcbf79912e79, 0x070709071b383f1b,
	0xadadeaad2301ac23, 0x5a5aee5a2feab02f,
	0x83839883b56cefb5, 0x33335533ff85b6ff,
	0x6363a563f23f5cf2, 0x020206020a10120a,
	0xaaaae3aa38399338, 0x71719371a8afdea8,
	0xc8c845c8cf0ec6cf, 0x19192b197dc8d17d,
	0x4949db4970723b70, 0xd9d976d99a865f9a,
	0xf2f20bf21dc3311d, 0xe3e338e3484ba848,
	0x5b5bed5b2ae2b92a, 0x888885889234bc92,
	0x9a9ab39ac8a43ec8, 0x26266a26be2d0bbe,
	0x32325632fa8dbffa, 0xb0b0cdb04ae9594a,
	0xe9e926e96a1bf26a, 0x0f0f110f33787733,
	0xd5d562d5a6e633a6, 0x80809d80ba74f4ba,
	0xbebedfbe7c99277c, 0xcdcd4acdde26ebde,
	0x34345c34e4bd89e4, 0x4848d848757a3275,
	0xffff1cff24ab5424, 0x7a7a8e7a8ff78d8f,
	0x9090ad90eaf464ea, 0x5f5fe15f3ec29d3e,
	0x20206020a01d3da0, 0x6868b868d5670fd5,
	0x1a1a2e1a72d0ca72, 0xaeaeefae2c19b72c,
	0xb4b4c1b45ec97d5e, 0x5454fc54199ace19,
	0x9393a893e5ec7fe5, 0x22226622aa0d2faa,
	0x6464ac64e90763e9, 0xf1f10ef112db2a12,
	0x73739573a2bfcca2, 0x121236125a90825a,
	0x4040c0405d3a7a5d, 0x0808180828404828,
	0xc3c358c3e85695e8, 0xecec29ec7b33df7b,
	0xdbdb70db90964d90, 0xa1a1fea11f61c01f,
	0x8d8d8a8d831c9183, 0x3d3d473dc9f5c8c9,
	0x9797a497f1cc5bf1, 0x0000000000000000,
	0xcfcf4ccfd436f9d4, 0x2b2b7d2b87456e87,
	0x76769a76b397e1b3, 0x82829b82b064e6b0,
	0xd6d667d6a9fe28a9, 0x1b1b2d1b77d8c377,
	0xb5b5c2b55bc1745b, 0xafafecaf2911be29,
	0x6a6abe6adf771ddf, 0x5050f0500dbaea0d,
	0x4545cf454c12574c, 0xf3f308f318cb3818,
	0x30305030f09dadf0, 0xefef2cef742bc474,
	0x3f3f413fc3e5dac3, 0x5555ff551c92c71c,
	0xa2a2fba21079db10, 0xeaea23ea6503e965,
	0x6565af65ec0f6aec, 0xbabad3ba68b90368,
	0x2f2f712f93654a93, 0xc0c05dc0e74e8ee7,
	0xdede7fde81be6081, 0x1c1c241c6ce0fc6c,
	0xfdfd1afd2ebb462e, 0x4d4dd74d64521f64,
	0x9292ab92e0e476e0, 0x75759f75bc8ffabc,
	0x06060a061e30361e, 0x8a8a838a9824ae98,
	0xb2b2cbb240f94b40, 0xe6e637e659638559,
	0x0e0e120e36707e36, 0x1f1f211f63f8e763,
	0x6262a662f73755f7, 0xd4d461d4a3ee3aa3,
	0xa8a8e5a832298132, 0x9696a796f4c452f4,
	0xf9f916f93a9b623a, 0xc5c552c5f666a3f6,
	0x25256f25b13510b1, 0x5959eb5920f2ab20,
	0x84849184ae54d0ae, 0x72729672a7b7c5a7,
	0x39394b39ddd5ecdd, 0x4c4cd44c615a1661,
	0x5e5ee25e3bca943b, 0x7878887885e79f85,
	0x38384838d8dde5d8, 0x8c8c898c86149886,
	0xd1d16ed1b2c617b2, 0xa5a5f2a50b41e40b,
	0xe2e23be24d43a14d, 0x6161a361f82f4ef8,
	0xb3b3c8b345f14245, 0x21216321a51534a5,
	0x9c9cb99cd69408d6, 0x1e1e221e66f0ee66,
	0x4343c54352226152, 0xc7c754c7fc76b1fc,
	0xfcfc19fc2bb34f2b, 0x04040c0414202414,
	0x5151f35108b2e308, 0x9999b699c7bc25c7,
	0x6d6db76dc44f22c4, 0x0d0d170d39686539,
	0xfafa13fa35837935, 0xdfdf7cdf84b66984,
	0x7e7e827e9bd7a99b, 0x24246c24b43d19b4,
	0x3b3b4d3bd7c5fed7, 0xababe0ab3d319a3d,
	0xcece4fced13ef0d1, 0x1111331155889955,
	0x8f8f8c8f890c8389, 0x4e4ed24e6b4a046b,
	0xb7b7c4b751d16651, 0xebeb20eb600be060,
	0x3c3c443cccfdc1cc, 0x81819e81bf7cfdbf,
	0x9494a194fed440fe, 0xf7f704f70ceb1c0c,
	0xb9b9d6b967a11867, 0x131335135f988b5f,
	0x2c2c742c9c7d519c, 0xd3d368d3b8d605b8,
	0xe7e734e75c6b8c5c, 0x6e6eb26ecb5739cb,
	0xc4c451c4f36eaaf3, 0x030305030f181b0f,
	0x5656fa56138adc13, 0x4444cc44491a5e49,
	0x7f7f817f9edfa09e, 0xa9a9e6a937218837,
	0x2a2a7e2a824d6782, 0xbbbbd0bb6db10a6d,
	0xc1c15ec1e24687e2, 0x5353f55302a2f102,
	0xdcdc79dc8bae728b, 0x0b0b1d0b27585327,
	0x9d9dba9dd39c01d3, 0x6c6cb46cc1472bc1,
	0x31315331f595a4f5, 0x74749c74b987f3b9,
	0xf6f607f609e31509, 0x4646ca46430a4c43,
	0xacace9ac2609a526, 0x89898689973cb597,
	0x14143c1444a0b444, 0xe1e13ee1425bba42,
	0x16163a164eb0a64e, 0x3a3a4e3ad2cdf7d2,
	0x6969bb69d06f06d0, 0x09091b092d48412d,
	0x70709070ada7d7ad, 0xb6b6c7b654d96f54,
	0xd0d06dd0b7ce1eb7, 0xeded2aed7e3bd67e,
	0xcccc49ccdb2ee2db, 0x4242c642572a6857,
	0x9898b598c2b42cc2, 0xa4a4f1a40e49ed0e,
	0x28287828885d7588, 0x5c5ce45c31da8631,
	0xf8f815f83f936b3f, 0x86869786a444c2a4,

###############################################################################

TITLE
     Whirlpool_C1

TYPE
    64

DATA
	0x781818281878c0d8, 0xaf23236523af0526,
	0xf9c6c657c6f97eb8, 0x6fe8e825e86f13fb,
	0xa187879487a14ccb, 0x62b8b8d5b862a911,
	0x0501010301050809, 0x6e4f4fd14f6e420d,
	0xee36365a36eead9b, 0x04a6a6f7a60459ff,
	0xbdd2d26bd2bdde0c, 0x06f5f502f506fb0e,
	0x8079798b7980ef96, 0xce6f6fb16fce5f30,
	0xef9191ae91effc6d, 0x075252f65207aaf8,
	0xfd6060a060fd2747, 0x76bcbcd9bc768935,
	0xcd9b9bb09bcdac37, 0x8c8e8e8f8e8c048a,
	0x15a3a3f8a31571d2, 0x3c0c0c140c3c606c,
	0x8a7b7b8d7b8aff84, 0xe135355f35e1b580,
	0x691d1d271d69e8f5, 0x47e0e03de04753b3,
	0xacd7d764d7acf621, 0xedc2c25bc2ed5e9c,
	0x962e2e722e966d43, 0x7a4b4bdd4b7a6229,
	0x21fefe1ffe21a35d, 0x165757f9571682d5,
	0x4115153f1541a8bd, 0xb677779977b69fe8,
	0xeb37375937eba592, 0x56e5e532e5567b9e,
	0xd99f9fbc9fd98c13, 0x17f0f00df017d323,
	0x7f4a4ade4a7f6a20, 0x95dada73da959e44,
	0x255858e85825faa2, 0xcac9c946c9ca06cf,
	0x8d29297b298d557c, 0x220a0a1e0a22505a,
	0x4fb1b1ceb14fe150, 0x1aa0a0fda01a69c9,
	0xda6b6bbd6bda7f14, 0xab85859285ab5cd9,
	0x73bdbddabd73813c, 0x345d5de75d34d28f,
	0x5010103010508090, 0x03f4f401f403f307,
	0xc0cbcb40cbc016dd, 0xc63e3e423ec6edd3,
	0x1105050f0511282d, 0xe66767a967e61f78,
	0x53e4e431e4537397, 0xbb27276927bb2502,
	0x584141c341583273, 0x9d8b8b808b9d2ca7,
	0x01a7a7f4a70151f6, 0x947d7d877d94cfb2,
	0xfb9595a295fbdc49, 0x9fd8d875d89f8e56,
	0x30fbfb10fb308b70, 0x71eeee2fee7123cd,
	0x917c7c847c91c7bb, 0xe36666aa66e31771,
	0x8edddd7add8ea67b, 0x4b171739174bb8af,
	0x464747c947460245, 0xdc9e9ebf9edc841a,
	0xc5caca43cac51ed4, 0x992d2d772d997558,
	0x79bfbfdcbf79912e, 0x1b070709071b383f,
	0x23adadeaad2301ac, 0x2f5a5aee5a2feab0,
	0xb583839883b56cef, 0xff33335533ff85b6,
	0xf26363a563f23f5c, 0x0a020206020a1012,
	0x38aaaae3aa383993, 0xa871719371a8afde,
	0xcfc8c845c8cf0ec6, 0x7d19192b197dc8d1,
	0x704949db4970723b, 0x9ad9d976d99a865f,
	0x1df2f20bf21dc331, 0x48e3e338e3484ba8,
	0x2a5b5bed5b2ae2b9, 0x92888885889234bc,
	0xc89a9ab39ac8a43e, 0xbe26266a26be2d0b,
	0xfa32325632fa8dbf, 0x4ab0b0cdb04ae959,
	0x6ae9e926e96a1bf2, 0x330f0f110f337877,
	0xa6d5d562d5a6e633, 0xba80809d80ba74f4,
	0x7cbebedfbe7c9927, 0xdecdcd4acdde26eb,
	0xe434345c34e4bd89, 0x754848d848757a32,
	0x24ffff1cff24ab54, 0x8f7a7a8e7a8ff78d,
	0xea9090ad90eaf464, 0x3e5f5fe15f3ec29d,
	0xa020206020a01d3d, 0xd56868b868d5670f,
	0x721a1a2e1a72d0ca, 0x2caeaeefae2c19b7,
	0x5eb4b4c1b45ec97d, 0x195454fc54199ace,
	0xe59393a893e5ec7f, 0xaa22226622aa0d2f,
	0xe96464ac64e90763, 0x12f1f10ef112db2a,
	0xa273739573a2bfcc, 0x5a121236125a9082,
	0x5d4040c0405d3a7a, 0x2808081808284048,
	0xe8c3c358c3e85695, 0x7becec29ec7b33df,
	0x90dbdb70db90964d, 0x1fa1a1fea11f61c0,
	0x838d8d8a8d831c91, 0xc93d3d473dc9f5c8,
	0xf19797a497f1cc5b, 0x0000000000000000,
	0xd4cfcf4ccfd436f9, 0x872b2b7d2b87456e,
	0xb376769a76b397e1, 0xb082829b82b064e6,
	0xa9d6d667d6a9fe28, 0x771b1b2d1b77d8c3,
	0x5bb5b5c2b55bc174, 0x29afafecaf2911be,
	0xdf6a6abe6adf771d, 0x0d5050f0500dbaea,
	0x4c4545cf454c1257, 0x18f3f308f318cb38,
	0xf030305030f09dad, 0x74efef2cef742bc4,
	0xc33f3f413fc3e5da, 0x1c5555ff551c92c7,
	0x10a2a2fba21079db, 0x65eaea23ea6503e9,
	0xec6565af65ec0f6a, 0x68babad3ba68b903,
	0x932f2f712f93654a, 0xe7c0c05dc0e74e8e,
	0x81dede7fde81be60, 0x6c1c1c241c6ce0fc,
	0x2efdfd1afd2ebb46, 0x644d4dd74d64521f,
	0xe09292ab92e0e476, 0xbc75759f75bc8ffa,
	0x1e06060a061e3036, 0x988a8a838a9824ae,
	0x40b2b2cbb240f94b, 0x59e6e637e6596385,
	0x360e0e120e36707e, 0x631f1f211f63f8e7,
	0xf76262a662f73755, 0xa3d4d461d4a3ee3a,
	0x32a8a8e5a8322981, 0xf49696a796f4c452,
	0x3af9f916f93a9b62, 0xf6c5c552c5f666a3,
	0xb125256f25b13510, 0x205959eb5920f2ab,
	0xae84849184ae54d0, 0xa772729672a7b7c5,
	0xdd39394b39ddd5ec, 0x614c4cd44c615a16,
	0x3b5e5ee25e3bca94, 0x857878887885e79f,
	0xd838384838d8dde5, 0x868c8c898c861498,
	0xb2d1d16ed1b2c617, 0x0ba5a5f2a50b41e4,
	0x4de2e23be24d43a1, 0xf86161a361f82f4e,
	0x45b3b3c8b345f142, 0xa521216321a51534,
	0xd69c9cb99cd69408, 0x661e1e221e66f0ee,
	0x524343c543522261, 0xfcc7c754c7fc76b1,
	0x2bfcfc19fc2bb34f, 0x1404040c04142024,
	0x085151f35108b2e3, 0xc79999b699c7bc25,
	0xc46d6db76dc44f22, 0x390d0d170d396865,
	0x35fafa13fa358379, 0x84dfdf7cdf84b669,
	0x9b7e7e827e9bd7a9, 0xb424246c24b43d19,
	0xd73b3b4d3bd7c5fe, 0x3dababe0ab3d319a,
	0xd1cece4fced13ef0, 0x5511113311558899,
	0x898f8f8c8f890c83, 0x6b4e4ed24e6b4a04,
	0x51b7b7c4b751d166, 0x60ebeb20eb600be0,
	0xcc3c3c443cccfdc1, 0xbf81819e81bf7cfd,
	0xfe9494a194fed440, 0x0cf7f704f70ceb1c,
	0x67b9b9d6b967a118, 0x5f131335135f988b,
	0x9c2c2c742c9c7d51, 0xb8d3d368d3b8d605,
	0x5ce7e734e75c6b8c, 0xcb6e6eb26ecb5739,
	0xf3c4c451c4f36eaa, 0x0f030305030f181b,
	0x135656fa56138adc, 0x494444cc44491a5e,
	0x9e7f7f817f9edfa0, 0x37a9a9e6a9372188,
	0x822a2a7e2a824d67, 0x6dbbbbd0bb6db10a,
	0xe2c1c15ec1e24687, 0x025353f55302a2f1,
	0x8bdcdc79dc8bae72, 0x270b0b1d0b275853,
	0xd39d9dba9dd39c01, 0xc16c6cb46cc1472b,
	0xf531315331f595a4, 0xb974749c74b987f3,
	0x09f6f607f609e315, 0x434646ca46430a4c,
	0x26acace9ac2609a5, 0x9789898689973cb5,
	0x4414143c1444a0b4, 0x42e1e13ee1425bba,
	0x4e16163a164eb0a6, 0xd23a3a4e3ad2cdf7,
	0xd06969bb69d06f06, 0x2d09091b092d4841,
	0xad70709070ada7d7, 0x54b6b6c7b654d96f,
	0xb7d0d06dd0b7ce1e, 0x7eeded2aed7e3bd6,
	0xdbcccc49ccdb2ee2, 0x574242c642572a68,
	0xc29898b598c2b42c, 0x0ea4a4f1a40e49ed,
	0x8828287828885d75, 0x315c5ce45c31da86,
	0x3ff8f815f83f936b, 0xa486869786a444c2,

###############################################################################

TITLE
     Whirlpool_C2

TYPE
    64

DATA
	0xd8781818281878c0, 0x26af23236523af05,
	0xb8f9c6c657c6f97e, 0xfb6fe8e825e86f13,
	0xcba187879487a14c, 0x1162b8b8d5b862a9,
	0x0905010103010508, 0x0d6e4f4fd14f6e42,
	0x9bee36365a36eead, 0xff04a6a6f7a60459,
	0x0cbdd2d26bd2bdde, 0x0e06f5f502f506fb,
	0x968079798b7980ef, 0x30ce6f6fb16fce5f,
	0x6def9191ae91effc, 0xf8075252f65207aa,
	0x47fd6060a060fd27, 0x3576bcbcd9bc7689,
	0x37cd9b9bb09bcdac, 0x8a8c8e8e8f8e8c04,
	0xd215a3a3f8a31571, 0x6c3c0c0c140c3c60,
	0x848a7b7b8d7b8aff, 0x80e135355f35e1b5,
	0xf5691d1d271d69e8, 0xb347e0e03de04753,
	0x21acd7d764d7acf6, 0x9cedc2c25bc2ed5e,
	0x43962e2e722e966d, 0x297a4b4bdd4b7a62,
	0x5d21fefe1ffe21a3, 0xd5165757f9571682,
	0xbd4115153f1541a8, 0xe8b677779977b69f,
	0x92eb37375937eba5, 0x9e56e5e532e5567b,
	0x13d99f9fbc9fd98c, 0x2317f0f00df017d3,
	0x207f4a4ade4a7f6a, 0x4495dada73da959e,
	0xa2255858e85825fa, 0xcfcac9c946c9ca06,
	0x7c8d29297b298d55, 0x5a220a0a1e0a2250,
	0x504fb1b1ceb14fe1, 0xc91aa0a0fda01a69,
	0x14da6b6bbd6bda7f, 0xd9ab85859285ab5c,
	0x3c73bdbddabd7381, 0x8f345d5de75d34d2,
	0x9050101030105080, 0x0703f4f401f403f3,
	0xddc0cbcb40cbc016, 0xd3c63e3e423ec6ed,
	0x2d1105050f051128, 0x78e66767a967e61f,
	0x9753e4e431e45373, 0x02bb27276927bb25,
	0x73584141c3415832, 0xa79d8b8b808b9d2c,
	0xf601a7a7f4a70151, 0xb2947d7d877d94cf,
	0x49fb9595a295fbdc, 0x569fd8d875d89f8e,
	0x7030fbfb10fb308b, 0xcd71eeee2fee7123,
	0xbb917c7c847c91c7, 0x71e36666aa66e317,
	0x7b8edddd7add8ea6, 0xaf4b171739174bb8,
	0x45464747c9474602, 0x1adc9e9ebf9edc84,
	0xd4c5caca43cac51e, 0x58992d2d772d9975,
	0x2e79bfbfdcbf7991, 0x3f1b070709071b38,
	0xac23adadeaad2301, 0xb02f5a5aee5a2fea,
	0xefb583839883b56c, 0xb6ff33335533ff85,
	0x5cf26363a563f23f, 0x120a020206020a10,
	0x9338aaaae3aa3839, 0xdea871719371a8af,
	0xc6cfc8c845c8cf0e, 0xd17d19192b197dc8,
	0x3b704949db497072, 0x5f9ad9d976d99a86,
	0x311df2f20bf21dc3, 0xa848e3e338e3484b,
	0xb92a5b5bed5b2ae2, 0xbc92888885889234,
	0x3ec89a9ab39ac8a4, 0x0bbe26266a26be2d,
	0xbffa32325632fa8d, 0x594ab0b0cdb04ae9,
	0xf26ae9e926e96a1b, 0x77330f0f110f3378,
	0x33a6d5d562d5a6e6, 0xf4ba80809d80ba74,
	0x277cbebedfbe7c99, 0xebdecdcd4acdde26,
	0x89e434345c34e4bd, 0x32754848d848757a,
	0x5424ffff1cff24ab, 0x8d8f7a7a8e7a8ff7,
	0x64ea9090ad90eaf4, 0x9d3e5f5fe15f3ec2,
	0x3da020206020a01d, 0x0fd56868b868d567,
	0xca721a1a2e1a72d0, 0xb72caeaeefae2c19,
	0x7d5eb4b4c1b45ec9, 0xce195454fc54199a,
	0x7fe59393a893e5ec, 0x2faa22226622aa0d,
	0x63e96464ac64e907, 0x2a12f1f10ef112db,
	0xcca273739573a2bf, 0x825a121236125a90,
	0x7a5d4040c0405d3a, 0x4828080818082840,
	0x95e8c3c358c3e856, 0xdf7becec29ec7b33,
	0x4d90dbdb70db9096, 0xc01fa1a1fea11f61,
	0x91838d8d8a8d831c, 0xc8c93d3d473dc9f5,
	0x5bf19797a497f1cc, 0x0000000000000000,
	0xf9d4cfcf4ccfd436, 0x6e872b2b7d2b8745,
	0xe1b376769a76b397, 0xe6b082829b82b064,
	0x28a9d6d667d6a9fe, 0xc3771b1b2d1b77d8,
	0x745bb5b5c2b55bc1, 0xbe29afafecaf2911,
	0x1ddf6a6abe6adf77, 0xea0d5050f0500dba,
	0x574c4545cf454c12, 0x3818f3f308f318cb,
	0xadf030305030f09d, 0xc474efef2cef742b,
	0xdac33f3f413fc3e5, 0xc71c5555ff551c92,
	0xdb10a2a2fba21079, 0xe965eaea23ea6503,
	0x6aec6565af65ec0f, 0x0368babad3ba68b9,
	0x4a932f2f712f9365, 0x8ee7c0c05dc0e74e,
	0x6081dede7fde81be, 0xfc6c1c1c241c6ce0,
	0x462efdfd1afd2ebb, 0x1f644d4dd74d6452,
	0x76e09292ab92e0e4, 0xfabc75759f75bc8f,
	0x361e06060a061e30, 0xae988a8a838a9824,
	0x4b40b2b2cbb240f9, 0x8559e6e637e65963,
	0x7e360e0e120e3670, 0xe7631f1f211f63f8,
	0x55f76262a662f737, 0x3aa3d4d461d4a3ee,
	0x8132a8a8e5a83229, 0x52f49696a796f4c4,
	0x623af9f916f93a9b, 0xa3f6c5c552c5f666,
	0x10b125256f25b135, 0xab205959eb5920f2,
	0xd0ae84849184ae54, 0xc5a772729672a7b7,
	0xecdd39394b39ddd5, 0x16614c4cd44c615a,
	0x943b5e5ee25e3bca, 0x9f857878887885e7,
	0xe5d838384838d8dd, 0x98868c8c898c8614,
	0x17b2d1d16ed1b2c6, 0xe40ba5a5f2a50b41,
	0xa14de2e23be24d43, 0x4ef86161a361f82f,
	0x4245b3b3c8b345f1, 0x34a521216321a515,
	0x08d69c9cb99cd694, 0xee661e1e221e66f0,
	0x61524343c5435222, 0xb1fcc7c754c7fc76,
	0x4f2bfcfc19fc2bb3, 0x241404040c041420,
	0xe3085151f35108b2, 0x25c79999b699c7bc,
	0x22c46d6db76dc44f, 0x65390d0d170d3968,
	0x7935fafa13fa3583, 0x6984dfdf7cdf84b6,
	0xa99b7e7e827e9bd7, 0x19b424246c24b43d,
	0xfed73b3b4d3bd7c5, 0x9a3dababe0ab3d31,
	0xf0d1cece4fced13e, 0x9955111133115588,
	0x83898f8f8c8f890c, 0x046b4e4ed24e6b4a,
	0x6651b7b7c4b751d1, 0xe060ebeb20eb600b,
	0xc1cc3c3c443cccfd, 0xfdbf81819e81bf7c,
	0x40fe9494a194fed4, 0x1c0cf7f704f70ceb,
	0x1867b9b9d6b967a1, 0x8b5f131335135f98,
	0x519c2c2c742c9c7d, 0x05b8d3d368d3b8d6,
	0x8c5ce7e734e75c6b, 0x39cb6e6eb26ecb57,
	0xaaf3c4c451c4f36e, 0x1b0f030305030f18,
	0xdc135656fa56138a, 0x5e494444cc44491a,
	0xa09e7f7f817f9edf, 0x8837a9a9e6a93721,
	0x67822a2a7e2a824d, 0x0a6dbbbbd0bb6db1,
	0x87e2c1c15ec1e246, 0xf1025353f55302a2,
	0x728bdcdc79dc8bae, 0x53270b0b1d0b2758,
	0x01d39d9dba9dd39c, 0x2bc16c6cb46cc147,
	0xa4f531315331f595, 0xf3b974749c74b987,
	0x1509f6f607f609e3, 0x4c434646ca46430a,
	0xa526acace9ac2609, 0xb59789898689973c,
	0xb44414143c1444a0, 0xba42e1e13ee1425b,
	0xa64e16163a164eb0, 0xf7d23a3a4e3ad2cd,
	0x06d06969bb69d06f, 0x412d09091b092d48,
	0xd7ad70709070ada7, 0x6f54b6b6c7b654d9,
	0x1eb7d0d06dd0b7ce, 0xd67eeded2aed7e3b,
	0xe2dbcccc49ccdb2e, 0x68574242c642572a,
	0x2cc29898b598c2b4, 0xed0ea4a4f1a40e49,
	0x758828287828885d, 0x86315c5ce45c31da,
	0x6b3ff8f815f83f93, 0xc2a486869786a444,

###############################################################################

TITLE
     Whirlpool_C3

TYPE
    64

DATA
	0xc0d8781818281878, 0x0526af23236523af,
	0x7eb8f9c6c657c6f9, 0x13fb6fe8e825e86f,
	0x4ccba187879487a1, 0xa91162b8b8d5b862,
	0x0809050101030105, 0x420d6e4f4fd14f6e,
	0xad9bee36365a36ee, 0x59ff04a6a6f7a604,
	0xde0cbdd2d26bd2bd, 0xfb0e06f5f502f506,
	0xef968079798b7980, 0x5f30ce6f6fb16fce,
	0xfc6def9191ae91ef, 0xaaf8075252f65207,
	0x2747fd6060a060fd, 0x893576bcbcd9bc76,
	0xac37cd9b9bb09bcd, 0x048a8c8e8e8f8e8c,
	0x71d215a3a3f8a315, 0x606c3c0c0c140c3c,
	0xff848a7b7b8d7b8a, 0xb580e135355f35e1,
	0xe8f5691d1d271d69, 0x53b347e0e03de047,
	0xf621acd7d764d7ac, 0x5e9cedc2c25bc2ed,
	0x6d43962e2e722e96, 0x62297a4b4bdd4b7a,
	0xa35d21fefe1ffe21, 0x82d5165757f95716,
	0xa8bd4115153f1541, 0x9fe8b677779977b6,
	0xa592eb37375937eb, 0x7b9e56e5e532e556,
	0x8c13d99f9fbc9fd9, 0xd32317f0f00df017,
	0x6a207f4a4ade4a7f, 0x9e4495dada73da95,
	0xfaa2255858e85825, 0x06cfcac9c946c9ca,
	0x557c8d29297b298d, 0x505a220a0a1e0a22,
	0xe1504fb1b1ceb14f, 0x69c91aa0a0fda01a,
	0x7f14da6b6bbd6bda, 0x5cd9ab85859285ab,
	0x813c73bdbddabd73, 0xd28f345d5de75d34,
	0x8090501010301050, 0xf30703f4f401f403,
	0x16ddc0cbcb40cbc0, 0xedd3c63e3e423ec6,
	0x282d1105050f0511, 0x1f78e66767a967e6,
	0x739753e4e431e453, 0x2502bb27276927bb,
	0x3273584141c34158, 0x2ca79d8b8b808b9d,
	0x51f601a7a7f4a701, 0xcfb2947d7d877d94,
	0xdc49fb9595a295fb, 0x8e569fd8d875d89f,
	0x8b7030fbfb10fb30, 0x23cd71eeee2fee71,
	0xc7bb917c7c847c91, 0x1771e36666aa66e3,
	0xa67b8edddd7add8e, 0xb8af4b171739174b,
	0x0245464747c94746, 0x841adc9e9ebf9edc,
	0x1ed4c5caca43cac5, 0x7558992d2d772d99,
	0x912e79bfbfdcbf79, 0x383f1b070709071b,
	0x01ac23adadeaad23, 0xeab02f5a5aee5a2f,
	0x6cefb583839883b5, 0x85b6ff33335533ff,
	0x3f5cf26363a563f2, 0x10120a020206020a,
	0x399338aaaae3aa38, 0xafdea871719371a8,
	0x0ec6cfc8c845c8cf, 0xc8d17d19192b197d,
	0x723b704949db4970, 0x865f9ad9d976d99a,
	0xc3311df2f20bf21d, 0x4ba848e3e338e348,
	0xe2b92a5b5bed5b2a, 0x34bc928888858892,
	0xa43ec89a9ab39ac8, 0x2d0bbe26266a26be,
	0x8dbffa32325632fa, 0xe9594ab0b0cdb04a,
	0x1bf26ae9e926e96a, 0x7877330f0f110f33,
	0xe633a6d5d562d5a6, 0x74f4ba80809d80ba,
	0x99277cbebedfbe7c, 0x26ebdecdcd4acdde,
	0xbd89e434345c34e4, 0x7a32754848d84875,
	0xab5424ffff1cff24, 0xf78d8f7a7a8e7a8f,
	0xf464ea9090ad90ea, 0xc29d3e5f5fe15f3e,
	0x1d3da020206020a0, 0x670fd56868b868d5,
	0xd0ca721a1a2e1a72, 0x19b72caeaeefae2c,
	0xc97d5eb4b4c1b45e, 0x9ace195454fc5419,
	0xec7fe59393a893e5, 0x0d2faa22226622aa,
	0x0763e96464ac64e9, 0xdb2a12f1f10ef112,
	0xbfcca273739573a2, 0x90825a121236125a,
	0x3a7a5d4040c0405d, 0x4048280808180828,
	0x5695e8c3c358c3e8, 0x33df7becec29ec7b,
	0x964d90dbdb70db90, 0x61c01fa1a1fea11f,
	0x1c91838d8d8a8d83, 0xf5c8c93d3d473dc9,
	0xcc5bf19797a497f1, 0x0000000000000000,
	0x36f9d4cfcf4ccfd4, 0x456e872b2b7d2b87,
	0x97e1b376769a76b3, 0x64e6b082829b82b0,
	0xfe28a9d6d667d6a9, 0xd8c3771b1b2d1b77,
	0xc1745bb5b5c2b55b, 0x11be29afafecaf29,
	0x771ddf6a6abe6adf, 0xbaea0d5050f0500d,
	0x12574c4545cf454c, 0xcb3818f3f308f318,
	0x9dadf030305030f0, 0x2bc474efef2cef74,
	0xe5dac33f3f413fc3, 0x92c71c5555ff551c,
	0x79db10a2a2fba210, 0x03e965eaea23ea65,
	0x0f6aec6565af65ec, 0xb90368babad3ba68,
	0x654a932f2f712f93, 0x4e8ee7c0c05dc0e7,
	0xbe6081dede7fde81, 0xe0fc6c1c1c241c6c,
	0xbb462efdfd1afd2e, 0x521f644d4dd74d64,
	0xe476e09292ab92e0, 0x8ffabc75759f75bc,
	0x30361e06060a061e, 0x24ae988a8a838a98,
	0xf94b40b2b2cbb240, 0x638559e6e637e659,
	0x707e360e0e120e36, 0xf8e7631f1f211f63,
	0x3755f76262a662f7, 0xee3aa3d4d461d4a3,
	0x298132a8a8e5a832, 0xc452f49696a796f4,
	0x9b623af9f916f93a, 0x66a3f6c5c552c5f6,
	0x3510b125256f25b1, 0xf2ab205959eb5920,
	0x54d0ae84849184ae, 0xb7c5a772729672a7,
	0xd5ecdd39394b39dd, 0x5a16614c4cd44c61,
	0xca943b5e5ee25e3b, 0xe79f857878887885,
	0xdde5d838384838d8, 0x1498868c8c898c86,
	0xc617b2d1d16ed1b2, 0x41e40ba5a5f2a50b,
	0x43a14de2e23be24d, 0x2f4ef86161a361f8,
	0xf14245b3b3c8b345, 0x1534a521216321a5,
	0x9408d69c9cb99cd6, 0xf0ee661e1e221e66,
	0x2261524343c54352, 0x76b1fcc7c754c7fc,
	0xb34f2bfcfc19fc2b, 0x20241404040c0414,
	0xb2e3085151f35108, 0xbc25c79999b699c7,
	0x4f22c46d6db76dc4, 0x6865390d0d170d39,
	0x837935fafa13fa35, 0xb66984dfdf7cdf84,
	0xd7a99b7e7e827e9b, 0x3d19b424246c24b4,
	0xc5fed73b3b4d3bd7, 0x319a3dababe0ab3d,
	0x3ef0d1cece4fced1, 0x8899551111331155,
	0x0c83898f8f8c8f89, 0x4a046b4e4ed24e6b,
	0xd16651b7b7c4b751, 0x0be060ebeb20eb60,
	0xfdc1cc3c3c443ccc, 0x7cfdbf81819e81bf,
	0xd440fe9494a194fe, 0xeb1c0cf7f704f70c,
	0xa11867b9b9d6b967, 0x988b5f131335135f,
	0x7d519c2c2c742c9c, 0xd605b8d3d368d3b8,
	0x6b8c5ce7e734e75c, 0x5739cb6e6eb26ecb,
	0x6eaaf3c4c451c4f3, 0x181b0f030305030f,
	0x8adc135656fa5613, 0x1a5e494444cc4449,
	0xdfa09e7f7f817f9e, 0x218837a9a9e6a937,
	0x4d67822a2a7e2a82, 0xb10a6dbbbbd0bb6d,
	0x4687e2c1c15ec1e2, 0xa2f1025353f55302,
	0xae728bdcdc79dc8b, 0x5853270b0b1d0b27,
	0x9c01d39d9dba9dd3, 0x472bc16c6cb46cc1,
	0x95a4f531315331f5, 0x87f3b974749c74b9,
	0xe31509f6f607f609, 0x0a4c434646ca4643,
	0x09a526acace9ac26, 0x3cb5978989868997,
	0xa0b44414143c1444, 0x5bba42e1e13ee142,
	0xb0a64e16163a164e, 0xcdf7d23a3a4e3ad2,
	0x6f06d06969bb69d0, 0x48412d09091b092d,
	0xa7d7ad70709070ad, 0xd96f54b6b6c7b654,
	0xce1eb7d0d06dd0b7, 0x3bd67eeded2aed7e,
	0x2ee2dbcccc49ccdb, 0x2a68574242c64257,
	0xb42cc29898b598c2, 0x49ed0ea4a4f1a40e,
	0x5d75882828782888, 0xda86315c5ce45c31,
	0x936b3ff8f815f83f, 0x44c2a486869786a4,

###############################################################################

TITLE
     PKCS_DigestDecoration_MD2

TYPE
    8

DATA
 {0x30,0x20,0x30,0x0c,0x06,0x08,0x2a,0x86,0x48,0x86,0xf7,0x0d,0x02,0x02,0x05,0x00,0x04,0x10};

###############################################################################

TITLE
     PKCS_DigestDecoration_MD5

TYPE
    8

DATA
 {0x30,0x20,0x30,0x0c,0x06,0x08,0x2a,0x86,0x48,0x86,0xf7,0x0d,0x02,0x05,0x05,0x00,0x04,0x10};

###############################################################################

TITLE
     PKCS_DigestDecoration_RIPEMD160

TYPE
    8

DATA
 {0x30,0x21,0x30,0x09,0x06,0x05,0x2b,0x24,0x03,0x02,0x01,0x05,0x00,0x04,0x14};

###############################################################################

TITLE
     PKCS_DigestDecoration_Tiger

TYPE
    8

DATA
 {0x30,0x29,0x30,0x0D,0x06,0x09,0x2B,0x06,0x01,0x04,0x01,0xDA,0x47,0x0C,0x02,0x05,0x00,0x04,0x18};

###############################################################################

TITLE
     PKCS_DigestDecoration_SHA256

TYPE
    8

DATA
 {0x30,0x31,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x01,0x05,0x00,0x04,0x20};

###############################################################################

TITLE
     PKCS_DigestDecoration_SHA384

TYPE
    8

DATA
 {0x30,0x41,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x02,0x05,0x00,0x04,0x30};

###############################################################################

TITLE
     PKCS_DigestDecoration_SHA512

TYPE
    8

DATA
 {0x30,0x51,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x03,0x05,0x00,0x04,0x40};

###############################################################################

TITLE
     HAVAL_wi2

TYPE
    32

DATA
 { 5,14,26,18,11,28, 7,16, 0,23,20,22, 1,10, 4, 8,30, 3,21, 9,17,24,29, 6,19,12,15,13, 2,25,31,27};

###############################################################################

TITLE
     HAVAL_wi3

TYPE
    32

DATA
 {19, 9, 4,20,28,17, 8,22,29,14,25,12,24,30,16,26,31,15, 7, 3, 1, 0,18,27,13, 6,21,10,23,11, 5, 2};

###############################################################################

TITLE
     HAVAL_wi4

TYPE
    32

DATA
 {24, 4, 0,14, 2, 7,28,23,26, 6,30,20,18,25,19, 3,22,11,31,21, 8,27,12, 9, 1,29, 5,15,17,10,16,13};

###############################################################################

TITLE
     HAVAL_wi5

TYPE
    32

DATA
 {27, 3,21,26,17,11,20,29,19, 0,12, 7,13, 8,31,10, 5, 9,14,30,18, 6,28,24, 2,23,16,22, 4, 1,25,15};

###############################################################################

TITLE
     DES_fp

TYPE
    8

DATA
	   40,  8, 48, 16, 56, 24, 64, 32,
	   39,  7, 47, 15, 55, 23, 63, 31,
	   38,  6, 46, 14, 54, 22, 62, 30,
	   37,  5, 45, 13, 53, 21, 61, 29,
	   36,  4, 44, 12, 52, 20, 60, 28,
	   35,  3, 43, 11, 51, 19, 59, 27,
	   34,  2, 42, 10, 50, 18, 58, 26,
	   33,  1, 41,  9, 49, 17, 57, 25

###############################################################################

TITLE
     DES_ei

TYPE
    8

DATA
	   32,  1,  2,  3,  4,  5,
		4,  5,  6,  7,  8,  9,
		8,  9, 10, 11, 12, 13,
	   12, 13, 14, 15, 16, 17,
	   16, 17, 18, 19, 20, 21,
	   20, 21, 22, 23, 24, 25,
	   24, 25, 26, 27, 28, 29,
	   28, 29, 30, 31, 32,  1

###############################################################################

TITLE
     DES_p32i

TYPE
    8

DATA
	   16,  7, 20, 21,
	   29, 12, 28, 17,
		1, 15, 23, 26,
		5, 18, 31, 10,
		2,  8, 24, 14,
	   32, 27,  3,  9,
	   19, 13, 30,  6,
	   22, 11,  4, 25

###############################################################################

TITLE
     CAST_S

TYPE
    32

DATA
	0x30FB40D4UL, 0x9FA0FF0BUL, 0x6BECCD2FUL, 0x3F258C7AUL,
	0x1E213F2FUL, 0x9C004DD3UL, 0x6003E540UL, 0xCF9FC949UL,
	0xBFD4AF27UL, 0x88BBBDB5UL, 0xE2034090UL, 0x98D09675UL,
	0x6E63A0E0UL, 0x15C361D2UL, 0xC2E7661DUL, 0x22D4FF8EUL,
	0x28683B6FUL, 0xC07FD059UL, 0xFF2379C8UL, 0x775F50E2UL,
	0x43C340D3UL, 0xDF2F8656UL, 0x887CA41AUL, 0xA2D2BD2DUL,
	0xA1C9E0D6UL, 0x346C4819UL, 0x61B76D87UL, 0x22540F2FUL,
	0x2ABE32E1UL, 0xAA54166BUL, 0x22568E3AUL, 0xA2D341D0UL,
	0x66DB40C8UL, 0xA784392FUL, 0x004DFF2FUL, 0x2DB9D2DEUL,
	0x97943FACUL, 0x4A97C1D8UL, 0x527644B7UL, 0xB5F437A7UL,
	0xB82CBAEFUL, 0xD751D159UL, 0x6FF7F0EDUL, 0x5A097A1FUL,
	0x827B68D0UL, 0x90ECF52EUL, 0x22B0C054UL, 0xBC8E5935UL,
	0x4B6D2F7FUL, 0x50BB64A2UL, 0xD2664910UL, 0xBEE5812DUL,
	0xB7332290UL, 0xE93B159FUL, 0xB48EE411UL, 0x4BFF345DUL,
	0xFD45C240UL, 0xAD31973FUL, 0xC4F6D02EUL, 0x55FC8165UL,
	0xD5B1CAADUL, 0xA1AC2DAEUL, 0xA2D4B76DUL, 0xC19B0C50UL,
	0x882240F2UL, 0x0C6E4F38UL, 0xA4E4BFD7UL, 0x4F5BA272UL,
	0x564C1D2FUL, 0xC59C5319UL, 0xB949E354UL, 0xB04669FEUL,
	0xB1B6AB8AUL, 0xC71358DDUL, 0x6385C545UL, 0x110F935DUL,
	0x57538AD5UL, 0x6A390493UL, 0xE63D37E0UL, 0x2A54F6B3UL,
	0x3A787D5FUL, 0x6276A0B5UL, 0x19A6FCDFUL, 0x7A42206AUL,
	0x29F9D4D5UL, 0xF61B1891UL, 0xBB72275EUL, 0xAA508167UL,
	0x38901091UL, 0xC6B505EBUL, 0x84C7CB8CUL, 0x2AD75A0FUL,
	0x874A1427UL, 0xA2D1936BUL, 0x2AD286AFUL, 0xAA56D291UL,
	0xD7894360UL, 0x425C750DUL, 0x93B39E26UL, 0x187184C9UL,
	0x6C00B32DUL, 0x73E2BB14UL, 0xA0BEBC3CUL, 0x54623779UL,
	0x64459EABUL, 0x3F328B82UL, 0x7718CF82UL, 0x59A2CEA6UL,
	0x04EE002EUL, 0x89FE78E6UL, 0x3FAB0950UL, 0x325FF6C2UL,
	0x81383F05UL, 0x6963C5C8UL, 0x76CB5AD6UL, 0xD49974C9UL,
	0xCA180DCFUL, 0x380782D5UL, 0xC7FA5CF6UL, 0x8AC31511UL,
	0x35E79E13UL, 0x47DA91D0UL, 0xF40F9086UL, 0xA7E2419EUL,
	0x31366241UL, 0x051EF495UL, 0xAA573B04UL, 0x4A805D8DUL,
	0x548300D0UL, 0x00322A3CUL, 0xBF64CDDFUL, 0xBA57A68EUL,
	0x75C6372BUL, 0x50AFD341UL, 0xA7C13275UL, 0x915A0BF5UL,
	0x6B54BFABUL, 0x2B0B1426UL, 0xAB4CC9D7UL, 0x449CCD82UL,
	0xF7FBF265UL, 0xAB85C5F3UL, 0x1B55DB94UL, 0xAAD4E324UL,
	0xCFA4BD3FUL, 0x2DEAA3E2UL, 0x9E204D02UL, 0xC8BD25ACUL,
	0xEADF55B3UL, 0xD5BD9E98UL, 0xE31231B2UL, 0x2AD5AD6CUL,
	0x954329DEUL, 0xADBE4528UL, 0xD8710F69UL, 0xAA51C90FUL,
	0xAA786BF6UL, 0x22513F1EUL, 0xAA51A79BUL, 0x2AD344CCUL,
	0x7B5A41F0UL, 0xD37CFBADUL, 0x1B069505UL, 0x41ECE491UL,
	0xB4C332E6UL, 0x032268D4UL, 0xC9600ACCUL, 0xCE387E6DUL,
	0xBF6BB16CUL, 0x6A70FB78UL, 0x0D03D9C9UL, 0xD4DF39DEUL,
	0xE01063DAUL, 0x4736F464UL, 0x5AD328D8UL, 0xB347CC96UL,
	0x75BB0FC3UL, 0x98511BFBUL, 0x4FFBCC35UL, 0xB58BCF6AUL,
	0xE11F0ABCUL, 0xBFC5FE4AUL, 0xA70AEC10UL, 0xAC39570AUL,
	0x3F04442FUL, 0x6188B153UL, 0xE0397A2EUL, 0x5727CB79UL,
	0x9CEB418FUL, 0x1CACD68DUL, 0x2AD37C96UL, 0x0175CB9DUL,
	0xC69DFF09UL, 0xC75B65F0UL, 0xD9DB40D8UL, 0xEC0E7779UL,
	0x4744EAD4UL, 0xB11C3274UL, 0xDD24CB9EUL, 0x7E1C54BDUL,
	0xF01144F9UL, 0xD2240EB1UL, 0x9675B3FDUL, 0xA3AC3755UL,
	0xD47C27AFUL, 0x51C85F4DUL, 0x56907596UL, 0xA5BB15E6UL,
	0x580304F0UL, 0xCA042CF1UL, 0x011A37EAUL, 0x8DBFAADBUL,
	0x35BA3E4AUL, 0x3526FFA0UL, 0xC37B4D09UL, 0xBC306ED9UL,
	0x98A52666UL, 0x5648F725UL, 0xFF5E569DUL, 0x0CED63D0UL,
	0x7C63B2CFUL, 0x700B45E1UL, 0xD5EA50F1UL, 0x85A92872UL,
	0xAF1FBDA7UL, 0xD4234870UL, 0xA7870BF3UL, 0x2D3B4D79UL,
	0x42E04198UL, 0x0CD0EDE7UL, 0x26470DB8UL, 0xF881814CUL,
	0x474D6AD7UL, 0x7C0C5E5CUL, 0xD1231959UL, 0x381B7298UL,
	0xF5D2F4DBUL, 0xAB838653UL, 0x6E2F1E23UL, 0x83719C9EUL,
	0xBD91E046UL, 0x9A56456EUL, 0xDC39200CUL, 0x20C8C571UL,
	0x962BDA1CUL, 0xE1E696FFUL, 0xB141AB08UL, 0x7CCA89B9UL,
	0x1A69E783UL, 0x02CC4843UL, 0xA2F7C579UL, 0x429EF47DUL,
	0x427B169CUL, 0x5AC9F049UL, 0xDD8F0F00UL, 0x5C8165BFUL
,
	0x1F201094UL, 0xEF0BA75BUL, 0x69E3CF7EUL, 0x393F4380UL,
	0xFE61CF7AUL, 0xEEC5207AUL, 0x55889C94UL, 0x72FC0651UL,
	0xADA7EF79UL, 0x4E1D7235UL, 0xD55A63CEUL, 0xDE0436BAUL,
	0x99C430EFUL, 0x5F0C0794UL, 0x18DCDB7DUL, 0xA1D6EFF3UL,
	0xA0B52F7BUL, 0x59E83605UL, 0xEE15B094UL, 0xE9FFD909UL,
	0xDC440086UL, 0xEF944459UL, 0xBA83CCB3UL, 0xE0C3CDFBUL,
	0xD1DA4181UL, 0x3B092AB1UL, 0xF997F1C1UL, 0xA5E6CF7BUL,
	0x01420DDBUL, 0xE4E7EF5BUL, 0x25A1FF41UL, 0xE180F806UL,
	0x1FC41080UL, 0x179BEE7AUL, 0xD37AC6A9UL, 0xFE5830A4UL,
	0x98DE8B7FUL, 0x77E83F4EUL, 0x79929269UL, 0x24FA9F7BUL,
	0xE113C85BUL, 0xACC40083UL, 0xD7503525UL, 0xF7EA615FUL,
	0x62143154UL, 0x0D554B63UL, 0x5D681121UL, 0xC866C359UL,
	0x3D63CF73UL, 0xCEE234C0UL, 0xD4D87E87UL, 0x5C672B21UL,
	0x071F6181UL, 0x39F7627FUL, 0x361E3084UL, 0xE4EB573BUL,
	0x602F64A4UL, 0xD63ACD9CUL, 0x1BBC4635UL, 0x9E81032DUL,
	0x2701F50CUL, 0x99847AB4UL, 0xA0E3DF79UL, 0xBA6CF38CUL,
	0x10843094UL, 0x2537A95EUL, 0xF46F6FFEUL, 0xA1FF3B1FUL,
	0x208CFB6AUL, 0x8F458C74UL, 0xD9E0A227UL, 0x4EC73A34UL,
	0xFC884F69UL, 0x3E4DE8DFUL, 0xEF0E0088UL, 0x3559648DUL,
	0x8A45388CUL, 0x1D804366UL, 0x721D9BFDUL, 0xA58684BBUL,
	0xE8256333UL, 0x844E8212UL, 0x128D8098UL, 0xFED33FB4UL,
	0xCE280AE1UL, 0x27E19BA5UL, 0xD5A6C252UL, 0xE49754BDUL,
	0xC5D655DDUL, 0xEB667064UL, 0x77840B4DUL, 0xA1B6A801UL,
	0x84DB26A9UL, 0xE0B56714UL, 0x21F043B7UL, 0xE5D05860UL,
	0x54F03084UL, 0x066FF472UL, 0xA31AA153UL, 0xDADC4755UL,
	0xB5625DBFUL, 0x68561BE6UL, 0x83CA6B94UL, 0x2D6ED23BUL,
	0xECCF01DBUL, 0xA6D3D0BAUL, 0xB6803D5CUL, 0xAF77A709UL,
	0x33B4A34CUL, 0x397BC8D6UL, 0x5EE22B95UL, 0x5F0E5304UL,
	0x81ED6F61UL, 0x20E74364UL, 0xB45E1378UL, 0xDE18639BUL,
	0x881CA122UL, 0xB96726D1UL, 0x8049A7E8UL, 0x22B7DA7BUL,
	0x5E552D25UL, 0x5272D237UL, 0x79D2951CUL, 0xC60D894CUL,
	0x488CB402UL, 0x1BA4FE5BUL, 0xA4B09F6BUL, 0x1CA815CFUL,
	0xA20C3005UL, 0x8871DF63UL, 0xB9DE2FCBUL, 0x0CC6C9E9UL,
	0x0BEEFF53UL, 0xE3214517UL, 0xB4542835UL, 0x9F63293CUL,
	0xEE41E729UL, 0x6E1D2D7CUL, 0x50045286UL, 0x1E6685F3UL,
	0xF33401C6UL, 0x30A22C95UL, 0x31A70850UL, 0x60930F13UL,
	0x73F98417UL, 0xA1269859UL, 0xEC645C44UL, 0x52C877A9UL,
	0xCDFF33A6UL, 0xA02B1741UL, 0x7CBAD9A2UL, 0x2180036FUL,
	0x50D99C08UL, 0xCB3F4861UL, 0xC26BD765UL, 0x64A3F6ABUL,
	0x80342676UL, 0x25A75E7BUL, 0xE4E6D1FCUL, 0x20C710E6UL,
	0xCDF0B680UL, 0x17844D3BUL, 0x31EEF84DUL, 0x7E0824E4UL,
	0x2CCB49EBUL, 0x846A3BAEUL, 0x8FF77888UL, 0xEE5D60F6UL,
	0x7AF75673UL, 0x2FDD5CDBUL, 0xA11631C1UL, 0x30F66F43UL,
	0xB3FAEC54UL, 0x157FD7FAUL, 0xEF8579CCUL, 0xD152DE58UL,
	0xDB2FFD5EUL, 0x8F32CE19UL, 0x306AF97AUL, 0x02F03EF8UL,
	0x99319AD5UL, 0xC242FA0FUL, 0xA7E3EBB0UL, 0xC68E4906UL,
	0xB8DA230CUL, 0x80823028UL, 0xDCDEF3C8UL, 0xD35FB171UL,
	0x088A1BC8UL, 0xBEC0C560UL, 0x61A3C9E8UL, 0xBCA8F54DUL,
	0xC72FEFFAUL, 0x22822E99UL, 0x82C570B4UL, 0xD8D94E89UL,
	0x8B1C34BCUL, 0x301E16E6UL, 0x273BE979UL, 0xB0FFEAA6UL,
	0x61D9B8C6UL, 0x00B24869UL, 0xB7FFCE3FUL, 0x08DC283BUL,
	0x43DAF65AUL, 0xF7E19798UL, 0x7619B72FUL, 0x8F1C9BA4UL,
	0xDC8637A0UL, 0x16A7D3B1UL, 0x9FC393B7UL, 0xA7136EEBUL,
	0xC6BCC63EUL, 0x1A513742UL, 0xEF6828BCUL, 0x520365D6UL,
	0x2D6A77ABUL, 0x3527ED4BUL, 0x821FD216UL, 0x095C6E2EUL,
	0xDB92F2FBUL, 0x5EEA29CBUL, 0x145892F5UL, 0x91584F7FUL,
	0x5483697BUL, 0x2667A8CCUL, 0x85196048UL, 0x8C4BACEAUL,
	0x833860D4UL, 0x0D23E0F9UL, 0x6C387E8AUL, 0x0AE6D249UL,
	0xB284600CUL, 0xD835731DUL, 0xDCB1C647UL, 0xAC4C56EAUL,
	0x3EBD81B3UL, 0x230EABB0UL, 0x6438BC87UL, 0xF0B5B1FAUL,
	0x8F5EA2B3UL, 0xFC184642UL, 0x0A036B7AUL, 0x4FB089BDUL,
	0x649DA589UL, 0xA345415EUL, 0x5C038323UL, 0x3E5D3BB9UL,
	0x43D79572UL, 0x7E6DD07CUL, 0x06DFDF1EUL, 0x6C6CC4EFUL,
	0x7160A539UL, 0x73BFBE70UL, 0x83877605UL, 0x4523ECF1UL
,
	0x8DEFC240UL, 0x25FA5D9FUL, 0xEB903DBFUL, 0xE810C907UL,
	0x47607FFFUL, 0x369FE44BUL, 0x8C1FC644UL, 0xAECECA90UL,
	0xBEB1F9BFUL, 0xEEFBCAEAUL, 0xE8CF1950UL, 0x51DF07AEUL,
	0x920E8806UL, 0xF0AD0548UL, 0xE13C8D83UL, 0x927010D5UL,
	0x11107D9FUL, 0x07647DB9UL, 0xB2E3E4D4UL, 0x3D4F285EUL,
	0xB9AFA820UL, 0xFADE82E0UL, 0xA067268BUL, 0x8272792EUL,
	0x553FB2C0UL, 0x489AE22BUL, 0xD4EF9794UL, 0x125E3FBCUL,
	0x21FFFCEEUL, 0x825B1BFDUL, 0x9255C5EDUL, 0x1257A240UL,
	0x4E1A8302UL, 0xBAE07FFFUL, 0x528246E7UL, 0x8E57140EUL,
	0x3373F7BFUL, 0x8C9F8188UL, 0xA6FC4EE8UL, 0xC982B5A5UL,
	0xA8C01DB7UL, 0x579FC264UL, 0x67094F31UL, 0xF2BD3F5FUL,
	0x40FFF7C1UL, 0x1FB78DFCUL, 0x8E6BD2C1UL, 0x437BE59BUL,
	0x99B03DBFUL, 0xB5DBC64BUL, 0x638DC0E6UL, 0x55819D99UL,
	0xA197C81CUL, 0x4A012D6EUL, 0xC5884A28UL, 0xCCC36F71UL,
	0xB843C213UL, 0x6C0743F1UL, 0x8309893CUL, 0x0FEDDD5FUL,
	0x2F7FE850UL, 0xD7C07F7EUL, 0x02507FBFUL, 0x5AFB9A04UL,
	0xA747D2D0UL, 0x1651192EUL, 0xAF70BF3EUL, 0x58C31380UL,
	0x5F98302EUL, 0x727CC3C4UL, 0x0A0FB402UL, 0x0F7FEF82UL,
	0x8C96FDADUL, 0x5D2C2AAEUL, 0x8EE99A49UL, 0x50DA88B8UL,
	0x8427F4A0UL, 0x1EAC5790UL, 0x796FB449UL, 0x8252DC15UL,
	0xEFBD7D9BUL, 0xA672597DUL, 0xADA840D8UL, 0x45F54504UL,
	0xFA5D7403UL, 0xE83EC305UL, 0x4F91751AUL, 0x925669C2UL,
	0x23EFE941UL, 0xA903F12EUL, 0x60270DF2UL, 0x0276E4B6UL,
	0x94FD6574UL, 0x927985B2UL, 0x8276DBCBUL, 0x02778176UL,
	0xF8AF918DUL, 0x4E48F79EUL, 0x8F616DDFUL, 0xE29D840EUL,
	0x842F7D83UL, 0x340CE5C8UL, 0x96BBB682UL, 0x93B4B148UL,
	0xEF303CABUL, 0x984FAF28UL, 0x779FAF9BUL, 0x92DC560DUL,
	0x224D1E20UL, 0x8437AA88UL, 0x7D29DC96UL, 0x2756D3DCUL,
	0x8B907CEEUL, 0xB51FD240UL, 0xE7C07CE3UL, 0xE566B4A1UL,
	0xC3E9615EUL, 0x3CF8209DUL, 0x6094D1E3UL, 0xCD9CA341UL,
	0x5C76460EUL, 0x00EA983BUL, 0xD4D67881UL, 0xFD47572CUL,
	0xF76CEDD9UL, 0xBDA8229CUL, 0x127DADAAUL, 0x438A074EUL,
	0x1F97C090UL, 0x081BDB8AUL, 0x93A07EBEUL, 0xB938CA15UL,
	0x97B03CFFUL, 0x3DC2C0F8UL, 0x8D1AB2ECUL, 0x64380E51UL,
	0x68CC7BFBUL, 0xD90F2788UL, 0x12490181UL, 0x5DE5FFD4UL,
	0xDD7EF86AUL, 0x76A2E214UL, 0xB9A40368UL, 0x925D958FUL,
	0x4B39FFFAUL, 0xBA39AEE9UL, 0xA4FFD30BUL, 0xFAF7933BUL,
	0x6D498623UL, 0x193CBCFAUL, 0x27627545UL, 0x825CF47AUL,
	0x61BD8BA0UL, 0xD11E42D1UL, 0xCEAD04F4UL, 0x127EA392UL,
	0x10428DB7UL, 0x8272A972UL, 0x9270C4A8UL, 0x127DE50BUL,
	0x285BA1C8UL, 0x3C62F44FUL, 0x35C0EAA5UL, 0xE805D231UL,
	0x428929FBUL, 0xB4FCDF82UL, 0x4FB66A53UL, 0x0E7DC15BUL,
	0x1F081FABUL, 0x108618AEUL, 0xFCFD086DUL, 0xF9FF2889UL,
	0x694BCC11UL, 0x236A5CAEUL, 0x12DECA4DUL, 0x2C3F8CC5UL,
	0xD2D02DFEUL, 0xF8EF5896UL, 0xE4CF52DAUL, 0x95155B67UL,
	0x494A488CUL, 0xB9B6A80CUL, 0x5C8F82BCUL, 0x89D36B45UL,
	0x3A609437UL, 0xEC00C9A9UL, 0x44715253UL, 0x0A874B49UL,
	0xD773BC40UL, 0x7C34671CUL, 0x02717EF6UL, 0x4FEB5536UL,
	0xA2D02FFFUL, 0xD2BF60C4UL, 0xD43F03C0UL, 0x50B4EF6DUL,
	0x07478CD1UL, 0x006E1888UL, 0xA2E53F55UL, 0xB9E6D4BCUL,
	0xA2048016UL, 0x97573833UL, 0xD7207D67UL, 0xDE0F8F3DUL,
	0x72F87B33UL, 0xABCC4F33UL, 0x7688C55DUL, 0x7B00A6B0UL,
	0x947B0001UL, 0x570075D2UL, 0xF9BB88F8UL, 0x8942019EUL,
	0x4264A5FFUL, 0x856302E0UL, 0x72DBD92BUL, 0xEE971B69UL,
	0x6EA22FDEUL, 0x5F08AE2BUL, 0xAF7A616DUL, 0xE5C98767UL,
	0xCF1FEBD2UL, 0x61EFC8C2UL, 0xF1AC2571UL, 0xCC8239C2UL,
	0x67214CB8UL, 0xB1E583D1UL, 0xB7DC3E62UL, 0x7F10BDCEUL,
	0xF90A5C38UL, 0x0FF0443DUL, 0x606E6DC6UL, 0x60543A49UL,
	0x5727C148UL, 0x2BE98A1DUL, 0x8AB41738UL, 0x20E1BE24UL,
	0xAF96DA0FUL, 0x68458425UL, 0x99833BE5UL, 0x600D457DUL,
	0x282F9350UL, 0x8334B362UL, 0xD91D1120UL, 0x2B6D8DA0UL,
	0x642B1E31UL, 0x9C305A00UL, 0x52BCE688UL, 0x1B03588AUL,
	0xF7BAEFD5UL, 0x4142ED9CUL, 0xA4315C11UL, 0x83323EC5UL,
	0xDFEF4636UL, 0xA133C501UL, 0xE9D3531CUL, 0xEE353783UL
,
	0x9DB30420UL, 0x1FB6E9DEUL, 0xA7BE7BEFUL, 0xD273A298UL,
	0x4A4F7BDBUL, 0x64AD8C57UL, 0x85510443UL, 0xFA020ED1UL,
	0x7E287AFFUL, 0xE60FB663UL, 0x095F35A1UL, 0x79EBF120UL,
	0xFD059D43UL, 0x6497B7B1UL, 0xF3641F63UL, 0x241E4ADFUL,
	0x28147F5FUL, 0x4FA2B8CDUL, 0xC9430040UL, 0x0CC32220UL,
	0xFDD30B30UL, 0xC0A5374FUL, 0x1D2D00D9UL, 0x24147B15UL,
	0xEE4D111AUL, 0x0FCA5167UL, 0x71FF904CUL, 0x2D195FFEUL,
	0x1A05645FUL, 0x0C13FEFEUL, 0x081B08CAUL, 0x05170121UL,
	0x80530100UL, 0xE83E5EFEUL, 0xAC9AF4F8UL, 0x7FE72701UL,
	0xD2B8EE5FUL, 0x06DF4261UL, 0xBB9E9B8AUL, 0x7293EA25UL,
	0xCE84FFDFUL, 0xF5718801UL, 0x3DD64B04UL, 0xA26F263BUL,
	0x7ED48400UL, 0x547EEBE6UL, 0x446D4CA0UL, 0x6CF3D6F5UL,
	0x2649ABDFUL, 0xAEA0C7F5UL, 0x36338CC1UL, 0x503F7E93UL,
	0xD3772061UL, 0x11B638E1UL, 0x72500E03UL, 0xF80EB2BBUL,
	0xABE0502EUL, 0xEC8D77DEUL, 0x57971E81UL, 0xE14F6746UL,
	0xC9335400UL, 0x6920318FUL, 0x081DBB99UL, 0xFFC304A5UL,
	0x4D351805UL, 0x7F3D5CE3UL, 0xA6C866C6UL, 0x5D5BCCA9UL,
	0xDAEC6FEAUL, 0x9F926F91UL, 0x9F46222FUL, 0x3991467DUL,
	0xA5BF6D8EUL, 0x1143C44FUL, 0x43958302UL, 0xD0214EEBUL,
	0x022083B8UL, 0x3FB6180CUL, 0x18F8931EUL, 0x281658E6UL,
	0x26486E3EUL, 0x8BD78A70UL, 0x7477E4C1UL, 0xB506E07CUL,
	0xF32D0A25UL, 0x79098B02UL, 0xE4EABB81UL, 0x28123B23UL,
	0x69DEAD38UL, 0x1574CA16UL, 0xDF871B62UL, 0x211C40B7UL,
	0xA51A9EF9UL, 0x0014377BUL, 0x041E8AC8UL, 0x09114003UL,
	0xBD59E4D2UL, 0xE3D156D5UL, 0x4FE876D5UL, 0x2F91A340UL,
	0x557BE8DEUL, 0x00EAE4A7UL, 0x0CE5C2ECUL, 0x4DB4BBA6UL,
	0xE756BDFFUL, 0xDD3369ACUL, 0xEC17B035UL, 0x06572327UL,
	0x99AFC8B0UL, 0x56C8C391UL, 0x6B65811CUL, 0x5E146119UL,
	0x6E85CB75UL, 0xBE07C002UL, 0xC2325577UL, 0x893FF4ECUL,
	0x5BBFC92DUL, 0xD0EC3B25UL, 0xB7801AB7UL, 0x8D6D3B24UL,
	0x20C763EFUL, 0xC366A5FCUL, 0x9C382880UL, 0x0ACE3205UL,
	0xAAC9548AUL, 0xECA1D7C7UL, 0x041AFA32UL, 0x1D16625AUL,
	0x6701902CUL, 0x9B757A54UL, 0x31D477F7UL, 0x9126B031UL,
	0x36CC6FDBUL, 0xC70B8B46UL, 0xD9E66A48UL, 0x56E55A79UL,
	0x026A4CEBUL, 0x52437EFFUL, 0x2F8F76B4UL, 0x0DF980A5UL,
	0x8674CDE3UL, 0xEDDA04EBUL, 0x17A9BE04UL, 0x2C18F4DFUL,
	0xB7747F9DUL, 0xAB2AF7B4UL, 0xEFC34D20UL, 0x2E096B7CUL,
	0x1741A254UL, 0xE5B6A035UL, 0x213D42F6UL, 0x2C1C7C26UL,
	0x61C2F50FUL, 0x6552DAF9UL, 0xD2C231F8UL, 0x25130F69UL,
	0xD8167FA2UL, 0x0418F2C8UL, 0x001A96A6UL, 0x0D1526ABUL,
	0x63315C21UL, 0x5E0A72ECUL, 0x49BAFEFDUL, 0x187908D9UL,
	0x8D0DBD86UL, 0x311170A7UL, 0x3E9B640CUL, 0xCC3E10D7UL,
	0xD5CAD3B6UL, 0x0CAEC388UL, 0xF73001E1UL, 0x6C728AFFUL,
	0x71EAE2A1UL, 0x1F9AF36EUL, 0xCFCBD12FUL, 0xC1DE8417UL,
	0xAC07BE6BUL, 0xCB44A1D8UL, 0x8B9B0F56UL, 0x013988C3UL,
	0xB1C52FCAUL, 0xB4BE31CDUL, 0xD8782806UL, 0x12A3A4E2UL,
	0x6F7DE532UL, 0x58FD7EB6UL, 0xD01EE900UL, 0x24ADFFC2UL,
	0xF4990FC5UL, 0x9711AAC5UL, 0x001D7B95UL, 0x82E5E7D2UL,
	0x109873F6UL, 0x00613096UL, 0xC32D9521UL, 0xADA121FFUL,
	0x29908415UL, 0x7FBB977FUL, 0xAF9EB3DBUL, 0x29C9ED2AUL,
	0x5CE2A465UL, 0xA730F32CUL, 0xD0AA3FE8UL, 0x8A5CC091UL,
	0xD49E2CE7UL, 0x0CE454A9UL, 0xD60ACD86UL, 0x015F1919UL,
	0x77079103UL, 0xDEA03AF6UL, 0x78A8565EUL, 0xDEE356DFUL,
	0x21F05CBEUL, 0x8B75E387UL, 0xB3C50651UL, 0xB8A5C3EFUL,
	0xD8EEB6D2UL, 0xE523BE77UL, 0xC2154529UL, 0x2F69EFDFUL,
	0xAFE67AFBUL, 0xF470C4B2UL, 0xF3E0EB5BUL, 0xD6CC9876UL,
	0x39E4460CUL, 0x1FDA8538UL, 0x1987832FUL, 0xCA007367UL,
	0xA99144F8UL, 0x296B299EUL, 0x492FC295UL, 0x9266BEABUL,
	0xB5676E69UL, 0x9BD3DDDAUL, 0xDF7E052FUL, 0xDB25701CUL,
	0x1B5E51EEUL, 0xF65324E6UL, 0x6AFCE36CUL, 0x0316CC04UL,
	0x8644213EUL, 0xB7DC59D0UL, 0x7965291FUL, 0xCCD6FD43UL,
	0x41823979UL, 0x932BCDF6UL, 0xB657C34DUL, 0x4EDFD282UL,
	0x7AE5290CUL, 0x3CB9536BUL, 0x851E20FEUL, 0x9833557EUL,
	0x13ECF0B0UL, 0xD3FFB372UL, 0x3F85C5C1UL, 0x0AEF7ED2UL
,
	0x7EC90C04UL, 0x2C6E74B9UL, 0x9B0E66DFUL, 0xA6337911UL,
	0xB86A7FFFUL, 0x1DD358F5UL, 0x44DD9D44UL, 0x1731167FUL,
	0x08FBF1FAUL, 0xE7F511CCUL, 0xD2051B00UL, 0x735ABA00UL,
	0x2AB722D8UL, 0x386381CBUL, 0xACF6243AUL, 0x69BEFD7AUL,
	0xE6A2E77FUL, 0xF0C720CDUL, 0xC4494816UL, 0xCCF5C180UL,
	0x38851640UL, 0x15B0A848UL, 0xE68B18CBUL, 0x4CAADEFFUL,
	0x5F480A01UL, 0x0412B2AAUL, 0x259814FCUL, 0x41D0EFE2UL,
	0x4E40B48DUL, 0x248EB6FBUL, 0x8DBA1CFEUL, 0x41A99B02UL,
	0x1A550A04UL, 0xBA8F65CBUL, 0x7251F4E7UL, 0x95A51725UL,
	0xC106ECD7UL, 0x97A5980AUL, 0xC539B9AAUL, 0x4D79FE6AUL,
	0xF2F3F763UL, 0x68AF8040UL, 0xED0C9E56UL, 0x11B4958BUL,
	0xE1EB5A88UL, 0x8709E6B0UL, 0xD7E07156UL, 0x4E29FEA7UL,
	0x6366E52DUL, 0x02D1C000UL, 0xC4AC8E05UL, 0x9377F571UL,
	0x0C05372AUL, 0x578535F2UL, 0x2261BE02UL, 0xD642A0C9UL,
	0xDF13A280UL, 0x74B55BD2UL, 0x682199C0UL, 0xD421E5ECUL,
	0x53FB3CE8UL, 0xC8ADEDB3UL, 0x28A87FC9UL, 0x3D959981UL,
	0x5C1FF900UL, 0xFE38D399UL, 0x0C4EFF0BUL, 0x062407EAUL,
	0xAA2F4FB1UL, 0x4FB96976UL, 0x90C79505UL, 0xB0A8A774UL,
	0xEF55A1FFUL, 0xE59CA2C2UL, 0xA6B62D27UL, 0xE66A4263UL,
	0xDF65001FUL, 0x0EC50966UL, 0xDFDD55BCUL, 0x29DE0655UL,
	0x911E739AUL, 0x17AF8975UL, 0x32C7911CUL, 0x89F89468UL,
	0x0D01E980UL, 0x524755F4UL, 0x03B63CC9UL, 0x0CC844B2UL,
	0xBCF3F0AAUL, 0x87AC36E9UL, 0xE53A7426UL, 0x01B3D82BUL,
	0x1A9E7449UL, 0x64EE2D7EUL, 0xCDDBB1DAUL, 0x01C94910UL,
	0xB868BF80UL, 0x0D26F3FDUL, 0x9342EDE7UL, 0x04A5C284UL,
	0x636737B6UL, 0x50F5B616UL, 0xF24766E3UL, 0x8ECA36C1UL,
	0x136E05DBUL, 0xFEF18391UL, 0xFB887A37UL, 0xD6E7F7D4UL,
	0xC7FB7DC9UL, 0x3063FCDFUL, 0xB6F589DEUL, 0xEC2941DAUL,
	0x26E46695UL, 0xB7566419UL, 0xF654EFC5UL, 0xD08D58B7UL,
	0x48925401UL, 0xC1BACB7FUL, 0xE5FF550FUL, 0xB6083049UL,
	0x5BB5D0E8UL, 0x87D72E5AUL, 0xAB6A6EE1UL, 0x223A66CEUL,
	0xC62BF3CDUL, 0x9E0885F9UL, 0x68CB3E47UL, 0x086C010FUL,
	0xA21DE820UL, 0xD18B69DEUL, 0xF3F65777UL, 0xFA02C3F6UL,
	0x407EDAC3UL, 0xCBB3D550UL, 0x1793084DUL, 0xB0D70EBAUL,
	0x0AB378D5UL, 0xD951FB0CUL, 0xDED7DA56UL, 0x4124BBE4UL,
	0x94CA0B56UL, 0x0F5755D1UL, 0xE0E1E56EUL, 0x6184B5BEUL,
	0x580A249FUL, 0x94F74BC0UL, 0xE327888EUL, 0x9F7B5561UL,
	0xC3DC0280UL, 0x05687715UL, 0x646C6BD7UL, 0x44904DB3UL,
	0x66B4F0A3UL, 0xC0F1648AUL, 0x697ED5AFUL, 0x49E92FF6UL,
	0x309E374FUL, 0x2CB6356AUL, 0x85808573UL, 0x4991F840UL,
	0x76F0AE02UL, 0x083BE84DUL, 0x28421C9AUL, 0x44489406UL,
	0x736E4CB8UL, 0xC1092910UL, 0x8BC95FC6UL, 0x7D869CF4UL,
	0x134F616FUL, 0x2E77118DUL, 0xB31B2BE1UL, 0xAA90B472UL,
	0x3CA5D717UL, 0x7D161BBAUL, 0x9CAD9010UL, 0xAF462BA2UL,
	0x9FE459D2UL, 0x45D34559UL, 0xD9F2DA13UL, 0xDBC65487UL,
	0xF3E4F94EUL, 0x176D486FUL, 0x097C13EAUL, 0x631DA5C7UL,
	0x445F7382UL, 0x175683F4UL, 0xCDC66A97UL, 0x70BE0288UL,
	0xB3CDCF72UL, 0x6E5DD2F3UL, 0x20936079UL, 0x459B80A5UL,
	0xBE60E2DBUL, 0xA9C23101UL, 0xEBA5315CUL, 0x224E42F2UL,
	0x1C5C1572UL, 0xF6721B2CUL, 0x1AD2FFF3UL, 0x8C25404EUL,
	0x324ED72FUL, 0x4067B7FDUL, 0x0523138EUL, 0x5CA3BC78UL,
	0xDC0FD66EUL, 0x75922283UL, 0x784D6B17UL, 0x58EBB16EUL,
	0x44094F85UL, 0x3F481D87UL, 0xFCFEAE7BUL, 0x77B5FF76UL,
	0x8C2302BFUL, 0xAAF47556UL, 0x5F46B02AUL, 0x2B092801UL,
	0x3D38F5F7UL, 0x0CA81F36UL, 0x52AF4A8AUL, 0x66D5E7C0UL,
	0xDF3B0874UL, 0x95055110UL, 0x1B5AD7A8UL, 0xF61ED5ADUL,
	0x6CF6E479UL, 0x20758184UL, 0xD0CEFA65UL, 0x88F7BE58UL,
	0x4A046826UL, 0x0FF6F8F3UL, 0xA09C7F70UL, 0x5346ABA0UL,
	0x5CE96C28UL, 0xE176EDA3UL, 0x6BAC307FUL, 0x376829D2UL,
	0x85360FA9UL, 0x17E3FE2AUL, 0x24B79767UL, 0xF5A96B20UL,
	0xD6CD2595UL, 0x68FF1EBFUL, 0x7555442CUL, 0xF19F06BEUL,
	0xF9E0659AUL, 0xEEB9491DUL, 0x34010718UL, 0xBB30CAB8UL,
	0xE822FE15UL, 0x88570983UL, 0x750E6249UL, 0xDA627E55UL,
	0x5E76FFA8UL, 0xB1534546UL, 0x6D47DE08UL, 0xEFE9E7D4UL
,
	0xF6FA8F9DUL, 0x2CAC6CE1UL, 0x4CA34867UL, 0xE2337F7CUL,
	0x95DB08E7UL, 0x016843B4UL, 0xECED5CBCUL, 0x325553ACUL,
	0xBF9F0960UL, 0xDFA1E2EDUL, 0x83F0579DUL, 0x63ED86B9UL,
	0x1AB6A6B8UL, 0xDE5EBE39UL, 0xF38FF732UL, 0x8989B138UL,
	0x33F14961UL, 0xC01937BDUL, 0xF506C6DAUL, 0xE4625E7EUL,
	0xA308EA99UL, 0x4E23E33CUL, 0x79CBD7CCUL, 0x48A14367UL,
	0xA3149619UL, 0xFEC94BD5UL, 0xA114174AUL, 0xEAA01866UL,
	0xA084DB2DUL, 0x09A8486FUL, 0xA888614AUL, 0x2900AF98UL,
	0x01665991UL, 0xE1992863UL, 0xC8F30C60UL, 0x2E78EF3CUL,
	0xD0D51932UL, 0xCF0FEC14UL, 0xF7CA07D2UL, 0xD0A82072UL,
	0xFD41197EUL, 0x9305A6B0UL, 0xE86BE3DAUL, 0x74BED3CDUL,
	0x372DA53CUL, 0x4C7F4448UL, 0xDAB5D440UL, 0x6DBA0EC3UL,
	0x083919A7UL, 0x9FBAEED9UL, 0x49DBCFB0UL, 0x4E670C53UL,
	0x5C3D9C01UL, 0x64BDB941UL, 0x2C0E636AUL, 0xBA7DD9CDUL,
	0xEA6F7388UL, 0xE70BC762UL, 0x35F29ADBUL, 0x5C4CDD8DUL,
	0xF0D48D8CUL, 0xB88153E2UL, 0x08A19866UL, 0x1AE2EAC8UL,
	0x284CAF89UL, 0xAA928223UL, 0x9334BE53UL, 0x3B3A21BFUL,
	0x16434BE3UL, 0x9AEA3906UL, 0xEFE8C36EUL, 0xF890CDD9UL,
	0x80226DAEUL, 0xC340A4A3UL, 0xDF7E9C09UL, 0xA694A807UL,
	0x5B7C5ECCUL, 0x221DB3A6UL, 0x9A69A02FUL, 0x68818A54UL,
	0xCEB2296FUL, 0x53C0843AUL, 0xFE893655UL, 0x25BFE68AUL,
	0xB4628ABCUL, 0xCF222EBFUL, 0x25AC6F48UL, 0xA9A99387UL,
	0x53BDDB65UL, 0xE76FFBE7UL, 0xE967FD78UL, 0x0BA93563UL,
	0x8E342BC1UL, 0xE8A11BE9UL, 0x4980740DUL, 0xC8087DFCUL,
	0x8DE4BF99UL, 0xA11101A0UL, 0x7FD37975UL, 0xDA5A26C0UL,
	0xE81F994FUL, 0x9528CD89UL, 0xFD339FEDUL, 0xB87834BFUL,
	0x5F04456DUL, 0x22258698UL, 0xC9C4C83BUL, 0x2DC156BEUL,
	0x4F628DAAUL, 0x57F55EC5UL, 0xE2220ABEUL, 0xD2916EBFUL,
	0x4EC75B95UL, 0x24F2C3C0UL, 0x42D15D99UL, 0xCD0D7FA0UL,
	0x7B6E27FFUL, 0xA8DC8AF0UL, 0x7345C106UL, 0xF41E232FUL,
	0x35162386UL, 0xE6EA8926UL, 0x3333B094UL, 0x157EC6F2UL,
	0x372B74AFUL, 0x692573E4UL, 0xE9A9D848UL, 0xF3160289UL,
	0x3A62EF1DUL, 0xA787E238UL, 0xF3A5F676UL, 0x74364853UL,
	0x20951063UL, 0x4576698DUL, 0xB6FAD407UL, 0x592AF950UL,
	0x36F73523UL, 0x4CFB6E87UL, 0x7DA4CEC0UL, 0x6C152DAAUL,
	0xCB0396A8UL, 0xC50DFE5DUL, 0xFCD707ABUL, 0x0921C42FUL,
	0x89DFF0BBUL, 0x5FE2BE78UL, 0x448F4F33UL, 0x754613C9UL,
	0x2B05D08DUL, 0x48B9D585UL, 0xDC049441UL, 0xC8098F9BUL,
	0x7DEDE786UL, 0xC39A3373UL, 0x42410005UL, 0x6A091751UL,
	0x0EF3C8A6UL, 0x890072D6UL, 0x28207682UL, 0xA9A9F7BEUL,
	0xBF32679DUL, 0xD45B5B75UL, 0xB353FD00UL, 0xCBB0E358UL,
	0x830F220AUL, 0x1F8FB214UL, 0xD372CF08UL, 0xCC3C4A13UL,
	0x8CF63166UL, 0x061C87BEUL, 0x88C98F88UL, 0x6062E397UL,
	0x47CF8E7AUL, 0xB6C85283UL, 0x3CC2ACFBUL, 0x3FC06976UL,
	0x4E8F0252UL, 0x64D8314DUL, 0xDA3870E3UL, 0x1E665459UL,
	0xC10908F0UL, 0x513021A5UL, 0x6C5B68B7UL, 0x822F8AA0UL,
	0x3007CD3EUL, 0x74719EEFUL, 0xDC872681UL, 0x073340D4UL,
	0x7E432FD9UL, 0x0C5EC241UL, 0x8809286CUL, 0xF592D891UL,
	0x08A930F6UL, 0x957EF305UL, 0xB7FBFFBDUL, 0xC266E96FUL,
	0x6FE4AC98UL, 0xB173ECC0UL, 0xBC60B42AUL, 0x953498DAUL,
	0xFBA1AE12UL, 0x2D4BD736UL, 0x0F25FAABUL, 0xA4F3FCEBUL,
	0xE2969123UL, 0x257F0C3DUL, 0x9348AF49UL, 0x361400BCUL,
	0xE8816F4AUL, 0x3814F200UL, 0xA3F94043UL, 0x9C7A54C2UL,
	0xBC704F57UL, 0xDA41E7F9UL, 0xC25AD33AUL, 0x54F4A084UL,
	0xB17F5505UL, 0x59357CBEUL, 0xEDBD15C8UL, 0x7F97C5ABUL,
	0xBA5AC7B5UL, 0xB6F6DEAFUL, 0x3A479C3AUL, 0x5302DA25UL,
	0x653D7E6AUL, 0x54268D49UL, 0x51A477EAUL, 0x5017D55BUL,
	0xD7D25D88UL, 0x44136C76UL, 0x0404A8C8UL, 0xB8E5A121UL,
	0xB81A928AUL, 0x60ED5869UL, 0x97C55B96UL, 0xEAEC991BUL,
	0x29935913UL, 0x01FDB7F1UL, 0x088E8DFAUL, 0x9AB6F6F5UL,
	0x3B4CBF9FUL, 0x4A5DE3ABUL, 0xE6051D35UL, 0xA0E1D855UL,
	0xD36B4CF1UL, 0xF544EDEBUL, 0xB0E93524UL, 0xBEBB8FBDUL,
	0xA2D762CFUL, 0x49C92F54UL, 0x38B5F331UL, 0x7128A454UL,
	0x48392905UL, 0xA65B1DB8UL, 0x851C97BDUL, 0xD675CF2FUL
,
	0x85E04019UL, 0x332BF567UL, 0x662DBFFFUL, 0xCFC65693UL,
	0x2A8D7F6FUL, 0xAB9BC912UL, 0xDE6008A1UL, 0x2028DA1FUL,
	0x0227BCE7UL, 0x4D642916UL, 0x18FAC300UL, 0x50F18B82UL,
	0x2CB2CB11UL, 0xB232E75CUL, 0x4B3695F2UL, 0xB28707DEUL,
	0xA05FBCF6UL, 0xCD4181E9UL, 0xE150210CUL, 0xE24EF1BDUL,
	0xB168C381UL, 0xFDE4E789UL, 0x5C79B0D8UL, 0x1E8BFD43UL,
	0x4D495001UL, 0x38BE4341UL, 0x913CEE1DUL, 0x92A79C3FUL,
	0x089766BEUL, 0xBAEEADF4UL, 0x1286BECFUL, 0xB6EACB19UL,
	0x2660C200UL, 0x7565BDE4UL, 0x64241F7AUL, 0x8248DCA9UL,
	0xC3B3AD66UL, 0x28136086UL, 0x0BD8DFA8UL, 0x356D1CF2UL,
	0x107789BEUL, 0xB3B2E9CEUL, 0x0502AA8FUL, 0x0BC0351EUL,
	0x166BF52AUL, 0xEB12FF82UL, 0xE3486911UL, 0xD34D7516UL,
	0x4E7B3AFFUL, 0x5F43671BUL, 0x9CF6E037UL, 0x4981AC83UL,
	0x334266CEUL, 0x8C9341B7UL, 0xD0D854C0UL, 0xCB3A6C88UL,
	0x47BC2829UL, 0x4725BA37UL, 0xA66AD22BUL, 0x7AD61F1EUL,
	0x0C5CBAFAUL, 0x4437F107UL, 0xB6E79962UL, 0x42D2D816UL,
	0x0A961288UL, 0xE1A5C06EUL, 0x13749E67UL, 0x72FC081AUL,
	0xB1D139F7UL, 0xF9583745UL, 0xCF19DF58UL, 0xBEC3F756UL,
	0xC06EBA30UL, 0x07211B24UL, 0x45C28829UL, 0xC95E317FUL,
	0xBC8EC511UL, 0x38BC46E9UL, 0xC6E6FA14UL, 0xBAE8584AUL,
	0xAD4EBC46UL, 0x468F508BUL, 0x7829435FUL, 0xF124183BUL,
	0x821DBA9FUL, 0xAFF60FF4UL, 0xEA2C4E6DUL, 0x16E39264UL,
	0x92544A8BUL, 0x009B4FC3UL, 0xABA68CEDUL, 0x9AC96F78UL,
	0x06A5B79AUL, 0xB2856E6EUL, 0x1AEC3CA9UL, 0xBE838688UL,
	0x0E0804E9UL, 0x55F1BE56UL, 0xE7E5363BUL, 0xB3A1F25DUL,
	0xF7DEBB85UL, 0x61FE033CUL, 0x16746233UL, 0x3C034C28UL,
	0xDA6D0C74UL, 0x79AAC56CUL, 0x3CE4E1ADUL, 0x51F0C802UL,
	0x98F8F35AUL, 0x1626A49FUL, 0xEED82B29UL, 0x1D382FE3UL,
	0x0C4FB99AUL, 0xBB325778UL, 0x3EC6D97BUL, 0x6E77A6A9UL,
	0xCB658B5CUL, 0xD45230C7UL, 0x2BD1408BUL, 0x60C03EB7UL,
	0xB9068D78UL, 0xA33754F4UL, 0xF430C87DUL, 0xC8A71302UL,
	0xB96D8C32UL, 0xEBD4E7BEUL, 0xBE8B9D2DUL, 0x7979FB06UL,
	0xE7225308UL, 0x8B75CF77UL, 0x11EF8DA4UL, 0xE083C858UL,
	0x8D6B786FUL, 0x5A6317A6UL, 0xFA5CF7A0UL, 0x5DDA0033UL,
	0xF28EBFB0UL, 0xF5B9C310UL, 0xA0EAC280UL, 0x08B9767AUL,
	0xA3D9D2B0UL, 0x79D34217UL, 0x021A718DUL, 0x9AC6336AUL,
	0x2711FD60UL, 0x438050E3UL, 0x069908A8UL, 0x3D7FEDC4UL,
	0x826D2BEFUL, 0x4EEB8476UL, 0x488DCF25UL, 0x36C9D566UL,
	0x28E74E41UL, 0xC2610ACAUL, 0x3D49A9CFUL, 0xBAE3B9DFUL,
	0xB65F8DE6UL, 0x92AEAF64UL, 0x3AC7D5E6UL, 0x9EA80509UL,
	0xF22B017DUL, 0xA4173F70UL, 0xDD1E16C3UL, 0x15E0D7F9UL,
	0x50B1B887UL, 0x2B9F4FD5UL, 0x625ABA82UL, 0x6A017962UL,
	0x2EC01B9CUL, 0x15488AA9UL, 0xD716E740UL, 0x40055A2CUL,
	0x93D29A22UL, 0xE32DBF9AUL, 0x058745B9UL, 0x3453DC1EUL,
	0xD699296EUL, 0x496CFF6FUL, 0x1C9F4986UL, 0xDFE2ED07UL,
	0xB87242D1UL, 0x19DE7EAEUL, 0x053E561AUL, 0x15AD6F8CUL,
	0x66626C1CUL, 0x7154C24CUL, 0xEA082B2AUL, 0x93EB2939UL,
	0x17DCB0F0UL, 0x58D4F2AEUL, 0x9EA294FBUL, 0x52CF564CUL,
	0x9883FE66UL, 0x2EC40581UL, 0x763953C3UL, 0x01D6692EUL,
	0xD3A0C108UL, 0xA1E7160EUL, 0xE4F2DFA6UL, 0x693ED285UL,
	0x74904698UL, 0x4C2B0EDDUL, 0x4F757656UL, 0x5D393378UL,
	0xA132234FUL, 0x3D321C5DUL, 0xC3F5E194UL, 0x4B269301UL,
	0xC79F022FUL, 0x3C997E7EUL, 0x5E4F9504UL, 0x3FFAFBBDUL,
	0x76F7AD0EUL, 0x296693F4UL, 0x3D1FCE6FUL, 0xC61E45BEUL,
	0xD3B5AB34UL, 0xF72BF9B7UL, 0x1B0434C0UL, 0x4E72B567UL,
	0x5592A33DUL, 0xB5229301UL, 0xCFD2A87FUL, 0x60AEB767UL,
	0x1814386BUL, 0x30BCC33DUL, 0x38A0C07DUL, 0xFD1606F2UL,
	0xC363519BUL, 0x589DD390UL, 0x5479F8E6UL, 0x1CB8D647UL,
	0x97FD61A9UL, 0xEA7759F4UL, 0x2D57539DUL, 0x569A58CFUL,
	0xE84E63ADUL, 0x462E1B78UL, 0x6580F87EUL, 0xF3817914UL,
	0x91DA55F4UL, 0x40A230F3UL, 0xD1988F35UL, 0xB6E318D2UL,
	0x3FFA50BCUL, 0x3D40F021UL, 0xC3C0BDAEUL, 0x4958C24CUL,
	0x518F36B2UL, 0x84B1D370UL, 0x0FEDCE83UL, 0x878DDADAUL,
	0xF2A279C7UL, 0x94E01BE8UL, 0x90716F4BUL, 0x954B8AA3UL
,
	0xE216300DUL, 0xBBDDFFFCUL, 0xA7EBDABDUL, 0x35648095UL,
	0x7789F8B7UL, 0xE6C1121BUL, 0x0E241600UL, 0x052CE8B5UL,
	0x11A9CFB0UL, 0xE5952F11UL, 0xECE7990AUL, 0x9386D174UL,
	0x2A42931CUL, 0x76E38111UL, 0xB12DEF3AUL, 0x37DDDDFCUL,
	0xDE9ADEB1UL, 0x0A0CC32CUL, 0xBE197029UL, 0x84A00940UL,
	0xBB243A0FUL, 0xB4D137CFUL, 0xB44E79F0UL, 0x049EEDFDUL,
	0x0B15A15DUL, 0x480D3168UL, 0x8BBBDE5AUL, 0x669DED42UL,
	0xC7ECE831UL, 0x3F8F95E7UL, 0x72DF191BUL, 0x7580330DUL,
	0x94074251UL, 0x5C7DCDFAUL, 0xABBE6D63UL, 0xAA402164UL,
	0xB301D40AUL, 0x02E7D1CAUL, 0x53571DAEUL, 0x7A3182A2UL,
	0x12A8DDECUL, 0xFDAA335DUL, 0x176F43E8UL, 0x71FB46D4UL,
	0x38129022UL, 0xCE949AD4UL, 0xB84769ADUL, 0x965BD862UL,
	0x82F3D055UL, 0x66FB9767UL, 0x15B80B4EUL, 0x1D5B47A0UL,
	0x4CFDE06FUL, 0xC28EC4B8UL, 0x57E8726EUL, 0x647A78FCUL,
	0x99865D44UL, 0x608BD593UL, 0x6C200E03UL, 0x39DC5FF6UL,
	0x5D0B00A3UL, 0xAE63AFF2UL, 0x7E8BD632UL, 0x70108C0CUL,
	0xBBD35049UL, 0x2998DF04UL, 0x980CF42AUL, 0x9B6DF491UL,
	0x9E7EDD53UL, 0x06918548UL, 0x58CB7E07UL, 0x3B74EF2EUL,
	0x522FFFB1UL, 0xD24708CCUL, 0x1C7E27CDUL, 0xA4EB215BUL,
	0x3CF1D2E2UL, 0x19B47A38UL, 0x424F7618UL, 0x35856039UL,
	0x9D17DEE7UL, 0x27EB35E6UL, 0xC9AFF67BUL, 0x36BAF5B8UL,
	0x09C467CDUL, 0xC18910B1UL, 0xE11DBF7BUL, 0x06CD1AF8UL,
	0x7170C608UL, 0x2D5E3354UL, 0xD4DE495AUL, 0x64C6D006UL,
	0xBCC0C62CUL, 0x3DD00DB3UL, 0x708F8F34UL, 0x77D51B42UL,
	0x264F620FUL, 0x24B8D2BFUL, 0x15C1B79EUL, 0x46A52564UL,
	0xF8D7E54EUL, 0x3E378160UL, 0x7895CDA5UL, 0x859C15A5UL,
	0xE6459788UL, 0xC37BC75FUL, 0xDB07BA0CUL, 0x0676A3ABUL,
	0x7F229B1EUL, 0x31842E7BUL, 0x24259FD7UL, 0xF8BEF472UL,
	0x835FFCB8UL, 0x6DF4C1F2UL, 0x96F5B195UL, 0xFD0AF0FCUL,
	0xB0FE134CUL, 0xE2506D3DUL, 0x4F9B12EAUL, 0xF215F225UL,
	0xA223736FUL, 0x9FB4C428UL, 0x25D04979UL, 0x34C713F8UL,
	0xC4618187UL, 0xEA7A6E98UL, 0x7CD16EFCUL, 0x1436876CUL,
	0xF1544107UL, 0xBEDEEE14UL, 0x56E9AF27UL, 0xA04AA441UL,
	0x3CF7C899UL, 0x92ECBAE6UL, 0xDD67016DUL, 0x151682EBUL,
	0xA842EEDFUL, 0xFDBA60B4UL, 0xF1907B75UL, 0x20E3030FUL,
	0x24D8C29EUL, 0xE139673BUL, 0xEFA63FB8UL, 0x71873054UL,
	0xB6F2CF3BUL, 0x9F326442UL, 0xCB15A4CCUL, 0xB01A4504UL,
	0xF1E47D8DUL, 0x844A1BE5UL, 0xBAE7DFDCUL, 0x42CBDA70UL,
	0xCD7DAE0AUL, 0x57E85B7AUL, 0xD53F5AF6UL, 0x20CF4D8CUL,
	0xCEA4D428UL, 0x79D130A4UL, 0x3486EBFBUL, 0x33D3CDDCUL,
	0x77853B53UL, 0x37EFFCB5UL, 0xC5068778UL, 0xE580B3E6UL,
	0x4E68B8F4UL, 0xC5C8B37EUL, 0x0D809EA2UL, 0x398FEB7CUL,
	0x132A4F94UL, 0x43B7950EUL, 0x2FEE7D1CUL, 0x223613BDUL,
	0xDD06CAA2UL, 0x37DF932BUL, 0xC4248289UL, 0xACF3EBC3UL,
	0x5715F6B7UL, 0xEF3478DDUL, 0xF267616FUL, 0xC148CBE4UL,
	0x9052815EUL, 0x5E410FABUL, 0xB48A2465UL, 0x2EDA7FA4UL,
	0xE87B40E4UL, 0xE98EA084UL, 0x5889E9E1UL, 0xEFD390FCUL,
	0xDD07D35BUL, 0xDB485694UL, 0x38D7E5B2UL, 0x57720101UL,
	0x730EDEBCUL, 0x5B643113UL, 0x94917E4FUL, 0x503C2FBAUL,
	0x646F1282UL, 0x7523D24AUL, 0xE0779695UL, 0xF9C17A8FUL,
	0x7A5B2121UL, 0xD187B896UL, 0x29263A4DUL, 0xBA510CDFUL,
	0x81F47C9FUL, 0xAD1163EDUL, 0xEA7B5965UL, 0x1A00726EUL,
	0x11403092UL, 0x00DA6D77UL, 0x4A0CDD61UL, 0xAD1F4603UL,
	0x605BDFB0UL, 0x9EEDC364UL, 0x22EBE6A8UL, 0xCEE7D28AUL,
	0xA0E736A0UL, 0x5564A6B9UL, 0x10853209UL, 0xC7EB8F37UL,
	0x2DE705CAUL, 0x8951570FUL, 0xDF09822BUL, 0xBD691A6CUL,
	0xAA12E4F2UL, 0x87451C0FUL, 0xE0F6A27AUL, 0x3ADA4819UL,
	0x4CF1764FUL, 0x0D771C2BUL, 0x67CDB156UL, 0x350D8384UL,
	0x5938FA0FUL, 0x42399EF3UL, 0x36997B07UL, 0x0E84093DUL,
	0x4AA93E61UL, 0x8360D87BUL, 0x1FA98B0CUL, 0x1149382CUL,
	0xE97625A5UL, 0x0614D1B7UL, 0x0E25244BUL, 0x0C768347UL,
	0x589E8D82UL, 0x0D2059D1UL, 0xA466BB1EUL, 0xF8DA0A82UL,
	0x04F19130UL, 0xBA6E4EC0UL, 0x99265164UL, 0x1EE7230DUL,
	0x50B2AD80UL, 0xEAEE6801UL, 0x8DB2A283UL, 0xEA8BF59EUL

###############################################################################

TITLE
     Blowfish_s_init

TYPE
    32

DATA
 3509652390U, 2564797868U,  805139163U, 3491422135U,
 3101798381U, 1780907670U, 3128725573U, 4046225305U,
  614570311U, 3012652279U,  134345442U, 2240740374U,
 1667834072U, 1901547113U, 2757295779U, 4103290238U,
  227898511U, 1921955416U, 1904987480U, 2182433518U,
 2069144605U, 3260701109U, 2620446009U,  720527379U,
 3318853667U,  677414384U, 3393288472U, 3101374703U,
 2390351024U, 1614419982U, 1822297739U, 2954791486U,
 3608508353U, 3174124327U, 2024746970U, 1432378464U,
 3864339955U, 2857741204U, 1464375394U, 1676153920U,
 1439316330U,  715854006U, 3033291828U,  289532110U,
 2706671279U, 2087905683U, 3018724369U, 1668267050U,
  732546397U, 1947742710U, 3462151702U, 2609353502U,
 2950085171U, 1814351708U, 2050118529U,  680887927U,
  999245976U, 1800124847U, 3300911131U, 1713906067U,
 1641548236U, 4213287313U, 1216130144U, 1575780402U,
 4018429277U, 3917837745U, 3693486850U, 3949271944U,
  596196993U, 3549867205U,  258830323U, 2213823033U,
  772490370U, 2760122372U, 1774776394U, 2652871518U,
  566650946U, 4142492826U, 1728879713U, 2882767088U,
 1783734482U, 3629395816U, 2517608232U, 2874225571U,
 1861159788U,  326777828U, 3124490320U, 2130389656U,
 2716951837U,  967770486U, 1724537150U, 2185432712U,
 2364442137U, 1164943284U, 2105845187U,  998989502U,
 3765401048U, 2244026483U, 1075463327U, 1455516326U,
 1322494562U,  910128902U,  469688178U, 1117454909U,
  936433444U, 3490320968U, 3675253459U, 1240580251U,
  122909385U, 2157517691U,  634681816U, 4142456567U,
 3825094682U, 3061402683U, 2540495037U,   79693498U,
 3249098678U, 1084186820U, 1583128258U,  426386531U,
 1761308591U, 1047286709U,  322548459U,  995290223U,
 1845252383U, 2603652396U, 3431023940U, 2942221577U,
 3202600964U, 3727903485U, 1712269319U,  422464435U,
 3234572375U, 1170764815U, 3523960633U, 3117677531U,
 1434042557U,  442511882U, 3600875718U, 1076654713U,
 1738483198U, 4213154764U, 2393238008U, 3677496056U,
 1014306527U, 4251020053U,  793779912U, 2902807211U,
  842905082U, 4246964064U, 1395751752U, 1040244610U,
 2656851899U, 3396308128U,  445077038U, 3742853595U,
 3577915638U,  679411651U, 2892444358U, 2354009459U,
 1767581616U, 3150600392U, 3791627101U, 3102740896U,
  284835224U, 4246832056U, 1258075500U,  768725851U,
 2589189241U, 3069724005U, 3532540348U, 1274779536U,
 3789419226U, 2764799539U, 1660621633U, 3471099624U,
 4011903706U,  913787905U, 3497959166U,  737222580U,
 2514213453U, 2928710040U, 3937242737U, 1804850592U,
 3499020752U, 2949064160U, 2386320175U, 2390070455U,
 2415321851U, 4061277028U, 2290661394U, 2416832540U,
 1336762016U, 1754252060U, 3520065937U, 3014181293U,
  791618072U, 3188594551U, 3933548030U, 2332172193U,
 3852520463U, 3043980520U,  413987798U, 3465142937U,
 3030929376U, 4245938359U, 2093235073U, 3534596313U,
  375366246U, 2157278981U, 2479649556U,  555357303U,
 3870105701U, 2008414854U, 3344188149U, 4221384143U,
 3956125452U, 2067696032U, 3594591187U, 2921233993U,
    2428461U,  544322398U,  577241275U, 1471733935U,
  610547355U, 4027169054U, 1432588573U, 1507829418U,
 2025931657U, 3646575487U,  545086370U,   48609733U,
 2200306550U, 1653985193U,  298326376U, 1316178497U,
 3007786442U, 2064951626U,  458293330U, 2589141269U,
 3591329599U, 3164325604U,  727753846U, 2179363840U,
  146436021U, 1461446943U, 4069977195U,  705550613U,
 3059967265U, 3887724982U, 4281599278U, 3313849956U,
 1404054877U, 2845806497U,  146425753U, 1854211946U,
 1266315497U, 3048417604U, 3681880366U, 3289982499U,
 2909710000U, 1235738493U, 2632868024U, 2414719590U,
 3970600049U, 1771706367U, 1449415276U, 3266420449U,
  422970021U, 1963543593U, 2690192192U, 3826793022U,
 1062508698U, 1531092325U, 1804592342U, 2583117782U,
 2714934279U, 4024971509U, 1294809318U, 4028980673U,
 1289560198U, 2221992742U, 1669523910U,   35572830U,
  157838143U, 1052438473U, 1016535060U, 1802137761U,
 1753167236U, 1386275462U, 3080475397U, 2857371447U,
 1040679964U, 2145300060U, 2390574316U, 1461121720U,
 2956646967U, 4031777805U, 4028374788U,   33600511U,
 2920084762U, 1018524850U,  629373528U, 3691585981U,
 3515945977U, 2091462646U, 2486323059U,  586499841U,
  988145025U,  935516892U, 3367335476U, 2599673255U,
 2839830854U,  265290510U, 3972581182U, 2759138881U,
 3795373465U, 1005194799U,  847297441U,  406762289U,
 1314163512U, 1332590856U, 1866599683U, 4127851711U,
  750260880U,  613907577U, 1450815602U, 3165620655U,
 3734664991U, 3650291728U, 3012275730U, 3704569646U,
 1427272223U,  778793252U, 1343938022U, 2676280711U,
 2052605720U, 1946737175U, 3164576444U, 3914038668U,
 3967478842U, 3682934266U, 1661551462U, 3294938066U,
 4011595847U,  840292616U, 3712170807U,  616741398U,
  312560963U,  711312465U, 1351876610U,  322626781U,
 1910503582U,  271666773U, 2175563734U, 1594956187U,
   70604529U, 3617834859U, 1007753275U, 1495573769U,
 4069517037U, 2549218298U, 2663038764U,  504708206U,
 2263041392U, 3941167025U, 2249088522U, 1514023603U,
 1998579484U, 1312622330U,  694541497U, 2582060303U,
 2151582166U, 1382467621U,  776784248U, 2618340202U,
 3323268794U, 2497899128U, 2784771155U,  503983604U,
 4076293799U,  907881277U,  423175695U,  432175456U,
 1378068232U, 4145222326U, 3954048622U, 3938656102U,
 3820766613U, 2793130115U, 2977904593U,   26017576U,
 3274890735U, 3194772133U, 1700274565U, 1756076034U,
 4006520079U, 3677328699U,  720338349U, 1533947780U,
  354530856U,  688349552U, 3973924725U, 1637815568U,
  332179504U, 3949051286U,   53804574U, 2852348879U,
 3044236432U, 1282449977U, 3583942155U, 3416972820U,
 4006381244U, 1617046695U, 2628476075U, 3002303598U,
 1686838959U,  431878346U, 2686675385U, 1700445008U,
 1080580658U, 1009431731U,  832498133U, 3223435511U,
 2605976345U, 2271191193U, 2516031870U, 1648197032U,
 4164389018U, 2548247927U,  300782431U,  375919233U,
  238389289U, 3353747414U, 2531188641U, 2019080857U,
 1475708069U,  455242339U, 2609103871U,  448939670U,
 3451063019U, 1395535956U, 2413381860U, 1841049896U,
 1491858159U,  885456874U, 4264095073U, 4001119347U,
 1565136089U, 3898914787U, 1108368660U,  540939232U,
 1173283510U, 2745871338U, 3681308437U, 4207628240U,
 3343053890U, 4016749493U, 1699691293U, 1103962373U,
 3625875870U, 2256883143U, 3830138730U, 1031889488U,
 3479347698U, 1535977030U, 4236805024U, 3251091107U,
 2132092099U, 1774941330U, 1199868427U, 1452454533U,
  157007616U, 2904115357U,  342012276U,  595725824U,
 1480756522U,  206960106U,  497939518U,  591360097U,
  863170706U, 2375253569U, 3596610801U, 1814182875U,
 2094937945U, 3421402208U, 1082520231U, 3463918190U,
 2785509508U,  435703966U, 3908032597U, 1641649973U,
 2842273706U, 3305899714U, 1510255612U, 2148256476U,
 2655287854U, 3276092548U, 4258621189U,  236887753U,
 3681803219U,  274041037U, 1734335097U, 3815195456U,
 3317970021U, 1899903192U, 1026095262U, 4050517792U,
  356393447U, 2410691914U, 3873677099U, 3682840055U,
 3913112168U, 2491498743U, 4132185628U, 2489919796U,
 1091903735U, 1979897079U, 3170134830U, 3567386728U,
 3557303409U,  857797738U, 1136121015U, 1342202287U,
  507115054U, 2535736646U,  337727348U, 3213592640U,
 1301675037U, 2528481711U, 1895095763U, 1721773893U,
 3216771564U,   62756741U, 2142006736U,  835421444U,
 2531993523U, 1442658625U, 3659876326U, 2882144922U,
  676362277U, 1392781812U,  170690266U, 3921047035U,
 1759253602U, 3611846912U, 1745797284U,  664899054U,
 1329594018U, 3901205900U, 3045908486U, 2062866102U,
 2865634940U, 3543621612U, 3464012697U, 1080764994U,
  553557557U, 3656615353U, 3996768171U,  991055499U,
  499776247U, 1265440854U,  648242737U, 3940784050U,
  980351604U, 3713745714U, 1749149687U, 3396870395U,
 4211799374U, 3640570775U, 1161844396U, 3125318951U,
 1431517754U,  545492359U, 4268468663U, 3499529547U,
 1437099964U, 2702547544U, 3433638243U, 2581715763U,
 2787789398U, 1060185593U, 1593081372U, 2418618748U,
 4260947970U,   69676912U, 2159744348U,   86519011U,
 2512459080U, 3838209314U, 1220612927U, 3339683548U,
  133810670U, 1090789135U, 1078426020U, 1569222167U,
  845107691U, 3583754449U, 4072456591U, 1091646820U,
  628848692U, 1613405280U, 3757631651U,  526609435U,
  236106946U,   48312990U, 2942717905U, 3402727701U,
 1797494240U,  859738849U,  992217954U, 4005476642U,
 2243076622U, 3870952857U, 3732016268U,  765654824U,
 3490871365U, 2511836413U, 1685915746U, 3888969200U,
 1414112111U, 2273134842U, 3281911079U, 4080962846U,
  172450625U, 2569994100U,  980381355U, 4109958455U,
 2819808352U, 2716589560U, 2568741196U, 3681446669U,
 3329971472U, 1835478071U,  660984891U, 3704678404U,
 4045999559U, 3422617507U, 3040415634U, 1762651403U,
 1719377915U, 3470491036U, 2693910283U, 3642056355U,
 3138596744U, 1364962596U, 2073328063U, 1983633131U,
  926494387U, 3423689081U, 2150032023U, 4096667949U,
 1749200295U, 3328846651U,  309677260U, 2016342300U,
 1779581495U, 3079819751U,  111262694U, 1274766160U,
  443224088U,  298511866U, 1025883608U, 3806446537U,
 1145181785U,  168956806U, 3641502830U, 3584813610U,
 1689216846U, 3666258015U, 3200248200U, 1692713982U,
 2646376535U, 4042768518U, 1618508792U, 1610833997U,
 3523052358U, 4130873264U, 2001055236U, 3610705100U,
 2202168115U, 4028541809U, 2961195399U, 1006657119U,
 2006996926U, 3186142756U, 1430667929U, 3210227297U,
 1314452623U, 4074634658U, 4101304120U, 2273951170U,
 1399257539U, 3367210612U, 3027628629U, 1190975929U,
 2062231137U, 2333990788U, 2221543033U, 2438960610U,
 1181637006U,  548689776U, 2362791313U, 3372408396U,
 3104550113U, 3145860560U,  296247880U, 1970579870U,
 3078560182U, 3769228297U, 1714227617U, 3291629107U,
 3898220290U,  166772364U, 1251581989U,  493813264U,
  448347421U,  195405023U, 2709975567U,  677966185U,
 3703036547U, 1463355134U, 2715995803U, 1338867538U,
 1343315457U, 2802222074U, 2684532164U,  233230375U,
 2599980071U, 2000651841U, 3277868038U, 1638401717U,
 4028070440U, 3237316320U,    6314154U,  819756386U,
  300326615U,  590932579U, 1405279636U, 3267499572U,
 3150704214U, 2428286686U, 3959192993U, 3461946742U,
 1862657033U, 1266418056U,  963775037U, 2089974820U,
 2263052895U, 1917689273U,  448879540U, 3550394620U,
 3981727096U,  150775221U, 3627908307U, 1303187396U,
  508620638U, 2975983352U, 2726630617U, 1817252668U,
 1876281319U, 1457606340U,  908771278U, 3720792119U,
 3617206836U, 2455994898U, 1729034894U, 1080033504U,
  976866871U, 3556439503U, 2881648439U, 1522871579U,
 1555064734U, 1336096578U, 3548522304U, 2579274686U,
 3574697629U, 3205460757U, 3593280638U, 3338716283U,
 3079412587U,  564236357U, 2993598910U, 1781952180U,
 1464380207U, 3163844217U, 3332601554U, 1699332808U,
 1393555694U, 1183702653U, 3581086237U, 1288719814U,
  691649499U, 2847557200U, 2895455976U, 3193889540U,
 2717570544U, 1781354906U, 1676643554U, 2592534050U,
 3230253752U, 1126444790U, 2770207658U, 2633158820U,
 2210423226U, 2615765581U, 2414155088U, 3127139286U,
  673620729U, 2805611233U, 1269405062U, 4015350505U,
 3341807571U, 4149409754U, 1057255273U, 2012875353U,
 2162469141U, 2276492801U, 2601117357U,  993977747U,
 3918593370U, 2654263191U,  753973209U,   36408145U,
 2530585658U,   25011837U, 3520020182U, 2088578344U,
  530523599U, 2918365339U, 1524020338U, 1518925132U,
 3760827505U, 3759777254U, 1202760957U, 3985898139U,
 3906192525U,  674977740U, 4174734889U, 2031300136U,
 2019492241U, 3983892565U, 4153806404U, 3822280332U,
  352677332U, 2297720250U,   60907813U,   90501309U,
 3286998549U, 1016092578U, 2535922412U, 2839152426U,
  457141659U,  509813237U, 4120667899U,  652014361U,
 1966332200U, 2975202805U,   55981186U, 2327461051U,
  676427537U, 3255491064U, 2882294119U, 3433927263U,
 1307055953U,  942726286U,  933058658U, 2468411793U,
 3933900994U, 4215176142U, 1361170020U, 2001714738U,
 2830558078U, 3274259782U, 1222529897U, 1679025792U,
 2729314320U, 3714953764U, 1770335741U,  151462246U,
 3013232138U, 1682292957U, 1483529935U,  471910574U,
 1539241949U,  458788160U, 3436315007U, 1807016891U,
 3718408830U,  978976581U, 1043663428U, 3165965781U,
 1927990952U, 4200891579U, 2372276910U, 3208408903U,
 3533431907U, 1412390302U, 2931980059U, 4132332400U,
 1947078029U, 3881505623U, 4168226417U, 2941484381U,
 1077988104U, 1320477388U,  886195818U,   18198404U,
 3786409000U, 2509781533U,  112762804U, 3463356488U,
 1866414978U,  891333506U,   18488651U,  661792760U,
 1628790961U, 3885187036U, 3141171499U,  876946877U,
 2693282273U, 1372485963U,  791857591U, 2686433993U,
 3759982718U, 3167212022U, 3472953795U, 2716379847U,
  445679433U, 3561995674U, 3504004811U, 3574258232U,
   54117162U, 3331405415U, 2381918588U, 3769707343U,
 4154350007U, 1140177722U, 4074052095U,  668550556U,
 3214352940U,  367459370U,  261225585U, 2610173221U,
 4209349473U, 3468074219U, 3265815641U,  314222801U,
 3066103646U, 3808782860U,  282218597U, 3406013506U,
 3773591054U,  379116347U, 1285071038U,  846784868U,
 2669647154U, 3771962079U, 3550491691U, 2305946142U,
  453669953U, 1268987020U, 3317592352U, 3279303384U,
 3744833421U, 2610507566U, 3859509063U,  266596637U,
 3847019092U,  517658769U, 3462560207U, 3443424879U,
  370717030U, 4247526661U, 2224018117U, 4143653529U,
 4112773975U, 2788324899U, 2477274417U, 1456262402U,
 2901442914U, 1517677493U, 1846949527U, 2295493580U,
 3734397586U, 2176403920U, 1280348187U, 1908823572U,
 3871786941U,  846861322U, 1172426758U, 3287448474U,
 3383383037U, 1655181056U, 3139813346U,  901632758U,
 1897031941U, 2986607138U, 3066810236U, 3447102507U,
 1393639104U,  373351379U,  950779232U,  625454576U,
 3124240540U, 4148612726U, 2007998917U,  544563296U,
 2244738638U, 2330496472U, 2058025392U, 1291430526U,
  424198748U,   50039436U,   29584100U, 3605783033U,
 2429876329U, 2791104160U, 1057563949U, 3255363231U,
 3075367218U, 3463963227U, 1469046755U,  985887462U

###############################################################################

TITLE
    Blowfish_s_init (b)

TYPE
    8 HEX

DATA
d9 23 5f e6 ca 68 97 b0 7b f2 0c 34 11 a5 8d 4e
0a 46 77 8d 10 9f 5e 62 f1 34 ec a5 c9 b3 d8 2b
59 47 e3 d2 ff ae 64 ca 15 8b 7d 38 21 bc 96 00
49 56 23 15 97 e4 cb 6f f2 70 3c 88 ba d1 0d ae
e2 38 ba 44 9f 83 5d 1c de ab c7 65 f1 76 09 20
86 bd 0a f1 3c a7 29 93 cb 45 5f e8 10 74 62 de
b8 77 80 d1 12 26 ac 6d e9 cf f3 54 3a 0b 95 4e
b1 30 a4 96 f8 57 49 8e 05 1f 62 7c c3 2b da ed
bb 86 0d 7a 97 13 6c 4e 51 30 e5 f2 2f d8 c4 a9
91 76 f0 17 43 38 29 84 a2 db ef 65 5e ca 0d bc
e7 fa d8 81 6f 00 14 42 25 7c 5d c9 9e b6 33 ab
5a 6f 9b d9 fe 71 44 c5 37 a2 88 2d 00 b6 13 ec
4e 96 a8 5a b5 d7 c3 8d 3f f2 ec 04 60 71 1b 29
04 79 e3 c7 1b 66 81 4a 25 9d dc 5f 3e b0 f8 a2
91 34 f6 5c 67 89 73 05 22 aa cb ee bf 18 d0 4d
f5 36 ae 01 2f 94 c3 49 8b bd 58 12 e0 77 6c da

###############################################################################

TITLE
    Phelix

TYPE
    32 AND

DATA
    0x912d94f1 0x0aadaadaa
    9    10    17    30    13    20    11    5    15    25

###############################################################################

TITLE
    Kasumi S7

TYPE
    16

DATA
54, 50, 62, 56, 22, 34, 94, 96, 38, 6, 63, 93, 2, 18,123, 33,
55,113, 39,114, 21, 67, 65, 12, 47, 73, 46, 27, 25,111,124, 81,
53, 9,121, 79, 52, 60, 58, 48,101,127, 40,120,104, 70, 71, 43,
20,122, 72, 61, 23,109, 13,100, 77, 1, 16, 7, 82, 10,105, 98,
117,116, 76, 11, 89,106, 0,125,118, 99, 86, 69, 30, 57,126, 87,
112, 51, 17, 5, 95, 14, 90, 84, 91, 8, 35,103, 32, 97, 28, 66,
102, 31, 26, 45, 75, 4, 85, 92, 37, 74, 80, 49, 68, 29,115, 44,
64,107,108, 24,110, 83, 36, 78, 42, 19, 15, 41, 88,119, 59, 3};

###############################################################################

TITLE
    Kasumi S9

TYPE
    16

DATA
167,239,161,379,391,334, 9,338, 38,226, 48,358,452,385, 90,397,
183,253,147,331,415,340, 51,362,306,500,262, 82,216,159,356,177,
175,241,489, 37,206, 17, 0,333, 44,254,378, 58,143,220, 81,400,
95, 3,315,245, 54,235,218,405,472,264,172,494,371,290,399, 76,
165,197,395,121,257,480,423,212,240, 28,462,176,406,507,288,223,
501,407,249,265, 89,186,221,428,164, 74,440,196,458,421,350,163,
232,158,134,354, 13,250,491,142,191, 69,193,425,152,227,366,135,
344,300,276,242,437,320,113,278, 11,243, 87,317, 36, 93,496, 27,
487,446,482, 41, 68,156,457,131,326,403,339, 20, 39,115,442,124,
475,384,508, 53,112,170,479,151,126,169, 73,268,279,321,168,364,
363,292, 46,499,393,327,324, 24,456,267,157,460,488,426,309,229,
439,506,208,271,349,401,434,236, 16,209,359, 52, 56,120,199,277,
465,416,252,287,246, 6, 83,305,420,345,153,502, 65, 61,244,282,
173,222,418, 67,386,368,261,101,476,291,195,430, 49, 79,166,330,
280,383,373,128,382,408,155,495,367,388,274,107,459,417, 62,454,
132,225,203,316,234, 14,301, 91,503,286,424,211,347,307,140,374,
35,103,125,427, 19,214,453,146,498,314,444,230,256,329,198,285,
50,116, 78,410, 10,205,510,171,231, 45,139,467, 29, 86,505, 32,
72, 26,342,150,313,490,431,238,411,325,149,473, 40,119,174,355,
185,233,389, 71,448,273,372, 55,110,178,322, 12,469,392,369,190,
1,109,375,137,181, 88, 75,308,260,484, 98,272,370,275,412,111,
336,318, 4,504,492,259,304, 77,337,435, 21,357,303,332,483, 18,
47, 85, 25,497,474,289,100,269,296,478,270,106, 31,104,433, 84,
414,486,394, 96, 99,154,511,148,413,361,409,255,162,215,302,201,
266,351,343,144,441,365,108,298,251, 34,182,509,138,210,335,133,
311,352,328,141,396,346,123,319,450,281,429,228,443,481, 92,404,
485,422,248,297, 23,213,130,466, 22,217,283, 70,294,360,419,127,
312,377, 7,468,194, 2,117,295,463,258,224,447,247,187, 80,398,
284,353,105,390,299,471,470,184, 57,200,348, 63,204,188, 33,451,
97, 30,310,219, 94,160,129,493, 64,179,263,102,189,207,114,402,
438,477,387,122,192, 42,381, 5,145,118,180,449,293,323,136,380,
43, 66, 60,455,341,445,202,432, 8,237, 15,376,436,464, 59,461};

###############################################################################

TITLE
    Loki97 permutation map

TYPE
    8

DATA
    56, 48, 40, 32, 24, 16,  8, 0,
    57, 49, 41, 33, 25, 17,  9, 1,
    58, 50, 42, 34, 26, 18, 10, 2,
    59, 51, 43, 35, 27, 19, 11, 3,
    60, 52, 44, 36, 28, 20, 12, 4,
    61, 53, 45, 37, 29, 21, 13, 5,
    62, 54, 46, 38, 30, 22, 14, 6,
    63, 55, 47, 39, 31, 23, 15, 7

###############################################################################

TITLE
    MacGuffin sbits

TYPE
    8, 32

DATA
    {2,5,6,9,11,13}, {1,4,7,10,8,14},
    {3,6,8,13,0,15}, {12,14,1,2,4,10},
    {0,10,3,14,6,12}, {7,8,12,15,1,5},
    {9,15,5,11,2,7}, {11,13,0,4,3,9}};

###############################################################################

TITLE
    MacGuffin sbits (b)

TYPE
    16

DATA
    0x0036, 0x06c0, 0x6900
    0x5048, 0x2106, 0x8411
    0x8601, 0x4828, 0x10c4
    0x2980, 0x9011, 0x022a

###############################################################################

TITLE
    MacGuffin outputmasks

TYPE
    16

DATA
0x0030, 0x0010, 0x0000, 0x0020, 0x0000, 0x0030, 0x0030, 0x0000,
0x0020, 0x0000, 0x0030, 0x0030, 0x0010, 0x0020, 0x0000, 0x0010,
0x0030, 0x0000, 0x0010, 0x0030, 0x0000, 0x0020, 0x0020, 0x0010,
0x0010, 0x0030, 0x0020, 0x0010, 0x0020, 0x0000, 0x0010, 0x0020},
/* 3 (S4) */
{0x0040, 0x00c0, 0x00c0, 0x0080, 0x0080, 0x00c0, 0x0040, 0x0040,
0x0000, 0x0000, 0x0000, 0x00c0, 0x00c0, 0x0000, 0x0080, 0x0040,
0x0040, 0x0000, 0x0000, 0x0040, 0x0080, 0x0000, 0x0040, 0x0080,
0x00c0, 0x0040, 0x0080, 0x0080, 0x0000, 0x0080, 0x00c0, 0x00c0,
0x0080, 0x0040, 0x0000, 0x00c0, 0x00c0, 0x0000, 0x0000, 0x0000,
0x0080, 0x0080, 0x00c0, 0x0040, 0x0040, 0x00c0, 0x00c0, 0x0080,
0x00c0, 0x00c0, 0x0040, 0x0000, 0x0040, 0x0040, 0x0080, 0x00c0,
0x0040, 0x0080, 0x0000, 0x0040, 0x0080, 0x0000, 0x0000, 0x0080},
/* 4 (S5) */
{0x0000, 0x0200, 0x0200, 0x0300, 0x0000, 0x0000, 0x0100, 0x0200,
0x0100, 0x0000, 0x0200, 0x0100, 0x0300, 0x0300, 0x0000, 0x0100,
0x0200, 0x0100, 0x0100, 0x0000, 0x0100, 0x0300, 0x0300, 0x0200,
0x0300, 0x0100, 0x0000, 0x0300, 0x0200, 0x0200, 0x0300, 0x0000,
0x0000, 0x0300, 0x0000, 0x0200, 0x0100, 0x0200, 0x0300, 0x0100,
0x0200, 0x0100, 0x0300, 0x0200, 0x0100, 0x0000, 0x0200, 0x0300,
0x0300, 0x0000, 0x0300, 0x0300, 0x0200, 0x0000, 0x0100, 0x0300,
0x0000, 0x0200, 0x0100, 0x0000, 0x0000, 0x0100, 0x0200, 0x0100},
/* 5 (S6) */
{0x0800, 0x0800, 0x0400, 0x0c00, 0x0800, 0x0000, 0x0c00, 0x0000,
0x0c00, 0x0400, 0x0000, 0x0800, 0x0000, 0x0c00, 0x0800, 0x0400,
0x0000, 0x0000, 0x0c00, 0x0400, 0x0400, 0x0c00, 0x0000, 0x0800,
0x0800, 0x0000, 0x0400, 0x0c00, 0x0400, 0x0400, 0x0c00, 0x0800,
0x0c00, 0x0000, 0x0800, 0x0400, 0x0c00, 0x0000, 0x0400, 0x0800,
0x0000, 0x0c00, 0x0800, 0x0400, 0x0800, 0x0c00, 0x0400, 0x0800,
0x0400, 0x0c00, 0x0000, 0x0800, 0x0000, 0x0400, 0x0800, 0x0400,
0x0400, 0x0000, 0x0c00, 0x0000, 0x0c00, 0x0800, 0x0000, 0x0c00},
/* 6 (S7) */
{0x0000, 0x3000, 0x3000, 0x0000, 0x0000, 0x3000, 0x2000, 0x1000,
0x3000, 0x0000, 0x0000, 0x3000, 0x2000, 0x1000, 0x3000, 0x2000,
0x1000, 0x2000, 0x2000, 0x1000, 0x3000, 0x1000, 0x1000, 0x2000,
0x1000, 0x0000, 0x2000, 0x3000, 0x0000, 0x2000, 0x1000, 0x0000,
0x1000, 0x0000, 0x0000, 0x3000, 0x3000, 0x3000, 0x3000, 0x2000,
0x2000, 0x1000, 0x1000, 0x0000, 0x1000, 0x2000, 0x2000, 0x1000,
0x2000, 0x3000, 0x3000, 0x1000, 0x0000, 0x0000, 0x2000, 0x3000,
0x0000, 0x2000, 0x1000, 0x0000, 0x3000, 0x1000, 0x0000, 0x2000},
/* 7 (S8) */
{0xc000, 0x4000, 0x0000, 0xc000, 0x8000, 0xc000, 0x0000, 0x8000,
0x0000, 0x8000, 0xc000, 0x4000, 0xc000, 0x4000, 0x4000, 0x0000,
0x8000, 0x8000, 0xc000, 0x4000, 0x4000, 0x0000, 0x8000, 0xc000,
0x4000, 0x0000, 0x0000, 0x8000, 0x8000, 0xc000, 0x4000, 0x0000,
/* ...??? */

###############################################################################

TITLE
    Iraqi block cipher chaos1

TYPE
    8

DATA
173,84,240,67,1,53,254,36,41,172,115,109,223,199,152,189,90,46,
149,193,218,130,250,40,203,4,35,237,236,246,213,143,169,176,48,
23,61,206,69,34,97,155,4,109,183,220,42,64,21,123,29,233,253,
105,183,209,1,191,113,12,46,7,8,183,166,199,166,7,78,37,135,
252,174,84,140,164,152,94,22,185,59,68,181,60,176,67,51,25,28,
190,138,198,44,90,92,221,149,175,186,25,49,210,50,237,41,207,
31,226,114,121,230,15,58,25,142,58,98,232,59,3,189,28,8,116,
131,185,78,250,239,33,116,173,94,45,104,62,122,179,18,150,246,
250,17,8,79,157,225,238,47,10,133,58,8,126,82,68,153,141,2,158,
204,50,130,53,59,32,243,160,172,35,24,107,35,115,228,143,28,
224,77,55,25,28,120,89,186,152,49,84,117,180,30,138,134,77,182,
157,61,230,22,149,54,15,110,32,213,155,106,78,16,23,89,140,158,
169,96,136,186,104,30,199,67,35,218,159,210,109,28,238,33,150,
173,180,247,201,83,150,105,164,228,59,207,101,221,99,52,120,
199,31,6,144,202,215,209,49,42,195};

###############################################################################

TITLE
    Iraqi block cipher fixed_key

TYPE
    8

DATA
  46,245,138,13,244,233,238,154,139,30,241,90,47,205,171,97,223,
  190,28,10,185,13,23,137,30,208,254,143,165,101,27,48};

###############################################################################

TITLE
    Iraqi block cipher permut

TYPE
    8

DATA
    {5,10,1,3,0,4,15,2,7,9,13,8,11,14,12,6},
    {5,7,15,13,3,8,1,11,10,0,9,12,2,6,14,4},
    {4,6,12,14,1,0,13,5,7,9,10,11,2,15,8,3},
    {3,4,2,12,13,9,1,8,5,15,14,6,10,0,11,7},
    {9,8,3,5,4,6,0,2,13,15,14,1,12,11,7,10},
    {14,13,3,11,0,2,1,10,7,9,4,5,15,6,12,8},
    {8,4,0,5,7,3,12,11,13,9,6,1,15,10,2,14},
    {11,14,13,1,9,8,4,5,12,6,7,3,10,0,15,2},
    {13,12,2,1,6,9,14,11,3,10,8,15,4,5,7,0},
    {1,14,12,7,8,0,11,9,6,5,4,2,10,3,15,13},
    {6,0,10,8,5,2,11,13,14,1,4,9,3,12,15,7},
    {12,0,5,13,2,4,8,6,3,15,9,10,14,7,1,11},
    {7,10,8,11,9,2,0,3,5,4,12,15,14,1,6,13},
    {8,4,15,7,10,9,3,12,6,14,0,2,1,5,13,11},
    {11,13,14,3,5,12,7,6,2,0,10,8,1,15,4,9},
    {1,6,3,8,7,4,11,14,0,10,9,2,15,12,5,13}};

###############################################################################

TITLE
    Boucher randgen1

TYPE
    32 AND

DATA
    367     171
    887     336
    1489    252

###############################################################################

TITLE
    Boucher randgen4

TYPE
    32 AND

DATA
    467     719     941     1129
    66049   3907864577

###############################################################################

TITLE
    Boucher randgen4 (logic)

TYPE
    32 AND
DATA
0x000001d3,0x000002cf,0x000003ad,0x00000469,0x00010dcd,0x00010201,0xe8ed4801,0x00010dcd,
0x00010201,0xe8ed4801,0x00010dcd,0x00010201,0xe8ed4801,0x00010dcd,0x00010201,0xe8ed4801,

###############################################################################

TITLE
    Boucher randgen5

TYPE
    32 AND

DATA
    349     953     601     751     557     887

###############################################################################

TITLE
    Crypton p_box

TYPE
    8

DATA
{   { 15,  9,  6,  8,  9,  9,  4, 12,  6,  2,  6, 10,  1,  3,  5, 15 },
    { 10, 15,  4,  7,  5,  2, 14,  6,  9,  3, 12,  8, 13,  1, 11,  0 },
    {  0,  4,  8,  4,  2, 15,  8, 13,  1,  1, 15,  7,  2, 11, 14, 15 }

###############################################################################

TITLE
    Crypton kp

TYPE
    32

DATA
    0xbb67ae85, 0x3c6ef372, 0xa54ff53a, 0x510e527f

###############################################################################

TITLE
    Crypton kq

TYPE
    32

DATA
    0x9b05688c, 0x1f83d9ab, 0x5be0cd19, 0xcbbb9d5d

###############################################################################

TITLE
    Crypton

TYPE
    32 AND

DATA
    0x3fcff3fc  0xfc3fcff3  0xf3fc3fcf  0xcff3fc3f
    0xcffccffc  0xf33ff33f  0xfccffccf  0x3ff33ff3
    0x01010101

###############################################################################

TITLE
    DEAL

TYPE
    32 AND

DATA
    0x67452301, 0xefcdab89
    0x00000080  0x00000040  0x00000020  0x00000010
    224     192     160     128     96      64      32

###############################################################################

TITLE
    Crypton v1

TYPE
    32 AND

DATA
    0xacacacac  0x59595959  0xb2b2b2b2  0x65656565
    0x01010101
    0x3fcff3fc  0xfc3fcff3  0xf3fc3fcf  0xcff3fc3f

###############################################################################

TITLE
    Crypton v1 p0

TYPE
    8

DATA
    { 15, 14, 10,  1, 11,  5,  8, 13,  9,  3,  2,  7,  0,  6,  4, 12 };

###############################################################################

TITLE
    Crypton v1 p1

TYPE
    8

DATA
    { 11, 10, 13,  7,  8, 14,  0,  5, 15,  6,  3,  4,  1,  9,  2, 12 };


###############################################################################

TITLE
    Crypton v1 ip0

TYPE
    8

DATA
    { 12,  3, 10,  9, 14,  5, 13, 11,  6,  8,  2,  4, 15,  7,  1,  0 };


###############################################################################

TITLE
    Crypton v1 ip1

TYPE
    8

DATA
    {  6, 12, 14, 10, 11,  7,  9,  3,  4, 13,  1,  0, 15,  2,  5,  8 };

###############################################################################

TITLE
    DFC rt64

TYPE
    32

DATA
    0xb7e15162, 0x8aed2a6a, 0xbf715880, 0x9cf4f3c7, 
    0x62e7160f, 0x38b4da56, 0xa784d904, 0x5190cfef, 
    0x324e7738, 0x926cfbe5, 0xf4bf8d8d, 0x8c31d763,
    0xda06c80a, 0xbb1185eb, 0x4f7c7b57, 0x57f59584, 

    0x90cfd47d, 0x7c19bb42, 0x158d9554, 0xf7b46bce, 
    0xd55c4d79, 0xfd5f24d6, 0x613c31c3, 0x839a2ddf,
    0x8a9a276b, 0xcfbfa1c8, 0x77c56284, 0xdab79cd4, 
    0xc2b3293d, 0x20e9e5ea, 0xf02ac60a, 0xcc93ed87, 

    0x4422a52e, 0xcb238fee, 0xe5ab6add, 0x835fd1a0,
    0x753d0a8f, 0x78e537d2, 0xb95bb79d, 0x8dcaec64, 
    0x2c1e9f23, 0xb829b5c2, 0x780bf387, 0x37df8bb3, 
    0x00d01334, 0xa0d0bd86, 0x45cbfa73, 0xa6160ffe,

    0x393c48cb, 0xbbca060f, 0x0ff8ec6d, 0x31beb5cc, 
    0xeed7f2f0, 0xbb088017, 0x163bc60d, 0xf45a0ecb, 
    0x1bcd289b, 0x06cbbfea, 0x21ad08e1, 0x847f3f73,
    0x78d56ced, 0x94640d6e, 0xf0d3d37b, 0xe67008e1, 

###############################################################################

TITLE
    DFC values

TYPE
    32 AND

DATA
    0xeb64749a;

    0x86d1bf27, 0x5b9b241d  

    0xb7e15162, 0x8aed2a6a, 
    0xbf715880, 0x9cf4f3c7, 
    0x62e7160f, 0x38b4da56, 

    0xa784d904, 0x5190cfef, 
    0x324e7738, 0x926cfbe5, 
    0xf4bf8d8d, 0x8c31d763,

    0xda06c80a, 0xbb1185eb, 0x4f7c7b57, 0x57f59584, 
    0x90cfd47d, 0x7c19bb42, 0x158d9554, 0xf7b46bce,

###############################################################################

TITLE
    E2 sbox

TYPE
    8

DATA
 0xe1, 0x42, 0x3e, 0x81, 0x4e, 0x17, 0x9e, 0xfd, 0xb4, 0x3f, 0x2c, 0xda,
 0x31, 0x1e, 0xe0, 0x41, 0xcc, 0xf3, 0x82, 0x7d, 0x7c, 0x12, 0x8e, 0xbb,
 0xe4, 0x58, 0x15, 0xd5, 0x6f, 0xe9, 0x4c, 0x4b, 0x35, 0x7b, 0x5a, 0x9a,
 0x90, 0x45, 0xbc, 0xf8, 0x79, 0xd6, 0x1b, 0x88, 0x02, 0xab, 0xcf, 0x64,
 0x09, 0x0c, 0xf0, 0x01, 0xa4, 0xb0, 0xf6, 0x93, 0x43, 0x63, 0x86, 0xdc,
 0x11, 0xa5, 0x83, 0x8b, 0xc9, 0xd0, 0x19, 0x95, 0x6a, 0xa1, 0x5c, 0x24,
 0x6e, 0x50, 0x21, 0x80, 0x2f, 0xe7, 0x53, 0x0f, 0x91, 0x22, 0x04, 0xed,
 0xa6, 0x48, 0x49, 0x67, 0xec, 0xf7, 0xc0, 0x39, 0xce, 0xf2, 0x2d, 0xbe,
 0x5d, 0x1c, 0xe3, 0x87, 0x07, 0x0d, 0x7a, 0xf4, 0xfb, 0x32, 0xf5, 0x8c,
 0xdb, 0x8f, 0x25, 0x96, 0xa8, 0xea, 0xcd, 0x33, 0x65, 0x54, 0x06, 0x8d,
 0x89, 0x0a, 0x5e, 0xd9, 0x16, 0x0e, 0x71, 0x6c, 0x0b, 0xff, 0x60, 0xd2,
 0x2e, 0xd3, 0xc8, 0x55, 0xc2, 0x23, 0xb7, 0x74, 0xe2, 0x9b, 0xdf, 0x77,
 0x2b, 0xb9, 0x3c, 0x62, 0x13, 0xe5, 0x94, 0x34, 0xb1, 0x27, 0x84, 0x9f,
 0xd7, 0x51, 0x00, 0x61, 0xad, 0x85, 0x73, 0x03, 0x08, 0x40, 0xef, 0x68,
 0xfe, 0x97, 0x1f, 0xde, 0xaf, 0x66, 0xe8, 0xb8, 0xae, 0xbd, 0xb3, 0xeb,
 0xc6, 0x6b, 0x47, 0xa9, 0xd8, 0xa7, 0x72, 0xee, 0x1d, 0x7e, 0xaa, 0xb6,
 0x75, 0xcb, 0xd4, 0x30, 0x69, 0x20, 0x7f, 0x37, 0x5b, 0x9d, 0x78, 0xa3,
 0xf1, 0x76, 0xfa, 0x05, 0x3d, 0x3a, 0x44, 0x57, 0x3b, 0xca, 0xc7, 0x8a,
 0x18, 0x46, 0x9c, 0xbf, 0xba, 0x38, 0x56, 0x1a, 0x92, 0x4d, 0x26, 0x29,
 0xa2, 0x98, 0x10, 0x99, 0x70, 0xa0, 0xc5, 0x28, 0xc1, 0x6d, 0x14, 0xac,
 0xf9, 0x5f, 0x4f, 0xc4, 0xc3, 0xd1, 0xfc, 0xdd, 0xb2, 0x59, 0xe6, 0xb5,
 0x36, 0x52, 0x4a, 0x2a

###############################################################################

TITLE
    E2 values

TYPE
    32 AND

DATA
    0x67452301
    0xefcdab89
    0x30d32e58
    0xb89e4984
    0x0957cfec
    0xd800502e
    0x00ffff00  0x0000ffff  0xff0000ff  0xffff0000  0x00ff00ff

###############################################################################

TITLE
    3 rotor German Enigma

TYPE
    8

DATA
    "YRUHQSLDPXNGOKMIEBFZCWVJAT"

###############################################################################

TITLE
    LOKI97 values

TYPE
    32 64 AND

DATA
    0x2911  0x2000  0xAA7   0x800
    0x9E3779B9L     0x7F4A7C15L

###############################################################################

TITLE
    Frog seed

TYPE
    8

DATA
    113,  21, 232,  18, 113,  92,  63, 157, 124, 193, 166, 197, 126,  56, 229, 229, 
    156, 162,  54,  17, 230,  89, 189,  87, 169,   0,  81, 204,   8,  70, 203, 225, 
    160,  59, 167, 189, 100, 157,  84,  11,   7, 130,  29,  51,  32,  45, 135, 237, 
    139,  33,  17, 221,  24,  50,  89,  74,  21, 205, 191, 242,  84,  53,   3, 230, 

    231, 118,  15,  15, 107,   4,  21,  34,   3, 156,  57,  66,  93, 255, 191,   3, 
     85, 135, 205, 200, 185, 204,  52,  37,  35,  24,  68, 185, 201,  10, 224, 234, 
      7, 120, 201, 115, 216, 103,  57, 255,  93, 110,  42, 249,  68,  14,  29,  55, 
    128,  84,  37, 152, 221, 137,  39,  11, 252,  50, 144,  35, 178, 190,  43, 162, 

    103, 249, 109,   8, 235,  33, 158, 111, 252, 205, 169,  54,  10,  20, 221, 201, 
    178, 224,  89, 184, 182,  65, 201,  10,  60,   6, 191, 174,  79,  98,  26, 160, 
    252,  51,  63,  79,   6, 102, 123, 173,  49,   3, 110, 233,  90, 158, 228, 210, 
    209, 237,  30,  95,  28, 179, 204, 220,  72, 163,  77, 166, 192,  98, 165,  25, 

    145, 162,  91, 212,  41, 230, 110,   6, 107, 187, 127,  38,  82,  98,  30,  67, 
    225,  80, 208, 134,  60, 250, 153,  87, 148,  60,  66, 165,  72,  29, 165,  82, 
    211, 207,   0, 177, 206,  13,   6,  14,  92, 248,  60, 201, 132,  95,  35, 215, 
    118, 177, 121, 180,  27,  83, 131,  26,  39,  46,  12,   0,   0,   0,   0,   0

###############################################################################

TITLE
    GSM A38 table_0

TYPE
    8

DATA
        102,177,186,162,  2,156,112, 75, 55, 25,  8, 12,251,193,246,188,
        109,213,151, 53, 42, 79,191,115,233,242,164,223,209,148,108,161,
        252, 37,244, 47, 64,211,  6,237,185,160,139,113, 76,138, 59, 70,
         67, 26, 13,157, 63,179,221, 30,214, 36,166, 69,152,124,207,116,
        247,194, 41, 84, 71,  1, 49, 14, 95, 35,169, 21, 96, 78,215,225,
        182,243, 28, 92,201,118,  4, 74,248,128, 17, 11,146,132,245, 48,
        149, 90,120, 39, 87,230,106,232,175, 19,126,190,202,141,137,176,
        250, 27,101, 40,219,227, 58, 20, 51,178, 98,216,140, 22, 32,121,
         61,103,203, 72, 29,110, 85,212,180,204,150,183, 15, 66,172,196,
         56,197,158,  0,100, 45,153,  7,144,222,163,167, 60,135,210,231,
        174,165, 38,249,224, 34,220,229,217,208,241, 68,206,189,125,255,
        239, 54,168, 89,123,122, 73,145,117,234,143, 99,129,200,192, 82,
        104,170,136,235, 93, 81,205,173,236, 94,105, 52, 46,228,198,  5,
         57,254, 97,155,142,133,199,171,187, 50, 65,181,127,107,147,226,
        184,218,131, 33, 77, 86, 31, 44, 88, 62,238, 18, 24, 43,154, 23,
         80,159,134,111,  9,114,  3, 91, 16,130, 83, 10,195,240,253,119,
        177,102,162,186,156,  2, 75,112, 25, 55, 12,  8,193,251,188,246,
        213,109, 53,151, 79, 42,115,191,242,233,223,164,148,209,161,108,
         37,252, 47,244,211, 64,237,  6,160,185,113,139,138, 76, 70, 59,
         26, 67,157, 13,179, 63, 30,221, 36,214, 69,166,124,152,116,207,
        194,247, 84, 41,  1, 71, 14, 49, 35, 95, 21,169, 78, 96,225,215,
        243,182, 92, 28,118,201, 74,  4,128,248, 11, 17,132,146, 48,245,
         90,149, 39,120,230, 87,232,106, 19,175,190,126,141,202,176,137,
         27,250, 40,101,227,219, 20, 58,178, 51,216, 98, 22,140,121, 32,
        103, 61, 72,203,110, 29,212, 85,204,180,183,150, 66, 15,196,172,
        197, 56,  0,158, 45,100,  7,153,222,144,167,163,135, 60,231,210,
        165,174,249, 38, 34,224,229,220,208,217, 68,241,189,206,255,125,
         54,239, 89,168,122,123,145, 73,234,117, 99,143,200,129, 82,192,
        170,104,235,136, 81, 93,173,205, 94,236, 52,105,228, 46,  5,198,
        254, 57,155, 97,133,142,171,199, 50,187,181, 65,107,127,226,147,
        218,184, 33,131, 86, 77, 44, 31, 62, 88, 18,238, 43, 24, 23,154,
        159, 80,111,134,114,  9, 91,  3,130, 16, 10, 83,240,195,119,253

###############################################################################

TITLE
    GSM A38 table_1

TYPE
    8

DATA
         19, 11, 80,114, 43,  1, 69, 94, 39, 18,127,117, 97,  3, 85, 43,
         27,124, 70, 83, 47, 71, 63, 10, 47, 89, 79,  4, 14, 59, 11,  5,
         35,107,103, 68, 21, 86, 36, 91, 85,126, 32, 50,109, 94,120,  6,
         53, 79, 28, 45, 99, 95, 41, 34, 88, 68, 93, 55,110,125,105, 20,
         90, 80, 76, 96, 23, 60, 89, 64,121, 56, 14, 74,101,  8, 19, 78,
         76, 66,104, 46,111, 50, 32,  3, 39,  0, 58, 25, 92, 22, 18, 51,
         57, 65,119,116, 22,109,  7, 86, 59, 93, 62,110, 78, 99, 77, 67,
         12,113, 87, 98,102,  5, 88, 33, 38, 56, 23,  8, 75, 45, 13, 75,
         95, 63, 28, 49,123,120, 20,112, 44, 30, 15, 98,106,  2,103, 29,
         82,107, 42,124, 24, 30, 41, 16,108,100,117, 40, 73, 40,  7,114,
         82,115, 36,112, 12,102,100, 84, 92, 48, 72, 97,  9, 54, 55, 74,
        113,123, 17, 26, 53, 58,  4,  9, 69,122, 21,118, 42, 60, 27, 73,
        118,125, 34, 15, 65,115, 84, 64, 62, 81, 70,  1, 24,111,121, 83,
        104, 81, 49,127, 48,105, 31, 10,  6, 91, 87, 37, 16, 54,116,126,
         31, 38, 13,  0, 72,106, 77, 61, 26, 67, 46, 29, 96, 37, 61, 52,
        101, 17, 44,108, 71, 52, 66, 57, 33, 51, 25, 90,  2,119,122, 35

###############################################################################

TITLE
    GSM A38 table_2

TYPE
    8

DATA
         52, 50, 44,  6, 21, 49, 41, 59, 39, 51, 25, 32, 51, 47, 52, 43,
         37,  4, 40, 34, 61, 12, 28,  4, 58, 23,  8, 15, 12, 22,  9, 18,
         55, 10, 33, 35, 50,  1, 43,  3, 57, 13, 62, 14,  7, 42, 44, 59,
         62, 57, 27,  6,  8, 31, 26, 54, 41, 22, 45, 20, 39,  3, 16, 56,
         48,  2, 21, 28, 36, 42, 60, 33, 34, 18,  0, 11, 24, 10, 17, 61,
         29, 14, 45, 26, 55, 46, 11, 17, 54, 46,  9, 24, 30, 60, 32,  0,
         20, 38,  2, 30, 58, 35,  1, 16, 56, 40, 23, 48, 13, 19, 19, 27,
         31, 53, 47, 38, 63, 15, 49,  5, 37, 53, 25, 36, 63, 29,  5,  7

###############################################################################

TITLE
    GSM A38 table_3

TYPE
    8

DATA
          1,  5, 29,  6, 25,  1, 18, 23, 17, 19,  0,  9, 24, 25,  6, 31,
         28, 20, 24, 30,  4, 27,  3, 13, 15, 16, 14, 18,  4,  3,  8,  9,
         20,  0, 12, 26, 21,  8, 28,  2, 29,  2, 15,  7, 11, 22, 14, 10,
         17, 21, 12, 30, 26, 27, 16, 31, 11,  7, 13, 23, 10,  5, 22, 19

###############################################################################

TITLE
    GSM A38 table_4

TYPE
    8

DATA
         15, 12, 10,  4,  1, 14, 11,  7,  5,  0, 14,  7,  1,  2, 13,  8,
         10,  3,  4,  9,  6,  0,  3,  2,  5,  6,  8,  9, 11, 13, 15, 12

###############################################################################

TITLE
    Lucifer (smith) s0

TYPE
    8, 32

DATA
    { 12, 15, 7, 10, 14, 13, 11, 0, 2, 6, 3, 1, 9, 4, 5, 8 };

###############################################################################

TITLE
    Lucifer (smith) s1

TYPE
    8, 32

DATA
    { 7, 2, 14, 9, 3, 11, 0, 4, 12, 13, 1, 10, 6, 15, 8, 5 };

###############################################################################

TITLE
    Lucifer (outerbridge) DFLTKY

TYPE
    8

DATA
    { 1,35,69,103,137,171,205,239,254,220,186,152,118,84,50,16 };

###############################################################################

TITLE
    Lucifer (outerbridge) Dps

TYPE
    8

DATA
        4,16,32,2,1,8,64,128,   128,4,16,32,2,1,8,64,
        64,128,4,16,32,2,1,8,   8,64,128,4,16,32,2,1,
        1,8,64,128,4,16,32,2,   2,1,8,64,128,4,16,32,
        32,2,1,8,64,128,4,16,   16,32,2,1,8,64,128,4    

###############################################################################

TITLE
    Lucifer (outerbridge) TCB0

TYPE
    8

DATA
         87, 21,117, 54, 23, 55, 20, 84,116,118, 22, 53, 85,119, 52, 86,
        223,157,253,190,159,191,156,220,252,254,158,189,221,255,188,222,
        207,141,237,174,143,175,140,204,236,238,142,173,205,239,172,206,
        211,145,241,178,147,179,144,208,240,242,146,177,209,243,176,210,
        215,149,245,182,151,183,148,212,244,246,150,181,213,247,180,214,
         95, 29,125, 62, 31, 63, 28, 92,124,126, 30, 61, 93,127, 60, 94,
        219,153,249,186,155,187,152,216,248,250,154,185,217,251,184,218,
         67,  1, 97, 34,  3, 35,  0, 64, 96, 98,  2, 33, 65, 99, 32, 66,
        195,129,225,162,131,163,128,192,224,226,130,161,193,227,160,194,
        199,133,229,166,135,167,132,196,228,230,134,165,197,231,164,198,
        203,137,233,170,139,171,136,200,232,234,138,169,201,235,168,202,
         75,  9,105, 42, 11, 43,  8, 72,104,106, 10, 41, 73,107, 40, 74,
         91, 25,121, 58, 27, 59, 24, 88,120,122, 26, 57, 89,123, 56, 90,
         71,  5,101, 38,  7, 39,  4, 68,100,102,  6, 37, 69,103, 36, 70,
         79, 13,109, 46, 15, 47, 12, 76,108,110, 14, 45, 77,111, 44, 78,
         83, 17,113, 50, 19, 51, 16, 80,112,114, 18, 49, 81,115, 48, 82 };

###############################################################################

TITLE
    Lucifer (outerbridge) TCB1

TYPE
    8

DATA
         87,223,207,211,215, 95,219, 67,195,199,203, 75, 91, 71, 79, 83,
         21,157,141,145,149, 29,153,  1,129,133,137,  9, 25,  5, 13, 17,
        117,253,237,241,245,125,249, 97,225,229,233,105,121,101,109,113,
         54,190,174,178,182, 62,186, 34,162,166,170, 42, 58, 38, 46, 50,
         23,159,143,147,151, 31,155,  3,131,135,139, 11, 27,  7, 15, 19,
         55,191,175,179,183, 63,187, 35,163,167,171, 43, 59, 39, 47, 51,
         20,156,140,144,148, 28,152,  0,128,132,136,  8, 24,  4, 12, 16,
         84,220,204,208,212, 92,216, 64,192,196,200, 72, 88, 68, 76, 80,
        116,252,236,240,244,124,248, 96,224,228,232,104,120,100,108,112,
        118,254,238,242,246,126,250, 98,226,230,234,106,122,102,110,114,
         22,158,142,146,150, 30,154,  2,130,134,138, 10, 26,  6, 14, 18,
         53,189,173,177,181, 61,185, 33,161,165,169, 41, 57, 37, 45, 49,
         85,221,205,209,213, 93,217, 65,193,197,201, 73, 89, 69, 77, 81,
        119,255,239,243,247,127,251, 99,227,231,235,107,123,103,111,115,
         52,188,172,176,180, 60,184, 32,160,164,168, 40, 56, 36, 44, 48,
         86,222,206,210,214, 94,218, 66,194,198,202, 74, 90, 70, 78, 82 };

###############################################################################

TITLE
    GSM A5/1 goodAtoB

TYPE
    8

DATA
    { 0x53, 0x4E, 0xAA, 0x58, 0x2F, 0xE8, 0x15,
      0x1A, 0xB6, 0xE1, 0x85, 0x5A, 0x72, 0x8C, 0x00 };

###############################################################################

TITLE
    GSM A5/1 goodBtoA

TYPE
    8

DATA
    { 0x24, 0xFD, 0x35, 0xA3, 0x5D, 0x5F, 0xB6,
      0x52, 0x6D, 0x32, 0xF9, 0x06, 0xDF, 0x1A, 0xC0 };

###############################################################################

TITLE
    GSM A5/2 goodAtoB

TYPE
    8

DATA
    { 0xf4, 0x51, 0x2c, 0xac, 0x13, 0x59, 0x37,
      0x64, 0x46, 0x0b, 0x72, 0x2d, 0xad, 0xd5, 0x00 };

###############################################################################

TITLE
    GSM A5/2 goodBtoA

TYPE
    8

DATA
    { 0x48, 0x00, 0xd4, 0x32, 0x8e, 0x16, 0xa1,
      0x4d, 0xcd, 0x7b, 0x97, 0x22, 0x26, 0x51, 0x00 };

###############################################################################

TITLE
    MBC1 iv_tbl

TYPE
    32

DATA
	0xFA5D7CEC, 0x734533F8, 0x484EA4B2, 0x2BF0E46B,
	0xA853884B, 0xCBE7DEE0, 0x976DF92A, 0xE2B17575,
	0xF9BC1EFD, 0xF8ADC573, 0x2E5B6EA9, 0x1C5A4FFD,
	0x3DF27762, 0x2D7BF0BD, 0x039D26D6, 0x0A937D09,
	0x01052BC2, 0x8AEEEA1C, 0xFB7D3EBE, 0x2449A182,
	0x17B71BA3, 0xC6E68955, 0x74C7A0CD, 0xE1B88745,
	0x4D71958C, 0x149CEB88, 0x5344E0B9, 0xC3F0A21F,
	0xA348429B, 0xF672C8CD, 0xD01FA55C, 0x4C6FD3DF,
	0xC05B564E, 0xE0D81861, 0xA3B3EAAC, 0x17AE4A08,
	0x9D8DF3BF, 0x1353CBFE, 0x25C0F1C8, 0xD52818EC,
	0x1BA102B0, 0xC2FDC394, 0x9AB0505E, 0xF8D5F8CB,
	0x708749DA, 0x34C5D60B, 0xD1C046B0, 0x4C8E4672,
	0x0E236A84, 0x5A36C5AB, 0xDC9B9EB5, 0x0ADB5718,
	0x57D27CC5, 0xC4ECAEFD, 0xB57C0D9E, 0x764E92EA,
	0x4CA01ED6, 0xA7314405, 0xEE5E6B4B, 0xF9560189,
	0xC50CD4D5, 0xBFE0AFD8, 0x8322F984, 0x65601B60

###############################################################################

TITLE
    Noekeon Nessie round

TYPE
    8, 32 HEX

DATA
    80,1B,36,6C,D8,AB,4D,9A,2F,5E,BC,63,C6,97,35,6A,D4

###############################################################################

TITLE
    Misty md5const

TYPE
    32

DATA
    3614090360L, 3905402710L,  606105819L, 3250441966L,
    4118548399L, 1200080426L, 2821735955L, 4249261313L,
    1770035416L, 2336552879L, 4294925233L, 2304563134L,
    1804603682L, 4254626195L, 2792965006L, 1236535329L,
    4129170786L, 3225465664L,  643717713L, 3921069994L,
    3593408605L,   38016083L, 3634488961L, 3889429448L,
    568446438L, 3275163606L, 4107603335L, 1163531501L,
    2850285829L, 4243563512L, 1735328473L, 2368359562L,
    4294588738L, 2272392833L, 1839030562L, 4259657740L,
    2763975236L, 1272893353L, 4139469664L, 3200236656L,
    681279174L, 3936430074L, 3572445317L,   76029189L,
    3654602809L, 3873151461L,  530742520L, 3299628645L,
    4096336452L, 1126891415L, 2878612391L, 4237533241L,
    1700485571L, 2399980690L, 4293915773L, 2240044497L,
    1873313359L, 4264355552L, 2734768916L, 1309151649L,
    4149444226L, 3174756917L,  718787259L, 3951481745L

###############################################################################

TITLE
    MBC2

TYPE
    32 AND

DATA
    0x80000000    31
    0x40000000    30
    0x20000000    29
    0x10000000    28
    0x08000000    27
    0x04000000    26
    0x02000000    25
    0x01000000    24
    0x00800000    23
    0x00400000    22
    0x00200000    21
    0x00100000    20
    0x00080000    19
    0x00040000    18
    0x00020000    17
    0x00010000    16
    0x00008000    15
    0x00004000    14
    0x00002000    13
    0x00001000    12
    0x00000800    11
    0x00000400    10
    0x00000200     9
    0x00000100     8
    0x00000080     7
    0x00000040     6
    0x00000020     5
    0x00000010     4
    0x00000008     3
    0x00000004     2
    0x00000002     1

###############################################################################

TITLE
    Magenta tab and large tab0

TYPE
    8, 32

DATA
 0x01 0x02 0x04 0x08 0x10 0x20 0x40 0x80 0x65 0xca 0xf1 0x87 0x6b 0xd6 0xc9 0xf7
 0x8b 0x73 0xe6 0xa9 0x37 0x6e 0xdc 0xdd 0xdf 0xdb 0xd3 0xc3 0xe3 0xa3 0x23 0x46
 0x8c 0x7d 0xfa 0x91 0x47 0x8e 0x79 0xf2 0x81 0x67 0xce 0xf9 0x97 0x4b 0x96 0x49
 0x92 0x41 0x82 0x61 0xc2 0xe1 0xa7 0x2b 0x56 0xac 0x3d 0x7a 0xf4 0x8d 0x7f 0xfe
 0x99 0x57 0xae 0x39 0x72 0xe4 0xad 0x3f 0x7e 0xfc 0x9d 0x5f 0xbe 0x19 0x32 0x64
 0xc8 0xf5 0x8f 0x7b 0xf6 0x89 0x77 0xee 0xb9 0x17 0x2e 0x5c 0xb8 0x15 0x2a 0x54
 0xa8 0x35 0x6a 0xd4 0xcd 0xff 0x9b 0x53 0xa6 0x29 0x52 0xa4 0x2d 0x5a 0xb4 0x0d
 0x1a 0x34 0x68 0xd0 0xc5 0xef 0xbb 0x13 0x26 0x4c 0x98 0x55 0xaa 0x31 0x62 0xc4
 0xed 0xbf 0x1b 0x36 0x6c 0xd8 0xd5 0xcf 0xfb 0x93 0x43 0x86 0x69 0xd2 0xc1 0xe7
 0xab 0x33 0x66 0xcc 0xfd 0x9f 0x5b 0xb6 0x09 0x12 0x24 0x48 0x90 0x45 0x8a 0x71
 0xe2 0xa1 0x27 0x4e 0x9c 0x5d 0xba 0x11 0x22 0x44 0x88 0x75 0xea 0xb1 0x07 0x0e
 0x1c 0x38 0x70 0xe0 0xa5 0x2f 0x5e 0xbc 0x1d 0x3a 0x74 0xe8 0xb5 0x0f 0x1e 0x3c
 0x78 0xf0 0x85 0x6f 0xde 0xd9 0xd7 0xcb 0xf3 0x83 0x63 0xc6 0xe9 0xb7 0x0b 0x16
 0x2c 0x58 0xb0 0x05 0x0a 0x14 0x28 0x50 0xa0 0x25 0x4a 0x94 0x4d 0x9a 0x51 0xa2
 0x21 0x42 0x84 0x6d 0xda 0xd1 0xc7 0xeb 0xb3 0x03 0x06 0x0c 0x18 0x30 0x60 0xc0
 0xe5 0xaf 0x3b 0x76 0xec 0xbd 0x1f 0x3e 0x7c 0xf8 0x95 0x4f 0x9e 0x59 0xb2 0x00

###############################################################################

TITLE
    Huffman LZH p_len

TYPE
    8

DATA
    0x03, 0x04, 0x04, 0x04, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
    0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08

###############################################################################

TITLE
    Huffman LZH d_len

TYPE
    8

DATA
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
    0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
    0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,

###############################################################################

TITLE
    Pkep init

TYPE
    8

DATA
  0x94,0x05,0xF4,0x50,0x81,0x79,0x38,0xAB,
  0x39,0x81,0x05,0x8C,0xCD,0xE8,0x04,0xDF,0x6E,0x7C,0xAB,0x07,
  0x63,0xFE,0x4A,0xD7,0x47,0x05,0x9D,0x2D,0x73,0xA9,0x38,0xBA,
  0xB5,0x48,0x39,0x10,0x0A,0xD8,0xD1,0x5A,0x9D,0x64,0x74,0xF8,
  0x8B,0xC5,0x3E,0x9A,0xBF,0x27,0x55,0x9C,0x0C,0x6A,0x7E,0xD8,
  0xA4,0x78,0x96,0x4C,0x96,0xBB,0x3A,0xC3

###############################################################################

TITLE
    Pkep prime512

TYPE
    8

DATA
        0xF5, 0x2A, 0xFF, 0x3C, 0xE1, 0xB1, 0x29, 0x40,
        0x18, 0x11, 0x8D, 0x7C, 0x84, 0xA7, 0x0A, 0x72,
        0xD6, 0x86, 0xC4, 0x03, 0x19, 0xC8, 0x07, 0x29,
        0x7A, 0xCA, 0x95, 0x0C, 0xD9, 0x96, 0x9F, 0xAB,
        0xD0, 0x0A, 0x50, 0x9B, 0x02, 0x46, 0xD3, 0x08,
        0x3D, 0x66, 0xA4, 0x5D, 0x41, 0x9F, 0x9C, 0x7C,
        0xBD, 0x89, 0x4B, 0x22, 0x19, 0x26, 0xBA, 0xAB,
        0xA2, 0x5E, 0xC3, 0x55, 0xE9, 0x2A, 0x05, 0x5F

###############################################################################

TITLE
    redoc3 prime

TYPE
    32

DATA
      1,   3,   5,   7,  11,  13,  17,
	 19,  23,  29,  31,  37,  41,  43,
	  47,  53,  59,  61,  67,  71,  73,
	  79,  83,  89,  97, 101, 103, 107,
	 109, 113, 127, 131, 137, 139, 149

###############################################################################

TITLE
    redoc2 key_x

TYPE
    8

DATA
    {114, 77, 62, 14, 91, 113, 233, 170, 56, 152};

###############################################################################

TITLE
    redoc2 key_y

TYPE
    8

DATA
    {255, 222, 26, 155, 213, 248, 12, 109, 78, 95};

###############################################################################

TITLE
    Misty s7

TYPE
    8, 32

DATA
  0x1b, 0x32, 0x33, 0x5a, 0x3b, 0x10, 0x17, 0x54, 0x5b, 0x1a, 0x72, 0x73, 0x6b, 0x2c, 0x66, 0x49,
  0x1f, 0x24, 0x13, 0x6c, 0x37, 0x2e, 0x3f, 0x4a, 0x5d, 0x0f, 0x40, 0x56, 0x25, 0x51, 0x1c, 0x04,
  0x0b, 0x46, 0x20, 0x0d, 0x7b, 0x35, 0x44, 0x42, 0x2b, 0x1e, 0x41, 0x14, 0x4b, 0x79, 0x15, 0x6f,
  0x0e, 0x55, 0x09, 0x36, 0x74, 0x0c, 0x67, 0x53, 0x28, 0x0a, 0x7e, 0x38, 0x02, 0x07, 0x60, 0x29,
  0x19, 0x12, 0x65, 0x2f, 0x30, 0x39, 0x08, 0x68, 0x5f, 0x78, 0x2a, 0x4c, 0x64, 0x45, 0x75, 0x3d,
  0x59, 0x48, 0x03, 0x57, 0x7c, 0x4f, 0x62, 0x3c, 0x1d, 0x21, 0x5e, 0x27, 0x6a, 0x70, 0x4d, 0x3a,
  0x01, 0x6d, 0x6e, 0x63, 0x18, 0x77, 0x23, 0x05, 0x26, 0x76, 0x00, 0x31, 0x2d, 0x7a, 0x7f, 0x61,
  0x50, 0x22, 0x11, 0x06, 0x47, 0x16, 0x52, 0x4e, 0x71, 0x3e, 0x69, 0x43, 0x34, 0x5c, 0x58, 0x7d

###############################################################################

TITLE
    Misty s9

TYPE
    16, 32

DATA
  0x1c3, 0x0cb, 0x153, 0x19f, 0x1e3, 0x0e9, 0x0fb, 0x035, 0x181, 0x0b9, 0x117, 0x1eb, 0x133, 0x009, 0x02d, 0x0d3,
  0x0c7, 0x14a, 0x037, 0x07e, 0x0eb, 0x164, 0x193, 0x1d8, 0x0a3, 0x11e, 0x055, 0x02c, 0x01d, 0x1a2, 0x163, 0x118,
  0x14b, 0x152, 0x1d2, 0x00f, 0x02b, 0x030, 0x13a, 0x0e5, 0x111, 0x138, 0x18e, 0x063, 0x0e3, 0x0c8, 0x1f4, 0x01b,
  0x001, 0x09d, 0x0f8, 0x1a0, 0x16d, 0x1f3, 0x01c, 0x146, 0x07d, 0x0d1, 0x082, 0x1ea, 0x183, 0x12d, 0x0f4, 0x19e,
  0x1d3, 0x0dd, 0x1e2, 0x128, 0x1e0, 0x0ec, 0x059, 0x091, 0x011, 0x12f, 0x026, 0x0dc, 0x0b0, 0x18c, 0x10f, 0x1f7,
  0x0e7, 0x16c, 0x0b6, 0x0f9, 0x0d8, 0x151, 0x101, 0x14c, 0x103, 0x0b8, 0x154, 0x12b, 0x1ae, 0x017, 0x071, 0x00c,
  0x047, 0x058, 0x07f, 0x1a4, 0x134, 0x129, 0x084, 0x15d, 0x19d, 0x1b2, 0x1a3, 0x048, 0x07c, 0x051, 0x1ca, 0x023,
  0x13d, 0x1a7, 0x165, 0x03b, 0x042, 0x0da, 0x192, 0x0ce, 0x0c1, 0x06b, 0x09f, 0x1f1, 0x12c, 0x184, 0x0fa, 0x196,
  0x1e1, 0x169, 0x17d, 0x031, 0x180, 0x10a, 0x094, 0x1da, 0x186, 0x13e, 0x11c, 0x060, 0x175, 0x1cf, 0x067, 0x119,
  0x065, 0x068, 0x099, 0x150, 0x008, 0x007, 0x17c, 0x0b7, 0x024, 0x019, 0x0de, 0x127, 0x0db, 0x0e4, 0x1a9, 0x052,
  0x109, 0x090, 0x19c, 0x1c1, 0x028, 0x1b3, 0x135, 0x16a, 0x176, 0x0df, 0x1e5, 0x188, 0x0c5, 0x16e, 0x1de, 0x1b1,
  0x0c3, 0x1df, 0x036, 0x0ee, 0x1ee, 0x0f0, 0x093, 0x049, 0x09a, 0x1b6, 0x069, 0x081, 0x125, 0x00b, 0x05e, 0x0b4,
  0x149, 0x1c7, 0x174, 0x03e, 0x13b, 0x1b7, 0x08e, 0x1c6, 0x0ae, 0x010, 0x095, 0x1ef, 0x04e, 0x0f2, 0x1fd, 0x085,
  0x0fd, 0x0f6, 0x0a0, 0x16f, 0x083, 0x08a, 0x156, 0x09b, 0x13c, 0x107, 0x167, 0x098, 0x1d0, 0x1e9, 0x003, 0x1fe,
  0x0bd, 0x122, 0x089, 0x0d2, 0x18f, 0x012, 0x033, 0x06a, 0x142, 0x0ed, 0x170, 0x11b, 0x0e2, 0x14f, 0x158, 0x131,
  0x147, 0x05d, 0x113, 0x1cd, 0x079, 0x161, 0x1a5, 0x179, 0x09e, 0x1b4, 0x0cc, 0x022, 0x132, 0x01a, 0x0e8, 0x004,
  0x187, 0x1ed, 0x197, 0x039, 0x1bf, 0x1d7, 0x027, 0x18b, 0x0c6, 0x09c, 0x0d0, 0x14e, 0x06c, 0x034, 0x1f2, 0x06e,
  0x0ca, 0x025, 0x0ba, 0x191, 0x0fe, 0x013, 0x106, 0x02f, 0x1ad, 0x172, 0x1db, 0x0c0, 0x10b, 0x1d6, 0x0f5, 0x1ec,
  0x10d, 0x076, 0x114, 0x1ab, 0x075, 0x10c, 0x1e4, 0x159, 0x054, 0x11f, 0x04b, 0x0c4, 0x1be, 0x0f7, 0x029, 0x0a4,
  0x00e, 0x1f0, 0x077, 0x04d, 0x17a, 0x086, 0x08b, 0x0b3, 0x171, 0x0bf, 0x10e, 0x104, 0x097, 0x15b, 0x160, 0x168,
  0x0d7, 0x0bb, 0x066, 0x1ce, 0x0fc, 0x092, 0x1c5, 0x06f, 0x016, 0x04a, 0x0a1, 0x139, 0x0af, 0x0f1, 0x190, 0x00a,
  0x1aa, 0x143, 0x17b, 0x056, 0x18d, 0x166, 0x0d4, 0x1fb, 0x14d, 0x194, 0x19a, 0x087, 0x1f8, 0x123, 0x0a7, 0x1b8,
  0x141, 0x03c, 0x1f9, 0x140, 0x02a, 0x155, 0x11a, 0x1a1, 0x198, 0x0d5, 0x126, 0x1af, 0x061, 0x12e, 0x157, 0x1dc,
  0x072, 0x18a, 0x0aa, 0x096, 0x115, 0x0ef, 0x045, 0x07b, 0x08d, 0x145, 0x053, 0x05f, 0x178, 0x0b2, 0x02e, 0x020,
  0x1d5, 0x03f, 0x1c9, 0x1e7, 0x1ac, 0x044, 0x038, 0x014, 0x0b1, 0x16b, 0x0ab, 0x0b5, 0x05a, 0x182, 0x1c8, 0x1d4,
  0x018, 0x177, 0x064, 0x0cf, 0x06d, 0x100, 0x199, 0x130, 0x15a, 0x005, 0x120, 0x1bb, 0x1bd, 0x0e0, 0x04f, 0x0d6,
  0x13f, 0x1c4, 0x12a, 0x015, 0x006, 0x0ff, 0x19b, 0x0a6, 0x043, 0x088, 0x050, 0x15f, 0x1e8, 0x121, 0x073, 0x17e,
  0x0bc, 0x0c2, 0x0c9, 0x173, 0x189, 0x1f5, 0x074, 0x1cc, 0x1e6, 0x1a8, 0x195, 0x01f, 0x041, 0x00d, 0x1ba, 0x032,
  0x03d, 0x1d1, 0x080, 0x0a8, 0x057, 0x1b9, 0x162, 0x148, 0x0d9, 0x105, 0x062, 0x07a, 0x021, 0x1ff, 0x112, 0x108,
  0x1c0, 0x0a9, 0x11d, 0x1b0, 0x1a6, 0x0cd, 0x0f3, 0x05c, 0x102, 0x05b, 0x1d9, 0x144, 0x1f6, 0x0ad, 0x0a5, 0x03a,
  0x1cb, 0x136, 0x17f, 0x046, 0x0e1, 0x01e, 0x1dd, 0x0e6, 0x137, 0x1fa, 0x185, 0x08c, 0x08f, 0x040, 0x1b5, 0x0be,
  0x078, 0x000, 0x0ac, 0x110, 0x15e, 0x124, 0x002, 0x1bc, 0x0a2, 0x0ea, 0x070, 0x1fc, 0x116, 0x15c, 0x04c, 0x1c2

###############################################################################

TITLE
    SecuDE bdk

TYPE
    8

DATA
        { 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01 } ,
        { 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE } ,
        { 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F } ,
        { 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0 } ,
        { 0xE0, 0xFE, 0xE0, 0xFE, 0xF1, 0xFE, 0xF1, 0xFE } ,
        { 0x1F, 0xFE, 0x1F, 0xFE, 0x0E, 0xFE, 0x0E, 0xFE } ,
        { 0x01, 0xFE, 0x01, 0xFE, 0x01, 0xFE, 0x01, 0xFE } ,
        { 0x1F, 0x0E, 0x1F, 0xE0, 0x0E, 0xF1, 0x0E, 0xF1 } ,
        { 0x01, 0xE0, 0x01, 0xE0, 0x01, 0xF1, 0x01, 0xF1 } ,
        { 0x01, 0xE0, 0x01, 0xE0, 0x01, 0xF1, 0x01, 0xF1 } ,
        { 0xFE, 0xE0, 0xFE, 0xE0, 0xFE, 0xF1, 0xFE, 0xF1 } ,
        { 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x0E, 0xFE, 0x0E } ,
        { 0xFE, 0x01, 0xFE, 0x01, 0xFE, 0x01, 0xFE, 0x01 } ,
        { 0xFE, 0x1F, 0xFE, 0x1F, 0xFE, 0x0E, 0xFE, 0x0E } ,
        { 0xE0, 0x01, 0xE0, 0x01, 0xF1, 0x01, 0xF1, 0x01 } ,
        { 0x1F, 0x01, 0x1F, 0x01, 0x0E, 0x01, 0x0E, 0x01 } 

###############################################################################

TITLE
    SecuDE random_mult

TYPE
    32

DATA
    { 0x12345675, 0x89abcdef, 0x47110815, 0x1f2e3d4c, 0x256345fc, 0xfdbc2454, 0x2345fbac, 0xfd6a87fb};

###############################################################################

TITLE
    SecuDE random_add

TYPE
    32

DATA
    { 0x23571113, 0x17192123, 0x29313741, 0x43475359, 0x456fbcae, 0x456fbd67, 0x245fbcdd, 0x43563567};

###############################################################################

TITLE
    STARMOD transport_key

TYPE
    8

DATA
    {0xA2, 0x6F, 0xA6, 0xA2, 0xF8, 0x5E, 0x83, 0x8D,
     0xBE, 0x62, 0x34, 0xC1, 0xCB, 0xF7, 0x2F, 0xBF,
     0xBD, 0x94, 0x73, 0xEF, 0xBC, 0x46, 0xD6, 0xB4,
     0xDB, 0x24, 0x31, 0x39, 0xDE, 0x0C, 0x68, 0x49,
     0x8A, 0x67, 0xD5, 0xFD, 0x2A, 0x6D, 0x3A, 0x70,
     0x2A, 0xE4, 0xDC, 0xD1, 0x07, 0x87, 0xD5, 0x31,
     0x0E, 0x27, 0x0C, 0x45, 0x6A, 0x28, 0x1A, 0xE1,
     0x22, 0x93, 0xC7, 0xD0, 0xD5, 0xF6, 0xEF, 0x6D};

###############################################################################

TITLE
    Turing sbox

TYPE
    8

DATA
    0x61, 0x51, 0xeb, 0x19, 0xb9, 0x5d, 0x60, 0x38,
    0x7c, 0xb2, 0x06, 0x12, 0xc4, 0x5b, 0x16, 0x3b,
    0x2b, 0x18, 0x83, 0xb0, 0x7f, 0x75, 0xfa, 0xa0,
    0xe9, 0xdd, 0x6d, 0x7a, 0x6b, 0x68, 0x2d, 0x49,
    0xb5, 0x1c, 0x90, 0xf7, 0xed, 0x9f, 0xe8, 0xce,
    0xae, 0x77, 0xc2, 0x13, 0xfd, 0xcd, 0x3e, 0xcf,
    0x37, 0x6a, 0xd4, 0xdb, 0x8e, 0x65, 0x1f, 0x1a,
    0x87, 0xcb, 0x40, 0x15, 0x88, 0x0d, 0x35, 0xb3,
    0x11, 0x0f, 0xd0, 0x30, 0x48, 0xf9, 0xa8, 0xac,
    0x85, 0x27, 0x0e, 0x8a, 0xe0, 0x50, 0x64, 0xa7,
    0xcc, 0xe4, 0xf1, 0x98, 0xff, 0xa1, 0x04, 0xda,
    0xd5, 0xbc, 0x1b, 0xbb, 0xd1, 0xfe, 0x31, 0xca,
    0xba, 0xd9, 0x2e, 0xf3, 0x1d, 0x47, 0x4a, 0x3d,
    0x71, 0x4c, 0xab, 0x7d, 0x8d, 0xc7, 0x59, 0xb8,
    0xc1, 0x96, 0x1e, 0xfc, 0x44, 0xc8, 0x7b, 0xdc,
    0x5c, 0x78, 0x2a, 0x9d, 0xa5, 0xf0, 0x73, 0x22,
    0x89, 0x05, 0xf4, 0x07, 0x21, 0x52, 0xa6, 0x28,
    0x9a, 0x92, 0x69, 0x8f, 0xc5, 0xc3, 0xf5, 0xe1,
    0xde, 0xec, 0x09, 0xf2, 0xd3, 0xaf, 0x34, 0x23,
    0xaa, 0xdf, 0x7e, 0x82, 0x29, 0xc0, 0x24, 0x14,
    0x03, 0x32, 0x4e, 0x39, 0x6f, 0xc6, 0xb1, 0x9b,
    0xea, 0x72, 0x79, 0x41, 0xd8, 0x26, 0x6c, 0x5e,
    0x2c, 0xb4, 0xa2, 0x53, 0x57, 0xe2, 0x9c, 0x86,
    0x54, 0x95, 0xb6, 0x80, 0x8c, 0x36, 0x67, 0xbd,
    0x08, 0x93, 0x2f, 0x99, 0x5a, 0xf8, 0x3a, 0xd7,
    0x56, 0x84, 0xd2, 0x01, 0xf6, 0x66, 0x4d, 0x55,
    0x8b, 0x0c, 0x0b, 0x46, 0xb7, 0x3c, 0x45, 0x91,
    0xa4, 0xe3, 0x70, 0xd6, 0xfb, 0xe6, 0x10, 0xa9,
    0xc9, 0x00, 0x9e, 0xe7, 0x4f, 0x76, 0x25, 0x3f,
    0x5f, 0xa3, 0x33, 0x20, 0x02, 0xef, 0x62, 0x74,
    0xee, 0x17, 0x81, 0x42, 0x58, 0x0a, 0x4b, 0x63,
    0xe5, 0xbe, 0x6e, 0xad, 0xbf, 0x43, 0x94, 0x97,

###############################################################################

TITLE
    Turing multab

TYPE
    32

DATA
    0x00000000, 0xD02B4367, 0xED5686CE, 0x3D7DC5A9,
    0x97AC41D1, 0x478702B6, 0x7AFAC71F, 0xAAD18478,
    0x631582EF, 0xB33EC188, 0x8E430421, 0x5E684746,
    0xF4B9C33E, 0x24928059, 0x19EF45F0, 0xC9C40697,
    0xC62A4993, 0x16010AF4, 0x2B7CCF5D, 0xFB578C3A,
    0x51860842, 0x81AD4B25, 0xBCD08E8C, 0x6CFBCDEB,
    0xA53FCB7C, 0x7514881B, 0x48694DB2, 0x98420ED5,
    0x32938AAD, 0xE2B8C9CA, 0xDFC50C63, 0x0FEE4F04,
    0xC154926B, 0x117FD10C, 0x2C0214A5, 0xFC2957C2,
    0x56F8D3BA, 0x86D390DD, 0xBBAE5574, 0x6B851613,
    0xA2411084, 0x726A53E3, 0x4F17964A, 0x9F3CD52D,
    0x35ED5155, 0xE5C61232, 0xD8BBD79B, 0x089094FC,
    0x077EDBF8, 0xD755989F, 0xEA285D36, 0x3A031E51,
    0x90D29A29, 0x40F9D94E, 0x7D841CE7, 0xADAF5F80,
    0x646B5917, 0xB4401A70, 0x893DDFD9, 0x59169CBE,
    0xF3C718C6, 0x23EC5BA1, 0x1E919E08, 0xCEBADD6F,
    0xCFA869D6, 0x1F832AB1, 0x22FEEF18, 0xF2D5AC7F,
    0x58042807, 0x882F6B60, 0xB552AEC9, 0x6579EDAE,
    0xACBDEB39, 0x7C96A85E, 0x41EB6DF7, 0x91C02E90,
    0x3B11AAE8, 0xEB3AE98F, 0xD6472C26, 0x066C6F41,
    0x09822045, 0xD9A96322, 0xE4D4A68B, 0x34FFE5EC,
    0x9E2E6194, 0x4E0522F3, 0x7378E75A, 0xA353A43D,
    0x6A97A2AA, 0xBABCE1CD, 0x87C12464, 0x57EA6703,
    0xFD3BE37B, 0x2D10A01C, 0x106D65B5, 0xC04626D2,
    0x0EFCFBBD, 0xDED7B8DA, 0xE3AA7D73, 0x33813E14,
    0x9950BA6C, 0x497BF90B, 0x74063CA2, 0xA42D7FC5,
    0x6DE97952, 0xBDC23A35, 0x80BFFF9C, 0x5094BCFB,
    0xFA453883, 0x2A6E7BE4, 0x1713BE4D, 0xC738FD2A,
    0xC8D6B22E, 0x18FDF149, 0x258034E0, 0xF5AB7787,
    0x5F7AF3FF, 0x8F51B098, 0xB22C7531, 0x62073656,
    0xABC330C1, 0x7BE873A6, 0x4695B60F, 0x96BEF568,
    0x3C6F7110, 0xEC443277, 0xD139F7DE, 0x0112B4B9,
    0xD31DD2E1, 0x03369186, 0x3E4B542F, 0xEE601748,
    0x44B19330, 0x949AD057, 0xA9E715FE, 0x79CC5699,
    0xB008500E, 0x60231369, 0x5D5ED6C0, 0x8D7595A7,
    0x27A411DF, 0xF78F52B8, 0xCAF29711, 0x1AD9D476,
    0x15379B72, 0xC51CD815, 0xF8611DBC, 0x284A5EDB,
    0x829BDAA3, 0x52B099C4, 0x6FCD5C6D, 0xBFE61F0A,
    0x7622199D, 0xA6095AFA, 0x9B749F53, 0x4B5FDC34,
    0xE18E584C, 0x31A51B2B, 0x0CD8DE82, 0xDCF39DE5,
    0x1249408A, 0xC26203ED, 0xFF1FC644, 0x2F348523,
    0x85E5015B, 0x55CE423C, 0x68B38795, 0xB898C4F2,
    0x715CC265, 0xA1778102, 0x9C0A44AB, 0x4C2107CC,
    0xE6F083B4, 0x36DBC0D3, 0x0BA6057A, 0xDB8D461D,
    0xD4630919, 0x04484A7E, 0x39358FD7, 0xE91ECCB0,
    0x43CF48C8, 0x93E40BAF, 0xAE99CE06, 0x7EB28D61,
    0xB7768BF6, 0x675DC891, 0x5A200D38, 0x8A0B4E5F,
    0x20DACA27, 0xF0F18940, 0xCD8C4CE9, 0x1DA70F8E,
    0x1CB5BB37, 0xCC9EF850, 0xF1E33DF9, 0x21C87E9E,
    0x8B19FAE6, 0x5B32B981, 0x664F7C28, 0xB6643F4F,
    0x7FA039D8, 0xAF8B7ABF, 0x92F6BF16, 0x42DDFC71,
    0xE80C7809, 0x38273B6E, 0x055AFEC7, 0xD571BDA0,
    0xDA9FF2A4, 0x0AB4B1C3, 0x37C9746A, 0xE7E2370D,
    0x4D33B375, 0x9D18F012, 0xA06535BB, 0x704E76DC,
    0xB98A704B, 0x69A1332C, 0x54DCF685, 0x84F7B5E2,
    0x2E26319A, 0xFE0D72FD, 0xC370B754, 0x135BF433,
    0xDDE1295C, 0x0DCA6A3B, 0x30B7AF92, 0xE09CECF5,
    0x4A4D688D, 0x9A662BEA, 0xA71BEE43, 0x7730AD24,
    0xBEF4ABB3, 0x6EDFE8D4, 0x53A22D7D, 0x83896E1A,
    0x2958EA62, 0xF973A905, 0xC40E6CAC, 0x14252FCB,
    0x1BCB60CF, 0xCBE023A8, 0xF69DE601, 0x26B6A566,
    0x8C67211E, 0x5C4C6279, 0x6131A7D0, 0xB11AE4B7,
    0x78DEE220, 0xA8F5A147, 0x958864EE, 0x45A32789,
    0xEF72A3F1, 0x3F59E096, 0x0224253F, 0xD20F6658,

###############################################################################

TITLE
    Turing Qbox

TYPE
    32

DATA
    0x1faa1887,   0x4e5e435c,   0x9165c042,   0x250e6ef4,   
    0x5957ee20,   0xd484fed3,   0xa666c502,   0x7e54e8ae,   
    0xd12ee9d9,   0xfc1f38d4,   0x49829b5d,   0x1b5cdf3c,   
    0x74864249,   0xda2e3963,   0x28f4429f,   0xc8432c35,   
    0x4af40325,   0x9fc0dd70,   0xd8973ded,   0x1a02dc5e,   
    0xcd175b42,   0xf10012bf,   0x6694d78c,   0xacaab26b,   
    0x4ec11b9a,   0x3f168146,   0xc0ea8ec5,   0xb38ac28f,   
    0x1fed5c0f,   0xaab4101c,   0xea2db082,   0x470929e1,   
    0xe71843de,   0x508299fc,   0xe72fbc4b,   0x2e3915dd,   
    0x9fa803fa,   0x9546b2de,   0x3c233342,   0x0fcee7c3,   
    0x24d607ef,   0x8f97ebab,   0xf37f859b,   0xcd1f2e2f,   
    0xc25b71da,   0x75e2269a,   0x1e39c3d1,   0xeda56b36,   
    0xf8c9def2,   0x46c9fc5f,   0x1827b3a3,   0x70a56ddf,   
    0x0d25b510,   0x000f85a7,   0xb2e82e71,   0x68cb8816,   
    0x8f951e2a,   0x72f5f6af,   0xe4cbc2b3,   0xd34ff55d,   
    0x2e6b6214,   0x220b83e3,   0xd39ea6f5,   0x6fe041af,   
    0x6b2f1f17,   0xad3b99ee,   0x16a65ec0,   0x757016c6,   
    0xba7709a4,   0xb0326e01,   0xf4b280d9,   0x4bfb1418,   
    0xd6aff227,   0xfd548203,   0xf56b9d96,   0x6717a8c0,   
    0x00d5bf6e,   0x10ee7888,   0xedfcfe64,   0x1ba193cd,   
    0x4b0d0184,   0x89ae4930,   0x1c014f36,   0x82a87088,   
    0x5ead6c2a,   0xef22c678,   0x31204de7,   0xc9c2e759,   
    0xd200248e,   0x303b446b,   0xb00d9fc2,   0x9914a895,   
    0x906cc3a1,   0x54fef170,   0x34c19155,   0xe27b8a66,   
    0x131b5e69,   0xc3a8623e,   0x27bdfa35,   0x97f068cc,   
    0xca3a6acd,   0x4b55e936,   0x86602db9,   0x51df13c1,   
    0x390bb16d,   0x5a80b83c,   0x22b23763,   0x39d8a911,   
    0x2cb6bc13,   0xbf5579d7,   0x6c5c2fa8,   0xa8f4196e,   
    0xbcdb5476,   0x6864a866,   0x416e16ad,   0x897fc515,   
    0x956feb3c,   0xf6c8a306,   0x216799d9,   0x171a9133,   
    0x6c2466dd,   0x75eb5dcd,   0xdf118f50,   0xe4afb226,   
    0x26b9cef3,   0xadb36189,   0x8a7a19b1,   0xe2c73084,   
    0xf77ded5c,   0x8b8bc58f,   0x06dde421,   0xb41e47fb,   
    0xb1cc715e,   0x68c0ff99,   0x5d122f0f,   0xa4d25184,   
    0x097a5e6c,   0x0cbf18bc,   0xc2d7c6e0,   0x8bb7e420,   
    0xa11f523f,   0x35d9b8a2,   0x03da1a6b,   0x06888c02,   
    0x7dd1e354,   0x6bba7d79,   0x32cc7753,   0xe52d9655,   
    0xa9829da1,   0x301590a7,   0x9bc1c149,   0x13537f1c,   
    0xd3779b69,   0x2d71f2b7,   0x183c58fa,   0xacdc4418,   
    0x8d8c8c76,   0x2620d9f0,   0x71a80d4d,   0x7a74c473,   
    0x449410e9,   0xa20e4211,   0xf9c8082b,   0x0a6b334a,   
    0xb5f68ed2,   0x8243cc1b,   0x453c0ff3,   0x9be564a0,   
    0x4ff55a4f,   0x8740f8e7,   0xcca7f15f,   0xe300fe21,   
    0x786d37d6,   0xdfd506f1,   0x8ee00973,   0x17bbde36,   
    0x7a670fa8,   0x5c31ab9e,   0xd4dab618,   0xcc1f52f5,   
    0xe358eb4f,   0x19b9e343,   0x3a8d77dd,   0xcdb93da6,   
    0x140fd52d,   0x395412f8,   0x2ba63360,   0x37e53ad0,   
    0x80700f1c,   0x7624ed0b,   0x703dc1ec,   0xb7366795,   
    0xd6549d15,   0x66ce46d7,   0xd17abe76,   0xa448e0a0,   
    0x28f07c02,   0xc31249b7,   0x6e9ed6ba,   0xeaa47f78,   
    0xbbcfffbd,   0xc507ca84,   0xe965f4da,   0x8e9f35da,   
    0x6ad2aa44,   0x577452ac,   0xb5d674a7,   0x5461a46a,   
    0x6763152a,   0x9c12b7aa,   0x12615927,   0x7b4fb118,   
    0xc351758d,   0x7e81687b,   0x5f52f0b3,   0x2d4254ed,   
    0xd4c77271,   0x0431acab,   0xbef94aec,   0xfee994cd,   
    0x9c4d9e81,   0xed623730,   0xcf8a21e8,   0x51917f0b,   
    0xa7a9b5d6,   0xb297adf8,   0xeed30431,   0x68cac921,   
    0xf1b35d46,   0x7a430a36,   0x51194022,   0x9abca65e,   
    0x85ec70ba,   0x39aea8cc,   0x737bae8b,   0x582924d5,   
    0x03098a5a,   0x92396b81,   0x18de2522,   0x745c1cb8,   
    0xa1b8fe1d,   0x5db3c697,   0x29164f83,   0x97c16376,   
    0x8419224c,   0x21203b35,   0x833ac0fe,   0xd966a19a,   
    0xaaf0b24f,   0x40fda998,   0xe7d52d71,   0x390896a8,   
    0xcee6053f,   0xd0b0d300,   0xff99cbcc,   0x065e3d40,   

###############################################################################

TITLE
    t-class 32 hi0xC2DB2AA3

TYPE
    32

DATA
0x00000000, 0x5E3F42BB, 0xBC7E8576, 0xE241C7CD, 0x1D986F89, 0x43A72D32,
0xA1E6EAFF, 0xFFD9A844, 0x3B30DF12, 0x650F9DA9, 0x874E5A64, 0xD97118DF,
0x26A8B09B, 0x7897F220, 0x9AD635ED, 0xC4E97756, 0x7661BE24, 0x285EFC9F,
0xCA1F3B52, 0x942079E9, 0x6BF9D1AD, 0x35C69316, 0xD78754DB, 0x89B81660,
0x4D516136, 0x136E238D, 0xF12FE440, 0xAF10A6FB, 0x50C90EBF, 0x0EF64C04,
0xECB78BC9, 0xB288C972, 0xECC37C48, 0xB2FC3EF3, 0x50BDF93E, 0x0E82BB85,
0xF15B13C1, 0xAF64517A, 0x4D2596B7, 0x131AD40C, 0xD7F3A35A, 0x89CCE1E1,
0x6B8D262C, 0x35B26497, 0xCA6BCCD3, 0x94548E68, 0x761549A5, 0x282A0B1E,
0x9AA2C26C, 0xC49D80D7, 0x26DC471A, 0x78E305A1, 0x873AADE5, 0xD905EF5E,
0x3B442893, 0x657B6A28, 0xA1921D7E, 0xFFAD5FC5, 0x1DEC9808, 0x43D3DAB3,
0xBC0A72F7, 0xE235304C, 0x0074F781, 0x5E4BB53A, 0xBCE39DF5, 0xE2DCDF4E,
0x009D1883, 0x5EA25A38, 0xA17BF27C, 0xFF44B0C7, 0x1D05770A, 0x433A35B1,
0x87D342E7, 0xD9EC005C, 0x3BADC791, 0x6592852A, 0x9A4B2D6E, 0xC4746FD5,
0x2635A818, 0x780AEAA3, 0xCA8223D1, 0x94BD616A, 0x76FCA6A7, 0x28C3E41C,
0xD71A4C58, 0x89250EE3, 0x6B64C92E, 0x355B8B95, 0xF1B2FCC3, 0xAF8DBE78,
0x4DCC79B5, 0x13F33B0E, 0xEC2A934A, 0xB215D1F1, 0x5054163C, 0x0E6B5487,
0x5020E1BD, 0x0E1FA306, 0xEC5E64CB, 0xB2612670, 0x4DB88E34, 0x1387CC8F,
0xF1C60B42, 0xAFF949F9, 0x6B103EAF, 0x352F7C14, 0xD76EBBD9, 0x8951F962,
0x76885126, 0x28B7139D, 0xCAF6D450, 0x94C996EB, 0x26415F99, 0x787E1D22,
0x9A3FDAEF, 0xC4009854, 0x3BD93010, 0x65E672AB, 0x87A7B566, 0xD998F7DD,
0x1D71808B, 0x434EC230, 0xA10F05FD, 0xFF304746, 0x00E9EF02, 0x5ED6ADB9,
0xBC976A74, 0xE2A828CF, 0x1CA25E8F, 0x429D1C34, 0xA0DCDBF9, 0xFEE39942,
0x013A3106, 0x5F0573BD, 0xBD44B470, 0xE37BF6CB, 0x2792819D, 0x79ADC326,
0x9BEC04EB, 0xC5D34650, 0x3A0AEE14, 0x6435ACAF, 0x86746B62, 0xD84B29D9,
0x6AC3E0AB, 0x34FCA210, 0xD6BD65DD, 0x88822766, 0x775B8F22, 0x2964CD99,
0xCB250A54, 0x951A48EF, 0x51F33FB9, 0x0FCC7D02, 0xED8DBACF, 0xB3B2F874,
0x4C6B5030, 0x1254128B, 0xF015D546, 0xAE2A97FD, 0xF06122C7, 0xAE5E607C,
0x4C1FA7B1, 0x1220E50A, 0xEDF94D4E, 0xB3C60FF5, 0x5187C838, 0x0FB88A83,
0xCB51FDD5, 0x956EBF6E, 0x772F78A3, 0x29103A18, 0xD6C9925C, 0x88F6D0E7,
0x6AB7172A, 0x34885591, 0x86009CE3, 0xD83FDE58, 0x3A7E1995, 0x64415B2E,
0x9B98F36A, 0xC5A7B1D1, 0x27E6761C, 0x79D934A7, 0xBD3043F1, 0xE30F014A,
0x014EC687, 0x5F71843C, 0xA0A82C78, 0xFE976EC3, 0x1CD6A90E, 0x42E9EBB5,
0xA041C37A, 0xFE7E81C1, 0x1C3F460C, 0x420004B7, 0xBDD9ACF3, 0xE3E6EE48,
0x01A72985, 0x5F986B3E, 0x9B711C68, 0xC54E5ED3, 0x270F991E, 0x7930DBA5,
0x86E973E1, 0xD8D6315A, 0x3A97F697, 0x64A8B42C, 0xD6207D5E, 0x881F3FE5,
0x6A5EF828, 0x3461BA93, 0xCBB812D7, 0x9587506C, 0x77C697A1, 0x29F9D51A,
0xED10A24C, 0xB32FE0F7, 0x516E273A, 0x0F516581, 0xF088CDC5, 0xAEB78F7E,
0x4CF648B3, 0x12C90A08, 0x4C82BF32, 0x12BDFD89, 0xF0FC3A44, 0xAEC378FF,
0x511AD0BB, 0x0F259200, 0xED6455CD, 0xB35B1776, 0x77B26020, 0x298D229B,
0xCBCCE556, 0x95F3A7ED, 0x6A2A0FA9, 0x34154D12, 0xD6548ADF, 0x886BC864,
0x3AE30116, 0x64DC43AD, 0x869D8460, 0xD8A2C6DB, 0x277B6E9F, 0x79442C24,
0x9B05EBE9, 0xC53AA952, 0x01D3DE04, 0x5FEC9CBF, 0xBDAD5B72, 0xE39219C9,
0x1C4BB18D, 0x4274F336, 0xA03534FB, 0xFE0A7640, 0x3944BD1E, 0x677BFFA5,
0x853A3868, 0xDB057AD3, 0x24DCD297, 0x7AE3902C, 0x98A257E1, 0xC69D155A,
0x0274620C, 0x5C4B20B7, 0xBE0AE77A, 0xE035A5C1, 0x1FEC0D85, 0x41D34F3E,
0xA39288F3, 0xFDADCA48, 0x4F25033A, 0x111A4181, 0xF35B864C, 0xAD64C4F7,
0x52BD6CB3, 0x0C822E08, 0xEEC3E9C5, 0xB0FCAB7E, 0x7415DC28, 0x2A2A9E93,
0xC86B595E, 0x96541BE5, 0x698DB3A1, 0x37B2F11A, 0xD5F336D7, 0x8BCC746C,
0xD587C156, 0x8BB883ED, 0x69F94420, 0x37C6069B, 0xC81FAEDF, 0x9620EC64,
0x74612BA9, 0x2A5E6912, 0xEEB71E44, 0xB0885CFF, 0x52C99B32, 0x0CF6D989,
0xF32F71CD, 0xAD103376, 0x4F51F4BB, 0x116EB600, 0xA3E67F72, 0xFDD93DC9,
0x1F98FA04, 0x41A7B8BF, 0xBE7E10FB, 0xE0415240, 0x0200958D, 0x5C3FD736,
0x98D6A060, 0xC6E9E2DB, 0x24A82516, 0x7A9767AD, 0x854ECFE9, 0xDB718D52,
0x39304A9F, 0x670F0824, 0x85A720EB, 0xDB986250, 0x39D9A59D, 0x67E6E726,
0x983F4F62, 0xC6000DD9, 0x2441CA14, 0x7A7E88AF, 0xBE97FFF9, 0xE0A8BD42,
0x02E97A8F, 0x5CD63834, 0xA30F9070, 0xFD30D2CB, 0x1F711506, 0x414E57BD,
0xF3C69ECF, 0xADF9DC74, 0x4FB81BB9, 0x11875902, 0xEE5EF146, 0xB061B3FD,
0x52207430, 0x0C1F368B, 0xC8F641DD, 0x96C90366, 0x7488C4AB, 0x2AB78610,
0xD56E2E54, 0x8B516CEF, 0x6910AB22, 0x372FE999, 0x69645CA3, 0x375B1E18,
0xD51AD9D5, 0x8B259B6E, 0x74FC332A, 0x2AC37191, 0xC882B65C, 0x96BDF4E7,
0x525483B1, 0x0C6BC10A, 0xEE2A06C7, 0xB015447C, 0x4FCCEC38, 0x11F3AE83,
0xF3B2694E, 0xAD8D2BF5, 0x1F05E287, 0x413AA03C, 0xA37B67F1, 0xFD44254A,
0x029D8D0E, 0x5CA2CFB5, 0xBEE30878, 0xE0DC4AC3, 0x24353D95, 0x7A0A7F2E,
0x984BB8E3, 0xC674FA58, 0x39AD521C, 0x679210A7, 0x85D3D76A, 0xDBEC95D1,
0x25E6E391, 0x7BD9A12A, 0x999866E7, 0xC7A7245C, 0x387E8C18, 0x6641CEA3,
0x8400096E, 0xDA3F4BD5, 0x1ED63C83, 0x40E97E38, 0xA2A8B9F5, 0xFC97FB4E,
0x034E530A, 0x5D7111B1, 0xBF30D67C, 0xE10F94C7, 0x53875DB5, 0x0DB81F0E,
0xEFF9D8C3, 0xB1C69A78, 0x4E1F323C, 0x10207087, 0xF261B74A, 0xAC5EF5F1,
0x68B782A7, 0x3688C01C, 0xD4C907D1, 0x8AF6456A, 0x752FED2E, 0x2B10AF95,
0xC9516858, 0x976E2AE3, 0xC9259FD9, 0x971ADD62, 0x755B1AAF, 0x2B645814,
0xD4BDF050, 0x8A82B2EB, 0x68C37526, 0x36FC379D, 0xF21540CB, 0xAC2A0270,
0x4E6BC5BD, 0x10548706, 0xEF8D2F42, 0xB1B26DF9, 0x53F3AA34, 0x0DCCE88F,
0xBF4421FD, 0xE17B6346, 0x033AA48B, 0x5D05E630, 0xA2DC4E74, 0xFCE30CCF,
0x1EA2CB02, 0x409D89B9, 0x8474FEEF, 0xDA4BBC54, 0x380A7B99, 0x66353922,
0x99EC9166, 0xC7D3D3DD, 0x25921410, 0x7BAD56AB, 0x99057E64, 0xC73A3CDF,
0x257BFB12, 0x7B44B9A9, 0x849D11ED, 0xDAA25356, 0x38E3949B, 0x66DCD620,
0xA235A176, 0xFC0AE3CD, 0x1E4B2400, 0x407466BB, 0xBFADCEFF, 0xE1928C44,
0x03D34B89, 0x5DEC0932, 0xEF64C040, 0xB15B82FB, 0x531A4536, 0x0D25078D,
0xF2FCAFC9, 0xACC3ED72, 0x4E822ABF, 0x10BD6804, 0xD4541F52, 0x8A6B5DE9,
0x682A9A24, 0x3615D89F, 0xC9CC70DB, 0x97F33260, 0x75B2F5AD, 0x2B8DB716,
0x75C6022C, 0x2BF94097, 0xC9B8875A, 0x9787C5E1, 0x685E6DA5, 0x36612F1E,
0xD420E8D3, 0x8A1FAA68, 0x4EF6DD3E, 0x10C99F85, 0xF2885848, 0xACB71AF3,
0x536EB2B7, 0x0D51F00C, 0xEF1037C1, 0xB12F757A, 0x03A7BC08, 0x5D98FEB3,
0xBFD9397E, 0xE1E67BC5, 0x1E3FD381, 0x4000913A, 0xA24156F7, 0xFC7E144C,
0x3897631A, 0x66A821A1, 0x84E9E66C, 0xDAD6A4D7, 0x250F0C93, 0x7B304E28,
0x997189E5, 0xC74ECB5E, 0x72897A3C, 0x2CB63887, 0xCEF7FF4A, 0x90C8BDF1,
0x6F1115B5, 0x312E570E, 0xD36F90C3, 0x8D50D278, 0x49B9A52E, 0x1786E795,
0xF5C72058, 0xABF862E3, 0x5421CAA7, 0x0A1E881C, 0xE85F4FD1, 0xB6600D6A,
0x04E8C418, 0x5AD786A3, 0xB896416E, 0xE6A903D5, 0x1970AB91, 0x474FE92A,
0xA50E2EE7, 0xFB316C5C, 0x3FD81B0A, 0x61E759B1, 0x83A69E7C, 0xDD99DCC7,
0x22407483, 0x7C7F3638, 0x9E3EF1F5, 0xC001B34E, 0x9E4A0674, 0xC07544CF,
0x22348302, 0x7C0BC1B9, 0x83D269FD, 0xDDED2B46, 0x3FACEC8B, 0x6193AE30,
0xA57AD966, 0xFB459BDD, 0x19045C10, 0x473B1EAB, 0xB8E2B6EF, 0xE6DDF454,
0x049C3399, 0x5AA37122, 0xE82BB850, 0xB614FAEB, 0x54553D26, 0x0A6A7F9D,
0xF5B3D7D9, 0xAB8C9562, 0x49CD52AF, 0x17F21014, 0xD31B6742, 0x8D2425F9,
0x6F65E234, 0x315AA08F, 0xCE8308CB, 0x90BC4A70, 0x72FD8DBD, 0x2CC2CF06,
0xCE6AE7C9, 0x9055A572, 0x721462BF, 0x2C2B2004, 0xD3F28840, 0x8DCDCAFB,
0x6F8C0D36, 0x31B34F8D, 0xF55A38DB, 0xAB657A60, 0x4924BDAD, 0x171BFF16,
0xE8C25752, 0xB6FD15E9, 0x54BCD224, 0x0A83909F, 0xB80B59ED, 0xE6341B56,
0x0475DC9B, 0x5A4A9E20, 0xA5933664, 0xFBAC74DF, 0x19EDB312, 0x47D2F1A9,
0x833B86FF, 0xDD04C444, 0x3F450389, 0x617A4132, 0x9EA3E976, 0xC09CABCD,
0x22DD6C00, 0x7CE22EBB, 0x22A99B81, 0x7C96D93A, 0x9ED71EF7, 0xC0E85C4C,
0x3F31F408, 0x610EB6B3, 0x834F717E, 0xDD7033C5, 0x19994493, 0x47A60628,
0xA5E7C1E5, 0xFBD8835E, 0x04012B1A, 0x5A3E69A1, 0xB87FAE6C, 0xE640ECD7,
0x54C825A5, 0x0AF7671E, 0xE8B6A0D3, 0xB689E268, 0x49504A2C, 0x176F0897,
0xF52ECF5A, 0xAB118DE1, 0x6FF8FAB7, 0x31C7B80C, 0xD3867FC1, 0x8DB93D7A,
0x7260953E, 0x2C5FD785, 0xCE1E1048, 0x902152F3, 0x6E2B24B3, 0x30146608,
0xD255A1C5, 0x8C6AE37E, 0x73B34B3A, 0x2D8C0981, 0xCFCDCE4C, 0x91F28CF7,
0x551BFBA1, 0x0B24B91A, 0xE9657ED7, 0xB75A3C6C, 0x48839428, 0x16BCD693,
0xF4FD115E, 0xAAC253E5, 0x184A9A97, 0x4675D82C, 0xA4341FE1, 0xFA0B5D5A,
0x05D2F51E, 0x5BEDB7A5, 0xB9AC7068, 0xE79332D3, 0x237A4585, 0x7D45073E,
0x9F04C0F3, 0xC13B8248, 0x3EE22A0C, 0x60DD68B7, 0x829CAF7A, 0xDCA3EDC1,
0x82E858FB, 0xDCD71A40, 0x3E96DD8D, 0x60A99F36, 0x9F703772, 0xC14F75C9,
0x230EB204, 0x7D31F0BF, 0xB9D887E9, 0xE7E7C552, 0x05A6029F, 0x5B994024,
0xA440E860, 0xFA7FAADB, 0x183E6D16, 0x46012FAD, 0xF489E6DF, 0xAAB6A464,
0x48F763A9, 0x16C82112, 0xE9118956, 0xB72ECBED, 0x556F0C20, 0x0B504E9B,
0xCFB939CD, 0x91867B76, 0x73C7BCBB, 0x2DF8FE00, 0xD2215644, 0x8C1E14FF,
0x6E5FD332, 0x30609189, 0xD2C8B946, 0x8CF7FBFD, 0x6EB63C30, 0x30897E8B,
0xCF50D6CF, 0x916F9474, 0x732E53B9, 0x2D111102, 0xE9F86654, 0xB7C724EF,
0x5586E322, 0x0BB9A199, 0xF46009DD, 0xAA5F4B66, 0x481E8CAB, 0x1621CE10,
0xA4A90762, 0xFA9645D9, 0x18D78214, 0x46E8C0AF, 0xB93168EB, 0xE70E2A50,
0x054FED9D, 0x5B70AF26, 0x9F99D870, 0xC1A69ACB, 0x23E75D06, 0x7DD81FBD,
0x8201B7F9, 0xDC3EF542, 0x3E7F328F, 0x60407034, 0x3E0BC50E, 0x603487B5,
0x82754078, 0xDC4A02C3, 0x2393AA87, 0x7DACE83C, 0x9FED2FF1, 0xC1D26D4A,
0x053B1A1C, 0x5B0458A7, 0xB9459F6A, 0xE77ADDD1, 0x18A37595, 0x469C372E,
0xA4DDF0E3, 0xFAE2B258, 0x486A7B2A, 0x16553991, 0xF414FE5C, 0xAA2BBCE7,
0x55F214A3, 0x0BCD5618, 0xE98C91D5, 0xB7B3D36E, 0x735AA438, 0x2D65E683,
0xCF24214E, 0x911B63F5, 0x6EC2CBB1, 0x30FD890A, 0xD2BC4EC7, 0x8C830C7C,
0x4BCDC722, 0x15F28599, 0xF7B34254, 0xA98C00EF, 0x5655A8AB, 0x086AEA10,
0xEA2B2DDD, 0xB4146F66, 0x70FD1830, 0x2EC25A8B, 0xCC839D46, 0x92BCDFFD,
0x6D6577B9, 0x335A3502, 0xD11BF2CF, 0x8F24B074, 0x3DAC7906, 0x63933BBD,
0x81D2FC70, 0xDFEDBECB, 0x2034168F, 0x7E0B5434, 0x9C4A93F9, 0xC275D142,
0x069CA614, 0x58A3E4AF, 0xBAE22362, 0xE4DD61D9, 0x1B04C99D, 0x453B8B26,
0xA77A4CEB, 0xF9450E50, 0xA70EBB6A, 0xF931F9D1, 0x1B703E1C, 0x454F7CA7,
0xBA96D4E3, 0xE4A99658, 0x06E85195, 0x58D7132E, 0x9C3E6478, 0xC20126C3,
0x2040E10E, 0x7E7FA3B5, 0x81A60BF1, 0xDF99494A, 0x3DD88E87, 0x63E7CC3C,
0xD16F054E, 0x8F5047F5, 0x6D118038, 0x332EC283, 0xCCF76AC7, 0x92C8287C,
0x7089EFB1, 0x2EB6AD0A, 0xEA5FDA5C, 0xB46098E7, 0x56215F2A, 0x081E1D91,
0xF7C7B5D5, 0xA9F8F76E, 0x4BB930A3, 0x15867218, 0xF72E5AD7, 0xA911186C,
0x4B50DFA1, 0x156F9D1A, 0xEAB6355E, 0xB48977E5, 0x56C8B028, 0x08F7F293,
0xCC1E85C5, 0x9221C77E, 0x706000B3, 0x2E5F4208, 0xD186EA4C, 0x8FB9A8F7,
0x6DF86F3A, 0x33C72D81, 0x814FE4F3, 0xDF70A648, 0x3D316185, 0x630E233E,
0x9CD78B7A, 0xC2E8C9C1, 0x20A90E0C, 0x7E964CB7, 0xBA7F3BE1, 0xE440795A,
0x0601BE97, 0x583EFC2C, 0xA7E75468, 0xF9D816D3, 0x1B99D11E, 0x45A693A5,
0x1BED269F, 0x45D26424, 0xA793A3E9, 0xF9ACE152, 0x06754916, 0x584A0BAD,
0xBA0BCC60, 0xE4348EDB, 0x20DDF98D, 0x7EE2BB36, 0x9CA37CFB, 0xC29C3E40,
0x3D459604, 0x637AD4BF, 0x813B1372, 0xDF0451C9, 0x6D8C98BB, 0x33B3DA00,
0xD1F21DCD, 0x8FCD5F76, 0x7014F732, 0x2E2BB589, 0xCC6A7244, 0x925530FF,
0x56BC47A9, 0x08830512, 0xEAC2C2DF, 0xB4FD8064, 0x4B242820, 0x151B6A9B,
0xF75AAD56, 0xA965EFED, 0x576F99AD, 0x0950DB16, 0xEB111CDB, 0xB52E5E60,
0x4AF7F624, 0x14C8B49F, 0xF6897352, 0xA8B631E9, 0x6C5F46BF, 0x32600404,
0xD021C3C9, 0x8E1E8172, 0x71C72936, 0x2FF86B8D, 0xCDB9AC40, 0x9386EEFB,
0x210E2789, 0x7F316532, 0x9D70A2FF, 0xC34FE044, 0x3C964800, 0x62A90ABB,
0x80E8CD76, 0xDED78FCD, 0x1A3EF89B, 0x4401BA20, 0xA6407DED, 0xF87F3F56,
0x07A69712, 0x5999D5A9, 0xBBD81264, 0xE5E750DF, 0xBBACE5E5, 0xE593A75E,
0x07D26093, 0x59ED2228, 0xA6348A6C, 0xF80BC8D7, 0x1A4A0F1A, 0x44754DA1,
0x809C3AF7, 0xDEA3784C, 0x3CE2BF81, 0x62DDFD3A, 0x9D04557E, 0xC33B17C5,
0x217AD008, 0x7F4592B3, 0xCDCD5BC1, 0x93F2197A, 0x71B3DEB7, 0x2F8C9C0C,
0xD0553448, 0x8E6A76F3, 0x6C2BB13E, 0x3214F385, 0xF6FD84D3, 0xA8C2C668,
0x4A8301A5, 0x14BC431E, 0xEB65EB5A, 0xB55AA9E1, 0x571B6E2C, 0x09242C97,
0xEB8C0458, 0xB5B346E3, 0x57F2812E, 0x09CDC395, 0xF6146BD1, 0xA82B296A,
0x4A6AEEA7, 0x1455AC1C, 0xD0BCDB4A, 0x8E8399F1, 0x6CC25E3C, 0x32FD1C87,
0xCD24B4C3, 0x931BF678, 0x715A31B5, 0x2F65730E, 0x9DEDBA7C, 0xC3D2F8C7,
0x21933F0A, 0x7FAC7DB1, 0x8075D5F5, 0xDE4A974E, 0x3C0B5083, 0x62341238,
0xA6DD656E, 0xF8E227D5, 0x1AA3E018, 0x449CA2A3, 0xBB450AE7, 0xE57A485C,
0x073B8F91, 0x5904CD2A, 0x074F7810, 0x59703AAB, 0xBB31FD66, 0xE50EBFDD,
0x1AD71799, 0x44E85522, 0xA6A992EF, 0xF896D054, 0x3C7FA702, 0x6240E5B9,
0x80012274, 0xDE3E60CF, 0x21E7C88B, 0x7FD88A30, 0x9D994DFD, 0xC3A60F46,
0x712EC634, 0x2F11848F, 0xCD504342, 0x936F01F9, 0x6CB6A9BD, 0x3289EB06,
0xD0C82CCB, 0x8EF76E70, 0x4A1E1926, 0x14215B9D, 0xF6609C50, 0xA85FDEEB,
0x578676AF, 0x09B93414, 0xEBF8F3D9, 0xB5C7B162,

###############################################################################

TITLE
    t-class 32 mid0xC2DB2AA3

TYPE
    32

DATA
0x00000000, 0x4FC38FA0, 0x9F871F40, 0xD04490E0, 0x5A6B5BE5, 0x15A8D445,
0xC5EC44A5, 0x8A2FCB05, 0xB4D6B7CA, 0xFB15386A, 0x2B51A88A, 0x6492272A,
0xEEBDEC2F, 0xA17E638F, 0x713AF36F, 0x3EF97CCF, 0x0CC80AF1, 0x430B8551,
0x934F15B1, 0xDC8C9A11, 0x56A35114, 0x1960DEB4, 0xC9244E54, 0x86E7C1F4,
0xB81EBD3B, 0xF7DD329B, 0x2799A27B, 0x685A2DDB, 0xE275E6DE, 0xADB6697E,
0x7DF2F99E, 0x3231763E, 0x199015E2, 0x56539A42, 0x86170AA2, 0xC9D48502,
0x43FB4E07, 0x0C38C1A7, 0xDC7C5147, 0x93BFDEE7, 0xAD46A228, 0xE2852D88,
0x32C1BD68, 0x7D0232C8, 0xF72DF9CD, 0xB8EE766D, 0x68AAE68D, 0x2769692D,
0x15581F13, 0x5A9B90B3, 0x8ADF0053, 0xC51C8FF3, 0x4F3344F6, 0x00F0CB56,
0xD0B45BB6, 0x9F77D416, 0xA18EA8D9, 0xEE4D2779, 0x3E09B799, 0x71CA3839,
0xFBE5F33C, 0xB4267C9C, 0x6462EC7C, 0x2BA163DC, 0x33202BC4, 0x7CE3A464,
0xACA73484, 0xE364BB24, 0x694B7021, 0x2688FF81, 0xF6CC6F61, 0xB90FE0C1,
0x87F69C0E, 0xC83513AE, 0x1871834E, 0x57B20CEE, 0xDD9DC7EB, 0x925E484B,
0x421AD8AB, 0x0DD9570B, 0x3FE82135, 0x702BAE95, 0xA06F3E75, 0xEFACB1D5,
0x65837AD0, 0x2A40F570, 0xFA046590, 0xB5C7EA30, 0x8B3E96FF, 0xC4FD195F,
0x14B989BF, 0x5B7A061F, 0xD155CD1A, 0x9E9642BA, 0x4ED2D25A, 0x01115DFA,
0x2AB03E26, 0x6573B186, 0xB5372166, 0xFAF4AEC6, 0x70DB65C3, 0x3F18EA63,
0xEF5C7A83, 0xA09FF523, 0x9E6689EC, 0xD1A5064C, 0x01E196AC, 0x4E22190C,
0xC40DD209, 0x8BCE5DA9, 0x5B8ACD49, 0x144942E9, 0x267834D7, 0x69BBBB77,
0xB9FF2B97, 0xF63CA437, 0x7C136F32, 0x33D0E092, 0xE3947072, 0xAC57FFD2,
0x92AE831D, 0xDD6D0CBD, 0x0D299C5D, 0x42EA13FD, 0xC8C5D8F8, 0x87065758,
0x5742C7B8, 0x18814818, 0x66405788, 0x2983D828, 0xF9C748C8, 0xB604C768,
0x3C2B0C6D, 0x73E883CD, 0xA3AC132D, 0xEC6F9C8D, 0xD296E042, 0x9D556FE2,
0x4D11FF02, 0x02D270A2, 0x88FDBBA7, 0xC73E3407, 0x177AA4E7, 0x58B92B47,
0x6A885D79, 0x254BD2D9, 0xF50F4239, 0xBACCCD99, 0x30E3069C, 0x7F20893C,
0xAF6419DC, 0xE0A7967C, 0xDE5EEAB3, 0x919D6513, 0x41D9F5F3, 0x0E1A7A53,
0x8435B156, 0xCBF63EF6, 0x1BB2AE16, 0x547121B6, 0x7FD0426A, 0x3013CDCA,
0xE0575D2A, 0xAF94D28A, 0x25BB198F, 0x6A78962F, 0xBA3C06CF, 0xF5FF896F,
0xCB06F5A0, 0x84C57A00, 0x5481EAE0, 0x1B426540, 0x916DAE45, 0xDEAE21E5,
0x0EEAB105, 0x41293EA5, 0x7318489B, 0x3CDBC73B, 0xEC9F57DB, 0xA35CD87B,
0x2973137E, 0x66B09CDE, 0xB6F40C3E, 0xF937839E, 0xC7CEFF51, 0x880D70F1,
0x5849E011, 0x178A6FB1, 0x9DA5A4B4, 0xD2662B14, 0x0222BBF4, 0x4DE13454,
0x55607C4C, 0x1AA3F3EC, 0xCAE7630C, 0x8524ECAC, 0x0F0B27A9, 0x40C8A809,
0x908C38E9, 0xDF4FB749, 0xE1B6CB86, 0xAE754426, 0x7E31D4C6, 0x31F25B66,
0xBBDD9063, 0xF41E1FC3, 0x245A8F23, 0x6B990083, 0x59A876BD, 0x166BF91D,
0xC62F69FD, 0x89ECE65D, 0x03C32D58, 0x4C00A2F8, 0x9C443218, 0xD387BDB8,
0xED7EC177, 0xA2BD4ED7, 0x72F9DE37, 0x3D3A5197, 0xB7159A92, 0xF8D61532,
0x289285D2, 0x67510A72, 0x4CF069AE, 0x0333E60E, 0xD37776EE, 0x9CB4F94E,
0x169B324B, 0x5958BDEB, 0x891C2D0B, 0xC6DFA2AB, 0xF826DE64, 0xB7E551C4,
0x67A1C124, 0x28624E84, 0xA24D8581, 0xED8E0A21, 0x3DCA9AC1, 0x72091561,
0x4038635F, 0x0FFBECFF, 0xDFBF7C1F, 0x907CF3BF, 0x1A5338BA, 0x5590B71A,
0x85D427FA, 0xCA17A85A, 0xF4EED495, 0xBB2D5B35, 0x6B69CBD5, 0x24AA4475,
0xAE858F70, 0xE14600D0, 0x31029030, 0x7EC11F90, 0xCC80AF10, 0x834320B0,
0x5307B050, 0x1CC43FF0, 0x96EBF4F5, 0xD9287B55, 0x096CEBB5, 0x46AF6415,
0x785618DA, 0x3795977A, 0xE7D1079A, 0xA812883A, 0x223D433F, 0x6DFECC9F,
0xBDBA5C7F, 0xF279D3DF, 0xC048A5E1, 0x8F8B2A41, 0x5FCFBAA1, 0x100C3501,
0x9A23FE04, 0xD5E071A4, 0x05A4E144, 0x4A676EE4, 0x749E122B, 0x3B5D9D8B,
0xEB190D6B, 0xA4DA82CB, 0x2EF549CE, 0x6136C66E, 0xB172568E, 0xFEB1D92E,
0xD510BAF2, 0x9AD33552, 0x4A97A5B2, 0x05542A12, 0x8F7BE117, 0xC0B86EB7,
0x10FCFE57, 0x5F3F71F7, 0x61C60D38, 0x2E058298, 0xFE411278, 0xB1829DD8,
0x3BAD56DD, 0x746ED97D, 0xA42A499D, 0xEBE9C63D, 0xD9D8B003, 0x961B3FA3,
0x465FAF43, 0x099C20E3, 0x83B3EBE6, 0xCC706446, 0x1C34F4A6, 0x53F77B06,
0x6D0E07C9, 0x22CD8869, 0xF2891889, 0xBD4A9729, 0x37655C2C, 0x78A6D38C,
0xA8E2436C, 0xE721CCCC, 0xFFA084D4, 0xB0630B74, 0x60279B94, 0x2FE41434,
0xA5CBDF31, 0xEA085091, 0x3A4CC071, 0x758F4FD1, 0x4B76331E, 0x04B5BCBE,
0xD4F12C5E, 0x9B32A3FE, 0x111D68FB, 0x5EDEE75B, 0x8E9A77BB, 0xC159F81B,
0xF3688E25, 0xBCAB0185, 0x6CEF9165, 0x232C1EC5, 0xA903D5C0, 0xE6C05A60,
0x3684CA80, 0x79474520, 0x47BE39EF, 0x087DB64F, 0xD83926AF, 0x97FAA90F,
0x1DD5620A, 0x5216EDAA, 0x82527D4A, 0xCD91F2EA, 0xE6309136, 0xA9F31E96,
0x79B78E76, 0x367401D6, 0xBC5BCAD3, 0xF3984573, 0x23DCD593, 0x6C1F5A33,
0x52E626FC, 0x1D25A95C, 0xCD6139BC, 0x82A2B61C, 0x088D7D19, 0x474EF2B9,
0x970A6259, 0xD8C9EDF9, 0xEAF89BC7, 0xA53B1467, 0x757F8487, 0x3ABC0B27,
0xB093C022, 0xFF504F82, 0x2F14DF62, 0x60D750C2, 0x5E2E2C0D, 0x11EDA3AD,
0xC1A9334D, 0x8E6ABCED, 0x044577E8, 0x4B86F848, 0x9BC268A8, 0xD401E708,
0xAAC0F898, 0xE5037738, 0x3547E7D8, 0x7A846878, 0xF0ABA37D, 0xBF682CDD,
0x6F2CBC3D, 0x20EF339D, 0x1E164F52, 0x51D5C0F2, 0x81915012, 0xCE52DFB2,
0x447D14B7, 0x0BBE9B17, 0xDBFA0BF7, 0x94398457, 0xA608F269, 0xE9CB7DC9,
0x398FED29, 0x764C6289, 0xFC63A98C, 0xB3A0262C, 0x63E4B6CC, 0x2C27396C,
0x12DE45A3, 0x5D1DCA03, 0x8D595AE3, 0xC29AD543, 0x48B51E46, 0x077691E6,
0xD7320106, 0x98F18EA6, 0xB350ED7A, 0xFC9362DA, 0x2CD7F23A, 0x63147D9A,
0xE93BB69F, 0xA6F8393F, 0x76BCA9DF, 0x397F267F, 0x07865AB0, 0x4845D510,
0x980145F0, 0xD7C2CA50, 0x5DED0155, 0x122E8EF5, 0xC26A1E15, 0x8DA991B5,
0xBF98E78B, 0xF05B682B, 0x201FF8CB, 0x6FDC776B, 0xE5F3BC6E, 0xAA3033CE,
0x7A74A32E, 0x35B72C8E, 0x0B4E5041, 0x448DDFE1, 0x94C94F01, 0xDB0AC0A1,
0x51250BA4, 0x1EE68404, 0xCEA214E4, 0x81619B44, 0x99E0D35C, 0xD6235CFC,
0x0667CC1C, 0x49A443BC, 0xC38B88B9, 0x8C480719, 0x5C0C97F9, 0x13CF1859,
0x2D366496, 0x62F5EB36, 0xB2B17BD6, 0xFD72F476, 0x775D3F73, 0x389EB0D3,
0xE8DA2033, 0xA719AF93, 0x9528D9AD, 0xDAEB560D, 0x0AAFC6ED, 0x456C494D,
0xCF438248, 0x80800DE8, 0x50C49D08, 0x1F0712A8, 0x21FE6E67, 0x6E3DE1C7,
0xBE797127, 0xF1BAFE87, 0x7B953582, 0x3456BA22, 0xE4122AC2, 0xABD1A562,
0x8070C6BE, 0xCFB3491E, 0x1FF7D9FE, 0x5034565E, 0xDA1B9D5B, 0x95D812FB,
0x459C821B, 0x0A5F0DBB, 0x34A67174, 0x7B65FED4, 0xAB216E34, 0xE4E2E194,
0x6ECD2A91, 0x210EA531, 0xF14A35D1, 0xBE89BA71, 0x8CB8CC4F, 0xC37B43EF,
0x133FD30F, 0x5CFC5CAF, 0xD6D397AA, 0x9910180A, 0x495488EA, 0x0697074A,
0x386E7B85, 0x77ADF425, 0xA7E964C5, 0xE82AEB65, 0x62052060, 0x2DC6AFC0,
0xFD823F20, 0xB241B080, 0xFC643B45, 0xB3A7B4E5, 0x63E32405, 0x2C20ABA5,
0xA60F60A0, 0xE9CCEF00, 0x39887FE0, 0x764BF040, 0x48B28C8F, 0x0771032F,
0xD73593CF, 0x98F61C6F, 0x12D9D76A, 0x5D1A58CA, 0x8D5EC82A, 0xC29D478A,
0xF0AC31B4, 0xBF6FBE14, 0x6F2B2EF4, 0x20E8A154, 0xAAC76A51, 0xE504E5F1,
0x35407511, 0x7A83FAB1, 0x447A867E, 0x0BB909DE, 0xDBFD993E, 0x943E169E,
0x1E11DD9B, 0x51D2523B, 0x8196C2DB, 0xCE554D7B, 0xE5F42EA7, 0xAA37A107,
0x7A7331E7, 0x35B0BE47, 0xBF9F7542, 0xF05CFAE2, 0x20186A02, 0x6FDBE5A2,
0x5122996D, 0x1EE116CD, 0xCEA5862D, 0x8166098D, 0x0B49C288, 0x448A4D28,
0x94CEDDC8, 0xDB0D5268, 0xE93C2456, 0xA6FFABF6, 0x76BB3B16, 0x3978B4B6,
0xB3577FB3, 0xFC94F013, 0x2CD060F3, 0x6313EF53, 0x5DEA939C, 0x12291C3C,
0xC26D8CDC, 0x8DAE037C, 0x0781C879, 0x484247D9, 0x9806D739, 0xD7C55899,
0xCF441081, 0x80879F21, 0x50C30FC1, 0x1F008061, 0x952F4B64, 0xDAECC4C4,
0x0AA85424, 0x456BDB84, 0x7B92A74B, 0x345128EB, 0xE415B80B, 0xABD637AB,
0x21F9FCAE, 0x6E3A730E, 0xBE7EE3EE, 0xF1BD6C4E, 0xC38C1A70, 0x8C4F95D0,
0x5C0B0530, 0x13C88A90, 0x99E74195, 0xD624CE35, 0x06605ED5, 0x49A3D175,
0x775AADBA, 0x3899221A, 0xE8DDB2FA, 0xA71E3D5A, 0x2D31F65F, 0x62F279FF,
0xB2B6E91F, 0xFD7566BF, 0xD6D40563, 0x99178AC3, 0x49531A23, 0x06909583,
0x8CBF5E86, 0xC37CD126, 0x133841C6, 0x5CFBCE66, 0x6202B2A9, 0x2DC13D09,
0xFD85ADE9, 0xB2462249, 0x3869E94C, 0x77AA66EC, 0xA7EEF60C, 0xE82D79AC,
0xDA1C0F92, 0x95DF8032, 0x459B10D2, 0x0A589F72, 0x80775477, 0xCFB4DBD7,
0x1FF04B37, 0x5033C497, 0x6ECAB858, 0x210937F8, 0xF14DA718, 0xBE8E28B8,
0x34A1E3BD, 0x7B626C1D, 0xAB26FCFD, 0xE4E5735D, 0x9A246CCD, 0xD5E7E36D,
0x05A3738D, 0x4A60FC2D, 0xC04F3728, 0x8F8CB888, 0x5FC82868, 0x100BA7C8,
0x2EF2DB07, 0x613154A7, 0xB175C447, 0xFEB64BE7, 0x749980E2, 0x3B5A0F42,
0xEB1E9FA2, 0xA4DD1002, 0x96EC663C, 0xD92FE99C, 0x096B797C, 0x46A8F6DC,
0xCC873DD9, 0x8344B279, 0x53002299, 0x1CC3AD39, 0x223AD1F6, 0x6DF95E56,
0xBDBDCEB6, 0xF27E4116, 0x78518A13, 0x379205B3, 0xE7D69553, 0xA8151AF3,
0x83B4792F, 0xCC77F68F, 0x1C33666F, 0x53F0E9CF, 0xD9DF22CA, 0x961CAD6A,
0x46583D8A, 0x099BB22A, 0x3762CEE5, 0x78A14145, 0xA8E5D1A5, 0xE7265E05,
0x6D099500, 0x22CA1AA0, 0xF28E8A40, 0xBD4D05E0, 0x8F7C73DE, 0xC0BFFC7E,
0x10FB6C9E, 0x5F38E33E, 0xD517283B, 0x9AD4A79B, 0x4A90377B, 0x0553B8DB,
0x3BAAC414, 0x74694BB4, 0xA42DDB54, 0xEBEE54F4, 0x61C19FF1, 0x2E021051,
0xFE4680B1, 0xB1850F11, 0xA9044709, 0xE6C7C8A9, 0x36835849, 0x7940D7E9,
0xF36F1CEC, 0xBCAC934C, 0x6CE803AC, 0x232B8C0C, 0x1DD2F0C3, 0x52117F63,
0x8255EF83, 0xCD966023, 0x47B9AB26, 0x087A2486, 0xD83EB466, 0x97FD3BC6,
0xA5CC4DF8, 0xEA0FC258, 0x3A4B52B8, 0x7588DD18, 0xFFA7161D, 0xB06499BD,
0x6020095D, 0x2FE386FD, 0x111AFA32, 0x5ED97592, 0x8E9DE572, 0xC15E6AD2,
0x4B71A1D7, 0x04B22E77, 0xD4F6BE97, 0x9B353137, 0xB09452EB, 0xFF57DD4B,
0x2F134DAB, 0x60D0C20B, 0xEAFF090E, 0xA53C86AE, 0x7578164E, 0x3ABB99EE,
0x0442E521, 0x4B816A81, 0x9BC5FA61, 0xD40675C1, 0x5E29BEC4, 0x11EA3164,
0xC1AEA184, 0x8E6D2E24, 0xBC5C581A, 0xF39FD7BA, 0x23DB475A, 0x6C18C8FA,
0xE63703FF, 0xA9F48C5F, 0x79B01CBF, 0x3673931F, 0x088AEFD0, 0x47496070,
0x970DF090, 0xD8CE7F30, 0x52E1B435, 0x1D223B95, 0xCD66AB75, 0x82A524D5,
0x30E49455, 0x7F271BF5, 0xAF638B15, 0xE0A004B5, 0x6A8FCFB0, 0x254C4010,
0xF508D0F0, 0xBACB5F50, 0x8432239F, 0xCBF1AC3F, 0x1BB53CDF, 0x5476B37F,
0xDE59787A, 0x919AF7DA, 0x41DE673A, 0x0E1DE89A, 0x3C2C9EA4, 0x73EF1104,
0xA3AB81E4, 0xEC680E44, 0x6647C541, 0x29844AE1, 0xF9C0DA01, 0xB60355A1,
0x88FA296E, 0xC739A6CE, 0x177D362E, 0x58BEB98E, 0xD291728B, 0x9D52FD2B,
0x4D166DCB, 0x02D5E26B, 0x297481B7, 0x66B70E17, 0xB6F39EF7, 0xF9301157,
0x731FDA52, 0x3CDC55F2, 0xEC98C512, 0xA35B4AB2, 0x9DA2367D, 0xD261B9DD,
0x0225293D, 0x4DE6A69D, 0xC7C96D98, 0x880AE238, 0x584E72D8, 0x178DFD78,
0x25BC8B46, 0x6A7F04E6, 0xBA3B9406, 0xF5F81BA6, 0x7FD7D0A3, 0x30145F03,
0xE050CFE3, 0xAF934043, 0x916A3C8C, 0xDEA9B32C, 0x0EED23CC, 0x412EAC6C,
0xCB016769, 0x84C2E8C9, 0x54867829, 0x1B45F789, 0x03C4BF91, 0x4C073031,
0x9C43A0D1, 0xD3802F71, 0x59AFE474, 0x166C6BD4, 0xC628FB34, 0x89EB7494,
0xB712085B, 0xF8D187FB, 0x2895171B, 0x675698BB, 0xED7953BE, 0xA2BADC1E,
0x72FE4CFE, 0x3D3DC35E, 0x0F0CB560, 0x40CF3AC0, 0x908BAA20, 0xDF482580,
0x5567EE85, 0x1AA46125, 0xCAE0F1C5, 0x85237E65, 0xBBDA02AA, 0xF4198D0A,
0x245D1DEA, 0x6B9E924A, 0xE1B1594F, 0xAE72D6EF, 0x7E36460F, 0x31F5C9AF,
0x1A54AA73, 0x559725D3, 0x85D3B533, 0xCA103A93, 0x403FF196, 0x0FFC7E36,
0xDFB8EED6, 0x907B6176, 0xAE821DB9, 0xE1419219, 0x310502F9, 0x7EC68D59,
0xF4E9465C, 0xBB2AC9FC, 0x6B6E591C, 0x24ADD6BC, 0x169CA082, 0x595F2F22,
0x891BBFC2, 0xC6D83062, 0x4CF7FB67, 0x033474C7, 0xD370E427, 0x9CB36B87,
0xA24A1748, 0xED8998E8, 0x3DCD0808, 0x720E87A8, 0xF8214CAD, 0xB7E2C30D,
0x67A653ED, 0x2865DC4D, 0x56A4C3DD, 0x19674C7D, 0xC923DC9D, 0x86E0533D,
0x0CCF9838, 0x430C1798, 0x93488778, 0xDC8B08D8, 0xE2727417, 0xADB1FBB7,
0x7DF56B57, 0x3236E4F7, 0xB8192FF2, 0xF7DAA052, 0x279E30B2, 0x685DBF12,
0x5A6CC92C, 0x15AF468C, 0xC5EBD66C, 0x8A2859CC, 0x000792C9, 0x4FC41D69,
0x9F808D89, 0xD0430229, 0xEEBA7EE6, 0xA179F146, 0x713D61A6, 0x3EFEEE06,
0xB4D12503, 0xFB12AAA3, 0x2B563A43, 0x6495B5E3, 0x4F34D63F, 0x00F7599F,
0xD0B3C97F, 0x9F7046DF, 0x155F8DDA, 0x5A9C027A, 0x8AD8929A, 0xC51B1D3A,
0xFBE261F5, 0xB421EE55, 0x64657EB5, 0x2BA6F115, 0xA1893A10, 0xEE4AB5B0,
0x3E0E2550, 0x71CDAAF0, 0x43FCDCCE, 0x0C3F536E, 0xDC7BC38E, 0x93B84C2E,
0x1997872B, 0x5654088B, 0x8610986B, 0xC9D317CB, 0xF72A6B04, 0xB8E9E4A4,
0x68AD7444, 0x276EFBE4, 0xAD4130E1, 0xE282BF41, 0x32C62FA1, 0x7D05A001,
0x6584E819, 0x2A4767B9, 0xFA03F759, 0xB5C078F9, 0x3FEFB3FC, 0x702C3C5C,
0xA068ACBC, 0xEFAB231C, 0xD1525FD3, 0x9E91D073, 0x4ED54093, 0x0116CF33,
0x8B390436, 0xC4FA8B96, 0x14BE1B76, 0x5B7D94D6, 0x694CE2E8, 0x268F6D48,
0xF6CBFDA8, 0xB9087208, 0x3327B90D, 0x7CE436AD, 0xACA0A64D, 0xE36329ED,
0xDD9A5522, 0x9259DA82, 0x421D4A62, 0x0DDEC5C2, 0x87F10EC7, 0xC8328167,
0x18761187, 0x57B59E27, 0x7C14FDFB, 0x33D7725B, 0xE393E2BB, 0xAC506D1B,
0x267FA61E, 0x69BC29BE, 0xB9F8B95E, 0xF63B36FE, 0xC8C24A31, 0x8701C591,
0x57455571, 0x1886DAD1, 0x92A911D4, 0xDD6A9E74, 0x0D2E0E94, 0x42ED8134,
0x70DCF70A, 0x3F1F78AA, 0xEF5BE84A, 0xA09867EA, 0x2AB7ACEF, 0x6574234F,
0xB530B3AF, 0xFAF33C0F, 0xC40A40C0, 0x8BC9CF60, 0x5B8D5F80, 0x144ED020,
0x9E611B25, 0xD1A29485, 0x01E60465, 0x4E258BC5, 0x9DAD13EF, 0xD26E9C4F,
0x022A0CAF, 0x4DE9830F, 0xC7C6480A, 0x8805C7AA, 0x5841574A, 0x1782D8EA,
0x297BA425, 0x66B82B85, 0xB6FCBB65, 0xF93F34C5, 0x7310FFC0, 0x3CD37060,
0xEC97E080, 0xA3546F20, 0x9165191E, 0xDEA696BE, 0x0EE2065E, 0x412189FE,
0xCB0E42FB, 0x84CDCD5B, 0x54895DBB, 0x1B4AD21B, 0x25B3AED4, 0x6A702174,
0xBA34B194, 0xF5F73E34, 0x7FD8F531, 0x301B7A91, 0xE05FEA71, 0xAF9C65D1,
0x843D060D, 0xCBFE89AD, 0x1BBA194D, 0x547996ED, 0xDE565DE8, 0x9195D248,
0x41D142A8, 0x0E12CD08, 0x30EBB1C7, 0x7F283E67, 0xAF6CAE87, 0xE0AF2127,
0x6A80EA22, 0x25436582, 0xF507F562, 0xBAC47AC2, 0x88F50CFC, 0xC736835C,
0x177213BC, 0x58B19C1C, 0xD29E5719, 0x9D5DD8B9, 0x4D194859, 0x02DAC7F9,
0x3C23BB36, 0x73E03496, 0xA3A4A476, 0xEC672BD6, 0x6648E0D3, 0x298B6F73,
0xF9CFFF93, 0xB60C7033, 0xAE8D382B, 0xE14EB78B, 0x310A276B, 0x7EC9A8CB,
0xF4E663CE, 0xBB25EC6E, 0x6B617C8E, 0x24A2F32E, 0x1A5B8FE1, 0x55980041,
0x85DC90A1, 0xCA1F1F01, 0x4030D404, 0x0FF35BA4, 0xDFB7CB44, 0x907444E4,
0xA24532DA, 0xED86BD7A, 0x3DC22D9A, 0x7201A23A, 0xF82E693F, 0xB7EDE69F,
0x67A9767F, 0x286AF9DF, 0x16938510, 0x59500AB0, 0x89149A50, 0xC6D715F0,
0x4CF8DEF5, 0x033B5155, 0xD37FC1B5, 0x9CBC4E15, 0xB71D2DC9, 0xF8DEA269,
0x289A3289, 0x6759BD29, 0xED76762C, 0xA2B5F98C, 0x72F1696C, 0x3D32E6CC,
0x03CB9A03, 0x4C0815A3, 0x9C4C8543, 0xD38F0AE3, 0x59A0C1E6, 0x16634E46,
0xC627DEA6, 0x89E45106, 0xBBD52738, 0xF416A898, 0x24523878, 0x6B91B7D8,
0xE1BE7CDD, 0xAE7DF37D, 0x7E39639D, 0x31FAEC3D, 0x0F0390F2, 0x40C01F52,
0x90848FB2, 0xDF470012, 0x5568CB17, 0x1AAB44B7, 0xCAEFD457, 0x852C5BF7,
0xFBED4467, 0xB42ECBC7, 0x646A5B27, 0x2BA9D487, 0xA1861F82, 0xEE459022,
0x3E0100C2, 0x71C28F62, 0x4F3BF3AD, 0x00F87C0D, 0xD0BCECED, 0x9F7F634D,
0x1550A848, 0x5A9327E8, 0x8AD7B708, 0xC51438A8, 0xF7254E96, 0xB8E6C136,
0x68A251D6, 0x2761DE76, 0xAD4E1573, 0xE28D9AD3, 0x32C90A33, 0x7D0A8593,
0x43F3F95C, 0x0C3076FC, 0xDC74E61C, 0x93B769BC, 0x1998A2B9, 0x565B2D19,
0x861FBDF9, 0xC9DC3259, 0xE27D5185, 0xADBEDE25, 0x7DFA4EC5, 0x3239C165,
0xB8160A60, 0xF7D585C0, 0x27911520, 0x68529A80, 0x56ABE64F, 0x196869EF,
0xC92CF90F, 0x86EF76AF, 0x0CC0BDAA, 0x4303320A, 0x9347A2EA, 0xDC842D4A,
0xEEB55B74, 0xA176D4D4, 0x71324434, 0x3EF1CB94, 0xB4DE0091, 0xFB1D8F31,
0x2B591FD1, 0x649A9071, 0x5A63ECBE, 0x15A0631E, 0xC5E4F3FE, 0x8A277C5E,
0x0008B75B, 0x4FCB38FB, 0x9F8FA81B, 0xD04C27BB, 0xC8CD6FA3, 0x870EE003,
0x574A70E3, 0x1889FF43, 0x92A63446, 0xDD65BBE6, 0x0D212B06, 0x42E2A4A6,
0x7C1BD869, 0x33D857C9, 0xE39CC729, 0xAC5F4889, 0x2670838C, 0x69B30C2C,
0xB9F79CCC, 0xF634136C, 0xC4056552, 0x8BC6EAF2, 0x5B827A12, 0x1441F5B2,
0x9E6E3EB7, 0xD1ADB117, 0x01E921F7, 0x4E2AAE57, 0x70D3D298, 0x3F105D38,
0xEF54CDD8, 0xA0974278, 0x2AB8897D, 0x657B06DD, 0xB53F963D, 0xFAFC199D,
0xD15D7A41, 0x9E9EF5E1, 0x4EDA6501, 0x0119EAA1, 0x8B3621A4, 0xC4F5AE04,
0x14B13EE4, 0x5B72B144, 0x658BCD8B, 0x2A48422B, 0xFA0CD2CB, 0xB5CF5D6B,
0x3FE0966E, 0x702319CE, 0xA067892E, 0xEFA4068E, 0xDD9570B0, 0x9256FF10,
0x42126FF0, 0x0DD1E050, 0x87FE2B55, 0xC83DA4F5, 0x18793415, 0x57BABBB5,
0x6943C77A, 0x268048DA, 0xF6C4D83A, 0xB907579A, 0x33289C9F, 0x7CEB133F,
0xACAF83DF, 0xE36C0C7F, 0x512DBCFF, 0x1EEE335F, 0xCEAAA3BF, 0x81692C1F,
0x0B46E71A, 0x448568BA, 0x94C1F85A, 0xDB0277FA, 0xE5FB0B35, 0xAA388495,
0x7A7C1475, 0x35BF9BD5, 0xBF9050D0, 0xF053DF70, 0x20174F90, 0x6FD4C030,
0x5DE5B60E, 0x122639AE, 0xC262A94E, 0x8DA126EE, 0x078EEDEB, 0x484D624B,
0x9809F2AB, 0xD7CA7D0B, 0xE93301C4, 0xA6F08E64, 0x76B41E84, 0x39779124,
0xB3585A21, 0xFC9BD581, 0x2CDF4561, 0x631CCAC1, 0x48BDA91D, 0x077E26BD,
0xD73AB65D, 0x98F939FD, 0x12D6F2F8, 0x5D157D58, 0x8D51EDB8, 0xC2926218,
0xFC6B1ED7, 0xB3A89177, 0x63EC0197, 0x2C2F8E37, 0xA6004532, 0xE9C3CA92,
0x39875A72, 0x7644D5D2, 0x4475A3EC, 0x0BB62C4C, 0xDBF2BCAC, 0x9431330C,
0x1E1EF809, 0x51DD77A9, 0x8199E749, 0xCE5A68E9, 0xF0A31426, 0xBF609B86,
0x6F240B66, 0x20E784C6, 0xAAC84FC3, 0xE50BC063, 0x354F5083, 0x7A8CDF23,
0x620D973B, 0x2DCE189B, 0xFD8A887B, 0xB24907DB, 0x3866CCDE, 0x77A5437E,
0xA7E1D39E, 0xE8225C3E, 0xD6DB20F1, 0x9918AF51, 0x495C3FB1, 0x069FB011,
0x8CB07B14, 0xC373F4B4, 0x13376454, 0x5CF4EBF4, 0x6EC59DCA, 0x2106126A,
0xF142828A, 0xBE810D2A, 0x34AEC62F, 0x7B6D498F, 0xAB29D96F, 0xE4EA56CF,
0xDA132A00, 0x95D0A5A0, 0x45943540, 0x0A57BAE0, 0x807871E5, 0xCFBBFE45,
0x1FFF6EA5, 0x503CE105, 0x7B9D82D9, 0x345E0D79, 0xE41A9D99, 0xABD91239,
0x21F6D93C, 0x6E35569C, 0xBE71C67C, 0xF1B249DC, 0xCF4B3513, 0x8088BAB3,
0x50CC2A53, 0x1F0FA5F3, 0x95206EF6, 0xDAE3E156, 0x0AA771B6, 0x4564FE16,
0x77558828, 0x38960788, 0xE8D29768, 0xA71118C8, 0x2D3ED3CD, 0x62FD5C6D,
0xB2B9CC8D, 0xFD7A432D, 0xC3833FE2, 0x8C40B042, 0x5C0420A2, 0x13C7AF02,
0x99E86407, 0xD62BEBA7, 0x066F7B47, 0x49ACF4E7, 0x376DEB77, 0x78AE64D7,
0xA8EAF437, 0xE7297B97, 0x6D06B092, 0x22C53F32, 0xF281AFD2, 0xBD422072,
0x83BB5CBD, 0xCC78D31D, 0x1C3C43FD, 0x53FFCC5D, 0xD9D00758, 0x961388F8,
0x46571818, 0x099497B8, 0x3BA5E186, 0x74666E26, 0xA422FEC6, 0xEBE17166,
0x61CEBA63, 0x2E0D35C3, 0xFE49A523, 0xB18A2A83, 0x8F73564C, 0xC0B0D9EC,
0x10F4490C, 0x5F37C6AC, 0xD5180DA9, 0x9ADB8209, 0x4A9F12E9, 0x055C9D49,
0x2EFDFE95, 0x613E7135, 0xB17AE1D5, 0xFEB96E75, 0x7496A570, 0x3B552AD0,
0xEB11BA30, 0xA4D23590, 0x9A2B495F, 0xD5E8C6FF, 0x05AC561F, 0x4A6FD9BF,
0xC04012BA, 0x8F839D1A, 0x5FC70DFA, 0x1004825A, 0x2235F464, 0x6DF67BC4,
0xBDB2EB24, 0xF2716484, 0x785EAF81, 0x379D2021, 0xE7D9B0C1, 0xA81A3F61,
0x96E343AE, 0xD920CC0E, 0x09645CEE, 0x46A7D34E, 0xCC88184B, 0x834B97EB,
0x530F070B, 0x1CCC88AB, 0x044DC0B3, 0x4B8E4F13, 0x9BCADFF3, 0xD4095053,
0x5E269B56, 0x11E514F6, 0xC1A18416, 0x8E620BB6, 0xB09B7779, 0xFF58F8D9,
0x2F1C6839, 0x60DFE799, 0xEAF02C9C, 0xA533A33C, 0x757733DC, 0x3AB4BC7C,
0x0885CA42, 0x474645E2, 0x9702D502, 0xD8C15AA2, 0x52EE91A7, 0x1D2D1E07,
0xCD698EE7, 0x82AA0147, 0xBC537D88, 0xF390F228, 0x23D462C8, 0x6C17ED68,
0xE638266D, 0xA9FBA9CD, 0x79BF392D, 0x367CB68D, 0x1DDDD551, 0x521E5AF1,
0x825ACA11, 0xCD9945B1, 0x47B68EB4, 0x08750114, 0xD83191F4, 0x97F21E54,
0xA90B629B, 0xE6C8ED3B, 0x368C7DDB, 0x794FF27B, 0xF360397E, 0xBCA3B6DE,
0x6CE7263E, 0x2324A99E, 0x1115DFA0, 0x5ED65000, 0x8E92C0E0, 0xC1514F40,
0x4B7E8445, 0x04BD0BE5, 0xD4F99B05, 0x9B3A14A5, 0xA5C3686A, 0xEA00E7CA,
0x3A44772A, 0x7587F88A, 0xFFA8338F, 0xB06BBC2F, 0x602F2CCF, 0x2FECA36F,
0x61C928AA, 0x2E0AA70A, 0xFE4E37EA, 0xB18DB84A, 0x3BA2734F, 0x7461FCEF,
0xA4256C0F, 0xEBE6E3AF, 0xD51F9F60, 0x9ADC10C0, 0x4A988020, 0x055B0F80,
0x8F74C485, 0xC0B74B25, 0x10F3DBC5, 0x5F305465, 0x6D01225B, 0x22C2ADFB,
0xF2863D1B, 0xBD45B2BB, 0x376A79BE, 0x78A9F61E, 0xA8ED66FE, 0xE72EE95E,
0xD9D79591, 0x96141A31, 0x46508AD1, 0x09930571, 0x83BCCE74, 0xCC7F41D4,
0x1C3BD134, 0x53F85E94, 0x78593D48, 0x379AB2E8, 0xE7DE2208, 0xA81DADA8,
0x223266AD, 0x6DF1E90D, 0xBDB579ED, 0xF276F64D, 0xCC8F8A82, 0x834C0522,
0x530895C2, 0x1CCB1A62, 0x96E4D167, 0xD9275EC7, 0x0963CE27, 0x46A04187,
0x749137B9, 0x3B52B819, 0xEB1628F9, 0xA4D5A759, 0x2EFA6C5C, 0x6139E3FC,
0xB17D731C, 0xFEBEFCBC, 0xC0478073, 0x8F840FD3, 0x5FC09F33, 0x10031093,
0x9A2CDB96, 0xD5EF5436, 0x05ABC4D6, 0x4A684B76, 0x52E9036E, 0x1D2A8CCE,
0xCD6E1C2E, 0x82AD938E, 0x0882588B, 0x4741D72B, 0x970547CB, 0xD8C6C86B,
0xE63FB4A4, 0xA9FC3B04, 0x79B8ABE4, 0x367B2444, 0xBC54EF41, 0xF39760E1,
0x23D3F001, 0x6C107FA1, 0x5E21099F, 0x11E2863F, 0xC1A616DF, 0x8E65997F,
0x044A527A, 0x4B89DDDA, 0x9BCD4D3A, 0xD40EC29A, 0xEAF7BE55, 0xA53431F5,
0x7570A115, 0x3AB32EB5, 0xB09CE5B0, 0xFF5F6A10, 0x2F1BFAF0, 0x60D87550,
0x4B79168C, 0x04BA992C, 0xD4FE09CC, 0x9B3D866C, 0x11124D69, 0x5ED1C2C9,
0x8E955229, 0xC156DD89, 0xFFAFA146, 0xB06C2EE6, 0x6028BE06, 0x2FEB31A6,
0xA5C4FAA3, 0xEA077503, 0x3A43E5E3, 0x75806A43, 0x47B11C7D, 0x087293DD,
0xD836033D, 0x97F58C9D, 0x1DDA4798, 0x5219C838, 0x825D58D8, 0xCD9ED778,
0xF367ABB7, 0xBCA42417, 0x6CE0B4F7, 0x23233B57, 0xA90CF052, 0xE6CF7FF2,
0x368BEF12, 0x794860B2, 0x07897F22, 0x484AF082, 0x980E6062, 0xD7CDEFC2,
0x5DE224C7, 0x1221AB67, 0xC2653B87, 0x8DA6B427, 0xB35FC8E8, 0xFC9C4748,
0x2CD8D7A8, 0x631B5808, 0xE934930D, 0xA6F71CAD, 0x76B38C4D, 0x397003ED,
0x0B4175D3, 0x4482FA73, 0x94C66A93, 0xDB05E533, 0x512A2E36, 0x1EE9A196,
0xCEAD3176, 0x816EBED6, 0xBF97C219, 0xF0544DB9, 0x2010DD59, 0x6FD352F9,
0xE5FC99FC, 0xAA3F165C, 0x7A7B86BC, 0x35B8091C, 0x1E196AC0, 0x51DAE560,
0x819E7580, 0xCE5DFA20, 0x44723125, 0x0BB1BE85, 0xDBF52E65, 0x9436A1C5,
0xAACFDD0A, 0xE50C52AA, 0x3548C24A, 0x7A8B4DEA, 0xF0A486EF, 0xBF67094F,
0x6F2399AF, 0x20E0160F, 0x12D16031, 0x5D12EF91, 0x8D567F71, 0xC295F0D1,
0x48BA3BD4, 0x0779B474, 0xD73D2494, 0x98FEAB34, 0xA607D7FB, 0xE9C4585B,
0x3980C8BB, 0x7643471B, 0xFC6C8C1E, 0xB3AF03BE, 0x63EB935E, 0x2C281CFE,
0x34A954E6, 0x7B6ADB46, 0xAB2E4BA6, 0xE4EDC406, 0x6EC20F03, 0x210180A3,
0xF1451043, 0xBE869FE3, 0x807FE32C, 0xCFBC6C8C, 0x1FF8FC6C, 0x503B73CC,
0xDA14B8C9, 0x95D73769, 0x4593A789, 0x0A502829, 0x38615E17, 0x77A2D1B7,
0xA7E64157, 0xE825CEF7, 0x620A05F2, 0x2DC98A52, 0xFD8D1AB2, 0xB24E9512,
0x8CB7E9DD, 0xC374667D, 0x1330F69D, 0x5CF3793D, 0xD6DCB238, 0x991F3D98,
0x495BAD78, 0x069822D8, 0x2D394104, 0x62FACEA4, 0xB2BE5E44, 0xFD7DD1E4,
0x77521AE1, 0x38919541, 0xE8D505A1, 0xA7168A01, 0x99EFF6CE, 0xD62C796E,
0x0668E98E, 0x49AB662E, 0xC384AD2B, 0x8C47228B, 0x5C03B26B, 0x13C03DCB,
0x21F14BF5, 0x6E32C455, 0xBE7654B5, 0xF1B5DB15, 0x7B9A1010, 0x34599FB0,
0xE41D0F50, 0xABDE80F0, 0x9527FC3F, 0xDAE4739F, 0x0AA0E37F, 0x45636CDF,
0xCF4CA7DA, 0x808F287A, 0x50CBB89A, 0x1F08373A, 0xAD4987BA, 0xE28A081A,
0x32CE98FA, 0x7D0D175A, 0xF722DC5F, 0xB8E153FF, 0x68A5C31F, 0x27664CBF,
0x199F3070, 0x565CBFD0, 0x86182F30, 0xC9DBA090, 0x43F46B95, 0x0C37E435,
0xDC7374D5, 0x93B0FB75, 0xA1818D4B, 0xEE4202EB, 0x3E06920B, 0x71C51DAB,
0xFBEAD6AE, 0xB429590E, 0x646DC9EE, 0x2BAE464E, 0x15573A81, 0x5A94B521,
0x8AD025C1, 0xC513AA61, 0x4F3C6164, 0x00FFEEC4, 0xD0BB7E24, 0x9F78F184,
0xB4D99258, 0xFB1A1DF8, 0x2B5E8D18, 0x649D02B8, 0xEEB2C9BD, 0xA171461D,
0x7135D6FD, 0x3EF6595D, 0x000F2592, 0x4FCCAA32, 0x9F883AD2, 0xD04BB572,
0x5A647E77, 0x15A7F1D7, 0xC5E36137, 0x8A20EE97, 0xB81198A9, 0xF7D21709,
0x279687E9, 0x68550849, 0xE27AC34C, 0xADB94CEC, 0x7DFDDC0C, 0x323E53AC,
0x0CC72F63, 0x4304A0C3, 0x93403023, 0xDC83BF83, 0x56AC7486, 0x196FFB26,
0xC92B6BC6, 0x86E8E466, 0x9E69AC7E, 0xD1AA23DE, 0x01EEB33E, 0x4E2D3C9E,
0xC402F79B, 0x8BC1783B, 0x5B85E8DB, 0x1446677B, 0x2ABF1BB4, 0x657C9414,
0xB53804F4, 0xFAFB8B54, 0x70D44051, 0x3F17CFF1, 0xEF535F11, 0xA090D0B1,
0x92A1A68F, 0xDD62292F, 0x0D26B9CF, 0x42E5366F, 0xC8CAFD6A, 0x870972CA,
0x574DE22A, 0x188E6D8A, 0x26771145, 0x69B49EE5, 0xB9F00E05, 0xF63381A5,
0x7C1C4AA0, 0x33DFC500, 0xE39B55E0, 0xAC58DA40, 0x87F9B99C, 0xC83A363C,
0x187EA6DC, 0x57BD297C, 0xDD92E279, 0x92516DD9, 0x4215FD39, 0x0DD67299,
0x332F0E56, 0x7CEC81F6, 0xACA81116, 0xE36B9EB6, 0x694455B3, 0x2687DA13,
0xF6C34AF3, 0xB900C553, 0x8B31B36D, 0xC4F23CCD, 0x14B6AC2D, 0x5B75238D,
0xD15AE888, 0x9E996728, 0x4EDDF7C8, 0x011E7868, 0x3FE704A7, 0x70248B07,
0xA0601BE7, 0xEFA39447, 0x658C5F42, 0x2A4FD0E2, 0xFA0B4002, 0xB5C8CFA2,
0xCB09D032, 0x84CA5F92, 0x548ECF72, 0x1B4D40D2, 0x91628BD7, 0xDEA10477,
0x0EE59497, 0x41261B37, 0x7FDF67F8, 0x301CE858, 0xE05878B8, 0xAF9BF718,
0x25B43C1D, 0x6A77B3BD, 0xBA33235D, 0xF5F0ACFD, 0xC7C1DAC3, 0x88025563,
0x5846C583, 0x17854A23, 0x9DAA8126, 0xD2690E86, 0x022D9E66, 0x4DEE11C6,
0x73176D09, 0x3CD4E2A9, 0xEC907249, 0xA353FDE9, 0x297C36EC, 0x66BFB94C,
0xB6FB29AC, 0xF938A60C, 0xD299C5D0, 0x9D5A4A70, 0x4D1EDA90, 0x02DD5530,
0x88F29E35, 0xC7311195, 0x17758175, 0x58B60ED5, 0x664F721A, 0x298CFDBA,
0xF9C86D5A, 0xB60BE2FA, 0x3C2429FF, 0x73E7A65F, 0xA3A336BF, 0xEC60B91F,
0xDE51CF21, 0x91924081, 0x41D6D061, 0x0E155FC1, 0x843A94C4, 0xCBF91B64,
0x1BBD8B84, 0x547E0424, 0x6A8778EB, 0x2544F74B, 0xF50067AB, 0xBAC3E80B,
0x30EC230E, 0x7F2FACAE, 0xAF6B3C4E, 0xE0A8B3EE, 0xF829FBF6, 0xB7EA7456,
0x67AEE4B6, 0x286D6B16, 0xA242A013, 0xED812FB3, 0x3DC5BF53, 0x720630F3,
0x4CFF4C3C, 0x033CC39C, 0xD378537C, 0x9CBBDCDC, 0x169417D9, 0x59579879,
0x89130899, 0xC6D08739, 0xF4E1F107, 0xBB227EA7, 0x6B66EE47, 0x24A561E7,
0xAE8AAAE2, 0xE1492542, 0x310DB5A2, 0x7ECE3A02, 0x403746CD, 0x0FF4C96D,
0xDFB0598D, 0x9073D62D, 0x1A5C1D28, 0x559F9288, 0x85DB0268, 0xCA188DC8,
0xE1B9EE14, 0xAE7A61B4, 0x7E3EF154, 0x31FD7EF4, 0xBBD2B5F1, 0xF4113A51,
0x2455AAB1, 0x6B962511, 0x556F59DE, 0x1AACD67E, 0xCAE8469E, 0x852BC93E,
0x0F04023B, 0x40C78D9B, 0x90831D7B, 0xDF4092DB, 0xED71E4E5, 0xA2B26B45,
0x72F6FBA5, 0x3D357405, 0xB71ABF00, 0xF8D930A0, 0x289DA040, 0x675E2FE0,
0x59A7532F, 0x1664DC8F, 0xC6204C6F, 0x89E3C3CF, 0x03CC08CA, 0x4C0F876A,
0x9C4B178A, 0xD388982A,

###############################################################################

TITLE
    t-class 32 lo0xC2DB2AA3

TYPE
    32

DATA
0x00000000, 0xC2DB2AA3, 0xE0D33023, 0x22081A80, 0xA4C30523, 0x66182F80,
0x44103500, 0x86CB1FA3, 0x2CE36F23, 0xEE384580, 0xCC305F00, 0x0EEB75A3,
0x88206A00, 0x4AFB40A3, 0x68F35A23, 0xAA287080, 0x59C6DE46, 0x9B1DF4E5,
0xB915EE65, 0x7BCEC4C6, 0xFD05DB65, 0x3FDEF1C6, 0x1DD6EB46, 0xDF0DC1E5,
0x7525B165, 0xB7FE9BC6, 0x95F68146, 0x572DABE5, 0xD1E6B446, 0x133D9EE5,
0x31358465, 0xF3EEAEC6, 0xB38DBC8C, 0x7156962F, 0x535E8CAF, 0x9185A60C,
0x174EB9AF, 0xD595930C, 0xF79D898C, 0x3546A32F, 0x9F6ED3AF, 0x5DB5F90C,
0x7FBDE38C, 0xBD66C92F, 0x3BADD68C, 0xF976FC2F, 0xDB7EE6AF, 0x19A5CC0C,
0xEA4B62CA, 0x28904869, 0x0A9852E9, 0xC843784A, 0x4E8867E9, 0x8C534D4A,
0xAE5B57CA, 0x6C807D69, 0xC6A80DE9, 0x0473274A, 0x267B3DCA, 0xE4A01769,
0x626B08CA, 0xA0B02269, 0x82B838E9, 0x4063124A, 0x027E1C7D, 0xC0A536DE,
0xE2AD2C5E, 0x207606FD, 0xA6BD195E, 0x646633FD, 0x466E297D, 0x84B503DE,
0x2E9D735E, 0xEC4659FD, 0xCE4E437D, 0x0C9569DE, 0x8A5E767D, 0x48855CDE,
0x6A8D465E, 0xA8566CFD, 0x5BB8C23B, 0x9963E898, 0xBB6BF218, 0x79B0D8BB,
0xFF7BC718, 0x3DA0EDBB, 0x1FA8F73B, 0xDD73DD98, 0x775BAD18, 0xB58087BB,
0x97889D3B, 0x5553B798, 0xD398A83B, 0x11438298, 0x334B9818, 0xF190B2BB,
0xB1F3A0F1, 0x73288A52, 0x512090D2, 0x93FBBA71, 0x1530A5D2, 0xD7EB8F71,
0xF5E395F1, 0x3738BF52, 0x9D10CFD2, 0x5FCBE571, 0x7DC3FFF1, 0xBF18D552,
0x39D3CAF1, 0xFB08E052, 0xD900FAD2, 0x1BDBD071, 0xE8357EB7, 0x2AEE5414,
0x08E64E94, 0xCA3D6437, 0x4CF67B94, 0x8E2D5137, 0xAC254BB7, 0x6EFE6114,
0xC4D61194, 0x060D3B37, 0x240521B7, 0xE6DE0B14, 0x601514B7, 0xA2CE3E14,
0x80C62494, 0x421D0E37, 0x04FC38FA, 0xC6271259, 0xE42F08D9, 0x26F4227A,
0xA03F3DD9, 0x62E4177A, 0x40EC0DFA, 0x82372759, 0x281F57D9, 0xEAC47D7A,
0xC8CC67FA, 0x0A174D59, 0x8CDC52FA, 0x4E077859, 0x6C0F62D9, 0xAED4487A,
0x5D3AE6BC, 0x9FE1CC1F, 0xBDE9D69F, 0x7F32FC3C, 0xF9F9E39F, 0x3B22C93C,
0x192AD3BC, 0xDBF1F91F, 0x71D9899F, 0xB302A33C, 0x910AB9BC, 0x53D1931F,
0xD51A8CBC, 0x17C1A61F, 0x35C9BC9F, 0xF712963C, 0xB7718476, 0x75AAAED5,
0x57A2B455, 0x95799EF6, 0x13B28155, 0xD169ABF6, 0xF361B176, 0x31BA9BD5,
0x9B92EB55, 0x5949C1F6, 0x7B41DB76, 0xB99AF1D5, 0x3F51EE76, 0xFD8AC4D5,
0xDF82DE55, 0x1D59F4F6, 0xEEB75A30, 0x2C6C7093, 0x0E646A13, 0xCCBF40B0,
0x4A745F13, 0x88AF75B0, 0xAAA76F30, 0x687C4593, 0xC2543513, 0x008F1FB0,
0x22870530, 0xE05C2F93, 0x66973030, 0xA44C1A93, 0x86440013, 0x449F2AB0,
0x06822487, 0xC4590E24, 0xE65114A4, 0x248A3E07, 0xA24121A4, 0x609A0B07,
0x42921187, 0x80493B24, 0x2A614BA4, 0xE8BA6107, 0xCAB27B87, 0x08695124,
0x8EA24E87, 0x4C796424, 0x6E717EA4, 0xACAA5407, 0x5F44FAC1, 0x9D9FD062,
0xBF97CAE2, 0x7D4CE041, 0xFB87FFE2, 0x395CD541, 0x1B54CFC1, 0xD98FE562,
0x73A795E2, 0xB17CBF41, 0x9374A5C1, 0x51AF8F62, 0xD76490C1, 0x15BFBA62,
0x37B7A0E2, 0xF56C8A41, 0xB50F980B, 0x77D4B2A8, 0x55DCA828, 0x9707828B,
0x11CC9D28, 0xD317B78B, 0xF11FAD0B, 0x33C487A8, 0x99ECF728, 0x5B37DD8B,
0x793FC70B, 0xBBE4EDA8, 0x3D2FF20B, 0xFFF4D8A8, 0xDDFCC228, 0x1F27E88B,
0xECC9464D, 0x2E126CEE, 0x0C1A766E, 0xCEC15CCD, 0x480A436E, 0x8AD169CD,
0xA8D9734D, 0x6A0259EE, 0xC02A296E, 0x02F103CD, 0x20F9194D, 0xE22233EE,
0x64E92C4D, 0xA63206EE, 0x843A1C6E, 0x46E136CD, 0x09F871F4, 0xCB235B57,
0xE92B41D7, 0x2BF06B74, 0xAD3B74D7, 0x6FE05E74, 0x4DE844F4, 0x8F336E57,
0x251B1ED7, 0xE7C03474, 0xC5C82EF4, 0x07130457, 0x81D81BF4, 0x43033157,
0x610B2BD7, 0xA3D00174, 0x503EAFB2, 0x92E58511, 0xB0ED9F91, 0x7236B532,
0xF4FDAA91, 0x36268032, 0x142E9AB2, 0xD6F5B011, 0x7CDDC091, 0xBE06EA32,
0x9C0EF0B2, 0x5ED5DA11, 0xD81EC5B2, 0x1AC5EF11, 0x38CDF591, 0xFA16DF32,
0xBA75CD78, 0x78AEE7DB, 0x5AA6FD5B, 0x987DD7F8, 0x1EB6C85B, 0xDC6DE2F8,
0xFE65F878, 0x3CBED2DB, 0x9696A25B, 0x544D88F8, 0x76459278, 0xB49EB8DB,
0x3255A778, 0xF08E8DDB, 0xD286975B, 0x105DBDF8, 0xE3B3133E, 0x2168399D,
0x0360231D, 0xC1BB09BE, 0x4770161D, 0x85AB3CBE, 0xA7A3263E, 0x65780C9D,
0xCF507C1D, 0x0D8B56BE, 0x2F834C3E, 0xED58669D, 0x6B93793E, 0xA948539D,
0x8B40491D, 0x499B63BE, 0x0B866D89, 0xC95D472A, 0xEB555DAA, 0x298E7709,
0xAF4568AA, 0x6D9E4209, 0x4F965889, 0x8D4D722A, 0x276502AA, 0xE5BE2809,
0xC7B63289, 0x056D182A, 0x83A60789, 0x417D2D2A, 0x637537AA, 0xA1AE1D09,
0x5240B3CF, 0x909B996C, 0xB29383EC, 0x7048A94F, 0xF683B6EC, 0x34589C4F,
0x165086CF, 0xD48BAC6C, 0x7EA3DCEC, 0xBC78F64F, 0x9E70ECCF, 0x5CABC66C,
0xDA60D9CF, 0x18BBF36C, 0x3AB3E9EC, 0xF868C34F, 0xB80BD105, 0x7AD0FBA6,
0x58D8E126, 0x9A03CB85, 0x1CC8D426, 0xDE13FE85, 0xFC1BE405, 0x3EC0CEA6,
0x94E8BE26, 0x56339485, 0x743B8E05, 0xB6E0A4A6, 0x302BBB05, 0xF2F091A6,
0xD0F88B26, 0x1223A185, 0xE1CD0F43, 0x231625E0, 0x011E3F60, 0xC3C515C3,
0x450E0A60, 0x87D520C3, 0xA5DD3A43, 0x670610E0, 0xCD2E6060, 0x0FF54AC3,
0x2DFD5043, 0xEF267AE0, 0x69ED6543, 0xAB364FE0, 0x893E5560, 0x4BE57FC3,
0x0D04490E, 0xCFDF63AD, 0xEDD7792D, 0x2F0C538E, 0xA9C74C2D, 0x6B1C668E,
0x49147C0E, 0x8BCF56AD, 0x21E7262D, 0xE33C0C8E, 0xC134160E, 0x03EF3CAD,
0x8524230E, 0x47FF09AD, 0x65F7132D, 0xA72C398E, 0x54C29748, 0x9619BDEB,
0xB411A76B, 0x76CA8DC8, 0xF001926B, 0x32DAB8C8, 0x10D2A248, 0xD20988EB,
0x7821F86B, 0xBAFAD2C8, 0x98F2C848, 0x5A29E2EB, 0xDCE2FD48, 0x1E39D7EB,
0x3C31CD6B, 0xFEEAE7C8, 0xBE89F582, 0x7C52DF21, 0x5E5AC5A1, 0x9C81EF02,
0x1A4AF0A1, 0xD891DA02, 0xFA99C082, 0x3842EA21, 0x926A9AA1, 0x50B1B002,
0x72B9AA82, 0xB0628021, 0x36A99F82, 0xF472B521, 0xD67AAFA1, 0x14A18502,
0xE74F2BC4, 0x25940167, 0x079C1BE7, 0xC5473144, 0x438C2EE7, 0x81570444,
0xA35F1EC4, 0x61843467, 0xCBAC44E7, 0x09776E44, 0x2B7F74C4, 0xE9A45E67,
0x6F6F41C4, 0xADB46B67, 0x8FBC71E7, 0x4D675B44, 0x0F7A5573, 0xCDA17FD0,
0xEFA96550, 0x2D724FF3, 0xABB95050, 0x69627AF3, 0x4B6A6073, 0x89B14AD0,
0x23993A50, 0xE14210F3, 0xC34A0A73, 0x019120D0, 0x875A3F73, 0x458115D0,
0x67890F50, 0xA55225F3, 0x56BC8B35, 0x9467A196, 0xB66FBB16, 0x74B491B5,
0xF27F8E16, 0x30A4A4B5, 0x12ACBE35, 0xD0779496, 0x7A5FE416, 0xB884CEB5,
0x9A8CD435, 0x5857FE96, 0xDE9CE135, 0x1C47CB96, 0x3E4FD116, 0xFC94FBB5,
0xBCF7E9FF, 0x7E2CC35C, 0x5C24D9DC, 0x9EFFF37F, 0x1834ECDC, 0xDAEFC67F,
0xF8E7DCFF, 0x3A3CF65C, 0x901486DC, 0x52CFAC7F, 0x70C7B6FF, 0xB21C9C5C,
0x34D783FF, 0xF60CA95C, 0xD404B3DC, 0x16DF997F, 0xE53137B9, 0x27EA1D1A,
0x05E2079A, 0xC7392D39, 0x41F2329A, 0x83291839, 0xA12102B9, 0x63FA281A,
0xC9D2589A, 0x0B097239, 0x290168B9, 0xEBDA421A, 0x6D115DB9, 0xAFCA771A,
0x8DC26D9A, 0x4F194739, 0x13F0E3E8, 0xD12BC94B, 0xF323D3CB, 0x31F8F968,
0xB733E6CB, 0x75E8CC68, 0x57E0D6E8, 0x953BFC4B, 0x3F138CCB, 0xFDC8A668,
0xDFC0BCE8, 0x1D1B964B, 0x9BD089E8, 0x590BA34B, 0x7B03B9CB, 0xB9D89368,
0x4A363DAE, 0x88ED170D, 0xAAE50D8D, 0x683E272E, 0xEEF5388D, 0x2C2E122E,
0x0E2608AE, 0xCCFD220D, 0x66D5528D, 0xA40E782E, 0x860662AE, 0x44DD480D,
0xC21657AE, 0x00CD7D0D, 0x22C5678D, 0xE01E4D2E, 0xA07D5F64, 0x62A675C7,
0x40AE6F47, 0x827545E4, 0x04BE5A47, 0xC66570E4, 0xE46D6A64, 0x26B640C7,
0x8C9E3047, 0x4E451AE4, 0x6C4D0064, 0xAE962AC7, 0x285D3564, 0xEA861FC7,
0xC88E0547, 0x0A552FE4, 0xF9BB8122, 0x3B60AB81, 0x1968B101, 0xDBB39BA2,
0x5D788401, 0x9FA3AEA2, 0xBDABB422, 0x7F709E81, 0xD558EE01, 0x1783C4A2,
0x358BDE22, 0xF750F481, 0x719BEB22, 0xB340C181, 0x9148DB01, 0x5393F1A2,
0x118EFF95, 0xD355D536, 0xF15DCFB6, 0x3386E515, 0xB54DFAB6, 0x7796D015,
0x559ECA95, 0x9745E036, 0x3D6D90B6, 0xFFB6BA15, 0xDDBEA095, 0x1F658A36,
0x99AE9595, 0x5B75BF36, 0x797DA5B6, 0xBBA68F15, 0x484821D3, 0x8A930B70,
0xA89B11F0, 0x6A403B53, 0xEC8B24F0, 0x2E500E53, 0x0C5814D3, 0xCE833E70,
0x64AB4EF0, 0xA6706453, 0x84787ED3, 0x46A35470, 0xC0684BD3, 0x02B36170,
0x20BB7BF0, 0xE2605153, 0xA2034319, 0x60D869BA, 0x42D0733A, 0x800B5999,
0x06C0463A, 0xC41B6C99, 0xE6137619, 0x24C85CBA, 0x8EE02C3A, 0x4C3B0699,
0x6E331C19, 0xACE836BA, 0x2A232919, 0xE8F803BA, 0xCAF0193A, 0x082B3399,
0xFBC59D5F, 0x391EB7FC, 0x1B16AD7C, 0xD9CD87DF, 0x5F06987C, 0x9DDDB2DF,
0xBFD5A85F, 0x7D0E82FC, 0xD726F27C, 0x15FDD8DF, 0x37F5C25F, 0xF52EE8FC,
0x73E5F75F, 0xB13EDDFC, 0x9336C77C, 0x51EDEDDF, 0x170CDB12, 0xD5D7F1B1,
0xF7DFEB31, 0x3504C192, 0xB3CFDE31, 0x7114F492, 0x531CEE12, 0x91C7C4B1,
0x3BEFB431, 0xF9349E92, 0xDB3C8412, 0x19E7AEB1, 0x9F2CB112, 0x5DF79BB1,
0x7FFF8131, 0xBD24AB92, 0x4ECA0554, 0x8C112FF7, 0xAE193577, 0x6CC21FD4,
0xEA090077, 0x28D22AD4, 0x0ADA3054, 0xC8011AF7, 0x62296A77, 0xA0F240D4,
0x82FA5A54, 0x402170F7, 0xC6EA6F54, 0x043145F7, 0x26395F77, 0xE4E275D4,
0xA481679E, 0x665A4D3D, 0x445257BD, 0x86897D1E, 0x004262BD, 0xC299481E,
0xE091529E, 0x224A783D, 0x886208BD, 0x4AB9221E, 0x68B1389E, 0xAA6A123D,
0x2CA10D9E, 0xEE7A273D, 0xCC723DBD, 0x0EA9171E, 0xFD47B9D8, 0x3F9C937B,
0x1D9489FB, 0xDF4FA358, 0x5984BCFB, 0x9B5F9658, 0xB9578CD8, 0x7B8CA67B,
0xD1A4D6FB, 0x137FFC58, 0x3177E6D8, 0xF3ACCC7B, 0x7567D3D8, 0xB7BCF97B,
0x95B4E3FB, 0x576FC958, 0x1572C76F, 0xD7A9EDCC, 0xF5A1F74C, 0x377ADDEF,
0xB1B1C24C, 0x736AE8EF, 0x5162F26F, 0x93B9D8CC, 0x3991A84C, 0xFB4A82EF,
0xD942986F, 0x1B99B2CC, 0x9D52AD6F, 0x5F8987CC, 0x7D819D4C, 0xBF5AB7EF,
0x4CB41929, 0x8E6F338A, 0xAC67290A, 0x6EBC03A9, 0xE8771C0A, 0x2AAC36A9,
0x08A42C29, 0xCA7F068A, 0x6057760A, 0xA28C5CA9, 0x80844629, 0x425F6C8A,
0xC4947329, 0x064F598A, 0x2447430A, 0xE69C69A9, 0xA6FF7BE3, 0x64245140,
0x462C4BC0, 0x84F76163, 0x023C7EC0, 0xC0E75463, 0xE2EF4EE3, 0x20346440,
0x8A1C14C0, 0x48C73E63, 0x6ACF24E3, 0xA8140E40, 0x2EDF11E3, 0xEC043B40,
0xCE0C21C0, 0x0CD70B63, 0xFF39A5A5, 0x3DE28F06, 0x1FEA9586, 0xDD31BF25,
0x5BFAA086, 0x99218A25, 0xBB2990A5, 0x79F2BA06, 0xD3DACA86, 0x1101E025,
0x3309FAA5, 0xF1D2D006, 0x7719CFA5, 0xB5C2E506, 0x97CAFF86, 0x5511D525,
0x1A08921C, 0xD8D3B8BF, 0xFADBA23F, 0x3800889C, 0xBECB973F, 0x7C10BD9C,
0x5E18A71C, 0x9CC38DBF, 0x36EBFD3F, 0xF430D79C, 0xD638CD1C, 0x14E3E7BF,
0x9228F81C, 0x50F3D2BF, 0x72FBC83F, 0xB020E29C, 0x43CE4C5A, 0x811566F9,
0xA31D7C79, 0x61C656DA, 0xE70D4979, 0x25D663DA, 0x07DE795A, 0xC50553F9,
0x6F2D2379, 0xADF609DA, 0x8FFE135A, 0x4D2539F9, 0xCBEE265A, 0x09350CF9,
0x2B3D1679, 0xE9E63CDA, 0xA9852E90, 0x6B5E0433, 0x49561EB3, 0x8B8D3410,
0x0D462BB3, 0xCF9D0110, 0xED951B90, 0x2F4E3133, 0x856641B3, 0x47BD6B10,
0x65B57190, 0xA76E5B33, 0x21A54490, 0xE37E6E33, 0xC17674B3, 0x03AD5E10,
0xF043F0D6, 0x3298DA75, 0x1090C0F5, 0xD24BEA56, 0x5480F5F5, 0x965BDF56,
0xB453C5D6, 0x7688EF75, 0xDCA09FF5, 0x1E7BB556, 0x3C73AFD6, 0xFEA88575,
0x78639AD6, 0xBAB8B075, 0x98B0AAF5, 0x5A6B8056, 0x18768E61, 0xDAADA4C2,
0xF8A5BE42, 0x3A7E94E1, 0xBCB58B42, 0x7E6EA1E1, 0x5C66BB61, 0x9EBD91C2,
0x3495E142, 0xF64ECBE1, 0xD446D161, 0x169DFBC2, 0x9056E461, 0x528DCEC2,
0x7085D442, 0xB25EFEE1, 0x41B05027, 0x836B7A84, 0xA1636004, 0x63B84AA7,
0xE5735504, 0x27A87FA7, 0x05A06527, 0xC77B4F84, 0x6D533F04, 0xAF8815A7,
0x8D800F27, 0x4F5B2584, 0xC9903A27, 0x0B4B1084, 0x29430A04, 0xEB9820A7,
0xABFB32ED, 0x6920184E, 0x4B2802CE, 0x89F3286D, 0x0F3837CE, 0xCDE31D6D,
0xEFEB07ED, 0x2D302D4E, 0x87185DCE, 0x45C3776D, 0x67CB6DED, 0xA510474E,
0x23DB58ED, 0xE100724E, 0xC30868CE, 0x01D3426D, 0xF23DECAB, 0x30E6C608,
0x12EEDC88, 0xD035F62B, 0x56FEE988, 0x9425C32B, 0xB62DD9AB, 0x74F6F308,
0xDEDE8388, 0x1C05A92B, 0x3E0DB3AB, 0xFCD69908, 0x7A1D86AB, 0xB8C6AC08,
0x9ACEB688, 0x58159C2B, 0x1EF4AAE6, 0xDC2F8045, 0xFE279AC5, 0x3CFCB066,
0xBA37AFC5, 0x78EC8566, 0x5AE49FE6, 0x983FB545, 0x3217C5C5, 0xF0CCEF66,
0xD2C4F5E6, 0x101FDF45, 0x96D4C0E6, 0x540FEA45, 0x7607F0C5, 0xB4DCDA66,
0x473274A0, 0x85E95E03, 0xA7E14483, 0x653A6E20, 0xE3F17183, 0x212A5B20,
0x032241A0, 0xC1F96B03, 0x6BD11B83, 0xA90A3120, 0x8B022BA0, 0x49D90103,
0xCF121EA0, 0x0DC93403, 0x2FC12E83, 0xED1A0420, 0xAD79166A, 0x6FA23CC9,
0x4DAA2649, 0x8F710CEA, 0x09BA1349, 0xCB6139EA, 0xE969236A, 0x2BB209C9,
0x819A7949, 0x434153EA, 0x6149496A, 0xA39263C9, 0x25597C6A, 0xE78256C9,
0xC58A4C49, 0x075166EA, 0xF4BFC82C, 0x3664E28F, 0x146CF80F, 0xD6B7D2AC,
0x507CCD0F, 0x92A7E7AC, 0xB0AFFD2C, 0x7274D78F, 0xD85CA70F, 0x1A878DAC,
0x388F972C, 0xFA54BD8F, 0x7C9FA22C, 0xBE44888F, 0x9C4C920F, 0x5E97B8AC,
0x1C8AB69B, 0xDE519C38, 0xFC5986B8, 0x3E82AC1B, 0xB849B3B8, 0x7A92991B,
0x589A839B, 0x9A41A938, 0x3069D9B8, 0xF2B2F31B, 0xD0BAE99B, 0x1261C338,
0x94AADC9B, 0x5671F638, 0x7479ECB8, 0xB6A2C61B, 0x454C68DD, 0x8797427E,
0xA59F58FE, 0x6744725D, 0xE18F6DFE, 0x2354475D, 0x015C5DDD, 0xC387777E,
0x69AF07FE, 0xAB742D5D, 0x897C37DD, 0x4BA71D7E, 0xCD6C02DD, 0x0FB7287E,
0x2DBF32FE, 0xEF64185D, 0xAF070A17, 0x6DDC20B4, 0x4FD43A34, 0x8D0F1097,
0x0BC40F34, 0xC91F2597, 0xEB173F17, 0x29CC15B4, 0x83E46534, 0x413F4F97,
0x63375517, 0xA1EC7FB4, 0x27276017, 0xE5FC4AB4, 0xC7F45034, 0x052F7A97,
0xF6C1D451, 0x341AFEF2, 0x1612E472, 0xD4C9CED1, 0x5202D172, 0x90D9FBD1,
0xB2D1E151, 0x700ACBF2, 0xDA22BB72, 0x18F991D1, 0x3AF18B51, 0xF82AA1F2,
0x7EE1BE51, 0xBC3A94F2, 0x9E328E72, 0x5CE9A4D1, 0x27E1C7D0, 0xE53AED73,
0xC732F7F3, 0x05E9DD50, 0x8322C2F3, 0x41F9E850, 0x63F1F2D0, 0xA12AD873,
0x0B02A8F3, 0xC9D98250, 0xEBD198D0, 0x290AB273, 0xAFC1ADD0, 0x6D1A8773,
0x4F129DF3, 0x8DC9B750, 0x7E271996, 0xBCFC3335, 0x9EF429B5, 0x5C2F0316,
0xDAE41CB5, 0x183F3616, 0x3A372C96, 0xF8EC0635, 0x52C476B5, 0x901F5C16,
0xB2174696, 0x70CC6C35, 0xF6077396, 0x34DC5935, 0x16D443B5, 0xD40F6916,
0x946C7B5C, 0x56B751FF, 0x74BF4B7F, 0xB66461DC, 0x30AF7E7F, 0xF27454DC,
0xD07C4E5C, 0x12A764FF, 0xB88F147F, 0x7A543EDC, 0x585C245C, 0x9A870EFF,
0x1C4C115C, 0xDE973BFF, 0xFC9F217F, 0x3E440BDC, 0xCDAAA51A, 0x0F718FB9,
0x2D799539, 0xEFA2BF9A, 0x6969A039, 0xABB28A9A, 0x89BA901A, 0x4B61BAB9,
0xE149CA39, 0x2392E09A, 0x019AFA1A, 0xC341D0B9, 0x458ACF1A, 0x8751E5B9,
0xA559FF39, 0x6782D59A, 0x259FDBAD, 0xE744F10E, 0xC54CEB8E, 0x0797C12D,
0x815CDE8E, 0x4387F42D, 0x618FEEAD, 0xA354C40E, 0x097CB48E, 0xCBA79E2D,
0xE9AF84AD, 0x2B74AE0E, 0xADBFB1AD, 0x6F649B0E, 0x4D6C818E, 0x8FB7AB2D,
0x7C5905EB, 0xBE822F48, 0x9C8A35C8, 0x5E511F6B, 0xD89A00C8, 0x1A412A6B,
0x384930EB, 0xFA921A48, 0x50BA6AC8, 0x9261406B, 0xB0695AEB, 0x72B27048,
0xF4796FEB, 0x36A24548, 0x14AA5FC8, 0xD671756B, 0x96126721, 0x54C94D82,
0x76C15702, 0xB41A7DA1, 0x32D16202, 0xF00A48A1, 0xD2025221, 0x10D97882,
0xBAF10802, 0x782A22A1, 0x5A223821, 0x98F91282, 0x1E320D21, 0xDCE92782,
0xFEE13D02, 0x3C3A17A1, 0xCFD4B967, 0x0D0F93C4, 0x2F078944, 0xEDDCA3E7,
0x6B17BC44, 0xA9CC96E7, 0x8BC48C67, 0x491FA6C4, 0xE337D644, 0x21ECFCE7,
0x03E4E667, 0xC13FCCC4, 0x47F4D367, 0x852FF9C4, 0xA727E344, 0x65FCC9E7,
0x231DFF2A, 0xE1C6D589, 0xC3CECF09, 0x0115E5AA, 0x87DEFA09, 0x4505D0AA,
0x670DCA2A, 0xA5D6E089, 0x0FFE9009, 0xCD25BAAA, 0xEF2DA02A, 0x2DF68A89,
0xAB3D952A, 0x69E6BF89, 0x4BEEA509, 0x89358FAA, 0x7ADB216C, 0xB8000BCF,
0x9A08114F, 0x58D33BEC, 0xDE18244F, 0x1CC30EEC, 0x3ECB146C, 0xFC103ECF,
0x56384E4F, 0x94E364EC, 0xB6EB7E6C, 0x743054CF, 0xF2FB4B6C, 0x302061CF,
0x12287B4F, 0xD0F351EC, 0x909043A6, 0x524B6905, 0x70437385, 0xB2985926,
0x34534685, 0xF6886C26, 0xD48076A6, 0x165B5C05, 0xBC732C85, 0x7EA80626,
0x5CA01CA6, 0x9E7B3605, 0x18B029A6, 0xDA6B0305, 0xF8631985, 0x3AB83326,
0xC9569DE0, 0x0B8DB743, 0x2985ADC3, 0xEB5E8760, 0x6D9598C3, 0xAF4EB260,
0x8D46A8E0, 0x4F9D8243, 0xE5B5F2C3, 0x276ED860, 0x0566C2E0, 0xC7BDE843,
0x4176F7E0, 0x83ADDD43, 0xA1A5C7C3, 0x637EED60, 0x2163E357, 0xE3B8C9F4,
0xC1B0D374, 0x036BF9D7, 0x85A0E674, 0x477BCCD7, 0x6573D657, 0xA7A8FCF4,
0x0D808C74, 0xCF5BA6D7, 0xED53BC57, 0x2F8896F4, 0xA9438957, 0x6B98A3F4,
0x4990B974, 0x8B4B93D7, 0x78A53D11, 0xBA7E17B2, 0x98760D32, 0x5AAD2791,
0xDC663832, 0x1EBD1291, 0x3CB50811, 0xFE6E22B2, 0x54465232, 0x969D7891,
0xB4956211, 0x764E48B2, 0xF0855711, 0x325E7DB2, 0x10566732, 0xD28D4D91,
0x92EE5FDB, 0x50357578, 0x723D6FF8, 0xB0E6455B, 0x362D5AF8, 0xF4F6705B,
0xD6FE6ADB, 0x14254078, 0xBE0D30F8, 0x7CD61A5B, 0x5EDE00DB, 0x9C052A78,
0x1ACE35DB, 0xD8151F78, 0xFA1D05F8, 0x38C62F5B, 0xCB28819D, 0x09F3AB3E,
0x2BFBB1BE, 0xE9209B1D, 0x6FEB84BE, 0xAD30AE1D, 0x8F38B49D, 0x4DE39E3E,
0xE7CBEEBE, 0x2510C41D, 0x0718DE9D, 0xC5C3F43E, 0x4308EB9D, 0x81D3C13E,
0xA3DBDBBE, 0x6100F11D, 0x2E19B624, 0xECC29C87, 0xCECA8607, 0x0C11ACA4,
0x8ADAB307, 0x480199A4, 0x6A098324, 0xA8D2A987, 0x02FAD907, 0xC021F3A4,
0xE229E924, 0x20F2C387, 0xA639DC24, 0x64E2F687, 0x46EAEC07, 0x8431C6A4,
0x77DF6862, 0xB50442C1, 0x970C5841, 0x55D772E2, 0xD31C6D41, 0x11C747E2,
0x33CF5D62, 0xF11477C1, 0x5B3C0741, 0x99E72DE2, 0xBBEF3762, 0x79341DC1,
0xFFFF0262, 0x3D2428C1, 0x1F2C3241, 0xDDF718E2, 0x9D940AA8, 0x5F4F200B,
0x7D473A8B, 0xBF9C1028, 0x39570F8B, 0xFB8C2528, 0xD9843FA8, 0x1B5F150B,
0xB177658B, 0x73AC4F28, 0x51A455A8, 0x937F7F0B, 0x15B460A8, 0xD76F4A0B,
0xF567508B, 0x37BC7A28, 0xC452D4EE, 0x0689FE4D, 0x2481E4CD, 0xE65ACE6E,
0x6091D1CD, 0xA24AFB6E, 0x8042E1EE, 0x4299CB4D, 0xE8B1BBCD, 0x2A6A916E,
0x08628BEE, 0xCAB9A14D, 0x4C72BEEE, 0x8EA9944D, 0xACA18ECD, 0x6E7AA46E,
0x2C67AA59, 0xEEBC80FA, 0xCCB49A7A, 0x0E6FB0D9, 0x88A4AF7A, 0x4A7F85D9,
0x68779F59, 0xAAACB5FA, 0x0084C57A, 0xC25FEFD9, 0xE057F559, 0x228CDFFA,
0xA447C059, 0x669CEAFA, 0x4494F07A, 0x864FDAD9, 0x75A1741F, 0xB77A5EBC,
0x9572443C, 0x57A96E9F, 0xD162713C, 0x13B95B9F, 0x31B1411F, 0xF36A6BBC,
0x59421B3C, 0x9B99319F, 0xB9912B1F, 0x7B4A01BC, 0xFD811E1F, 0x3F5A34BC,
0x1D522E3C, 0xDF89049F, 0x9FEA16D5, 0x5D313C76, 0x7F3926F6, 0xBDE20C55,
0x3B2913F6, 0xF9F23955, 0xDBFA23D5, 0x19210976, 0xB30979F6, 0x71D25355,
0x53DA49D5, 0x91016376, 0x17CA7CD5, 0xD5115676, 0xF7194CF6, 0x35C26655,
0xC62CC893, 0x04F7E230, 0x26FFF8B0, 0xE424D213, 0x62EFCDB0, 0xA034E713,
0x823CFD93, 0x40E7D730, 0xEACFA7B0, 0x28148D13, 0x0A1C9793, 0xC8C7BD30,
0x4E0CA293, 0x8CD78830, 0xAEDF92B0, 0x6C04B813, 0x2AE58EDE, 0xE83EA47D,
0xCA36BEFD, 0x08ED945E, 0x8E268BFD, 0x4CFDA15E, 0x6EF5BBDE, 0xAC2E917D,
0x0606E1FD, 0xC4DDCB5E, 0xE6D5D1DE, 0x240EFB7D, 0xA2C5E4DE, 0x601ECE7D,
0x4216D4FD, 0x80CDFE5E, 0x73235098, 0xB1F87A3B, 0x93F060BB, 0x512B4A18,
0xD7E055BB, 0x153B7F18, 0x37336598, 0xF5E84F3B, 0x5FC03FBB, 0x9D1B1518,
0xBF130F98, 0x7DC8253B, 0xFB033A98, 0x39D8103B, 0x1BD00ABB, 0xD90B2018,
0x99683252, 0x5BB318F1, 0x79BB0271, 0xBB6028D2, 0x3DAB3771, 0xFF701DD2,
0xDD780752, 0x1FA32DF1, 0xB58B5D71, 0x775077D2, 0x55586D52, 0x978347F1,
0x11485852, 0xD39372F1, 0xF19B6871, 0x334042D2, 0xC0AEEC14, 0x0275C6B7,
0x207DDC37, 0xE2A6F694, 0x646DE937, 0xA6B6C394, 0x84BED914, 0x4665F3B7,
0xEC4D8337, 0x2E96A994, 0x0C9EB314, 0xCE4599B7, 0x488E8614, 0x8A55ACB7,
0xA85DB637, 0x6A869C94, 0x289B92A3, 0xEA40B800, 0xC848A280, 0x0A938823,
0x8C589780, 0x4E83BD23, 0x6C8BA7A3, 0xAE508D00, 0x0478FD80, 0xC6A3D723,
0xE4ABCDA3, 0x2670E700, 0xA0BBF8A3, 0x6260D200, 0x4068C880, 0x82B3E223,
0x715D4CE5, 0xB3866646, 0x918E7CC6, 0x53555665, 0xD59E49C6, 0x17456365,
0x354D79E5, 0xF7965346, 0x5DBE23C6, 0x9F650965, 0xBD6D13E5, 0x7FB63946,
0xF97D26E5, 0x3BA60C46, 0x19AE16C6, 0xDB753C65, 0x9B162E2F, 0x59CD048C,
0x7BC51E0C, 0xB91E34AF, 0x3FD52B0C, 0xFD0E01AF, 0xDF061B2F, 0x1DDD318C,
0xB7F5410C, 0x752E6BAF, 0x5726712F, 0x95FD5B8C, 0x1336442F, 0xD1ED6E8C,
0xF3E5740C, 0x313E5EAF, 0xC2D0F069, 0x000BDACA, 0x2203C04A, 0xE0D8EAE9,
0x6613F54A, 0xA4C8DFE9, 0x86C0C569, 0x441BEFCA, 0xEE339F4A, 0x2CE8B5E9,
0x0EE0AF69, 0xCC3B85CA, 0x4AF09A69, 0x882BB0CA, 0xAA23AA4A, 0x68F880E9,
0x34112438, 0xF6CA0E9B, 0xD4C2141B, 0x16193EB8, 0x90D2211B, 0x52090BB8,
0x70011138, 0xB2DA3B9B, 0x18F24B1B, 0xDA2961B8, 0xF8217B38, 0x3AFA519B,
0xBC314E38, 0x7EEA649B, 0x5CE27E1B, 0x9E3954B8, 0x6DD7FA7E, 0xAF0CD0DD,
0x8D04CA5D, 0x4FDFE0FE, 0xC914FF5D, 0x0BCFD5FE, 0x29C7CF7E, 0xEB1CE5DD,
0x4134955D, 0x83EFBFFE, 0xA1E7A57E, 0x633C8FDD, 0xE5F7907E, 0x272CBADD,
0x0524A05D, 0xC7FF8AFE, 0x879C98B4, 0x4547B217, 0x674FA897, 0xA5948234,
0x235F9D97, 0xE184B734, 0xC38CADB4, 0x01578717, 0xAB7FF797, 0x69A4DD34,
0x4BACC7B4, 0x8977ED17, 0x0FBCF2B4, 0xCD67D817, 0xEF6FC297, 0x2DB4E834,
0xDE5A46F2, 0x1C816C51, 0x3E8976D1, 0xFC525C72, 0x7A9943D1, 0xB8426972,
0x9A4A73F2, 0x58915951, 0xF2B929D1, 0x30620372, 0x126A19F2, 0xD0B13351,
0x567A2CF2, 0x94A10651, 0xB6A91CD1, 0x74723672, 0x366F3845, 0xF4B412E6,
0xD6BC0866, 0x146722C5, 0x92AC3D66, 0x507717C5, 0x727F0D45, 0xB0A427E6,
0x1A8C5766, 0xD8577DC5, 0xFA5F6745, 0x38844DE6, 0xBE4F5245, 0x7C9478E6,
0x5E9C6266, 0x9C4748C5, 0x6FA9E603, 0xAD72CCA0, 0x8F7AD620, 0x4DA1FC83,
0xCB6AE320, 0x09B1C983, 0x2BB9D303, 0xE962F9A0, 0x434A8920, 0x8191A383,
0xA399B903, 0x614293A0, 0xE7898C03, 0x2552A6A0, 0x075ABC20, 0xC5819683,
0x85E284C9, 0x4739AE6A, 0x6531B4EA, 0xA7EA9E49, 0x212181EA, 0xE3FAAB49,
0xC1F2B1C9, 0x03299B6A, 0xA901EBEA, 0x6BDAC149, 0x49D2DBC9, 0x8B09F16A,
0x0DC2EEC9, 0xCF19C46A, 0xED11DEEA, 0x2FCAF449, 0xDC245A8F, 0x1EFF702C,
0x3CF76AAC, 0xFE2C400F, 0x78E75FAC, 0xBA3C750F, 0x98346F8F, 0x5AEF452C,
0xF0C735AC, 0x321C1F0F, 0x1014058F, 0xD2CF2F2C, 0x5404308F, 0x96DF1A2C,
0xB4D700AC, 0x760C2A0F, 0x30ED1CC2, 0xF2363661, 0xD03E2CE1, 0x12E50642,
0x942E19E1, 0x56F53342, 0x74FD29C2, 0xB6260361, 0x1C0E73E1, 0xDED55942,
0xFCDD43C2, 0x3E066961, 0xB8CD76C2, 0x7A165C61, 0x581E46E1, 0x9AC56C42,
0x692BC284, 0xABF0E827, 0x89F8F2A7, 0x4B23D804, 0xCDE8C7A7, 0x0F33ED04,
0x2D3BF784, 0xEFE0DD27, 0x45C8ADA7, 0x87138704, 0xA51B9D84, 0x67C0B727,
0xE10BA884, 0x23D08227, 0x01D898A7, 0xC303B204, 0x8360A04E, 0x41BB8AED,
0x63B3906D, 0xA168BACE, 0x27A3A56D, 0xE5788FCE, 0xC770954E, 0x05ABBFED,
0xAF83CF6D, 0x6D58E5CE, 0x4F50FF4E, 0x8D8BD5ED, 0x0B40CA4E, 0xC99BE0ED,
0xEB93FA6D, 0x2948D0CE, 0xDAA67E08, 0x187D54AB, 0x3A754E2B, 0xF8AE6488,
0x7E657B2B, 0xBCBE5188, 0x9EB64B08, 0x5C6D61AB, 0xF645112B, 0x349E3B88,
0x16962108, 0xD44D0BAB, 0x52861408, 0x905D3EAB, 0xB255242B, 0x708E0E88,
0x329300BF, 0xF0482A1C, 0xD240309C, 0x109B1A3F, 0x9650059C, 0x548B2F3F,
0x768335BF, 0xB4581F1C, 0x1E706F9C, 0xDCAB453F, 0xFEA35FBF, 0x3C78751C,
0xBAB36ABF, 0x7868401C, 0x5A605A9C, 0x98BB703F, 0x6B55DEF9, 0xA98EF45A,
0x8B86EEDA, 0x495DC479, 0xCF96DBDA, 0x0D4DF179, 0x2F45EBF9, 0xED9EC15A,
0x47B6B1DA, 0x856D9B79, 0xA76581F9, 0x65BEAB5A, 0xE375B4F9, 0x21AE9E5A,
0x03A684DA, 0xC17DAE79, 0x811EBC33, 0x43C59690, 0x61CD8C10, 0xA316A6B3,
0x25DDB910, 0xE70693B3, 0xC50E8933, 0x07D5A390, 0xADFDD310, 0x6F26F9B3,
0x4D2EE333, 0x8FF5C990, 0x093ED633, 0xCBE5FC90, 0xE9EDE610, 0x2B36CCB3,
0xD8D86275, 0x1A0348D6, 0x380B5256, 0xFAD078F5, 0x7C1B6756, 0xBEC04DF5,
0x9CC85775, 0x5E137DD6, 0xF43B0D56, 0x36E027F5, 0x14E83D75, 0xD63317D6,
0x50F80875, 0x922322D6, 0xB02B3856, 0x72F012F5, 0x3DE955CC, 0xFF327F6F,
0xDD3A65EF, 0x1FE14F4C, 0x992A50EF, 0x5BF17A4C, 0x79F960CC, 0xBB224A6F,
0x110A3AEF, 0xD3D1104C, 0xF1D90ACC, 0x3302206F, 0xB5C93FCC, 0x7712156F,
0x551A0FEF, 0x97C1254C, 0x642F8B8A, 0xA6F4A129, 0x84FCBBA9, 0x4627910A,
0xC0EC8EA9, 0x0237A40A, 0x203FBE8A, 0xE2E49429, 0x48CCE4A9, 0x8A17CE0A,
0xA81FD48A, 0x6AC4FE29, 0xEC0FE18A, 0x2ED4CB29, 0x0CDCD1A9, 0xCE07FB0A,
0x8E64E940, 0x4CBFC3E3, 0x6EB7D963, 0xAC6CF3C0, 0x2AA7EC63, 0xE87CC6C0,
0xCA74DC40, 0x08AFF6E3, 0xA2878663, 0x605CACC0, 0x4254B640, 0x808F9CE3,
0x06448340, 0xC49FA9E3, 0xE697B363, 0x244C99C0, 0xD7A23706, 0x15791DA5,
0x37710725, 0xF5AA2D86, 0x73613225, 0xB1BA1886, 0x93B20206, 0x516928A5,
0xFB415825, 0x399A7286, 0x1B926806, 0xD94942A5, 0x5F825D06, 0x9D5977A5,
0xBF516D25, 0x7D8A4786, 0x3F9749B1, 0xFD4C6312, 0xDF447992, 0x1D9F5331,
0x9B544C92, 0x598F6631, 0x7B877CB1, 0xB95C5612, 0x13742692, 0xD1AF0C31,
0xF3A716B1, 0x317C3C12, 0xB7B723B1, 0x756C0912, 0x57641392, 0x95BF3931,
0x665197F7, 0xA48ABD54, 0x8682A7D4, 0x44598D77, 0xC29292D4, 0x0049B877,
0x2241A2F7, 0xE09A8854, 0x4AB2F8D4, 0x8869D277, 0xAA61C8F7, 0x68BAE254,
0xEE71FDF7, 0x2CAAD754, 0x0EA2CDD4, 0xCC79E777, 0x8C1AF53D, 0x4EC1DF9E,
0x6CC9C51E, 0xAE12EFBD, 0x28D9F01E, 0xEA02DABD, 0xC80AC03D, 0x0AD1EA9E,
0xA0F99A1E, 0x6222B0BD, 0x402AAA3D, 0x82F1809E, 0x043A9F3D, 0xC6E1B59E,
0xE4E9AF1E, 0x263285BD, 0xD5DC2B7B, 0x170701D8, 0x350F1B58, 0xF7D431FB,
0x711F2E58, 0xB3C404FB, 0x91CC1E7B, 0x531734D8, 0xF93F4458, 0x3BE46EFB,
0x19EC747B, 0xDB375ED8, 0x5DFC417B, 0x9F276BD8, 0xBD2F7158, 0x7FF45BFB,
0x39156D36, 0xFBCE4795, 0xD9C65D15, 0x1B1D77B6, 0x9DD66815, 0x5F0D42B6,
0x7D055836, 0xBFDE7295, 0x15F60215, 0xD72D28B6, 0xF5253236, 0x37FE1895,
0xB1350736, 0x73EE2D95, 0x51E63715, 0x933D1DB6, 0x60D3B370, 0xA20899D3,
0x80008353, 0x42DBA9F0, 0xC410B653, 0x06CB9CF0, 0x24C38670, 0xE618ACD3,
0x4C30DC53, 0x8EEBF6F0, 0xACE3EC70, 0x6E38C6D3, 0xE8F3D970, 0x2A28F3D3,
0x0820E953, 0xCAFBC3F0, 0x8A98D1BA, 0x4843FB19, 0x6A4BE199, 0xA890CB3A,
0x2E5BD499, 0xEC80FE3A, 0xCE88E4BA, 0x0C53CE19, 0xA67BBE99, 0x64A0943A,
0x46A88EBA, 0x8473A419, 0x02B8BBBA, 0xC0639119, 0xE26B8B99, 0x20B0A13A,
0xD35E0FFC, 0x1185255F, 0x338D3FDF, 0xF156157C, 0x779D0ADF, 0xB546207C,
0x974E3AFC, 0x5595105F, 0xFFBD60DF, 0x3D664A7C, 0x1F6E50FC, 0xDDB57A5F,
0x5B7E65FC, 0x99A54F5F, 0xBBAD55DF, 0x79767F7C, 0x3B6B714B, 0xF9B05BE8,
0xDBB84168, 0x19636BCB, 0x9FA87468, 0x5D735ECB, 0x7F7B444B, 0xBDA06EE8,
0x17881E68, 0xD55334CB, 0xF75B2E4B, 0x358004E8, 0xB34B1B4B, 0x719031E8,
0x53982B68, 0x914301CB, 0x62ADAF0D, 0xA07685AE, 0x827E9F2E, 0x40A5B58D,
0xC66EAA2E, 0x04B5808D, 0x26BD9A0D, 0xE466B0AE, 0x4E4EC02E, 0x8C95EA8D,
0xAE9DF00D, 0x6C46DAAE, 0xEA8DC50D, 0x2856EFAE, 0x0A5EF52E, 0xC885DF8D,
0x88E6CDC7, 0x4A3DE764, 0x6835FDE4, 0xAAEED747, 0x2C25C8E4, 0xEEFEE247,
0xCCF6F8C7, 0x0E2DD264, 0xA405A2E4, 0x66DE8847, 0x44D692C7, 0x860DB864,
0x00C6A7C7, 0xC21D8D64, 0xE01597E4, 0x22CEBD47, 0xD1201381, 0x13FB3922,
0x31F323A2, 0xF3280901, 0x75E316A2, 0xB7383C01, 0x95302681, 0x57EB0C22,
0xFDC37CA2, 0x3F185601, 0x1D104C81, 0xDFCB6622, 0x59007981, 0x9BDB5322,
0xB9D349A2, 0x7B086301,

###############################################################################

TITLE
    t-class 32 sbox

TYPE
    32

DATA
    0xa3aa1887UL, 0xd75e435cUL, 0x0965c042UL, 0x830e6ef4UL,
    0xf857ee20UL, 0x4884fed3UL, 0xf666c502UL, 0xf454e8aeUL,
    0xb32ee9d9UL, 0x211f38d4UL, 0x15829b5dUL, 0x785cdf3cUL,
    0x99864249UL, 0xb12e3963UL, 0xaff4429fUL, 0xf9432c35UL,
    0xe7f40325UL, 0x2dc0dd70UL, 0x4d973dedUL, 0x8a02dc5eUL,
    0xce175b42UL, 0x4c0012bfUL, 0xca94d78cUL, 0x2eaab26bUL,
    0x52c11b9aUL, 0x95168146UL, 0xd9ea8ec5UL, 0x1e8ac28fUL,
    0x4eed5c0fUL, 0x38b4101cUL, 0x442db082UL, 0x280929e1UL,
    0x0a1843deUL, 0xdf8299fcUL, 0x022fbc4bUL, 0xa03915ddUL,
    0x17a803faUL, 0xf146b2deUL, 0x60233342UL, 0x68cee7c3UL,
    0x12d607efUL, 0xb797ebabUL, 0x7a7f859bUL, 0xc31f2e2fUL,
    0xe95b71daUL, 0xfae2269aUL, 0x3d39c3d1UL, 0x53a56b36UL,
    0x96c9def2UL, 0x84c9fc5fUL, 0x6b27b3a3UL, 0xbaa56ddfUL,
    0xf225b510UL, 0x630f85a7UL, 0x9ae82e71UL, 0x19cb8816UL,
    0x7c951e2aUL, 0xaef5f6afUL, 0xe5cbc2b3UL, 0xf54ff55dUL,
    0xf76b6214UL, 0x160b83e3UL, 0x6a9ea6f5UL, 0xa2e041afUL,
    0x392f1f17UL, 0xb63b99eeUL, 0x7ba65ec0UL, 0x0f7016c6UL,
    0xc17709a4UL, 0x93326e01UL, 0x81b280d9UL, 0x1bfb1418UL,
    0xeeaff227UL, 0xb4548203UL, 0x1a6b9d96UL, 0xea17a8c0UL,
    0xd0d5bf6eUL, 0x91ee7888UL, 0x2ffcfe64UL, 0xb8a193cdUL,
    0x550d0184UL, 0xb9ae4930UL, 0xda014f36UL, 0x85a87088UL,
    0x3fad6c2aUL, 0x4122c678UL, 0xbf204de7UL, 0xe0c2e759UL,
    0x5a00248eUL, 0x583b446bUL, 0x800d9fc2UL, 0x5f14a895UL,
    0x666cc3a1UL, 0x0bfef170UL, 0xd8c19155UL, 0x907b8a66UL,
    0x351b5e69UL, 0xd5a8623eUL, 0xc0bdfa35UL, 0xa7f068ccUL,
    0x333a6acdUL, 0x0655e936UL, 0x65602db9UL, 0x69df13c1UL,
    0x450bb16dUL, 0x0080b83cUL, 0x94b23763UL, 0x56d8a911UL,
    0x6db6bc13UL, 0x985579d7UL, 0x9b5c2fa8UL, 0x76f4196eUL,
    0x97db5476UL, 0xfc64a866UL, 0xb26e16adUL, 0xc27fc515UL,
    0xb06feb3cUL, 0xfec8a306UL, 0xdb6799d9UL, 0x201a9133UL,
    0xe12466ddUL, 0xebeb5dcdUL, 0xd6118f50UL, 0xe4afb226UL,
    0xddb9cef3UL, 0x47b36189UL, 0x4a7a19b1UL, 0x1dc73084UL,
    0x427ded5cUL, 0xed8bc58fUL, 0x9edde421UL, 0x6e1e47fbUL,
    0x49cc715eUL, 0x3cc0ff99UL, 0xcd122f0fUL, 0x43d25184UL,
    0x277a5e6cUL, 0xd2bf18bcUL, 0x07d7c6e0UL, 0xd4b7e420UL,
    0xde1f523fUL, 0xc7d9b8a2UL, 0x67da1a6bUL, 0x18888c02UL,
    0x89d1e354UL, 0xcbba7d79UL, 0x30cc7753UL, 0x1f2d9655UL,
    0x8d829da1UL, 0xc61590a7UL, 0x8fc1c149UL, 0xaa537f1cUL,
    0xc8779b69UL, 0x7471f2b7UL, 0xdc3c58faUL, 0xc9dc4418UL,
    0x5d8c8c76UL, 0x5c20d9f0UL, 0x31a80d4dUL, 0xa474c473UL,
    0x709410e9UL, 0x880e4211UL, 0x61c8082bUL, 0x2c6b334aUL,
    0x9ff68ed2UL, 0x0d43cc1bUL, 0x2b3c0ff3UL, 0x87e564a0UL,
    0x50f55a4fUL, 0x8240f8e7UL, 0x54a7f15fUL, 0x6400fe21UL,
    0x266d37d6UL, 0x7dd506f1UL, 0x03e00973UL, 0x40bbde36UL,
    0x34670fa8UL, 0x4b31ab9eUL, 0x1cdab618UL, 0x731f52f5UL,
    0xd158eb4fUL, 0xc4b9e343UL, 0xfd8d77ddUL, 0x3bb93da6UL,
    0xcc0fd52dUL, 0xfb5412f8UL, 0x7fa63360UL, 0xabe53ad0UL,
    0xe6700f1cUL, 0x3e24ed0bUL, 0x5b3dc1ecUL, 0xa5366795UL,
    0xad549d15UL, 0x04ce46d7UL, 0x237abe76UL, 0x9c48e0a0UL,
    0x14f07c02UL, 0x511249b7UL, 0x229ed6baUL, 0xf0a47f78UL,
    0x29cfffbdUL, 0x7907ca84UL, 0x7165f4daUL, 0x7e9f35daUL,
    0xffd2aa44UL, 0x8c7452acUL, 0x0ed674a7UL, 0xe261a46aUL,
    0x0c63152aUL, 0xef12b7aaUL, 0xbc615927UL, 0x724fb118UL,
    0x7551758dUL, 0x6f81687bUL, 0x3752f0b3UL, 0xa14254edUL,
    0xecc77271UL, 0xd331acabUL, 0x8ef94aecUL, 0x62e994cdUL,
    0x8b4d9e81UL, 0x86623730UL, 0x108a21e8UL, 0xe8917f0bUL,
    0x08a9b5d6UL, 0x7797adf8UL, 0x11d30431UL, 0xbecac921UL,
    0x92b35d46UL, 0x4f430a36UL, 0x24194022UL, 0xc5bca65eUL,
    0x32ec70baUL, 0x36aea8ccUL, 0x9d7bae8bUL, 0xcf2924d5UL,
    0xf3098a5aUL, 0xa6396b81UL, 0xbbde2522UL, 0xac5c1cb8UL,
    0x5eb8fe1dUL, 0x6cb3c697UL, 0xa9164f83UL, 0x13c16376UL,
    0x5719224cUL, 0x25203b35UL, 0xb53ac0feUL, 0xe366a19aUL,
    0xbdf0b24fUL, 0xa8fda998UL, 0x3ad52d71UL, 0x010896a8UL,
    0x05e6053fUL, 0x59b0d300UL, 0x2a99cbccUL, 0x465e3d40UL,

###############################################################################

TITLE
    t-class 16 sbox

TYPE
    16

DATA
    0xa3db, 0xd76e, 0x0966, 0x83d0, 0xf8be, 0x4858, 0xf611, 0xf4cf,
    0xb314, 0x212d, 0x15a2, 0x78dd, 0x99f5, 0xb1c4, 0xafed, 0xf981,
    0xe79b, 0x2daa, 0x4d40, 0x8a75, 0xce54, 0x4cd5, 0xcad5, 0x2e75,
    0x522d, 0x951a, 0xd91a, 0x1e73, 0x4e4a, 0x387c, 0x442c, 0x28b3,
    0x0a21, 0xdfb6, 0x02d4, 0xa03e, 0x1734, 0xf158, 0x6074, 0x682c,
    0x1271, 0xb7f5, 0x7a76, 0xc391, 0xe9df, 0xfab5, 0x3d04, 0x532e,
    0x96e2, 0x843b, 0x6b22, 0xba34, 0xf2a7, 0x63c8, 0x9afb, 0x1932,
    0x7c2e, 0xaee5, 0xe540, 0xf5ad, 0xf727, 0x163e, 0x6a9a, 0xa2ee,
    0x3919, 0xb68e, 0x7be1, 0x0ff9, 0xc1e9, 0x9348, 0x816a, 0x1bd0,
    0xee85, 0xb4c9, 0x1a63, 0xea16, 0xd013, 0x9186, 0x2f7b, 0xb828,
    0x559d, 0xb917, 0xdabc, 0x8541, 0x3f12, 0x4140, 0xbfc1, 0xe0cb,
    0x5a4e, 0x588d, 0x80eb, 0x5f96, 0x663f, 0x0b58, 0xd882, 0x902f,
    0x35dd, 0xd522, 0xc045, 0xa7a2, 0x33bc, 0x068a, 0x65a0, 0x6965,
    0x4515, 0x00b6, 0x9422, 0x5615, 0x6dcb, 0x985f, 0x9b67, 0x762c,
    0x9795, 0xfc94, 0xb20c, 0xc2bd, 0xb0f8, 0xfeeb, 0xdb44, 0x20f6,
    0xe1a9, 0xeb0b, 0xd6e3, 0xe4c0, 0xdd18, 0x47b7, 0x4a03, 0x1d16,
    0x42db, 0xed8f, 0x9e11, 0x6e60, 0x4950, 0x3cd9, 0xcdfa, 0x43ae,
    0x27d8, 0xd28c, 0x0765, 0xd451, 0xdedb, 0xc780, 0x67d8, 0x1868,
    0x890f, 0xcbf7, 0x303d, 0x1f5a, 0x8daa, 0xc6d9, 0x8fad, 0xaac4,
    0xc862, 0x74a3, 0xdc5a, 0xc94d, 0x5d1b, 0x5cf1, 0x3169, 0xa45c,
    0x7098, 0x88a8, 0x61a0, 0x2c66, 0x9f03, 0x0d5d, 0x2b3c, 0x8736,
    0x502f, 0x82a0, 0x540b, 0x648a, 0x267e, 0x7db9, 0x0345, 0x400d,
    0x345e, 0x4bce, 0x1cd6, 0x73fe, 0xd1b0, 0xc485, 0xfd5e, 0x3bfc,
    0xccd6, 0xfbd3, 0x7f06, 0xab01, 0xe668, 0x3ee8, 0x5ba5, 0xa56e,
    0xadce, 0x041d, 0x2313, 0x9c5f, 0x14c6, 0x51f0, 0x22e0, 0xf0f3,
    0x29d5, 0x7933, 0x7182, 0x7eef, 0xff9b, 0x8c65, 0x0e23, 0xe2c1,
    0x0c3d, 0xef61, 0xbcf8, 0x7296, 0x7581, 0x6f90, 0x37ff, 0xa145,
    0xec47, 0xd363, 0x8e13, 0x62bf, 0x8b2e, 0x8628, 0x103b, 0xe83c,
    0x08ce, 0x7782, 0x11f7, 0xbec0, 0x92ef, 0x4f2c, 0x244b, 0xc593,
    0x326b, 0x36bd, 0x9dd0, 0xcfd7, 0xf380, 0xa6f6, 0xbb4e, 0xac75,
    0x5e68, 0x6cf3, 0xa933, 0x1347, 0x570b, 0x2503, 0xb597, 0xe33c,
    0xbdef, 0xa872, 0x3a38, 0x01aa, 0x053f, 0x5991, 0x2a0e, 0x4698,

###############################################################################

TITLE
    t-class 16 hi0xE382

TYPE
    16

DATA
0x0000, 0x5788, 0xAF10, 0xF898, 0x0EF7, 0x597F, 0xA1E7, 0xF66F, 0x1DEE,
0x4A66, 0xB2FE, 0xE576, 0x1319, 0x4491, 0xBC09, 0xEB81, 0x3BDC, 0x6C54,
0x94CC, 0xC344, 0x352B, 0x62A3, 0x9A3B, 0xCDB3, 0x2632, 0x71BA, 0x8922,
0xDEAA, 0x28C5, 0x7F4D, 0x87D5, 0xD05D, 0x77B8, 0x2030, 0xD8A8, 0x8F20,
0x794F, 0x2EC7, 0xD65F, 0x81D7, 0x6A56, 0x3DDE, 0xC546, 0x92CE, 0x64A1,
0x3329, 0xCBB1, 0x9C39, 0x4C64, 0x1BEC, 0xE374, 0xB4FC, 0x4293, 0x151B,
0xED83, 0xBA0B, 0x518A, 0x0602, 0xFE9A, 0xA912, 0x5F7D, 0x08F5, 0xF06D,
0xA7E5, 0xEF70, 0xB8F8, 0x4060, 0x17E8, 0xE187, 0xB60F, 0x4E97, 0x191F,
0xF29E, 0xA516, 0x5D8E, 0x0A06, 0xFC69, 0xABE1, 0x5379, 0x04F1, 0xD4AC,
0x8324, 0x7BBC, 0x2C34, 0xDA5B, 0x8DD3, 0x754B, 0x22C3, 0xC942, 0x9ECA,
0x6652, 0x31DA, 0xC7B5, 0x903D, 0x68A5, 0x3F2D, 0x98C8, 0xCF40, 0x37D8,
0x6050, 0x963F, 0xC1B7, 0x392F, 0x6EA7, 0x8526, 0xD2AE, 0x2A36, 0x7DBE,
0x8BD1, 0xDC59, 0x24C1, 0x7349, 0xA314, 0xF49C, 0x0C04, 0x5B8C, 0xADE3,
0xFA6B, 0x02F3, 0x557B, 0xBEFA, 0xE972, 0x11EA, 0x4662, 0xB00D, 0xE785,
0x1F1D, 0x4895, 0x8E37, 0xD9BF, 0x2127, 0x76AF, 0x80C0, 0xD748, 0x2FD0,
0x7858, 0x93D9, 0xC451, 0x3CC9, 0x6B41, 0x9D2E, 0xCAA6, 0x323E, 0x65B6,
0xB5EB, 0xE263, 0x1AFB, 0x4D73, 0xBB1C, 0xEC94, 0x140C, 0x4384, 0xA805,
0xFF8D, 0x0715, 0x509D, 0xA6F2, 0xF17A, 0x09E2, 0x5E6A, 0xF98F, 0xAE07,
0x569F, 0x0117, 0xF778, 0xA0F0, 0x5868, 0x0FE0, 0xE461, 0xB3E9, 0x4B71,
0x1CF9, 0xEA96, 0xBD1E, 0x4586, 0x120E, 0xC253, 0x95DB, 0x6D43, 0x3ACB,
0xCCA4, 0x9B2C, 0x63B4, 0x343C, 0xDFBD, 0x8835, 0x70AD, 0x2725, 0xD14A,
0x86C2, 0x7E5A, 0x29D2, 0x6147, 0x36CF, 0xCE57, 0x99DF, 0x6FB0, 0x3838,
0xC0A0, 0x9728, 0x7CA9, 0x2B21, 0xD3B9, 0x8431, 0x725E, 0x25D6, 0xDD4E,
0x8AC6, 0x5A9B, 0x0D13, 0xF58B, 0xA203, 0x546C, 0x03E4, 0xFB7C, 0xACF4,
0x4775, 0x10FD, 0xE865, 0xBFED, 0x4982, 0x1E0A, 0xE692, 0xB11A, 0x16FF,
0x4177, 0xB9EF, 0xEE67, 0x1808, 0x4F80, 0xB718, 0xE090, 0x0B11, 0x5C99,
0xA401, 0xF389, 0x05E6, 0x526E, 0xAAF6, 0xFD7E, 0x2D23, 0x7AAB, 0x8233,
0xD5BB, 0x23D4, 0x745C, 0x8CC4, 0xDB4C, 0x30CD, 0x6745, 0x9FDD, 0xC855,
0x3E3A, 0x69B2, 0x912A, 0xC6A2,

###############################################################################

TITLE
    t-class 16 lo0xE382

TYPE
    16

DATA
0x0000, 0xE382, 0x97D3, 0x7451, 0x7F71, 0x9CF3, 0xE8A2, 0x0B20, 0xFEE2,
0x1D60, 0x6931, 0x8AB3, 0x8193, 0x6211, 0x1640, 0xF5C2, 0xAD13, 0x4E91,
0x3AC0, 0xD942, 0xD262, 0x31E0, 0x45B1, 0xA633, 0x53F1, 0xB073, 0xC422,
0x27A0, 0x2C80, 0xCF02, 0xBB53, 0x58D1, 0x0AF1, 0xE973, 0x9D22, 0x7EA0,
0x7580, 0x9602, 0xE253, 0x01D1, 0xF413, 0x1791, 0x63C0, 0x8042, 0x8B62,
0x68E0, 0x1CB1, 0xFF33, 0xA7E2, 0x4460, 0x3031, 0xD3B3, 0xD893, 0x3B11,
0x4F40, 0xACC2, 0x5900, 0xBA82, 0xCED3, 0x2D51, 0x2671, 0xC5F3, 0xB1A2,
0x5220, 0x15E2, 0xF660, 0x8231, 0x61B3, 0x6A93, 0x8911, 0xFD40, 0x1EC2,
0xEB00, 0x0882, 0x7CD3, 0x9F51, 0x9471, 0x77F3, 0x03A2, 0xE020, 0xB8F1,
0x5B73, 0x2F22, 0xCCA0, 0xC780, 0x2402, 0x5053, 0xB3D1, 0x4613, 0xA591,
0xD1C0, 0x3242, 0x3962, 0xDAE0, 0xAEB1, 0x4D33, 0x1F13, 0xFC91, 0x88C0,
0x6B42, 0x6062, 0x83E0, 0xF7B1, 0x1433, 0xE1F1, 0x0273, 0x7622, 0x95A0,
0x9E80, 0x7D02, 0x0953, 0xEAD1, 0xB200, 0x5182, 0x25D3, 0xC651, 0xCD71,
0x2EF3, 0x5AA2, 0xB920, 0x4CE2, 0xAF60, 0xDB31, 0x38B3, 0x3393, 0xD011,
0xA440, 0x47C2, 0x2BC4, 0xC846, 0xBC17, 0x5F95, 0x54B5, 0xB737, 0xC366,
0x20E4, 0xD526, 0x36A4, 0x42F5, 0xA177, 0xAA57, 0x49D5, 0x3D84, 0xDE06,
0x86D7, 0x6555, 0x1104, 0xF286, 0xF9A6, 0x1A24, 0x6E75, 0x8DF7, 0x7835,
0x9BB7, 0xEFE6, 0x0C64, 0x0744, 0xE4C6, 0x9097, 0x7315, 0x2135, 0xC2B7,
0xB6E6, 0x5564, 0x5E44, 0xBDC6, 0xC997, 0x2A15, 0xDFD7, 0x3C55, 0x4804,
0xAB86, 0xA0A6, 0x4324, 0x3775, 0xD4F7, 0x8C26, 0x6FA4, 0x1BF5, 0xF877,
0xF357, 0x10D5, 0x6484, 0x8706, 0x72C4, 0x9146, 0xE517, 0x0695, 0x0DB5,
0xEE37, 0x9A66, 0x79E4, 0x3E26, 0xDDA4, 0xA9F5, 0x4A77, 0x4157, 0xA2D5,
0xD684, 0x3506, 0xC0C4, 0x2346, 0x5717, 0xB495, 0xBFB5, 0x5C37, 0x2866,
0xCBE4, 0x9335, 0x70B7, 0x04E6, 0xE764, 0xEC44, 0x0FC6, 0x7B97, 0x9815,
0x6DD7, 0x8E55, 0xFA04, 0x1986, 0x12A6, 0xF124, 0x8575, 0x66F7, 0x34D7,
0xD755, 0xA304, 0x4086, 0x4BA6, 0xA824, 0xDC75, 0x3FF7, 0xCA35, 0x29B7,
0x5DE6, 0xBE64, 0xB544, 0x56C6, 0x2297, 0xC115, 0x99C4, 0x7A46, 0x0E17,
0xED95, 0xE6B5, 0x0537, 0x7166, 0x92E4, 0x6726, 0x84A4, 0xF0F5, 0x1377,
0x1857, 0xFBD5, 0x8F84, 0x6C06,

###############################################################################

TITLE
    t-class 16 hi0x673C

TYPE
    16

DATA
0x0000, 0x2ACD, 0x559A, 0x7F57, 0xAB34, 0x81F9, 0xFEAE, 0xD463, 0x06BF,
0x2C72, 0x5325, 0x79E8, 0xAD8B, 0x8746, 0xF811, 0xD2DC, 0x0D7E, 0x27B3,
0x58E4, 0x7229, 0xA64A, 0x8C87, 0xF3D0, 0xD91D, 0x0BC1, 0x210C, 0x5E5B,
0x7496, 0xA0F5, 0x8A38, 0xF56F, 0xDFA2, 0x1AFC, 0x3031, 0x4F66, 0x65AB,
0xB1C8, 0x9B05, 0xE452, 0xCE9F, 0x1C43, 0x368E, 0x49D9, 0x6314, 0xB777,
0x9DBA, 0xE2ED, 0xC820, 0x1782, 0x3D4F, 0x4218, 0x68D5, 0xBCB6, 0x967B,
0xE92C, 0xC3E1, 0x113D, 0x3BF0, 0x44A7, 0x6E6A, 0xBA09, 0x90C4, 0xEF93,
0xC55E, 0x35F8, 0x1F35, 0x6062, 0x4AAF, 0x9ECC, 0xB401, 0xCB56, 0xE19B,
0x3347, 0x198A, 0x66DD, 0x4C10, 0x9873, 0xB2BE, 0xCDE9, 0xE724, 0x3886,
0x124B, 0x6D1C, 0x47D1, 0x93B2, 0xB97F, 0xC628, 0xECE5, 0x3E39, 0x14F4,
0x6BA3, 0x416E, 0x950D, 0xBFC0, 0xC097, 0xEA5A, 0x2F04, 0x05C9, 0x7A9E,
0x5053, 0x8430, 0xAEFD, 0xD1AA, 0xFB67, 0x29BB, 0x0376, 0x7C21, 0x56EC,
0x828F, 0xA842, 0xD715, 0xFDD8, 0x227A, 0x08B7, 0x77E0, 0x5D2D, 0x894E,
0xA383, 0xDCD4, 0xF619, 0x24C5, 0x0E08, 0x715F, 0x5B92, 0x8FF1, 0xA53C,
0xDA6B, 0xF0A6, 0x6BF0, 0x413D, 0x3E6A, 0x14A7, 0xC0C4, 0xEA09, 0x955E,
0xBF93, 0x6D4F, 0x4782, 0x38D5, 0x1218, 0xC67B, 0xECB6, 0x93E1, 0xB92C,
0x668E, 0x4C43, 0x3314, 0x19D9, 0xCDBA, 0xE777, 0x9820, 0xB2ED, 0x6031,
0x4AFC, 0x35AB, 0x1F66, 0xCB05, 0xE1C8, 0x9E9F, 0xB452, 0x710C, 0x5BC1,
0x2496, 0x0E5B, 0xDA38, 0xF0F5, 0x8FA2, 0xA56F, 0x77B3, 0x5D7E, 0x2229,
0x08E4, 0xDC87, 0xF64A, 0x891D, 0xA3D0, 0x7C72, 0x56BF, 0x29E8, 0x0325,
0xD746, 0xFD8B, 0x82DC, 0xA811, 0x7ACD, 0x5000, 0x2F57, 0x059A, 0xD1F9,
0xFB34, 0x8463, 0xAEAE, 0x5E08, 0x74C5, 0x0B92, 0x215F, 0xF53C, 0xDFF1,
0xA0A6, 0x8A6B, 0x58B7, 0x727A, 0x0D2D, 0x27E0, 0xF383, 0xD94E, 0xA619,
0x8CD4, 0x5376, 0x79BB, 0x06EC, 0x2C21, 0xF842, 0xD28F, 0xADD8, 0x8715,
0x55C9, 0x7F04, 0x0053, 0x2A9E, 0xFEFD, 0xD430, 0xAB67, 0x81AA, 0x44F4,
0x6E39, 0x116E, 0x3BA3, 0xEFC0, 0xC50D, 0xBA5A, 0x9097, 0x424B, 0x6886,
0x17D1, 0x3D1C, 0xE97F, 0xC3B2, 0xBCE5, 0x9628, 0x498A, 0x6347, 0x1C10,
0x36DD, 0xE2BE, 0xC873, 0xB724, 0x9DE9, 0x4F35, 0x65F8, 0x1AAF, 0x3062,
0xE401, 0xCECC, 0xB19B, 0x9B56,

###############################################################################

TITLE
    t-class 16 lo0x673C

TYPE
    16

DATA
0x0000, 0x673C, 0xCE78, 0xA944, 0xCC27, 0xAB1B, 0x025F, 0x6563, 0xC899,
0xAFA5, 0x06E1, 0x61DD, 0x04BE, 0x6382, 0xCAC6, 0xADFA, 0xC1E5, 0xA6D9,
0x0F9D, 0x68A1, 0x0DC2, 0x6AFE, 0xC3BA, 0xA486, 0x097C, 0x6E40, 0xC704,
0xA038, 0xC55B, 0xA267, 0x0B23, 0x6C1F, 0xD31D, 0xB421, 0x1D65, 0x7A59,
0x1F3A, 0x7806, 0xD142, 0xB67E, 0x1B84, 0x7CB8, 0xD5FC, 0xB2C0, 0xD7A3,
0xB09F, 0x19DB, 0x7EE7, 0x12F8, 0x75C4, 0xDC80, 0xBBBC, 0xDEDF, 0xB9E3,
0x10A7, 0x779B, 0xDA61, 0xBD5D, 0x1419, 0x7325, 0x1646, 0x717A, 0xD83E,
0xBF02, 0xF6ED, 0x91D1, 0x3895, 0x5FA9, 0x3ACA, 0x5DF6, 0xF4B2, 0x938E,
0x3E74, 0x5948, 0xF00C, 0x9730, 0xF253, 0x956F, 0x3C2B, 0x5B17, 0x3708,
0x5034, 0xF970, 0x9E4C, 0xFB2F, 0x9C13, 0x3557, 0x526B, 0xFF91, 0x98AD,
0x31E9, 0x56D5, 0x33B6, 0x548A, 0xFDCE, 0x9AF2, 0x25F0, 0x42CC, 0xEB88,
0x8CB4, 0xE9D7, 0x8EEB, 0x27AF, 0x4093, 0xED69, 0x8A55, 0x2311, 0x442D,
0x214E, 0x4672, 0xEF36, 0x880A, 0xE415, 0x8329, 0x2A6D, 0x4D51, 0x2832,
0x4F0E, 0xE64A, 0x8176, 0x2C8C, 0x4BB0, 0xE2F4, 0x85C8, 0xE0AB, 0x8797,
0x2ED3, 0x49EF, 0xBD0D, 0xDA31, 0x7375, 0x1449, 0x712A, 0x1616, 0xBF52,
0xD86E, 0x7594, 0x12A8, 0xBBEC, 0xDCD0, 0xB9B3, 0xDE8F, 0x77CB, 0x10F7,
0x7CE8, 0x1BD4, 0xB290, 0xD5AC, 0xB0CF, 0xD7F3, 0x7EB7, 0x198B, 0xB471,
0xD34D, 0x7A09, 0x1D35, 0x7856, 0x1F6A, 0xB62E, 0xD112, 0x6E10, 0x092C,
0xA068, 0xC754, 0xA237, 0xC50B, 0x6C4F, 0x0B73, 0xA689, 0xC1B5, 0x68F1,
0x0FCD, 0x6AAE, 0x0D92, 0xA4D6, 0xC3EA, 0xAFF5, 0xC8C9, 0x618D, 0x06B1,
0x63D2, 0x04EE, 0xADAA, 0xCA96, 0x676C, 0x0050, 0xA914, 0xCE28, 0xAB4B,
0xCC77, 0x6533, 0x020F, 0x4BE0, 0x2CDC, 0x8598, 0xE2A4, 0x87C7, 0xE0FB,
0x49BF, 0x2E83, 0x8379, 0xE445, 0x4D01, 0x2A3D, 0x4F5E, 0x2862, 0x8126,
0xE61A, 0x8A05, 0xED39, 0x447D, 0x2341, 0x4622, 0x211E, 0x885A, 0xEF66,
0x429C, 0x25A0, 0x8CE4, 0xEBD8, 0x8EBB, 0xE987, 0x40C3, 0x27FF, 0x98FD,
0xFFC1, 0x5685, 0x31B9, 0x54DA, 0x33E6, 0x9AA2, 0xFD9E, 0x5064, 0x3758,
0x9E1C, 0xF920, 0x9C43, 0xFB7F, 0x523B, 0x3507, 0x5918, 0x3E24, 0x9760,
0xF05C, 0x953F, 0xF203, 0x5B47, 0x3C7B, 0x9181, 0xF6BD, 0x5FF9, 0x38C5,
0x5DA6, 0x3A9A, 0x93DE, 0xF4E2,

###############################################################################

TITLE
    Sober mul99 / t-class 8 mul0x63

TYPE
    8

DATA
  0,  99, 198, 165, 193, 162,   7, 100,
207, 172,   9, 106,  14, 109, 200, 171,
211, 176,  21, 118,  18, 113, 212, 183,
 28, 127, 218, 185, 221, 190,  27, 120,
235, 136,  45,  78,  42,  73, 236, 143,
 36,  71, 226, 129, 229, 134,  35,  64,
 56,  91, 254, 157, 249, 154,  63,  92,
247, 148,  49,  82,  54,  85, 240, 147,
155, 248,  93,  62,  90,  57, 156, 255,
 84,  55, 146, 241, 149, 246,  83,  48,
 72,  43, 142, 237, 137, 234,  79,  44,
135, 228,  65,  34,  70,  37, 128, 227,
112,  19, 182, 213, 177, 210, 119,  20,
191, 220, 121,  26, 126,  29, 184, 219,
163, 192, 101,   6,  98,   1, 164, 199,
108,  15, 170, 201, 173, 206, 107,   8,
123,  24, 189, 222, 186, 217, 124,  31,
180, 215, 114,  17, 117,  22, 179, 208,
168, 203, 110,  13, 105,  10, 175, 204,
103,   4, 161, 194, 166, 197,  96,   3,
144, 243,  86,  53,  81,  50, 151, 244,
 95,  60, 153, 250, 158, 253,  88,  59,
 67,  32, 133, 230, 130, 225,  68,  39,
140, 239,  74,  41,  77,  46, 139, 232,
224, 131,  38,  69,  33,  66, 231, 132,
 47,  76, 233, 138, 238, 141,  40,  75,
 51,  80, 245, 150, 242, 145,  52,  87,
252, 159,  58,  89,  61,  94, 251, 152,
 11, 104, 205, 174, 202, 169,  12, 111,
196, 167,   2,  97,   5, 102, 195, 160,
216, 187,  30, 125,  25, 122, 223, 188,
 23, 116, 209, 178, 214, 181,  16, 115,

###############################################################################

TITLE
    Sober mul206 / t-class 8 mul0xCE

TYPE
    8

DATA
  0, 206, 209,  31, 239,  33,  62, 240,
147,  93,  66, 140, 124, 178, 173,  99,
107, 165, 186, 116, 132,  74,  85, 155,
248,  54,  41, 231,  23, 217, 198,   8,
214,  24,   7, 201,  57, 247, 232,  38,
 69, 139, 148,  90, 170, 100, 123, 181,
189, 115, 108, 162,  82, 156, 131,  77,
 46, 224, 255,  49, 193,  15,  16, 222,
225,  47,  48, 254,  14, 192, 223,  17,
114, 188, 163, 109, 157,  83,  76, 130,
138,  68,  91, 149, 101, 171, 180, 122,
 25, 215, 200,   6, 246,  56,  39, 233,
 55, 249, 230,  40, 216,  22,   9, 199,
164, 106, 117, 187,  75, 133, 154,  84,
 92, 146, 141,  67, 179, 125,  98, 172,
207,   1,  30, 208,  32, 238, 241,  63,
143,  65,  94, 144,  96, 174, 177, 127,
 28, 210, 205,   3, 243,  61,  34, 236,
228,  42,  53, 251,  11, 197, 218,  20,
119, 185, 166, 104, 152,  86,  73, 135,
 89, 151, 136,  70, 182, 120, 103, 169,
202,   4,  27, 213,  37, 235, 244,  58,
 50, 252, 227,  45, 221,  19,  12, 194,
161, 111, 112, 190,  78, 128, 159,  81,
110, 160, 191, 113, 129,  79,  80, 158,
253,  51,  44, 226,  18, 220, 195,  13,
  5, 203, 212,  26, 234,  36,  59, 245,
150,  88,  71, 137, 121, 183, 168, 102,
184, 118, 105, 167,  87, 153, 134,  72,
 43, 229, 250,  52, 196,  10,  21, 219,
211,  29,   2, 204,  60, 242, 237,  35,
 64, 142, 145,  95, 175,  97, 126, 176,

###############################################################################

TITLE
    S1 clear and cipher family

TYPE
    8

DATA
    {129,3,5,7,2,4,6,131};
    {1,254,253,252,128,129,130,8};

###############################################################################

TITLE
    ICE ice_smod

TYPE
    32

DATA
				{333, 313, 505, 369},
				{379, 375, 319, 391},
				{361, 445, 451, 397},
				{397, 425, 395, 505}};

###############################################################################

TITLE
    ICE ice_sxor

TYPE
    32

DATA
				{0x83, 0x85, 0x9b, 0xcd},
				{0xcc, 0xa7, 0xad, 0x41},
				{0x4b, 0x2e, 0xd4, 0x33},
				{0xea, 0xcb, 0x2e, 0x04}};

###############################################################################

TITLE
    ICE ice_pbox

TYPE
    32 64

DATA
		0x00000001, 0x00000080, 0x00000400, 0x00002000,
		0x00080000, 0x00200000, 0x01000000, 0x40000000,
		0x00000008, 0x00000020, 0x00000100, 0x00004000,
		0x00010000, 0x00800000, 0x04000000, 0x20000000,
		0x00000004, 0x00000010, 0x00000200, 0x00008000,
		0x00020000, 0x00400000, 0x08000000, 0x10000000,
		0x00000002, 0x00000040, 0x00000800, 0x00001000,
		0x00040000, 0x00100000, 0x02000000, 0x80000000};

###############################################################################

TITLE
    Zodiac sbox1

TYPE
    8

DATA
 0x2d 0xf3 0x7c 0x6d 0x9d 0xb5 0x26 0x74 0xf2 0x93 0x53 0xb0 0xf0 0x11 0xed 0x83
 0x78 0xb6 0x03 0x16 0x73 0x3b 0x1e 0x8e 0x70 0xbd 0x86 0x1b 0x47 0x7e 0x24 0x56
 0xf1 0x77 0x88 0x46 0x97 0xb1 0xba 0xa3 0xb7 0x10 0x0a 0xc5 0x37 0xb3 0xc9 0x5a
 0x28 0xac 0x64 0xa5 0xec 0xab 0xaa 0xc6 0x67 0x95 0x58 0x0d 0xf8 0x9a 0xf6 0x6e
 0x66 0xdc 0x05 0x3d 0xd3 0x8a 0xc3 0xd8 0x89 0x6a 0xe9 0x36 0x49 0x43 0xbf 0xeb
 0xd4 0x96 0x9b 0x68 0xa0 0x65 0x5d 0x57 0x92 0x1f 0xd5 0x71 0x5c 0xbb 0x22 0xc1
 0xbe 0x7b 0xbc 0x99 0x63 0x94 0x5f 0x2a 0x61 0xb8 0x34 0x32 0x19 0xfd 0xfb 0x17
 0x40 0xe6 0x51 0x1d 0x41 0x44 0x8f 0x29 0xdd 0x04 0x80 0xde 0xe7 0x31 0xd6 0x7f
 0x01 0xa2 0xf7 0x39 0xda 0x6f 0x23 0xca 0xfe 0x3a 0xd0 0x1c 0xd1 0x30 0x3e 0x12
 0xa1 0xcd 0x0f 0xe0 0xa8 0xaf 0x82 0x59 0x2c 0xf5 0x7d 0xad 0xb2 0xef 0xc2 0x87
 0xce 0x75 0x06 0x13 0x02 0x90 0x4f 0x2e 0x72 0x33 0x85 0xc0 0x8d 0xcf 0xa9 0x81
 0xe2 0xc4 0x27 0x2f 0x6c 0x7a 0x9f 0x52 0xe1 0x15 0x38 0x2b 0xfc 0x20 0x42 0xc7
 0x08 0xe4 0x09 0x55 0x5e 0x8c 0x14 0x76 0x60 0xff 0xdf 0xd7 0x98 0xfa 0x0b 0x21
 0x00 0x1a 0xf9 0xa6 0xb9 0xe8 0x9e 0x62 0x4c 0xd9 0x91 0x50 0xd2 0xee 0x18 0xb4
 0x07 0x84 0xea 0x5b 0xa4 0xc8 0x0e 0xcb 0x48 0x69 0x4b 0x4e 0x9c 0x35 0x79 0x45
 0x4d 0x54 0xe5 0x25 0x3c 0x0c 0x4a 0x8b 0x3f 0xcc 0xa7 0xdb 0x6b 0xae 0xf4 0xe3

###############################################################################

TITLE
    Zodiac sbox2

TYPE
    8

DATA
    0x12 0x4a 0x26 0xc8 0xd2 0x62 0xce 0xe7
    0x2e 0xc3 0xfb 0x7c 0x65 0x48 0x8f 0xb8
    0x76 0x3d 0xa5 0x8e 0x86 0x57 0xbd 0xbc
    0x1f 0xef 0x0c 0xe0 0x78 0x71 0x11 0x75
    0x95 0xd9 0x9b 0x9e 0xb9 0xa4 0xf7 0x02
    0x7f 0x80 0x83 0x7e 0xbe 0x56 0x96 0x73
    0x9f 0x88 0x2a 0x14 0x89 0x9a 0xf9 0xdc
    0x32 0x6d 0xde 0x6a 0x84 0x72 0xd8 0x8a
    0xd7 0xe3 0x08 0x4e 0x1e 0xb3 0x5d 0x50
    /* ... the rest is not here because the PDF sux! */

###############################################################################

TITLE
    SMS4 sbox

TYPE
    8 HEX

DATA
  d6 90 e9 fe cc e1 3d b7 16 b6 14 c2 28 fb 2c 05
  2b 67 9a 76 2a be 04 c3 aa 44 13 26 49 86 06 99
  9c 42 50 f4 91 ef 98 7a 33 54 0b 43 ed cf ac 62
  e4 b3 1c a9 c9 08 e8 95 80 df 94 fa 75 8f 3f a6
  47 07 a7 fc f3 73 17 ba 83 59 3c 19 e6 85 4f a8
  68 6b 81 b2 71 64 da 8b f8 eb 0f 4b 70 56 9d 35
  1e 24 0e 5e 63 58 d1 a2 25 22 7c 3b 01 21 78 87
  d4 00 46 57 9f d3 27 52 4c 36 02 e7 a0 c4 c8 9e
  ea bf 8a d2 40 c7 38 b5 a3 f7 f2 ce f9 61 15 a1
  e0 ae 5d a4 9b 34 1a 55 ad 93 32 30 f5 8c b1 e3
  1d f6 e2 2e 82 66 ca 60 c0 29 23 ab 0d 53 4e 6f
  d5 db 37 45 de fd 8e 2f 03 ff 6a 72 6d 6c 5b 51
  8d 1b af 92 bb dd bc 7f 11 d9 5c 41 1f 10 5a d8
  0a c1 31 88 a5 cd 7b bd 2d 74 d0 12 b8 e5 b4 b0
  89 69 97 4a 0c 96 77 7e 65 b9 f1 09 c5 6e c6 84
  18 f0 7d ec 3a dc 4d 20 79 ee 5f 3e d7 cb 39 48

###############################################################################

TITLE
    Zodiac SS1

TYPE
    16

DATA
0x1200, 0x4a00, 0x2600, 0xc800, 0xd200, 0x6200, 0xce00, 0xe700, 0x2e00, 0xc300, 0xfb00, 0x7c00,
0x6500, 0x4800, 0x8f00, 0xb800, 0x7600, 0x3d00, 0xa500, 0x8e00, 0x8600, 0x5700, 0xbd00, 0xbc00,
0x1f00, 0xef00, 0x0c00, 0xe000, 0x7800, 0x7100, 0x1100, 0x7500, 0x9500, 0xd900, 0x9b00, 0x9e00,
0xb900, 0xa400, 0xf700, 0x0200, 0x7f00, 0x8000, 0x8300, 0x7e00, 0xbe00, 0x5600, 0x9600, 0x7300,
0x9f00, 0x8800, 0x2a00, 0x1400, 0x8900, 0x9a00, 0xf900, 0xdc00, 0x3200, 0x6d00, 0xde00, 0x6a00,
0x8400, 0x7200, 0xd800, 0x8a00, 0xd700, 0xe300, 0x0800, 0x4e00, 0x1e00, 0xb300, 0x5d00, 0x5000,
0xd600, 0xeb00, 0xb100, 0x0d00, 0xcf00, 0xad00, 0xc600, 0x0e00, 0x7d00, 0xa000, 0xdd00, 0x9c00,
0x4100, 0x1c00, 0xcd00, 0x1a00, 0x3800, 0x3400, 0x5b00, 0x2300, 0x0300, 0x8c00, 0x6800, 0x4600,
0x5300, 0x0400, 0xa900, 0x2700, 0xac00, 0xe600, 0x1b00, 0xfc00, 0x2f00, 0xa300, 0x0b00, 0x2800,
0xe400, 0x0f00, 0xda00, 0xd400, 0xc400, 0xd500, 0x9400, 0x8b00, 0x9000, 0x6b00, 0x9d00, 0xf800,
0xae00, 0x6300, 0x7a00, 0x0700, 0xe200, 0xea00, 0xc500, 0xdb00, 0x9800, 0x1500, 0xc100, 0x0a00,
0xa200, 0xc200, 0x3000, 0x4400, 0x5a00, 0xf100, 0x3a00, 0x6e00, 0xa800, 0xc900, 0x5500, 0x4d00,
0x2000, 0x6f00, 0xf200, 0x3500, 0x5900, 0x1900, 0x7700, 0xbb00, 0x9200, 0x6c00, 0x2c00, 0x4500,
0x6600, 0x4200, 0xf300, 0x3900, 0x2900, 0xc000, 0xe800, 0x4f00, 0xe500, 0xc700, 0xb000, 0xe100,
0x8d00, 0xf600, 0x0000, 0x0100, 0x7b00, 0xd100, 0xcb00, 0x5200, 0xfd00, 0xcc00, 0x5800, 0x3f00,
0xee00, 0xb200, 0xff00, 0x4000, 0xaa00, 0x4b00, 0x7400, 0xb400, 0x6000, 0x5f00, 0x9900, 0x2b00,
0x9100, 0xdf00, 0xf400, 0x4700, 0x2100, 0x3b00, 0x3300, 0x9300, 0xaf00, 0xd300, 0x1600, 0x5e00,
0x3600, 0x4300, 0x4900, 0xa600, 0xd000, 0x0600, 0xb600, 0x7000, 0x8100, 0x8200, 0xa100, 0xfa00,
0x9700, 0x8500, 0x7900, 0xb700, 0xba00, 0x3c00, 0x1000, 0xb500, 0xab00, 0x1300, 0xa700, 0x6400,
0xe900, 0x0900, 0x5400, 0x2500, 0x3700, 0x6700, 0x1d00, 0xfe00, 0xf500, 0x6900, 0x2d00, 0x3100,
0x2200, 0xf000, 0x1800, 0x3e00, 0x6100, 0x1700, 0x5100, 0xec00, 0x0500, 0xca00, 0xed00, 0x5c00,
0x8700, 0xbf00, 0x4c00, 0x2400

###############################################################################

TITLE
    Zodiac SS2

TYPE
    32

DATA
0x2d0000, 0xf30000, 0x7c0000, 0x6d0000, 0x9d0000, 0xb50000, 0x260000, 0x740000, 0xf20000, 0x930000, 0x530000, 0xb00000,
0xf00000, 0x110000, 0xed0000, 0x830000, 0x780000, 0xb60000, 0x030000, 0x160000, 0x730000, 0x3b0000, 0x1e0000, 0x8e0000,
0x700000, 0xbd0000, 0x860000, 0x1b0000, 0x470000, 0x7e0000, 0x240000, 0x560000, 0xf10000, 0x770000, 0x880000, 0x460000,
0x970000, 0xb10000, 0xba0000, 0xa30000, 0xb70000, 0x100000, 0x0a0000, 0xc50000, 0x370000, 0xb30000, 0xc90000, 0x5a0000,
0x280000, 0xac0000, 0x640000, 0xa50000, 0xec0000, 0xab0000, 0xaa0000, 0xc60000, 0x670000, 0x950000, 0x580000, 0x0d0000,
0xf80000, 0x9a0000, 0xf60000, 0x6e0000, 0x660000, 0xdc0000, 0x050000, 0x3d0000, 0xd30000, 0x8a0000, 0xc30000, 0xd80000,
0x890000, 0x6a0000, 0xe90000, 0x360000, 0x490000, 0x430000, 0xbf0000, 0xeb0000, 0xd40000, 0x960000, 0x9b0000, 0x680000,
0xa00000, 0x650000, 0x5d0000, 0x570000, 0x920000, 0x1f0000, 0xd50000, 0x710000, 0x5c0000, 0xbb0000, 0x220000, 0xc10000,
0xbe0000, 0x7b0000, 0xbc0000, 0x990000, 0x630000, 0x940000, 0x5f0000, 0x2a0000, 0x610000, 0xb80000, 0x340000, 0x320000,
0x190000, 0xfd0000, 0xfb0000, 0x170000, 0x400000, 0xe60000, 0x510000, 0x1d0000, 0x410000, 0x440000, 0x8f0000, 0x290000,
0xdd0000, 0x040000, 0x800000, 0xde0000, 0xe70000, 0x310000, 0xd60000, 0x7f0000, 0x010000, 0xa20000, 0xf70000, 0x390000,
0xda0000, 0x6f0000, 0x230000, 0xca0000, 0xfe0000, 0x3a0000, 0xd00000, 0x1c0000, 0xd10000, 0x300000, 0x3e0000, 0x120000,
0xa10000, 0xcd0000, 0x0f0000, 0xe00000, 0xa80000, 0xaf0000, 0x820000, 0x590000, 0x2c0000, 0xf50000, 0x7d0000, 0xad0000,
0xb20000, 0xef0000, 0xc20000, 0x870000, 0xce0000, 0x750000, 0x060000, 0x130000, 0x020000, 0x900000, 0x4f0000, 0x2e0000,
0x720000, 0x330000, 0x850000, 0xc00000, 0x8d0000, 0xcf0000, 0xa90000, 0x810000, 0xe20000, 0xc40000, 0x270000, 0x2f0000,
0x6c0000, 0x7a0000, 0x9f0000, 0x520000, 0xe10000, 0x150000, 0x380000, 0x2b0000, 0xfc0000, 0x200000, 0x420000, 0xc70000,
0x080000, 0xe40000, 0x090000, 0x550000, 0x5e0000, 0x8c0000, 0x140000, 0x760000, 0x600000, 0xff0000, 0xdf0000, 0xd70000,
0x980000, 0xfa0000, 0x0b0000, 0x210000, 0x000000, 0x1a0000, 0xf90000, 0xa60000, 0xb90000, 0xe80000, 0x9e0000, 0x620000,
0x4c0000, 0xd90000, 0x910000, 0x500000, 0xd20000, 0xee0000, 0x180000, 0xb40000, 0x070000, 0x840000, 0xea0000, 0x5b0000,
0xa40000, 0xc80000, 0x0e0000, 0xcb0000, 0x480000, 0x690000, 0x4b0000, 0x4e0000, 0x9c0000, 0x350000, 0x790000, 0x450000,
0x4d0000, 0x540000, 0xe50000, 0x250000, 0x3c0000, 0x0c0000, 0x4a0000, 0x8b0000, 0x3f0000, 0xcc0000, 0xa70000, 0xdb0000,
0x6b0000, 0xae0000, 0xf40000, 0xe30000

###############################################################################

TITLE
    Zodiac SS3

TYPE
    32

DATA
0x12000000, 0x4a000000, 0x26000000, 0xc8000000, 0xd2000000, 0x62000000, 0xce000000, 0xe7000000, 0x2e000000, 0xc3000000, 0xfb000000,
0x7c000000,
0x65000000, 0x48000000, 0x8f000000, 0xb8000000, 0x76000000, 0x3d000000, 0xa5000000, 0x8e000000, 0x86000000, 0x57000000, 0xbd000000,
0xbc000000,
0x1f000000, 0xef000000, 0x0c000000, 0xe0000000, 0x78000000, 0x71000000, 0x11000000, 0x75000000, 0x95000000, 0xd9000000, 0x9b000000,
0x9e000000,
0xb9000000, 0xa4000000, 0xf7000000, 0x02000000, 0x7f000000, 0x80000000, 0x83000000, 0x7e000000, 0xbe000000, 0x56000000, 0x96000000,
0x73000000,
0x9f000000, 0x88000000, 0x2a000000, 0x14000000, 0x89000000, 0x9a000000, 0xf9000000, 0xdc000000, 0x32000000, 0x6d000000, 0xde000000,
0x6a000000,
0x84000000, 0x72000000, 0xd8000000, 0x8a000000, 0xd7000000, 0xe3000000, 0x08000000, 0x4e000000, 0x1e000000, 0xb3000000, 0x5d000000,
0x50000000,
0xd6000000, 0xeb000000, 0xb1000000, 0x0d000000, 0xcf000000, 0xad000000, 0xc6000000, 0x0e000000, 0x7d000000, 0xa0000000, 0xdd000000,
0x9c000000,
0x41000000, 0x1c000000, 0xcd000000, 0x1a000000, 0x38000000, 0x34000000, 0x5b000000, 0x23000000, 0x03000000, 0x8c000000, 0x68000000,
0x46000000,
0x53000000, 0x04000000, 0xa9000000, 0x27000000, 0xac000000, 0xe6000000, 0x1b000000, 0xfc000000, 0x2f000000, 0xa3000000, 0x0b000000,
0x28000000,
0xe4000000, 0x0f000000, 0xda000000, 0xd4000000, 0xc4000000, 0xd5000000, 0x94000000, 0x8b000000, 0x90000000, 0x6b000000, 0x9d000000,
0xf8000000,
0xae000000, 0x63000000, 0x7a000000, 0x07000000, 0xe2000000, 0xea000000, 0xc5000000, 0xdb000000, 0x98000000, 0x15000000, 0xc1000000,
0x0a000000,
0xa2000000, 0xc2000000, 0x30000000, 0x44000000, 0x5a000000, 0xf1000000, 0x3a000000, 0x6e000000, 0xa8000000, 0xc9000000, 0x55000000,
0x4d000000,
0x20000000, 0x6f000000, 0xf2000000, 0x35000000, 0x59000000, 0x19000000, 0x77000000, 0xbb000000, 0x92000000, 0x6c000000, 0x2c000000,
0x45000000,
0x66000000, 0x42000000, 0xf3000000, 0x39000000, 0x29000000, 0xc0000000, 0xe8000000, 0x4f000000, 0xe5000000, 0xc7000000, 0xb0000000,
0xe1000000,
0x8d000000, 0xf6000000, 0x00000000, 0x01000000, 0x7b000000, 0xd1000000, 0xcb000000, 0x52000000, 0xfd000000, 0xcc000000, 0x58000000,
0x3f000000,
0xee000000, 0xb2000000, 0xff000000, 0x40000000, 0xaa000000, 0x4b000000, 0x74000000, 0xb4000000, 0x60000000, 0x5f000000, 0x99000000,
0x2b000000,
0x91000000, 0xdf000000, 0xf4000000, 0x47000000, 0x21000000, 0x3b000000, 0x33000000, 0x93000000, 0xaf000000, 0xd3000000, 0x16000000,
0x5e000000,
0x36000000, 0x43000000, 0x49000000, 0xa6000000, 0xd0000000, 0x06000000, 0xb6000000, 0x70000000, 0x81000000, 0x82000000, 0xa1000000,
0xfa000000,
0x97000000, 0x85000000, 0x79000000, 0xb7000000, 0xba000000, 0x3c000000, 0x10000000, 0xb5000000, 0xab000000, 0x13000000, 0xa7000000,
0x64000000,
0xe9000000, 0x09000000, 0x54000000, 0x25000000, 0x37000000, 0x67000000, 0x1d000000, 0xfe000000, 0xf5000000, 0x69000000, 0x2d000000,
0x31000000,
0x22000000, 0xf0000000, 0x18000000, 0x3e000000, 0x61000000, 0x17000000, 0x51000000, 0xec000000, 0x05000000, 0xca000000, 0xed000000,
0x5c000000,
0x87000000, 0xbf000000, 0x4c000000, 0x24000000

###############################################################################

TITLE
    DVB scrambling algorithm sbox

TYPE
    8

DATA
 0x3A 0xEA 0x68 0xFE 0x33 0xE9 0x88 0x1A 0x83 0xCF 0xE1 0x7F 0xBA 0xE2 0x38 0x12
 0xE8 0x27 0x61 0x95 0x0C 0x36 0xE5 0x70 0xA2 0x06 0x82 0x7C 0x17 0xA3 0x26 0x49
 0xBE 0x7A 0x6D 0x47 0xC1 0x51 0x8F 0xF3 0xCC 0x5B 0x67 0xBD 0xCD 0x18 0x08 0xC9
 0xFF 0x69 0xEF 0x03 0x4E 0x48 0x4A 0x84 0x3F 0xB4 0x10 0x04 0xDC 0xF5 0x5C 0xC6
 0x16 0xAB 0xAC 0x4C 0xF1 0x6A 0x2F 0x3C 0x3B 0xD4 0xD5 0x94 0xD0 0xC4 0x63 0x62
 0x71 0xA1 0xF9 0x4F 0x2E 0xAA 0xC5 0x56 0xE3 0x39 0x93 0xCE 0x65 0x64 0xE4 0x58
 0x6C 0x19 0x42 0x79 0xDD 0xEE 0x96 0xF6 0x8A 0xEC 0x1E 0x85 0x53 0x45 0xDE 0xBB
 0x7E 0x0A 0x9A 0x13 0x2A 0x9D 0xC2 0x5E 0x5A 0x1F 0x32 0x35 0x9C 0xA8 0x73 0x30
 0x29 0x3D 0xE7 0x92 0x87 0x1B 0x2B 0x4B 0xA5 0x57 0x97 0x40 0x15 0xE6 0xBC 0x0E
 0xEB 0xC3 0x34 0x2D 0xB8 0x44 0x25 0xA4 0x1C 0xC7 0x23 0xED 0x90 0x6E 0x50 0x00
 0x99 0x9E 0x4D 0xD9 0xDA 0x8D 0x6F 0x5F 0x3E 0xD7 0x21 0x74 0x86 0xDF 0x6B 0x05
 0x8E 0x5D 0x37 0x11 0xD2 0x28 0x75 0xD6 0xA7 0x77 0x24 0xBF 0xF0 0xB0 0x02 0xB7
 0xF8 0xFC 0x81 0x09 0xB1 0x01 0x76 0x91 0x7D 0x0F 0xC8 0xA0 0xF2 0xCB 0x78 0x60
 0xD1 0xF7 0xE0 0xB5 0x98 0x22 0xB3 0x20 0x1D 0xA6 0xDB 0x7B 0x59 0x9F 0xAE 0x31
 0xFB 0xD3 0xB6 0xCA 0x43 0x72 0x07 0xF4 0xD8 0x41 0x14 0x55 0x0D 0x54 0x8B 0xB9
 0xAD 0x46 0x0B 0xAF 0x80 0x52 0x2C 0xFA 0x8C 0x89 0x66 0xFD 0xB2 0xA9 0x9B 0xC0

###############################################################################

TITLE
    DVB scrambling algorithm permutation

TYPE
    8

DATA
    17 35 8 6 41 48 28 20 27 53 61 49 18 32 58 63
    23 19 36 38 1 52 26 0 33 3 12 13 56 39 25 40
    50 34 51 11 21 47 29 57 44 30 7 24 22 46 60 16
    59 4 55 42 10 5 9 43 31 62 45 14 2 37 15 54

###############################################################################

TITLE
    RealAudio ATRC huffcode6

TYPE
    8

DATA
  0x0,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0x14,0x15,0x16,0x17,0x18,0x19,0x34,0x35,
  0x36,0x37,0x38,0x39,0x3A,0x3B,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,

###############################################################################

TITLE
    RealAudio ATRC huffcode7

TYPE
    8

DATA
  0x0,0x2,0x3,0x8,0x9,0xA,0xB,0xC,0xD,0xE,0xF,0x10,0x11,0x24,0x25,0x26,0x27,0x28,
  0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33,0x68,0x69,0x6A,0x6B,0x6C,
  0x6D,0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,0xEC,0xED,0xEE,0xEF,0xF0,0xF1,0xF2,
  0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,

###############################################################################

TITLE
    Smacker palmap

TYPE
    8

DATA
   0x00, 0x04, 0x08, 0x0C, 0x10, 0x14, 0x18, 0x1C,
   0x20, 0x24, 0x28, 0x2C, 0x30, 0x34, 0x38, 0x3C,
   0x41, 0x45, 0x49, 0x4D, 0x51, 0x55, 0x59, 0x5D,
   0x61, 0x65, 0x69, 0x6D, 0x71, 0x75, 0x79, 0x7D,
   0x82, 0x86, 0x8A, 0x8E, 0x92, 0x96, 0x9A, 0x9E,
   0xA2, 0xA6, 0xAA, 0xAE, 0xB2, 0xB6, 0xBA, 0xBE,
   0xC3, 0xC7, 0xCB, 0xCF, 0xD3, 0xD7, 0xDB, 0xDF,
   0xE3, 0xE7, 0xEB, 0xEF, 0xF3, 0xF7, 0xFB, 0xFF

###############################################################################

TITLE
    Smacker sizetable

TYPE
    32

DATA
                  1,    2,    3,    4,    5,    6,    7,    8,
                  9,   10,   11,   12,   13,   14,   15,   16,
                 17,   18,   19,   20,   21,   22,   23,   24,
                 25,   26,   27,   28,   29,   30,   31,   32,
                 33,   34,   35,   36,   37,   38,   39,   40,
                 41,   42,   43,   44,   45,   46,   47,   48,
                 49,   50,   51,   52,   53,   54,   55,   56,
                 57,   58,   59,  128,  256,  512, 1024, 2048};

###############################################################################

TITLE
    VC1 transform_matrix_8x8

TYPE
    8, 32

DATA
   {  12,  12,  12,  12,  12,  12,  12,  12 },
   {  16,  15,   9,   4,  -4,  -9, -15, -16 },
   {  16,   6,  -6, -16, -16,  -6,   6,  16 },
   {  15,  -4, -16,  -9,   9,  16,   4, -15 },
   {  12, -12, -12,  12,  12, -12, -12,  12 },
   {   9, -16,   4,  15, -15,  -4,  16,  -9 },
   {   6, -16,  16,  -6,  -6,  16, -16,   6 },
   {   4,  -9,  15, -16,  16, -15,   9,  -4 }

###############################################################################

TITLE
    VC1 transform_matrix_4x4

TYPE
    8, 32

DATA
   {  17,  17,  17,  17 },
   {  22,  10, -10, -22 },
   {  17, -17, -17,  17 },
   {  10, -22,  22, -10 }

###############################################################################

TITLE
    VC1 non_uniform_implicit_quantizers

TYPE
    8, 32

DATA
    0,  0,  0,  0,  0,  0,  0,  0,
    0,  6,  7,  8,  9, 10, 11, 12,
   13, 14, 15, 16, 17, 18, 19, 20,
   21, 22, 23, 24, 25, 27, 29, 31

###############################################################################

TITLE
    VC1 1 <= PQuant <= 7

TYPE
    8, 32

DATA
    {0, 11, 5},
    {1, 3, 1},
    {2, 3, 2},
    {3, 3, 3},
    {4, 3, 4},
    {5, 3, 5},
    {6, 3, 6},
    {7, 3, 7},
    {0, 5, 8},
    {1, 5, 9},
    {2, 5, 10},
    {3, 5, 11}

###############################################################################

TITLE
    VC1 8 <= PQuant <= 31

TYPE
    8, 32

DATA
    {0, 7, 6}, 
    {1, 1, 2},
    {1, 2, 3},
    {1, 3, 4},
    {1, 4, 5},
    {1, 5, 6},
    {1, 6, 7},
    {0, 6, 8}

###############################################################################

TITLE
    Electronic Arts TQI base_table2

TYPE
    8, 32

DATA
    8, 16, 19, 22, 26, 27, 29, 34,
   16, 16, 22, 24, 27, 29, 34, 37,
   19, 22, 26, 27, 29, 34, 34, 38,
   22, 22, 26, 27, 29, 34, 37, 40,
   22, 26, 27, 29, 32, 35, 40, 48,
   26, 27, 29, 32, 35, 40, 48, 58,
   26, 27, 29, 34, 38, 46, 56, 69,
   27, 29, 35, 38, 46, 56, 69, 83,

###############################################################################

TITLE
    Sine table

TYPE
    8, 32

DATA
        128,131,134,137,140,143,146,149,152,156,159,162,165,168,171,174,
        176,179,182,185,188,191,193,196,199,201,204,206,209,211,213,216,
        218,220,222,224,226,228,230,232,234,236,237,239,240,242,243,245,
        246,247,248,249,250,251,252,252,253,254,254,255,255,255,255,255,
        255,255,255,255,255,255,254,254,253,252,252,251,250,249,248,247,
        246,245,243,242,240,239,237,236,234,232,230,228,226,224,222,220,
        218,216,213,211,209,206,204,201,199,196,193,191,188,185,182,179,
        176,174,171,168,165,162,159,156,152,149,146,143,140,137,134,131,
        128,124,121,118,115,112,109,106,103,99, 96, 93, 90, 87, 84, 81, 
        79, 76, 73, 70, 67, 64, 62, 59, 56, 54, 51, 49, 46, 44, 42, 39, 
        37, 35, 33, 31, 29, 27, 25, 23, 21, 19, 18, 16, 15, 13, 12, 10, 
        9,  8,  7,  6,  5,  4,  3,  3,  2,  1,  1,  0,  0,  0,  0,  0,  
        0,  0,  0,  0,  0,  0,  1,  1,  2,  3,  3,  4,  5,  6,  7,  8,  
        9,  10, 12, 13, 15, 16, 18, 19, 21, 23, 25, 27, 29, 31, 33, 35, 
        37, 39, 42, 44, 46, 49, 51, 54, 56, 59, 62, 64, 67, 70, 73, 76, 
        79, 81, 84, 87, 90, 93, 96, 99, 103,106,109,112,115,118,121,124

################################################################################

TITLE
    PSCHF - Pukall Stream Cipher Hash Function

TYPE
    8

DATA
    "Remsaalps!123456"

################################################################################

TITLE
    Snefru S box 0

TYPE
    32

DATA
	0x64F9001B, /*  0  */
	0xFEDDCDF6, /*  1  */
	0x7C8FF1E2, /*  2  */
	0x11D71514, /*  3  */
	0x8B8C18D3, /*  4  */
	0xDDDF881E, /*  5  */
	0x6EAB5056, /*  6  */
	0x88CED8E1, /*  7  */
	0x49148959, /*  8  */
	0x69C56FD5, /*  9  */
	0xB7994F03, /*  10  */
	0x0FBCEE3E, /*  11  */
	0x3C264940, /*  12  */
	0x21557E58, /*  13  */
	0xE14B3FC2, /*  14  */
	0x2E5CF591, /*  15  */
	0xDCEFF8CE, /*  16  */
	0x092A1648, /*  17  */
	0xBE812936, /*  18  */
	0xFF7B0C6A, /*  19  */
	0xD5251037, /*  20  */
	0xAFA448F1, /*  21  */
	0x7DAFC95A, /*  22  */
	0x1EA69C3F, /*  23  */
	0xA417ABE7, /*  24  */
	0x5890E423, /*  25  */
	0xB0CB70C0, /*  26  */
	0xC85025F7, /*  27  */
	0x244D97E3, /*  28  */
	0x1FF3595F, /*  29  */
	0xC4EC6396, /*  30  */
	0x59181E17, /*  31  */
	0xE635B477, /*  32  */
	0x354E7DBF, /*  33  */
	0x796F7753, /*  34  */
	0x66EB52CC, /*  35  */
	0x77C3F995, /*  36  */
	0x32E3A927, /*  37  */
	0x80CCAED6, /*  38  */
	0x4E2BE89D, /*  39  */
	0x375BBD28, /*  40  */
	0xAD1A3D05, /*  41  */
	0x2B1B42B3, /*  42  */
	0x16C44C71, /*  43  */
	0x4D54BFA8, /*  44  */
	0xE57DDC7A, /*  45  */
	0xEC6D8144, /*  46  */
	0x5A71046B, /*  47  */
	0xD8229650, /*  48  */
	0x87FC8F24, /*  49  */
	0xCBC60E09, /*  50  */
	0xB6390366, /*  51  */
	0xD9F76092, /*  52  */
	0xD393A70B, /*  53  */
	0x1D31A08A, /*  54  */
	0x9CD971C9, /*  55  */
	0x5C1EF445, /*  56  */
	0x86FAB694, /*  57  */
	0xFDB44165, /*  58  */
	0x8EAAFCBE, /*  59  */
	0x4BCAC6EB, /*  60  */
	0xFB7A94E5, /*  61  */
	0x5789D04E, /*  62  */
	0xFA13CF35, /*  63  */
	0x236B8DA9, /*  64  */
	0x4133F000, /*  65  */
	0x6224261C, /*  66  */
	0xF412F23B, /*  67  */
	0xE75E56A4, /*  68  */
	0x30022116, /*  69  */
	0xBAF17F1F, /*  70  */
	0xD09872F9, /*  71  */
	0xC1A3699C, /*  72  */
	0xF1E802AA, /*  73  */
	0x0DD145DC, /*  74  */
	0x4FDCE093, /*  75  */
	0x8D8412F0, /*  76  */
	0x6CD0F376, /*  77  */
	0x3DE6B73D, /*  78  */
	0x84BA737F, /*  79  */
	0xB43A30F2, /*  80  */
	0x44569F69, /*  81  */
	0x00E4EACA, /*  82  */
	0xB58DE3B0, /*  83  */
	0x959113C8, /*  84  */
	0xD62EFEE9, /*  85  */
	0x90861F83, /*  86  */
	0xCED69874, /*  87  */
	0x2F793CEE, /*  88  */
	0xE8571C30, /*  89  */
	0x483665D1, /*  90  */
	0xAB07B031, /*  91  */
	0x914C844F, /*  92  */
	0x15BF3BE8, /*  93  */
	0x2C3F2A9A, /*  94  */
	0x9EB95FD4, /*  95  */
	0x92E7472D, /*  96  */
	0x2297CC5B, /*  97  */
	0xEE5F2782, /*  98  */
	0x5377B562, /*  99  */
	0xDB8EBBCF, /*  100  */
	0xF961DEDD, /*  101  */
	0xC59B5C60, /*  102  */
	0x1BD3910D, /*  103  */
	0x26D206AD, /*  104  */
	0xB28514D8, /*  105  */
	0x5ECF6B52, /*  106  */
	0x7FEA78BB, /*  107  */
	0x504879AC, /*  108  */
	0xED34A884, /*  109  */
	0x36E51D3C, /*  110  */
	0x1753741D, /*  111  */
	0x8C47CAED, /*  112  */
	0x9D0A40EF, /*  113  */
	0x3145E221, /*  114  */
	0xDA27EB70, /*  115  */
	0xDF730BA3, /*  116  */
	0x183C8789, /*  117  */
	0x739AC0A6, /*  118  */
	0x9A58DFC6, /*  119  */
	0x54B134C1, /*  120  */
	0xAC3E242E, /*  121  */
	0xCC493902, /*  122  */
	0x7B2DDA99, /*  123  */
	0x8F15BC01, /*  124  */
	0x29FD38C7, /*  125  */
	0x27D5318F, /*  126  */
	0x604AAFF5, /*  127  */
	0xF29C6818, /*  128  */
	0xC38AA2EC, /*  129  */
	0x1019D4C3, /*  130  */
	0xA8FB936E, /*  131  */
	0x20ED7B39, /*  132  */
	0x0B686119, /*  133  */
	0x89A0906F, /*  134  */
	0x1CC7829E, /*  135  */
	0x9952EF4B, /*  136  */
	0x850E9E8C, /*  137  */
	0xCD063A90, /*  138  */
	0x67002F8E, /*  139  */
	0xCFAC8CB7, /*  140  */
	0xEAA24B11, /*  141  */
	0x988B4E6C, /*  142  */
	0x46F066DF, /*  143  */
	0xCA7EEC08, /*  144  */
	0xC7BBA664, /*  145  */
	0x831D17BD, /*  146  */
	0x63F575E6, /*  147  */
	0x9764350E, /*  148  */
	0x47870D42, /*  149  */
	0x026CA4A2, /*  150  */
	0x8167D587, /*  151  */
	0x61B6ADAB, /*  152  */
	0xAA6564D2, /*  153  */
	0x70DA237B, /*  154  */
	0x25E1C74A, /*  155  */
	0xA1C901A0, /*  156  */
	0x0EB0A5DA, /*  157  */
	0x7670F741, /*  158  */
	0x51C05AEA, /*  159  */
	0x933DFA32, /*  160  */
	0x0759FF1A, /*  161  */
	0x56010AB8, /*  162  */
	0x5FDECB78, /*  163  */
	0x3F32EDF8, /*  164  */
	0xAEBEDBB9, /*  165  */
	0x39F8326D, /*  166  */
	0xD20858C5, /*  167  */
	0x9B638BE4, /*  168  */
	0xA572C80A, /*  169  */
	0x28E0A19F, /*  170  */
	0x432099FC, /*  171  */
	0x3A37C3CD, /*  172  */
	0xBF95C585, /*  173  */
	0xB392C12A, /*  174  */
	0x6AA707D7, /*  175  */
	0x52F66A61, /*  176  */
	0x12D483B1, /*  177  */
	0x96435B5E, /*  178  */
	0x3E75802B, /*  179  */
	0x3BA52B33, /*  180  */
	0xA99F51A5, /*  181  */
	0xBDA1E157, /*  182  */
	0x78C2E70C, /*  183  */
	0xFCAE7CE0, /*  184  */
	0xD1602267, /*  185  */
	0x2AFFAC4D, /*  186  */
	0x4A510947, /*  187  */
	0x0AB2B83A, /*  188  */
	0x7A04E579, /*  189  */
	0x340DFD80, /*  190  */
	0xB916E922, /*  191  */
	0xE29D5E9B, /*  192  */
	0xF5624AF4, /*  193  */
	0x4CA9D9AF, /*  194  */
	0x6BBD2CFE, /*  195  */
	0xE3B7F620, /*  196  */
	0xC2746E07, /*  197  */
	0x5B42B9B6, /*  198  */
	0xA06919BC, /*  199  */
	0xF0F2C40F, /*  200  */
	0x72217AB5, /*  201  */
	0x14C19DF3, /*  202  */
	0xF3802DAE, /*  203  */
	0xE094BEB4, /*  204  */
	0xA2101AFF, /*  205  */
	0x0529575D, /*  206  */
	0x55CDB27C, /*  207  */
	0xA33BDDB2, /*  208  */
	0x6528B37D, /*  209  */
	0x740C05DB, /*  210  */
	0xE96A62C4, /*  211  */
	0x40782846, /*  212  */
	0x6D30D706, /*  213  */
	0xBBF48E2C, /*  214  */
	0xBCE2D3DE, /*  215  */
	0x049E37FA, /*  216  */
	0x01B5E634, /*  217  */
	0x2D886D8D, /*  218  */
	0x7E5A2E7E, /*  219  */
	0xD7412013, /*  220  */
	0x06E90F97, /*  221  */
	0xE45D3EBA, /*  222  */
	0xB8AD3386, /*  223  */
	0x13051B25, /*  224  */
	0x0C035354, /*  225  */
	0x71C89B75, /*  226  */
	0xC638FBD0, /*  227  */
	0x197F11A1, /*  228  */
	0xEF0F08FB, /*  229  */
	0xF8448651, /*  230  */
	0x38409563, /*  231  */
	0x452F4443, /*  232  */
	0x5D464D55, /*  233  */
	0x03D8764C, /*  234  */
	0xB1B8D638, /*  235  */
	0xA70BBA2F, /*  236  */
	0x94B3D210, /*  237  */
	0xEB6692A7, /*  238  */
	0xD409C2D9, /*  239  */
	0x68838526, /*  240  */
	0xA6DB8A15, /*  241  */
	0x751F6C98, /*  242  */
	0xDE769A88, /*  243  */
	0xC9EE4668, /*  244  */
	0x1A82A373, /*  245  */
	0x0896AA49, /*  246  */
	0x42233681, /*  247  */
	0xF62C55CB, /*  248  */
	0x9F1C5404, /*  249  */
	0xF74FB15C, /*  250  */
	0xC06E4312, /*  251  */
	0x6FFE5D72, /*  252  */
	0x8AA8678B, /*  253  */
	0x337CD129, /*  254  */
	0x8211CEFD  /*  255  */

################################################################################

TITLE
    Snefru S box 1

TYPE
    32

DATA
	0x074A1D09, /*  0  */
	0x52A10E5A, /*  1  */
	0x9275A3F8, /*  2  */
	0x4B82506C, /*  3  */
	0x37DF7E1B, /*  4  */
	0x4C78B3C5, /*  5  */
	0xCEFAB1DA, /*  6  */
	0xF472267E, /*  7  */
	0xB63045F6, /*  8  */
	0xD66A1FC0, /*  9  */
	0x400298E3, /*  10  */
	0x27E60C94, /*  11  */
	0x87D2F1B8, /*  12  */
	0xDF9E56CC, /*  13  */
	0x45CD1803, /*  14  */
	0x1D35E098, /*  15  */
	0xCCE7C736, /*  16  */
	0x03483BF1, /*  17  */
	0x1F7307D7, /*  18  */
	0xC6E8F948, /*  19  */
	0xE613C111, /*  20  */
	0x3955C6FF, /*  21  */
	0x1170ED7C, /*  22  */
	0x8E95DA41, /*  23  */
	0x99C31BF4, /*  24  */
	0xA4DA8021, /*  25  */
	0x7B5F94FB, /*  26  */
	0xDD0DA51F, /*  27  */
	0x6562AA77, /*  28  */
	0x556BCB23, /*  29  */
	0xDB1BACC6, /*  30  */
	0x798040B9, /*  31  */
	0xBFE5378F, /*  32  */
	0x731D55E6, /*  33  */
	0xDAA5BFEE, /*  34  */
	0x389BBC60, /*  35  */
	0x1B33FBA4, /*  36  */
	0x9C567204, /*  37  */
	0x36C26C68, /*  38  */
	0x77EE9D69, /*  39  */
	0x8AEB3E88, /*  40  */
	0x2D50B5CE, /*  41  */
	0x9579E790, /*  42  */
	0x42B13CFC, /*  43  */
	0x33FBD32B, /*  44  */
	0xEE0503A7, /*  45  */
	0xB5862824, /*  46  */
	0x15E41EAD, /*  47  */
	0xC8412EF7, /*  48  */
	0x9D441275, /*  49  */
	0x2FCEC582, /*  50  */
	0x5FF483B7, /*  51  */
	0x8F3931DF, /*  52  */
	0x2E5D2A7B, /*  53  */
	0x49467BF9, /*  54  */
	0x0653DEA9, /*  55  */
	0x2684CE35, /*  56  */
	0x7E655E5C, /*  57  */
	0xF12771D8, /*  58  */
	0xBB15CC67, /*  59  */
	0xAB097CA1, /*  60  */
	0x983DCF52, /*  61  */
	0x10DDF026, /*  62  */
	0x21267F57, /*  63  */
	0x2C58F6B4, /*  64  */
	0x31043265, /*  65  */
	0x0BAB8C01, /*  66  */
	0xD5492099, /*  67  */
	0xACAAE619, /*  68  */
	0x944CE54A, /*  69  */
	0xF2D13D39, /*  70  */
	0xADD3FC32, /*  71  */
	0xCDA08A40, /*  72  */
	0xE2B0D451, /*  73  */
	0x9EFE08AE, /*  74  */
	0xB9D50FD2, /*  75  */
	0xEA5CD7FD, /*  76  */
	0xC9A749DD, /*  77  */
	0x13EA2253, /*  78  */
	0x832DEBAA, /*  79  */
	0x24BE640F, /*  80  */
	0xE03E926A, /*  81  */
	0x29E01CDE, /*  82  */
	0x8BF59F18, /*  83  */
	0x0F9D00B6, /*  84  */
	0xE1238B46, /*  85  */
	0x1E7D8E34, /*  86  */
	0x93619ADB, /*  87  */
	0x76B32F9F, /*  88  */
	0xBD972CEC, /*  89  */
	0xE31FA976, /*  90  */
	0xA68FBB10, /*  91  */
	0xFB3BA49D, /*  92  */
	0x8587C41D, /*  93  */
	0xA5ADD1D0, /*  94  */
	0xF3CF84BF, /*  95  */
	0xD4E11150, /*  96  */
	0xD9FFA6BC, /*  97  */
	0xC3F6018C, /*  98  */
	0xAEF10572, /*  99  */
	0x74A64B2F, /*  100  */
	0xE7DC9559, /*  101  */
	0x2AAE35D5, /*  102  */
	0x5B6F587F, /*  103  */
	0xA9E353FE, /*  104  */
	0xCA4FB674, /*  105  */
	0x04BA24A8, /*  106  */
	0xE5C6875F, /*  107  */
	0xDCBC6266, /*  108  */
	0x6BC5C03F, /*  109  */
	0x661EEF02, /*  110  */
	0xED740BAB, /*  111  */
	0x058E34E4, /*  112  */
	0xB7E946CF, /*  113  */
	0x88698125, /*  114  */
	0x72EC48ED, /*  115  */
	0xB11073A3, /*  116  */
	0xA13485EB, /*  117  */
	0xA2A2429C, /*  118  */
	0xFA407547, /*  119  */
	0x50B76713, /*  120  */
	0x5418C37D, /*  121  */
	0x96192DA5, /*  122  */
	0x170BB04B, /*  123  */
	0x518A021E, /*  124  */
	0xB0AC13D1, /*  125  */
	0x0963FA2A, /*  126  */
	0x4A6E10E1, /*  127  */
	0x58472BDC, /*  128  */
	0xF7F8D962, /*  129  */
	0x979139EA, /*  130  */
	0x8D856538, /*  131  */
	0xC0997042, /*  132  */
	0x48324D7A, /*  133  */
	0x447623CB, /*  134  */
	0x8CBBE364, /*  135  */
	0x6E0C6B0E, /*  136  */
	0xD36D63B0, /*  137  */
	0x3F244C84, /*  138  */
	0x3542C971, /*  139  */
	0x2B228DC1, /*  140  */
	0xCB0325BB, /*  141  */
	0xF8C0D6E9, /*  142  */
	0xDE11066B, /*  143  */
	0xA8649327, /*  144  */
	0xFC31F83E, /*  145  */
	0x7DD80406, /*  146  */
	0xF916DD61, /*  147  */
	0xD89F79D3, /*  148  */
	0x615144C2, /*  149  */
	0xEBB45D31, /*  150  */
	0x28002958, /*  151  */
	0x56890A37, /*  152  */
	0xF05B3808, /*  153  */
	0x123AE844, /*  154  */
	0x86839E16, /*  155  */
	0x914B0D83, /*  156  */
	0xC506B43C, /*  157  */
	0xCF3CBA5E, /*  158  */
	0x7C60F5C9, /*  159  */
	0x22DEB2A0, /*  160  */
	0x5D9C2715, /*  161  */
	0xC77BA0EF, /*  162  */
	0x4F45360B, /*  163  */
	0xC1017D8B, /*  164  */
	0xE45ADC29, /*  165  */
	0xA759909B, /*  166  */
	0x412CD293, /*  167  */
	0xD7D796B1, /*  168  */
	0x00C8FF30, /*  169  */
	0x23A34A80, /*  170  */
	0x4EC15C91, /*  171  */
	0x714E78B5, /*  172  */
	0x47B9E42E, /*  173  */
	0x78F3EA4D, /*  174  */
	0x7F078F5B, /*  175  */
	0x346C593A, /*  176  */
	0xA3A87A1A, /*  177  */
	0x9BCBFE12, /*  178  */
	0x3D439963, /*  179  */
	0xB2EF6D8E, /*  180  */
	0xB8D46028, /*  181  */
	0x6C2FD5CA, /*  182  */
	0x62675256, /*  183  */
	0x01F2A2F3, /*  184  */
	0xBC96AE0A, /*  185  */
	0x709A8920, /*  186  */
	0xB4146E87, /*  187  */
	0x6308B9E2, /*  188  */
	0x64BDA7BA, /*  189  */
	0xAFED6892, /*  190  */
	0x6037F2A2, /*  191  */
	0xF52969E0, /*  192  */
	0x0ADB43A6, /*  193  */
	0x82811400, /*  194  */
	0x90D0BDF0, /*  195  */
	0x19C9549E, /*  196  */
	0x203F6A73, /*  197  */
	0x1ACCAF4F, /*  198  */
	0x89714E6D, /*  199  */
	0x164D4705, /*  200  */
	0x67665F07, /*  201  */
	0xEC206170, /*  202  */
	0x0C2182B2, /*  203  */
	0xA02B9C81, /*  204  */
	0x53289722, /*  205  */
	0xF6A97686, /*  206  */
	0x140E4179, /*  207  */
	0x9F778849, /*  208  */
	0x9A88E15D, /*  209  */
	0x25CADB54, /*  210  */
	0xD157F36F, /*  211  */
	0x32A421C3, /*  212  */
	0xB368E98A, /*  213  */
	0x5A92CD0D, /*  214  */
	0x757AA8D4, /*  215  */
	0xC20AC278, /*  216  */
	0x08B551C7, /*  217  */
	0x849491E8, /*  218  */
	0x4DC75AD6, /*  219  */
	0x697C33BE, /*  220  */
	0xBAF0CA33, /*  221  */
	0x46125B4E, /*  222  */
	0x59D677B3, /*  223  */
	0x30D9C8F2, /*  224  */
	0xD0AF860C, /*  225  */
	0x1C7FD0FA, /*  226  */
	0xFE0FF72C, /*  227  */
	0x5C8D6F43, /*  228  */
	0x57FDEC3B, /*  229  */
	0x6AB6AD97, /*  230  */
	0xD22ADF89, /*  231  */
	0x18171785, /*  232  */
	0x02BFE22D, /*  233  */
	0x6DB80917, /*  234  */
	0x80B216AF, /*  235  */
	0xE85E4F9A, /*  236  */
	0x7A1C306E, /*  237  */
	0x6FC49BF5, /*  238  */
	0x3AF7A11C, /*  239  */
	0x81E215E7, /*  240  */
	0x68363FCD, /*  241  */
	0x3E9357C8, /*  242  */
	0xEF52FD55, /*  243  */
	0x3B8BAB4C, /*  244  */
	0x3C8CF495, /*  245  */
	0xBEFCEEBD, /*  246  */
	0xFD25B714, /*  247  */
	0xC498D83D, /*  248  */
	0x0D2E1A8D, /*  249  */
	0xE9F966AC, /*  250  */
	0x0E387445, /*  251  */
	0x435419E5, /*  252  */
	0x5E7EBEC4, /*  253  */
	0xAA90B8D9, /*  254  */
	0xFF1A3A96  /*  255  */

################################################################################

TITLE
    Snefru S box 2

TYPE
    32

DATA
	0x4A8FE4E3, /*  0  */
	0xF27D99CD, /*  1  */
	0xD04A40CA, /*  2  */
	0xCB5FF194, /*  3  */
	0x3668275A, /*  4  */
	0xFF4816BE, /*  5  */
	0xA78B394C, /*  6  */
	0x4C6BE9DB, /*  7  */
	0x4EEC38D2, /*  8  */
	0x4296EC80, /*  9  */
	0xCDCE96F8, /*  10  */
	0x888C2F38, /*  11  */
	0xE75508F5, /*  12  */
	0x7B916414, /*  13  */
	0x060AA14A, /*  14  */
	0xA214F327, /*  15  */
	0xBE608DAF, /*  16  */
	0x1EBBDEC2, /*  17  */
	0x61F98CE9, /*  18  */
	0xE92156FE, /*  19  */
	0x4F22D7A3, /*  20  */
	0x3F76A8D9, /*  21  */
	0x559A4B33, /*  22  */
	0x38AD2959, /*  23  */
	0xF3F17E9E, /*  24  */
	0x85E1BA91, /*  25  */
	0xE5EBA6FB, /*  26  */
	0x73DCD48C, /*  27  */
	0xF5C3FF78, /*  28  */
	0x481B6058, /*  29  */
	0x8A3297F7, /*  30  */
	0x8F1F3BF4, /*  31  */
	0x93785AB2, /*  32  */
	0x477A4A5B, /*  33  */
	0x6334EB5D, /*  34  */
	0x6D251B2E, /*  35  */
	0x74A9102D, /*  36  */
	0x07E38FFA, /*  37  */
	0x915C9C62, /*  38  */
	0xCCC275EA, /*  39  */
	0x6BE273EC, /*  40  */
	0x3EBDDD70, /*  41  */
	0xD895796C, /*  42  */
	0xDC54A91B, /*  43  */
	0xC9AFDF81, /*  44  */
	0x23633F73, /*  45  */
	0x275119B4, /*  46  */
	0xB19F6B67, /*  47  */
	0x50756E22, /*  48  */
	0x2BB152E2, /*  49  */
	0x76EA46A2, /*  50  */
	0xA353E232, /*  51  */
	0x2F596AD6, /*  52  */
	0x0B1EDB0B, /*  53  */
	0x02D3D9A4, /*  54  */
	0x78B47843, /*  55  */
	0x64893E90, /*  56  */
	0x40F0CAAD, /*  57  */
	0xF68D3AD7, /*  58  */
	0x46FD1707, /*  59  */
	0x1C9C67EF, /*  60  */
	0xB5E086DE, /*  61  */
	0x96EE6CA6, /*  62  */
	0x9AA34774, /*  63  */
	0x1BA4F48A, /*  64  */
	0x8D01ABFD, /*  65  */
	0x183EE1F6, /*  66  */
	0x5FF8AA7A, /*  67  */
	0x17E4FAAE, /*  68  */
	0x303983B0, /*  69  */
	0x6C08668B, /*  70  */
	0xD4AC4382, /*  71  */
	0xE6C5849F, /*  72  */
	0x92FEFB53, /*  73  */
	0xC1CAC4CE, /*  74  */
	0x43501388, /*  75  */
	0x441118CF, /*  76  */
	0xEC4FB308, /*  77  */
	0x53A08E86, /*  78  */
	0x9E0FE0C5, /*  79  */
	0xF91C1525, /*  80  */
	0xAC45BE05, /*  81  */
	0xD7987CB5, /*  82  */
	0x49BA1487, /*  83  */
	0x57938940, /*  84  */
	0xD5877648, /*  85  */
	0xA958727F, /*  86  */
	0x58DFE3C3, /*  87  */
	0xF436CF77, /*  88  */
	0x399E4D11, /*  89  */
	0xF0A5BFA9, /*  90  */
	0xEF61A33B, /*  91  */
	0xA64CAC60, /*  92  */
	0x04A8D0BA, /*  93  */
	0x030DD572, /*  94  */
	0xB83D320F, /*  95  */
	0xCAB23045, /*  96  */
	0xE366F2F0, /*  97  */
	0x815D008D, /*  98  */
	0xC897A43A, /*  99  */
	0x1D352DF3, /*  100  */
	0xB9CC571D, /*  101  */
	0x8BF38744, /*  102  */
	0x72209092, /*  103  */
	0xEBA124EB, /*  104  */
	0xFB99CE5E, /*  105  */
	0x3BB94293, /*  106  */
	0x28DA549C, /*  107  */
	0xAAB8A228, /*  108  */
	0xA4197785, /*  109  */
	0x33C70296, /*  110  */
	0x25F6259B, /*  111  */
	0x5C85DA21, /*  112  */
	0xDF15BDEE, /*  113  */
	0x15B7C7E8, /*  114  */
	0xE2ABEF75, /*  115  */
	0xFCC19BC1, /*  116  */
	0x417FF868, /*  117  */
	0x14884434, /*  118  */
	0x62825179, /*  119  */
	0xC6D5C11C, /*  120  */
	0x0E4705DC, /*  121  */
	0x22700DE0, /*  122  */
	0xD3D2AF18, /*  123  */
	0x9BE822A0, /*  124  */
	0x35B669F1, /*  125  */
	0xC42BB55C, /*  126  */
	0x0A801252, /*  127  */
	0x115BF0FC, /*  128  */
	0x3CD7D856, /*  129  */
	0xB43F5F9D, /*  130  */
	0xC2306516, /*  131  */
	0xA1231C47, /*  132  */
	0xF149207E, /*  133  */
	0x5209A795, /*  134  */
	0x34B3CCD8, /*  135  */
	0x67AEFE54, /*  136  */
	0x2C83924E, /*  137  */
	0x6662CBAC, /*  138  */
	0x5EEDD161, /*  139  */
	0x84E681AA, /*  140  */
	0x5D57D26B, /*  141  */
	0xFA465CC4, /*  142  */
	0x7E3AC3A8, /*  143  */
	0xBF7C0CC6, /*  144  */
	0xE18A9AA1, /*  145  */
	0xC32F0A6F, /*  146  */
	0xB22CC00D, /*  147  */
	0x3D280369, /*  148  */
	0x994E554F, /*  149  */
	0x68F480D3, /*  150  */
	0xADCFF5E6, /*  151  */
	0x3A8EB265, /*  152  */
	0x83269831, /*  153  */
	0xBD568A09, /*  154  */
	0x4BC8AE6A, /*  155  */
	0x69F56D2B, /*  156  */
	0x0F17EAC8, /*  157  */
	0x772EB6C7, /*  158  */
	0x9F41343C, /*  159  */
	0xAB1D0742, /*  160  */
	0x826A6F50, /*  161  */
	0xFEA2097C, /*  162  */
	0x1912C283, /*  163  */
	0xCE185899, /*  164  */
	0xE4444839, /*  165  */
	0x2D8635D5, /*  166  */
	0x65D0B1FF, /*  167  */
	0x865A7F17, /*  168  */
	0x326D9FB1, /*  169  */
	0x59E52820, /*  170  */
	0x0090ADE1, /*  171  */
	0x753C7149, /*  172  */
	0x9DDD8B98, /*  173  */
	0xA5A691DA, /*  174  */
	0x0D0382BB, /*  175  */
	0x8904C930, /*  176  */
	0x086CB000, /*  177  */
	0x6E69D3BD, /*  178  */
	0x24D4E7A7, /*  179  */
	0x05244FD0, /*  180  */
	0x101A5E0C, /*  181  */
	0x6A947DCB, /*  182  */
	0xE840F77B, /*  183  */
	0x7D0C5003, /*  184  */
	0x7C370F1F, /*  185  */
	0x805245ED, /*  186  */
	0xE05E3D3F, /*  187  */
	0x7906880E, /*  188  */
	0xBABFCD35, /*  189  */
	0x1A7EC697, /*  190  */
	0x8C052324, /*  191  */
	0x0C6EC8DF, /*  192  */
	0xD129A589, /*  193  */
	0xC7A75B02, /*  194  */
	0x12D81DE7, /*  195  */
	0xD9BE2A66, /*  196  */
	0x1F4263AB, /*  197  */
	0xDE73FDB6, /*  198  */
	0x2A00680A, /*  199  */
	0x56649E36, /*  200  */
	0x3133ED55, /*  201  */
	0x90FA0BF2, /*  202  */
	0x2910A02A, /*  203  */
	0x949D9D46, /*  204  */
	0xA0D1DCDD, /*  205  */
	0xCFC9B7D4, /*  206  */
	0xD2677BE5, /*  207  */
	0x95CB36B3, /*  208  */
	0x13CD9410, /*  209  */
	0xDBF73313, /*  210  */
	0xB7C6E8C0, /*  211  */
	0xF781414B, /*  212  */
	0x510B016D, /*  213  */
	0xB0DE1157, /*  214  */
	0xD6B0F62C, /*  215  */
	0xBB074ECC, /*  216  */
	0x7F1395B7, /*  217  */
	0xEE792CF9, /*  218  */
	0xEA6FD63E, /*  219  */
	0x5BD6938E, /*  220  */
	0xAF02FC64, /*  221  */
	0xDAB57AB8, /*  222  */
	0x8EDB3784, /*  223  */
	0x8716318F, /*  224  */
	0x164D1A01, /*  225  */
	0x26F26141, /*  226  */
	0xB372E6B9, /*  227  */
	0xF8FC2B06, /*  228  */
	0x7AC00E04, /*  229  */
	0x3727B89A, /*  230  */
	0x97E9BCA5, /*  231  */
	0x9C2A742F, /*  232  */
	0xBC3B1F7D, /*  233  */
	0x7165B471, /*  234  */
	0x609B4C29, /*  235  */
	0x20925351, /*  236  */
	0x5AE72112, /*  237  */
	0x454BE5D1, /*  238  */
	0xC0FFB95F, /*  239  */
	0xDD0EF919, /*  240  */
	0x6F2D70C9, /*  241  */
	0x0974C5BF, /*  242  */
	0x98AA6263, /*  243  */
	0x01D91E4D, /*  244  */
	0x2184BB6E, /*  245  */
	0x70C43C1E, /*  246  */
	0x4D435915, /*  247  */
	0xAE7B8523, /*  248  */
	0xB6FB06BC, /*  249  */
	0x5431EE76, /*  250  */
	0xFDBC5D26, /*  251  */
	0xED77493D, /*  252  */
	0xC5712EE4, /*  253  */
	0xA8380437, /*  254  */
	0x2EEF261A  /*  255  */

################################################################################

TITLE
    Snefru S box 3

TYPE
    32

DATA
	0x5A79392B, /*  0  */
	0xB8AF32C2, /*  1  */
	0x41F7720A, /*  2  */
	0x833A61EC, /*  3  */
	0x13DFEDAC, /*  4  */
	0xC4990BC4, /*  5  */
	0xDC0F54BC, /*  6  */
	0xFEDD5E88, /*  7  */
	0x80DA1881, /*  8  */
	0x4DEA1AFD, /*  9  */
	0xFD402CC6, /*  10  */
	0xAE67CC7A, /*  11  */
	0xC5238525, /*  12  */
	0x8EA01254, /*  13  */
	0xB56B9BD5, /*  14  */
	0x862FBD6D, /*  15  */
	0xAC8575D3, /*  16  */
	0x6FBA3714, /*  17  */
	0xDA7EBF46, /*  18  */
	0x59CD5238, /*  19  */
	0x8AC9DBFE, /*  20  */
	0x353729FC, /*  21  */
	0xE497D7F2, /*  22  */
	0xC3AB84E0, /*  23  */
	0xF05A114B, /*  24  */
	0x7B887A75, /*  25  */
	0xEDC603DD, /*  26  */
	0x5E6FE680, /*  27  */
	0x2C84B399, /*  28  */
	0x884EB1DA, /*  29  */
	0x1CB8C8BF, /*  30  */
	0xAA51098A, /*  31  */
	0xC862231C, /*  32  */
	0x8BAC2221, /*  33  */
	0x21B387E5, /*  34  */
	0x208A430D, /*  35  */
	0x2A3F0F8B, /*  36  */
	0xA5FF9CD2, /*  37  */
	0x6012A2EA, /*  38  */
	0x147A9EE7, /*  39  */
	0xF62A501D, /*  40  */
	0xB4B2E51A, /*  41  */
	0x3EF3484C, /*  42  */
	0xC0253C59, /*  43  */
	0x2B82B536, /*  44  */
	0x0AA9696B, /*  45  */
	0xBE0C109B, /*  46  */
	0xC70B7929, /*  47  */
	0xCE3E8A19, /*  48  */
	0x2F66950E, /*  49  */
	0x459F1C2C, /*  50  */
	0xE68FB93D, /*  51  */
	0xA3C3FF3E, /*  52  */
	0x62B45C62, /*  53  */
	0x300991CB, /*  54  */
	0x01914C57, /*  55  */
	0x7F7BC06A, /*  56  */
	0x182831F5, /*  57  */
	0xE7B74BCA, /*  58  */
	0xFA50F6D0, /*  59  */
	0x523CAA61, /*  60  */
	0xE3A7CF05, /*  61  */
	0xE9E41311, /*  62  */
	0x280A21D1, /*  63  */
	0x6A4297E1, /*  64  */
	0xF24DC67E, /*  65  */
	0xFC3189E6, /*  66  */
	0xB72BF34F, /*  67  */
	0x4B1E67AF, /*  68  */
	0x543402CE, /*  69  */
	0x79A59867, /*  70  */
	0x0648E02A, /*  71  */
	0x00A3AC17, /*  72  */
	0xC6208D35, /*  73  */
	0x6E7F5F76, /*  74  */
	0xA45BB4BE, /*  75  */
	0xF168FA63, /*  76  */
	0x3F4125F3, /*  77  */
	0xF311406F, /*  78  */
	0x02706565, /*  79  */
	0xBFE58022, /*  80  */
	0x0CFCFDD9, /*  81  */
	0x0735A7F7, /*  82  */
	0x8F049092, /*  83  */
	0xD98EDC27, /*  84  */
	0xF5C5D55C, /*  85  */
	0xE0F201DB, /*  86  */
	0x0DCAFC9A, /*  87  */
	0x7727FB79, /*  88  */
	0xAF43ABF4, /*  89  */
	0x26E938C1, /*  90  */
	0x401B26A6, /*  91  */
	0x900720FA, /*  92  */
	0x2752D97B, /*  93  */
	0xCFF1D1B3, /*  94  */
	0xA9D9E424, /*  95  */
	0x42DB99AB, /*  96  */
	0x6CF8BE5F, /*  97  */
	0xE82CEBE3, /*  98  */
	0x3AFB733B, /*  99  */
	0x6B734EB6, /*  100  */
	0x1036414A, /*  101  */
	0x975F667C, /*  102  */
	0x049D6377, /*  103  */
	0xBA587C60, /*  104  */
	0xB1D10483, /*  105  */
	0xDE1AEFCC, /*  106  */
	0x1129D055, /*  107  */
	0x72051E91, /*  108  */
	0x6946D623, /*  109  */
	0xF9E86EA7, /*  110  */
	0x48768C00, /*  111  */
	0xB0166C93, /*  112  */
	0x9956BBF0, /*  113  */
	0x1F1F6D84, /*  114  */
	0xFB15E18E, /*  115  */
	0x033B495D, /*  116  */
	0x56E3362E, /*  117  */
	0x4F44C53C, /*  118  */
	0x747CBA51, /*  119  */
	0x89D37872, /*  120  */
	0x5D9C331B, /*  121  */
	0xD2EF9FA8, /*  122  */
	0x254917F8, /*  123  */
	0x1B106F47, /*  124  */
	0x37D75553, /*  125  */
	0xB3F053B0, /*  126  */
	0x7DCCD8EF, /*  127  */
	0xD30EB802, /*  128  */
	0x5889F42D, /*  129  */
	0x610206D7, /*  130  */
	0x1A7D34A1, /*  131  */
	0x92D87DD8, /*  132  */
	0xE5F4A315, /*  133  */
	0xD1CF0E71, /*  134  */
	0xB22DFE45, /*  135  */
	0xB901E8EB, /*  136  */
	0x0FC0CE5E, /*  137  */
	0x2EFA60C9, /*  138  */
	0x2DE74290, /*  139  */
	0x36D0C906, /*  140  */
	0x381C70E4, /*  141  */
	0x4C6DA5B5, /*  142  */
	0x3D81A682, /*  143  */
	0x7E381F34, /*  144  */
	0x396C4F52, /*  145  */
	0x95AD5901, /*  146  */
	0x1DB50C5A, /*  147  */
	0x29982E9E, /*  148  */
	0x1557689F, /*  149  */
	0x3471EE42, /*  150  */
	0xD7E2F7C0, /*  151  */
	0x8795A1E2, /*  152  */
	0xBC324D8D, /*  153  */
	0xE224C3C8, /*  154  */
	0x12837E39, /*  155  */
	0xCDEE3D74, /*  156  */
	0x7AD2143F, /*  157  */
	0x0E13D40C, /*  158  */
	0x78BD4A68, /*  159  */
	0xA2EB194D, /*  160  */
	0xDB9451F9, /*  161  */
	0x859B71DC, /*  162  */
	0x5C4F5B89, /*  163  */
	0xCA14A8A4, /*  164  */
	0xEF92F003, /*  165  */
	0x16741D98, /*  166  */
	0x33AA4444, /*  167  */
	0x9E967FBB, /*  168  */
	0x092E3020, /*  169  */
	0xD86A35B8, /*  170  */
	0x8CC17B10, /*  171  */
	0xE1BF08AE, /*  172  */
	0x55693FC5, /*  173  */
	0x7680AD13, /*  174  */
	0x1E6546E8, /*  175  */
	0x23B6E7B9, /*  176  */
	0xEE77A4B2, /*  177  */
	0x08ED0533, /*  178  */
	0x44FD2895, /*  179  */
	0xB6393B69, /*  180  */
	0x05D6CACF, /*  181  */
	0x9819B209, /*  182  */
	0xECBBB72F, /*  183  */
	0x9A75779C, /*  184  */
	0xEAEC0749, /*  185  */
	0x94A65AEE, /*  186  */
	0xBDF52DC3, /*  187  */
	0xD6A25D04, /*  188  */
	0x82008E4E, /*  189  */
	0xA6DE160F, /*  190  */
	0x9B036AFB, /*  191  */
	0x228B3A66, /*  192  */
	0x5FB10A70, /*  193  */
	0xCC338B58, /*  194  */
	0x5378A9DF, /*  195  */
	0xC908BCA9, /*  196  */
	0x4959E25B, /*  197  */
	0x46909A97, /*  198  */
	0x66AE8F6E, /*  199  */
	0xDD0683E9, /*  200  */
	0x65F994B4, /*  201  */
	0x6426CDA5, /*  202  */
	0xC24B8840, /*  203  */
	0x32539DA0, /*  204  */
	0x63175650, /*  205  */
	0xD0C815FF, /*  206  */
	0x50CBC41E, /*  207  */
	0xF7C774A3, /*  208  */
	0x31B0C231, /*  209  */
	0x8D0D8116, /*  210  */
	0x24BEF16C, /*  211  */
	0xD555D256, /*  212  */
	0xDF47EA8C, /*  213  */
	0x6D21ECCD, /*  214  */
	0xA887A012, /*  215  */
	0x84542AED, /*  216  */
	0xA7B9C1BD, /*  217  */
	0x914C1BB1, /*  218  */
	0xA0D5B67D, /*  219  */
	0x438CE937, /*  220  */
	0x7030F873, /*  221  */
	0x71F6B0C7, /*  222  */
	0x574576BA, /*  223  */
	0xF8BC4541, /*  224  */
	0x9C61D348, /*  225  */
	0x1960579D, /*  226  */
	0x17C4DAAD, /*  227  */
	0x96A4CB0B, /*  228  */
	0xC193F2F6, /*  229  */
	0x756EAFA2, /*  230  */
	0x7C1D2F94, /*  231  */
	0xF4FE2B43, /*  232  */
	0xCB86E33A, /*  233  */
	0xEBD4C728, /*  234  */
	0x9D18AE64, /*  235  */
	0x9FE13E30, /*  236  */
	0x3CE0F5DE, /*  237  */
	0xABA1F985, /*  238  */
	0xADDC2718, /*  239  */
	0x68CE6278, /*  240  */
	0xD45E241F, /*  241  */
	0xA15C82B7, /*  242  */
	0x3B2293D4, /*  243  */
	0x739EDD32, /*  244  */
	0x674A6BF1, /*  245  */
	0x5B5D587F, /*  246  */
	0x4772DEAA, /*  247  */
	0x4A63968F, /*  248  */
	0x0BE68686, /*  249  */
	0x513D6426, /*  250  */
	0x939A4787, /*  251  */
	0xBBA89296, /*  252  */
	0x4EC20007, /*  253  */
	0x818D0D08, /*  254  */
	0xFF64DFD6  /*  255  */

################################################################################

TITLE
    Snefru S box 4

TYPE
    32

DATA
	0xCB2297CB, /*  0  */
	0xDB48A144, /*  1  */
	0xA16CBE4B, /*  2  */
	0xBBEA1D6C, /*  3  */
	0x5AF6B6B7, /*  4  */
	0x8A8110B6, /*  5  */
	0xF9236EF9, /*  6  */
	0xC98F83E6, /*  7  */
	0x0F9C65B8, /*  8  */
	0x252D4A89, /*  9  */
	0xA497F068, /*  10  */
	0xA5D7ED2D, /*  11  */
	0x94C22845, /*  12  */
	0x9DA1C8C4, /*  13  */
	0xE27C2E2E, /*  14  */
	0x6E8BA2B4, /*  15  */
	0xC3DD17FB, /*  16  */
	0x498CD482, /*  17  */
	0x0DFE6A9F, /*  18  */
	0xB0705829, /*  19  */
	0x9A1E6DC1, /*  20  */
	0xF829717C, /*  21  */
	0x07BB8E3A, /*  22  */
	0xDA3C0B02, /*  23  */
	0x1AF82FC7, /*  24  */
	0x73B70955, /*  25  */
	0x7A04379C, /*  26  */
	0x5EE20A28, /*  27  */
	0x83712AE5, /*  28  */
	0xF4C47C6D, /*  29  */
	0xDF72BA56, /*  30  */
	0xD794858D, /*  31  */
	0x8C0CF709, /*  32  */
	0x18F0F390, /*  33  */
	0xB6C69B35, /*  34  */
	0xBF2F01DB, /*  35  */
	0x2FA74DCA, /*  36  */
	0xD0CD9127, /*  37  */
	0xBDE66CEC, /*  38  */
	0x3DEEBD46, /*  39  */
	0x57C88FC3, /*  40  */
	0xCEE1406F, /*  41  */
	0x0066385A, /*  42  */
	0xF3C3444F, /*  43  */
	0x3A79D5D5, /*  44  */
	0x75751EB9, /*  45  */
	0x3E7F8185, /*  46  */
	0x521C2605, /*  47  */
	0xE1AAAB6E, /*  48  */
	0x38EBB80F, /*  49  */
	0xBEE7E904, /*  50  */
	0x61CB9647, /*  51  */
	0xEA54904E, /*  52  */
	0x05AE00E4, /*  53  */
	0x2D7AC65F, /*  54  */
	0x087751A1, /*  55  */
	0xDCD82915, /*  56  */
	0x0921EE16, /*  57  */
	0xDD86D33B, /*  58  */
	0xD6BD491A, /*  59  */
	0x40FBADF0, /*  60  */
	0x4232CBD2, /*  61  */
	0x33808D10, /*  62  */
	0x39098C42, /*  63  */
	0x193F3199, /*  64  */
	0x0BC1E47A, /*  65  */
	0x4A82B149, /*  66  */
	0x02B65A8A, /*  67  */
	0x104CDC8E, /*  68  */
	0x24A8F52C, /*  69  */
	0x685C6077, /*  70  */
	0xC79F95C9, /*  71  */
	0x1D11FE50, /*  72  */
	0xC08DAFCD, /*  73  */
	0x7B1A9A03, /*  74  */
	0x1C1F11D8, /*  75  */
	0x84250E7F, /*  76  */
	0x979DB248, /*  77  */
	0xEBDC0501, /*  78  */
	0xB9553395, /*  79  */
	0xE3C05EA8, /*  80  */
	0xB1E51C4C, /*  81  */
	0x13B0E681, /*  82  */
	0x3B407766, /*  83  */
	0x36DB3087, /*  84  */
	0xEE17C9FC, /*  85  */
	0x6C53ECF2, /*  86  */
	0xADCCC58F, /*  87  */
	0xC427660B, /*  88  */
	0xEFD5867D, /*  89  */
	0x9B6D54A5, /*  90  */
	0x6FF1AEFF, /*  91  */
	0x8E787952, /*  92  */
	0x9E2BFFE0, /*  93  */
	0x8761D034, /*  94  */
	0xE00BDBAD, /*  95  */
	0xAE99A8D3, /*  96  */
	0xCC03F6E2, /*  97  */
	0xFD0ED807, /*  98  */
	0x0E508AE3, /*  99  */
	0xB74182AB, /*  100  */
	0x4349245D, /*  101  */
	0xD120A465, /*  102  */
	0xB246A641, /*  103  */
	0xAF3B7AB0, /*  104  */
	0x2A6488BB, /*  105  */
	0x4B3A0D1F, /*  106  */
	0xE7C7E58C, /*  107  */
	0x3FAFF2EB, /*  108  */
	0x90445FFD, /*  109  */
	0xCF38C393, /*  110  */
	0x995D07E7, /*  111  */
	0xF24F1B36, /*  112  */
	0x356F6891, /*  113  */
	0x6D6EBCBE, /*  114  */
	0x8DA9E262, /*  115  */
	0x50FD520E, /*  116  */
	0x5BCA9E1E, /*  117  */
	0x37472CF3, /*  118  */
	0x69075057, /*  119  */
	0x7EC5FDED, /*  120  */
	0x0CAB892A, /*  121  */
	0xFB2412BA, /*  122  */
	0x1728DEBF, /*  123  */
	0xA000A988, /*  124  */
	0xD843CE79, /*  125  */
	0x042E20DD, /*  126  */
	0x4FE8F853, /*  127  */
	0x56659C3C, /*  128  */
	0x2739D119, /*  129  */
	0xA78A6120, /*  130  */
	0x80960375, /*  131  */
	0x70420611, /*  132  */
	0x85E09F78, /*  133  */
	0xABD17E96, /*  134  */
	0x1B513EAF, /*  135  */
	0x1E01EB63, /*  136  */
	0x26AD2133, /*  137  */
	0xA890C094, /*  138  */
	0x7613CF60, /*  139  */
	0x817E781B, /*  140  */
	0xA39113D7, /*  141  */
	0xE957FA58, /*  142  */
	0x4131B99E, /*  143  */
	0x28B1EFDA, /*  144  */
	0x66ACFBA7, /*  145  */
	0xFF68944A, /*  146  */
	0x77A44FD1, /*  147  */
	0x7F331522, /*  148  */
	0x59FFB3FA, /*  149  */
	0xA6DF935B, /*  150  */
	0xFA12D9DF, /*  151  */
	0xC6BF6F3F, /*  152  */
	0x89520CF6, /*  153  */
	0x659EDD6A, /*  154  */
	0x544DA739, /*  155  */
	0x8B052538, /*  156  */
	0x7C30EA21, /*  157  */
	0xC2345525, /*  158  */
	0x15927FB2, /*  159  */
	0x144A436B, /*  160  */
	0xBA107B8B, /*  161  */
	0x1219AC97, /*  162  */
	0x06730432, /*  163  */
	0x31831AB3, /*  164  */
	0xC55A5C24, /*  165  */
	0xAA0FCD3E, /*  166  */
	0xE5606BE8, /*  167  */
	0x5C88F19B, /*  168  */
	0x4C0841EE, /*  169  */
	0x1FE37267, /*  170  */
	0x11F9C4F4, /*  171  */
	0x9F1B9DAE, /*  172  */
	0x864E76D0, /*  173  */
	0xE637C731, /*  174  */
	0xD97D23A6, /*  175  */
	0x32F53D5C, /*  176  */
	0xB8161980, /*  177  */
	0x93FA0F84, /*  178  */
	0xCAEF0870, /*  179  */
	0x8874487E, /*  180  */
	0x98F2CC73, /*  181  */
	0x645FB5C6, /*  182  */
	0xCD853659, /*  183  */
	0x2062470D, /*  184  */
	0x16EDE8E9, /*  185  */
	0x6B06DAB5, /*  186  */
	0x78B43900, /*  187  */
	0xFC95B786, /*  188  */
	0x5D8E7DE1, /*  189  */
	0x465B5954, /*  190  */
	0xFE7BA014, /*  191  */
	0xF7D23F7B, /*  192  */
	0x92BC8B18, /*  193  */
	0x03593592, /*  194  */
	0x55CEF4F7, /*  195  */
	0x74B27317, /*  196  */
	0x79DE1FC2, /*  197  */
	0xC8A0BFBD, /*  198  */
	0x229398CC, /*  199  */
	0x62A602CE, /*  200  */
	0xBCB94661, /*  201  */
	0x5336D206, /*  202  */
	0xD2A375FE, /*  203  */
	0x6A6AB483, /*  204  */
	0x4702A5A4, /*  205  */
	0xA2E9D73D, /*  206  */
	0x23A2E0F1, /*  207  */
	0x9189140A, /*  208  */
	0x581D18DC, /*  209  */
	0xB39A922B, /*  210  */
	0x82356212, /*  211  */
	0xD5F432A9, /*  212  */
	0xD356C2A3, /*  213  */
	0x5F765B4D, /*  214  */
	0x450AFCC8, /*  215  */
	0x4415E137, /*  216  */
	0xE8ECDFBC, /*  217  */
	0xED0DE3EA, /*  218  */
	0x60D42B13, /*  219  */
	0xF13DF971, /*  220  */
	0x71FC5DA2, /*  221  */
	0xC1455340, /*  222  */
	0xF087742F, /*  223  */
	0xF55E5751, /*  224  */
	0x67B3C1F8, /*  225  */
	0xAC6B8774, /*  226  */
	0x7DCFAAAC, /*  227  */
	0x95983BC0, /*  228  */
	0x489BB0B1, /*  229  */
	0x2C184223, /*  230  */
	0x964B6726, /*  231  */
	0x2BD3271C, /*  232  */
	0x72266472, /*  233  */
	0xDED64530, /*  234  */
	0x0A2AA343, /*  235  */
	0xD4F716A0, /*  236  */
	0xB4DAD6D9, /*  237  */
	0x2184345E, /*  238  */
	0x512C990C, /*  239  */
	0x29D92D08, /*  240  */
	0x2EBE709A, /*  241  */
	0x01144C69, /*  242  */
	0x34584B9D, /*  243  */
	0xE4634ED6, /*  244  */
	0xECC963CF, /*  245  */
	0x3C6984AA, /*  246  */
	0x4ED056EF, /*  247  */
	0x9CA56976, /*  248  */
	0x8F3E80D4, /*  249  */
	0xB5BAE7C5, /*  250  */
	0x30B5CAF5, /*  251  */
	0x63F33A64, /*  252  */
	0xA9E4BBDE, /*  253  */
	0xF6B82298, /*  254  */
	0x4D673C1D  /*  255  */

################################################################################

TITLE
    Snefru S box 5

TYPE
    32

DATA
	0x4B4F1121, /*  0  */
	0xBA183081, /*  1  */
	0xC784F41F, /*  2  */
	0xD17D0BAC, /*  3  */
	0x083D2267, /*  4  */
	0x37B1361E, /*  5  */
	0x3581AD05, /*  6  */
	0xFDA2F6BC, /*  7  */
	0x1E892CDD, /*  8  */
	0xB56D3C3A, /*  9  */
	0x32140E46, /*  10  */
	0x138D8AAB, /*  11  */
	0xE14773D4, /*  12  */
	0x5B0E71DF, /*  13  */
	0x5D1FE055, /*  14  */
	0x3FB991D3, /*  15  */
	0xF1F46C71, /*  16  */
	0xA325988C, /*  17  */
	0x10F66E80, /*  18  */
	0xB1006348, /*  19  */
	0x726A9F60, /*  20  */
	0x3B67F8BA, /*  21  */
	0x4E114EF4, /*  22  */
	0x05C52115, /*  23  */
	0x4C5CA11C, /*  24  */
	0x99E1EFD8, /*  25  */
	0x471B83B3, /*  26  */
	0xCBF7E524, /*  27  */
	0x43AD82F5, /*  28  */
	0x690CA93B, /*  29  */
	0xFAA61BB2, /*  30  */
	0x12A832B5, /*  31  */
	0xB734F943, /*  32  */
	0xBD22AEA7, /*  33  */
	0x88FEC626, /*  34  */
	0x5E80C3E7, /*  35  */
	0xBE3EAF5E, /*  36  */
	0x44617652, /*  37  */
	0xA5724475, /*  38  */
	0xBB3B9695, /*  39  */
	0x7F3FEE8F, /*  40  */
	0x964E7DEB, /*  41  */
	0x518C052D, /*  42  */
	0x2A0BBC2B, /*  43  */
	0xC2175F5C, /*  44  */
	0x9A7B3889, /*  45  */
	0xA70D8D0C, /*  46  */
	0xEACCDD29, /*  47  */
	0xCCCD6658, /*  48  */
	0x34BB25E6, /*  49  */
	0xB8391090, /*  50  */
	0xF651356F, /*  51  */
	0x52987C9E, /*  52  */
	0x0C16C1CD, /*  53  */
	0x8E372D3C, /*  54  */
	0x2FC6EBBD, /*  55  */
	0x6E5DA3E3, /*  56  */
	0xB0E27239, /*  57  */
	0x5F685738, /*  58  */
	0x45411786, /*  59  */
	0x067F65F8, /*  60  */
	0x61778B40, /*  61  */
	0x81AB2E65, /*  62  */
	0x14C8F0F9, /*  63  */
	0xA6B7B4CE, /*  64  */
	0x4036EAEC, /*  65  */
	0xBF62B00A, /*  66  */
	0xECFD5E02, /*  67  */
	0x045449A6, /*  68  */
	0xB20AFD28, /*  69  */
	0x2166D273, /*  70  */
	0x0D13A863, /*  71  */
	0x89508756, /*  72  */
	0xD51A7530, /*  73  */
	0x2D653F7A, /*  74  */
	0x3CDBDBC3, /*  75  */
	0x80C9DF4F, /*  76  */
	0x3D5812D9, /*  77  */
	0x53FBB1F3, /*  78  */
	0xC0F185C0, /*  79  */
	0x7A3C3D7E, /*  80  */
	0x68646410, /*  81  */
	0x857607A0, /*  82  */
	0x1D12622E, /*  83  */
	0x97F33466, /*  84  */
	0xDB4C9917, /*  85  */
	0x6469607C, /*  86  */
	0x566E043D, /*  87  */
	0x79EF1EDB, /*  88  */
	0x2C05898D, /*  89  */
	0xC9578E25, /*  90  */
	0xCD380101, /*  91  */
	0x46E04377, /*  92  */
	0x7D1CC7A9, /*  93  */
	0x6552B837, /*  94  */
	0x20192608, /*  95  */
	0xB97500C5, /*  96  */
	0xED296B44, /*  97  */
	0x368648B4, /*  98  */
	0x62995CD5, /*  99  */
	0x82731400, /*  100  */
	0xF9AEBD8B, /*  101  */
	0x3844C0C7, /*  102  */
	0x7C2DE794, /*  103  */
	0x33A1A770, /*  104  */
	0x8AE528C2, /*  105  */
	0x5A2BE812, /*  106  */
	0x1F8F4A07, /*  107  */
	0x2B5ED7CA, /*  108  */
	0x937EB564, /*  109  */
	0x6FDA7E11, /*  110  */
	0xE49B5D6C, /*  111  */
	0xB4B3244E, /*  112  */
	0x18AA53A4, /*  113  */
	0x3A061334, /*  114  */
	0x4D6067A3, /*  115  */
	0x83BA5868, /*  116  */
	0x9BDF4DFE, /*  117  */
	0x7449F261, /*  118  */
	0x709F8450, /*  119  */
	0xCAD133CB, /*  120  */
	0xDE941C3F, /*  121  */
	0xF52AE484, /*  122  */
	0x781D77ED, /*  123  */
	0x7E4395F0, /*  124  */
	0xAE103B59, /*  125  */
	0x922331BB, /*  126  */
	0x42CE50C8, /*  127  */
	0xE6F08153, /*  128  */
	0xE7D941D0, /*  129  */
	0x5028ED6B, /*  130  */
	0xB3D2C49B, /*  131  */
	0xAD4D9C3E, /*  132  */
	0xD201FB6E, /*  133  */
	0xA45BD5BE, /*  134  */
	0xFFCB7F4B, /*  135  */
	0x579D7806, /*  136  */
	0xF821BB5B, /*  137  */
	0x59D592AD, /*  138  */
	0xD0BE0C31, /*  139  */
	0xD4E3B676, /*  140  */
	0x0107165A, /*  141  */
	0x0FE939D2, /*  142  */
	0x49BCAAFD, /*  143  */
	0x55FFCFE5, /*  144  */
	0x2EC1F783, /*  145  */
	0xF39A09A5, /*  146  */
	0x3EB42772, /*  147  */
	0x19B55A5D, /*  148  */
	0x024A0679, /*  149  */
	0x8C83B3F7, /*  150  */
	0x8642BA1D, /*  151  */
	0xACACD9EA, /*  152  */
	0x87D352C4, /*  153  */
	0x60931F45, /*  154  */
	0xA05F97D7, /*  155  */
	0x1CECD42C, /*  156  */
	0xE2FCC87B, /*  157  */
	0xB60F94E2, /*  158  */
	0x67A34B0B, /*  159  */
	0xFCDD40C9, /*  160  */
	0x0B150A27, /*  161  */
	0xD3EE9E04, /*  162  */
	0x582E29E9, /*  163  */
	0x4AC22B41, /*  164  */
	0x6AC4E1B8, /*  165  */
	0xBCCAA51A, /*  166  */
	0x237AF30E, /*  167  */
	0xEBC3B709, /*  168  */
	0xC4A59D19, /*  169  */
	0x284BC98A, /*  170  */
	0xE9D41A93, /*  171  */
	0x6BFA2018, /*  172  */
	0x73B2D651, /*  173  */
	0x11F9A2FA, /*  174  */
	0xCE09BFF1, /*  175  */
	0x41A470AA, /*  176  */
	0x25888F22, /*  177  */
	0x77E754E8, /*  178  */
	0xF7330D8E, /*  179  */
	0x158EAB16, /*  180  */
	0xC5D68842, /*  181  */
	0xC685A6F6, /*  182  */
	0xE5B82FDE, /*  183  */
	0x09EA3A96, /*  184  */
	0x6DDE1536, /*  185  */
	0x4FA919DA, /*  186  */
	0x26C0BE9F, /*  187  */
	0x9EED6F69, /*  188  */
	0xF05555F2, /*  189  */
	0xE06FC285, /*  190  */
	0x9CD76D23, /*  191  */
	0xAF452A92, /*  192  */
	0xEFC74CB7, /*  193  */
	0x9D6B4732, /*  194  */
	0x8BE408EE, /*  195  */
	0x22401D0D, /*  196  */
	0xEE6C459D, /*  197  */
	0x7587CB82, /*  198  */
	0xE8746862, /*  199  */
	0x5CBDDE87, /*  200  */
	0x98794278, /*  201  */
	0x31AFB94D, /*  202  */
	0xC11E0F2F, /*  203  */
	0x30E8FC2A, /*  204  */
	0xCF3261EF, /*  205  */
	0x1A3023E1, /*  206  */
	0xAA2F86CF, /*  207  */
	0xF202E24A, /*  208  */
	0x8D08DCFF, /*  209  */
	0x764837C6, /*  210  */
	0xA26374CC, /*  211  */
	0x9F7C3E88, /*  212  */
	0x949CC57D, /*  213  */
	0xDD26A07F, /*  214  */
	0xC39EFAB0, /*  215  */
	0xC8F879A1, /*  216  */
	0xDCE67BB9, /*  217  */
	0xF4B0A435, /*  218  */
	0x912C9AE0, /*  219  */
	0xD85603E4, /*  220  */
	0x953A9BBF, /*  221  */
	0xFB8290D6, /*  222  */
	0x0AEBCD5F, /*  223  */
	0x16206A9A, /*  224  */
	0x6C787A14, /*  225  */
	0xD9A0F16A, /*  226  */
	0x29BF4F74, /*  227  */
	0x8F8BCE91, /*  228  */
	0x0E5A9354, /*  229  */
	0xAB038CB1, /*  230  */
	0x1B8AD11B, /*  231  */
	0xE327FF49, /*  232  */
	0x0053DA20, /*  233  */
	0x90CF51DC, /*  234  */
	0xDA92FE6D, /*  235  */
	0x0390CA47, /*  236  */
	0xA8958097, /*  237  */
	0xA9DC5BAF, /*  238  */
	0x3931E3C1, /*  239  */
	0x840446B6, /*  240  */
	0x63D069FB, /*  241  */
	0xD7460299, /*  242  */
	0x7124ECD1, /*  243  */
	0x0791E613, /*  244  */
	0x485918FC, /*  245  */
	0xD635D04C, /*  246  */
	0xDF96AC33, /*  247  */
	0x66F2D303, /*  248  */
	0x247056AE, /*  249  */
	0xA1A7B2A8, /*  250  */
	0x27D8CC9C, /*  251  */
	0x17B6E998, /*  252  */
	0x7BF5590F, /*  253  */
	0xFE97F557, /*  254  */
	0x5471D8A2  /*  255  */

################################################################################

TITLE
    Snefru S box 6

TYPE
    32

DATA
	0x83A327A1, /*  0  */
	0x9F379F51, /*  1  */
	0x40A7D007, /*  2  */
	0x11307423, /*  3  */
	0x224587C1, /*  4  */
	0xAC27D63B, /*  5  */
	0x3B7E64EA, /*  6  */
	0x2E1CBFA6, /*  7  */
	0x09996000, /*  8  */
	0x03BC0E2C, /*  9  */
	0xD4C4478A, /*  10  */
	0x4542E0AB, /*  11  */
	0xFEDA26D4, /*  12  */
	0xC1D10FCB, /*  13  */
	0x8252F596, /*  14  */
	0x4494EB5C, /*  15  */
	0xA362F314, /*  16  */
	0xF5BA81FD, /*  17  */
	0x75C3A376, /*  18  */
	0x4CA214CA, /*  19  */
	0xE164DEDD, /*  20  */
	0x5088FA97, /*  21  */
	0x4B0930E0, /*  22  */
	0x2FCFB7E8, /*  23  */
	0x33A6F4B2, /*  24  */
	0xC7E94211, /*  25  */
	0x2D66C774, /*  26  */
	0x43BE8BAE, /*  27  */
	0xC663D445, /*  28  */
	0x908EB130, /*  29  */
	0xF4E3BE15, /*  30  */
	0x63B9D566, /*  31  */
	0x529396B5, /*  32  */
	0x1E1BE743, /*  33  */
	0x4D5FF63F, /*  34  */
	0x985E4A83, /*  35  */
	0x71AB9DF7, /*  36  */
	0xC516C6F5, /*  37  */
	0x85C19AB4, /*  38  */
	0x1F4DAEE4, /*  39  */
	0xF2973431, /*  40  */
	0xB713DC5E, /*  41  */
	0x3F2E159A, /*  42  */
	0xC824DA16, /*  43  */
	0x06BF376A, /*  44  */
	0xB2FE23EC, /*  45  */
	0xE39B1C22, /*  46  */
	0xF1EECB5F, /*  47  */
	0x08E82D52, /*  48  */
	0x565686C2, /*  49  */
	0xAB0AEA93, /*  50  */
	0xFD47219F, /*  51  */
	0xEBDBABD7, /*  52  */
	0x2404A185, /*  53  */
	0x8C7312B9, /*  54  */
	0xA8F2D828, /*  55  */
	0x0C8902DA, /*  56  */
	0x65B42B63, /*  57  */
	0xC0BBEF62, /*  58  */
	0x4E3E4CEF, /*  59  */
	0x788F8018, /*  60  */
	0xEE1EBAB7, /*  61  */
	0x93928F9D, /*  62  */
	0x683D2903, /*  63  */
	0xD3B60689, /*  64  */
	0xAFCB0DDC, /*  65  */
	0x88A4C47A, /*  66  */
	0xF6DD9C3D, /*  67  */
	0x7EA5FCA0, /*  68  */
	0x8A6D7244, /*  69  */
	0xBE11F120, /*  70  */
	0x04FF91B8, /*  71  */
	0x8D2DC8C0, /*  72  */
	0x27F97FDB, /*  73  */
	0x7F9E1F47, /*  74  */
	0x1734F0C7, /*  75  */
	0x26F3ED8E, /*  76  */
	0x0DF8F2BF, /*  77  */
	0xB0833D9E, /*  78  */
	0xE420A4E5, /*  79  */
	0xA423CAE6, /*  80  */
	0x95616772, /*  81  */
	0x9AE6C049, /*  82  */
	0x075941F2, /*  83  */
	0xD8E12812, /*  84  */
	0xF6F4F, /*  85  */
	0x3C0D6B05, /*  86  */
	0x6CEF921C, /*  87  */
	0xB82BC264, /*  88  */
	0x396CB008, /*  89  */
	0x5D608A6F, /*  90  */
	0x6D7782C8, /*  91  */
	0x186550AA, /*  92  */
	0x6B6FEC09, /*  93  */
	0x28E70B13, /*  94  */
	0x57CE5688, /*  95  */
	0xECD3AF84, /*  96  */
	0x23335A95, /*  97  */
	0x91F40CD2, /*  98  */
	0x7B6A3B26, /*  99  */
	0xBD32B3B6, /*  100  */
	0x3754A6FB, /*  101  */
	0x8ED088F0, /*  102  */
	0xF867E87C, /*  103  */
	0x20851746, /*  104  */
	0x6410F9C6, /*  105  */
	0x35380442, /*  106  */
	0xC2CA10A7, /*  107  */
	0x1ADEA27F, /*  108  */
	0x76BDDD79, /*  109  */
	0x92742CF4, /*  110  */
	0x0E98F7EE, /*  111  */
	0x164E931D, /*  112  */
	0xB9C835B3, /*  113  */
	0x69060A99, /*  114  */
	0xB44C531E, /*  115  */
	0xFA7B66FE, /*  116  */
	0xC98A5B53, /*  117  */
	0x7D95AAE9, /*  118  */
	0x302F467B, /*  119  */
	0x74B811DE, /*  120  */
	0xF3866ABD, /*  121  */
	0xB5B3D32D, /*  122  */
	0xFC3157A4, /*  123  */
	0xD251FE19, /*  124  */
	0x0B5D8EAC, /*  125  */
	0xDA71FFD5, /*  126  */
	0x47EA05A3, /*  127  */
	0x05C6A9E1, /*  128  */
	0xCA0EE958, /*  129  */
	0x9939034D, /*  130  */
	0x25DC5EDF, /*  131  */
	0x79083CB1, /*  132  */
	0x86768450, /*  133  */
	0xCF757D6D, /*  134  */
	0x5972B6BC, /*  135  */
	0xA78D59C9, /*  136  */
	0xC4AD8D41, /*  137  */
	0x2A362AD3, /*  138  */
	0xD1179991, /*  139  */
	0x601407FF, /*  140  */
	0xDCF50917, /*  141  */
	0x587069D0, /*  142  */
	0xE0821ED6, /*  143  */
	0xDBB59427, /*  144  */
	0x73911A4B, /*  145  */
	0x7C904FC3, /*  146  */
	0x844AFB92, /*  147  */
	0x6F8C955D, /*  148  */
	0xE8C0C5BB, /*  149  */
	0xB67AB987, /*  150  */
	0xA529D96C, /*  151  */
	0xF91F7181, /*  152  */
	0x618B1B06, /*  153  */
	0xE718BB0C, /*  154  */
	0x8BD7615B, /*  155  */
	0xD5A93A59, /*  156  */
	0x54AEF81B, /*  157  */
	0x772136E3, /*  158  */
	0xCE44FD9C, /*  159  */
	0x10CDA57E, /*  160  */
	0x87D66E0B, /*  161  */
	0x3D798967, /*  162  */
	0x1B2C1804, /*  163  */
	0x3EDFBD68, /*  164  */
	0x15F6E62B, /*  165  */
	0xEF68B854, /*  166  */
	0x3896DB35, /*  167  */
	0x12B7B5E2, /*  168  */
	0xCB489029, /*  169  */
	0x9E4F98A5, /*  170  */
	0x62EB77A8, /*  171  */
	0x217C24A2, /*  172  */
	0x964152F6, /*  173  */
	0x49B2080A, /*  174  */
	0x53D23EE7, /*  175  */
	0x48FB6D69, /*  176  */
	0x1903D190, /*  177  */
	0x9449E494, /*  178  */
	0xBF6E7886, /*  179  */
	0xFB356CFA, /*  180  */
	0x3A261365, /*  181  */
	0x424BC1EB, /*  182  */
	0xA1192570, /*  183  */
	0x019CA782, /*  184  */
	0x9D3F7E0E, /*  185  */
	0x9C127575, /*  186  */
	0xEDF02039, /*  187  */
	0xAD57BCCE, /*  188  */
	0x5C153277, /*  189  */
	0x81A84540, /*  190  */
	0xBCAA7356, /*  191  */
	0xCCD59B60, /*  192  */
	0xA62A629B, /*  193  */
	0xA25CCD10, /*  194  */
	0x2B5B65CF, /*  195  */
	0x1C535832, /*  196  */
	0x55FD4E3A, /*  197  */
	0x31D9790D, /*  198  */
	0xF06BC37D, /*  199  */
	0x4AFC1D71, /*  200  */
	0xAEED5533, /*  201  */
	0xBA461634, /*  202  */
	0xBB694B78, /*  203  */
	0x5F3A5C73, /*  204  */
	0x6A3C764A, /*  205  */
	0x8FB0CCA9, /*  206  */
	0xF725684C, /*  207  */
	0x4FE5382F, /*  208  */
	0x1D0163AF, /*  209  */
	0x5AA07A8F, /*  210  */
	0xE205A8ED, /*  211  */
	0xC30BAD38, /*  212  */
	0xFF22CF1F, /*  213  */
	0x72432E2E, /*  214  */
	0x32C2518B, /*  215  */
	0x3487CE4E, /*  216  */
	0x7AE0AC02, /*  217  */
	0x709FA098, /*  218  */
	0x0A3B395A, /*  219  */
	0x5B4043F8, /*  220  */
	0xA9E48C36, /*  221  */
	0x149A8521, /*  222  */
	0xD07DEE6B, /*  223  */
	0x46ACD2F3, /*  224  */
	0x8958DFFC, /*  225  */
	0xB3A1223C, /*  226  */
	0xB11D31C4, /*  227  */
	0xCD7F4D3E, /*  228  */
	0x0F28E3AD, /*  229  */
	0xE5B100BE, /*  230  */
	0xAAC54824, /*  231  */
	0xE9C9D7BA, /*  232  */
	0x9BD47001, /*  233  */
	0x80F149B0, /*  234  */
	0x66022F0F, /*  235  */
	0x020C4048, /*  236  */
	0x6EFA192A, /*  237  */
	0x67073F8D, /*  238  */
	0x13EC7BF9, /*  239  */
	0x3655011A, /*  240  */
	0xE6AFE157, /*  241  */
	0xD9845F6E, /*  242  */
	0xDECC4425, /*  243  */
	0x511AE2CC, /*  244  */
	0xDF81B4D8, /*  245  */
	0xD7809E55, /*  246  */
	0xD6D883D9, /*  247  */
	0x2CC7978C, /*  248  */
	0x5E787CC5, /*  249  */
	0xDD0033D1, /*  250  */
	0xA050C937, /*  251  */
	0x97F75DCD, /*  252  */
	0x299DE580, /*  253  */
	0x41E2B261, /*  254  */
	0xEA5A54F1  /*  255  */

################################################################################

TITLE
    Snefru S box 7

TYPE
    32

DATA
	0x7E672590, /*  0  */
	0xBEA513BB, /*  1  */
	0x2C906FE6, /*  2  */
	0x86029C2B, /*  3  */
	0x55DC4F74, /*  4  */
	0x0553398E, /*  5  */
	0x63E09647, /*  6  */
	0xCAFD0BAB, /*  7  */
	0x264C37DF, /*  8  */
	0x8272210F, /*  9  */
	0x67AFA669, /*  10  */
	0x12D98A5F, /*  11  */
	0x8CAB23C4, /*  12  */
	0x75C68BD1, /*  13  */
	0xC3370470, /*  14  */
	0x33F37F4E, /*  15  */
	0x283992FF, /*  16  */
	0xE73A3A67, /*  17  */
	0x1032F283, /*  18  */
	0xF5AD9FC2, /*  19  */
	0x963F0C5D, /*  20  */
	0x664FBC45, /*  21  */
	0x202BA41C, /*  22  */
	0xC7C02D80, /*  23  */
	0x54731E84, /*  24  */
	0x8A1085F5, /*  25  */
	0x601D80FB, /*  26  */
	0x2F968E55, /*  27  */
	0x35E96812, /*  28  */
	0xE45A8F78, /*  29  */
	0xBD7DE662, /*  30  */
	0x3B6E6EAD, /*  31  */
	0x8097C5EF, /*  32  */
	0x070B6781, /*  33  */
	0xB1E508F3, /*  34  */
	0x24E4FAE3, /*  35  */
	0xB81A7805, /*  36  */
	0xEC0FC918, /*  37  */
	0x43C8774B, /*  38  */
	0x9B2512A9, /*  39  */
	0x2B05AD04, /*  40  */
	0x32C2536F, /*  41  */
	0xEDF236E0, /*  42  */
	0x8BC4B0CF, /*  43  */
	0xBACEB837, /*  44  */
	0x4535B289, /*  45  */
	0x0D0E94C3, /*  46  */
	0xA5A371D0, /*  47  */
	0xAD695A58, /*  48  */
	0x39E3437D, /*  49  */
	0x9186BFFC, /*  50  */
	0x21038C3B, /*  51  */
	0x0AA9DFF9, /*  52  */
	0x5D1F06CE, /*  53  */
	0x62DEF8A4, /*  54  */
	0xF740A2B4, /*  55  */
	0xA2575868, /*  56  */
	0x682683C1, /*  57  */
	0xDBB30FAC, /*  58  */
	0x61FE1928, /*  59  */
	0x468A6511, /*  60  */
	0xC61CD5F4, /*  61  */
	0xE54D9800, /*  62  */
	0x6B98D7F7, /*  63  */
	0x8418B6A5, /*  64  */
	0x5F09A5D2, /*  65  */
	0x90B4E80B, /*  66  */
	0x49B2C852, /*  67  */
	0x69F11C77, /*  68  */
	0x17412B7E, /*  69  */
	0x7F6FC0ED, /*  70  */
	0x56838DCC, /*  71  */
	0x6E9546A2, /*  72  */
	0xD0758619, /*  73  */
	0x087B9B9A, /*  74  */
	0xD231A01D, /*  75  */
	0xAF46D415, /*  76  */
	0x097060FD, /*  77  */
	0xD920F657, /*  78  */
	0x882D3F9F, /*  79  */
	0x3AE7C3C9, /*  80  */
	0xE8A00D9B, /*  81  */
	0x4FE67EBE, /*  82  */
	0x2EF80EB2, /*  83  */
	0xC1916B0C, /*  84  */
	0xF4DFFEA0, /*  85  */
	0xB97EB3EB, /*  86  */
	0xFDFF84DD, /*  87  */
	0xFF8B14F1, /*  88  */
	0xE96B0572, /*  89  */
	0xF64B508C, /*  90  */
	0xAE220A6E, /*  91  */
	0x4423AE5A, /*  92  */
	0xC2BECE5E, /*  93  */
	0xDE27567C, /*  94  */
	0xFC935C63, /*  95  */
	0x47075573, /*  96  */
	0xE65B27F0, /*  97  */
	0xE121FD22, /*  98  */
	0xF2668753, /*  99  */
	0x2DEBF5D7, /*  100  */
	0x8347E08D, /*  101  */
	0xAC5EDA03, /*  102  */
	0x2A7CEBE9, /*  103  */
	0x3FE8D92E, /*  104  */
	0x23542FE4, /*  105  */
	0x1FA7BD50, /*  106  */
	0xCF9B4102, /*  107  */
	0x9D0DBA39, /*  108  */
	0x9CB8902A, /*  109  */
	0xA7249D8B, /*  110  */
	0x0F6D667A, /*  111  */
	0x5EBFA9EC, /*  112  */
	0x6A594DF2, /*  113  */
	0x79600938, /*  114  */
	0x023B7591, /*  115  */
	0xEA2C79C8, /*  116  */
	0xC99D07EA, /*  117  */
	0x64CB5EE1, /*  118  */
	0x1A9CAB3D, /*  119  */
	0x76DB9527, /*  120  */
	0xC08E012F, /*  121  */
	0x3DFB481A, /*  122  */
	0x872F22E7, /*  123  */
	0x2948D15C, /*  124  */
	0xA4782C79, /*  125  */
	0x6F50D232, /*  126  */
	0x78F0728A, /*  127  */
	0x5A87AAB1, /*  128  */
	0xC4E2C19C, /*  129  */
	0xEE767387, /*  130  */
	0x1B2A1864, /*  131  */
	0x7B8D10D3, /*  132  */
	0xD1713161, /*  133  */
	0x0EEAC456, /*  134  */
	0xD8799E06, /*  135  */
	0xB645B548, /*  136  */
	0x4043CB65, /*  137  */
	0xA874FB29, /*  138  */
	0x4B12D030, /*  139  */
	0x7D687413, /*  140  */
	0x18EF9A1F, /*  141  */
	0xD7631D4C, /*  142  */
	0x5829C7DA, /*  143  */
	0xCDFA30FA, /*  144  */
	0xC5084BB0, /*  145  */
	0x92CD20E2, /*  146  */
	0xD4C16940, /*  147  */
	0x03283EC0, /*  148  */
	0xA917813F, /*  149  */
	0x9A587D01, /*  150  */
	0x70041F8F, /*  151  */
	0xDC6AB1DC, /*  152  */
	0xDDAEE3D5, /*  153  */
	0x31829742, /*  154  */
	0x198C022D, /*  155  */
	0x1C9EAFCB, /*  156  */
	0x5BBC6C49, /*  157  */
	0xD3D3293A, /*  158  */
	0x16D50007, /*  159  */
	0x04BB8820, /*  160  */
	0x3C5C2A41, /*  161  */
	0x37EE7AF8, /*  162  */
	0x8EB04025, /*  163  */
	0x9313ECBA, /*  164  */
	0xBFFC4799, /*  165  */
	0x8955A744, /*  166  */
	0xEF85D633, /*  167  */
	0x504499A7, /*  168  */
	0xA6CA6A86, /*  169  */
	0xBB3D3297, /*  170  */
	0xB34A8236, /*  171  */
	0x6DCCBE4F, /*  172  */
	0x06143394, /*  173  */
	0xCE19FC7B, /*  174  */
	0xCCC3C6C6, /*  175  */
	0xE36254AE, /*  176  */
	0x77B7EDA1, /*  177  */
	0xA133DD9E, /*  178  */
	0xEBF9356A, /*  179  */
	0x513CCF88, /*  180  */
	0xE2A1B417, /*  181  */
	0x972EE5BD, /*  182  */
	0x853824CD, /*  183  */
	0x5752F4EE, /*  184  */
	0x6C1142E8, /*  185  */
	0x3EA4F309, /*  186  */
	0xB2B5934A, /*  187  */
	0xDFD628AA, /*  188  */
	0x59ACEA3E, /*  189  */
	0xA01EB92C, /*  190  */
	0x389964BC, /*  191  */
	0xDA305DD4, /*  192  */
	0x019A59B7, /*  193  */
	0x11D2CA93, /*  194  */
	0xFAA6D3B9, /*  195  */
	0x4E772ECA, /*  196  */
	0x72651776, /*  197  */
	0xFB4E5B0E, /*  198  */
	0xA38F91A8, /*  199  */
	0x1D0663B5, /*  200  */
	0x30F4F192, /*  201  */
	0xB50051B6, /*  202  */
	0xB716CCB3, /*  203  */
	0x4ABD1B59, /*  204  */
	0x146C5F26, /*  205  */
	0xF134E2DE, /*  206  */
	0x00F67C6C, /*  207  */
	0xB0E1B795, /*  208  */
	0x98AA4EC7, /*  209  */
	0x0CC73B34, /*  210  */
	0x654276A3, /*  211  */
	0x8D1BA871, /*  212  */
	0x740A5216, /*  213  */
	0xE0D01A23, /*  214  */
	0x9ED161D6, /*  215  */
	0x9F36A324, /*  216  */
	0x993EBB7F, /*  217  */
	0xFEB9491B, /*  218  */
	0x365DDCDB, /*  219  */
	0x810CFFC5, /*  220  */
	0x71EC0382, /*  221  */
	0x2249E7BF, /*  222  */
	0x48817046, /*  223  */
	0xF3A24A5B, /*  224  */
	0x4288E4D9, /*  225  */
	0x0BF5C243, /*  226  */
	0x257FE151, /*  227  */
	0x95B64C0D, /*  228  */
	0x4164F066, /*  229  */
	0xAAF7DB08, /*  230  */
	0x73B1119D, /*  231  */
	0x8F9F7BB8, /*  232  */
	0xD6844596, /*  233  */
	0xF07A34A6, /*  234  */
	0x53943D0A, /*  235  */
	0xF9DD166D, /*  236  */
	0x7A8957AF, /*  237  */
	0xF8BA3CE5, /*  238  */
	0x27C9621E, /*  239  */
	0x5CDAE910, /*  240  */
	0xC8518998, /*  241  */
	0x941538FE, /*  242  */
	0x136115D8, /*  243  */
	0xABA8443C, /*  244  */
	0x4D01F931, /*  245  */
	0x34EDF760, /*  246  */
	0xB45F266B, /*  247  */
	0xD5D4DE14, /*  248  */
	0x52D8AC35, /*  249  */
	0x15CFD885, /*  250  */
	0xCBC5CD21, /*  251  */
	0x4CD76D4D, /*  252  */
	0x7C80EF54, /*  253  */
	0xBC92EE75, /*  254  */
	0x1E56A1F6  /*  255  */

################################################################################

TITLE
    m_huffman.c (from doomsday)

TYPE
    FLOAT

DATA
    0.261347881463, 0.016916769232, 0.099777149782, 0.007231102512,
    0.078927148320, 0.003303840954, 0.003997674320, 0.051381346053,
    0.004863421887, 0.002004704890, 0.023628011432, 0.001021396833,
    0.010792094170, 0.001282047587, 0.001111368696, 0.000778452212,
    0.005905613133, 0.000729039747, 0.002841010864, 0.011992199419,
    0.005981378912, 0.000727804435, 0.005555402285, 0.000820864578,
    0.003674846214, 0.001290077112, 0.001652229305, 0.002900099937,
    0.001201340560, 0.000922983673, 0.001000602420, 0.000942748659,
    0.008744976914, 0.000595008435, 0.001374078303, 0.001144927996,
    0.003616374797, 0.001251164796, 0.001358019252, 0.001723053839,
    0.000872747667, 0.001004926011, 0.000651009229, 0.001242517615,
    0.001207723004, 0.001599728561, 0.001360901646, 0.001332695364,
    0.004142205781, 0.001597669708, 0.001850702707, 0.001053309050,
    0.000786069967, 0.001016867357, 0.002317650503, 0.000990308157,
    0.001347519103, 0.001928115569, 0.001500491860, 0.002002234267,
    0.001933674472, 0.001370784139, 0.001208134774, 0.001714612542,
    0.005039453795, 0.002550918516, 0.002118353560, 0.003177839168,
    0.001923380208, 0.001494932958, 0.001643582124, 0.001712553690,
    0.001529521683, 0.001255900157, 0.001523345125, 0.001288635915,
    0.001455402985, 0.000617861700, 0.000676333117, 0.000837541285,
    0.003083749599, 0.000586361254, 0.000994425862, 0.001056191444,
    0.000882836045, 0.002295209009, 0.001077397627, 0.001015014389,
    0.001331665937, 0.001822084654, 0.003632227963, 0.001015837930,
    0.000865335797, 0.000736863387, 0.000598302599, 0.000684774414,
    0.003247016619, 0.001498638892, 0.000759098997, 0.000711745384,
    0.000926895493, 0.000828482333, 0.000836100088, 0.000679215511,
    0.001347724988, 0.000768775604, 0.000724510271, 0.001178487295,
    0.000712363040, 0.000693009824, 0.000760951964, 0.000659656410,
    0.006524298374, 0.000662950575, 0.000968690203, 0.001575022328,
    0.001306547934, 0.001461785429, 0.001409078799, 0.000990514042,
    0.001219870235, 0.002090147278, 0.001233664548, 0.000780511065,
    0.000655950476, 0.000589037762, 0.005355281801, 0.002871275999,
    0.012205908331, 0.001121457075, 0.001259194322, 0.001241282303,
    0.000553213725, 0.000456447647, 0.000562272677, 0.000433594382,
    0.000508124850, 0.000560625595, 0.000521095623, 0.000535095821,
    0.000518007344, 0.000676539003, 0.000595626091, 0.000676744888,
    0.011022685675, 0.001302841999, 0.001583257739, 0.001272782749,
    0.001249105943, 0.001152751636, 0.000997308256, 0.000526448640,
    0.000746128225, 0.000989484616, 0.001275047487, 0.001116309943,
    0.001525403978, 0.001194134576, 0.001201134675, 0.000638244342,
    0.009756079483, 0.000558566742, 0.000810364429, 0.000763010817,
    0.001378607779, 0.001397137454, 0.001303253770, 0.001260841404,
    0.001317253968, 0.001550110210, 0.001201752331, 0.001166340064,
    0.001016867357, 0.001269282700, 0.001046514836, 0.000477653830,
    0.009010363029, 0.000524595672, 0.000525419213, 0.000557743201,
    0.000509154277, 0.000721216107, 0.000516977917, 0.000750040045,
    0.000867188764, 0.000793893608, 0.000699186383, 0.001072662265,
    0.000882630160, 0.000708039449, 0.000686627381, 0.000714010122,
    0.009556370770, 0.000669333018, 0.000901983375, 0.001089338972,
    0.001178899066, 0.001021808603, 0.001060309149, 0.001137927897,
    0.001738083463, 0.001676935538, 0.001687847457, 0.001666435389,
    0.001912468289, 0.001787084158, 0.001850702707, 0.003220869190,
    0.010349029066, 0.002433769796, 0.002500064854, 0.001287194718,
    0.001127839518, 0.001192487493, 0.001099839121, 0.001036632343,
    0.001130310141, 0.001100868548, 0.001021808603, 0.000994631747,
    0.001126810092, 0.001035602916, 0.001080485906, 0.001121868845,
    0.009375809386, 0.001078632938, 0.001236546942, 0.001240870532,
    0.001318901050, 0.001059897379, 0.001052691394, 0.001085221267,
    0.001181369689, 0.000856276845, 0.001283900554, 0.001125163010,
    0.001325901150, 0.001437902737, 0.001482373956, 0.001487726973,
    0.005829023811, 0.001277929881, 0.001573787017, 0.001741377628,
    0.001309636213, 0.001333930675, 0.000908983474, 0.001500080089,
    0.001828055327, 0.001625670105, 0.001895379811, 0.002661273022,
    0.003641698685, 0.003401018803, 0.005049130402, 0.010072525146

################################################################################

TITLE
    anti-debug: INT 41h Debugger Notification

TYPE
    8 HEX

DATA
    57              // push edi
    6a 4f           // PUSH 0000004F
    68 2a 00 2a 00  // PUSH 002A002A
    e8              // CALL ...
                    // 66 2d 86 f3  // SUB AX,F386
                    // 5f           // pop edi

################################################################################

TITLE
    anti-debug: INT 3's with SoftICE's I3HERE

TYPE
    8 HEX

DATA
    66 be 47 46     // MOV SI,4647
    66 bf 4d 4a     // MOV DI,4A4D
    0e              // PUSH CS
    1f              // POP DS
    66 b8 11 09     // MOV AX,0911h
    66 ba 0e 00     // MOV DX,000Eh
    cd 03           // INT 3

################################################################################

TITLE
    anti-debug: BCHK BoundsChecker interface

TYPE
    8 HEX

DATA
    BD 4B 48 43 42  // MOV EBP,4243484B
    66 B8 04 00     // MOV AX,4
    CD 03           // INT 3
    3C 04           // CMP AL,4

################################################################################

TITLE
    anti-debug: ICECream detection (Windows 95).

TYPE
    8 HEX

DATA
                        // SIDT FWORD PTR opIDT <-- Store IDT.
                        // MOV EAX, DWORD PTR [opIDT+2] <-- EAX=IDT.
    83 C0 08            // ADD EAX,8
    8B 18               // MOV EBX,DWORD PTR DS:[EAX]
    83 C0 10            // ADD EAX,10
    8B 00               // MOV EAX,DWORD PTR DS:[EAX]
    25 FF FF 00 00      // AND EAX,0000FFFF
    81 E3 FF FF 00 00   // AND EBX,0000FFFF
    29 D8               // SUB EAX,EBX
    83 F8 1E            // CMP EAX,1E

################################################################################

TITLE
    anti-debug: Detect SoftICE VxD or SoftICE GFX VxD 

TYPE
    8 HEX

DATA
    66 31 FF        // XOR DI,DI
    8E C7           // MOV ES,DI
    66 B8 84 16     // MOV AX,1684
    66 BB 02 02     // MOV BX,202
    CD 2F           // INT 2F
    66 8C C0        // MOV AX,ES
    66 01 C7        // ADD DI,AX
    66 83 FF 00     // CMP DI,0

################################################################################

TITLE
    anti-debug: Detect WinICE handler using INT 68h (V86) since SoftICE hooks

TYPE
    8 HEX

DATA
                    // MOV ECX, 0
                    // MOV CX, CS
                    // XOR CL, CL
                    // JECX _dont_use_this_method
    B4 43           // MOV AH,43
    CD 68           // INT 68
    66 3D 86 F3     // CMP AX,0F386

################################################################################

TITLE
    anti-debug: another INT 68h handler

TYPE
    8 HEX

DATA
    66 31 C0                // XOR AX,AX
    8E C0                   // MOV ES,AX
    26 66 8B 1D A0 01 00 00 // MOV BX,WORD PTR ES:[1A0]
    26 8E 05 A2 01 00 00    // MOV ES,WORD PTR ES:[1A2]
    B8 80 FC 43 0F          // MOV EAX,0F43FC80
    26 3B 03                // CMP EAX,DWORD PTR ES:[EBX]

################################################################################

TITLE
    anti-debug: Detect and crash SoftICE with an illegal form of the instruction CMPXCHG8B

TYPE
    8 HEX

DATA
    F0 0F C7 C8             // LOCK CMPXCHG8B EAX

################################################################################

TITLE
    anti-debug: WINICE.BR

TYPE
    8

DATA
    "WINICE.BR"

################################################################################

TITLE
    anti-debug: SOFTICE1

TYPE
    8

DATA
    "SOFTICE1"

################################################################################
#
#TITLE
#    anti-debug: Dongle protection
#
#TYPE
#    8 HEX
#
#DATA
#    EB 01       // JMP $+1
#    E8          // DB E8h
#
################################################################################

TITLE
    anti-debug: IsDebuggerPresent

TYPE
    8

DATA
    "IsDebuggerPresent"

################################################################################

TITLE
    anti-debug: SOFTWARE\\NuMega

TYPE
    8

DATA
    "SOFTWARE\\NuMega\0"

################################################################################

TITLE
    anti-debug: SYSTEM\\CurrentControlSet\\Services\\IceExt

TYPE
    8

DATA
    "SYSTEM\\CurrentControlSet\\Services\\IceExt\0"

################################################################################

TITLE
    anti-debug: CheckForSoftICEBP

TYPE
    8 HEX

DATA
    56                      // PUSH ESI
    1E                      // PUSH DS
    0E                      // PUSH CS
    1F                      // POP DS
    8B 76 02                // MOV ESI,DWORD PTR DS:[ESI+2]
    8B 36                   // MOV ESI,DWORD PTR DS:[ESI]
    89 F0                   // MOV EAX,ESI
    25 FF 00 00 00          // AND EAX,000000FF
    3C CC                   // CMP AL,0CC

################################################################################

TITLE
    anti-debug: W32Dasm bug

TYPE
    8 HEX

DATA
    EB 03                   // JMP SHORT signsrch.00401005
    90 90 90                // NOPs
    EB F9                   // JMP SHORT signsrch.00401000

################################################################################

TITLE
    anti-debug: Detection from SafeDisc, this is the content of secdrv.sys

TYPE
    8 HEX

DATA
    0F 21 F8                // MOV EAX,DR0
    25 00 05 00 00          // AND EAX,00000500
    89 01                   // MOV DWORD PTR DS:[ECX],EAX

################################################################################

TITLE
    anti-debug: Detect single-stepping and turn off the monitor (1)

TYPE
    8 HEX

DATA
    66 BA C4 03             // MOV DX,3C4
    B0 01                   // MOV AL,1
    EE                      // OUT DX,AL
    66 42                   // INC DX
    EC                      // IN AL,DX
    0C 20                   // OR AL,20
    EE                      // OUT DX,AL

################################################################################

TITLE
    anti-debug: Detect single-stepping and turn off the monitor (2)

TYPE
    8 HEX

DATA
    66 BA C4 03             // MOV DX,3C4
    B0 01                   // MOV AL,1
    EE                      // OUT DX,AL
    66 42                   // INC DX
    EC                      // IN AL,DX
    20 D0                   // AND AL,DL
    EE                      // OUT DX,AL

################################################################################

TITLE
    anti-debug: Exit the program if its being debugged by checking execution timing

TYPE
    8 HEX

DATA
    0F 31           // RDTSC
    33 C9           // XOR ECX,ECX
    03 C8           // ADD ECX,EAX
    0F 31           // RDTSC
    2B C1           // SUB EAX,ECX
    3D FF 0F 00 00  // CMP EAX,0FFF
    EB 08           // JB SHORT _FAST_ENOUGH
    6A 00           // PUSH 0 ; ExitCode = 0 

################################################################################

TITLE
    anti-debug: UnhandledExceptionFilter protection

TYPE
    8 HEX

DATA
                    // MOV EDI, UnhandledExceptionFilter
    B9 06 00 00 00  // MOV ECX,6
    B0 CC           // MOV AL,0CC
    F2 AE           // REPNE SCAS BYTE PTR ES:[EDI]
    85 C9           // TEST ECX,ECX

################################################################################

TITLE
    anti-debug: anti-VMWare

TYPE
    8 HEX

DATA
    B8 68 58 4D 56  // MOV EAX,564D5868
    BB 00 00 00 00  // MOV EBX,0
    B9 0A 00 00 00  // MOV ECX,0A
    BA 58 56 00 00  // MOV EDX,5658
    ED              // IN EAX,DX

################################################################################

TITLE
    anti-debug: PEB!IsDebugged

TYPE
    8 HEX

DATA
    64 A1 30 00 00 00   // MOV EAX,DWORD PTR FS:[30]
    0F B6 40 02         // MOVZX EAX,BYTE PTR DS:[EAX+2]
    85 C0               // TEST EAX,EAX

################################################################################

TITLE
    anti-debug: PEB!IsDebugged (2)

TYPE
    8 HEX

DATA
    64 A1 30 00 00 00   // MOV EAX,DWORD PTR FS:[30]
    8b 40 02            // MOV EAX,DWORD PTR DS:[EAX+2]
    85 C0               // TEST EAX,EAX

################################################################################

TITLE
    anti-debug: PEB!NtGlobalFlags

TYPE
    8 HEX

DATA
    64 A1 30 00 00 00   // MOV EAX,DWORD PTR FS:[30]
    8B 40 68            // MOV EAX,DWORD PTR DS:[EAX+68]
    83 E0 70            // AND EAX,00000070
    85 C0               // TEST EAX,EAX

################################################################################

TITLE
    anti-debug: Heap flags

TYPE
    8 HEX

DATA
    64 A1 30 00 00 00   // MOV EAX,DWORD PTR FS:[30]
    8B 40 18            // MOV EAX,DWORD PTR DS:[EAX+18]
    8B 40 10            // MOV EAX,DWORD PTR DS:[EAX+10]
    85 C0               // TEST EAX,EAX

################################################################################

TITLE
    anti-debug: Vista anti-debug (no name)

TYPE
    8 HEX

DATA
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    64 A1 18 00 00 00       // MOV EAX,DWORD PTR FS:[18]
    05 FC 0B 00 00          // ADD EAX,0BFC
    8B 18                   // MOV EBX,DWORD PTR DS:[EAX]
    85 DB                   // TEST EBX,EBX

################################################################################

TITLE
    anti-debug: NtSetInformationThread (partial)

TYPE
    8 HEX

DATA
    6A 00               // PUSH 0
    6A 00               // PUSH 0
    6A 11               // PUSH 11
    6A FE               // PUSH -2
    e8                  // call NtSetInformationThread 

################################################################################

TITLE
    anti-debug: kernel32!CloseHandle and NtClose

TYPE
    8 HEX

DATA
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    68 34 12 00 00          // PUSH 1234
    e8                      // call CloseHandle

################################################################################

TITLE
    anti-debug: Timestamp counters

TYPE
    8 HEX

DATA
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    0F 31                   // RDTSC
    50                      // PUSH EAX
    31 C0                   // XOR EAX,EAX
    F7 F0                   // DIV EAX
    0F 31                   // RDTSC
    2B 04 E4                // SUB EAX,DWORD PTR SS:[ESP]
    83 C4 04                // ADD ESP,4
    64 8F 05 00 00 00 00    // POP DWORD PTR FS:[0]
    83 C4 04                // ADD ESP,4
    3D 00 00 01 00          // CMP EAX,10000

################################################################################

TITLE
    anti-debug: Popf and the trap flag

TYPE
    8 HEX

DATA
    9C                      // PUSHFD
    C7 04 E4 00 01 00 00    // MOV DWORD PTR SS:[ESP],100
    9D                      // POPFD

################################################################################

TITLE
    anti-debug: Stack Segment register

TYPE
    8 HEX

DATA
    16                      // PUSH SS
    17                      // POP SS
    9C                      // PUSHFD
    90                      // NOP

################################################################################

TITLE
    anti-debug: Debug registers manipulation (1)

TYPE
    8 HEX

DATA
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    31 C0                   // XOR EAX,EAX
    F7 F0                   // DIV EAX
    64 8F 05 00 00 00 00    // POP DWORD PTR FS:[0]
    83 C4 04                // ADD ESP,4

################################################################################

TITLE
    anti-debug: Debug registers manipulation (2)

TYPE
    8 HEX

DATA
    8B 4C E4 0C             // MOV ECX,DWORD PTR SS:[ESP+0C]
    83 81 B8 00 00 00 02    // ADD DWORD PTR DS:[ECX+0B8],2
    C7 41 04 00 00 00 00    // MOV DWORD PTR DS:[ECX+4],0
    C7 41 08 00 00 00 00    // MOV DWORD PTR DS:[ECX+8],0
    C7 41 0C 00 00 00 00    // MOV DWORD PTR DS:[ECX+0C],0
    C7 41 10 00 00 00 00    // MOV DWORD PTR DS:[ECX+10],0
    C7 41 14 00 00 00 00    // MOV DWORD PTR DS:[ECX+14],0
    C7 41 18 00 00 00 00    // MOV DWORD PTR DS:[ECX+18],0
    31 C0                   // XOR EAX,EAX

################################################################################

TITLE
    anti-debug: IsIceSIDT

TYPE
    8 HEX

DATA
    83 C0 08                // ADD EAX,8
    8B 18                   // MOV EBX,DWORD PTR DS:[EAX]
    83 C0 16                // ADD EAX,16
    8B 00                   // MOV EAX,DWORD PTR DS:[EAX]
    25 FF FF 00 00          // AND EAX,0000FFFF
    81 E3 FF FF 00 00       // AND EBX,0000FFFF
    29 D8                   // SUB EAX,EBX
    83 F8 1E                // CMP EAX,1E

################################################################################

TITLE
    anti-debug: Rose's TRAP #1

TYPE
    8 HEX

DATA
    66 8C CA                // MOV DX,CS
    66 31 DB                // XOR BX,BX
    66 89 D9                // MOV CX,BX
    8E C3                   // MOV ES,BX
    FA                      // CLI
    67 26 66 87 07          // XCHG WORD PTR ES:[BX],AX
    67 26 66 87 57 02       // XCHG WORD PTR ES:[BX+2],DX
    FB                      // STI
    66 F7 F1                // DIV CX
    66 B8 00 4C             // MOV AX,4C00
    CD 21                   // INT 21
    FA                      // CLI
    67 26 66 87 07          // XCHG WORD PTR ES:[BX],AX
    67 26 66 87 57 02       // XCHG WORD PTR ES:[BX+2],DX
    FB                      // STI

################################################################################

TITLE
    anti-debug: Rose's TRAP #3

TYPE
    8 HEX

DATA
    B4 09                   // MOV AH,9
    CD 21                   // INT 21
    66 B8 00 4C             // MOV AX,4C00
    CD 21                   // INT 21

################################################################################

TITLE
    anti-debug: Rose's TRAP #4 (1)

TYPE
    8 HEX

DATA
    0F 21 F8                // MOV EAX,DR0
    0D 00 20 00 00          // OR EAX,00002000
    0F 23 F8                // MOV DR0,EAX
    0F 21 F8                // MOV EAX,DR0

################################################################################

TITLE
    anti-debug: Rose's UAC

TYPE
    8 HEX

DATA
    1E                      // PUSH DS
    66 31 C0                // XOR AX,AX
    8E D8                   // MOV DS,AX
    66 F7 15 05 00 00 00    // NOT WORD PTR DS:[5]
    EB 01                   // JMP SHORT 004011DA
    9a                      // db 9a
    66 F7 15 05 00 00 00    // NOT WORD PTR DS:[5]
    1F                      // POP DS

################################################################################

TITLE
    anti-debug: Softice \\.\SICE

TYPE
    8

DATA
    "\\\\.\\SICE\0"

################################################################################

TITLE
    anti-debug: Softice \\.\NTICE

TYPE
    8

DATA
    "\\\\.\\NTICE\0"

################################################################################

TITLE
    anti-debug: Softice \\.\SIWVID

TYPE
    8

DATA
    "\\\\.\\SIWVID\0"

################################################################################

TITLE
    anti-debug: Softice C:\siw95\nmtrans.dll

TYPE
    8

DATA
    "C:\\siw95\\nmtrans.dll\0"

################################################################################

TITLE
    anti-debug: Softice C:\ntice\nmtrans.dll

TYPE
    8

DATA
    "C:\\ntice\\nmtrans.dll\0"

################################################################################

TITLE
    anti-debug: Softice NmSymIsSoftICELoaded

TYPE
    8

DATA
    "NmSymIsSoftICELoaded\0"

################################################################################

TITLE
    anti-debug: SEH handler trick

TYPE
    8 HEX

DATA
    50                      // PUSH EAX
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    33 C0                   // XOR EAX,EAX
    C7 00 00 01 00 00       // MOV DWORD PTR DS:[EAX],100

################################################################################

TITLE
    anti-debug: SEH handler trick (alternate way)

TYPE
    8 HEX

DATA
    //    mov ecx, -100h
    //    push fs
    //    pop es
    //    mov eax, 12345678h
    //    push eax
    //    lea eax, ContinueCode
    89 44 24 FC             // MOV DWORD PTR SS:[ESP-4],EAX
    26 8B 99 00 01 00 00    // MOV EBX,DWORD PTR ES:[ECX+100]
    53                      // PUSH EBX
    8B 04 24                // MOV EAX,DWORD PTR SS:[ESP]
    8B 18                   // MOV EBX,DWORD PTR DS:[EAX]
    26 89 81 00 01 00 00    // MOV DWORD PTR ES:[ECX+100],EAX

################################################################################

TITLE
    anti-debug: Obfuscated RDTSC

TYPE
    8 HEX

DATA
    5B                      // POP EBX
    8B CC                   // MOV ECX,ESP
    83 C1 04                // ADD ECX,4
    8B F4                   // MOV ESI,ESP
    83 C6 10                // ADD ESI,10
    55                      // PUSH EBP
    6A 01                   // PUSH 1
    53                      // PUSH EBX
    6A 02                   // PUSH 2
    6A 03                   // PUSH 3
    B8 20 32 97 7C          // MOV EAX,7C973220

################################################################################

TITLE
    anti-debug: OllyDbg Instruction Prefix Detection

TYPE
    8 HEX

DATA
    64 FF 35 00 00 00 00    // PUSH DWORD PTR FS:[0]
    64 89 25 00 00 00 00    // MOV DWORD PTR FS:[0],ESP
    F3 64                   // PREFIX REP:
    F1                      // INT1
    64 8F 05 00 00 00 00    // POP DWORD PTR FS:[0]
    83 C4 04                // ADD ESP,4
    61                      // POPAD
    6A 30                   // PUSH 30

################################################################################

TITLE
    anti-debug: PeID GenOEP Spoofing

TYPE
    8 HEX

DATA
    55h,8Bh,0ECh,6Ah,0FFh,68h,0F8h,40h,40h,00h,68h,0F4h
    1Dh,40h,00h,64h,0A1h,00,00,00,00,50h,64h,89h,25h,00
    00,00,00,83h,0ECh,58h,53h,56h,57h,89h,65h,0E8h,0FFh
    15h,58h,40h,40h,00,33h,0D2h,8Ah,0D4h

################################################################################

TITLE
    anti-debug: PeID OEP Signature Spoofing

TYPE
    8 HEX

DATA
    0EBh,03h,3Ah,4Dh,3Ah,1Eh,0EBh,02h,0CDh,20h,9Ch,0EBh,02h,0CDh,20h,0EBh,02h,0CDh,20h,60h

################################################################################

TITLE
    anti-debug: ProcDump PE Header Corruption

TYPE
    8 HEX

DATA
    BB 3C 00 40 00      // MOV EBX,0040003C
    8B 0B               // MOV ECX,DWORD PTR DS:[EBX]
    81 C1 06 00 40 00   // ADD ECX,00400006
    33 DB               // XOR EBX,EBX
    66 8B 19            // MOV BX,WORD PTR DS:[ECX]
    51                  // PUSH ECX
    81 C1 F2 00 00 00   // ADD ECX,0F2
    BA 28 00 00 00      // MOV EDX,28
    C6 01 00            // MOV BYTE PTR DS:[ECX],0
    41                  // INC ECX
    4A                  // DEC EDX

################################################################################

TITLE
    anti-debug: RDG OEP Signature Spoofing

TYPE
    8 HEX

DATA
    0Bh,0B6h,66h,0B1h,22h,0B7h

################################################################################

TITLE
    anti-debug: RDTSC Instruction Debugger Latency Detection

TYPE
    8 HEX

DATA
    0F 31                   // RDTSC
    33 C9                   // XOR ECX,ECX
    03 C8                   // ADD ECX,EAX
    0F 31                   // RDTSC
    2B C1                   // SUB EAX,ECX
    3D FF 0F 00 00          // CMP EAX,0FFF

################################################################################

TITLE
    bitmask

TYPE
    32 HEX

DATA
	0x00000001, 0x00000003, 0x00000007, 0x0000000F,
	0x0000001F,	0x0000003F,	0x0000007F,	0x000000FF,
	0x000001FF,	0x000003FF,	0x000007FF,	0x00000FFF,
	0x00001FFF,	0x00003FFF,	0x00007FFF,	0x0000FFFF,
	0x0001FFFF,	0x0003FFFF,	0x0007FFFF,	0x000FFFFF,
	0x001FFFFf,	0x003FFFFF,	0x007FFFFF,	0x00FFFFFF,
	0x01FFFFFF,	0x03FFFFFF,	0x07FFFFFF,	0x0FFFFFFF,
	0x1FFFFFFF,	0x3FFFFFFF,	0x7FFFFFFF,	0xFFFFFFFF,

################################################################################

TITLE
    Quake 3 msg_hData (huffman)

TYPE
    32

DATA
250315,			// 0
41193,			// 1
6292,			// 2
7106,			// 3
3730,			// 4
3750,			// 5
6110,			// 6
23283,			// 7
33317,			// 8
6950,			// 9
7838,			// 10
9714,			// 11
9257,			// 12
17259,			// 13
3949,			// 14
1778,			// 15
8288,			// 16
1604,			// 17
1590,			// 18
1663,			// 19
1100,			// 20
1213,			// 21
1238,			// 22
1134,			// 23
1749,			// 24
1059,			// 25
1246,			// 26
1149,			// 27
1273,			// 28
4486,			// 29
2805,			// 30
3472,			// 31
21819,			// 32
1159,			// 33
1670,			// 34
1066,			// 35
1043,			// 36
1012,			// 37
1053,			// 38
1070,			// 39
1726,			// 40
888,			// 41
1180,			// 42
850,			// 43
960,			// 44
780,			// 45
1752,			// 46
3296,			// 47
10630,			// 48
4514,			// 49
5881,			// 50
2685,			// 51
4650,			// 52
3837,			// 53
2093,			// 54
1867,			// 55
2584,			// 56
1949,			// 57
1972,			// 58
940,			// 59
1134,			// 60
1788,			// 61
1670,			// 62
1206,			// 63
5719,			// 64
6128,			// 65
7222,			// 66
6654,			// 67
3710,			// 68
3795,			// 69
1492,			// 70
1524,			// 71
2215,			// 72
1140,			// 73
1355,			// 74
971,			// 75
2180,			// 76
1248,			// 77
1328,			// 78
1195,			// 79
1770,			// 80
1078,			// 81
1264,			// 82
1266,			// 83
1168,			// 84
965,			// 85
1155,			// 86
1186,			// 87
1347,			// 88
1228,			// 89
1529,			// 90
1600,			// 91
2617,			// 92
2048,			// 93
2546,			// 94
3275,			// 95
2410,			// 96
3585,			// 97
2504,			// 98
2800,			// 99
2675,			// 100
6146,			// 101
3663,			// 102
2840,			// 103
14253,			// 104
3164,			// 105
2221,			// 106
1687,			// 107
3208,			// 108
2739,			// 109
3512,			// 110
4796,			// 111
4091,			// 112
3515,			// 113
5288,			// 114
4016,			// 115
7937,			// 116
6031,			// 117
5360,			// 118
3924,			// 119
4892,			// 120
3743,			// 121
4566,			// 122
4807,			// 123
5852,			// 124
6400,			// 125
6225,			// 126
8291,			// 127
23243,			// 128
7838,			// 129
7073,			// 130
8935,			// 131
5437,			// 132
4483,			// 133
3641,			// 134
5256,			// 135
5312,			// 136
5328,			// 137
5370,			// 138
3492,			// 139
2458,			// 140
1694,			// 141
1821,			// 142
2121,			// 143
1916,			// 144
1149,			// 145
1516,			// 146
1367,			// 147
1236,			// 148
1029,			// 149
1258,			// 150
1104,			// 151
1245,			// 152
1006,			// 153
1149,			// 154
1025,			// 155
1241,			// 156
952,			// 157
1287,			// 158
997,			// 159
1713,			// 160
1009,			// 161
1187,			// 162
879,			// 163
1099,			// 164
929,			// 165
1078,			// 166
951,			// 167
1656,			// 168
930,			// 169
1153,			// 170
1030,			// 171
1262,			// 172
1062,			// 173
1214,			// 174
1060,			// 175
1621,			// 176
930,			// 177
1106,			// 178
912,			// 179
1034,			// 180
892,			// 181
1158,			// 182
990,			// 183
1175,			// 184
850,			// 185
1121,			// 186
903,			// 187
1087,			// 188
920,			// 189
1144,			// 190
1056,			// 191
3462,			// 192
2240,			// 193
4397,			// 194
12136,			// 195
7758,			// 196
1345,			// 197
1307,			// 198
3278,			// 199
1950,			// 200
886,			// 201
1023,			// 202
1112,			// 203
1077,			// 204
1042,			// 205
1061,			// 206
1071,			// 207
1484,			// 208
1001,			// 209
1096,			// 210
915,			// 211
1052,			// 212
995,			// 213
1070,			// 214
876,			// 215
1111,			// 216
851,			// 217
1059,			// 218
805,			// 219
1112,			// 220
923,			// 221
1103,			// 222
817,			// 223
1899,			// 224
1872,			// 225
976,			// 226
841,			// 227
1127,			// 228
956,			// 229
1159,			// 230
950,			// 231
7791,			// 232
954,			// 233
1289,			// 234
933,			// 235
1127,			// 236
3207,			// 237
1020,			// 238
927,			// 239
1355,			// 240
768,			// 241
1040,			// 242
745,			// 243
952,			// 244
805,			// 245
1073,			// 246
740,			// 247
1013,			// 248
805,			// 249
1008,			// 250
796,			// 251
996,			// 252
1057,			// 253
11457,			// 254
13504,			// 255

################################################################################

TITLE
    Torque Huffman frequency table

TYPE
    32

DATA
       0,    0,    0,    0,    0,    0,    0,    0,
       0,  329,   21,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
    2809,   68,    0,   27,    0,   58,    3,   62,
       4,    7,    0,    0,   15,   65,  554,    3,
     394,  404,  189,  117,   30,   51,   27,   15,
      34,   32,   80,    1,  142,    3,  142,   39,
       0,  144,  125,   44,  122,  275,   70,  135,
      61,  127,    8,   12,  113,  246,  122,   36,
     185,    1,  149,  309,  335,   12,   11,   14,
      54,  151,    0,    0,    2,    0,    0,  211,
       0, 2090,  344,  736,  993, 2872,  701,  605,
     646, 1552,  328,  305, 1240,  735, 1533, 1713,
     562,    3, 1775, 1149, 1469,  979,  407,  553,
      59,  279,   31,    0,    0,    0,   68,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0,
       0,    0,    0,    0,    0,    0,    0,    0

################################################################################

TITLE
    SOSEMANUK mul_a

TYPE
    32

DATA
	0x00000000, 0xE19FCF13, 0x6B973726, 0x8A08F835,
	0xD6876E4C, 0x3718A15F, 0xBD10596A, 0x5C8F9679,
	0x05A7DC98, 0xE438138B, 0x6E30EBBE, 0x8FAF24AD,
	0xD320B2D4, 0x32BF7DC7, 0xB8B785F2, 0x59284AE1,
	0x0AE71199, 0xEB78DE8A, 0x617026BF, 0x80EFE9AC,
	0xDC607FD5, 0x3DFFB0C6, 0xB7F748F3, 0x566887E0,
	0x0F40CD01, 0xEEDF0212, 0x64D7FA27, 0x85483534,
	0xD9C7A34D, 0x38586C5E, 0xB250946B, 0x53CF5B78,
	0x1467229B, 0xF5F8ED88, 0x7FF015BD, 0x9E6FDAAE,
	0xC2E04CD7, 0x237F83C4, 0xA9777BF1, 0x48E8B4E2,
	0x11C0FE03, 0xF05F3110, 0x7A57C925, 0x9BC80636,
	0xC747904F, 0x26D85F5C, 0xACD0A769, 0x4D4F687A,
	0x1E803302, 0xFF1FFC11, 0x75170424, 0x9488CB37,
	0xC8075D4E, 0x2998925D, 0xA3906A68, 0x420FA57B,
	0x1B27EF9A, 0xFAB82089, 0x70B0D8BC, 0x912F17AF,
	0xCDA081D6, 0x2C3F4EC5, 0xA637B6F0, 0x47A879E3,
	0x28CE449F, 0xC9518B8C, 0x435973B9, 0xA2C6BCAA,
	0xFE492AD3, 0x1FD6E5C0, 0x95DE1DF5, 0x7441D2E6,
	0x2D699807, 0xCCF65714, 0x46FEAF21, 0xA7616032,
	0xFBEEF64B, 0x1A713958, 0x9079C16D, 0x71E60E7E,
	0x22295506, 0xC3B69A15, 0x49BE6220, 0xA821AD33,
	0xF4AE3B4A, 0x1531F459, 0x9F390C6C, 0x7EA6C37F,
	0x278E899E, 0xC611468D, 0x4C19BEB8, 0xAD8671AB,
	0xF109E7D2, 0x109628C1, 0x9A9ED0F4, 0x7B011FE7,
	0x3CA96604, 0xDD36A917, 0x573E5122, 0xB6A19E31,
	0xEA2E0848, 0x0BB1C75B, 0x81B93F6E, 0x6026F07D,
	0x390EBA9C, 0xD891758F, 0x52998DBA, 0xB30642A9,
	0xEF89D4D0, 0x0E161BC3, 0x841EE3F6, 0x65812CE5,
	0x364E779D, 0xD7D1B88E, 0x5DD940BB, 0xBC468FA8,
	0xE0C919D1, 0x0156D6C2, 0x8B5E2EF7, 0x6AC1E1E4,
	0x33E9AB05, 0xD2766416, 0x587E9C23, 0xB9E15330,
	0xE56EC549, 0x04F10A5A, 0x8EF9F26F, 0x6F663D7C,
	0x50358897, 0xB1AA4784, 0x3BA2BFB1, 0xDA3D70A2,
	0x86B2E6DB, 0x672D29C8, 0xED25D1FD, 0x0CBA1EEE,
	0x5592540F, 0xB40D9B1C, 0x3E056329, 0xDF9AAC3A,
	0x83153A43, 0x628AF550, 0xE8820D65, 0x091DC276,
	0x5AD2990E, 0xBB4D561D, 0x3145AE28, 0xD0DA613B,
	0x8C55F742, 0x6DCA3851, 0xE7C2C064, 0x065D0F77,
	0x5F754596, 0xBEEA8A85, 0x34E272B0, 0xD57DBDA3,
	0x89F22BDA, 0x686DE4C9, 0xE2651CFC, 0x03FAD3EF,
	0x4452AA0C, 0xA5CD651F, 0x2FC59D2A, 0xCE5A5239,
	0x92D5C440, 0x734A0B53, 0xF942F366, 0x18DD3C75,
	0x41F57694, 0xA06AB987, 0x2A6241B2, 0xCBFD8EA1,
	0x977218D8, 0x76EDD7CB, 0xFCE52FFE, 0x1D7AE0ED,
	0x4EB5BB95, 0xAF2A7486, 0x25228CB3, 0xC4BD43A0,
	0x9832D5D9, 0x79AD1ACA, 0xF3A5E2FF, 0x123A2DEC,
	0x4B12670D, 0xAA8DA81E, 0x2085502B, 0xC11A9F38,
	0x9D950941, 0x7C0AC652, 0xF6023E67, 0x179DF174,
	0x78FBCC08, 0x9964031B, 0x136CFB2E, 0xF2F3343D,
	0xAE7CA244, 0x4FE36D57, 0xC5EB9562, 0x24745A71,
	0x7D5C1090, 0x9CC3DF83, 0x16CB27B6, 0xF754E8A5,
	0xABDB7EDC, 0x4A44B1CF, 0xC04C49FA, 0x21D386E9,
	0x721CDD91, 0x93831282, 0x198BEAB7, 0xF81425A4,
	0xA49BB3DD, 0x45047CCE, 0xCF0C84FB, 0x2E934BE8,
	0x77BB0109, 0x9624CE1A, 0x1C2C362F, 0xFDB3F93C,
	0xA13C6F45, 0x40A3A056, 0xCAAB5863, 0x2B349770,
	0x6C9CEE93, 0x8D032180, 0x070BD9B5, 0xE69416A6,
	0xBA1B80DF, 0x5B844FCC, 0xD18CB7F9, 0x301378EA,
	0x693B320B, 0x88A4FD18, 0x02AC052D, 0xE333CA3E,
	0xBFBC5C47, 0x5E239354, 0xD42B6B61, 0x35B4A472,
	0x667BFF0A, 0x87E43019, 0x0DECC82C, 0xEC73073F,
	0xB0FC9146, 0x51635E55, 0xDB6BA660, 0x3AF46973,
	0x63DC2392, 0x8243EC81, 0x084B14B4, 0xE9D4DBA7,
	0xB55B4DDE, 0x54C482CD, 0xDECC7AF8, 0x3F53B5EB

################################################################################

TITLE
    SOSEMANUK mul_ia

TYPE
    32

DATA
	0x00000000, 0x180F40CD, 0x301E8033, 0x2811C0FE,
	0x603CA966, 0x7833E9AB, 0x50222955, 0x482D6998,
	0xC078FBCC, 0xD877BB01, 0xF0667BFF, 0xE8693B32,
	0xA04452AA, 0xB84B1267, 0x905AD299, 0x88559254,
	0x29F05F31, 0x31FF1FFC, 0x19EEDF02, 0x01E19FCF,
	0x49CCF657, 0x51C3B69A, 0x79D27664, 0x61DD36A9,
	0xE988A4FD, 0xF187E430, 0xD99624CE, 0xC1996403,
	0x89B40D9B, 0x91BB4D56, 0xB9AA8DA8, 0xA1A5CD65,
	0x5249BE62, 0x4A46FEAF, 0x62573E51, 0x7A587E9C,
	0x32751704, 0x2A7A57C9, 0x026B9737, 0x1A64D7FA,
	0x923145AE, 0x8A3E0563, 0xA22FC59D, 0xBA208550,
	0xF20DECC8, 0xEA02AC05, 0xC2136CFB, 0xDA1C2C36,
	0x7BB9E153, 0x63B6A19E, 0x4BA76160, 0x53A821AD,
	0x1B854835, 0x038A08F8, 0x2B9BC806, 0x339488CB,
	0xBBC11A9F, 0xA3CE5A52, 0x8BDF9AAC, 0x93D0DA61,
	0xDBFDB3F9, 0xC3F2F334, 0xEBE333CA, 0xF3EC7307,
	0xA492D5C4, 0xBC9D9509, 0x948C55F7, 0x8C83153A,
	0xC4AE7CA2, 0xDCA13C6F, 0xF4B0FC91, 0xECBFBC5C,
	0x64EA2E08, 0x7CE56EC5, 0x54F4AE3B, 0x4CFBEEF6,
	0x04D6876E, 0x1CD9C7A3, 0x34C8075D, 0x2CC74790,
	0x8D628AF5, 0x956DCA38, 0xBD7C0AC6, 0xA5734A0B,
	0xED5E2393, 0xF551635E, 0xDD40A3A0, 0xC54FE36D,
	0x4D1A7139, 0x551531F4, 0x7D04F10A, 0x650BB1C7,
	0x2D26D85F, 0x35299892, 0x1D38586C, 0x053718A1,
	0xF6DB6BA6, 0xEED42B6B, 0xC6C5EB95, 0xDECAAB58,
	0x96E7C2C0, 0x8EE8820D, 0xA6F942F3, 0xBEF6023E,
	0x36A3906A, 0x2EACD0A7, 0x06BD1059, 0x1EB25094,
	0x569F390C, 0x4E9079C1, 0x6681B93F, 0x7E8EF9F2,
	0xDF2B3497, 0xC724745A, 0xEF35B4A4, 0xF73AF469,
	0xBF179DF1, 0xA718DD3C, 0x8F091DC2, 0x97065D0F,
	0x1F53CF5B, 0x075C8F96, 0x2F4D4F68, 0x37420FA5,
	0x7F6F663D, 0x676026F0, 0x4F71E60E, 0x577EA6C3,
	0xE18D0321, 0xF98243EC, 0xD1938312, 0xC99CC3DF,
	0x81B1AA47, 0x99BEEA8A, 0xB1AF2A74, 0xA9A06AB9,
	0x21F5F8ED, 0x39FAB820, 0x11EB78DE, 0x09E43813,
	0x41C9518B, 0x59C61146, 0x71D7D1B8, 0x69D89175,
	0xC87D5C10, 0xD0721CDD, 0xF863DC23, 0xE06C9CEE,
	0xA841F576, 0xB04EB5BB, 0x985F7545, 0x80503588,
	0x0805A7DC, 0x100AE711, 0x381B27EF, 0x20146722,
	0x68390EBA, 0x70364E77, 0x58278E89, 0x4028CE44,
	0xB3C4BD43, 0xABCBFD8E, 0x83DA3D70, 0x9BD57DBD,
	0xD3F81425, 0xCBF754E8, 0xE3E69416, 0xFBE9D4DB,
	0x73BC468F, 0x6BB30642, 0x43A2C6BC, 0x5BAD8671,
	0x1380EFE9, 0x0B8FAF24, 0x239E6FDA, 0x3B912F17,
	0x9A34E272, 0x823BA2BF, 0xAA2A6241, 0xB225228C,
	0xFA084B14, 0xE2070BD9, 0xCA16CB27, 0xD2198BEA,
	0x5A4C19BE, 0x42435973, 0x6A52998D, 0x725DD940,
	0x3A70B0D8, 0x227FF015, 0x0A6E30EB, 0x12617026,
	0x451FD6E5, 0x5D109628, 0x750156D6, 0x6D0E161B,
	0x25237F83, 0x3D2C3F4E, 0x153DFFB0, 0x0D32BF7D,
	0x85672D29, 0x9D686DE4, 0xB579AD1A, 0xAD76EDD7,
	0xE55B844F, 0xFD54C482, 0xD545047C, 0xCD4A44B1,
	0x6CEF89D4, 0x74E0C919, 0x5CF109E7, 0x44FE492A,
	0x0CD320B2, 0x14DC607F, 0x3CCDA081, 0x24C2E04C,
	0xAC977218, 0xB49832D5, 0x9C89F22B, 0x8486B2E6,
	0xCCABDB7E, 0xD4A49BB3, 0xFCB55B4D, 0xE4BA1B80,
	0x17566887, 0x0F59284A, 0x2748E8B4, 0x3F47A879,
	0x776AC1E1, 0x6F65812C, 0x477441D2, 0x5F7B011F,
	0xD72E934B, 0xCF21D386, 0xE7301378, 0xFF3F53B5,
	0xB7123A2D, 0xAF1D7AE0, 0x870CBA1E, 0x9F03FAD3,
	0x3EA637B6, 0x26A9777B, 0x0EB8B785, 0x16B7F748,
	0x5E9A9ED0, 0x4695DE1D, 0x6E841EE3, 0x768B5E2E,
	0xFEDECC7A, 0xE6D18CB7, 0xCEC04C49, 0xD6CF0C84,
	0x9EE2651C, 0x86ED25D1, 0xAEFCE52F, 0xB6F3A5E2

################################################################################

TITLE
    ISI rFactor encryption algorithm

TYPE
    64

DATA
  0xe56f8aa2ed826faaLL, 0x2f777cf9c70031d8LL, 0x12b42c082f7753a9LL, 0xe5c4f0aca218138dLL, 0xff00000000000000LL, 0x00000000000000ffLL

################################################################################

TITLE
    LZMA compression

TYPE
    8

DATA
  0, 0, 0, 0, 1, 2, 3,  4,  5,  6,  4,  5, 
  7, 7, 7, 7, 7, 7, 7, 10, 10, 10, 10, 10

################################################################################

TITLE
    ARIA encryption KRK

TYPE
    32

DATA
	{0x517cc1b7, 0x27220a94, 0xfe13abe8, 0xfa9a6ee0}, 
	{0x6db14acc, 0x9e21c820, 0xff28b1d5, 0xef5de2b0}, 
	{0xdb92371d, 0x2126e970, 0x03249775, 0x04e8c90e}

################################################################################

TITLE
    ARIA encryption S2

TYPE
    8 HEX

DATA
	e2, 4e, 54, fc, 94, c2, 4a, cc, 62, 0d, 6a, 46, 3c, 4d, 8b, d1),
	5e, fa, 64, cb, b4, 97, be, 2b, bc, 77, 2e, 03, d3, 19, 59, c1),
	1d, 06, 41, 6b, 55, f0, 99, 69, ea, 9c, 18, ae, 63, df, e7, bb),
	00, 73, 66, fb, 96, 4c, 85, e4, 3a, 09, 45, aa, 0f, ee, 10, eb),
	2d, 7f, f4, 29, ac, cf, ad, 91, 8d, 78, c8, 95, f9, 2f, ce, cd),
	08, 7a, 88, 38, 5c, 83, 2a, 28, 47, db, b8, c7, 93, a4, 12, 53),
	ff, 87, 0e, 31, 36, 21, 58, 48, 01, 8e, 37, 74, 32, ca, e9, b1),
	b7, ab, 0c, d7, c4, 56, 42, 26, 07, 98, 60, d9, b6, b9, 11, 40),
	ec, 20, 8c, bd, a0, c9, 84, 04, 49, 23, f1, 4f, 50, 1f, 13, dc),
	d8, c0, 9e, 57, e3, c3, 7b, 65, 3b, 02, 8f, 3e, e8, 25, 92, e5),
	15, dd, fd, 17, a9, bf, d4, 9a, 7e, c5, 39, 67, fe, 76, 9d, 43),
	a7, e1, d0, f5, 68, f2, 1b, 34, 70, 05, a3, 8a, d5, 79, 86, a8),
	30, c6, 51, 4b, 1e, a6, 27, f6, 35, d2, 6e, 24, 16, 82, 5f, da),
	e6, 75, a2, ef, 2c, b2, 1c, 9f, 5d, 6f, 80, 0a, 72, 44, 9b, 6c),
	90, 0b, 5b, 33, 7d, 5a, 52, f3, 61, a1, f7, b0, d6, 3f, 7c, 6d),
	ed, 14, e0, a5, 3d, 22, b3, f8, 89, de, 71, 1a, af, ba, b5, 81)

################################################################################

TITLE
    ARIA encryption X2

TYPE
    8 HEX

DATA
	30, 68, 99, 1b, 87, b9, 21, 78, 50, 39, db, e1, 72, 09, 62, 3c),
	3e, 7e, 5e, 8e, f1, a0, cc, a3, 2a, 1d, fb, b6, d6, 20, c4, 8d),
	81, 65, f5, 89, cb, 9d, 77, c6, 57, 43, 56, 17, d4, 40, 1a, 4d),
	c0, 63, 6c, e3, b7, c8, 64, 6a, 53, aa, 38, 98, 0c, f4, 9b, ed),
	7f, 22, 76, af, dd, 3a, 0b, 58, 67, 88, 06, c3, 35, 0d, 01, 8b),
	8c, c2, e6, 5f, 02, 24, 75, 93, 66, 1e, e5, e2, 54, d8, 10, ce),
	7a, e8, 08, 2c, 12, 97, 32, ab, b4, 27, 0a, 23, df, ef, ca, d9),
	b8, fa, dc, 31, 6b, d1, ad, 19, 49, bd, 51, 96, ee, e4, a8, 41),
	da, ff, cd, 55, 86, 36, be, 61, 52, f8, bb, 0e, 82, 48, 69, 9a),
	e0, 47, 9e, 5c, 04, 4b, 34, 15, 79, 26, a7, de, 29, ae, 92, d7),
	84, e9, d2, ba, 5d, f3, c5, b0, bf, a4, 3b, 71, 44, 46, 2b, fc),
	eb, 6f, d5, f6, 14, fe, 7c, 70, 5a, 7d, fd, 2f, 18, 83, 16, a5),
	91, 1f, 05, 95, 74, a9, c1, 5b, 4a, 85, 6d, 13, 07, 4f, 4e, 45),
	b2, 0f, c9, 1c, a6, bc, ec, 73, 90, 7b, cf, 59, 8f, a1, f9, 2d),
	f2, b1, 00, 94, 37, 9f, d0, 2e, 9c, 6e, 28, 3f, 80, f0, 3d, d3),
	25, 8a, b5, e7, 42, b3, c7, ea, f7, 4c, 11, 33, 03, a2, ac, 60)

################################################################################

TITLE
    ABC encryption window1

TYPE
    32

DATA
  0x8bbc7b0a, 0xe774a906, 0x13040ec0, 0xea149bd0,
  0x32e3281d, 0x38c15589, 0xbdc92ea9, 0x6b587ba0,
  0xe1009816, 0xeaa84751, 0x77f1ce29, 0xeb94ad46,
  0xffd624d0, 0x89581695, 0xf0bbfbd3, 0x83404b20,
  0x9e66abea, 0x798ce417, 0x8d1adfb3, 0xb8c6bf9f,
  0x3bbad552, 0x923ddd55, 0xa6461e22, 0xcbf825b8,
  0x1139265e, 0xb9cf4535, 0xe7c87f14, 0xf4f855d3,
  0x7c77f154, 0x46c0f13c, 0x2d1229e6, 0xcf390000,
  0xa883b17d

################################################################################

TITLE
    CIPHERUNICORN

TYPE
    8

DATA
149,111,237,155,21,  85,108,  76,236,  75,193,  84,  22,138,  89,  55,
51,145,  13,153,148,163,86,59,204,175,91,117,126,70,144,  10,
248,146,201,  0,  97,208,  23,214,147,234,  66,  65,226,  57,210,224,
172,40,154,  87,178,235,135,220,110,121,  96,  8,  9,  53,241,105,
143,169,182,139,112,  16,183,67,233,  39,197,  74,166,218,231,242,
161,159,192,37,177,228,47,119,  14,  18,244,  56,  3,195,239,219,
33,167,  26,180,  54,  61,58,222,  4,  30,191,  34,107,249,142,150,
95,42,124,  25,232,181,120,  93,  5,  68,  6,48,129,41,104,73,
188,165,212,160,250,141,123,216,  94,238,  81,202,  7,122,196,  17,
207,102,184,189,243,  72,206,  12,200,225,164,176,247,  1,  2,254,
71,185,229,187,251,137,69,168,  50,  24,171,173,158,221,127,  27,
252,114,152,82,209,  38,203,128,215,213,  36,174,134,179,  90,118,
80,246,253,125,29,  44,  15,227,  98,205,255,  77,198,194,133,130,
79,103,  78,  49,  19,140,109,211,223,63,  64,151,  62,217,170,  83,
136,45,115,199,  20,  46,190,240,132,  28,162,230,131,106,  32,  88,
157,  31,  43,156,113,186,  35,101,  52,  60,  11,100,116,245,  99,  92,
174,255,161,109,254,40,  95,  67,  33,124,133,  58,224,238,129,  56,
137,  57,169,  87,221,220,163,  84,  14,239,171,138,74,192,  66,104,
8,250,43,115,126,  88,212,103,  62,  82,143,  4,117,226,  28,155,
65,156,139,183,235,125,217,116,111,237,157,  68,160,184,213,172,
170,132,  73,  2,  1,232,92,249,136,106,175,  5,  9,140,  38,191,
50,251,85,  12,  27,  48,  46,  52,145,  78,168,159,100,188,  16,227,
26,198,244,205,178,  72,142,162,  51,246,241,128,194,177,122,  20,
144,49,  83,166,247,225,  11,  7,102,242,185,  18,150,165,121,98,
93,197,70,151,75,118,202,216,108,207,  15,112,99,35,101,69,
86,61,79,110,  13,218,149,  6,134,29,36,131,181,154,180,230,
77,193,164,  17,211,  3,209,105,  94,206,  44,  19,  60,123,  10,  31,
130,195,76,208,  54,252,219,203,199,  39,189,  80,167,90,  32,  30,
233,64,245,182,120,231,127,47,  22,135,  55,114,234,  41,  21,  81,
173,223,  23,253,153,  25,  45,248,  97,179,186,119,200,146,187,210,
0,228,  24,190,141,236,  63,201,  96,113,240,147,229,  91,107,214,
89,  59,152,215,176,204,243,148,  42,158,  71,  34,222,  37,196,  53,
37,34,162,132,134,220,91,143,41,45,229,247,98,178,  68,  56,
212,97,70,  15,  58,  72,216,208,  14,96,214,217,133,179,  28,154,
120,123,  83,100,235,  3,230,160,193,245,164,155,255,175,  79,148,
227,219,  23,  95,111,  11,  87,104,163,203,189,  29,156,173,211,  64,
157,53,196,  89,  81,  4,84,  16,192,  74,  13,181,  20,184,  57,183,
90,119,  93,207,  38,131,  94,  60,116,  1,213,122,  5,101,144,117,
75,46,  8,172,170,152,231,210,  66,  54,  10,187,128,204,  12,102,
243,115,137,147,159,233,  59,221,253,112,165,198,105,222,234,153,
43,201,121,180,86,205,225,242,182,55,63,232,254,44,  9,  21,
136,65,114,  31,  40,  49,  0,  36,169,  22,249,  35,  62,  17,174,248,
158,151,  24,  50,176,108,  67,127,150,  18,  2,168,194,171,195,145,
99,  25,  80,224,  33,200,197,118,161,  61,142,  77,190,209,  48,139,
238,206,42,125,239,237,  52,223,  88,167,  26,130,  76,191,  7,  71,
215,27,126,  6,251,  51,241,129,135,246,244,146,  32,177,  73,  82,
226,110,  78,186,240,141,166,  69,107,  85,103,149,250,109,202,  19,
113,140,138,  39,185,228,106,  47,252,199,188,  92,218,  30,236,124,
24,252,144,121,  17,42,77,127,  2,35,173,  21,129,  58,105,113,
112,229,185,189,  76,204,209,  87,  5,  96,  82,  99,133,140,  66,  64,
192,107,194,220,  16,  68,183,171,219,  51,  92,  13,152,86,135,123,
98,174,103,156,157,  59,145,155,158,  8,231,132,  83,49,  23,  32,
85,69,251,  36,233,238,222,149,  37,248,  26,  18,125,  11,137,253,
79,  52,  56,  95,241,187,44,167,124,102,227,115,212,142,154,  93,
247,211,  33,  28,  67,  10,147,225,215,210,246,160,131,73,  65,  57,
1,182,180,199,207,126,216,224,  61,  81,202,196,146,188,119,128,
50,  30,  91,161,  89,  12,195,  74,235,223,226,172,245,  7,218,159,
242,217,208,38,163,  45,  39,  4,  62,136,104,179,  88,197,  6,  0,
141,190,243,214,109,162,  60,165,198,228,221,164,106,101,203,236,
143,48,110,  80,176,  78,234,181,  97,  84,  20,  70,  29,168,  27,  72,
71,  90,255,  19,254,114,25,230,47,43,100,178,40,41,249,186,
150,205,184,201,139,  75,  54,  22,  63,244,108,175,  46,169,240,153,
151,116,122,232,166,117,  14,94,111,206,237,177,200,  31,170,120,
213,  53,148,  15,  55,239,  3,191,134,250,193,  9,130,118,138,  34

################################################################################

TITLE
    RNG (original numbers)

TYPE
    32 AND

DATA
    2147483647L;
    44488L;
    // const word16 LC_RNG::a=(unsigned int)48271L;
    // const word16 LC_RNG::r=3399;

################################################################################

TITLE
    RNG

TYPE
    32 AND

DATA
    2147483647L;
    127773L;
    // const word16 LC_RNG::a=16807;
    // const word16 LC_RNG::r=2836;

################################################################################

TITLE
    SALSA

TYPE
    32 AND

DATA
	0x61707865
	0x3120646e   0x3320646e
	0x79622d36   0x79622d32
	0x6b206574

################################################################################

TITLE
    3-way

TYPE
    32 AND

DATA
    0x0b0b 0xb1b1 0x11011

################################################################################

TITLE
    VMAC

TYPE
    64 AND

DATA
0xfffffffffffffeff 0x3fffffffffffffff 0x7fffffffffffffff 0xffffffffffffffff 0x1fffffff1fffffff


################################################################################

TITLE
    RRC2 - Ron Rivest Cipher Nr. 2 Beale

TYPE
    16 32

DATA
  71, 194,  38,1701,  89,  76,  11,  83,1629,  48,  94,  63, 132,  16, 111,  95, 
  84, 341, 975,  14,  40,  64,  27,  81, 139, 213,  63,  90,1120,   8,  15,   3, 
 126,2018,  40,  74, 758, 485, 604, 230, 436, 664, 582, 150, 251, 284, 308, 231, 
 124, 211, 486, 225, 401, 370,  11, 101, 305, 139, 189,  17,  33,  88, 208, 193, 
 145,   1,  94,  73, 416, 918, 263,  28, 500, 538, 356, 117, 136, 219,  27, 176, 
 130,  10, 460,  25, 485,  18, 436,  65,  84, 200, 283, 118, 320, 138,  36, 416, 
 280,  15,  71, 224, 961,  44,  16, 401,  39,  88,  61, 304,  12,  21,  24, 283, 
 134,  92,  63, 246, 486, 682,   7, 219, 184, 360, 780,  18,  64, 463, 474, 131, 
 160,  79,  73, 440,  95,  18,  64, 581,  34,  69, 128, 367, 460,  17,  81,  12, 
 103, 820,  62, 110,  97, 103, 862,  70,  60,1317, 471, 540, 208, 121, 890, 346, 
  36, 150,  59, 568, 614,  13, 120,  63, 219, 812,2160,1780,  99,  35,  18,  21, 
 136, 872,  15,  28, 170,  88,   4,  30,  44, 112,  18, 147, 436, 195, 320,  37, 
 122, 113,   6, 140,   8, 120, 305,  42,  58, 461,  44, 106, 301,  13, 408, 680, 
  93,  86, 116, 530,  82, 568,   9, 102,  38, 416,  89,  71, 216, 728, 965, 818, 
   2,  38, 121, 195,  14, 326, 148, 234,  18,  55, 131, 234, 361, 824,   5,  81, 
 623,  48, 961,  19,  26,  33,  10,1101, 365,  92,  88, 181, 275, 346, 201, 206 

################################################################################

TITLE
    RRC2 - Ron Rivest Cipher Nr. 2 Pad

TYPE
    8

DATA
 158, 186, 223,  97,  64, 145, 190, 190, 117, 217, 163,  70, 206, 176, 183, 194, 
 146,  43, 248, 141,   3,  54,  72, 223, 233, 153,  91, 210,  36, 131, 244, 161, 
 105, 120, 113, 191, 113,  86,  19, 245, 213, 221,  43,  27, 242, 157,  73, 213, 
 193,  92, 166,  10,  23, 197, 112, 110, 193,  30, 156,  51, 125,  51, 158,  67, 
 197, 215,  59, 218, 110, 246, 181,   0, 135,  76, 164,  97,  47,  87, 234, 108, 
 144, 127,   6,   6, 222, 172,  80, 144,  22, 245, 207,  70, 227, 182, 146, 134, 
 119, 176,  73,  58, 135,  69,  23, 198,   0, 170,  32, 171, 176, 129,  91,  24, 
 126,  77, 248,   0, 118,  69,  57,  60, 190, 171, 217,  61, 136, 169, 196,  84, 
 168, 167, 163, 102, 223,  64, 174, 178, 166, 239, 242, 195, 249,  92,  59,  38, 
 241,  46, 236,  31,  59, 114,  23,  50, 119, 186,   7,  66, 212,  97, 222, 182, 
 230, 118, 122,  86, 105,  92, 179, 243, 255, 189, 223, 164, 194, 215,  98,  44, 
  17,  20,  53, 153, 137, 224, 176, 100, 208, 114,  36, 200, 145, 150, 215,  20, 
  87,  44, 252,  20, 235, 242, 163, 132,  63,  18,   5, 122,  74,  97,  34,  97, 
 142,  86, 146, 221, 179, 166, 161,  74,  69, 182,  88, 120, 128,  58,  76, 155, 
  15,  30,  77, 216, 165, 117, 107,  90, 169, 127, 143, 181, 208, 137, 200, 127, 
 170, 195,  26,  84, 255, 132, 150,  58, 103, 250, 120, 221, 237,  37,   8,  99 


################################################################################

TITLE
    SNOW SBox_0

TYPE
    32

DATA
1077968896UL,   4227072UL,1077968900UL, 268503108UL,
   4261892UL, 272664580UL,1073743876UL,   4259904UL,
1342275584UL, 268535812UL, 272730116UL,1077970948UL,
 268503104UL,1342275652UL,1346371652UL,1077968960UL,
1342242884UL,   4292672UL,1346437184UL,1073807424UL,
 268435456UL, 272697412UL,1073774592UL,1077938244UL,
     98304UL,1073807364UL, 268503044UL, 272730176UL,
1078003776UL,   4259844UL,1078001732UL,      2116UL,
   4292612UL,     65536UL,1073776708UL,1078001664UL,
     67648UL,   4194372UL, 268500992UL,1346371648UL,
1073741892UL, 268533764UL,   4261956UL,1342242816UL,
     98368UL,     34816UL,1346472004UL, 268437508UL,
   4196416UL,1342212100UL,1342244928UL,1342277632UL,
1073842240UL, 272664644UL,1342179392UL, 268437572UL,
 268535876UL,   4194368UL, 272631812UL,1342242880UL,
 272730180UL,1342210048UL, 268470272UL,1077936128UL,
     32772UL,   4227076UL, 268468288UL,   4227136UL,
   4194308UL,     32768UL,1346469892UL,         4UL,
1346406400UL,1073741824UL, 268435524UL, 268437504UL,
1078036544UL,     32836UL,   4227140UL, 272631808UL,
1346437120UL,1073807360UL, 268470340UL,1073840128UL,
1342177348UL,1077970944UL,1078036548UL,1346439232UL,
   4294660UL, 272697344UL,1077938240UL, 272695364UL,
 268533824UL,1342212096UL,1077936196UL,   4292608UL,
 272629828UL,1073743940UL,1342212160UL,        64UL,
     98308UL,   4259840UL, 272664640UL,1346472000UL,
1073741828UL,1342277700UL, 272631872UL,   4292676UL,
   4196352UL, 272631876UL,1078034432UL, 272662532UL,
1346404356UL,1346373696UL,1342277696UL,     34880UL,
     65540UL,1342244868UL,1077938176UL,   4229184UL,
 268533828UL,1073774660UL,1346406464UL,1342210112UL,
 268501056UL,1073840132UL,1342179328UL, 272662592UL,
1073743936UL,1077936132UL,   4261888UL, 272695296UL,
1346439168UL,1346373636UL,1078001728UL, 268500996UL,
 268533760UL,1342242820UL,     98372UL,1342275648UL,
1346471936UL,1073807428UL,1346404416UL, 268535808UL,
1346371588UL, 272662528UL, 272697408UL, 272662596UL,
      2052UL,1078036480UL,   4294720UL,1073741888UL,
   4259908UL, 272695300UL,1073842180UL, 272629760UL,
   4229188UL,1073776644UL,1073776640UL,         0UL,
     34820UL,1077936192UL, 268468292UL,1346406468UL,
1342244864UL,1073774596UL,   4196420UL,1346371584UL,
      2048UL,1346437188UL,     67588UL,1342177344UL,
1077971008UL, 272728132UL,1077968964UL,1342212164UL,
1078003712UL,    100416UL,1078001668UL,1346373700UL,
 272629824UL,   4294656UL,1073774656UL,1078034436UL,
1342210052UL, 268535872UL, 268501060UL,     65604UL,
 268435520UL,1346437124UL,1073809408UL, 272629764UL,
1078003780UL,1342277636UL, 268470276UL, 272728128UL,
 268468224UL,1342179332UL, 272664576UL,   4229124UL,
1078034500UL,   4261952UL,1346469888UL,        68UL,
1346469956UL, 268435460UL,1342179396UL,1073840192UL,
1346404420UL,      2112UL,1346404352UL,1077971012UL,
1073809476UL,1073840196UL,     65600UL,   4196356UL,
 272728064UL,     67652UL,     32832UL,1346373632UL,
1073809412UL,1342210116UL,1342177280UL,1073776704UL,
1342177284UL, 268470336UL,1073809472UL,   4229120UL,
 272697348UL,1342275588UL,1078036484UL,1078003716UL,
1342244932UL, 268468228UL,1073842244UL,    100420UL,
 272728068UL,     67584UL,     34884UL,1346406404UL,
 268503040UL,1346439236UL,1073842176UL,1346471940UL,
1346469952UL, 272730112UL,1346439172UL,   4194304UL,
1077938180UL, 272695360UL,1078034496UL,1073743872UL,
   4294724UL,    100356UL, 268437568UL,    100352UL

################################################################################

TITLE
    SNOW SBox_1

TYPE
    32

DATA
2148008448UL,    524800UL,2148008450UL,  69206290UL,
   2621698UL,  67633922UL,2147483906UL,   2621456UL,
2216690176UL,  69206786UL,  69731074UL,2148008706UL,
  69206288UL,2216690194UL,2215116818UL,2148008464UL,
2216689682UL,   2621968UL,2217213968UL,2149580816UL,
  67108864UL,  69730578UL,2147484160UL,2148008210UL,
   2097664UL,2149580802UL,  69206274UL,  69731088UL,
2150105360UL,   2621442UL,2150105106UL,       274UL,
   2621954UL,   2097152UL,2147484434UL,2150105088UL,
   2097424UL,    524306UL,  69206016UL,2215116816UL,
2147483666UL,  69206530UL,   2621714UL,2216689664UL,
   2097680UL,       768UL,2217214738UL,  67109122UL,
    524560UL,2214593282UL,2216689936UL,2216690432UL,
2149581584UL,  67633938UL,2214592784UL,  67109138UL,
  69206802UL,    524304UL,  67633410UL,2216689680UL,
  69731090UL,2214593024UL,  67109632UL,2148007936UL,
       514UL,    524802UL,  67109392UL,    524816UL,
    524290UL,       512UL,2217214466UL,         2UL,
2215117568UL,2147483648UL,  67108882UL,  67109120UL,
2150105872UL,       530UL,    524818UL,  67633408UL,
2217213952UL,2149580800UL,  67109650UL,2149581312UL,
2214592530UL,2148008704UL,2150105874UL,2217214224UL,
   2622210UL,  69730560UL,2148008208UL,  69730322UL,
  69206544UL,2214593280UL,2148007954UL,   2621952UL,
  67633170UL,2147483922UL,2214593296UL,        16UL,
   2097666UL,   2621440UL,  67633936UL,2217214736UL,
2147483650UL,2216690450UL,  67633424UL,   2621970UL,
    524544UL,  67633426UL,2150105600UL,  67633666UL,
2215117314UL,2215117072UL,2216690448UL,       784UL,
   2097154UL,2216689922UL,2148008192UL,    525072UL,
  69206546UL,2147484178UL,2215117584UL,2214593040UL,
  69206032UL,2149581314UL,2214592768UL,  67633680UL,
2147483920UL,2148007938UL,   2621696UL,  69730304UL,
2217214208UL,2215117058UL,2150105104UL,  69206018UL,
  69206528UL,2216689666UL,   2097682UL,2216690192UL,
2217214720UL,2149580818UL,2215117328UL,  69206784UL,
2215116802UL,  67633664UL,  69730576UL,  67633682UL,
       258UL,2150105856UL,   2622224UL,2147483664UL,
   2621458UL,  69730306UL,2149581570UL,  67633152UL,
    525074UL,2147484418UL,2147484416UL,         0UL,
       770UL,2148007952UL,  67109394UL,2215117586UL,
2216689920UL,2147484162UL,    524562UL,2215116800UL,
       256UL,2217213970UL,   2097410UL,2214592528UL,
2148008720UL,  69730834UL,2148008466UL,2214593298UL,
2150105344UL,   2097936UL,2150105090UL,2215117074UL,
  67633168UL,   2622208UL,2147484176UL,2150105602UL,
2214593026UL,  69206800UL,  69206034UL,   2097170UL,
  67108880UL,2217213954UL,2149581056UL,  67633154UL,
2150105362UL,2216690434UL,  67109634UL,  69730832UL,
  67109376UL,2214592770UL,  67633920UL,    525058UL,
2150105618UL,   2621712UL,2217214464UL,        18UL,
2217214482UL,  67108866UL,2214592786UL,2149581328UL,
2215117330UL,       272UL,2215117312UL,2148008722UL,
2149581074UL,2149581330UL,   2097168UL,    524546UL,
  69730816UL,   2097426UL,       528UL,2215117056UL,
2149581058UL,2214593042UL,2214592512UL,2147484432UL,
2214592514UL,  67109648UL,2149581072UL,    525056UL,
  69730562UL,2216690178UL,2150105858UL,2150105346UL,
2216689938UL,  67109378UL,2149581586UL,   2097938UL,
  69730818UL,   2097408UL,       786UL,2215117570UL,
  69206272UL,2217214226UL,2149581568UL,2217214722UL,
2217214480UL,  69731072UL,2217214210UL,    524288UL,
2148008194UL,  69730320UL,2150105616UL,2147483904UL,
   2622226UL,   2097922UL,  67109136UL,   2097920UL

################################################################################

TITLE
    SNOW SBox_2

TYPE
    32

DATA
 142610432UL,   8392704UL, 142610560UL,  33824928UL,
   8659072UL,  41955456UL, 134226048UL,   8650784UL,
 168038400UL,  33828992UL,  42217600UL, 142618752UL,
  33824800UL, 168038560UL, 176160928UL, 142610464UL,
 168034464UL,   8654880UL, 176422944UL, 134479904UL,
  33554432UL,  42213536UL, 134221824UL, 142614688UL,
    266240UL, 134480000UL,  33824896UL,  42217504UL,
 142876704UL,   8650880UL, 142868640UL,      8352UL,
   8654976UL,    262144UL, 134230176UL, 142868480UL,
    270368UL,   8388768UL,  33816576UL, 176160800UL,
 134217888UL,  33820800UL,   8659104UL, 168034304UL,
    266272UL,     12288UL, 176435360UL,  33562752UL,
   8396832UL, 167784576UL, 168042528UL, 168046592UL,
 134492192UL,  41955488UL, 167780384UL,  33562784UL,
  33829024UL,   8388640UL,  41951360UL, 168034336UL,
  42217632UL, 167776256UL,  33566720UL, 142606336UL,
      4224UL,   8392832UL,  33558560UL,   8392736UL,
   8388736UL,      4096UL, 176427136UL,       128UL,
 176173056UL, 134217728UL,  33554592UL,  33562624UL,
 142880800UL,      4256UL,   8392864UL,  41951232UL,
 176422912UL, 134479872UL,  33566880UL, 134483968UL,
 167772320UL, 142618624UL, 142880928UL, 176431136UL,
   8663168UL,  42213376UL, 142614560UL,  42205344UL,
  33820704UL, 167784448UL, 142606496UL,   8654848UL,
  41943200UL, 134226080UL, 167784480UL,        32UL,
    266368UL,   8650752UL,  41955360UL, 176435232UL,
 134217856UL, 168046752UL,  41951264UL,   8655008UL,
   8396800UL,  41951392UL, 142872576UL,  41947264UL,
 176164992UL, 176168992UL, 168046624UL,     12320UL,
    262272UL, 168042624UL, 142614528UL,   8400928UL,
  33820832UL, 134221984UL, 176173088UL, 167776288UL,
  33816608UL, 134484096UL, 167780352UL,  41947168UL,
 134225952UL, 142606464UL,   8658944UL,  42205184UL,
 176431104UL, 176169088UL, 142868512UL,  33816704UL,
  33820672UL, 168034432UL,    266400UL, 168038432UL,
 176435200UL, 134480032UL, 176164896UL,  33828864UL,
 176160896UL,  41947136UL,  42213408UL,  41947296UL,
      8320UL, 142880768UL,   8663072UL, 134217760UL,
   8650912UL,  42205312UL, 134492288UL,  41943040UL,
   8401056UL, 134230144UL, 134230016UL,         0UL,
     12416UL, 142606368UL,  33558688UL, 176173216UL,
 168042496UL, 134221952UL,   8396960UL, 176160768UL,
      8192UL, 176423072UL,    270464UL, 167772192UL,
 142618656UL,  42209440UL, 142610592UL, 167784608UL,
 142876672UL,    274464UL, 142868608UL, 176169120UL,
  41943072UL,   8663040UL, 134221856UL, 142872704UL,
 167776384UL,  33828896UL,  33816736UL,    262304UL,
  33554464UL, 176423040UL, 134488064UL,  41943168UL,
 142876832UL, 168046720UL,  33566848UL,  42209312UL,
  33558528UL, 167780480UL,  41955328UL,   8401024UL,
 142872736UL,   8658976UL, 176427008UL,       160UL,
 176427168UL,  33554560UL, 167780512UL, 134484000UL,
 176165024UL,      8224UL, 176164864UL, 142618784UL,
 134488224UL, 134484128UL,    262176UL,   8396928UL,
  42209280UL,    270496UL,      4128UL, 176168960UL,
 134488192UL, 167776416UL, 167772160UL, 134230048UL,
 167772288UL,  33566752UL, 134488096UL,   8400896UL,
  42213504UL, 168038528UL, 142880896UL, 142876800UL,
 168042656UL,  33558656UL, 134492320UL,    274592UL,
  42209408UL,    270336UL,     12448UL, 176173184UL,
  33824768UL, 176431264UL, 134492160UL, 176435328UL,
 176427040UL,  42217472UL, 176431232UL,   8388608UL,
 142614656UL,  42205216UL, 142872608UL, 134225920UL,
   8663200UL,    274560UL,  33562656UL,    274432UL

################################################################################

TITLE
    SNOW SBox_3

TYPE
    32

DATA
 537018368UL,    147456UL, 537018376UL,  17826825UL,
   1180680UL,  16925704UL, 536871944UL,   1179649UL,
 554713088UL,  17843208UL,  17974280UL, 537019400UL,
  17826817UL, 554713097UL, 553779209UL, 537018369UL,
 554696713UL,   1196033UL, 554827777UL, 537919489UL,
  16777216UL,  17957897UL, 536887296UL, 537003017UL,
   1064960UL, 537919496UL,  17826824UL,  17974273UL,
 538051585UL,   1179656UL, 538050569UL,      1033UL,
   1196040UL,   1048576UL, 536888329UL, 538050560UL,
   1049601UL,    131081UL,  17825792UL, 553779201UL,
 536870921UL,  17842184UL,   1180681UL, 554696704UL,
   1064961UL,     17408UL, 554845193UL,  16778248UL,
    132097UL, 553665544UL, 554697729UL, 554714112UL,
 537936897UL,  16925705UL, 553649153UL,  16778249UL,
  17843209UL,    131073UL,  16909320UL, 554696705UL,
  17974281UL, 553664512UL,  16794624UL, 537001984UL,
     16392UL,    147464UL,  16793601UL,    147457UL,
    131080UL,     16384UL, 554844168UL,         8UL,
 553796608UL, 536870912UL,  16777225UL,  16778240UL,
 538067969UL,     16393UL,    147465UL,  16909312UL,
 554827776UL, 537919488UL,  16794633UL, 537935872UL,
 553648137UL, 537019392UL, 538067977UL, 554828801UL,
   1197064UL,  17957888UL, 537003009UL,  17956873UL,
  17842177UL, 553665536UL, 537001993UL,   1196032UL,
  16908297UL, 536871945UL, 553665537UL,         1UL,
   1064968UL,   1179648UL,  16925697UL, 554845185UL,
 536870920UL, 554714121UL,  16909313UL,   1196041UL,
    132096UL,  16909321UL, 538066944UL,  16924680UL,
 553795592UL, 553780225UL, 554714113UL,     17409UL,
   1048584UL, 554697736UL, 537003008UL,    148481UL,
  17842185UL, 536887305UL, 553796609UL, 553664513UL,
  17825793UL, 537935880UL, 553649152UL,  16924673UL,
 536871937UL, 537001992UL,   1180672UL,  17956864UL,
 554828800UL, 553780232UL, 538050561UL,  17825800UL,
  17842176UL, 554696712UL,   1064969UL, 554713089UL,
 554845184UL, 537919497UL, 553795585UL,  17843200UL,
 553779208UL,  16924672UL,  17957889UL,  16924681UL,
      1032UL, 538067968UL,   1197057UL, 536870913UL,
   1179657UL,  17956872UL, 537936904UL,  16908288UL,
    148489UL, 536888328UL, 536888320UL,         0UL,
     17416UL, 537001985UL,  16793609UL, 553796617UL,
 554697728UL, 536887304UL,    132105UL, 553779200UL,
      1024UL, 554827785UL,   1049608UL, 553648129UL,
 537019393UL,  17973257UL, 537018377UL, 553665545UL,
 538051584UL,   1065985UL, 538050568UL, 553780233UL,
  16908289UL,   1197056UL, 536887297UL, 538066952UL,
 553664520UL,  17843201UL,  17825801UL,   1048585UL,
  16777217UL, 554827784UL, 537920512UL,  16908296UL,
 538051593UL, 554714120UL,  16794632UL,  17973249UL,
  16793600UL, 553649160UL,  16925696UL,    148488UL,
 538066953UL,   1180673UL, 554844160UL,         9UL,
 554844169UL,  16777224UL, 553649161UL, 537935873UL,
 553795593UL,      1025UL, 553795584UL, 537019401UL,
 537920521UL, 537935881UL,   1048577UL,    132104UL,
  17973248UL,   1049609UL,     16385UL, 553780224UL,
 537920520UL, 553664521UL, 553648128UL, 536888321UL,
 553648136UL,  16794625UL, 537920513UL,    148480UL,
  17957896UL, 554713096UL, 538067976UL, 538051592UL,
 554697737UL,  16793608UL, 537936905UL,   1065993UL,
  17973256UL,   1049600UL,     17417UL, 553796616UL,
  17826816UL, 554828809UL, 537936896UL, 554845192UL,
 554844161UL,  17974272UL, 554828808UL,    131072UL,
 537003016UL,  17956865UL, 538066945UL, 536871936UL,
   1197065UL,   1065992UL,  16778241UL,   1065984UL

################################################################################

TITLE
    Ultima Online uodemo.dat algorithm

TYPE
    32

DATA
        0x000000e4,0x000000ea,0x000000e9,0x000000e2,0x000000ed,0x000000e8,0x000000e0,0x000000ee,
        0x000000e6,0x000000eb,0x000000e1,0x000000ec,0x000000e7,0x000000ef,0x000000e5,0x000000e3,
        0x000000b4,0x000000ba,0x000000b9,0x000000b2,0x000000bd,0x000000b8,0x000000b0,0x000000be,
        0x000000b6,0x000000bb,0x000000b1,0x000000bc,0x000000b7,0x000000bf,0x000000b5,0x000000b3,
        0x00000044,0x0000004a,0x00000049,0x00000042,0x0000004d,0x00000048,0x00000040,0x0000004e,
        0x00000046,0x0000004b,0x00000041,0x0000004c,0x00000047,0x0000004f,0x00000045,0x00000043,
        0x000000c4,0x000000ca,0x000000c9,0x000000c2,0x000000cd,0x000000c8,0x000000c0,0x000000ce,
        0x000000c6,0x000000cb,0x000000c1,0x000000cc,0x000000c7,0x000000cf,0x000000c5,0x000000c3,
        0x00000064,0x0000006a,0x00000069,0x00000062,0x0000006d,0x00000068,0x00000060,0x0000006e,
        0x00000066,0x0000006b,0x00000061,0x0000006c,0x00000067,0x0000006f,0x00000065,0x00000063,
        0x000000d4,0x000000da,0x000000d9,0x000000d2,0x000000dd,0x000000d8,0x000000d0,0x000000de,
        0x000000d6,0x000000db,0x000000d1,0x000000dc,0x000000d7,0x000000df,0x000000d5,0x000000d3,
        0x000000f4,0x000000fa,0x000000f9,0x000000f2,0x000000fd,0x000000f8,0x000000f0,0x000000fe,
        0x000000f6,0x000000fb,0x000000f1,0x000000fc,0x000000f7,0x000000ff,0x000000f5,0x000000f3,
        0x000000a4,0x000000aa,0x000000a9,0x000000a2,0x000000ad,0x000000a8,0x000000a0,0x000000ae,
        0x000000a6,0x000000ab,0x000000a1,0x000000ac,0x000000a7,0x000000af,0x000000a5,0x000000a3,
        0x00000024,0x0000002a,0x00000029,0x00000022,0x0000002d,0x00000028,0x00000020,0x0000002e,
        0x00000026,0x0000002b,0x00000021,0x0000002c,0x00000027,0x0000002f,0x00000025,0x00000023,
        0x00000034,0x0000003a,0x00000039,0x00000032,0x0000003d,0x00000038,0x00000030,0x0000003e,
        0x00000036,0x0000003b,0x00000031,0x0000003c,0x00000037,0x0000003f,0x00000035,0x00000033,
        0x00000084,0x0000008a,0x00000089,0x00000082,0x0000008d,0x00000088,0x00000080,0x0000008e,
        0x00000086,0x0000008b,0x00000081,0x0000008c,0x00000087,0x0000008f,0x00000085,0x00000083,
        0x00000014,0x0000001a,0x00000019,0x00000012,0x0000001d,0x00000018,0x00000010,0x0000001e,
        0x00000016,0x0000001b,0x00000011,0x0000001c,0x00000017,0x0000001f,0x00000015,0x00000013,
        0x00000004,0x0000000a,0x00000009,0x00000002,0x0000000d,0x00000008,0x00000000,0x0000000e,
        0x00000006,0x0000000b,0x00000001,0x0000000c,0x00000007,0x0000000f,0x00000005,0x00000003,
        0x00000074,0x0000007a,0x00000079,0x00000072,0x0000007d,0x00000078,0x00000070,0x0000007e,
        0x00000076,0x0000007b,0x00000071,0x0000007c,0x00000077,0x0000007f,0x00000075,0x00000073,
        0x00000054,0x0000005a,0x00000059,0x00000052,0x0000005d,0x00000058,0x00000050,0x0000005e,
        0x00000056,0x0000005b,0x00000051,0x0000005c,0x00000057,0x0000005f,0x00000055,0x00000053,
        0x00000094,0x0000009a,0x00000099,0x00000092,0x0000009d,0x00000098,0x00000090,0x0000009e,

################################################################################

TITLE
    Ultima Online uodemo.dat algorithm key

TYPE
    32

DATA
            0xf7aa4c98, 0xbf62c067, 0x0b524334, 0xbc28a2d0,
            0x6b57c2d1, 0x233843aa, 0xc06d0210, 0x38d4f804 };


################################################################################

TITLE
    Ventrilo UDP status packet encryption ventrilo_udp_encdata_head

TYPE
    8

DATA
    "\x80\xe5\x0e\x38\xba\x63\x4c\x99\x88\x63\x4c\xd6\x54\xb8\x65\x7e"
    "\xbf\x8a\xf0\x17\x8a\xaa\x4d\x0f\xb7\x23\x27\xf6\xeb\x12\xf8\xea"
    "\x17\xb7\xcf\x52\x57\xcb\x51\xcf\x1b\x14\xfd\x6f\x84\x38\xb5\x24"
    "\x11\xcf\x7a\x75\x7a\xbb\x78\x74\xdc\xbc\x42\xf0\x17\x3f\x5e\xeb"
    "\x74\x77\x04\x4e\x8c\xaf\x23\xdc\x65\xdf\xa5\x65\xdd\x7d\xf4\x3c"
    "\x4c\x95\xbd\xeb\x65\x1c\xf4\x24\x5d\x82\x18\xfb\x50\x86\xb8\x53"
    "\xe0\x4e\x36\x96\x1f\xb7\xcb\xaa\xaf\xea\xcb\x20\x27\x30\x2a\xae"
    "\xb9\x07\x40\xdf\x12\x75\xc9\x09\x82\x9c\x30\x80\x5d\x8f\x0d\x09"
    "\xa1\x64\xec\x91\xd8\x8a\x50\x1f\x40\x5d\xf7\x08\x2a\xf8\x60\x62"
    "\xa0\x4a\x8b\xba\x4a\x6d\x00\x0a\x93\x32\x12\xe5\x07\x01\x65\xf5"
    "\xff\xe0\xae\xa7\x81\xd1\xba\x25\x62\x61\xb2\x85\xad\x7e\x9d\x3f"
    "\x49\x89\x26\xe5\xd5\xac\x9f\x0e\xd7\x6e\x47\x94\x16\x84\xc8\xff"
    "\x44\xea\x04\x40\xe0\x33\x11\xa3\x5b\x1e\x82\xff\x7a\x69\xe9\x2f"
    "\xfb\xea\x9a\xc6\x7b\xdb\xb1\xff\x97\x76\x56\xf3\x52\xc2\x3f\x0f"
    "\xb6\xac\x77\xc4\xbf\x59\x5e\x80\x74\xbb\xf2\xde\x57\x62\x4c\x1a"
    "\xff\x95\x6d\xc7\x04\xa2\x3b\xc4\x1b\x72\xc7\x6c\x82\x60\xd1\x0d";

################################################################################

TITLE
    Ventrilo UDP status packet encryption ventrilo_udp_encdata_data

TYPE
    8

DATA
    "\x82\x8b\x7f\x68\x90\xe0\x44\x09\x19\x3b\x8e\x5f\xc2\x82\x38\x23"
    "\x6d\xdb\x62\x49\x52\x6e\x21\xdf\x51\x6c\x76\x37\x86\x50\x7d\x48"
    "\x1f\x65\xe7\x52\x6a\x88\xaa\xc1\x32\x2f\xf7\x54\x4c\xaa\x6d\x7e"
    "\x6d\xa9\x8c\x0d\x3f\xff\x6c\x09\xb3\xa5\xaf\xdf\x98\x02\xb4\xbe"
    "\x6d\x69\x0d\x42\x73\xe4\x34\x50\x07\x30\x79\x41\x2f\x08\x3f\x42"
    "\x73\xa7\x68\xfa\xee\x88\x0e\x6e\xa4\x70\x74\x22\x16\xae\x3c\x81"
    "\x14\xa1\xda\x7f\xd3\x7c\x48\x7d\x3f\x46\xfb\x6d\x92\x25\x17\x36"
    "\x26\xdb\xdf\x5a\x87\x91\x6f\xd6\xcd\xd4\xad\x4a\x29\xdd\x7d\x59"
    "\xbd\x15\x34\x53\xb1\xd8\x50\x11\x83\x79\x66\x21\x9e\x87\x5b\x24"
    "\x2f\x4f\xd7\x73\x34\xa2\xf7\x09\xd5\xd9\x42\x9d\xf8\x15\xdf\x0e"
    "\x10\xcc\x05\x04\x35\x81\xb2\xd5\x7a\xd2\xa0\xa5\x7b\xb8\x75\xd2"
    "\x35\x0b\x39\x8f\x1b\x44\x0e\xce\x66\x87\x1b\x64\xac\xe1\xca\x67"
    "\xb4\xce\x33\xdb\x89\xfe\xd8\x8e\xcd\x58\x92\x41\x50\x40\xcb\x08"
    "\xe1\x15\xee\xf4\x64\xfe\x1c\xee\x25\xe7\x21\xe6\x6c\xc6\xa6\x2e"
    "\x52\x23\xa7\x20\xd2\xd7\x28\x07\x23\x14\x24\x3d\x45\xa5\xc7\x90"
    "\xdb\x77\xdd\xea\x38\x59\x89\x32\xbc\x00\x3a\x6d\x61\x4e\xdb\x29";

################################################################################

TITLE
    Black Hole Entertainment ORK encryption

TYPE
    32 AND

DATA
    0x48b18039 0x48b18039 0x48b18039
    // 0x114e230b 0xa4d6cf31 1869628369 0x48b18039

################################################################################

TITLE
    LZSS (N 4096, F 18, T 2)

TYPE
    32 AND

DATA
    0xfee 0xf0 0xfff 0xfff

################################################################################

TITLE
    Simbin Race WTCC files encryption version 0 and 1

TYPE
    8

DATA
    "\x46\x17\x80\x2d\x13\xe4\x2f\x2f\x27\x6f\x1e\x19\x23\x65\x69\x14\x41\x2c\x01\x05",

################################################################################

TITLE
    Simbin Race WTCC files encryption version 2

TYPE
    8

DATA
    "qcB81[O x_@)pobk",

################################################################################

TITLE
    Simbin Race WTCC files encryption version 5

TYPE
    8

DATA
    "\x45\x13\x3B\x81\x0B\xA1\x09\x96\x25\x42\xF0\xE5\x7D\x19\x11\x53"

################################################################################

TITLE
    GameGuard files encryption public key

TYPE
    8

DATA
                "\x06\x02\x00\x00\x00\x24\x00\x00\x52\x53\x41\x31\x00\x02\x00\x00"
                "\x01\x00\x01\x00\xFB\xE3\xFC\x09\xAF\xAE\x65\x8C\x96\x4C\xC5\x37"
                "\xD2\xA4\x77\xE7\x4C\x41\xC2\xCF\xF2\xFE\x2D\x9C\x80\x94\x0C\x88"
                "\x6D\xB3\x84\x9F\x8C\x22\xA0\xC9\xCD\xC0\xAB\x30\x65\x82\x42\x3C"
                "\xEE\x3C\xA8\xB7\x11\xD6\x22\xFA\xFB\x23\xF7\x72\xCD\xE7\xD0\x6F"
                "\x6A\x8E\x96\xE3"

################################################################################

TITLE
    CP850andASCIItable

TYPE
    8

DATA
	0x0,	0xFC,	0xE9,	0xE2,	0xE4,	0xE9,	0x0,	0x0,
	0xEA,	0x0,	0xE8,	0x0,	0xEE,	0xEC,	0xC4,	0x0,
	0xC9,	0x0,	0x0,	0xF4,	0xF6,	0xF2,	0xFB,	0xF9,
	0x0,	0xD6,	0xDC,	0x0,	0x0,	0x0,	0x0,	0x0,
	0xE1,	0xED,	0xF3,	0xFA,	0x0,	0x0,	0x0,	0x0,
	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
	0x0,	0x0,	0x0,	0x0,	0x0,	0xC1,	0xC2,	0xC0,
	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,	0x0,
	0x0,	0xC1,	0xC2,	0x0,	0xC4,	0x0,	0x0,	0x0,
	0xC8,	0xC9,	0xCA,	0x0,	0xCC,	0xCD,	0xCE,	0x0,
	0x0,	0x0,	0xCA,	0xDA,	0xD4,	0x0,	0xCD,	0xCE,
	0x0,	0xD9,	0xDA,	0xDB,	0xDC,	0x0,	0xCC,	0xDF,
	0xE9,	0xDF,	0xD4,	0xD2,	0xE4,	0x0,	0x0,	0x0,
	0xE8,	0xD3,	0xDB,	0xD9,	0xEC,	0xED,	0xEE,	0x0,
	0x0,	0x0,	0xF2,	0xF3,	0xF4,	0x0,	0xF6,	0x0,
	0x0,	0xF9,	0xFA,	0xFB,	0xFC,	0x0

################################################################################

TITLE
    PSX VAG_f decoder

TYPE
    FLOAT

DATA
                     { { 0.0          ,   0.0        },
                       {  60.0 / 64.0 ,   0.0        },
		               { 115.0 / 64.0 , -52.0 / 64.0 },
		               {  98.0 / 64.0 , -55.0 / 64.0 } ,
		               { 122.0 / 64.0 , -60.0 / 64.0 } } ;

################################################################################

TITLE
    SDX2 - 2:1 Squareroot-delta-exact compression

TYPE
    16, 32

DATA
-32768,-32258,-31752,-31250,-30752,-30258,-29768,-29282,-28800,-28322,-27848,
-27378,-26912,-26450,-25992,-25538,-25088,-24642,-24200,-23762,-23328,-22898,
-22472,-22050,-21632,-21218,-20808,-20402,-20000,-19602,-19208,-18818,-18432,
-18050,-17672,-17298,-16928,-16562,-16200,-15842,-15488,-15138,-14792,-14450,
-14112,-13778,-13448,-13122,-12800,-12482,-12168,-11858,-11552,-11250,-10952,
-10658,-10368,-10082, -9800, -9522, -9248, -8978, -8712, -8450, -8192, -7938,
 -7688, -7442, -7200, -6962, -6728, -6498, -6272, -6050, -5832, -5618, -5408,
 -5202, -5000, -4802, -4608, -4418, -4232, -4050, -3872, -3698, -3528, -3362,
 -3200, -3042, -2888, -2738, -2592, -2450, -2312, -2178, -2048, -1922, -1800,
 -1682, -1568, -1458, -1352, -1250, -1152, -1058,  -968,  -882,  -800,  -722,
  -648,  -578,  -512,  -450,  -392,  -338,  -288,  -242,  -200,  -162,  -128,
   -98,   -72,   -50,   -32,   -18,    -8,    -2,     0,     2,     8,    18,
    32,    50,    72,    98,   128,   162,   200,   242,   288,   338,   392,
   450,   512,   578,   648,   722,   800,   882,   968,  1058,  1152,  1250,
  1352,  1458,  1568,  1682,  1800,  1922,  2048,  2178,  2312,  2450,  2592,
  2738,  2888,  3042,  3200,  3362,  3528,  3698,  3872,  4050,  4232,  4418,
  4608,  4802,  5000,  5202,  5408,  5618,  5832,  6050,  6272,  6498,  6728,
  6962,  7200,  7442,  7688,  7938,  8192,  8450,  8712,  8978,  9248,  9522,
  9800, 10082, 10368, 10658, 10952, 11250, 11552, 11858, 12168, 12482, 12800,
 13122, 13448, 13778, 14112, 14450, 14792, 15138, 15488, 15842, 16200, 16562,
 16928, 17298, 17672, 18050, 18432, 18818, 19208, 19602, 20000, 20402, 20808,
 21218, 21632, 22050, 22472, 22898, 23328, 23762, 24200, 24642, 25088, 25538,
 25992, 26450, 26912, 27378, 27848, 28322, 28800, 29282, 29768, 30258, 30752,
 31250, 31752, 32258

################################################################################

TITLE
    Westwood Studios ADPCM (WSTable2bit and WSTable4bit)

TYPE
    8

DATA
    {-2,-1,0,1};
    {-9,-8,-6,-5,-4,-3,-2,-1,
      0, 1, 2, 3, 4, 5 ,6, 8};

################################################################################

TITLE
    swscale rgb2yuv_table

TYPE
    FLOAT

DATA
    {0.7152, 0.0722, 0.2126, -0.386, 0.5, -0.115, -0.454, -0.046, 0.5},
    {0.7152, 0.0722, 0.2126, -0.386, 0.5, -0.115, -0.454, -0.046, 0.5},
    {0.587 , 0.114 , 0.299 , -0.331, 0.5, -0.169, -0.419, -0.081, 0.5},
    {0.587 , 0.114 , 0.299 , -0.331, 0.5, -0.169, -0.419, -0.081, 0.5},
    {0.59  , 0.11  , 0.30  , -0.331, 0.5, -0.169, -0.421, -0.079, 0.5}, //FCC
    {0.587 , 0.114 , 0.299 , -0.331, 0.5, -0.169, -0.419, -0.081, 0.5},
    {0.587 , 0.114 , 0.299 , -0.331, 0.5, -0.169, -0.419, -0.081, 0.5}, //SMPTE 170M
    {0.701 , 0.087 , 0.212 , -0.384, 0.5  -0.116, -0.445, -0.055, 0.5}, //SMPTE 240M

################################################################################

TITLE
    swscale perm_rgb 

TYPE
    8

DATA
               {0x00,0x01,0x10,0x02,0x03,0x11,0x04,0x05,
                0x12,0x06,0x07,0x13,0x08,0x09,0x14,0x0a},
               {0x0b,0x15,0x0c,0x0d,0x16,0x0e,0x0f,0x17,
                0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f},
               {0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
                0x00,0x01,0x18,0x02,0x03,0x19,0x04,0x05},
               {0x1a,0x06,0x07,0x1b,0x08,0x09,0x1c,0x0a,
                0x0b,0x1d,0x0c,0x0d,0x1e,0x0e,0x0f,0x1f};

################################################################################

TITLE
    base64 map 

TYPE
    8

DATA
    0x3e, 0xff, 0xff, 0xff, 0x3f, 0x34, 0x35, 0x36,
    0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c, 0x3d, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01,
    0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
    0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x10, 0x11,
    0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x1a, 0x1b,
    0x1c, 0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23,
    0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b,
    0x2c, 0x2d, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33

################################################################################

TITLE
    ff_sqrt_tab

TYPE
    8

DATA
  0, 16, 23, 28, 32, 36, 40, 43, 46, 48, 51, 54, 56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 77, 79, 80, 82, 84, 85, 87, 88, 90,
 91, 92, 94, 95, 96, 98, 99,100,102,103,104,105,107,108,109,110,111,112,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,144,145,146,147,148,149,150,151,151,152,153,154,155,156,156,
157,158,159,160,160,161,162,163,164,164,165,166,167,168,168,169,170,171,171,172,173,174,174,175,176,176,177,178,179,179,180,181,
182,182,183,184,184,185,186,186,187,188,188,189,190,190,191,192,192,193,194,194,195,196,196,197,198,198,199,200,200,201,202,202,
203,204,204,205,205,206,207,207,208,208,209,210,210,211,212,212,213,213,214,215,215,216,216,217,218,218,219,219,220,220,221,222,
222,223,223,224,224,225,226,226,227,227,228,228,229,230,230,231,231,232,232,233,233,234,235,235,236,236,237,237,238,238,239,239,
240,240,241,242,242,243,243,244,244,245,245,246,246,247,247,248,248,249,249,250,250,251,251,252,252,253,253,254,254,255,255,255

################################################################################

TITLE
    libavformat CODEC_ID_AMR_WB packet_size

TYPE
    8

DATA
    {18, 24, 33, 37, 41, 47, 51, 59, 61, 6, 6, 0, 0, 0, 1, 1}

################################################################################

TITLE
    libavformat CODEC_ID_AMR_NB packet_size

TYPE
    8

DATA
    {13, 14, 16, 18, 20, 21, 27, 32, 6, 0, 0, 0, 0, 0, 0, 0};

################################################################################

TITLE
    libavformat dv_aaux_packs_dist

TYPE
    8

DATA
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0xff, 0xff, 0xff, 0x50, 0x51, 0x52, 0x53, 0xff, 0xff },
    { 0x50, 0x51, 0x52, 0x53, 0xff, 0xff, 0xff, 0xff, 0xff },

################################################################################

TITLE
    libavformat gif_clut

TYPE
    8

DATA
    { 0x00, 0x00, 0x00 }, { 0x00, 0x00, 0x33 }, { 0x00, 0x00, 0x66 }, { 0x00, 0x00, 0x99 }, { 0x00, 0x00, 0xcc }, { 0x00, 0x00, 0xff },
    { 0x00, 0x33, 0x00 }, { 0x00, 0x33, 0x33 }, { 0x00, 0x33, 0x66 }, { 0x00, 0x33, 0x99 }, { 0x00, 0x33, 0xcc }, { 0x00, 0x33, 0xff },
    { 0x00, 0x66, 0x00 }, { 0x00, 0x66, 0x33 }, { 0x00, 0x66, 0x66 }, { 0x00, 0x66, 0x99 }, { 0x00, 0x66, 0xcc }, { 0x00, 0x66, 0xff },
    { 0x00, 0x99, 0x00 }, { 0x00, 0x99, 0x33 }, { 0x00, 0x99, 0x66 }, { 0x00, 0x99, 0x99 }, { 0x00, 0x99, 0xcc }, { 0x00, 0x99, 0xff },
    { 0x00, 0xcc, 0x00 }, { 0x00, 0xcc, 0x33 }, { 0x00, 0xcc, 0x66 }, { 0x00, 0xcc, 0x99 }, { 0x00, 0xcc, 0xcc }, { 0x00, 0xcc, 0xff },
    { 0x00, 0xff, 0x00 }, { 0x00, 0xff, 0x33 }, { 0x00, 0xff, 0x66 }, { 0x00, 0xff, 0x99 }, { 0x00, 0xff, 0xcc }, { 0x00, 0xff, 0xff },
    { 0x33, 0x00, 0x00 }, { 0x33, 0x00, 0x33 }, { 0x33, 0x00, 0x66 }, { 0x33, 0x00, 0x99 }, { 0x33, 0x00, 0xcc }, { 0x33, 0x00, 0xff },
    { 0x33, 0x33, 0x00 }, { 0x33, 0x33, 0x33 }, { 0x33, 0x33, 0x66 }, { 0x33, 0x33, 0x99 }, { 0x33, 0x33, 0xcc }, { 0x33, 0x33, 0xff },
    { 0x33, 0x66, 0x00 }, { 0x33, 0x66, 0x33 }, { 0x33, 0x66, 0x66 }, { 0x33, 0x66, 0x99 }, { 0x33, 0x66, 0xcc }, { 0x33, 0x66, 0xff },
    { 0x33, 0x99, 0x00 }, { 0x33, 0x99, 0x33 }, { 0x33, 0x99, 0x66 }, { 0x33, 0x99, 0x99 }, { 0x33, 0x99, 0xcc }, { 0x33, 0x99, 0xff },
    { 0x33, 0xcc, 0x00 }, { 0x33, 0xcc, 0x33 }, { 0x33, 0xcc, 0x66 }, { 0x33, 0xcc, 0x99 }, { 0x33, 0xcc, 0xcc }, { 0x33, 0xcc, 0xff },
    { 0x33, 0xff, 0x00 }, { 0x33, 0xff, 0x33 }, { 0x33, 0xff, 0x66 }, { 0x33, 0xff, 0x99 }, { 0x33, 0xff, 0xcc }, { 0x33, 0xff, 0xff },
    { 0x66, 0x00, 0x00 }, { 0x66, 0x00, 0x33 }, { 0x66, 0x00, 0x66 }, { 0x66, 0x00, 0x99 }, { 0x66, 0x00, 0xcc }, { 0x66, 0x00, 0xff },
    { 0x66, 0x33, 0x00 }, { 0x66, 0x33, 0x33 }, { 0x66, 0x33, 0x66 }, { 0x66, 0x33, 0x99 }, { 0x66, 0x33, 0xcc }, { 0x66, 0x33, 0xff },
    { 0x66, 0x66, 0x00 }, { 0x66, 0x66, 0x33 }, { 0x66, 0x66, 0x66 }, { 0x66, 0x66, 0x99 }, { 0x66, 0x66, 0xcc }, { 0x66, 0x66, 0xff },
    { 0x66, 0x99, 0x00 }, { 0x66, 0x99, 0x33 }, { 0x66, 0x99, 0x66 }, { 0x66, 0x99, 0x99 }, { 0x66, 0x99, 0xcc }, { 0x66, 0x99, 0xff },
    { 0x66, 0xcc, 0x00 }, { 0x66, 0xcc, 0x33 }, { 0x66, 0xcc, 0x66 }, { 0x66, 0xcc, 0x99 }, { 0x66, 0xcc, 0xcc }, { 0x66, 0xcc, 0xff },
    { 0x66, 0xff, 0x00 }, { 0x66, 0xff, 0x33 }, { 0x66, 0xff, 0x66 }, { 0x66, 0xff, 0x99 }, { 0x66, 0xff, 0xcc }, { 0x66, 0xff, 0xff },
    { 0x99, 0x00, 0x00 }, { 0x99, 0x00, 0x33 }, { 0x99, 0x00, 0x66 }, { 0x99, 0x00, 0x99 }, { 0x99, 0x00, 0xcc }, { 0x99, 0x00, 0xff },
    { 0x99, 0x33, 0x00 }, { 0x99, 0x33, 0x33 }, { 0x99, 0x33, 0x66 }, { 0x99, 0x33, 0x99 }, { 0x99, 0x33, 0xcc }, { 0x99, 0x33, 0xff },
    { 0x99, 0x66, 0x00 }, { 0x99, 0x66, 0x33 }, { 0x99, 0x66, 0x66 }, { 0x99, 0x66, 0x99 }, { 0x99, 0x66, 0xcc }, { 0x99, 0x66, 0xff },
    { 0x99, 0x99, 0x00 }, { 0x99, 0x99, 0x33 }, { 0x99, 0x99, 0x66 }, { 0x99, 0x99, 0x99 }, { 0x99, 0x99, 0xcc }, { 0x99, 0x99, 0xff },
    { 0x99, 0xcc, 0x00 }, { 0x99, 0xcc, 0x33 }, { 0x99, 0xcc, 0x66 }, { 0x99, 0xcc, 0x99 }, { 0x99, 0xcc, 0xcc }, { 0x99, 0xcc, 0xff },
    { 0x99, 0xff, 0x00 }, { 0x99, 0xff, 0x33 }, { 0x99, 0xff, 0x66 }, { 0x99, 0xff, 0x99 }, { 0x99, 0xff, 0xcc }, { 0x99, 0xff, 0xff },
    { 0xcc, 0x00, 0x00 }, { 0xcc, 0x00, 0x33 }, { 0xcc, 0x00, 0x66 }, { 0xcc, 0x00, 0x99 }, { 0xcc, 0x00, 0xcc }, { 0xcc, 0x00, 0xff },
    { 0xcc, 0x33, 0x00 }, { 0xcc, 0x33, 0x33 }, { 0xcc, 0x33, 0x66 }, { 0xcc, 0x33, 0x99 }, { 0xcc, 0x33, 0xcc }, { 0xcc, 0x33, 0xff },
    { 0xcc, 0x66, 0x00 }, { 0xcc, 0x66, 0x33 }, { 0xcc, 0x66, 0x66 }, { 0xcc, 0x66, 0x99 }, { 0xcc, 0x66, 0xcc }, { 0xcc, 0x66, 0xff },
    { 0xcc, 0x99, 0x00 }, { 0xcc, 0x99, 0x33 }, { 0xcc, 0x99, 0x66 }, { 0xcc, 0x99, 0x99 }, { 0xcc, 0x99, 0xcc }, { 0xcc, 0x99, 0xff },
    { 0xcc, 0xcc, 0x00 }, { 0xcc, 0xcc, 0x33 }, { 0xcc, 0xcc, 0x66 }, { 0xcc, 0xcc, 0x99 }, { 0xcc, 0xcc, 0xcc }, { 0xcc, 0xcc, 0xff },
    { 0xcc, 0xff, 0x00 }, { 0xcc, 0xff, 0x33 }, { 0xcc, 0xff, 0x66 }, { 0xcc, 0xff, 0x99 }, { 0xcc, 0xff, 0xcc }, { 0xcc, 0xff, 0xff },
    { 0xff, 0x00, 0x00 }, { 0xff, 0x00, 0x33 }, { 0xff, 0x00, 0x66 }, { 0xff, 0x00, 0x99 }, { 0xff, 0x00, 0xcc }, { 0xff, 0x00, 0xff },
    { 0xff, 0x33, 0x00 }, { 0xff, 0x33, 0x33 }, { 0xff, 0x33, 0x66 }, { 0xff, 0x33, 0x99 }, { 0xff, 0x33, 0xcc }, { 0xff, 0x33, 0xff },
    { 0xff, 0x66, 0x00 }, { 0xff, 0x66, 0x33 }, { 0xff, 0x66, 0x66 }, { 0xff, 0x66, 0x99 }, { 0xff, 0x66, 0xcc }, { 0xff, 0x66, 0xff },
    { 0xff, 0x99, 0x00 }, { 0xff, 0x99, 0x33 }, { 0xff, 0x99, 0x66 }, { 0xff, 0x99, 0x99 }, { 0xff, 0x99, 0xcc }, { 0xff, 0x99, 0xff },
    { 0xff, 0xcc, 0x00 }, { 0xff, 0xcc, 0x33 }, { 0xff, 0xcc, 0x66 }, { 0xff, 0xcc, 0x99 }, { 0xff, 0xcc, 0xcc }, { 0xff, 0xcc, 0xff },
    { 0xff, 0xff, 0x00 }, { 0xff, 0xff, 0x33 }, { 0xff, 0xff, 0x66 }, { 0xff, 0xff, 0x99 }, { 0xff, 0xff, 0xcc }, { 0xff, 0xff, 0xff },

################################################################################

TITLE
    libavformat fps_umf2avr AVRational map

TYPE
    32

DATA
    {{50, 1}, {60000, 1001}, {24, 1},
        {25, 1}, {30000, 1001}};

################################################################################

TITLE
    libavformat ff_mxf_data_definition_uls

TYPE
    8

DATA
    { { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x01,0x01,0x03,0x02,0x02,0x01,0x00,0x00,0x00 }, 13, 0 },
    { { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x01,0x01,0x03,0x02,0x02,0x02,0x00,0x00,0x00 }, 13, 1 },
    { { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },  0,  2 },

################################################################################

TITLE
    libavformat ff_mxf_data_definition_uls (b)

TYPE
    8
DATA
0x06,0x0e,0x2b,0x34,0x04,0x01,0x01,0x01,0x01,0x03,0x02,0x02,0x01,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x0e,0x2b,0x34,0x04,0x01,0x01,0x01,
0x01,0x03,0x02,0x02,0x02,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x02,

################################################################################

TITLE
    libavformat mxf_mpeg2_codec_uls

TYPE
    8

DATA
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x01,0x10,0x00 }, // MP-ML I-Frame
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x01,0x11,0x00 }, // MP-ML Long GOP
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x02,0x02,0x00 }, // 422P-ML I-Frame
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x02,0x03,0x00 }, // 422P-ML Long GOP
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x03,0x02,0x00 }, // MP-HL I-Frame
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x03,0x03,0x00 }, // MP-HL Long GOP
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x04,0x02,0x00 }, // 422P-HL I-Frame
    { 0x06,0x0E,0x2B,0x34,0x04,0x01,0x01,0x03,0x04,0x01,0x02,0x02,0x01,0x04,0x03,0x00 }, // 422P-HL Long GOP

################################################################################

TITLE
    libavformat ff_qt_default_palette_256

TYPE
    8

DATA
  0xFF, 0xFF, 0xFF, 0x00,
  0xFF, 0xFF, 0xCC, 0x00,
  0xFF, 0xFF, 0x99, 0x00,
  0xFF, 0xFF, 0x66, 0x00,
  0xFF, 0xFF, 0x33, 0x00,
  0xFF, 0xFF, 0x00, 0x00,
  0xFF, 0xCC, 0xFF, 0x00,
  0xFF, 0xCC, 0xCC, 0x00,
  0xFF, 0xCC, 0x99, 0x00,
  0xFF, 0xCC, 0x66, 0x00,
  0xFF, 0xCC, 0x33, 0x00,
  0xFF, 0xCC, 0x00, 0x00,
  0xFF, 0x99, 0xFF, 0x00,
  0xFF, 0x99, 0xCC, 0x00,
  0xFF, 0x99, 0x99, 0x00,
  0xFF, 0x99, 0x66, 0x00,
  0xFF, 0x99, 0x33, 0x00,
  0xFF, 0x99, 0x00, 0x00,
  0xFF, 0x66, 0xFF, 0x00,
  0xFF, 0x66, 0xCC, 0x00,
  0xFF, 0x66, 0x99, 0x00,
  0xFF, 0x66, 0x66, 0x00,
  0xFF, 0x66, 0x33, 0x00,
  0xFF, 0x66, 0x00, 0x00,
  0xFF, 0x33, 0xFF, 0x00,
  0xFF, 0x33, 0xCC, 0x00,
  0xFF, 0x33, 0x99, 0x00,
  0xFF, 0x33, 0x66, 0x00,
  0xFF, 0x33, 0x33, 0x00,
  0xFF, 0x33, 0x00, 0x00,
  0xFF, 0x00, 0xFF, 0x00,
  0xFF, 0x00, 0xCC, 0x00,
  0xFF, 0x00, 0x99, 0x00,
  0xFF, 0x00, 0x66, 0x00,
  0xFF, 0x00, 0x33, 0x00,
  0xFF, 0x00, 0x00, 0x00,
  0xCC, 0xFF, 0xFF, 0x00,
  0xCC, 0xFF, 0xCC, 0x00,
  0xCC, 0xFF, 0x99, 0x00,
  0xCC, 0xFF, 0x66, 0x00,
  0xCC, 0xFF, 0x33, 0x00,
  0xCC, 0xFF, 0x00, 0x00,
  0xCC, 0xCC, 0xFF, 0x00,
  0xCC, 0xCC, 0xCC, 0x00,
  0xCC, 0xCC, 0x99, 0x00,
  0xCC, 0xCC, 0x66, 0x00,
  0xCC, 0xCC, 0x33, 0x00,
  0xCC, 0xCC, 0x00, 0x00,
  0xCC, 0x99, 0xFF, 0x00,
  0xCC, 0x99, 0xCC, 0x00,
  0xCC, 0x99, 0x99, 0x00,
  0xCC, 0x99, 0x66, 0x00,
  0xCC, 0x99, 0x33, 0x00,
  0xCC, 0x99, 0x00, 0x00,
  0xCC, 0x66, 0xFF, 0x00,
  0xCC, 0x66, 0xCC, 0x00,
  0xCC, 0x66, 0x99, 0x00,
  0xCC, 0x66, 0x66, 0x00,
  0xCC, 0x66, 0x33, 0x00,
  0xCC, 0x66, 0x00, 0x00,
  0xCC, 0x33, 0xFF, 0x00,
  0xCC, 0x33, 0xCC, 0x00,
  0xCC, 0x33, 0x99, 0x00,
  0xCC, 0x33, 0x66, 0x00,
  0xCC, 0x33, 0x33, 0x00,
  0xCC, 0x33, 0x00, 0x00,
  0xCC, 0x00, 0xFF, 0x00,
  0xCC, 0x00, 0xCC, 0x00,
  0xCC, 0x00, 0x99, 0x00,
  0xCC, 0x00, 0x66, 0x00,
  0xCC, 0x00, 0x33, 0x00,
  0xCC, 0x00, 0x00, 0x00,
  0x99, 0xFF, 0xFF, 0x00,
  0x99, 0xFF, 0xCC, 0x00,
  0x99, 0xFF, 0x99, 0x00,
  0x99, 0xFF, 0x66, 0x00,
  0x99, 0xFF, 0x33, 0x00,
  0x99, 0xFF, 0x00, 0x00,
  0x99, 0xCC, 0xFF, 0x00,
  0x99, 0xCC, 0xCC, 0x00,
  0x99, 0xCC, 0x99, 0x00,
  0x99, 0xCC, 0x66, 0x00,
  0x99, 0xCC, 0x33, 0x00,
  0x99, 0xCC, 0x00, 0x00,
  0x99, 0x99, 0xFF, 0x00,
  0x99, 0x99, 0xCC, 0x00,
  0x99, 0x99, 0x99, 0x00,
  0x99, 0x99, 0x66, 0x00,
  0x99, 0x99, 0x33, 0x00,
  0x99, 0x99, 0x00, 0x00,
  0x99, 0x66, 0xFF, 0x00,
  0x99, 0x66, 0xCC, 0x00,
  0x99, 0x66, 0x99, 0x00,
  0x99, 0x66, 0x66, 0x00,
  0x99, 0x66, 0x33, 0x00,
  0x99, 0x66, 0x00, 0x00,
  0x99, 0x33, 0xFF, 0x00,
  0x99, 0x33, 0xCC, 0x00,
  0x99, 0x33, 0x99, 0x00,
  0x99, 0x33, 0x66, 0x00,
  0x99, 0x33, 0x33, 0x00,
  0x99, 0x33, 0x00, 0x00,
  0x99, 0x00, 0xFF, 0x00,
  0x99, 0x00, 0xCC, 0x00,
  0x99, 0x00, 0x99, 0x00,
  0x99, 0x00, 0x66, 0x00,
  0x99, 0x00, 0x33, 0x00,
  0x99, 0x00, 0x00, 0x00,
  0x66, 0xFF, 0xFF, 0x00,
  0x66, 0xFF, 0xCC, 0x00,
  0x66, 0xFF, 0x99, 0x00,
  0x66, 0xFF, 0x66, 0x00,
  0x66, 0xFF, 0x33, 0x00,
  0x66, 0xFF, 0x00, 0x00,
  0x66, 0xCC, 0xFF, 0x00,
  0x66, 0xCC, 0xCC, 0x00,
  0x66, 0xCC, 0x99, 0x00,
  0x66, 0xCC, 0x66, 0x00,
  0x66, 0xCC, 0x33, 0x00,
  0x66, 0xCC, 0x00, 0x00,
  0x66, 0x99, 0xFF, 0x00,
  0x66, 0x99, 0xCC, 0x00,
  0x66, 0x99, 0x99, 0x00,
  0x66, 0x99, 0x66, 0x00,
  0x66, 0x99, 0x33, 0x00,
  0x66, 0x99, 0x00, 0x00,
  0x66, 0x66, 0xFF, 0x00,
  0x66, 0x66, 0xCC, 0x00,
  0x66, 0x66, 0x99, 0x00,
  0x66, 0x66, 0x66, 0x00,
  0x66, 0x66, 0x33, 0x00,
  0x66, 0x66, 0x00, 0x00,
  0x66, 0x33, 0xFF, 0x00,
  0x66, 0x33, 0xCC, 0x00,
  0x66, 0x33, 0x99, 0x00,
  0x66, 0x33, 0x66, 0x00,
  0x66, 0x33, 0x33, 0x00,
  0x66, 0x33, 0x00, 0x00,
  0x66, 0x00, 0xFF, 0x00,
  0x66, 0x00, 0xCC, 0x00,
  0x66, 0x00, 0x99, 0x00,
  0x66, 0x00, 0x66, 0x00,
  0x66, 0x00, 0x33, 0x00,
  0x66, 0x00, 0x00, 0x00,
  0x33, 0xFF, 0xFF, 0x00,
  0x33, 0xFF, 0xCC, 0x00,
  0x33, 0xFF, 0x99, 0x00,
  0x33, 0xFF, 0x66, 0x00,
  0x33, 0xFF, 0x33, 0x00,
  0x33, 0xFF, 0x00, 0x00,
  0x33, 0xCC, 0xFF, 0x00,
  0x33, 0xCC, 0xCC, 0x00,
  0x33, 0xCC, 0x99, 0x00,
  0x33, 0xCC, 0x66, 0x00,
  0x33, 0xCC, 0x33, 0x00,
  0x33, 0xCC, 0x00, 0x00,
  0x33, 0x99, 0xFF, 0x00,
  0x33, 0x99, 0xCC, 0x00,
  0x33, 0x99, 0x99, 0x00,
  0x33, 0x99, 0x66, 0x00,
  0x33, 0x99, 0x33, 0x00,
  0x33, 0x99, 0x00, 0x00,
  0x33, 0x66, 0xFF, 0x00,
  0x33, 0x66, 0xCC, 0x00,
  0x33, 0x66, 0x99, 0x00,
  0x33, 0x66, 0x66, 0x00,
  0x33, 0x66, 0x33, 0x00,
  0x33, 0x66, 0x00, 0x00,
  0x33, 0x33, 0xFF, 0x00,
  0x33, 0x33, 0xCC, 0x00,
  0x33, 0x33, 0x99, 0x00,
  0x33, 0x33, 0x66, 0x00,
  0x33, 0x33, 0x33, 0x00,
  0x33, 0x33, 0x00, 0x00,
  0x33, 0x00, 0xFF, 0x00,
  0x33, 0x00, 0xCC, 0x00,
  0x33, 0x00, 0x99, 0x00,
  0x33, 0x00, 0x66, 0x00,
  0x33, 0x00, 0x33, 0x00,
  0x33, 0x00, 0x00, 0x00,
  0x00, 0xFF, 0xFF, 0x00,
  0x00, 0xFF, 0xCC, 0x00,
  0x00, 0xFF, 0x99, 0x00,
  0x00, 0xFF, 0x66, 0x00,
  0x00, 0xFF, 0x33, 0x00,
  0x00, 0xFF, 0x00, 0x00,
  0x00, 0xCC, 0xFF, 0x00,
  0x00, 0xCC, 0xCC, 0x00,
  0x00, 0xCC, 0x99, 0x00,
  0x00, 0xCC, 0x66, 0x00,
  0x00, 0xCC, 0x33, 0x00,
  0x00, 0xCC, 0x00, 0x00,
  0x00, 0x99, 0xFF, 0x00,
  0x00, 0x99, 0xCC, 0x00,
  0x00, 0x99, 0x99, 0x00,
  0x00, 0x99, 0x66, 0x00,
  0x00, 0x99, 0x33, 0x00,
  0x00, 0x99, 0x00, 0x00,
  0x00, 0x66, 0xFF, 0x00,
  0x00, 0x66, 0xCC, 0x00,
  0x00, 0x66, 0x99, 0x00,
  0x00, 0x66, 0x66, 0x00,
  0x00, 0x66, 0x33, 0x00,
  0x00, 0x66, 0x00, 0x00,
  0x00, 0x33, 0xFF, 0x00,
  0x00, 0x33, 0xCC, 0x00,
  0x00, 0x33, 0x99, 0x00,
  0x00, 0x33, 0x66, 0x00,
  0x00, 0x33, 0x33, 0x00,
  0x00, 0x33, 0x00, 0x00,
  0x00, 0x00, 0xFF, 0x00,
  0x00, 0x00, 0xCC, 0x00,
  0x00, 0x00, 0x99, 0x00,
  0x00, 0x00, 0x66, 0x00,
  0x00, 0x00, 0x33, 0x00,
  0xEE, 0x00, 0x00, 0x00,
  0xDD, 0x00, 0x00, 0x00,
  0xBB, 0x00, 0x00, 0x00,
  0xAA, 0x00, 0x00, 0x00,
  0x88, 0x00, 0x00, 0x00,
  0x77, 0x00, 0x00, 0x00,
  0x55, 0x00, 0x00, 0x00,
  0x44, 0x00, 0x00, 0x00,
  0x22, 0x00, 0x00, 0x00,
  0x11, 0x00, 0x00, 0x00,
  0x00, 0xEE, 0x00, 0x00,
  0x00, 0xDD, 0x00, 0x00,
  0x00, 0xBB, 0x00, 0x00,
  0x00, 0xAA, 0x00, 0x00,
  0x00, 0x88, 0x00, 0x00,
  0x00, 0x77, 0x00, 0x00,
  0x00, 0x55, 0x00, 0x00,
  0x00, 0x44, 0x00, 0x00,
  0x00, 0x22, 0x00, 0x00,
  0x00, 0x11, 0x00, 0x00,
  0x00, 0x00, 0xEE, 0x00,
  0x00, 0x00, 0xDD, 0x00,
  0x00, 0x00, 0xBB, 0x00,
  0x00, 0x00, 0xAA, 0x00,
  0x00, 0x00, 0x88, 0x00,
  0x00, 0x00, 0x77, 0x00,
  0x00, 0x00, 0x55, 0x00,
  0x00, 0x00, 0x44, 0x00,
  0x00, 0x00, 0x22, 0x00,
  0x00, 0x00, 0x11, 0x00,
  0xEE, 0xEE, 0xEE, 0x00,
  0xDD, 0xDD, 0xDD, 0x00,
  0xBB, 0xBB, 0xBB, 0x00,
  0xAA, 0xAA, 0xAA, 0x00,
  0x88, 0x88, 0x88, 0x00,
  0x77, 0x77, 0x77, 0x00,
  0x55, 0x55, 0x55, 0x00,
  0x44, 0x44, 0x44, 0x00,
  0x22, 0x22, 0x22, 0x00,
  0x11, 0x11, 0x11, 0x00,
  0x00, 0x00, 0x00, 0x00

################################################################################

TITLE
    libavformat wc3_pal_lookup

TYPE
    8

DATA
  0x00, 0x03, 0x05, 0x07, 0x09, 0x0B, 0x0D, 0x0E,
  0x10, 0x12, 0x13, 0x15, 0x16, 0x18, 0x19, 0x1A,
  0x1C, 0x1D, 0x1F, 0x20, 0x21, 0x23, 0x24, 0x25,
  0x27, 0x28, 0x29, 0x2A, 0x2C, 0x2D, 0x2E, 0x2F,
  0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x38, 0x39,
  0x3A, 0x3B, 0x3C, 0x3D, 0x3F, 0x40, 0x41, 0x42,
  0x43, 0x44, 0x45, 0x46, 0x48, 0x49, 0x4A, 0x4B,
  0x4C, 0x4D, 0x4E, 0x4F, 0x50, 0x51, 0x52, 0x53,
  0x54, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C,
  0x5D, 0x5E, 0x5F, 0x60, 0x61, 0x62, 0x63, 0x64,
  0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C,
  0x6D, 0x6E, 0x6F, 0x70, 0x71, 0x72, 0x73, 0x74,
  0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C,
  0x7D, 0x7D, 0x7E, 0x7F, 0x80, 0x81, 0x82, 0x83,
  0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B,
  0x8C, 0x8D, 0x8D, 0x8E, 0x8F, 0x90, 0x91, 0x92,
  0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x99,
  0x9A, 0x9B, 0x9C, 0x9D, 0x9E, 0x9F, 0xA0, 0xA1,
  0xA2, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8,
  0xA9, 0xAA, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF,
  0xB0, 0xB1, 0xB2, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6,
  0xB7, 0xB8, 0xB9, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD,
  0xBE, 0xBF, 0xBF, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4,
  0xC5, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB,
  0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0xD0, 0xD1,
  0xD2, 0xD3, 0xD4, 0xD5, 0xD5, 0xD6, 0xD7, 0xD8,
  0xD9, 0xDA, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF,
  0xDF, 0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE4, 0xE5,
  0xE6, 0xE7, 0xE8, 0xE9, 0xE9, 0xEA, 0xEB, 0xEC,
  0xED, 0xED, 0xEE, 0xEF, 0xF0, 0xF1, 0xF1, 0xF2,
  0xF3, 0xF4, 0xF5, 0xF6, 0xF6, 0xF7, 0xF8, 0xF9,
  0xFA, 0xFA, 0xFB, 0xFC, 0xFD, 0xFD, 0xFD, 0xFD

################################################################################

TITLE
    libavcodec 8svx fibonacci

TYPE
    16 HEX

DATA
    de00 eb00 f300 f800 fb00 fd00 fe00 ff00
    0000 0100 0200 0300 0500 0800 0d00 1500

################################################################################

TITLE
    libavcodec swb_offset_1024_32

TYPE
    16

DATA
      0,   4,   8,  12,  16,  20,  24,  28,
     32,  36,  40,  48,  56,  64,  72,  80,
     88,  96, 108, 120, 132, 144, 160, 176,
    196, 216, 240, 264, 292, 320, 352, 384,
    416, 448, 480, 512, 544, 576, 608, 640,
    672, 704, 736, 768, 800, 832, 864, 896,
    928, 960, 992, 1024

################################################################################

TITLE
    libavcodec ff_aac_scalefactor_code

TYPE
    32

DATA
    0x3ffe8, 0x3ffe6, 0x3ffe7, 0x3ffe5, 0x7fff5, 0x7fff1, 0x7ffed, 0x7fff6,
    0x7ffee, 0x7ffef, 0x7fff0, 0x7fffc, 0x7fffd, 0x7ffff, 0x7fffe, 0x7fff7,
    0x7fff8, 0x7fffb, 0x7fff9, 0x3ffe4, 0x7fffa, 0x3ffe3, 0x1ffef, 0x1fff0,
    0x0fff5, 0x1ffee, 0x0fff2, 0x0fff3, 0x0fff4, 0x0fff1, 0x07ff6, 0x07ff7,
    0x03ff9, 0x03ff5, 0x03ff7, 0x03ff3, 0x03ff6, 0x03ff2, 0x01ff7, 0x01ff5,
    0x00ff9, 0x00ff7, 0x00ff6, 0x007f9, 0x00ff4, 0x007f8, 0x003f9, 0x003f7,
    0x003f5, 0x001f8, 0x001f7, 0x000fa, 0x000f8, 0x000f6, 0x00079, 0x0003a,
    0x00038, 0x0001a, 0x0000b, 0x00004, 0x00000, 0x0000a, 0x0000c, 0x0001b,
    0x00039, 0x0003b, 0x00078, 0x0007a, 0x000f7, 0x000f9, 0x001f6, 0x001f9,
    0x003f4, 0x003f6, 0x003f8, 0x007f5, 0x007f4, 0x007f6, 0x007f7, 0x00ff5,
    0x00ff8, 0x01ff4, 0x01ff6, 0x01ff8, 0x03ff8, 0x03ff4, 0x0fff0, 0x07ff4,
    0x0fff6, 0x07ff5, 0x3ffe2, 0x7ffd9, 0x7ffda, 0x7ffdb, 0x7ffdc, 0x7ffdd,
    0x7ffde, 0x7ffd8, 0x7ffd2, 0x7ffd3, 0x7ffd4, 0x7ffd5, 0x7ffd6, 0x7fff2,
    0x7ffdf, 0x7ffe7, 0x7ffe8, 0x7ffe9, 0x7ffea, 0x7ffeb, 0x7ffe6, 0x7ffe0,
    0x7ffe1, 0x7ffe2, 0x7ffe3, 0x7ffe4, 0x7ffe5, 0x7ffd7, 0x7ffec, 0x7fff4,
    0x7fff3,

################################################################################

TITLE
    libavcodec aac codes11

TYPE
    16

DATA
    0x000, 0x006, 0x019, 0x03d, 0x09c, 0x0c6, 0x1a7, 0x390,
    0x3c2, 0x3df, 0x7e6, 0x7f3, 0xffb, 0x7ec, 0xffa, 0xffe,
    0x38e, 0x005, 0x001, 0x008, 0x014, 0x037, 0x042, 0x092,
    0x0af, 0x191, 0x1a5, 0x1b5, 0x39e, 0x3c0, 0x3a2, 0x3cd,
    0x7d6, 0x0ae, 0x017, 0x007, 0x009, 0x018, 0x039, 0x040,
    0x08e, 0x0a3, 0x0b8, 0x199, 0x1ac, 0x1c1, 0x3b1, 0x396,
    0x3be, 0x3ca, 0x09d, 0x03c, 0x015, 0x016, 0x01a, 0x03b,
    0x044, 0x091, 0x0a5, 0x0be, 0x196, 0x1ae, 0x1b9, 0x3a1,
    0x391, 0x3a5, 0x3d5, 0x094, 0x09a, 0x036, 0x038, 0x03a,
    0x041, 0x08c, 0x09b, 0x0b0, 0x0c3, 0x19e, 0x1ab, 0x1bc,
    0x39f, 0x38f, 0x3a9, 0x3cf, 0x093, 0x0bf, 0x03e, 0x03f,
    0x043, 0x045, 0x09e, 0x0a7, 0x0b9, 0x194, 0x1a2, 0x1ba,
    0x1c3, 0x3a6, 0x3a7, 0x3bb, 0x3d4, 0x09f, 0x1a0, 0x08f,
    0x08d, 0x090, 0x098, 0x0a6, 0x0b6, 0x0c4, 0x19f, 0x1af,
    0x1bf, 0x399, 0x3bf, 0x3b4, 0x3c9, 0x3e7, 0x0a8, 0x1b6,
    0x0ab, 0x0a4, 0x0aa, 0x0b2, 0x0c2, 0x0c5, 0x198, 0x1a4,
    0x1b8, 0x38c, 0x3a4, 0x3c4, 0x3c6, 0x3dd, 0x3e8, 0x0ad,
    0x3af, 0x192, 0x0bd, 0x0bc, 0x18e, 0x197, 0x19a, 0x1a3,
    0x1b1, 0x38d, 0x398, 0x3b7, 0x3d3, 0x3d1, 0x3db, 0x7dd,
    0x0b4, 0x3de, 0x1a9, 0x19b, 0x19c, 0x1a1, 0x1aa, 0x1ad,
    0x1b3, 0x38b, 0x3b2, 0x3b8, 0x3ce, 0x3e1, 0x3e0, 0x7d2,
    0x7e5, 0x0b7, 0x7e3, 0x1bb, 0x1a8, 0x1a6, 0x1b0, 0x1b2,
    0x1b7, 0x39b, 0x39a, 0x3ba, 0x3b5, 0x3d6, 0x7d7, 0x3e4,
    0x7d8, 0x7ea, 0x0ba, 0x7e8, 0x3a0, 0x1bd, 0x1b4, 0x38a,
    0x1c4, 0x392, 0x3aa, 0x3b0, 0x3bc, 0x3d7, 0x7d4, 0x7dc,
    0x7db, 0x7d5, 0x7f0, 0x0c1, 0x7fb, 0x3c8, 0x3a3, 0x395,
    0x39d, 0x3ac, 0x3ae, 0x3c5, 0x3d8, 0x3e2, 0x3e6, 0x7e4,
    0x7e7, 0x7e0, 0x7e9, 0x7f7, 0x190, 0x7f2, 0x393, 0x1be,
    0x1c0, 0x394, 0x397, 0x3ad, 0x3c3, 0x3c1, 0x3d2, 0x7da,
    0x7d9, 0x7df, 0x7eb, 0x7f4, 0x7fa, 0x195, 0x7f8, 0x3bd,
    0x39c, 0x3ab, 0x3a8, 0x3b3, 0x3b9, 0x3d0, 0x3e3, 0x3e5,
    0x7e2, 0x7de, 0x7ed, 0x7f1, 0x7f9, 0x7fc, 0x193, 0xffd,
    0x3dc, 0x3b6, 0x3c7, 0x3cc, 0x3cb, 0x3d9, 0x3da, 0x7d3,
    0x7e1, 0x7ee, 0x7ef, 0x7f5, 0x7f6, 0xffc, 0xfff, 0x19d,
    0x1c2, 0x0b5, 0x0a1, 0x096, 0x097, 0x095, 0x099, 0x0a0,
    0x0a2, 0x0ac, 0x0a9, 0x0b1, 0x0b3, 0x0bb, 0x0c0, 0x18f,
    0x004,

################################################################################

TITLE
    libavcodec aac codebook_vector10

TYPE
    FLOAT

DATA
  0.0000000,  0.0000000,  0.0000000,  1.0000000,
  0.0000000,  2.5198421,  0.0000000,  4.3267487,
  0.0000000,  6.3496042,  0.0000000,  8.5498797,
  0.0000000, 10.9027236,  0.0000000, 13.3905183,
  0.0000000, 16.0000000,  0.0000000, 18.7207544,
  0.0000000, 21.5443469,  0.0000000, 24.4637810,
  0.0000000, 27.4731418,  0.0000000, 30.5673509,
  0.0000000, 33.7419917,  0.0000000, 36.9931811,
  0.0000000,      64.0f,  1.0000000,  0.0000000,
  1.0000000,  1.0000000,  1.0000000,  2.5198421,
  1.0000000,  4.3267487,  1.0000000,  6.3496042,
  1.0000000,  8.5498797,  1.0000000, 10.9027236,
  1.0000000, 13.3905183,  1.0000000, 16.0000000,
  1.0000000, 18.7207544,  1.0000000, 21.5443469,
  1.0000000, 24.4637810,  1.0000000, 27.4731418,
  1.0000000, 30.5673509,  1.0000000, 33.7419917,
  1.0000000, 36.9931811,  1.0000000,      64.0f,
  2.5198421,  0.0000000,  2.5198421,  1.0000000,
  2.5198421,  2.5198421,  2.5198421,  4.3267487,
  2.5198421,  6.3496042,  2.5198421,  8.5498797,
  2.5198421, 10.9027236,  2.5198421, 13.3905183,
  2.5198421, 16.0000000,  2.5198421, 18.7207544,
  2.5198421, 21.5443469,  2.5198421, 24.4637810,
  2.5198421, 27.4731418,  2.5198421, 30.5673509,
  2.5198421, 33.7419917,  2.5198421, 36.9931811,
  2.5198421,      64.0f,  4.3267487,  0.0000000,
  4.3267487,  1.0000000,  4.3267487,  2.5198421,
  4.3267487,  4.3267487,  4.3267487,  6.3496042,
  4.3267487,  8.5498797,  4.3267487, 10.9027236,
  4.3267487, 13.3905183,  4.3267487, 16.0000000,
  4.3267487, 18.7207544,  4.3267487, 21.5443469,
  4.3267487, 24.4637810,  4.3267487, 27.4731418,
  4.3267487, 30.5673509,  4.3267487, 33.7419917,
  4.3267487, 36.9931811,  4.3267487,      64.0f,
  6.3496042,  0.0000000,  6.3496042,  1.0000000,
  6.3496042,  2.5198421,  6.3496042,  4.3267487,
  6.3496042,  6.3496042,  6.3496042,  8.5498797,
  6.3496042, 10.9027236,  6.3496042, 13.3905183,
  6.3496042, 16.0000000,  6.3496042, 18.7207544,
  6.3496042, 21.5443469,  6.3496042, 24.4637810,
  6.3496042, 27.4731418,  6.3496042, 30.5673509,
  6.3496042, 33.7419917,  6.3496042, 36.9931811,
  6.3496042,      64.0f,  8.5498797,  0.0000000,
  8.5498797,  1.0000000,  8.5498797,  2.5198421,
  8.5498797,  4.3267487,  8.5498797,  6.3496042,
  8.5498797,  8.5498797,  8.5498797, 10.9027236,
  8.5498797, 13.3905183,  8.5498797, 16.0000000,
  8.5498797, 18.7207544,  8.5498797, 21.5443469,
  8.5498797, 24.4637810,  8.5498797, 27.4731418,
  8.5498797, 30.5673509,  8.5498797, 33.7419917,
  8.5498797, 36.9931811,  8.5498797,      64.0f,
 10.9027236,  0.0000000, 10.9027236,  1.0000000,
 10.9027236,  2.5198421, 10.9027236,  4.3267487,
 10.9027236,  6.3496042, 10.9027236,  8.5498797,
 10.9027236, 10.9027236, 10.9027236, 13.3905183,
 10.9027236, 16.0000000, 10.9027236, 18.7207544,
 10.9027236, 21.5443469, 10.9027236, 24.4637810,
 10.9027236, 27.4731418, 10.9027236, 30.5673509,
 10.9027236, 33.7419917, 10.9027236, 36.9931811,
 10.9027236,      64.0f, 13.3905183,  0.0000000,
 13.3905183,  1.0000000, 13.3905183,  2.5198421,
 13.3905183,  4.3267487, 13.3905183,  6.3496042,
 13.3905183,  8.5498797, 13.3905183, 10.9027236,
 13.3905183, 13.3905183, 13.3905183, 16.0000000,
 13.3905183, 18.7207544, 13.3905183, 21.5443469,
 13.3905183, 24.4637810, 13.3905183, 27.4731418,
 13.3905183, 30.5673509, 13.3905183, 33.7419917,
 13.3905183, 36.9931811, 13.3905183,      64.0f,
 16.0000000,  0.0000000, 16.0000000,  1.0000000,
 16.0000000,  2.5198421, 16.0000000,  4.3267487,
 16.0000000,  6.3496042, 16.0000000,  8.5498797,
 16.0000000, 10.9027236, 16.0000000, 13.3905183,
 16.0000000, 16.0000000, 16.0000000, 18.7207544,
 16.0000000, 21.5443469, 16.0000000, 24.4637810,
 16.0000000, 27.4731418, 16.0000000, 30.5673509,
 16.0000000, 33.7419917, 16.0000000, 36.9931811,
 16.0000000,      64.0f, 18.7207544,  0.0000000,
 18.7207544,  1.0000000, 18.7207544,  2.5198421,
 18.7207544,  4.3267487, 18.7207544,  6.3496042,
 18.7207544,  8.5498797, 18.7207544, 10.9027236,
 18.7207544, 13.3905183, 18.7207544, 16.0000000,
 18.7207544, 18.7207544, 18.7207544, 21.5443469,
 18.7207544, 24.4637810, 18.7207544, 27.4731418,
 18.7207544, 30.5673509, 18.7207544, 33.7419917,
 18.7207544, 36.9931811, 18.7207544,      64.0f,
 21.5443469,  0.0000000, 21.5443469,  1.0000000,
 21.5443469,  2.5198421, 21.5443469,  4.3267487,
 21.5443469,  6.3496042, 21.5443469,  8.5498797,
 21.5443469, 10.9027236, 21.5443469, 13.3905183,
 21.5443469, 16.0000000, 21.5443469, 18.7207544,
 21.5443469, 21.5443469, 21.5443469, 24.4637810,
 21.5443469, 27.4731418, 21.5443469, 30.5673509,
 21.5443469, 33.7419917, 21.5443469, 36.9931811,
 21.5443469,      64.0f, 24.4637810,  0.0000000,
 24.4637810,  1.0000000, 24.4637810,  2.5198421,
 24.4637810,  4.3267487, 24.4637810,  6.3496042,
 24.4637810,  8.5498797, 24.4637810, 10.9027236,
 24.4637810, 13.3905183, 24.4637810, 16.0000000,
 24.4637810, 18.7207544, 24.4637810, 21.5443469,
 24.4637810, 24.4637810, 24.4637810, 27.4731418,
 24.4637810, 30.5673509, 24.4637810, 33.7419917,
 24.4637810, 36.9931811, 24.4637810,      64.0f,
 27.4731418,  0.0000000, 27.4731418,  1.0000000,
 27.4731418,  2.5198421, 27.4731418,  4.3267487,
 27.4731418,  6.3496042, 27.4731418,  8.5498797,
 27.4731418, 10.9027236, 27.4731418, 13.3905183,
 27.4731418, 16.0000000, 27.4731418, 18.7207544,
 27.4731418, 21.5443469, 27.4731418, 24.4637810,
 27.4731418, 27.4731418, 27.4731418, 30.5673509,
 27.4731418, 33.7419917, 27.4731418, 36.9931811,
 27.4731418,      64.0f, 30.5673509,  0.0000000,
 30.5673509,  1.0000000, 30.5673509,  2.5198421,
 30.5673509,  4.3267487, 30.5673509,  6.3496042,
 30.5673509,  8.5498797, 30.5673509, 10.9027236,
 30.5673509, 13.3905183, 30.5673509, 16.0000000,
 30.5673509, 18.7207544, 30.5673509, 21.5443469,
 30.5673509, 24.4637810, 30.5673509, 27.4731418,
 30.5673509, 30.5673509, 30.5673509, 33.7419917,
 30.5673509, 36.9931811, 30.5673509,      64.0f,
 33.7419917,  0.0000000, 33.7419917,  1.0000000,
 33.7419917,  2.5198421, 33.7419917,  4.3267487,
 33.7419917,  6.3496042, 33.7419917,  8.5498797,
 33.7419917, 10.9027236, 33.7419917, 13.3905183,
 33.7419917, 16.0000000, 33.7419917, 18.7207544,
 33.7419917, 21.5443469, 33.7419917, 24.4637810,
 33.7419917, 27.4731418, 33.7419917, 30.5673509,
 33.7419917, 33.7419917, 33.7419917, 36.9931811,
 33.7419917,      64.0f, 36.9931811,  0.0000000,
 36.9931811,  1.0000000, 36.9931811,  2.5198421,
 36.9931811,  4.3267487, 36.9931811,  6.3496042,
 36.9931811,  8.5498797, 36.9931811, 10.9027236,
 36.9931811, 13.3905183, 36.9931811, 16.0000000,
 36.9931811, 18.7207544, 36.9931811, 21.5443469,
 36.9931811, 24.4637810, 36.9931811, 27.4731418,
 36.9931811, 30.5673509, 36.9931811, 33.7419917,
 36.9931811, 36.9931811, 36.9931811,      64.0f,
      64.0f,  0.0000000,      64.0f,  1.0000000,
      64.0f,  2.5198421,      64.0f,  4.3267487,
      64.0f,  6.3496042,      64.0f,  8.5498797,
      64.0f, 10.9027236,      64.0f, 13.3905183,
      64.0f, 16.0000000,      64.0f, 18.7207544,
      64.0f, 21.5443469,      64.0f, 24.4637810,
      64.0f, 27.4731418,      64.0f, 30.5673509,
      64.0f, 33.7419917,      64.0f, 36.9931811,
      64.0f,      64.0f,

################################################################################

TITLE
    libavcodec AAN ff_inv_aanscales

TYPE
    16

DATA
  4096,  2953,  3135,  3483,  4096,  5213,  7568, 14846,
  2953,  2129,  2260,  2511,  2953,  3759,  5457, 10703,
  3135,  2260,  2399,  2666,  3135,  3990,  5793, 11363,
  3483,  2511,  2666,  2962,  3483,  4433,  6436, 12625,
  4096,  2953,  3135,  3483,  4096,  5213,  7568, 14846,
  5213,  3759,  3990,  4433,  5213,  6635,  9633, 18895,
  7568,  5457,  5793,  6436,  7568,  9633, 13985, 27432,
 14846, 10703, 11363, 12625, 14846, 18895, 27432, 53809,

################################################################################

TITLE
    libavcodec AC3 quantization_tab

TYPE
    8

DATA
    0, 3, 5, 7, 11, 15,
    5, 6, 7, 8, 9, 10, 11, 12, 14, 16

################################################################################

TITLE
    libavcodec AC3 ac3_default_coeffs

TYPE
    8

DATA
    { { 2, 7 }, { 7, 2 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, },
    { { 4, 4 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, },
    { { 2, 7 }, { 7, 2 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, },
    { { 2, 7 }, { 5, 5 }, { 7, 2 }, { 0, 0 }, { 0, 0 }, },
    { { 2, 7 }, { 7, 2 }, { 6, 6 }, { 0, 0 }, { 0, 0 }, },
    { { 2, 7 }, { 5, 5 }, { 7, 2 }, { 8, 8 }, { 0, 0 }, },
    { { 2, 7 }, { 7, 2 }, { 6, 7 }, { 7, 6 }, { 0, 0 }, },
    { { 2, 7 }, { 5, 5 }, { 7, 2 }, { 6, 7 }, { 7, 6 }, },

################################################################################

TITLE
    libavcodec AC3 ff_ac3_ungroup_3_in_5_bits_tab

TYPE
    8

DATA
    { 0, 0, 0 }, { 0, 0, 1 }, { 0, 0, 2 }, { 0, 1, 0 },
    { 0, 1, 1 }, { 0, 1, 2 }, { 0, 2, 0 }, { 0, 2, 1 },
    { 0, 2, 2 }, { 1, 0, 0 }, { 1, 0, 1 }, { 1, 0, 2 },
    { 1, 1, 0 }, { 1, 1, 1 }, { 1, 1, 2 }, { 1, 2, 0 },
    { 1, 2, 1 }, { 1, 2, 2 }, { 2, 0, 0 }, { 2, 0, 1 },
    { 2, 0, 2 }, { 2, 1, 0 }, { 2, 1, 1 }, { 2, 1, 2 },
    { 2, 2, 0 }, { 2, 2, 1 }, { 2, 2, 2 }, { 3, 0, 0 },
    { 3, 0, 1 }, { 3, 0, 2 }, { 3, 1, 0 }, { 3, 1, 1 }

################################################################################

TITLE
    libavcodec AC3 ff_eac3_hebap_tab

TYPE
    8

DATA
    0, 1, 2, 3, 4, 5, 6, 7, 8, 8,
    8, 8, 9, 9, 9, 10, 10, 10, 10, 11,
    11, 11, 11, 12, 12, 12, 12, 13, 13, 13,
    13, 14, 14, 14, 14, 15, 15, 15, 15, 16,
    16, 16, 16, 17, 17, 17, 17, 18, 18, 18,
    18, 18, 18, 18, 18, 19, 19, 19, 19, 19,
    19, 19, 19, 19,

################################################################################

TITLE
    libavcodec AC3 ff_eac3_bits_vs_hebap

TYPE
    8

DATA
    0,  2,  3,  4,  5,  7,  8,  9,  3,  4,
    5,  6,  7,  8,  9, 10, 11, 12, 14, 16,

################################################################################

TITLE
    libavcodec AC3 ff_eac3_gaq_remap_1

TYPE
    16

DATA
    4681, 2185, 1057, 520, 258, 129, 64, 32, 16, 8, 2, 0

################################################################################

TITLE
    libavcodec AC3 ff_eac3_gaq_remap_2_4_a

TYPE
    16

DATA
    { -10923, -4681 },
    { -14043, -6554 },
    { -15292, -7399 },
    { -15855, -7802 },
    { -16124, -7998 },
    { -16255, -8096 },
    { -16320, -8144 },
    { -16352, -8168 },
    { -16368, -8180 }

################################################################################

TITLE
    libavcodec AC3 ff_eac3_gaq_remap_2_4_b

TYPE
    8

DATA
    { -22,  -5 },
    { -46, -20 },
    { -56, -26 },
    { -60, -29 },
    { -62, -31 },
    { -63, -32 },
    { -64, -32 },
    { -64, -32 },
    { -64, -32 },

################################################################################

TITLE
    libavcodec AC3 vq_hebap1

TYPE
    16

DATA
{   7167,    4739,    1106,    4269,   10412,    4820},
{  -5702,   -3187,  -14483,   -1392,   -2027,     849},
{    633,    6199,    7009,  -12779,   -2306,   -2636},
{  -1468,   -7031,    7592,   10617,   -5946,   -3062},

################################################################################

TITLE
    libavcodec AC3 vq_hebap2

TYPE
    16

DATA
{ -12073,     608,   -7019,     590,    4000,     869},
{   6692,   15689,   -6178,   -9239,     -74,     133},
{   1855,    -989,   20596,   -2920,   -4475,     225},
{  -1194,   -3901,    -821,   -6566,    -875,  -20298},
{  -2762,   -3181,   -4094,   -5623,  -16945,    9765},
{   1547,    6839,    1980,   20233,   -1071,   -4986},
{   6221,  -17915,   -5516,    6266,     358,    1162},
{   3753,   -1066,    4283,   -3227,   15928,   10186},

################################################################################

TITLE
    libavcodec AC3 vq_hebap3

TYPE
    16

DATA
{ -10028,   20779,   10982,   -4560,     798,     -68},
{  11050,   20490,   -6617,   -5342,   -1797,   -1631},
{   3977,    -542,    7118,   -1166,   18844,   14678},
{  -4320,     -96,   -7295,    -492,  -22050,   -4277},
{   2692,    5856,    5530,   21862,   -7212,   -5325},
{   -135,  -23391,     962,    8115,    -644,     382},
{  -1563,    3400,   -3299,    4693,   -6892,   22398},
{   3535,    3030,    7296,    6214,   20476,  -12099},
{     57,   -6823,    1848,  -22349,   -5919,    6823},
{   -821,   -3655,    -387,   -6253,   -1735,  -22373},
{  -6046,    1586,  -18890,  -14392,    9214,     705},
{  -5716,     264,  -17964,   14618,    7921,    -337},
{   -110,     108,       8,      74,     -89,     -50},
{   6612,   -1517,   21687,   -1658,   -7949,    -246},
{  21667,   -6335,   -8290,    -101,   -1349,     -22},
{ -22003,   -6476,    7974,     648,    2054,    -331},

################################################################################

TITLE
    libavcodec AC3 vq_hebap4

TYPE
    16

DATA
{   6636,   -4593,   14173,  -17297,  -16523,     864},
{   3658,   22540,     104,   -1763,     -84,       6},
{  21580,  -17815,   -7282,   -1575,   -2078,    -320},
{  -2233,   10017,   -2728,   14938,  -13640,  -17659},
{  -1564,  -17738,  -19161,   13735,    2757,    2951},
{   4520,    5510,    7393,   10799,   19231,  -13770},
{    399,    2976,   -1099,    5013,   -1159,   22095},
{   3624,   -2359,    4680,   -2238,   22702,    3765},
{  -4201,   -8285,   -6810,  -12390,  -18414,   15382},
{  -5198,   -6869,  -10047,   -8364,  -16022,  -20562},
{   -142,  -22671,    -368,    4391,    -464,     -13},
{    814,   -1118,   -1089,  -22019,      74,    1553},
{  -1618,   19222,  -17642,  -13490,     842,   -2309},
{   4689,   16490,   20813,  -15387,   -4164,   -3968},
{  -3308,   11214,  -13542,   13599,  -19473,   13770},
{   1817,     854,   21225,    -966,   -1643,    -268},
{  -2587,    -107,  -20154,     376,    1174,    -304},
{  -2919,     453,   -5390,     750,  -22034,    -978},
{ -19012,   16839,   10000,   -3580,    2211,    1459},
{   1363,   -2658,     -33,   -4067,    1165,  -21985},
{  -8592,   -2760,  -17520,  -15985,   14897,    1323},
{    652,   -9331,    3253,  -14622,   12181,   19692},
{  -6361,    5773,  -15395,   17291,   16590,   -2922},
{   -661,    -601,    1609,   22610,     992,   -1045},
{   4961,    9107,   11225,    7829,   16320,   18627},
{ -21872,   -1433,     138,    1470,   -1891,    -196},
{ -19499,  -18203,   11056,    -516,    2543,   -2249},
{  -1196,  -17574,   20150,   11462,    -401,    2619},
{   4638,   -8154,   11891,  -15759,   17615,  -14955},
{    -83,     278,     323,      55,    -154,     232},
{   7788,    1462,   18395,   15296,  -15763,   -1131},

################################################################################

TITLE
    libavcodec AC3 vq_hebap5

TYPE
    16

DATA
{  -3394,  -19730,    2963,    9590,    4660,   19673},
{ -15665,   -6405,   17671,    3860,   -8232,  -19429},
{   4467,     412,  -17873,   -8037,     691,  -17307},
{   3580,    2363,    6886,    3763,    6379,  -20522},
{ -17230,  -14133,   -1396,  -23939,    8373,  -12537},
{  -8073,  -21469,  -15638,    3214,    8105,   -5965},
{   4343,    5169,    2683,  -16822,   -5146,  -16558},
{   6348,  -10668,   12995,  -25500,  -22090,    4091},
{  -2880,   -8366,   -5968,  -17158,   -2638,   23132},
{  -5095,  -14281,  -22371,   21741,    3689,    2961},
{  -2443,  -17739,   25155,    2707,    1594,       7},
{ -18379,    9010,    4270,     731,    -426,    -640},
{ -23695,   24732,    5642,     612,    -308,    -964},
{   -767,    1268,     225,    1635,     173,     916},
{   5455,    6493,    4902,   10560,   23041,  -17140},
{  17219,  -21054,  -18716,    4936,   -3420,    3357},
{  -1390,   15488,  -21946,  -14611,    1339,     542},
{  -6866,   -2254,  -12070,   -3075,  -19981,  -20622},
{  -1803,   11775,    1343,    8917,     693,   24497},
{ -21610,    9462,    4681,    9254,   -7815,   15904},
{  -5559,   -3018,   -9169,   -1347,  -22547,   12868},
{   -366,    5076,   -1727,   20427,    -283,   -2923},
{  -1886,   -6313,    -939,   -2081,   -1399,    3513},
{  -3161,    -537,   -5075,   11268,   19396,     989},
{   2345,    4153,    5769,   -4273,     233,    -399},
{ -21894,   -1138,  -16474,    5902,    5488,   -3211},
{  10007,  -12530,   18829,   20932,   -1158,    1790},
{  -1165,    5014,   -1199,    6415,   -8418,  -21038},
{   1892,   -3534,    3815,   -5846,   16427,   20288},
{  -2664,  -11627,   -4147,  -18311,  -22710,   14848},
{  17256,   10419,    7764,   12040,   18956,    2525},
{ -21419,  -18685,  -10897,    4368,   -7051,    4539},
{  -1574,    2050,    5760,   24756,   15983,   17678},
{   -538,  -22867,   11067,   10301,     385,     528},
{  -8465,   -3025,  -16357,  -23237,   16491,    3654},
{   5840,     575,   11890,    1947,   25157,    6653},
{   6625,   -3516,   -1964,    3850,    -390,    -116},
{  18005,   20900,   14323,   -7621,  -10922,   11802},
{  -4857,   -2932,  -13334,   -7815,   21622,    2267},
{   -579,   -9431,    -748,  -21321,   12367,    8265},
{  -8317,    1375,  -17847,    2921,    9062,   22046},
{  18398,    8635,   -1503,   -2418,  -18295,  -14734},
{  -2987,   15129,   -3331,   22300,   13878,  -13639},
{   5874,  -19026,   15587,   11350,  -20738,    1971},
{   1581,   -6955,  -21440,    2455,      65,     414},
{    515,   -4468,    -665,   -4672,     125,  -19222},
{  21495,  -20301,   -1872,   -1926,    -211,   -1022},
{   5189,  -12250,   -1775,  -23550,   -4546,    5813},
{    321,   -6331,   14646,    6975,   -1773,     867},
{ -13814,    3180,    7927,     444,   19552,    3146},
{  -6660,   12252,   -1972,   17408,  -24280,  -12956},
{   -745,   14356,   -1107,   23742,   -9631,  -18344},
{  18284,   -7909,   -7531,   19118,    7721,  -12659},
{   1926,   15101,  -12848,    2153,   21631,    1864},
{  -2130,   23416,   17056,  -15597,   -1544,      87},
{   8314,  -11824,   14581,  -20591,    7891,   -2099},
{  19600,   22814,  -17304,   -2040,     285,   -3863},
{  -8214,  -18322,   10724,  -13744,  -13469,   -1666},
{  14351,    4880,  -20034,     964,   -4221,    -180},
{ -24598,  -16635,   19724,    5925,    4777,    4414},
{  -2495,   23493,  -16141,    2918,   -1038,   -2010},
{  18974,   -2540,   13343,    1405,   -6194,   -1136},
{   2489,   13670,   22638,   -7311,    -129,   -2792},
{ -13962,   16775,   23012,     728,    3397,     162},
{   3038,     993,    8774,  -21969,   -6609,     910},
{ -12444,  -22386,   -2626,   -5295,   19520,    9872},
{  -1911,  -18274,  -18506,  -14962,    4760,    7119},
{   8298,   -2978,   25886,    7660,   -7897,    1020},
{   6132,   15127,   18757,  -24370,   -6529,   -6627},
{   7924,   12125,   -9459,  -23962,    5502,     937},
{ -17056,   -5373,    2522,     327,    1129,    -390},
{  15774,   19955,  -10380,   11172,   -3107,   14853},
{ -11904,   -8091,  -17928,  -22287,  -17237,   -6803},
{ -12862,   -2172,   -6509,    5927,   12458,  -22355},
{   -497,     322,    1038,   -6643,   -5404,   20311},
{   1083,  -22984,   -8494,   12130,    -762,    2623},
{   5067,   19712,   -1901,     -30,    -325,      85},
{    987,   -5830,    4212,   -9030,    9121,  -25038},
{  -7868,    7284,  -12292,   12914,  -21592,   20941},
{  -1630,   -7694,   -2187,   -8525,   -5604,  -25196},
{  -6668,     388,  -22535,    1526,    9082,     193},
{  -7867,  -22308,    5163,     362,     944,    -259},
{   3824,  -11850,    7591,  -23176,   25342,   23771},
{ -10504,    4123,  -21111,   21173,   22439,    -838},
{  -4723,   21795,    6184,    -122,    1642,    -717},
{  24504,   19887,   -2043,     986,       7,     -55},
{ -27313,    -135,    2437,     259,      89,     307},
{  24446,   -3873,   -5391,    -820,   -2387,     361},
{   5529,    5784,   18682,     242,  -21896,   -4003},
{  22304,    4483,     722,  -12242,    7570,   15448},
{   8673,    3009,   20437,   21108,  -21100,   -3080},
{  -1132,    2705,   -1825,    5420,    -785,   18532},
{  16932,  -13517,  -16509,  -14858,  -20327,  -14221},
{   2219,    1380,   21474,   -1128,     327,      83},
{  -2177,   21517,   -3856,  -14180,    -204,   -2191},
{    953,   -9426,   15874,  -10710,   -3231,   21030},
{   -421,   -1377,     640,   -8239,  -20976,    2174},
{   4309,   18514,   -9100,  -18319,  -15518,    3704},
{  -5943,     449,   -8387,    1075,  -22210,   -4992},
{   2953,   12788,   18285,    1430,   14937,   21731},
{  -2913,     401,   -4739,  -20105,    1699,   -1147},
{   3449,    5241,    8853,   22134,   -7547,    1451},
{  -2154,    8584,   18120,  -15614,   19319,   -5991},
{   3501,    2841,    5897,    6397,    8630,   23018},
{   2467,    2956,     379,    5703,  -22047,   -2189},
{ -16963,    -594,   18822,   -5295,    1640,     774},
{   2896,   -1424,    3586,   -2292,   19910,   -1822},
{ -18575,   21219,  -14001,  -12573,   16466,     635},
{  -1998,  -19314,  -16527,   12208,  -16576,   -7854},
{  -9674,    1012,  -21645,    2883,  -12712,    2321},
{  -1005,     471,   -3629,    8045,  -11087,   25533},
{   4141,  -21472,   -2673,     756,    -663,    -523},
{   6490,    8531,   19289,   18949,    6092,   -9347},
{  16965,   24599,   14024,   10072,    -536,  -10438},
{  -8147,    2145,  -23028,  -17073,    5451,   -4401},
{ -14873,   20520,  -18303,   -9717,  -11885,  -17831},
{  -2290,  -14120,    2070,   22467,    1671,     725},
{  -8538,   14629,    3521,  -20577,    6673,    8200},
{  20248,    4410,   -1366,    -585,    1229,   -2449},
{   7467,   -7148,   13667,   -8246,   22392,  -17320},
{  -1932,    3875,   -9064,   -3812,     958,     265},
{  -4399,    2959,  -15911,   19598,    4954,   -1105},
{  18009,   -9923,  -18137,   -3862,   11178,    5821},
{ -14596,   -1227,    9660,   21619,   11228,  -11721},
{   -721,   -1700,     109,   -2142,      61,   -6772},
{ -24619,  -22520,    5608,   -1957,   -1761,   -1012},
{ -23728,   -4451,   -2688,  -14679,   -4266,    9919},
{   8495,    -894,   20438,  -13820,  -17267,     139},

################################################################################

TITLE
    libavcodec AC3 vq_hebap6

TYPE
    16

DATA
{  10154,    7365,   16861,   18681,  -22893,   -3636},
{  -2619,   -3788,   -5529,   -5192,   -9009,  -20298},
{  -5583,  -22800,   21297,    7012,     745,     720},
{    428,   -1459,     109,   -3082,     361,   -8403},
{   8161,   22401,     241,    1755,    -874,   -2824},
{   1140,   12643,    2306,   22263,  -25146,  -17557},
{  -2609,    3379,   10337,  -19730,  -15468,  -23944},
{  -4040,  -12796,  -25772,   13096,    3905,    1315},
{   4624,  -23799,   13608,   25317,   -1175,    2173},
{    -97,   13747,   -5122,   23255,    4214,  -22145},
{   6878,    -322,   18264,    -854,  -11916,    -733},
{  17280,  -12669,   -9693,   23563,  -16240,   -1309},
{   5802,   -4968,   19526,  -21194,  -24622,    -183},
{   5851,  -16137,   15229,   -9496,   -1538,     377},
{  14096,   25057,   13419,    8290,   23320,   16818},
{  -7261,     118,  -15867,   19097,    9781,    -277},
{  -4288,   21589,  -13288,  -16259,   16633,   -4862},
{   4909,  -19217,   23411,   14705,    -722,     125},
{  19462,   -4732,   -1928,  -11527,   20770,    5425},
{ -27562,   -2881,   -4331,     384,   -2103,    1367},
{   -266,   -9175,    5441,   26333,   -1924,    4221},
{  -2970,  -20170,  -21816,    5450,   -7426,    5344},
{   -221,   -6696,     603,   -9140,    1308,  -27506},
{   9621,   -8380,   -1967,    9403,   -1651,   22817},
{   7566,   -5250,   -4165,    1385,    -990,     560},
{  -1262,   24738,  -19057,   10741,    7585,   -7098},
{    451,   20130,   -9949,   -6015,   -2188,   -1458},
{  22249,    9380,    9096,   10959,   -2365,   -3724},
{  18668,    -650,   -1234,   11092,    7678,    5969},
{  19207,   -1485,   -1076,    -731,    -684,      43},
{  -4973,   13430,   20139,      60,     476,    -935},
{ -20029,    8710,    2499,    1016,   -1158,     335},
{ -26413,   18598,   -2201,    -669,    3409,     793},
{  -4726,    8875,  -24607,   -9646,    3643,    -283},
{  13303,  -21404,   -3691,   -1184,   -1970,    1612},
{    173,      60,     919,    1229,    6942,    -665},
{  16377,   16991,    5341,  -14015,   -2304,  -20390},
{  25334,  -10609,   11947,   -7653,   -6363,   14058},
{  23929,  -13259,   -7226,    -937,     234,    -187},
{   6311,   -1877,   12506,   -1879,   18751,  -23341},
{    621,    6445,    3354,  -24274,    8406,    5315},
{  -3297,   -5034,   -4704,   -5080,  -25730,    5347},
{  -1275,  -13295,    -965,  -23318,    1214,   26259},
{  -6252,   10035,  -20105,   15301,  -16073,    5136},
{   9562,   -3911,  -19510,    4745,   22270,   -4171},
{   7978,  -19600,   14024,   -5745,  -20855,    8939},
{      7,   -4039,     991,   -6065,      52,  -19423},
{   3485,    2969,    7732,    7786,   25312,    6206},
{   -959,  -12812,   -1840,  -22743,    7324,   10830},
{  -4686,    1678,  -10172,   -5205,    4294,   -1271},
{   3889,    1302,    7450,     638,   20374,   -3133},
{ -12496,   -9123,   18463,  -12343,   -7238,   18552},
{  -6185,    8649,   -6903,    -895,   17109,   16604},
{  -9896,   28579,    2845,    1640,    2925,    -298},
{  14968,  -25988,   14878,  -24012,    1815,   -6474},
{  26107,    5166,   21225,   15873,   21617,   14825},
{ -21684,   16438,   20504,  -14346,   -7114,   -4162},
{  28647,      90,   -1572,     789,    -902,     -75},
{  -1479,    2471,   -4061,    3612,   -2240,   10914},
{   8616,   17491,   17255,  -17456,   17022,  -16357},
{ -20722,  -18597,   25274,   17720,   -3573,    1695},
{   -997,    6129,   -6303,   11250,  -11359,  -19739},
{    -74,   -4001,   -1584,   13384,     162,    -144},
{   -529,   21068,    7923,  -11396,     422,     -26},
{   7102,  -13531,  -20055,    2629,    -178,    -429},
{   9201,    1368,  -22238,    2623,  -20499,   24889},
{   -432,    6675,    -266,    8723,      80,   28024},
{  19493,   -3108,   -9261,    1910,  -21777,    5345},
{  14079,  -11489,   12604,    6079,   19877,    1315},
{  10947,    9837,  -18612,   15742,    4792,     605},
{  -1777,    3758,   -4087,   21696,    6024,    -576},
{   3567,   -3578,   16379,    2680,   -1752,     716},
{  -5049,   -1399,   -4550,    -652,  -17721,   -3366},
{  -3635,   -4372,   -6522,  -22152,    7382,    1458},
{  12242,   19190,    5646,   -7815,  -20289,   21344},
{  -7508,   19952,   23542,   -9753,    5669,   -1990},
{  -2275,   15438,   10907,  -17879,    6497,   13582},
{ -15894,  -15646,   -4716,    6019,   24250,   -6179},
{  -2049,   -6856,   -1208,     918,   17735,     -69},
{  -3721,    9099,  -16065,  -23621,    5981,   -2344},
{   7862,   -8918,   24033,   25508,  -11033,    -741},
{ -12588,   19468,   14649,   15451,  -21226,    1171},
{   2102,    1147,    2789,    4096,    2179,    8750},
{ -18214,  -17758,  -10366,   -5203,   -1066,   -3541},
{  -2819,  -19958,  -11921,    6032,    8315,   10374},
{  -9078,   -2100,   19431,     -17,     732,    -689},
{ -14512,  -19224,   -7095,   18727,    1870,   22906},
{   3912,     659,   25597,   -4006,    9619,     877},
{   2616,   22695,   -5770,   17920,    3812,   20220},
{   2561,   26847,   -5245,  -10908,    2256,    -517},
{  -4974,     198,  -21983,   -3608,   22174,  -18924},
{  21308,   -1211,   19144,   16691,   -1588,   11390},
{  -1790,    3959,   -3488,    7003,   -7107,   20877},
{  -6108,  -17955,  -18722,   24763,   16508,    3211},
{  20462,  -24987,  -20361,    4484,   -5111,    -478},
{  -6378,   -1998,  -10229,    -561,  -22039,  -22339},
{   3047,  -18850,    7586,   14743,  -19862,    6351},
{  -5047,    1405,   -9672,    1055,  -21881,   11170},
{   3481,   -9699,    6526,  -16655,   22813,   21907},
{ -18570,   17501,   14664,    1291,    5026,   19676},
{  16134,  -19810,  -16956,  -17939,  -16933,    5800},
{  -8224,    4908,    8935,    2272,   -1140,  -23217},
{   1572,    2753,   -1598,    2143,   -3346,  -21926},
{  -9832,   -1060,  -27818,    1214,    7289,     150},
{     98,    1538,     535,   17429,  -23198,    -901},
{  21340,  -20146,    3297,   -1744,   -8207,  -21462},
{  -4166,   -4633,  -17902,    5478,    1285,     136},
{  18713,   21003,   24818,   11421,    1282,   -4618},
{  -3535,    7636,    -265,    2141,    -829,   -2035},
{  -3184,   19713,    2775,      -2,    1090,     104},
{  -6771,  -20185,    2938,   -2125,     -36,    1268},
{   9560,    9430,    9586,   22100,   13827,    6296},
{   -535,  -20018,    4276,   -1868,    -448,  -17183},
{ -24352,   14244,  -13647,  -21040,    2271,   11555},
{  -2646,   15437,   -4589,   18638,   -4299,    -622},
{ -20064,    4169,   18115,   -1404,   13722,   -1825},
{ -16359,    9080,     744,   22021,     125,   10794},
{   9644,  -14607,  -18479,  -14714,   11174,  -20754},
{   -326,  -23762,    6144,    7909,     602,    1540},
{  -6650,    6634,  -12683,   21396,   20785,   -6839},
{   4252,  -21043,    5628,   18687,   23860,    8328},
{  17986,    5704,   -5245,  -18093,    -555,    3219},
{   6091,   14232,   -5117,  -17456,  -19452,  -11649},
{ -21586,   11302,   15434,   25590,    6777,  -26683},
{  21355,   -8244,    5877,   -3540,    6079,   -2567},
{   2603,   -2455,    5421,  -12286,  -19100,    5574},
{  -1721,  -26393,  -23664,   22904,    -349,    3787},
{   2189,   -1203,    5340,    3249,  -22617,     104},
{  -1664,  -11020,   -2857,  -20723,  -24049,   19900},
{  22873,   -7345,  -18481,  -14616,   -8400,  -12965},
{   3777,    3958,    8239,   20494,   -6991,   -1201},
{   -160,   -1613,    -793,   -8681,     573,     776},
{   4297,   -3786,   20373,    6082,   -5321,  -18400},
{  18745,    2463,   12546,   -7749,   -7734,   -2183},
{  11074,   -4720,   22119,    1825,  -24351,    4080},
{   1503,  -19178,   -1569,      13,    -313,     375},
{    318,    -575,    2544,     178,     102,      40},
{ -15996,  -26897,    5008,    3320,     686,    1159},
{  25755,   26886,     574,   -5930,   -3916,    1407},
{  -9148,   -7665,   -2875,   -8384,  -18663,   26400},
{  -7445,  -18040,  -18396,    8802,   -2252,  -21886},
{   7851,   11773,   27485,  -12847,   -1410,   19590},
{   2240,    5947,   11247,   15980,   -6499,   24280},
{  21673,  -18515,    9771,    6550,   -2730,     334},
{  -4149,    1576,  -11010,      89,  -24429,   -5710},
{   7720,    1478,   21412,  -25025,   -8385,       9},
{  -2448,   10218,  -12756,  -16079,    1161,  -21284},
{  -8757,  -14429,  -22918,  -14812,    2629,   13844},
{  -7252,    2843,   -9639,    2882,  -14625,   24497},
{   -674,   -6530,     414,  -23333,  -21343,     454},
{   2104,   -6312,   10887,   18087,   -1199,     175},
{   -493,    -562,   -2739,     118,   -1074,      93},
{ -10011,   -4075,  -28071,   22180,   15077,    -636},
{  -4637,  -16408,   -9003,  -20418,  -11608,  -20932},
{   4815,   15892,   24238,  -13634,   -3074,   -1059},
{  -6724,    4610,  -18772,  -15283,  -16685,   23988},
{  15349,    -674,   -3682,   21679,    4475,  -12088},
{   4756,    2593,    5354,    6001,   15063,   26490},
{ -23815,  -17251,    6944,     378,     694,     670},
{  23392,   -8839,  -14713,    7544,    -876,   11088},
{   3640,    3336,   22593,   -3495,   -2328,    -113},
{    284,    6914,    3097,   10171,    6638,  -18621},
{   2472,    5976,   11054,  -11936,    -603,    -663},
{  16175,   16441,   13164,   -4043,    4667,    7431},
{  19338,   15534,   -6533,    1681,   -4857,   17048},
{  17027,     532,  -19064,   -1441,   -5130,    1085},
{ -12617,  -17609,    2062,  -25332,   19009,  -16121},
{  10056,  -21000,  -13634,   -2949,   15367,   19934},
{   -648,   -1605,   10046,   -1592,   13296,   19808},
{  -1054,   10744,     538,   24938,    9630,   -9052},
{ -10099,    3042,  -25076,  -24052,   13971,     100},
{   6547,    6907,    7031,   10348,   23775,  -17886},
{ -22793,   -1984,   -1393,   -3330,    9267,   14317},
{ -14346,   -3967,    3042,   16254,  -17303,    9646},
{ -21393,   23628,   16773,     716,    2663,     114},
{ -19016,   -3038,    1574,    -245,    1463,    -793},
{  22410,   23441,  -14637,    -530,   17310,   13617},
{ -11582,    7935,  -13954,   23465,  -24628,   26550},
{  -1045,    3679,   -2218,   10572,   20999,   -3702},
{ -15513,     197,   16718,  -24603,    4945,       5},
{  10781,    4335,   26790,   -9059,  -16152,   -2840},
{  16075,  -24100,   -3933,   -6833,   12645,   -7029},
{   2096,  -25572,   -8370,    6814,      11,    1178},
{ -11848,    -583,   -8889,  -20543,  -10471,    -380},
{  -2487,   24777,  -21639,  -19341,    1660,    -732},
{   2313,   13679,    4085,   24549,   24691,  -21179},
{  -2366,    -504,   -4130,  -10570,   23668,    1961},
{  20379,   17809,   -9506,    3733,  -18954,   -6292},
{  -3856,   16802,    -929,  -20310,  -17739,    6797},
{  12431,    6078,  -11272,  -14450,    6913,   23476},
{   7636,   -1655,   23017,   10719,   -8292,     838},
{  -8559,   -1235,  -18096,    3897,   16093,    1490},
{  -3586,    8276,   15165,   -3791,  -21149,    1741},
{  -4497,   21739,    2366,    -278,   -4792,   15549},
{ -23122,  -13708,    7668,   16232,   24120,   15025},
{ -20043,   12821,  -20160,   16691,  -11655,  -16081},
{ -12601,   20239,    3496,   -2549,   -6745,  -11850},
{   4441,    7812,   20783,   17080,   11523,   -9643},
{  24766,    8494,  -23298,   -3262,   11101,   -7120},
{ -10107,   -7623,  -22152,  -18303,   26645,    9550},
{ -25549,     477,    7874,   -1538,    1123,    -168},
{    470,    9834,    -347,   23945,  -10381,   -9467},
{  -4096,   -9702,   -6856,  -21544,   20845,    7174},
{   5370,    9748,  -23765,   -1190,     512,   -1538},
{  -1006,  -10046,  -12649,   19234,   -1790,    -890},
{  15108,   23620,  -15646,   -2522,   -1203,   -1325},
{  -7406,   -2605,    1095,    -247,    -473,     177},
{   8089,       4,   12424,  -22284,   10405,   -7728},
{  22196,   10775,   -5043,     690,     534,    -212},
{  -3153,   -1418,  -16835,   18426,   15821,   22956},
{   5681,   -2229,    3196,   -3414,  -21817,  -14807},
{     19,     787,    1032,     170,   -8295,    -645},
{   -882,   -2319,  -27105,     432,   -4392,    1499},
{  -1354,  -11819,     -76,  -20380,  -10293,   11328},
{    211,   -4753,   -4675,   -6933,  -13538,   14479},
{   6043,    5260,    -459,    -462,     143,     -65},
{  -2572,    7256,   -3317,    9212,  -23184,   -9990},
{ -24882,   -9532,   18874,    6101,    2429,  -14482},
{   8314,    2277,   14192,    3512,   25881,   22000},
{    208,   20218,    -281,  -24778,     -63,   -1183},
{   1095,   -6034,    2706,  -21935,   -2655,     563},
{     23,   -5930,     243,   -8989,    5345,   20558},
{ -15466,   12699,    4160,   11087,   20621,  -10416},
{  20995,     -85,   -8468,     194,    1003,   -9515},
{ -19637,   -3335,  -14081,    3574,  -23381,    -667},
{  -2076,    3489,   -3192,  -19367,     539,   -1530},
{   7352,  -15213,   22596,   19369,    1043,   16627},
{  -1872,    -413,    1235,   -5276,   -3550,   21903},
{   7931,   -2008,   16968,   -6799,   29393,   -2475},
{ -13589,    8389,  -23636,  -22091,  -14178,  -14297},
{ -11575,  -20090,   16056,   -1848,   15721,    4500},
{   3849,  -16581,   20161,  -21155,    7778,   11864},
{  -6547,   -1273,  -18837,  -11218,   11636,    1044},
{   2528,   -6691,  -17917,  -11362,   -4894,   -1008},
{   1241,    4260,    2319,    6111,    3485,   20209},
{   3014,   -3048,    5316,   -4539,   20831,    8702},
{  -1790,  -14683,     278,   13956,  -10065,  -10547},
{ -22732,   -7957,   -1154,   13821,   -1484,   -1247},
{  -7317,    -615,   13094,   18927,    9897,    1452},
{   2552,   -2338,    3424,   -4630,   11124,  -19584},
{ -11125,  -20553,  -10855,  -10783,  -20767,    6833},
{    984,  -15095,    5775,   25125,    5377,  -19799},
{    517,   13272,   -7458,   -1711,   20612,   -6013},
{ -21417,   13251,  -20795,   13449,   17281,   13104},
{ -15811,  -16248,   23093,   -4037,   -8195,     871},
{    582,   12571,  -21129,  -14766,   -9187,    5685},
{   4318,   -1776,   11425,  -17763,   -9921,     577},
{   6013,   16830,   17655,  -25766,   -4400,   -3550},
{ -13744,  -16541,    3636,   -3330,  -21091,  -15886},
{   6565,  -11147,    8649,  -13114,   23345,  -13565},
{  -2542,   -9046,   -7558,   29240,    3701,    -383},
{ -10612,   24995,    1893,   -8210,   20920,  -16210},
{   5276,   16726,   10659,   19940,   -4799,  -19324},
{   -532,   -9300,   27856,    4965,    -241,     536},
{   -765,  -20706,   -3412,   18870,    2765,    1420},
{  -3059,    2708,  -19022,    -331,    3537,     116},

################################################################################

TITLE
    libavcodec AC3 vq_hebap7

TYPE
    16

DATA
{ -21173,   21893,   10390,   13646,   10718,   -9177},
{ -22519,   -8193,   18328,   -6629,   25518,  -10848},
{   6800,  -13758,  -13278,   22418,   14667,  -20938},
{   2347,   10516,    1125,   -3455,    5569,   27136},
{  -6617,   11851,  -24524,   22937,   20362,   -6019},
{ -21768,   10681,  -19615,  -15021,   -8478,   -2081},
{  -2745,    8684,   -4895,   27739,    7554,  -11961},
{  -1020,    2460,    -954,    4754,    -627,  -16368},
{ -19702,   23097,      75,  -13684,   -2644,    2108},
{   4049,   -2872,    5851,   -4459,   22150,   12560},
{ -21304,  -17129,    -730,    7419,  -11658,  -10523},
{  11332,    1792,   26666,   23518,  -19561,    -491},
{ -17827,  -16777,  -13606,  -14389,  -22029,   -2464},
{   1091,   -5967,   -7975,  -16977,  -20432,  -21931},
{  18388,   -1103,    1933,   13342,  -17463,   18114},
{  22646,   17345,   -9966,   17919,   18274,     698},
{   1484,   20297,   -5754,  -26515,    4941,  -22263},
{  -2603,    4587,   -5842,   18464,    8767,   -2568},
{  -2797,   -1602,   21713,    3099,  -25683,    3224},
{ -19027,    4693,   -5007,    6060,    1972,  -15095},
{  -2189,    9516,    -530,   20669,   -4662,   -8301},
{ -22325,   -8887,    2529,  -11352,    5476,     998},
{  22100,   -5052,    1651,   -2657,    4615,    2319},
{  20855,   -3078,   -3330,    4105,   13470,    3069},
{     85,   17289,   10264,  -14752,     214,      90},
{ -26365,  -18849,  -19352,   19244,  -10218,    9909},
{  -9739,   20497,   -6579,   -6983,    2891,    -738},
{  20575,  -15860,  -22913,    6870,      76,     327},
{   8744,  -12877,  -22945,   -2372,  -19424,   -9771},
{ -12886,   16183,   21084,    3821,     749,  -13792},
{ -15995,   18399,    2391,  -17661,   19484,   -6018},
{   1423,   11734,    4051,   19290,    6857,  -19681},
{  -5200,    9766,   18246,    2463,   18764,   -4852},
{   -597,   19498,    1323,   -9096,    -308,   -1104},
{  -3099,  -25731,  -15665,   25332,    4634,    2635},
{  19623,   -2384,   -7913,   11796,   -9333,  -14084},
{   2642,   26453,  -21091,  -10354,   -1693,   -1711},
{  22031,   21625,   11580,  -22915,   -4141,     129},
{  -6122,    3542,     915,    -261,     -17,    -383},
{   1696,    6704,   -1425,   20838,     857,   -4416},
{   1423,  -15280,   -8550,   -9667,    5210,    5687},
{  -4520,    -613,  -11683,    5618,    4230,     619},
{    937,   -4963,  -14102,  -17104,   -6906,   -5952},
{ -15068,    -481,   -7237,  -14894,   18876,   21673},
{ -25658,    2910,    1143,    -327,    -458,    -995},
{  -9656,    -819,  -24900,    2804,   20225,    1083},
{  -1111,   -3682,   -1788,  -19492,     966,     821},
{   7293,  -21759,   10790,   -7059,  -23293,   -1723},
{   -282,  -11093,     170,  -20950,  -28926,   12615},
{  17938,    3713,   -1563,     885,       5,     564},
{   6116,   22696,    2242,   -6951,    9975,   -6132},
{   4338,   26808,   -3705,    1976,   -1079,   -2570},
{   -661,   -7901,   -2668,  -15194,   17722,    4375},
{  -4174,  -11053,     717,  -22506,    1562,   12252},
{  -6405,   18334,    6103,    6983,    5956,   18195},
{   9851,    5370,   23604,   -6861,   -6569,     -62},
{  21964,   13359,    -683,    3785,    2168,     209},
{  -3569,   -1127,  -19724,   -1544,    1308,    -803},
{  -3083,   16049,  -13791,   -3077,    4294,   23713},
{  -9999,    9943,  -15872,   12934,  -23631,   21699},
{   9722,   22837,   12192,   15091,    5533,    4837},
{   2243,    2099,    1243,    4089,    4748,   12956},
{   4007,   -2468,    3353,   -3092,    8843,   17024},
{   4330,    6127,    5549,    9249,   11226,   28592},
{  -9586,   -8825,     236,    1009,     455,    -964},
{   6829,   19290,   -1018,     200,    1821,     578},
{   5196,     957,   10372,    3330,  -12800,    -127},
{  -3022,   -8193,  -14557,   22061,    5920,    1053},
{  10982,   25942,  -24546,  -23278,  -11905,   -6789},
{  22667,  -11010,    5736,    2567,   23705,  -10253},
{  -3343,   -4233,   -5458,   20667,  -10843,   -3605},
{  -4131,   -3612,    4575,    -829,    -350,    -847},
{  -3303,    3451,   -7398,  -11604,    3023,     455},
{   3200,   -9547,    3202,  -22893,   11184,  -26466},
{ -14093,   -4117,   15382,   14295,  -10915,  -20377},
{   3807,  -11016,   22052,   14370,  -15328,   -7733},
{  -6291,  -17719,   -1560,   12048,  -19805,    -443},
{  -6147,   -4234,    -160,    8363,   22638,   11911},
{  19197,    1175,    7422,   -9875,   -4136,    4704},
{    -72,   -7652,    -112,  -11955,   -3230,   27175},
{   3274,    5963,    7501,  -17019,     866,  -25452},
{    737,    1861,    1833,    2022,    2384,    4755},
{  -5217,    7512,    3323,    2715,    3065,   -1606},
{   4247,     565,    5629,    2497,   18019,   -4920},
{  -2833,  -17920,   -8062,   15738,   -1018,    2136},
{   3050,  -19483,   16930,   29835,  -10222,   15153},
{ -11346,     118,  -25796,  -13761,   15320,    -468},
{  -4824,    4960,   -4263,    1575,  -10593,   19561},
{  -8203,   -1409,    -763,   -1139,    -607,    1408},
{  -2203,  -11415,    2021,   -6388,   -2600,     711},
{   -413,   -2511,    -216,   -3519,  -28267,    1719},
{ -14446,   17050,   13917,   13499,  -25762,  -16121},
{  19228,    7341,  -12301,     682,   -3791,    -199},
{  -4193,   20746,  -15651,   11349,    5860,    -824},
{ -21490,   -3546,      -3,   -1705,   -3959,    9213},
{  15445,   -1876,    2012,  -19627,   16228,   -4845},
{  -2867,   -3733,   -7354,    -175,  -20119,   11174},
{  -3571,  -24587,   19700,    6654,     979,    -654},
{  21820,   -7430,   -6639,  -10767,   -8362,   15543},
{  14827,   17977,   -7204,   -3409,    1906,  -17288},
{   3525,   -3947,   -1415,   -2798,   17648,    2082},
{  -6580,  -15255,  -17913,    1337,   15338,   21158},
{   6210,    9698,   15155,  -24666,  -22507,   -3999},
{  -1740,    -593,    1095,   -7779,   25058,    5601},
{  21415,    -432,   -1658,   -6898,   -1438,  -14454},
{  -6943,     700,  -12139,    -745,  -24187,   22466},
{   6287,    3283,   11006,    3844,   19184,   14781},
{ -22502,   15274,    5443,   -2808,    -970,   -3343},
{   3257,   -3708,    4744,   -8301,   22814,  -10208},
{  24346,  -20970,   19846,     987,  -11958,   -6277},
{   3906,  -19701,   13060,   -1609,   18641,    7466},
{ -26409,  -22549,   16305,    2014,   10975,   18032},
{  -7039,    4655,  -14818,   18739,   15789,    1296},
{   9310,   -1681,   14667,   -3326,   26535,  -11853},
{   5728,    5917,   13400,   10020,   -2236,  -24704},
{   1741,   -6727,   12695,  -22009,    4080,    5450},
{  -2621,    9393,   21143,  -25938,   -3162,   -2529},
{  20672,   18894,  -13939,    6990,   -8260,   15811},
{ -23818,   11183,  -13639,   11868,   16045,    2630},
{  18361,  -10220,     829,     856,   -1010,     157},
{  14400,   -4678,    5153,  -13290,  -27434,  -11028},
{  21613,   11256,   17453,    7604,   13130,    -484},
{      7,    1236,     573,    4214,    5576,   -3081},
{    916,   -9092,    1285,   -8958,    1185,  -28699},
{  21587,   23695,   19116,   -2885,  -14282,   -8438},
{  23414,   -6161,   12978,    3061,   -9351,    2236},
{  -3070,   -7344,  -20140,    5788,     582,    -551},
{  -3993,     315,   -7773,    8224,  -28082,  -12465},
{  13766,  -15357,   19205,  -20624,   13043,  -19247},
{   3777,    -177,    8029,   -1001,   17812,    5162},
{  -7308,   -4327,  -18096,    -620,   -1350,   14932},
{  14756,   -1221,  -12819,  -14922,    -547,   27125},
{   2234,    1708,    2764,    5416,    7986,  -25163},
{   2873,    3636,    3992,    5344,   10142,   21259},
{   1158,    5379,     508,  -10514,     290,   -1615},
{   1114,   24789,   16575,  -25168,    -298,   -2832},
{  -1107,   -6144,   -1918,   -7791,   -2971,  -23276},
{   4016,   10793,   17317,   -4342,  -20982,   -3383},
{  -4494,    -207,   -9951,   -3575,    7947,    1154},
{  -7576,    8117,  -14047,   16982,  -26457,  -27540},
{ -15164,   16096,  -16844,   -8886,  -23720,   15906},
{  24922,    5680,   -1874,     420,     132,     117},
{   -506,  -19310,    -198,     412,    -311,     752},
{  -1906,    3981,   -7688,   16566,  -19291,  -14722},
{   -399,    -729,   -3807,   -4196,  -12395,    7639},
{   3368,    2330,    9092,   23686,  -10290,   -1705},
{  -3148,    2596,   -7986,   14602,   -4807,   16627},
{   8057,    1481,      49,   17205,   24869,    7474},
{ -19304,    -513,   11905,    2346,    5588,    3365},
{  -5063,  -21812,   11370,   10896,    4881,     261},
{   4794,   20577,    5109,   -6025,   -8049,   -1521},
{   8125,  -14756,   20639,  -14918,   23941,   -3650},
{  12451,    1381,    3613,    8687,  -24002,    4848},
{   6726,   10643,   10086,   25217,  -25159,   -1065},
{   6561,   13977,    2911,   21737,   16465,  -26050},
{  -1776,    2575,  -19606,  -16800,    3032,    6679},
{  15012,  -17910,   -8438,  -21554,  -27111,   11808},
{   3448,    -924,  -15913,   -1135,    5126,  -20613},
{   7720,    2226,   17463,    5434,   28942,   17552},
{   1246,   15614,  -11743,   24618,  -17539,    3272},
{   3215,   17950,    2783,    -722,  -22672,    5979},
{  -5678,   -3184,  -26087,   26034,    6583,    3302},
{  20310,   -3555,   -2715,    -444,   -1487,    1526},
{ -20640,  -21970,  -12207,  -25793,    8863,   -1036},
{  17888,     570,  -16102,    8329,   -2553,   15275},
{  -2677,    9950,   -1879,   16477,  -12762,  -29007},
{   -120,   -2221,     219,      97,     365,      35},
{   1270,    -718,    1480,   -2689,    1930,   -7527},
{   1896,    8750,    1906,   18235,  -12692,   -6174},
{  -3733,   13713,   -9882,  -15960,   -1376,   -7146},
{ -10600,    8496,   15967,   -8792,    7532,   20439},
{   3041,  -13457,    1032,  -26952,    5787,   24984},
{  -4590,   -8220,   -9322,   -6112,  -17243,   25745},
{ -17808,    6970,    3752,     626,    -114,    2178},
{   4449,   -4862,    7054,   -5404,    4738,   -2827},
{   4922,    -651,   18939,   -9866,     848,    1886},
{   -336,   -5410,    7234,   20444,   -9583,    -600},
{    781,  -19474,  -12648,    6634,    1414,     450},
{  -3399,  -16770,   11107,   13200,   -5498,   21663},
{  -3265,    4859,   -5961,    7530,  -10837,   28086},
{  10350,  -12901,   25699,   25640,    -639,     351},
{   1163,   18763,   -5466,  -15087,    -145,   -1377},
{ -14477,   27229,  -31383,  -32653,   21439,   -2894},
{  15420,   18823,   22128,   19398,   22583,   13587},
{ -10674,   10710,    5089,   -4756,     909,  -20760},
{ -12948,  -20660,    7410,    2722,    3427,   11585},
{  -1105,   18374,   19731,   -9650,   22442,   19634},
{   -296,   -6798,  -14677,   21603,   19796,   21399},
{ -19350,   -7501,   25446,   13144,    8588,  -25298},
{   3092,  -10618,   20896,    9249,   -3326,    1796},
{   -811,    1449,    3106,    4748,   12073,  -14262},
{ -20720,   14275,   -4332,  -25838,   -5781,  -21149},
{  -5132,   10554,  -14020,  -22150,    2840,    -554},
{  25533,   17648,   14886,  -21074,    2459,   25142},
{  -9370,   -1788,  -12862,   -5870,  -25811,  -11023},
{   6698,     819,   10313,     166,   27581,     523},
{    101,  -19388,    3413,    9638,      64,     806},
{  -2742,  -17931,   -2576,   22818,    8553,    1126},
{   2972,   15203,    1792,   25434,   -5728,  -17265},
{  -1419,    1604,    4398,   11452,    1731,   23787},
{  -5136,    4625,  -10653,   27981,    9897,   -2510},
{ -10528,  -28033,    2999,   -1530,    -832,    -830},
{ -11133,  -12511,   22206,   -7243,  -23578,  -21698},
{  16935,  -21892,    1861,   -9606,    9432,   19026},
{  10277,    9516,   26815,    2010,   -4943,   -9080},
{   5547,   -2210,   14270,  -15300,  -19316,    1822},
{  -4850,    -783,   -8959,   -3076,  -20056,   -3197},
{   8232,   -2794,  -17752,   13308,    3229,    -991},
{ -12237,   -6581,   10315,   -9552,    2260,  -20648},
{  -7000,    5529,   -7553,   -7490,  -10342,  -10266},
{   3641,   19479,   -5972,  -19097,  -18570,   12805},
{   1283,   -4164,    4198,  -28473,   -2498,    1866},
{  16047,   26826,  -13053,   -6316,     985,   -1597},
{   -403,   13680,    6457,   25070,   27124,  -20710},
{ -18070,   -1790,  -24986,    5953,    -954,   26600},
{ -24224,  -15383,   24788,    1953,   -1136,     187},
{  -2289,   12505,  -20738,    -904,   18324,   21258},
{   2658,   -6140,   16179,   22276,    -556,    2154},
{  -6087,   13950,  -25682,  -27713,    4049,   -4795},
{ -21452,   26473,   19435,   -9124,     895,     303},
{ -22200,  -26177,   -6026,   24729,  -22926,   -9030},
{ -14276,  -15982,   23732,  -22851,    9268,   -3841},
{  29482,   21923,   -6213,    1679,   -2059,   -1120},
{   -435,    9802,   -3891,   12359,   -4288,  -18971},
{  19768,     -86,    2467,    1990,   -1021,   -5354},
{  20986,   -8783,   -5329,  -23562,   -4730,    2673},
{  -5095,    5605,   -4629,   19150,   26037,  -12259},
{    972,    6858,    4551,   27949,   -4025,   -2272},
{   6075,   -3260,   -4989,    -373,   -1571,   -3730},
{  -7256,  -12992,   -8820,   -5109,   23054,    5054},
{    920,    2615,    7912,   -7353,   -4905,   20186},
{   -250,    5454,    3140,    6928,  -18723,   -2051},
{ -10299,   -4372,   19608,    4879,    -661,   -1885},
{  14816,   -8603,  -19815,    6135,  -21210,   14108},
{ -11945,   -2223,    5018,   11892,   22741,     406},
{ -13184,   -2613,  -13256,  -22433,  -12482,   -8380},
{  17066,   25267,   -2273,    5056,    -342,     145},
{   8401,  -17683,   19112,   10615,  -19453,   17083},
{  20821,   -5700,   12298,  -25598,   10391,    7692},
{   4550,   15779,   17338,  -19379,   -4768,    1206},
{  -7723,   10836,  -27164,  -11439,    6835,   -1776},
{   2542,    3199,    4442,   17513,   -3711,    -914},
{  20960,  -16774,   -5814,   11087,     -70,   22961},
{   3305,    2919,    6256,   -4800,  -20966,   -3230},
{   5924,  -16547,    2183,    2733,    3446,  -23306},
{  -6061,    -194,  -13852,  -10971,   19488,    1029},
{   4467,   -5964,  -19004,    1519,    -359,     855},
{  -1581,   -7607,   22070,  -11580,  -10032,   17102},
{ -12412,    2553,    4324,   22500,    5751,   12170},
{ -25127,   17996,   -6384,    1180,    1182,    9622},
{  23462,   -8471,   -4392,   -2669,    7638,  -16835},
{  -5511,   -2887,  -10757,  -20883,    7246,    1053},
{   2703,  -20602,   -7554,    7516,   -7740,    5868},
{  20670,   21901,     457,   14969,  -17657,  -11921},
{   3603,   -1595,   -2177,    -157,     -43,     605},
{   2513,    8954,   10527,   22559,  -16100,  -16041},
{   6002,    4951,    6795,   -4862,  -22400,   18849},
{   7590,   -1693,  -24688,   -3404,   14169,    1214},
{  -4398,   -6663,   -6870,  -10083,  -24596,    9253},
{  10468,   17751,   -7748,     147,   -6314,    4419},
{  16187,  -16557,   -4119,    4302,    7625,    5409},
{   3303,    2735,    7458,  -19902,   -2254,   -3702},
{  -2077,   21609,   14870,   12545,   -6081,   -1764},
{   4678,   11740,    2859,    6953,    1919,   -3871},
{   3522,  -21853,   -2469,  -10453,   18893,  -10742},
{   3759,  -10191,   -4866,   -2659,  -17831,   -1242},
{  14991,    9351,   11870,   -1573,   -4848,   22549},
{   9509,  -27152,   10734,   20851,  -26185,  -17878},
{  -7170,   -1392,  -19495,   12746,    8198,   -1988},
{   1883,   28158,    -846,   -7235,     249,     233},
{  -7200,     669,    -371,   -2948,   23234,   -5635},
{   3141,     288,    3223,   -1258,     -98,  -27607},
{  17373,  -23235,    5110,  -11199,   -2574,  -11487},
{  -4928,    1518,   -5456,     670,  -18278,    1951},
{  10334,  -19865,   -4649,     361,    -160,    -923},
{  18732,   14264,   -3155,   -7485,   -3328,    5959},
{  -3614,   21077,    7276,    3536,    8121,   -1528},
{  -8422,     500,  -19182,   18929,   26392,   -1039},
{  15639,   25668,    8375,    1903,    1945,  -11979},
{  -2716,    3389,   26850,   -4587,    1803,      22},
{   1177,    -655,    1233,   -2128,    7844,    1767},
{   -761,    8209,  -19290,   -4593,    1923,    -343},
{   -689,   -3530,   -3267,   -3804,   -2753,   18566},
{  -2110,    1962,   -1353,   16643,    2765,  -23102},
{   -433,    4905,     302,   13016,   15933,   -5905},
{   3203,    4126,   11181,   -5496,   -2529,   -1160},
{  -1091,   -6469,   -1415,    5682,    -268,     583},
{  -9405,  -19572,    6216,    1658,     993,     -75},
{  -1695,   -4504,   -2289,   -4088,   -6556,  -16577},
{   4760,    -892,  -10902,    6516,   24199,   -6011},
{   -253,    1000,      63,     -81,    -115,    -382},
{  -1333,   24224,    -698,   -4667,   -2801,  -19144},
{   -876,  -28866,  -21873,   12677,   -6344,    3235},
{  16847,   21145,  -26172,   -3183,    -396,     230},
{  18296,   -7790,  -12857,    -679,   -1473,       5},
{ -10488,   11429,   25805,   -1122,    1401,    -438},
{   3782,   -7429,   26720,   17567,   19257,   12542},
{   6332,    -746,   12789,    9316,  -22542,   -5354},
{   3418,  -22728,   26978,   18303,    1076,     956},
{ -27315,   -2988,     920,     235,    2233,      81},
{   6199,    5296,   16093,   14768,   -8429,   -1112},
{  -6432,   19244,    9921,   -3253,    1278,    -954},
{  24213,    2049,  -22931,    2585,   -2410,   -4216},
{   9286,   14282,  -19735,   -3985,   -2344,    1028},
{ -20128,   17993,   -9458,   23012,  -16983,    8625},
{  -6896,  -20730,    3762,   17415,   22341,   19024},
{    842,   24181,   25062,   -5839,     -78,     937},
{   -621,   19722,  -24204,   -1962,  -14854,     -56},
{  22766,   -5119,   17365,   23868,  -19480,   -6558},
{  -2158,   17490,  -21435,    3340,  -12819,  -20295},
{  -9621,   17325,     715,    2265,   -4123,    -492},
{   9156,   12947,   27303,  -21175,   -6072,   -9457},
{ -13164,  -23269,  -14006,   -4184,    6978,       2},
{    938,  -13381,    3520,  -24297,   22902,   19589},
{  -4911,  -19774,   19764,   -9310,  -12650,    3819},
{  -5462,   -4249,   -6987,   -6260,  -13943,  -25150},
{   9341,   10369,  -13862,   -6704,   22556,    -519},
{   6651,   18768,   -4855,   12570,   14730,  -10209},
{   -823,   18119,     398,   -1582,    -116,    -363},
{  -6935,  -12694,  -28392,    8552,    6961,    -239},
{  -2602,   -4704,   -1021,    2015,    5129,   23670},
{ -12559,   -8190,  -25028,   18544,   14179,    1663},
{   3813,   21036,   -9620,   -5051,   -1800,   -1087},
{ -22057,   16675,   14960,    9459,    2786,   16991},
{ -26040,  -19318,   -6414,    1104,    5798,  -18039},
{  -1737,   24825,   10417,  -11087,     896,   -5273},
{  -1855,   11661,   -2803,   24809,  -21435,  -19792},
{ -23473,  -16729,   -5782,    5643,    2636,    4940},
{  -1724,    4388,  -26673,  -13695,   10570,  -25895},
{  15358,  -19496,   26242,  -18493,    1736,    8054},
{   5684,   20890,    4091,  -19100,  -14588,  -10468},
{  17260,  -16291,   14859,  -17711,  -19174,   12435},
{ -27185,  -12573,    6743,    -562,     976,    -257},
{  12395,   -8618,  -22248,  -19843,   11013,    7762},
{   3799,   11853,  -27622,   -8473,    1089,   -1495},
{   4141,   -2182,  -26720,    -735,    -774,    1469},
{   3125,   13762,    4606,   29257,   18771,   -9958},
{ -17465,   -9445,  -17562,   -2530,   -6435,   -3726},
{  -1742,    4351,   -6841,  -19773,    9627,  -10654},
{   7251,    3525,   10835,    5601,   25198,  -23348},
{ -10300,  -17830,     631,   11640,    2044,  -20878},
{   -873,   -8502,   -1063,  -15674,  -10693,   14934},
{ -15957,   28137,    5268,     477,   -1053,    1158},
{  -1495,   -8814,   -5764,  -24965,   25988,    7907},
{  -1038,    -114,   -2308,   -1319,   -6480,    1472},
{   4895,  -17897,  -25850,    5301,    -188,    1581},
{   3200,   17225,    4346,   22101,  -18543,   22028},
{ -10250,     545,  -10932,    2276,  -28070,    8118},
{  15343,    2329,    9316,   20537,   14908,   21021},
{   6329,    6130,  -24508,     837,   -8637,   -5844},
{   7386,    -501,   10503,   20131,   11435,   -4755},
{  -2745,   24174,   -9274,   15273,   -8389,   -5835},
{   2992,   -2864,    6048,   -7473,   11687,  -19996},
{   -883,  -11954,   -9976,  -21829,   -4436,  -27178},
{   3458,   19626,    1280,    2597,   19849,    5255},
{  -5315,   19133,  -14518,   -8946,   13749,   -1352},
{  18642,   17655,   11001,    6817,  -18418,    6336},
{  -1697,    2244,   -4640,    3948,  -12890,   -5273},
{  20428,   10542,    4170,   -1012,   19439,   21691},
{  -2943,  -19735,   -4208,    1320,     909,   -8897},
{   9351,   -8066,   -2618,  -12933,   26582,    3507},
{   9705,  -22628,    8311,    8167,  -13293,    5608},
{   3222,    3749,   -1508,     165,     -52,    -196},
{    102,  -22744,   -8832,     903,  -11421,  -14662},
{   -120,    5998,   19765,   13401,    3628,    5197},
{   8528,    5827,   -1066,     774,     -39,    -166},
{   9411,   -9476,    9581,  -13004,   24456,   24900},
{  17878,    2235,  -21639,   20478,    4716,   -7190},
{  -2482,    9511,    1611,  -21943,   14230,   -1289},
{   9288,   -2291,   23215,   -3452,  -10842,      11},
{   9496,    3041,    5130,   -3890,  -21219,  -22589},
{  14262,   -9838,   20195,   14019,      91,  -17200},
{ -18591,     980,      17,     821,     120,    -574},
{  12285,  -19269,   13742,   16373,    -161,    6025},
{  -3364,    1530,   -4005,    2454,  -10872,  -23839},
{    105,    5085,    -260,    5790,    -588,   19170},
{   4121,    4169,   13439,   14644,   20899,    7434},
{   -175,   13101,   -3704,   23233,    3907,   10106},
{  -6101,   23467,    5204,   -1341,    1599,   13174},
{  -3217,   -3494,   15117,   -8387,  -11762,   -4750},
{   1146,    4675,  -19378,   14917,   -5091,     249},
{ -21506,   10136,  -16473,  -13305,   18382,   -8601},
{    628,    2447,    3344,    3130,   -5115,     119},
{  17900,  -22422,  -17633,   21967,  -16293,   -7676},
{  16863,   24214,    5612,   -3858,    -809,    3822},
{  -2291,   10091,   -2360,  -25109,   -1226,     312},
{   2957,   11256,   26745,  -13266,   -3455,   -1128},
{ -19762,   -2708,    4604,    6355,    1638,   25501},
{ -19593,   -7753,    3159,     -85,    -489,   -1855},
{    814,   12510,   19077,   -4681,   -2610,   -1474},
{ -23408,  -19027,    8137,   19878,    7912,    -282},
{    839,  -19652,   11927,   27278,   -3211,    2266},
{   4020,   -1110,    8226,   -1274,   20922,   25060},
{  26576,     325,   -8693,    -232,   -2218,    -699},
{ -11293,   -4200,    1805,   -6673,  -22940,   -1339},
{  -2005,  -15886,   -1047,  -27687,  -13235,   14370},
{ -22073,    1949,   13175,  -15656,   -1846,    8055},
{   3039,   12025,    7132,  -24632,     413,   -2347},
{ -24048,    -206,   12459,   -6654,    -417,  -10091},
{  18179,  -23688,  -20515,  -16396,    7230,     763},
{   5659,   -5085,   13878,  -23729,  -11077,  -19587},
{  11340,     501,   25040,    7616,  -19658,    1605},
{ -26650,    8878,   10544,     417,    1299,     261},
{  14460,   11369,   -3263,    9990,    8194,   18111},
{   1355,  -20838,   -9196,  -16060,   -8559,    -730},
{  -1918,  -20937,  -18293,   -2461,   -2651,    4316},
{  -2810,   24521,  -10996,  -25721,     308,   -1234},
{  -9075,  -17280,   -1833,  -29342,  -24213,  -16631},
{  -2843,   10165,   -5339,   -2888,   21858,  -21340},
{ -15832,   14849,  -23780,    5184,   10113,  -20639},
{ -19535,  -11361,    8413,    1486,  -23658,   -5759},
{  -7512,    1027,  -20794,   13732,   19892,  -21934},
{ -12132,   -7022,  -19175,   -8840,   22125,  -16490},
{   1937,    5210,   -6318,  -23788,   13141,   11082},
{   -205,    6036,    -380,    8658,    -233,   28020},
{  -5523,    7477,    7635,   23595,    9763,   -2590},
{  21658,  -28313,   -3086,    -300,   -1032,    1744},
{ -22352,   16646,     208,    6665,  -17400,   -3028},
{  18482,    9336,   -2737,  -19372,     407,   -4389},
{  -4913,  -17370,   18819,  -17654,   13416,   15232},
{   7749,    6368,   23135,  -18174,    7584,   -4248},
{  -1489,   -6523,     586,  -10157,   14964,   25568},
{   3844,   -6156,    4897,  -13045,  -22526,    5647},
{  -8491,   -2105,  -24774,     905,   -9326,    1456},
{  -3040,   -1476,    1166,   -4428,   11236,    9204},
{   3397,   -1451,   13598,  -15841,   24540,    5819},
{   8483,   -2993,   21547,  -16916,    7741,   24018},
{ -14932,  -23758,   -5332,   -6664,   -4497,   13267},
{  19379,   12916,   -2142,    -737,   21100,  -22101},
{   3393,   -4629,    5735,  -18913,   -6969,    2687},
{   1148,  -16147,  -21433,  -28095,    -630,  -14449},
{   7300,     672,   18530,  -17452,  -10149,     351},
{  11356,  -10974,   17212,    4624,     145,   17791},
{   -711,   -3479,   -2238,   15887,    2027,       0},
{ -28048,    1794,    -593,   -2758,  -21852,   11535},
{ -19683,    4937,   22004,   21523,   -3148,    1790},
{    813,    8231,    2633,   11981,   -3043,   22201},
{   8952,  -24760,    -690,   14873,   -2366,   -5372},
{   8406,   -5439,    -274,    -642,    -145,     778},
{  -6605,    7258,   20780,  -23507,  -18625,   22782},
{ -22896,  -25488,   10020,   -1614,    1508,   -1393},
{   7607,     407,  -24678,  -16385,   -1804,   -4699},
{ -10592,  -19139,   10462,   -3747,    8721,   -6919},
{  13010,    5292,   -6230,   -4884,  -20904,   -1797},
{  16891,  -13770,    -465,   19343,  -10741,  -12959},
{  25193,  -14799,   -5681,    -521,    -321,   -1211},
{   6917,   -3093,   20183,  -26903,  -12026,    1295},
{    305,    1992,   19457,    -985,      25,    -521},
{   6707,   -3698,    8365,   -8687,   21921,  -27166},
{   4668,    5997,    7117,   11696,   24401,  -10794},
{    744,   -9416,   19893,    1963,    7922,   -9824},
{   3430,   21282,   -1736,   10844,    8821,   27015},
{  -8813,    1521,  -24038,    1651,    7838,   -1208},
{   3911,  -11221,    3273,  -12541,    7168,   18402},
{  21642,    9117,  -11536,   -5256,    7077,    2382},
{    100,    3817,   -6713,    1244,    1518,    -321},
{   7946,  -18670,   10667,   -4866,     727,     776},
{ -15883,   -8150,   -2087,   22739,    1567,   -3482},
{   4380,   -2735,    8469,   -7025,  -11424,    1317},
{  26970,    4393,    7665,   17561,    -714,     650},
{ -16191,    -835,    8365,    1795,  -14314,   16297},
{   4504,  -10048,    7662,  -26690,  -17428,    2580},
{     48,   -3984,     564,   -5871,    2658,  -18658},
{  12579,  -26016,  -15642,    2672,   -1347,    -887},
{  -4950,    4208,   -6811,    2569,  -20621,   -8658},
{  -1836,  -14818,   -5571,  -23322,  -14800,   25867},
{   5434,  -28139,   -2357,   -2883,    -570,    2431},
{  13096,   -2771,   24994,  -12496,  -24723,   -1025},
{  -5676,   -4339,    1908,   18628,  -21323,   17366},
{  27660,  -27897,  -15409,    1436,   -7112,   -2241},
{   8019,    3847,   24568,    -469,    9674,   10683},
{   -903,  -10149,    1801,  -21260,    4795,   -8751},
{   1122,   -9582,    2625,   22791,     956,     882},
{   7876,   19075,   -9900,  -24266,    7496,    9277},
{    980,  -26764,   -5386,    5396,    1086,    1648},
{  28838,   -1270,    -447,       5,    -429,     -20},
{ -15283,    6132,   22812,    1252,   -9963,     511},
{    851,    7925,    -457,  -12210,    4261,    7579},
{  -4530,    8452,   -1246,   14501,  -24951,   -5760},
{ -17814,  -10727,    9887,  -23929,  -13432,    1878},
{ -15049,   10165,   16491,  -14603,  -11712,  -21156},
{  -3317,     840,   -5683,   22413,    1994,     586},
{  23158,   -5788,  -15043,  -10372,   -9271,  -13523},
{   -773,   -9509,   -3993,  -24264,    8463,    5804},
{  -8545,    -703,  -12440,   -3985,  -25122,  -28147},
{ -16659,   16001,    2746,    1611,    5097,   -1043},
{     41,   -7181,   19903,   31555,  -32237,   13927},
{  -5658,     845,  -12774,    5705,   16695,     -86},
{   5282,   14875,   27026,   21124,   15776,  -10477},
{  14712,   19648,  -11487,  -13361,  -20196,  -15229},
{   8597,   -9138,    -626,   10891,   -6015,    6346},
{  -1488,   -1272,   -1479,   -1303,   -3704,   -5485},
{  -3370,   17871,   -6604,   24930,   25886,   -3127},
{   8416,   27783,   -1385,    5350,   -4260,   19993},
{   5688,     362,   17246,    3809,   -3246,    1088},
{   -105,  -29607,    2747,   15223,    -167,    3722},
{   3502,   -3195,    8602,    7772,   -1566,    -915},
{   -491,    3257,   -2423,    5522,   20606,    -100},
{ -13948,  -11368,  -15375,  -21866,   -8520,   12221},
{   -616,    2424,   -2023,    4398,   -3805,    8108},
{  -7204,   21043,   21211,   -9395,  -19391,     896},
{  -5737,  -15160,  -21298,   17066,   -1006,    -366},
{   6261,    3240,  -11937,  -16213,  -15820,    6581},
{  -3155,   24796,    2733,   -1257,    -875,   -1597},
{ -20469,   11094,   24071,   -8987,   14136,    2220},
{ -14106,   11959,  -22495,    4135,   -1055,   -5420},
{    801,   -2655,      60,   -5324,    -790,    5937},
{  -7372,   -1764,  -22433,  -26060,   21707,    4178},
{  -5715,   -6648,  -14908,    1325,  -24044,    1493},
{  -6024,  -12488,   23930,    2950,    1601,    1173},
{  19067,   17630,   17929,  -10654,   10928,   -4958},
{   3231,   -3284,   27336,    4174,   -1683,     497},

################################################################################

TITLE
    libavcodec AC3 ff_ac3_frame_size_tab

TYPE
    16

DATA
    { 64,   69,   96   },
    { 64,   70,   96   },
    { 80,   87,   120  },
    { 80,   88,   120  },
    { 96,   104,  144  },
    { 96,   105,  144  },
    { 112,  121,  168  },
    { 112,  122,  168  },
    { 128,  139,  192  },
    { 128,  140,  192  },
    { 160,  174,  240  },
    { 160,  175,  240  },
    { 192,  208,  288  },
    { 192,  209,  288  },
    { 224,  243,  336  },
    { 224,  244,  336  },
    { 256,  278,  384  },
    { 256,  279,  384  },
    { 320,  348,  480  },
    { 320,  349,  480  },
    { 384,  417,  576  },
    { 384,  418,  576  },
    { 448,  487,  672  },
    { 448,  488,  672  },
    { 512,  557,  768  },
    { 512,  558,  768  },
    { 640,  696,  960  },
    { 640,  697,  960  },
    { 768,  835,  1152 },
    { 768,  836,  1152 },
    { 896,  975,  1344 },
    { 896,  976,  1344 },
    { 1024, 1114, 1536 },
    { 1024, 1115, 1536 },
    { 1152, 1253, 1728 },
    { 1152, 1254, 1728 },
    { 1280, 1393, 1920 },
    { 1280, 1394, 1920 },

################################################################################

TITLE
    libavcodec AC3 ff_ac3_window

TYPE
    16

DATA
    4,    7,   12,   16,   21,   28,   34,   42,
   51,   61,   72,   84,   97,  111,  127,  145,
  164,  184,  207,  231,  257,  285,  315,  347,
  382,  419,  458,  500,  544,  591,  641,  694,
  750,  810,  872,  937, 1007, 1079, 1155, 1235,
 1318, 1406, 1497, 1593, 1692, 1796, 1903, 2016,
 2132, 2253, 2379, 2509, 2644, 2783, 2927, 3076,
 3230, 3389, 3552, 3721, 3894, 4072, 4255, 4444,
 4637, 4835, 5038, 5246, 5459, 5677, 5899, 6127,
 6359, 6596, 6837, 7083, 7334, 7589, 7848, 8112,
 8380, 8652, 8927, 9207, 9491, 9778,10069,10363,
10660,10960,11264,11570,11879,12190,12504,12820,
13138,13458,13780,14103,14427,14753,15079,15407,
15735,16063,16392,16720,17049,17377,17705,18032,
18358,18683,19007,19330,19651,19970,20287,20602,
20914,21225,21532,21837,22139,22438,22733,23025,
23314,23599,23880,24157,24430,24699,24964,25225,
25481,25732,25979,26221,26459,26691,26919,27142,
27359,27572,27780,27983,28180,28373,28560,28742,
28919,29091,29258,29420,29577,29729,29876,30018,
30155,30288,30415,30538,30657,30771,30880,30985,
31086,31182,31274,31363,31447,31528,31605,31678,
31747,31814,31877,31936,31993,32046,32097,32145,
32190,32232,32272,32310,32345,32378,32409,32438,
32465,32490,32513,32535,32556,32574,32592,32608,
32623,32636,32649,32661,32671,32681,32690,32698,
32705,32712,32718,32724,32729,32733,32737,32741,
32744,32747,32750,32752,32754,32756,32757,32759,
32760,32761,32762,32763,32764,32764,32765,32765,
32766,32766,32766,32766,32767,32767,32767,32767,
32767,32767,32767,32767,32767,32767,32767,32767,
32767,32767,32767,32767,32767,32767,32767,32767,

################################################################################

TITLE
    libavcodec AC3 ff_ac3_log_add_tab

TYPE
    8

DATA
0x40,0x3f,0x3e,0x3d,0x3c,0x3b,0x3a,0x39,0x38,0x37,
0x36,0x35,0x34,0x34,0x33,0x32,0x31,0x30,0x2f,0x2f,
0x2e,0x2d,0x2c,0x2c,0x2b,0x2a,0x29,0x29,0x28,0x27,
0x26,0x26,0x25,0x24,0x24,0x23,0x23,0x22,0x21,0x21,
0x20,0x20,0x1f,0x1e,0x1e,0x1d,0x1d,0x1c,0x1c,0x1b,
0x1b,0x1a,0x1a,0x19,0x19,0x18,0x18,0x17,0x17,0x16,
0x16,0x15,0x15,0x15,0x14,0x14,0x13,0x13,0x13,0x12,
0x12,0x12,0x11,0x11,0x11,0x10,0x10,0x10,0x0f,0x0f,
0x0f,0x0e,0x0e,0x0e,0x0d,0x0d,0x0d,0x0d,0x0c,0x0c,
0x0c,0x0c,0x0b,0x0b,0x0b,0x0b,0x0a,0x0a,0x0a,0x0a,
0x0a,0x09,0x09,0x09,0x09,0x09,0x08,0x08,0x08,0x08,
0x08,0x08,0x07,0x07,0x07,0x07,0x07,0x07,0x06,0x06,
0x06,0x06,0x06,0x06,0x06,0x06,0x05,0x05,0x05,0x05,
0x05,0x05,0x05,0x05,0x04,0x04,0x04,0x04,0x04,0x04,
0x04,0x04,0x04,0x04,0x04,0x03,0x03,0x03,0x03,0x03,
0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,
0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

################################################################################

TITLE
    libavcodec AC3 ff_ac3_hearing_threshold_tab

TYPE
    16

DATA
{ 0x04d0,0x04f0,0x0580 },
{ 0x04d0,0x04f0,0x0580 },
{ 0x0440,0x0460,0x04b0 },
{ 0x0400,0x0410,0x0450 },
{ 0x03e0,0x03e0,0x0420 },
{ 0x03c0,0x03d0,0x03f0 },
{ 0x03b0,0x03c0,0x03e0 },
{ 0x03b0,0x03b0,0x03d0 },
{ 0x03a0,0x03b0,0x03c0 },
{ 0x03a0,0x03a0,0x03b0 },
{ 0x03a0,0x03a0,0x03b0 },
{ 0x03a0,0x03a0,0x03b0 },
{ 0x03a0,0x03a0,0x03a0 },
{ 0x0390,0x03a0,0x03a0 },
{ 0x0390,0x0390,0x03a0 },
{ 0x0390,0x0390,0x03a0 },
{ 0x0380,0x0390,0x03a0 },
{ 0x0380,0x0380,0x03a0 },
{ 0x0370,0x0380,0x03a0 },
{ 0x0370,0x0380,0x03a0 },
{ 0x0360,0x0370,0x0390 },
{ 0x0360,0x0370,0x0390 },
{ 0x0350,0x0360,0x0390 },
{ 0x0350,0x0360,0x0390 },
{ 0x0340,0x0350,0x0380 },
{ 0x0340,0x0350,0x0380 },
{ 0x0330,0x0340,0x0380 },
{ 0x0320,0x0340,0x0370 },
{ 0x0310,0x0320,0x0360 },
{ 0x0300,0x0310,0x0350 },
{ 0x02f0,0x0300,0x0340 },
{ 0x02f0,0x02f0,0x0330 },
{ 0x02f0,0x02f0,0x0320 },
{ 0x02f0,0x02f0,0x0310 },
{ 0x0300,0x02f0,0x0300 },
{ 0x0310,0x0300,0x02f0 },
{ 0x0340,0x0320,0x02f0 },
{ 0x0390,0x0350,0x02f0 },
{ 0x03e0,0x0390,0x0300 },
{ 0x0420,0x03e0,0x0310 },
{ 0x0460,0x0420,0x0330 },
{ 0x0490,0x0450,0x0350 },
{ 0x04a0,0x04a0,0x03c0 },
{ 0x0460,0x0490,0x0410 },
{ 0x0440,0x0460,0x0470 },
{ 0x0440,0x0440,0x04a0 },
{ 0x0520,0x0480,0x0460 },
{ 0x0800,0x0630,0x0440 },
{ 0x0840,0x0840,0x0450 },
{ 0x0840,0x0840,0x04e0 },

################################################################################

TITLE
    libavcodec AC3 ff_ac3_critical_band_size_tab

TYPE
    8

DATA
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3,
    3, 6, 6, 6, 6, 6, 6, 12, 12, 12, 12, 24, 24, 24, 24, 24

################################################################################

TITLE
    libavcodec ff_acelp_interp_filter

TYPE
    16

DATA
  29443, 28346, 25207, 20449, 14701,  8693,
   3143, -1352, -4402, -5865, -5850, -4673,
  -2783,  -672,  1211,  2536,  3130,  2991,
   2259,  1170,     0, -1001, -1652, -1868,
  -1666, -1147,  -464,   218,   756,  1060,
   1099,   904,   550,   135,  -245,  -514,
   -634,  -602,  -451,  -231,     0,   191,
    308,   340,   296,   198,    78,   -36,
   -120,  -163,  -165,  -132,   -79,   -19,
     34,    73,    91,    89,    70,    38,
      0,

################################################################################

TITLE
    libavcodec ff_fc_2pulses_9bits_track1

TYPE
    8

DATA
    1,  3,
    6,  8,
    11, 13,
    16, 18,
    21, 23,
    26, 28,
    31, 33,
    36, 38

################################################################################

TITLE
    libavcodec ff_fc_2pulses_9bits_track1_gray

TYPE
    8

DATA
  1,  3,
  8,  6,
  18, 16,
  11, 13,
  38, 36,
  31, 33,
  21, 23,
  28, 26,

################################################################################

TITLE
    libavcodec ff_fc_2pulses_9bits_track2_gray

TYPE
    8

DATA
  0,  2,
  5,  4,
  12, 10,
  7,  9,
  25, 24,
  20, 22,
  14, 15,
  19, 17,
  36, 31,
  21, 26,
  1,  6,
  16, 11,
  27, 29,
  32, 30,
  39, 37,
  34, 35,

################################################################################

TITLE
    libavcodec ff_fc_4pulses_8bits_track_4

TYPE
    8

DATA
    3,  4,
    8,  9,
    13, 14,
    18, 19,
    23, 24,
    28, 29,
    33, 34,
    38, 39,
    43, 44,
    48, 49,
    53, 54,
    58, 59,
    63, 64,
    68, 69,
    73, 74,
    78, 79,

################################################################################

TITLE
    libavcodec ape_filter_orders

TYPE
    16

DATA
    {  0,   0,    0 },
    { 16,   0,    0 },
    { 64,   0,    0 },
    { 32, 256,    0 },
    { 16, 256, 1280 }

################################################################################

TITLE
    libavcodec ape_filter_fracbits

TYPE
    8

DATA
    {  0,  0,  0 },
    { 11,  0,  0 },
    { 11,  0,  0 },
    { 10, 13,  0 },
    { 11, 13, 15 }

################################################################################

TITLE
    libavcodec asus v1/v2 asv2_level_tab

TYPE
    8

DATA
    {0x3F,10},{0x2F,10},{0x37,10},{0x27,10},{0x3B,10},{0x2B,10},{0x33,10},{0x23,10},
    {0x3D,10},{0x2D,10},{0x35,10},{0x25,10},{0x39,10},{0x29,10},{0x31,10},{0x21,10},
    {0x1F, 8},{0x17, 8},{0x1B, 8},{0x13, 8},{0x1D, 8},{0x15, 8},{0x19, 8},{0x11, 8},
    {0x0F, 6},{0x0B, 6},{0x0D, 6},{0x09, 6},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x07, 4},{0x05, 4},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x03, 2},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x00, 5},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x02, 2},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x04, 4},{0x06, 4},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x08, 6},{0x0C, 6},{0x0A, 6},{0x0E, 6},{0x00, 0},{0x00, 0},{0x00, 0},{0x00, 0},
    {0x10, 8},{0x18, 8},{0x14, 8},{0x1C, 8},{0x12, 8},{0x1A, 8},{0x16, 8},{0x1E, 8},
    {0x20,10},{0x30,10},{0x28,10},{0x38,10},{0x24,10},{0x34,10},{0x2C,10},{0x3C,10},
    {0x22,10},{0x32,10},{0x2A,10},{0x3A,10},{0x26,10},{0x36,10},{0x2E,10},{0x3E,10},

################################################################################

TITLE
    libavcodec asus v1/v2 scantab

TYPE
    8

DATA
    0x00,0x08,0x01,0x09,0x10,0x18,0x11,0x19,
    0x02,0x0A,0x03,0x0B,0x12,0x1A,0x13,0x1B,
    0x04,0x0C,0x05,0x0D,0x20,0x28,0x21,0x29,
    0x06,0x0E,0x07,0x0F,0x14,0x1C,0x15,0x1D,
    0x22,0x2A,0x23,0x2B,0x30,0x38,0x31,0x39,
    0x16,0x1E,0x17,0x1F,0x24,0x2C,0x25,0x2D,
    0x32,0x3A,0x33,0x3B,0x26,0x2E,0x27,0x2F,
    0x34,0x3C,0x35,0x3D,0x36,0x3E,0x37,0x3F,

################################################################################

TITLE
    libavcodec asus v1/v2 ccp_tab

TYPE
    8

DATA
    {0x2,2}, {0x7,5}, {0xB,5}, {0x3,5},
    {0xD,5}, {0x5,5}, {0x9,5}, {0x1,5},
    {0xE,5}, {0x6,5}, {0xA,5}, {0x2,5},
    {0xC,5}, {0x4,5}, {0x8,5}, {0x3,2},
    {0xF,5}, //EOB

################################################################################

TITLE
    libavcodec asus v1/v2 dc_ccp_tab

TYPE
    8

DATA
    {0x1,2}, {0xD,4}, {0xF,4}, {0xC,4},
    {0x5,3}, {0xE,4}, {0x4,3}, {0x0,2},

################################################################################

TITLE
    libavcodec asus v1/v2 ac_ccp_tab

TYPE
    8

DATA
    {0x00,2}, {0x3B,6}, {0x0A,4}, {0x3A,6},
    {0x02,3}, {0x39,6}, {0x3C,6}, {0x38,6},
    {0x03,3}, {0x3D,6}, {0x08,4}, {0x1F,5},
    {0x09,4}, {0x0B,4}, {0x0D,4}, {0x0C,4},

################################################################################

TITLE
    libavcodec atrac huffcode6

TYPE
    8

DATA
  0x0,0x2,0x3,0x4,0x5,0x6,0x7,0x14,0x15,0x16,0x17,0x18,0x19,0x34,0x35,
  0x36,0x37,0x38,0x39,0x3A,0x3B,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x8,0x9,

################################################################################

TITLE
    libavcodec atrac huffcode7

TYPE
    8

DATA
  0x0,0x8,0x9,0xA,0xB,0xC,0xD,0xE,0xF,0x10,0x11,0x24,0x25,0x26,0x27,0x28,
  0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33,0x68,0x69,0x6A,0x6B,0x6C,
  0x6D,0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,0xEC,0xED,0xEE,0xEF,0xF0,0xF1,0xF2,
  0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0x2,0x3,

################################################################################

TITLE
    libavcodec atrac subbandTab

TYPE
    16

DATA
  0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224,
  256, 288, 320, 352, 384, 416, 448, 480, 512, 576, 640, 704, 768, 896, 1024

################################################################################

TITLE
    libavcodec atrac qmf_48tap_half

TYPE
    FLOAT

DATA
   -0.00001461907, -0.00009205479, -0.000056157569, 0.00030117269,
    0.0002422519,-0.00085293897, -0.0005205574, 0.0020340169,
    0.00078333891, -0.0042153862, -0.00075614988, 0.0078402944,
   -0.000061169922, -0.01344162, 0.0024626821, 0.021736089,
   -0.007801671, -0.034090221, 0.01880949, 0.054326009,
   -0.043596379, -0.099384367, 0.13207909, 0.46424159

################################################################################

TITLE
    libavcodec atrac ff_cavs_intra_dec

TYPE
    8

DATA
      {  1, 1, 1},{ -1, 1, 1},{  1, 2, 1},{ -1, 2, 1},{  1, 3, 1},{ -1, 3, 1},
      {  1, 4, 1},{ -1, 4, 1},{  1, 5, 1},{ -1, 5, 1},{  1, 6, 1},{ -1, 6, 1},
      {  1, 7, 1},{ -1, 7, 1},{  1, 8, 1},{ -1, 8, 1},{  1, 9, 1},{ -1, 9, 1},
      {  1,10, 1},{ -1,10, 1},{  1,11, 1},{ -1,11, 1},{  2, 1, 2},{ -2, 1, 2},
      {  1,12, 1},{ -1,12, 1},{  1,13, 1},{ -1,13, 1},{  1,14, 1},{ -1,14, 1},
      {  1,15, 1},{ -1,15, 1},{  2, 2, 2},{ -2, 2, 2},{  1,16, 1},{ -1,16, 1},
      {  1,17, 1},{ -1,17, 1},{  3, 1, 3},{ -3, 1, 3},{  1,18, 1},{ -1,18, 1},
      {  1,19, 1},{ -1,19, 1},{  2, 3, 2},{ -2, 3, 2},{  1,20, 1},{ -1,20, 1},
      {  1,21, 1},{ -1,21, 1},{  2, 4, 2},{ -2, 4, 2},{  1,22, 1},{ -1,22, 1},

################################################################################

TITLE
    libavcodec celp_math base_cos G729_BITEXACT

TYPE
    16

DATA
  32767,  32729,  32610,  32413,  32138,  31786,  31357,  30853,
  30274,  29622,  28899,  28106,  27246,  26320,  25330,  24279,
  23170,  22006,  20788,  19520,  18205,  16846,  15447,  14010,
  12540,  11039,   9512,   7962,   6393,   4808,   3212,   1608,
      0,  -1608,  -3212,  -4808,  -6393,  -7962,  -9512, -11039,
 -12540, -14010, -15447, -16846, -18205, -19520, -20788, -22006,
 -23170, -24279, -25330, -26320, -27246, -28106, -28899, -29622,
 -30274, -30853, -31357, -31786, -32138, -32413, -32610, -32729

################################################################################

TITLE
    libavcodec celp_math slope_cos G729_BITEXACT

TYPE
    16

DATA
   -632,  -1893,  -3150,  -4399,  -5638,  -6863,  -8072,  -9261,
 -10428, -11570, -12684, -13767, -14817, -15832, -16808, -17744,
 -18637, -19486, -20287, -21039, -21741, -22390, -22986, -23526,
 -24009, -24435, -24801, -25108, -25354, -25540, -25664, -25726,
 -25726, -25664, -25540, -25354, -25108, -24801, -24435, -24009,
 -23526, -22986, -22390, -21741, -21039, -20287, -19486, -18637,
 -17744, -16808, -15832, -14817, -13767, -12684, -11570, -10428,
  -9261,  -8072,  -6863,  -5638,  -4399,  -3150,  -1893,   -632

################################################################################

TITLE
    libavcodec celp_math tab_exp2 G729_BITEXACT

TYPE
    16

DATA
  16384, 16743, 17109, 17484, 17867, 18258, 18658, 19066, 19484, 19911,
  20347, 20792, 21247, 21713, 22188, 22674, 23170, 23678, 24196, 24726,
  25268, 25821, 26386, 26964, 27554, 28158, 28774, 29405, 30048, 30706,
  31379, 32066, 32767

################################################################################

TITLE
    libavcodec celp_math tab_log2 G729_BITEXACT

TYPE
    16

DATA
      0,   1455,   2866,   4236,   5568,   6863,   8124,   9352,
  10549,  11716,  12855,  13967,  15054,  16117,  17156,  18172,
  19167,  20142,  21097,  22033,  22951,  23852,  24735,  25603,
  26455,  27291,  28113,  28922,  29716,  30497,  31266,  32023,  32767,

################################################################################

TITLE
    libavcodec celp_math base_cos

TYPE
    16

DATA
  32767,  32738,  32617,  32421,  32145,  31793,  31364,  30860,
  30280,  29629,  28905,  28113,  27252,  26326,  25336,  24285,
  23176,  22011,  20793,  19525,  18210,  16851,  15451,  14014,
  12543,  11043,   9515,   7965,   6395,   4810,   3214,   1609,
      1,  -1607,  -3211,  -4808,  -6393,  -7962,  -9513, -11040,
 -12541, -14012, -15449, -16848, -18207, -19523, -20791, -22009,
 -23174, -24283, -25334, -26324, -27250, -28111, -28904, -29627,
 -30279, -30858, -31363, -31792, -32144, -32419, -32616, -32736, -32768,

################################################################################

TITLE
    libavcodec celp_math exp2a

TYPE
    16

DATA
     0,  1435,  2901,  4400,  5931,  7496,  9096, 10730,
 12400, 14106, 15850, 17632, 19454, 21315, 23216, 25160,
 27146, 29175, 31249, 33368, 35534, 37747, 40009, 42320,
 44682, 47095, 49562, 52082, 54657, 57289, 59979, 62727,

################################################################################

TITLE
    libavcodec celp_math exp2b

TYPE
    16

DATA
     3,   712,  1424,  2134,  2845,  3557,  4270,  4982,
  5696,  6409,  7124,  7839,  8554,  9270,  9986, 10704,
 11421, 12138, 12857, 13576, 14295, 15014, 15734, 16455,
 17176, 17898, 18620, 19343, 20066, 20790, 21514, 22238,

################################################################################

TITLE
    libavcodec celp_math tab_log2

TYPE
    16

DATA
      4,   1459,   2870,   4240,   5572,   6867,   8127,   9355,
  10552,  11719,  12858,  13971,  15057,  16120,  17158,  18175,
  19170,  20145,  21100,  22036,  22954,  23854,  24738,  25605,
  26457,  27294,  28116,  28924,  29719,  30500,  31269,  32025,  32769,

################################################################################

TITLE
    libavcodec dca_channel_reorder_lfe

TYPE
    8

DATA
    { 0, -1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 2,  0,  1, -1, -1, -1, -1, -1},
    { 0,  1,  3, -1, -1, -1, -1, -1},
    { 2,  0,  1,  4, -1, -1, -1, -1},
    { 0,  1,  3,  4, -1, -1, -1, -1},
    { 2,  0,  1,  4,  5, -1, -1, -1},
    { 3,  4,  0,  1,  5,  6, -1, -1},
    { 2,  0,  1,  4,  5,  6, -1, -1},
    { 0,  6,  4,  5,  2,  3, -1, -1},
    { 4,  2,  5,  0,  1,  6,  7, -1},
    { 5,  6,  0,  1,  7,  3,  8,  4},
    { 4,  2,  5,  0,  1,  6,  8,  7},

################################################################################

TITLE
    libavcodec dca_channel_reorder_nolfe

TYPE
    8

DATA
    { 0, -1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 0,  1, -1, -1, -1, -1, -1, -1},
    { 2,  0,  1, -1, -1, -1, -1, -1},
    { 0,  1,  2, -1, -1, -1, -1, -1},
    { 2,  0,  1,  3, -1, -1, -1, -1},
    { 0,  1,  2,  3, -1, -1, -1, -1},
    { 2,  0,  1,  3,  4, -1, -1, -1},
    { 2,  3,  0,  1,  4,  5, -1, -1},
    { 2,  0,  1,  3,  4,  5, -1, -1},
    { 0,  5,  3,  4,  1,  2, -1, -1},
    { 3,  2,  4,  0,  1,  5,  6, -1},
    { 4,  5,  0,  1,  6,  2,  7,  3},
    { 3,  2,  4,  0,  1,  5,  7,  6},

################################################################################

TITLE
    libavcodec dca adpcm_vb

TYPE
    16

DATA
  { 9928, -2618, -1093, -1263 },
  { 11077, -2876, -1747, -308 },
  { 10503, -1082, -1426, -1167 },
  { 9337, -2403, -1495, 274 },
  { 10698, -2529, -532, -1122 },
  { 10368, -3974, -1264, -750 },
  { 10070, -3667, 346, 863 },
  { 10278, -3093, 311, -576 },
  { 9894, -1330, -1428, -860 },
  { 10544, -1923, -1058, -971 },
  { 10996, -1632, -841, -1404 },
  { 11832, -3465, 1658, -1990 },
  { 10852, -688, -2658, -499 },
  { 10546, -1749, -147, -1733 },
  { 10801, -1004, -708, -1453 },
  { 10588, -441, -2113, -952 },
  { 10141, -3331, -582, -1432 },
  { 9608, -2590, 383, 258 },
  { 11422, -3265, 229, -1544 },
  { 10460, -1338, -713, -1568 },
  { 10306, -1721, -1660, -603 },
  { 9580, -1812, -1235, -1061 },
  { 11471, -2285, -1617, -607 },
  { 10081, -2225, -1408, -868 },
  { 10715, -2624, -1367, -704 },
  { 10616, -1871, -2770, -35 },
  { 9352, -2340, -1024, -1566 },
  { 11065, -1458, -1926, -735 },
  { 11334, -2056, -1041, -1144 },
  { 9825, -2048, -794, -1536 },
  { 11850, -2695, -1123, -867 },
  { 10654, -2226, -1891, -373 },
  { 10024, -1557, -808, -1069 },
  { 11142, -1266, -3238, 128 },
  { 11729, -3282, -514, -1011 },
  { 11402, -2094, -2335, -189 },
  { 10195, -3658, 181, -1875 },
  { 11431, -2626, -404, -1377 },
  { 11001, -3868, -619, -1077 },
  { 10894, -2559, 274, -1758 },
  { 9633, -1482, -2253, -773 },
  { 11245, -3321, 830, -1972 },
  { 9768, -2701, -199, -1859 },
  { 10500, -2042, 525, -2043 },
  { 11669, -4069, 293, -1468 },
  { 9192, -1991, -583, -61 },
  { 10057, -3220, -2015, -473 },
  { 9497, -2315, -2490, -467 },
  { 10455, -3069, -1194, -1007 },
  { 9994, -1936, -60, -1225 },
  { 9295, -2156, -1761, -1134 },
  { 10085, -3748, -1026, 197 },
  { 9334, -2360, 804, -351 },
  { 11561, -2553, 1352, -2313 },
  { 12837, -3998, 1195, -1958 },
  { 10114, -1100, -2414, -394 },
  { 9341, -2530, 315, 755 },
  { 10131, -3164, 1411, -674 },
  { 9535, -905, -1551, 579 },
  { 11717, -1519, -3051, 91 },
  { 9824, -2911, -2775, 192 },
  { 9662, -2934, -561, 1450 },
  { 11085, -3392, -1298, -659 },
  { 8955, -2102, -1899, 703 },
  { 8607, -1742, -4348, 814 },
  { 7640, -2063, -3617, 52 },
  { 7074, -826, -4325, 4375 },
  { 7714, 584, -4238, 1927 },
  { 6355, -952, -4912, 3127 },
  { 7069, -660, -6413, 4087 },
  { 8313, -132, -2964, -876 },
  { 6952, -1422, -3962, -24 },
  { 9299, -734, -3088, -263 },
  { 9484, -574, -4513, 466 },
  { 7246, -91, -3735, -704 },
  { 8325, -1417, -3090, -530 },
  { 6469, -1226, -4757, 829 },
  { 6652, -368, -5682, 1393 },
  { 7971, -1278, -2284, 1205 },
  { 7229, -699, -3556, 1840 },
  { 7994, 1284, -2729, 732 },
  { 9005, -698, -4522, 2189 },
  { 6963, 197, -2727, 380 },
  { 8527, 135, -3991, -213 },
  { 8840, 934, -3014, -567 },
  { 10125, 418, -3284, -371 },
  { 6367, 361, -2318, 2554 },
  { 7892, 172, -5247, 4673 },
  { 6674, 387, -5424, 4398 },
  { 6240, 684, -4047, 1219 },
  { 11170, -794, -5081, 1195 },
  { 11765, -648, -6265, 2052 },
  { 10845, -775, -3837, 366 },
  { 12496, -689, -8260, 3562 },
  { 7893, -1166, -4972, 988 },
  { 8592, 1052, -5986, 3087 },
  { 7277, 1874, -5685, 3579 },
  { 6900, 2016, -4809, 3491 },
  { 8530, -2405, -3250, 1986 },
  { 9426, 494, -7067, 5038 },
  { 10285, 564, -8210, 5370 },
  { 8749, -2207, -3980, 2852 },
  { 9653, -2686, -4300, 1400 },
  { 9770, -2286, -5663, 4233 },
  { 8490, -4, -7048, 4496 },
  { 7697, -1209, -5328, 3183 },
  { 6451, 801, -4324, -554 },
  { 7387, 1806, -5265, 545 },
  { 7450, -2302, -4445, 1418 },
  { 8817, -1370, -5827, 2168 },
  { 10324, -2406, -5629, 2579 },
  { 8863, -2578, -3537, 467 },
  { 6901, -1624, -3169, 3392 },
  { 7846, 156, -6948, 3381 },
  { 7928, -1115, -5972, 4816 },
  { 6089, -599, -4368, -320 },
  { 7833, 1246, -3960, -621 },
  { 8931, 2521, -6768, 2052 },
  { 8900, 1944, -4126, 40 },
  { 7661, -34, -2855, 2480 },
  { 5873, 474, -3262, 3712 },
  { 7535, -234, -4699, 216 },
  { 5856, 143, -5142, 73 },
  { 8944, -106, -5874, 3663 },
  { 7134, 426, -5879, 2895 },
  { 10199, 1011, -4762, 369 },
  { 8454, 264, -5971, 1291 },
  { 7822, -2449, -4333, 4540 },
  { 6200, -2758, -2632, 1497 },
  { 6070, -4315, -2699, 414 },
  { 7047, -3739, -3210, 1060 },
  { 5675, -3801, -2717, -407 },
  { 4789, -4063, -2628, -744 },
  { 4023, -3366, -3133, -726 },
  { 4296, -2407, -3381, -513 },
  { 4388, -2931, -2820, 1512 },
  { 4559, -4233, -1941, 1976 },
  { 6702, -3208, -1755, 1680 },
  { 4416, -3521, -1052, 2984 },
  { 7154, -4266, -1203, 3732 },
  { 3625, -4242, -3244, 1395 },
  { 6518, -2856, -1304, 2887 },
  { 6170, -1949, -3014, 3973 },
  { 5189, -2451, -4020, 3477 },
  { 6218, -2988, -1921, 3844 },
  { 4827, -3688, -1928, 3343 },
  { 6668, -3991, -2805, 3095 },
  { 5297, -3115, -3684, 2390 },
  { 5354, -4614, -2662, 1504 },
  { 4196, -3091, -4147, 1135 },
  { 3540, -2893, -4007, 100 },
  { 5569, -1602, -4007, 1909 },
  { 4341, -2091, -4272, 252 },
  { 5559, -2878, -3832, 498 },
  { 4548, -4479, -2898, -27 },
  { 5176, -2494, -4635, 1476 },
  { 3294, -3485, -3738, 716 },
  { 4920, -1229, -4195, -365 },
  { 3257, -3518, -3349, 2862 },
  { 5286, -1948, -3485, -778 },
  { 6502, -3051, -152, 2854 },
  { 5864, -4192, -1076, 3451 },
  { 4656, -3122, -3448, 179 },
  { 5907, -754, -1596, 3116 },
  { 7229, -3680, -1590, 2892 },
  { 5107, -3888, -3364, 806 },
  { 6764, -2635, -3450, 134 },
  { 5258, -2827, -2844, -1052 },
  { 5798, -1725, -4305, 205 },
  { 5404, -1213, -3362, 449 },
  { 6224, -2738, -3046, -581 },
  { 4223, -2438, -2725, 3745 },
  { 4751, -3411, -2123, 116 },
  { 3868, -3000, -3954, 2297 },
  { 6819, -2899, -4277, 2825 },
  { 4207, -4754, -2808, 865 },
  { 4804, -1494, -1997, 4688 },
  { 5282, -2213, -548, 3559 },
  { 5580, -1912, -566, 4370 },
  { 6168, -2857, -672, 4053 },
  { 6583, -4515, -2850, 1670 },
  { 6511, -3093, -3988, 1421 },
  { 4646, -1790, -1443, 3650 },
  { 5915, -924, -2020, 896 },
  { 7814, -4181, -3152, 2007 },
  { 6190, -2238, -4817, 2279 },
  { 4737, -4034, -3288, 1835 },
  { 8161, -3633, -3423, 3137 },
  { 7415, -2351, -2088, 4290 },
  { 4106, -2517, -62, 2905 },
  { 4909, -3145, -614, 4112 },
  { 4938, -3281, -397, 1100 },
  { -173, 919, 1589, -5363 },
  { -13, 796, -295, -6655 },
  { -1860, -829, 1141, -4555 },
  { 2298, -838, -664, -5005 },
  { -884, -1097, 2074, -4613 },
  { -101, 281, 2846, -4535 },
  { 1166, 453, 2429, -5910 },
  { 879, -664, 2370, -5452 },
  { 1415, -370, -1699, -4727 },
  { -1413, 1277, -669, -6649 },
  { 2133, 304, -968, -4624 },
  { 380, 586, -2087, -4892 },
  { 1336, 275, -82, -5789 },
  { -2459, 1057, -34, -5416 },
  { 2278, -1758, 866, -5653 },
  { 1945, -2295, -149, -5302 },
  { 1287, -3525, 996, -5255 },
  { 2297, 803, 1177, -6067 },
  { 187, -180, -619, -6202 },
  { -793, -2537, 1554, -5057 },
  { -2703, -204, -629, -5853 },
  { -1007, -146, 313, -5582 },
  { 830, 357, 869, -6363 },
  { -228, -575, -3177, -4433 },
  { -1001, -1553, -142, -5708 },
  { -1644, 1683, 1721, -4533 },
  { 893, 1924, -15, -5791 },
  { 2195, 2061, -262, -5471 },
  { 3031, 270, 311, -5096 },
  { 1912, 1638, -1523, -4677 },
  { -3142, -55, 253, -4914 },
  { 356, -1680, 343, -6123 },
  { -2241, -1734, -976, -5939 },
  { -2196, -2893, 547, -4938 },
  { -1245, 126, -1916, -5419 },
  { -249, -3755, -1422, -5594 },
  { 575, -2683, -1926, -4566 },
  { -762, 1885, 192, -5880 },
  { -811, -2562, -1068, -6013 },
  { -2264, -3086, -976, -4775 },
  { 70, -1215, 2880, -4410 },
  { 714, -3760, 2916, -4691 },
  { -244, -3404, 1740, -4493 },
  { 684, -5137, -328, -5608 },
  { -529, -3825, -1786, -4535 },
  { -713, -4743, -1118, -5546 },
  { 2718, -3788, 1798, -5708 },
  { -1639, -3679, -1564, -6095 },
  { 1693, -2642, -1389, -4539 },
  { 505, -1573, -1651, -4878 },
  { -835, -2256, -1941, -5352 },
  { 1464, -411, 1993, -6441 },
  { 493, -3184, -145, -6148 },
  { -1413, 499, -1617, -6479 },
  { -294, 1722, -1419, -5725 },
  { -2937, -1528, -175, -4624 },
  { -594, -5911, -56, -6146 },
  { -300, -4275, 1156, -5947 },
  { 552, -2643, 2669, -3959 },
  { 905, -4158, 1789, -5809 },
  { 1336, -2009, 2108, -5903 },
  { 1555, -3600, 1110, -6759 },
  { -1294, -3464, 77, -6084 },
  { -1139, -4006, -1270, -4181 },
  { -5094, -3296, 1092, -2847 },
  { -5503, -2883, 1984, -2067 },
  { -4671, -4218, -1417, -4132 },
  { -3763, -3818, 1262, -3082 },
  { -5132, -3430, 2928, -728 },
  { -5957, -2877, 1251, -2446 },
  { -4425, -2319, -212, -4276 },
  { -6201, -1993, 1774, -2182 },
  { -5500, -3836, 2201, -1396 },
  { -6934, -2334, 2366, -1293 },
  { -6124, -4140, 1337, -1977 },
  { -6553, -4186, 1756, -1325 },
  { -5126, -1258, 744, -3656 },
  { -5167, -1390, 1581, -2895 },
  { -4525, -3398, 2429, -1865 },
  { -4076, -3183, 2027, -2510 },
  { -6191, -3274, 1838, -1814 },
  { -4454, -2753, 2723, -1185 },
  { -6655, -4797, 251, -2595 },
  { -6332, -2232, 1832, 217 },
  { -5869, -1698, 134, 340 },
  { -6614, -1045, 2126, -1932 },
  { -4859, -2107, 2010, -2435 },
  { -6274, -1622, 2808, -1374 },
  { -3119, -3209, 521, -3988 },
  { -5676, -2082, -420, -2711 },
  { -7073, -3623, 696, -2343 },
  { -5986, -4224, 572, -2454 },
  { -4340, -4521, 882, -2771 },
  { -6178, -1933, 535, -1444 },
  { -4923, -4163, 1744, -2066 },
  { -6410, -1519, 1058, -2683 },
  { -5077, -1185, 856, -2216 },
  { -7091, -2444, 687, -2597 },
  { -5284, -2165, 3239, -993 },
  { -4763, -1497, 197, -3179 },
  { -4128, -4958, -396, -3578 },
  { -5054, -3878, -647, -2672 },
  { -7005, -3348, 1679, -1579 },
  { -5767, -1017, 2582, -1915 },
  { -7069, -2787, 1331, -2070 },
  { -5532, -2296, 706, -2950 },
  { -5059, -3543, -821, -3637 },
  { -6639, -1835, 1016, -696 },
  { -5611, -5220, -694, -3371 },
  { -5994, -2803, 2933, -729 },
  { -5948, -619, 1596, -2676 },
  { -5486, -4419, 153, -3265 },
  { -4329, -3440, 1646, -1439 },
  { -4083, -3978, 177, -3569 },
  { -4289, -2599, 1224, -3075 },
  { -5707, -3253, 1912, -759 },
  { -6606, -3437, 2562, -571 },
  { -5254, -2444, 769, -352 },
  { -6545, -3154, 582, -1103 },
  { -5328, -2241, 2566, -1775 },
  { -7216, -1936, 1538, -1983 },
  { -3730, -2451, 426, -3869 },
  { -5110, -1385, 2031, -1169 },
  { -6470, -2715, 269, -3123 },
  { -5806, -2480, -97, -3832 },
  { -3683, -4916, -490, -4330 },
  { -6341, -2083, -669, -115 },
  { -4913, -4079, -837, -4673 },
  { -3274, -2497, 2334, -2652 },
  { -1286, -1731, 2550, -3756 },
  { -3375, -877, 926, -3977 },
  { -2525, -2079, 2879, -2625 },
  { -5308, -504, 3111, -1607 },
  { -4904, 460, 4093, -1232 },
  { -1993, 1616, 4656, -1913 },
  { -3481, -1176, 3119, -2236 },
  { -4132, -1502, 2339, -2545 },
  { -2542, 1151, 3569, -2550 },
  { -4381, 430, 3147, -2082 },
  { -3888, 867, 3899, -1657 },
  { -2861, 1290, 4202, -1979 },
  { -3893, -253, 2363, -2764 },
  { -1705, 688, 3827, -2923 },
  { -2223, 2312, 3700, -3148 },
  { -1986, -720, 5021, -795 },
  { -3177, 242, 1952, -3352 },
  { -1854, 1509, 2528, -3815 },
  { -3173, 97, 5019, -706 },
  { -2689, -145, 1375, -3915 },
  { -4838, -385, 2488, -2427 },
  { -4557, -355, 1603, -3060 },
  { -3522, 1832, 3292, -2674 },
  { -3769, 780, 2378, -2704 },
  { -4323, -1932, 3414, -1169 },
  { -2740, 1158, 2729, -3273 },
  { -3647, 210, 1464, -2892 },
  { -2342, -2097, 1513, -3727 },
  { -4422, -1242, 3130, -1833 },
  { -1308, -1039, 4290, -1875 },
  { -1754, -2535, 3298, -2314 },
  { -4102, -186, 4037, -1094 },
  { -1008, 1570, 3290, 171 },
  { -3322, -2621, 2791, -1536 },
  { -2539, -2597, 3442, -1672 },
  { -3411, -2015, 3670, -1174 },
  { -2097, 730, 5581, -1399 },
  { -1510, -74, 4820, -2004 },
  { -4086, -868, 4425, -771 },
  { -956, -986, 3640, -2925 },
  { -2087, -1250, 3464, -2458 },
  { -3308, -2411, 1334, -3667 },
  { -2264, -389, 4004, -1854 },
  { -680, 239, 4058, -3388 },
  { -1357, 30, 2993, -3658 },
  { -3601, -552, 1177, -1136 },
  { -2641, 442, 4374, -1625 },
  { -2525, 770, 1640, -3895 },
  { -3172, -891, 3893, -1608 },
  { -2996, 13, 3277, -2414 },
  { -899, 1055, 4470, -2501 },
  { -422, -584, 3475, -3787 },
  { -1978, -593, 2566, -3415 },
  { -3150, -1280, 2362, -3047 },
  { -3592, 224, 1026, -3932 },
  { -4840, -1189, 3633, -879 },
  { -3952, -2255, 2916, -1826 },
  { -1695, 28, 1810, -349 },
  { -745, -2484, 3308, -3293 },
  { -1016, 1563, 5365, -1823 },
  { -2172, -1787, 4266, -1287 },
  { -1241, -1951, 3982, -2413 },
  { -2009, -2639, 2330, -3480 },
  { 5105, -1618, -2588, -2015 },
  { 6497, -1523, -3218, -910 },
  { 6526, -2305, -2029, -1790 },
  { 5289, -99, -3436, -400 },
  { 5781, -1623, -1577, -2617 },
  { 5259, -670, -3125, -1700 },
  { 6343, -1256, -331, -3222 },
  { 7967, -678, -2195, -1462 },
  { 6119, -695, -2988, -1538 },
  { 6108, 494, -3359, -1548 },
  { 5067, 969, -2328, -2707 },
  { 7595, -435, -1497, -2056 },
  { 6929, -719, -2420, -1665 },
  { 5190, 584, -2982, -2103 },
  { 6106, -444, -1411, -2739 },
  { 5584, 289, -1804, -2803 },
  { 5276, 227, -1180, -3361 },
  { 7544, -1525, -1834, -1725 },
  { 5986, -1470, -2606, -1701 },
  { 5096, -765, -1712, -3006 },
  { 5423, -149, -3933, -1157 },
  { 7651, 26, -2445, -1507 },
  { 4745, -464, -1735, -2362 },
  { 5352, -1011, -1094, -1999 },
  { 6300, -672, -542, -1950 },
  { 6675, -1020, -1318, -1059 },
  { 7218, -2036, -603, -2462 },
  { 7755, -1514, -2430, -1229 },
  { 5041, 449, -1056, -2405 },
  { 6710, -2277, -1344, -2284 },
  { 6824, -1347, -2254, 251 },
  { 6068, -1857, -983, -1316 },
  { 5603, -2177, -2730, -1477 },
  { 5838, -1059, -3604, -970 },
  { 5076, -789, -335, -2413 },
  { 6191, -1634, -2000, -2129 },
  { 5092, -1292, -2543, -1034 },
  { 5305, 435, -1710, -1850 },
  { 6140, 561, -2176, -2380 },
  { 6752, 348, -2496, -1890 },
  { 6405, 273, -1098, -2778 },
  { 6942, -1340, -496, -1381 },
  { 5238, -687, -2454, -2349 },
  { 6959, -882, -1833, -2061 },
  { 6292, -253, -2125, -2199 },
  { 5838, -574, -759, -3215 },
  { 6954, -1484, -640, -2771 },
  { 7498, -1706, -1210, -2154 },
  { 6772, -1003, -1235, -2532 },
  { 6014, 228, -2154, -1108 },
  { 6943, -2178, -2644, -1122 },
  { 7262, -763, -3056, -1090 },
  { 6273, -1478, -1072, 177 },
  { 4734, 425, -2912, 357 },
  { 7129, 168, -1537, -2327 },
  { 7204, -434, -746, -2660 },
  { 6879, 57, -3087, -1310 },
  { 4623, -610, -718, -3459 },
  { 6565, -543, -1998, -339 },
  { 4752, -277, -2066, -1405 },
  { 7435, -1416, -1904, -505 },
  { 4076, 150, -1222, -3556 },
  { 7082, -28, -1456, -1174 },
  { 5941, -446, -1326, -1158 },
  { 3870, -1648, -2474, -2589 },
  { 858, 37, -3387, -3721 },
  { 3557, -1503, -1664, -3383 },
  { 3336, -1972, -3079, -2216 },
  { 3186, 60, -4185, -863 },
  { 3456, -773, -3066, -2457 },
  { 4131, -913, -2060, -2601 },
  { 4431, -691, -4114, -972 },
  { 3461, -334, -3680, -1751 },
  { 2006, -459, -2214, -3827 },
  { 1322, 32, -2816, -3203 },
  { 4425, -1897, -2791, -1946 },
  { 4504, 23, -3421, -1909 },
  { 3090, -885, -2366, -3264 },
  { 3209, -2363, -3730, -834 },
  { 3312, -1471, -3641, -1579 },
  { 4184, -1669, -3323, -1248 },
  { 2190, -931, -3302, -2944 },
  { 2947, -229, -4791, -1195 },
  { 2020, -1626, -2700, -3125 },
  { 2214, -326, -4352, -1683 },
  { 3286, -2619, -2412, -2458 },
  { 1000, -2571, -4129, -2158 },
  { 2496, -2627, -3611, -1433 },
  { 2043, -2191, -2167, -3827 },
  { 2571, -2544, -1915, -3222 },
  { 2022, -1501, -3856, -2165 },
  { 2685, -1180, -1461, -4038 },
  { 1610, -2313, -4391, -1173 },
  { 2340, -2490, -4215, -516 },
  { 1742, -2615, -3632, -2146 },
  { 523, -1293, -4246, -2442 },
  { 3725, -2723, -3014, -1576 },
  { 3554, -1381, -4200, -824 },
  { 1291, -1594, -4777, -1430 },
  { 1452, 515, -2960, -3830 },
  { 4264, -894, -3305, -1826 },
  { 2606, -1452, -4522, -966 },
  { 1196, -830, -4807, -1816 },
  { 1054, -775, -2616, -4071 },
  { 4206, 415, -4344, -1132 },
  { 3044, 491, -4126, -1934 },
  { 988, -901, -3353, -3443 },
  { 1729, -3063, -2267, -3370 },
  { 3915, 912, -2989, -2387 },
  { 3781, 300, -2457, -3050 },
  { 2712, 924, -1350, -1206 },
  { 4230, 405, -2343, 665 },
  { 1878, -873, -225, -29 },
  { 3510, 56, -1334, -3420 },
  { 2850, 1447, -2651, -3150 },
  { 1510, -706, -4125, -2483 },
  { 3115, 793, -1692, -3894 },
  { 2667, 213, -2973, -2786 },
  { 1184, -2384, -3051, -3173 },
  { 2139, 796, -2079, -3697 },
  { 1464, -1483, -3726, -2754 },
  { 2407, -1148, -3915, -1569 },
  { 2612, -1779, -3217, -2271 },
  { 2406, -2870, -2937, -2496 },
  { 2140, 126, -3646, -2758 },
  { 2952, -1036, 268, -1423 },
  { 93, -1931, -3841, -3535 },
  { 389, -2953, -3383, -3343 },
  { 8652, -5511, -1662, 565 },
  { 7427, -2791, -2535, -842 },
  { 8541, -4253, -1407, -988 },
  { 8018, -3203, -2998, 105 },
  { 7231, -3926, -958, 1308 },
  { 7331, -3690, -363, 2586 },
  { 6803, -3646, -2226, -903 },
  { 8163, -2811, -477, -2235 },
  { 9356, -3818, -1685, -684 },
  { 8466, -2854, -302, -698 },
  { 8458, -3224, 517, 279 },
  { 8074, -2619, -1326, 2596 },
  { 8779, -2761, -2527, -441 },
  { 6533, -2887, -899, -696 },
  { 7394, -2305, -1642, -120 },
  { 8281, -3780, -22, 1305 },
  { 9158, -4413, -779, 901 },
  { 9031, -5240, -1109, 1678 },
  { 8717, -3650, 410, -1075 },
  { 7317, -3197, -818, -2264 },
  { 7934, -2385, -1214, -1886 },
  { 8256, -4441, -291, -587 },
  { 7358, -3395, 1090, -270 },
  { 9446, -4910, -1343, -473 },
  { 8187, -4726, -808, 1166 },
  { 7504, -3845, -47, 267 },
  { 8029, -2146, -1283, -383 },
  { 7461, -2705, -853, 783 },
  { 9367, -3636, -645, -354 },
  { 8955, -3473, -308, -1947 },
  { 8676, -2683, -2099, 1485 },
  { 7481, -3003, -871, -444 },
  { 8015, -2839, -1673, 1175 },
  { 6947, -4643, -1527, -1047 },
  { 7622, -2575, -137, -960 },
  { 9388, -4279, -707, -1322 },
  { 8382, -5259, -1283, -565 },
  { 6856, -4138, -1030, 630 },
  { 8659, -2571, -1124, -1666 },
  { 8763, -3807, -537, 2543 },
  { 8049, -3578, -2186, -604 },
  { 8272, -2351, -1985, -1214 },
  { 6855, -3796, -1527, -1631 },
  { 7178, -2896, -1600, -1756 },
  { 7040, -2888, -89, -1586 },
  { 6261, -3403, -264, 998 },
  { 7756, -4699, -1543, -834 },
  { 7682, -4622, -758, -1721 },
  { 8839, -4232, -2932, 1959 },
  { 9363, -4679, -1956, 39 },
  { 7883, -3616, -1414, -1432 },
  { 8828, -3188, -1356, -1312 },
  { 7746, -3987, -121, -2424 },
  { 9262, -3256, -693, 818 },
  { 7670, -3420, -148, 3504 },
  { 7344, -3183, 608, 1595 },
  { 8976, -4139, -1848, 1304 },
  { 6708, -4131, 33, -852 },
  { 7840, -4429, -2275, 79 },
  { 8980, -3858, -2838, 453 },
  { 7815, -4604, -2563, 944 },
  { 8372, -4422, -1783, 3071 },
  { 8623, -5128, -1754, 2888 },
  { 7462, -3281, 889, 920 },
  { 8416, -59, -1320, -1825 },
  { 7928, -1488, -414, -2499 },
  { 8110, -977, -1047, -2042 },
  { 8278, -687, -1597, -1550 },
  { 7988, -174, -977, -2106 },
  { 8609, -1547, -1628, -1527 },
  { 9000, -1798, -946, -1761 },
  { 8954, -872, -1404, -1594 },
  { 8939, 466, -748, -1212 },
  { 9549, -329, -177, -1360 },
  { 9411, -18, -1126, -1568 },
  { 8859, -782, -488, -1338 },
  { 8955, -218, -43, -1209 },
  { 9131, -69, -453, -1001 },
  { 9069, -1519, -1091, -1199 },
  { 9247, -1309, -566, -1146 },
  { 8528, -1617, -287, -1313 },
  { 7763, -745, -149, -2040 },
  { 8294, -343, 257, -2633 },
  { 10149, -893, -552, -1649 },
  { 9398, -915, 218, -2042 },
  { 9703, -1194, -675, -1592 },
  { 9586, -700, -427, -1710 },
  { 8930, 497, -1445, -1218 },
  { 9285, -1323, -163, -1552 },
  { 8431, -1289, -985, -1404 },
  { 8965, -655, 653, -1483 },
  { 9542, -1001, -951, -1128 },
  { 9205, -647, -37, -882 },
  { 8603, -56, 514, -1793 },
  { 9300, -12, -1324, -567 },
  { 8773, 238, -184, -1456 },
  { 9941, -1306, -69, -1792 },
  { 9360, 279, -376, -1919 },
  { 9180, -285, 95, -2170 },
  { 9922, -501, -970, -1570 },
  { 8341, -1493, -856, -2092 },
  { 8780, -981, -850, -1014 },
  { 9721, -548, -1504, -1094 },
  { 9973, -1493, 482, -2105 },
  { 8707, -333, -1027, -1087 },
  { 9098, -469, -315, -1723 },
  { 8879, -1050, -661, -2020 },
  { 8857, 602, -866, -1918 },
  { 8945, -1025, -2154, -1071 },
  { 8484, -1930, -468, -2179 },
  { 9177, -1903, -224, -2112 },
  { 8652, -137, -2097, -1214 },
  { 9063, -973, -1405, -772 },
  { 9328, -456, 662, -2469 },
  { 10101, -697, 127, -2113 },
  { 9685, 811, -2359, -1024 },
  { 8586, -94, -460, -1982 },
  { 7924, -141, -509, -2513 },
  { 7773, -669, -107, -2835 },
  { 8636, -1064, -46, -2409 },
  { 9748, 596, -1815, -1349 },
  { 8924, 304, 547, -2614 },
  { 9442, 746, -1153, -1679 },
  { 9454, -278, -529, -1976 },
  { 8488, 561, -32, -2160 },
  { 10083, -63, -1544, -1364 },
  { 9390, -1278, 568, -1131 },
  { 9740, -49, -2253, -910 },
  { 3636, -2391, -1115, -3614 },
  { 6014, -3204, -1902, -1808 },
  { 5787, -3497, -1116, -2590 },
  { 4365, -3046, -1632, -2668 },
  { 4733, -2192, -2029, -2468 },
  { 5412, -2753, -1633, -2464 },
  { 4455, -3375, -767, -3399 },
  { 4456, -1644, -983, -2841 },
  { 4039, -2523, 38, -3967 },
  { 3406, -2662, 72, -4757 },
  { 4279, -2005, 1055, -4399 },
  { 4321, -1377, -860, -3786 },
  { 3743, -5739, -651, -3047 },
  { 3528, -5510, 361, -4060 },
  { 6496, -4886, -136, -2689 },
  { 4513, -5254, 551, -4010 },
  { 6557, -3413, -92, -3063 },
  { 4186, -2059, 187, 47 },
  { 6210, -4117, -1256, -1985 },
  { 6038, -4343, 351, -2124 },
  { 4305, -4780, -2077, -1897 },
  { 4480, -3815, -2228, -1533 },
  { 5582, -3689, 1221, -3429 },
  { 5532, -4874, 1195, -2765 },
  { 6518, -2853, -905, -2568 },
  { 5467, -2192, 470, -4115 },
  { 4139, -1577, 240, -3493 },
  { 5281, -1926, -729, -3340 },
  { 5214, -2870, 1359, -4289 },
  { 3046, -3510, -1536, -3214 },
  { 5433, -2881, -1230, -1184 },
  { 4861, -3932, -1071, -2791 },
  { 5693, -4234, -1906, -1502 },
  { 4004, -3935, -1804, -2383 },
  { 3728, -3792, 681, -4773 },
  { 3621, -3030, -1951, -2598 },
  { 5133, -3903, 44, -3700 },
  { 3561, -3451, 1183, -5301 },
  { 5026, -2762, -2341, -1780 },
  { 5841, -2492, -467, -3210 },
  { 5591, -1791, 497, -2472 },
  { 5054, -3898, -1822, -2097 },
  { 5813, -2792, 83, -1469 },
  { 4432, -4497, 1670, -5193 },
  { 5338, -4653, -1109, -2200 },
  { 3239, -4401, -648, -3655 },
  { 2147, -3598, -1200, -4242 },
  { 4417, -2271, -1552, -3210 },
  { 6494, -4360, 852, -3565 },
  { 2393, -6358, -856, -4524 },
  { 4959, -4196, -847, -1403 },
  { 4924, -5438, -226, -3026 },
  { 4254, -5303, -1306, -2424 },
  { 4121, -3126, -2334, -1981 },
  { 3437, -4443, -1464, -2953 },
  { 3203, -3459, -529, -4339 },
  { 5896, -5945, 543, -3246 },
  { 1987, -4733, -220, -4863 },
  { 4358, -4431, -514, -3081 },
  { 4583, -2416, -492, -2287 },
  { 2943, -5035, 419, -4927 },
  { 5358, -5129, 987, -4309 },
  { 4460, -3392, 1752, -5634 },
  { 3415, -4633, 1507, -5945 },
  { 811, -4692, -445, 2333 },
  { 1009, -5613, -1857, 1360 },
  { 1338, -2712, -2720, 3036 },
  { 1002, -3754, -2582, 2344 },
  { 750, -4608, -2334, 714 },
  { 2043, -3207, -2822, 2173 },
  { -140, -4654, -2953, 357 },
  { -54, -4026, -2376, 2695 },
  { 1858, -5022, -717, 2287 },
  { 2064, -3894, -722, 3255 },
  { 2727, -4558, -332, 2603 },
  { 1810, -5378, 283, 1826 },
  { 3935, -4326, 762, 3383 },
  { -767, -4697, -2510, 1922 },
  { 2146, -4312, -3090, 1641 },
  { 54, -5881, -2114, 921 },
  { 1992, -5766, -640, 1574 },
  { 1200, -5371, -1114, 1828 },
  { 2973, -5337, 34, 2266 },
  { 1531, -5018, -2817, 1192 },
  { 3078, -4570, 117, 1990 },
  { 924, -4286, -1388, 2713 },
  { 142, -5058, -2848, 1487 },
  { -106, -6180, -881, 842 },
  { 673, -5433, -229, 1596 },
  { 783, -5710, -2784, 562 },
  { 1935, -5729, -2009, 856 },
  { -410, -3375, -3326, 2734 },
  { 234, -3000, -2628, 3260 },
  { 733, -3405, -3806, 1589 },
  { 771, -4285, -3544, 1314 },
  { 1192, -3563, -3960, 2178 },
  { 206, -5555, -1250, 1546 },
  { -130, -3815, -1210, 3041 },
  { 646, -3940, -393, 2992 },
  { -184, -4931, -1767, 1925 },
  { 2746, -5120, -2275, 1464 },
  { 2440, -3731, -3352, 2729 },
  { -490, -4942, -3779, 997 },
  { 68, -2636, -4167, 3778 },
  { 48, -3986, -4118, 2106 },
  { -978, -5486, -1336, 1390 },
  { 1126, -5297, -855, 640 },
  { -472, -3975, -3622, 1557 },
  { 2456, -5344, -1523, 1648 },
  { -774, -5652, -2417, 1147 },
  { 995, -6122, -812, 1132 },
  { 3282, -4571, -1763, 2175 },
  { 3655, -3862, -676, 3568 },
  { 3038, -3647, -1672, 3381 },
  { 2595, -2964, -2772, 3263 },
  { 4176, -3353, -1148, 4354 },
  { 1603, -3442, -1500, 3444 },
  { 828, -6226, -1783, 678 },
  { 1421, -3333, -3080, 3403 },
  { 1121, -4727, -1924, 1984 },
  { -186, -5083, -682, 1796 },
  { 819, -2778, -3488, 530 },
  { 421, -2873, -3832, 2596 },
  { 2164, -4263, -1605, 2282 },
  { 585, -4437, -682, -491 },
  { -644, -4452, -1157, 2325 },
  { 1991, -4299, 210, 2834 },
  { 2135, -3632, -2113, 665 },
  { -7482, -2724, -2662, -1380 },
  { -6983, -2166, -3756, -3509 },
  { -7085, -1439, -2397, -3112 },
  { -7760, -3049, -3319, -2822 },
  { -8413, -2760, -4406, -3298 },
  { -5995, -3943, -1260, -3750 },
  { -7879, -1554, -3464, -2606 },
  { -6314, -2034, -3878, -1681 },
  { -8849, -2084, -1399, -1231 },
  { -7153, -2602, -1384, -817 },
  { -8041, -2571, -407, -2785 },
  { -7246, -2233, -1578, 260 },
  { -7336, -3883, -4061, -1342 },
  { -7619, -3908, -2342, 382 },
  { -8684, -3724, -1662, -727 },
  { -7850, -2922, -1770, -3449 },
  { -6766, -2034, -1293, -1988 },
  { -6895, -2116, -968, -3744 },
  { -7136, -5147, -2618, -2809 },
  { -8224, -3724, -2519, -1589 },
  { -6711, -2750, -3021, -219 },
  { -8059, -1638, -1102, -3175 },
  { -8710, -4839, -3963, -3143 },
  { -9363, -4965, -3257, -1002 },
  { -6099, -1751, -3157, -395 },
  { -6453, -3216, -4597, -483 },
  { -7879, -5477, -839, -2638 },
  { -7202, -4038, -526, -2856 },
  { -8022, -1228, -1910, -1646 },
  { -9117, -1393, -1582, -2535 },
  { -9095, -2693, -636, -2605 },
  { -9076, -2580, -3481, -2519 },
  { -8327, -4859, -2422, 83 },
  { -8368, -2129, -2324, -2173 },
  { -8554, -4563, -3842, -2007 },
  { -10462, -4261, -1934, -2084 },
  { -9717, -3187, -2294, -1896 },
  { -9625, -3889, -3020, -3224 },
  { -9857, -4955, -4239, -2184 },
  { -9752, -2351, -2277, -3129 },
  { -7219, -1302, -2639, -1603 },
  { -7477, -4360, -3718, -559 },
  { -5680, -2033, -2326, -3078 },
  { -10190, -5548, -4643, -3601 },
  { -9431, -4121, -879, -2479 },
  { -8365, -5450, -2020, -1439 },
  { -6289, -5178, -1605, -3845 },
  { -8319, -3866, -687, -2792 },
  { -8131, -1031, -3608, -3947 },
  { -10510, -2560, -1199, -2082 },
  { -11015, -3640, -2748, -3041 },
  { -8762, -5022, -5231, -1162 },
  { -10153, -2715, -4648, -4859 },
  { -7930, -5205, -1900, -3600 },
  { -9561, -3548, -4812, -3722 },
  { -7663, -4709, -1180, -1475 },
  { -9073, -5707, -1815, -2980 },
  { -8602, -2363, -2675, -3770 },
  { -9967, -5614, -3575, -3838 },
  { -8324, -1005, -2131, -3254 },
  { -10331, -5737, -2550, -2940 },
  { -8234, -3354, -3361, -4479 },
  { -8140, -1951, -4526, -4545 },
  { -6679, -2662, -2284, -4182 },
  { -1122, -1514, -6427, -212 },
  { 54, -1660, -5424, -1404 },
  { 254, -2778, -5222, 846 },
  { -267, -1661, -6577, 814 },
  { -305, -2021, -5759, 1484 },
  { -1791, -2446, -6867, -86 },
  { -2929, -3158, -6603, -1799 },
  { -1391, -3189, -5557, -1053 },
  { -1602, -884, -6767, -1213 },
  { -361, -318, -6219, -44 },
  { -4078, -2635, -5523, -433 },
  { -956, 478, -4382, 1470 },
  { -3300, -2462, -6021, -2721 },
  { 708, -2434, -5085, -540 },
  { -2435, -3607, -5647, -2110 },
  { -491, -1134, -4681, -2886 },
  { 87, -3435, -4641, -1194 },
  { -586, -2927, -4784, 366 },
  { -1394, -2326, -6021, 350 },
  { 97, -2519, -4678, -2120 },
  { -1547, -1907, -5069, -2993 },
  { 268, -3724, -4719, 127 },
  { -827, -1190, -5912, 1144 },
  { -3959, -2322, -6898, -1974 },
  { -2728, -2228, -6426, -562 },
  { -456, -666, -5785, -1609 },
  { 531, -1096, -5731, -656 },
  { -3569, -688, -3915, 110 },
  { -4752, -1725, -4393, -377 },
  { -3210, -3315, -6960, -840 },
  { -688, -3416, -4971, 1221 },
  { -1833, 77, -6491, -2434 },
  { -239, -255, -6850, -886 },
  { -2112, -1490, -6291, -2689 },
  { -1544, -4579, -5198, -1261 },
  { -2771, -4014, -5520, 683 },
  { -1635, -2829, -5512, 1214 },
  { -958, -2582, -4823, 2360 },
  { -2077, -4566, -4642, 365 },
  { -3112, -4214, -5960, -823 },
  { -2467, -2510, -4858, 1467 },
  { -1561, -3399, -5822, 211 },
  { -775, -1081, -4424, 2636 },
  { -1263, 25, -6378, -1392 },
  { -3476, -366, -5417, -1393 },
  { -3176, -1476, -4149, 1466 },
  { -2479, 518, -4448, -257 },
  { -2992, 158, -4660, -1279 },
  { -1320, -3872, -4479, 1147 },
  { -1475, -312, -5318, 539 },
  { -3527, -1679, -5860, -1681 },
  { -3397, -3438, -5593, 1866 },
  { -4089, -2439, -4763, 1275 },
  { -748, -4513, -4687, -48 },
  { -2166, -4531, -4691, -2856 },
  { -2385, -853, -6035, -627 },
  { -1194, -4091, -4472, -1963 },
  { -682, -3234, -4084, -3033 },
  { -3255, -5015, -5328, -12 },
  { -2313, -3436, -4601, -155 },
  { -2792, -1038, -6947, -2019 },
  { -1244, -1526, -5771, -1882 },
  { -4679, -3731, -5506, 283 },
  { -3062, -66, -3558, -758 },
  { -4895, -1187, 4751, 3728 },
  { -7600, -2752, 3320, 4613 },
  { -5703, -2975, 3944, 2659 },
  { -4972, -1257, -246, 2952 },
  { -4221, -2487, 1702, 4295 },
  { -2900, -1529, 2458, 4935 },
  { -5061, 407, 2416, 4050 },
  { -6931, -3478, 2761, 2213 },
  { -6037, -3921, 3192, 1866 },
  { -6113, -811, 2407, 3782 },
  { -5878, -1716, 1207, 3478 },
  { -5953, -2853, 2207, 2712 },
  { -6807, -3223, 2749, 3595 },
  { -3272, -3157, 1389, 3788 },
  { -5368, -1904, 1980, 5077 },
  { -7235, -1398, 3075, 4548 },
  { -4765, -3487, 2755, 2796 },
  { -7658, -4435, 2694, 2582 },
  { -6997, -4282, 456, 3832 },
  { -5563, -3115, -63, 3713 },
  { -4244, -4220, 1450, 2767 },
  { -3801, -2194, 190, 4303 },
  { -5458, -4119, 1958, 2274 },
  { -7300, -3469, 3514, 3193 },
  { -4594, -2067, 775, 4752 },
  { -3389, -1654, 1464, 5412 },
  { -4845, -3483, 964, 3437 },
  { -6007, -2818, 1666, 4659 },
  { -8709, -5007, 1757, 3287 },
  { -5833, -4389, 1025, 3171 },
  { -5788, -1780, 3944, 3661 },
  { -4430, -920, 1938, 4753 },
  { -7066, -1857, 4591, 4538 },
  { -3549, -513, 1427, 5317 },
  { -7517, -1220, 2883, 3049 },
  { -7605, -2687, 1874, 2735 },
  { -8718, -4035, 2676, 3730 },
  { -7990, -3907, 1185, 2607 },
  { -6058, -1744, 3349, 5157 },
  { -5954, 565, 3161, 3250 },
  { -6478, -612, 1930, 2271 },
  { -6535, -1445, -2, 1618 },
  { -8963, -4151, 1192, 4044 },
  { -7227, -3570, 1600, 4234 },
  { -4674, 79, 595, 3015 },
  { -3974, 430, 2727, 5137 },
  { -5299, 9, 3714, 4779 },
  { -6779, -2699, -8, 2436 },
  { -7016, -1145, 1293, 2310 },
  { -6955, -3312, 1534, 1801 },
  { -4025, 740, 1850, 4054 },
  { -9589, -3460, 4154, 5270 },
  { -4404, -1181, 4298, 5173 },
  { -7356, -4583, -18, 2644 },
  { -6516, -1235, 4439, 6234 },
  { -3453, -301, 4344, 4464 },
  { -4643, 1530, 3315, 4340 },
  { -4575, -2557, 3754, 3682 },
  { -3643, -3501, 2051, 2997 },
  { -5412, -2475, 2301, 1579 },
  { -5846, 259, 1360, 2348 },
  { -5258, -1358, 1050, 838 },
  { -5542, -219, 6377, 5750 },
  { -5713, -2952, 922, 899 },
  { -2049, -1135, 5206, 1033 },
  { -1693, -1886, 4835, -106 },
  { -2344, -3504, 4232, -13 },
  { -2475, -2334, 5043, 1126 },
  { -787, -2549, 3880, 2138 },
  { -3159, -2341, 4830, 2887 },
  { -1780, -1009, 6240, 2061 },
  { -4327, -3363, 2818, 886 },
  { -3376, -2743, 4104, 207 },
  { -3250, -4640, 2718, 1498 },
  { -382, -1075, 4382, 3460 },
  { -2416, -4168, 3530, 816 },
  { -1756, -2708, 4861, 622 },
  { -1879, -2097, 5156, 2889 },
  { -2496, -2418, 3722, 2671 },
  { -2717, -3252, 3341, 1944 },
  { -4063, -4091, 3306, 267 },
  { -3549, -3808, 3747, 842 },
  { -2635, 546, 5794, 1894 },
  { -1857, -1121, 4383, 3964 },
  { -2226, -2166, 3489, 3678 },
  { -3492, -660, 5323, 1063 },
  { -3033, -3130, 4382, 1828 },
  { -2703, -625, 6369, 2851 },
  { -1656, -2842, 4584, -528 },
  { -4781, -2622, 4390, 2097 },
  { -413, -2045, 5081, 3035 },
  { -3810, -2662, 4532, 1095 },
  { -3144, -1858, 5215, 1880 },
  { -3562, -1795, 4928, 670 },
  { -4800, -1509, 5189, 1859 },
  { -1085, -3832, 4169, 900 },
  { -1969, -3270, 2857, 2878 },
  { -4267, -4140, 3176, 1805 },
  { -5145, -3727, 3524, 1168 },
  { -1346, -1876, 5501, 1748 },
  { -4998, -2945, 3699, 338 },
  { -3458, -3096, 3406, -635 },
  { -1751, -3209, 3508, 395 },
  { -2507, 170, 5987, 705 },
  { -3756, -1072, 5647, 3536 },
  { -2870, -1439, 5026, 3212 },
  { -3913, -3225, 3669, 2144 },
  { -3739, 226, 5747, 764 },
  { -2052, -820, 5266, 3093 },
  { -3214, -3820, 2409, 2391 },
  { -4398, -2588, 3501, -218 },
  { -4484, -1763, 4180, -198 },
  { -3368, -1525, 4362, -134 },
  { -2407, 224, 4905, 3533 },
  { -1369, -2937, 4728, 1788 },
  { -4848, -1707, 4159, 851 },
  { -3454, -1749, 4281, 3230 },
  { -1990, -3853, 3487, 1735 },
  { -3117, 92, 6155, 4075 },
  { -2676, -2472, 4078, -589 },
  { -1547, -2012, 2626, 1835 },
  { -4275, -588, 4824, 725 },
  { -601, -2249, 3736, 3548 },
  { -4060, -61, 5333, 3097 },
  { -4303, 7, 6551, 3054 },
  { -5003, -1029, 5786, 3319 },
  { -2810, -728, 5392, 199 },
  { -1232, -200, 5228, 3121 },
  { 2621, 165, -6255, 298 },
  { 3669, 537, -6844, 1564 },
  { 1598, -1190, -6235, 2523 },
  { 2164, -32, -6894, 1383 },
  { 853, -1597, -6069, 1449 },
  { 1377, -1661, -5266, 108 },
  { 2660, 48, -5172, -517 },
  { 1903, -391, -5677, 1010 },
  { 3792, 206, -5274, -11 },
  { 1239, 2776, -2929, 2721 },
  { 4071, 149, -7259, 3125 },
  { 1436, -480, -6156, -196 },
  { 1373, -1960, -5005, 3122 },
  { 3413, -1271, -5176, 3283 },
  { 3060, -68, -6495, 2238 },
  { 2700, -2075, -4681, 91 },
  { 2928, -1728, -5168, 1858 },
  { 4424, 828, -4471, 88 },
  { 2672, -2604, -4038, 2753 },
  { 5223, -123, -6749, 2295 },
  { 4237, -420, -5538, 1353 },
  { 4744, -1281, -4097, 4708 },
  { 1103, -2764, -4751, 2024 },
  { 3747, -1913, -3911, 3960 },
  { 2470, -1416, -5542, 615 },
  { 4847, -1354, -5334, 1733 },
  { 5336, 88, -7593, 4007 },
  { 2388, -2880, -4807, 1037 },
  { 4495, 1391, -5685, -139 },
  { 5253, 1637, -6450, 1533 },
  { 1199, 795, -5515, 1261 },
  { 1397, -1259, -4252, 3838 },
  { 746, 70, -6640, 604 },
  { 1584, 166, -4972, 3072 },
  { 380, -999, -5397, 2267 },
  { 2974, 1707, -3242, 5360 },
  { 5202, -403, -5453, 2832 },
  { 3718, -1731, -4760, 714 },
  { 4150, -975, -4792, 61 },
  { 2925, -818, -4841, 15 },
  { 5301, 577, -4006, 3259 },
  { 5265, 1986, -5679, 3028 },
  { 3752, 1928, -4509, 3729 },
  { 3278, 1925, -6370, 1247 },
  { 5107, 1721, -4853, 3127 },
  { 3279, 2982, -2515, 4005 },
  { 4622, 668, -6204, 759 },
  { 6034, 317, -5763, 4818 },
  { -558, 57, -3785, 2817 },
  { 4476, 1616, -3965, 4536 },
  { 5953, 2056, -8215, 2715 },
  { 4387, 2613, -7463, 868 },
  { 5834, 1088, -4736, 4924 },
  { 6473, -856, -6991, 4172 },
  { 4959, -293, -5162, 76 },
  { 2731, -843, -6119, 3847 },
  { 3245, 1202, -6833, 616 },
  { 2553, 1383, -3829, 3859 },
  { 4332, 2099, -3480, 3622 },
  { 2110, 2683, -2728, 3990 },
  { 876, 1167, -3290, 3466 },
  { 3991, 1709, -2410, 4077 },
  { 5105, 939, -2584, 3256 },
  { 4719, 688, -1566, 3040 },
  { -3632, 4335, 1266, -3303 },
  { -4956, 3207, 1312, -2806 },
  { -4669, 2627, 2663, -2435 },
  { -4282, 3708, 2303, -3038 },
  { -4536, 2297, -175, -3350 },
  { -5234, 2503, -139, -880 },
  { -3978, 1512, 1092, -3619 },
  { -4519, 4649, 1363, -2455 },
  { -5118, 3132, 1961, -1577 },
  { -5196, 3379, -182, -1378 },
  { -6420, 4486, 2397, -1993 },
  { -5030, 5046, 1292, -1118 },
  { -4559, 2573, -927, -1406 },
  { -3501, 3730, 691, -4930 },
  { -4364, 2758, 1007, -3909 },
  { -4026, 2839, -1559, -2340 },
  { -5037, 4053, 836, -1571 },
  { -4727, 5136, 1110, -3588 },
  { -5245, 2799, -999, -2164 },
  { -4954, 1501, 422, -3963 },
  { -5994, 2726, 1462, -2833 },
  { -5621, 5159, 2038, -2512 },
  { -4991, 2291, 1917, -3151 },
  { -5469, 4382, -148, -2978 },
  { -5858, 1983, 807, -2720 },
  { -4709, 3556, 952, -467 },
  { -2489, 2362, 1714, -4230 },
  { -4717, 5004, -1180, -3672 },
  { -5914, 3653, 1359, -1317 },
  { -5506, 2995, 780, -1059 },
  { -5287, 3945, 2480, -2293 },
  { -3849, 4358, 322, -1770 },
  { -3911, 3570, 252, -3185 },
  { -3660, 5128, 158, -3719 },
  { -4599, 3277, -503, -2727 },
  { -3673, 3760, -1252, -3339 },
  { -5161, 2337, 388, -1943 },
  { -3529, 2216, 2156, -3080 },
  { -4309, 4331, 1808, -1460 },
  { -4782, 3820, 480, -2504 },
  { -4166, 3544, -378, -1567 },
  { -5572, 2466, -418, -2909 },
  { -6096, 2930, 119, -1878 },
  { -5963, 3554, 1011, -2233 },
  { -6433, 4335, 935, -2930 },
  { -5004, 3314, -1352, -3430 },
  { -6042, 3463, -1008, -3940 },
  { -4671, 2214, -640, -5040 },
  { -2795, 3759, 1412, -3803 },
  { -3647, 4436, 729, -515 },
  { -3594, 1033, 56, -4148 },
  { -2908, 3027, 2889, -3485 },
  { -3338, 2234, 313, -4285 },
  { -3825, 4497, -561, -2634 },
  { -6167, 3012, -48, -3149 },
  { -4828, 3515, -969, -4475 },
  { -5789, 2757, -539, -4173 },
  { -2452, 3067, 564, -4249 },
  { -4921, 1358, 1331, -2889 },
  { -3127, 4239, -1045, -1523 },
  { -4780, 2326, -1118, -3446 },
  { -3908, 5546, 152, -2622 },
  { -6972, 2976, 337, -2809 },
  { -4839, 4613, -35, -4077 },
  { -1408, 4822, -1149, -4997 },
  { -981, 4979, -912, -6304 },
  { -2098, 5689, -888, -2878 },
  { -3343, 4814, -657, -4434 },
  { -2461, 3601, -967, -4869 },
  { -2652, 3944, 87, -5520 },
  { -1104, 6076, 174, -6407 },
  { 355, 5370, -1721, -5869 },
  { 1242, 4497, -1107, -5091 },
  { -89, 4002, -1491, -5182 },
  { 1059, 5693, -1591, -4905 },
  { 1323, 4682, -2078, -4768 },
  { 818, 3996, -549, -5468 },
  { -287, 4529, 929, -5543 },
  { -919, 5519, -2791, -2844 },
  { -1407, 5679, -3289, -3974 },
  { -189, 6530, -3547, -4002 },
  { -900, 7039, -3371, -4855 },
  { -2983, 7211, -363, -4835 },
  { -814, 6503, -104, -5106 },
  { -2386, 6896, 809, -4919 },
  { 845, 4492, 352, -6621 },
  { -1998, 7237, -1646, -4231 },
  { -3380, 6251, 471, -4577 },
  { -1908, 7059, 84, -5726 },
  { -340, 6346, -803, -6265 },
  { -2279, 5834, -47, -4633 },
  { -1532, 5286, -1748, -1901 },
  { -2757, 6188, -453, -3415 },
  { -1255, 6405, -2043, -6357 },
  { 918, 5581, -121, -5667 },
  { 1840, 5336, -821, -5034 },
  { -2475, 4992, -1825, -3104 },
  { -2413, 5606, -1789, -4298 },
  { 132, 5128, -2389, -4442 },
  { 223, 6400, -2653, -4742 },
  { -673, 5012, 680, -4582 },
  { -1657, 6624, -349, -3596 },
  { -755, 6289, -1860, -3978 },
  { -572, 6894, -1946, -5207 },
  { -1141, 4756, -2665, -5586 },
  { -1073, 4269, -431, -4030 },
  { 186, 5761, 916, -5868 },
  { -1907, 4836, 1017, -5106 },
  { -963, 3363, -1248, -6348 },
  { -3262, 4774, -1818, -5858 },
  { 847, 3812, -2538, -4302 },
  { -1223, 5903, 1360, -5479 },
  { -1094, 6923, -1244, -2381 },
  { 267, 6276, -709, -2846 },
  { -157, 5840, 1124, -4266 },
  { 889, 3206, -910, -5305 },
  { -1736, 3344, 582, -4838 },
  { -2357, 5676, -2695, -6277 },
  { -1916, 6901, -986, -5397 },
  { -3062, 6028, -695, -5687 },
  { 1836, 3566, -1357, -5226 },
  { -2176, 4938, 646, -3872 },
  { -2199, 3055, -208, -6124 },
  { -236, 3032, -821, -5325 },
  { -3989, 7277, -565, -3899 },
  { -595, 4362, 74, -5975 },
  { 684, 5874, -841, -4424 },
  { -2731, 6305, -2389, -5465 },
  { -5775, 1325, -56, -2528 },
  { -7029, -534, -1890, -3278 },
  { -5798, -15, -2734, -2210 },
  { -5504, -1198, -353, -3659 },
  { -5079, 960, -894, -4336 },
  { -6073, -36, -133, -3014 },
  { -5782, -259, -1025, -3986 },
  { -6843, 1262, -807, -1639 },
  { -5263, -918, -3290, -579 },
  { -4840, 461, -2158, -533 },
  { -6014, -50, -620, 504 },
  { -5843, 241, -1359, -282 },
  { -5898, 577, 769, -3271 },
  { -6833, -946, -466, -3347 },
  { -6026, 1459, -512, -729 },
  { -7361, 747, -388, -1110 },
  { -6391, 2142, -1160, -2513 },
  { -6995, 304, 498, -2673 },
  { -6757, 679, -386, -433 },
  { -5222, 1688, -1093, -1032 },
  { -5019, 575, 184, -3627 },
  { -4237, 628, -3507, -1243 },
  { -7479, -456, -1722, -1486 },
  { -6464, 713, -1273, -1153 },
  { -6255, 1682, -606, -3607 },
  { -7033, 1497, -71, -1955 },
  { -6694, 1556, -1721, -3214 },
  { -6114, -356, 813, -2575 },
  { -5308, 632, -1851, -1636 },
  { -5742, -911, -1733, 383 },
  { -6083, -387, -2313, -879 },
  { -6535, -530, -1505, -2083 },
  { -4896, 1223, -2750, -1816 },
  { -6392, -463, -3247, -2093 },
  { -5373, 1264, -2706, -3042 },
  { -3894, -1390, -1020, -891 },
  { -6179, 1168, -1966, -1922 },
  { -5162, 1668, -1617, -1916 },
  { -6453, 920, -1169, -2432 },
  { -6130, 2005, -536, -1519 },
  { -6552, -98, -518, -1938 },
  { -7528, 355, -1101, -1772 },
  { -5745, 610, -247, -1360 },
  { -7003, 177, -2064, -1958 },
  { -6956, -570, -2220, -4225 },
  { -7830, 791, -1394, -2774 },
  { -7634, 480, -3171, -4224 },
  { -7913, 1154, -350, -2381 },
  { -5063, 1704, -1804, -2977 },
  { -4887, -524, -2703, 188 },
  { -5551, 406, -1620, -3063 },
  { -7109, 1342, 381, -3021 },
  { -6846, 631, -458, -3398 },
  { -4606, -605, 11, -3930 },
  { -8134, -225, -1738, -2648 },
  { -7043, 402, -2734, -3059 },
  { -7417, 1825, -2545, -4389 },
  { -6971, -236, -1031, -665 },
  { -5752, 2111, -1632, -3808 },
  { -7660, -78, -624, -3135 },
  { -6358, 619, -1951, -3911 },
  { -8134, 408, -1935, -3695 },
  { -6335, 1911, -2368, -4505 },
  { -7116, 2163, -344, -2753 },
  { 2357, 4488, 2220, -5682 },
  { 1385, 3206, 2300, -5305 },
  { 1419, 2557, 5203, -3516 },
  { 262, 4315, 3920, -1847 },
  { 3316, 3187, 1612, -5609 },
  { 1729, 2350, 1673, -6068 },
  { 1603, 6126, 1467, -2839 },
  { -1339, 3316, 3691, -3530 },
  { -563, 4618, 3180, -4548 },
  { 463, 4624, 3111, -5614 },
  { 1246, 5455, 3356, -5720 },
  { 480, 2149, 5422, -2893 },
  { 1768, 4827, 913, -5579 },
  { -149, 5381, 4366, -3297 },
  { 985, 3672, 2644, -92 },
  { -258, 2911, 5817, -2213 },
  { 3428, 3289, 3351, -3541 },
  { -666, 3295, 4727, -2869 },
  { 35, 6641, 4160, -4052 },
  { 623, 6787, 3156, -4560 },
  { 2654, 4360, 4676, -4632 },
  { 1386, 5246, 4834, -4497 },
  { 3488, 4574, 3856, -5946 },
  { 383, 4481, 4168, -4110 },
  { 1753, 3652, 4288, -3326 },
  { 1344, 4905, 2508, -4660 },
  { 1580, 4106, 3104, -2224 },
  { 2027, 5038, 1683, -1554 },
  { 446, 3699, 5872, -3013 },
  { 4637, 4087, 3578, -5018 },
  { 2629, 3560, 5331, -4900 },
  { 1527, 6674, 2523, -4131 },
  { -1437, 2804, 2528, -4464 },
  { -229, 3355, 2016, -5537 },
  { 3666, 3418, 4374, -4581 },
  { 1192, 3799, 923, -6596 },
  { 2040, 2956, 448, -5322 },
  { 2468, 5768, 4029, -5869 },
  { 3438, 6516, 3529, -6667 },
  { 2737, 5495, 680, -5535 },
  { 3896, 5727, 1801, -4958 },
  { 4988, 4957, 3592, -6518 },
  { -542, 4416, 5794, -2787 },
  { 4136, 4354, 2064, -4696 },
  { 3067, 5936, 1207, -3396 },
  { 2789, 4966, 2405, -3854 },
  { 1731, 3270, 3251, -1063 },
  { 1767, 5537, 2084, -2349 },
  { 465, 3116, 4532, -837 },
  { 1499, 2627, 4610, -2212 },
  { 122, 3095, 3642, -3552 },
  { 2542, 2866, 2705, -6402 },
  { 3134, 4323, 698, -4785 },
  { 731, 1859, 3112, -5242 },
  { 2553, 2980, 3241, -4846 },
  { 1329, 5310, 1607, -6624 },
  { 2468, 1858, 3476, -1034 },
  { -172, 4996, 2000, -5562 },
  { 2621, 4220, 1574, -3386 },
  { -333, 1832, 3362, -4117 },
  { 2169, 6762, 3065, -6225 },
  { 2844, 5528, 3223, -4765 },
  { 526, 5175, 1644, -4267 },
  { 2922, 4426, 2414, -2610 },
  { 452, 1399, -4516, -2636 },
  { 2872, 1720, -4667, -1435 },
  { 1279, 702, -5424, -1984 },
  { 2187, 870, -5021, -1341 },
  { 583, -144, -4628, -2464 },
  { 3, 2237, -5284, -2827 },
  { -19, 1005, -5460, -1819 },
  { 2897, 2084, -5885, -515 },
  { -400, 3370, -5527, -2947 },
  { 1505, 2593, -5518, -1802 },
  { 1341, 4534, -5094, -1899 },
  { 3241, 3670, -5493, -1252 },
  { -1287, 921, -5994, -1675 },
  { 627, 408, -6652, -364 },
  { -260, 1127, -4849, -3247 },
  { 371, 3400, -5976, -2285 },
  { 1533, 1566, -6373, -610 },
  { 2462, 4274, -6184, -1254 },
  { 1782, 3363, -6222, -1381 },
  { 572, 4650, -5673, -2754 },
  { 2674, 3414, -4460, -2154 },
  { 3614, 3820, -6883, -398 },
  { 1136, -1, -5511, -1112 },
  { -1773, 1137, -5647, -2377 },
  { -753, 2104, -6085, -2565 },
  { -204, 3025, -4731, -1418 },
  { -1486, 1438, -4380, -216 },
  { 302, 858, -5786, -264 },
  { 3486, 1495, -5234, -783 },
  { 888, 2327, -3423, -3720 },
  { -259, 772, -6596, -1311 },
  { -1197, 2073, -5174, -1826 },
  { 1500, 3470, -4462, -2645 },
  { 3072, 1960, -3277, -2264 },
  { 1841, 952, -4324, -2340 },
  { 1994, 2200, -3940, -2923 },
  { -1782, 1699, -4667, -1075 },
  { -1464, 2906, -3468, -375 },
  { 366, 2380, -3747, 1467 },
  { -545, 1645, -4619, 376 },
  { 1724, 2350, -2374, -3512 },
  { 3184, 2628, -2996, -3275 },
  { 734, 2010, -6239, -1479 },
  { 524, 3756, -4496, -3263 },
  { 1492, 3570, -3494, -3600 },
  { -932, 618, -5389, -2894 },
  { -133, 2161, -4083, -3267 },
  { 786, 774, -3279, -3731 },
  { 1078, 803, -3843, -3007 },
  { -332, 3405, -3347, 40 },
  { -17, 6, -4005, -3690 },
  { -189, 4372, -4488, -2561 },
  { -450, 3846, -3790, -1370 },
  { 362, 2212, -5272, -15 },
  { -1529, 791, -6802, -2296 },
  { 2145, 4241, -4474, 376 },
  { 1813, 2426, -2932, -2726 },
  { -542, 4557, -3140, -1080 },
  { 1192, 3784, -4371, -20 },
  { 2784, 5188, -6399, -1394 },
  { 431, 4561, -3673, -1398 },
  { 1382, 3096, -4083, 1253 },
  { 1209, 4224, -2930, 1500 },
  { 2798, 2684, -6676, -606 },
  { -2396, 1510, -5381, -2713 },
  { -2625, 2542, -4032, -2880 },
  { -1231, 3967, -4098, -2886 },
  { -1393, 2374, -3862, -4525 },
  { -2495, 1665, -1637, -5445 },
  { -3854, 1759, -1750, -4944 },
  { -2373, 1668, -2856, -6251 },
  { -2668, 1981, -886, -4557 },
  { -2927, 4427, -3451, -6172 },
  { -1925, 2596, -4696, -2527 },
  { -3202, 2847, -3928, -5896 },
  { -3332, 1665, -5025, -3412 },
  { -3212, 3115, -4155, -4062 },
  { -1013, 3205, -5133, -3751 },
  { -2022, 4595, -3947, -5611 },
  { -3556, 1755, -3715, -2300 },
  { -1784, 4114, -2723, -1773 },
  { -3586, 4081, -2733, -4942 },
  { -1608, 3685, -4154, -4573 },
  { -3368, 4042, -4452, -6227 },
  { -1407, 3881, -5729, -3719 },
  { -2751, 3281, -5077, -4999 },
  { -3791, 2410, -4906, -5288 },
  { -730, 2303, -4217, -3755 },
  { -1812, 2311, -5492, -3709 },
  { -610, 4336, -3915, -3783 },
  { -2841, 4337, -4278, -4430 },
  { -1662, 4666, -4661, -3964 },
  { -589, 5209, -4923, -3682 },
  { -4155, 2234, -4076, -4218 },
  { -3951, 2770, -2665, -2805 },
  { -2302, 3228, -3717, -1908 },
  { -3129, 4373, -2264, -2851 },
  { -447, 1363, -3578, -4323 },
  { -2648, 4237, -3159, -3071 },
  { -4072, 3241, -3541, -4605 },
  { -4507, 3458, -2339, -3838 },
  { -1646, 997, -4926, -3970 },
  { -3025, 1614, -3940, -1242 },
  { -1337, 1756, -3163, -5529 },
  { -3203, 1865, -3282, -4354 },
  { -1646, 2118, -2203, -6018 },
  { 174, 1871, -2707, -4639 },
  { -2607, 1485, -4778, -4750 },
  { -2199, 3991, -3134, -4879 },
  { -2962, 3323, -2816, -2419 },
  { -5286, 2495, -4548, -5395 },
  { -2810, 3710, -2274, -4211 },
  { -330, 3006, -2993, -4678 },
  { -1187, 2411, -2743, -5196 },
  { -664, 4033, -3101, -5641 },
  { -1458, 3602, -2816, -5371 },
  { -4116, 4923, -3321, -5630 },
  { -4165, 2528, -2592, -4798 },
  { -2759, 3080, -2333, -5719 },
  { -5157, 3011, -5526, -6348 },
  { -3095, 2126, -5881, -4234 },
  { -4377, 3849, -3600, -6099 },
  { -1994, 4947, -5235, -4753 },
  { -1067, 600, -3258, -5133 },
  { -4992, 3302, -2208, -5051 },
  { -3377, 2981, -1655, -4815 },
  { -3325, 2446, -1787, -6116 },
  { -2341, 2737, -3240, -6347 },
  { -2258, -3732, 3710, -1235 },
  { -1558, -3849, 2694, -3012 },
  { -599, -4837, 3050, -2951 },
  { -2246, -5433, 2798, -1910 },
  { -2255, -4989, 3260, 270 },
  { -3026, -5353, 2693, -1036 },
  { -1151, -6097, 1097, -3782 },
  { -3391, -6012, 2130, -1303 },
  { -2850, -4422, 3375, -480 },
  { -1138, -3779, 1491, -4162 },
  { -551, -3892, 3787, -2082 },
  { -3221, -3676, 3144, -1202 },
  { -3023, -5196, 2650, 605 },
  { -1756, -5729, 2646, 321 },
  { -2693, -4409, 494, -4797 },
  { -1913, -4573, 3372, -1730 },
  { -1277, -3604, 4061, -993 },
  { -420, -4993, 1351, -4796 },
  { -3052, -5333, 1435, -1242 },
  { -602, -5034, 3869, -1141 },
  { -2436, -4680, 1665, -3019 },
  { -2657, -3658, 1459, -3391 },
  { -1220, -6246, 2749, -525 },
  { -3838, -4844, 2265, -1735 },
  { -1247, -5679, 3356, -1417 },
  { -917, -5448, 3342, 105 },
  { -1756, -6839, 2276, -2350 },
  { -412, -5206, 1764, -3539 },
  { -1439, -6915, 1442, -3750 },
  { -1381, -4439, 3863, -282 },
  { -3482, -4953, 2726, -336 },
  { -1376, -5931, 1714, -1987 },
  { -1716, -4405, 2608, 105 },
  { -1590, -5191, 2652, -2704 },
  { -2149, -6442, 2453, -1263 },
  { -3426, -3832, 2334, -1829 },
  { -2747, -5948, 2362, -173 },
  { -2435, -3267, 2966, -1710 },
  { -3979, -4282, 2705, -775 },
  { -356, -4238, 2544, -4343 },
  { -1363, -6471, 2817, -1836 },
  { -2878, -5117, 218, -3149 },
  { -3539, -5196, 1710, -2356 },
  { -2888, -4537, 2746, -1701 },
  { -1870, -4439, 1496, -4121 },
  { -1486, -3388, 3349, -2145 },
  { -3333, -4138, 1467, -2876 },
  { -345, -5340, 1012, -1190 },
  { -1672, -4992, 2289, -1029 },
  { -2146, -5528, 3038, -635 },
  { -316, -3656, 3426, -3152 },
  { -2695, -5812, 2336, -2050 },
  { -2067, -6052, 737, -3258 },
  { -2664, -4205, -350, -1266 },
  { -617, -5406, 80, -4853 },
  { -2418, -3825, 1853, -1326 },
  { -1961, -4339, 583, -4315 },
  { -1495, -5141, -133, -5205 },
  { -3208, -6440, 1691, -2069 },
  { -2632, -3633, 2325, -2761 },
  { -2624, -5670, 1252, -3676 },
  { -3687, -5608, 687, -2833 },
  { -3320, -5707, 16, -3877 },
  { -2738, -6112, 84, -5135 },
  { 2277, -5661, 3076, 843 },
  { 1555, -5769, 2821, -5236 },
  { 536, -6381, 603, -4910 },
  { 734, -4609, 3314, -4092 },
  { 1836, -4547, 3267, -4322 },
  { -13, -5976, 3752, -1607 },
  { 1423, -6318, 2336, 398 },
  { 365, -7779, 1498, -534 },
  { 2104, -8366, 2946, -1345 },
  { 143, -5545, 1898, -3756 },
  { 655, -6852, 1430, 148 },
  { 4, -6653, 2397, -59 },
  { 2346, -5996, 4562, -934 },
  { 1229, -7104, 2963, -598 },
  { -528, -7048, 2887, -1790 },
  { 1451, -6857, 3900, -1637 },
  { 554, -6018, 3336, 9 },
  { 3278, -5758, 4034, 129 },
  { 3541, -7145, 4905, -1575 },
  { 2339, -6907, 3464, -301 },
  { 2775, -7301, 1667, -3894 },
  { 539, -7887, 991, -4156 },
  { 2115, -7421, 3131, -3075 },
  { 2803, -8546, 2564, -5836 },
  { 2869, -5833, 1620, -4561 },
  { 2591, -7281, 3215, -4719 },
  { -1228, -8477, 706, -4782 },
  { 1967, -5243, 4813, -1940 },
  { 701, -7010, 2273, -3893 },
  { 915, -8470, 1918, -5620 },
  { -94, -6715, 156, -3873 },
  { 1074, -5607, 4389, -1017 },
  { 2739, -6551, 1227, -3521 },
  { 725, -7835, 2701, -1291 },
  { -493, -7475, 2263, -1075 },
  { -412, -6508, 2984, -744 },
  { 665, -5451, 3725, -2692 },
  { 1499, -8129, 3564, -2072 },
  { 2870, -6333, 4487, -2108 },
  { 706, -5007, 3911, -152 },
  { -482, -8660, 1483, -2900 },
  { 2481, -6596, 2518, -1715 },
  { 1403, -6414, 1398, -5387 },
  { 652, -6267, 583, -5942 },
  { 694, -7540, 646, -6272 },
  { 2275, -7614, 256, -5015 },
  { 1416, -9727, 1900, -3153 },
  { 2760, -6433, 3875, -3771 },
  { 2325, -11196, 2182, -5155 },
  { 1223, -11061, 1377, -5097 },
  { 108, -10603, 307, -4952 },
  { -118, -8268, 1650, -1572 },
  { 1839, -7943, 1755, -612 },
  { 2501, -9056, 981, -2969 },
  { 2902, -8476, 1491, -5780 },
  { 1995, -11175, 1585, -3643 },
  { 696, -8212, 828, -2474 },
  { 1526, -8649, 1380, -1210 },
  { 461, -7253, 3222, -2229 },
  { 2966, -8641, 4121, -3271 },
  { 833, -6039, 2361, -1086 },
  { 3565, -7312, 1980, -5427 },
  { 2850, -8671, 3760, -1846 },
  { 2643, -7281, 2163, -173 },
  { 3463, -3706, -3132, -923 },
  { 1315, -3825, -3443, 2 },
  { 2594, -4083, -3815, 670 },
  { 1826, -4291, -2741, -155 },
  { 868, -3749, -4175, -298 },
  { 2008, -4237, -3897, -517 },
  { 1242, -3493, -4335, -1335 },
  { -88, -4142, -3390, -1529 },
  { 2176, -3488, -3822, -975 },
  { 1706, -5188, -3415, -637 },
  { 2717, -6159, -2333, -882 },
  { 1276, -3978, -4361, 537 },
  { 2471, -5556, -2866, -208 },
  { 799, -4673, -4086, 56 },
  { 1901, -4786, -3533, 270 },
  { 3036, -3902, -3606, -333 },
  { 2249, -3317, -4319, -144 },
  { 2594, -4207, -2105, -2930 },
  { 4008, -4774, -2626, -902 },
  { 1038, -3659, -3496, -2454 },
  { 2725, -3597, -3298, -1535 },
  { 1662, -5803, -2813, 175 },
  { 705, -3757, -3441, -1484 },
  { 1860, -5987, -2821, -886 },
  { 3786, -4918, -2199, -1929 },
  { 3683, -4235, -2547, -1287 },
  { 2531, -4896, -2956, -1593 },
  { 1005, -5585, -3324, -180 },
  { 1625, -5229, -1756, -3642 },
  { 1494, -5041, -2989, -2685 },
  { 2718, -4655, -3224, -867 },
  { 2374, -6640, -1745, -2975 },
  { 2133, -6436, -2477, -1499 },
  { 1833, -4418, -3523, -1512 },
  { 1128, -4910, -2658, -1106 },
  { 689, -4777, -2831, -2085 },
  { 3593, -5280, -2627, -315 },
  { 3264, -3771, -2673, -1861 },
  { 3202, -5602, -2409, 402 },
  { 552, -4618, -2221, -3002 },
  { 3095, -5356, -2666, -1083 },
  { 3401, -4609, -3146, 45 },
  { 3051, -4662, -2192, -2232 },
  { 2798, -5552, -2462, -1941 },
  { 2354, -5815, -2223, -2619 },
  { 192, -3708, -2807, -2658 },
  { 1886, -4226, -1862, -3529 },
  { 2526, -3976, -2819, -2332 },
  { 1577, -3870, -2711, -2806 },
  { 1288, -5588, -3382, -1403 },
  { 2711, -5399, -1564, -3253 },
  { 1459, -5492, -2222, -322 },
  { 2823, -5091, -2886, 776 },
  { 3559, -5821, -2109, -1360 },
  { 1587, -6331, -2760, -1909 },
  { 2139, -5213, -2874, -2120 },
  { 1318, -4337, -3695, -2098 },
  { 821, -4471, -1849, -565 },
  { 3329, -4782, -1725, -89 },
  { 582, -4914, -4105, -1119 },
  { 417, -4144, -4072, -2529 },
  { -199, -3803, -2765, -4042 },
  { 2731, -4283, -2143, 1 },
  { 2911, -6187, -1951, -2116 },
  { 1573, -6094, -493, -2838 },
  { 2081, -6927, -864, -3211 },
  { 1058, -7826, 79, -364 },
  { 3147, -5570, -684, -978 },
  { 3572, -5856, 1060, 1824 },
  { 1143, -6702, -1478, 338 },
  { 2341, -7220, -88, 260 },
  { 3639, -6861, 668, 815 },
  { 2227, -6268, -1706, 446 },
  { 3390, -6082, -353, 1302 },
  { 1123, -7556, -1237, -430 },
  { 1729, -7742, 729, -218 },
  { 1457, -6774, 587, 579 },
  { 505, -6919, -569, 371 },
  { 1106, -7245, 78, 158 },
  { 2755, -6745, -1122, 338 },
  { 3069, -6040, -1415, 986 },
  { 2174, -7064, -1430, -283 },
  { 1390, -8626, -446, -3031 },
  { 3534, -6890, -431, 547 },
  { 2267, -9618, 475, -2994 },
  { 3672, -7673, 75, -115 },
  { 2131, -7560, -1206, -750 },
  { 2972, -7477, -685, -262 },
  { 1604, -6637, -672, 699 },
  { 1666, -7577, -577, -240 },
  { 1591, -6554, -2158, -94 },
  { 2348, -6286, -353, 1123 },
  { 2017, -8810, -412, -1805 },
  { 2892, -6713, -1765, -554 },
  { 2500, -6828, -1995, -1197 },
  { 3877, -6639, -224, -1655 },
  { 2392, -7872, -91, -333 },
  { 3562, -7370, -532, -2836 },
  { 2552, -7614, 164, -1805 },
  { 990, -6104, 218, 438 },
  { 910, -7861, 312, -1195 },
  { 1472, -6327, 372, -640 },
  { 1576, -7143, -1983, -843 },
  { 422, -7625, -457, -278 },
  { 1797, -8532, 405, -1011 },
  { 1088, -7396, -238, -2277 },
  { 3209, -6753, -1431, -2072 },
  { 2617, -6839, 100, -2573 },
  { 2575, -8573, -387, -3188 },
  { 3618, -6971, -1190, -321 },
  { 2205, -7361, -1695, -2008 },
  { 2985, -6297, 1464, 1179 },
  { 2804, -7310, 1053, 338 },
  { 1362, -6074, -1163, -840 },
  { 3336, -6325, -1794, 21 },
  { 2836, -8109, 818, -329 },
  { 2791, -5879, 560, 1546 },
  { 2392, -6064, 135, 100 },
  { 1838, -6194, 596, 1085 },
  { 1926, -7515, -414, -4901 },
  { 3225, -7298, -1202, -1189 },
  { 3960, -7558, -659, -719 },
  { 3442, -6647, -1692, -1095 },
  { 3381, -6441, 262, -886 },
  { 1431, -8150, -1186, -1406 },
  { 340, -8498, -150, -899 },
  { 3004, -8149, -260, -953 },
  { 2749, -6611, 563, 873 },
  { -6647, -1325, -4517, -4691 },
  { -6005, -1657, -4089, -3797 },
  { -3157, 588, -5213, -3068 },
  { -3311, -1425, -6329, -3726 },
  { -5866, -819, -3857, -2744 },
  { -5001, -1799, -1075, -4621 },
  { -5330, -2650, -2672, -4664 },
  { -4930, -539, -2363, -4010 },
  { -2984, 10, -3863, -5749 },
  { -1055, -2106, -3713, -4267 },
  { -5476, -502, -4279, -6504 },
  { -5231, -1543, -5018, -6425 },
  { -5134, -363, -3165, -5109 },
  { -3953, -771, -4107, -6393 },
  { -2159, -563, -3652, -5342 },
  { -3888, -2321, -919, -5057 },
  { -1236, -597, -4235, -4193 },
  { -4053, 675, -3083, -6174 },
  { -2793, -1089, -5396, -3460 },
  { -3000, -44, -2209, -6575 },
  { -3336, -1531, -4313, -5160 },
  { -2127, 128, -4851, -3692 },
  { -3321, 136, -2067, -5660 },
  { -5215, 1404, -4374, -4356 },
  { -2747, 400, -6340, -3691 },
  { -3926, -599, -5361, -5006 },
  { -2875, -2592, -5143, -4092 },
  { -4991, -1958, -5322, -4891 },
  { -4965, -1318, -6652, -5333 },
  { -4920, -1691, -3388, -5561 },
  { -3644, -3354, -2688, -5982 },
  { -5076, -919, -4563, -2984 },
  { -6114, 250, -3884, -3915 },
  { -4014, 744, -3973, -1924 },
  { -5543, -1041, -5557, -3847 },
  { -4711, -1352, -5649, -2603 },
  { -3362, 775, -5305, -4879 },
  { -5001, 107, -3554, -2888 },
  { -6258, -1651, -6356, -6566 },
  { -4529, 407, -5003, -3865 },
  { -5154, 550, -5278, -5465 },
  { -4195, -467, -1894, -3129 },
  { -5022, 1127, -3349, -3314 },
  { -6075, 1250, -4313, -5641 },
  { -2677, -2283, -2312, -5903 },
  { -4113, 193, -1195, -4833 },
  { -3940, -1048, -1389, -5079 },
  { -3703, 917, -4043, -4451 },
  { -3366, -4231, -1534, -5488 },
  { -3326, -3583, -2091, -4903 },
  { -5144, 1254, -2532, -4949 },
  { -5982, -870, -2545, -4555 },
  { -3925, -157, -5367, -2281 },
  { -6419, -746, -5668, -4371 },
  { -5787, 518, -7096, -5805 },
  { -4258, 954, -6453, -4321 },
  { -4771, -695, -4158, -1639 },
  { -7078, -760, -5195, -5877 },
  { -7348, 83, -4101, -4586 },
  { -2430, 184, -2874, -1679 },
  { -2284, -3943, -2924, -5034 },
  { -1804, -1785, -3002, -4710 },
  { -4399, -2772, -1815, -4637 },
  { -6340, -2626, -2824, -5191 },
  { -4998, -5168, -3480, 1905 },
  { -3958, -5492, -1599, 1579 },
  { -2471, -3755, -276, 3182 },
  { -3033, -5779, -1063, 1554 },
  { -2936, -4829, -1290, 2386 },
  { -1835, -5073, -3051, 1299 },
  { -1724, -3771, -3935, 2324 },
  { -5070, -2550, -3692, 768 },
  { -4326, -5333, -297, 1878 },
  { -3472, -5619, -3094, 992 },
  { -3027, -4384, -3038, 2265 },
  { -3201, -5332, 67, 2200 },
  { -1681, -4373, -1947, 2461 },
  { -3221, -3329, -4238, 2564 },
  { -1262, -2968, -2915, 3227 },
  { -3419, -1878, -3373, 2110 },
  { -2244, -5583, -2012, 1288 },
  { -1971, -5266, -990, 1812 },
  { -2975, -2778, -452, 4063 },
  { -2198, -1165, -3298, 2965 },
  { -4782, -4894, -4767, 664 },
  { -6002, -3950, -2806, 2025 },
  { -3142, -3162, -2859, 3295 },
  { -3262, -3340, -4123, 1596 },
  { -4014, -3918, -1955, 3361 },
  { -1700, -3463, -1346, 3449 },
  { -4245, -4445, -4743, 1644 },
  { -4180, -3969, -401, 3281 },
  { -2782, -5240, -4117, 1156 },
  { -5744, -4040, -1439, 3470 },
  { -5063, -4663, -323, 3172 },
  { -4531, -3319, -844, 3988 },
  { -6226, -5125, -2064, 2976 },
  { -3115, -3267, -1531, 3898 },
  { -4628, -4421, -2864, 2808 },
  { -4559, -2989, -3442, 2024 },
  { -1775, -4487, -656, 2477 },
  { -2664, -1865, -1884, 4081 },
  { -1828, -2575, -3894, 3378 },
  { -6441, -3677, -2025, 1677 },
  { -4141, -2156, -1191, 3474 },
  { -4802, -1623, -1727, 2160 },
  { -5474, -2745, -1475, 2498 },
  { -3664, -1056, -1975, 2491 },
  { -4672, -3062, -2235, 2933 },
  { -4205, -5960, -2849, 1517 },
  { -4995, -5708, -1739, 1805 },
  { -4892, -6080, -4793, 872 },
  { -4270, -4172, -4263, 2185 },
  { -4687, -1470, -2905, 1023 },
  { -6446, -5017, -3919, 1000 },
  { -6046, -5538, -3943, 2006 },
  { -6028, -3750, -3953, 771 },
  { -5959, -4582, -5024, 824 },
  { -5818, -2576, -2249, 1326 },
  { -5659, -5345, -1119, 2500 },
  { -3346, -4155, 606, 2749 },
  { -5680, -4827, -2501, 1838 },
  { -6193, -2543, -1295, 840 },
  { -6871, -4925, -3512, 1801 },
  { -5605, -1788, -1895, 779 },
  { -3922, -5712, -4644, 510 },
  { -4745, -3869, -4533, 99 },
  { -2984, -4907, -399, 1497 },
  { 1847, -478, 3061, -5812 },
  { 4450, -1116, 3609, -6570 },
  { 3139, 99, 3007, -5532 },
  { 2590, -3782, 3138, -4770 },
  { 1881, 1204, 5778, -3404 },
  { 3631, 2060, 5566, -5038 },
  { 3461, 1961, 5167, -3800 },
  { 2947, 273, 4536, -4389 },
  { 4453, -1730, 5788, -4370 },
  { 4032, 1805, 2666, -4534 },
  { 3487, -944, 2313, -6028 },
  { 1313, 34, 4210, -4067 },
  { 5632, -1502, 5825, -5855 },
  { 7736, -547, 4879, -5476 },
  { 4906, -1512, 4760, -5760 },
  { 3843, 447, 1091, -4958 },
  { 2982, -1135, 5442, -4386 },
  { 3579, 271, 3031, -6770 },
  { 3932, -211, 4688, -5507 },
  { 4411, 1720, 2387, -5584 },
  { 5379, -479, 4575, -6280 },
  { 3613, -362, 2012, -4885 },
  { 3744, -2013, 4493, -5073 },
  { 5693, 109, 4379, -3362 },
  { 5475, -621, 5317, -3985 },
  { 6411, -673, 5708, -4752 },
  { 4933, -796, 7262, -4290 },
  { 2804, 444, 6276, -3655 },
  { 4120, -517, 6078, -4531 },
  { 5119, 841, 3486, -3910 },
  { 4738, 1539, 3525, -2970 },
  { 5086, 370, 5895, -5640 },
  { 4235, 2716, 4589, -5044 },
  { 3691, 682, 6199, -4700 },
  { 6111, -570, 6271, -6528 },
  { 2611, 1277, 3756, -4802 },
  { 4395, 970, 3807, -5879 },
  { 5225, 2299, 3242, -4333 },
  { 5144, 1778, 4946, -5545 },
  { 2989, -3016, 3247, -5495 },
  { 2983, 920, 2071, -6059 },
  { 5270, -903, 4434, -2350 },
  { 6415, -585, 3970, -3554 },
  { 3866, -197, 5216, -2884 },
  { 3767, -1298, 6702, -3315 },
  { 6299, 2620, 5284, -6824 },
  { 6654, 646, 3653, -4927 },
  { 4770, 3047, 5160, -6287 },
  { 5364, 434, 2919, -5207 },
  { 2998, 1344, 4801, -2456 },
  { 3896, 1013, 3773, -1864 },
  { 2115, 655, 2999, -6344 },
  { 5170, -981, 2849, -4464 },
  { 2735, -2159, 2717, -5776 },
  { 2430, -1952, 4392, -4559 },
  { 6143, -1180, 3659, -4746 },
  { 4978, -1483, 1726, -4875 },
  { 3486, -2383, 3306, -4301 },
  { 1434, -1372, 4171, -4770 },
  { 3354, -2627, 1525, -5093 },
  { 6790, 2386, 3995, -5909 },
  { 1475, -2674, 3451, -4204 },
  { 1999, -3494, 3693, -5556 },
  { 4764, -2848, 2856, -5589 },
  { -3677, 5131, 2827, -2934 },
  { -2844, 7078, 2852, -3580 },
  { -3902, 6434, 4118, -1911 },
  { -1769, 7530, 3492, -3541 },
  { -1937, 5679, -447, -1127 },
  { -2456, 4680, 4196, -2407 },
  { -2778, 8241, 1698, -4288 },
  { -2876, 6104, 5182, -2387 },
  { -2802, 7341, 4463, -2938 },
  { -1025, 6267, 4752, -3201 },
  { -2349, 5413, 2041, -3794 },
  { -2252, 8225, 2856, -4269 },
  { -1465, 4967, 4976, -2500 },
  { -636, 7565, 3517, -4233 },
  { -1905, 5618, 3904, -2942 },
  { -302, 6816, 3343, -3316 },
  { -2210, 4156, 2817, -3511 },
  { -717, 6568, 1863, -2951 },
  { -3873, 5682, 2164, -575 },
  { -2878, 5835, 440, -2597 },
  { -3228, 7701, 2610, -2514 },
  { -3608, 8888, 3377, -2468 },
  { -2582, 9717, 2519, -3126 },
  { -5238, 6202, 2866, -2831 },
  { -3428, 7370, 3056, -335 },
  { -1681, 8836, 1210, -2010 },
  { -3276, 6724, 1156, -3930 },
  { -894, 8149, 827, -1258 },
  { -2965, 8631, 2549, -1320 },
  { -3961, 6902, 3581, 55 },
  { -1894, 7745, 1750, -841 },
  { -821, 6844, 850, -676 },
  { -608, 6948, -4, -1376 },
  { 615, 6524, 1089, -1147 },
  { -2972, 5668, 1091, -489 },
  { -157, 4649, 2904, -413 },
  { 673, 5121, 1498, -66 },
  { -390, 5902, 1611, -245 },
  { -2349, 5478, 4772, -1320 },
  { 88, 6798, 1972, -1859 },
  { -1213, 5120, 2991, 200 },
  { -2347, 6040, 2839, 376 },
  { -578, 5976, 3364, -1796 },
  { -1391, 5872, 3002, -965 },
  { -564, 4496, 3946, -1186 },
  { -2299, 6386, 3135, -2176 },
  { -2131, 5641, 2011, 1223 },
  { -772, 5807, 1124, 895 },
  { -2837, 6758, 2297, -740 },
  { -3091, 6298, 1415, -2126 },
  { -4197, 6036, 1843, -3022 },
  { -41, 6459, 92, 344 },
  { -2241, 6860, 2095, -4396 },
  { -1931, 7088, 2117, -2135 },
  { -2375, 4422, 1688, -3169 },
  { -1742, 6674, 1538, -119 },
  { -4818, 7749, 4192, -1577 },
  { -2004, 5672, 193, -430 },
  { -3825, 6042, 2128, -1898 },
  { -1108, 8033, 2119, -3013 },
  { -2370, 5453, 1721, 266 },
  { -1570, 7134, 614, -2638 },
  { -1519, 8752, 3503, -4330 },
  { -2050, 3845, 2907, -1126 },
  { 5085, 4412, -335, -1923 },
  { 3618, 1423, -613, -4012 },
  { 4481, 3729, 589, -4631 },
  { 4270, 3216, -1763, -3168 },
  { 4241, 1796, -1701, -2796 },
  { 4787, 2338, -487, -3639 },
  { 2915, 3429, -621, -4753 },
  { 5175, 1660, -1265, -3223 },
  { 4280, 4057, -684, -4079 },
  { 4980, 4419, -1455, -2719 },
  { 5436, 2464, 387, -4197 },
  { 4507, 4018, 1121, -3314 },
  { 6020, 2401, -413, -3201 },
  { 4200, 3789, -333, -2813 },
  { 5229, 2493, -1194, -1878 },
  { 5851, 2695, -492, -2292 },
  { 5743, 3288, -697, -1221 },
  { 5692, 2612, 979, -2227 },
  { 5085, 2067, 1046, -1214 },
  { 3163, 2240, -2098, -3435 },
  { 5228, 1898, 145, -2397 },
  { 5860, 3976, -418, -2872 },
  { 6008, 3399, 1027, -3506 },
  { 4126, 2035, 1865, -893 },
  { 5375, 3596, 511, -2362 },
  { 1937, 1493, -852, -122 },
  { 3473, 4849, 547, -2603 },
  { 4631, 2977, 1141, -1768 },
  { 6149, 3050, -71, -1886 },
  { 4069, 4353, -289, -1429 },
  { 2884, 1225, -1388, 365 },
  { 5485, 2518, -235, -571 },
  { 1216, 4375, 1443, 398 },
  { 4988, 3106, 107, -1435 },
  { 4511, 2801, 307, -444 },
  { 3235, 4386, 327, -676 },
  { 2055, 3708, 1657, -305 },
  { 5839, 2374, 290, -1385 },
  { 5110, 3305, 1936, -4206 },
  { 6416, 2920, 338, -2736 },
  { 3350, 2824, -1269, -3881 },
  { 4840, 1815, 464, 186 },
  { 2399, 3332, 238, 1238 },
  { 3516, 1363, 1582, 688 },
  { 3582, 1874, 154, -4770 },
  { 3261, 2878, 886, 283 },
  { 3877, 2658, -327, 884 },
  { 4151, 3436, 2173, -2923 },
  { 3592, 3674, 1281, -1295 },
  { 4561, 3730, -1114, -1747 },
  { 4595, 3625, -558, -575 },
  { 2577, 2348, 2267, 120 },
  { 5242, 3299, 32, -3412 },
  { 4264, 3637, 709, -2320 },
  { 6556, 3570, -838, -2472 },
  { 5745, 4014, -940, -1973 },
  { 5629, 4475, 477, -3328 },
  { 5269, 3199, 1682, -3085 },
  { 4432, 2416, 1145, -3299 },
  { 4465, 2505, 2162, -2186 },
  { 4643, 4941, -88, -2885 },
  { 4568, 5231, 552, -3915 },
  { 5667, 3075, -1406, -2963 },
  { 5418, 5259, -771, -2818 },
  { -256, -7875, 511, -471 },
  { -1813, -7971, -424, -396 },
  { -306, -7006, 862, 282 },
  { -2306, -6422, -1440, 508 },
  { -245, -6787, 375, -100 },
  { -1309, -6065, -20, 779 },
  { -1656, -6047, -641, 1307 },
  { -1496, -6522, 964, 726 },
  { -2291, -6588, -202, 795 },
  { -762, -7522, 1454, -558 },
  { -2270, -7004, -834, -580 },
  { -1139, -7078, 259, 362 },
  { -2535, -7568, -1040, 49 },
  { -3786, -7280, 934, -476 },
  { -3336, -6368, 606, 1056 },
  { -3602, -6924, 52, 714 },
  { -2278, -6550, 1674, 204 },
  { -2855, -5765, 930, 1530 },
  { -2889, -7325, -215, 305 },
  { -2749, -6080, -237, 1452 },
  { -985, -6667, 1577, 400 },
  { -2036, -6083, 380, 1267 },
  { -2077, -7460, 380, -30 },
  { -1775, -7175, 1540, -386 },
  { -3065, -6927, 989, 168 },
  { -2836, -7602, 117, -3392 },
  { -1058, -6396, 593, -3078 },
  { -844, -6062, 999, -236 },
  { -3261, -6951, 1491, -720 },
  { -2186, -8484, 75, -1287 },
  { -2882, -7756, 456, -510 },
  { -1800, -6879, 960, -1183 },
  { -2554, -7241, 1614, -1474 },
  { -2608, -5305, 392, 851 },
  { -2973, -6562, -859, 858 },
  { -2640, -5989, 1031, -416 },
  { -977, -8366, 705, -1434 },
  { -1213, -7409, -77, -1390 },
  { -1335, -6657, 2125, -123 },
  { -2544, -6862, 1852, -737 },
  { -3235, -6422, 1752, -103 },
  { -1300, -7557, 939, -348 },
  { -3476, -7579, 202, -109 },
  { -2482, -6572, 753, 619 },
  { -2554, -8136, -648, -429 },
  { -1012, -7870, -3, -421 },
  { -3604, -6247, 32, -3102 },
  { -1486, -7271, 2013, -1021 },
  { -578, -6799, -523, 405 },
  { -2841, -5948, 1644, 911 },
  { -2411, -7473, 1084, -484 },
  { -2238, -6033, 294, -1059 },
  { -3459, -6470, -201, -790 },
  { -2027, -6009, 1833, 805 },
  { -1433, -8047, 1531, -1754 },
  { -3258, -7884, 763, -1422 },
  { -1544, -6928, -729, 478 },
  { -2314, -8415, 74, -3757 },
  { -3201, -5684, 95, -2214 },
  { -2423, -8694, 725, -3631 },
  { -3545, -7071, 1162, -1798 },
  { -294, -9662, 403, -2274 },
  { -2290, -5460, 1196, 402 },
  { -1603, -6713, 903, -2363 },
  { 4121, 2491, -3142, -2482 },
  { 4500, 3305, -3671, -1567 },
  { 5973, 3172, -1348, -534 },
  { 4830, 3379, -1549, 643 },
  { 5214, 3938, -2641, -2302 },
  { 4639, 4826, -5532, -847 },
  { 5639, 2731, -2170, -963 },
  { 6084, 3487, -3525, -1346 },
  { 5971, 3154, -2190, -2316 },
  { 5618, 4865, -6927, 116 },
  { 5345, 3568, -7391, 709 },
  { 5429, 5078, -3811, -1524 },
  { 6960, 2037, -3515, -1096 },
  { 7092, 2531, -4557, -588 },
  { 6061, 4247, -5651, -478 },
  { 4595, 3684, -4907, -827 },
  { 7497, 3213, -3048, -424 },
  { 5996, 2137, -3098, -1745 },
  { 6198, 5199, -2223, -2274 },
  { 6888, 2851, -2768, -1675 },
  { 6114, 4210, -2316, -954 },
  { 7127, 4242, -3041, -1408 },
  { 6126, 3668, -1517, -1427 },
  { 6245, 6129, -4225, -1186 },
  { 6816, 3213, -2101, -964 },
  { 5345, 5276, -2643, -847 },
  { 6592, 4665, -4338, 484 },
  { 6746, 3751, -3443, 124 },
  { 5453, 1980, -2738, 2606 },
  { 4662, 2179, -4226, -1059 },
  { 5571, 3208, -3554, 174 },
  { 5256, 4447, -1815, -1481 },
  { 5400, 2570, -1210, 235 },
  { 7056, 2549, -2674, 318 },
  { 4574, 4340, -2892, -130 },
  { 6203, 4587, -3273, -305 },
  { 5103, 1925, -2715, -2137 },
  { 3905, 4296, -1700, 247 },
  { 4421, 4605, -3299, 811 },
  { 5671, 1273, -3870, -924 },
  { 5486, 1805, -4901, 133 },
  { 6437, 2578, -1828, -106 },
  { 5530, 5253, -5058, 1223 },
  { 4816, 2025, -1215, 1443 },
  { 3457, 3525, -2456, 3217 },
  { 3316, 2595, -1108, 2459 },
  { 3068, 3810, -2207, 1926 },
  { 6351, 5436, -6470, 600 },
  { 6324, 4240, -5365, 2416 },
  { 4851, 4774, -4075, 1878 },
  { 4900, 3679, -5198, 1078 },
  { 8347, 3633, -4565, -171 },
  { 5244, 5718, -3853, 173 },
  { 3960, 3492, -2939, 2105 },
  { 6070, 3473, -2351, 161 },
  { 8228, 3034, -3360, -901 },
  { 7006, 3985, -1940, -1926 },
  { 7123, 4681, -4301, -878 },
  { 5122, 4097, -1851, -449 },
  { 6200, 2060, -2251, 1049 },
  { 7106, 3844, -7209, 2625 },
  { 7108, 3370, -6734, 533 },
  { 6859, 2849, -3992, 1360 },
  { 5458, 2278, -3253, 1131 },
  { -1072, -2109, 4783, -1073 },
  { -319, -2604, 4257, -2418 },
  { 2466, 1300, 3476, -314 },
  { 2847, -1502, 5296, -141 },
  { 1667, -1273, 5559, -2725 },
  { 2877, -3402, 6434, 204 },
  { 53, -2637, 5275, -1181 },
  { 1091, -2215, 5803, -1549 },
  { 2397, -922, 4327, 1182 },
  { 219, -3747, 4647, -1564 },
  { -29, -2705, 4812, 1277 },
  { 1499, -2608, 5648, 1407 },
  { 2139, -2399, 4202, 2791 },
  { -426, -2064, 5528, 151 },
  { 2560, -2803, 6179, -2806 },
  { 4537, -2479, 3797, 1095 },
  { 888, -3357, 5341, -415 },
  { 4460, -1814, 5388, -1227 },
  { 3920, -3268, 6364, -703 },
  { 3343, -4698, 4410, 784 },
  { 309, -1897, 6306, 1223 },
  { 958, -3318, 4254, -3167 },
  { -99, 1596, 6018, -1983 },
  { -429, -853, 6407, 878 },
  { 1170, -1322, 6290, -417 },
  { 2288, -505, 6303, -1999 },
  { 3312, -1674, 6749, -2494 },
  { -415, -3401, 4721, -371 },
  { -189, -1210, 4844, -2002 },
  { 888, -4142, 4377, 130 },
  { 2469, -4381, 5398, -2492 },
  { 2879, -2912, 5094, -2598 },
  { -717, -617, 5650, -685 },
  { 1470, -3863, 5352, -1684 },
  { 3935, -96, 3823, -730 },
  { 3769, -430, 3168, 694 },
  { 2556, 385, 3539, 512 },
  { 77, -1415, 5111, 2655 },
  { 2724, -2158, 6715, -822 },
  { 1832, 1001, 5385, -1900 },
  { 900, 2198, 4464, -559 },
  { 441, 69, 5921, -1743 },
  { -1161, 738, 6732, -308 },
  { 257, 2035, 4091, 736 },
  { 1607, 1288, 4355, -23 },
  { -13, 1316, 4180, 1672 },
  { 1511, 1336, 3057, 1435 },
  { 2189, -3813, 4530, 939 },
  { 3632, -706, 2646, 1375 },
  { 4266, -3761, 4241, 1077 },
  { 3101, -427, 5273, -1202 },
  { 2293, 276, 4810, -313 },
  { 3430, -1851, 3101, 2045 },
  { 3453, -2979, 5142, 942 },
  { 1683, -3281, 4802, 2002 },
  { 3954, -4715, 5611, 578 },
  { 1272, -155, 5085, 454 },
  { 128, -194, 5095, 1409 },
  { 820, 880, 5797, -2658 },
  { -1095, 656, 5774, 1095 },
  { 813, -1669, 4320, -3251 },
  { -119, 518, 6372, -651 },
  { 2922, -4299, 6115, -877 },
  { 4205, -4273, 4004, 2642 },
  { -1211, -3892, 224, 3127 },
  { -34, -4371, 1321, 2318 },
  { 77, -6326, 1201, 828 },
  { 3995, -3775, 1958, 3233 },
  { 178, -3301, 1985, 3318 },
  { 2330, -3801, 1033, 3195 },
  { 1413, -5536, 826, 1709 },
  { 2468, -3499, 3653, 3631 },
  { 741, -4617, 1723, 2008 },
  { 1246, -3043, 2978, 3949 },
  { -343, -4308, 2258, 2189 },
  { -682, -4640, 454, 2272 },
  { 1236, -4829, 2491, 1642 },
  { -512, -3766, 1182, 3052 },
  { 119, -3939, 3712, 971 },
  { -1145, -4624, 1360, 2281 },
  { 101, -4746, 2866, 1255 },
  { -1500, -5455, 539, 1637 },
  { -969, -5909, 1414, 1128 },
  { -1261, -4939, -231, 2022 },
  { -226, -5345, 1207, 705 },
  { 2712, -5109, 3205, 1866 },
  { -476, -5913, 273, 1208 },
  { -2039, -4464, 624, 2545 },
  { -2351, -3930, 2019, 2673 },
  { -2675, -4849, 1522, 1990 },
  { -1524, -3461, 1446, 3204 },
  { 477, -5314, 1710, 1577 },
  { 656, -3729, 2346, 2511 },
  { 550, -5917, 1975, 1040 },
  { 1728, -4704, 3067, 1058 },
  { -9, -5247, 506, 1760 },
  { -574, -5135, 1675, 1672 },
  { 2129, -3781, 3444, 2313 },
  { 1144, -4439, 2214, 2529 },
  { 1292, -4160, 3185, 1833 },
  { 2445, -3262, 2534, 3227 },
  { 2266, -4401, 2023, 2400 },
  { -587, -3602, 3408, 2067 },
  { -885, -4951, 3228, 1174 },
  { -728, -2711, 2807, 3552 },
  { 1019, -3043, 3195, 2954 },
  { 1888, -4615, 1140, 2454 },
  { 660, -5616, 754, 800 },
  { -1975, -5371, 1649, 1585 },
  { -1544, -5436, 2422, 1081 },
  { -422, -5882, 2390, 750 },
  { 1336, -5557, 2441, 1230 },
  { 136, -4001, 267, 2854 },
  { -522, -3289, 2226, 2728 },
  { -971, -4580, 2471, 708 },
  { 704, -5306, 3300, 1001 },
  { 325, -3464, 3555, 2398 },
  { 794, -3686, 848, 3169 },
  { 660, -3017, 4584, 3242 },
  { -1486, -3978, 2170, 1644 },
  { -1615, -4650, 2688, 1844 },
  { 750, -4578, 538, 2239 },
  { 1668, -5849, 1455, 1031 },
  { 3486, -4681, 2030, 2183 },
  { 2642, -5429, 1696, 1761 },
  { 4491, -4502, 3538, 2767 },
  { 3545, -4528, 3514, 2982 },
  { 3269, -3676, 2758, 3966 },
  { 5572, 1146, 209, -3379 },
  { 7459, 1053, 593, -1896 },
  { 4480, 200, -310, -4259 },
  { 5577, -939, 242, -3992 },
  { 8142, 442, 1257, -3083 },
  { 5442, 1261, 1424, -3236 },
  { 6260, -183, 3125, -2532 },
  { 7179, 889, 1618, -2548 },
  { 6416, 932, 2379, -2487 },
  { 7094, 2560, 961, -3392 },
  { 7322, 463, 2732, -3735 },
  { 6632, 1577, 1912, -3272 },
  { 6312, 1349, 3028, -3460 },
  { 6105, 386, 1213, -977 },
  { 5478, 1158, 1114, -486 },
  { 6493, 410, 1686, -2180 },
  { 6378, 1881, 1333, -2240 },
  { 5711, 812, 1958, -1300 },
  { 6844, 877, 730, -1189 },
  { 6824, -245, 2249, -2000 },
  { 7515, 1521, 1251, -3058 },
  { 6697, 1051, 1300, -1749 },
  { 6476, 1425, 811, -2773 },
  { 7350, 465, -76, -2849 },
  { 6975, 2095, 567, -2492 },
  { 4691, 1736, 2660, -2289 },
  { 7837, 1456, 340, -2767 },
  { 7930, 507, 838, -2074 },
  { 6106, 1502, 766, -1110 },
  { 4891, -659, 835, -3954 },
  { 7250, 141, 1369, -1523 },
  { 7651, 67, 1651, -2298 },
  { 7364, -305, 601, -3132 },
  { 7179, 193, 2491, -2871 },
  { 6504, -272, 2167, -1322 },
  { 4456, 983, 2300, -421 },
  { 4817, 457, 1695, 371 },
  { 6914, 555, 850, -3159 },
  { 5904, 1030, 202, -1959 },
  { 6258, 880, 2233, -4503 },
  { 6029, 10, 2130, -3600 },
  { 6449, 985, 1129, -3963 },
  { 6616, -18, -111, -3285 },
  { 4496, 775, 817, -4276 },
  { 6134, 2338, 1470, -2973 },
  { 6911, 152, 430, -1946 },
  { 4053, 991, 3218, -1193 },
  { 5435, 1285, 3124, -2412 },
  { 5507, 1836, 1935, -1988 },
  { 5240, 689, 2189, -2670 },
  { 6638, 1719, 606, -1799 },
  { 5556, -180, 129, -2595 },
  { 5644, 1918, 1281, -4316 },
  { 6410, 1088, -282, -3117 },
  { 6503, 1841, 312, -3514 },
  { 6947, 20, 1358, -3886 },
  { 5464, 2109, 2398, -3194 },
  { 5616, -407, 2140, -498 },
  { 6121, 2707, 2379, -4096 },
  { 7303, 1846, 2266, -4095 },
  { 5444, 470, 2718, -1553 },
  { 5817, -645, 3285, -1349 },
  { 5625, 1427, 1103, -1991 },
  { 6041, -806, 1196, -2943 },
  { 3050, -5722, 4070, -5460 },
  { 3420, -4386, 4078, -5155 },
  { 6020, -3982, 7268, -2689 },
  { 7502, -4317, 7894, -3973 },
  { 4156, -3558, 5247, -4316 },
  { 4725, -4401, 7290, -1540 },
  { 6688, -5122, 8216, -3210 },
  { 9176, -6576, 9276, -4963 },
  { 8706, -5708, 7987, -4621 },
  { 7060, -3535, 6532, -3308 },
  { 5600, -2719, 5363, -1568 },
  { 4661, -2803, 6263, -4716 },
  { 3673, -3636, 6147, -3433 },
  { 5305, -2585, 6073, -2638 },
  { 7614, -1962, 6079, -5266 },
  { 6760, -3366, 7382, -4322 },
  { 6385, -3883, 4797, -1353 },
  { 8182, -5120, 4298, -4641 },
  { 9130, -6198, 4975, -3063 },
  { 7421, -5436, 5576, -3713 },
  { 3483, -4898, 5443, -2745 },
  { 4907, -5643, 6390, -4105 },
  { 8119, -7008, 7992, -6764 },
  { 6528, -6122, 6967, -5590 },
  { 5890, -4190, 6624, -5688 },
  { 6815, -7934, 7275, -5456 },
  { 5434, -4306, 5169, -5378 },
  { 4364, -6436, 5376, -2604 },
  { 8152, -3404, 5913, -5048 },
  { 7983, -4863, 4262, -2461 },
  { 8023, -6188, 6238, -5062 },
  { 6753, -3692, 3935, -3723 },
  { 6826, -4760, 3284, -4051 },
  { 7224, -7423, 4492, -3875 },
  { 6904, -2590, 6587, -6248 },
  { 6106, -1944, 7345, -5506 },
  { 4956, -2990, 7808, -3146 },
  { 6908, -6885, 5949, -1288 },
  { 7162, -6058, 3419, -3401 },
  { 7015, -7080, 6907, -3018 },
  { 6971, -6832, 5646, -3273 },
  { 8014, -5546, 5471, -1544 },
  { 6792, -2220, 5105, -2879 },
  { 8494, -3974, 4408, -3999 },
  { 9591, -4866, 6027, -4558 },
  { 5264, -5161, 6101, -738 },
  { 5803, -6141, 5197, -5231 },
  { 4657, -6822, 3232, -5189 },
  { 4791, -5135, 3809, -4665 },
  { 6108, -5103, 2379, -3873 },
  { 4680, -3909, 3234, -5093 },
  { 5802, -3853, 3795, -4984 },
  { 4360, -7483, 4802, -3877 },
  { 5429, -7517, 5911, -3717 },
  { 6866, -2280, 4880, -4634 },
  { 10131, -4628, 4414, -4092 },
  { 10811, -5189, 7746, -5337 },
  { 5663, -8941, 5287, -5680 },
  { 8023, -5991, 7403, -2796 },
  { 9669, -6919, 6525, -4932 },
  { 7275, -3796, 4962, -2547 },
  { 8848, -4806, 5677, -3080 },
  { 8128, -4308, 7749, -6569 },
  { 4032, -5196, 2282, -6239 },
  { 6593, 700, -229, 304 },
  { 8260, 539, -66, -1259 },
  { 6605, 176, -814, -109 },
  { 8057, 0, -1, -136 },
  { 7382, -38, -484, -1129 },
  { 8373, -929, 682, -454 },
  { 7674, 690, -1278, 546 },
  { 7326, -517, 406, -1283 },
  { 7612, -1715, -1167, 1175 },
  { 8590, 441, -782, -710 },
  { 8572, -1202, -291, 260 },
  { 7308, -147, -1785, 414 },
  { 6787, -353, -672, 934 },
  { 5177, -133, 179, 82 },
  { 4161, -34, 447, 1497 },
  { 5997, -902, 1533, -121 },
  { 5727, -871, -1370, 945 },
  { 8386, -252, 293, -823 },
  { 6573, -1354, 682, 616 },
  { 7650, -2096, 725, 457 },
  { 8122, 78, 636, -1400 },
  { 8421, 428, -1620, 131 },
  { 7341, -1292, -717, 186 },
  { 7998, -49, -720, 266 },
  { 5987, -351, 669, 844 },
  { 7314, -1620, 250, -603 },
  { 7219, -1562, -572, 1994 },
  { 8682, -358, -290, -388 },
  { 5810, 155, -178, 1199 },
  { 7246, -12, 1042, -786 },
  { 7357, -923, 1468, -475 },
  { 7801, 621, -212, -724 },
  { 5346, -514, 1210, 1356 },
  { 8459, 36, -127, -779 },
  { 6878, -2429, 854, 1750 },
  { 7280, -1401, -1353, 2845 },
  { 7579, -2148, -1463, 2087 },
  { 6637, 946, -872, 750 },
  { 4807, -1100, 1289, 2602 },
  { 4495, 219, 1551, 1128 },
  { 7639, 506, 446, -1107 },
  { 6359, 188, 1009, -115 },
  { 6641, -1820, 1655, 723 },
  { 5394, -2382, 1604, 2542 },
  { 6021, -2644, 2396, 1407 },
  { 4698, 882, 245, 1525 },
  { 8103, 573, -798, -349 },
  { 8045, -519, 997, -1092 },
  { 7571, -122, 227, -338 },
  { 5347, -1200, 630, 1718 },
  { 7070, 790, 218, -544 },
  { 7440, 728, -527, -20 },
  { 6402, -355, 197, -736 },
  { 4031, 771, 866, 1895 },
  { 6009, 896, 445, -31 },
  { 5160, 1098, -856, 1784 },
  { 7980, -886, -1293, 1396 },
  { 6318, -1361, 2423, 252 },
  { 7547, -699, 133, 506 },
  { 8562, -2344, 940, 264 },
  { 5890, 1187, -1425, 2194 },
  { 6558, -645, -1311, 2621 },
  { 4634, -1671, 2075, 1623 },
  { 5614, 105, -816, 2376 },
  { 6646, 1558, -1365, 630 },
  { 6998, 1150, -2117, -990 },
  { 6555, 2311, -1093, -1783 },
  { 6682, 1430, -2391, -1940 },
  { 7861, 1555, -2977, -1188 },
  { 6745, 1723, -459, -2085 },
  { 7504, 1229, -1666, -2060 },
  { 7937, 671, -2128, -1529 },
  { 7139, 991, -735, -2632 },
  { 6867, 1592, -1303, -2324 },
  { 6401, 2230, -1732, -2508 },
  { 7201, 2184, -2169, -1988 },
  { 6636, 2190, -995, -2840 },
  { 7620, 2306, -2089, -651 },
  { 7584, 1875, -1438, -631 },
  { 9214, 1561, -2464, -1139 },
  { 6154, 1318, -1237, -2917 },
  { 7917, 2847, -1797, -1599 },
  { 8309, 2029, -2555, -465 },
  { 8204, 1282, -584, -2405 },
  { 8440, 1035, -1147, -1137 },
  { 7107, 1858, -60, -1568 },
  { 6781, 2912, -873, -1463 },
  { 7603, 1316, -319, -1249 },
  { 7833, 1335, -78, -1849 },
  { 7930, 1141, -1016, -695 },
  { 7883, 1610, -1017, -1314 },
  { 8069, 1409, -1811, -196 },
  { 8319, 1031, -582, -1590 },
  { 5948, 1537, -2153, -2373 },
  { 8684, 1171, -1871, -850 },
  { 8357, 2484, -2411, -1292 },
  { 6516, 2092, -193, -1167 },
  { 6112, 1697, 22, -525 },
  { 7161, 703, -602, -1879 },
  { 6047, 2351, -807, -219 },
  { 8072, 1854, -1817, -1553 },
  { 6956, 1304, 76, -1011 },
  { 6607, 1481, -544, -162 },
  { 6958, 2541, -265, -1938 },
  { 6416, 2514, -777, -850 },
  { 7272, 2110, -899, -1171 },
  { 7741, 2153, -283, -2614 },
  { 6482, 2041, -1758, -1221 },
  { 6762, 940, -1862, -2281 },
  { 5610, 1194, -1691, -1561 },
  { 7833, 2164, -823, -1952 },
  { 5460, 1438, -848, 1189 },
  { 6011, 1377, -771, -1557 },
  { 7679, 544, -1134, -2214 },
  { 7209, 1292, -2714, -1564 },
  { 5567, 1200, -404, -169 },
  { 5853, 1461, -1465, -518 },
  { 6782, 689, -844, -860 },
  { 7330, 1337, -1152, -71 },
  { 7189, 1506, -653, -685 },
  { 6860, 2116, -1403, -240 },
  { 8804, 1516, -1391, -1760 },
  { 7210, 2689, -1498, -989 },
  { 7030, 3022, -1441, -2083 },
  { 5649, 1836, -407, 525 },
  { 7451, 3099, -717, -2464 },
  { 7384, 1656, -2007, 398 },
  { 6504, 707, -1919, -134 },
  { -1851, 3639, -2279, -695 },
  { -4037, 1644, -77, 1329 },
  { -4025, 1960, -1565, -567 },
  { -3430, 2495, -795, 368 },
  { -4771, 2480, 993, 756 },
  { -3431, 2058, -2539, -971 },
  { -3802, 3418, 380, 217 },
  { -3074, 3350, -1652, -1056 },
  { -3705, 326, -1650, 1535 },
  { -3122, 1281, -1192, 1607 },
  { -4601, 1367, -968, 53 },
  { -3808, 958, 44, 2560 },
  { -2079, 2530, -1485, 1166 },
  { -3707, 343, -2889, 180 },
  { -5249, 1431, -31, 688 },
  { -4990, 125, -704, 1270 },
  { -2771, 1334, -2446, 746 },
  { -2292, 994, -1527, 2630 },
  { -1261, 3070, -2519, 268 },
  { -2544, 3890, -1057, -552 },
  { -4421, 255, -1980, 530 },
  { -2951, 454, -13, 3643 },
  { -2262, 1815, -370, 2880 },
  { -2383, 3657, -649, 576 },
  { -3541, -161, -1389, 2550 },
  { -4241, 1575, 1325, 2561 },
  { -2767, 4037, 1221, 1578 },
  { -3748, 2697, 1148, 1801 },
  { -4686, 2385, -220, 0 },
  { -1531, 1645, -2751, 1327 },
  { -45, 4032, -799, 2298 },
  { -2915, 2280, 709, 2495 },
  { -1199, 3278, -406, 2346 },
  { -2471, 116, -2706, 2060 },
  { -2440, 2173, -2894, -344 },
  { -3375, 2287, 1781, 3226 },
  { -2153, 3568, 1827, 2918 },
  { -862, 2267, -1626, 2527 },
  { -2698, 1135, 301, 4239 },
  { -2364, 2123, 1010, 3710 },
  { -2447, 3281, -81, 1408 },
  { -2660, 4735, 472, 258 },
  { -1053, 3097, 2682, 2398 },
  { -3366, -1037, -1152, -868 },
  { -643, 4242, 2212, 1259 },
  { 971, 3991, 934, 643 },
  { -1617, 2002, 2139, 2195 },
  { -4897, 972, 784, 1719 },
  { -1275, 2992, 1039, 3821 },
  { -392, 4973, -209, 1821 },
  { -1028, 4718, -1479, -137 },
  { 50, 3914, 553, 2210 },
  { 678, 4364, 359, 1303 },
  { -582, 4911, 514, 1671 },
  { 1276, 3914, -1252, 2934 },
  { -1496, 3984, 857, 2330 },
  { 772, 4744, -655, 2332 },
  { -799, 5283, -439, 624 },
  { 1341, 2937, 650, 2027 },
  { -1739, 4892, 1275, 1702 },
  { -892, 2596, -151, 3951 },
  { -3532, 1090, 1292, 32 },
  { 321, 3146, 2647, 1475 },
  { 264, 4199, -1591, 1317 },
  { -452, -2357, 2266, 4192 },
  { 3022, -1033, -2389, 5678 },
  { -1162, -1342, 3543, 4990 },
  { -474, -1477, -1223, 5016 },
  { -699, -2857, 900, 3835 },
  { -461, -2255, -117, 4626 },
  { 1204, -2062, -1211, 4403 },
  { 2192, -3035, -337, 3966 },
  { 108, -831, 279, 5643 },
  { 1457, -620, -2908, 5276 },
  { -2527, -78, 1085, 5460 },
  { -1978, -1918, -949, 4733 },
  { 32, 367, -1904, 5166 },
  { 1890, -1665, 440, 4752 },
  { -518, -348, 2816, 4891 },
  { 3695, -2490, -1374, 4603 },
  { 246, -1965, 3549, 3969 },
  { 1100, -3111, 656, 3737 },
  { -1379, 870, -414, 4575 },
  { 628, -357, -1227, 6179 },
  { -1129, -1318, -2457, 4576 },
  { -425, -98, -73, 6336 },
  { 367, -887, 2990, 4207 },
  { 2091, -1251, 2444, 3557 },
  { -1759, -1610, 2046, 5273 },
  { 3210, 1414, -20, 2616 },
  { 3303, -2636, 1005, 4237 },
  { -327, -3107, -640, 3687 },
  { -197, 764, 572, 5486 },
  { 646, -767, 1388, 5464 },
  { 104, 2742, -228, 3907 },
  { -236, 1829, -579, 4585 },
  { -2150, -474, -1525, 4006 },
  { -23, -2632, -2400, 3892 },
  { -12, -1739, -2910, 4867 },
  { -2310, -368, -102, 4583 },
  { -1991, -2061, 533, 4531 },
  { 3884, -1446, -153, 4393 },
  { 1568, 14, -289, 5268 },
  { -1376, -253, -2797, 3417 },
  { 3193, -2577, 2475, 3566 },
  { 3418, 617, 1350, 1857 },
  { 3792, -24, -272, 3370 },
  { 153, 1159, 2906, 2877 },
  { 511, 2162, 1548, 2741 },
  { 262, 819, -2791, 3734 },
  { 4232, -2015, 1486, 3477 },
  { 2943, -1110, -1014, 5480 },
  { 2842, 369, 703, 3476 },
  { 3011, 1634, -933, 3553 },
  { 4412, -1548, -942, 5021 },
  { -1405, 593, 2372, 5267 },
  { 2093, 2129, 896, 2365 },
  { 4845, -1980, 0, 3823 },
  { -2140, 81, 3278, 5637 },
  { 1484, 2665, -324, 3653 },
  { 10, 192, 1620, 5291 },
  { 2152, 738, -2269, 5000 },
  { 2102, 2748, -1652, 4707 },
  { 2855, -2131, -387, 5188 },
  { 1173, 676, 1338, 3277 },
  { 2340, -2329, -2064, 4095 },
  { 861, -2024, 1296, 5055 },
  { 2189, 3225, -695, 2626 },
  { 6196, -7079, 1943, -822 },
  { 4547, -4813, 3261, 1856 },
  { 4243, -6904, 3443, 448 },
  { 4581, -7503, 946, 506 },
  { 6626, -7754, 3427, 470 },
  { 3407, -9088, 3269, -1496 },
  { 4079, -6464, 2304, 777 },
  { 5621, -9336, 2684, -768 },
  { 5351, -6464, 5238, -214 },
  { 5961, -8007, 1724, -3091 },
  { 4213, -8067, 603, -246 },
  { 7208, -7403, 3168, -1738 },
  { 6098, -7700, 329, -1379 },
  { 6525, -6735, 4248, -1072 },
  { 6073, -6241, 2167, -2378 },
  { 4609, -9218, 3051, -1033 },
  { 6813, -7283, 1581, -1897 },
  { 6126, -6275, 2789, 681 },
  { 4423, -6538, 1621, -1692 },
  { 6272, -8298, 3167, -1855 },
  { 6172, -8558, 4498, -1169 },
  { 4844, -8588, 1647, -366 },
  { 6209, -8807, 1581, -369 },
  { 5389, -8059, 550, -192 },
  { 6654, -9775, 2504, -1063 },
  { 7103, -7998, 806, 530 },
  { 5662, -6736, 1565, -3620 },
  { 4165, -9564, 4191, -2131 },
  { 4526, -7181, 576, -2875 },
  { 4633, -8623, 2807, -4742 },
  { 3709, -7794, 1815, 34 },
  { 3634, -8622, 2313, -826 },
  { 6991, -8447, 2063, -3198 },
  { 7757, -9486, 2255, -558 },
  { 4149, -7778, 4728, -1696 },
  { 5767, -7427, 1113, 707 },
  { 4592, -6261, 2329, 1864 },
  { 3159, -10498, 1677, -4273 },
  { 3534, -9010, 2437, -3565 },
  { 4479, -10821, 2715, -4942 },
  { 3207, -9805, 3054, -3886 },
  { 4627, -8189, 3018, -2354 },
  { 5527, -10566, 3244, -2749 },
  { 4346, -10127, 3335, -3084 },
  { 6132, -10085, 3316, -1308 },
  { 5629, -9704, 2178, -3058 },
  { 3603, -8538, 1246, -624 },
  { 3737, -8488, 395, -3167 },
  { 5465, -11414, 2810, -4640 },
  { 5306, -7745, 2721, -3988 },
  { 7000, -9111, 1695, -1409 },
  { 6663, -7741, 2466, -4079 },
  { 4083, -7175, 1836, -4831 },
  { 3613, -9926, 1342, -3455 },
  { 6588, -8033, 457, -258 },
  { 4720, -8102, 17, -1209 },
  { 7414, -8709, 1294, -344 },
  { 5437, -10030, 4043, -1704 },
  { 4862, -9281, 1558, -1431 },
  { 6800, -6403, 5113, 862 },
  { 4623, -8242, 2667, -228 },
  { 5919, -5083, 3348, 2135 },
  { 5985, -8889, 2733, -5105 },
  { 5029, -5767, 4407, 719 },
  { 354, -6158, -838, -3001 },
  { 351, -5943, -2104, -1534 },
  { -633, -7190, -25, -4798 },
  { -1595, -7235, -3812, -1400 },
  { 103, -6197, -2933, -78 },
  { -1722, -5020, -3441, -4333 },
  { -1963, -5644, -4365, -270 },
  { -846, -5743, -3477, 196 },
  { -191, -5348, -4054, -469 },
  { -2515, -7754, -3495, -818 },
  { -2090, -6710, -2701, 117 },
  { -546, -7036, -1398, 163 },
  { -278, -7091, -2662, -536 },
  { -622, -7962, -2731, -1464 },
  { -1555, -8118, -3612, -2057 },
  { -1094, -6280, -2314, 505 },
  { -2556, -8538, -4024, -2247 },
  { 109, -7134, -3107, -1823 },
  { -900, -6954, -3340, -717 },
  { -605, -7113, -3656, -2154 },
  { 837, -6263, -3211, -2177 },
  { -417, -5810, -3871, -1469 },
  { -1318, -5649, -4207, -3198 },
  { 413, -6765, -2082, -33 },
  { -3101, -6450, -4362, -766 },
  { 755, -6489, -2967, -846 },
  { 1117, -7106, -2452, -1352 },
  { -1202, -8387, -3072, -2897 },
  { -365, -4894, -3561, -2937 },
  { -2372, -8776, -265, -4441 },
  { -1224, -8678, -896, -5074 },
  { -755, -10096, -600, -6623 },
  { 300, -8206, -225, -4568 },
  { -1176, -6824, -2633, -3527 },
  { -2006, -5443, -1526, -5849 },
  { -1115, -5540, -2363, -4785 },
  { 1059, -6812, -2543, -2654 },
  { -1976, -6861, -3062, -5508 },
  { -379, -5328, -2321, -3624 },
  { -2108, -5860, -4518, -1915 },
  { -379, -7885, -1329, -594 },
  { 774, -5389, -581, -5213 },
  { -2601, -5083, -1849, -4921 },
  { -176, -5580, 74, -5075 },
  { -204, -6780, -190, -6232 },
  { 418, -7594, -1987, -820 },
  { -1873, -8529, -2926, -1609 },
  { 1340, -6362, -919, -4975 },
  { 577, -7990, -2044, -1873 },
  { -2572, -7413, -1745, -2224 },
  { -2037, -7030, -1461, -7138 },
  { -2559, -8756, -2039, -5836 },
  { -2079, -6764, -1209, -5669 },
  { -1613, -7801, -2006, -685 },
  { -1865, -6583, -722, -3529 },
  { -589, -6358, -1377, -1003 },
  { -540, -7514, -1331, -3542 },
  { 419, -6192, -1677, -4927 },
  { -2786, -8763, -2966, -5065 },
  { -2172, -8411, -1726, -4675 },
  { -3382, -9833, -3497, -5722 },
  { -2433, -10169, -2077, -5775 },
  { -424, -9451, -1096, -3658 },
  { -537, -8522, -910, -1897 },
  { -5550, 2807, 1683, -693 },
  { -6395, 635, 3573, -1246 },
  { -7544, 2280, 2140, 44 },
  { -8751, 1136, 2951, -794 },
  { -5605, 2709, 2052, 916 },
  { -7650, 654, 869, 135 },
  { -6939, 967, 1409, 870 },
  { -7834, 2123, 3310, 974 },
  { -6935, 2818, 1274, -1678 },
  { -5605, 2233, 1013, 471 },
  { -7095, 1849, 1648, 198 },
  { -6636, 1634, 712, -37 },
  { -7279, 978, 296, -315 },
  { -7664, 3504, 3292, -216 },
  { -7836, 1209, 1221, -257 },
  { -7913, 2201, 1765, -1529 },
  { -7077, 3783, 2632, -1407 },
  { -5565, 1645, 1410, -622 },
  { -6494, 2879, 1181, -759 },
  { -7073, 3137, 3010, 550 },
  { -7249, 1839, 847, -805 },
  { -6630, 2197, 282, -1096 },
  { -8836, 1573, 1988, -1090 },
  { -7809, 1274, 836, -1198 },
  { -7895, 2970, 3511, -1097 },
  { -6960, 1664, 1356, -2442 },
  { -6582, 2866, 2273, 307 },
  { -7221, 821, 2851, -1435 },
  { -6015, 1703, 2001, -2367 },
  { -8082, 1034, 2103, 239 },
  { -5952, 1912, 301, -465 },
  { -6099, 841, 379, 567 },
  { -6343, 50, 494, 658 },
  { -6586, 983, 591, -893 },
  { -5500, 869, 2187, -2479 },
  { -6482, 60, 1545, -979 },
  { -6705, 515, 1974, -53 },
  { -6460, 1755, 1325, -1275 },
  { -6093, 2617, 2465, -623 },
  { -7330, 2161, 594, -2115 },
  { -7324, 762, 1593, -2004 },
  { -6385, 679, 1510, -2514 },
  { -6159, 241, 2976, -1631 },
  { -8583, 3030, 4045, -162 },
  { -6299, 66, 2209, -2103 },
  { -5428, 1279, 3267, -1846 },
  { -6438, 1335, 2728, -1631 },
  { -8012, 1070, 2428, -1151 },
  { -6201, 2781, 2349, -1918 },
  { -5918, 1139, 3121, -148 },
  { -6314, 2481, 3137, -1808 },
  { -7180, 1722, 2435, -1602 },
  { -6750, 1829, 3763, -1145 },
  { -6713, 1777, 2221, 1212 },
  { -7479, 1835, 3627, -479 },
  { -7299, 10, 2406, -1593 },
  { -8249, 3129, 996, -2870 },
  { -8374, 1534, 1333, -1882 },
  { -7507, 3353, 1598, -2299 },
  { -7379, 2701, 2326, -1167 },
  { -8440, 2276, 2796, -542 },
  { -10348, 1527, 2649, -1165 },
  { -8184, 3614, 2574, -1738 },
  { -5539, 1574, 1733, 1138 },
  { 9404, -7652, 67, 79 },
  { 8654, -3972, 1358, -60 },
  { 8617, -4794, 117, 2318 },
  { 7886, -4505, 1784, 1200 },
  { 8636, -6125, 3879, -1003 },
  { 9654, -6836, 1816, 205 },
  { 9374, -6553, 913, 1875 },
  { 8020, -6150, 1134, 2390 },
  { 7786, -4970, 2078, -1857 },
  { 8691, -6119, 711, 708 },
  { 9039, -5568, 2944, -1902 },
  { 9955, -5048, 1433, -601 },
  { 8089, -6927, 3093, -2846 },
  { 8487, -7024, 2415, 19 },
  { 9388, -5287, 3577, -2655 },
  { 8591, -7371, 2300, -996 },
  { 9104, -4763, 1453, -2558 },
  { 7615, -5457, 596, 164 },
  { 9860, -7047, 3433, -614 },
  { 8756, -4404, 2235, -964 },
  { 9462, -4660, 299, -1822 },
  { 10119, -5550, 2689, -1273 },
  { 10915, -7471, 2705, -1007 },
  { 11433, -7090, 1410, -1198 },
  { 9882, -7431, 2965, -1895 },
  { 7628, -5219, 769, -2661 },
  { 8169, -5318, 2262, 70 },
  { 8846, -6320, 1939, -754 },
  { 7147, -5593, 1248, -971 },
  { 10652, -5485, 935, 137 },
  { 7778, -6533, 2564, -1932 },
  { 8878, -5173, 1214, -361 },
  { 9828, -4943, 282, 510 },
  { 10042, -6134, 3895, -1914 },
  { 7965, -6630, 3566, -433 },
  { 8573, -4502, 3574, -1209 },
  { 8398, -4801, 1031, -1347 },
  { 10136, -7772, 2612, 1547 },
  { 9890, -7280, 1768, -1083 },
  { 8407, -6585, -706, -58 },
  { 7976, -7582, 229, -131 },
  { 10481, -8866, 1166, -147 },
  { 10914, -4342, 3189, -2412 },
  { 10440, -5198, -104, -1109 },
  { 11227, -6530, 2381, -2449 },
  { 8487, -8064, 1086, 230 },
  { 9975, -6123, -857, -134 },
  { 8339, -6498, 1232, -2337 },
  { 11042, -4506, 1119, -2098 },
  { 12563, -5592, 1837, -2062 },
  { 11801, -5590, 632, -1296 },
  { 10152, -5617, 1511, -1917 },
  { 7800, -6473, 51, -1337 },
  { 7941, -5560, 2438, -3270 },
  { 6554, -3834, 2100, 1476 },
  { 9065, -5520, -226, -1120 },
  { 10794, -7120, -243, 122 },
  { 10429, -6968, 272, -806 },
  { 8942, -8914, 1442, -392 },
  { 9969, -5051, 2033, -2953 },
  { 7275, -4152, 3058, -64 },
  { 11127, -5488, 4589, -3227 },
  { 9626, -6666, 2739, -2958 },
  { 6943, -5362, 4470, 1008 },
  { -7456, -967, 2936, -1002 },
  { -8622, -333, 6962, 2606 },
  { -7486, -3392, 3668, 1287 },
  { -8053, -827, 5148, 1097 },
  { -6610, 454, 4952, 96 },
  { -7701, -1982, 3161, -468 },
  { -7307, -1132, 4071, -36 },
  { -8125, -271, 5199, 3862 },
  { -9182, -1950, 2813, 1878 },
  { -9855, -952, 4794, 3010 },
  { -7241, 1431, 4202, 2468 },
  { -9646, 157, 4766, 1046 },
  { -9371, 1230, 6009, 2958 },
  { -11514, -64, 8630, 5248 },
  { -6766, 565, 2766, 2140 },
  { -8426, -9, 2852, 1271 },
  { -11291, -1113, 5087, 2937 },
  { -8297, 2092, 4495, 1264 },
  { -9983, 735, 3809, -51 },
  { -9048, -1000, 3191, -308 },
  { -7331, -1987, 2655, 1391 },
  { -7144, -21, 4333, 2161 },
  { -6032, -1540, 3543, 896 },
  { -7987, -1036, 1985, 1529 },
  { -9264, 2004, 5194, 290 },
  { -11308, -840, 5754, 1654 },
  { -9130, -2398, 4292, 2973 },
  { -6248, 838, 3563, 1223 },
  { -6819, -2760, 3511, 119 },
  { -7213, -2006, 4364, 762 },
  { -5431, -1047, 4533, 166 },
  { -7098, -641, 2021, 639 },
  { -8628, -2249, 3588, 399 },
  { -6352, -1498, 3560, -648 },
  { -7033, -2190, 4870, 2562 },
  { -7405, -46, 3772, -581 },
  { -6104, 796, 5143, 1965 },
  { -5787, 943, 5784, 3030 },
  { -8367, 1465, 7192, 4097 },
  { -8259, 789, 5694, 1963 },
  { -10614, -1899, 5748, 2645 },
  { -8258, -805, 3698, 2275 },
  { -6877, -972, 6431, 3160 },
  { -6483, 363, 7018, 3129 },
  { -6283, -1358, 5191, 1524 },
  { -8853, -3157, 4119, 1741 },
  { -6086, -267, 3883, -835 },
  { -7254, 1032, 6613, 4017 },
  { -11470, -3350, 4649, 3426 },
  { -6743, 481, 6148, 1239 },
  { -5394, -166, 5309, 3165 },
  { -7958, 1068, 4268, -240 },
  { -10520, 2256, 7916, 2828 },
  { -5132, -4, 5739, 1176 },
  { -8643, 120, 3255, -629 },
  { -9631, 1974, 8870, 4362 },
  { -10663, -1221, 3733, 589 },
  { -8224, -1843, 5806, 2655 },
  { -8282, 1255, 8647, 3478 },
  { -12311, -1505, 9043, 6256 },
  { -11312, -856, 7136, 4681 },
  { -11944, -722, 7941, 3309 },
  { -7868, -463, 6846, 4196 },
  { -8679, -241, 7410, 5347 },
  { 6759, -4680, -508, 1220 },
  { 5176, -6111, 944, 121 },
  { 6843, -5667, -1368, -533 },
  { 5616, -5884, -1471, -695 },
  { 6030, -5089, -1808, -940 },
  { 7444, -5463, -52, 1881 },
  { 4207, -6079, -506, 1571 },
  { 6785, -4410, -649, 3084 },
  { 4838, -5214, 2026, 2998 },
  { 4201, -5790, 645, 1811 },
  { 6930, -5129, -1940, 1698 },
  { 6332, -4627, 692, 3027 },
  { 6285, -4314, -106, 3644 },
  { 6255, -5450, -1975, 742 },
  { 4199, -4676, -459, 1796 },
  { 5592, -5500, 1345, 1300 },
  { 4358, -5556, -2236, 114 },
  { 4620, -5875, -1563, 888 },
  { 4892, -7550, -327, -419 },
  { 4734, -7085, 7, 613 },
  { 3883, -5562, -1969, 1080 },
  { 5610, -4990, -204, 834 },
  { 4117, -6482, -1271, 341 },
  { 6585, -5107, 892, 1169 },
  { 6632, -3683, 302, 3002 },
  { 6326, -5351, -983, -1250 },
  { 4382, -7192, -730, -158 },
  { 5227, -6540, -451, 1123 },
  { 5468, -6472, -870, -1471 },
  { 5191, -6402, -1365, -127 },
  { 7407, -6317, -973, -336 },
  { 4611, -6530, -820, -1980 },
  { 4963, -5159, -2050, -966 },
  { 4414, -5691, -211, -998 },
  { 5954, -5873, 750, -1749 },
  { 4394, -4796, -1268, 254 },
  { 7161, -6214, -1010, 689 },
  { 4965, -3598, 2372, 1711 },
  { 6248, -6180, 981, 864 },
  { 6473, -5336, 525, -600 },
  { 4591, -6864, -1131, -900 },
  { 6314, -6440, -1021, -375 },
  { 5838, -6209, -1199, 944 },
  { 5308, -5283, -2100, 1267 },
  { 4342, -5860, -1637, -1356 },
  { 5680, -4388, -1227, -104 },
  { 4900, -4098, 1449, 4046 },
  { 4677, -4284, -106, 3190 },
  { 7574, -6173, -848, 1859 },
  { 6493, -7207, -131, 726 },
  { 5513, -5261, -2117, 4 },
  { 6191, -7352, -193, -505 },
  { 5885, -4333, 324, -134 },
  { 6162, -6081, -312, -2044 },
  { 4216, -6200, -1810, -572 },
  { 5652, -7035, -696, -197 },
  { 7131, -7189, -366, -60 },
  { 5032, -4803, -1514, 2832 },
  { 7386, -4610, -606, 3489 },
  { 4211, -5031, 1221, 3047 },
  { 4050, -4653, 1584, 1469 },
  { 6852, -5302, -1861, 206 },
  { 7736, -4816, -1794, 3359 },
  { 6290, -3439, 1522, 2454 },
  { 1768, 5990, -5560, -2594 },
  { 3903, 5326, -1530, -1501 },
  { 2472, 3738, -2117, -4240 },
  { 3260, 5448, -904, -4733 },
  { 1435, 7297, -3676, -4102 },
  { 4096, 5951, -656, -3312 },
  { 2178, 6009, -3146, -3724 },
  { 3787, 5493, -5473, -1633 },
  { 2998, 7286, -3334, -3571 },
  { 2894, 6576, -4708, -2804 },
  { 830, 6163, -4286, -3348 },
  { 4755, 5569, -1730, -2739 },
  { 4604, 6065, -3562, -2605 },
  { 2749, 5141, -3986, -2775 },
  { 3942, 4875, -2143, -3340 },
  { 2819, 8517, -2004, -2724 },
  { 2146, 6298, -689, -3093 },
  { 5196, 6504, -3393, -1475 },
  { 1851, 8386, -1748, -1420 },
  { 3474, 8572, -3534, -2688 },
  { 4503, 7560, -3561, -2245 },
  { 4433, 6219, -2393, -1575 },
  { 3506, 7248, -2275, -1977 },
  { 3490, 7409, -3147, -604 },
  { 4214, 6447, -3520, 516 },
  { 619, 7034, -829, -1705 },
  { 1732, 7395, -356, -2208 },
  { 1226, 5204, -3294, -3732 },
  { 2027, 5619, -1813, -4146 },
  { 3078, 5877, 47, -2651 },
  { 1654, 5458, 424, -682 },
  { 3163, 5464, -2026, -270 },
  { 2884, 5375, -685, -530 },
  { 2950, 7286, -35, -2967 },
  { 1986, 5066, -597, 482 },
  { 3459, 4308, -3845, -2333 },
  { 3155, 7037, -1346, -4345 },
  { 2193, 6696, -717, -1319 },
  { 3677, 5089, -3892, -487 },
  { 2186, 5136, -4186, -1492 },
  { 773, 5796, -917, 817 },
  { 2489, 6546, -3570, -2117 },
  { 1223, 6469, -1362, -33 },
  { 271, 6061, -1466, -1725 },
  { 2540, 5171, -1847, 1032 },
  { 2548, 5251, -2697, 1677 },
  { 771, 7600, -768, -632 },
  { 4710, 6647, -4736, -1275 },
  { 1369, 5917, -2971, -1056 },
  { 163, 5239, -3499, -2275 },
  { 2104, 4285, -3211, -3286 },
  { 1107, 7411, -1972, -1671 },
  { 2196, 7262, -2310, -1926 },
  { -244, 6439, -1745, -839 },
  { 3293, 3832, -2890, -3000 },
  { 419, 6443, -379, -407 },
  { 3077, 4930, -1156, -2869 },
  { 2131, 5874, -2330, 224 },
  { 690, 6538, -2212, -2841 },
  { 1602, 4421, -2515, 1542 },
  { 3318, 9373, -3032, -3477 },
  { 5646, 7462, -5153, -1463 },
  { 4139, 7137, -1539, -3321 },
  { 3481, 9077, -1645, -3653 },
  { -7747, 375, -106, -543 },
  { -8587, -1379, -586, -461 },
  { -10146, -892, 2094, 694 },
  { -8103, 382, 504, -325 },
  { -8548, -92, 94, -656 },
  { -7460, 38, 152, 388 },
  { -8266, -271, -459, -883 },
  { -7935, -664, -1026, -802 },
  { -8341, -109, 853, 161 },
  { -8802, -1355, 1099, 630 },
  { -8957, -6, 1108, -669 },
  { -7260, -1520, -43, -407 },
  { -7555, -174, 668, -2562 },
  { -9014, -126, 227, -1191 },
  { -8184, 769, 290, -1375 },
  { -9476, 55, 962, -1528 },
  { -8679, 541, 755, -1030 },
  { -9842, -1626, 838, -1588 },
  { -8513, -702, 788, -1998 },
  { -10101, -1558, -366, -1841 },
  { -8135, 78, 1479, -1813 },
  { -9128, -454, 313, -1786 },
  { -7554, -1084, 831, -2442 },
  { -7576, -701, 2068, -1665 },
  { -7791, -1481, 1587, -1808 },
  { -6701, -596, -97, 802 },
  { -7418, -15, 684, -963 },
  { -7127, -477, -139, -426 },
  { -8097, -110, -36, -264 },
  { -7620, -1922, -590, -101 },
  { -7647, -1201, 279, 660 },
  { -7856, -1974, 758, -2271 },
  { -8496, -167, 2232, -1143 },
  { -8506, -1359, 624, -740 },
  { -7274, -1052, 1062, -139 },
  { -7800, -217, 91, -1794 },
  { -7030, -1694, -955, 615 },
  { -9020, -1864, 101, -2182 },
  { -9400, -740, 598, -667 },
  { -8448, -1184, 2024, -1272 },
  { -8812, -570, -897, -2384 },
  { -10559, -1286, 538, -1536 },
  { -8728, -888, -1089, -1397 },
  { -7080, -1185, 636, -1252 },
  { -9880, 233, 2344, -782 },
  { -7952, -1326, -378, -1947 },
  { -7207, -378, 1408, -2237 },
  { -8467, -1545, 902, -1987 },
  { -9163, -1474, 924, -1739 },
  { -8159, -992, -77, -2744 },
  { -8343, 148, -423, -1573 },
  { -9105, -649, -254, -1214 },
  { -8939, 456, 281, -1905 },
  { -8837, 179, -394, -2634 },
  { -9145, 757, 1547, -1319 },
  { -9775, -723, 441, -1680 },
  { -8910, -686, 1529, -1525 },
  { -9492, -1134, 2064, -938 },
  { -6111, -943, 677, -31 },
  { -7411, -613, -814, 46 },
  { -9479, -922, -430, -2061 },
  { -11298, -1268, 1318, -1117 },
  { -8190, 832, 671, -2214 },
  { -10453, -550, 1672, -886 },
  { 1044, 9353, -1651, -5423 },
  { 1034, 8149, -455, -6166 },
  { 761, 8293, -3214, -4838 },
  { 938, 8077, 164, -5130 },
  { 1295, 8673, 2582, -5490 },
  { -314, 7973, -2395, -5231 },
  { -507, 9012, -2497, -5775 },
  { 2396, 8314, -1022, -4673 },
  { -1516, 8501, 1950, -4969 },
  { -308, 7401, 1549, -4866 },
  { -112, 8340, 3003, -4920 },
  { -50, 9315, 1371, -5666 },
  { -659, 9449, 2496, -5547 },
  { 2573, 9148, -2270, -4783 },
  { 830, 7104, -438, -3907 },
  { 522, 10672, -677, -6483 },
  { -1190, 10108, -510, -6518 },
  { -427, 8271, -579, -6315 },
  { 1602, 8113, -1927, -4418 },
  { -2266, 8180, 448, -5190 },
  { -1633, 8816, -226, -5771 },
  { 759, 9481, -105, -5813 },
  { 2254, 6679, -466, -5662 },
  { -88, 6946, 895, -5958 },
  { -1705, 10009, 1394, -5574 },
  { 748, 7943, 540, -6692 },
  { 1411, 7009, 232, -6145 },
  { 697, 7290, -1221, -5342 },
  { -1764, 10580, 1944, -3981 },
  { -1334, 9124, 1195, -3903 },
  { -905, 10067, 635, -5039 },
  { 664, 10680, 49, -4625 },
  { 1374, 9536, -777, -3591 },
  { 252, 9698, -597, -2931 },
  { 824, 9164, -1014, -2144 },
  { 2438, 10569, -2289, -4424 },
  { 2101, 7102, 507, -3614 },
  { 294, 8051, -432, -1518 },
  { -665, 10337, 547, -2852 },
  { 1168, 11989, -492, -5427 },
  { 1344, 6416, 302, -5061 },
  { -1727, 12264, 1507, -4543 },
  { 674, 10889, -902, -3605 },
  { -582, 9504, 300, -3618 },
  { 641, 7654, 689, -2109 },
  { 2065, 9243, 508, -4367 },
  { 1055, 8373, 688, -3144 },
  { -641, 8185, 986, -3307 },
  { 1120, 7426, 1785, -3757 },
  { 1660, 8070, -593, -3104 },
  { 2002, 9467, -1722, -3475 },
  { 2361, 8368, 100, -3709 },
  { -772, 7845, -613, -4988 },
  { 1485, 7430, 1896, -6127 },
  { -432, 7823, -947, -2882 },
  { 313, 11122, -760, -4871 },
  { 412, 8412, -283, -4231 },
  { 1585, 10402, -1884, -3267 },
  { 321, 6952, 773, -3016 },
  { -105, 9014, 121, -2249 },
  { 1585, 10313, -977, -4812 },
  { 1619, 11869, 1306, -6876 },
  { -1168, 8886, -81, -2500 },
  { -395, 10886, 733, -6490 },
  { -4949, 4274, 3992, -1054 },
  { -4241, 5299, 4262, -1584 },
  { -2710, 3862, 4552, -1673 },
  { -4608, 2472, 3672, -1715 },
  { -2843, 2816, 4003, -2326 },
  { -5229, 2964, 5636, 90 },
  { -4924, 3442, 5015, -1096 },
  { -1281, 3313, 5537, -2066 },
  { -3808, 1939, 4351, -919 },
  { -1915, 2585, 4939, -1614 },
  { -3470, 1843, 5562, -682 },
  { -3800, 870, 5827, 144 },
  { -4985, 1452, 4728, -709 },
  { -3745, 2750, 7220, 259 },
  { -1875, 1900, 6514, -826 },
  { -4329, 1574, 7192, 1304 },
  { -5408, 1444, 6208, 631 },
  { -3327, 5312, 5707, -1541 },
  { -6966, 3334, 4034, 1028 },
  { -7484, 4245, 4218, -212 },
  { -6567, 5839, 4539, -512 },
  { -5715, 5935, 3747, -1186 },
  { -6410, 4881, 3356, -1610 },
  { -5146, 2590, 2850, 2172 },
  { -5196, 4095, 2569, -373 },
  { -5043, 6025, 4318, 692 },
  { -5525, 4884, 3513, 370 },
  { -6804, 7533, 5812, -488 },
  { -5657, 2480, 4061, 1234 },
  { -3155, 1472, 6071, 1188 },
  { -3427, 5217, 3442, 858 },
  { -4698, 3013, 5517, 2586 },
  { -4449, 2226, 5418, 3580 },
  { -6395, 3547, 5487, 2028 },
  { -3500, 5019, 4787, 1 },
  { -4038, 2578, 3073, 3151 },
  { -2750, 1955, 4469, 3856 },
  { -5696, 1659, 6118, 2469 },
  { -4350, 1241, 6840, 3126 },
  { -5565, 5058, 5196, 1314 },
  { -1642, 4190, 3948, 607 },
  { -1233, 4108, 4850, -640 },
  { -997, 3428, 3239, 1378 },
  { -6488, 2741, 6926, 2792 },
  { -4188, 3763, 4235, 2018 },
  { -3210, 3224, 5646, 1427 },
  { -5526, 6909, 5070, -627 },
  { -2815, 3994, 3425, 1903 },
  { -2163, 2734, 5423, 145 },
  { -4149, 4247, 2355, 734 },
  { -410, 2521, 4138, -16 },
  { -2411, 2385, 4927, 2105 },
  { -6077, 3591, 3114, 594 },
  { -4186, 4834, 5926, -1004 },
  { -7315, 3369, 5966, 448 },
  { -7042, 5721, 5771, 238 },
  { -4466, 3907, 3535, -1751 },
  { -2116, 3970, 6163, -1392 },
  { -7239, 2143, 8407, 3630 },
  { -5431, 4486, 6486, -42 },
  { -1874, 1617, 6333, 519 },
  { -6478, 2629, 4634, -505 },
  { -7784, 2342, 7216, 1365 },
  { -1154, 1432, 4831, 1544 },
  { -4964, -5801, 1797, 506 },
  { -4436, -6905, 1059, -1237 },
  { -5400, -6886, 884, -290 },
  { -6259, -7103, 523, -227 },
  { -4819, -6450, 1412, -450 },
  { -4056, -6213, 1725, -943 },
  { -5642, -6091, 1357, 605 },
  { -4196, -5678, 2187, -173 },
  { -4726, -5126, 2470, 321 },
  { -6642, -5091, 1507, -1005 },
  { -5304, -5250, 1944, 1579 },
  { -7179, -5520, 1468, -425 },
  { -6033, -4895, 1876, -955 },
  { -6595, -5143, 2207, 1291 },
  { -4224, -4943, 1846, 1792 },
  { -7128, -6950, 539, 724 },
  { -4369, -4901, 2590, 1103 },
  { -7413, -5696, 1712, 1440 },
  { -5885, -6821, 418, 871 },
  { -6828, -5599, 710, -1563 },
  { -6123, -5817, 1358, 1631 },
  { -5291, -5622, 578, 2138 },
  { -7171, -6004, 347, 2208 },
  { -6083, -5251, 2132, 425 },
  { -4329, -5721, 407, -2993 },
  { -5326, -5056, 1119, -1837 },
  { -5485, -5856, 185, -2389 },
  { -6529, -5178, 403, -697 },
  { -6719, -4412, 2726, 871 },
  { -5126, -5629, 1835, -771 },
  { -5622, -4361, 2973, 858 },
  { -5282, -5895, 45, -335 },
  { -4357, -5656, 1696, -1558 },
  { -7139, -6659, 627, -409 },
  { -4415, -6328, 35, 1306 },
  { -7639, -6110, 1134, 197 },
  { -3626, -5592, 2019, 901 },
  { -3547, -5064, 1176, 1738 },
  { -5075, -3899, 2087, 266 },
  { -4086, -6311, 1479, 360 },
  { -6210, -5220, -199, -1477 },
  { -3910, -5063, 1356, -15 },
  { -7616, -4977, 461, 2401 },
  { -6118, -6131, 1258, -563 },
  { -6127, -4968, 1286, -27 },
  { -4121, -5852, 1113, 1476 },
  { -5157, -4881, 1162, -662 },
  { -4637, -5031, 1179, 709 },
  { -5509, -5452, -397, 1224 },
  { -4597, -6861, 646, 467 },
  { -6247, -4043, 468, 278 },
  { -5336, -6465, 874, -1472 },
  { -6998, -6346, 78, -1798 },
  { -4915, -4530, 2756, -203 },
  { -6048, -4373, 1468, 1052 },
  { -4273, -7100, 942, -323 },
  { -6552, -4287, 2351, 69 },
  { -6954, -4613, 722, 1521 },
  { -4201, -5361, 763, -1562 },
  { -6881, -5596, -748, 669 },
  { -6695, -3547, -34, 1299 },
  { -3981, -5728, 84, 111 },
  { -4663, -4809, 2173, -1031 },
  { -6599, -6077, 1303, 256 },
  { -7596, -4265, -5791, -4140 },
  { -6610, -2758, -5288, -3936 },
  { -5880, -3865, -6563, -3088 },
  { -7228, -5510, -7677, -3912 },
  { -8854, -6553, -8318, -5361 },
  { -9362, -5249, -6413, -4319 },
  { -4418, -3110, -6368, -4358 },
  { -5544, -4203, -6863, -5013 },
  { -3056, -4316, -5567, -3181 },
  { -3078, -5999, -5051, -2657 },
  { -5884, -6292, -5756, -4013 },
  { -4825, -4549, -5535, -4053 },
  { -4443, -6126, -5316, -1368 },
  { -3972, -6341, -6098, -2686 },
  { -5751, -2781, -5398, -6230 },
  { -4466, -6135, -5570, -3679 },
  { -4291, -5992, -3564, -5189 },
  { -7189, -4429, -7279, -6082 },
  { -5076, -4433, -2748, -5366 },
  { -6225, -2825, -6833, -5663 },
  { -2989, -4792, -3960, -4492 },
  { -7836, -7773, -7722, -5741 },
  { -6559, -5703, -5844, -5589 },
  { -7612, -5438, -4136, -3774 },
  { -4218, -4176, -6591, -2333 },
  { -4837, -5063, -6581, 322 },
  { -6590, -5990, -2980, -3847 },
  { -5558, -2971, -5489, -1932 },
  { -7001, -5323, -4975, -1697 },
  { -4694, -2688, -6904, -3044 },
  { -8511, -5379, -5767, -2549 },
  { -7548, -5412, -6522, -2572 },
  { -6597, -4973, -6423, -1274 },
  { -6415, -4022, -5168, -1072 },
  { -5528, -5530, -7218, -2345 },
  { -4845, -4805, -5943, -1227 },
  { -6049, -7150, -6744, -2161 },
  { -9061, -7299, -8542, -4375 },
  { -5010, -5546, -5416, -82 },
  { -4135, -4205, -5109, -3373 },
  { -3311, -5869, -4007, -5061 },
  { -5993, -6472, -3962, -4718 },
  { -2966, -5832, -2821, -6305 },
  { -4851, -5152, -2067, -3930 },
  { -3620, -4441, -3362, -5836 },
  { -4469, -5221, -4534, -5592 },
  { -4022, -6335, -4321, -6107 },
  { -4899, -4503, -3084, -3725 },
  { -4490, -8276, -4620, -6236 },
  { -6591, -4342, -7365, -4063 },
  { -6498, -5057, -5553, 485 },
  { -6060, -2714, -7093, -4144 },
  { -6199, -7774, -7094, -4057 },
  { -7536, -6424, -6415, -4265 },
  { -7439, -2454, -6348, -4827 },
  { -5333, -7565, -4417, -4639 },
  { -4353, -7103, -4197, -2689 },
  { -5229, -6549, -5129, -6804 },
  { -6129, -7701, -5236, -4836 },
  { -6797, -3983, -3884, -4406 },
  { -6624, -4467, -4745, -5052 },
  { -3324, -7596, -2720, -6553 },
  { -5473, -6284, -1704, -4511 },
  { -4131, -7263, -3180, -5196 },
  { -7116, -5565, -3469, 685 },
  { -6002, -6021, -3858, 576 },
  { -3144, -8203, -1291, -434 },
  { -6096, -7027, -4004, 1353 },
  { -3943, -7709, -2344, -36 },
  { -4510, -6767, -2642, 631 },
  { -3657, -11541, -2570, -3984 },
  { -5959, -8854, -1333, -867 },
  { -6699, -8866, -1606, -344 },
  { -3836, -7961, -2334, -2028 },
  { -3430, -8045, -3037, -672 },
  { -3868, -9184, -3635, -1819 },
  { -4258, -9060, -2621, -1008 },
  { -3595, -8693, -2022, -752 },
  { -4573, -8048, -3166, -2622 },
  { -4852, -7903, -1405, 256 },
  { -4591, -7057, -1560, 965 },
  { -6963, -7655, -980, 808 },
  { -5179, -6641, -3356, 1196 },
  { -7102, -6941, -2798, 2123 },
  { -6867, -5834, -3320, -770 },
  { -5977, -7369, -2500, -778 },
  { -6160, -6400, -934, -2543 },
  { -6741, -7608, -355, -1289 },
  { -6856, -6466, -1433, -1643 },
  { -4786, -6292, -4970, 376 },
  { -5407, -8866, -2255, -400 },
  { -3814, -6506, -1387, -3620 },
  { -4998, -6137, -1200, -4092 },
  { -5123, -9557, -2849, -1306 },
  { -4259, -6444, -4395, -338 },
  { -5221, -6810, -883, 1225 },
  { -6137, -6215, -2165, 554 },
  { -3895, -6557, -3176, -1829 },
  { -3886, -8188, -87, -954 },
  { -7243, -6707, -2216, -316 },
  { -5592, -7606, 85, -432 },
  { -3957, -7945, -504, -144 },
  { -4617, -7624, 218, -312 },
  { -4797, -8737, -844, -1051 },
  { -4478, -8516, -1401, -454 },
  { -4557, -7058, -302, -2332 },
  { -6623, -7736, -271, -50 },
  { -3157, -7532, -1111, -2207 },
  { -3590, -7300, -1271, 517 },
  { -4442, -7306, -507, 590 },
  { -6458, -7524, -2807, 666 },
  { -4991, -8466, -3363, -785 },
  { -7474, -7541, -1056, -1839 },
  { -7501, -8316, -938, -180 },
  { -5329, -7739, -579, -2341 },
  { -4549, -7063, -176, -3539 },
  { -5191, -8612, -1504, -4250 },
  { -3083, -7058, -2251, 32 },
  { -4003, -7043, -1093, -791 },
  { -5523, -8093, -678, -114 },
  { -3022, -10265, -2070, -3109 },
  { -3905, -6274, -182, -3652 },
  { -3269, -9217, -551, -2650 },
  { -3138, -9314, -1726, -1704 },
  { -4420, -10339, -1744, -3459 },
  { -4163, -8609, -2298, -4113 },
  { -5566, -6505, -1241, -463 },
  { -3130, -9746, -2352, -4884 },
  { -7825, -3439, 1451, -1468 },
  { -8451, -3318, 2360, -435 },
  { -8462, -4130, 1438, -1024 },
  { -9425, -4564, 1328, -689 },
  { -11014, -3202, 2278, 2080 },
  { -8269, -2761, -146, -440 },
  { -7497, -2618, -166, 413 },
  { -8250, -3060, 522, -2133 },
  { -8365, -5366, 1347, -451 },
  { -8589, -3979, 2943, 714 },
  { -8111, -2572, 1272, -1748 },
  { -7830, -5193, 605, -1484 },
  { -8119, -4736, 2141, 256 },
  { -7724, -4769, 1463, -812 },
  { -7363, -3911, 2540, 4 },
  { -7974, -3397, 2363, 1366 },
  { -7359, -4204, 1752, -958 },
  { -7622, -3505, 660, 916 },
  { -9934, -3665, 3165, 828 },
  { -8721, -4162, 62, 1718 },
  { -9433, -4768, 2722, 1234 },
  { -7960, -4496, 138, 1528 },
  { -8198, -3454, -443, 631 },
  { -7756, -2246, 655, 1137 },
  { -8841, -3145, 1113, 829 },
  { -7817, -3298, 1251, 230 },
  { -9413, -2733, 323, -1862 },
  { -9408, -4168, 1270, 1549 },
  { -9037, -3892, -942, 283 },
  { -8255, -3849, 1301, 1762 },
  { -9057, -3987, -41, -682 },
  { -9441, -4187, 2019, -111 },
  { -9740, -3178, 1602, -871 },
  { -8344, -2474, 1461, 1506 },
  { -9752, -2925, 1996, 1243 },
  { -9199, -3796, 180, 537 },
  { -9060, -2405, 1140, -1562 },
  { -9348, -2376, 309, -162 },
  { -10786, -3182, -5, -1500 },
  { -8142, -4540, -434, -826 },
  { -7528, -2341, 1104, -73 },
  { -9360, -2658, 3062, 56 },
  { -8267, -2335, 2000, -1193 },
  { -12169, -3154, 1287, -640 },
  { -11398, -2120, 946, -1163 },
  { -8940, -4559, 328, -1696 },
  { -11025, -4213, 2813, 840 },
  { -9224, -3581, 2224, 2039 },
  { -8943, -3337, 1248, -1298 },
  { -7900, -4042, 485, -2080 },
  { -9221, -1947, 2191, -880 },
  { -10762, -1800, 2516, -324 },
  { -10095, -2238, 981, -1335 },
  { -11908, -2808, 3255, 645 },
  { -10640, -4105, 1283, -595 },
  { -7663, -2863, 2467, -797 },
  { -10712, -3854, 3710, 1538 },
  { -10823, -2893, 1408, -801 },
  { -9874, -3832, 256, -1638 },
  { -10394, -3391, 2315, -94 },
  { -11525, -4079, 4153, 2122 },
  { -9546, -2088, 1541, 481 },
  { -8731, -2433, 1042, 2160 },
  { -7852, -3977, -1370, 1677 },
  { 7072, -3420, 1398, -1741 },
  { 6180, -1976, 1280, -3557 },
  { 7692, -1793, 2844, -1700 },
  { 8363, -1773, 3104, -2679 },
  { 9213, -3266, 3756, -3542 },
  { 9650, -2644, 1426, -1318 },
  { 7712, -2796, 3686, -1975 },
  { 7316, -3517, 2821, -622 },
  { 7434, -2594, 2305, -2264 },
  { 7237, -1797, 255, -3114 },
  { 8663, -1983, 1338, -3056 },
  { 6616, -952, 4059, -2652 },
  { 8823, -1327, 1362, -1356 },
  { 9938, -1722, 1287, -2362 },
  { 7207, -1057, 1913, -1315 },
  { 7508, -1585, 870, -1982 },
  { 8217, -3680, 1417, -3170 },
  { 8329, -2541, 1684, -585 },
  { 8062, -2335, 252, -2800 },
  { 8204, -4108, 3097, -2569 },
  { 7701, -3367, 576, -3008 },
  { 7350, -786, 2414, -2129 },
  { 6948, -2568, 1607, -225 },
  { 7684, -2387, 1308, -3449 },
  { 8306, -3458, 2394, -1454 },
  { 8438, -2781, 1043, -1362 },
  { 9175, -2076, 2144, -1987 },
  { 8347, -2709, 3489, -4301 },
  { 5696, -2377, 2870, 851 },
  { 8825, -1243, 2219, -2603 },
  { 8801, -1614, 584, -2513 },
  { 8413, -384, 1421, -2244 },
  { 9228, -3050, 3279, -2164 },
  { 6342, -2698, 3547, -107 },
  { 10053, -2476, 2837, -3168 },
  { 7439, -604, 3177, -3991 },
  { 7749, -1064, 4329, -4855 },
  { 8655, -2177, 2252, -3519 },
  { 8490, -228, 1958, -3233 },
  { 10513, -2968, 1911, -2340 },
  { 8146, -862, 1884, -1723 },
  { 7788, -666, 3004, -2891 },
  { 7785, -1620, 4133, -3417 },
  { 10262, -3731, 3455, -2971 },
  { 8570, -905, 4519, -4649 },
  { 9129, -2562, 463, -2465 },
  { 9451, -3587, 1904, -3056 },
  { 6549, -2236, 3010, -4523 },
  { 7175, -2684, 2967, -3458 },
  { 9872, -3278, 1054, -2472 },
  { 9153, -931, 1217, -2565 },
  { 8789, -3469, 753, -2568 },
  { 6683, -3791, 1797, -3968 },
  { 6801, -1977, 2311, -452 },
  { 6336, -1572, 2612, -3264 },
  { 7996, -1008, 730, -2964 },
  { 7521, -1059, 1573, -3694 },
  { 8148, -3973, 2600, -3572 },
  { 7765, -1532, 2528, -3856 },
  { 7404, -3918, 4472, -143 },
  { 8894, -1398, 3299, -3685 },
  { 5768, -2041, 1487, -637 },
  { 5131, -2865, 2463, -811 },
  { 6439, -1568, 3500, -1550 },
  { -8878, -6798, -5319, -1452 },
  { -6332, -9713, -3112, -990 },
  { -8444, -6316, -3694, -687 },
  { -6123, -10840, -3637, -4358 },
  { -4784, -9580, -4577, -2581 },
  { -6108, -10515, -4859, -2524 },
  { -7605, -7518, -2327, -2797 },
  { -9662, -8775, -2467, -2010 },
  { -6494, -7523, -4715, -118 },
  { -8290, -8982, -1672, -317 },
  { -8798, -11051, -3888, -1426 },
  { -6273, -6623, -6791, -142 },
  { -8313, -7668, -2141, -1275 },
  { -6453, -8412, -3589, -4102 },
  { -6747, -7750, -5690, -2498 },
  { -7814, -6693, -3174, -2446 },
  { -10383, -10130, -3931, -2364 },
  { -10606, -8467, -5539, -2772 },
  { -9475, -6671, -3305, -2271 },
  { -8982, -9457, -5635, -4005 },
  { -10111, -7965, -6515, -4180 },
  { -7301, -6479, -5364, 720 },
  { -9543, -8999, -7921, -912 },
  { -9534, -8562, -3469, -384 },
  { -7601, -10344, -3205, -1127 },
  { -8088, -8620, -4954, -2888 },
  { -8202, -8406, -7038, -3775 },
  { -7312, -8324, -3334, -1775 },
  { -8566, -9262, -8071, -4174 },
  { -7068, -11300, -5573, -2907 },
  { -8295, -8952, -4366, -1544 },
  { -11104, -10210, -2285, -384 },
  { -5213, -7520, -5008, -1339 },
  { -5889, -7940, -5987, -1385 },
  { -10816, -8201, -4153, -1485 },
  { -10277, -8919, -6315, -1652 },
  { -5888, -10320, -3821, -1733 },
  { -10497, -7181, -6083, -3032 },
  { -7721, -9724, -6591, -5336 },
  { -5688, -7894, -3486, -2552 },
  { -10014, -10500, -3247, -820 },
  { -6301, -8765, -4506, -2923 },
  { -8261, -7847, -6213, -1552 },
  { -10212, -7481, -8113, -3954 },
  { -6938, -10874, -6074, -4703 },
  { -7183, -10968, -4446, -1773 },
  { -7120, -9193, -1966, -2509 },
  { -6234, -9263, -2313, -4284 },
  { -8503, -9857, -2429, -608 },
  { -9372, -7844, -8391, -2120 },
  { -7951, -7157, -6535, -11 },
  { -7256, -9473, -2172, -660 },
  { -10063, -9612, -2515, -15 },
  { -6684, -9134, -6109, -4206 },
  { -8204, -11932, -5220, -2306 },
  { -9710, -6706, -4115, -3275 },
  { -6855, -7078, -2409, -4447 },
  { -7344, -7673, -4479, -4116 },
  { -8851, -6842, -4927, -2948 },
  { -8927, -10452, -5633, -2194 },
  { -8627, -9002, -7176, -1575 },
  { -8209, -9722, -7021, -3324 },
  { -3770, -10249, -3623, -4816 },
  { -8183, -7465, -4090, 646 },
  { -8163, -7149, 200, 498 },
  { -8289, -6266, 686, -206 },
  { -10030, -6241, -1032, -1864 },
  { -8793, -8327, -773, -169 },
  { -9149, -6215, 969, -15 },
  { -8303, -5859, -7, 2006 },
  { -9682, -7283, 255, 1322 },
  { -9293, -7227, 71, -231 },
  { -8525, -6215, 287, -837 },
  { -10477, -5379, 1159, 1449 },
  { -10726, -7856, -130, 102 },
  { -8694, -7461, -1210, 690 },
  { -9367, -5324, 1103, 3170 },
  { -10686, -8055, -831, 1633 },
  { -9201, -6873, -2704, 2258 },
  { -8421, -5358, -1405, 226 },
  { -9066, -5830, -307, -1571 },
  { -11150, -7381, -2746, -900 },
  { -9978, -5925, -2006, -437 },
  { -9464, -4741, -273, 1061 },
  { -10543, -6684, -1113, 1660 },
  { -10073, -5576, 1083, -269 },
  { -8826, -5763, 1600, 1486 },
  { -10445, -9071, -1253, -64 },
  { -12085, -5799, 2, 769 },
  { -12939, -6663, 1650, 1437 },
  { -10932, -6434, -1252, -649 },
  { -11650, -7826, -2053, 710 },
  { -12122, -6733, -1889, -731 },
  { -9093, -6095, -2463, -842 },
  { -10977, -4364, 469, 420 },
  { -11488, -6908, -521, 893 },
  { -9669, -5478, -842, 337 },
  { -10606, -5203, -632, -1361 },
  { -10198, -6284, 1662, 1277 },
  { -10135, -5292, 2435, 3493 },
  { -11027, -6561, 655, 56 },
  { -10977, -5030, 1127, -358 },
  { -12766, -3986, 1348, -335 },
  { -14244, -7731, 264, 317 },
  { -15124, -10309, -508, 1447 },
  { -12821, -8638, -608, 137 },
  { -13076, -8693, -2852, -431 },
  { -11156, -5546, -2252, -1600 },
  { -8692, -7366, -819, -1223 },
  { -12507, -9816, -1714, -121 },
  { -10712, -6666, 544, 3349 },
  { -12462, -5890, -2491, -2318 },
  { -12468, -7226, 437, 232 },
  { -11300, -5226, 2068, 687 },
  { -11994, -8320, -626, 2728 },
  { -12222, -5476, 1142, 18 },
  { -10277, -8122, -2418, 2003 },
  { -13418, -6115, -3563, -2802 },
  { -14759, -9834, -1243, 21 },
  { -13699, -5665, 1525, 507 },
  { -16269, -9476, -701, 163 },
  { -12677, -5437, -247, -1019 },
  { -11827, -4295, -181, -1243 },
  { -12847, -4496, 2984, 1123 },
  { -13860, -7915, -1166, -547 },
  { -12276, -8145, -2290, -1527 },
  { -11417, -4830, 2983, 1854 },
  { -11793, -6002, 1163, 1940 },
  { 11443, -4920, -3235, 3151 },
  { 11300, -6616, -1506, 1175 },
  { 9198, -4628, -2060, 2390 },
  { 10532, -4027, -643, 912 },
  { 9902, -3573, -1606, 1327 },
  { 9653, -3536, -2240, 1869 },
  { 9948, -5171, -423, 2662 },
  { 12316, -4004, -1989, 281 },
  { 12125, -4800, -1265, -163 },
  { 10650, -2617, -2337, 1462 },
  { 9909, -4968, -2376, 916 },
  { 12944, -4647, -1958, 460 },
  { 12988, -5283, -1141, 41 },
  { 12321, -2915, -3621, 1025 },
  { 11449, -2894, -2728, 351 },
  { 12087, -3041, -2002, -32 },
  { 11558, -4031, -1343, -399 },
  { 12983, -3740, -3516, 1245 },
  { 12099, -2515, -2752, 225 },
  { 12515, -3465, -2701, 550 },
  { 14683, -5022, -5272, 2996 },
  { 12260, -3383, -1215, -528 },
  { 13810, -5422, -2443, 1166 },
  { 13421, -5378, -1886, 721 },
  { 12961, -4259, -2594, 796 },
  { 12266, -2104, -4768, 1591 },
  { 13523, -4710, -3045, 1342 },
  { 12437, -2099, -5610, 2117 },
  { 11850, -2183, -3497, 661 },
  { 12275, -3936, -597, -697 },
  { 12459, -5253, -517, -544 },
  { 12835, -4094, -1322, -168 },
  { 14360, -5677, -3305, 1859 },
  { 13905, -4552, -4309, 2117 },
  { 11559, -3412, -1847, -81 },
  { 13379, -3167, -5764, 2746 },
  { 11910, -1634, -4342, 1052 },
  { 12662, -4742, 71, -974 },
  { 13057, -3254, -4424, 1705 },
  { 15046, -5706, -4851, 3019 },
  { 14162, -4142, -5514, 2843 },
  { 12764, -1845, -6684, 2888 },
  { 13714, -2374, -7838, 3857 },
  { 13295, -1663, -8293, 4073 },
  { 10032, -4152, -3403, 1421 },
  { 10942, -5386, -2222, 950 },
  { 10532, -6385, -1750, 1925 },
  { 10273, -5972, -1534, 643 },
  { 10605, -4782, -1695, 27 },
  { 10988, -5153, -1123, -341 },
  { 11629, -5884, -1060, 48 },
  { 10441, -4045, -2431, 311 },
  { 10788, -3595, -4171, 1807 },
  { 12110, -5686, -2127, 976 },
  { 11746, -4773, -2639, 891 },
  { 11541, -5299, -3031, 1732 },
  { 11416, -2559, -5359, 2198 },
  { 11583, -5376, -704, 677 },
  { 10416, -3214, -3516, 872 },
  { 9651, -5435, -1618, 3255 },
  { 9973, -5133, -996, 3923 },
  { 11707, -4643, -430, -796 },
  { 10994, -2709, -3587, 2302 },
  { 10716, -5118, -645, 270 },
  { 14100, -10314, 1095, 1531 },
  { 12944, -8049, 1105, -741 },
  { 13276, -7035, -511, 274 },
  { 14008, -7254, -283, 139 },
  { 11594, -6536, -91, 1671 },
  { 11732, -8645, 746, 15 },
  { 14613, -7085, -1578, 1183 },
  { 13083, -6224, -750, -4 },
  { 13988, -6256, -1592, 820 },
  { 14678, -8683, 441, 126 },
  { 15571, -8872, -521, 1139 },
  { 15642, -9533, 341, 697 },
  { 15960, -9586, -168, 1121 },
  { 15464, -10239, 1433, -1 },
  { 14934, -7887, -1046, 1080 },
  { 15252, -7630, -1899, 1628 },
  { 15485, -8384, -1234, 1484 },
  { 15962, -8638, -1815, 1931 },
  { 16501, -10664, 398, 1167 },
  { 16146, -10145, 411, 918 },
  { 14573, -7475, -697, 601 },
  { 14302, -7996, 28, 257 },
  { 14769, -6792, -2286, 1574 },
  { 14144, -6137, -2169, 1257 },
  { 14770, -6271, -3111, 1933 },
  { 14110, -8312, 1083, -531 },
  { 15235, -6991, -2993, 2174 },
  { 13222, -5805, 547, -891 },
  { 14796, -8762, 1254, -246 },
  { 16040, -9181, -1005, 1551 },
  { 16487, -10086, -373, 1420 },
  { 15077, -9479, 966, 51 },
  { 13026, -6468, 932, -1080 },
  { 12703, -6152, -33, -573 },
  { 15641, -6810, -4128, 2874 },
  { 13282, -7673, 1583, -1283 },
  { 12373, -7150, 1512, -917 },
  { 12992, -7751, -678, 783 },
  { 10907, -6858, -313, 2597 },
  { 13026, -8963, 125, 2152 },
  { 12770, -9946, 1957, -505 },
  { 12482, -6849, -1268, 833 },
  { 13790, -6181, -138, -279 },
  { 12709, -8382, 2044, 227 },
  { 12244, -6630, 203, -457 },
  { 14209, -6816, -1032, 632 },
  { 15134, -8267, -288, 640 },
  { 13619, -6157, -1090, 356 },
  { 14044, -7413, 725, -484 },
  { 12958, -7753, 2585, -1980 },
  { 13188, -8396, 2306, -1558 },
  { 14379, -9980, 2132, -688 },
  { 14275, -9857, 1162, 179 },
  { 13690, -8648, 1621, -889 },
  { 11770, -6829, -746, 278 },
  { 12732, -8202, 286, 90 },
  { 13630, -10146, 1867, -207 },
  { 12072, -8740, 1299, -645 },
  { 12852, -9492, 1226, 62 },
  { 11792, -7382, -54, -116 },
  { 13779, -9014, 487, 351 },
  { 11951, -7729, 121, 834 },
  { 11970, -9781, 2276, -4 },
  { 12680, -7984, 2787, -787 },
  { 13300, -14488, 6408, -1927 },
  { 13635, -15355, 9153, -3073 },
  { 12804, -13566, 5517, -1625 },
  { 16624, -10854, 1690, 28 },
  { 20387, -18532, 6162, -261 },
  { 16515, -12642, 3392, -519 },
  { 15800, -11095, 2151, -202 },
  { 16824, -11790, 1651, 599 },
  { 17604, -13213, 2563, 538 },
  { 17892, -14177, 3562, 147 },
  { 16987, -11399, 869, 1052 },
  { 17003, -12456, 2442, 265 },
  { 21657, -21806, 9198, -1250 },
  { 16825, -13341, 3980, -686 },
  { 17525, -12714, 1887, 805 },
  { 16419, -11034, 1216, 617 },
  { 20931, -19939, 7469, -684 },
  { 18452, -15390, 4573, -191 },
  { 14778, -10077, 2841, -1209 },
  { 17402, -13319, 3042, 160 },
  { 19365, -17922, 7087, -1061 },
  { 16298, -11941, 2810, -351 },
  { 19087, -16176, 4775, -84 },
  { 17666, -12289, 938, 1224 },
  { 18581, -15894, 5132, -430 },
  { 19823, -16717, 4142, 545 },
  { 19960, -19423, 8400, -1492 },
  { 18973, -16817, 5906, -594 },
  { 19079, -15431, 3528, 503 },
  { 16667, -12485, 4467, -1302 },
  { 19791, -17797, 6196, -529 },
  { 20005, -17606, 5354, -20 },
  { 20123, -18599, 6886, -728 },
  { 19068, -14805, 2394, 1105 },
  { 14443, -13723, 5631, -2029 },
  { 14730, -14231, 5631, -1450 },
  { 16089, -15959, 7271, -2029 },
  { 13473, -11200, 3236, -924 },
  { 14413, -10902, 2347, -267 },
  { 17666, -18662, 11381, -3496 },
  { 14749, -11042, 3305, -275 },
  { 15304, -10486, 1869, -240 },
  { 14809, -12126, 3369, -616 },
  { 16896, -16561, 7307, -1845 },
  { 15782, -14336, 5380, -1264 },
  { 16395, -15520, 6415, -1588 },
  { 13681, -11114, 2584, -320 },
  { 14244, -12326, 4480, -1632 },
  { 15247, -13119, 4265, -898 },
  { 13987, -12091, 3469, -597 },
  { 13941, -12770, 4240, -839 },
  { 13771, -13627, 5252, -1384 },
  { 15010, -16074, 7592, -2249 },
  { 15852, -17226, 8619, -2655 },
  { 18921, -16916, 6875, -1501 },
  { 14909, -11678, 2768, -295 },
  { 18988, -18353, 8424, -2070 },
  { 15457, -15080, 6218, -1513 },
  { 14916, -15512, 6949, -1883 },
  { 18108, -14702, 4681, -701 },
  { 17600, -15733, 5616, -775 },
  { 14070, -13683, 6472, -2626 },
  { 13832, -11914, 5201, -2232 },
  { 18846, -19009, 9192, -1961 },
  { -11981, -10994, -6324, -2264 },
  { -10976, -9047, -6546, -3828 },
  { -11288, -10532, -7014, -4191 },
  { -10139, -10189, -7799, -2688 },
  { -10555, -9988, -9181, -2040 },
  { -11596, -11339, -10022, -2707 },
  { -13400, -13395, -11306, -4206 },
  { -9774, -12281, -7466, -4133 },
  { -10842, -13125, -8777, -4956 },
  { -11964, -15082, -9779, -5095 },
  { -9382, -10188, -9053, -4927 },
  { -11562, -11296, -3651, -985 },
  { -9287, -10083, -7918, -4069 },
  { -12821, -16556, -11410, -6195 },
  { -12628, -8959, -4521, -1113 },
  { -13845, -11581, -3649, -681 },
  { -12685, -10269, -5483, -1275 },
  { -14988, -12874, -5107, -1189 },
  { -13761, -11367, -6202, -1804 },
  { -13225, -11249, -7820, -3354 },
  { -14809, -11992, -3202, -312 },
  { -15620, -15519, -10210, -3433 },
  { -12954, -10200, -3139, -611 },
  { -11536, -9981, -5284, -923 },
  { -13034, -12417, -4612, -1098 },
  { -16911, -15505, -6123, -1352 },
  { -17396, -17685, -8330, -2171 },
  { -14120, -10764, -2265, -99 },
  { -12598, -7367, -5406, -3530 },
  { -14143, -12793, -10909, -5226 },
  { -14692, -16871, -11626, -5554 },
  { -12581, -11197, -9194, -3837 },
  { -16752, -16726, -9746, -2808 },
  { -10600, -10358, -6560, -1227 },
  { -14573, -13312, -8957, -3393 },
  { -10172, -8463, -8579, -3387 },
  { -11418, -12421, -5522, -1842 },
  { -11855, -14204, -6669, -2625 },
  { -13308, -8191, -3941, -2194 },
  { -10007, -12266, -5022, -1811 },
  { -13532, -15771, -9497, -3175 },
  { -11760, -11148, -10339, -5529 },
  { -12149, -12763, -11198, -3697 },
  { -12029, -12119, -8555, -1792 },
  { -16995, -19957, -11447, -3471 },
  { -13144, -14504, -9988, -3191 },
  { -9938, -11064, -6139, -3162 },
  { -8873, -11550, -8294, -6550 },
  { -9303, -13010, -6150, -2711 },
  { -15463, -10469, -1766, -170 },
  { -15985, -11693, -3007, -650 },
  { -17142, -10671, -1434, 47 },
  { -16063, -13858, -4817, -1058 },
  { -19446, -19599, -9594, -2464 },
  { -20076, -18744, -8313, -1889 },
  { -15047, -16085, -7590, -2250 },
  { -13481, -16195, -8552, -2998 },
  { -13829, -14869, -6704, -1932 },
  { -16357, -18484, -9802, -2959 },
  { -10551, -8393, -9303, -5070 },
  { -11345, -9156, -5641, -3107 },
  { -13217, -13449, -9270, -4541 },
  { -11988, -13732, -9995, -6374 },
  { -11007, -9519, -5168, -4107 },
  { 9930, -7858, 8061, -4375 },
  { 8274, -7867, 5992, -2096 },
  { 9692, -9675, 7621, -3670 },
  { 9589, -8110, 6509, -3010 },
  { 12617, -11976, 10122, -5360 },
  { 11867, -8895, 7948, -5323 },
  { 10388, -10482, 9234, -4324 },
  { 8188, -8220, 7810, -2737 },
  { 10407, -8787, 4806, -1930 },
  { 10348, -8845, 9233, -6614 },
  { 9422, -7091, 4820, -2878 },
  { 9758, -9796, 5584, -2256 },
  { 10188, -7994, 5347, -3343 },
  { 11133, -7455, 4015, -2306 },
  { 10676, -10744, 6093, -2629 },
  { 11522, -12184, 7848, -3375 },
  { 8805, -9883, 5317, -3071 },
  { 9498, -9654, 6555, -3592 },
  { 10488, -8008, 4066, -1252 },
  { 11261, -8930, 6068, -2738 },
  { 12180, -10397, 5027, -1531 },
  { 9138, -8531, 3601, -1959 },
  { 8107, -8380, 4970, -2061 },
  { 9737, -13248, 6438, -2617 },
  { 11178, -10423, 2622, -522 },
  { 9572, -12372, 5199, -2019 },
  { 12057, -12144, 4147, -1099 },
  { 9047, -9925, 2516, -665 },
  { 10790, -8030, 5882, -4386 },
  { 7199, -8426, 6337, -2841 },
  { 7778, -8285, 3529, -3442 },
  { 7559, -10569, 3484, -1332 },
  { 9404, -8115, 7484, -5541 },
  { 7792, -11976, 5546, -2573 },
  { 9313, -10264, 7661, -5195 },
  { 6701, -10725, 4370, -1784 },
  { 4918, -11361, 4507, -4527 },
  { 5147, -12305, 3978, -5556 },
  { 6525, -9899, 4481, -3129 },
  { 7538, -12855, 6060, -4826 },
  { 8659, -12111, 7159, -4430 },
  { 8440, -11304, 4547, -1747 },
  { 9216, -10918, 3507, -1195 },
  { 6165, -9254, 4771, -4677 },
  { 9163, -11019, 5637, -4935 },
  { 13441, -11509, 6676, -2434 },
  { 7912, -9398, 6663, -4048 },
  { 11723, -13745, 8131, -4148 },
  { 6065, -10257, 5005, -6327 },
  { 11618, -12417, 5336, -1894 },
  { 8891, -13924, 8407, -6131 },
  { 9622, -12563, 7908, -5109 },
  { 11479, -10315, 8349, -3991 },
  { 11676, -14103, 6611, -2330 },
  { 11951, -8953, 3829, -1550 },
  { 10486, -8044, 10493, -5920 },
  { 11801, -10769, 9763, -5305 },
  { 6109, -8676, 5827, -1346 },
  { 7030, -9611, 5624, -5761 },
  { 12808, -12886, 8683, -4148 },
  { 13213, -10464, 6381, -3189 },
  { 11796, -13681, 10703, -6075 },
  { 9639, -7949, 9625, -3944 },
  { 8538, -6997, 5309, 453 }

################################################################################

TITLE
    libavcodec dca scale_factor_quant6

TYPE
    32

DATA
        1,       2,       2,       3,       3,       4,       6,       7,
       10,      12,      16,      20,      26,      34,      44,      56,
       72,      93,     120,     155,     200,     257,     331,     427,
      550,     708,     912,    1175,    1514,    1950,    2512,    3236,
     4169,    5370,    6918,    8913,   11482,   14791,   19055,   24547,
    31623,   40738,   52481,   67608,   87096,  112202,  144544,  186209,
   239883,  309030,  398107,  512861,  660693,  851138, 1096478, 1412538,
  1819701, 2344229, 3019952, 3890451, 5011872, 6456542, 8317638,       0

################################################################################

TITLE
    libavcodec dca scale_factor_quant7

TYPE
    32

DATA
        1,       1,       2,       2,       2,       2,       3,       3,
        3,       4,       4,       5,       6,       7,       7,       8,
       10,      11,      12,      14,      16,      18,      20,      23,
       26,      30,      34,      38,      44,      50,      56,      64,
       72,      82,      93,     106,     120,     136,     155,     176,
      200,     226,     257,     292,     331,     376,     427,     484,
      550,     624,     708,     804,     912,    1035,    1175,    1334,
     1514,    1718,    1950,    2213,    2512,    2851,    3236,    3673,
     4169,    4732,    5370,    6095,    6918,    7852,    8913,   10116,
    11482,   13032,   14791,   16788,   19055,   21627,   24547,   27861,
    31623,   35892,   40738,   46238,   52481,   59566,   67608,   76736,
    87096,   98855,  112202,  127350,  144544,  164059,  186209,  211349,
   239883,  272270,  309030,  350752,  398107,  451856,  512861,  582103,
   660693,  749894,  851138,  966051, 1096478, 1244515, 1412538, 1603245,
  1819701, 2065380, 2344229, 2660725, 3019952, 3427678, 3890451, 4415704,
  5011872, 5688529, 6456542, 7328245, 8317638,       0,       0,       0

################################################################################

TITLE
    libavcodec dca lossy_quant_d

TYPE
    FLOAT

DATA
          0,     1.6,      1.0,     0.8,    0.59,    0.50,    0.42,    0.34,
       0.19,    0.11,     0.06,   0.035,   0.019,   0.011,  0.0065,  0.0040,
     0.0025,  0.0014,   0.0008, 0.00045, 0.00030, 0.00017, 0.00008, 0.00004,
    0.00002, 0.00001, 0.000005,       0,       0,       0,       0,       0

################################################################################

TITLE
    libavcodec dca lossless_quant

TYPE
    32

DATA
        0, 4194304, 2097152, 1384120, 1048576,  696254,  524288,  348127,
   262144,  131072,   65431,   33026,   16450,    8208,    4100,    2049,
     1024,     512,     256,     128,      64,      32,      16,       8,
        4,       2,       1,       0,       0,       0,       0,       0

################################################################################

TITLE
    libavcodec dca lossless_quant_d

TYPE
    FLOAT

DATA
    0,             1.0,      0.5,     0.33,     0.25,    0.166,    0.125,
    0.083,      0.0625,  0.03125,   0.0156, 7.874E-3, 3.922E-3, 1.957E-3,
    9.775E-4, 4.885E-4, 2.442E-4, 1.221E-4, 6.104E-5, 3.052E-5, 1.526E-5,
    7.629E-6, 3.815E-6, 1.907E-6, 9.537E-7, 4.768E-7, 2.384E-7,        0,
           0,        0,        0,        0

################################################################################

TITLE
    libavcodec dca high_freq_vq

TYPE
    8

DATA
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { -4, -2, 2, 1, -16, -10, 1, 3, 1, 0, 6, 1, -3, 7, 1, -22,
    2, -4, -3, 11, 14, 6, -1, 1, -13, 29, -28, 10, 10, -8, 0, -9 },
  { -8, 8, -7, 10, -3, -12, -5, -8, 1, -2, 9, -2, -5, -18, 1, 9,
    -8, -8, 3, 41, 7, -9, -9, 22, -42, -29, 14, -18, -14, -32, 1, -15 },
  { -16, 8, 15, 16, -16, 5, 2, 7, -6, -16, -7, 1, 1, -3, -2, 0,
    8, 20, -26, -11, 2, -17, 0, -3, -34, -37, 10, 44, -2, 22, 2, -4 },
  { 7, 14, 5, 6, 15, -1, 3, -3, -9, -23, -5, -14, 8, -1, -14, -6,
    -5, -8, 54, 31, -6, 18, 2, -19, -2, -11, -30, -6, -19, 2, -2, -14 },
  { 1, 2, -2, -1, -3, -3, 1, -5, 1, -3, -4, -8, 5, -4, 0, 1,
    3, 7, -5, -4, -3, -12, 3, -2, -3, 12, -53, -51, 6, -1, 6, 8 },
  { 0, -1, 5, 1, -6, -8, 7, 5, -18, -4, -1, 1, 0, -3, -3, -14,
    -1, -6, 0, -14, -1, -1, 5, -3, -11, 1, -20, 10, 2, 19, -2, -2 },
  { 2, 4, 3, 0, 5, 0, 3, 1, -2, 0, -6, -3, -4, -5, -3, -3,
    -7, 0, -34, 4, -43, 17, 0, -53, -13, -7, 24, 14, 5, -18, 9, -20 },
  { 1, 0, -3, 2, 3, -5, -2, 7, -21, 5, -25, 23, 11, -28, 2, 1,
    -11, 9, 13, -6, -12, 5, 7, 2, 4, -11, -6, -1, 8, 0, 1, -2 },
  { 2, -4, -6, -4, 0, -5, -29, 13, -6, -22, -3, -43, 12, -41, 5, 24,
    18, -9, -36, -6, 4, -7, -4, 13, 4, -15, -1, -5, 1, 2, -5, 4 },
  { 0, -1, 13, -6, -5, 1, 0, -3, 1, -5, 19, -22, 31, -27, 4, -15,
    -6, 15, 9, -13, 1, -9, 10, -17, 4, -1, -1, 4, 2, 0, -3, -5 },
  { -7, 3, -8, 13, 19, -12, 8, -19, -3, -2, -24, 31, 14, 0, 7, -13,
    -18, 0, 3, 6, 13, -2, 1, -12, -21, 9, -2, 30, 21, -14, 2, -14 },
  { -3, -7, 8, -1, -2, -9, 6, 1, -7, 7, 13, 3, -1, -10, 30, 4,
    -10, 12, 5, 6, -13, -7, -4, -2, -2, 7, -3, -6, 3, 4, 1, 2 },
  { -8, 9, 2, -3, -5, 2, 0, 9, 3, 7, -4, -16, -13, 3, 23, -27,
    18, 46, -38, 6, 4, 43, -1, 0, 8, -7, -4, -1, 11, -7, 6, -3 },
  { 1, 1, 18, -8, -6, 0, 3, 4, 22, -3, -4, -2, -4, -11, 40, -7,
    -3, -13, -14, -7, -10, 14, 7, 5, -14, 11, -5, 7, 21, -2, 9, -3 },
  { 0, 0, -2, 4, -2, 0, 2, 0, -1, 2, -1, 0, 0, 2, 2, 2,
    -1, 1, -3, -1, -15, -2, -63, -27, -21, -47, -14, 1, -14, 10, 0, 2 },
  { 1, 0, -4, 0, -3, -9, 4, 2, 6, -6, 0, -5, 11, -7, -15, 6,
    -7, -6, 3, 7, -15, -5, 23, -13, -6, 12, -8, 9, 2, -3, 3, 4 },
  { 6, 0, 3, 0, -2, -4, 2, 1, 1, -1, 1, -2, -1, -4, -22, -15,
    -46, -66, 10, 20, 2, -17, 12, -6, 1, -2, -2, 0, 1, -5, 1, 2 },
  { -1, 0, 0, 1, 0, -4, 0, 1, -10, -3, -8, 5, 7, -11, 2, -11,
    29, -25, 11, 10, 0, -1, 5, -7, -2, -5, -2, 4, 4, -3, 5, -2 },
  { 1, -1, -1, -3, -2, 1, -8, -3, 2, -2, 4, -5, -1, -7, -2, 1,
    -14, -7, 3, -30, -15, -14, 3, -4, -1, 3, -13, -1, -3, 1, 2, 3 },
  { -1, -2, -3, 2, 2, -3, 3, 1, -3, 2, 0, -4, 6, 5, -5, 10,
    -57, 3, 22, -50, 1, -2, -5, -6, -1, 5, 1, 2, 2, 1, -2, 2 },
  { 2, 0, -1, -7, 2, 1, 3, 2, 0, 4, 3, -2, 3, -3, 4, -4,
    24, -35, -3, 38, -6, -5, 15, 20, 3, 16, -7, -5, 0, -4, -5, 0 },
  { 0, 1, 0, 0, 0, -1, -1, 1, 1, -1, 1, -2, 0, 0, 0, 0,
    0, -1, -2, -1, -5, -2, -43, -3, 46, -52, -10, 7, -8, 11, -2, -1 },
  { 0, 0, -1, 0, -1, 2, -41, 33, -44, -48, -15, -26, -9, 6, 3, 3,
    -3, 2, 2, 2, 2, -1, -1, -2, 1, 3, 0, 0, 5, 2, 3, 1 },
  { -4, 1, 6, 1, -6, -1, -2, 1, -14, -4, 0, -5, -2, 2, -2, 0,
    -6, 1, 0, 8, -21, 32, -3, -36, -6, -2, -1, -7, 3, 0, 1, -6 },
  { -3, -2, 3, 0, 2, 2, 8, -4, -4, 6, 2, 1, 3, -6, 4, 3,
    13, 0, -12, -1, 25, -20, -2, -23, -15, 7, -3, -11, -3, 6, -1, 0 },
  { 0, 0, -3, -1, 0, 0, -2, -1, -2, -2, 1, -1, 0, 0, 10, 3,
    -2, 3, 3, -7, -6, -5, 0, -4, -60, -16, -6, 38, 5, 6, -5, 0 },
  { 0, 1, 0, 0, 0, 0, 0, 0, 1, -1, -1, 0, 1, 0, 0, 1,
    0, 0, -1, 0, -8, 2, -9, 10, 40, 31, -56, -21, 4, 20, -4, 7 },
  { -2, -2, 0, 4, -3, -1, 7, 3, 1, 3, -8, 0, 3, 1, 2, 5,
    1, -2, 14, 5, 4, 5, 5, 5, -5, 9, -66, 0, -20, -2, -8, 4 },
  { -2, -1, 4, -1, -8, -2, -4, -1, -3, -3, 2, -7, -3, 5, 7, -2,
    45, 31, -17, -16, -2, -2, -1, -22, 1, -1, -3, 3, 5, -3, 5, -1 },
  { -4, 0, 7, 5, 8, 7, 2, 9, -9, -9, -7, -11, -3, -8, 17, -4,
    34, 32, 18, 22, 1, 2, 1, -7, -5, 6, -1, 6, 4, 10, -2, -7 },
  { 6, 0, 14, 9, 6, -1, -2, -3, 4, -6, -8, 4, 7, -1, 28, 38,
    15, -1, 16, -11, 5, 8, 4, -10, 3, -10, -17, 5, 3, 3, 3, 1 },
  { 1, 1, 2, -1, 2, 1, 0, 0, -1, 0, 0, -2, 1, -3, 0, 1,
    2, -2, -4, -2, 0, -1, 1, -3, 1, 1, 1, -1, 8, 8, 66, 33 },
  { -5, 2, -3, -7, 2, -8, -4, 10, 17, -18, -7, 4, -4, -7, -6, -6,
    -5, 5, -12, 2, 0, 6, 8, -2, 1, 4, -11, 2, 1, 8, 31, 19 },
  { 6, 9, 16, -6, -6, -1, -2, -3, -11, -2, 7, 7, 17, 3, 4, 10,
    2, 5, -13, 8, 7, 1, 4, 5, 7, 6, 7, -8, 9, -8, 33, 6 },
  { 3, -1, 1, 0, -7, -5, 0, 14, -7, 1, -7, 1, 2, -4, 7, 10,
    -16, 12, 1, -6, 3, 8, -1, 10, -13, -6, -12, -23, 12, -3, 30, 14 },
  { -2, -15, 0, 8, 3, -19, 5, -3, 2, 3, 13, 7, 14, -3, -10, 0,
    8, 5, -6, -16, -8, -8, 14, 2, -1, 1, -9, -11, 11, -5, 27, 9 },
  { -8, 6, -4, 4, -4, -1, 5, 4, 1, -7, -5, -4, -15, 1, 9, 0,
    8, 4, 1, -17, 11, -2, -19, -1, -6, -8, 3, -12, 3, -17, 33, -10 },
  { -3, -1, 2, 7, 7, -2, 9, 8, -18, -1, -13, -10, -3, -3, 11, 8,
    -2, -12, -8, 1, 4, 9, 14, 10, -3, 0, 2, 1, -2, 3, 31, 10 },
  { -3, -10, 8, -1, -5, -11, 7, -5, 3, 6, 1, 4, -16, 10, 5, -4,
    -2, -10, -1, 13, 6, -5, -7, 12, 7, -3, -17, 1, 12, -4, 29, 8 },
  { 1, 2, 5, 2, -6, -7, 0, -1, 6, -1, 10, 6, -4, 5, 2, 2,
    -2, -8, -6, -11, 14, -13, 27, 3, -2, -12, 5, -16, 2, -26, 20, 15 },
  { -1, -3, -5, -3, -3, 6, -1, 3, -5, 1, 7, 2, 1, 0, -1, -1,
    0, -1, 9, 7, -6, -3, 4, -5, -4, 8, -8, -25, -8, -4, 34, 23 },
  { -1, -2, 1, 1, -1, -2, -1, 1, -1, 0, 0, 0, 0, -2, -1, 1,
    0, 2, 1, -1, 4, 0, 0, 1, -1, 0, 5, 3, 12, -9, 68, -16 },
  { 10, 0, -8, 14, -6, 1, -12, 0, 0, -3, -5, -11, -6, 12, 9, -10,
    -3, 5, 0, 7, 11, 2, 4, -3, -8, -3, 7, 4, 3, -3, 34, 4 },
  { -12, 13, -5, 7, -11, -2, -1, 1, -4, -14, -21, 3, -3, -3, -4, -7,
    -9, -4, 3, -17, -2, -13, 10, -2, 12, -4, 0, -9, 1, -5, 31, 10 },
  { -10, 6, 5, 6, 4, -7, 10, 0, -28, -3, 0, -11, -1, -5, 16, -10,
    -16, 7, 20, 2, -4, 2, -5, 0, 15, 6, 5, -10, 7, -9, 20, 4 },
  { 1, -7, -2, -7, 4, -3, -2, -7, -1, -14, 6, -16, 4, -5, -4, -6,
    -5, 0, -2, 2, -6, 9, -5, 4, -18, 8, -10, 8, 15, 0, 32, 1 },
  { -5, 7, -3, 7, 15, -4, 0, -16, 9, 5, -5, 5, 4, -3, -12, -9,
    -18, 10, 2, 2, -3, 7, 3, -1, 6, -9, -10, 3, 15, -4, 35, -7 },
  { -1, -10, 2, 2, -4, -2, 10, 2, -1, 2, -2, 1, -1, -14, -11, 3,
    -8, 5, -8, -2, 6, -1, -7, 1, 7, 5, 7, 8, 30, -4, 30, 14 },
  { 2, -2, 1, 2, 3, -8, 3, 0, -2, 0, -9, 2, 1, 4, -6, -1,
    -2, 5, 0, 1, -2, 12, 6, -3, 9, -3, 4, -12, 21, -39, 24, -2 },
  { 3, 5, 1, -2, -2, -2, -3, 6, -8, -2, -11, -8, -1, 4, 2, 2,
    -4, -10, 12, -5, -11, 1, -15, -34, -11, -7, -11, -1, 7, -14, 38, -1 },
  { -4, 4, 8, 9, 8, 1, -5, -9, 4, -2, 15, -4, 11, -15, 20, -1,
    -1, -3, 4, -9, -2, -2, -2, 8, 6, 12, -5, 0, 11, -12, 27, -4 },
  { 0, 8, -4, 3, -11, 6, -11, 2, 3, 0, 5, -8, -7, -6, -9, -21,
    4, -11, -1, -16, -7, 16, -3, 7, -7, 4, -5, 0, 11, -7, 31, 3 },
  { 1, 3, 4, 11, -11, -2, -3, -6, 6, 5, 0, 3, -9, -6, 4, -4,
    0, 4, -8, 13, -6, -13, -1, -5, -1, 4, 0, 0, 9, -22, 24, 18 },
  { -7, 3, 10, -13, -6, 6, -6, 6, 22, 1, 0, -14, 2, 3, 7, -1,
    8, 20, -1, 5, -4, 13, 9, -9, -9, 6, 0, -4, 0, -8, 31, -4 },
  { -3, -4, 0, 1, 7, 3, -7, 0, 5, -2, 1, 3, 3, 1, -5, -2,
    5, 2, -11, 4, 0, -1, 12, 0, -3, -13, 15, 8, -6, -27, 34, 0 },
  { -3, -3, 10, -4, 2, -1, -3, 0, -1, -1, -4, 2, 6, -2, 12, 1,
    3, -6, -7, -6, -5, 4, -19, -6, -8, -34, -4, -8, 10, -7, 23, 10 },
  { -7, 0, -1, -6, 8, 4, -4, 2, -5, -8, -7, -9, -8, 5, 9, 7,
    -6, 1, -12, -12, -1, -16, 5, 0, 16, 3, -7, -8, 27, -4, 23, 15 },
  { -8, 4, 8, 5, 6, 11, -3, 5, 3, -1, -11, 6, -5, 0, 2, -6,
    -3, -6, 4, -1, 5, -5, -12, -6, 7, -5, 9, 3, 6, -7, 29, 1 },
  { 1, 3, -2, -2, -6, -2, 1, 6, -6, -3, 1, 2, 3, 4, 1, 5,
    -1, 0, 4, 2, 11, 6, 2, -3, 13, -9, -19, 18, -15, -10, 36, 21 },
  { -3, -3, 2, -1, -7, 6, -4, 1, -3, -1, -2, 2, 3, -7, -3, 0,
    -2, 0, -2, 6, -19, 3, -8, 2, -6, 7, -1, 0, 29, -6, 28, -10 },
  { -5, 1, -3, -7, -12, -4, 1, 1, -1, 13, -10, -1, -9, -5, -13, 6,
    13, 3, -4, 2, 3, 11, 2, 6, -25, -16, -6, 0, 14, -1, 27, 16 },
  { -6, -1, -7, -5, -2, -5, -5, -1, 9, 1, 0, 3, -8, -12, -6, 5,
    -6, 5, 3, -9, 1, 4, -7, -10, -9, -7, -17, -5, -15, -23, 25, 3 },
  { -8, -2, 9, -3, -4, 3, -1, 8, -7, -7, -5, -4, -2, 9, 4, -1,
    -7, -4, -5, -16, 3, -6, 18, -13, -9, 16, -15, 8, 15, -10, 24, 5 },
  { 1, -38, 2, 34, 9, 10, 11, 2, 2, -6, 3, 2, -2, 5, 4, -7,
    -1, 1, 4, 0, 3, 1, -8, -1, -6, 5, 4, 2, -4, 5, 2, -1 },
  { 1, -22, 15, 18, -2, 10, -16, -9, -8, -11, 8, 4, 0, 7, -14, -5,
    -1, -7, 12, 17, 9, 5, -7, -4, -12, -6, 7, 0, 7, 2, -2, 1 },
  { -11, -29, 7, 10, 19, -1, -8, -9, 7, 1, 9, 6, 8, -7, -14, 8,
    -3, -11, -13, 0, -7, -23, -2, -8, 12, 9, 2, 14, 19, 1, -1, 5 },
  { -24, -27, -11, 36, 2, 6, -3, 4, -6, 8, 0, 12, -1, -4, -6, 3,
    4, -1, 2, -3, -2, 3, 2, -1, -2, -4, 0, -1, -2, 7, 2, 3 },
  { -9, -24, 11, 13, -10, -12, 12, -2, 7, 4, 8, 13, -3, -3, 2, 9,
    -3, -4, 4, 13, 5, 13, -6, -3, 1, 15, 7, -3, 0, 19, -2, -9 },
  { -8, -15, 7, 14, -4, -5, 2, -18, -19, -2, 2, 17, 16, 6, -10, 10,
    -9, 14, -1, -5, -1, -6, -7, 2, 9, 11, 13, 6, -5, -12, 3, 2 },
  { -10, -37, 13, 1, 3, -14, 0, -20, 4, -3, 8, 2, -2, -3, -9, -5,
    -3, -17, -1, 13, -11, 2, -6, 4, 4, 0, 3, 1, -9, -4, -5, -4 },
  { -2, -22, -5, 46, -8, 5, 9, -11, 8, 7, 7, -1, -1, -2, -7, 2,
    -3, 3, -1, -2, 7, 0, 2, -1, 1, -2, -2, -3, 6, 0, -4, -6 },
  { -16, -27, 15, 16, -4, 14, -7, -26, 2, -2, 6, 5, -3, 11, 0, 2,
    3, 9, -7, -1, 2, -4, -4, -1, 6, 10, 1, 1, -3, -2, 3, 0 },
  { -3, -22, 10, 26, 1, 2, -3, 3, 17, -3, -7, 9, 1, -21, -4, 5,
    3, 0, -7, -6, 3, 3, -8, -7, -9, 3, 7, 1, -8, 12, 6, -7 },
  { -9, -25, 3, 18, 9, -6, -11, 0, -5, -12, 9, -8, -7, -6, -6, 22,
    2, -6, -3, 15, 3, 2, -2, 9, 14, -10, -7, 15, 13, 6, -2, 11 },
  { 5, -20, -5, 28, 11, 10, -4, -4, 0, -7, 3, 5, 2, -5, -8, 2,
    6, 10, 9, -9, -18, 3, 14, 1, 3, -3, -1, -6, 7, 7, 2, -1 },
  { -8, -30, 7, 12, 10, 8, 7, -13, -16, 0, 1, -1, -6, -11, -15, 4,
    1, -2, 10, -15, 1, 11, -2, 8, 9, -7, -7, 9, -5, 2, 7, -18 },
  { -10, -32, 10, 11, 3, -1, 3, -5, 5, 2, 14, -6, 3, 1, 5, -15,
    -11, 6, 20, 4, 0, -12, -7, 3, 1, -1, 10, 6, -1, -9, -4, -1 },
  { 1, -25, -14, 12, -11, 9, 9, -16, -24, -17, 22, -9, 11, -30, -3, -4,
    6, -7, 9, 2, -1, -5, -6, 2, -1, -1, 10, 1, -3, 3, 4, 8 },
  { -14, -26, -6, 9, 8, 17, -11, -24, -7, -4, -8, -2, 10, 2, 2, -1,
    2, 13, 12, -7, 4, -6, -10, 6, 6, -13, -11, -7, -16, 0, -2, 5 },
  { -4, -30, -13, 12, 16, -6, 12, -16, -13, 5, 15, -2, -2, -10, -7, 7,
    11, -1, -4, -2, -4, 7, 4, -8, 1, 3, 0, 11, 3, -2, -5, 4 },
  { -4, -21, 20, 22, 2, 20, -8, 1, -12, -5, -9, 4, -10, -17, -3, -8,
    -3, 3, -12, 1, -3, 0, 7, 4, 7, 7, -3, 7, 5, 3, 1, -5 },
  { -12, -20, 2, 29, 11, -6, 9, -7, -6, -4, 0, 6, 17, -13, -2, -10,
    -17, -1, -18, 2, 0, 14, -6, 1, 0, 3, 2, -10, 1, -5, -2, 5 },
  { 16, -37, -1, 26, -2, -14, 1, -5, -14, 2, 2, 3, 6, 1, 1, 4,
    0, -1, 0, -2, -2, 4, 9, -6, 0, -2, 10, -7, -2, 4, 1, 0 },
  { -9, -24, -12, 5, 5, 3, -17, -14, 4, 3, 2, -4, 10, -22, -8, -3,
    6, 1, 12, -8, 4, 1, 9, -1, 18, -3, 6, 5, 3, -5, 9, -5 },
  { -14, -33, -2, 20, -13, -10, 2, -7, -1, 11, -9, -8, 18, -3, 1, 8,
    0, -2, 10, 7, -2, -13, 9, -3, -4, 5, -2, -2, -1, -5, 1, -7 },
  { -10, -23, 8, 14, 1, 7, 1, -3, -7, 4, 1, 1, 8, -7, 15, -14,
    13, 14, 2, 5, -13, -5, -8, -1, 6, 3, 6, 9, 6, 15, 14, 5 },
  { -13, -25, -10, 13, -17, -24, -7, -13, -6, -10, -8, 2, 0, -13, -10, -4,
    -8, 4, -9, 9, -4, 4, -3, -3, 3, 3, -5, -9, 1, -2, 11, 2 },
  { -12, -23, 1, 18, -11, -2, 5, 9, -5, 5, 14, -9, -3, -2, -6, 2,
    -2, 11, -13, 1, -3, 11, -9, -4, -2, -6, 8, 10, 1, 4, 2, 1 },
  { -5, -18, 16, 22, 2, 0, 8, -6, -9, -7, 10, -16, 23, 10, -11, -1,
    7, 2, 7, 2, 1, -5, 6, 1, 0, -4, 9, 2, -3, 1, 0, -4 },
  { -3, -26, 14, 11, 2, -9, 17, -2, -1, -5, -16, -9, -5, 10, -13, 1,
    6, 12, 10, 11, 0, 0, -3, -14, 6, -2, 0, 4, -5, -1, -7, -1 },
  { -10, -33, 1, 8, 11, -5, 1, -6, 7, 4, 5, 6, 1, -2, -10, -5,
    -6, 12, -11, 5, -10, 4, 12, -1, -1, -3, 4, -1, 9, 0, 16, -17 },
  { -14, -37, 7, 7, -2, 5, -8, -11, 2, -13, 4, -19, 1, 8, 8, 4,
    -9, 2, -4, 3, 12, 2, 4, -4, -8, 8, 1, 4, 8, -1, 6, -2 },
  { -6, -30, 18, 17, 1, -22, -3, 4, -7, -10, 7, 0, -8, 8, -1, 4,
    2, 8, 6, -2, 2, 7, 4, 4, 3, -6, 2, 1, -3, 1, -1, -5 },
  { -17, -18, -3, 22, -8, 1, 9, -2, -17, 20, -5, -5, -12, -5, 4, -5,
    -9, 8, -2, 16, -3, 0, 19, -8, 8, 1, 2, -4, 0, 11, 0, -3 },
  { -9, -23, 3, 10, 4, 4, -3, -2, -2, -2, 1, -22, 11, 0, -2, 5,
    -2, 14, -9, -11, -4, 7, 5, 32, 1, -3, -7, 0, 21, -9, 7, -6 },
  { 0, 0, 0, 2, -1, 1, 0, 1, 3, 0, 0, 1, 0, 1, 0, 1,
    -3, 0, -1, -2, 0, -1, -1, -3, -1, 1, -4, 1, -1, -5, -69, -19 },
  { -3, -5, -8, -12, 4, -3, -19, -11, -5, 0, -14, 7, 18, -6, 7, 22,
    8, 14, 15, 10, 3, -1, -3, 5, -1, 7, -7, 1, -6, 3, -26, -11 },
  { -1, -6, 4, -4, -5, -16, 0, -6, -3, 11, 1, 0, 9, 5, 16, 3,
    -4, -33, -4, 4, -7, 0, 1, 6, -11, -2, -13, -2, -18, 20, -25, -16 },
  { 4, 0, -1, 0, -5, 1, 0, 2, 0, 11, -10, 4, -10, 7, 16, 2,
    16, 15, 2, -1, 2, 9, 2, 8, -3, -5, -2, 0, -3, 0, -33, -2 },
  { -3, -15, 10, 10, -9, -1, 7, 3, 5, -5, -8, -8, -3, 15, -9, 4,
    12, 13, -13, -14, 10, -6, 9, 22, -27, 23, -1, 5, -24, 2, -30, 5 },
  { 0, -2, 7, -5, -5, 3, 5, 3, -3, -5, 2, 1, -4, 3, -3, -1,
    1, -2, 10, 22, -3, -4, -2, -2, -7, 3, 8, 1, 14, 4, -37, 9 },
  { -3, -4, -1, 1, -4, 0, 6, 2, 6, -7, -10, -10, -1, -4, 11, -3,
    7, -6, 4, -12, -1, 5, 1, -7, 10, -6, 17, -4, 8, 3, -40, 13 },
  { 2, 12, 4, -7, 14, -3, 16, -2, 18, 2, 13, 5, 5, 1, 11, -1,
    0, 9, 2, -6, -1, 2, -6, 2, -5, 3, 5, 1, -1, 1, -32, -7 },
  { -16, 11, 7, -4, 2, -5, -9, 9, 11, 11, 15, -13, -11, 11, 9, 4,
    3, -8, -10, 12, 12, 0, 0, -16, -9, 13, 2, 9, 4, -13, -33, 3 },
  { 6, 4, 5, 4, 3, -1, 5, 6, 4, 2, -11, -1, -15, -11, -1, 1,
    11, -3, -2, 24, -4, -6, -25, -10, -15, -8, 0, 0, -5, 4, -30, 2 },
  { 10, -3, -6, 1, -9, -5, 6, 9, -10, -3, 8, -1, 4, -1, 11, -11,
    3, 9, 11, -3, 6, -17, 5, -8, -33, 9, -13, 19, -2, 9, -25, 2 },
  { 0, 0, -1, -3, 0, -2, 1, 0, 0, 2, 1, 0, -2, 0, -1, 2,
    0, -1, 4, -1, 2, -3, 4, -2, 3, 3, 1, 0, -15, 12, -63, 27 },
  { -2, 14, 9, -1, 3, 0, 1, 1, -19, 15, 3, 4, 0, -10, 1, -5,
    3, 0, -5, -10, 2, -16, -4, 8, -12, -6, 7, -5, -10, -1, -33, -4 },
  { 0, 3, 1, 3, 1, 2, 4, 4, 9, -6, -8, -5, 1, -12, 3, 8,
    -10, 6, -1, 1, 13, -5, -5, 2, -4, 13, -18, -10, -7, -9, -33, 10 },
  { -6, -3, -12, 5, -1, 11, -6, 0, -2, 1, 2, -7, 3, 1, 3, -2,
    1, 8, -10, 7, -1, -3, 3, 0, 13, 1, 6, 7, -16, -7, -39, 8 },
  { -6, -1, 11, 6, -3, 8, 3, -5, 3, 0, -5, -2, -6, -3, -4, 2,
    -3, 13, -11, 1, 7, 5, 19, -5, -3, -15, -1, 7, -1, 6, -33, 8 },
  { -7, 3, -4, -3, -4, 1, 6, -5, -5, 6, -8, -1, -7, 4, -1, -6,
    -2, 1, 7, 0, 1, 1, -5, 2, -2, 0, -13, -2, -31, -14, -39, -12 },
  { -10, 9, 0, -3, 1, -1, -1, 0, 1, -5, -1, -4, -2, 5, 2, -7,
    18, -8, -2, -19, -7, -7, -12, -14, -11, -1, -9, -13, -7, -12, -31, -9 },
  { -3, -16, 10, 9, 1, -10, -12, 2, -2, 2, 7, -3, -3, 1, -4, -5,
    -9, 5, 7, 3, -1, 4, -11, -8, 4, 13, -10, 13, 10, -4, -36, 1 },
  { -7, -12, 4, -20, -7, -7, 2, 11, -1, -2, 3, -12, 1, 0, -6, -7,
    6, 4, 13, 3, -3, 4, 3, -6, -12, 5, -5, -22, -13, -8, -37, -6 },
  { -7, 5, 3, 5, 7, 9, -14, -3, 10, 17, -1, 1, -12, 5, -6, 0,
    -4, -9, 0, -11, -14, 3, 13, 6, -25, -8, -12, 4, -10, 18, -30, -1 },
  { -10, 6, -10, 6, 6, 1, -10, 0, -7, 5, -2, 17, -18, -4, 0, -3,
    -16, -6, -3, -8, 5, 1, -4, 6, -7, 16, 6, 10, -1, 0, -32, -11 },
  { -1, 9, 9, -5, 4, 9, 6, 9, -4, -2, 7, 11, 4, 2, -5, -4,
    -6, 0, 2, -3, -1, 5, 10, 0, 12, -10, -18, -3, -1, 14, -33, 2 },
  { 4, -8, -18, -4, -5, -11, 4, -10, -4, 9, 13, -12, 1, -6, 1, 2,
    4, -9, 8, 3, -6, 21, 13, -1, -2, 1, -2, 6, -7, 0, -30, 1 },
  { 6, -1, 2, -3, -1, -4, 6, -4, 0, 4, 2, 2, -9, 2, 6, 3,
    -2, 4, -1, 9, -6, 0, 7, -8, 5, 19, -2, 9, -5, 2, -33, -8 },
  { 2, 1, 12, -5, -8, 8, 3, -2, -4, 1, -2, 5, -4, -9, -8, -8,
    7, -11, -4, 6, -10, 7, -1, -1, -2, -1, 16, 32, -7, 20, -33, -6 },
  { -18, 2, 6, 13, 9, 9, -1, 3, -17, 24, -2, -6, 28, 8, -2, 6,
    3, -10, -34, -16, -13, -4, -15, -11, -12, -3, -10, 4, -8, 4, -31, -4 },
  { -11, 0, 18, 2, -16, -9, -13, -2, -2, -12, -3, -22, 30, 0, 8, 3,
    9, -4, -16, 1, 0, -11, 15, -2, -4, 6, -5, 6, 1, 2, -25, -12 },
  { 14, -1, 5, 7, 3, -15, -8, 1, 5, -2, 12, 13, 11, -25, 3, 1,
    0, -2, -4, -16, -23, 0, -5, -17, 7, 5, -9, 6, -5, 2, -32, -7 },
  { 3, -1, 6, 14, 2, -12, -9, -9, 4, 7, 4, 6, 5, -8, 4, 2,
    4, 5, -2, 8, 8, -6, 0, 10, -20, -1, 3, -1, 8, 23, -33, -5 },
  { -3, 11, -6, 3, -4, 5, 7, 3, 4, 5, -2, 3, -1, 30, 6, 1,
    8, -6, 0, 0, -9, 6, -9, 4, 2, 9, -6, 1, -12, 0, -34, 18 },
  { -17, 13, 0, 1, 9, -4, -11, 0, 7, 0, -10, -4, -1, 6, -6, 4,
    1, 6, -9, 3, -5, -6, -11, 2, -4, 14, 23, -3, 2, 5, -30, 12 },
  { -14, 5, -27, 2, 0, 7, 1, 4, 30, 8, 7, 5, 1, -1, 0, 5,
    8, -10, 48, -11, 12, 33, 6, 8, -15, 20, -2, -5, 32, 5, -19, 10 },
  { -16, -4, -12, -7, -2, 0, 8, -6, -20, -18, 16, -3, 0, 31, -2, 11,
    2, -9, 49, -19, -12, -23, 10, 26, 16, -2, 4, -21, -14, 13, -11, -9 },
  { -5, -9, -1, 3, -5, -21, 2, 10, 0, 0, 10, -21, -7, 7, -26, -9,
    22, 32, 58, 11, -3, 11, -5, -8, -13, 6, -5, -9, 1, 10, 14, -8 },
  { 7, 7, 10, 3, -2, -1, -11, -11, -6, -43, -3, 14, -19, -18, 19, 18,
    -32, 10, 45, -6, 6, 21, -20, -12, 2, 4, 6, 6, -4, 3, 3, 1 },
  { 21, 22, -3, -2, -11, -6, -1, -2, 8, 8, 32, -21, 7, 28, -4, -6,
    -3, -2, 50, 2, 2, 27, -5, -8, 12, 7, -5, -1, -4, -17, 27, 6 },
  { 13, 7, 2, -6, -12, 2, -10, -5, -17, 11, 4, 17, -12, -2, 5, -17,
    37, -16, 48, -14, -18, 29, 8, 24, 11, -5, -9, 11, -1, 1, -13, -3 },
  { 1, 1, -1, 2, 0, 0, 0, -1, 1, -1, 7, 2, -3, 3, 0, 6,
    2, 10, 54, -25, 7, 54, -5, -6, -1, -15, 9, 13, -24, -15, -12, 3 },
  { 21, 5, 8, 3, -3, -4, -2, -4, 3, -11, -5, -8, 9, 16, 8, -9,
    -10, -3, 46, -46, 2, 1, -10, 10, 17, 11, -20, -36, 10, 14, 0, -5 },
  { 7, -13, -6, -9, -24, 45, 2, 8, 8, 0, 17, 20, 12, -24, 1, -7,
    -15, -3, 46, -13, -2, 20, 1, -13, -11, -13, 2, 15, 1, 10, -1, 3 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -2, -1,
    -16, -9, 31, -69, -34, 26, 7, 17, -1, -6, -1, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4,
    -5, -20, 18, -82, 22, 3, -7, 9, 4, 6, 2, -4, -1, 0, -2, 2 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, -1,
    15, -5, 62, -36, 4, 52, -7, 5, 0, 6, 1, 2, 1, 1, -1, 0 },
  { 3, -19, 19, -20, 13, -4, -11, 8, 8, -16, 10, 1, -14, 30, 1, -33,
    10, -11, 45, -30, 3, -4, -3, -13, 7, 12, 3, -22, 3, -2, -4, -2 },
  { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2, 1,
    11, 8, 70, 48, -10, 21, 4, 9, -9, -9, -4, -6, 0, -1, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0,
    2, -1, 80, 2, -15, -36, -10, -5, -2, 8, -2, 2, 0, 0, 0, 0 },
  { 10, 8, -8, -8, -24, 12, -1, 0, 20, 9, -1, -2, 2, -2, 12, -10,
    -2, -13, 35, -43, 44, 15, -10, -25, 4, 10, -3, -5, -5, 7, -1, 3 },
  { 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, -2, -1,
    -18, 9, 49, -72, 7, -8, 7, -5, 2, 3, 2, -2, 1, -2, -3, 1 },
  { -1, 4, -3, 10, 19, 4, 3, 20, 6, -24, 6, 9, 8, 15, 18, 18,
    -36, 19, 57, -11, 4, -3, 8, 7, 2, -3, -2, -9, -15, -2, 12, -4 },
  { 20, 3, 11, -9, -4, 22, 42, -25, 1, 5, -10, -19, 0, 9, -16, 5,
    2, 10, 44, -29, 17, -3, -9, -2, -1, 8, 14, -7, -1, 16, -5, 1 },
  { -7, 16, -11, 12, 6, 33, -15, 14, -23, 2, -26, 8, 2, 10, 0, -5,
    8, -8, 38, -38, -4, 5, 5, 5, 1, 22, -15, 7, 6, 0, 4, 28 },
  { -1, -12, 2, 10, -2, 0, 7, 17, 12, 22, -4, 10, 25, 29, 5, 18,
    4, 1, 27, -39, 31, 17, 2, 2, 22, -23, 13, 16, 1, -7, -4, -5 },
  { 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -2, 0, -14, 0,
    -7, -11, 49, -22, -4, 19, 17, -39, 4, -29, 10, 2, 36, -4, 23, -1 },
  { -2, -2, -2, -2, 1, 15, -5, -7, -16, -8, -19, 16, -3, -20, 36, -9,
    -3, 20, 39, -20, 0, 2, 27, -16, 10, 10, -14, -22, -16, -3, 13, -8 },
  { 5, -9, 6, -25, 7, 37, 13, -10, -5, 3, -5, 7, 18, -22, -7, 9,
    -5, -4, 50, -11, -4, -5, -5, 8, -4, -2, -4, -27, 14, 20, 7, -9 },
  { 0, -14, -10, -27, -14, -17, -6, 26, 10, 2, 14, -12, -5, 0, 8, 9,
    0, -28, 55, -7, -12, -7, 4, -10, 10, 7, -12, 11, 3, 5, 9, -8 },
  { 2, 23, 4, -2, -1, -20, -2, 14, 10, -9, -9, -24, 10, 0, 11, -12,
    12, 11, 49, -25, -2, 29, 7, -13, 21, -10, 11, -17, 3, 1, -8, 5 },
  { 3, 0, -14, -6, 18, -2, 17, -9, -19, 9, -5, 9, 14, 6, 19, -3,
    27, 1, 41, -21, 20, -15, 33, 0, 26, 14, 7, 10, 3, 20, -3, -12 },
  { -1, 16, 15, -8, 3, -8, -8, 21, -5, -16, -29, 4, 1, -6, -4, -28,
    2, 31, 37, -26, -2, 13, 24, 8, -9, -6, -29, 10, 7, 2, 7, 8 },
  { -10, -10, 11, 13, -32, 2, 16, 9, 14, 23, -15, -13, 24, 13, 4, -27,
    14, 12, 31, -18, 17, 23, -2, -7, -14, 9, -17, -6, -10, 20, 9, 6 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0,
    5, 1, 89, 8, 10, -6, 2, -1, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, -1,
    4, -7, 64, -50, 7, 37, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0 },
  { -2, 5, 3, -4, -4, -3, 2, -3, 3, -3, 5, 4, 1, -6, -1, 1,
    6, -2, 50, -35, -7, 43, 7, -7, -5, -26, 24, 21, 3, -15, 5, 6 },
  { -8, 21, -19, 33, -8, 22, -11, 17, 3, 0, 0, -2, 1, -3, 6, -1,
    10, -8, 4, -11, -4, -5, 0, 8, -4, 3, 1, -4, 4, 2, 8, 4 },
  { -7, 5, -20, 9, -22, 3, -14, 1, 6, 13, 23, -2, -4, -7, 2, 0,
    11, 4, 6, 3, -7, -11, -7, 4, 5, 5, -12, 8, 2, 4, 7, -3 },
  { -7, 6, -4, 20, -20, 16, -2, 7, 6, 16, 11, 12, -7, -7, 5, 3,
    -9, -4, 1, 2, 5, 2, 1, -9, -2, -17, -4, 6, -10, 7, -7, -6 },
  { -9, 18, -17, 12, -24, 1, -1, 4, 14, 9, 4, 3, 2, 8, -12, -14,
    4, -8, -4, 7, 7, 6, -1, 13, -9, -4, -1, 1, 0, -4, 15, 8 },
  { -25, 2, -11, 6, -5, 24, -28, -5, 8, 12, -2, 6, 8, -3, 8, -9,
    -1, -5, -1, -5, 6, -1, -1, -1, -4, 8, -12, -2, -13, 7, 2, 1 },
  { -14, 14, -18, 20, -10, 12, -2, 9, 1, 0, 12, -2, 15, -10, 26, -17,
    16, -11, 10, -10, 9, -2, 4, -8, 2, -3, 4, 4, 2, -3, -5, 1 },
  { -18, 12, -18, 21, -6, 12, -6, 13, -25, 18, 1, 11, -9, -5, 0, 10,
    -5, 3, -3, 8, -9, 7, 4, 2, -9, 0, 5, 0, 2, -3, 9, -8 },
  { -4, 16, 1, 18, -30, 9, 1, 6, -8, 13, 13, -12, -6, -1, 13, 7,
    6, 2, -15, -3, 5, 5, 1, -6, 1, -5, 0, 2, -16, 0, 3, -4 },
  { -21, 1, -2, 6, -43, 18, -1, 5, -1, 4, 6, -2, -1, -3, -1, -3,
    0, 1, 2, -9, 0, -1, 0, -2, 0, -1, -1, -2, 6, 0, 1, -2 },
  { -23, 10, 4, 7, -32, -11, -18, 2, -2, -7, -6, -3, -3, -12, 19, 3,
    -5, -6, 16, -6, 16, 2, 16, 16, 8, -2, 13, 8, -15, -11, 2, 10 },
  { -8, 2, -13, 2, -29, 24, -20, 19, 1, 10, -4, 10, 1, 2, -9, 11,
    -1, -2, 9, -5, 19, -7, 16, -9, -2, -18, 11, 1, 1, 0, 7, -3 },
  { -6, 3, 4, 13, -26, 10, -10, 28, -7, 28, 1, 7, 0, -14, 5, 7,
    4, -4, 3, -2, 3, 3, -11, 7, 6, 4, 0, -1, 2, -1, -3, 2 },
  { -6, 16, -31, 13, -10, 17, -6, 4, -14, 4, 4, -1, -10, 12, -5, 1,
    -14, 15, 0, -8, 1, -5, 3, 3, 9, -5, 7, -20, 7, 4, 11, -5 },
  { -19, 3, -17, 14, -12, 16, -22, 18, 14, 8, -2, 4, 10, 12, -14, 4,
    -3, 2, 3, 7, -7, 7, -6, 2, -2, -4, -5, 0, -5, -2, 2, 1 },
  { -9, -7, -11, 24, -36, -9, -11, 5, 7, -12, -13, 18, -2, 20, 1, -4,
    -1, -10, 15, -6, 14, 1, 0, 2, 1, 2, -9, -16, -11, 7, 13, 0 },
  { -24, 24, -18, 18, -22, 14, -11, 13, -12, 11, -10, 11, -7, 11, -5, -4,
    -1, 1, 5, 2, 3, -1, 1, -5, 7, -4, 5, -6, 8, -7, 8, -6 },
  { -6, 18, -22, 22, 5, 11, -1, 6, 19, 22, 8, 4, -8, 20, -2, 15,
    -6, -18, 0, -33, -9, -12, -1, 6, 5, 2, 5, 5, -5, -17, -3, -3 },
  { 1, 11, -16, 9, -18, 11, -4, 18, 20, 26, -10, 8, 1, -11, 8, -4,
    0, 7, 3, 5, 2, 2, 10, -2, -4, 4, -4, -2, 1, -4, -5, -1 },
  { -10, 6, -1, 18, -17, 27, -3, 10, -2, 12, -7, -9, 1, 1, -1, 7,
    -12, -1, -7, -6, -1, 8, 3, -15, 8, 9, 3, -7, 4, -1, 1, -1 },
  { -14, 6, -16, 22, 2, 5, 0, 5, -18, 11, 6, -3, 22, -20, -9, -3,
    6, -6, -7, -15, 1, 15, -8, 11, 8, -3, -8, 1, -8, 2, 6, -2 },
  { -21, 5, -19, 19, -7, 4, -7, 0, -8, 6, 12, 5, -3, -22, -13, -6,
    -1, -3, -2, -14, 6, -3, 1, -8, -7, -5, -6, 11, -3, -10, -5, 2 },
  { -1, 9, -12, 15, -6, 6, -19, 14, -9, 11, 3, 12, -17, -3, 8, -4,
    -3, -4, 1, -5, 4, 5, -7, -15, -7, 15, -6, -5, 1, -5, -3, 1 },
  { -12, 20, -15, 20, -14, 3, -14, 9, -6, 33, -13, 6, -2, 8, -6, 7,
    -5, -6, -3, -3, 0, 8, -3, -3, 1, -2, 2, 2, 6, -5, -5, -2 },
  { -7, 12, -18, 12, -18, 10, -4, 8, 2, 4, 8, 9, 0, 3, -8, 3,
    6, -12, -4, 1, 25, -5, -9, 6, -7, 0, -9, -7, 3, -5, -4, -4 },
  { -18, 12, -10, 11, -22, 0, -15, 5, -2, 2, -3, 6, -4, -4, -3, -15,
    -2, -3, 21, 6, -12, -11, 19, 3, 3, -14, 7, 0, -11, -22, -10, 0 },
  { -15, 2, -30, 15, -17, 13, -16, 8, -7, 10, -8, 2, 11, 3, 10, -7,
    7, -22, 12, -10, 3, -12, 6, -10, 12, -10, 7, -8, 5, 2, 9, 1 },
  { -9, 11, -14, 6, -10, 21, 5, 12, -5, 5, 7, 21, 6, 2, -2, -1,
    -1, 4, 2, -20, -18, -1, -14, 3, -1, 4, -7, 10, 1, 11, 4, -4 },
  { -22, 8, -30, 13, -21, -4, 4, -1, 12, 9, -2, -3, 2, -6, 4, -13,
    -2, 8, 8, 1, -7, 3, -4, -5, -1, -7, -2, 8, 8, 7, 8, 0 },
  { -6, -4, -35, 16, -13, 15, -11, 14, -7, 9, -1, 11, 7, 0, 13, 10,
    -1, 8, 1, 1, -2, 8, -1, 2, 2, 3, -10, -1, 7, -13, -3, -7 },
  { -15, 7, -16, 14, -18, 17, -6, 14, 3, 4, 7, -3, 10, -22, 5, -15,
    4, -4, -11, 15, -15, 11, -11, 20, 1, 0, 2, 1, 11, -3, 11, -7 },
  { -12, 3, 5, 16, -37, -1, 15, 15, -15, 10, 3, -10, 1, 15, 7, -15,
    -13, 8, 9, -3, 2, 12, -8, 2, -5, 0, -3, 4, 5, -9, -4, 5 },
  { -16, 26, -4, 14, -22, 26, 6, -3, -8, 4, 21, 6, 16, -4, -11, 7,
    -10, 3, 3, 7, -4, 2, -9, 8, -2, 2, 5, -2, -4, -2, 7, -1 },
  { -7, -10, 4, 3, 2, -4, -12, -10, -4, -5, 16, 19, -16, 1, 2, -9,
    -10, 0, 9, 7, -8, 3, 12, 8, -6, -11, -13, -1, -3, -20, 6, -5 },
  { -14, -17, 3, -5, 14, -12, -12, 8, -6, -25, 21, 21, 10, -8, -12, 4,
    10, -4, 3, -9, 11, 9, 0, 4, 2, -15, 1, -14, 4, 1, 0, -4 },
  { -4, -9, -3, -1, 6, 3, -6, 6, -10, -4, 14, 8, 2, -3, -12, -19,
    0, 11, -20, 1, 6, -2, -27, -6, 10, -17, -14, -17, -9, 8, -8, 3 },
  { -12, -13, 16, -4, -2, 12, -7, -11, 2, -13, 3, 7, -16, -18, -1, -12,
    -2, 1, -12, -9, -2, -6, 2, 9, -22, -3, -4, -14, -7, 7, -1, 2 },
  { -7, -8, -8, 15, 15, 18, 15, 16, -4, -37, 11, 15, -12, -1, -3, 3,
    6, 6, 0, -5, -3, -5, 9, 1, 1, -11, -1, -8, -6, 2, 3, 0 },
  { -6, 7, -5, -12, 13, 10, -18, -4, -3, -21, 6, 16, -15, -7, -12, -9,
    1, -12, -1, 10, -2, -1, -3, 4, -4, 1, -16, -1, 12, -9, 5, 9 },
  { -14, -5, 9, 3, 4, 26, -28, 3, -6, -24, 4, 5, 3, 13, 5, -1,
    3, -1, 3, 1, 1, -5, 3, 0, -7, -8, -7, -3, 3, -5, 4, 0 },
  { -4, 2, -10, -6, 25, 26, -6, 10, -6, -8, 15, 11, -6, -3, 2, -7,
    5, 14, 9, -1, 0, -12, 4, -4, -10, 1, -3, 3, -2, -2, -6, -1 },
  { -10, 8, -15, -10, 19, 17, -8, 0, -3, -7, 7, 5, -13, -1, 7, -7,
    1, 13, -12, -13, 17, -12, 1, 26, -18, -3, -5, -6, 4, 5, 8, 1 },
  { 2, -5, 3, 0, 0, 0, 2, -3, -2, -5, 7, 13, -4, 9, 0, -5,
    4, -1, -11, -8, -4, 0, -13, 2, -47, -23, -8, -11, -4, 4, -2, -3 },
  { -18, -4, 4, 5, -1, 17, -12, -8, 1, -12, 7, 20, -12, 3, -2, -11,
    16, 12, -6, 1, -13, -16, -6, -3, -3, -5, 4, -12, -5, -9, 10, 1 },
  { -11, 0, 4, 7, 7, 8, 3, -1, 3, -19, 32, 8, -19, -8, 2, 4,
    -12, 15, -16, 3, 1, 9, -2, 1, -2, 8, 5, 6, -4, -1, 11, -8 },
  { 3, -1, 4, -2, 14, 32, -9, -23, -10, -12, 22, 15, -1, -2, 10, 0,
    4, 6, -8, 4, -15, -2, -1, -4, 0, -8, 4, 1, -8, 3, 4, 1 },
  { -17, -12, 6, -8, 16, 13, -20, -8, -1, -16, 10, 21, -19, 11, -9, -5,
    7, 18, -6, 7, -7, -18, 13, 2, -2, 8, -12, -9, 2, 4, -5, 16 },
  { 4, 0, 17, -11, 12, 7, -12, 5, -1, -25, 30, -8, -7, -6, -4, -7,
    9, 8, 7, 3, 3, -16, 8, 0, -2, -2, -18, -3, -4, -5, 1, 4 },
  { -3, -6, 6, -16, 17, 6, -3, 2, -9, -17, 12, 11, 11, 2, -20, 8,
    1, 1, 0, 2, -2, -6, -21, -13, -9, -15, -1, -8, -6, -8, 0, -2 },
  { -11, -7, 6, -9, 3, 6, 8, 16, 4, -5, 23, 26, -10, -3, 4, 0,
    2, 2, -4, 4, -2, -12, 12, 10, -11, 0, -10, -16, 3, 0, 0, -10 },
  { -5, -16, 10, -6, 27, 13, -3, 4, -2, -13, 15, 5, 2, 5, 3, -4,
    13, 12, -11, -7, 0, 1, 11, 12, 2, 13, -15, -8, 9, -2, 3, 8 },
  { -5, -8, 4, 3, 9, 3, -11, 10, 14, -25, 14, 8, -2, 5, -12, -21,
    2, 10, -7, 2, -3, 2, 0, 2, -1, -3, -5, -6, -1, -16, 2, 8 },
  { -1, 5, 1, -11, 5, 9, -7, 8, -13, -12, 4, 12, -4, 1, -1, -1,
    27, 29, 10, 15, 2, -6, -3, 4, -21, 10, -9, -11, -6, -1, -9, -3 },
  { -6, -3, -1, -6, 11, -5, 0, -2, -5, -31, 11, 3, -1, 5, -3, 4,
    5, 7, -10, 5, -10, -13, 4, 12, -15, -2, 2, -7, 1, -9, -3, -10 },
  { -3, -7, 17, -8, -5, 36, 8, -7, -8, -20, 12, 8, 1, -1, 3, 0,
    1, 4, -10, 3, 1, 4, -2, -3, -2, -3, -10, 4, -1, -7, 3, 2 },
  { -13, -3, -5, 9, 22, 6, -23, 3, -10, -7, 17, 17, 18, -14, -8, -8,
    2, 4, -8, 2, -3, -8, 6, 4, -1, 7, 0, 0, -3, 0, -12, -3 },
  { -3, -10, -15, -3, 9, 3, -23, -9, -13, -18, 12, 13, -2, 0, 1, 8,
    -1, 2, -7, -12, -5, 14, 2, 1, -22, 6, -10, -8, -9, 28, -7, -14 },
  { -3, 1, 2, -1, 13, 7, -2, -7, 1, -3, 6, 9, -3, -2, 4, -2,
    2, 1, -10, -2, -2, -22, -2, -7, -10, -5, -11, -27, -12, -16, 4, -7 },
  { 2, -6, -3, 1, 8, 0, -2, 12, -3, -4, 58, 15, -10, -4, -2, 2,
    -2, 0, -2, -6, 2, 4, -1, 1, -4, 1, -1, -5, -4, -3, 3, 1 },
  { 10, -1, 0, 5, 21, 7, -14, 6, -3, -16, 15, 17, -16, 13, 3, -6,
    -4, 6, -12, -5, 1, -4, -7, -8, 2, 3, -6, 6, -1, -8, 5, 4 },
  { -6, -2, -8, -11, 15, 10, 0, 8, -6, -15, 33, 8, -2, 18, -15, -11,
    5, -1, 0, 15, -15, -4, -4, -1, 10, 7, -13, 4, -4, 0, 8, 3 },
  { -7, -2, 0, -2, 0, -2, -4, -5, -14, -16, 12, 38, 7, 12, 6, -4,
    0, -1, 0, 3, -2, -6, 0, 2, -9, 1, 0, -1, 0, -2, 4, 1 },
  { -8, -4, 18, 1, 14, 5, -12, -3, 20, -17, 5, 19, -11, -8, 11, -3,
    3, 9, -7, -8, 9, -17, 2, 15, -10, -11, 5, -5, 7, 15, -6, -2 },
  { -7, 2, 38, 5, 19, 16, -5, 4, -13, -20, 0, 4, -4, 6, 4, 2,
    -7, 6, -8, -2, -5, -7, 6, 3, -4, -3, -2, -3, 7, -6, -4, 0 },
  { -11, -12, 8, -15, -3, 14, -7, -22, -11, 2, 22, 14, -19, 2, -19, -6,
    1, 3, -18, 14, 2, -6, -2, -8, -3, -6, 5, -7, -8, -4, 1, 1 },
  { 8, 7, 25, -21, 12, -6, -5, -4, -10, 6, 0, 10, 1, -12, 18, -5,
    -15, 4, 1, 14, -1, 5, 8, -7, 1, -7, -3, 9, 10, 1, -1, 0 },
  { 9, 10, 32, -15, 8, 2, 11, -7, -18, -8, 2, -6, -9, -16, -3, 3,
    -1, 3, 1, -5, 4, -2, 1, -8, 0, -6, -3, -11, 1, 5, 0, 0 },
  { 14, 0, 23, -25, 22, 3, 7, 10, 0, -2, 7, 8, 0, 10, 0, 0,
    3, 2, 3, -10, 0, 10, 0, -7, 0, 10, -1, -5, -7, 1, -1, 2 },
  { 12, 0, 25, -18, -5, -4, 13, -10, 3, -6, 7, 21, 0, -16, 3, -10,
    -6, 5, -7, -3, 2, 5, 3, -6, 4, 9, -8, 12, -2, 3, 2, 4 },
  { 31, 15, 27, -20, 10, -7, 15, -10, 9, -8, 4, -5, 3, -3, 5, 6,
    11, -2, -12, -2, 6, -2, 1, 2, -1, -1, 1, 1, 3, 1, 1, 2 },
  { 12, -4, 13, -23, 12, -6, 2, 4, -3, 13, 6, -7, 5, -19, -7, 18,
    1, -7, 7, 1, 16, -7, 3, 0, 3, 0, -12, 8, -11, 9, 4, 7 },
  { 29, 1, 3, -22, -5, 6, 0, 12, -14, 11, 1, 6, -3, 4, 6, -2,
    4, -13, 12, 1, 1, 3, -11, 9, -10, -1, -7, 16, -11, -1, 3, 9 },
  { 4, 4, 36, -23, -5, -8, -15, 1, -6, 3, 13, -1, -5, -7, 4, 9,
    2, -11, -3, 5, 1, 3, -6, -1, -4, -4, -2, 2, 3, -1, -5, -2 },
  { 19, 10, 6, -17, 2, -4, -2, -4, -3, 13, 2, 2, -13, -7, -3, -11,
    9, -6, 1, -9, -5, 4, -5, -9, -18, -7, -11, 9, 4, -11, 8, 4 },
  { 16, -3, 9, -16, 18, -2, -12, -16, -11, 11, -18, 16, -13, 6, 2, 8,
    3, 8, -4, -16, 10, -11, -1, -3, -8, 5, -9, -4, 9, -4, 0, -3 },
  { 14, 15, 3, -23, -5, 7, -8, -6, 2, 17, 2, 12, -8, -12, 13, -1,
    -9, 3, 1, 1, 19, 15, 4, -1, 1, 2, -3, 2, -3, 1, 5, 3 },
  { 32, 5, -10, -47, -5, -1, 4, 11, -7, 0, 2, -2, 1, -7, 6, -4,
    6, 2, -4, -2, 2, -2, 0, -4, 1, -6, -5, 2, -2, -1, -3, -4 },
  { 20, 8, 10, -21, -7, -9, -16, 12, 1, 4, 6, -5, 9, -11, -7, 4,
    -11, 28, -3, 2, 4, -6, 10, -8, -5, -5, -9, 9, -2, -1, 6, -5 },
  { 38, 3, 23, -25, -6, -18, 3, -10, -8, 6, -10, 1, -10, 2, 2, 0,
    -7, 2, -4, 5, -1, 8, -3, 0, 3, 3, -1, 1, 0, -4, -4, 0 },
  { 20, 5, 16, -22, 24, -18, 2, -12, -14, -7, -3, 10, 2, 7, -10, 2,
    -8, 1, 8, -1, 4, 1, 4, -2, 5, -9, -18, -8, -13, 5, -11, 10 },
  { 14, 8, -12, -16, 9, -11, -3, -6, -25, -7, 6, 5, -7, -16, 10, 2,
    -7, -1, -9, -3, 16, 4, 3, 3, -3, -3, -15, 13, -3, 4, 13, -7 },
  { 16, -9, 19, -23, 7, -19, -3, -5, -15, 11, -21, 21, -16, 18, -1, 6,
    10, -10, 18, -14, 16, -15, 6, -5, -9, 5, -17, 13, -10, 13, 0, 10 },
  { 8, -4, 4, -24, 8, -21, -18, 9, -11, 4, -6, 17, 5, -9, -2, -2,
    2, 15, -2, -3, -2, 1, 7, -13, 15, -10, -8, -11, 3, 3, -1, -1 },
  { 14, 17, 6, -32, 5, -17, -2, 0, 15, -1, -5, 16, 1, -5, -2, 9,
    -3, 8, 4, -2, -2, -4, -3, 1, 0, 7, -3, 4, -5, 0, -7, 2 },
  { 24, 6, 22, -12, 8, 3, -14, 4, -7, 8, 6, 5, 6, 1, 6, -12,
    15, 10, 4, 11, 9, 6, -7, -4, 10, -9, 2, -1, -5, 11, 15, 3 },
  { 17, 12, 3, -23, 5, -1, -2, 1, -9, -1, -3, 1, 8, 1, -5, 17,
    11, 0, -2, -11, 7, 4, 0, -27, -7, 1, 2, -8, 9, 7, 5, 3 },
  { 12, 10, 12, -10, -4, 5, -1, 2, -24, 5, -8, 2, 6, -17, 19, 5,
    12, -2, 16, -7, -6, -14, 4, 1, -3, 13, -16, 5, -1, 4, 1, 1 },
  { 31, 9, 11, -17, 10, -3, -7, 7, 1, 2, 2, 4, -3, -1, 11, 4,
    -5, -8, 1, 4, 15, -6, -28, 1, 8, 3, -6, 5, 17, -2, 2, -4 },
  { 11, 19, 16, -26, 0, -7, -7, 2, -13, -15, -12, 9, -3, 27, 8, 4,
    -6, 1, 4, -6, 11, -1, -6, -7, -3, 0, -6, 4, -6, -7, -3, -1 },
  { 10, 18, 16, -32, 19, -9, -4, -3, -7, 8, 8, -3, -11, -2, -6, -16,
    13, 13, -6, -1, 10, -2, -2, -9, 0, -3, 9, 4, 11, -2, -6, 6 },
  { 9, 4, 19, -33, 4, 7, -12, 36, -3, -1, 8, -2, 2, -8, -9, -4,
    -8, 0, 1, -1, 0, -4, -4, 3, 0, 3, 6, 0, -6, 2, 0, -2 },
  { 25, 7, 15, -12, 2, -24, -1, 24, -4, 4, 9, 0, -2, -9, 4, 6,
    3, 13, -3, 1, 5, -1, -3, -5, -1, 7, -2, 3, 4, 4, 1, 0 },
  { 19, 6, 8, -20, 9, -9, 5, -4, -13, 7, 11, -3, 5, -13, -9, 6,
    -11, -1, 0, 4, 11, 26, 3, 6, -7, 12, 6, -3, 1, -9, 7, 1 },
  { 15, 6, 19, -23, -3, -9, 3, 16, -6, -4, 6, -5, -10, 1, 16, -14,
    2, 0, 2, -13, -3, 8, -6, 3, 1, 1, 2, -5, 12, -4, -8, -3 },
  { 14, 4, 16, -20, 1, 12, 0, 6, -3, 9, 4, 16, 10, -16, 5, 7,
    5, -4, -4, -18, -3, -11, -4, 4, -7, 3, 13, 7, 3, 3, 2, -7 },
  { 22, 3, -1, -30, 18, -3, -9, 9, -2, 11, -16, -2, -14, 12, 0, 4,
    -5, 4, -1, 3, -20, 12, 4, -10, -2, -2, -12, -12, 10, 6, 11, -3 },
  { 15, 7, 2, -21, 5, 4, 9, -9, -33, 7, 7, 3, -6, -14, -8, 10,
    12, 0, 2, -1, 5, 4, -2, 0, -7, 0, 2, 4, 0, 1, -3, 8 },
  { -7, 0, 12, 3, 0, -6, 8, -4, 0, 2, 14, -15, 2, -7, -31, -3,
    14, 0, 14, -15, -1, -4, -15, 10, 1, -3, 1, 2, 5, 2, -8, 1 },
  { -2, 5, 1, 0, -3, 3, 3, -6, -1, 2, -4, 1, -19, 0, -11, 18,
    11, 10, 21, 5, 6, 2, 10, 3, -6, 0, -2, 13, 5, -1, -2, 9 },
  { -9, 1, -5, 0, 0, -15, 8, 4, 8, 3, 8, 12, -13, -2, -39, -2,
    4, -4, 5, -3, -4, 3, -3, 3, 10, 5, 3, 2, -3, 5, -2, 8 },
  { -9, 6, 6, -8, 12, -12, 23, -18, 4, -15, -5, 2, -20, 13, -7, 7,
    7, -12, 14, -12, 6, 1, 1, -3, -8, 9, 0, 1, -7, 3, 7, -6 },
  { -18, 13, 4, 3, -10, -30, -10, -6, -14, 1, -7, -4, -35, 5, -25, 11,
    9, 8, 19, -4, -7, -3, -18, -8, 1, 5, 10, -4, -14, -9, 3, -4 },
  { -6, -1, 4, -9, -9, 4, 20, 0, 0, 3, 11, 7, -16, -17, -20, 11,
    -6, -14, 1, 4, 19, 2, -8, 6, -15, 3, 6, -5, -14, 3, 7, 2 },
  { 1, 6, -2, -8, -5, -3, 3, -8, 21, 1, 3, 16, -14, -2, -9, -4,
    13, -2, 18, 14, 14, 19, -13, 5, -10, 2, -3, 3, 5, 5, 1, -1 },
  { -1, -5, -6, -2, -11, -7, 5, -4, 5, -1, 0, 3, -3, 2, -19, 18,
    16, 4, 14, -22, -2, -11, -22, 1, -1, 11, 1, 2, 11, -10, 7, -12 },
  { 1, 4, 5, -1, -9, -5, 1, 12, 5, 6, 12, 9, -24, 23, 1, 20,
    14, -11, 13, 5, -2, -2, 5, 6, 2, 1, -9, 6, 10, 5, -4, 11 },
  { -1, -1, 1, 7, -3, -4, 8, -16, 15, -1, -7, 9, -22, -11, -11, 10,
    16, 9, -2, 4, 13, 10, 6, 16, 4, 7, 1, -8, -7, -14, -7, 4 },
  { 1, 3, -6, 0, 15, -9, -4, 0, 4, 6, 12, 9, -6, -5, -22, 17,
    7, -11, 15, -5, 1, 3, -19, 0, -15, -3, 16, 5, 5, -7, -11, 12 },
  { -2, -1, 13, 2, 4, -24, 37, -5, -2, -6, 12, 7, -2, -23, -4, 9,
    2, -3, 3, 2, 3, 3, -14, 11, 0, -4, -2, -2, 3, 10, -10, 4 },
  { 2, 9, 8, -6, -28, 14, 28, -11, 18, -11, 0, 2, -2, 4, -12, 3,
    6, 0, 7, -7, -6, 2, 5, -1, -1, -1, 5, 2, 3, 0, -3, 9 },
  { -7, 14, 5, -10, -3, 7, 4, -5, 7, -8, -7, 4, -12, 14, -16, 25,
    3, 0, 1, -5, 12, -10, 0, -10, 0, 12, 12, 17, 12, 10, -1, 0 },
  { -4, -2, 5, -2, -17, -3, 5, -5, 7, -17, 1, 5, -4, 4, -20, 0,
    11, -15, 13, -8, 10, 1, 1, 5, -12, 9, -8, 0, 6, -1, -11, 4 },
  { -3, 12, 13, -15, -7, -7, 0, 5, 33, 3, 3, -6, -13, -7, -15, 10,
    3, 3, 3, -5, 2, 7, -1, 0, -12, 2, 11, -6, -9, 0, 5, 11 },
  { -8, 5, 10, -7, -14, -4, 13, 0, 18, -3, -6, 7, 1, -6, 0, 21,
    8, -7, 10, -8, -3, 17, -9, 0, -5, 1, 4, 8, -3, 11, -5, 0 },
  { -8, 8, -3, -8, 8, -11, 16, -16, 17, 0, 8, 16, -17, 10, -16, 10,
    -8, 6, 11, 0, 10, 7, 4, 5, 7, -5, -5, -6, -7, -5, -1, 16 },
  { -6, 0, 6, 1, -8, -8, 8, -7, -5, -10, -11, 8, -19, 6, -7, 13,
    5, -3, 4, -8, 7, -1, -18, 9, 0, -5, 6, 26, 3, 8, 2, 4 },
  { -2, -2, 23, -2, -20, 2, 7, -7, -6, -15, 3, 9, -19, -2, -10, 7,
    -2, 7, 9, 11, 0, 4, -4, 6, 9, -2, 4, -3, 4, 3, 2, 8 },
  { -6, 12, 10, -10, -7, 4, 17, 11, -6, 1, 12, 11, -18, 8, -12, 4,
    1, 13, 6, -13, 23, 9, -5, 8, -2, -5, 1, 3, 0, -2, -4, 4 },
  { 7, 1, 7, -17, -8, 8, -1, -7, 5, -6, 4, -3, -16, 9, -24, 18,
    -3, 10, 13, -11, -6, -11, -4, 10, 0, 11, 8, 2, 6, -5, -11, 4 },
  { -4, 1, -5, -10, 0, -3, 9, -2, 4, -1, 1, 5, -41, -10, -7, 4,
    -3, 3, 1, 0, -12, 4, -3, 0, 2, -1, -2, -5, 3, 2, -7, 5 },
  { -2, 1, 4, 4, -3, -6, 1, 0, 12, -5, 11, 0, -17, -3, -1, 11,
    4, 1, 27, -12, 0, -14, 2, -15, -3, -9, 0, -7, -3, 15, -8, 6 },
  { -6, 4, 9, 2, 4, 3, 7, -10, 28, 1, -2, 48, 7, 0, -10, 10,
    1, -9, 2, -1, 0, 3, -5, 5, -4, -2, 7, 7, 1, 3, 2, 5 },
  { -3, 3, -1, 3, -9, 0, -1, 3, 2, -6, 39, -14, -12, 5, -19, 21,
    7, -6, 4, -1, -4, 0, -4, 1, 0, -9, 1, 10, 0, -2, 0, 7 },
  { 4, 2, -29, 12, 5, -3, 16, -6, 15, -13, -4, -1, -13, 22, -16, 17,
    16, 4, 9, -4, 4, -6, -4, 11, -8, 7, 8, 4, 3, -3, -7, -13 },
  { 0, 3, 3, -6, -4, 0, 9, 0, 5, 0, 10, 10, 4, -13, -12, 16,
    23, -4, -12, -6, -4, 20, 2, 0, -4, 23, 1, 8, 11, -4, -5, 15 },
  { -6, 4, -15, -9, -1, -19, 12, -30, -17, -4, 1, -13, -13, 4, -3, 26,
    5, -25, 11, -14, -6, -13, 0, -7, 9, 2, 8, -1, -8, 1, -8, 13 },
  { 1, 6, 1, -4, -4, 1, 2, 0, -3, 2, 10, 6, -6, -2, -11, 4,
    32, 15, 15, -47, -8, 3, -12, 4, -5, 4, -1, 0, -5, 5, 1, -7 },
  { 2, -1, 0, 0, -1, -6, 0, -6, 4, -4, 5, 9, -5, 1, -3, 51,
    4, -5, 4, -14, -1, -4, -3, 1, -4, -1, 0, 2, -8, 0, 1, 2 },
  { 0, 4, -2, -7, -2, -9, 6, -8, 11, -3, -6, 3, -11, -8, -12, 8,
    11, 5, 19, 3, -24, 19, -14, 11, -5, -18, -8, -12, -5, -4, -1, 4 },
  { 16, 9, 10, 14, -18, -2, -18, -27, 10, -5, 12, 14, 4, 0, -2, -6,
    -12, -7, -1, 3, 4, 7, 11, 10, 5, -5, -7, -16, -3, -6, 6, 9 },
  { 7, 15, -9, 10, -19, 4, -5, -37, -2, -4, 8, 2, 4, -1, 1, 9,
    -5, -5, -12, 1, -1, -8, 3, -3, 4, 6, 9, 3, 3, -1, 2, 4 },
  { 13, 17, 3, 9, -7, -7, -15, -17, -8, -13, -4, -8, 19, 2, 16, 25,
    7, 15, 2, 16, -5, -6, -10, -9, -7, -6, -2, -7, 7, 2, 4, 5 },
  { 24, 7, 9, 8, -13, -2, 0, -4, 1, -13, 3, 6, 7, 10, -4, 15,
    5, 7, -4, 5, -5, 3, 13, -7, 5, 15, -11, -2, 7, 5, 8, 6 },
  { 17, 6, -15, 23, -2, -1, -6, -2, 0, -4, 11, -3, 12, 15, 6, -8,
    -15, 10, -9, 7, -1, -11, 2, -8, -4, 3, 4, -10, 4, 4, 11, 1 },
  { 21, 12, -3, 6, -8, 8, -11, -8, -5, -5, 3, 7, -1, -5, 12, 15,
    -10, -11, 3, 15, 8, 4, 2, -15, 0, 14, 1, -8, -1, 3, 10, -7 },
  { 16, 12, 5, 13, -6, 15, -23, 0, -17, -9, 0, 4, -9, 13, 6, 18,
    0, 0, -4, -1, 0, 14, 5, -1, 8, -4, -8, -6, 5, -2, -2, 0 },
  { 14, 16, -1, 12, -15, -9, -6, -20, 4, 6, 8, 9, 3, 1, -9, -4,
    -1, -11, 9, 11, -12, 1, -14, -7, 2, -8, 11, 9, -4, 10, 4, -16 },
  { 13, 10, 3, 7, 0, -8, -33, -6, 4, -4, 19, -2, 14, 6, 5, 7,
    6, -3, -1, -10, -10, -9, 4, -3, 5, 9, 2, 2, 10, 9, -2, -3 },
  { 11, 10, 25, 18, -1, -6, -21, -21, -11, -16, 6, 5, 14, 4, 8, 7,
    0, -10, -7, -9, -5, -4, 3, -1, 1, 6, -1, 6, -2, 2, -3, -9 },
  { 15, 9, 5, 22, -17, 15, -9, 7, 7, -9, 13, 9, 10, -1, 8, -3,
    -2, 6, 1, 17, 8, -14, 7, -3, 12, 9, 1, 0, 1, -5, 17, -18 },
  { 25, 19, -17, 12, -4, -10, 1, -13, -19, -7, -3, 9, 6, -2, 3, 1,
    4, -2, -11, -14, -1, -7, -5, -9, 7, -1, -3, 4, -5, 1, 0, -1 },
  { 20, 8, -3, -10, -24, 3, -6, -2, 0, -12, 14, 6, 7, 11, 4, 7,
    -12, -5, -8, -10, 5, -1, -4, 4, 16, 7, -14, 6, -1, -2, -7, -11 },
  { 16, 18, 17, 1, -15, -6, -5, -3, -1, -19, 8, -2, 2, 8, 12, -19,
    -12, 8, 0, -3, -1, -1, 4, -14, 9, -1, -12, -1, -7, 10, -3, 5 },
  { 18, 12, -7, 7, 0, -3, -13, 0, -1, -4, 9, -2, 6, -1, 0, 1,
    15, -21, 1, -8, 25, -19, 13, -9, 2, 12, 5, -7, -3, -1, -3, 1 },
  { 13, 16, -4, 9, -2, 2, -1, -19, -7, -4, 18, -6, 14, 18, -5, 4,
    -6, -3, -19, -14, -1, -12, 10, 6, 7, 17, -12, -13, -10, -4, 5, 4 },
  { 27, 17, 4, 14, -9, -2, -4, -8, 0, -6, 14, -11, -7, 2, -3, -3,
    -2, -3, -13, 12, 16, 1, -5, -9, -10, -11, -2, 3, -7, 5, 11, -7 },
  { 7, 17, -16, -2, -14, -28, -7, -8, 15, -10, 7, 15, 8, 17, 13, -1,
    4, -7, -12, -11, 0, 0, 2, 3, -3, 7, -6, 6, 1, -16, 1, -2 },
  { 23, 11, -9, 15, -23, -4, -6, -4, 2, -9, -7, 9, -8, 3, -13, -4,
    8, 18, -6, -2, 1, -5, 6, -14, -5, -2, -6, -5, -3, -2, 4, -5 },
  { 12, 13, 18, 18, -35, 2, 7, -17, 3, -11, 6, 9, -3, -2, 10, -4,
    3, 3, -2, -7, 0, 2, -4, 0, -4, 0, -6, 5, 10, 4, -3, -1 },
  { 19, 11, 1, 20, -14, 4, -9, -13, -2, 11, 0, 17, -1, -1, -1, -1,
    -5, -8, 0, 5, -1, -8, 5, -1, 3, 2, -12, 21, -2, -24, 5, 7 },
  { 15, 15, -15, 17, -14, -22, 3, -4, -11, -3, -7, 1, 18, 10, 1, 10,
    -6, -3, 8, 2, -7, 0, -2, 1, 1, 2, -9, -2, 1, 2, -3, 4 },
  { 45, 13, 8, 17, -5, 2, -16, 2, 8, -2, 8, -15, 4, 5, -1, 7,
    -6, -2, -6, 2, -3, 0, 0, -9, -1, 7, 2, 3, -3, -3, -1, 5 },
  { 1, 18, -8, 18, -12, -10, 3, 4, -22, -12, 20, 8, -3, 9, 2, 10,
    -10, -3, 9, 3, 6, -3, 10, -1, -3, 2, -2, 4, 2, 3, -3, -18 },
  { 9, 10, -5, 9, -35, -21, -18, -16, -1, -12, -6, -7, -15, -19, 12, 4,
    4, 9, -7, 2, 14, 1, 4, 0, -1, 6, -7, 2, 1, 1, -4, 4 },
  { 31, 8, -17, 35, -8, 1, -5, -6, -7, -6, 10, -2, -3, 6, 9, 3,
    -6, -2, 3, 3, 5, -3, 0, 6, 0, 1, -5, -3, -2, -4, -1, 0 },
  { 18, 4, -8, 7, -8, -15, -1, -16, 12, 18, 3, 19, 2, 4, 8, 8,
    0, -5, -8, -12, 10, -5, 0, 1, 0, 4, -3, 16, 11, 11, -2, -6 },
  { 27, 15, -17, -10, -23, -22, -1, -14, -4, -7, 20, -2, -7, 6, 15, -5,
    32, 4, 9, -11, -3, -8, 11, -4, -1, -4, -8, -6, -4, -5, -2, -7 },
  { 22, 4, -7, 2, -15, -11, -17, -10, 2, 0, 15, 11, 7, 12, -8, 6,
    -10, -18, -6, -12, 7, 3, 22, 3, -7, 14, -5, -2, -13, -7, -1, -7 },
  { 18, 13, 9, 24, -4, -19, -9, -11, 13, 8, 2, 4, -1, 8, 14, 10,
    -12, 0, 0, 5, 10, 5, 4, -1, 5, 1, -1, 11, 2, -4, 0, -9 },
  { 15, 19, -5, 1, -4, -10, -8, -27, 6, 8, 5, 10, 4, 11, 5, -5,
    -11, 0, -11, -14, -4, -9, -8, -8, 6, -9, 4, -5, -1, 1, 5, -4 },
  { 18, 1, -13, 14, -14, 9, -15, -7, 12, 1, 13, -4, -20, 12, 10, 12,
    -12, 7, 1, -13, 10, -6, 5, -3, 4, 8, 10, -13, -3, -6, 9, -3 },
  { 19, -14, 5, -8, -6, 2, -5, 5, -3, -1, -28, 11, 18, -6, -4, -2,
    11, 14, -43, -42, 9, 2, 20, -23, 6, 32, 0, 5, 0, 6, 9, 5 },
  { 8, 11, -14, -1, 7, 12, -7, 2, -16, 2, 10, -3, -1, -7, -7, -1,
    1, -10, -60, -23, -18, 42, -13, 9, 18, -11, 0, 1, 0, 2, -5, 1 },
  { -5, -1, 2, 0, 3, -3, 3, -2, -6, 0, -3, -3, 7, 2, 0, -2,
    -2, 3, -34, -15, 37, 47, 10, 20, 9, 1, 3, -21, -25, -33, -14, 8 },
  { 5, 6, 2, -2, -2, -2, 6, 5, -5, 7, -3, 1, -5, -13, 9, 3,
    -17, -19, -2, -79, -12, -7, -8, -6, -2, -2, -1, -1, -7, -13, 6, -1 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, -1,
    0, 3, 4, -87, 6, -11, 16, -9, -1, 8, 0, 5, 0, 1, 2, 1 },
  { -5, 6, 2, -24, 5, -9, -7, 0, 7, 3, -3, 16, -14, -16, 0, 18,
    15, -9, -14, -28, -17, 53, 14, -6, -28, -1, -3, -10, -7, -14, 19, -15 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3, 0,
    -13, 0, -53, 3, -22, 63, 19, 16, 1, -11, 0, -3, 0, -3, 0, 1 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1,
    -1, -6, -43, -43, -2, 65, -13, -4, 9, 1, 1, 2, 1, 0, 0, 1 },
  { 0, 1, 0, 0, -1, 0, 1, 1, 0, 0, 1, 2, -1, -1, -3, -1,
    -23, 1, -61, -55, 3, -28, -6, -4, -4, 8, 2, 1, 1, -1, 0, 0 },
  { 0, 1, -1, 1, -1, 0, -1, 0, 1, -1, 0, 1, -1, 0, -9, -4,
    -48, -19, -52, -46, 11, -12, 5, -14, 0, -10, 0, 0, -1, -2, -1, 0 },
  { 0, -3, -1, -4, 2, -1, -7, 3, 1, 3, -1, 1, -3, 0, -7, 0,
    3, -7, -61, -51, -4, -21, -16, -21, -11, 14, -7, 8, 3, -5, 1, 2 },
  { 0, 0, 0, 1, 0, 0, -1, 0, 0, 0, 0, 0, 1, -1, 9, -3,
    56, -11, -6, -67, -1, 13, 0, 7, 1, -9, -1, -1, 0, 0, 1, 0 },
  { 14, 9, -2, 14, -10, -10, 9, -5, 1, -8, -23, 30, 8, -7, 23, 8,
    2, 10, -1, -27, -17, 57, 22, 4, -5, 2, -12, -6, 2, -7, -4, -9 },
  { 1, 5, 12, -2, -2, -3, 2, -3, 6, 0, 4, -2, -8, -6, 0, 16,
    -15, 29, -55, -29, -24, 29, 3, 10, 6, 13, 10, -5, 21, 11, -14, 5 },
  { 4, 2, 26, -6, 10, 11, -23, -10, -27, -20, 3, -24, -11, -10, -13, 25,
    -10, 5, -9, -36, -7, 43, 3, -13, 6, 13, -2, 0, 1, 3, -3, -4 },
  { -1, 0, -1, 0, 0, 0, 0, -1, 1, 0, -1, 0, 0, 0, -1, 1,
    -12, 12, -26, -64, -15, 29, 37, -7, -3, -12, -5, 14, 8, -8, -10, -2 },
  { 19, -4, -11, -16, 8, 14, 5, 19, 3, 22, -11, -21, -1, -6, -11, 11,
    10, -24, -23, -40, -8, 20, 17, 5, 13, -6, 3, 14, -20, -8, 3, 28 },
  { 2, -12, 10, -14, -18, 26, -22, 4, -2, 5, -21, 8, 3, 1, 19, 0,
    -12, 24, -14, -40, 15, 29, -15, 6, 15, 1, -19, 2, 4, 7, -12, -3 },
  { 0, 17, 13, 7, -5, -11, 2, -19, 3, 38, -21, -3, -6, -4, 7, 1,
    1, -5, -40, -10, -2, 35, 8, 8, -10, -8, -9, 33, 4, 4, 0, -2 },
  { -2, -12, 7, 29, -24, 2, 16, -1, -7, 16, 10, -2, -2, -2, 13, -2,
    -37, 15, -22, -40, -11, 33, 10, -1, 8, 10, 6, 8, 9, 0, -12, 2 },
  { 15, -8, -9, -2, 7, -17, 7, 19, 14, 4, 12, 27, 11, 10, 4, 11,
    -15, 14, -13, -48, 5, 18, 0, -9, -36, -11, 2, 4, 5, 5, -15, -12 },
  { -12, 0, 3, 4, 7, -5, 5, -14, -24, -18, -6, -15, -8, -20, 1, -7,
    -33, -28, -40, -38, -18, -10, -5, 17, -12, 4, 3, -5, 5, -13, 4, -7 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1,
    -3, -9, -49, -60, -5, 45, -1, 6, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1,
    -3, -9, -49, -60, -5, 45, -1, 6, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0,
    3, -2, 9, -29, -11, 55, 8, 32, -36, -13, -7, 37, 4, 11, 0, 3 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    4, -1, -39, -4, -30, 63, 28, -17, -6, 10, 7, -14, -9, 11, 9, 7 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1,
    13, -2, -50, -32, 22, 51, 4, 7, 6, 11, -20, -13, 9, -5, 21, -4 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1,
    -3, -9, -49, -60, -5, 45, -1, 6, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1,
    -3, -9, -49, -60, -5, 45, -1, 6, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0,
    3, -2, 9, -29, -11, 55, 8, 32, -36, -13, -7, 37, 4, 11, 0, 3 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    4, -1, -39, -4, -30, 63, 28, -17, -6, 10, 7, -14, -9, 11, 9, 7 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1,
    13, -2, -50, -32, 22, 51, 4, 7, 6, 11, -20, -13, 9, -5, 21, -4 },
  { -8, 2, 1, 22, -31, -6, -25, -3, -3, 1, -15, -11, -2, -3, 4, -13,
    -9, 15, -18, 37, -7, -37, 12, -13, -11, -25, -10, -11, -22, 7, 16, 7 },
  { 14, 10, 4, -10, -1, -5, -7, -3, 16, 13, -5, -15, 5, 11, -1, 8,
    -27, 7, -12, 49, 17, -22, 9, -2, -9, -1, 2, -15, -1, 41, -18, -17 },
  { -4, -9, -15, -3, 3, 4, 4, 2, 7, -3, -7, -8, -5, 17, -19, -7,
    36, -9, -38, 17, 1, -48, 11, -18, -13, -2, -8, 4, -10, -5, 21, 11 },
  { 15, -13, 4, 2, 1, -5, -2, 1, -10, 7, -1, 3, -6, 0, 11, -11,
    8, 20, -17, 51, -17, -41, 2, 15, 4, 8, -2, 16, -32, -1, 17, 6 },
  { -8, 8, -18, -5, 4, 6, -3, 8, 0, -4, 2, 0, -1, -4, 5, 8,
    30, 30, -8, 70, 2, 8, 2, 0, 7, 1, 13, -1, -6, -7, -11, 2 },
  { -8, -7, 9, -10, -13, 6, -11, -14, 13, 25, -26, 5, 2, -5, -5, 5,
    -8, 4, 0, 33, 12, -38, -4, 6, 13, 6, 25, 34, -1, 25, -19, -5 },
  { 18, 3, -17, 4, -8, 7, 20, 1, -1, 5, -5, -2, -8, 8, -35, 15,
    24, 43, -5, 51, 5, -12, -3, 1, -2, 3, -3, -3, -9, 8, -9, 2 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    2, 10, 24, 76, -2, -22, 11, -1, 4, 33, 4, 1, -1, 1, 2, 0 },
  { 0, -1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 2, 0,
    24, 13, 32, 70, 26, 5, -21, -9, -6, -15, 2, -2, 2, 4, 1, 1 },
  { 5, -4, -11, 4, -4, 22, 10, -2, 13, -11, -4, -21, -17, 0, -7, 4,
    10, -34, 11, 52, 2, -46, -5, 0, 0, -1, 2, 4, -9, 1, 1, -7 },
  { 0, 1, 1, 0, -1, 0, 1, 0, 1, 1, 0, 1, 0, 0, -3, 1,
    -8, 9, -1, 64, -13, -61, -3, 3, -5, 10, 1, 3, -1, -1, -1, -1 },
  { 0, 1, 0, -1, 0, -1, 0, 0, 1, 0, 0, 0, 1, 1, 2, 1,
    10, -2, -31, 79, -10, 27, 0, -1, 3, 8, 1, 1, 0, -1, 0, -1 },
  { 3, 12, 10, 26, -19, 10, -9, 6, -4, -15, 10, 3, -16, 6, 11, -19,
    3, 10, 18, 44, 5, -30, 5, -9, 21, 4, 20, 10, 14, -25, 8, -17 },
  { 0, 0, 0, 1, -1, 0, -1, 0, 1, 0, 1, 1, 0, 0, -6, -2,
    8, -8, 13, 69, 26, -19, -25, -17, 16, 6, -12, 22, 2, -6, 9, 5 },
  { 0, -1, 0, 1, 0, -1, -1, 0, 0, 1, -2, 1, 0, 0, -4, -1,
    -34, -15, -33, 56, 9, -42, 9, 10, 6, 9, -8, -11, 0, -6, 15, 5 },
  { 10, 2, -14, -3, -15, -35, -1, 7, -18, 14, 8, -1, -15, -26, 6, -15,
    -18, 22, 9, 33, 0, -32, -9, 3, -11, 7, 4, -1, 5, 30, 9, 1 },
  { 4, 15, 0, 6, -5, -11, 9, 6, 6, 6, 14, 2, -1, 10, -24, -25,
    -2, -4, -1, 37, 2, -29, 14, -9, 22, 17, -2, 33, 10, -25, 11, -11 },
  { 0, 5, 2, 18, -12, 21, 22, 33, -7, 21, -9, -7, 7, -15, -7, 16,
    7, 0, -14, 44, 10, -25, 5, -4, 15, -8, 10, -4, 5, 9, -1, 16 },
  { 3, 13, 12, 12, 8, 25, -23, 8, -22, -3, -18, -8, 15, 12, 9, 19,
    0, 0, -9, 49, -27, -15, -9, -15, 12, -8, -16, -7, 13, 5, 13, 2 },
  { 12, -6, 7, -2, 20, -9, -14, 12, 13, -5, -17, 22, -8, -4, 2, 7,
    -13, -2, -15, 43, -5, -30, 27, 4, 10, -27, 5, 27, -10, -10, -18, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    -1, 10, -18, 70, -2, -52, -1, -7, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    -1, 10, -18, 70, -2, -52, -1, -7, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 15, -13, -20, 16, 2, 13, 5, -11, -8, -5, -3, 2, 24, -23, 30, -7,
    11, 30, -15, 43, 5, -15, 15, -3, -14, 1, -23, 8, 3, 9, 4, -11 },
  { 0, -1, 0, 1, 0, -1, -1, 0, 0, 1, -2, 1, 0, 0, -4, -1,
    -34, -15, -33, 56, 9, -42, 9, 10, 6, 9, -8, -11, 0, -6, 15, 5 },
  { 10, 2, -14, -3, -15, -35, -1, 7, -18, 14, 8, -1, -15, -26, 6, -15,
    -18, 22, 9, 33, 0, -32, -9, 3, -11, 7, 4, -1, 5, 30, 9, 1 },
  { 4, 15, 0, 6, -5, -11, 9, 6, 6, 6, 14, 2, -1, 10, -24, -25,
    -2, -4, -1, 37, 2, -29, 14, -9, 22, 17, -2, 33, 10, -25, 11, -11 },
  { 0, 5, 2, 18, -12, 21, 22, 33, -7, 21, -9, -7, 7, -15, -7, 16,
    7, 0, -14, 44, 10, -25, 5, -4, 15, -8, 10, -4, 5, 9, -1, 16 },
  { 3, 13, 12, 12, 8, 25, -23, 8, -22, -3, -18, -8, 15, 12, 9, 19,
    0, 0, -9, 49, -27, -15, -9, -15, 12, -8, -16, -7, 13, 5, 13, 2 },
  { 12, -6, 7, -2, 20, -9, -14, 12, 13, -5, -17, 22, -8, -4, 2, 7,
    -13, -2, -15, 43, -5, -30, 27, 4, 10, -27, 5, 27, -10, -10, -18, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    -1, 10, -18, 70, -2, -52, -1, -7, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    -1, 10, -18, 70, -2, -52, -1, -7, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 15, -13, -20, 16, 2, 13, 5, -11, -8, -5, -3, 2, 24, -23, 30, -7,
    11, 30, -15, 43, 5, -15, 15, -3, -14, 1, -23, 8, 3, 9, 4, -11 },
  { 16, -18, 7, -4, 31, -15, -9, -13, 20, -12, -6, 0, 12, -6, -2, 4,
    3, -3, -1, 0, 1, 3, 3, -2, 1, 6, 4, 0, -3, 2, -5, 1 },
  { 38, -5, -13, -4, 8, -15, 11, 1, 2, -4, -1, 9, 13, 4, -12, -7,
    0, -2, 7, 2, -6, -2, -3, -2, 3, -4, 6, 15, 1, 1, -11, -2 },
  { 47, -22, 9, -26, 3, -5, 2, -7, 4, -2, 2, -2, 3, 0, 3, -4,
    3, -3, 2, -3, 7, -3, -1, 1, 1, -5, 5, 0, 2, -5, -3, -2 },
  { 14, -16, 2, -6, 7, -2, -7, -4, -4, -7, 14, -3, 7, -19, -14, -17,
    -29, 6, 26, 16, -5, 13, -4, -1, 21, 14, 1, 3, -6, 0, -7, -1 },
  { 29, -11, 5, -3, 4, 11, 4, -10, 1, -22, -3, -10, 5, 4, 2, 8,
    -2, -7, -12, -12, -8, -3, -18, -2, -9, -5, -1, -3, 2, -14, -14, 7 },
  { 28, -12, 5, 3, 9, -7, 0, -2, 2, 1, 4, 0, -7, -3, -2, 4,
    4, 14, 8, -1, -4, 14, -7, 17, -2, -2, -9, 2, 19, -7, 9, -8 },
  { 31, -18, -22, 8, 15, -5, -10, -15, 1, 10, 6, 7, 6, -8, 2, -1,
    12, -3, 3, -1, 1, 5, -6, -4, 0, 1, 7, -10, -2, 4, -3, -4 },
  { 53, -30, -4, 12, 2, 3, -3, -3, 0, 1, 6, 5, -5, -4, -7, 1,
    0, 2, 1, 3, 1, 5, 0, 2, 2, -1, 0, 4, 2, 0, -2, 0 },
  { 27, -18, -3, -2, 4, -8, 3, -2, -11, 2, 10, -8, -8, -4, 0, -2,
    8, 0, 9, 0, -16, 11, 1, -6, 13, -3, -10, -13, -15, 25, 1, 0 },
  { 35, -5, -1, -8, 23, 11, -14, -3, 2, -2, 8, -6, 17, -2, 7, 0,
    -2, 10, -17, 13, -2, -2, 11, 11, -14, 2, -2, -3, -8, -1, -12, -5 },
  { 29, -9, 7, 3, 2, -10, 0, 3, 9, 0, -3, 5, 1, -10, 10, -5,
    3, 6, -20, -9, -6, -4, 1, 0, 12, 17, -8, 9, 3, -1, -9, 0 },
  { 15, -16, 18, -19, 16, -15, 17, -18, 13, -16, 17, -14, 15, -9, 13, -17,
    9, -7, 4, -5, 3, -4, -3, 0, -6, 7, -9, 7, -2, 7, -9, 9 },
  { 21, -10, 7, -2, 12, -7, 13, -17, 11, -2, 20, 3, 5, -11, -6, -6,
    -15, 0, -9, 5, -11, 7, -1, 7, 8, -10, -9, 3, -5, 9, -8, -2 },
  { 23, -22, 15, -5, 16, -4, -3, -12, 9, 3, -1, -2, -8, 2, -2, -16,
    3, 4, -2, -6, -7, 12, -8, 2, -14, 2, -7, 11, -2, 6, -4, -1 },
  { 34, -17, -4, 8, 4, -6, 1, 8, 4, 16, 3, 6, 12, -1, -1, -15,
    6, 4, -7, -6, 6, 0, 2, 1, -2, 2, 3, 3, -3, -2, 8, -6 },
  { 18, -18, 2, -2, 10, 1, 18, -23, -3, -10, 0, 4, 20, -19, -3, -4,
    2, 8, 6, 1, -3, 1, 1, 3, 5, -1, -11, 3, -7, 5, -1, 1 },
  { 15, -14, 2, 3, 10, -8, 12, -13, 13, -15, 6, -8, -4, -10, 14, -9,
    24, 2, -7, -18, 13, -11, 8, 14, -6, -2, 3, -1, -4, 7, -7, -4 },
  { 20, -12, 13, 5, -1, -10, 15, -6, 8, -1, -3, -10, 17, 0, -6, -19,
    2, -1, 8, -3, -16, 0, -3, 2, -2, 0, 8, -9, 0, 1, -10, -9 },
  { 32, 0, -9, -5, -1, 5, 13, -11, 8, 3, 11, -11, 0, -8, -2, -14,
    7, 10, 6, -5, 1, 10, 2, 12, -10, 4, 4, 6, 4, 0, -7, -10 },
  { 16, -14, 10, -7, 11, -11, 11, -11, 18, -13, 8, -15, 16, -11, 13, -9,
    8, -7, 12, -11, 7, -6, 3, -5, 9, -5, 4, -1, 7, -4, 8, -3 },
  { 24, -27, -1, 5, 8, -5, 12, 7, 4, -3, 3, -1, -9, -11, -13, -5,
    10, 0, -13, 7, 1, -5, 4, -9, 7, -3, 13, 2, -5, -3, -17, -2 },
  { 23, -19, 15, 1, -10, -18, -12, -6, 8, -3, 12, 0, -12, -10, -4, -4,
    8, -10, 4, 2, -2, -8, 13, -3, -2, -6, 2, -3, 5, -2, 2, 11 },
  { 25, -12, 4, 2, 24, -3, 3, -6, 14, 11, 0, -21, -3, -3, 1, -8,
    7, 0, 0, 3, 3, -6, -7, 6, 2, 1, -4, 5, -1, 10, -2, 9 },
  { 24, -8, -6, 7, 16, -12, 13, -1, 11, -21, 2, -6, 3, -12, 0, 9,
    4, 11, -7, 1, 4, 1, -8, 3, 3, -6, 3, 3, 0, -8, 8, 4 },
  { 25, -21, 13, 14, 13, -18, 4, -3, 0, -5, -4, 5, -3, 0, 4, 12,
    7, 3, 5, -5, 2, -2, 3, -10, 2, -9, -15, 6, 1, 7, -5, 1 },
  { 23, -16, -2, 10, 4, -1, 3, 1, 32, 3, -5, -2, 9, 10, -1, -4,
    -6, 2, 9, -1, 14, 12, -6, -1, -17, -2, -4, -9, -7, -6, -8, 3 },
  { 50, -8, 5, 2, -11, 10, 0, 0, 6, -3, 7, 0, -3, -2, -3, 0,
    6, -4, 2, -5, -9, 0, 3, 10, 1, -7, -2, -3, -6, -9, 1, -2 },
  { 28, -17, 0, -2, 2, -9, 1, 5, -4, -1, 0, 0, 19, -27, 5, -12,
    7, -14, -3, -6, 10, -2, -4, -2, 4, -5, -2, -7, 1, 7, -9, 4 },
  { 22, -19, -6, -6, 3, -22, 3, 5, 20, -8, -14, -5, 1, 1, 20, 2,
    16, 6, 3, 14, 4, 3, 5, 1, 5, -7, -10, -6, 3, -6, 1, -14 },
  { 29, -14, -8, 13, 8, -10, -6, 4, 4, -6, 5, -7, 1, 12, 14, 11,
    -7, 1, 2, -9, -11, -9, 0, 4, -1, 7, 10, 4, 4, 20, -1, -11 },
  { 18, -9, 4, 1, 7, -29, 12, 1, -1, -9, -2, -1, -2, 2, 9, -8,
    -13, 5, 4, -13, -4, 2, -5, -7, -6, 14, -10, -34, -3, 1, -3, -13 },
  { 38, -9, 24, 8, 11, 4, -6, -11, -2, -12, 1, 1, -11, -8, -5, -2,
    -15, -8, 8, 0, 1, -7, 5, 4, -1, 8, -2, 11, -3, -1, -5, -5 },
  { -20, 11, -4, 24, -11, 1, 15, 4, 0, -28, -10, -1, 10, 10, -6, 5,
    -6, 2, 7, -2, 1, -2, -6, -3, -7, 1, 2, 12, -1, 7, 0, -2 },
  { -9, 10, -23, 27, -4, -17, 20, -6, 14, -17, 5, -1, 5, -9, -7, 5,
    -6, 4, -2, 9, 0, 8, 0, 1, -3, -3, -5, -8, 5, -2, -2, 12 },
  { -10, 19, 4, 9, 1, -16, 17, -2, 9, -29, -16, -11, -4, 7, -5, 4,
    -1, -3, 3, 2, 3, -4, 5, -12, -2, 6, 5, -4, 4, 1, 4, 10 },
  { -20, 10, -24, 14, -5, 11, 9, 0, 16, -20, 10, -5, -6, -6, -1, 2,
    -4, 5, -16, 8, -2, 5, 5, -11, 9, -11, 4, -11, -1, -1, 4, 3 },
  { -9, 11, 3, 19, 24, 4, 5, -14, 30, -17, -4, -2, -17, 7, 2, 3,
    1, 3, -7, -4, 2, -3, 1, 4, -1, -1, 3, -12, -2, 3, -3, 10 },
  { -19, 18, 11, 19, 19, 19, 10, 4, 13, 6, 5, 4, 8, 3, -2, 12,
    -6, -2, 7, -6, 15, 12, 16, 16, 18, -3, -4, -20, 0, 10, -9, -3 },
  { -21, 9, 20, 12, 0, -3, 5, -9, 15, -13, 5, -5, -6, 24, 2, 9,
    -5, 2, -7, 2, 5, 7, -5, 2, 15, 3, 1, -1, -4, -2, 7, 0 },
  { -18, 16, 13, 15, 2, -10, 14, -11, 4, -11, 5, 12, 12, 20, 8, 30,
    2, 11, -9, 7, 0, -3, -16, -5, -6, 5, -4, -21, 0, 5, 6, 1 },
  { -26, 8, -13, 9, 6, -10, 2, -11, 7, -4, 6, -19, -11, -6, -12, 16,
    0, 5, -7, 8, 5, 6, 17, -9, 10, -10, 5, -3, -11, 2, 4, 10 },
  { -11, 17, -3, 22, -5, 18, 3, 1, 4, -5, 14, -27, 5, -7, -4, -5,
    -10, 11, 1, 15, 1, 1, -6, -5, 10, -22, -7, -7, -15, 13, -4, 5 },
  { -17, 14, -7, 13, 3, 0, 13, -6, 9, -14, -22, -1, 1, 19, 14, -3,
    4, -13, -13, 2, -4, 8, -2, -2, 13, -12, 13, -12, -7, -5, -3, 6 },
  { -17, 17, -1, 33, 6, 3, 9, -16, 3, -14, -8, 6, -17, 8, 3, 13,
    8, -6, 3, 1, -2, 0, -2, 8, 4, 9, 13, -10, 4, -17, 0, -6 },
  { -20, 7, 7, 21, 1, -3, 7, -3, -2, -12, 9, -7, 2, -3, 14, 1,
    -1, -7, 12, -10, 5, -20, 11, -2, 0, -24, -17, 6, 6, -4, 3, -1 },
  { -8, 10, 6, 7, -1, -6, 28, -6, 10, -33, 1, -20, 0, -12, 10, 1,
    -6, 8, -3, -1, -10, 8, 5, 0, 10, -2, 8, 16, -5, -3, -7, 4 },
  { -17, 13, 3, 15, 1, -5, 27, -5, 6, -6, 12, 2, -4, 8, -1, -3,
    -2, 12, -15, 3, 4, 1, 2, -9, 0, -16, -21, 2, -4, 16, -7, 4 },
  { -15, 20, 8, 17, 5, -14, 15, -11, 21, -11, 13, -13, 2, -15, -13, 1,
    -5, 5, 2, 10, -9, 4, -1, 3, 2, -4, 13, -5, 1, -4, 5, -3 },
  { -21, 8, 2, 16, -1, 2, 15, -16, 13, -12, -12, -7, -8, 2, -7, 11,
    -8, 5, 2, -7, 16, -4, 1, -7, 3, -15, 6, -5, -8, 2, -8, 5 },
  { -15, 17, -6, 3, -3, 3, 9, -7, 14, -23, 11, 1, -1, 4, 7, 6,
    -1, -14, 7, 6, -8, 5, 1, -15, 10, -9, 2, -3, -1, 4, -10, -4 },
  { -10, 18, 3, 11, 1, 4, 14, -14, 7, -4, 15, -10, 10, -11, 10, -4,
    5, -14, 10, 4, 15, -12, 15, -13, 20, -15, 14, -15, 8, -11, 4, -6 },
  { -7, 23, 2, 20, 7, 8, 19, -5, 9, -16, -8, -17, -5, 1, 5, -6,
    -8, 1, -6, -4, 10, 6, 6, 2, -11, -4, 0, 2, 4, 7, 9, -4 },
  { -15, 20, -5, 22, 11, -8, 9, -5, 10, -13, -8, 8, 2, -2, -3, 7,
    6, 10, 1, 2, -5, -9, 1, 10, 16, -22, -7, 0, 7, 7, 6, 1 },
  { -26, 19, -5, 3, 5, 25, 18, -5, 9, -14, -8, -6, -2, -6, 2, 3,
    -8, -2, -7, 7, -3, 7, 3, 4, -8, 0, 1, -8, -4, -2, -2, 1 },
  { -20, 14, -10, 6, -3, 7, 8, -32, -2, -7, -2, -10, 16, -12, -9, 15,
    -2, -5, -6, 2, -7, 5, 9, 1, 6, -7, -1, 0, -2, -4, -7, 3 },
  { -14, 16, 4, 11, -8, 1, 23, -4, 17, -13, -10, 1, 12, 9, 12, -4,
    7, -1, -1, 5, -8, -6, 3, 3, -6, -3, -18, 0, 18, 20, 4, -2 },
  { -33, 19, -10, 30, 15, 2, -3, -1, -4, -14, 7, -7, -1, 7, -8, 9,
    -1, -3, -5, 2, 2, 4, 0, 5, 0, 0, 2, 3, 3, -3, -3, 4 },
  { -6, 20, 0, 5, 17, -10, 18, -17, 9, -16, 4, -13, -6, 2, -14, 14,
    -28, 9, -12, 25, -4, 7, 7, -8, 6, -6, -2, -10, 2, -11, -1, 2 },
  { -12, 14, 12, 52, -3, 5, -5, 4, 8, -13, 2, -5, -4, 2, -2, -1,
    -2, 3, 3, 5, 2, 3, 0, 1, -5, 2, -4, -3, 1, -5, -2, 0 },
  { -13, 6, 9, 24, 0, 8, 14, -15, 18, -9, -11, -8, 3, 15, -2, -4,
    -9, 4, -3, 12, 14, -13, 11, -4, 2, -4, 0, -6, -6, -6, -14, -1 },
  { -10, 28, 3, 12, 9, 3, 11, -28, 6, -11, -7, 4, 0, 7, 8, -9,
    0, -6, 0, -16, 4, 7, 4, 4, 7, 3, 4, -7, 0, -3, -10, 6 },
  { -11, 14, -2, 19, -1, -1, 7, 9, -2, -27, 10, -14, 15, -4, 12, -4,
    2, -2, -6, 12, -6, 0, -5, -4, -5, 1, 3, -11, 5, -9, 3, -8 },
  { -18, 7, 13, 16, -4, 3, 9, -10, 10, -10, -3, -22, -4, -12, 3, -16,
    0, -3, -16, 8, -11, 1, 10, -7, 15, 3, 0, -1, -13, 8, 1, 6 },
  { -20, 10, -10, 10, 8, -1, 6, 0, 16, -12, 9, -10, -1, -5, -4, -13,
    13, 16, -8, 12, -2, 14, 18, 13, 0, -16, 2, -5, -5, -5, -4, 3 },
  { -14, 5, -7, -17, 5, -13, 23, 20, -4, -1, 1, -6, 13, 5, -1, 4,
    -14, -2, -7, 8, 3, 2, 2, -7, 2, -1, 4, 7, 3, -9, -1, -5 },
  { -19, 3, -24, -28, -9, -7, 19, 3, 2, 19, 7, 5, -13, 8, -15, -17,
    3, -11, 4, 13, 3, 2, -1, -3, -4, -4, 2, 0, -5, -6, 6, 2 },
  { -17, 18, -30, -20, -2, -3, 1, 15, -1, -11, 6, -4, 11, 11, -4, -5,
    -10, 0, 0, 1, 3, -7, 8, 2, 5, 1, 5, -5, 1, 6, 4, 1 },
  { -6, 1, -30, -25, -1, -8, -2, -9, -17, 16, 3, -1, -2, -9, -6, -7,
    -3, 12, 6, -4, -10, 0, 10, -8, -6, -5, -3, -11, -4, 0, -1, -3 },
  { -1, -1, -34, -28, 1, -10, 2, 9, 4, 16, 2, 6, 14, 17, 0, 7,
    -4, 4, 4, 4, 0, 1, -1, -5, 8, 1, -4, 1, -9, -2, 5, 6 },
  { -11, 14, 1, -31, -7, -24, 9, 7, 6, 5, -13, 1, -1, 3, 4, -1,
    -2, -8, -6, 3, 5, -4, -6, 7, -2, 5, 3, 3, 0, 0, -5, 2 },
  { -25, 8, -11, -18, 1, -4, 8, -3, -4, 15, 6, -5, 8, 2, 3, 4,
    -4, 5, 6, 8, -7, 6, 1, -11, -15, -13, 9, -4, -14, 10, 12, 7 },
  { -20, 11, -15, -25, 3, 4, 18, 13, -4, -5, -9, -1, -5, -2, -2, -7,
    16, 5, -4, -5, -7, -2, -3, -9, 11, -2, 0, -7, -17, -6, -11, 6 },
  { -11, 18, -5, -20, -15, -3, 9, 11, -20, 12, 5, 5, 11, -3, 7, 1,
    10, -6, -3, -3, 3, 3, 14, -7, 10, -17, 9, -11, -2, -6, 7, -12 },
  { -20, 8, -14, -17, -9, -13, -3, 0, -27, -14, -3, -14, 4, 3, 6, -6,
    7, 4, 23, 9, 11, 9, 3, -4, 9, 2, 4, -1, -6, 1, -8, -11 },
  { -9, 14, 2, -37, -7, 13, 6, -11, -6, 9, 18, -11, -6, 2, 12, 4,
    -1, 3, 1, -2, -2, 1, -9, -4, -2, -3, 3, 5, -6, 0, -2, -8 },
  { -29, 8, -1, -13, -2, 8, 23, 2, -10, 7, 13, -6, -5, 11, 13, 0,
    -10, -13, 11, -12, -10, 6, 4, 6, 4, 3, 6, -5, -9, -2, -1, 3 },
  { -18, 6, -10, -55, -4, -11, -2, 0, 1, -3, -9, -6, 3, -2, -1, 6,
    3, -1, 3, 1, -4, -7, -2, 6, 3, -2, -1, -3, -2, 0, 4, 1 },
  { -14, 5, 3, -21, -8, -16, -4, -2, -11, 27, 15, -20, 3, 0, 1, 1,
    2, -5, -5, 4, 1, -9, 5, -3, 3, 0, -4, -2, -11, -4, -3, 7 },
  { -17, -1, -9, -17, -8, -18, 12, -13, -9, 13, -3, 3, 3, -3, 1, -2,
    0, 16, -9, 6, 12, 9, 5, 11, 2, -15, 1, -4, -16, 7, -4, -12 },
  { -18, 8, -6, -11, -8, -7, 13, 7, 1, 6, 8, -1, 21, -4, 14, 15,
    18, -4, -3, 15, 0, 9, 4, 7, 3, -1, 9, -2, 0, 7, -8, 2 },
  { -10, 7, -18, -29, 3, 12, 12, 9, 11, 4, -1, -15, 1, -1, 8, -2,
    -2, 10, -15, -1, 0, 6, 12, -6, -1, 10, -6, -3, -11, -4, 9, -6 },
  { -14, 14, -9, -21, -12, -2, -1, -7, -5, -10, 5, -8, 0, 6, 9, -11,
    11, -3, -5, 3, 8, 15, -2, -4, -22, 4, -6, 12, 2, 13, 6, -7 },
  { -12, 11, -5, -29, -25, 4, 12, -13, -11, -7, 4, 2, 2, -5, 5, 8,
    7, -5, -5, 6, 3, -10, 1, -6, 6, -6, -5, -1, -2, -4, 7, 6 },
  { -15, 11, -5, -16, 0, -13, 26, -23, -6, -3, 5, -2, -2, 21, -6, -3,
    -5, -1, 6, -1, 0, -13, 2, -3, -9, -1, -4, -3, 5, -4, 12, -16 },
  { -9, 9, -1, -17, -3, -6, 12, 6, -18, -2, 11, -14, -6, 3, 14, -12,
    -11, -5, 14, 2, 5, -8, -4, -11, 2, -5, 16, 6, -7, -4, 8, 13 },
  { -13, 5, 3, -28, -14, 0, 6, 23, 5, 4, -1, -17, 1, -3, 0, 0,
    5, 4, 0, -18, 14, 10, 4, 2, 5, -2, 4, -3, 2, 0, 2, 0 },
  { -15, 4, -13, -16, -3, -12, -2, 2, 7, 10, 9, 3, 11, 4, 23, 14,
    9, 16, 4, 1, -12, -3, 4, -7, -15, -7, -10, -14, -6, -8, -1, -6 },
  { -7, 10, -5, -10, -3, -13, 16, -1, -12, 7, -3, -12, 2, 13, 13, 2,
    17, 15, -13, 1, -5, -2, 3, -1, 1, -3, 6, -3, -12, -16, 7, -7 },
  { -11, -5, -12, -30, -6, -22, 1, 4, -6, -3, 12, 6, 7, 0, 16, 6,
    -2, 0, -22, -2, -9, 2, -13, 8, 6, -8, 4, -7, -1, -6, 4, 6 },
  { -14, 5, 1, -27, -4, 2, 1, 14, -11, -7, -8, -4, 1, 8, 0, -6,
    -13, 11, -12, -7, -5, 1, 10, 7, 3, -2, 0, 6, -8, 2, 10, -1 },
  { -10, 10, -25, -13, -20, -4, 19, 3, 13, 5, 5, 7, -8, 2, 4, 2,
    3, -1, -1, -9, 14, 10, 9, 14, 3, 3, -6, 0, -5, 4, 1, -1 },
  { -9, 15, -18, -17, 4, -11, 6, 7, -12, 8, -1, -11, 2, 3, 7, 16,
    -3, -9, 7, -12, 23, 0, 6, 7, -14, -9, 8, 1, -2, 6, -2, -1 },
  { -6, 9, -16, -26, -14, -11, 9, -6, 5, -2, 13, 17, 21, 7, 18, -19,
    6, -23, -2, -15, -2, 2, -10, -8, 2, 1, -2, 4, -3, -4, -5, -4 },
  { 0, 6, -5, -28, -17, -32, 2, -10, 11, 3, -5, 9, 10, 3, 11, 11,
    -3, 12, -2, 2, 4, -6, 9, -4, -4, -4, -4, -9, 2, 0, 2, 4 },
  { 0, -8, -18, -34, -9, -7, -4, -11, 10, 15, 11, -1, -8, 15, 6, -13,
    9, 2, -4, -12, 0, -1, 19, 12, 6, 5, 0, -3, -10, -12, 3, -5 },
  { -10, 6, -9, -17, -12, -11, 9, -6, 11, 11, 18, -7, 0, 16, 4, 2,
    -6, 3, -12, -1, 0, 1, -5, -22, -2, -12, 0, 6, 17, 5, 5, 6 },
  { 12, -5, 7, 1, -5, -2, -1, 2, 2, -4, -3, -3, -3, -2, -29, 11,
    5, -13, -73, 24, 12, 4, -14, -10, 5, 1, 0, -11, -7, -7, 7, 3 },
  { 10, -3, -1, -3, 4, -11, -5, -2, -8, 7, 9, 2, -8, -6, 6, 7,
    21, 17, -54, 47, -14, -10, 14, 19, 13, 21, -4, 3, 1, 2, -4, 2 },
  { -12, 4, -16, -12, 5, -9, -4, 19, -7, -22, -22, -17, 3, 0, -6, 8,
    23, -4, -55, -28, 2, -26, 2, 1, 4, 0, -13, 6, 0, 10, -7, -11 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, -1,
    35, -1, -67, -35, -24, -24, -6, 2, 2, -2, 1, 3, 2, 0, -1, 1 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 5, 0,
    41, -4, -73, -15, 18, 4, 17, 8, -1, -16, -1, -2, 1, 0, 0, 0 },
  { -4, -4, 4, 6, -1, 2, -16, -10, -15, -10, 21, -2, -6, -2, 14, -7,
    10, -5, -55, 34, -12, 11, -13, -2, 2, 28, -26, 0, 7, 4, 21, -7 },
  { 2, 1, 15, -22, 10, -3, 14, -6, -2, 15, -2, -7, 20, 6, -15, -7,
    23, 10, -60, 8, -4, 29, -22, 2, -13, 9, -10, 12, -1, -3, 4, 7 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -1, -2, 11, -5,
    -21, -11, -60, -27, -17, -39, 6, 36, 0, -8, 2, 2, 0, 0, -2, 3 },
  { 2, -5, 9, -17, -1, 2, -3, -6, 8, 12, 7, -6, -33, -11, -14, -40,
    10, 36, -46, 0, -19, 5, 0, -10, 3, 12, -6, -8, 6, -12, -7, 1 },
  { 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, -1, 0, 1, 0, -2, 0,
    4, -2, -87, -3, -2, 2, -2, 20, 2, 6, -1, 6, 0, 0, 2, -1 },
  { 1, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 1,
    1, 7, -76, 41, -7, -24, 0, -6, 3, 6, 0, -2, -1, 1, 0, 0 },
  { 0, -3, 4, 2, 3, 2, 2, 0, 3, -1, 4, 0, -1, 4, -2, -4,
    -32, -11, -64, -29, -9, -43, 2, -11, -1, -7, 0, -4, -2, -2, -2, 2 },
  { 10, -20, 3, -3, 13, 13, 0, -4, 2, 7, -8, 7, -2, 2, -20, -20,
    -19, 3, -47, -18, -16, -6, -15, -42, -17, 14, -6, 8, 12, -10, 11, -12 },
  { -3, -2, -2, -1, -1, 4, -3, -1, -6, -2, 3, 2, -3, 6, -1, -9,
    10, 13, -68, -9, 26, 3, 5, 3, -21, 10, -15, 21, -22, 19, 11, -14 },
  { 1, 5, 18, -19, -29, -13, -2, 18, -10, 20, 2, 10, -10, 11, 1, 8,
    -16, -17, -41, 10, -14, -25, 0, -14, -19, 17, 7, -12, 14, -11, 14, 5 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, -1, -43, 5,
    6, -12, -48, 19, 8, -38, -8, -3, 22, -21, -10, 15, 20, -9, -5, 8 },
  { 0, 0, 0, 0, -1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 6, -3,
    22, -14, -71, -24, -2, -33, 23, 7, -8, 7, -3, 2, -4, 1, -8, -2 },
  { 1, 0, -1, 2, 0, -2, 0, 0, -1, 0, 4, 0, 26, -1, 10, -11,
    -17, -32, -58, 14, -14, -11, -2, 15, 2, -8, 12, 10, -9, 13, -33, -14 },
  { 15, -17, -19, 7, -8, -15, -32, -22, 7, 12, 18, 0, 0, -15, -4, 16,
    37, -2, -46, 11, 2, -8, -10, -8, 14, 9, -4, 5, 7, -17, 4, 3 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0,
    -5, 3, -85, 23, -9, -17, -2, -2, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0,
    -5, 3, -85, 23, -9, -17, -2, -2, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 1, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 1,
    1, 7, -76, 41, -7, -24, 0, -6, 3, 6, 0, -2, -1, 1, 0, 0 },
  { 0, -3, 4, 2, 3, 2, 2, 0, 3, -1, 4, 0, -1, 4, -2, -4,
    -32, -11, -64, -29, -9, -43, 2, -11, -1, -7, 0, -4, -2, -2, -2, 2 },
  { 10, -20, 3, -3, 13, 13, 0, -4, 2, 7, -8, 7, -2, 2, -20, -20,
    -19, 3, -47, -18, -16, -6, -15, -42, -17, 14, -6, 8, 12, -10, 11, -12 },
  { -3, -2, -2, -1, -1, 4, -3, -1, -6, -2, 3, 2, -3, 6, -1, -9,
    10, 13, -68, -9, 26, 3, 5, 3, -21, 10, -15, 21, -22, 19, 11, -14 },
  { 1, 5, 18, -19, -29, -13, -2, 18, -10, 20, 2, 10, -10, 11, 1, 8,
    -16, -17, -41, 10, -14, -25, 0, -14, -19, 17, 7, -12, 14, -11, 14, 5 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, -1, -43, 5,
    6, -12, -48, 19, 8, -38, -8, -3, 22, -21, -10, 15, 20, -9, -5, 8 },
  { 0, 0, 0, 0, -1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 6, -3,
    22, -14, -71, -24, -2, -33, 23, 7, -8, 7, -3, 2, -4, 1, -8, -2 },
  { 1, 0, -1, 2, 0, -2, 0, 0, -1, 0, 4, 0, 26, -1, 10, -11,
    -17, -32, -58, 14, -14, -11, -2, 15, 2, -8, 12, 10, -9, 13, -33, -14 },
  { 15, -17, -19, 7, -8, -15, -32, -22, 7, 12, 18, 0, 0, -15, -4, 16,
    37, -2, -46, 11, 2, -8, -10, -8, 14, 9, -4, 5, 7, -17, 4, 3 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0,
    -5, 3, -85, 23, -9, -17, -2, -2, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, 0,
    -5, 3, -85, 23, -9, -17, -2, -2, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 16, 65, -2, -2, 4, 3, 0, -7, 3, 1, 3, 1, 0, 5, 1, -5,
    0, 2, -1, 3, 0, 0, -1, -2, 6, 0, -2, 0, 0, -1, 1, 1 },
  { 5, 37, -4, 8, -4, -1, 9, 17, 6, -7, 5, -1, 11, 6, -4, 7,
    -2, 4, 1, -3, 11, 3, 3, -9, 6, 0, -2, -4, -5, 4, -12, -11 },
  { 15, 24, -14, 2, 6, 17, 26, 5, 8, 11, -9, -7, -6, -8, 3, -5,
    9, 10, -3, 10, 0, 1, 4, -9, 4, 9, 3, 0, 4, 0, -5, 3 },
  { 9, 36, -9, -8, 7, 7, 4, 3, -1, -16, -2, 7, -5, -6, 6, 12,
    -11, -12, 9, -1, -3, -9, 12, 6, -6, 2, 2, 5, 0, 5, 6, -6 },
  { 25, 39, -5, 24, 3, 10, 3, -6, 13, -8, 3, -7, 2, -10, -5, 2,
    -2, 3, 5, -2, 1, 5, -2, 3, -4, 1, -5, -4, 0, 1, -2, 0 },
  { 16, 27, -1, 0, -14, 6, 4, -5, 7, -2, -6, 0, -3, -5, 2, -1,
    -1, -19, 5, -8, 0, 11, 12, 5, 0, 3, 10, 6, -14, 14, -13, -15 },
  { 12, 23, -14, 2, 1, 4, -3, 16, 7, -8, 2, -8, 8, 6, -8, -7,
    -3, 0, 2, 8, -13, 7, 13, -6, -4, 6, -13, -16, 14, 11, -7, 5 },
  { 16, 28, -7, -1, 6, -3, 9, 0, -7, 3, 0, 3, -12, 20, 8, 9,
    8, 23, 8, -13, -2, 4, 9, 3, -5, 13, 5, -2, 12, 14, 5, -1 },
  { 19, 37, 19, 5, 7, 5, 10, 5, 19, 10, 14, 0, 2, 5, 1, -4,
    -4, 2, 2, -5, -2, -1, 2, -6, -4, -4, -5, -3, 2, -2, -2, -2 },
  { 24, 21, 1, -11, -10, 17, -14, 14, 6, -1, -6, -1, 0, -13, -1, -12,
    -2, -5, 6, -4, -12, 14, 5, -2, -8, -8, 15, -7, -30, -12, 4, 0 },
  { 11, 26, -3, 3, 5, -1, -2, 3, -2, 10, 15, -4, 10, -28, 10, -17,
    -8, 1, 2, -7, -1, -6, -15, -1, 4, 5, -7, 9, 0, -5, -4, 4 },
  { 18, 32, 1, 2, -7, 4, 15, 2, -9, -2, 12, -11, 7, 11, 13, 2,
    0, 5, 9, -10, 16, 3, -3, 5, -9, -23, 2, -2, -1, 5, 2, 11 },
  { 35, 24, -20, 2, 4, -1, 5, 14, -10, -9, 8, -7, 0, 5, -7, -7,
    11, 1, 5, 3, 2, 0, -2, 3, 0, 1, 4, 0, -2, -8, 0, -4 },
  { 9, 35, -1, 2, -1, -19, -3, 12, -1, 8, 8, -13, -1, -2, 2, 5,
    -8, -1, 13, -2, 11, 1, 0, -10, 0, -3, -7, 2, 1, -12, 3, 12 },
  { 20, 27, -12, -12, 7, 4, -1, -13, -1, -9, 2, 13, -11, 5, 7, -9,
    9, 1, 1, 8, -9, 0, -6, 7, 4, 2, -2, 7, 3, -2, 1, -9 },
  { 8, 37, -20, -5, 0, -21, 10, -8, 3, 19, -9, 7, -3, -8, 10, -2,
    0, 5, 6, -4, -2, -1, 0, -7, 6, 1, 0, 4, -5, 6, -8, 2 },
  { 8, 27, 1, -3, -5, 1, 6, 0, 15, 2, 17, -1, 3, -17, 10, 5,
    5, -6, -6, 6, -10, 18, -5, 0, 0, 13, 7, 10, -5, -6, -2, -4 },
  { 14, 29, -20, -4, -3, 1, -5, -1, 2, 12, -10, -3, 4, -18, 4, 14,
    -4, -1, -9, 15, -2, 2, -5, -3, 2, 9, -2, -14, -3, 4, -4, -7 },
  { 23, 23, -23, -11, 27, 4, 4, -1, 7, 0, -5, 9, 2, -11, 3, 7,
    -2, -5, 2, -7, -7, 13, -3, -6, 2, 3, 3, -4, -1, -8, 5, -2 },
  { 16, 26, -6, 8, -9, -1, -2, -1, -8, 4, -2, 0, -12, 9, -1, 0,
    -17, -9, 30, -5, -15, -16, -13, 0, 10, -11, -7, -3, -1, 0, -11, -2 },
  { 12, 32, -4, -5, 10, 19, -10, 4, -12, 5, -6, 9, -12, -6, -6, -8,
    4, 1, 3, 0, 8, 0, -3, -4, -7, -4, 10, 8, 6, 5, -1, 4 },
  { 46, 42, -3, -14, -2, -6, 6, -2, -5, -1, -3, -3, 1, -1, 3, 1,
    1, 4, -1, 2, 3, 1, -2, 6, 0, -1, -2, 4, -2, -1, 2, 2 },
  { 9, 33, -13, 4, -11, 3, -8, 22, 12, -2, 4, 0, -16, 5, 4, -1,
    7, -6, -9, 1, 7, 5, 0, -5, 5, -1, 10, 3, -2, -1, 3, -2 },
  { 9, 30, 6, -3, 6, 1, -7, 5, 11, 14, 7, 1, 0, 2, 2, -1,
    8, 7, -6, -13, -10, -2, 1, -6, 10, 7, 6, 5, -2, -5, -1, -16 },
  { 9, 28, -11, -10, 9, -10, 15, 8, 4, 9, -4, -7, 0, -5, 9, 8,
    -7, 2, -15, -23, 4, -4, 4, 16, -8, -3, 0, -8, 14, 5, -3, 15 },
  { 17, 26, -5, -5, -1, -8, 20, 18, -7, -2, 4, -7, -8, -5, -4, 16,
    0, 0, -7, -2, -13, -5, -2, 3, 12, 1, 3, -5, 2, 2, 0, -1 },
  { 11, 37, 7, -23, 6, -1, 15, 13, 4, -9, 7, 5, 3, -3, -5, -8,
    -2, 3, -5, -1, -8, 7, 2, 13, 1, 3, 0, -3, -1, 2, 0, -2 },
  { 21, 33, 7, 20, 21, -10, 6, -5, -5, -6, -9, 2, 10, 0, 8, -4,
    10, 2, -2, -2, 0, -10, -6, -2, 0, -5, 3, -11, 3, -9, -3, 1 },
  { 6, 30, -15, -8, 16, 1, 4, 6, 4, 5, 8, -3, 8, -9, -1, -6,
    8, 2, -2, 4, -2, 5, 11, -21, 3, -10, 16, -11, 24, 10, 14, -6 },
  { 15, 36, -3, -9, -20, 12, 0, -7, -18, -4, -8, -9, 9, -7, -3, -1,
    2, 7, -5, -8, 6, 2, 2, -1, 7, 1, 1, -3, 3, -4, -8, 1 },
  { 16, 34, 21, 3, -9, 10, 7, 9, -7, 1, -4, -9, -4, -5, -5, 3,
    3, -19, 1, 5, 4, -2, -6, -5, -10, -11, -8, -2, 2, -5, -8, -7 },
  { 28, 29, -3, 18, -2, 0, -6, 12, -2, 10, -11, -4, -13, -12, -6, -4,
    0, 4, -1, -8, 6, 4, 12, 11, 10, 10, -3, -6, 1, 2, 1, 7 },
  { 3, 8, 22, -8, 3, 36, -8, -1, 9, 6, -13, -14, 8, -1, 1, 2,
    -2, -8, 0, 3, 1, 2, -1, 5, -1, -8, 0, -2, 2, 2, -1, 1 },
  { 0, 6, 0, 0, 4, 13, -7, -16, -6, 15, -14, -21, -9, -10, -10, -6,
    -21, 5, 4, 2, 12, 4, 12, 11, -4, -6, -6, -10, -7, -18, 1, 4 },
  { -1, 3, 10, 1, -1, 15, 4, -7, -16, 3, 0, -22, 10, 2, -3, -2,
    13, 5, -8, 16, -5, 4, 0, -11, -10, -22, 0, -4, -17, 5, 2, 1 },
  { 12, 8, -4, -9, 14, 40, -21, 0, 1, -15, -10, -12, 12, 6, -10, 2,
    8, 6, -12, -10, -11, 1, 0, -11, 2, 1, 13, 0, 6, 3, 8, 4 },
  { -10, 3, 5, -4, -3, 3, 0, -9, 2, 8, -22, -23, 17, 8, -17, -3,
    14, -8, -4, 1, -8, 3, 0, 5, -1, -3, -2, -4, 1, -10, 0, -2 },
  { 0, -1, 5, -7, 4, 12, -2, 0, -7, 2, -16, -15, 12, 21, -7, -4,
    7, -7, -11, -15, -7, -9, -5, -8, 0, -6, 8, -3, -8, 22, -7, -9 },
  { 7, 19, 4, -9, 24, 22, 2, -6, 8, 13, -14, -20, -4, 11, 8, -4,
    -1, 2, 0, -7, 5, -17, -3, 3, -6, 5, 3, 4, -5, -7, -3, 14 },
  { -2, 6, 2, 8, -2, 5, -4, -2, -10, 3, -45, -30, -3, -3, -12, -4,
    -3, -3, -1, 9, -6, -6, 5, -4, 0, 5, -1, -2, -1, 0, -6, -1 },
  { -3, 14, -16, -10, 10, 0, -2, -40, -9, 12, 2, -19, 15, -4, 4, 3,
    3, -4, 7, 1, -4, -5, 0, 4, -1, 0, -9, -2, -4, -1, -2, 0 },
  { 7, 16, 2, -7, 8, 2, 0, 1, 5, 21, -10, -26, 7, 2, -9, -7,
    -3, -16, 8, 5, 5, -6, 10, 4, -14, -6, 5, 3, -2, -2, -4, 1 },
  { -9, 14, -1, 3, 3, 11, 1, -5, -3, 13, -16, -18, 20, 6, -5, 0,
    -3, 2, 8, 4, -19, -9, 12, 0, -8, 2, 2, 1, 6, 13, -7, -11 },
  { 2, 5, 16, -4, 19, 15, 4, 0, -11, 7, -10, -10, -16, 18, -11, -12,
    -9, -4, 7, -4, -4, -17, 1, 1, -8, -3, -3, 5, -2, -6, -11, -5 },
  { 2, 12, 0, -9, -10, 14, 6, 2, -3, 2, -12, -28, 12, 1, -1, 2,
    0, -3, -4, 7, 16, 5, -7, 8, -4, -3, -1, 3, -12, 4, -17, -5 },
  { -4, 7, 11, 6, 1, 14, -4, -6, 5, 5, -6, -24, 23, -9, -15, 13,
    -7, -9, -15, 10, -1, 8, -5, 1, 12, 6, 2, 0, 4, -2, 9, -10 },
  { 1, 5, 11, 3, 6, 12, -3, 8, -21, 5, -7, -20, 12, -2, -9, -3,
    17, -7, -8, -9, -14, 3, -13, 18, -8, 9, 2, -8, 4, -8, -5, -2 },
  { -3, -3, -1, 5, -2, 15, 3, 2, 1, -8, 1, -39, -6, 13, -13, 0,
    -2, -5, -6, -3, 0, -5, -2, 15, -9, 5, -3, -6, -2, 7, 0, -13 },
  { 2, 8, 5, -12, -13, 22, 8, -16, 11, 5, -2, -32, -2, -4, 11, 5,
    5, -6, 1, 3, 1, 5, 3, 6, -5, 4, 4, -8, 8, 4, 1, 3 },
  { 13, 9, 5, -4, 9, 18, -11, 2, -1, 15, -10, -19, -2, 14, 0, -10,
    1, 1, -18, 3, 2, -6, -8, 20, 7, -8, 16, 9, 9, -13, -3, -2 },
  { -13, 11, 11, -9, -10, 13, -3, -18, 2, 10, 5, -21, 6, 15, -11, -21,
    3, 14, 0, -12, 9, -1, -2, -4, 3, -3, -9, -8, -5, -2, -8, 2 },
  { 3, 3, 11, 4, 0, 13, 1, -8, 10, 13, -6, -26, 2, 12, -3, -5,
    12, -2, 1, 8, -7, -17, -19, 5, 10, 7, -3, 2, -3, 0, 5, 0 },
  { 5, 0, 3, -3, -9, 5, -15, -5, -5, 17, -5, -31, 0, 13, 13, 5,
    -1, -6, -14, 7, -8, 9, -14, -2, -16, -4, -4, -6, 6, -6, -10, 6 },
  { 13, 3, 1, 7, -3, 4, -1, -2, -1, 4, -8, -32, -1, -4, 0, 3,
    -10, 7, 10, -10, 4, -1, 6, 2, -16, -9, 4, 3, 13, -23, -3, -4 },
  { 4, 11, -4, -9, 4, 11, -12, -12, -12, 6, 1, -28, -3, 14, 18, -2,
    -12, 7, 15, -3, -5, -7, -3, 2, -6, 4, 4, -2, -5, -3, 2, -13 },
  { 8, 7, -7, 0, 13, 7, -8, -7, 8, 36, -10, -22, 3, 23, -3, -10,
    -3, 11, 1, -7, 3, 3, -1, -7, -4, 2, 3, 2, 5, 3, -4, -1 },
  { -1, 1, 13, 1, -6, -1, -6, -9, -18, 17, -5, -37, -1, -1, -6, -4,
    1, -6, -15, 2, 17, -9, 0, -3, 0, 4, 0, -5, 0, 4, 1, -5 },
  { 0, 14, 5, 0, -7, 2, -6, 17, -6, -9, 7, -16, -5, 23, -14, -13,
    8, -15, 11, 10, -11, -13, -33, -5, -2, 1, 6, 8, 0, -13, -9, 5 },
  { 11, 7, -2, -8, 9, 11, 25, -14, 7, 3, -1, -33, 14, 8, -6, -19,
    3, 3, 2, -1, -3, -1, -2, -10, -3, 1, 2, 1, 4, 2, -3, 4 },
  { -2, 8, 4, -2, 9, 13, -4, -2, -15, -3, 19, -37, 9, 25, -9, 2,
    -5, -2, -2, -4, 4, 2, 2, 0, 3, 3, 3, 5, -2, -3, -4, -3 },
  { 10, 13, -1, -15, 4, 6, -18, -4, 25, 1, -23, -17, 15, 13, -8, -8,
    7, 4, -5, 3, 6, 9, -7, 6, 0, -5, 8, 0, -6, -1, -2, -2 },
  { 1, 3, 9, -5, 27, 15, -9, -31, -1, 23, -2, -9, 1, 8, -1, -7,
    -2, -8, -4, -4, -2, -1, 3, 5, 0, 0, -1, 1, -7, 7, -3, -3 },
  { -8, 7, 3, -6, 8, 3, -11, -2, 36, 14, 1, -30, 6, 10, -12, -6,
    -6, -2, -4, -3, -5, 0, 9, 4, -5, -5, -8, 12, 4, -3, 1, -8 },
  { -2, 9, 33, 0, 12, -3, -7, -4, -4, -1, 6, -25, 11, -6, -9, -11,
    -2, -4, -2, 6, -1, -3, -6, 15, -6, 3, 10, -4, 1, 0, 5, 8 },
  { -22, -21, -9, -19, -5, -7, -12, -15, -8, 9, -19, 14, -7, -4, 5, -8,
    -2, 7, 1, -3, 4, -4, 6, 11, 2, 6, -3, -5, 2, -2, 0, -3 },
  { -32, -13, 3, -24, 3, -8, 4, 1, -10, 14, -15, 0, 4, 6, -1, 6,
    7, -1, 6, 4, -3, -17, 1, 4, -6, -1, 1, 0, 3, 3, -7, -4 },
  { -32, -11, 7, -8, -12, 13, -5, -22, -4, 12, -16, 2, 0, 4, 0, 1,
    0, 6, -5, -8, 2, 6, 5, 0, -3, -6, 5, 6, 5, 5, 13, -4 },
  { -44, -33, 6, -4, 2, 0, -9, 10, 3, 4, 7, 0, -1, 7, 5, 1,
    1, -3, 1, 6, -1, 0, 2, 3, -4, 0, 0, 1, 0, -1, -2, -1 },
  { -30, -18, -24, -8, 5, 0, -2, 14, 7, 0, 1, 12, 6, 4, -9, 7,
    5, 7, -11, -5, 1, -8, -1, 2, 2, -9, 7, -1, 7, 5, 6, 6 },
  { -22, -20, -13, -9, 20, -3, 10, -8, 6, -4, 2, -7, 10, 8, 0, -1,
    2, -3, 6, -19, 2, 4, 3, 3, -7, 2, -1, -6, 1, 1, 6, -2 },
  { -27, -8, -1, 3, -1, -11, 24, 4, -1, 1, -8, 8, 5, -11, 15, -3,
    -15, -1, -1, -13, -1, 1, -5, 5, 2, 3, -9, 0, 4, 3, -7, 6 },
  { -33, -16, -1, -8, 10, -23, 6, 13, -1, -3, -9, 0, 5, -7, -5, -12,
    -2, 3, 3, 6, -2, -3, 2, -3, 9, -6, -3, -2, 0, 5, -3, -4 },
  { -22, -17, 11, -3, 3, 1, -1, -5, 17, 2, -15, -2, 10, -9, 6, 14,
    -16, -12, 20, -1, -7, 6, -3, -12, 1, 10, -10, -1, 7, -3, -1, 10 },
  { -28, -13, 1, -3, -1, -1, 0, 3, 3, 5, 1, 10, -10, -3, 7, 2,
    4, 19, -1, -1, 10, 5, -8, 1, 11, -15, -4, -3, -5, 4, -13, 3 },
  { -22, -13, 42, -20, 5, -13, 7, -11, 1, 1, -1, 1, 6, 3, 6, -11,
    3, 3, -2, 0, -4, 4, -3, -1, -5, 2, 0, 0, -9, -1, 4, 4 },
  { -26, -15, -2, -6, -4, -2, 16, 8, 21, 8, 1, -3, -10, 7, -8, -12,
    -5, 12, -9, 3, -2, -3, 18, 1, -12, -15, -4, 5, -3, 0, 12, 7 },
  { -26, -16, 5, 6, 14, -3, 15, 6, 1, -7, -13, 16, -15, 5, 11, -2,
    9, -7, -4, -2, 0, 0, -2, 7, -8, -6, -5, 2, 7, -3, 2, 12 },
  { -31, -17, -8, -30, 4, 14, 6, -6, 6, -11, 0, 3, -4, 0, 0, -4,
    0, -4, 1, 4, 3, 4, 0, -5, 3, 2, 2, 0, 2, 1, 3, 5 },
  { -61, -10, 4, 10, 4, 7, 0, -3, 0, 1, 0, -3, 0, 1, 0, -2,
    -1, 1, 2, -2, 4, -3, 1, 1, -1, 1, -2, -4, -4, 4, 0, 0 },
  { -28, -13, -8, -4, 3, -3, 2, 1, 11, 14, 3, 9, 1, 13, 3, 5,
    -3, -2, -2, -12, -14, -9, -11, -15, -12, -5, -4, -12, 3, -3, 0, -5 },
  { -41, 0, 12, -24, 13, 4, 5, 16, -5, -4, 0, 0, 13, -4, 1, -9,
    9, -6, -1, 6, -2, 5, 2, 9, 6, -9, -8, 8, -2, -3, -6, -4 },
  { -26, -19, -2, -15, 4, -14, 6, 0, 26, 20, 8, 9, 9, 3, -4, -5,
    -8, 1, 0, -1, 5, 9, 3, 4, 4, 7, 1, 3, -2, -2, -10, 0 },
  { -29, -18, 9, -4, 1, -5, -14, -12, 5, -10, -5, 4, -5, 0, -1, -1,
    4, -5, 7, -16, -11, 2, 7, -15, 2, -4, 6, -4, -6, 7, -3, 7 },
  { -27, -16, 9, -14, 3, -8, 9, 0, 7, -4, -3, -7, 0, -10, -1, 2,
    1, -2, 15, -10, 14, 7, 6, 17, 3, -4, 3, -10, 8, -8, 3, 11 },
  { -21, -20, -8, -8, 4, 5, -3, -2, 0, -5, 14, -10, 11, -4, 13, 0,
    5, -11, 19, -18, 18, 3, -5, -3, -4, -8, 11, -10, 10, 3, 4, -9 },
  { -35, -15, 13, -12, 4, 0, -2, -4, -12, -3, -8, -24, -7, 1, 7, 8,
    -3, 0, -2, -1, 3, -2, -2, -6, 8, 1, 0, 1, -6, -1, 2, -6 },
  { -19, -14, 13, -10, 9, -1, 1, 3, -12, 5, -16, 7, 13, 9, 4, -4,
    6, -5, 4, 9, -3, 17, -4, 12, -11, -6, -5, -6, 13, 2, 7, -9 },
  { -34, -8, -4, 1, 2, -1, 3, 6, -20, -11, 8, -1, 4, 2, -9, 4,
    -4, -5, 16, 10, -4, 14, -13, 1, -6, 0, 2, -10, 0, -3, -3, 7 },
  { -36, -10, -8, -3, 2, -2, 14, -4, -1, -7, -4, 10, -1, -3, 15, -11,
    0, 2, 3, -1, 4, 0, 8, -1, 0, 18, -11, -5, 15, -5, 13, -12 },
  { -22, -13, 14, -20, 15, 25, 16, 10, 8, -2, -10, -5, -1, -8, 11, 8,
    -1, -2, -4, 1, 2, -1, -7, 0, 0, 0, -3, 0, 2, -1, 0, 2 },
  { -31, -22, 7, 6, -2, 5, -20, 14, -6, 7, 0, 14, 3, -7, 3, -6,
    -2, 1, -3, -5, 1, -10, 1, -24, 6, -2, 3, -7, 1, -7, 8, 7 },
  { -25, -20, -3, -9, 10, 6, 12, 7, 5, 4, -3, 6, -1, -5, -6, -8,
    3, 5, 6, 5, -10, 10, -4, -15, -15, -2, -9, 2, 18, 1, 8, 12 },
  { -24, -19, -2, -4, -7, 11, 6, 9, 16, 2, -7, 18, 6, -7, 6, 6,
    -2, -9, 3, 12, -2, 3, -1, 6, 7, 8, 0, 8, -11, 8, 4, 2 },
  { -26, -20, -12, -12, -2, -3, 1, -5, -1, -2, 0, 3, 7, 9, -2, 2,
    9, 22, 13, 4, -4, -1, -2, -14, 5, 15, -8, -5, -7, -11, -14, -6 },
  { -21, -18, -1, -4, 0, 3, 7, -2, 10, 8, -8, -1, 15, 1, -9, 3,
    1, 3, -5, -2, 2, 4, 0, -1, 10, 2, -19, -8, 8, 30, -7, 8 },
  { -25, -6, 26, 4, -8, 4, -2, 21, 5, -4, -16, 5, 13, 4, -10, -1,
    -6, -2, 2, -10, -13, 1, 3, -3, -6, -8, 2, 11, 1, -7, 0, 5 },
  { 0, -1, -2, 19, -12, -48, -6, 11, 8, -2, -4, -2, -7, 5, -3, 2,
    -2, -1, -1, -7, 0, -3, -3, -4, -4, 4, 1, 3, -3, -1, -2, -5 },
  { -11, -8, -28, 18, 16, -24, -8, 19, 4, 8, -12, 9, -4, -2, 4, -7,
    6, 2, 3, 3, -4, 0, 1, -6, -4, -2, 2, 6, 0, -3, 1, -16 },
  { -9, -5, -26, 7, -3, -37, -16, -2, 2, -7, 4, -13, 0, -4, -6, -5,
    -6, -4, 0, 3, 4, -3, -4, -4, 4, -3, 9, -4, -2, 2, 7, -4 },
  { 2, 9, -18, 7, 29, -24, -1, 7, 14, 10, 3, -3, -2, -5, 6, -10,
    -6, -3, -8, 0, 5, 1, 4, 3, -12, 2, 6, 1, 3, 4, 1, -3 },
  { -20, 2, 8, 20, -9, -24, -4, 18, 3, 11, -1, -11, 6, 9, -1, -3,
    1, -1, -15, 3, 15, 9, 3, 2, -13, 2, -8, 8, 1, -1, 1, -8 },
  { -12, 5, -11, 6, 19, -26, -17, -6, 4, 14, 6, -8, 9, 5, -6, -5,
    2, -1, 20, 1, -11, -10, -18, 20, -7, 0, -3, 4, 2, 0, 10, 4 },
  { -15, 1, -2, 13, -8, -21, -22, 4, 4, 3, 3, -7, -31, 4, -10, -14,
    0, 8, 4, 5, 8, 11, 2, -8, 6, 7, 0, -2, 6, 8, 8, 7 },
  { -13, -10, -9, 12, 19, -16, -3, -2, 9, 2, 11, -29, -1, 9, 4, -3,
    1, -10, -10, 16, 1, 7, -7, -6, -4, -1, -5, 3, 6, 0, 3, 1 },
  { -17, -1, -5, 19, 12, -9, -21, -5, 2, 12, -7, -7, -3, 8, 7, -2,
    6, -9, -9, 1, -4, 1, 1, 3, -14, 2, -8, 0, 10, 1, -12, -6 },
  { -13, -5, 8, 15, 0, -20, -2, 20, 8, -8, 8, -19, 12, 10, 2, -11,
    0, 12, 1, -11, 0, -11, -15, 5, -11, 2, 4, -4, -11, 5, -4, -5 },
  { 3, -11, -7, 8, 0, -17, -26, 15, 19, -7, 10, -9, -5, -5, 14, -25,
    0, -8, 2, -9, -3, 9, 1, -6, 4, -4, 3, -9, -1, 6, 2, 2 },
  { -12, 5, 5, 9, 14, -18, -19, 4, 2, 16, 14, -21, -15, -9, -1, 16,
    12, -11, -10, -5, -7, 4, 15, -8, -5, -1, 1, 14, 13, -7, -1, -4 },
  { -10, -5, -1, 8, 7, -23, -10, 14, 6, 11, 10, -16, -3, 16, 6, 0,
    0, 9, 6, -2, -7, 1, 22, 5, 3, -8, 0, 3, -2, -10, 3, 0 },
  { -2, -14, 2, 16, 15, -17, -17, 6, 19, 4, -10, -15, -1, 15, 11, -14,
    -8, 5, 8, 8, -2, -8, -11, 10, 10, -8, -14, 2, 13, 4, -2, -12 },
  { -10, 3, 6, 4, 19, -23, -19, 1, 4, -9, -30, 3, -6, 18, 0, 2,
    0, -11, 0, 3, 7, -2, 8, 5, 2, -3, 6, -9, 1, -4, 7, -6 },
  { 9, 5, -2, 21, 20, -33, -13, 7, -10, 8, 8, -15, -6, -4, 1, 5,
    3, 7, -2, -9, -1, 4, -6, 1, 0, 9, -1, -5, 2, 1, -3, 3 },
  { -9, -3, 3, 15, -3, -30, -7, -7, -25, 6, 2, -6, 1, 19, 1, -12,
    1, -8, -13, 9, 13, 1, 8, 2, 5, 15, -2, 3, -9, 0, -4, 4 },
  { -6, -12, -17, 25, 22, -13, -10, 9, 2, 11, -7, -16, 4, 6, 1, 0,
    0, 18, -4, -5, 4, -2, -1, -5, 0, -4, 6, 1, 6, -1, 7, 0 },
  { -1, 0, -10, 8, 8, -27, 0, -2, 29, 16, -2, -4, 9, -1, 2, 0,
    6, 10, 6, 4, 2, -7, 9, -18, 3, 3, 3, -10, 17, 10, 9, -6 },
  { -3, -12, -6, 11, 20, -32, 5, 21, 3, -4, -9, 2, -10, 1, 7, -4,
    5, 0, 0, -1, -8, -9, -7, 4, -10, 5, 0, 2, -5, 4, 9, 1 },
  { -5, -1, -5, 1, 2, -19, -13, 1, 6, 12, 2, -16, -17, 11, 10, 13,
    16, -12, -11, 3, -6, 0, 6, 4, -3, 1, 8, 2, 5, -11, 3, -14 },
  { -19, 5, 10, 11, 2, -23, -9, 16, -2, 7, 0, -11, -7, 10, 6, -7,
    26, -15, -4, 8, 6, -4, 7, -9, -15, 1, 8, -4, 4, 2, -12, 16 },
  { -11, 1, 11, -4, 1, -31, -13, -1, 8, 5, 4, -2, 0, 13, 7, -17,
    7, -10, -6, 1, 4, -1, 2, -9, -4, 9, 3, 3, -4, -5, 3, 4 },
  { -3, 1, 10, -1, 0, -15, -22, 4, 40, -11, -4, -3, -14, 9, 11, -1,
    9, -1, -6, 6, 3, -6, 0, 0, -12, 7, -2, 0, 9, 3, 1, 3 },
  { -1, -1, -1, 14, 8, -24, -14, -8, 5, 8, 5, -12, -17, 8, 2, 7,
    10, -8, 0, 4, -6, -6, -10, 8, 4, -12, 3, -9, -12, 5, 4, -3 },
  { -5, 1, -11, 8, 9, -24, 0, 2, 2, 14, -12, -13, 1, 6, 7, 0,
    7, -6, 9, 26, 11, -14, 8, 10, 1, 9, 0, 11, -2, 6, 2, -10 },
  { -13, 1, 4, 34, 19, -17, -15, 0, 3, -2, -7, -1, 0, -3, -3, -1,
    1, -1, -10, 8, 5, 0, -8, 4, -17, 9, -2, 0, 0, 6, 2, -3 },
  { -6, -4, 1, 2, 2, -14, -29, 0, 9, 34, -3, -5, -14, 6, -10, -9,
    -5, -1, 0, 3, 3, 0, 1, -1, -2, -1, -1, -3, -3, -4, 3, -3 },
  { -4, 6, 3, 14, 14, -8, -29, 31, 11, 14, -4, -5, -6, 10, 6, -9,
    -1, -11, -7, 1, 7, 4, 1, -6, 4, 0, 10, -7, -5, -1, 2, 4 },
  { -4, -4, -2, 14, 6, -32, -6, -14, 14, -5, -11, 10, -18, -4, 6, -8,
    9, 5, -4, 1, -4, 5, -2, -9, 3, 5, 2, -10, -6, -17, 3, 17 },
  { -16, 9, 21, 19, 4, -20, -17, 14, 9, 15, -6, -17, -1, 1, 6, -3,
    1, 1, 8, -3, -6, 6, 9, 4, 9, -9, -5, 1, -1, 0, -1, 2 },
  { -7, -5, 3, 19, 1, -20, -9, 14, 21, -7, -18, -9, 26, -7, -17, -7,
    12, 6, 0, -9, -6, 14, 9, -9, -8, 4, 15, -7, -9, -1, 9, 1 },
  { -20, 30, -6, 11, 24, -4, 0, -6, -2, 8, -4, 12, -8, -17, 0, 5,
    -4, 1, -1, 3, -3, 5, 3, 3, 7, -2, -3, -2, 4, 0, 0, -1 },
  { -35, 17, 6, 1, -9, -1, -16, 3, -20, -13, 8, 7, -4, -7, -4, -20,
    7, 12, -5, 5, -5, -11, 12, -1, 15, -9, -6, 16, -4, -9, -13, 4 },
  { -21, 36, -19, 9, 0, -7, -8, 9, -4, -3, 3, 0, 7, -8, -2, -2,
    -11, 13, -1, 5, -3, 7, 2, 3, -1, -2, -5, 1, -1, -2, -5, -3 },
  { -12, 33, -4, 1, -12, -9, 0, -13, -1, 2, -8, 4, -10, 6, -16, -7,
    -1, -4, -10, 15, -1, 0, -5, -8, 5, 5, -3, 0, 2, -7, 1, -7 },
  { -14, 32, 5, -7, -15, 3, -5, 8, 14, 5, 9, 13, 3, 18, -3, 7,
    4, -10, -10, 10, -1, 2, 0, -2, -11, 5, -3, -4, 2, 2, 7, 4 },
  { -14, 34, 1, 20, -1, -12, 0, -3, -7, -4, 7, 18, 9, -3, 14, -7,
    -9, -20, -7, -4, -13, 12, 1, 12, 5, -6, 2, -4, 0, -15, 1, 3 },
  { -21, 23, 7, -8, 3, -13, -3, 0, -6, -2, -7, 6, -12, 9, -6, -2,
    -2, -4, -1, 6, 9, 5, -9, 15, 0, 8, -8, 7, 6, -15, 3, -5 },
  { -27, 32, -1, -4, -2, 4, -10, 12, -3, 8, 13, 7, 0, -15, 4, -2,
    3, 5, 7, -4, 9, -12, -1, -2, -1, -4, 0, -4, 2, -5, 6, -6 },
  { -17, 29, 15, 0, -1, -4, -10, 13, 12, -1, -8, -10, -10, 4, 7, -2,
    6, -5, -13, 19, 6, 1, -7, 2, -9, -2, 12, -4, -8, -3, 2, 4 },
  { -38, 27, 16, -15, -6, 3, -7, -4, 0, -1, 6, -2, -3, -6, 6, -6,
    -3, 0, 2, 0, -4, 6, 1, -1, 0, 4, -1, 3, 4, 1, -2, 5 },
  { -33, 40, -4, 2, 1, 0, 0, -10, -14, 0, -7, 4, -1, 3, -2, 5,
    7, 6, -1, 4, 1, 3, 1, -7, 1, -4, 5, 7, 0, 4, 3, -4 },
  { -20, 25, 12, -4, 16, -4, 2, 2, -14, -2, -3, 29, -1, 1, 3, 1,
    9, -5, 2, -8, -3, 1, -7, -2, -7, 1, 0, 4, 16, -2, -1, -1 },
  { -10, 30, 17, 3, -5, -2, 0, -5, -22, 4, 5, 5, -3, -18, -6, 10,
    -5, -7, 2, 8, 7, -7, -11, -2, 0, -3, 3, 2, 11, -4, 4, -4 },
  { -11, 30, 11, 4, -3, -8, 1, -2, 4, 18, 3, 1, -1, 0, -8, -4,
    -3, 10, 13, 14, 5, -5, 1, 1, -10, 2, 15, 4, 9, -1, -5, -3 },
  { -17, 32, 18, -18, -3, -5, 6, 10, 1, -15, -5, 9, 8, -12, -10, -6,
    11, 9, -5, -8, -7, 10, 5, -10, -14, -4, -3, 1, 9, -11, 2, 1 },
  { -13, 28, -11, -1, 2, -16, -2, 7, -24, 0, 3, 6, 3, -1, -8, -7,
    -12, 2, 2, -20, 10, 4, 0, -13, -2, -2, 1, 8, -14, 0, 4, 1 },
  { -14, 23, 12, 8, 8, -26, 2, -4, -14, 13, -14, 15, 3, -9, -1, -13,
    -10, -2, -10, 6, -16, 12, 8, 0, 9, -10, -7, -4, -4, 7, -8, 8 },
  { -20, 45, 10, -14, 4, 16, 8, -9, 1, -8, 10, 5, -7, -2, 2, -5,
    -1, 0, -5, 4, -6, -2, 4, 1, 3, 4, -4, 2, -2, -2, 5, 1 },
  { -20, 26, -4, 1, 7, 4, -8, 1, -5, -13, 2, 13, -7, -3, 6, -6,
    22, 0, 5, 11, -4, -11, 8, -9, 2, -2, -4, -2, 2, -13, -4, -8 },
  { -28, 18, 17, 3, -8, -23, -16, -6, 5, -10, 14, 10, 5, -1, -8, 4,
    -2, 13, -3, -2, 3, 4, 3, -2, -3, -4, 0, 1, 3, 4, 0, 4 },
  { -12, 32, -6, -16, 18, 12, -16, 0, 7, 13, -4, 5, -8, -1, -3, 4,
    6, -2, -1, -13, 4, -1, 3, 12, -3, -10, 1, 6, 8, -11, -2, 4 },
  { -18, 26, 2, 5, 0, -9, -17, 14, 5, 1, 7, -3, -8, -3, 11, 7,
    -5, -12, -8, 7, 0, -7, 2, -12, -9, 13, -11, 9, 6, -11, -5, 11 },
  { -24, 22, -15, -9, 8, 1, -7, -12, -9, 3, 11, 15, 14, -11, 12, -15,
    -5, 7, -2, 0, -8, 3, 3, -1, 2, 11, -11, 14, -6, 13, 1, -6 },
  { -20, 28, 18, -4, -6, -5, 12, 14, 2, 10, -13, -6, -8, -6, -13, -1,
    -26, 22, -3, -14, 6, 0, 10, -15, -13, -9, 6, -7, 1, -5, -4, -1 },
  { -19, 26, -8, -3, -14, -6, -9, -4, -8, 15, -8, 3, -12, -4, -2, -7,
    -5, 3, 13, -3, -4, -25, 4, -1, 5, -12, -1, -13, 5, 2, 0, 6 },
  { -18, 43, 14, -8, 1, -23, -2, -2, 1, 3, -7, 0, 0, 8, -1, -3,
    -5, 1, 5, 2, 0, -2, -2, -2, 1, -1, -1, -7, 0, 3, -3, 9 },
  { -11, 30, 10, -14, 3, 1, 10, -11, 1, -7, -4, 14, 2, 1, -9, 1,
    -11, -2, -7, 5, -11, 1, 3, 14, 1, -16, -8, 3, -5, 7, -4, 4 },
  { -18, 24, 6, 3, 8, 7, -22, -7, -7, 3, -8, 4, 23, 9, 3, -1,
    3, 6, 7, -1, -7, 6, 4, 1, -3, 1, -6, -1, 2, -7, 3, 3 },
  { -15, 38, -7, -1, -11, 2, -17, -24, 24, 8, 7, -4, -5, 2, 2, -7,
    1, 4, 0, -9, 5, 0, -1, 1, -1, -5, -6, 3, 0, 7, 8, -3 },
  { -14, 22, 1, -5, 9, -12, -9, -5, -6, 5, 7, 8, -1, -4, -9, -3,
    -33, -16, -9, -1, 12, -11, 17, -7, -3, -1, -7, 3, 2, -3, 16, -4 },
  { -14, 20, 6, 4, -10, -4, -4, -4, 1, -7, 2, 6, 8, -12, 4, 1,
    -1, 12, 10, 3, -14, -10, -3, 18, -2, 33, -5, -17, 17, -5, 9, 7 },
  { -12, 23, 13, 0, -11, -8, -11, 12, -5, -9, -16, 11, 6, 4, 12, -5,
    5, -13, 7, -12, -3, 1, 2, 12, 1, -4, -1, 5, 4, 11, -12, -3 },
  { 15, 2, 14, 7, 1, 2, 1, 12, 10, 23, 4, 6, -20, -10, 4, 26,
    -6, 13, 4, 3, 2, -11, 5, -7, -10, 4, 9, 1, 10, -4, 11, 4 },
  { 17, 15, 31, 17, 18, 16, 11, 24, 2, 4, 2, 3, -8, -3, 7, -3,
    -5, -7, -2, -6, -4, -5, -4, -1, -4, -2, -5, -6, 2, -1, 4, -2 },
  { 16, 8, 15, 14, 3, 7, 21, 9, 8, 15, 21, 6, 8, 12, 5, -5,
    7, -3, 10, 2, -3, 8, 6, 0, 5, 5, 6, -3, 2, 4, 0, -5 },
  { 5, -4, 6, 12, 6, 13, 24, 17, -5, 17, -1, -6, -7, -10, -8, -18,
    3, -2, 2, 7, -15, -11, 12, -3, -2, -2, -4, -7, 2, 0, 5, 5 },
  { 10, -6, 8, 11, 12, 20, 22, -11, -3, 15, -3, 15, -2, -2, 0, 2,
    5, -8, 4, -5, -9, -4, -1, 2, -1, -3, 1, 3, 13, -1, 9, 7 },
  { -5, 8, 5, 11, 14, -5, 14, -9, 2, 35, 8, 15, 1, -2, 2, -2,
    4, -9, -3, -14, -12, -2, -2, -4, -2, -8, -3, 1, -6, 3, 10, 0 },
  { 16, 0, -6, 15, -3, 4, 4, 3, 3, 20, 5, -4, 10, 9, -9, -3,
    -10, -2, -7, 11, -11, -10, 17, -1, 3, -15, 2, 9, -15, -10, 16, 10 },
  { 14, 4, -7, 19, 3, 0, 19, 8, 16, 34, -9, 6, -13, -1, 6, 5,
    -1, -2, 4, 3, 2, 1, 1, -1, 0, -7, 2, -1, 1, 0, 6, -1 },
  { 1, 6, 9, 13, 9, 10, 15, 16, 10, 18, 13, 17, 3, -1, -7, 2,
    -15, -11, -10, -4, -13, -6, -17, -13, -6, -14, 1, -10, 6, 4, -1, -1 },
  { 13, 1, 7, 10, 14, 13, -7, 5, 5, 28, 14, 14, -2, 2, 3, -3,
    -13, -4, 10, -9, 19, -4, -3, 4, -5, -5, 0, 5, -5, 0, 3, -4 },
  { 1, 0, 6, 22, 9, 18, 18, -3, 5, 10, 12, -2, 1, -3, -8, -12,
    9, -10, -7, 1, -1, 19, 0, 2, -8, -11, -10, 9, 6, 11, 0, 3 },
  { 10, 11, 19, 44, 0, 14, 1, -7, 6, 22, 2, -1, 9, 2, 0, -4,
    4, 0, -6, -6, 3, 0, 0, -2, 2, -5, 1, -2, 0, 1, 1, 1 },
  { 5, 7, 0, 32, 30, 26, 5, 4, -7, -3, 15, -6, 3, -10, 7, 6,
    -8, -7, 2, -13, -5, -1, -3, 7, 3, -2, -8, 0, 6, 4, 5, 0 },
  { 9, 8, -2, 4, 2, 11, 4, 29, -5, 14, 8, -5, -14, 8, 0, 9,
    8, -10, 5, -15, -6, -9, 9, -1, 18, -16, 9, -21, -3, -13, -2, 8 },
  { 25, 7, -9, 23, 20, 18, 6, 16, -9, 8, 8, -5, 11, 13, -8, 7,
    4, 10, -2, -1, -7, -9, -7, -9, -4, 1, 1, -5, -10, 8, 4, -5 },
  { 9, 2, 16, 14, -5, 14, 1, 0, -21, 17, -1, 9, 12, -3, -3, 4,
    -4, 14, 10, 3, 0, -10, 7, 4, 4, -11, 2, 4, -1, -3, 9, -1 },
  { 17, 8, 11, 26, 15, -3, 14, -1, 12, 9, 10, -8, 8, -18, -11, -3,
    -14, -7, 7, -3, -3, -4, 1, -7, -3, 2, -3, 16, 10, 0, 9, 6 },
  { 9, 8, 3, 8, 18, 14, 11, 1, 10, 6, 1, -4, -16, -2, 14, -2,
    1, 8, 12, 14, 3, -3, 8, 8, 12, -15, 3, -3, 3, -2, 14, 10 },
  { 22, -3, -11, 13, -7, 11, 4, 11, 3, 14, 0, -6, -2, -9, 4, 2,
    -2, 0, -5, -27, -10, 3, -1, 5, 8, -24, -3, -11, -3, 2, 11, -1 },
  { 19, 2, 8, 36, 5, -6, 3, 15, -3, -4, -5, 14, -10, 1, -12, -10,
    -3, -4, 3, -2, 1, -8, 4, 3, 5, -3, 0, 4, 8, -2, 8, 4 },
  { 8, 14, 15, 9, -4, 10, 5, 11, 9, 10, 8, 9, -15, 15, 6, -8,
    -10, -13, 5, -8, -20, -13, -6, -11, -1, -3, -6, -4, -1, 0, 13, 15 },
  { -2, -1, 9, 12, 2, 2, 13, 3, -23, 33, 15, 2, -4, -1, 3, 8,
    8, 6, 6, -7, 8, 6, 9, -1, 3, -8, 0, -4, 1, -8, 11, -1 },
  { 6, 5, -6, 16, 2, -3, 31, 21, -9, 12, 0, -1, -4, 1, -12, 3,
    -13, -18, 2, -11, -9, 2, -8, -6, 11, -3, -1, 0, -1, 0, 13, 5 },
  { 5, -1, 2, 0, 25, 5, 10, 16, -5, 21, 14, 12, 13, 2, -5, 5,
    5, -3, -2, -14, 0, -12, 7, 11, -1, -7, 19, -1, -1, -1, 8, -1 },
  { 10, 7, 3, 11, 0, 8, 22, 3, 3, 19, -4, 12, 15, 9, 5, 15,
    2, 1, 2, -10, -10, 0, 2, -1, 0, 1, -12, -1, 21, 16, 9, -7 },
  { 11, -4, -5, 24, -7, 11, 20, 11, -15, 18, 5, -13, -15, 0, -5, 9,
    1, 0, -1, -9, 4, -8, 6, -8, 1, -2, -7, 20, 9, 3, 9, 3 },
  { 20, 0, -12, -6, 9, 31, 9, 12, 8, 27, 15, 7, -16, 5, -3, -7,
    -1, -9, -2, -7, -3, 4, -8, -3, 3, -6, -2, -2, -3, -6, -1, 2 },
  { 6, -6, 48, 8, -3, 19, 12, 11, -7, 2, 3, 0, -1, 1, 8, -4,
    4, -6, 0, -4, -4, -3, 3, 6, 3, -13, -8, 5, -3, -7, 8, 5 },
  { 7, -2, 6, 11, 12, 2, 14, 4, -5, 12, 2, 9, 4, 2, 0, -1,
    2, 0, -15, -9, -16, -2, 8, -17, -5, -22, -19, -5, -1, -10, 1, -2 },
  { 11, -9, 3, 12, 6, 6, 1, 17, -6, 19, 14, 7, -7, -1, -1, -9,
    9, -11, -17, 0, -6, 16, 0, 1, 9, -24, 3, 3, -9, -3, 3, -2 },
  { 9, 0, 1, 8, 1, 7, 2, -5, -3, 8, -1, 7, 2, 6, -3, -6,
    5, -2, 6, -2, -4, -3, 0, -3, 13, -50, 1, -2, 2, 4, 4, 3 },
  { 7, 0, 26, 21, -4, 2, 17, 8, 7, 11, -7, 1, -1, -15, -1, -15,
    -11, -4, -17, -4, 1, -7, 3, 6, 3, -9, 2, 3, 6, 10, 6, 12 },
  { 1, -2, 2, -1, -10, -4, 6, -3, -5, -2, -8, 2, 2, 2, 8, 0,
    1, 1, 6, 0, 11, 13, 3, 4, 0, -12, 11, -5, 19, 20, 2, 5 },
  { 5, 3, -13, -2, 1, -12, 11, -7, -12, 7, 10, 0, 7, 0, -2, 4,
    -6, -9, -11, -12, -23, 12, 10, -3, 0, 6, 19, -1, 24, 18, 9, 12 },
  { 6, -3, 2, 5, 2, 2, -2, -5, -8, -11, -4, 3, -8, -4, 5, -3,
    -16, -4, 3, -12, -4, 3, 32, 7, 2, 8, 32, -18, -1, 12, 1, 7 },
  { 0, -8, -1, 0, -8, 7, -8, -1, -1, 4, -12, -1, 3, 0, 1, -18,
    8, 8, -14, -10, -11, 19, 9, 5, -7, 6, 8, -4, 26, 12, -1, 6 },
  { 3, 5, -14, 7, 14, 8, 20, -13, -16, -10, -2, 17, -7, 4, -8, -9,
    14, -5, 3, -4, -12, 7, 14, -10, -19, -20, 35, 8, 13, 14, -2, 9 },
  { -2, -4, -1, 1, -3, 0, -1, 1, 2, 2, 6, 0, 0, 4, 5, -2,
    3, 3, 3, -2, -7, -3, -3, -1, 6, -2, 29, 22, 13, 34, 0, 14 },
  { -3, -9, 3, 1, 5, -4, 2, 0, 7, -9, 0, 2, -5, -3, 0, 6,
    -1, -1, -1, 2, 2, 4, 8, 7, 20, -6, 7, 16, 33, 20, 6, -1 },
  { -11, 1, -3, -3, -11, 3, -9, -25, -1, -16, 4, -8, 15, 1, -2, 7,
    8, 23, 2, 18, -13, 16, 3, -7, 6, 3, 16, -8, 12, 16, 3, 4 },
  { 0, 5, 5, -5, 1, -1, 2, -3, -2, 1, -13, 2, 2, 10, 6, 7,
    18, 18, 7, 9, 8, 9, 21, 14, 7, 12, 15, 14, 15, 12, 11, 5 },
  { 1, -5, 11, -2, 17, 8, 3, 0, -1, 6, 11, -7, 6, 6, 7, 5,
    -15, 14, 1, 11, 4, 10, 12, 1, 2, 4, 30, 1, 11, 1, 6, 13 },
  { 2, 4, 3, -7, 5, 8, -11, 7, -5, 9, -10, 6, 8, -10, -3, 10,
    1, -29, -4, -26, 5, -8, 13, 4, 3, 6, 35, 1, 3, 6, 3, 0 },
  { -2, 1, 0, 0, -1, -3, -7, -3, -9, -3, -1, -6, 3, 4, 4, 0,
    5, -1, -2, -2, -1, -4, -10, 8, 0, -6, 10, -4, 46, 12, 2, 28 },
  { 4, -1, 4, 1, 0, 4, -2, -2, -2, -1, 2, -4, 1, 5, 0, -3,
    1, 1, -2, 0, 1, -2, -1, -1, 3, -6, 35, -11, 13, 53, -3, -1 },
  { -5, -2, 0, -13, -16, 5, -12, -11, 1, -30, 3, -18, -24, -8, -5, -19,
    1, -3, -8, 7, -7, -8, 15, -19, 4, 10, 30, 24, 6, 1, -9, 10 },
  { -4, 8, -7, -4, -6, 12, -1, -9, -4, 2, -9, 3, 2, -2, 4, 2,
    22, 9, 4, -5, 0, 5, -2, -9, -3, 1, 18, -12, 18, 16, 4, 16 },
  { -5, -8, -3, -5, -3, 6, -7, -3, -2, -5, -3, 1, 2, 2, 4, -6,
    10, 3, 12, -3, 20, 0, 27, -4, 16, 5, 18, -3, 23, 4, 12, 11 },
  { 0, 1, 0, 1, -2, 1, 2, 1, -1, 0, -2, 2, -2, -4, 1, -2,
    -2, -1, -5, -2, 0, 0, -2, 2, 9, 7, 63, 5, 12, -1, 1, 0 },
  { 4, -3, -7, -5, -11, -5, -12, -10, -10, -12, -15, -12, -14, -14, 1, 1,
    10, -10, 16, 6, 2, 9, 11, 9, 9, 8, 12, -1, 13, 12, 6, 3 },
  { 7, -3, -2, 4, 6, -8, 2, -3, -12, -5, -9, -8, -10, 15, -2, -4,
    8, 9, 7, -13, -18, 34, -5, 7, 12, 22, 16, -11, 13, 25, -15, -11 },
  { -3, -2, 0, -4, 1, 0, -3, -13, -7, 13, 12, -7, -10, 13, 19, 6,
    16, 15, -12, -15, -3, 34, 1, 5, 1, -9, 11, 21, 8, 17, -5, -6 },
  { 3, -5, 0, -4, 0, 4, -11, 4, -7, -3, -1, -8, 3, -2, 2, 1,
    11, 5, 6, 14, -3, 2, -4, -7, 0, 31, 15, -2, 24, 11, 5, 4 },
  { -1, -4, -9, 5, -8, -18, -4, -9, -20, -18, 7, -14, -16, 3, 8, -3,
    29, 11, -13, -13, 7, 1, 17, 6, 6, 21, 11, 1, 14, -8, 2, 5 },
  { -3, 8, -10, -6, 12, 2, 1, 3, 3, 3, 3, -6, -8, -14, 15, -5,
    16, 4, 16, 0, 7, -1, 0, 16, 2, 1, 22, 4, 19, 13, -11, 1 },
  { 2, -3, 10, 20, -4, -1, -8, 5, -8, -9, -6, -2, -4, -7, 8, -10,
    0, 8, -6, 1, -8, 14, 13, 5, 17, -6, 26, -1, 7, -1, 0, 12 },
  { -4, -7, -31, -2, -7, -1, 5, -5, -5, -12, 4, -7, -6, 3, 15, -2,
    5, -2, 7, -1, 10, 7, 8, -1, 14, 20, 14, 9, 16, 16, 8, 24 },
  { -7, 0, -3, -6, 1, 3, -13, -6, -4, -4, -5, -9, -1, -10, -4, -8,
    2, 0, -1, 1, 24, 24, 21, 31, 5, 2, 11, 12, 7, 4, 3, 6 },
  { -3, -5, 6, -4, -3, -1, 2, -1, -2, 1, 0, -8, -1, 2, 0, -4,
    6, 22, -1, -5, 8, 12, -1, -2, 28, 27, 20, -27, 14, 1, 2, -3 },
  { 1, -5, -2, -2, 6, -2, 9, 1, -2, -5, 3, 4, 11, 5, 2, 8,
    -3, -1, 1, -2, -3, -5, 5, 8, 49, 12, 8, -3, 9, 20, 12, 17 },
  { -6, 0, 1, 7, 0, 9, -2, -4, 8, 0, -2, -10, 0, 7, 21, -1,
    0, 1, 17, -7, -5, 2, 4, 16, -2, 17, 14, -20, 15, 14, 4, 15 },
  { 0, 3, -4, 9, -4, 0, 6, 4, -6, -6, -5, -7, 2, -9, -10, -2,
    -5, 0, -3, -21, 9, 14, -11, 13, 29, 2, 25, 4, 22, -1, 2, -3 },
  { 2, 12, -11, 2, 16, 9, -4, 7, 1, -10, -15, 11, -4, 3, -2, 4,
    4, -5, -10, 1, 4, 19, -15, 6, -4, -2, 30, -7, 11, 21, -12, 5 },
  { -2, -3, -2, 4, -1, -5, -3, -7, -5, 1, 0, -6, 1, -6, 7, 0,
    8, -7, -3, -2, 2, 14, 2, -3, -26, -1, 26, 22, 32, 1, -2, 6 },
  { 1, -38, -1, -20, -2, -3, -6, -4, 2, 2, 7, 0, 3, 5, 3, 10,
    6, 1, -3, -5, 7, 5, -5, -4, 8, 3, 1, -14, -1, -9, -5, -4 },
  { -5, -26, -7, -19, -10, -5, -11, 5, -11, -25, -8, -14, -9, -16, -8, -6,
    -17, -14, -1, -1, 6, 2, 2, 2, 3, 0, 2, 8, -8, 3, 0, -3 },
  { 17, -49, -3, -23, -1, 11, 7, 3, 4, -4, 0, 0, -1, 4, 2, 4,
    -2, -4, 2, -2, -1, -2, 2, 0, 0, -1, 0, 0, 1, 2, 0, 0 },
  { 4, -34, -6, -9, 1, 21, -7, 3, -2, -1, -3, 18, 2, -16, 7, -3,
    8, 7, -5, 7, 2, 4, 8, -6, -7, -2, -5, -1, 4, 1, 2, -4 },
  { 5, -29, 13, -2, -14, 3, 1, 18, -15, 4, -8, 8, -10, 8, 2, 1,
    -8, 15, 3, -10, -4, -4, -2, 0, -3, -4, 2, -3, -4, -3, 12, -6 },
  { 13, -20, 3, -18, -17, 4, -14, 13, 28, 11, -8, -6, 16, 6, 0, 10,
    3, 4, -9, 13, 5, -7, 12, -5, 0, -7, 5, 1, 3, 3, 2, 1 },
  { 3, -27, -5, -11, -21, -11, -12, 0, -5, 7, -22, 1, 3, 5, 0, -5,
    8, 7, 1, -5, -7, 2, -5, 4, 1, 3, -8, -2, 0, 4, -2, 6 },
  { 31, -45, 0, -1, -12, 1, 2, -6, 4, 3, -1, 3, 3, 0, 5, 3,
    -5, 12, 4, 6, 2, 1, -2, 1, 3, 2, 5, 2, 2, 2, 3, -1 },
  { 9, -45, 6, 5, -1, -17, -2, 18, -3, 2, 0, 1, 0, -1, 10, 8,
    -7, -2, -5, -8, 6, -1, 0, 4, 6, -3, 12, -1, -2, 0, 5, -7 },
  { 3, -26, -2, -12, -12, 2, -10, 16, -3, 12, 4, 5, 11, 8, -16, -17,
    -2, -3, -3, 2, 5, -9, 13, 1, 10, 11, 3, 5, -2, 2, 2, -7 },
  { 8, -26, 32, -7, -5, 22, 2, 14, -10, -8, -7, 3, 3, 7, 0, -5,
    0, -1, -3, 0, 8, 4, -5, -7, 6, -1, 4, 8, 1, 1, 7, -6 },
  { 4, -31, 2, -14, 2, 0, 1, 8, -6, -1, 17, -3, 13, -6, 5, -10,
    -2, -10, -2, -10, -3, 7, 1, 5, -8, 8, -14, -3, -15, 7, -10, -6 },
  { 16, -27, 13, -4, -23, 7, -9, 6, -7, 5, 4, 2, -1, -3, 23, -18,
    7, 0, -3, 4, -3, 9, -6, -2, -1, 8, -6, 2, 6, -3, 2, -2 },
  { -1, -35, -2, -8, 11, -1, -7, -3, -2, 11, 7, 6, -6, -10, 9, 6,
    -3, -5, -6, -3, 9, 16, -16, -9, -20, 12, 3, 5, -3, 1, -9, 4 },
  { 2, -24, 1, -12, -16, 5, -4, 3, -4, -1, -11, -11, -8, -14, 14, 10,
    -8, 20, 8, -3, -11, 1, 1, -4, -4, -7, -3, 15, 2, -6, -2, 7 },
  { 9, -21, 2, -19, -7, -5, -8, 25, 3, 17, 5, -3, 9, -12, 8, 2,
    -4, 3, 3, 1, 11, -9, -4, -3, 4, 3, -22, 6, 4, 6, 11, -5 },
  { 16, -23, 13, -17, -21, -12, 5, 9, -20, 7, 6, -6, 0, 2, -9, 6,
    -6, -13, -7, -1, 5, -3, 5, -7, -10, 1, 0, 8, -9, 11, 0, -8 },
  { 10, -26, -9, -7, -19, -4, 6, 16, -7, 5, -4, 4, 8, 0, 4, -1,
    6, -7, 1, -8, -11, 10, -14, 0, -16, 6, -3, 5, -1, 14, 12, 1 },
  { 8, -27, 12, -14, -1, -1, -19, 10, -11, 21, -14, 9, -8, -3, 8, -1,
    12, -13, 3, -4, -2, 0, -9, 0, -7, 2, -3, 12, 1, -3, 3, 1 },
  { 18, -20, -14, -14, -16, -3, -24, 6, -17, 2, -3, -11, 2, -3, 12, 10,
    10, 1, 10, 7, 8, 5, 5, 4, -1, 7, 2, 2, 0, 4, 7, 0 },
  { 0, -30, 9, -16, -18, 15, 12, -3, 4, -4, -5, -11, -4, -12, -10, 0,
    2, -2, -4, -1, 2, 0, -1, -6, 2, -3, 4, -5, 7, 3, 5, 7 },
  { 25, -24, -1, -6, -9, 6, -13, -2, 3, 15, -3, 11, 4, -8, -11, 2,
    0, -9, -2, 7, 4, 8, 5, -8, 5, 6, -1, -11, -15, -5, 0, 11 },
  { 0, -34, -7, -11, -7, 9, -3, 19, 4, -8, 3, -11, 11, -3, -9, 12,
    9, 9, 2, 1, -7, 1, -3, 0, -6, -2, -1, 3, 0, -7, -2, -5 },
  { 6, -34, -4, -5, -3, -9, 2, 9, -1, 9, -5, -3, -26, -12, 8, -6,
    -7, 11, -8, 4, 4, 1, -1, 0, 8, 9, -4, 7, -1, 1, -3, -1 },
  { 3, -30, 5, 6, -10, 3, -7, 6, 3, 3, -26, -19, -3, 1, 7, 5,
    -4, -5, 6, 10, 13, -10, 4, -7, -4, 5, -3, 9, -6, 3, 9, 5 },
  { 4, -24, 9, -19, 2, -4, -5, 8, -3, 2, 0, -15, -1, 9, -4, 22,
    6, 9, 3, 7, 11, -9, 0, -3, 4, 5, -5, 10, -8, 5, -7, -3 },
  { 8, -27, 7, -3, -1, 2, -9, 13, 7, 12, -4, -6, -6, 5, 0, 7,
    5, 1, 15, -3, -4, 0, -5, -2, 7, -5, -7, 1, -2, 13, -8, 13 },
  { 17, -22, -15, -11, -8, 16, -14, 18, 2, -1, 14, -7, 14, -6, -6, -7,
    -8, 17, 6, 4, 4, -7, -5, -9, -14, -6, -1, 9, -3, 1, 6, -5 },
  { 25, -30, 2, -12, -13, 18, -18, 16, 8, -3, 10, -8, -3, -1, -6, 3,
    -5, -7, 4, 6, 7, 1, 1, -11, -5, 6, 2, -4, 9, -1, -5, -2 },
  { 7, -23, 7, -15, -1, -3, -1, 0, -10, 12, 2, 5, -4, 0, 4, 6,
    -1, 5, -9, -1, -1, -7, 1, 17, 9, -17, -16, 8, 4, -14, 11, 14 },
  { 0, -31, 7, -13, 3, -11, -7, 6, 1, -11, 8, -7, 15, -3, 16, -11,
    -1, -15, 16, -3, 5, 0, -2, -2, -6, 11, 5, 6, 5, -5, 6, 3 },
  { 13, -24, -2, -20, -10, 7, -3, -1, 15, 2, 6, -5, -7, -10, -20, 1,
    -4, 14, 8, -2, 3, -13, -3, 1, -4, 1, -3, 2, 8, -7, 16, -4 },
  { 1, -2, -2, -3, -4, -7, 0, 3, 6, 7, 3, 2, 1, -2, -1, 0,
    -6, 4, 2, -4, -3, -4, 5, 9, 5, 0, -3, -3, -4, -7, -31, -50 },
  { -1, -3, 7, 2, -1, 2, 4, 6, 0, 10, -2, 0, -20, -6, -3, 9,
    -20, -22, -1, -1, 15, 9, -12, 10, -13, -20, 12, 3, 5, 6, -7, -26 },
  { 0, 4, -2, -14, -12, 6, -13, 11, -10, 3, 22, 6, 16, -2, -5, 1,
    -3, -11, 0, -7, 5, -5, 0, 1, -1, -6, 8, 8, 10, 9, -5, -27 },
  { -5, 10, -2, 7, 9, -9, 5, -9, 5, 4, -15, 14, 1, 3, -10, 5,
    0, -2, 7, 3, -13, 6, 9, -6, 5, -14, -17, -1, 11, 14, -2, -26 },
  { 0, 6, -3, 0, -8, 6, 0, 1, 4, -8, 2, -5, 4, 7, 15, 11,
    9, 19, -2, 14, -8, 7, -1, 3, -3, -3, -10, -2, 12, -2, -12, -29 },
  { -12, -5, 0, -3, -2, 6, 3, -3, 2, -2, 1, 11, 2, -7, 5, 1,
    2, -2, -14, 0, -1, -5, 3, 8, -28, -26, 6, -6, 3, 8, -10, -27 },
  { -1, -3, 6, 2, 4, 15, 1, 0, 2, -2, -2, 13, 3, 6, 0, 6,
    -1, -4, -1, -5, 8, -1, 5, -5, -15, 11, -8, -5, 14, -6, -14, -29 },
  { -5, -6, 0, 1, 0, 6, -3, 2, -5, -1, 5, -3, 2, -10, 3, 4,
    3, 0, 13, -3, -1, 4, -4, -6, 2, 9, 8, 2, -3, 28, -11, -31 },
  { 1, -4, -10, -9, -4, -3, -15, -6, 1, 5, -3, -6, 5, -6, -22, 27,
    -13, 5, 3, -7, -4, 20, -7, -12, -1, -24, -4, -13, -8, -11, -15, -21 },
  { -6, -4, 19, -6, 2, 11, -6, 1, -3, -10, 9, -9, 12, -10, 2, 1,
    -9, 1, 15, 7, -5, 5, -29, -35, 4, -30, 9, 9, 19, 17, 2, -17 },
  { -3, 3, -3, 1, 2, 5, -1, 5, -2, -3, 1, -3, -8, 3, -4, -2,
    -4, -1, 12, 0, 2, -8, -6, -4, 16, -1, -14, -2, 25, -6, -15, -36 },
  { 0, -1, 3, -4, -4, -1, 7, -4, 8, 0, 10, 9, -4, 1, 10, -1,
    -3, -13, -5, -4, -1, -4, 8, 11, 14, -7, -5, 16, 12, 13, -1, -28 },
  { 1, -2, 2, -3, -8, 10, 4, 9, 12, 3, 5, 0, 8, -3, -6, 2,
    16, -11, 11, 0, 1, 6, 1, 18, -10, -16, -1, -4, 5, -14, -15, -20 },
  { 1, -12, 5, 4, -7, 8, -1, -17, -2, -9, -14, -11, 6, -9, 5, -4,
    3, -2, 7, 18, -5, 5, 6, -1, -11, -2, -10, -3, 8, -3, -2, -32 },
  { -12, 5, 20, -5, -6, -11, -6, -6, -13, 4, -6, 19, -8, 2, 3, -9,
    -4, -4, -1, 9, -1, 21, -1, 7, 15, -10, -1, -3, 9, -3, 2, -24 },
  { 0, -3, 2, -6, 4, -1, -9, -2, -1, -3, 6, -1, -5, -6, -5, -8,
    0, -2, -6, 9, -4, 3, 2, -13, 1, -7, 23, -13, 4, -3, -15, -33 },
  { -7, 2, -15, 11, -10, 14, 0, -11, 3, -1, 12, -4, -4, 9, 11, -13,
    -13, -3, -14, 1, 3, 6, -5, 8, 0, 5, 5, -10, 4, 5, -6, -30 },
  { -6, 4, 0, -5, 4, 1, -1, -1, 3, 6, 5, -2, -5, 0, -2, 5,
    -4, -2, -4, -2, 4, 7, -7, -1, 1, -4, -3, -19, 37, 12, 10, -40 },
  { -7, 2, -7, -12, 17, 11, -7, 2, 2, 3, 1, -1, 3, 4, -2, -5,
    9, -9, 6, 4, 9, 12, 11, -5, 2, -1, 0, 9, 5, -7, -2, -24 },
  { -7, 6, 1, 3, 1, 0, 6, 0, 4, -12, -2, -2, 1, -9, 10, -2,
    11, -1, 21, -12, 15, -5, 10, -5, 5, -5, 14, -6, 5, -7, -3, -29 },
  { -2, 0, -5, -2, -3, 1, -3, 0, 4, 2, 3, 0, 2, -2, 7, -2,
    3, -5, 2, -1, 6, -4, 0, -3, 8, -11, 19, -8, 22, -34, 13, -35 },
  { -1, -3, -1, 9, 11, -3, -3, -1, 7, 18, 11, -5, 2, -12, -11, 18,
    9, -5, 1, -6, -9, 12, 1, -3, -3, -9, -14, 9, 9, 8, -6, -26 },
  { 0, 5, -5, -1, -1, -2, 4, 6, 8, 2, -1, -2, 5, 1, -5, -4,
    1, 1, 18, 1, 7, -10, 3, -2, 12, -1, -15, 9, 12, -14, 13, -38 },
  { 3, 0, -8, -1, 0, 8, -9, -3, -8, 16, 3, 16, -5, -9, 0, -1,
    -7, -1, -4, 13, 7, 0, 1, 2, -1, -16, 0, -2, 1, 8, -8, -28 },
  { 7, 9, -5, -3, -2, 2, 0, 3, 11, -6, -4, -2, -2, -5, 28, -18,
    -6, 2, 15, -10, -15, -10, -2, 0, -2, -2, 4, -3, 7, 11, 5, -30 },
  { 9, 0, -7, -1, -4, -7, 2, 2, 9, -2, 2, 3, -8, -6, -6, 3,
    -10, 4, 10, 5, 21, -4, 14, -18, 1, 3, -10, -2, 6, 14, -8, -26 },
  { -14, -1, 2, 3, -3, 7, 1, -22, -1, -1, 0, 1, 12, -14, 3, -5,
    0, 10, -3, 1, -5, 12, -3, 10, -8, -22, -11, -13, -7, -10, -13, -25 },
  { -2, -5, -4, -4, -9, -18, 9, -3, -5, 17, 13, 5, 6, 11, 3, 8,
    20, 4, 2, 9, 8, 5, 6, 1, 7, -7, -6, -2, -7, 0, -17, -23 },
  { -5, -5, 2, 0, 6, 2, -2, 2, -3, 4, 4, 0, -5, -2, -4, 6,
    8, 10, -1, 1, -5, 5, -14, -2, -11, 8, 6, 25, 7, -1, 0, -43 },
  { -4, 0, 4, -2, 7, 0, 3, 17, 5, 2, -5, 1, 21, 3, -2, -10,
    -16, -9, 7, -12, 9, -8, 2, 5, -5, -10, -2, -11, -5, -1, -9, -30 },
  { -2, 3, 1, -4, -1, 0, 8, 1, 12, 4, -1, -1, 3, -17, 13, 9,
    0, 7, -6, -5, 9, 1, 5, 4, -10, -18, 0, 14, 11, -4, -16, -28 },
  { -1, 0, 2, -1, 4, 1, -1, 1, -1, -2, -1, -2, 3, 0, 0, -1,
    -1, 1, 2, -2, 3, 3, -2, 4, -2, -1, -6, 1, -1, -1, 6, -70 },
  { 7, 3, -11, -1, 12, -4, -14, 4, 4, -4, 4, -2, 2, -12, -4, 15,
    -17, -4, -3, 6, 8, -5, 22, -22, 5, -11, 15, -4, 4, -1, -21, -1 },
  { 10, -2, -13, 11, 4, 14, 4, 9, 8, 8, 19, 15, 14, 15, 5, 10,
    8, 15, -5, 4, 14, -8, 1, 1, 2, 1, -1, -3, 21, 8, -29, 13 },
  { -6, 0, -6, 6, -1, 2, 8, -4, -5, 4, -4, -5, 0, -2, -4, 0,
    9, -2, 1, -2, 26, -19, 21, -10, 4, 1, -8, 5, 22, -10, -13, 15 },
  { 11, -5, 1, 0, 6, 3, 7, -2, -2, -3, -5, -1, -2, -6, 1, 1,
    -8, -5, -13, 13, -2, -3, -1, -9, -28, 4, 2, -11, 18, -20, -24, 9 },
  { 7, 4, -3, 6, 6, -6, -7, -5, -7, -4, -4, 0, -7, -5, -6, -5,
    2, -13, -12, 2, 0, 5, 18, 15, -13, -7, 13, -20, 16, -10, -19, 6 },
  { 5, -8, -1, 5, 10, 2, -1, -10, -11, 23, 8, -5, -8, 4, -5, -4,
    -5, -5, -11, -8, 5, 1, 7, -9, -9, -6, 12, 14, 17, -12, -22, 3 },
  { -5, -8, -3, 3, 12, -1, 0, -4, -5, 1, 1, 6, 1, 5, -5, 7,
    -2, 7, 1, 6, 6, 2, 0, -5, 17, -4, -5, -24, 13, -20, -27, 14 },
  { -1, 2, -3, 1, -3, 1, -3, 0, -2, 3, -2, 1, 2, -1, -2, -1,
    -2, -5, 5, -2, 0, -7, 1, -6, 8, 8, 11, -5, 24, -43, -13, 2 },
  { -2, 4, 7, -3, -4, 4, 13, -4, 0, 0, -2, 9, 0, -3, -6, 1,
    -7, 1, -1, 10, 0, 5, -1, -24, 25, -15, 7, 2, 22, -10, -21, 0 },
  { -5, 2, 6, -2, 13, 3, 5, -12, -11, 16, 6, 10, -5, 0, -3, 6,
    5, -5, -5, 10, 12, 10, 11, -7, 8, -14, 2, -15, 13, -14, -8, -3 },
  { 5, 6, -7, -5, 5, 2, 9, 5, 0, -1, -4, 2, 8, 0, 3, 5,
    -12, 3, -3, -6, 2, -1, -5, 14, 11, -20, -21, -25, 24, -1, -10, 6 },
  { -5, 5, -2, 9, 4, -4, -1, -6, 11, -6, 5, 0, 2, -3, 6, -1,
    -17, -18, -4, -13, 9, -1, 9, -7, -4, -8, 2, -3, 12, -31, -18, 5 },
  { -7, -11, 6, -8, 4, -3, -12, 0, -1, -6, -3, 0, 5, 9, 7, 2,
    1, -8, -6, 8, 2, -5, 7, -1, 16, -10, 16, -12, 18, -1, -25, -12 },
  { 3, -12, 1, 2, -2, -18, -8, -15, -10, -9, 2, -7, 11, -11, 2, -1,
    -1, -1, -9, -6, 3, -14, -2, -1, 2, -13, -7, -9, 19, -5, -17, 2 },
  { 7, 1, -8, 7, 17, -13, -10, 5, 7, 1, -6, 4, 9, -4, 0, 3,
    8, 1, -14, -9, 4, 7, -9, 0, 6, -5, -12, -2, 25, -2, -19, 1 },
  { 7, -3, 6, -3, 1, 6, -7, 0, 10, 0, 4, -5, -17, -4, 4, -1,
    0, -3, -7, 19, 24, -1, 21, 8, 10, 9, 8, -1, 23, -2, -18, -2 },
  { 3, -3, 0, 5, 8, -2, -9, 2, 9, 6, 19, 8, 2, 6, -9, -2,
    -4, -3, -8, 7, -7, -8, 5, 4, 26, -6, 7, 18, 24, 0, -13, 4 },
  { 0, -13, -11, -1, 3, -9, 5, 4, -7, 3, 0, 2, -1, 4, -5, 2,
    9, -2, -11, 15, 1, -21, 1, -1, 0, 4, -14, -4, 24, -16, -13, 1 },
  { 1, -9, -8, 0, 0, -4, 11, -1, 14, 16, 0, 17, -2, -9, -12, 0,
    -1, -14, -9, -14, 0, -2, 19, 4, 6, 4, 4, -11, 8, -17, -19, -5 },
  { -3, 1, 2, 12, -4, -18, -1, -4, -7, 14, -3, 2, 0, -7, -8, 12,
    -5, -9, 14, 12, -9, -2, 4, -6, 4, 18, -1, -25, 22, 2, -23, -5 },
  { -2, 0, 0, 0, 1, 3, 5, -1, 5, -2, -2, 2, -3, 0, 1, 2,
    0, -1, 2, -1, -9, -6, -7, -4, -2, 4, -7, -5, 64, -3, -25, 4 },
  { 12, -2, -3, 0, 8, -9, 13, -7, 6, -3, -12, 12, 15, -9, -4, 2,
    9, -4, -12, 3, 14, 1, 7, -15, 15, 0, -6, -12, 0, -3, -20, 6 },
  { 2, -1, -4, 5, 9, 6, -7, 2, -2, -7, -2, 0, -1, -18, -4, -6,
    -15, -5, 11, 5, -10, -1, 2, 7, 12, -19, -7, 8, 21, -4, -15, 4 },
  { 4, 2, 5, 5, -5, 1, 3, 2, -8, 13, 0, -5, -2, -14, -11, 6,
    2, 17, 8, -13, 26, -2, 5, -15, -4, -14, 12, -9, 13, -21, -23, -4 },
  { 2, -3, -2, -3, 3, -2, 6, 9, -9, 13, 4, 2, 12, -3, -3, 1,
    -17, -22, -3, 4, 3, -2, 1, -9, 1, -6, 11, -13, 14, 0, -15, 6 },
  { -16, -4, 17, -2, -20, -11, 11, 10, 5, -8, 16, 2, -17, -14, 11, 11,
    -6, -11, -7, 12, 12, -10, -6, 5, 8, -4, -2, -5, 28, 3, -13, 4 },
  { 0, -3, 3, -7, 6, 8, -12, 20, -19, 18, -11, 10, -5, 0, -9, 11,
    3, 0, -2, 9, -7, -5, 18, 3, -2, -16, 1, 6, 12, -7, -16, 1 },
  { 4, 1, 5, -5, 15, 2, -8, 3, 5, -11, 15, -3, 8, -8, -1, 7,
    4, 7, -2, 6, -9, 5, 12, 2, 33, -2, -6, -18, 4, 0, -18, 11 },
  { 3, -1, 1, -1, 0, 1, 4, -1, -5, 0, 1, 0, 4, 2, -1, 4,
    -3, 2, 0, -2, 4, 6, -1, 6, 42, 19, -4, -37, 19, 1, -15, -4 },
  { 2, 0, -5, 0, 10, 0, 0, -5, 3, 0, 0, -3, -3, 0, 2, -4,
    -10, 2, -6, 4, 4, 1, 27, -7, 17, -34, 5, -9, 15, -16, -7, -5 },
  { -2, 7, 7, -2, 9, -2, -15, 11, 11, 7, 5, 1, 15, 1, -9, 31,
    2, -15, 2, 4, 3, 4, -1, -8, 2, -7, 6, -17, 11, -14, -11, 2 },
  { 1, 1, -11, 9, 9, -6, -14, -11, -10, 8, -3, 11, 16, -9, -8, -13,
    -8, 9, 0, 6, 6, -2, 13, -8, -2, 3, 13, -3, 10, -6, -17, 4 },
  { 14, 5, 4, -6, -12, 10, -7, 8, 21, -8, -30, 15, -2, 1, 11, -9,
    -5, 1, 0, -1, -1, -6, -2, 3, -5, 7, 9, 5, -5, 2, 0, 1 },
  { -1, 2, 20, -17, -15, 3, 3, 7, 11, -17, -13, -6, -3, 18, 17, -15,
    -4, -4, -5, 22, 14, -14, -2, -10, -7, 11, 8, -7, -3, 0, -7, 11 },
  { 7, -11, -7, -8, -14, 22, 5, 2, 6, 13, -12, -2, 10, 3, 0, -21,
    -4, 20, 3, 10, 21, -10, -12, 8, 11, 2, -5, 2, 1, 3, -1, 15 },
  { -1, -2, -1, -2, -13, 8, -4, 0, 7, -2, -17, 8, 18, 5, 3, 8,
    -8, -2, 3, -4, 14, -18, -13, 14, 15, -13, -1, -2, 4, 11, 1, 12 },
  { 13, -6, -4, -16, -17, 16, 21, -2, 5, -11, -9, 19, 21, -17, -3, -17,
    3, 12, 8, -12, -6, 1, -7, 9, 9, -7, -5, -1, -3, 5, -6, -4 },
  { 11, 5, 12, -20, -6, 10, 4, 12, 8, -5, -10, 15, 13, 14, 10, -15,
    -13, 1, 6, 14, 15, -17, -13, 4, -5, 10, 7, -6, -8, -3, -4, 12 },
  { 25, -1, 7, -5, -7, 11, 1, 17, 13, -15, -14, -4, 5, 3, 8, -3,
    -2, 2, 0, 6, 16, -12, -6, -4, 4, -3, 7, -10, -3, -7, -13, 7 },
  { -8, 10, -3, -13, 5, 2, 4, 9, 9, -17, -13, 2, 11, 1, 6, -4,
    8, -10, 4, 1, 19, -15, -4, 12, 31, 7, -5, -17, -4, 9, -2, 7 },
  { 14, -6, -6, -6, -14, 13, 17, -5, 4, -14, -9, 7, 7, -9, 3, -16,
    -15, 11, 11, 6, 4, -11, -19, 3, 5, 8, 13, -14, -14, 3, -4, 12 },
  { -2, -4, 10, -4, -7, -1, 27, 5, 2, -16, -18, 4, 12, -2, -3, -2,
    -1, 1, -8, -12, 3, -4, 8, 15, 2, 4, 9, -13, -14, 9, -7, 5 },
  { 4, 2, -10, -5, -7, 2, 1, 4, -1, -6, -15, 6, 1, 10, 5, -10,
    -9, -1, 13, -3, 5, -21, -11, 8, 8, 5, 27, -21, -18, -5, -1, 15 },
  { 11, 1, -16, -8, -11, 0, 5, -8, -12, -13, -17, 22, 4, -6, -1, -18,
    -10, 0, 19, 2, -2, -8, -7, -3, 2, -2, -9, -17, -5, 4, 4, 10 },
  { 8, -6, -19, -5, -4, 12, 14, 15, 10, -9, -1, -9, 19, 12, 0, -1,
    2, 4, 7, 9, 16, -16, -14, 9, -4, 3, 1, 0, -2, 10, -1, -1 },
  { 12, -8, 12, -9, 0, 25, 7, 9, 2, -31, -9, -4, 15, 4, -5, 1,
    -10, 11, 8, 10, 0, -6, 5, 11, -1, -6, 4, -10, -9, 6, 4, 5 },
  { 14, 6, -17, -2, 17, 12, -9, 2, 0, -25, -14, 5, 20, 14, 8, -20,
    5, 2, -2, -3, 9, -13, -3, -1, -6, 3, 7, -6, 0, 2, 3, 1 },
  { 8, 4, -15, -3, 10, 18, -4, 13, 8, -22, -10, 9, 19, -15, 7, -5,
    -13, 12, -4, 9, 2, -9, -6, 0, 2, 1, -9, -6, 6, 1, -1, 11 },
  { 4, 1, 4, -5, -10, 18, 7, 2, -4, -9, -11, 0, 32, -7, 4, -16,
    -1, 0, 6, 3, 6, -3, -14, 16, 9, -2, 7, -1, 0, -5, 5, -3 },
  { -3, 2, 3, -8, -6, 4, 6, 2, 4, -12, -15, 2, 8, 8, 9, -3,
    -18, 6, 34, 11, 12, -15, -1, 2, 9, 2, -4, -4, 2, 4, 2, -3 },
  { 18, -6, -12, -8, -1, 15, 20, -4, -1, -11, -5, 6, 6, -11, -15, -7,
    3, 7, 10, 2, 8, -10, -5, 8, 15, -5, 5, -17, -13, 13, 11, 7 },
  { 8, -4, -6, -1, -14, -3, 6, -2, 1, -5, -1, 10, 10, -15, 5, 0,
    -10, -4, -3, 7, -4, -19, -15, 27, 11, 18, 3, -19, -2, 6, 0, 12 },
  { 12, 0, -5, 0, 4, -5, 1, 5, 10, -7, -11, 21, 29, 1, -2, 1,
    -4, -11, -1, 13, 11, -20, -1, 4, 4, 4, -5, 6, -13, -2, 11, 9 },
  { 2, -7, -7, -3, -10, -1, 20, 12, 1, -19, -19, -1, 5, 4, -7, -25,
    14, 1, -3, 2, 12, -4, -3, -3, -2, 6, 1, 0, 3, 2, 5, -1 },
  { 12, -8, 3, -12, -10, 10, 13, 0, 23, -14, -18, 10, 0, 15, 3, -12,
    -3, -5, 5, -4, 2, -14, -10, 8, 2, 9, -1, -11, -3, 5, 13, 2 },
  { 9, -6, 7, -7, -30, 17, 6, 13, 1, -14, 0, -1, 6, -9, 8, 3,
    -4, 0, -1, -7, -5, -13, -19, -3, -4, 4, -6, -2, -13, 1, -2, 3 },
  { 10, 1, 3, -18, -26, 17, 4, -16, 4, -3, -13, -4, -6, -11, -4, -21,
    7, 8, 2, 5, 13, -6, 1, 5, 8, 7, 9, -6, -6, 1, -1, 2 },
  { -3, -1, 0, -2, -2, 0, -1, 3, 4, -14, -8, -9, 13, 2, 50, -23,
    -8, 8, 7, 11, 16, 3, -7, 0, -2, 6, 5, -1, 1, -2, 4, 3 },
  { 1, 3, 1, 1, -6, 3, 6, 6, 2, -2, -3, 10, 2, -8, -5, -5,
    5, 4, 4, -2, 10, -8, -40, -1, 21, 8, 3, -4, -1, 13, 4, 7 },
  { 2, 0, -4, -8, 5, 2, 7, -5, 5, -8, -4, -1, 12, 2, 12, -13,
    -9, 0, 1, -12, 9, -43, 1, -5, 12, 1, 3, 6, 1, -1, 3, -2 },
  { 6, -2, -1, 1, 0, 4, 8, 14, 4, -7, -23, -5, 23, -17, -6, -15,
    -8, 7, 10, -1, 7, -16, 4, -6, 2, 3, -3, -3, -1, 8, -1, 4 },
  { 10, 4, -4, 1, 7, -3, 2, 11, 4, -6, -3, 8, 5, 4, 1, -45,
    -6, -4, 4, 2, 1, -14, -10, 1, 1, 6, 2, -8, -1, -3, 3, 3 },
  { 1, -1, 2, -3, -8, 9, 3, 3, -2, -5, -8, 8, 7, -7, -4, -6,
    5, -9, 11, -2, 46, -5, -1, 9, -2, 0, 3, -5, -3, -5, 7, 0 },
  { -4, 1, -2, -1, -11, 11, 8, -3, -2, -10, 0, 4, 9, 9, -17, -17,
    -34, -4, -5, -7, -3, -12, -3, 11, 18, 3, -2, -5, -18, -5, -3, 6 },
  { 7, -5, -3, 1, -4, -3, -5, -1, 2, 5, -2, 3, -10, 12, -18, -5,
    -10, 12, -9, 4, -6, 2, 0, 16, -17, 15, 14, -12, -10, -2, -9, -1 },
  { 4, -5, -3, -5, -3, -1, 7, 18, -7, 12, 3, 5, -8, -4, -20, 1,
    -25, 1, -8, 13, -10, 8, -19, -1, -8, 10, 6, -9, -1, 0, 12, 4 },
  { -4, 5, 0, -1, 2, 5, -8, -2, -6, 4, -8, 9, 3, 2, -7, 4,
    -25, 13, -23, 10, 14, 15, -11, 3, -18, 4, 16, -4, 1, -10, -10, 3 },
  { 5, -3, -1, -3, 4, 1, -3, -4, -5, 1, -12, 14, -7, 11, -15, 6,
    -6, 24, -4, 13, -1, 15, -13, 8, 3, 7, -5, 2, 2, 0, 3, -7 },
  { -3, 1, 0, 8, 6, -1, 6, 5, -5, -2, -12, 4, 0, -2, -3, 5,
    -6, 0, -8, 9, -10, 4, -28, 12, -20, 11, -13, 7, -18, 1, -11, 1 },
  { 1, -4, -15, 5, 0, -13, -5, 13, -11, 4, -4, -5, 5, -14, -16, 0,
    -14, 5, -20, 12, 10, -7, -5, 6, 6, 22, 6, -4, -2, 3, 8, 11 },
  { 13, -11, -2, 16, 16, -7, 0, 20, -7, -1, 0, 5, -9, 12, -2, -5,
    -22, 5, -10, 12, -6, 11, 9, 21, -8, 15, 4, 0, -8, -4, -4, 10 },
  { 18, -4, -13, 0, 1, -15, -1, -3, 2, 10, -1, 6, 1, -4, -20, -5,
    -8, 6, -8, 17, -5, 5, -10, 8, -22, 6, -5, -2, 8, -17, 8, 2 },
  { 1, -2, -9, 6, -31, -8, -8, 8, 0, 5, -9, -4, 2, 3, -12, 11,
    -18, 10, -5, 3, -11, 13, -6, 11, -3, 12, -7, 3, -9, -1, 2, 11 },
  { -9, -6, 21, -8, -15, 4, -11, 12, -11, 17, -1, 2, -6, 0, -15, 13,
    -12, 19, 0, 2, -6, -3, -9, 10, 3, 17, -2, 5, -10, -3, 0, 1 },
  { 4, -6, 5, -10, 1, -5, 1, 0, 0, 0, 2, 7, -2, 2, -2, 0,
    -4, 3, -4, 1, -12, 6, -49, 16, -10, 13, 0, -2, 8, 6, 1, 8 },
  { 5, -8, -7, 9, 13, -5, 7, 0, 10, 11, -4, -3, -1, 13, -14, 6,
    -15, -6, -14, 16, 15, 1, -18, -4, -20, 20, -7, -1, -9, -2, -10, 10 },
  { -12, 4, 0, 10, 0, 3, 8, 4, -27, -1, -2, 19, -4, 2, -13, 3,
    1, 9, -12, 1, -22, 19, -5, 4, -9, 12, 2, -9, -8, 11, -3, 7 },
  { 4, -5, 11, -6, 17, -17, 5, -4, -2, -6, 1, -5, 2, 4, -14, 6,
    -20, 19, -20, 12, -21, 5, -14, 13, -2, 11, 4, -3, 0, -10, -4, -2 },
  { -2, -1, -3, 8, -9, -7, -22, -3, -24, 13, -2, 10, -15, 5, -9, 4,
    -7, 0, -5, 15, -8, 11, -13, 6, -4, 19, -8, 12, -4, 6, 9, 7 },
  { 2, -3, 2, -1, 0, 3, 1, 2, 1, -4, -2, -3, 1, 5, -12, 6,
    -16, 14, -23, 10, -14, 17, -15, 16, -2, 9, -25, 9, -10, 16, 4, 9 },
  { -3, 7, -8, -3, 2, 2, -4, -8, -9, 10, 3, -11, 25, -10, -28, 27,
    -9, 7, -13, 9, -2, 4, -12, -8, -14, 6, 7, -10, 3, 3, -3, 5 },
  { -8, -3, 1, -10, 8, -3, -9, -4, 13, 7, 2, 4, -10, 4, 3, 7,
    -18, 2, -22, 15, 4, 20, -7, 5, -6, 13, -1, 4, -7, -6, 6, 13 },
  { -2, 3, 0, 2, -4, -2, 0, 0, 1, 2, -2, -5, 0, 1, -4, 0,
    -2, -3, 1, 2, -1, 2, -8, -1, -24, 68, -3, 8, 3, 3, -1, -1 },
  { -15, -2, -9, -7, -1, 8, -14, 8, 3, 6, 0, -1, -8, 8, -23, 2,
    -14, 17, -15, 8, -4, 7, -18, 0, -8, -3, -1, -4, -10, 4, -1, 4 },
  { 8, 0, 2, -7, 0, 5, 1, 3, -11, 4, -8, 14, 3, 20, 1, 26,
    -11, 13, -13, 20, -2, 0, -8, 2, -6, 6, -1, 9, 3, -6, -3, 10 },
  { 5, 0, -1, -7, 10, 1, -3, 5, 4, 7, -5, -1, -3, -1, 12, -3,
    -15, 7, -9, 22, -19, 8, -9, 4, -23, 13, -14, 6, -6, -14, -4, 7 },
  { 14, -5, -8, -10, 25, 3, -23, -7, -28, 0, -1, -9, 4, 1, -13, 20,
    -8, 10, -16, 8, 12, -13, -21, 5, -13, 11, -2, 1, 12, -7, 2, -10 },
  { -5, -4, 9, 5, -6, 35, -7, 8, 15, 2, -1, -9, -6, 2, -18, 7,
    -15, 6, -3, 2, 8, 12, -30, 7, -4, 20, 2, 6, 13, -6, -4, 0 },
  { 1, 8, -9, 9, -5, 12, -9, 16, -9, 16, -17, 14, -13, 15, -18, 14,
    -15, 17, -12, 14, -13, 7, -16, 13, -9, 5, -11, 10, -9, 6, -12, 13 },
  { -10, -4, 5, 3, 1, 6, 8, -14, -5, 15, 7, 4, 8, 7, -22, 8,
    -7, -8, -15, 26, 1, 13, -3, 17, -5, 9, -2, 4, -6, 3, -8, 9 },
  { 8, -3, 2, 3, 3, 1, -2, -1, -11, 8, -4, 0, -6, -5, -1, 13,
    -37, 9, 1, -6, -10, -2, -10, 11, 8, 13, -3, -2, -6, 8, -4, 13 },
  { 3, 2, -3, -4, -4, 7, -8, 9, -8, 9, -20, 12, -19, 15, -18, 17,
    -15, 7, -1, 20, -11, 6, -6, 3, 1, 9, 2, -14, -2, -2, 2, 1 },
  { -7, 1, -1, -3, -6, 4, 4, -3, 3, -1, 5, -4, 3, 2, -1, 9,
    -59, 5, -4, 30, 3, 3, -2, -3, -1, 2, 2, 1, -1, -1, -2, 1 },
  { 0, -3, 2, 0, -1, -8, 0, 2, -3, 4, -4, 1, 10, 6, -6, 8,
    -7, 4, 10, 11, -41, 27, -20, 3, -3, 8, 1, 11, -5, -8, 0, 4 },
  { 5, 1, 4, -2, 1, 2, -1, 6, -7, 2, 11, 4, 0, 0, -8, 7,
    -10, 0, 0, 8, 2, 10, -1, 1, -2, 44, -2, -21, -12, -3, -1, 2 },
  { -4, 4, -2, -2, 6, -8, 2, 1, -10, 14, 8, 6, 5, 1, -2, 4,
    -13, 4, 2, 5, 10, -2, -21, 32, -3, 18, 9, -6, -9, -9, 10, 2 },
  { 9, -16, -6, -2, 1, 4, 22, 2, -2, 1, -3, -2, -9, 3, 16, 19,
    -24, -6, -6, -5, -8, -7, 8, -7, -1, -12, 5, -3, 0, 4, 2, -3 },
  { 10, 3, -16, -4, -1, 13, 4, 4, 1, -3, 1, -6, -14, 18, 3, 8,
    -8, -28, -16, 4, 4, 2, 12, 7, 9, -4, -4, 5, -1, -1, 2, 2 },
  { -5, -13, -22, -3, -8, 21, -2, -9, 21, -4, -9, 5, -8, 15, 5, 1,
    -5, -9, -7, -2, -5, -5, -1, -5, -5, -5, 3, 10, -4, 0, -7, -2 },
  { 5, -10, -18, 2, 20, 4, 13, -10, 8, -15, -11, -3, -1, 16, 10, 9,
    -8, 6, 7, -5, 6, 11, 5, 17, -4, 7, -11, 5, -3, -6, 2, 1 },
  { 3, -5, -19, 1, 1, -3, -2, -25, -11, -17, 0, -13, -4, 10, 10, 2,
    -5, 4, 0, 3, -3, -5, -10, -2, 13, -22, 0, 3, -11, -5, 7, -1 },
  { 12, -14, -29, 6, -1, 10, 7, -17, -12, 14, 3, 9, -9, 9, 7, 6,
    -3, -13, 0, 5, 3, -1, -6, -1, 0, 2, 4, -12, -5, -1, 2, 11 },
  { 12, -15, -7, -2, -12, 17, 20, -16, -2, -12, -6, 15, -6, 12, 11, 9,
    7, -6, 7, -4, -19, 6, 2, 2, 3, -11, -10, -4, -5, -3, 3, 2 },
  { 11, -22, -6, 0, 8, 18, 3, -11, -4, -7, -15, -17, -12, 6, 16, 4,
    -9, 4, -5, 3, 6, -16, 10, -7, -7, -3, 5, 0, 1, -15, -4, 5 },
  { 12, -22, -16, 5, -6, 8, 12, -4, -9, -17, -11, 3, 5, 8, -17, 0,
    11, -4, -13, -6, 2, -1, -1, 3, 3, -11, -12, -1, 1, 1, 12, -2 },
  { 8, -10, -33, -5, -3, -6, 1, -7, -8, -4, -6, -1, 5, -4, -6, -12,
    -16, -8, 11, 8, -14, 7, 12, 11, 4, -14, -3, 6, -7, -5, -3, 3 },
  { 0, -8, -7, 2, -4, 24, 2, -9, -11, -3, -7, 11, -12, 17, 1, -1,
    3, -5, -7, 12, 4, 11, 0, 3, 2, -18, -3, 4, 7, -6, 3, 15 },
  { 10, -15, -16, -2, -4, -9, 7, -15, -6, 2, -16, 13, -8, 7, 19, -21,
    -4, -12, -9, -3, -3, 6, 11, -3, -1, -19, 3, -7, -9, -4, 3, -6 },
  { -5, -10, -21, 0, -3, -7, 18, -21, 15, -5, -12, -4, -13, 2, 6, -9,
    -9, -11, -4, 13, -3, 6, 4, -1, 7, -9, -4, 9, 5, 2, 6, 3 },
  { 15, -1, -27, -2, 10, 3, 7, -8, 9, -2, 7, 1, -2, -5, 18, 9,
    -11, -17, -2, 7, -9, 11, 10, 0, -8, 6, -16, -3, 2, -7, 3, 11 },
  { 4, -9, -39, 19, 6, -13, 13, -5, -5, -15, -2, 9, 0, 4, 14, 6,
    -10, -4, -5, 2, -4, -2, 5, -11, 3, 3, -2, -2, -7, 9, 7, -10 },
  { 5, -11, -8, 10, -2, 12, 16, 0, 12, -2, -6, 8, 14, 8, 7, 1,
    18, -30, 4, 10, -4, -6, 2, -11, 9, -10, -8, 5, 0, 0, -7, 6 },
  { -1, -16, -10, 11, 0, 13, 12, -4, -4, -5, -21, 12, 4, 13, 14, -7,
    6, -16, -13, 8, 2, 9, 15, -12, 1, -9, -22, 10, -9, 9, 9, -7 },
  { 4, -12, -27, 1, -2, 11, 15, 3, 14, -14, -9, 0, -9, 16, 22, 10,
    16, -10, 5, -5, -9, 1, 1, 6, 6, -4, 2, -17, -5, -6, -15, -1 },
  { 7, -12, -17, 1, -9, 5, 20, -7, 3, 23, -8, -8, -8, -1, 13, 17,
    -7, -13, 4, -4, 7, 14, 8, 11, -3, -3, 4, 0, 4, 6, -1, -9 },
  { 7, -15, -15, -4, 10, 12, 3, -13, 6, 14, 9, -8, -15, 14, 23, -5,
    -10, -5, 1, 15, -10, -7, 1, 9, 4, -13, -10, 10, 7, -3, 2, 3 },
  { 4, -10, -14, 0, 3, 4, 0, -9, -3, -4, -11, 2, -17, 8, 2, 15,
    6, -12, -12, 15, -5, 17, 18, 3, -3, -3, -4, -6, -8, 13, 4, 10 },
  { -2, -18, -26, 10, -4, 10, 13, 4, -4, -16, -7, -17, -3, 5, -4, 2,
    -15, -10, -1, -8, -7, -3, 2, 2, 8, -10, -7, 2, 2, -4, 4, -1 },
  { 4, -19, -5, -1, -1, -6, 2, -8, 10, -16, -28, -6, 8, -1, 11, 28,
    2, -10, -4, 6, -6, 6, 11, 15, -4, -2, 7, 3, 7, -7, 4, 1 },
  { -3, -6, -10, -5, 13, 18, 10, -15, -5, -3, -13, 5, 1, 2, 18, -5,
    -10, -10, -7, 4, 2, 1, 5, 4, 2, 5, 4, 8, -9, -17, 7, 7 },
  { 20, -12, -2, -4, 5, 14, 7, -11, -1, -16, -6, -4, -11, 17, 14, 0,
    -8, -10, -8, 10, 3, 5, 10, -16, 3, -8, -14, 10, 3, 9, 0, 3 },
  { 12, -10, -36, 0, 7, 15, 2, -16, 2, -1, 0, -1, 5, 4, 5, -3,
    1, -10, 5, -1, -15, -3, -12, 12, 2, 5, -1, 5, 6, -3, -2, 2 },
  { 17, -15, -31, 23, -4, 15, -2, -3, 6, -7, -5, 1, -12, 4, 6, 8,
    -10, 8, 3, 5, -4, 1, 5, 3, -1, -4, -3, 1, 10, -4, -2, -2 },
  { 6, -18, -5, 12, 10, 12, 14, -11, 15, 2, -9, -6, -5, -2, -9, 4,
    -5, -28, -4, 14, 0, -16, 9, 14, -1, 3, -4, -4, 2, 1, 0, 4 },
  { -5, -14, -31, 8, 16, 7, 13, -13, 5, 6, -16, 10, -5, 2, -2, 2,
    14, -5, 8, -5, 7, -16, 6, -13, -5, 0, -5, 8, -3, -1, 4, 3 },
  { 1, -2, -1, 0, 6, 5, 2, -4, -3, -1, 0, 1, 4, 2, 43, 28,
    -12, -35, -2, -2, -7, -1, 0, 2, -1, -2, -2, 1, -4, 0, -2, 3 },
  { 2, -9, -22, 12, 3, 3, -7, -4, -19, -22, -14, -4, -1, 21, 9, -3,
    -15, -16, -13, 1, -11, 4, -9, 1, -7, -1, -1, 0, -2, 9, -13, -3 },
  { -1, -3, -23, 0, 2, 12, 3, -9, -4, 7, 3, 9, -10, 1, 27, 28,
    0, 9, -15, -2, -2, 1, 6, 8, -8, 7, -3, 20, 0, 0, -1, -6 },
  { -1, 11, 8, -2, 1, 5, -6, -1, 4, 2, -4, 0, -1, -5, 4, -6,
    -10, -12, 19, 1, -7, 9, -8, -9, -16, -11, -2, 12, 14, 4, 4, 34 },
  { 17, 7, -6, 1, 4, -10, -5, 4, -11, 3, -18, 4, 14, -13, -3, 1,
    0, 0, -11, 0, 7, -17, -4, 4, -11, -6, -8, 18, 0, 0, 0, 26 },
  { -6, -7, -1, -1, 11, -8, 1, 3, 2, 11, -6, -6, 10, -3, 1, -3,
    7, 4, -12, -8, 0, -9, 8, -22, -5, 0, -6, 22, -2, 11, -13, 24 },
  { -3, 4, 0, 3, 9, 10, -1, 3, -9, -12, 1, -5, 18, 0, -3, 8,
    25, 15, -8, 2, 2, -2, 4, 8, 9, -1, -5, 10, -3, 1, -1, 23 },
  { -5, 2, -9, -1, -3, 0, 3, -1, -10, -4, 0, -13, 16, 9, -1, -14,
    2, 6, -2, -6, -5, -2, -7, 7, 5, 3, 11, -2, -14, 0, -9, 30 },
  { 4, 6, 6, 5, -3, -1, 4, 5, 10, 0, 5, -4, 7, -11, 14, 14,
    7, 34, -9, 0, -10, 22, -7, -1, 7, -9, 2, -8, 0, -7, -5, 29 },
  { -4, 3, -1, -4, -3, 5, 1, -4, 0, 2, 4, 2, 1, -1, -10, 1,
    6, -6, -4, 1, 4, -3, -3, -5, 0, 3, 7, -12, 0, -2, -10, 55 },
  { 5, 9, -1, 0, 4, 9, -21, -9, 4, 2, 6, -7, 11, -7, 1, -5,
    0, -4, 2, -3, -13, -8, 0, -9, -4, 2, 16, -2, -15, -7, -11, 31 },
  { 8, 2, -1, 0, 3, -5, -5, 5, 1, -1, -9, 1, 0, -6, -2, -1,
    5, 2, 0, 0, 12, 20, -19, 1, 8, -12, -11, 0, 6, -5, 2, 31 },
  { -1, -1, -2, 1, -1, 3, -9, -5, 8, -2, 5, -1, 0, -2, 4, -2,
    -3, -12, 0, -2, 3, 0, 9, 4, -1, 21, -8, 3, -4, 9, -6, 30 },
  { -4, 0, -7, 17, 10, -12, -2, -10, -12, -3, 10, 0, 11, -4, -13, -3,
    5, 6, 10, 7, -8, 0, -7, -13, 1, 0, -2, 7, -12, 4, -3, 24 },
  { -13, 9, 4, -2, 2, -4, -14, -1, -3, -5, -10, 4, 13, -2, 5, 13,
    8, 3, -2, 1, 5, -6, 7, -18, -10, 1, -1, 5, 4, 1, 0, 25 },
  { -5, -1, 18, 12, 8, 8, -16, -1, 1, 1, 1, -4, -5, 3, 3, 4,
    4, -11, -12, -16, -6, 2, 12, -13, 0, 9, 7, 9, -9, 0, -10, 24 },
  { -4, 1, -3, 0, 2, -4, 4, 1, 5, 0, -3, 2, -3, -2, 2, -1,
    1, 4, -1, -2, -2, 1, -1, -1, -4, -1, -4, -2, -6, 6, 12, 69 },
  { 8, 5, 11, 0, -15, -4, 13, 6, 0, -4, 9, 1, -5, -3, 15, 0,
    1, 6, -5, 0, 1, 6, 5, 8, 0, 7, 1, -1, -4, -11, -9, 41 },
  { -4, -9, 32, -6, 0, 7, -4, 6, -6, 1, -6, -2, 4, -8, -5, -3,
    -16, -1, -2, -6, 1, 15, 0, 21, 3, -3, -4, 3, -12, 16, 2, 27 },
  { -6, -5, 1, -9, -5, 3, 7, -3, 5, 5, 14, 13, 20, -7, -1, 12,
    -1, 10, -11, -11, -7, -4, -14, 7, -14, 13, 22, 18, -1, 0, 14, 28 },
  { -8, 3, -2, 0, 5, 6, -1, -4, 1, 3, -7, 3, 1, -15, 4, -9,
    22, -10, -9, -4, 1, 8, -4, 9, -15, 2, -6, -4, -16, 12, -10, 23 },
  { 0, 0, 2, 0, -1, 3, -3, -1, 3, -5, 7, 1, 5, -5, -8, 1,
    13, -15, -5, -7, 12, -6, -2, 3, 10, -5, -8, 17, -5, -11, -14, 23 },
  { -7, -4, 6, -4, 5, -6, -5, 2, -4, 11, 9, -4, 2, -2, -4, 6,
    15, 3, -3, 18, -15, -2, -6, 3, 3, -20, 17, 11, -4, 2, 3, 29 },
  { 6, 1, -6, 2, 3, 0, 0, -3, 3, 3, -1, 3, -4, -6, -6, -7,
    -3, -2, -7, -2, -4, 5, 3, -5, -20, -13, -4, 10, -14, -29, 14, 37 },
  { 3, 4, 3, -6, -4, 5, 0, 3, 2, 3, 0, -2, 4, 0, -3, -5,
    -4, 4, -4, 4, 4, 3, 1, -4, -4, -9, -14, 20, -30, 3, -18, 33 },
  { 0, 2, 5, -2, -4, -2, -1, 2, -6, -3, -2, -2, 2, -5, -1, 4,
    3, 2, -3, 0, -1, -1, -10, -7, 2, -4, -18, 2, -37, -1, 12, 40 },
  { -7, 2, -1, 0, -2, 4, -8, 1, -4, 12, 7, 4, 15, -7, 1, -9,
    18, 0, 12, -17, -3, -1, 0, 0, 0, 2, -6, 0, -4, -3, -1, 26 },
  { -6, 4, 8, -5, -6, -2, 2, -1, 1, -1, -15, 8, 7, -1, -17, -4,
    1, 5, 6, -11, -6, 14, 17, -5, -15, 11, 8, 0, -3, -15, -6, 28 },
  { -1, 0, 0, 0, 1, 0, -1, 0, 1, 3, 2, -2, 3, -1, -1, 2,
    2, -1, -1, -7, 1, 2, -9, 0, -1, -4, -18, 7, -10, 49, -13, 32 },
  { -1, -3, 4, 1, 2, -5, 1, -7, -1, 5, -9, 4, 4, 25, 1, -1,
    2, -5, 2, -7, 17, -2, 10, -5, 0, 2, -15, 3, -9, 7, -9, 30 },
  { -5, -1, 0, 2, 1, -1, 2, 5, -33, 3, -5, 14, 11, 7, 5, -3,
    2, -8, -4, -2, -7, -6, 4, -8, -1, -8, 2, -2, -8, -1, -4, 27 },
  { -1, 0, -1, -2, 1, -1, -2, -1, 2, 0, 1, 2, 2, 4, 1, 3,
    4, 2, 1, -7, -4, 1, -3, -4, -35, -25, 17, 10, -3, -26, -7, 32 },
  { -5, 1, 6, -2, 6, 6, -9, 3, -1, -4, 5, -4, -2, -2, -9, 2,
    -5, 2, 2, 4, 3, 5, -5, -16, -31, -12, -11, 2, -19, 20, -2, 21 },
  { -5, 2, 7, -7, -7, 5, -7, 2, 0, 0, -4, 3, -1, 0, -1, -2,
    0, -3, 5, -11, -8, -3, -7, -7, 28, -11, -7, 0, -16, -11, -4, 29 },
  { 2, 1, -3, -2, -1, 3, 4, 0, 1, 0, -1, -5, 4, -5, -12, 2,
    -2, -5, -22, -2, -1, 11, 8, -7, -12, 0, -34, 6, -5, 11, -8, 19 },
  { -1, -3, 5, 11, 18, -2, -2, -5, -2, 4, -1, 8, 5, -6, 1, -1,
    2, 8, 4, -5, -8, -2, 5, -18, 7, 12, 7, 19, -18, 2, -6, -13 },
  { 9, 0, 0, 5, 4, 3, -6, 4, 1, -4, 5, -1, -4, 8, 8, 6,
    -8, -6, 0, 6, -3, 3, 5, -3, 17, 31, 16, 10, -13, 0, -9, -19 },
  { 12, -10, 2, -2, -2, -1, -3, 6, -12, -5, -2, 14, -16, 4, 12, 12,
    17, 4, 7, -16, 7, -6, 11, 7, 7, 2, -25, 23, -24, 5, -7, -9 },
  { 10, 4, 13, 10, 10, 3, -6, 3, 3, 2, -1, -6, 8, 4, 10, 0,
    1, 2, -4, 2, -3, -8, 0, -1, 9, 9, -10, -3, -29, 1, -1, -27 },
  { 2, 2, 0, 7, 9, -2, -10, -1, -1, 1, -9, -5, 8, 4, 1, 2,
    -10, 1, 13, 12, -3, 15, -9, 2, -7, 1, -10, 23, -20, -18, -9, -15 },
  { -3, -5, -1, 8, 0, -5, -1, 4, 7, -1, -7, 2, -8, -5, 11, 7,
    -6, 3, -3, -9, 7, 9, -22, 1, 6, -4, 14, 27, -25, -14, 3, -5 },
  { 1, 3, 8, 4, 7, 6, 12, -17, -15, 1, -8, -10, 7, -14, -8, 6,
    -2, -2, -11, -11, -7, 13, -2, -2, 4, 5, -5, 13, -23, -6, -17, -8 },
  { -5, 4, -14, -5, -4, -5, 6, 5, -8, -5, -2, -11, -7, -12, 3, -11,
    2, -6, 4, -10, -5, -7, 14, 5, 23, 11, 7, 12, -16, -6, -4, -16 },
  { 5, 6, 2, 5, -2, -5, -5, -6, -5, -19, -13, -1, -3, -13, 5, 0,
    6, -2, -2, -6, -7, -7, -1, -9, 4, 14, 17, -12, -27, 3, 0, -1 },
  { 7, -1, 9, -10, 8, 2, -7, -2, 5, 2, -3, -7, 3, 0, 6, 4,
    12, 5, 11, 14, -13, -1, 8, 1, 13, 9, 12, 12, -18, -14, -11, -16 },
  { -7, -5, -6, -5, 0, -1, -3, 2, 2, 1, 4, 9, 2, 3, 5, -2,
    2, 1, 8, 0, 3, 0, -2, 2, 1, 7, 29, 0, -36, -5, -9, -21 },
  { 14, -6, -9, 0, -1, -8, -8, -11, 2, 2, -9, -12, 12, -4, 5, 3,
    -5, -9, 11, -1, -3, 12, -21, -3, 12, 5, 3, 11, -18, -15, 1, -2 },
  { -1, 3, -9, -3, 7, -7, -18, 2, 4, 12, -10, 2, 8, -3, -14, 13,
    17, -5, 5, -9, 13, -3, -7, -18, 17, -2, 5, 7, -20, -3, -6, -11 },
  { -3, 3, 3, -1, 1, -6, -5, 1, 5, -3, -14, -6, -5, -8, 14, -6,
    7, -1, 5, 1, 15, -1, -7, -4, 6, -11, 9, -2, -37, 16, -7, -3 },
  { -1, 0, 6, 1, -3, -9, 0, 11, -8, 2, -2, 0, 5, 2, 12, -10,
    10, 13, 2, 7, -6, 2, -10, -10, 21, -5, 5, 5, -12, -23, 3, -14 },
  { 6, 0, -2, 1, 0, 1, 0, -4, 1, 1, 8, -2, 2, -5, -2, 1,
    8, -4, -1, -1, 4, -1, 2, 6, 32, 1, -5, -20, -40, -4, -18, -14 },
  { 2, 2, -7, -2, 4, 4, -1, 2, 0, -2, -4, -7, 3, 5, 0, -5,
    1, 2, -6, 4, -1, -2, -1, -15, 8, 3, 9, 46, -7, -18, 6, -11 },
  { 5, 5, 16, 21, 3, -11, -4, 11, -12, 2, 4, -12, -1, 11, 8, 1,
    -4, 11, -11, -21, 1, 1, -11, 3, 13, 1, 5, 12, -25, 1, -3, -2 },
  { 1, 6, -7, 4, 2, 3, 1, -5, 8, 9, -15, 3, -3, -14, 17, 4,
    -8, 14, -2, -8, -4, 5, 8, -7, 8, 9, 7, 6, -29, -17, 8, 4 },
  { -7, -7, 4, 0, 13, 1, 0, 4, 4, -16, -10, -7, 5, 9, -15, -10,
    -10, 8, -4, -1, -11, -1, -10, -15, 3, 3, 14, 10, -19, 2, -18, -12 },
  { -4, 0, 2, 0, 5, -2, -9, 0, 4, -4, 2, -1, -2, 2, -4, 9,
    2, -6, -4, -2, -1, -3, -3, -1, 2, 5, -1, 11, -24, -44, -9, -15 },
  { -1, -10, 6, 21, 11, 15, -7, 10, -14, -9, -8, -8, 4, 6, 19, 1,
    -6, 1, -5, -17, -8, -10, 9, 5, 11, 18, -1, 10, -16, -7, -9, -8 },
  { 3, -5, 0, 0, -2, -2, -6, 4, -4, 1, -1, 0, 7, -3, 4, -4,
    -7, 7, 17, -20, 6, 4, 1, -6, -12, 31, 13, 19, -14, -10, -7, -2 },
  { -2, 6, -10, 3, 9, 6, -14, 15, 2, -5, 2, -11, 9, -8, 4, 6,
    20, -15, -3, -3, -1, 32, -21, 6, 1, 9, 11, 17, -19, 6, -1, -3 },
  { 8, 10, -2, 0, -8, -16, 7, 7, 6, 10, 4, -14, 7, -6, 21, -7,
    10, 5, 5, 0, -7, 2, -6, 0, -7, 11, -9, 15, -20, -7, -11, 2 },
  { 0, -7, 5, 2, 0, -3, -6, -4, -2, -1, -4, -5, -13, -1, 27, -9,
    -6, -11, -7, 1, 11, -4, -4, -14, -2, 11, 6, 10, -19, -6, -15, 2 },
  { 0, 7, -1, 2, -7, -15, -2, -3, 13, -5, -5, 12, 3, 0, 5, -5,
    -22, 2, 7, 22, 13, 0, -1, 2, 3, 2, -7, 7, -27, -4, -4, -12 },
  { 11, 1, -16, 6, -15, 1, 3, 2, 0, 2, -3, 2, 5, -2, -5, 9,
    5, -3, 3, -2, -11, 3, 9, 6, 9, 3, -1, 12, -41, 8, -6, 9 },
  { 3, -7, 3, 2, 5, 5, 0, -1, 1, 3, -5, -2, -13, 7, -1, -2,
    -2, -6, 4, -6, 0, 2, -2, 2, 4, 1, -4, 1, -47, -21, 7, -6 },
  { 3, 16, -7, 13, -4, -2, 10, -3, -1, 18, -13, 7, -13, -4, 8, 4,
    8, 9, -5, 13, 8, -5, 3, -6, 7, 18, -8, 10, -25, -3, -12, -12 },
  { 1, -1, -1, 0, 2, 5, -5, -3, 0, -5, -1, 0, -4, -8, -2, 3,
    2, -2, -17, -6, -4, 1, 33, -6, -20, -6, 8, 31, -26, -8, -1, -4 },
  { 3, -3, -3, 5, -3, -2, 1, 7, 0, 3, 6, 3, 6, -2, 9, 15,
    -10, -3, -15, -5, -3, -4, -6, -30, 17, -8, -2, 2, -20, 0, -8, -2 },
  { -2, -1, -1, -1, 3, -5, -2, -3, 4, -2, 0, 5, 8, -3, 1, -4,
    1, 1, -3, 4, 4, -14, 3, 11, -5, 3, -3, 7, -3, 13, 23, -16 },
  { 2, -6, 1, -3, 5, 0, -6, -11, -7, -4, -1, 2, -7, -1, -1, 7,
    1, -2, 6, 12, -6, 8, -13, 17, 25, -23, -19, -7, -12, 9, 16, -17 },
  { 9, 4, 4, 4, -3, -1, 6, -2, -3, 0, 13, -4, -7, 14, 1, -7,
    0, -5, 3, -19, -3, 5, 3, 9, -1, 9, -13, 13, -17, 4, 21, -26 },
  { 0, -5, 0, 0, -4, -5, 2, -6, -4, 5, -7, 10, 0, 2, 0, -2,
    -2, 0, 4, -6, 7, -2, 6, 5, -5, 2, -12, 1, -29, 29, 27, 12 },
  { 9, -10, -22, 6, -1, -1, 9, -14, -12, -2, 1, -1, 10, -11, -16, 0,
    3, 11, 13, -14, -9, -2, -1, 6, 4, -14, 0, -10, -2, 16, 17, -11 },
  { 2, 0, -1, -2, 4, 3, -6, -2, 1, -1, 1, 3, -4, 1, 3, -4,
    -1, -1, 4, -1, 1, 0, 1, 6, -5, -7, 2, 1, -47, -3, 50, -17 },
  { 8, -4, -11, -7, 11, 11, 14, -7, 12, -7, 6, 2, 13, -6, -3, -2,
    -14, 6, 6, 6, 0, 2, -1, 5, -20, 2, -1, 4, -5, 6, 21, -11 },
  { -2, -9, 3, 0, -6, 7, 8, -8, 1, -3, 4, 1, 5, -2, -3, -7,
    4, 7, -12, -9, -2, 10, -6, 13, 6, 5, 20, 2, -15, 9, 28, -7 },
  { 0, -5, -6, -6, -6, 1, -6, 6, -2, 4, 8, -3, 12, -1, -4, -2,
    6, 16, -14, 9, -14, -2, -8, -27, -3, 18, -1, -7, -3, 8, 23, -23 },
  { 1, 4, -9, -1, -5, 10, -2, 1, -11, 1, -9, 4, 7, 14, -9, -2,
    -3, 2, -5, -1, -6, -10, -7, 11, 20, 2, 3, -19, 3, 15, 30, -9 },
  { 7, 2, -14, -4, 0, -2, 5, 2, 5, -2, 8, -3, -7, 6, 6, -11,
    -14, 1, 10, -1, -7, -8, 1, 10, 3, -6, -15, -12, -17, 4, 30, -6 },
  { 4, 2, 1, -2, 3, 0, 1, 0, 2, 0, 1, 6, -7, 0, 3, 4,
    4, -4, -2, -5, -2, 2, -1, -2, 0, -2, -11, -7, -3, 42, 24, -14 },
  { 4, 1, 3, 2, 0, -2, -3, -2, 2, -1, 4, 11, -2, 2, 3, -4,
    -5, 9, 2, -4, -9, 5, 8, -1, -7, 1, 24, -13, -28, 20, 15, -22 },
  { -3, 7, 6, 3, -2, -5, -10, -2, -2, -1, -6, -6, -2, -14, -16, -6,
    -5, 0, 18, 0, 9, 1, 7, -13, -5, -6, -9, 11, -15, 9, 22, -11 },
  { 9, -2, 6, 5, 2, 9, -10, 1, 1, 5, -4, 12, 2, 2, -10, -7,
    -4, -6, 7, 9, 6, 15, 6, 6, -10, 10, 5, -13, -5, 6, 24, -12 },
  { 1, 3, -3, -3, 8, 1, -6, 2, -5, -3, 7, 2, 14, 6, 9, -6,
    -5, -4, 27, 7, -3, 8, -6, 3, -8, 8, 22, -5, -6, -2, 22, -17 },
  { -2, -2, 3, 10, 9, 9, 12, -15, -1, -11, -13, 3, -2, 1, -3, -11,
    7, 9, 16, -3, -10, -5, -5, 1, 8, -3, 9, 9, -5, 3, 31, -12 },
  { 7, -5, 10, -4, -8, 2, 16, -2, 10, 10, -3, -2, 3, -8, -3, 3,
    -13, -6, 15, 20, -9, -3, -12, 1, -2, -16, 8, 8, -1, 16, 22, -5 },
  { 5, -3, -15, -2, 12, -8, 8, -5, 2, -8, 20, -18, 14, -4, 3, 3,
    7, -13, -16, 1, -10, 7, 16, 7, 4, -14, -4, -5, -9, 8, 23, -6 },
  { 5, -4, -5, -4, 1, 8, 4, -7, -5, 8, 10, 6, -6, -10, -2, 6,
    9, -17, -14, 11, 12, -3, -13, -7, 2, 18, 3, -25, -16, 18, 22, -5 },
  { 5, 6, -7, -20, -4, 2, 8, 4, -24, -4, 1, 4, -5, -2, 1, -10,
    -2, 9, 3, -4, -3, -4, -4, -4, 10, 10, 3, 0, -6, 25, 21, -11 },
  { 0, 7, -1, 14, -6, -4, -10, 5, 4, 4, 4, -5, 3, 4, -1, -7,
    8, -19, 0, 6, 2, 3, -18, -3, -6, 2, 8, 14, -26, 22, 27, -13 },
  { -2, -6, 7, -5, 12, -7, 8, -1, 3, -2, 4, 1, 8, -2, 0, 14,
    6, -5, 6, -4, -7, 7, -21, 8, 1, 8, -9, -4, -3, 11, 25, -13 },
  { 4, 4, -1, -6, 4, 9, -8, 1, -3, -10, -2, 0, 15, -9, -16, 11,
    1, 1, 6, 3, -9, -5, 16, 26, 1, -14, 1, -3, -14, 7, 15, -9 },
  { -12, -2, -9, -13, 2, 6, 14, 0, 1, 0, -1, -13, 0, 10, -1, 6,
    9, -7, 8, 8, 19, 6, -1, 9, 10, -4, 1, -7, -22, -2, 29, -7 },
  { 2, 4, 13, -12, -8, -4, -5, 13, 12, -5, -3, -3, -4, 1, -1, 10,
    15, -6, -1, -11, -30, 4, 15, -1, 9, -7, 0, -2, -7, 10, 25, -16 },
  { 7, -15, -7, -7, -1, -5, -5, -11, -20, 10, 3, -10, -3, 5, 20, -4,
    0, -2, -2, 17, 2, 0, -3, 3, 6, 5, -1, -12, -3, 15, 22, -16 },
  { 4, -1, 3, 4, -5, 0, -1, -5, -24, -29, 4, -9, 1, -3, 0, 0,
    0, -4, 7, -4, -4, -4, 3, 1, -6, 5, -3, -5, -10, 3, 25, -10 },
  { -2, -1, -1, 4, 4, -1, 2, 0, -4, -4, 2, -1, -3, -1, -2, -2,
    1, -3, -5, -1, 2, -3, -4, -4, -3, 5, -9, 1, -11, 7, 46, -46 },
  { 0, -9, 3, 4, 4, 3, -5, -6, 5, -4, 4, -2, 1, 7, -4, -10,
    13, 1, 3, -6, 4, -4, 7, 2, -19, -25, -3, -16, -12, 16, 20, -1 },
  { 18, 6, 4, -12, 0, -14, 9, -6, -1, -4, -5, 2, 1, 12, 4, 2,
    7, 0, 2, 5, -11, -5, -2, 2, -4, 10, 0, -9, -7, 9, 25, -8 },
  { 5, 0, -6, 5, 6, 3, 3, -10, -5, 1, -1, 4, 3, -11, -8, 5,
    4, -5, 5, -5, -7, -5, 11, 5, 20, -8, -16, 21, -4, 27, 23, -5 }

################################################################################

TITLE
    libavcodec dca dca_downmix_coeffs

TYPE
    FLOAT

DATA
  1.000000000000000, 0.988553094656939, 0.971627951577106, 0.944060876285923, 0.917275935389780, 0.891250938133746,
  0.865964323360065, 0.841395141645195, 0.817523037943650, 0.794328234724281, 0.771791515585012, 0.749894209332456,
  0.728618174513228, 0.707945784384138, 0.687859912308808, 0.668343917568615, 0.649381631576211, 0.630957344480193,
  0.613055792149821, 0.595662143529010, 0.578761988349121, 0.562341325190349, 0.546386549881854, 0.530884444230988,
  0.515822165072306, 0.501187233627272, 0.446683592150963, 0.398107170553497, 0.354813389233575, 0.316227766016838,
  0.281838293126445, 0.251188643150958, 0.223872113856834, 0.199526231496888, 0.177827941003892, 0.158489319246111,
  0.141253754462275, 0.125892541179417, 0.112201845430196, 0.100000000000000, 0.089125093813374, 0.079432823472428,
  0.070794578438414, 0.063095734448019, 0.053088444423099, 0.044668359215096, 0.037583740428844, 0.031622776601684,
  0.026607250597988, 0.022387211385683, 0.018836490894898, 0.015848931924611, 0.013335214321633, 0.011220184543020,
  0.009440608762859, 0.007943282347243, 0.005623413251903, 0.003981071705535, 0.002818382931264, 0.001995262314969,
  0.001412537544623, 0.001000000000000, 0.000501187233627, 0.000251188643151, 0.000000000000000,

################################################################################

TITLE
    libavcodec dca dca_default_coeffs

TYPE
    8

DATA
    { { 13, 13 }, {  0,  0 }, {  0,  0 }, {  0,  0 }, {  0,  0 },
    { {  0, 64 }, { 64,  0 }, {  0,  0 }, {  0,  0 }, {  0,  0 },
    { {  0, 64 }, { 64,  0 }, {  0,  0 }, {  0,  0 }, {  0,  0 },
    { {  0, 64 }, { 64,  0 }, {  0,  0 }, {  0,  0 }, {  0,  0 },
    { {  0, 64 }, { 64,  0 }, {  0,  0 }, {  0,  0 }, {  0,  0 },
    { {  6,  6 }, {  0, 25 }, { 25,  0 }, {  0,  0 }, {  0,  0 },
    { {  0, 25 }, { 25,  0 }, { 13, 13 }, {  0,  0 }, {  0,  0 },
    { {  6,  6 }, {  0, 25 }, { 25,  0 }, { 13, 13 }, {  0,  0 },
    { {  0, 25 }, { 25,  0 }, {  0, 13 }, { 13,  0 }, {  0,  0 },
    { {  6,  6 }, {  0, 25 }, { 25,  0 }, {  0, 13 }, { 13,  0 },

################################################################################

TITLE
    libavcodec dcahuff scales_codes

TYPE
    16

DATA
    0x3AB0, 0x3AB2, 0x3AB4, 0x3AB6, 0x3AB8, 0x3ABA, 0x3ABC, 0x3ABE,
    0x3AC0, 0x3AC2, 0x3AC4, 0x3AC6, 0x3AC8, 0x3ACA, 0x3ACC, 0x3ACE,
    0x3AD0, 0x3AD2, 0x3AD4, 0x3AD6, 0x3AD8, 0x3ADA, 0x3ADC, 0x3ADE,
    0x3AE0, 0x3AE2, 0x3AE4, 0x3AE6, 0x3AE8, 0x3AEA, 0x3AEC, 0x3AEE,
    0x3AF0, 0x3AF2, 0x3AF4, 0x3AF6, 0x3AF8, 0x3AFA, 0x3AFC, 0x3AFE,
    0x0540, 0x0542, 0x0544, 0x0546, 0x0548, 0x054A, 0x054C, 0x054E,
    0x0558, 0x055E, 0x02AD, 0x0154, 0x0754, 0x03A8, 0x0056, 0x0028,
    0x00E8, 0x004A, 0x000B, 0x003B, 0x0013, 0x0003, 0x000F, 0x0005,
    0x0001, 0x0006, 0x0000, 0x0008, 0x001C, 0x0004, 0x0024, 0x004B,
    0x00E9, 0x0029, 0x0057, 0x03A9, 0x0755, 0x0155, 0x02AE, 0x055F,
    0x0559, 0x054F, 0x054D, 0x054B, 0x0549, 0x0547, 0x0545, 0x0543,
    0x0541, 0x3AFF, 0x3AFD, 0x3AFB, 0x3AF9, 0x3AF7, 0x3AF5, 0x3AF3,
    0x3AF1, 0x3AEF, 0x3AED, 0x3AEB, 0x3AE9, 0x3AE7, 0x3AE5, 0x3AE3,
    0x3AE1, 0x3ADF, 0x3ADD, 0x3ADB, 0x3AD9, 0x3AD7, 0x3AD5, 0x3AD3,
    0x3AD1, 0x3ACF, 0x3ACD, 0x3ACB, 0x3AC9, 0x3AC7, 0x3AC5, 0x3AC3,
    0x3AC1, 0x3ABF, 0x3ABD, 0x3ABB, 0x3AB9, 0x3AB7, 0x3AB5, 0x3AB3,
    0x3AB1,
  },
  {
    0x0F60, 0x0F62, 0x0F64, 0x0F66, 0x0F68, 0x0F6A, 0x0F6C, 0x0F6E,
    0x0F70, 0x0F72, 0x0F74, 0x0F76, 0x0F78, 0x0F7A, 0x0F7C, 0x0F7E,
    0x0F80, 0x0F82, 0x0F84, 0x0F86, 0x0F88, 0x0F8A, 0x0F8C, 0x0F8E,
    0x0F90, 0x0F92, 0x0F94, 0x0F96, 0x0F98, 0x0F9A, 0x0F9C, 0x0F9E,
    0x0FA0, 0x0FA2, 0x0FA4, 0x0FA6, 0x0FA8, 0x0FAA, 0x0FAC, 0x0FAE,
    0x0FB0, 0x0FB2, 0x0FB4, 0x0FB6, 0x0FB8, 0x0FBA, 0x0FBC, 0x0FBE,
    0x07A0, 0x07A2, 0x03D2, 0x01EA, 0x00FC, 0x007F, 0x001C, 0x000C,
    0x0004, 0x0034, 0x0010, 0x001B, 0x0009, 0x000B, 0x000E, 0x0001,
    0x0003, 0x0002, 0x000F, 0x000C, 0x000A, 0x0000, 0x0011, 0x0035,
    0x0005, 0x000D, 0x001D, 0x003C, 0x00FD, 0x01EB, 0x03D3, 0x07A3,
    0x07A1, 0x0FBF, 0x0FBD, 0x0FBB, 0x0FB9, 0x0FB7, 0x0FB5, 0x0FB3,
    0x0FB1, 0x0FAF, 0x0FAD, 0x0FAB, 0x0FA9, 0x0FA7, 0x0FA5, 0x0FA3,
    0x0FA1, 0x0F9F, 0x0F9D, 0x0F9B, 0x0F99, 0x0F97, 0x0F95, 0x0F93,
    0x0F91, 0x0F8F, 0x0F8D, 0x0F8B, 0x0F89, 0x0F87, 0x0F85, 0x0F83,
    0x0F81, 0x0F7F, 0x0F7D, 0x0F7B, 0x0F79, 0x0F77, 0x0F75, 0x0F73,
    0x0F71, 0x0F6F, 0x0F6D, 0x0F6B, 0x0F69, 0x0F67, 0x0F65, 0x0F63,
    0x0F61,
  },
  {
    0x51D0, 0x51D2, 0x51D4, 0x51D6, 0x51D8, 0x51DA, 0x51DC, 0x51DE,
    0x51E0, 0x51E2, 0x51E4, 0x51E6, 0x51E8, 0x51EA, 0x51EC, 0x51EE,
    0x51F0, 0x51F2, 0x51F4, 0x51F6, 0x51F8, 0x51FA, 0x51FC, 0x51FE,
    0x70C0, 0x70C2, 0x70C4, 0x70C6, 0x70C8, 0x70CA, 0x70CC, 0x70CE,
    0x70EC, 0x10EA, 0x3868, 0x3877, 0x0876, 0x1C35, 0x0434, 0x0A34,
    0x0E1B, 0x021B, 0x051B, 0x070F, 0x010F, 0x0380, 0x0080, 0x0140,
    0x01C1, 0x0041, 0x00A1, 0x00E2, 0x0022, 0x0052, 0x0072, 0x0012,
    0x002A, 0x003A, 0x000A, 0x0016, 0x001E, 0x0006, 0x000C, 0x0000,
    0x0004, 0x0001, 0x000D, 0x0007, 0x001F, 0x0017, 0x000B, 0x003B,
    0x002B, 0x0013, 0x0073, 0x0053, 0x0023, 0x00E3, 0x00A2, 0x0042,
    0x01C2, 0x0141, 0x0081, 0x0381, 0x028C, 0x010C, 0x051C, 0x021C,
    0x0E1C, 0x0A35, 0x0435, 0x1C3A, 0x0877, 0x0874, 0x3869, 0x10EB,
    0x70ED, 0x70CF, 0x70CD, 0x70CB, 0x70C9, 0x70C7, 0x70C5, 0x70C3,
    0x70C1, 0x51FF, 0x51FD, 0x51FB, 0x51F9, 0x51F7, 0x51F5, 0x51F3,
    0x51F1, 0x51EF, 0x51ED, 0x51EB, 0x51E9, 0x51E7, 0x51E5, 0x51E3,
    0x51E1, 0x51DF, 0x51DD, 0x51DB, 0x51D9, 0x51D7, 0x51D5, 0x51D3,
    0x51D1,
  },
  {
    0x6F64, 0x6F66, 0x6F68, 0x6F6A, 0x6F6C, 0x6F6E, 0x6F70, 0x6F72,
    0x6F74, 0x6F76, 0x6F78, 0x6F7A, 0x6F7C, 0x6F7E, 0x6F80, 0x6F82,
    0x6F84, 0x6F86, 0x6F88, 0x6F8A, 0x6F8C, 0x6F8E, 0x6F90, 0x6F92,
    0x6F94, 0x6F96, 0x6F98, 0x6F9A, 0x6F9C, 0x6F9E, 0x6FA0, 0x6FA2,
    0x6FA4, 0x6FA6, 0x6FA8, 0x6FAA, 0x6FAC, 0x6FAE, 0x6FB0, 0x6FB2,
    0x6FB4, 0x6FB6, 0x17B4, 0x37DC, 0x0BDB, 0x1BEF, 0x05EE, 0x0DF8,
    0x02F8, 0x06FD, 0x017D, 0x037F, 0x00BF, 0x0040, 0x00C0, 0x0021,
    0x0061, 0x0011, 0x0031, 0x0009, 0x0019, 0x0006, 0x000E, 0x0004,
    0x0000, 0x0005, 0x000F, 0x0007, 0x001A, 0x000A, 0x0036, 0x0016,
    0x006E, 0x002E, 0x00C1, 0x0041, 0x01BC, 0x00BC, 0x037A, 0x017A,
    0x02F9, 0x0DF9, 0x05EF, 0x05EC, 0x1BD8, 0x37DD, 0x17B5, 0x6FB7,
    0x6FB5, 0x6FB3, 0x6FB1, 0x6FAF, 0x6FAD, 0x6FAB, 0x6FA9, 0x6FA7,
    0x6FA5, 0x6FA3, 0x6FA1, 0x6F9F, 0x6F9D, 0x6F9B, 0x6F99, 0x6F97,
    0x6F95, 0x6F93, 0x6F91, 0x6F8F, 0x6F8D, 0x6F8B, 0x6F89, 0x6F87,
    0x6F85, 0x6F83, 0x6F81, 0x6F7F, 0x6F7D, 0x6F7B, 0x6F79, 0x6F77,
    0x6F75, 0x6F73, 0x6F71, 0x6F6F, 0x6F6D, 0x6F6B, 0x6F69, 0x6F67,
    0x6F65,
  },
  {
    0xDF54, 0xDF56, 0xDFC8, 0xDFCA, 0xDFCC, 0xDFCE, 0xDFD0, 0xDFD2,
    0xDFD4, 0xDFD6, 0xDFD8, 0xDFDA, 0xDFDC, 0xDFDE, 0xDFE0, 0xDFE2,
    0x0FE8, 0x2FEA, 0x6FA8, 0x6FF6, 0x07F5, 0x07F7, 0x37D2, 0x37F9,
    0x03F8, 0x0BF8, 0x0BFB, 0x1BEB, 0x01FA, 0x05FA, 0x09FA, 0x0DFA,
    0x0DFF, 0x00FF, 0x02FF, 0x06FB, 0x007C, 0x017C, 0x027C, 0x027F,
    0x003C, 0x00BC, 0x013C, 0x01BC, 0x001C, 0x005C, 0x009C, 0x00DC,
    0x000C, 0x002C, 0x004C, 0x006C, 0x0004, 0x0014, 0x0024, 0x0034,
    0x0000, 0x0008, 0x0010, 0x0018, 0x001E, 0x0002, 0x0006, 0x000A,
    0x000E, 0x000B, 0x0007, 0x0003, 0x001F, 0x0019, 0x0011, 0x0009,
    0x0001, 0x0035, 0x0025, 0x0015, 0x0005, 0x006D, 0x004D, 0x002D,
    0x000D, 0x00DD, 0x009D, 0x005D, 0x001D, 0x01BD, 0x013D, 0x00BD,
    0x003D, 0x037C, 0x027D, 0x017D, 0x007D, 0x06FC, 0x04FC, 0x02FC,
    0x00FC, 0x0DFB, 0x09FB, 0x05FB, 0x01FB, 0x1BF8, 0x1BE8, 0x0BF9,
    0x03F9, 0x37FA, 0x37D3, 0x17F4, 0x07F6, 0x6FF7, 0x6FA9, 0x2FEB,
    0x0FE9, 0xDFE3, 0xDFE1, 0xDFDF, 0xDFDD, 0xDFDB, 0xDFD9, 0xDFD7,
    0xDFD5, 0xDFD3, 0xDFD1, 0xDFCF, 0xDFCD, 0xDFCB, 0xDFC9, 0xDF57,
    0xDF55,
  }

################################################################################

TITLE
    libavcodec dcahuff scales_bits

TYPE
    8

DATA
  {
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    13, 13, 13, 13, 13, 13, 13, 13,
    13, 13, 12, 11, 11, 10,  9,  8,
     8,  7,  6,  6,  5,  4,  4,  3,
     2,  3,  3,  4,  5,  5,  6,  7,
     8,  8,  9, 10, 11, 11, 12, 13,
    13, 13, 13, 13, 13, 13, 13, 13,
    13, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14,
    14,
  },
  {
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    14, 14, 13, 12, 11, 10,  8,  7,
     6,  6,  5,  5,  4,  4,  4,  3,
     3,  3,  4,  4,  4,  4,  5,  6,
     6,  7,  8,  9, 11, 12, 13, 14,
    14, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15,
  },
  {
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 14, 14, 14, 13, 13, 12, 12,
    12, 11, 11, 11, 10, 10,  9,  9,
     9,  8,  8,  8,  7,  7,  7,  6,
     6,  6,  5,  5,  5,  4,  4,  3,
     3,  3,  4,  4,  5,  5,  5,  6,
     6,  6,  7,  7,  7,  8,  8,  8,
     9,  9,  9, 10, 10, 10, 11, 11,
    12, 12, 12, 13, 13, 13, 14, 14,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15,
  },
  {
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 14, 14, 13, 13, 12, 12,
    11, 11, 10, 10,  9,  8,  8,  7,
     7,  6,  6,  5,  5,  4,  4,  3,
     2,  3,  4,  4,  5,  5,  6,  6,
     7,  7,  8,  8,  9,  9, 10, 10,
    11, 12, 12, 12, 13, 14, 14, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15, 15, 15, 15, 15, 15, 15, 15,
    15,
  },
  {
    16, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16,
    15, 15, 15, 15, 14, 14, 14, 14,
    13, 13, 13, 13, 12, 12, 12, 12,
    12, 11, 11, 11, 10, 10, 10, 10,
     9,  9,  9,  9,  8,  8,  8,  8,
     7,  7,  7,  7,  6,  6,  6,  6,
     5,  5,  5,  5,  5,  4,  4,  4,
     4,  4,  4,  4,  5,  5,  5,  5,
     5,  6,  6,  6,  6,  7,  7,  7,
     7,  8,  8,  8,  8,  9,  9,  9,
     9, 10, 10, 10, 10, 11, 11, 11,
    11, 12, 12, 12, 12, 13, 13, 13,
    13, 14, 14, 14, 14, 15, 15, 15,
    15, 16, 16, 16, 16, 16, 16, 16,
    16, 16, 16, 16, 16, 16, 16, 16,
    16,
  }

################################################################################

TITLE
    libavcodec dnxhd_1252_ac_codes

TYPE
    16

DATA
    0, 1, 4, 10, 11, 12, 26, 27, 56, 57, 58, 118, 119, 120, 242, 243, 244, 245, 246, 247, 496, 497, 498, 499, 500, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 4060, 4061, 4062, 4063, 4064, 4065, 4066, 4067, 4068, 4069, 4070, 4071, 8144, 8145, 8146, 8147, 8148, 8149, 8150, 8151, 8152, 8153, 8154, 8155, 8156, 8157, 8158, 16318, 16319, 16320, 16321, 16322, 16323, 16324, 16325, 16326, 16327, 16328, 16329, 16330, 16331, 16332, 16333, 16334, 16335, 32672, 32673, 32674, 32675, 32676, 32677, 32678, 32679, 32680, 32681, 32682, 32683, 32684, 32685, 32686, 32687, 32688, 32689, 32690, 32691, 32692, 32693, 32694, 65390, 65391, 65392, 65393, 65394, 65395, 65396, 65397, 65398, 65399, 65400, 65401, 65402, 65403, 65404, 65405, 65406, 65407, 65408, 65409, 65410, 65411, 65412, 65413, 65414, 65415, 65416, 65417, 65418, 65419, 65420, 65421, 65422, 65423, 65424, 65425, 65426, 65427, 65428, 65429, 65430, 65431, 65432, 65433, 65434, 65435, 65436, 65437, 65438, 65439, 65440, 65441, 65442, 65443, 65444, 65445, 65446, 65447, 65448, 65449, 65450, 65451, 65452, 65453, 65454, 65455, 65456, 65457, 65458, 65459, 65460, 65461, 65462, 65463, 65464, 65465, 65466, 65467, 65468, 65469, 65470, 65471, 65472, 65473, 65474, 65475, 65476, 65477, 65478, 65479, 65480, 65481, 65482, 65483, 65484, 65485, 65486, 65487, 65488, 65489, 65490, 65491, 65492, 65493, 65494, 65495, 65496, 65497, 65498, 65499, 65500, 65501, 65502, 65503, 65504, 65505, 65506, 65507, 65508, 65509, 65510, 65511, 65512, 65513, 65514, 65515, 65516, 65517, 65518, 65519, 65520, 65521, 65522, 65523, 65524, 65525, 65526, 65527, 65528, 65529, 65530, 65531, 65532, 65533, 65534, 65535,

################################################################################

TITLE
    libavcodec dpcm interplay_delta_table

TYPE
    16 32

DATA
         0,      1,      2,      3,      4,      5,      6,      7,
         8,      9,     10,     11,     12,     13,     14,     15,
        16,     17,     18,     19,     20,     21,     22,     23,
        24,     25,     26,     27,     28,     29,     30,     31,
        32,     33,     34,     35,     36,     37,     38,     39,
        40,     41,     42,     43,     47,     51,     56,     61,
        66,     72,     79,     86,     94,    102,    112,    122,
       133,    145,    158,    173,    189,    206,    225,    245,
       267,    292,    318,    348,    379,    414,    452,    493,
       538,    587,    640,    699,    763,    832,    908,    991,
      1081,   1180,   1288,   1405,   1534,   1673,   1826,   1993,
      2175,   2373,   2590,   2826,   3084,   3365,   3672,   4008,
      4373,   4772,   5208,   5683,   6202,   6767,   7385,   8059,
      8794,   9597,  10472,  11428,  12471,  13609,  14851,  16206,
     17685,  19298,  21060,  22981,  25078,  27367,  29864,  32589,
    -29973, -26728, -23186, -19322, -15105, -10503,  -5481,     -1,
         1,      1,   5481,  10503,  15105,  19322,  23186,  26728,
     29973, -32589, -29864, -27367, -25078, -22981, -21060, -19298,
    -17685, -16206, -14851, -13609, -12471, -11428, -10472,  -9597,
     -8794,  -8059,  -7385,  -6767,  -6202,  -5683,  -5208,  -4772,
     -4373,  -4008,  -3672,  -3365,  -3084,  -2826,  -2590,  -2373,
     -2175,  -1993,  -1826,  -1673,  -1534,  -1405,  -1288,  -1180,
     -1081,   -991,   -908,   -832,   -763,   -699,   -640,   -587,
      -538,   -493,   -452,   -414,   -379,   -348,   -318,   -292,
      -267,   -245,   -225,   -206,   -189,   -173,   -158,   -145,
      -133,   -122,   -112,   -102,    -94,    -86,    -79,    -72,
       -66,    -61,    -56,    -51,    -47,    -43,    -42,    -41,
       -40,    -39,    -38,    -37,    -36,    -35,    -34,    -33,
       -32,    -31,    -30,    -29,    -28,    -27,    -26,    -25,
       -24,    -23,    -22,    -21,    -20,    -19,    -18,    -17,
       -16,    -15,    -14,    -13,    -12,    -11,    -10,     -9,
        -8,     -7,     -6,     -5,     -4,     -3,     -2,     -1

################################################################################

TITLE
    libavcodec dv remap

TYPE
    8

DATA
                                      {{ 0, 0}, { 0, 0}, { 0, 0}, { 0, 0}, { 0, 0},
                                       { 0, 0}, { 0, 1}, { 0, 2}, { 0, 3}, {10, 0},
                                       {10, 1}, {10, 2}, {10, 3}, {20, 0}, {20, 1},
                                       {20, 2}, {20, 3}, {30, 0}, {30, 1}, {30, 2},
                                       {30, 3}, {40, 0}, {40, 1}, {40, 2}, {40, 3},
                                       {50, 0}, {50, 1}, {50, 2}, {50, 3}, {60, 0},
                                       {60, 1}, {60, 2}, {60, 3}, {70, 0}, {70, 1},
                                       {70, 2}, {70, 3}, { 0,64}, { 0,65}, { 0,66},
                                       {10,64}, {10,65}, {10,66}, {20,64}, {20,65},
                                       {20,66}, {30,64}, {30,65}, {30,66}, {40,64},
                                       {40,65}, {40,66}, {50,64}, {50,65}, {50,66},
                                       {60,64}, {60,65}, {60,66}, {70,64}, {70,65},
                                       {70,66}, { 0,67}, {20,67}, {40,67}, {60,67}};

################################################################################

TITLE
    libavcodec fax ccitt_syms

TYPE
    16

DATA
    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
  128,  192,  256,  320,  384,  448,  512,  576,  640,  704,  768,  832,  896,
  960, 1024, 1088, 1152, 1216, 1280, 1344, 1408, 1472, 1536, 1600, 1664, 1728,
 1792, 1856, 1920, 1984, 2048, 2112, 2176, 2240, 2304, 2368, 2432, 2496, 2560

################################################################################

TITLE
    libavcodec fax ccitt_codes_bits

TYPE
    8

DATA
    0x35, 0x07, 0x07, 0x08, 0x0B, 0x0C, 0x0E, 0x0F, 0x13, 0x14, 0x07, 0x08, 0x08,
    0x03, 0x34, 0x35, 0x2A, 0x2B, 0x27, 0x0C, 0x08, 0x17, 0x03, 0x04, 0x28, 0x2B,
    0x13, 0x24, 0x18, 0x02, 0x03, 0x1A, 0x1B, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
    0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x04, 0x05, 0x0A, 0x0B, 0x52, 0x53, 0x54,
    0x55, 0x24, 0x25, 0x58, 0x59, 0x5A, 0x5B, 0x4A, 0x4B, 0x32, 0x33, 0x34, 0x1B,
    0x12, 0x17, 0x37, 0x36, 0x37, 0x64, 0x65, 0x68, 0x67, 0xCC, 0xCD, 0xD2, 0xD3,
    0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0x98, 0x99, 0x9A, 0x18, 0x9B,
    0x08, 0x0C, 0x0D, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x1C, 0x1D, 0x1E, 0x1F
  }, {
    0x37, 0x02, 0x03, 0x02, 0x03, 0x03, 0x02, 0x03, 0x05, 0x04, 0x04, 0x05, 0x07,
    0x04, 0x07, 0x18, 0x17, 0x18, 0x08, 0x67, 0x68, 0x6C, 0x37, 0x28, 0x17, 0x18,
    0xCA, 0xCB, 0xCC, 0xCD, 0x68, 0x69, 0x6A, 0x6B, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6,
    0xD7, 0x6C, 0x6D, 0xDA, 0xDB, 0x54, 0x55, 0x56, 0x57, 0x64, 0x65, 0x52, 0x53,
    0x24, 0x37, 0x38, 0x27, 0x28, 0x58, 0x59, 0x2B, 0x2C, 0x5A, 0x66, 0x67, 0x0F,
    0xC8, 0xC9, 0x5B, 0x33, 0x34, 0x35, 0x6C, 0x6D, 0x4A, 0x4B, 0x4C, 0x4D, 0x72,
    0x73, 0x74, 0x75, 0x76, 0x77, 0x52, 0x53, 0x54, 0x55, 0x5A, 0x5B, 0x64, 0x65,
    0x08, 0x0C, 0x0D, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x1C, 0x1D, 0x1E, 0x1F

################################################################################

TITLE
    libavcodec fax ccitt_codes_lens

TYPE
    8

DATA
     8,  6,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  7,  7,
     7,  7,  7,  7,  7,  7,  7,  7,  7,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,
     8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,
     8,  8,  8,  8,  5,  5,  6,  7,  8,  8,  8,  8,  8,  8,  9,  9,  9,  9,  9,  9,
     9,  9,  9,  9,  9,  9,  9,  9,  9,  6,  9, 11, 11, 11, 12, 12, 12, 12, 12, 12,
    12, 12, 12, 12
  },{
    10,  3,  2,  2,  3,  4,  4,  5,  6,  6,  7,  7,  7,  8,  8,  9, 10, 10, 10, 11,
    11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
    12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
    12, 12, 12, 12, 10, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13,
    13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 11, 11, 11, 12, 12, 12, 12, 12, 12,
    12, 12, 12, 12

################################################################################

TITLE
    libavcodec G729 cb_lsp_1st

TYPE
    16

DATA
  { 1486,  2168,  3751,  9074, 12134, 13944, 17983, 19173, 21190, 21820},
  { 1730,  2640,  3450,  4870,  6126,  7876, 15644, 17817, 20294, 21902},
  { 1568,  2256,  3088,  4874, 11063, 13393, 18307, 19293, 21109, 21741},
  { 1733,  2512,  3357,  4708,  6977, 10296, 17024, 17956, 19145, 20350},
  { 1744,  2436,  3308,  8731, 10432, 12007, 15614, 16639, 21359, 21913},
  { 1786,  2369,  3372,  4521,  6795, 12963, 17674, 18988, 20855, 21640},
  { 1631,  2433,  3361,  6328, 10709, 12013, 13277, 13904, 19441, 21088},
  { 1489,  2364,  3291,  6250,  9227, 10403, 13843, 15278, 17721, 21451},
  { 1869,  2533,  3475,  4365,  9152, 14513, 15908, 17022, 20611, 21411},
  { 2070,  3025,  4333,  5854,  7805,  9231, 10597, 16047, 20109, 21834},
  { 1910,  2673,  3419,  4261, 11168, 15111, 16577, 17591, 19310, 20265},
  { 1141,  1815,  2624,  4623,  6495,  9588, 13968, 16428, 19351, 21286},
  { 2192,  3171,  4707,  5808, 10904, 12500, 14162, 15664, 21124, 21789},
  { 1286,  1907,  2548,  3453,  9574, 11964, 15978, 17344, 19691, 22495},
  { 1921,  2720,  4604,  6684, 11503, 12992, 14350, 15262, 16997, 20791},
  { 2052,  2759,  3897,  5246,  6638, 10267, 15834, 16814, 18149, 21675},
  { 1798,  2497,  5617, 11449, 13189, 14711, 17050, 18195, 20307, 21182},
  { 1009,  1647,  2889,  5709,  9541, 12354, 15231, 18494, 20966, 22033},
  { 3016,  3794,  5406,  7469, 12488, 13984, 15328, 16334, 19952, 20791},
  { 2203,  3040,  3796,  5442, 11987, 13512, 14931, 16370, 17856, 18803},
  { 2912,  4292,  7988,  9572, 11562, 13244, 14556, 16529, 20004, 21073},
  { 2861,  3607,  5923,  7034,  9234, 12054, 13729, 18056, 20262, 20974},
  { 3069,  4311,  5967,  7367, 11482, 12699, 14309, 16233, 18333, 19172},
  { 2434,  3661,  4866,  5798, 10383, 11722, 13049, 15668, 18862, 19831},
  { 2020,  2605,  3860,  9241, 13275, 14644, 16010, 17099, 19268, 20251},
  { 1877,  2809,  3590,  4707, 11056, 12441, 15622, 17168, 18761, 19907},
  { 2107,  2873,  3673,  5799, 13579, 14687, 15938, 17077, 18890, 19831},
  { 1612,  2284,  2944,  3572,  8219, 13959, 15924, 17239, 18592, 20117},
  { 2420,  3156,  6542, 10215, 12061, 13534, 15305, 16452, 18717, 19880},
  { 1667,  2612,  3534,  5237, 10513, 11696, 12940, 16798, 18058, 19378},
  { 2388,  3017,  4839,  9333, 11413, 12730, 15024, 16248, 17449, 18677},
  { 1875,  2786,  4231,  6320,  8694, 10149, 11785, 17013, 18608, 19960},
  {  679,  1411,  4654,  8006, 11446, 13249, 15763, 18127, 20361, 21567},
  { 1838,  2596,  3578,  4608,  5650, 11274, 14355, 15886, 20579, 21754},
  { 1303,  1955,  2395,  3322, 12023, 13764, 15883, 18077, 20180, 21232},
  { 1438,  2102,  2663,  3462,  8328, 10362, 13763, 17248, 19732, 22344},
  {  860,  1904,  6098,  7775,  9815, 12007, 14821, 16709, 19787, 21132},
  { 1673,  2723,  3704,  6125,  7668,  9447, 13683, 14443, 20538, 21731},
  { 1246,  1849,  2902,  4508,  7221, 12710, 14835, 16314, 19335, 22720},
  { 1525,  2260,  3862,  5659,  7342, 11748, 13370, 14442, 18044, 21334},
  { 1196,  1846,  3104,  7063, 10972, 12905, 14814, 17037, 19922, 22636},
  { 2147,  3106,  4475,  6511,  8227,  9765, 10984, 12161, 18971, 21300},
  { 1585,  2405,  2994,  4036, 11481, 13177, 14519, 15431, 19967, 21275},
  { 1778,  2688,  3614,  4680,  9465, 11064, 12473, 16320, 19742, 20800},
  { 1862,  2586,  3492,  6719, 11708, 13012, 14364, 16128, 19610, 20425},
  { 1395,  2156,  2669,  3386, 10607, 12125, 13614, 16705, 18976, 21367},
  { 1444,  2117,  3286,  6233,  9423, 12981, 14998, 15853, 17188, 21857},
  { 2004,  2895,  3783,  4897,  6168,  7297, 12609, 16445, 19297, 21465},
  { 1495,  2863,  6360,  8100, 11399, 14271, 15902, 17711, 20479, 22061},
  { 2484,  3114,  5718,  7097,  8400, 12616, 14073, 14847, 20535, 21396},
  { 2424,  3277,  5296,  6284, 11290, 12903, 16022, 17508, 19333, 20283},
  { 2565,  3778,  5360,  6989,  8782, 10428, 14390, 15742, 17770, 21734},
  { 2727,  3384,  6613,  9254, 10542, 12236, 14651, 15687, 20074, 21102},
  { 1916,  2953,  6274,  8088,  9710, 10925, 12392, 16434, 20010, 21183},
  { 3384,  4366,  5349,  7667, 11180, 12605, 13921, 15324, 19901, 20754},
  { 3075,  4283,  5951,  7619,  9604, 11010, 12384, 14006, 20658, 21497},
  { 1751,  2455,  5147,  9966, 11621, 13176, 14739, 16470, 20788, 21756},
  { 1442,  2188,  3330,  6813,  8929, 12135, 14476, 15306, 19635, 20544},
  { 2294,  2895,  4070,  8035, 12233, 13416, 14762, 17367, 18952, 19688},
  { 1937,  2659,  4602,  6697,  9071, 12863, 14197, 15230, 16047, 18877},
  { 2071,  2663,  4216,  9445, 10887, 12292, 13949, 14909, 19236, 20341},
  { 1740,  2491,  3488,  8138,  9656, 11153, 13206, 14688, 20896, 21907},
  { 2199,  2881,  4675,  8527, 10051, 11408, 14435, 15463, 17190, 20597},
  { 1943,  2988,  4177,  6039,  7478,  8536, 14181, 15551, 17622, 21579},
  { 1825,  3175,  7062,  9818, 12824, 15450, 18330, 19856, 21830, 22412},
  { 2464,  3046,  4822,  5977,  7696, 15398, 16730, 17646, 20588, 21320},
  { 2550,  3393,  5305,  6920, 10235, 14083, 18143, 19195, 20681, 21336},
  { 3003,  3799,  5321,  6437,  7919, 11643, 15810, 16846, 18119, 18980},
  { 3455,  4157,  6838,  8199,  9877, 12314, 15905, 16826, 19949, 20892},
  { 3052,  3769,  4891,  5810,  6977, 10126, 14788, 15990, 19773, 20904},
  { 3671,  4356,  5827,  6997,  8460, 12084, 14154, 14939, 19247, 20423},
  { 2716,  3684,  5246,  6686,  8463, 10001, 12394, 14131, 16150, 19776},
  { 1945,  2638,  4130,  7995, 14338, 15576, 17057, 18206, 20225, 20997},
  { 2304,  2928,  4122,  4824,  5640, 13139, 15825, 16938, 20108, 21054},
  { 1800,  2516,  3350,  5219, 13406, 15948, 17618, 18540, 20531, 21252},
  { 1436,  2224,  2753,  4546,  9657, 11245, 15177, 16317, 17489, 19135},
  { 2319,  2899,  4980,  6936,  8404, 13489, 15554, 16281, 20270, 20911},
  { 2187,  2919,  4610,  5875,  7390, 12556, 14033, 16794, 20998, 21769},
  { 2235,  2923,  5121,  6259,  8099, 13589, 15340, 16340, 17927, 20159},
  { 1765,  2638,  3751,  5730,  7883, 10108, 13633, 15419, 16808, 18574},
  { 3460,  5741,  9596, 11742, 14413, 16080, 18173, 19090, 20845, 21601},
  { 3735,  4426,  6199,  7363,  9250, 14489, 16035, 17026, 19873, 20876},
  { 3521,  4778,  6887,  8680, 12717, 14322, 15950, 18050, 20166, 21145},
  { 2141,  2968,  6865,  8051, 10010, 13159, 14813, 15861, 17528, 18655},
  { 4148,  6128,  9028, 10871, 12686, 14005, 15976, 17208, 19587, 20595},
  { 4403,  5367,  6634,  8371, 10163, 11599, 14963, 16331, 17982, 18768},
  { 4091,  5386,  6852,  8770, 11563, 13290, 15728, 16930, 19056, 20102},
  { 2746,  3625,  5299,  7504, 10262, 11432, 13172, 15490, 16875, 17514},
  { 2248,  3556,  8539, 10590, 12665, 14696, 16515, 17824, 20268, 21247},
  { 1279,  1960,  3920,  7793, 10153, 14753, 16646, 18139, 20679, 21466},
  { 2440,  3475,  6737,  8654, 12190, 14588, 17119, 17925, 19110, 19979},
  { 1879,  2514,  4497,  7572, 10017, 14948, 16141, 16897, 18397, 19376},
  { 2804,  3688,  7490, 10086, 11218, 12711, 16307, 17470, 20077, 21126},
  { 2023,  2682,  3873,  8268, 10255, 11645, 15187, 17102, 18965, 19788},
  { 2823,  3605,  5815,  8595, 10085, 11469, 16568, 17462, 18754, 19876},
  { 2851,  3681,  5280,  7648,  9173, 10338, 14961, 16148, 17559, 18474},
  { 1348,  2645,  5826,  8785, 10620, 12831, 16255, 18319, 21133, 22586},
  { 2141,  3036,  4293,  6082,  7593, 10629, 17158, 18033, 21466, 22084},
  { 1608,  2375,  3384,  6878,  9970, 11227, 16928, 17650, 20185, 21120},
  { 2774,  3616,  5014,  6557,  7788,  8959, 17068, 18302, 19537, 20542},
  { 1934,  4813,  6204,  7212,  8979, 11665, 15989, 17811, 20426, 21703},
  { 2288,  3507,  5037,  6841,  8278,  9638, 15066, 16481, 21653, 22214},
  { 2951,  3771,  4878,  7578,  9016, 10298, 14490, 15242, 20223, 20990},
  { 3256,  4791,  6601,  7521,  8644,  9707, 13398, 16078, 19102, 20249},
  { 1827,  2614,  3486,  6039, 12149, 13823, 16191, 17282, 21423, 22041},
  { 1000,  1704,  3002,  6335,  8471, 10500, 14878, 16979, 20026, 22427},
  { 1646,  2286,  3109,  7245, 11493, 12791, 16824, 17667, 18981, 20222},
  { 1708,  2501,  3315,  6737,  8729,  9924, 16089, 17097, 18374, 19917},
  { 2623,  3510,  4478,  5645,  9862, 11115, 15219, 18067, 19583, 20382},
  { 2518,  3434,  4728,  6388,  8082,  9285, 13162, 18383, 19819, 20552},
  { 1726,  2383,  4090,  6303,  7805, 12845, 14612, 17608, 19269, 20181},
  { 2860,  3735,  4838,  6044,  7254,  8402, 14031, 16381, 18037, 19410},
  { 4247,  5993,  7952,  9792, 12342, 14653, 17527, 18774, 20831, 21699},
  { 3502,  4051,  5680,  6805,  8146, 11945, 16649, 17444, 20390, 21564},
  { 3151,  4893,  5899,  7198, 11418, 13073, 15124, 17673, 20520, 21861},
  { 3960,  4848,  5926,  7259,  8811, 10529, 15661, 16560, 18196, 20183},
  { 4499,  6604,  8036,  9251, 10804, 12627, 15880, 17512, 20020, 21046},
  { 4251,  5541,  6654,  8318,  9900, 11686, 15100, 17093, 20572, 21687},
  { 3769,  5327,  7865,  9360, 10684, 11818, 13660, 15366, 18733, 19882},
  { 3083,  3969,  6248,  8121,  9798, 10994, 12393, 13686, 17888, 19105},
  { 2731,  4670,  7063,  9201, 11346, 13735, 16875, 18797, 20787, 22360},
  { 1187,  2227,  4737,  7214,  9622, 12633, 15404, 17968, 20262, 23533},
  { 1911,  2477,  3915, 10098, 11616, 12955, 16223, 17138, 19270, 20729},
  { 1764,  2519,  3887,  6944,  9150, 12590, 16258, 16984, 17924, 18435},
  { 1400,  3674,  7131,  8718, 10688, 12508, 15708, 17711, 19720, 21068},
  { 2322,  3073,  4287,  8108,  9407, 10628, 15862, 16693, 19714, 21474},
  { 2630,  3339,  4758,  8360, 10274, 11333, 12880, 17374, 19221, 19936},
  { 1721,  2577,  5553,  7195,  8651, 10686, 15069, 16953, 18703, 19929}

################################################################################

TITLE
    libavcodec G729 cb_lsp_2nd

TYPE
    16

DATA
  { -435,  -815,  -742,  1033,  -518,   582, -1201,   829,    86,   385},
  { -833,  -891,   463,    -8, -1251,  1450,    72,  -231,   864,   661},
  {-1021,   231,  -306,   321,  -220,  -163,  -526,  -754, -1633,   267},
  {   57,  -198,  -339,   -33, -1468,   573,   796,  -169,  -631,   816},
  {  171,  -350,   294,  1660,   453,   519,   291,   159,  -640, -1296},
  { -701,  -842,   -58,   950,   892,  1549,   715,   527,  -714,  -193},
  {  584,    31,  -289,   356,  -333,  -457,   612,  -283, -1381,  -741},
  { -109,  -808,   231,    77,   -87,  -344,  1341,  1087,  -654,  -569},
  { -859,  1236,   550,   854,   714,  -543, -1752,  -195,   -98,  -276},
  { -877,  -954, -1248,  -299,   212,  -235,  -728,   949,  1517,   895},
  {  -77,   344,  -620,   763,   413,   502,  -362,  -960,  -483,  1386},
  { -314,  -307,  -256, -1260,  -429,   450,  -466,  -108,  1010,  2223},
  {  711,   693,   521,   650,  1305,   -28,  -378,   744, -1005,   240},
  { -112,  -271,  -500,   946,  1733,   271,   -15,   909,  -259,  1688},
  {  575,   -10,  -468,  -199,  1101, -1011,   581,   -53,  -747,   878},
  {  145,  -285, -1280,  -398,    36,  -498, -1377,    18,  -444,  1483},
  {-1133,  -835,  1350,  1284,   -95,  1015,  -222,   443,   372,  -354},
  {-1459, -1237,   416,  -213,   466,   669,   659,  1640,   932,   534},
  {  -15,    66,   468,  1019,  -748,  1385,  -182,  -907,  -721,  -262},
  { -338,   148,  1445,    75,  -760,   569,  1247,   337,   416,  -121},
  {  389,   239,  1568,   981,   113,   369, -1003,  -507,  -587,  -904},
  { -312,   -98,   949,    31,  1104,    72,  -141,  1465,    63,  -785},
  { 1127,   584,   835,   277, -1159,   208,   301,  -882,   117,  -404},
  {  539,  -114,   856,  -493,   223,  -912,   623,   -76,   276,  -440},
  { 2197,  2337,  1268,   670,   304,  -267,  -525,   140,   882,  -139},
  {-1596,   550,   801,  -456,   -56,  -697,   865,  1060,   413,   446},
  { 1154,   593,   -77,  1237,   -31,   581, -1037,  -895,   669,   297},
  {  397,   558,   203,  -797,  -919,     3,   692,  -292,  1050,   782},
  {  334,  1475,   632,   -80,    48, -1061,  -484,   362,  -597,  -852},
  { -545,  -330,  -429,  -680,  1133, -1182,  -744,  1340,   262,    63},
  { 1320,   827,  -398,  -576,   341,  -774,  -483, -1247,   -70,    98},
  { -163,   674,   -11,  -886,   531, -1125,  -265,  -242,   724,   934}

################################################################################

TITLE
    libavcodec G729 cb_gain_1st_8k

TYPE
    16

DATA
{ /*(0.14) (2.13) */
  { 3242 ,  9949 },
  { 1551 ,  2425 },
  { 2678 , 27162 },
  { 1921 ,  9291 },
  { 1831 ,  5022 },
  {    1 ,  1516 },
  {  356 , 14756 },
  {   57 ,  5404 },

################################################################################

TITLE
    libavcodec G729 cb_gain_2nd_8k

TYPE
    16

DATA
{ /*(1.14) (1.13) */
  {  5142 ,   592 },
  { 17299 ,  1861 },
  {  6160 ,  2395 },
  { 16112 ,  3392 },
  {   826 ,  2005 },
  { 18973 ,  5935 },
  {  1994 ,     0 },
  { 15434 ,   237 },
  { 10573 ,  2966 },
  { 15132 ,  4914 },
  { 11569 ,  1196 },
  { 14194 ,  1630 },
  {  8091 ,  4861 },
  { 15161 , 14276 },
  {  9120 ,   525 },
  { 13260 ,  3256 },

################################################################################

TITLE
    libavcodec G729 cb_ma_predictor

TYPE
    16

DATA
    { 8421,  9109,  9175,  8965,  9034,  9057,  8765,  8775,  9106,  8673},
    { 7018,  7189,  7638,  7307,  7444,  7379,  7038,  6956,  6930,  6868},
    { 5472,  4990,  5134,  5177,  5246,  5141,  5206,  5095,  4830,  5147},
    { 4056,  3031,  2614,  3024,  2916,  2713,  3309,  3237,  2857,  3473}
  }, {
    { 7733,  7880,  8188,  8175,  8247,  8490,  8637,  8601,  8359,  7569},
    { 4210,  3031,  2552,  3473,  3876,  3853,  4184,  4154,  3909,  3968},
    { 3214,  1930,  1313,  2143,  2493,  2385,  2755,  2706,  2542,  2919},
    { 3024,  1592,   940,  1631,  1723,  1579,  2034,  2084,  1913,  2601}

################################################################################

TITLE
    libavcodec ff_ue_golomb_vlc_code

TYPE
    8

DATA
31,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,
 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

################################################################################

TITLE
    libavcodec ff_se_golomb_vlc_code

TYPE
    8

DATA
 16, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,  8, -8,  9, -9, 10,-10, 11,-11, 12,-12, 13,-13, 14,-14, 15,-15,
  4,  4,  4,  4, -4, -4, -4, -4,  5,  5,  5,  5, -5, -5, -5, -5,  6,  6,  6,  6, -6, -6, -6, -6,  7,  7,  7,  7, -7, -7, -7, -7,
  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, -3,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,

################################################################################

TITLE
    libavcodec ff_interleaved_ue_golomb_vlc_code

TYPE
    8

DATA
 15,16,7, 7, 17,18,8, 8, 3, 3, 3, 3, 3, 3, 3, 3,
 19,20,9, 9, 21,22,10,10,4, 4, 4, 4, 4, 4, 4, 4,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 23,24,11,11,25,26,12,12,5, 5, 5, 5, 5, 5, 5, 5,
 27,28,13,13,29,30,14,14,6, 6, 6, 6, 6, 6, 6, 6,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

################################################################################

TITLE
    libavcodec ff_interleaved_se_golomb_vlc_code

TYPE
    8

DATA
  8, -8,  4,  4,  9, -9, -4, -4,  2,  2,  2,  2,  2,  2,  2,  2,
 10,-10,  5,  5, 11,-11, -5, -5, -2, -2, -2, -2, -2, -2, -2, -2,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
 12,-12,  6,  6, 13,-13, -6, -6,  3,  3,  3,  3,  3,  3,  3,  3,
 14,-14,  7,  7, 15,-15, -7, -7, -3, -3, -3, -3, -3, -3, -3, -3,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,

################################################################################

TITLE
    libavcodec ff_interleaved_dirac_golomb_vlc_code

TYPE
    8

DATA
0, 1, 0, 0, 2, 3, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
4, 5, 2, 2, 6, 7, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
8, 9, 4, 4, 10,11,5, 5, 2, 2, 2, 2, 2, 2, 2, 2,
12,13,6, 6, 14,15,7, 7, 3, 3, 3, 3, 3, 3, 3, 3,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,};

################################################################################

TITLE
    libavcodec h261_cbp_tab

TYPE
    8

DATA
    {11,5}, {9,5}, {13,6}, {13,4}, {23,7}, {19,7}, {31,8}, {12,4},
    {22,7}, {18,7}, {30,8}, {19,5}, {27,8}, {23,8}, {19,8}, {11,4},
    {21,7}, {17,7}, {29,8}, {17,5}, {25,8}, {21,8}, {17,8}, {15,6},
    {15,8}, {13,8}, {3,9}, {15,5}, {11,8}, {7,8}, {7,9}, {10,4},
    {20,7}, {16,7}, {28,8}, {14,6}, {14,8}, {12,8}, {2,9}, {16,5},
    {24,8}, {20,8}, {16,8}, {14,5}, {10,8}, {6,8}, {6,9}, {18,5},
    {26,8}, {22,8}, {18,8}, {13,5}, {9,8}, {5,8}, {5,9}, {12,5},
    {8,8}, {4,8}, {4,9}, {7,3}, {10,5}, {8,5}, {12,6}

################################################################################

TITLE
    libavcodec h261_tcoeff_vlc

TYPE
    16

DATA
{ 0x2, 2 }, { 0x3, 2 },{ 0x4, 4 },{ 0x5, 5 },
{ 0x6, 7 },{ 0x26, 8 },{ 0x21, 8 },{ 0xa, 10 },
{ 0x1d, 12 },{ 0x18, 12 },{ 0x13, 12 },{ 0x10 , 12 },
{ 0x1a, 13},{ 0x19, 13 }, { 0x18, 13 }, { 0x17, 13 },
{ 0x3, 3 }, { 0x6, 6 }, { 0x25 , 8 }, { 0xc, 10 },
{ 0x1b, 12 }, { 0x16, 13 }, { 0x15, 13 }, { 0x5, 4},
{ 0x4, 7}, { 0xb, 10 }, { 0x14, 12 }, { 0x14, 13 },
{ 0x7, 5 }, { 0x24, 8 }, { 0x1c, 12 }, { 0x13, 13 },
{ 0x6, 5 }, { 0xf, 10 }, { 0x12, 12}, { 0x7, 6},
{ 0x9 , 10 }, { 0x12, 13 }, { 0x5, 6 }, { 0x1e, 12 },
{ 0x4, 6 }, { 0x15, 12 }, { 0x7, 7 }, { 0x11, 12},
{ 0x5, 7 }, { 0x11, 13 }, { 0x27, 8 }, { 0x10, 13 },
{ 0x23, 8 }, { 0x22, 8 }, { 0x20, 8 }, { 0xe , 10 },
{ 0xd, 10 }, { 0x8, 10 },{ 0x1f, 12 }, { 0x1a, 12 },
{ 0x19, 12 }, { 0x17, 12 }, { 0x16, 12}, { 0x1f, 13},
{ 0x1e, 13 }, { 0x1d, 13 }, { 0x1c, 13}, { 0x1b, 13},
{ 0x1, 6 }                                             //escape

################################################################################

TITLE
    libavcodec h263 inter_vlc

TYPE
    16

DATA
{ 0x2, 2 },{ 0xf, 4 },{ 0x15, 6 },{ 0x17, 7 },
{ 0x1f, 8 },{ 0x25, 9 },{ 0x24, 9 },{ 0x21, 10 },
{ 0x20, 10 },{ 0x7, 11 },{ 0x6, 11 },{ 0x20, 11 },
{ 0x6, 3 },{ 0x14, 6 },{ 0x1e, 8 },{ 0xf, 10 },
{ 0x21, 11 },{ 0x50, 12 },{ 0xe, 4 },{ 0x1d, 8 },
{ 0xe, 10 },{ 0x51, 12 },{ 0xd, 5 },{ 0x23, 9 },
{ 0xd, 10 },{ 0xc, 5 },{ 0x22, 9 },{ 0x52, 12 },
{ 0xb, 5 },{ 0xc, 10 },{ 0x53, 12 },{ 0x13, 6 },
{ 0xb, 10 },{ 0x54, 12 },{ 0x12, 6 },{ 0xa, 10 },
{ 0x11, 6 },{ 0x9, 10 },{ 0x10, 6 },{ 0x8, 10 },
{ 0x16, 7 },{ 0x55, 12 },{ 0x15, 7 },{ 0x14, 7 },
{ 0x1c, 8 },{ 0x1b, 8 },{ 0x21, 9 },{ 0x20, 9 },
{ 0x1f, 9 },{ 0x1e, 9 },{ 0x1d, 9 },{ 0x1c, 9 },
{ 0x1b, 9 },{ 0x1a, 9 },{ 0x22, 11 },{ 0x23, 11 },
{ 0x56, 12 },{ 0x57, 12 },{ 0x7, 4 },{ 0x19, 9 },
{ 0x5, 11 },{ 0xf, 6 },{ 0x4, 11 },{ 0xe, 6 },
{ 0xd, 6 },{ 0xc, 6 },{ 0x13, 7 },{ 0x12, 7 },
{ 0x11, 7 },{ 0x10, 7 },{ 0x1a, 8 },{ 0x19, 8 },
{ 0x18, 8 },{ 0x17, 8 },{ 0x16, 8 },{ 0x15, 8 },
{ 0x14, 8 },{ 0x13, 8 },{ 0x18, 9 },{ 0x17, 9 },
{ 0x16, 9 },{ 0x15, 9 },{ 0x14, 9 },{ 0x13, 9 },
{ 0x12, 9 },{ 0x11, 9 },{ 0x7, 10 },{ 0x6, 10 },
{ 0x5, 10 },{ 0x4, 10 },{ 0x24, 11 },{ 0x25, 11 },
{ 0x26, 11 },{ 0x27, 11 },{ 0x58, 12 },{ 0x59, 12 },
{ 0x5a, 12 },{ 0x5b, 12 },{ 0x5c, 12 },{ 0x5d, 12 },
{ 0x5e, 12 },{ 0x5f, 12 },{ 0x3, 7 },

################################################################################

TITLE
    libavcodec h263 intra_vlc_aic

TYPE
    16

DATA
{  0x2,  2 }, {  0x6,  3 }, {  0xe,  4 }, {  0xc,  5 },
{  0xd,  5 }, { 0x10,  6 }, { 0x11,  6 }, { 0x12,  6 },
{ 0x16,  7 }, { 0x1b,  8 }, { 0x20,  9 }, { 0x21,  9 },
{ 0x1a,  9 }, { 0x1b,  9 }, { 0x1c,  9 }, { 0x1d,  9 },
{ 0x1e,  9 }, { 0x1f,  9 }, { 0x23, 11 }, { 0x22, 11 },
{ 0x57, 12 }, { 0x56, 12 }, { 0x55, 12 }, { 0x54, 12 },
{ 0x53, 12 }, {  0xf,  4 }, { 0x14,  6 }, { 0x14,  7 },
{ 0x1e,  8 }, {  0xf, 10 }, { 0x21, 11 }, { 0x50, 12 },
{  0xb,  5 }, { 0x15,  7 }, {  0xe, 10 }, {  0x9, 10 },
{ 0x15,  6 }, { 0x1d,  8 }, {  0xd, 10 }, { 0x51, 12 },
{ 0x13,  6 }, { 0x23,  9 }, {  0x7, 11 }, { 0x17,  7 },
{ 0x22,  9 }, { 0x52, 12 }, { 0x1c,  8 }, {  0xc, 10 },
{ 0x1f,  8 }, {  0xb, 10 }, { 0x25,  9 }, {  0xa, 10 },
{ 0x24,  9 }, {  0x6, 11 }, { 0x21, 10 }, { 0x20, 10 },
{  0x8, 10 }, { 0x20, 11 }, {  0x7,  4 }, {  0xc,  6 },
{ 0x10,  7 }, { 0x13,  8 }, { 0x11,  9 }, { 0x12,  9 },
{  0x4, 10 }, { 0x27, 11 }, { 0x26, 11 }, { 0x5f, 12 },
{  0xf,  6 }, { 0x13,  9 }, {  0x5, 10 }, { 0x25, 11 },
{  0xe,  6 }, { 0x14,  9 }, { 0x24, 11 }, {  0xd,  6 },
{  0x6, 10 }, { 0x5e, 12 }, { 0x11,  7 }, {  0x7, 10 },
{ 0x13,  7 }, { 0x5d, 12 }, { 0x12,  7 }, { 0x5c, 12 },
{ 0x14,  8 }, { 0x5b, 12 }, { 0x15,  8 }, { 0x1a,  8 },
{ 0x19,  8 }, { 0x18,  8 }, { 0x17,  8 }, { 0x16,  8 },
{ 0x19,  9 }, { 0x15,  9 }, { 0x16,  9 }, { 0x18,  9 },
{ 0x17,  9 }, {  0x4, 11 }, {  0x5, 11 }, { 0x58, 12 },
{ 0x59, 12 }, { 0x5a, 12 }, {  0x3,  7 },

################################################################################

TITLE
    libavcodec h264 tc0_table

TYPE
    8

DATA
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 },
    {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 0 }, {-1, 0, 0, 1 },
    {-1, 0, 0, 1 }, {-1, 0, 0, 1 }, {-1, 0, 0, 1 }, {-1, 0, 1, 1 }, {-1, 0, 1, 1 }, {-1, 1, 1, 1 },
    {-1, 1, 1, 1 }, {-1, 1, 1, 1 }, {-1, 1, 1, 1 }, {-1, 1, 1, 2 }, {-1, 1, 1, 2 }, {-1, 1, 1, 2 },
    {-1, 1, 1, 2 }, {-1, 1, 2, 3 }, {-1, 1, 2, 3 }, {-1, 2, 2, 3 }, {-1, 2, 2, 4 }, {-1, 2, 3, 4 },
    {-1, 2, 3, 4 }, {-1, 3, 3, 5 }, {-1, 3, 4, 6 }, {-1, 3, 4, 6 }, {-1, 4, 5, 7 }, {-1, 4, 5, 8 },
    {-1, 4, 6, 9 }, {-1, 5, 7,10 }, {-1, 6, 8,11 }, {-1, 6, 8,13 }, {-1, 7,10,14 }, {-1, 8,11,16 },
    {-1, 9,12,18 }, {-1,10,13,20 }, {-1,11,15,23 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },
    {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 }, {-1,13,17,25 },

################################################################################

TITLE
    libavcodec h264 cabac_context_init_I

TYPE
    8

DATA
{
    /* 0 - 10 */
    { 20, -15 }, {  2, 54 },  {  3,  74 }, { 20, -15 },
    {  2,  54 }, {  3, 74 },  { -28,127 }, { -23, 104 },
    { -6,  53 }, { -1, 54 },  {  7,  51 },

    /* 11 - 23 unsused for I */
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },

    /* 24- 39 */
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },

    /* 40 - 53 */
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },

    /* 54 - 59 */
    { 0, 0 },    { 0, 0 },    { 0, 0 },      { 0, 0 },
    { 0, 0 },    { 0, 0 },

    /* 60 - 69 */
    { 0, 41 },   { 0, 63 },   { 0, 63 },     { 0, 63 },
    { -9, 83 },  { 4, 86 },   { 0, 97 },     { -7, 72 },
    { 13, 41 },  { 3, 62 },

    /* 70 -> 87 */
    { 0, 11 },   { 1, 55 },   { 0, 69 },     { -17, 127 },
    { -13, 102 },{ 0, 82 },   { -7, 74 },    { -21, 107 },
    { -27, 127 },{ -31, 127 },{ -24, 127 },  { -18, 95 },
    { -27, 127 },{ -21, 114 },{ -30, 127 },  { -17, 123 },
    { -12, 115 },{ -16, 122 },

    /* 88 -> 104 */
    { -11, 115 },{ -12, 63 }, { -2, 68 },    { -15, 84 },
    { -13, 104 },{ -3, 70 },  { -8, 93 },    { -10, 90 },
    { -30, 127 },{ -1, 74 },  { -6, 97 },    { -7, 91 },
    { -20, 127 },{ -4, 56 },  { -5, 82 },    { -7, 76 },
    { -22, 125 },

    /* 105 -> 135 */
    { -7, 93 },  { -11, 87 }, { -3, 77 },    { -5, 71 },
    { -4, 63 },  { -4, 68 },  { -12, 84 },   { -7, 62 },
    { -7, 65 },  { 8, 61 },   { 5, 56 },     { -2, 66 },
    { 1, 64 },   { 0, 61 },   { -2, 78 },    { 1, 50 },
    { 7, 52 },   { 10, 35 },  { 0, 44 },     { 11, 38 },
    { 1, 45 },   { 0, 46 },   { 5, 44 },     { 31, 17 },
    { 1, 51 },   { 7, 50 },   { 28, 19 },    { 16, 33 },
    { 14, 62 },  { -13, 108 },{ -15, 100 },

    /* 136 -> 165 */
    { -13, 101 },{ -13, 91 }, { -12, 94 },   { -10, 88 },
    { -16, 84 }, { -10, 86 }, { -7, 83 },    { -13, 87 },
    { -19, 94 }, { 1, 70 },   { 0, 72 },     { -5, 74 },
    { 18, 59 },  { -8, 102 }, { -15, 100 },  { 0, 95 },
    { -4, 75 },  { 2, 72 },   { -11, 75 },   { -3, 71 },
    { 15, 46 },  { -13, 69 }, { 0, 62 },     { 0, 65 },
    { 21, 37 },  { -15, 72 }, { 9, 57 },     { 16, 54 },
    { 0, 62 },   { 12, 72 },

    /* 166 -> 196 */
    { 24, 0 },   { 15, 9 },   { 8, 25 },     { 13, 18 },
    { 15, 9 },   { 13, 19 },  { 10, 37 },    { 12, 18 },
    { 6, 29 },   { 20, 33 },  { 15, 30 },    { 4, 45 },
    { 1, 58 },   { 0, 62 },   { 7, 61 },     { 12, 38 },
    { 11, 45 },  { 15, 39 },  { 11, 42 },    { 13, 44 },
    { 16, 45 },  { 12, 41 },  { 10, 49 },    { 30, 34 },
    { 18, 42 },  { 10, 55 },  { 17, 51 },    { 17, 46 },
    { 0, 89 },   { 26, -19 }, { 22, -17 },

    /* 197 -> 226 */
    { 26, -17 }, { 30, -25 }, { 28, -20 },   { 33, -23 },
    { 37, -27 }, { 33, -23 }, { 40, -28 },   { 38, -17 },
    { 33, -11 }, { 40, -15 }, { 41, -6 },    { 38, 1 },
    { 41, 17 },  { 30, -6 },  { 27, 3 },     { 26, 22 },
    { 37, -16 }, { 35, -4 },  { 38, -8 },    { 38, -3 },
    { 37, 3 },   { 38, 5 },   { 42, 0 },     { 35, 16 },
    { 39, 22 },  { 14, 48 },  { 27, 37 },    { 21, 60 },
    { 12, 68 },  { 2, 97 },

    /* 227 -> 251 */
    { -3, 71 },  { -6, 42 },  { -5, 50 },    { -3, 54 },
    { -2, 62 },  { 0, 58 },   { 1, 63 },     { -2, 72 },
    { -1, 74 },  { -9, 91 },  { -5, 67 },    { -5, 27 },
    { -3, 39 },  { -2, 44 },  { 0, 46 },     { -16, 64 },
    { -8, 68 },  { -10, 78 }, { -6, 77 },    { -10, 86 },
    { -12, 92 }, { -15, 55 }, { -10, 60 },   { -6, 62 },
    { -4, 65 },

    /* 252 -> 275 */
    { -12, 73 }, { -8, 76 },  { -7, 80 },    { -9, 88 },
    { -17, 110 },{ -11, 97 }, { -20, 84 },   { -11, 79 },
    { -6, 73 },  { -4, 74 },  { -13, 86 },   { -13, 96 },
    { -11, 97 }, { -19, 117 },{ -8, 78 },    { -5, 33 },
    { -4, 48 },  { -2, 53 },  { -3, 62 },    { -13, 71 },
    { -10, 79 }, { -12, 86 }, { -13, 90 },   { -14, 97 },

    /* 276 a bit special (not used, bypass is used instead) */
    { 0, 0 },

    /* 277 -> 307 */
    { -6, 93 },  { -6, 84 },  { -8, 79 },    { 0, 66 },
    { -1, 71 },  { 0, 62 },   { -2, 60 },    { -2, 59 },
    { -5, 75 },  { -3, 62 },  { -4, 58 },    { -9, 66 },
    { -1, 79 },  { 0, 71 },   { 3, 68 },     { 10, 44 },
    { -7, 62 },  { 15, 36 },  { 14, 40 },    { 16, 27 },
    { 12, 29 },  { 1, 44 },   { 20, 36 },    { 18, 32 },
    { 5, 42 },   { 1, 48 },   { 10, 62 },    { 17, 46 },
    { 9, 64 },   { -12, 104 },{ -11, 97 },

    /* 308 -> 337 */
    { -16, 96 }, { -7, 88 },  { -8, 85 },    { -7, 85 },
    { -9, 85 },  { -13, 88 }, { 4, 66 },     { -3, 77 },
    { -3, 76 },  { -6, 76 },  { 10, 58 },    { -1, 76 },
    { -1, 83 },  { -7, 99 },  { -14, 95 },   { 2, 95 },
    { 0, 76 },   { -5, 74 },  { 0, 70 },     { -11, 75 },
    { 1, 68 },   { 0, 65 },   { -14, 73 },   { 3, 62 },
    { 4, 62 },   { -1, 68 },  { -13, 75 },   { 11, 55 },
    { 5, 64 },   { 12, 70 },

    /* 338 -> 368 */
    { 15, 6 },   { 6, 19 },   { 7, 16 },     { 12, 14 },
    { 18, 13 },  { 13, 11 },  { 13, 15 },    { 15, 16 },
    { 12, 23 },  { 13, 23 },  { 15, 20 },    { 14, 26 },
    { 14, 44 },  { 17, 40 },  { 17, 47 },    { 24, 17 },
    { 21, 21 },  { 25, 22 },  { 31, 27 },    { 22, 29 },
    { 19, 35 },  { 14, 50 },  { 10, 57 },    { 7, 63 },
    { -2, 77 },  { -4, 82 },  { -3, 94 },    { 9, 69 },
    { -12, 109 },{ 36, -35 }, { 36, -34 },

    /* 369 -> 398 */
    { 32, -26 }, { 37, -30 }, { 44, -32 },   { 34, -18 },
    { 34, -15 }, { 40, -15 }, { 33, -7 },    { 35, -5 },
    { 33, 0 },   { 38, 2 },   { 33, 13 },    { 23, 35 },
    { 13, 58 },  { 29, -3 },  { 26, 0 },     { 22, 30 },
    { 31, -7 },  { 35, -15 }, { 34, -3 },    { 34, 3 },
    { 36, -1 },  { 34, 5 },   { 32, 11 },    { 35, 5 },
    { 34, 12 },  { 39, 11 },  { 30, 29 },    { 34, 26 },
    { 29, 39 },  { 19, 66 },

    /* 399 -> 435 */
    {  31,  21 }, {  31,  31 }, {  25,  50 },
    { -17, 120 }, { -20, 112 }, { -18, 114 }, { -11,  85 },
    { -15,  92 }, { -14,  89 }, { -26,  71 }, { -15,  81 },
    { -14,  80 }, {   0,  68 }, { -14,  70 }, { -24,  56 },
    { -23,  68 }, { -24,  50 }, { -11,  74 }, {  23, -13 },
    {  26, -13 }, {  40, -15 }, {  49, -14 }, {  44,   3 },
    {  45,   6 }, {  44,  34 }, {  33,  54 }, {  19,  82 },
    {  -3,  75 }, {  -1,  23 }, {   1,  34 }, {   1,  43 },
    {   0,  54 }, {  -2,  55 }, {   0,  61 }, {   1,  64 },
    {   0,  68 }, {  -9,  92 },

    /* 436 -> 459 */
    { -14, 106 }, { -13,  97 }, { -15,  90 }, { -12,  90 },
    { -18,  88 }, { -10,  73 }, {  -9,  79 }, { -14,  86 },
    { -10,  73 }, { -10,  70 }, { -10,  69 }, {  -5,  66 },
    {  -9,  64 }, {  -5,  58 }, {   2,  59 }, {  21, -10 },
    {  24, -11 }, {  28,  -8 }, {  28,  -1 }, {  29,   3 },
    {  29,   9 }, {  35,  20 }, {  29,  36 }, {  14,  67 }

################################################################################

TITLE
    libavcodec h264 cabac_context_init_PB

TYPE
    8

DATA
    /* i_cabac_init_idc == 0 */
    {
        /* 0 - 10 */
        {  20, -15 }, {   2,  54 }, {   3,  74 }, {  20, -15 },
        {   2,  54 }, {   3,  74 }, { -28, 127 }, { -23, 104 },
        {  -6,  53 }, {  -1,  54 }, {   7,  51 },

        /* 11 - 23 */
        {  23,  33 }, {  23,   2 }, {  21,   0 }, {   1,   9 },
        {   0,  49 }, { -37, 118 }, {   5,  57 }, { -13,  78 },
        { -11,  65 }, {   1,  62 }, {  12,  49 }, {  -4,  73 },
        {  17,  50 },

        /* 24 - 39 */
        {  18,  64 }, {   9,  43 }, {  29,   0 }, {  26,  67 },
        {  16,  90 }, {   9, 104 }, { -46, 127 }, { -20, 104 },
        {   1,  67 }, { -13,  78 }, { -11,  65 }, {   1,  62 },
        {  -6,  86 }, { -17,  95 }, {  -6,  61 }, {   9,  45 },

        /* 40 - 53 */
        {  -3,  69 }, {  -6,  81 }, { -11,  96 }, {   6,  55 },
        {   7,  67 }, {  -5,  86 }, {   2,  88 }, {   0,  58 },
        {  -3,  76 }, { -10,  94 }, {   5,  54 }, {   4,  69 },
        {  -3,  81 }, {   0,  88 },

        /* 54 - 59 */
        {  -7,  67 }, {  -5,  74 }, {  -4,  74 }, {  -5,  80 },
        {  -7,  72 }, {   1,  58 },

        /* 60 - 69 */
        {   0,  41 }, {   0,  63 }, {   0,  63 }, { 0, 63 },
        {  -9,  83 }, {   4,  86 }, {   0,  97 }, { -7, 72 },
        {  13,  41 }, {   3,  62 },

        /* 70 - 87 */
        {   0,  45 }, {  -4,  78 }, {  -3,  96 }, { -27,  126 },
        { -28,  98 }, { -25, 101 }, { -23,  67 }, { -28,  82 },
        { -20,  94 }, { -16,  83 }, { -22, 110 }, { -21,  91 },
        { -18, 102 }, { -13,  93 }, { -29, 127 }, {  -7,  92 },
        {  -5,  89 }, {  -7,  96 }, { -13, 108 }, {  -3,  46 },
        {  -1,  65 }, {  -1,  57 }, {  -9,  93 }, {  -3,  74 },
        {  -9,  92 }, {  -8,  87 }, { -23, 126 }, {   5,  54 },
        {   6,  60 }, {   6,  59 }, {   6,  69 }, {  -1,  48 },
        {   0,  68 }, {  -4,  69 }, {  -8,  88 },

        /* 105 -> 165 */
        {  -2,  85 }, {  -6,  78 }, {  -1,  75 }, {  -7,  77 },
        {   2,  54 }, {   5,  50 }, {  -3,  68 }, {   1,  50 },
        {   6,  42 }, {  -4,  81 }, {   1,  63 }, {  -4,  70 },
        {   0,  67 }, {   2,  57 }, {  -2,  76 }, {  11,  35 },
        {   4,  64 }, {   1,  61 }, {  11,  35 }, {  18,  25 },
        {  12,  24 }, {  13,  29 }, {  13,  36 }, { -10,  93 },
        {  -7,  73 }, {  -2,  73 }, {  13,  46 }, {   9,  49 },
        {  -7, 100 }, {   9,  53 }, {   2,  53 }, {   5,  53 },
        {  -2,  61 }, {   0,  56 }, {   0,  56 }, { -13,  63 },
        {  -5,  60 }, {  -1,  62 }, {   4,  57 }, {  -6,  69 },
        {   4,  57 }, {  14,  39 }, {   4,  51 }, {  13,  68 },
        {   3,  64 }, {   1,  61 }, {   9,  63 }, {   7,  50 },
        {  16,  39 }, {   5,  44 }, {   4,  52 }, {  11,  48 },
        {  -5,  60 }, {  -1,  59 }, {   0,  59 }, {  22,  33 },
        {   5,  44 }, {  14,  43 }, {  -1,  78 }, {   0,  60 },
        {   9,  69 },

        /* 166 - 226 */
        {  11,  28 }, {   2,  40 }, {   3,  44 }, {   0,  49 },
        {   0,  46 }, {   2,  44 }, {   2,  51 }, {   0,  47 },
        {   4,  39 }, {   2,  62 }, {   6,  46 }, {   0,  54 },
        {   3,  54 }, {   2,  58 }, {   4,  63 }, {   6,  51 },
        {   6,  57 }, {   7,  53 }, {   6,  52 }, {   6,  55 },
        {  11,  45 }, {  14,  36 }, {   8,  53 }, {  -1,  82 },
        {   7,  55 }, {  -3,  78 }, {  15,  46 }, {  22,  31 },
        {  -1,  84 }, {  25,   7 }, {  30,  -7 }, {  28,   3 },
        {  28,   4 }, {  32,   0 }, {  34,  -1 }, {  30,   6 },
        {  30,   6 }, {  32,   9 }, {  31,  19 }, {  26,  27 },
        {  26,  30 }, {  37,  20 }, {  28,  34 }, {  17,  70 },
        {   1,  67 }, {   5,  59 }, {   9,  67 }, {  16,  30 },
        {  18,  32 }, {  18,  35 }, {  22,  29 }, {  24,  31 },
        {  23,  38 }, {  18,  43 }, {  20,  41 }, {  11,  63 },
        {   9,  59 }, {   9,  64 }, {  -1,  94 }, {  -2,  89 },
        {  -9, 108 },

        /* 227 - 275 */
        {  -6,  76 }, {  -2,  44 }, {   0,  45 }, {   0,  52 },
        {  -3,  64 }, {  -2,  59 }, {  -4,  70 }, {  -4,  75 },
        {  -8,  82 }, { -17, 102 }, {  -9,  77 }, {   3,  24 },
        {   0,  42 }, {   0,  48 }, {   0,  55 }, {  -6,  59 },
        {  -7,  71 }, { -12,  83 }, { -11,  87 }, { -30, 119 },
        {   1,  58 }, {  -3,  29 }, {  -1,  36 }, {   1,  38 },
        {   2,  43 }, {  -6,  55 }, {   0,  58 }, {   0,  64 },
        {  -3,  74 }, { -10,  90 }, {   0,  70 }, {  -4,  29 },
        {   5,  31 }, {   7,  42 }, {   1,  59 }, {  -2,  58 },
        {  -3,  72 }, {  -3,  81 }, { -11,  97 }, {   0,  58 },
        {   8,   5 }, {  10,  14 }, {  14,  18 }, {  13,  27 },
        {   2,  40 }, {   0,  58 }, {  -3,  70 }, {  -6,  79 },
        {  -8,  85 },

        /* 276 a bit special (not used, bypass is used instead) */
        { 0, 0 },

        /* 277 - 337 */
        { -13, 106 }, { -16, 106 }, { -10,  87 }, { -21, 114 },
        { -18, 110 }, { -14,  98 }, { -22, 110 }, { -21, 106 },
        { -18, 103 }, { -21, 107 }, { -23, 108 }, { -26, 112 },
        { -10,  96 }, { -12,  95 }, {  -5,  91 }, {  -9,  93 },
        { -22,  94 }, {  -5,  86 }, {   9,  67 }, {  -4,  80 },
        { -10,  85 }, {  -1,  70 }, {   7,  60 }, {   9,  58 },
        {   5,  61 }, {  12,  50 }, {  15,  50 }, {  18,  49 },
        {  17,  54 }, {  10,  41 }, {   7,  46 }, {  -1,  51 },
        {   7,  49 }, {   8,  52 }, {   9,  41 }, {   6,  47 },
        {   2,  55 }, {  13,  41 }, {  10,  44 }, {   6,  50 },
        {   5,  53 }, {  13,  49 }, {   4,  63 }, {   6,  64 },
        {  -2,  69 }, {  -2,  59 }, {   6,  70 }, {  10,  44 },
        {   9,  31 }, {  12,  43 }, {   3,  53 }, {  14,  34 },
        {  10,  38 }, {  -3,  52 }, {  13,  40 }, {  17,  32 },
        {   7,  44 }, {   7,  38 }, {  13,  50 }, {  10,  57 },
        {  26,  43 },

        /* 338 - 398 */
        {  14,  11 }, {  11,  14 }, {   9,  11 }, {  18,  11 },
        {  21,   9 }, {  23,  -2 }, {  32, -15 }, {  32, -15 },
        {  34, -21 }, {  39, -23 }, {  42, -33 }, {  41, -31 },
        {  46, -28 }, {  38, -12 }, {  21,  29 }, {  45, -24 },
        {  53, -45 }, {  48, -26 }, {  65, -43 }, {  43, -19 },
        {  39, -10 }, {  30,   9 }, {  18,  26 }, {  20,  27 },
        {   0,  57 }, { -14,  82 }, {  -5,  75 }, { -19,  97 },
        { -35, 125 }, {  27,   0 }, {  28,   0 }, {  31,  -4 },
        {  27,   6 }, {  34,   8 }, {  30,  10 }, {  24,  22 },
        {  33,  19 }, {  22,  32 }, {  26,  31 }, {  21,  41 },
        {  26,  44 }, {  23,  47 }, {  16,  65 }, {  14,  71 },
        {   8,  60 }, {   6,  63 }, {  17,  65 }, {  21,  24 },
        {  23,  20 }, {  26,  23 }, {  27,  32 }, {  28,  23 },
        {  28,  24 }, {  23,  40 }, {  24,  32 }, {  28,  29 },
        {  23,  42 }, {  19,  57 }, {  22,  53 }, {  22,  61 },
        {  11,  86 },

        /* 399 - 435 */
        {  12,  40 }, {  11,  51 }, {  14,  59 },
        {  -4,  79 }, {  -7,  71 }, {  -5,  69 }, {  -9,  70 },
        {  -8,  66 }, { -10,  68 }, { -19,  73 }, { -12,  69 },
        { -16,  70 }, { -15,  67 }, { -20,  62 }, { -19,  70 },
        { -16,  66 }, { -22,  65 }, { -20,  63 }, {   9,  -2 },
        {  26,  -9 }, {  33,  -9 }, {  39,  -7 }, {  41,  -2 },
        {  45,   3 }, {  49,   9 }, {  45,  27 }, {  36,  59 },
        {  -6,  66 }, {  -7,  35 }, {  -7,  42 }, {  -8,  45 },
        {  -5,  48 }, { -12,  56 }, {  -6,  60 }, {  -5,  62 },
        {  -8,  66 }, {  -8,  76 },

        /* 436 - 459 */
        {  -5,  85 }, {  -6,  81 }, { -10,  77 }, {  -7,  81 },
        { -17,  80 }, { -18,  73 }, {  -4,  74 }, { -10,  83 },
        {  -9,  71 }, {  -9,  67 }, {  -1,  61 }, {  -8,  66 },
        { -14,  66 }, {   0,  59 }, {   2,  59 }, {  21, -13 },
        {  33, -14 }, {  39,  -7 }, {  46,  -2 }, {  51,   2 },
        {  60,   6 }, {  61,  17 }, {  55,  34 }, {  42,  62 },
    },

    /* i_cabac_init_idc == 1 */
    {
        /* 0 - 10 */
        {  20, -15 }, {   2,  54 }, {   3,  74 }, {  20, -15 },
        {   2,  54 }, {   3,  74 }, { -28, 127 }, { -23, 104 },
        {  -6,  53 }, {  -1,  54 }, {   7,  51 },

        /* 11 - 23 */
        {  22,  25 }, {  34,   0 }, {  16,   0 }, {  -2,   9 },
        {   4,  41 }, { -29, 118 }, {   2,  65 }, {  -6,  71 },
        { -13,  79 }, {   5,  52 }, {   9,  50 }, {  -3,  70 },
        {  10,  54 },

        /* 24 - 39 */
        {  26,  34 }, {  19,  22 }, {  40,   0 }, {  57,   2 },
        {  41,  36 }, {  26,  69 }, { -45, 127 }, { -15, 101 },
        {  -4,  76 }, {  -6,  71 }, { -13,  79 }, {   5,  52 },
        {   6,  69 }, { -13,  90 }, {   0,  52 }, {   8,  43 },

        /* 40 - 53 */
        {  -2,  69 },{  -5,  82 },{ -10,  96 },{   2,  59 },
        {   2,  75 },{  -3,  87 },{  -3,  100 },{   1,  56 },
        {  -3,  74 },{  -6,  85 },{   0,  59 },{  -3,  81 },
        {  -7,  86 },{  -5,  95 },

        /* 54 - 59 */
        {  -1,  66 },{  -1,  77 },{   1,  70 },{  -2,  86 },
        {  -5,  72 },{   0,  61 },

        /* 60 - 69 */
        { 0, 41 },   { 0, 63 },   { 0, 63 },     { 0, 63 },
        { -9, 83 },  { 4, 86 },   { 0, 97 },     { -7, 72 },
        { 13, 41 },  { 3, 62 },

        /* 70 - 104 */
        {  13,  15 }, {   7,  51 }, {   2,  80 }, { -39, 127 },
        { -18,  91 }, { -17,  96 }, { -26,  81 }, { -35,  98 },
        { -24, 102 }, { -23,  97 }, { -27, 119 }, { -24,  99 },
        { -21, 110 }, { -18, 102 }, { -36, 127 }, {   0,  80 },
        {  -5,  89 }, {  -7,  94 }, {  -4,  92 }, {   0,  39 },
        {   0,  65 }, { -15,  84 }, { -35, 127 }, {  -2,  73 },
        { -12, 104 }, {  -9,  91 }, { -31, 127 }, {   3,  55 },
        {   7,  56 }, {   7,  55 }, {   8,  61 }, {  -3,  53 },
        {   0,  68 }, {  -7,  74 }, {  -9,  88 },

        /* 105 -> 165 */
        { -13, 103 }, { -13,  91 }, {  -9,  89 }, { -14,  92 },
        {  -8,  76 }, { -12,  87 }, { -23, 110 }, { -24, 105 },
        { -10,  78 }, { -20, 112 }, { -17,  99 }, { -78, 127 },
        { -70, 127 }, { -50, 127 }, { -46, 127 }, {  -4,  66 },
        {  -5,  78 }, {  -4,  71 }, {  -8,  72 }, {   2,  59 },
        {  -1,  55 }, {  -7,  70 }, {  -6,  75 }, {  -8,  89 },
        { -34, 119 }, {  -3,  75 }, {  32,  20 }, {  30,  22 },
        { -44, 127 }, {   0,  54 }, {  -5,  61 }, {   0,  58 },
        {  -1,  60 }, {  -3,  61 }, {  -8,  67 }, { -25,  84 },
        { -14,  74 }, {  -5,  65 }, {   5,  52 }, {   2,  57 },
        {   0,  61 }, {  -9,  69 }, { -11,  70 }, {  18,  55 },
        {  -4,  71 }, {   0,  58 }, {   7,  61 }, {   9,  41 },
        {  18,  25 }, {   9,  32 }, {   5,  43 }, {   9,  47 },
        {   0,  44 }, {   0,  51 }, {   2,  46 }, {  19,  38 },
        {  -4,  66 }, {  15,  38 }, {  12,  42 }, {   9,  34 },
        {   0,  89 },

        /* 166 - 226 */
        {   4,  45 }, {  10,  28 }, {  10,  31 }, {  33, -11 },
        {  52, -43 }, {  18,  15 }, {  28,   0 }, {  35, -22 },
        {  38, -25 }, {  34,   0 }, {  39, -18 }, {  32, -12 },
        { 102, -94 }, {   0,   0 }, {  56, -15 }, {  33,  -4 },
        {  29,  10 }, {  37,  -5 }, {  51, -29 }, {  39,  -9 },
        {  52, -34 }, {  69, -58 }, {  67, -63 }, {  44,  -5 },
        {  32,   7 }, {  55, -29 }, {  32,   1 }, {   0,   0 },
        {  27,  36 }, {  33, -25 }, {  34, -30 }, {  36, -28 },
        {  38, -28 }, {  38, -27 }, {  34, -18 }, {  35, -16 },
        {  34, -14 }, {  32,  -8 }, {  37,  -6 }, {  35,   0 },
        {  30,  10 }, {  28,  18 }, {  26,  25 }, {  29,  41 },
        {   0,  75 }, {   2,  72 }, {   8,  77 }, {  14,  35 },
        {  18,  31 }, {  17,  35 }, {  21,  30 }, {  17,  45 },
        {  20,  42 }, {  18,  45 }, {  27,  26 }, {  16,  54 },
        {   7,  66 }, {  16,  56 }, {  11,  73 }, {  10,  67 },
        { -10, 116 },

        /* 227 - 275 */
        { -23, 112 }, { -15,  71 }, {  -7,  61 }, {   0,  53 },
        {  -5,  66 }, { -11,  77 }, {  -9,  80 }, {  -9,  84 },
        { -10,  87 }, { -34, 127 }, { -21, 101 }, {  -3,  39 },
        {  -5,  53 }, {  -7,  61 }, { -11,  75 }, { -15,  77 },
        { -17,  91 }, { -25, 107 }, { -25, 111 }, { -28, 122 },
        { -11,  76 }, { -10,  44 }, { -10,  52 }, { -10,  57 },
        {  -9,  58 }, { -16,  72 }, {  -7,  69 }, {  -4,  69 },
        {  -5,  74 }, {  -9,  86 }, {   2,  66 }, {  -9,  34 },
        {   1,  32 }, {  11,  31 }, {   5,  52 }, {  -2,  55 },
        {  -2,  67 }, {   0,  73 }, {  -8,  89 }, {   3,  52 },
        {   7,   4 }, {  10,   8 }, {  17,   8 }, {  16,  19 },
        {   3,  37 }, {  -1,  61 }, {  -5,  73 }, {  -1,  70 },
        {  -4,  78 },

        /* 276 a bit special (not used, bypass is used instead) */
        { 0, 0 },

        /* 277 - 337 */
        { -21, 126 }, { -23, 124 }, { -20, 110 }, { -26, 126 },
        { -25, 124 }, { -17, 105 }, { -27, 121 }, { -27, 117 },
        { -17, 102 }, { -26, 117 }, { -27, 116 }, { -33, 122 },
        { -10,  95 }, { -14, 100 }, {  -8,  95 }, { -17, 111 },
        { -28, 114 }, {  -6,  89 }, {  -2,  80 }, {  -4,  82 },
        {  -9,  85 }, {  -8,  81 }, {  -1,  72 }, {   5,  64 },
        {   1,  67 }, {   9,  56 }, {   0,  69 }, {   1,  69 },
        {   7,  69 }, {  -7,  69 }, {  -6,  67 }, { -16,  77 },
        {  -2,  64 }, {   2,  61 }, {  -6,  67 }, {  -3,  64 },
        {   2,  57 }, {  -3,  65 }, {  -3,  66 }, {   0,  62 },
        {   9,  51 }, {  -1,  66 }, {  -2,  71 }, {  -2,  75 },
        {  -1,  70 }, {  -9,  72 }, {  14,  60 }, {  16,  37 },
        {   0,  47 }, {  18,  35 }, {  11,  37 }, {  12,  41 },
        {  10,  41 }, {   2,  48 }, {  12,  41 }, {  13,  41 },
        {   0,  59 }, {   3,  50 }, {  19,  40 }, {   3,  66 },
        {  18,  50 },

        /* 338 - 398 */
        {  19,  -6 }, {  18,  -6 }, {  14,   0 }, {  26, -12 },
        {  31, -16 }, {  33, -25 }, {  33, -22 }, {  37, -28 },
        {  39, -30 }, {  42, -30 }, {  47, -42 }, {  45, -36 },
        {  49, -34 }, {  41, -17 }, {  32,   9 }, {  69, -71 },
        {  63, -63 }, {  66, -64 }, {  77, -74 }, {  54, -39 },
        {  52, -35 }, {  41, -10 }, {  36,   0 }, {  40,  -1 },
        {  30,  14 }, {  28,  26 }, {  23,  37 }, {  12,  55 },
        {  11,  65 }, {  37, -33 }, {  39, -36 }, {  40, -37 },
        {  38, -30 }, {  46, -33 }, {  42, -30 }, {  40, -24 },
        {  49, -29 }, {  38, -12 }, {  40, -10 }, {  38,  -3 },
        {  46,  -5 }, {  31,  20 }, {  29,  30 }, {  25,  44 },
        {  12,  48 }, {  11,  49 }, {  26,  45 }, {  22,  22 },
        {  23,  22 }, {  27,  21 }, {  33,  20 }, {  26,  28 },
        {  30,  24 }, {  27,  34 }, {  18,  42 }, {  25,  39 },
        {  18,  50 }, {  12,  70 }, {  21,  54 }, {  14,  71 },
        {  11,  83 },

        /* 399 - 435 */
        {  25,  32 }, {  21,  49 }, {  21,  54 },
        {  -5,  85 }, {  -6,  81 }, { -10,  77 }, {  -7,  81 },
        { -17,  80 }, { -18,  73 }, {  -4,  74 }, { -10,  83 },
        {  -9,  71 }, {  -9,  67 }, {  -1,  61 }, {  -8,  66 },
        { -14,  66 }, {   0,  59 }, {   2,  59 }, {  17, -10 },
        {  32, -13 }, {  42,  -9 }, {  49,  -5 }, {  53,   0 },
        {  64,   3 }, {  68,  10 }, {  66,  27 }, {  47,  57 },
        {  -5,  71 }, {   0,  24 }, {  -1,  36 }, {  -2,  42 },
        {  -2,  52 }, {  -9,  57 }, {  -6,  63 }, {  -4,  65 },
        {  -4,  67 }, {  -7,  82 },

        /* 436 - 459 */
        {  -3,  81 }, {  -3,  76 }, {  -7,  72 }, {  -6,  78 },
        { -12,  72 }, { -14,  68 }, {  -3,  70 }, {  -6,  76 },
        {  -5,  66 }, {  -5,  62 }, {   0,  57 }, {  -4,  61 },
        {  -9,  60 }, {   1,  54 }, {   2,  58 }, {  17, -10 },
        {  32, -13 }, {  42,  -9 }, {  49,  -5 }, {  53,   0 },
        {  64,   3 }, {  68,  10 }, {  66,  27 }, {  47,  57 },
    },

    /* i_cabac_init_idc == 2 */
    {
        /* 0 - 10 */
        {  20, -15 }, {   2,  54 }, {   3,  74 }, {  20, -15 },
        {   2,  54 }, {   3,  74 }, { -28, 127 }, { -23, 104 },
        {  -6,  53 }, {  -1,  54 }, {   7,  51 },

        /* 11 - 23 */
        {  29,  16 }, {  25,   0 }, {  14,   0 }, { -10,  51 },
        {  -3,  62 }, { -27,  99 }, {  26,  16 }, {  -4,  85 },
        { -24, 102 }, {   5,  57 }, {   6,  57 }, { -17,  73 },
        {  14,  57 },

        /* 24 - 39 */
        {  20,  40 }, {  20,  10 }, {  29,   0 }, {  54,   0 },
        {  37,  42 }, {  12,  97 }, { -32, 127 }, { -22, 117 },
        {  -2,  74 }, {  -4,  85 }, { -24, 102 }, {   5,  57 },
        {  -6,  93 }, { -14,  88 }, {  -6,  44 }, {   4,  55 },

        /* 40 - 53 */
        { -11,  89 },{ -15,  103 },{ -21,  116 },{  19,  57 },
        {  20,  58 },{   4,  84 },{   6,  96 },{   1,  63 },
        {  -5,  85 },{ -13,  106 },{   5,  63 },{   6,  75 },
        {  -3,  90 },{  -1,  101 },

        /* 54 - 59 */
        {   3,  55 },{  -4,  79 },{  -2,  75 },{ -12,  97 },
        {  -7,  50 },{   1,  60 },

        /* 60 - 69 */
        { 0, 41 },   { 0, 63 },   { 0, 63 },     { 0, 63 },
        { -9, 83 },  { 4, 86 },   { 0, 97 },     { -7, 72 },
        { 13, 41 },  { 3, 62 },

        /* 70 - 104 */
        {   7,  34 }, {  -9,  88 }, { -20, 127 }, { -36, 127 },
        { -17,  91 }, { -14,  95 }, { -25,  84 }, { -25,  86 },
        { -12,  89 }, { -17,  91 }, { -31, 127 }, { -14,  76 },
        { -18, 103 }, { -13,  90 }, { -37, 127 }, {  11,  80 },
        {   5,  76 }, {   2,  84 }, {   5,  78 }, {  -6,  55 },
        {   4,  61 }, { -14,  83 }, { -37, 127 }, {  -5,  79 },
        { -11, 104 }, { -11,  91 }, { -30, 127 }, {   0,  65 },
        {  -2,  79 }, {   0,  72 }, {  -4,  92 }, {  -6,  56 },
        {   3,  68 }, {  -8,  71 }, { -13,  98 },

        /* 105 -> 165 */
        {  -4,  86 }, { -12,  88 }, {  -5,  82 }, {  -3,  72 },
        {  -4,  67 }, {  -8,  72 }, { -16,  89 }, {  -9,  69 },
        {  -1,  59 }, {   5,  66 }, {   4,  57 }, {  -4,  71 },
        {  -2,  71 }, {   2,  58 }, {  -1,  74 }, {  -4,  44 },
        {  -1,  69 }, {   0,  62 }, {  -7,  51 }, {  -4,  47 },
        {  -6,  42 }, {  -3,  41 }, {  -6,  53 }, {   8,  76 },
        {  -9,  78 }, { -11,  83 }, {   9,  52 }, {   0,  67 },
        {  -5,  90 }, {   1,  67 }, { -15,  72 }, {  -5,  75 },
        {  -8,  80 }, { -21,  83 }, { -21,  64 }, { -13,  31 },
        { -25,  64 }, { -29,  94 }, {   9,  75 }, {  17,  63 },
        {  -8,  74 }, {  -5,  35 }, {  -2,  27 }, {  13,  91 },
        {   3,  65 }, {  -7,  69 }, {   8,  77 }, { -10,  66 },
        {   3,  62 }, {  -3,  68 }, { -20,  81 }, {   0,  30 },
        {   1,   7 }, {  -3,  23 }, { -21,  74 }, {  16,  66 },
        { -23, 124 }, {  17,  37 }, {  44, -18 }, {  50, -34 },
        { -22, 127 },

        /* 166 - 226 */
        {   4,  39 }, {   0,  42 }, {   7,  34 }, {  11,  29 },
        {   8,  31 }, {   6,  37 }, {   7,  42 }, {   3,  40 },
        {   8,  33 }, {  13,  43 }, {  13,  36 }, {   4,  47 },
        {   3,  55 }, {   2,  58 }, {   6,  60 }, {   8,  44 },
        {  11,  44 }, {  14,  42 }, {   7,  48 }, {   4,  56 },
        {   4,  52 }, {  13,  37 }, {   9,  49 }, {  19,  58 },
        {  10,  48 }, {  12,  45 }, {   0,  69 }, {  20,  33 },
        {   8,  63 }, {  35, -18 }, {  33, -25 }, {  28,  -3 },
        {  24,  10 }, {  27,   0 }, {  34, -14 }, {  52, -44 },
        {  39, -24 }, {  19,  17 }, {  31,  25 }, {  36,  29 },
        {  24,  33 }, {  34,  15 }, {  30,  20 }, {  22,  73 },
        {  20,  34 }, {  19,  31 }, {  27,  44 }, {  19,  16 },
        {  15,  36 }, {  15,  36 }, {  21,  28 }, {  25,  21 },
        {  30,  20 }, {  31,  12 }, {  27,  16 }, {  24,  42 },
        {   0,  93 }, {  14,  56 }, {  15,  57 }, {  26,  38 },
        { -24, 127 },

        /* 227 - 275 */
        { -24, 115 }, { -22,  82 }, {  -9,  62 }, {   0,  53 },
        {   0,  59 }, { -14,  85 }, { -13,  89 }, { -13,  94 },
        { -11,  92 }, { -29, 127 }, { -21, 100 }, { -14,  57 },
        { -12,  67 }, { -11,  71 }, { -10,  77 }, { -21,  85 },
        { -16,  88 }, { -23, 104 }, { -15,  98 }, { -37, 127 },
        { -10,  82 }, {  -8,  48 }, {  -8,  61 }, {  -8,  66 },
        {  -7,  70 }, { -14,  75 }, { -10,  79 }, {  -9,  83 },
        { -12,  92 }, { -18, 108 }, {  -4,  79 }, { -22,  69 },
        { -16,  75 }, {  -2,  58 }, {   1,  58 }, { -13,  78 },
        {  -9,  83 }, {  -4,  81 }, { -13,  99 }, { -13,  81 },
        {  -6,  38 }, { -13,  62 }, {  -6,  58 }, {  -2,  59 },
        { -16,  73 }, { -10,  76 }, { -13,  86 }, {  -9,  83 },
        { -10,  87 },

        /* 276 a bit special (not used, bypass is used instead) */
        { 0, 0 },

        /* 277 - 337 */
        { -22, 127 }, { -25, 127 }, { -25, 120 }, { -27, 127 },
        { -19, 114 }, { -23, 117 }, { -25, 118 }, { -26, 117 },
        { -24, 113 }, { -28, 118 }, { -31, 120 }, { -37, 124 },
        { -10,  94 }, { -15, 102 }, { -10,  99 }, { -13, 106 },
        { -50, 127 }, {  -5,  92 }, {  17,  57 }, {  -5,  86 },
        { -13,  94 }, { -12,  91 }, {  -2,  77 }, {   0,  71 },
        {  -1,  73 }, {   4,  64 }, {  -7,  81 }, {   5,  64 },
        {  15,  57 }, {   1,  67 }, {   0,  68 }, { -10,  67 },
        {   1,  68 }, {   0,  77 }, {   2,  64 }, {   0,  68 },
        {  -5,  78 }, {   7,  55 }, {   5,  59 }, {   2,  65 },
        {  14,  54 }, {  15,  44 }, {   5,  60 }, {   2,  70 },
        {  -2,  76 }, { -18,  86 }, {  12,  70 }, {   5,  64 },
        { -12,  70 }, {  11,  55 }, {   5,  56 }, {   0,  69 },
        {   2,  65 }, {  -6,  74 }, {   5,  54 }, {   7,  54 },
        {  -6,  76 }, { -11,  82 }, {  -2,  77 }, {  -2,  77 },
        {  25,  42 },

        /* 338 - 398 */
        {  17, -13 }, {  16,  -9 }, {  17, -12 }, {  27, -21 },
        {  37, -30 }, {  41, -40 }, {  42, -41 }, {  48, -47 },
        {  39, -32 }, {  46, -40 }, {  52, -51 }, {  46, -41 },
        {  52, -39 }, {  43, -19 }, {  32,  11 }, {  61, -55 },
        {  56, -46 }, {  62, -50 }, {  81, -67 }, {  45, -20 },
        {  35,  -2 }, {  28,  15 }, {  34,   1 }, {  39,   1 },
        {  30,  17 }, {  20,  38 }, {  18,  45 }, {  15,  54 },
        {   0,  79 }, {  36, -16 }, {  37, -14 }, {  37, -17 },
        {  32,   1 }, {  34,  15 }, {  29,  15 }, {  24,  25 },
        {  34,  22 }, {  31,  16 }, {  35,  18 }, {  31,  28 },
        {  33,  41 }, {  36,  28 }, {  27,  47 }, {  21,  62 },
        {  18,  31 }, {  19,  26 }, {  36,  24 }, {  24,  23 },
        {  27,  16 }, {  24,  30 }, {  31,  29 }, {  22,  41 },
        {  22,  42 }, {  16,  60 }, {  15,  52 }, {  14,  60 },
        {   3,  78 }, { -16, 123 }, {  21,  53 }, {  22,  56 },
        {  25,  61 },

        /* 399 - 435 */
        {  21,  33 }, {  19,  50 }, {  17,  61 },
        {  -3,  78 }, {  -8,  74 }, {  -9,  72 }, { -10,  72 },
        { -18,  75 }, { -12,  71 }, { -11,  63 }, {  -5,  70 },
        { -17,  75 }, { -14,  72 }, { -16,  67 }, {  -8,  53 },
        { -14,  59 }, {  -9,  52 }, { -11,  68 }, {   9,  -2 },
        {  30, -10 }, {  31,  -4 }, {  33,  -1 }, {  33,   7 },
        {  31,  12 }, {  37,  23 }, {  31,  38 }, {  20,  64 },
        {  -9,  71 }, {  -7,  37 }, {  -8,  44 }, { -11,  49 },
        { -10,  56 }, { -12,  59 }, {  -8,  63 }, {  -9,  67 },
        {  -6,  68 }, { -10,  79 },

        /* 436 - 459 */
        {  -3,  78 }, {  -8,  74 }, {  -9,  72 }, { -10,  72 },
        { -18,  75 }, { -12,  71 }, { -11,  63 }, {  -5,  70 },
        { -17,  75 }, { -14,  72 }, { -16,  67 }, {  -8,  53 },
        { -14,  59 }, {  -9,  52 }, { -11,  68 }, {   9,  -2 },
        {  30, -10 }, {  31,  -4 }, {  33,  -1 }, {  33,   7 },
        {  31,  12 }, {  37,  23 }, {  31,  38 }, {  20,  64 },
    }

################################################################################

TITLE
    libavcodec h264 quant_coeff

TYPE
    32

DATA
    { 419430, 258111, 419430, 258111, 258111, 167772, 258111, 167772, 419430, 258111, 419430, 258111, 258111, 167772, 258111, 167772,},
    { 381300, 239675, 381300, 239675, 239675, 149131, 239675, 149131, 381300, 239675, 381300, 239675, 239675, 149131, 239675, 149131,},
    { 322639, 209715, 322639, 209715, 209715, 134218, 209715, 134218, 322639, 209715, 322639, 209715, 209715, 134218, 209715, 134218,},
    { 299593, 186414, 299593, 186414, 186414, 116711, 186414, 116711, 299593, 186414, 299593, 186414, 186414, 116711, 186414, 116711,},
    { 262144, 167772, 262144, 167772, 167772, 107374, 167772, 107374, 262144, 167772, 262144, 167772, 167772, 107374, 167772, 107374,},
    { 233017, 145889, 233017, 145889, 145889,  92564, 145889,  92564, 233017, 145889, 233017, 145889, 145889,  92564, 145889,  92564,},
    { 209715, 129056, 209715, 129056, 129056,  83886, 129056,  83886, 209715, 129056, 209715, 129056, 129056,  83886, 129056,  83886,},
    { 190650, 119837, 190650, 119837, 119837,  74565, 119837,  74565, 190650, 119837, 190650, 119837, 119837,  74565, 119837,  74565,},
    { 161319, 104858, 161319, 104858, 104858,  67109, 104858,  67109, 161319, 104858, 161319, 104858, 104858,  67109, 104858,  67109,},
    { 149797,  93207, 149797,  93207,  93207,  58356,  93207,  58356, 149797,  93207, 149797,  93207,  93207,  58356,  93207,  58356,},
    { 131072,  83886, 131072,  83886,  83886,  53687,  83886,  53687, 131072,  83886, 131072,  83886,  83886,  53687,  83886,  53687,},
    { 116508,  72944, 116508,  72944,  72944,  46282,  72944,  46282, 116508,  72944, 116508,  72944,  72944,  46282,  72944,  46282,},
    { 104858,  64528, 104858,  64528,  64528,  41943,  64528,  41943, 104858,  64528, 104858,  64528,  64528,  41943,  64528,  41943,},
    {  95325,  59919,  95325,  59919,  59919,  37283,  59919,  37283,  95325,  59919,  95325,  59919,  59919,  37283,  59919,  37283,},
    {  80660,  52429,  80660,  52429,  52429,  33554,  52429,  33554,  80660,  52429,  80660,  52429,  52429,  33554,  52429,  33554,},
    {  74898,  46603,  74898,  46603,  46603,  29178,  46603,  29178,  74898,  46603,  74898,  46603,  46603,  29178,  46603,  29178,},
    {  65536,  41943,  65536,  41943,  41943,  26844,  41943,  26844,  65536,  41943,  65536,  41943,  41943,  26844,  41943,  26844,},
    {  58254,  36472,  58254,  36472,  36472,  23141,  36472,  23141,  58254,  36472,  58254,  36472,  36472,  23141,  36472,  23141,},
    {  52429,  32264,  52429,  32264,  32264,  20972,  32264,  20972,  52429,  32264,  52429,  32264,  32264,  20972,  32264,  20972,},
    {  47663,  29959,  47663,  29959,  29959,  18641,  29959,  18641,  47663,  29959,  47663,  29959,  29959,  18641,  29959,  18641,},
    {  40330,  26214,  40330,  26214,  26214,  16777,  26214,  16777,  40330,  26214,  40330,  26214,  26214,  16777,  26214,  16777,},
    {  37449,  23302,  37449,  23302,  23302,  14589,  23302,  14589,  37449,  23302,  37449,  23302,  23302,  14589,  23302,  14589,},
    {  32768,  20972,  32768,  20972,  20972,  13422,  20972,  13422,  32768,  20972,  32768,  20972,  20972,  13422,  20972,  13422,},
    {  29127,  18236,  29127,  18236,  18236,  11570,  18236,  11570,  29127,  18236,  29127,  18236,  18236,  11570,  18236,  11570,},
    {  26214,  16132,  26214,  16132,  16132,  10486,  16132,  10486,  26214,  16132,  26214,  16132,  16132,  10486,  16132,  10486,},
    {  23831,  14980,  23831,  14980,  14980,   9321,  14980,   9321,  23831,  14980,  23831,  14980,  14980,   9321,  14980,   9321,},
    {  20165,  13107,  20165,  13107,  13107,   8389,  13107,   8389,  20165,  13107,  20165,  13107,  13107,   8389,  13107,   8389,},
    {  18725,  11651,  18725,  11651,  11651,   7294,  11651,   7294,  18725,  11651,  18725,  11651,  11651,   7294,  11651,   7294,},
    {  16384,  10486,  16384,  10486,  10486,   6711,  10486,   6711,  16384,  10486,  16384,  10486,  10486,   6711,  10486,   6711,},
    {  14564,   9118,  14564,   9118,   9118,   5785,   9118,   5785,  14564,   9118,  14564,   9118,   9118,   5785,   9118,   5785,},
    {  13107,   8066,  13107,   8066,   8066,   5243,   8066,   5243,  13107,   8066,  13107,   8066,   8066,   5243,   8066,   5243,},
    {  11916,   7490,  11916,   7490,   7490,   4660,   7490,   4660,  11916,   7490,  11916,   7490,   7490,   4660,   7490,   4660,},
    {  10082,   6554,  10082,   6554,   6554,   4194,   6554,   4194,  10082,   6554,  10082,   6554,   6554,   4194,   6554,   4194,},
    {   9362,   5825,   9362,   5825,   5825,   3647,   5825,   3647,   9362,   5825,   9362,   5825,   5825,   3647,   5825,   3647,},
    {   8192,   5243,   8192,   5243,   5243,   3355,   5243,   3355,   8192,   5243,   8192,   5243,   5243,   3355,   5243,   3355,},
    {   7282,   4559,   7282,   4559,   4559,   2893,   4559,   2893,   7282,   4559,   7282,   4559,   4559,   2893,   4559,   2893,},
    {   6554,   4033,   6554,   4033,   4033,   2621,   4033,   2621,   6554,   4033,   6554,   4033,   4033,   2621,   4033,   2621,},
    {   5958,   3745,   5958,   3745,   3745,   2330,   3745,   2330,   5958,   3745,   5958,   3745,   3745,   2330,   3745,   2330,},
    {   5041,   3277,   5041,   3277,   3277,   2097,   3277,   2097,   5041,   3277,   5041,   3277,   3277,   2097,   3277,   2097,},
    {   4681,   2913,   4681,   2913,   2913,   1824,   2913,   1824,   4681,   2913,   4681,   2913,   2913,   1824,   2913,   1824,},
    {   4096,   2621,   4096,   2621,   2621,   1678,   2621,   1678,   4096,   2621,   4096,   2621,   2621,   1678,   2621,   1678,},
    {   3641,   2280,   3641,   2280,   2280,   1446,   2280,   1446,   3641,   2280,   3641,   2280,   2280,   1446,   2280,   1446,},
    {   3277,   2016,   3277,   2016,   2016,   1311,   2016,   1311,   3277,   2016,   3277,   2016,   2016,   1311,   2016,   1311,},
    {   2979,   1872,   2979,   1872,   1872,   1165,   1872,   1165,   2979,   1872,   2979,   1872,   1872,   1165,   1872,   1165,},
    {   2521,   1638,   2521,   1638,   1638,   1049,   1638,   1049,   2521,   1638,   2521,   1638,   1638,   1049,   1638,   1049,},
    {   2341,   1456,   2341,   1456,   1456,    912,   1456,    912,   2341,   1456,   2341,   1456,   1456,    912,   1456,    912,},
    {   2048,   1311,   2048,   1311,   1311,    839,   1311,    839,   2048,   1311,   2048,   1311,   1311,    839,   1311,    839,},
    {   1820,   1140,   1820,   1140,   1140,    723,   1140,    723,   1820,   1140,   1820,   1140,   1140,    723,   1140,    723,},
    {   1638,   1008,   1638,   1008,   1008,    655,   1008,    655,   1638,   1008,   1638,   1008,   1008,    655,   1008,    655,},
    {   1489,    936,   1489,    936,    936,    583,    936,    583,   1489,    936,   1489,    936,    936,    583,    936,    583,},
    {   1260,    819,   1260,    819,    819,    524,    819,    524,   1260,    819,   1260,    819,    819,    524,    819,    524,},
    {   1170,    728,   1170,    728,    728,    456,    728,    456,   1170,    728,   1170,    728,    728,    456,    728,    456,},

################################################################################

TITLE
    libavcodec huffyuv classic_shift_luma

TYPE
    8

DATA
  34,36,35,69,135,232,9,16,10,24,11,23,12,16,13,10,14,8,15,8,
  16,8,17,20,16,10,207,206,205,236,11,8,10,21,9,23,8,8,199,70,
  69,68, 0

################################################################################

TITLE
    libavcodec huffyuv classic_shift_chroma

TYPE
    8

DATA
  66,36,37,38,39,40,41,75,76,77,110,239,144,81,82,83,84,85,118,183,
  56,57,88,89,56,89,154,57,58,57,26,141,57,56,58,57,58,57,184,119,
  214,245,116,83,82,49,80,79,78,77,44,75,41,40,39,38,37,36,34, 0

################################################################################

TITLE
    libavcodec huffyuv classic_add_luma

TYPE
    8

DATA
    3,  9,  5, 12, 10, 35, 32, 29, 27, 50, 48, 45, 44, 41, 39, 37,
   73, 70, 68, 65, 64, 61, 58, 56, 53, 50, 49, 46, 44, 41, 38, 36,
   68, 65, 63, 61, 58, 55, 53, 51, 48, 46, 45, 43, 41, 39, 38, 36,
   35, 33, 32, 30, 29, 27, 26, 25, 48, 47, 46, 44, 43, 41, 40, 39,
   37, 36, 35, 34, 32, 31, 30, 28, 27, 26, 24, 23, 22, 20, 19, 37,
   35, 34, 33, 31, 30, 29, 27, 26, 24, 23, 21, 20, 18, 17, 15, 29,
   27, 26, 24, 22, 21, 19, 17, 16, 14, 26, 25, 23, 21, 19, 18, 16,
   15, 27, 25, 23, 21, 19, 17, 16, 14, 26, 25, 23, 21, 18, 17, 14,
   12, 17, 19, 13,  4,  9,  2, 11,  1,  7,  8,  0, 16,  3, 14,  6,
   12, 10,  5, 15, 18, 11, 10, 13, 15, 16, 19, 20, 22, 24, 27, 15,
   18, 20, 22, 24, 26, 14, 17, 20, 22, 24, 27, 15, 18, 20, 23, 25,
   28, 16, 19, 22, 25, 28, 32, 36, 21, 25, 29, 33, 38, 42, 45, 49,
   28, 31, 34, 37, 40, 42, 44, 47, 49, 50, 52, 54, 56, 57, 59, 60,
   62, 64, 66, 67, 69, 35, 37, 39, 40, 42, 43, 45, 47, 48, 51, 52,
   54, 55, 57, 59, 60, 62, 63, 66, 67, 69, 71, 72, 38, 40, 42, 43,
   46, 47, 49, 51, 26, 28, 30, 31, 33, 34, 18, 19, 11, 13,  7,  8,

################################################################################

TITLE
    libavcodec imc_weights1

TYPE
    FLOAT

DATA
    0.119595, 0.123124, 0.129192, 9.97377e-2, 8.1923e-2, 9.61153e-2, 8.77885e-2, 8.61174e-2,
    9.00882e-2, 9.91658e-2, 0.112991, 0.131126, 0.152886, 0.177292, 0.221782, 0.244917, 0.267386,
    0.306816, 0.323046, 0.33729, 0.366773, 0.392557, 0.398076, 0.403302, 0.42451, 0.444777,
    0.449188, 0.455445, 0.477853, 0.500669, 0.510395};

################################################################################

TITLE
    libavcodec imc_weights2

TYPE
    FLOAT

DATA
    3.23466e-3, 3.49886e-3, 3.98413e-3, 1.98116e-3, 1.16465e-3, 1.79283e-3, 1.40372e-3, 1.33274e-3,
    1.50523e-3, 1.95064e-3, 2.77472e-3, 4.14725e-3, 6.2776e-3, 9.36401e-3, 1.71397e-2, 2.24052e-2,
    2.83971e-2, 4.11689e-2, 4.73165e-2, 5.31631e-2, 6.66614e-2, 8.00824e-2, 8.31588e-2, 8.61397e-2,
    9.89229e-2, 0.112197, 0.115227, 0.119613, 0.136174, 0.15445, 0.162685};

################################################################################

TITLE
    libavcodec imc_quantizer1

TYPE
    FLOAT

DATA
    { 8.4431201e-1, 4.7358301e-1, 1.448354, 2.7073899e-1, 7.4449003e-1, 1.241991,  1.845484,  0.0},
    { 8.6876702e-1, 4.7659001e-1, 1.478224, 2.5672799e-1, 7.55777e-1,   1.3229851, 2.03438,   0.0},
    { 7.5891501e-1, 6.2272799e-1, 1.271322, 3.47904e-1,   7.5317699e-1, 1.150767,  1.628476,  0.0},
    { 7.65257e-1,   6.44647e-1,   1.263824, 3.4548101e-1, 7.6384902e-1, 1.214466,  1.7638789, 0.0},

################################################################################

TITLE
    libavcodec imc_quantizer2

TYPE
    FLOAT

DATA
    { 1.39236e-1, 3.50548e-1, 5.9547901e-1, 8.5772401e-1, 1.121545, 1.3882281, 1.695882, 2.1270809,
      7.2221003e-2, 1.85177e-1, 2.9521701e-1, 4.12568e-1, 5.4068601e-1, 6.7679501e-1, 8.1196898e-1, 9.4765198e-1,
      1.0779999, 1.203415, 1.337265, 1.481871, 1.639982, 1.814766, 2.0701399, 2.449862,
      3.7533998e-2, 1.02722e-1, 1.6021401e-1, 2.16043e-1, 2.7231601e-1, 3.3025399e-1, 3.9022601e-1, 4.52849e-1,
      5.1794899e-1, 5.8529502e-1, 6.53956e-1, 7.2312802e-1, 7.9150802e-1, 8.5891002e-1, 9.28141e-1, 9.9706203e-1,
      1.062153, 1.12564, 1.189834, 1.256122, 1.324469, 1.3955311, 1.468906, 1.545084,
      1.6264729, 1.711524, 1.802705, 1.91023, 2.0533991, 2.22333, 2.4830019, 3.253329 },
    { 1.11654e-1, 3.54469e-1, 6.4232099e-1, 9.6128798e-1, 1.295053, 1.61777, 1.989839, 2.51107,
      5.7721999e-2, 1.69879e-1, 2.97589e-1, 4.3858799e-1, 5.9039903e-1, 7.4934798e-1, 9.1628098e-1, 1.087297,
      1.262751, 1.4288321, 1.6040879, 1.79067, 2.000668, 2.2394669, 2.649332, 5.2760072,
      2.9722e-2, 8.7316997e-2, 1.4445201e-1, 2.04247e-1, 2.6879501e-1, 3.3716801e-1, 4.08811e-1, 4.8306999e-1,
      5.6049401e-1, 6.3955498e-1, 7.2044599e-1, 8.0427998e-1, 8.8933599e-1, 9.7537601e-1, 1.062461, 1.1510431,
      1.240236, 1.326715, 1.412513, 1.500502, 1.591749, 1.686413, 1.785239, 1.891233,
      2.0051291, 2.127681, 2.2709141, 2.475826, 2.7219379, 3.101985, 4.686213, 6.2287788},

################################################################################

TITLE
    libavcodec imc_exp_tab

TYPE
    FLOAT

DATA
    1.778280e-4, 3.162278e-4, 5.623413e-4, 1.000000e-3,
    1.778280e-3, 3.162278e-3, 5.623413e-3, 1.000000e-2,
    1.778280e-2, 3.162278e-2, 5.623413e-2, 1.000000e-1,
    1.778280e-1, 3.162278e-1, 5.623413e-1, 1.000000e00,
    1.778280e00, 3.162278e00, 5.623413e00, 1.000000e01,
    1.778280e01, 3.162278e01, 5.623413e01, 1.000000e02,
    1.778280e02, 3.162278e02, 5.623413e02, 1.000000e03,
    1.778280e03, 3.162278e03, 5.623413e03, 1.000000e04

################################################################################

TITLE
    libavcodec imc_huffman_lens

TYPE
    8

DATA
        { 16, 15, 13, 11,  8,  5,  3,  1,  2,  4,  6,  9, 10, 12, 14, 16,  7,  0 },
        { 10,  8,  7,  6,  4,  4,  3,  2,  2,  3,  4,  6,  7,  9, 11, 11,  7,  0 },
        { 15, 15, 14, 11,  8,  6,  4,  2,  1,  4,  5,  7,  9, 10, 12, 13,  4,  0 },
        { 13, 11, 10,  8,  6,  4,  2,  2,  2,  3,  5,  7,  9, 12, 15, 15, 14,  0 },
    },
    {
        { 14, 12, 10,  8,  7,  4,  2,  2,  2,  3,  5,  7,  9, 11, 13, 14,  7,  0 },
        { 14, 13, 11,  8,  6,  4,  3,  2,  2,  3,  5,  7,  9, 10, 12, 14,  3,  0 },
        { 13, 12, 10,  7,  5,  4,  3,  2,  2,  3,  4,  6,  8,  9, 11, 13,  4,  0 },
        { 13, 12, 10,  7,  5,  4,  3,  2,  2,  3,  4,  6,  8,  9, 11, 13,  4,  0 },
    },
    {
        { 16, 14, 12, 10,  8,  5,  3,  1,  2,  4,  7,  9, 11, 13, 15, 17,  6, 17 },
        { 15, 13, 11,  8,  6,  4,  2,  2,  2,  3,  5,  7, 10, 12, 14, 16,  9, 16 },
        { 14, 12, 11,  9,  8,  6,  3,  1,  2,  5,  7, 10, 13, 15, 16, 17,  4, 17 },
        { 16, 14, 12,  9,  7,  5,  2,  2,  2,  3,  4,  6,  8, 11, 13, 15, 10, 16 },
    },
    {
        { 13, 11, 10,  8,  7,  5,  2,  2,  2,  4,  6,  9, 12, 14, 15, 16,  3, 16 },
        { 11, 11, 10,  9,  8,  7,  5,  4,  3,  3,  3,  3,  3,  3,  4,  5,  6,  5 },
        {  9,  9,  7,  6,  5,  4,  3,  3,  2,  3,  4,  5,  4,  5,  5,  6,  8,  6 },
        { 13, 12, 10,  8,  5,  3,  3,  2,  2,  3,  4,  7,  9, 11, 14, 15,  6, 15 },

################################################################################

TITLE
    libavcodec imc_huffman_bits

TYPE
    16

DATA
    {
        { 0xCC32, 0x6618, 0x1987, 0x0660, 0x00CD, 0x0018, 0x0007, 0x0000, 0x0002, 0x000D, 0x0032, 0x0199, 0x0331, 0x0CC2, 0x330D, 0xCC33, 0x0067, 0x0000 },
        { 0x02FE, 0x00BE, 0x005E, 0x002D, 0x000A, 0x0009, 0x0003, 0x0003, 0x0000, 0x0002, 0x0008, 0x002C, 0x005D, 0x017E, 0x05FE, 0x05FF, 0x005C, 0x0000 },
        { 0x5169, 0x5168, 0x28B5, 0x0517, 0x00A3, 0x0029, 0x0008, 0x0003, 0x0000, 0x0009, 0x0015, 0x0050, 0x0144, 0x028A, 0x0A2C, 0x145B, 0x000B, 0x0000 },
        { 0x1231, 0x048D, 0x0247, 0x0090, 0x0025, 0x0008, 0x0001, 0x0003, 0x0000, 0x0005, 0x0013, 0x0049, 0x0122, 0x0919, 0x48C3, 0x48C2, 0x2460, 0x0000 },
    },
    {
        { 0x2D1D, 0x0B46, 0x02D0, 0x00B5, 0x0059, 0x000A, 0x0003, 0x0001, 0x0000, 0x0004, 0x0017, 0x005B, 0x0169, 0x05A2, 0x168F, 0x2D1C, 0x0058, 0x0000 },
        { 0x1800, 0x0C01, 0x0301, 0x0061, 0x0019, 0x0007, 0x0004, 0x0003, 0x0000, 0x0005, 0x000D, 0x0031, 0x00C1, 0x0181, 0x0601, 0x1801, 0x0002, 0x0000 },
        { 0x1556, 0x0AAA, 0x02AB, 0x0054, 0x0014, 0x000B, 0x0002, 0x0003, 0x0000, 0x0003, 0x0008, 0x002B, 0x00AB, 0x0154, 0x0554, 0x1557, 0x0009, 0x0000 },
        { 0x1556, 0x0AAA, 0x02AB, 0x0054, 0x0014, 0x000B, 0x0002, 0x0003, 0x0000, 0x0003, 0x0008, 0x002B, 0x00AB, 0x0154, 0x0554, 0x1557, 0x0009, 0x0000 },
    },
    {
        { 0x2993, 0x0A65, 0x0298, 0x00A7, 0x0028, 0x0004, 0x0000, 0x0001, 0x0001, 0x0003, 0x0015, 0x0052, 0x014D, 0x0533, 0x14C8, 0x5324, 0x000B, 0x5325 },
        { 0x09B8, 0x026F, 0x009A, 0x0012, 0x0005, 0x0000, 0x0001, 0x0002, 0x0003, 0x0001, 0x0003, 0x0008, 0x004C, 0x0136, 0x04DD, 0x1373, 0x0027, 0x1372 },
        { 0x0787, 0x01E0, 0x00F1, 0x003D, 0x001F, 0x0006, 0x0001, 0x0001, 0x0001, 0x0002, 0x000E, 0x0079, 0x03C2, 0x0F0D, 0x1E19, 0x3C30, 0x0000, 0x3C31 },
        { 0x4B06, 0x12C0, 0x04B1, 0x0097, 0x0024, 0x0008, 0x0002, 0x0003, 0x0000, 0x0003, 0x0005, 0x0013, 0x004A, 0x0259, 0x0961, 0x2582, 0x012D, 0x4B07 },
    },
    {
        { 0x0A5A, 0x0297, 0x014A, 0x0053, 0x0028, 0x000B, 0x0003, 0x0000, 0x0002, 0x0004, 0x0015, 0x00A4, 0x052C, 0x14B7, 0x296C, 0x52DB, 0x0003, 0x52DA },
        { 0x0193, 0x0192, 0x00C8, 0x0065, 0x0033, 0x0018, 0x0007, 0x0004, 0x0000, 0x0004, 0x0005, 0x0007, 0x0006, 0x0003, 0x0005, 0x0005, 0x000D, 0x0004 },
        { 0x0012, 0x0013, 0x0005, 0x0003, 0x0000, 0x0003, 0x0005, 0x0004, 0x0003, 0x0003, 0x0005, 0x0005, 0x0004, 0x0004, 0x0003, 0x0005, 0x0008, 0x0004 },
        { 0x0D66, 0x06B2, 0x01AD, 0x006A, 0x000C, 0x0005, 0x0004, 0x0000, 0x0003, 0x0002, 0x0007, 0x0034, 0x00D7, 0x0358, 0x1ACF, 0x359C, 0x001B, 0x359D },
    }

################################################################################

TITLE
    libavcodec indeo ir2_codes le

TYPE
    16

DATA
{0x0000,  3}, {0x0004,  3}, {0x0006,  3}, {0x0001,  5},
{0x0009,  5}, {0x0019,  5}, {0x000D,  5}, {0x001D,  5},
{0x0023,  6}, {0x0013,  6}, {0x0033,  6}, {0x000B,  6},
{0x002B,  6}, {0x001B,  6}, {0x0007,  8}, {0x0087,  8},
{0x0027,  8}, {0x00A7,  8}, {0x0067,  8}, {0x00E7,  8},
{0x0097,  8}, {0x0057,  8}, {0x0037,  8}, {0x00B7,  8},
{0x00F7,  8}, {0x000F,  9}, {0x008F,  9}, {0x018F,  9},
{0x014F,  9}, {0x00CF,  9}, {0x002F,  9}, {0x012F,  9},
{0x01AF,  9}, {0x006F,  9}, {0x00EF,  9}, {0x01EF,  9},
{0x001F, 10}, {0x021F, 10}, {0x011F, 10}, {0x031F, 10},
{0x009F, 10}, {0x029F, 10}, {0x019F, 10}, {0x039F, 10},
{0x005F, 10}, {0x025F, 10}, {0x015F, 10}, {0x035F, 10},
{0x00DF, 10}, {0x02DF, 10}, {0x01DF, 10}, {0x03DF, 10},
{0x003F, 13}, {0x103F, 13}, {0x083F, 13}, {0x183F, 13},
{0x043F, 13}, {0x143F, 13}, {0x0C3F, 13}, {0x1C3F, 13},
{0x023F, 13}, {0x123F, 13}, {0x0A3F, 13}, {0x1A3F, 13},
{0x063F, 13}, {0x163F, 13}, {0x0E3F, 13}, {0x1E3F, 13},
{0x013F, 13}, {0x113F, 13}, {0x093F, 13}, {0x193F, 13},
{0x053F, 13}, {0x153F, 13}, {0x0D3F, 13}, {0x1D3F, 13},
{0x033F, 13}, {0x133F, 13}, {0x0B3F, 13}, {0x1B3F, 13},
{0x073F, 13}, {0x173F, 13}, {0x0F3F, 13}, {0x1F3F, 13},
{0x00BF, 13}, {0x10BF, 13}, {0x08BF, 13}, {0x18BF, 13},
{0x04BF, 13}, {0x14BF, 13}, {0x0CBF, 13}, {0x1CBF, 13},
{0x02BF, 13}, {0x12BF, 13}, {0x0ABF, 13}, {0x1ABF, 13},
{0x06BF, 13}, {0x16BF, 13}, {0x0EBF, 13}, {0x1EBF, 13},
{0x01BF, 13}, {0x11BF, 13}, {0x09BF, 13}, {0x19BF, 13},
{0x05BF, 13}, {0x15BF, 13}, {0x0DBF, 13}, {0x1DBF, 13},
{0x03BF, 13}, {0x13BF, 13}, {0x0BBF, 13}, {0x1BBF, 13},
{0x07BF, 13}, {0x17BF, 13}, {0x0FBF, 13}, {0x1FBF, 13},
{0x007F, 14}, {0x207F, 14}, {0x107F, 14}, {0x307F, 14},
{0x087F, 14}, {0x287F, 14}, {0x187F, 14}, {0x387F, 14},
{0x047F, 14}, {0x247F, 14}, {0x147F, 14}, {0x0002,  3},
{0x0011,  5}, {0x0005,  5}, {0x0015,  5}, {0x0003,  6},
{0x003B,  6}, {0x0047,  8}, {0x00C7,  8}, {0x0017,  8},
{0x00D7,  8}, {0x0077,  8}, {0x010F,  9}, {0x004F,  9},
{0x01CF,  9}, {0x00AF,  9}, {0x016F,  9},

################################################################################

TITLE
    libavcodec indeo ir2_codes

TYPE
    16

DATA
    {0x0000,  3}, {0x0001,  3}, {0x0003,  3}, {0x0010,  5},
    {0x0012,  5}, {0x0013,  5}, {0x0016,  5}, {0x0017,  5},
    {0x0031,  6}, {0x0032,  6}, {0x0033,  6}, {0x0034,  6},
    {0x0035,  6}, {0x0036,  6}, {0x00E0,  8}, {0x00E1,  8},
    {0x00E4,  8}, {0x00E5,  8}, {0x00E6,  8}, {0x00E7,  8},
    {0x00E9,  8}, {0x00EA,  8}, {0x00EC,  8}, {0x00ED,  8},
    {0x00EF,  8}, {0x01E0,  9}, {0x01E2,  9}, {0x01E3,  9},
    {0x01E5,  9}, {0x01E6,  9}, {0x01E8,  9}, {0x01E9,  9},
    {0x01EB,  9}, {0x01EC,  9}, {0x01EE,  9}, {0x01EF,  9},
    {0x03E0, 10}, {0x03E1, 10}, {0x03E2, 10}, {0x03E3, 10},
    {0x03E4, 10}, {0x03E5, 10}, {0x03E6, 10}, {0x03E7, 10},
    {0x03E8, 10}, {0x03E9, 10}, {0x03EA, 10}, {0x03EB, 10},
    {0x03EC, 10}, {0x03ED, 10}, {0x03EE, 10}, {0x03EF, 10},
    {0x1F80, 13}, {0x1F81, 13}, {0x1F82, 13}, {0x1F83, 13},
    {0x1F84, 13}, {0x1F85, 13}, {0x1F86, 13}, {0x1F87, 13},
    {0x1F88, 13}, {0x1F89, 13}, {0x1F8A, 13}, {0x1F8B, 13},
    {0x1F8C, 13}, {0x1F8D, 13}, {0x1F8E, 13}, {0x1F8F, 13},
    {0x1F90, 13}, {0x1F91, 13}, {0x1F92, 13}, {0x1F93, 13},
    {0x1F94, 13}, {0x1F95, 13}, {0x1F96, 13}, {0x1F97, 13},
    {0x1F98, 13}, {0x1F99, 13}, {0x1F9A, 13}, {0x1F9B, 13},
    {0x1F9C, 13}, {0x1F9D, 13}, {0x1F9E, 13}, {0x1F9F, 13},
    {0x1FA0, 13}, {0x1FA1, 13}, {0x1FA2, 13}, {0x1FA3, 13},
    {0x1FA4, 13}, {0x1FA5, 13}, {0x1FA6, 13}, {0x1FA7, 13},
    {0x1FA8, 13}, {0x1FA9, 13}, {0x1FAA, 13}, {0x1FAB, 13},
    {0x1FAC, 13}, {0x1FAD, 13}, {0x1FAE, 13}, {0x1FAF, 13},
    {0x1FB0, 13}, {0x1FB1, 13}, {0x1FB2, 13}, {0x1FB3, 13},
    {0x1FB4, 13}, {0x1FB5, 13}, {0x1FB6, 13}, {0x1FB7, 13},
    {0x1FB8, 13}, {0x1FB9, 13}, {0x1FBA, 13}, {0x1FBB, 13},
    {0x1FBC, 13}, {0x1FBD, 13}, {0x1FBE, 13}, {0x1FBF, 13},
    {0x3F80, 14}, {0x3F81, 14}, {0x3F82, 14}, {0x3F83, 14},
    {0x3F84, 14}, {0x3F85, 14}, {0x3F86, 14}, {0x3F87, 14},
    {0x3F88, 14}, {0x3F89, 14}, {0x3F8A, 14}, {0x0002,  3},
    {0x0011,  5}, {0x0014,  5}, {0x0015,  5}, {0x0030,  6},
    {0x0037,  6}, {0x00E2,  8}, {0x00E3,  8}, {0x00E8,  8},
    {0x00EB,  8}, {0x00EE,  8}, {0x01E1,  9}, {0x01E4,  9},
    {0x01E7,  9}, {0x01EA,  9}, {0x01ED,  9}

################################################################################

TITLE
    libavcodec indeo ir2_luma_table

TYPE
    8

DATA
 0x80, 0x80, 0x84, 0x84, 0x7C, 0x7C, 0x7F, 0x85,
 0x81, 0x7B, 0x85, 0x7F, 0x7B, 0x81, 0x8C, 0x8C,
 0x74, 0x74, 0x83, 0x8D, 0x7D, 0x73, 0x8D, 0x83,
 0x73, 0x7D, 0x77, 0x89, 0x89, 0x77, 0x89, 0x77,
 0x77, 0x89, 0x8C, 0x95, 0x74, 0x6B, 0x95, 0x8C,
 0x6B, 0x74, 0x7C, 0x90, 0x84, 0x70, 0x90, 0x7C,
 0x70, 0x84, 0x96, 0x96, 0x6A, 0x6A, 0x82, 0x98,
 0x7E, 0x68, 0x98, 0x82, 0x68, 0x7E, 0x97, 0xA2,
 0x69, 0x5E, 0xA2, 0x97, 0x5E, 0x69, 0xA2, 0xA2,
 0x5E, 0x5E, 0x8B, 0xA3, 0x75, 0x5D, 0xA3, 0x8B,
 0x5D, 0x75, 0x71, 0x95, 0x8F, 0x6B, 0x95, 0x71,
 0x6B, 0x8F, 0x78, 0x9D, 0x88, 0x63, 0x9D, 0x78,
 0x63, 0x88, 0x7F, 0xA7, 0x81, 0x59, 0xA7, 0x7F,
 0x59, 0x81, 0xA4, 0xB1, 0x5C, 0x4F, 0xB1, 0xA4,
 0x4F, 0x5C, 0x96, 0xB1, 0x6A, 0x4F, 0xB1, 0x96,
 0x4F, 0x6A, 0xB2, 0xB2, 0x4E, 0x4E, 0x65, 0x9B,
 0x9B, 0x65, 0x9B, 0x65, 0x65, 0x9B, 0x89, 0xB4,
 0x77, 0x4C, 0xB4, 0x89, 0x4C, 0x77, 0x6A, 0xA3,
 0x96, 0x5D, 0xA3, 0x6A, 0x5D, 0x96, 0x73, 0xAC,
 0x8D, 0x54, 0xAC, 0x73, 0x54, 0x8D, 0xB4, 0xC3,
 0x4C, 0x3D, 0xC3, 0xB4, 0x3D, 0x4C, 0xA4, 0xC3,
 0x5C, 0x3D, 0xC3, 0xA4, 0x3D, 0x5C, 0xC4, 0xC4,
 0x3C, 0x3C, 0x96, 0xC6, 0x6A, 0x3A, 0xC6, 0x96,
 0x3A, 0x6A, 0x7C, 0xBA, 0x84, 0x46, 0xBA, 0x7C,
 0x46, 0x84, 0x5B, 0xAB, 0xA5, 0x55, 0xAB, 0x5B,
 0x55, 0xA5, 0x63, 0xB4, 0x9D, 0x4C, 0xB4, 0x63,
 0x4C, 0x9D, 0x86, 0xCA, 0x7A, 0x36, 0xCA, 0x86,
 0x36, 0x7A, 0xB6, 0xD7, 0x4A, 0x29, 0xD7, 0xB6,
 0x29, 0x4A, 0xC8, 0xD7, 0x38, 0x29, 0xD7, 0xC8,
 0x29, 0x38, 0xA4, 0xD8, 0x5C, 0x28, 0xD8, 0xA4,
 0x28, 0x5C, 0x6C, 0xC1, 0x94, 0x3F, 0xC1, 0x6C,
 0x3F, 0x94, 0xD9, 0xD9, 0x27, 0x27, 0x80, 0x80

################################################################################

TITLE
    libavcodec indeo3 corrector_type_0

TYPE
    8

DATA
    195, 159, 133, 115, 101,  93,  87,  77,
    195, 159, 133, 115, 101,  93,  87,  77,
    128,  79,  79,  79,  79,  79,  79,  79

################################################################################

TITLE
    libavcodec indeo3 correction

TYPE
    32

DATA
        0x00000000, 0x00000202, 0xfffffdfe, 0x000002ff, 0xfffffd01, 0xffffff03, 0x000000fd, 0x00000404,
        0xfffffbfc, 0x00000501, 0xfffffaff, 0x00000105, 0xfffffefb, 0x000003fc, 0xfffffc04, 0x000005fe,
        0xfffffa02, 0xfffffe06, 0x000001fa, 0x00000904, 0xfffff6fc, 0x00000409, 0xfffffbf7, 0x00000909,
        0xfffff6f7, 0x00000a01, 0xfffff5ff, 0x0000010a, 0xfffffef6, 0x000007fb, 0xfffff805, 0xfffffb08,
        0x000004f8, 0x00000f09, 0xfffff0f7, 0x0000090f, 0xfffff6f1, 0x00000bfd, 0xfffff403, 0xfffffd0c,
        0x000002f4, 0x00001004, 0xffffeffc, 0x00000410, 0xfffffbf0, 0x00001010, 0xffffeff0, 0x00001200,
        0xffffee00, 0x00000012, 0xffffffee, 0x00000bf4, 0xfffff40c, 0x00000ff7, 0xfffff009, 0xfffff710,
        0x000008f0, 0x00001b0b, 0xffffe4f5, 0x00000b1b, 0xfffff4e5, 0x00001c13, 0xffffe3ed, 0x0000131c,
        0xffffece4, 0x000015fa, 0xffffea06, 0xfffffa16, 0x000005ea, 0x00001d04, 0xffffe2fc, 0x0000041d,
        0xfffffbe3, 0x00001e1e, 0xffffe1e2, 0x000020fe, 0xffffdf02, 0xfffffe21, 0x000001df, 0x000016ee,
        0xffffe912, 0xffffee17, 0x000011e9, 0x00001df1, 0xffffe20f, 0xfffff11e, 0x00000ee2, 0x00002e16,
        0xffffd1ea, 0x0000162e, 0xffffe9d2, 0x00002f0d, 0xffffd0f3, 0x00000d2f, 0xfffff2d1, 0x00003123,
        0xffffcedd, 0x00002331, 0xffffdccf, 0x000028f5, 0xffffd70b, 0xfffff529, 0x00000ad7, 0x00003304,
        0xffffccfc, 0x00000433, 0xfffffbcd, 0x00003636, 0xffffc9ca, 0x000021de, 0xffffde22, 0x000029e3,
        0xffffd61d, 0xffffe32a, 0x00001cd6, 0x00003bfa, 0xffffc406, 0xfffffa3c, 0x000005c4, 0x00004c1b,
        0xffffb3e5, 0x00001b4c, 0xffffe4b4, 0x00004d2b, 0xffffb2d5, 0x00002b4d, 0xffffd4b3, 0x000036e8,
        0xffffc918, 0xffffe837, 0x000017c9, 0x00004f0e, 0xffffb0f2, 0x00000e4f, 0xfffff1b1, 0x0000533f,
        0xffffacc1, 0x00003f53, 0xffffc0ad, 0x000049ec, 0xffffb614, 0xffffec4a, 0x000013b6, 0x00005802,
        0xffffa7fe, 0x00000258, 0xfffffda8, 0x00005d5d, 0xffffa2a3, 0x00003ccc, 0xffffc334, 0xffffcc3d,
        0x000033c3, 0x00007834, 0xffff87cc, 0x00003478, 0xffffcb88, 0x00004ad3, 0xffffb52d, 0xffffd34b,
        0x00002cb5, 0x00007d4b, 0xffff82b5, 0x00004b7d, 0xffffb483, 0x00007a21, 0xffff85df, 0x0000217a,
        0xffffde86, 0x000066f3, 0xffff990d, 0xfffff367, 0x00000c99, 0x00005fd8, 0xffffa028, 0xffffd860,
        0x000027a0, 0x00007ede, 0xffff8122, 0xffffde7f, 0x00002181, 0x000058a7, 0xffffa759, 0x000068b2,
        0xffff974e, 0xffffb269, 0x00004d97, 0x00000c0c, 0xfffff3f4, 0x00001717, 0xffffe8e9, 0x00002a2a,
        0xffffd5d6, 0x00004949, 0xffffb6b7, 0x00000000, 0x02020000, 0xfdfe0000, 0x02ff0000, 0xfd010000,
        0xff030000, 0x00fd0000, 0x00000202, 0x02020202, 0xfdfe0202, 0x02ff0202, 0xfd010202, 0xff030202,
        0x00fd0202, 0xfffffdfe, 0x0201fdfe, 0xfdfdfdfe, 0x02fefdfe, 0xfd00fdfe, 0xff02fdfe, 0x00fcfdfe,
        0x000002ff, 0x020202ff, 0xfdfe02ff, 0x02ff02ff, 0xfd0102ff, 0xff0302ff, 0x00fd02ff, 0xfffffd01,
        0x0201fd01, 0xfdfdfd01, 0x02fefd01, 0xfd00fd01, 0xff02fd01, 0x00fcfd01, 0xffffff03, 0x0201ff03,
        0xfdfdff03, 0x02feff03, 0xfd00ff03, 0xff02ff03, 0x00fcff03, 0x000000fd, 0x020200fd, 0xfdfe00fd,
        0x02ff00fd, 0xfd0100fd, 0xff0300fd, 0x00fd00fd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000303, 0xfffffcfd, 0x000003ff, 0xfffffc01, 0xffffff04, 0x000000fc, 0x00000707,
        0xfffff8f9, 0x00000802, 0xfffff7fe, 0x00000208, 0xfffffdf8, 0x000008fe, 0xfffff702, 0xfffffe09,
        0x000001f7, 0x000005fa, 0xfffffa06, 0x00000d06, 0xfffff2fa, 0x0000060d, 0xfffff9f3, 0x00000d0d,
        0xfffff2f3, 0x00000e01, 0xfffff1ff, 0x0000010e, 0xfffffef2, 0x00000bf8, 0xfffff408, 0xfffff80c,
        0x000007f4, 0x0000170e, 0xffffe8f2, 0x00000e17, 0xfffff1e9, 0x000011fb, 0xffffee05, 0xfffffb12,
        0x000004ee, 0x00001806, 0xffffe7fa, 0x00000618, 0xfffff9e8, 0x00001818, 0xffffe7e8, 0x00001aff,
        0xffffe501, 0xffffff1b, 0x000000e5, 0x000010ef, 0xffffef11, 0x000016f3, 0xffffe90d, 0xfffff317,
        0x00000ce9, 0x00002810, 0xffffd7f0, 0x00001028, 0xffffefd8, 0x0000291c, 0xffffd6e4, 0x00001c29,
        0xffffe3d7, 0x000020f7, 0xffffdf09, 0xfffff721, 0x000008df, 0x00002b06, 0xffffd4fa, 0x0000062b,
        0xfffff9d5, 0x00002e2e, 0xffffd1d2, 0x000031fc, 0xffffce04, 0xfffffc32, 0x000003ce, 0x000021e5,
        0xffffde1b, 0xffffe522, 0x00001ade, 0x00002cea, 0xffffd316, 0xffffea2d, 0x000015d3, 0x00004522,
        0xffffbade, 0x00002245, 0xffffddbb, 0x00004613, 0xffffb9ed, 0x00001346, 0xffffecba, 0x00004935,
        0xffffb6cb, 0x00003549, 0xffffcab7, 0x00003def, 0xffffc211, 0xffffef3e, 0x000010c2, 0x00004d05,
        0xffffb2fb, 0x0000054d, 0xfffffab3, 0x00005252, 0xffffadae, 0x000032cd, 0xffffcd33, 0x00003fd5,
        0xffffc02b, 0xffffd540, 0x00002ac0, 0x000059f6, 0xffffa60a, 0xfffff65a, 0x000009a6, 0x00007229,
        0xffff8dd7, 0x00002972, 0xffffd68e, 0x00007440, 0xffff8bc0, 0x00004074, 0xffffbf8c, 0x000051db,
        0xffffae25, 0xffffdb52, 0x000024ae, 0x00007716, 0xffff88ea, 0x00001677, 0xffffe989, 0x00007c5f,
        0xffff83a1, 0x00005f7c, 0xffffa084, 0x00006ee2, 0xffff911e, 0xffffe26f, 0x00001d91, 0x00005bb2,
        0xffffa44e, 0xffffb25c, 0x00004da4, 0x000070bc, 0xffff8f44, 0xffffbc71, 0x0000438f, 0x00001212,
        0xffffedee, 0x00002222, 0xffffddde, 0x00003f3f, 0xffffc0c1, 0x00006d6d, 0xffff9293, 0x00000000,
        0x03030000, 0xfcfd0000, 0x03ff0000, 0xfc010000, 0xff040000, 0x00fc0000, 0x07070000, 0xf8f90000,
        0x00000303, 0x03030303, 0xfcfd0303, 0x03ff0303, 0xfc010303, 0xff040303, 0x00fc0303, 0x07070303,
        0xf8f90303, 0xfffffcfd, 0x0302fcfd, 0xfcfcfcfd, 0x03fefcfd, 0xfc00fcfd, 0xff03fcfd, 0x00fbfcfd,
        0x0706fcfd, 0xf8f8fcfd, 0x000003ff, 0x030303ff, 0xfcfd03ff, 0x03ff03ff, 0xfc0103ff, 0xff0403ff,
        0x00fc03ff, 0x070703ff, 0xf8f903ff, 0xfffffc01, 0x0302fc01, 0xfcfcfc01, 0x03fefc01, 0xfc00fc01,
        0xff03fc01, 0x00fbfc01, 0x0706fc01, 0xf8f8fc01, 0xffffff04, 0x0302ff04, 0xfcfcff04, 0x03feff04,
        0xfc00ff04, 0xff03ff04, 0x00fbff04, 0x0706ff04, 0xf8f8ff04, 0x000000fc, 0x030300fc, 0xfcfd00fc,
        0x03ff00fc, 0xfc0100fc, 0xff0400fc, 0x00fc00fc, 0x070700fc, 0xf8f900fc, 0x00000707, 0x03030707,
        0xfcfd0707, 0x03ff0707, 0xfc010707, 0xff040707, 0x00fc0707, 0x07070707, 0xf8f90707, 0xfffff8f9,
        0x0302f8f9, 0xfcfcf8f9, 0x03fef8f9, 0xfc00f8f9, 0xff03f8f9, 0x00fbf8f9, 0x0706f8f9, 0xf8f8f8f9,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000404, 0xfffffbfc, 0x000004ff, 0xfffffb01, 0xffffff05, 0x000000fb, 0x00000a03,
        0xfffff5fd, 0x0000030a, 0xfffffcf6, 0x00000909, 0xfffff6f7, 0x000006f9, 0xfffff907, 0x00000bfd,
        0xfffff403, 0xfffffd0c, 0x000002f4, 0x00001108, 0xffffeef8, 0x00000811, 0xfffff7ef, 0x00001111,
        0xffffeeef, 0x00001301, 0xffffecff, 0x00000113, 0xfffffeed, 0x00000ff5, 0xfffff00b, 0xfffff510,
        0x00000af0, 0x000016fa, 0xffffe906, 0xfffffa17, 0x000005e9, 0x00001f12, 0xffffe0ee, 0x0000121f,
        0xffffede1, 0x00002008, 0xffffdff8, 0x00000820, 0xfffff7e0, 0x00002121, 0xffffdedf, 0x000023ff,
        0xffffdc01, 0xffffff24, 0x000000dc, 0x000016e9, 0xffffe917, 0x00001eef, 0xffffe111, 0xffffef1f,
        0x000010e1, 0x00003615, 0xffffc9eb, 0x00001536, 0xffffeaca, 0x00003725, 0xffffc8db, 0x00002537,
        0xffffdac9, 0x00002bf4, 0xffffd40c, 0xfffff42c, 0x00000bd4, 0x00003908, 0xffffc6f8, 0x00000839,
        0xfffff7c7, 0x00003d3d, 0xffffc2c3, 0x000041fb, 0xffffbe05, 0xfffffb42, 0x000004be, 0x00002cdc,
        0xffffd324, 0xffffdc2d, 0x000023d3, 0x00003be3, 0xffffc41d, 0xffffe33c, 0x00001cc4, 0x00005c2d,
        0xffffa3d3, 0x00002d5c, 0xffffd2a4, 0x00005d19, 0xffffa2e7, 0x0000195d, 0xffffe6a3, 0x00006147,
        0xffff9eb9, 0x00004761, 0xffffb89f, 0x000052ea, 0xffffad16, 0xffffea53, 0x000015ad, 0x00006607,
        0xffff99f9, 0x00000766, 0xfffff89a, 0x00006d6d, 0xffff9293, 0x000043bc, 0xffffbc44, 0x000054c7,
        0xffffab39, 0xffffc755, 0x000038ab, 0x000077f3, 0xffff880d, 0xfffff378, 0x00000c88, 0x00006dcf,
        0xffff9231, 0xffffcf6e, 0x00003092, 0x00007a98, 0xffff8568, 0xffff987b, 0x00006785, 0x00001818,
        0xffffe7e8, 0x00002e2e, 0xffffd1d2, 0x00005454, 0xffffabac, 0x00000000, 0x04040000, 0xfbfc0000,
        0x04ff0000, 0xfb010000, 0xff050000, 0x00fb0000, 0x0a030000, 0xf5fd0000, 0x030a0000, 0x00000404,
        0x04040404, 0xfbfc0404, 0x04ff0404, 0xfb010404, 0xff050404, 0x00fb0404, 0x0a030404, 0xf5fd0404,
        0x030a0404, 0xfffffbfc, 0x0403fbfc, 0xfbfbfbfc, 0x04fefbfc, 0xfb00fbfc, 0xff04fbfc, 0x00fafbfc,
        0x0a02fbfc, 0xf5fcfbfc, 0x0309fbfc, 0x000004ff, 0x040404ff, 0xfbfc04ff, 0x04ff04ff, 0xfb0104ff,
        0xff0504ff, 0x00fb04ff, 0x0a0304ff, 0xf5fd04ff, 0x030a04ff, 0xfffffb01, 0x0403fb01, 0xfbfbfb01,
        0x04fefb01, 0xfb00fb01, 0xff04fb01, 0x00fafb01, 0x0a02fb01, 0xf5fcfb01, 0x0309fb01, 0xffffff05,
        0x0403ff05, 0xfbfbff05, 0x04feff05, 0xfb00ff05, 0xff04ff05, 0x00faff05, 0x0a02ff05, 0xf5fcff05,
        0x0309ff05, 0x000000fb, 0x040400fb, 0xfbfc00fb, 0x04ff00fb, 0xfb0100fb, 0xff0500fb, 0x00fb00fb,
        0x0a0300fb, 0xf5fd00fb, 0x030a00fb, 0x00000a03, 0x04040a03, 0xfbfc0a03, 0x04ff0a03, 0xfb010a03,
        0xff050a03, 0x00fb0a03, 0x0a030a03, 0xf5fd0a03, 0x030a0a03, 0xfffff5fd, 0x0403f5fd, 0xfbfbf5fd,
        0x04fef5fd, 0xfb00f5fd, 0xff04f5fd, 0x00faf5fd, 0x0a02f5fd, 0xf5fcf5fd, 0x0309f5fd, 0x0000030a,
        0x0404030a, 0xfbfc030a, 0x04ff030a, 0xfb01030a, 0xff05030a, 0x00fb030a, 0x0a03030a, 0xf5fd030a,
        0x030a030a, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000505, 0xfffffafb, 0x000006fe, 0xfffff902, 0xfffffe07, 0x000001f9, 0x00000b0b,
        0xfffff4f5, 0x00000d03, 0xfffff2fd, 0x0000030d, 0xfffffcf3, 0x000008f7, 0xfffff709, 0x00000efc,
        0xfffff104, 0xfffffc0f, 0x000003f1, 0x0000160b, 0xffffe9f5, 0x00000b16, 0xfffff4ea, 0x00001515,
        0xffffeaeb, 0x00001802, 0xffffe7fe, 0x00000218, 0xfffffde8, 0x000013f2, 0xffffec0e, 0xfffff214,
        0x00000dec, 0x00002617, 0xffffd9e9, 0x00001726, 0xffffe8da, 0x00001cf8, 0xffffe308, 0xfffff81d,
        0x000007e3, 0x0000270b, 0xffffd8f5, 0x00000b27, 0xfffff4d9, 0x00002929, 0xffffd6d7, 0x00002cff,
        0xffffd301, 0xffffff2d, 0x000000d3, 0x00001ce3, 0xffffe31d, 0x000026ea, 0xffffd916, 0xffffea27,
        0x000015d9, 0x0000431b, 0xffffbce5, 0x00001b43, 0xffffe4bd, 0x0000452f, 0xffffbad1, 0x00002f45,
        0xffffd0bb, 0x000037f1, 0xffffc80f, 0xfffff138, 0x00000ec8, 0x0000470b, 0xffffb8f5, 0x00000b47,
        0xfffff4b9, 0x00004c4c, 0xffffb3b4, 0x000052fa, 0xffffad06, 0xfffffa53, 0x000005ad, 0x000038d3,
        0xffffc72d, 0xffffd339, 0x00002cc7, 0x00004adc, 0xffffb524, 0xffffdc4b, 0x000023b5, 0x00007338,
        0xffff8cc8, 0x00003873, 0xffffc78d, 0x0000751f, 0xffff8ae1, 0x00001f75, 0xffffe08b, 0x00007a58,
        0xffff85a8, 0x0000587a, 0xffffa786, 0x000067e4, 0xffff981c, 0xffffe468, 0x00001b98, 0x000054ab,
        0xffffab55, 0x000069b8, 0xffff9648, 0xffffb86a, 0x00004796, 0x00001e1e, 0xffffe1e2, 0x00003a3a,
        0xffffc5c6, 0x00006969, 0xffff9697, 0x00000000, 0x05050000, 0xfafb0000, 0x06fe0000, 0xf9020000,
        0xfe070000, 0x01f90000, 0x0b0b0000, 0xf4f50000, 0x0d030000, 0xf2fd0000, 0x00000505, 0x05050505,
        0xfafb0505, 0x06fe0505, 0xf9020505, 0xfe070505, 0x01f90505, 0x0b0b0505, 0xf4f50505, 0x0d030505,
        0xf2fd0505, 0xfffffafb, 0x0504fafb, 0xfafafafb, 0x06fdfafb, 0xf901fafb, 0xfe06fafb, 0x01f8fafb,
        0x0b0afafb, 0xf4f4fafb, 0x0d02fafb, 0xf2fcfafb, 0x000006fe, 0x050506fe, 0xfafb06fe, 0x06fe06fe,
        0xf90206fe, 0xfe0706fe, 0x01f906fe, 0x0b0b06fe, 0xf4f506fe, 0x0d0306fe, 0xf2fd06fe, 0xfffff902,
        0x0504f902, 0xfafaf902, 0x06fdf902, 0xf901f902, 0xfe06f902, 0x01f8f902, 0x0b0af902, 0xf4f4f902,
        0x0d02f902, 0xf2fcf902, 0xfffffe07, 0x0504fe07, 0xfafafe07, 0x06fdfe07, 0xf901fe07, 0xfe06fe07,
        0x01f8fe07, 0x0b0afe07, 0xf4f4fe07, 0x0d02fe07, 0xf2fcfe07, 0x000001f9, 0x050501f9, 0xfafb01f9,
        0x06fe01f9, 0xf90201f9, 0xfe0701f9, 0x01f901f9, 0x0b0b01f9, 0xf4f501f9, 0x0d0301f9, 0xf2fd01f9,
        0x00000b0b, 0x05050b0b, 0xfafb0b0b, 0x06fe0b0b, 0xf9020b0b, 0xfe070b0b, 0x01f90b0b, 0x0b0b0b0b,
        0xf4f50b0b, 0x0d030b0b, 0xf2fd0b0b, 0xfffff4f5, 0x0504f4f5, 0xfafaf4f5, 0x06fdf4f5, 0xf901f4f5,
        0xfe06f4f5, 0x01f8f4f5, 0x0b0af4f5, 0xf4f4f4f5, 0x0d02f4f5, 0xf2fcf4f5, 0x00000d03, 0x05050d03,
        0xfafb0d03, 0x06fe0d03, 0xf9020d03, 0xfe070d03, 0x01f90d03, 0x0b0b0d03, 0xf4f50d03, 0x0d030d03,
        0xf2fd0d03, 0xfffff2fd, 0x0504f2fd, 0xfafaf2fd, 0x06fdf2fd, 0xf901f2fd, 0xfe06f2fd, 0x01f8f2fd,
        0x0b0af2fd, 0xf4f4f2fd, 0x0d02f2fd, 0xf2fcf2fd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000606, 0xfffff9fa, 0x000007fe, 0xfffff802, 0xfffffe08, 0x000001f8, 0x00000d0d,
        0xfffff2f3, 0x00000f04, 0xfffff0fc, 0x0000040f, 0xfffffbf1, 0x00000af5, 0xfffff50b, 0x000011fb,
        0xffffee05, 0xfffffb12, 0x000004ee, 0x00001a0d, 0xffffe5f3, 0x00000d1a, 0xfffff2e6, 0x00001a1a,
        0xffffe5e6, 0x00001d02, 0xffffe2fe, 0x0000021d, 0xfffffde3, 0x000017f0, 0xffffe810, 0xfffff018,
        0x00000fe8, 0x00002e1c, 0xffffd1e4, 0x00001c2e, 0xffffe3d2, 0x000022f7, 0xffffdd09, 0xfffff723,
        0x000008dd, 0x00002f0d, 0xffffd0f3, 0x00000d2f, 0xfffff2d1, 0x00003131, 0xffffcecf, 0x000035ff,
        0xffffca01, 0xffffff36, 0x000000ca, 0x000022dd, 0xffffdd23, 0x00002ee6, 0xffffd11a, 0xffffe62f,
        0x000019d1, 0x00005120, 0xffffaee0, 0x00002051, 0xffffdfaf, 0x00005338, 0xffffacc8, 0x00003853,
        0xffffc7ad, 0x000042ee, 0xffffbd12, 0xffffee43, 0x000011bd, 0x0000560d, 0xffffa9f3, 0x00000d56,
        0xfffff2aa, 0x00005b5b, 0xffffa4a5, 0x000062f9, 0xffff9d07, 0xfffff963, 0x0000069d, 0x000043ca,
        0xffffbc36, 0xffffca44, 0x000035bc, 0x000059d4, 0xffffa62c, 0xffffd45a, 0x00002ba6, 0x00007bdf,
        0xffff8421, 0xffffdf7c, 0x00002084, 0x00006699, 0xffff9967, 0x00007eaa, 0xffff8156, 0xffffaa7f,
        0x00005581, 0x00002525, 0xffffdadb, 0x00004545, 0xffffbabb, 0x00000000, 0x06060000, 0xf9fa0000,
        0x07fe0000, 0xf8020000, 0xfe080000, 0x01f80000, 0x0d0d0000, 0xf2f30000, 0x0f040000, 0xf0fc0000,
        0x040f0000, 0x00000606, 0x06060606, 0xf9fa0606, 0x07fe0606, 0xf8020606, 0xfe080606, 0x01f80606,
        0x0d0d0606, 0xf2f30606, 0x0f040606, 0xf0fc0606, 0x040f0606, 0xfffff9fa, 0x0605f9fa, 0xf9f9f9fa,
        0x07fdf9fa, 0xf801f9fa, 0xfe07f9fa, 0x01f7f9fa, 0x0d0cf9fa, 0xf2f2f9fa, 0x0f03f9fa, 0xf0fbf9fa,
        0x040ef9fa, 0x000007fe, 0x060607fe, 0xf9fa07fe, 0x07fe07fe, 0xf80207fe, 0xfe0807fe, 0x01f807fe,
        0x0d0d07fe, 0xf2f307fe, 0x0f0407fe, 0xf0fc07fe, 0x040f07fe, 0xfffff802, 0x0605f802, 0xf9f9f802,
        0x07fdf802, 0xf801f802, 0xfe07f802, 0x01f7f802, 0x0d0cf802, 0xf2f2f802, 0x0f03f802, 0xf0fbf802,
        0x040ef802, 0xfffffe08, 0x0605fe08, 0xf9f9fe08, 0x07fdfe08, 0xf801fe08, 0xfe07fe08, 0x01f7fe08,
        0x0d0cfe08, 0xf2f2fe08, 0x0f03fe08, 0xf0fbfe08, 0x040efe08, 0x000001f8, 0x060601f8, 0xf9fa01f8,
        0x07fe01f8, 0xf80201f8, 0xfe0801f8, 0x01f801f8, 0x0d0d01f8, 0xf2f301f8, 0x0f0401f8, 0xf0fc01f8,
        0x040f01f8, 0x00000d0d, 0x06060d0d, 0xf9fa0d0d, 0x07fe0d0d, 0xf8020d0d, 0xfe080d0d, 0x01f80d0d,
        0x0d0d0d0d, 0xf2f30d0d, 0x0f040d0d, 0xf0fc0d0d, 0x040f0d0d, 0xfffff2f3, 0x0605f2f3, 0xf9f9f2f3,
        0x07fdf2f3, 0xf801f2f3, 0xfe07f2f3, 0x01f7f2f3, 0x0d0cf2f3, 0xf2f2f2f3, 0x0f03f2f3, 0xf0fbf2f3,
        0x040ef2f3, 0x00000f04, 0x06060f04, 0xf9fa0f04, 0x07fe0f04, 0xf8020f04, 0xfe080f04, 0x01f80f04,
        0x0d0d0f04, 0xf2f30f04, 0x0f040f04, 0xf0fc0f04, 0x040f0f04, 0xfffff0fc, 0x0605f0fc, 0xf9f9f0fc,
        0x07fdf0fc, 0xf801f0fc, 0xfe07f0fc, 0x01f7f0fc, 0x0d0cf0fc, 0xf2f2f0fc, 0x0f03f0fc, 0xf0fbf0fc,
        0x040ef0fc, 0x0000040f, 0x0606040f, 0xf9fa040f, 0x07fe040f, 0xf802040f, 0xfe08040f, 0x01f8040f,
        0x0d0d040f, 0xf2f3040f, 0x0f04040f, 0xf0fc040f, 0x040f040f, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000707, 0xfffff8f9, 0x000009fd, 0xfffff603, 0xfffffd0a, 0x000002f6, 0x00001010,
        0xffffeff0, 0x00001205, 0xffffedfb, 0x00000512, 0xfffffaee, 0x00000cf3, 0xfffff30d, 0x000014fa,
        0xffffeb06, 0xfffffa15, 0x000005eb, 0x00001e0f, 0xffffe1f1, 0x00000f1e, 0xfffff0e2, 0x00001e1e,
        0xffffe1e2, 0x00002202, 0xffffddfe, 0x00000222, 0xfffffdde, 0x00001bed, 0xffffe413, 0xffffed1c,
        0x000012e4, 0x00003620, 0xffffc9e0, 0x00002036, 0xffffdfca, 0x000028f5, 0xffffd70b, 0xfffff529,
        0x00000ad7, 0x0000370f, 0xffffc8f1, 0x00000f37, 0xfffff0c9, 0x00003939, 0xffffc6c7, 0x00003eff,
        0xffffc101, 0xffffff3f, 0x000000c1, 0x000027d8, 0xffffd828, 0x000036e2, 0xffffc91e, 0xffffe237,
        0x00001dc9, 0x00005e25, 0xffffa1db, 0x0000255e, 0xffffdaa2, 0x00006041, 0xffff9fbf, 0x00004160,
        0xffffbea0, 0x00004deb, 0xffffb215, 0xffffeb4e, 0x000014b2, 0x0000640f, 0xffff9bf1, 0x00000f64,
        0xfffff09c, 0x00006a6a, 0xffff9596, 0x000073f8, 0xffff8c08, 0xfffff874, 0x0000078c, 0x00004ec1,
        0xffffb13f, 0xffffc14f, 0x00003eb1, 0x000068cd, 0xffff9733, 0xffffcd69, 0x00003297, 0x00007788,
        0xffff8878, 0x00002b2b, 0xffffd4d5, 0x00005050, 0xffffafb0, 0x00000000, 0x07070000, 0xf8f90000,
        0x09fd0000, 0xf6030000, 0xfd0a0000, 0x02f60000, 0x10100000, 0xeff00000, 0x12050000, 0xedfb0000,
        0x05120000, 0x00000707, 0x07070707, 0xf8f90707, 0x09fd0707, 0xf6030707, 0xfd0a0707, 0x02f60707,
        0x10100707, 0xeff00707, 0x12050707, 0xedfb0707, 0x05120707, 0xfffff8f9, 0x0706f8f9, 0xf8f8f8f9,
        0x09fcf8f9, 0xf602f8f9, 0xfd09f8f9, 0x02f5f8f9, 0x100ff8f9, 0xefeff8f9, 0x1204f8f9, 0xedfaf8f9,
        0x0511f8f9, 0x000009fd, 0x070709fd, 0xf8f909fd, 0x09fd09fd, 0xf60309fd, 0xfd0a09fd, 0x02f609fd,
        0x101009fd, 0xeff009fd, 0x120509fd, 0xedfb09fd, 0x051209fd, 0xfffff603, 0x0706f603, 0xf8f8f603,
        0x09fcf603, 0xf602f603, 0xfd09f603, 0x02f5f603, 0x100ff603, 0xefeff603, 0x1204f603, 0xedfaf603,
        0x0511f603, 0xfffffd0a, 0x0706fd0a, 0xf8f8fd0a, 0x09fcfd0a, 0xf602fd0a, 0xfd09fd0a, 0x02f5fd0a,
        0x100ffd0a, 0xefeffd0a, 0x1204fd0a, 0xedfafd0a, 0x0511fd0a, 0x000002f6, 0x070702f6, 0xf8f902f6,
        0x09fd02f6, 0xf60302f6, 0xfd0a02f6, 0x02f602f6, 0x101002f6, 0xeff002f6, 0x120502f6, 0xedfb02f6,
        0x051202f6, 0x00001010, 0x07071010, 0xf8f91010, 0x09fd1010, 0xf6031010, 0xfd0a1010, 0x02f61010,
        0x10101010, 0xeff01010, 0x12051010, 0xedfb1010, 0x05121010, 0xffffeff0, 0x0706eff0, 0xf8f8eff0,
        0x09fceff0, 0xf602eff0, 0xfd09eff0, 0x02f5eff0, 0x100feff0, 0xefefeff0, 0x1204eff0, 0xedfaeff0,
        0x0511eff0, 0x00001205, 0x07071205, 0xf8f91205, 0x09fd1205, 0xf6031205, 0xfd0a1205, 0x02f61205,
        0x10101205, 0xeff01205, 0x12051205, 0xedfb1205, 0x05121205, 0xffffedfb, 0x0706edfb, 0xf8f8edfb,
        0x09fcedfb, 0xf602edfb, 0xfd09edfb, 0x02f5edfb, 0x100fedfb, 0xefefedfb, 0x1204edfb, 0xedfaedfb,
        0x0511edfb, 0x00000512, 0x07070512, 0xf8f90512, 0x09fd0512, 0xf6030512, 0xfd0a0512, 0x02f60512,
        0x10100512, 0xeff00512, 0x12050512, 0xedfb0512, 0x05120512, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000808, 0xfffff7f8, 0x00000afd, 0xfffff503, 0xfffffd0b, 0x000002f5, 0x00001212,
        0xffffedee, 0x00001405, 0xffffebfb, 0x00000514, 0xfffffaec, 0x00000ef1, 0xfffff10f, 0x000017f9,
        0xffffe807, 0xfffff918, 0x000006e8, 0x00002311, 0xffffdcef, 0x00001123, 0xffffeedd, 0x00002222,
        0xffffddde, 0x00002603, 0xffffd9fd, 0x00000326, 0xfffffcda, 0x00001fea, 0xffffe016, 0xffffea20,
        0x000015e0, 0x00003d25, 0xffffc2db, 0x0000253d, 0xffffdac3, 0x00002ef3, 0xffffd10d, 0xfffff32f,
        0x00000cd1, 0x00003f11, 0xffffc0ef, 0x0000113f, 0xffffeec1, 0x00004141, 0xffffbebf, 0x000047ff,
        0xffffb801, 0xffffff48, 0x000000b8, 0x00002dd2, 0xffffd22e, 0x00003edd, 0xffffc123, 0xffffdd3f,
        0x000022c1, 0x00006b2b, 0xffff94d5, 0x00002b6b, 0xffffd495, 0x00006e4b, 0xffff91b5, 0x00004b6e,
        0xffffb492, 0x000058e8, 0xffffa718, 0xffffe859, 0x000017a7, 0x00007211, 0xffff8def, 0x00001172,
        0xffffee8e, 0x00007979, 0xffff8687, 0x00005ab8, 0xffffa548, 0xffffb85b, 0x000047a5, 0x000077c6,
        0xffff883a, 0xffffc678, 0x00003988, 0x00003131, 0xffffcecf, 0x00005c5c, 0xffffa3a4, 0x00000000,
        0x08080000, 0xf7f80000, 0x0afd0000, 0xf5030000, 0xfd0b0000, 0x02f50000, 0x12120000, 0xedee0000,
        0x14050000, 0xebfb0000, 0x05140000, 0x00000808, 0x08080808, 0xf7f80808, 0x0afd0808, 0xf5030808,
        0xfd0b0808, 0x02f50808, 0x12120808, 0xedee0808, 0x14050808, 0xebfb0808, 0x05140808, 0xfffff7f8,
        0x0807f7f8, 0xf7f7f7f8, 0x0afcf7f8, 0xf502f7f8, 0xfd0af7f8, 0x02f4f7f8, 0x1211f7f8, 0xededf7f8,
        0x1404f7f8, 0xebfaf7f8, 0x0513f7f8, 0x00000afd, 0x08080afd, 0xf7f80afd, 0x0afd0afd, 0xf5030afd,
        0xfd0b0afd, 0x02f50afd, 0x12120afd, 0xedee0afd, 0x14050afd, 0xebfb0afd, 0x05140afd, 0xfffff503,
        0x0807f503, 0xf7f7f503, 0x0afcf503, 0xf502f503, 0xfd0af503, 0x02f4f503, 0x1211f503, 0xededf503,
        0x1404f503, 0xebfaf503, 0x0513f503, 0xfffffd0b, 0x0807fd0b, 0xf7f7fd0b, 0x0afcfd0b, 0xf502fd0b,
        0xfd0afd0b, 0x02f4fd0b, 0x1211fd0b, 0xededfd0b, 0x1404fd0b, 0xebfafd0b, 0x0513fd0b, 0x000002f5,
        0x080802f5, 0xf7f802f5, 0x0afd02f5, 0xf50302f5, 0xfd0b02f5, 0x02f502f5, 0x121202f5, 0xedee02f5,
        0x140502f5, 0xebfb02f5, 0x051402f5, 0x00001212, 0x08081212, 0xf7f81212, 0x0afd1212, 0xf5031212,
        0xfd0b1212, 0x02f51212, 0x12121212, 0xedee1212, 0x14051212, 0xebfb1212, 0x05141212, 0xffffedee,
        0x0807edee, 0xf7f7edee, 0x0afcedee, 0xf502edee, 0xfd0aedee, 0x02f4edee, 0x1211edee, 0xedededee,
        0x1404edee, 0xebfaedee, 0x0513edee, 0x00001405, 0x08081405, 0xf7f81405, 0x0afd1405, 0xf5031405,
        0xfd0b1405, 0x02f51405, 0x12121405, 0xedee1405, 0x14051405, 0xebfb1405, 0x05141405, 0xffffebfb,
        0x0807ebfb, 0xf7f7ebfb, 0x0afcebfb, 0xf502ebfb, 0xfd0aebfb, 0x02f4ebfb, 0x1211ebfb, 0xededebfb,
        0x1404ebfb, 0xebfaebfb, 0x0513ebfb, 0x00000514, 0x08080514, 0xf7f80514, 0x0afd0514, 0xf5030514,
        0xfd0b0514, 0x02f50514, 0x12120514, 0xedee0514, 0x14050514, 0xebfb0514, 0x05140514, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000909, 0xfffff6f7, 0x00000bfd, 0xfffff403, 0xfffffd0c, 0x000002f4, 0x00001414,
        0xffffebec, 0x00001706, 0xffffe8fa, 0x00000617, 0xfffff9e9, 0x000010ef, 0xffffef11, 0x00001af9,
        0xffffe507, 0xfffff91b, 0x000006e5, 0x00002713, 0xffffd8ed, 0x00001327, 0xffffecd9, 0x00002727,
        0xffffd8d9, 0x00002b03, 0xffffd4fd, 0x0000032b, 0xfffffcd5, 0x000023e8, 0xffffdc18, 0xffffe824,
        0x000017dc, 0x0000452a, 0xffffbad6, 0x00002a45, 0xffffd5bb, 0x000034f2, 0xffffcb0e, 0xfffff235,
        0x00000dcb, 0x00004713, 0xffffb8ed, 0x00001347, 0xffffecb9, 0x00004949, 0xffffb6b7, 0x00004ffe,
        0xffffb002, 0xfffffe50, 0x000001b0, 0x000033cc, 0xffffcc34, 0x000045d9, 0xffffba27, 0xffffd946,
        0x000026ba, 0x00007930, 0xffff86d0, 0x00003079, 0xffffcf87, 0x00007c54, 0xffff83ac, 0x0000547c,
        0xffffab84, 0x000063e5, 0xffff9c1b, 0xffffe564, 0x00001a9c, 0x000065af, 0xffff9a51, 0xffffaf66,
        0x0000509a, 0x00003737, 0xffffc8c9, 0x00006868, 0xffff9798, 0x00000000, 0x09090000, 0xf6f70000,
        0x0bfd0000, 0xf4030000, 0xfd0c0000, 0x02f40000, 0x14140000, 0xebec0000, 0x17060000, 0xe8fa0000,
        0x06170000, 0xf9e90000, 0x00000909, 0x09090909, 0xf6f70909, 0x0bfd0909, 0xf4030909, 0xfd0c0909,
        0x02f40909, 0x14140909, 0xebec0909, 0x17060909, 0xe8fa0909, 0x06170909, 0xf9e90909, 0xfffff6f7,
        0x0908f6f7, 0xf6f6f6f7, 0x0bfcf6f7, 0xf402f6f7, 0xfd0bf6f7, 0x02f3f6f7, 0x1413f6f7, 0xebebf6f7,
        0x1705f6f7, 0xe8f9f6f7, 0x0616f6f7, 0xf9e8f6f7, 0x00000bfd, 0x09090bfd, 0xf6f70bfd, 0x0bfd0bfd,
        0xf4030bfd, 0xfd0c0bfd, 0x02f40bfd, 0x14140bfd, 0xebec0bfd, 0x17060bfd, 0xe8fa0bfd, 0x06170bfd,
        0xf9e90bfd, 0xfffff403, 0x0908f403, 0xf6f6f403, 0x0bfcf403, 0xf402f403, 0xfd0bf403, 0x02f3f403,
        0x1413f403, 0xebebf403, 0x1705f403, 0xe8f9f403, 0x0616f403, 0xf9e8f403, 0xfffffd0c, 0x0908fd0c,
        0xf6f6fd0c, 0x0bfcfd0c, 0xf402fd0c, 0xfd0bfd0c, 0x02f3fd0c, 0x1413fd0c, 0xebebfd0c, 0x1705fd0c,
        0xe8f9fd0c, 0x0616fd0c, 0xf9e8fd0c, 0x000002f4, 0x090902f4, 0xf6f702f4, 0x0bfd02f4, 0xf40302f4,
        0xfd0c02f4, 0x02f402f4, 0x141402f4, 0xebec02f4, 0x170602f4, 0xe8fa02f4, 0x061702f4, 0xf9e902f4,
        0x00001414, 0x09091414, 0xf6f71414, 0x0bfd1414, 0xf4031414, 0xfd0c1414, 0x02f41414, 0x14141414,
        0xebec1414, 0x17061414, 0xe8fa1414, 0x06171414, 0xf9e91414, 0xffffebec, 0x0908ebec, 0xf6f6ebec,
        0x0bfcebec, 0xf402ebec, 0xfd0bebec, 0x02f3ebec, 0x1413ebec, 0xebebebec, 0x1705ebec, 0xe8f9ebec,
        0x0616ebec, 0xf9e8ebec, 0x00001706, 0x09091706, 0xf6f71706, 0x0bfd1706, 0xf4031706, 0xfd0c1706,
        0x02f41706, 0x14141706, 0xebec1706, 0x17061706, 0xe8fa1706, 0x06171706, 0xf9e91706, 0xffffe8fa,
        0x0908e8fa, 0xf6f6e8fa, 0x0bfce8fa, 0xf402e8fa, 0xfd0be8fa, 0x02f3e8fa, 0x1413e8fa, 0xebebe8fa,
        0x1705e8fa, 0xe8f9e8fa, 0x0616e8fa, 0xf9e8e8fa, 0x00000617, 0x09090617, 0xf6f70617, 0x0bfd0617,
        0xf4030617, 0xfd0c0617, 0x02f40617, 0x14140617, 0xebec0617, 0x17060617, 0xe8fa0617, 0x06170617,
        0xf9e90617, 0xfffff9e9, 0x0908f9e9, 0xf6f6f9e9, 0x0bfcf9e9, 0xf402f9e9, 0xfd0bf9e9, 0x02f3f9e9,
        0x1413f9e9, 0xebebf9e9, 0x1705f9e9, 0xe8f9f9e9, 0x0616f9e9, 0xf9e8f9e9, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000200, 0xfffffe00, 0x00000002, 0xfffffffe, 0x00000404,
        0xfffffbfc, 0x00000400, 0xfffffc00, 0x00000004, 0xfffffffc, 0x000003fc, 0xfffffc04, 0x000005fe,
        0xfffffa02, 0xfffffe06, 0x000001fa, 0x00000804, 0xfffff7fc, 0x00000408, 0xfffffbf8, 0x00000808,
        0xfffff7f8, 0x00000a00, 0xfffff600, 0x0000000a, 0xfffffff6, 0x000007fc, 0xfffff804, 0xfffffc08,
        0x000003f8, 0x00000e08, 0xfffff1f8, 0x0000080e, 0xfffff7f2, 0x00000bfe, 0xfffff402, 0xfffffe0c,
        0x000001f4, 0x00001004, 0xffffeffc, 0x00000410, 0xfffffbf0, 0x00001010, 0xffffeff0, 0x00001200,
        0xffffee00, 0x00000012, 0xffffffee, 0x00000bf4, 0xfffff40c, 0x00000ff8, 0xfffff008, 0xfffff810,
        0x000007f0, 0x00001a0a, 0xffffe5f6, 0x00000a1a, 0xfffff5e6, 0x00001c12, 0xffffe3ee, 0x0000121c,
        0xffffede4, 0x000015fa, 0xffffea06, 0xfffffa16, 0x000005ea, 0x00001c04, 0xffffe3fc, 0x0000041c,
        0xfffffbe4, 0x00001e1e, 0xffffe1e2, 0x00001ffe, 0xffffe002, 0xfffffe20, 0x000001e0, 0x000015ee,
        0xffffea12, 0xffffee16, 0x000011ea, 0x00001df2, 0xffffe20e, 0xfffff21e, 0x00000de2, 0x00002e16,
        0xffffd1ea, 0x0000162e, 0xffffe9d2, 0x00002e0c, 0xffffd1f4, 0x00000c2e, 0xfffff3d2, 0x00003022,
        0xffffcfde, 0x00002230, 0xffffddd0, 0x000027f6, 0xffffd80a, 0xfffff628, 0x000009d8, 0x00003204,
        0xffffcdfc, 0x00000432, 0xfffffbce, 0x00003636, 0xffffc9ca, 0x000021de, 0xffffde22, 0x000029e4,
        0xffffd61c, 0xffffe42a, 0x00001bd6, 0x00003bfa, 0xffffc406, 0xfffffa3c, 0x000005c4, 0x00004c1a,
        0xffffb3e6, 0x00001a4c, 0xffffe5b4, 0x00004c2a, 0xffffb3d6, 0x00002a4c, 0xffffd5b4, 0x000035e8,
        0xffffca18, 0xffffe836, 0x000017ca, 0x00004e0e, 0xffffb1f2, 0x00000e4e, 0xfffff1b2, 0x0000523e,
        0xffffadc2, 0x00003e52, 0xffffc1ae, 0x000049ec, 0xffffb614, 0xffffec4a, 0x000013b6, 0x00005802,
        0xffffa7fe, 0x00000258, 0xfffffda8, 0x00005c5c, 0xffffa3a4, 0x00003bcc, 0xffffc434, 0xffffcc3c,
        0x000033c4, 0x00007634, 0xffff89cc, 0x00003476, 0xffffcb8a, 0x000049d4, 0xffffb62c, 0xffffd44a,
        0x00002bb6, 0x0000764a, 0xffff89b6, 0x00004a76, 0xffffb58a, 0x00007620, 0xffff89e0, 0x00002076,
        0xffffdf8a, 0x000065f4, 0xffff9a0c, 0xfffff466, 0x00000b9a, 0x00005fd8, 0xffffa028, 0xffffd860,
        0x000027a0, 0x000075de, 0xffff8a22, 0xffffde76, 0x0000218a, 0x000057a8, 0xffffa858, 0x000067b2,
        0xffff984e, 0xffffb268, 0x00004d98, 0x00000c0c, 0xfffff3f4, 0x00001616, 0xffffe9ea, 0x00002a2a,
        0xffffd5d6, 0x00004848, 0xffffb7b8, 0x00000000, 0x02020000, 0xfdfe0000, 0x02000000, 0xfe000000,
        0x00020000, 0xfffe0000, 0x00000202, 0x02020202, 0xfdfe0202, 0x02000202, 0xfe000202, 0x00020202,
        0xfffe0202, 0xfffffdfe, 0x0201fdfe, 0xfdfdfdfe, 0x01fffdfe, 0xfdfffdfe, 0x0001fdfe, 0xfffdfdfe,
        0x00000200, 0x02020200, 0xfdfe0200, 0x02000200, 0xfe000200, 0x00020200, 0xfffe0200, 0xfffffe00,
        0x0201fe00, 0xfdfdfe00, 0x01fffe00, 0xfdfffe00, 0x0001fe00, 0xfffdfe00, 0x00000002, 0x02020002,
        0xfdfe0002, 0x02000002, 0xfe000002, 0x00020002, 0xfffe0002, 0xfffffffe, 0x0201fffe, 0xfdfdfffe,
        0x01fffffe, 0xfdfffffe, 0x0001fffe, 0xfffdfffe, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000303, 0xfffffcfd, 0x00000300, 0xfffffd00, 0x00000003, 0xfffffffd, 0x00000606,
        0xfffff9fa, 0x00000903, 0xfffff6fd, 0x00000309, 0xfffffcf7, 0x000008fd, 0xfffff703, 0xfffffd09,
        0x000002f7, 0x000005fa, 0xfffffa06, 0x00000c06, 0xfffff3fa, 0x0000060c, 0xfffff9f4, 0x00000c0c,
        0xfffff3f4, 0x00000f00, 0xfffff100, 0x0000000f, 0xfffffff1, 0x00000bf7, 0xfffff409, 0xfffff70c,
        0x000008f4, 0x0000180f, 0xffffe7f1, 0x00000f18, 0xfffff0e8, 0x000011fa, 0xffffee06, 0xfffffa12,
        0x000005ee, 0x00001806, 0xffffe7fa, 0x00000618, 0xfffff9e8, 0x00001818, 0xffffe7e8, 0x00001b00,
        0xffffe500, 0x0000001b, 0xffffffe5, 0x000011ee, 0xffffee12, 0x000017f4, 0xffffe80c, 0xfffff418,
        0x00000be8, 0x0000270f, 0xffffd8f1, 0x00000f27, 0xfffff0d9, 0x00002a1b, 0xffffd5e5, 0x00001b2a,
        0xffffe4d6, 0x000020f7, 0xffffdf09, 0xfffff721, 0x000008df, 0x00002a06, 0xffffd5fa, 0x0000062a,
        0xfffff9d6, 0x00002d2d, 0xffffd2d3, 0x000032fd, 0xffffcd03, 0xfffffd33, 0x000002cd, 0x000020e5,
        0xffffdf1b, 0xffffe521, 0x00001adf, 0x00002ceb, 0xffffd315, 0xffffeb2d, 0x000014d3, 0x00004521,
        0xffffbadf, 0x00002145, 0xffffdebb, 0x00004512, 0xffffbaee, 0x00001245, 0xffffedbb, 0x00004836,
        0xffffb7ca, 0x00003648, 0xffffc9b8, 0x00003eee, 0xffffc112, 0xffffee3f, 0x000011c1, 0x00004e06,
        0xffffb1fa, 0x0000064e, 0xfffff9b2, 0x00005151, 0xffffaeaf, 0x000032cd, 0xffffcd33, 0x00003ed6,
        0xffffc12a, 0xffffd63f, 0x000029c1, 0x000059f7, 0xffffa609, 0xfffff75a, 0x000008a6, 0x0000722a,
        0xffff8dd6, 0x00002a72, 0xffffd58e, 0x0000753f, 0xffff8ac1, 0x00003f75, 0xffffc08b, 0x000050dc,
        0xffffaf24, 0xffffdc51, 0x000023af, 0x00007815, 0xffff87eb, 0x00001578, 0xffffea88, 0x00007b60,
        0xffff84a0, 0x0000607b, 0xffff9f85, 0x00006ee2, 0xffff911e, 0xffffe26f, 0x00001d91, 0x00005cb2,
        0xffffa34e, 0xffffb25d, 0x00004da3, 0x000071bb, 0xffff8e45, 0xffffbb72, 0x0000448e, 0x00001212,
        0xffffedee, 0x00002121, 0xffffdedf, 0x00003f3f, 0xffffc0c1, 0x00006c6c, 0xffff9394, 0x00000000,
        0x03030000, 0xfcfd0000, 0x03000000, 0xfd000000, 0x00030000, 0xfffd0000, 0x06060000, 0xf9fa0000,
        0x00000303, 0x03030303, 0xfcfd0303, 0x03000303, 0xfd000303, 0x00030303, 0xfffd0303, 0x06060303,
        0xf9fa0303, 0xfffffcfd, 0x0302fcfd, 0xfcfcfcfd, 0x02fffcfd, 0xfcfffcfd, 0x0002fcfd, 0xfffcfcfd,
        0x0605fcfd, 0xf9f9fcfd, 0x00000300, 0x03030300, 0xfcfd0300, 0x03000300, 0xfd000300, 0x00030300,
        0xfffd0300, 0x06060300, 0xf9fa0300, 0xfffffd00, 0x0302fd00, 0xfcfcfd00, 0x02fffd00, 0xfcfffd00,
        0x0002fd00, 0xfffcfd00, 0x0605fd00, 0xf9f9fd00, 0x00000003, 0x03030003, 0xfcfd0003, 0x03000003,
        0xfd000003, 0x00030003, 0xfffd0003, 0x06060003, 0xf9fa0003, 0xfffffffd, 0x0302fffd, 0xfcfcfffd,
        0x02fffffd, 0xfcfffffd, 0x0002fffd, 0xfffcfffd, 0x0605fffd, 0xf9f9fffd, 0x00000606, 0x03030606,
        0xfcfd0606, 0x03000606, 0xfd000606, 0x00030606, 0xfffd0606, 0x06060606, 0xf9fa0606, 0xfffff9fa,
        0x0302f9fa, 0xfcfcf9fa, 0x02fff9fa, 0xfcfff9fa, 0x0002f9fa, 0xfffcf9fa, 0x0605f9fa, 0xf9f9f9fa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000404, 0xfffffbfc, 0x00000400, 0xfffffc00, 0x00000004, 0xfffffffc, 0x00000804,
        0xfffff7fc, 0x00000408, 0xfffffbf8, 0x00000808, 0xfffff7f8, 0x000007f8, 0xfffff808, 0x00000bfc,
        0xfffff404, 0xfffffc0c, 0x000003f4, 0x00001008, 0xffffeff8, 0x00000810, 0xfffff7f0, 0x00001010,
        0xffffeff0, 0x00001400, 0xffffec00, 0x00000014, 0xffffffec, 0x00000ff4, 0xfffff00c, 0xfffff410,
        0x00000bf0, 0x000017fc, 0xffffe804, 0xfffffc18, 0x000003e8, 0x00002010, 0xffffdff0, 0x00001020,
        0xffffefe0, 0x00002008, 0xffffdff8, 0x00000820, 0xfffff7e0, 0x00002020, 0xffffdfe0, 0x00002400,
        0xffffdc00, 0x00000024, 0xffffffdc, 0x000017e8, 0xffffe818, 0x00001ff0, 0xffffe010, 0xfffff020,
        0x00000fe0, 0x00003414, 0xffffcbec, 0x00001434, 0xffffebcc, 0x00003824, 0xffffc7dc, 0x00002438,
        0xffffdbc8, 0x00002bf4, 0xffffd40c, 0xfffff42c, 0x00000bd4, 0x00003808, 0xffffc7f8, 0x00000838,
        0xfffff7c8, 0x00003c3c, 0xffffc3c4, 0x00003ffc, 0xffffc004, 0xfffffc40, 0x000003c0, 0x00002bdc,
        0xffffd424, 0xffffdc2c, 0x000023d4, 0x00003be4, 0xffffc41c, 0xffffe43c, 0x00001bc4, 0x00005c2c,
        0xffffa3d4, 0x00002c5c, 0xffffd3a4, 0x00005c18, 0xffffa3e8, 0x0000185c, 0xffffe7a4, 0x00006048,
        0xffff9fb8, 0x00004860, 0xffffb7a0, 0x000053ec, 0xffffac14, 0xffffec54, 0x000013ac, 0x00006408,
        0xffff9bf8, 0x00000864, 0xfffff79c, 0x00006c6c, 0xffff9394, 0x000043bc, 0xffffbc44, 0x000053c8,
        0xffffac38, 0xffffc854, 0x000037ac, 0x000077f4, 0xffff880c, 0xfffff478, 0x00000b88, 0x00006bd0,
        0xffff9430, 0xffffd06c, 0x00002f94, 0x00007b98, 0xffff8468, 0xffff987c, 0x00006784, 0x00001818,
        0xffffe7e8, 0x00002c2c, 0xffffd3d4, 0x00005454, 0xffffabac, 0x00000000, 0x04040000, 0xfbfc0000,
        0x04000000, 0xfc000000, 0x00040000, 0xfffc0000, 0x08040000, 0xf7fc0000, 0x04080000, 0x00000404,
        0x04040404, 0xfbfc0404, 0x04000404, 0xfc000404, 0x00040404, 0xfffc0404, 0x08040404, 0xf7fc0404,
        0x04080404, 0xfffffbfc, 0x0403fbfc, 0xfbfbfbfc, 0x03fffbfc, 0xfbfffbfc, 0x0003fbfc, 0xfffbfbfc,
        0x0803fbfc, 0xf7fbfbfc, 0x0407fbfc, 0x00000400, 0x04040400, 0xfbfc0400, 0x04000400, 0xfc000400,
        0x00040400, 0xfffc0400, 0x08040400, 0xf7fc0400, 0x04080400, 0xfffffc00, 0x0403fc00, 0xfbfbfc00,
        0x03fffc00, 0xfbfffc00, 0x0003fc00, 0xfffbfc00, 0x0803fc00, 0xf7fbfc00, 0x0407fc00, 0x00000004,
        0x04040004, 0xfbfc0004, 0x04000004, 0xfc000004, 0x00040004, 0xfffc0004, 0x08040004, 0xf7fc0004,
        0x04080004, 0xfffffffc, 0x0403fffc, 0xfbfbfffc, 0x03fffffc, 0xfbfffffc, 0x0003fffc, 0xfffbfffc,
        0x0803fffc, 0xf7fbfffc, 0x0407fffc, 0x00000804, 0x04040804, 0xfbfc0804, 0x04000804, 0xfc000804,
        0x00040804, 0xfffc0804, 0x08040804, 0xf7fc0804, 0x04080804, 0xfffff7fc, 0x0403f7fc, 0xfbfbf7fc,
        0x03fff7fc, 0xfbfff7fc, 0x0003f7fc, 0xfffbf7fc, 0x0803f7fc, 0xf7fbf7fc, 0x0407f7fc, 0x00000408,
        0x04040408, 0xfbfc0408, 0x04000408, 0xfc000408, 0x00040408, 0xfffc0408, 0x08040408, 0xf7fc0408,
        0x04080408, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000505, 0xfffffafb, 0x00000500, 0xfffffb00, 0x00000005, 0xfffffffb, 0x00000a0a,
        0xfffff5f6, 0x00000f05, 0xfffff0fb, 0x0000050f, 0xfffffaf1, 0x000009f6, 0xfffff60a, 0x00000efb,
        0xfffff105, 0xfffffb0f, 0x000004f1, 0x0000140a, 0xffffebf6, 0x00000a14, 0xfffff5ec, 0x00001414,
        0xffffebec, 0x00001900, 0xffffe700, 0x00000019, 0xffffffe7, 0x000013f1, 0xffffec0f, 0xfffff114,
        0x00000eec, 0x00002819, 0xffffd7e7, 0x00001928, 0xffffe6d8, 0x00001df6, 0xffffe20a, 0xfffff61e,
        0x000009e2, 0x0000280a, 0xffffd7f6, 0x00000a28, 0xfffff5d8, 0x00002828, 0xffffd7d8, 0x00002d00,
        0xffffd300, 0x0000002d, 0xffffffd3, 0x00001de2, 0xffffe21e, 0x000027ec, 0xffffd814, 0xffffec28,
        0x000013d8, 0x00004119, 0xffffbee7, 0x00001941, 0xffffe6bf, 0x0000462d, 0xffffb9d3, 0x00002d46,
        0xffffd2ba, 0x000036f1, 0xffffc90f, 0xfffff137, 0x00000ec9, 0x0000460a, 0xffffb9f6, 0x00000a46,
        0xfffff5ba, 0x00004b4b, 0xffffb4b5, 0x000054fb, 0xffffab05, 0xfffffb55, 0x000004ab, 0x000036d3,
        0xffffc92d, 0xffffd337, 0x00002cc9, 0x00004add, 0xffffb523, 0xffffdd4b, 0x000022b5, 0x00007337,
        0xffff8cc9, 0x00003773, 0xffffc88d, 0x0000731e, 0xffff8ce2, 0x00001e73, 0xffffe18d, 0x0000785a,
        0xffff87a6, 0x00005a78, 0xffffa588, 0x000068e2, 0xffff971e, 0xffffe269, 0x00001d97, 0x000054ab,
        0xffffab55, 0x000068ba, 0xffff9746, 0xffffba69, 0x00004597, 0x00001e1e, 0xffffe1e2, 0x00003c3c,
        0xffffc3c4, 0x00006969, 0xffff9697, 0x00000000, 0x05050000, 0xfafb0000, 0x05000000, 0xfb000000,
        0x00050000, 0xfffb0000, 0x0a0a0000, 0xf5f60000, 0x0f050000, 0xf0fb0000, 0x00000505, 0x05050505,
        0xfafb0505, 0x05000505, 0xfb000505, 0x00050505, 0xfffb0505, 0x0a0a0505, 0xf5f60505, 0x0f050505,
        0xf0fb0505, 0xfffffafb, 0x0504fafb, 0xfafafafb, 0x04fffafb, 0xfafffafb, 0x0004fafb, 0xfffafafb,
        0x0a09fafb, 0xf5f5fafb, 0x0f04fafb, 0xf0fafafb, 0x00000500, 0x05050500, 0xfafb0500, 0x05000500,
        0xfb000500, 0x00050500, 0xfffb0500, 0x0a0a0500, 0xf5f60500, 0x0f050500, 0xf0fb0500, 0xfffffb00,
        0x0504fb00, 0xfafafb00, 0x04fffb00, 0xfafffb00, 0x0004fb00, 0xfffafb00, 0x0a09fb00, 0xf5f5fb00,
        0x0f04fb00, 0xf0fafb00, 0x00000005, 0x05050005, 0xfafb0005, 0x05000005, 0xfb000005, 0x00050005,
        0xfffb0005, 0x0a0a0005, 0xf5f60005, 0x0f050005, 0xf0fb0005, 0xfffffffb, 0x0504fffb, 0xfafafffb,
        0x04fffffb, 0xfafffffb, 0x0004fffb, 0xfffafffb, 0x0a09fffb, 0xf5f5fffb, 0x0f04fffb, 0xf0fafffb,
        0x00000a0a, 0x05050a0a, 0xfafb0a0a, 0x05000a0a, 0xfb000a0a, 0x00050a0a, 0xfffb0a0a, 0x0a0a0a0a,
        0xf5f60a0a, 0x0f050a0a, 0xf0fb0a0a, 0xfffff5f6, 0x0504f5f6, 0xfafaf5f6, 0x04fff5f6, 0xfafff5f6,
        0x0004f5f6, 0xfffaf5f6, 0x0a09f5f6, 0xf5f5f5f6, 0x0f04f5f6, 0xf0faf5f6, 0x00000f05, 0x05050f05,
        0xfafb0f05, 0x05000f05, 0xfb000f05, 0x00050f05, 0xfffb0f05, 0x0a0a0f05, 0xf5f60f05, 0x0f050f05,
        0xf0fb0f05, 0xfffff0fb, 0x0504f0fb, 0xfafaf0fb, 0x04fff0fb, 0xfafff0fb, 0x0004f0fb, 0xfffaf0fb,
        0x0a09f0fb, 0xf5f5f0fb, 0x0f04f0fb, 0xf0faf0fb, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000606, 0xfffff9fa, 0x00000600, 0xfffffa00, 0x00000006, 0xfffffffa, 0x00000c0c,
        0xfffff3f4, 0x00000c06, 0xfffff3fa, 0x0000060c, 0xfffff9f4, 0x00000bf4, 0xfffff40c, 0x000011fa,
        0xffffee06, 0xfffffa12, 0x000005ee, 0x0000180c, 0xffffe7f4, 0x00000c18, 0xfffff3e8, 0x00001818,
        0xffffe7e8, 0x00001e00, 0xffffe200, 0x0000001e, 0xffffffe2, 0x000017ee, 0xffffe812, 0xffffee18,
        0x000011e8, 0x0000301e, 0xffffcfe2, 0x00001e30, 0xffffe1d0, 0x000023fa, 0xffffdc06, 0xfffffa24,
        0x000005dc, 0x0000300c, 0xffffcff4, 0x00000c30, 0xfffff3d0, 0x00003030, 0xffffcfd0, 0x00003600,
        0xffffca00, 0x00000036, 0xffffffca, 0x000023dc, 0xffffdc24, 0x00002fe8, 0xffffd018, 0xffffe830,
        0x000017d0, 0x00004e1e, 0xffffb1e2, 0x00001e4e, 0xffffe1b2, 0x00005436, 0xffffabca, 0x00003654,
        0xffffc9ac, 0x000041ee, 0xffffbe12, 0xffffee42, 0x000011be, 0x0000540c, 0xffffabf4, 0x00000c54,
        0xfffff3ac, 0x00005a5a, 0xffffa5a6, 0x00005ffa, 0xffffa006, 0xfffffa60, 0x000005a0, 0x000041ca,
        0xffffbe36, 0xffffca42, 0x000035be, 0x000059d6, 0xffffa62a, 0xffffd65a, 0x000029a6, 0x00007de2,
        0xffff821e, 0xffffe27e, 0x00001d82, 0x0000659a, 0xffff9a66, 0x00007dac, 0xffff8254, 0xffffac7e,
        0x00005382, 0x00002424, 0xffffdbdc, 0x00004242, 0xffffbdbe, 0x00000000, 0x06060000, 0xf9fa0000,
        0x06000000, 0xfa000000, 0x00060000, 0xfffa0000, 0x0c0c0000, 0xf3f40000, 0x0c060000, 0xf3fa0000,
        0x060c0000, 0x00000606, 0x06060606, 0xf9fa0606, 0x06000606, 0xfa000606, 0x00060606, 0xfffa0606,
        0x0c0c0606, 0xf3f40606, 0x0c060606, 0xf3fa0606, 0x060c0606, 0xfffff9fa, 0x0605f9fa, 0xf9f9f9fa,
        0x05fff9fa, 0xf9fff9fa, 0x0005f9fa, 0xfff9f9fa, 0x0c0bf9fa, 0xf3f3f9fa, 0x0c05f9fa, 0xf3f9f9fa,
        0x060bf9fa, 0x00000600, 0x06060600, 0xf9fa0600, 0x06000600, 0xfa000600, 0x00060600, 0xfffa0600,
        0x0c0c0600, 0xf3f40600, 0x0c060600, 0xf3fa0600, 0x060c0600, 0xfffffa00, 0x0605fa00, 0xf9f9fa00,
        0x05fffa00, 0xf9fffa00, 0x0005fa00, 0xfff9fa00, 0x0c0bfa00, 0xf3f3fa00, 0x0c05fa00, 0xf3f9fa00,
        0x060bfa00, 0x00000006, 0x06060006, 0xf9fa0006, 0x06000006, 0xfa000006, 0x00060006, 0xfffa0006,
        0x0c0c0006, 0xf3f40006, 0x0c060006, 0xf3fa0006, 0x060c0006, 0xfffffffa, 0x0605fffa, 0xf9f9fffa,
        0x05fffffa, 0xf9fffffa, 0x0005fffa, 0xfff9fffa, 0x0c0bfffa, 0xf3f3fffa, 0x0c05fffa, 0xf3f9fffa,
        0x060bfffa, 0x00000c0c, 0x06060c0c, 0xf9fa0c0c, 0x06000c0c, 0xfa000c0c, 0x00060c0c, 0xfffa0c0c,
        0x0c0c0c0c, 0xf3f40c0c, 0x0c060c0c, 0xf3fa0c0c, 0x060c0c0c, 0xfffff3f4, 0x0605f3f4, 0xf9f9f3f4,
        0x05fff3f4, 0xf9fff3f4, 0x0005f3f4, 0xfff9f3f4, 0x0c0bf3f4, 0xf3f3f3f4, 0x0c05f3f4, 0xf3f9f3f4,
        0x060bf3f4, 0x00000c06, 0x06060c06, 0xf9fa0c06, 0x06000c06, 0xfa000c06, 0x00060c06, 0xfffa0c06,
        0x0c0c0c06, 0xf3f40c06, 0x0c060c06, 0xf3fa0c06, 0x060c0c06, 0xfffff3fa, 0x0605f3fa, 0xf9f9f3fa,
        0x05fff3fa, 0xf9fff3fa, 0x0005f3fa, 0xfff9f3fa, 0x0c0bf3fa, 0xf3f3f3fa, 0x0c05f3fa, 0xf3f9f3fa,
        0x060bf3fa, 0x0000060c, 0x0606060c, 0xf9fa060c, 0x0600060c, 0xfa00060c, 0x0006060c, 0xfffa060c,
        0x0c0c060c, 0xf3f4060c, 0x0c06060c, 0xf3fa060c, 0x060c060c, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000707, 0xfffff8f9, 0x00000700, 0xfffff900, 0x00000007, 0xfffffff9, 0x00000e0e,
        0xfffff1f2, 0x00001507, 0xffffeaf9, 0x00000715, 0xfffff8eb, 0x00000df2, 0xfffff20e, 0x000014f9,
        0xffffeb07, 0xfffff915, 0x000006eb, 0x00001c0e, 0xffffe3f2, 0x00000e1c, 0xfffff1e4, 0x00001c1c,
        0xffffe3e4, 0x00002300, 0xffffdd00, 0x00000023, 0xffffffdd, 0x00001beb, 0xffffe415, 0xffffeb1c,
        0x000014e4, 0x00003823, 0xffffc7dd, 0x00002338, 0xffffdcc8, 0x000029f2, 0xffffd60e, 0xfffff22a,
        0x00000dd6, 0x0000380e, 0xffffc7f2, 0x00000e38, 0xfffff1c8, 0x00003838, 0xffffc7c8, 0x00003f00,
        0xffffc100, 0x0000003f, 0xffffffc1, 0x000029d6, 0xffffd62a, 0x000037e4, 0xffffc81c, 0xffffe438,
        0x00001bc8, 0x00005b23, 0xffffa4dd, 0x0000235b, 0xffffdca5, 0x0000623f, 0xffff9dc1, 0x00003f62,
        0xffffc09e, 0x00004ceb, 0xffffb315, 0xffffeb4d, 0x000014b3, 0x0000620e, 0xffff9df2, 0x00000e62,
        0xfffff19e, 0x00006969, 0xffff9697, 0x000076f9, 0xffff8907, 0xfffff977, 0x00000689, 0x00004cc1,
        0xffffb33f, 0xffffc14d, 0x00003eb3, 0x000068cf, 0xffff9731, 0xffffcf69, 0x00003097, 0x00007689,
        0xffff8977, 0x00002a2a, 0xffffd5d6, 0x00004d4d, 0xffffb2b3, 0x00000000, 0x07070000, 0xf8f90000,
        0x07000000, 0xf9000000, 0x00070000, 0xfff90000, 0x0e0e0000, 0xf1f20000, 0x15070000, 0xeaf90000,
        0x07150000, 0x00000707, 0x07070707, 0xf8f90707, 0x07000707, 0xf9000707, 0x00070707, 0xfff90707,
        0x0e0e0707, 0xf1f20707, 0x15070707, 0xeaf90707, 0x07150707, 0xfffff8f9, 0x0706f8f9, 0xf8f8f8f9,
        0x06fff8f9, 0xf8fff8f9, 0x0006f8f9, 0xfff8f8f9, 0x0e0df8f9, 0xf1f1f8f9, 0x1506f8f9, 0xeaf8f8f9,
        0x0714f8f9, 0x00000700, 0x07070700, 0xf8f90700, 0x07000700, 0xf9000700, 0x00070700, 0xfff90700,
        0x0e0e0700, 0xf1f20700, 0x15070700, 0xeaf90700, 0x07150700, 0xfffff900, 0x0706f900, 0xf8f8f900,
        0x06fff900, 0xf8fff900, 0x0006f900, 0xfff8f900, 0x0e0df900, 0xf1f1f900, 0x1506f900, 0xeaf8f900,
        0x0714f900, 0x00000007, 0x07070007, 0xf8f90007, 0x07000007, 0xf9000007, 0x00070007, 0xfff90007,
        0x0e0e0007, 0xf1f20007, 0x15070007, 0xeaf90007, 0x07150007, 0xfffffff9, 0x0706fff9, 0xf8f8fff9,
        0x06fffff9, 0xf8fffff9, 0x0006fff9, 0xfff8fff9, 0x0e0dfff9, 0xf1f1fff9, 0x1506fff9, 0xeaf8fff9,
        0x0714fff9, 0x00000e0e, 0x07070e0e, 0xf8f90e0e, 0x07000e0e, 0xf9000e0e, 0x00070e0e, 0xfff90e0e,
        0x0e0e0e0e, 0xf1f20e0e, 0x15070e0e, 0xeaf90e0e, 0x07150e0e, 0xfffff1f2, 0x0706f1f2, 0xf8f8f1f2,
        0x06fff1f2, 0xf8fff1f2, 0x0006f1f2, 0xfff8f1f2, 0x0e0df1f2, 0xf1f1f1f2, 0x1506f1f2, 0xeaf8f1f2,
        0x0714f1f2, 0x00001507, 0x07071507, 0xf8f91507, 0x07001507, 0xf9001507, 0x00071507, 0xfff91507,
        0x0e0e1507, 0xf1f21507, 0x15071507, 0xeaf91507, 0x07151507, 0xffffeaf9, 0x0706eaf9, 0xf8f8eaf9,
        0x06ffeaf9, 0xf8ffeaf9, 0x0006eaf9, 0xfff8eaf9, 0x0e0deaf9, 0xf1f1eaf9, 0x1506eaf9, 0xeaf8eaf9,
        0x0714eaf9, 0x00000715, 0x07070715, 0xf8f90715, 0x07000715, 0xf9000715, 0x00070715, 0xfff90715,
        0x0e0e0715, 0xf1f20715, 0x15070715, 0xeaf90715, 0x07150715, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000808, 0xfffff7f8, 0x00000800, 0xfffff800, 0x00000008, 0xfffffff8, 0x00001010,
        0xffffeff0, 0x00001008, 0xffffeff8, 0x00000810, 0xfffff7f0, 0x00000ff0, 0xfffff010, 0x000017f8,
        0xffffe808, 0xfffff818, 0x000007e8, 0x00002010, 0xffffdff0, 0x00001020, 0xffffefe0, 0x00002020,
        0xffffdfe0, 0x00002800, 0xffffd800, 0x00000028, 0xffffffd8, 0x00001fe8, 0xffffe018, 0xffffe820,
        0x000017e0, 0x00004028, 0xffffbfd8, 0x00002840, 0xffffd7c0, 0x00002ff0, 0xffffd010, 0xfffff030,
        0x00000fd0, 0x00004010, 0xffffbff0, 0x00001040, 0xffffefc0, 0x00004040, 0xffffbfc0, 0x00004800,
        0xffffb800, 0x00000048, 0xffffffb8, 0x00002fd0, 0xffffd030, 0x00003fe0, 0xffffc020, 0xffffe040,
        0x00001fc0, 0x00006828, 0xffff97d8, 0x00002868, 0xffffd798, 0x00007048, 0xffff8fb8, 0x00004870,
        0xffffb790, 0x000057e8, 0xffffa818, 0xffffe858, 0x000017a8, 0x00007010, 0xffff8ff0, 0x00001070,
        0xffffef90, 0x00007878, 0xffff8788, 0x000057b8, 0xffffa848, 0xffffb858, 0x000047a8, 0x000077c8,
        0xffff8838, 0xffffc878, 0x00003788, 0x00003030, 0xffffcfd0, 0x00005858, 0xffffa7a8, 0x00000000,
        0x08080000, 0xf7f80000, 0x08000000, 0xf8000000, 0x00080000, 0xfff80000, 0x10100000, 0xeff00000,
        0x10080000, 0xeff80000, 0x08100000, 0x00000808, 0x08080808, 0xf7f80808, 0x08000808, 0xf8000808,
        0x00080808, 0xfff80808, 0x10100808, 0xeff00808, 0x10080808, 0xeff80808, 0x08100808, 0xfffff7f8,
        0x0807f7f8, 0xf7f7f7f8, 0x07fff7f8, 0xf7fff7f8, 0x0007f7f8, 0xfff7f7f8, 0x100ff7f8, 0xefeff7f8,
        0x1007f7f8, 0xeff7f7f8, 0x080ff7f8, 0x00000800, 0x08080800, 0xf7f80800, 0x08000800, 0xf8000800,
        0x00080800, 0xfff80800, 0x10100800, 0xeff00800, 0x10080800, 0xeff80800, 0x08100800, 0xfffff800,
        0x0807f800, 0xf7f7f800, 0x07fff800, 0xf7fff800, 0x0007f800, 0xfff7f800, 0x100ff800, 0xefeff800,
        0x1007f800, 0xeff7f800, 0x080ff800, 0x00000008, 0x08080008, 0xf7f80008, 0x08000008, 0xf8000008,
        0x00080008, 0xfff80008, 0x10100008, 0xeff00008, 0x10080008, 0xeff80008, 0x08100008, 0xfffffff8,
        0x0807fff8, 0xf7f7fff8, 0x07fffff8, 0xf7fffff8, 0x0007fff8, 0xfff7fff8, 0x100ffff8, 0xefeffff8,
        0x1007fff8, 0xeff7fff8, 0x080ffff8, 0x00001010, 0x08081010, 0xf7f81010, 0x08001010, 0xf8001010,
        0x00081010, 0xfff81010, 0x10101010, 0xeff01010, 0x10081010, 0xeff81010, 0x08101010, 0xffffeff0,
        0x0807eff0, 0xf7f7eff0, 0x07ffeff0, 0xf7ffeff0, 0x0007eff0, 0xfff7eff0, 0x100feff0, 0xefefeff0,
        0x1007eff0, 0xeff7eff0, 0x080feff0, 0x00001008, 0x08081008, 0xf7f81008, 0x08001008, 0xf8001008,
        0x00081008, 0xfff81008, 0x10101008, 0xeff01008, 0x10081008, 0xeff81008, 0x08101008, 0xffffeff8,
        0x0807eff8, 0xf7f7eff8, 0x07ffeff8, 0xf7ffeff8, 0x0007eff8, 0xfff7eff8, 0x100feff8, 0xefefeff8,
        0x1007eff8, 0xeff7eff8, 0x080feff8, 0x00000810, 0x08080810, 0xf7f80810, 0x08000810, 0xf8000810,
        0x00080810, 0xfff80810, 0x10100810, 0xeff00810, 0x10080810, 0xeff80810, 0x08100810, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000909, 0xfffff6f7, 0x00000900, 0xfffff700, 0x00000009, 0xfffffff7, 0x00001212,
        0xffffedee, 0x00001b09, 0xffffe4f7, 0x0000091b, 0xfffff6e5, 0x000011ee, 0xffffee12, 0x00001af7,
        0xffffe509, 0xfffff71b, 0x000008e5, 0x00002412, 0xffffdbee, 0x00001224, 0xffffeddc, 0x00002424,
        0xffffdbdc, 0x00002d00, 0xffffd300, 0x0000002d, 0xffffffd3, 0x000023e5, 0xffffdc1b, 0xffffe524,
        0x00001adc, 0x0000482d, 0xffffb7d3, 0x00002d48, 0xffffd2b8, 0x000035ee, 0xffffca12, 0xffffee36,
        0x000011ca, 0x00004812, 0xffffb7ee, 0x00001248, 0xffffedb8, 0x00004848, 0xffffb7b8, 0x00005100,
        0xffffaf00, 0x00000051, 0xffffffaf, 0x000035ca, 0xffffca36, 0x000047dc, 0xffffb824, 0xffffdc48,
        0x000023b8, 0x0000752d, 0xffff8ad3, 0x00002d75, 0xffffd28b, 0x00007e51, 0xffff81af, 0x0000517e,
        0xffffae82, 0x000062e5, 0xffff9d1b, 0xffffe563, 0x00001a9d, 0x000062af, 0xffff9d51, 0xffffaf63,
        0x0000509d, 0x00003636, 0xffffc9ca, 0x00006c6c, 0xffff9394, 0x00000000, 0x09090000, 0xf6f70000,
        0x09000000, 0xf7000000, 0x00090000, 0xfff70000, 0x12120000, 0xedee0000, 0x1b090000, 0xe4f70000,
        0x091b0000, 0xf6e50000, 0x00000909, 0x09090909, 0xf6f70909, 0x09000909, 0xf7000909, 0x00090909,
        0xfff70909, 0x12120909, 0xedee0909, 0x1b090909, 0xe4f70909, 0x091b0909, 0xf6e50909, 0xfffff6f7,
        0x0908f6f7, 0xf6f6f6f7, 0x08fff6f7, 0xf6fff6f7, 0x0008f6f7, 0xfff6f6f7, 0x1211f6f7, 0xededf6f7,
        0x1b08f6f7, 0xe4f6f6f7, 0x091af6f7, 0xf6e4f6f7, 0x00000900, 0x09090900, 0xf6f70900, 0x09000900,
        0xf7000900, 0x00090900, 0xfff70900, 0x12120900, 0xedee0900, 0x1b090900, 0xe4f70900, 0x091b0900,
        0xf6e50900, 0xfffff700, 0x0908f700, 0xf6f6f700, 0x08fff700, 0xf6fff700, 0x0008f700, 0xfff6f700,
        0x1211f700, 0xededf700, 0x1b08f700, 0xe4f6f700, 0x091af700, 0xf6e4f700, 0x00000009, 0x09090009,
        0xf6f70009, 0x09000009, 0xf7000009, 0x00090009, 0xfff70009, 0x12120009, 0xedee0009, 0x1b090009,
        0xe4f70009, 0x091b0009, 0xf6e50009, 0xfffffff7, 0x0908fff7, 0xf6f6fff7, 0x08fffff7, 0xf6fffff7,
        0x0008fff7, 0xfff6fff7, 0x1211fff7, 0xededfff7, 0x1b08fff7, 0xe4f6fff7, 0x091afff7, 0xf6e4fff7,
        0x00001212, 0x09091212, 0xf6f71212, 0x09001212, 0xf7001212, 0x00091212, 0xfff71212, 0x12121212,
        0xedee1212, 0x1b091212, 0xe4f71212, 0x091b1212, 0xf6e51212, 0xffffedee, 0x0908edee, 0xf6f6edee,
        0x08ffedee, 0xf6ffedee, 0x0008edee, 0xfff6edee, 0x1211edee, 0xedededee, 0x1b08edee, 0xe4f6edee,
        0x091aedee, 0xf6e4edee, 0x00001b09, 0x09091b09, 0xf6f71b09, 0x09001b09, 0xf7001b09, 0x00091b09,
        0xfff71b09, 0x12121b09, 0xedee1b09, 0x1b091b09, 0xe4f71b09, 0x091b1b09, 0xf6e51b09, 0xffffe4f7,
        0x0908e4f7, 0xf6f6e4f7, 0x08ffe4f7, 0xf6ffe4f7, 0x0008e4f7, 0xfff6e4f7, 0x1211e4f7, 0xedede4f7,
        0x1b08e4f7, 0xe4f6e4f7, 0x091ae4f7, 0xf6e4e4f7, 0x0000091b, 0x0909091b, 0xf6f7091b, 0x0900091b,
        0xf700091b, 0x0009091b, 0xfff7091b, 0x1212091b, 0xedee091b, 0x1b09091b, 0xe4f7091b, 0x091b091b,
        0xf6e5091b, 0xfffff6e5, 0x0908f6e5, 0xf6f6f6e5, 0x08fff6e5, 0xf6fff6e5, 0x0008f6e5, 0xfff6f6e5,
        0x1211f6e5, 0xededf6e5, 0x1b08f6e5, 0xe4f6f6e5, 0x091af6e5, 0xf6e4f6e5, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000300, 0xfffffd00, 0x00000003, 0xfffffffd, 0x00000606,
        0xfffff9fa, 0x00000700, 0xfffff900, 0x00000007, 0xfffffff9, 0x000004fb, 0xfffffb05, 0xfffffb05,
        0x000004fb, 0x00000b06, 0xfffff4fa, 0x0000060b, 0xfffff9f5, 0x00000800, 0xfffff800, 0x00000008,
        0xfffffff8, 0x00000b0b, 0xfffff4f5, 0x00000c00, 0xfffff400, 0x0000000c, 0xfffffff4, 0x0000110c,
        0xffffeef4, 0x00000c11, 0xfffff3ef, 0x00001111, 0xffffeeef, 0x00001206, 0xffffedfa, 0x00000612,
        0xfffff9ee, 0x00000af8, 0xfffff508, 0xfffff80b, 0x000007f5, 0x00000f00, 0xfffff100, 0x0000000f,
        0xfffffff1, 0x00001400, 0xffffec00, 0x00000014, 0xffffffec, 0x00001912, 0xffffe6ee, 0x00001219,
        0xffffede7, 0x0000190b, 0xffffe6f5, 0x00000b19, 0xfffff4e7, 0x00001919, 0xffffe6e7, 0x00000df2,
        0xfffff20e, 0xfffff20e, 0x00000df2, 0x00001a00, 0xffffe600, 0x0000001a, 0xffffffe6, 0x000011f5,
        0xffffee0b, 0xfffff512, 0x00000aee, 0x000015f9, 0xffffea07, 0xfffff916, 0x000006ea, 0x0000221a,
        0xffffdde6, 0x00001a22, 0xffffe5de, 0x00002212, 0xffffddee, 0x00001222, 0xffffedde, 0x00002222,
        0xffffddde, 0x0000230b, 0xffffdcf5, 0x00000b23, 0xfffff4dd, 0x00001d00, 0xffffe300, 0x0000001d,
        0xffffffe3, 0x000015ed, 0xffffea13, 0xffffed16, 0x000012ea, 0x000019f1, 0xffffe60f, 0xfffff11a,
        0x00000ee6, 0x00002500, 0xffffdb00, 0x00000025, 0xffffffdb, 0x00002c1b, 0xffffd3e5, 0x00001b2c,
        0xffffe4d4, 0x00002c24, 0xffffd3dc, 0x0000242c, 0xffffdbd4, 0x00002c12, 0xffffd3ee, 0x0000122c,
        0xffffedd4, 0x000020f6, 0xffffdf0a, 0xfffff621, 0x000009df, 0x00002d2d, 0xffffd2d3, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000300, 0xfffffd00, 0x00000003, 0xfffffffd, 0x00000606,
        0xfffff9fa, 0x00000700, 0xfffff900, 0x02020000, 0x02020202, 0x0201fdfe, 0x02020300, 0x0201fd00,
        0x02020003, 0x0201fffd, 0x02020606, 0x0201f9fa, 0x02020700, 0x0201f900, 0xfdfe0000, 0xfdfe0202,
        0xfdfdfdfe, 0xfdfe0300, 0xfdfdfd00, 0xfdfe0003, 0xfdfdfffd, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0700,
        0xfdfdf900, 0x03000000, 0x03000202, 0x02fffdfe, 0x03000300, 0x02fffd00, 0x03000003, 0x02fffffd,
        0x03000606, 0x02fff9fa, 0x03000700, 0x02fff900, 0xfd000000, 0xfd000202, 0xfcfffdfe, 0xfd000300,
        0xfcfffd00, 0xfd000003, 0xfcfffffd, 0xfd000606, 0xfcfff9fa, 0xfd000700, 0xfcfff900, 0x00030000,
        0x00030202, 0x0002fdfe, 0x00030300, 0x0002fd00, 0x00030003, 0x0002fffd, 0x00030606, 0x0002f9fa,
        0x00030700, 0x0002f900, 0xfffd0000, 0xfffd0202, 0xfffcfdfe, 0xfffd0300, 0xfffcfd00, 0xfffd0003,
        0xfffcfffd, 0xfffd0606, 0xfffcf9fa, 0xfffd0700, 0xfffcf900, 0x06060000, 0x06060202, 0x0605fdfe,
        0x06060300, 0x0605fd00, 0x06060003, 0x0605fffd, 0x06060606, 0x0605f9fa, 0x06060700, 0x0605f900,
        0xf9fa0000, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0300, 0xf9f9fd00, 0xf9fa0003, 0xf9f9fffd, 0xf9fa0606,
        0xf9f9f9fa, 0xf9fa0700, 0xf9f9f900, 0x07000000, 0x07000202, 0x06fffdfe, 0x07000300, 0x06fffd00,
        0x07000003, 0x06fffffd, 0x07000606, 0x06fff9fa, 0x07000700, 0x06fff900, 0xf9000000, 0xf9000202,
        0xf8fffdfe, 0xf9000300, 0xf8fffd00, 0xf9000003, 0xf8fffffd, 0xf9000606, 0xf8fff9fa, 0xf9000700,
        0xf8fff900, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000200, 0xfffffe00, 0x00000002, 0xfffffffe, 0x00000202, 0xfffffdfe, 0x00000606,
        0xfffff9fa, 0x00000600, 0xfffffa00, 0x00000006, 0xfffffffa, 0x000003fc, 0xfffffc04, 0xfffffa0a,
        0x000005f6, 0xfffff400, 0x00000c00, 0xfffff3fa, 0xfffff406, 0x00000bfa, 0x00000c06, 0xfffffff2,
        0x0000000e, 0x00000c0c, 0xfffff3f4, 0xffffee00, 0x00001200, 0xfffff40e, 0x00000bf2, 0xfffff9ee,
        0xfffffa12, 0x000005ee, 0x00000612, 0xffffedf6, 0xffffee0a, 0x000011f6, 0x0000120a, 0xffffffea,
        0x00000016, 0xffffe800, 0x00001800, 0xfffff3ea, 0xfffff416, 0x00000bea, 0x00000c16, 0xffffe7f8,
        0xffffe808, 0x000017f8, 0x00001808, 0xfffff9e6, 0xfffffa1a, 0x000005e6, 0x0000061a, 0xffffffe4,
        0x0000001c, 0x00001414, 0xffffebec, 0xffffe5f2, 0x00001a0e, 0xfffff3e2, 0x00000c1e, 0xffffdff6,
        0x0000200a, 0xffffdfee, 0x00002012, 0xffffe5e6, 0x00001a1a, 0xffffebde, 0x00001422, 0xfffff3da,
        0x00000c26, 0xffffdfe0, 0x00002020, 0x00002020, 0xffffd7ea, 0xffffddde, 0x00002222, 0x00000000,
        0x00000200, 0xfffffe00, 0x00000002, 0xfffffffe, 0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa,
        0x00000600, 0xfffffa00, 0x00000006, 0xfffffffa, 0x02000000, 0x02000200, 0x01fffe00, 0x02000002,
        0x01fffffe, 0x02000202, 0x01fffdfe, 0x02000606, 0x01fff9fa, 0x02000600, 0x01fffa00, 0x02000006,
        0x01fffffa, 0xfe000000, 0xfe000200, 0xfdfffe00, 0xfe000002, 0xfdfffffe, 0xfe000202, 0xfdfffdfe,
        0xfe000606, 0xfdfff9fa, 0xfe000600, 0xfdfffa00, 0xfe000006, 0xfdfffffa, 0x00020000, 0x00020200,
        0x0001fe00, 0x00020002, 0x0001fffe, 0x00020202, 0x0001fdfe, 0x00020606, 0x0001f9fa, 0x00020600,
        0x0001fa00, 0x00020006, 0x0001fffa, 0xfffe0000, 0xfffe0200, 0xfffdfe00, 0xfffe0002, 0xfffdfffe,
        0xfffe0202, 0xfffdfdfe, 0xfffe0606, 0xfffdf9fa, 0xfffe0600, 0xfffdfa00, 0xfffe0006, 0xfffdfffa,
        0x02020000, 0x02020200, 0x0201fe00, 0x02020002, 0x0201fffe, 0x02020202, 0x0201fdfe, 0x02020606,
        0x0201f9fa, 0x02020600, 0x0201fa00, 0x02020006, 0x0201fffa, 0xfdfe0000, 0xfdfe0200, 0xfdfdfe00,
        0xfdfe0002, 0xfdfdfffe, 0xfdfe0202, 0xfdfdfdfe, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0600, 0xfdfdfa00,
        0xfdfe0006, 0xfdfdfffa, 0x06060000, 0x06060200, 0x0605fe00, 0x06060002, 0x0605fffe, 0x06060202,
        0x0605fdfe, 0x06060606, 0x0605f9fa, 0x06060600, 0x0605fa00, 0x06060006, 0x0605fffa, 0xf9fa0000,
        0xf9fa0200, 0xf9f9fe00, 0xf9fa0002, 0xf9f9fffe, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0606, 0xf9f9f9fa,
        0xf9fa0600, 0xf9f9fa00, 0xf9fa0006, 0xf9f9fffa, 0x06000000, 0x06000200, 0x05fffe00, 0x06000002,
        0x05fffffe, 0x06000202, 0x05fffdfe, 0x06000606, 0x05fff9fa, 0x06000600, 0x05fffa00, 0x06000006,
        0x05fffffa, 0xfa000000, 0xfa000200, 0xf9fffe00, 0xfa000002, 0xf9fffffe, 0xfa000202, 0xf9fffdfe,
        0xfa000606, 0xf9fff9fa, 0xfa000600, 0xf9fffa00, 0xfa000006, 0xf9fffffa, 0x00060000, 0x00060200,
        0x0005fe00, 0x00060002, 0x0005fffe, 0x00060202, 0x0005fdfe, 0x00060606, 0x0005f9fa, 0x00060600,
        0x0005fa00, 0x00060006, 0x0005fffa, 0xfffa0000, 0xfffa0200, 0xfff9fe00, 0xfffa0002, 0xfff9fffe,
        0xfffa0202, 0xfff9fdfe, 0xfffa0606, 0xfff9f9fa, 0xfffa0600, 0xfff9fa00, 0xfffa0006, 0xfff9fffa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000200, 0xfffffe00, 0x00000002, 0xfffffffe, 0x00000404, 0xfffffbfc, 0x00000a0a,
        0xfffff5f6, 0x00000a00, 0xfffff600, 0x0000000a, 0xfffffff6, 0x000005fa, 0xfffffa06, 0xfffff80e,
        0x000007f2, 0xffffffee, 0x00000012, 0xfffff00a, 0x00000ff6, 0xffffe800, 0x00001800, 0xfffff7e8,
        0xfffff818, 0x000007e8, 0x00000818, 0x00001212, 0xffffedee, 0xfffff014, 0x00000fec, 0xffffe5f2,
        0xffffe60e, 0x000019f2, 0x00001a0e, 0xffffffe2, 0x0000001e, 0xffffde00, 0x00002200, 0xfffff7de,
        0xfffff822, 0x000007de, 0x00000822, 0xffffede2, 0xffffee1e, 0x000011e2, 0x0000121e, 0xffffddf6,
        0xffffde0a, 0x000021f6, 0x0000220a, 0xffffddec, 0x00002214, 0xffffffd8, 0x00000028, 0x00001e1e,
        0xffffe1e2, 0xffffedd8, 0x00001228, 0xffffd400, 0x00002c00, 0xffffd3f0, 0x00002c10, 0xffffdbdc,
        0xffffdbdc, 0x00002424, 0xffffd3e6, 0x00002c1a, 0xffffe5d2, 0x00001a2e, 0xffffedcc, 0x00001234,
        0xffffc9ec, 0xffffd3d4, 0x00002c2c, 0xffffc9e0, 0xffffd1d2, 0xffffd1d2, 0x00002e2e, 0x00000000,
        0x00000200, 0xfffffe00, 0x00000002, 0xfffffffe, 0x00000404, 0xfffffbfc, 0x00000a0a, 0xfffff5f6,
        0x00000a00, 0xfffff600, 0x0000000a, 0xfffffff6, 0x02000000, 0x02000200, 0x01fffe00, 0x02000002,
        0x01fffffe, 0x02000404, 0x01fffbfc, 0x02000a0a, 0x01fff5f6, 0x02000a00, 0x01fff600, 0x0200000a,
        0x01fffff6, 0xfe000000, 0xfe000200, 0xfdfffe00, 0xfe000002, 0xfdfffffe, 0xfe000404, 0xfdfffbfc,
        0xfe000a0a, 0xfdfff5f6, 0xfe000a00, 0xfdfff600, 0xfe00000a, 0xfdfffff6, 0x00020000, 0x00020200,
        0x0001fe00, 0x00020002, 0x0001fffe, 0x00020404, 0x0001fbfc, 0x00020a0a, 0x0001f5f6, 0x00020a00,
        0x0001f600, 0x0002000a, 0x0001fff6, 0xfffe0000, 0xfffe0200, 0xfffdfe00, 0xfffe0002, 0xfffdfffe,
        0xfffe0404, 0xfffdfbfc, 0xfffe0a0a, 0xfffdf5f6, 0xfffe0a00, 0xfffdf600, 0xfffe000a, 0xfffdfff6,
        0x04040000, 0x04040200, 0x0403fe00, 0x04040002, 0x0403fffe, 0x04040404, 0x0403fbfc, 0x04040a0a,
        0x0403f5f6, 0x04040a00, 0x0403f600, 0x0404000a, 0x0403fff6, 0xfbfc0000, 0xfbfc0200, 0xfbfbfe00,
        0xfbfc0002, 0xfbfbfffe, 0xfbfc0404, 0xfbfbfbfc, 0xfbfc0a0a, 0xfbfbf5f6, 0xfbfc0a00, 0xfbfbf600,
        0xfbfc000a, 0xfbfbfff6, 0x0a0a0000, 0x0a0a0200, 0x0a09fe00, 0x0a0a0002, 0x0a09fffe, 0x0a0a0404,
        0x0a09fbfc, 0x0a0a0a0a, 0x0a09f5f6, 0x0a0a0a00, 0x0a09f600, 0x0a0a000a, 0x0a09fff6, 0xf5f60000,
        0xf5f60200, 0xf5f5fe00, 0xf5f60002, 0xf5f5fffe, 0xf5f60404, 0xf5f5fbfc, 0xf5f60a0a, 0xf5f5f5f6,
        0xf5f60a00, 0xf5f5f600, 0xf5f6000a, 0xf5f5fff6, 0x0a000000, 0x0a000200, 0x09fffe00, 0x0a000002,
        0x09fffffe, 0x0a000404, 0x09fffbfc, 0x0a000a0a, 0x09fff5f6, 0x0a000a00, 0x09fff600, 0x0a00000a,
        0x09fffff6, 0xf6000000, 0xf6000200, 0xf5fffe00, 0xf6000002, 0xf5fffffe, 0xf6000404, 0xf5fffbfc,
        0xf6000a0a, 0xf5fff5f6, 0xf6000a00, 0xf5fff600, 0xf600000a, 0xf5fffff6, 0x000a0000, 0x000a0200,
        0x0009fe00, 0x000a0002, 0x0009fffe, 0x000a0404, 0x0009fbfc, 0x000a0a0a, 0x0009f5f6, 0x000a0a00,
        0x0009f600, 0x000a000a, 0x0009fff6, 0xfff60000, 0xfff60200, 0xfff5fe00, 0xfff60002, 0xfff5fffe,
        0xfff60404, 0xfff5fbfc, 0xfff60a0a, 0xfff5f5f6, 0xfff60a00, 0xfff5f600, 0xfff6000a, 0xfff5fff6,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000400, 0xfffffc00, 0x00000004, 0xfffffffc, 0x00000404, 0xfffffbfc, 0x00000c0c,
        0xfffff3f4, 0x00000c00, 0xfffff400, 0x0000000c, 0xfffffff4, 0x000007f8, 0xfffff808, 0xfffff008,
        0x00000ff8, 0xffffe800, 0x00001800, 0xfffff7e8, 0xfffff818, 0x000007e8, 0x00000818, 0xfffff014,
        0x00000fec, 0xffffffe4, 0x0000001c, 0xffffe7f0, 0xffffe810, 0x000017f0, 0x00001810, 0xffffe000,
        0x00002000, 0xffffefe4, 0xfffff01c, 0x00000fe4, 0x0000101c, 0xffffdff8, 0xffffe008, 0xfffff7e0,
        0xfffff820, 0x000007e0, 0x00000820, 0x00001ff8, 0x00002008, 0x00001818, 0xffffe7e8, 0xffffe818,
        0x000017e8, 0xffffdfec, 0x00002014, 0xffffffd8, 0x00000028, 0xffffefd8, 0x00001028, 0xffffd400,
        0xffffd400, 0xffffffd4, 0x0000002c, 0x00002c00, 0x00002c00, 0xffffdfe0, 0x00002020, 0xffffd3f0,
        0x00002c10, 0xffffd3e8, 0xffffe7d4, 0x0000182c, 0x00002c18, 0xffffefd0, 0x00001030, 0xffffdbdc,
        0xffffdbdc, 0x00002424, 0x00002424, 0xffffcbec, 0x00002828, 0xffffd7d8, 0xffffcbe0, 0x00000000,
        0x00000400, 0xfffffc00, 0x00000004, 0xfffffffc, 0x00000404, 0xfffffbfc, 0x00000c0c, 0xfffff3f4,
        0x00000c00, 0xfffff400, 0x0000000c, 0xfffffff4, 0x04000000, 0x04000400, 0x03fffc00, 0x04000004,
        0x03fffffc, 0x04000404, 0x03fffbfc, 0x04000c0c, 0x03fff3f4, 0x04000c00, 0x03fff400, 0x0400000c,
        0x03fffff4, 0xfc000000, 0xfc000400, 0xfbfffc00, 0xfc000004, 0xfbfffffc, 0xfc000404, 0xfbfffbfc,
        0xfc000c0c, 0xfbfff3f4, 0xfc000c00, 0xfbfff400, 0xfc00000c, 0xfbfffff4, 0x00040000, 0x00040400,
        0x0003fc00, 0x00040004, 0x0003fffc, 0x00040404, 0x0003fbfc, 0x00040c0c, 0x0003f3f4, 0x00040c00,
        0x0003f400, 0x0004000c, 0x0003fff4, 0xfffc0000, 0xfffc0400, 0xfffbfc00, 0xfffc0004, 0xfffbfffc,
        0xfffc0404, 0xfffbfbfc, 0xfffc0c0c, 0xfffbf3f4, 0xfffc0c00, 0xfffbf400, 0xfffc000c, 0xfffbfff4,
        0x04040000, 0x04040400, 0x0403fc00, 0x04040004, 0x0403fffc, 0x04040404, 0x0403fbfc, 0x04040c0c,
        0x0403f3f4, 0x04040c00, 0x0403f400, 0x0404000c, 0x0403fff4, 0xfbfc0000, 0xfbfc0400, 0xfbfbfc00,
        0xfbfc0004, 0xfbfbfffc, 0xfbfc0404, 0xfbfbfbfc, 0xfbfc0c0c, 0xfbfbf3f4, 0xfbfc0c00, 0xfbfbf400,
        0xfbfc000c, 0xfbfbfff4, 0x0c0c0000, 0x0c0c0400, 0x0c0bfc00, 0x0c0c0004, 0x0c0bfffc, 0x0c0c0404,
        0x0c0bfbfc, 0x0c0c0c0c, 0x0c0bf3f4, 0x0c0c0c00, 0x0c0bf400, 0x0c0c000c, 0x0c0bfff4, 0xf3f40000,
        0xf3f40400, 0xf3f3fc00, 0xf3f40004, 0xf3f3fffc, 0xf3f40404, 0xf3f3fbfc, 0xf3f40c0c, 0xf3f3f3f4,
        0xf3f40c00, 0xf3f3f400, 0xf3f4000c, 0xf3f3fff4, 0x0c000000, 0x0c000400, 0x0bfffc00, 0x0c000004,
        0x0bfffffc, 0x0c000404, 0x0bfffbfc, 0x0c000c0c, 0x0bfff3f4, 0x0c000c00, 0x0bfff400, 0x0c00000c,
        0x0bfffff4, 0xf4000000, 0xf4000400, 0xf3fffc00, 0xf4000004, 0xf3fffffc, 0xf4000404, 0xf3fffbfc,
        0xf4000c0c, 0xf3fff3f4, 0xf4000c00, 0xf3fff400, 0xf400000c, 0xf3fffff4, 0x000c0000, 0x000c0400,
        0x000bfc00, 0x000c0004, 0x000bfffc, 0x000c0404, 0x000bfbfc, 0x000c0c0c, 0x000bf3f4, 0x000c0c00,
        0x000bf400, 0x000c000c, 0x000bfff4, 0xfff40000, 0xfff40400, 0xfff3fc00, 0xfff40004, 0xfff3fffc,
        0xfff40404, 0xfff3fbfc, 0xfff40c0c, 0xfff3f3f4, 0xfff40c00, 0xfff3f400, 0xfff4000c, 0xfff3fff4,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414,
        0xffffebec, 0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414, 0xffffebec,
        0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x02020000, 0x02020202, 0x0201fdfe, 0x02020606,
        0x0201f9fa, 0x02020c0c, 0x0201f3f4, 0x02021414, 0x0201ebec, 0x02022020, 0x0201dfe0, 0x02022e2e,
        0x0201d1d2, 0xfdfe0000, 0xfdfe0202, 0xfdfdfdfe, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0c0c, 0xfdfdf3f4,
        0xfdfe1414, 0xfdfdebec, 0xfdfe2020, 0xfdfddfe0, 0xfdfe2e2e, 0xfdfdd1d2, 0x06060000, 0x06060202,
        0x0605fdfe, 0x06060606, 0x0605f9fa, 0x06060c0c, 0x0605f3f4, 0x06061414, 0x0605ebec, 0x06062020,
        0x0605dfe0, 0x06062e2e, 0x0605d1d2, 0xf9fa0000, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0606, 0xf9f9f9fa,
        0xf9fa0c0c, 0xf9f9f3f4, 0xf9fa1414, 0xf9f9ebec, 0xf9fa2020, 0xf9f9dfe0, 0xf9fa2e2e, 0xf9f9d1d2,
        0x0c0c0000, 0x0c0c0202, 0x0c0bfdfe, 0x0c0c0606, 0x0c0bf9fa, 0x0c0c0c0c, 0x0c0bf3f4, 0x0c0c1414,
        0x0c0bebec, 0x0c0c2020, 0x0c0bdfe0, 0x0c0c2e2e, 0x0c0bd1d2, 0xf3f40000, 0xf3f40202, 0xf3f3fdfe,
        0xf3f40606, 0xf3f3f9fa, 0xf3f40c0c, 0xf3f3f3f4, 0xf3f41414, 0xf3f3ebec, 0xf3f42020, 0xf3f3dfe0,
        0xf3f42e2e, 0xf3f3d1d2, 0x14140000, 0x14140202, 0x1413fdfe, 0x14140606, 0x1413f9fa, 0x14140c0c,
        0x1413f3f4, 0x14141414, 0x1413ebec, 0x14142020, 0x1413dfe0, 0x14142e2e, 0x1413d1d2, 0xebec0000,
        0xebec0202, 0xebebfdfe, 0xebec0606, 0xebebf9fa, 0xebec0c0c, 0xebebf3f4, 0xebec1414, 0xebebebec,
        0xebec2020, 0xebebdfe0, 0xebec2e2e, 0xebebd1d2, 0x20200000, 0x20200202, 0x201ffdfe, 0x20200606,
        0x201ff9fa, 0x20200c0c, 0x201ff3f4, 0x20201414, 0x201febec, 0x20202020, 0x201fdfe0, 0x20202e2e,
        0x201fd1d2, 0xdfe00000, 0xdfe00202, 0xdfdffdfe, 0xdfe00606, 0xdfdff9fa, 0xdfe00c0c, 0xdfdff3f4,
        0xdfe01414, 0xdfdfebec, 0xdfe02020, 0xdfdfdfe0, 0xdfe02e2e, 0xdfdfd1d2, 0x2e2e0000, 0x2e2e0202,
        0x2e2dfdfe, 0x2e2e0606, 0x2e2df9fa, 0x2e2e0c0c, 0x2e2df3f4, 0x2e2e1414, 0x2e2debec, 0x2e2e2020,
        0x2e2ddfe0, 0x2e2e2e2e, 0x2e2dd1d2, 0xd1d20000, 0xd1d20202, 0xd1d1fdfe, 0xd1d20606, 0xd1d1f9fa,
        0xd1d20c0c, 0xd1d1f3f4, 0xd1d21414, 0xd1d1ebec, 0xd1d22020, 0xd1d1dfe0, 0xd1d22e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414,
        0xffffebec, 0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414, 0xffffebec,
        0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x02020000, 0x02020202, 0x0201fdfe, 0x02020606,
        0x0201f9fa, 0x02020c0c, 0x0201f3f4, 0x02021414, 0x0201ebec, 0x02022020, 0x0201dfe0, 0x02022e2e,
        0x0201d1d2, 0xfdfe0000, 0xfdfe0202, 0xfdfdfdfe, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0c0c, 0xfdfdf3f4,
        0xfdfe1414, 0xfdfdebec, 0xfdfe2020, 0xfdfddfe0, 0xfdfe2e2e, 0xfdfdd1d2, 0x06060000, 0x06060202,
        0x0605fdfe, 0x06060606, 0x0605f9fa, 0x06060c0c, 0x0605f3f4, 0x06061414, 0x0605ebec, 0x06062020,
        0x0605dfe0, 0x06062e2e, 0x0605d1d2, 0xf9fa0000, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0606, 0xf9f9f9fa,
        0xf9fa0c0c, 0xf9f9f3f4, 0xf9fa1414, 0xf9f9ebec, 0xf9fa2020, 0xf9f9dfe0, 0xf9fa2e2e, 0xf9f9d1d2,
        0x0c0c0000, 0x0c0c0202, 0x0c0bfdfe, 0x0c0c0606, 0x0c0bf9fa, 0x0c0c0c0c, 0x0c0bf3f4, 0x0c0c1414,
        0x0c0bebec, 0x0c0c2020, 0x0c0bdfe0, 0x0c0c2e2e, 0x0c0bd1d2, 0xf3f40000, 0xf3f40202, 0xf3f3fdfe,
        0xf3f40606, 0xf3f3f9fa, 0xf3f40c0c, 0xf3f3f3f4, 0xf3f41414, 0xf3f3ebec, 0xf3f42020, 0xf3f3dfe0,
        0xf3f42e2e, 0xf3f3d1d2, 0x14140000, 0x14140202, 0x1413fdfe, 0x14140606, 0x1413f9fa, 0x14140c0c,
        0x1413f3f4, 0x14141414, 0x1413ebec, 0x14142020, 0x1413dfe0, 0x14142e2e, 0x1413d1d2, 0xebec0000,
        0xebec0202, 0xebebfdfe, 0xebec0606, 0xebebf9fa, 0xebec0c0c, 0xebebf3f4, 0xebec1414, 0xebebebec,
        0xebec2020, 0xebebdfe0, 0xebec2e2e, 0xebebd1d2, 0x20200000, 0x20200202, 0x201ffdfe, 0x20200606,
        0x201ff9fa, 0x20200c0c, 0x201ff3f4, 0x20201414, 0x201febec, 0x20202020, 0x201fdfe0, 0x20202e2e,
        0x201fd1d2, 0xdfe00000, 0xdfe00202, 0xdfdffdfe, 0xdfe00606, 0xdfdff9fa, 0xdfe00c0c, 0xdfdff3f4,
        0xdfe01414, 0xdfdfebec, 0xdfe02020, 0xdfdfdfe0, 0xdfe02e2e, 0xdfdfd1d2, 0x2e2e0000, 0x2e2e0202,
        0x2e2dfdfe, 0x2e2e0606, 0x2e2df9fa, 0x2e2e0c0c, 0x2e2df3f4, 0x2e2e1414, 0x2e2debec, 0x2e2e2020,
        0x2e2ddfe0, 0x2e2e2e2e, 0x2e2dd1d2, 0xd1d20000, 0xd1d20202, 0xd1d1fdfe, 0xd1d20606, 0xd1d1f9fa,
        0xd1d20c0c, 0xd1d1f3f4, 0xd1d21414, 0xd1d1ebec, 0xd1d22020, 0xd1d1dfe0, 0xd1d22e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414,
        0xffffebec, 0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414, 0xffffebec,
        0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x02020000, 0x02020202, 0x0201fdfe, 0x02020606,
        0x0201f9fa, 0x02020c0c, 0x0201f3f4, 0x02021414, 0x0201ebec, 0x02022020, 0x0201dfe0, 0x02022e2e,
        0x0201d1d2, 0xfdfe0000, 0xfdfe0202, 0xfdfdfdfe, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0c0c, 0xfdfdf3f4,
        0xfdfe1414, 0xfdfdebec, 0xfdfe2020, 0xfdfddfe0, 0xfdfe2e2e, 0xfdfdd1d2, 0x06060000, 0x06060202,
        0x0605fdfe, 0x06060606, 0x0605f9fa, 0x06060c0c, 0x0605f3f4, 0x06061414, 0x0605ebec, 0x06062020,
        0x0605dfe0, 0x06062e2e, 0x0605d1d2, 0xf9fa0000, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0606, 0xf9f9f9fa,
        0xf9fa0c0c, 0xf9f9f3f4, 0xf9fa1414, 0xf9f9ebec, 0xf9fa2020, 0xf9f9dfe0, 0xf9fa2e2e, 0xf9f9d1d2,
        0x0c0c0000, 0x0c0c0202, 0x0c0bfdfe, 0x0c0c0606, 0x0c0bf9fa, 0x0c0c0c0c, 0x0c0bf3f4, 0x0c0c1414,
        0x0c0bebec, 0x0c0c2020, 0x0c0bdfe0, 0x0c0c2e2e, 0x0c0bd1d2, 0xf3f40000, 0xf3f40202, 0xf3f3fdfe,
        0xf3f40606, 0xf3f3f9fa, 0xf3f40c0c, 0xf3f3f3f4, 0xf3f41414, 0xf3f3ebec, 0xf3f42020, 0xf3f3dfe0,
        0xf3f42e2e, 0xf3f3d1d2, 0x14140000, 0x14140202, 0x1413fdfe, 0x14140606, 0x1413f9fa, 0x14140c0c,
        0x1413f3f4, 0x14141414, 0x1413ebec, 0x14142020, 0x1413dfe0, 0x14142e2e, 0x1413d1d2, 0xebec0000,
        0xebec0202, 0xebebfdfe, 0xebec0606, 0xebebf9fa, 0xebec0c0c, 0xebebf3f4, 0xebec1414, 0xebebebec,
        0xebec2020, 0xebebdfe0, 0xebec2e2e, 0xebebd1d2, 0x20200000, 0x20200202, 0x201ffdfe, 0x20200606,
        0x201ff9fa, 0x20200c0c, 0x201ff3f4, 0x20201414, 0x201febec, 0x20202020, 0x201fdfe0, 0x20202e2e,
        0x201fd1d2, 0xdfe00000, 0xdfe00202, 0xdfdffdfe, 0xdfe00606, 0xdfdff9fa, 0xdfe00c0c, 0xdfdff3f4,
        0xdfe01414, 0xdfdfebec, 0xdfe02020, 0xdfdfdfe0, 0xdfe02e2e, 0xdfdfd1d2, 0x2e2e0000, 0x2e2e0202,
        0x2e2dfdfe, 0x2e2e0606, 0x2e2df9fa, 0x2e2e0c0c, 0x2e2df3f4, 0x2e2e1414, 0x2e2debec, 0x2e2e2020,
        0x2e2ddfe0, 0x2e2e2e2e, 0x2e2dd1d2, 0xd1d20000, 0xd1d20202, 0xd1d1fdfe, 0xd1d20606, 0xd1d1f9fa,
        0xd1d20c0c, 0xd1d1f3f4, 0xd1d21414, 0xd1d1ebec, 0xd1d22020, 0xd1d1dfe0, 0xd1d22e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414,
        0xffffebec, 0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000202, 0xfffffdfe, 0x00000606, 0xfffff9fa, 0x00000c0c, 0xfffff3f4, 0x00001414, 0xffffebec,
        0x00002020, 0xffffdfe0, 0x00002e2e, 0xffffd1d2, 0x02020000, 0x02020202, 0x0201fdfe, 0x02020606,
        0x0201f9fa, 0x02020c0c, 0x0201f3f4, 0x02021414, 0x0201ebec, 0x02022020, 0x0201dfe0, 0x02022e2e,
        0x0201d1d2, 0xfdfe0000, 0xfdfe0202, 0xfdfdfdfe, 0xfdfe0606, 0xfdfdf9fa, 0xfdfe0c0c, 0xfdfdf3f4,
        0xfdfe1414, 0xfdfdebec, 0xfdfe2020, 0xfdfddfe0, 0xfdfe2e2e, 0xfdfdd1d2, 0x06060000, 0x06060202,
        0x0605fdfe, 0x06060606, 0x0605f9fa, 0x06060c0c, 0x0605f3f4, 0x06061414, 0x0605ebec, 0x06062020,
        0x0605dfe0, 0x06062e2e, 0x0605d1d2, 0xf9fa0000, 0xf9fa0202, 0xf9f9fdfe, 0xf9fa0606, 0xf9f9f9fa,
        0xf9fa0c0c, 0xf9f9f3f4, 0xf9fa1414, 0xf9f9ebec, 0xf9fa2020, 0xf9f9dfe0, 0xf9fa2e2e, 0xf9f9d1d2,
        0x0c0c0000, 0x0c0c0202, 0x0c0bfdfe, 0x0c0c0606, 0x0c0bf9fa, 0x0c0c0c0c, 0x0c0bf3f4, 0x0c0c1414,
        0x0c0bebec, 0x0c0c2020, 0x0c0bdfe0, 0x0c0c2e2e, 0x0c0bd1d2, 0xf3f40000, 0xf3f40202, 0xf3f3fdfe,
        0xf3f40606, 0xf3f3f9fa, 0xf3f40c0c, 0xf3f3f3f4, 0xf3f41414, 0xf3f3ebec, 0xf3f42020, 0xf3f3dfe0,
        0xf3f42e2e, 0xf3f3d1d2, 0x14140000, 0x14140202, 0x1413fdfe, 0x14140606, 0x1413f9fa, 0x14140c0c,
        0x1413f3f4, 0x14141414, 0x1413ebec, 0x14142020, 0x1413dfe0, 0x14142e2e, 0x1413d1d2, 0xebec0000,
        0xebec0202, 0xebebfdfe, 0xebec0606, 0xebebf9fa, 0xebec0c0c, 0xebebf3f4, 0xebec1414, 0xebebebec,
        0xebec2020, 0xebebdfe0, 0xebec2e2e, 0xebebd1d2, 0x20200000, 0x20200202, 0x201ffdfe, 0x20200606,
        0x201ff9fa, 0x20200c0c, 0x201ff3f4, 0x20201414, 0x201febec, 0x20202020, 0x201fdfe0, 0x20202e2e,
        0x201fd1d2, 0xdfe00000, 0xdfe00202, 0xdfdffdfe, 0xdfe00606, 0xdfdff9fa, 0xdfe00c0c, 0xdfdff3f4,
        0xdfe01414, 0xdfdfebec, 0xdfe02020, 0xdfdfdfe0, 0xdfe02e2e, 0xdfdfd1d2, 0x2e2e0000, 0x2e2e0202,
        0x2e2dfdfe, 0x2e2e0606, 0x2e2df9fa, 0x2e2e0c0c, 0x2e2df3f4, 0x2e2e1414, 0x2e2debec, 0x2e2e2020,
        0x2e2ddfe0, 0x2e2e2e2e, 0x2e2dd1d2, 0xd1d20000, 0xd1d20202, 0xd1d1fdfe, 0xd1d20606, 0xd1d1f9fa,
        0xd1d20c0c, 0xd1d1f3f4, 0xd1d21414, 0xd1d1ebec, 0xd1d22020, 0xd1d1dfe0, 0xd1d22e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000

################################################################################

TITLE
    libavcodec indeo3 correctionloworder

TYPE
    32

DATA
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd, 0x04040404,
        0xfbfbfbfc, 0x05050101, 0xfafafeff, 0x01010505, 0xfefefafb, 0x0403fbfc, 0xfbfc0404, 0x0605fdfe,
        0xf9fa0202, 0xfdfe0606, 0x0201f9fa, 0x09090404, 0xf6f6fbfc, 0x04040909, 0xfbfbf6f7, 0x09090909,
        0xf6f6f6f7, 0x0a0a0101, 0xf5f5feff, 0x01010a0a, 0xfefef5f6, 0x0807fafb, 0xf7f80505, 0xfafb0808,
        0x0504f7f8, 0x0f0f0909, 0xf0f0f6f7, 0x09090f0f, 0xf6f6f0f1, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c,
        0x0302f3f4, 0x10100404, 0xefeffbfc, 0x04041010, 0xfbfbeff0, 0x10101010, 0xefefeff0, 0x12120000,
        0xedee0000, 0x00001212, 0xffffedee, 0x0c0bf3f4, 0xf3f40c0c, 0x100ff6f7, 0xeff00909, 0xf6f71010,
        0x0908eff0, 0x1b1b0b0b, 0xe4e4f4f5, 0x0b0b1b1b, 0xf4f4e4e5, 0x1c1c1313, 0xe3e3eced, 0x13131c1c,
        0xecece3e4, 0x1615f9fa, 0xe9ea0606, 0xf9fa1616, 0x0605e9ea, 0x1d1d0404, 0xe2e2fbfc, 0x04041d1d,
        0xfbfbe2e3, 0x1e1e1e1e, 0xe1e1e1e2, 0x2120fdfe, 0xdedf0202, 0xfdfe2121, 0x0201dedf, 0x1716edee,
        0xe8e91212, 0xedee1717, 0x1211e8e9, 0x1e1df0f1, 0xe1e20f0f, 0xf0f11e1e, 0x0f0ee1e2, 0x2e2e1616,
        0xd1d1e9ea, 0x16162e2e, 0xe9e9d1d2, 0x2f2f0d0d, 0xd0d0f2f3, 0x0d0d2f2f, 0xf2f2d0d1, 0x31312323,
        0xcecedcdd, 0x23233131, 0xdcdccecf, 0x2928f4f5, 0xd6d70b0b, 0xf4f52929, 0x0b0ad6d7, 0x33330404,
        0xccccfbfc, 0x04043333, 0xfbfbcccd, 0x36363636, 0xc9c9c9ca, 0x2221ddde, 0xddde2222, 0x2a29e2e3,
        0xd5d61d1d, 0xe2e32a2a, 0x1d1cd5d6, 0x3c3bf9fa, 0xc3c40606, 0xf9fa3c3c, 0x0605c3c4, 0x4c4c1b1b,
        0xb3b3e4e5, 0x1b1b4c4c, 0xe4e4b3b4, 0x4d4d2b2b, 0xb2b2d4d5, 0x2b2b4d4d, 0xd4d4b2b3, 0x3736e7e8,
        0xc8c91818, 0xe7e83737, 0x1817c8c9, 0x4f4f0e0e, 0xb0b0f1f2, 0x0e0e4f4f, 0xf1f1b0b1, 0x53533f3f,
        0xacacc0c1, 0x3f3f5353, 0xc0c0acad, 0x4a49ebec, 0xb5b61414, 0xebec4a4a, 0x1413b5b6, 0x58580202,
        0xa7a7fdfe, 0x02025858, 0xfdfda7a8, 0x5d5d5d5d, 0xa2a2a2a3, 0x3d3ccbcc, 0xc2c33434, 0xcbcc3d3d,
        0x3433c2c3, 0x78783434, 0x8787cbcc, 0x34347878, 0xcbcb8788, 0x4b4ad2d3, 0xb4b52d2d, 0xd2d34b4b,
        0x2d2cb4b5, 0x7d7d4b4b, 0x8282b4b5, 0x4b4b7d7d, 0xb4b48283, 0x7a7a2121, 0x8585dedf, 0x21217a7a,
        0xdede8586, 0x6766f2f3, 0x98990d0d, 0xf2f36767, 0x0d0c9899, 0x605fd7d8, 0x9fa02828, 0xd7d86060,
        0x28279fa0, 0x7f7eddde, 0x80812222, 0xddde7f7f, 0x22218081, 0x5958a6a7, 0xa6a75959, 0x6968b1b2,
        0x96974e4e, 0xb1b26969, 0x4e4d9697, 0x0c0c0c0c, 0xf3f3f3f4, 0x17171717, 0xe8e8e8e9, 0x2a2a2a2a,
        0xd5d5d5d6, 0x49494949, 0xb6b6b6b7, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0x0302feff, 0x0302feff, 0x0302feff, 0x0302feff, 0x0302feff, 0x0302feff, 0x0302feff, 0xfcfd0101,
        0xfcfd0101, 0xfcfd0101, 0xfcfd0101, 0xfcfd0101, 0xfcfd0101, 0xfcfd0101, 0xfeff0303, 0xfeff0303,
        0xfeff0303, 0xfeff0303, 0xfeff0303, 0xfeff0303, 0xfeff0303, 0x0100fcfd, 0x0100fcfd, 0x0100fcfd,
        0x0100fcfd, 0x0100fcfd, 0x0100fcfd, 0x0100fcfd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707,
        0xf8f8f8f9, 0x08080202, 0xf7f7fdfe, 0x02020808, 0xfdfdf7f8, 0x0908fdfe, 0xf6f70202, 0xfdfe0909,
        0x0201f6f7, 0x0605f9fa, 0xf9fa0606, 0x0d0d0606, 0xf2f2f9fa, 0x06060d0d, 0xf9f9f2f3, 0x0d0d0d0d,
        0xf2f2f2f3, 0x0e0e0101, 0xf1f1feff, 0x01010e0e, 0xfefef1f2, 0x0c0bf7f8, 0xf3f40808, 0xf7f80c0c,
        0x0807f3f4, 0x17170e0e, 0xe8e8f1f2, 0x0e0e1717, 0xf1f1e8e9, 0x1211fafb, 0xedee0505, 0xfafb1212,
        0x0504edee, 0x18180606, 0xe7e7f9fa, 0x06061818, 0xf9f9e7e8, 0x18181818, 0xe7e7e7e8, 0x1b1afeff,
        0xe4e50101, 0xfeff1b1b, 0x0100e4e5, 0x1110eeef, 0xeeef1111, 0x1716f2f3, 0xe8e90d0d, 0xf2f31717,
        0x0d0ce8e9, 0x28281010, 0xd7d7eff0, 0x10102828, 0xefefd7d8, 0x29291c1c, 0xd6d6e3e4, 0x1c1c2929,
        0xe3e3d6d7, 0x2120f6f7, 0xdedf0909, 0xf6f72121, 0x0908dedf, 0x2b2b0606, 0xd4d4f9fa, 0x06062b2b,
        0xf9f9d4d5, 0x2e2e2e2e, 0xd1d1d1d2, 0x3231fbfc, 0xcdce0404, 0xfbfc3232, 0x0403cdce, 0x2221e4e5,
        0xddde1b1b, 0xe4e52222, 0x1b1addde, 0x2d2ce9ea, 0xd2d31616, 0xe9ea2d2d, 0x1615d2d3, 0x45452222,
        0xbabaddde, 0x22224545, 0xddddbabb, 0x46461313, 0xb9b9eced, 0x13134646, 0xececb9ba, 0x49493535,
        0xb6b6cacb, 0x35354949, 0xcacab6b7, 0x3e3deeef, 0xc1c21111, 0xeeef3e3e, 0x1110c1c2, 0x4d4d0505,
        0xb2b2fafb, 0x05054d4d, 0xfafab2b3, 0x52525252, 0xadadadae, 0x3332cccd, 0xcccd3333, 0x403fd4d5,
        0xbfc02b2b, 0xd4d54040, 0x2b2abfc0, 0x5a59f5f6, 0xa5a60a0a, 0xf5f65a5a, 0x0a09a5a6, 0x72722929,
        0x8d8dd6d7, 0x29297272, 0xd6d68d8e, 0x74744040, 0x8b8bbfc0, 0x40407474, 0xbfbf8b8c, 0x5251dadb,
        0xadae2525, 0xdadb5252, 0x2524adae, 0x77771616, 0x8888e9ea, 0x16167777, 0xe9e98889, 0x7c7c5f5f,
        0x8383a0a1, 0x5f5f7c7c, 0xa0a08384, 0x6f6ee1e2, 0x90911e1e, 0xe1e26f6f, 0x1e1d9091, 0x5c5bb1b2,
        0xa3a44e4e, 0xb1b25c5c, 0x4e4da3a4, 0x7170bbbc, 0x8e8f4444, 0xbbbc7171, 0x44438e8f, 0x12121212,
        0xedededee, 0x22222222, 0xddddddde, 0x3f3f3f3f, 0xc0c0c0c1, 0x6d6d6d6d, 0x92929293, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303,
        0x03030303, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd,
        0xfcfcfcfd, 0xfcfcfcfd, 0x0403feff, 0x0403feff, 0x0403feff, 0x0403feff, 0x0403feff, 0x0403feff,
        0x0403feff, 0x0403feff, 0x0403feff, 0xfbfc0101, 0xfbfc0101, 0xfbfc0101, 0xfbfc0101, 0xfbfc0101,
        0xfbfc0101, 0xfbfc0101, 0xfbfc0101, 0xfbfc0101, 0xfeff0404, 0xfeff0404, 0xfeff0404, 0xfeff0404,
        0xfeff0404, 0xfeff0404, 0xfeff0404, 0xfeff0404, 0xfeff0404, 0x0100fbfc, 0x0100fbfc, 0x0100fbfc,
        0x0100fbfc, 0x0100fbfc, 0x0100fbfc, 0x0100fbfc, 0x0100fbfc, 0x0100fbfc, 0x07070707, 0x07070707,
        0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0xf8f8f8f9,
        0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303,
        0xf5f5fcfd, 0x03030a0a, 0xfcfcf5f6, 0x09090909, 0xf6f6f6f7, 0x0706f8f9, 0xf8f90707, 0x0c0bfcfd,
        0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x11110808, 0xeeeef7f8, 0x08081111, 0xf7f7eeef, 0x11111111,
        0xeeeeeeef, 0x13130101, 0xececfeff, 0x01011313, 0xfefeeced, 0x100ff4f5, 0xeff00b0b, 0xf4f51010,
        0x0b0aeff0, 0x1716f9fa, 0xe8e90606, 0xf9fa1717, 0x0605e8e9, 0x1f1f1212, 0xe0e0edee, 0x12121f1f,
        0xedede0e1, 0x20200808, 0xdfdff7f8, 0x08082020, 0xf7f7dfe0, 0x21212121, 0xdedededf, 0x2423feff,
        0xdbdc0101, 0xfeff2424, 0x0100dbdc, 0x1716e8e9, 0xe8e91717, 0x1f1eeeef, 0xe0e11111, 0xeeef1f1f,
        0x1110e0e1, 0x36361515, 0xc9c9eaeb, 0x15153636, 0xeaeac9ca, 0x37372525, 0xc8c8dadb, 0x25253737,
        0xdadac8c9, 0x2c2bf3f4, 0xd3d40c0c, 0xf3f42c2c, 0x0c0bd3d4, 0x39390808, 0xc6c6f7f8, 0x08083939,
        0xf7f7c6c7, 0x3d3d3d3d, 0xc2c2c2c3, 0x4241fafb, 0xbdbe0505, 0xfafb4242, 0x0504bdbe, 0x2d2cdbdc,
        0xd2d32424, 0xdbdc2d2d, 0x2423d2d3, 0x3c3be2e3, 0xc3c41d1d, 0xe2e33c3c, 0x1d1cc3c4, 0x5c5c2d2d,
        0xa3a3d2d3, 0x2d2d5c5c, 0xd2d2a3a4, 0x5d5d1919, 0xa2a2e6e7, 0x19195d5d, 0xe6e6a2a3, 0x61614747,
        0x9e9eb8b9, 0x47476161, 0xb8b89e9f, 0x5352e9ea, 0xacad1616, 0xe9ea5353, 0x1615acad, 0x66660707,
        0x9999f8f9, 0x07076666, 0xf8f8999a, 0x6d6d6d6d, 0x92929293, 0x4443bbbc, 0xbbbc4444, 0x5554c6c7,
        0xaaab3939, 0xc6c75555, 0x3938aaab, 0x7877f2f3, 0x87880d0d, 0xf2f37878, 0x0d0c8788, 0x6e6dcecf,
        0x91923131, 0xcecf6e6e, 0x31309192, 0x7b7a9798, 0x84856868, 0x97987b7b, 0x68678485, 0x18181818,
        0xe7e7e7e8, 0x2e2e2e2e, 0xd1d1d1d2, 0x54545454, 0xabababac, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x04040404,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404,
        0x04040404, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0x0504feff, 0x0504feff, 0x0504feff, 0x0504feff, 0x0504feff,
        0x0504feff, 0x0504feff, 0x0504feff, 0x0504feff, 0x0504feff, 0xfafb0101, 0xfafb0101, 0xfafb0101,
        0xfafb0101, 0xfafb0101, 0xfafb0101, 0xfafb0101, 0xfafb0101, 0xfafb0101, 0xfafb0101, 0xfeff0505,
        0xfeff0505, 0xfeff0505, 0xfeff0505, 0xfeff0505, 0xfeff0505, 0xfeff0505, 0xfeff0505, 0xfeff0505,
        0xfeff0505, 0x0100fafb, 0x0100fafb, 0x0100fafb, 0x0100fafb, 0x0100fafb, 0x0100fafb, 0x0100fafb,
        0x0100fafb, 0x0100fafb, 0x0100fafb, 0x0a0a0303, 0x0a0a0303, 0x0a0a0303, 0x0a0a0303, 0x0a0a0303,
        0x0a0a0303, 0x0a0a0303, 0x0a0a0303, 0x0a0a0303, 0x0a0a0303, 0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd,
        0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd, 0xf5f5fcfd, 0x03030a0a,
        0x03030a0a, 0x03030a0a, 0x03030a0a, 0x03030a0a, 0x03030a0a, 0x03030a0a, 0x03030a0a, 0x03030a0a,
        0x03030a0a, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b,
        0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x03030d0d, 0xfcfcf2f3, 0x0908f6f7, 0xf6f70909, 0x0f0efbfc,
        0xf0f10404, 0xfbfc0f0f, 0x0403f0f1, 0x16160b0b, 0xe9e9f4f5, 0x0b0b1616, 0xf4f4e9ea, 0x15151515,
        0xeaeaeaeb, 0x18180202, 0xe7e7fdfe, 0x02021818, 0xfdfde7e8, 0x1413f1f2, 0xebec0e0e, 0xf1f21414,
        0x0e0debec, 0x26261717, 0xd9d9e8e9, 0x17172626, 0xe8e8d9da, 0x1d1cf7f8, 0xe2e30808, 0xf7f81d1d,
        0x0807e2e3, 0x27270b0b, 0xd8d8f4f5, 0x0b0b2727, 0xf4f4d8d9, 0x29292929, 0xd6d6d6d7, 0x2d2cfeff,
        0xd2d30101, 0xfeff2d2d, 0x0100d2d3, 0x1d1ce2e3, 0xe2e31d1d, 0x2726e9ea, 0xd8d91616, 0xe9ea2727,
        0x1615d8d9, 0x43431b1b, 0xbcbce4e5, 0x1b1b4343, 0xe4e4bcbd, 0x45452f2f, 0xbabad0d1, 0x2f2f4545,
        0xd0d0babb, 0x3837f0f1, 0xc7c80f0f, 0xf0f13838, 0x0f0ec7c8, 0x47470b0b, 0xb8b8f4f5, 0x0b0b4747,
        0xf4f4b8b9, 0x4c4c4c4c, 0xb3b3b3b4, 0x5352f9fa, 0xacad0606, 0xf9fa5353, 0x0605acad, 0x3938d2d3,
        0xc6c72d2d, 0xd2d33939, 0x2d2cc6c7, 0x4b4adbdc, 0xb4b52424, 0xdbdc4b4b, 0x2423b4b5, 0x73733838,
        0x8c8cc7c8, 0x38387373, 0xc7c78c8d, 0x75751f1f, 0x8a8ae0e1, 0x1f1f7575, 0xe0e08a8b, 0x7a7a5858,
        0x8585a7a8, 0x58587a7a, 0xa7a78586, 0x6867e3e4, 0x97981c1c, 0xe3e46868, 0x1c1b9798, 0x5554aaab,
        0xaaab5555, 0x6a69b7b8, 0x95964848, 0xb7b86a6a, 0x48479596, 0x1e1e1e1e, 0xe1e1e1e2, 0x3a3a3a3a,
        0xc5c5c5c6, 0x69696969, 0x96969697, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x05050505, 0x05050505,
        0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505,
        0x05050505, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb,
        0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe,
        0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0x0706fdfe, 0xf8f90202,
        0xf8f90202, 0xf8f90202, 0xf8f90202, 0xf8f90202, 0xf8f90202, 0xf8f90202, 0xf8f90202, 0xf8f90202,
        0xf8f90202, 0xf8f90202, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707,
        0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0xfdfe0707, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9,
        0x0201f8f9, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9, 0x0201f8f9,
        0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b,
        0x0b0b0b0b, 0x0b0b0b0b, 0x0b0b0b0b, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5,
        0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0xf4f4f4f5, 0x0d0d0303, 0x0d0d0303,
        0x0d0d0303, 0x0d0d0303, 0x0d0d0303, 0x0d0d0303, 0x0d0d0303, 0x0d0d0303, 0x0d0d0303, 0x0d0d0303,
        0x0d0d0303, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd,
        0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0xf2f2fcfd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d,
        0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0xfbfbf0f1, 0x0b0af4f5, 0xf4f50b0b, 0x1211fafb,
        0xedee0505, 0xfafb1212, 0x0504edee, 0x1a1a0d0d, 0xe5e5f2f3, 0x0d0d1a1a, 0xf2f2e5e6, 0x1a1a1a1a,
        0xe5e5e5e6, 0x1d1d0202, 0xe2e2fdfe, 0x02021d1d, 0xfdfde2e3, 0x1817eff0, 0xe7e81010, 0xeff01818,
        0x100fe7e8, 0x2e2e1c1c, 0xd1d1e3e4, 0x1c1c2e2e, 0xe3e3d1d2, 0x2322f6f7, 0xdcdd0909, 0xf6f72323,
        0x0908dcdd, 0x2f2f0d0d, 0xd0d0f2f3, 0x0d0d2f2f, 0xf2f2d0d1, 0x31313131, 0xcecececf, 0x3635feff,
        0xc9ca0101, 0xfeff3636, 0x0100c9ca, 0x2322dcdd, 0xdcdd2323, 0x2f2ee5e6, 0xd0d11a1a, 0xe5e62f2f,
        0x1a19d0d1, 0x51512020, 0xaeaedfe0, 0x20205151, 0xdfdfaeaf, 0x53533838, 0xacacc7c8, 0x38385353,
        0xc7c7acad, 0x4342edee, 0xbcbd1212, 0xedee4343, 0x1211bcbd, 0x56560d0d, 0xa9a9f2f3, 0x0d0d5656,
        0xf2f2a9aa, 0x5b5b5b5b, 0xa4a4a4a5, 0x6362f8f9, 0x9c9d0707, 0xf8f96363, 0x07069c9d, 0x4443c9ca,
        0xbbbc3636, 0xc9ca4444, 0x3635bbbc, 0x5a59d3d4, 0xa5a62c2c, 0xd3d45a5a, 0x2c2ba5a6, 0x7c7bdedf,
        0x83842121, 0xdedf7c7c, 0x21208384, 0x67669899, 0x98996767, 0x7f7ea9aa, 0x80815656, 0xa9aa7f7f,
        0x56558081, 0x25252525, 0xdadadadb, 0x45454545, 0xbabababb, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe,
        0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0x0807fdfe, 0xf7f80202, 0xf7f80202, 0xf7f80202,
        0xf7f80202, 0xf7f80202, 0xf7f80202, 0xf7f80202, 0xf7f80202, 0xf7f80202, 0xf7f80202, 0xf7f80202,
        0xf7f80202, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808,
        0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0xfdfe0808, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8,
        0x0201f7f8, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8, 0x0201f7f8,
        0x0201f7f8, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d,
        0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0x0d0d0d0d, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3,
        0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3, 0xf2f2f2f3,
        0xf2f2f2f3, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404,
        0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0x0f0f0404, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc,
        0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc, 0xf0f0fbfc,
        0xf0f0fbfc, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f,
        0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x04040f0f, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010,
        0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0xfafaedee, 0x0d0cf2f3, 0xf2f30d0d, 0x1514f9fa,
        0xeaeb0606, 0xf9fa1515, 0x0605eaeb, 0x1e1e0f0f, 0xe1e1f0f1, 0x0f0f1e1e, 0xf0f0e1e2, 0x1e1e1e1e,
        0xe1e1e1e2, 0x22220202, 0xddddfdfe, 0x02022222, 0xfdfdddde, 0x1c1beced, 0xe3e41313, 0xeced1c1c,
        0x1312e3e4, 0x36362020, 0xc9c9dfe0, 0x20203636, 0xdfdfc9ca, 0x2928f4f5, 0xd6d70b0b, 0xf4f52929,
        0x0b0ad6d7, 0x37370f0f, 0xc8c8f0f1, 0x0f0f3737, 0xf0f0c8c9, 0x39393939, 0xc6c6c6c7, 0x3f3efeff,
        0xc0c10101, 0xfeff3f3f, 0x0100c0c1, 0x2827d7d8, 0xd7d82828, 0x3736e1e2, 0xc8c91e1e, 0xe1e23737,
        0x1e1dc8c9, 0x5e5e2525, 0xa1a1dadb, 0x25255e5e, 0xdadaa1a2, 0x60604141, 0x9f9fbebf, 0x41416060,
        0xbebe9fa0, 0x4e4deaeb, 0xb1b21515, 0xeaeb4e4e, 0x1514b1b2, 0x64640f0f, 0x9b9bf0f1, 0x0f0f6464,
        0xf0f09b9c, 0x6a6a6a6a, 0x95959596, 0x7473f7f8, 0x8b8c0808, 0xf7f87474, 0x08078b8c, 0x4f4ec0c1,
        0xb0b13f3f, 0xc0c14f4f, 0x3f3eb0b1, 0x6968cccd, 0x96973333, 0xcccd6969, 0x33329697, 0x78778788,
        0x87887878, 0x2b2b2b2b, 0xd4d4d4d5, 0x50505050, 0xafafafb0, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707,
        0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9,
        0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9,
        0xf8f8f8f9, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd,
        0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0x0a09fcfd, 0xf5f60303, 0xf5f60303, 0xf5f60303,
        0xf5f60303, 0xf5f60303, 0xf5f60303, 0xf5f60303, 0xf5f60303, 0xf5f60303, 0xf5f60303, 0xf5f60303,
        0xf5f60303, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a,
        0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0xfcfd0a0a, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6,
        0x0302f5f6, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6, 0x0302f5f6,
        0x0302f5f6, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010,
        0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0xefefeff0, 0xefefeff0, 0xefefeff0,
        0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0,
        0xefefeff0, 0x12120505, 0x12120505, 0x12120505, 0x12120505, 0x12120505, 0x12120505, 0x12120505,
        0x12120505, 0x12120505, 0x12120505, 0x12120505, 0x12120505, 0xededfafb, 0xededfafb, 0xededfafb,
        0xededfafb, 0xededfafb, 0xededfafb, 0xededfafb, 0xededfafb, 0xededfafb, 0xededfafb, 0xededfafb,
        0xededfafb, 0x05051212, 0x05051212, 0x05051212, 0x05051212, 0x05051212, 0x05051212, 0x05051212,
        0x05051212, 0x05051212, 0x05051212, 0x05051212, 0x05051212, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212,
        0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0xfafaebec, 0x0f0ef0f1, 0xf0f10f0f, 0x1817f8f9,
        0xe7e80707, 0xf8f91818, 0x0706e7e8, 0x23231111, 0xdcdceeef, 0x11112323, 0xeeeedcdd, 0x22222222,
        0xddddddde, 0x26260303, 0xd9d9fcfd, 0x03032626, 0xfcfcd9da, 0x201fe9ea, 0xdfe01616, 0xe9ea2020,
        0x1615dfe0, 0x3d3d2525, 0xc2c2dadb, 0x25253d3d, 0xdadac2c3, 0x2f2ef2f3, 0xd0d10d0d, 0xf2f32f2f,
        0x0d0cd0d1, 0x3f3f1111, 0xc0c0eeef, 0x11113f3f, 0xeeeec0c1, 0x41414141, 0xbebebebf, 0x4847feff,
        0xb7b80101, 0xfeff4848, 0x0100b7b8, 0x2e2dd1d2, 0xd1d22e2e, 0x3f3edcdd, 0xc0c12323, 0xdcdd3f3f,
        0x2322c0c1, 0x6b6b2b2b, 0x9494d4d5, 0x2b2b6b6b, 0xd4d49495, 0x6e6e4b4b, 0x9191b4b5, 0x4b4b6e6e,
        0xb4b49192, 0x5958e7e8, 0xa6a71818, 0xe7e85959, 0x1817a6a7, 0x72721111, 0x8d8deeef, 0x11117272,
        0xeeee8d8e, 0x79797979, 0x86868687, 0x5b5ab7b8, 0xa4a54848, 0xb7b85b5b, 0x4847a4a5, 0x7877c5c6,
        0x87883a3a, 0xc5c67878, 0x3a398788, 0x31313131, 0xcecececf, 0x5c5c5c5c, 0xa3a3a3a4, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808,
        0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0xf7f7f7f8,
        0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8,
        0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd,
        0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0x0b0afcfd, 0xf4f50303,
        0xf4f50303, 0xf4f50303, 0xf4f50303, 0xf4f50303, 0xf4f50303, 0xf4f50303, 0xf4f50303, 0xf4f50303,
        0xf4f50303, 0xf4f50303, 0xf4f50303, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b,
        0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0xfcfd0b0b, 0x0302f4f5,
        0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x0302f4f5,
        0x0302f4f5, 0x0302f4f5, 0x0302f4f5, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212,
        0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0xedededee,
        0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee,
        0xedededee, 0xedededee, 0xedededee, 0x14140505, 0x14140505, 0x14140505, 0x14140505, 0x14140505,
        0x14140505, 0x14140505, 0x14140505, 0x14140505, 0x14140505, 0x14140505, 0x14140505, 0xebebfafb,
        0xebebfafb, 0xebebfafb, 0xebebfafb, 0xebebfafb, 0xebebfafb, 0xebebfafb, 0xebebfafb, 0xebebfafb,
        0xebebfafb, 0xebebfafb, 0xebebfafb, 0x05051414, 0x05051414, 0x05051414, 0x05051414, 0x05051414,
        0x05051414, 0x05051414, 0x05051414, 0x05051414, 0x05051414, 0x05051414, 0x05051414, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414,
        0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x1110eeef, 0xeeef1111, 0x1b1af8f9,
        0xe4e50707, 0xf8f91b1b, 0x0706e4e5, 0x27271313, 0xd8d8eced, 0x13132727, 0xececd8d9, 0x27272727,
        0xd8d8d8d9, 0x2b2b0303, 0xd4d4fcfd, 0x03032b2b, 0xfcfcd4d5, 0x2423e7e8, 0xdbdc1818, 0xe7e82424,
        0x1817dbdc, 0x45452a2a, 0xbabad5d6, 0x2a2a4545, 0xd5d5babb, 0x3534f1f2, 0xcacb0e0e, 0xf1f23535,
        0x0e0dcacb, 0x47471313, 0xb8b8eced, 0x13134747, 0xececb8b9, 0x49494949, 0xb6b6b6b7, 0x504ffdfe,
        0xafb00202, 0xfdfe5050, 0x0201afb0, 0x3433cbcc, 0xcbcc3434, 0x4645d8d9, 0xb9ba2727, 0xd8d94646,
        0x2726b9ba, 0x79793030, 0x8686cfd0, 0x30307979, 0xcfcf8687, 0x7c7c5454, 0x8383abac, 0x54547c7c,
        0xabab8384, 0x6463e4e5, 0x9b9c1b1b, 0xe4e56464, 0x1b1a9b9c, 0x6665aeaf, 0x999a5151, 0xaeaf6666,
        0x5150999a, 0x37373737, 0xc8c8c8c9, 0x68686868, 0x97979798, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909,
        0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0xf6f6f6f7,
        0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7,
        0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd,
        0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd, 0x0c0bfcfd,
        0x0c0bfcfd, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303,
        0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xf3f40303, 0xfcfd0c0c, 0xfcfd0c0c,
        0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c,
        0xfcfd0c0c, 0xfcfd0c0c, 0xfcfd0c0c, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4,
        0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4, 0x0302f3f4,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0x17170606, 0x17170606, 0x17170606, 0x17170606, 0x17170606, 0x17170606,
        0x17170606, 0x17170606, 0x17170606, 0x17170606, 0x17170606, 0x17170606, 0x17170606, 0xe8e8f9fa,
        0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa,
        0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0xe8e8f9fa, 0x06061717, 0x06061717, 0x06061717, 0x06061717,
        0x06061717, 0x06061717, 0x06061717, 0x06061717, 0x06061717, 0x06061717, 0x06061717, 0x06061717,
        0x06061717, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9,
        0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0xf9f9e8e9, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404,
        0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x0403fbfc, 0xfbfc0404, 0x0605fdfe,
        0xf9fa0202, 0xfdfe0606, 0x0201f9fa, 0x08080404, 0xf7f7fbfc, 0x04040808, 0xfbfbf7f8, 0x08080808,
        0xf7f7f7f8, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x0807fbfc, 0xf7f80404, 0xfbfc0808,
        0x0403f7f8, 0x0e0e0808, 0xf1f1f7f8, 0x08080e0e, 0xf7f7f1f2, 0x0c0bfdfe, 0xf3f40202, 0xfdfe0c0c,
        0x0201f3f4, 0x10100404, 0xefeffbfc, 0x04041010, 0xfbfbeff0, 0x10101010, 0xefefeff0, 0x12120000,
        0xedee0000, 0x00001212, 0xffffedee, 0x0c0bf3f4, 0xf3f40c0c, 0x100ff7f8, 0xeff00808, 0xf7f81010,
        0x0807eff0, 0x1a1a0a0a, 0xe5e5f5f6, 0x0a0a1a1a, 0xf5f5e5e6, 0x1c1c1212, 0xe3e3edee, 0x12121c1c,
        0xedede3e4, 0x1615f9fa, 0xe9ea0606, 0xf9fa1616, 0x0605e9ea, 0x1c1c0404, 0xe3e3fbfc, 0x04041c1c,
        0xfbfbe3e4, 0x1e1e1e1e, 0xe1e1e1e2, 0x201ffdfe, 0xdfe00202, 0xfdfe2020, 0x0201dfe0, 0x1615edee,
        0xe9ea1212, 0xedee1616, 0x1211e9ea, 0x1e1df1f2, 0xe1e20e0e, 0xf1f21e1e, 0x0e0de1e2, 0x2e2e1616,
        0xd1d1e9ea, 0x16162e2e, 0xe9e9d1d2, 0x2e2e0c0c, 0xd1d1f3f4, 0x0c0c2e2e, 0xf3f3d1d2, 0x30302222,
        0xcfcfddde, 0x22223030, 0xddddcfd0, 0x2827f5f6, 0xd7d80a0a, 0xf5f62828, 0x0a09d7d8, 0x32320404,
        0xcdcdfbfc, 0x04043232, 0xfbfbcdce, 0x36363636, 0xc9c9c9ca, 0x2221ddde, 0xddde2222, 0x2a29e3e4,
        0xd5d61c1c, 0xe3e42a2a, 0x1c1bd5d6, 0x3c3bf9fa, 0xc3c40606, 0xf9fa3c3c, 0x0605c3c4, 0x4c4c1a1a,
        0xb3b3e5e6, 0x1a1a4c4c, 0xe5e5b3b4, 0x4c4c2a2a, 0xb3b3d5d6, 0x2a2a4c4c, 0xd5d5b3b4, 0x3635e7e8,
        0xc9ca1818, 0xe7e83636, 0x1817c9ca, 0x4e4e0e0e, 0xb1b1f1f2, 0x0e0e4e4e, 0xf1f1b1b2, 0x52523e3e,
        0xadadc1c2, 0x3e3e5252, 0xc1c1adae, 0x4a49ebec, 0xb5b61414, 0xebec4a4a, 0x1413b5b6, 0x58580202,
        0xa7a7fdfe, 0x02025858, 0xfdfda7a8, 0x5c5c5c5c, 0xa3a3a3a4, 0x3c3bcbcc, 0xc3c43434, 0xcbcc3c3c,
        0x3433c3c4, 0x76763434, 0x8989cbcc, 0x34347676, 0xcbcb898a, 0x4a49d3d4, 0xb5b62c2c, 0xd3d44a4a,
        0x2c2bb5b6, 0x76764a4a, 0x8989b5b6, 0x4a4a7676, 0xb5b5898a, 0x76762020, 0x8989dfe0, 0x20207676,
        0xdfdf898a, 0x6665f3f4, 0x999a0c0c, 0xf3f46666, 0x0c0b999a, 0x605fd7d8, 0x9fa02828, 0xd7d86060,
        0x28279fa0, 0x7675ddde, 0x898a2222, 0xddde7676, 0x2221898a, 0x5857a7a8, 0xa7a85858, 0x6867b1b2,
        0x97984e4e, 0xb1b26868, 0x4e4d9798, 0x0c0c0c0c, 0xf3f3f3f4, 0x16161616, 0xe9e9e9ea, 0x2a2a2a2a,
        0xd5d5d5d6, 0x48484848, 0xb7b7b7b8, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0xfdfe0000,
        0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0x00000202, 0x00000202,
        0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe,
        0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606,
        0xf9f9f9fa, 0x09090303, 0xf6f6fcfd, 0x03030909, 0xfcfcf6f7, 0x0908fcfd, 0xf6f70303, 0xfcfd0909,
        0x0302f6f7, 0x0605f9fa, 0xf9fa0606, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0xf9f9f3f4, 0x0c0c0c0c,
        0xf3f3f3f4, 0x0f0f0000, 0xf0f10000, 0x00000f0f, 0xfffff0f1, 0x0c0bf6f7, 0xf3f40909, 0xf6f70c0c,
        0x0908f3f4, 0x18180f0f, 0xe7e7f0f1, 0x0f0f1818, 0xf0f0e7e8, 0x1211f9fa, 0xedee0606, 0xf9fa1212,
        0x0605edee, 0x18180606, 0xe7e7f9fa, 0x06061818, 0xf9f9e7e8, 0x18181818, 0xe7e7e7e8, 0x1b1b0000,
        0xe4e50000, 0x00001b1b, 0xffffe4e5, 0x1211edee, 0xedee1212, 0x1817f3f4, 0xe7e80c0c, 0xf3f41818,
        0x0c0be7e8, 0x27270f0f, 0xd8d8f0f1, 0x0f0f2727, 0xf0f0d8d9, 0x2a2a1b1b, 0xd5d5e4e5, 0x1b1b2a2a,
        0xe4e4d5d6, 0x2120f6f7, 0xdedf0909, 0xf6f72121, 0x0908dedf, 0x2a2a0606, 0xd5d5f9fa, 0x06062a2a,
        0xf9f9d5d6, 0x2d2d2d2d, 0xd2d2d2d3, 0x3332fcfd, 0xcccd0303, 0xfcfd3333, 0x0302cccd, 0x2120e4e5,
        0xdedf1b1b, 0xe4e52121, 0x1b1adedf, 0x2d2ceaeb, 0xd2d31515, 0xeaeb2d2d, 0x1514d2d3, 0x45452121,
        0xbabadedf, 0x21214545, 0xdedebabb, 0x45451212, 0xbabaedee, 0x12124545, 0xededbabb, 0x48483636,
        0xb7b7c9ca, 0x36364848, 0xc9c9b7b8, 0x3f3eedee, 0xc0c11212, 0xedee3f3f, 0x1211c0c1, 0x4e4e0606,
        0xb1b1f9fa, 0x06064e4e, 0xf9f9b1b2, 0x51515151, 0xaeaeaeaf, 0x3332cccd, 0xcccd3333, 0x3f3ed5d6,
        0xc0c12a2a, 0xd5d63f3f, 0x2a29c0c1, 0x5a59f6f7, 0xa5a60909, 0xf6f75a5a, 0x0908a5a6, 0x72722a2a,
        0x8d8dd5d6, 0x2a2a7272, 0xd5d58d8e, 0x75753f3f, 0x8a8ac0c1, 0x3f3f7575, 0xc0c08a8b, 0x5150dbdc,
        0xaeaf2424, 0xdbdc5151, 0x2423aeaf, 0x78781515, 0x8787eaeb, 0x15157878, 0xeaea8788, 0x7b7b6060,
        0x84849fa0, 0x60607b7b, 0x9f9f8485, 0x6f6ee1e2, 0x90911e1e, 0xe1e26f6f, 0x1e1d9091, 0x5d5cb1b2,
        0xa2a34e4e, 0xb1b25d5d, 0x4e4da2a3, 0x7271babb, 0x8d8e4545, 0xbabb7272, 0x45448d8e, 0x12121212,
        0xedededee, 0x21212121, 0xdedededf, 0x3f3f3f3f, 0xc0c0c0c1, 0x6c6c6c6c, 0x93939394, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303, 0x03030303,
        0x03030303, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd, 0xfcfcfcfd,
        0xfcfcfcfd, 0xfcfcfcfd, 0x03030000, 0x03030000, 0x03030000, 0x03030000, 0x03030000, 0x03030000,
        0x03030000, 0x03030000, 0x03030000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000,
        0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0x00000303, 0x00000303, 0x00000303, 0x00000303,
        0x00000303, 0x00000303, 0x00000303, 0x00000303, 0x00000303, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd,
        0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404,
        0xf7f7fbfc, 0x04040808, 0xfbfbf7f8, 0x08080808, 0xf7f7f7f8, 0x0807f7f8, 0xf7f80808, 0x0c0bfbfc,
        0xf3f40404, 0xfbfc0c0c, 0x0403f3f4, 0x10100808, 0xefeff7f8, 0x08081010, 0xf7f7eff0, 0x10101010,
        0xefefeff0, 0x14140000, 0xebec0000, 0x00001414, 0xffffebec, 0x100ff3f4, 0xeff00c0c, 0xf3f41010,
        0x0c0beff0, 0x1817fbfc, 0xe7e80404, 0xfbfc1818, 0x0403e7e8, 0x20201010, 0xdfdfeff0, 0x10102020,
        0xefefdfe0, 0x20200808, 0xdfdff7f8, 0x08082020, 0xf7f7dfe0, 0x20202020, 0xdfdfdfe0, 0x24240000,
        0xdbdc0000, 0x00002424, 0xffffdbdc, 0x1817e7e8, 0xe7e81818, 0x201feff0, 0xdfe01010, 0xeff02020,
        0x100fdfe0, 0x34341414, 0xcbcbebec, 0x14143434, 0xebebcbcc, 0x38382424, 0xc7c7dbdc, 0x24243838,
        0xdbdbc7c8, 0x2c2bf3f4, 0xd3d40c0c, 0xf3f42c2c, 0x0c0bd3d4, 0x38380808, 0xc7c7f7f8, 0x08083838,
        0xf7f7c7c8, 0x3c3c3c3c, 0xc3c3c3c4, 0x403ffbfc, 0xbfc00404, 0xfbfc4040, 0x0403bfc0, 0x2c2bdbdc,
        0xd3d42424, 0xdbdc2c2c, 0x2423d3d4, 0x3c3be3e4, 0xc3c41c1c, 0xe3e43c3c, 0x1c1bc3c4, 0x5c5c2c2c,
        0xa3a3d3d4, 0x2c2c5c5c, 0xd3d3a3a4, 0x5c5c1818, 0xa3a3e7e8, 0x18185c5c, 0xe7e7a3a4, 0x60604848,
        0x9f9fb7b8, 0x48486060, 0xb7b79fa0, 0x5453ebec, 0xabac1414, 0xebec5454, 0x1413abac, 0x64640808,
        0x9b9bf7f8, 0x08086464, 0xf7f79b9c, 0x6c6c6c6c, 0x93939394, 0x4443bbbc, 0xbbbc4444, 0x5453c7c8,
        0xabac3838, 0xc7c85454, 0x3837abac, 0x7877f3f4, 0x87880c0c, 0xf3f47878, 0x0c0b8788, 0x6c6bcfd0,
        0x93943030, 0xcfd06c6c, 0x302f9394, 0x7c7b9798, 0x83846868, 0x97987c7c, 0x68678384, 0x18181818,
        0xe7e7e7e8, 0x2c2c2c2c, 0xd3d3d3d4, 0x54545454, 0xabababac, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x04040404,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404,
        0x04040404, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000,
        0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000,
        0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0x00000404,
        0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404,
        0x00000404, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc,
        0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0x08080404, 0x08080404, 0x08080404, 0x08080404, 0x08080404,
        0x08080404, 0x08080404, 0x08080404, 0x08080404, 0x08080404, 0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc,
        0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc, 0xf7f7fbfc, 0x04040808,
        0x04040808, 0x04040808, 0x04040808, 0x04040808, 0x04040808, 0x04040808, 0x04040808, 0x04040808,
        0x04040808, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a,
        0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x05050f0f, 0xfafaf0f1, 0x0a09f5f6, 0xf5f60a0a, 0x0f0efafb,
        0xf0f10505, 0xfafb0f0f, 0x0504f0f1, 0x14140a0a, 0xebebf5f6, 0x0a0a1414, 0xf5f5ebec, 0x14141414,
        0xebebebec, 0x19190000, 0xe6e70000, 0x00001919, 0xffffe6e7, 0x1413f0f1, 0xebec0f0f, 0xf0f11414,
        0x0f0eebec, 0x28281919, 0xd7d7e6e7, 0x19192828, 0xe6e6d7d8, 0x1e1df5f6, 0xe1e20a0a, 0xf5f61e1e,
        0x0a09e1e2, 0x28280a0a, 0xd7d7f5f6, 0x0a0a2828, 0xf5f5d7d8, 0x28282828, 0xd7d7d7d8, 0x2d2d0000,
        0xd2d30000, 0x00002d2d, 0xffffd2d3, 0x1e1de1e2, 0xe1e21e1e, 0x2827ebec, 0xd7d81414, 0xebec2828,
        0x1413d7d8, 0x41411919, 0xbebee6e7, 0x19194141, 0xe6e6bebf, 0x46462d2d, 0xb9b9d2d3, 0x2d2d4646,
        0xd2d2b9ba, 0x3736f0f1, 0xc8c90f0f, 0xf0f13737, 0x0f0ec8c9, 0x46460a0a, 0xb9b9f5f6, 0x0a0a4646,
        0xf5f5b9ba, 0x4b4b4b4b, 0xb4b4b4b5, 0x5554fafb, 0xaaab0505, 0xfafb5555, 0x0504aaab, 0x3736d2d3,
        0xc8c92d2d, 0xd2d33737, 0x2d2cc8c9, 0x4b4adcdd, 0xb4b52323, 0xdcdd4b4b, 0x2322b4b5, 0x73733737,
        0x8c8cc8c9, 0x37377373, 0xc8c88c8d, 0x73731e1e, 0x8c8ce1e2, 0x1e1e7373, 0xe1e18c8d, 0x78785a5a,
        0x8787a5a6, 0x5a5a7878, 0xa5a58788, 0x6968e1e2, 0x96971e1e, 0xe1e26969, 0x1e1d9697, 0x5554aaab,
        0xaaab5555, 0x6968b9ba, 0x96974646, 0xb9ba6969, 0x46459697, 0x1e1e1e1e, 0xe1e1e1e2, 0x3c3c3c3c,
        0xc3c3c3c4, 0x69696969, 0x96969697, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x05050505, 0x05050505,
        0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505, 0x05050505,
        0x05050505, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb,
        0xfafafafb, 0xfafafafb, 0xfafafafb, 0xfafafafb, 0x05050000, 0x05050000, 0x05050000, 0x05050000,
        0x05050000, 0x05050000, 0x05050000, 0x05050000, 0x05050000, 0x05050000, 0x05050000, 0xfafb0000,
        0xfafb0000, 0xfafb0000, 0xfafb0000, 0xfafb0000, 0xfafb0000, 0xfafb0000, 0xfafb0000, 0xfafb0000,
        0xfafb0000, 0xfafb0000, 0x00000505, 0x00000505, 0x00000505, 0x00000505, 0x00000505, 0x00000505,
        0x00000505, 0x00000505, 0x00000505, 0x00000505, 0x00000505, 0xfffffafb, 0xfffffafb, 0xfffffafb,
        0xfffffafb, 0xfffffafb, 0xfffffafb, 0xfffffafb, 0xfffffafb, 0xfffffafb, 0xfffffafb, 0xfffffafb,
        0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,
        0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6,
        0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0x0f0f0505, 0x0f0f0505,
        0x0f0f0505, 0x0f0f0505, 0x0f0f0505, 0x0f0f0505, 0x0f0f0505, 0x0f0f0505, 0x0f0f0505, 0x0f0f0505,
        0x0f0f0505, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb,
        0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0xf0f0fafb, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c,
        0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0xf9f9f3f4, 0x0c0bf3f4, 0xf3f40c0c, 0x1211f9fa,
        0xedee0606, 0xf9fa1212, 0x0605edee, 0x18180c0c, 0xe7e7f3f4, 0x0c0c1818, 0xf3f3e7e8, 0x18181818,
        0xe7e7e7e8, 0x1e1e0000, 0xe1e20000, 0x00001e1e, 0xffffe1e2, 0x1817edee, 0xe7e81212, 0xedee1818,
        0x1211e7e8, 0x30301e1e, 0xcfcfe1e2, 0x1e1e3030, 0xe1e1cfd0, 0x2423f9fa, 0xdbdc0606, 0xf9fa2424,
        0x0605dbdc, 0x30300c0c, 0xcfcff3f4, 0x0c0c3030, 0xf3f3cfd0, 0x30303030, 0xcfcfcfd0, 0x36360000,
        0xc9ca0000, 0x00003636, 0xffffc9ca, 0x2423dbdc, 0xdbdc2424, 0x302fe7e8, 0xcfd01818, 0xe7e83030,
        0x1817cfd0, 0x4e4e1e1e, 0xb1b1e1e2, 0x1e1e4e4e, 0xe1e1b1b2, 0x54543636, 0xababc9ca, 0x36365454,
        0xc9c9abac, 0x4241edee, 0xbdbe1212, 0xedee4242, 0x1211bdbe, 0x54540c0c, 0xababf3f4, 0x0c0c5454,
        0xf3f3abac, 0x5a5a5a5a, 0xa5a5a5a6, 0x605ff9fa, 0x9fa00606, 0xf9fa6060, 0x06059fa0, 0x4241c9ca,
        0xbdbe3636, 0xc9ca4242, 0x3635bdbe, 0x5a59d5d6, 0xa5a62a2a, 0xd5d65a5a, 0x2a29a5a6, 0x7e7de1e2,
        0x81821e1e, 0xe1e27e7e, 0x1e1d8182, 0x6665999a, 0x999a6666, 0x7e7dabac, 0x81825454, 0xabac7e7e,
        0x54538182, 0x24242424, 0xdbdbdbdc, 0x42424242, 0xbdbdbdbe, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000,
        0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000,
        0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000,
        0xf9fa0000, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606,
        0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa,
        0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa,
        0xfffff9fa, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606,
        0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0x0c0c0606, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa,
        0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa, 0xf3f3f9fa,
        0xf3f3f9fa, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c,
        0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x06060c0c, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e,
        0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0xf8f8eaeb, 0x0e0df1f2, 0xf1f20e0e, 0x1514f8f9,
        0xeaeb0707, 0xf8f91515, 0x0706eaeb, 0x1c1c0e0e, 0xe3e3f1f2, 0x0e0e1c1c, 0xf1f1e3e4, 0x1c1c1c1c,
        0xe3e3e3e4, 0x23230000, 0xdcdd0000, 0x00002323, 0xffffdcdd, 0x1c1beaeb, 0xe3e41515, 0xeaeb1c1c,
        0x1514e3e4, 0x38382323, 0xc7c7dcdd, 0x23233838, 0xdcdcc7c8, 0x2a29f1f2, 0xd5d60e0e, 0xf1f22a2a,
        0x0e0dd5d6, 0x38380e0e, 0xc7c7f1f2, 0x0e0e3838, 0xf1f1c7c8, 0x38383838, 0xc7c7c7c8, 0x3f3f0000,
        0xc0c10000, 0x00003f3f, 0xffffc0c1, 0x2a29d5d6, 0xd5d62a2a, 0x3837e3e4, 0xc7c81c1c, 0xe3e43838,
        0x1c1bc7c8, 0x5b5b2323, 0xa4a4dcdd, 0x23235b5b, 0xdcdca4a5, 0x62623f3f, 0x9d9dc0c1, 0x3f3f6262,
        0xc0c09d9e, 0x4d4ceaeb, 0xb2b31515, 0xeaeb4d4d, 0x1514b2b3, 0x62620e0e, 0x9d9df1f2, 0x0e0e6262,
        0xf1f19d9e, 0x69696969, 0x96969697, 0x7776f8f9, 0x88890707, 0xf8f97777, 0x07068889, 0x4d4cc0c1,
        0xb2b33f3f, 0xc0c14d4d, 0x3f3eb2b3, 0x6968cecf, 0x96973131, 0xcecf6969, 0x31309697, 0x77768889,
        0x88897777, 0x2a2a2a2a, 0xd5d5d5d6, 0x4d4d4d4d, 0xb2b2b2b3, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707,
        0x07070707, 0x07070707, 0x07070707, 0x07070707, 0x07070707, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9,
        0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9, 0xf8f8f8f9,
        0xf8f8f8f9, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000,
        0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0xf8f90000, 0xf8f90000, 0xf8f90000,
        0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000,
        0xf8f90000, 0x00000707, 0x00000707, 0x00000707, 0x00000707, 0x00000707, 0x00000707, 0x00000707,
        0x00000707, 0x00000707, 0x00000707, 0x00000707, 0x00000707, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9,
        0xfffff8f9, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9, 0xfffff8f9,
        0xfffff8f9, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e,
        0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0x0e0e0e0e, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2,
        0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2, 0xf1f1f1f2,
        0xf1f1f1f2, 0x15150707, 0x15150707, 0x15150707, 0x15150707, 0x15150707, 0x15150707, 0x15150707,
        0x15150707, 0x15150707, 0x15150707, 0x15150707, 0x15150707, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9,
        0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9, 0xeaeaf8f9,
        0xeaeaf8f9, 0x07071515, 0x07071515, 0x07071515, 0x07071515, 0x07071515, 0x07071515, 0x07071515,
        0x07071515, 0x07071515, 0x07071515, 0x07071515, 0x07071515, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010,
        0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0xf7f7eff0, 0x100feff0, 0xeff01010, 0x1817f7f8,
        0xe7e80808, 0xf7f81818, 0x0807e7e8, 0x20201010, 0xdfdfeff0, 0x10102020, 0xefefdfe0, 0x20202020,
        0xdfdfdfe0, 0x28280000, 0xd7d80000, 0x00002828, 0xffffd7d8, 0x201fe7e8, 0xdfe01818, 0xe7e82020,
        0x1817dfe0, 0x40402828, 0xbfbfd7d8, 0x28284040, 0xd7d7bfc0, 0x302feff0, 0xcfd01010, 0xeff03030,
        0x100fcfd0, 0x40401010, 0xbfbfeff0, 0x10104040, 0xefefbfc0, 0x40404040, 0xbfbfbfc0, 0x48480000,
        0xb7b80000, 0x00004848, 0xffffb7b8, 0x302fcfd0, 0xcfd03030, 0x403fdfe0, 0xbfc02020, 0xdfe04040,
        0x201fbfc0, 0x68682828, 0x9797d7d8, 0x28286868, 0xd7d79798, 0x70704848, 0x8f8fb7b8, 0x48487070,
        0xb7b78f90, 0x5857e7e8, 0xa7a81818, 0xe7e85858, 0x1817a7a8, 0x70701010, 0x8f8feff0, 0x10107070,
        0xefef8f90, 0x78787878, 0x87878788, 0x5857b7b8, 0xa7a84848, 0xb7b85858, 0x4847a7a8, 0x7877c7c8,
        0x87883838, 0xc7c87878, 0x38378788, 0x30303030, 0xcfcfcfd0, 0x58585858, 0xa7a7a7a8, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808,
        0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0x08080808, 0xf7f7f7f8,
        0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8,
        0xf7f7f7f8, 0xf7f7f7f8, 0xf7f7f7f8, 0x08080000, 0x08080000, 0x08080000, 0x08080000, 0x08080000,
        0x08080000, 0x08080000, 0x08080000, 0x08080000, 0x08080000, 0x08080000, 0x08080000, 0xf7f80000,
        0xf7f80000, 0xf7f80000, 0xf7f80000, 0xf7f80000, 0xf7f80000, 0xf7f80000, 0xf7f80000, 0xf7f80000,
        0xf7f80000, 0xf7f80000, 0xf7f80000, 0x00000808, 0x00000808, 0x00000808, 0x00000808, 0x00000808,
        0x00000808, 0x00000808, 0x00000808, 0x00000808, 0x00000808, 0x00000808, 0x00000808, 0xfffff7f8,
        0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0xfffff7f8,
        0xfffff7f8, 0xfffff7f8, 0xfffff7f8, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010,
        0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0x10101010, 0xefefeff0,
        0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0, 0xefefeff0,
        0xefefeff0, 0xefefeff0, 0xefefeff0, 0x10100808, 0x10100808, 0x10100808, 0x10100808, 0x10100808,
        0x10100808, 0x10100808, 0x10100808, 0x10100808, 0x10100808, 0x10100808, 0x10100808, 0xefeff7f8,
        0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0xefeff7f8,
        0xefeff7f8, 0xefeff7f8, 0xefeff7f8, 0x08081010, 0x08081010, 0x08081010, 0x08081010, 0x08081010,
        0x08081010, 0x08081010, 0x08081010, 0x08081010, 0x08081010, 0x08081010, 0x08081010, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212,
        0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x1211edee, 0xedee1212, 0x1b1af6f7,
        0xe4e50909, 0xf6f71b1b, 0x0908e4e5, 0x24241212, 0xdbdbedee, 0x12122424, 0xededdbdc, 0x24242424,
        0xdbdbdbdc, 0x2d2d0000, 0xd2d30000, 0x00002d2d, 0xffffd2d3, 0x2423e4e5, 0xdbdc1b1b, 0xe4e52424,
        0x1b1adbdc, 0x48482d2d, 0xb7b7d2d3, 0x2d2d4848, 0xd2d2b7b8, 0x3635edee, 0xc9ca1212, 0xedee3636,
        0x1211c9ca, 0x48481212, 0xb7b7edee, 0x12124848, 0xededb7b8, 0x48484848, 0xb7b7b7b8, 0x51510000,
        0xaeaf0000, 0x00005151, 0xffffaeaf, 0x3635c9ca, 0xc9ca3636, 0x4847dbdc, 0xb7b82424, 0xdbdc4848,
        0x2423b7b8, 0x75752d2d, 0x8a8ad2d3, 0x2d2d7575, 0xd2d28a8b, 0x7e7e5151, 0x8181aeaf, 0x51517e7e,
        0xaeae8182, 0x6362e4e5, 0x9c9d1b1b, 0xe4e56363, 0x1b1a9c9d, 0x6362aeaf, 0x9c9d5151, 0xaeaf6363,
        0x51509c9d, 0x36363636, 0xc9c9c9ca, 0x6c6c6c6c, 0x93939394, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909,
        0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0x09090909, 0xf6f6f6f7,
        0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7,
        0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0xf6f6f6f7, 0x09090000, 0x09090000, 0x09090000, 0x09090000,
        0x09090000, 0x09090000, 0x09090000, 0x09090000, 0x09090000, 0x09090000, 0x09090000, 0x09090000,
        0x09090000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000,
        0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0xf6f70000, 0x00000909, 0x00000909,
        0x00000909, 0x00000909, 0x00000909, 0x00000909, 0x00000909, 0x00000909, 0x00000909, 0x00000909,
        0x00000909, 0x00000909, 0x00000909, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7,
        0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7, 0xfffff6f7,
        0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212,
        0x12121212, 0x12121212, 0x12121212, 0x12121212, 0x12121212, 0xedededee, 0xedededee, 0xedededee,
        0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee, 0xedededee,
        0xedededee, 0xedededee, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909,
        0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0x1b1b0909, 0xe4e4f6f7,
        0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7,
        0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0xe4e4f6f7, 0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b,
        0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b, 0x09091b1b,
        0x09091b1b, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5,
        0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0xf6f6e4e5, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606,
        0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0504fafb, 0xfafb0505, 0xfafb0505,
        0x0504fafb, 0x0b0b0606, 0xf4f4f9fa, 0x06060b0b, 0xf9f9f4f5, 0x08080000, 0xf7f80000, 0x00000808,
        0xfffff7f8, 0x0b0b0b0b, 0xf4f4f4f5, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x11110c0c,
        0xeeeef3f4, 0x0c0c1111, 0xf3f3eeef, 0x11111111, 0xeeeeeeef, 0x12120606, 0xededf9fa, 0x06061212,
        0xf9f9edee, 0x0b0af7f8, 0xf4f50808, 0xf7f80b0b, 0x0807f4f5, 0x0f0f0000, 0xf0f10000, 0x00000f0f,
        0xfffff0f1, 0x14140000, 0xebec0000, 0x00001414, 0xffffebec, 0x19191212, 0xe6e6edee, 0x12121919,
        0xedede6e7, 0x19190b0b, 0xe6e6f4f5, 0x0b0b1919, 0xf4f4e6e7, 0x19191919, 0xe6e6e6e7, 0x0e0df1f2,
        0xf1f20e0e, 0xf1f20e0e, 0x0e0df1f2, 0x1a1a0000, 0xe5e60000, 0x00001a1a, 0xffffe5e6, 0x1211f4f5,
        0xedee0b0b, 0xf4f51212, 0x0b0aedee, 0x1615f8f9, 0xe9ea0707, 0xf8f91616, 0x0706e9ea, 0x22221a1a,
        0xdddde5e6, 0x1a1a2222, 0xe5e5ddde, 0x22221212, 0xddddedee, 0x12122222, 0xededddde, 0x22222222,
        0xddddddde, 0x23230b0b, 0xdcdcf4f5, 0x0b0b2323, 0xf4f4dcdd, 0x1d1d0000, 0xe2e30000, 0x00001d1d,
        0xffffe2e3, 0x1615eced, 0xe9ea1313, 0xeced1616, 0x1312e9ea, 0x1a19f0f1, 0xe5e60f0f, 0xf0f11a1a,
        0x0f0ee5e6, 0x25250000, 0xdadb0000, 0x00002525, 0xffffdadb, 0x2c2c1b1b, 0xd3d3e4e5, 0x1b1b2c2c,
        0xe4e4d3d4, 0x2c2c2424, 0xd3d3dbdc, 0x24242c2c, 0xdbdbd3d4, 0x2c2c1212, 0xd3d3edee, 0x12122c2c,
        0xededd3d4, 0x2120f5f6, 0xdedf0a0a, 0xf5f62121, 0x0a09dedf, 0x2d2d2d2d, 0xd2d2d2d3, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606,
        0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000,
        0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000,
        0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd,
        0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000,
        0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa,
        0x07070000, 0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303,
        0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606,
        0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x03030000, 0xfcfd0000,
        0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000, 0xf8f90000, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x07070000,
        0xf8f90000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0403fbfc, 0xfbfc0404, 0xf9fa0a0a,
        0x0605f5f6, 0xf3f40000, 0x0c0c0000, 0xf3f3f9fa, 0xf3f40606, 0x0c0bf9fa, 0x0c0c0606, 0xfffff1f2,
        0x00000e0e, 0x0c0c0c0c, 0xf3f3f3f4, 0xedee0000, 0x12120000, 0xf3f40e0e, 0x0c0bf1f2, 0xf9f9edee,
        0xf9fa1212, 0x0605edee, 0x06061212, 0xededf5f6, 0xedee0a0a, 0x1211f5f6, 0x12120a0a, 0xffffe9ea,
        0x00001616, 0xe7e80000, 0x18180000, 0xf3f3e9ea, 0xf3f41616, 0x0c0be9ea, 0x0c0c1616, 0xe7e7f7f8,
        0xe7e80808, 0x1817f7f8, 0x18180808, 0xf9f9e5e6, 0xf9fa1a1a, 0x0605e5e6, 0x06061a1a, 0xffffe3e4,
        0x00001c1c, 0x14141414, 0xebebebec, 0xe5e5f1f2, 0x1a1a0e0e, 0xf3f3e1e2, 0x0c0c1e1e, 0xdfdff5f6,
        0x20200a0a, 0xdfdfedee, 0x20201212, 0xe5e5e5e6, 0x1a1a1a1a, 0xebebddde, 0x14142222, 0xf3f3d9da,
        0x0c0c2626, 0xdfdfdfe0, 0x20202020, 0x20202020, 0xd7d7e9ea, 0xddddddde, 0x22222222, 0x00000000,
        0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202,
        0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606,
        0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000,
        0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000,
        0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000,
        0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000,
        0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000,
        0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202,
        0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606,
        0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000,
        0xfdfe0000, 0x00000202, 0xfffffdfe, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000,
        0xf9fa0000, 0x00000606, 0xfffff9fa, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a,
        0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x0605f9fa, 0xf9fa0606, 0xf7f80e0e,
        0x0807f1f2, 0xffffedee, 0x00001212, 0xeff00a0a, 0x100ff5f6, 0xe7e80000, 0x18180000, 0xf7f7e7e8,
        0xf7f81818, 0x0807e7e8, 0x08081818, 0x12121212, 0xedededee, 0xeff01414, 0x100febec, 0xe5e5f1f2,
        0xe5e60e0e, 0x1a19f1f2, 0x1a1a0e0e, 0xffffe1e2, 0x00001e1e, 0xddde0000, 0x22220000, 0xf7f7ddde,
        0xf7f82222, 0x0807ddde, 0x08082222, 0xedede1e2, 0xedee1e1e, 0x1211e1e2, 0x12121e1e, 0xddddf5f6,
        0xddde0a0a, 0x2221f5f6, 0x22220a0a, 0xddddebec, 0x22221414, 0xffffd7d8, 0x00002828, 0x1e1e1e1e,
        0xe1e1e1e2, 0xededd7d8, 0x12122828, 0xd3d40000, 0x2c2c0000, 0xd3d3eff0, 0x2c2c1010, 0xdbdbdbdc,
        0xdbdbdbdc, 0x24242424, 0xd3d3e5e6, 0x2c2c1a1a, 0xe5e5d1d2, 0x1a1a2e2e, 0xededcbcc, 0x12123434,
        0xc9c9ebec, 0xd3d3d3d4, 0x2c2c2c2c, 0xc9c9dfe0, 0xd1d1d1d2, 0xd1d1d1d2, 0x2e2e2e2e, 0x00000000,
        0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6,
        0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202,
        0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a,
        0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc,
        0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000,
        0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000,
        0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe,
        0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6,
        0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a,
        0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000,
        0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000,
        0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404,
        0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000,
        0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6,
        0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202,
        0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a,
        0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc,
        0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000,
        0xfdfe0000, 0x00000202, 0xfffffdfe, 0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000,
        0xf5f60000, 0x00000a0a, 0xfffff5f6, 0x00000000, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe,
        0x04040404, 0xfbfbfbfc, 0x0a0a0a0a, 0xf5f5f5f6, 0x0a0a0000, 0xf5f60000, 0x00000a0a, 0xfffff5f6,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c,
        0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x0807f7f8, 0xf7f80808, 0xeff00808,
        0x100ff7f8, 0xe7e80000, 0x18180000, 0xf7f7e7e8, 0xf7f81818, 0x0807e7e8, 0x08081818, 0xeff01414,
        0x100febec, 0xffffe3e4, 0x00001c1c, 0xe7e7eff0, 0xe7e81010, 0x1817eff0, 0x18181010, 0xdfe00000,
        0x20200000, 0xefefe3e4, 0xeff01c1c, 0x100fe3e4, 0x10101c1c, 0xdfdff7f8, 0xdfe00808, 0xf7f7dfe0,
        0xf7f82020, 0x0807dfe0, 0x08082020, 0x201ff7f8, 0x20200808, 0x18181818, 0xe7e7e7e8, 0xe7e81818,
        0x1817e7e8, 0xdfdfebec, 0x20201414, 0xffffd7d8, 0x00002828, 0xefefd7d8, 0x10102828, 0xd3d40000,
        0xd3d40000, 0xffffd3d4, 0x00002c2c, 0x2c2c0000, 0x2c2c0000, 0xdfdfdfe0, 0x20202020, 0xd3d3eff0,
        0x2c2c1010, 0xd3d3e7e8, 0xe7e7d3d4, 0x18182c2c, 0x2c2c1818, 0xefefcfd0, 0x10103030, 0xdbdbdbdc,
        0xdbdbdbdc, 0x24242424, 0x24242424, 0xcbcbebec, 0x28282828, 0xd7d7d7d8, 0xcbcbdfe0, 0x00000000,
        0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4,
        0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404,
        0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c,
        0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000,
        0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000,
        0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc,
        0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4,
        0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c,
        0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000,
        0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000,
        0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404,
        0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000,
        0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4,
        0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404,
        0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c,
        0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000,
        0xfbfc0000, 0x00000404, 0xfffffbfc, 0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000,
        0xf3f40000, 0x00000c0c, 0xfffff3f4, 0x00000000, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc,
        0x04040404, 0xfbfbfbfc, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0000, 0xf3f40000, 0x00000c0c, 0xfffff3f4,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0,
        0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c,
        0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0,
        0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c,
        0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0,
        0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c,
        0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414,
        0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0,
        0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c,
        0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec,
        0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606,
        0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e,
        0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4,
        0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x06060606, 0xf9f9f9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020,
        0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x06060606, 0xf9f9f9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x14141414, 0xebebebec, 0x20202020, 0xdfdfdfe0, 0x2e2e2e2e, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000

################################################################################

TITLE
    libavcodec indeo3 correctionhighorder

TYPE
    32

DATA
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101,
        0xfeff0303, 0x0100fcfd, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303,
        0x0100fcfd, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x0302feff, 0xfcfd0101, 0xfeff0303, 0x0100fcfd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9,
        0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707,
        0xf8f8f8f9, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc,
        0x07070707, 0xf8f8f8f9, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404,
        0x0100fbfc, 0x07070707, 0xf8f8f8f9, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101,
        0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x0403feff,
        0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9, 0x00000000, 0x03030303, 0xfcfcfcfd,
        0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9, 0x00000000, 0x03030303,
        0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9, 0x00000000,
        0x03030303, 0xfcfcfcfd, 0x0403feff, 0xfbfc0101, 0xfeff0404, 0x0100fbfc, 0x07070707, 0xf8f8f8f9,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd,
        0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb,
        0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101,
        0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd,
        0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb,
        0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101,
        0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd, 0x03030a0a, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x0504feff, 0xfafb0101, 0xfeff0505, 0x0100fafb, 0x0a0a0303, 0xf5f5fcfd,
        0x03030a0a, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202,
        0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505,
        0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303,
        0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9,
        0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe,
        0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000,
        0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5,
        0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707,
        0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb,
        0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd,
        0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b,
        0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202,
        0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x05050505,
        0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9, 0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303,
        0xf2f2fcfd, 0x00000000, 0x05050505, 0xfafafafb, 0x0706fdfe, 0xf8f90202, 0xfdfe0707, 0x0201f8f9,
        0x0b0b0b0b, 0xf4f4f4f5, 0x0d0d0303, 0xf2f2fcfd, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8, 0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc,
        0x04040f0f, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x0807fdfe, 0xf7f80202, 0xfdfe0808, 0x0201f7f8,
        0x0d0d0d0d, 0xf2f2f2f3, 0x0f0f0404, 0xf0f0fbfc, 0x04040f0f, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6, 0x10101010, 0xefefeff0, 0x12120505, 0xededfafb,
        0x05051212, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x0a09fcfd, 0xf5f60303, 0xfcfd0a0a, 0x0302f5f6,
        0x10101010, 0xefefeff0, 0x12120505, 0xededfafb, 0x05051212, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303, 0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee,
        0x14140505, 0xebebfafb, 0x05051414, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x0b0afcfd, 0xf4f50303,
        0xfcfd0b0b, 0x0302f4f5, 0x12121212, 0xedededee, 0x14140505, 0xebebfafb, 0x05051414, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x09090909, 0xf6f6f6f7,
        0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa,
        0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c,
        0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000,
        0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec,
        0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd,
        0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717,
        0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4,
        0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909,
        0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606,
        0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303,
        0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9,
        0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414,
        0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7,
        0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa,
        0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c,
        0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000,
        0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec,
        0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd,
        0xf3f40303, 0xfcfd0c0c, 0x0302f3f4, 0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717,
        0xf9f9e8e9, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x0c0bfcfd, 0xf3f40303, 0xfcfd0c0c, 0x0302f3f4,
        0x14141414, 0xebebebec, 0x17170606, 0xe8e8f9fa, 0x06061717, 0xf9f9e8e9, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000,
        0x00000202, 0xfffffdfe, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202,
        0xfffffdfe, 0x00000000, 0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe,
        0x00000000, 0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x00000000,
        0x02020202, 0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x00000000, 0x02020202,
        0xfdfdfdfe, 0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x00000000, 0x02020202, 0xfdfdfdfe,
        0x02020000, 0xfdfe0000, 0x00000202, 0xfffffdfe, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa,
        0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606,
        0xf9f9f9fa, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd,
        0x06060606, 0xf9f9f9fa, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303,
        0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000,
        0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x00000000, 0x03030303, 0xfcfcfcfd, 0x03030000,
        0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x00000000, 0x03030303, 0xfcfcfcfd,
        0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x00000000, 0x03030303,
        0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa, 0x00000000,
        0x03030303, 0xfcfcfcfd, 0x03030000, 0xfcfd0000, 0x00000303, 0xfffffcfd, 0x06060606, 0xf9f9f9fa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc,
        0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc,
        0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000,
        0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc,
        0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc,
        0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000,
        0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000, 0x04040404, 0xfbfbfbfc,
        0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc, 0x04040808, 0x00000000,
        0x04040404, 0xfbfbfbfc, 0x04040000, 0xfbfc0000, 0x00000404, 0xfffffbfc, 0x08080404, 0xf7f7fbfc,
        0x04040808, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000,
        0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505,
        0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505,
        0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb,
        0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000,
        0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000,
        0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6,
        0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505,
        0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb,
        0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb,
        0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a,
        0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000,
        0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x05050505,
        0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb, 0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505,
        0xf0f0fafb, 0x00000000, 0x05050505, 0xfafafafb, 0x05050000, 0xfafb0000, 0x00000505, 0xfffffafb,
        0x0a0a0a0a, 0xf5f5f5f6, 0x0f0f0505, 0xf0f0fafb, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa,
        0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa, 0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa,
        0x06060c0c, 0x00000000, 0x06060606, 0xf9f9f9fa, 0x06060000, 0xf9fa0000, 0x00000606, 0xfffff9fa,
        0x0c0c0c0c, 0xf3f3f3f4, 0x0c0c0606, 0xf3f3f9fa, 0x06060c0c, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9,
        0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9, 0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9,
        0x07071515, 0x00000000, 0x07070707, 0xf8f8f8f9, 0x07070000, 0xf8f90000, 0x00000707, 0xfffff8f9,
        0x0e0e0e0e, 0xf1f1f1f2, 0x15150707, 0xeaeaf8f9, 0x07071515, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000, 0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0,
        0x10100808, 0xefeff7f8, 0x08081010, 0x00000000, 0x08080808, 0xf7f7f7f8, 0x08080000, 0xf7f80000,
        0x00000808, 0xfffff7f8, 0x10101010, 0xefefeff0, 0x10100808, 0xefeff7f8, 0x08081010, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000, 0x09090909, 0xf6f6f6f7,
        0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7,
        0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909,
        0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000,
        0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee,
        0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000,
        0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b,
        0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7,
        0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909,
        0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909,
        0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000,
        0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5,
        0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212,
        0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7,
        0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7,
        0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909,
        0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000,
        0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee,
        0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000,
        0xf6f70000, 0x00000909, 0xfffff6f7, 0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b,
        0xf6f6e4e5, 0x00000000, 0x09090909, 0xf6f6f6f7, 0x09090000, 0xf6f70000, 0x00000909, 0xfffff6f7,
        0x12121212, 0xedededee, 0x1b1b0909, 0xe4e4f6f7, 0x09091b1b, 0xf6f6e4e5, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0x03030000, 0x03030000, 0x03030000, 0x03030000, 0x03030000, 0x03030000, 0x03030000,
        0x03030000, 0x03030000, 0x03030000, 0x03030000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000,
        0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0xfcfd0000, 0x00000303,
        0x00000303, 0x00000303, 0x00000303, 0x00000303, 0x00000303, 0x00000303, 0x00000303, 0x00000303,
        0x00000303, 0x00000303, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd,
        0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0xfffffcfd, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000,
        0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0x07070000, 0xf8f90000, 0xf8f90000,
        0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000, 0xf8f90000,
        0xf8f90000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020000, 0x02020000, 0x02020000, 0x02020000,
        0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000,
        0x02020000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000,
        0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0x00000202, 0x00000202,
        0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202,
        0x00000202, 0x00000202, 0x00000202, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe,
        0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0x06060000, 0x06060000, 0x06060000, 0x06060000,
        0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000, 0x06060000,
        0x06060000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000,
        0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0xf9fa0000, 0x00000606, 0x00000606,
        0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606, 0x00000606,
        0x00000606, 0x00000606, 0x00000606, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa,
        0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa, 0xfffff9fa,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020000, 0x02020000, 0x02020000, 0x02020000,
        0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000, 0x02020000,
        0x02020000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000,
        0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0xfdfe0000, 0x00000202, 0x00000202,
        0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202, 0x00000202,
        0x00000202, 0x00000202, 0x00000202, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe,
        0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe, 0xfffffdfe,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,
        0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0xf5f5f5f6,
        0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6,
        0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0xf5f5f5f6, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000,
        0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000, 0x0a0a0000,
        0x0a0a0000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000,
        0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0xf5f60000, 0x00000a0a, 0x00000a0a,
        0x00000a0a, 0x00000a0a, 0x00000a0a, 0x00000a0a, 0x00000a0a, 0x00000a0a, 0x00000a0a, 0x00000a0a,
        0x00000a0a, 0x00000a0a, 0x00000a0a, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6,
        0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6, 0xfffff5f6,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x04040000, 0x04040000, 0x04040000, 0x04040000,
        0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000, 0x04040000,
        0x04040000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000,
        0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0xfbfc0000, 0x00000404, 0x00000404,
        0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404, 0x00000404,
        0x00000404, 0x00000404, 0x00000404, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc,
        0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc, 0xfffffbfc,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404,
        0x04040404, 0x04040404, 0x04040404, 0x04040404, 0x04040404, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc, 0xfbfbfbfc,
        0xfbfbfbfc, 0xfbfbfbfc, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000,
        0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000, 0x0c0c0000,
        0x0c0c0000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000,
        0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0xf3f40000, 0x00000c0c, 0x00000c0c,
        0x00000c0c, 0x00000c0c, 0x00000c0c, 0x00000c0c, 0x00000c0c, 0x00000c0c, 0x00000c0c, 0x00000c0c,
        0x00000c0c, 0x00000c0c, 0x00000c0c, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4,
        0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4, 0xfffff3f4,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0,
        0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0,
        0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0,
        0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef,
        0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0xdeadbeef, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202, 0x02020202,
        0x02020202, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe,
        0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0xfdfdfdfe, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606, 0x06060606,
        0x06060606, 0x06060606, 0x06060606, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa, 0xf9f9f9fa,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c,
        0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0x0c0c0c0c, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4, 0xf3f3f3f4,
        0xf3f3f3f4, 0xf3f3f3f4, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414,
        0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0x14141414, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec,
        0xebebebec, 0xebebebec, 0xebebebec, 0xebebebec, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020, 0x20202020,
        0x20202020, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0,
        0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0xdfdfdfe0, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e,
        0x2e2e2e2e, 0x2e2e2e2e, 0x2e2e2e2e, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2, 0xd1d1d1d2,
        0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000

################################################################################

TITLE
    libavcodec intrax8 crazy_mix_runlevel

TYPE
    8

DATA
        0x22,0x32,0x33,0x53,0x23,0x42,0x43,0x63,
        0x24,0x52,0x34,0x73,0x25,0x62,0x44,0x83,
        0x26,0x72,0x35,0x54,0x27,0x82,0x45,0x64,
        0x28,0x92,0x36,0x74,0x29,0xa2,0x46,0x84};

################################################################################

TITLE
    libavcodec intrax8 zero_prediction_weights

TYPE
    16

DATA
    640,  640,  669,  480,  708,  354,  748, 257,  792, 198,  760, 143,  808, 101,  772,  72,
    480,  669,  537,  537,  598,  416,  661, 316,  719, 250,  707, 185,  768, 134,  745,  97,
    354,  708,  416,  598,  488,  488,  564, 388,  634, 317,  642, 241,  716, 179,  706, 132,
    257,  748,  316,  661,  388,  564,  469, 469,  543, 395,  571, 311,  655, 238,  660, 180,
    198,  792,  250,  719,  317,  634,  395, 543,  469, 469,  507, 380,  597, 299,  616, 231,
    161,  855,  206,  788,  266,  710,  340, 623,  411, 548,  455, 455,  548, 366,  576, 288,
    122,  972,  159,  914,  211,  842,  276, 758,  341, 682,  389, 584,  483, 483,  520, 390,
    110, 1172,  144, 1107,  193, 1028,  254, 932,  317, 846,  366, 731,  458, 611,  499, 499

################################################################################

TITLE
    libavcodec ff_dirac_schro_video_format_info

TYPE
    16

DATA
    { 640,  480,  24000, 1001},
    { 176,  120,  15000, 1001},
    { 176,  144,  25,    2   },
    { 352,  240,  15000, 1001},
    { 352,  288,  25,    2   },
    { 704,  480,  15000, 1001},
    { 704,  576,  25,    2   },
    { 720,  480,  30000, 1001},
    { 720,  576,  25,    1   },
    { 1280, 720,  60000, 1001},
    { 1280, 720,  50,    1   },
    { 1920, 1080, 30000, 1001},
    { 1920, 1080, 25,    1   },
    { 1920, 1080, 60000, 1001},
    { 1920, 1080, 50,    1   },
    { 2048, 1080, 24,    1   },
    { 4096, 2160, 24,    1   },

################################################################################

TITLE
    libavcodec libmp3lame sBitRates

TYPE
    16 32

DATA
    {   {  0, 32, 64, 96,128,160,192,224,256,288,320,352,384,416,448},
        {  0, 32, 48, 56, 64, 80, 96,112,128,160,192,224,256,320,384},
        {  0, 32, 40, 48, 56, 64, 80, 96,112,128,160,192,224,256,320}
    },
    {   {  0, 32, 48, 56, 64, 80, 96,112,128,144,160,176,192,224,256},
        {  0,  8, 16, 24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160},
        {  0,  8, 16, 24, 32, 40, 48, 56, 64, 80, 96,112,128,144,160}

################################################################################

TITLE
    libavcodec MACEtab2

TYPE
    16

DATA
    {    37,    116,    206,    330}, {    39,    121,    216,    346},
    {    41,    127,    225,    361}, {    42,    132,    235,    377},
    {    44,    137,    245,    392}, {    46,    144,    256,    410},
    {    48,    150,    267,    428}, {    51,    157,    280,    449},
    {    53,    165,    293,    470}, {    55,    172,    306,    490},
    {    58,    179,    319,    511}, {    60,    187,    333,    534},
    {    63,    195,    348,    557}, {    66,    205,    364,    583},
    {    69,    214,    380,    609}, {    72,    223,    396,    635},
    {    75,    233,    414,    663}, {    79,    244,    433,    694},
    {    82,    254,    453,    725}, {    86,    265,    472,    756},
    {    90,    278,    495,    792}, {    94,    290,    516,    826},
    {    98,    303,    538,    862}, {   102,    316,    562,    901},
    {   107,    331,    588,    942}, {   112,    345,    614,    983},
    {   117,    361,    641,   1027}, {   122,    377,    670,   1074},
    {   127,    394,    701,   1123}, {   133,    411,    732,   1172},
    {   139,    430,    764,   1224}, {   145,    449,    799,   1280},
    {   152,    469,    835,   1337}, {   159,    490,    872,   1397},
    {   166,    512,    911,   1459}, {   173,    535,    951,   1523},
    {   181,    558,    993,   1590}, {   189,    584,   1038,   1663},
    {   197,    610,   1085,   1738}, {   206,    637,   1133,   1815},
    {   215,    665,   1183,   1895}, {   225,    695,   1237,   1980},
    {   235,    726,   1291,   2068}, {   246,    759,   1349,   2161},
    {   257,    792,   1409,   2257}, {   268,    828,   1472,   2357},
    {   280,    865,   1538,   2463}, {   293,    903,   1606,   2572},
    {   306,    944,   1678,   2688}, {   319,    986,   1753,   2807},
    {   334,   1030,   1832,   2933}, {   349,   1076,   1914,   3065},
    {   364,   1124,   1999,   3202}, {   380,   1174,   2088,   3344},
    {   398,   1227,   2182,   3494}, {   415,   1281,   2278,   3649},
    {   434,   1339,   2380,   3811}, {   453,   1398,   2486,   3982},
    {   473,   1461,   2598,   4160}, {   495,   1526,   2714,   4346},
    {   517,   1594,   2835,   4540}, {   540,   1665,   2961,   4741},
    {   564,   1740,   3093,   4953}, {   589,   1818,   3232,   5175},
    {   615,   1898,   3375,   5405}, {   643,   1984,   3527,   5647},
    {   671,   2072,   3683,   5898}, {   701,   2164,   3848,   6161},
    {   733,   2261,   4020,   6438}, {   766,   2362,   4199,   6724},
    {   800,   2467,   4386,   7024}, {   836,   2578,   4583,   7339},
    {   873,   2692,   4786,   7664}, {   912,   2813,   5001,   8008},
    {   952,   2938,   5223,   8364}, {   995,   3070,   5457,   8739},
    {  1039,   3207,   5701,   9129}, {  1086,   3350,   5956,   9537},
    {  1134,   3499,   6220,   9960}, {  1185,   3655,   6497,  10404},
    {  1238,   3818,   6788,  10869}, {  1293,   3989,   7091,  11355},
    {  1351,   4166,   7407,  11861}, {  1411,   4352,   7738,  12390},
    {  1474,   4547,   8084,  12946}, {  1540,   4750,   8444,  13522},
    {  1609,   4962,   8821,  14126}, {  1680,   5183,   9215,  14756},
    {  1756,   5415,   9626,  15415}, {  1834,   5657,  10057,  16104},
    {  1916,   5909,  10505,  16822}, {  2001,   6173,  10975,  17574},
    {  2091,   6448,  11463,  18356}, {  2184,   6736,  11974,  19175},
    {  2282,   7037,  12510,  20032}, {  2383,   7351,  13068,  20926},
    {  2490,   7679,  13652,  21861}, {  2601,   8021,  14260,  22834},
    {  2717,   8380,  14897,  23854}, {  2838,   8753,  15561,  24918},
    {  2965,   9144,  16256,  26031}, {  3097,   9553,  16982,  27193},
    {  3236,   9979,  17740,  28407}, {  3380,  10424,  18532,  29675},
    {  3531,  10890,  19359,  31000}, {  3688,  11375,  20222,  32382},
    {  3853,  11883,  21125,  32767}, {  4025,  12414,  22069,  32767},
    {  4205,  12967,  23053,  32767}, {  4392,  13546,  24082,  32767},
    {  4589,  14151,  25157,  32767}, {  4793,  14783,  26280,  32767},
    {  5007,  15442,  27452,  32767}, {  5231,  16132,  28678,  32767},
    {  5464,  16851,  29957,  32767}, {  5708,  17603,  31294,  32767},
    {  5963,  18389,  32691,  32767}, {  6229,  19210,  32767,  32767},
    {  6507,  20067,  32767,  32767}, {  6797,  20963,  32767,  32767},
    {  7101,  21899,  32767,  32767}, {  7418,  22876,  32767,  32767},
    {  7749,  23897,  32767,  32767}, {  8095,  24964,  32767,  32767},
    {  8456,  26078,  32767,  32767}, {  8833,  27242,  32767,  32767},
    {  9228,  28457,  32767,  32767}, {  9639,  29727,  32767,  32767}

################################################################################

TITLE
    libavcodec MACEtab4

TYPE
    16

DATA
    {    64,    216}, {    67,    226}, {    70,    236}, {    74,    246},
    {    77,    257}, {    80,    268}, {    84,    280}, {    88,    294},
    {    92,    307}, {    96,    321}, {   100,    334}, {   104,    350},
    {   109,    365}, {   114,    382}, {   119,    399}, {   124,    416},
    {   130,    434}, {   136,    454}, {   142,    475}, {   148,    495},
    {   155,    519}, {   162,    541}, {   169,    564}, {   176,    590},
    {   185,    617}, {   193,    644}, {   201,    673}, {   210,    703},
    {   220,    735}, {   230,    767}, {   240,    801}, {   251,    838},
    {   262,    876}, {   274,    914}, {   286,    955}, {   299,    997},
    {   312,   1041}, {   326,   1089}, {   341,   1138}, {   356,   1188},
    {   372,   1241}, {   388,   1297}, {   406,   1354}, {   424,   1415},
    {   443,   1478}, {   462,   1544}, {   483,   1613}, {   505,   1684},
    {   527,   1760}, {   551,   1838}, {   576,   1921}, {   601,   2007},
    {   628,   2097}, {   656,   2190}, {   686,   2288}, {   716,   2389},
    {   748,   2496}, {   781,   2607}, {   816,   2724}, {   853,   2846},
    {   891,   2973}, {   930,   3104}, {   972,   3243}, {  1016,   3389},
    {  1061,   3539}, {  1108,   3698}, {  1158,   3862}, {  1209,   4035},
    {  1264,   4216}, {  1320,   4403}, {  1379,   4599}, {  1441,   4806},
    {  1505,   5019}, {  1572,   5244}, {  1642,   5477}, {  1715,   5722},
    {  1792,   5978}, {  1872,   6245}, {  1955,   6522}, {  2043,   6813},
    {  2134,   7118}, {  2229,   7436}, {  2329,   7767}, {  2432,   8114},
    {  2541,   8477}, {  2655,   8854}, {  2773,   9250}, {  2897,   9663},
    {  3026,  10094}, {  3162,  10546}, {  3303,  11016}, {  3450,  11508},
    {  3604,  12020}, {  3765,  12556}, {  3933,  13118}, {  4108,  13703},
    {  4292,  14315}, {  4483,  14953}, {  4683,  15621}, {  4892,  16318},
    {  5111,  17046}, {  5339,  17807}, {  5577,  18602}, {  5826,  19433},
    {  6086,  20300}, {  6358,  21205}, {  6642,  22152}, {  6938,  23141},
    {  7248,  24173}, {  7571,  25252}, {  7909,  26380}, {  8262,  27557},
    {  8631,  28786}, {  9016,  30072}, {  9419,  31413}, {  9839,  32767},
    { 10278,  32767}, { 10737,  32767}, { 11216,  32767}, { 11717,  32767},
    { 12240,  32767}, { 12786,  32767}, { 13356,  32767}, { 13953,  32767},
    { 14576,  32767}, { 15226,  32767}, { 15906,  32767}, { 16615,  32767}

################################################################################

TITLE
    libavcodec mimic vlcdec_lookup

TYPE
    8

DATA
 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -3 3 -2 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -7 7 -6 6 -5 5 -4 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -15 15 -14 14 -13 13 -12 12 -11 11 -10 10 -9 9 -8 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -31 31 -30 30 -29 29 -28 28 -27 27 -26 26 -25 25 -24 24 -23 23 -22 22 -21 21 -20 20 -19 19 -18 18 -17 17 -16 16 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 -63 63 -62 62 -61 61 -60 60 -59 59 -58 58 -57 57 -56 56 -55 55 -54 54 -53 53 -52 52 -51 51 -50 50 -49 49 -48 48 -47 47 -46 46 -45 45 -44 44 -43 43 -42 42 -41 41 -40 40 -39 39 -38 38 -37 37 -36 36 -35 35 -34 34 -33 33 -32 32
 -127 127 -126 126 -125 125 -124 124 -123 123 -122 122 -121 121 -120 120 -119 119 -118 118 -117 117 -116 116 -115 115 -114 114 -113 113 -112 112 -111 111 -110 110 -109 109 -108 108 -107 107 -106 106 -105 105 -104 104 -103 103 -102 102 -101 101 -100 100 -99 99 -98 98 -97 97 -96 96
 -95 95 -94 94 -93 93 -92 92 -91 91 -90 90 -89 89 -88 88 -87 87 -86 86 -85 85 -84 84 -83 83 -82 82 -81 81 -80 80 -79 79 -78 78 -77 77 -76 76 -75 75 -74 74 -73 73 -72 72 -71 71 -70 70 -69 69 -68 68 -67 67 -66 66 -65 65 -64 64

################################################################################

TITLE
    libavcodec ff_mjpeg_val_ac_luminance

TYPE
    8

DATA
{ 0x01, 0x02, 0x03, 0x00, 0x04, 0x11, 0x05, 0x12,
  0x21, 0x31, 0x41, 0x06, 0x13, 0x51, 0x61, 0x07,
  0x22, 0x71, 0x14, 0x32, 0x81, 0x91, 0xa1, 0x08,
  0x23, 0x42, 0xb1, 0xc1, 0x15, 0x52, 0xd1, 0xf0,
  0x24, 0x33, 0x62, 0x72, 0x82, 0x09, 0x0a, 0x16,
  0x17, 0x18, 0x19, 0x1a, 0x25, 0x26, 0x27, 0x28,
  0x29, 0x2a, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
  0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
  0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
  0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
  0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
  0x7a, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
  0x8a, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98,
  0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
  0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6,
  0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4, 0xc5,
  0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4,
  0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xe1, 0xe2,
  0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea,
  0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
  0xf9, 0xfa

################################################################################

TITLE
    libavcodec ff_mjpeg_val_ac_chrominance

TYPE
    8

DATA
{ 0x00, 0x01, 0x02, 0x03, 0x11, 0x04, 0x05, 0x21,
  0x31, 0x06, 0x12, 0x41, 0x51, 0x07, 0x61, 0x71,
  0x13, 0x22, 0x32, 0x81, 0x08, 0x14, 0x42, 0x91,
  0xa1, 0xb1, 0xc1, 0x09, 0x23, 0x33, 0x52, 0xf0,
  0x15, 0x62, 0x72, 0xd1, 0x0a, 0x16, 0x24, 0x34,
  0xe1, 0x25, 0xf1, 0x17, 0x18, 0x19, 0x1a, 0x26,
  0x27, 0x28, 0x29, 0x2a, 0x35, 0x36, 0x37, 0x38,
  0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
  0x49, 0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
  0x59, 0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68,
  0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
  0x79, 0x7a, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
  0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95, 0x96,
  0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5,
  0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4,
  0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3,
  0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2,
  0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda,
  0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
  0xea, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
  0xf9, 0xfa

################################################################################

TITLE
    libavcodec ff_mlp_huffman_tables

TYPE
    8

DATA
    {    /* Huffman table 0, -7 - +10 */
        {0x01, 9}, {0x01, 8}, {0x01, 7}, {0x01, 6}, {0x01, 5}, {0x01, 4}, {0x01, 3},
        {0x04, 3}, {0x05, 3}, {0x06, 3}, {0x07, 3},
        {0x03, 3}, {0x05, 4}, {0x09, 5}, {0x11, 6}, {0x21, 7}, {0x41, 8}, {0x81, 9},
    }, { /* Huffman table 1, -7 - +8 */
        {0x01, 9}, {0x01, 8}, {0x01, 7}, {0x01, 6}, {0x01, 5}, {0x01, 4}, {0x01, 3},
        {0x02, 2}, {0x03, 2},
        {0x03, 3}, {0x05, 4}, {0x09, 5}, {0x11, 6}, {0x21, 7}, {0x41, 8}, {0x81, 9}, {0,0}, {0,0}
    }, { /* Huffman table 2, -7 - +7 */
        {0x01, 9}, {0x01, 8}, {0x01, 7}, {0x01, 6}, {0x01, 5}, {0x01, 4}, {0x01, 3},
        {0x01, 1},
        {0x03, 3}, {0x05, 4}, {0x09, 5}, {0x11, 6}, {0x21, 7}, {0x41, 8}, {0x81, 9}, {0,0}, {0,0}
    }

################################################################################

TITLE
    libavcodec mpc7_quant_vlc

TYPE
    16

DATA
 54 6 9 5 32 6 5 5 10 4 7 5 52 6 0 5 35 6 10 5 6 4 4 5 11 4 7 3 12 4 3 5 7 4 11 5 34 6 1 5 53 6 6 5 9 4 2 5 33 6 8 5 55 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 103 8 62 7 225 9 55 7 3 4 52 7 101 8 60 7 227 9 24 6 0 4 61 7 4 4 1 1 5 4 63 7 1 4 59 7 226 9 57 7 100 8 53 7 2 4 54 7 224 9 58 7 102 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 89 7 47 6 15 5 0 5 91 7 4 5 6 4 13 4 4 4 5 5 20 5 12 4 4 3 15 4 14 5 3 5 3 4 14 4 5 4 1 5 90 7 2 5 21 5 46 6 88 7 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 921 10 113 7 51 6 231 8 922 10 104 7 30 5 0 3 29 5 105 7 50 6 1 3 2 2 3 3 49 6 107 7 27 5 2 3 31 5 112 7 920 10 106 7 48 6 114 7 923 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 12 4 4 3 0 2 1 2 7 3 5 3 13 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 5 3 4 2 2 3 2 1 2 0 3 5 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 5 4 0 3 4 3 6 3 7 3 5 3 3 3 1 3 4 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 9 5 12 4 3 3 0 2 2 2 7 3 13 4 5 4 8 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 57 6 23 5 8 4 10 4 13 4 0 3 2 3 3 3 1 3 15 4 12 4 9 4 29 5 22 5 56 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 229 8 56 6 7 5 2 4 0 3 3 3 5 3 6 3 4 3 2 3 15 4 29 5 6 5 115 7 228 8 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 65 7 6 6 44 6 45 6 59 6 13 5 17 5 19 5 23 5 21 5 26 5 30 5 0 4 2 4 5 4 7 4 3 4 4 4 31 5 28 5 25 5 27 5 24 5 20 5 18 5 12 5 2 5 58 6 33 6 7 6 64 7 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 6472 13 6474 13 808 10 405 9 203 8 102 7 49 6 9 5 15 5 31 5 2 4 6 4 8 4 11 4 13 4 0 3 14 4 10 4 9 4 5 4 3 4 30 5 14 5 8 5 48 6 103 7 201 8 200 8 1619 11 6473 13 6475 13 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
 103 8 153 8 181 8 233 8 64 7 65 7 77 7 81 7 91 7 113 7 112 7 24 6 29 6 35 6 37 6 41 6 44 6 46 6 51 6 49 6 54 6 55 6 57 6 60 6 0 5 2 5 10 5 5 5 9 5 6 5 13 5 7 5 11 5 15 5 8 5 4 5 3 5 1 5 63 6 62 6 61 6 53 6 59 6 52 6 48 6 47 6 43 6 42 6 39 6 36 6 33 6 28 6 117 7 101 7 100 7 80 7 69 7 68 7 50 7 232 8 180 8 152 8 102 8 0 0 14244 14 14253 14 14246 14 14254 14 3562 12 752 10 753 10 160 9 162 9 444 9 122 8 223 8 60 7 73 7 110 7 14 6 24 6 25 6 34 6 37 6 54 6 3 5 9 5 11 5 16 5 19 5 21 5 24 5 26 5 29 5 31 5 2 4 0 4 30 5 28 5 25 5 22 5 20 5 14 5 13 5 8 5 6 5 2 5 46 6 35 6 31 6 21 6 15 6 95 7 72 7 41 7 189 8 123 8 377 9 161 9 891 10 327 10 326 10 3560 12 14255 14 14247 14 14252 14 14245 14 0 0

################################################################################

TITLE
    libavcodec mpc8_cnk

TYPE
    32

DATA
    {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31},
    {0, 0, 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, 66, 78, 91, 105, 120, 136, 153, 171, 190, 210, 231, 253, 276, 300, 325, 351, 378, 406, 435, 465},
    {0, 0, 0, 1, 4, 10, 20, 35, 56, 84, 120, 165, 220, 286, 364, 455, 560, 680, 816, 969, 1140, 1330, 1540, 1771, 2024, 2300, 2600, 2925, 3276, 3654, 4060, 4495},
    {0, 0, 0, 0, 1, 5, 15, 35, 70, 126, 210, 330, 495, 715, 1001, 1365, 1820, 2380, 3060, 3876, 4845, 5985, 7315, 8855, 10626, 12650, 14950, 17550, 20475, 23751, 27405, 31465},
    {0, 0, 0, 0, 0, 1, 6, 21, 56, 126, 252, 462, 792, 1287, 2002, 3003, 4368, 6188, 8568, 11628, 15504, 20349, 26334, 33649, 42504, 53130, 65780, 80730, 98280, 118755, 142506, 169911},
    {0, 0, 0, 0, 0, 0, 1, 7, 28, 84, 210, 462, 924, 1716, 3003, 5005, 8008, 12376, 18564, 27132, 38760, 54264, 74613, 100947, 134596, 177100, 230230, 296010, 376740, 475020, 593775, 736281},
    {0, 0, 0, 0, 0, 0, 0, 1, 8, 36, 120, 330, 792, 1716, 3432, 6435, 11440, 19448, 31824, 50388, 77520, 116280, 170544, 245157, 346104, 480700, 657800, 888030, 1184040, 1560780, 2035800, 2629575},
    {0, 0, 0, 0, 0, 0, 0, 0, 1, 9, 45, 165, 495, 1287, 3003, 6435, 12870, 24310, 43758, 75582, 125970, 203490, 319770, 490314, 735471, 1081575, 1562275, 2220075, 3108105, 4292145, 5852925, 7888725},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 10, 55, 220, 715, 2002, 5005, 11440, 24310, 48620, 92378, 167960, 293930, 497420, 817190, 1307504, 2042975, 3124550, 4686825, 6906900, 10015005, 14307150, 20160075},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 11, 66, 286, 1001, 3003, 8008, 19448, 43758, 92378, 184756, 352716, 646646, 1144066, 1961256, 3268760, 5311735, 8436285, 13123110, 20030010, 30045015, 44352165},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 12, 78, 364, 1365, 4368, 12376, 31824, 75582, 167960, 352716, 705432, 1352078, 2496144, 4457400, 7726160, 13037895, 21474180, 34597290, 54627300, 84672315},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 13, 91, 455, 1820, 6188, 18564, 50388, 125970, 293930, 646646, 1352078, 2704156, 5200300, 9657700, 17383860, 30421755, 51895935, 86493225, 141120525},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 14, 105, 560, 2380, 8568, 27132, 77520, 203490, 497420, 1144066, 2496144, 5200300, 10400600, 20058300, 37442160, 67863915, 119759850, 206253075},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 15, 120, 680, 3060, 11628, 38760, 116280, 319770, 817190, 1961256, 4457400, 9657700, 20058300, 40116600, 77558760, 145422675, 265182525},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 16, 136, 816, 3876, 15504, 54264, 170544, 490314, 1307504, 3268760, 7726160, 17383860, 37442160, 77558760, 155117520, 300540195},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 17, 153, 969, 4845, 20349, 74613, 245157, 735471, 2042975, 5311735, 13037895, 30421755, 67863915, 145422675, 300540195}

################################################################################

TITLE
    libavcodec mpc8_cnk_lost

TYPE
    32

DATA
    {0, 0, 1, 0, 3, 2, 1, 0, 7, 6, 5, 4, 3, 2, 1, 0, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 31},
    {0, 0, 1, 2, 6, 1, 11, 4, 28, 19, 9, 62, 50, 37, 23, 8, 120, 103, 85, 66, 46, 25, 3, 236, 212, 187, 161, 134, 106, 77, 47, 16, 0},
    {0, 0, 0, 0, 6, 12, 29, 8, 44, 8, 91, 36, 226, 148, 57, 464, 344, 208, 55, 908, 718, 508, 277, 24, 1796, 1496, 1171, 820, 442, 36, 3697, 3232, 0},
    {0, 0, 0, 0, 3, 1, 29, 58, 2, 46, 182, 17, 309, 23, 683, 228, 1716, 1036, 220, 3347, 2207, 877, 7529, 5758, 3734, 1434, 15218, 12293, 9017, 5363, 1303, 29576, 0},
    {0, 0, 0, 0, 0, 2, 11, 8, 2, 4, 50, 232, 761, 46, 1093, 3824, 2004, 7816, 4756, 880, 12419, 6434, 31887, 23032, 12406, 65292, 50342, 32792, 12317, 119638, 92233, 60768, 0},
    {0, 0, 0, 0, 0, 0, 1, 4, 44, 46, 50, 100, 332, 1093, 3187, 184, 4008, 14204, 5636, 26776, 11272, 56459, 30125, 127548, 85044, 31914, 228278, 147548, 49268, 454801, 312295, 142384, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 28, 8, 182, 232, 332, 664, 1757, 4944, 13320, 944, 15148, 53552, 14792, 91600, 16987, 178184, 43588, 390776, 160546, 913112, 536372, 61352, 1564729, 828448, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 7, 19, 91, 17, 761, 1093, 1757, 3514, 8458, 21778, 55490, 5102, 58654, 204518, 33974, 313105, 1015577, 534877, 1974229, 1086199, 4096463, 2535683, 499883, 6258916, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 9, 36, 309, 46, 3187, 4944, 8458, 16916, 38694, 94184, 230358, 26868, 231386, 789648, 54177, 1069754, 3701783, 1481708, 6762211, 2470066, 13394357, 5505632, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 62, 226, 23, 1093, 184, 13320, 21778, 38694, 77388, 171572, 401930, 953086, 135896, 925544, 3076873, 8340931, 3654106, 13524422, 3509417, 22756699, 2596624, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 50, 148, 683, 3824, 4008, 944, 55490, 94184, 171572, 343144, 745074, 1698160, 3931208, 662448, 3739321, 12080252, 32511574, 12481564, 49545413, 5193248, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 37, 57, 228, 2004, 14204, 15148, 5102, 230358, 401930, 745074, 1490148, 3188308, 7119516, 16170572, 3132677, 15212929, 47724503, 127314931, 42642616, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 23, 464, 1716, 7816, 5636, 53552, 58654, 26868, 953086, 1698160, 3188308, 6376616, 13496132, 29666704, 66353813, 14457878, 62182381, 189497312, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 8, 344, 1036, 4756, 26776, 14792, 204518, 231386, 135896, 3931208, 7119516, 13496132, 26992264, 56658968, 123012781, 3252931, 65435312, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 208, 220, 880, 11272, 91600, 33974, 789648, 925544, 662448, 16170572, 29666704, 56658968, 113317936, 236330717, 508019104, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 103, 55, 3347, 12419, 56459, 16987, 313105, 54177, 3076873, 3739321, 3132677, 66353813, 123012781, 236330717, 0}

################################################################################

TITLE
    libavcodec mpc_CC

TYPE
    FLOAT

DATA
    65536.0000, 21845.3333, 13107.2000, 9362.2857, 7281.7778, 4369.0667, 2114.0645,
    1040.2539, 516.0315, 257.0039, 128.2505, 64.0626, 32.0156, 16.0039, 8.0010,
    4.0002, 2.0001, 1.0000

################################################################################

TITLE
    libavcodec mpc_SCF

TYPE
    FLOAT

DATA
    307.330047607421875000, 255.999984741210937500, 213.243041992187500000, 177.627334594726562500,
    147.960128784179687500, 123.247924804687500000, 102.663139343261718750, 85.516410827636718750,
    71.233520507812500000, 59.336143493652343750, 49.425861358642578125, 41.170787811279296875,
    34.294471740722656250, 28.566631317138671875, 23.795452117919921875, 19.821151733398437500,
    16.510635375976562500, 13.753040313720703125, 11.456016540527343750, 9.542640686035156250,
    7.948835372924804688, 6.621226310729980469, 5.515353679656982422, 4.594182968139648438,
    3.826865673065185547, 3.187705039978027344, 2.655296564102172852, 2.211810588836669922,
    1.842395424842834473, 1.534679770469665527, 1.278358578681945801, 1.064847946166992188,
    0.886997759342193604, 0.738851964473724365, 0.615449428558349609, 0.512657463550567627,
    0.427033752202987671, 0.355710864067077637, 0.296300262212753296, 0.246812388300895691,
    0.205589950084686279, 0.171252459287643433, 0.142649993300437927, 0.118824683129787445,
    0.098978661000728607, 0.082447312772274017, 0.068677015602588654, 0.057206626981496811,
    0.047652013599872589, 0.039693206548690796, 0.033063672482967377, 0.027541399002075195,
    0.022941453382372856, 0.019109787419438362, 0.015918083488941193, 0.013259455561637878,
    0.011044870130717754, 0.009200163185596466, 0.007663558237254620, 0.006383595988154411,
    0.005317411851137877, 0.004429301247000694, 0.003689522389322519, 0.003073300700634718,
    0.002560000168159604, 0.002132430672645569, 0.001776273478753865, 0.001479601487517357,
    0.001232479466125369, 0.001026631565764546, 0.000855164253152907, 0.000712335284333676,
    0.000593361502978951, 0.000494258652906865, 0.000411707907915115, 0.000342944724252447,
    0.000285666319541633, 0.000237954518524930, 0.000198211506358348, 0.000165106350323185,
    0.000137530398205854, 0.000114560163638089, 0.000095426403277088, 0.000079488345363643,
    0.000066212254751008, 0.000055153526773211, 0.000045941822463647, 0.000038268648495432,
    0.000031877043511486, 0.000026552961571724, 0.000022118103515822, 0.000018423952496960,
    0.000015346795407822, 0.000012783583770215, 0.000010648477655195, 0.000008869976227288,
    0.000007388518497464, 0.000006154492893984, 0.000005126573796588, 0.000004270336830814,
    0.000003557107902452, 0.000002963002089018, 0.000002468123511790, 0.000002055899130937,
    0.000001712524181130, 0.000001426499579793, 0.000001188246528727, 0.000000989786371974,
    0.000000824472920158, 0.000000686770022185, 0.000000572066142013, 0.000000476520028769,
    0.000000396931966407, 0.000000330636652279, 0.000000275413924555, 0.000000229414467867,
    0.000000191097811353, 0.000000159180785886, 0.000000132594522029, 0.000000110448674207,
    0.000000092001613439, 0.000000076635565449, 0.000000063835940978, 0.000000053174105119,
    0.000000044293003043, 0.000000036895215771, 0.000000030733001921, 0.000000025599996789

################################################################################

TITLE
    libavcodec mpeg4 inter_rvlc

TYPE
    16

DATA
{0x0006,  3},{0x0001,  4},{0x0004,  5},{0x001C,  7},
{0x003C,  8},{0x003D,  8},{0x007C,  9},{0x00FC, 10},
{0x00FD, 10},{0x01FC, 11},{0x01FD, 11},{0x03FC, 12},
{0x07FC, 13},{0x07FD, 13},{0x0BFC, 13},{0x0BFD, 13},
{0x0FFC, 14},{0x0FFD, 14},{0x1FFC, 15},{0x0007,  3},
{0x000C,  6},{0x005C,  8},{0x007D,  9},{0x017C, 10},
{0x02FC, 11},{0x03FD, 12},{0x0DFC, 13},{0x17FC, 14},
{0x17FD, 14},{0x000A,  4},{0x001D,  7},{0x00BC,  9},
{0x02FD, 11},{0x05FC, 12},{0x1BFC, 14},{0x1BFD, 14},
{0x0005,  5},{0x005D,  8},{0x017D, 10},{0x05FD, 12},
{0x0DFD, 13},{0x1DFC, 14},{0x1FFD, 15},{0x0008,  5},
{0x006C,  8},{0x037C, 11},{0x0EFC, 13},{0x2FFC, 15},
{0x0009,  5},{0x00BD,  9},{0x037D, 11},{0x0EFD, 13},
{0x000D,  6},{0x01BC, 10},{0x06FC, 12},{0x1DFD, 14},
{0x0014,  6},{0x01BD, 10},{0x06FD, 12},{0x2FFD, 15},
{0x0015,  6},{0x01DC, 10},{0x0F7C, 13},{0x002C,  7},
{0x01DD, 10},{0x1EFC, 14},{0x002D,  7},{0x03BC, 11},
{0x0034,  7},{0x077C, 12},{0x006D,  8},{0x0F7D, 13},
{0x0074,  8},{0x1EFD, 14},{0x0075,  8},{0x1F7C, 14},
{0x00DC,  9},{0x1F7D, 14},{0x00DD,  9},{0x1FBC, 14},
{0x00EC,  9},{0x37FC, 15},{0x01EC, 10},{0x01ED, 10},
{0x01F4, 10},{0x03BD, 11},{0x03DC, 11},{0x03DD, 11},
{0x03EC, 11},{0x03ED, 11},{0x03F4, 11},{0x077D, 12},
{0x07BC, 12},{0x07BD, 12},{0x0FBC, 13},{0x0FBD, 13},
{0x0FDC, 13},{0x0FDD, 13},{0x1FBD, 14},{0x1FDC, 14},
{0x1FDD, 14},{0x37FD, 15},{0x3BFC, 15},
{0x000B,  4},{0x0078,  8},{0x03F5, 11},{0x0FEC, 13},
{0x1FEC, 14},{0x0012,  5},{0x00ED,  9},{0x07DC, 12},
{0x1FED, 14},{0x3BFD, 15},{0x0013,  5},{0x03F8, 11},
{0x3DFC, 15},{0x0018,  6},{0x07DD, 12},{0x0019,  6},
{0x07EC, 12},{0x0022,  6},{0x0FED, 13},{0x0023,  6},
{0x0FF4, 13},{0x0035,  7},{0x0FF5, 13},{0x0038,  7},
{0x0FF8, 13},{0x0039,  7},{0x0FF9, 13},{0x0042,  7},
{0x1FF4, 14},{0x0043,  7},{0x1FF5, 14},{0x0079,  8},
{0x1FF8, 14},{0x0082,  8},{0x3DFD, 15},{0x0083,  8},
{0x00F4,  9},{0x00F5,  9},{0x00F8,  9},{0x00F9,  9},
{0x0102,  9},{0x0103,  9},{0x01F5, 10},{0x01F8, 10},
{0x01F9, 10},{0x0202, 10},{0x0203, 10},{0x03F9, 11},
{0x0402, 11},{0x0403, 11},{0x07ED, 12},{0x07F4, 12},
{0x07F5, 12},{0x07F8, 12},{0x07F9, 12},{0x0802, 12},
{0x0803, 12},{0x1002, 13},{0x1003, 13},{0x1FF9, 14},
{0x2002, 14},{0x2003, 14},{0x3EFC, 15},{0x3EFD, 15},
{0x3F7C, 15},{0x3F7D, 15},{0x0000, 4}

################################################################################

TITLE
    libavcodec mpeg4 intra_rvlc

TYPE
    16

DATA
{0x0006,  3},{0x0007,  3},{0x000A,  4},{0x0009,  5},
{0x0014,  6},{0x0015,  6},{0x0034,  7},{0x0074,  8},
{0x0075,  8},{0x00DD,  9},{0x00EC,  9},{0x01EC, 10},
{0x01ED, 10},{0x01F4, 10},{0x03EC, 11},{0x03ED, 11},
{0x03F4, 11},{0x077D, 12},{0x07BC, 12},{0x0FBD, 13},
{0x0FDC, 13},{0x07BD, 12},{0x0FDD, 13},{0x1FBD, 14},
{0x1FDC, 14},{0x1FDD, 14},{0x1FFC, 15},{0x0001,  4},
{0x0008,  5},{0x002D,  7},{0x006C,  8},{0x006D,  8},
{0x00DC,  9},{0x01DD, 10},{0x03DC, 11},{0x03DD, 11},
{0x077C, 12},{0x0FBC, 13},{0x1F7D, 14},{0x1FBC, 14},
{0x0004,  5},{0x002C,  7},{0x00BC,  9},{0x01DC, 10},
{0x03BC, 11},{0x03BD, 11},{0x0EFD, 13},{0x0F7C, 13},
{0x0F7D, 13},{0x1EFD, 14},{0x1F7C, 14},{0x0005,  5},
{0x005C,  8},{0x00BD,  9},{0x037D, 11},{0x06FC, 12},
{0x0EFC, 13},{0x1DFD, 14},{0x1EFC, 14},{0x1FFD, 15},
{0x000C,  6},{0x005D,  8},{0x01BD, 10},{0x03FD, 12},
{0x06FD, 12},{0x1BFD, 14},{0x000D,  6},{0x007D,  9},
{0x02FC, 11},{0x05FC, 12},{0x1BFC, 14},{0x1DFC, 14},
{0x001C,  7},{0x017C, 10},{0x02FD, 11},{0x05FD, 12},
{0x2FFC, 15},{0x001D,  7},{0x017D, 10},{0x037C, 11},
{0x0DFD, 13},{0x2FFD, 15},{0x003C,  8},{0x01BC, 10},
{0x0BFD, 13},{0x17FD, 14},{0x003D,  8},{0x01FD, 11},
{0x0DFC, 13},{0x37FC, 15},{0x007C,  9},{0x03FC, 12},
{0x00FC, 10},{0x0BFC, 13},{0x00FD, 10},{0x37FD, 15},
{0x01FC, 11},{0x07FC, 13},{0x07FD, 13},{0x0FFC, 14},
{0x0FFD, 14},{0x17FC, 14},{0x3BFC, 15},
{0x000B,  4},{0x0078,  8},{0x03F5, 11},{0x0FEC, 13},
{0x1FEC, 14},{0x0012,  5},{0x00ED,  9},{0x07DC, 12},
{0x1FED, 14},{0x3BFD, 15},{0x0013,  5},{0x03F8, 11},
{0x3DFC, 15},{0x0018,  6},{0x07DD, 12},{0x0019,  6},
{0x07EC, 12},{0x0022,  6},{0x0FED, 13},{0x0023,  6},
{0x0FF4, 13},{0x0035,  7},{0x0FF5, 13},{0x0038,  7},
{0x0FF8, 13},{0x0039,  7},{0x0FF9, 13},{0x0042,  7},
{0x1FF4, 14},{0x0043,  7},{0x1FF5, 14},{0x0079,  8},
{0x1FF8, 14},{0x0082,  8},{0x3DFD, 15},{0x0083,  8},
{0x00F4,  9},{0x00F5,  9},{0x00F8,  9},{0x00F9,  9},
{0x0102,  9},{0x0103,  9},{0x01F5, 10},{0x01F8, 10},
{0x01F9, 10},{0x0202, 10},{0x0203, 10},{0x03F9, 11},
{0x0402, 11},{0x0403, 11},{0x07ED, 12},{0x07F4, 12},
{0x07F5, 12},{0x07F8, 12},{0x07F9, 12},{0x0802, 12},
{0x0803, 12},{0x1002, 13},{0x1003, 13},{0x1FF9, 14},
{0x2002, 14},{0x2003, 14},{0x3EFC, 15},{0x3EFD, 15},
{0x3F7C, 15},{0x3F7D, 15},{0x0000,  4}

################################################################################

TITLE
    libavcodec mpeg1_vlc

TYPE
    16

DATA
 { 0x3, 2 }, { 0x4, 4 }, { 0x5, 5 }, { 0x6, 7 },
 { 0x26, 8 }, { 0x21, 8 }, { 0xa, 10 }, { 0x1d, 12 },
 { 0x18, 12 }, { 0x13, 12 }, { 0x10, 12 }, { 0x1a, 13 },
 { 0x19, 13 }, { 0x18, 13 }, { 0x17, 13 }, { 0x1f, 14 },
 { 0x1e, 14 }, { 0x1d, 14 }, { 0x1c, 14 }, { 0x1b, 14 },
 { 0x1a, 14 }, { 0x19, 14 }, { 0x18, 14 }, { 0x17, 14 },
 { 0x16, 14 }, { 0x15, 14 }, { 0x14, 14 }, { 0x13, 14 },
 { 0x12, 14 }, { 0x11, 14 }, { 0x10, 14 }, { 0x18, 15 },
 { 0x17, 15 }, { 0x16, 15 }, { 0x15, 15 }, { 0x14, 15 },
 { 0x13, 15 }, { 0x12, 15 }, { 0x11, 15 }, { 0x10, 15 },
 { 0x3, 3 }, { 0x6, 6 }, { 0x25, 8 }, { 0xc, 10 },
 { 0x1b, 12 }, { 0x16, 13 }, { 0x15, 13 }, { 0x1f, 15 },
 { 0x1e, 15 }, { 0x1d, 15 }, { 0x1c, 15 }, { 0x1b, 15 },
 { 0x1a, 15 }, { 0x19, 15 }, { 0x13, 16 }, { 0x12, 16 },
 { 0x11, 16 }, { 0x10, 16 }, { 0x5, 4 }, { 0x4, 7 },
 { 0xb, 10 }, { 0x14, 12 }, { 0x14, 13 }, { 0x7, 5 },
 { 0x24, 8 }, { 0x1c, 12 }, { 0x13, 13 }, { 0x6, 5 },
 { 0xf, 10 }, { 0x12, 12 }, { 0x7, 6 }, { 0x9, 10 },
 { 0x12, 13 }, { 0x5, 6 }, { 0x1e, 12 }, { 0x14, 16 },
 { 0x4, 6 }, { 0x15, 12 }, { 0x7, 7 }, { 0x11, 12 },
 { 0x5, 7 }, { 0x11, 13 }, { 0x27, 8 }, { 0x10, 13 },
 { 0x23, 8 }, { 0x1a, 16 }, { 0x22, 8 }, { 0x19, 16 },
 { 0x20, 8 }, { 0x18, 16 }, { 0xe, 10 }, { 0x17, 16 },
 { 0xd, 10 }, { 0x16, 16 }, { 0x8, 10 }, { 0x15, 16 },
 { 0x1f, 12 }, { 0x1a, 12 }, { 0x19, 12 }, { 0x17, 12 },
 { 0x16, 12 }, { 0x1f, 13 }, { 0x1e, 13 }, { 0x1d, 13 },
 { 0x1c, 13 }, { 0x1b, 13 }, { 0x1f, 16 }, { 0x1e, 16 },
 { 0x1d, 16 }, { 0x1c, 16 }, { 0x1b, 16 },
 { 0x1, 6 }, /* escape */
 { 0x2, 2 }, /* EOB */

################################################################################

TITLE
    libavcodec mpeg2_vlc

TYPE
    16

DATA
  {0x02, 2}, {0x06, 3}, {0x07, 4}, {0x1c, 5},
  {0x1d, 5}, {0x05, 6}, {0x04, 6}, {0x7b, 7},
  {0x7c, 7}, {0x23, 8}, {0x22, 8}, {0xfa, 8},
  {0xfb, 8}, {0xfe, 8}, {0xff, 8}, {0x1f,14},
  {0x1e,14}, {0x1d,14}, {0x1c,14}, {0x1b,14},
  {0x1a,14}, {0x19,14}, {0x18,14}, {0x17,14},
  {0x16,14}, {0x15,14}, {0x14,14}, {0x13,14},
  {0x12,14}, {0x11,14}, {0x10,14}, {0x18,15},
  {0x17,15}, {0x16,15}, {0x15,15}, {0x14,15},
  {0x13,15}, {0x12,15}, {0x11,15}, {0x10,15},
  {0x02, 3}, {0x06, 5}, {0x79, 7}, {0x27, 8},
  {0x20, 8}, {0x16,13}, {0x15,13}, {0x1f,15},
  {0x1e,15}, {0x1d,15}, {0x1c,15}, {0x1b,15},
  {0x1a,15}, {0x19,15}, {0x13,16}, {0x12,16},
  {0x11,16}, {0x10,16}, {0x05, 5}, {0x07, 7},
  {0xfc, 8}, {0x0c,10}, {0x14,13}, {0x07, 5},
  {0x26, 8}, {0x1c,12}, {0x13,13}, {0x06, 6},
  {0xfd, 8}, {0x12,12}, {0x07, 6}, {0x04, 9},
  {0x12,13}, {0x06, 7}, {0x1e,12}, {0x14,16},
  {0x04, 7}, {0x15,12}, {0x05, 7}, {0x11,12},
  {0x78, 7}, {0x11,13}, {0x7a, 7}, {0x10,13},
  {0x21, 8}, {0x1a,16}, {0x25, 8}, {0x19,16},
  {0x24, 8}, {0x18,16}, {0x05, 9}, {0x17,16},
  {0x07, 9}, {0x16,16}, {0x0d,10}, {0x15,16},
  {0x1f,12}, {0x1a,12}, {0x19,12}, {0x17,12},
  {0x16,12}, {0x1f,13}, {0x1e,13}, {0x1d,13},
  {0x1c,13}, {0x1b,13}, {0x1f,16}, {0x1e,16},
  {0x1d,16}, {0x1c,16}, {0x1b,16},
  {0x01,6}, /* escape */
  {0x06,4}, /* EOB */

################################################################################

TITLE
    libavcodec ff_mpa_enwindow

TYPE
    32

DATA
     0,    -1,    -1,    -1,    -1,    -1,    -1,    -2,
    -2,    -2,    -2,    -3,    -3,    -4,    -4,    -5,
    -5,    -6,    -7,    -7,    -8,    -9,   -10,   -11,
   -13,   -14,   -16,   -17,   -19,   -21,   -24,   -26,
   -29,   -31,   -35,   -38,   -41,   -45,   -49,   -53,
   -58,   -63,   -68,   -73,   -79,   -85,   -91,   -97,
  -104,  -111,  -117,  -125,  -132,  -139,  -147,  -154,
  -161,  -169,  -176,  -183,  -190,  -196,  -202,  -208,
   213,   218,   222,   225,   227,   228,   228,   227,
   224,   221,   215,   208,   200,   189,   177,   163,
   146,   127,   106,    83,    57,    29,    -2,   -36,
   -72,  -111,  -153,  -197,  -244,  -294,  -347,  -401,
  -459,  -519,  -581,  -645,  -711,  -779,  -848,  -919,
  -991, -1064, -1137, -1210, -1283, -1356, -1428, -1498,
 -1567, -1634, -1698, -1759, -1817, -1870, -1919, -1962,
 -2001, -2032, -2057, -2075, -2085, -2087, -2080, -2063,
  2037,  2000,  1952,  1893,  1822,  1739,  1644,  1535,
  1414,  1280,  1131,   970,   794,   605,   402,   185,
   -45,  -288,  -545,  -814, -1095, -1388, -1692, -2006,
 -2330, -2663, -3004, -3351, -3705, -4063, -4425, -4788,
 -5153, -5517, -5879, -6237, -6589, -6935, -7271, -7597,
 -7910, -8209, -8491, -8755, -8998, -9219, -9416, -9585,
 -9727, -9838, -9916, -9959, -9966, -9935, -9863, -9750,
 -9592, -9389, -9139, -8840, -8492, -8092, -7640, -7134,
  6574,  5959,  5288,  4561,  3776,  2935,  2037,  1082,
    70,  -998, -2122, -3300, -4533, -5818, -7154, -8540,
 -9975,-11455,-12980,-14548,-16155,-17799,-19478,-21189,
-22929,-24694,-26482,-28289,-30112,-31947,-33791,-35640,
-37489,-39336,-41176,-43006,-44821,-46617,-48390,-50137,
-51853,-53534,-55178,-56778,-58333,-59838,-61289,-62684,
-64019,-65290,-66494,-67629,-68692,-69679,-70590,-71420,
-72169,-72835,-73415,-73908,-74313,-74630,-74856,-74992,
 75038,

################################################################################

TITLE
    libavcodec msmpeg4 table1_mv_code

TYPE
    16

DATA
 0x0000, 0x0007, 0x0009, 0x000f, 0x000a, 0x0011, 0x001a, 0x001c,
 0x0011, 0x0031, 0x0025, 0x002d, 0x002f, 0x006f, 0x0075, 0x0041,
 0x004c, 0x004e, 0x005c, 0x0060, 0x0062, 0x0066, 0x0068, 0x0069,
 0x006b, 0x00a6, 0x00c1, 0x00cb, 0x00cc, 0x00ce, 0x00da, 0x00e8,
 0x00ee, 0x0087, 0x0090, 0x009e, 0x009f, 0x00ba, 0x00ca, 0x00d8,
 0x00db, 0x00df, 0x0104, 0x0109, 0x010c, 0x0143, 0x0145, 0x014a,
 0x0156, 0x015c, 0x01b3, 0x01d3, 0x01da, 0x0103, 0x0109, 0x010b,
 0x0122, 0x0127, 0x0134, 0x0161, 0x0164, 0x0176, 0x0184, 0x018d,
 0x018e, 0x018f, 0x0190, 0x0193, 0x0196, 0x019d, 0x019e, 0x019f,
 0x01a9, 0x01b2, 0x01b4, 0x01ba, 0x01bb, 0x01bc, 0x0201, 0x0202,
 0x0205, 0x0207, 0x020d, 0x0210, 0x0211, 0x0215, 0x021b, 0x021f,
 0x0281, 0x0285, 0x0290, 0x029c, 0x029d, 0x02a2, 0x02a7, 0x02a8,
 0x02aa, 0x02b0, 0x02b1, 0x02b4, 0x02bc, 0x02bf, 0x0320, 0x0326,
 0x0327, 0x0329, 0x032a, 0x0336, 0x0360, 0x0362, 0x0363, 0x0372,
 0x03b2, 0x03bc, 0x03bd, 0x0203, 0x0205, 0x021a, 0x0249, 0x024a,
 0x024c, 0x02c7, 0x02ca, 0x02ce, 0x02ef, 0x030d, 0x0322, 0x0325,
 0x0338, 0x0373, 0x037a, 0x0409, 0x0415, 0x0416, 0x0418, 0x0428,
 0x042d, 0x042f, 0x0434, 0x0508, 0x0509, 0x0510, 0x0511, 0x051c,
 0x051e, 0x0524, 0x0541, 0x0543, 0x0546, 0x0547, 0x054d, 0x0557,
 0x055f, 0x056a, 0x056c, 0x056d, 0x056f, 0x0576, 0x0577, 0x057a,
 0x057b, 0x057c, 0x057d, 0x0600, 0x0601, 0x0603, 0x0614, 0x0616,
 0x0617, 0x061c, 0x061f, 0x0642, 0x0648, 0x0649, 0x064a, 0x064b,
 0x0657, 0x0668, 0x0669, 0x066b, 0x066e, 0x067f, 0x06c2, 0x06c8,
 0x06cb, 0x06de, 0x06df, 0x06e2, 0x06e3, 0x06ef, 0x0748, 0x074b,
 0x076e, 0x076f, 0x077c, 0x0409, 0x0423, 0x0428, 0x0429, 0x042a,
 0x042b, 0x0432, 0x0433, 0x0496, 0x049a, 0x04d5, 0x04db, 0x0581,
 0x0582, 0x058b, 0x058c, 0x058d, 0x0598, 0x0599, 0x059a, 0x059e,
 0x05dd, 0x0619, 0x0632, 0x0633, 0x0648, 0x0672, 0x06a1, 0x06a2,
 0x06a3, 0x06af, 0x06e2, 0x06e3, 0x06e4, 0x0800, 0x0801, 0x0802,
 0x0803, 0x081a, 0x081b, 0x0829, 0x082f, 0x0832, 0x083e, 0x083f,
 0x0852, 0x0853, 0x0858, 0x086b, 0x0877, 0x0878, 0x0879, 0x087a,
 0x087b, 0x0a00, 0x0a01, 0x0a0d, 0x0a0e, 0x0a0f, 0x0a24, 0x0a37,
 0x0a3a, 0x0a3b, 0x0a3e, 0x0a46, 0x0a47, 0x0a4a, 0x0a4b, 0x0a5f,
 0x0a79, 0x0a7a, 0x0a7b, 0x0a80, 0x0a81, 0x0a84, 0x0a85, 0x0a99,
 0x0aa5, 0x0aa6, 0x0ab8, 0x0aba, 0x0abb, 0x0abc, 0x0abd, 0x0ac8,
 0x0ace, 0x0acf, 0x0ad7, 0x0adc, 0x0aeb, 0x0c04, 0x0c25, 0x0c26,
 0x0c27, 0x0c2a, 0x0c2b, 0x0c3a, 0x0c3b, 0x0c3c, 0x0c3d, 0x0ca0,
 0x0cad, 0x0cd4, 0x0cd5, 0x0cfc, 0x0cfd, 0x0d86, 0x0d92, 0x0d93,
 0x0d94, 0x0d95, 0x0db0, 0x0db8, 0x0db9, 0x0dba, 0x0dbb, 0x0dc0,
 0x0dc2, 0x0dc3, 0x0dda, 0x0ddb, 0x0ddc, 0x0ddd, 0x0e92, 0x0e93,
 0x0e94, 0x0e95, 0x0ec7, 0x0ecc, 0x0ece, 0x0ecf, 0x0ed8, 0x0ed9,
 0x0eda, 0x0edb, 0x0808, 0x0809, 0x080a, 0x0810, 0x0811, 0x0844,
 0x0845, 0x0861, 0x0862, 0x0863, 0x086c, 0x0922, 0x0923, 0x092e,
 0x092f, 0x0936, 0x0937, 0x09b1, 0x09b2, 0x09b3, 0x09b4, 0x09b5,
 0x09b8, 0x09b9, 0x09ba, 0x09bb, 0x09bc, 0x09bd, 0x09be, 0x09bf,
 0x0b00, 0x0b15, 0x0b2c, 0x0b2d, 0x0b2e, 0x0b2f, 0x0b36, 0x0bb9,
 0x0c28, 0x0c2a, 0x0c2b, 0x0c2c, 0x0c2d, 0x0c2e, 0x0c2f, 0x0c30,
 0x0c31, 0x0c38, 0x0c60, 0x0c61, 0x0c62, 0x0c63, 0x0c8d, 0x0c8e,
 0x0c8f, 0x0c92, 0x0cbe, 0x0cbf, 0x0ce6, 0x0ce7, 0x0d40, 0x0d41,
 0x0d57, 0x0d58, 0x0d59, 0x0d5a, 0x0d5b, 0x0d5c, 0x0d5d, 0x0d98,
 0x0d99, 0x0d9a, 0x0d9b, 0x0d9c, 0x0d9d, 0x0dad, 0x0dae, 0x0daf,
 0x0dc0, 0x0dc1, 0x0dc2, 0x0dc3, 0x0dca, 0x0dcb, 0x0dec, 0x0ded,
 0x0dee, 0x0def, 0x1018, 0x1022, 0x1023, 0x1030, 0x1031, 0x1032,
 0x1033, 0x1050, 0x1051, 0x105c, 0x1074, 0x1075, 0x1076, 0x1077,
 0x1078, 0x1079, 0x107a, 0x107b, 0x10b2, 0x10b3, 0x10b8, 0x10b9,
 0x10ba, 0x10bb, 0x10d4, 0x10ea, 0x10eb, 0x10ec, 0x10ed, 0x1404,
 0x1405, 0x1406, 0x1407, 0x1410, 0x1411, 0x1412, 0x1413, 0x1414,
 0x1415, 0x1416, 0x1417, 0x1418, 0x1419, 0x1466, 0x1467, 0x1468,
 0x1469, 0x146a, 0x146b, 0x146c, 0x146d, 0x147e, 0x147f, 0x1488,
 0x1489, 0x148a, 0x148b, 0x14b6, 0x14b7, 0x14b8, 0x14b9, 0x14ba,
 0x14bb, 0x14bc, 0x14bd, 0x14f0, 0x14f1, 0x14f8, 0x14f9, 0x14fa,
 0x14fb, 0x14fc, 0x14fd, 0x14fe, 0x14ff, 0x152a, 0x152b, 0x152c,
 0x152d, 0x152e, 0x152f, 0x1530, 0x1531, 0x1548, 0x1549, 0x154e,
 0x154f, 0x1558, 0x1559, 0x155a, 0x155b, 0x1572, 0x159a, 0x159b,
 0x15ac, 0x15ba, 0x15bb, 0x15d0, 0x15d1, 0x15d2, 0x15d3, 0x15d4,
 0x15d5, 0x181d, 0x181e, 0x181f, 0x1840, 0x1841, 0x1842, 0x1843,
 0x1844, 0x1845, 0x1846, 0x1847, 0x1848, 0x1849, 0x1861, 0x1862,
 0x1863, 0x1864, 0x1865, 0x1866, 0x1867, 0x1868, 0x1869, 0x186a,
 0x186b, 0x186c, 0x186d, 0x186e, 0x191b, 0x191c, 0x191d, 0x191e,
 0x191f, 0x1942, 0x1943, 0x1944, 0x1945, 0x1946, 0x1947, 0x1958,
 0x1959, 0x19ed, 0x19ee, 0x19ef, 0x19f0, 0x19f1, 0x19f2, 0x19f3,
 0x19f4, 0x19f5, 0x19f6, 0x19f7, 0x1b0e, 0x1b0f, 0x1b62, 0x1b63,
 0x1b64, 0x1b65, 0x1b66, 0x1b67, 0x1b68, 0x1b69, 0x1b6a, 0x1b6b,
 0x1b6c, 0x1b6d, 0x1b6e, 0x1b6f, 0x1b82, 0x1ba8, 0x1ba9, 0x1baa,
 0x1bab, 0x1bac, 0x1bad, 0x1bae, 0x1baf, 0x1bb0, 0x1bb1, 0x1bb2,
 0x1bb3, 0x1d80, 0x1d81, 0x1d82, 0x1d83, 0x1d84, 0x1d85, 0x1d86,
 0x1d87, 0x1d88, 0x1d89, 0x1d8a, 0x1d8b, 0x1d8c, 0x1d8d, 0x1007,
 0x1008, 0x1009, 0x100a, 0x100b, 0x100c, 0x100d, 0x100e, 0x100f,
 0x1016, 0x1080, 0x1081, 0x1082, 0x1083, 0x1084, 0x1085, 0x1086,
 0x1087, 0x10c0, 0x123a, 0x123b, 0x123c, 0x123d, 0x123e, 0x123f,
 0x1240, 0x1241, 0x1242, 0x1243, 0x1350, 0x1352, 0x1353, 0x1358,
 0x1359, 0x135a, 0x135b, 0x135c, 0x135d, 0x135e, 0x135f, 0x1360,
 0x1361, 0x1602, 0x1603, 0x160c, 0x160d, 0x160e, 0x160f, 0x1620,
 0x1621, 0x1622, 0x1623, 0x1624, 0x1625, 0x1626, 0x1627, 0x1628,
 0x1629, 0x166e, 0x166f, 0x167c, 0x167d, 0x167e, 0x167f, 0x1770,
 0x1771, 0x1852, 0x1853, 0x1872, 0x1873, 0x1874, 0x1875, 0x1876,
 0x1877, 0x1878, 0x1879, 0x187a, 0x187b, 0x187c, 0x187d, 0x187e,
 0x187f, 0x1918, 0x1919, 0x1926, 0x1927, 0x1970, 0x1971, 0x1972,
 0x1973, 0x1974, 0x1975, 0x1976, 0x1977, 0x1978, 0x1979, 0x197a,
 0x197b, 0x1aa0, 0x1aa1, 0x1aa2, 0x1aa3, 0x1aa4, 0x1aa5, 0x1aa6,
 0x1aa7, 0x1aa8, 0x1aa9, 0x1aaa, 0x1aab, 0x1aac, 0x1aad, 0x1b3c,
 0x1b3d, 0x1b3e, 0x1b3f, 0x1b50, 0x1b51, 0x1b52, 0x1b53, 0x1b54,
 0x1b55, 0x1b56, 0x1b57, 0x1b58, 0x1b59, 0x2032, 0x2033, 0x2034,
 0x2035, 0x2036, 0x2037, 0x2038, 0x2039, 0x203a, 0x203b, 0x203c,
 0x203d, 0x203e, 0x203f, 0x2040, 0x2041, 0x2042, 0x2043, 0x20ba,
 0x20bb, 0x20cc, 0x20cd, 0x20ce, 0x20cf, 0x20e0, 0x20e1, 0x20e2,
 0x20e3, 0x20e4, 0x20e5, 0x20e6, 0x20e7, 0x21aa, 0x21ab, 0x21c0,
 0x21c1, 0x21c2, 0x21c3, 0x21c4, 0x21c5, 0x21c6, 0x21c7, 0x21c8,
 0x21c9, 0x21ca, 0x21cb, 0x21cc, 0x21cd, 0x21ce, 0x21cf, 0x21d0,
 0x21d1, 0x21d2, 0x21d3, 0x2894, 0x2895, 0x2896, 0x2897, 0x2898,
 0x2899, 0x289a, 0x289b, 0x289c, 0x289d, 0x289e, 0x289f, 0x28c0,
 0x28c1, 0x28c2, 0x28c3, 0x28c4, 0x28c5, 0x28c6, 0x28c7, 0x28c8,
 0x28c9, 0x28ca, 0x28cb, 0x2930, 0x2931, 0x2932, 0x2933, 0x2934,
 0x2935, 0x2936, 0x2937, 0x2938, 0x2939, 0x293a, 0x293b, 0x293c,
 0x293d, 0x293e, 0x293f, 0x2960, 0x2961, 0x2962, 0x2963, 0x2964,
 0x2965, 0x2966, 0x2967, 0x2968, 0x2969, 0x296a, 0x296b, 0x2a40,
 0x2a41, 0x2a42, 0x2a43, 0x2a44, 0x2a45, 0x2a46, 0x2a47, 0x2a48,
 0x2a49, 0x2a4a, 0x2a4b, 0x2a4c, 0x2a4d, 0x2a4e, 0x2a4f, 0x2a50,
 0x2a51, 0x2a52, 0x2a53, 0x2ae6, 0x2ae7, 0x2b24, 0x2b25, 0x2b26,
 0x2b27, 0x2b28, 0x2b29, 0x2b2a, 0x2b2b, 0x2b2c, 0x2b2d, 0x2b2e,
 0x2b2f, 0x2b30, 0x2b31, 0x2b32, 0x2b33, 0x2b5a, 0x2b5b, 0x3014,
 0x3015, 0x3016, 0x3017, 0x3020, 0x3021, 0x3022, 0x3023, 0x3024,
 0x3025, 0x3026, 0x3027, 0x3028, 0x3029, 0x302a, 0x302b, 0x302c,
 0x302d, 0x302e, 0x302f, 0x3030, 0x3031, 0x3032, 0x3033, 0x3034,
 0x3035, 0x3036, 0x3037, 0x3038, 0x3039, 0x30c0, 0x30c1, 0x30de,
 0x30df, 0x3218, 0x3219, 0x321a, 0x321b, 0x321c, 0x321d, 0x321e,
 0x321f, 0x3220, 0x3221, 0x3222, 0x3223, 0x3224, 0x3225, 0x3226,
 0x3227, 0x3228, 0x3229, 0x322a, 0x322b, 0x322c, 0x322d, 0x322e,
 0x322f, 0x3230, 0x3231, 0x3232, 0x3233, 0x3234, 0x3235, 0x3378,
 0x3379, 0x337a, 0x337b, 0x337c, 0x337d, 0x337e, 0x337f, 0x33c0,
 0x33c1, 0x33c2, 0x33c3, 0x33c4, 0x33c5, 0x33c6, 0x33c7, 0x33c8,
 0x33c9, 0x33ca, 0x33cb, 0x33cc, 0x33cd, 0x33ce, 0x33cf, 0x33d0,
 0x33d1, 0x33d2, 0x33d3, 0x33d4, 0x33d5, 0x33d6, 0x33d7, 0x33d8,
 0x33d9, 0x3706, 0x3707, 0x3730, 0x3731, 0x3732, 0x3733, 0x3734,
 0x3735, 0x3736, 0x3737, 0x3738, 0x3739, 0x373a, 0x373b, 0x373c,
 0x373d, 0x373e, 0x373f, 0x3740, 0x3741, 0x3742, 0x3743, 0x3744,
 0x3745, 0x3746, 0x3747, 0x3748, 0x3749, 0x374a, 0x374b, 0x374c,
 0x374d, 0x374e, 0x374f, 0x3b34, 0x3b35, 0x3b36, 0x3b37, 0x3be8,
 0x3be9, 0x3bea, 0x3beb, 0x3bec, 0x3bed, 0x3bee, 0x3bef, 0x3bf0,
 0x3bf1, 0x3bf2, 0x3bf3, 0x3bf4, 0x3bf5, 0x3bf6, 0x3bf7, 0x3bf8,
 0x3bf9, 0x3bfa, 0x3bfb, 0x3bfc, 0x3bfd, 0x3bfe, 0x3bff, 0x2000,
 0x2001, 0x2002, 0x2003, 0x2004, 0x2005, 0x2006, 0x2007, 0x2008,
 0x2009, 0x200a, 0x200b, 0x200c, 0x200d, 0x202e, 0x202f, 0x2182,
 0x2183, 0x21b4, 0x21b5, 0x21b6, 0x21b7, 0x21b8, 0x21b9, 0x21ba,
 0x21bb, 0x21bc, 0x21bd, 0x21be, 0x21bf, 0x2460, 0x2461, 0x2462,
 0x2463, 0x2464, 0x2465, 0x2466, 0x2467, 0x2468, 0x2469, 0x246a,
 0x246b, 0x246c, 0x246d, 0x246e, 0x246f, 0x2470, 0x2471, 0x2472,
 0x2473, 0x26a2, 0x26a3, 0x000b,

################################################################################

TITLE
    libavcodec msmpeg4 table0_mv_code

TYPE
    16

DATA
 0x0001, 0x0003, 0x0005, 0x0007, 0x0003, 0x0008, 0x000c, 0x0001,
 0x0002, 0x001b, 0x0006, 0x000b, 0x0015, 0x0002, 0x000e, 0x000f,
 0x0014, 0x0020, 0x0022, 0x0025, 0x0027, 0x0029, 0x002d, 0x004b,
 0x004d, 0x0003, 0x0022, 0x0023, 0x0025, 0x0027, 0x0042, 0x0048,
 0x0049, 0x0050, 0x005c, 0x0091, 0x009f, 0x000e, 0x0043, 0x004c,
 0x0054, 0x0056, 0x008c, 0x0098, 0x009a, 0x009b, 0x00b1, 0x00b2,
 0x0120, 0x0121, 0x0126, 0x0133, 0x0139, 0x01a1, 0x01a4, 0x01a5,
 0x01a6, 0x01a7, 0x01ae, 0x01af, 0x000b, 0x0019, 0x0085, 0x0090,
 0x009b, 0x00aa, 0x00af, 0x010c, 0x010e, 0x011c, 0x011e, 0x0133,
 0x0144, 0x0160, 0x0174, 0x0175, 0x0177, 0x0178, 0x0249, 0x024b,
 0x0252, 0x0261, 0x0265, 0x0270, 0x0352, 0x0353, 0x0355, 0x0359,
 0x0010, 0x0011, 0x0013, 0x0034, 0x0035, 0x0036, 0x0037, 0x003d,
 0x003e, 0x0109, 0x0126, 0x0156, 0x021a, 0x021e, 0x023a, 0x023e,
 0x028e, 0x028f, 0x02cf, 0x0491, 0x0494, 0x049f, 0x04a0, 0x04a3,
 0x04a6, 0x04a7, 0x04ad, 0x04ae, 0x04c0, 0x04c4, 0x04c6, 0x04c8,
 0x04c9, 0x04f5, 0x04f6, 0x04f7, 0x0680, 0x0682, 0x0683, 0x0688,
 0x0689, 0x068d, 0x068e, 0x068f, 0x06a2, 0x06a3, 0x06a9, 0x06b0,
 0x06b1, 0x06b4, 0x06b5, 0x0024, 0x0060, 0x0063, 0x0078, 0x0079,
 0x0211, 0x0244, 0x0245, 0x0247, 0x0248, 0x0249, 0x024a, 0x024b,
 0x026b, 0x02af, 0x02b8, 0x02bb, 0x0436, 0x0476, 0x0477, 0x047e,
 0x04c8, 0x04c9, 0x04ca, 0x0514, 0x0586, 0x0587, 0x0598, 0x059d,
 0x05d9, 0x05da, 0x0920, 0x0921, 0x093b, 0x093c, 0x093d, 0x0942,
 0x0943, 0x0944, 0x0945, 0x0959, 0x095e, 0x095f, 0x0982, 0x0983,
 0x098e, 0x098f, 0x09c4, 0x09e7, 0x09e8, 0x09e9, 0x0d02, 0x0d17,
 0x0d18, 0x0d19, 0x0d41, 0x0d42, 0x0d43, 0x0d50, 0x0d5f, 0x0d6d,
 0x0d6e, 0x0d6f, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057,
 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x041e, 0x041f, 0x0420, 0x0421,
 0x048c, 0x048d, 0x04d3, 0x04d4, 0x04d5, 0x055c, 0x055d, 0x0572,
 0x0573, 0x0574, 0x0575, 0x08de, 0x08df, 0x08fe, 0x08ff, 0x0996,
 0x0a36, 0x0a37, 0x0b08, 0x0b09, 0x0b0a, 0x0b0b, 0x0b32, 0x0b33,
 0x0b34, 0x0b35, 0x0b36, 0x0b37, 0x0b38, 0x0b39, 0x0bb0, 0x0bf7,
 0x0bf8, 0x0bf9, 0x0bfa, 0x0bfb, 0x0bfc, 0x0bfd, 0x0bfe, 0x0bff,
 0x1254, 0x1255, 0x1256, 0x1257, 0x1270, 0x1271, 0x1272, 0x1273,
 0x1274, 0x1275, 0x12ab, 0x12ac, 0x12ad, 0x12ae, 0x12af, 0x12b0,
 0x12b1, 0x1315, 0x1316, 0x1317, 0x13bf, 0x13c0, 0x13c1, 0x13c2,
 0x13c3, 0x13c4, 0x13c5, 0x13c6, 0x13c7, 0x13c8, 0x13c9, 0x13ca,
 0x13cb, 0x13cc, 0x13cd, 0x1a06, 0x1a07, 0x1a28, 0x1a29, 0x1a2a,
 0x1a2b, 0x1a2c, 0x1a2d, 0x1a80, 0x1abb, 0x1abc, 0x1abd, 0x1ad8,
 0x1ad9, 0x0094, 0x0095, 0x0096, 0x0097, 0x00a0, 0x00a1, 0x00a2,
 0x00a3, 0x0831, 0x0832, 0x0833, 0x0834, 0x0835, 0x0836, 0x0837,
 0x0838, 0x0839, 0x083a, 0x083b, 0x0939, 0x093a, 0x093b, 0x093c,
 0x093d, 0x093e, 0x093f, 0x09a0, 0x09a1, 0x09a2, 0x09a3, 0x09a4,
 0x09a5, 0x11ac, 0x11ad, 0x11ae, 0x11af, 0x11b0, 0x11b1, 0x11b2,
 0x11b3, 0x11b4, 0x11b5, 0x11b6, 0x11b7, 0x11b8, 0x11b9, 0x11ba,
 0x11bb, 0x132f, 0x1454, 0x1455, 0x1456, 0x1457, 0x1458, 0x1459,
 0x145a, 0x145b, 0x145c, 0x145d, 0x145e, 0x145f, 0x1460, 0x1461,
 0x1462, 0x1463, 0x1464, 0x1465, 0x1466, 0x1467, 0x1468, 0x1469,
 0x146a, 0x146b, 0x17de, 0x17df, 0x17e0, 0x17e1, 0x17e2, 0x17e3,
 0x17e4, 0x17e5, 0x17e6, 0x17e7, 0x17e8, 0x17e9, 0x17ea, 0x17eb,
 0x17ec, 0x17ed, 0x2540, 0x2541, 0x2542, 0x2543, 0x2544, 0x2545,
 0x2546, 0x2547, 0x2548, 0x2549, 0x254a, 0x254b, 0x254c, 0x254d,
 0x254e, 0x254f, 0x2550, 0x2551, 0x2552, 0x2553, 0x2554, 0x2555,
 0x2628, 0x2766, 0x2767, 0x2768, 0x2769, 0x276a, 0x276b, 0x276c,
 0x276d, 0x276e, 0x276f, 0x2770, 0x2771, 0x2772, 0x2773, 0x2774,
 0x2775, 0x2776, 0x2777, 0x2778, 0x2779, 0x277a, 0x277b, 0x277c,
 0x277d, 0x3503, 0x3544, 0x3545, 0x3546, 0x3547, 0x3560, 0x3561,
 0x3562, 0x3563, 0x3564, 0x3565, 0x3566, 0x3567, 0x3568, 0x3569,
 0x356a, 0x356b, 0x356c, 0x356d, 0x356e, 0x356f, 0x3570, 0x3571,
 0x3572, 0x3573, 0x3574, 0x3575, 0x03f0, 0x103d, 0x103e, 0x103f,
 0x1040, 0x1041, 0x1042, 0x1043, 0x1044, 0x1045, 0x1046, 0x1047,
 0x1048, 0x1049, 0x104a, 0x104b, 0x104c, 0x104d, 0x104e, 0x104f,
 0x1050, 0x1051, 0x1052, 0x1053, 0x1054, 0x1055, 0x1056, 0x1057,
 0x1058, 0x1059, 0x105a, 0x105b, 0x105c, 0x105d, 0x105e, 0x105f,
 0x1060, 0x1061, 0x1270, 0x1271, 0x21b8, 0x21b9, 0x21ba, 0x21bb,
 0x21bc, 0x21bd, 0x21be, 0x21bf, 0x21f0, 0x21f1, 0x21f2, 0x21f3,
 0x21f4, 0x21f5, 0x21f6, 0x21f7, 0x21f8, 0x21f9, 0x21fa, 0x21fb,
 0x21fc, 0x21fd, 0x21fe, 0x21ff, 0x2340, 0x2341, 0x2342, 0x2343,
 0x2344, 0x2345, 0x2346, 0x2347, 0x2348, 0x2349, 0x234a, 0x234b,
 0x234c, 0x234d, 0x234e, 0x234f, 0x2350, 0x2351, 0x2352, 0x2353,
 0x2354, 0x2355, 0x2356, 0x2357, 0x265c, 0x2f88, 0x2f89, 0x2f8a,
 0x2f8b, 0x2f8c, 0x2f8d, 0x2f8e, 0x2f8f, 0x2f90, 0x2f91, 0x2f92,
 0x2f93, 0x2f94, 0x2f95, 0x2f96, 0x2f97, 0x2f98, 0x2f99, 0x2f9a,
 0x2f9b, 0x2f9c, 0x2f9d, 0x2f9e, 0x2f9f, 0x2fa0, 0x2fa1, 0x2fa2,
 0x2fa3, 0x2fa4, 0x2fa5, 0x2fa6, 0x2fa7, 0x2fa8, 0x2fa9, 0x2faa,
 0x2fab, 0x2fac, 0x2fad, 0x2fae, 0x2faf, 0x2fb0, 0x2fb1, 0x2fb2,
 0x2fb3, 0x2fb4, 0x2fb5, 0x2fb6, 0x2fb7, 0x2fb8, 0x2fb9, 0x2fba,
 0x2fbb, 0x4c52, 0x4c53, 0x4e28, 0x4e29, 0x4e2a, 0x4e2b, 0x4e2c,
 0x4e2d, 0x4e2e, 0x4e2f, 0x4e30, 0x4e31, 0x4e32, 0x4e33, 0x4e34,
 0x4e35, 0x4e36, 0x4e37, 0x4e38, 0x4e39, 0x4e3a, 0x4e3b, 0x4e3c,
 0x4e3d, 0x4e3e, 0x4e3f, 0x4e80, 0x4e81, 0x4e82, 0x4e83, 0x4e84,
 0x4e85, 0x4e86, 0x4e87, 0x4e88, 0x4e89, 0x4e8a, 0x4e8b, 0x4e8c,
 0x4e8d, 0x4e8e, 0x4e8f, 0x4e90, 0x4e91, 0x4e92, 0x4e93, 0x4e94,
 0x4e95, 0x4e96, 0x4e97, 0x4e98, 0x4e99, 0x4e9a, 0x4e9b, 0x4e9c,
 0x4e9d, 0x4e9e, 0x4e9f, 0x4ea0, 0x4ea1, 0x4ea2, 0x4ea3, 0x4ea4,
 0x4ea5, 0x4ea6, 0x4ea7, 0x4ea8, 0x4ea9, 0x4eaa, 0x4eab, 0x4eac,
 0x4ead, 0x4eae, 0x4eaf, 0x4eb0, 0x4eb1, 0x4eb2, 0x4eb3, 0x4eb4,
 0x4eb5, 0x4eb6, 0x4eb7, 0x4eb8, 0x4eb9, 0x4eba, 0x4ebb, 0x4ebc,
 0x4ebd, 0x4ebe, 0x4ebf, 0x4ec0, 0x4ec1, 0x4ec2, 0x4ec3, 0x4ec4,
 0x4ec5, 0x4ec6, 0x4ec7, 0x4ec8, 0x4ec9, 0x4eca, 0x4ecb, 0x6a04,
 0x6a05, 0x07e2, 0x07e3, 0x07e4, 0x07e5, 0x07e6, 0x07e7, 0x07e8,
 0x07e9, 0x07ea, 0x07eb, 0x07ec, 0x07ed, 0x07ee, 0x07ef, 0x07f0,
 0x07f1, 0x07f2, 0x07f3, 0x07f4, 0x07f5, 0x07f6, 0x07f7, 0x07f8,
 0x07f9, 0x07fa, 0x07fb, 0x07fc, 0x07fd, 0x07fe, 0x07ff, 0x2000,
 0x2001, 0x2002, 0x2003, 0x2004, 0x2005, 0x2006, 0x2007, 0x2008,
 0x2009, 0x200a, 0x200b, 0x200c, 0x200d, 0x200e, 0x200f, 0x2010,
 0x2011, 0x2012, 0x2013, 0x2014, 0x2015, 0x2016, 0x2017, 0x2018,
 0x2019, 0x201a, 0x201b, 0x201c, 0x201d, 0x201e, 0x201f, 0x2020,
 0x2021, 0x2022, 0x2023, 0x2024, 0x2025, 0x2026, 0x2027, 0x2028,
 0x2029, 0x202a, 0x202b, 0x202c, 0x202d, 0x202e, 0x202f, 0x2030,
 0x2031, 0x2032, 0x2033, 0x2034, 0x2035, 0x2036, 0x2037, 0x2038,
 0x2039, 0x203a, 0x203b, 0x203c, 0x203d, 0x203e, 0x203f, 0x2040,
 0x2041, 0x2042, 0x2043, 0x2044, 0x2045, 0x2046, 0x2047, 0x2048,
 0x2049, 0x204a, 0x204b, 0x204c, 0x204d, 0x204e, 0x204f, 0x2050,
 0x2051, 0x2052, 0x2053, 0x2054, 0x2055, 0x2056, 0x2057, 0x2058,
 0x2059, 0x205a, 0x205b, 0x205c, 0x205d, 0x205e, 0x205f, 0x2060,
 0x2061, 0x2062, 0x2063, 0x2064, 0x2065, 0x2066, 0x2067, 0x2068,
 0x2069, 0x206a, 0x206b, 0x206c, 0x206d, 0x206e, 0x206f, 0x2070,
 0x2071, 0x2072, 0x2073, 0x2074, 0x2075, 0x2076, 0x2077, 0x2078,
 0x2079, 0x4cba, 0x4cbb, 0x5d88, 0x5d89, 0x5d8a, 0x5d8b, 0x5d8c,
 0x5d8d, 0x5d8e, 0x5d8f, 0x5db0, 0x5db1, 0x5db2, 0x5db3, 0x5db4,
 0x5db5, 0x5db6, 0x5db7, 0x5db8, 0x5db9, 0x5dba, 0x5dbb, 0x5dbc,
 0x5dbd, 0x5dbe, 0x5dbf, 0x5e40, 0x5e41, 0x5e42, 0x5e43, 0x5e44,
 0x5e45, 0x5e46, 0x5e47, 0x5e48, 0x5e49, 0x5e4a, 0x5e4b, 0x5e4c,
 0x5e4d, 0x5e4e, 0x5e4f, 0x5e50, 0x5e51, 0x5e52, 0x5e53, 0x5e54,
 0x5e55, 0x5e56, 0x5e57, 0x5e58, 0x5e59, 0x5e5a, 0x5e5b, 0x5e5c,
 0x5e5d, 0x5e5e, 0x5e5f, 0x5e60, 0x5e61, 0x5e62, 0x5e63, 0x5e64,
 0x5e65, 0x5e66, 0x5e67, 0x5e68, 0x5e69, 0x5e6a, 0x5e6b, 0x5e6c,
 0x5e6d, 0x5e6e, 0x5e6f, 0x5e70, 0x5e71, 0x5e72, 0x5e73, 0x5e74,
 0x5e75, 0x5e76, 0x5e77, 0x5e78, 0x5e79, 0x5e7a, 0x5e7b, 0x5e7c,
 0x5e7d, 0x5e7e, 0x5e7f, 0x5e80, 0x5e81, 0x5e82, 0x5e83, 0x5e84,
 0x5e85, 0x5e86, 0x5e87, 0x5e88, 0x5e89, 0x5e8a, 0x5e8b, 0x5e8c,
 0x5e8d, 0x5e8e, 0x5e8f, 0x5e90, 0x5e91, 0x5e92, 0x5e93, 0x5e94,
 0x5e95, 0x5e96, 0x5e97, 0x5e98, 0x5e99, 0x5e9a, 0x5e9b, 0x5e9c,
 0x5e9d, 0x5e9e, 0x5e9f, 0x5ea0, 0x5ea1, 0x5ea2, 0x5ea3, 0x5ea4,
 0x5ea5, 0x5ea6, 0x5ea7, 0x5ea8, 0x5ea9, 0x5eaa, 0x5eab, 0x5eac,
 0x5ead, 0x5eae, 0x5eaf, 0x5eb0, 0x5eb1, 0x5eb2, 0x5eb3, 0x5eb4,
 0x5eb5, 0x5eb6, 0x5eb7, 0x5eb8, 0x5eb9, 0x5eba, 0x5ebb, 0x5ebc,
 0x5ebd, 0x5ebe, 0x5ebf, 0x5ec0, 0x5ec1, 0x5ec2, 0x5ec3, 0x5ec4,
 0x5ec5, 0x5ec6, 0x5ec7, 0x5ec8, 0x5ec9, 0x5eca, 0x5ecb, 0x5ecc,
 0x5ecd, 0x5ece, 0x5ecf, 0x5ed0, 0x5ed1, 0x5ed2, 0x5ed3, 0x5ed4,
 0x5ed5, 0x5ed6, 0x5ed7, 0x5ed8, 0x5ed9, 0x5eda, 0x5edb, 0x5edc,
 0x5edd, 0x5ede, 0x5edf, 0x5ee0, 0x5ee1, 0x5ee2, 0x5ee3, 0x5ee4,
 0x5ee5, 0x5ee6, 0x5ee7, 0x5ee8, 0x5ee9, 0x5eea, 0x5eeb, 0x5eec,
 0x5eed, 0x5eee, 0x5eef, 0x5ef0, 0x5ef1, 0x5ef2, 0x5ef3, 0x5ef4,
 0x5ef5, 0x5ef6, 0x5ef7, 0x5ef8, 0x5ef9, 0x5efa, 0x5efb, 0x5efc,
 0x5efd, 0x5efe, 0x5eff, 0x5f00, 0x5f01, 0x5f02, 0x5f03, 0x5f04,
 0x5f05, 0x5f06, 0x5f07, 0x5f08, 0x5f09, 0x5f0a, 0x5f0b, 0x5f0c,
 0x5f0d, 0x5f0e, 0x5f0f, 0x0000,

################################################################################

TITLE
    libavcodec ff_nelly_dequantization_table

TYPE
    FLOAT

DATA
 0.0000000000,

-0.8472560048, 0.7224709988,

-1.5247479677,-0.4531480074, 0.3753609955, 1.4717899561,

-1.9822579622,-1.1929379702,-0.5829370022,-0.0693780035, 0.3909569979, 0.9069200158, 1.4862740040, 2.2215409279,

-2.3887870312,-1.8067539930,-1.4105420113,-1.0773609877,-0.7995010018,-0.5558109879,-0.3334020078,-0.1324490011,
 0.0568020009, 0.2548770010, 0.4773550034, 0.7386850119, 1.0443060398, 1.3954459429, 1.8098750114, 2.3918759823,

-2.3893830776,-1.9884680510,-1.7514040470,-1.5643119812,-1.3922129869,-1.2164649963,-1.0469499826,-0.8905100226,
-0.7645580173,-0.6454579830,-0.5259280205,-0.4059549868,-0.3029719889,-0.2096900046,-0.1239869967,-0.0479229987,
 0.0257730000, 0.1001340002, 0.1737180054, 0.2585540116, 0.3522900045, 0.4569880068, 0.5767750144, 0.7003160119,
 0.8425520062, 1.0093879700, 1.1821349859, 1.3534560204, 1.5320819616, 1.7332619429, 1.9722349644, 2.3978140354,

-2.5756309032,-2.0573320389,-1.8984919786,-1.7727810144,-1.6662600040,-1.5742180347,-1.4993319511,-1.4316639900,
-1.3652280569,-1.3000990152,-1.2280930281,-1.1588579416,-1.0921250582,-1.0135740042,-0.9202849865,-0.8287050128,
-0.7374889851,-0.6447759867,-0.5590940118,-0.4857139885,-0.4110319912,-0.3459700048,-0.2851159871,-0.2341620028,
-0.1870580018,-0.1442500055,-0.1107169986,-0.0739680007,-0.0365610011,-0.0073290002, 0.0203610007, 0.0479039997,
 0.0751969963, 0.0980999991, 0.1220389977, 0.1458999962, 0.1694349945, 0.1970459968, 0.2252430022, 0.2556869984,
 0.2870100141, 0.3197099864, 0.3525829911, 0.3889069855, 0.4334920049, 0.4769459963, 0.5204820037, 0.5644530058,
 0.6122040153, 0.6685929894, 0.7341650128, 0.8032159805, 0.8784040213, 0.9566209912, 1.0397069454, 1.1293770075,
 1.2211159468, 1.3080279827, 1.4024800062, 1.5056819916, 1.6227730513, 1.7724959850, 1.9430880547, 2.2903931141

################################################################################

TITLE
    libavcodec ff_nelly_init_table

TYPE
    16

DATA
3134, 5342, 6870, 7792, 8569, 9185, 9744, 10191, 10631, 11061, 11434, 11770,
12116, 12513, 12925, 13300, 13674, 14027, 14352, 14716, 15117, 15477, 15824,
16157, 16513, 16804, 17090, 17401, 17679, 17948, 18238, 18520, 18764, 19078,
19381, 19640, 19921, 20205, 20500, 20813, 21162, 21465, 21794, 22137, 22453,
22756, 23067, 23350, 23636, 23926, 24227, 24521, 24819, 25107, 25414, 25730,
26120, 26497, 26895, 27344, 27877, 28463, 29426, 31355

################################################################################

TITLE
    libavcodec ff_nelly_delta_table

TYPE
    16

DATA
-11725, -9420, -7910, -6801, -5948, -5233, -4599, -4039, -3507, -3030, -2596,
-2170, -1774, -1383, -1016, -660, -329, -1, 337, 696, 1085, 1512, 1962, 2433,
2968, 3569, 4314, 5279, 6622, 8154, 10076, 12975

################################################################################

TITLE
    libavcodec nuppelvideo fallback_lquant

TYPE
    8

DATA
    16,  11,  10,  16,  24,  40,  51,  61,
    12,  12,  14,  19,  26,  58,  60,  55,
    14,  13,  16,  24,  40,  57,  69,  56,
    14,  17,  22,  29,  51,  87,  80,  62,
    18,  22,  37,  56,  68, 109, 103,  77,
    24,  35,  55,  64,  81, 104, 113,  92,
    49,  64,  78,  87, 103, 121, 120, 101,
    72,  92,  95,  98, 112, 100, 103,  99

################################################################################

TITLE
    libavcodec qcelp_rate_full_codebook

TYPE
    16

DATA
     10,  -65,  -59,   12,  110,   34, -134,  157,
    104,  -84,  -34, -115,   23, -101,    3,   45,
   -101,  -16,  -59,   28,  -45,  134,  -67,   22,
     61,  -29,  226,  -26,  -55, -179,  157,  -51,
   -220,  -93,  -37,   60,  118,   74,  -48,  -95,
   -181,  111,   36,  -52, -215,   78, -112,   39,
    -17,  -47, -223,   19,   12,  -98, -142,  130,
     54, -127,   21,  -12,   39,  -48,   12,  128,
      6, -167,   82, -102,  -79,   55,  -44,   48,
    -20,  -53,    8,  -61,   11,  -70, -157, -168,
     20,  -56,  -74,   78,   33,  -63, -173,   -2,
    -75,  -53, -146,   77,   66,  -29,    9,  -75,
     65,  119,  -43,   76,  233,   98,  125, -156,
    -27,   78,   -9,  170,  176,  143, -148,   -7,
     27, -136,    5,   27,   18,  139,  204,    7,
   -184, -197,   52,   -3,   78, -189,    8,  -65

################################################################################

TITLE
    libavcodec qcelp_lspvq1

TYPE
    16

DATA
{ 327, 118},{ 919, 111},{ 427, 440},{1327, 185},
{ 469,  50},{1272,  91},{ 892,  59},{1771, 193},
{ 222, 158},{1100, 127},{ 827,  55},{ 978, 791},
{ 665,  47},{ 700,1401},{ 670, 859},{1913,1048},
{ 471, 215},{1046, 125},{ 645, 298},{1599, 160},
{ 593,  39},{1187, 462},{ 749, 341},{1520, 511},
{ 290, 792},{ 909, 362},{ 753,  81},{1111,1058},
{ 519, 253},{ 828, 839},{ 685, 541},{1421,1258},
{ 386, 130},{ 962, 119},{ 542, 387},{1431, 185},
{ 526,  51},{1175, 260},{ 831, 167},{1728, 510},
{ 273, 437},{1172, 113},{ 771, 144},{1122, 751},
{ 619, 119},{ 492,1276},{ 658, 695},{1882, 615},
{ 415, 200},{1018,  88},{ 681, 339},{1436, 325},
{ 555, 122},{1042, 485},{ 826, 345},{1374, 743},
{ 383,1018},{1005, 358},{ 704,  86},{1301, 586},
{ 597, 241},{ 832, 621},{ 555, 573},{1504, 839}};

################################################################################

TITLE
    libavcodec qcelp_lspvq2

TYPE
    16

DATA
{ 255, 293},{ 904, 219},{ 151,1211},{1447, 498},
{ 470, 253},{1559, 177},{1547, 994},{2394, 242},
{  91, 813},{ 857, 590},{ 934,1326},{1889, 282},
{ 813, 472},{1057,1494},{ 450,3315},{2163,1895},
{ 538, 532},{1399, 218},{ 146,1552},{1755, 626},
{ 822, 202},{1299, 663},{ 706,1732},{2656, 401},
{ 418, 745},{ 762,1038},{ 583,1748},{1746,1285},
{ 527,1169},{1314, 830},{ 556,2116},{1073,2321},
{ 297, 570},{ 981, 403},{ 468,1103},{1740, 243},
{ 725, 179},{1255, 474},{1374,1362},{1922, 912},
{ 285, 947},{ 930, 700},{ 593,1372},{1909, 576},
{ 588, 916},{1110,1116},{ 224,2719},{1633,2220},
{ 402, 520},{1061, 448},{ 402,1352},{1499, 775},
{ 664, 589},{1081, 727},{ 801,2206},{2165,1157},
{ 566, 802},{ 911,1116},{ 306,1703},{1792, 836},
{ 655, 999},{1061,1038},{ 298,2089},{1110,1753},
{ 361, 311},{ 970, 239},{ 265,1231},{1495, 573},
{ 566, 262},{1569, 293},{1341,1144},{2271, 544},
{ 214, 877},{ 847, 719},{ 794,1384},{2067, 274},
{ 703, 688},{1099,1306},{ 391,2947},{2024,1670},
{ 471, 525},{1245, 290},{ 264,1557},{1568, 807},
{ 718, 399},{1193, 685},{ 883,1594},{2729, 764},
{ 500, 754},{ 809,1108},{ 541,1648},{1523,1385},
{ 614,1196},{1209, 847},{ 345,2242},{1442,1747},
{ 199, 560},{1092, 194},{ 349,1253},{1653, 507},
{ 625, 354},{1376, 431},{1187,1465},{2164, 872},
{ 360, 974},{1008, 698},{ 704,1346},{2114, 452},
{ 720, 816},{1240,1089},{ 439,2475},{1498,2040},
{ 336, 718},{1213, 187},{ 451,1450},{1368, 885},
{ 592, 578},{1131, 531},{ 861,1855},{1764,1500},
{ 444, 970},{ 935, 903},{ 424,1687},{1633,1102},
{ 793, 897},{1060, 897},{ 185,2011},{1205,1855}};

################################################################################

TITLE
    libavcodec qcelp_lspvq3

TYPE
    16

DATA
{ 225, 283},{1296, 355},{ 543, 343},{2073, 274},
{ 204,1099},{1562, 523},{1388, 161},{2784, 274},
{ 112, 849},{1870, 175},{1189, 160},{1490,1088},
{ 969,1115},{ 659,3322},{1158,1073},{3183,1363},
{ 517, 223},{1740, 223},{ 704, 387},{2637, 234},
{ 692,1005},{1287,1610},{ 952, 532},{2393, 646},
{ 490, 552},{1619, 657},{ 845, 670},{1784,2280},
{ 191,1775},{ 272,2868},{ 942, 952},{2628,1479},
{ 278, 579},{1565, 218},{ 814, 180},{2379, 187},
{ 276,1444},{1199,1223},{1200, 349},{3009, 307},
{ 312, 844},{1898, 306},{ 863, 470},{1685,1241},
{ 513,1727},{ 711,2233},{1085, 864},{3398, 527},
{ 414, 440},{1356, 612},{ 964, 147},{2173, 738},
{ 465,1292},{ 877,1749},{1104, 689},{2105,1311},
{ 580, 864},{1895, 752},{ 652, 609},{1485,1699},
{ 514,1400},{ 386,2131},{ 933, 798},{2473, 986},
{ 334, 360},{1375, 398},{ 621, 276},{2183, 280},
{ 311,1114},{1382, 807},{1284, 175},{2605, 636},
{ 230, 816},{1739, 408},{1074, 176},{1619,1120},
{ 784,1371},{ 448,3050},{1189, 880},{3039,1165},
{ 424, 241},{1672, 186},{ 815, 333},{2432, 324},
{ 584,1029},{1137,1546},{1015, 585},{2198, 995},
{ 574, 581},{1746, 647},{ 733, 740},{1938,1737},
{ 347,1710},{ 373,2429},{ 787,1061},{2439,1438},
{ 185, 536},{1489, 178},{ 703, 216},{2178, 487},
{ 154,1421},{1414, 994},{1103, 352},{3072, 473},
{ 408, 819},{2055, 168},{ 998, 354},{1917,1140},
{ 665,1799},{ 993,2213},{1234, 631},{3003, 762},
{ 373, 620},{1518, 425},{ 913, 300},{1966, 836},
{ 402,1185},{ 948,1385},{1121, 555},{1802,1509},
{ 474, 886},{1888, 610},{ 739, 585},{1231,2379},
{ 661,1335},{ 205,2211},{ 823, 822},{2480,1179}};

################################################################################

TITLE
    libavcodec qcelp_lspvq4

TYPE
    16

DATA
{ 348, 311},{ 812,1145},{ 552, 461},{1826, 263},
{ 601, 675},{1730, 172},{1523, 193},{2449, 277},
{ 334, 668},{ 805,1441},{1319, 207},{1684, 910},
{ 582,1318},{1403,1098},{ 979, 832},{2700,1359},
{ 624, 228},{1292, 979},{ 800, 195},{2226, 285},
{ 730, 862},{1537, 601},{1115, 509},{2720, 354},
{ 218,1167},{1212,1538},{1074, 247},{1674,1710},
{ 322,2142},{1263, 777},{ 981, 556},{2119,1710},
{ 193, 596},{1035, 957},{ 694, 397},{1997, 253},
{ 743, 603},{1584, 321},{1346, 346},{2221, 708},
{ 451, 732},{1040,1415},{1184, 230},{1853, 919},
{ 310,1661},{1625, 706},{ 856, 843},{2902, 702},
{ 467, 348},{1108,1048},{ 859, 306},{1964, 463},
{ 560,1013},{1425, 533},{1142, 634},{2391, 879},
{ 397,1084},{1345,1700},{ 976, 248},{1887,1189},
{ 644,2087},{1262, 603},{ 877, 550},{2203,1307}};

################################################################################

TITLE
    libavcodec qcelp_lspvq5

TYPE
    16

DATA
{ 360, 222},{ 820,1097},{ 601, 319},{1656, 198},
{ 604, 513},{1552, 141},{1391, 155},{2474, 261},
{ 269, 785},{1463, 646},{1123, 191},{2015, 223},
{ 785, 844},{1202,1011},{ 980, 807},{3014, 793},
{ 570, 180},{1135,1382},{ 778, 256},{1901, 179},
{ 807, 622},{1461, 458},{1231, 178},{2028, 821},
{ 387, 927},{1496,1004},{ 888, 392},{2246, 341},
{ 295,1462},{1156, 694},{1022, 473},{2226,1364},
{ 210, 478},{1029,1020},{ 722, 181},{1730, 251},
{ 730, 488},{1465, 293},{1303, 326},{2595, 387},
{ 458, 584},{1569, 742},{1029, 173},{1910, 495},
{ 605,1159},{1268, 719},{ 973, 646},{2872, 428},
{ 443, 334},{ 835,1465},{ 912, 138},{1716, 442},
{ 620, 778},{1316, 450},{1186, 335},{1446,1665},
{ 486,1050},{1675,1019},{ 880, 278},{2214, 202},
{ 539,1564},{1142, 533},{ 984, 391},{2130,1089}};

################################################################################

TITLE
    libavcodec qdm2 fft_tone_sample_table

TYPE
    FLOAT

DATA
    { { .0100000000f,-.0037037037f,-.0020000000f,-.0069444444f,-.0018416207f },
      { .0416666667f, .0000000000f, .0000000000f,-.0208333333f,-.0123456791f },
      { .1250000000f, .0558035709f, .0330687836f,-.0164473690f,-.0097465888f },
      { .1562500000f, .0625000000f, .0370370370f,-.0062500000f,-.0037037037f },
      { .1996007860f, .0781250000f, .0462962948f, .0022727272f, .0013468013f },
      { .2000000000f, .0625000000f, .0370370373f, .0208333333f, .0074074073f },
      { .2127659619f, .0555555556f, .0329218097f, .0208333333f, .0123456791f },
      { .2173913121f, .0473484844f, .0280583613f, .0347222239f, .0205761325f },
      { .2173913121f, .0347222239f, .0205761325f, .0473484844f, .0280583613f },
      { .2127659619f, .0208333333f, .0123456791f, .0555555556f, .0329218097f },
      { .2000000000f, .0208333333f, .0074074073f, .0625000000f, .0370370370f },
      { .1996007860f, .0022727272f, .0013468013f, .0781250000f, .0462962948f },
      { .1562500000f,-.0062500000f,-.0037037037f, .0625000000f, .0370370370f },
      { .1250000000f,-.0164473690f,-.0097465888f, .0558035709f, .0330687836f },
      { .0416666667f,-.0208333333f,-.0123456791f, .0000000000f, .0000000000f },
      { .0100000000f,-.0069444444f,-.0018416207f,-.0037037037f,-.0020000000f } },

    { { .0050000000f,-.0200000000f, .0125000000f,-.3030303030f, .0020000000f },
      { .1041666642f, .0400000000f,-.0250000000f, .0333333333f,-.0200000000f },
      { .1250000000f, .0100000000f, .0142857144f,-.0500000007f,-.0200000000f },
      { .1562500000f,-.0006250000f,-.00049382716f,-.000625000f,-.00049382716f },
      { .1562500000f,-.0006250000f,-.00049382716f,-.000625000f,-.00049382716f },
      { .1250000000f,-.0500000000f,-.0200000000f, .0100000000f, .0142857144f },
      { .1041666667f, .0333333333f,-.0200000000f, .0400000000f,-.0250000000f },
      { .0050000000f,-.3030303030f, .0020000001f,-.0200000000f, .0125000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f } },

    { { .1428571492f, .1250000000f,-.0285714287f,-.0357142873f, .0208333333f },
      { .1818181818f, .0588235296f, .0333333333f, .0212765951f, .0100000000f },
      { .1818181818f, .0212765951f, .0100000000f, .0588235296f, .0333333333f },
      { .1428571492f,-.0357142873f, .0208333333f, .1250000000f,-.0285714287f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f } },

    { { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f },
      { .0000000000f, .0000000000f, .0000000000f, .0000000000f, .0000000000f } }

################################################################################

TITLE
    libavcodec qdm2 fft_tone_level_table

TYPE
    FLOAT

DATA
/* pow ~ (i > 46) ? 0 : (((((i & 1) ? 431 : 304) << (i >> 1))) / 1024.0); */
    0.17677669f, 0.42677650f, 0.60355347f, 0.85355347f,
    1.20710683f, 1.68359375f, 2.37500000f, 3.36718750f,
    4.75000000f, 6.73437500f, 9.50000000f, 13.4687500f,
    19.0000000f, 26.9375000f, 38.0000000f, 53.8750000f,
    76.0000000f, 107.750000f, 152.000000f, 215.500000f,
    304.000000f, 431.000000f, 608.000000f, 862.000000f,
    1216.00000f, 1724.00000f, 2432.00000f, 3448.00000f,
    4864.00000f, 6896.00000f, 9728.00000f, 13792.0000f,
    19456.0000f, 27584.0000f, 38912.0000f, 55168.0000f,
    77824.0000f, 110336.000f, 155648.000f, 220672.000f,
    311296.000f, 441344.000f, 622592.000f, 882688.000f,
    1245184.00f, 1765376.00f, 2490368.00f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
  }, {
/* pow = (i > 45) ? 0 : ((((i & 1) ? 431 : 304) << (i >> 1)) / 512.0); */
    0.59375000f, 0.84179688f, 1.18750000f, 1.68359375f,
    2.37500000f, 3.36718750f, 4.75000000f, 6.73437500f,
    9.50000000f, 13.4687500f, 19.0000000f, 26.9375000f,
    38.0000000f, 53.8750000f, 76.0000000f, 107.750000f,
    152.000000f, 215.500000f, 304.000000f, 431.000000f,
    608.000000f, 862.000000f, 1216.00000f, 1724.00000f,
    2432.00000f, 3448.00000f, 4864.00000f, 6896.00000f,
    9728.00000f, 13792.0000f, 19456.0000f, 27584.0000f,
    38912.0000f, 55168.0000f, 77824.0000f, 110336.000f,
    155648.000f, 220672.000f, 311296.000f, 441344.000f,
    622592.000f, 882688.000f, 1245184.00f, 1765376.00f,
    2490368.00f, 3530752.00f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f,
    0.00000000f, 0.00000000f, 0.00000000f, 0.00000000f

################################################################################

TITLE
    libavcodec qdm2 fft_tone_envelope_table

TYPE
    FLOAT

DATA
    { .009607375f, .038060248f, .084265202f, .146446645f, .222214907f, .308658302f,
      .402454883f, .500000060f, .597545207f, .691341758f, .777785182f, .853553414f,
      .915734828f, .961939812f, .990392685f, 1.00000000f, .990392625f, .961939752f,
      .915734768f, .853553295f, .777785063f, .691341639f, .597545087f, .500000000f,
      .402454853f, .308658272f, .222214878f, .146446615f, .084265172f, .038060218f,
      .009607345f },
    { .038060248f, .146446645f, .308658302f, .500000060f, .691341758f, .853553414f,
      .961939812f, 1.00000000f, .961939752f, .853553295f, .691341639f, .500000000f,
      .308658272f, .146446615f, .038060218f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f },
    { .146446645f, .500000060f, .853553414f, 1.00000000f, .853553295f, .500000000f,
      .146446615f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f },
    { .500000060f, 1.00000000f, .500000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f, .000000000f, .000000000f, .000000000f, .000000000f, .000000000f,
      .000000000f }

################################################################################

TITLE
    libavcodec qdm2 sb_noise_attenuation

TYPE
    FLOAT

DATA
    0.0f, 0.0f, 0.3f, 0.4f, 0.5f, 0.7f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f,
    1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f,

################################################################################

TITLE
    libavcodec real audio 144 cb1_base

TYPE
    16

DATA
    19657, 18474, 18365, 17520, 21048, 18231, 18584, 16671,
    20363, 19069, 19409, 18430, 21844, 18753, 19613, 17411,
    20389, 21772, 20129, 21702, 20978, 20472, 19627, 19387,
    21477, 23134, 21841, 23919, 22089, 21519, 21134, 20852,
    19675, 17821, 19044, 17477, 19986, 16955, 18446, 16086,
    21138, 18899, 20952, 18929, 21452, 17833, 20104, 17159,
    19770, 20056, 20336, 20866, 19329, 18217, 18908, 18004,
    21556, 21948, 23079, 23889, 20922, 19544, 20984, 19781,
    19781, 20984, 19544, 20922, 23889, 23079, 21948, 21556,
    18004, 18908, 18217, 19329, 20866, 20336, 20056, 19770,
    17159, 20104, 17833, 21452, 18929, 20952, 18899, 21138,
    16086, 18446, 16955, 19986, 17477, 19044, 17821, 19675,
    20852, 21134, 21519, 22089, 23919, 21841, 23134, 21477,
    19387, 19627, 20472, 20978, 21702, 20129, 21772, 20389,
    17411, 19613, 18753, 21844, 18430, 19409, 19069, 20363,
    16671, 18584, 18231, 21048, 17520, 18365, 18474, 19657,

################################################################################

TITLE
    libavcodec real audio 144 cb2_base

TYPE
    16

DATA
    12174, 13380, 13879, 13832, 13170, 13227, 13204, 12053,
    12410, 13988, 14348, 14631, 13100, 13415, 13224, 12268,
    11982, 13825, 13499, 14210, 13877, 14788, 13811, 13109,
    11449, 13275, 12833, 13717, 12728, 13696, 12759, 12405,
    10230, 12185, 11628, 13161, 11762, 13458, 12312, 12818,
    10443, 12773, 12011, 14020, 11818, 13825, 12453, 13226,
    10446, 13162, 11881, 14300, 12859, 16288, 13490, 15053,
    10155, 12820, 11519, 13973, 12041, 15081, 12635, 14198,
    14198, 12635, 15081, 12041, 13973, 11519, 12820, 10155,
    15053, 13490, 16288, 12859, 14300, 11881, 13162, 10446,
    13226, 12453, 13825, 11818, 14020, 12011, 12773, 10443,
    12818, 12312, 13458, 11762, 13161, 11628, 12185, 10230,
    12405, 12759, 13696, 12728, 13717, 12833, 13275, 11449,
    13109, 13811, 14788, 13877, 14210, 13499, 13825, 11982,
    12268, 13224, 13415, 13100, 14631, 14348, 13988, 12410,
    12053, 13204, 13227, 13170, 13832, 13879, 13380, 12174,

################################################################################

TITLE
    libavcodec real audio 288 codetable

TYPE
    16

DATA
    {   668, -2950, -1254, -1790, -2553}, { -5032, -4577, -1045,  2908,  3318},
    { -2819, -2677,  -948, -2825, -4450}, { -6679,  -340,  1482, -1276,  1262},
    {  -562, -6757,  1281,   179, -1274}, { -2512, -7130, -4925,  6913,  2411},
    { -2478,  -156,  4683, -3873,     0}, { -8208,  2140,  -478, -2785,   533},
    {  1889,  2759,  1381, -6955, -5913}, {  5082, -2460, -5778,  1797,   568},
    { -2208, -3309, -4523, -6236, -7505}, { -2719,  4358, -2988, -1149,  2664},
    {  1259,   995,  2711, -2464,-10390}, {  1722, -7569, -2742,  2171, -2329},
    {  1032,   747,  -858, -7946,-12843}, {  3106,  4856, -4193, -2541,  1035},
    {  1862,  -960, -6628,   410,  5882}, { -2493, -2628, -4000,   -60,  7202},
    { -2672,  1446,  1536, -3831,  1233}, { -5302,  6912,  1589, -4187,  3665},
    { -3456, -8170, -7709,  1384,  4698}, { -4699, -6209,-11176,  8104, 16830},
    {   930,  7004,  1269, -8977,  2567}, {  4649, 11804,  3441, -5657,  1199},
    {  2542,  -183, -8859, -7976,  3230}, { -2872, -2011, -9713, -8385, 12983},
    {  3086,  2140, -3680, -9643, -2896}, { -7609,  6515, -2283, -2522,  6332},
    { -3333, -5620, -9130,-11131,  5543}, {  -407, -6721,-17466, -2889, 11568},
    {  3692,  6796,  -262,-10846, -1856}, {  7275, 13404, -2989,-10595,  4936},
    {   244, -2219,  2656,  3776, -5412}, { -4043, -5934,  2131,   863, -2866},
    { -3302,  1743, -2006,  -128, -2052}, { -6361,  3342, -1583,   -21,  1142},
    { -3837, -1831,  6397,  2545, -2848}, { -9332, -6528,  5309,  1986, -2245},
    { -4490,   748,  1935, -3027,  -493}, { -9255,  5366,  3193, -4493,  1784},
    {  4784,  -370,  1866,  1057, -1889}, {  7342, -2690, -2577,   676,  -611},
    {  -502,  2235, -1850, -1777, -2049}, {  1011,  3880, -2465,  2209,  -152},
    {  2592,  2829,  5588,  2839, -7306}, { -3049, -4918,  5955,  9201, -4447},
    {   697,  3908,  5798, -4451, -4644}, { -2121,  5444, -2570,   321, -1202},
    {  2846, -2086,  3532,   566,  -708}, { -4279,   950,  4980,  3749,   452},
    { -2484,  3502,  1719,  -170,   238}, { -3435,   263,  2114, -2005,  2361},
    { -7338, -1208,  9347, -1216, -4013}, {-13498,  -439,  8028, -4232,   361},
    { -3729,  5433,  2004, -4727, -1259}, { -3986,  7743,  8429, -3691,  -987},
    {  5198,  -423,  1150, -1281,   816}, {  7409,  4109, -3949,  2690,    30},
    {  1246,  3055,   -35, -1370,  -246}, { -1489,  5635,  -678, -2627,  3170},
    {  4830, -4585,  2008, -1062,   799}, {  -129,   717,  4594, 14937, 10706},
    {   417,  2759,  1850, -5057, -1153}, { -3887,  7361, -5768,  4285,   666},
    {  1443,  -938,    20, -2119, -1697}, { -3712, -3402, -2212,   110,  2136},
    { -2952,    12, -1568, -3500, -1855}, { -1315, -1731,  1160,  -558,  1709},
    {    88, -4569,   194,  -454, -2957}, { -2839, -1666,  -273,  2084,  -155},
    {  -189, -2376,  1663, -1040, -2449}, { -2842, -1369,   636,  -248, -2677},
    {  1517,    79, -3013, -3669,  -973}, {  1913, -2493, -5312,  -749,  1271},
    { -2903, -3324, -3756, -3690, -1829}, { -2913, -1547, -2760, -1406,  1124},
    {  1844, -1834,   456,   706, -4272}, {   467, -4256, -1909,  1521,  1134},
    {  -127,  -994,  -637, -1491, -6494}, {   873, -2045, -3828, -2792,  -578},
    {  2311, -1817,  2632, -3052,  1968}, {   641,  1194,  1893,  4107,  6342},
    {   -45,  1198,  2160, -1449,  2203}, { -2004,  1713,  3518,  2652,  4251},
    {  2936, -3968,  1280,   131, -1476}, {  2827,     8, -1928,  2658,  3513},
    {  3199,  -816,  2687, -1741, -1407}, {  2948,  4029,   394,  -253,  1298},
    {  4286,    51, -4507,   -32,  -659}, {  3903,  5646, -5588, -2592,  5707},
    {  -606,  1234, -1607, -5187,   664}, {  -525,  3620, -2192, -2527,  1707},
    {  4297, -3251, -2283,   812, -2264}, {  5765,   528, -3287,  1352,  1672},
    {  2735,  1241, -1103, -3273, -3407}, {  4033,  1648, -2965, -1174,  1444},
    {    74,   918,  1999,   915, -1026}, { -2496, -1605,  2034,  2950,   229},
    { -2168,  2037,    15, -1264,  -208}, { -3552,  1530,   581,  1491,   962},
    { -2613, -2338,  3621, -1488, -2185}, { -1747,    81,  5538,  1432, -2257},
    { -1019,   867,   214, -2284, -1510}, { -1684,  2816,  -229,  2551, -1389},
    {  2707,   504,   479,  2783, -1009}, {  2517, -1487, -1596,   621,  1929},
    {  -148,  2206, -4288,  1292, -1401}, {  -527,  1243, -2731,  1909,  1280},
    {  2149, -1501,  3688,   610, -4591}, {  3306, -3369,  1875,  3636, -1217},
    {  2574,  2513,  1449, -3074, -4979}, {   814,  1826, -2497,  4234, -4077},
    {  1664,  -220,  3418,  1002,  1115}, {   781,  1658,  3919,  6130,  3140},
    {  1148,  4065,  1516,   815,   199}, {  1191,  2489,  2561,  2421,  2443},
    {   770, -5915,  5515,  -368, -3199}, {  1190,  1047,  3742,  6927, -2089},
    {   292,  3099,  4308,  -758, -2455}, {   523,  3921,  4044,  1386,    85},
    {  4367,  1006, -1252, -1466, -1383}, {  3852,  1579,   -77,  2064,   868},
    {  5109,  2919,  -202,   359,  -509}, {  3650,  3206,  2303,  1693,  1296},
    {  2905, -3907,   229, -1196, -2332}, {  5977, -3585,   805,  3825, -3138},
    {  3746,  -606,    53,  -269, -3301}, {   606,  2018, -1316,  4064,   398}

################################################################################

TITLE
    libavcodec real audio 288 syn_window

TYPE
    FLOAT

DATA
  0.576690972, 0.580838025, 0.585013986, 0.589219987, 0.59345597,  0.597723007,
  0.602020264, 0.606384277, 0.610748291, 0.615142822, 0.619598389, 0.624084473,
  0.628570557, 0.633117676, 0.637695313, 0.642272949, 0.646911621, 0.651580811,
  0.656280518, 0.66104126,  0.665802002, 0.670593262, 0.675445557, 0.680328369,
  0.685241699, 0.690185547, 0.695159912, 0.700164795, 0.705230713, 0.710327148,
  0.715454102, 0.720611572, 0.725830078, 0.731048584, 0.736328125, 0.741638184,
  0.747009277, 0.752380371, 0.7578125,   0.763305664, 0.768798828, 0.774353027,
  0.779937744, 0.785583496, 0.791229248, 0.796936035, 0.802703857, 0.808502197,
  0.814331055, 0.820220947, 0.826141357, 0.832092285, 0.838104248, 0.844146729,
  0.850250244, 0.856384277, 0.862548828, 0.868774414, 0.875061035, 0.881378174,
  0.88772583,  0.894134521, 0.900604248, 0.907104492, 0.913635254, 0.920227051,
  0.926879883, 0.933563232, 0.940307617, 0.94708252,  0.953918457, 0.96081543,
  0.96774292,  0.974731445, 0.981781006, 0.988861084, 0.994842529, 0.998565674,
  0.999969482, 0.99911499,  0.996002197, 0.990600586, 0.982910156, 0.973022461,
  0.960876465, 0.946533203, 0.930053711, 0.911437988, 0.89074707,  0.868041992,
  0.843322754, 0.816680908, 0.788208008, 0.757904053, 0.725891113, 0.692199707,
  0.656921387, 0.620178223, 0.582000732, 0.542480469, 0.501739502, 0.459838867,
  0.416900635, 0.373016357, 0.328277588, 0.282775879, 0.236663818, 0.189971924,
  0.142852783, 0.0954284668,0.0477600098

################################################################################

TITLE
    libavcodec real audio 288 gain_window

TYPE
    FLOAT

DATA
  0.505699992, 0.524200022, 0.54339999,  0.563300014, 0.583953857, 0.60534668,
  0.627502441, 0.650482178, 0.674316406, 0.699005127, 0.724578857, 0.75112915,
  0.778625488, 0.807128906, 0.836669922, 0.86730957,  0.899078369, 0.932006836,
  0.961486816, 0.982757568, 0.995635986, 1,           0.995819092, 0.983154297,
  0.96206665,  0.932769775, 0.895507813, 0.850585938, 0.798400879, 0.739379883,
  0.674072266, 0.602996826, 0.526763916, 0.446014404, 0.361480713, 0.273834229,
  0.183868408, 0.0923461914

################################################################################

TITLE
    libavcodec real audio 288 syn_bw_tab

TYPE
    FLOAT

DATA
  0.98828125,  0.976699829, 0.965254128, 0.953942537, 0.942763507, 0.931715488,
  0.920796931, 0.910006344, 0.899342179, 0.888803005, 0.878387332, 0.868093729,
  0.857920766, 0.847867012, 0.837931097, 0.828111589, 0.818407178, 0.808816493,
  0.799338162, 0.789970934, 0.780713439, 0.771564424, 0.762522638, 0.753586829,
  0.744755745, 0.736028135, 0.727402806, 0.718878567, 0.710454226, 0.702128589,
  0.693900526, 0.685768902, 0.677732527, 0.669790328, 0.66194123,  0.654184103

################################################################################

TITLE
    libavcodec rv10 rv_lum_code

TYPE
    16

DATA
 0x3e7f, 0x0f00, 0x0f01, 0x0f02, 0x0f03, 0x0f04, 0x0f05, 0x0f06,
 0x0f07, 0x0f08, 0x0f09, 0x0f0a, 0x0f0b, 0x0f0c, 0x0f0d, 0x0f0e,
 0x0f0f, 0x0f10, 0x0f11, 0x0f12, 0x0f13, 0x0f14, 0x0f15, 0x0f16,
 0x0f17, 0x0f18, 0x0f19, 0x0f1a, 0x0f1b, 0x0f1c, 0x0f1d, 0x0f1e,
 0x0f1f, 0x0f20, 0x0f21, 0x0f22, 0x0f23, 0x0f24, 0x0f25, 0x0f26,
 0x0f27, 0x0f28, 0x0f29, 0x0f2a, 0x0f2b, 0x0f2c, 0x0f2d, 0x0f2e,
 0x0f2f, 0x0f30, 0x0f31, 0x0f32, 0x0f33, 0x0f34, 0x0f35, 0x0f36,
 0x0f37, 0x0f38, 0x0f39, 0x0f3a, 0x0f3b, 0x0f3c, 0x0f3d, 0x0f3e,
 0x0f3f, 0x0380, 0x0381, 0x0382, 0x0383, 0x0384, 0x0385, 0x0386,
 0x0387, 0x0388, 0x0389, 0x038a, 0x038b, 0x038c, 0x038d, 0x038e,
 0x038f, 0x0390, 0x0391, 0x0392, 0x0393, 0x0394, 0x0395, 0x0396,
 0x0397, 0x0398, 0x0399, 0x039a, 0x039b, 0x039c, 0x039d, 0x039e,
 0x039f, 0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6,
 0x00c7, 0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce,
 0x00cf, 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056,
 0x0057, 0x0020, 0x0021, 0x0022, 0x0023, 0x000c, 0x000d, 0x0004,
 0x0000, 0x0005, 0x000e, 0x000f, 0x0024, 0x0025, 0x0026, 0x0027,
 0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f,
 0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7,
 0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df,
 0x03a0, 0x03a1, 0x03a2, 0x03a3, 0x03a4, 0x03a5, 0x03a6, 0x03a7,
 0x03a8, 0x03a9, 0x03aa, 0x03ab, 0x03ac, 0x03ad, 0x03ae, 0x03af,
 0x03b0, 0x03b1, 0x03b2, 0x03b3, 0x03b4, 0x03b5, 0x03b6, 0x03b7,
 0x03b8, 0x03b9, 0x03ba, 0x03bb, 0x03bc, 0x03bd, 0x03be, 0x03bf,
 0x0f40, 0x0f41, 0x0f42, 0x0f43, 0x0f44, 0x0f45, 0x0f46, 0x0f47,
 0x0f48, 0x0f49, 0x0f4a, 0x0f4b, 0x0f4c, 0x0f4d, 0x0f4e, 0x0f4f,
 0x0f50, 0x0f51, 0x0f52, 0x0f53, 0x0f54, 0x0f55, 0x0f56, 0x0f57,
 0x0f58, 0x0f59, 0x0f5a, 0x0f5b, 0x0f5c, 0x0f5d, 0x0f5e, 0x0f5f,
 0x0f60, 0x0f61, 0x0f62, 0x0f63, 0x0f64, 0x0f65, 0x0f66, 0x0f67,
 0x0f68, 0x0f69, 0x0f6a, 0x0f6b, 0x0f6c, 0x0f6d, 0x0f6e, 0x0f6f,
 0x0f70, 0x0f71, 0x0f72, 0x0f73, 0x0f74, 0x0f75, 0x0f76, 0x0f77,
 0x0f78, 0x0f79, 0x0f7a, 0x0f7b, 0x0f7c, 0x0f7d, 0x0f7e, 0x0f7f,

################################################################################

TITLE
    libavcodec rv10 rv_chrom_code

TYPE
    16

DATA
 0xfe7f, 0x3f00, 0x3f01, 0x3f02, 0x3f03, 0x3f04, 0x3f05, 0x3f06,
 0x3f07, 0x3f08, 0x3f09, 0x3f0a, 0x3f0b, 0x3f0c, 0x3f0d, 0x3f0e,
 0x3f0f, 0x3f10, 0x3f11, 0x3f12, 0x3f13, 0x3f14, 0x3f15, 0x3f16,
 0x3f17, 0x3f18, 0x3f19, 0x3f1a, 0x3f1b, 0x3f1c, 0x3f1d, 0x3f1e,
 0x3f1f, 0x3f20, 0x3f21, 0x3f22, 0x3f23, 0x3f24, 0x3f25, 0x3f26,
 0x3f27, 0x3f28, 0x3f29, 0x3f2a, 0x3f2b, 0x3f2c, 0x3f2d, 0x3f2e,
 0x3f2f, 0x3f30, 0x3f31, 0x3f32, 0x3f33, 0x3f34, 0x3f35, 0x3f36,
 0x3f37, 0x3f38, 0x3f39, 0x3f3a, 0x3f3b, 0x3f3c, 0x3f3d, 0x3f3e,
 0x3f3f, 0x0f80, 0x0f81, 0x0f82, 0x0f83, 0x0f84, 0x0f85, 0x0f86,
 0x0f87, 0x0f88, 0x0f89, 0x0f8a, 0x0f8b, 0x0f8c, 0x0f8d, 0x0f8e,
 0x0f8f, 0x0f90, 0x0f91, 0x0f92, 0x0f93, 0x0f94, 0x0f95, 0x0f96,
 0x0f97, 0x0f98, 0x0f99, 0x0f9a, 0x0f9b, 0x0f9c, 0x0f9d, 0x0f9e,
 0x0f9f, 0x03c0, 0x03c1, 0x03c2, 0x03c3, 0x03c4, 0x03c5, 0x03c6,
 0x03c7, 0x03c8, 0x03c9, 0x03ca, 0x03cb, 0x03cc, 0x03cd, 0x03ce,
 0x03cf, 0x00e0, 0x00e1, 0x00e2, 0x00e3, 0x00e4, 0x00e5, 0x00e6,
 0x00e7, 0x0030, 0x0031, 0x0032, 0x0033, 0x0008, 0x0009, 0x0002,
 0x0000, 0x0003, 0x000a, 0x000b, 0x0034, 0x0035, 0x0036, 0x0037,
 0x00e8, 0x00e9, 0x00ea, 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef,
 0x03d0, 0x03d1, 0x03d2, 0x03d3, 0x03d4, 0x03d5, 0x03d6, 0x03d7,
 0x03d8, 0x03d9, 0x03da, 0x03db, 0x03dc, 0x03dd, 0x03de, 0x03df,
 0x0fa0, 0x0fa1, 0x0fa2, 0x0fa3, 0x0fa4, 0x0fa5, 0x0fa6, 0x0fa7,
 0x0fa8, 0x0fa9, 0x0faa, 0x0fab, 0x0fac, 0x0fad, 0x0fae, 0x0faf,
 0x0fb0, 0x0fb1, 0x0fb2, 0x0fb3, 0x0fb4, 0x0fb5, 0x0fb6, 0x0fb7,
 0x0fb8, 0x0fb9, 0x0fba, 0x0fbb, 0x0fbc, 0x0fbd, 0x0fbe, 0x0fbf,
 0x3f40, 0x3f41, 0x3f42, 0x3f43, 0x3f44, 0x3f45, 0x3f46, 0x3f47,
 0x3f48, 0x3f49, 0x3f4a, 0x3f4b, 0x3f4c, 0x3f4d, 0x3f4e, 0x3f4f,
 0x3f50, 0x3f51, 0x3f52, 0x3f53, 0x3f54, 0x3f55, 0x3f56, 0x3f57,
 0x3f58, 0x3f59, 0x3f5a, 0x3f5b, 0x3f5c, 0x3f5d, 0x3f5e, 0x3f5f,
 0x3f60, 0x3f61, 0x3f62, 0x3f63, 0x3f64, 0x3f65, 0x3f66, 0x3f67,
 0x3f68, 0x3f69, 0x3f6a, 0x3f6b, 0x3f6c, 0x3f6d, 0x3f6e, 0x3f6f,
 0x3f70, 0x3f71, 0x3f72, 0x3f73, 0x3f74, 0x3f75, 0x3f76, 0x3f77,
 0x3f78, 0x3f79, 0x3f7a, 0x3f7b, 0x3f7c, 0x3f7d, 0x3f7e, 0x3f7f,

################################################################################

TITLE
    libavcodec rv30_itype_from_context

TYPE
    8

DATA
    0, 9, 9, 9, 9, 9, 9, 9, 9,
    0, 2, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    2, 0, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,
    9, 9, 9, 9, 9, 9, 9, 9, 9,

    0, 1, 9, 9, 9, 9, 9, 9, 9,
    0, 2, 1, 6, 4, 8, 5, 7, 3,
    1, 0, 2, 6, 5, 4, 3, 8, 7,
    2, 8, 0, 1, 7, 4, 3, 6, 5,
    2, 0, 1, 3, 8, 5, 4, 7, 6,
    2, 0, 1, 4, 6, 7, 8, 3, 5,
    0, 1, 5, 2, 6, 3, 8, 4, 7,
    0, 1, 6, 2, 4, 7, 5, 8, 3,
    2, 7, 0, 1, 4, 8, 6, 3, 5,
    2, 8, 0, 1, 7, 3, 4, 5, 6,

    1, 0, 9, 9, 9, 9, 9, 9, 9,
    1, 2, 5, 6, 3, 0, 4, 8, 7,
    1, 6, 2, 5, 3, 0, 4, 8, 7,
    2, 1, 7, 6, 8, 3, 5, 0, 4,
    1, 2, 5, 3, 6, 8, 4, 7, 0,
    1, 6, 2, 0, 4, 5, 8, 7, 3,
    1, 5, 2, 6, 3, 8, 4, 0, 7,
    1, 6, 0, 2, 4, 5, 7, 3, 8,
    2, 1, 7, 6, 0, 8, 5, 4, 3,
    1, 2, 7, 8, 3, 4, 5, 6, 0,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    0, 2, 1, 8, 7, 6, 5, 4, 3,
    1, 2, 0, 6, 5, 7, 4, 8, 3,
    2, 8, 7, 1, 0, 6, 4, 3, 5,
    2, 0, 8, 1, 3, 7, 5, 4, 6,
    2, 0, 4, 1, 7, 8, 6, 3, 5,
    2, 0, 1, 5, 8, 4, 6, 7, 3,
    2, 0, 6, 1, 4, 7, 8, 5, 3,
    2, 7, 8, 1, 0, 5, 4, 6, 3,
    2, 8, 7, 1, 0, 4, 3, 6, 5,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    0, 2, 1, 3, 5, 8, 6, 4, 7,
    1, 0, 2, 5, 3, 6, 4, 8, 7,
    2, 8, 1, 0, 3, 5, 7, 6, 4,
    3, 2, 5, 8, 1, 4, 6, 7, 0,
    4, 2, 0, 6, 1, 5, 8, 3, 7,
    5, 3, 1, 2, 8, 6, 4, 0, 7,
    1, 6, 0, 2, 4, 5, 8, 3, 7,
    2, 7, 0, 1, 5, 4, 8, 6, 3,
    2, 8, 3, 5, 1, 0, 7, 6, 4,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    2, 0, 6, 1, 4, 7, 5, 8, 3,
    1, 6, 2, 0, 4, 5, 3, 7, 8,
    2, 8, 7, 6, 4, 0, 1, 5, 3,
    4, 2, 1, 0, 6, 8, 3, 5, 7,
    4, 2, 6, 0, 1, 5, 7, 8, 3,
    1, 2, 5, 0, 6, 3, 4, 7, 8,
    6, 4, 0, 1, 2, 7, 5, 3, 8,
    2, 7, 4, 6, 0, 1, 8, 5, 3,
    2, 8, 7, 4, 6, 1, 3, 5, 0,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    5, 1, 2, 3, 6, 8, 0, 4, 7,
    1, 5, 6, 3, 2, 0, 4, 8, 7,
    2, 1, 5, 3, 6, 8, 7, 4, 0,
    5, 3, 1, 2, 6, 8, 4, 7, 0,
    1, 6, 2, 4, 5, 8, 0, 3, 7,
    5, 1, 3, 6, 2, 0, 8, 4, 7,
    1, 6, 5, 2, 0, 4, 3, 7, 8,
    2, 7, 1, 6, 5, 0, 8, 3, 4,
    2, 5, 1, 3, 6, 8, 4, 0, 7,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    1, 6, 2, 0, 5, 4, 3, 7, 8,
    1, 6, 5, 4, 2, 3, 0, 7, 8,
    2, 1, 6, 7, 4, 8, 5, 3, 0,
    2, 1, 6, 5, 8, 4, 3, 0, 7,
    6, 4, 1, 2, 0, 5, 7, 8, 3,
    1, 6, 5, 2, 3, 0, 4, 8, 7,
    6, 1, 4, 0, 2, 7, 5, 3, 8,
    2, 7, 4, 6, 1, 5, 0, 8, 3,
    2, 1, 6, 8, 4, 7, 3, 5, 0,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    2, 0, 4, 7, 6, 1, 8, 5, 3,
    6, 1, 2, 0, 4, 7, 5, 8, 3,
    2, 7, 8, 0, 1, 6, 4, 3, 5,
    2, 4, 0, 8, 3, 1, 7, 6, 5,
    4, 2, 7, 0, 6, 1, 8, 5, 3,
    2, 1, 0, 8, 5, 6, 7, 4, 3,
    2, 6, 4, 1, 7, 0, 5, 8, 3,
    2, 7, 4, 0, 8, 6, 1, 5, 3,
    2, 8, 7, 4, 1, 0, 3, 6, 5,

    9, 9, 9, 9, 9, 9, 9, 9, 9,
    2, 0, 8, 1, 3, 4, 6, 5, 7,
    1, 2, 0, 6, 8, 5, 7, 3, 4,
    2, 8, 7, 1, 0, 3, 6, 5, 4,
    8, 3, 2, 5, 1, 0, 4, 7, 6,
    2, 0, 4, 8, 5, 1, 7, 6, 3,
    2, 1, 0, 8, 5, 3, 6, 4, 7,
    2, 1, 6, 0, 8, 4, 5, 7, 3,
    2, 7, 8, 4, 0, 6, 1, 5, 3,
    2, 8, 3, 0, 7, 4, 1, 6, 5,

################################################################################

TITLE
    libavcodec rv30 modulo_three_table

TYPE
    8

DATA
 { 0, 0, 0, 0 }, { 0, 0, 0, 1 }, { 0, 0, 0, 2 }, { 0, 0, 1, 0 },
 { 0, 0, 1, 1 }, { 0, 0, 1, 2 }, { 0, 0, 2, 0 }, { 0, 0, 2, 1 },
 { 0, 0, 2, 2 }, { 0, 1, 0, 0 }, { 0, 1, 0, 1 }, { 0, 1, 0, 2 },
 { 0, 1, 1, 0 }, { 0, 1, 1, 1 }, { 0, 1, 1, 2 }, { 0, 1, 2, 0 },
 { 0, 1, 2, 1 }, { 0, 1, 2, 2 }, { 0, 2, 0, 0 }, { 0, 2, 0, 1 },
 { 0, 2, 0, 2 }, { 0, 2, 1, 0 }, { 0, 2, 1, 1 }, { 0, 2, 1, 2 },
 { 0, 2, 2, 0 }, { 0, 2, 2, 1 }, { 0, 2, 2, 2 }, { 1, 0, 0, 0 },
 { 1, 0, 0, 1 }, { 1, 0, 0, 2 }, { 1, 0, 1, 0 }, { 1, 0, 1, 1 },
 { 1, 0, 1, 2 }, { 1, 0, 2, 0 }, { 1, 0, 2, 1 }, { 1, 0, 2, 2 },
 { 1, 1, 0, 0 }, { 1, 1, 0, 1 }, { 1, 1, 0, 2 }, { 1, 1, 1, 0 },
 { 1, 1, 1, 1 }, { 1, 1, 1, 2 }, { 1, 1, 2, 0 }, { 1, 1, 2, 1 },
 { 1, 1, 2, 2 }, { 1, 2, 0, 0 }, { 1, 2, 0, 1 }, { 1, 2, 0, 2 },
 { 1, 2, 1, 0 }, { 1, 2, 1, 1 }, { 1, 2, 1, 2 }, { 1, 2, 2, 0 },
 { 1, 2, 2, 1 }, { 1, 2, 2, 2 }, { 2, 0, 0, 0 }, { 2, 0, 0, 1 },
 { 2, 0, 0, 2 }, { 2, 0, 1, 0 }, { 2, 0, 1, 1 }, { 2, 0, 1, 2 },
 { 2, 0, 2, 0 }, { 2, 0, 2, 1 }, { 2, 0, 2, 2 }, { 2, 1, 0, 0 },
 { 2, 1, 0, 1 }, { 2, 1, 0, 2 }, { 2, 1, 1, 0 }, { 2, 1, 1, 1 },
 { 2, 1, 1, 2 }, { 2, 1, 2, 0 }, { 2, 1, 2, 1 }, { 2, 1, 2, 2 },
 { 2, 2, 0, 0 }, { 2, 2, 0, 1 }, { 2, 2, 0, 2 }, { 2, 2, 1, 0 },
 { 2, 2, 1, 1 }, { 2, 2, 1, 2 }, { 2, 2, 2, 0 }, { 2, 2, 2, 1 },
 { 2, 2, 2, 2 }, { 3, 0, 0, 0 }, { 3, 0, 0, 1 }, { 3, 0, 0, 2 },
 { 3, 0, 1, 0 }, { 3, 0, 1, 1 }, { 3, 0, 1, 2 }, { 3, 0, 2, 0 },
 { 3, 0, 2, 1 }, { 3, 0, 2, 2 }, { 3, 1, 0, 0 }, { 3, 1, 0, 1 },
 { 3, 1, 0, 2 }, { 3, 1, 1, 0 }, { 3, 1, 1, 1 }, { 3, 1, 1, 2 },
 { 3, 1, 2, 0 }, { 3, 1, 2, 1 }, { 3, 1, 2, 2 }, { 3, 2, 0, 0 },
 { 3, 2, 0, 1 }, { 3, 2, 0, 2 }, { 3, 2, 1, 0 }, { 3, 2, 1, 1 },
 { 3, 2, 1, 2 }, { 3, 2, 2, 0 }, { 3, 2, 2, 1 }, { 3, 2, 2, 2 },

################################################################################

TITLE
    libavcodec rv34_table_intra_cbp

TYPE
    8

DATA
    { 0,  3,  3,  4,  3,  5,  5,  5,  2,  5,  4,  6,  4,  6,  6,  6, },
    { 0,  2,  3,  4,  2,  5,  6,  7,  3,  6,  5,  7,  4,  7,  8,  8, },
    { 0,  3,  4,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  3, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  6,  3,  5,  6,  5, },
    { 0,  4,  4,  4,  4,  5,  5,  4,  4,  5,  4,  5,  4,  4,  4,  2, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  6,  6,  5,  6,  5,  6,  4,  6,  6,  5,  4,  4,  4,  4,  1, },
    { 0,  4,  4,  4,  4,  5,  5,  4,  4,  5,  5,  4,  4,  4,  4,  2, },
  },
  {
    { 0,  4,  3,  4,  3,  4,  5,  4,  3,  5,  4,  5,  3,  5,  5,  5, },
    { 0,  2,  3,  4,  2,  5,  6,  7,  3,  6,  5,  7,  4,  7,  8,  8, },
    { 0,  4,  4,  4,  4,  4,  5,  4,  4,  5,  4,  4,  3,  4,  4,  3, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  6,  3,  5,  6,  5, },
    { 0,  4,  4,  4,  4,  4,  5,  4,  4,  5,  5,  5,  4,  4,  4,  2, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  5,  6,  5,  5,  5,  6,  4,  6,  6,  5,  4,  5,  4,  4,  1, },
    { 0,  4,  4,  4,  4,  4,  5,  4,  4,  5,  5,  4,  4,  4,  5,  2, },
  },
  {
    { 0,  3,  3,  4,  3,  4,  4,  5,  3,  5,  4,  5,  4,  5,  5,  5, },
    { 0,  2,  3,  4,  2,  4,  6,  7,  3,  6,  5,  7,  5,  7,  8,  8, },
    { 0,  4,  4,  4,  4,  4,  5,  4,  3,  5,  4,  4,  4,  4,  4,  3, },
    { 0,  3,  3,  4,  3,  3,  6,  6,  3,  6,  4,  6,  3,  6,  6,  5, },
    { 0,  4,  4,  4,  3,  4,  5,  4,  4,  5,  4,  4,  4,  4,  4,  3, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  5,  5,  5,  5,  5,  6,  4,  5,  6,  5,  5,  5,  4,  4,  1, },
    { 0,  4,  4,  4,  4,  4,  6,  4,  4,  6,  5,  4,  4,  4,  4,  2, },
  },
  {
    { 0,  3,  3,  4,  3,  4,  4,  5,  3,  5,  4,  5,  4,  5,  5,  5, },
    { 0,  2,  3,  4,  2,  4,  7,  6,  3,  7,  5,  7,  5,  7,  7,  7, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  3,  3,  3,  3,  4,  6,  6,  3,  6,  4,  6,  3,  6,  6,  5, },
    { 0,  3,  4,  4,  3,  4,  5,  4,  4,  5,  4,  5,  4,  5,  4,  3, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  4,  5,  4,  4,  4,  5,  4,  4,  5,  5,  4,  4,  4,  4,  2, },
    { 0,  4,  4,  4,  4,  5,  5,  4,  4,  5,  5,  4,  4,  4,  4,  2, },
  },
  {
    { 0,  3,  3,  4,  3,  4,  5,  6,  2,  5,  4,  7,  4,  6,  6,  7, },
    { 0,  2,  3,  4,  2,  4,  6,  7,  3,  7,  5,  7,  5,  7,  7,  7, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  2,  3,  4,  3,  4,  6,  5,  3,  6,  4,  6,  4,  6,  6,  6, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  3,  3,  4,  3,  4,  5,  5,  3,  5,  4,  5,  4,  5,  5,  4, },
    { 0,  4,  4,  4,  4,  5,  5,  4,  4,  5,  5,  4,  4,  4,  4,  2, },
    { 0,  3,  4,  4,  4,  4,  5,  4,  4,  5,  4,  4,  4,  4,  4,  3, },

################################################################################

TITLE
    libavcodec rv40_aic_table_index

TYPE
    16

DATA
 0x000, 0x100, 0x200,
 0x011, 0x111, 0x211, 0x511, 0x611,
 0x022, 0x122, 0x222, 0x722,
 0x272, 0x227,
 0x822, 0x282, 0x228,
 0x112, 0x116, 0x221

################################################################################

TITLE
    libavcodec rv40 aic_mode2_vlc_codes

TYPE
    16

DATA
{ 0x0001, 0x0001, 0x0005, 0x01F5, 0x0011, 0x0049, 0x0000, 0x0048, 0x004B,
  0x0035, 0x0003, 0x0034, 0x03C9, 0x01F4, 0x00C9, 0x004A, 0x0FD9, 0x03C8,
  0x0010, 0x0037, 0x0001, 0x00C8, 0x0075, 0x01F7, 0x00CB, 0x0074, 0x0002,
  0x01F6, 0x00CA, 0x01F1, 0x01F0, 0x1F81, 0x07F9, 0x1F80, 0x1F83, 0x07F8,
  0x0077, 0x00F5, 0x0036, 0x07FB, 0x0076, 0x1F82, 0x00F4, 0x00F7, 0x07FA,
  0x0071, 0x00F6, 0x03CB, 0x03CA, 0x0FD8, 0x00F1, 0x03F5, 0x1F8D, 0x07E5,
  0x0013, 0x0031, 0x00F0, 0x0FDB, 0x00F3, 0x07E4, 0x0030, 0x01F3, 0x07E7,
  0x03F4, 0x07E6, 0x0070, 0x3F19, 0x01F2, 0x3F18, 0x0FDA, 0x0033, 0x07E1,
  0x01FD, 0x01FC, 0x0073, 0x01FF, 0x0FC5, 0x0FC4, 0x0FC7, 0x03F7, 0x0072, },
{ 0x0005, 0x0005, 0x0005, 0x0079, 0x0005, 0x000D, 0x001D, 0x0078, 0x0069,
  0x0004, 0x0001, 0x0007, 0x0068, 0x001C, 0x001F, 0x0004, 0x006B, 0x000C,
  0x0004, 0x001E, 0x0006, 0x006A, 0x0015, 0x000F, 0x0014, 0x0017, 0x0007,
  0x0016, 0x000E, 0x0011, 0x0009, 0x00D1, 0x00D0, 0x0181, 0x00D3, 0x007B,
  0x0010, 0x0013, 0x0004, 0x00D2, 0x0007, 0x0319, 0x0008, 0x007A, 0x00DD,
  0x0019, 0x0006, 0x000B, 0x0065, 0x00DC, 0x0012, 0x0064, 0x0180, 0x00DF,
  0x0006, 0x0018, 0x0001, 0x00DE, 0x001D, 0x00D9, 0x001B, 0x0067, 0x000A,
  0x00D8, 0x00DB, 0x001C, 0x0318, 0x00DA, 0x0635, 0x0183, 0x0000, 0x00C5,
  0x0066, 0x0061, 0x0035, 0x00C4, 0x0182, 0x0634, 0x031B, 0x00C7, 0x001F, },
{ 0x0005, 0x0001, 0x001D, 0x01C1, 0x0035, 0x00F1, 0x006D, 0x00F0, 0x0049,
  0x0000, 0x0004, 0x0003, 0x00F3, 0x0048, 0x0034, 0x006C, 0x01C0, 0x01C3,
  0x0007, 0x0006, 0x0001, 0x006F, 0x0002, 0x004B, 0x006E, 0x001C, 0x0005,
  0x0069, 0x0068, 0x006B, 0x0037, 0x01C2, 0x00F2, 0x0395, 0x01CD, 0x00FD,
  0x006A, 0x0036, 0x0015, 0x01CC, 0x0014, 0x0394, 0x004A, 0x00FC, 0x00FF,
  0x0017, 0x0031, 0x00FE, 0x01CF, 0x0397, 0x00F9, 0x01CE, 0x0725, 0x0396,
  0x0016, 0x0030, 0x0075, 0x0724, 0x00F8, 0x0727, 0x0033, 0x0391, 0x0390,
  0x0011, 0x0032, 0x001F, 0x00FB, 0x0074, 0x0726, 0x00FA, 0x001E, 0x0077,
  0x0019, 0x0018, 0x0004, 0x0010, 0x003D, 0x0076, 0x0071, 0x0013, 0x0001, },
{ 0x000D, 0x0019, 0x0011, 0x0015, 0x0061, 0x0019, 0x0014, 0x01AD, 0x0060,
  0x0018, 0x0001, 0x0005, 0x001B, 0x0010, 0x0019, 0x0005, 0x0017, 0x0018,
  0x0016, 0x0004, 0x0004, 0x0013, 0x000C, 0x0012, 0x001A, 0x0018, 0x0005,
  0x000F, 0x001B, 0x0004, 0x001D, 0x0011, 0x001C, 0x0010, 0x000E, 0x001B,
  0x0013, 0x001F, 0x001A, 0x0029, 0x0005, 0x0063, 0x001E, 0x0009, 0x0062,
  0x0008, 0x0007, 0x0007, 0x0019, 0x0004, 0x001A, 0x0018, 0x006D, 0x0007,
  0x001B, 0x0007, 0x001A, 0x006C, 0x0006, 0x0012, 0x0005, 0x006F, 0x000B,
  0x006E, 0x0069, 0x001D, 0x0359, 0x0028, 0x002B, 0x002A, 0x001C, 0x00D5,
  0x0358, 0x001F, 0x0001, 0x001E, 0x0068, 0x00D4, 0x00D7, 0x0019, 0x0000, },
{ 0x00B9, 0x0061, 0x0060, 0x00B8, 0x02B5, 0x01AD, 0x00BB, 0x0AF5, 0x0151,
  0x0001, 0x0001, 0x0005, 0x0000, 0x0003, 0x0005, 0x0004, 0x0063, 0x0025,
  0x00BA, 0x0004, 0x0007, 0x0062, 0x00A5, 0x0024, 0x006D, 0x0002, 0x006C,
  0x02B4, 0x000D, 0x006F, 0x0027, 0x00A4, 0x0026, 0x01AC, 0x0150, 0x01AF,
  0x01AE, 0x0021, 0x006E, 0x02B7, 0x0020, 0x0153, 0x0023, 0x00A7, 0x0152,
  0x00A6, 0x0006, 0x000C, 0x0022, 0x01A9, 0x0019, 0x002D, 0x02B6, 0x01A8,
  0x000F, 0x0007, 0x000E, 0x00A1, 0x0069, 0x002C, 0x0001, 0x01AB, 0x00A0,
  0x02B1, 0x00A3, 0x002F, 0x0AF4, 0x02B0, 0x0AF7, 0x02B3, 0x0068, 0x015D,
  0x0AF6, 0x01AA, 0x0055, 0x015C, 0x02B2, 0x0579, 0x0578, 0x015F, 0x00A2, },
{ 0x0905, 0x013D, 0x013C, 0x0904, 0x121D, 0x049D, 0x049C, 0x243D, 0x0907,
  0x00ED, 0x0001, 0x0015, 0x0041, 0x013F, 0x0031, 0x0014, 0x025D, 0x025C,
  0x013E, 0x000D, 0x0000, 0x0040, 0x0139, 0x0043, 0x0030, 0x0017, 0x0033,
  0x0906, 0x0032, 0x0042, 0x00EC, 0x025F, 0x00EF, 0x025E, 0x049F, 0x0138,
  0x0901, 0x013B, 0x0259, 0x121C, 0x049E, 0x0900, 0x0258, 0x243C, 0x121F,
  0x0903, 0x003D, 0x00EE, 0x025B, 0x025A, 0x004D, 0x013A, 0x0902, 0x0245,
  0x00E9, 0x0016, 0x00E8, 0x0499, 0x0125, 0x0244, 0x004C, 0x0498, 0x090D,
  0x00EB, 0x003C, 0x0011, 0x049B, 0x049A, 0x0485, 0x00EA, 0x003F, 0x0124,
  0x090C, 0x003E, 0x0039, 0x0095, 0x0247, 0x0246, 0x0484, 0x0094, 0x0038, },
{ 0x0F09, 0x00CD, 0x01FD, 0x0791, 0x1E6D, 0x0790, 0x03D9, 0x3CD1, 0x3CD0,
  0x0075, 0x0001, 0x0001, 0x0035, 0x00CC, 0x0011, 0x0000, 0x03D8, 0x01FC,
  0x03DB, 0x0010, 0x0003, 0x00CF, 0x03DA, 0x00CE, 0x0074, 0x0034, 0x0077,
  0x0793, 0x0013, 0x0076, 0x0071, 0x03C5, 0x0070, 0x01FF, 0x0792, 0x01FE,
  0x01F9, 0x0037, 0x00C9, 0x0F08, 0x01F8, 0x03C4, 0x00C8, 0x0F0B, 0x079D,
  0x03C7, 0x0001, 0x0012, 0x0073, 0x00CB, 0x0005, 0x0036, 0x03C6, 0x0072,
  0x007D, 0x0002, 0x00CA, 0x079C, 0x01FB, 0x00F5, 0x0031, 0x079F, 0x0F0A,
  0x0F35, 0x079E, 0x01FA, 0x1E6C, 0x1E6F, 0x3CD3, 0x0799, 0x03C1, 0x1E6E,
  0x3CD2, 0x0030, 0x00F4, 0x007C, 0x03C0, 0x03C3, 0x0798, 0x01E5, 0x00F7, },
{ 0x01A5, 0x0001, 0x001D, 0x0021, 0x00A1, 0x000D, 0x0061, 0x06B9, 0x00A0,
  0x0060, 0x0001, 0x0005, 0x000C, 0x0020, 0x001C, 0x0004, 0x01A4, 0x01A7,
  0x00A3, 0x001F, 0x001E, 0x0023, 0x0022, 0x002D, 0x002C, 0x0063, 0x0062,
  0x1A81, 0x01A6, 0x01A1, 0x06B8, 0x06BB, 0x00A2, 0x06BA, 0x0D59, 0x06A5,
  0x01A0, 0x000F, 0x006D, 0x06A4, 0x002F, 0x00AD, 0x006C, 0x06A7, 0x00AC,
  0x0D58, 0x000E, 0x01A3, 0x00AF, 0x00AE, 0x006F, 0x01A2, 0x0D5B, 0x00A9,
  0x0019, 0x0001, 0x0009, 0x00A8, 0x006E, 0x002E, 0x0000, 0x01AD, 0x00AB,
  0x00AA, 0x0355, 0x0029, 0x1A80, 0x1A83, 0x1A82, 0x0354, 0x01AC, 0x0D5A,
  0x1A8D, 0x01AF, 0x0357, 0x0D45, 0x0D44, 0x0D47, 0x1A8C, 0x06A6, 0x06A1, },
{ 0x0001, 0x0011, 0x0005, 0x0775, 0x00F9, 0x00F8, 0x0031, 0x0030, 0x0049,
  0x00FB, 0x0010, 0x0033, 0x0EC9, 0x038D, 0x038C, 0x00FA, 0x038F, 0x0774,
  0x0048, 0x0032, 0x0000, 0x01D5, 0x00E5, 0x038E, 0x00E4, 0x0013, 0x000D,
  0x0389, 0x0777, 0x0388, 0x038B, 0x1DF9, 0x0EC8, 0x3BC9, 0x1DF8, 0x038A,
  0x03B5, 0x0776, 0x00E7, 0x3BC8, 0x01D4, 0x3BCB, 0x0ECB, 0x0771, 0x0ECA,
  0x01D7, 0x03B4, 0x01D6, 0x1DFB, 0x0EF5, 0x0770, 0x0EF4, 0x3BCA, 0x0773,
  0x00E6, 0x03B7, 0x004B, 0x1DFA, 0x03B6, 0x0EF7, 0x00E1, 0x0EF6, 0x0EF1,
  0x03B1, 0x01D1, 0x003D, 0x0EF0, 0x0772, 0x077D, 0x077C, 0x003C, 0x01D0,
  0x03B0, 0x01D3, 0x003F, 0x03B3, 0x01D2, 0x0EF3, 0x077F, 0x00E0, 0x004A, },
{ 0x0015, 0x0049, 0x0014, 0x07D1, 0x03FD, 0x03FC, 0x01C1, 0x01C0, 0x00F1,
  0x0017, 0x0001, 0x0001, 0x01C3, 0x0048, 0x004B, 0x0016, 0x0031, 0x01C2,
  0x004A, 0x0011, 0x0000, 0x01CD, 0x00F0, 0x01CC, 0x0075, 0x0010, 0x000D,
  0x03FF, 0x01CF, 0x01CE, 0x07D0, 0x0F81, 0x07D3, 0x1F1D, 0x0F80, 0x07D2,
  0x01C9, 0x03FE, 0x0074, 0x07DD, 0x00F3, 0x1F1C, 0x07DC, 0x03F9, 0x07DF,
  0x00F2, 0x00FD, 0x0077, 0x07DE, 0x07D9, 0x01C8, 0x07D8, 0x0F83, 0x03F8,
  0x0030, 0x0076, 0x0013, 0x0F82, 0x00FC, 0x03FB, 0x0033, 0x03FA, 0x03E5,
  0x03E4, 0x01CB, 0x0032, 0x1F1F, 0x03E7, 0x07DB, 0x07DA, 0x003D, 0x01CA,
  0x07C5, 0x03E6, 0x0071, 0x0F8D, 0x07C4, 0x1F1E, 0x0F8C, 0x03E1, 0x01F5, },
{ 0x0019, 0x0065, 0x0018, 0x0351, 0x0350, 0x0353, 0x0021, 0x0020, 0x0064,
  0x001D, 0x0005, 0x0005, 0x01A5, 0x0023, 0x0067, 0x0005, 0x0066, 0x0022,
  0x001B, 0x0004, 0x0001, 0x0004, 0x001C, 0x0061, 0x001A, 0x0005, 0x0004,
  0x0007, 0x002D, 0x0006, 0x002C, 0x01A4, 0x002F, 0x0352, 0x035D, 0x0060,
  0x0001, 0x002E, 0x001F, 0x035C, 0x0000, 0x06B1, 0x01A7, 0x0029, 0x01A6,
  0x0028, 0x0063, 0x0062, 0x035F, 0x01A1, 0x002B, 0x06B0, 0x06B3, 0x01A0,
  0x0003, 0x006D, 0x001E, 0x035E, 0x006C, 0x06B2, 0x0002, 0x01A3, 0x01A2,
  0x000D, 0x0005, 0x0007, 0x01AD, 0x006F, 0x002A, 0x006E, 0x0004, 0x0004,
  0x000C, 0x0007, 0x0006, 0x000F, 0x000E, 0x00D5, 0x0009, 0x0006, 0x0007, },
{ 0x0065, 0x0181, 0x0064, 0x36C9, 0x06D5, 0x0DB5, 0x0379, 0x0180, 0x0183,
  0x00D5, 0x001D, 0x001C, 0x0DB4, 0x0182, 0x0378, 0x00D4, 0x00D7, 0x06D4,
  0x0067, 0x001F, 0x0001, 0x00D6, 0x00D1, 0x018D, 0x0066, 0x0001, 0x0000,
  0x037B, 0x06D7, 0x037A, 0x0DB7, 0x36C8, 0x06D6, 0x0DB6, 0x1B79, 0x0DB1,
  0x018C, 0x0365, 0x00D0, 0x1B78, 0x00D3, 0x1B7B, 0x0364, 0x06D1, 0x06D0,
  0x018F, 0x018E, 0x00D2, 0x36CB, 0x0367, 0x0366, 0x06D3, 0x0DB0, 0x06D2,
  0x0361, 0x06DD, 0x0189, 0x36CA, 0x0360, 0x36F5, 0x0188, 0x0DB3, 0x36F4,
  0x0009, 0x0008, 0x0005, 0x06DC, 0x00DD, 0x018B, 0x00DC, 0x0004, 0x000B,
  0x018A, 0x0061, 0x0003, 0x0363, 0x00DF, 0x06DF, 0x0362, 0x000A, 0x001E, },
{ 0x001D, 0x0061, 0x000D, 0x0D55, 0x06B9, 0x06B8, 0x01A5, 0x0021, 0x0020,
  0x0023, 0x000C, 0x0060, 0x0D54, 0x00AD, 0x00AC, 0x0022, 0x00AF, 0x06BB,
  0x000F, 0x001C, 0x0001, 0x002D, 0x0063, 0x01A4, 0x000E, 0x0001, 0x0005,
  0x01A7, 0x06BA, 0x01A6, 0x06A5, 0x0D57, 0x0D56, 0x1ABD, 0x0D51, 0x00AE,
  0x002C, 0x00A9, 0x002F, 0x0D50, 0x01A1, 0x1ABC, 0x06A4, 0x06A7, 0x06A6,
  0x00A8, 0x06A1, 0x01A0, 0x1ABF, 0x0D53, 0x06A0, 0x0D52, 0x1ABE, 0x06A3,
  0x0062, 0x002E, 0x0009, 0x0D5D, 0x01A3, 0x0D5C, 0x006D, 0x00AB, 0x06A2,
  0x006C, 0x001F, 0x0001, 0x06AD, 0x0029, 0x01A2, 0x0028, 0x0004, 0x001E,
  0x01AD, 0x006F, 0x0000, 0x01AC, 0x01AF, 0x06AC, 0x00AA, 0x006E, 0x0019, },
{ 0x0019, 0x007D, 0x0018, 0x01B5, 0x000D, 0x01B4, 0x007C, 0x007F, 0x01B7,
  0x000C, 0x001B, 0x001A, 0x01B6, 0x000F, 0x00D5, 0x0019, 0x007E, 0x00D4,
  0x0018, 0x001B, 0x0001, 0x000E, 0x0011, 0x0009, 0x0005, 0x0005, 0x0005,
  0x00D7, 0x01B1, 0x0008, 0x01B0, 0x0079, 0x06FD, 0x0371, 0x0370, 0x00D6,
  0x0078, 0x01B3, 0x0010, 0x0373, 0x0013, 0x06FC, 0x007B, 0x007A, 0x00D1,
  0x00D0, 0x00D3, 0x0065, 0x0372, 0x06FF, 0x0064, 0x06FE, 0x037D, 0x00D2,
  0x00DD, 0x0067, 0x0004, 0x037C, 0x0012, 0x01B2, 0x0007, 0x0066, 0x01BD,
  0x0006, 0x0061, 0x0004, 0x01BC, 0x001A, 0x0060, 0x001D, 0x0004, 0x001C,
  0x0063, 0x0001, 0x0007, 0x000B, 0x0000, 0x0062, 0x000A, 0x0005, 0x0007, },
{ 0x0069, 0x0045, 0x0068, 0x04BD, 0x0255, 0x04BC, 0x00E5, 0x00E4, 0x0031,
  0x0030, 0x0019, 0x0001, 0x0121, 0x00E7, 0x00E6, 0x0033, 0x00E1, 0x00E0,
  0x006B, 0x0018, 0x0001, 0x0044, 0x0032, 0x0047, 0x006A, 0x001B, 0x0005,
  0x003D, 0x0046, 0x0015, 0x0041, 0x0120, 0x0123, 0x04BF, 0x0122, 0x0040,
  0x003C, 0x00E3, 0x0014, 0x0254, 0x0043, 0x0975, 0x012D, 0x00E2, 0x00ED,
  0x0042, 0x00EC, 0x004D, 0x0257, 0x0256, 0x0251, 0x04BE, 0x0974, 0x0250,
  0x00EF, 0x00EE, 0x004C, 0x04B9, 0x012C, 0x04B8, 0x004F, 0x04BB, 0x0253,
  0x003F, 0x0017, 0x0001, 0x0252, 0x00E9, 0x00E8, 0x00EB, 0x0000, 0x0003,
  0x0016, 0x0002, 0x0004, 0x004E, 0x003E, 0x00EA, 0x0049, 0x000D, 0x0007, },
{ 0x000D, 0x01BD, 0x000C, 0x0D31, 0x0D30, 0x0D33, 0x0359, 0x0358, 0x002D,
  0x0065, 0x001D, 0x001C, 0x0D32, 0x035B, 0x035A, 0x002C, 0x01BC, 0x0345,
  0x000F, 0x001F, 0x0001, 0x002F, 0x0064, 0x01BF, 0x0067, 0x0001, 0x0005,
  0x0066, 0x002E, 0x0061, 0x0029, 0x0695, 0x0694, 0x0697, 0x0696, 0x0060,
  0x01BE, 0x0D3D, 0x0028, 0x1A49, 0x0344, 0x1A48, 0x1A4B, 0x0D3C, 0x0691,
  0x002B, 0x01B9, 0x002A, 0x0D3F, 0x0690, 0x0347, 0x0D3E, 0x1A4A, 0x0346,
  0x00D5, 0x0341, 0x0063, 0x0D39, 0x0340, 0x0D38, 0x01B8, 0x0D3B, 0x0D3A,
  0x00D4, 0x0062, 0x0000, 0x0693, 0x01BB, 0x0343, 0x0342, 0x001E, 0x000E,
  0x006D, 0x0009, 0x0001, 0x006C, 0x00D7, 0x034D, 0x01BA, 0x0008, 0x0004, },
{ 0x0075, 0x00CD, 0x0035, 0x03C1, 0x03C0, 0x07F9, 0x03C3, 0x1F8D, 0x00CC,
  0x0074, 0x0011, 0x0010, 0x03C2, 0x0FD9, 0x01F1, 0x00CF, 0x03CD, 0x00CE,
  0x0034, 0x0001, 0x0001, 0x0037, 0x00C9, 0x00C8, 0x0036, 0x0000, 0x0001,
  0x0FD8, 0x03CC, 0x00CB, 0x01F0, 0x07F8, 0x03CF, 0x07FB, 0x07FA, 0x00CA,
  0x01F3, 0x03CE, 0x00F5, 0x0FDB, 0x00F4, 0x07E5, 0x07E4, 0x07E7, 0x01F2,
  0x07E6, 0x03C9, 0x01FD, 0x0FDA, 0x1F8C, 0x07E1, 0x1F8F, 0x1F8E, 0x03C8,
  0x03CB, 0x0077, 0x0076, 0x0FC5, 0x03CA, 0x07E0, 0x00F7, 0x0FC4, 0x03F5,
  0x00F6, 0x01FC, 0x0003, 0x03F4, 0x0071, 0x03F7, 0x00F1, 0x0013, 0x0031,
  0x0030, 0x0070, 0x0005, 0x0012, 0x0073, 0x01FF, 0x0072, 0x007D, 0x0002, },
{ 0x0061, 0x0055, 0x0060, 0x02C9, 0x02C8, 0x02CB, 0x0171, 0x00B5, 0x0054,
  0x0001, 0x0001, 0x0001, 0x0057, 0x0001, 0x0063, 0x001D, 0x0062, 0x0039,
  0x006D, 0x0000, 0x0005, 0x0038, 0x0056, 0x00B4, 0x006C, 0x0003, 0x001C,
  0x006F, 0x003B, 0x0002, 0x003A, 0x0170, 0x00B7, 0x0173, 0x0051, 0x006E,
  0x0025, 0x0050, 0x0069, 0x02CA, 0x0024, 0x0027, 0x0172, 0x00B6, 0x00B1,
  0x000D, 0x000C, 0x001F, 0x017D, 0x0026, 0x0068, 0x0053, 0x017C, 0x006B,
  0x001E, 0x000F, 0x0004, 0x017F, 0x006A, 0x02F5, 0x0019, 0x0021, 0x0052,
  0x02F4, 0x02F7, 0x0020, 0x0BCD, 0x05E5, 0x05E4, 0x0BCC, 0x0023, 0x00B0,
  0x02F6, 0x00B3, 0x0022, 0x02F1, 0x02F0, 0x0BCF, 0x0BCE, 0x017E, 0x005D, },
{ 0x00BD, 0x0025, 0x01A1, 0x0159, 0x0299, 0x00BC, 0x0024, 0x0505, 0x0504,
  0x01A0, 0x0001, 0x001D, 0x006D, 0x001C, 0x0001, 0x0005, 0x0027, 0x01A3,
  0x0158, 0x001F, 0x001E, 0x01A2, 0x0026, 0x0021, 0x000D, 0x0020, 0x0023,
  0x0298, 0x006C, 0x0022, 0x00BF, 0x00BE, 0x01AD, 0x002D, 0x029B, 0x00B9,
  0x01AC, 0x00B8, 0x01AF, 0x029A, 0x006F, 0x015B, 0x006E, 0x0285, 0x0284,
  0x01AE, 0x0019, 0x002C, 0x01A9, 0x01A8, 0x000C, 0x000F, 0x015A, 0x00BB,
  0x000E, 0x0000, 0x0069, 0x01AB, 0x0018, 0x01AA, 0x0004, 0x0055, 0x00BA,
  0x0507, 0x0145, 0x0054, 0x0506, 0x00A5, 0x0501, 0x00A4, 0x0057, 0x0500,
  0x0A05, 0x0144, 0x00A7, 0x0287, 0x0286, 0x0503, 0x0147, 0x0A04, 0x0146, },
{ 0x0759, 0x0041, 0x00E5, 0x03BD, 0x0E9D, 0x012D, 0x012C, 0x3A1D, 0x03BC,
  0x012F, 0x000D, 0x0040, 0x00E4, 0x03BF, 0x0043, 0x0042, 0x0758, 0x03BE,
  0x00E7, 0x0001, 0x0000, 0x003D, 0x00E6, 0x0015, 0x0014, 0x0017, 0x003C,
  0x743D, 0x012E, 0x03B9, 0x03B8, 0x0E9C, 0x03BB, 0x075B, 0x3A1C, 0x0E9F,
  0x0129, 0x00E1, 0x0128, 0x0E9E, 0x012B, 0x075A, 0x00E0, 0x0E99, 0x0745,
  0x3A1F, 0x03BA, 0x0744, 0x0E98, 0x1D0D, 0x03A5, 0x0E9B, 0x743C, 0x0E9A,
  0x012A, 0x004D, 0x00E3, 0x0E85, 0x01D5, 0x0E84, 0x004C, 0x0747, 0x1D0C,
  0x01D4, 0x003F, 0x0016, 0x0746, 0x03A4, 0x0741, 0x004F, 0x003E, 0x01D7,
  0x0740, 0x000C, 0x0011, 0x004E, 0x00E2, 0x00ED, 0x00EC, 0x0049, 0x0048, },

################################################################################

TITLE
    libavcodec sp5x_data_dqt

TYPE
    8

DATA
    0xFF, 0xDB, /* DQT */
    0x00, 0x84, /* len */
    0x00,
    0x05, 0x03, 0x04, 0x04, 0x04, 0x03, 0x05, 0x04,
    0x04, 0x04, 0x06, 0x05, 0x05, 0x06, 0x08, 0x0D,
    0x08, 0x08, 0x07, 0x07, 0x08, 0x10, 0x0C, 0x0C,
    0x0A, 0x0D, 0x14, 0x11, 0x15, 0x14, 0x13, 0x11,
    0x13, 0x13, 0x16, 0x18, 0x1F, 0x1A, 0x16, 0x17,
    0x1E, 0x17, 0x13, 0x13, 0x1B, 0x25, 0x1C, 0x1E,
    0x20, 0x21, 0x23, 0x23, 0x23, 0x15, 0x1A, 0x27,
    0x29, 0x26, 0x22, 0x29, 0x1F, 0x22, 0x23, 0x22,
    0x01,
    0x05, 0x06, 0x06, 0x08, 0x07, 0x08, 0x10, 0x08,
    0x08, 0x10, 0x22, 0x16, 0x13, 0x16, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
    0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22

################################################################################

TITLE
    libavcodec sp5x_data_dht

TYPE
    8

DATA
    0xFF, 0xC4, /* DHT */
    0x01, 0xA2, /* len */
    0x00, 0x00, 0x01, 0x05, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06,
    0x07, 0x08, 0x09, 0x0A, 0x0B, 0x01, 0x00, 0x03,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
    0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
    0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
    0x0A, 0x0B, 0x10, 0x00, 0x02, 0x01, 0x03, 0x03,
    0x02, 0x04, 0x03, 0x05, 0x05, 0x04, 0x04, 0x00,
    0x00, 0x01, 0x7D, 0x01, 0x02, 0x03, 0x00, 0x04,
    0x11, 0x05, 0x12, 0x21, 0x31, 0x41, 0x06, 0x13,
    0x51, 0x61, 0x07, 0x22, 0x71, 0x14, 0x32, 0x81,
    0x91, 0xA1, 0x08, 0x23, 0x42, 0xB1, 0xC1, 0x15,
    0x52, 0xD1, 0xF0, 0x24, 0x33, 0x62, 0x72, 0x82,
    0x09, 0x0A, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x25,
    0x26, 0x27, 0x28, 0x29, 0x2A, 0x34, 0x35, 0x36,
    0x37, 0x38, 0x39, 0x3A, 0x43, 0x44, 0x45, 0x46,
    0x47, 0x48, 0x49, 0x4A, 0x53, 0x54, 0x55, 0x56,
    0x57, 0x58, 0x59, 0x5A, 0x63, 0x64, 0x65, 0x66,
    0x67, 0x68, 0x69, 0x6A, 0x73, 0x74, 0x75, 0x76,
    0x77, 0x78, 0x79, 0x7A, 0x83, 0x84, 0x85, 0x86,
    0x87, 0x88, 0x89, 0x8A, 0x92, 0x93, 0x94, 0x95,
    0x96, 0x97, 0x98, 0x99, 0x9A, 0xA2, 0xA3, 0xA4,
    0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xB2, 0xB3,
    0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xC2,
    0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA,
    0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9,
    0xDA, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7,
    0xE8, 0xE9, 0xEA, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5,
    0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0x11, 0x00, 0x02,
    0x01, 0x02, 0x04, 0x04, 0x03, 0x04, 0x07, 0x05,
    0x04, 0x04, 0x00, 0x01, 0x02, 0x77, 0x00, 0x01,
    0x02, 0x03, 0x11, 0x04, 0x05, 0x21, 0x31, 0x06,
    0x12, 0x41, 0x51, 0x07, 0x61, 0x71, 0x13, 0x22,
    0x32, 0x81, 0x08, 0x14, 0x42, 0x91, 0xA1, 0xB1,
    0xC1, 0x09, 0x23, 0x33, 0x52, 0xF0, 0x15, 0x62,
    0x72, 0xD1, 0x0A, 0x16, 0x24, 0x34, 0xE1, 0x25,
    0xF1, 0x17, 0x18, 0x19, 0x1A, 0x26, 0x27, 0x28,
    0x29, 0x2A, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A,
    0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A,
    0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A,
    0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A,
    0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A,
    0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
    0x8A, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98,
    0x99, 0x9A, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7,
    0xA8, 0xA9, 0xAA, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6,
    0xB7, 0xB8, 0xB9, 0xBA, 0xC2, 0xC3, 0xC4, 0xC5,
    0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xD2, 0xD3, 0xD4,
    0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xE2, 0xE3,
    0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xF2,
    0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA

################################################################################

TITLE
    libavcodec ff_svq1_frame_size_table

TYPE
    16

DATA
  { 160, 120 }, { 128,  96 }, { 176, 144 }, { 352, 288 },
  { 704, 576 }, { 240, 180 }, { 320, 240 }, {  -1,  -1 }

################################################################################

TITLE
    libavcodec svq3_dequant_coeff

TYPE
    32

DATA
     3881,  4351,  4890,  5481,  6154,  6914,  7761,  8718,
     9781, 10987, 12339, 13828, 15523, 17435, 19561, 21873,
    24552, 27656, 30847, 34870, 38807, 43747, 49103, 54683,
    61694, 68745, 77615, 89113,100253,109366,126635,141533

################################################################################

TITLE
    libavcodec truemotion pc_tbl2

TYPE
    8

DATA
0x8,0x00,0x00,0x00,0x00,
0x8,0x00,0x00,0x00,0x00,
0x8,0x10,0x00,0x00,0x00,
0x8,0x01,0x00,0x00,0x00,
0x8,0x00,0x10,0x00,0x00,
0x8,0x00,0x01,0x00,0x00,
0x8,0x00,0x00,0x10,0x00,
0x8,0x00,0x00,0x01,0x00,
0x8,0x00,0x00,0x00,0x10,
0x8,0x00,0x00,0x00,0x01,
0x6,0x00,0x00,0x00,
0x6,0x10,0x00,0x00,
0x6,0x01,0x00,0x00,
0x6,0x00,0x10,0x00,
0x6,0x00,0x01,0x00,
0x6,0x00,0x00,0x01,
0x6,0x00,0x00,0x10,
0x6,0x00,0x00,0x02,
0x6,0x00,0x00,0x20,
0x6,0x20,0x10,0x00,
0x6,0x00,0x02,0x01,
0x6,0x00,0x20,0x10,
0x6,0x02,0x01,0x00,
0x6,0x11,0x00,0x00,
0x6,0x00,0x20,0x00,
0x6,0x00,0x02,0x00,
0x6,0x20,0x00,0x00,
0x6,0x01,0x10,0x00,
0x6,0x02,0x00,0x00,
0x6,0x01,0x00,0x02,
0x6,0x10,0x00,0x20,
0x6,0x00,0x01,0x02,
0x6,0x10,0x01,0x00,
0x6,0x00,0x10,0x20,
0x6,0x10,0x10,0x00,
0x6,0x10,0x00,0x01,
0x6,0x20,0x00,0x10,
0x6,0x02,0x00,0x01,
0x6,0x01,0x01,0x00,
0x6,0x01,0x00,0x10,
0x6,0x00,0x11,0x00,
0x6,0x10,0x00,0x02,
0x6,0x00,0x01,0x10,
0x6,0x00,0x00,0x11,
0x6,0x10,0x00,0x10,
0x6,0x01,0x00,0x01,
0x6,0x00,0x00,0x22,
0x6,0x02,0x01,0x01,
0x6,0x10,0x20,0x10,
0x6,0x01,0x02,0x01,
0x6,0x20,0x10,0x10,
0x6,0x01,0x00,0x20,
0x6,0x00,0x10,0x01,
0x6,0x21,0x10,0x00,
0x6,0x10,0x02,0x01,
0x6,0x12,0x01,0x00,
0x6,0x01,0x20,0x10,
0x6,0x01,0x02,0x00,
0x6,0x10,0x20,0x00,
0x6,0x00,0x10,0x02,
0x6,0x00,0x01,0x20,
0x6,0x00,0x02,0x21,
0x6,0x00,0x02,0x20,
0x6,0x00,0x00,0x12,
0x6,0x00,0x00,0x21,
0x6,0x20,0x11,0x00,
0x6,0x00,0x01,0x01,
0x6,0x11,0x10,0x00,
0x6,0x00,0x20,0x12,
0x6,0x00,0x20,0x11,
0x6,0x20,0x10,0x02,
0x6,0x02,0x01,0x20,
0x6,0x00,0x22,0x11,
0x6,0x00,0x10,0x10,
0x6,0x02,0x11,0x00,
0x6,0x00,0x21,0x10,
0x6,0x00,0x02,0x03,
0x6,0x20,0x10,0x01,
0x6,0x00,0x12,0x01,
0x4,0x11,0x00,
0x4,0x00,0x22,
0x4,0x20,0x00,
0x4,0x01,0x10,
0x4,0x02,0x20,
0x4,0x00,0x20,
0x4,0x02,0x00,
0x4,0x10,0x01,
0x4,0x00,0x11,
0x4,0x02,0x01,
0x4,0x02,0x21,
0x4,0x00,0x02,
0x4,0x20,0x02,
0x4,0x01,0x01,
0x4,0x10,0x10,
0x4,0x10,0x02,
0x4,0x22,0x00,
0x4,0x10,0x00,
0x4,0x01,0x00,
0x4,0x21,0x00,
0x4,0x12,0x00,
0x4,0x00,0x10,
0x4,0x20,0x12,
0x4,0x01,0x11,
0x4,0x00,0x01,
0x4,0x01,0x02,
0x4,0x11,0x02,
0x4,0x11,0x01,
0x4,0x10,0x20,
0x4,0x20,0x01,
0x4,0x22,0x11,
0x4,0x00,0x12,
0x4,0x20,0x10,
0x4,0x22,0x01,
0x4,0x01,0x20,
0x4,0x00,0x21,
0x4,0x10,0x11,
0x4,0x21,0x10,
0x4,0x10,0x22,
0x4,0x02,0x03,
0x4,0x12,0x01,
0x4,0x20,0x11,
0x4,0x11,0x10,
0x4,0x20,0x30,
0x4,0x11,0x20,
0x4,0x02,0x10,
0x4,0x22,0x10,
0x4,0x11,0x11,
0x4,0x30,0x20,
0x4,0x30,0x00,
0x4,0x01,0x22,
0x4,0x01,0x12,
0x4,0x02,0x11,
0x4,0x03,0x02,
0x4,0x03,0x00,
0x4,0x10,0x21,
0x4,0x12,0x20,
0x4,0x00,0x00,
0x4,0x12,0x21,
0x4,0x21,0x11,
0x4,0x02,0x22,
0x4,0x10,0x12,
0x4,0x31,0x00,
0x4,0x20,0x20,
0x4,0x00,0x03,
0x4,0x02,0x02,
0x4,0x22,0x20,
0x4,0x01,0x21,
0x4,0x21,0x02,
0x4,0x21,0x12,
0x4,0x11,0x22,
0x4,0x00,0x30,
0x4,0x12,0x11,
0x4,0x20,0x22,
0x4,0x31,0x20,
0x4,0x21,0x30,
0x4,0x22,0x02,
0x4,0x22,0x22,
0x4,0x20,0x31,
0x4,0x13,0x02,
0x4,0x03,0x10,
0x4,0x11,0x12,
0x4,0x00,0x13,
0x4,0x21,0x01,
0x4,0x12,0x03,
0x4,0x13,0x00,
0x4,0x13,0x10,
0x4,0x02,0x13,
0x4,0x30,0x01,
0x4,0x12,0x10,
0x4,0x22,0x13,
0x4,0x03,0x12,
0x4,0x31,0x01,
0x4,0x30,0x22,
0x4,0x00,0x31,
0x4,0x01,0x31,
0x4,0x02,0x23,
0x4,0x01,0x30,
0x4,0x11,0x21,
0x4,0x22,0x21,
0x4,0x01,0x13,
0x4,0x10,0x03,
0x4,0x22,0x03,
0x4,0x30,0x21,
0x4,0x21,0x31,
0x4,0x33,0x00,
0x4,0x13,0x12,
0x4,0x11,0x31,
0x4,0x30,0x02,
0x4,0x12,0x02,
0x4,0x11,0x13,
0x4,0x12,0x22,
0x4,0x20,0x32,
0x4,0x10,0x13,
0x4,0x22,0x31,
0x4,0x21,0x20,
0x4,0x01,0x33,
0x4,0x33,0x10,
0x4,0x20,0x13,
0x4,0x31,0x22,
0x4,0x13,0x30,
0x4,0x01,0x03,
0x4,0x11,0x33,
0x4,0x20,0x21,
0x4,0x13,0x31,
0x4,0x03,0x22,
0x4,0x31,0x02,
0x4,0x00,0x24,
0x2,0x00,
0x2,0x10,
0x2,0x20,
0x2,0x30,
0x2,0x40,
0x2,0x50,
0x2,0x60,
0x2,0x01,
0x2,0x11,
0x2,0x21,
0x2,0x31,
0x2,0x41,
0x2,0x51,
0x2,0x61,
0x2,0x02,
0x2,0x12,
0x2,0x22,
0x2,0x32,
0x2,0x42,
0x2,0x52,
0x2,0x62,
0x2,0x03,
0x2,0x13,
0x2,0x23,
0x2,0x33,
0x2,0x43,
0x2,0x53,
0x2,0x63,
0x2,0x04,
0x2,0x14,
0x2,0x24,
0x2,0x34,
0x2,0x44,
0x2,0x54,
0x2,0x64,
0x2,0x05,
0x2,0x15,
0x2,0x25,
0x2,0x35,
0x2,0x45,
0x2,0x55,
0x2,0x65,
0x2,0x06,
0x2,0x16,
0x2,0x26,
0x2,0x36,
0x2,0x46,
0x2,0x56,
0x2,0x66

################################################################################

TITLE
    libavcodec truemotion pc_tbl3

TYPE
    8

DATA
0x6,0x00,0x00,0x00,
0x6,0x00,0x00,0x00,
0x6,0x00,0x00,0x01,
0x6,0x00,0x00,0x10,
0x6,0x00,0x00,0x11,
0x6,0x00,0x01,0x00,
0x6,0x00,0x01,0x01,
0x6,0x00,0x01,0x10,
0x6,0x00,0x01,0x11,
0x6,0x00,0x10,0x00,
0x6,0x00,0x10,0x01,
0x6,0x00,0x10,0x10,
0x6,0x00,0x10,0x11,
0x6,0x00,0x11,0x00,
0x6,0x00,0x11,0x01,
0x6,0x00,0x11,0x10,
0x6,0x00,0x11,0x11,
0x6,0x01,0x00,0x00,
0x6,0x01,0x00,0x01,
0x6,0x01,0x00,0x10,
0x6,0x01,0x00,0x11,
0x6,0x01,0x01,0x00,
0x6,0x01,0x01,0x01,
0x6,0x01,0x01,0x10,
0x6,0x01,0x01,0x11,
0x6,0x01,0x10,0x00,
0x6,0x01,0x10,0x01,
0x6,0x01,0x10,0x10,
0x6,0x01,0x10,0x11,
0x6,0x01,0x11,0x00,
0x6,0x01,0x11,0x01,
0x6,0x01,0x11,0x10,
0x6,0x01,0x11,0x11,
0x6,0x10,0x00,0x00,
0x6,0x10,0x00,0x01,
0x6,0x10,0x00,0x10,
0x6,0x10,0x00,0x11,
0x6,0x10,0x01,0x00,
0x6,0x10,0x01,0x01,
0x6,0x10,0x01,0x10,
0x6,0x10,0x01,0x11,
0x6,0x10,0x10,0x00,
0x6,0x10,0x10,0x01,
0x6,0x10,0x10,0x10,
0x6,0x10,0x10,0x11,
0x6,0x10,0x11,0x00,
0x6,0x10,0x11,0x01,
0x6,0x10,0x11,0x10,
0x6,0x10,0x11,0x11,
0x6,0x11,0x00,0x00,
0x6,0x11,0x00,0x01,
0x6,0x11,0x00,0x10,
0x6,0x11,0x00,0x11,
0x6,0x11,0x01,0x00,
0x6,0x11,0x01,0x01,
0x6,0x11,0x01,0x10,
0x6,0x11,0x01,0x11,
0x6,0x11,0x10,0x00,
0x6,0x11,0x10,0x01,
0x6,0x11,0x10,0x10,
0x6,0x11,0x10,0x11,
0x6,0x11,0x11,0x00,
0x6,0x11,0x11,0x01,
0x6,0x11,0x11,0x10,
0x4,0x00,0x00,
0x4,0x00,0x01,
0x4,0x00,0x02,
0x4,0x00,0x03,
0x4,0x00,0x10,
0x4,0x00,0x11,
0x4,0x00,0x12,
0x4,0x00,0x13,
0x4,0x00,0x20,
0x4,0x00,0x21,
0x4,0x00,0x22,
0x4,0x00,0x23,
0x4,0x00,0x30,
0x4,0x00,0x31,
0x4,0x00,0x32,
0x4,0x00,0x33,
0x4,0x01,0x00,
0x4,0x01,0x01,
0x4,0x01,0x02,
0x4,0x01,0x03,
0x4,0x01,0x10,
0x4,0x01,0x11,
0x4,0x01,0x12,
0x4,0x01,0x13,
0x4,0x01,0x20,
0x4,0x01,0x21,
0x4,0x01,0x22,
0x4,0x01,0x23,
0x4,0x01,0x30,
0x4,0x01,0x31,
0x4,0x01,0x32,
0x4,0x01,0x33,
0x4,0x02,0x00,
0x4,0x02,0x01,
0x4,0x02,0x02,
0x4,0x02,0x03,
0x4,0x02,0x10,
0x4,0x02,0x11,
0x4,0x02,0x12,
0x4,0x02,0x13,
0x4,0x02,0x20,
0x4,0x02,0x21,
0x4,0x02,0x22,
0x4,0x02,0x23,
0x4,0x02,0x30,
0x4,0x02,0x31,
0x4,0x02,0x32,
0x4,0x02,0x33,
0x4,0x03,0x00,
0x4,0x03,0x01,
0x4,0x03,0x02,
0x4,0x03,0x03,
0x4,0x03,0x10,
0x4,0x03,0x11,
0x4,0x03,0x12,
0x4,0x03,0x13,
0x4,0x03,0x20,
0x4,0x03,0x21,
0x4,0x03,0x22,
0x4,0x03,0x23,
0x4,0x03,0x30,
0x4,0x03,0x31,
0x4,0x03,0x32,
0x4,0x03,0x33,
0x4,0x10,0x00,
0x4,0x10,0x01,
0x4,0x10,0x02,
0x4,0x10,0x03,
0x4,0x10,0x10,
0x4,0x10,0x11,
0x4,0x10,0x12,
0x4,0x10,0x13,
0x4,0x10,0x20,
0x4,0x10,0x21,
0x4,0x10,0x22,
0x4,0x10,0x23,
0x4,0x10,0x30,
0x4,0x10,0x31,
0x4,0x10,0x32,
0x4,0x10,0x33,
0x4,0x11,0x00,
0x4,0x11,0x01,
0x4,0x11,0x02,
0x4,0x11,0x03,
0x4,0x11,0x10,
0x4,0x11,0x11,
0x4,0x11,0x12,
0x4,0x11,0x13,
0x4,0x11,0x20,
0x4,0x11,0x21,
0x4,0x11,0x22,
0x4,0x11,0x23,
0x4,0x11,0x30,
0x4,0x11,0x31,
0x4,0x11,0x32,
0x4,0x11,0x33,
0x4,0x12,0x00,
0x4,0x12,0x01,
0x4,0x12,0x02,
0x4,0x12,0x03,
0x4,0x12,0x10,
0x4,0x12,0x11,
0x4,0x12,0x12,
0x4,0x12,0x13,
0x4,0x12,0x20,
0x4,0x12,0x21,
0x4,0x12,0x22,
0x4,0x12,0x23,
0x4,0x12,0x30,
0x4,0x12,0x31,
0x4,0x12,0x32,
0x4,0x12,0x33,
0x4,0x13,0x00,
0x4,0x13,0x01,
0x4,0x13,0x02,
0x4,0x13,0x03,
0x4,0x13,0x10,
0x4,0x13,0x11,
0x4,0x13,0x12,
0x4,0x13,0x13,
0x4,0x13,0x20,
0x4,0x13,0x21,
0x4,0x13,0x22,
0x4,0x13,0x23,
0x4,0x13,0x30,
0x4,0x13,0x31,
0x4,0x13,0x32,
0x4,0x13,0x33,
0x2,0x00,
0x2,0x10,
0x2,0x20,
0x2,0x30,
0x2,0x40,
0x2,0x50,
0x2,0x60,
0x2,0x70,
0x2,0x01,
0x2,0x11,
0x2,0x21,
0x2,0x31,
0x2,0x41,
0x2,0x51,
0x2,0x61,
0x2,0x71,
0x2,0x02,
0x2,0x12,
0x2,0x22,
0x2,0x32,
0x2,0x42,
0x2,0x52,
0x2,0x62,
0x2,0x72,
0x2,0x03,
0x2,0x13,
0x2,0x23,
0x2,0x33,
0x2,0x43,
0x2,0x53,
0x2,0x63,
0x2,0x73,
0x2,0x04,
0x2,0x14,
0x2,0x24,
0x2,0x34,
0x2,0x44,
0x2,0x54,
0x2,0x64,
0x2,0x74,
0x2,0x05,
0x2,0x15,
0x2,0x25,
0x2,0x35,
0x2,0x45,
0x2,0x55,
0x2,0x65,
0x2,0x75,
0x2,0x06,
0x2,0x16,
0x2,0x26,
0x2,0x36,
0x2,0x46,
0x2,0x56,
0x2,0x66,
0x2,0x76,
0x2,0x07,
0x2,0x17,
0x2,0x27,
0x2,0x37,
0x2,0x47,
0x2,0x57,
0x2,0x67,
0x2,0x77

################################################################################

TITLE
    libavcodec truemotion pc_tbl4

TYPE
    8

DATA
0x8,0x00,0x00,0x00,0x00,
0x8,0x00,0x00,0x00,0x00,
0x8,0x20,0x00,0x00,0x00,
0x8,0x00,0x00,0x00,0x01,
0x8,0x10,0x00,0x00,0x00,
0x8,0x00,0x00,0x00,0x02,
0x8,0x01,0x00,0x00,0x00,
0x8,0x00,0x00,0x00,0x10,
0x8,0x02,0x00,0x00,0x00,
0x6,0x00,0x00,0x00,
0x6,0x20,0x00,0x00,
0x6,0x00,0x00,0x01,
0x6,0x10,0x00,0x00,
0x6,0x00,0x00,0x02,
0x6,0x00,0x10,0x00,
0x6,0x00,0x20,0x00,
0x6,0x00,0x02,0x00,
0x6,0x00,0x01,0x00,
0x6,0x01,0x00,0x00,
0x6,0x00,0x00,0x20,
0x6,0x02,0x00,0x00,
0x6,0x00,0x00,0x10,
0x6,0x10,0x00,0x20,
0x6,0x01,0x00,0x02,
0x6,0x20,0x00,0x10,
0x6,0x02,0x00,0x01,
0x6,0x20,0x10,0x00,
0x6,0x00,0x12,0x00,
0x6,0x00,0x02,0x01,
0x6,0x02,0x01,0x00,
0x6,0x00,0x21,0x00,
0x6,0x00,0x01,0x02,
0x6,0x00,0x20,0x10,
0x6,0x00,0x00,0x21,
0x6,0x00,0x00,0x12,
0x6,0x00,0x01,0x20,
0x6,0x12,0x00,0x00,
0x6,0x00,0x10,0x20,
0x6,0x01,0x20,0x00,
0x6,0x02,0x10,0x00,
0x6,0x10,0x20,0x00,
0x6,0x01,0x02,0x00,
0x6,0x21,0x00,0x00,
0x6,0x00,0x02,0x10,
0x6,0x20,0x01,0x00,
0x6,0x00,0x22,0x00,
0x6,0x10,0x02,0x00,
0x6,0x00,0x10,0x02,
0x6,0x11,0x00,0x00,
0x6,0x00,0x11,0x00,
0x6,0x22,0x00,0x00,
0x6,0x20,0x00,0x02,
0x6,0x10,0x00,0x01,
0x6,0x00,0x20,0x01,
0x6,0x02,0x20,0x00,
0x6,0x01,0x10,0x00,
0x6,0x01,0x00,0x20,
0x6,0x00,0x20,0x02,
0x6,0x01,0x20,0x02,
0x6,0x10,0x01,0x00,
0x6,0x02,0x00,0x10,
0x6,0x00,0x10,0x01,
0x6,0x10,0x01,0x20,
0x6,0x20,0x02,0x10,
0x6,0x00,0x00,0x22,
0x6,0x10,0x00,0x02,
0x6,0x00,0x02,0x20,
0x6,0x20,0x02,0x00,
0x6,0x00,0x00,0x11,
0x6,0x02,0x10,0x01,
0x6,0x00,0x01,0x10,
0x6,0x00,0x02,0x11,
0x4,0x01,0x02,
0x4,0x02,0x01,
0x4,0x01,0x00,
0x4,0x10,0x20,
0x4,0x20,0x10,
0x4,0x20,0x00,
0x4,0x11,0x00,
0x4,0x02,0x00,
0x4,0x12,0x00,
0x4,0x00,0x21,
0x4,0x22,0x00,
0x4,0x00,0x12,
0x4,0x21,0x00,
0x4,0x02,0x11,
0x4,0x00,0x01,
0x4,0x10,0x02,
0x4,0x02,0x20,
0x4,0x20,0x11,
0x4,0x01,0x10,
0x4,0x21,0x10,
0x4,0x10,0x00,
0x4,0x10,0x22,
0x4,0x20,0x20,
0x4,0x00,0x22,
0x4,0x01,0x22,
0x4,0x20,0x01,
0x4,0x02,0x02,
0x4,0x00,0x20,
0x4,0x00,0x10,
0x4,0x00,0x11,
0x4,0x22,0x01,
0x4,0x11,0x20,
0x4,0x12,0x01,
0x4,0x12,0x20,
0x4,0x11,0x02,
0x4,0x10,0x10,
0x4,0x01,0x01,
0x4,0x02,0x21,
0x4,0x20,0x12,
0x4,0x01,0x12,
0x4,0x22,0x11,
0x4,0x21,0x12,
0x4,0x22,0x10,
0x4,0x21,0x02,
0x4,0x20,0x02,
0x4,0x10,0x01,
0x4,0x00,0x02,
0x4,0x10,0x21,
0x4,0x01,0x20,
0x4,0x11,0x22,
0x4,0x12,0x21,
0x4,0x22,0x20,
0x4,0x02,0x10,
0x4,0x02,0x22,
0x4,0x11,0x10,
0x4,0x22,0x02,
0x4,0x20,0x21,
0x4,0x01,0x11,
0x4,0x11,0x01,
0x4,0x10,0x12,
0x4,0x02,0x12,
0x4,0x20,0x22,
0x4,0x21,0x20,
0x4,0x01,0x21,
0x4,0x12,0x02,
0x4,0x21,0x11,
0x4,0x12,0x22,
0x4,0x12,0x10,
0x4,0x22,0x21,
0x4,0x10,0x11,
0x4,0x21,0x01,
0x4,0x11,0x12,
0x4,0x12,0x11,
0x4,0x66,0x66,
0x4,0x22,0x22,
0x4,0x11,0x21,
0x4,0x11,0x11,
0x4,0x21,0x22,
0x4,0x00,0x00,
0x4,0x22,0x12,
0x4,0x12,0x12,
0x4,0x21,0x21,
0x4,0x42,0x00,
0x4,0x00,0x04,
0x4,0x40,0x00,
0x4,0x30,0x00,
0x4,0x31,0x00,
0x4,0x00,0x03,
0x4,0x00,0x14,
0x4,0x00,0x13,
0x4,0x01,0x24,
0x4,0x20,0x13,
0x4,0x01,0x42,
0x4,0x14,0x20,
0x4,0x42,0x02,
0x4,0x13,0x00,
0x4,0x00,0x24,
0x4,0x31,0x20,
0x4,0x22,0x13,
0x4,0x11,0x24,
0x4,0x12,0x66,
0x4,0x30,0x01,
0x4,0x02,0x13,
0x4,0x12,0x42,
0x4,0x40,0x10,
0x4,0x40,0x02,
0x4,0x01,0x04,
0x4,0x24,0x00,
0x4,0x42,0x10,
0x4,0x21,0x13,
0x4,0x13,0x12,
0x4,0x31,0x21,
0x4,0x21,0x24,
0x4,0x00,0x40,
0x4,0x10,0x24,
0x4,0x10,0x42,
0x4,0x32,0x01,
0x4,0x11,0x42,
0x4,0x20,0x31,
0x4,0x12,0x40,
0x2,0x00,
0x2,0x10,
0x2,0x20,
0x2,0x30,
0x2,0x40,
0x2,0x50,
0x2,0x60,
0x2,0x70,
0x2,0x01,
0x2,0x11,
0x2,0x21,
0x2,0x31,
0x2,0x41,
0x2,0x51,
0x2,0x61,
0x2,0x71,
0x2,0x02,
0x2,0x12,
0x2,0x22,
0x2,0x32,
0x2,0x42,
0x2,0x52,
0x2,0x62,
0x2,0x72,
0x2,0x03,
0x2,0x13,
0x2,0x23,
0x2,0x33,
0x2,0x43,
0x2,0x53,
0x2,0x63,
0x2,0x73,
0x2,0x04,
0x2,0x14,
0x2,0x24,
0x2,0x34,
0x2,0x44,
0x2,0x54,
0x2,0x64,
0x2,0x74,
0x2,0x05,
0x2,0x15,
0x2,0x25,
0x2,0x35,
0x2,0x45,
0x2,0x55,
0x2,0x65,
0x2,0x75,
0x2,0x06,
0x2,0x16,
0x2,0x26,
0x2,0x36,
0x2,0x46,
0x2,0x56,
0x2,0x66,
0x2,0x76,
0x2,0x07,
0x2,0x17,
0x2,0x27,
0x2,0x37,
0x2,0x47,
0x2,0x57,
0x2,0x67,
0x2,0x77

################################################################################

TITLE
    libavcodec truespeech ts_cb_0

TYPE
    16

DATA
    0x8240, 0x8364, 0x84CE, 0x865D, 0x8805, 0x89DE, 0x8BD7, 0x8DF4,
    0x9051, 0x92E2, 0x95DE, 0x990F, 0x9C81, 0xA079, 0xA54C, 0xAAD2,
    0xB18A, 0xB90A, 0xC124, 0xC9CC, 0xD339, 0xDDD3, 0xE9D6, 0xF893,
    0x096F, 0x1ACA, 0x29EC, 0x381F, 0x45F9, 0x546A, 0x63C3, 0x73B5,

################################################################################

TITLE
    libavcodec truespeech ts_cb_1

TYPE
    16

DATA
    0x9F65, 0xB56B, 0xC583, 0xD371, 0xE018, 0xEBB4, 0xF61C, 0xFF59,
    0x085B, 0x1106, 0x1952, 0x214A, 0x28C9, 0x2FF8, 0x36E6, 0x3D92,
    0x43DF, 0x49BB, 0x4F46, 0x5467, 0x5930, 0x5DA3, 0x61EC, 0x65F9,
    0x69D4, 0x6D5A, 0x709E, 0x73AD, 0x766B, 0x78F0, 0x7B5A, 0x7DA5,

################################################################################

TITLE
    libavcodec truespeech ts_cb_2

TYPE
    16

DATA
    0x96F8, 0xA3B4, 0xAF45, 0xBA53, 0xC4B1, 0xCECC, 0xD86F, 0xE21E,
    0xEBF3, 0xF640, 0x00F7, 0x0C20, 0x1881, 0x269A, 0x376B, 0x4D60,

################################################################################

TITLE
    libavcodec truespeech ts_cb_3

TYPE
    16

DATA
    0xC654, 0xDEF2, 0xEFAA, 0xFD94, 0x096A, 0x143F, 0x1E7B, 0x282C,
    0x3176, 0x3A89, 0x439F, 0x4CA2, 0x557F, 0x5E50, 0x6718, 0x6F8D,

################################################################################

TITLE
    libavcodec truespeech ts_cb_4

TYPE
    16

DATA
    0xABE7, 0xBBA8, 0xC81C, 0xD326, 0xDD0E, 0xE5D4, 0xEE22, 0xF618,
    0xFE28, 0x064F, 0x0EB7, 0x17B8, 0x21AA, 0x2D8B, 0x3BA2, 0x4DF9,

################################################################################

TITLE
    libavcodec truespeech ts_cb_5

TYPE
    16

DATA
    0xD51B, 0xF12E, 0x042E, 0x13C7, 0x2260, 0x311B, 0x40DE, 0x5385,

################################################################################

TITLE
    libavcodec truespeech ts_cb_6

TYPE
    16

DATA
    0xB550, 0xC825, 0xD980, 0xE997, 0xF883, 0x0752, 0x1811, 0x2E18,

################################################################################

TITLE
    libavcodec truespeech ts_cb_7

TYPE
    16

DATA
    0xCEF0, 0xE4F9, 0xF6BB, 0x0646, 0x14F5, 0x23FF, 0x356F, 0x4A8D,

################################################################################

TITLE
    libavcodec truespeech ts_140

TYPE
    16

DATA
    0x0E46, 0x0CCC, 0x0B6D, 0x0A28, 0x08FC, 0x07E8, 0x06EB, 0x0604,
    0x0532, 0x0474, 0x03C9, 0x0330, 0x02A8, 0x0230, 0x01C7, 0x016C,
    0x011E, 0x00DC, 0x00A5, 0x0078, 0x0054, 0x0038, 0x0023, 0x0014,
    0x000A, 0x0004, 0x0001, 0x0000, 0x0000, 0x0000,

    0x0196, 0x017A, 0x015F, 0x0145, 0x012C, 0x0114, 0x00FD, 0x00E7,
    0x00D2, 0x00BE, 0x00AB, 0x0099, 0x0088, 0x0078, 0x0069, 0x005B,
    0x004E, 0x0042, 0x0037, 0x002D, 0x0024, 0x001C, 0x0015, 0x000F,
    0x000A, 0x0006, 0x0003, 0x0001, 0x0000, 0x0000,

    0x001D, 0x001C, 0x001B, 0x001A, 0x0019, 0x0018, 0x0017, 0x0016,
    0x0015, 0x0014, 0x0013, 0x0012, 0x0011, 0x0010, 0x000F, 0x000E,
    0x000D, 0x000C, 0x000B, 0x000A, 0x0009, 0x0008, 0x0007, 0x0006,
    0x0005, 0x0004, 0x0003, 0x0002, 0x0001, 0x0000,

    0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
    0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
    0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
    0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001

################################################################################

TITLE
    libavcodec truespeech ts_230

TYPE
    16

DATA
    { 0x7F3B, 0x7E78, 0x7DB6, 0x7CF5, 0x7C35, 0x7B76, 0x7AB8, 0x79FC };

################################################################################

TITLE
    libavcodec truespeech ts_240

TYPE
    16

DATA
    0xED2F, 0x5239,
    0x54F1, 0xE4A9,
    0x2620, 0xEE3E,
    0x09D6, 0x2C40,
    0xEFB5, 0x2BE0,

    0x3FE1, 0x3339,
    0x442F, 0xE6FE,
    0x4458, 0xF9DF,
    0xF231, 0x43DB,
    0x3DB0, 0xF705,

    0x4F7B, 0xFEFB,
    0x26AD, 0x0CDC,
    0x33C2, 0x0739,
    0x12BE, 0x43A2,
    0x1BDF, 0x1F3E,

    0x0211, 0x0796,
    0x2AEB, 0x163F,
    0x050D, 0x3A38,
    0x0D1E, 0x0D78,
    0x150F, 0x3346,

    0x38A4, 0x0B7D,
    0x2D5D, 0x1FDF,
    0x19B7, 0x2822,
    0x0D99, 0x1F12,
    0x194C, 0x0CE6

################################################################################

TITLE
    libavcodec truespeech ts_562

TYPE
    16

DATA
    0x0002, 0x0006, 0xFFFE, 0xFFFA,
    0x0004, 0x000C, 0xFFFC, 0xFFF4,
    0x0006, 0x0012, 0xFFFA, 0xFFEE,
    0x000A, 0x001E, 0xFFF6, 0xFFE2,
    0x0010, 0x0030, 0xFFF0, 0xFFD0,
    0x0019, 0x004B, 0xFFE7, 0xFFB5,
    0x0028, 0x0078, 0xFFD8, 0xFF88,
    0x0040, 0x00C0, 0xFFC0, 0xFF40,
    0x0065, 0x012F, 0xFF9B, 0xFED1,
    0x00A1, 0x01E3, 0xFF5F, 0xFE1D,
    0x0100, 0x0300, 0xFF00, 0xFD00,
    0x0196, 0x04C2, 0xFE6A, 0xFB3E,
    0x0285, 0x078F, 0xFD7B, 0xF871,
    0x0400, 0x0C00, 0xFC00, 0xF400,
    0x0659, 0x130B, 0xF9A7, 0xECF5,
    0x0A14, 0x1E3C, 0xF5EC, 0xE1C4

################################################################################

TITLE
    libavcodec truespeech ts_5E2

TYPE
    16

DATA
    { 0x4666, 0x26B8, 0x154C, 0x0BB6, 0x0671, 0x038B, 0x01F3, 0x0112 };

################################################################################

TITLE
    libavcodec truespeech ts_5F2

TYPE
    16

DATA
    { 0x6000, 0x4800, 0x3600, 0x2880, 0x1E60, 0x16C8, 0x1116, 0x0CD1 };

################################################################################

TITLE
    libavcodec ultimotion ulti_lumas

TYPE
    8

DATA
    { 0x10, 0x13, 0x17, 0x1A, 0x1E, 0x21, 0x25, 0x28,
      0x2C, 0x2F, 0x33, 0x36, 0x3A, 0x3D, 0x41, 0x44,
      0x48, 0x4B, 0x4F, 0x52, 0x56, 0x59, 0x5C, 0x60,
      0x63, 0x67, 0x6A, 0x6E, 0x71, 0x75, 0x78, 0x7C,
      0x7F, 0x83, 0x86, 0x8A, 0x8D, 0x91, 0x94, 0x98,
      0x9B, 0x9F, 0xA2, 0xA5, 0xA9, 0xAC, 0xB0, 0xB3,
      0xB7, 0xBA, 0xBE, 0xC1, 0xC5, 0xC8, 0xCC, 0xCF,
      0xD3, 0xD6, 0xDA, 0xDD, 0xE1, 0xE4, 0xE8, 0xEB};

################################################################################

TITLE
    libavcodec ultimotion ulti_chromas

TYPE
    8

DATA
    { 0x60, 0x67, 0x6D, 0x73, 0x7A, 0x80, 0x86, 0x8D,
      0x93, 0x99, 0xA0, 0xA6, 0xAC, 0xB3, 0xB9, 0xC0};

################################################################################

TITLE
    libavcodec ultimotion ulti_codebook

TYPE
    8

DATA
    0x00, 0x01, 0x01, 0x02,
    0x00, 0x01, 0x02, 0x03,
    0x00, 0x02, 0x03, 0x04,
    0x00, 0x01, 0x03, 0x04,
    0x00, 0x01, 0x02, 0x04,
    0x00, 0x02, 0x03, 0x05,
    0x00, 0x02, 0x04, 0x05,
    0x00, 0x01, 0x04, 0x05,
    0x00, 0x01, 0x03, 0x05,
    0x00, 0x02, 0x04, 0x06,
    0x00, 0x03, 0x05, 0x06,
    0x00, 0x01, 0x05, 0x06,
    0x00, 0x01, 0x03, 0x06,
    0x00, 0x06, 0x06, 0x06,
    0x00, 0x00, 0x06, 0x06,
    0x00, 0x00, 0x00, 0x06,
    0x00, 0x03, 0x04, 0x07,
    0x00, 0x03, 0x06, 0x07,
    0x00, 0x01, 0x06, 0x07,
    0x00, 0x01, 0x04, 0x07,
    0x00, 0x03, 0x05, 0x08,
    0x00, 0x04, 0x06, 0x08,
    0x00, 0x02, 0x06, 0x08,
    0x00, 0x02, 0x04, 0x08,
    0x00, 0x08, 0x08, 0x08,
    0x00, 0x00, 0x08, 0x08,
    0x00, 0x00, 0x00, 0x08,
    0x00, 0x04, 0x07, 0x0B,
    0x00, 0x05, 0x09, 0x0B,
    0x00, 0x02, 0x09, 0x0B,
    0x00, 0x02, 0x06, 0x0B,
    0x00, 0x0B, 0x0B, 0x0B,
    0x00, 0x00, 0x0B, 0x0B,
    0x00, 0x00, 0x00, 0x0B,
    0x00, 0x05, 0x09, 0x0E,
    0x00, 0x07, 0x0B, 0x0E,
    0x00, 0x03, 0x0B, 0x0E,
    0x00, 0x03, 0x07, 0x0E,
    0x00, 0x0E, 0x0E, 0x0E,
    0x00, 0x00, 0x0E, 0x0E,
    0x00, 0x00, 0x00, 0x0E,
    0x00, 0x06, 0x0B, 0x11,
    0x00, 0x08, 0x0D, 0x11,
    0x00, 0x04, 0x0D, 0x11,
    0x00, 0x04, 0x09, 0x11,
    0x00, 0x11, 0x11, 0x11,
    0x00, 0x00, 0x11, 0x11,
    0x00, 0x00, 0x00, 0x11,
    0x00, 0x07, 0x0D, 0x14,
    0x00, 0x0A, 0x0F, 0x14,
    0x00, 0x05, 0x0F, 0x14,
    0x00, 0x05, 0x0A, 0x14,
    0x00, 0x14, 0x14, 0x14,
    0x00, 0x00, 0x14, 0x14,
    0x00, 0x00, 0x00, 0x14,
    0x00, 0x0B, 0x12, 0x17,
    0x00, 0x05, 0x12, 0x17,
    0x00, 0x05, 0x0C, 0x17,
    0x00, 0x17, 0x17, 0x17,
    0x00, 0x00, 0x17, 0x17,
    0x00, 0x00, 0x00, 0x17,
    0x00, 0x0D, 0x14, 0x1A,
    0x00, 0x06, 0x14, 0x1A,
    0x00, 0x06, 0x0D, 0x1A,
    0x00, 0x1A, 0x1A, 0x1A,
    0x00, 0x00, 0x1A, 0x1A,
    0x00, 0x00, 0x00, 0x1A,
    0x00, 0x0E, 0x16, 0x1D,
    0x00, 0x07, 0x16, 0x1D,
    0x00, 0x07, 0x0F, 0x1D,
    0x00, 0x1D, 0x1D, 0x1D,
    0x00, 0x00, 0x1D, 0x1D,
    0x00, 0x00, 0x00, 0x1D,
    0x00, 0x10, 0x18, 0x20,
    0x00, 0x08, 0x18, 0x20,
    0x00, 0x08, 0x10, 0x20,
    0x00, 0x20, 0x20, 0x20,
    0x00, 0x00, 0x20, 0x20,
    0x00, 0x00, 0x00, 0x20,
    0x00, 0x23, 0x23, 0x23,
    0x00, 0x00, 0x23, 0x23,
    0x00, 0x00, 0x00, 0x23,
    0x00, 0x12, 0x1B, 0x24,
    0x00, 0x09, 0x1B, 0x24,
    0x00, 0x09, 0x12, 0x24,
    0x00, 0x28, 0x28, 0x28,
    0x00, 0x00, 0x28, 0x28,
    0x00, 0x00, 0x00, 0x28,
    0x00, 0x2E, 0x2E, 0x2E,
    0x00, 0x00, 0x2E, 0x2E,
    0x00, 0x00, 0x00, 0x2E,
    0x01, 0x02, 0x02, 0x03,
    0x01, 0x02, 0x03, 0x04,
    0x01, 0x03, 0x04, 0x05,
    0x01, 0x02, 0x04, 0x05,
    0x01, 0x02, 0x03, 0x05,
    0x01, 0x03, 0x04, 0x06,
    0x01, 0x03, 0x05, 0x06,
    0x01, 0x02, 0x05, 0x06,
    0x01, 0x02, 0x04, 0x06,
    0x01, 0x03, 0x05, 0x07,
    0x01, 0x04, 0x06, 0x07,
    0x01, 0x02, 0x06, 0x07,
    0x01, 0x02, 0x04, 0x07,
    0x01, 0x07, 0x07, 0x07,
    0x01, 0x01, 0x07, 0x07,
    0x01, 0x01, 0x01, 0x07,
    0x01, 0x04, 0x05, 0x08,
    0x01, 0x04, 0x07, 0x08,
    0x01, 0x02, 0x07, 0x08,
    0x01, 0x02, 0x05, 0x08,
    0x01, 0x04, 0x06, 0x09,
    0x01, 0x05, 0x07, 0x09,
    0x01, 0x03, 0x07, 0x09,
    0x01, 0x03, 0x05, 0x09,
    0x01, 0x09, 0x09, 0x09,
    0x01, 0x01, 0x09, 0x09,
    0x01, 0x01, 0x01, 0x09,
    0x01, 0x05, 0x08, 0x0C,
    0x01, 0x06, 0x0A, 0x0C,
    0x01, 0x03, 0x0A, 0x0C,
    0x01, 0x03, 0x07, 0x0C,
    0x01, 0x0C, 0x0C, 0x0C,
    0x01, 0x01, 0x0C, 0x0C,
    0x01, 0x01, 0x01, 0x0C,
    0x01, 0x06, 0x0A, 0x0F,
    0x01, 0x08, 0x0C, 0x0F,
    0x01, 0x04, 0x0C, 0x0F,
    0x01, 0x04, 0x08, 0x0F,
    0x01, 0x0F, 0x0F, 0x0F,
    0x01, 0x01, 0x0F, 0x0F,
    0x01, 0x01, 0x01, 0x0F,
    0x01, 0x07, 0x0C, 0x12,
    0x01, 0x09, 0x0E, 0x12,
    0x01, 0x05, 0x0E, 0x12,
    0x01, 0x05, 0x0A, 0x12,
    0x01, 0x12, 0x12, 0x12,
    0x01, 0x01, 0x12, 0x12,
    0x01, 0x01, 0x01, 0x12,
    0x01, 0x08, 0x0E, 0x15,
    0x01, 0x0B, 0x10, 0x15,
    0x01, 0x06, 0x10, 0x15,
    0x01, 0x06, 0x0B, 0x15,
    0x01, 0x15, 0x15, 0x15,
    0x01, 0x01, 0x15, 0x15,
    0x01, 0x01, 0x01, 0x15,
    0x01, 0x0C, 0x13, 0x18,
    0x01, 0x06, 0x13, 0x18,
    0x01, 0x06, 0x0D, 0x18,
    0x01, 0x18, 0x18, 0x18,
    0x01, 0x01, 0x18, 0x18,
    0x01, 0x01, 0x01, 0x18,
    0x01, 0x0E, 0x15, 0x1B,
    0x01, 0x07, 0x15, 0x1B,
    0x01, 0x07, 0x0E, 0x1B,
    0x01, 0x1B, 0x1B, 0x1B,
    0x01, 0x01, 0x1B, 0x1B,
    0x01, 0x01, 0x01, 0x1B,
    0x01, 0x0F, 0x17, 0x1E,
    0x01, 0x08, 0x17, 0x1E,
    0x01, 0x08, 0x10, 0x1E,
    0x01, 0x1E, 0x1E, 0x1E,
    0x01, 0x01, 0x1E, 0x1E,
    0x01, 0x01, 0x01, 0x1E,
    0x01, 0x11, 0x19, 0x21,
    0x01, 0x09, 0x19, 0x21,
    0x01, 0x09, 0x11, 0x21,
    0x01, 0x21, 0x21, 0x21,
    0x01, 0x01, 0x21, 0x21,
    0x01, 0x01, 0x01, 0x21,
    0x01, 0x24, 0x24, 0x24,
    0x01, 0x01, 0x24, 0x24,
    0x01, 0x01, 0x01, 0x24,
    0x01, 0x13, 0x1C, 0x25,
    0x01, 0x0A, 0x1C, 0x25,
    0x01, 0x0A, 0x13, 0x25,
    0x01, 0x29, 0x29, 0x29,
    0x01, 0x01, 0x29, 0x29,
    0x01, 0x01, 0x01, 0x29,
    0x01, 0x2F, 0x2F, 0x2F,
    0x01, 0x01, 0x2F, 0x2F,
    0x01, 0x01, 0x01, 0x2F,
    0x02, 0x03, 0x03, 0x04,
    0x02, 0x03, 0x04, 0x05,
    0x02, 0x04, 0x05, 0x06,
    0x02, 0x03, 0x05, 0x06,
    0x02, 0x03, 0x04, 0x06,
    0x02, 0x04, 0x05, 0x07,
    0x02, 0x04, 0x06, 0x07,
    0x02, 0x03, 0x06, 0x07,
    0x02, 0x03, 0x05, 0x07,
    0x02, 0x04, 0x06, 0x08,
    0x02, 0x05, 0x07, 0x08,
    0x02, 0x03, 0x07, 0x08,
    0x02, 0x03, 0x05, 0x08,
    0x02, 0x08, 0x08, 0x08,
    0x02, 0x02, 0x08, 0x08,
    0x02, 0x02, 0x02, 0x08,
    0x02, 0x05, 0x06, 0x09,
    0x02, 0x05, 0x08, 0x09,
    0x02, 0x03, 0x08, 0x09,
    0x02, 0x03, 0x06, 0x09,
    0x02, 0x05, 0x07, 0x0A,
    0x02, 0x06, 0x08, 0x0A,
    0x02, 0x04, 0x08, 0x0A,
    0x02, 0x04, 0x06, 0x0A,
    0x02, 0x0A, 0x0A, 0x0A,
    0x02, 0x02, 0x0A, 0x0A,
    0x02, 0x02, 0x02, 0x0A,
    0x02, 0x06, 0x09, 0x0D,
    0x02, 0x07, 0x0B, 0x0D,
    0x02, 0x04, 0x0B, 0x0D,
    0x02, 0x04, 0x08, 0x0D,
    0x02, 0x0D, 0x0D, 0x0D,
    0x02, 0x02, 0x0D, 0x0D,
    0x02, 0x02, 0x02, 0x0D,
    0x02, 0x07, 0x0B, 0x10,
    0x02, 0x09, 0x0D, 0x10,
    0x02, 0x05, 0x0D, 0x10,
    0x02, 0x05, 0x09, 0x10,
    0x02, 0x10, 0x10, 0x10,
    0x02, 0x02, 0x10, 0x10,
    0x02, 0x02, 0x02, 0x10,
    0x02, 0x08, 0x0D, 0x13,
    0x02, 0x0A, 0x0F, 0x13,
    0x02, 0x06, 0x0F, 0x13,
    0x02, 0x06, 0x0B, 0x13,
    0x02, 0x13, 0x13, 0x13,
    0x02, 0x02, 0x13, 0x13,
    0x02, 0x02, 0x02, 0x13,
    0x02, 0x09, 0x0F, 0x16,
    0x02, 0x0C, 0x11, 0x16,
    0x02, 0x07, 0x11, 0x16,
    0x02, 0x07, 0x0C, 0x16,
    0x02, 0x16, 0x16, 0x16,
    0x02, 0x02, 0x16, 0x16,
    0x02, 0x02, 0x02, 0x16,
    0x02, 0x0D, 0x14, 0x19,
    0x02, 0x07, 0x14, 0x19,
    0x02, 0x07, 0x0E, 0x19,
    0x02, 0x19, 0x19, 0x19,
    0x02, 0x02, 0x19, 0x19,
    0x02, 0x02, 0x02, 0x19,
    0x02, 0x0F, 0x16, 0x1C,
    0x02, 0x08, 0x16, 0x1C,
    0x02, 0x08, 0x0F, 0x1C,
    0x02, 0x1C, 0x1C, 0x1C,
    0x02, 0x02, 0x1C, 0x1C,
    0x02, 0x02, 0x02, 0x1C,
    0x02, 0x10, 0x18, 0x1F,
    0x02, 0x09, 0x18, 0x1F,
    0x02, 0x09, 0x11, 0x1F,
    0x02, 0x1F, 0x1F, 0x1F,
    0x02, 0x02, 0x1F, 0x1F,
    0x02, 0x02, 0x02, 0x1F,
    0x02, 0x12, 0x1A, 0x22,
    0x02, 0x0A, 0x1A, 0x22,
    0x02, 0x0A, 0x12, 0x22,
    0x02, 0x22, 0x22, 0x22,
    0x02, 0x02, 0x22, 0x22,
    0x02, 0x02, 0x02, 0x22,
    0x02, 0x25, 0x25, 0x25,
    0x02, 0x02, 0x25, 0x25,
    0x02, 0x02, 0x02, 0x25,
    0x02, 0x14, 0x1D, 0x26,
    0x02, 0x0B, 0x1D, 0x26,
    0x02, 0x0B, 0x14, 0x26,
    0x02, 0x2A, 0x2A, 0x2A,
    0x02, 0x02, 0x2A, 0x2A,
    0x02, 0x02, 0x02, 0x2A,
    0x02, 0x30, 0x30, 0x30,
    0x02, 0x02, 0x30, 0x30,
    0x02, 0x02, 0x02, 0x30,
    0x03, 0x04, 0x04, 0x05,
    0x03, 0x04, 0x05, 0x06,
    0x03, 0x05, 0x06, 0x07,
    0x03, 0x04, 0x06, 0x07,
    0x03, 0x04, 0x05, 0x07,
    0x03, 0x05, 0x06, 0x08,
    0x03, 0x05, 0x07, 0x08,
    0x03, 0x04, 0x07, 0x08,
    0x03, 0x04, 0x06, 0x08,
    0x03, 0x05, 0x07, 0x09,
    0x03, 0x06, 0x08, 0x09,
    0x03, 0x04, 0x08, 0x09,
    0x03, 0x04, 0x06, 0x09,
    0x03, 0x09, 0x09, 0x09,
    0x03, 0x03, 0x09, 0x09,
    0x03, 0x03, 0x03, 0x09,
    0x03, 0x06, 0x07, 0x0A,
    0x03, 0x06, 0x09, 0x0A,
    0x03, 0x04, 0x09, 0x0A,
    0x03, 0x04, 0x07, 0x0A,
    0x03, 0x06, 0x08, 0x0B,
    0x03, 0x07, 0x09, 0x0B,
    0x03, 0x05, 0x09, 0x0B,
    0x03, 0x05, 0x07, 0x0B,
    0x03, 0x0B, 0x0B, 0x0B,
    0x03, 0x03, 0x0B, 0x0B,
    0x03, 0x03, 0x03, 0x0B,
    0x03, 0x07, 0x0A, 0x0E,
    0x03, 0x08, 0x0C, 0x0E,
    0x03, 0x05, 0x0C, 0x0E,
    0x03, 0x05, 0x09, 0x0E,
    0x03, 0x0E, 0x0E, 0x0E,
    0x03, 0x03, 0x0E, 0x0E,
    0x03, 0x03, 0x03, 0x0E,
    0x03, 0x08, 0x0C, 0x11,
    0x03, 0x0A, 0x0E, 0x11,
    0x03, 0x06, 0x0E, 0x11,
    0x03, 0x06, 0x0A, 0x11,
    0x03, 0x11, 0x11, 0x11,
    0x03, 0x03, 0x11, 0x11,
    0x03, 0x03, 0x03, 0x11,
    0x03, 0x09, 0x0E, 0x14,
    0x03, 0x0B, 0x10, 0x14,
    0x03, 0x07, 0x10, 0x14,
    0x03, 0x07, 0x0C, 0x14,
    0x03, 0x14, 0x14, 0x14,
    0x03, 0x03, 0x14, 0x14,
    0x03, 0x03, 0x03, 0x14,
    0x03, 0x0A, 0x10, 0x17,
    0x03, 0x0D, 0x12, 0x17,
    0x03, 0x08, 0x12, 0x17,
    0x03, 0x08, 0x0D, 0x17,
    0x03, 0x17, 0x17, 0x17,
    0x03, 0x03, 0x17, 0x17,
    0x03, 0x03, 0x03, 0x17,
    0x03, 0x0E, 0x15, 0x1A,
    0x03, 0x08, 0x15, 0x1A,
    0x03, 0x08, 0x0F, 0x1A,
    0x03, 0x1A, 0x1A, 0x1A,
    0x03, 0x03, 0x1A, 0x1A,
    0x03, 0x03, 0x03, 0x1A,
    0x03, 0x10, 0x17, 0x1D,
    0x03, 0x09, 0x17, 0x1D,
    0x03, 0x09, 0x10, 0x1D,
    0x03, 0x1D, 0x1D, 0x1D,
    0x03, 0x03, 0x1D, 0x1D,
    0x03, 0x03, 0x03, 0x1D,
    0x03, 0x11, 0x19, 0x20,
    0x03, 0x0A, 0x19, 0x20,
    0x03, 0x0A, 0x12, 0x20,
    0x03, 0x20, 0x20, 0x20,
    0x03, 0x03, 0x20, 0x20,
    0x03, 0x03, 0x03, 0x20,
    0x03, 0x13, 0x1B, 0x23,
    0x03, 0x0B, 0x1B, 0x23,
    0x03, 0x0B, 0x13, 0x23,
    0x03, 0x23, 0x23, 0x23,
    0x03, 0x03, 0x23, 0x23,
    0x03, 0x03, 0x03, 0x23,
    0x03, 0x26, 0x26, 0x26,
    0x03, 0x03, 0x26, 0x26,
    0x03, 0x03, 0x03, 0x26,
    0x03, 0x15, 0x1E, 0x27,
    0x03, 0x0C, 0x1E, 0x27,
    0x03, 0x0C, 0x15, 0x27,
    0x03, 0x2B, 0x2B, 0x2B,
    0x03, 0x03, 0x2B, 0x2B,
    0x03, 0x03, 0x03, 0x2B,
    0x03, 0x31, 0x31, 0x31,
    0x03, 0x03, 0x31, 0x31,
    0x03, 0x03, 0x03, 0x31,
    0x04, 0x05, 0x05, 0x06,
    0x04, 0x05, 0x06, 0x07,
    0x04, 0x06, 0x07, 0x08,
    0x04, 0x05, 0x07, 0x08,
    0x04, 0x05, 0x06, 0x08,
    0x04, 0x06, 0x07, 0x09,
    0x04, 0x06, 0x08, 0x09,
    0x04, 0x05, 0x08, 0x09,
    0x04, 0x05, 0x07, 0x09,
    0x04, 0x06, 0x08, 0x0A,
    0x04, 0x07, 0x09, 0x0A,
    0x04, 0x05, 0x09, 0x0A,
    0x04, 0x05, 0x07, 0x0A,
    0x04, 0x0A, 0x0A, 0x0A,
    0x04, 0x04, 0x0A, 0x0A,
    0x04, 0x04, 0x04, 0x0A,
    0x04, 0x07, 0x08, 0x0B,
    0x04, 0x07, 0x0A, 0x0B,
    0x04, 0x05, 0x0A, 0x0B,
    0x04, 0x05, 0x08, 0x0B,
    0x04, 0x07, 0x09, 0x0C,
    0x04, 0x08, 0x0A, 0x0C,
    0x04, 0x06, 0x0A, 0x0C,
    0x04, 0x06, 0x08, 0x0C,
    0x04, 0x0C, 0x0C, 0x0C,
    0x04, 0x04, 0x0C, 0x0C,
    0x04, 0x04, 0x04, 0x0C,
    0x04, 0x08, 0x0B, 0x0F,
    0x04, 0x09, 0x0D, 0x0F,
    0x04, 0x06, 0x0D, 0x0F,
    0x04, 0x06, 0x0A, 0x0F,
    0x04, 0x0F, 0x0F, 0x0F,
    0x04, 0x04, 0x0F, 0x0F,
    0x04, 0x04, 0x04, 0x0F,
    0x04, 0x09, 0x0D, 0x12,
    0x04, 0x0B, 0x0F, 0x12,
    0x04, 0x07, 0x0F, 0x12,
    0x04, 0x07, 0x0B, 0x12,
    0x04, 0x12, 0x12, 0x12,
    0x04, 0x04, 0x12, 0x12,
    0x04, 0x04, 0x04, 0x12,
    0x04, 0x0A, 0x0F, 0x15,
    0x04, 0x0C, 0x11, 0x15,
    0x04, 0x08, 0x11, 0x15,
    0x04, 0x08, 0x0D, 0x15,
    0x04, 0x15, 0x15, 0x15,
    0x04, 0x04, 0x15, 0x15,
    0x04, 0x04, 0x04, 0x15,
    0x04, 0x0B, 0x11, 0x18,
    0x04, 0x0E, 0x13, 0x18,
    0x04, 0x09, 0x13, 0x18,
    0x04, 0x09, 0x0E, 0x18,
    0x04, 0x18, 0x18, 0x18,
    0x04, 0x04, 0x18, 0x18,
    0x04, 0x04, 0x04, 0x18,
    0x04, 0x0F, 0x16, 0x1B,
    0x04, 0x09, 0x16, 0x1B,
    0x04, 0x09, 0x10, 0x1B,
    0x04, 0x1B, 0x1B, 0x1B,
    0x04, 0x04, 0x1B, 0x1B,
    0x04, 0x04, 0x04, 0x1B,
    0x04, 0x11, 0x18, 0x1E,
    0x04, 0x0A, 0x18, 0x1E,
    0x04, 0x0A, 0x11, 0x1E,
    0x04, 0x1E, 0x1E, 0x1E,
    0x04, 0x04, 0x1E, 0x1E,
    0x04, 0x04, 0x04, 0x1E,
    0x04, 0x12, 0x1A, 0x21,
    0x04, 0x0B, 0x1A, 0x21,
    0x04, 0x0B, 0x13, 0x21,
    0x04, 0x21, 0x21, 0x21,
    0x04, 0x04, 0x21, 0x21,
    0x04, 0x04, 0x04, 0x21,
    0x04, 0x14, 0x1C, 0x24,
    0x04, 0x0C, 0x1C, 0x24,
    0x04, 0x0C, 0x14, 0x24,
    0x04, 0x24, 0x24, 0x24,
    0x04, 0x04, 0x24, 0x24,
    0x04, 0x04, 0x04, 0x24,
    0x04, 0x27, 0x27, 0x27,
    0x04, 0x04, 0x27, 0x27,
    0x04, 0x04, 0x04, 0x27,
    0x04, 0x16, 0x1F, 0x28,
    0x04, 0x0D, 0x1F, 0x28,
    0x04, 0x0D, 0x16, 0x28,
    0x04, 0x2C, 0x2C, 0x2C,
    0x04, 0x04, 0x2C, 0x2C,
    0x04, 0x04, 0x04, 0x2C,
    0x04, 0x32, 0x32, 0x32,
    0x04, 0x04, 0x32, 0x32,
    0x04, 0x04, 0x04, 0x32,
    0x05, 0x06, 0x06, 0x07,
    0x05, 0x06, 0x07, 0x08,
    0x05, 0x07, 0x08, 0x09,
    0x05, 0x06, 0x08, 0x09,
    0x05, 0x06, 0x07, 0x09,
    0x05, 0x07, 0x08, 0x0A,
    0x05, 0x07, 0x09, 0x0A,
    0x05, 0x06, 0x09, 0x0A,
    0x05, 0x06, 0x08, 0x0A,
    0x05, 0x07, 0x09, 0x0B,
    0x05, 0x08, 0x0A, 0x0B,
    0x05, 0x06, 0x0A, 0x0B,
    0x05, 0x06, 0x08, 0x0B,
    0x05, 0x0B, 0x0B, 0x0B,
    0x05, 0x05, 0x0B, 0x0B,
    0x05, 0x05, 0x05, 0x0B,
    0x05, 0x08, 0x09, 0x0C,
    0x05, 0x08, 0x0B, 0x0C,
    0x05, 0x06, 0x0B, 0x0C,
    0x05, 0x06, 0x09, 0x0C,
    0x05, 0x08, 0x0A, 0x0D,
    0x05, 0x09, 0x0B, 0x0D,
    0x05, 0x07, 0x0B, 0x0D,
    0x05, 0x07, 0x09, 0x0D,
    0x05, 0x0D, 0x0D, 0x0D,
    0x05, 0x05, 0x0D, 0x0D,
    0x05, 0x05, 0x05, 0x0D,
    0x05, 0x09, 0x0C, 0x10,
    0x05, 0x0A, 0x0E, 0x10,
    0x05, 0x07, 0x0E, 0x10,
    0x05, 0x07, 0x0B, 0x10,
    0x05, 0x10, 0x10, 0x10,
    0x05, 0x05, 0x10, 0x10,
    0x05, 0x05, 0x05, 0x10,
    0x05, 0x0A, 0x0E, 0x13,
    0x05, 0x0C, 0x10, 0x13,
    0x05, 0x08, 0x10, 0x13,
    0x05, 0x08, 0x0C, 0x13,
    0x05, 0x13, 0x13, 0x13,
    0x05, 0x05, 0x13, 0x13,
    0x05, 0x05, 0x05, 0x13,
    0x05, 0x0B, 0x10, 0x16,
    0x05, 0x0D, 0x12, 0x16,
    0x05, 0x09, 0x12, 0x16,
    0x05, 0x09, 0x0E, 0x16,
    0x05, 0x16, 0x16, 0x16,
    0x05, 0x05, 0x16, 0x16,
    0x05, 0x05, 0x05, 0x16,
    0x05, 0x0C, 0x12, 0x19,
    0x05, 0x0F, 0x14, 0x19,
    0x05, 0x0A, 0x14, 0x19,
    0x05, 0x0A, 0x0F, 0x19,
    0x05, 0x19, 0x19, 0x19,
    0x05, 0x05, 0x19, 0x19,
    0x05, 0x05, 0x05, 0x19,
    0x05, 0x10, 0x17, 0x1C,
    0x05, 0x0A, 0x17, 0x1C,
    0x05, 0x0A, 0x11, 0x1C,
    0x05, 0x1C, 0x1C, 0x1C,
    0x05, 0x05, 0x1C, 0x1C,
    0x05, 0x05, 0x05, 0x1C,
    0x05, 0x12, 0x19, 0x1F,
    0x05, 0x0B, 0x19, 0x1F,
    0x05, 0x0B, 0x12, 0x1F,
    0x05, 0x1F, 0x1F, 0x1F,
    0x05, 0x05, 0x1F, 0x1F,
    0x05, 0x05, 0x05, 0x1F,
    0x05, 0x13, 0x1B, 0x22,
    0x05, 0x0C, 0x1B, 0x22,
    0x05, 0x0C, 0x14, 0x22,
    0x05, 0x22, 0x22, 0x22,
    0x05, 0x05, 0x22, 0x22,
    0x05, 0x05, 0x05, 0x22,
    0x05, 0x15, 0x1D, 0x25,
    0x05, 0x0D, 0x1D, 0x25,
    0x05, 0x0D, 0x15, 0x25,
    0x05, 0x25, 0x25, 0x25,
    0x05, 0x05, 0x25, 0x25,
    0x05, 0x05, 0x05, 0x25,
    0x05, 0x28, 0x28, 0x28,
    0x05, 0x05, 0x28, 0x28,
    0x05, 0x05, 0x05, 0x28,
    0x05, 0x17, 0x20, 0x29,
    0x05, 0x0E, 0x20, 0x29,
    0x05, 0x0E, 0x17, 0x29,
    0x05, 0x2D, 0x2D, 0x2D,
    0x05, 0x05, 0x2D, 0x2D,
    0x05, 0x05, 0x05, 0x2D,
    0x05, 0x33, 0x33, 0x33,
    0x05, 0x05, 0x33, 0x33,
    0x05, 0x05, 0x05, 0x33,
    0x06, 0x07, 0x07, 0x08,
    0x06, 0x07, 0x08, 0x09,
    0x06, 0x08, 0x09, 0x0A,
    0x06, 0x07, 0x09, 0x0A,
    0x06, 0x07, 0x08, 0x0A,
    0x06, 0x08, 0x09, 0x0B,
    0x06, 0x08, 0x0A, 0x0B,
    0x06, 0x07, 0x0A, 0x0B,
    0x06, 0x07, 0x09, 0x0B,
    0x06, 0x08, 0x0A, 0x0C,
    0x06, 0x09, 0x0B, 0x0C,
    0x06, 0x07, 0x0B, 0x0C,
    0x06, 0x07, 0x09, 0x0C,
    0x06, 0x0C, 0x0C, 0x0C,
    0x06, 0x06, 0x0C, 0x0C,
    0x06, 0x06, 0x06, 0x0C,
    0x06, 0x09, 0x0A, 0x0D,
    0x06, 0x09, 0x0C, 0x0D,
    0x06, 0x07, 0x0C, 0x0D,
    0x06, 0x07, 0x0A, 0x0D,
    0x06, 0x09, 0x0B, 0x0E,
    0x06, 0x0A, 0x0C, 0x0E,
    0x06, 0x08, 0x0C, 0x0E,
    0x06, 0x08, 0x0A, 0x0E,
    0x06, 0x0E, 0x0E, 0x0E,
    0x06, 0x06, 0x0E, 0x0E,
    0x06, 0x06, 0x06, 0x0E,
    0x06, 0x0A, 0x0D, 0x11,
    0x06, 0x0B, 0x0F, 0x11,
    0x06, 0x08, 0x0F, 0x11,
    0x06, 0x08, 0x0C, 0x11,
    0x06, 0x11, 0x11, 0x11,
    0x06, 0x06, 0x11, 0x11,
    0x06, 0x06, 0x06, 0x11,
    0x06, 0x0B, 0x0F, 0x14,
    0x06, 0x0D, 0x11, 0x14,
    0x06, 0x09, 0x11, 0x14,
    0x06, 0x09, 0x0D, 0x14,
    0x06, 0x14, 0x14, 0x14,
    0x06, 0x06, 0x14, 0x14,
    0x06, 0x06, 0x06, 0x14,
    0x06, 0x0C, 0x11, 0x17,
    0x06, 0x0E, 0x13, 0x17,
    0x06, 0x0A, 0x13, 0x17,
    0x06, 0x0A, 0x0F, 0x17,
    0x06, 0x17, 0x17, 0x17,
    0x06, 0x06, 0x17, 0x17,
    0x06, 0x06, 0x06, 0x17,
    0x06, 0x0D, 0x13, 0x1A,
    0x06, 0x10, 0x15, 0x1A,
    0x06, 0x0B, 0x15, 0x1A,
    0x06, 0x0B, 0x10, 0x1A,
    0x06, 0x1A, 0x1A, 0x1A,
    0x06, 0x06, 0x1A, 0x1A,
    0x06, 0x06, 0x06, 0x1A,
    0x06, 0x11, 0x18, 0x1D,
    0x06, 0x0B, 0x18, 0x1D,
    0x06, 0x0B, 0x12, 0x1D,
    0x06, 0x1D, 0x1D, 0x1D,
    0x06, 0x06, 0x1D, 0x1D,
    0x06, 0x06, 0x06, 0x1D,
    0x06, 0x13, 0x1A, 0x20,
    0x06, 0x0C, 0x1A, 0x20,
    0x06, 0x0C, 0x13, 0x20,
    0x06, 0x20, 0x20, 0x20,
    0x06, 0x06, 0x20, 0x20,
    0x06, 0x06, 0x06, 0x20,
    0x06, 0x14, 0x1C, 0x23,
    0x06, 0x0D, 0x1C, 0x23,
    0x06, 0x0D, 0x15, 0x23,
    0x06, 0x23, 0x23, 0x23,
    0x06, 0x06, 0x23, 0x23,
    0x06, 0x06, 0x06, 0x23,
    0x06, 0x16, 0x1E, 0x26,
    0x06, 0x0E, 0x1E, 0x26,
    0x06, 0x0E, 0x16, 0x26,
    0x06, 0x26, 0x26, 0x26,
    0x06, 0x06, 0x26, 0x26,
    0x06, 0x06, 0x06, 0x26,
    0x06, 0x29, 0x29, 0x29,
    0x06, 0x06, 0x29, 0x29,
    0x06, 0x06, 0x06, 0x29,
    0x06, 0x18, 0x21, 0x2A,
    0x06, 0x0F, 0x21, 0x2A,
    0x06, 0x0F, 0x18, 0x2A,
    0x06, 0x2E, 0x2E, 0x2E,
    0x06, 0x06, 0x2E, 0x2E,
    0x06, 0x06, 0x06, 0x2E,
    0x06, 0x34, 0x34, 0x34,
    0x06, 0x06, 0x34, 0x34,
    0x06, 0x06, 0x06, 0x34,
    0x07, 0x08, 0x08, 0x09,
    0x07, 0x08, 0x09, 0x0A,
    0x07, 0x09, 0x0A, 0x0B,
    0x07, 0x08, 0x0A, 0x0B,
    0x07, 0x08, 0x09, 0x0B,
    0x07, 0x09, 0x0A, 0x0C,
    0x07, 0x09, 0x0B, 0x0C,
    0x07, 0x08, 0x0B, 0x0C,
    0x07, 0x08, 0x0A, 0x0C,
    0x07, 0x09, 0x0B, 0x0D,
    0x07, 0x0A, 0x0C, 0x0D,
    0x07, 0x08, 0x0C, 0x0D,
    0x07, 0x08, 0x0A, 0x0D,
    0x07, 0x0D, 0x0D, 0x0D,
    0x07, 0x07, 0x0D, 0x0D,
    0x07, 0x07, 0x07, 0x0D,
    0x07, 0x0A, 0x0B, 0x0E,
    0x07, 0x0A, 0x0D, 0x0E,
    0x07, 0x08, 0x0D, 0x0E,
    0x07, 0x08, 0x0B, 0x0E,
    0x07, 0x0A, 0x0C, 0x0F,
    0x07, 0x0B, 0x0D, 0x0F,
    0x07, 0x09, 0x0D, 0x0F,
    0x07, 0x09, 0x0B, 0x0F,
    0x07, 0x0F, 0x0F, 0x0F,
    0x07, 0x07, 0x0F, 0x0F,
    0x07, 0x07, 0x07, 0x0F,
    0x07, 0x0B, 0x0E, 0x12,
    0x07, 0x0C, 0x10, 0x12,
    0x07, 0x09, 0x10, 0x12,
    0x07, 0x09, 0x0D, 0x12,
    0x07, 0x12, 0x12, 0x12,
    0x07, 0x07, 0x12, 0x12,
    0x07, 0x07, 0x07, 0x12,
    0x07, 0x0C, 0x10, 0x15,
    0x07, 0x0E, 0x12, 0x15,
    0x07, 0x0A, 0x12, 0x15,
    0x07, 0x0A, 0x0E, 0x15,
    0x07, 0x15, 0x15, 0x15,
    0x07, 0x07, 0x15, 0x15,
    0x07, 0x07, 0x07, 0x15,
    0x07, 0x0D, 0x12, 0x18,
    0x07, 0x0F, 0x14, 0x18,
    0x07, 0x0B, 0x14, 0x18,
    0x07, 0x0B, 0x10, 0x18,
    0x07, 0x18, 0x18, 0x18,
    0x07, 0x07, 0x18, 0x18,
    0x07, 0x07, 0x07, 0x18,
    0x07, 0x0E, 0x14, 0x1B,
    0x07, 0x11, 0x16, 0x1B,
    0x07, 0x0C, 0x16, 0x1B,
    0x07, 0x0C, 0x11, 0x1B,
    0x07, 0x1B, 0x1B, 0x1B,
    0x07, 0x07, 0x1B, 0x1B,
    0x07, 0x07, 0x07, 0x1B,
    0x07, 0x12, 0x19, 0x1E,
    0x07, 0x0C, 0x19, 0x1E,
    0x07, 0x0C, 0x13, 0x1E,
    0x07, 0x1E, 0x1E, 0x1E,
    0x07, 0x07, 0x1E, 0x1E,
    0x07, 0x07, 0x07, 0x1E,
    0x07, 0x14, 0x1B, 0x21,
    0x07, 0x0D, 0x1B, 0x21,
    0x07, 0x0D, 0x14, 0x21,
    0x07, 0x21, 0x21, 0x21,
    0x07, 0x07, 0x21, 0x21,
    0x07, 0x07, 0x07, 0x21,
    0x07, 0x15, 0x1D, 0x24,
    0x07, 0x0E, 0x1D, 0x24,
    0x07, 0x0E, 0x16, 0x24,
    0x07, 0x24, 0x24, 0x24,
    0x07, 0x07, 0x24, 0x24,
    0x07, 0x07, 0x07, 0x24,
    0x07, 0x17, 0x1F, 0x27,
    0x07, 0x0F, 0x1F, 0x27,
    0x07, 0x0F, 0x17, 0x27,
    0x07, 0x27, 0x27, 0x27,
    0x07, 0x07, 0x27, 0x27,
    0x07, 0x07, 0x07, 0x27,
    0x07, 0x2A, 0x2A, 0x2A,
    0x07, 0x07, 0x2A, 0x2A,
    0x07, 0x07, 0x07, 0x2A,
    0x07, 0x19, 0x22, 0x2B,
    0x07, 0x10, 0x22, 0x2B,
    0x07, 0x10, 0x19, 0x2B,
    0x07, 0x2F, 0x2F, 0x2F,
    0x07, 0x07, 0x2F, 0x2F,
    0x07, 0x07, 0x07, 0x2F,
    0x07, 0x35, 0x35, 0x35,
    0x07, 0x07, 0x35, 0x35,
    0x07, 0x07, 0x07, 0x35,
    0x08, 0x09, 0x09, 0x0A,
    0x08, 0x09, 0x0A, 0x0B,
    0x08, 0x0A, 0x0B, 0x0C,
    0x08, 0x09, 0x0B, 0x0C,
    0x08, 0x09, 0x0A, 0x0C,
    0x08, 0x0A, 0x0B, 0x0D,
    0x08, 0x0A, 0x0C, 0x0D,
    0x08, 0x09, 0x0C, 0x0D,
    0x08, 0x09, 0x0B, 0x0D,
    0x08, 0x0A, 0x0C, 0x0E,
    0x08, 0x0B, 0x0D, 0x0E,
    0x08, 0x09, 0x0D, 0x0E,
    0x08, 0x09, 0x0B, 0x0E,
    0x08, 0x0E, 0x0E, 0x0E,
    0x08, 0x08, 0x0E, 0x0E,
    0x08, 0x08, 0x08, 0x0E,
    0x08, 0x0B, 0x0C, 0x0F,
    0x08, 0x0B, 0x0E, 0x0F,
    0x08, 0x09, 0x0E, 0x0F,
    0x08, 0x09, 0x0C, 0x0F,
    0x08, 0x0B, 0x0D, 0x10,
    0x08, 0x0C, 0x0E, 0x10,
    0x08, 0x0A, 0x0E, 0x10,
    0x08, 0x0A, 0x0C, 0x10,
    0x08, 0x10, 0x10, 0x10,
    0x08, 0x08, 0x10, 0x10,
    0x08, 0x08, 0x08, 0x10,
    0x08, 0x0C, 0x0F, 0x13,
    0x08, 0x0D, 0x11, 0x13,
    0x08, 0x0A, 0x11, 0x13,
    0x08, 0x0A, 0x0E, 0x13,
    0x08, 0x13, 0x13, 0x13,
    0x08, 0x08, 0x13, 0x13,
    0x08, 0x08, 0x08, 0x13,
    0x08, 0x0D, 0x11, 0x16,
    0x08, 0x0F, 0x13, 0x16,
    0x08, 0x0B, 0x13, 0x16,
    0x08, 0x0B, 0x0F, 0x16,
    0x08, 0x16, 0x16, 0x16,
    0x08, 0x08, 0x16, 0x16,
    0x08, 0x08, 0x08, 0x16,
    0x08, 0x0E, 0x13, 0x19,
    0x08, 0x10, 0x15, 0x19,
    0x08, 0x0C, 0x15, 0x19,
    0x08, 0x0C, 0x11, 0x19,
    0x08, 0x19, 0x19, 0x19,
    0x08, 0x08, 0x19, 0x19,
    0x08, 0x08, 0x08, 0x19,
    0x08, 0x0F, 0x15, 0x1C,
    0x08, 0x12, 0x17, 0x1C,
    0x08, 0x0D, 0x17, 0x1C,
    0x08, 0x0D, 0x12, 0x1C,
    0x08, 0x1C, 0x1C, 0x1C,
    0x08, 0x08, 0x1C, 0x1C,
    0x08, 0x08, 0x08, 0x1C,
    0x08, 0x13, 0x1A, 0x1F,
    0x08, 0x0D, 0x1A, 0x1F,
    0x08, 0x0D, 0x14, 0x1F,
    0x08, 0x1F, 0x1F, 0x1F,
    0x08, 0x08, 0x1F, 0x1F,
    0x08, 0x08, 0x08, 0x1F,
    0x08, 0x15, 0x1C, 0x22,
    0x08, 0x0E, 0x1C, 0x22,
    0x08, 0x0E, 0x15, 0x22,
    0x08, 0x22, 0x22, 0x22,
    0x08, 0x08, 0x22, 0x22,
    0x08, 0x08, 0x08, 0x22,
    0x08, 0x16, 0x1E, 0x25,
    0x08, 0x0F, 0x1E, 0x25,
    0x08, 0x0F, 0x17, 0x25,
    0x08, 0x25, 0x25, 0x25,
    0x08, 0x08, 0x25, 0x25,
    0x08, 0x08, 0x08, 0x25,
    0x08, 0x18, 0x20, 0x28,
    0x08, 0x10, 0x20, 0x28,
    0x08, 0x10, 0x18, 0x28,
    0x08, 0x28, 0x28, 0x28,
    0x08, 0x08, 0x28, 0x28,
    0x08, 0x08, 0x08, 0x28,
    0x08, 0x2B, 0x2B, 0x2B,
    0x08, 0x08, 0x2B, 0x2B,
    0x08, 0x08, 0x08, 0x2B,
    0x08, 0x1A, 0x23, 0x2C,
    0x08, 0x11, 0x23, 0x2C,
    0x08, 0x11, 0x1A, 0x2C,
    0x08, 0x30, 0x30, 0x30,
    0x08, 0x08, 0x30, 0x30,
    0x08, 0x08, 0x08, 0x30,
    0x08, 0x36, 0x36, 0x36,
    0x08, 0x08, 0x36, 0x36,
    0x08, 0x08, 0x08, 0x36,
    0x09, 0x0A, 0x0A, 0x0B,
    0x09, 0x0A, 0x0B, 0x0C,
    0x09, 0x0B, 0x0C, 0x0D,
    0x09, 0x0A, 0x0C, 0x0D,
    0x09, 0x0A, 0x0B, 0x0D,
    0x09, 0x0B, 0x0C, 0x0E,
    0x09, 0x0B, 0x0D, 0x0E,
    0x09, 0x0A, 0x0D, 0x0E,
    0x09, 0x0A, 0x0C, 0x0E,
    0x09, 0x0B, 0x0D, 0x0F,
    0x09, 0x0C, 0x0E, 0x0F,
    0x09, 0x0A, 0x0E, 0x0F,
    0x09, 0x0A, 0x0C, 0x0F,
    0x09, 0x0F, 0x0F, 0x0F,
    0x09, 0x09, 0x0F, 0x0F,
    0x09, 0x09, 0x09, 0x0F,
    0x09, 0x0C, 0x0D, 0x10,
    0x09, 0x0C, 0x0F, 0x10,
    0x09, 0x0A, 0x0F, 0x10,
    0x09, 0x0A, 0x0D, 0x10,
    0x09, 0x0C, 0x0E, 0x11,
    0x09, 0x0D, 0x0F, 0x11,
    0x09, 0x0B, 0x0F, 0x11,
    0x09, 0x0B, 0x0D, 0x11,
    0x09, 0x11, 0x11, 0x11,
    0x09, 0x09, 0x11, 0x11,
    0x09, 0x09, 0x09, 0x11,
    0x09, 0x0D, 0x10, 0x14,
    0x09, 0x0E, 0x12, 0x14,
    0x09, 0x0B, 0x12, 0x14,
    0x09, 0x0B, 0x0F, 0x14,
    0x09, 0x14, 0x14, 0x14,
    0x09, 0x09, 0x14, 0x14,
    0x09, 0x09, 0x09, 0x14,
    0x09, 0x0E, 0x12, 0x17,
    0x09, 0x10, 0x14, 0x17,
    0x09, 0x0C, 0x14, 0x17,
    0x09, 0x0C, 0x10, 0x17,
    0x09, 0x17, 0x17, 0x17,
    0x09, 0x09, 0x17, 0x17,
    0x09, 0x09, 0x09, 0x17,
    0x09, 0x0F, 0x14, 0x1A,
    0x09, 0x11, 0x16, 0x1A,
    0x09, 0x0D, 0x16, 0x1A,
    0x09, 0x0D, 0x12, 0x1A,
    0x09, 0x1A, 0x1A, 0x1A,
    0x09, 0x09, 0x1A, 0x1A,
    0x09, 0x09, 0x09, 0x1A,
    0x09, 0x10, 0x16, 0x1D,
    0x09, 0x13, 0x18, 0x1D,
    0x09, 0x0E, 0x18, 0x1D,
    0x09, 0x0E, 0x13, 0x1D,
    0x09, 0x1D, 0x1D, 0x1D,
    0x09, 0x09, 0x1D, 0x1D,
    0x09, 0x09, 0x09, 0x1D,
    0x09, 0x14, 0x1B, 0x20,
    0x09, 0x0E, 0x1B, 0x20,
    0x09, 0x0E, 0x15, 0x20,
    0x09, 0x20, 0x20, 0x20,
    0x09, 0x09, 0x20, 0x20,
    0x09, 0x09, 0x09, 0x20,
    0x09, 0x16, 0x1D, 0x23,
    0x09, 0x0F, 0x1D, 0x23,
    0x09, 0x0F, 0x16, 0x23,
    0x09, 0x23, 0x23, 0x23,
    0x09, 0x09, 0x23, 0x23,
    0x09, 0x09, 0x09, 0x23,
    0x09, 0x17, 0x1F, 0x26,
    0x09, 0x10, 0x1F, 0x26,
    0x09, 0x10, 0x18, 0x26,
    0x09, 0x26, 0x26, 0x26,
    0x09, 0x09, 0x26, 0x26,
    0x09, 0x09, 0x09, 0x26,
    0x09, 0x19, 0x21, 0x29,
    0x09, 0x11, 0x21, 0x29,
    0x09, 0x11, 0x19, 0x29,
    0x09, 0x29, 0x29, 0x29,
    0x09, 0x09, 0x29, 0x29,
    0x09, 0x09, 0x09, 0x29,
    0x09, 0x2C, 0x2C, 0x2C,
    0x09, 0x09, 0x2C, 0x2C,
    0x09, 0x09, 0x09, 0x2C,
    0x09, 0x1B, 0x24, 0x2D,
    0x09, 0x12, 0x24, 0x2D,
    0x09, 0x12, 0x1B, 0x2D,
    0x09, 0x31, 0x31, 0x31,
    0x09, 0x09, 0x31, 0x31,
    0x09, 0x09, 0x09, 0x31,
    0x09, 0x37, 0x37, 0x37,
    0x09, 0x09, 0x37, 0x37,
    0x09, 0x09, 0x09, 0x37,
    0x0A, 0x0B, 0x0B, 0x0C,
    0x0A, 0x0B, 0x0C, 0x0D,
    0x0A, 0x0C, 0x0D, 0x0E,
    0x0A, 0x0B, 0x0D, 0x0E,
    0x0A, 0x0B, 0x0C, 0x0E,
    0x0A, 0x0C, 0x0D, 0x0F,
    0x0A, 0x0C, 0x0E, 0x0F,
    0x0A, 0x0B, 0x0E, 0x0F,
    0x0A, 0x0B, 0x0D, 0x0F,
    0x0A, 0x0C, 0x0E, 0x10,
    0x0A, 0x0D, 0x0F, 0x10,
    0x0A, 0x0B, 0x0F, 0x10,
    0x0A, 0x0B, 0x0D, 0x10,
    0x0A, 0x10, 0x10, 0x10,
    0x0A, 0x0A, 0x10, 0x10,
    0x0A, 0x0A, 0x0A, 0x10,
    0x0A, 0x0D, 0x0E, 0x11,
    0x0A, 0x0D, 0x10, 0x11,
    0x0A, 0x0B, 0x10, 0x11,
    0x0A, 0x0B, 0x0E, 0x11,
    0x0A, 0x0D, 0x0F, 0x12,
    0x0A, 0x0E, 0x10, 0x12,
    0x0A, 0x0C, 0x10, 0x12,
    0x0A, 0x0C, 0x0E, 0x12,
    0x0A, 0x12, 0x12, 0x12,
    0x0A, 0x0A, 0x12, 0x12,
    0x0A, 0x0A, 0x0A, 0x12,
    0x0A, 0x0E, 0x11, 0x15,
    0x0A, 0x0F, 0x13, 0x15,
    0x0A, 0x0C, 0x13, 0x15,
    0x0A, 0x0C, 0x10, 0x15,
    0x0A, 0x15, 0x15, 0x15,
    0x0A, 0x0A, 0x15, 0x15,
    0x0A, 0x0A, 0x0A, 0x15,
    0x0A, 0x0F, 0x13, 0x18,
    0x0A, 0x11, 0x15, 0x18,
    0x0A, 0x0D, 0x15, 0x18,
    0x0A, 0x0D, 0x11, 0x18,
    0x0A, 0x18, 0x18, 0x18,
    0x0A, 0x0A, 0x18, 0x18,
    0x0A, 0x0A, 0x0A, 0x18,
    0x0A, 0x10, 0x15, 0x1B,
    0x0A, 0x12, 0x17, 0x1B,
    0x0A, 0x0E, 0x17, 0x1B,
    0x0A, 0x0E, 0x13, 0x1B,
    0x0A, 0x1B, 0x1B, 0x1B,
    0x0A, 0x0A, 0x1B, 0x1B,
    0x0A, 0x0A, 0x0A, 0x1B,
    0x0A, 0x11, 0x17, 0x1E,
    0x0A, 0x14, 0x19, 0x1E,
    0x0A, 0x0F, 0x19, 0x1E,
    0x0A, 0x0F, 0x14, 0x1E,
    0x0A, 0x1E, 0x1E, 0x1E,
    0x0A, 0x0A, 0x1E, 0x1E,
    0x0A, 0x0A, 0x0A, 0x1E,
    0x0A, 0x15, 0x1C, 0x21,
    0x0A, 0x0F, 0x1C, 0x21,
    0x0A, 0x0F, 0x16, 0x21,
    0x0A, 0x21, 0x21, 0x21,
    0x0A, 0x0A, 0x21, 0x21,
    0x0A, 0x0A, 0x0A, 0x21,
    0x0A, 0x17, 0x1E, 0x24,
    0x0A, 0x10, 0x1E, 0x24,
    0x0A, 0x10, 0x17, 0x24,
    0x0A, 0x24, 0x24, 0x24,
    0x0A, 0x0A, 0x24, 0x24,
    0x0A, 0x0A, 0x0A, 0x24,
    0x0A, 0x18, 0x20, 0x27,
    0x0A, 0x11, 0x20, 0x27,
    0x0A, 0x11, 0x19, 0x27,
    0x0A, 0x27, 0x27, 0x27,
    0x0A, 0x0A, 0x27, 0x27,
    0x0A, 0x0A, 0x0A, 0x27,
    0x0A, 0x1A, 0x22, 0x2A,
    0x0A, 0x12, 0x22, 0x2A,
    0x0A, 0x12, 0x1A, 0x2A,
    0x0A, 0x2A, 0x2A, 0x2A,
    0x0A, 0x0A, 0x2A, 0x2A,
    0x0A, 0x0A, 0x0A, 0x2A,
    0x0A, 0x2D, 0x2D, 0x2D,
    0x0A, 0x0A, 0x2D, 0x2D,
    0x0A, 0x0A, 0x0A, 0x2D,
    0x0A, 0x1C, 0x25, 0x2E,
    0x0A, 0x13, 0x25, 0x2E,
    0x0A, 0x13, 0x1C, 0x2E,
    0x0A, 0x32, 0x32, 0x32,
    0x0A, 0x0A, 0x32, 0x32,
    0x0A, 0x0A, 0x0A, 0x32,
    0x0A, 0x38, 0x38, 0x38,
    0x0A, 0x0A, 0x38, 0x38,
    0x0A, 0x0A, 0x0A, 0x38,
    0x0B, 0x0C, 0x0C, 0x0D,
    0x0B, 0x0C, 0x0D, 0x0E,
    0x0B, 0x0D, 0x0E, 0x0F,
    0x0B, 0x0C, 0x0E, 0x0F,
    0x0B, 0x0C, 0x0D, 0x0F,
    0x0B, 0x0D, 0x0E, 0x10,
    0x0B, 0x0D, 0x0F, 0x10,
    0x0B, 0x0C, 0x0F, 0x10,
    0x0B, 0x0C, 0x0E, 0x10,
    0x0B, 0x0D, 0x0F, 0x11,
    0x0B, 0x0E, 0x10, 0x11,
    0x0B, 0x0C, 0x10, 0x11,
    0x0B, 0x0C, 0x0E, 0x11,
    0x0B, 0x11, 0x11, 0x11,
    0x0B, 0x0B, 0x11, 0x11,
    0x0B, 0x0B, 0x0B, 0x11,
    0x0B, 0x0E, 0x0F, 0x12,
    0x0B, 0x0E, 0x11, 0x12,
    0x0B, 0x0C, 0x11, 0x12,
    0x0B, 0x0C, 0x0F, 0x12,
    0x0B, 0x0E, 0x10, 0x13,
    0x0B, 0x0F, 0x11, 0x13,
    0x0B, 0x0D, 0x11, 0x13,
    0x0B, 0x0D, 0x0F, 0x13,
    0x0B, 0x13, 0x13, 0x13,
    0x0B, 0x0B, 0x13, 0x13,
    0x0B, 0x0B, 0x0B, 0x13,
    0x0B, 0x0F, 0x12, 0x16,
    0x0B, 0x10, 0x14, 0x16,
    0x0B, 0x0D, 0x14, 0x16,
    0x0B, 0x0D, 0x11, 0x16,
    0x0B, 0x16, 0x16, 0x16,
    0x0B, 0x0B, 0x16, 0x16,
    0x0B, 0x0B, 0x0B, 0x16,
    0x0B, 0x10, 0x14, 0x19,
    0x0B, 0x12, 0x16, 0x19,
    0x0B, 0x0E, 0x16, 0x19,
    0x0B, 0x0E, 0x12, 0x19,
    0x0B, 0x19, 0x19, 0x19,
    0x0B, 0x0B, 0x19, 0x19,
    0x0B, 0x0B, 0x0B, 0x19,
    0x0B, 0x11, 0x16, 0x1C,
    0x0B, 0x13, 0x18, 0x1C,
    0x0B, 0x0F, 0x18, 0x1C,
    0x0B, 0x0F, 0x14, 0x1C,
    0x0B, 0x1C, 0x1C, 0x1C,
    0x0B, 0x0B, 0x1C, 0x1C,
    0x0B, 0x0B, 0x0B, 0x1C,
    0x0B, 0x12, 0x18, 0x1F,
    0x0B, 0x15, 0x1A, 0x1F,
    0x0B, 0x10, 0x1A, 0x1F,
    0x0B, 0x10, 0x15, 0x1F,
    0x0B, 0x1F, 0x1F, 0x1F,
    0x0B, 0x0B, 0x1F, 0x1F,
    0x0B, 0x0B, 0x0B, 0x1F,
    0x0B, 0x16, 0x1D, 0x22,
    0x0B, 0x10, 0x1D, 0x22,
    0x0B, 0x10, 0x17, 0x22,
    0x0B, 0x22, 0x22, 0x22,
    0x0B, 0x0B, 0x22, 0x22,
    0x0B, 0x0B, 0x0B, 0x22,
    0x0B, 0x18, 0x1F, 0x25,
    0x0B, 0x11, 0x1F, 0x25,
    0x0B, 0x11, 0x18, 0x25,
    0x0B, 0x25, 0x25, 0x25,
    0x0B, 0x0B, 0x25, 0x25,
    0x0B, 0x0B, 0x0B, 0x25,
    0x0B, 0x19, 0x21, 0x28,
    0x0B, 0x12, 0x21, 0x28,
    0x0B, 0x12, 0x1A, 0x28,
    0x0B, 0x28, 0x28, 0x28,
    0x0B, 0x0B, 0x28, 0x28,
    0x0B, 0x0B, 0x0B, 0x28,
    0x0B, 0x1B, 0x23, 0x2B,
    0x0B, 0x13, 0x23, 0x2B,
    0x0B, 0x13, 0x1B, 0x2B,
    0x0B, 0x2B, 0x2B, 0x2B,
    0x0B, 0x0B, 0x2B, 0x2B,
    0x0B, 0x0B, 0x0B, 0x2B,
    0x0B, 0x2E, 0x2E, 0x2E,
    0x0B, 0x0B, 0x2E, 0x2E,
    0x0B, 0x0B, 0x0B, 0x2E,
    0x0B, 0x1D, 0x26, 0x2F,
    0x0B, 0x14, 0x26, 0x2F,
    0x0B, 0x14, 0x1D, 0x2F,
    0x0B, 0x33, 0x33, 0x33,
    0x0B, 0x0B, 0x33, 0x33,
    0x0B, 0x0B, 0x0B, 0x33,
    0x0B, 0x39, 0x39, 0x39,
    0x0B, 0x0B, 0x39, 0x39,
    0x0B, 0x0B, 0x0B, 0x39,
    0x0C, 0x0D, 0x0D, 0x0E,
    0x0C, 0x0D, 0x0E, 0x0F,
    0x0C, 0x0E, 0x0F, 0x10,
    0x0C, 0x0D, 0x0F, 0x10,
    0x0C, 0x0D, 0x0E, 0x10,
    0x0C, 0x0E, 0x0F, 0x11,
    0x0C, 0x0E, 0x10, 0x11,
    0x0C, 0x0D, 0x10, 0x11,
    0x0C, 0x0D, 0x0F, 0x11,
    0x0C, 0x0E, 0x10, 0x12,
    0x0C, 0x0F, 0x11, 0x12,
    0x0C, 0x0D, 0x11, 0x12,
    0x0C, 0x0D, 0x0F, 0x12,
    0x0C, 0x12, 0x12, 0x12,
    0x0C, 0x0C, 0x12, 0x12,
    0x0C, 0x0C, 0x0C, 0x12,
    0x0C, 0x0F, 0x10, 0x13,
    0x0C, 0x0F, 0x12, 0x13,
    0x0C, 0x0D, 0x12, 0x13,
    0x0C, 0x0D, 0x10, 0x13,
    0x0C, 0x0F, 0x11, 0x14,
    0x0C, 0x10, 0x12, 0x14,
    0x0C, 0x0E, 0x12, 0x14,
    0x0C, 0x0E, 0x10, 0x14,
    0x0C, 0x14, 0x14, 0x14,
    0x0C, 0x0C, 0x14, 0x14,
    0x0C, 0x0C, 0x0C, 0x14,
    0x0C, 0x10, 0x13, 0x17,
    0x0C, 0x11, 0x15, 0x17,
    0x0C, 0x0E, 0x15, 0x17,
    0x0C, 0x0E, 0x12, 0x17,
    0x0C, 0x17, 0x17, 0x17,
    0x0C, 0x0C, 0x17, 0x17,
    0x0C, 0x0C, 0x0C, 0x17,
    0x0C, 0x11, 0x15, 0x1A,
    0x0C, 0x13, 0x17, 0x1A,
    0x0C, 0x0F, 0x17, 0x1A,
    0x0C, 0x0F, 0x13, 0x1A,
    0x0C, 0x1A, 0x1A, 0x1A,
    0x0C, 0x0C, 0x1A, 0x1A,
    0x0C, 0x0C, 0x0C, 0x1A,
    0x0C, 0x12, 0x17, 0x1D,
    0x0C, 0x14, 0x19, 0x1D,
    0x0C, 0x10, 0x19, 0x1D,
    0x0C, 0x10, 0x15, 0x1D,
    0x0C, 0x1D, 0x1D, 0x1D,
    0x0C, 0x0C, 0x1D, 0x1D,
    0x0C, 0x0C, 0x0C, 0x1D,
    0x0C, 0x13, 0x19, 0x20,
    0x0C, 0x16, 0x1B, 0x20,
    0x0C, 0x11, 0x1B, 0x20,
    0x0C, 0x11, 0x16, 0x20,
    0x0C, 0x20, 0x20, 0x20,
    0x0C, 0x0C, 0x20, 0x20,
    0x0C, 0x0C, 0x0C, 0x20,
    0x0C, 0x17, 0x1E, 0x23,
    0x0C, 0x11, 0x1E, 0x23,
    0x0C, 0x11, 0x18, 0x23,
    0x0C, 0x23, 0x23, 0x23,
    0x0C, 0x0C, 0x23, 0x23,
    0x0C, 0x0C, 0x0C, 0x23,
    0x0C, 0x19, 0x20, 0x26,
    0x0C, 0x12, 0x20, 0x26,
    0x0C, 0x12, 0x19, 0x26,
    0x0C, 0x26, 0x26, 0x26,
    0x0C, 0x0C, 0x26, 0x26,
    0x0C, 0x0C, 0x0C, 0x26,
    0x0C, 0x1A, 0x22, 0x29,
    0x0C, 0x13, 0x22, 0x29,
    0x0C, 0x13, 0x1B, 0x29,
    0x0C, 0x29, 0x29, 0x29,
    0x0C, 0x0C, 0x29, 0x29,
    0x0C, 0x0C, 0x0C, 0x29,
    0x0C, 0x1C, 0x24, 0x2C,
    0x0C, 0x14, 0x24, 0x2C,
    0x0C, 0x14, 0x1C, 0x2C,
    0x0C, 0x2C, 0x2C, 0x2C,
    0x0C, 0x0C, 0x2C, 0x2C,
    0x0C, 0x0C, 0x0C, 0x2C,
    0x0C, 0x2F, 0x2F, 0x2F,
    0x0C, 0x0C, 0x2F, 0x2F,
    0x0C, 0x0C, 0x0C, 0x2F,
    0x0C, 0x1E, 0x27, 0x30,
    0x0C, 0x15, 0x27, 0x30,
    0x0C, 0x15, 0x1E, 0x30,
    0x0C, 0x34, 0x34, 0x34,
    0x0C, 0x0C, 0x34, 0x34,
    0x0C, 0x0C, 0x0C, 0x34,
    0x0C, 0x3A, 0x3A, 0x3A,
    0x0C, 0x0C, 0x3A, 0x3A,
    0x0C, 0x0C, 0x0C, 0x3A,
    0x0D, 0x0E, 0x0E, 0x0F,
    0x0D, 0x0E, 0x0F, 0x10,
    0x0D, 0x0F, 0x10, 0x11,
    0x0D, 0x0E, 0x10, 0x11,
    0x0D, 0x0E, 0x0F, 0x11,
    0x0D, 0x0F, 0x10, 0x12,
    0x0D, 0x0F, 0x11, 0x12,
    0x0D, 0x0E, 0x11, 0x12,
    0x0D, 0x0E, 0x10, 0x12,
    0x0D, 0x0F, 0x11, 0x13,
    0x0D, 0x10, 0x12, 0x13,
    0x0D, 0x0E, 0x12, 0x13,
    0x0D, 0x0E, 0x10, 0x13,
    0x0D, 0x13, 0x13, 0x13,
    0x0D, 0x0D, 0x13, 0x13,
    0x0D, 0x0D, 0x0D, 0x13,
    0x0D, 0x10, 0x11, 0x14,
    0x0D, 0x10, 0x13, 0x14,
    0x0D, 0x0E, 0x13, 0x14,
    0x0D, 0x0E, 0x11, 0x14,
    0x0D, 0x10, 0x12, 0x15,
    0x0D, 0x11, 0x13, 0x15,
    0x0D, 0x0F, 0x13, 0x15,
    0x0D, 0x0F, 0x11, 0x15,
    0x0D, 0x15, 0x15, 0x15,
    0x0D, 0x0D, 0x15, 0x15,
    0x0D, 0x0D, 0x0D, 0x15,
    0x0D, 0x11, 0x14, 0x18,
    0x0D, 0x12, 0x16, 0x18,
    0x0D, 0x0F, 0x16, 0x18,
    0x0D, 0x0F, 0x13, 0x18,
    0x0D, 0x18, 0x18, 0x18,
    0x0D, 0x0D, 0x18, 0x18,
    0x0D, 0x0D, 0x0D, 0x18,
    0x0D, 0x12, 0x16, 0x1B,
    0x0D, 0x14, 0x18, 0x1B,
    0x0D, 0x10, 0x18, 0x1B,
    0x0D, 0x10, 0x14, 0x1B,
    0x0D, 0x1B, 0x1B, 0x1B,
    0x0D, 0x0D, 0x1B, 0x1B,
    0x0D, 0x0D, 0x0D, 0x1B,
    0x0D, 0x13, 0x18, 0x1E,
    0x0D, 0x15, 0x1A, 0x1E,
    0x0D, 0x11, 0x1A, 0x1E,
    0x0D, 0x11, 0x16, 0x1E,
    0x0D, 0x1E, 0x1E, 0x1E,
    0x0D, 0x0D, 0x1E, 0x1E,
    0x0D, 0x0D, 0x0D, 0x1E,
    0x0D, 0x14, 0x1A, 0x21,
    0x0D, 0x17, 0x1C, 0x21,
    0x0D, 0x12, 0x1C, 0x21,
    0x0D, 0x12, 0x17, 0x21,
    0x0D, 0x21, 0x21, 0x21,
    0x0D, 0x0D, 0x21, 0x21,
    0x0D, 0x0D, 0x0D, 0x21,
    0x0D, 0x18, 0x1F, 0x24,
    0x0D, 0x12, 0x1F, 0x24,
    0x0D, 0x12, 0x19, 0x24,
    0x0D, 0x24, 0x24, 0x24,
    0x0D, 0x0D, 0x24, 0x24,
    0x0D, 0x0D, 0x0D, 0x24,
    0x0D, 0x1A, 0x21, 0x27,
    0x0D, 0x13, 0x21, 0x27,
    0x0D, 0x13, 0x1A, 0x27,
    0x0D, 0x27, 0x27, 0x27,
    0x0D, 0x0D, 0x27, 0x27,
    0x0D, 0x0D, 0x0D, 0x27,
    0x0D, 0x1B, 0x23, 0x2A,
    0x0D, 0x14, 0x23, 0x2A,
    0x0D, 0x14, 0x1C, 0x2A,
    0x0D, 0x2A, 0x2A, 0x2A,
    0x0D, 0x0D, 0x2A, 0x2A,
    0x0D, 0x0D, 0x0D, 0x2A,
    0x0D, 0x1D, 0x25, 0x2D,
    0x0D, 0x15, 0x25, 0x2D,
    0x0D, 0x15, 0x1D, 0x2D,
    0x0D, 0x2D, 0x2D, 0x2D,
    0x0D, 0x0D, 0x2D, 0x2D,
    0x0D, 0x0D, 0x0D, 0x2D,
    0x0D, 0x30, 0x30, 0x30,
    0x0D, 0x0D, 0x30, 0x30,
    0x0D, 0x0D, 0x0D, 0x30,
    0x0D, 0x1F, 0x28, 0x31,
    0x0D, 0x16, 0x28, 0x31,
    0x0D, 0x16, 0x1F, 0x31,
    0x0D, 0x35, 0x35, 0x35,
    0x0D, 0x0D, 0x35, 0x35,
    0x0D, 0x0D, 0x0D, 0x35,
    0x0D, 0x3B, 0x3B, 0x3B,
    0x0D, 0x0D, 0x3B, 0x3B,
    0x0D, 0x0D, 0x0D, 0x3B,
    0x0E, 0x0F, 0x0F, 0x10,
    0x0E, 0x0F, 0x10, 0x11,
    0x0E, 0x10, 0x11, 0x12,
    0x0E, 0x0F, 0x11, 0x12,
    0x0E, 0x0F, 0x10, 0x12,
    0x0E, 0x10, 0x11, 0x13,
    0x0E, 0x10, 0x12, 0x13,
    0x0E, 0x0F, 0x12, 0x13,
    0x0E, 0x0F, 0x11, 0x13,
    0x0E, 0x10, 0x12, 0x14,
    0x0E, 0x11, 0x13, 0x14,
    0x0E, 0x0F, 0x13, 0x14,
    0x0E, 0x0F, 0x11, 0x14,
    0x0E, 0x14, 0x14, 0x14,
    0x0E, 0x0E, 0x14, 0x14,
    0x0E, 0x0E, 0x0E, 0x14,
    0x0E, 0x11, 0x12, 0x15,
    0x0E, 0x11, 0x14, 0x15,
    0x0E, 0x0F, 0x14, 0x15,
    0x0E, 0x0F, 0x12, 0x15,
    0x0E, 0x11, 0x13, 0x16,
    0x0E, 0x12, 0x14, 0x16,
    0x0E, 0x10, 0x14, 0x16,
    0x0E, 0x10, 0x12, 0x16,
    0x0E, 0x16, 0x16, 0x16,
    0x0E, 0x0E, 0x16, 0x16,
    0x0E, 0x0E, 0x0E, 0x16,
    0x0E, 0x12, 0x15, 0x19,
    0x0E, 0x13, 0x17, 0x19,
    0x0E, 0x10, 0x17, 0x19,
    0x0E, 0x10, 0x14, 0x19,
    0x0E, 0x19, 0x19, 0x19,
    0x0E, 0x0E, 0x19, 0x19,
    0x0E, 0x0E, 0x0E, 0x19,
    0x0E, 0x13, 0x17, 0x1C,
    0x0E, 0x15, 0x19, 0x1C,
    0x0E, 0x11, 0x19, 0x1C,
    0x0E, 0x11, 0x15, 0x1C,
    0x0E, 0x1C, 0x1C, 0x1C,
    0x0E, 0x0E, 0x1C, 0x1C,
    0x0E, 0x0E, 0x0E, 0x1C,
    0x0E, 0x14, 0x19, 0x1F,
    0x0E, 0x16, 0x1B, 0x1F,
    0x0E, 0x12, 0x1B, 0x1F,
    0x0E, 0x12, 0x17, 0x1F,
    0x0E, 0x1F, 0x1F, 0x1F,
    0x0E, 0x0E, 0x1F, 0x1F,
    0x0E, 0x0E, 0x0E, 0x1F,
    0x0E, 0x15, 0x1B, 0x22,
    0x0E, 0x18, 0x1D, 0x22,
    0x0E, 0x13, 0x1D, 0x22,
    0x0E, 0x13, 0x18, 0x22,
    0x0E, 0x22, 0x22, 0x22,
    0x0E, 0x0E, 0x22, 0x22,
    0x0E, 0x0E, 0x0E, 0x22,
    0x0E, 0x19, 0x20, 0x25,
    0x0E, 0x13, 0x20, 0x25,
    0x0E, 0x13, 0x1A, 0x25,
    0x0E, 0x25, 0x25, 0x25,
    0x0E, 0x0E, 0x25, 0x25,
    0x0E, 0x0E, 0x0E, 0x25,
    0x0E, 0x1B, 0x22, 0x28,
    0x0E, 0x14, 0x22, 0x28,
    0x0E, 0x14, 0x1B, 0x28,
    0x0E, 0x28, 0x28, 0x28,
    0x0E, 0x0E, 0x28, 0x28,
    0x0E, 0x0E, 0x0E, 0x28,
    0x0E, 0x1C, 0x24, 0x2B,
    0x0E, 0x15, 0x24, 0x2B,
    0x0E, 0x15, 0x1D, 0x2B,
    0x0E, 0x2B, 0x2B, 0x2B,
    0x0E, 0x0E, 0x2B, 0x2B,
    0x0E, 0x0E, 0x0E, 0x2B,
    0x0E, 0x1E, 0x26, 0x2E,
    0x0E, 0x16, 0x26, 0x2E,
    0x0E, 0x16, 0x1E, 0x2E,
    0x0E, 0x2E, 0x2E, 0x2E,
    0x0E, 0x0E, 0x2E, 0x2E,
    0x0E, 0x0E, 0x0E, 0x2E,
    0x0E, 0x31, 0x31, 0x31,
    0x0E, 0x0E, 0x31, 0x31,
    0x0E, 0x0E, 0x0E, 0x31,
    0x0E, 0x20, 0x29, 0x32,
    0x0E, 0x17, 0x29, 0x32,
    0x0E, 0x17, 0x20, 0x32,
    0x0E, 0x36, 0x36, 0x36,
    0x0E, 0x0E, 0x36, 0x36,
    0x0E, 0x0E, 0x0E, 0x36,
    0x0E, 0x3C, 0x3C, 0x3C,
    0x0E, 0x0E, 0x3C, 0x3C,
    0x0E, 0x0E, 0x0E, 0x3C,
    0x0F, 0x10, 0x10, 0x11,
    0x0F, 0x10, 0x11, 0x12,
    0x0F, 0x11, 0x12, 0x13,
    0x0F, 0x10, 0x12, 0x13,
    0x0F, 0x10, 0x11, 0x13,
    0x0F, 0x11, 0x12, 0x14,
    0x0F, 0x11, 0x13, 0x14,
    0x0F, 0x10, 0x13, 0x14,
    0x0F, 0x10, 0x12, 0x14,
    0x0F, 0x11, 0x13, 0x15,
    0x0F, 0x12, 0x14, 0x15,
    0x0F, 0x10, 0x14, 0x15,
    0x0F, 0x10, 0x12, 0x15,
    0x0F, 0x15, 0x15, 0x15,
    0x0F, 0x0F, 0x15, 0x15,
    0x0F, 0x0F, 0x0F, 0x15,
    0x0F, 0x12, 0x13, 0x16,
    0x0F, 0x12, 0x15, 0x16,
    0x0F, 0x10, 0x15, 0x16,
    0x0F, 0x10, 0x13, 0x16,
    0x0F, 0x12, 0x14, 0x17,
    0x0F, 0x13, 0x15, 0x17,
    0x0F, 0x11, 0x15, 0x17,
    0x0F, 0x11, 0x13, 0x17,
    0x0F, 0x17, 0x17, 0x17,
    0x0F, 0x0F, 0x17, 0x17,
    0x0F, 0x0F, 0x0F, 0x17,
    0x0F, 0x13, 0x16, 0x1A,
    0x0F, 0x14, 0x18, 0x1A,
    0x0F, 0x11, 0x18, 0x1A,
    0x0F, 0x11, 0x15, 0x1A,
    0x0F, 0x1A, 0x1A, 0x1A,
    0x0F, 0x0F, 0x1A, 0x1A,
    0x0F, 0x0F, 0x0F, 0x1A,
    0x0F, 0x14, 0x18, 0x1D,
    0x0F, 0x16, 0x1A, 0x1D,
    0x0F, 0x12, 0x1A, 0x1D,
    0x0F, 0x12, 0x16, 0x1D,
    0x0F, 0x1D, 0x1D, 0x1D,
    0x0F, 0x0F, 0x1D, 0x1D,
    0x0F, 0x0F, 0x0F, 0x1D,
    0x0F, 0x15, 0x1A, 0x20,
    0x0F, 0x17, 0x1C, 0x20,
    0x0F, 0x13, 0x1C, 0x20,
    0x0F, 0x13, 0x18, 0x20,
    0x0F, 0x20, 0x20, 0x20,
    0x0F, 0x0F, 0x20, 0x20,
    0x0F, 0x0F, 0x0F, 0x20,
    0x0F, 0x16, 0x1C, 0x23,
    0x0F, 0x19, 0x1E, 0x23,
    0x0F, 0x14, 0x1E, 0x23,
    0x0F, 0x14, 0x19, 0x23,
    0x0F, 0x23, 0x23, 0x23,
    0x0F, 0x0F, 0x23, 0x23,
    0x0F, 0x0F, 0x0F, 0x23,
    0x0F, 0x1A, 0x21, 0x26,
    0x0F, 0x14, 0x21, 0x26,
    0x0F, 0x14, 0x1B, 0x26,
    0x0F, 0x26, 0x26, 0x26,
    0x0F, 0x0F, 0x26, 0x26,
    0x0F, 0x0F, 0x0F, 0x26,
    0x0F, 0x1C, 0x23, 0x29,
    0x0F, 0x15, 0x23, 0x29,
    0x0F, 0x15, 0x1C, 0x29,
    0x0F, 0x29, 0x29, 0x29,
    0x0F, 0x0F, 0x29, 0x29,
    0x0F, 0x0F, 0x0F, 0x29,
    0x0F, 0x1D, 0x25, 0x2C,
    0x0F, 0x16, 0x25, 0x2C,
    0x0F, 0x16, 0x1E, 0x2C,
    0x0F, 0x2C, 0x2C, 0x2C,
    0x0F, 0x0F, 0x2C, 0x2C,
    0x0F, 0x0F, 0x0F, 0x2C,
    0x0F, 0x1F, 0x27, 0x2F,
    0x0F, 0x17, 0x27, 0x2F,
    0x0F, 0x17, 0x1F, 0x2F,
    0x0F, 0x2F, 0x2F, 0x2F,
    0x0F, 0x0F, 0x2F, 0x2F,
    0x0F, 0x0F, 0x0F, 0x2F,
    0x0F, 0x32, 0x32, 0x32,
    0x0F, 0x0F, 0x32, 0x32,
    0x0F, 0x0F, 0x0F, 0x32,
    0x0F, 0x21, 0x2A, 0x33,
    0x0F, 0x18, 0x2A, 0x33,
    0x0F, 0x18, 0x21, 0x33,
    0x0F, 0x37, 0x37, 0x37,
    0x0F, 0x0F, 0x37, 0x37,
    0x0F, 0x0F, 0x0F, 0x37,
    0x0F, 0x3D, 0x3D, 0x3D,
    0x0F, 0x0F, 0x3D, 0x3D,
    0x0F, 0x0F, 0x0F, 0x3D,
    0x10, 0x11, 0x11, 0x12,
    0x10, 0x11, 0x12, 0x13,
    0x10, 0x12, 0x13, 0x14,
    0x10, 0x11, 0x13, 0x14,
    0x10, 0x11, 0x12, 0x14,
    0x10, 0x12, 0x13, 0x15,
    0x10, 0x12, 0x14, 0x15,
    0x10, 0x11, 0x14, 0x15,
    0x10, 0x11, 0x13, 0x15,
    0x10, 0x12, 0x14, 0x16,
    0x10, 0x13, 0x15, 0x16,
    0x10, 0x11, 0x15, 0x16,
    0x10, 0x11, 0x13, 0x16,
    0x10, 0x16, 0x16, 0x16,
    0x10, 0x10, 0x16, 0x16,
    0x10, 0x10, 0x10, 0x16,
    0x10, 0x13, 0x14, 0x17,
    0x10, 0x13, 0x16, 0x17,
    0x10, 0x11, 0x16, 0x17,
    0x10, 0x11, 0x14, 0x17,
    0x10, 0x13, 0x15, 0x18,
    0x10, 0x14, 0x16, 0x18,
    0x10, 0x12, 0x16, 0x18,
    0x10, 0x12, 0x14, 0x18,
    0x10, 0x18, 0x18, 0x18,
    0x10, 0x10, 0x18, 0x18,
    0x10, 0x10, 0x10, 0x18,
    0x10, 0x14, 0x17, 0x1B,
    0x10, 0x15, 0x19, 0x1B,
    0x10, 0x12, 0x19, 0x1B,
    0x10, 0x12, 0x16, 0x1B,
    0x10, 0x1B, 0x1B, 0x1B,
    0x10, 0x10, 0x1B, 0x1B,
    0x10, 0x10, 0x10, 0x1B,
    0x10, 0x15, 0x19, 0x1E,
    0x10, 0x17, 0x1B, 0x1E,
    0x10, 0x13, 0x1B, 0x1E,
    0x10, 0x13, 0x17, 0x1E,
    0x10, 0x1E, 0x1E, 0x1E,
    0x10, 0x10, 0x1E, 0x1E,
    0x10, 0x10, 0x10, 0x1E,
    0x10, 0x16, 0x1B, 0x21,
    0x10, 0x18, 0x1D, 0x21,
    0x10, 0x14, 0x1D, 0x21,
    0x10, 0x14, 0x19, 0x21,
    0x10, 0x21, 0x21, 0x21,
    0x10, 0x10, 0x21, 0x21,
    0x10, 0x10, 0x10, 0x21,
    0x10, 0x17, 0x1D, 0x24,
    0x10, 0x1A, 0x1F, 0x24,
    0x10, 0x15, 0x1F, 0x24,
    0x10, 0x15, 0x1A, 0x24,
    0x10, 0x24, 0x24, 0x24,
    0x10, 0x10, 0x24, 0x24,
    0x10, 0x10, 0x10, 0x24,
    0x10, 0x1B, 0x22, 0x27,
    0x10, 0x15, 0x22, 0x27,
    0x10, 0x15, 0x1C, 0x27,
    0x10, 0x27, 0x27, 0x27,
    0x10, 0x10, 0x27, 0x27,
    0x10, 0x10, 0x10, 0x27,
    0x10, 0x1D, 0x24, 0x2A,
    0x10, 0x16, 0x24, 0x2A,
    0x10, 0x16, 0x1D, 0x2A,
    0x10, 0x2A, 0x2A, 0x2A,
    0x10, 0x10, 0x2A, 0x2A,
    0x10, 0x10, 0x10, 0x2A,
    0x10, 0x1E, 0x26, 0x2D,
    0x10, 0x17, 0x26, 0x2D,
    0x10, 0x17, 0x1F, 0x2D,
    0x10, 0x2D, 0x2D, 0x2D,
    0x10, 0x10, 0x2D, 0x2D,
    0x10, 0x10, 0x10, 0x2D,
    0x10, 0x20, 0x28, 0x30,
    0x10, 0x18, 0x28, 0x30,
    0x10, 0x18, 0x20, 0x30,
    0x10, 0x30, 0x30, 0x30,
    0x10, 0x10, 0x30, 0x30,
    0x10, 0x10, 0x10, 0x30,
    0x10, 0x33, 0x33, 0x33,
    0x10, 0x10, 0x33, 0x33,
    0x10, 0x10, 0x10, 0x33,
    0x10, 0x22, 0x2B, 0x34,
    0x10, 0x19, 0x2B, 0x34,
    0x10, 0x19, 0x22, 0x34,
    0x10, 0x38, 0x38, 0x38,
    0x10, 0x10, 0x38, 0x38,
    0x10, 0x10, 0x10, 0x38,
    0x10, 0x3E, 0x3E, 0x3E,
    0x10, 0x10, 0x3E, 0x3E,
    0x10, 0x10, 0x10, 0x3E,
    0x11, 0x12, 0x12, 0x13,
    0x11, 0x12, 0x13, 0x14,
    0x11, 0x13, 0x14, 0x15,
    0x11, 0x12, 0x14, 0x15,
    0x11, 0x12, 0x13, 0x15,
    0x11, 0x13, 0x14, 0x16,
    0x11, 0x13, 0x15, 0x16,
    0x11, 0x12, 0x15, 0x16,
    0x11, 0x12, 0x14, 0x16,
    0x11, 0x13, 0x15, 0x17,
    0x11, 0x14, 0x16, 0x17,
    0x11, 0x12, 0x16, 0x17,
    0x11, 0x12, 0x14, 0x17,
    0x11, 0x17, 0x17, 0x17,
    0x11, 0x11, 0x17, 0x17,
    0x11, 0x11, 0x11, 0x17,
    0x11, 0x14, 0x15, 0x18,
    0x11, 0x14, 0x17, 0x18,
    0x11, 0x12, 0x17, 0x18,
    0x11, 0x12, 0x15, 0x18,
    0x11, 0x14, 0x16, 0x19,
    0x11, 0x15, 0x17, 0x19,
    0x11, 0x13, 0x17, 0x19,
    0x11, 0x13, 0x15, 0x19,
    0x11, 0x19, 0x19, 0x19,
    0x11, 0x11, 0x19, 0x19,
    0x11, 0x11, 0x11, 0x19,
    0x11, 0x15, 0x18, 0x1C,
    0x11, 0x16, 0x1A, 0x1C,
    0x11, 0x13, 0x1A, 0x1C,
    0x11, 0x13, 0x17, 0x1C,
    0x11, 0x1C, 0x1C, 0x1C,
    0x11, 0x11, 0x1C, 0x1C,
    0x11, 0x11, 0x11, 0x1C,
    0x11, 0x16, 0x1A, 0x1F,
    0x11, 0x18, 0x1C, 0x1F,
    0x11, 0x14, 0x1C, 0x1F,
    0x11, 0x14, 0x18, 0x1F,
    0x11, 0x1F, 0x1F, 0x1F,
    0x11, 0x11, 0x1F, 0x1F,
    0x11, 0x11, 0x11, 0x1F,
    0x11, 0x17, 0x1C, 0x22,
    0x11, 0x19, 0x1E, 0x22,
    0x11, 0x15, 0x1E, 0x22,
    0x11, 0x15, 0x1A, 0x22,
    0x11, 0x22, 0x22, 0x22,
    0x11, 0x11, 0x22, 0x22,
    0x11, 0x11, 0x11, 0x22,
    0x11, 0x18, 0x1E, 0x25,
    0x11, 0x1B, 0x20, 0x25,
    0x11, 0x16, 0x20, 0x25,
    0x11, 0x16, 0x1B, 0x25,
    0x11, 0x25, 0x25, 0x25,
    0x11, 0x11, 0x25, 0x25,
    0x11, 0x11, 0x11, 0x25,
    0x11, 0x1C, 0x23, 0x28,
    0x11, 0x16, 0x23, 0x28,
    0x11, 0x16, 0x1D, 0x28,
    0x11, 0x28, 0x28, 0x28,
    0x11, 0x11, 0x28, 0x28,
    0x11, 0x11, 0x11, 0x28,
    0x11, 0x1E, 0x25, 0x2B,
    0x11, 0x17, 0x25, 0x2B,
    0x11, 0x17, 0x1E, 0x2B,
    0x11, 0x2B, 0x2B, 0x2B,
    0x11, 0x11, 0x2B, 0x2B,
    0x11, 0x11, 0x11, 0x2B,
    0x11, 0x1F, 0x27, 0x2E,
    0x11, 0x18, 0x27, 0x2E,
    0x11, 0x18, 0x20, 0x2E,
    0x11, 0x2E, 0x2E, 0x2E,
    0x11, 0x11, 0x2E, 0x2E,
    0x11, 0x11, 0x11, 0x2E,
    0x11, 0x21, 0x29, 0x31,
    0x11, 0x19, 0x29, 0x31,
    0x11, 0x19, 0x21, 0x31,
    0x11, 0x31, 0x31, 0x31,
    0x11, 0x11, 0x31, 0x31,
    0x11, 0x11, 0x11, 0x31,
    0x11, 0x34, 0x34, 0x34,
    0x11, 0x11, 0x34, 0x34,
    0x11, 0x11, 0x11, 0x34,
    0x11, 0x23, 0x2C, 0x35,
    0x11, 0x1A, 0x2C, 0x35,
    0x11, 0x1A, 0x23, 0x35,
    0x11, 0x39, 0x39, 0x39,
    0x11, 0x11, 0x39, 0x39,
    0x11, 0x11, 0x11, 0x39,
    0x11, 0x3F, 0x3F, 0x3F,
    0x11, 0x11, 0x3F, 0x3F,
    0x11, 0x11, 0x11, 0x3F,
    0x12, 0x13, 0x13, 0x14,
    0x12, 0x13, 0x14, 0x15,
    0x12, 0x14, 0x15, 0x16,
    0x12, 0x13, 0x15, 0x16,
    0x12, 0x13, 0x14, 0x16,
    0x12, 0x14, 0x15, 0x17,
    0x12, 0x14, 0x16, 0x17,
    0x12, 0x13, 0x16, 0x17,
    0x12, 0x13, 0x15, 0x17,
    0x12, 0x14, 0x16, 0x18,
    0x12, 0x15, 0x17, 0x18,
    0x12, 0x13, 0x17, 0x18,
    0x12, 0x13, 0x15, 0x18,
    0x12, 0x18, 0x18, 0x18,
    0x12, 0x12, 0x18, 0x18,
    0x12, 0x12, 0x12, 0x18,
    0x12, 0x15, 0x16, 0x19,
    0x12, 0x15, 0x18, 0x19,
    0x12, 0x13, 0x18, 0x19,
    0x12, 0x13, 0x16, 0x19,
    0x12, 0x15, 0x17, 0x1A,
    0x12, 0x16, 0x18, 0x1A,
    0x12, 0x14, 0x18, 0x1A,
    0x12, 0x14, 0x16, 0x1A,
    0x12, 0x1A, 0x1A, 0x1A,
    0x12, 0x12, 0x1A, 0x1A,
    0x12, 0x12, 0x12, 0x1A,
    0x12, 0x16, 0x19, 0x1D,
    0x12, 0x17, 0x1B, 0x1D,
    0x12, 0x14, 0x1B, 0x1D,
    0x12, 0x14, 0x18, 0x1D,
    0x12, 0x1D, 0x1D, 0x1D,
    0x12, 0x12, 0x1D, 0x1D,
    0x12, 0x12, 0x12, 0x1D,
    0x12, 0x17, 0x1B, 0x20,
    0x12, 0x19, 0x1D, 0x20,
    0x12, 0x15, 0x1D, 0x20,
    0x12, 0x15, 0x19, 0x20,
    0x12, 0x20, 0x20, 0x20,
    0x12, 0x12, 0x20, 0x20,
    0x12, 0x12, 0x12, 0x20,
    0x12, 0x18, 0x1D, 0x23,
    0x12, 0x1A, 0x1F, 0x23,
    0x12, 0x16, 0x1F, 0x23,
    0x12, 0x16, 0x1B, 0x23,
    0x12, 0x23, 0x23, 0x23,
    0x12, 0x12, 0x23, 0x23,
    0x12, 0x12, 0x12, 0x23,
    0x12, 0x19, 0x1F, 0x26,
    0x12, 0x1C, 0x21, 0x26,
    0x12, 0x17, 0x21, 0x26,
    0x12, 0x17, 0x1C, 0x26,
    0x12, 0x26, 0x26, 0x26,
    0x12, 0x12, 0x26, 0x26,
    0x12, 0x12, 0x12, 0x26,
    0x12, 0x1D, 0x24, 0x29,
    0x12, 0x17, 0x24, 0x29,
    0x12, 0x17, 0x1E, 0x29,
    0x12, 0x29, 0x29, 0x29,
    0x12, 0x12, 0x29, 0x29,
    0x12, 0x12, 0x12, 0x29,
    0x12, 0x1F, 0x26, 0x2C,
    0x12, 0x18, 0x26, 0x2C,
    0x12, 0x18, 0x1F, 0x2C,
    0x12, 0x2C, 0x2C, 0x2C,
    0x12, 0x12, 0x2C, 0x2C,
    0x12, 0x12, 0x12, 0x2C,
    0x12, 0x20, 0x28, 0x2F,
    0x12, 0x19, 0x28, 0x2F,
    0x12, 0x19, 0x21, 0x2F,
    0x12, 0x2F, 0x2F, 0x2F,
    0x12, 0x12, 0x2F, 0x2F,
    0x12, 0x12, 0x12, 0x2F,
    0x12, 0x22, 0x2A, 0x32,
    0x12, 0x1A, 0x2A, 0x32,
    0x12, 0x1A, 0x22, 0x32,
    0x12, 0x32, 0x32, 0x32,
    0x12, 0x12, 0x32, 0x32,
    0x12, 0x12, 0x12, 0x32,
    0x12, 0x35, 0x35, 0x35,
    0x12, 0x12, 0x35, 0x35,
    0x12, 0x12, 0x12, 0x35,
    0x12, 0x24, 0x2D, 0x36,
    0x12, 0x1B, 0x2D, 0x36,
    0x12, 0x1B, 0x24, 0x36,
    0x12, 0x3A, 0x3A, 0x3A,
    0x12, 0x12, 0x3A, 0x3A,
    0x12, 0x12, 0x12, 0x3A,
    0x13, 0x14, 0x14, 0x15,
    0x13, 0x14, 0x15, 0x16,
    0x13, 0x15, 0x16, 0x17,
    0x13, 0x14, 0x16, 0x17,
    0x13, 0x14, 0x15, 0x17,
    0x13, 0x15, 0x16, 0x18,
    0x13, 0x15, 0x17, 0x18,
    0x13, 0x14, 0x17, 0x18,
    0x13, 0x14, 0x16, 0x18,
    0x13, 0x15, 0x17, 0x19,
    0x13, 0x16, 0x18, 0x19,
    0x13, 0x14, 0x18, 0x19,
    0x13, 0x14, 0x16, 0x19,
    0x13, 0x19, 0x19, 0x19,
    0x13, 0x13, 0x19, 0x19,
    0x13, 0x13, 0x13, 0x19,
    0x13, 0x16, 0x17, 0x1A,
    0x13, 0x16, 0x19, 0x1A,
    0x13, 0x14, 0x19, 0x1A,
    0x13, 0x14, 0x17, 0x1A,
    0x13, 0x16, 0x18, 0x1B,
    0x13, 0x17, 0x19, 0x1B,
    0x13, 0x15, 0x19, 0x1B,
    0x13, 0x15, 0x17, 0x1B,
    0x13, 0x1B, 0x1B, 0x1B,
    0x13, 0x13, 0x1B, 0x1B,
    0x13, 0x13, 0x13, 0x1B,
    0x13, 0x17, 0x1A, 0x1E,
    0x13, 0x18, 0x1C, 0x1E,
    0x13, 0x15, 0x1C, 0x1E,
    0x13, 0x15, 0x19, 0x1E,
    0x13, 0x1E, 0x1E, 0x1E,
    0x13, 0x13, 0x1E, 0x1E,
    0x13, 0x13, 0x13, 0x1E,
    0x13, 0x18, 0x1C, 0x21,
    0x13, 0x1A, 0x1E, 0x21,
    0x13, 0x16, 0x1E, 0x21,
    0x13, 0x16, 0x1A, 0x21,
    0x13, 0x21, 0x21, 0x21,
    0x13, 0x13, 0x21, 0x21,
    0x13, 0x13, 0x13, 0x21,
    0x13, 0x19, 0x1E, 0x24,
    0x13, 0x1B, 0x20, 0x24,
    0x13, 0x17, 0x20, 0x24,
    0x13, 0x17, 0x1C, 0x24,
    0x13, 0x24, 0x24, 0x24,
    0x13, 0x13, 0x24, 0x24,
    0x13, 0x13, 0x13, 0x24,
    0x13, 0x1A, 0x20, 0x27,
    0x13, 0x1D, 0x22, 0x27,
    0x13, 0x18, 0x22, 0x27,
    0x13, 0x18, 0x1D, 0x27,
    0x13, 0x27, 0x27, 0x27,
    0x13, 0x13, 0x27, 0x27,
    0x13, 0x13, 0x13, 0x27,
    0x13, 0x1E, 0x25, 0x2A,
    0x13, 0x18, 0x25, 0x2A,
    0x13, 0x18, 0x1F, 0x2A,
    0x13, 0x2A, 0x2A, 0x2A,
    0x13, 0x13, 0x2A, 0x2A,
    0x13, 0x13, 0x13, 0x2A,
    0x13, 0x20, 0x27, 0x2D,
    0x13, 0x19, 0x27, 0x2D,
    0x13, 0x19, 0x20, 0x2D,
    0x13, 0x2D, 0x2D, 0x2D,
    0x13, 0x13, 0x2D, 0x2D,
    0x13, 0x13, 0x13, 0x2D,
    0x13, 0x21, 0x29, 0x30,
    0x13, 0x1A, 0x29, 0x30,
    0x13, 0x1A, 0x22, 0x30,
    0x13, 0x30, 0x30, 0x30,
    0x13, 0x13, 0x30, 0x30,
    0x13, 0x13, 0x13, 0x30,
    0x13, 0x23, 0x2B, 0x33,
    0x13, 0x1B, 0x2B, 0x33,
    0x13, 0x1B, 0x23, 0x33,
    0x13, 0x33, 0x33, 0x33,
    0x13, 0x13, 0x33, 0x33,
    0x13, 0x13, 0x13, 0x33,
    0x13, 0x36, 0x36, 0x36,
    0x13, 0x13, 0x36, 0x36,
    0x13, 0x13, 0x13, 0x36,
    0x13, 0x25, 0x2E, 0x37,
    0x13, 0x1C, 0x2E, 0x37,
    0x13, 0x1C, 0x25, 0x37,
    0x13, 0x3B, 0x3B, 0x3B,
    0x13, 0x13, 0x3B, 0x3B,
    0x13, 0x13, 0x13, 0x3B,
    0x14, 0x15, 0x15, 0x16,
    0x14, 0x15, 0x16, 0x17,
    0x14, 0x16, 0x17, 0x18,
    0x14, 0x15, 0x17, 0x18,
    0x14, 0x15, 0x16, 0x18,
    0x14, 0x16, 0x17, 0x19,
    0x14, 0x16, 0x18, 0x19,
    0x14, 0x15, 0x18, 0x19,
    0x14, 0x15, 0x17, 0x19,
    0x14, 0x16, 0x18, 0x1A,
    0x14, 0x17, 0x19, 0x1A,
    0x14, 0x15, 0x19, 0x1A,
    0x14, 0x15, 0x17, 0x1A,
    0x14, 0x1A, 0x1A, 0x1A,
    0x14, 0x14, 0x1A, 0x1A,
    0x14, 0x14, 0x14, 0x1A,
    0x14, 0x17, 0x18, 0x1B,
    0x14, 0x17, 0x1A, 0x1B,
    0x14, 0x15, 0x1A, 0x1B,
    0x14, 0x15, 0x18, 0x1B,
    0x14, 0x17, 0x19, 0x1C,
    0x14, 0x18, 0x1A, 0x1C,
    0x14, 0x16, 0x1A, 0x1C,
    0x14, 0x16, 0x18, 0x1C,
    0x14, 0x1C, 0x1C, 0x1C,
    0x14, 0x14, 0x1C, 0x1C,
    0x14, 0x14, 0x14, 0x1C,
    0x14, 0x18, 0x1B, 0x1F,
    0x14, 0x19, 0x1D, 0x1F,
    0x14, 0x16, 0x1D, 0x1F,
    0x14, 0x16, 0x1A, 0x1F,
    0x14, 0x1F, 0x1F, 0x1F,
    0x14, 0x14, 0x1F, 0x1F,
    0x14, 0x14, 0x14, 0x1F,
    0x14, 0x19, 0x1D, 0x22,
    0x14, 0x1B, 0x1F, 0x22,
    0x14, 0x17, 0x1F, 0x22,
    0x14, 0x17, 0x1B, 0x22,
    0x14, 0x22, 0x22, 0x22,
    0x14, 0x14, 0x22, 0x22,
    0x14, 0x14, 0x14, 0x22,
    0x14, 0x1A, 0x1F, 0x25,
    0x14, 0x1C, 0x21, 0x25,
    0x14, 0x18, 0x21, 0x25,
    0x14, 0x18, 0x1D, 0x25,
    0x14, 0x25, 0x25, 0x25,
    0x14, 0x14, 0x25, 0x25,
    0x14, 0x14, 0x14, 0x25,
    0x14, 0x1B, 0x21, 0x28,
    0x14, 0x1E, 0x23, 0x28,
    0x14, 0x19, 0x23, 0x28,
    0x14, 0x19, 0x1E, 0x28,
    0x14, 0x28, 0x28, 0x28,
    0x14, 0x14, 0x28, 0x28,
    0x14, 0x14, 0x14, 0x28,
    0x14, 0x1F, 0x26, 0x2B,
    0x14, 0x19, 0x26, 0x2B,
    0x14, 0x19, 0x20, 0x2B,
    0x14, 0x2B, 0x2B, 0x2B,
    0x14, 0x14, 0x2B, 0x2B,
    0x14, 0x14, 0x14, 0x2B,
    0x14, 0x21, 0x28, 0x2E,
    0x14, 0x1A, 0x28, 0x2E,
    0x14, 0x1A, 0x21, 0x2E,
    0x14, 0x2E, 0x2E, 0x2E,
    0x14, 0x14, 0x2E, 0x2E,
    0x14, 0x14, 0x14, 0x2E,
    0x14, 0x22, 0x2A, 0x31,
    0x14, 0x1B, 0x2A, 0x31,
    0x14, 0x1B, 0x23, 0x31,
    0x14, 0x31, 0x31, 0x31,
    0x14, 0x14, 0x31, 0x31,
    0x14, 0x14, 0x14, 0x31,
    0x14, 0x24, 0x2C, 0x34,
    0x14, 0x1C, 0x2C, 0x34,
    0x14, 0x1C, 0x24, 0x34,
    0x14, 0x34, 0x34, 0x34,
    0x14, 0x14, 0x34, 0x34,
    0x14, 0x14, 0x14, 0x34,
    0x14, 0x37, 0x37, 0x37,
    0x14, 0x14, 0x37, 0x37,
    0x14, 0x14, 0x14, 0x37,
    0x14, 0x26, 0x2F, 0x38,
    0x14, 0x1D, 0x2F, 0x38,
    0x14, 0x1D, 0x26, 0x38,
    0x14, 0x3C, 0x3C, 0x3C,
    0x14, 0x14, 0x3C, 0x3C,
    0x14, 0x14, 0x14, 0x3C,
    0x15, 0x16, 0x16, 0x17,
    0x15, 0x16, 0x17, 0x18,
    0x15, 0x17, 0x18, 0x19,
    0x15, 0x16, 0x18, 0x19,
    0x15, 0x16, 0x17, 0x19,
    0x15, 0x17, 0x18, 0x1A,
    0x15, 0x17, 0x19, 0x1A,
    0x15, 0x16, 0x19, 0x1A,
    0x15, 0x16, 0x18, 0x1A,
    0x15, 0x17, 0x19, 0x1B,
    0x15, 0x18, 0x1A, 0x1B,
    0x15, 0x16, 0x1A, 0x1B,
    0x15, 0x16, 0x18, 0x1B,
    0x15, 0x1B, 0x1B, 0x1B,
    0x15, 0x15, 0x1B, 0x1B,
    0x15, 0x15, 0x15, 0x1B,
    0x15, 0x18, 0x19, 0x1C,
    0x15, 0x18, 0x1B, 0x1C,
    0x15, 0x16, 0x1B, 0x1C,
    0x15, 0x16, 0x19, 0x1C,
    0x15, 0x18, 0x1A, 0x1D,
    0x15, 0x19, 0x1B, 0x1D,
    0x15, 0x17, 0x1B, 0x1D,
    0x15, 0x17, 0x19, 0x1D,
    0x15, 0x1D, 0x1D, 0x1D,
    0x15, 0x15, 0x1D, 0x1D,
    0x15, 0x15, 0x15, 0x1D,
    0x15, 0x19, 0x1C, 0x20,
    0x15, 0x1A, 0x1E, 0x20,
    0x15, 0x17, 0x1E, 0x20,
    0x15, 0x17, 0x1B, 0x20,
    0x15, 0x20, 0x20, 0x20,
    0x15, 0x15, 0x20, 0x20,
    0x15, 0x15, 0x15, 0x20,
    0x15, 0x1A, 0x1E, 0x23,
    0x15, 0x1C, 0x20, 0x23,
    0x15, 0x18, 0x20, 0x23,
    0x15, 0x18, 0x1C, 0x23,
    0x15, 0x23, 0x23, 0x23,
    0x15, 0x15, 0x23, 0x23,
    0x15, 0x15, 0x15, 0x23,
    0x15, 0x1B, 0x20, 0x26,
    0x15, 0x1D, 0x22, 0x26,
    0x15, 0x19, 0x22, 0x26,
    0x15, 0x19, 0x1E, 0x26,
    0x15, 0x26, 0x26, 0x26,
    0x15, 0x15, 0x26, 0x26,
    0x15, 0x15, 0x15, 0x26,
    0x15, 0x1C, 0x22, 0x29,
    0x15, 0x1F, 0x24, 0x29,
    0x15, 0x1A, 0x24, 0x29,
    0x15, 0x1A, 0x1F, 0x29,
    0x15, 0x29, 0x29, 0x29,
    0x15, 0x15, 0x29, 0x29,
    0x15, 0x15, 0x15, 0x29,
    0x15, 0x20, 0x27, 0x2C,
    0x15, 0x1A, 0x27, 0x2C,
    0x15, 0x1A, 0x21, 0x2C,
    0x15, 0x2C, 0x2C, 0x2C,
    0x15, 0x15, 0x2C, 0x2C,
    0x15, 0x15, 0x15, 0x2C,
    0x15, 0x22, 0x29, 0x2F,
    0x15, 0x1B, 0x29, 0x2F,
    0x15, 0x1B, 0x22, 0x2F,
    0x15, 0x2F, 0x2F, 0x2F,
    0x15, 0x15, 0x2F, 0x2F,
    0x15, 0x15, 0x15, 0x2F,
    0x15, 0x23, 0x2B, 0x32,
    0x15, 0x1C, 0x2B, 0x32,
    0x15, 0x1C, 0x24, 0x32,
    0x15, 0x32, 0x32, 0x32,
    0x15, 0x15, 0x32, 0x32,
    0x15, 0x15, 0x15, 0x32,
    0x15, 0x25, 0x2D, 0x35,
    0x15, 0x1D, 0x2D, 0x35,
    0x15, 0x1D, 0x25, 0x35,
    0x15, 0x35, 0x35, 0x35,
    0x15, 0x15, 0x35, 0x35,
    0x15, 0x15, 0x15, 0x35,
    0x15, 0x38, 0x38, 0x38,
    0x15, 0x15, 0x38, 0x38,
    0x15, 0x15, 0x15, 0x38,
    0x15, 0x27, 0x30, 0x39,
    0x15, 0x1E, 0x30, 0x39,
    0x15, 0x1E, 0x27, 0x39,
    0x15, 0x3D, 0x3D, 0x3D,
    0x15, 0x15, 0x3D, 0x3D,
    0x15, 0x15, 0x15, 0x3D,
    0x16, 0x17, 0x17, 0x18,
    0x16, 0x17, 0x18, 0x19,
    0x16, 0x18, 0x19, 0x1A,
    0x16, 0x17, 0x19, 0x1A,
    0x16, 0x17, 0x18, 0x1A,
    0x16, 0x18, 0x19, 0x1B,
    0x16, 0x18, 0x1A, 0x1B,
    0x16, 0x17, 0x1A, 0x1B,
    0x16, 0x17, 0x19, 0x1B,
    0x16, 0x18, 0x1A, 0x1C,
    0x16, 0x19, 0x1B, 0x1C,
    0x16, 0x17, 0x1B, 0x1C,
    0x16, 0x17, 0x19, 0x1C,
    0x16, 0x1C, 0x1C, 0x1C,
    0x16, 0x16, 0x1C, 0x1C,
    0x16, 0x16, 0x16, 0x1C,
    0x16, 0x19, 0x1A, 0x1D,
    0x16, 0x19, 0x1C, 0x1D,
    0x16, 0x17, 0x1C, 0x1D,
    0x16, 0x17, 0x1A, 0x1D,
    0x16, 0x19, 0x1B, 0x1E,
    0x16, 0x1A, 0x1C, 0x1E,
    0x16, 0x18, 0x1C, 0x1E,
    0x16, 0x18, 0x1A, 0x1E,
    0x16, 0x1E, 0x1E, 0x1E,
    0x16, 0x16, 0x1E, 0x1E,
    0x16, 0x16, 0x16, 0x1E,
    0x16, 0x1A, 0x1D, 0x21,
    0x16, 0x1B, 0x1F, 0x21,
    0x16, 0x18, 0x1F, 0x21,
    0x16, 0x18, 0x1C, 0x21,
    0x16, 0x21, 0x21, 0x21,
    0x16, 0x16, 0x21, 0x21,
    0x16, 0x16, 0x16, 0x21,
    0x16, 0x1B, 0x1F, 0x24,
    0x16, 0x1D, 0x21, 0x24,
    0x16, 0x19, 0x21, 0x24,
    0x16, 0x19, 0x1D, 0x24,
    0x16, 0x24, 0x24, 0x24,
    0x16, 0x16, 0x24, 0x24,
    0x16, 0x16, 0x16, 0x24,
    0x16, 0x1C, 0x21, 0x27,
    0x16, 0x1E, 0x23, 0x27,
    0x16, 0x1A, 0x23, 0x27,
    0x16, 0x1A, 0x1F, 0x27,
    0x16, 0x27, 0x27, 0x27,
    0x16, 0x16, 0x27, 0x27,
    0x16, 0x16, 0x16, 0x27,
    0x16, 0x1D, 0x23, 0x2A,
    0x16, 0x20, 0x25, 0x2A,
    0x16, 0x1B, 0x25, 0x2A,
    0x16, 0x1B, 0x20, 0x2A,
    0x16, 0x2A, 0x2A, 0x2A,
    0x16, 0x16, 0x2A, 0x2A,
    0x16, 0x16, 0x16, 0x2A,
    0x16, 0x21, 0x28, 0x2D,
    0x16, 0x1B, 0x28, 0x2D,
    0x16, 0x1B, 0x22, 0x2D,
    0x16, 0x2D, 0x2D, 0x2D,
    0x16, 0x16, 0x2D, 0x2D,
    0x16, 0x16, 0x16, 0x2D,
    0x16, 0x23, 0x2A, 0x30,
    0x16, 0x1C, 0x2A, 0x30,
    0x16, 0x1C, 0x23, 0x30,
    0x16, 0x30, 0x30, 0x30,
    0x16, 0x16, 0x30, 0x30,
    0x16, 0x16, 0x16, 0x30,
    0x16, 0x24, 0x2C, 0x33,
    0x16, 0x1D, 0x2C, 0x33,
    0x16, 0x1D, 0x25, 0x33,
    0x16, 0x33, 0x33, 0x33,
    0x16, 0x16, 0x33, 0x33,
    0x16, 0x16, 0x16, 0x33,
    0x16, 0x26, 0x2E, 0x36,
    0x16, 0x1E, 0x2E, 0x36,
    0x16, 0x1E, 0x26, 0x36,
    0x16, 0x36, 0x36, 0x36,
    0x16, 0x16, 0x36, 0x36,
    0x16, 0x16, 0x16, 0x36,
    0x16, 0x39, 0x39, 0x39,
    0x16, 0x16, 0x39, 0x39,
    0x16, 0x16, 0x16, 0x39,
    0x16, 0x28, 0x31, 0x3A,
    0x16, 0x1F, 0x31, 0x3A,
    0x16, 0x1F, 0x28, 0x3A,
    0x16, 0x3E, 0x3E, 0x3E,
    0x16, 0x16, 0x3E, 0x3E,
    0x16, 0x16, 0x16, 0x3E,
    0x17, 0x18, 0x18, 0x19,
    0x17, 0x18, 0x19, 0x1A,
    0x17, 0x19, 0x1A, 0x1B,
    0x17, 0x18, 0x1A, 0x1B,
    0x17, 0x18, 0x19, 0x1B,
    0x17, 0x19, 0x1A, 0x1C,
    0x17, 0x19, 0x1B, 0x1C,
    0x17, 0x18, 0x1B, 0x1C,
    0x17, 0x18, 0x1A, 0x1C,
    0x17, 0x19, 0x1B, 0x1D,
    0x17, 0x1A, 0x1C, 0x1D,
    0x17, 0x18, 0x1C, 0x1D,
    0x17, 0x18, 0x1A, 0x1D,
    0x17, 0x1D, 0x1D, 0x1D,
    0x17, 0x17, 0x1D, 0x1D,
    0x17, 0x17, 0x17, 0x1D,
    0x17, 0x1A, 0x1B, 0x1E,
    0x17, 0x1A, 0x1D, 0x1E,
    0x17, 0x18, 0x1D, 0x1E,
    0x17, 0x18, 0x1B, 0x1E,
    0x17, 0x1A, 0x1C, 0x1F,
    0x17, 0x1B, 0x1D, 0x1F,
    0x17, 0x19, 0x1D, 0x1F,
    0x17, 0x19, 0x1B, 0x1F,
    0x17, 0x1F, 0x1F, 0x1F,
    0x17, 0x17, 0x1F, 0x1F,
    0x17, 0x17, 0x17, 0x1F,
    0x17, 0x1B, 0x1E, 0x22,
    0x17, 0x1C, 0x20, 0x22,
    0x17, 0x19, 0x20, 0x22,
    0x17, 0x19, 0x1D, 0x22,
    0x17, 0x22, 0x22, 0x22,
    0x17, 0x17, 0x22, 0x22,
    0x17, 0x17, 0x17, 0x22,
    0x17, 0x1C, 0x20, 0x25,
    0x17, 0x1E, 0x22, 0x25,
    0x17, 0x1A, 0x22, 0x25,
    0x17, 0x1A, 0x1E, 0x25,
    0x17, 0x25, 0x25, 0x25,
    0x17, 0x17, 0x25, 0x25,
    0x17, 0x17, 0x17, 0x25,
    0x17, 0x1D, 0x22, 0x28,
    0x17, 0x1F, 0x24, 0x28,
    0x17, 0x1B, 0x24, 0x28,
    0x17, 0x1B, 0x20, 0x28,
    0x17, 0x28, 0x28, 0x28,
    0x17, 0x17, 0x28, 0x28,
    0x17, 0x17, 0x17, 0x28,
    0x17, 0x1E, 0x24, 0x2B,
    0x17, 0x21, 0x26, 0x2B,
    0x17, 0x1C, 0x26, 0x2B,
    0x17, 0x1C, 0x21, 0x2B,
    0x17, 0x2B, 0x2B, 0x2B,
    0x17, 0x17, 0x2B, 0x2B,
    0x17, 0x17, 0x17, 0x2B,
    0x17, 0x22, 0x29, 0x2E,
    0x17, 0x1C, 0x29, 0x2E,
    0x17, 0x1C, 0x23, 0x2E,
    0x17, 0x2E, 0x2E, 0x2E,
    0x17, 0x17, 0x2E, 0x2E,
    0x17, 0x17, 0x17, 0x2E,
    0x17, 0x24, 0x2B, 0x31,
    0x17, 0x1D, 0x2B, 0x31,
    0x17, 0x1D, 0x24, 0x31,
    0x17, 0x31, 0x31, 0x31,
    0x17, 0x17, 0x31, 0x31,
    0x17, 0x17, 0x17, 0x31,
    0x17, 0x25, 0x2D, 0x34,
    0x17, 0x1E, 0x2D, 0x34,
    0x17, 0x1E, 0x26, 0x34,
    0x17, 0x34, 0x34, 0x34,
    0x17, 0x17, 0x34, 0x34,
    0x17, 0x17, 0x17, 0x34,
    0x17, 0x27, 0x2F, 0x37,
    0x17, 0x1F, 0x2F, 0x37,
    0x17, 0x1F, 0x27, 0x37,
    0x17, 0x37, 0x37, 0x37,
    0x17, 0x17, 0x37, 0x37,
    0x17, 0x17, 0x17, 0x37,
    0x17, 0x3A, 0x3A, 0x3A,
    0x17, 0x17, 0x3A, 0x3A,
    0x17, 0x17, 0x17, 0x3A,
    0x17, 0x29, 0x32, 0x3B,
    0x17, 0x20, 0x32, 0x3B,
    0x17, 0x20, 0x29, 0x3B,
    0x17, 0x3F, 0x3F, 0x3F,
    0x17, 0x17, 0x3F, 0x3F,
    0x17, 0x17, 0x17, 0x3F,
    0x18, 0x19, 0x19, 0x1A,
    0x18, 0x19, 0x1A, 0x1B,
    0x18, 0x1A, 0x1B, 0x1C,
    0x18, 0x19, 0x1B, 0x1C,
    0x18, 0x19, 0x1A, 0x1C,
    0x18, 0x1A, 0x1B, 0x1D,
    0x18, 0x1A, 0x1C, 0x1D,
    0x18, 0x19, 0x1C, 0x1D,
    0x18, 0x19, 0x1B, 0x1D,
    0x18, 0x1A, 0x1C, 0x1E,
    0x18, 0x1B, 0x1D, 0x1E,
    0x18, 0x19, 0x1D, 0x1E,
    0x18, 0x19, 0x1B, 0x1E,
    0x18, 0x1E, 0x1E, 0x1E,
    0x18, 0x18, 0x1E, 0x1E,
    0x18, 0x18, 0x18, 0x1E,
    0x18, 0x1B, 0x1C, 0x1F,
    0x18, 0x1B, 0x1E, 0x1F,
    0x18, 0x19, 0x1E, 0x1F,
    0x18, 0x19, 0x1C, 0x1F,
    0x18, 0x1B, 0x1D, 0x20,
    0x18, 0x1C, 0x1E, 0x20,
    0x18, 0x1A, 0x1E, 0x20,
    0x18, 0x1A, 0x1C, 0x20,
    0x18, 0x20, 0x20, 0x20,
    0x18, 0x18, 0x20, 0x20,
    0x18, 0x18, 0x18, 0x20,
    0x18, 0x1C, 0x1F, 0x23,
    0x18, 0x1D, 0x21, 0x23,
    0x18, 0x1A, 0x21, 0x23,
    0x18, 0x1A, 0x1E, 0x23,
    0x18, 0x23, 0x23, 0x23,
    0x18, 0x18, 0x23, 0x23,
    0x18, 0x18, 0x18, 0x23,
    0x18, 0x1D, 0x21, 0x26,
    0x18, 0x1F, 0x23, 0x26,
    0x18, 0x1B, 0x23, 0x26,
    0x18, 0x1B, 0x1F, 0x26,
    0x18, 0x26, 0x26, 0x26,
    0x18, 0x18, 0x26, 0x26,
    0x18, 0x18, 0x18, 0x26,
    0x18, 0x1E, 0x23, 0x29,
    0x18, 0x20, 0x25, 0x29,
    0x18, 0x1C, 0x25, 0x29,
    0x18, 0x1C, 0x21, 0x29,
    0x18, 0x29, 0x29, 0x29,
    0x18, 0x18, 0x29, 0x29,
    0x18, 0x18, 0x18, 0x29,
    0x18, 0x1F, 0x25, 0x2C,
    0x18, 0x22, 0x27, 0x2C,
    0x18, 0x1D, 0x27, 0x2C,
    0x18, 0x1D, 0x22, 0x2C,
    0x18, 0x2C, 0x2C, 0x2C,
    0x18, 0x18, 0x2C, 0x2C,
    0x18, 0x18, 0x18, 0x2C,
    0x18, 0x23, 0x2A, 0x2F,
    0x18, 0x1D, 0x2A, 0x2F,
    0x18, 0x1D, 0x24, 0x2F,
    0x18, 0x2F, 0x2F, 0x2F,
    0x18, 0x18, 0x2F, 0x2F,
    0x18, 0x18, 0x18, 0x2F,
    0x18, 0x25, 0x2C, 0x32,
    0x18, 0x1E, 0x2C, 0x32,
    0x18, 0x1E, 0x25, 0x32,
    0x18, 0x32, 0x32, 0x32,
    0x18, 0x18, 0x32, 0x32,
    0x18, 0x18, 0x18, 0x32,
    0x18, 0x26, 0x2E, 0x35,
    0x18, 0x1F, 0x2E, 0x35,
    0x18, 0x1F, 0x27, 0x35,
    0x18, 0x35, 0x35, 0x35,
    0x18, 0x18, 0x35, 0x35,
    0x18, 0x18, 0x18, 0x35,
    0x18, 0x28, 0x30, 0x38,
    0x18, 0x20, 0x30, 0x38,
    0x18, 0x20, 0x28, 0x38,
    0x18, 0x38, 0x38, 0x38,
    0x18, 0x18, 0x38, 0x38,
    0x18, 0x18, 0x18, 0x38,
    0x18, 0x3B, 0x3B, 0x3B,
    0x18, 0x18, 0x3B, 0x3B,
    0x18, 0x18, 0x18, 0x3B,
    0x18, 0x2A, 0x33, 0x3C,
    0x18, 0x21, 0x33, 0x3C,
    0x18, 0x21, 0x2A, 0x3C,
    0x19, 0x1A, 0x1A, 0x1B,
    0x19, 0x1A, 0x1B, 0x1C,
    0x19, 0x1B, 0x1C, 0x1D,
    0x19, 0x1A, 0x1C, 0x1D,
    0x19, 0x1A, 0x1B, 0x1D,
    0x19, 0x1B, 0x1C, 0x1E,
    0x19, 0x1B, 0x1D, 0x1E,
    0x19, 0x1A, 0x1D, 0x1E,
    0x19, 0x1A, 0x1C, 0x1E,
    0x19, 0x1B, 0x1D, 0x1F,
    0x19, 0x1C, 0x1E, 0x1F,
    0x19, 0x1A, 0x1E, 0x1F,
    0x19, 0x1A, 0x1C, 0x1F,
    0x19, 0x1F, 0x1F, 0x1F,
    0x19, 0x19, 0x1F, 0x1F,
    0x19, 0x19, 0x19, 0x1F,
    0x19, 0x1C, 0x1D, 0x20,
    0x19, 0x1C, 0x1F, 0x20,
    0x19, 0x1A, 0x1F, 0x20,
    0x19, 0x1A, 0x1D, 0x20,
    0x19, 0x1C, 0x1E, 0x21,
    0x19, 0x1D, 0x1F, 0x21,
    0x19, 0x1B, 0x1F, 0x21,
    0x19, 0x1B, 0x1D, 0x21,
    0x19, 0x21, 0x21, 0x21,
    0x19, 0x19, 0x21, 0x21,
    0x19, 0x19, 0x19, 0x21,
    0x19, 0x1D, 0x20, 0x24,
    0x19, 0x1E, 0x22, 0x24,
    0x19, 0x1B, 0x22, 0x24,
    0x19, 0x1B, 0x1F, 0x24,
    0x19, 0x24, 0x24, 0x24,
    0x19, 0x19, 0x24, 0x24,
    0x19, 0x19, 0x19, 0x24,
    0x19, 0x1E, 0x22, 0x27,
    0x19, 0x20, 0x24, 0x27,
    0x19, 0x1C, 0x24, 0x27,
    0x19, 0x1C, 0x20, 0x27,
    0x19, 0x27, 0x27, 0x27,
    0x19, 0x19, 0x27, 0x27,
    0x19, 0x19, 0x19, 0x27,
    0x19, 0x1F, 0x24, 0x2A,
    0x19, 0x21, 0x26, 0x2A,
    0x19, 0x1D, 0x26, 0x2A,
    0x19, 0x1D, 0x22, 0x2A,
    0x19, 0x2A, 0x2A, 0x2A,
    0x19, 0x19, 0x2A, 0x2A,
    0x19, 0x19, 0x19, 0x2A,
    0x19, 0x20, 0x26, 0x2D,
    0x19, 0x23, 0x28, 0x2D,
    0x19, 0x1E, 0x28, 0x2D,
    0x19, 0x1E, 0x23, 0x2D,
    0x19, 0x2D, 0x2D, 0x2D,
    0x19, 0x19, 0x2D, 0x2D,
    0x19, 0x19, 0x19, 0x2D,
    0x19, 0x24, 0x2B, 0x30,
    0x19, 0x1E, 0x2B, 0x30,
    0x19, 0x1E, 0x25, 0x30,
    0x19, 0x30, 0x30, 0x30,
    0x19, 0x19, 0x30, 0x30,
    0x19, 0x19, 0x19, 0x30,
    0x19, 0x26, 0x2D, 0x33,
    0x19, 0x1F, 0x2D, 0x33,
    0x19, 0x1F, 0x26, 0x33,
    0x19, 0x33, 0x33, 0x33,
    0x19, 0x19, 0x33, 0x33,
    0x19, 0x19, 0x19, 0x33,
    0x19, 0x27, 0x2F, 0x36,
    0x19, 0x20, 0x2F, 0x36,
    0x19, 0x20, 0x28, 0x36,
    0x19, 0x36, 0x36, 0x36,
    0x19, 0x19, 0x36, 0x36,
    0x19, 0x19, 0x19, 0x36,
    0x19, 0x29, 0x31, 0x39,
    0x19, 0x21, 0x31, 0x39,
    0x19, 0x21, 0x29, 0x39,
    0x19, 0x39, 0x39, 0x39,
    0x19, 0x19, 0x39, 0x39,
    0x19, 0x19, 0x19, 0x39,
    0x19, 0x3C, 0x3C, 0x3C,
    0x19, 0x19, 0x3C, 0x3C,
    0x19, 0x19, 0x19, 0x3C,
    0x19, 0x2B, 0x34, 0x3D,
    0x19, 0x22, 0x34, 0x3D,
    0x19, 0x22, 0x2B, 0x3D,
    0x1A, 0x1B, 0x1B, 0x1C,
    0x1A, 0x1B, 0x1C, 0x1D,
    0x1A, 0x1C, 0x1D, 0x1E,
    0x1A, 0x1B, 0x1D, 0x1E,
    0x1A, 0x1B, 0x1C, 0x1E,
    0x1A, 0x1C, 0x1D, 0x1F,
    0x1A, 0x1C, 0x1E, 0x1F,
    0x1A, 0x1B, 0x1E, 0x1F,
    0x1A, 0x1B, 0x1D, 0x1F,
    0x1A, 0x1C, 0x1E, 0x20,
    0x1A, 0x1D, 0x1F, 0x20,
    0x1A, 0x1B, 0x1F, 0x20,
    0x1A, 0x1B, 0x1D, 0x20,
    0x1A, 0x20, 0x20, 0x20,
    0x1A, 0x1A, 0x20, 0x20,
    0x1A, 0x1A, 0x1A, 0x20,
    0x1A, 0x1D, 0x1E, 0x21,
    0x1A, 0x1D, 0x20, 0x21,
    0x1A, 0x1B, 0x20, 0x21,
    0x1A, 0x1B, 0x1E, 0x21,
    0x1A, 0x1D, 0x1F, 0x22,
    0x1A, 0x1E, 0x20, 0x22,
    0x1A, 0x1C, 0x20, 0x22,
    0x1A, 0x1C, 0x1E, 0x22,
    0x1A, 0x22, 0x22, 0x22,
    0x1A, 0x1A, 0x22, 0x22,
    0x1A, 0x1A, 0x1A, 0x22,
    0x1A, 0x1E, 0x21, 0x25,
    0x1A, 0x1F, 0x23, 0x25,
    0x1A, 0x1C, 0x23, 0x25,
    0x1A, 0x1C, 0x20, 0x25,
    0x1A, 0x25, 0x25, 0x25,
    0x1A, 0x1A, 0x25, 0x25,
    0x1A, 0x1A, 0x1A, 0x25,
    0x1A, 0x1F, 0x23, 0x28,
    0x1A, 0x21, 0x25, 0x28,
    0x1A, 0x1D, 0x25, 0x28,
    0x1A, 0x1D, 0x21, 0x28,
    0x1A, 0x28, 0x28, 0x28,
    0x1A, 0x1A, 0x28, 0x28,
    0x1A, 0x1A, 0x1A, 0x28,
    0x1A, 0x20, 0x25, 0x2B,
    0x1A, 0x22, 0x27, 0x2B,
    0x1A, 0x1E, 0x27, 0x2B,
    0x1A, 0x1E, 0x23, 0x2B,
    0x1A, 0x2B, 0x2B, 0x2B,
    0x1A, 0x1A, 0x2B, 0x2B,
    0x1A, 0x1A, 0x1A, 0x2B,
    0x1A, 0x21, 0x27, 0x2E,
    0x1A, 0x24, 0x29, 0x2E,
    0x1A, 0x1F, 0x29, 0x2E,
    0x1A, 0x1F, 0x24, 0x2E,
    0x1A, 0x2E, 0x2E, 0x2E,
    0x1A, 0x1A, 0x2E, 0x2E,
    0x1A, 0x1A, 0x1A, 0x2E,
    0x1A, 0x25, 0x2C, 0x31,
    0x1A, 0x1F, 0x2C, 0x31,
    0x1A, 0x1F, 0x26, 0x31,
    0x1A, 0x31, 0x31, 0x31,
    0x1A, 0x1A, 0x31, 0x31,
    0x1A, 0x1A, 0x1A, 0x31,
    0x1A, 0x27, 0x2E, 0x34,
    0x1A, 0x20, 0x2E, 0x34,
    0x1A, 0x20, 0x27, 0x34,
    0x1A, 0x34, 0x34, 0x34,
    0x1A, 0x1A, 0x34, 0x34,
    0x1A, 0x1A, 0x1A, 0x34,
    0x1A, 0x28, 0x30, 0x37,
    0x1A, 0x21, 0x30, 0x37,
    0x1A, 0x21, 0x29, 0x37,
    0x1A, 0x37, 0x37, 0x37,
    0x1A, 0x1A, 0x37, 0x37,
    0x1A, 0x1A, 0x1A, 0x37,
    0x1A, 0x2A, 0x32, 0x3A,
    0x1A, 0x22, 0x32, 0x3A,
    0x1A, 0x22, 0x2A, 0x3A,
    0x1A, 0x3A, 0x3A, 0x3A,
    0x1A, 0x1A, 0x3A, 0x3A,
    0x1A, 0x1A, 0x1A, 0x3A,
    0x1A, 0x3D, 0x3D, 0x3D,
    0x1A, 0x1A, 0x3D, 0x3D,
    0x1A, 0x1A, 0x1A, 0x3D,
    0x1A, 0x2C, 0x35, 0x3E,
    0x1A, 0x23, 0x35, 0x3E,
    0x1A, 0x23, 0x2C, 0x3E,
    0x1B, 0x1C, 0x1C, 0x1D,
    0x1B, 0x1C, 0x1D, 0x1E,
    0x1B, 0x1D, 0x1E, 0x1F,
    0x1B, 0x1C, 0x1E, 0x1F,
    0x1B, 0x1C, 0x1D, 0x1F,
    0x1B, 0x1D, 0x1E, 0x20,
    0x1B, 0x1D, 0x1F, 0x20,
    0x1B, 0x1C, 0x1F, 0x20,
    0x1B, 0x1C, 0x1E, 0x20,
    0x1B, 0x1D, 0x1F, 0x21,
    0x1B, 0x1E, 0x20, 0x21,
    0x1B, 0x1C, 0x20, 0x21,
    0x1B, 0x1C, 0x1E, 0x21,
    0x1B, 0x21, 0x21, 0x21,
    0x1B, 0x1B, 0x21, 0x21,
    0x1B, 0x1B, 0x1B, 0x21,
    0x1B, 0x1E, 0x1F, 0x22,
    0x1B, 0x1E, 0x21, 0x22,
    0x1B, 0x1C, 0x21, 0x22,
    0x1B, 0x1C, 0x1F, 0x22,
    0x1B, 0x1E, 0x20, 0x23,
    0x1B, 0x1F, 0x21, 0x23,
    0x1B, 0x1D, 0x21, 0x23,
    0x1B, 0x1D, 0x1F, 0x23,
    0x1B, 0x23, 0x23, 0x23,
    0x1B, 0x1B, 0x23, 0x23,
    0x1B, 0x1B, 0x1B, 0x23,
    0x1B, 0x1F, 0x22, 0x26,
    0x1B, 0x20, 0x24, 0x26,
    0x1B, 0x1D, 0x24, 0x26,
    0x1B, 0x1D, 0x21, 0x26,
    0x1B, 0x26, 0x26, 0x26,
    0x1B, 0x1B, 0x26, 0x26,
    0x1B, 0x1B, 0x1B, 0x26,
    0x1B, 0x20, 0x24, 0x29,
    0x1B, 0x22, 0x26, 0x29,
    0x1B, 0x1E, 0x26, 0x29,
    0x1B, 0x1E, 0x22, 0x29,
    0x1B, 0x29, 0x29, 0x29,
    0x1B, 0x1B, 0x29, 0x29,
    0x1B, 0x1B, 0x1B, 0x29,
    0x1B, 0x21, 0x26, 0x2C,
    0x1B, 0x23, 0x28, 0x2C,
    0x1B, 0x1F, 0x28, 0x2C,
    0x1B, 0x1F, 0x24, 0x2C,
    0x1B, 0x2C, 0x2C, 0x2C,
    0x1B, 0x1B, 0x2C, 0x2C,
    0x1B, 0x1B, 0x1B, 0x2C,
    0x1B, 0x22, 0x28, 0x2F,
    0x1B, 0x25, 0x2A, 0x2F,
    0x1B, 0x20, 0x2A, 0x2F,
    0x1B, 0x20, 0x25, 0x2F,
    0x1B, 0x2F, 0x2F, 0x2F,
    0x1B, 0x1B, 0x2F, 0x2F,
    0x1B, 0x1B, 0x1B, 0x2F,
    0x1B, 0x26, 0x2D, 0x32,
    0x1B, 0x20, 0x2D, 0x32,
    0x1B, 0x20, 0x27, 0x32,
    0x1B, 0x32, 0x32, 0x32,
    0x1B, 0x1B, 0x32, 0x32,
    0x1B, 0x1B, 0x1B, 0x32,
    0x1B, 0x28, 0x2F, 0x35,
    0x1B, 0x21, 0x2F, 0x35,
    0x1B, 0x21, 0x28, 0x35,
    0x1B, 0x35, 0x35, 0x35,
    0x1B, 0x1B, 0x35, 0x35,
    0x1B, 0x1B, 0x1B, 0x35,
    0x1B, 0x29, 0x31, 0x38,
    0x1B, 0x22, 0x31, 0x38,
    0x1B, 0x22, 0x2A, 0x38,
    0x1B, 0x38, 0x38, 0x38,
    0x1B, 0x1B, 0x38, 0x38,
    0x1B, 0x1B, 0x1B, 0x38,
    0x1B, 0x2B, 0x33, 0x3B,
    0x1B, 0x23, 0x33, 0x3B,
    0x1B, 0x23, 0x2B, 0x3B,
    0x1B, 0x3B, 0x3B, 0x3B,
    0x1B, 0x1B, 0x3B, 0x3B,
    0x1B, 0x1B, 0x1B, 0x3B,
    0x1B, 0x3E, 0x3E, 0x3E,
    0x1B, 0x1B, 0x3E, 0x3E,
    0x1B, 0x1B, 0x1B, 0x3E,
    0x1B, 0x2D, 0x36, 0x3F,
    0x1B, 0x24, 0x36, 0x3F,
    0x1B, 0x24, 0x2D, 0x3F,
    0x1C, 0x1D, 0x1D, 0x1E,
    0x1C, 0x1D, 0x1E, 0x1F,
    0x1C, 0x1E, 0x1F, 0x20,
    0x1C, 0x1D, 0x1F, 0x20,
    0x1C, 0x1D, 0x1E, 0x20,
    0x1C, 0x1E, 0x1F, 0x21,
    0x1C, 0x1E, 0x20, 0x21,
    0x1C, 0x1D, 0x20, 0x21,
    0x1C, 0x1D, 0x1F, 0x21,
    0x1C, 0x1E, 0x20, 0x22,
    0x1C, 0x1F, 0x21, 0x22,
    0x1C, 0x1D, 0x21, 0x22,
    0x1C, 0x1D, 0x1F, 0x22,
    0x1C, 0x22, 0x22, 0x22,
    0x1C, 0x1C, 0x22, 0x22,
    0x1C, 0x1C, 0x1C, 0x22,
    0x1C, 0x1F, 0x20, 0x23,
    0x1C, 0x1F, 0x22, 0x23,
    0x1C, 0x1D, 0x22, 0x23,
    0x1C, 0x1D, 0x20, 0x23,
    0x1C, 0x1F, 0x21, 0x24,
    0x1C, 0x20, 0x22, 0x24,
    0x1C, 0x1E, 0x22, 0x24,
    0x1C, 0x1E, 0x20, 0x24,
    0x1C, 0x24, 0x24, 0x24,
    0x1C, 0x1C, 0x24, 0x24,
    0x1C, 0x1C, 0x1C, 0x24,
    0x1C, 0x20, 0x23, 0x27,
    0x1C, 0x21, 0x25, 0x27,
    0x1C, 0x1E, 0x25, 0x27,
    0x1C, 0x1E, 0x22, 0x27,
    0x1C, 0x27, 0x27, 0x27,
    0x1C, 0x1C, 0x27, 0x27,
    0x1C, 0x1C, 0x1C, 0x27,
    0x1C, 0x21, 0x25, 0x2A,
    0x1C, 0x23, 0x27, 0x2A,
    0x1C, 0x1F, 0x27, 0x2A,
    0x1C, 0x1F, 0x23, 0x2A,
    0x1C, 0x2A, 0x2A, 0x2A,
    0x1C, 0x1C, 0x2A, 0x2A,
    0x1C, 0x1C, 0x1C, 0x2A,
    0x1C, 0x22, 0x27, 0x2D,
    0x1C, 0x24, 0x29, 0x2D,
    0x1C, 0x20, 0x29, 0x2D,
    0x1C, 0x20, 0x25, 0x2D,
    0x1C, 0x2D, 0x2D, 0x2D,
    0x1C, 0x1C, 0x2D, 0x2D,
    0x1C, 0x1C, 0x1C, 0x2D,
    0x1C, 0x23, 0x29, 0x30,
    0x1C, 0x26, 0x2B, 0x30,
    0x1C, 0x21, 0x2B, 0x30,
    0x1C, 0x21, 0x26, 0x30,
    0x1C, 0x30, 0x30, 0x30,
    0x1C, 0x1C, 0x30, 0x30,
    0x1C, 0x1C, 0x1C, 0x30,
    0x1C, 0x27, 0x2E, 0x33,
    0x1C, 0x21, 0x2E, 0x33,
    0x1C, 0x21, 0x28, 0x33,
    0x1C, 0x33, 0x33, 0x33,
    0x1C, 0x1C, 0x33, 0x33,
    0x1C, 0x1C, 0x1C, 0x33,
    0x1C, 0x29, 0x30, 0x36,
    0x1C, 0x22, 0x30, 0x36,
    0x1C, 0x22, 0x29, 0x36,
    0x1C, 0x36, 0x36, 0x36,
    0x1C, 0x1C, 0x36, 0x36,
    0x1C, 0x1C, 0x1C, 0x36,
    0x1C, 0x2A, 0x32, 0x39,
    0x1C, 0x23, 0x32, 0x39,
    0x1C, 0x23, 0x2B, 0x39,
    0x1C, 0x39, 0x39, 0x39,
    0x1C, 0x1C, 0x39, 0x39,
    0x1C, 0x1C, 0x1C, 0x39,
    0x1C, 0x2C, 0x34, 0x3C,
    0x1C, 0x24, 0x34, 0x3C,
    0x1C, 0x24, 0x2C, 0x3C,
    0x1C, 0x3C, 0x3C, 0x3C,
    0x1C, 0x1C, 0x3C, 0x3C,
    0x1C, 0x1C, 0x1C, 0x3C,
    0x1C, 0x3F, 0x3F, 0x3F,
    0x1C, 0x1C, 0x3F, 0x3F,
    0x1C, 0x1C, 0x1C, 0x3F,
    0x1D, 0x1E, 0x1E, 0x1F,
    0x1D, 0x1E, 0x1F, 0x20,
    0x1D, 0x1F, 0x20, 0x21,
    0x1D, 0x1E, 0x20, 0x21,
    0x1D, 0x1E, 0x1F, 0x21,
    0x1D, 0x1F, 0x20, 0x22,
    0x1D, 0x1F, 0x21, 0x22,
    0x1D, 0x1E, 0x21, 0x22,
    0x1D, 0x1E, 0x20, 0x22,
    0x1D, 0x1F, 0x21, 0x23,
    0x1D, 0x20, 0x22, 0x23,
    0x1D, 0x1E, 0x22, 0x23,
    0x1D, 0x1E, 0x20, 0x23,
    0x1D, 0x23, 0x23, 0x23,
    0x1D, 0x1D, 0x23, 0x23,
    0x1D, 0x1D, 0x1D, 0x23,
    0x1D, 0x20, 0x21, 0x24,
    0x1D, 0x20, 0x23, 0x24,
    0x1D, 0x1E, 0x23, 0x24,
    0x1D, 0x1E, 0x21, 0x24,
    0x1D, 0x20, 0x22, 0x25,
    0x1D, 0x21, 0x23, 0x25,
    0x1D, 0x1F, 0x23, 0x25,
    0x1D, 0x1F, 0x21, 0x25,
    0x1D, 0x25, 0x25, 0x25,
    0x1D, 0x1D, 0x25, 0x25,
    0x1D, 0x1D, 0x1D, 0x25,
    0x1D, 0x21, 0x24, 0x28,
    0x1D, 0x22, 0x26, 0x28,
    0x1D, 0x1F, 0x26, 0x28,
    0x1D, 0x1F, 0x23, 0x28,
    0x1D, 0x28, 0x28, 0x28,
    0x1D, 0x1D, 0x28, 0x28,
    0x1D, 0x1D, 0x1D, 0x28,
    0x1D, 0x22, 0x26, 0x2B,
    0x1D, 0x24, 0x28, 0x2B,
    0x1D, 0x20, 0x28, 0x2B,
    0x1D, 0x20, 0x24, 0x2B,
    0x1D, 0x2B, 0x2B, 0x2B,
    0x1D, 0x1D, 0x2B, 0x2B,
    0x1D, 0x1D, 0x1D, 0x2B,
    0x1D, 0x23, 0x28, 0x2E,
    0x1D, 0x25, 0x2A, 0x2E,
    0x1D, 0x21, 0x2A, 0x2E,
    0x1D, 0x21, 0x26, 0x2E,
    0x1D, 0x2E, 0x2E, 0x2E,
    0x1D, 0x1D, 0x2E, 0x2E,
    0x1D, 0x1D, 0x1D, 0x2E,
    0x1D, 0x24, 0x2A, 0x31,
    0x1D, 0x27, 0x2C, 0x31,
    0x1D, 0x22, 0x2C, 0x31,
    0x1D, 0x22, 0x27, 0x31,
    0x1D, 0x31, 0x31, 0x31,
    0x1D, 0x1D, 0x31, 0x31,
    0x1D, 0x1D, 0x1D, 0x31,
    0x1D, 0x28, 0x2F, 0x34,
    0x1D, 0x22, 0x2F, 0x34,
    0x1D, 0x22, 0x29, 0x34,
    0x1D, 0x34, 0x34, 0x34,
    0x1D, 0x1D, 0x34, 0x34,
    0x1D, 0x1D, 0x1D, 0x34,
    0x1D, 0x2A, 0x31, 0x37,
    0x1D, 0x23, 0x31, 0x37,
    0x1D, 0x23, 0x2A, 0x37,
    0x1D, 0x37, 0x37, 0x37,
    0x1D, 0x1D, 0x37, 0x37,
    0x1D, 0x1D, 0x1D, 0x37,
    0x1D, 0x2B, 0x33, 0x3A,
    0x1D, 0x24, 0x33, 0x3A,
    0x1D, 0x24, 0x2C, 0x3A,
    0x1D, 0x3A, 0x3A, 0x3A,
    0x1D, 0x1D, 0x3A, 0x3A,
    0x1D, 0x1D, 0x1D, 0x3A,
    0x1D, 0x2D, 0x35, 0x3D,
    0x1D, 0x25, 0x35, 0x3D,
    0x1D, 0x25, 0x2D, 0x3D,
    0x1D, 0x3D, 0x3D, 0x3D,
    0x1D, 0x1D, 0x3D, 0x3D,
    0x1D, 0x1D, 0x1D, 0x3D,
    0x1E, 0x1F, 0x1F, 0x20,
    0x1E, 0x1F, 0x20, 0x21,
    0x1E, 0x20, 0x21, 0x22,
    0x1E, 0x1F, 0x21, 0x22,
    0x1E, 0x1F, 0x20, 0x22,
    0x1E, 0x20, 0x21, 0x23,
    0x1E, 0x20, 0x22, 0x23,
    0x1E, 0x1F, 0x22, 0x23,
    0x1E, 0x1F, 0x21, 0x23,
    0x1E, 0x20, 0x22, 0x24,
    0x1E, 0x21, 0x23, 0x24,
    0x1E, 0x1F, 0x23, 0x24,
    0x1E, 0x1F, 0x21, 0x24,
    0x1E, 0x24, 0x24, 0x24,
    0x1E, 0x1E, 0x24, 0x24,
    0x1E, 0x1E, 0x1E, 0x24,
    0x1E, 0x21, 0x22, 0x25,
    0x1E, 0x21, 0x24, 0x25,
    0x1E, 0x1F, 0x24, 0x25,
    0x1E, 0x1F, 0x22, 0x25,
    0x1E, 0x21, 0x23, 0x26,
    0x1E, 0x22, 0x24, 0x26,
    0x1E, 0x20, 0x24, 0x26,
    0x1E, 0x20, 0x22, 0x26,
    0x1E, 0x26, 0x26, 0x26,
    0x1E, 0x1E, 0x26, 0x26,
    0x1E, 0x1E, 0x1E, 0x26,
    0x1E, 0x22, 0x25, 0x29,
    0x1E, 0x23, 0x27, 0x29,
    0x1E, 0x20, 0x27, 0x29,
    0x1E, 0x20, 0x24, 0x29,
    0x1E, 0x29, 0x29, 0x29,
    0x1E, 0x1E, 0x29, 0x29,
    0x1E, 0x1E, 0x1E, 0x29,
    0x1E, 0x23, 0x27, 0x2C,
    0x1E, 0x25, 0x29, 0x2C,
    0x1E, 0x21, 0x29, 0x2C,
    0x1E, 0x21, 0x25, 0x2C,
    0x1E, 0x2C, 0x2C, 0x2C,
    0x1E, 0x1E, 0x2C, 0x2C,
    0x1E, 0x1E, 0x1E, 0x2C,
    0x1E, 0x24, 0x29, 0x2F,
    0x1E, 0x26, 0x2B, 0x2F,
    0x1E, 0x22, 0x2B, 0x2F,
    0x1E, 0x22, 0x27, 0x2F,
    0x1E, 0x2F, 0x2F, 0x2F,
    0x1E, 0x1E, 0x2F, 0x2F,
    0x1E, 0x1E, 0x1E, 0x2F,
    0x1E, 0x25, 0x2B, 0x32,
    0x1E, 0x28, 0x2D, 0x32,
    0x1E, 0x23, 0x2D, 0x32,
    0x1E, 0x23, 0x28, 0x32,
    0x1E, 0x32, 0x32, 0x32,
    0x1E, 0x1E, 0x32, 0x32,
    0x1E, 0x1E, 0x1E, 0x32,
    0x1E, 0x29, 0x30, 0x35,
    0x1E, 0x23, 0x30, 0x35,
    0x1E, 0x23, 0x2A, 0x35,
    0x1E, 0x35, 0x35, 0x35,
    0x1E, 0x1E, 0x35, 0x35,
    0x1E, 0x1E, 0x1E, 0x35,
    0x1E, 0x2B, 0x32, 0x38,
    0x1E, 0x24, 0x32, 0x38,
    0x1E, 0x24, 0x2B, 0x38,
    0x1E, 0x38, 0x38, 0x38,
    0x1E, 0x1E, 0x38, 0x38,
    0x1E, 0x1E, 0x1E, 0x38,
    0x1E, 0x2C, 0x34, 0x3B,
    0x1E, 0x25, 0x34, 0x3B,
    0x1E, 0x25, 0x2D, 0x3B,
    0x1E, 0x3B, 0x3B, 0x3B,
    0x1E, 0x1E, 0x3B, 0x3B,
    0x1E, 0x1E, 0x1E, 0x3B,
    0x1E, 0x2E, 0x36, 0x3E,
    0x1E, 0x26, 0x36, 0x3E,
    0x1E, 0x26, 0x2E, 0x3E,
    0x1E, 0x3E, 0x3E, 0x3E,
    0x1E, 0x1E, 0x3E, 0x3E,
    0x1E, 0x1E, 0x1E, 0x3E,
    0x1F, 0x20, 0x20, 0x21,
    0x1F, 0x20, 0x21, 0x22,
    0x1F, 0x21, 0x22, 0x23,
    0x1F, 0x20, 0x22, 0x23,
    0x1F, 0x20, 0x21, 0x23,
    0x1F, 0x21, 0x22, 0x24,
    0x1F, 0x21, 0x23, 0x24,
    0x1F, 0x20, 0x23, 0x24,
    0x1F, 0x20, 0x22, 0x24,
    0x1F, 0x21, 0x23, 0x25,
    0x1F, 0x22, 0x24, 0x25,
    0x1F, 0x20, 0x24, 0x25,
    0x1F, 0x20, 0x22, 0x25,
    0x1F, 0x25, 0x25, 0x25,
    0x1F, 0x1F, 0x25, 0x25,
    0x1F, 0x1F, 0x1F, 0x25,
    0x1F, 0x22, 0x23, 0x26,
    0x1F, 0x22, 0x25, 0x26,
    0x1F, 0x20, 0x25, 0x26,
    0x1F, 0x20, 0x23, 0x26,
    0x1F, 0x22, 0x24, 0x27,
    0x1F, 0x23, 0x25, 0x27,
    0x1F, 0x21, 0x25, 0x27,
    0x1F, 0x21, 0x23, 0x27,
    0x1F, 0x27, 0x27, 0x27,
    0x1F, 0x1F, 0x27, 0x27,
    0x1F, 0x1F, 0x1F, 0x27,
    0x1F, 0x23, 0x26, 0x2A,
    0x1F, 0x24, 0x28, 0x2A,
    0x1F, 0x21, 0x28, 0x2A,
    0x1F, 0x21, 0x25, 0x2A,
    0x1F, 0x2A, 0x2A, 0x2A,
    0x1F, 0x1F, 0x2A, 0x2A,
    0x1F, 0x1F, 0x1F, 0x2A,
    0x1F, 0x24, 0x28, 0x2D,
    0x1F, 0x26, 0x2A, 0x2D,
    0x1F, 0x22, 0x2A, 0x2D,
    0x1F, 0x22, 0x26, 0x2D,
    0x1F, 0x2D, 0x2D, 0x2D,
    0x1F, 0x1F, 0x2D, 0x2D,
    0x1F, 0x1F, 0x1F, 0x2D,
    0x1F, 0x25, 0x2A, 0x30,
    0x1F, 0x27, 0x2C, 0x30,
    0x1F, 0x23, 0x2C, 0x30,
    0x1F, 0x23, 0x28, 0x30,
    0x1F, 0x30, 0x30, 0x30,
    0x1F, 0x1F, 0x30, 0x30,
    0x1F, 0x1F, 0x1F, 0x30,
    0x1F, 0x26, 0x2C, 0x33,
    0x1F, 0x29, 0x2E, 0x33,
    0x1F, 0x24, 0x2E, 0x33,
    0x1F, 0x24, 0x29, 0x33,
    0x1F, 0x33, 0x33, 0x33,
    0x1F, 0x1F, 0x33, 0x33,
    0x1F, 0x1F, 0x1F, 0x33,
    0x1F, 0x2A, 0x31, 0x36,
    0x1F, 0x24, 0x31, 0x36,
    0x1F, 0x24, 0x2B, 0x36,
    0x1F, 0x36, 0x36, 0x36,
    0x1F, 0x1F, 0x36, 0x36,
    0x1F, 0x1F, 0x1F, 0x36,
    0x1F, 0x2C, 0x33, 0x39,
    0x1F, 0x25, 0x33, 0x39,
    0x1F, 0x25, 0x2C, 0x39,
    0x1F, 0x39, 0x39, 0x39,
    0x1F, 0x1F, 0x39, 0x39,
    0x1F, 0x1F, 0x1F, 0x39,
    0x1F, 0x2D, 0x35, 0x3C,
    0x1F, 0x26, 0x35, 0x3C,
    0x1F, 0x26, 0x2E, 0x3C,
    0x1F, 0x3C, 0x3C, 0x3C,
    0x1F, 0x1F, 0x3C, 0x3C,
    0x1F, 0x1F, 0x1F, 0x3C,
    0x1F, 0x2F, 0x37, 0x3F,
    0x1F, 0x27, 0x37, 0x3F,
    0x1F, 0x27, 0x2F, 0x3F,
    0x1F, 0x3F, 0x3F, 0x3F,
    0x1F, 0x1F, 0x3F, 0x3F,
    0x1F, 0x1F, 0x1F, 0x3F,
    0x20, 0x21, 0x21, 0x22,
    0x20, 0x21, 0x22, 0x23,
    0x20, 0x22, 0x23, 0x24,
    0x20, 0x21, 0x23, 0x24,
    0x20, 0x21, 0x22, 0x24,
    0x20, 0x22, 0x23, 0x25,
    0x20, 0x22, 0x24, 0x25,
    0x20, 0x21, 0x24, 0x25,
    0x20, 0x21, 0x23, 0x25,
    0x20, 0x22, 0x24, 0x26,
    0x20, 0x23, 0x25, 0x26,
    0x20, 0x21, 0x25, 0x26,
    0x20, 0x21, 0x23, 0x26,
    0x20, 0x26, 0x26, 0x26,
    0x20, 0x20, 0x26, 0x26,
    0x20, 0x20, 0x20, 0x26,
    0x20, 0x23, 0x24, 0x27,
    0x20, 0x23, 0x26, 0x27,
    0x20, 0x21, 0x26, 0x27,
    0x20, 0x21, 0x24, 0x27,
    0x20, 0x23, 0x25, 0x28,
    0x20, 0x24, 0x26, 0x28,
    0x20, 0x22, 0x26, 0x28,
    0x20, 0x22, 0x24, 0x28,
    0x20, 0x28, 0x28, 0x28,
    0x20, 0x20, 0x28, 0x28,
    0x20, 0x20, 0x20, 0x28,
    0x20, 0x24, 0x27, 0x2B,
    0x20, 0x25, 0x29, 0x2B,
    0x20, 0x22, 0x29, 0x2B,
    0x20, 0x22, 0x26, 0x2B,
    0x20, 0x2B, 0x2B, 0x2B,
    0x20, 0x20, 0x2B, 0x2B,
    0x20, 0x20, 0x20, 0x2B,
    0x20, 0x25, 0x29, 0x2E,
    0x20, 0x27, 0x2B, 0x2E,
    0x20, 0x23, 0x2B, 0x2E,
    0x20, 0x23, 0x27, 0x2E,
    0x20, 0x2E, 0x2E, 0x2E,
    0x20, 0x20, 0x2E, 0x2E,
    0x20, 0x20, 0x20, 0x2E,
    0x20, 0x26, 0x2B, 0x31,
    0x20, 0x28, 0x2D, 0x31,
    0x20, 0x24, 0x2D, 0x31,
    0x20, 0x24, 0x29, 0x31,
    0x20, 0x31, 0x31, 0x31,
    0x20, 0x20, 0x31, 0x31,
    0x20, 0x20, 0x20, 0x31,
    0x20, 0x27, 0x2D, 0x34,
    0x20, 0x2A, 0x2F, 0x34,
    0x20, 0x25, 0x2F, 0x34,
    0x20, 0x25, 0x2A, 0x34,
    0x20, 0x34, 0x34, 0x34,
    0x20, 0x20, 0x34, 0x34,
    0x20, 0x20, 0x20, 0x34,
    0x20, 0x2B, 0x32, 0x37,
    0x20, 0x25, 0x32, 0x37,
    0x20, 0x25, 0x2C, 0x37,
    0x20, 0x37, 0x37, 0x37,
    0x20, 0x20, 0x37, 0x37,
    0x20, 0x20, 0x20, 0x37,
    0x20, 0x2D, 0x34, 0x3A,
    0x20, 0x26, 0x34, 0x3A,
    0x20, 0x26, 0x2D, 0x3A,
    0x20, 0x3A, 0x3A, 0x3A,
    0x20, 0x20, 0x3A, 0x3A,
    0x20, 0x20, 0x20, 0x3A,
    0x20, 0x2E, 0x36, 0x3D,
    0x20, 0x27, 0x36, 0x3D,
    0x20, 0x27, 0x2F, 0x3D,
    0x20, 0x3D, 0x3D, 0x3D,
    0x20, 0x20, 0x3D, 0x3D,
    0x20, 0x20, 0x20, 0x3D,
    0x21, 0x22, 0x22, 0x23,
    0x21, 0x22, 0x23, 0x24,
    0x21, 0x23, 0x24, 0x25,
    0x21, 0x22, 0x24, 0x25,
    0x21, 0x22, 0x23, 0x25,
    0x21, 0x23, 0x24, 0x26,
    0x21, 0x23, 0x25, 0x26,
    0x21, 0x22, 0x25, 0x26,
    0x21, 0x22, 0x24, 0x26,
    0x21, 0x23, 0x25, 0x27,
    0x21, 0x24, 0x26, 0x27,
    0x21, 0x22, 0x26, 0x27,
    0x21, 0x22, 0x24, 0x27,
    0x21, 0x27, 0x27, 0x27,
    0x21, 0x21, 0x27, 0x27,
    0x21, 0x21, 0x21, 0x27,
    0x21, 0x24, 0x25, 0x28,
    0x21, 0x24, 0x27, 0x28,
    0x21, 0x22, 0x27, 0x28,
    0x21, 0x22, 0x25, 0x28,
    0x21, 0x24, 0x26, 0x29,
    0x21, 0x25, 0x27, 0x29,
    0x21, 0x23, 0x27, 0x29,
    0x21, 0x23, 0x25, 0x29,
    0x21, 0x29, 0x29, 0x29,
    0x21, 0x21, 0x29, 0x29,
    0x21, 0x21, 0x21, 0x29,
    0x21, 0x25, 0x28, 0x2C,
    0x21, 0x26, 0x2A, 0x2C,
    0x21, 0x23, 0x2A, 0x2C,
    0x21, 0x23, 0x27, 0x2C,
    0x21, 0x2C, 0x2C, 0x2C,
    0x21, 0x21, 0x2C, 0x2C,
    0x21, 0x21, 0x21, 0x2C,
    0x21, 0x26, 0x2A, 0x2F,
    0x21, 0x28, 0x2C, 0x2F,
    0x21, 0x24, 0x2C, 0x2F,
    0x21, 0x24, 0x28, 0x2F,
    0x21, 0x2F, 0x2F, 0x2F,
    0x21, 0x21, 0x2F, 0x2F,
    0x21, 0x21, 0x21, 0x2F,
    0x21, 0x27, 0x2C, 0x32,
    0x21, 0x29, 0x2E, 0x32,
    0x21, 0x25, 0x2E, 0x32,
    0x21, 0x25, 0x2A, 0x32,
    0x21, 0x32, 0x32, 0x32,
    0x21, 0x21, 0x32, 0x32,
    0x21, 0x21, 0x21, 0x32,
    0x21, 0x28, 0x2E, 0x35,
    0x21, 0x2B, 0x30, 0x35,
    0x21, 0x26, 0x30, 0x35,
    0x21, 0x26, 0x2B, 0x35,
    0x21, 0x35, 0x35, 0x35,
    0x21, 0x21, 0x35, 0x35,
    0x21, 0x21, 0x21, 0x35,
    0x21, 0x2C, 0x33, 0x38,
    0x21, 0x26, 0x33, 0x38,
    0x21, 0x26, 0x2D, 0x38,
    0x21, 0x38, 0x38, 0x38,
    0x21, 0x21, 0x38, 0x38,
    0x21, 0x21, 0x21, 0x38,
    0x21, 0x2E, 0x35, 0x3B,
    0x21, 0x27, 0x35, 0x3B,
    0x21, 0x27, 0x2E, 0x3B,
    0x21, 0x3B, 0x3B, 0x3B,
    0x21, 0x21, 0x3B, 0x3B,
    0x21, 0x21, 0x21, 0x3B,
    0x21, 0x2F, 0x37, 0x3E,
    0x21, 0x28, 0x37, 0x3E,
    0x21, 0x28, 0x30, 0x3E,
    0x21, 0x3E, 0x3E, 0x3E,
    0x21, 0x21, 0x3E, 0x3E,
    0x21, 0x21, 0x21, 0x3E,
    0x22, 0x23, 0x23, 0x24,
    0x22, 0x23, 0x24, 0x25,
    0x22, 0x24, 0x25, 0x26,
    0x22, 0x23, 0x25, 0x26,
    0x22, 0x23, 0x24, 0x26,
    0x22, 0x24, 0x25, 0x27,
    0x22, 0x24, 0x26, 0x27,
    0x22, 0x23, 0x26, 0x27,
    0x22, 0x23, 0x25, 0x27,
    0x22, 0x24, 0x26, 0x28,
    0x22, 0x25, 0x27, 0x28,
    0x22, 0x23, 0x27, 0x28,
    0x22, 0x23, 0x25, 0x28,
    0x22, 0x28, 0x28, 0x28,
    0x22, 0x22, 0x28, 0x28,
    0x22, 0x22, 0x22, 0x28,
    0x22, 0x25, 0x26, 0x29,
    0x22, 0x25, 0x28, 0x29,
    0x22, 0x23, 0x28, 0x29,
    0x22, 0x23, 0x26, 0x29,
    0x22, 0x25, 0x27, 0x2A,
    0x22, 0x26, 0x28, 0x2A,
    0x22, 0x24, 0x28, 0x2A,
    0x22, 0x24, 0x26, 0x2A,
    0x22, 0x2A, 0x2A, 0x2A,
    0x22, 0x22, 0x2A, 0x2A,
    0x22, 0x22, 0x22, 0x2A,
    0x22, 0x26, 0x29, 0x2D,
    0x22, 0x27, 0x2B, 0x2D,
    0x22, 0x24, 0x2B, 0x2D,
    0x22, 0x24, 0x28, 0x2D,
    0x22, 0x2D, 0x2D, 0x2D,
    0x22, 0x22, 0x2D, 0x2D,
    0x22, 0x22, 0x22, 0x2D,
    0x22, 0x27, 0x2B, 0x30,
    0x22, 0x29, 0x2D, 0x30,
    0x22, 0x25, 0x2D, 0x30,
    0x22, 0x25, 0x29, 0x30,
    0x22, 0x30, 0x30, 0x30,
    0x22, 0x22, 0x30, 0x30,
    0x22, 0x22, 0x22, 0x30,
    0x22, 0x28, 0x2D, 0x33,
    0x22, 0x2A, 0x2F, 0x33,
    0x22, 0x26, 0x2F, 0x33,
    0x22, 0x26, 0x2B, 0x33,
    0x22, 0x33, 0x33, 0x33,
    0x22, 0x22, 0x33, 0x33,
    0x22, 0x22, 0x22, 0x33,
    0x22, 0x29, 0x2F, 0x36,
    0x22, 0x2C, 0x31, 0x36,
    0x22, 0x27, 0x31, 0x36,
    0x22, 0x27, 0x2C, 0x36,
    0x22, 0x36, 0x36, 0x36,
    0x22, 0x22, 0x36, 0x36,
    0x22, 0x22, 0x22, 0x36,
    0x22, 0x2D, 0x34, 0x39,
    0x22, 0x27, 0x34, 0x39,
    0x22, 0x27, 0x2E, 0x39,
    0x22, 0x39, 0x39, 0x39,
    0x22, 0x22, 0x39, 0x39,
    0x22, 0x22, 0x22, 0x39,
    0x22, 0x2F, 0x36, 0x3C,
    0x22, 0x28, 0x36, 0x3C,
    0x22, 0x28, 0x2F, 0x3C,
    0x22, 0x3C, 0x3C, 0x3C,
    0x22, 0x22, 0x3C, 0x3C,
    0x22, 0x22, 0x22, 0x3C,
    0x22, 0x30, 0x38, 0x3F,
    0x22, 0x29, 0x38, 0x3F,
    0x22, 0x29, 0x31, 0x3F,
    0x22, 0x3F, 0x3F, 0x3F,
    0x22, 0x22, 0x3F, 0x3F,
    0x22, 0x22, 0x22, 0x3F,
    0x23, 0x24, 0x24, 0x25,
    0x23, 0x24, 0x25, 0x26,
    0x23, 0x25, 0x26, 0x27,
    0x23, 0x24, 0x26, 0x27,
    0x23, 0x24, 0x25, 0x27,
    0x23, 0x25, 0x26, 0x28,
    0x23, 0x25, 0x27, 0x28,
    0x23, 0x24, 0x27, 0x28,
    0x23, 0x24, 0x26, 0x28,
    0x23, 0x25, 0x27, 0x29,
    0x23, 0x26, 0x28, 0x29,
    0x23, 0x24, 0x28, 0x29,
    0x23, 0x24, 0x26, 0x29,
    0x23, 0x29, 0x29, 0x29,
    0x23, 0x23, 0x29, 0x29,
    0x23, 0x23, 0x23, 0x29,
    0x23, 0x26, 0x27, 0x2A,
    0x23, 0x26, 0x29, 0x2A,
    0x23, 0x24, 0x29, 0x2A,
    0x23, 0x24, 0x27, 0x2A,
    0x23, 0x26, 0x28, 0x2B,
    0x23, 0x27, 0x29, 0x2B,
    0x23, 0x25, 0x29, 0x2B,
    0x23, 0x25, 0x27, 0x2B,
    0x23, 0x2B, 0x2B, 0x2B,
    0x23, 0x23, 0x2B, 0x2B,
    0x23, 0x23, 0x23, 0x2B,
    0x23, 0x27, 0x2A, 0x2E,
    0x23, 0x28, 0x2C, 0x2E,
    0x23, 0x25, 0x2C, 0x2E,
    0x23, 0x25, 0x29, 0x2E,
    0x23, 0x2E, 0x2E, 0x2E,
    0x23, 0x23, 0x2E, 0x2E,
    0x23, 0x23, 0x23, 0x2E,
    0x23, 0x28, 0x2C, 0x31,
    0x23, 0x2A, 0x2E, 0x31,
    0x23, 0x26, 0x2E, 0x31,
    0x23, 0x26, 0x2A, 0x31,
    0x23, 0x31, 0x31, 0x31,
    0x23, 0x23, 0x31, 0x31,
    0x23, 0x23, 0x23, 0x31,
    0x23, 0x29, 0x2E, 0x34,
    0x23, 0x2B, 0x30, 0x34,
    0x23, 0x27, 0x30, 0x34,
    0x23, 0x27, 0x2C, 0x34,
    0x23, 0x34, 0x34, 0x34,
    0x23, 0x23, 0x34, 0x34,
    0x23, 0x23, 0x23, 0x34,
    0x23, 0x2A, 0x30, 0x37,
    0x23, 0x2D, 0x32, 0x37,
    0x23, 0x28, 0x32, 0x37,
    0x23, 0x28, 0x2D, 0x37,
    0x23, 0x37, 0x37, 0x37,
    0x23, 0x23, 0x37, 0x37,
    0x23, 0x23, 0x23, 0x37,
    0x23, 0x2E, 0x35, 0x3A,
    0x23, 0x28, 0x35, 0x3A,
    0x23, 0x28, 0x2F, 0x3A,
    0x23, 0x3A, 0x3A, 0x3A,
    0x23, 0x23, 0x3A, 0x3A,
    0x23, 0x23, 0x23, 0x3A,
    0x23, 0x30, 0x37, 0x3D,
    0x23, 0x29, 0x37, 0x3D,
    0x23, 0x29, 0x30, 0x3D,
    0x23, 0x3D, 0x3D, 0x3D,
    0x23, 0x23, 0x3D, 0x3D,
    0x23, 0x23, 0x23, 0x3D,
    0x24, 0x25, 0x25, 0x26,
    0x24, 0x25, 0x26, 0x27,
    0x24, 0x26, 0x27, 0x28,
    0x24, 0x25, 0x27, 0x28,
    0x24, 0x25, 0x26, 0x28,
    0x24, 0x26, 0x27, 0x29,
    0x24, 0x26, 0x28, 0x29,
    0x24, 0x25, 0x28, 0x29,
    0x24, 0x25, 0x27, 0x29,
    0x24, 0x26, 0x28, 0x2A,
    0x24, 0x27, 0x29, 0x2A,
    0x24, 0x25, 0x29, 0x2A,
    0x24, 0x25, 0x27, 0x2A,
    0x24, 0x2A, 0x2A, 0x2A,
    0x24, 0x24, 0x2A, 0x2A,
    0x24, 0x24, 0x24, 0x2A,
    0x24, 0x27, 0x28, 0x2B,
    0x24, 0x27, 0x2A, 0x2B,
    0x24, 0x25, 0x2A, 0x2B,
    0x24, 0x25, 0x28, 0x2B,
    0x24, 0x27, 0x29, 0x2C,
    0x24, 0x28, 0x2A, 0x2C,
    0x24, 0x26, 0x2A, 0x2C,
    0x24, 0x26, 0x28, 0x2C,
    0x24, 0x2C, 0x2C, 0x2C,
    0x24, 0x24, 0x2C, 0x2C,
    0x24, 0x24, 0x24, 0x2C,
    0x24, 0x28, 0x2B, 0x2F,
    0x24, 0x29, 0x2D, 0x2F,
    0x24, 0x26, 0x2D, 0x2F,
    0x24, 0x26, 0x2A, 0x2F,
    0x24, 0x2F, 0x2F, 0x2F,
    0x24, 0x24, 0x2F, 0x2F,
    0x24, 0x24, 0x24, 0x2F,
    0x24, 0x29, 0x2D, 0x32,
    0x24, 0x2B, 0x2F, 0x32,
    0x24, 0x27, 0x2F, 0x32,
    0x24, 0x27, 0x2B, 0x32,
    0x24, 0x32, 0x32, 0x32,
    0x24, 0x24, 0x32, 0x32,
    0x24, 0x24, 0x24, 0x32,
    0x24, 0x2A, 0x2F, 0x35,
    0x24, 0x2C, 0x31, 0x35,
    0x24, 0x28, 0x31, 0x35,
    0x24, 0x28, 0x2D, 0x35,
    0x24, 0x35, 0x35, 0x35,
    0x24, 0x24, 0x35, 0x35,
    0x24, 0x24, 0x24, 0x35,
    0x24, 0x2B, 0x31, 0x38,
    0x24, 0x2E, 0x33, 0x38,
    0x24, 0x29, 0x33, 0x38,
    0x24, 0x29, 0x2E, 0x38,
    0x24, 0x38, 0x38, 0x38,
    0x24, 0x24, 0x38, 0x38,
    0x24, 0x24, 0x24, 0x38,
    0x24, 0x2F, 0x36, 0x3B,
    0x24, 0x29, 0x36, 0x3B,
    0x24, 0x29, 0x30, 0x3B,
    0x24, 0x3B, 0x3B, 0x3B,
    0x24, 0x24, 0x3B, 0x3B,
    0x24, 0x24, 0x24, 0x3B,
    0x24, 0x31, 0x38, 0x3E,
    0x24, 0x2A, 0x38, 0x3E,
    0x24, 0x2A, 0x31, 0x3E,
    0x24, 0x3E, 0x3E, 0x3E,
    0x24, 0x24, 0x3E, 0x3E,
    0x24, 0x24, 0x24, 0x3E,
    0x25, 0x26, 0x26, 0x27,
    0x25, 0x26, 0x27, 0x28,
    0x25, 0x27, 0x28, 0x29,
    0x25, 0x26, 0x28, 0x29,
    0x25, 0x26, 0x27, 0x29,
    0x25, 0x27, 0x28, 0x2A,
    0x25, 0x27, 0x29, 0x2A,
    0x25, 0x26, 0x29, 0x2A,
    0x25, 0x26, 0x28, 0x2A,
    0x25, 0x27, 0x29, 0x2B,
    0x25, 0x28, 0x2A, 0x2B,
    0x25, 0x26, 0x2A, 0x2B,
    0x25, 0x26, 0x28, 0x2B,
    0x25, 0x2B, 0x2B, 0x2B,
    0x25, 0x25, 0x2B, 0x2B,
    0x25, 0x25, 0x25, 0x2B,
    0x25, 0x28, 0x29, 0x2C,
    0x25, 0x28, 0x2B, 0x2C,
    0x25, 0x26, 0x2B, 0x2C,
    0x25, 0x26, 0x29, 0x2C,
    0x25, 0x28, 0x2A, 0x2D,
    0x25, 0x29, 0x2B, 0x2D,
    0x25, 0x27, 0x2B, 0x2D,
    0x25, 0x27, 0x29, 0x2D,
    0x25, 0x2D, 0x2D, 0x2D,
    0x25, 0x25, 0x2D, 0x2D,
    0x25, 0x25, 0x25, 0x2D,
    0x25, 0x29, 0x2C, 0x30,
    0x25, 0x2A, 0x2E, 0x30,
    0x25, 0x27, 0x2E, 0x30,
    0x25, 0x27, 0x2B, 0x30,
    0x25, 0x30, 0x30, 0x30,
    0x25, 0x25, 0x30, 0x30,
    0x25, 0x25, 0x25, 0x30,
    0x25, 0x2A, 0x2E, 0x33,
    0x25, 0x2C, 0x30, 0x33,
    0x25, 0x28, 0x30, 0x33,
    0x25, 0x28, 0x2C, 0x33,
    0x25, 0x33, 0x33, 0x33,
    0x25, 0x25, 0x33, 0x33,
    0x25, 0x25, 0x25, 0x33,
    0x25, 0x2B, 0x30, 0x36,
    0x25, 0x2D, 0x32, 0x36,
    0x25, 0x29, 0x32, 0x36,
    0x25, 0x29, 0x2E, 0x36,
    0x25, 0x36, 0x36, 0x36,
    0x25, 0x25, 0x36, 0x36,
    0x25, 0x25, 0x25, 0x36,
    0x25, 0x2C, 0x32, 0x39,
    0x25, 0x2F, 0x34, 0x39,
    0x25, 0x2A, 0x34, 0x39,
    0x25, 0x2A, 0x2F, 0x39,
    0x25, 0x39, 0x39, 0x39,
    0x25, 0x25, 0x39, 0x39,
    0x25, 0x25, 0x25, 0x39,
    0x25, 0x30, 0x37, 0x3C,
    0x25, 0x2A, 0x37, 0x3C,
    0x25, 0x2A, 0x31, 0x3C,
    0x25, 0x3C, 0x3C, 0x3C,
    0x25, 0x25, 0x3C, 0x3C,
    0x25, 0x25, 0x25, 0x3C,
    0x25, 0x32, 0x39, 0x3F,
    0x25, 0x2B, 0x39, 0x3F,
    0x25, 0x2B, 0x32, 0x3F,
    0x25, 0x3F, 0x3F, 0x3F,
    0x25, 0x25, 0x3F, 0x3F,
    0x25, 0x25, 0x25, 0x3F,
    0x26, 0x27, 0x27, 0x28,
    0x26, 0x27, 0x28, 0x29,
    0x26, 0x28, 0x29, 0x2A,
    0x26, 0x27, 0x29, 0x2A,
    0x26, 0x27, 0x28, 0x2A,
    0x26, 0x28, 0x29, 0x2B,
    0x26, 0x28, 0x2A, 0x2B,
    0x26, 0x27, 0x2A, 0x2B,
    0x26, 0x27, 0x29, 0x2B,
    0x26, 0x28, 0x2A, 0x2C,
    0x26, 0x29, 0x2B, 0x2C,
    0x26, 0x27, 0x2B, 0x2C,
    0x26, 0x27, 0x29, 0x2C,
    0x26, 0x2C, 0x2C, 0x2C,
    0x26, 0x26, 0x2C, 0x2C,
    0x26, 0x26, 0x26, 0x2C,
    0x26, 0x29, 0x2A, 0x2D,
    0x26, 0x29, 0x2C, 0x2D,
    0x26, 0x27, 0x2C, 0x2D,
    0x26, 0x27, 0x2A, 0x2D,
    0x26, 0x29, 0x2B, 0x2E,
    0x26, 0x2A, 0x2C, 0x2E,
    0x26, 0x28, 0x2C, 0x2E,
    0x26, 0x28, 0x2A, 0x2E,
    0x26, 0x2E, 0x2E, 0x2E,
    0x26, 0x26, 0x2E, 0x2E,
    0x26, 0x26, 0x26, 0x2E,
    0x26, 0x2A, 0x2D, 0x31,
    0x26, 0x2B, 0x2F, 0x31,
    0x26, 0x28, 0x2F, 0x31,
    0x26, 0x28, 0x2C, 0x31,
    0x26, 0x31, 0x31, 0x31,
    0x26, 0x26, 0x31, 0x31,
    0x26, 0x26, 0x26, 0x31,
    0x26, 0x2B, 0x2F, 0x34,
    0x26, 0x2D, 0x31, 0x34,
    0x26, 0x29, 0x31, 0x34,
    0x26, 0x29, 0x2D, 0x34,
    0x26, 0x34, 0x34, 0x34,
    0x26, 0x26, 0x34, 0x34,
    0x26, 0x26, 0x26, 0x34,
    0x26, 0x2C, 0x31, 0x37,
    0x26, 0x2E, 0x33, 0x37,
    0x26, 0x2A, 0x33, 0x37,
    0x26, 0x2A, 0x2F, 0x37,
    0x26, 0x37, 0x37, 0x37,
    0x26, 0x26, 0x37, 0x37,
    0x26, 0x26, 0x26, 0x37,
    0x26, 0x2D, 0x33, 0x3A,
    0x26, 0x30, 0x35, 0x3A,
    0x26, 0x2B, 0x35, 0x3A,
    0x26, 0x2B, 0x30, 0x3A,
    0x26, 0x3A, 0x3A, 0x3A,
    0x26, 0x26, 0x3A, 0x3A,
    0x26, 0x26, 0x26, 0x3A,
    0x26, 0x31, 0x38, 0x3D,
    0x26, 0x2B, 0x38, 0x3D,
    0x26, 0x2B, 0x32, 0x3D,
    0x26, 0x3D, 0x3D, 0x3D,
    0x26, 0x26, 0x3D, 0x3D,
    0x26, 0x26, 0x26, 0x3D,
    0x27, 0x28, 0x28, 0x29,
    0x27, 0x28, 0x29, 0x2A,
    0x27, 0x29, 0x2A, 0x2B,
    0x27, 0x28, 0x2A, 0x2B,
    0x27, 0x28, 0x29, 0x2B,
    0x27, 0x29, 0x2A, 0x2C,
    0x27, 0x29, 0x2B, 0x2C,
    0x27, 0x28, 0x2B, 0x2C,
    0x27, 0x28, 0x2A, 0x2C,
    0x27, 0x29, 0x2B, 0x2D,
    0x27, 0x2A, 0x2C, 0x2D,
    0x27, 0x28, 0x2C, 0x2D,
    0x27, 0x28, 0x2A, 0x2D,
    0x27, 0x2D, 0x2D, 0x2D,
    0x27, 0x27, 0x2D, 0x2D,
    0x27, 0x27, 0x27, 0x2D,
    0x27, 0x2A, 0x2B, 0x2E,
    0x27, 0x2A, 0x2D, 0x2E,
    0x27, 0x28, 0x2D, 0x2E,
    0x27, 0x28, 0x2B, 0x2E,
    0x27, 0x2A, 0x2C, 0x2F,
    0x27, 0x2B, 0x2D, 0x2F,
    0x27, 0x29, 0x2D, 0x2F,
    0x27, 0x29, 0x2B, 0x2F,
    0x27, 0x2F, 0x2F, 0x2F,
    0x27, 0x27, 0x2F, 0x2F,
    0x27, 0x27, 0x27, 0x2F,
    0x27, 0x2B, 0x2E, 0x32,
    0x27, 0x2C, 0x30, 0x32,
    0x27, 0x29, 0x30, 0x32,
    0x27, 0x29, 0x2D, 0x32,
    0x27, 0x32, 0x32, 0x32,
    0x27, 0x27, 0x32, 0x32,
    0x27, 0x27, 0x27, 0x32,
    0x27, 0x2C, 0x30, 0x35,
    0x27, 0x2E, 0x32, 0x35,
    0x27, 0x2A, 0x32, 0x35,
    0x27, 0x2A, 0x2E, 0x35,
    0x27, 0x35, 0x35, 0x35,
    0x27, 0x27, 0x35, 0x35,
    0x27, 0x27, 0x27, 0x35,
    0x27, 0x2D, 0x32, 0x38,
    0x27, 0x2F, 0x34, 0x38,
    0x27, 0x2B, 0x34, 0x38,
    0x27, 0x2B, 0x30, 0x38,
    0x27, 0x38, 0x38, 0x38,
    0x27, 0x27, 0x38, 0x38,
    0x27, 0x27, 0x27, 0x38,
    0x27, 0x2E, 0x34, 0x3B,
    0x27, 0x31, 0x36, 0x3B,
    0x27, 0x2C, 0x36, 0x3B,
    0x27, 0x2C, 0x31, 0x3B,
    0x27, 0x3B, 0x3B, 0x3B,
    0x27, 0x27, 0x3B, 0x3B,
    0x27, 0x27, 0x27, 0x3B,
    0x27, 0x32, 0x39, 0x3E,
    0x27, 0x2C, 0x39, 0x3E,
    0x27, 0x2C, 0x33, 0x3E,
    0x27, 0x3E, 0x3E, 0x3E,
    0x27, 0x27, 0x3E, 0x3E,
    0x27, 0x27, 0x27, 0x3E,
    0x28, 0x29, 0x29, 0x2A,
    0x28, 0x29, 0x2A, 0x2B,
    0x28, 0x2A, 0x2B, 0x2C,
    0x28, 0x29, 0x2B, 0x2C,
    0x28, 0x29, 0x2A, 0x2C,
    0x28, 0x2A, 0x2B, 0x2D,
    0x28, 0x2A, 0x2C, 0x2D,
    0x28, 0x29, 0x2C, 0x2D,
    0x28, 0x29, 0x2B, 0x2D,
    0x28, 0x2A, 0x2C, 0x2E,
    0x28, 0x2B, 0x2D, 0x2E,
    0x28, 0x29, 0x2D, 0x2E,
    0x28, 0x29, 0x2B, 0x2E,
    0x28, 0x2E, 0x2E, 0x2E,
    0x28, 0x28, 0x2E, 0x2E,
    0x28, 0x28, 0x28, 0x2E,
    0x28, 0x2B, 0x2C, 0x2F,
    0x28, 0x2B, 0x2E, 0x2F,
    0x28, 0x29, 0x2E, 0x2F,
    0x28, 0x29, 0x2C, 0x2F,
    0x28, 0x2B, 0x2D, 0x30,
    0x28, 0x2C, 0x2E, 0x30,
    0x28, 0x2A, 0x2E, 0x30,
    0x28, 0x2A, 0x2C, 0x30,
    0x28, 0x30, 0x30, 0x30,
    0x28, 0x28, 0x30, 0x30,
    0x28, 0x28, 0x28, 0x30,
    0x28, 0x2C, 0x2F, 0x33,
    0x28, 0x2D, 0x31, 0x33,
    0x28, 0x2A, 0x31, 0x33,
    0x28, 0x2A, 0x2E, 0x33,
    0x28, 0x33, 0x33, 0x33,
    0x28, 0x28, 0x33, 0x33,
    0x28, 0x28, 0x28, 0x33,
    0x28, 0x2D, 0x31, 0x36,
    0x28, 0x2F, 0x33, 0x36,
    0x28, 0x2B, 0x33, 0x36,
    0x28, 0x2B, 0x2F, 0x36,
    0x28, 0x36, 0x36, 0x36,
    0x28, 0x28, 0x36, 0x36,
    0x28, 0x28, 0x28, 0x36,
    0x28, 0x2E, 0x33, 0x39,
    0x28, 0x30, 0x35, 0x39,
    0x28, 0x2C, 0x35, 0x39,
    0x28, 0x2C, 0x31, 0x39,
    0x28, 0x39, 0x39, 0x39,
    0x28, 0x28, 0x39, 0x39,
    0x28, 0x28, 0x28, 0x39,
    0x28, 0x2F, 0x35, 0x3C,
    0x28, 0x32, 0x37, 0x3C,
    0x28, 0x2D, 0x37, 0x3C,
    0x28, 0x2D, 0x32, 0x3C,
    0x28, 0x3C, 0x3C, 0x3C,
    0x28, 0x28, 0x3C, 0x3C,
    0x28, 0x28, 0x28, 0x3C,
    0x28, 0x33, 0x3A, 0x3F,
    0x28, 0x2D, 0x3A, 0x3F,
    0x28, 0x2D, 0x34, 0x3F,
    0x28, 0x3F, 0x3F, 0x3F,
    0x28, 0x28, 0x3F, 0x3F,
    0x28, 0x28, 0x28, 0x3F,
    0x29, 0x2A, 0x2A, 0x2B,
    0x29, 0x2A, 0x2B, 0x2C,
    0x29, 0x2B, 0x2C, 0x2D,
    0x29, 0x2A, 0x2C, 0x2D,
    0x29, 0x2A, 0x2B, 0x2D,
    0x29, 0x2B, 0x2C, 0x2E,
    0x29, 0x2B, 0x2D, 0x2E,
    0x29, 0x2A, 0x2D, 0x2E,
    0x29, 0x2A, 0x2C, 0x2E,
    0x29, 0x2B, 0x2D, 0x2F,
    0x29, 0x2C, 0x2E, 0x2F,
    0x29, 0x2A, 0x2E, 0x2F,
    0x29, 0x2A, 0x2C, 0x2F,
    0x29, 0x2F, 0x2F, 0x2F,
    0x29, 0x29, 0x2F, 0x2F,
    0x29, 0x29, 0x29, 0x2F,
    0x29, 0x2C, 0x2D, 0x30,
    0x29, 0x2C, 0x2F, 0x30,
    0x29, 0x2A, 0x2F, 0x30,
    0x29, 0x2A, 0x2D, 0x30,
    0x29, 0x2C, 0x2E, 0x31,
    0x29, 0x2D, 0x2F, 0x31,
    0x29, 0x2B, 0x2F, 0x31,
    0x29, 0x2B, 0x2D, 0x31,
    0x29, 0x31, 0x31, 0x31,
    0x29, 0x29, 0x31, 0x31,
    0x29, 0x29, 0x29, 0x31,
    0x29, 0x2D, 0x30, 0x34,
    0x29, 0x2E, 0x32, 0x34,
    0x29, 0x2B, 0x32, 0x34,
    0x29, 0x2B, 0x2F, 0x34,
    0x29, 0x34, 0x34, 0x34,
    0x29, 0x29, 0x34, 0x34,
    0x29, 0x29, 0x29, 0x34,
    0x29, 0x2E, 0x32, 0x37,
    0x29, 0x30, 0x34, 0x37,
    0x29, 0x2C, 0x34, 0x37,
    0x29, 0x2C, 0x30, 0x37,
    0x29, 0x37, 0x37, 0x37,
    0x29, 0x29, 0x37, 0x37,
    0x29, 0x29, 0x29, 0x37,
    0x29, 0x2F, 0x34, 0x3A,
    0x29, 0x31, 0x36, 0x3A,
    0x29, 0x2D, 0x36, 0x3A,
    0x29, 0x2D, 0x32, 0x3A,
    0x29, 0x3A, 0x3A, 0x3A,
    0x29, 0x29, 0x3A, 0x3A,
    0x29, 0x29, 0x29, 0x3A,
    0x29, 0x30, 0x36, 0x3D,
    0x29, 0x33, 0x38, 0x3D,
    0x29, 0x2E, 0x38, 0x3D,
    0x29, 0x2E, 0x33, 0x3D,
    0x29, 0x3D, 0x3D, 0x3D,
    0x29, 0x29, 0x3D, 0x3D,
    0x29, 0x29, 0x29, 0x3D,
    0x2A, 0x2B, 0x2B, 0x2C,
    0x2A, 0x2B, 0x2C, 0x2D,
    0x2A, 0x2C, 0x2D, 0x2E,
    0x2A, 0x2B, 0x2D, 0x2E,
    0x2A, 0x2B, 0x2C, 0x2E,
    0x2A, 0x2C, 0x2D, 0x2F,
    0x2A, 0x2C, 0x2E, 0x2F,
    0x2A, 0x2B, 0x2E, 0x2F,
    0x2A, 0x2B, 0x2D, 0x2F,
    0x2A, 0x2C, 0x2E, 0x30,
    0x2A, 0x2D, 0x2F, 0x30,
    0x2A, 0x2B, 0x2F, 0x30,
    0x2A, 0x2B, 0x2D, 0x30,
    0x2A, 0x30, 0x30, 0x30,
    0x2A, 0x2A, 0x30, 0x30,
    0x2A, 0x2A, 0x2A, 0x30,
    0x2A, 0x2D, 0x2E, 0x31,
    0x2A, 0x2D, 0x30, 0x31,
    0x2A, 0x2B, 0x30, 0x31,
    0x2A, 0x2B, 0x2E, 0x31,
    0x2A, 0x2D, 0x2F, 0x32,
    0x2A, 0x2E, 0x30, 0x32,
    0x2A, 0x2C, 0x30, 0x32,
    0x2A, 0x2C, 0x2E, 0x32,
    0x2A, 0x32, 0x32, 0x32,
    0x2A, 0x2A, 0x32, 0x32,
    0x2A, 0x2A, 0x2A, 0x32,
    0x2A, 0x2E, 0x31, 0x35,
    0x2A, 0x2F, 0x33, 0x35,
    0x2A, 0x2C, 0x33, 0x35,
    0x2A, 0x2C, 0x30, 0x35,
    0x2A, 0x35, 0x35, 0x35,
    0x2A, 0x2A, 0x35, 0x35,
    0x2A, 0x2A, 0x2A, 0x35,
    0x2A, 0x2F, 0x33, 0x38,
    0x2A, 0x31, 0x35, 0x38,
    0x2A, 0x2D, 0x35, 0x38,
    0x2A, 0x2D, 0x31, 0x38,
    0x2A, 0x38, 0x38, 0x38,
    0x2A, 0x2A, 0x38, 0x38,
    0x2A, 0x2A, 0x2A, 0x38,
    0x2A, 0x30, 0x35, 0x3B,
    0x2A, 0x32, 0x37, 0x3B,
    0x2A, 0x2E, 0x37, 0x3B,
    0x2A, 0x2E, 0x33, 0x3B,
    0x2A, 0x3B, 0x3B, 0x3B,
    0x2A, 0x2A, 0x3B, 0x3B,
    0x2A, 0x2A, 0x2A, 0x3B,
    0x2A, 0x31, 0x37, 0x3E,
    0x2A, 0x34, 0x39, 0x3E,
    0x2A, 0x2F, 0x39, 0x3E,
    0x2A, 0x2F, 0x34, 0x3E,
    0x2A, 0x3E, 0x3E, 0x3E,
    0x2A, 0x2A, 0x3E, 0x3E,
    0x2A, 0x2A, 0x2A, 0x3E,
    0x2B, 0x2C, 0x2C, 0x2D,
    0x2B, 0x2C, 0x2D, 0x2E,
    0x2B, 0x2D, 0x2E, 0x2F,
    0x2B, 0x2C, 0x2E, 0x2F,
    0x2B, 0x2C, 0x2D, 0x2F,
    0x2B, 0x2D, 0x2E, 0x30,
    0x2B, 0x2D, 0x2F, 0x30,
    0x2B, 0x2C, 0x2F, 0x30,
    0x2B, 0x2C, 0x2E, 0x30,
    0x2B, 0x2D, 0x2F, 0x31,
    0x2B, 0x2E, 0x30, 0x31,
    0x2B, 0x2C, 0x30, 0x31,
    0x2B, 0x2C, 0x2E, 0x31,
    0x2B, 0x31, 0x31, 0x31,
    0x2B, 0x2B, 0x31, 0x31,
    0x2B, 0x2B, 0x2B, 0x31,
    0x2B, 0x2E, 0x2F, 0x32,
    0x2B, 0x2E, 0x31, 0x32,
    0x2B, 0x2C, 0x31, 0x32,
    0x2B, 0x2C, 0x2F, 0x32,
    0x2B, 0x2E, 0x30, 0x33,
    0x2B, 0x2F, 0x31, 0x33,
    0x2B, 0x2D, 0x31, 0x33,
    0x2B, 0x2D, 0x2F, 0x33,
    0x2B, 0x33, 0x33, 0x33,
    0x2B, 0x2B, 0x33, 0x33,
    0x2B, 0x2B, 0x2B, 0x33,
    0x2B, 0x2F, 0x32, 0x36,
    0x2B, 0x30, 0x34, 0x36,
    0x2B, 0x2D, 0x34, 0x36,
    0x2B, 0x2D, 0x31, 0x36,
    0x2B, 0x36, 0x36, 0x36,
    0x2B, 0x2B, 0x36, 0x36,
    0x2B, 0x2B, 0x2B, 0x36,
    0x2B, 0x30, 0x34, 0x39,
    0x2B, 0x32, 0x36, 0x39,
    0x2B, 0x2E, 0x36, 0x39,
    0x2B, 0x2E, 0x32, 0x39,
    0x2B, 0x39, 0x39, 0x39,
    0x2B, 0x2B, 0x39, 0x39,
    0x2B, 0x2B, 0x2B, 0x39,
    0x2B, 0x31, 0x36, 0x3C,
    0x2B, 0x33, 0x38, 0x3C,
    0x2B, 0x2F, 0x38, 0x3C,
    0x2B, 0x2F, 0x34, 0x3C,
    0x2B, 0x3C, 0x3C, 0x3C,
    0x2B, 0x2B, 0x3C, 0x3C,
    0x2B, 0x2B, 0x2B, 0x3C,
    0x2B, 0x32, 0x38, 0x3F,
    0x2B, 0x35, 0x3A, 0x3F,
    0x2B, 0x30, 0x3A, 0x3F,
    0x2B, 0x30, 0x35, 0x3F,
    0x2B, 0x3F, 0x3F, 0x3F,
    0x2B, 0x2B, 0x3F, 0x3F,
    0x2B, 0x2B, 0x2B, 0x3F,
    0x2C, 0x2D, 0x2D, 0x2E,
    0x2C, 0x2D, 0x2E, 0x2F,
    0x2C, 0x2E, 0x2F, 0x30,
    0x2C, 0x2D, 0x2F, 0x30,
    0x2C, 0x2D, 0x2E, 0x30,
    0x2C, 0x2E, 0x2F, 0x31,
    0x2C, 0x2E, 0x30, 0x31,
    0x2C, 0x2D, 0x30, 0x31,
    0x2C, 0x2D, 0x2F, 0x31,
    0x2C, 0x2E, 0x30, 0x32,
    0x2C, 0x2F, 0x31, 0x32,
    0x2C, 0x2D, 0x31, 0x32,
    0x2C, 0x2D, 0x2F, 0x32,
    0x2C, 0x32, 0x32, 0x32,
    0x2C, 0x2C, 0x32, 0x32,
    0x2C, 0x2C, 0x2C, 0x32,
    0x2C, 0x2F, 0x30, 0x33,
    0x2C, 0x2F, 0x32, 0x33,
    0x2C, 0x2D, 0x32, 0x33,
    0x2C, 0x2D, 0x30, 0x33,
    0x2C, 0x2F, 0x31, 0x34,
    0x2C, 0x30, 0x32, 0x34,
    0x2C, 0x2E, 0x32, 0x34,
    0x2C, 0x2E, 0x30, 0x34,
    0x2C, 0x34, 0x34, 0x34,
    0x2C, 0x2C, 0x34, 0x34,
    0x2C, 0x2C, 0x2C, 0x34,
    0x2C, 0x30, 0x33, 0x37,
    0x2C, 0x31, 0x35, 0x37,
    0x2C, 0x2E, 0x35, 0x37,
    0x2C, 0x2E, 0x32, 0x37,
    0x2C, 0x37, 0x37, 0x37,
    0x2C, 0x2C, 0x37, 0x37,
    0x2C, 0x2C, 0x2C, 0x37,
    0x2C, 0x31, 0x35, 0x3A,
    0x2C, 0x33, 0x37, 0x3A,
    0x2C, 0x2F, 0x37, 0x3A,
    0x2C, 0x2F, 0x33, 0x3A,
    0x2C, 0x3A, 0x3A, 0x3A,
    0x2C, 0x2C, 0x3A, 0x3A,
    0x2C, 0x2C, 0x2C, 0x3A,
    0x2C, 0x32, 0x37, 0x3D,
    0x2C, 0x34, 0x39, 0x3D,
    0x2C, 0x30, 0x39, 0x3D,
    0x2C, 0x30, 0x35, 0x3D,
    0x2C, 0x3D, 0x3D, 0x3D,
    0x2C, 0x2C, 0x3D, 0x3D,
    0x2C, 0x2C, 0x2C, 0x3D,
    0x2D, 0x2E, 0x2E, 0x2F,
    0x2D, 0x2E, 0x2F, 0x30,
    0x2D, 0x2F, 0x30, 0x31,
    0x2D, 0x2E, 0x30, 0x31,
    0x2D, 0x2E, 0x2F, 0x31,
    0x2D, 0x2F, 0x30, 0x32,
    0x2D, 0x2F, 0x31, 0x32,
    0x2D, 0x2E, 0x31, 0x32,
    0x2D, 0x2E, 0x30, 0x32,
    0x2D, 0x2F, 0x31, 0x33,
    0x2D, 0x30, 0x32, 0x33,
    0x2D, 0x2E, 0x32, 0x33,
    0x2D, 0x2E, 0x30, 0x33,
    0x2D, 0x33, 0x33, 0x33,
    0x2D, 0x2D, 0x33, 0x33,
    0x2D, 0x2D, 0x2D, 0x33,
    0x2D, 0x30, 0x31, 0x34,
    0x2D, 0x30, 0x33, 0x34,
    0x2D, 0x2E, 0x33, 0x34,
    0x2D, 0x2E, 0x31, 0x34,
    0x2D, 0x30, 0x32, 0x35,
    0x2D, 0x31, 0x33, 0x35,
    0x2D, 0x2F, 0x33, 0x35,
    0x2D, 0x2F, 0x31, 0x35,
    0x2D, 0x35, 0x35, 0x35,
    0x2D, 0x2D, 0x35, 0x35,
    0x2D, 0x2D, 0x2D, 0x35,
    0x2D, 0x31, 0x34, 0x38,
    0x2D, 0x32, 0x36, 0x38,
    0x2D, 0x2F, 0x36, 0x38,
    0x2D, 0x2F, 0x33, 0x38,
    0x2D, 0x38, 0x38, 0x38,
    0x2D, 0x2D, 0x38, 0x38,
    0x2D, 0x2D, 0x2D, 0x38,
    0x2D, 0x32, 0x36, 0x3B,
    0x2D, 0x34, 0x38, 0x3B,
    0x2D, 0x30, 0x38, 0x3B,
    0x2D, 0x30, 0x34, 0x3B,
    0x2D, 0x3B, 0x3B, 0x3B,
    0x2D, 0x2D, 0x3B, 0x3B,
    0x2D, 0x2D, 0x2D, 0x3B,
    0x2D, 0x33, 0x38, 0x3E,
    0x2D, 0x35, 0x3A, 0x3E,
    0x2D, 0x31, 0x3A, 0x3E,
    0x2D, 0x31, 0x36, 0x3E,
    0x2D, 0x3E, 0x3E, 0x3E,
    0x2D, 0x2D, 0x3E, 0x3E,
    0x2D, 0x2D, 0x2D, 0x3E,
    0x2E, 0x2F, 0x2F, 0x30,
    0x2E, 0x2F, 0x30, 0x31,
    0x2E, 0x30, 0x31, 0x32,
    0x2E, 0x2F, 0x31, 0x32,
    0x2E, 0x2F, 0x30, 0x32,
    0x2E, 0x30, 0x31, 0x33,
    0x2E, 0x30, 0x32, 0x33,
    0x2E, 0x2F, 0x32, 0x33,
    0x2E, 0x2F, 0x31, 0x33,
    0x2E, 0x30, 0x32, 0x34,
    0x2E, 0x31, 0x33, 0x34,
    0x2E, 0x2F, 0x33, 0x34,
    0x2E, 0x2F, 0x31, 0x34,
    0x2E, 0x34, 0x34, 0x34,
    0x2E, 0x2E, 0x34, 0x34,
    0x2E, 0x2E, 0x2E, 0x34,
    0x2E, 0x31, 0x32, 0x35,
    0x2E, 0x31, 0x34, 0x35,
    0x2E, 0x2F, 0x34, 0x35,
    0x2E, 0x2F, 0x32, 0x35,
    0x2E, 0x31, 0x33, 0x36,
    0x2E, 0x32, 0x34, 0x36,
    0x2E, 0x30, 0x34, 0x36,
    0x2E, 0x30, 0x32, 0x36,
    0x2E, 0x36, 0x36, 0x36,
    0x2E, 0x2E, 0x36, 0x36,
    0x2E, 0x2E, 0x2E, 0x36,
    0x2E, 0x32, 0x35, 0x39,
    0x2E, 0x33, 0x37, 0x39,
    0x2E, 0x30, 0x37, 0x39,
    0x2E, 0x30, 0x34, 0x39,
    0x2E, 0x39, 0x39, 0x39,
    0x2E, 0x2E, 0x39, 0x39,
    0x2E, 0x2E, 0x2E, 0x39,
    0x2E, 0x33, 0x37, 0x3C,
    0x2E, 0x35, 0x39, 0x3C,
    0x2E, 0x31, 0x39, 0x3C,
    0x2E, 0x31, 0x35, 0x3C,
    0x2E, 0x3C, 0x3C, 0x3C,
    0x2E, 0x2E, 0x3C, 0x3C,
    0x2E, 0x2E, 0x2E, 0x3C,
    0x2E, 0x34, 0x39, 0x3F,
    0x2E, 0x36, 0x3B, 0x3F,
    0x2E, 0x32, 0x3B, 0x3F,
    0x2E, 0x32, 0x37, 0x3F,
    0x2E, 0x3F, 0x3F, 0x3F,
    0x2E, 0x2E, 0x3F, 0x3F,
    0x2E, 0x2E, 0x2E, 0x3F,
    0x2F, 0x30, 0x30, 0x31,
    0x2F, 0x30, 0x31, 0x32,
    0x2F, 0x31, 0x32, 0x33,
    0x2F, 0x30, 0x32, 0x33,
    0x2F, 0x30, 0x31, 0x33,
    0x2F, 0x31, 0x32, 0x34,
    0x2F, 0x31, 0x33, 0x34,
    0x2F, 0x30, 0x33, 0x34,
    0x2F, 0x30, 0x32, 0x34,
    0x2F, 0x31, 0x33, 0x35,
    0x2F, 0x32, 0x34, 0x35,
    0x2F, 0x30, 0x34, 0x35,
    0x2F, 0x30, 0x32, 0x35,
    0x2F, 0x35, 0x35, 0x35,
    0x2F, 0x2F, 0x35, 0x35,
    0x2F, 0x2F, 0x2F, 0x35,
    0x2F, 0x32, 0x33, 0x36,
    0x2F, 0x32, 0x35, 0x36,
    0x2F, 0x30, 0x35, 0x36,
    0x2F, 0x30, 0x33, 0x36,
    0x2F, 0x32, 0x34, 0x37,
    0x2F, 0x33, 0x35, 0x37,
    0x2F, 0x31, 0x35, 0x37,
    0x2F, 0x31, 0x33, 0x37,
    0x2F, 0x37, 0x37, 0x37,
    0x2F, 0x2F, 0x37, 0x37,
    0x2F, 0x2F, 0x2F, 0x37,
    0x2F, 0x33, 0x36, 0x3A,
    0x2F, 0x34, 0x38, 0x3A,
    0x2F, 0x31, 0x38, 0x3A,
    0x2F, 0x31, 0x35, 0x3A,
    0x2F, 0x3A, 0x3A, 0x3A,
    0x2F, 0x2F, 0x3A, 0x3A,
    0x2F, 0x2F, 0x2F, 0x3A,
    0x2F, 0x34, 0x38, 0x3D,
    0x2F, 0x36, 0x3A, 0x3D,
    0x2F, 0x32, 0x3A, 0x3D,
    0x2F, 0x32, 0x36, 0x3D,
    0x2F, 0x3D, 0x3D, 0x3D,
    0x2F, 0x2F, 0x3D, 0x3D,
    0x2F, 0x2F, 0x2F, 0x3D,
    0x30, 0x31, 0x31, 0x32,
    0x30, 0x31, 0x32, 0x33,
    0x30, 0x32, 0x33, 0x34,
    0x30, 0x31, 0x33, 0x34,
    0x30, 0x31, 0x32, 0x34,
    0x30, 0x32, 0x33, 0x35,
    0x30, 0x32, 0x34, 0x35,
    0x30, 0x31, 0x34, 0x35,
    0x30, 0x31, 0x33, 0x35,
    0x30, 0x32, 0x34, 0x36,
    0x30, 0x33, 0x35, 0x36,
    0x30, 0x31, 0x35, 0x36,
    0x30, 0x31, 0x33, 0x36,
    0x30, 0x36, 0x36, 0x36,
    0x30, 0x30, 0x36, 0x36,
    0x30, 0x30, 0x30, 0x36,
    0x30, 0x33, 0x34, 0x37,
    0x30, 0x33, 0x36, 0x37,
    0x30, 0x31, 0x36, 0x37,
    0x30, 0x31, 0x34, 0x37,
    0x30, 0x33, 0x35, 0x38,
    0x30, 0x34, 0x36, 0x38,
    0x30, 0x32, 0x36, 0x38,
    0x30, 0x32, 0x34, 0x38,
    0x30, 0x38, 0x38, 0x38,
    0x30, 0x30, 0x38, 0x38,
    0x30, 0x30, 0x30, 0x38,
    0x30, 0x34, 0x37, 0x3B,
    0x30, 0x35, 0x39, 0x3B,
    0x30, 0x32, 0x39, 0x3B,
    0x30, 0x32, 0x36, 0x3B,
    0x30, 0x3B, 0x3B, 0x3B,
    0x30, 0x30, 0x3B, 0x3B,
    0x30, 0x30, 0x30, 0x3B,
    0x30, 0x35, 0x39, 0x3E,
    0x30, 0x37, 0x3B, 0x3E,
    0x30, 0x33, 0x3B, 0x3E,
    0x30, 0x33, 0x37, 0x3E,
    0x30, 0x3E, 0x3E, 0x3E,
    0x30, 0x30, 0x3E, 0x3E,
    0x30, 0x30, 0x30, 0x3E,
    0x31, 0x32, 0x32, 0x33,
    0x31, 0x32, 0x33, 0x34,
    0x31, 0x33, 0x34, 0x35,
    0x31, 0x32, 0x34, 0x35,
    0x31, 0x32, 0x33, 0x35,
    0x31, 0x33, 0x34, 0x36,
    0x31, 0x33, 0x35, 0x36,
    0x31, 0x32, 0x35, 0x36,
    0x31, 0x32, 0x34, 0x36,
    0x31, 0x33, 0x35, 0x37,
    0x31, 0x34, 0x36, 0x37,
    0x31, 0x32, 0x36, 0x37,
    0x31, 0x32, 0x34, 0x37,
    0x31, 0x37, 0x37, 0x37,
    0x31, 0x31, 0x37, 0x37,
    0x31, 0x31, 0x31, 0x37,
    0x31, 0x34, 0x35, 0x38,
    0x31, 0x34, 0x37, 0x38,
    0x31, 0x32, 0x37, 0x38,
    0x31, 0x32, 0x35, 0x38,
    0x31, 0x34, 0x36, 0x39,
    0x31, 0x35, 0x37, 0x39,
    0x31, 0x33, 0x37, 0x39,
    0x31, 0x33, 0x35, 0x39,
    0x31, 0x39, 0x39, 0x39,
    0x31, 0x31, 0x39, 0x39,
    0x31, 0x31, 0x31, 0x39,
    0x31, 0x35, 0x38, 0x3C,
    0x31, 0x36, 0x3A, 0x3C,
    0x31, 0x33, 0x3A, 0x3C,
    0x31, 0x33, 0x37, 0x3C,
    0x31, 0x3C, 0x3C, 0x3C,
    0x31, 0x31, 0x3C, 0x3C,
    0x31, 0x31, 0x31, 0x3C,
    0x31, 0x36, 0x3A, 0x3F,
    0x31, 0x38, 0x3C, 0x3F,
    0x31, 0x34, 0x3C, 0x3F,
    0x31, 0x34, 0x38, 0x3F,
    0x31, 0x3F, 0x3F, 0x3F,
    0x31, 0x31, 0x3F, 0x3F,
    0x31, 0x31, 0x31, 0x3F,
    0x32, 0x33, 0x33, 0x34,
    0x32, 0x33, 0x34, 0x35,
    0x32, 0x34, 0x35, 0x36,
    0x32, 0x33, 0x35, 0x36,
    0x32, 0x33, 0x34, 0x36,
    0x32, 0x34, 0x35, 0x37,
    0x32, 0x34, 0x36, 0x37,
    0x32, 0x33, 0x36, 0x37,
    0x32, 0x33, 0x35, 0x37,
    0x32, 0x34, 0x36, 0x38,
    0x32, 0x35, 0x37, 0x38,
    0x32, 0x33, 0x37, 0x38,
    0x32, 0x33, 0x35, 0x38,
    0x32, 0x38, 0x38, 0x38,
    0x32, 0x32, 0x38, 0x38,
    0x32, 0x32, 0x32, 0x38,
    0x32, 0x35, 0x36, 0x39,
    0x32, 0x35, 0x38, 0x39,
    0x32, 0x33, 0x38, 0x39,
    0x32, 0x33, 0x36, 0x39,
    0x32, 0x35, 0x37, 0x3A,
    0x32, 0x36, 0x38, 0x3A,
    0x32, 0x34, 0x38, 0x3A,
    0x32, 0x34, 0x36, 0x3A,
    0x32, 0x3A, 0x3A, 0x3A,
    0x32, 0x32, 0x3A, 0x3A,
    0x32, 0x32, 0x32, 0x3A,
    0x32, 0x36, 0x39, 0x3D,
    0x32, 0x37, 0x3B, 0x3D,
    0x32, 0x34, 0x3B, 0x3D,
    0x32, 0x34, 0x38, 0x3D,
    0x32, 0x3D, 0x3D, 0x3D,
    0x32, 0x32, 0x3D, 0x3D,
    0x32, 0x32, 0x32, 0x3D,
    0x33, 0x34, 0x34, 0x35,
    0x33, 0x34, 0x35, 0x36,
    0x33, 0x35, 0x36, 0x37,
    0x33, 0x34, 0x36, 0x37,
    0x33, 0x34, 0x35, 0x37,
    0x33, 0x35, 0x36, 0x38,
    0x33, 0x35, 0x37, 0x38,
    0x33, 0x34, 0x37, 0x38,
    0x33, 0x34, 0x36, 0x38,
    0x33, 0x35, 0x37, 0x39,
    0x33, 0x36, 0x38, 0x39,
    0x33, 0x34, 0x38, 0x39,
    0x33, 0x34, 0x36, 0x39,
    0x33, 0x39, 0x39, 0x39,
    0x33, 0x33, 0x39, 0x39,
    0x33, 0x33, 0x33, 0x39,
    0x33, 0x36, 0x37, 0x3A,
    0x33, 0x36, 0x39, 0x3A,
    0x33, 0x34, 0x39, 0x3A,
    0x33, 0x34, 0x37, 0x3A,
    0x33, 0x36, 0x38, 0x3B,
    0x33, 0x37, 0x39, 0x3B,
    0x33, 0x35, 0x39, 0x3B,
    0x33, 0x35, 0x37, 0x3B,
    0x33, 0x3B, 0x3B, 0x3B,
    0x33, 0x33, 0x3B, 0x3B,
    0x33, 0x33, 0x33, 0x3B,
    0x33, 0x37, 0x3A, 0x3E,
    0x33, 0x38, 0x3C, 0x3E,
    0x33, 0x35, 0x3C, 0x3E,
    0x33, 0x35, 0x39, 0x3E,
    0x33, 0x3E, 0x3E, 0x3E,
    0x33, 0x33, 0x3E, 0x3E,
    0x33, 0x33, 0x33, 0x3E,
    0x34, 0x35, 0x35, 0x36,
    0x34, 0x35, 0x36, 0x37,
    0x34, 0x36, 0x37, 0x38,
    0x34, 0x35, 0x37, 0x38,
    0x34, 0x35, 0x36, 0x38,
    0x34, 0x36, 0x37, 0x39,
    0x34, 0x36, 0x38, 0x39,
    0x34, 0x35, 0x38, 0x39,
    0x34, 0x35, 0x37, 0x39,
    0x34, 0x36, 0x38, 0x3A,
    0x34, 0x37, 0x39, 0x3A,
    0x34, 0x35, 0x39, 0x3A,
    0x34, 0x35, 0x37, 0x3A,
    0x34, 0x3A, 0x3A, 0x3A,
    0x34, 0x34, 0x3A, 0x3A,
    0x34, 0x34, 0x34, 0x3A,
    0x34, 0x37, 0x38, 0x3B,
    0x34, 0x37, 0x3A, 0x3B,
    0x34, 0x35, 0x3A, 0x3B,
    0x34, 0x35, 0x38, 0x3B,
    0x34, 0x37, 0x39, 0x3C,
    0x34, 0x38, 0x3A, 0x3C,
    0x34, 0x36, 0x3A, 0x3C,
    0x34, 0x36, 0x38, 0x3C,
    0x34, 0x3C, 0x3C, 0x3C,
    0x34, 0x34, 0x3C, 0x3C,
    0x34, 0x34, 0x34, 0x3C,
    0x34, 0x38, 0x3B, 0x3F,
    0x34, 0x39, 0x3D, 0x3F,
    0x34, 0x36, 0x3D, 0x3F,
    0x34, 0x36, 0x3A, 0x3F,
    0x34, 0x3F, 0x3F, 0x3F,
    0x34, 0x34, 0x3F, 0x3F,
    0x34, 0x34, 0x34, 0x3F,
    0x35, 0x36, 0x36, 0x37,
    0x35, 0x36, 0x37, 0x38,
    0x35, 0x37, 0x38, 0x39,
    0x35, 0x36, 0x38, 0x39,
    0x35, 0x36, 0x37, 0x39,
    0x35, 0x37, 0x38, 0x3A,
    0x35, 0x37, 0x39, 0x3A,
    0x35, 0x36, 0x39, 0x3A,
    0x35, 0x36, 0x38, 0x3A,
    0x35, 0x37, 0x39, 0x3B,
    0x35, 0x38, 0x3A, 0x3B,
    0x35, 0x36, 0x3A, 0x3B,
    0x35, 0x36, 0x38, 0x3B,
    0x35, 0x3B, 0x3B, 0x3B,
    0x35, 0x35, 0x3B, 0x3B,
    0x35, 0x35, 0x35, 0x3B,
    0x35, 0x38, 0x39, 0x3C,
    0x35, 0x38, 0x3B, 0x3C,
    0x35, 0x36, 0x3B, 0x3C,
    0x35, 0x36, 0x39, 0x3C,
    0x35, 0x38, 0x3A, 0x3D,
    0x35, 0x39, 0x3B, 0x3D,
    0x35, 0x37, 0x3B, 0x3D,
    0x35, 0x37, 0x39, 0x3D,
    0x35, 0x3D, 0x3D, 0x3D,
    0x35, 0x35, 0x3D, 0x3D,
    0x35, 0x35, 0x35, 0x3D,
    0x36, 0x37, 0x37, 0x38,
    0x36, 0x37, 0x38, 0x39,
    0x36, 0x38, 0x39, 0x3A,
    0x36, 0x37, 0x39, 0x3A,
    0x36, 0x37, 0x38, 0x3A,
    0x36, 0x38, 0x39, 0x3B,
    0x36, 0x38, 0x3A, 0x3B,
    0x36, 0x37, 0x3A, 0x3B,
    0x36, 0x37, 0x39, 0x3B,
    0x36, 0x38, 0x3A, 0x3C,
    0x36, 0x39, 0x3B, 0x3C,
    0x36, 0x37, 0x3B, 0x3C,
    0x36, 0x37, 0x39, 0x3C,
    0x36, 0x3C, 0x3C, 0x3C,
    0x36, 0x36, 0x3C, 0x3C,
    0x36, 0x36, 0x36, 0x3C,
    0x36, 0x39, 0x3A, 0x3D,
    0x36, 0x39, 0x3C, 0x3D,
    0x36, 0x37, 0x3C, 0x3D,
    0x36, 0x37, 0x3A, 0x3D,
    0x36, 0x39, 0x3B, 0x3E,
    0x36, 0x3A, 0x3C, 0x3E,
    0x36, 0x38, 0x3C, 0x3E,
    0x36, 0x38, 0x3A, 0x3E,
    0x36, 0x3E, 0x3E, 0x3E,
    0x36, 0x36, 0x3E, 0x3E,
    0x36, 0x36, 0x36, 0x3E,
    0x37, 0x38, 0x38, 0x39,
    0x37, 0x38, 0x39, 0x3A,
    0x37, 0x39, 0x3A, 0x3B,
    0x37, 0x38, 0x3A, 0x3B,
    0x37, 0x38, 0x39, 0x3B,
    0x37, 0x39, 0x3A, 0x3C,
    0x37, 0x39, 0x3B, 0x3C,
    0x37, 0x38, 0x3B, 0x3C,
    0x37, 0x38, 0x3A, 0x3C,
    0x37, 0x39, 0x3B, 0x3D,
    0x37, 0x3A, 0x3C, 0x3D,
    0x37, 0x38, 0x3C, 0x3D,
    0x37, 0x38, 0x3A, 0x3D,
    0x37, 0x3D, 0x3D, 0x3D,
    0x37, 0x37, 0x3D, 0x3D,
    0x37, 0x37, 0x37, 0x3D,
    0x37, 0x3A, 0x3B, 0x3E,
    0x37, 0x3A, 0x3D, 0x3E,
    0x37, 0x38, 0x3D, 0x3E,
    0x37, 0x38, 0x3B, 0x3E,
    0x37, 0x3A, 0x3C, 0x3F,
    0x37, 0x3B, 0x3D, 0x3F,
    0x37, 0x39, 0x3D, 0x3F,
    0x37, 0x39, 0x3B, 0x3F,
    0x37, 0x3F, 0x3F, 0x3F,
    0x37, 0x37, 0x3F, 0x3F,
    0x37, 0x37, 0x37, 0x3F,
    0x38, 0x39, 0x39, 0x3A,
    0x38, 0x39, 0x3A, 0x3B,
    0x38, 0x3A, 0x3B, 0x3C,
    0x38, 0x39, 0x3B, 0x3C,
    0x38, 0x39, 0x3A, 0x3C,
    0x38, 0x3A, 0x3B, 0x3D,
    0x38, 0x3A, 0x3C, 0x3D,
    0x38, 0x39, 0x3C, 0x3D,
    0x38, 0x39, 0x3B, 0x3D,
    0x38, 0x3A, 0x3C, 0x3E,
    0x38, 0x3B, 0x3D, 0x3E,
    0x38, 0x39, 0x3D, 0x3E,
    0x38, 0x39, 0x3B, 0x3E,
    0x38, 0x3E, 0x3E, 0x3E,
    0x38, 0x38, 0x3E, 0x3E,
    0x38, 0x38, 0x38, 0x3E,
    0x38, 0x3B, 0x3C, 0x3F,
    0x38, 0x3B, 0x3E, 0x3F,
    0x38, 0x39, 0x3E, 0x3F,
    0x38, 0x39, 0x3C, 0x3F,
    0x39, 0x3A, 0x3A, 0x3B,
    0x39, 0x3A, 0x3B, 0x3C,
    0x39, 0x3B, 0x3C, 0x3D,
    0x39, 0x3A, 0x3C, 0x3D,
    0x39, 0x3A, 0x3B, 0x3D,
    0x39, 0x3B, 0x3C, 0x3E,
    0x39, 0x3B, 0x3D, 0x3E,
    0x39, 0x3A, 0x3D, 0x3E,
    0x39, 0x3A, 0x3C, 0x3E,
    0x39, 0x3B, 0x3D, 0x3F,
    0x39, 0x3C, 0x3E, 0x3F,
    0x39, 0x3A, 0x3E, 0x3F,
    0x39, 0x3A, 0x3C, 0x3F,
    0x39, 0x3F, 0x3F, 0x3F,
    0x39, 0x39, 0x3F, 0x3F,
    0x39, 0x39, 0x39, 0x3F,
    0x3A, 0x3B, 0x3B, 0x3C,
    0x3A, 0x3B, 0x3C, 0x3D,
    0x3A, 0x3C, 0x3D, 0x3E,
    0x3A, 0x3B, 0x3D, 0x3E,
    0x3A, 0x3B, 0x3C, 0x3E,
    0x3A, 0x3C, 0x3D, 0x3F,
    0x3A, 0x3C, 0x3E, 0x3F,
    0x3A, 0x3B, 0x3E, 0x3F,
    0x3A, 0x3B, 0x3D, 0x3F,
    0x3B, 0x3C, 0x3C, 0x3D,
    0x3B, 0x3C, 0x3D, 0x3E,
    0x3B, 0x3D, 0x3E, 0x3F,
    0x3B, 0x3C, 0x3E, 0x3F,
    0x3B, 0x3C, 0x3D, 0x3F,
    0x3C, 0x3D, 0x3D, 0x3E,
    0x3C, 0x3D, 0x3E, 0x3F,
    0x3D, 0x3E, 0x3E, 0x3F

################################################################################

TITLE
    libavcodec Beam software vb_patterns

TYPE
    16

DATA
    0x0660, 0xFF00, 0xCCCC, 0xF000, 0x8888, 0x000F, 0x1111, 0xFEC8,
    0x8CEF, 0x137F, 0xF731, 0xC800, 0x008C, 0x0013, 0x3100, 0xCC00,
    0x00CC, 0x0033, 0x3300, 0x0FF0, 0x6666, 0x00F0, 0x0F00, 0x2222,
    0x4444, 0xF600, 0x8CC8, 0x006F, 0x1331, 0x318C, 0xC813, 0x33CC,
    0x6600, 0x0CC0, 0x0066, 0x0330, 0xF900, 0xC88C, 0x009F, 0x3113,
    0x6000, 0x0880, 0x0006, 0x0110, 0xCC88, 0xFC00, 0x00CF, 0x88CC,
    0x003F, 0x1133, 0x3311, 0xF300, 0x6FF6, 0x0603, 0x08C6, 0x8C63,
    0xC631, 0x6310, 0xC060, 0x0136, 0x136C, 0x36C8, 0x6C80, 0x324C

################################################################################

TITLE
    libavcodec VC-1 and WMV3 dcpred

TYPE
    16

DATA
    -1, 1024,  512,  341,  256,  205,  171,  146,  128,
         114,  102,   93,   85,   79,   73,   68,   64,
          60,   57,   54,   51,   49,   47,   45,   43,
          41,   39,   38,   37,   35,   34,   33

################################################################################

TITLE
    libavcodec VC-1 vc1_ac_tables

TYPE
    32

DATA
{ 0x0001,  2}, { 0x0005,  3}, { 0x000D,  4}, { 0x0012,  5}, { 0x000E,  6}, { 0x0015,  7},
{ 0x0013,  8}, { 0x003F,  8}, { 0x004B,  9}, { 0x011F,  9}, { 0x00B8, 10}, { 0x03E3, 10},
{ 0x0172, 11}, { 0x024D, 12}, { 0x03DA, 12}, { 0x02DD, 13}, { 0x1F55, 13}, { 0x05B9, 14},
{ 0x3EAE, 14}, { 0x0000,  4}, { 0x0010,  5}, { 0x0008,  7}, { 0x0020,  8}, { 0x0029,  9},
{ 0x01F4,  9}, { 0x0233, 10}, { 0x01E0, 11}, { 0x012A, 12}, { 0x03DD, 12}, { 0x050A, 13},
{ 0x1F29, 13}, { 0x0A42, 14}, { 0x1272, 15}, { 0x1737, 15}, { 0x0003,  5}, { 0x0011,  7},
{ 0x00C4,  8}, { 0x004B, 10}, { 0x00B4, 11}, { 0x07D4, 11}, { 0x0345, 12}, { 0x02D7, 13},
{ 0x07BF, 13}, { 0x0938, 14}, { 0x0BBB, 14}, { 0x095E, 15}, { 0x0013,  5}, { 0x0078,  7},
{ 0x0069,  9}, { 0x0232, 10}, { 0x0461, 11}, { 0x03EC, 12}, { 0x0520, 13}, { 0x1F2A, 13},
{ 0x3E50, 14}, { 0x3E51, 14}, { 0x1486, 15}, { 0x000C,  6}, { 0x0024,  9}, { 0x0094, 11},
{ 0x08C0, 12}, { 0x0F09, 14}, { 0x1EF0, 15}, { 0x003D,  6}, { 0x0053,  9}, { 0x01A0, 11},
{ 0x02D6, 13}, { 0x0F08, 14}, { 0x0013,  7}, { 0x007C,  9}, { 0x07C1, 11}, { 0x04AC, 14},
{ 0x001B,  7}, { 0x00A0, 10}, { 0x0344, 12}, { 0x0F79, 14}, { 0x0079,  7}, { 0x03E1, 10},
{ 0x02D4, 13}, { 0x2306, 14}, { 0x0021,  8}, { 0x023C, 10}, { 0x0FAE, 12}, { 0x23DE, 14},
{ 0x0035,  8}, { 0x0175, 11}, { 0x07B3, 13}, { 0x00C5,  8}, { 0x0174, 11}, { 0x0785, 13},
{ 0x0048,  9}, { 0x01A3, 11}, { 0x049E, 13}, { 0x002C,  9}, { 0x00FA, 10}, { 0x07D6, 11},
{ 0x0092, 10}, { 0x05CC, 13}, { 0x1EF1, 15}, { 0x00A3, 10}, { 0x03ED, 12}, { 0x093E, 14},
{ 0x01E2, 11}, { 0x1273, 15}, { 0x07C4, 11}, { 0x1487, 15}, { 0x0291, 12}, { 0x0293, 12},
{ 0x0F8A, 12}, { 0x0509, 13}, { 0x0508, 13}, { 0x078D, 13}, { 0x07BE, 13}, { 0x078C, 13},
{ 0x04AE, 14}, { 0x0BBA, 14}, { 0x2307, 14}, { 0x0B9A, 14}, { 0x1736, 15}, { 0x000E,  4},
{ 0x0045,  7}, { 0x01F3,  9}, { 0x047A, 11}, { 0x05DC, 13}, { 0x23DF, 14}, { 0x0019,  5},
{ 0x0028,  9}, { 0x0176, 11}, { 0x049D, 13}, { 0x23DD, 14}, { 0x0030,  6}, { 0x00A2, 10},
{ 0x02EF, 12}, { 0x05B8, 14}, { 0x003F,  6}, { 0x00A5, 10}, { 0x03DB, 12}, { 0x093F, 14},
{ 0x0044,  7}, { 0x07CB, 11}, { 0x095F, 15}, { 0x0063,  7}, { 0x03C3, 12}, { 0x0015,  8},
{ 0x08F6, 12}, { 0x0017,  8}, { 0x0498, 13}, { 0x002C,  8}, { 0x07B2, 13}, { 0x002F,  8},
{ 0x1F54, 13}, { 0x008D,  8}, { 0x07BD, 13}, { 0x008E,  8}, { 0x1182, 13}, { 0x00FB,  8},
{ 0x050B, 13}, { 0x002D,  8}, { 0x07C0, 11}, { 0x0079,  9}, { 0x1F5F, 13}, { 0x007A,  9},
{ 0x1F56, 13}, { 0x0231, 10}, { 0x03E4, 10}, { 0x01A1, 11}, { 0x0143, 11}, { 0x01F7, 11},
{ 0x016F, 12}, { 0x0292, 12}, { 0x02E7, 12}, { 0x016C, 12}, { 0x016D, 12}, { 0x03DC, 12},
{ 0x0F8B, 12}, { 0x0499, 13}, { 0x03D8, 12}, { 0x078E, 13}, { 0x02D5, 13}, { 0x1F5E, 13},
{ 0x1F2B, 13}, { 0x078F, 13}, { 0x04AD, 14}, { 0x3EAF, 14}, { 0x23DC, 14}, { 0x004A,  9}

################################################################################

TITLE
    libavcodec On2 Vp3 predictor_transform

TYPE
    32

DATA
        {  0,  0,  0,  0},
        {  0,  0,  0,128},        // PL
        {  0,  0,128,  0},        // PUR
        {  0,  0, 53, 75},        // PUR|PL
        {  0,128,  0,  0},        // PU
        {  0, 64,  0, 64},        // PU|PL
        {  0,128,  0,  0},        // PU|PUR
        {  0,  0, 53, 75},        // PU|PUR|PL
        {128,  0,  0,  0},        // PUL
        {  0,  0,  0,128},        // PUL|PL
        { 64,  0, 64,  0},        // PUL|PUR
        {  0,  0, 53, 75},        // PUL|PUR|PL
        {  0,128,  0,  0},        // PUL|PU
       {-104,116,  0,116},        // PUL|PU|PL
        { 24, 80, 24,  0},        // PUL|PU|PUR
       {-104,116,  0,116}         // PUL|PU|PUR|PL

################################################################################

TITLE
    libavcodec vp5_ract_pct

TYPE
    8

DATA
    { { { 227, 246, 230, 247, 244, 254, 254, 254, 254, 254, 254 },
        { 202, 254, 209, 231, 231, 249, 249, 253, 254, 254, 254 },
        { 206, 254, 225, 242, 241, 251, 253, 254, 254, 254, 254 },
        { 235, 254, 241, 253, 252, 254, 254, 254, 254, 254, 254 },
        { 234, 254, 248, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } },
      { { 240, 254, 248, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 238, 254, 240, 253, 254, 254, 254, 254, 254, 254, 254 },
        { 244, 254, 251, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } } },
    { { { 206, 203, 227, 239, 247, 254, 253, 254, 254, 254, 254 },
        { 207, 199, 220, 236, 243, 252, 252, 254, 254, 254, 254 },
        { 212, 219, 230, 243, 244, 253, 252, 254, 254, 254, 254 },
        { 236, 237, 247, 252, 253, 254, 254, 254, 254, 254, 254 },
        { 240, 240, 248, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } },
      { { 230, 233, 249, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 238, 238, 250, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 248, 251, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } } },
    { { { 225, 239, 227, 231, 244, 253, 243, 254, 254, 253, 254 },
        { 232, 234, 224, 228, 242, 249, 242, 252, 251, 251, 254 },
        { 235, 249, 238, 240, 251, 254, 249, 254, 253, 253, 254 },
        { 249, 253, 251, 250, 254, 254, 254, 254, 254, 254, 254 },
        { 251, 250, 249, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } },
      { { 243, 244, 250, 250, 254, 254, 254, 254, 254, 254, 254 },
        { 249, 248, 250, 253, 254, 254, 254, 254, 254, 254, 254 },
        { 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 },
        { 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254 } } },

################################################################################

TITLE
    libavcodec vp6_ract_pct

TYPE
    8

DATA
  { { { 227, 246, 230, 247, 244, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 209, 231, 231, 249, 249, 253, 255, 255, 255 },
      { 255, 255, 225, 242, 241, 251, 253, 255, 255, 255, 255 },
      { 255, 255, 241, 253, 252, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 248, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } },
    { { 240, 255, 248, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 240, 253, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } } },
  { { { 206, 203, 227, 239, 247, 255, 253, 255, 255, 255, 255 },
      { 207, 199, 220, 236, 243, 252, 252, 255, 255, 255, 255 },
      { 212, 219, 230, 243, 244, 253, 252, 255, 255, 255, 255 },
      { 236, 237, 247, 252, 253, 255, 255, 255, 255, 255, 255 },
      { 240, 240, 248, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } },
    { { 230, 233, 249, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 238, 238, 250, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 248, 251, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } } },
  { { { 225, 239, 227, 231, 244, 253, 243, 255, 255, 253, 255 },
      { 232, 234, 224, 228, 242, 249, 242, 252, 251, 251, 255 },
      { 235, 249, 238, 240, 251, 255, 249, 255, 253, 253, 255 },
      { 249, 253, 251, 250, 255, 255, 255, 255, 255, 255, 255 },
      { 251, 250, 249, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } },
    { { 243, 244, 250, 250, 255, 255, 255, 255, 255, 255, 255 },
      { 249, 248, 250, 253, 255, 255, 255, 255, 255, 255, 255 },
      { 253, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 },
      { 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255 } } }

################################################################################

TITLE
    libavcodec wp_exp2_table

TYPE
    8

DATA
    0x00, 0x01, 0x01, 0x02, 0x03, 0x03, 0x04, 0x05, 0x06, 0x06, 0x07, 0x08, 0x08, 0x09, 0x0a, 0x0b,
    0x0b, 0x0c, 0x0d, 0x0e, 0x0e, 0x0f, 0x10, 0x10, 0x11, 0x12, 0x13, 0x13, 0x14, 0x15, 0x16, 0x16,
    0x17, 0x18, 0x19, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1d, 0x1e, 0x1f, 0x20, 0x20, 0x21, 0x22, 0x23,
    0x24, 0x24, 0x25, 0x26, 0x27, 0x28, 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2c, 0x2d, 0x2e, 0x2f, 0x30,
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3a, 0x3b, 0x3c, 0x3d,
    0x3e, 0x3f, 0x40, 0x41, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x48, 0x49, 0x4a, 0x4b,
    0x4c, 0x4d, 0x4e, 0x4f, 0x50, 0x51, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a,
    0x5b, 0x5c, 0x5d, 0x5e, 0x5e, 0x5f, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
    0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
    0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x87, 0x88, 0x89, 0x8a,
    0x8b, 0x8c, 0x8d, 0x8e, 0x8f, 0x90, 0x91, 0x92, 0x93, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a, 0x9b,
    0x9c, 0x9d, 0x9f, 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa8, 0xa9, 0xaa, 0xab, 0xac, 0xad,
    0xaf, 0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xbc, 0xbd, 0xbe, 0xbf, 0xc0,
    0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc8, 0xc9, 0xca, 0xcb, 0xcd, 0xce, 0xcf, 0xd0, 0xd2, 0xd3, 0xd4,
    0xd6, 0xd7, 0xd8, 0xd9, 0xdb, 0xdc, 0xdd, 0xde, 0xe0, 0xe1, 0xe2, 0xe4, 0xe5, 0xe6, 0xe8, 0xe9,
    0xea, 0xec, 0xed, 0xee, 0xf0, 0xf1, 0xf2, 0xf4, 0xf5, 0xf6, 0xf8, 0xf9, 0xfa, 0xfc, 0xfd, 0xff

################################################################################

TITLE
    libavcodec wp_log2_table

TYPE
    8

DATA
    0x00, 0x01, 0x03, 0x04, 0x06, 0x07, 0x09, 0x0a, 0x0b, 0x0d, 0x0e, 0x10, 0x11, 0x12, 0x14, 0x15,
    0x16, 0x18, 0x19, 0x1a, 0x1c, 0x1d, 0x1e, 0x20, 0x21, 0x22, 0x24, 0x25, 0x26, 0x28, 0x29, 0x2a,
    0x2c, 0x2d, 0x2e, 0x2f, 0x31, 0x32, 0x33, 0x34, 0x36, 0x37, 0x38, 0x39, 0x3b, 0x3c, 0x3d, 0x3e,
    0x3f, 0x41, 0x42, 0x43, 0x44, 0x45, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4d, 0x4e, 0x4f, 0x50, 0x51,
    0x52, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x61, 0x62, 0x63,
    0x64, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70, 0x71, 0x72, 0x74, 0x75,
    0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85,
    0x86, 0x87, 0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95,
    0x96, 0x97, 0x98, 0x99, 0x9a, 0x9b, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f, 0xa0, 0xa1, 0xa2, 0xa3, 0xa4,
    0xa5, 0xa6, 0xa7, 0xa8, 0xa9, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf, 0xb0, 0xb1, 0xb2, 0xb2,
    0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf, 0xc0, 0xc0,
    0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xcb, 0xcb, 0xcc, 0xcd, 0xce,
    0xcf, 0xd0, 0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd8, 0xd9, 0xda, 0xdb,
    0xdc, 0xdc, 0xdd, 0xde, 0xdf, 0xe0, 0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe4, 0xe5, 0xe6, 0xe7, 0xe7,
    0xe8, 0xe9, 0xea, 0xea, 0xeb, 0xec, 0xed, 0xee, 0xee, 0xef, 0xf0, 0xf1, 0xf1, 0xf2, 0xf3, 0xf4,
    0xf4, 0xf5, 0xf6, 0xf7, 0xf7, 0xf8, 0xf9, 0xf9, 0xfa, 0xfb, 0xfc, 0xfc, 0xfd, 0xfe, 0xff, 0xff

################################################################################

TITLE
    libavcodec ff_wma_lsp_codebook

TYPE
    FLOAT

DATA
 { 1.98732877, 1.97944528, 1.97179088, 1.96260549, 1.95038374, 1.93336114, 1.90719232, 1.86191415, },
 { 1.97260000, 1.96083160, 1.94982586, 1.93806164, 1.92516608, 1.91010199, 1.89232331, 1.87149812,
   1.84564818, 1.81358067, 1.77620070, 1.73265264, 1.67907855, 1.60959081, 1.50829650, 1.33120330, },
 { 1.90109110, 1.86482426, 1.83419671, 1.80168452, 1.76650116, 1.72816320, 1.68502700, 1.63738256,
   1.58501580, 1.51795181, 1.43679906, 1.33950585, 1.24176208, 1.12260729, 0.96749668, 0.74048265, },
 { 1.76943864, 1.67822463, 1.59946365, 1.53560582, 1.47470796, 1.41210167, 1.34509536, 1.27339507,
   1.19303814, 1.09765169, 0.98818722, 0.87239446, 0.74369172, 0.59768184, 0.43168630, 0.17977021, },
 { 1.43428349, 1.32038354, 1.21074086, 1.10577988, 1.00561746, 0.90335924, 0.80437489, 0.70709671,
   0.60427395, 0.49814048, 0.38509539, 0.27106800, 0.14407416, 0.00219910, -0.16725141, -0.36936085, },
 { 0.99895687, 0.84188166, 0.70753739, 0.57906595, 0.47055563, 0.36966965, 0.26826648, 0.17163380,
   0.07208392, -0.03062936, -1.40037388, -0.25128968, -0.37213937, -0.51075646, -0.64887512, -0.80308031, },
 { 0.26515280, 0.06313551, -0.08872080, -0.21103548, -0.31069678, -0.39680323, -0.47223474, -0.54167135,
   -0.61444740, -0.68943343, -0.76580211, -0.85170082, -0.95289061, -1.06514703, -1.20510707, -1.37617746, },
 { -0.53940301, -0.73770929, -0.88424876, -1.01117930, -1.13389091, -1.26830073, -1.42041987, -1.62033919,
   -1.10158808, -1.16512566, -1.23337128, -1.30414401, -1.37663312, -1.46853845, -1.57625798, -1.66893638, },
 { -0.38601997, -0.56009350, -0.66978483, -0.76028471, -0.83846064, -0.90868087, -0.97408881, -1.03694962, },
 { -1.56144989, -1.65944032, -1.72689685, -1.77857740, -1.82203011, -1.86220079, -1.90283983, -1.94820479, },

################################################################################

TITLE
    libavcodec wnv1 code_tab

TYPE
    16

DATA
{0x1FD,9}, {0xFD,8}, {0x7D,7}, {0x3D,6}, {0x1D,5}, {0x0D,4}, {0x005,3},
{0x000,1},
{0x004,3}, {0x0C,4}, {0x1C,5}, {0x3C,6}, {0x7C,7}, {0xFC,8}, {0x1FC,9}, {0xFF,8}

################################################################################

TITLE
    libavcodec VideoXL xl_table

TYPE
    16

DATA
   0,   1,   2,   3,   4,   5,   6,   7,
   8,   9,  12,  15,  20,  25,  34,  46,
  64,  82,  94, 103, 108, 113, 116, 119,
 120, 121, 122, 123, 124, 125, 126, 127};

################################################################################

TITLE
    PADDINGXXPADDING

TYPE
    8

DATA
    "PADDINGXXPADDING"

################################################################################

TITLE
    unlzx table_one

TYPE
    8

DATA
 0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14

################################################################################

TITLE
    unlzx table_two

TYPE
    32

DATA
 0,1,2,3,4,6,8,12,16,24,32,48,64,96,128,192,256,384,512,768,1024,
 1536,2048,3072,4096,6144,8192,12288,16384,24576,32768,49152

################################################################################

TITLE
    unlzx table_three

TYPE
    16 32

DATA
 0,1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,16383,32767

################################################################################

TITLE
    Thandor game audio codec (? needs verification)

TYPE
    32

DATA
    -10000,-7000,-6000,-5415,
    -5000,-4678,-4415,-4193,
    -4000,-3830,-3678,-3540,
    -3415,-3300,-3193,-3093,
    -3000,-2913,-2830,-2752,
    -2678,-2608,-2541,-2476,
    -2415,-2356,-2300,-2245,
    -2193,-2142,-2093,-2046,
    -2000,-1956,-1913,-1871,
    -1830,-1791,-1752,-1715,
    -1678,-1642,-1608,-1574,
    -1541,-1508,-1476,-1445,
    -1415,-1385,-1356,-1328,
    -1300,-1272,-1245,-1219,
    -1193,-1167,-1142,-1117,
    -1093,-1069,-1046,-1023,
    -1000,-978,-956,-934,
    -913,-891,-871,-850,
    -830,-810,-791,-771,
    -752,-733,-715,-696,
    -678,-660,-642,-625,
    -608,-591,-574,-557,
    -541,-524,-508,-492,
    -476,-461,-445,-430,
    -415,-400,-385,-371,
    -356,-342,-328,-314,
    -300,-286,-272,-259,
    -245,-232,-219,-206,
    -193,-180,-167,-154,
    -142,-130,-117,-105,
    -93,-81,-69,-57,
    -46,-34,-23,-11,

################################################################################

TITLE
    PKWare Data Compression Library (DCL) (blast.c litlen)

TYPE
    8

DATA
        11, 124, 8, 7, 28, 7, 188, 13, 76, 4, 10, 8, 12, 10, 12, 10, 8, 23, 8,
        9, 7, 6, 7, 8, 7, 6, 55, 8, 23, 24, 12, 11, 7, 9, 11, 12, 6, 7, 22, 5,
        7, 24, 6, 11, 9, 6, 7, 22, 7, 11, 38, 7, 9, 8, 25, 11, 8, 11, 9, 12,
        8, 12, 5, 38, 5, 38, 5, 11, 7, 5, 6, 21, 6, 10, 53, 8, 7, 24, 10, 27,
        44, 253, 253, 253, 252, 252, 252, 13, 12, 45, 12, 45, 12, 61, 12, 45,
        44, 173};

################################################################################

TITLE
    MD5 constants

TYPE
    32 AND

DATA
    0x67452301 0x10325477 0x67452302 0x10325476

################################################################################

TITLE
    Crysis game type table

TYPE
    8

DATA
    "\x0A\x00\x00\x5C\x7A\x61\x00\x2C\x46\x80\x00\x21\x57\x00\x00\x4F"
    "\x00\x19\x1C\x00\x00\x5D\x00\x71\x12\x00\x00\x00\x51\x1E\x03\x33"
    "\x00\x13\x84\x00\x27\x00\x4E\x00\x8C\x00\x00\x00\x00\x50\x00\x2B"
    "\x3C\x82\x47\x28\x00\x11\x8D\x00\x70\x42\x0D\x01\x07\x09\x08\x05"
    "\x00\x34\x00\x6B\x10\x66\x6D\x00\x00\x39\x00\x78\x00\x00\x55\x59"
    "\x04\x00\x00\x72\x63\x00\x87\x00\x00\x00\x00\x00\x58\x67\x48\x2D"
    "\x3B\x4C\x35\x00\x26\x00\x03\x89\x00\x1A\x03\x00\x6A\x30\x83\x4A"
    "\x00\x0B\x8B\x00\x5A\x74\x00\x7D\x14\x18\x4B\x00\x00\x00\x6C\x1B"
    "\x00\x20\x00\x45\x38\x0E\x3A\x25\x86\x00\x00\x6F\x00\x5B\x00\x24"
    "\x00\x62\x00\x00\x00\x8E\x44\x00\x88\x7E\x0C\x23\x00\x36\x00\x00"
    "\x31\x00\x5F\x53\x90\x7B\x7C\x00\x41\x73\x60\x3D\x76\x00\x5E\x8A"
    "\x00\x68\x03\x3F\x00\x00\x8F\x16\x17\x00\x85\x00\x00\x00\x56\x15"
    "\x75\x00\x1D\x00\x40\x00\x00\x00\x29\x00\x4D\x22\x00\x00\x2A\x43"
    "\x7F\x3E\x2E\x00\x1F\x00\x00\x6E\x00\x00\x00\x49\x00\x00\x00\x00"
    "\x69\x00\x00\x00\x2F\x00\x32\x37\x54\x52\x00\x77\x00\x65\x00\x00"
    "\x79\x00\x00\x00\x00\x64\x0F\x81\x00\x00\x00\x00\x03\x03\x02\x06";

################################################################################

TITLE
    lzari

TYPE
    32 AND

DATA
    10000 200 314

################################################################################

TITLE
    DMC compression

TYPE
    32 and

DATA
    0x3e4ccccd 0x3e4ccccd 0x3e4ccccd 0x3e4ccccd

################################################################################

TITLE
    compression algorithm seen in the game DreamKiller

TYPE
    32 and

DATA
    0xFFFFFF1F 0xFFFFFF3F 0xFFFFFF0F

################################################################################

TITLE
    function where is handled the ZipCrypto password

TYPE
    32 and

DATA
    0x12345678 0x23456789 0x34567890

################################################################################

TITLE
    XTEA::DELTAS

TYPE
    32

DATA
0x00000000, 0x9E3779B9, 0x9E3779B9, 0x3C6EF372, 0x3C6EF372, 0xDAA66D2B,
0xDAA66D2B, 0x78DDE6E4, 0x78DDE6E4, 0x1715609D, 0x1715609D, 0xB54CDA56,
0xB54CDA56, 0x5384540F, 0x5384540F, 0xF1BBCDC8, 0xF1BBCDC8, 0x8FF34781,
0x8FF34781, 0x2E2AC13A, 0x2E2AC13A, 0xCC623AF3, 0xCC623AF3, 0x6A99B4AC,
0x6A99B4AC, 0x08D12E65, 0x08D12E65, 0xA708A81E, 0xA708A81E, 0x454021D7,
0x454021D7, 0xE3779B90, 0xE3779B90, 0x81AF1549, 0x81AF1549, 0x1FE68F02,
0x1FE68F02, 0xBE1E08BB, 0xBE1E08BB, 0x5C558274, 0x5C558274, 0xFA8CFC2D,
0xFA8CFC2D, 0x98C475E6, 0x98C475E6, 0x36FBEF9F, 0x36FBEF9F, 0xD5336958,
0xD5336958, 0x736AE311, 0x736AE311, 0x11A25CCA, 0x11A25CCA, 0xAFD9D683,
0xAFD9D683, 0x4E11503C, 0x4E11503C, 0xEC48C9F5, 0xEC48C9F5, 0x8A8043AE,
0x8A8043AE, 0x28B7BD67, 0x28B7BD67, 0xC6EF3720

################################################################################

TITLE
    Erlang

TYPE
    32 and

DATA
    0x9E3779B9
    0x3c6ef372 0xdaa66d2b 0x78dde6e4 0x1715609d
    0xb54cda56 0x5384540f 0xf1bbcdc8 0x8ff34781
    0x2e2ac13a 0xcc623af3 0x6a99b4ac 0x08d12e65
    0xa708a81e 0x454021d7

################################################################################

TITLE
    Inverse Modified DCT pm64 (liba52)

TYPE
    32
DATA
0x00,0x08,0x10,0x18,0x20,0x28,0x30,0x38,0x04,0x14,0x24,0x34,0x0c,0x1c,0x2c,0x3c,0x02,0x0a,0x12,0x1a,0x22,0x2a,0x32,0x3a,0x06,0x0e,0x16,0x1e,0x26,0x2e,0x36,0x3e,
0x01,0x09,0x11,0x19,0x21,0x29,0x31,0x39,0x05,0x15,0x25,0x35,0x0d,0x1d,0x2d,0x3d,0x03,0x0b,0x13,0x1b,0x23,0x2b,0x33,0x3b,0x07,0x17,0x27,0x37,0x0f,0x1f,0x2f,0x3f,

################################################################################

TITLE
    TNS filter long tns_max_bands_1024 (avcodec)

TYPE
    8
DATA
0x1f,0x1f,0x22,0x28,0x2a,0x33,0x2e,0x2e,0x2a,0x2a,0x2a,0x27,0x27,

################################################################################

TITLE
    TNS filter long SSR tnsMaxBandsLong

TYPE
    8
DATA
0x1c,0x1c,0x1b,0x1a,0x1a,0x1a,0x1d,0x1d,0x17,0x17,0x17,0x13,

################################################################################

TITLE
    TNS filter short tns_max_bands_128 (avcodec)

TYPE
    8
DATA
0x09,0x09,0x0a,0x0e,0x0e,0x0e,0x0e,0x0e,0x0e,0x0e,0x0e,0x0e,0x0e,

################################################################################

TITLE
    TNS filter short SSR tnsMaxBandsShort

TYPE
    8
DATA
0x07,0x07,0x07,0x06,0x06,0x06,0x07,0x07,0x08,0x08,0x08,0x07,

################################################################################

TITLE
    AudioKinetic Wwise RIFF packed_codebooks.bin (first 1024 bytes)

TYPE
    8

DATA
    0x92, 0x07, 0xa0, 0x10, 0xa9, 0x32, 0x33, 0xbb, 0xcb, 0xcc, 0x2a, 0xb3, 0xbb, 0xbb, 0xcc, 0xac, 
    0x32, 0xbb, 0xbb, 0xcb, 0x4c, 0x33, 0xb3, 0xbb, 0xbb, 0xcc, 0x34, 0x33, 0xbb, 0xbb, 0xcb, 0x4c, 
    0xb3, 0xbb, 0xbb, 0xbb, 0xcc, 0x34, 0xbb, 0xbb, 0xbb, 0xcb, 0xcc, 0xbb, 0xbb, 0xbb, 0xbb, 0xcc, 
    0xcc, 0xbc, 0xbb, 0xbb, 0xcb, 0xcc, 0x4c, 0xc4, 0xbb, 0xbb, 0xcc, 0xcc, 0xbc, 0xbb, 0xbb, 0x0b, 
    0x00, 0x40, 0x05, 0x0e, 0x00, 0x00, 0x01, 0x36, 0x8a, 0x6c, 0x4e, 0x30, 0x12, 0x14, 0x14, 0x05, 
    0x20, 0x19, 0xa2, 0x2a, 0xaa, 0x22, 0xab, 0xb2, 0x2b, 0x3b, 0xaa, 0xaa, 0xb3, 0x3a, 0xa3, 0x2a, 
    0xbb, 0x2b, 0xb3, 0x3a, 0x33, 0xc3, 0x43, 0x2c, 0x3b, 0x43, 0x3b, 0x44, 0xaa, 0x2a, 0x33, 0xbb, 
    0xab, 0xb3, 0x43, 0x34, 0xc3, 0xb2, 0x3b, 0x44, 0x43, 0x0b, 0x00, 0x00, 0x01, 0x0e, 0x00, 0x00, 
    0x01, 0x16, 0x42, 0x12, 0x05, 0xe0, 0x50, 0xca, 0x5a, 0xad, 0xc5, 0x68, 0xad, 0xd6, 0xde, 0x8b, 
    0xd1, 0x5a, 0xad, 0xbd, 0x17, 0xa3, 0xd6, 0xde, 0x7b, 0x6f, 0x4e, 0xbc, 0xf7, 0xde, 0x9c, 0x78, 
    0x2f, 0xc6, 0x5a, 0x11, 0x63, 0x8c, 0xb5, 0x62, 0xce, 0x39, 0x6b, 0x05, 0x31, 0xd6, 0x1a, 0x00, 
    0x00, 0x0a, 0x1c, 0x00, 0x00, 0x02, 0x6c, 0xd0, 0x94, 0x58, 0x1c, 0x20, 0x92, 0x07, 0x20, 0x99, 
    0xa9, 0x32, 0xbb, 0xbb, 0x1b, 0xa2, 0xaa, 0xb3, 0xbb, 0xbb, 0x21, 0xaa, 0xb2, 0xbb, 0xbb, 0x2b, 
    0x2b, 0xb3, 0x3b, 0x44, 0xc4, 0x2a, 0x33, 0xbb, 0x43, 0x44, 0xb4, 0xb3, 0x3b, 0x44, 0x44, 0x44, 
    0xb3, 0xbb, 0x43, 0x44, 0x44, 0xbc, 0x3b, 0x44, 0xc4, 0x44, 0xc4, 0xbb, 0x43, 0x44, 0x44, 0xc4, 
    0xbc, 0x3b, 0x44, 0xc4, 0xc4, 0xcc, 0xbb, 0x43, 0x44, 0xc4, 0xcc, 0x0c, 0x00, 0x40, 0x05, 0x0e, 
    0x00, 0x00, 0x01, 0x36, 0x8a, 0x6c, 0x4e, 0x30, 0x12, 0x14, 0x12, 0x0e, 0x20, 0x98, 0x31, 0xbb, 
    0x3b, 0x3b, 0xc3, 0x43, 0x1c, 0x2b, 0xbc, 0x4c, 0x3c, 0x44, 0x44, 0x3c, 0xaa, 0x3a, 0xcc, 0x44, 
    0xc4, 0xcc, 0x4c, 0xb5, 0xbb, 0x4c, 0xd5, 0x4c, 0x55, 0x5d, 0x55, 0xbb, 0xcb, 0x54, 0xcd, 0x54, 
    0x5d, 0x55, 0x3d, 0x44, 0xd5, 0x5d, 0xd5, 0xd5, 0xdd, 0xdd, 0xc3, 0x54, 0xdd, 0x55, 0xdd, 0xdd, 
    0xdd, 0x3d, 0xc4, 0xcc, 0xd5, 0xdd, 0xdd, 0xdd, 0xe5, 0x43, 0x54, 0x55, 0xdd, 0xdd, 0xe5, 0x65, 
    0xc6, 0x4c, 0xd5, 0xdd, 0xe5, 0x65, 0xe6, 0x66, 0xcc, 0x54, 0xdd, 0x5d, 0xe6, 0x65, 0x6e, 0x46, 
    0xcd, 0x55, 0xde, 0x65, 0x66, 0x66, 0x6e, 0xcc, 0xdc, 0xdd, 0x5d, 0x66, 0x66, 0xee, 0x4e, 0xd5, 
    0xdd, 0x65, 0xe6, 0x6e, 0xee, 0xee, 0x54, 0xdd, 0xdd, 0xe5, 0xe5, 0xe6, 0xee, 0x0e, 0x00, 0xdc, 
    0x0d, 0x0e, 0x00, 0x10, 0x09, 0x36, 0xce, 0xb0, 0x92, 0x74, 0x56, 0x38, 0x1a, 0x1c, 0x92, 0x01, 
    0x98, 0x6c, 0xe4, 0x48, 0x72, 0x24, 0xc9, 0xb6, 0x65, 0xdb, 0x06, 0x00, 0x80, 0x01, 0x07, 0x00, 
    0x80, 0x00, 0x13, 0xca, 0x40, 0x92, 0x01, 0x98, 0x6c, 0xe4, 0x48, 0x72, 0x24, 0xc9, 0xb6, 0x65, 
    0xdb, 0x06, 0x00, 0x80, 0x01, 0x07, 0x00, 0x80, 0x00, 0x13, 0xca, 0x40, 0xa1, 0x00, 0x50, 0xe8, 
    0xba, 0x16, 0x92, 0x07, 0xa0, 0x98, 0xa9, 0x32, 0x33, 0xbb, 0x4b, 0xa2, 0x2a, 0xb3, 0xbb, 0xbb, 
    0x24, 0xaa, 0x32, 0xbb, 0xbb, 0x4b, 0x33, 0xb3, 0xbb, 0xbb, 0xbb, 0xcc, 0x34, 0x33, 0xbb, 0xbb, 
    0xcb, 0x4c, 0xb3, 0xbb, 0xbb, 0xbb, 0xcc, 0x34, 0xbb, 0xbb, 0xbb, 0xcb, 0xcc, 0xbb, 0xbb, 0x3b, 
    0xbc, 0xcc, 0xcc, 0xbc, 0xbb, 0xbb, 0xcb, 0xcc, 0x4c, 0xc4, 0xbb, 0xbb, 0xcc, 0xcc, 0xbc, 0xbb, 
    0xbb, 0x0b, 0x00, 0x40, 0x05, 0x0e, 0x00, 0x00, 0x01, 0x36, 0x8a, 0x6c, 0x4e, 0x30, 0x12, 0x14, 
    0x92, 0x0a, 0x20, 0x40, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 
    0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 
    0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0xbc, 0xbb, 0xbb, 0xbb, 0xbb, 
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 
    0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0x0b, 0x80, 0xd8, 0x15, 0x0e, 0x00, 0x3b, 0x11, 0x36, 
    0xac, 0x8e, 0x70, 0x52, 0x34, 0x16, 0x18, 0x42, 0x06, 0xa8, 0x61, 0x10, 0x42, 0x07, 0x25, 0x27, 
    0xc9, 0x20, 0xc5, 0x98, 0x83, 0xda, 0x2b, 0x64, 0x90, 0x62, 0x4e, 0x5a, 0xd2, 0x14, 0x32, 0x48, 
    0x31, 0x48, 0xc5, 0x63, 0x0a, 0x21, 0xc4, 0xa0, 0x04, 0x8f, 0x31, 0x84, 0x90, 0x62, 0x56, 0x3c, 
    0xe7, 0x18, 0x43, 0x88, 0x59, 0xf1, 0xa0, 0x84, 0x90, 0x29, 0x66, 0xc1, 0x16, 0xdf, 0x73, 0x4b, 
    0xa5, 0x15, 0x1d, 0x8c, 0x31, 0xba, 0xd6, 0x5e, 0x04, 0x92, 0x07, 0xa0, 0x10, 0xa9, 0x32, 0x33, 
    0xbb, 0x53, 0xd5, 0x2a, 0xb3, 0xbb, 0x3b, 0x55, 0xad, 0x32, 0xbb, 0xbb, 0x53, 0xd5, 0xaa, 0xbb, 
    0x3b, 0x44, 0x55, 0xad, 0xba, 0xbb, 0x43, 0x54, 0x55, 0xb3, 0xbb, 0xbb, 0x3b, 0x55, 0x35, 0xbb, 
    0xbb, 0x3b, 0x54, 0xd5, 0xbb, 0xbb, 0xbb, 0x3b, 0x55, 0x55, 0xbd, 0xbb, 0xbb, 0x53, 0x55, 0xd5, 
    0xbb, 0xbb, 0x3b, 0x55, 0x55, 0x35, 0xbb, 0xbb, 0x0b, 0x00, 0x40, 0x05, 0x0e, 0x00, 0x00, 0x01, 
    0x36, 0x8a, 0x6c, 0x4e, 0x30, 0x12, 0x14, 0x92, 0x0a, 0x20, 0xa0, 0xd9, 0xdd, 0xdd, 0xdd, 0xdd, 
    0x1d, 0x3c, 0x55, 0x55, 0x55, 0x55, 0xd5, 0x38, 0x53, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 
    0x55, 0x55, 0x55, 0x55, 0xd5, 0x54, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 
    0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 
    0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 
    0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x0d, 0x80, 
    0x4b, 0x15, 0x0e, 0x00, 0xba, 0x0f, 0x36, 0xac, 0x8e, 0x70, 0x52, 0x34, 0x16, 0x18, 0x92, 0x0a, 
    0xe0, 0x70, 0xce, 0x5a, 0xad, 0xb5, 0xf6, 0x5e, 0x8c, 0x2b, 0xa5, 0xf6, 0x5e, 0x7c, 0x2f, 0xc6, 
    0x59, 0x57, 0x4a, 0xef, 0xc5, 0xf8, 0x5e, 0x9c, 0xb3, 0x7a, 0xef, 0xc5, 0x18, 0x63, 0x9c, 0xb3, 
    0x56, 0x31, 0xc6, 0x17, 0x63, 0x8c, 0x73, 0xd6, 0x2a, 0xe7, 0x18, 0xe7, 0x9c, 0xb3, 0xd6, 0x7b, 
    0xed, 0x1c, 0xe3, 0x9c, 0x73, 0xd6, 0x7a, 0x2f, 0xe6, 0x8c, 0xb1, 0xd6, 0x7b, 0xf3, 0xc5, 0x9c, 
    0x31, 0xce, 0x79, 0x6f, 0xce, 0xc8, 0xbb, 0xce, 0x5a, 0xef, 0xcd, 0x1b, 0x7b, 0xcf, 0x59, 0xeb, 
    0xbd, 0x39, 0x83, 0x7b, 0xef, 0xcd, 0x79, 0x77, 0x70, 0xef, 0xbd, 0x39, 0xef, 0x1e, 0x00, 0xc0, 
    0x13, 0x1c, 0x00, 0x80, 0x0a, 0x6c, 0x58, 0x1d, 0xe1, 0xa4, 0x68, 0x2c, 0x30, 0x01, 0x08, 0x60, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xca, 0x38, 0xe5, 0x9c, 0x93, 0x4e, 0x4b, 0x2f, 0xd5, 0x35, 
    0xd7, 0x6d, 0xb7, 0xdd, 0x77, 0xdf, 0x9d, 0xf7, 0xde, 0x7b, 0x6b, 0xad, 0xb5, 0xd6, 0x5a, 0x6b, 

################################################################################

TITLE
    AudioKinetic Wwise RIFF packed_codebooks_aoTuV_603.bin (first 1024 bytes)

TYPE
    8

DATA
    0x91, 0x00, 0x58, 0x53, 0x55, 0x75, 0x75, 0x00, 0x91, 0x01, 0x58, 0x00, 0x75, 0x75, 0x95, 0xb5, 
    0xb5, 0xb7, 0xd7, 0xd9, 0x00, 0x01, 0x04, 0x60, 0x00, 0x00, 0x00, 0x25, 0x8d, 0x54, 0x52, 0x59, 
    0x65, 0x9d, 0xb6, 0xda, 0x6b, 0xf1, 0xc5, 0x18, 0x67, 0xac, 0xb9, 0xe6, 0x39, 0x73, 0xce, 0x39, 
    0xe7, 0x7b, 0xef, 0x05, 0x91, 0x00, 0x58, 0x55, 0x55, 0x73, 0x75, 0x00, 0x91, 0x01, 0x60, 0x00, 
    0xa3, 0x94, 0x53, 0xce, 0x49, 0x67, 0xa5, 0xd5, 0xd6, 0x7b, 0x00, 0x01, 0x04, 0x60, 0x00, 0x00, 
    0x00, 0x65, 0x9c, 0xb2, 0x4a, 0x2b, 0x2f, 0xbd, 0xf5, 0xde, 0x7b, 0xef, 0xbd, 0xf7, 0xde, 0x7b, 
    0xef, 0xbd, 0xf7, 0xde, 0x7b, 0xef, 0xbd, 0xf7, 0x5e, 0x03, 0x01, 0x04, 0x20, 0x23, 0x42, 0xac, 
    0xc2, 0x3d, 0x3b, 0x3d, 0xf4, 0x12, 0x31, 0x1b, 0x29, 0x2c, 0xaa, 0xab, 0xf3, 0x23, 0xc2, 0xa3, 
    0xa9, 0x34, 0x22, 0x3d, 0xf3, 0x76, 0x66, 0xe6, 0x53, 0x4f, 0x2b, 0xc5, 0x74, 0x00, 0x01, 0x10, 
    0x20, 0xaa, 0xf3, 0xc2, 0xf4, 0xd4, 0x75, 0x77, 0xf7, 0x29, 0xf3, 0xb2, 0x73, 0x3c, 0x74, 0x77, 
    0xf7, 0x3a, 0x74, 0xb3, 0xf3, 0xc4, 0x74, 0x77, 0x77, 0x67, 0x77, 0x4f, 0x75, 0x67, 0x76, 0x77, 
    0xf7, 0x29, 0xf3, 0x3a, 0xf4, 0xcc, 0x75, 0x77, 0xf7, 0xa0, 0x72, 0x2a, 0xf3, 0x2b, 0x73, 0x77, 
    0x77, 0xaa, 0x73, 0x2a, 0x73, 0x2c, 0x73, 0x77, 0xf7, 0x5e, 0xf6, 0x4d, 0x75, 0x77, 0x77, 0x77, 
    0x77, 0x3b, 0x74, 0xcc, 0x74, 0xef, 0x76, 0x77, 0x77, 0x2a, 0x73, 0x3b, 0xf4, 0xc5, 0x74, 0x77, 
    0x77, 0x33, 0x74, 0xb3, 0xf3, 0x3d, 0x74, 0x77, 0x77, 0xe6, 0xf6, 0xd5, 0x75, 0x77, 0x77, 0x77, 
    0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x66, 0x76, 0x77, 0x77, 0x77, 0x77, 0x77, 
    0x77, 0x5f, 0x76, 0x5f, 0x76, 0x6f, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x76, 0x77, 0x77, 0x77, 
    0x77, 0x00, 0x01, 0x08, 0xa8, 0x41, 0x08, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0x84, 0x10, 0x52, 
    0x48, 0x29, 0xa5, 0x90, 0x52, 0x4c, 0x31, 0xc5, 0x14, 0x53, 0x8e, 0x39, 0xe6, 0x98, 0x63, 0x8e, 
    0x41, 0x06, 0x19, 0x64, 0xd0, 0x41, 0x27, 0x9d, 0x74, 0x92, 0x49, 0x25, 0x9d, 0x74, 0x94, 0x49, 
    0x46, 0x1d, 0xa5, 0xd6, 0x52, 0x6a, 0x29, 0xa6, 0x98, 0x62, 0xcb, 0x2d, 0xc6, 0x5a, 0x6b, 0xad, 
    0x39, 0xe7, 0x5e, 0x83, 0x52, 0xc6, 0x18, 0x63, 0x8c, 0x31, 0xc6, 0x18, 0x63, 0x8c, 0x31, 0xc6, 
    0x18, 0x63, 0x8c, 0x31, 0x46, 0x00, 0x01, 0x02, 0xa0, 0x18, 0x1a, 0x1a, 0x1a, 0x22, 0x22, 0xa2, 
    0xa2, 0xa2, 0x2a, 0x2b, 0xab, 0xb3, 0xb3, 0xb3, 0x33, 0x00, 0x01, 0x08, 0x68, 0x00, 0x00, 0x00, 
    0x80, 0xa3, 0x48, 0x8a, 0xe4, 0x48, 0x8e, 0xe4, 0x48, 0x92, 0x24, 0x59, 0x92, 0x25, 0x69, 0x92, 
    0x67, 0x79, 0x96, 0x67, 0x79, 0x96, 0xa7, 0x89, 0x9a, 0xa8, 0xa9, 0xa2, 0xaa, 0xba, 0xaa, 0xed, 
    0xda, 0xbe, 0xed, 0xcb, 0xbe, 0xed, 0xbb, 0xba, 0xec, 0xdb, 0xbe, 0x6c, 0xbb, 0xba, 0xac, 0xcb, 
    0xb2, 0xac, 0xbb, 0xb6, 0xad, 0xcb, 0xba, 0xab, 0xeb, 0xba, 0xae, 0xeb, 0xba, 0xae, 0xeb, 0xba, 
    0xae, 0xeb, 0xba, 0xae, 0xeb, 0xba, 0xae, 0xeb, 0x3a, 0x00, 0x21, 0x01, 0x58, 0x97, 0x77, 0x97, 
    0x77, 0x97, 0x97, 0x97, 0x95, 0x05, 0x21, 0x03, 0x60, 0x00, 0x00, 0x4e, 0x39, 0xe5, 0x9c, 0x74, 
    0xd2, 0x59, 0x67, 0xa5, 0x95, 0x5a, 0x6a, 0xeb, 0xad, 0xb7, 0x5e, 0x7b, 0x2d, 0xb6, 0xf8, 0x00, 
    0x01, 0x08, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4a, 0x29, 0xe5, 0x94, 0x73, 0x52, 0x5a, 
    0xab, 0xb5, 0xf6, 0x5e, 0x7d, 0x31, 0xc6, 0x59, 0x6b, 0x8d, 0x73, 0xd6, 0x5a, 0xeb, 0x9c, 0x73, 
    0xce, 0x39, 0xe7, 0x9c, 0x73, 0xce, 0x39, 0xe7, 0x9c, 0x73, 0xce, 0x39, 0xe7, 0x9c, 0x73, 0xce, 
    0x39, 0xe7, 0x9c, 0x73, 0xce, 0x39, 0xe7, 0x9c, 0x73, 0x4e, 0x00, 0x21, 0x01, 0x58, 0x77, 0x77, 
    0x77, 0x75, 0x77, 0x77, 0x79, 0x99, 0x09, 0x21, 0x03, 0x60, 0x00, 0x00, 0x46, 0x29, 0xa7, 0xa4, 
    0xb3, 0xce, 0x4a, 0x6d, 0xb5, 0xf5, 0xd6, 0x6b, 0xf1, 0xcd, 0x77, 0x63, 0x9e, 0x7d, 0xf6, 0xba, 
    0x01, 0x01, 0x08, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xce, 0x3b, 0xef, 0xbc, 0xf3, 0xd2, 
    0x4b, 0x6f, 0xbd, 0xf3, 0xce, 0x4b, 0x2f, 0xb5, 0xd6, 0x5a, 0x6b, 0xad, 0xb5, 0xd6, 0x5a, 0x6b, 
    0xad, 0xb5, 0xd6, 0x5a, 0x6b, 0xad, 0xb5, 0xd6, 0x5a, 0x6b, 0xad, 0xb5, 0xd6, 0x5a, 0x6b, 0xad, 
    0xb5, 0xd6, 0x5a, 0x6b, 0xad, 0xb5, 0xd6, 0x5a, 0x6b, 0xad, 0x35, 0x00, 0x81, 0x00, 0x18, 0x44, 
    0xe5, 0x6c, 0x00, 0x01, 0x04, 0x28, 0x21, 0x44, 0x23, 0x63, 0xa8, 0x53, 0x4a, 0x82, 0x4b, 0xc1, 
    0x42, 0x88, 0x23, 0x62, 0xa8, 0x43, 0xc8, 0x79, 0x28, 0xb5, 0x74, 0x10, 0x3c, 0xa5, 0xb0, 0x64, 
    0x4c, 0x7a, 0x8a, 0x35, 0x08, 0x21, 0x84, 0xef, 0xbd, 0xe7, 0xde, 0x7b, 0xef, 0x3d, 0x00, 0x01, 
    0x04, 0xa8, 0x30, 0x0a, 0x1c, 0xc4, 0xc0, 0x63, 0x12, 0x84, 0x10, 0x42, 0x31, 0x8a, 0x13, 0xa2, 
    0x38, 0x53, 0x10, 0x84, 0x10, 0xc2, 0x72, 0x12, 0x2c, 0xe5, 0x3c, 0x74, 0x12, 0x84, 0xee, 0x41, 
    0x08, 0x21, 0x5c, 0xce, 0xbd, 0xe5, 0xdc, 0x7b, 0xef, 0x3d, 0x00, 0x01, 0x10, 0x28, 0x63, 0x8c, 
    0x2a, 0xc5, 0x28, 0x53, 0x4a, 0x5a, 0x29, 0x31, 0x63, 0x8e, 0x32, 0xc6, 0x28, 0x53, 0x4c, 0x52, 
    0x29, 0xb1, 0x94, 0xd0, 0x42, 0x08, 0xa9, 0x73, 0x8e, 0x62, 0x2a, 0x35, 0xe7, 0x9a, 0x73, 0x8d, 
    0x35, 0xb7, 0x16, 0x84, 0x10, 0x42, 0x63, 0x0a, 0x2a, 0xa5, 0x20, 0x53, 0xca, 0x51, 0x2a, 0x2d, 
    0x63, 0x0c, 0x32, 0xa5, 0x20, 0x53, 0x0a, 0x62, 0x29, 0xa9, 0x84, 0x4e, 0x42, 0xe7, 0xa4, 0x73, 
    0x0c, 0x62, 0x2b, 0x29, 0xd8, 0x1a, 0x73, 0x6d, 0x31, 0xc8, 0x96, 0x83, 0xb0, 0x41, 0x53, 0x8a, 
    0x29, 0x85, 0x98, 0x52, 0x4a, 0x51, 0x08, 0x21, 0x63, 0x8a, 0x31, 0xa5, 0x98, 0x52, 0x4a, 0x49, 
    0xe8, 0xa0, 0x84, 0xce, 0x41, 0xc7, 0x9c, 0x63, 0xca, 0x51, 0x09, 0x25, 0x08, 0x97, 0x73, 0x6e, 
    0xb5, 0xd6, 0xd2, 0x72, 0x6c, 0x31, 0x95, 0x4e, 0x52, 0xe9, 0x9c, 0x84, 0x8c, 0x49, 0x08, 0x29, 
    0xa5, 0x50, 0x52, 0xe9, 0xa0, 0x74, 0xca, 0x49, 0x08, 0xa9, 0xc6, 0xd2, 0x5a, 0x2a, 0xa5, 0x63, 
    0x4e, 0x4a, 0x4a, 0x2d, 0x08, 0x1d, 0x84, 0x10, 0x42, 0xc8, 0x16, 0x84, 0xb0, 0x41, 0x00, 0x41, 
    0x00, 0x0c, 0x04, 0xa1, 0x00, 0x50, 0xe8, 0xba, 0x16, 0x91, 0x01, 0x58, 0x00, 0xaa, 0xae, 0xae, 
    0xee, 0xf2, 0xf2, 0x36, 0x17, 0x01, 0x04, 0x68, 0x00, 0x00, 0x00, 0xc3, 0x51, 0x24, 0x45, 0x52, 
    0x24, 0xc7, 0x92, 0x2c, 0x49, 0xb3, 0x2c, 0x4d, 0x13, 0x45, 0x55, 0xf5, 0x55, 0xdb, 0x54, 0x55, 
    0xd9, 0xd7, 0x75, 0x5d, 0xd7, 0x75, 0x5d, 0xd7, 0x01, 0x01, 0x10, 0xa0, 0x32, 0xdb, 0x2a, 0x5b, 
    0xab, 0x4a, 0x5f, 0x65, 0xb3, 0x63, 0xb3, 0x5b, 0x33, 0xd3, 0x5d, 0xe5, 0x44, 0x54, 0x44, 0xcc, 
    0xbc, 0xdb, 0xde, 0x6d, 0xd5, 0x6d, 0x5d, 0x75, 0x5f, 0x76, 0x77, 0xf7, 0x2a, 0xcb, 0xaa, 0x52, 
    0xab, 0xc2, 0x5e, 0x65, 0x33, 0xcb, 0x2a, 0x43, 0xb3, 0x4a, 0xde, 0x5c, 0x44, 0x54, 0xc4, 0x43, 

################################################################################

TITLE
    golay23_decode

TYPE
    32

DATA
0x00000000UL, 0x00000001UL, 0x00000002UL, 0x00000003UL, 0x00000004UL, 0x00000005UL, 0x00000006UL, 0x00000007UL,
0x00000008UL, 0x00000009UL, 0x0000000aUL, 0x0000000bUL, 0x0000000cUL, 0x0000000dUL, 0x0000000eUL, 0x00024020UL,
0x00000010UL, 0x00000011UL, 0x00000012UL, 0x00000013UL, 0x00000014UL, 0x00000015UL, 0x00000016UL, 0x00412000UL,
0x00000018UL, 0x00000019UL, 0x0000001aUL, 0x00180800UL, 0x0000001cUL, 0x00200300UL, 0x00048040UL, 0x00001480UL,
0x00000020UL, 0x00000021UL, 0x00000022UL, 0x00000023UL, 0x00000024UL, 0x00000025UL, 0x00000026UL, 0x00024008UL,
0x00000028UL, 0x00000029UL, 0x0000002aUL, 0x00024004UL, 0x0000002cUL, 0x00024002UL, 0x00024001UL, 0x00024000UL,
0x00000030UL, 0x00000031UL, 0x00000032UL, 0x00008180UL, 0x00000034UL, 0x00000c40UL, 0x00301000UL, 0x000c0200UL,
0x00000038UL, 0x00043000UL, 0x00400600UL, 0x00210040UL, 0x00090080UL, 0x00508000UL, 0x00002900UL, 0x00024010UL,
0x00000040UL, 0x00000041UL, 0x00000042UL, 0x00000043UL, 0x00000044UL, 0x00000045UL, 0x00000046UL, 0x00280080UL,
0x00000048UL, 0x00000049UL, 0x0000004aUL, 0x00002500UL, 0x0000004cUL, 0x00111000UL, 0x00048010UL, 0x00400a00UL,
0x00000050UL, 0x00000051UL, 0x00000052UL, 0x00021200UL, 0x00000054UL, 0x00000c20UL, 0x00048008UL, 0x00104100UL,
0x00000058UL, 0x00404080UL, 0x00048004UL, 0x00210020UL, 0x00048002UL, 0x000a2000UL, 0x00048000UL, 0x00048001UL,
0x00000060UL, 0x00000061UL, 0x00000062UL, 0x00540000UL, 0x00000064UL, 0x00000c10UL, 0x00010300UL, 0x0000b000UL,
0x00000068UL, 0x00088200UL, 0x00001880UL, 0x00210010UL, 0x00602000UL, 0x00040180UL, 0x00180400UL, 0x00024040UL,
0x00000070UL, 0x00000c04UL, 0x00086000UL, 0x00210008UL, 0x00000c01UL, 0x00000c00UL, 0x00420080UL, 0x00000c02UL,
0x00120100UL, 0x00210002UL, 0x00210001UL, 0x00210000UL, 0x00005200UL, 0x00000c08UL, 0x00048020UL, 0x00210004UL,
0x00000080UL, 0x00000081UL, 0x00000082UL, 0x00000083UL, 0x00000084UL, 0x00000085UL, 0x00000086UL, 0x00280040UL,
0x00000088UL, 0x00000089UL, 0x0000008aUL, 0x00050200UL, 0x0000008cUL, 0x0000a800UL, 0x00500100UL, 0x00001410UL,
0x00000090UL, 0x00000091UL, 0x00000092UL, 0x00008120UL, 0x00000094UL, 0x00160000UL, 0x00004a00UL, 0x00001408UL,
0x00000098UL, 0x00404040UL, 0x00222000UL, 0x00001404UL, 0x00090020UL, 0x00001402UL, 0x00001401UL, 0x00001400UL,
0x000000a0UL, 0x000000a1UL, 0x000000a2UL, 0x00008110UL, 0x000000a4UL, 0x00401200UL, 0x00042400UL, 0x00110800UL,
0x000000a8UL, 0x00300400UL, 0x00001840UL, 0x00482000UL, 0x00090010UL, 0x00040140UL, 0x00208200UL, 0x00024080UL,
0x000000b0UL, 0x00008102UL, 0x00008101UL, 0x00008100UL, 0x00090008UL, 0x00206000UL, 0x00420040UL, 0x00008104UL,
0x00090004UL, 0x00020a00UL, 0x00144000UL, 0x00008108UL, 0x00090000UL, 0x00090001UL, 0x00090002UL, 0x00001420UL,
0x000000c0UL, 0x000000c1UL, 0x000000c2UL, 0x00280004UL, 0x000000c4UL, 0x00280002UL, 0x00280001UL, 0x00280000UL,
0x000000c8UL, 0x00404010UL, 0x00001820UL, 0x00128000UL, 0x00020600UL, 0x00040120UL, 0x00016000UL, 0x00280008UL,
0x000000d0UL, 0x00404008UL, 0x00110400UL, 0x00042800UL, 0x00003100UL, 0x00018200UL, 0x00420020UL, 0x00280010UL,
0x00404001UL, 0x00404000UL, 0x00080300UL, 0x00404002UL, 0x00300800UL, 0x00404004UL, 0x00048080UL, 0x00001440UL,
0x000000e0UL, 0x00032000UL, 0x00001808UL, 0x00004600UL, 0x0010c000UL, 0x00040108UL, 0x00420010UL, 0x00280020UL,
0x00001802UL, 0x00040104UL, 0x00001800UL, 0x00001801UL, 0x00040101UL, 0x00040100UL, 0x00001804UL, 0x00040102UL,
0x00240200UL, 0x00181000UL, 0x00420004UL, 0x00008140UL, 0x00420002UL, 0x00000c80UL, 0x00420000UL, 0x00420001UL,
0x0000a400UL, 0x00404020UL, 0x00001810UL, 0x00210080UL, 0x00090040UL, 0x00040110UL, 0x00420008UL, 0x00102200UL,
0x00000100UL, 0x00000101UL, 0x00000102UL, 0x00000103UL, 0x00000104UL, 0x00000105UL, 0x00000106UL, 0x00041800UL,
0x00000108UL, 0x00000109UL, 0x0000010aUL, 0x00002440UL, 0x0000010cUL, 0x00200210UL, 0x00500080UL, 0x00098000UL,
0x00000110UL, 0x00000111UL, 0x00000112UL, 0x000080a0UL, 0x00000114UL, 0x00200208UL, 0x000a0400UL, 0x00104040UL,
0x00000118UL, 0x00200204UL, 0x00015000UL, 0x00460000UL, 0x00200201UL, 0x00200200UL, 0x00002820UL, 0x00200202UL,
0x00000120UL, 0x00000121UL, 0x00000122UL, 0x00008090UL, 0x00000124UL, 0x00182000UL, 0x00010240UL, 0x00600400UL,
0x00000128UL, 0x00410800UL, 0x002c0000UL, 0x00101200UL, 0x00009400UL, 0x000400c0UL, 0x00002810UL, 0x00024100UL,
0x00000130UL, 0x00008082UL, 0x00008081UL, 0x00008080UL, 0x00444000UL, 0x00031000UL, 0x00002808UL, 0x00008084UL,
0x00120040UL, 0x00084400UL, 0x00002804UL, 0x00008088UL, 0x00002802UL, 0x00200220UL, 0x00002800UL, 0x00002801UL,
0x00000140UL, 0x00000141UL, 0x00000142UL, 0x00002408UL, 0x00000144UL, 0x00428000UL, 0x00010220UL, 0x00104010UL,
0x00000148UL, 0x00002402UL, 0x00002401UL, 0x00002400UL, 0x00084800UL, 0x000400a0UL, 0x00221000UL, 0x00002404UL,
0x00000150UL, 0x000d0000UL, 0x00600800UL, 0x00104004UL, 0x00003080UL, 0x00104002UL, 0x00104001UL, 0x00104000UL,
0x00120020UL, 0x00009800UL, 0x00080280UL, 0x00002410UL, 0x00410400UL, 0x00200240UL, 0x00048100UL, 0x00104008UL,
0x00000160UL, 0x00205000UL, 0x00010204UL, 0x000a0800UL, 0x00010202UL, 0x00040088UL, 0x00010200UL, 0x00010201UL,
0x00120010UL, 0x00040084UL, 0x0040c000UL, 0x00002420UL, 0x00040081UL, 0x00040080UL, 0x00010208UL, 0x00040082UL,
0x00120008UL, 0x00402200UL, 0x00041400UL, 0x000080c0UL, 0x00288000UL, 0x00000d00UL, 0x00010210UL, 0x00104020UL,
0x00120000UL, 0x00120001UL, 0x00120002UL, 0x00210100UL, 0x00120004UL, 0x00040090UL, 0x00002840UL, 0x00481000UL,
0x00000180UL, 0x00000181UL, 0x00000182UL, 0x00008030UL, 0x00000184UL, 0x00014400UL, 0x00500008UL, 0x00022200UL,
0x00000188UL, 0x000a1000UL, 0x00500004UL, 0x00204800UL, 0x00500002UL, 0x00040060UL, 0x00500000UL, 0x00500001UL,
0x00000190UL, 0x00008022UL, 0x00008021UL, 0x00008020UL, 0x00003040UL, 0x00480800UL, 0x00250000UL, 0x00008024UL,
0x00040c00UL, 0x00112000UL, 0x00080240UL, 0x00008028UL, 0x0002c000UL, 0x00200280UL, 0x00500010UL, 0x00001500UL,
0x000001a0UL, 0x00008012UL, 0x00008011UL, 0x00008010UL, 0x00220800UL, 0x00040048UL, 0x00085000UL, 0x00008014UL,
0x00006200UL, 0x00040044UL, 0x00030400UL, 0x00008018UL, 0x00040041UL, 0x00040040UL, 0x00500020UL, 0x00040042UL,
0x00008003UL, 0x00008002UL, 0x00008001UL, 0x00008000UL, 0x00100600UL, 0x00008006UL, 0x00008005UL, 0x00008004UL,
0x00601000UL, 0x0000800aUL, 0x00008009UL, 0x00008008UL, 0x00090100UL, 0x00040050UL, 0x00002880UL, 0x0000800cUL,
0x000001c0UL, 0x00100a00UL, 0x00064000UL, 0x00411000UL, 0x00003010UL, 0x00040028UL, 0x00008c00UL, 0x00280100UL,
0x00218000UL, 0x00040024UL, 0x00080210UL, 0x00002480UL, 0x00040021UL, 0x00040020UL, 0x00500040UL, 0x00040022UL,
0x00003004UL, 0x00220400UL, 0x00080208UL, 0x00008060UL, 0x00003000UL, 0x00003001UL, 0x00003002UL, 0x00104080UL,
0x00080202UL, 0x00404100UL, 0x00080200UL, 0x00080201UL, 0x00003008UL, 0x00040030UL, 0x00080204UL, 0x00030800UL,
0x00480400UL, 0x0004000cUL, 0x00302000UL, 0x00008050UL, 0x00040009UL, 0x00040008UL, 0x00010280UL, 0x0004000aUL,
0x00040005UL, 0x00040004UL, 0x00001900UL, 0x00040006UL, 0x00040001UL, 0x00040000UL, 0x00040003UL, 0x00040002UL,
0x00014800UL, 0x00008042UL, 0x00008041UL, 0x00008040UL, 0x00003020UL, 0x00040018UL, 0x00420100UL, 0x00008044UL,
0x00120080UL, 0x00040014UL, 0x00080220UL, 0x00008048UL, 0x00040011UL, 0x00040010UL, 0x00204400UL, 0x00040012UL,
0x00000200UL, 0x00000201UL, 0x00000202UL, 0x00000203UL, 0x00000204UL, 0x00000205UL, 0x00000206UL, 0x00108400UL,
0x00000208UL, 0x00000209UL, 0x0000020aUL, 0x00050080UL, 0x0000020cUL, 0x00200110UL, 0x00083000UL, 0x00400840UL,
0x00000210UL, 0x00000211UL, 0x00000212UL, 0x00021040UL, 0x00000214UL, 0x00200108UL, 0x00004880UL, 0x000c0020UL,
0x00000218UL, 0x00200104UL, 0x00400420UL, 0x0000e000UL, 0x00200101UL, 0x00200100UL, 0x00130000UL, 0x00200102UL,
0x00000220UL, 0x00000221UL, 0x00000222UL, 0x00202800UL, 0x00000224UL, 0x00401080UL, 0x00010140UL, 0x000c0010UL,
0x00000228UL, 0x00088040UL, 0x00400410UL, 0x00101100UL, 0x00140800UL, 0x00012400UL, 0x00208080UL, 0x00024200UL,
0x00000230UL, 0x00114000UL, 0x00400408UL, 0x000c0004UL, 0x0002a000UL, 0x000c0002UL, 0x000c0001UL, 0x000c0000UL,
0x00400402UL, 0x00020880UL, 0x00400400UL, 0x00400401UL, 0x00005040UL, 0x00200120UL, 0x00400404UL, 0x000c0008UL,
0x00000240UL, 0x00000241UL, 0x00000242UL, 0x00021010UL, 0x00000244UL, 0x00046000UL, 0x00010120UL, 0x00400808UL,
0x00000248UL, 0x00088020UL, 0x00304000UL, 0x00400804UL, 0x00020480UL, 0x00400802UL, 0x00400801UL, 0x00400800UL,
0x00000250UL, 0x00021002UL, 0x00021001UL, 0x00021000UL, 0x00580000UL, 0x00018080UL, 0x00202400UL, 0x00021004UL,
0x00012800UL, 0x00140400UL, 0x00080180UL, 0x00021008UL, 0x00005020UL, 0x00200140UL, 0x00048200UL, 0x00400810UL,
0x00000260UL, 0x00088008UL, 0x00010104UL, 0x00004480UL, 0x00010102UL, 0x00320000UL, 0x00010100UL, 0x00010101UL,
0x00088001UL, 0x00088000UL, 0x00062000UL, 0x00088002UL, 0x00005010UL, 0x00088004UL, 0x00010108UL, 0x00400820UL,
0x00240080UL, 0x00402100UL, 0x00108800UL, 0x00021020UL, 0x00005008UL, 0x00000e00UL, 0x00010110UL, 0x000c0040UL,
0x00005004UL, 0x00088010UL, 0x00400440UL, 0x00210200UL, 0x00005000UL, 0x00005001UL, 0x00005002UL, 0x00102080UL,
0x00000280UL, 0x00000281UL, 0x00000282UL, 0x00050008UL, 0x00000284UL, 0x00401020UL, 0x00004810UL, 0x00022100UL,
0x00000288UL, 0x00050002UL, 0x00050001UL, 0x00050000UL, 0x00020440UL, 0x00184000UL, 0x00208020UL, 0x00050004UL,
0x00000290UL, 0x00082400UL, 0x00004804UL, 0x00700000UL, 0x00004802UL, 0x00018040UL, 0x00004800UL, 0x00004801UL,
0x00109000UL, 0x00020820UL, 0x00080140UL, 0x00050010UL, 0x00442000UL, 0x00200180UL, 0x00004808UL, 0x00001600UL,
0x000002a0UL, 0x00401004UL, 0x001a0000UL, 0x00004440UL, 0x00401001UL, 0x00401000UL, 0x00208008UL, 0x00401002UL,
0x00006100UL, 0x00020810UL, 0x00208004UL, 0x00050020UL, 0x00208002UL, 0x00401008UL, 0x00208000UL, 0x00208001UL,
0x00240040UL, 0x00020808UL, 0x00013000UL, 0x00008300UL, 0x00100500UL, 0x00401010UL, 0x00004820UL, 0x000c0080UL,
0x00020801UL, 0x00020800UL, 0x00400480UL, 0x00020802UL, 0x00090200UL, 0x00020804UL, 0x00208010UL, 0x00102040UL,
0x000002c0UL, 0x00100900UL, 0x0040a000UL, 0x00004420UL, 0x00020408UL, 0x00018010UL, 0x00141000UL, 0x00280200UL,
0x00020404UL, 0x00203000UL, 0x00080110UL, 0x00050040UL, 0x00020400UL, 0x00020401UL, 0x00020402UL, 0x00400880UL,
0x00240020UL, 0x00018004UL, 0x00080108UL, 0x00021080UL, 0x00018001UL, 0x00018000UL, 0x00004840UL, 0x00018002UL,
0x00080102UL, 0x00404200UL, 0x00080100UL, 0x00080101UL, 0x00020410UL, 0x00018008UL, 0x00080104UL, 0x00102020UL,
0x00240010UL, 0x00004402UL, 0x00004401UL, 0x00004400UL, 0x00082800UL, 0x00401040UL, 0x00010180UL, 0x00004404UL,
0x00510000UL, 0x00088080UL, 0x00001a00UL, 0x00004408UL, 0x00020420UL, 0x00040300UL, 0x00208040UL, 0x00102010UL,
0x00240000UL, 0x00240001UL, 0x00240002UL, 0x00004410UL, 0x00240004UL, 0x00018020UL, 0x00420200UL, 0x00102008UL,
0x00240008UL, 0x00020840UL, 0x00080120UL, 0x00102004UL, 0x00005080UL, 0x00102002UL, 0x00102001UL, 0x00102000UL,
0x00000300UL, 0x00000301UL, 0x00000302UL, 0x00484000UL, 0x00000304UL, 0x00200018UL, 0x00010060UL, 0x00022080UL,
0x00000308UL, 0x00200014UL, 0x00028800UL, 0x00101020UL, 0x00200011UL, 0x00200010UL, 0x00044400UL, 0x00200012UL,
0x00000310UL, 0x0020000cUL, 0x00142000UL, 0x00010c00UL, 0x00200009UL, 0x00200008UL, 0x00409000UL, 0x0020000aUL,
0x00200005UL, 0x00200004UL, 0x000800c0UL, 0x00200006UL, 0x00200001UL, 0x00200000UL, 0x00200003UL, 0x00200002UL,
0x00000320UL, 0x00060400UL, 0x00010044UL, 0x00101008UL, 0x00010042UL, 0x0000c800UL, 0x00010040UL, 0x00010041UL,
0x00006080UL, 0x00101002UL, 0x00101001UL, 0x00101000UL, 0x004a0000UL, 0x00200030UL, 0x00010048UL, 0x00101004UL,
0x00081800UL, 0x00402040UL, 0x00224000UL, 0x00008280UL, 0x00100480UL, 0x00200028UL, 0x00010050UL, 0x000c0100UL,
0x00058000UL, 0x00200024UL, 0x00400500UL, 0x00101010UL, 0x00200021UL, 0x00200020UL, 0x00002a00UL, 0x00200022UL,
0x00000340UL, 0x00100880UL, 0x00010024UL, 0x00248000UL, 0x00010022UL, 0x00081400UL, 0x00010020UL, 0x00010021UL,
0x00441000UL, 0x00034000UL, 0x00080090UL, 0x00002600UL, 0x0010a000UL, 0x00200050UL, 0x00010028UL, 0x00400900UL,
0x0000c400UL, 0x00402020UL, 0x00080088UL, 0x00021100UL, 0x00060800UL, 0x00200048UL, 0x00010030UL, 0x00104200UL,
0x00080082UL, 0x00200044UL, 0x00080080UL, 0x00080081UL, 0x00200041UL, 0x00200040UL, 0x00080084UL, 0x00200042UL,
0x00010006UL, 0x00402010UL, 0x00010004UL, 0x00010005UL, 0x00010002UL, 0x00010003UL, 0x00010000UL, 0x00010001UL,
0x00200c00UL, 0x00088100UL, 0x0001000cUL, 0x00101040UL, 0x0001000aUL, 0x00040280UL, 0x00010008UL, 0x00010009UL,
0x00402001UL, 0x00402000UL, 0x00010014UL, 0x00402002UL, 0x00010012UL, 0x00402004UL, 0x00010010UL, 0x00010011UL,
0x00120200UL, 0x00402008UL, 0x000800a0UL, 0x00044800UL, 0x00005100UL, 0x00200060UL, 0x00010018UL, 0x00028400UL,
0x00000380UL, 0x00100840UL, 0x00201400UL, 0x00022004UL, 0x000c8000UL, 0x00022002UL, 0x00022001UL, 0x00022000UL,
0x00006020UL, 0x00408400UL, 0x00080050UL, 0x00050100UL, 0x00011800UL, 0x00200090UL, 0x00500200UL, 0x00022008UL,
0x00430000UL, 0x00045000UL, 0x00080048UL, 0x00008220UL, 0x00100420UL, 0x00200088UL, 0x00004900UL, 0x00022010UL,
0x00080042UL, 0x00200084UL, 0x00080040UL, 0x00080041UL, 0x00200081UL, 0x00200080UL, 0x00080044UL, 0x00200082UL,
0x00006008UL, 0x00290000UL, 0x00440800UL, 0x00008210UL, 0x00100410UL, 0x00401100UL, 0x000100c0UL, 0x00022020UL,
0x00006000UL, 0x00006001UL, 0x00006002UL, 0x00101080UL, 0x00006004UL, 0x00040240UL, 0x00208100UL, 0x00080c00UL,
0x00100404UL, 0x00008202UL, 0x00008201UL, 0x00008200UL, 0x00100400UL, 0x00100401UL, 0x00100402UL, 0x00008204UL,
0x00006010UL, 0x00020900UL, 0x00080060UL, 0x00008208UL, 0x00100408UL, 0x002000a0UL, 0x00061000UL, 0x00414000UL,
0x00100801UL, 0x00100800UL, 0x00080018UL, 0x00100802UL, 0x00604000UL, 0x00100804UL, 0x000100a0UL, 0x00022040UL,
0x00080012UL, 0x00100808UL, 0x00080010UL, 0x00080011UL, 0x00020500UL, 0x00040220UL, 0x00080014UL, 0x0000d000UL,
0x0008000aUL, 0x00100810UL, 0x00080008UL, 0x00080009UL, 0x00003200UL, 0x00018100UL, 0x0008000cUL, 0x00440400UL,
0x00080002UL, 0x00080003UL, 0x00080000UL, 0x00080001UL, 0x00080006UL, 0x002000c0UL, 0x00080004UL, 0x00080005UL,
0x00029000UL, 0x00100820UL, 0x00010084UL, 0x00004500UL, 0x00010082UL, 0x00040208UL, 0x00010080UL, 0x00010081UL,
0x00006040UL, 0x00040204UL, 0x00080030UL, 0x00620000UL, 0x00040201UL, 0x00040200UL, 0x00010088UL, 0x00040202UL,
0x00240100UL, 0x00402080UL, 0x00080028UL, 0x00008240UL, 0x00100440UL, 0x000a4000UL, 0x00010090UL, 0x00201800UL,
0x00080022UL, 0x00011400UL, 0x00080020UL, 0x00080021UL, 0x00408800UL, 0x00040210UL, 0x00080024UL, 0x00102100UL,
0x00000400UL, 0x00000401UL, 0x00000402UL, 0x00000403UL, 0x00000404UL, 0x00000405UL, 0x00000406UL, 0x00108200UL,
0x00000408UL, 0x00000409UL, 0x0000040aUL, 0x00002140UL, 0x0000040cUL, 0x004c0000UL, 0x00210800UL, 0x00001090UL,
0x00000410UL, 0x00000411UL, 0x00000412UL, 0x00244000UL, 0x00000414UL, 0x00000860UL, 0x000a0100UL, 0x00001088UL,
0x00000418UL, 0x00038000UL, 0x00400220UL, 0x00001084UL, 0x00106000UL, 0x00001082UL, 0x00001081UL, 0x00001080UL,
0x00000420UL, 0x00000421UL, 0x00000422UL, 0x00091000UL, 0x00000424UL, 0x00000850UL, 0x00042080UL, 0x00600100UL,
0x00000428UL, 0x00300080UL, 0x00400210UL, 0x00048800UL, 0x00009100UL, 0x00012200UL, 0x00180040UL, 0x00024400UL,
0x00000430UL, 0x00000844UL, 0x00400208UL, 0x00122000UL, 0x00000841UL, 0x00000840UL, 0x0001c000UL, 0x00000842UL,
0x00400202UL, 0x00084100UL, 0x00400200UL, 0x00400201UL, 0x00260000UL, 0x00000848UL, 0x00400204UL, 0x000010a0UL,
0x00000440UL, 0x00000441UL, 0x00000442UL, 0x00002108UL, 0x00000444UL, 0x00000830UL, 0x00405000UL, 0x00070000UL,
0x00000448UL, 0x00002102UL, 0x00002101UL, 0x00002100UL, 0x00020280UL, 0x0020c000UL, 0x00180020UL, 0x00002104UL,
0x00000450UL, 0x00000824UL, 0x00110080UL, 0x00488000UL, 0x00000821UL, 0x00000820UL, 0x00202200UL, 0x00000822UL,
0x00281000UL, 0x00140200UL, 0x00024800UL, 0x00002110UL, 0x00410100UL, 0x00000828UL, 0x00048400UL, 0x000010c0UL,
0x00000460UL, 0x00000814UL, 0x00228000UL, 0x00004280UL, 0x00000811UL, 0x00000810UL, 0x00180008UL, 0x00000812UL,
0x00054000UL, 0x00421000UL, 0x00180004UL, 0x00002120UL, 0x00180002UL, 0x00000818UL, 0x00180000UL, 0x00180001UL,
0x00000805UL, 0x00000804UL, 0x00041100UL, 0x00000806UL, 0x00000801UL, 0x00000800UL, 0x00000803UL, 0x00000802UL,
0x0000a080UL, 0x0000080cUL, 0x00400240UL, 0x00210400UL, 0x00000809UL, 0x00000808UL, 0x00180010UL, 0x0000080aUL,
0x00000480UL, 0x00000481UL, 0x00000482UL, 0x00420800UL, 0x00000484UL, 0x00014100UL, 0x00042020UL, 0x00001018UL,
0x00000488UL, 0x00300020UL, 0x0008c000UL, 0x00001014UL, 0x00020240UL, 0x00001012UL, 0x00001011UL, 0x00001010UL,
0x00000490UL, 0x00082200UL, 0x00110040UL, 0x0000100cUL, 0x00608000UL, 0x0000100aUL, 0x00001009UL, 0x00001008UL,
0x00040900UL, 0x00001006UL, 0x00001005UL, 0x00001004UL, 0x00001003UL, 0x00001002UL, 0x00001001UL, 0x00001000UL,
0x000004a0UL, 0x00300008UL, 0x00042004UL, 0x00004240UL, 0x00042002UL, 0x000a8000UL, 0x00042000UL, 0x00042001UL,
0x00300001UL, 0x00300000UL, 0x00030100UL, 0x00300002UL, 0x00404800UL, 0x00300004UL, 0x00042008UL, 0x00001030UL,
0x00025000UL, 0x00450000UL, 0x00280800UL, 0x00008500UL, 0x00100300UL, 0x000008c0UL, 0x00042010UL, 0x00001028UL,
0x0000a040UL, 0x00300010UL, 0x00400280UL, 0x00001024UL, 0x00090400UL, 0x00001022UL, 0x00001021UL, 0x00001020UL,
0x000004c0UL, 0x00049000UL, 0x00110010UL, 0x00004220UL, 0x00020208UL, 0x00502000UL, 0x00008900UL, 0x00280400UL,
0x00020204UL, 0x00090800UL, 0x00640000UL, 0x00002180UL, 0x00020200UL, 0x00020201UL, 0x00020202UL, 0x00001050UL,
0x00110002UL, 0x00220100UL, 0x00110000UL, 0x00110001UL, 0x000c4000UL, 0x000008a0UL, 0x00110004UL, 0x00001048UL,
0x0000a020UL, 0x00404400UL, 0x00110008UL, 0x00001044UL, 0x00020210UL, 0x00001042UL, 0x00001041UL, 0x00001040UL,
0x00480100UL, 0x00004202UL, 0x00004201UL, 0x00004200UL, 0x00211000UL, 0x00000890UL, 0x00042040UL, 0x00004204UL,
0x0000a010UL, 0x00300040UL, 0x00001c00UL, 0x00004208UL, 0x00020220UL, 0x00040500UL, 0x00180080UL, 0x00418000UL,
0x0000a008UL, 0x00000884UL, 0x00110020UL, 0x00004210UL, 0x00000881UL, 0x00000880UL, 0x00420400UL, 0x00000882UL,
0x0000a000UL, 0x0000a001UL, 0x0000a002UL, 0x000e0000UL, 0x0000a004UL, 0x00000888UL, 0x00204100UL, 0x00001060UL,
0x00000500UL, 0x00000501UL, 0x00000502UL, 0x00002048UL, 0x00000504UL, 0x00014080UL, 0x000a0010UL, 0x00600020UL,
0x00000508UL, 0x00002042UL, 0x00002041UL, 0x00002040UL, 0x00009020UL, 0x00120800UL, 0x00044200UL, 0x00002044UL,
0x00000510UL, 0x00501000UL, 0x000a0004UL, 0x00010a00UL, 0x000a0002UL, 0x0004a000UL, 0x000a0000UL, 0x000a0001UL,
0x00040880UL, 0x00084020UL, 0x00308000UL, 0x00002050UL, 0x00410040UL, 0x00200600UL, 0x000a0008UL, 0x00001180UL,
0x00000520UL, 0x00060200UL, 0x00104800UL, 0x00600004UL, 0x00009008UL, 0x00600002UL, 0x00600001UL, 0x00600000UL,
0x00009004UL, 0x00084010UL, 0x00030080UL, 0x00002060UL, 0x00009000UL, 0x00009001UL, 0x00009002UL, 0x00600008UL,
0x00212000UL, 0x00084008UL, 0x00041040UL, 0x00008480UL, 0x00100280UL, 0x00000940UL, 0x000a0020UL, 0x00600010UL,
0x00084001UL, 0x00084000UL, 0x00400300UL, 0x00084002UL, 0x00009010UL, 0x00084004UL, 0x00002c00UL, 0x00150000UL,
0x00000540UL, 0x0000200aUL, 0x00002009UL, 0x00002008UL, 0x00340000UL, 0x00081200UL, 0x00008880UL, 0x0000200cUL,
0x00002003UL, 0x00002002UL, 0x00002001UL, 0x00002000UL, 0x00410010UL, 0x00002006UL, 0x00002005UL, 0x00002004UL,
0x0000c200UL, 0x00220080UL, 0x00041020UL, 0x00002018UL, 0x00410008UL, 0x00000920UL, 0x000a0040UL, 0x00104400UL,
0x00410004UL, 0x00002012UL, 0x00002011UL, 0x00002010UL, 0x00410000UL, 0x00410001UL, 0x00410002UL, 0x00002014UL,
0x00480080UL, 0x00118000UL, 0x00041010UL, 0x00002028UL, 0x00026000UL, 0x00000910UL, 0x00010600UL, 0x00600040UL,
0x00200a00UL, 0x00002022UL, 0x00002021UL, 0x00002020UL, 0x00009040UL, 0x00040480UL, 0x00180100UL, 0x00002024UL,
0x00041002UL, 0x00000904UL, 0x00041000UL, 0x00041001UL, 0x00000901UL, 0x00000900UL, 0x00041004UL, 0x00000902UL,
0x00120400UL, 0x00084040UL, 0x00041008UL, 0x00002030UL, 0x00410020UL, 0x00000908UL, 0x00204080UL, 0x00028200UL,
0x00000580UL, 0x00014004UL, 0x00201200UL, 0x001c0000UL, 0x00014001UL, 0x00014000UL, 0x00008840UL, 0x00014002UL,
0x00040810UL, 0x00408200UL, 0x00030020UL, 0x000020c0UL, 0x00282000UL, 0x00014008UL, 0x00500400UL, 0x00001110UL,
0x00040808UL, 0x00220040UL, 0x00406000UL, 0x00008420UL, 0x00100220UL, 0x00014010UL, 0x000a0080UL, 0x00001108UL,
0x00040800UL, 0x00040801UL, 0x00040802UL, 0x00001104UL, 0x00040804UL, 0x00001102UL, 0x00001101UL, 0x00001100UL,
0x00480040UL, 0x00003800UL, 0x00030008UL, 0x00008410UL, 0x00100210UL, 0x00014020UL, 0x00042100UL, 0x00600080UL,
0x00030002UL, 0x00300100UL, 0x00030000UL, 0x00030001UL, 0x00009080UL, 0x00040440UL, 0x00030004UL, 0x00080a00UL,
0x00100204UL, 0x00008402UL, 0x00008401UL, 0x00008400UL, 0x00100200UL, 0x00100201UL, 0x00100202UL, 0x00008404UL,
0x00040820UL, 0x00084080UL, 0x00030010UL, 0x00008408UL, 0x00100208UL, 0x00422000UL, 0x00204040UL, 0x00001120UL,
0x00480020UL, 0x00220010UL, 0x00008804UL, 0x00002088UL, 0x00008802UL, 0x00014040UL, 0x00008800UL, 0x00008801UL,
0x00105000UL, 0x00002082UL, 0x00002081UL, 0x00002080UL, 0x00020300UL, 0x00040420UL, 0x00008808UL, 0x00002084UL,
0x00220001UL, 0x00220000UL, 0x00110100UL, 0x00220002UL, 0x00003400UL, 0x00220004UL, 0x00008810UL, 0x00440200UL,
0x00040840UL, 0x00220008UL, 0x00080600UL, 0x00002090UL, 0x00410080UL, 0x00188000UL, 0x00204020UL, 0x00001140UL,
0x00480000UL, 0x00480001UL, 0x00480002UL, 0x00004300UL, 0x00480004UL, 0x00040408UL, 0x00008820UL, 0x00121000UL,
0x00480008UL, 0x00040404UL, 0x00030040UL, 0x000020a0UL, 0x00040401UL, 0x00040400UL, 0x00204010UL, 0x00040402UL,
0x00480010UL, 0x00220020UL, 0x00041080UL, 0x00008440UL, 0x00100240UL, 0x00000980UL, 0x00204008UL, 0x00092000UL,
0x0000a100UL, 0x00011200UL, 0x00204004UL, 0x00500800UL, 0x00204002UL, 0x00040410UL, 0x00204000UL, 0x00204001UL,
0x00000600UL, 0x00000601UL, 0x00000602UL, 0x00108004UL, 0x00000604UL, 0x00108002UL, 0x00108001UL, 0x00108000UL,
0x00000608UL, 0x00005800UL, 0x00400030UL, 0x002a0000UL, 0x000200c0UL, 0x00012020UL, 0x00044100UL, 0x00108008UL,
0x00000610UL, 0x00082080UL, 0x00400028UL, 0x00010900UL, 0x00051000UL, 0x00424000UL, 0x00202040UL, 0x00108010UL,
0x00400022UL, 0x00140040UL, 0x00400020UL, 0x00400021UL, 0x00088800UL, 0x00200500UL, 0x00400024UL, 0x00001280UL,
0x00000620UL, 0x00060100UL, 0x00400018UL, 0x000040c0UL, 0x00284000UL, 0x00012008UL, 0x00021800UL, 0x00108020UL,
0x00400012UL, 0x00012004UL, 0x00400010UL, 0x00400011UL, 0x00012001UL, 0x00012000UL, 0x00400014UL, 0x00012002UL,
0x0040000aUL, 0x00209000UL, 0x00400008UL, 0x00400009UL, 0x00100180UL, 0x00000a40UL, 0x0040000cUL, 0x000c0400UL,
0x00400002UL, 0x00400003UL, 0x00400000UL, 0x00400001UL, 0x00400006UL, 0x00012010UL, 0x00400004UL, 0x00400005UL,
0x00000640UL, 0x00610000UL, 0x000c0800UL, 0x000040a0UL, 0x00020088UL, 0x00081100UL, 0x00202010UL, 0x00108040UL,
0x00020084UL, 0x00140010UL, 0x00019000UL, 0x00002300UL, 0x00020080UL, 0x00020081UL, 0x00020082UL, 0x00400c00UL,
0x0000c100UL, 0x00140008UL, 0x00202004UL, 0x00021400UL, 0x00202002UL, 0x00000a20UL, 0x00202000UL, 0x00202001UL,
0x00140001UL, 0x00140000UL, 0x00400060UL, 0x00140002UL, 0x00020090UL, 0x00140004UL, 0x00202008UL, 0x00094000UL,
0x00103000UL, 0x00004082UL, 0x00004081UL, 0x00004080UL, 0x00448000UL, 0x00000a10UL, 0x00010500UL, 0x00004084UL,
0x00200900UL, 0x00088400UL, 0x00400050UL, 0x00004088UL, 0x000200a0UL, 0x00012040UL, 0x00180200UL, 0x00241000UL,
0x000b0000UL, 0x00000a04UL, 0x00400048UL, 0x00004090UL, 0x00000a01UL, 0x00000a00UL, 0x00202020UL, 0x00000a02UL,
0x00400042UL, 0x00140020UL, 0x00400040UL, 0x00400041UL, 0x00005400UL, 0x00000a08UL, 0x00400044UL, 0x00028100UL,
0x00000680UL, 0x00082010UL, 0x00201100UL, 0x00004060UL, 0x00020048UL, 0x00240800UL, 0x00490000UL, 0x00108080UL,
0x00020044UL, 0x00408100UL, 0x00102800UL, 0x00050400UL, 0x00020040UL, 0x00020041UL, 0x00020042UL, 0x00001210UL,
0x00082001UL, 0x00082000UL, 0x00068000UL, 0x00082002UL, 0x00100120UL, 0x00082004UL, 0x00004c00UL, 0x00001208UL,
0x00214000UL, 0x00082008UL, 0x004000a0UL, 0x00001204UL, 0x00020050UL, 0x00001202UL, 0x00001201UL, 0x00001200UL,
0x00018800UL, 0x00004042UL, 0x00004041UL, 0x00004040UL, 0x00100110UL, 0x00401400UL, 0x00042200UL, 0x00004044UL,
0x000c1000UL, 0x00300200UL, 0x00400090UL, 0x00004048UL, 0x00020060UL, 0x00012080UL, 0x00208400UL, 0x00080900UL,
0x00100104UL, 0x00082020UL, 0x00400088UL, 0x00004050UL, 0x00100100UL, 0x00100101UL, 0x00100102UL, 0x00230000UL,
0x00400082UL, 0x00020c00UL, 0x00400080UL, 0x00400081UL, 0x00100108UL, 0x0004c000UL, 0x00400084UL, 0x00001220UL,
0x0002000cUL, 0x00004022UL, 0x00004021UL, 0x00004020UL, 0x00020008UL, 0x00020009UL, 0x0002000aUL, 0x00004024UL,
0x00020004UL, 0x00020005UL, 0x00020006UL, 0x00004028UL, 0x00020000UL, 0x00020001UL, 0x00020002UL, 0x00020003UL,
0x00401800UL, 0x00082040UL, 0x00110200UL, 0x00004030UL, 0x00020018UL, 0x00018400UL, 0x00202080UL, 0x00440100UL,
0x00020014UL, 0x00140080UL, 0x00080500UL, 0x00208800UL, 0x00020010UL, 0x00020011UL, 0x00020012UL, 0x00001240UL,
0x00004003UL, 0x00004002UL, 0x00004001UL, 0x00004000UL, 0x00020028UL, 0x00004006UL, 0x00004005UL, 0x00004004UL,
0x00020024UL, 0x0000400aUL, 0x00004009UL, 0x00004008UL, 0x00020020UL, 0x00020021UL, 0x00020022UL, 0x0000400cUL,
0x00240400UL, 0x00004012UL, 0x00004011UL, 0x00004010UL, 0x00100140UL, 0x00000a80UL, 0x00089000UL, 0x00004014UL,
0x0000a200UL, 0x00011100UL, 0x004000c0UL, 0x00004018UL, 0x00020030UL, 0x00680000UL, 0x00050800UL, 0x00102400UL,
0x00000700UL, 0x00060020UL, 0x00201080UL, 0x00010810UL, 0x00402800UL, 0x00081040UL, 0x00044008UL, 0x00108100UL,
0x00190000UL, 0x00408080UL, 0x00044004UL, 0x00002240UL, 0x00044002UL, 0x00200410UL, 0x00044000UL, 0x00044001UL,
0x0000c040UL, 0x00010802UL, 0x00010801UL, 0x00010800UL, 0x001000a0UL, 0x00200408UL, 0x000a0200UL, 0x00010804UL,
0x00023000UL, 0x00200404UL, 0x00400120UL, 0x00010808UL, 0x00200401UL, 0x00200400UL, 0x00044010UL, 0x00200402UL,
0x00060001UL, 0x00060000UL, 0x0008a000UL, 0x00060002UL, 0x00100090UL, 0x00060004UL, 0x00010440UL, 0x00600200UL,
0x00200840UL, 0x00060008UL, 0x00400110UL, 0x00101400UL, 0x00009200UL, 0x00012100UL, 0x00044020UL, 0x00080880UL,
0x00100084UL, 0x00060010UL, 0x00400108UL, 0x00010820UL, 0x00100080UL, 0x00100081UL, 0x00100082UL, 0x00007000UL,
0x00400102UL, 0x00084200UL, 0x00400100UL, 0x00400101UL, 0x00100088UL, 0x00200420UL, 0x00400104UL, 0x00028040UL,
0x0000c010UL, 0x00081004UL, 0x00520000UL, 0x00002208UL, 0x00081001UL, 0x00081000UL, 0x00010420UL, 0x00081002UL,
0x00200820UL, 0x00002202UL, 0x00002201UL, 0x00002200UL, 0x00020180UL, 0x00081008UL, 0x00044040UL, 0x00002204UL,
0x0000c000UL, 0x0000c001UL, 0x0000c002UL, 0x00010840UL, 0x0000c004UL, 0x00081010UL, 0x00202100UL, 0x00440080UL,
0x0000c008UL, 0x00140100UL, 0x00080480UL, 0x00002210UL, 0x00410200UL, 0x00200440UL, 0x00101800UL, 0x00028020UL,
0x00200808UL, 0x00060040UL, 0x00010404UL, 0x00004180UL, 0x00010402UL, 0x00081020UL, 0x00010400UL, 0x00010401UL,
0x00200800UL, 0x00200801UL, 0x00200802UL, 0x00002220UL, 0x00200804UL, 0x00504000UL, 0x00010408UL, 0x00028010UL,
0x0000c020UL, 0x00402400UL, 0x00041200UL, 0x00380000UL, 0x001000c0UL, 0x00000b00UL, 0x00010410UL, 0x00028008UL,
0x00200810UL, 0x00011080UL, 0x00400140UL, 0x00028004UL, 0x000c2000UL, 0x00028002UL, 0x00028001UL, 0x00028000UL,
0x00201002UL, 0x00408008UL, 0x00201000UL, 0x00201001UL, 0x00100030UL, 0x00014200UL, 0x00201004UL, 0x00022400UL,
0x00408001UL, 0x00408000UL, 0x00201008UL, 0x00408002UL, 0x00020140UL, 0x00408004UL, 0x00044080UL, 0x00080820UL,
0x00100024UL, 0x00082100UL, 0x00201010UL, 0x00010880UL, 0x00100020UL, 0x00100021UL, 0x00100022UL, 0x00440040UL,
0x00040a00UL, 0x00408010UL, 0x00080440UL, 0x00124000UL, 0x00100028UL, 0x00200480UL, 0x0001a000UL, 0x00001300UL,
0x00100014UL, 0x00060080UL, 0x00201020UL, 0x00004140UL, 0x00100010UL, 0x00100011UL, 0x00100012UL, 0x00080808UL,
0x00006400UL, 0x00408020UL, 0x00030200UL, 0x00080804UL, 0x00100018UL, 0x00080802UL, 0x00080801UL, 0x00080800UL,
0x00100004UL, 0x00100005UL, 0x00100006UL, 0x00008600UL, 0x00100000UL, 0x00100001UL, 0x00100002UL, 0x00100003UL,
0x0010000cUL, 0x00011040UL, 0x00400180UL, 0x00242000UL, 0x00100008UL, 0x00100009UL, 0x0010000aUL, 0x00080810UL,
0x00052000UL, 0x00100c00UL, 0x00201040UL, 0x00004120UL, 0x00020108UL, 0x00081080UL, 0x00008a00UL, 0x00440010UL,
0x00020104UL, 0x00408040UL, 0x00080410UL, 0x00002280UL, 0x00020100UL, 0x00020101UL, 0x00020102UL, 0x00310000UL,
0x0000c080UL, 0x00220200UL, 0x00080408UL, 0x00440004UL, 0x00100060UL, 0x00440002UL, 0x00440001UL, 0x00440000UL,
0x00080402UL, 0x00011020UL, 0x00080400UL, 0x00080401UL, 0x00020110UL, 0x00006800UL, 0x00080404UL, 0x00440008UL,
0x00480200UL, 0x00004102UL, 0x00004101UL, 0x00004100UL, 0x00100050UL, 0x0020a000UL, 0x00010480UL, 0x00004104UL,
0x00200880UL, 0x00011010UL, 0x00148000UL, 0x00004108UL, 0x00020120UL, 0x00040600UL, 0x00403000UL, 0x00080840UL,
0x00100044UL, 0x00011008UL, 0x00022800UL, 0x00004110UL, 0x00100040UL, 0x00100041UL, 0x00100042UL, 0x00440020UL,
0x00011001UL, 0x00011000UL, 0x00080420UL, 0x00011002UL, 0x00100048UL, 0x00011004UL, 0x00204200UL, 0x00028080UL, 


################################################################################

TITLE
    Mersenne twister

TYPE
    32 AND

DATA
    0x6c078965 0x9d2c5680 0xefc60000 0x9908b0df

################################################################################

TITLE
    lz4

TYPE
    32

DATA
    0, 0, 0, 0, 0, 1, 1, 2, 0, 3, 1, 3, 1, 4, 2, 7, 0, 2, 3, 6, 1, 5, 3, 5, 1, 3, 4, 4, 2, 5, 6, 7, 7, 0, 1, 2, 3, 3, 4, 6, 2, 6, 5, 5, 3, 4, 5, 6, 7, 1, 2, 4, 6, 4, 4, 5, 7, 2, 6, 5, 7, 6, 7, 7

################################################################################

TITLE
    enwik8

TYPE
    8

DATA
         32, 101, 116,  97, 105, 111, 110, 114, 115, 108, 104, 100,  99, 117,  93,  91,
        109, 112, 103, 102,  10, 121,  98,  39, 119,  46,  44, 118,  59,  38, 124,  47,
         49, 107,  61,  48,  67,  65,  58,  45,  84,  83,  60,  62,  50, 113,  73,  57,
         42, 120,  41,  40,  66,  77,  80,  69,  68,  53,  51,  72,  70,  56,  52,  71,
         82,  54,  76,  55,  78,  87, 122, 125, 123,  79, 106,  85,  74,  75, 208,  95,
        195,  35,  86, 215,  90,  34,  89, 209, 128, 224, 184, 131,  92, 227,  37,  33,
        176, 169, 206, 226, 130,  63,  88,  81, 161, 153,  43, 129, 188, 179, 216, 164,
        181, 189, 148, 190, 173, 187, 186, 229, 225, 167, 217, 177, 178, 168, 149, 185,
        197, 144, 147, 196, 207, 194, 180, 156, 132, 170, 166, 136, 182, 191,   9, 230,
        141, 160, 175,  36, 152, 140, 165, 145,  94, 133, 163, 183, 171, 157, 137, 174,
        134, 135, 236, 151, 231, 155, 201, 158, 138, 143, 150, 162, 159, 139, 172, 154,
        126, 232, 235, 146, 233, 228, 202, 203, 142, 214, 237, 204, 219, 234, 213,  96,
        218, 199,  64, 210, 239, 198, 211, 205, 212, 240, 222, 220, 200,   0,   1,   2,
          3,   4,   5,   6,   7,   8,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,
         21,  22,  23,  24,  25,  26,  27,  28,  29,  30,  31, 127, 192, 193, 221, 223,
        238, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255,

################################################################################

TITLE
    libzling matchidx_code

TYPE
    8

DATA

   0,    1,    2,    3,    4,    4,    5,    5,    6,    6,    6,    6,    7,    7,    7,    7,
   8,    8,    8,    8,    8,    8,    8,    8,    9,    9,    9,    9,    9,    9,    9,    9,
  10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
  11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
  12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
  12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
  13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
  13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
  14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
  14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
  14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
  14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
  15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
  15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
  15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
  15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
  31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,

################################################################################

TITLE
    lzfse base values

TYPE
    32

DATA
  0,      1,      2,      3,     4,     6,     8,     10,    12,    16,
  20,     24,     28,     36,    44,    52,    60,    76,    92,    108,
  124,    156,    188,    220,   252,   316,   380,   444,   508,   636,
  764,    892,    1020,   1276,  1532,  1788,  2044,  2556,  3068,  3580,
  4092,   5116,   6140,   7164,  8188,  10236, 12284, 14332, 16380, 20476,
  24572,  28668,  32764,  40956, 49148, 57340, 65532, 81916, 98300, 114684,
  131068, 163836, 196604, 229372

################################################################################

